#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 9
#define STATE_COUNT 3911
#define SYMBOL_COUNT 295
#define ALIAS_COUNT 4
#define TOKEN_COUNT 125
#define EXTERNAL_TOKEN_COUNT 1
#define MAX_ALIAS_SEQUENCE_LENGTH 5

enum {
  sym_raw_string_literal = 1,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH = 2,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH = 3,
  anon_sym_LF = 4,
  anon_sym_LPAREN = 5,
  anon_sym_DOT_DOT_DOT = 6,
  anon_sym_COMMA = 7,
  anon_sym_RPAREN = 8,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH = 9,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH = 10,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH = 11,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH = 12,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH = 13,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH = 14,
  sym_preproc_directive = 15,
  sym_preproc_arg = 16,
  anon_sym_SEMI = 17,
  anon_sym_typedef = 18,
  anon_sym_extern = 19,
  anon_sym_LBRACE = 20,
  anon_sym_RBRACE = 21,
  anon_sym_LPAREN2 = 22,
  anon_sym_STAR = 23,
  anon_sym_LBRACK = 24,
  anon_sym_RBRACK = 25,
  anon_sym_EQ = 26,
  anon_sym_static = 27,
  anon_sym_register = 28,
  anon_sym_inline = 29,
  anon_sym_const = 30,
  anon_sym_restrict = 31,
  anon_sym_volatile = 32,
  anon_sym__Atomic = 33,
  anon_sym_mutable = 34,
  anon_sym_explicit = 35,
  anon_sym_constexpr = 36,
  anon_sym_unsigned = 37,
  anon_sym_long = 38,
  anon_sym_short = 39,
  sym_primitive_type = 40,
  anon_sym_enum = 41,
  anon_sym_struct = 42,
  anon_sym_union = 43,
  anon_sym_COLON = 44,
  anon_sym_if = 45,
  anon_sym_else = 46,
  anon_sym_switch = 47,
  anon_sym_case = 48,
  anon_sym_default = 49,
  anon_sym_while = 50,
  anon_sym_do = 51,
  anon_sym_for = 52,
  anon_sym_return = 53,
  anon_sym_break = 54,
  anon_sym_continue = 55,
  anon_sym_goto = 56,
  anon_sym_QMARK = 57,
  anon_sym_STAR_EQ = 58,
  anon_sym_SLASH_EQ = 59,
  anon_sym_PERCENT_EQ = 60,
  anon_sym_PLUS_EQ = 61,
  anon_sym_DASH_EQ = 62,
  anon_sym_LT_LT_EQ = 63,
  anon_sym_GT_GT_EQ = 64,
  anon_sym_AMP_EQ = 65,
  anon_sym_CARET_EQ = 66,
  anon_sym_PIPE_EQ = 67,
  anon_sym_AMP = 68,
  anon_sym_PIPE_PIPE = 69,
  anon_sym_AMP_AMP = 70,
  anon_sym_BANG = 71,
  anon_sym_PIPE = 72,
  anon_sym_CARET = 73,
  anon_sym_TILDE = 74,
  anon_sym_EQ_EQ = 75,
  anon_sym_BANG_EQ = 76,
  anon_sym_LT = 77,
  anon_sym_GT = 78,
  anon_sym_LT_EQ = 79,
  anon_sym_GT_EQ = 80,
  anon_sym_LT_LT = 81,
  anon_sym_GT_GT = 82,
  anon_sym_PLUS = 83,
  anon_sym_DASH = 84,
  anon_sym_SLASH = 85,
  anon_sym_PERCENT = 86,
  anon_sym_DASH_DASH = 87,
  anon_sym_PLUS_PLUS = 88,
  anon_sym_sizeof = 89,
  anon_sym_DOT = 90,
  anon_sym_DASH_GT = 91,
  sym_number_literal = 92,
  anon_sym_SQUOTE = 93,
  aux_sym_SLASH_LBRACK_CARET_BSLASHn_SQUOTE_RBRACK_SLASH = 94,
  anon_sym_DQUOTE = 95,
  aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_BSLASHn_RBRACK_SLASH = 96,
  sym_escape_sequence = 97,
  sym_system_lib_string = 98,
  sym_true = 99,
  sym_false = 100,
  sym_null = 101,
  sym_identifier = 102,
  sym_comment = 103,
  anon_sym_class = 104,
  anon_sym_final = 105,
  anon_sym_override = 106,
  anon_sym_public = 107,
  sym_auto = 108,
  anon_sym_typename = 109,
  anon_sym_template = 110,
  anon_sym_GT2 = 111,
  anon_sym_delete = 112,
  anon_sym_friend = 113,
  anon_sym_private = 114,
  anon_sym_protected = 115,
  sym_noexcept = 116,
  anon_sym_namespace = 117,
  anon_sym_using = 118,
  anon_sym_try = 119,
  anon_sym_catch = 120,
  anon_sym_new = 121,
  anon_sym_COLON_COLON = 122,
  sym_operator_name = 123,
  sym_nullptr = 124,
  sym_translation_unit = 125,
  sym_preproc_include = 126,
  sym_preproc_def = 127,
  sym_preproc_function_def = 128,
  sym_preproc_params = 129,
  sym_preproc_call = 130,
  sym_preproc_if = 131,
  sym_preproc_ifdef = 132,
  sym_preproc_else = 133,
  sym_preproc_elif = 134,
  sym_preproc_if_in_compound_statement = 135,
  sym_preproc_ifdef_in_compound_statement = 136,
  sym_preproc_else_in_compound_statement = 137,
  sym_preproc_elif_in_compound_statement = 138,
  sym_preproc_if_in_field_declaration_list = 139,
  sym_preproc_ifdef_in_field_declaration_list = 140,
  sym_preproc_else_in_field_declaration_list = 141,
  sym_preproc_elif_in_field_declaration_list = 142,
  sym_function_definition = 143,
  sym_declaration = 144,
  sym_type_definition = 145,
  sym__declaration_specifiers = 146,
  sym_linkage_specification = 147,
  sym_declaration_list = 148,
  sym__declarator = 149,
  sym__field_declarator = 150,
  sym__type_declarator = 151,
  sym__abstract_declarator = 152,
  sym_pointer_declarator = 153,
  sym_pointer_field_declarator = 154,
  sym_pointer_type_declarator = 155,
  sym_abstract_pointer_declarator = 156,
  sym_function_declarator = 157,
  sym_function_field_declarator = 158,
  sym_function_type_declarator = 159,
  sym_abstract_function_declarator = 160,
  sym_array_declarator = 161,
  sym_array_field_declarator = 162,
  sym_array_type_declarator = 163,
  sym_abstract_array_declarator = 164,
  sym_init_declarator = 165,
  sym_compound_statement = 166,
  sym_storage_class_specifier = 167,
  sym_type_qualifier = 168,
  sym__type_specifier = 169,
  sym_sized_type_specifier = 170,
  sym_enum_specifier = 171,
  sym_enumerator_list = 172,
  sym_struct_specifier = 173,
  sym_union_specifier = 174,
  sym_field_declaration_list = 175,
  sym__field_declaration_list_item = 176,
  sym_field_declaration = 177,
  sym_enumerator = 178,
  sym_parameter_list = 179,
  sym_parameter_declaration = 180,
  sym_labeled_statement = 181,
  sym_expression_statement = 182,
  sym_if_statement = 183,
  sym_switch_statement = 184,
  sym_case_statement = 185,
  sym_while_statement = 186,
  sym_do_statement = 187,
  sym_for_statement = 188,
  sym_return_statement = 189,
  sym_break_statement = 190,
  sym_continue_statement = 191,
  sym_goto_statement = 192,
  sym__expression = 193,
  sym_comma_expression = 194,
  sym_conditional_expression = 195,
  sym_assignment_expression = 196,
  sym_pointer_expression = 197,
  sym_logical_expression = 198,
  sym_bitwise_expression = 199,
  sym_equality_expression = 200,
  sym_relational_expression = 201,
  sym_shift_expression = 202,
  sym_math_expression = 203,
  sym_cast_expression = 204,
  sym_type_descriptor = 205,
  sym_sizeof_expression = 206,
  sym_subscript_expression = 207,
  sym_call_expression = 208,
  sym_argument_list = 209,
  sym_field_expression = 210,
  sym_compound_literal_expression = 211,
  sym_parenthesized_expression = 212,
  sym_initializer_list = 213,
  sym_initializer_pair = 214,
  sym_subscript_designator = 215,
  sym_field_designator = 216,
  sym_char_literal = 217,
  sym_concatenated_string = 218,
  sym_string_literal = 219,
  sym__empty_declaration = 220,
  sym_macro_type_specifier = 221,
  sym_class_specifier = 222,
  sym_virtual_specifier = 223,
  sym_base_class_clause = 224,
  sym_dependent_type = 225,
  sym_structured_binding_declaration = 226,
  sym_template_declaration = 227,
  sym_template_instantiation = 228,
  sym_template_parameter_list = 229,
  sym_type_parameter_declaration = 230,
  sym_optional_type_parameter_declaration = 231,
  sym_optional_parameter_declaration = 232,
  sym_field_initializer_list = 233,
  sym_field_initializer = 234,
  sym_inline_method_definition = 235,
  sym_constructor_or_destructor_definition = 236,
  sym_constructor_or_destructor_declaration = 237,
  sym_default_method_clause = 238,
  sym_delete_method_clause = 239,
  sym_friend_declaration = 240,
  sym_access_specifier = 241,
  sym_reference_declarator = 242,
  sym_reference_field_declarator = 243,
  sym_abstract_reference_declarator = 244,
  sym_structured_binding_reference_declarator = 245,
  sym_structured_binding_declarator = 246,
  sym_trailing_return_type = 247,
  sym_template_type = 248,
  sym_template_method = 249,
  sym_template_function = 250,
  sym_template_argument_list = 251,
  sym_namespace_definition = 252,
  sym_using_declaration = 253,
  sym_alias_declaration = 254,
  sym_for_range_loop = 255,
  sym_for_range_declaration = 256,
  sym_try_statement = 257,
  sym_catch_clause = 258,
  sym_new_expression = 259,
  sym_new_declarator = 260,
  sym_delete_expression = 261,
  sym_lambda_expression = 262,
  sym_lambda_capture_specifier = 263,
  sym_lambda_default_capture = 264,
  sym_destructor_name = 265,
  sym_scoped_field_identifier = 266,
  sym_scoped_identifier = 267,
  sym_scoped_type_identifier = 268,
  sym_scoped_namespace_identifier = 269,
  aux_sym_translation_unit_repeat1 = 270,
  aux_sym_preproc_params_repeat1 = 271,
  aux_sym_preproc_if_in_compound_statement_repeat1 = 272,
  aux_sym_preproc_if_in_field_declaration_list_repeat1 = 273,
  aux_sym_declaration_repeat1 = 274,
  aux_sym_type_definition_repeat1 = 275,
  aux_sym__declaration_specifiers_repeat1 = 276,
  aux_sym_function_declarator_repeat1 = 277,
  aux_sym_abstract_function_declarator_repeat1 = 278,
  aux_sym_sized_type_specifier_repeat1 = 279,
  aux_sym_enumerator_list_repeat1 = 280,
  aux_sym_field_declaration_repeat1 = 281,
  aux_sym_parameter_list_repeat1 = 282,
  aux_sym_for_statement_repeat1 = 283,
  aux_sym_argument_list_repeat1 = 284,
  aux_sym_initializer_list_repeat1 = 285,
  aux_sym_initializer_pair_repeat1 = 286,
  aux_sym_concatenated_string_repeat1 = 287,
  aux_sym_string_literal_repeat1 = 288,
  aux_sym_base_class_clause_repeat1 = 289,
  aux_sym_template_parameter_list_repeat1 = 290,
  aux_sym_field_initializer_list_repeat1 = 291,
  aux_sym_structured_binding_declarator_repeat1 = 292,
  aux_sym_template_argument_list_repeat1 = 293,
  aux_sym_try_statement_repeat1 = 294,
  alias_sym_field_identifier = 295,
  alias_sym_namespace_identifier = 296,
  alias_sym_statement_identifier = 297,
  alias_sym_type_identifier = 298,
};

static const char *ts_symbol_names[] = {
  [sym_raw_string_literal] = "raw_string_literal",
  [ts_builtin_sym_end] = "END",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = "#include",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = "#define",
  [anon_sym_LF] = "\n",
  [anon_sym_LPAREN] = "(",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_COMMA] = ",",
  [anon_sym_RPAREN] = ")",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = "#if",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = "#endif",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = "#ifdef",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = "#ifndef",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = "#else",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = "#elif",
  [sym_preproc_directive] = "preproc_directive",
  [sym_preproc_arg] = "preproc_arg",
  [anon_sym_SEMI] = ";",
  [anon_sym_typedef] = "typedef",
  [anon_sym_extern] = "extern",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_LPAREN2] = "(",
  [anon_sym_STAR] = "*",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_EQ] = "=",
  [anon_sym_static] = "static",
  [anon_sym_register] = "register",
  [anon_sym_inline] = "inline",
  [anon_sym_const] = "const",
  [anon_sym_restrict] = "restrict",
  [anon_sym_volatile] = "volatile",
  [anon_sym__Atomic] = "_Atomic",
  [anon_sym_mutable] = "mutable",
  [anon_sym_explicit] = "explicit",
  [anon_sym_constexpr] = "constexpr",
  [anon_sym_unsigned] = "unsigned",
  [anon_sym_long] = "long",
  [anon_sym_short] = "short",
  [sym_primitive_type] = "primitive_type",
  [anon_sym_enum] = "enum",
  [anon_sym_struct] = "struct",
  [anon_sym_union] = "union",
  [anon_sym_COLON] = ":",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_for] = "for",
  [anon_sym_return] = "return",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_goto] = "goto",
  [anon_sym_QMARK] = "?",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_AMP] = "&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_BANG] = "!",
  [anon_sym_PIPE] = "|",
  [anon_sym_CARET] = "^",
  [anon_sym_TILDE] = "~",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_sizeof] = "sizeof",
  [anon_sym_DOT] = ".",
  [anon_sym_DASH_GT] = "->",
  [sym_number_literal] = "number_literal",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_SLASH_LBRACK_CARET_BSLASHn_SQUOTE_RBRACK_SLASH] = "/[^\\n']/",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_BSLASHn_RBRACK_SLASH] = "/[^\\\\\"\\n]/",
  [sym_escape_sequence] = "escape_sequence",
  [sym_system_lib_string] = "system_lib_string",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_identifier] = "identifier",
  [sym_comment] = "comment",
  [anon_sym_class] = "class",
  [anon_sym_final] = "final",
  [anon_sym_override] = "override",
  [anon_sym_public] = "public",
  [sym_auto] = "auto",
  [anon_sym_typename] = "typename",
  [anon_sym_template] = "template",
  [anon_sym_GT2] = ">",
  [anon_sym_delete] = "delete",
  [anon_sym_friend] = "friend",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [sym_noexcept] = "noexcept",
  [anon_sym_namespace] = "namespace",
  [anon_sym_using] = "using",
  [anon_sym_try] = "try",
  [anon_sym_catch] = "catch",
  [anon_sym_new] = "new",
  [anon_sym_COLON_COLON] = "::",
  [sym_operator_name] = "operator_name",
  [sym_nullptr] = "nullptr",
  [sym_translation_unit] = "translation_unit",
  [sym_preproc_include] = "preproc_include",
  [sym_preproc_def] = "preproc_def",
  [sym_preproc_function_def] = "preproc_function_def",
  [sym_preproc_params] = "preproc_params",
  [sym_preproc_call] = "preproc_call",
  [sym_preproc_if] = "preproc_if",
  [sym_preproc_ifdef] = "preproc_ifdef",
  [sym_preproc_else] = "preproc_else",
  [sym_preproc_elif] = "preproc_elif",
  [sym_preproc_if_in_compound_statement] = "preproc_if",
  [sym_preproc_ifdef_in_compound_statement] = "preproc_ifdef",
  [sym_preproc_else_in_compound_statement] = "preproc_else",
  [sym_preproc_elif_in_compound_statement] = "preproc_elif",
  [sym_preproc_if_in_field_declaration_list] = "preproc_if",
  [sym_preproc_ifdef_in_field_declaration_list] = "preproc_ifdef",
  [sym_preproc_else_in_field_declaration_list] = "preproc_else",
  [sym_preproc_elif_in_field_declaration_list] = "preproc_elif",
  [sym_function_definition] = "function_definition",
  [sym_declaration] = "declaration",
  [sym_type_definition] = "type_definition",
  [sym__declaration_specifiers] = "_declaration_specifiers",
  [sym_linkage_specification] = "linkage_specification",
  [sym_declaration_list] = "declaration_list",
  [sym__declarator] = "_declarator",
  [sym__field_declarator] = "_field_declarator",
  [sym__type_declarator] = "_type_declarator",
  [sym__abstract_declarator] = "_abstract_declarator",
  [sym_pointer_declarator] = "pointer_declarator",
  [sym_pointer_field_declarator] = "pointer_declarator",
  [sym_pointer_type_declarator] = "pointer_declarator",
  [sym_abstract_pointer_declarator] = "abstract_pointer_declarator",
  [sym_function_declarator] = "function_declarator",
  [sym_function_field_declarator] = "function_declarator",
  [sym_function_type_declarator] = "function_declarator",
  [sym_abstract_function_declarator] = "abstract_function_declarator",
  [sym_array_declarator] = "array_declarator",
  [sym_array_field_declarator] = "array_declarator",
  [sym_array_type_declarator] = "array_declarator",
  [sym_abstract_array_declarator] = "abstract_array_declarator",
  [sym_init_declarator] = "init_declarator",
  [sym_compound_statement] = "compound_statement",
  [sym_storage_class_specifier] = "storage_class_specifier",
  [sym_type_qualifier] = "type_qualifier",
  [sym__type_specifier] = "_type_specifier",
  [sym_sized_type_specifier] = "sized_type_specifier",
  [sym_enum_specifier] = "enum_specifier",
  [sym_enumerator_list] = "enumerator_list",
  [sym_struct_specifier] = "struct_specifier",
  [sym_union_specifier] = "union_specifier",
  [sym_field_declaration_list] = "field_declaration_list",
  [sym__field_declaration_list_item] = "_field_declaration_list_item",
  [sym_field_declaration] = "field_declaration",
  [sym_enumerator] = "enumerator",
  [sym_parameter_list] = "parameter_list",
  [sym_parameter_declaration] = "parameter_declaration",
  [sym_labeled_statement] = "labeled_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_case_statement] = "case_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_for_statement] = "for_statement",
  [sym_return_statement] = "return_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_goto_statement] = "goto_statement",
  [sym__expression] = "_expression",
  [sym_comma_expression] = "comma_expression",
  [sym_conditional_expression] = "conditional_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_pointer_expression] = "pointer_expression",
  [sym_logical_expression] = "logical_expression",
  [sym_bitwise_expression] = "bitwise_expression",
  [sym_equality_expression] = "equality_expression",
  [sym_relational_expression] = "relational_expression",
  [sym_shift_expression] = "shift_expression",
  [sym_math_expression] = "math_expression",
  [sym_cast_expression] = "cast_expression",
  [sym_type_descriptor] = "type_descriptor",
  [sym_sizeof_expression] = "sizeof_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_call_expression] = "call_expression",
  [sym_argument_list] = "argument_list",
  [sym_field_expression] = "field_expression",
  [sym_compound_literal_expression] = "compound_literal_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_initializer_list] = "initializer_list",
  [sym_initializer_pair] = "initializer_pair",
  [sym_subscript_designator] = "subscript_designator",
  [sym_field_designator] = "field_designator",
  [sym_char_literal] = "char_literal",
  [sym_concatenated_string] = "concatenated_string",
  [sym_string_literal] = "string_literal",
  [sym__empty_declaration] = "_empty_declaration",
  [sym_macro_type_specifier] = "macro_type_specifier",
  [sym_class_specifier] = "class_specifier",
  [sym_virtual_specifier] = "virtual_specifier",
  [sym_base_class_clause] = "base_class_clause",
  [sym_dependent_type] = "dependent_type",
  [sym_structured_binding_declaration] = "structured_binding_declaration",
  [sym_template_declaration] = "template_declaration",
  [sym_template_instantiation] = "template_instantiation",
  [sym_template_parameter_list] = "template_parameter_list",
  [sym_type_parameter_declaration] = "type_parameter_declaration",
  [sym_optional_type_parameter_declaration] = "optional_type_parameter_declaration",
  [sym_optional_parameter_declaration] = "optional_parameter_declaration",
  [sym_field_initializer_list] = "field_initializer_list",
  [sym_field_initializer] = "field_initializer",
  [sym_inline_method_definition] = "function_definition",
  [sym_constructor_or_destructor_definition] = "function_definition",
  [sym_constructor_or_destructor_declaration] = "declaration",
  [sym_default_method_clause] = "default_method_clause",
  [sym_delete_method_clause] = "delete_method_clause",
  [sym_friend_declaration] = "friend_declaration",
  [sym_access_specifier] = "access_specifier",
  [sym_reference_declarator] = "reference_declarator",
  [sym_reference_field_declarator] = "reference_declarator",
  [sym_abstract_reference_declarator] = "abstract_reference_declarator",
  [sym_structured_binding_reference_declarator] = "reference_declarator",
  [sym_structured_binding_declarator] = "structured_binding_declarator",
  [sym_trailing_return_type] = "trailing_return_type",
  [sym_template_type] = "template_type",
  [sym_template_method] = "template_method",
  [sym_template_function] = "template_function",
  [sym_template_argument_list] = "template_argument_list",
  [sym_namespace_definition] = "namespace_definition",
  [sym_using_declaration] = "using_declaration",
  [sym_alias_declaration] = "alias_declaration",
  [sym_for_range_loop] = "for_range_loop",
  [sym_for_range_declaration] = "for_range_declaration",
  [sym_try_statement] = "try_statement",
  [sym_catch_clause] = "catch_clause",
  [sym_new_expression] = "new_expression",
  [sym_new_declarator] = "new_declarator",
  [sym_delete_expression] = "delete_expression",
  [sym_lambda_expression] = "lambda_expression",
  [sym_lambda_capture_specifier] = "lambda_capture_specifier",
  [sym_lambda_default_capture] = "lambda_default_capture",
  [sym_destructor_name] = "destructor_name",
  [sym_scoped_field_identifier] = "scoped_field_identifier",
  [sym_scoped_identifier] = "scoped_identifier",
  [sym_scoped_type_identifier] = "scoped_type_identifier",
  [sym_scoped_namespace_identifier] = "scoped_namespace_identifier",
  [aux_sym_translation_unit_repeat1] = "translation_unit_repeat1",
  [aux_sym_preproc_params_repeat1] = "preproc_params_repeat1",
  [aux_sym_preproc_if_in_compound_statement_repeat1] = "preproc_if_in_compound_statement_repeat1",
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = "preproc_if_in_field_declaration_list_repeat1",
  [aux_sym_declaration_repeat1] = "declaration_repeat1",
  [aux_sym_type_definition_repeat1] = "type_definition_repeat1",
  [aux_sym__declaration_specifiers_repeat1] = "_declaration_specifiers_repeat1",
  [aux_sym_function_declarator_repeat1] = "function_declarator_repeat1",
  [aux_sym_abstract_function_declarator_repeat1] = "abstract_function_declarator_repeat1",
  [aux_sym_sized_type_specifier_repeat1] = "sized_type_specifier_repeat1",
  [aux_sym_enumerator_list_repeat1] = "enumerator_list_repeat1",
  [aux_sym_field_declaration_repeat1] = "field_declaration_repeat1",
  [aux_sym_parameter_list_repeat1] = "parameter_list_repeat1",
  [aux_sym_for_statement_repeat1] = "for_statement_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_initializer_list_repeat1] = "initializer_list_repeat1",
  [aux_sym_initializer_pair_repeat1] = "initializer_pair_repeat1",
  [aux_sym_concatenated_string_repeat1] = "concatenated_string_repeat1",
  [aux_sym_string_literal_repeat1] = "string_literal_repeat1",
  [aux_sym_base_class_clause_repeat1] = "base_class_clause_repeat1",
  [aux_sym_template_parameter_list_repeat1] = "template_parameter_list_repeat1",
  [aux_sym_field_initializer_list_repeat1] = "field_initializer_list_repeat1",
  [aux_sym_structured_binding_declarator_repeat1] = "structured_binding_declarator_repeat1",
  [aux_sym_template_argument_list_repeat1] = "template_argument_list_repeat1",
  [aux_sym_try_statement_repeat1] = "try_statement_repeat1",
  [alias_sym_field_identifier] = "field_identifier",
  [alias_sym_namespace_identifier] = "namespace_identifier",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [sym_raw_string_literal] = {
    .visible = true,
    .named = true,
  },
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = {
    .visible = true,
    .named = false,
  },
  [sym_preproc_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_arg] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typedef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_register] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_restrict] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_volatile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Atomic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mutable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_explicit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_constexpr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsigned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_long] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_short] = {
    .visible = true,
    .named = false,
  },
  [sym_primitive_type] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_union] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_goto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sizeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [sym_number_literal] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_SLASH_LBRACK_CARET_BSLASHn_SQUOTE_RBRACK_SLASH] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_BSLASHn_RBRACK_SLASH] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_system_lib_string] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_final] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_override] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [sym_auto] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_typename] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_template] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_friend] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [sym_noexcept] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_using] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [sym_operator_name] = {
    .visible = true,
    .named = true,
  },
  [sym_nullptr] = {
    .visible = true,
    .named = true,
  },
  [sym_translation_unit] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_include] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_def] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_function_def] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_params] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_call] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__declaration_specifiers] = {
    .visible = false,
    .named = true,
  },
  [sym_linkage_specification] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__declarator] = {
    .visible = false,
    .named = true,
  },
  [sym__field_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym__type_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym__abstract_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_init_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_storage_class_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_type_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym__type_specifier] = {
    .visible = false,
    .named = true,
  },
  [sym_sized_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_union_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__field_declaration_list_item] = {
    .visible = false,
    .named = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_goto_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_comma_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_bitwise_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_equality_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_relational_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_shift_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_math_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym_sizeof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_literal_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_field_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_char_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenated_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__empty_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_macro_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_class_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_virtual_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_base_class_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_dependent_type] = {
    .visible = true,
    .named = true,
  },
  [sym_structured_binding_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_template_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_template_instantiation] = {
    .visible = true,
    .named = true,
  },
  [sym_template_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_type_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_inline_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_or_destructor_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_or_destructor_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_default_method_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_delete_method_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_friend_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_access_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_reference_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_structured_binding_reference_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_structured_binding_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_trailing_return_type] = {
    .visible = true,
    .named = true,
  },
  [sym_template_type] = {
    .visible = true,
    .named = true,
  },
  [sym_template_method] = {
    .visible = true,
    .named = true,
  },
  [sym_template_function] = {
    .visible = true,
    .named = true,
  },
  [sym_template_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_using_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_for_range_loop] = {
    .visible = true,
    .named = true,
  },
  [sym_for_range_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_delete_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_capture_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_default_capture] = {
    .visible = true,
    .named = true,
  },
  [sym_destructor_name] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_namespace_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_translation_unit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_params_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_compound_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__declaration_specifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_abstract_function_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_sized_type_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enumerator_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_pair_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenated_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_base_class_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_initializer_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_structured_binding_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_namespace_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[15][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [1] = {
    [0] = alias_sym_type_identifier,
  },
  [2] = {
    [1] = alias_sym_type_identifier,
  },
  [3] = {
    [1] = alias_sym_namespace_identifier,
  },
  [4] = {
    [1] = alias_sym_statement_identifier,
  },
  [5] = {
    [0] = alias_sym_statement_identifier,
  },
  [6] = {
    [0] = alias_sym_namespace_identifier,
  },
  [7] = {
    [0] = alias_sym_namespace_identifier,
    [2] = alias_sym_type_identifier,
  },
  [8] = {
    [0] = alias_sym_namespace_identifier,
    [2] = alias_sym_namespace_identifier,
  },
  [9] = {
    [2] = alias_sym_field_identifier,
  },
  [10] = {
    [2] = alias_sym_type_identifier,
  },
  [11] = {
    [2] = alias_sym_namespace_identifier,
  },
  [12] = {
    [0] = alias_sym_field_identifier,
  },
  [13] = {
    [1] = alias_sym_field_identifier,
  },
  [14] = {
    [0] = alias_sym_namespace_identifier,
    [2] = alias_sym_field_identifier,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(38);
      if (lookahead == '&')
        ADVANCE(40);
      if (lookahead == '\'')
        ADVANCE(43);
      if (lookahead == '(')
        ADVANCE(44);
      if (lookahead == ')')
        ADVANCE(45);
      if (lookahead == '*')
        ADVANCE(46);
      if (lookahead == '+')
        ADVANCE(48);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(52);
      if (lookahead == '.')
        ADVANCE(56);
      if (lookahead == '/')
        ADVANCE(59);
      if (lookahead == '0')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(74);
      if (lookahead == ';')
        ADVANCE(76);
      if (lookahead == '<')
        ADVANCE(77);
      if (lookahead == '=')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(83);
      if (lookahead == '?')
        ADVANCE(84);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == '\\')
        ADVANCE(86);
      if (lookahead == ']')
        ADVANCE(101);
      if (lookahead == '^')
        ADVANCE(102);
      if (lookahead == 'o')
        ADVANCE(104);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '|')
        ADVANCE(125);
      if (lookahead == '}')
        ADVANCE(128);
      if (lookahead == '~')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(130);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=')
        ADVANCE(3);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 5:
      if (lookahead == 'd')
        ADVANCE(6);
      if (lookahead == 'e')
        ADVANCE(13);
      if (lookahead == 'i')
        ADVANCE(23);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(5);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e')
        ADVANCE(7);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f')
        ADVANCE(8);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i')
        ADVANCE(9);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'n')
        ADVANCE(10);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e')
        ADVANCE(11);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l')
        ADVANCE(14);
      if (lookahead == 'n')
        ADVANCE(19);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i')
        ADVANCE(15);
      if (lookahead == 's')
        ADVANCE(17);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f')
        ADVANCE(16);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e')
        ADVANCE(18);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd')
        ADVANCE(20);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i')
        ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f')
        ADVANCE(22);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f')
        ADVANCE(24);
      if (lookahead == 'n')
        ADVANCE(32);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH);
      if (lookahead == 'd')
        ADVANCE(25);
      if (lookahead == 'n')
        ADVANCE(28);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e')
        ADVANCE(26);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f')
        ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd')
        ADVANCE(29);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e')
        ADVANCE(30);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f')
        ADVANCE(31);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'c')
        ADVANCE(33);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l')
        ADVANCE(34);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'u')
        ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd')
        ADVANCE(36);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e')
        ADVANCE(37);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=')
        ADVANCE(39);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(41);
      if (lookahead == '=')
        ADVANCE(42);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=')
        ADVANCE(47);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+')
        ADVANCE(49);
      if (lookahead == '=')
        ADVANCE(50);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-')
        ADVANCE(53);
      if (lookahead == '=')
        ADVANCE(54);
      if (lookahead == '>')
        ADVANCE(55);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.')
        ADVANCE(57);
      END_STATE();
    case 57:
      if (lookahead == '.')
        ADVANCE(58);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*')
        ADVANCE(60);
      if (lookahead == '/')
        ADVANCE(63);
      if (lookahead == '=')
        ADVANCE(64);
      END_STATE();
    case 60:
      if (lookahead == '*')
        ADVANCE(61);
      if (lookahead != 0)
        ADVANCE(60);
      END_STATE();
    case 61:
      if (lookahead == '*')
        ADVANCE(61);
      if (lookahead == '/')
        ADVANCE(62);
      if (lookahead != 0)
        ADVANCE(60);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(63);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '.')
        ADVANCE(66);
      if (lookahead == 'L')
        ADVANCE(68);
      if (lookahead == 'U')
        ADVANCE(68);
      if (lookahead == 'b')
        ADVANCE(69);
      if (lookahead == 'l')
        ADVANCE(68);
      if (lookahead == 'u')
        ADVANCE(68);
      if (lookahead == 'x')
        ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      END_STATE();
    case 66:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(67);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'L')
        ADVANCE(68);
      if (lookahead == 'U')
        ADVANCE(68);
      if (lookahead == 'l')
        ADVANCE(68);
      if (lookahead == 'u')
        ADVANCE(68);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(67);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'L')
        ADVANCE(68);
      if (lookahead == 'U')
        ADVANCE(68);
      if (lookahead == 'l')
        ADVANCE(68);
      if (lookahead == 'u')
        ADVANCE(68);
      END_STATE();
    case 69:
      if (lookahead == '0' ||
          lookahead == '1')
        ADVANCE(70);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'L')
        ADVANCE(68);
      if (lookahead == 'U')
        ADVANCE(68);
      if (lookahead == 'l')
        ADVANCE(68);
      if (lookahead == 'u')
        ADVANCE(68);
      if (lookahead == '0' ||
          lookahead == '1')
        ADVANCE(70);
      END_STATE();
    case 71:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'f'))
        ADVANCE(72);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'L')
        ADVANCE(72);
      if (lookahead == 'U')
        ADVANCE(72);
      if (lookahead == 'l')
        ADVANCE(68);
      if (lookahead == 'u')
        ADVANCE(68);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'f'))
        ADVANCE(72);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '.')
        ADVANCE(66);
      if (lookahead == 'L')
        ADVANCE(68);
      if (lookahead == 'U')
        ADVANCE(68);
      if (lookahead == 'l')
        ADVANCE(68);
      if (lookahead == 'u')
        ADVANCE(68);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':')
        ADVANCE(75);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<')
        ADVANCE(78);
      if (lookahead == '=')
        ADVANCE(80);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=')
        ADVANCE(79);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(82);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_GT2);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 86:
      if (lookahead == 'U')
        ADVANCE(87);
      if (lookahead == 'u')
        ADVANCE(91);
      if (lookahead == 'x')
        ADVANCE(96);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(99);
      if (lookahead != 0)
        ADVANCE(95);
      END_STATE();
    case 87:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(88);
      END_STATE();
    case 88:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(89);
      END_STATE();
    case 89:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(90);
      END_STATE();
    case 90:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(91);
      END_STATE();
    case 91:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(92);
      END_STATE();
    case 92:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(93);
      END_STATE();
    case 93:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(94);
      END_STATE();
    case 94:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(95);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 96:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(97);
      END_STATE();
    case 97:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(98);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(98);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(100);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(95);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=')
        ADVANCE(103);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'p')
        ADVANCE(105);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(106);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(107);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(108);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(109);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(110);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(111);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '!')
        ADVANCE(112);
      if (lookahead == '%')
        ADVANCE(112);
      if (lookahead == '&')
        ADVANCE(114);
      if (lookahead == '(')
        ADVANCE(115);
      if (lookahead == '*')
        ADVANCE(112);
      if (lookahead == '+')
        ADVANCE(116);
      if (lookahead == ',')
        ADVANCE(113);
      if (lookahead == '-')
        ADVANCE(117);
      if (lookahead == '/')
        ADVANCE(112);
      if (lookahead == '<')
        ADVANCE(119);
      if (lookahead == '=')
        ADVANCE(112);
      if (lookahead == '>')
        ADVANCE(120);
      if (lookahead == '[')
        ADVANCE(121);
      if (lookahead == '^')
        ADVANCE(112);
      if (lookahead == '|')
        ADVANCE(122);
      if (lookahead == '~')
        ADVANCE(113);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(sym_operator_name);
      if (lookahead == '=')
        ADVANCE(113);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(sym_operator_name);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(sym_operator_name);
      if (lookahead == '&')
        ADVANCE(113);
      if (lookahead == '=')
        ADVANCE(113);
      END_STATE();
    case 115:
      if (lookahead == ')')
        ADVANCE(113);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(sym_operator_name);
      if (lookahead == '+')
        ADVANCE(113);
      if (lookahead == '=')
        ADVANCE(113);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym_operator_name);
      if (lookahead == '-')
        ADVANCE(113);
      if (lookahead == '=')
        ADVANCE(113);
      if (lookahead == '>')
        ADVANCE(118);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym_operator_name);
      if (lookahead == '*')
        ADVANCE(113);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym_operator_name);
      if (lookahead == '<')
        ADVANCE(112);
      if (lookahead == '=')
        ADVANCE(113);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(sym_operator_name);
      if (lookahead == '=')
        ADVANCE(113);
      if (lookahead == '>')
        ADVANCE(112);
      END_STATE();
    case 121:
      if (lookahead == ']')
        ADVANCE(113);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(sym_operator_name);
      if (lookahead == '=')
        ADVANCE(113);
      if (lookahead == '|')
        ADVANCE(113);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=')
        ADVANCE(126);
      if (lookahead == '|')
        ADVANCE(127);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 130:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(38);
      if (lookahead == '&')
        ADVANCE(40);
      if (lookahead == '\'')
        ADVANCE(43);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == ')')
        ADVANCE(45);
      if (lookahead == '*')
        ADVANCE(46);
      if (lookahead == '+')
        ADVANCE(48);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(52);
      if (lookahead == '.')
        ADVANCE(56);
      if (lookahead == '/')
        ADVANCE(59);
      if (lookahead == '0')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(74);
      if (lookahead == ';')
        ADVANCE(76);
      if (lookahead == '<')
        ADVANCE(77);
      if (lookahead == '=')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(83);
      if (lookahead == '?')
        ADVANCE(84);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == ']')
        ADVANCE(101);
      if (lookahead == '^')
        ADVANCE(102);
      if (lookahead == 'o')
        ADVANCE(104);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '|')
        ADVANCE(125);
      if (lookahead == '}')
        ADVANCE(128);
      if (lookahead == '~')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(130);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_LPAREN2);
      END_STATE();
    case 132:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(133);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '&')
        ADVANCE(135);
      if (lookahead == '\'')
        ADVANCE(43);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == '*')
        ADVANCE(136);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == '-')
        ADVANCE(138);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == '0')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(76);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == 'o')
        ADVANCE(104);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(132);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 134:
      if (lookahead == 'd')
        ADVANCE(6);
      if (lookahead == 'i')
        ADVANCE(23);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(134);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(41);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+')
        ADVANCE(49);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-')
        ADVANCE(53);
      END_STATE();
    case 139:
      if (lookahead == '*')
        ADVANCE(60);
      if (lookahead == '/')
        ADVANCE(63);
      END_STATE();
    case 140:
      if (lookahead == ':')
        ADVANCE(75);
      END_STATE();
    case 141:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == '<')
        ADVANCE(142);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(141);
      END_STATE();
    case 142:
      if (lookahead == '>')
        ADVANCE(143);
      if (lookahead == '\\')
        ADVANCE(144);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(142);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(sym_system_lib_string);
      END_STATE();
    case 144:
      if (lookahead == '>')
        ADVANCE(145);
      if (lookahead == '\\')
        ADVANCE(144);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(142);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym_system_lib_string);
      if (lookahead == '>')
        ADVANCE(143);
      if (lookahead == '\\')
        ADVANCE(144);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(142);
      END_STATE();
    case 146:
      if (lookahead == '!')
        ADVANCE(133);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == '\'')
        ADVANCE(43);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == '*')
        ADVANCE(136);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(138);
      if (lookahead == '.')
        ADVANCE(148);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == '0')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(76);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '}')
        ADVANCE(128);
      if (lookahead == '~')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(146);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 149:
      if (lookahead == '\n')
        SKIP(149);
      if (lookahead == '/')
        ADVANCE(150);
      if (lookahead == '\\')
        ADVANCE(155);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(157);
      if (lookahead != 0)
        ADVANCE(156);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '*')
        ADVANCE(151);
      if (lookahead == '/')
        ADVANCE(154);
      if (lookahead == '\\')
        ADVANCE(155);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(156);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n')
        ADVANCE(60);
      if (lookahead == '*')
        ADVANCE(152);
      if (lookahead == '\\')
        ADVANCE(153);
      if (lookahead != 0)
        ADVANCE(151);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n')
        ADVANCE(60);
      if (lookahead == '*')
        ADVANCE(152);
      if (lookahead == '/')
        ADVANCE(62);
      if (lookahead == '\\')
        ADVANCE(153);
      if (lookahead != 0)
        ADVANCE(151);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n')
        ADVANCE(151);
      if (lookahead == '*')
        ADVANCE(152);
      if (lookahead == '\\')
        ADVANCE(153);
      if (lookahead != 0)
        ADVANCE(151);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\\')
        ADVANCE(154);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(154);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n')
        ADVANCE(156);
      if (lookahead == '\\')
        ADVANCE(155);
      if (lookahead != 0)
        ADVANCE(156);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\\')
        ADVANCE(155);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(156);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/')
        ADVANCE(150);
      if (lookahead == '\\')
        ADVANCE(155);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(157);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(156);
      END_STATE();
    case 158:
      if (lookahead == '\n')
        ADVANCE(159);
      if (lookahead == '/')
        ADVANCE(150);
      if (lookahead == '\\')
        ADVANCE(155);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(160);
      if (lookahead != 0)
        ADVANCE(156);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_LF);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/')
        ADVANCE(150);
      if (lookahead == '\\')
        ADVANCE(155);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(160);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(156);
      END_STATE();
    case 161:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(133);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '&')
        ADVANCE(135);
      if (lookahead == '\'')
        ADVANCE(43);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == '*')
        ADVANCE(136);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == '-')
        ADVANCE(138);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == '0')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(76);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == 'o')
        ADVANCE(104);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '}')
        ADVANCE(128);
      if (lookahead == '~')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(161);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 162:
      if (lookahead == '!')
        ADVANCE(133);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(163);
      if (lookahead == '&')
        ADVANCE(135);
      if (lookahead == '\'')
        ADVANCE(43);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == '*')
        ADVANCE(136);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == '-')
        ADVANCE(138);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == '0')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == 'o')
        ADVANCE(104);
      if (lookahead == '}')
        ADVANCE(128);
      if (lookahead == '~')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(162);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 163:
      if (lookahead == 'i')
        ADVANCE(164);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(163);
      END_STATE();
    case 164:
      if (lookahead == 'f')
        ADVANCE(165);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH);
      if (lookahead == 'd')
        ADVANCE(166);
      if (lookahead == 'n')
        ADVANCE(169);
      END_STATE();
    case 166:
      if (lookahead == 'e')
        ADVANCE(167);
      END_STATE();
    case 167:
      if (lookahead == 'f')
        ADVANCE(168);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH);
      END_STATE();
    case 169:
      if (lookahead == 'd')
        ADVANCE(170);
      END_STATE();
    case 170:
      if (lookahead == 'e')
        ADVANCE(171);
      END_STATE();
    case 171:
      if (lookahead == 'f')
        ADVANCE(172);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH);
      END_STATE();
    case 173:
      if (lookahead == '!')
        ADVANCE(133);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == '\'')
        ADVANCE(43);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == '*')
        ADVANCE(136);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(138);
      if (lookahead == '.')
        ADVANCE(148);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == '0')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(174);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == ']')
        ADVANCE(101);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(173);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 175:
      if (lookahead == '&')
        ADVANCE(135);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == ')')
        ADVANCE(45);
      if (lookahead == '*')
        ADVANCE(136);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(176);
      if (lookahead == '.')
        ADVANCE(148);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == ':')
        ADVANCE(74);
      if (lookahead == ';')
        ADVANCE(76);
      if (lookahead == '<')
        ADVANCE(177);
      if (lookahead == '=')
        ADVANCE(174);
      if (lookahead == '>')
        ADVANCE(83);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == 'o')
        ADVANCE(104);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(175);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 176:
      if (lookahead == '>')
        ADVANCE(55);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 178:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(38);
      if (lookahead == '&')
        ADVANCE(40);
      if (lookahead == '\'')
        ADVANCE(43);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == '*')
        ADVANCE(46);
      if (lookahead == '+')
        ADVANCE(48);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(52);
      if (lookahead == '.')
        ADVANCE(148);
      if (lookahead == '/')
        ADVANCE(59);
      if (lookahead == '0')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(74);
      if (lookahead == ';')
        ADVANCE(76);
      if (lookahead == '<')
        ADVANCE(77);
      if (lookahead == '=')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(179);
      if (lookahead == '?')
        ADVANCE(84);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == '^')
        ADVANCE(102);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '|')
        ADVANCE(125);
      if (lookahead == '}')
        ADVANCE(128);
      if (lookahead == '~')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(178);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(180);
      if (lookahead == '>')
        ADVANCE(181);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=')
        ADVANCE(182);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 183:
      if (lookahead == '!')
        ADVANCE(133);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == '\'')
        ADVANCE(43);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == '*')
        ADVANCE(136);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(138);
      if (lookahead == '.')
        ADVANCE(148);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == '0')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(76);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '}')
        ADVANCE(128);
      if (lookahead == '~')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(183);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 184:
      if (lookahead == '!')
        ADVANCE(185);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(38);
      if (lookahead == '&')
        ADVANCE(40);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == ')')
        ADVANCE(45);
      if (lookahead == '*')
        ADVANCE(46);
      if (lookahead == '+')
        ADVANCE(48);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(52);
      if (lookahead == '.')
        ADVANCE(148);
      if (lookahead == '/')
        ADVANCE(59);
      if (lookahead == ':')
        ADVANCE(186);
      if (lookahead == ';')
        ADVANCE(76);
      if (lookahead == '<')
        ADVANCE(77);
      if (lookahead == '=')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(179);
      if (lookahead == '?')
        ADVANCE(84);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == '^')
        ADVANCE(102);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '|')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(184);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 185:
      if (lookahead == '=')
        ADVANCE(3);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 187:
      if (lookahead == '\n')
        SKIP(188);
      if (lookahead == '/')
        ADVANCE(189);
      if (lookahead == '\\')
        ADVANCE(190);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(191);
      if (lookahead != 0 &&
          lookahead != '\'')
        ADVANCE(191);
      END_STATE();
    case 188:
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(188);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_BSLASHn_SQUOTE_RBRACK_SLASH);
      if (lookahead == '*')
        ADVANCE(60);
      if (lookahead == '/')
        ADVANCE(63);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_BSLASHn_SQUOTE_RBRACK_SLASH);
      if (lookahead == 'U')
        ADVANCE(87);
      if (lookahead == 'u')
        ADVANCE(91);
      if (lookahead == 'x')
        ADVANCE(96);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(99);
      if (lookahead != 0)
        ADVANCE(95);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_BSLASHn_SQUOTE_RBRACK_SLASH);
      END_STATE();
    case 192:
      if (lookahead == '\n')
        SKIP(193);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '/')
        ADVANCE(194);
      if (lookahead == '\\')
        ADVANCE(86);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(194);
      if (lookahead != 0)
        ADVANCE(194);
      END_STATE();
    case 193:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(193);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_BSLASHn_RBRACK_SLASH);
      END_STATE();
    case 195:
      if (lookahead == '!')
        ADVANCE(185);
      if (lookahead == '%')
        ADVANCE(38);
      if (lookahead == '&')
        ADVANCE(40);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == '*')
        ADVANCE(46);
      if (lookahead == '+')
        ADVANCE(48);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(52);
      if (lookahead == '.')
        ADVANCE(148);
      if (lookahead == '/')
        ADVANCE(59);
      if (lookahead == ':')
        ADVANCE(74);
      if (lookahead == ';')
        ADVANCE(76);
      if (lookahead == '<')
        ADVANCE(77);
      if (lookahead == '=')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(179);
      if (lookahead == '?')
        ADVANCE(84);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == '^')
        ADVANCE(102);
      if (lookahead == 'o')
        ADVANCE(104);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '|')
        ADVANCE(125);
      if (lookahead == '}')
        ADVANCE(128);
      if (lookahead == '~')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(195);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 196:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(196);
      END_STATE();
    case 197:
      if (lookahead == '&')
        ADVANCE(135);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == ')')
        ADVANCE(45);
      if (lookahead == '*')
        ADVANCE(136);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == ':')
        ADVANCE(74);
      if (lookahead == ';')
        ADVANCE(76);
      if (lookahead == '<')
        ADVANCE(177);
      if (lookahead == '=')
        ADVANCE(174);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == 'o')
        ADVANCE(104);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(197);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 198:
      if (lookahead == '\n')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(44);
      if (lookahead == '/')
        ADVANCE(150);
      if (lookahead == '\\')
        ADVANCE(155);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(160);
      if (lookahead != 0)
        ADVANCE(156);
      END_STATE();
    case 199:
      if (lookahead == '!')
        ADVANCE(133);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(135);
      if (lookahead == '\'')
        ADVANCE(43);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == '*')
        ADVANCE(136);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(138);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == '0')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(76);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == 'o')
        ADVANCE(104);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(199);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 200:
      if (lookahead == '\n')
        ADVANCE(159);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(200);
      END_STATE();
    case 201:
      if (lookahead == '&')
        ADVANCE(135);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == ')')
        ADVANCE(45);
      if (lookahead == '*')
        ADVANCE(136);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(176);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == ':')
        ADVANCE(74);
      if (lookahead == ';')
        ADVANCE(76);
      if (lookahead == '<')
        ADVANCE(177);
      if (lookahead == '=')
        ADVANCE(174);
      if (lookahead == '>')
        ADVANCE(83);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(201);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 202:
      if (lookahead == '!')
        ADVANCE(185);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(38);
      if (lookahead == '&')
        ADVANCE(40);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == ')')
        ADVANCE(45);
      if (lookahead == '*')
        ADVANCE(46);
      if (lookahead == '+')
        ADVANCE(48);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(52);
      if (lookahead == '.')
        ADVANCE(148);
      if (lookahead == '/')
        ADVANCE(59);
      if (lookahead == ':')
        ADVANCE(74);
      if (lookahead == ';')
        ADVANCE(76);
      if (lookahead == '<')
        ADVANCE(77);
      if (lookahead == '=')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(179);
      if (lookahead == '?')
        ADVANCE(84);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == ']')
        ADVANCE(101);
      if (lookahead == '^')
        ADVANCE(102);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '|')
        ADVANCE(125);
      if (lookahead == '}')
        ADVANCE(128);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(202);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 203:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(38);
      if (lookahead == '&')
        ADVANCE(40);
      if (lookahead == '\'')
        ADVANCE(43);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == ')')
        ADVANCE(45);
      if (lookahead == '*')
        ADVANCE(46);
      if (lookahead == '+')
        ADVANCE(48);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(52);
      if (lookahead == '.')
        ADVANCE(148);
      if (lookahead == '/')
        ADVANCE(59);
      if (lookahead == '0')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(77);
      if (lookahead == '=')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(179);
      if (lookahead == '?')
        ADVANCE(84);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == '^')
        ADVANCE(102);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '|')
        ADVANCE(125);
      if (lookahead == '~')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(203);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 204:
      if (lookahead == '&')
        ADVANCE(135);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == ')')
        ADVANCE(45);
      if (lookahead == '*')
        ADVANCE(136);
      if (lookahead == '.')
        ADVANCE(205);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(204);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 205:
      if (lookahead == '.')
        ADVANCE(57);
      END_STATE();
    case 206:
      if (lookahead == '!')
        ADVANCE(185);
      if (lookahead == '%')
        ADVANCE(38);
      if (lookahead == '&')
        ADVANCE(40);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == ')')
        ADVANCE(45);
      if (lookahead == '*')
        ADVANCE(46);
      if (lookahead == '+')
        ADVANCE(48);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(52);
      if (lookahead == '.')
        ADVANCE(148);
      if (lookahead == '/')
        ADVANCE(59);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(76);
      if (lookahead == '<')
        ADVANCE(77);
      if (lookahead == '=')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(179);
      if (lookahead == '?')
        ADVANCE(84);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == '^')
        ADVANCE(102);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '|')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(206);
      END_STATE();
    case 207:
      if (lookahead == '!')
        ADVANCE(133);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == '\'')
        ADVANCE(43);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == '*')
        ADVANCE(136);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == '-')
        ADVANCE(138);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == '0')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == ']')
        ADVANCE(101);
      if (lookahead == '~')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(207);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 208:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(38);
      if (lookahead == '&')
        ADVANCE(40);
      if (lookahead == '\'')
        ADVANCE(43);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == '*')
        ADVANCE(46);
      if (lookahead == '+')
        ADVANCE(48);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(52);
      if (lookahead == '.')
        ADVANCE(148);
      if (lookahead == '/')
        ADVANCE(59);
      if (lookahead == '0')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(77);
      if (lookahead == '=')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(179);
      if (lookahead == '?')
        ADVANCE(84);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == ']')
        ADVANCE(101);
      if (lookahead == '^')
        ADVANCE(102);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '|')
        ADVANCE(125);
      if (lookahead == '~')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(208);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 209:
      if (lookahead == '&')
        ADVANCE(135);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == ')')
        ADVANCE(45);
      if (lookahead == '*')
        ADVANCE(136);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(176);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == ':')
        ADVANCE(186);
      if (lookahead == ';')
        ADVANCE(76);
      if (lookahead == '<')
        ADVANCE(177);
      if (lookahead == '=')
        ADVANCE(174);
      if (lookahead == '>')
        ADVANCE(83);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(209);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 210:
      if (lookahead == '!')
        ADVANCE(133);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == '\'')
        ADVANCE(43);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == '*')
        ADVANCE(136);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(138);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == '0')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '>')
        ADVANCE(83);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == '~')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(210);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 211:
      if (lookahead == '!')
        ADVANCE(185);
      if (lookahead == '%')
        ADVANCE(38);
      if (lookahead == '&')
        ADVANCE(40);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == ')')
        ADVANCE(45);
      if (lookahead == '*')
        ADVANCE(46);
      if (lookahead == '+')
        ADVANCE(48);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(52);
      if (lookahead == '.')
        ADVANCE(148);
      if (lookahead == '/')
        ADVANCE(59);
      if (lookahead == ':')
        ADVANCE(186);
      if (lookahead == ';')
        ADVANCE(76);
      if (lookahead == '<')
        ADVANCE(77);
      if (lookahead == '=')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(179);
      if (lookahead == '?')
        ADVANCE(84);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == ']')
        ADVANCE(101);
      if (lookahead == '^')
        ADVANCE(102);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '|')
        ADVANCE(125);
      if (lookahead == '}')
        ADVANCE(128);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(211);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 212:
      if (lookahead == '!')
        ADVANCE(185);
      if (lookahead == '%')
        ADVANCE(38);
      if (lookahead == '&')
        ADVANCE(40);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == ')')
        ADVANCE(45);
      if (lookahead == '*')
        ADVANCE(46);
      if (lookahead == '+')
        ADVANCE(48);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(52);
      if (lookahead == '.')
        ADVANCE(148);
      if (lookahead == '/')
        ADVANCE(59);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(76);
      if (lookahead == '<')
        ADVANCE(77);
      if (lookahead == '=')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(179);
      if (lookahead == '?')
        ADVANCE(84);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == '^')
        ADVANCE(102);
      if (lookahead == 'o')
        ADVANCE(104);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '|')
        ADVANCE(125);
      if (lookahead == '}')
        ADVANCE(128);
      if (lookahead == '~')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(212);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 213:
      if (lookahead == '&')
        ADVANCE(135);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == '*')
        ADVANCE(136);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == ':')
        ADVANCE(74);
      if (lookahead == ';')
        ADVANCE(76);
      if (lookahead == '<')
        ADVANCE(177);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == 'o')
        ADVANCE(104);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(213);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 214:
      if (lookahead == '!')
        ADVANCE(133);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == '\'')
        ADVANCE(43);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == ')')
        ADVANCE(45);
      if (lookahead == '*')
        ADVANCE(136);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == '-')
        ADVANCE(138);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == '0')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(214);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 215:
      if (lookahead == '!')
        ADVANCE(133);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(216);
      if (lookahead == '&')
        ADVANCE(135);
      if (lookahead == '\'')
        ADVANCE(43);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == '*')
        ADVANCE(136);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(138);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == '0')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(76);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == 'o')
        ADVANCE(104);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(215);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 216:
      if (lookahead == 'd')
        ADVANCE(6);
      if (lookahead == 'e')
        ADVANCE(217);
      if (lookahead == 'i')
        ADVANCE(23);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(216);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'n')
        ADVANCE(19);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 218:
      if (lookahead == '!')
        ADVANCE(133);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(219);
      if (lookahead == '&')
        ADVANCE(135);
      if (lookahead == '\'')
        ADVANCE(43);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == '*')
        ADVANCE(136);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == '-')
        ADVANCE(138);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == '0')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(76);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == '~')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(218);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 219:
      if (lookahead == 'e')
        ADVANCE(220);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(219);
      END_STATE();
    case 220:
      if (lookahead == 'n')
        ADVANCE(221);
      END_STATE();
    case 221:
      if (lookahead == 'd')
        ADVANCE(222);
      END_STATE();
    case 222:
      if (lookahead == 'i')
        ADVANCE(223);
      END_STATE();
    case 223:
      if (lookahead == 'f')
        ADVANCE(224);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH);
      END_STATE();
    case 225:
      if (lookahead == '&')
        ADVANCE(135);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == '*')
        ADVANCE(136);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(176);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == ':')
        ADVANCE(186);
      if (lookahead == ';')
        ADVANCE(76);
      if (lookahead == '<')
        ADVANCE(177);
      if (lookahead == '=')
        ADVANCE(174);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(225);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 226:
      if (lookahead == '!')
        ADVANCE(133);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == '\'')
        ADVANCE(43);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == '*')
        ADVANCE(136);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == '-')
        ADVANCE(138);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == '0')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(76);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(226);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 227:
      if (lookahead == '!')
        ADVANCE(185);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(38);
      if (lookahead == '&')
        ADVANCE(40);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == '*')
        ADVANCE(46);
      if (lookahead == '+')
        ADVANCE(48);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(52);
      if (lookahead == '.')
        ADVANCE(148);
      if (lookahead == '/')
        ADVANCE(59);
      if (lookahead == ':')
        ADVANCE(74);
      if (lookahead == '<')
        ADVANCE(77);
      if (lookahead == '=')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(83);
      if (lookahead == '?')
        ADVANCE(84);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == '^')
        ADVANCE(102);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '|')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(227);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 228:
      if (lookahead == '!')
        ADVANCE(185);
      if (lookahead == '%')
        ADVANCE(38);
      if (lookahead == '&')
        ADVANCE(40);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == ')')
        ADVANCE(45);
      if (lookahead == '*')
        ADVANCE(46);
      if (lookahead == '+')
        ADVANCE(48);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(52);
      if (lookahead == '.')
        ADVANCE(148);
      if (lookahead == '/')
        ADVANCE(59);
      if (lookahead == ':')
        ADVANCE(74);
      if (lookahead == ';')
        ADVANCE(76);
      if (lookahead == '<')
        ADVANCE(77);
      if (lookahead == '=')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(179);
      if (lookahead == '?')
        ADVANCE(84);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == ']')
        ADVANCE(101);
      if (lookahead == '^')
        ADVANCE(102);
      if (lookahead == 'o')
        ADVANCE(104);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '|')
        ADVANCE(125);
      if (lookahead == '}')
        ADVANCE(128);
      if (lookahead == '~')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(228);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 229:
      if (lookahead == '&')
        ADVANCE(135);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == '*')
        ADVANCE(136);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(176);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(177);
      if (lookahead == '=')
        ADVANCE(174);
      if (lookahead == '>')
        ADVANCE(83);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(229);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 230:
      if (lookahead == '&')
        ADVANCE(135);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == '*')
        ADVANCE(136);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == ':')
        ADVANCE(74);
      if (lookahead == '<')
        ADVANCE(177);
      if (lookahead == '=')
        ADVANCE(174);
      if (lookahead == '>')
        ADVANCE(83);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == 'o')
        ADVANCE(104);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(230);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 231:
      if (lookahead == '!')
        ADVANCE(133);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == '\'')
        ADVANCE(43);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == ')')
        ADVANCE(45);
      if (lookahead == '*')
        ADVANCE(136);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == '-')
        ADVANCE(138);
      if (lookahead == '.')
        ADVANCE(205);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == '0')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(231);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 232:
      if (lookahead == '&')
        ADVANCE(135);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == ')')
        ADVANCE(45);
      if (lookahead == '*')
        ADVANCE(136);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == 'o')
        ADVANCE(104);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(232);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 233:
      if (lookahead == '!')
        ADVANCE(133);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(216);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == '\'')
        ADVANCE(43);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == '*')
        ADVANCE(136);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == '-')
        ADVANCE(138);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == '0')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(76);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(233);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 234:
      if (lookahead == '#')
        ADVANCE(235);
      if (lookahead == '&')
        ADVANCE(135);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == '*')
        ADVANCE(136);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == 'o')
        ADVANCE(104);
      if (lookahead == '~')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(234);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 235:
      if (lookahead == 'e')
        ADVANCE(236);
      if (lookahead == 'i')
        ADVANCE(164);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(235);
      END_STATE();
    case 236:
      if (lookahead == 'l')
        ADVANCE(237);
      if (lookahead == 'n')
        ADVANCE(221);
      END_STATE();
    case 237:
      if (lookahead == 'i')
        ADVANCE(238);
      if (lookahead == 's')
        ADVANCE(240);
      END_STATE();
    case 238:
      if (lookahead == 'f')
        ADVANCE(239);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH);
      END_STATE();
    case 240:
      if (lookahead == 'e')
        ADVANCE(241);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH);
      END_STATE();
    case 242:
      if (lookahead == '#')
        ADVANCE(235);
      if (lookahead == '&')
        ADVANCE(135);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == '*')
        ADVANCE(136);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(76);
      if (lookahead == 'o')
        ADVANCE(104);
      if (lookahead == '}')
        ADVANCE(128);
      if (lookahead == '~')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(242);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 243:
      if (lookahead == '!')
        ADVANCE(185);
      if (lookahead == '%')
        ADVANCE(38);
      if (lookahead == '&')
        ADVANCE(40);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == '*')
        ADVANCE(46);
      if (lookahead == '+')
        ADVANCE(48);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(52);
      if (lookahead == '.')
        ADVANCE(148);
      if (lookahead == '/')
        ADVANCE(59);
      if (lookahead == ':')
        ADVANCE(186);
      if (lookahead == ';')
        ADVANCE(76);
      if (lookahead == '<')
        ADVANCE(77);
      if (lookahead == '=')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(179);
      if (lookahead == '?')
        ADVANCE(84);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == '^')
        ADVANCE(102);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '|')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(243);
      END_STATE();
    case 244:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(38);
      if (lookahead == '&')
        ADVANCE(40);
      if (lookahead == '\'')
        ADVANCE(43);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == '*')
        ADVANCE(46);
      if (lookahead == '+')
        ADVANCE(48);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(52);
      if (lookahead == '.')
        ADVANCE(148);
      if (lookahead == '/')
        ADVANCE(59);
      if (lookahead == '0')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(76);
      if (lookahead == '<')
        ADVANCE(77);
      if (lookahead == '=')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(179);
      if (lookahead == '?')
        ADVANCE(84);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == '^')
        ADVANCE(102);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '|')
        ADVANCE(125);
      if (lookahead == '}')
        ADVANCE(128);
      if (lookahead == '~')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(244);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 245:
      if (lookahead == '&')
        ADVANCE(135);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == ')')
        ADVANCE(45);
      if (lookahead == '*')
        ADVANCE(136);
      if (lookahead == '.')
        ADVANCE(205);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == 'o')
        ADVANCE(104);
      if (lookahead == '~')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(245);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 246:
      if (lookahead == ')')
        ADVANCE(45);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == '>')
        ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(246);
      END_STATE();
    case 247:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(133);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '&')
        ADVANCE(135);
      if (lookahead == '\'')
        ADVANCE(43);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == '*')
        ADVANCE(136);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(138);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == '0')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(76);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == 'o')
        ADVANCE(104);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '}')
        ADVANCE(128);
      if (lookahead == '~')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(247);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 248:
      if (lookahead == '!')
        ADVANCE(185);
      if (lookahead == '%')
        ADVANCE(38);
      if (lookahead == '&')
        ADVANCE(40);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == ')')
        ADVANCE(45);
      if (lookahead == '*')
        ADVANCE(46);
      if (lookahead == '+')
        ADVANCE(48);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(52);
      if (lookahead == '.')
        ADVANCE(148);
      if (lookahead == '/')
        ADVANCE(59);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(77);
      if (lookahead == '=')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(179);
      if (lookahead == '?')
        ADVANCE(84);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == '^')
        ADVANCE(102);
      if (lookahead == 'o')
        ADVANCE(104);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '|')
        ADVANCE(125);
      if (lookahead == '~')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(248);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 249:
      if (lookahead == '&')
        ADVANCE(135);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == ')')
        ADVANCE(45);
      if (lookahead == '*')
        ADVANCE(136);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(176);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == '=')
        ADVANCE(174);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(249);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 250:
      if (lookahead == '!')
        ADVANCE(185);
      if (lookahead == '%')
        ADVANCE(38);
      if (lookahead == '&')
        ADVANCE(40);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == '*')
        ADVANCE(46);
      if (lookahead == '+')
        ADVANCE(48);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(52);
      if (lookahead == '.')
        ADVANCE(148);
      if (lookahead == '/')
        ADVANCE(59);
      if (lookahead == ':')
        ADVANCE(186);
      if (lookahead == '<')
        ADVANCE(77);
      if (lookahead == '=')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(83);
      if (lookahead == '?')
        ADVANCE(84);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == '^')
        ADVANCE(102);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '|')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(250);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 251:
      if (lookahead == '&')
        ADVANCE(135);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == '*')
        ADVANCE(136);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(176);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == ':')
        ADVANCE(74);
      if (lookahead == ';')
        ADVANCE(76);
      if (lookahead == '<')
        ADVANCE(177);
      if (lookahead == '=')
        ADVANCE(174);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(251);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 252:
      if (lookahead == '&')
        ADVANCE(135);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == ')')
        ADVANCE(45);
      if (lookahead == '*')
        ADVANCE(136);
      if (lookahead == '-')
        ADVANCE(176);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == ':')
        ADVANCE(74);
      if (lookahead == ';')
        ADVANCE(76);
      if (lookahead == '<')
        ADVANCE(177);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(252);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 253:
      if (lookahead == '&')
        ADVANCE(135);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == ')')
        ADVANCE(45);
      if (lookahead == '*')
        ADVANCE(136);
      if (lookahead == '-')
        ADVANCE(176);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead == ':')
        ADVANCE(186);
      if (lookahead == ';')
        ADVANCE(76);
      if (lookahead == '<')
        ADVANCE(177);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(253);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    case 254:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(38);
      if (lookahead == '&')
        ADVANCE(40);
      if (lookahead == '\'')
        ADVANCE(43);
      if (lookahead == '(')
        ADVANCE(131);
      if (lookahead == '*')
        ADVANCE(46);
      if (lookahead == '+')
        ADVANCE(48);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(52);
      if (lookahead == '.')
        ADVANCE(148);
      if (lookahead == '/')
        ADVANCE(59);
      if (lookahead == '0')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(77);
      if (lookahead == '=')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(83);
      if (lookahead == '?')
        ADVANCE(84);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == '^')
        ADVANCE(102);
      if (lookahead == '{')
        ADVANCE(124);
      if (lookahead == '|')
        ADVANCE(125);
      if (lookahead == '~')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(254);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(123);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 'F')
        ADVANCE(1);
      if (lookahead == 'N')
        ADVANCE(6);
      if (lookahead == 'T')
        ADVANCE(10);
      if (lookahead == '_')
        ADVANCE(14);
      if (lookahead == 'a')
        ADVANCE(21);
      if (lookahead == 'b')
        ADVANCE(25);
      if (lookahead == 'c')
        ADVANCE(33);
      if (lookahead == 'd')
        ADVANCE(67);
      if (lookahead == 'e')
        ADVANCE(82);
      if (lookahead == 'f')
        ADVANCE(100);
      if (lookahead == 'g')
        ADVANCE(117);
      if (lookahead == 'i')
        ADVANCE(121);
      if (lookahead == 'l')
        ADVANCE(128);
      if (lookahead == 'm')
        ADVANCE(132);
      if (lookahead == 'n')
        ADVANCE(139);
      if (lookahead == 'o')
        ADVANCE(163);
      if (lookahead == 'p')
        ADVANCE(171);
      if (lookahead == 'r')
        ADVANCE(190);
      if (lookahead == 's')
        ADVANCE(208);
      if (lookahead == 't')
        ADVANCE(235);
      if (lookahead == 'u')
        ADVANCE(256);
      if (lookahead == 'v')
        ADVANCE(274);
      if (lookahead == 'w')
        ADVANCE(283);
      END_STATE();
    case 1:
      if (lookahead == 'A')
        ADVANCE(2);
      END_STATE();
    case 2:
      if (lookahead == 'L')
        ADVANCE(3);
      END_STATE();
    case 3:
      if (lookahead == 'S')
        ADVANCE(4);
      END_STATE();
    case 4:
      if (lookahead == 'E')
        ADVANCE(5);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 6:
      if (lookahead == 'U')
        ADVANCE(7);
      END_STATE();
    case 7:
      if (lookahead == 'L')
        ADVANCE(8);
      END_STATE();
    case 8:
      if (lookahead == 'L')
        ADVANCE(9);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 10:
      if (lookahead == 'R')
        ADVANCE(11);
      END_STATE();
    case 11:
      if (lookahead == 'U')
        ADVANCE(12);
      END_STATE();
    case 12:
      if (lookahead == 'E')
        ADVANCE(13);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 14:
      if (lookahead == 'A')
        ADVANCE(15);
      END_STATE();
    case 15:
      if (lookahead == 't')
        ADVANCE(16);
      END_STATE();
    case 16:
      if (lookahead == 'o')
        ADVANCE(17);
      END_STATE();
    case 17:
      if (lookahead == 'm')
        ADVANCE(18);
      END_STATE();
    case 18:
      if (lookahead == 'i')
        ADVANCE(19);
      END_STATE();
    case 19:
      if (lookahead == 'c')
        ADVANCE(20);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym__Atomic);
      END_STATE();
    case 21:
      if (lookahead == 'u')
        ADVANCE(22);
      END_STATE();
    case 22:
      if (lookahead == 't')
        ADVANCE(23);
      END_STATE();
    case 23:
      if (lookahead == 'o')
        ADVANCE(24);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(sym_auto);
      END_STATE();
    case 25:
      if (lookahead == 'o')
        ADVANCE(26);
      if (lookahead == 'r')
        ADVANCE(29);
      END_STATE();
    case 26:
      if (lookahead == 'o')
        ADVANCE(27);
      END_STATE();
    case 27:
      if (lookahead == 'l')
        ADVANCE(28);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(sym_primitive_type);
      END_STATE();
    case 29:
      if (lookahead == 'e')
        ADVANCE(30);
      END_STATE();
    case 30:
      if (lookahead == 'a')
        ADVANCE(31);
      END_STATE();
    case 31:
      if (lookahead == 'k')
        ADVANCE(32);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 33:
      if (lookahead == 'a')
        ADVANCE(34);
      if (lookahead == 'h')
        ADVANCE(40);
      if (lookahead == 'l')
        ADVANCE(50);
      if (lookahead == 'o')
        ADVANCE(54);
      END_STATE();
    case 34:
      if (lookahead == 's')
        ADVANCE(35);
      if (lookahead == 't')
        ADVANCE(37);
      END_STATE();
    case 35:
      if (lookahead == 'e')
        ADVANCE(36);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 37:
      if (lookahead == 'c')
        ADVANCE(38);
      END_STATE();
    case 38:
      if (lookahead == 'h')
        ADVANCE(39);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 40:
      if (lookahead == 'a')
        ADVANCE(41);
      END_STATE();
    case 41:
      if (lookahead == 'r')
        ADVANCE(42);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(sym_primitive_type);
      if (lookahead == '1')
        ADVANCE(43);
      if (lookahead == '3')
        ADVANCE(46);
      if (lookahead == '6')
        ADVANCE(47);
      if (lookahead == '8')
        ADVANCE(44);
      if (lookahead == 'p')
        ADVANCE(48);
      END_STATE();
    case 43:
      if (lookahead == '6')
        ADVANCE(44);
      END_STATE();
    case 44:
      if (lookahead == '_')
        ADVANCE(45);
      END_STATE();
    case 45:
      if (lookahead == 't')
        ADVANCE(28);
      END_STATE();
    case 46:
      if (lookahead == '2')
        ADVANCE(44);
      END_STATE();
    case 47:
      if (lookahead == '4')
        ADVANCE(44);
      END_STATE();
    case 48:
      if (lookahead == 't')
        ADVANCE(49);
      END_STATE();
    case 49:
      if (lookahead == 'r')
        ADVANCE(44);
      END_STATE();
    case 50:
      if (lookahead == 'a')
        ADVANCE(51);
      END_STATE();
    case 51:
      if (lookahead == 's')
        ADVANCE(52);
      END_STATE();
    case 52:
      if (lookahead == 's')
        ADVANCE(53);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 54:
      if (lookahead == 'n')
        ADVANCE(55);
      END_STATE();
    case 55:
      if (lookahead == 's')
        ADVANCE(56);
      if (lookahead == 't')
        ADVANCE(62);
      END_STATE();
    case 56:
      if (lookahead == 't')
        ADVANCE(57);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_const);
      if (lookahead == 'e')
        ADVANCE(58);
      END_STATE();
    case 58:
      if (lookahead == 'x')
        ADVANCE(59);
      END_STATE();
    case 59:
      if (lookahead == 'p')
        ADVANCE(60);
      END_STATE();
    case 60:
      if (lookahead == 'r')
        ADVANCE(61);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_constexpr);
      END_STATE();
    case 62:
      if (lookahead == 'i')
        ADVANCE(63);
      END_STATE();
    case 63:
      if (lookahead == 'n')
        ADVANCE(64);
      END_STATE();
    case 64:
      if (lookahead == 'u')
        ADVANCE(65);
      END_STATE();
    case 65:
      if (lookahead == 'e')
        ADVANCE(66);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 67:
      if (lookahead == 'e')
        ADVANCE(68);
      if (lookahead == 'o')
        ADVANCE(78);
      END_STATE();
    case 68:
      if (lookahead == 'f')
        ADVANCE(69);
      if (lookahead == 'l')
        ADVANCE(74);
      END_STATE();
    case 69:
      if (lookahead == 'a')
        ADVANCE(70);
      END_STATE();
    case 70:
      if (lookahead == 'u')
        ADVANCE(71);
      END_STATE();
    case 71:
      if (lookahead == 'l')
        ADVANCE(72);
      END_STATE();
    case 72:
      if (lookahead == 't')
        ADVANCE(73);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 74:
      if (lookahead == 'e')
        ADVANCE(75);
      END_STATE();
    case 75:
      if (lookahead == 't')
        ADVANCE(76);
      END_STATE();
    case 76:
      if (lookahead == 'e')
        ADVANCE(77);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'u')
        ADVANCE(79);
      END_STATE();
    case 79:
      if (lookahead == 'b')
        ADVANCE(80);
      END_STATE();
    case 80:
      if (lookahead == 'l')
        ADVANCE(81);
      END_STATE();
    case 81:
      if (lookahead == 'e')
        ADVANCE(28);
      END_STATE();
    case 82:
      if (lookahead == 'l')
        ADVANCE(83);
      if (lookahead == 'n')
        ADVANCE(86);
      if (lookahead == 'x')
        ADVANCE(89);
      END_STATE();
    case 83:
      if (lookahead == 's')
        ADVANCE(84);
      END_STATE();
    case 84:
      if (lookahead == 'e')
        ADVANCE(85);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 86:
      if (lookahead == 'u')
        ADVANCE(87);
      END_STATE();
    case 87:
      if (lookahead == 'm')
        ADVANCE(88);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 89:
      if (lookahead == 'p')
        ADVANCE(90);
      if (lookahead == 't')
        ADVANCE(96);
      END_STATE();
    case 90:
      if (lookahead == 'l')
        ADVANCE(91);
      END_STATE();
    case 91:
      if (lookahead == 'i')
        ADVANCE(92);
      END_STATE();
    case 92:
      if (lookahead == 'c')
        ADVANCE(93);
      END_STATE();
    case 93:
      if (lookahead == 'i')
        ADVANCE(94);
      END_STATE();
    case 94:
      if (lookahead == 't')
        ADVANCE(95);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_explicit);
      END_STATE();
    case 96:
      if (lookahead == 'e')
        ADVANCE(97);
      END_STATE();
    case 97:
      if (lookahead == 'r')
        ADVANCE(98);
      END_STATE();
    case 98:
      if (lookahead == 'n')
        ADVANCE(99);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_extern);
      END_STATE();
    case 100:
      if (lookahead == 'a')
        ADVANCE(101);
      if (lookahead == 'i')
        ADVANCE(104);
      if (lookahead == 'l')
        ADVANCE(108);
      if (lookahead == 'o')
        ADVANCE(110);
      if (lookahead == 'r')
        ADVANCE(112);
      END_STATE();
    case 101:
      if (lookahead == 'l')
        ADVANCE(102);
      END_STATE();
    case 102:
      if (lookahead == 's')
        ADVANCE(103);
      END_STATE();
    case 103:
      if (lookahead == 'e')
        ADVANCE(5);
      END_STATE();
    case 104:
      if (lookahead == 'n')
        ADVANCE(105);
      END_STATE();
    case 105:
      if (lookahead == 'a')
        ADVANCE(106);
      END_STATE();
    case 106:
      if (lookahead == 'l')
        ADVANCE(107);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_final);
      END_STATE();
    case 108:
      if (lookahead == 'o')
        ADVANCE(109);
      END_STATE();
    case 109:
      if (lookahead == 'a')
        ADVANCE(45);
      END_STATE();
    case 110:
      if (lookahead == 'r')
        ADVANCE(111);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 112:
      if (lookahead == 'i')
        ADVANCE(113);
      END_STATE();
    case 113:
      if (lookahead == 'e')
        ADVANCE(114);
      END_STATE();
    case 114:
      if (lookahead == 'n')
        ADVANCE(115);
      END_STATE();
    case 115:
      if (lookahead == 'd')
        ADVANCE(116);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_friend);
      END_STATE();
    case 117:
      if (lookahead == 'o')
        ADVANCE(118);
      END_STATE();
    case 118:
      if (lookahead == 't')
        ADVANCE(119);
      END_STATE();
    case 119:
      if (lookahead == 'o')
        ADVANCE(120);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_goto);
      END_STATE();
    case 121:
      if (lookahead == 'f')
        ADVANCE(122);
      if (lookahead == 'n')
        ADVANCE(123);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 123:
      if (lookahead == 'l')
        ADVANCE(124);
      if (lookahead == 't')
        ADVANCE(42);
      END_STATE();
    case 124:
      if (lookahead == 'i')
        ADVANCE(125);
      END_STATE();
    case 125:
      if (lookahead == 'n')
        ADVANCE(126);
      END_STATE();
    case 126:
      if (lookahead == 'e')
        ADVANCE(127);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_inline);
      END_STATE();
    case 128:
      if (lookahead == 'o')
        ADVANCE(129);
      END_STATE();
    case 129:
      if (lookahead == 'n')
        ADVANCE(130);
      END_STATE();
    case 130:
      if (lookahead == 'g')
        ADVANCE(131);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_long);
      END_STATE();
    case 132:
      if (lookahead == 'u')
        ADVANCE(133);
      END_STATE();
    case 133:
      if (lookahead == 't')
        ADVANCE(134);
      END_STATE();
    case 134:
      if (lookahead == 'a')
        ADVANCE(135);
      END_STATE();
    case 135:
      if (lookahead == 'b')
        ADVANCE(136);
      END_STATE();
    case 136:
      if (lookahead == 'l')
        ADVANCE(137);
      END_STATE();
    case 137:
      if (lookahead == 'e')
        ADVANCE(138);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_mutable);
      END_STATE();
    case 139:
      if (lookahead == 'a')
        ADVANCE(140);
      if (lookahead == 'e')
        ADVANCE(148);
      if (lookahead == 'o')
        ADVANCE(150);
      if (lookahead == 'u')
        ADVANCE(157);
      END_STATE();
    case 140:
      if (lookahead == 'm')
        ADVANCE(141);
      END_STATE();
    case 141:
      if (lookahead == 'e')
        ADVANCE(142);
      END_STATE();
    case 142:
      if (lookahead == 's')
        ADVANCE(143);
      END_STATE();
    case 143:
      if (lookahead == 'p')
        ADVANCE(144);
      END_STATE();
    case 144:
      if (lookahead == 'a')
        ADVANCE(145);
      END_STATE();
    case 145:
      if (lookahead == 'c')
        ADVANCE(146);
      END_STATE();
    case 146:
      if (lookahead == 'e')
        ADVANCE(147);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 148:
      if (lookahead == 'w')
        ADVANCE(149);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 150:
      if (lookahead == 'e')
        ADVANCE(151);
      END_STATE();
    case 151:
      if (lookahead == 'x')
        ADVANCE(152);
      END_STATE();
    case 152:
      if (lookahead == 'c')
        ADVANCE(153);
      END_STATE();
    case 153:
      if (lookahead == 'e')
        ADVANCE(154);
      END_STATE();
    case 154:
      if (lookahead == 'p')
        ADVANCE(155);
      END_STATE();
    case 155:
      if (lookahead == 't')
        ADVANCE(156);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym_noexcept);
      END_STATE();
    case 157:
      if (lookahead == 'l')
        ADVANCE(158);
      END_STATE();
    case 158:
      if (lookahead == 'l')
        ADVANCE(159);
      END_STATE();
    case 159:
      if (lookahead == 'p')
        ADVANCE(160);
      END_STATE();
    case 160:
      if (lookahead == 't')
        ADVANCE(161);
      END_STATE();
    case 161:
      if (lookahead == 'r')
        ADVANCE(162);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(sym_nullptr);
      END_STATE();
    case 163:
      if (lookahead == 'v')
        ADVANCE(164);
      END_STATE();
    case 164:
      if (lookahead == 'e')
        ADVANCE(165);
      END_STATE();
    case 165:
      if (lookahead == 'r')
        ADVANCE(166);
      END_STATE();
    case 166:
      if (lookahead == 'r')
        ADVANCE(167);
      END_STATE();
    case 167:
      if (lookahead == 'i')
        ADVANCE(168);
      END_STATE();
    case 168:
      if (lookahead == 'd')
        ADVANCE(169);
      END_STATE();
    case 169:
      if (lookahead == 'e')
        ADVANCE(170);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_override);
      END_STATE();
    case 171:
      if (lookahead == 'r')
        ADVANCE(172);
      if (lookahead == 'u')
        ADVANCE(185);
      END_STATE();
    case 172:
      if (lookahead == 'i')
        ADVANCE(173);
      if (lookahead == 'o')
        ADVANCE(178);
      END_STATE();
    case 173:
      if (lookahead == 'v')
        ADVANCE(174);
      END_STATE();
    case 174:
      if (lookahead == 'a')
        ADVANCE(175);
      END_STATE();
    case 175:
      if (lookahead == 't')
        ADVANCE(176);
      END_STATE();
    case 176:
      if (lookahead == 'e')
        ADVANCE(177);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 178:
      if (lookahead == 't')
        ADVANCE(179);
      END_STATE();
    case 179:
      if (lookahead == 'e')
        ADVANCE(180);
      END_STATE();
    case 180:
      if (lookahead == 'c')
        ADVANCE(181);
      END_STATE();
    case 181:
      if (lookahead == 't')
        ADVANCE(182);
      END_STATE();
    case 182:
      if (lookahead == 'e')
        ADVANCE(183);
      END_STATE();
    case 183:
      if (lookahead == 'd')
        ADVANCE(184);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 185:
      if (lookahead == 'b')
        ADVANCE(186);
      END_STATE();
    case 186:
      if (lookahead == 'l')
        ADVANCE(187);
      END_STATE();
    case 187:
      if (lookahead == 'i')
        ADVANCE(188);
      END_STATE();
    case 188:
      if (lookahead == 'c')
        ADVANCE(189);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 190:
      if (lookahead == 'e')
        ADVANCE(191);
      END_STATE();
    case 191:
      if (lookahead == 'g')
        ADVANCE(192);
      if (lookahead == 's')
        ADVANCE(198);
      if (lookahead == 't')
        ADVANCE(204);
      END_STATE();
    case 192:
      if (lookahead == 'i')
        ADVANCE(193);
      END_STATE();
    case 193:
      if (lookahead == 's')
        ADVANCE(194);
      END_STATE();
    case 194:
      if (lookahead == 't')
        ADVANCE(195);
      END_STATE();
    case 195:
      if (lookahead == 'e')
        ADVANCE(196);
      END_STATE();
    case 196:
      if (lookahead == 'r')
        ADVANCE(197);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_register);
      END_STATE();
    case 198:
      if (lookahead == 't')
        ADVANCE(199);
      END_STATE();
    case 199:
      if (lookahead == 'r')
        ADVANCE(200);
      END_STATE();
    case 200:
      if (lookahead == 'i')
        ADVANCE(201);
      END_STATE();
    case 201:
      if (lookahead == 'c')
        ADVANCE(202);
      END_STATE();
    case 202:
      if (lookahead == 't')
        ADVANCE(203);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_restrict);
      END_STATE();
    case 204:
      if (lookahead == 'u')
        ADVANCE(205);
      END_STATE();
    case 205:
      if (lookahead == 'r')
        ADVANCE(206);
      END_STATE();
    case 206:
      if (lookahead == 'n')
        ADVANCE(207);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 208:
      if (lookahead == 'h')
        ADVANCE(209);
      if (lookahead == 'i')
        ADVANCE(213);
      if (lookahead == 's')
        ADVANCE(218);
      if (lookahead == 't')
        ADVANCE(221);
      if (lookahead == 'w')
        ADVANCE(230);
      END_STATE();
    case 209:
      if (lookahead == 'o')
        ADVANCE(210);
      END_STATE();
    case 210:
      if (lookahead == 'r')
        ADVANCE(211);
      END_STATE();
    case 211:
      if (lookahead == 't')
        ADVANCE(212);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(anon_sym_short);
      END_STATE();
    case 213:
      if (lookahead == 'z')
        ADVANCE(214);
      END_STATE();
    case 214:
      if (lookahead == 'e')
        ADVANCE(215);
      END_STATE();
    case 215:
      if (lookahead == '_')
        ADVANCE(45);
      if (lookahead == 'o')
        ADVANCE(216);
      END_STATE();
    case 216:
      if (lookahead == 'f')
        ADVANCE(217);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_sizeof);
      END_STATE();
    case 218:
      if (lookahead == 'i')
        ADVANCE(219);
      END_STATE();
    case 219:
      if (lookahead == 'z')
        ADVANCE(220);
      END_STATE();
    case 220:
      if (lookahead == 'e')
        ADVANCE(44);
      END_STATE();
    case 221:
      if (lookahead == 'a')
        ADVANCE(222);
      if (lookahead == 'r')
        ADVANCE(226);
      END_STATE();
    case 222:
      if (lookahead == 't')
        ADVANCE(223);
      END_STATE();
    case 223:
      if (lookahead == 'i')
        ADVANCE(224);
      END_STATE();
    case 224:
      if (lookahead == 'c')
        ADVANCE(225);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 226:
      if (lookahead == 'u')
        ADVANCE(227);
      END_STATE();
    case 227:
      if (lookahead == 'c')
        ADVANCE(228);
      END_STATE();
    case 228:
      if (lookahead == 't')
        ADVANCE(229);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 230:
      if (lookahead == 'i')
        ADVANCE(231);
      END_STATE();
    case 231:
      if (lookahead == 't')
        ADVANCE(232);
      END_STATE();
    case 232:
      if (lookahead == 'c')
        ADVANCE(233);
      END_STATE();
    case 233:
      if (lookahead == 'h')
        ADVANCE(234);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 235:
      if (lookahead == 'e')
        ADVANCE(236);
      if (lookahead == 'r')
        ADVANCE(243);
      if (lookahead == 'y')
        ADVANCE(246);
      END_STATE();
    case 236:
      if (lookahead == 'm')
        ADVANCE(237);
      END_STATE();
    case 237:
      if (lookahead == 'p')
        ADVANCE(238);
      END_STATE();
    case 238:
      if (lookahead == 'l')
        ADVANCE(239);
      END_STATE();
    case 239:
      if (lookahead == 'a')
        ADVANCE(240);
      END_STATE();
    case 240:
      if (lookahead == 't')
        ADVANCE(241);
      END_STATE();
    case 241:
      if (lookahead == 'e')
        ADVANCE(242);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_template);
      END_STATE();
    case 243:
      if (lookahead == 'u')
        ADVANCE(244);
      if (lookahead == 'y')
        ADVANCE(245);
      END_STATE();
    case 244:
      if (lookahead == 'e')
        ADVANCE(13);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 246:
      if (lookahead == 'p')
        ADVANCE(247);
      END_STATE();
    case 247:
      if (lookahead == 'e')
        ADVANCE(248);
      END_STATE();
    case 248:
      if (lookahead == 'd')
        ADVANCE(249);
      if (lookahead == 'n')
        ADVANCE(252);
      END_STATE();
    case 249:
      if (lookahead == 'e')
        ADVANCE(250);
      END_STATE();
    case 250:
      if (lookahead == 'f')
        ADVANCE(251);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(anon_sym_typedef);
      END_STATE();
    case 252:
      if (lookahead == 'a')
        ADVANCE(253);
      END_STATE();
    case 253:
      if (lookahead == 'm')
        ADVANCE(254);
      END_STATE();
    case 254:
      if (lookahead == 'e')
        ADVANCE(255);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_typename);
      END_STATE();
    case 256:
      if (lookahead == 'i')
        ADVANCE(257);
      if (lookahead == 'n')
        ADVANCE(260);
      if (lookahead == 's')
        ADVANCE(270);
      END_STATE();
    case 257:
      if (lookahead == 'n')
        ADVANCE(258);
      END_STATE();
    case 258:
      if (lookahead == 't')
        ADVANCE(259);
      END_STATE();
    case 259:
      if (lookahead == '1')
        ADVANCE(43);
      if (lookahead == '3')
        ADVANCE(46);
      if (lookahead == '6')
        ADVANCE(47);
      if (lookahead == '8')
        ADVANCE(44);
      if (lookahead == 'p')
        ADVANCE(48);
      END_STATE();
    case 260:
      if (lookahead == 'i')
        ADVANCE(261);
      if (lookahead == 's')
        ADVANCE(264);
      END_STATE();
    case 261:
      if (lookahead == 'o')
        ADVANCE(262);
      END_STATE();
    case 262:
      if (lookahead == 'n')
        ADVANCE(263);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(anon_sym_union);
      END_STATE();
    case 264:
      if (lookahead == 'i')
        ADVANCE(265);
      END_STATE();
    case 265:
      if (lookahead == 'g')
        ADVANCE(266);
      END_STATE();
    case 266:
      if (lookahead == 'n')
        ADVANCE(267);
      END_STATE();
    case 267:
      if (lookahead == 'e')
        ADVANCE(268);
      END_STATE();
    case 268:
      if (lookahead == 'd')
        ADVANCE(269);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(anon_sym_unsigned);
      END_STATE();
    case 270:
      if (lookahead == 'i')
        ADVANCE(271);
      END_STATE();
    case 271:
      if (lookahead == 'n')
        ADVANCE(272);
      END_STATE();
    case 272:
      if (lookahead == 'g')
        ADVANCE(273);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_using);
      END_STATE();
    case 274:
      if (lookahead == 'o')
        ADVANCE(275);
      END_STATE();
    case 275:
      if (lookahead == 'i')
        ADVANCE(276);
      if (lookahead == 'l')
        ADVANCE(277);
      END_STATE();
    case 276:
      if (lookahead == 'd')
        ADVANCE(28);
      END_STATE();
    case 277:
      if (lookahead == 'a')
        ADVANCE(278);
      END_STATE();
    case 278:
      if (lookahead == 't')
        ADVANCE(279);
      END_STATE();
    case 279:
      if (lookahead == 'i')
        ADVANCE(280);
      END_STATE();
    case 280:
      if (lookahead == 'l')
        ADVANCE(281);
      END_STATE();
    case 281:
      if (lookahead == 'e')
        ADVANCE(282);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(anon_sym_volatile);
      END_STATE();
    case 283:
      if (lookahead == 'h')
        ADVANCE(284);
      END_STATE();
    case 284:
      if (lookahead == 'i')
        ADVANCE(285);
      END_STATE();
    case 285:
      if (lookahead == 'l')
        ADVANCE(286);
      END_STATE();
    case 286:
      if (lookahead == 'e')
        ADVANCE(287);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 132, .external_lex_state = 1},
  [2] = {.lex_state = 141},
  [3] = {.lex_state = 146},
  [4] = {.lex_state = 149},
  [5] = {.lex_state = 146},
  [6] = {.lex_state = 158},
  [7] = {.lex_state = 161, .external_lex_state = 1},
  [8] = {.lex_state = 146},
  [9] = {.lex_state = 132},
  [10] = {.lex_state = 146, .external_lex_state = 1},
  [11] = {.lex_state = 162, .external_lex_state = 1},
  [12] = {.lex_state = 162, .external_lex_state = 1},
  [13] = {.lex_state = 173, .external_lex_state = 1},
  [14] = {.lex_state = 175},
  [15] = {.lex_state = 175},
  [16] = {.lex_state = 146},
  [17] = {.lex_state = 178},
  [18] = {.lex_state = 178},
  [19] = {.lex_state = 146},
  [20] = {.lex_state = 132},
  [21] = {.lex_state = 183, .external_lex_state = 1},
  [22] = {.lex_state = 184},
  [23] = {.lex_state = 132},
  [24] = {.lex_state = 183, .external_lex_state = 1},
  [25] = {.lex_state = 132},
  [26] = {.lex_state = 183, .external_lex_state = 1},
  [27] = {.lex_state = 132},
  [28] = {.lex_state = 132},
  [29] = {.lex_state = 146},
  [30] = {.lex_state = 162, .external_lex_state = 1},
  [31] = {.lex_state = 132},
  [32] = {.lex_state = 183, .external_lex_state = 1},
  [33] = {.lex_state = 183, .external_lex_state = 1},
  [34] = {.lex_state = 183, .external_lex_state = 1},
  [35] = {.lex_state = 183, .external_lex_state = 1},
  [36] = {.lex_state = 187},
  [37] = {.lex_state = 192},
  [38] = {.lex_state = 195},
  [39] = {.lex_state = 178},
  [40] = {.lex_state = 146},
  [41] = {.lex_state = 175},
  [42] = {.lex_state = 183, .external_lex_state = 1},
  [43] = {.lex_state = 146},
  [44] = {.lex_state = 146},
  [45] = {.lex_state = 132},
  [46] = {.lex_state = 146},
  [47] = {.lex_state = 132},
  [48] = {.lex_state = 196},
  [49] = {.lex_state = 132},
  [50] = {.lex_state = 132},
  [51] = {.lex_state = 184},
  [52] = {.lex_state = 132},
  [53] = {.lex_state = 178},
  [54] = {.lex_state = 132},
  [55] = {.lex_state = 178},
  [56] = {.lex_state = 197},
  [57] = {.lex_state = 184},
  [58] = {.lex_state = 132},
  [59] = {.lex_state = 184},
  [60] = {.lex_state = 197},
  [61] = {.lex_state = 132},
  [62] = {.lex_state = 132, .external_lex_state = 1},
  [63] = {.lex_state = 132},
  [64] = {.lex_state = 132},
  [65] = {.lex_state = 192},
  [66] = {.lex_state = 161, .external_lex_state = 1},
  [67] = {.lex_state = 198},
  [68] = {.lex_state = 199, .external_lex_state = 1},
  [69] = {.lex_state = 199, .external_lex_state = 1},
  [70] = {.lex_state = 161, .external_lex_state = 1},
  [71] = {.lex_state = 200},
  [72] = {.lex_state = 146},
  [73] = {.lex_state = 146},
  [74] = {.lex_state = 178},
  [75] = {.lex_state = 178},
  [76] = {.lex_state = 201},
  [77] = {.lex_state = 178},
  [78] = {.lex_state = 146},
  [79] = {.lex_state = 146},
  [80] = {.lex_state = 146},
  [81] = {.lex_state = 201},
  [82] = {.lex_state = 201},
  [83] = {.lex_state = 132},
  [84] = {.lex_state = 146},
  [85] = {.lex_state = 146},
  [86] = {.lex_state = 146},
  [87] = {.lex_state = 141},
  [88] = {.lex_state = 146},
  [89] = {.lex_state = 149},
  [90] = {.lex_state = 146},
  [91] = {.lex_state = 158},
  [92] = {.lex_state = 146, .external_lex_state = 1},
  [93] = {.lex_state = 146},
  [94] = {.lex_state = 146},
  [95] = {.lex_state = 146, .external_lex_state = 1},
  [96] = {.lex_state = 161, .external_lex_state = 1},
  [97] = {.lex_state = 183, .external_lex_state = 1},
  [98] = {.lex_state = 183, .external_lex_state = 1},
  [99] = {.lex_state = 146},
  [100] = {.lex_state = 132},
  [101] = {.lex_state = 183, .external_lex_state = 1},
  [102] = {.lex_state = 184},
  [103] = {.lex_state = 132},
  [104] = {.lex_state = 183, .external_lex_state = 1},
  [105] = {.lex_state = 132},
  [106] = {.lex_state = 183, .external_lex_state = 1},
  [107] = {.lex_state = 132},
  [108] = {.lex_state = 132},
  [109] = {.lex_state = 146},
  [110] = {.lex_state = 183, .external_lex_state = 1},
  [111] = {.lex_state = 195},
  [112] = {.lex_state = 132},
  [113] = {.lex_state = 132},
  [114] = {.lex_state = 178},
  [115] = {.lex_state = 132},
  [116] = {.lex_state = 202},
  [117] = {.lex_state = 146, .external_lex_state = 1},
  [118] = {.lex_state = 146},
  [119] = {.lex_state = 162, .external_lex_state = 1},
  [120] = {.lex_state = 162, .external_lex_state = 1},
  [121] = {.lex_state = 178},
  [122] = {.lex_state = 178},
  [123] = {.lex_state = 162, .external_lex_state = 1},
  [124] = {.lex_state = 132},
  [125] = {.lex_state = 183, .external_lex_state = 1},
  [126] = {.lex_state = 183, .external_lex_state = 1},
  [127] = {.lex_state = 183, .external_lex_state = 1},
  [128] = {.lex_state = 183, .external_lex_state = 1},
  [129] = {.lex_state = 203},
  [130] = {.lex_state = 178},
  [131] = {.lex_state = 146},
  [132] = {.lex_state = 183, .external_lex_state = 1},
  [133] = {.lex_state = 146},
  [134] = {.lex_state = 132},
  [135] = {.lex_state = 203},
  [136] = {.lex_state = 204},
  [137] = {.lex_state = 203},
  [138] = {.lex_state = 203},
  [139] = {.lex_state = 203},
  [140] = {.lex_state = 203},
  [141] = {.lex_state = 146},
  [142] = {.lex_state = 204},
  [143] = {.lex_state = 206},
  [144] = {.lex_state = 132},
  [145] = {.lex_state = 132},
  [146] = {.lex_state = 202},
  [147] = {.lex_state = 132},
  [148] = {.lex_state = 175},
  [149] = {.lex_state = 132},
  [150] = {.lex_state = 132},
  [151] = {.lex_state = 183, .external_lex_state = 1},
  [152] = {.lex_state = 183, .external_lex_state = 1},
  [153] = {.lex_state = 132},
  [154] = {.lex_state = 173},
  [155] = {.lex_state = 207, .external_lex_state = 1},
  [156] = {.lex_state = 183, .external_lex_state = 1},
  [157] = {.lex_state = 183, .external_lex_state = 1},
  [158] = {.lex_state = 183, .external_lex_state = 1},
  [159] = {.lex_state = 183, .external_lex_state = 1},
  [160] = {.lex_state = 202},
  [161] = {.lex_state = 183, .external_lex_state = 1},
  [162] = {.lex_state = 146},
  [163] = {.lex_state = 132},
  [164] = {.lex_state = 208},
  [165] = {.lex_state = 208},
  [166] = {.lex_state = 173},
  [167] = {.lex_state = 146},
  [168] = {.lex_state = 175},
  [169] = {.lex_state = 175},
  [170] = {.lex_state = 162},
  [171] = {.lex_state = 146},
  [172] = {.lex_state = 175},
  [173] = {.lex_state = 209},
  [174] = {.lex_state = 146},
  [175] = {.lex_state = 175},
  [176] = {.lex_state = 184},
  [177] = {.lex_state = 132},
  [178] = {.lex_state = 175},
  [179] = {.lex_state = 175},
  [180] = {.lex_state = 132},
  [181] = {.lex_state = 175},
  [182] = {.lex_state = 175},
  [183] = {.lex_state = 184},
  [184] = {.lex_state = 132},
  [185] = {.lex_state = 175},
  [186] = {.lex_state = 175},
  [187] = {.lex_state = 183, .external_lex_state = 1},
  [188] = {.lex_state = 132},
  [189] = {.lex_state = 183, .external_lex_state = 1},
  [190] = {.lex_state = 183, .external_lex_state = 1},
  [191] = {.lex_state = 183, .external_lex_state = 1},
  [192] = {.lex_state = 183, .external_lex_state = 1},
  [193] = {.lex_state = 183, .external_lex_state = 1},
  [194] = {.lex_state = 183, .external_lex_state = 1},
  [195] = {.lex_state = 183, .external_lex_state = 1},
  [196] = {.lex_state = 183, .external_lex_state = 1},
  [197] = {.lex_state = 192},
  [198] = {.lex_state = 183, .external_lex_state = 1},
  [199] = {.lex_state = 146},
  [200] = {.lex_state = 132},
  [201] = {.lex_state = 184},
  [202] = {.lex_state = 184},
  [203] = {.lex_state = 184},
  [204] = {.lex_state = 183, .external_lex_state = 1},
  [205] = {.lex_state = 183, .external_lex_state = 1},
  [206] = {.lex_state = 146},
  [207] = {.lex_state = 146, .external_lex_state = 1},
  [208] = {.lex_state = 146},
  [209] = {.lex_state = 132},
  [210] = {.lex_state = 183, .external_lex_state = 1},
  [211] = {.lex_state = 184},
  [212] = {.lex_state = 132},
  [213] = {.lex_state = 183, .external_lex_state = 1},
  [214] = {.lex_state = 132},
  [215] = {.lex_state = 183, .external_lex_state = 1},
  [216] = {.lex_state = 132},
  [217] = {.lex_state = 132},
  [218] = {.lex_state = 146},
  [219] = {.lex_state = 178},
  [220] = {.lex_state = 132},
  [221] = {.lex_state = 146},
  [222] = {.lex_state = 178},
  [223] = {.lex_state = 132},
  [224] = {.lex_state = 183, .external_lex_state = 1},
  [225] = {.lex_state = 161, .external_lex_state = 1},
  [226] = {.lex_state = 183, .external_lex_state = 1},
  [227] = {.lex_state = 183, .external_lex_state = 1},
  [228] = {.lex_state = 183, .external_lex_state = 1},
  [229] = {.lex_state = 183, .external_lex_state = 1},
  [230] = {.lex_state = 183, .external_lex_state = 1},
  [231] = {.lex_state = 183, .external_lex_state = 1},
  [232] = {.lex_state = 183, .external_lex_state = 1},
  [233] = {.lex_state = 183, .external_lex_state = 1},
  [234] = {.lex_state = 146},
  [235] = {.lex_state = 132},
  [236] = {.lex_state = 178},
  [237] = {.lex_state = 132},
  [238] = {.lex_state = 178},
  [239] = {.lex_state = 161, .external_lex_state = 1},
  [240] = {.lex_state = 161, .external_lex_state = 1},
  [241] = {.lex_state = 132},
  [242] = {.lex_state = 132},
  [243] = {.lex_state = 132},
  [244] = {.lex_state = 146},
  [245] = {.lex_state = 197},
  [246] = {.lex_state = 132},
  [247] = {.lex_state = 132},
  [248] = {.lex_state = 184},
  [249] = {.lex_state = 175},
  [250] = {.lex_state = 202},
  [251] = {.lex_state = 206},
  [252] = {.lex_state = 202},
  [253] = {.lex_state = 202},
  [254] = {.lex_state = 183, .external_lex_state = 1},
  [255] = {.lex_state = 178},
  [256] = {.lex_state = 132},
  [257] = {.lex_state = 202},
  [258] = {.lex_state = 192},
  [259] = {.lex_state = 183, .external_lex_state = 1},
  [260] = {.lex_state = 210, .external_lex_state = 1},
  [261] = {.lex_state = 132},
  [262] = {.lex_state = 211},
  [263] = {.lex_state = 212},
  [264] = {.lex_state = 175},
  [265] = {.lex_state = 175},
  [266] = {.lex_state = 184},
  [267] = {.lex_state = 132},
  [268] = {.lex_state = 175},
  [269] = {.lex_state = 175},
  [270] = {.lex_state = 175},
  [271] = {.lex_state = 175},
  [272] = {.lex_state = 175},
  [273] = {.lex_state = 175},
  [274] = {.lex_state = 132},
  [275] = {.lex_state = 132},
  [276] = {.lex_state = 210},
  [277] = {.lex_state = 213},
  [278] = {.lex_state = 146},
  [279] = {.lex_state = 132},
  [280] = {.lex_state = 132},
  [281] = {.lex_state = 132},
  [282] = {.lex_state = 132},
  [283] = {.lex_state = 146},
  [284] = {.lex_state = 132},
  [285] = {.lex_state = 132},
  [286] = {.lex_state = 146},
  [287] = {.lex_state = 132},
  [288] = {.lex_state = 173, .external_lex_state = 1},
  [289] = {.lex_state = 178},
  [290] = {.lex_state = 161, .external_lex_state = 1},
  [291] = {.lex_state = 132},
  [292] = {.lex_state = 161, .external_lex_state = 1},
  [293] = {.lex_state = 178},
  [294] = {.lex_state = 146},
  [295] = {.lex_state = 132},
  [296] = {.lex_state = 132},
  [297] = {.lex_state = 132},
  [298] = {.lex_state = 146},
  [299] = {.lex_state = 214, .external_lex_state = 1},
  [300] = {.lex_state = 146},
  [301] = {.lex_state = 178},
  [302] = {.lex_state = 178},
  [303] = {.lex_state = 202},
  [304] = {.lex_state = 178},
  [305] = {.lex_state = 146},
  [306] = {.lex_state = 146},
  [307] = {.lex_state = 178},
  [308] = {.lex_state = 146},
  [309] = {.lex_state = 202},
  [310] = {.lex_state = 211},
  [311] = {.lex_state = 132},
  [312] = {.lex_state = 178},
  [313] = {.lex_state = 212},
  [314] = {.lex_state = 183, .external_lex_state = 1},
  [315] = {.lex_state = 211},
  [316] = {.lex_state = 161, .external_lex_state = 1},
  [317] = {.lex_state = 132},
  [318] = {.lex_state = 146},
  [319] = {.lex_state = 132},
  [320] = {.lex_state = 197},
  [321] = {.lex_state = 178},
  [322] = {.lex_state = 146},
  [323] = {.lex_state = 173},
  [324] = {.lex_state = 204},
  [325] = {.lex_state = 207, .external_lex_state = 1},
  [326] = {.lex_state = 184},
  [327] = {.lex_state = 146},
  [328] = {.lex_state = 146},
  [329] = {.lex_state = 161, .external_lex_state = 1},
  [330] = {.lex_state = 173},
  [331] = {.lex_state = 132},
  [332] = {.lex_state = 183, .external_lex_state = 1},
  [333] = {.lex_state = 161, .external_lex_state = 1},
  [334] = {.lex_state = 183, .external_lex_state = 1},
  [335] = {.lex_state = 183, .external_lex_state = 1},
  [336] = {.lex_state = 183, .external_lex_state = 1},
  [337] = {.lex_state = 183, .external_lex_state = 1},
  [338] = {.lex_state = 183, .external_lex_state = 1},
  [339] = {.lex_state = 183, .external_lex_state = 1},
  [340] = {.lex_state = 183, .external_lex_state = 1},
  [341] = {.lex_state = 183, .external_lex_state = 1},
  [342] = {.lex_state = 183, .external_lex_state = 1},
  [343] = {.lex_state = 183, .external_lex_state = 1},
  [344] = {.lex_state = 183, .external_lex_state = 1},
  [345] = {.lex_state = 183, .external_lex_state = 1},
  [346] = {.lex_state = 183, .external_lex_state = 1},
  [347] = {.lex_state = 211},
  [348] = {.lex_state = 146},
  [349] = {.lex_state = 211},
  [350] = {.lex_state = 178},
  [351] = {.lex_state = 132},
  [352] = {.lex_state = 211},
  [353] = {.lex_state = 204},
  [354] = {.lex_state = 201},
  [355] = {.lex_state = 207, .external_lex_state = 1},
  [356] = {.lex_state = 132},
  [357] = {.lex_state = 132},
  [358] = {.lex_state = 132},
  [359] = {.lex_state = 178},
  [360] = {.lex_state = 211},
  [361] = {.lex_state = 210, .external_lex_state = 1},
  [362] = {.lex_state = 175},
  [363] = {.lex_state = 132, .external_lex_state = 1},
  [364] = {.lex_state = 197},
  [365] = {.lex_state = 132},
  [366] = {.lex_state = 184},
  [367] = {.lex_state = 132},
  [368] = {.lex_state = 197},
  [369] = {.lex_state = 132},
  [370] = {.lex_state = 132},
  [371] = {.lex_state = 175},
  [372] = {.lex_state = 175},
  [373] = {.lex_state = 132},
  [374] = {.lex_state = 161, .external_lex_state = 1},
  [375] = {.lex_state = 192},
  [376] = {.lex_state = 161, .external_lex_state = 1},
  [377] = {.lex_state = 204},
  [378] = {.lex_state = 200},
  [379] = {.lex_state = 158},
  [380] = {.lex_state = 141},
  [381] = {.lex_state = 146},
  [382] = {.lex_state = 149},
  [383] = {.lex_state = 161, .external_lex_state = 1},
  [384] = {.lex_state = 146},
  [385] = {.lex_state = 215, .external_lex_state = 1},
  [386] = {.lex_state = 149},
  [387] = {.lex_state = 158},
  [388] = {.lex_state = 199, .external_lex_state = 1},
  [389] = {.lex_state = 146},
  [390] = {.lex_state = 132},
  [391] = {.lex_state = 146, .external_lex_state = 1},
  [392] = {.lex_state = 146},
  [393] = {.lex_state = 132},
  [394] = {.lex_state = 183, .external_lex_state = 1},
  [395] = {.lex_state = 184},
  [396] = {.lex_state = 132},
  [397] = {.lex_state = 183, .external_lex_state = 1},
  [398] = {.lex_state = 132},
  [399] = {.lex_state = 183, .external_lex_state = 1},
  [400] = {.lex_state = 132},
  [401] = {.lex_state = 132},
  [402] = {.lex_state = 146},
  [403] = {.lex_state = 195},
  [404] = {.lex_state = 175},
  [405] = {.lex_state = 146},
  [406] = {.lex_state = 146},
  [407] = {.lex_state = 132},
  [408] = {.lex_state = 218},
  [409] = {.lex_state = 132},
  [410] = {.lex_state = 184},
  [411] = {.lex_state = 178},
  [412] = {.lex_state = 132},
  [413] = {.lex_state = 199, .external_lex_state = 1},
  [414] = {.lex_state = 132},
  [415] = {.lex_state = 161, .external_lex_state = 1},
  [416] = {.lex_state = 218},
  [417] = {.lex_state = 199, .external_lex_state = 1},
  [418] = {.lex_state = 161, .external_lex_state = 1},
  [419] = {.lex_state = 146},
  [420] = {.lex_state = 225},
  [421] = {.lex_state = 225},
  [422] = {.lex_state = 162},
  [423] = {.lex_state = 201},
  [424] = {.lex_state = 225},
  [425] = {.lex_state = 184},
  [426] = {.lex_state = 132},
  [427] = {.lex_state = 201},
  [428] = {.lex_state = 209},
  [429] = {.lex_state = 201},
  [430] = {.lex_state = 225},
  [431] = {.lex_state = 184},
  [432] = {.lex_state = 132},
  [433] = {.lex_state = 201},
  [434] = {.lex_state = 209},
  [435] = {.lex_state = 210, .external_lex_state = 1},
  [436] = {.lex_state = 146},
  [437] = {.lex_state = 201},
  [438] = {.lex_state = 201},
  [439] = {.lex_state = 225},
  [440] = {.lex_state = 184},
  [441] = {.lex_state = 132},
  [442] = {.lex_state = 201},
  [443] = {.lex_state = 209},
  [444] = {.lex_state = 225},
  [445] = {.lex_state = 201},
  [446] = {.lex_state = 146},
  [447] = {.lex_state = 146},
  [448] = {.lex_state = 184},
  [449] = {.lex_state = 132},
  [450] = {.lex_state = 146},
  [451] = {.lex_state = 201},
  [452] = {.lex_state = 146},
  [453] = {.lex_state = 146},
  [454] = {.lex_state = 225},
  [455] = {.lex_state = 225},
  [456] = {.lex_state = 146},
  [457] = {.lex_state = 161, .external_lex_state = 1},
  [458] = {.lex_state = 132},
  [459] = {.lex_state = 192},
  [460] = {.lex_state = 146, .external_lex_state = 1},
  [461] = {.lex_state = 198},
  [462] = {.lex_state = 226, .external_lex_state = 1},
  [463] = {.lex_state = 226, .external_lex_state = 1},
  [464] = {.lex_state = 146, .external_lex_state = 1},
  [465] = {.lex_state = 200},
  [466] = {.lex_state = 146},
  [467] = {.lex_state = 146},
  [468] = {.lex_state = 146, .external_lex_state = 1},
  [469] = {.lex_state = 146, .external_lex_state = 1},
  [470] = {.lex_state = 183, .external_lex_state = 1},
  [471] = {.lex_state = 183, .external_lex_state = 1},
  [472] = {.lex_state = 183, .external_lex_state = 1},
  [473] = {.lex_state = 203},
  [474] = {.lex_state = 183, .external_lex_state = 1},
  [475] = {.lex_state = 132},
  [476] = {.lex_state = 183, .external_lex_state = 1},
  [477] = {.lex_state = 184},
  [478] = {.lex_state = 183, .external_lex_state = 1},
  [479] = {.lex_state = 183, .external_lex_state = 1},
  [480] = {.lex_state = 146},
  [481] = {.lex_state = 183, .external_lex_state = 1},
  [482] = {.lex_state = 146, .external_lex_state = 1},
  [483] = {.lex_state = 178},
  [484] = {.lex_state = 132},
  [485] = {.lex_state = 146, .external_lex_state = 1},
  [486] = {.lex_state = 146, .external_lex_state = 1},
  [487] = {.lex_state = 132},
  [488] = {.lex_state = 183, .external_lex_state = 1},
  [489] = {.lex_state = 146},
  [490] = {.lex_state = 146, .external_lex_state = 1},
  [491] = {.lex_state = 178},
  [492] = {.lex_state = 146},
  [493] = {.lex_state = 173},
  [494] = {.lex_state = 146, .external_lex_state = 1},
  [495] = {.lex_state = 161, .external_lex_state = 1},
  [496] = {.lex_state = 146, .external_lex_state = 1},
  [497] = {.lex_state = 146},
  [498] = {.lex_state = 203},
  [499] = {.lex_state = 132},
  [500] = {.lex_state = 203},
  [501] = {.lex_state = 132},
  [502] = {.lex_state = 201},
  [503] = {.lex_state = 201},
  [504] = {.lex_state = 209},
  [505] = {.lex_state = 201},
  [506] = {.lex_state = 201},
  [507] = {.lex_state = 209},
  [508] = {.lex_state = 203},
  [509] = {.lex_state = 132},
  [510] = {.lex_state = 183, .external_lex_state = 1},
  [511] = {.lex_state = 203},
  [512] = {.lex_state = 201},
  [513] = {.lex_state = 201},
  [514] = {.lex_state = 209},
  [515] = {.lex_state = 201},
  [516] = {.lex_state = 173, .external_lex_state = 1},
  [517] = {.lex_state = 203},
  [518] = {.lex_state = 146},
  [519] = {.lex_state = 203},
  [520] = {.lex_state = 146},
  [521] = {.lex_state = 203},
  [522] = {.lex_state = 183, .external_lex_state = 1},
  [523] = {.lex_state = 209},
  [524] = {.lex_state = 203},
  [525] = {.lex_state = 204},
  [526] = {.lex_state = 204},
  [527] = {.lex_state = 203},
  [528] = {.lex_state = 203},
  [529] = {.lex_state = 183, .external_lex_state = 1},
  [530] = {.lex_state = 211},
  [531] = {.lex_state = 183, .external_lex_state = 1},
  [532] = {.lex_state = 183, .external_lex_state = 1},
  [533] = {.lex_state = 183, .external_lex_state = 1},
  [534] = {.lex_state = 183, .external_lex_state = 1},
  [535] = {.lex_state = 183, .external_lex_state = 1},
  [536] = {.lex_state = 183, .external_lex_state = 1},
  [537] = {.lex_state = 183, .external_lex_state = 1},
  [538] = {.lex_state = 183, .external_lex_state = 1},
  [539] = {.lex_state = 183, .external_lex_state = 1},
  [540] = {.lex_state = 183, .external_lex_state = 1},
  [541] = {.lex_state = 183, .external_lex_state = 1},
  [542] = {.lex_state = 183, .external_lex_state = 1},
  [543] = {.lex_state = 183, .external_lex_state = 1},
  [544] = {.lex_state = 203},
  [545] = {.lex_state = 204},
  [546] = {.lex_state = 204},
  [547] = {.lex_state = 132},
  [548] = {.lex_state = 202},
  [549] = {.lex_state = 202},
  [550] = {.lex_state = 178},
  [551] = {.lex_state = 132},
  [552] = {.lex_state = 132},
  [553] = {.lex_state = 203},
  [554] = {.lex_state = 183, .external_lex_state = 1},
  [555] = {.lex_state = 208},
  [556] = {.lex_state = 173, .external_lex_state = 1},
  [557] = {.lex_state = 208},
  [558] = {.lex_state = 146},
  [559] = {.lex_state = 208},
  [560] = {.lex_state = 146},
  [561] = {.lex_state = 208},
  [562] = {.lex_state = 183, .external_lex_state = 1},
  [563] = {.lex_state = 183, .external_lex_state = 1},
  [564] = {.lex_state = 183, .external_lex_state = 1},
  [565] = {.lex_state = 132},
  [566] = {.lex_state = 183, .external_lex_state = 1},
  [567] = {.lex_state = 183, .external_lex_state = 1},
  [568] = {.lex_state = 183, .external_lex_state = 1},
  [569] = {.lex_state = 183, .external_lex_state = 1},
  [570] = {.lex_state = 183, .external_lex_state = 1},
  [571] = {.lex_state = 183, .external_lex_state = 1},
  [572] = {.lex_state = 183, .external_lex_state = 1},
  [573] = {.lex_state = 183, .external_lex_state = 1},
  [574] = {.lex_state = 183, .external_lex_state = 1},
  [575] = {.lex_state = 183, .external_lex_state = 1},
  [576] = {.lex_state = 183, .external_lex_state = 1},
  [577] = {.lex_state = 173},
  [578] = {.lex_state = 208},
  [579] = {.lex_state = 146},
  [580] = {.lex_state = 175},
  [581] = {.lex_state = 178},
  [582] = {.lex_state = 146},
  [583] = {.lex_state = 175},
  [584] = {.lex_state = 149},
  [585] = {.lex_state = 146},
  [586] = {.lex_state = 146},
  [587] = {.lex_state = 175},
  [588] = {.lex_state = 178},
  [589] = {.lex_state = 178},
  [590] = {.lex_state = 213},
  [591] = {.lex_state = 178},
  [592] = {.lex_state = 184},
  [593] = {.lex_state = 146},
  [594] = {.lex_state = 175},
  [595] = {.lex_state = 146},
  [596] = {.lex_state = 146},
  [597] = {.lex_state = 132},
  [598] = {.lex_state = 213},
  [599] = {.lex_state = 132},
  [600] = {.lex_state = 225},
  [601] = {.lex_state = 213},
  [602] = {.lex_state = 213},
  [603] = {.lex_state = 132},
  [604] = {.lex_state = 162},
  [605] = {.lex_state = 132},
  [606] = {.lex_state = 213},
  [607] = {.lex_state = 175},
  [608] = {.lex_state = 146},
  [609] = {.lex_state = 146},
  [610] = {.lex_state = 175},
  [611] = {.lex_state = 146},
  [612] = {.lex_state = 175},
  [613] = {.lex_state = 184},
  [614] = {.lex_state = 132},
  [615] = {.lex_state = 175},
  [616] = {.lex_state = 175},
  [617] = {.lex_state = 175},
  [618] = {.lex_state = 132},
  [619] = {.lex_state = 146},
  [620] = {.lex_state = 184},
  [621] = {.lex_state = 175},
  [622] = {.lex_state = 184},
  [623] = {.lex_state = 132},
  [624] = {.lex_state = 175},
  [625] = {.lex_state = 132},
  [626] = {.lex_state = 184},
  [627] = {.lex_state = 183, .external_lex_state = 1},
  [628] = {.lex_state = 183, .external_lex_state = 1},
  [629] = {.lex_state = 183, .external_lex_state = 1},
  [630] = {.lex_state = 183, .external_lex_state = 1},
  [631] = {.lex_state = 183, .external_lex_state = 1},
  [632] = {.lex_state = 183, .external_lex_state = 1},
  [633] = {.lex_state = 183, .external_lex_state = 1},
  [634] = {.lex_state = 146},
  [635] = {.lex_state = 132},
  [636] = {.lex_state = 203},
  [637] = {.lex_state = 203},
  [638] = {.lex_state = 183, .external_lex_state = 1},
  [639] = {.lex_state = 203},
  [640] = {.lex_state = 203},
  [641] = {.lex_state = 178},
  [642] = {.lex_state = 161, .external_lex_state = 1},
  [643] = {.lex_state = 203},
  [644] = {.lex_state = 184},
  [645] = {.lex_state = 184},
  [646] = {.lex_state = 184},
  [647] = {.lex_state = 184},
  [648] = {.lex_state = 183, .external_lex_state = 1},
  [649] = {.lex_state = 184},
  [650] = {.lex_state = 184},
  [651] = {.lex_state = 192},
  [652] = {.lex_state = 173, .external_lex_state = 1},
  [653] = {.lex_state = 184},
  [654] = {.lex_state = 178},
  [655] = {.lex_state = 178},
  [656] = {.lex_state = 178},
  [657] = {.lex_state = 146},
  [658] = {.lex_state = 184},
  [659] = {.lex_state = 146},
  [660] = {.lex_state = 184},
  [661] = {.lex_state = 183, .external_lex_state = 1},
  [662] = {.lex_state = 214, .external_lex_state = 1},
  [663] = {.lex_state = 183, .external_lex_state = 1},
  [664] = {.lex_state = 183, .external_lex_state = 1},
  [665] = {.lex_state = 183, .external_lex_state = 1},
  [666] = {.lex_state = 183, .external_lex_state = 1},
  [667] = {.lex_state = 183, .external_lex_state = 1},
  [668] = {.lex_state = 183, .external_lex_state = 1},
  [669] = {.lex_state = 183, .external_lex_state = 1},
  [670] = {.lex_state = 183, .external_lex_state = 1},
  [671] = {.lex_state = 183, .external_lex_state = 1},
  [672] = {.lex_state = 183, .external_lex_state = 1},
  [673] = {.lex_state = 183, .external_lex_state = 1},
  [674] = {.lex_state = 183, .external_lex_state = 1},
  [675] = {.lex_state = 183, .external_lex_state = 1},
  [676] = {.lex_state = 146},
  [677] = {.lex_state = 184},
  [678] = {.lex_state = 210, .external_lex_state = 1},
  [679] = {.lex_state = 195},
  [680] = {.lex_state = 132},
  [681] = {.lex_state = 161, .external_lex_state = 1},
  [682] = {.lex_state = 132},
  [683] = {.lex_state = 132},
  [684] = {.lex_state = 132},
  [685] = {.lex_state = 161, .external_lex_state = 1},
  [686] = {.lex_state = 211},
  [687] = {.lex_state = 146, .external_lex_state = 1},
  [688] = {.lex_state = 183, .external_lex_state = 1},
  [689] = {.lex_state = 132},
  [690] = {.lex_state = 183, .external_lex_state = 1},
  [691] = {.lex_state = 184},
  [692] = {.lex_state = 183, .external_lex_state = 1},
  [693] = {.lex_state = 183, .external_lex_state = 1},
  [694] = {.lex_state = 146},
  [695] = {.lex_state = 183, .external_lex_state = 1},
  [696] = {.lex_state = 146},
  [697] = {.lex_state = 178},
  [698] = {.lex_state = 132},
  [699] = {.lex_state = 146},
  [700] = {.lex_state = 146},
  [701] = {.lex_state = 132},
  [702] = {.lex_state = 183, .external_lex_state = 1},
  [703] = {.lex_state = 146},
  [704] = {.lex_state = 132},
  [705] = {.lex_state = 146},
  [706] = {.lex_state = 183, .external_lex_state = 1},
  [707] = {.lex_state = 195},
  [708] = {.lex_state = 132},
  [709] = {.lex_state = 132},
  [710] = {.lex_state = 178},
  [711] = {.lex_state = 184},
  [712] = {.lex_state = 146},
  [713] = {.lex_state = 211},
  [714] = {.lex_state = 183, .external_lex_state = 1},
  [715] = {.lex_state = 183, .external_lex_state = 1},
  [716] = {.lex_state = 173, .external_lex_state = 1},
  [717] = {.lex_state = 183, .external_lex_state = 1},
  [718] = {.lex_state = 183, .external_lex_state = 1},
  [719] = {.lex_state = 183, .external_lex_state = 1},
  [720] = {.lex_state = 183, .external_lex_state = 1},
  [721] = {.lex_state = 146},
  [722] = {.lex_state = 183, .external_lex_state = 1},
  [723] = {.lex_state = 146},
  [724] = {.lex_state = 132},
  [725] = {.lex_state = 178},
  [726] = {.lex_state = 146},
  [727] = {.lex_state = 178},
  [728] = {.lex_state = 173},
  [729] = {.lex_state = 203},
  [730] = {.lex_state = 183, .external_lex_state = 1},
  [731] = {.lex_state = 178},
  [732] = {.lex_state = 173, .external_lex_state = 1},
  [733] = {.lex_state = 178},
  [734] = {.lex_state = 146},
  [735] = {.lex_state = 178},
  [736] = {.lex_state = 146},
  [737] = {.lex_state = 178},
  [738] = {.lex_state = 183, .external_lex_state = 1},
  [739] = {.lex_state = 161, .external_lex_state = 1},
  [740] = {.lex_state = 183, .external_lex_state = 1},
  [741] = {.lex_state = 183, .external_lex_state = 1},
  [742] = {.lex_state = 183, .external_lex_state = 1},
  [743] = {.lex_state = 183, .external_lex_state = 1},
  [744] = {.lex_state = 183, .external_lex_state = 1},
  [745] = {.lex_state = 183, .external_lex_state = 1},
  [746] = {.lex_state = 183, .external_lex_state = 1},
  [747] = {.lex_state = 183, .external_lex_state = 1},
  [748] = {.lex_state = 183, .external_lex_state = 1},
  [749] = {.lex_state = 183, .external_lex_state = 1},
  [750] = {.lex_state = 183, .external_lex_state = 1},
  [751] = {.lex_state = 183, .external_lex_state = 1},
  [752] = {.lex_state = 178},
  [753] = {.lex_state = 161, .external_lex_state = 1},
  [754] = {.lex_state = 211},
  [755] = {.lex_state = 132},
  [756] = {.lex_state = 175},
  [757] = {.lex_state = 132},
  [758] = {.lex_state = 203},
  [759] = {.lex_state = 211},
  [760] = {.lex_state = 202},
  [761] = {.lex_state = 192},
  [762] = {.lex_state = 161, .external_lex_state = 1},
  [763] = {.lex_state = 183, .external_lex_state = 1},
  [764] = {.lex_state = 183, .external_lex_state = 1},
  [765] = {.lex_state = 183, .external_lex_state = 1},
  [766] = {.lex_state = 183, .external_lex_state = 1},
  [767] = {.lex_state = 183, .external_lex_state = 1},
  [768] = {.lex_state = 183, .external_lex_state = 1},
  [769] = {.lex_state = 187},
  [770] = {.lex_state = 192},
  [771] = {.lex_state = 227},
  [772] = {.lex_state = 146},
  [773] = {.lex_state = 228},
  [774] = {.lex_state = 183, .external_lex_state = 1},
  [775] = {.lex_state = 146},
  [776] = {.lex_state = 132},
  [777] = {.lex_state = 229},
  [778] = {.lex_state = 227},
  [779] = {.lex_state = 210},
  [780] = {.lex_state = 227},
  [781] = {.lex_state = 229},
  [782] = {.lex_state = 132},
  [783] = {.lex_state = 227},
  [784] = {.lex_state = 229},
  [785] = {.lex_state = 132},
  [786] = {.lex_state = 146},
  [787] = {.lex_state = 229},
  [788] = {.lex_state = 212},
  [789] = {.lex_state = 211},
  [790] = {.lex_state = 175},
  [791] = {.lex_state = 184},
  [792] = {.lex_state = 132},
  [793] = {.lex_state = 175},
  [794] = {.lex_state = 132},
  [795] = {.lex_state = 184},
  [796] = {.lex_state = 132},
  [797] = {.lex_state = 132},
  [798] = {.lex_state = 132},
  [799] = {.lex_state = 178},
  [800] = {.lex_state = 146},
  [801] = {.lex_state = 146},
  [802] = {.lex_state = 230},
  [803] = {.lex_state = 230},
  [804] = {.lex_state = 210},
  [805] = {.lex_state = 146},
  [806] = {.lex_state = 230},
  [807] = {.lex_state = 132},
  [808] = {.lex_state = 132},
  [809] = {.lex_state = 213},
  [810] = {.lex_state = 132},
  [811] = {.lex_state = 161, .external_lex_state = 1},
  [812] = {.lex_state = 178},
  [813] = {.lex_state = 132},
  [814] = {.lex_state = 146},
  [815] = {.lex_state = 161, .external_lex_state = 1},
  [816] = {.lex_state = 132},
  [817] = {.lex_state = 132},
  [818] = {.lex_state = 146},
  [819] = {.lex_state = 132},
  [820] = {.lex_state = 132},
  [821] = {.lex_state = 132},
  [822] = {.lex_state = 132},
  [823] = {.lex_state = 218, .external_lex_state = 1},
  [824] = {.lex_state = 161, .external_lex_state = 1},
  [825] = {.lex_state = 146},
  [826] = {.lex_state = 132},
  [827] = {.lex_state = 183, .external_lex_state = 1},
  [828] = {.lex_state = 184},
  [829] = {.lex_state = 132},
  [830] = {.lex_state = 132},
  [831] = {.lex_state = 195},
  [832] = {.lex_state = 132},
  [833] = {.lex_state = 161, .external_lex_state = 1},
  [834] = {.lex_state = 161, .external_lex_state = 1},
  [835] = {.lex_state = 161, .external_lex_state = 1},
  [836] = {.lex_state = 146},
  [837] = {.lex_state = 132},
  [838] = {.lex_state = 178},
  [839] = {.lex_state = 132},
  [840] = {.lex_state = 178},
  [841] = {.lex_state = 132},
  [842] = {.lex_state = 132},
  [843] = {.lex_state = 132, .external_lex_state = 1},
  [844] = {.lex_state = 202},
  [845] = {.lex_state = 203},
  [846] = {.lex_state = 203},
  [847] = {.lex_state = 146},
  [848] = {.lex_state = 211},
  [849] = {.lex_state = 211},
  [850] = {.lex_state = 162},
  [851] = {.lex_state = 202},
  [852] = {.lex_state = 211},
  [853] = {.lex_state = 184},
  [854] = {.lex_state = 132},
  [855] = {.lex_state = 202},
  [856] = {.lex_state = 211},
  [857] = {.lex_state = 202},
  [858] = {.lex_state = 211},
  [859] = {.lex_state = 184},
  [860] = {.lex_state = 132},
  [861] = {.lex_state = 202},
  [862] = {.lex_state = 211},
  [863] = {.lex_state = 146},
  [864] = {.lex_state = 202},
  [865] = {.lex_state = 202},
  [866] = {.lex_state = 211},
  [867] = {.lex_state = 184},
  [868] = {.lex_state = 132},
  [869] = {.lex_state = 202},
  [870] = {.lex_state = 211},
  [871] = {.lex_state = 211},
  [872] = {.lex_state = 202},
  [873] = {.lex_state = 183, .external_lex_state = 1},
  [874] = {.lex_state = 211},
  [875] = {.lex_state = 202},
  [876] = {.lex_state = 178},
  [877] = {.lex_state = 146},
  [878] = {.lex_state = 202},
  [879] = {.lex_state = 211},
  [880] = {.lex_state = 211},
  [881] = {.lex_state = 178},
  [882] = {.lex_state = 173, .external_lex_state = 1},
  [883] = {.lex_state = 178},
  [884] = {.lex_state = 132},
  [885] = {.lex_state = 178},
  [886] = {.lex_state = 132},
  [887] = {.lex_state = 173},
  [888] = {.lex_state = 178},
  [889] = {.lex_state = 173},
  [890] = {.lex_state = 175},
  [891] = {.lex_state = 132},
  [892] = {.lex_state = 161, .external_lex_state = 1},
  [893] = {.lex_state = 146, .external_lex_state = 1},
  [894] = {.lex_state = 231, .external_lex_state = 1},
  [895] = {.lex_state = 183, .external_lex_state = 1},
  [896] = {.lex_state = 161, .external_lex_state = 1},
  [897] = {.lex_state = 178},
  [898] = {.lex_state = 175},
  [899] = {.lex_state = 146},
  [900] = {.lex_state = 183, .external_lex_state = 1},
  [901] = {.lex_state = 132},
  [902] = {.lex_state = 203},
  [903] = {.lex_state = 209},
  [904] = {.lex_state = 146},
  [905] = {.lex_state = 232},
  [906] = {.lex_state = 232},
  [907] = {.lex_state = 146},
  [908] = {.lex_state = 232},
  [909] = {.lex_state = 183, .external_lex_state = 1},
  [910] = {.lex_state = 207, .external_lex_state = 1},
  [911] = {.lex_state = 209},
  [912] = {.lex_state = 207, .external_lex_state = 1},
  [913] = {.lex_state = 183, .external_lex_state = 1},
  [914] = {.lex_state = 183, .external_lex_state = 1},
  [915] = {.lex_state = 183, .external_lex_state = 1},
  [916] = {.lex_state = 183, .external_lex_state = 1},
  [917] = {.lex_state = 183, .external_lex_state = 1},
  [918] = {.lex_state = 183, .external_lex_state = 1},
  [919] = {.lex_state = 146},
  [920] = {.lex_state = 132},
  [921] = {.lex_state = 208},
  [922] = {.lex_state = 208},
  [923] = {.lex_state = 207, .external_lex_state = 1},
  [924] = {.lex_state = 225},
  [925] = {.lex_state = 146},
  [926] = {.lex_state = 184},
  [927] = {.lex_state = 132},
  [928] = {.lex_state = 132},
  [929] = {.lex_state = 175},
  [930] = {.lex_state = 132},
  [931] = {.lex_state = 173},
  [932] = {.lex_state = 132},
  [933] = {.lex_state = 132},
  [934] = {.lex_state = 161, .external_lex_state = 1},
  [935] = {.lex_state = 132},
  [936] = {.lex_state = 178},
  [937] = {.lex_state = 184},
  [938] = {.lex_state = 202},
  [939] = {.lex_state = 208},
  [940] = {.lex_state = 178},
  [941] = {.lex_state = 184},
  [942] = {.lex_state = 178},
  [943] = {.lex_state = 178},
  [944] = {.lex_state = 178},
  [945] = {.lex_state = 178},
  [946] = {.lex_state = 178},
  [947] = {.lex_state = 178},
  [948] = {.lex_state = 178},
  [949] = {.lex_state = 178},
  [950] = {.lex_state = 178},
  [951] = {.lex_state = 202},
  [952] = {.lex_state = 132},
  [953] = {.lex_state = 132},
  [954] = {.lex_state = 211},
  [955] = {.lex_state = 175},
  [956] = {.lex_state = 178},
  [957] = {.lex_state = 212},
  [958] = {.lex_state = 211},
  [959] = {.lex_state = 203},
  [960] = {.lex_state = 132},
  [961] = {.lex_state = 178},
  [962] = {.lex_state = 201},
  [963] = {.lex_state = 207, .external_lex_state = 1},
  [964] = {.lex_state = 209},
  [965] = {.lex_state = 208},
  [966] = {.lex_state = 207, .external_lex_state = 1},
  [967] = {.lex_state = 207, .external_lex_state = 1},
  [968] = {.lex_state = 178},
  [969] = {.lex_state = 211},
  [970] = {.lex_state = 146},
  [971] = {.lex_state = 209},
  [972] = {.lex_state = 178},
  [973] = {.lex_state = 175},
  [974] = {.lex_state = 227},
  [975] = {.lex_state = 210},
  [976] = {.lex_state = 132},
  [977] = {.lex_state = 197},
  [978] = {.lex_state = 197},
  [979] = {.lex_state = 173},
  [980] = {.lex_state = 132},
  [981] = {.lex_state = 132},
  [982] = {.lex_state = 161, .external_lex_state = 1},
  [983] = {.lex_state = 203},
  [984] = {.lex_state = 158},
  [985] = {.lex_state = 161, .external_lex_state = 1},
  [986] = {.lex_state = 161, .external_lex_state = 1},
  [987] = {.lex_state = 200},
  [988] = {.lex_state = 192},
  [989] = {.lex_state = 199, .external_lex_state = 1},
  [990] = {.lex_state = 198},
  [991] = {.lex_state = 199, .external_lex_state = 1},
  [992] = {.lex_state = 199, .external_lex_state = 1},
  [993] = {.lex_state = 141},
  [994] = {.lex_state = 146},
  [995] = {.lex_state = 149},
  [996] = {.lex_state = 146},
  [997] = {.lex_state = 158},
  [998] = {.lex_state = 215, .external_lex_state = 1},
  [999] = {.lex_state = 146},
  [1000] = {.lex_state = 132},
  [1001] = {.lex_state = 146, .external_lex_state = 1},
  [1002] = {.lex_state = 146},
  [1003] = {.lex_state = 132},
  [1004] = {.lex_state = 183, .external_lex_state = 1},
  [1005] = {.lex_state = 184},
  [1006] = {.lex_state = 132},
  [1007] = {.lex_state = 183, .external_lex_state = 1},
  [1008] = {.lex_state = 132},
  [1009] = {.lex_state = 183, .external_lex_state = 1},
  [1010] = {.lex_state = 132},
  [1011] = {.lex_state = 132},
  [1012] = {.lex_state = 146},
  [1013] = {.lex_state = 195},
  [1014] = {.lex_state = 175},
  [1015] = {.lex_state = 146},
  [1016] = {.lex_state = 146},
  [1017] = {.lex_state = 132},
  [1018] = {.lex_state = 132},
  [1019] = {.lex_state = 184},
  [1020] = {.lex_state = 178},
  [1021] = {.lex_state = 132},
  [1022] = {.lex_state = 215, .external_lex_state = 1},
  [1023] = {.lex_state = 132},
  [1024] = {.lex_state = 199, .external_lex_state = 1},
  [1025] = {.lex_state = 199, .external_lex_state = 1},
  [1026] = {.lex_state = 200},
  [1027] = {.lex_state = 146},
  [1028] = {.lex_state = 146},
  [1029] = {.lex_state = 146},
  [1030] = {.lex_state = 199, .external_lex_state = 1},
  [1031] = {.lex_state = 146, .external_lex_state = 1},
  [1032] = {.lex_state = 183, .external_lex_state = 1},
  [1033] = {.lex_state = 132},
  [1034] = {.lex_state = 183, .external_lex_state = 1},
  [1035] = {.lex_state = 184},
  [1036] = {.lex_state = 183, .external_lex_state = 1},
  [1037] = {.lex_state = 183, .external_lex_state = 1},
  [1038] = {.lex_state = 146},
  [1039] = {.lex_state = 183, .external_lex_state = 1},
  [1040] = {.lex_state = 199, .external_lex_state = 1},
  [1041] = {.lex_state = 178},
  [1042] = {.lex_state = 132},
  [1043] = {.lex_state = 199, .external_lex_state = 1},
  [1044] = {.lex_state = 199, .external_lex_state = 1},
  [1045] = {.lex_state = 132},
  [1046] = {.lex_state = 183, .external_lex_state = 1},
  [1047] = {.lex_state = 132},
  [1048] = {.lex_state = 132},
  [1049] = {.lex_state = 146},
  [1050] = {.lex_state = 161, .external_lex_state = 1},
  [1051] = {.lex_state = 132},
  [1052] = {.lex_state = 199, .external_lex_state = 1},
  [1053] = {.lex_state = 178},
  [1054] = {.lex_state = 146},
  [1055] = {.lex_state = 132},
  [1056] = {.lex_state = 146},
  [1057] = {.lex_state = 161, .external_lex_state = 1},
  [1058] = {.lex_state = 199, .external_lex_state = 1},
  [1059] = {.lex_state = 178},
  [1060] = {.lex_state = 146},
  [1061] = {.lex_state = 173},
  [1062] = {.lex_state = 146},
  [1063] = {.lex_state = 199, .external_lex_state = 1},
  [1064] = {.lex_state = 173},
  [1065] = {.lex_state = 199, .external_lex_state = 1},
  [1066] = {.lex_state = 218},
  [1067] = {.lex_state = 199, .external_lex_state = 1},
  [1068] = {.lex_state = 184},
  [1069] = {.lex_state = 161, .external_lex_state = 1},
  [1070] = {.lex_state = 218},
  [1071] = {.lex_state = 146},
  [1072] = {.lex_state = 225},
  [1073] = {.lex_state = 146},
  [1074] = {.lex_state = 225},
  [1075] = {.lex_state = 225},
  [1076] = {.lex_state = 162},
  [1077] = {.lex_state = 225},
  [1078] = {.lex_state = 184},
  [1079] = {.lex_state = 132},
  [1080] = {.lex_state = 225},
  [1081] = {.lex_state = 132},
  [1082] = {.lex_state = 184},
  [1083] = {.lex_state = 225},
  [1084] = {.lex_state = 184},
  [1085] = {.lex_state = 132},
  [1086] = {.lex_state = 225},
  [1087] = {.lex_state = 132},
  [1088] = {.lex_state = 184},
  [1089] = {.lex_state = 201},
  [1090] = {.lex_state = 227},
  [1091] = {.lex_state = 210},
  [1092] = {.lex_state = 201},
  [1093] = {.lex_state = 225},
  [1094] = {.lex_state = 184},
  [1095] = {.lex_state = 132},
  [1096] = {.lex_state = 225},
  [1097] = {.lex_state = 132},
  [1098] = {.lex_state = 184},
  [1099] = {.lex_state = 146},
  [1100] = {.lex_state = 203},
  [1101] = {.lex_state = 184},
  [1102] = {.lex_state = 146},
  [1103] = {.lex_state = 161, .external_lex_state = 1},
  [1104] = {.lex_state = 207, .external_lex_state = 1},
  [1105] = {.lex_state = 184},
  [1106] = {.lex_state = 201},
  [1107] = {.lex_state = 132},
  [1108] = {.lex_state = 146, .external_lex_state = 1},
  [1109] = {.lex_state = 192},
  [1110] = {.lex_state = 146, .external_lex_state = 1},
  [1111] = {.lex_state = 200},
  [1112] = {.lex_state = 158},
  [1113] = {.lex_state = 141},
  [1114] = {.lex_state = 146},
  [1115] = {.lex_state = 149},
  [1116] = {.lex_state = 146, .external_lex_state = 1},
  [1117] = {.lex_state = 146},
  [1118] = {.lex_state = 233, .external_lex_state = 1},
  [1119] = {.lex_state = 149},
  [1120] = {.lex_state = 158},
  [1121] = {.lex_state = 226, .external_lex_state = 1},
  [1122] = {.lex_state = 146},
  [1123] = {.lex_state = 146, .external_lex_state = 1},
  [1124] = {.lex_state = 146},
  [1125] = {.lex_state = 132},
  [1126] = {.lex_state = 183, .external_lex_state = 1},
  [1127] = {.lex_state = 184},
  [1128] = {.lex_state = 132},
  [1129] = {.lex_state = 183, .external_lex_state = 1},
  [1130] = {.lex_state = 132},
  [1131] = {.lex_state = 183, .external_lex_state = 1},
  [1132] = {.lex_state = 132},
  [1133] = {.lex_state = 132},
  [1134] = {.lex_state = 146},
  [1135] = {.lex_state = 195},
  [1136] = {.lex_state = 132},
  [1137] = {.lex_state = 218},
  [1138] = {.lex_state = 132},
  [1139] = {.lex_state = 178},
  [1140] = {.lex_state = 132},
  [1141] = {.lex_state = 226, .external_lex_state = 1},
  [1142] = {.lex_state = 146, .external_lex_state = 1},
  [1143] = {.lex_state = 218},
  [1144] = {.lex_state = 226, .external_lex_state = 1},
  [1145] = {.lex_state = 146, .external_lex_state = 1},
  [1146] = {.lex_state = 132},
  [1147] = {.lex_state = 146},
  [1148] = {.lex_state = 146, .external_lex_state = 1},
  [1149] = {.lex_state = 203},
  [1150] = {.lex_state = 183, .external_lex_state = 1},
  [1151] = {.lex_state = 178},
  [1152] = {.lex_state = 146, .external_lex_state = 1},
  [1153] = {.lex_state = 183, .external_lex_state = 1},
  [1154] = {.lex_state = 195},
  [1155] = {.lex_state = 146, .external_lex_state = 1},
  [1156] = {.lex_state = 132},
  [1157] = {.lex_state = 146, .external_lex_state = 1},
  [1158] = {.lex_state = 132},
  [1159] = {.lex_state = 183, .external_lex_state = 1},
  [1160] = {.lex_state = 178},
  [1161] = {.lex_state = 184},
  [1162] = {.lex_state = 146, .external_lex_state = 1},
  [1163] = {.lex_state = 146, .external_lex_state = 1},
  [1164] = {.lex_state = 146, .external_lex_state = 1},
  [1165] = {.lex_state = 132},
  [1166] = {.lex_state = 146, .external_lex_state = 1},
  [1167] = {.lex_state = 146, .external_lex_state = 1},
  [1168] = {.lex_state = 146},
  [1169] = {.lex_state = 183, .external_lex_state = 1},
  [1170] = {.lex_state = 132},
  [1171] = {.lex_state = 183, .external_lex_state = 1},
  [1172] = {.lex_state = 203},
  [1173] = {.lex_state = 203},
  [1174] = {.lex_state = 218, .external_lex_state = 1},
  [1175] = {.lex_state = 183, .external_lex_state = 1},
  [1176] = {.lex_state = 203},
  [1177] = {.lex_state = 203},
  [1178] = {.lex_state = 173, .external_lex_state = 1},
  [1179] = {.lex_state = 203},
  [1180] = {.lex_state = 146},
  [1181] = {.lex_state = 203},
  [1182] = {.lex_state = 203},
  [1183] = {.lex_state = 204},
  [1184] = {.lex_state = 203},
  [1185] = {.lex_state = 203},
  [1186] = {.lex_state = 146},
  [1187] = {.lex_state = 203},
  [1188] = {.lex_state = 203},
  [1189] = {.lex_state = 203},
  [1190] = {.lex_state = 184},
  [1191] = {.lex_state = 203},
  [1192] = {.lex_state = 203},
  [1193] = {.lex_state = 203},
  [1194] = {.lex_state = 203},
  [1195] = {.lex_state = 203},
  [1196] = {.lex_state = 203},
  [1197] = {.lex_state = 203},
  [1198] = {.lex_state = 203},
  [1199] = {.lex_state = 203},
  [1200] = {.lex_state = 202},
  [1201] = {.lex_state = 211},
  [1202] = {.lex_state = 203},
  [1203] = {.lex_state = 203},
  [1204] = {.lex_state = 202},
  [1205] = {.lex_state = 146},
  [1206] = {.lex_state = 178},
  [1207] = {.lex_state = 202},
  [1208] = {.lex_state = 183, .external_lex_state = 1},
  [1209] = {.lex_state = 203},
  [1210] = {.lex_state = 218, .external_lex_state = 1},
  [1211] = {.lex_state = 183, .external_lex_state = 1},
  [1212] = {.lex_state = 208},
  [1213] = {.lex_state = 208},
  [1214] = {.lex_state = 173, .external_lex_state = 1},
  [1215] = {.lex_state = 208},
  [1216] = {.lex_state = 208},
  [1217] = {.lex_state = 208},
  [1218] = {.lex_state = 184},
  [1219] = {.lex_state = 208},
  [1220] = {.lex_state = 208},
  [1221] = {.lex_state = 208},
  [1222] = {.lex_state = 208},
  [1223] = {.lex_state = 208},
  [1224] = {.lex_state = 208},
  [1225] = {.lex_state = 208},
  [1226] = {.lex_state = 208},
  [1227] = {.lex_state = 208},
  [1228] = {.lex_state = 132},
  [1229] = {.lex_state = 173},
  [1230] = {.lex_state = 208},
  [1231] = {.lex_state = 175},
  [1232] = {.lex_state = 183, .external_lex_state = 1},
  [1233] = {.lex_state = 146},
  [1234] = {.lex_state = 146},
  [1235] = {.lex_state = 234},
  [1236] = {.lex_state = 234},
  [1237] = {.lex_state = 146},
  [1238] = {.lex_state = 146},
  [1239] = {.lex_state = 213},
  [1240] = {.lex_state = 213},
  [1241] = {.lex_state = 213},
  [1242] = {.lex_state = 213},
  [1243] = {.lex_state = 213},
  [1244] = {.lex_state = 213},
  [1245] = {.lex_state = 132},
  [1246] = {.lex_state = 213},
  [1247] = {.lex_state = 213},
  [1248] = {.lex_state = 213},
  [1249] = {.lex_state = 213},
  [1250] = {.lex_state = 242},
  [1251] = {.lex_state = 146},
  [1252] = {.lex_state = 242},
  [1253] = {.lex_state = 132},
  [1254] = {.lex_state = 132},
  [1255] = {.lex_state = 178},
  [1256] = {.lex_state = 146},
  [1257] = {.lex_state = 132},
  [1258] = {.lex_state = 213},
  [1259] = {.lex_state = 242},
  [1260] = {.lex_state = 132},
  [1261] = {.lex_state = 132},
  [1262] = {.lex_state = 183, .external_lex_state = 1},
  [1263] = {.lex_state = 132},
  [1264] = {.lex_state = 197},
  [1265] = {.lex_state = 225},
  [1266] = {.lex_state = 175},
  [1267] = {.lex_state = 225},
  [1268] = {.lex_state = 242},
  [1269] = {.lex_state = 146, .external_lex_state = 1},
  [1270] = {.lex_state = 146},
  [1271] = {.lex_state = 242},
  [1272] = {.lex_state = 173},
  [1273] = {.lex_state = 213},
  [1274] = {.lex_state = 132},
  [1275] = {.lex_state = 175},
  [1276] = {.lex_state = 162},
  [1277] = {.lex_state = 184},
  [1278] = {.lex_state = 213},
  [1279] = {.lex_state = 213},
  [1280] = {.lex_state = 146},
  [1281] = {.lex_state = 146},
  [1282] = {.lex_state = 175},
  [1283] = {.lex_state = 146},
  [1284] = {.lex_state = 175},
  [1285] = {.lex_state = 146},
  [1286] = {.lex_state = 175},
  [1287] = {.lex_state = 175},
  [1288] = {.lex_state = 132},
  [1289] = {.lex_state = 175},
  [1290] = {.lex_state = 175},
  [1291] = {.lex_state = 132},
  [1292] = {.lex_state = 175},
  [1293] = {.lex_state = 132},
  [1294] = {.lex_state = 175},
  [1295] = {.lex_state = 132},
  [1296] = {.lex_state = 203},
  [1297] = {.lex_state = 183, .external_lex_state = 1},
  [1298] = {.lex_state = 203},
  [1299] = {.lex_state = 173, .external_lex_state = 1},
  [1300] = {.lex_state = 203},
  [1301] = {.lex_state = 146},
  [1302] = {.lex_state = 203},
  [1303] = {.lex_state = 146},
  [1304] = {.lex_state = 203},
  [1305] = {.lex_state = 183, .external_lex_state = 1},
  [1306] = {.lex_state = 183, .external_lex_state = 1},
  [1307] = {.lex_state = 183, .external_lex_state = 1},
  [1308] = {.lex_state = 183, .external_lex_state = 1},
  [1309] = {.lex_state = 183, .external_lex_state = 1},
  [1310] = {.lex_state = 183, .external_lex_state = 1},
  [1311] = {.lex_state = 183, .external_lex_state = 1},
  [1312] = {.lex_state = 183, .external_lex_state = 1},
  [1313] = {.lex_state = 183, .external_lex_state = 1},
  [1314] = {.lex_state = 183, .external_lex_state = 1},
  [1315] = {.lex_state = 183, .external_lex_state = 1},
  [1316] = {.lex_state = 183, .external_lex_state = 1},
  [1317] = {.lex_state = 183, .external_lex_state = 1},
  [1318] = {.lex_state = 183, .external_lex_state = 1},
  [1319] = {.lex_state = 203},
  [1320] = {.lex_state = 203},
  [1321] = {.lex_state = 146, .external_lex_state = 1},
  [1322] = {.lex_state = 183, .external_lex_state = 1},
  [1323] = {.lex_state = 203},
  [1324] = {.lex_state = 184},
  [1325] = {.lex_state = 218, .external_lex_state = 1},
  [1326] = {.lex_state = 178},
  [1327] = {.lex_state = 178},
  [1328] = {.lex_state = 184},
  [1329] = {.lex_state = 178},
  [1330] = {.lex_state = 178},
  [1331] = {.lex_state = 184},
  [1332] = {.lex_state = 178},
  [1333] = {.lex_state = 178},
  [1334] = {.lex_state = 184},
  [1335] = {.lex_state = 183, .external_lex_state = 1},
  [1336] = {.lex_state = 184},
  [1337] = {.lex_state = 184},
  [1338] = {.lex_state = 184},
  [1339] = {.lex_state = 173, .external_lex_state = 1},
  [1340] = {.lex_state = 184},
  [1341] = {.lex_state = 184},
  [1342] = {.lex_state = 203},
  [1343] = {.lex_state = 203},
  [1344] = {.lex_state = 184},
  [1345] = {.lex_state = 184},
  [1346] = {.lex_state = 161, .external_lex_state = 1},
  [1347] = {.lex_state = 184},
  [1348] = {.lex_state = 184},
  [1349] = {.lex_state = 184},
  [1350] = {.lex_state = 184},
  [1351] = {.lex_state = 184},
  [1352] = {.lex_state = 184},
  [1353] = {.lex_state = 184},
  [1354] = {.lex_state = 184},
  [1355] = {.lex_state = 184},
  [1356] = {.lex_state = 184},
  [1357] = {.lex_state = 184},
  [1358] = {.lex_state = 243},
  [1359] = {.lex_state = 227},
  [1360] = {.lex_state = 210},
  [1361] = {.lex_state = 132},
  [1362] = {.lex_state = 195},
  [1363] = {.lex_state = 195},
  [1364] = {.lex_state = 178},
  [1365] = {.lex_state = 132},
  [1366] = {.lex_state = 211},
  [1367] = {.lex_state = 203},
  [1368] = {.lex_state = 183, .external_lex_state = 1},
  [1369] = {.lex_state = 146},
  [1370] = {.lex_state = 183, .external_lex_state = 1},
  [1371] = {.lex_state = 195},
  [1372] = {.lex_state = 146},
  [1373] = {.lex_state = 132},
  [1374] = {.lex_state = 146},
  [1375] = {.lex_state = 132},
  [1376] = {.lex_state = 183, .external_lex_state = 1},
  [1377] = {.lex_state = 178},
  [1378] = {.lex_state = 184},
  [1379] = {.lex_state = 146},
  [1380] = {.lex_state = 146},
  [1381] = {.lex_state = 146},
  [1382] = {.lex_state = 132},
  [1383] = {.lex_state = 146},
  [1384] = {.lex_state = 183, .external_lex_state = 1},
  [1385] = {.lex_state = 161, .external_lex_state = 1},
  [1386] = {.lex_state = 214, .external_lex_state = 1},
  [1387] = {.lex_state = 178},
  [1388] = {.lex_state = 132},
  [1389] = {.lex_state = 132},
  [1390] = {.lex_state = 225},
  [1391] = {.lex_state = 225},
  [1392] = {.lex_state = 183, .external_lex_state = 1},
  [1393] = {.lex_state = 183, .external_lex_state = 1},
  [1394] = {.lex_state = 211},
  [1395] = {.lex_state = 203},
  [1396] = {.lex_state = 208},
  [1397] = {.lex_state = 183, .external_lex_state = 1},
  [1398] = {.lex_state = 178},
  [1399] = {.lex_state = 173},
  [1400] = {.lex_state = 173, .external_lex_state = 1},
  [1401] = {.lex_state = 178},
  [1402] = {.lex_state = 146},
  [1403] = {.lex_state = 178},
  [1404] = {.lex_state = 146},
  [1405] = {.lex_state = 178},
  [1406] = {.lex_state = 183, .external_lex_state = 1},
  [1407] = {.lex_state = 183, .external_lex_state = 1},
  [1408] = {.lex_state = 183, .external_lex_state = 1},
  [1409] = {.lex_state = 183, .external_lex_state = 1},
  [1410] = {.lex_state = 183, .external_lex_state = 1},
  [1411] = {.lex_state = 183, .external_lex_state = 1},
  [1412] = {.lex_state = 183, .external_lex_state = 1},
  [1413] = {.lex_state = 183, .external_lex_state = 1},
  [1414] = {.lex_state = 183, .external_lex_state = 1},
  [1415] = {.lex_state = 183, .external_lex_state = 1},
  [1416] = {.lex_state = 183, .external_lex_state = 1},
  [1417] = {.lex_state = 183, .external_lex_state = 1},
  [1418] = {.lex_state = 183, .external_lex_state = 1},
  [1419] = {.lex_state = 183, .external_lex_state = 1},
  [1420] = {.lex_state = 146},
  [1421] = {.lex_state = 178},
  [1422] = {.lex_state = 183, .external_lex_state = 1},
  [1423] = {.lex_state = 183, .external_lex_state = 1},
  [1424] = {.lex_state = 173},
  [1425] = {.lex_state = 183, .external_lex_state = 1},
  [1426] = {.lex_state = 203},
  [1427] = {.lex_state = 218, .external_lex_state = 1},
  [1428] = {.lex_state = 183, .external_lex_state = 1},
  [1429] = {.lex_state = 178},
  [1430] = {.lex_state = 178},
  [1431] = {.lex_state = 173, .external_lex_state = 1},
  [1432] = {.lex_state = 178},
  [1433] = {.lex_state = 178},
  [1434] = {.lex_state = 184},
  [1435] = {.lex_state = 178},
  [1436] = {.lex_state = 178},
  [1437] = {.lex_state = 178},
  [1438] = {.lex_state = 178},
  [1439] = {.lex_state = 178},
  [1440] = {.lex_state = 178},
  [1441] = {.lex_state = 178},
  [1442] = {.lex_state = 178},
  [1443] = {.lex_state = 178},
  [1444] = {.lex_state = 178},
  [1445] = {.lex_state = 175},
  [1446] = {.lex_state = 175},
  [1447] = {.lex_state = 244, .external_lex_state = 1},
  [1448] = {.lex_state = 203},
  [1449] = {.lex_state = 203},
  [1450] = {.lex_state = 203},
  [1451] = {.lex_state = 227},
  [1452] = {.lex_state = 132},
  [1453] = {.lex_state = 227},
  [1454] = {.lex_state = 132},
  [1455] = {.lex_state = 175},
  [1456] = {.lex_state = 132},
  [1457] = {.lex_state = 227},
  [1458] = {.lex_state = 227},
  [1459] = {.lex_state = 227},
  [1460] = {.lex_state = 183, .external_lex_state = 1},
  [1461] = {.lex_state = 227},
  [1462] = {.lex_state = 132},
  [1463] = {.lex_state = 227},
  [1464] = {.lex_state = 192},
  [1465] = {.lex_state = 183, .external_lex_state = 1},
  [1466] = {.lex_state = 210, .external_lex_state = 1},
  [1467] = {.lex_state = 132},
  [1468] = {.lex_state = 227},
  [1469] = {.lex_state = 227},
  [1470] = {.lex_state = 173, .external_lex_state = 1},
  [1471] = {.lex_state = 227},
  [1472] = {.lex_state = 146},
  [1473] = {.lex_state = 178},
  [1474] = {.lex_state = 178},
  [1475] = {.lex_state = 227},
  [1476] = {.lex_state = 178},
  [1477] = {.lex_state = 146},
  [1478] = {.lex_state = 146},
  [1479] = {.lex_state = 227},
  [1480] = {.lex_state = 146},
  [1481] = {.lex_state = 227},
  [1482] = {.lex_state = 227},
  [1483] = {.lex_state = 132},
  [1484] = {.lex_state = 227},
  [1485] = {.lex_state = 146},
  [1486] = {.lex_state = 227},
  [1487] = {.lex_state = 183, .external_lex_state = 1},
  [1488] = {.lex_state = 227},
  [1489] = {.lex_state = 229},
  [1490] = {.lex_state = 229},
  [1491] = {.lex_state = 210},
  [1492] = {.lex_state = 227},
  [1493] = {.lex_state = 183, .external_lex_state = 1},
  [1494] = {.lex_state = 214, .external_lex_state = 1},
  [1495] = {.lex_state = 183, .external_lex_state = 1},
  [1496] = {.lex_state = 183, .external_lex_state = 1},
  [1497] = {.lex_state = 183, .external_lex_state = 1},
  [1498] = {.lex_state = 183, .external_lex_state = 1},
  [1499] = {.lex_state = 183, .external_lex_state = 1},
  [1500] = {.lex_state = 183, .external_lex_state = 1},
  [1501] = {.lex_state = 183, .external_lex_state = 1},
  [1502] = {.lex_state = 183, .external_lex_state = 1},
  [1503] = {.lex_state = 183, .external_lex_state = 1},
  [1504] = {.lex_state = 183, .external_lex_state = 1},
  [1505] = {.lex_state = 183, .external_lex_state = 1},
  [1506] = {.lex_state = 183, .external_lex_state = 1},
  [1507] = {.lex_state = 183, .external_lex_state = 1},
  [1508] = {.lex_state = 227},
  [1509] = {.lex_state = 146},
  [1510] = {.lex_state = 228},
  [1511] = {.lex_state = 227},
  [1512] = {.lex_state = 210},
  [1513] = {.lex_state = 228},
  [1514] = {.lex_state = 210},
  [1515] = {.lex_state = 227},
  [1516] = {.lex_state = 132},
  [1517] = {.lex_state = 227},
  [1518] = {.lex_state = 132},
  [1519] = {.lex_state = 227},
  [1520] = {.lex_state = 229},
  [1521] = {.lex_state = 229},
  [1522] = {.lex_state = 175},
  [1523] = {.lex_state = 132},
  [1524] = {.lex_state = 175},
  [1525] = {.lex_state = 132},
  [1526] = {.lex_state = 132},
  [1527] = {.lex_state = 230},
  [1528] = {.lex_state = 230},
  [1529] = {.lex_state = 146},
  [1530] = {.lex_state = 245},
  [1531] = {.lex_state = 230},
  [1532] = {.lex_state = 230},
  [1533] = {.lex_state = 227},
  [1534] = {.lex_state = 132},
  [1535] = {.lex_state = 227},
  [1536] = {.lex_state = 210},
  [1537] = {.lex_state = 246},
  [1538] = {.lex_state = 132},
  [1539] = {.lex_state = 227},
  [1540] = {.lex_state = 183, .external_lex_state = 1},
  [1541] = {.lex_state = 230},
  [1542] = {.lex_state = 146},
  [1543] = {.lex_state = 146},
  [1544] = {.lex_state = 210},
  [1545] = {.lex_state = 146},
  [1546] = {.lex_state = 230},
  [1547] = {.lex_state = 230},
  [1548] = {.lex_state = 230},
  [1549] = {.lex_state = 213},
  [1550] = {.lex_state = 161, .external_lex_state = 1},
  [1551] = {.lex_state = 146},
  [1552] = {.lex_state = 178},
  [1553] = {.lex_state = 132},
  [1554] = {.lex_state = 132},
  [1555] = {.lex_state = 132},
  [1556] = {.lex_state = 132},
  [1557] = {.lex_state = 213},
  [1558] = {.lex_state = 132},
  [1559] = {.lex_state = 178},
  [1560] = {.lex_state = 183, .external_lex_state = 1},
  [1561] = {.lex_state = 132},
  [1562] = {.lex_state = 183, .external_lex_state = 1},
  [1563] = {.lex_state = 184},
  [1564] = {.lex_state = 183, .external_lex_state = 1},
  [1565] = {.lex_state = 183, .external_lex_state = 1},
  [1566] = {.lex_state = 183, .external_lex_state = 1},
  [1567] = {.lex_state = 183, .external_lex_state = 1},
  [1568] = {.lex_state = 146},
  [1569] = {.lex_state = 161, .external_lex_state = 1},
  [1570] = {.lex_state = 161, .external_lex_state = 1},
  [1571] = {.lex_state = 146},
  [1572] = {.lex_state = 132},
  [1573] = {.lex_state = 132},
  [1574] = {.lex_state = 146},
  [1575] = {.lex_state = 218},
  [1576] = {.lex_state = 178},
  [1577] = {.lex_state = 161, .external_lex_state = 1},
  [1578] = {.lex_state = 178},
  [1579] = {.lex_state = 132},
  [1580] = {.lex_state = 132, .external_lex_state = 1},
  [1581] = {.lex_state = 183, .external_lex_state = 1},
  [1582] = {.lex_state = 202},
  [1583] = {.lex_state = 203},
  [1584] = {.lex_state = 146},
  [1585] = {.lex_state = 211},
  [1586] = {.lex_state = 146},
  [1587] = {.lex_state = 211},
  [1588] = {.lex_state = 211},
  [1589] = {.lex_state = 162},
  [1590] = {.lex_state = 211},
  [1591] = {.lex_state = 184},
  [1592] = {.lex_state = 132},
  [1593] = {.lex_state = 211},
  [1594] = {.lex_state = 132},
  [1595] = {.lex_state = 184},
  [1596] = {.lex_state = 211},
  [1597] = {.lex_state = 184},
  [1598] = {.lex_state = 132},
  [1599] = {.lex_state = 211},
  [1600] = {.lex_state = 132},
  [1601] = {.lex_state = 184},
  [1602] = {.lex_state = 202},
  [1603] = {.lex_state = 211},
  [1604] = {.lex_state = 184},
  [1605] = {.lex_state = 132},
  [1606] = {.lex_state = 211},
  [1607] = {.lex_state = 132},
  [1608] = {.lex_state = 184},
  [1609] = {.lex_state = 208},
  [1610] = {.lex_state = 211},
  [1611] = {.lex_state = 202},
  [1612] = {.lex_state = 202},
  [1613] = {.lex_state = 218, .external_lex_state = 1},
  [1614] = {.lex_state = 178},
  [1615] = {.lex_state = 146},
  [1616] = {.lex_state = 173},
  [1617] = {.lex_state = 173},
  [1618] = {.lex_state = 178},
  [1619] = {.lex_state = 146},
  [1620] = {.lex_state = 146, .external_lex_state = 1},
  [1621] = {.lex_state = 247, .external_lex_state = 1},
  [1622] = {.lex_state = 183, .external_lex_state = 1},
  [1623] = {.lex_state = 183, .external_lex_state = 1},
  [1624] = {.lex_state = 183, .external_lex_state = 1},
  [1625] = {.lex_state = 183, .external_lex_state = 1},
  [1626] = {.lex_state = 183, .external_lex_state = 1},
  [1627] = {.lex_state = 183, .external_lex_state = 1},
  [1628] = {.lex_state = 183, .external_lex_state = 1},
  [1629] = {.lex_state = 146},
  [1630] = {.lex_state = 132},
  [1631] = {.lex_state = 178},
  [1632] = {.lex_state = 178},
  [1633] = {.lex_state = 209},
  [1634] = {.lex_state = 248},
  [1635] = {.lex_state = 132},
  [1636] = {.lex_state = 232},
  [1637] = {.lex_state = 132},
  [1638] = {.lex_state = 178},
  [1639] = {.lex_state = 175},
  [1640] = {.lex_state = 146},
  [1641] = {.lex_state = 178},
  [1642] = {.lex_state = 161, .external_lex_state = 1},
  [1643] = {.lex_state = 146},
  [1644] = {.lex_state = 178},
  [1645] = {.lex_state = 132},
  [1646] = {.lex_state = 161, .external_lex_state = 1},
  [1647] = {.lex_state = 204},
  [1648] = {.lex_state = 209},
  [1649] = {.lex_state = 203},
  [1650] = {.lex_state = 232},
  [1651] = {.lex_state = 232},
  [1652] = {.lex_state = 203},
  [1653] = {.lex_state = 203},
  [1654] = {.lex_state = 203},
  [1655] = {.lex_state = 232},
  [1656] = {.lex_state = 232},
  [1657] = {.lex_state = 232},
  [1658] = {.lex_state = 203},
  [1659] = {.lex_state = 209},
  [1660] = {.lex_state = 183, .external_lex_state = 1},
  [1661] = {.lex_state = 208},
  [1662] = {.lex_state = 173, .external_lex_state = 1},
  [1663] = {.lex_state = 208},
  [1664] = {.lex_state = 146},
  [1665] = {.lex_state = 208},
  [1666] = {.lex_state = 146},
  [1667] = {.lex_state = 208},
  [1668] = {.lex_state = 183, .external_lex_state = 1},
  [1669] = {.lex_state = 183, .external_lex_state = 1},
  [1670] = {.lex_state = 183, .external_lex_state = 1},
  [1671] = {.lex_state = 183, .external_lex_state = 1},
  [1672] = {.lex_state = 183, .external_lex_state = 1},
  [1673] = {.lex_state = 183, .external_lex_state = 1},
  [1674] = {.lex_state = 183, .external_lex_state = 1},
  [1675] = {.lex_state = 183, .external_lex_state = 1},
  [1676] = {.lex_state = 183, .external_lex_state = 1},
  [1677] = {.lex_state = 183, .external_lex_state = 1},
  [1678] = {.lex_state = 183, .external_lex_state = 1},
  [1679] = {.lex_state = 183, .external_lex_state = 1},
  [1680] = {.lex_state = 183, .external_lex_state = 1},
  [1681] = {.lex_state = 208},
  [1682] = {.lex_state = 207, .external_lex_state = 1},
  [1683] = {.lex_state = 208},
  [1684] = {.lex_state = 207, .external_lex_state = 1},
  [1685] = {.lex_state = 146},
  [1686] = {.lex_state = 178},
  [1687] = {.lex_state = 178},
  [1688] = {.lex_state = 178},
  [1689] = {.lex_state = 146},
  [1690] = {.lex_state = 209},
  [1691] = {.lex_state = 225},
  [1692] = {.lex_state = 209},
  [1693] = {.lex_state = 184},
  [1694] = {.lex_state = 161, .external_lex_state = 1},
  [1695] = {.lex_state = 161, .external_lex_state = 1},
  [1696] = {.lex_state = 132},
  [1697] = {.lex_state = 173},
  [1698] = {.lex_state = 175},
  [1699] = {.lex_state = 175},
  [1700] = {.lex_state = 146},
  [1701] = {.lex_state = 173},
  [1702] = {.lex_state = 132},
  [1703] = {.lex_state = 173},
  [1704] = {.lex_state = 211},
  [1705] = {.lex_state = 183, .external_lex_state = 1},
  [1706] = {.lex_state = 132},
  [1707] = {.lex_state = 202},
  [1708] = {.lex_state = 175},
  [1709] = {.lex_state = 132},
  [1710] = {.lex_state = 211},
  [1711] = {.lex_state = 209},
  [1712] = {.lex_state = 178},
  [1713] = {.lex_state = 146},
  [1714] = {.lex_state = 178},
  [1715] = {.lex_state = 201},
  [1716] = {.lex_state = 209},
  [1717] = {.lex_state = 207, .external_lex_state = 1},
  [1718] = {.lex_state = 208},
  [1719] = {.lex_state = 207, .external_lex_state = 1},
  [1720] = {.lex_state = 209},
  [1721] = {.lex_state = 178},
  [1722] = {.lex_state = 146},
  [1723] = {.lex_state = 178},
  [1724] = {.lex_state = 178},
  [1725] = {.lex_state = 178},
  [1726] = {.lex_state = 146},
  [1727] = {.lex_state = 132},
  [1728] = {.lex_state = 201},
  [1729] = {.lex_state = 178},
  [1730] = {.lex_state = 175},
  [1731] = {.lex_state = 210},
  [1732] = {.lex_state = 175},
  [1733] = {.lex_state = 210},
  [1734] = {.lex_state = 197},
  [1735] = {.lex_state = 161, .external_lex_state = 1},
  [1736] = {.lex_state = 197},
  [1737] = {.lex_state = 204},
  [1738] = {.lex_state = 158},
  [1739] = {.lex_state = 203},
  [1740] = {.lex_state = 161, .external_lex_state = 1},
  [1741] = {.lex_state = 199, .external_lex_state = 1},
  [1742] = {.lex_state = 192},
  [1743] = {.lex_state = 199, .external_lex_state = 1},
  [1744] = {.lex_state = 200},
  [1745] = {.lex_state = 158},
  [1746] = {.lex_state = 199, .external_lex_state = 1},
  [1747] = {.lex_state = 218},
  [1748] = {.lex_state = 199, .external_lex_state = 1},
  [1749] = {.lex_state = 199, .external_lex_state = 1},
  [1750] = {.lex_state = 218},
  [1751] = {.lex_state = 199, .external_lex_state = 1},
  [1752] = {.lex_state = 192},
  [1753] = {.lex_state = 215, .external_lex_state = 1},
  [1754] = {.lex_state = 198},
  [1755] = {.lex_state = 199, .external_lex_state = 1},
  [1756] = {.lex_state = 199, .external_lex_state = 1},
  [1757] = {.lex_state = 215, .external_lex_state = 1},
  [1758] = {.lex_state = 200},
  [1759] = {.lex_state = 146},
  [1760] = {.lex_state = 146},
  [1761] = {.lex_state = 146},
  [1762] = {.lex_state = 215, .external_lex_state = 1},
  [1763] = {.lex_state = 146, .external_lex_state = 1},
  [1764] = {.lex_state = 183, .external_lex_state = 1},
  [1765] = {.lex_state = 132},
  [1766] = {.lex_state = 183, .external_lex_state = 1},
  [1767] = {.lex_state = 184},
  [1768] = {.lex_state = 183, .external_lex_state = 1},
  [1769] = {.lex_state = 183, .external_lex_state = 1},
  [1770] = {.lex_state = 146},
  [1771] = {.lex_state = 183, .external_lex_state = 1},
  [1772] = {.lex_state = 215, .external_lex_state = 1},
  [1773] = {.lex_state = 178},
  [1774] = {.lex_state = 132},
  [1775] = {.lex_state = 215, .external_lex_state = 1},
  [1776] = {.lex_state = 215, .external_lex_state = 1},
  [1777] = {.lex_state = 132},
  [1778] = {.lex_state = 183, .external_lex_state = 1},
  [1779] = {.lex_state = 132},
  [1780] = {.lex_state = 132},
  [1781] = {.lex_state = 146},
  [1782] = {.lex_state = 161, .external_lex_state = 1},
  [1783] = {.lex_state = 132},
  [1784] = {.lex_state = 215, .external_lex_state = 1},
  [1785] = {.lex_state = 178},
  [1786] = {.lex_state = 146},
  [1787] = {.lex_state = 132},
  [1788] = {.lex_state = 146},
  [1789] = {.lex_state = 215, .external_lex_state = 1},
  [1790] = {.lex_state = 178},
  [1791] = {.lex_state = 146},
  [1792] = {.lex_state = 173},
  [1793] = {.lex_state = 146},
  [1794] = {.lex_state = 215, .external_lex_state = 1},
  [1795] = {.lex_state = 173},
  [1796] = {.lex_state = 215, .external_lex_state = 1},
  [1797] = {.lex_state = 215, .external_lex_state = 1},
  [1798] = {.lex_state = 184},
  [1799] = {.lex_state = 218},
  [1800] = {.lex_state = 199, .external_lex_state = 1},
  [1801] = {.lex_state = 199, .external_lex_state = 1},
  [1802] = {.lex_state = 132},
  [1803] = {.lex_state = 146},
  [1804] = {.lex_state = 199, .external_lex_state = 1},
  [1805] = {.lex_state = 132},
  [1806] = {.lex_state = 199, .external_lex_state = 1},
  [1807] = {.lex_state = 203},
  [1808] = {.lex_state = 183, .external_lex_state = 1},
  [1809] = {.lex_state = 178},
  [1810] = {.lex_state = 199, .external_lex_state = 1},
  [1811] = {.lex_state = 183, .external_lex_state = 1},
  [1812] = {.lex_state = 195},
  [1813] = {.lex_state = 199, .external_lex_state = 1},
  [1814] = {.lex_state = 132},
  [1815] = {.lex_state = 199, .external_lex_state = 1},
  [1816] = {.lex_state = 132},
  [1817] = {.lex_state = 183, .external_lex_state = 1},
  [1818] = {.lex_state = 178},
  [1819] = {.lex_state = 184},
  [1820] = {.lex_state = 199, .external_lex_state = 1},
  [1821] = {.lex_state = 199, .external_lex_state = 1},
  [1822] = {.lex_state = 199, .external_lex_state = 1},
  [1823] = {.lex_state = 132},
  [1824] = {.lex_state = 199, .external_lex_state = 1},
  [1825] = {.lex_state = 199, .external_lex_state = 1},
  [1826] = {.lex_state = 132},
  [1827] = {.lex_state = 199, .external_lex_state = 1},
  [1828] = {.lex_state = 161, .external_lex_state = 1},
  [1829] = {.lex_state = 199, .external_lex_state = 1},
  [1830] = {.lex_state = 199, .external_lex_state = 1},
  [1831] = {.lex_state = 146},
  [1832] = {.lex_state = 178},
  [1833] = {.lex_state = 132},
  [1834] = {.lex_state = 132},
  [1835] = {.lex_state = 199, .external_lex_state = 1},
  [1836] = {.lex_state = 199, .external_lex_state = 1},
  [1837] = {.lex_state = 146, .external_lex_state = 1},
  [1838] = {.lex_state = 199, .external_lex_state = 1},
  [1839] = {.lex_state = 146},
  [1840] = {.lex_state = 183, .external_lex_state = 1},
  [1841] = {.lex_state = 132},
  [1842] = {.lex_state = 132},
  [1843] = {.lex_state = 132},
  [1844] = {.lex_state = 199, .external_lex_state = 1},
  [1845] = {.lex_state = 161, .external_lex_state = 1},
  [1846] = {.lex_state = 173},
  [1847] = {.lex_state = 161, .external_lex_state = 1},
  [1848] = {.lex_state = 225},
  [1849] = {.lex_state = 146},
  [1850] = {.lex_state = 146},
  [1851] = {.lex_state = 225},
  [1852] = {.lex_state = 225},
  [1853] = {.lex_state = 132},
  [1854] = {.lex_state = 225},
  [1855] = {.lex_state = 132},
  [1856] = {.lex_state = 225},
  [1857] = {.lex_state = 132},
  [1858] = {.lex_state = 225},
  [1859] = {.lex_state = 132},
  [1860] = {.lex_state = 201},
  [1861] = {.lex_state = 210},
  [1862] = {.lex_state = 201},
  [1863] = {.lex_state = 210},
  [1864] = {.lex_state = 225},
  [1865] = {.lex_state = 132},
  [1866] = {.lex_state = 225},
  [1867] = {.lex_state = 132},
  [1868] = {.lex_state = 146},
  [1869] = {.lex_state = 184},
  [1870] = {.lex_state = 184},
  [1871] = {.lex_state = 146},
  [1872] = {.lex_state = 207, .external_lex_state = 1},
  [1873] = {.lex_state = 184},
  [1874] = {.lex_state = 208},
  [1875] = {.lex_state = 207, .external_lex_state = 1},
  [1876] = {.lex_state = 161, .external_lex_state = 1},
  [1877] = {.lex_state = 146, .external_lex_state = 1},
  [1878] = {.lex_state = 146, .external_lex_state = 1},
  [1879] = {.lex_state = 146, .external_lex_state = 1},
  [1880] = {.lex_state = 200},
  [1881] = {.lex_state = 192},
  [1882] = {.lex_state = 226, .external_lex_state = 1},
  [1883] = {.lex_state = 198},
  [1884] = {.lex_state = 226, .external_lex_state = 1},
  [1885] = {.lex_state = 226, .external_lex_state = 1},
  [1886] = {.lex_state = 141},
  [1887] = {.lex_state = 146},
  [1888] = {.lex_state = 149},
  [1889] = {.lex_state = 146},
  [1890] = {.lex_state = 158},
  [1891] = {.lex_state = 233, .external_lex_state = 1},
  [1892] = {.lex_state = 146},
  [1893] = {.lex_state = 146, .external_lex_state = 1},
  [1894] = {.lex_state = 146},
  [1895] = {.lex_state = 132},
  [1896] = {.lex_state = 183, .external_lex_state = 1},
  [1897] = {.lex_state = 184},
  [1898] = {.lex_state = 132},
  [1899] = {.lex_state = 183, .external_lex_state = 1},
  [1900] = {.lex_state = 132},
  [1901] = {.lex_state = 183, .external_lex_state = 1},
  [1902] = {.lex_state = 132},
  [1903] = {.lex_state = 132},
  [1904] = {.lex_state = 146},
  [1905] = {.lex_state = 195},
  [1906] = {.lex_state = 132},
  [1907] = {.lex_state = 132},
  [1908] = {.lex_state = 178},
  [1909] = {.lex_state = 132},
  [1910] = {.lex_state = 233, .external_lex_state = 1},
  [1911] = {.lex_state = 226, .external_lex_state = 1},
  [1912] = {.lex_state = 226, .external_lex_state = 1},
  [1913] = {.lex_state = 200},
  [1914] = {.lex_state = 146},
  [1915] = {.lex_state = 146},
  [1916] = {.lex_state = 226, .external_lex_state = 1},
  [1917] = {.lex_state = 146, .external_lex_state = 1},
  [1918] = {.lex_state = 183, .external_lex_state = 1},
  [1919] = {.lex_state = 132},
  [1920] = {.lex_state = 183, .external_lex_state = 1},
  [1921] = {.lex_state = 184},
  [1922] = {.lex_state = 183, .external_lex_state = 1},
  [1923] = {.lex_state = 183, .external_lex_state = 1},
  [1924] = {.lex_state = 146},
  [1925] = {.lex_state = 183, .external_lex_state = 1},
  [1926] = {.lex_state = 226, .external_lex_state = 1},
  [1927] = {.lex_state = 178},
  [1928] = {.lex_state = 132},
  [1929] = {.lex_state = 226, .external_lex_state = 1},
  [1930] = {.lex_state = 226, .external_lex_state = 1},
  [1931] = {.lex_state = 132},
  [1932] = {.lex_state = 183, .external_lex_state = 1},
  [1933] = {.lex_state = 146},
  [1934] = {.lex_state = 146, .external_lex_state = 1},
  [1935] = {.lex_state = 226, .external_lex_state = 1},
  [1936] = {.lex_state = 178},
  [1937] = {.lex_state = 146},
  [1938] = {.lex_state = 173},
  [1939] = {.lex_state = 226, .external_lex_state = 1},
  [1940] = {.lex_state = 218},
  [1941] = {.lex_state = 226, .external_lex_state = 1},
  [1942] = {.lex_state = 146, .external_lex_state = 1},
  [1943] = {.lex_state = 218},
  [1944] = {.lex_state = 146, .external_lex_state = 1},
  [1945] = {.lex_state = 132},
  [1946] = {.lex_state = 183, .external_lex_state = 1},
  [1947] = {.lex_state = 203},
  [1948] = {.lex_state = 146, .external_lex_state = 1},
  [1949] = {.lex_state = 146, .external_lex_state = 1},
  [1950] = {.lex_state = 214, .external_lex_state = 1},
  [1951] = {.lex_state = 178},
  [1952] = {.lex_state = 183, .external_lex_state = 1},
  [1953] = {.lex_state = 183, .external_lex_state = 1},
  [1954] = {.lex_state = 132},
  [1955] = {.lex_state = 146, .external_lex_state = 1},
  [1956] = {.lex_state = 146, .external_lex_state = 1},
  [1957] = {.lex_state = 178},
  [1958] = {.lex_state = 132},
  [1959] = {.lex_state = 146, .external_lex_state = 1},
  [1960] = {.lex_state = 203, .external_lex_state = 1},
  [1961] = {.lex_state = 203},
  [1962] = {.lex_state = 208},
  [1963] = {.lex_state = 218, .external_lex_state = 1},
  [1964] = {.lex_state = 178},
  [1965] = {.lex_state = 178},
  [1966] = {.lex_state = 178},
  [1967] = {.lex_state = 146},
  [1968] = {.lex_state = 249},
  [1969] = {.lex_state = 249},
  [1970] = {.lex_state = 203},
  [1971] = {.lex_state = 203},
  [1972] = {.lex_state = 204},
  [1973] = {.lex_state = 203},
  [1974] = {.lex_state = 204},
  [1975] = {.lex_state = 203},
  [1976] = {.lex_state = 183, .external_lex_state = 1},
  [1977] = {.lex_state = 146},
  [1978] = {.lex_state = 201},
  [1979] = {.lex_state = 201},
  [1980] = {.lex_state = 178},
  [1981] = {.lex_state = 208, .external_lex_state = 1},
  [1982] = {.lex_state = 208},
  [1983] = {.lex_state = 208},
  [1984] = {.lex_state = 218, .external_lex_state = 1},
  [1985] = {.lex_state = 183, .external_lex_state = 1},
  [1986] = {.lex_state = 178},
  [1987] = {.lex_state = 175},
  [1988] = {.lex_state = 146},
  [1989] = {.lex_state = 146},
  [1990] = {.lex_state = 146},
  [1991] = {.lex_state = 242},
  [1992] = {.lex_state = 234},
  [1993] = {.lex_state = 149},
  [1994] = {.lex_state = 218},
  [1995] = {.lex_state = 234},
  [1996] = {.lex_state = 242},
  [1997] = {.lex_state = 218},
  [1998] = {.lex_state = 234},
  [1999] = {.lex_state = 132},
  [2000] = {.lex_state = 146},
  [2001] = {.lex_state = 213},
  [2002] = {.lex_state = 242},
  [2003] = {.lex_state = 132},
  [2004] = {.lex_state = 178},
  [2005] = {.lex_state = 146},
  [2006] = {.lex_state = 242},
  [2007] = {.lex_state = 242},
  [2008] = {.lex_state = 146},
  [2009] = {.lex_state = 178},
  [2010] = {.lex_state = 132},
  [2011] = {.lex_state = 132},
  [2012] = {.lex_state = 132},
  [2013] = {.lex_state = 203},
  [2014] = {.lex_state = 225},
  [2015] = {.lex_state = 132},
  [2016] = {.lex_state = 178},
  [2017] = {.lex_state = 225},
  [2018] = {.lex_state = 132},
  [2019] = {.lex_state = 242},
  [2020] = {.lex_state = 207, .external_lex_state = 1},
  [2021] = {.lex_state = 146},
  [2022] = {.lex_state = 183, .external_lex_state = 1},
  [2023] = {.lex_state = 242},
  [2024] = {.lex_state = 225},
  [2025] = {.lex_state = 225},
  [2026] = {.lex_state = 146},
  [2027] = {.lex_state = 225},
  [2028] = {.lex_state = 242},
  [2029] = {.lex_state = 146, .external_lex_state = 1},
  [2030] = {.lex_state = 132},
  [2031] = {.lex_state = 132},
  [2032] = {.lex_state = 242},
  [2033] = {.lex_state = 213},
  [2034] = {.lex_state = 213},
  [2035] = {.lex_state = 173},
  [2036] = {.lex_state = 213},
  [2037] = {.lex_state = 175},
  [2038] = {.lex_state = 146},
  [2039] = {.lex_state = 146},
  [2040] = {.lex_state = 175},
  [2041] = {.lex_state = 146},
  [2042] = {.lex_state = 146},
  [2043] = {.lex_state = 146},
  [2044] = {.lex_state = 175},
  [2045] = {.lex_state = 175},
  [2046] = {.lex_state = 175},
  [2047] = {.lex_state = 175},
  [2048] = {.lex_state = 183, .external_lex_state = 1},
  [2049] = {.lex_state = 203},
  [2050] = {.lex_state = 218, .external_lex_state = 1},
  [2051] = {.lex_state = 183, .external_lex_state = 1},
  [2052] = {.lex_state = 203},
  [2053] = {.lex_state = 203},
  [2054] = {.lex_state = 173, .external_lex_state = 1},
  [2055] = {.lex_state = 203},
  [2056] = {.lex_state = 146},
  [2057] = {.lex_state = 132},
  [2058] = {.lex_state = 183, .external_lex_state = 1},
  [2059] = {.lex_state = 184},
  [2060] = {.lex_state = 132},
  [2061] = {.lex_state = 132},
  [2062] = {.lex_state = 178},
  [2063] = {.lex_state = 132},
  [2064] = {.lex_state = 132, .external_lex_state = 1},
  [2065] = {.lex_state = 203},
  [2066] = {.lex_state = 184},
  [2067] = {.lex_state = 203},
  [2068] = {.lex_state = 203},
  [2069] = {.lex_state = 203},
  [2070] = {.lex_state = 203},
  [2071] = {.lex_state = 203},
  [2072] = {.lex_state = 203},
  [2073] = {.lex_state = 203},
  [2074] = {.lex_state = 203},
  [2075] = {.lex_state = 203},
  [2076] = {.lex_state = 203},
  [2077] = {.lex_state = 183, .external_lex_state = 1},
  [2078] = {.lex_state = 184},
  [2079] = {.lex_state = 178, .external_lex_state = 1},
  [2080] = {.lex_state = 184},
  [2081] = {.lex_state = 208},
  [2082] = {.lex_state = 184},
  [2083] = {.lex_state = 218, .external_lex_state = 1},
  [2084] = {.lex_state = 184},
  [2085] = {.lex_state = 203},
  [2086] = {.lex_state = 183, .external_lex_state = 1},
  [2087] = {.lex_state = 243},
  [2088] = {.lex_state = 210},
  [2089] = {.lex_state = 243},
  [2090] = {.lex_state = 210},
  [2091] = {.lex_state = 195},
  [2092] = {.lex_state = 195},
  [2093] = {.lex_state = 183, .external_lex_state = 1},
  [2094] = {.lex_state = 203},
  [2095] = {.lex_state = 146},
  [2096] = {.lex_state = 178},
  [2097] = {.lex_state = 183, .external_lex_state = 1},
  [2098] = {.lex_state = 146},
  [2099] = {.lex_state = 214, .external_lex_state = 1},
  [2100] = {.lex_state = 178},
  [2101] = {.lex_state = 183, .external_lex_state = 1},
  [2102] = {.lex_state = 183, .external_lex_state = 1},
  [2103] = {.lex_state = 132},
  [2104] = {.lex_state = 146},
  [2105] = {.lex_state = 203},
  [2106] = {.lex_state = 203},
  [2107] = {.lex_state = 183, .external_lex_state = 1},
  [2108] = {.lex_state = 203},
  [2109] = {.lex_state = 214, .external_lex_state = 1},
  [2110] = {.lex_state = 225},
  [2111] = {.lex_state = 132},
  [2112] = {.lex_state = 225},
  [2113] = {.lex_state = 225},
  [2114] = {.lex_state = 178},
  [2115] = {.lex_state = 203},
  [2116] = {.lex_state = 183, .external_lex_state = 1},
  [2117] = {.lex_state = 175},
  [2118] = {.lex_state = 203},
  [2119] = {.lex_state = 218, .external_lex_state = 1},
  [2120] = {.lex_state = 183, .external_lex_state = 1},
  [2121] = {.lex_state = 178},
  [2122] = {.lex_state = 178},
  [2123] = {.lex_state = 173, .external_lex_state = 1},
  [2124] = {.lex_state = 178},
  [2125] = {.lex_state = 211},
  [2126] = {.lex_state = 178},
  [2127] = {.lex_state = 146},
  [2128] = {.lex_state = 178},
  [2129] = {.lex_state = 184},
  [2130] = {.lex_state = 178},
  [2131] = {.lex_state = 178},
  [2132] = {.lex_state = 178},
  [2133] = {.lex_state = 178},
  [2134] = {.lex_state = 178},
  [2135] = {.lex_state = 178},
  [2136] = {.lex_state = 178},
  [2137] = {.lex_state = 178},
  [2138] = {.lex_state = 178},
  [2139] = {.lex_state = 183, .external_lex_state = 1},
  [2140] = {.lex_state = 146},
  [2141] = {.lex_state = 178},
  [2142] = {.lex_state = 208},
  [2143] = {.lex_state = 178},
  [2144] = {.lex_state = 146},
  [2145] = {.lex_state = 244, .external_lex_state = 1},
  [2146] = {.lex_state = 178},
  [2147] = {.lex_state = 208},
  [2148] = {.lex_state = 218, .external_lex_state = 1},
  [2149] = {.lex_state = 183, .external_lex_state = 1},
  [2150] = {.lex_state = 227},
  [2151] = {.lex_state = 183, .external_lex_state = 1},
  [2152] = {.lex_state = 132},
  [2153] = {.lex_state = 227},
  [2154] = {.lex_state = 227},
  [2155] = {.lex_state = 132},
  [2156] = {.lex_state = 203},
  [2157] = {.lex_state = 227},
  [2158] = {.lex_state = 227},
  [2159] = {.lex_state = 146},
  [2160] = {.lex_state = 227},
  [2161] = {.lex_state = 178},
  [2162] = {.lex_state = 146},
  [2163] = {.lex_state = 227},
  [2164] = {.lex_state = 227},
  [2165] = {.lex_state = 210},
  [2166] = {.lex_state = 227},
  [2167] = {.lex_state = 227},
  [2168] = {.lex_state = 218, .external_lex_state = 1},
  [2169] = {.lex_state = 146},
  [2170] = {.lex_state = 227},
  [2171] = {.lex_state = 227},
  [2172] = {.lex_state = 162},
  [2173] = {.lex_state = 227},
  [2174] = {.lex_state = 227},
  [2175] = {.lex_state = 184},
  [2176] = {.lex_state = 132},
  [2177] = {.lex_state = 227},
  [2178] = {.lex_state = 250},
  [2179] = {.lex_state = 227},
  [2180] = {.lex_state = 227},
  [2181] = {.lex_state = 184},
  [2182] = {.lex_state = 132},
  [2183] = {.lex_state = 227},
  [2184] = {.lex_state = 250},
  [2185] = {.lex_state = 146},
  [2186] = {.lex_state = 227},
  [2187] = {.lex_state = 227},
  [2188] = {.lex_state = 227},
  [2189] = {.lex_state = 184},
  [2190] = {.lex_state = 132},
  [2191] = {.lex_state = 227},
  [2192] = {.lex_state = 250},
  [2193] = {.lex_state = 227},
  [2194] = {.lex_state = 227},
  [2195] = {.lex_state = 183, .external_lex_state = 1},
  [2196] = {.lex_state = 227},
  [2197] = {.lex_state = 227},
  [2198] = {.lex_state = 227},
  [2199] = {.lex_state = 146},
  [2200] = {.lex_state = 227},
  [2201] = {.lex_state = 227},
  [2202] = {.lex_state = 227},
  [2203] = {.lex_state = 227},
  [2204] = {.lex_state = 227},
  [2205] = {.lex_state = 173, .external_lex_state = 1},
  [2206] = {.lex_state = 227},
  [2207] = {.lex_state = 210},
  [2208] = {.lex_state = 229},
  [2209] = {.lex_state = 210},
  [2210] = {.lex_state = 227},
  [2211] = {.lex_state = 146},
  [2212] = {.lex_state = 227},
  [2213] = {.lex_state = 227},
  [2214] = {.lex_state = 210},
  [2215] = {.lex_state = 227},
  [2216] = {.lex_state = 203},
  [2217] = {.lex_state = 203},
  [2218] = {.lex_state = 227},
  [2219] = {.lex_state = 208},
  [2220] = {.lex_state = 227},
  [2221] = {.lex_state = 184},
  [2222] = {.lex_state = 227},
  [2223] = {.lex_state = 227},
  [2224] = {.lex_state = 227},
  [2225] = {.lex_state = 227},
  [2226] = {.lex_state = 227},
  [2227] = {.lex_state = 227},
  [2228] = {.lex_state = 227},
  [2229] = {.lex_state = 227},
  [2230] = {.lex_state = 227},
  [2231] = {.lex_state = 227},
  [2232] = {.lex_state = 227},
  [2233] = {.lex_state = 175},
  [2234] = {.lex_state = 228},
  [2235] = {.lex_state = 210},
  [2236] = {.lex_state = 228},
  [2237] = {.lex_state = 227},
  [2238] = {.lex_state = 227},
  [2239] = {.lex_state = 227},
  [2240] = {.lex_state = 146, .external_lex_state = 1},
  [2241] = {.lex_state = 227},
  [2242] = {.lex_state = 210},
  [2243] = {.lex_state = 175},
  [2244] = {.lex_state = 175},
  [2245] = {.lex_state = 146},
  [2246] = {.lex_state = 232},
  [2247] = {.lex_state = 232},
  [2248] = {.lex_state = 227},
  [2249] = {.lex_state = 230},
  [2250] = {.lex_state = 227},
  [2251] = {.lex_state = 132},
  [2252] = {.lex_state = 231, .external_lex_state = 1},
  [2253] = {.lex_state = 183, .external_lex_state = 1},
  [2254] = {.lex_state = 227},
  [2255] = {.lex_state = 132},
  [2256] = {.lex_state = 227},
  [2257] = {.lex_state = 230},
  [2258] = {.lex_state = 210},
  [2259] = {.lex_state = 146},
  [2260] = {.lex_state = 210},
  [2261] = {.lex_state = 230},
  [2262] = {.lex_state = 230},
  [2263] = {.lex_state = 146},
  [2264] = {.lex_state = 225},
  [2265] = {.lex_state = 225},
  [2266] = {.lex_state = 178},
  [2267] = {.lex_state = 132},
  [2268] = {.lex_state = 132},
  [2269] = {.lex_state = 203},
  [2270] = {.lex_state = 183, .external_lex_state = 1},
  [2271] = {.lex_state = 178},
  [2272] = {.lex_state = 183, .external_lex_state = 1},
  [2273] = {.lex_state = 195},
  [2274] = {.lex_state = 183, .external_lex_state = 1},
  [2275] = {.lex_state = 178},
  [2276] = {.lex_state = 184},
  [2277] = {.lex_state = 161, .external_lex_state = 1},
  [2278] = {.lex_state = 218},
  [2279] = {.lex_state = 132},
  [2280] = {.lex_state = 132},
  [2281] = {.lex_state = 178},
  [2282] = {.lex_state = 161, .external_lex_state = 1},
  [2283] = {.lex_state = 132},
  [2284] = {.lex_state = 218},
  [2285] = {.lex_state = 161, .external_lex_state = 1},
  [2286] = {.lex_state = 203},
  [2287] = {.lex_state = 203},
  [2288] = {.lex_state = 202},
  [2289] = {.lex_state = 203},
  [2290] = {.lex_state = 211},
  [2291] = {.lex_state = 146},
  [2292] = {.lex_state = 146},
  [2293] = {.lex_state = 211},
  [2294] = {.lex_state = 211},
  [2295] = {.lex_state = 132},
  [2296] = {.lex_state = 211},
  [2297] = {.lex_state = 132},
  [2298] = {.lex_state = 211},
  [2299] = {.lex_state = 132},
  [2300] = {.lex_state = 211},
  [2301] = {.lex_state = 132},
  [2302] = {.lex_state = 211},
  [2303] = {.lex_state = 132},
  [2304] = {.lex_state = 211},
  [2305] = {.lex_state = 132},
  [2306] = {.lex_state = 178},
  [2307] = {.lex_state = 211},
  [2308] = {.lex_state = 178},
  [2309] = {.lex_state = 173},
  [2310] = {.lex_state = 173},
  [2311] = {.lex_state = 173},
  [2312] = {.lex_state = 146, .external_lex_state = 1},
  [2313] = {.lex_state = 203},
  [2314] = {.lex_state = 132},
  [2315] = {.lex_state = 183, .external_lex_state = 1},
  [2316] = {.lex_state = 178},
  [2317] = {.lex_state = 173, .external_lex_state = 1},
  [2318] = {.lex_state = 178},
  [2319] = {.lex_state = 146},
  [2320] = {.lex_state = 178},
  [2321] = {.lex_state = 146},
  [2322] = {.lex_state = 178},
  [2323] = {.lex_state = 183, .external_lex_state = 1},
  [2324] = {.lex_state = 183, .external_lex_state = 1},
  [2325] = {.lex_state = 183, .external_lex_state = 1},
  [2326] = {.lex_state = 183, .external_lex_state = 1},
  [2327] = {.lex_state = 183, .external_lex_state = 1},
  [2328] = {.lex_state = 183, .external_lex_state = 1},
  [2329] = {.lex_state = 183, .external_lex_state = 1},
  [2330] = {.lex_state = 183, .external_lex_state = 1},
  [2331] = {.lex_state = 183, .external_lex_state = 1},
  [2332] = {.lex_state = 183, .external_lex_state = 1},
  [2333] = {.lex_state = 183, .external_lex_state = 1},
  [2334] = {.lex_state = 183, .external_lex_state = 1},
  [2335] = {.lex_state = 183, .external_lex_state = 1},
  [2336] = {.lex_state = 183, .external_lex_state = 1},
  [2337] = {.lex_state = 178},
  [2338] = {.lex_state = 132},
  [2339] = {.lex_state = 248},
  [2340] = {.lex_state = 248},
  [2341] = {.lex_state = 132},
  [2342] = {.lex_state = 178},
  [2343] = {.lex_state = 178},
  [2344] = {.lex_state = 178},
  [2345] = {.lex_state = 146},
  [2346] = {.lex_state = 225},
  [2347] = {.lex_state = 225},
  [2348] = {.lex_state = 178},
  [2349] = {.lex_state = 161, .external_lex_state = 1},
  [2350] = {.lex_state = 203},
  [2351] = {.lex_state = 209},
  [2352] = {.lex_state = 203},
  [2353] = {.lex_state = 203},
  [2354] = {.lex_state = 203},
  [2355] = {.lex_state = 232},
  [2356] = {.lex_state = 203},
  [2357] = {.lex_state = 203},
  [2358] = {.lex_state = 183, .external_lex_state = 1},
  [2359] = {.lex_state = 203},
  [2360] = {.lex_state = 203},
  [2361] = {.lex_state = 146},
  [2362] = {.lex_state = 203},
  [2363] = {.lex_state = 232},
  [2364] = {.lex_state = 232},
  [2365] = {.lex_state = 183, .external_lex_state = 1},
  [2366] = {.lex_state = 203},
  [2367] = {.lex_state = 218, .external_lex_state = 1},
  [2368] = {.lex_state = 183, .external_lex_state = 1},
  [2369] = {.lex_state = 208},
  [2370] = {.lex_state = 208},
  [2371] = {.lex_state = 173, .external_lex_state = 1},
  [2372] = {.lex_state = 208},
  [2373] = {.lex_state = 208},
  [2374] = {.lex_state = 184},
  [2375] = {.lex_state = 208},
  [2376] = {.lex_state = 208},
  [2377] = {.lex_state = 208},
  [2378] = {.lex_state = 208},
  [2379] = {.lex_state = 208},
  [2380] = {.lex_state = 208},
  [2381] = {.lex_state = 208},
  [2382] = {.lex_state = 208},
  [2383] = {.lex_state = 208},
  [2384] = {.lex_state = 208},
  [2385] = {.lex_state = 209},
  [2386] = {.lex_state = 225},
  [2387] = {.lex_state = 251},
  [2388] = {.lex_state = 251},
  [2389] = {.lex_state = 225},
  [2390] = {.lex_state = 251},
  [2391] = {.lex_state = 251},
  [2392] = {.lex_state = 225},
  [2393] = {.lex_state = 251},
  [2394] = {.lex_state = 251},
  [2395] = {.lex_state = 225},
  [2396] = {.lex_state = 209},
  [2397] = {.lex_state = 209},
  [2398] = {.lex_state = 184},
  [2399] = {.lex_state = 184},
  [2400] = {.lex_state = 209},
  [2401] = {.lex_state = 175},
  [2402] = {.lex_state = 175},
  [2403] = {.lex_state = 173},
  [2404] = {.lex_state = 173},
  [2405] = {.lex_state = 175},
  [2406] = {.lex_state = 175},
  [2407] = {.lex_state = 178},
  [2408] = {.lex_state = 175},
  [2409] = {.lex_state = 175},
  [2410] = {.lex_state = 178},
  [2411] = {.lex_state = 146},
  [2412] = {.lex_state = 132},
  [2413] = {.lex_state = 201},
  [2414] = {.lex_state = 178},
  [2415] = {.lex_state = 209},
  [2416] = {.lex_state = 207, .external_lex_state = 1},
  [2417] = {.lex_state = 208},
  [2418] = {.lex_state = 209},
  [2419] = {.lex_state = 201},
  [2420] = {.lex_state = 201},
  [2421] = {.lex_state = 201},
  [2422] = {.lex_state = 209},
  [2423] = {.lex_state = 201},
  [2424] = {.lex_state = 201},
  [2425] = {.lex_state = 209},
  [2426] = {.lex_state = 201},
  [2427] = {.lex_state = 201},
  [2428] = {.lex_state = 209},
  [2429] = {.lex_state = 201},
  [2430] = {.lex_state = 132},
  [2431] = {.lex_state = 132},
  [2432] = {.lex_state = 201},
  [2433] = {.lex_state = 175},
  [2434] = {.lex_state = 175},
  [2435] = {.lex_state = 203},
  [2436] = {.lex_state = 158},
  [2437] = {.lex_state = 203},
  [2438] = {.lex_state = 199, .external_lex_state = 1},
  [2439] = {.lex_state = 199, .external_lex_state = 1},
  [2440] = {.lex_state = 199, .external_lex_state = 1},
  [2441] = {.lex_state = 200},
  [2442] = {.lex_state = 199, .external_lex_state = 1},
  [2443] = {.lex_state = 218},
  [2444] = {.lex_state = 199, .external_lex_state = 1},
  [2445] = {.lex_state = 218},
  [2446] = {.lex_state = 215, .external_lex_state = 1},
  [2447] = {.lex_state = 192},
  [2448] = {.lex_state = 215, .external_lex_state = 1},
  [2449] = {.lex_state = 200},
  [2450] = {.lex_state = 158},
  [2451] = {.lex_state = 215, .external_lex_state = 1},
  [2452] = {.lex_state = 218},
  [2453] = {.lex_state = 199, .external_lex_state = 1},
  [2454] = {.lex_state = 215, .external_lex_state = 1},
  [2455] = {.lex_state = 218},
  [2456] = {.lex_state = 199, .external_lex_state = 1},
  [2457] = {.lex_state = 215, .external_lex_state = 1},
  [2458] = {.lex_state = 132},
  [2459] = {.lex_state = 146},
  [2460] = {.lex_state = 215, .external_lex_state = 1},
  [2461] = {.lex_state = 132},
  [2462] = {.lex_state = 215, .external_lex_state = 1},
  [2463] = {.lex_state = 203},
  [2464] = {.lex_state = 183, .external_lex_state = 1},
  [2465] = {.lex_state = 178},
  [2466] = {.lex_state = 215, .external_lex_state = 1},
  [2467] = {.lex_state = 183, .external_lex_state = 1},
  [2468] = {.lex_state = 195},
  [2469] = {.lex_state = 215, .external_lex_state = 1},
  [2470] = {.lex_state = 132},
  [2471] = {.lex_state = 215, .external_lex_state = 1},
  [2472] = {.lex_state = 132},
  [2473] = {.lex_state = 183, .external_lex_state = 1},
  [2474] = {.lex_state = 178},
  [2475] = {.lex_state = 184},
  [2476] = {.lex_state = 215, .external_lex_state = 1},
  [2477] = {.lex_state = 215, .external_lex_state = 1},
  [2478] = {.lex_state = 215, .external_lex_state = 1},
  [2479] = {.lex_state = 132},
  [2480] = {.lex_state = 215, .external_lex_state = 1},
  [2481] = {.lex_state = 215, .external_lex_state = 1},
  [2482] = {.lex_state = 132},
  [2483] = {.lex_state = 215, .external_lex_state = 1},
  [2484] = {.lex_state = 161, .external_lex_state = 1},
  [2485] = {.lex_state = 215, .external_lex_state = 1},
  [2486] = {.lex_state = 215, .external_lex_state = 1},
  [2487] = {.lex_state = 146},
  [2488] = {.lex_state = 178},
  [2489] = {.lex_state = 132},
  [2490] = {.lex_state = 132},
  [2491] = {.lex_state = 215, .external_lex_state = 1},
  [2492] = {.lex_state = 215, .external_lex_state = 1},
  [2493] = {.lex_state = 146, .external_lex_state = 1},
  [2494] = {.lex_state = 215, .external_lex_state = 1},
  [2495] = {.lex_state = 146},
  [2496] = {.lex_state = 183, .external_lex_state = 1},
  [2497] = {.lex_state = 132},
  [2498] = {.lex_state = 132},
  [2499] = {.lex_state = 132},
  [2500] = {.lex_state = 215, .external_lex_state = 1},
  [2501] = {.lex_state = 173},
  [2502] = {.lex_state = 218},
  [2503] = {.lex_state = 199, .external_lex_state = 1},
  [2504] = {.lex_state = 132},
  [2505] = {.lex_state = 183, .external_lex_state = 1},
  [2506] = {.lex_state = 203},
  [2507] = {.lex_state = 199, .external_lex_state = 1},
  [2508] = {.lex_state = 178},
  [2509] = {.lex_state = 183, .external_lex_state = 1},
  [2510] = {.lex_state = 199, .external_lex_state = 1},
  [2511] = {.lex_state = 214, .external_lex_state = 1},
  [2512] = {.lex_state = 178},
  [2513] = {.lex_state = 183, .external_lex_state = 1},
  [2514] = {.lex_state = 183, .external_lex_state = 1},
  [2515] = {.lex_state = 199, .external_lex_state = 1},
  [2516] = {.lex_state = 199, .external_lex_state = 1},
  [2517] = {.lex_state = 132},
  [2518] = {.lex_state = 199, .external_lex_state = 1},
  [2519] = {.lex_state = 132},
  [2520] = {.lex_state = 199, .external_lex_state = 1},
  [2521] = {.lex_state = 199, .external_lex_state = 1},
  [2522] = {.lex_state = 199, .external_lex_state = 1},
  [2523] = {.lex_state = 178},
  [2524] = {.lex_state = 132},
  [2525] = {.lex_state = 199, .external_lex_state = 1},
  [2526] = {.lex_state = 199, .external_lex_state = 1},
  [2527] = {.lex_state = 199, .external_lex_state = 1},
  [2528] = {.lex_state = 199, .external_lex_state = 1},
  [2529] = {.lex_state = 225},
  [2530] = {.lex_state = 146},
  [2531] = {.lex_state = 225},
  [2532] = {.lex_state = 225},
  [2533] = {.lex_state = 225},
  [2534] = {.lex_state = 225},
  [2535] = {.lex_state = 201},
  [2536] = {.lex_state = 201},
  [2537] = {.lex_state = 225},
  [2538] = {.lex_state = 225},
  [2539] = {.lex_state = 184},
  [2540] = {.lex_state = 207, .external_lex_state = 1},
  [2541] = {.lex_state = 208},
  [2542] = {.lex_state = 146, .external_lex_state = 1},
  [2543] = {.lex_state = 226, .external_lex_state = 1},
  [2544] = {.lex_state = 192},
  [2545] = {.lex_state = 226, .external_lex_state = 1},
  [2546] = {.lex_state = 200},
  [2547] = {.lex_state = 158},
  [2548] = {.lex_state = 226, .external_lex_state = 1},
  [2549] = {.lex_state = 218},
  [2550] = {.lex_state = 226, .external_lex_state = 1},
  [2551] = {.lex_state = 226, .external_lex_state = 1},
  [2552] = {.lex_state = 218},
  [2553] = {.lex_state = 226, .external_lex_state = 1},
  [2554] = {.lex_state = 192},
  [2555] = {.lex_state = 233, .external_lex_state = 1},
  [2556] = {.lex_state = 198},
  [2557] = {.lex_state = 226, .external_lex_state = 1},
  [2558] = {.lex_state = 226, .external_lex_state = 1},
  [2559] = {.lex_state = 233, .external_lex_state = 1},
  [2560] = {.lex_state = 200},
  [2561] = {.lex_state = 146},
  [2562] = {.lex_state = 146},
  [2563] = {.lex_state = 233, .external_lex_state = 1},
  [2564] = {.lex_state = 146, .external_lex_state = 1},
  [2565] = {.lex_state = 183, .external_lex_state = 1},
  [2566] = {.lex_state = 132},
  [2567] = {.lex_state = 183, .external_lex_state = 1},
  [2568] = {.lex_state = 184},
  [2569] = {.lex_state = 183, .external_lex_state = 1},
  [2570] = {.lex_state = 183, .external_lex_state = 1},
  [2571] = {.lex_state = 146},
  [2572] = {.lex_state = 183, .external_lex_state = 1},
  [2573] = {.lex_state = 233, .external_lex_state = 1},
  [2574] = {.lex_state = 178},
  [2575] = {.lex_state = 132},
  [2576] = {.lex_state = 233, .external_lex_state = 1},
  [2577] = {.lex_state = 233, .external_lex_state = 1},
  [2578] = {.lex_state = 132},
  [2579] = {.lex_state = 183, .external_lex_state = 1},
  [2580] = {.lex_state = 146},
  [2581] = {.lex_state = 233, .external_lex_state = 1},
  [2582] = {.lex_state = 178},
  [2583] = {.lex_state = 146},
  [2584] = {.lex_state = 173},
  [2585] = {.lex_state = 233, .external_lex_state = 1},
  [2586] = {.lex_state = 233, .external_lex_state = 1},
  [2587] = {.lex_state = 218},
  [2588] = {.lex_state = 226, .external_lex_state = 1},
  [2589] = {.lex_state = 226, .external_lex_state = 1},
  [2590] = {.lex_state = 132},
  [2591] = {.lex_state = 146},
  [2592] = {.lex_state = 226, .external_lex_state = 1},
  [2593] = {.lex_state = 203},
  [2594] = {.lex_state = 183, .external_lex_state = 1},
  [2595] = {.lex_state = 178},
  [2596] = {.lex_state = 226, .external_lex_state = 1},
  [2597] = {.lex_state = 183, .external_lex_state = 1},
  [2598] = {.lex_state = 195},
  [2599] = {.lex_state = 226, .external_lex_state = 1},
  [2600] = {.lex_state = 132},
  [2601] = {.lex_state = 226, .external_lex_state = 1},
  [2602] = {.lex_state = 132},
  [2603] = {.lex_state = 183, .external_lex_state = 1},
  [2604] = {.lex_state = 178},
  [2605] = {.lex_state = 184},
  [2606] = {.lex_state = 226, .external_lex_state = 1},
  [2607] = {.lex_state = 226, .external_lex_state = 1},
  [2608] = {.lex_state = 226, .external_lex_state = 1},
  [2609] = {.lex_state = 132},
  [2610] = {.lex_state = 226, .external_lex_state = 1},
  [2611] = {.lex_state = 226, .external_lex_state = 1},
  [2612] = {.lex_state = 146},
  [2613] = {.lex_state = 183, .external_lex_state = 1},
  [2614] = {.lex_state = 132},
  [2615] = {.lex_state = 146, .external_lex_state = 1},
  [2616] = {.lex_state = 146, .external_lex_state = 1},
  [2617] = {.lex_state = 146, .external_lex_state = 1},
  [2618] = {.lex_state = 146},
  [2619] = {.lex_state = 132},
  [2620] = {.lex_state = 183, .external_lex_state = 1},
  [2621] = {.lex_state = 184},
  [2622] = {.lex_state = 132},
  [2623] = {.lex_state = 132},
  [2624] = {.lex_state = 178},
  [2625] = {.lex_state = 132},
  [2626] = {.lex_state = 146, .external_lex_state = 1},
  [2627] = {.lex_state = 183, .external_lex_state = 1},
  [2628] = {.lex_state = 183, .external_lex_state = 1},
  [2629] = {.lex_state = 203},
  [2630] = {.lex_state = 214, .external_lex_state = 1},
  [2631] = {.lex_state = 178},
  [2632] = {.lex_state = 203},
  [2633] = {.lex_state = 146, .external_lex_state = 1},
  [2634] = {.lex_state = 146, .external_lex_state = 1},
  [2635] = {.lex_state = 203},
  [2636] = {.lex_state = 203},
  [2637] = {.lex_state = 252},
  [2638] = {.lex_state = 252},
  [2639] = {.lex_state = 253},
  [2640] = {.lex_state = 252},
  [2641] = {.lex_state = 252},
  [2642] = {.lex_state = 253},
  [2643] = {.lex_state = 252},
  [2644] = {.lex_state = 252},
  [2645] = {.lex_state = 253},
  [2646] = {.lex_state = 249},
  [2647] = {.lex_state = 249},
  [2648] = {.lex_state = 203},
  [2649] = {.lex_state = 203},
  [2650] = {.lex_state = 249},
  [2651] = {.lex_state = 203},
  [2652] = {.lex_state = 203},
  [2653] = {.lex_state = 201},
  [2654] = {.lex_state = 201},
  [2655] = {.lex_state = 178},
  [2656] = {.lex_state = 178},
  [2657] = {.lex_state = 201},
  [2658] = {.lex_state = 208},
  [2659] = {.lex_state = 208},
  [2660] = {.lex_state = 208},
  [2661] = {.lex_state = 175},
  [2662] = {.lex_state = 146},
  [2663] = {.lex_state = 234},
  [2664] = {.lex_state = 234},
  [2665] = {.lex_state = 242},
  [2666] = {.lex_state = 218},
  [2667] = {.lex_state = 234},
  [2668] = {.lex_state = 242},
  [2669] = {.lex_state = 218},
  [2670] = {.lex_state = 242},
  [2671] = {.lex_state = 132},
  [2672] = {.lex_state = 242},
  [2673] = {.lex_state = 242},
  [2674] = {.lex_state = 146, .external_lex_state = 1},
  [2675] = {.lex_state = 242},
  [2676] = {.lex_state = 146},
  [2677] = {.lex_state = 132},
  [2678] = {.lex_state = 242},
  [2679] = {.lex_state = 203},
  [2680] = {.lex_state = 132},
  [2681] = {.lex_state = 203},
  [2682] = {.lex_state = 184},
  [2683] = {.lex_state = 203},
  [2684] = {.lex_state = 225},
  [2685] = {.lex_state = 132},
  [2686] = {.lex_state = 242},
  [2687] = {.lex_state = 132},
  [2688] = {.lex_state = 132},
  [2689] = {.lex_state = 225},
  [2690] = {.lex_state = 207, .external_lex_state = 1},
  [2691] = {.lex_state = 184},
  [2692] = {.lex_state = 208},
  [2693] = {.lex_state = 207, .external_lex_state = 1},
  [2694] = {.lex_state = 178},
  [2695] = {.lex_state = 146},
  [2696] = {.lex_state = 225},
  [2697] = {.lex_state = 183, .external_lex_state = 1},
  [2698] = {.lex_state = 225},
  [2699] = {.lex_state = 146},
  [2700] = {.lex_state = 225},
  [2701] = {.lex_state = 225},
  [2702] = {.lex_state = 225},
  [2703] = {.lex_state = 242},
  [2704] = {.lex_state = 242},
  [2705] = {.lex_state = 242},
  [2706] = {.lex_state = 242},
  [2707] = {.lex_state = 175},
  [2708] = {.lex_state = 146},
  [2709] = {.lex_state = 175},
  [2710] = {.lex_state = 203, .external_lex_state = 1},
  [2711] = {.lex_state = 203},
  [2712] = {.lex_state = 208},
  [2713] = {.lex_state = 218, .external_lex_state = 1},
  [2714] = {.lex_state = 183, .external_lex_state = 1},
  [2715] = {.lex_state = 132},
  [2716] = {.lex_state = 183, .external_lex_state = 1},
  [2717] = {.lex_state = 184},
  [2718] = {.lex_state = 183, .external_lex_state = 1},
  [2719] = {.lex_state = 183, .external_lex_state = 1},
  [2720] = {.lex_state = 183, .external_lex_state = 1},
  [2721] = {.lex_state = 183, .external_lex_state = 1},
  [2722] = {.lex_state = 146},
  [2723] = {.lex_state = 183, .external_lex_state = 1},
  [2724] = {.lex_state = 183, .external_lex_state = 1},
  [2725] = {.lex_state = 132, .external_lex_state = 1},
  [2726] = {.lex_state = 184},
  [2727] = {.lex_state = 184},
  [2728] = {.lex_state = 184},
  [2729] = {.lex_state = 184},
  [2730] = {.lex_state = 243},
  [2731] = {.lex_state = 243},
  [2732] = {.lex_state = 146},
  [2733] = {.lex_state = 132},
  [2734] = {.lex_state = 183, .external_lex_state = 1},
  [2735] = {.lex_state = 184},
  [2736] = {.lex_state = 132},
  [2737] = {.lex_state = 132},
  [2738] = {.lex_state = 178},
  [2739] = {.lex_state = 132},
  [2740] = {.lex_state = 146},
  [2741] = {.lex_state = 183, .external_lex_state = 1},
  [2742] = {.lex_state = 183, .external_lex_state = 1},
  [2743] = {.lex_state = 203},
  [2744] = {.lex_state = 214, .external_lex_state = 1},
  [2745] = {.lex_state = 178},
  [2746] = {.lex_state = 203},
  [2747] = {.lex_state = 146},
  [2748] = {.lex_state = 161, .external_lex_state = 1},
  [2749] = {.lex_state = 161, .external_lex_state = 1},
  [2750] = {.lex_state = 183, .external_lex_state = 1},
  [2751] = {.lex_state = 183, .external_lex_state = 1},
  [2752] = {.lex_state = 203},
  [2753] = {.lex_state = 203},
  [2754] = {.lex_state = 225},
  [2755] = {.lex_state = 225},
  [2756] = {.lex_state = 214, .external_lex_state = 1},
  [2757] = {.lex_state = 183, .external_lex_state = 1},
  [2758] = {.lex_state = 244, .external_lex_state = 1},
  [2759] = {.lex_state = 178},
  [2760] = {.lex_state = 208},
  [2761] = {.lex_state = 218, .external_lex_state = 1},
  [2762] = {.lex_state = 183, .external_lex_state = 1},
  [2763] = {.lex_state = 211},
  [2764] = {.lex_state = 183, .external_lex_state = 1},
  [2765] = {.lex_state = 173},
  [2766] = {.lex_state = 178},
  [2767] = {.lex_state = 178},
  [2768] = {.lex_state = 178},
  [2769] = {.lex_state = 227},
  [2770] = {.lex_state = 227},
  [2771] = {.lex_state = 227},
  [2772] = {.lex_state = 227},
  [2773] = {.lex_state = 254, .external_lex_state = 1},
  [2774] = {.lex_state = 227},
  [2775] = {.lex_state = 183, .external_lex_state = 1},
  [2776] = {.lex_state = 146},
  [2777] = {.lex_state = 227},
  [2778] = {.lex_state = 210},
  [2779] = {.lex_state = 227},
  [2780] = {.lex_state = 210},
  [2781] = {.lex_state = 227},
  [2782] = {.lex_state = 146},
  [2783] = {.lex_state = 227},
  [2784] = {.lex_state = 146},
  [2785] = {.lex_state = 227},
  [2786] = {.lex_state = 227},
  [2787] = {.lex_state = 162},
  [2788] = {.lex_state = 227},
  [2789] = {.lex_state = 184},
  [2790] = {.lex_state = 132},
  [2791] = {.lex_state = 227},
  [2792] = {.lex_state = 132},
  [2793] = {.lex_state = 184},
  [2794] = {.lex_state = 227},
  [2795] = {.lex_state = 184},
  [2796] = {.lex_state = 132},
  [2797] = {.lex_state = 227},
  [2798] = {.lex_state = 132},
  [2799] = {.lex_state = 184},
  [2800] = {.lex_state = 227},
  [2801] = {.lex_state = 227},
  [2802] = {.lex_state = 184},
  [2803] = {.lex_state = 132},
  [2804] = {.lex_state = 227},
  [2805] = {.lex_state = 132},
  [2806] = {.lex_state = 184},
  [2807] = {.lex_state = 208},
  [2808] = {.lex_state = 227},
  [2809] = {.lex_state = 227},
  [2810] = {.lex_state = 227},
  [2811] = {.lex_state = 218, .external_lex_state = 1},
  [2812] = {.lex_state = 210},
  [2813] = {.lex_state = 229},
  [2814] = {.lex_state = 227},
  [2815] = {.lex_state = 229},
  [2816] = {.lex_state = 227},
  [2817] = {.lex_state = 227},
  [2818] = {.lex_state = 203},
  [2819] = {.lex_state = 227},
  [2820] = {.lex_state = 183, .external_lex_state = 1},
  [2821] = {.lex_state = 227},
  [2822] = {.lex_state = 227},
  [2823] = {.lex_state = 227},
  [2824] = {.lex_state = 146, .external_lex_state = 1},
  [2825] = {.lex_state = 146},
  [2826] = {.lex_state = 210},
  [2827] = {.lex_state = 210},
  [2828] = {.lex_state = 232},
  [2829] = {.lex_state = 227},
  [2830] = {.lex_state = 230},
  [2831] = {.lex_state = 227},
  [2832] = {.lex_state = 146},
  [2833] = {.lex_state = 227},
  [2834] = {.lex_state = 225},
  [2835] = {.lex_state = 225},
  [2836] = {.lex_state = 178},
  [2837] = {.lex_state = 178},
  [2838] = {.lex_state = 225},
  [2839] = {.lex_state = 183, .external_lex_state = 1},
  [2840] = {.lex_state = 203},
  [2841] = {.lex_state = 214, .external_lex_state = 1},
  [2842] = {.lex_state = 178},
  [2843] = {.lex_state = 183, .external_lex_state = 1},
  [2844] = {.lex_state = 183, .external_lex_state = 1},
  [2845] = {.lex_state = 161, .external_lex_state = 1},
  [2846] = {.lex_state = 132},
  [2847] = {.lex_state = 218},
  [2848] = {.lex_state = 132},
  [2849] = {.lex_state = 178},
  [2850] = {.lex_state = 146},
  [2851] = {.lex_state = 178},
  [2852] = {.lex_state = 132},
  [2853] = {.lex_state = 211},
  [2854] = {.lex_state = 146},
  [2855] = {.lex_state = 211},
  [2856] = {.lex_state = 211},
  [2857] = {.lex_state = 211},
  [2858] = {.lex_state = 211},
  [2859] = {.lex_state = 211},
  [2860] = {.lex_state = 211},
  [2861] = {.lex_state = 211},
  [2862] = {.lex_state = 183, .external_lex_state = 1},
  [2863] = {.lex_state = 203},
  [2864] = {.lex_state = 218, .external_lex_state = 1},
  [2865] = {.lex_state = 183, .external_lex_state = 1},
  [2866] = {.lex_state = 178},
  [2867] = {.lex_state = 178},
  [2868] = {.lex_state = 173, .external_lex_state = 1},
  [2869] = {.lex_state = 178},
  [2870] = {.lex_state = 178},
  [2871] = {.lex_state = 178},
  [2872] = {.lex_state = 184},
  [2873] = {.lex_state = 178},
  [2874] = {.lex_state = 178},
  [2875] = {.lex_state = 178},
  [2876] = {.lex_state = 178},
  [2877] = {.lex_state = 178},
  [2878] = {.lex_state = 178},
  [2879] = {.lex_state = 178},
  [2880] = {.lex_state = 178},
  [2881] = {.lex_state = 178},
  [2882] = {.lex_state = 178},
  [2883] = {.lex_state = 248},
  [2884] = {.lex_state = 248},
  [2885] = {.lex_state = 201},
  [2886] = {.lex_state = 201},
  [2887] = {.lex_state = 209},
  [2888] = {.lex_state = 201},
  [2889] = {.lex_state = 201},
  [2890] = {.lex_state = 209},
  [2891] = {.lex_state = 201},
  [2892] = {.lex_state = 201},
  [2893] = {.lex_state = 209},
  [2894] = {.lex_state = 225},
  [2895] = {.lex_state = 225},
  [2896] = {.lex_state = 178},
  [2897] = {.lex_state = 178},
  [2898] = {.lex_state = 225},
  [2899] = {.lex_state = 203},
  [2900] = {.lex_state = 203},
  [2901] = {.lex_state = 232},
  [2902] = {.lex_state = 203},
  [2903] = {.lex_state = 146},
  [2904] = {.lex_state = 203},
  [2905] = {.lex_state = 203},
  [2906] = {.lex_state = 146},
  [2907] = {.lex_state = 232},
  [2908] = {.lex_state = 249},
  [2909] = {.lex_state = 203},
  [2910] = {.lex_state = 208, .external_lex_state = 1},
  [2911] = {.lex_state = 208},
  [2912] = {.lex_state = 208},
  [2913] = {.lex_state = 218, .external_lex_state = 1},
  [2914] = {.lex_state = 183, .external_lex_state = 1},
  [2915] = {.lex_state = 184},
  [2916] = {.lex_state = 209},
  [2917] = {.lex_state = 184},
  [2918] = {.lex_state = 184},
  [2919] = {.lex_state = 184},
  [2920] = {.lex_state = 201},
  [2921] = {.lex_state = 209},
  [2922] = {.lex_state = 132},
  [2923] = {.lex_state = 201},
  [2924] = {.lex_state = 132},
  [2925] = {.lex_state = 199, .external_lex_state = 1},
  [2926] = {.lex_state = 199, .external_lex_state = 1},
  [2927] = {.lex_state = 199, .external_lex_state = 1},
  [2928] = {.lex_state = 215, .external_lex_state = 1},
  [2929] = {.lex_state = 215, .external_lex_state = 1},
  [2930] = {.lex_state = 215, .external_lex_state = 1},
  [2931] = {.lex_state = 200},
  [2932] = {.lex_state = 215, .external_lex_state = 1},
  [2933] = {.lex_state = 218},
  [2934] = {.lex_state = 215, .external_lex_state = 1},
  [2935] = {.lex_state = 218},
  [2936] = {.lex_state = 215, .external_lex_state = 1},
  [2937] = {.lex_state = 132},
  [2938] = {.lex_state = 183, .external_lex_state = 1},
  [2939] = {.lex_state = 203},
  [2940] = {.lex_state = 215, .external_lex_state = 1},
  [2941] = {.lex_state = 178},
  [2942] = {.lex_state = 183, .external_lex_state = 1},
  [2943] = {.lex_state = 215, .external_lex_state = 1},
  [2944] = {.lex_state = 214, .external_lex_state = 1},
  [2945] = {.lex_state = 178},
  [2946] = {.lex_state = 183, .external_lex_state = 1},
  [2947] = {.lex_state = 183, .external_lex_state = 1},
  [2948] = {.lex_state = 215, .external_lex_state = 1},
  [2949] = {.lex_state = 215, .external_lex_state = 1},
  [2950] = {.lex_state = 132},
  [2951] = {.lex_state = 215, .external_lex_state = 1},
  [2952] = {.lex_state = 132},
  [2953] = {.lex_state = 215, .external_lex_state = 1},
  [2954] = {.lex_state = 215, .external_lex_state = 1},
  [2955] = {.lex_state = 215, .external_lex_state = 1},
  [2956] = {.lex_state = 178},
  [2957] = {.lex_state = 132},
  [2958] = {.lex_state = 215, .external_lex_state = 1},
  [2959] = {.lex_state = 215, .external_lex_state = 1},
  [2960] = {.lex_state = 215, .external_lex_state = 1},
  [2961] = {.lex_state = 215, .external_lex_state = 1},
  [2962] = {.lex_state = 199, .external_lex_state = 1},
  [2963] = {.lex_state = 146},
  [2964] = {.lex_state = 132},
  [2965] = {.lex_state = 183, .external_lex_state = 1},
  [2966] = {.lex_state = 184},
  [2967] = {.lex_state = 132},
  [2968] = {.lex_state = 132},
  [2969] = {.lex_state = 178},
  [2970] = {.lex_state = 132},
  [2971] = {.lex_state = 199, .external_lex_state = 1},
  [2972] = {.lex_state = 183, .external_lex_state = 1},
  [2973] = {.lex_state = 203},
  [2974] = {.lex_state = 203},
  [2975] = {.lex_state = 183, .external_lex_state = 1},
  [2976] = {.lex_state = 203},
  [2977] = {.lex_state = 214, .external_lex_state = 1},
  [2978] = {.lex_state = 178},
  [2979] = {.lex_state = 203},
  [2980] = {.lex_state = 199, .external_lex_state = 1},
  [2981] = {.lex_state = 199, .external_lex_state = 1},
  [2982] = {.lex_state = 199, .external_lex_state = 1},
  [2983] = {.lex_state = 225},
  [2984] = {.lex_state = 184},
  [2985] = {.lex_state = 226, .external_lex_state = 1},
  [2986] = {.lex_state = 226, .external_lex_state = 1},
  [2987] = {.lex_state = 226, .external_lex_state = 1},
  [2988] = {.lex_state = 200},
  [2989] = {.lex_state = 226, .external_lex_state = 1},
  [2990] = {.lex_state = 218},
  [2991] = {.lex_state = 226, .external_lex_state = 1},
  [2992] = {.lex_state = 218},
  [2993] = {.lex_state = 233, .external_lex_state = 1},
  [2994] = {.lex_state = 192},
  [2995] = {.lex_state = 233, .external_lex_state = 1},
  [2996] = {.lex_state = 200},
  [2997] = {.lex_state = 158},
  [2998] = {.lex_state = 233, .external_lex_state = 1},
  [2999] = {.lex_state = 218},
  [3000] = {.lex_state = 226, .external_lex_state = 1},
  [3001] = {.lex_state = 233, .external_lex_state = 1},
  [3002] = {.lex_state = 218},
  [3003] = {.lex_state = 226, .external_lex_state = 1},
  [3004] = {.lex_state = 233, .external_lex_state = 1},
  [3005] = {.lex_state = 132},
  [3006] = {.lex_state = 146},
  [3007] = {.lex_state = 233, .external_lex_state = 1},
  [3008] = {.lex_state = 203},
  [3009] = {.lex_state = 183, .external_lex_state = 1},
  [3010] = {.lex_state = 178},
  [3011] = {.lex_state = 233, .external_lex_state = 1},
  [3012] = {.lex_state = 183, .external_lex_state = 1},
  [3013] = {.lex_state = 195},
  [3014] = {.lex_state = 233, .external_lex_state = 1},
  [3015] = {.lex_state = 132},
  [3016] = {.lex_state = 233, .external_lex_state = 1},
  [3017] = {.lex_state = 132},
  [3018] = {.lex_state = 183, .external_lex_state = 1},
  [3019] = {.lex_state = 178},
  [3020] = {.lex_state = 184},
  [3021] = {.lex_state = 233, .external_lex_state = 1},
  [3022] = {.lex_state = 233, .external_lex_state = 1},
  [3023] = {.lex_state = 233, .external_lex_state = 1},
  [3024] = {.lex_state = 132},
  [3025] = {.lex_state = 233, .external_lex_state = 1},
  [3026] = {.lex_state = 233, .external_lex_state = 1},
  [3027] = {.lex_state = 146},
  [3028] = {.lex_state = 183, .external_lex_state = 1},
  [3029] = {.lex_state = 132},
  [3030] = {.lex_state = 218},
  [3031] = {.lex_state = 226, .external_lex_state = 1},
  [3032] = {.lex_state = 132},
  [3033] = {.lex_state = 183, .external_lex_state = 1},
  [3034] = {.lex_state = 203},
  [3035] = {.lex_state = 226, .external_lex_state = 1},
  [3036] = {.lex_state = 183, .external_lex_state = 1},
  [3037] = {.lex_state = 226, .external_lex_state = 1},
  [3038] = {.lex_state = 214, .external_lex_state = 1},
  [3039] = {.lex_state = 178},
  [3040] = {.lex_state = 183, .external_lex_state = 1},
  [3041] = {.lex_state = 183, .external_lex_state = 1},
  [3042] = {.lex_state = 132},
  [3043] = {.lex_state = 226, .external_lex_state = 1},
  [3044] = {.lex_state = 226, .external_lex_state = 1},
  [3045] = {.lex_state = 178},
  [3046] = {.lex_state = 132},
  [3047] = {.lex_state = 226, .external_lex_state = 1},
  [3048] = {.lex_state = 183, .external_lex_state = 1},
  [3049] = {.lex_state = 132},
  [3050] = {.lex_state = 183, .external_lex_state = 1},
  [3051] = {.lex_state = 184},
  [3052] = {.lex_state = 183, .external_lex_state = 1},
  [3053] = {.lex_state = 183, .external_lex_state = 1},
  [3054] = {.lex_state = 183, .external_lex_state = 1},
  [3055] = {.lex_state = 183, .external_lex_state = 1},
  [3056] = {.lex_state = 146},
  [3057] = {.lex_state = 183, .external_lex_state = 1},
  [3058] = {.lex_state = 146, .external_lex_state = 1},
  [3059] = {.lex_state = 146, .external_lex_state = 1},
  [3060] = {.lex_state = 183, .external_lex_state = 1},
  [3061] = {.lex_state = 203},
  [3062] = {.lex_state = 203},
  [3063] = {.lex_state = 214, .external_lex_state = 1},
  [3064] = {.lex_state = 183, .external_lex_state = 1},
  [3065] = {.lex_state = 203},
  [3066] = {.lex_state = 249},
  [3067] = {.lex_state = 203},
  [3068] = {.lex_state = 203},
  [3069] = {.lex_state = 203},
  [3070] = {.lex_state = 178},
  [3071] = {.lex_state = 201},
  [3072] = {.lex_state = 178},
  [3073] = {.lex_state = 178},
  [3074] = {.lex_state = 178},
  [3075] = {.lex_state = 234},
  [3076] = {.lex_state = 218},
  [3077] = {.lex_state = 234},
  [3078] = {.lex_state = 242},
  [3079] = {.lex_state = 242},
  [3080] = {.lex_state = 242},
  [3081] = {.lex_state = 242},
  [3082] = {.lex_state = 242},
  [3083] = {.lex_state = 242},
  [3084] = {.lex_state = 203},
  [3085] = {.lex_state = 203},
  [3086] = {.lex_state = 225},
  [3087] = {.lex_state = 132},
  [3088] = {.lex_state = 225},
  [3089] = {.lex_state = 225},
  [3090] = {.lex_state = 184},
  [3091] = {.lex_state = 207, .external_lex_state = 1},
  [3092] = {.lex_state = 208},
  [3093] = {.lex_state = 242},
  [3094] = {.lex_state = 146},
  [3095] = {.lex_state = 225},
  [3096] = {.lex_state = 225},
  [3097] = {.lex_state = 225},
  [3098] = {.lex_state = 178},
  [3099] = {.lex_state = 225},
  [3100] = {.lex_state = 225},
  [3101] = {.lex_state = 225},
  [3102] = {.lex_state = 225},
  [3103] = {.lex_state = 225},
  [3104] = {.lex_state = 203},
  [3105] = {.lex_state = 203},
  [3106] = {.lex_state = 203},
  [3107] = {.lex_state = 183, .external_lex_state = 1},
  [3108] = {.lex_state = 183, .external_lex_state = 1},
  [3109] = {.lex_state = 195},
  [3110] = {.lex_state = 183, .external_lex_state = 1},
  [3111] = {.lex_state = 178},
  [3112] = {.lex_state = 184},
  [3113] = {.lex_state = 132, .external_lex_state = 1},
  [3114] = {.lex_state = 161, .external_lex_state = 1},
  [3115] = {.lex_state = 203},
  [3116] = {.lex_state = 183, .external_lex_state = 1},
  [3117] = {.lex_state = 183, .external_lex_state = 1},
  [3118] = {.lex_state = 132},
  [3119] = {.lex_state = 183, .external_lex_state = 1},
  [3120] = {.lex_state = 184},
  [3121] = {.lex_state = 183, .external_lex_state = 1},
  [3122] = {.lex_state = 183, .external_lex_state = 1},
  [3123] = {.lex_state = 183, .external_lex_state = 1},
  [3124] = {.lex_state = 183, .external_lex_state = 1},
  [3125] = {.lex_state = 146},
  [3126] = {.lex_state = 183, .external_lex_state = 1},
  [3127] = {.lex_state = 146},
  [3128] = {.lex_state = 146},
  [3129] = {.lex_state = 183, .external_lex_state = 1},
  [3130] = {.lex_state = 203},
  [3131] = {.lex_state = 203},
  [3132] = {.lex_state = 214, .external_lex_state = 1},
  [3133] = {.lex_state = 183, .external_lex_state = 1},
  [3134] = {.lex_state = 203},
  [3135] = {.lex_state = 161, .external_lex_state = 1},
  [3136] = {.lex_state = 183, .external_lex_state = 1},
  [3137] = {.lex_state = 203},
  [3138] = {.lex_state = 203},
  [3139] = {.lex_state = 203},
  [3140] = {.lex_state = 161, .external_lex_state = 1},
  [3141] = {.lex_state = 178},
  [3142] = {.lex_state = 178},
  [3143] = {.lex_state = 178},
  [3144] = {.lex_state = 227},
  [3145] = {.lex_state = 183, .external_lex_state = 1},
  [3146] = {.lex_state = 227},
  [3147] = {.lex_state = 227},
  [3148] = {.lex_state = 227},
  [3149] = {.lex_state = 146},
  [3150] = {.lex_state = 146},
  [3151] = {.lex_state = 227},
  [3152] = {.lex_state = 227},
  [3153] = {.lex_state = 132},
  [3154] = {.lex_state = 227},
  [3155] = {.lex_state = 132},
  [3156] = {.lex_state = 227},
  [3157] = {.lex_state = 132},
  [3158] = {.lex_state = 227},
  [3159] = {.lex_state = 132},
  [3160] = {.lex_state = 227},
  [3161] = {.lex_state = 132},
  [3162] = {.lex_state = 227},
  [3163] = {.lex_state = 132},
  [3164] = {.lex_state = 227},
  [3165] = {.lex_state = 227},
  [3166] = {.lex_state = 227},
  [3167] = {.lex_state = 210},
  [3168] = {.lex_state = 227},
  [3169] = {.lex_state = 227},
  [3170] = {.lex_state = 227},
  [3171] = {.lex_state = 210},
  [3172] = {.lex_state = 232},
  [3173] = {.lex_state = 146},
  [3174] = {.lex_state = 229},
  [3175] = {.lex_state = 229},
  [3176] = {.lex_state = 227},
  [3177] = {.lex_state = 178},
  [3178] = {.lex_state = 225},
  [3179] = {.lex_state = 178},
  [3180] = {.lex_state = 178},
  [3181] = {.lex_state = 178},
  [3182] = {.lex_state = 146},
  [3183] = {.lex_state = 132},
  [3184] = {.lex_state = 183, .external_lex_state = 1},
  [3185] = {.lex_state = 184},
  [3186] = {.lex_state = 132},
  [3187] = {.lex_state = 132},
  [3188] = {.lex_state = 178},
  [3189] = {.lex_state = 132},
  [3190] = {.lex_state = 161, .external_lex_state = 1},
  [3191] = {.lex_state = 183, .external_lex_state = 1},
  [3192] = {.lex_state = 183, .external_lex_state = 1},
  [3193] = {.lex_state = 203},
  [3194] = {.lex_state = 214, .external_lex_state = 1},
  [3195] = {.lex_state = 178},
  [3196] = {.lex_state = 203},
  [3197] = {.lex_state = 132},
  [3198] = {.lex_state = 218},
  [3199] = {.lex_state = 178},
  [3200] = {.lex_state = 132},
  [3201] = {.lex_state = 178},
  [3202] = {.lex_state = 211},
  [3203] = {.lex_state = 244, .external_lex_state = 1},
  [3204] = {.lex_state = 178},
  [3205] = {.lex_state = 208},
  [3206] = {.lex_state = 218, .external_lex_state = 1},
  [3207] = {.lex_state = 183, .external_lex_state = 1},
  [3208] = {.lex_state = 178},
  [3209] = {.lex_state = 225},
  [3210] = {.lex_state = 178},
  [3211] = {.lex_state = 178},
  [3212] = {.lex_state = 178},
  [3213] = {.lex_state = 146},
  [3214] = {.lex_state = 249},
  [3215] = {.lex_state = 249},
  [3216] = {.lex_state = 203},
  [3217] = {.lex_state = 249},
  [3218] = {.lex_state = 232},
  [3219] = {.lex_state = 203},
  [3220] = {.lex_state = 249},
  [3221] = {.lex_state = 208},
  [3222] = {.lex_state = 208},
  [3223] = {.lex_state = 208},
  [3224] = {.lex_state = 184},
  [3225] = {.lex_state = 209},
  [3226] = {.lex_state = 184},
  [3227] = {.lex_state = 184},
  [3228] = {.lex_state = 132},
  [3229] = {.lex_state = 201},
  [3230] = {.lex_state = 215, .external_lex_state = 1},
  [3231] = {.lex_state = 215, .external_lex_state = 1},
  [3232] = {.lex_state = 215, .external_lex_state = 1},
  [3233] = {.lex_state = 215, .external_lex_state = 1},
  [3234] = {.lex_state = 146},
  [3235] = {.lex_state = 132},
  [3236] = {.lex_state = 183, .external_lex_state = 1},
  [3237] = {.lex_state = 184},
  [3238] = {.lex_state = 132},
  [3239] = {.lex_state = 132},
  [3240] = {.lex_state = 178},
  [3241] = {.lex_state = 132},
  [3242] = {.lex_state = 215, .external_lex_state = 1},
  [3243] = {.lex_state = 183, .external_lex_state = 1},
  [3244] = {.lex_state = 203},
  [3245] = {.lex_state = 203},
  [3246] = {.lex_state = 183, .external_lex_state = 1},
  [3247] = {.lex_state = 203},
  [3248] = {.lex_state = 214, .external_lex_state = 1},
  [3249] = {.lex_state = 178},
  [3250] = {.lex_state = 203},
  [3251] = {.lex_state = 215, .external_lex_state = 1},
  [3252] = {.lex_state = 215, .external_lex_state = 1},
  [3253] = {.lex_state = 215, .external_lex_state = 1},
  [3254] = {.lex_state = 183, .external_lex_state = 1},
  [3255] = {.lex_state = 132},
  [3256] = {.lex_state = 183, .external_lex_state = 1},
  [3257] = {.lex_state = 184},
  [3258] = {.lex_state = 183, .external_lex_state = 1},
  [3259] = {.lex_state = 183, .external_lex_state = 1},
  [3260] = {.lex_state = 183, .external_lex_state = 1},
  [3261] = {.lex_state = 183, .external_lex_state = 1},
  [3262] = {.lex_state = 146},
  [3263] = {.lex_state = 183, .external_lex_state = 1},
  [3264] = {.lex_state = 199, .external_lex_state = 1},
  [3265] = {.lex_state = 199, .external_lex_state = 1},
  [3266] = {.lex_state = 199, .external_lex_state = 1},
  [3267] = {.lex_state = 183, .external_lex_state = 1},
  [3268] = {.lex_state = 203},
  [3269] = {.lex_state = 203},
  [3270] = {.lex_state = 214, .external_lex_state = 1},
  [3271] = {.lex_state = 183, .external_lex_state = 1},
  [3272] = {.lex_state = 226, .external_lex_state = 1},
  [3273] = {.lex_state = 226, .external_lex_state = 1},
  [3274] = {.lex_state = 226, .external_lex_state = 1},
  [3275] = {.lex_state = 233, .external_lex_state = 1},
  [3276] = {.lex_state = 233, .external_lex_state = 1},
  [3277] = {.lex_state = 233, .external_lex_state = 1},
  [3278] = {.lex_state = 200},
  [3279] = {.lex_state = 233, .external_lex_state = 1},
  [3280] = {.lex_state = 218},
  [3281] = {.lex_state = 233, .external_lex_state = 1},
  [3282] = {.lex_state = 218},
  [3283] = {.lex_state = 233, .external_lex_state = 1},
  [3284] = {.lex_state = 132},
  [3285] = {.lex_state = 183, .external_lex_state = 1},
  [3286] = {.lex_state = 203},
  [3287] = {.lex_state = 233, .external_lex_state = 1},
  [3288] = {.lex_state = 183, .external_lex_state = 1},
  [3289] = {.lex_state = 233, .external_lex_state = 1},
  [3290] = {.lex_state = 214, .external_lex_state = 1},
  [3291] = {.lex_state = 178},
  [3292] = {.lex_state = 183, .external_lex_state = 1},
  [3293] = {.lex_state = 183, .external_lex_state = 1},
  [3294] = {.lex_state = 132},
  [3295] = {.lex_state = 233, .external_lex_state = 1},
  [3296] = {.lex_state = 233, .external_lex_state = 1},
  [3297] = {.lex_state = 178},
  [3298] = {.lex_state = 132},
  [3299] = {.lex_state = 233, .external_lex_state = 1},
  [3300] = {.lex_state = 226, .external_lex_state = 1},
  [3301] = {.lex_state = 146},
  [3302] = {.lex_state = 132},
  [3303] = {.lex_state = 183, .external_lex_state = 1},
  [3304] = {.lex_state = 184},
  [3305] = {.lex_state = 132},
  [3306] = {.lex_state = 132},
  [3307] = {.lex_state = 178},
  [3308] = {.lex_state = 132},
  [3309] = {.lex_state = 226, .external_lex_state = 1},
  [3310] = {.lex_state = 183, .external_lex_state = 1},
  [3311] = {.lex_state = 203},
  [3312] = {.lex_state = 203},
  [3313] = {.lex_state = 183, .external_lex_state = 1},
  [3314] = {.lex_state = 203},
  [3315] = {.lex_state = 214, .external_lex_state = 1},
  [3316] = {.lex_state = 178},
  [3317] = {.lex_state = 203},
  [3318] = {.lex_state = 226, .external_lex_state = 1},
  [3319] = {.lex_state = 226, .external_lex_state = 1},
  [3320] = {.lex_state = 203},
  [3321] = {.lex_state = 183, .external_lex_state = 1},
  [3322] = {.lex_state = 183, .external_lex_state = 1},
  [3323] = {.lex_state = 195},
  [3324] = {.lex_state = 183, .external_lex_state = 1},
  [3325] = {.lex_state = 178},
  [3326] = {.lex_state = 184},
  [3327] = {.lex_state = 146, .external_lex_state = 1},
  [3328] = {.lex_state = 146, .external_lex_state = 1},
  [3329] = {.lex_state = 183, .external_lex_state = 1},
  [3330] = {.lex_state = 146, .external_lex_state = 1},
  [3331] = {.lex_state = 183, .external_lex_state = 1},
  [3332] = {.lex_state = 203},
  [3333] = {.lex_state = 203},
  [3334] = {.lex_state = 146, .external_lex_state = 1},
  [3335] = {.lex_state = 203},
  [3336] = {.lex_state = 249},
  [3337] = {.lex_state = 203},
  [3338] = {.lex_state = 203},
  [3339] = {.lex_state = 178},
  [3340] = {.lex_state = 201},
  [3341] = {.lex_state = 178},
  [3342] = {.lex_state = 178},
  [3343] = {.lex_state = 218},
  [3344] = {.lex_state = 225},
  [3345] = {.lex_state = 146},
  [3346] = {.lex_state = 225},
  [3347] = {.lex_state = 184},
  [3348] = {.lex_state = 225},
  [3349] = {.lex_state = 225},
  [3350] = {.lex_state = 225},
  [3351] = {.lex_state = 225},
  [3352] = {.lex_state = 225},
  [3353] = {.lex_state = 242},
  [3354] = {.lex_state = 225},
  [3355] = {.lex_state = 225},
  [3356] = {.lex_state = 225},
  [3357] = {.lex_state = 225},
  [3358] = {.lex_state = 225},
  [3359] = {.lex_state = 183, .external_lex_state = 1},
  [3360] = {.lex_state = 203},
  [3361] = {.lex_state = 214, .external_lex_state = 1},
  [3362] = {.lex_state = 178},
  [3363] = {.lex_state = 183, .external_lex_state = 1},
  [3364] = {.lex_state = 183, .external_lex_state = 1},
  [3365] = {.lex_state = 132, .external_lex_state = 1},
  [3366] = {.lex_state = 161, .external_lex_state = 1},
  [3367] = {.lex_state = 203},
  [3368] = {.lex_state = 183, .external_lex_state = 1},
  [3369] = {.lex_state = 183, .external_lex_state = 1},
  [3370] = {.lex_state = 195},
  [3371] = {.lex_state = 183, .external_lex_state = 1},
  [3372] = {.lex_state = 178},
  [3373] = {.lex_state = 184},
  [3374] = {.lex_state = 146},
  [3375] = {.lex_state = 146},
  [3376] = {.lex_state = 183, .external_lex_state = 1},
  [3377] = {.lex_state = 146},
  [3378] = {.lex_state = 183, .external_lex_state = 1},
  [3379] = {.lex_state = 203},
  [3380] = {.lex_state = 203},
  [3381] = {.lex_state = 146},
  [3382] = {.lex_state = 161, .external_lex_state = 1},
  [3383] = {.lex_state = 183, .external_lex_state = 1},
  [3384] = {.lex_state = 203},
  [3385] = {.lex_state = 227},
  [3386] = {.lex_state = 227},
  [3387] = {.lex_state = 146},
  [3388] = {.lex_state = 227},
  [3389] = {.lex_state = 227},
  [3390] = {.lex_state = 227},
  [3391] = {.lex_state = 227},
  [3392] = {.lex_state = 227},
  [3393] = {.lex_state = 227},
  [3394] = {.lex_state = 227},
  [3395] = {.lex_state = 229},
  [3396] = {.lex_state = 229},
  [3397] = {.lex_state = 227},
  [3398] = {.lex_state = 227},
  [3399] = {.lex_state = 229},
  [3400] = {.lex_state = 178},
  [3401] = {.lex_state = 225},
  [3402] = {.lex_state = 178},
  [3403] = {.lex_state = 178},
  [3404] = {.lex_state = 183, .external_lex_state = 1},
  [3405] = {.lex_state = 132},
  [3406] = {.lex_state = 183, .external_lex_state = 1},
  [3407] = {.lex_state = 184},
  [3408] = {.lex_state = 183, .external_lex_state = 1},
  [3409] = {.lex_state = 183, .external_lex_state = 1},
  [3410] = {.lex_state = 183, .external_lex_state = 1},
  [3411] = {.lex_state = 183, .external_lex_state = 1},
  [3412] = {.lex_state = 146},
  [3413] = {.lex_state = 183, .external_lex_state = 1},
  [3414] = {.lex_state = 161, .external_lex_state = 1},
  [3415] = {.lex_state = 183, .external_lex_state = 1},
  [3416] = {.lex_state = 203},
  [3417] = {.lex_state = 203},
  [3418] = {.lex_state = 214, .external_lex_state = 1},
  [3419] = {.lex_state = 183, .external_lex_state = 1},
  [3420] = {.lex_state = 132},
  [3421] = {.lex_state = 178},
  [3422] = {.lex_state = 178},
  [3423] = {.lex_state = 178},
  [3424] = {.lex_state = 178},
  [3425] = {.lex_state = 225},
  [3426] = {.lex_state = 178},
  [3427] = {.lex_state = 178},
  [3428] = {.lex_state = 249},
  [3429] = {.lex_state = 249},
  [3430] = {.lex_state = 203},
  [3431] = {.lex_state = 203},
  [3432] = {.lex_state = 249},
  [3433] = {.lex_state = 249},
  [3434] = {.lex_state = 183, .external_lex_state = 1},
  [3435] = {.lex_state = 132},
  [3436] = {.lex_state = 183, .external_lex_state = 1},
  [3437] = {.lex_state = 184},
  [3438] = {.lex_state = 183, .external_lex_state = 1},
  [3439] = {.lex_state = 183, .external_lex_state = 1},
  [3440] = {.lex_state = 183, .external_lex_state = 1},
  [3441] = {.lex_state = 183, .external_lex_state = 1},
  [3442] = {.lex_state = 146},
  [3443] = {.lex_state = 183, .external_lex_state = 1},
  [3444] = {.lex_state = 215, .external_lex_state = 1},
  [3445] = {.lex_state = 215, .external_lex_state = 1},
  [3446] = {.lex_state = 215, .external_lex_state = 1},
  [3447] = {.lex_state = 183, .external_lex_state = 1},
  [3448] = {.lex_state = 203},
  [3449] = {.lex_state = 203},
  [3450] = {.lex_state = 214, .external_lex_state = 1},
  [3451] = {.lex_state = 183, .external_lex_state = 1},
  [3452] = {.lex_state = 203},
  [3453] = {.lex_state = 183, .external_lex_state = 1},
  [3454] = {.lex_state = 183, .external_lex_state = 1},
  [3455] = {.lex_state = 195},
  [3456] = {.lex_state = 183, .external_lex_state = 1},
  [3457] = {.lex_state = 178},
  [3458] = {.lex_state = 184},
  [3459] = {.lex_state = 199, .external_lex_state = 1},
  [3460] = {.lex_state = 199, .external_lex_state = 1},
  [3461] = {.lex_state = 183, .external_lex_state = 1},
  [3462] = {.lex_state = 199, .external_lex_state = 1},
  [3463] = {.lex_state = 183, .external_lex_state = 1},
  [3464] = {.lex_state = 203},
  [3465] = {.lex_state = 203},
  [3466] = {.lex_state = 199, .external_lex_state = 1},
  [3467] = {.lex_state = 233, .external_lex_state = 1},
  [3468] = {.lex_state = 233, .external_lex_state = 1},
  [3469] = {.lex_state = 233, .external_lex_state = 1},
  [3470] = {.lex_state = 233, .external_lex_state = 1},
  [3471] = {.lex_state = 146},
  [3472] = {.lex_state = 132},
  [3473] = {.lex_state = 183, .external_lex_state = 1},
  [3474] = {.lex_state = 184},
  [3475] = {.lex_state = 132},
  [3476] = {.lex_state = 132},
  [3477] = {.lex_state = 178},
  [3478] = {.lex_state = 132},
  [3479] = {.lex_state = 233, .external_lex_state = 1},
  [3480] = {.lex_state = 183, .external_lex_state = 1},
  [3481] = {.lex_state = 203},
  [3482] = {.lex_state = 203},
  [3483] = {.lex_state = 183, .external_lex_state = 1},
  [3484] = {.lex_state = 203},
  [3485] = {.lex_state = 214, .external_lex_state = 1},
  [3486] = {.lex_state = 178},
  [3487] = {.lex_state = 203},
  [3488] = {.lex_state = 233, .external_lex_state = 1},
  [3489] = {.lex_state = 233, .external_lex_state = 1},
  [3490] = {.lex_state = 183, .external_lex_state = 1},
  [3491] = {.lex_state = 132},
  [3492] = {.lex_state = 183, .external_lex_state = 1},
  [3493] = {.lex_state = 184},
  [3494] = {.lex_state = 183, .external_lex_state = 1},
  [3495] = {.lex_state = 183, .external_lex_state = 1},
  [3496] = {.lex_state = 183, .external_lex_state = 1},
  [3497] = {.lex_state = 183, .external_lex_state = 1},
  [3498] = {.lex_state = 146},
  [3499] = {.lex_state = 183, .external_lex_state = 1},
  [3500] = {.lex_state = 226, .external_lex_state = 1},
  [3501] = {.lex_state = 226, .external_lex_state = 1},
  [3502] = {.lex_state = 226, .external_lex_state = 1},
  [3503] = {.lex_state = 183, .external_lex_state = 1},
  [3504] = {.lex_state = 203},
  [3505] = {.lex_state = 203},
  [3506] = {.lex_state = 214, .external_lex_state = 1},
  [3507] = {.lex_state = 183, .external_lex_state = 1},
  [3508] = {.lex_state = 183, .external_lex_state = 1},
  [3509] = {.lex_state = 203},
  [3510] = {.lex_state = 214, .external_lex_state = 1},
  [3511] = {.lex_state = 178},
  [3512] = {.lex_state = 183, .external_lex_state = 1},
  [3513] = {.lex_state = 183, .external_lex_state = 1},
  [3514] = {.lex_state = 146, .external_lex_state = 1},
  [3515] = {.lex_state = 146, .external_lex_state = 1},
  [3516] = {.lex_state = 146, .external_lex_state = 1},
  [3517] = {.lex_state = 183, .external_lex_state = 1},
  [3518] = {.lex_state = 203},
  [3519] = {.lex_state = 178},
  [3520] = {.lex_state = 178},
  [3521] = {.lex_state = 178},
  [3522] = {.lex_state = 146},
  [3523] = {.lex_state = 225},
  [3524] = {.lex_state = 225},
  [3525] = {.lex_state = 225},
  [3526] = {.lex_state = 225},
  [3527] = {.lex_state = 225},
  [3528] = {.lex_state = 225},
  [3529] = {.lex_state = 225},
  [3530] = {.lex_state = 225},
  [3531] = {.lex_state = 225},
  [3532] = {.lex_state = 225},
  [3533] = {.lex_state = 225},
  [3534] = {.lex_state = 225},
  [3535] = {.lex_state = 132, .external_lex_state = 1},
  [3536] = {.lex_state = 183, .external_lex_state = 1},
  [3537] = {.lex_state = 183, .external_lex_state = 1},
  [3538] = {.lex_state = 203},
  [3539] = {.lex_state = 214, .external_lex_state = 1},
  [3540] = {.lex_state = 178},
  [3541] = {.lex_state = 203},
  [3542] = {.lex_state = 183, .external_lex_state = 1},
  [3543] = {.lex_state = 203},
  [3544] = {.lex_state = 214, .external_lex_state = 1},
  [3545] = {.lex_state = 178},
  [3546] = {.lex_state = 183, .external_lex_state = 1},
  [3547] = {.lex_state = 183, .external_lex_state = 1},
  [3548] = {.lex_state = 146},
  [3549] = {.lex_state = 146},
  [3550] = {.lex_state = 146},
  [3551] = {.lex_state = 183, .external_lex_state = 1},
  [3552] = {.lex_state = 203},
  [3553] = {.lex_state = 161, .external_lex_state = 1},
  [3554] = {.lex_state = 183, .external_lex_state = 1},
  [3555] = {.lex_state = 227},
  [3556] = {.lex_state = 227},
  [3557] = {.lex_state = 229},
  [3558] = {.lex_state = 227},
  [3559] = {.lex_state = 227},
  [3560] = {.lex_state = 227},
  [3561] = {.lex_state = 203},
  [3562] = {.lex_state = 183, .external_lex_state = 1},
  [3563] = {.lex_state = 183, .external_lex_state = 1},
  [3564] = {.lex_state = 195},
  [3565] = {.lex_state = 183, .external_lex_state = 1},
  [3566] = {.lex_state = 178},
  [3567] = {.lex_state = 184},
  [3568] = {.lex_state = 161, .external_lex_state = 1},
  [3569] = {.lex_state = 183, .external_lex_state = 1},
  [3570] = {.lex_state = 183, .external_lex_state = 1},
  [3571] = {.lex_state = 203},
  [3572] = {.lex_state = 203},
  [3573] = {.lex_state = 203},
  [3574] = {.lex_state = 249},
  [3575] = {.lex_state = 203},
  [3576] = {.lex_state = 203},
  [3577] = {.lex_state = 203},
  [3578] = {.lex_state = 249},
  [3579] = {.lex_state = 203},
  [3580] = {.lex_state = 183, .external_lex_state = 1},
  [3581] = {.lex_state = 183, .external_lex_state = 1},
  [3582] = {.lex_state = 195},
  [3583] = {.lex_state = 183, .external_lex_state = 1},
  [3584] = {.lex_state = 178},
  [3585] = {.lex_state = 184},
  [3586] = {.lex_state = 215, .external_lex_state = 1},
  [3587] = {.lex_state = 215, .external_lex_state = 1},
  [3588] = {.lex_state = 183, .external_lex_state = 1},
  [3589] = {.lex_state = 215, .external_lex_state = 1},
  [3590] = {.lex_state = 183, .external_lex_state = 1},
  [3591] = {.lex_state = 203},
  [3592] = {.lex_state = 203},
  [3593] = {.lex_state = 215, .external_lex_state = 1},
  [3594] = {.lex_state = 183, .external_lex_state = 1},
  [3595] = {.lex_state = 203},
  [3596] = {.lex_state = 214, .external_lex_state = 1},
  [3597] = {.lex_state = 178},
  [3598] = {.lex_state = 183, .external_lex_state = 1},
  [3599] = {.lex_state = 183, .external_lex_state = 1},
  [3600] = {.lex_state = 199, .external_lex_state = 1},
  [3601] = {.lex_state = 199, .external_lex_state = 1},
  [3602] = {.lex_state = 199, .external_lex_state = 1},
  [3603] = {.lex_state = 183, .external_lex_state = 1},
  [3604] = {.lex_state = 203},
  [3605] = {.lex_state = 183, .external_lex_state = 1},
  [3606] = {.lex_state = 132},
  [3607] = {.lex_state = 183, .external_lex_state = 1},
  [3608] = {.lex_state = 184},
  [3609] = {.lex_state = 183, .external_lex_state = 1},
  [3610] = {.lex_state = 183, .external_lex_state = 1},
  [3611] = {.lex_state = 183, .external_lex_state = 1},
  [3612] = {.lex_state = 183, .external_lex_state = 1},
  [3613] = {.lex_state = 146},
  [3614] = {.lex_state = 183, .external_lex_state = 1},
  [3615] = {.lex_state = 233, .external_lex_state = 1},
  [3616] = {.lex_state = 233, .external_lex_state = 1},
  [3617] = {.lex_state = 233, .external_lex_state = 1},
  [3618] = {.lex_state = 183, .external_lex_state = 1},
  [3619] = {.lex_state = 203},
  [3620] = {.lex_state = 203},
  [3621] = {.lex_state = 214, .external_lex_state = 1},
  [3622] = {.lex_state = 183, .external_lex_state = 1},
  [3623] = {.lex_state = 203},
  [3624] = {.lex_state = 183, .external_lex_state = 1},
  [3625] = {.lex_state = 183, .external_lex_state = 1},
  [3626] = {.lex_state = 195},
  [3627] = {.lex_state = 183, .external_lex_state = 1},
  [3628] = {.lex_state = 178},
  [3629] = {.lex_state = 184},
  [3630] = {.lex_state = 226, .external_lex_state = 1},
  [3631] = {.lex_state = 226, .external_lex_state = 1},
  [3632] = {.lex_state = 183, .external_lex_state = 1},
  [3633] = {.lex_state = 226, .external_lex_state = 1},
  [3634] = {.lex_state = 183, .external_lex_state = 1},
  [3635] = {.lex_state = 203},
  [3636] = {.lex_state = 203},
  [3637] = {.lex_state = 226, .external_lex_state = 1},
  [3638] = {.lex_state = 146, .external_lex_state = 1},
  [3639] = {.lex_state = 183, .external_lex_state = 1},
  [3640] = {.lex_state = 183, .external_lex_state = 1},
  [3641] = {.lex_state = 203},
  [3642] = {.lex_state = 214, .external_lex_state = 1},
  [3643] = {.lex_state = 178},
  [3644] = {.lex_state = 203},
  [3645] = {.lex_state = 146, .external_lex_state = 1},
  [3646] = {.lex_state = 183, .external_lex_state = 1},
  [3647] = {.lex_state = 251},
  [3648] = {.lex_state = 251},
  [3649] = {.lex_state = 225},
  [3650] = {.lex_state = 251},
  [3651] = {.lex_state = 251},
  [3652] = {.lex_state = 225},
  [3653] = {.lex_state = 251},
  [3654] = {.lex_state = 251},
  [3655] = {.lex_state = 225},
  [3656] = {.lex_state = 225},
  [3657] = {.lex_state = 225},
  [3658] = {.lex_state = 225},
  [3659] = {.lex_state = 225},
  [3660] = {.lex_state = 225},
  [3661] = {.lex_state = 225},
  [3662] = {.lex_state = 225},
  [3663] = {.lex_state = 225},
  [3664] = {.lex_state = 225},
  [3665] = {.lex_state = 183, .external_lex_state = 1},
  [3666] = {.lex_state = 132, .external_lex_state = 1},
  [3667] = {.lex_state = 183, .external_lex_state = 1},
  [3668] = {.lex_state = 203},
  [3669] = {.lex_state = 203},
  [3670] = {.lex_state = 214, .external_lex_state = 1},
  [3671] = {.lex_state = 183, .external_lex_state = 1},
  [3672] = {.lex_state = 146},
  [3673] = {.lex_state = 183, .external_lex_state = 1},
  [3674] = {.lex_state = 183, .external_lex_state = 1},
  [3675] = {.lex_state = 203},
  [3676] = {.lex_state = 214, .external_lex_state = 1},
  [3677] = {.lex_state = 178},
  [3678] = {.lex_state = 203},
  [3679] = {.lex_state = 146},
  [3680] = {.lex_state = 183, .external_lex_state = 1},
  [3681] = {.lex_state = 161, .external_lex_state = 1},
  [3682] = {.lex_state = 227},
  [3683] = {.lex_state = 229},
  [3684] = {.lex_state = 227},
  [3685] = {.lex_state = 227},
  [3686] = {.lex_state = 183, .external_lex_state = 1},
  [3687] = {.lex_state = 203},
  [3688] = {.lex_state = 214, .external_lex_state = 1},
  [3689] = {.lex_state = 178},
  [3690] = {.lex_state = 183, .external_lex_state = 1},
  [3691] = {.lex_state = 183, .external_lex_state = 1},
  [3692] = {.lex_state = 161, .external_lex_state = 1},
  [3693] = {.lex_state = 183, .external_lex_state = 1},
  [3694] = {.lex_state = 203},
  [3695] = {.lex_state = 203},
  [3696] = {.lex_state = 249},
  [3697] = {.lex_state = 203},
  [3698] = {.lex_state = 203},
  [3699] = {.lex_state = 183, .external_lex_state = 1},
  [3700] = {.lex_state = 203},
  [3701] = {.lex_state = 214, .external_lex_state = 1},
  [3702] = {.lex_state = 178},
  [3703] = {.lex_state = 183, .external_lex_state = 1},
  [3704] = {.lex_state = 183, .external_lex_state = 1},
  [3705] = {.lex_state = 215, .external_lex_state = 1},
  [3706] = {.lex_state = 215, .external_lex_state = 1},
  [3707] = {.lex_state = 215, .external_lex_state = 1},
  [3708] = {.lex_state = 183, .external_lex_state = 1},
  [3709] = {.lex_state = 203},
  [3710] = {.lex_state = 199, .external_lex_state = 1},
  [3711] = {.lex_state = 183, .external_lex_state = 1},
  [3712] = {.lex_state = 183, .external_lex_state = 1},
  [3713] = {.lex_state = 203},
  [3714] = {.lex_state = 214, .external_lex_state = 1},
  [3715] = {.lex_state = 178},
  [3716] = {.lex_state = 203},
  [3717] = {.lex_state = 199, .external_lex_state = 1},
  [3718] = {.lex_state = 183, .external_lex_state = 1},
  [3719] = {.lex_state = 203},
  [3720] = {.lex_state = 183, .external_lex_state = 1},
  [3721] = {.lex_state = 183, .external_lex_state = 1},
  [3722] = {.lex_state = 195},
  [3723] = {.lex_state = 183, .external_lex_state = 1},
  [3724] = {.lex_state = 178},
  [3725] = {.lex_state = 184},
  [3726] = {.lex_state = 233, .external_lex_state = 1},
  [3727] = {.lex_state = 233, .external_lex_state = 1},
  [3728] = {.lex_state = 183, .external_lex_state = 1},
  [3729] = {.lex_state = 233, .external_lex_state = 1},
  [3730] = {.lex_state = 183, .external_lex_state = 1},
  [3731] = {.lex_state = 203},
  [3732] = {.lex_state = 203},
  [3733] = {.lex_state = 233, .external_lex_state = 1},
  [3734] = {.lex_state = 183, .external_lex_state = 1},
  [3735] = {.lex_state = 203},
  [3736] = {.lex_state = 214, .external_lex_state = 1},
  [3737] = {.lex_state = 178},
  [3738] = {.lex_state = 183, .external_lex_state = 1},
  [3739] = {.lex_state = 183, .external_lex_state = 1},
  [3740] = {.lex_state = 226, .external_lex_state = 1},
  [3741] = {.lex_state = 226, .external_lex_state = 1},
  [3742] = {.lex_state = 226, .external_lex_state = 1},
  [3743] = {.lex_state = 183, .external_lex_state = 1},
  [3744] = {.lex_state = 203},
  [3745] = {.lex_state = 183, .external_lex_state = 1},
  [3746] = {.lex_state = 146, .external_lex_state = 1},
  [3747] = {.lex_state = 183, .external_lex_state = 1},
  [3748] = {.lex_state = 203},
  [3749] = {.lex_state = 203},
  [3750] = {.lex_state = 214, .external_lex_state = 1},
  [3751] = {.lex_state = 183, .external_lex_state = 1},
  [3752] = {.lex_state = 146, .external_lex_state = 1},
  [3753] = {.lex_state = 225},
  [3754] = {.lex_state = 225},
  [3755] = {.lex_state = 225},
  [3756] = {.lex_state = 225},
  [3757] = {.lex_state = 225},
  [3758] = {.lex_state = 183, .external_lex_state = 1},
  [3759] = {.lex_state = 183, .external_lex_state = 1},
  [3760] = {.lex_state = 203},
  [3761] = {.lex_state = 203},
  [3762] = {.lex_state = 183, .external_lex_state = 1},
  [3763] = {.lex_state = 146},
  [3764] = {.lex_state = 183, .external_lex_state = 1},
  [3765] = {.lex_state = 203},
  [3766] = {.lex_state = 203},
  [3767] = {.lex_state = 214, .external_lex_state = 1},
  [3768] = {.lex_state = 183, .external_lex_state = 1},
  [3769] = {.lex_state = 146},
  [3770] = {.lex_state = 161, .external_lex_state = 1},
  [3771] = {.lex_state = 183, .external_lex_state = 1},
  [3772] = {.lex_state = 183, .external_lex_state = 1},
  [3773] = {.lex_state = 203},
  [3774] = {.lex_state = 214, .external_lex_state = 1},
  [3775] = {.lex_state = 178},
  [3776] = {.lex_state = 203},
  [3777] = {.lex_state = 183, .external_lex_state = 1},
  [3778] = {.lex_state = 215, .external_lex_state = 1},
  [3779] = {.lex_state = 183, .external_lex_state = 1},
  [3780] = {.lex_state = 183, .external_lex_state = 1},
  [3781] = {.lex_state = 203},
  [3782] = {.lex_state = 214, .external_lex_state = 1},
  [3783] = {.lex_state = 178},
  [3784] = {.lex_state = 203},
  [3785] = {.lex_state = 215, .external_lex_state = 1},
  [3786] = {.lex_state = 183, .external_lex_state = 1},
  [3787] = {.lex_state = 183, .external_lex_state = 1},
  [3788] = {.lex_state = 199, .external_lex_state = 1},
  [3789] = {.lex_state = 183, .external_lex_state = 1},
  [3790] = {.lex_state = 203},
  [3791] = {.lex_state = 203},
  [3792] = {.lex_state = 214, .external_lex_state = 1},
  [3793] = {.lex_state = 183, .external_lex_state = 1},
  [3794] = {.lex_state = 199, .external_lex_state = 1},
  [3795] = {.lex_state = 183, .external_lex_state = 1},
  [3796] = {.lex_state = 203},
  [3797] = {.lex_state = 214, .external_lex_state = 1},
  [3798] = {.lex_state = 178},
  [3799] = {.lex_state = 183, .external_lex_state = 1},
  [3800] = {.lex_state = 183, .external_lex_state = 1},
  [3801] = {.lex_state = 233, .external_lex_state = 1},
  [3802] = {.lex_state = 233, .external_lex_state = 1},
  [3803] = {.lex_state = 233, .external_lex_state = 1},
  [3804] = {.lex_state = 183, .external_lex_state = 1},
  [3805] = {.lex_state = 203},
  [3806] = {.lex_state = 226, .external_lex_state = 1},
  [3807] = {.lex_state = 183, .external_lex_state = 1},
  [3808] = {.lex_state = 183, .external_lex_state = 1},
  [3809] = {.lex_state = 203},
  [3810] = {.lex_state = 214, .external_lex_state = 1},
  [3811] = {.lex_state = 178},
  [3812] = {.lex_state = 203},
  [3813] = {.lex_state = 226, .external_lex_state = 1},
  [3814] = {.lex_state = 183, .external_lex_state = 1},
  [3815] = {.lex_state = 183, .external_lex_state = 1},
  [3816] = {.lex_state = 183, .external_lex_state = 1},
  [3817] = {.lex_state = 203},
  [3818] = {.lex_state = 203},
  [3819] = {.lex_state = 225},
  [3820] = {.lex_state = 225},
  [3821] = {.lex_state = 225},
  [3822] = {.lex_state = 225},
  [3823] = {.lex_state = 183, .external_lex_state = 1},
  [3824] = {.lex_state = 203},
  [3825] = {.lex_state = 183, .external_lex_state = 1},
  [3826] = {.lex_state = 183, .external_lex_state = 1},
  [3827] = {.lex_state = 203},
  [3828] = {.lex_state = 203},
  [3829] = {.lex_state = 183, .external_lex_state = 1},
  [3830] = {.lex_state = 161, .external_lex_state = 1},
  [3831] = {.lex_state = 183, .external_lex_state = 1},
  [3832] = {.lex_state = 203},
  [3833] = {.lex_state = 203},
  [3834] = {.lex_state = 214, .external_lex_state = 1},
  [3835] = {.lex_state = 183, .external_lex_state = 1},
  [3836] = {.lex_state = 183, .external_lex_state = 1},
  [3837] = {.lex_state = 215, .external_lex_state = 1},
  [3838] = {.lex_state = 183, .external_lex_state = 1},
  [3839] = {.lex_state = 203},
  [3840] = {.lex_state = 203},
  [3841] = {.lex_state = 214, .external_lex_state = 1},
  [3842] = {.lex_state = 183, .external_lex_state = 1},
  [3843] = {.lex_state = 215, .external_lex_state = 1},
  [3844] = {.lex_state = 183, .external_lex_state = 1},
  [3845] = {.lex_state = 183, .external_lex_state = 1},
  [3846] = {.lex_state = 203},
  [3847] = {.lex_state = 203},
  [3848] = {.lex_state = 233, .external_lex_state = 1},
  [3849] = {.lex_state = 183, .external_lex_state = 1},
  [3850] = {.lex_state = 183, .external_lex_state = 1},
  [3851] = {.lex_state = 203},
  [3852] = {.lex_state = 214, .external_lex_state = 1},
  [3853] = {.lex_state = 178},
  [3854] = {.lex_state = 203},
  [3855] = {.lex_state = 233, .external_lex_state = 1},
  [3856] = {.lex_state = 183, .external_lex_state = 1},
  [3857] = {.lex_state = 183, .external_lex_state = 1},
  [3858] = {.lex_state = 226, .external_lex_state = 1},
  [3859] = {.lex_state = 183, .external_lex_state = 1},
  [3860] = {.lex_state = 203},
  [3861] = {.lex_state = 203},
  [3862] = {.lex_state = 214, .external_lex_state = 1},
  [3863] = {.lex_state = 183, .external_lex_state = 1},
  [3864] = {.lex_state = 226, .external_lex_state = 1},
  [3865] = {.lex_state = 183, .external_lex_state = 1},
  [3866] = {.lex_state = 203},
  [3867] = {.lex_state = 183, .external_lex_state = 1},
  [3868] = {.lex_state = 183, .external_lex_state = 1},
  [3869] = {.lex_state = 203},
  [3870] = {.lex_state = 183, .external_lex_state = 1},
  [3871] = {.lex_state = 183, .external_lex_state = 1},
  [3872] = {.lex_state = 203},
  [3873] = {.lex_state = 203},
  [3874] = {.lex_state = 183, .external_lex_state = 1},
  [3875] = {.lex_state = 183, .external_lex_state = 1},
  [3876] = {.lex_state = 203},
  [3877] = {.lex_state = 203},
  [3878] = {.lex_state = 183, .external_lex_state = 1},
  [3879] = {.lex_state = 203},
  [3880] = {.lex_state = 183, .external_lex_state = 1},
  [3881] = {.lex_state = 233, .external_lex_state = 1},
  [3882] = {.lex_state = 183, .external_lex_state = 1},
  [3883] = {.lex_state = 203},
  [3884] = {.lex_state = 203},
  [3885] = {.lex_state = 214, .external_lex_state = 1},
  [3886] = {.lex_state = 183, .external_lex_state = 1},
  [3887] = {.lex_state = 233, .external_lex_state = 1},
  [3888] = {.lex_state = 183, .external_lex_state = 1},
  [3889] = {.lex_state = 183, .external_lex_state = 1},
  [3890] = {.lex_state = 203},
  [3891] = {.lex_state = 203},
  [3892] = {.lex_state = 183, .external_lex_state = 1},
  [3893] = {.lex_state = 183, .external_lex_state = 1},
  [3894] = {.lex_state = 183, .external_lex_state = 1},
  [3895] = {.lex_state = 203},
  [3896] = {.lex_state = 183, .external_lex_state = 1},
  [3897] = {.lex_state = 203},
  [3898] = {.lex_state = 183, .external_lex_state = 1},
  [3899] = {.lex_state = 183, .external_lex_state = 1},
  [3900] = {.lex_state = 183, .external_lex_state = 1},
  [3901] = {.lex_state = 203},
  [3902] = {.lex_state = 203},
  [3903] = {.lex_state = 183, .external_lex_state = 1},
  [3904] = {.lex_state = 203},
  [3905] = {.lex_state = 183, .external_lex_state = 1},
  [3906] = {.lex_state = 183, .external_lex_state = 1},
  [3907] = {.lex_state = 183, .external_lex_state = 1},
  [3908] = {.lex_state = 203},
  [3909] = {.lex_state = 183, .external_lex_state = 1},
  [3910] = {.lex_state = 183, .external_lex_state = 1},
};

enum {
  ts_external_token_raw_string_literal,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_raw_string_literal] = sym_raw_string_literal,
};

static bool ts_external_scanner_states[2][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_raw_string_literal] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_raw_string_literal] = ACTIONS(1),
    [ts_builtin_sym_end] = ACTIONS(1),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3),
    [sym_preproc_directive] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_typedef] = ACTIONS(3),
    [anon_sym_extern] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_LPAREN2] = ACTIONS(3),
    [anon_sym_STAR] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(3),
    [anon_sym_register] = ACTIONS(3),
    [anon_sym_inline] = ACTIONS(3),
    [anon_sym_const] = ACTIONS(3),
    [anon_sym_restrict] = ACTIONS(3),
    [anon_sym_volatile] = ACTIONS(3),
    [anon_sym__Atomic] = ACTIONS(3),
    [anon_sym_mutable] = ACTIONS(3),
    [anon_sym_explicit] = ACTIONS(3),
    [anon_sym_constexpr] = ACTIONS(3),
    [anon_sym_unsigned] = ACTIONS(3),
    [anon_sym_long] = ACTIONS(3),
    [anon_sym_short] = ACTIONS(3),
    [sym_primitive_type] = ACTIONS(3),
    [anon_sym_enum] = ACTIONS(3),
    [anon_sym_struct] = ACTIONS(3),
    [anon_sym_union] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3),
    [anon_sym_if] = ACTIONS(3),
    [anon_sym_else] = ACTIONS(3),
    [anon_sym_switch] = ACTIONS(3),
    [anon_sym_case] = ACTIONS(3),
    [anon_sym_default] = ACTIONS(3),
    [anon_sym_while] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3),
    [anon_sym_for] = ACTIONS(3),
    [anon_sym_return] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(3),
    [anon_sym_continue] = ACTIONS(3),
    [anon_sym_goto] = ACTIONS(3),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(3),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(3),
    [anon_sym_PIPE] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(3),
    [anon_sym_GT] = ACTIONS(3),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(3),
    [anon_sym_GT_GT] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(3),
    [anon_sym_SLASH] = ACTIONS(3),
    [anon_sym_PERCENT] = ACTIONS(3),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_sizeof] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [sym_number_literal] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_true] = ACTIONS(3),
    [sym_false] = ACTIONS(3),
    [sym_null] = ACTIONS(3),
    [sym_identifier] = ACTIONS(3),
    [sym_comment] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(3),
    [anon_sym_final] = ACTIONS(3),
    [anon_sym_override] = ACTIONS(3),
    [anon_sym_public] = ACTIONS(3),
    [sym_auto] = ACTIONS(3),
    [anon_sym_typename] = ACTIONS(3),
    [anon_sym_template] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(3),
    [anon_sym_friend] = ACTIONS(3),
    [anon_sym_private] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(3),
    [sym_noexcept] = ACTIONS(3),
    [anon_sym_namespace] = ACTIONS(3),
    [anon_sym_using] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(3),
    [anon_sym_catch] = ACTIONS(3),
    [anon_sym_new] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [sym_operator_name] = ACTIONS(1),
    [sym_nullptr] = ACTIONS(3),
  },
  [1] = {
    [sym_translation_unit] = STATE(48),
    [sym_preproc_include] = STATE(62),
    [sym_preproc_def] = STATE(62),
    [sym_preproc_function_def] = STATE(62),
    [sym_preproc_call] = STATE(62),
    [sym_preproc_if] = STATE(62),
    [sym_preproc_ifdef] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_declaration] = STATE(62),
    [sym_type_definition] = STATE(62),
    [sym__declaration_specifiers] = STATE(49),
    [sym_linkage_specification] = STATE(62),
    [sym__declarator] = STATE(50),
    [sym_pointer_declarator] = STATE(50),
    [sym_function_declarator] = STATE(51),
    [sym_array_declarator] = STATE(50),
    [sym_compound_statement] = STATE(62),
    [sym_storage_class_specifier] = STATE(63),
    [sym_type_qualifier] = STATE(63),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(62),
    [sym_expression_statement] = STATE(62),
    [sym_if_statement] = STATE(62),
    [sym_switch_statement] = STATE(62),
    [sym_case_statement] = STATE(62),
    [sym_while_statement] = STATE(62),
    [sym_do_statement] = STATE(62),
    [sym_for_statement] = STATE(62),
    [sym_return_statement] = STATE(62),
    [sym_break_statement] = STATE(62),
    [sym_continue_statement] = STATE(62),
    [sym_goto_statement] = STATE(62),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(62),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(62),
    [sym_template_declaration] = STATE(62),
    [sym_template_instantiation] = STATE(62),
    [sym_constructor_or_destructor_definition] = STATE(62),
    [sym_reference_declarator] = STATE(50),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(57),
    [sym_namespace_definition] = STATE(62),
    [sym_using_declaration] = STATE(62),
    [sym_alias_declaration] = STATE(62),
    [sym_for_range_loop] = STATE(62),
    [sym_try_statement] = STATE(62),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_destructor_name] = STATE(50),
    [sym_scoped_identifier] = STATE(59),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_translation_unit_repeat1] = STATE(62),
    [aux_sym__declaration_specifiers_repeat1] = STATE(63),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(5),
    [ts_builtin_sym_end] = ACTIONS(7),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(9),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(13),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(15),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(15),
    [sym_preproc_directive] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_switch] = ACTIONS(49),
    [anon_sym_case] = ACTIONS(51),
    [anon_sym_default] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(89),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_template] = ACTIONS(97),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_namespace] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(103),
    [anon_sym_try] = ACTIONS(105),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_operator_name] = ACTIONS(111),
    [sym_nullptr] = ACTIONS(87),
  },
  [2] = {
    [sym_string_literal] = STATE(66),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_system_lib_string] = ACTIONS(115),
    [sym_comment] = ACTIONS(91),
  },
  [3] = {
    [sym_identifier] = ACTIONS(117),
    [sym_comment] = ACTIONS(91),
  },
  [4] = {
    [sym_preproc_arg] = ACTIONS(119),
    [sym_comment] = ACTIONS(121),
  },
  [5] = {
    [sym_identifier] = ACTIONS(123),
    [sym_comment] = ACTIONS(91),
  },
  [6] = {
    [anon_sym_LF] = ACTIONS(125),
    [sym_preproc_arg] = ACTIONS(127),
    [sym_comment] = ACTIONS(121),
  },
  [7] = {
    [sym_raw_string_literal] = ACTIONS(129),
    [ts_builtin_sym_end] = ACTIONS(129),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(131),
    [sym_preproc_directive] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(129),
    [anon_sym_typedef] = ACTIONS(131),
    [anon_sym_extern] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_RBRACE] = ACTIONS(129),
    [anon_sym_LPAREN2] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(129),
    [anon_sym_static] = ACTIONS(131),
    [anon_sym_register] = ACTIONS(131),
    [anon_sym_inline] = ACTIONS(131),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_restrict] = ACTIONS(131),
    [anon_sym_volatile] = ACTIONS(131),
    [anon_sym__Atomic] = ACTIONS(131),
    [anon_sym_mutable] = ACTIONS(131),
    [anon_sym_explicit] = ACTIONS(131),
    [anon_sym_constexpr] = ACTIONS(131),
    [anon_sym_unsigned] = ACTIONS(131),
    [anon_sym_long] = ACTIONS(131),
    [anon_sym_short] = ACTIONS(131),
    [sym_primitive_type] = ACTIONS(131),
    [anon_sym_enum] = ACTIONS(131),
    [anon_sym_struct] = ACTIONS(131),
    [anon_sym_union] = ACTIONS(131),
    [anon_sym_if] = ACTIONS(131),
    [anon_sym_else] = ACTIONS(131),
    [anon_sym_switch] = ACTIONS(131),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(131),
    [anon_sym_break] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_goto] = ACTIONS(131),
    [anon_sym_AMP] = ACTIONS(131),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_BANG] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_PLUS] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(129),
    [anon_sym_PLUS_PLUS] = ACTIONS(129),
    [anon_sym_sizeof] = ACTIONS(131),
    [sym_number_literal] = ACTIONS(129),
    [anon_sym_SQUOTE] = ACTIONS(129),
    [anon_sym_DQUOTE] = ACTIONS(129),
    [sym_true] = ACTIONS(131),
    [sym_false] = ACTIONS(131),
    [sym_null] = ACTIONS(131),
    [sym_identifier] = ACTIONS(131),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(131),
    [sym_auto] = ACTIONS(131),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(131),
    [anon_sym_delete] = ACTIONS(131),
    [anon_sym_namespace] = ACTIONS(131),
    [anon_sym_using] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(131),
    [anon_sym_new] = ACTIONS(131),
    [anon_sym_COLON_COLON] = ACTIONS(129),
    [sym_operator_name] = ACTIONS(129),
    [sym_nullptr] = ACTIONS(131),
  },
  [8] = {
    [sym_type_qualifier] = STATE(84),
    [sym__type_specifier] = STATE(80),
    [sym_sized_type_specifier] = STATE(80),
    [sym_enum_specifier] = STATE(80),
    [sym_struct_specifier] = STATE(80),
    [sym_union_specifier] = STATE(80),
    [sym_macro_type_specifier] = STATE(80),
    [sym_class_specifier] = STATE(80),
    [sym_dependent_type] = STATE(80),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(82),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_type_definition_repeat1] = STATE(84),
    [aux_sym_sized_type_specifier_repeat1] = STATE(85),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(135),
    [anon_sym_long] = ACTIONS(135),
    [anon_sym_short] = ACTIONS(135),
    [sym_primitive_type] = ACTIONS(137),
    [anon_sym_enum] = ACTIONS(139),
    [anon_sym_struct] = ACTIONS(141),
    [anon_sym_union] = ACTIONS(143),
    [sym_identifier] = ACTIONS(145),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(147),
    [sym_auto] = ACTIONS(137),
    [anon_sym_typename] = ACTIONS(149),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [9] = {
    [sym_string_literal] = STATE(86),
    [anon_sym_extern] = ACTIONS(153),
    [anon_sym_LPAREN2] = ACTIONS(155),
    [anon_sym_STAR] = ACTIONS(155),
    [anon_sym_static] = ACTIONS(153),
    [anon_sym_register] = ACTIONS(153),
    [anon_sym_inline] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(153),
    [anon_sym_restrict] = ACTIONS(153),
    [anon_sym_volatile] = ACTIONS(153),
    [anon_sym__Atomic] = ACTIONS(153),
    [anon_sym_mutable] = ACTIONS(153),
    [anon_sym_explicit] = ACTIONS(153),
    [anon_sym_constexpr] = ACTIONS(153),
    [anon_sym_unsigned] = ACTIONS(153),
    [anon_sym_long] = ACTIONS(153),
    [anon_sym_short] = ACTIONS(153),
    [sym_primitive_type] = ACTIONS(153),
    [anon_sym_enum] = ACTIONS(153),
    [anon_sym_struct] = ACTIONS(153),
    [anon_sym_union] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_identifier] = ACTIONS(153),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(153),
    [sym_auto] = ACTIONS(153),
    [anon_sym_typename] = ACTIONS(153),
    [anon_sym_COLON_COLON] = ACTIONS(155),
    [sym_operator_name] = ACTIONS(155),
  },
  [10] = {
    [sym_preproc_include] = STATE(117),
    [sym_preproc_def] = STATE(117),
    [sym_preproc_function_def] = STATE(117),
    [sym_preproc_call] = STATE(117),
    [sym_preproc_if_in_compound_statement] = STATE(117),
    [sym_preproc_ifdef_in_compound_statement] = STATE(117),
    [sym_declaration] = STATE(117),
    [sym_type_definition] = STATE(117),
    [sym__declaration_specifiers] = STATE(113),
    [sym_compound_statement] = STATE(117),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(117),
    [sym_expression_statement] = STATE(117),
    [sym_if_statement] = STATE(117),
    [sym_switch_statement] = STATE(117),
    [sym_case_statement] = STATE(117),
    [sym_while_statement] = STATE(117),
    [sym_do_statement] = STATE(117),
    [sym_for_statement] = STATE(117),
    [sym_return_statement] = STATE(117),
    [sym_break_statement] = STATE(117),
    [sym_continue_statement] = STATE(117),
    [sym_goto_statement] = STATE(117),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(117),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(117),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(117),
    [sym_try_statement] = STATE(117),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(117),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(157),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(159),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(161),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(163),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(165),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(165),
    [sym_preproc_directive] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_typedef] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_RBRACE] = ACTIONS(177),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(185),
    [anon_sym_case] = ACTIONS(187),
    [anon_sym_default] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(209),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_nullptr] = ACTIONS(207),
  },
  [11] = {
    [sym__declarator] = STATE(135),
    [sym_pointer_declarator] = STATE(135),
    [sym_function_declarator] = STATE(135),
    [sym_array_declarator] = STATE(135),
    [sym_type_qualifier] = STATE(141),
    [sym__type_specifier] = STATE(136),
    [sym_sized_type_specifier] = STATE(136),
    [sym_enum_specifier] = STATE(136),
    [sym_struct_specifier] = STATE(136),
    [sym_union_specifier] = STATE(136),
    [sym__expression] = STATE(137),
    [sym_comma_expression] = STATE(138),
    [sym_conditional_expression] = STATE(137),
    [sym_assignment_expression] = STATE(137),
    [sym_pointer_expression] = STATE(137),
    [sym_logical_expression] = STATE(137),
    [sym_bitwise_expression] = STATE(137),
    [sym_equality_expression] = STATE(137),
    [sym_relational_expression] = STATE(137),
    [sym_shift_expression] = STATE(137),
    [sym_math_expression] = STATE(137),
    [sym_cast_expression] = STATE(137),
    [sym_type_descriptor] = STATE(139),
    [sym_sizeof_expression] = STATE(137),
    [sym_subscript_expression] = STATE(137),
    [sym_call_expression] = STATE(137),
    [sym_field_expression] = STATE(137),
    [sym_compound_literal_expression] = STATE(137),
    [sym_parenthesized_expression] = STATE(137),
    [sym_char_literal] = STATE(137),
    [sym_concatenated_string] = STATE(137),
    [sym_string_literal] = STATE(140),
    [sym_macro_type_specifier] = STATE(136),
    [sym_class_specifier] = STATE(136),
    [sym_dependent_type] = STATE(136),
    [sym_reference_declarator] = STATE(135),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(57),
    [sym_new_expression] = STATE(137),
    [sym_delete_expression] = STATE(137),
    [sym_lambda_expression] = STATE(137),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_destructor_name] = STATE(135),
    [sym_scoped_identifier] = STATE(59),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_type_definition_repeat1] = STATE(141),
    [aux_sym_sized_type_specifier_repeat1] = STATE(142),
    [sym_raw_string_literal] = ACTIONS(213),
    [anon_sym_LPAREN2] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(217),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(219),
    [anon_sym_long] = ACTIONS(219),
    [anon_sym_short] = ACTIONS(219),
    [sym_primitive_type] = ACTIONS(221),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [anon_sym_AMP] = ACTIONS(227),
    [anon_sym_AMP_AMP] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(233),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [sym_null] = ACTIONS(241),
    [sym_identifier] = ACTIONS(243),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(221),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(253),
    [sym_operator_name] = ACTIONS(255),
    [sym_nullptr] = ACTIONS(241),
  },
  [12] = {
    [sym__declarator] = STATE(145),
    [sym_pointer_declarator] = STATE(145),
    [sym_function_declarator] = STATE(145),
    [sym_array_declarator] = STATE(145),
    [sym_type_qualifier] = STATE(150),
    [sym__expression] = STATE(146),
    [sym_conditional_expression] = STATE(146),
    [sym_assignment_expression] = STATE(146),
    [sym_pointer_expression] = STATE(146),
    [sym_logical_expression] = STATE(146),
    [sym_bitwise_expression] = STATE(146),
    [sym_equality_expression] = STATE(146),
    [sym_relational_expression] = STATE(146),
    [sym_shift_expression] = STATE(146),
    [sym_math_expression] = STATE(146),
    [sym_cast_expression] = STATE(146),
    [sym_sizeof_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_compound_literal_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_char_literal] = STATE(146),
    [sym_concatenated_string] = STATE(146),
    [sym_string_literal] = STATE(55),
    [sym_reference_declarator] = STATE(145),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(57),
    [sym_new_expression] = STATE(146),
    [sym_delete_expression] = STATE(146),
    [sym_lambda_expression] = STATE(146),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_destructor_name] = STATE(145),
    [sym_scoped_identifier] = STATE(59),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [aux_sym_type_definition_repeat1] = STATE(150),
    [sym_raw_string_literal] = ACTIONS(257),
    [anon_sym_LPAREN2] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(257),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(259),
    [sym_false] = ACTIONS(259),
    [sym_null] = ACTIONS(259),
    [sym_identifier] = ACTIONS(261),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_operator_name] = ACTIONS(265),
    [sym_nullptr] = ACTIONS(259),
  },
  [13] = {
    [sym__expression] = STATE(164),
    [sym_conditional_expression] = STATE(164),
    [sym_assignment_expression] = STATE(164),
    [sym_pointer_expression] = STATE(164),
    [sym_logical_expression] = STATE(164),
    [sym_bitwise_expression] = STATE(164),
    [sym_equality_expression] = STATE(164),
    [sym_relational_expression] = STATE(164),
    [sym_shift_expression] = STATE(164),
    [sym_math_expression] = STATE(164),
    [sym_cast_expression] = STATE(164),
    [sym_sizeof_expression] = STATE(164),
    [sym_subscript_expression] = STATE(164),
    [sym_call_expression] = STATE(164),
    [sym_field_expression] = STATE(164),
    [sym_compound_literal_expression] = STATE(164),
    [sym_parenthesized_expression] = STATE(164),
    [sym_char_literal] = STATE(164),
    [sym_concatenated_string] = STATE(164),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(164),
    [sym_new_expression] = STATE(164),
    [sym_delete_expression] = STATE(164),
    [sym_lambda_expression] = STATE(164),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_lambda_default_capture] = STATE(166),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(267),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(273),
    [anon_sym_EQ] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(267),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(289),
    [sym_false] = ACTIONS(289),
    [sym_null] = ACTIONS(289),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(289),
  },
  [14] = {
    [anon_sym_COMMA] = ACTIONS(155),
    [anon_sym_RPAREN] = ACTIONS(155),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(153),
    [anon_sym_LPAREN2] = ACTIONS(155),
    [anon_sym_STAR] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(155),
    [anon_sym_static] = ACTIONS(153),
    [anon_sym_register] = ACTIONS(153),
    [anon_sym_inline] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(153),
    [anon_sym_restrict] = ACTIONS(153),
    [anon_sym_volatile] = ACTIONS(153),
    [anon_sym__Atomic] = ACTIONS(153),
    [anon_sym_mutable] = ACTIONS(153),
    [anon_sym_explicit] = ACTIONS(153),
    [anon_sym_constexpr] = ACTIONS(153),
    [anon_sym_unsigned] = ACTIONS(153),
    [anon_sym_long] = ACTIONS(153),
    [anon_sym_short] = ACTIONS(153),
    [sym_primitive_type] = ACTIONS(153),
    [anon_sym_enum] = ACTIONS(153),
    [anon_sym_struct] = ACTIONS(153),
    [anon_sym_union] = ACTIONS(153),
    [anon_sym_COLON] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [sym_identifier] = ACTIONS(153),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(153),
    [sym_auto] = ACTIONS(153),
    [anon_sym_typename] = ACTIONS(153),
    [anon_sym_GT2] = ACTIONS(155),
    [anon_sym_COLON_COLON] = ACTIONS(155),
    [sym_operator_name] = ACTIONS(155),
  },
  [15] = {
    [anon_sym_COMMA] = ACTIONS(299),
    [anon_sym_RPAREN] = ACTIONS(299),
    [anon_sym_SEMI] = ACTIONS(299),
    [anon_sym_extern] = ACTIONS(301),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_LPAREN2] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(299),
    [anon_sym_EQ] = ACTIONS(299),
    [anon_sym_static] = ACTIONS(301),
    [anon_sym_register] = ACTIONS(301),
    [anon_sym_inline] = ACTIONS(301),
    [anon_sym_const] = ACTIONS(301),
    [anon_sym_restrict] = ACTIONS(301),
    [anon_sym_volatile] = ACTIONS(301),
    [anon_sym__Atomic] = ACTIONS(301),
    [anon_sym_mutable] = ACTIONS(301),
    [anon_sym_explicit] = ACTIONS(301),
    [anon_sym_constexpr] = ACTIONS(301),
    [anon_sym_unsigned] = ACTIONS(301),
    [anon_sym_long] = ACTIONS(301),
    [anon_sym_short] = ACTIONS(301),
    [sym_primitive_type] = ACTIONS(301),
    [anon_sym_enum] = ACTIONS(301),
    [anon_sym_struct] = ACTIONS(301),
    [anon_sym_union] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(301),
    [anon_sym_AMP] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(299),
    [anon_sym_TILDE] = ACTIONS(299),
    [anon_sym_DASH_GT] = ACTIONS(299),
    [sym_identifier] = ACTIONS(301),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(301),
    [anon_sym_final] = ACTIONS(301),
    [anon_sym_override] = ACTIONS(301),
    [sym_auto] = ACTIONS(301),
    [anon_sym_typename] = ACTIONS(301),
    [anon_sym_GT2] = ACTIONS(299),
    [sym_noexcept] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(299),
    [sym_operator_name] = ACTIONS(299),
  },
  [16] = {
    [sym_enumerator_list] = STATE(169),
    [anon_sym_LBRACE] = ACTIONS(303),
    [sym_identifier] = ACTIONS(305),
    [sym_comment] = ACTIONS(91),
  },
  [17] = {
    [sym_field_declaration_list] = STATE(175),
    [sym_virtual_specifier] = STATE(176),
    [sym_base_class_clause] = STATE(177),
    [sym_template_type] = STATE(178),
    [sym_scoped_type_identifier] = STATE(179),
    [sym_scoped_namespace_identifier] = STATE(180),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(311),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(315),
  },
  [18] = {
    [sym_field_declaration_list] = STATE(182),
    [sym_virtual_specifier] = STATE(183),
    [sym_base_class_clause] = STATE(184),
    [sym_template_type] = STATE(185),
    [sym_scoped_type_identifier] = STATE(186),
    [sym_scoped_namespace_identifier] = STATE(180),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(317),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(315),
  },
  [19] = {
    [anon_sym_LPAREN2] = ACTIONS(319),
    [anon_sym_constexpr] = ACTIONS(321),
    [sym_comment] = ACTIONS(91),
  },
  [20] = {
    [sym_parenthesized_expression] = STATE(190),
    [anon_sym_LPAREN2] = ACTIONS(323),
    [sym_comment] = ACTIONS(91),
  },
  [21] = {
    [sym__expression] = STATE(201),
    [sym_conditional_expression] = STATE(201),
    [sym_assignment_expression] = STATE(201),
    [sym_pointer_expression] = STATE(201),
    [sym_logical_expression] = STATE(201),
    [sym_bitwise_expression] = STATE(201),
    [sym_equality_expression] = STATE(201),
    [sym_relational_expression] = STATE(201),
    [sym_shift_expression] = STATE(201),
    [sym_math_expression] = STATE(201),
    [sym_cast_expression] = STATE(201),
    [sym_sizeof_expression] = STATE(201),
    [sym_subscript_expression] = STATE(201),
    [sym_call_expression] = STATE(201),
    [sym_field_expression] = STATE(201),
    [sym_compound_literal_expression] = STATE(201),
    [sym_parenthesized_expression] = STATE(201),
    [sym_char_literal] = STATE(201),
    [sym_concatenated_string] = STATE(201),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(201),
    [sym_new_expression] = STATE(201),
    [sym_delete_expression] = STATE(201),
    [sym_lambda_expression] = STATE(201),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(325),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(325),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(343),
    [sym_false] = ACTIONS(343),
    [sym_null] = ACTIONS(343),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(343),
  },
  [22] = {
    [anon_sym_COLON] = ACTIONS(351),
    [sym_comment] = ACTIONS(91),
  },
  [23] = {
    [sym_parenthesized_expression] = STATE(205),
    [anon_sym_LPAREN2] = ACTIONS(323),
    [sym_comment] = ACTIONS(91),
  },
  [24] = {
    [sym_compound_statement] = STATE(221),
    [sym_labeled_statement] = STATE(221),
    [sym_expression_statement] = STATE(221),
    [sym_if_statement] = STATE(221),
    [sym_switch_statement] = STATE(221),
    [sym_case_statement] = STATE(221),
    [sym_while_statement] = STATE(221),
    [sym_do_statement] = STATE(221),
    [sym_for_statement] = STATE(221),
    [sym_return_statement] = STATE(221),
    [sym_break_statement] = STATE(221),
    [sym_continue_statement] = STATE(221),
    [sym_goto_statement] = STATE(221),
    [sym__expression] = STATE(222),
    [sym_comma_expression] = STATE(223),
    [sym_conditional_expression] = STATE(222),
    [sym_assignment_expression] = STATE(222),
    [sym_pointer_expression] = STATE(222),
    [sym_logical_expression] = STATE(222),
    [sym_bitwise_expression] = STATE(222),
    [sym_equality_expression] = STATE(222),
    [sym_relational_expression] = STATE(222),
    [sym_shift_expression] = STATE(222),
    [sym_math_expression] = STATE(222),
    [sym_cast_expression] = STATE(222),
    [sym_sizeof_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_call_expression] = STATE(222),
    [sym_field_expression] = STATE(222),
    [sym_compound_literal_expression] = STATE(222),
    [sym_parenthesized_expression] = STATE(222),
    [sym_char_literal] = STATE(222),
    [sym_concatenated_string] = STATE(222),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(222),
    [sym_for_range_loop] = STATE(221),
    [sym_try_statement] = STATE(221),
    [sym_new_expression] = STATE(222),
    [sym_delete_expression] = STATE(222),
    [sym_lambda_expression] = STATE(222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(359),
    [anon_sym_switch] = ACTIONS(361),
    [anon_sym_case] = ACTIONS(363),
    [anon_sym_default] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [anon_sym_do] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(373),
    [anon_sym_break] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_goto] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(353),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_identifier] = ACTIONS(383),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(381),
  },
  [25] = {
    [anon_sym_LPAREN2] = ACTIONS(387),
    [sym_comment] = ACTIONS(91),
  },
  [26] = {
    [sym__expression] = STATE(236),
    [sym_conditional_expression] = STATE(236),
    [sym_assignment_expression] = STATE(236),
    [sym_pointer_expression] = STATE(236),
    [sym_logical_expression] = STATE(236),
    [sym_bitwise_expression] = STATE(236),
    [sym_equality_expression] = STATE(236),
    [sym_relational_expression] = STATE(236),
    [sym_shift_expression] = STATE(236),
    [sym_math_expression] = STATE(236),
    [sym_cast_expression] = STATE(236),
    [sym_sizeof_expression] = STATE(236),
    [sym_subscript_expression] = STATE(236),
    [sym_call_expression] = STATE(236),
    [sym_field_expression] = STATE(236),
    [sym_compound_literal_expression] = STATE(236),
    [sym_parenthesized_expression] = STATE(236),
    [sym_initializer_list] = STATE(237),
    [sym_char_literal] = STATE(236),
    [sym_concatenated_string] = STATE(236),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(236),
    [sym_new_expression] = STATE(236),
    [sym_delete_expression] = STATE(236),
    [sym_lambda_expression] = STATE(236),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(389),
    [anon_sym_SEMI] = ACTIONS(391),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(389),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_null] = ACTIONS(409),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(409),
  },
  [27] = {
    [anon_sym_SEMI] = ACTIONS(417),
    [sym_comment] = ACTIONS(91),
  },
  [28] = {
    [anon_sym_SEMI] = ACTIONS(419),
    [sym_comment] = ACTIONS(91),
  },
  [29] = {
    [sym_identifier] = ACTIONS(421),
    [sym_comment] = ACTIONS(91),
  },
  [30] = {
    [sym__declarator] = STATE(145),
    [sym_pointer_declarator] = STATE(145),
    [sym_function_declarator] = STATE(145),
    [sym_array_declarator] = STATE(145),
    [sym__expression] = STATE(146),
    [sym_conditional_expression] = STATE(146),
    [sym_assignment_expression] = STATE(146),
    [sym_pointer_expression] = STATE(146),
    [sym_logical_expression] = STATE(146),
    [sym_bitwise_expression] = STATE(146),
    [sym_equality_expression] = STATE(146),
    [sym_relational_expression] = STATE(146),
    [sym_shift_expression] = STATE(146),
    [sym_math_expression] = STATE(146),
    [sym_cast_expression] = STATE(146),
    [sym_sizeof_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_compound_literal_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_char_literal] = STATE(146),
    [sym_concatenated_string] = STATE(146),
    [sym_string_literal] = STATE(55),
    [sym_reference_declarator] = STATE(145),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(57),
    [sym_new_expression] = STATE(146),
    [sym_delete_expression] = STATE(146),
    [sym_lambda_expression] = STATE(146),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_destructor_name] = STATE(145),
    [sym_scoped_identifier] = STATE(59),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(257),
    [anon_sym_LPAREN2] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(257),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(259),
    [sym_false] = ACTIONS(259),
    [sym_null] = ACTIONS(259),
    [sym_identifier] = ACTIONS(261),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_operator_name] = ACTIONS(265),
    [sym_nullptr] = ACTIONS(259),
  },
  [31] = {
    [sym__declarator] = STATE(145),
    [sym_pointer_declarator] = STATE(145),
    [sym_function_declarator] = STATE(145),
    [sym_array_declarator] = STATE(145),
    [sym_reference_declarator] = STATE(145),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(145),
    [sym_destructor_name] = STATE(145),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(431),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(265),
  },
  [32] = {
    [sym__expression] = STATE(250),
    [sym_conditional_expression] = STATE(250),
    [sym_assignment_expression] = STATE(250),
    [sym_pointer_expression] = STATE(250),
    [sym_logical_expression] = STATE(250),
    [sym_bitwise_expression] = STATE(250),
    [sym_equality_expression] = STATE(250),
    [sym_relational_expression] = STATE(250),
    [sym_shift_expression] = STATE(250),
    [sym_math_expression] = STATE(250),
    [sym_cast_expression] = STATE(250),
    [sym_sizeof_expression] = STATE(250),
    [sym_subscript_expression] = STATE(250),
    [sym_call_expression] = STATE(250),
    [sym_field_expression] = STATE(250),
    [sym_compound_literal_expression] = STATE(250),
    [sym_parenthesized_expression] = STATE(250),
    [sym_char_literal] = STATE(250),
    [sym_concatenated_string] = STATE(250),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(250),
    [sym_new_expression] = STATE(250),
    [sym_delete_expression] = STATE(250),
    [sym_lambda_expression] = STATE(250),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(435),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(435),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(437),
    [sym_false] = ACTIONS(437),
    [sym_null] = ACTIONS(437),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(437),
  },
  [33] = {
    [sym__expression] = STATE(252),
    [sym_conditional_expression] = STATE(252),
    [sym_assignment_expression] = STATE(252),
    [sym_pointer_expression] = STATE(252),
    [sym_logical_expression] = STATE(252),
    [sym_bitwise_expression] = STATE(252),
    [sym_equality_expression] = STATE(252),
    [sym_relational_expression] = STATE(252),
    [sym_shift_expression] = STATE(252),
    [sym_math_expression] = STATE(252),
    [sym_cast_expression] = STATE(252),
    [sym_sizeof_expression] = STATE(252),
    [sym_subscript_expression] = STATE(252),
    [sym_call_expression] = STATE(252),
    [sym_field_expression] = STATE(252),
    [sym_compound_literal_expression] = STATE(252),
    [sym_parenthesized_expression] = STATE(252),
    [sym_char_literal] = STATE(252),
    [sym_concatenated_string] = STATE(252),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(252),
    [sym_new_expression] = STATE(252),
    [sym_delete_expression] = STATE(252),
    [sym_lambda_expression] = STATE(252),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(439),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(439),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(441),
    [sym_false] = ACTIONS(441),
    [sym_null] = ACTIONS(441),
    [sym_identifier] = ACTIONS(443),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(441),
  },
  [34] = {
    [sym__expression] = STATE(253),
    [sym_conditional_expression] = STATE(253),
    [sym_assignment_expression] = STATE(253),
    [sym_pointer_expression] = STATE(253),
    [sym_logical_expression] = STATE(253),
    [sym_bitwise_expression] = STATE(253),
    [sym_equality_expression] = STATE(253),
    [sym_relational_expression] = STATE(253),
    [sym_shift_expression] = STATE(253),
    [sym_math_expression] = STATE(253),
    [sym_cast_expression] = STATE(253),
    [sym_sizeof_expression] = STATE(253),
    [sym_subscript_expression] = STATE(253),
    [sym_call_expression] = STATE(253),
    [sym_field_expression] = STATE(253),
    [sym_compound_literal_expression] = STATE(253),
    [sym_parenthesized_expression] = STATE(253),
    [sym_char_literal] = STATE(253),
    [sym_concatenated_string] = STATE(253),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(253),
    [sym_new_expression] = STATE(253),
    [sym_delete_expression] = STATE(253),
    [sym_lambda_expression] = STATE(253),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(445),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(445),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(447),
    [sym_false] = ACTIONS(447),
    [sym_null] = ACTIONS(447),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(447),
  },
  [35] = {
    [sym__expression] = STATE(255),
    [sym_conditional_expression] = STATE(255),
    [sym_assignment_expression] = STATE(255),
    [sym_pointer_expression] = STATE(255),
    [sym_logical_expression] = STATE(255),
    [sym_bitwise_expression] = STATE(255),
    [sym_equality_expression] = STATE(255),
    [sym_relational_expression] = STATE(255),
    [sym_shift_expression] = STATE(255),
    [sym_math_expression] = STATE(255),
    [sym_cast_expression] = STATE(255),
    [sym_sizeof_expression] = STATE(255),
    [sym_subscript_expression] = STATE(255),
    [sym_call_expression] = STATE(255),
    [sym_field_expression] = STATE(255),
    [sym_compound_literal_expression] = STATE(255),
    [sym_parenthesized_expression] = STATE(255),
    [sym_char_literal] = STATE(255),
    [sym_concatenated_string] = STATE(255),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(255),
    [sym_new_expression] = STATE(255),
    [sym_delete_expression] = STATE(255),
    [sym_lambda_expression] = STATE(255),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(449),
    [anon_sym_LPAREN2] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(449),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(453),
    [sym_false] = ACTIONS(453),
    [sym_null] = ACTIONS(453),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(453),
  },
  [36] = {
    [aux_sym_SLASH_LBRACK_CARET_BSLASHn_SQUOTE_RBRACK_SLASH] = ACTIONS(455),
    [sym_escape_sequence] = ACTIONS(457),
    [sym_comment] = ACTIONS(121),
  },
  [37] = {
    [aux_sym_string_literal_repeat1] = STATE(258),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_BSLASHn_RBRACK_SLASH] = ACTIONS(461),
    [sym_escape_sequence] = ACTIONS(461),
    [sym_comment] = ACTIONS(121),
  },
  [38] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(263),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(465),
    [anon_sym_extern] = ACTIONS(468),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(470),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_LBRACK] = ACTIONS(470),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_register] = ACTIONS(468),
    [anon_sym_inline] = ACTIONS(468),
    [anon_sym_const] = ACTIONS(468),
    [anon_sym_restrict] = ACTIONS(468),
    [anon_sym_volatile] = ACTIONS(468),
    [anon_sym__Atomic] = ACTIONS(468),
    [anon_sym_mutable] = ACTIONS(468),
    [anon_sym_explicit] = ACTIONS(468),
    [anon_sym_constexpr] = ACTIONS(468),
    [anon_sym_COLON] = ACTIONS(479),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(474),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_TILDE] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_identifier] = ACTIONS(468),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(486),
    [sym_operator_name] = ACTIONS(481),
  },
  [39] = {
    [sym_field_declaration_list] = STATE(265),
    [sym_virtual_specifier] = STATE(266),
    [sym_base_class_clause] = STATE(267),
    [sym_template_type] = STATE(268),
    [sym_scoped_type_identifier] = STATE(269),
    [sym_scoped_namespace_identifier] = STATE(180),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(488),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(315),
  },
  [40] = {
    [sym__type_specifier] = STATE(271),
    [sym_sized_type_specifier] = STATE(271),
    [sym_enum_specifier] = STATE(271),
    [sym_struct_specifier] = STATE(271),
    [sym_union_specifier] = STATE(271),
    [sym_macro_type_specifier] = STATE(271),
    [sym_class_specifier] = STATE(271),
    [sym_dependent_type] = STATE(271),
    [sym_template_type] = STATE(272),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(180),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(490),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [sym_identifier] = ACTIONS(492),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(490),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_COLON_COLON] = ACTIONS(315),
  },
  [41] = {
    [sym__declaration_specifiers] = STATE(280),
    [sym__declarator] = STATE(281),
    [sym_pointer_declarator] = STATE(281),
    [sym_function_declarator] = STATE(281),
    [sym_array_declarator] = STATE(281),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_parameter_list] = STATE(283),
    [sym_reference_declarator] = STATE(281),
    [sym_template_type] = STATE(284),
    [sym_template_function] = STATE(281),
    [sym_destructor_name] = STATE(281),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(285),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(494),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_AMP] = ACTIONS(500),
    [anon_sym_AMP_AMP] = ACTIONS(502),
    [anon_sym_TILDE] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(504),
    [sym_identifier] = ACTIONS(506),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_COLON_COLON] = ACTIONS(510),
    [sym_operator_name] = ACTIONS(512),
  },
  [42] = {
    [sym__expression] = STATE(289),
    [sym_conditional_expression] = STATE(289),
    [sym_assignment_expression] = STATE(289),
    [sym_pointer_expression] = STATE(289),
    [sym_logical_expression] = STATE(289),
    [sym_bitwise_expression] = STATE(289),
    [sym_equality_expression] = STATE(289),
    [sym_relational_expression] = STATE(289),
    [sym_shift_expression] = STATE(289),
    [sym_math_expression] = STATE(289),
    [sym_cast_expression] = STATE(289),
    [sym_sizeof_expression] = STATE(289),
    [sym_subscript_expression] = STATE(289),
    [sym_call_expression] = STATE(289),
    [sym_field_expression] = STATE(289),
    [sym_compound_literal_expression] = STATE(289),
    [sym_parenthesized_expression] = STATE(289),
    [sym_char_literal] = STATE(289),
    [sym_concatenated_string] = STATE(289),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(289),
    [sym_new_expression] = STATE(289),
    [sym_delete_expression] = STATE(289),
    [sym_lambda_expression] = STATE(289),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(514),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(516),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(514),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(518),
    [sym_false] = ACTIONS(518),
    [sym_null] = ACTIONS(518),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(518),
  },
  [43] = {
    [sym_declaration_list] = STATE(292),
    [anon_sym_LBRACE] = ACTIONS(520),
    [sym_identifier] = ACTIONS(522),
    [sym_comment] = ACTIONS(91),
  },
  [44] = {
    [sym_template_type] = STATE(296),
    [sym_scoped_identifier] = STATE(297),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(296),
    [sym_identifier] = ACTIONS(524),
    [sym_comment] = ACTIONS(91),
    [anon_sym_namespace] = ACTIONS(526),
    [anon_sym_COLON_COLON] = ACTIONS(528),
  },
  [45] = {
    [sym_compound_statement] = STATE(298),
    [anon_sym_LBRACE] = ACTIONS(357),
    [sym_comment] = ACTIONS(91),
  },
  [46] = {
    [sym__type_specifier] = STATE(307),
    [sym_sized_type_specifier] = STATE(307),
    [sym_enum_specifier] = STATE(307),
    [sym_struct_specifier] = STATE(307),
    [sym_union_specifier] = STATE(307),
    [sym_argument_list] = STATE(308),
    [sym_macro_type_specifier] = STATE(307),
    [sym_class_specifier] = STATE(307),
    [sym_dependent_type] = STATE(307),
    [sym_template_type] = STATE(309),
    [sym_scoped_type_identifier] = STATE(310),
    [sym_scoped_namespace_identifier] = STATE(311),
    [aux_sym_sized_type_specifier_repeat1] = STATE(312),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_unsigned] = ACTIONS(532),
    [anon_sym_long] = ACTIONS(532),
    [anon_sym_short] = ACTIONS(532),
    [sym_primitive_type] = ACTIONS(534),
    [anon_sym_enum] = ACTIONS(536),
    [anon_sym_struct] = ACTIONS(538),
    [anon_sym_union] = ACTIONS(540),
    [sym_identifier] = ACTIONS(542),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(544),
    [sym_auto] = ACTIONS(534),
    [anon_sym_typename] = ACTIONS(546),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [47] = {
    [sym_destructor_name] = STATE(315),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(550),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(552),
    [sym_operator_name] = ACTIONS(554),
  },
  [48] = {
    [ts_builtin_sym_end] = ACTIONS(556),
    [sym_comment] = ACTIONS(91),
  },
  [49] = {
    [sym__declarator] = STATE(321),
    [sym_pointer_declarator] = STATE(321),
    [sym_function_declarator] = STATE(321),
    [sym_array_declarator] = STATE(321),
    [sym_init_declarator] = STATE(322),
    [sym_reference_declarator] = STATE(321),
    [sym_structured_binding_reference_declarator] = STATE(323),
    [sym_structured_binding_declarator] = STATE(323),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(321),
    [sym_destructor_name] = STATE(321),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [anon_sym_SEMI] = ACTIONS(558),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(566),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(568),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(570),
  },
  [50] = {
    [sym_parameter_list] = STATE(326),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(574),
    [sym_comment] = ACTIONS(91),
  },
  [51] = {
    [sym_compound_statement] = STATE(329),
    [sym_field_initializer_list] = STATE(330),
    [sym_default_method_clause] = STATE(329),
    [sym_delete_method_clause] = STATE(329),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(576),
    [anon_sym_LBRACK] = ACTIONS(576),
    [anon_sym_EQ] = ACTIONS(578),
    [anon_sym_COLON] = ACTIONS(580),
    [sym_comment] = ACTIONS(91),
  },
  [52] = {
    [sym_storage_class_specifier] = STATE(331),
    [sym_type_qualifier] = STATE(331),
    [aux_sym__declaration_specifiers_repeat1] = STATE(331),
    [anon_sym_SEMI] = ACTIONS(582),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_LPAREN2] = ACTIONS(582),
    [anon_sym_STAR] = ACTIONS(582),
    [anon_sym_LBRACK] = ACTIONS(582),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(584),
    [anon_sym_AMP_AMP] = ACTIONS(582),
    [anon_sym_TILDE] = ACTIONS(582),
    [sym_identifier] = ACTIONS(584),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(582),
    [sym_operator_name] = ACTIONS(582),
  },
  [53] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(586),
    [anon_sym_SEMI] = ACTIONS(588),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(590),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(594),
    [anon_sym_QMARK] = ACTIONS(596),
    [anon_sym_STAR_EQ] = ACTIONS(598),
    [anon_sym_SLASH_EQ] = ACTIONS(598),
    [anon_sym_PERCENT_EQ] = ACTIONS(598),
    [anon_sym_PLUS_EQ] = ACTIONS(598),
    [anon_sym_DASH_EQ] = ACTIONS(598),
    [anon_sym_LT_LT_EQ] = ACTIONS(598),
    [anon_sym_GT_GT_EQ] = ACTIONS(598),
    [anon_sym_AMP_EQ] = ACTIONS(598),
    [anon_sym_CARET_EQ] = ACTIONS(598),
    [anon_sym_PIPE_EQ] = ACTIONS(598),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_PIPE_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(604),
    [anon_sym_PIPE] = ACTIONS(606),
    [anon_sym_CARET] = ACTIONS(608),
    [anon_sym_EQ_EQ] = ACTIONS(610),
    [anon_sym_BANG_EQ] = ACTIONS(610),
    [anon_sym_LT] = ACTIONS(612),
    [anon_sym_GT] = ACTIONS(612),
    [anon_sym_LT_EQ] = ACTIONS(614),
    [anon_sym_GT_EQ] = ACTIONS(614),
    [anon_sym_LT_LT] = ACTIONS(616),
    [anon_sym_GT_GT] = ACTIONS(616),
    [anon_sym_PLUS] = ACTIONS(618),
    [anon_sym_DASH] = ACTIONS(618),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [54] = {
    [anon_sym_SEMI] = ACTIONS(588),
    [sym_comment] = ACTIONS(91),
  },
  [55] = {
    [sym_string_literal] = STATE(350),
    [aux_sym_concatenated_string_repeat1] = STATE(350),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_LPAREN2] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(91),
  },
  [56] = {
    [sym_initializer_list] = STATE(352),
    [anon_sym_RPAREN] = ACTIONS(624),
    [anon_sym_SEMI] = ACTIONS(624),
    [anon_sym_extern] = ACTIONS(626),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(624),
    [anon_sym_STAR] = ACTIONS(624),
    [anon_sym_LBRACK] = ACTIONS(624),
    [anon_sym_static] = ACTIONS(626),
    [anon_sym_register] = ACTIONS(626),
    [anon_sym_inline] = ACTIONS(626),
    [anon_sym_const] = ACTIONS(626),
    [anon_sym_restrict] = ACTIONS(626),
    [anon_sym_volatile] = ACTIONS(626),
    [anon_sym__Atomic] = ACTIONS(626),
    [anon_sym_mutable] = ACTIONS(626),
    [anon_sym_explicit] = ACTIONS(626),
    [anon_sym_constexpr] = ACTIONS(626),
    [anon_sym_AMP] = ACTIONS(626),
    [anon_sym_AMP_AMP] = ACTIONS(624),
    [anon_sym_TILDE] = ACTIONS(624),
    [sym_identifier] = ACTIONS(626),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(628),
    [sym_operator_name] = ACTIONS(624),
  },
  [57] = {
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(630),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_LPAREN2] = ACTIONS(630),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(630),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_comment] = ACTIONS(91),
  },
  [58] = {
    [sym__abstract_declarator] = STATE(357),
    [sym_abstract_pointer_declarator] = STATE(357),
    [sym_abstract_function_declarator] = STATE(358),
    [sym_abstract_array_declarator] = STATE(357),
    [sym_parameter_list] = STATE(359),
    [sym_abstract_reference_declarator] = STATE(357),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_AMP] = ACTIONS(639),
    [anon_sym_AMP_AMP] = ACTIONS(641),
    [sym_comment] = ACTIONS(91),
  },
  [59] = {
    [sym_template_argument_list] = STATE(360),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(630),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_LPAREN2] = ACTIONS(630),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(630),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_comment] = ACTIONS(91),
  },
  [60] = {
    [sym_initializer_list] = STATE(352),
    [sym_template_argument_list] = STATE(362),
    [anon_sym_COMMA] = ACTIONS(624),
    [anon_sym_RPAREN] = ACTIONS(624),
    [anon_sym_SEMI] = ACTIONS(624),
    [anon_sym_extern] = ACTIONS(626),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(624),
    [anon_sym_STAR] = ACTIONS(624),
    [anon_sym_LBRACK] = ACTIONS(624),
    [anon_sym_static] = ACTIONS(626),
    [anon_sym_register] = ACTIONS(626),
    [anon_sym_inline] = ACTIONS(626),
    [anon_sym_const] = ACTIONS(626),
    [anon_sym_restrict] = ACTIONS(626),
    [anon_sym_volatile] = ACTIONS(626),
    [anon_sym__Atomic] = ACTIONS(626),
    [anon_sym_mutable] = ACTIONS(626),
    [anon_sym_explicit] = ACTIONS(626),
    [anon_sym_constexpr] = ACTIONS(626),
    [anon_sym_AMP] = ACTIONS(626),
    [anon_sym_AMP_AMP] = ACTIONS(624),
    [anon_sym_TILDE] = ACTIONS(624),
    [anon_sym_LT] = ACTIONS(643),
    [sym_identifier] = ACTIONS(626),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(624),
    [sym_operator_name] = ACTIONS(624),
  },
  [61] = {
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(628),
  },
  [62] = {
    [sym_preproc_include] = STATE(363),
    [sym_preproc_def] = STATE(363),
    [sym_preproc_function_def] = STATE(363),
    [sym_preproc_call] = STATE(363),
    [sym_preproc_if] = STATE(363),
    [sym_preproc_ifdef] = STATE(363),
    [sym_function_definition] = STATE(363),
    [sym_declaration] = STATE(363),
    [sym_type_definition] = STATE(363),
    [sym__declaration_specifiers] = STATE(49),
    [sym_linkage_specification] = STATE(363),
    [sym__declarator] = STATE(50),
    [sym_pointer_declarator] = STATE(50),
    [sym_function_declarator] = STATE(51),
    [sym_array_declarator] = STATE(50),
    [sym_compound_statement] = STATE(363),
    [sym_storage_class_specifier] = STATE(63),
    [sym_type_qualifier] = STATE(63),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(363),
    [sym_expression_statement] = STATE(363),
    [sym_if_statement] = STATE(363),
    [sym_switch_statement] = STATE(363),
    [sym_case_statement] = STATE(363),
    [sym_while_statement] = STATE(363),
    [sym_do_statement] = STATE(363),
    [sym_for_statement] = STATE(363),
    [sym_return_statement] = STATE(363),
    [sym_break_statement] = STATE(363),
    [sym_continue_statement] = STATE(363),
    [sym_goto_statement] = STATE(363),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(363),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(363),
    [sym_template_declaration] = STATE(363),
    [sym_template_instantiation] = STATE(363),
    [sym_constructor_or_destructor_definition] = STATE(363),
    [sym_reference_declarator] = STATE(50),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(57),
    [sym_namespace_definition] = STATE(363),
    [sym_using_declaration] = STATE(363),
    [sym_alias_declaration] = STATE(363),
    [sym_for_range_loop] = STATE(363),
    [sym_try_statement] = STATE(363),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_destructor_name] = STATE(50),
    [sym_scoped_identifier] = STATE(59),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_translation_unit_repeat1] = STATE(363),
    [aux_sym__declaration_specifiers_repeat1] = STATE(63),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(5),
    [ts_builtin_sym_end] = ACTIONS(645),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(9),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(13),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(15),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(15),
    [sym_preproc_directive] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_switch] = ACTIONS(49),
    [anon_sym_case] = ACTIONS(51),
    [anon_sym_default] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(89),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_template] = ACTIONS(97),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_namespace] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(103),
    [anon_sym_try] = ACTIONS(105),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_operator_name] = ACTIONS(111),
    [sym_nullptr] = ACTIONS(87),
  },
  [63] = {
    [sym__declarator] = STATE(50),
    [sym_pointer_declarator] = STATE(50),
    [sym_function_declarator] = STATE(366),
    [sym_array_declarator] = STATE(50),
    [sym_storage_class_specifier] = STATE(370),
    [sym_type_qualifier] = STATE(370),
    [sym__type_specifier] = STATE(367),
    [sym_sized_type_specifier] = STATE(367),
    [sym_enum_specifier] = STATE(367),
    [sym_struct_specifier] = STATE(367),
    [sym_union_specifier] = STATE(367),
    [sym_macro_type_specifier] = STATE(367),
    [sym_class_specifier] = STATE(367),
    [sym_dependent_type] = STATE(367),
    [sym_reference_declarator] = STATE(50),
    [sym_template_type] = STATE(368),
    [sym_template_function] = STATE(50),
    [sym_destructor_name] = STATE(50),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(369),
    [aux_sym__declaration_specifiers_repeat1] = STATE(370),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(425),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(647),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(649),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(647),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_COLON_COLON] = ACTIONS(651),
    [sym_operator_name] = ACTIONS(111),
  },
  [64] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(373),
    [anon_sym_SEMI] = ACTIONS(653),
    [anon_sym_extern] = ACTIONS(655),
    [anon_sym_LPAREN2] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_register] = ACTIONS(655),
    [anon_sym_inline] = ACTIONS(655),
    [anon_sym_const] = ACTIONS(655),
    [anon_sym_restrict] = ACTIONS(655),
    [anon_sym_volatile] = ACTIONS(655),
    [anon_sym__Atomic] = ACTIONS(655),
    [anon_sym_mutable] = ACTIONS(655),
    [anon_sym_explicit] = ACTIONS(655),
    [anon_sym_constexpr] = ACTIONS(655),
    [anon_sym_unsigned] = ACTIONS(657),
    [anon_sym_long] = ACTIONS(657),
    [anon_sym_short] = ACTIONS(657),
    [sym_primitive_type] = ACTIONS(659),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [anon_sym_TILDE] = ACTIONS(653),
    [sym_identifier] = ACTIONS(661),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(653),
    [sym_operator_name] = ACTIONS(653),
  },
  [65] = {
    [aux_sym_string_literal_repeat1] = STATE(375),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_BSLASHn_RBRACK_SLASH] = ACTIONS(666),
    [sym_escape_sequence] = ACTIONS(666),
    [sym_comment] = ACTIONS(121),
  },
  [66] = {
    [sym_raw_string_literal] = ACTIONS(668),
    [ts_builtin_sym_end] = ACTIONS(668),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(670),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(670),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(670),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(670),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(670),
    [sym_preproc_directive] = ACTIONS(670),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(670),
    [anon_sym_extern] = ACTIONS(670),
    [anon_sym_LBRACE] = ACTIONS(668),
    [anon_sym_RBRACE] = ACTIONS(668),
    [anon_sym_LPAREN2] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(668),
    [anon_sym_LBRACK] = ACTIONS(668),
    [anon_sym_static] = ACTIONS(670),
    [anon_sym_register] = ACTIONS(670),
    [anon_sym_inline] = ACTIONS(670),
    [anon_sym_const] = ACTIONS(670),
    [anon_sym_restrict] = ACTIONS(670),
    [anon_sym_volatile] = ACTIONS(670),
    [anon_sym__Atomic] = ACTIONS(670),
    [anon_sym_mutable] = ACTIONS(670),
    [anon_sym_explicit] = ACTIONS(670),
    [anon_sym_constexpr] = ACTIONS(670),
    [anon_sym_unsigned] = ACTIONS(670),
    [anon_sym_long] = ACTIONS(670),
    [anon_sym_short] = ACTIONS(670),
    [sym_primitive_type] = ACTIONS(670),
    [anon_sym_enum] = ACTIONS(670),
    [anon_sym_struct] = ACTIONS(670),
    [anon_sym_union] = ACTIONS(670),
    [anon_sym_if] = ACTIONS(670),
    [anon_sym_switch] = ACTIONS(670),
    [anon_sym_case] = ACTIONS(670),
    [anon_sym_default] = ACTIONS(670),
    [anon_sym_while] = ACTIONS(670),
    [anon_sym_do] = ACTIONS(670),
    [anon_sym_for] = ACTIONS(670),
    [anon_sym_return] = ACTIONS(670),
    [anon_sym_break] = ACTIONS(670),
    [anon_sym_continue] = ACTIONS(670),
    [anon_sym_goto] = ACTIONS(670),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_AMP_AMP] = ACTIONS(668),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_PLUS] = ACTIONS(670),
    [anon_sym_DASH] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(668),
    [anon_sym_PLUS_PLUS] = ACTIONS(668),
    [anon_sym_sizeof] = ACTIONS(670),
    [sym_number_literal] = ACTIONS(668),
    [anon_sym_SQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE] = ACTIONS(668),
    [sym_true] = ACTIONS(670),
    [sym_false] = ACTIONS(670),
    [sym_null] = ACTIONS(670),
    [sym_identifier] = ACTIONS(670),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(670),
    [sym_auto] = ACTIONS(670),
    [anon_sym_typename] = ACTIONS(670),
    [anon_sym_template] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_namespace] = ACTIONS(670),
    [anon_sym_using] = ACTIONS(670),
    [anon_sym_try] = ACTIONS(670),
    [anon_sym_new] = ACTIONS(670),
    [anon_sym_COLON_COLON] = ACTIONS(668),
    [sym_operator_name] = ACTIONS(668),
    [sym_nullptr] = ACTIONS(670),
  },
  [67] = {
    [sym_preproc_params] = STATE(379),
    [anon_sym_LF] = ACTIONS(672),
    [anon_sym_LPAREN] = ACTIONS(674),
    [sym_preproc_arg] = ACTIONS(676),
    [sym_comment] = ACTIONS(121),
  },
  [68] = {
    [sym_preproc_include] = STATE(413),
    [sym_preproc_def] = STATE(413),
    [sym_preproc_function_def] = STATE(413),
    [sym_preproc_call] = STATE(413),
    [sym_preproc_if] = STATE(413),
    [sym_preproc_ifdef] = STATE(413),
    [sym_preproc_else] = STATE(408),
    [sym_preproc_elif] = STATE(408),
    [sym_function_definition] = STATE(413),
    [sym_declaration] = STATE(413),
    [sym_type_definition] = STATE(413),
    [sym__declaration_specifiers] = STATE(409),
    [sym_linkage_specification] = STATE(413),
    [sym__declarator] = STATE(50),
    [sym_pointer_declarator] = STATE(50),
    [sym_function_declarator] = STATE(410),
    [sym_array_declarator] = STATE(50),
    [sym_compound_statement] = STATE(413),
    [sym_storage_class_specifier] = STATE(414),
    [sym_type_qualifier] = STATE(414),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(413),
    [sym_expression_statement] = STATE(413),
    [sym_if_statement] = STATE(413),
    [sym_switch_statement] = STATE(413),
    [sym_case_statement] = STATE(413),
    [sym_while_statement] = STATE(413),
    [sym_do_statement] = STATE(413),
    [sym_for_statement] = STATE(413),
    [sym_return_statement] = STATE(413),
    [sym_break_statement] = STATE(413),
    [sym_continue_statement] = STATE(413),
    [sym_goto_statement] = STATE(413),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(413),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(413),
    [sym_template_declaration] = STATE(413),
    [sym_template_instantiation] = STATE(413),
    [sym_constructor_or_destructor_definition] = STATE(413),
    [sym_reference_declarator] = STATE(50),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(57),
    [sym_namespace_definition] = STATE(413),
    [sym_using_declaration] = STATE(413),
    [sym_alias_declaration] = STATE(413),
    [sym_for_range_loop] = STATE(413),
    [sym_try_statement] = STATE(413),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_destructor_name] = STATE(50),
    [sym_scoped_identifier] = STATE(59),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_translation_unit_repeat1] = STATE(413),
    [aux_sym__declaration_specifiers_repeat1] = STATE(414),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(678),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(684),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(686),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(688),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(688),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(690),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(692),
    [sym_preproc_directive] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_typedef] = ACTIONS(698),
    [anon_sym_extern] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(704),
    [anon_sym_switch] = ACTIONS(706),
    [anon_sym_case] = ACTIONS(708),
    [anon_sym_default] = ACTIONS(710),
    [anon_sym_while] = ACTIONS(712),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(728),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_template] = ACTIONS(730),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_namespace] = ACTIONS(732),
    [anon_sym_using] = ACTIONS(734),
    [anon_sym_try] = ACTIONS(736),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_operator_name] = ACTIONS(111),
    [sym_nullptr] = ACTIONS(726),
  },
  [69] = {
    [sym_preproc_include] = STATE(417),
    [sym_preproc_def] = STATE(417),
    [sym_preproc_function_def] = STATE(417),
    [sym_preproc_call] = STATE(417),
    [sym_preproc_if] = STATE(417),
    [sym_preproc_ifdef] = STATE(417),
    [sym_preproc_else] = STATE(416),
    [sym_preproc_elif] = STATE(416),
    [sym_function_definition] = STATE(417),
    [sym_declaration] = STATE(417),
    [sym_type_definition] = STATE(417),
    [sym__declaration_specifiers] = STATE(409),
    [sym_linkage_specification] = STATE(417),
    [sym__declarator] = STATE(50),
    [sym_pointer_declarator] = STATE(50),
    [sym_function_declarator] = STATE(410),
    [sym_array_declarator] = STATE(50),
    [sym_compound_statement] = STATE(417),
    [sym_storage_class_specifier] = STATE(414),
    [sym_type_qualifier] = STATE(414),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(417),
    [sym_expression_statement] = STATE(417),
    [sym_if_statement] = STATE(417),
    [sym_switch_statement] = STATE(417),
    [sym_case_statement] = STATE(417),
    [sym_while_statement] = STATE(417),
    [sym_do_statement] = STATE(417),
    [sym_for_statement] = STATE(417),
    [sym_return_statement] = STATE(417),
    [sym_break_statement] = STATE(417),
    [sym_continue_statement] = STATE(417),
    [sym_goto_statement] = STATE(417),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(417),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(417),
    [sym_template_declaration] = STATE(417),
    [sym_template_instantiation] = STATE(417),
    [sym_constructor_or_destructor_definition] = STATE(417),
    [sym_reference_declarator] = STATE(50),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(57),
    [sym_namespace_definition] = STATE(417),
    [sym_using_declaration] = STATE(417),
    [sym_alias_declaration] = STATE(417),
    [sym_for_range_loop] = STATE(417),
    [sym_try_statement] = STATE(417),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_destructor_name] = STATE(50),
    [sym_scoped_identifier] = STATE(59),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_translation_unit_repeat1] = STATE(417),
    [aux_sym__declaration_specifiers_repeat1] = STATE(414),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(678),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(684),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(738),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(688),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(688),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(690),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(692),
    [sym_preproc_directive] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_typedef] = ACTIONS(698),
    [anon_sym_extern] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(704),
    [anon_sym_switch] = ACTIONS(706),
    [anon_sym_case] = ACTIONS(708),
    [anon_sym_default] = ACTIONS(710),
    [anon_sym_while] = ACTIONS(712),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(728),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_template] = ACTIONS(730),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_namespace] = ACTIONS(732),
    [anon_sym_using] = ACTIONS(734),
    [anon_sym_try] = ACTIONS(736),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_operator_name] = ACTIONS(111),
    [sym_nullptr] = ACTIONS(726),
  },
  [70] = {
    [sym_raw_string_literal] = ACTIONS(740),
    [ts_builtin_sym_end] = ACTIONS(740),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(742),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(742),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(742),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(742),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(742),
    [sym_preproc_directive] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(740),
    [anon_sym_typedef] = ACTIONS(742),
    [anon_sym_extern] = ACTIONS(742),
    [anon_sym_LBRACE] = ACTIONS(740),
    [anon_sym_RBRACE] = ACTIONS(740),
    [anon_sym_LPAREN2] = ACTIONS(740),
    [anon_sym_STAR] = ACTIONS(740),
    [anon_sym_LBRACK] = ACTIONS(740),
    [anon_sym_static] = ACTIONS(742),
    [anon_sym_register] = ACTIONS(742),
    [anon_sym_inline] = ACTIONS(742),
    [anon_sym_const] = ACTIONS(742),
    [anon_sym_restrict] = ACTIONS(742),
    [anon_sym_volatile] = ACTIONS(742),
    [anon_sym__Atomic] = ACTIONS(742),
    [anon_sym_mutable] = ACTIONS(742),
    [anon_sym_explicit] = ACTIONS(742),
    [anon_sym_constexpr] = ACTIONS(742),
    [anon_sym_unsigned] = ACTIONS(742),
    [anon_sym_long] = ACTIONS(742),
    [anon_sym_short] = ACTIONS(742),
    [sym_primitive_type] = ACTIONS(742),
    [anon_sym_enum] = ACTIONS(742),
    [anon_sym_struct] = ACTIONS(742),
    [anon_sym_union] = ACTIONS(742),
    [anon_sym_if] = ACTIONS(742),
    [anon_sym_switch] = ACTIONS(742),
    [anon_sym_case] = ACTIONS(742),
    [anon_sym_default] = ACTIONS(742),
    [anon_sym_while] = ACTIONS(742),
    [anon_sym_do] = ACTIONS(742),
    [anon_sym_for] = ACTIONS(742),
    [anon_sym_return] = ACTIONS(742),
    [anon_sym_break] = ACTIONS(742),
    [anon_sym_continue] = ACTIONS(742),
    [anon_sym_goto] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_AMP_AMP] = ACTIONS(740),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(742),
    [anon_sym_DASH] = ACTIONS(742),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_sizeof] = ACTIONS(742),
    [sym_number_literal] = ACTIONS(740),
    [anon_sym_SQUOTE] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(740),
    [sym_true] = ACTIONS(742),
    [sym_false] = ACTIONS(742),
    [sym_null] = ACTIONS(742),
    [sym_identifier] = ACTIONS(742),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(742),
    [sym_auto] = ACTIONS(742),
    [anon_sym_typename] = ACTIONS(742),
    [anon_sym_template] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(742),
    [anon_sym_namespace] = ACTIONS(742),
    [anon_sym_using] = ACTIONS(742),
    [anon_sym_try] = ACTIONS(742),
    [anon_sym_new] = ACTIONS(742),
    [anon_sym_COLON_COLON] = ACTIONS(740),
    [sym_operator_name] = ACTIONS(740),
    [sym_nullptr] = ACTIONS(742),
  },
  [71] = {
    [anon_sym_LF] = ACTIONS(744),
    [sym_comment] = ACTIONS(121),
  },
  [72] = {
    [anon_sym_extern] = ACTIONS(301),
    [anon_sym_LPAREN2] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_static] = ACTIONS(301),
    [anon_sym_register] = ACTIONS(301),
    [anon_sym_inline] = ACTIONS(301),
    [anon_sym_const] = ACTIONS(301),
    [anon_sym_restrict] = ACTIONS(301),
    [anon_sym_volatile] = ACTIONS(301),
    [anon_sym__Atomic] = ACTIONS(301),
    [anon_sym_mutable] = ACTIONS(301),
    [anon_sym_explicit] = ACTIONS(301),
    [anon_sym_constexpr] = ACTIONS(301),
    [anon_sym_unsigned] = ACTIONS(301),
    [anon_sym_long] = ACTIONS(301),
    [anon_sym_short] = ACTIONS(301),
    [sym_primitive_type] = ACTIONS(301),
    [anon_sym_enum] = ACTIONS(301),
    [anon_sym_struct] = ACTIONS(301),
    [anon_sym_union] = ACTIONS(301),
    [sym_identifier] = ACTIONS(301),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(301),
    [sym_auto] = ACTIONS(301),
    [anon_sym_typename] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(299),
  },
  [73] = {
    [sym_enumerator_list] = STATE(421),
    [anon_sym_LBRACE] = ACTIONS(746),
    [sym_identifier] = ACTIONS(748),
    [sym_comment] = ACTIONS(91),
  },
  [74] = {
    [sym_field_declaration_list] = STATE(424),
    [sym_virtual_specifier] = STATE(425),
    [sym_base_class_clause] = STATE(426),
    [sym_template_type] = STATE(427),
    [sym_scoped_type_identifier] = STATE(428),
    [sym_scoped_namespace_identifier] = STATE(83),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(752),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [75] = {
    [sym_field_declaration_list] = STATE(430),
    [sym_virtual_specifier] = STATE(431),
    [sym_base_class_clause] = STATE(432),
    [sym_template_type] = STATE(433),
    [sym_scoped_type_identifier] = STATE(434),
    [sym_scoped_namespace_identifier] = STATE(83),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(754),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [76] = {
    [sym_template_argument_list] = STATE(437),
    [anon_sym_LPAREN2] = ACTIONS(481),
    [anon_sym_STAR] = ACTIONS(481),
    [anon_sym_LT] = ACTIONS(756),
    [sym_identifier] = ACTIONS(481),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(758),
  },
  [77] = {
    [sym_field_declaration_list] = STATE(439),
    [sym_virtual_specifier] = STATE(440),
    [sym_base_class_clause] = STATE(441),
    [sym_template_type] = STATE(442),
    [sym_scoped_type_identifier] = STATE(443),
    [sym_scoped_namespace_identifier] = STATE(83),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(760),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [78] = {
    [sym__type_specifier] = STATE(444),
    [sym_sized_type_specifier] = STATE(444),
    [sym_enum_specifier] = STATE(444),
    [sym_struct_specifier] = STATE(444),
    [sym_union_specifier] = STATE(444),
    [sym_macro_type_specifier] = STATE(444),
    [sym_class_specifier] = STATE(444),
    [sym_dependent_type] = STATE(444),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(82),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_sized_type_specifier_repeat1] = STATE(85),
    [anon_sym_unsigned] = ACTIONS(135),
    [anon_sym_long] = ACTIONS(135),
    [anon_sym_short] = ACTIONS(135),
    [sym_primitive_type] = ACTIONS(762),
    [anon_sym_enum] = ACTIONS(139),
    [anon_sym_struct] = ACTIONS(141),
    [anon_sym_union] = ACTIONS(143),
    [sym_identifier] = ACTIONS(145),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(147),
    [sym_auto] = ACTIONS(762),
    [anon_sym_typename] = ACTIONS(149),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [79] = {
    [sym_identifier] = ACTIONS(764),
    [sym_comment] = ACTIONS(91),
  },
  [80] = {
    [sym__type_declarator] = STATE(449),
    [sym_pointer_type_declarator] = STATE(449),
    [sym_function_type_declarator] = STATE(449),
    [sym_array_type_declarator] = STATE(449),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_STAR] = ACTIONS(768),
    [sym_identifier] = ACTIONS(770),
    [sym_comment] = ACTIONS(91),
  },
  [81] = {
    [anon_sym_COMMA] = ACTIONS(624),
    [anon_sym_RPAREN] = ACTIONS(624),
    [anon_sym_SEMI] = ACTIONS(624),
    [anon_sym_LBRACE] = ACTIONS(624),
    [anon_sym_LPAREN2] = ACTIONS(624),
    [anon_sym_STAR] = ACTIONS(624),
    [anon_sym_LBRACK] = ACTIONS(624),
    [anon_sym_EQ] = ACTIONS(624),
    [anon_sym_const] = ACTIONS(626),
    [anon_sym_restrict] = ACTIONS(626),
    [anon_sym_volatile] = ACTIONS(626),
    [anon_sym__Atomic] = ACTIONS(626),
    [anon_sym_mutable] = ACTIONS(626),
    [anon_sym_explicit] = ACTIONS(626),
    [anon_sym_constexpr] = ACTIONS(626),
    [anon_sym_COLON] = ACTIONS(626),
    [anon_sym_AMP] = ACTIONS(626),
    [anon_sym_AMP_AMP] = ACTIONS(624),
    [anon_sym_DASH_GT] = ACTIONS(624),
    [sym_identifier] = ACTIONS(626),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(626),
    [anon_sym_override] = ACTIONS(626),
    [anon_sym_GT2] = ACTIONS(624),
    [sym_noexcept] = ACTIONS(626),
    [anon_sym_COLON_COLON] = ACTIONS(772),
  },
  [82] = {
    [sym_template_argument_list] = STATE(451),
    [anon_sym_LPAREN2] = ACTIONS(624),
    [anon_sym_STAR] = ACTIONS(624),
    [anon_sym_LT] = ACTIONS(756),
    [sym_identifier] = ACTIONS(624),
    [sym_comment] = ACTIONS(91),
  },
  [83] = {
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(772),
  },
  [84] = {
    [sym_type_qualifier] = STATE(453),
    [sym__type_specifier] = STATE(452),
    [sym_sized_type_specifier] = STATE(452),
    [sym_enum_specifier] = STATE(452),
    [sym_struct_specifier] = STATE(452),
    [sym_union_specifier] = STATE(452),
    [sym_macro_type_specifier] = STATE(452),
    [sym_class_specifier] = STATE(452),
    [sym_dependent_type] = STATE(452),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(82),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_type_definition_repeat1] = STATE(453),
    [aux_sym_sized_type_specifier_repeat1] = STATE(85),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(135),
    [anon_sym_long] = ACTIONS(135),
    [anon_sym_short] = ACTIONS(135),
    [sym_primitive_type] = ACTIONS(774),
    [anon_sym_enum] = ACTIONS(139),
    [anon_sym_struct] = ACTIONS(141),
    [anon_sym_union] = ACTIONS(143),
    [sym_identifier] = ACTIONS(145),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(147),
    [sym_auto] = ACTIONS(774),
    [anon_sym_typename] = ACTIONS(149),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [85] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(456),
    [anon_sym_LPAREN2] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(653),
    [anon_sym_unsigned] = ACTIONS(776),
    [anon_sym_long] = ACTIONS(776),
    [anon_sym_short] = ACTIONS(776),
    [sym_primitive_type] = ACTIONS(778),
    [sym_identifier] = ACTIONS(780),
    [sym_comment] = ACTIONS(91),
  },
  [86] = {
    [sym_function_definition] = STATE(457),
    [sym_declaration] = STATE(457),
    [sym__declaration_specifiers] = STATE(458),
    [sym_declaration_list] = STATE(457),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(272),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(180),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [sym_identifier] = ACTIONS(492),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_COLON_COLON] = ACTIONS(315),
  },
  [87] = {
    [sym_string_literal] = STATE(460),
    [anon_sym_DQUOTE] = ACTIONS(783),
    [sym_system_lib_string] = ACTIONS(785),
    [sym_comment] = ACTIONS(91),
  },
  [88] = {
    [sym_identifier] = ACTIONS(787),
    [sym_comment] = ACTIONS(91),
  },
  [89] = {
    [sym_preproc_arg] = ACTIONS(789),
    [sym_comment] = ACTIONS(121),
  },
  [90] = {
    [sym_identifier] = ACTIONS(791),
    [sym_comment] = ACTIONS(91),
  },
  [91] = {
    [anon_sym_LF] = ACTIONS(793),
    [sym_preproc_arg] = ACTIONS(795),
    [sym_comment] = ACTIONS(121),
  },
  [92] = {
    [sym_raw_string_literal] = ACTIONS(129),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(131),
    [sym_preproc_directive] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(129),
    [anon_sym_typedef] = ACTIONS(131),
    [anon_sym_extern] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_RBRACE] = ACTIONS(129),
    [anon_sym_LPAREN2] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(129),
    [anon_sym_static] = ACTIONS(131),
    [anon_sym_register] = ACTIONS(131),
    [anon_sym_inline] = ACTIONS(131),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_restrict] = ACTIONS(131),
    [anon_sym_volatile] = ACTIONS(131),
    [anon_sym__Atomic] = ACTIONS(131),
    [anon_sym_mutable] = ACTIONS(131),
    [anon_sym_explicit] = ACTIONS(131),
    [anon_sym_constexpr] = ACTIONS(131),
    [anon_sym_unsigned] = ACTIONS(131),
    [anon_sym_long] = ACTIONS(131),
    [anon_sym_short] = ACTIONS(131),
    [sym_primitive_type] = ACTIONS(131),
    [anon_sym_enum] = ACTIONS(131),
    [anon_sym_struct] = ACTIONS(131),
    [anon_sym_union] = ACTIONS(131),
    [anon_sym_if] = ACTIONS(131),
    [anon_sym_else] = ACTIONS(131),
    [anon_sym_switch] = ACTIONS(131),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(131),
    [anon_sym_break] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_goto] = ACTIONS(131),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_BANG] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_PLUS] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(129),
    [anon_sym_PLUS_PLUS] = ACTIONS(129),
    [anon_sym_sizeof] = ACTIONS(131),
    [sym_number_literal] = ACTIONS(129),
    [anon_sym_SQUOTE] = ACTIONS(129),
    [anon_sym_DQUOTE] = ACTIONS(129),
    [sym_true] = ACTIONS(131),
    [sym_false] = ACTIONS(131),
    [sym_null] = ACTIONS(131),
    [sym_identifier] = ACTIONS(131),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(131),
    [sym_auto] = ACTIONS(131),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_delete] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(131),
    [anon_sym_new] = ACTIONS(131),
    [anon_sym_COLON_COLON] = ACTIONS(129),
    [sym_nullptr] = ACTIONS(131),
  },
  [93] = {
    [sym_type_qualifier] = STATE(467),
    [sym__type_specifier] = STATE(466),
    [sym_sized_type_specifier] = STATE(466),
    [sym_enum_specifier] = STATE(466),
    [sym_struct_specifier] = STATE(466),
    [sym_union_specifier] = STATE(466),
    [sym_macro_type_specifier] = STATE(466),
    [sym_class_specifier] = STATE(466),
    [sym_dependent_type] = STATE(466),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(82),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_type_definition_repeat1] = STATE(467),
    [aux_sym_sized_type_specifier_repeat1] = STATE(85),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(135),
    [anon_sym_long] = ACTIONS(135),
    [anon_sym_short] = ACTIONS(135),
    [sym_primitive_type] = ACTIONS(797),
    [anon_sym_enum] = ACTIONS(139),
    [anon_sym_struct] = ACTIONS(141),
    [anon_sym_union] = ACTIONS(143),
    [sym_identifier] = ACTIONS(145),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(147),
    [sym_auto] = ACTIONS(797),
    [anon_sym_typename] = ACTIONS(149),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [94] = {
    [anon_sym_extern] = ACTIONS(153),
    [anon_sym_static] = ACTIONS(153),
    [anon_sym_register] = ACTIONS(153),
    [anon_sym_inline] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(153),
    [anon_sym_restrict] = ACTIONS(153),
    [anon_sym_volatile] = ACTIONS(153),
    [anon_sym__Atomic] = ACTIONS(153),
    [anon_sym_mutable] = ACTIONS(153),
    [anon_sym_explicit] = ACTIONS(153),
    [anon_sym_constexpr] = ACTIONS(153),
    [anon_sym_unsigned] = ACTIONS(153),
    [anon_sym_long] = ACTIONS(153),
    [anon_sym_short] = ACTIONS(153),
    [sym_primitive_type] = ACTIONS(153),
    [anon_sym_enum] = ACTIONS(153),
    [anon_sym_struct] = ACTIONS(153),
    [anon_sym_union] = ACTIONS(153),
    [sym_identifier] = ACTIONS(153),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(153),
    [sym_auto] = ACTIONS(153),
    [anon_sym_typename] = ACTIONS(153),
    [anon_sym_COLON_COLON] = ACTIONS(155),
  },
  [95] = {
    [sym_preproc_include] = STATE(469),
    [sym_preproc_def] = STATE(469),
    [sym_preproc_function_def] = STATE(469),
    [sym_preproc_call] = STATE(469),
    [sym_preproc_if_in_compound_statement] = STATE(469),
    [sym_preproc_ifdef_in_compound_statement] = STATE(469),
    [sym_declaration] = STATE(469),
    [sym_type_definition] = STATE(469),
    [sym__declaration_specifiers] = STATE(113),
    [sym_compound_statement] = STATE(469),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(469),
    [sym_expression_statement] = STATE(469),
    [sym_if_statement] = STATE(469),
    [sym_switch_statement] = STATE(469),
    [sym_case_statement] = STATE(469),
    [sym_while_statement] = STATE(469),
    [sym_do_statement] = STATE(469),
    [sym_for_statement] = STATE(469),
    [sym_return_statement] = STATE(469),
    [sym_break_statement] = STATE(469),
    [sym_continue_statement] = STATE(469),
    [sym_goto_statement] = STATE(469),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(469),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(469),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(469),
    [sym_try_statement] = STATE(469),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(469),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(157),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(159),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(161),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(163),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(165),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(165),
    [sym_preproc_directive] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_typedef] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_RBRACE] = ACTIONS(799),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(185),
    [anon_sym_case] = ACTIONS(187),
    [anon_sym_default] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(209),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_nullptr] = ACTIONS(207),
  },
  [96] = {
    [sym_raw_string_literal] = ACTIONS(801),
    [ts_builtin_sym_end] = ACTIONS(801),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(803),
    [sym_preproc_directive] = ACTIONS(803),
    [anon_sym_SEMI] = ACTIONS(801),
    [anon_sym_typedef] = ACTIONS(803),
    [anon_sym_extern] = ACTIONS(803),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(801),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(801),
    [anon_sym_LBRACK] = ACTIONS(801),
    [anon_sym_static] = ACTIONS(803),
    [anon_sym_register] = ACTIONS(803),
    [anon_sym_inline] = ACTIONS(803),
    [anon_sym_const] = ACTIONS(803),
    [anon_sym_restrict] = ACTIONS(803),
    [anon_sym_volatile] = ACTIONS(803),
    [anon_sym__Atomic] = ACTIONS(803),
    [anon_sym_mutable] = ACTIONS(803),
    [anon_sym_explicit] = ACTIONS(803),
    [anon_sym_constexpr] = ACTIONS(803),
    [anon_sym_unsigned] = ACTIONS(803),
    [anon_sym_long] = ACTIONS(803),
    [anon_sym_short] = ACTIONS(803),
    [sym_primitive_type] = ACTIONS(803),
    [anon_sym_enum] = ACTIONS(803),
    [anon_sym_struct] = ACTIONS(803),
    [anon_sym_union] = ACTIONS(803),
    [anon_sym_if] = ACTIONS(803),
    [anon_sym_else] = ACTIONS(803),
    [anon_sym_switch] = ACTIONS(803),
    [anon_sym_case] = ACTIONS(803),
    [anon_sym_default] = ACTIONS(803),
    [anon_sym_while] = ACTIONS(803),
    [anon_sym_do] = ACTIONS(803),
    [anon_sym_for] = ACTIONS(803),
    [anon_sym_return] = ACTIONS(803),
    [anon_sym_break] = ACTIONS(803),
    [anon_sym_continue] = ACTIONS(803),
    [anon_sym_goto] = ACTIONS(803),
    [anon_sym_AMP] = ACTIONS(803),
    [anon_sym_AMP_AMP] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_DASH] = ACTIONS(803),
    [anon_sym_DASH_DASH] = ACTIONS(801),
    [anon_sym_PLUS_PLUS] = ACTIONS(801),
    [anon_sym_sizeof] = ACTIONS(803),
    [sym_number_literal] = ACTIONS(801),
    [anon_sym_SQUOTE] = ACTIONS(801),
    [anon_sym_DQUOTE] = ACTIONS(801),
    [sym_true] = ACTIONS(803),
    [sym_false] = ACTIONS(803),
    [sym_null] = ACTIONS(803),
    [sym_identifier] = ACTIONS(803),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(803),
    [sym_auto] = ACTIONS(803),
    [anon_sym_typename] = ACTIONS(803),
    [anon_sym_template] = ACTIONS(803),
    [anon_sym_delete] = ACTIONS(803),
    [anon_sym_namespace] = ACTIONS(803),
    [anon_sym_using] = ACTIONS(803),
    [anon_sym_try] = ACTIONS(803),
    [anon_sym_catch] = ACTIONS(803),
    [anon_sym_new] = ACTIONS(803),
    [anon_sym_COLON_COLON] = ACTIONS(801),
    [sym_operator_name] = ACTIONS(801),
    [sym_nullptr] = ACTIONS(803),
  },
  [97] = {
    [sym_type_qualifier] = STATE(141),
    [sym__type_specifier] = STATE(136),
    [sym_sized_type_specifier] = STATE(136),
    [sym_enum_specifier] = STATE(136),
    [sym_struct_specifier] = STATE(136),
    [sym_union_specifier] = STATE(136),
    [sym__expression] = STATE(137),
    [sym_comma_expression] = STATE(138),
    [sym_conditional_expression] = STATE(137),
    [sym_assignment_expression] = STATE(137),
    [sym_pointer_expression] = STATE(137),
    [sym_logical_expression] = STATE(137),
    [sym_bitwise_expression] = STATE(137),
    [sym_equality_expression] = STATE(137),
    [sym_relational_expression] = STATE(137),
    [sym_shift_expression] = STATE(137),
    [sym_math_expression] = STATE(137),
    [sym_cast_expression] = STATE(137),
    [sym_type_descriptor] = STATE(139),
    [sym_sizeof_expression] = STATE(137),
    [sym_subscript_expression] = STATE(137),
    [sym_call_expression] = STATE(137),
    [sym_field_expression] = STATE(137),
    [sym_compound_literal_expression] = STATE(137),
    [sym_parenthesized_expression] = STATE(137),
    [sym_char_literal] = STATE(137),
    [sym_concatenated_string] = STATE(137),
    [sym_string_literal] = STATE(140),
    [sym_macro_type_specifier] = STATE(136),
    [sym_class_specifier] = STATE(136),
    [sym_dependent_type] = STATE(136),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(137),
    [sym_new_expression] = STATE(137),
    [sym_delete_expression] = STATE(137),
    [sym_lambda_expression] = STATE(137),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_type_definition_repeat1] = STATE(141),
    [aux_sym_sized_type_specifier_repeat1] = STATE(142),
    [sym_raw_string_literal] = ACTIONS(213),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(219),
    [anon_sym_long] = ACTIONS(219),
    [anon_sym_short] = ACTIONS(219),
    [sym_primitive_type] = ACTIONS(221),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [sym_null] = ACTIONS(241),
    [sym_identifier] = ACTIONS(811),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(221),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(253),
    [sym_nullptr] = ACTIONS(241),
  },
  [98] = {
    [sym__expression] = STATE(146),
    [sym_conditional_expression] = STATE(146),
    [sym_assignment_expression] = STATE(146),
    [sym_pointer_expression] = STATE(146),
    [sym_logical_expression] = STATE(146),
    [sym_bitwise_expression] = STATE(146),
    [sym_equality_expression] = STATE(146),
    [sym_relational_expression] = STATE(146),
    [sym_shift_expression] = STATE(146),
    [sym_math_expression] = STATE(146),
    [sym_cast_expression] = STATE(146),
    [sym_sizeof_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_compound_literal_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_char_literal] = STATE(146),
    [sym_concatenated_string] = STATE(146),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(146),
    [sym_new_expression] = STATE(146),
    [sym_delete_expression] = STATE(146),
    [sym_lambda_expression] = STATE(146),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(257),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(257),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(259),
    [sym_false] = ACTIONS(259),
    [sym_null] = ACTIONS(259),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(259),
  },
  [99] = {
    [anon_sym_LPAREN2] = ACTIONS(813),
    [anon_sym_constexpr] = ACTIONS(815),
    [sym_comment] = ACTIONS(91),
  },
  [100] = {
    [sym_parenthesized_expression] = STATE(476),
    [anon_sym_LPAREN2] = ACTIONS(323),
    [sym_comment] = ACTIONS(91),
  },
  [101] = {
    [sym__expression] = STATE(477),
    [sym_conditional_expression] = STATE(477),
    [sym_assignment_expression] = STATE(477),
    [sym_pointer_expression] = STATE(477),
    [sym_logical_expression] = STATE(477),
    [sym_bitwise_expression] = STATE(477),
    [sym_equality_expression] = STATE(477),
    [sym_relational_expression] = STATE(477),
    [sym_shift_expression] = STATE(477),
    [sym_math_expression] = STATE(477),
    [sym_cast_expression] = STATE(477),
    [sym_sizeof_expression] = STATE(477),
    [sym_subscript_expression] = STATE(477),
    [sym_call_expression] = STATE(477),
    [sym_field_expression] = STATE(477),
    [sym_compound_literal_expression] = STATE(477),
    [sym_parenthesized_expression] = STATE(477),
    [sym_char_literal] = STATE(477),
    [sym_concatenated_string] = STATE(477),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(477),
    [sym_new_expression] = STATE(477),
    [sym_delete_expression] = STATE(477),
    [sym_lambda_expression] = STATE(477),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(817),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(817),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(819),
    [sym_false] = ACTIONS(819),
    [sym_null] = ACTIONS(819),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(819),
  },
  [102] = {
    [anon_sym_COLON] = ACTIONS(821),
    [sym_comment] = ACTIONS(91),
  },
  [103] = {
    [sym_parenthesized_expression] = STATE(479),
    [anon_sym_LPAREN2] = ACTIONS(323),
    [sym_comment] = ACTIONS(91),
  },
  [104] = {
    [sym_compound_statement] = STATE(480),
    [sym_labeled_statement] = STATE(480),
    [sym_expression_statement] = STATE(480),
    [sym_if_statement] = STATE(480),
    [sym_switch_statement] = STATE(480),
    [sym_case_statement] = STATE(480),
    [sym_while_statement] = STATE(480),
    [sym_do_statement] = STATE(480),
    [sym_for_statement] = STATE(480),
    [sym_return_statement] = STATE(480),
    [sym_break_statement] = STATE(480),
    [sym_continue_statement] = STATE(480),
    [sym_goto_statement] = STATE(480),
    [sym__expression] = STATE(222),
    [sym_comma_expression] = STATE(223),
    [sym_conditional_expression] = STATE(222),
    [sym_assignment_expression] = STATE(222),
    [sym_pointer_expression] = STATE(222),
    [sym_logical_expression] = STATE(222),
    [sym_bitwise_expression] = STATE(222),
    [sym_equality_expression] = STATE(222),
    [sym_relational_expression] = STATE(222),
    [sym_shift_expression] = STATE(222),
    [sym_math_expression] = STATE(222),
    [sym_cast_expression] = STATE(222),
    [sym_sizeof_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_call_expression] = STATE(222),
    [sym_field_expression] = STATE(222),
    [sym_compound_literal_expression] = STATE(222),
    [sym_parenthesized_expression] = STATE(222),
    [sym_char_literal] = STATE(222),
    [sym_concatenated_string] = STATE(222),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(222),
    [sym_for_range_loop] = STATE(480),
    [sym_try_statement] = STATE(480),
    [sym_new_expression] = STATE(222),
    [sym_delete_expression] = STATE(222),
    [sym_lambda_expression] = STATE(222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(359),
    [anon_sym_switch] = ACTIONS(361),
    [anon_sym_case] = ACTIONS(363),
    [anon_sym_default] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [anon_sym_do] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(373),
    [anon_sym_break] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_goto] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(353),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_identifier] = ACTIONS(383),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(381),
  },
  [105] = {
    [anon_sym_LPAREN2] = ACTIONS(823),
    [sym_comment] = ACTIONS(91),
  },
  [106] = {
    [sym__expression] = STATE(483),
    [sym_conditional_expression] = STATE(483),
    [sym_assignment_expression] = STATE(483),
    [sym_pointer_expression] = STATE(483),
    [sym_logical_expression] = STATE(483),
    [sym_bitwise_expression] = STATE(483),
    [sym_equality_expression] = STATE(483),
    [sym_relational_expression] = STATE(483),
    [sym_shift_expression] = STATE(483),
    [sym_math_expression] = STATE(483),
    [sym_cast_expression] = STATE(483),
    [sym_sizeof_expression] = STATE(483),
    [sym_subscript_expression] = STATE(483),
    [sym_call_expression] = STATE(483),
    [sym_field_expression] = STATE(483),
    [sym_compound_literal_expression] = STATE(483),
    [sym_parenthesized_expression] = STATE(483),
    [sym_initializer_list] = STATE(484),
    [sym_char_literal] = STATE(483),
    [sym_concatenated_string] = STATE(483),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(483),
    [sym_new_expression] = STATE(483),
    [sym_delete_expression] = STATE(483),
    [sym_lambda_expression] = STATE(483),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(825),
    [anon_sym_SEMI] = ACTIONS(827),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(825),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(829),
    [sym_false] = ACTIONS(829),
    [sym_null] = ACTIONS(829),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(829),
  },
  [107] = {
    [anon_sym_SEMI] = ACTIONS(831),
    [sym_comment] = ACTIONS(91),
  },
  [108] = {
    [anon_sym_SEMI] = ACTIONS(833),
    [sym_comment] = ACTIONS(91),
  },
  [109] = {
    [sym_identifier] = ACTIONS(835),
    [sym_comment] = ACTIONS(91),
  },
  [110] = {
    [sym__expression] = STATE(252),
    [sym_conditional_expression] = STATE(252),
    [sym_assignment_expression] = STATE(252),
    [sym_pointer_expression] = STATE(252),
    [sym_logical_expression] = STATE(252),
    [sym_bitwise_expression] = STATE(252),
    [sym_equality_expression] = STATE(252),
    [sym_relational_expression] = STATE(252),
    [sym_shift_expression] = STATE(252),
    [sym_math_expression] = STATE(252),
    [sym_cast_expression] = STATE(252),
    [sym_sizeof_expression] = STATE(252),
    [sym_subscript_expression] = STATE(252),
    [sym_call_expression] = STATE(252),
    [sym_field_expression] = STATE(252),
    [sym_compound_literal_expression] = STATE(252),
    [sym_parenthesized_expression] = STATE(252),
    [sym_char_literal] = STATE(252),
    [sym_concatenated_string] = STATE(252),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(252),
    [sym_new_expression] = STATE(252),
    [sym_delete_expression] = STATE(252),
    [sym_lambda_expression] = STATE(252),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(439),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(439),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(441),
    [sym_false] = ACTIONS(441),
    [sym_null] = ACTIONS(441),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(441),
  },
  [111] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(263),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(465),
    [anon_sym_extern] = ACTIONS(468),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_RBRACE] = ACTIONS(463),
    [anon_sym_LPAREN2] = ACTIONS(465),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_register] = ACTIONS(468),
    [anon_sym_inline] = ACTIONS(468),
    [anon_sym_const] = ACTIONS(468),
    [anon_sym_restrict] = ACTIONS(468),
    [anon_sym_volatile] = ACTIONS(468),
    [anon_sym__Atomic] = ACTIONS(468),
    [anon_sym_mutable] = ACTIONS(468),
    [anon_sym_explicit] = ACTIONS(468),
    [anon_sym_constexpr] = ACTIONS(468),
    [anon_sym_COLON] = ACTIONS(837),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(474),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_TILDE] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_identifier] = ACTIONS(468),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(486),
    [sym_operator_name] = ACTIONS(481),
  },
  [112] = {
    [sym_compound_statement] = STATE(489),
    [anon_sym_LBRACE] = ACTIONS(357),
    [sym_comment] = ACTIONS(91),
  },
  [113] = {
    [sym__declarator] = STATE(491),
    [sym_pointer_declarator] = STATE(491),
    [sym_function_declarator] = STATE(491),
    [sym_array_declarator] = STATE(491),
    [sym_init_declarator] = STATE(492),
    [sym_reference_declarator] = STATE(491),
    [sym_structured_binding_reference_declarator] = STATE(493),
    [sym_structured_binding_declarator] = STATE(493),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(491),
    [sym_destructor_name] = STATE(491),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [anon_sym_SEMI] = ACTIONS(839),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(566),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(568),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(841),
  },
  [114] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(586),
    [anon_sym_SEMI] = ACTIONS(843),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(590),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(594),
    [anon_sym_QMARK] = ACTIONS(596),
    [anon_sym_STAR_EQ] = ACTIONS(598),
    [anon_sym_SLASH_EQ] = ACTIONS(598),
    [anon_sym_PERCENT_EQ] = ACTIONS(598),
    [anon_sym_PLUS_EQ] = ACTIONS(598),
    [anon_sym_DASH_EQ] = ACTIONS(598),
    [anon_sym_LT_LT_EQ] = ACTIONS(598),
    [anon_sym_GT_GT_EQ] = ACTIONS(598),
    [anon_sym_AMP_EQ] = ACTIONS(598),
    [anon_sym_CARET_EQ] = ACTIONS(598),
    [anon_sym_PIPE_EQ] = ACTIONS(598),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_PIPE_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(604),
    [anon_sym_PIPE] = ACTIONS(606),
    [anon_sym_CARET] = ACTIONS(608),
    [anon_sym_EQ_EQ] = ACTIONS(610),
    [anon_sym_BANG_EQ] = ACTIONS(610),
    [anon_sym_LT] = ACTIONS(612),
    [anon_sym_GT] = ACTIONS(612),
    [anon_sym_LT_EQ] = ACTIONS(614),
    [anon_sym_GT_EQ] = ACTIONS(614),
    [anon_sym_LT_LT] = ACTIONS(616),
    [anon_sym_GT_GT] = ACTIONS(616),
    [anon_sym_PLUS] = ACTIONS(618),
    [anon_sym_DASH] = ACTIONS(618),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [115] = {
    [anon_sym_SEMI] = ACTIONS(843),
    [sym_comment] = ACTIONS(91),
  },
  [116] = {
    [sym_template_argument_list] = STATE(360),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_RBRACE] = ACTIONS(463),
    [anon_sym_LPAREN2] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_RBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_comment] = ACTIONS(91),
  },
  [117] = {
    [sym_preproc_include] = STATE(496),
    [sym_preproc_def] = STATE(496),
    [sym_preproc_function_def] = STATE(496),
    [sym_preproc_call] = STATE(496),
    [sym_preproc_if_in_compound_statement] = STATE(496),
    [sym_preproc_ifdef_in_compound_statement] = STATE(496),
    [sym_declaration] = STATE(496),
    [sym_type_definition] = STATE(496),
    [sym__declaration_specifiers] = STATE(113),
    [sym_compound_statement] = STATE(496),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(496),
    [sym_expression_statement] = STATE(496),
    [sym_if_statement] = STATE(496),
    [sym_switch_statement] = STATE(496),
    [sym_case_statement] = STATE(496),
    [sym_while_statement] = STATE(496),
    [sym_do_statement] = STATE(496),
    [sym_for_statement] = STATE(496),
    [sym_return_statement] = STATE(496),
    [sym_break_statement] = STATE(496),
    [sym_continue_statement] = STATE(496),
    [sym_goto_statement] = STATE(496),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(496),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(496),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(496),
    [sym_try_statement] = STATE(496),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(496),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(157),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(159),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(161),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(163),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(165),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(165),
    [sym_preproc_directive] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_typedef] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_RBRACE] = ACTIONS(845),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(185),
    [anon_sym_case] = ACTIONS(187),
    [anon_sym_default] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(209),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_nullptr] = ACTIONS(207),
  },
  [118] = {
    [sym_storage_class_specifier] = STATE(497),
    [sym_type_qualifier] = STATE(497),
    [sym__type_specifier] = STATE(367),
    [sym_sized_type_specifier] = STATE(367),
    [sym_enum_specifier] = STATE(367),
    [sym_struct_specifier] = STATE(367),
    [sym_union_specifier] = STATE(367),
    [sym_macro_type_specifier] = STATE(367),
    [sym_class_specifier] = STATE(367),
    [sym_dependent_type] = STATE(367),
    [sym_template_type] = STATE(272),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(180),
    [aux_sym__declaration_specifiers_repeat1] = STATE(497),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(647),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [sym_identifier] = ACTIONS(492),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(647),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_COLON_COLON] = ACTIONS(315),
  },
  [119] = {
    [sym__declarator] = STATE(135),
    [sym_pointer_declarator] = STATE(135),
    [sym_function_declarator] = STATE(135),
    [sym_array_declarator] = STATE(135),
    [sym_type_qualifier] = STATE(141),
    [sym__type_specifier] = STATE(136),
    [sym_sized_type_specifier] = STATE(136),
    [sym_enum_specifier] = STATE(136),
    [sym_struct_specifier] = STATE(136),
    [sym_union_specifier] = STATE(136),
    [sym__expression] = STATE(137),
    [sym_comma_expression] = STATE(138),
    [sym_conditional_expression] = STATE(137),
    [sym_assignment_expression] = STATE(137),
    [sym_pointer_expression] = STATE(137),
    [sym_logical_expression] = STATE(137),
    [sym_bitwise_expression] = STATE(137),
    [sym_equality_expression] = STATE(137),
    [sym_relational_expression] = STATE(137),
    [sym_shift_expression] = STATE(137),
    [sym_math_expression] = STATE(137),
    [sym_cast_expression] = STATE(137),
    [sym_type_descriptor] = STATE(498),
    [sym_sizeof_expression] = STATE(137),
    [sym_subscript_expression] = STATE(137),
    [sym_call_expression] = STATE(137),
    [sym_field_expression] = STATE(137),
    [sym_compound_literal_expression] = STATE(137),
    [sym_parenthesized_expression] = STATE(137),
    [sym_char_literal] = STATE(137),
    [sym_concatenated_string] = STATE(137),
    [sym_string_literal] = STATE(140),
    [sym_macro_type_specifier] = STATE(136),
    [sym_class_specifier] = STATE(136),
    [sym_dependent_type] = STATE(136),
    [sym_reference_declarator] = STATE(135),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(57),
    [sym_new_expression] = STATE(137),
    [sym_delete_expression] = STATE(137),
    [sym_lambda_expression] = STATE(137),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_destructor_name] = STATE(135),
    [sym_scoped_identifier] = STATE(59),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_type_definition_repeat1] = STATE(141),
    [aux_sym_sized_type_specifier_repeat1] = STATE(142),
    [sym_raw_string_literal] = ACTIONS(213),
    [anon_sym_LPAREN2] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(217),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(219),
    [anon_sym_long] = ACTIONS(219),
    [anon_sym_short] = ACTIONS(219),
    [sym_primitive_type] = ACTIONS(221),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [anon_sym_AMP] = ACTIONS(227),
    [anon_sym_AMP_AMP] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(233),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [sym_null] = ACTIONS(241),
    [sym_identifier] = ACTIONS(243),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(221),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(253),
    [sym_operator_name] = ACTIONS(255),
    [sym_nullptr] = ACTIONS(241),
  },
  [120] = {
    [sym__declarator] = STATE(500),
    [sym_pointer_declarator] = STATE(500),
    [sym_function_declarator] = STATE(500),
    [sym_array_declarator] = STATE(500),
    [sym_type_qualifier] = STATE(501),
    [sym__expression] = STATE(146),
    [sym_conditional_expression] = STATE(146),
    [sym_assignment_expression] = STATE(146),
    [sym_pointer_expression] = STATE(146),
    [sym_logical_expression] = STATE(146),
    [sym_bitwise_expression] = STATE(146),
    [sym_equality_expression] = STATE(146),
    [sym_relational_expression] = STATE(146),
    [sym_shift_expression] = STATE(146),
    [sym_math_expression] = STATE(146),
    [sym_cast_expression] = STATE(146),
    [sym_sizeof_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_compound_literal_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_char_literal] = STATE(146),
    [sym_concatenated_string] = STATE(146),
    [sym_string_literal] = STATE(140),
    [sym_reference_declarator] = STATE(500),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(57),
    [sym_new_expression] = STATE(146),
    [sym_delete_expression] = STATE(146),
    [sym_lambda_expression] = STATE(146),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_destructor_name] = STATE(500),
    [sym_scoped_identifier] = STATE(59),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [aux_sym_type_definition_repeat1] = STATE(501),
    [sym_raw_string_literal] = ACTIONS(257),
    [anon_sym_LPAREN2] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(217),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(227),
    [anon_sym_AMP_AMP] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(233),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(257),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(259),
    [sym_false] = ACTIONS(259),
    [sym_null] = ACTIONS(259),
    [sym_identifier] = ACTIONS(261),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_operator_name] = ACTIONS(849),
    [sym_nullptr] = ACTIONS(259),
  },
  [121] = {
    [sym_field_declaration_list] = STATE(175),
    [sym_virtual_specifier] = STATE(176),
    [sym_base_class_clause] = STATE(177),
    [sym_template_type] = STATE(503),
    [sym_scoped_type_identifier] = STATE(504),
    [sym_scoped_namespace_identifier] = STATE(83),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(851),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [122] = {
    [sym_field_declaration_list] = STATE(182),
    [sym_virtual_specifier] = STATE(183),
    [sym_base_class_clause] = STATE(184),
    [sym_template_type] = STATE(506),
    [sym_scoped_type_identifier] = STATE(507),
    [sym_scoped_namespace_identifier] = STATE(83),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(853),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [123] = {
    [sym__declarator] = STATE(508),
    [sym_pointer_declarator] = STATE(508),
    [sym_function_declarator] = STATE(508),
    [sym_array_declarator] = STATE(508),
    [sym__expression] = STATE(146),
    [sym_conditional_expression] = STATE(146),
    [sym_assignment_expression] = STATE(146),
    [sym_pointer_expression] = STATE(146),
    [sym_logical_expression] = STATE(146),
    [sym_bitwise_expression] = STATE(146),
    [sym_equality_expression] = STATE(146),
    [sym_relational_expression] = STATE(146),
    [sym_shift_expression] = STATE(146),
    [sym_math_expression] = STATE(146),
    [sym_cast_expression] = STATE(146),
    [sym_sizeof_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_compound_literal_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_char_literal] = STATE(146),
    [sym_concatenated_string] = STATE(146),
    [sym_string_literal] = STATE(140),
    [sym_reference_declarator] = STATE(508),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(57),
    [sym_new_expression] = STATE(146),
    [sym_delete_expression] = STATE(146),
    [sym_lambda_expression] = STATE(146),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_destructor_name] = STATE(508),
    [sym_scoped_identifier] = STATE(59),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(257),
    [anon_sym_LPAREN2] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(217),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(227),
    [anon_sym_AMP_AMP] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(233),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(257),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(259),
    [sym_false] = ACTIONS(259),
    [sym_null] = ACTIONS(259),
    [sym_identifier] = ACTIONS(261),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_operator_name] = ACTIONS(855),
    [sym_nullptr] = ACTIONS(259),
  },
  [124] = {
    [sym__declarator] = STATE(508),
    [sym_pointer_declarator] = STATE(508),
    [sym_function_declarator] = STATE(508),
    [sym_array_declarator] = STATE(508),
    [sym_reference_declarator] = STATE(508),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(508),
    [sym_destructor_name] = STATE(508),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(859),
    [anon_sym_AMP_AMP] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(431),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(855),
  },
  [125] = {
    [sym__expression] = STATE(250),
    [sym_conditional_expression] = STATE(250),
    [sym_assignment_expression] = STATE(250),
    [sym_pointer_expression] = STATE(250),
    [sym_logical_expression] = STATE(250),
    [sym_bitwise_expression] = STATE(250),
    [sym_equality_expression] = STATE(250),
    [sym_relational_expression] = STATE(250),
    [sym_shift_expression] = STATE(250),
    [sym_math_expression] = STATE(250),
    [sym_cast_expression] = STATE(250),
    [sym_sizeof_expression] = STATE(250),
    [sym_subscript_expression] = STATE(250),
    [sym_call_expression] = STATE(250),
    [sym_field_expression] = STATE(250),
    [sym_compound_literal_expression] = STATE(250),
    [sym_parenthesized_expression] = STATE(250),
    [sym_char_literal] = STATE(250),
    [sym_concatenated_string] = STATE(250),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(250),
    [sym_new_expression] = STATE(250),
    [sym_delete_expression] = STATE(250),
    [sym_lambda_expression] = STATE(250),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(435),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(435),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(437),
    [sym_false] = ACTIONS(437),
    [sym_null] = ACTIONS(437),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(437),
  },
  [126] = {
    [sym__expression] = STATE(252),
    [sym_conditional_expression] = STATE(252),
    [sym_assignment_expression] = STATE(252),
    [sym_pointer_expression] = STATE(252),
    [sym_logical_expression] = STATE(252),
    [sym_bitwise_expression] = STATE(252),
    [sym_equality_expression] = STATE(252),
    [sym_relational_expression] = STATE(252),
    [sym_shift_expression] = STATE(252),
    [sym_math_expression] = STATE(252),
    [sym_cast_expression] = STATE(252),
    [sym_sizeof_expression] = STATE(252),
    [sym_subscript_expression] = STATE(252),
    [sym_call_expression] = STATE(252),
    [sym_field_expression] = STATE(252),
    [sym_compound_literal_expression] = STATE(252),
    [sym_parenthesized_expression] = STATE(252),
    [sym_char_literal] = STATE(252),
    [sym_concatenated_string] = STATE(252),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(252),
    [sym_new_expression] = STATE(252),
    [sym_delete_expression] = STATE(252),
    [sym_lambda_expression] = STATE(252),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(439),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(439),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(441),
    [sym_false] = ACTIONS(441),
    [sym_null] = ACTIONS(441),
    [sym_identifier] = ACTIONS(443),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(441),
  },
  [127] = {
    [sym__expression] = STATE(253),
    [sym_conditional_expression] = STATE(253),
    [sym_assignment_expression] = STATE(253),
    [sym_pointer_expression] = STATE(253),
    [sym_logical_expression] = STATE(253),
    [sym_bitwise_expression] = STATE(253),
    [sym_equality_expression] = STATE(253),
    [sym_relational_expression] = STATE(253),
    [sym_shift_expression] = STATE(253),
    [sym_math_expression] = STATE(253),
    [sym_cast_expression] = STATE(253),
    [sym_sizeof_expression] = STATE(253),
    [sym_subscript_expression] = STATE(253),
    [sym_call_expression] = STATE(253),
    [sym_field_expression] = STATE(253),
    [sym_compound_literal_expression] = STATE(253),
    [sym_parenthesized_expression] = STATE(253),
    [sym_char_literal] = STATE(253),
    [sym_concatenated_string] = STATE(253),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(253),
    [sym_new_expression] = STATE(253),
    [sym_delete_expression] = STATE(253),
    [sym_lambda_expression] = STATE(253),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(445),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(445),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(447),
    [sym_false] = ACTIONS(447),
    [sym_null] = ACTIONS(447),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(447),
  },
  [128] = {
    [sym__expression] = STATE(511),
    [sym_conditional_expression] = STATE(511),
    [sym_assignment_expression] = STATE(511),
    [sym_pointer_expression] = STATE(511),
    [sym_logical_expression] = STATE(511),
    [sym_bitwise_expression] = STATE(511),
    [sym_equality_expression] = STATE(511),
    [sym_relational_expression] = STATE(511),
    [sym_shift_expression] = STATE(511),
    [sym_math_expression] = STATE(511),
    [sym_cast_expression] = STATE(511),
    [sym_sizeof_expression] = STATE(511),
    [sym_subscript_expression] = STATE(511),
    [sym_call_expression] = STATE(511),
    [sym_field_expression] = STATE(511),
    [sym_compound_literal_expression] = STATE(511),
    [sym_parenthesized_expression] = STATE(511),
    [sym_char_literal] = STATE(511),
    [sym_concatenated_string] = STATE(511),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(511),
    [sym_new_expression] = STATE(511),
    [sym_delete_expression] = STATE(511),
    [sym_lambda_expression] = STATE(511),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(861),
    [anon_sym_LPAREN2] = ACTIONS(863),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(861),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(865),
    [sym_false] = ACTIONS(865),
    [sym_null] = ACTIONS(865),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(865),
  },
  [129] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(263),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(470),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_LBRACK] = ACTIONS(470),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(474),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(486),
  },
  [130] = {
    [sym_field_declaration_list] = STATE(265),
    [sym_virtual_specifier] = STATE(266),
    [sym_base_class_clause] = STATE(267),
    [sym_template_type] = STATE(513),
    [sym_scoped_type_identifier] = STATE(514),
    [sym_scoped_namespace_identifier] = STATE(83),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(867),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [131] = {
    [sym__type_specifier] = STATE(271),
    [sym_sized_type_specifier] = STATE(271),
    [sym_enum_specifier] = STATE(271),
    [sym_struct_specifier] = STATE(271),
    [sym_union_specifier] = STATE(271),
    [sym_macro_type_specifier] = STATE(271),
    [sym_class_specifier] = STATE(271),
    [sym_dependent_type] = STATE(271),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_sized_type_specifier_repeat1] = STATE(142),
    [anon_sym_unsigned] = ACTIONS(219),
    [anon_sym_long] = ACTIONS(219),
    [anon_sym_short] = ACTIONS(219),
    [sym_primitive_type] = ACTIONS(490),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(490),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [132] = {
    [sym__expression] = STATE(517),
    [sym_conditional_expression] = STATE(517),
    [sym_assignment_expression] = STATE(517),
    [sym_pointer_expression] = STATE(517),
    [sym_logical_expression] = STATE(517),
    [sym_bitwise_expression] = STATE(517),
    [sym_equality_expression] = STATE(517),
    [sym_relational_expression] = STATE(517),
    [sym_shift_expression] = STATE(517),
    [sym_math_expression] = STATE(517),
    [sym_cast_expression] = STATE(517),
    [sym_sizeof_expression] = STATE(517),
    [sym_subscript_expression] = STATE(517),
    [sym_call_expression] = STATE(517),
    [sym_field_expression] = STATE(517),
    [sym_compound_literal_expression] = STATE(517),
    [sym_parenthesized_expression] = STATE(517),
    [sym_char_literal] = STATE(517),
    [sym_concatenated_string] = STATE(517),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(517),
    [sym_new_expression] = STATE(517),
    [sym_delete_expression] = STATE(517),
    [sym_lambda_expression] = STATE(517),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(871),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(875),
    [sym_false] = ACTIONS(875),
    [sym_null] = ACTIONS(875),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(875),
  },
  [133] = {
    [sym__type_specifier] = STATE(519),
    [sym_sized_type_specifier] = STATE(519),
    [sym_enum_specifier] = STATE(519),
    [sym_struct_specifier] = STATE(519),
    [sym_union_specifier] = STATE(519),
    [sym_argument_list] = STATE(520),
    [sym_macro_type_specifier] = STATE(519),
    [sym_class_specifier] = STATE(519),
    [sym_dependent_type] = STATE(519),
    [sym_template_type] = STATE(309),
    [sym_scoped_type_identifier] = STATE(310),
    [sym_scoped_namespace_identifier] = STATE(311),
    [aux_sym_sized_type_specifier_repeat1] = STATE(521),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_unsigned] = ACTIONS(877),
    [anon_sym_long] = ACTIONS(877),
    [anon_sym_short] = ACTIONS(877),
    [sym_primitive_type] = ACTIONS(879),
    [anon_sym_enum] = ACTIONS(536),
    [anon_sym_struct] = ACTIONS(538),
    [anon_sym_union] = ACTIONS(540),
    [sym_identifier] = ACTIONS(542),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(544),
    [sym_auto] = ACTIONS(879),
    [anon_sym_typename] = ACTIONS(881),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [134] = {
    [sym_destructor_name] = STATE(315),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(550),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(883),
    [sym_operator_name] = ACTIONS(554),
  },
  [135] = {
    [sym_parameter_list] = STATE(524),
    [anon_sym_RPAREN] = ACTIONS(885),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(574),
    [sym_comment] = ACTIONS(91),
  },
  [136] = {
    [sym__abstract_declarator] = STATE(527),
    [sym_abstract_pointer_declarator] = STATE(527),
    [sym_abstract_function_declarator] = STATE(527),
    [sym_abstract_array_declarator] = STATE(527),
    [sym_parameter_list] = STATE(528),
    [sym_abstract_reference_declarator] = STATE(527),
    [anon_sym_RPAREN] = ACTIONS(887),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_AMP_AMP] = ACTIONS(893),
    [sym_comment] = ACTIONS(91),
  },
  [137] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(895),
    [anon_sym_RPAREN] = ACTIONS(897),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [138] = {
    [anon_sym_RPAREN] = ACTIONS(897),
    [sym_comment] = ACTIONS(91),
  },
  [139] = {
    [anon_sym_RPAREN] = ACTIONS(927),
    [sym_comment] = ACTIONS(91),
  },
  [140] = {
    [sym_string_literal] = STATE(544),
    [aux_sym_concatenated_string_repeat1] = STATE(544),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(463),
    [anon_sym_LPAREN2] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(91),
  },
  [141] = {
    [sym_type_qualifier] = STATE(453),
    [sym__type_specifier] = STATE(545),
    [sym_sized_type_specifier] = STATE(545),
    [sym_enum_specifier] = STATE(545),
    [sym_struct_specifier] = STATE(545),
    [sym_union_specifier] = STATE(545),
    [sym_macro_type_specifier] = STATE(545),
    [sym_class_specifier] = STATE(545),
    [sym_dependent_type] = STATE(545),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_type_definition_repeat1] = STATE(453),
    [aux_sym_sized_type_specifier_repeat1] = STATE(142),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(219),
    [anon_sym_long] = ACTIONS(219),
    [anon_sym_short] = ACTIONS(219),
    [sym_primitive_type] = ACTIONS(929),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(929),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [142] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(546),
    [anon_sym_RPAREN] = ACTIONS(653),
    [anon_sym_LPAREN2] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_unsigned] = ACTIONS(931),
    [anon_sym_long] = ACTIONS(931),
    [anon_sym_short] = ACTIONS(931),
    [sym_primitive_type] = ACTIONS(659),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [sym_identifier] = ACTIONS(933),
    [sym_comment] = ACTIONS(91),
  },
  [143] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(548),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(630),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(630),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(630),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(935),
  },
  [144] = {
    [sym_destructor_name] = STATE(315),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(937),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(552),
    [sym_operator_name] = ACTIONS(554),
  },
  [145] = {
    [sym_parameter_list] = STATE(550),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(574),
    [sym_comment] = ACTIONS(91),
  },
  [146] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_RPAREN] = ACTIONS(939),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_RBRACE] = ACTIONS(939),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(941),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(939),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(939),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(939),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_DASH] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [147] = {
    [sym_initializer_list] = STATE(352),
    [anon_sym_LBRACE] = ACTIONS(393),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(943),
  },
  [148] = {
    [sym_initializer_list] = STATE(352),
    [sym_template_argument_list] = STATE(362),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LT] = ACTIONS(945),
    [sym_comment] = ACTIONS(91),
  },
  [149] = {
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(943),
  },
  [150] = {
    [sym__declarator] = STATE(145),
    [sym_pointer_declarator] = STATE(145),
    [sym_function_declarator] = STATE(145),
    [sym_array_declarator] = STATE(145),
    [sym_type_qualifier] = STATE(552),
    [sym_reference_declarator] = STATE(145),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(145),
    [sym_destructor_name] = STATE(145),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [aux_sym_type_definition_repeat1] = STATE(552),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(425),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(431),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(265),
  },
  [151] = {
    [sym_type_qualifier] = STATE(141),
    [sym__type_specifier] = STATE(136),
    [sym_sized_type_specifier] = STATE(136),
    [sym_enum_specifier] = STATE(136),
    [sym_struct_specifier] = STATE(136),
    [sym_union_specifier] = STATE(136),
    [sym__expression] = STATE(137),
    [sym_comma_expression] = STATE(138),
    [sym_conditional_expression] = STATE(137),
    [sym_assignment_expression] = STATE(137),
    [sym_pointer_expression] = STATE(137),
    [sym_logical_expression] = STATE(137),
    [sym_bitwise_expression] = STATE(137),
    [sym_equality_expression] = STATE(137),
    [sym_relational_expression] = STATE(137),
    [sym_shift_expression] = STATE(137),
    [sym_math_expression] = STATE(137),
    [sym_cast_expression] = STATE(137),
    [sym_type_descriptor] = STATE(553),
    [sym_sizeof_expression] = STATE(137),
    [sym_subscript_expression] = STATE(137),
    [sym_call_expression] = STATE(137),
    [sym_field_expression] = STATE(137),
    [sym_compound_literal_expression] = STATE(137),
    [sym_parenthesized_expression] = STATE(137),
    [sym_char_literal] = STATE(137),
    [sym_concatenated_string] = STATE(137),
    [sym_string_literal] = STATE(140),
    [sym_macro_type_specifier] = STATE(136),
    [sym_class_specifier] = STATE(136),
    [sym_dependent_type] = STATE(136),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(137),
    [sym_new_expression] = STATE(137),
    [sym_delete_expression] = STATE(137),
    [sym_lambda_expression] = STATE(137),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_type_definition_repeat1] = STATE(141),
    [aux_sym_sized_type_specifier_repeat1] = STATE(142),
    [sym_raw_string_literal] = ACTIONS(213),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(219),
    [anon_sym_long] = ACTIONS(219),
    [anon_sym_short] = ACTIONS(219),
    [sym_primitive_type] = ACTIONS(221),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [sym_null] = ACTIONS(241),
    [sym_identifier] = ACTIONS(811),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(221),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(253),
    [sym_nullptr] = ACTIONS(241),
  },
  [152] = {
    [sym__expression] = STATE(146),
    [sym_conditional_expression] = STATE(146),
    [sym_assignment_expression] = STATE(146),
    [sym_pointer_expression] = STATE(146),
    [sym_logical_expression] = STATE(146),
    [sym_bitwise_expression] = STATE(146),
    [sym_equality_expression] = STATE(146),
    [sym_relational_expression] = STATE(146),
    [sym_shift_expression] = STATE(146),
    [sym_math_expression] = STATE(146),
    [sym_cast_expression] = STATE(146),
    [sym_sizeof_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_compound_literal_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_char_literal] = STATE(146),
    [sym_concatenated_string] = STATE(146),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(146),
    [sym_new_expression] = STATE(146),
    [sym_delete_expression] = STATE(146),
    [sym_lambda_expression] = STATE(146),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(257),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(257),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(259),
    [sym_false] = ACTIONS(259),
    [sym_null] = ACTIONS(259),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(259),
  },
  [153] = {
    [anon_sym_LPAREN2] = ACTIONS(947),
    [anon_sym_STAR] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(947),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [sym_comment] = ACTIONS(91),
  },
  [154] = {
    [anon_sym_RBRACK] = ACTIONS(951),
    [sym_comment] = ACTIONS(91),
  },
  [155] = {
    [sym__expression] = STATE(146),
    [sym_conditional_expression] = STATE(146),
    [sym_assignment_expression] = STATE(146),
    [sym_pointer_expression] = STATE(146),
    [sym_logical_expression] = STATE(146),
    [sym_bitwise_expression] = STATE(146),
    [sym_equality_expression] = STATE(146),
    [sym_relational_expression] = STATE(146),
    [sym_shift_expression] = STATE(146),
    [sym_math_expression] = STATE(146),
    [sym_cast_expression] = STATE(146),
    [sym_sizeof_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_compound_literal_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_char_literal] = STATE(146),
    [sym_concatenated_string] = STATE(146),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(146),
    [sym_new_expression] = STATE(146),
    [sym_delete_expression] = STATE(146),
    [sym_lambda_expression] = STATE(146),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(257),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(951),
    [anon_sym_AMP] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(257),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(259),
    [sym_false] = ACTIONS(259),
    [sym_null] = ACTIONS(259),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(259),
  },
  [156] = {
    [sym__expression] = STATE(250),
    [sym_conditional_expression] = STATE(250),
    [sym_assignment_expression] = STATE(250),
    [sym_pointer_expression] = STATE(250),
    [sym_logical_expression] = STATE(250),
    [sym_bitwise_expression] = STATE(250),
    [sym_equality_expression] = STATE(250),
    [sym_relational_expression] = STATE(250),
    [sym_shift_expression] = STATE(250),
    [sym_math_expression] = STATE(250),
    [sym_cast_expression] = STATE(250),
    [sym_sizeof_expression] = STATE(250),
    [sym_subscript_expression] = STATE(250),
    [sym_call_expression] = STATE(250),
    [sym_field_expression] = STATE(250),
    [sym_compound_literal_expression] = STATE(250),
    [sym_parenthesized_expression] = STATE(250),
    [sym_char_literal] = STATE(250),
    [sym_concatenated_string] = STATE(250),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(250),
    [sym_new_expression] = STATE(250),
    [sym_delete_expression] = STATE(250),
    [sym_lambda_expression] = STATE(250),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(435),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(435),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(437),
    [sym_false] = ACTIONS(437),
    [sym_null] = ACTIONS(437),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(437),
  },
  [157] = {
    [sym__expression] = STATE(252),
    [sym_conditional_expression] = STATE(252),
    [sym_assignment_expression] = STATE(252),
    [sym_pointer_expression] = STATE(252),
    [sym_logical_expression] = STATE(252),
    [sym_bitwise_expression] = STATE(252),
    [sym_equality_expression] = STATE(252),
    [sym_relational_expression] = STATE(252),
    [sym_shift_expression] = STATE(252),
    [sym_math_expression] = STATE(252),
    [sym_cast_expression] = STATE(252),
    [sym_sizeof_expression] = STATE(252),
    [sym_subscript_expression] = STATE(252),
    [sym_call_expression] = STATE(252),
    [sym_field_expression] = STATE(252),
    [sym_compound_literal_expression] = STATE(252),
    [sym_parenthesized_expression] = STATE(252),
    [sym_char_literal] = STATE(252),
    [sym_concatenated_string] = STATE(252),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(252),
    [sym_new_expression] = STATE(252),
    [sym_delete_expression] = STATE(252),
    [sym_lambda_expression] = STATE(252),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(439),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(439),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(441),
    [sym_false] = ACTIONS(441),
    [sym_null] = ACTIONS(441),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(441),
  },
  [158] = {
    [sym__expression] = STATE(253),
    [sym_conditional_expression] = STATE(253),
    [sym_assignment_expression] = STATE(253),
    [sym_pointer_expression] = STATE(253),
    [sym_logical_expression] = STATE(253),
    [sym_bitwise_expression] = STATE(253),
    [sym_equality_expression] = STATE(253),
    [sym_relational_expression] = STATE(253),
    [sym_shift_expression] = STATE(253),
    [sym_math_expression] = STATE(253),
    [sym_cast_expression] = STATE(253),
    [sym_sizeof_expression] = STATE(253),
    [sym_subscript_expression] = STATE(253),
    [sym_call_expression] = STATE(253),
    [sym_field_expression] = STATE(253),
    [sym_compound_literal_expression] = STATE(253),
    [sym_parenthesized_expression] = STATE(253),
    [sym_char_literal] = STATE(253),
    [sym_concatenated_string] = STATE(253),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(253),
    [sym_new_expression] = STATE(253),
    [sym_delete_expression] = STATE(253),
    [sym_lambda_expression] = STATE(253),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(445),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(445),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(447),
    [sym_false] = ACTIONS(447),
    [sym_null] = ACTIONS(447),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(447),
  },
  [159] = {
    [sym__expression] = STATE(555),
    [sym_conditional_expression] = STATE(555),
    [sym_assignment_expression] = STATE(555),
    [sym_pointer_expression] = STATE(555),
    [sym_logical_expression] = STATE(555),
    [sym_bitwise_expression] = STATE(555),
    [sym_equality_expression] = STATE(555),
    [sym_relational_expression] = STATE(555),
    [sym_shift_expression] = STATE(555),
    [sym_math_expression] = STATE(555),
    [sym_cast_expression] = STATE(555),
    [sym_sizeof_expression] = STATE(555),
    [sym_subscript_expression] = STATE(555),
    [sym_call_expression] = STATE(555),
    [sym_field_expression] = STATE(555),
    [sym_compound_literal_expression] = STATE(555),
    [sym_parenthesized_expression] = STATE(555),
    [sym_char_literal] = STATE(555),
    [sym_concatenated_string] = STATE(555),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(555),
    [sym_new_expression] = STATE(555),
    [sym_delete_expression] = STATE(555),
    [sym_lambda_expression] = STATE(555),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(953),
    [anon_sym_LPAREN2] = ACTIONS(955),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(953),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(957),
    [sym_false] = ACTIONS(957),
    [sym_null] = ACTIONS(957),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(957),
  },
  [160] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(548),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_RBRACE] = ACTIONS(463),
    [anon_sym_LPAREN2] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_RBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_COLON] = ACTIONS(477),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(935),
  },
  [161] = {
    [sym__expression] = STATE(557),
    [sym_conditional_expression] = STATE(557),
    [sym_assignment_expression] = STATE(557),
    [sym_pointer_expression] = STATE(557),
    [sym_logical_expression] = STATE(557),
    [sym_bitwise_expression] = STATE(557),
    [sym_equality_expression] = STATE(557),
    [sym_relational_expression] = STATE(557),
    [sym_shift_expression] = STATE(557),
    [sym_math_expression] = STATE(557),
    [sym_cast_expression] = STATE(557),
    [sym_sizeof_expression] = STATE(557),
    [sym_subscript_expression] = STATE(557),
    [sym_call_expression] = STATE(557),
    [sym_field_expression] = STATE(557),
    [sym_compound_literal_expression] = STATE(557),
    [sym_parenthesized_expression] = STATE(557),
    [sym_char_literal] = STATE(557),
    [sym_concatenated_string] = STATE(557),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(557),
    [sym_new_expression] = STATE(557),
    [sym_delete_expression] = STATE(557),
    [sym_lambda_expression] = STATE(557),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(959),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(961),
    [anon_sym_AMP] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(959),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(963),
    [sym_false] = ACTIONS(963),
    [sym_null] = ACTIONS(963),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(963),
  },
  [162] = {
    [sym__type_specifier] = STATE(559),
    [sym_sized_type_specifier] = STATE(559),
    [sym_enum_specifier] = STATE(559),
    [sym_struct_specifier] = STATE(559),
    [sym_union_specifier] = STATE(559),
    [sym_argument_list] = STATE(560),
    [sym_macro_type_specifier] = STATE(559),
    [sym_class_specifier] = STATE(559),
    [sym_dependent_type] = STATE(559),
    [sym_template_type] = STATE(309),
    [sym_scoped_type_identifier] = STATE(310),
    [sym_scoped_namespace_identifier] = STATE(311),
    [aux_sym_sized_type_specifier_repeat1] = STATE(561),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_unsigned] = ACTIONS(965),
    [anon_sym_long] = ACTIONS(965),
    [anon_sym_short] = ACTIONS(965),
    [sym_primitive_type] = ACTIONS(967),
    [anon_sym_enum] = ACTIONS(536),
    [anon_sym_struct] = ACTIONS(538),
    [anon_sym_union] = ACTIONS(540),
    [sym_identifier] = ACTIONS(542),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(544),
    [sym_auto] = ACTIONS(967),
    [anon_sym_typename] = ACTIONS(969),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [163] = {
    [sym_destructor_name] = STATE(315),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(937),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(971),
    [sym_operator_name] = ACTIONS(554),
  },
  [164] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(577),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(977),
    [anon_sym_EQ] = ACTIONS(979),
    [anon_sym_QMARK] = ACTIONS(981),
    [anon_sym_STAR_EQ] = ACTIONS(983),
    [anon_sym_SLASH_EQ] = ACTIONS(983),
    [anon_sym_PERCENT_EQ] = ACTIONS(983),
    [anon_sym_PLUS_EQ] = ACTIONS(983),
    [anon_sym_DASH_EQ] = ACTIONS(983),
    [anon_sym_LT_LT_EQ] = ACTIONS(983),
    [anon_sym_GT_GT_EQ] = ACTIONS(983),
    [anon_sym_AMP_EQ] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(983),
    [anon_sym_PIPE_EQ] = ACTIONS(983),
    [anon_sym_AMP] = ACTIONS(985),
    [anon_sym_PIPE_PIPE] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(989),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_CARET] = ACTIONS(993),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(999),
    [anon_sym_LT_LT] = ACTIONS(1001),
    [anon_sym_GT_GT] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(975),
    [anon_sym_PERCENT] = ACTIONS(975),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [165] = {
    [sym_string_literal] = STATE(578),
    [aux_sym_concatenated_string_repeat1] = STATE(578),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_LPAREN2] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_RBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(91),
  },
  [166] = {
    [anon_sym_RBRACK] = ACTIONS(977),
    [sym_comment] = ACTIONS(91),
  },
  [167] = {
    [sym_enumerator] = STATE(582),
    [anon_sym_COMMA] = ACTIONS(1005),
    [anon_sym_RBRACE] = ACTIONS(1007),
    [sym_identifier] = ACTIONS(1009),
    [sym_comment] = ACTIONS(91),
  },
  [168] = {
    [sym_enumerator_list] = STATE(583),
    [anon_sym_COMMA] = ACTIONS(1011),
    [anon_sym_RPAREN] = ACTIONS(1011),
    [anon_sym_SEMI] = ACTIONS(1011),
    [anon_sym_extern] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_LPAREN2] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(1011),
    [anon_sym_LBRACK] = ACTIONS(1011),
    [anon_sym_EQ] = ACTIONS(1011),
    [anon_sym_static] = ACTIONS(1013),
    [anon_sym_register] = ACTIONS(1013),
    [anon_sym_inline] = ACTIONS(1013),
    [anon_sym_const] = ACTIONS(1013),
    [anon_sym_restrict] = ACTIONS(1013),
    [anon_sym_volatile] = ACTIONS(1013),
    [anon_sym__Atomic] = ACTIONS(1013),
    [anon_sym_mutable] = ACTIONS(1013),
    [anon_sym_explicit] = ACTIONS(1013),
    [anon_sym_constexpr] = ACTIONS(1013),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_AMP] = ACTIONS(1013),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_DASH_GT] = ACTIONS(1011),
    [sym_identifier] = ACTIONS(1013),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1013),
    [anon_sym_override] = ACTIONS(1013),
    [anon_sym_GT2] = ACTIONS(1011),
    [sym_noexcept] = ACTIONS(1013),
    [anon_sym_COLON_COLON] = ACTIONS(1011),
    [sym_operator_name] = ACTIONS(1011),
  },
  [169] = {
    [anon_sym_COMMA] = ACTIONS(1015),
    [anon_sym_RPAREN] = ACTIONS(1015),
    [anon_sym_SEMI] = ACTIONS(1015),
    [anon_sym_extern] = ACTIONS(1017),
    [anon_sym_LBRACE] = ACTIONS(1015),
    [anon_sym_LPAREN2] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1015),
    [anon_sym_LBRACK] = ACTIONS(1015),
    [anon_sym_EQ] = ACTIONS(1015),
    [anon_sym_static] = ACTIONS(1017),
    [anon_sym_register] = ACTIONS(1017),
    [anon_sym_inline] = ACTIONS(1017),
    [anon_sym_const] = ACTIONS(1017),
    [anon_sym_restrict] = ACTIONS(1017),
    [anon_sym_volatile] = ACTIONS(1017),
    [anon_sym__Atomic] = ACTIONS(1017),
    [anon_sym_mutable] = ACTIONS(1017),
    [anon_sym_explicit] = ACTIONS(1017),
    [anon_sym_constexpr] = ACTIONS(1017),
    [anon_sym_COLON] = ACTIONS(1017),
    [anon_sym_AMP] = ACTIONS(1017),
    [anon_sym_AMP_AMP] = ACTIONS(1015),
    [anon_sym_TILDE] = ACTIONS(1015),
    [anon_sym_DASH_GT] = ACTIONS(1015),
    [sym_identifier] = ACTIONS(1017),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1017),
    [anon_sym_override] = ACTIONS(1017),
    [anon_sym_GT2] = ACTIONS(1015),
    [sym_noexcept] = ACTIONS(1017),
    [anon_sym_COLON_COLON] = ACTIONS(1015),
    [sym_operator_name] = ACTIONS(1015),
  },
  [170] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(604),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(604),
    [sym_type_definition] = STATE(604),
    [sym__declaration_specifiers] = STATE(598),
    [sym__declarator] = STATE(599),
    [sym_pointer_declarator] = STATE(599),
    [sym_function_declarator] = STATE(600),
    [sym_array_declarator] = STATE(599),
    [sym_storage_class_specifier] = STATE(605),
    [sym_type_qualifier] = STATE(605),
    [sym__type_specifier] = STATE(601),
    [sym_sized_type_specifier] = STATE(601),
    [sym_enum_specifier] = STATE(601),
    [sym_struct_specifier] = STATE(601),
    [sym_union_specifier] = STATE(601),
    [sym__field_declaration_list_item] = STATE(604),
    [sym_field_declaration] = STATE(604),
    [sym_macro_type_specifier] = STATE(601),
    [sym_class_specifier] = STATE(601),
    [sym_dependent_type] = STATE(601),
    [sym_template_declaration] = STATE(604),
    [sym_inline_method_definition] = STATE(604),
    [sym_constructor_or_destructor_definition] = STATE(604),
    [sym_constructor_or_destructor_declaration] = STATE(604),
    [sym_friend_declaration] = STATE(604),
    [sym_access_specifier] = STATE(604),
    [sym_reference_declarator] = STATE(599),
    [sym_template_type] = STATE(602),
    [sym_template_function] = STATE(599),
    [sym_using_declaration] = STATE(604),
    [sym_alias_declaration] = STATE(604),
    [sym_destructor_name] = STATE(599),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(603),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(604),
    [aux_sym__declaration_specifiers_repeat1] = STATE(605),
    [aux_sym_sized_type_specifier_repeat1] = STATE(606),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1019),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1021),
    [anon_sym_typedef] = ACTIONS(1023),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(1025),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(425),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(1027),
    [anon_sym_long] = ACTIONS(1027),
    [anon_sym_short] = ACTIONS(1027),
    [sym_primitive_type] = ACTIONS(1029),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(1031),
    [anon_sym_union] = ACTIONS(1033),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(1035),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1039),
    [sym_auto] = ACTIONS(1029),
    [anon_sym_typename] = ACTIONS(1041),
    [anon_sym_template] = ACTIONS(1043),
    [anon_sym_friend] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1039),
    [anon_sym_protected] = ACTIONS(1039),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_COLON_COLON] = ACTIONS(1049),
    [sym_operator_name] = ACTIONS(1051),
  },
  [171] = {
    [sym_template_type] = STATE(609),
    [sym_scoped_type_identifier] = STATE(610),
    [sym_scoped_namespace_identifier] = STATE(83),
    [sym_identifier] = ACTIONS(1053),
    [sym_comment] = ACTIONS(91),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [172] = {
    [sym_field_declaration_list] = STATE(612),
    [sym_virtual_specifier] = STATE(613),
    [sym_base_class_clause] = STATE(614),
    [sym_template_argument_list] = STATE(615),
    [anon_sym_COMMA] = ACTIONS(1057),
    [anon_sym_RPAREN] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1057),
    [anon_sym_extern] = ACTIONS(1059),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LPAREN2] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_EQ] = ACTIONS(1057),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_register] = ACTIONS(1059),
    [anon_sym_inline] = ACTIONS(1059),
    [anon_sym_const] = ACTIONS(1059),
    [anon_sym_restrict] = ACTIONS(1059),
    [anon_sym_volatile] = ACTIONS(1059),
    [anon_sym__Atomic] = ACTIONS(1059),
    [anon_sym_mutable] = ACTIONS(1059),
    [anon_sym_explicit] = ACTIONS(1059),
    [anon_sym_constexpr] = ACTIONS(1059),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(643),
    [sym_identifier] = ACTIONS(1059),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_GT2] = ACTIONS(1057),
    [anon_sym_COLON_COLON] = ACTIONS(1061),
    [sym_operator_name] = ACTIONS(1057),
  },
  [173] = {
    [anon_sym_COMMA] = ACTIONS(1063),
    [anon_sym_RPAREN] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_LPAREN2] = ACTIONS(1063),
    [anon_sym_LBRACK] = ACTIONS(1063),
    [anon_sym_EQ] = ACTIONS(1063),
    [anon_sym_const] = ACTIONS(1065),
    [anon_sym_restrict] = ACTIONS(1063),
    [anon_sym_volatile] = ACTIONS(1063),
    [anon_sym__Atomic] = ACTIONS(1063),
    [anon_sym_mutable] = ACTIONS(1063),
    [anon_sym_explicit] = ACTIONS(1063),
    [anon_sym_constexpr] = ACTIONS(1063),
    [anon_sym_COLON] = ACTIONS(1063),
    [anon_sym_DASH_GT] = ACTIONS(1063),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_GT2] = ACTIONS(1063),
    [sym_noexcept] = ACTIONS(1063),
  },
  [174] = {
    [sym_identifier] = ACTIONS(1067),
    [sym_comment] = ACTIONS(91),
  },
  [175] = {
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_RPAREN] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_extern] = ACTIONS(1071),
    [anon_sym_LBRACE] = ACTIONS(1069),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1069),
    [anon_sym_EQ] = ACTIONS(1069),
    [anon_sym_static] = ACTIONS(1071),
    [anon_sym_register] = ACTIONS(1071),
    [anon_sym_inline] = ACTIONS(1071),
    [anon_sym_const] = ACTIONS(1071),
    [anon_sym_restrict] = ACTIONS(1071),
    [anon_sym_volatile] = ACTIONS(1071),
    [anon_sym__Atomic] = ACTIONS(1071),
    [anon_sym_mutable] = ACTIONS(1071),
    [anon_sym_explicit] = ACTIONS(1071),
    [anon_sym_constexpr] = ACTIONS(1071),
    [anon_sym_COLON] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1069),
    [anon_sym_TILDE] = ACTIONS(1069),
    [anon_sym_DASH_GT] = ACTIONS(1069),
    [sym_identifier] = ACTIONS(1071),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1071),
    [anon_sym_override] = ACTIONS(1071),
    [anon_sym_GT2] = ACTIONS(1069),
    [sym_noexcept] = ACTIONS(1071),
    [anon_sym_COLON_COLON] = ACTIONS(1069),
    [sym_operator_name] = ACTIONS(1069),
  },
  [176] = {
    [sym_field_declaration_list] = STATE(617),
    [sym_base_class_clause] = STATE(618),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_COLON] = ACTIONS(1073),
    [sym_comment] = ACTIONS(91),
  },
  [177] = {
    [sym_field_declaration_list] = STATE(617),
    [anon_sym_LBRACE] = ACTIONS(307),
    [sym_comment] = ACTIONS(91),
  },
  [178] = {
    [sym_field_declaration_list] = STATE(617),
    [sym_virtual_specifier] = STATE(620),
    [sym_base_class_clause] = STATE(618),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_RPAREN] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_extern] = ACTIONS(1071),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1069),
    [anon_sym_EQ] = ACTIONS(1069),
    [anon_sym_static] = ACTIONS(1071),
    [anon_sym_register] = ACTIONS(1071),
    [anon_sym_inline] = ACTIONS(1071),
    [anon_sym_const] = ACTIONS(1071),
    [anon_sym_restrict] = ACTIONS(1071),
    [anon_sym_volatile] = ACTIONS(1071),
    [anon_sym__Atomic] = ACTIONS(1071),
    [anon_sym_mutable] = ACTIONS(1071),
    [anon_sym_explicit] = ACTIONS(1071),
    [anon_sym_constexpr] = ACTIONS(1071),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1069),
    [anon_sym_TILDE] = ACTIONS(1069),
    [sym_identifier] = ACTIONS(1071),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_GT2] = ACTIONS(1069),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [sym_operator_name] = ACTIONS(1069),
  },
  [179] = {
    [sym_field_declaration_list] = STATE(617),
    [sym_virtual_specifier] = STATE(620),
    [sym_base_class_clause] = STATE(618),
    [sym_template_argument_list] = STATE(362),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_RPAREN] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_extern] = ACTIONS(1071),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1069),
    [anon_sym_EQ] = ACTIONS(1069),
    [anon_sym_static] = ACTIONS(1071),
    [anon_sym_register] = ACTIONS(1071),
    [anon_sym_inline] = ACTIONS(1071),
    [anon_sym_const] = ACTIONS(1071),
    [anon_sym_restrict] = ACTIONS(1071),
    [anon_sym_volatile] = ACTIONS(1071),
    [anon_sym__Atomic] = ACTIONS(1071),
    [anon_sym_mutable] = ACTIONS(1071),
    [anon_sym_explicit] = ACTIONS(1071),
    [anon_sym_constexpr] = ACTIONS(1071),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1069),
    [anon_sym_TILDE] = ACTIONS(1069),
    [anon_sym_LT] = ACTIONS(643),
    [sym_identifier] = ACTIONS(1071),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_GT2] = ACTIONS(1069),
    [anon_sym_COLON_COLON] = ACTIONS(1069),
    [sym_operator_name] = ACTIONS(1069),
  },
  [180] = {
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
  },
  [181] = {
    [sym_field_declaration_list] = STATE(621),
    [sym_virtual_specifier] = STATE(622),
    [sym_base_class_clause] = STATE(623),
    [sym_template_argument_list] = STATE(615),
    [anon_sym_COMMA] = ACTIONS(1077),
    [anon_sym_RPAREN] = ACTIONS(1077),
    [anon_sym_SEMI] = ACTIONS(1077),
    [anon_sym_extern] = ACTIONS(1079),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LPAREN2] = ACTIONS(1077),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_LBRACK] = ACTIONS(1077),
    [anon_sym_EQ] = ACTIONS(1077),
    [anon_sym_static] = ACTIONS(1079),
    [anon_sym_register] = ACTIONS(1079),
    [anon_sym_inline] = ACTIONS(1079),
    [anon_sym_const] = ACTIONS(1079),
    [anon_sym_restrict] = ACTIONS(1079),
    [anon_sym_volatile] = ACTIONS(1079),
    [anon_sym__Atomic] = ACTIONS(1079),
    [anon_sym_mutable] = ACTIONS(1079),
    [anon_sym_explicit] = ACTIONS(1079),
    [anon_sym_constexpr] = ACTIONS(1079),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [anon_sym_LT] = ACTIONS(643),
    [sym_identifier] = ACTIONS(1079),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_GT2] = ACTIONS(1077),
    [anon_sym_COLON_COLON] = ACTIONS(1061),
    [sym_operator_name] = ACTIONS(1077),
  },
  [182] = {
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_RPAREN] = ACTIONS(1081),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_extern] = ACTIONS(1083),
    [anon_sym_LBRACE] = ACTIONS(1081),
    [anon_sym_LPAREN2] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1081),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(1081),
    [anon_sym_static] = ACTIONS(1083),
    [anon_sym_register] = ACTIONS(1083),
    [anon_sym_inline] = ACTIONS(1083),
    [anon_sym_const] = ACTIONS(1083),
    [anon_sym_restrict] = ACTIONS(1083),
    [anon_sym_volatile] = ACTIONS(1083),
    [anon_sym__Atomic] = ACTIONS(1083),
    [anon_sym_mutable] = ACTIONS(1083),
    [anon_sym_explicit] = ACTIONS(1083),
    [anon_sym_constexpr] = ACTIONS(1083),
    [anon_sym_COLON] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(1081),
    [sym_identifier] = ACTIONS(1083),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1083),
    [anon_sym_override] = ACTIONS(1083),
    [anon_sym_GT2] = ACTIONS(1081),
    [sym_noexcept] = ACTIONS(1083),
    [anon_sym_COLON_COLON] = ACTIONS(1081),
    [sym_operator_name] = ACTIONS(1081),
  },
  [183] = {
    [sym_field_declaration_list] = STATE(624),
    [sym_base_class_clause] = STATE(625),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_COLON] = ACTIONS(1073),
    [sym_comment] = ACTIONS(91),
  },
  [184] = {
    [sym_field_declaration_list] = STATE(624),
    [anon_sym_LBRACE] = ACTIONS(307),
    [sym_comment] = ACTIONS(91),
  },
  [185] = {
    [sym_field_declaration_list] = STATE(624),
    [sym_virtual_specifier] = STATE(626),
    [sym_base_class_clause] = STATE(625),
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_RPAREN] = ACTIONS(1081),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_extern] = ACTIONS(1083),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LPAREN2] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1081),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(1081),
    [anon_sym_static] = ACTIONS(1083),
    [anon_sym_register] = ACTIONS(1083),
    [anon_sym_inline] = ACTIONS(1083),
    [anon_sym_const] = ACTIONS(1083),
    [anon_sym_restrict] = ACTIONS(1083),
    [anon_sym_volatile] = ACTIONS(1083),
    [anon_sym__Atomic] = ACTIONS(1083),
    [anon_sym_mutable] = ACTIONS(1083),
    [anon_sym_explicit] = ACTIONS(1083),
    [anon_sym_constexpr] = ACTIONS(1083),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [sym_identifier] = ACTIONS(1083),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_GT2] = ACTIONS(1081),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [sym_operator_name] = ACTIONS(1081),
  },
  [186] = {
    [sym_field_declaration_list] = STATE(624),
    [sym_virtual_specifier] = STATE(626),
    [sym_base_class_clause] = STATE(625),
    [sym_template_argument_list] = STATE(362),
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_RPAREN] = ACTIONS(1081),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_extern] = ACTIONS(1083),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LPAREN2] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1081),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(1081),
    [anon_sym_static] = ACTIONS(1083),
    [anon_sym_register] = ACTIONS(1083),
    [anon_sym_inline] = ACTIONS(1083),
    [anon_sym_const] = ACTIONS(1083),
    [anon_sym_restrict] = ACTIONS(1083),
    [anon_sym_volatile] = ACTIONS(1083),
    [anon_sym__Atomic] = ACTIONS(1083),
    [anon_sym_mutable] = ACTIONS(1083),
    [anon_sym_explicit] = ACTIONS(1083),
    [anon_sym_constexpr] = ACTIONS(1083),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(643),
    [sym_identifier] = ACTIONS(1083),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_GT2] = ACTIONS(1081),
    [anon_sym_COLON_COLON] = ACTIONS(1081),
    [sym_operator_name] = ACTIONS(1081),
  },
  [187] = {
    [sym__expression] = STATE(636),
    [sym_conditional_expression] = STATE(636),
    [sym_assignment_expression] = STATE(636),
    [sym_pointer_expression] = STATE(636),
    [sym_logical_expression] = STATE(636),
    [sym_bitwise_expression] = STATE(636),
    [sym_equality_expression] = STATE(636),
    [sym_relational_expression] = STATE(636),
    [sym_shift_expression] = STATE(636),
    [sym_math_expression] = STATE(636),
    [sym_cast_expression] = STATE(636),
    [sym_sizeof_expression] = STATE(636),
    [sym_subscript_expression] = STATE(636),
    [sym_call_expression] = STATE(636),
    [sym_field_expression] = STATE(636),
    [sym_compound_literal_expression] = STATE(636),
    [sym_parenthesized_expression] = STATE(636),
    [sym_char_literal] = STATE(636),
    [sym_concatenated_string] = STATE(636),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(636),
    [sym_new_expression] = STATE(636),
    [sym_delete_expression] = STATE(636),
    [sym_lambda_expression] = STATE(636),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(1085),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(1085),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(1101),
    [sym_false] = ACTIONS(1101),
    [sym_null] = ACTIONS(1101),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(1101),
  },
  [188] = {
    [anon_sym_LPAREN2] = ACTIONS(1109),
    [sym_comment] = ACTIONS(91),
  },
  [189] = {
    [sym__expression] = STATE(639),
    [sym_comma_expression] = STATE(640),
    [sym_conditional_expression] = STATE(639),
    [sym_assignment_expression] = STATE(639),
    [sym_pointer_expression] = STATE(639),
    [sym_logical_expression] = STATE(639),
    [sym_bitwise_expression] = STATE(639),
    [sym_equality_expression] = STATE(639),
    [sym_relational_expression] = STATE(639),
    [sym_shift_expression] = STATE(639),
    [sym_math_expression] = STATE(639),
    [sym_cast_expression] = STATE(639),
    [sym_sizeof_expression] = STATE(639),
    [sym_subscript_expression] = STATE(639),
    [sym_call_expression] = STATE(639),
    [sym_field_expression] = STATE(639),
    [sym_compound_literal_expression] = STATE(639),
    [sym_parenthesized_expression] = STATE(639),
    [sym_char_literal] = STATE(639),
    [sym_concatenated_string] = STATE(639),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(639),
    [sym_new_expression] = STATE(639),
    [sym_delete_expression] = STATE(639),
    [sym_lambda_expression] = STATE(639),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(1111),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(1111),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(1113),
    [sym_false] = ACTIONS(1113),
    [sym_null] = ACTIONS(1113),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(1113),
  },
  [190] = {
    [sym_compound_statement] = STATE(642),
    [sym_labeled_statement] = STATE(642),
    [sym_expression_statement] = STATE(642),
    [sym_if_statement] = STATE(642),
    [sym_switch_statement] = STATE(642),
    [sym_case_statement] = STATE(642),
    [sym_while_statement] = STATE(642),
    [sym_do_statement] = STATE(642),
    [sym_for_statement] = STATE(642),
    [sym_return_statement] = STATE(642),
    [sym_break_statement] = STATE(642),
    [sym_continue_statement] = STATE(642),
    [sym_goto_statement] = STATE(642),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(642),
    [sym_try_statement] = STATE(642),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_switch] = ACTIONS(49),
    [anon_sym_case] = ACTIONS(51),
    [anon_sym_default] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(1115),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(105),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [191] = {
    [sym_type_qualifier] = STATE(141),
    [sym__type_specifier] = STATE(136),
    [sym_sized_type_specifier] = STATE(136),
    [sym_enum_specifier] = STATE(136),
    [sym_struct_specifier] = STATE(136),
    [sym_union_specifier] = STATE(136),
    [sym__expression] = STATE(137),
    [sym_comma_expression] = STATE(138),
    [sym_conditional_expression] = STATE(137),
    [sym_assignment_expression] = STATE(137),
    [sym_pointer_expression] = STATE(137),
    [sym_logical_expression] = STATE(137),
    [sym_bitwise_expression] = STATE(137),
    [sym_equality_expression] = STATE(137),
    [sym_relational_expression] = STATE(137),
    [sym_shift_expression] = STATE(137),
    [sym_math_expression] = STATE(137),
    [sym_cast_expression] = STATE(137),
    [sym_type_descriptor] = STATE(643),
    [sym_sizeof_expression] = STATE(137),
    [sym_subscript_expression] = STATE(137),
    [sym_call_expression] = STATE(137),
    [sym_field_expression] = STATE(137),
    [sym_compound_literal_expression] = STATE(137),
    [sym_parenthesized_expression] = STATE(137),
    [sym_char_literal] = STATE(137),
    [sym_concatenated_string] = STATE(137),
    [sym_string_literal] = STATE(140),
    [sym_macro_type_specifier] = STATE(136),
    [sym_class_specifier] = STATE(136),
    [sym_dependent_type] = STATE(136),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(137),
    [sym_new_expression] = STATE(137),
    [sym_delete_expression] = STATE(137),
    [sym_lambda_expression] = STATE(137),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_type_definition_repeat1] = STATE(141),
    [aux_sym_sized_type_specifier_repeat1] = STATE(142),
    [sym_raw_string_literal] = ACTIONS(213),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(219),
    [anon_sym_long] = ACTIONS(219),
    [anon_sym_short] = ACTIONS(219),
    [sym_primitive_type] = ACTIONS(221),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [sym_null] = ACTIONS(241),
    [sym_identifier] = ACTIONS(811),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(221),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(253),
    [sym_nullptr] = ACTIONS(241),
  },
  [192] = {
    [sym__expression] = STATE(644),
    [sym_conditional_expression] = STATE(644),
    [sym_assignment_expression] = STATE(644),
    [sym_pointer_expression] = STATE(644),
    [sym_logical_expression] = STATE(644),
    [sym_bitwise_expression] = STATE(644),
    [sym_equality_expression] = STATE(644),
    [sym_relational_expression] = STATE(644),
    [sym_shift_expression] = STATE(644),
    [sym_math_expression] = STATE(644),
    [sym_cast_expression] = STATE(644),
    [sym_sizeof_expression] = STATE(644),
    [sym_subscript_expression] = STATE(644),
    [sym_call_expression] = STATE(644),
    [sym_field_expression] = STATE(644),
    [sym_compound_literal_expression] = STATE(644),
    [sym_parenthesized_expression] = STATE(644),
    [sym_char_literal] = STATE(644),
    [sym_concatenated_string] = STATE(644),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(644),
    [sym_new_expression] = STATE(644),
    [sym_delete_expression] = STATE(644),
    [sym_lambda_expression] = STATE(644),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(1117),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(1119),
    [sym_false] = ACTIONS(1119),
    [sym_null] = ACTIONS(1119),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(1119),
  },
  [193] = {
    [sym__expression] = STATE(645),
    [sym_conditional_expression] = STATE(645),
    [sym_assignment_expression] = STATE(645),
    [sym_pointer_expression] = STATE(645),
    [sym_logical_expression] = STATE(645),
    [sym_bitwise_expression] = STATE(645),
    [sym_equality_expression] = STATE(645),
    [sym_relational_expression] = STATE(645),
    [sym_shift_expression] = STATE(645),
    [sym_math_expression] = STATE(645),
    [sym_cast_expression] = STATE(645),
    [sym_sizeof_expression] = STATE(645),
    [sym_subscript_expression] = STATE(645),
    [sym_call_expression] = STATE(645),
    [sym_field_expression] = STATE(645),
    [sym_compound_literal_expression] = STATE(645),
    [sym_parenthesized_expression] = STATE(645),
    [sym_char_literal] = STATE(645),
    [sym_concatenated_string] = STATE(645),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(645),
    [sym_new_expression] = STATE(645),
    [sym_delete_expression] = STATE(645),
    [sym_lambda_expression] = STATE(645),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(1121),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(1121),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(1123),
    [sym_false] = ACTIONS(1123),
    [sym_null] = ACTIONS(1123),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(1123),
  },
  [194] = {
    [sym__expression] = STATE(646),
    [sym_conditional_expression] = STATE(646),
    [sym_assignment_expression] = STATE(646),
    [sym_pointer_expression] = STATE(646),
    [sym_logical_expression] = STATE(646),
    [sym_bitwise_expression] = STATE(646),
    [sym_equality_expression] = STATE(646),
    [sym_relational_expression] = STATE(646),
    [sym_shift_expression] = STATE(646),
    [sym_math_expression] = STATE(646),
    [sym_cast_expression] = STATE(646),
    [sym_sizeof_expression] = STATE(646),
    [sym_subscript_expression] = STATE(646),
    [sym_call_expression] = STATE(646),
    [sym_field_expression] = STATE(646),
    [sym_compound_literal_expression] = STATE(646),
    [sym_parenthesized_expression] = STATE(646),
    [sym_char_literal] = STATE(646),
    [sym_concatenated_string] = STATE(646),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(646),
    [sym_new_expression] = STATE(646),
    [sym_delete_expression] = STATE(646),
    [sym_lambda_expression] = STATE(646),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(1125),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(1125),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(1127),
    [sym_false] = ACTIONS(1127),
    [sym_null] = ACTIONS(1127),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(1127),
  },
  [195] = {
    [sym__expression] = STATE(647),
    [sym_conditional_expression] = STATE(647),
    [sym_assignment_expression] = STATE(647),
    [sym_pointer_expression] = STATE(647),
    [sym_logical_expression] = STATE(647),
    [sym_bitwise_expression] = STATE(647),
    [sym_equality_expression] = STATE(647),
    [sym_relational_expression] = STATE(647),
    [sym_shift_expression] = STATE(647),
    [sym_math_expression] = STATE(647),
    [sym_cast_expression] = STATE(647),
    [sym_sizeof_expression] = STATE(647),
    [sym_subscript_expression] = STATE(647),
    [sym_call_expression] = STATE(647),
    [sym_field_expression] = STATE(647),
    [sym_compound_literal_expression] = STATE(647),
    [sym_parenthesized_expression] = STATE(647),
    [sym_char_literal] = STATE(647),
    [sym_concatenated_string] = STATE(647),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(647),
    [sym_new_expression] = STATE(647),
    [sym_delete_expression] = STATE(647),
    [sym_lambda_expression] = STATE(647),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(1129),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(1129),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(1131),
    [sym_false] = ACTIONS(1131),
    [sym_null] = ACTIONS(1131),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(1131),
  },
  [196] = {
    [sym__expression] = STATE(649),
    [sym_conditional_expression] = STATE(649),
    [sym_assignment_expression] = STATE(649),
    [sym_pointer_expression] = STATE(649),
    [sym_logical_expression] = STATE(649),
    [sym_bitwise_expression] = STATE(649),
    [sym_equality_expression] = STATE(649),
    [sym_relational_expression] = STATE(649),
    [sym_shift_expression] = STATE(649),
    [sym_math_expression] = STATE(649),
    [sym_cast_expression] = STATE(649),
    [sym_sizeof_expression] = STATE(649),
    [sym_subscript_expression] = STATE(649),
    [sym_call_expression] = STATE(649),
    [sym_field_expression] = STATE(649),
    [sym_compound_literal_expression] = STATE(649),
    [sym_parenthesized_expression] = STATE(649),
    [sym_char_literal] = STATE(649),
    [sym_concatenated_string] = STATE(649),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(649),
    [sym_new_expression] = STATE(649),
    [sym_delete_expression] = STATE(649),
    [sym_lambda_expression] = STATE(649),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(1133),
    [anon_sym_LPAREN2] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(1133),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(1137),
    [sym_false] = ACTIONS(1137),
    [sym_null] = ACTIONS(1137),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(1137),
  },
  [197] = {
    [aux_sym_string_literal_repeat1] = STATE(651),
    [anon_sym_DQUOTE] = ACTIONS(1139),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_BSLASHn_RBRACK_SLASH] = ACTIONS(1141),
    [sym_escape_sequence] = ACTIONS(1141),
    [sym_comment] = ACTIONS(121),
  },
  [198] = {
    [sym__expression] = STATE(653),
    [sym_conditional_expression] = STATE(653),
    [sym_assignment_expression] = STATE(653),
    [sym_pointer_expression] = STATE(653),
    [sym_logical_expression] = STATE(653),
    [sym_bitwise_expression] = STATE(653),
    [sym_equality_expression] = STATE(653),
    [sym_relational_expression] = STATE(653),
    [sym_shift_expression] = STATE(653),
    [sym_math_expression] = STATE(653),
    [sym_cast_expression] = STATE(653),
    [sym_sizeof_expression] = STATE(653),
    [sym_subscript_expression] = STATE(653),
    [sym_call_expression] = STATE(653),
    [sym_field_expression] = STATE(653),
    [sym_compound_literal_expression] = STATE(653),
    [sym_parenthesized_expression] = STATE(653),
    [sym_char_literal] = STATE(653),
    [sym_concatenated_string] = STATE(653),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(653),
    [sym_new_expression] = STATE(653),
    [sym_delete_expression] = STATE(653),
    [sym_lambda_expression] = STATE(653),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(1143),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(1145),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(1143),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(1147),
    [sym_false] = ACTIONS(1147),
    [sym_null] = ACTIONS(1147),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(1147),
  },
  [199] = {
    [sym__type_specifier] = STATE(658),
    [sym_sized_type_specifier] = STATE(658),
    [sym_enum_specifier] = STATE(658),
    [sym_struct_specifier] = STATE(658),
    [sym_union_specifier] = STATE(658),
    [sym_argument_list] = STATE(659),
    [sym_macro_type_specifier] = STATE(658),
    [sym_class_specifier] = STATE(658),
    [sym_dependent_type] = STATE(658),
    [sym_template_type] = STATE(309),
    [sym_scoped_type_identifier] = STATE(310),
    [sym_scoped_namespace_identifier] = STATE(311),
    [aux_sym_sized_type_specifier_repeat1] = STATE(660),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_unsigned] = ACTIONS(1149),
    [anon_sym_long] = ACTIONS(1149),
    [anon_sym_short] = ACTIONS(1149),
    [sym_primitive_type] = ACTIONS(1151),
    [anon_sym_enum] = ACTIONS(536),
    [anon_sym_struct] = ACTIONS(1153),
    [anon_sym_union] = ACTIONS(1155),
    [sym_identifier] = ACTIONS(542),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1157),
    [sym_auto] = ACTIONS(1151),
    [anon_sym_typename] = ACTIONS(1159),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [200] = {
    [sym_destructor_name] = STATE(315),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(937),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1161),
    [sym_operator_name] = ACTIONS(554),
  },
  [201] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_COLON] = ACTIONS(1169),
    [anon_sym_QMARK] = ACTIONS(1171),
    [anon_sym_STAR_EQ] = ACTIONS(1173),
    [anon_sym_SLASH_EQ] = ACTIONS(1173),
    [anon_sym_PERCENT_EQ] = ACTIONS(1173),
    [anon_sym_PLUS_EQ] = ACTIONS(1173),
    [anon_sym_DASH_EQ] = ACTIONS(1173),
    [anon_sym_LT_LT_EQ] = ACTIONS(1173),
    [anon_sym_GT_GT_EQ] = ACTIONS(1173),
    [anon_sym_AMP_EQ] = ACTIONS(1173),
    [anon_sym_CARET_EQ] = ACTIONS(1173),
    [anon_sym_PIPE_EQ] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_CARET] = ACTIONS(1183),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [202] = {
    [sym_string_literal] = STATE(677),
    [aux_sym_concatenated_string_repeat1] = STATE(677),
    [anon_sym_LPAREN2] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(91),
  },
  [203] = {
    [sym_template_argument_list] = STATE(360),
    [anon_sym_LPAREN2] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(1197),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_comment] = ACTIONS(91),
  },
  [204] = {
    [sym_declaration] = STATE(681),
    [sym_type_definition] = STATE(681),
    [sym__declaration_specifiers] = STATE(682),
    [sym_compound_statement] = STATE(681),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_labeled_statement] = STATE(681),
    [sym_expression_statement] = STATE(681),
    [sym_if_statement] = STATE(681),
    [sym_switch_statement] = STATE(681),
    [sym_case_statement] = STATE(681),
    [sym_while_statement] = STATE(681),
    [sym_do_statement] = STATE(681),
    [sym_for_statement] = STATE(681),
    [sym_return_statement] = STATE(681),
    [sym_break_statement] = STATE(681),
    [sym_continue_statement] = STATE(681),
    [sym_goto_statement] = STATE(681),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(681),
    [sym_try_statement] = STATE(681),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_switch] = ACTIONS(49),
    [anon_sym_case] = ACTIONS(51),
    [anon_sym_default] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(1200),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(105),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(1202),
    [sym_nullptr] = ACTIONS(87),
  },
  [205] = {
    [sym_compound_statement] = STATE(685),
    [sym_labeled_statement] = STATE(685),
    [sym_expression_statement] = STATE(685),
    [sym_if_statement] = STATE(685),
    [sym_switch_statement] = STATE(685),
    [sym_case_statement] = STATE(685),
    [sym_while_statement] = STATE(685),
    [sym_do_statement] = STATE(685),
    [sym_for_statement] = STATE(685),
    [sym_return_statement] = STATE(685),
    [sym_break_statement] = STATE(685),
    [sym_continue_statement] = STATE(685),
    [sym_goto_statement] = STATE(685),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(685),
    [sym_try_statement] = STATE(685),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_switch] = ACTIONS(49),
    [anon_sym_case] = ACTIONS(51),
    [anon_sym_default] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(1115),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(105),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [206] = {
    [anon_sym_else] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(129),
    [sym_comment] = ACTIONS(91),
  },
  [207] = {
    [sym_preproc_include] = STATE(687),
    [sym_preproc_def] = STATE(687),
    [sym_preproc_function_def] = STATE(687),
    [sym_preproc_call] = STATE(687),
    [sym_preproc_if_in_compound_statement] = STATE(687),
    [sym_preproc_ifdef_in_compound_statement] = STATE(687),
    [sym_declaration] = STATE(687),
    [sym_type_definition] = STATE(687),
    [sym__declaration_specifiers] = STATE(113),
    [sym_compound_statement] = STATE(687),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(687),
    [sym_expression_statement] = STATE(687),
    [sym_if_statement] = STATE(687),
    [sym_switch_statement] = STATE(687),
    [sym_case_statement] = STATE(687),
    [sym_while_statement] = STATE(687),
    [sym_do_statement] = STATE(687),
    [sym_for_statement] = STATE(687),
    [sym_return_statement] = STATE(687),
    [sym_break_statement] = STATE(687),
    [sym_continue_statement] = STATE(687),
    [sym_goto_statement] = STATE(687),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(687),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(687),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(687),
    [sym_try_statement] = STATE(687),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(687),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(157),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(159),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(161),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(163),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(165),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(165),
    [sym_preproc_directive] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_typedef] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_RBRACE] = ACTIONS(1204),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(185),
    [anon_sym_case] = ACTIONS(187),
    [anon_sym_default] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(209),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_nullptr] = ACTIONS(207),
  },
  [208] = {
    [anon_sym_LPAREN2] = ACTIONS(1206),
    [anon_sym_constexpr] = ACTIONS(1208),
    [sym_comment] = ACTIONS(91),
  },
  [209] = {
    [sym_parenthesized_expression] = STATE(690),
    [anon_sym_LPAREN2] = ACTIONS(323),
    [sym_comment] = ACTIONS(91),
  },
  [210] = {
    [sym__expression] = STATE(691),
    [sym_conditional_expression] = STATE(691),
    [sym_assignment_expression] = STATE(691),
    [sym_pointer_expression] = STATE(691),
    [sym_logical_expression] = STATE(691),
    [sym_bitwise_expression] = STATE(691),
    [sym_equality_expression] = STATE(691),
    [sym_relational_expression] = STATE(691),
    [sym_shift_expression] = STATE(691),
    [sym_math_expression] = STATE(691),
    [sym_cast_expression] = STATE(691),
    [sym_sizeof_expression] = STATE(691),
    [sym_subscript_expression] = STATE(691),
    [sym_call_expression] = STATE(691),
    [sym_field_expression] = STATE(691),
    [sym_compound_literal_expression] = STATE(691),
    [sym_parenthesized_expression] = STATE(691),
    [sym_char_literal] = STATE(691),
    [sym_concatenated_string] = STATE(691),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(691),
    [sym_new_expression] = STATE(691),
    [sym_delete_expression] = STATE(691),
    [sym_lambda_expression] = STATE(691),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(1210),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(1210),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(1212),
    [sym_false] = ACTIONS(1212),
    [sym_null] = ACTIONS(1212),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(1212),
  },
  [211] = {
    [anon_sym_COLON] = ACTIONS(1214),
    [sym_comment] = ACTIONS(91),
  },
  [212] = {
    [sym_parenthesized_expression] = STATE(693),
    [anon_sym_LPAREN2] = ACTIONS(323),
    [sym_comment] = ACTIONS(91),
  },
  [213] = {
    [sym_compound_statement] = STATE(694),
    [sym_labeled_statement] = STATE(694),
    [sym_expression_statement] = STATE(694),
    [sym_if_statement] = STATE(694),
    [sym_switch_statement] = STATE(694),
    [sym_case_statement] = STATE(694),
    [sym_while_statement] = STATE(694),
    [sym_do_statement] = STATE(694),
    [sym_for_statement] = STATE(694),
    [sym_return_statement] = STATE(694),
    [sym_break_statement] = STATE(694),
    [sym_continue_statement] = STATE(694),
    [sym_goto_statement] = STATE(694),
    [sym__expression] = STATE(222),
    [sym_comma_expression] = STATE(223),
    [sym_conditional_expression] = STATE(222),
    [sym_assignment_expression] = STATE(222),
    [sym_pointer_expression] = STATE(222),
    [sym_logical_expression] = STATE(222),
    [sym_bitwise_expression] = STATE(222),
    [sym_equality_expression] = STATE(222),
    [sym_relational_expression] = STATE(222),
    [sym_shift_expression] = STATE(222),
    [sym_math_expression] = STATE(222),
    [sym_cast_expression] = STATE(222),
    [sym_sizeof_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_call_expression] = STATE(222),
    [sym_field_expression] = STATE(222),
    [sym_compound_literal_expression] = STATE(222),
    [sym_parenthesized_expression] = STATE(222),
    [sym_char_literal] = STATE(222),
    [sym_concatenated_string] = STATE(222),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(222),
    [sym_for_range_loop] = STATE(694),
    [sym_try_statement] = STATE(694),
    [sym_new_expression] = STATE(222),
    [sym_delete_expression] = STATE(222),
    [sym_lambda_expression] = STATE(222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(359),
    [anon_sym_switch] = ACTIONS(361),
    [anon_sym_case] = ACTIONS(363),
    [anon_sym_default] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [anon_sym_do] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(373),
    [anon_sym_break] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_goto] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(353),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_identifier] = ACTIONS(383),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(381),
  },
  [214] = {
    [anon_sym_LPAREN2] = ACTIONS(1216),
    [sym_comment] = ACTIONS(91),
  },
  [215] = {
    [sym__expression] = STATE(697),
    [sym_conditional_expression] = STATE(697),
    [sym_assignment_expression] = STATE(697),
    [sym_pointer_expression] = STATE(697),
    [sym_logical_expression] = STATE(697),
    [sym_bitwise_expression] = STATE(697),
    [sym_equality_expression] = STATE(697),
    [sym_relational_expression] = STATE(697),
    [sym_shift_expression] = STATE(697),
    [sym_math_expression] = STATE(697),
    [sym_cast_expression] = STATE(697),
    [sym_sizeof_expression] = STATE(697),
    [sym_subscript_expression] = STATE(697),
    [sym_call_expression] = STATE(697),
    [sym_field_expression] = STATE(697),
    [sym_compound_literal_expression] = STATE(697),
    [sym_parenthesized_expression] = STATE(697),
    [sym_initializer_list] = STATE(698),
    [sym_char_literal] = STATE(697),
    [sym_concatenated_string] = STATE(697),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(697),
    [sym_new_expression] = STATE(697),
    [sym_delete_expression] = STATE(697),
    [sym_lambda_expression] = STATE(697),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(1218),
    [anon_sym_SEMI] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(1218),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(1222),
    [sym_false] = ACTIONS(1222),
    [sym_null] = ACTIONS(1222),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(1222),
  },
  [216] = {
    [anon_sym_SEMI] = ACTIONS(1224),
    [sym_comment] = ACTIONS(91),
  },
  [217] = {
    [anon_sym_SEMI] = ACTIONS(1226),
    [sym_comment] = ACTIONS(91),
  },
  [218] = {
    [sym_identifier] = ACTIONS(1228),
    [sym_comment] = ACTIONS(91),
  },
  [219] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(548),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_COLON] = ACTIONS(1230),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(935),
  },
  [220] = {
    [sym_compound_statement] = STATE(703),
    [anon_sym_LBRACE] = ACTIONS(357),
    [sym_comment] = ACTIONS(91),
  },
  [221] = {
    [anon_sym_while] = ACTIONS(1232),
    [sym_comment] = ACTIONS(91),
  },
  [222] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(586),
    [anon_sym_SEMI] = ACTIONS(1234),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(590),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(594),
    [anon_sym_QMARK] = ACTIONS(596),
    [anon_sym_STAR_EQ] = ACTIONS(598),
    [anon_sym_SLASH_EQ] = ACTIONS(598),
    [anon_sym_PERCENT_EQ] = ACTIONS(598),
    [anon_sym_PLUS_EQ] = ACTIONS(598),
    [anon_sym_DASH_EQ] = ACTIONS(598),
    [anon_sym_LT_LT_EQ] = ACTIONS(598),
    [anon_sym_GT_GT_EQ] = ACTIONS(598),
    [anon_sym_AMP_EQ] = ACTIONS(598),
    [anon_sym_CARET_EQ] = ACTIONS(598),
    [anon_sym_PIPE_EQ] = ACTIONS(598),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_PIPE_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(604),
    [anon_sym_PIPE] = ACTIONS(606),
    [anon_sym_CARET] = ACTIONS(608),
    [anon_sym_EQ_EQ] = ACTIONS(610),
    [anon_sym_BANG_EQ] = ACTIONS(610),
    [anon_sym_LT] = ACTIONS(612),
    [anon_sym_GT] = ACTIONS(612),
    [anon_sym_LT_EQ] = ACTIONS(614),
    [anon_sym_GT_EQ] = ACTIONS(614),
    [anon_sym_LT_LT] = ACTIONS(616),
    [anon_sym_GT_GT] = ACTIONS(616),
    [anon_sym_PLUS] = ACTIONS(618),
    [anon_sym_DASH] = ACTIONS(618),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [223] = {
    [anon_sym_SEMI] = ACTIONS(1234),
    [sym_comment] = ACTIONS(91),
  },
  [224] = {
    [sym_declaration] = STATE(706),
    [sym__declaration_specifiers] = STATE(709),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym__expression] = STATE(710),
    [sym_conditional_expression] = STATE(710),
    [sym_assignment_expression] = STATE(710),
    [sym_pointer_expression] = STATE(710),
    [sym_logical_expression] = STATE(710),
    [sym_bitwise_expression] = STATE(710),
    [sym_equality_expression] = STATE(710),
    [sym_relational_expression] = STATE(710),
    [sym_shift_expression] = STATE(710),
    [sym_math_expression] = STATE(710),
    [sym_cast_expression] = STATE(710),
    [sym_sizeof_expression] = STATE(710),
    [sym_subscript_expression] = STATE(710),
    [sym_call_expression] = STATE(710),
    [sym_field_expression] = STATE(710),
    [sym_compound_literal_expression] = STATE(710),
    [sym_parenthesized_expression] = STATE(710),
    [sym_char_literal] = STATE(710),
    [sym_concatenated_string] = STATE(710),
    [sym_string_literal] = STATE(238),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(710),
    [sym_for_range_declaration] = STATE(711),
    [sym_new_expression] = STATE(710),
    [sym_delete_expression] = STATE(710),
    [sym_lambda_expression] = STATE(710),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(1236),
    [anon_sym_SEMI] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(1236),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(1240),
    [sym_false] = ACTIONS(1240),
    [sym_null] = ACTIONS(1240),
    [sym_identifier] = ACTIONS(1242),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(1244),
    [sym_nullptr] = ACTIONS(1240),
  },
  [225] = {
    [sym_raw_string_literal] = ACTIONS(1246),
    [ts_builtin_sym_end] = ACTIONS(1246),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1248),
    [sym_preproc_directive] = ACTIONS(1248),
    [anon_sym_SEMI] = ACTIONS(1246),
    [anon_sym_typedef] = ACTIONS(1248),
    [anon_sym_extern] = ACTIONS(1248),
    [anon_sym_LBRACE] = ACTIONS(1246),
    [anon_sym_RBRACE] = ACTIONS(1246),
    [anon_sym_LPAREN2] = ACTIONS(1246),
    [anon_sym_STAR] = ACTIONS(1246),
    [anon_sym_LBRACK] = ACTIONS(1246),
    [anon_sym_static] = ACTIONS(1248),
    [anon_sym_register] = ACTIONS(1248),
    [anon_sym_inline] = ACTIONS(1248),
    [anon_sym_const] = ACTIONS(1248),
    [anon_sym_restrict] = ACTIONS(1248),
    [anon_sym_volatile] = ACTIONS(1248),
    [anon_sym__Atomic] = ACTIONS(1248),
    [anon_sym_mutable] = ACTIONS(1248),
    [anon_sym_explicit] = ACTIONS(1248),
    [anon_sym_constexpr] = ACTIONS(1248),
    [anon_sym_unsigned] = ACTIONS(1248),
    [anon_sym_long] = ACTIONS(1248),
    [anon_sym_short] = ACTIONS(1248),
    [sym_primitive_type] = ACTIONS(1248),
    [anon_sym_enum] = ACTIONS(1248),
    [anon_sym_struct] = ACTIONS(1248),
    [anon_sym_union] = ACTIONS(1248),
    [anon_sym_if] = ACTIONS(1248),
    [anon_sym_else] = ACTIONS(1248),
    [anon_sym_switch] = ACTIONS(1248),
    [anon_sym_case] = ACTIONS(1248),
    [anon_sym_default] = ACTIONS(1248),
    [anon_sym_while] = ACTIONS(1248),
    [anon_sym_do] = ACTIONS(1248),
    [anon_sym_for] = ACTIONS(1248),
    [anon_sym_return] = ACTIONS(1248),
    [anon_sym_break] = ACTIONS(1248),
    [anon_sym_continue] = ACTIONS(1248),
    [anon_sym_goto] = ACTIONS(1248),
    [anon_sym_AMP] = ACTIONS(1248),
    [anon_sym_AMP_AMP] = ACTIONS(1246),
    [anon_sym_BANG] = ACTIONS(1246),
    [anon_sym_TILDE] = ACTIONS(1246),
    [anon_sym_PLUS] = ACTIONS(1248),
    [anon_sym_DASH] = ACTIONS(1248),
    [anon_sym_DASH_DASH] = ACTIONS(1246),
    [anon_sym_PLUS_PLUS] = ACTIONS(1246),
    [anon_sym_sizeof] = ACTIONS(1248),
    [sym_number_literal] = ACTIONS(1246),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [anon_sym_DQUOTE] = ACTIONS(1246),
    [sym_true] = ACTIONS(1248),
    [sym_false] = ACTIONS(1248),
    [sym_null] = ACTIONS(1248),
    [sym_identifier] = ACTIONS(1248),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1248),
    [sym_auto] = ACTIONS(1248),
    [anon_sym_typename] = ACTIONS(1248),
    [anon_sym_template] = ACTIONS(1248),
    [anon_sym_delete] = ACTIONS(1248),
    [anon_sym_namespace] = ACTIONS(1248),
    [anon_sym_using] = ACTIONS(1248),
    [anon_sym_try] = ACTIONS(1248),
    [anon_sym_new] = ACTIONS(1248),
    [anon_sym_COLON_COLON] = ACTIONS(1246),
    [sym_operator_name] = ACTIONS(1246),
    [sym_nullptr] = ACTIONS(1248),
  },
  [226] = {
    [sym__expression] = STATE(725),
    [sym_conditional_expression] = STATE(725),
    [sym_assignment_expression] = STATE(725),
    [sym_pointer_expression] = STATE(725),
    [sym_logical_expression] = STATE(725),
    [sym_bitwise_expression] = STATE(725),
    [sym_equality_expression] = STATE(725),
    [sym_relational_expression] = STATE(725),
    [sym_shift_expression] = STATE(725),
    [sym_math_expression] = STATE(725),
    [sym_cast_expression] = STATE(725),
    [sym_sizeof_expression] = STATE(725),
    [sym_subscript_expression] = STATE(725),
    [sym_call_expression] = STATE(725),
    [sym_field_expression] = STATE(725),
    [sym_compound_literal_expression] = STATE(725),
    [sym_parenthesized_expression] = STATE(725),
    [sym_initializer_list] = STATE(726),
    [sym_initializer_pair] = STATE(726),
    [sym_subscript_designator] = STATE(728),
    [sym_field_designator] = STATE(728),
    [sym_char_literal] = STATE(725),
    [sym_concatenated_string] = STATE(725),
    [sym_string_literal] = STATE(727),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(725),
    [sym_new_expression] = STATE(725),
    [sym_delete_expression] = STATE(725),
    [sym_lambda_expression] = STATE(725),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [aux_sym_initializer_pair_repeat1] = STATE(728),
    [sym_raw_string_literal] = ACTIONS(1250),
    [anon_sym_COMMA] = ACTIONS(1252),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_RBRACE] = ACTIONS(1254),
    [anon_sym_LPAREN2] = ACTIONS(1256),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_LBRACK] = ACTIONS(1260),
    [anon_sym_AMP] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(1262),
    [anon_sym_TILDE] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_DASH_DASH] = ACTIONS(1268),
    [anon_sym_PLUS_PLUS] = ACTIONS(1268),
    [anon_sym_sizeof] = ACTIONS(1270),
    [anon_sym_DOT] = ACTIONS(1272),
    [sym_number_literal] = ACTIONS(1250),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(1274),
    [sym_false] = ACTIONS(1274),
    [sym_null] = ACTIONS(1274),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1276),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1280),
    [sym_nullptr] = ACTIONS(1274),
  },
  [227] = {
    [sym_type_qualifier] = STATE(141),
    [sym__type_specifier] = STATE(136),
    [sym_sized_type_specifier] = STATE(136),
    [sym_enum_specifier] = STATE(136),
    [sym_struct_specifier] = STATE(136),
    [sym_union_specifier] = STATE(136),
    [sym__expression] = STATE(137),
    [sym_comma_expression] = STATE(138),
    [sym_conditional_expression] = STATE(137),
    [sym_assignment_expression] = STATE(137),
    [sym_pointer_expression] = STATE(137),
    [sym_logical_expression] = STATE(137),
    [sym_bitwise_expression] = STATE(137),
    [sym_equality_expression] = STATE(137),
    [sym_relational_expression] = STATE(137),
    [sym_shift_expression] = STATE(137),
    [sym_math_expression] = STATE(137),
    [sym_cast_expression] = STATE(137),
    [sym_type_descriptor] = STATE(729),
    [sym_sizeof_expression] = STATE(137),
    [sym_subscript_expression] = STATE(137),
    [sym_call_expression] = STATE(137),
    [sym_field_expression] = STATE(137),
    [sym_compound_literal_expression] = STATE(137),
    [sym_parenthesized_expression] = STATE(137),
    [sym_char_literal] = STATE(137),
    [sym_concatenated_string] = STATE(137),
    [sym_string_literal] = STATE(140),
    [sym_macro_type_specifier] = STATE(136),
    [sym_class_specifier] = STATE(136),
    [sym_dependent_type] = STATE(136),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(137),
    [sym_new_expression] = STATE(137),
    [sym_delete_expression] = STATE(137),
    [sym_lambda_expression] = STATE(137),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_type_definition_repeat1] = STATE(141),
    [aux_sym_sized_type_specifier_repeat1] = STATE(142),
    [sym_raw_string_literal] = ACTIONS(213),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(219),
    [anon_sym_long] = ACTIONS(219),
    [anon_sym_short] = ACTIONS(219),
    [sym_primitive_type] = ACTIONS(221),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [sym_null] = ACTIONS(241),
    [sym_identifier] = ACTIONS(811),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(221),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(253),
    [sym_nullptr] = ACTIONS(241),
  },
  [228] = {
    [sym__expression] = STATE(146),
    [sym_conditional_expression] = STATE(146),
    [sym_assignment_expression] = STATE(146),
    [sym_pointer_expression] = STATE(146),
    [sym_logical_expression] = STATE(146),
    [sym_bitwise_expression] = STATE(146),
    [sym_equality_expression] = STATE(146),
    [sym_relational_expression] = STATE(146),
    [sym_shift_expression] = STATE(146),
    [sym_math_expression] = STATE(146),
    [sym_cast_expression] = STATE(146),
    [sym_sizeof_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_compound_literal_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_char_literal] = STATE(146),
    [sym_concatenated_string] = STATE(146),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(146),
    [sym_new_expression] = STATE(146),
    [sym_delete_expression] = STATE(146),
    [sym_lambda_expression] = STATE(146),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(257),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(257),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(259),
    [sym_false] = ACTIONS(259),
    [sym_null] = ACTIONS(259),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(259),
  },
  [229] = {
    [sym__expression] = STATE(250),
    [sym_conditional_expression] = STATE(250),
    [sym_assignment_expression] = STATE(250),
    [sym_pointer_expression] = STATE(250),
    [sym_logical_expression] = STATE(250),
    [sym_bitwise_expression] = STATE(250),
    [sym_equality_expression] = STATE(250),
    [sym_relational_expression] = STATE(250),
    [sym_shift_expression] = STATE(250),
    [sym_math_expression] = STATE(250),
    [sym_cast_expression] = STATE(250),
    [sym_sizeof_expression] = STATE(250),
    [sym_subscript_expression] = STATE(250),
    [sym_call_expression] = STATE(250),
    [sym_field_expression] = STATE(250),
    [sym_compound_literal_expression] = STATE(250),
    [sym_parenthesized_expression] = STATE(250),
    [sym_char_literal] = STATE(250),
    [sym_concatenated_string] = STATE(250),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(250),
    [sym_new_expression] = STATE(250),
    [sym_delete_expression] = STATE(250),
    [sym_lambda_expression] = STATE(250),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(435),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(435),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(437),
    [sym_false] = ACTIONS(437),
    [sym_null] = ACTIONS(437),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(437),
  },
  [230] = {
    [sym__expression] = STATE(252),
    [sym_conditional_expression] = STATE(252),
    [sym_assignment_expression] = STATE(252),
    [sym_pointer_expression] = STATE(252),
    [sym_logical_expression] = STATE(252),
    [sym_bitwise_expression] = STATE(252),
    [sym_equality_expression] = STATE(252),
    [sym_relational_expression] = STATE(252),
    [sym_shift_expression] = STATE(252),
    [sym_math_expression] = STATE(252),
    [sym_cast_expression] = STATE(252),
    [sym_sizeof_expression] = STATE(252),
    [sym_subscript_expression] = STATE(252),
    [sym_call_expression] = STATE(252),
    [sym_field_expression] = STATE(252),
    [sym_compound_literal_expression] = STATE(252),
    [sym_parenthesized_expression] = STATE(252),
    [sym_char_literal] = STATE(252),
    [sym_concatenated_string] = STATE(252),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(252),
    [sym_new_expression] = STATE(252),
    [sym_delete_expression] = STATE(252),
    [sym_lambda_expression] = STATE(252),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(439),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(439),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(441),
    [sym_false] = ACTIONS(441),
    [sym_null] = ACTIONS(441),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(441),
  },
  [231] = {
    [sym__expression] = STATE(253),
    [sym_conditional_expression] = STATE(253),
    [sym_assignment_expression] = STATE(253),
    [sym_pointer_expression] = STATE(253),
    [sym_logical_expression] = STATE(253),
    [sym_bitwise_expression] = STATE(253),
    [sym_equality_expression] = STATE(253),
    [sym_relational_expression] = STATE(253),
    [sym_shift_expression] = STATE(253),
    [sym_math_expression] = STATE(253),
    [sym_cast_expression] = STATE(253),
    [sym_sizeof_expression] = STATE(253),
    [sym_subscript_expression] = STATE(253),
    [sym_call_expression] = STATE(253),
    [sym_field_expression] = STATE(253),
    [sym_compound_literal_expression] = STATE(253),
    [sym_parenthesized_expression] = STATE(253),
    [sym_char_literal] = STATE(253),
    [sym_concatenated_string] = STATE(253),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(253),
    [sym_new_expression] = STATE(253),
    [sym_delete_expression] = STATE(253),
    [sym_lambda_expression] = STATE(253),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(445),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(445),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(447),
    [sym_false] = ACTIONS(447),
    [sym_null] = ACTIONS(447),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(447),
  },
  [232] = {
    [sym__expression] = STATE(731),
    [sym_conditional_expression] = STATE(731),
    [sym_assignment_expression] = STATE(731),
    [sym_pointer_expression] = STATE(731),
    [sym_logical_expression] = STATE(731),
    [sym_bitwise_expression] = STATE(731),
    [sym_equality_expression] = STATE(731),
    [sym_relational_expression] = STATE(731),
    [sym_shift_expression] = STATE(731),
    [sym_math_expression] = STATE(731),
    [sym_cast_expression] = STATE(731),
    [sym_sizeof_expression] = STATE(731),
    [sym_subscript_expression] = STATE(731),
    [sym_call_expression] = STATE(731),
    [sym_field_expression] = STATE(731),
    [sym_compound_literal_expression] = STATE(731),
    [sym_parenthesized_expression] = STATE(731),
    [sym_char_literal] = STATE(731),
    [sym_concatenated_string] = STATE(731),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(731),
    [sym_new_expression] = STATE(731),
    [sym_delete_expression] = STATE(731),
    [sym_lambda_expression] = STATE(731),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(1282),
    [anon_sym_LPAREN2] = ACTIONS(1284),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(1282),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(1286),
    [sym_false] = ACTIONS(1286),
    [sym_null] = ACTIONS(1286),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(1286),
  },
  [233] = {
    [sym__expression] = STATE(733),
    [sym_conditional_expression] = STATE(733),
    [sym_assignment_expression] = STATE(733),
    [sym_pointer_expression] = STATE(733),
    [sym_logical_expression] = STATE(733),
    [sym_bitwise_expression] = STATE(733),
    [sym_equality_expression] = STATE(733),
    [sym_relational_expression] = STATE(733),
    [sym_shift_expression] = STATE(733),
    [sym_math_expression] = STATE(733),
    [sym_cast_expression] = STATE(733),
    [sym_sizeof_expression] = STATE(733),
    [sym_subscript_expression] = STATE(733),
    [sym_call_expression] = STATE(733),
    [sym_field_expression] = STATE(733),
    [sym_compound_literal_expression] = STATE(733),
    [sym_parenthesized_expression] = STATE(733),
    [sym_char_literal] = STATE(733),
    [sym_concatenated_string] = STATE(733),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(733),
    [sym_new_expression] = STATE(733),
    [sym_delete_expression] = STATE(733),
    [sym_lambda_expression] = STATE(733),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(1288),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(1290),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(1288),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(1292),
    [sym_false] = ACTIONS(1292),
    [sym_null] = ACTIONS(1292),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(1292),
  },
  [234] = {
    [sym__type_specifier] = STATE(735),
    [sym_sized_type_specifier] = STATE(735),
    [sym_enum_specifier] = STATE(735),
    [sym_struct_specifier] = STATE(735),
    [sym_union_specifier] = STATE(735),
    [sym_argument_list] = STATE(736),
    [sym_macro_type_specifier] = STATE(735),
    [sym_class_specifier] = STATE(735),
    [sym_dependent_type] = STATE(735),
    [sym_template_type] = STATE(309),
    [sym_scoped_type_identifier] = STATE(310),
    [sym_scoped_namespace_identifier] = STATE(311),
    [aux_sym_sized_type_specifier_repeat1] = STATE(737),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_unsigned] = ACTIONS(1294),
    [anon_sym_long] = ACTIONS(1294),
    [anon_sym_short] = ACTIONS(1294),
    [sym_primitive_type] = ACTIONS(1296),
    [anon_sym_enum] = ACTIONS(536),
    [anon_sym_struct] = ACTIONS(538),
    [anon_sym_union] = ACTIONS(540),
    [sym_identifier] = ACTIONS(542),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(544),
    [sym_auto] = ACTIONS(1296),
    [anon_sym_typename] = ACTIONS(1298),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [235] = {
    [sym_destructor_name] = STATE(315),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(937),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1300),
    [sym_operator_name] = ACTIONS(554),
  },
  [236] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(1302),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [237] = {
    [anon_sym_SEMI] = ACTIONS(1302),
    [sym_comment] = ACTIONS(91),
  },
  [238] = {
    [sym_string_literal] = STATE(752),
    [aux_sym_concatenated_string_repeat1] = STATE(752),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_LPAREN2] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(91),
  },
  [239] = {
    [sym_raw_string_literal] = ACTIONS(1332),
    [ts_builtin_sym_end] = ACTIONS(1332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1334),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1334),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1334),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1334),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1334),
    [sym_preproc_directive] = ACTIONS(1334),
    [anon_sym_SEMI] = ACTIONS(1332),
    [anon_sym_typedef] = ACTIONS(1334),
    [anon_sym_extern] = ACTIONS(1334),
    [anon_sym_LBRACE] = ACTIONS(1332),
    [anon_sym_RBRACE] = ACTIONS(1332),
    [anon_sym_LPAREN2] = ACTIONS(1332),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_LBRACK] = ACTIONS(1332),
    [anon_sym_static] = ACTIONS(1334),
    [anon_sym_register] = ACTIONS(1334),
    [anon_sym_inline] = ACTIONS(1334),
    [anon_sym_const] = ACTIONS(1334),
    [anon_sym_restrict] = ACTIONS(1334),
    [anon_sym_volatile] = ACTIONS(1334),
    [anon_sym__Atomic] = ACTIONS(1334),
    [anon_sym_mutable] = ACTIONS(1334),
    [anon_sym_explicit] = ACTIONS(1334),
    [anon_sym_constexpr] = ACTIONS(1334),
    [anon_sym_unsigned] = ACTIONS(1334),
    [anon_sym_long] = ACTIONS(1334),
    [anon_sym_short] = ACTIONS(1334),
    [sym_primitive_type] = ACTIONS(1334),
    [anon_sym_enum] = ACTIONS(1334),
    [anon_sym_struct] = ACTIONS(1334),
    [anon_sym_union] = ACTIONS(1334),
    [anon_sym_if] = ACTIONS(1334),
    [anon_sym_else] = ACTIONS(1334),
    [anon_sym_switch] = ACTIONS(1334),
    [anon_sym_case] = ACTIONS(1334),
    [anon_sym_default] = ACTIONS(1334),
    [anon_sym_while] = ACTIONS(1334),
    [anon_sym_do] = ACTIONS(1334),
    [anon_sym_for] = ACTIONS(1334),
    [anon_sym_return] = ACTIONS(1334),
    [anon_sym_break] = ACTIONS(1334),
    [anon_sym_continue] = ACTIONS(1334),
    [anon_sym_goto] = ACTIONS(1334),
    [anon_sym_AMP] = ACTIONS(1334),
    [anon_sym_AMP_AMP] = ACTIONS(1332),
    [anon_sym_BANG] = ACTIONS(1332),
    [anon_sym_TILDE] = ACTIONS(1332),
    [anon_sym_PLUS] = ACTIONS(1334),
    [anon_sym_DASH] = ACTIONS(1334),
    [anon_sym_DASH_DASH] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(1332),
    [anon_sym_sizeof] = ACTIONS(1334),
    [sym_number_literal] = ACTIONS(1332),
    [anon_sym_SQUOTE] = ACTIONS(1332),
    [anon_sym_DQUOTE] = ACTIONS(1332),
    [sym_true] = ACTIONS(1334),
    [sym_false] = ACTIONS(1334),
    [sym_null] = ACTIONS(1334),
    [sym_identifier] = ACTIONS(1334),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1334),
    [sym_auto] = ACTIONS(1334),
    [anon_sym_typename] = ACTIONS(1334),
    [anon_sym_template] = ACTIONS(1334),
    [anon_sym_delete] = ACTIONS(1334),
    [anon_sym_namespace] = ACTIONS(1334),
    [anon_sym_using] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1334),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_COLON_COLON] = ACTIONS(1332),
    [sym_operator_name] = ACTIONS(1332),
    [sym_nullptr] = ACTIONS(1334),
  },
  [240] = {
    [sym_raw_string_literal] = ACTIONS(1336),
    [ts_builtin_sym_end] = ACTIONS(1336),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1338),
    [sym_preproc_directive] = ACTIONS(1338),
    [anon_sym_SEMI] = ACTIONS(1336),
    [anon_sym_typedef] = ACTIONS(1338),
    [anon_sym_extern] = ACTIONS(1338),
    [anon_sym_LBRACE] = ACTIONS(1336),
    [anon_sym_RBRACE] = ACTIONS(1336),
    [anon_sym_LPAREN2] = ACTIONS(1336),
    [anon_sym_STAR] = ACTIONS(1336),
    [anon_sym_LBRACK] = ACTIONS(1336),
    [anon_sym_static] = ACTIONS(1338),
    [anon_sym_register] = ACTIONS(1338),
    [anon_sym_inline] = ACTIONS(1338),
    [anon_sym_const] = ACTIONS(1338),
    [anon_sym_restrict] = ACTIONS(1338),
    [anon_sym_volatile] = ACTIONS(1338),
    [anon_sym__Atomic] = ACTIONS(1338),
    [anon_sym_mutable] = ACTIONS(1338),
    [anon_sym_explicit] = ACTIONS(1338),
    [anon_sym_constexpr] = ACTIONS(1338),
    [anon_sym_unsigned] = ACTIONS(1338),
    [anon_sym_long] = ACTIONS(1338),
    [anon_sym_short] = ACTIONS(1338),
    [sym_primitive_type] = ACTIONS(1338),
    [anon_sym_enum] = ACTIONS(1338),
    [anon_sym_struct] = ACTIONS(1338),
    [anon_sym_union] = ACTIONS(1338),
    [anon_sym_if] = ACTIONS(1338),
    [anon_sym_else] = ACTIONS(1338),
    [anon_sym_switch] = ACTIONS(1338),
    [anon_sym_case] = ACTIONS(1338),
    [anon_sym_default] = ACTIONS(1338),
    [anon_sym_while] = ACTIONS(1338),
    [anon_sym_do] = ACTIONS(1338),
    [anon_sym_for] = ACTIONS(1338),
    [anon_sym_return] = ACTIONS(1338),
    [anon_sym_break] = ACTIONS(1338),
    [anon_sym_continue] = ACTIONS(1338),
    [anon_sym_goto] = ACTIONS(1338),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_AMP_AMP] = ACTIONS(1336),
    [anon_sym_BANG] = ACTIONS(1336),
    [anon_sym_TILDE] = ACTIONS(1336),
    [anon_sym_PLUS] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_DASH_DASH] = ACTIONS(1336),
    [anon_sym_PLUS_PLUS] = ACTIONS(1336),
    [anon_sym_sizeof] = ACTIONS(1338),
    [sym_number_literal] = ACTIONS(1336),
    [anon_sym_SQUOTE] = ACTIONS(1336),
    [anon_sym_DQUOTE] = ACTIONS(1336),
    [sym_true] = ACTIONS(1338),
    [sym_false] = ACTIONS(1338),
    [sym_null] = ACTIONS(1338),
    [sym_identifier] = ACTIONS(1338),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1338),
    [sym_auto] = ACTIONS(1338),
    [anon_sym_typename] = ACTIONS(1338),
    [anon_sym_template] = ACTIONS(1338),
    [anon_sym_delete] = ACTIONS(1338),
    [anon_sym_namespace] = ACTIONS(1338),
    [anon_sym_using] = ACTIONS(1338),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_new] = ACTIONS(1338),
    [anon_sym_COLON_COLON] = ACTIONS(1336),
    [sym_operator_name] = ACTIONS(1336),
    [sym_nullptr] = ACTIONS(1338),
  },
  [241] = {
    [anon_sym_SEMI] = ACTIONS(1340),
    [sym_comment] = ACTIONS(91),
  },
  [242] = {
    [sym__declarator] = STATE(135),
    [sym_pointer_declarator] = STATE(135),
    [sym_function_declarator] = STATE(135),
    [sym_array_declarator] = STATE(135),
    [sym_reference_declarator] = STATE(135),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(135),
    [sym_destructor_name] = STATE(135),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(859),
    [anon_sym_AMP_AMP] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(431),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(255),
  },
  [243] = {
    [sym__declarator] = STATE(145),
    [sym_pointer_declarator] = STATE(145),
    [sym_function_declarator] = STATE(145),
    [sym_array_declarator] = STATE(145),
    [sym_type_qualifier] = STATE(150),
    [sym_reference_declarator] = STATE(145),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(145),
    [sym_destructor_name] = STATE(145),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [aux_sym_type_definition_repeat1] = STATE(150),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(425),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(431),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(265),
  },
  [244] = {
    [sym_identifier] = ACTIONS(1342),
    [sym_comment] = ACTIONS(91),
  },
  [245] = {
    [sym_template_argument_list] = STATE(548),
    [anon_sym_RPAREN] = ACTIONS(576),
    [anon_sym_SEMI] = ACTIONS(576),
    [anon_sym_LPAREN2] = ACTIONS(576),
    [anon_sym_LBRACK] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(945),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1344),
  },
  [246] = {
    [sym_destructor_name] = STATE(315),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(1346),
    [sym_comment] = ACTIONS(91),
    [sym_operator_name] = ACTIONS(554),
  },
  [247] = {
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1348),
  },
  [248] = {
    [sym_template_argument_list] = STATE(360),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_RPAREN] = ACTIONS(576),
    [anon_sym_SEMI] = ACTIONS(576),
    [anon_sym_LBRACE] = ACTIONS(576),
    [anon_sym_LPAREN2] = ACTIONS(576),
    [anon_sym_LBRACK] = ACTIONS(576),
    [anon_sym_EQ] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(945),
    [sym_comment] = ACTIONS(91),
  },
  [249] = {
    [sym_template_argument_list] = STATE(362),
    [anon_sym_LT] = ACTIONS(945),
    [sym_comment] = ACTIONS(91),
  },
  [250] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(1350),
    [anon_sym_RPAREN] = ACTIONS(1350),
    [anon_sym_SEMI] = ACTIONS(1350),
    [anon_sym_RBRACE] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(1350),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_QMARK] = ACTIONS(1350),
    [anon_sym_STAR_EQ] = ACTIONS(1350),
    [anon_sym_SLASH_EQ] = ACTIONS(1350),
    [anon_sym_PERCENT_EQ] = ACTIONS(1350),
    [anon_sym_PLUS_EQ] = ACTIONS(1350),
    [anon_sym_DASH_EQ] = ACTIONS(1350),
    [anon_sym_LT_LT_EQ] = ACTIONS(1350),
    [anon_sym_GT_GT_EQ] = ACTIONS(1350),
    [anon_sym_AMP_EQ] = ACTIONS(1350),
    [anon_sym_CARET_EQ] = ACTIONS(1350),
    [anon_sym_PIPE_EQ] = ACTIONS(1350),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_PIPE_PIPE] = ACTIONS(1350),
    [anon_sym_AMP_AMP] = ACTIONS(1350),
    [anon_sym_PIPE] = ACTIONS(1352),
    [anon_sym_CARET] = ACTIONS(1352),
    [anon_sym_EQ_EQ] = ACTIONS(1350),
    [anon_sym_BANG_EQ] = ACTIONS(1350),
    [anon_sym_LT] = ACTIONS(1352),
    [anon_sym_GT] = ACTIONS(1352),
    [anon_sym_LT_EQ] = ACTIONS(1350),
    [anon_sym_GT_EQ] = ACTIONS(1350),
    [anon_sym_LT_LT] = ACTIONS(1352),
    [anon_sym_GT_GT] = ACTIONS(1352),
    [anon_sym_PLUS] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1352),
    [anon_sym_SLASH] = ACTIONS(1352),
    [anon_sym_PERCENT] = ACTIONS(1352),
    [anon_sym_DASH_DASH] = ACTIONS(1350),
    [anon_sym_PLUS_PLUS] = ACTIONS(1350),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [251] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(548),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(1354),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(1354),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(1354),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(935),
  },
  [252] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(1356),
    [anon_sym_RPAREN] = ACTIONS(1356),
    [anon_sym_SEMI] = ACTIONS(1356),
    [anon_sym_RBRACE] = ACTIONS(1356),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1358),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(1356),
    [anon_sym_EQ] = ACTIONS(1358),
    [anon_sym_QMARK] = ACTIONS(1356),
    [anon_sym_STAR_EQ] = ACTIONS(1356),
    [anon_sym_SLASH_EQ] = ACTIONS(1356),
    [anon_sym_PERCENT_EQ] = ACTIONS(1356),
    [anon_sym_PLUS_EQ] = ACTIONS(1356),
    [anon_sym_DASH_EQ] = ACTIONS(1356),
    [anon_sym_LT_LT_EQ] = ACTIONS(1356),
    [anon_sym_GT_GT_EQ] = ACTIONS(1356),
    [anon_sym_AMP_EQ] = ACTIONS(1356),
    [anon_sym_CARET_EQ] = ACTIONS(1356),
    [anon_sym_PIPE_EQ] = ACTIONS(1356),
    [anon_sym_AMP] = ACTIONS(1358),
    [anon_sym_PIPE_PIPE] = ACTIONS(1356),
    [anon_sym_AMP_AMP] = ACTIONS(1356),
    [anon_sym_PIPE] = ACTIONS(1358),
    [anon_sym_CARET] = ACTIONS(1358),
    [anon_sym_EQ_EQ] = ACTIONS(1356),
    [anon_sym_BANG_EQ] = ACTIONS(1356),
    [anon_sym_LT] = ACTIONS(1358),
    [anon_sym_GT] = ACTIONS(1358),
    [anon_sym_LT_EQ] = ACTIONS(1356),
    [anon_sym_GT_EQ] = ACTIONS(1356),
    [anon_sym_LT_LT] = ACTIONS(1358),
    [anon_sym_GT_GT] = ACTIONS(1358),
    [anon_sym_PLUS] = ACTIONS(1358),
    [anon_sym_DASH] = ACTIONS(1358),
    [anon_sym_SLASH] = ACTIONS(1358),
    [anon_sym_PERCENT] = ACTIONS(1358),
    [anon_sym_DASH_DASH] = ACTIONS(1356),
    [anon_sym_PLUS_PLUS] = ACTIONS(1356),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [253] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(1360),
    [anon_sym_RPAREN] = ACTIONS(1360),
    [anon_sym_SEMI] = ACTIONS(1360),
    [anon_sym_RBRACE] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1362),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(1360),
    [anon_sym_EQ] = ACTIONS(1362),
    [anon_sym_QMARK] = ACTIONS(1360),
    [anon_sym_STAR_EQ] = ACTIONS(1360),
    [anon_sym_SLASH_EQ] = ACTIONS(1360),
    [anon_sym_PERCENT_EQ] = ACTIONS(1360),
    [anon_sym_PLUS_EQ] = ACTIONS(1360),
    [anon_sym_DASH_EQ] = ACTIONS(1360),
    [anon_sym_LT_LT_EQ] = ACTIONS(1360),
    [anon_sym_GT_GT_EQ] = ACTIONS(1360),
    [anon_sym_AMP_EQ] = ACTIONS(1360),
    [anon_sym_CARET_EQ] = ACTIONS(1360),
    [anon_sym_PIPE_EQ] = ACTIONS(1360),
    [anon_sym_AMP] = ACTIONS(1362),
    [anon_sym_PIPE_PIPE] = ACTIONS(1360),
    [anon_sym_AMP_AMP] = ACTIONS(1360),
    [anon_sym_PIPE] = ACTIONS(1362),
    [anon_sym_CARET] = ACTIONS(1362),
    [anon_sym_EQ_EQ] = ACTIONS(1360),
    [anon_sym_BANG_EQ] = ACTIONS(1360),
    [anon_sym_LT] = ACTIONS(1362),
    [anon_sym_GT] = ACTIONS(1362),
    [anon_sym_LT_EQ] = ACTIONS(1360),
    [anon_sym_GT_EQ] = ACTIONS(1360),
    [anon_sym_LT_LT] = ACTIONS(1362),
    [anon_sym_GT_GT] = ACTIONS(1362),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_SLASH] = ACTIONS(1362),
    [anon_sym_PERCENT] = ACTIONS(1362),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [254] = {
    [sym_type_qualifier] = STATE(141),
    [sym__type_specifier] = STATE(136),
    [sym_sized_type_specifier] = STATE(136),
    [sym_enum_specifier] = STATE(136),
    [sym_struct_specifier] = STATE(136),
    [sym_union_specifier] = STATE(136),
    [sym__expression] = STATE(137),
    [sym_comma_expression] = STATE(138),
    [sym_conditional_expression] = STATE(137),
    [sym_assignment_expression] = STATE(137),
    [sym_pointer_expression] = STATE(137),
    [sym_logical_expression] = STATE(137),
    [sym_bitwise_expression] = STATE(137),
    [sym_equality_expression] = STATE(137),
    [sym_relational_expression] = STATE(137),
    [sym_shift_expression] = STATE(137),
    [sym_math_expression] = STATE(137),
    [sym_cast_expression] = STATE(137),
    [sym_type_descriptor] = STATE(758),
    [sym_sizeof_expression] = STATE(137),
    [sym_subscript_expression] = STATE(137),
    [sym_call_expression] = STATE(137),
    [sym_field_expression] = STATE(137),
    [sym_compound_literal_expression] = STATE(137),
    [sym_parenthesized_expression] = STATE(137),
    [sym_char_literal] = STATE(137),
    [sym_concatenated_string] = STATE(137),
    [sym_string_literal] = STATE(140),
    [sym_macro_type_specifier] = STATE(136),
    [sym_class_specifier] = STATE(136),
    [sym_dependent_type] = STATE(136),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(137),
    [sym_new_expression] = STATE(137),
    [sym_delete_expression] = STATE(137),
    [sym_lambda_expression] = STATE(137),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_type_definition_repeat1] = STATE(141),
    [aux_sym_sized_type_specifier_repeat1] = STATE(142),
    [sym_raw_string_literal] = ACTIONS(213),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(219),
    [anon_sym_long] = ACTIONS(219),
    [anon_sym_short] = ACTIONS(219),
    [sym_primitive_type] = ACTIONS(221),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [sym_null] = ACTIONS(241),
    [sym_identifier] = ACTIONS(811),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(221),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(253),
    [sym_nullptr] = ACTIONS(241),
  },
  [255] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(1364),
    [anon_sym_SEMI] = ACTIONS(1364),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(590),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1366),
    [anon_sym_QMARK] = ACTIONS(1364),
    [anon_sym_STAR_EQ] = ACTIONS(1364),
    [anon_sym_SLASH_EQ] = ACTIONS(1364),
    [anon_sym_PERCENT_EQ] = ACTIONS(1364),
    [anon_sym_PLUS_EQ] = ACTIONS(1364),
    [anon_sym_DASH_EQ] = ACTIONS(1364),
    [anon_sym_LT_LT_EQ] = ACTIONS(1364),
    [anon_sym_GT_GT_EQ] = ACTIONS(1364),
    [anon_sym_AMP_EQ] = ACTIONS(1364),
    [anon_sym_CARET_EQ] = ACTIONS(1364),
    [anon_sym_PIPE_EQ] = ACTIONS(1364),
    [anon_sym_AMP] = ACTIONS(1366),
    [anon_sym_PIPE_PIPE] = ACTIONS(1364),
    [anon_sym_AMP_AMP] = ACTIONS(1364),
    [anon_sym_PIPE] = ACTIONS(1366),
    [anon_sym_CARET] = ACTIONS(1366),
    [anon_sym_EQ_EQ] = ACTIONS(1364),
    [anon_sym_BANG_EQ] = ACTIONS(1364),
    [anon_sym_LT] = ACTIONS(1366),
    [anon_sym_GT] = ACTIONS(1366),
    [anon_sym_LT_EQ] = ACTIONS(1364),
    [anon_sym_GT_EQ] = ACTIONS(1364),
    [anon_sym_LT_LT] = ACTIONS(616),
    [anon_sym_GT_GT] = ACTIONS(616),
    [anon_sym_PLUS] = ACTIONS(618),
    [anon_sym_DASH] = ACTIONS(618),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [256] = {
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [sym_comment] = ACTIONS(91),
  },
  [257] = {
    [anon_sym_COMMA] = ACTIONS(1370),
    [anon_sym_RPAREN] = ACTIONS(1370),
    [anon_sym_SEMI] = ACTIONS(1370),
    [anon_sym_extern] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1370),
    [anon_sym_RBRACE] = ACTIONS(1370),
    [anon_sym_LPAREN2] = ACTIONS(1370),
    [anon_sym_STAR] = ACTIONS(1372),
    [anon_sym_LBRACK] = ACTIONS(1370),
    [anon_sym_RBRACK] = ACTIONS(1370),
    [anon_sym_EQ] = ACTIONS(1372),
    [anon_sym_static] = ACTIONS(1372),
    [anon_sym_register] = ACTIONS(1372),
    [anon_sym_inline] = ACTIONS(1372),
    [anon_sym_const] = ACTIONS(1372),
    [anon_sym_restrict] = ACTIONS(1372),
    [anon_sym_volatile] = ACTIONS(1372),
    [anon_sym__Atomic] = ACTIONS(1372),
    [anon_sym_mutable] = ACTIONS(1372),
    [anon_sym_explicit] = ACTIONS(1372),
    [anon_sym_constexpr] = ACTIONS(1372),
    [anon_sym_unsigned] = ACTIONS(1372),
    [anon_sym_long] = ACTIONS(1372),
    [anon_sym_short] = ACTIONS(1372),
    [sym_primitive_type] = ACTIONS(1372),
    [anon_sym_enum] = ACTIONS(1372),
    [anon_sym_struct] = ACTIONS(1372),
    [anon_sym_union] = ACTIONS(1372),
    [anon_sym_QMARK] = ACTIONS(1370),
    [anon_sym_STAR_EQ] = ACTIONS(1370),
    [anon_sym_SLASH_EQ] = ACTIONS(1370),
    [anon_sym_PERCENT_EQ] = ACTIONS(1370),
    [anon_sym_PLUS_EQ] = ACTIONS(1370),
    [anon_sym_DASH_EQ] = ACTIONS(1370),
    [anon_sym_LT_LT_EQ] = ACTIONS(1370),
    [anon_sym_GT_GT_EQ] = ACTIONS(1370),
    [anon_sym_AMP_EQ] = ACTIONS(1370),
    [anon_sym_CARET_EQ] = ACTIONS(1370),
    [anon_sym_PIPE_EQ] = ACTIONS(1370),
    [anon_sym_AMP] = ACTIONS(1372),
    [anon_sym_PIPE_PIPE] = ACTIONS(1370),
    [anon_sym_AMP_AMP] = ACTIONS(1370),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_CARET] = ACTIONS(1372),
    [anon_sym_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG_EQ] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1372),
    [anon_sym_GT] = ACTIONS(1372),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_LT_LT] = ACTIONS(1372),
    [anon_sym_GT_GT] = ACTIONS(1372),
    [anon_sym_PLUS] = ACTIONS(1372),
    [anon_sym_DASH] = ACTIONS(1372),
    [anon_sym_SLASH] = ACTIONS(1372),
    [anon_sym_PERCENT] = ACTIONS(1372),
    [anon_sym_DASH_DASH] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1370),
    [anon_sym_DOT] = ACTIONS(1370),
    [anon_sym_DASH_GT] = ACTIONS(1370),
    [anon_sym_DQUOTE] = ACTIONS(1370),
    [sym_identifier] = ACTIONS(1372),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1372),
    [sym_auto] = ACTIONS(1372),
    [anon_sym_typename] = ACTIONS(1372),
    [anon_sym_COLON_COLON] = ACTIONS(1370),
  },
  [258] = {
    [aux_sym_string_literal_repeat1] = STATE(761),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_BSLASHn_RBRACK_SLASH] = ACTIONS(1376),
    [sym_escape_sequence] = ACTIONS(1376),
    [sym_comment] = ACTIONS(121),
  },
  [259] = {
    [sym_compound_statement] = STATE(762),
    [sym_labeled_statement] = STATE(762),
    [sym_expression_statement] = STATE(762),
    [sym_if_statement] = STATE(762),
    [sym_switch_statement] = STATE(762),
    [sym_case_statement] = STATE(762),
    [sym_while_statement] = STATE(762),
    [sym_do_statement] = STATE(762),
    [sym_for_statement] = STATE(762),
    [sym_return_statement] = STATE(762),
    [sym_break_statement] = STATE(762),
    [sym_continue_statement] = STATE(762),
    [sym_goto_statement] = STATE(762),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(762),
    [sym_try_statement] = STATE(762),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_switch] = ACTIONS(49),
    [anon_sym_case] = ACTIONS(51),
    [anon_sym_default] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(1115),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(105),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [260] = {
    [sym_type_qualifier] = STATE(786),
    [sym__type_specifier] = STATE(777),
    [sym_sized_type_specifier] = STATE(777),
    [sym_enum_specifier] = STATE(777),
    [sym_struct_specifier] = STATE(777),
    [sym_union_specifier] = STATE(777),
    [sym__expression] = STATE(778),
    [sym_conditional_expression] = STATE(778),
    [sym_assignment_expression] = STATE(778),
    [sym_pointer_expression] = STATE(778),
    [sym_logical_expression] = STATE(778),
    [sym_bitwise_expression] = STATE(778),
    [sym_equality_expression] = STATE(778),
    [sym_relational_expression] = STATE(778),
    [sym_shift_expression] = STATE(778),
    [sym_math_expression] = STATE(778),
    [sym_cast_expression] = STATE(778),
    [sym_type_descriptor] = STATE(779),
    [sym_sizeof_expression] = STATE(778),
    [sym_subscript_expression] = STATE(778),
    [sym_call_expression] = STATE(778),
    [sym_field_expression] = STATE(778),
    [sym_compound_literal_expression] = STATE(778),
    [sym_parenthesized_expression] = STATE(778),
    [sym_char_literal] = STATE(778),
    [sym_concatenated_string] = STATE(778),
    [sym_string_literal] = STATE(780),
    [sym_macro_type_specifier] = STATE(777),
    [sym_class_specifier] = STATE(777),
    [sym_dependent_type] = STATE(777),
    [sym_template_type] = STATE(781),
    [sym_template_function] = STATE(778),
    [sym_new_expression] = STATE(778),
    [sym_delete_expression] = STATE(778),
    [sym_lambda_expression] = STATE(778),
    [sym_lambda_capture_specifier] = STATE(782),
    [sym_scoped_identifier] = STATE(783),
    [sym_scoped_type_identifier] = STATE(784),
    [sym_scoped_namespace_identifier] = STATE(785),
    [aux_sym_type_definition_repeat1] = STATE(786),
    [aux_sym_sized_type_specifier_repeat1] = STATE(787),
    [sym_raw_string_literal] = ACTIONS(1378),
    [anon_sym_LPAREN2] = ACTIONS(1380),
    [anon_sym_STAR] = ACTIONS(1382),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(1384),
    [anon_sym_long] = ACTIONS(1384),
    [anon_sym_short] = ACTIONS(1384),
    [sym_primitive_type] = ACTIONS(1386),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [anon_sym_AMP] = ACTIONS(1382),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1394),
    [anon_sym_PLUS_PLUS] = ACTIONS(1394),
    [anon_sym_sizeof] = ACTIONS(1396),
    [sym_number_literal] = ACTIONS(1378),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_true] = ACTIONS(1402),
    [sym_false] = ACTIONS(1402),
    [sym_null] = ACTIONS(1402),
    [sym_identifier] = ACTIONS(1404),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(1386),
    [anon_sym_typename] = ACTIONS(1406),
    [anon_sym_GT2] = ACTIONS(1408),
    [anon_sym_delete] = ACTIONS(1410),
    [anon_sym_new] = ACTIONS(1412),
    [anon_sym_COLON_COLON] = ACTIONS(1414),
    [sym_nullptr] = ACTIONS(1402),
  },
  [261] = {
    [sym_destructor_name] = STATE(789),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(1416),
    [sym_comment] = ACTIONS(91),
    [sym_operator_name] = ACTIONS(1418),
  },
  [262] = {
    [anon_sym_COMMA] = ACTIONS(1420),
    [anon_sym_RPAREN] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(1420),
    [anon_sym_RBRACE] = ACTIONS(1420),
    [anon_sym_LPAREN2] = ACTIONS(1420),
    [anon_sym_STAR] = ACTIONS(1422),
    [anon_sym_LBRACK] = ACTIONS(1420),
    [anon_sym_RBRACK] = ACTIONS(1420),
    [anon_sym_EQ] = ACTIONS(1422),
    [anon_sym_COLON] = ACTIONS(1420),
    [anon_sym_QMARK] = ACTIONS(1420),
    [anon_sym_STAR_EQ] = ACTIONS(1420),
    [anon_sym_SLASH_EQ] = ACTIONS(1420),
    [anon_sym_PERCENT_EQ] = ACTIONS(1420),
    [anon_sym_PLUS_EQ] = ACTIONS(1420),
    [anon_sym_DASH_EQ] = ACTIONS(1420),
    [anon_sym_LT_LT_EQ] = ACTIONS(1420),
    [anon_sym_GT_GT_EQ] = ACTIONS(1420),
    [anon_sym_AMP_EQ] = ACTIONS(1420),
    [anon_sym_CARET_EQ] = ACTIONS(1420),
    [anon_sym_PIPE_EQ] = ACTIONS(1420),
    [anon_sym_AMP] = ACTIONS(1422),
    [anon_sym_PIPE_PIPE] = ACTIONS(1420),
    [anon_sym_AMP_AMP] = ACTIONS(1420),
    [anon_sym_PIPE] = ACTIONS(1422),
    [anon_sym_CARET] = ACTIONS(1422),
    [anon_sym_EQ_EQ] = ACTIONS(1420),
    [anon_sym_BANG_EQ] = ACTIONS(1420),
    [anon_sym_LT] = ACTIONS(1422),
    [anon_sym_GT] = ACTIONS(1422),
    [anon_sym_LT_EQ] = ACTIONS(1420),
    [anon_sym_GT_EQ] = ACTIONS(1420),
    [anon_sym_LT_LT] = ACTIONS(1422),
    [anon_sym_GT_GT] = ACTIONS(1422),
    [anon_sym_PLUS] = ACTIONS(1422),
    [anon_sym_DASH] = ACTIONS(1422),
    [anon_sym_SLASH] = ACTIONS(1422),
    [anon_sym_PERCENT] = ACTIONS(1422),
    [anon_sym_DASH_DASH] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1420),
    [anon_sym_DOT] = ACTIONS(1420),
    [anon_sym_DASH_GT] = ACTIONS(1420),
    [sym_comment] = ACTIONS(91),
  },
  [263] = {
    [anon_sym_COMMA] = ACTIONS(1424),
    [anon_sym_RPAREN] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1426),
    [anon_sym_extern] = ACTIONS(1429),
    [anon_sym_LBRACE] = ACTIONS(1431),
    [anon_sym_RBRACE] = ACTIONS(1424),
    [anon_sym_LPAREN2] = ACTIONS(1426),
    [anon_sym_STAR] = ACTIONS(1433),
    [anon_sym_LBRACK] = ACTIONS(1426),
    [anon_sym_EQ] = ACTIONS(1436),
    [anon_sym_static] = ACTIONS(1429),
    [anon_sym_register] = ACTIONS(1429),
    [anon_sym_inline] = ACTIONS(1429),
    [anon_sym_const] = ACTIONS(1429),
    [anon_sym_restrict] = ACTIONS(1429),
    [anon_sym_volatile] = ACTIONS(1429),
    [anon_sym__Atomic] = ACTIONS(1429),
    [anon_sym_mutable] = ACTIONS(1429),
    [anon_sym_explicit] = ACTIONS(1429),
    [anon_sym_constexpr] = ACTIONS(1429),
    [anon_sym_QMARK] = ACTIONS(1424),
    [anon_sym_STAR_EQ] = ACTIONS(1424),
    [anon_sym_SLASH_EQ] = ACTIONS(1424),
    [anon_sym_PERCENT_EQ] = ACTIONS(1424),
    [anon_sym_PLUS_EQ] = ACTIONS(1424),
    [anon_sym_DASH_EQ] = ACTIONS(1424),
    [anon_sym_LT_LT_EQ] = ACTIONS(1424),
    [anon_sym_GT_GT_EQ] = ACTIONS(1424),
    [anon_sym_AMP_EQ] = ACTIONS(1424),
    [anon_sym_CARET_EQ] = ACTIONS(1424),
    [anon_sym_PIPE_EQ] = ACTIONS(1424),
    [anon_sym_AMP] = ACTIONS(1433),
    [anon_sym_PIPE_PIPE] = ACTIONS(1424),
    [anon_sym_AMP_AMP] = ACTIONS(1426),
    [anon_sym_PIPE] = ACTIONS(1436),
    [anon_sym_CARET] = ACTIONS(1436),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_EQ_EQ] = ACTIONS(1424),
    [anon_sym_BANG_EQ] = ACTIONS(1424),
    [anon_sym_LT] = ACTIONS(1436),
    [anon_sym_GT] = ACTIONS(1436),
    [anon_sym_LT_EQ] = ACTIONS(1424),
    [anon_sym_GT_EQ] = ACTIONS(1424),
    [anon_sym_LT_LT] = ACTIONS(1436),
    [anon_sym_GT_GT] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1436),
    [anon_sym_DASH] = ACTIONS(1436),
    [anon_sym_SLASH] = ACTIONS(1436),
    [anon_sym_PERCENT] = ACTIONS(1436),
    [anon_sym_DASH_DASH] = ACTIONS(1424),
    [anon_sym_PLUS_PLUS] = ACTIONS(1424),
    [anon_sym_DOT] = ACTIONS(1424),
    [anon_sym_DASH_GT] = ACTIONS(1424),
    [sym_identifier] = ACTIONS(1429),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1431),
    [sym_operator_name] = ACTIONS(1431),
  },
  [264] = {
    [sym_field_declaration_list] = STATE(790),
    [sym_virtual_specifier] = STATE(791),
    [sym_base_class_clause] = STATE(792),
    [sym_template_argument_list] = STATE(615),
    [anon_sym_COMMA] = ACTIONS(1438),
    [anon_sym_RPAREN] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1438),
    [anon_sym_extern] = ACTIONS(1440),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LPAREN2] = ACTIONS(1438),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_LBRACK] = ACTIONS(1438),
    [anon_sym_EQ] = ACTIONS(1438),
    [anon_sym_static] = ACTIONS(1440),
    [anon_sym_register] = ACTIONS(1440),
    [anon_sym_inline] = ACTIONS(1440),
    [anon_sym_const] = ACTIONS(1440),
    [anon_sym_restrict] = ACTIONS(1440),
    [anon_sym_volatile] = ACTIONS(1440),
    [anon_sym__Atomic] = ACTIONS(1440),
    [anon_sym_mutable] = ACTIONS(1440),
    [anon_sym_explicit] = ACTIONS(1440),
    [anon_sym_constexpr] = ACTIONS(1440),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_AMP_AMP] = ACTIONS(1438),
    [anon_sym_TILDE] = ACTIONS(1438),
    [anon_sym_LT] = ACTIONS(643),
    [sym_identifier] = ACTIONS(1440),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_GT2] = ACTIONS(1438),
    [anon_sym_COLON_COLON] = ACTIONS(1061),
    [sym_operator_name] = ACTIONS(1438),
  },
  [265] = {
    [anon_sym_COMMA] = ACTIONS(1442),
    [anon_sym_RPAREN] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1442),
    [anon_sym_extern] = ACTIONS(1444),
    [anon_sym_LBRACE] = ACTIONS(1442),
    [anon_sym_LPAREN2] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(1442),
    [anon_sym_EQ] = ACTIONS(1442),
    [anon_sym_static] = ACTIONS(1444),
    [anon_sym_register] = ACTIONS(1444),
    [anon_sym_inline] = ACTIONS(1444),
    [anon_sym_const] = ACTIONS(1444),
    [anon_sym_restrict] = ACTIONS(1444),
    [anon_sym_volatile] = ACTIONS(1444),
    [anon_sym__Atomic] = ACTIONS(1444),
    [anon_sym_mutable] = ACTIONS(1444),
    [anon_sym_explicit] = ACTIONS(1444),
    [anon_sym_constexpr] = ACTIONS(1444),
    [anon_sym_COLON] = ACTIONS(1444),
    [anon_sym_AMP] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1442),
    [anon_sym_TILDE] = ACTIONS(1442),
    [anon_sym_DASH_GT] = ACTIONS(1442),
    [sym_identifier] = ACTIONS(1444),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1444),
    [anon_sym_override] = ACTIONS(1444),
    [anon_sym_GT2] = ACTIONS(1442),
    [sym_noexcept] = ACTIONS(1444),
    [anon_sym_COLON_COLON] = ACTIONS(1442),
    [sym_operator_name] = ACTIONS(1442),
  },
  [266] = {
    [sym_field_declaration_list] = STATE(793),
    [sym_base_class_clause] = STATE(794),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_COLON] = ACTIONS(1073),
    [sym_comment] = ACTIONS(91),
  },
  [267] = {
    [sym_field_declaration_list] = STATE(793),
    [anon_sym_LBRACE] = ACTIONS(307),
    [sym_comment] = ACTIONS(91),
  },
  [268] = {
    [sym_field_declaration_list] = STATE(793),
    [sym_virtual_specifier] = STATE(795),
    [sym_base_class_clause] = STATE(794),
    [anon_sym_COMMA] = ACTIONS(1442),
    [anon_sym_RPAREN] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1442),
    [anon_sym_extern] = ACTIONS(1444),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LPAREN2] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(1442),
    [anon_sym_EQ] = ACTIONS(1442),
    [anon_sym_static] = ACTIONS(1444),
    [anon_sym_register] = ACTIONS(1444),
    [anon_sym_inline] = ACTIONS(1444),
    [anon_sym_const] = ACTIONS(1444),
    [anon_sym_restrict] = ACTIONS(1444),
    [anon_sym_volatile] = ACTIONS(1444),
    [anon_sym__Atomic] = ACTIONS(1444),
    [anon_sym_mutable] = ACTIONS(1444),
    [anon_sym_explicit] = ACTIONS(1444),
    [anon_sym_constexpr] = ACTIONS(1444),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1442),
    [anon_sym_TILDE] = ACTIONS(1442),
    [sym_identifier] = ACTIONS(1444),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_GT2] = ACTIONS(1442),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [sym_operator_name] = ACTIONS(1442),
  },
  [269] = {
    [sym_field_declaration_list] = STATE(793),
    [sym_virtual_specifier] = STATE(795),
    [sym_base_class_clause] = STATE(794),
    [sym_template_argument_list] = STATE(362),
    [anon_sym_COMMA] = ACTIONS(1442),
    [anon_sym_RPAREN] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1442),
    [anon_sym_extern] = ACTIONS(1444),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LPAREN2] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(1442),
    [anon_sym_EQ] = ACTIONS(1442),
    [anon_sym_static] = ACTIONS(1444),
    [anon_sym_register] = ACTIONS(1444),
    [anon_sym_inline] = ACTIONS(1444),
    [anon_sym_const] = ACTIONS(1444),
    [anon_sym_restrict] = ACTIONS(1444),
    [anon_sym_volatile] = ACTIONS(1444),
    [anon_sym__Atomic] = ACTIONS(1444),
    [anon_sym_mutable] = ACTIONS(1444),
    [anon_sym_explicit] = ACTIONS(1444),
    [anon_sym_constexpr] = ACTIONS(1444),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1442),
    [anon_sym_TILDE] = ACTIONS(1442),
    [anon_sym_LT] = ACTIONS(643),
    [sym_identifier] = ACTIONS(1444),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_GT2] = ACTIONS(1442),
    [anon_sym_COLON_COLON] = ACTIONS(1442),
    [sym_operator_name] = ACTIONS(1442),
  },
  [270] = {
    [sym_template_argument_list] = STATE(615),
    [anon_sym_COMMA] = ACTIONS(481),
    [anon_sym_RPAREN] = ACTIONS(481),
    [anon_sym_SEMI] = ACTIONS(481),
    [anon_sym_extern] = ACTIONS(468),
    [anon_sym_LPAREN2] = ACTIONS(481),
    [anon_sym_STAR] = ACTIONS(481),
    [anon_sym_LBRACK] = ACTIONS(481),
    [anon_sym_EQ] = ACTIONS(481),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_register] = ACTIONS(468),
    [anon_sym_inline] = ACTIONS(468),
    [anon_sym_const] = ACTIONS(468),
    [anon_sym_restrict] = ACTIONS(468),
    [anon_sym_volatile] = ACTIONS(468),
    [anon_sym__Atomic] = ACTIONS(468),
    [anon_sym_mutable] = ACTIONS(468),
    [anon_sym_explicit] = ACTIONS(468),
    [anon_sym_constexpr] = ACTIONS(468),
    [anon_sym_COLON] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(468),
    [anon_sym_AMP_AMP] = ACTIONS(481),
    [anon_sym_TILDE] = ACTIONS(481),
    [anon_sym_LT] = ACTIONS(643),
    [sym_identifier] = ACTIONS(468),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(481),
    [anon_sym_COLON_COLON] = ACTIONS(1061),
    [sym_operator_name] = ACTIONS(481),
  },
  [271] = {
    [anon_sym_COMMA] = ACTIONS(1446),
    [anon_sym_RPAREN] = ACTIONS(1446),
    [anon_sym_SEMI] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(1446),
    [anon_sym_LPAREN2] = ACTIONS(1446),
    [anon_sym_STAR] = ACTIONS(1446),
    [anon_sym_LBRACK] = ACTIONS(1446),
    [anon_sym_EQ] = ACTIONS(1446),
    [anon_sym_static] = ACTIONS(1448),
    [anon_sym_register] = ACTIONS(1448),
    [anon_sym_inline] = ACTIONS(1448),
    [anon_sym_const] = ACTIONS(1448),
    [anon_sym_restrict] = ACTIONS(1448),
    [anon_sym_volatile] = ACTIONS(1448),
    [anon_sym__Atomic] = ACTIONS(1448),
    [anon_sym_mutable] = ACTIONS(1448),
    [anon_sym_explicit] = ACTIONS(1448),
    [anon_sym_constexpr] = ACTIONS(1448),
    [anon_sym_COLON] = ACTIONS(1448),
    [anon_sym_AMP] = ACTIONS(1448),
    [anon_sym_AMP_AMP] = ACTIONS(1446),
    [anon_sym_TILDE] = ACTIONS(1446),
    [anon_sym_DASH_GT] = ACTIONS(1446),
    [sym_identifier] = ACTIONS(1448),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1448),
    [anon_sym_override] = ACTIONS(1448),
    [anon_sym_GT2] = ACTIONS(1446),
    [sym_noexcept] = ACTIONS(1448),
    [anon_sym_COLON_COLON] = ACTIONS(1446),
    [sym_operator_name] = ACTIONS(1446),
  },
  [272] = {
    [anon_sym_COMMA] = ACTIONS(624),
    [anon_sym_RPAREN] = ACTIONS(624),
    [anon_sym_SEMI] = ACTIONS(624),
    [anon_sym_extern] = ACTIONS(626),
    [anon_sym_LPAREN2] = ACTIONS(624),
    [anon_sym_STAR] = ACTIONS(624),
    [anon_sym_LBRACK] = ACTIONS(624),
    [anon_sym_EQ] = ACTIONS(624),
    [anon_sym_static] = ACTIONS(626),
    [anon_sym_register] = ACTIONS(626),
    [anon_sym_inline] = ACTIONS(626),
    [anon_sym_const] = ACTIONS(626),
    [anon_sym_restrict] = ACTIONS(626),
    [anon_sym_volatile] = ACTIONS(626),
    [anon_sym__Atomic] = ACTIONS(626),
    [anon_sym_mutable] = ACTIONS(626),
    [anon_sym_explicit] = ACTIONS(626),
    [anon_sym_constexpr] = ACTIONS(626),
    [anon_sym_COLON] = ACTIONS(626),
    [anon_sym_AMP] = ACTIONS(626),
    [anon_sym_AMP_AMP] = ACTIONS(624),
    [anon_sym_TILDE] = ACTIONS(624),
    [sym_identifier] = ACTIONS(626),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(624),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [sym_operator_name] = ACTIONS(624),
  },
  [273] = {
    [sym_template_argument_list] = STATE(362),
    [anon_sym_COMMA] = ACTIONS(624),
    [anon_sym_RPAREN] = ACTIONS(624),
    [anon_sym_SEMI] = ACTIONS(624),
    [anon_sym_extern] = ACTIONS(626),
    [anon_sym_LBRACE] = ACTIONS(624),
    [anon_sym_LPAREN2] = ACTIONS(624),
    [anon_sym_STAR] = ACTIONS(624),
    [anon_sym_LBRACK] = ACTIONS(624),
    [anon_sym_EQ] = ACTIONS(624),
    [anon_sym_static] = ACTIONS(626),
    [anon_sym_register] = ACTIONS(626),
    [anon_sym_inline] = ACTIONS(626),
    [anon_sym_const] = ACTIONS(626),
    [anon_sym_restrict] = ACTIONS(626),
    [anon_sym_volatile] = ACTIONS(626),
    [anon_sym__Atomic] = ACTIONS(626),
    [anon_sym_mutable] = ACTIONS(626),
    [anon_sym_explicit] = ACTIONS(626),
    [anon_sym_constexpr] = ACTIONS(626),
    [anon_sym_COLON] = ACTIONS(626),
    [anon_sym_AMP] = ACTIONS(626),
    [anon_sym_AMP_AMP] = ACTIONS(624),
    [anon_sym_TILDE] = ACTIONS(624),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_DASH_GT] = ACTIONS(624),
    [sym_identifier] = ACTIONS(626),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(626),
    [anon_sym_override] = ACTIONS(626),
    [anon_sym_GT2] = ACTIONS(624),
    [sym_noexcept] = ACTIONS(626),
    [anon_sym_COLON_COLON] = ACTIONS(624),
    [sym_operator_name] = ACTIONS(624),
  },
  [274] = {
    [sym__declarator] = STATE(796),
    [sym_pointer_declarator] = STATE(796),
    [sym_function_declarator] = STATE(796),
    [sym_array_declarator] = STATE(796),
    [sym_type_qualifier] = STATE(797),
    [sym_reference_declarator] = STATE(796),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(796),
    [sym_destructor_name] = STATE(796),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [aux_sym_type_definition_repeat1] = STATE(797),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(500),
    [anon_sym_AMP_AMP] = ACTIONS(502),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(431),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(1450),
  },
  [275] = {
    [sym__declarator] = STATE(798),
    [sym_pointer_declarator] = STATE(798),
    [sym_function_declarator] = STATE(798),
    [sym_array_declarator] = STATE(798),
    [sym_reference_declarator] = STATE(798),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(798),
    [sym_destructor_name] = STATE(798),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(494),
    [anon_sym_AMP] = ACTIONS(500),
    [anon_sym_AMP_AMP] = ACTIONS(502),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(431),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(1452),
  },
  [276] = {
    [sym__declaration_specifiers] = STATE(802),
    [sym_storage_class_specifier] = STATE(805),
    [sym_type_qualifier] = STATE(805),
    [sym__type_specifier] = STATE(803),
    [sym_sized_type_specifier] = STATE(803),
    [sym_enum_specifier] = STATE(803),
    [sym_struct_specifier] = STATE(803),
    [sym_union_specifier] = STATE(803),
    [sym_parameter_declaration] = STATE(804),
    [sym_macro_type_specifier] = STATE(803),
    [sym_class_specifier] = STATE(803),
    [sym_dependent_type] = STATE(803),
    [sym_type_parameter_declaration] = STATE(804),
    [sym_optional_type_parameter_declaration] = STATE(804),
    [sym_optional_parameter_declaration] = STATE(804),
    [sym_template_type] = STATE(272),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(180),
    [aux_sym__declaration_specifiers_repeat1] = STATE(805),
    [aux_sym_sized_type_specifier_repeat1] = STATE(806),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(1454),
    [anon_sym_long] = ACTIONS(1454),
    [anon_sym_short] = ACTIONS(1454),
    [sym_primitive_type] = ACTIONS(1456),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [sym_identifier] = ACTIONS(492),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1458),
    [sym_auto] = ACTIONS(1456),
    [anon_sym_typename] = ACTIONS(1460),
    [anon_sym_GT2] = ACTIONS(1462),
    [anon_sym_COLON_COLON] = ACTIONS(315),
  },
  [277] = {
    [sym_template_argument_list] = STATE(808),
    [anon_sym_SEMI] = ACTIONS(576),
    [anon_sym_extern] = ACTIONS(468),
    [anon_sym_LPAREN2] = ACTIONS(1464),
    [anon_sym_STAR] = ACTIONS(481),
    [anon_sym_LBRACK] = ACTIONS(576),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_register] = ACTIONS(468),
    [anon_sym_inline] = ACTIONS(468),
    [anon_sym_const] = ACTIONS(468),
    [anon_sym_restrict] = ACTIONS(468),
    [anon_sym_volatile] = ACTIONS(468),
    [anon_sym__Atomic] = ACTIONS(468),
    [anon_sym_mutable] = ACTIONS(468),
    [anon_sym_explicit] = ACTIONS(468),
    [anon_sym_constexpr] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(468),
    [anon_sym_AMP_AMP] = ACTIONS(481),
    [anon_sym_TILDE] = ACTIONS(481),
    [anon_sym_LT] = ACTIONS(643),
    [sym_identifier] = ACTIONS(468),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1467),
    [sym_operator_name] = ACTIONS(481),
  },
  [278] = {
    [sym__type_specifier] = STATE(271),
    [sym_sized_type_specifier] = STATE(271),
    [sym_enum_specifier] = STATE(271),
    [sym_struct_specifier] = STATE(271),
    [sym_union_specifier] = STATE(271),
    [sym_macro_type_specifier] = STATE(271),
    [sym_class_specifier] = STATE(271),
    [sym_dependent_type] = STATE(271),
    [sym_template_type] = STATE(272),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(180),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(490),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [sym_identifier] = ACTIONS(492),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(490),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_COLON_COLON] = ACTIONS(315),
  },
  [279] = {
    [sym_destructor_name] = STATE(315),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(1469),
    [sym_comment] = ACTIONS(91),
    [sym_operator_name] = ACTIONS(554),
  },
  [280] = {
    [sym__declarator] = STATE(810),
    [sym_pointer_declarator] = STATE(810),
    [sym_function_declarator] = STATE(810),
    [sym_array_declarator] = STATE(810),
    [sym_reference_declarator] = STATE(810),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(810),
    [sym_destructor_name] = STATE(810),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(494),
    [anon_sym_AMP] = ACTIONS(500),
    [anon_sym_AMP_AMP] = ACTIONS(502),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(431),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(1471),
  },
  [281] = {
    [sym_parameter_list] = STATE(812),
    [anon_sym_SEMI] = ACTIONS(1473),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(574),
    [sym_comment] = ACTIONS(91),
  },
  [282] = {
    [sym_storage_class_specifier] = STATE(813),
    [sym_type_qualifier] = STATE(813),
    [aux_sym__declaration_specifiers_repeat1] = STATE(813),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_LPAREN2] = ACTIONS(582),
    [anon_sym_STAR] = ACTIONS(582),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(584),
    [anon_sym_AMP_AMP] = ACTIONS(582),
    [anon_sym_TILDE] = ACTIONS(582),
    [sym_identifier] = ACTIONS(584),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(582),
    [sym_operator_name] = ACTIONS(582),
  },
  [283] = {
    [sym_function_definition] = STATE(815),
    [sym_declaration] = STATE(815),
    [sym__declaration_specifiers] = STATE(816),
    [sym_storage_class_specifier] = STATE(818),
    [sym_type_qualifier] = STATE(818),
    [sym__type_specifier] = STATE(817),
    [sym_sized_type_specifier] = STATE(817),
    [sym_enum_specifier] = STATE(817),
    [sym_struct_specifier] = STATE(817),
    [sym_union_specifier] = STATE(817),
    [sym__empty_declaration] = STATE(815),
    [sym_macro_type_specifier] = STATE(817),
    [sym_class_specifier] = STATE(817),
    [sym_dependent_type] = STATE(817),
    [sym_template_type] = STATE(272),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(180),
    [aux_sym__declaration_specifiers_repeat1] = STATE(818),
    [aux_sym_sized_type_specifier_repeat1] = STATE(819),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(1475),
    [anon_sym_long] = ACTIONS(1475),
    [anon_sym_short] = ACTIONS(1475),
    [sym_primitive_type] = ACTIONS(1477),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [sym_identifier] = ACTIONS(492),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(1477),
    [anon_sym_typename] = ACTIONS(1479),
    [anon_sym_COLON_COLON] = ACTIONS(315),
  },
  [284] = {
    [anon_sym_extern] = ACTIONS(626),
    [anon_sym_LPAREN2] = ACTIONS(624),
    [anon_sym_STAR] = ACTIONS(624),
    [anon_sym_static] = ACTIONS(626),
    [anon_sym_register] = ACTIONS(626),
    [anon_sym_inline] = ACTIONS(626),
    [anon_sym_const] = ACTIONS(626),
    [anon_sym_restrict] = ACTIONS(626),
    [anon_sym_volatile] = ACTIONS(626),
    [anon_sym__Atomic] = ACTIONS(626),
    [anon_sym_mutable] = ACTIONS(626),
    [anon_sym_explicit] = ACTIONS(626),
    [anon_sym_constexpr] = ACTIONS(626),
    [anon_sym_AMP] = ACTIONS(626),
    [anon_sym_AMP_AMP] = ACTIONS(624),
    [anon_sym_TILDE] = ACTIONS(624),
    [sym_identifier] = ACTIONS(626),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1481),
    [sym_operator_name] = ACTIONS(624),
  },
  [285] = {
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1481),
  },
  [286] = {
    [sym_storage_class_specifier] = STATE(497),
    [sym_type_qualifier] = STATE(497),
    [sym__type_specifier] = STATE(821),
    [sym_sized_type_specifier] = STATE(821),
    [sym_enum_specifier] = STATE(821),
    [sym_struct_specifier] = STATE(821),
    [sym_union_specifier] = STATE(821),
    [sym_macro_type_specifier] = STATE(821),
    [sym_class_specifier] = STATE(821),
    [sym_dependent_type] = STATE(821),
    [sym_template_type] = STATE(272),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(180),
    [aux_sym__declaration_specifiers_repeat1] = STATE(497),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(1483),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [sym_identifier] = ACTIONS(492),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(1483),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_COLON_COLON] = ACTIONS(315),
  },
  [287] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(822),
    [anon_sym_extern] = ACTIONS(655),
    [anon_sym_LPAREN2] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(653),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_register] = ACTIONS(655),
    [anon_sym_inline] = ACTIONS(655),
    [anon_sym_const] = ACTIONS(655),
    [anon_sym_restrict] = ACTIONS(655),
    [anon_sym_volatile] = ACTIONS(655),
    [anon_sym__Atomic] = ACTIONS(655),
    [anon_sym_mutable] = ACTIONS(655),
    [anon_sym_explicit] = ACTIONS(655),
    [anon_sym_constexpr] = ACTIONS(655),
    [anon_sym_unsigned] = ACTIONS(1485),
    [anon_sym_long] = ACTIONS(1485),
    [anon_sym_short] = ACTIONS(1485),
    [sym_primitive_type] = ACTIONS(659),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [anon_sym_TILDE] = ACTIONS(653),
    [sym_identifier] = ACTIONS(661),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(653),
    [sym_operator_name] = ACTIONS(653),
  },
  [288] = {
    [sym__expression] = STATE(164),
    [sym_conditional_expression] = STATE(164),
    [sym_assignment_expression] = STATE(164),
    [sym_pointer_expression] = STATE(164),
    [sym_logical_expression] = STATE(164),
    [sym_bitwise_expression] = STATE(164),
    [sym_equality_expression] = STATE(164),
    [sym_relational_expression] = STATE(164),
    [sym_shift_expression] = STATE(164),
    [sym_math_expression] = STATE(164),
    [sym_cast_expression] = STATE(164),
    [sym_sizeof_expression] = STATE(164),
    [sym_subscript_expression] = STATE(164),
    [sym_call_expression] = STATE(164),
    [sym_field_expression] = STATE(164),
    [sym_compound_literal_expression] = STATE(164),
    [sym_parenthesized_expression] = STATE(164),
    [sym_char_literal] = STATE(164),
    [sym_concatenated_string] = STATE(164),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(164),
    [sym_new_expression] = STATE(164),
    [sym_delete_expression] = STATE(164),
    [sym_lambda_expression] = STATE(164),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_lambda_default_capture] = STATE(166),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(267),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(1487),
    [anon_sym_EQ] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(267),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(289),
    [sym_false] = ACTIONS(289),
    [sym_null] = ACTIONS(289),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(289),
  },
  [289] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(1489),
    [anon_sym_SEMI] = ACTIONS(1489),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(590),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1491),
    [anon_sym_QMARK] = ACTIONS(1489),
    [anon_sym_STAR_EQ] = ACTIONS(1489),
    [anon_sym_SLASH_EQ] = ACTIONS(1489),
    [anon_sym_PERCENT_EQ] = ACTIONS(1489),
    [anon_sym_PLUS_EQ] = ACTIONS(1489),
    [anon_sym_DASH_EQ] = ACTIONS(1489),
    [anon_sym_LT_LT_EQ] = ACTIONS(1489),
    [anon_sym_GT_GT_EQ] = ACTIONS(1489),
    [anon_sym_AMP_EQ] = ACTIONS(1489),
    [anon_sym_CARET_EQ] = ACTIONS(1489),
    [anon_sym_PIPE_EQ] = ACTIONS(1489),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_PIPE_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(604),
    [anon_sym_PIPE] = ACTIONS(606),
    [anon_sym_CARET] = ACTIONS(608),
    [anon_sym_EQ_EQ] = ACTIONS(610),
    [anon_sym_BANG_EQ] = ACTIONS(610),
    [anon_sym_LT] = ACTIONS(612),
    [anon_sym_GT] = ACTIONS(612),
    [anon_sym_LT_EQ] = ACTIONS(614),
    [anon_sym_GT_EQ] = ACTIONS(614),
    [anon_sym_LT_LT] = ACTIONS(616),
    [anon_sym_GT_GT] = ACTIONS(616),
    [anon_sym_PLUS] = ACTIONS(618),
    [anon_sym_DASH] = ACTIONS(618),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [290] = {
    [sym_preproc_include] = STATE(833),
    [sym_preproc_def] = STATE(833),
    [sym_preproc_function_def] = STATE(833),
    [sym_preproc_call] = STATE(833),
    [sym_preproc_if] = STATE(833),
    [sym_preproc_ifdef] = STATE(833),
    [sym_function_definition] = STATE(833),
    [sym_declaration] = STATE(833),
    [sym_type_definition] = STATE(833),
    [sym__declaration_specifiers] = STATE(49),
    [sym_linkage_specification] = STATE(833),
    [sym__declarator] = STATE(50),
    [sym_pointer_declarator] = STATE(50),
    [sym_function_declarator] = STATE(51),
    [sym_array_declarator] = STATE(50),
    [sym_compound_statement] = STATE(833),
    [sym_storage_class_specifier] = STATE(63),
    [sym_type_qualifier] = STATE(63),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(833),
    [sym_expression_statement] = STATE(833),
    [sym_if_statement] = STATE(833),
    [sym_switch_statement] = STATE(833),
    [sym_case_statement] = STATE(833),
    [sym_while_statement] = STATE(833),
    [sym_do_statement] = STATE(833),
    [sym_for_statement] = STATE(833),
    [sym_return_statement] = STATE(833),
    [sym_break_statement] = STATE(833),
    [sym_continue_statement] = STATE(833),
    [sym_goto_statement] = STATE(833),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(833),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(833),
    [sym_template_declaration] = STATE(833),
    [sym_template_instantiation] = STATE(833),
    [sym_constructor_or_destructor_definition] = STATE(833),
    [sym_reference_declarator] = STATE(50),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(57),
    [sym_namespace_definition] = STATE(833),
    [sym_using_declaration] = STATE(833),
    [sym_alias_declaration] = STATE(833),
    [sym_for_range_loop] = STATE(833),
    [sym_try_statement] = STATE(833),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_destructor_name] = STATE(50),
    [sym_scoped_identifier] = STATE(59),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_translation_unit_repeat1] = STATE(833),
    [aux_sym__declaration_specifiers_repeat1] = STATE(63),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(5),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(9),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(13),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(15),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(15),
    [sym_preproc_directive] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_RBRACE] = ACTIONS(1493),
    [anon_sym_LPAREN2] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(1495),
    [anon_sym_switch] = ACTIONS(1497),
    [anon_sym_case] = ACTIONS(1499),
    [anon_sym_default] = ACTIONS(1501),
    [anon_sym_while] = ACTIONS(1503),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(1505),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(1507),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_template] = ACTIONS(97),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_namespace] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(103),
    [anon_sym_try] = ACTIONS(1509),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_operator_name] = ACTIONS(111),
    [sym_nullptr] = ACTIONS(87),
  },
  [291] = {
    [sym_declaration_list] = STATE(834),
    [anon_sym_LBRACE] = ACTIONS(520),
    [sym_comment] = ACTIONS(91),
  },
  [292] = {
    [sym_raw_string_literal] = ACTIONS(1511),
    [ts_builtin_sym_end] = ACTIONS(1511),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1513),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1513),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1513),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1513),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1513),
    [sym_preproc_directive] = ACTIONS(1513),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_typedef] = ACTIONS(1513),
    [anon_sym_extern] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_RBRACE] = ACTIONS(1511),
    [anon_sym_LPAREN2] = ACTIONS(1511),
    [anon_sym_STAR] = ACTIONS(1511),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_static] = ACTIONS(1513),
    [anon_sym_register] = ACTIONS(1513),
    [anon_sym_inline] = ACTIONS(1513),
    [anon_sym_const] = ACTIONS(1513),
    [anon_sym_restrict] = ACTIONS(1513),
    [anon_sym_volatile] = ACTIONS(1513),
    [anon_sym__Atomic] = ACTIONS(1513),
    [anon_sym_mutable] = ACTIONS(1513),
    [anon_sym_explicit] = ACTIONS(1513),
    [anon_sym_constexpr] = ACTIONS(1513),
    [anon_sym_unsigned] = ACTIONS(1513),
    [anon_sym_long] = ACTIONS(1513),
    [anon_sym_short] = ACTIONS(1513),
    [sym_primitive_type] = ACTIONS(1513),
    [anon_sym_enum] = ACTIONS(1513),
    [anon_sym_struct] = ACTIONS(1513),
    [anon_sym_union] = ACTIONS(1513),
    [anon_sym_if] = ACTIONS(1513),
    [anon_sym_switch] = ACTIONS(1513),
    [anon_sym_case] = ACTIONS(1513),
    [anon_sym_default] = ACTIONS(1513),
    [anon_sym_while] = ACTIONS(1513),
    [anon_sym_do] = ACTIONS(1513),
    [anon_sym_for] = ACTIONS(1513),
    [anon_sym_return] = ACTIONS(1513),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_continue] = ACTIONS(1513),
    [anon_sym_goto] = ACTIONS(1513),
    [anon_sym_AMP] = ACTIONS(1513),
    [anon_sym_AMP_AMP] = ACTIONS(1511),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_DASH_DASH] = ACTIONS(1511),
    [anon_sym_PLUS_PLUS] = ACTIONS(1511),
    [anon_sym_sizeof] = ACTIONS(1513),
    [sym_number_literal] = ACTIONS(1511),
    [anon_sym_SQUOTE] = ACTIONS(1511),
    [anon_sym_DQUOTE] = ACTIONS(1511),
    [sym_true] = ACTIONS(1513),
    [sym_false] = ACTIONS(1513),
    [sym_null] = ACTIONS(1513),
    [sym_identifier] = ACTIONS(1513),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1513),
    [sym_auto] = ACTIONS(1513),
    [anon_sym_typename] = ACTIONS(1513),
    [anon_sym_template] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_namespace] = ACTIONS(1513),
    [anon_sym_using] = ACTIONS(1513),
    [anon_sym_try] = ACTIONS(1513),
    [anon_sym_new] = ACTIONS(1513),
    [anon_sym_COLON_COLON] = ACTIONS(1511),
    [sym_operator_name] = ACTIONS(1511),
    [sym_nullptr] = ACTIONS(1513),
  },
  [293] = {
    [sym_template_argument_list] = STATE(437),
    [anon_sym_SEMI] = ACTIONS(1515),
    [anon_sym_EQ] = ACTIONS(1517),
    [anon_sym_LT] = ACTIONS(945),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1519),
  },
  [294] = {
    [sym_template_type] = STATE(296),
    [sym_scoped_identifier] = STATE(839),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(296),
    [sym_identifier] = ACTIONS(1521),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(528),
  },
  [295] = {
    [sym_destructor_name] = STATE(315),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(1523),
    [sym_comment] = ACTIONS(91),
    [sym_operator_name] = ACTIONS(554),
  },
  [296] = {
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1525),
  },
  [297] = {
    [anon_sym_SEMI] = ACTIONS(1515),
    [sym_comment] = ACTIONS(91),
  },
  [298] = {
    [sym_catch_clause] = STATE(843),
    [aux_sym_try_statement_repeat1] = STATE(843),
    [sym_comment] = ACTIONS(91),
    [anon_sym_catch] = ACTIONS(1527),
  },
  [299] = {
    [sym__expression] = STATE(845),
    [sym_conditional_expression] = STATE(845),
    [sym_assignment_expression] = STATE(845),
    [sym_pointer_expression] = STATE(845),
    [sym_logical_expression] = STATE(845),
    [sym_bitwise_expression] = STATE(845),
    [sym_equality_expression] = STATE(845),
    [sym_relational_expression] = STATE(845),
    [sym_shift_expression] = STATE(845),
    [sym_math_expression] = STATE(845),
    [sym_cast_expression] = STATE(845),
    [sym_sizeof_expression] = STATE(845),
    [sym_subscript_expression] = STATE(845),
    [sym_call_expression] = STATE(845),
    [sym_field_expression] = STATE(845),
    [sym_compound_literal_expression] = STATE(845),
    [sym_parenthesized_expression] = STATE(845),
    [sym_initializer_list] = STATE(846),
    [sym_char_literal] = STATE(845),
    [sym_concatenated_string] = STATE(845),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(845),
    [sym_new_expression] = STATE(845),
    [sym_delete_expression] = STATE(845),
    [sym_lambda_expression] = STATE(845),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(1529),
    [anon_sym_RPAREN] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(1529),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(1533),
    [sym_false] = ACTIONS(1533),
    [sym_null] = ACTIONS(1533),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(1533),
  },
  [300] = {
    [sym_enumerator_list] = STATE(849),
    [anon_sym_LBRACE] = ACTIONS(1535),
    [sym_identifier] = ACTIONS(1537),
    [sym_comment] = ACTIONS(91),
  },
  [301] = {
    [sym_field_declaration_list] = STATE(852),
    [sym_virtual_specifier] = STATE(853),
    [sym_base_class_clause] = STATE(854),
    [sym_template_type] = STATE(855),
    [sym_scoped_type_identifier] = STATE(856),
    [sym_scoped_namespace_identifier] = STATE(311),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(1541),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [302] = {
    [sym_field_declaration_list] = STATE(858),
    [sym_virtual_specifier] = STATE(859),
    [sym_base_class_clause] = STATE(860),
    [sym_template_type] = STATE(861),
    [sym_scoped_type_identifier] = STATE(862),
    [sym_scoped_namespace_identifier] = STATE(311),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(1543),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [303] = {
    [sym_template_argument_list] = STATE(864),
    [anon_sym_COMMA] = ACTIONS(481),
    [anon_sym_RPAREN] = ACTIONS(481),
    [anon_sym_SEMI] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_LPAREN2] = ACTIONS(481),
    [anon_sym_STAR] = ACTIONS(468),
    [anon_sym_LBRACK] = ACTIONS(481),
    [anon_sym_RBRACK] = ACTIONS(481),
    [anon_sym_EQ] = ACTIONS(468),
    [anon_sym_COLON] = ACTIONS(468),
    [anon_sym_QMARK] = ACTIONS(481),
    [anon_sym_STAR_EQ] = ACTIONS(481),
    [anon_sym_SLASH_EQ] = ACTIONS(481),
    [anon_sym_PERCENT_EQ] = ACTIONS(481),
    [anon_sym_PLUS_EQ] = ACTIONS(481),
    [anon_sym_DASH_EQ] = ACTIONS(481),
    [anon_sym_LT_LT_EQ] = ACTIONS(481),
    [anon_sym_GT_GT_EQ] = ACTIONS(481),
    [anon_sym_AMP_EQ] = ACTIONS(481),
    [anon_sym_CARET_EQ] = ACTIONS(481),
    [anon_sym_PIPE_EQ] = ACTIONS(481),
    [anon_sym_AMP] = ACTIONS(468),
    [anon_sym_PIPE_PIPE] = ACTIONS(481),
    [anon_sym_AMP_AMP] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(468),
    [anon_sym_CARET] = ACTIONS(468),
    [anon_sym_EQ_EQ] = ACTIONS(481),
    [anon_sym_BANG_EQ] = ACTIONS(481),
    [anon_sym_LT] = ACTIONS(1545),
    [anon_sym_GT] = ACTIONS(468),
    [anon_sym_LT_EQ] = ACTIONS(481),
    [anon_sym_GT_EQ] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(468),
    [anon_sym_GT_GT] = ACTIONS(468),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_SLASH] = ACTIONS(468),
    [anon_sym_PERCENT] = ACTIONS(468),
    [anon_sym_DASH_DASH] = ACTIONS(481),
    [anon_sym_PLUS_PLUS] = ACTIONS(481),
    [anon_sym_DOT] = ACTIONS(481),
    [anon_sym_DASH_GT] = ACTIONS(481),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1548),
  },
  [304] = {
    [sym_field_declaration_list] = STATE(866),
    [sym_virtual_specifier] = STATE(867),
    [sym_base_class_clause] = STATE(868),
    [sym_template_type] = STATE(869),
    [sym_scoped_type_identifier] = STATE(870),
    [sym_scoped_namespace_identifier] = STATE(311),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(1550),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [305] = {
    [sym__type_specifier] = STATE(871),
    [sym_sized_type_specifier] = STATE(871),
    [sym_enum_specifier] = STATE(871),
    [sym_struct_specifier] = STATE(871),
    [sym_union_specifier] = STATE(871),
    [sym_macro_type_specifier] = STATE(871),
    [sym_class_specifier] = STATE(871),
    [sym_dependent_type] = STATE(871),
    [sym_template_type] = STATE(309),
    [sym_scoped_type_identifier] = STATE(310),
    [sym_scoped_namespace_identifier] = STATE(311),
    [aux_sym_sized_type_specifier_repeat1] = STATE(312),
    [anon_sym_unsigned] = ACTIONS(532),
    [anon_sym_long] = ACTIONS(532),
    [anon_sym_short] = ACTIONS(532),
    [sym_primitive_type] = ACTIONS(1552),
    [anon_sym_enum] = ACTIONS(536),
    [anon_sym_struct] = ACTIONS(538),
    [anon_sym_union] = ACTIONS(540),
    [sym_identifier] = ACTIONS(542),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(544),
    [sym_auto] = ACTIONS(1552),
    [anon_sym_typename] = ACTIONS(546),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [306] = {
    [sym_identifier] = ACTIONS(1554),
    [sym_comment] = ACTIONS(91),
  },
  [307] = {
    [sym_argument_list] = STATE(874),
    [sym_initializer_list] = STATE(874),
    [sym_new_declarator] = STATE(875),
    [anon_sym_COMMA] = ACTIONS(1556),
    [anon_sym_SEMI] = ACTIONS(1556),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1558),
    [anon_sym_LBRACK] = ACTIONS(1560),
    [anon_sym_EQ] = ACTIONS(1558),
    [anon_sym_QMARK] = ACTIONS(1556),
    [anon_sym_STAR_EQ] = ACTIONS(1556),
    [anon_sym_SLASH_EQ] = ACTIONS(1556),
    [anon_sym_PERCENT_EQ] = ACTIONS(1556),
    [anon_sym_PLUS_EQ] = ACTIONS(1556),
    [anon_sym_DASH_EQ] = ACTIONS(1556),
    [anon_sym_LT_LT_EQ] = ACTIONS(1556),
    [anon_sym_GT_GT_EQ] = ACTIONS(1556),
    [anon_sym_AMP_EQ] = ACTIONS(1556),
    [anon_sym_CARET_EQ] = ACTIONS(1556),
    [anon_sym_PIPE_EQ] = ACTIONS(1556),
    [anon_sym_AMP] = ACTIONS(1558),
    [anon_sym_PIPE_PIPE] = ACTIONS(1556),
    [anon_sym_AMP_AMP] = ACTIONS(1556),
    [anon_sym_PIPE] = ACTIONS(1558),
    [anon_sym_CARET] = ACTIONS(1558),
    [anon_sym_EQ_EQ] = ACTIONS(1556),
    [anon_sym_BANG_EQ] = ACTIONS(1556),
    [anon_sym_LT] = ACTIONS(1558),
    [anon_sym_GT] = ACTIONS(1558),
    [anon_sym_LT_EQ] = ACTIONS(1556),
    [anon_sym_GT_EQ] = ACTIONS(1556),
    [anon_sym_LT_LT] = ACTIONS(1558),
    [anon_sym_GT_GT] = ACTIONS(1558),
    [anon_sym_PLUS] = ACTIONS(1558),
    [anon_sym_DASH] = ACTIONS(1558),
    [anon_sym_SLASH] = ACTIONS(1558),
    [anon_sym_PERCENT] = ACTIONS(1558),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DOT] = ACTIONS(1556),
    [anon_sym_DASH_GT] = ACTIONS(1556),
    [sym_comment] = ACTIONS(91),
  },
  [308] = {
    [sym__type_specifier] = STATE(876),
    [sym_sized_type_specifier] = STATE(876),
    [sym_enum_specifier] = STATE(876),
    [sym_struct_specifier] = STATE(876),
    [sym_union_specifier] = STATE(876),
    [sym_macro_type_specifier] = STATE(876),
    [sym_class_specifier] = STATE(876),
    [sym_dependent_type] = STATE(876),
    [sym_template_type] = STATE(309),
    [sym_scoped_type_identifier] = STATE(310),
    [sym_scoped_namespace_identifier] = STATE(311),
    [aux_sym_sized_type_specifier_repeat1] = STATE(312),
    [anon_sym_unsigned] = ACTIONS(532),
    [anon_sym_long] = ACTIONS(532),
    [anon_sym_short] = ACTIONS(532),
    [sym_primitive_type] = ACTIONS(1562),
    [anon_sym_enum] = ACTIONS(536),
    [anon_sym_struct] = ACTIONS(538),
    [anon_sym_union] = ACTIONS(540),
    [sym_identifier] = ACTIONS(542),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(544),
    [sym_auto] = ACTIONS(1562),
    [anon_sym_typename] = ACTIONS(546),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [309] = {
    [anon_sym_COMMA] = ACTIONS(624),
    [anon_sym_RPAREN] = ACTIONS(624),
    [anon_sym_SEMI] = ACTIONS(624),
    [anon_sym_LBRACE] = ACTIONS(624),
    [anon_sym_RBRACE] = ACTIONS(624),
    [anon_sym_LPAREN2] = ACTIONS(624),
    [anon_sym_STAR] = ACTIONS(626),
    [anon_sym_LBRACK] = ACTIONS(624),
    [anon_sym_RBRACK] = ACTIONS(624),
    [anon_sym_EQ] = ACTIONS(626),
    [anon_sym_COLON] = ACTIONS(626),
    [anon_sym_QMARK] = ACTIONS(624),
    [anon_sym_STAR_EQ] = ACTIONS(624),
    [anon_sym_SLASH_EQ] = ACTIONS(624),
    [anon_sym_PERCENT_EQ] = ACTIONS(624),
    [anon_sym_PLUS_EQ] = ACTIONS(624),
    [anon_sym_DASH_EQ] = ACTIONS(624),
    [anon_sym_LT_LT_EQ] = ACTIONS(624),
    [anon_sym_GT_GT_EQ] = ACTIONS(624),
    [anon_sym_AMP_EQ] = ACTIONS(624),
    [anon_sym_CARET_EQ] = ACTIONS(624),
    [anon_sym_PIPE_EQ] = ACTIONS(624),
    [anon_sym_AMP] = ACTIONS(626),
    [anon_sym_PIPE_PIPE] = ACTIONS(624),
    [anon_sym_AMP_AMP] = ACTIONS(624),
    [anon_sym_PIPE] = ACTIONS(626),
    [anon_sym_CARET] = ACTIONS(626),
    [anon_sym_EQ_EQ] = ACTIONS(624),
    [anon_sym_BANG_EQ] = ACTIONS(624),
    [anon_sym_LT] = ACTIONS(626),
    [anon_sym_GT] = ACTIONS(626),
    [anon_sym_LT_EQ] = ACTIONS(624),
    [anon_sym_GT_EQ] = ACTIONS(624),
    [anon_sym_LT_LT] = ACTIONS(626),
    [anon_sym_GT_GT] = ACTIONS(626),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_SLASH] = ACTIONS(626),
    [anon_sym_PERCENT] = ACTIONS(626),
    [anon_sym_DASH_DASH] = ACTIONS(624),
    [anon_sym_PLUS_PLUS] = ACTIONS(624),
    [anon_sym_DOT] = ACTIONS(624),
    [anon_sym_DASH_GT] = ACTIONS(624),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1564),
  },
  [310] = {
    [sym_template_argument_list] = STATE(878),
    [anon_sym_COMMA] = ACTIONS(624),
    [anon_sym_RPAREN] = ACTIONS(624),
    [anon_sym_SEMI] = ACTIONS(624),
    [anon_sym_LBRACE] = ACTIONS(624),
    [anon_sym_RBRACE] = ACTIONS(624),
    [anon_sym_LPAREN2] = ACTIONS(624),
    [anon_sym_STAR] = ACTIONS(626),
    [anon_sym_LBRACK] = ACTIONS(624),
    [anon_sym_RBRACK] = ACTIONS(624),
    [anon_sym_EQ] = ACTIONS(626),
    [anon_sym_COLON] = ACTIONS(624),
    [anon_sym_QMARK] = ACTIONS(624),
    [anon_sym_STAR_EQ] = ACTIONS(624),
    [anon_sym_SLASH_EQ] = ACTIONS(624),
    [anon_sym_PERCENT_EQ] = ACTIONS(624),
    [anon_sym_PLUS_EQ] = ACTIONS(624),
    [anon_sym_DASH_EQ] = ACTIONS(624),
    [anon_sym_LT_LT_EQ] = ACTIONS(624),
    [anon_sym_GT_GT_EQ] = ACTIONS(624),
    [anon_sym_AMP_EQ] = ACTIONS(624),
    [anon_sym_CARET_EQ] = ACTIONS(624),
    [anon_sym_PIPE_EQ] = ACTIONS(624),
    [anon_sym_AMP] = ACTIONS(626),
    [anon_sym_PIPE_PIPE] = ACTIONS(624),
    [anon_sym_AMP_AMP] = ACTIONS(624),
    [anon_sym_PIPE] = ACTIONS(626),
    [anon_sym_CARET] = ACTIONS(626),
    [anon_sym_EQ_EQ] = ACTIONS(624),
    [anon_sym_BANG_EQ] = ACTIONS(624),
    [anon_sym_LT] = ACTIONS(1566),
    [anon_sym_GT] = ACTIONS(626),
    [anon_sym_LT_EQ] = ACTIONS(624),
    [anon_sym_GT_EQ] = ACTIONS(624),
    [anon_sym_LT_LT] = ACTIONS(626),
    [anon_sym_GT_GT] = ACTIONS(626),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_SLASH] = ACTIONS(626),
    [anon_sym_PERCENT] = ACTIONS(626),
    [anon_sym_DASH_DASH] = ACTIONS(624),
    [anon_sym_PLUS_PLUS] = ACTIONS(624),
    [anon_sym_DOT] = ACTIONS(624),
    [anon_sym_DASH_GT] = ACTIONS(624),
    [sym_comment] = ACTIONS(91),
  },
  [311] = {
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1564),
  },
  [312] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(881),
    [anon_sym_COMMA] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(653),
    [anon_sym_LBRACE] = ACTIONS(653),
    [anon_sym_LPAREN2] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_EQ] = ACTIONS(655),
    [anon_sym_unsigned] = ACTIONS(1569),
    [anon_sym_long] = ACTIONS(1569),
    [anon_sym_short] = ACTIONS(1569),
    [sym_primitive_type] = ACTIONS(1571),
    [anon_sym_QMARK] = ACTIONS(653),
    [anon_sym_STAR_EQ] = ACTIONS(653),
    [anon_sym_SLASH_EQ] = ACTIONS(653),
    [anon_sym_PERCENT_EQ] = ACTIONS(653),
    [anon_sym_PLUS_EQ] = ACTIONS(653),
    [anon_sym_DASH_EQ] = ACTIONS(653),
    [anon_sym_LT_LT_EQ] = ACTIONS(653),
    [anon_sym_GT_GT_EQ] = ACTIONS(653),
    [anon_sym_AMP_EQ] = ACTIONS(653),
    [anon_sym_CARET_EQ] = ACTIONS(653),
    [anon_sym_PIPE_EQ] = ACTIONS(653),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_PIPE_PIPE] = ACTIONS(653),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(655),
    [anon_sym_EQ_EQ] = ACTIONS(653),
    [anon_sym_BANG_EQ] = ACTIONS(653),
    [anon_sym_LT] = ACTIONS(655),
    [anon_sym_GT] = ACTIONS(655),
    [anon_sym_LT_EQ] = ACTIONS(653),
    [anon_sym_GT_EQ] = ACTIONS(653),
    [anon_sym_LT_LT] = ACTIONS(655),
    [anon_sym_GT_GT] = ACTIONS(655),
    [anon_sym_PLUS] = ACTIONS(655),
    [anon_sym_DASH] = ACTIONS(655),
    [anon_sym_SLASH] = ACTIONS(655),
    [anon_sym_PERCENT] = ACTIONS(655),
    [anon_sym_DASH_DASH] = ACTIONS(653),
    [anon_sym_PLUS_PLUS] = ACTIONS(653),
    [anon_sym_DOT] = ACTIONS(653),
    [anon_sym_DASH_GT] = ACTIONS(653),
    [sym_identifier] = ACTIONS(1573),
    [sym_comment] = ACTIONS(91),
  },
  [313] = {
    [anon_sym_COMMA] = ACTIONS(1575),
    [anon_sym_RPAREN] = ACTIONS(1577),
    [anon_sym_SEMI] = ACTIONS(1577),
    [anon_sym_extern] = ACTIONS(1580),
    [anon_sym_LBRACE] = ACTIONS(1582),
    [anon_sym_RBRACE] = ACTIONS(1575),
    [anon_sym_LPAREN2] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1584),
    [anon_sym_LBRACK] = ACTIONS(1577),
    [anon_sym_EQ] = ACTIONS(1587),
    [anon_sym_static] = ACTIONS(1580),
    [anon_sym_register] = ACTIONS(1580),
    [anon_sym_inline] = ACTIONS(1580),
    [anon_sym_const] = ACTIONS(1580),
    [anon_sym_restrict] = ACTIONS(1580),
    [anon_sym_volatile] = ACTIONS(1580),
    [anon_sym__Atomic] = ACTIONS(1580),
    [anon_sym_mutable] = ACTIONS(1580),
    [anon_sym_explicit] = ACTIONS(1580),
    [anon_sym_constexpr] = ACTIONS(1580),
    [anon_sym_QMARK] = ACTIONS(1575),
    [anon_sym_STAR_EQ] = ACTIONS(1575),
    [anon_sym_SLASH_EQ] = ACTIONS(1575),
    [anon_sym_PERCENT_EQ] = ACTIONS(1575),
    [anon_sym_PLUS_EQ] = ACTIONS(1575),
    [anon_sym_DASH_EQ] = ACTIONS(1575),
    [anon_sym_LT_LT_EQ] = ACTIONS(1575),
    [anon_sym_GT_GT_EQ] = ACTIONS(1575),
    [anon_sym_AMP_EQ] = ACTIONS(1575),
    [anon_sym_CARET_EQ] = ACTIONS(1575),
    [anon_sym_PIPE_EQ] = ACTIONS(1575),
    [anon_sym_AMP] = ACTIONS(1584),
    [anon_sym_PIPE_PIPE] = ACTIONS(1575),
    [anon_sym_AMP_AMP] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(1587),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1582),
    [anon_sym_EQ_EQ] = ACTIONS(1575),
    [anon_sym_BANG_EQ] = ACTIONS(1575),
    [anon_sym_LT] = ACTIONS(1584),
    [anon_sym_GT] = ACTIONS(1587),
    [anon_sym_LT_EQ] = ACTIONS(1575),
    [anon_sym_GT_EQ] = ACTIONS(1575),
    [anon_sym_LT_LT] = ACTIONS(1587),
    [anon_sym_GT_GT] = ACTIONS(1587),
    [anon_sym_PLUS] = ACTIONS(1587),
    [anon_sym_DASH] = ACTIONS(1587),
    [anon_sym_SLASH] = ACTIONS(1587),
    [anon_sym_PERCENT] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1575),
    [anon_sym_PLUS_PLUS] = ACTIONS(1575),
    [anon_sym_DOT] = ACTIONS(1575),
    [anon_sym_DASH_GT] = ACTIONS(1575),
    [sym_identifier] = ACTIONS(1580),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [sym_operator_name] = ACTIONS(1582),
  },
  [314] = {
    [sym__expression] = STATE(883),
    [sym_conditional_expression] = STATE(883),
    [sym_assignment_expression] = STATE(883),
    [sym_pointer_expression] = STATE(883),
    [sym_logical_expression] = STATE(883),
    [sym_bitwise_expression] = STATE(883),
    [sym_equality_expression] = STATE(883),
    [sym_relational_expression] = STATE(883),
    [sym_shift_expression] = STATE(883),
    [sym_math_expression] = STATE(883),
    [sym_cast_expression] = STATE(883),
    [sym_sizeof_expression] = STATE(883),
    [sym_subscript_expression] = STATE(883),
    [sym_call_expression] = STATE(883),
    [sym_field_expression] = STATE(883),
    [sym_compound_literal_expression] = STATE(883),
    [sym_parenthesized_expression] = STATE(883),
    [sym_char_literal] = STATE(883),
    [sym_concatenated_string] = STATE(883),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(883),
    [sym_new_expression] = STATE(883),
    [sym_delete_expression] = STATE(883),
    [sym_lambda_expression] = STATE(883),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(1591),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(1593),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(1591),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(1595),
    [sym_false] = ACTIONS(1595),
    [sym_null] = ACTIONS(1595),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(1595),
  },
  [315] = {
    [anon_sym_COMMA] = ACTIONS(1575),
    [anon_sym_RPAREN] = ACTIONS(1575),
    [anon_sym_SEMI] = ACTIONS(1575),
    [anon_sym_LBRACE] = ACTIONS(1575),
    [anon_sym_RBRACE] = ACTIONS(1575),
    [anon_sym_LPAREN2] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(1587),
    [anon_sym_LBRACK] = ACTIONS(1575),
    [anon_sym_RBRACK] = ACTIONS(1575),
    [anon_sym_EQ] = ACTIONS(1587),
    [anon_sym_COLON] = ACTIONS(1575),
    [anon_sym_QMARK] = ACTIONS(1575),
    [anon_sym_STAR_EQ] = ACTIONS(1575),
    [anon_sym_SLASH_EQ] = ACTIONS(1575),
    [anon_sym_PERCENT_EQ] = ACTIONS(1575),
    [anon_sym_PLUS_EQ] = ACTIONS(1575),
    [anon_sym_DASH_EQ] = ACTIONS(1575),
    [anon_sym_LT_LT_EQ] = ACTIONS(1575),
    [anon_sym_GT_GT_EQ] = ACTIONS(1575),
    [anon_sym_AMP_EQ] = ACTIONS(1575),
    [anon_sym_CARET_EQ] = ACTIONS(1575),
    [anon_sym_PIPE_EQ] = ACTIONS(1575),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_PIPE_PIPE] = ACTIONS(1575),
    [anon_sym_AMP_AMP] = ACTIONS(1575),
    [anon_sym_PIPE] = ACTIONS(1587),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_EQ_EQ] = ACTIONS(1575),
    [anon_sym_BANG_EQ] = ACTIONS(1575),
    [anon_sym_LT] = ACTIONS(1587),
    [anon_sym_GT] = ACTIONS(1587),
    [anon_sym_LT_EQ] = ACTIONS(1575),
    [anon_sym_GT_EQ] = ACTIONS(1575),
    [anon_sym_LT_LT] = ACTIONS(1587),
    [anon_sym_GT_GT] = ACTIONS(1587),
    [anon_sym_PLUS] = ACTIONS(1587),
    [anon_sym_DASH] = ACTIONS(1587),
    [anon_sym_SLASH] = ACTIONS(1587),
    [anon_sym_PERCENT] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1575),
    [anon_sym_PLUS_PLUS] = ACTIONS(1575),
    [anon_sym_DOT] = ACTIONS(1575),
    [anon_sym_DASH_GT] = ACTIONS(1575),
    [sym_comment] = ACTIONS(91),
  },
  [316] = {
    [sym_raw_string_literal] = ACTIONS(1597),
    [ts_builtin_sym_end] = ACTIONS(1597),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1599),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1599),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1599),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1599),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1599),
    [sym_preproc_directive] = ACTIONS(1599),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_typedef] = ACTIONS(1599),
    [anon_sym_extern] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(1597),
    [anon_sym_LPAREN2] = ACTIONS(1597),
    [anon_sym_STAR] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_static] = ACTIONS(1599),
    [anon_sym_register] = ACTIONS(1599),
    [anon_sym_inline] = ACTIONS(1599),
    [anon_sym_const] = ACTIONS(1599),
    [anon_sym_restrict] = ACTIONS(1599),
    [anon_sym_volatile] = ACTIONS(1599),
    [anon_sym__Atomic] = ACTIONS(1599),
    [anon_sym_mutable] = ACTIONS(1599),
    [anon_sym_explicit] = ACTIONS(1599),
    [anon_sym_constexpr] = ACTIONS(1599),
    [anon_sym_unsigned] = ACTIONS(1599),
    [anon_sym_long] = ACTIONS(1599),
    [anon_sym_short] = ACTIONS(1599),
    [sym_primitive_type] = ACTIONS(1599),
    [anon_sym_enum] = ACTIONS(1599),
    [anon_sym_struct] = ACTIONS(1599),
    [anon_sym_union] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(1599),
    [anon_sym_switch] = ACTIONS(1599),
    [anon_sym_case] = ACTIONS(1599),
    [anon_sym_default] = ACTIONS(1599),
    [anon_sym_while] = ACTIONS(1599),
    [anon_sym_do] = ACTIONS(1599),
    [anon_sym_for] = ACTIONS(1599),
    [anon_sym_return] = ACTIONS(1599),
    [anon_sym_break] = ACTIONS(1599),
    [anon_sym_continue] = ACTIONS(1599),
    [anon_sym_goto] = ACTIONS(1599),
    [anon_sym_AMP] = ACTIONS(1599),
    [anon_sym_AMP_AMP] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1597),
    [anon_sym_TILDE] = ACTIONS(1597),
    [anon_sym_PLUS] = ACTIONS(1599),
    [anon_sym_DASH] = ACTIONS(1599),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_sizeof] = ACTIONS(1599),
    [sym_number_literal] = ACTIONS(1597),
    [anon_sym_SQUOTE] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1597),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_null] = ACTIONS(1599),
    [sym_identifier] = ACTIONS(1599),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1599),
    [sym_auto] = ACTIONS(1599),
    [anon_sym_typename] = ACTIONS(1599),
    [anon_sym_template] = ACTIONS(1599),
    [anon_sym_delete] = ACTIONS(1599),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_using] = ACTIONS(1599),
    [anon_sym_try] = ACTIONS(1599),
    [anon_sym_new] = ACTIONS(1599),
    [anon_sym_COLON_COLON] = ACTIONS(1597),
    [sym_operator_name] = ACTIONS(1597),
    [sym_nullptr] = ACTIONS(1599),
  },
  [317] = {
    [sym__declarator] = STATE(885),
    [sym_pointer_declarator] = STATE(885),
    [sym_function_declarator] = STATE(885),
    [sym_array_declarator] = STATE(885),
    [sym_type_qualifier] = STATE(886),
    [sym_reference_declarator] = STATE(885),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(885),
    [sym_destructor_name] = STATE(885),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [aux_sym_type_definition_repeat1] = STATE(886),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(560),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(568),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(1605),
  },
  [318] = {
    [sym_identifier] = ACTIONS(1607),
    [sym_comment] = ACTIONS(91),
  },
  [319] = {
    [sym__declarator] = STATE(888),
    [sym_pointer_declarator] = STATE(888),
    [sym_function_declarator] = STATE(888),
    [sym_array_declarator] = STATE(888),
    [sym_reference_declarator] = STATE(888),
    [sym_structured_binding_declarator] = STATE(889),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(888),
    [sym_destructor_name] = STATE(888),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(568),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(1609),
  },
  [320] = {
    [sym_template_argument_list] = STATE(890),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_RPAREN] = ACTIONS(576),
    [anon_sym_SEMI] = ACTIONS(576),
    [anon_sym_LBRACE] = ACTIONS(576),
    [anon_sym_LPAREN2] = ACTIONS(576),
    [anon_sym_LBRACK] = ACTIONS(576),
    [anon_sym_EQ] = ACTIONS(576),
    [anon_sym_COLON] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(945),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1344),
  },
  [321] = {
    [sym_compound_statement] = STATE(896),
    [sym_parameter_list] = STATE(897),
    [sym_argument_list] = STATE(898),
    [sym_initializer_list] = STATE(898),
    [aux_sym_declaration_repeat1] = STATE(899),
    [anon_sym_COMMA] = ACTIONS(1613),
    [anon_sym_SEMI] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1617),
    [anon_sym_LPAREN2] = ACTIONS(1619),
    [anon_sym_LBRACK] = ACTIONS(574),
    [anon_sym_EQ] = ACTIONS(1621),
    [sym_comment] = ACTIONS(91),
  },
  [322] = {
    [aux_sym_declaration_repeat1] = STATE(899),
    [anon_sym_COMMA] = ACTIONS(1613),
    [anon_sym_SEMI] = ACTIONS(1615),
    [sym_comment] = ACTIONS(91),
  },
  [323] = {
    [sym_argument_list] = STATE(901),
    [sym_initializer_list] = STATE(901),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(1623),
    [sym_comment] = ACTIONS(91),
  },
  [324] = {
    [sym__declaration_specifiers] = STATE(905),
    [sym_storage_class_specifier] = STATE(907),
    [sym_type_qualifier] = STATE(907),
    [sym__type_specifier] = STATE(906),
    [sym_sized_type_specifier] = STATE(906),
    [sym_enum_specifier] = STATE(906),
    [sym_struct_specifier] = STATE(906),
    [sym_union_specifier] = STATE(906),
    [sym_parameter_declaration] = STATE(902),
    [sym_macro_type_specifier] = STATE(906),
    [sym_class_specifier] = STATE(906),
    [sym_dependent_type] = STATE(906),
    [sym_template_type] = STATE(272),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(180),
    [aux_sym__declaration_specifiers_repeat1] = STATE(907),
    [aux_sym_sized_type_specifier_repeat1] = STATE(908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1625),
    [anon_sym_RPAREN] = ACTIONS(1627),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(1629),
    [anon_sym_long] = ACTIONS(1629),
    [anon_sym_short] = ACTIONS(1629),
    [sym_primitive_type] = ACTIONS(1631),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [sym_identifier] = ACTIONS(492),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(1631),
    [anon_sym_typename] = ACTIONS(1633),
    [anon_sym_COLON_COLON] = ACTIONS(315),
  },
  [325] = {
    [sym_type_qualifier] = STATE(923),
    [sym__expression] = STATE(921),
    [sym_conditional_expression] = STATE(921),
    [sym_assignment_expression] = STATE(921),
    [sym_pointer_expression] = STATE(921),
    [sym_logical_expression] = STATE(921),
    [sym_bitwise_expression] = STATE(921),
    [sym_equality_expression] = STATE(921),
    [sym_relational_expression] = STATE(921),
    [sym_shift_expression] = STATE(921),
    [sym_math_expression] = STATE(921),
    [sym_cast_expression] = STATE(921),
    [sym_sizeof_expression] = STATE(921),
    [sym_subscript_expression] = STATE(921),
    [sym_call_expression] = STATE(921),
    [sym_field_expression] = STATE(921),
    [sym_compound_literal_expression] = STATE(921),
    [sym_parenthesized_expression] = STATE(921),
    [sym_char_literal] = STATE(921),
    [sym_concatenated_string] = STATE(921),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(921),
    [sym_new_expression] = STATE(921),
    [sym_delete_expression] = STATE(921),
    [sym_lambda_expression] = STATE(921),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [aux_sym_type_definition_repeat1] = STATE(923),
    [sym_raw_string_literal] = ACTIONS(1635),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1639),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(1641),
    [anon_sym_const] = ACTIONS(1643),
    [anon_sym_restrict] = ACTIONS(1643),
    [anon_sym_volatile] = ACTIONS(1643),
    [anon_sym__Atomic] = ACTIONS(1643),
    [anon_sym_mutable] = ACTIONS(1643),
    [anon_sym_explicit] = ACTIONS(1643),
    [anon_sym_constexpr] = ACTIONS(1643),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(1635),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(1657),
    [sym_false] = ACTIONS(1657),
    [sym_null] = ACTIONS(1657),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(1657),
  },
  [326] = {
    [sym_type_qualifier] = STATE(926),
    [sym_virtual_specifier] = STATE(926),
    [sym_trailing_return_type] = STATE(926),
    [aux_sym_function_declarator_repeat1] = STATE(926),
    [anon_sym_LBRACE] = ACTIONS(1665),
    [anon_sym_LPAREN2] = ACTIONS(1665),
    [anon_sym_LBRACK] = ACTIONS(1665),
    [anon_sym_EQ] = ACTIONS(1665),
    [anon_sym_const] = ACTIONS(1667),
    [anon_sym_restrict] = ACTIONS(1669),
    [anon_sym_volatile] = ACTIONS(1669),
    [anon_sym__Atomic] = ACTIONS(1669),
    [anon_sym_mutable] = ACTIONS(1669),
    [anon_sym_explicit] = ACTIONS(1669),
    [anon_sym_constexpr] = ACTIONS(1669),
    [anon_sym_COLON] = ACTIONS(1665),
    [anon_sym_DASH_GT] = ACTIONS(1671),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [sym_noexcept] = ACTIONS(1675),
  },
  [327] = {
    [anon_sym_default] = ACTIONS(1677),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1679),
  },
  [328] = {
    [sym_field_initializer] = STATE(931),
    [sym_template_type] = STATE(932),
    [sym_scoped_field_identifier] = STATE(933),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(932),
    [sym_identifier] = ACTIONS(1681),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
  },
  [329] = {
    [sym_raw_string_literal] = ACTIONS(1685),
    [ts_builtin_sym_end] = ACTIONS(1685),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1687),
    [sym_preproc_directive] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1685),
    [anon_sym_typedef] = ACTIONS(1687),
    [anon_sym_extern] = ACTIONS(1687),
    [anon_sym_LBRACE] = ACTIONS(1685),
    [anon_sym_RBRACE] = ACTIONS(1685),
    [anon_sym_LPAREN2] = ACTIONS(1685),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_LBRACK] = ACTIONS(1685),
    [anon_sym_static] = ACTIONS(1687),
    [anon_sym_register] = ACTIONS(1687),
    [anon_sym_inline] = ACTIONS(1687),
    [anon_sym_const] = ACTIONS(1687),
    [anon_sym_restrict] = ACTIONS(1687),
    [anon_sym_volatile] = ACTIONS(1687),
    [anon_sym__Atomic] = ACTIONS(1687),
    [anon_sym_mutable] = ACTIONS(1687),
    [anon_sym_explicit] = ACTIONS(1687),
    [anon_sym_constexpr] = ACTIONS(1687),
    [anon_sym_unsigned] = ACTIONS(1687),
    [anon_sym_long] = ACTIONS(1687),
    [anon_sym_short] = ACTIONS(1687),
    [sym_primitive_type] = ACTIONS(1687),
    [anon_sym_enum] = ACTIONS(1687),
    [anon_sym_struct] = ACTIONS(1687),
    [anon_sym_union] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1687),
    [anon_sym_switch] = ACTIONS(1687),
    [anon_sym_case] = ACTIONS(1687),
    [anon_sym_default] = ACTIONS(1687),
    [anon_sym_while] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1687),
    [anon_sym_for] = ACTIONS(1687),
    [anon_sym_return] = ACTIONS(1687),
    [anon_sym_break] = ACTIONS(1687),
    [anon_sym_continue] = ACTIONS(1687),
    [anon_sym_goto] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_BANG] = ACTIONS(1685),
    [anon_sym_TILDE] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_DASH] = ACTIONS(1687),
    [anon_sym_DASH_DASH] = ACTIONS(1685),
    [anon_sym_PLUS_PLUS] = ACTIONS(1685),
    [anon_sym_sizeof] = ACTIONS(1687),
    [sym_number_literal] = ACTIONS(1685),
    [anon_sym_SQUOTE] = ACTIONS(1685),
    [anon_sym_DQUOTE] = ACTIONS(1685),
    [sym_true] = ACTIONS(1687),
    [sym_false] = ACTIONS(1687),
    [sym_null] = ACTIONS(1687),
    [sym_identifier] = ACTIONS(1687),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1687),
    [sym_auto] = ACTIONS(1687),
    [anon_sym_typename] = ACTIONS(1687),
    [anon_sym_template] = ACTIONS(1687),
    [anon_sym_delete] = ACTIONS(1687),
    [anon_sym_namespace] = ACTIONS(1687),
    [anon_sym_using] = ACTIONS(1687),
    [anon_sym_try] = ACTIONS(1687),
    [anon_sym_new] = ACTIONS(1687),
    [anon_sym_COLON_COLON] = ACTIONS(1685),
    [sym_operator_name] = ACTIONS(1685),
    [sym_nullptr] = ACTIONS(1687),
  },
  [330] = {
    [sym_compound_statement] = STATE(934),
    [sym_default_method_clause] = STATE(934),
    [sym_delete_method_clause] = STATE(934),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_EQ] = ACTIONS(578),
    [sym_comment] = ACTIONS(91),
  },
  [331] = {
    [sym_storage_class_specifier] = STATE(935),
    [sym_type_qualifier] = STATE(935),
    [aux_sym__declaration_specifiers_repeat1] = STATE(935),
    [anon_sym_SEMI] = ACTIONS(1689),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_LPAREN2] = ACTIONS(1689),
    [anon_sym_STAR] = ACTIONS(1689),
    [anon_sym_LBRACK] = ACTIONS(1689),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(1691),
    [anon_sym_AMP_AMP] = ACTIONS(1689),
    [anon_sym_TILDE] = ACTIONS(1689),
    [sym_identifier] = ACTIONS(1691),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1689),
    [sym_operator_name] = ACTIONS(1689),
  },
  [332] = {
    [sym__expression] = STATE(936),
    [sym_comma_expression] = STATE(937),
    [sym_conditional_expression] = STATE(936),
    [sym_assignment_expression] = STATE(936),
    [sym_pointer_expression] = STATE(936),
    [sym_logical_expression] = STATE(936),
    [sym_bitwise_expression] = STATE(936),
    [sym_equality_expression] = STATE(936),
    [sym_relational_expression] = STATE(936),
    [sym_shift_expression] = STATE(936),
    [sym_math_expression] = STATE(936),
    [sym_cast_expression] = STATE(936),
    [sym_sizeof_expression] = STATE(936),
    [sym_subscript_expression] = STATE(936),
    [sym_call_expression] = STATE(936),
    [sym_field_expression] = STATE(936),
    [sym_compound_literal_expression] = STATE(936),
    [sym_parenthesized_expression] = STATE(936),
    [sym_char_literal] = STATE(936),
    [sym_concatenated_string] = STATE(936),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(936),
    [sym_new_expression] = STATE(936),
    [sym_delete_expression] = STATE(936),
    [sym_lambda_expression] = STATE(936),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(1693),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(1693),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(1695),
    [sym_false] = ACTIONS(1695),
    [sym_null] = ACTIONS(1695),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(1695),
  },
  [333] = {
    [sym_raw_string_literal] = ACTIONS(1697),
    [ts_builtin_sym_end] = ACTIONS(1697),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1699),
    [sym_preproc_directive] = ACTIONS(1699),
    [anon_sym_SEMI] = ACTIONS(1697),
    [anon_sym_typedef] = ACTIONS(1699),
    [anon_sym_extern] = ACTIONS(1699),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_RBRACE] = ACTIONS(1697),
    [anon_sym_LPAREN2] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1697),
    [anon_sym_LBRACK] = ACTIONS(1697),
    [anon_sym_static] = ACTIONS(1699),
    [anon_sym_register] = ACTIONS(1699),
    [anon_sym_inline] = ACTIONS(1699),
    [anon_sym_const] = ACTIONS(1699),
    [anon_sym_restrict] = ACTIONS(1699),
    [anon_sym_volatile] = ACTIONS(1699),
    [anon_sym__Atomic] = ACTIONS(1699),
    [anon_sym_mutable] = ACTIONS(1699),
    [anon_sym_explicit] = ACTIONS(1699),
    [anon_sym_constexpr] = ACTIONS(1699),
    [anon_sym_unsigned] = ACTIONS(1699),
    [anon_sym_long] = ACTIONS(1699),
    [anon_sym_short] = ACTIONS(1699),
    [sym_primitive_type] = ACTIONS(1699),
    [anon_sym_enum] = ACTIONS(1699),
    [anon_sym_struct] = ACTIONS(1699),
    [anon_sym_union] = ACTIONS(1699),
    [anon_sym_if] = ACTIONS(1699),
    [anon_sym_else] = ACTIONS(1699),
    [anon_sym_switch] = ACTIONS(1699),
    [anon_sym_case] = ACTIONS(1699),
    [anon_sym_default] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(1699),
    [anon_sym_do] = ACTIONS(1699),
    [anon_sym_for] = ACTIONS(1699),
    [anon_sym_return] = ACTIONS(1699),
    [anon_sym_break] = ACTIONS(1699),
    [anon_sym_continue] = ACTIONS(1699),
    [anon_sym_goto] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_AMP_AMP] = ACTIONS(1697),
    [anon_sym_BANG] = ACTIONS(1697),
    [anon_sym_TILDE] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1697),
    [anon_sym_PLUS_PLUS] = ACTIONS(1697),
    [anon_sym_sizeof] = ACTIONS(1699),
    [sym_number_literal] = ACTIONS(1697),
    [anon_sym_SQUOTE] = ACTIONS(1697),
    [anon_sym_DQUOTE] = ACTIONS(1697),
    [sym_true] = ACTIONS(1699),
    [sym_false] = ACTIONS(1699),
    [sym_null] = ACTIONS(1699),
    [sym_identifier] = ACTIONS(1699),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1699),
    [sym_auto] = ACTIONS(1699),
    [anon_sym_typename] = ACTIONS(1699),
    [anon_sym_template] = ACTIONS(1699),
    [anon_sym_delete] = ACTIONS(1699),
    [anon_sym_namespace] = ACTIONS(1699),
    [anon_sym_using] = ACTIONS(1699),
    [anon_sym_try] = ACTIONS(1699),
    [anon_sym_new] = ACTIONS(1699),
    [anon_sym_COLON_COLON] = ACTIONS(1697),
    [sym_operator_name] = ACTIONS(1697),
    [sym_nullptr] = ACTIONS(1699),
  },
  [334] = {
    [sym__expression] = STATE(938),
    [sym_conditional_expression] = STATE(938),
    [sym_assignment_expression] = STATE(938),
    [sym_pointer_expression] = STATE(938),
    [sym_logical_expression] = STATE(938),
    [sym_bitwise_expression] = STATE(938),
    [sym_equality_expression] = STATE(938),
    [sym_relational_expression] = STATE(938),
    [sym_shift_expression] = STATE(938),
    [sym_math_expression] = STATE(938),
    [sym_cast_expression] = STATE(938),
    [sym_sizeof_expression] = STATE(938),
    [sym_subscript_expression] = STATE(938),
    [sym_call_expression] = STATE(938),
    [sym_field_expression] = STATE(938),
    [sym_compound_literal_expression] = STATE(938),
    [sym_parenthesized_expression] = STATE(938),
    [sym_char_literal] = STATE(938),
    [sym_concatenated_string] = STATE(938),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(938),
    [sym_new_expression] = STATE(938),
    [sym_delete_expression] = STATE(938),
    [sym_lambda_expression] = STATE(938),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(1701),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(1701),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(1703),
    [sym_false] = ACTIONS(1703),
    [sym_null] = ACTIONS(1703),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(1703),
  },
  [335] = {
    [sym__expression] = STATE(939),
    [sym_conditional_expression] = STATE(939),
    [sym_assignment_expression] = STATE(939),
    [sym_pointer_expression] = STATE(939),
    [sym_logical_expression] = STATE(939),
    [sym_bitwise_expression] = STATE(939),
    [sym_equality_expression] = STATE(939),
    [sym_relational_expression] = STATE(939),
    [sym_shift_expression] = STATE(939),
    [sym_math_expression] = STATE(939),
    [sym_cast_expression] = STATE(939),
    [sym_sizeof_expression] = STATE(939),
    [sym_subscript_expression] = STATE(939),
    [sym_call_expression] = STATE(939),
    [sym_field_expression] = STATE(939),
    [sym_compound_literal_expression] = STATE(939),
    [sym_parenthesized_expression] = STATE(939),
    [sym_char_literal] = STATE(939),
    [sym_concatenated_string] = STATE(939),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(939),
    [sym_new_expression] = STATE(939),
    [sym_delete_expression] = STATE(939),
    [sym_lambda_expression] = STATE(939),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(1705),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(1705),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(1707),
    [sym_false] = ACTIONS(1707),
    [sym_null] = ACTIONS(1707),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(1707),
  },
  [336] = {
    [sym__expression] = STATE(940),
    [sym_conditional_expression] = STATE(940),
    [sym_assignment_expression] = STATE(940),
    [sym_pointer_expression] = STATE(940),
    [sym_logical_expression] = STATE(940),
    [sym_bitwise_expression] = STATE(940),
    [sym_equality_expression] = STATE(940),
    [sym_relational_expression] = STATE(940),
    [sym_shift_expression] = STATE(940),
    [sym_math_expression] = STATE(940),
    [sym_cast_expression] = STATE(940),
    [sym_sizeof_expression] = STATE(940),
    [sym_subscript_expression] = STATE(940),
    [sym_call_expression] = STATE(940),
    [sym_field_expression] = STATE(940),
    [sym_compound_literal_expression] = STATE(940),
    [sym_parenthesized_expression] = STATE(940),
    [sym_char_literal] = STATE(940),
    [sym_concatenated_string] = STATE(940),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(940),
    [sym_new_expression] = STATE(940),
    [sym_delete_expression] = STATE(940),
    [sym_lambda_expression] = STATE(940),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(1709),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(1709),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(1711),
    [sym_false] = ACTIONS(1711),
    [sym_null] = ACTIONS(1711),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(1711),
  },
  [337] = {
    [sym__expression] = STATE(941),
    [sym_conditional_expression] = STATE(941),
    [sym_assignment_expression] = STATE(941),
    [sym_pointer_expression] = STATE(941),
    [sym_logical_expression] = STATE(941),
    [sym_bitwise_expression] = STATE(941),
    [sym_equality_expression] = STATE(941),
    [sym_relational_expression] = STATE(941),
    [sym_shift_expression] = STATE(941),
    [sym_math_expression] = STATE(941),
    [sym_cast_expression] = STATE(941),
    [sym_sizeof_expression] = STATE(941),
    [sym_subscript_expression] = STATE(941),
    [sym_call_expression] = STATE(941),
    [sym_field_expression] = STATE(941),
    [sym_compound_literal_expression] = STATE(941),
    [sym_parenthesized_expression] = STATE(941),
    [sym_char_literal] = STATE(941),
    [sym_concatenated_string] = STATE(941),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(941),
    [sym_new_expression] = STATE(941),
    [sym_delete_expression] = STATE(941),
    [sym_lambda_expression] = STATE(941),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(1713),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(1713),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(1715),
    [sym_false] = ACTIONS(1715),
    [sym_null] = ACTIONS(1715),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(1715),
  },
  [338] = {
    [sym__expression] = STATE(942),
    [sym_conditional_expression] = STATE(942),
    [sym_assignment_expression] = STATE(942),
    [sym_pointer_expression] = STATE(942),
    [sym_logical_expression] = STATE(942),
    [sym_bitwise_expression] = STATE(942),
    [sym_equality_expression] = STATE(942),
    [sym_relational_expression] = STATE(942),
    [sym_shift_expression] = STATE(942),
    [sym_math_expression] = STATE(942),
    [sym_cast_expression] = STATE(942),
    [sym_sizeof_expression] = STATE(942),
    [sym_subscript_expression] = STATE(942),
    [sym_call_expression] = STATE(942),
    [sym_field_expression] = STATE(942),
    [sym_compound_literal_expression] = STATE(942),
    [sym_parenthesized_expression] = STATE(942),
    [sym_char_literal] = STATE(942),
    [sym_concatenated_string] = STATE(942),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(942),
    [sym_new_expression] = STATE(942),
    [sym_delete_expression] = STATE(942),
    [sym_lambda_expression] = STATE(942),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(1717),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(1717),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(1719),
    [sym_false] = ACTIONS(1719),
    [sym_null] = ACTIONS(1719),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(1719),
  },
  [339] = {
    [sym__expression] = STATE(943),
    [sym_conditional_expression] = STATE(943),
    [sym_assignment_expression] = STATE(943),
    [sym_pointer_expression] = STATE(943),
    [sym_logical_expression] = STATE(943),
    [sym_bitwise_expression] = STATE(943),
    [sym_equality_expression] = STATE(943),
    [sym_relational_expression] = STATE(943),
    [sym_shift_expression] = STATE(943),
    [sym_math_expression] = STATE(943),
    [sym_cast_expression] = STATE(943),
    [sym_sizeof_expression] = STATE(943),
    [sym_subscript_expression] = STATE(943),
    [sym_call_expression] = STATE(943),
    [sym_field_expression] = STATE(943),
    [sym_compound_literal_expression] = STATE(943),
    [sym_parenthesized_expression] = STATE(943),
    [sym_char_literal] = STATE(943),
    [sym_concatenated_string] = STATE(943),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(943),
    [sym_new_expression] = STATE(943),
    [sym_delete_expression] = STATE(943),
    [sym_lambda_expression] = STATE(943),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(1721),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(1721),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(1723),
    [sym_false] = ACTIONS(1723),
    [sym_null] = ACTIONS(1723),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(1723),
  },
  [340] = {
    [sym__expression] = STATE(944),
    [sym_conditional_expression] = STATE(944),
    [sym_assignment_expression] = STATE(944),
    [sym_pointer_expression] = STATE(944),
    [sym_logical_expression] = STATE(944),
    [sym_bitwise_expression] = STATE(944),
    [sym_equality_expression] = STATE(944),
    [sym_relational_expression] = STATE(944),
    [sym_shift_expression] = STATE(944),
    [sym_math_expression] = STATE(944),
    [sym_cast_expression] = STATE(944),
    [sym_sizeof_expression] = STATE(944),
    [sym_subscript_expression] = STATE(944),
    [sym_call_expression] = STATE(944),
    [sym_field_expression] = STATE(944),
    [sym_compound_literal_expression] = STATE(944),
    [sym_parenthesized_expression] = STATE(944),
    [sym_char_literal] = STATE(944),
    [sym_concatenated_string] = STATE(944),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(944),
    [sym_new_expression] = STATE(944),
    [sym_delete_expression] = STATE(944),
    [sym_lambda_expression] = STATE(944),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(1725),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(1725),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(1727),
    [sym_false] = ACTIONS(1727),
    [sym_null] = ACTIONS(1727),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(1727),
  },
  [341] = {
    [sym__expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_assignment_expression] = STATE(945),
    [sym_pointer_expression] = STATE(945),
    [sym_logical_expression] = STATE(945),
    [sym_bitwise_expression] = STATE(945),
    [sym_equality_expression] = STATE(945),
    [sym_relational_expression] = STATE(945),
    [sym_shift_expression] = STATE(945),
    [sym_math_expression] = STATE(945),
    [sym_cast_expression] = STATE(945),
    [sym_sizeof_expression] = STATE(945),
    [sym_subscript_expression] = STATE(945),
    [sym_call_expression] = STATE(945),
    [sym_field_expression] = STATE(945),
    [sym_compound_literal_expression] = STATE(945),
    [sym_parenthesized_expression] = STATE(945),
    [sym_char_literal] = STATE(945),
    [sym_concatenated_string] = STATE(945),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(945),
    [sym_new_expression] = STATE(945),
    [sym_delete_expression] = STATE(945),
    [sym_lambda_expression] = STATE(945),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(1729),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(1729),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(1731),
    [sym_false] = ACTIONS(1731),
    [sym_null] = ACTIONS(1731),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(1731),
  },
  [342] = {
    [sym__expression] = STATE(946),
    [sym_conditional_expression] = STATE(946),
    [sym_assignment_expression] = STATE(946),
    [sym_pointer_expression] = STATE(946),
    [sym_logical_expression] = STATE(946),
    [sym_bitwise_expression] = STATE(946),
    [sym_equality_expression] = STATE(946),
    [sym_relational_expression] = STATE(946),
    [sym_shift_expression] = STATE(946),
    [sym_math_expression] = STATE(946),
    [sym_cast_expression] = STATE(946),
    [sym_sizeof_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_call_expression] = STATE(946),
    [sym_field_expression] = STATE(946),
    [sym_compound_literal_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(946),
    [sym_char_literal] = STATE(946),
    [sym_concatenated_string] = STATE(946),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(946),
    [sym_new_expression] = STATE(946),
    [sym_delete_expression] = STATE(946),
    [sym_lambda_expression] = STATE(946),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(1733),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(1733),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(1735),
    [sym_false] = ACTIONS(1735),
    [sym_null] = ACTIONS(1735),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(1735),
  },
  [343] = {
    [sym__expression] = STATE(947),
    [sym_conditional_expression] = STATE(947),
    [sym_assignment_expression] = STATE(947),
    [sym_pointer_expression] = STATE(947),
    [sym_logical_expression] = STATE(947),
    [sym_bitwise_expression] = STATE(947),
    [sym_equality_expression] = STATE(947),
    [sym_relational_expression] = STATE(947),
    [sym_shift_expression] = STATE(947),
    [sym_math_expression] = STATE(947),
    [sym_cast_expression] = STATE(947),
    [sym_sizeof_expression] = STATE(947),
    [sym_subscript_expression] = STATE(947),
    [sym_call_expression] = STATE(947),
    [sym_field_expression] = STATE(947),
    [sym_compound_literal_expression] = STATE(947),
    [sym_parenthesized_expression] = STATE(947),
    [sym_char_literal] = STATE(947),
    [sym_concatenated_string] = STATE(947),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(947),
    [sym_new_expression] = STATE(947),
    [sym_delete_expression] = STATE(947),
    [sym_lambda_expression] = STATE(947),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(1737),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(1737),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(1739),
    [sym_false] = ACTIONS(1739),
    [sym_null] = ACTIONS(1739),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(1739),
  },
  [344] = {
    [sym__expression] = STATE(948),
    [sym_conditional_expression] = STATE(948),
    [sym_assignment_expression] = STATE(948),
    [sym_pointer_expression] = STATE(948),
    [sym_logical_expression] = STATE(948),
    [sym_bitwise_expression] = STATE(948),
    [sym_equality_expression] = STATE(948),
    [sym_relational_expression] = STATE(948),
    [sym_shift_expression] = STATE(948),
    [sym_math_expression] = STATE(948),
    [sym_cast_expression] = STATE(948),
    [sym_sizeof_expression] = STATE(948),
    [sym_subscript_expression] = STATE(948),
    [sym_call_expression] = STATE(948),
    [sym_field_expression] = STATE(948),
    [sym_compound_literal_expression] = STATE(948),
    [sym_parenthesized_expression] = STATE(948),
    [sym_char_literal] = STATE(948),
    [sym_concatenated_string] = STATE(948),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(948),
    [sym_new_expression] = STATE(948),
    [sym_delete_expression] = STATE(948),
    [sym_lambda_expression] = STATE(948),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(1741),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(1743),
    [sym_false] = ACTIONS(1743),
    [sym_null] = ACTIONS(1743),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(1743),
  },
  [345] = {
    [sym__expression] = STATE(949),
    [sym_conditional_expression] = STATE(949),
    [sym_assignment_expression] = STATE(949),
    [sym_pointer_expression] = STATE(949),
    [sym_logical_expression] = STATE(949),
    [sym_bitwise_expression] = STATE(949),
    [sym_equality_expression] = STATE(949),
    [sym_relational_expression] = STATE(949),
    [sym_shift_expression] = STATE(949),
    [sym_math_expression] = STATE(949),
    [sym_cast_expression] = STATE(949),
    [sym_sizeof_expression] = STATE(949),
    [sym_subscript_expression] = STATE(949),
    [sym_call_expression] = STATE(949),
    [sym_field_expression] = STATE(949),
    [sym_compound_literal_expression] = STATE(949),
    [sym_parenthesized_expression] = STATE(949),
    [sym_char_literal] = STATE(949),
    [sym_concatenated_string] = STATE(949),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(949),
    [sym_new_expression] = STATE(949),
    [sym_delete_expression] = STATE(949),
    [sym_lambda_expression] = STATE(949),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(1745),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(1745),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(1747),
    [sym_false] = ACTIONS(1747),
    [sym_null] = ACTIONS(1747),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(1747),
  },
  [346] = {
    [sym__expression] = STATE(950),
    [sym_conditional_expression] = STATE(950),
    [sym_assignment_expression] = STATE(950),
    [sym_pointer_expression] = STATE(950),
    [sym_logical_expression] = STATE(950),
    [sym_bitwise_expression] = STATE(950),
    [sym_equality_expression] = STATE(950),
    [sym_relational_expression] = STATE(950),
    [sym_shift_expression] = STATE(950),
    [sym_math_expression] = STATE(950),
    [sym_cast_expression] = STATE(950),
    [sym_sizeof_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_call_expression] = STATE(950),
    [sym_field_expression] = STATE(950),
    [sym_compound_literal_expression] = STATE(950),
    [sym_parenthesized_expression] = STATE(950),
    [sym_char_literal] = STATE(950),
    [sym_concatenated_string] = STATE(950),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(950),
    [sym_new_expression] = STATE(950),
    [sym_delete_expression] = STATE(950),
    [sym_lambda_expression] = STATE(950),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(1749),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(1749),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(1751),
    [sym_false] = ACTIONS(1751),
    [sym_null] = ACTIONS(1751),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(1751),
  },
  [347] = {
    [anon_sym_COMMA] = ACTIONS(1360),
    [anon_sym_RPAREN] = ACTIONS(1360),
    [anon_sym_SEMI] = ACTIONS(1360),
    [anon_sym_RBRACE] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(1360),
    [anon_sym_STAR] = ACTIONS(1362),
    [anon_sym_LBRACK] = ACTIONS(1360),
    [anon_sym_RBRACK] = ACTIONS(1360),
    [anon_sym_EQ] = ACTIONS(1362),
    [anon_sym_COLON] = ACTIONS(1360),
    [anon_sym_QMARK] = ACTIONS(1360),
    [anon_sym_STAR_EQ] = ACTIONS(1360),
    [anon_sym_SLASH_EQ] = ACTIONS(1360),
    [anon_sym_PERCENT_EQ] = ACTIONS(1360),
    [anon_sym_PLUS_EQ] = ACTIONS(1360),
    [anon_sym_DASH_EQ] = ACTIONS(1360),
    [anon_sym_LT_LT_EQ] = ACTIONS(1360),
    [anon_sym_GT_GT_EQ] = ACTIONS(1360),
    [anon_sym_AMP_EQ] = ACTIONS(1360),
    [anon_sym_CARET_EQ] = ACTIONS(1360),
    [anon_sym_PIPE_EQ] = ACTIONS(1360),
    [anon_sym_AMP] = ACTIONS(1362),
    [anon_sym_PIPE_PIPE] = ACTIONS(1360),
    [anon_sym_AMP_AMP] = ACTIONS(1360),
    [anon_sym_PIPE] = ACTIONS(1362),
    [anon_sym_CARET] = ACTIONS(1362),
    [anon_sym_EQ_EQ] = ACTIONS(1360),
    [anon_sym_BANG_EQ] = ACTIONS(1360),
    [anon_sym_LT] = ACTIONS(1362),
    [anon_sym_GT] = ACTIONS(1362),
    [anon_sym_LT_EQ] = ACTIONS(1360),
    [anon_sym_GT_EQ] = ACTIONS(1360),
    [anon_sym_LT_LT] = ACTIONS(1362),
    [anon_sym_GT_GT] = ACTIONS(1362),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_SLASH] = ACTIONS(1362),
    [anon_sym_PERCENT] = ACTIONS(1362),
    [anon_sym_DASH_DASH] = ACTIONS(1360),
    [anon_sym_PLUS_PLUS] = ACTIONS(1360),
    [anon_sym_DOT] = ACTIONS(1360),
    [anon_sym_DASH_GT] = ACTIONS(1360),
    [sym_comment] = ACTIONS(91),
  },
  [348] = {
    [sym_template_type] = STATE(953),
    [sym_template_method] = STATE(954),
    [sym_destructor_name] = STATE(954),
    [sym_scoped_field_identifier] = STATE(955),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(953),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(1753),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1755),
  },
  [349] = {
    [anon_sym_COMMA] = ACTIONS(1757),
    [anon_sym_RPAREN] = ACTIONS(1757),
    [anon_sym_SEMI] = ACTIONS(1757),
    [anon_sym_RBRACE] = ACTIONS(1757),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_STAR] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1757),
    [anon_sym_RBRACK] = ACTIONS(1757),
    [anon_sym_EQ] = ACTIONS(1759),
    [anon_sym_COLON] = ACTIONS(1757),
    [anon_sym_QMARK] = ACTIONS(1757),
    [anon_sym_STAR_EQ] = ACTIONS(1757),
    [anon_sym_SLASH_EQ] = ACTIONS(1757),
    [anon_sym_PERCENT_EQ] = ACTIONS(1757),
    [anon_sym_PLUS_EQ] = ACTIONS(1757),
    [anon_sym_DASH_EQ] = ACTIONS(1757),
    [anon_sym_LT_LT_EQ] = ACTIONS(1757),
    [anon_sym_GT_GT_EQ] = ACTIONS(1757),
    [anon_sym_AMP_EQ] = ACTIONS(1757),
    [anon_sym_CARET_EQ] = ACTIONS(1757),
    [anon_sym_PIPE_EQ] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1759),
    [anon_sym_PIPE_PIPE] = ACTIONS(1757),
    [anon_sym_AMP_AMP] = ACTIONS(1757),
    [anon_sym_PIPE] = ACTIONS(1759),
    [anon_sym_CARET] = ACTIONS(1759),
    [anon_sym_EQ_EQ] = ACTIONS(1757),
    [anon_sym_BANG_EQ] = ACTIONS(1757),
    [anon_sym_LT] = ACTIONS(1759),
    [anon_sym_GT] = ACTIONS(1759),
    [anon_sym_LT_EQ] = ACTIONS(1757),
    [anon_sym_GT_EQ] = ACTIONS(1757),
    [anon_sym_LT_LT] = ACTIONS(1759),
    [anon_sym_GT_GT] = ACTIONS(1759),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1759),
    [anon_sym_SLASH] = ACTIONS(1759),
    [anon_sym_PERCENT] = ACTIONS(1759),
    [anon_sym_DASH_DASH] = ACTIONS(1757),
    [anon_sym_PLUS_PLUS] = ACTIONS(1757),
    [anon_sym_DOT] = ACTIONS(1757),
    [anon_sym_DASH_GT] = ACTIONS(1757),
    [sym_comment] = ACTIONS(91),
  },
  [350] = {
    [sym_string_literal] = STATE(956),
    [aux_sym_concatenated_string_repeat1] = STATE(956),
    [anon_sym_COMMA] = ACTIONS(1761),
    [anon_sym_SEMI] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_EQ] = ACTIONS(1763),
    [anon_sym_QMARK] = ACTIONS(1761),
    [anon_sym_STAR_EQ] = ACTIONS(1761),
    [anon_sym_SLASH_EQ] = ACTIONS(1761),
    [anon_sym_PERCENT_EQ] = ACTIONS(1761),
    [anon_sym_PLUS_EQ] = ACTIONS(1761),
    [anon_sym_DASH_EQ] = ACTIONS(1761),
    [anon_sym_LT_LT_EQ] = ACTIONS(1761),
    [anon_sym_GT_GT_EQ] = ACTIONS(1761),
    [anon_sym_AMP_EQ] = ACTIONS(1761),
    [anon_sym_CARET_EQ] = ACTIONS(1761),
    [anon_sym_PIPE_EQ] = ACTIONS(1761),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_PIPE_PIPE] = ACTIONS(1761),
    [anon_sym_AMP_AMP] = ACTIONS(1761),
    [anon_sym_PIPE] = ACTIONS(1763),
    [anon_sym_CARET] = ACTIONS(1763),
    [anon_sym_EQ_EQ] = ACTIONS(1761),
    [anon_sym_BANG_EQ] = ACTIONS(1761),
    [anon_sym_LT] = ACTIONS(1763),
    [anon_sym_GT] = ACTIONS(1763),
    [anon_sym_LT_EQ] = ACTIONS(1761),
    [anon_sym_GT_EQ] = ACTIONS(1761),
    [anon_sym_LT_LT] = ACTIONS(1763),
    [anon_sym_GT_GT] = ACTIONS(1763),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_SLASH] = ACTIONS(1763),
    [anon_sym_PERCENT] = ACTIONS(1763),
    [anon_sym_DASH_DASH] = ACTIONS(1761),
    [anon_sym_PLUS_PLUS] = ACTIONS(1761),
    [anon_sym_DOT] = ACTIONS(1761),
    [anon_sym_DASH_GT] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(91),
  },
  [351] = {
    [sym_destructor_name] = STATE(958),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(1765),
    [sym_comment] = ACTIONS(91),
    [sym_operator_name] = ACTIONS(1767),
  },
  [352] = {
    [anon_sym_COMMA] = ACTIONS(1769),
    [anon_sym_RPAREN] = ACTIONS(1769),
    [anon_sym_SEMI] = ACTIONS(1769),
    [anon_sym_RBRACE] = ACTIONS(1769),
    [anon_sym_LPAREN2] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1771),
    [anon_sym_LBRACK] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(1769),
    [anon_sym_EQ] = ACTIONS(1771),
    [anon_sym_COLON] = ACTIONS(1769),
    [anon_sym_QMARK] = ACTIONS(1769),
    [anon_sym_STAR_EQ] = ACTIONS(1769),
    [anon_sym_SLASH_EQ] = ACTIONS(1769),
    [anon_sym_PERCENT_EQ] = ACTIONS(1769),
    [anon_sym_PLUS_EQ] = ACTIONS(1769),
    [anon_sym_DASH_EQ] = ACTIONS(1769),
    [anon_sym_LT_LT_EQ] = ACTIONS(1769),
    [anon_sym_GT_GT_EQ] = ACTIONS(1769),
    [anon_sym_AMP_EQ] = ACTIONS(1769),
    [anon_sym_CARET_EQ] = ACTIONS(1769),
    [anon_sym_PIPE_EQ] = ACTIONS(1769),
    [anon_sym_AMP] = ACTIONS(1771),
    [anon_sym_PIPE_PIPE] = ACTIONS(1769),
    [anon_sym_AMP_AMP] = ACTIONS(1769),
    [anon_sym_PIPE] = ACTIONS(1771),
    [anon_sym_CARET] = ACTIONS(1771),
    [anon_sym_EQ_EQ] = ACTIONS(1769),
    [anon_sym_BANG_EQ] = ACTIONS(1769),
    [anon_sym_LT] = ACTIONS(1771),
    [anon_sym_GT] = ACTIONS(1771),
    [anon_sym_LT_EQ] = ACTIONS(1769),
    [anon_sym_GT_EQ] = ACTIONS(1769),
    [anon_sym_LT_LT] = ACTIONS(1771),
    [anon_sym_GT_GT] = ACTIONS(1771),
    [anon_sym_PLUS] = ACTIONS(1771),
    [anon_sym_DASH] = ACTIONS(1771),
    [anon_sym_SLASH] = ACTIONS(1771),
    [anon_sym_PERCENT] = ACTIONS(1771),
    [anon_sym_DASH_DASH] = ACTIONS(1769),
    [anon_sym_PLUS_PLUS] = ACTIONS(1769),
    [anon_sym_DOT] = ACTIONS(1769),
    [anon_sym_DASH_GT] = ACTIONS(1769),
    [sym_comment] = ACTIONS(91),
  },
  [353] = {
    [sym__declaration_specifiers] = STATE(905),
    [sym__abstract_declarator] = STATE(959),
    [sym_abstract_pointer_declarator] = STATE(959),
    [sym_abstract_function_declarator] = STATE(959),
    [sym_abstract_array_declarator] = STATE(959),
    [sym_storage_class_specifier] = STATE(907),
    [sym_type_qualifier] = STATE(907),
    [sym__type_specifier] = STATE(906),
    [sym_sized_type_specifier] = STATE(906),
    [sym_enum_specifier] = STATE(906),
    [sym_struct_specifier] = STATE(906),
    [sym_union_specifier] = STATE(906),
    [sym_parameter_list] = STATE(528),
    [sym_parameter_declaration] = STATE(902),
    [sym_macro_type_specifier] = STATE(906),
    [sym_class_specifier] = STATE(906),
    [sym_dependent_type] = STATE(906),
    [sym_abstract_reference_declarator] = STATE(959),
    [sym_template_type] = STATE(272),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(180),
    [aux_sym__declaration_specifiers_repeat1] = STATE(907),
    [aux_sym_sized_type_specifier_repeat1] = STATE(908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1625),
    [anon_sym_RPAREN] = ACTIONS(1627),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(1629),
    [anon_sym_long] = ACTIONS(1629),
    [anon_sym_short] = ACTIONS(1629),
    [sym_primitive_type] = ACTIONS(1631),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_AMP_AMP] = ACTIONS(893),
    [sym_identifier] = ACTIONS(492),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(1631),
    [anon_sym_typename] = ACTIONS(1633),
    [anon_sym_COLON_COLON] = ACTIONS(315),
  },
  [354] = {
    [sym__abstract_declarator] = STATE(960),
    [sym_abstract_pointer_declarator] = STATE(960),
    [sym_abstract_function_declarator] = STATE(960),
    [sym_abstract_array_declarator] = STATE(960),
    [sym_type_qualifier] = STATE(962),
    [sym_parameter_list] = STATE(961),
    [sym_abstract_reference_declarator] = STATE(960),
    [aux_sym_type_definition_repeat1] = STATE(962),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(639),
    [anon_sym_AMP_AMP] = ACTIONS(641),
    [sym_comment] = ACTIONS(91),
  },
  [355] = {
    [sym_type_qualifier] = STATE(966),
    [sym__expression] = STATE(965),
    [sym_conditional_expression] = STATE(965),
    [sym_assignment_expression] = STATE(965),
    [sym_pointer_expression] = STATE(965),
    [sym_logical_expression] = STATE(965),
    [sym_bitwise_expression] = STATE(965),
    [sym_equality_expression] = STATE(965),
    [sym_relational_expression] = STATE(965),
    [sym_shift_expression] = STATE(965),
    [sym_math_expression] = STATE(965),
    [sym_cast_expression] = STATE(965),
    [sym_sizeof_expression] = STATE(965),
    [sym_subscript_expression] = STATE(965),
    [sym_call_expression] = STATE(965),
    [sym_field_expression] = STATE(965),
    [sym_compound_literal_expression] = STATE(965),
    [sym_parenthesized_expression] = STATE(965),
    [sym_char_literal] = STATE(965),
    [sym_concatenated_string] = STATE(965),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(965),
    [sym_new_expression] = STATE(965),
    [sym_delete_expression] = STATE(965),
    [sym_lambda_expression] = STATE(965),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [aux_sym_type_definition_repeat1] = STATE(966),
    [sym_raw_string_literal] = ACTIONS(1775),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(1779),
    [anon_sym_const] = ACTIONS(1643),
    [anon_sym_restrict] = ACTIONS(1643),
    [anon_sym_volatile] = ACTIONS(1643),
    [anon_sym__Atomic] = ACTIONS(1643),
    [anon_sym_mutable] = ACTIONS(1643),
    [anon_sym_explicit] = ACTIONS(1643),
    [anon_sym_constexpr] = ACTIONS(1643),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(1775),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(1781),
    [sym_false] = ACTIONS(1781),
    [sym_null] = ACTIONS(1781),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(1781),
  },
  [356] = {
    [sym__abstract_declarator] = STATE(960),
    [sym_abstract_pointer_declarator] = STATE(960),
    [sym_abstract_function_declarator] = STATE(960),
    [sym_abstract_array_declarator] = STATE(960),
    [sym_parameter_list] = STATE(961),
    [sym_abstract_reference_declarator] = STATE(960),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_AMP] = ACTIONS(639),
    [anon_sym_AMP_AMP] = ACTIONS(641),
    [sym_comment] = ACTIONS(91),
  },
  [357] = {
    [sym_parameter_list] = STATE(968),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [sym_comment] = ACTIONS(91),
  },
  [358] = {
    [sym_compound_statement] = STATE(969),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_LPAREN2] = ACTIONS(1785),
    [anon_sym_LBRACK] = ACTIONS(1785),
    [sym_comment] = ACTIONS(91),
  },
  [359] = {
    [sym_type_qualifier] = STATE(972),
    [sym_trailing_return_type] = STATE(971),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(972),
    [anon_sym_LBRACE] = ACTIONS(1787),
    [anon_sym_LPAREN2] = ACTIONS(1787),
    [anon_sym_LBRACK] = ACTIONS(1787),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(1789),
    [sym_comment] = ACTIONS(91),
    [sym_noexcept] = ACTIONS(1791),
  },
  [360] = {
    [anon_sym_COMMA] = ACTIONS(1424),
    [anon_sym_RPAREN] = ACTIONS(1424),
    [anon_sym_SEMI] = ACTIONS(1424),
    [anon_sym_LBRACE] = ACTIONS(1424),
    [anon_sym_RBRACE] = ACTIONS(1424),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_STAR] = ACTIONS(1436),
    [anon_sym_LBRACK] = ACTIONS(1424),
    [anon_sym_RBRACK] = ACTIONS(1424),
    [anon_sym_EQ] = ACTIONS(1436),
    [anon_sym_COLON] = ACTIONS(1424),
    [anon_sym_QMARK] = ACTIONS(1424),
    [anon_sym_STAR_EQ] = ACTIONS(1424),
    [anon_sym_SLASH_EQ] = ACTIONS(1424),
    [anon_sym_PERCENT_EQ] = ACTIONS(1424),
    [anon_sym_PLUS_EQ] = ACTIONS(1424),
    [anon_sym_DASH_EQ] = ACTIONS(1424),
    [anon_sym_LT_LT_EQ] = ACTIONS(1424),
    [anon_sym_GT_GT_EQ] = ACTIONS(1424),
    [anon_sym_AMP_EQ] = ACTIONS(1424),
    [anon_sym_CARET_EQ] = ACTIONS(1424),
    [anon_sym_PIPE_EQ] = ACTIONS(1424),
    [anon_sym_AMP] = ACTIONS(1436),
    [anon_sym_PIPE_PIPE] = ACTIONS(1424),
    [anon_sym_AMP_AMP] = ACTIONS(1424),
    [anon_sym_PIPE] = ACTIONS(1436),
    [anon_sym_CARET] = ACTIONS(1436),
    [anon_sym_EQ_EQ] = ACTIONS(1424),
    [anon_sym_BANG_EQ] = ACTIONS(1424),
    [anon_sym_LT] = ACTIONS(1436),
    [anon_sym_GT] = ACTIONS(1436),
    [anon_sym_LT_EQ] = ACTIONS(1424),
    [anon_sym_GT_EQ] = ACTIONS(1424),
    [anon_sym_LT_LT] = ACTIONS(1436),
    [anon_sym_GT_GT] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1436),
    [anon_sym_DASH] = ACTIONS(1436),
    [anon_sym_SLASH] = ACTIONS(1436),
    [anon_sym_PERCENT] = ACTIONS(1436),
    [anon_sym_DASH_DASH] = ACTIONS(1424),
    [anon_sym_PLUS_PLUS] = ACTIONS(1424),
    [anon_sym_DOT] = ACTIONS(1424),
    [anon_sym_DASH_GT] = ACTIONS(1424),
    [sym_comment] = ACTIONS(91),
  },
  [361] = {
    [sym_type_qualifier] = STATE(786),
    [sym__type_specifier] = STATE(777),
    [sym_sized_type_specifier] = STATE(777),
    [sym_enum_specifier] = STATE(777),
    [sym_struct_specifier] = STATE(777),
    [sym_union_specifier] = STATE(777),
    [sym__expression] = STATE(974),
    [sym_conditional_expression] = STATE(974),
    [sym_assignment_expression] = STATE(974),
    [sym_pointer_expression] = STATE(974),
    [sym_logical_expression] = STATE(974),
    [sym_bitwise_expression] = STATE(974),
    [sym_equality_expression] = STATE(974),
    [sym_relational_expression] = STATE(974),
    [sym_shift_expression] = STATE(974),
    [sym_math_expression] = STATE(974),
    [sym_cast_expression] = STATE(974),
    [sym_type_descriptor] = STATE(975),
    [sym_sizeof_expression] = STATE(974),
    [sym_subscript_expression] = STATE(974),
    [sym_call_expression] = STATE(974),
    [sym_field_expression] = STATE(974),
    [sym_compound_literal_expression] = STATE(974),
    [sym_parenthesized_expression] = STATE(974),
    [sym_char_literal] = STATE(974),
    [sym_concatenated_string] = STATE(974),
    [sym_string_literal] = STATE(780),
    [sym_macro_type_specifier] = STATE(777),
    [sym_class_specifier] = STATE(777),
    [sym_dependent_type] = STATE(777),
    [sym_template_type] = STATE(781),
    [sym_template_function] = STATE(974),
    [sym_new_expression] = STATE(974),
    [sym_delete_expression] = STATE(974),
    [sym_lambda_expression] = STATE(974),
    [sym_lambda_capture_specifier] = STATE(782),
    [sym_scoped_identifier] = STATE(783),
    [sym_scoped_type_identifier] = STATE(784),
    [sym_scoped_namespace_identifier] = STATE(785),
    [aux_sym_type_definition_repeat1] = STATE(786),
    [aux_sym_sized_type_specifier_repeat1] = STATE(787),
    [sym_raw_string_literal] = ACTIONS(1793),
    [anon_sym_LPAREN2] = ACTIONS(1380),
    [anon_sym_STAR] = ACTIONS(1382),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(1384),
    [anon_sym_long] = ACTIONS(1384),
    [anon_sym_short] = ACTIONS(1384),
    [sym_primitive_type] = ACTIONS(1386),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [anon_sym_AMP] = ACTIONS(1382),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1394),
    [anon_sym_PLUS_PLUS] = ACTIONS(1394),
    [anon_sym_sizeof] = ACTIONS(1396),
    [sym_number_literal] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_true] = ACTIONS(1795),
    [sym_false] = ACTIONS(1795),
    [sym_null] = ACTIONS(1795),
    [sym_identifier] = ACTIONS(1404),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(1386),
    [anon_sym_typename] = ACTIONS(1406),
    [anon_sym_GT2] = ACTIONS(1797),
    [anon_sym_delete] = ACTIONS(1410),
    [anon_sym_new] = ACTIONS(1412),
    [anon_sym_COLON_COLON] = ACTIONS(1414),
    [sym_nullptr] = ACTIONS(1795),
  },
  [362] = {
    [anon_sym_COMMA] = ACTIONS(1799),
    [anon_sym_RPAREN] = ACTIONS(1799),
    [anon_sym_SEMI] = ACTIONS(1799),
    [anon_sym_extern] = ACTIONS(1801),
    [anon_sym_LBRACE] = ACTIONS(1799),
    [anon_sym_LPAREN2] = ACTIONS(1799),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_LBRACK] = ACTIONS(1799),
    [anon_sym_EQ] = ACTIONS(1799),
    [anon_sym_static] = ACTIONS(1801),
    [anon_sym_register] = ACTIONS(1801),
    [anon_sym_inline] = ACTIONS(1801),
    [anon_sym_const] = ACTIONS(1801),
    [anon_sym_restrict] = ACTIONS(1801),
    [anon_sym_volatile] = ACTIONS(1801),
    [anon_sym__Atomic] = ACTIONS(1801),
    [anon_sym_mutable] = ACTIONS(1801),
    [anon_sym_explicit] = ACTIONS(1801),
    [anon_sym_constexpr] = ACTIONS(1801),
    [anon_sym_COLON] = ACTIONS(1801),
    [anon_sym_AMP] = ACTIONS(1801),
    [anon_sym_AMP_AMP] = ACTIONS(1799),
    [anon_sym_TILDE] = ACTIONS(1799),
    [anon_sym_DASH_GT] = ACTIONS(1799),
    [sym_identifier] = ACTIONS(1801),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1801),
    [anon_sym_override] = ACTIONS(1801),
    [anon_sym_GT2] = ACTIONS(1799),
    [sym_noexcept] = ACTIONS(1801),
    [anon_sym_COLON_COLON] = ACTIONS(1799),
    [sym_operator_name] = ACTIONS(1799),
  },
  [363] = {
    [sym_preproc_include] = STATE(363),
    [sym_preproc_def] = STATE(363),
    [sym_preproc_function_def] = STATE(363),
    [sym_preproc_call] = STATE(363),
    [sym_preproc_if] = STATE(363),
    [sym_preproc_ifdef] = STATE(363),
    [sym_function_definition] = STATE(363),
    [sym_declaration] = STATE(363),
    [sym_type_definition] = STATE(363),
    [sym__declaration_specifiers] = STATE(49),
    [sym_linkage_specification] = STATE(363),
    [sym__declarator] = STATE(50),
    [sym_pointer_declarator] = STATE(50),
    [sym_function_declarator] = STATE(51),
    [sym_array_declarator] = STATE(50),
    [sym_compound_statement] = STATE(363),
    [sym_storage_class_specifier] = STATE(63),
    [sym_type_qualifier] = STATE(63),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(363),
    [sym_expression_statement] = STATE(363),
    [sym_if_statement] = STATE(363),
    [sym_switch_statement] = STATE(363),
    [sym_case_statement] = STATE(363),
    [sym_while_statement] = STATE(363),
    [sym_do_statement] = STATE(363),
    [sym_for_statement] = STATE(363),
    [sym_return_statement] = STATE(363),
    [sym_break_statement] = STATE(363),
    [sym_continue_statement] = STATE(363),
    [sym_goto_statement] = STATE(363),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(363),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(363),
    [sym_template_declaration] = STATE(363),
    [sym_template_instantiation] = STATE(363),
    [sym_constructor_or_destructor_definition] = STATE(363),
    [sym_reference_declarator] = STATE(50),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(57),
    [sym_namespace_definition] = STATE(363),
    [sym_using_declaration] = STATE(363),
    [sym_alias_declaration] = STATE(363),
    [sym_for_range_loop] = STATE(363),
    [sym_try_statement] = STATE(363),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_destructor_name] = STATE(50),
    [sym_scoped_identifier] = STATE(59),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_translation_unit_repeat1] = STATE(363),
    [aux_sym__declaration_specifiers_repeat1] = STATE(63),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(1803),
    [ts_builtin_sym_end] = ACTIONS(1806),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1808),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1811),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1814),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1817),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1817),
    [sym_preproc_directive] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(1823),
    [anon_sym_typedef] = ACTIONS(1826),
    [anon_sym_extern] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(1832),
    [anon_sym_LPAREN2] = ACTIONS(1835),
    [anon_sym_STAR] = ACTIONS(1838),
    [anon_sym_LBRACK] = ACTIONS(1841),
    [anon_sym_static] = ACTIONS(1844),
    [anon_sym_register] = ACTIONS(1844),
    [anon_sym_inline] = ACTIONS(1844),
    [anon_sym_const] = ACTIONS(1847),
    [anon_sym_restrict] = ACTIONS(1847),
    [anon_sym_volatile] = ACTIONS(1847),
    [anon_sym__Atomic] = ACTIONS(1847),
    [anon_sym_mutable] = ACTIONS(1847),
    [anon_sym_explicit] = ACTIONS(1847),
    [anon_sym_constexpr] = ACTIONS(1847),
    [anon_sym_unsigned] = ACTIONS(1850),
    [anon_sym_long] = ACTIONS(1850),
    [anon_sym_short] = ACTIONS(1850),
    [sym_primitive_type] = ACTIONS(1853),
    [anon_sym_enum] = ACTIONS(1856),
    [anon_sym_struct] = ACTIONS(1859),
    [anon_sym_union] = ACTIONS(1862),
    [anon_sym_if] = ACTIONS(1865),
    [anon_sym_switch] = ACTIONS(1868),
    [anon_sym_case] = ACTIONS(1871),
    [anon_sym_default] = ACTIONS(1874),
    [anon_sym_while] = ACTIONS(1877),
    [anon_sym_do] = ACTIONS(1880),
    [anon_sym_for] = ACTIONS(1883),
    [anon_sym_return] = ACTIONS(1886),
    [anon_sym_break] = ACTIONS(1889),
    [anon_sym_continue] = ACTIONS(1892),
    [anon_sym_goto] = ACTIONS(1895),
    [anon_sym_AMP] = ACTIONS(1898),
    [anon_sym_AMP_AMP] = ACTIONS(1901),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1907),
    [anon_sym_PLUS] = ACTIONS(1910),
    [anon_sym_DASH] = ACTIONS(1910),
    [anon_sym_DASH_DASH] = ACTIONS(1913),
    [anon_sym_PLUS_PLUS] = ACTIONS(1913),
    [anon_sym_sizeof] = ACTIONS(1916),
    [sym_number_literal] = ACTIONS(1803),
    [anon_sym_SQUOTE] = ACTIONS(1919),
    [anon_sym_DQUOTE] = ACTIONS(1922),
    [sym_true] = ACTIONS(1925),
    [sym_false] = ACTIONS(1925),
    [sym_null] = ACTIONS(1925),
    [sym_identifier] = ACTIONS(1928),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1931),
    [sym_auto] = ACTIONS(1853),
    [anon_sym_typename] = ACTIONS(1934),
    [anon_sym_template] = ACTIONS(1937),
    [anon_sym_delete] = ACTIONS(1940),
    [anon_sym_namespace] = ACTIONS(1943),
    [anon_sym_using] = ACTIONS(1946),
    [anon_sym_try] = ACTIONS(1949),
    [anon_sym_new] = ACTIONS(1952),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [sym_operator_name] = ACTIONS(1958),
    [sym_nullptr] = ACTIONS(1925),
  },
  [364] = {
    [sym_template_argument_list] = STATE(977),
    [anon_sym_COMMA] = ACTIONS(481),
    [anon_sym_RPAREN] = ACTIONS(1464),
    [anon_sym_SEMI] = ACTIONS(481),
    [anon_sym_extern] = ACTIONS(468),
    [anon_sym_LPAREN2] = ACTIONS(1464),
    [anon_sym_STAR] = ACTIONS(481),
    [anon_sym_LBRACK] = ACTIONS(1464),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_register] = ACTIONS(468),
    [anon_sym_inline] = ACTIONS(468),
    [anon_sym_const] = ACTIONS(468),
    [anon_sym_restrict] = ACTIONS(468),
    [anon_sym_volatile] = ACTIONS(468),
    [anon_sym__Atomic] = ACTIONS(468),
    [anon_sym_mutable] = ACTIONS(468),
    [anon_sym_explicit] = ACTIONS(468),
    [anon_sym_constexpr] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(468),
    [anon_sym_AMP_AMP] = ACTIONS(481),
    [anon_sym_TILDE] = ACTIONS(481),
    [anon_sym_LT] = ACTIONS(643),
    [sym_identifier] = ACTIONS(468),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1961),
    [sym_operator_name] = ACTIONS(481),
  },
  [365] = {
    [sym_destructor_name] = STATE(315),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(1963),
    [sym_comment] = ACTIONS(91),
    [sym_operator_name] = ACTIONS(554),
  },
  [366] = {
    [sym_compound_statement] = STATE(934),
    [sym_field_initializer_list] = STATE(979),
    [sym_default_method_clause] = STATE(934),
    [sym_delete_method_clause] = STATE(934),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(576),
    [anon_sym_LBRACK] = ACTIONS(576),
    [anon_sym_EQ] = ACTIONS(578),
    [anon_sym_COLON] = ACTIONS(580),
    [sym_comment] = ACTIONS(91),
  },
  [367] = {
    [sym_storage_class_specifier] = STATE(980),
    [sym_type_qualifier] = STATE(980),
    [aux_sym__declaration_specifiers_repeat1] = STATE(980),
    [anon_sym_SEMI] = ACTIONS(1689),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_LPAREN2] = ACTIONS(1689),
    [anon_sym_STAR] = ACTIONS(1689),
    [anon_sym_LBRACK] = ACTIONS(1689),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(1691),
    [anon_sym_AMP_AMP] = ACTIONS(1689),
    [anon_sym_TILDE] = ACTIONS(1689),
    [sym_identifier] = ACTIONS(1691),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1689),
    [sym_operator_name] = ACTIONS(1689),
  },
  [368] = {
    [anon_sym_COMMA] = ACTIONS(624),
    [anon_sym_RPAREN] = ACTIONS(624),
    [anon_sym_SEMI] = ACTIONS(624),
    [anon_sym_extern] = ACTIONS(626),
    [anon_sym_LPAREN2] = ACTIONS(624),
    [anon_sym_STAR] = ACTIONS(624),
    [anon_sym_LBRACK] = ACTIONS(624),
    [anon_sym_static] = ACTIONS(626),
    [anon_sym_register] = ACTIONS(626),
    [anon_sym_inline] = ACTIONS(626),
    [anon_sym_const] = ACTIONS(626),
    [anon_sym_restrict] = ACTIONS(626),
    [anon_sym_volatile] = ACTIONS(626),
    [anon_sym__Atomic] = ACTIONS(626),
    [anon_sym_mutable] = ACTIONS(626),
    [anon_sym_explicit] = ACTIONS(626),
    [anon_sym_constexpr] = ACTIONS(626),
    [anon_sym_AMP] = ACTIONS(626),
    [anon_sym_AMP_AMP] = ACTIONS(624),
    [anon_sym_TILDE] = ACTIONS(624),
    [sym_identifier] = ACTIONS(626),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1965),
    [sym_operator_name] = ACTIONS(624),
  },
  [369] = {
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1965),
  },
  [370] = {
    [sym_storage_class_specifier] = STATE(370),
    [sym_type_qualifier] = STATE(370),
    [aux_sym__declaration_specifiers_repeat1] = STATE(370),
    [anon_sym_extern] = ACTIONS(1967),
    [anon_sym_LPAREN2] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(1970),
    [anon_sym_static] = ACTIONS(1967),
    [anon_sym_register] = ACTIONS(1967),
    [anon_sym_inline] = ACTIONS(1967),
    [anon_sym_const] = ACTIONS(1972),
    [anon_sym_restrict] = ACTIONS(1972),
    [anon_sym_volatile] = ACTIONS(1972),
    [anon_sym__Atomic] = ACTIONS(1972),
    [anon_sym_mutable] = ACTIONS(1972),
    [anon_sym_explicit] = ACTIONS(1972),
    [anon_sym_constexpr] = ACTIONS(1972),
    [anon_sym_unsigned] = ACTIONS(1975),
    [anon_sym_long] = ACTIONS(1975),
    [anon_sym_short] = ACTIONS(1975),
    [sym_primitive_type] = ACTIONS(1975),
    [anon_sym_enum] = ACTIONS(1975),
    [anon_sym_struct] = ACTIONS(1975),
    [anon_sym_union] = ACTIONS(1975),
    [anon_sym_AMP] = ACTIONS(1975),
    [anon_sym_AMP_AMP] = ACTIONS(1970),
    [anon_sym_TILDE] = ACTIONS(1970),
    [sym_identifier] = ACTIONS(1975),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1975),
    [sym_auto] = ACTIONS(1975),
    [anon_sym_typename] = ACTIONS(1975),
    [anon_sym_COLON_COLON] = ACTIONS(1970),
    [sym_operator_name] = ACTIONS(1970),
  },
  [371] = {
    [anon_sym_COMMA] = ACTIONS(1977),
    [anon_sym_RPAREN] = ACTIONS(1977),
    [anon_sym_SEMI] = ACTIONS(1977),
    [anon_sym_extern] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1977),
    [anon_sym_LPAREN2] = ACTIONS(1977),
    [anon_sym_STAR] = ACTIONS(1977),
    [anon_sym_LBRACK] = ACTIONS(1977),
    [anon_sym_EQ] = ACTIONS(1977),
    [anon_sym_static] = ACTIONS(1979),
    [anon_sym_register] = ACTIONS(1979),
    [anon_sym_inline] = ACTIONS(1979),
    [anon_sym_const] = ACTIONS(1979),
    [anon_sym_restrict] = ACTIONS(1979),
    [anon_sym_volatile] = ACTIONS(1979),
    [anon_sym__Atomic] = ACTIONS(1979),
    [anon_sym_mutable] = ACTIONS(1979),
    [anon_sym_explicit] = ACTIONS(1979),
    [anon_sym_constexpr] = ACTIONS(1979),
    [anon_sym_COLON] = ACTIONS(1979),
    [anon_sym_AMP] = ACTIONS(1979),
    [anon_sym_AMP_AMP] = ACTIONS(1977),
    [anon_sym_TILDE] = ACTIONS(1977),
    [anon_sym_DASH_GT] = ACTIONS(1977),
    [sym_identifier] = ACTIONS(1979),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1979),
    [anon_sym_override] = ACTIONS(1979),
    [anon_sym_GT2] = ACTIONS(1977),
    [sym_noexcept] = ACTIONS(1979),
    [anon_sym_COLON_COLON] = ACTIONS(1977),
    [sym_operator_name] = ACTIONS(1977),
  },
  [372] = {
    [anon_sym_COMMA] = ACTIONS(1981),
    [anon_sym_RPAREN] = ACTIONS(1981),
    [anon_sym_SEMI] = ACTIONS(1981),
    [anon_sym_extern] = ACTIONS(1983),
    [anon_sym_LBRACE] = ACTIONS(1981),
    [anon_sym_LPAREN2] = ACTIONS(1981),
    [anon_sym_STAR] = ACTIONS(1981),
    [anon_sym_LBRACK] = ACTIONS(1981),
    [anon_sym_EQ] = ACTIONS(1981),
    [anon_sym_static] = ACTIONS(1983),
    [anon_sym_register] = ACTIONS(1983),
    [anon_sym_inline] = ACTIONS(1983),
    [anon_sym_const] = ACTIONS(1983),
    [anon_sym_restrict] = ACTIONS(1983),
    [anon_sym_volatile] = ACTIONS(1983),
    [anon_sym__Atomic] = ACTIONS(1983),
    [anon_sym_mutable] = ACTIONS(1983),
    [anon_sym_explicit] = ACTIONS(1983),
    [anon_sym_constexpr] = ACTIONS(1983),
    [anon_sym_COLON] = ACTIONS(1983),
    [anon_sym_AMP] = ACTIONS(1983),
    [anon_sym_AMP_AMP] = ACTIONS(1981),
    [anon_sym_TILDE] = ACTIONS(1981),
    [anon_sym_DASH_GT] = ACTIONS(1981),
    [sym_identifier] = ACTIONS(1983),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1983),
    [anon_sym_override] = ACTIONS(1983),
    [anon_sym_GT2] = ACTIONS(1981),
    [sym_noexcept] = ACTIONS(1983),
    [anon_sym_COLON_COLON] = ACTIONS(1981),
    [sym_operator_name] = ACTIONS(1981),
  },
  [373] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(373),
    [anon_sym_SEMI] = ACTIONS(1985),
    [anon_sym_extern] = ACTIONS(1987),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1985),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_static] = ACTIONS(1987),
    [anon_sym_register] = ACTIONS(1987),
    [anon_sym_inline] = ACTIONS(1987),
    [anon_sym_const] = ACTIONS(1987),
    [anon_sym_restrict] = ACTIONS(1987),
    [anon_sym_volatile] = ACTIONS(1987),
    [anon_sym__Atomic] = ACTIONS(1987),
    [anon_sym_mutable] = ACTIONS(1987),
    [anon_sym_explicit] = ACTIONS(1987),
    [anon_sym_constexpr] = ACTIONS(1987),
    [anon_sym_unsigned] = ACTIONS(1989),
    [anon_sym_long] = ACTIONS(1989),
    [anon_sym_short] = ACTIONS(1989),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1985),
    [sym_operator_name] = ACTIONS(1985),
  },
  [374] = {
    [sym_raw_string_literal] = ACTIONS(1370),
    [ts_builtin_sym_end] = ACTIONS(1370),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1372),
    [sym_preproc_directive] = ACTIONS(1372),
    [anon_sym_SEMI] = ACTIONS(1370),
    [anon_sym_typedef] = ACTIONS(1372),
    [anon_sym_extern] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1370),
    [anon_sym_RBRACE] = ACTIONS(1370),
    [anon_sym_LPAREN2] = ACTIONS(1370),
    [anon_sym_STAR] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(1370),
    [anon_sym_static] = ACTIONS(1372),
    [anon_sym_register] = ACTIONS(1372),
    [anon_sym_inline] = ACTIONS(1372),
    [anon_sym_const] = ACTIONS(1372),
    [anon_sym_restrict] = ACTIONS(1372),
    [anon_sym_volatile] = ACTIONS(1372),
    [anon_sym__Atomic] = ACTIONS(1372),
    [anon_sym_mutable] = ACTIONS(1372),
    [anon_sym_explicit] = ACTIONS(1372),
    [anon_sym_constexpr] = ACTIONS(1372),
    [anon_sym_unsigned] = ACTIONS(1372),
    [anon_sym_long] = ACTIONS(1372),
    [anon_sym_short] = ACTIONS(1372),
    [sym_primitive_type] = ACTIONS(1372),
    [anon_sym_enum] = ACTIONS(1372),
    [anon_sym_struct] = ACTIONS(1372),
    [anon_sym_union] = ACTIONS(1372),
    [anon_sym_if] = ACTIONS(1372),
    [anon_sym_switch] = ACTIONS(1372),
    [anon_sym_case] = ACTIONS(1372),
    [anon_sym_default] = ACTIONS(1372),
    [anon_sym_while] = ACTIONS(1372),
    [anon_sym_do] = ACTIONS(1372),
    [anon_sym_for] = ACTIONS(1372),
    [anon_sym_return] = ACTIONS(1372),
    [anon_sym_break] = ACTIONS(1372),
    [anon_sym_continue] = ACTIONS(1372),
    [anon_sym_goto] = ACTIONS(1372),
    [anon_sym_AMP] = ACTIONS(1372),
    [anon_sym_AMP_AMP] = ACTIONS(1370),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_PLUS] = ACTIONS(1372),
    [anon_sym_DASH] = ACTIONS(1372),
    [anon_sym_DASH_DASH] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1370),
    [anon_sym_sizeof] = ACTIONS(1372),
    [sym_number_literal] = ACTIONS(1370),
    [anon_sym_SQUOTE] = ACTIONS(1370),
    [anon_sym_DQUOTE] = ACTIONS(1370),
    [sym_true] = ACTIONS(1372),
    [sym_false] = ACTIONS(1372),
    [sym_null] = ACTIONS(1372),
    [sym_identifier] = ACTIONS(1372),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1372),
    [sym_auto] = ACTIONS(1372),
    [anon_sym_typename] = ACTIONS(1372),
    [anon_sym_template] = ACTIONS(1372),
    [anon_sym_delete] = ACTIONS(1372),
    [anon_sym_namespace] = ACTIONS(1372),
    [anon_sym_using] = ACTIONS(1372),
    [anon_sym_try] = ACTIONS(1372),
    [anon_sym_new] = ACTIONS(1372),
    [anon_sym_COLON_COLON] = ACTIONS(1370),
    [sym_operator_name] = ACTIONS(1370),
    [sym_nullptr] = ACTIONS(1372),
  },
  [375] = {
    [aux_sym_string_literal_repeat1] = STATE(761),
    [anon_sym_DQUOTE] = ACTIONS(1992),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_BSLASHn_RBRACK_SLASH] = ACTIONS(1376),
    [sym_escape_sequence] = ACTIONS(1376),
    [sym_comment] = ACTIONS(121),
  },
  [376] = {
    [sym_raw_string_literal] = ACTIONS(1994),
    [ts_builtin_sym_end] = ACTIONS(1994),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1996),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1996),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1996),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1996),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1996),
    [sym_preproc_directive] = ACTIONS(1996),
    [anon_sym_SEMI] = ACTIONS(1994),
    [anon_sym_typedef] = ACTIONS(1996),
    [anon_sym_extern] = ACTIONS(1996),
    [anon_sym_LBRACE] = ACTIONS(1994),
    [anon_sym_RBRACE] = ACTIONS(1994),
    [anon_sym_LPAREN2] = ACTIONS(1994),
    [anon_sym_STAR] = ACTIONS(1994),
    [anon_sym_LBRACK] = ACTIONS(1994),
    [anon_sym_static] = ACTIONS(1996),
    [anon_sym_register] = ACTIONS(1996),
    [anon_sym_inline] = ACTIONS(1996),
    [anon_sym_const] = ACTIONS(1996),
    [anon_sym_restrict] = ACTIONS(1996),
    [anon_sym_volatile] = ACTIONS(1996),
    [anon_sym__Atomic] = ACTIONS(1996),
    [anon_sym_mutable] = ACTIONS(1996),
    [anon_sym_explicit] = ACTIONS(1996),
    [anon_sym_constexpr] = ACTIONS(1996),
    [anon_sym_unsigned] = ACTIONS(1996),
    [anon_sym_long] = ACTIONS(1996),
    [anon_sym_short] = ACTIONS(1996),
    [sym_primitive_type] = ACTIONS(1996),
    [anon_sym_enum] = ACTIONS(1996),
    [anon_sym_struct] = ACTIONS(1996),
    [anon_sym_union] = ACTIONS(1996),
    [anon_sym_if] = ACTIONS(1996),
    [anon_sym_switch] = ACTIONS(1996),
    [anon_sym_case] = ACTIONS(1996),
    [anon_sym_default] = ACTIONS(1996),
    [anon_sym_while] = ACTIONS(1996),
    [anon_sym_do] = ACTIONS(1996),
    [anon_sym_for] = ACTIONS(1996),
    [anon_sym_return] = ACTIONS(1996),
    [anon_sym_break] = ACTIONS(1996),
    [anon_sym_continue] = ACTIONS(1996),
    [anon_sym_goto] = ACTIONS(1996),
    [anon_sym_AMP] = ACTIONS(1996),
    [anon_sym_AMP_AMP] = ACTIONS(1994),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_PLUS] = ACTIONS(1996),
    [anon_sym_DASH] = ACTIONS(1996),
    [anon_sym_DASH_DASH] = ACTIONS(1994),
    [anon_sym_PLUS_PLUS] = ACTIONS(1994),
    [anon_sym_sizeof] = ACTIONS(1996),
    [sym_number_literal] = ACTIONS(1994),
    [anon_sym_SQUOTE] = ACTIONS(1994),
    [anon_sym_DQUOTE] = ACTIONS(1994),
    [sym_true] = ACTIONS(1996),
    [sym_false] = ACTIONS(1996),
    [sym_null] = ACTIONS(1996),
    [sym_identifier] = ACTIONS(1996),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1996),
    [sym_auto] = ACTIONS(1996),
    [anon_sym_typename] = ACTIONS(1996),
    [anon_sym_template] = ACTIONS(1996),
    [anon_sym_delete] = ACTIONS(1996),
    [anon_sym_namespace] = ACTIONS(1996),
    [anon_sym_using] = ACTIONS(1996),
    [anon_sym_try] = ACTIONS(1996),
    [anon_sym_new] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1994),
    [sym_operator_name] = ACTIONS(1994),
    [sym_nullptr] = ACTIONS(1996),
  },
  [377] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1998),
    [anon_sym_RPAREN] = ACTIONS(2000),
    [sym_identifier] = ACTIONS(1998),
    [sym_comment] = ACTIONS(91),
  },
  [378] = {
    [anon_sym_LF] = ACTIONS(2002),
    [sym_comment] = ACTIONS(121),
  },
  [379] = {
    [anon_sym_LF] = ACTIONS(2004),
    [sym_preproc_arg] = ACTIONS(2006),
    [sym_comment] = ACTIONS(121),
  },
  [380] = {
    [sym_string_literal] = STATE(989),
    [anon_sym_DQUOTE] = ACTIONS(2008),
    [sym_system_lib_string] = ACTIONS(2010),
    [sym_comment] = ACTIONS(91),
  },
  [381] = {
    [sym_identifier] = ACTIONS(2012),
    [sym_comment] = ACTIONS(91),
  },
  [382] = {
    [sym_preproc_arg] = ACTIONS(2014),
    [sym_comment] = ACTIONS(121),
  },
  [383] = {
    [sym_raw_string_literal] = ACTIONS(2016),
    [ts_builtin_sym_end] = ACTIONS(2016),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2018),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2018),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2018),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2018),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2018),
    [sym_preproc_directive] = ACTIONS(2018),
    [anon_sym_SEMI] = ACTIONS(2016),
    [anon_sym_typedef] = ACTIONS(2018),
    [anon_sym_extern] = ACTIONS(2018),
    [anon_sym_LBRACE] = ACTIONS(2016),
    [anon_sym_RBRACE] = ACTIONS(2016),
    [anon_sym_LPAREN2] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(2016),
    [anon_sym_LBRACK] = ACTIONS(2016),
    [anon_sym_static] = ACTIONS(2018),
    [anon_sym_register] = ACTIONS(2018),
    [anon_sym_inline] = ACTIONS(2018),
    [anon_sym_const] = ACTIONS(2018),
    [anon_sym_restrict] = ACTIONS(2018),
    [anon_sym_volatile] = ACTIONS(2018),
    [anon_sym__Atomic] = ACTIONS(2018),
    [anon_sym_mutable] = ACTIONS(2018),
    [anon_sym_explicit] = ACTIONS(2018),
    [anon_sym_constexpr] = ACTIONS(2018),
    [anon_sym_unsigned] = ACTIONS(2018),
    [anon_sym_long] = ACTIONS(2018),
    [anon_sym_short] = ACTIONS(2018),
    [sym_primitive_type] = ACTIONS(2018),
    [anon_sym_enum] = ACTIONS(2018),
    [anon_sym_struct] = ACTIONS(2018),
    [anon_sym_union] = ACTIONS(2018),
    [anon_sym_if] = ACTIONS(2018),
    [anon_sym_switch] = ACTIONS(2018),
    [anon_sym_case] = ACTIONS(2018),
    [anon_sym_default] = ACTIONS(2018),
    [anon_sym_while] = ACTIONS(2018),
    [anon_sym_do] = ACTIONS(2018),
    [anon_sym_for] = ACTIONS(2018),
    [anon_sym_return] = ACTIONS(2018),
    [anon_sym_break] = ACTIONS(2018),
    [anon_sym_continue] = ACTIONS(2018),
    [anon_sym_goto] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(2018),
    [anon_sym_AMP_AMP] = ACTIONS(2016),
    [anon_sym_BANG] = ACTIONS(2016),
    [anon_sym_TILDE] = ACTIONS(2016),
    [anon_sym_PLUS] = ACTIONS(2018),
    [anon_sym_DASH] = ACTIONS(2018),
    [anon_sym_DASH_DASH] = ACTIONS(2016),
    [anon_sym_PLUS_PLUS] = ACTIONS(2016),
    [anon_sym_sizeof] = ACTIONS(2018),
    [sym_number_literal] = ACTIONS(2016),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_DQUOTE] = ACTIONS(2016),
    [sym_true] = ACTIONS(2018),
    [sym_false] = ACTIONS(2018),
    [sym_null] = ACTIONS(2018),
    [sym_identifier] = ACTIONS(2018),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2018),
    [sym_auto] = ACTIONS(2018),
    [anon_sym_typename] = ACTIONS(2018),
    [anon_sym_template] = ACTIONS(2018),
    [anon_sym_delete] = ACTIONS(2018),
    [anon_sym_namespace] = ACTIONS(2018),
    [anon_sym_using] = ACTIONS(2018),
    [anon_sym_try] = ACTIONS(2018),
    [anon_sym_new] = ACTIONS(2018),
    [anon_sym_COLON_COLON] = ACTIONS(2016),
    [sym_operator_name] = ACTIONS(2016),
    [sym_nullptr] = ACTIONS(2018),
  },
  [384] = {
    [sym_identifier] = ACTIONS(2020),
    [sym_comment] = ACTIONS(91),
  },
  [385] = {
    [sym_preproc_include] = STATE(1022),
    [sym_preproc_def] = STATE(1022),
    [sym_preproc_function_def] = STATE(1022),
    [sym_preproc_call] = STATE(1022),
    [sym_preproc_if] = STATE(1022),
    [sym_preproc_ifdef] = STATE(1022),
    [sym_function_definition] = STATE(1022),
    [sym_declaration] = STATE(1022),
    [sym_type_definition] = STATE(1022),
    [sym__declaration_specifiers] = STATE(1018),
    [sym_linkage_specification] = STATE(1022),
    [sym__declarator] = STATE(50),
    [sym_pointer_declarator] = STATE(50),
    [sym_function_declarator] = STATE(1019),
    [sym_array_declarator] = STATE(50),
    [sym_compound_statement] = STATE(1022),
    [sym_storage_class_specifier] = STATE(1023),
    [sym_type_qualifier] = STATE(1023),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(1022),
    [sym_expression_statement] = STATE(1022),
    [sym_if_statement] = STATE(1022),
    [sym_switch_statement] = STATE(1022),
    [sym_case_statement] = STATE(1022),
    [sym_while_statement] = STATE(1022),
    [sym_do_statement] = STATE(1022),
    [sym_for_statement] = STATE(1022),
    [sym_return_statement] = STATE(1022),
    [sym_break_statement] = STATE(1022),
    [sym_continue_statement] = STATE(1022),
    [sym_goto_statement] = STATE(1022),
    [sym__expression] = STATE(1020),
    [sym_comma_expression] = STATE(1021),
    [sym_conditional_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1020),
    [sym_pointer_expression] = STATE(1020),
    [sym_logical_expression] = STATE(1020),
    [sym_bitwise_expression] = STATE(1020),
    [sym_equality_expression] = STATE(1020),
    [sym_relational_expression] = STATE(1020),
    [sym_shift_expression] = STATE(1020),
    [sym_math_expression] = STATE(1020),
    [sym_cast_expression] = STATE(1020),
    [sym_sizeof_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_field_expression] = STATE(1020),
    [sym_compound_literal_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_char_literal] = STATE(1020),
    [sym_concatenated_string] = STATE(1020),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(1022),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(1022),
    [sym_template_declaration] = STATE(1022),
    [sym_template_instantiation] = STATE(1022),
    [sym_constructor_or_destructor_definition] = STATE(1022),
    [sym_reference_declarator] = STATE(50),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(57),
    [sym_namespace_definition] = STATE(1022),
    [sym_using_declaration] = STATE(1022),
    [sym_alias_declaration] = STATE(1022),
    [sym_for_range_loop] = STATE(1022),
    [sym_try_statement] = STATE(1022),
    [sym_new_expression] = STATE(1020),
    [sym_delete_expression] = STATE(1020),
    [sym_lambda_expression] = STATE(1020),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_destructor_name] = STATE(50),
    [sym_scoped_identifier] = STATE(59),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_translation_unit_repeat1] = STATE(1022),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1023),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(2022),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2024),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2026),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2028),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2030),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2032),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2032),
    [sym_preproc_directive] = ACTIONS(2034),
    [anon_sym_SEMI] = ACTIONS(2036),
    [anon_sym_typedef] = ACTIONS(2038),
    [anon_sym_extern] = ACTIONS(2040),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(2044),
    [anon_sym_switch] = ACTIONS(2046),
    [anon_sym_case] = ACTIONS(2048),
    [anon_sym_default] = ACTIONS(2050),
    [anon_sym_while] = ACTIONS(2052),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(2056),
    [anon_sym_return] = ACTIONS(2058),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2062),
    [anon_sym_goto] = ACTIONS(2064),
    [anon_sym_AMP] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(2068),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_template] = ACTIONS(2070),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_namespace] = ACTIONS(2072),
    [anon_sym_using] = ACTIONS(2074),
    [anon_sym_try] = ACTIONS(2076),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_operator_name] = ACTIONS(111),
    [sym_nullptr] = ACTIONS(2066),
  },
  [386] = {
    [sym_preproc_arg] = ACTIONS(2078),
    [sym_comment] = ACTIONS(121),
  },
  [387] = {
    [anon_sym_LF] = ACTIONS(2080),
    [sym_preproc_arg] = ACTIONS(2082),
    [sym_comment] = ACTIONS(121),
  },
  [388] = {
    [sym_raw_string_literal] = ACTIONS(129),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(131),
    [sym_preproc_directive] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(129),
    [anon_sym_typedef] = ACTIONS(131),
    [anon_sym_extern] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_LPAREN2] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(129),
    [anon_sym_static] = ACTIONS(131),
    [anon_sym_register] = ACTIONS(131),
    [anon_sym_inline] = ACTIONS(131),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_restrict] = ACTIONS(131),
    [anon_sym_volatile] = ACTIONS(131),
    [anon_sym__Atomic] = ACTIONS(131),
    [anon_sym_mutable] = ACTIONS(131),
    [anon_sym_explicit] = ACTIONS(131),
    [anon_sym_constexpr] = ACTIONS(131),
    [anon_sym_unsigned] = ACTIONS(131),
    [anon_sym_long] = ACTIONS(131),
    [anon_sym_short] = ACTIONS(131),
    [sym_primitive_type] = ACTIONS(131),
    [anon_sym_enum] = ACTIONS(131),
    [anon_sym_struct] = ACTIONS(131),
    [anon_sym_union] = ACTIONS(131),
    [anon_sym_if] = ACTIONS(131),
    [anon_sym_else] = ACTIONS(131),
    [anon_sym_switch] = ACTIONS(131),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(131),
    [anon_sym_break] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_goto] = ACTIONS(131),
    [anon_sym_AMP] = ACTIONS(131),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_BANG] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_PLUS] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(129),
    [anon_sym_PLUS_PLUS] = ACTIONS(129),
    [anon_sym_sizeof] = ACTIONS(131),
    [sym_number_literal] = ACTIONS(129),
    [anon_sym_SQUOTE] = ACTIONS(129),
    [anon_sym_DQUOTE] = ACTIONS(129),
    [sym_true] = ACTIONS(131),
    [sym_false] = ACTIONS(131),
    [sym_null] = ACTIONS(131),
    [sym_identifier] = ACTIONS(131),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(131),
    [sym_auto] = ACTIONS(131),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(131),
    [anon_sym_delete] = ACTIONS(131),
    [anon_sym_namespace] = ACTIONS(131),
    [anon_sym_using] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(131),
    [anon_sym_new] = ACTIONS(131),
    [anon_sym_COLON_COLON] = ACTIONS(129),
    [sym_operator_name] = ACTIONS(129),
    [sym_nullptr] = ACTIONS(131),
  },
  [389] = {
    [sym_type_qualifier] = STATE(1028),
    [sym__type_specifier] = STATE(1027),
    [sym_sized_type_specifier] = STATE(1027),
    [sym_enum_specifier] = STATE(1027),
    [sym_struct_specifier] = STATE(1027),
    [sym_union_specifier] = STATE(1027),
    [sym_macro_type_specifier] = STATE(1027),
    [sym_class_specifier] = STATE(1027),
    [sym_dependent_type] = STATE(1027),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(82),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_type_definition_repeat1] = STATE(1028),
    [aux_sym_sized_type_specifier_repeat1] = STATE(85),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(135),
    [anon_sym_long] = ACTIONS(135),
    [anon_sym_short] = ACTIONS(135),
    [sym_primitive_type] = ACTIONS(2084),
    [anon_sym_enum] = ACTIONS(139),
    [anon_sym_struct] = ACTIONS(141),
    [anon_sym_union] = ACTIONS(143),
    [sym_identifier] = ACTIONS(145),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(147),
    [sym_auto] = ACTIONS(2084),
    [anon_sym_typename] = ACTIONS(149),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [390] = {
    [sym_string_literal] = STATE(1029),
    [anon_sym_extern] = ACTIONS(153),
    [anon_sym_LPAREN2] = ACTIONS(155),
    [anon_sym_STAR] = ACTIONS(155),
    [anon_sym_static] = ACTIONS(153),
    [anon_sym_register] = ACTIONS(153),
    [anon_sym_inline] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(153),
    [anon_sym_restrict] = ACTIONS(153),
    [anon_sym_volatile] = ACTIONS(153),
    [anon_sym__Atomic] = ACTIONS(153),
    [anon_sym_mutable] = ACTIONS(153),
    [anon_sym_explicit] = ACTIONS(153),
    [anon_sym_constexpr] = ACTIONS(153),
    [anon_sym_unsigned] = ACTIONS(153),
    [anon_sym_long] = ACTIONS(153),
    [anon_sym_short] = ACTIONS(153),
    [sym_primitive_type] = ACTIONS(153),
    [anon_sym_enum] = ACTIONS(153),
    [anon_sym_struct] = ACTIONS(153),
    [anon_sym_union] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_identifier] = ACTIONS(153),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(153),
    [sym_auto] = ACTIONS(153),
    [anon_sym_typename] = ACTIONS(153),
    [anon_sym_COLON_COLON] = ACTIONS(155),
    [sym_operator_name] = ACTIONS(155),
  },
  [391] = {
    [sym_preproc_include] = STATE(1031),
    [sym_preproc_def] = STATE(1031),
    [sym_preproc_function_def] = STATE(1031),
    [sym_preproc_call] = STATE(1031),
    [sym_preproc_if_in_compound_statement] = STATE(1031),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1031),
    [sym_declaration] = STATE(1031),
    [sym_type_definition] = STATE(1031),
    [sym__declaration_specifiers] = STATE(113),
    [sym_compound_statement] = STATE(1031),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(1031),
    [sym_expression_statement] = STATE(1031),
    [sym_if_statement] = STATE(1031),
    [sym_switch_statement] = STATE(1031),
    [sym_case_statement] = STATE(1031),
    [sym_while_statement] = STATE(1031),
    [sym_do_statement] = STATE(1031),
    [sym_for_statement] = STATE(1031),
    [sym_return_statement] = STATE(1031),
    [sym_break_statement] = STATE(1031),
    [sym_continue_statement] = STATE(1031),
    [sym_goto_statement] = STATE(1031),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(1031),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(1031),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(1031),
    [sym_try_statement] = STATE(1031),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1031),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(157),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(159),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(161),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(163),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(165),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(165),
    [sym_preproc_directive] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_typedef] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_RBRACE] = ACTIONS(2086),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(185),
    [anon_sym_case] = ACTIONS(187),
    [anon_sym_default] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(209),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_nullptr] = ACTIONS(207),
  },
  [392] = {
    [anon_sym_LPAREN2] = ACTIONS(2088),
    [anon_sym_constexpr] = ACTIONS(2090),
    [sym_comment] = ACTIONS(91),
  },
  [393] = {
    [sym_parenthesized_expression] = STATE(1034),
    [anon_sym_LPAREN2] = ACTIONS(323),
    [sym_comment] = ACTIONS(91),
  },
  [394] = {
    [sym__expression] = STATE(1035),
    [sym_conditional_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1035),
    [sym_pointer_expression] = STATE(1035),
    [sym_logical_expression] = STATE(1035),
    [sym_bitwise_expression] = STATE(1035),
    [sym_equality_expression] = STATE(1035),
    [sym_relational_expression] = STATE(1035),
    [sym_shift_expression] = STATE(1035),
    [sym_math_expression] = STATE(1035),
    [sym_cast_expression] = STATE(1035),
    [sym_sizeof_expression] = STATE(1035),
    [sym_subscript_expression] = STATE(1035),
    [sym_call_expression] = STATE(1035),
    [sym_field_expression] = STATE(1035),
    [sym_compound_literal_expression] = STATE(1035),
    [sym_parenthesized_expression] = STATE(1035),
    [sym_char_literal] = STATE(1035),
    [sym_concatenated_string] = STATE(1035),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1035),
    [sym_new_expression] = STATE(1035),
    [sym_delete_expression] = STATE(1035),
    [sym_lambda_expression] = STATE(1035),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2092),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(2092),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [sym_null] = ACTIONS(2094),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(2094),
  },
  [395] = {
    [anon_sym_COLON] = ACTIONS(2096),
    [sym_comment] = ACTIONS(91),
  },
  [396] = {
    [sym_parenthesized_expression] = STATE(1037),
    [anon_sym_LPAREN2] = ACTIONS(323),
    [sym_comment] = ACTIONS(91),
  },
  [397] = {
    [sym_compound_statement] = STATE(1038),
    [sym_labeled_statement] = STATE(1038),
    [sym_expression_statement] = STATE(1038),
    [sym_if_statement] = STATE(1038),
    [sym_switch_statement] = STATE(1038),
    [sym_case_statement] = STATE(1038),
    [sym_while_statement] = STATE(1038),
    [sym_do_statement] = STATE(1038),
    [sym_for_statement] = STATE(1038),
    [sym_return_statement] = STATE(1038),
    [sym_break_statement] = STATE(1038),
    [sym_continue_statement] = STATE(1038),
    [sym_goto_statement] = STATE(1038),
    [sym__expression] = STATE(222),
    [sym_comma_expression] = STATE(223),
    [sym_conditional_expression] = STATE(222),
    [sym_assignment_expression] = STATE(222),
    [sym_pointer_expression] = STATE(222),
    [sym_logical_expression] = STATE(222),
    [sym_bitwise_expression] = STATE(222),
    [sym_equality_expression] = STATE(222),
    [sym_relational_expression] = STATE(222),
    [sym_shift_expression] = STATE(222),
    [sym_math_expression] = STATE(222),
    [sym_cast_expression] = STATE(222),
    [sym_sizeof_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_call_expression] = STATE(222),
    [sym_field_expression] = STATE(222),
    [sym_compound_literal_expression] = STATE(222),
    [sym_parenthesized_expression] = STATE(222),
    [sym_char_literal] = STATE(222),
    [sym_concatenated_string] = STATE(222),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(222),
    [sym_for_range_loop] = STATE(1038),
    [sym_try_statement] = STATE(1038),
    [sym_new_expression] = STATE(222),
    [sym_delete_expression] = STATE(222),
    [sym_lambda_expression] = STATE(222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(359),
    [anon_sym_switch] = ACTIONS(361),
    [anon_sym_case] = ACTIONS(363),
    [anon_sym_default] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [anon_sym_do] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(373),
    [anon_sym_break] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_goto] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(353),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_identifier] = ACTIONS(383),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(381),
  },
  [398] = {
    [anon_sym_LPAREN2] = ACTIONS(2098),
    [sym_comment] = ACTIONS(91),
  },
  [399] = {
    [sym__expression] = STATE(1041),
    [sym_conditional_expression] = STATE(1041),
    [sym_assignment_expression] = STATE(1041),
    [sym_pointer_expression] = STATE(1041),
    [sym_logical_expression] = STATE(1041),
    [sym_bitwise_expression] = STATE(1041),
    [sym_equality_expression] = STATE(1041),
    [sym_relational_expression] = STATE(1041),
    [sym_shift_expression] = STATE(1041),
    [sym_math_expression] = STATE(1041),
    [sym_cast_expression] = STATE(1041),
    [sym_sizeof_expression] = STATE(1041),
    [sym_subscript_expression] = STATE(1041),
    [sym_call_expression] = STATE(1041),
    [sym_field_expression] = STATE(1041),
    [sym_compound_literal_expression] = STATE(1041),
    [sym_parenthesized_expression] = STATE(1041),
    [sym_initializer_list] = STATE(1042),
    [sym_char_literal] = STATE(1041),
    [sym_concatenated_string] = STATE(1041),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1041),
    [sym_new_expression] = STATE(1041),
    [sym_delete_expression] = STATE(1041),
    [sym_lambda_expression] = STATE(1041),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2100),
    [anon_sym_SEMI] = ACTIONS(2102),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(2100),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2104),
    [sym_false] = ACTIONS(2104),
    [sym_null] = ACTIONS(2104),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(2104),
  },
  [400] = {
    [anon_sym_SEMI] = ACTIONS(2106),
    [sym_comment] = ACTIONS(91),
  },
  [401] = {
    [anon_sym_SEMI] = ACTIONS(2108),
    [sym_comment] = ACTIONS(91),
  },
  [402] = {
    [sym_identifier] = ACTIONS(2110),
    [sym_comment] = ACTIONS(91),
  },
  [403] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(263),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(465),
    [anon_sym_extern] = ACTIONS(468),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(470),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_LBRACK] = ACTIONS(470),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_register] = ACTIONS(468),
    [anon_sym_inline] = ACTIONS(468),
    [anon_sym_const] = ACTIONS(468),
    [anon_sym_restrict] = ACTIONS(468),
    [anon_sym_volatile] = ACTIONS(468),
    [anon_sym__Atomic] = ACTIONS(468),
    [anon_sym_mutable] = ACTIONS(468),
    [anon_sym_explicit] = ACTIONS(468),
    [anon_sym_constexpr] = ACTIONS(468),
    [anon_sym_COLON] = ACTIONS(2112),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(474),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_TILDE] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_identifier] = ACTIONS(468),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(486),
    [sym_operator_name] = ACTIONS(481),
  },
  [404] = {
    [sym__declaration_specifiers] = STATE(1047),
    [sym__declarator] = STATE(1048),
    [sym_pointer_declarator] = STATE(1048),
    [sym_function_declarator] = STATE(1048),
    [sym_array_declarator] = STATE(1048),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_parameter_list] = STATE(1049),
    [sym_reference_declarator] = STATE(1048),
    [sym_template_type] = STATE(284),
    [sym_template_function] = STATE(1048),
    [sym_destructor_name] = STATE(1048),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(285),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(494),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_AMP] = ACTIONS(500),
    [anon_sym_AMP_AMP] = ACTIONS(502),
    [anon_sym_TILDE] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(504),
    [sym_identifier] = ACTIONS(506),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_COLON_COLON] = ACTIONS(510),
    [sym_operator_name] = ACTIONS(2114),
  },
  [405] = {
    [sym_declaration_list] = STATE(1052),
    [anon_sym_LBRACE] = ACTIONS(2116),
    [sym_identifier] = ACTIONS(2118),
    [sym_comment] = ACTIONS(91),
  },
  [406] = {
    [sym_template_type] = STATE(296),
    [sym_scoped_identifier] = STATE(1055),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(296),
    [sym_identifier] = ACTIONS(2120),
    [sym_comment] = ACTIONS(91),
    [anon_sym_namespace] = ACTIONS(2122),
    [anon_sym_COLON_COLON] = ACTIONS(528),
  },
  [407] = {
    [sym_compound_statement] = STATE(1056),
    [anon_sym_LBRACE] = ACTIONS(357),
    [sym_comment] = ACTIONS(91),
  },
  [408] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2124),
    [sym_comment] = ACTIONS(91),
  },
  [409] = {
    [sym__declarator] = STATE(1059),
    [sym_pointer_declarator] = STATE(1059),
    [sym_function_declarator] = STATE(1059),
    [sym_array_declarator] = STATE(1059),
    [sym_init_declarator] = STATE(1060),
    [sym_reference_declarator] = STATE(1059),
    [sym_structured_binding_reference_declarator] = STATE(1061),
    [sym_structured_binding_declarator] = STATE(1061),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(1059),
    [sym_destructor_name] = STATE(1059),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [anon_sym_SEMI] = ACTIONS(2126),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(566),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(568),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(2128),
  },
  [410] = {
    [sym_compound_statement] = STATE(1063),
    [sym_field_initializer_list] = STATE(1064),
    [sym_default_method_clause] = STATE(1063),
    [sym_delete_method_clause] = STATE(1063),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(576),
    [anon_sym_LBRACK] = ACTIONS(576),
    [anon_sym_EQ] = ACTIONS(2130),
    [anon_sym_COLON] = ACTIONS(580),
    [sym_comment] = ACTIONS(91),
  },
  [411] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(586),
    [anon_sym_SEMI] = ACTIONS(2132),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(590),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(594),
    [anon_sym_QMARK] = ACTIONS(596),
    [anon_sym_STAR_EQ] = ACTIONS(598),
    [anon_sym_SLASH_EQ] = ACTIONS(598),
    [anon_sym_PERCENT_EQ] = ACTIONS(598),
    [anon_sym_PLUS_EQ] = ACTIONS(598),
    [anon_sym_DASH_EQ] = ACTIONS(598),
    [anon_sym_LT_LT_EQ] = ACTIONS(598),
    [anon_sym_GT_GT_EQ] = ACTIONS(598),
    [anon_sym_AMP_EQ] = ACTIONS(598),
    [anon_sym_CARET_EQ] = ACTIONS(598),
    [anon_sym_PIPE_EQ] = ACTIONS(598),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_PIPE_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(604),
    [anon_sym_PIPE] = ACTIONS(606),
    [anon_sym_CARET] = ACTIONS(608),
    [anon_sym_EQ_EQ] = ACTIONS(610),
    [anon_sym_BANG_EQ] = ACTIONS(610),
    [anon_sym_LT] = ACTIONS(612),
    [anon_sym_GT] = ACTIONS(612),
    [anon_sym_LT_EQ] = ACTIONS(614),
    [anon_sym_GT_EQ] = ACTIONS(614),
    [anon_sym_LT_LT] = ACTIONS(616),
    [anon_sym_GT_GT] = ACTIONS(616),
    [anon_sym_PLUS] = ACTIONS(618),
    [anon_sym_DASH] = ACTIONS(618),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [412] = {
    [anon_sym_SEMI] = ACTIONS(2132),
    [sym_comment] = ACTIONS(91),
  },
  [413] = {
    [sym_preproc_include] = STATE(1067),
    [sym_preproc_def] = STATE(1067),
    [sym_preproc_function_def] = STATE(1067),
    [sym_preproc_call] = STATE(1067),
    [sym_preproc_if] = STATE(1067),
    [sym_preproc_ifdef] = STATE(1067),
    [sym_preproc_else] = STATE(1066),
    [sym_preproc_elif] = STATE(1066),
    [sym_function_definition] = STATE(1067),
    [sym_declaration] = STATE(1067),
    [sym_type_definition] = STATE(1067),
    [sym__declaration_specifiers] = STATE(409),
    [sym_linkage_specification] = STATE(1067),
    [sym__declarator] = STATE(50),
    [sym_pointer_declarator] = STATE(50),
    [sym_function_declarator] = STATE(410),
    [sym_array_declarator] = STATE(50),
    [sym_compound_statement] = STATE(1067),
    [sym_storage_class_specifier] = STATE(414),
    [sym_type_qualifier] = STATE(414),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(1067),
    [sym_expression_statement] = STATE(1067),
    [sym_if_statement] = STATE(1067),
    [sym_switch_statement] = STATE(1067),
    [sym_case_statement] = STATE(1067),
    [sym_while_statement] = STATE(1067),
    [sym_do_statement] = STATE(1067),
    [sym_for_statement] = STATE(1067),
    [sym_return_statement] = STATE(1067),
    [sym_break_statement] = STATE(1067),
    [sym_continue_statement] = STATE(1067),
    [sym_goto_statement] = STATE(1067),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(1067),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(1067),
    [sym_template_declaration] = STATE(1067),
    [sym_template_instantiation] = STATE(1067),
    [sym_constructor_or_destructor_definition] = STATE(1067),
    [sym_reference_declarator] = STATE(50),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(57),
    [sym_namespace_definition] = STATE(1067),
    [sym_using_declaration] = STATE(1067),
    [sym_alias_declaration] = STATE(1067),
    [sym_for_range_loop] = STATE(1067),
    [sym_try_statement] = STATE(1067),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_destructor_name] = STATE(50),
    [sym_scoped_identifier] = STATE(59),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_translation_unit_repeat1] = STATE(1067),
    [aux_sym__declaration_specifiers_repeat1] = STATE(414),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(678),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(684),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2134),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(688),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(688),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(690),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(692),
    [sym_preproc_directive] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_typedef] = ACTIONS(698),
    [anon_sym_extern] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(704),
    [anon_sym_switch] = ACTIONS(706),
    [anon_sym_case] = ACTIONS(708),
    [anon_sym_default] = ACTIONS(710),
    [anon_sym_while] = ACTIONS(712),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(728),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_template] = ACTIONS(730),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_namespace] = ACTIONS(732),
    [anon_sym_using] = ACTIONS(734),
    [anon_sym_try] = ACTIONS(736),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_operator_name] = ACTIONS(111),
    [sym_nullptr] = ACTIONS(726),
  },
  [414] = {
    [sym__declarator] = STATE(50),
    [sym_pointer_declarator] = STATE(50),
    [sym_function_declarator] = STATE(1068),
    [sym_array_declarator] = STATE(50),
    [sym_storage_class_specifier] = STATE(370),
    [sym_type_qualifier] = STATE(370),
    [sym__type_specifier] = STATE(367),
    [sym_sized_type_specifier] = STATE(367),
    [sym_enum_specifier] = STATE(367),
    [sym_struct_specifier] = STATE(367),
    [sym_union_specifier] = STATE(367),
    [sym_macro_type_specifier] = STATE(367),
    [sym_class_specifier] = STATE(367),
    [sym_dependent_type] = STATE(367),
    [sym_reference_declarator] = STATE(50),
    [sym_template_type] = STATE(368),
    [sym_template_function] = STATE(50),
    [sym_destructor_name] = STATE(50),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(369),
    [aux_sym__declaration_specifiers_repeat1] = STATE(370),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(425),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(647),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(649),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(647),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_COLON_COLON] = ACTIONS(651),
    [sym_operator_name] = ACTIONS(111),
  },
  [415] = {
    [sym_raw_string_literal] = ACTIONS(2136),
    [ts_builtin_sym_end] = ACTIONS(2136),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2138),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2138),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2138),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2138),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2138),
    [sym_preproc_directive] = ACTIONS(2138),
    [anon_sym_SEMI] = ACTIONS(2136),
    [anon_sym_typedef] = ACTIONS(2138),
    [anon_sym_extern] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2136),
    [anon_sym_RBRACE] = ACTIONS(2136),
    [anon_sym_LPAREN2] = ACTIONS(2136),
    [anon_sym_STAR] = ACTIONS(2136),
    [anon_sym_LBRACK] = ACTIONS(2136),
    [anon_sym_static] = ACTIONS(2138),
    [anon_sym_register] = ACTIONS(2138),
    [anon_sym_inline] = ACTIONS(2138),
    [anon_sym_const] = ACTIONS(2138),
    [anon_sym_restrict] = ACTIONS(2138),
    [anon_sym_volatile] = ACTIONS(2138),
    [anon_sym__Atomic] = ACTIONS(2138),
    [anon_sym_mutable] = ACTIONS(2138),
    [anon_sym_explicit] = ACTIONS(2138),
    [anon_sym_constexpr] = ACTIONS(2138),
    [anon_sym_unsigned] = ACTIONS(2138),
    [anon_sym_long] = ACTIONS(2138),
    [anon_sym_short] = ACTIONS(2138),
    [sym_primitive_type] = ACTIONS(2138),
    [anon_sym_enum] = ACTIONS(2138),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2138),
    [anon_sym_if] = ACTIONS(2138),
    [anon_sym_switch] = ACTIONS(2138),
    [anon_sym_case] = ACTIONS(2138),
    [anon_sym_default] = ACTIONS(2138),
    [anon_sym_while] = ACTIONS(2138),
    [anon_sym_do] = ACTIONS(2138),
    [anon_sym_for] = ACTIONS(2138),
    [anon_sym_return] = ACTIONS(2138),
    [anon_sym_break] = ACTIONS(2138),
    [anon_sym_continue] = ACTIONS(2138),
    [anon_sym_goto] = ACTIONS(2138),
    [anon_sym_AMP] = ACTIONS(2138),
    [anon_sym_AMP_AMP] = ACTIONS(2136),
    [anon_sym_BANG] = ACTIONS(2136),
    [anon_sym_TILDE] = ACTIONS(2136),
    [anon_sym_PLUS] = ACTIONS(2138),
    [anon_sym_DASH] = ACTIONS(2138),
    [anon_sym_DASH_DASH] = ACTIONS(2136),
    [anon_sym_PLUS_PLUS] = ACTIONS(2136),
    [anon_sym_sizeof] = ACTIONS(2138),
    [sym_number_literal] = ACTIONS(2136),
    [anon_sym_SQUOTE] = ACTIONS(2136),
    [anon_sym_DQUOTE] = ACTIONS(2136),
    [sym_true] = ACTIONS(2138),
    [sym_false] = ACTIONS(2138),
    [sym_null] = ACTIONS(2138),
    [sym_identifier] = ACTIONS(2138),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2138),
    [sym_auto] = ACTIONS(2138),
    [anon_sym_typename] = ACTIONS(2138),
    [anon_sym_template] = ACTIONS(2138),
    [anon_sym_delete] = ACTIONS(2138),
    [anon_sym_namespace] = ACTIONS(2138),
    [anon_sym_using] = ACTIONS(2138),
    [anon_sym_try] = ACTIONS(2138),
    [anon_sym_new] = ACTIONS(2138),
    [anon_sym_COLON_COLON] = ACTIONS(2136),
    [sym_operator_name] = ACTIONS(2136),
    [sym_nullptr] = ACTIONS(2138),
  },
  [416] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2140),
    [sym_comment] = ACTIONS(91),
  },
  [417] = {
    [sym_preproc_include] = STATE(1067),
    [sym_preproc_def] = STATE(1067),
    [sym_preproc_function_def] = STATE(1067),
    [sym_preproc_call] = STATE(1067),
    [sym_preproc_if] = STATE(1067),
    [sym_preproc_ifdef] = STATE(1067),
    [sym_preproc_else] = STATE(1070),
    [sym_preproc_elif] = STATE(1070),
    [sym_function_definition] = STATE(1067),
    [sym_declaration] = STATE(1067),
    [sym_type_definition] = STATE(1067),
    [sym__declaration_specifiers] = STATE(409),
    [sym_linkage_specification] = STATE(1067),
    [sym__declarator] = STATE(50),
    [sym_pointer_declarator] = STATE(50),
    [sym_function_declarator] = STATE(410),
    [sym_array_declarator] = STATE(50),
    [sym_compound_statement] = STATE(1067),
    [sym_storage_class_specifier] = STATE(414),
    [sym_type_qualifier] = STATE(414),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(1067),
    [sym_expression_statement] = STATE(1067),
    [sym_if_statement] = STATE(1067),
    [sym_switch_statement] = STATE(1067),
    [sym_case_statement] = STATE(1067),
    [sym_while_statement] = STATE(1067),
    [sym_do_statement] = STATE(1067),
    [sym_for_statement] = STATE(1067),
    [sym_return_statement] = STATE(1067),
    [sym_break_statement] = STATE(1067),
    [sym_continue_statement] = STATE(1067),
    [sym_goto_statement] = STATE(1067),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(1067),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(1067),
    [sym_template_declaration] = STATE(1067),
    [sym_template_instantiation] = STATE(1067),
    [sym_constructor_or_destructor_definition] = STATE(1067),
    [sym_reference_declarator] = STATE(50),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(57),
    [sym_namespace_definition] = STATE(1067),
    [sym_using_declaration] = STATE(1067),
    [sym_alias_declaration] = STATE(1067),
    [sym_for_range_loop] = STATE(1067),
    [sym_try_statement] = STATE(1067),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_destructor_name] = STATE(50),
    [sym_scoped_identifier] = STATE(59),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_translation_unit_repeat1] = STATE(1067),
    [aux_sym__declaration_specifiers_repeat1] = STATE(414),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(678),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(684),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2142),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(688),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(688),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(690),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(692),
    [sym_preproc_directive] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_typedef] = ACTIONS(698),
    [anon_sym_extern] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(704),
    [anon_sym_switch] = ACTIONS(706),
    [anon_sym_case] = ACTIONS(708),
    [anon_sym_default] = ACTIONS(710),
    [anon_sym_while] = ACTIONS(712),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(728),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_template] = ACTIONS(730),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_namespace] = ACTIONS(732),
    [anon_sym_using] = ACTIONS(734),
    [anon_sym_try] = ACTIONS(736),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_operator_name] = ACTIONS(111),
    [sym_nullptr] = ACTIONS(726),
  },
  [418] = {
    [sym_raw_string_literal] = ACTIONS(2144),
    [ts_builtin_sym_end] = ACTIONS(2144),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2146),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2146),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2146),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2146),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2146),
    [sym_preproc_directive] = ACTIONS(2146),
    [anon_sym_SEMI] = ACTIONS(2144),
    [anon_sym_typedef] = ACTIONS(2146),
    [anon_sym_extern] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(2144),
    [anon_sym_RBRACE] = ACTIONS(2144),
    [anon_sym_LPAREN2] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(2144),
    [anon_sym_LBRACK] = ACTIONS(2144),
    [anon_sym_static] = ACTIONS(2146),
    [anon_sym_register] = ACTIONS(2146),
    [anon_sym_inline] = ACTIONS(2146),
    [anon_sym_const] = ACTIONS(2146),
    [anon_sym_restrict] = ACTIONS(2146),
    [anon_sym_volatile] = ACTIONS(2146),
    [anon_sym__Atomic] = ACTIONS(2146),
    [anon_sym_mutable] = ACTIONS(2146),
    [anon_sym_explicit] = ACTIONS(2146),
    [anon_sym_constexpr] = ACTIONS(2146),
    [anon_sym_unsigned] = ACTIONS(2146),
    [anon_sym_long] = ACTIONS(2146),
    [anon_sym_short] = ACTIONS(2146),
    [sym_primitive_type] = ACTIONS(2146),
    [anon_sym_enum] = ACTIONS(2146),
    [anon_sym_struct] = ACTIONS(2146),
    [anon_sym_union] = ACTIONS(2146),
    [anon_sym_if] = ACTIONS(2146),
    [anon_sym_switch] = ACTIONS(2146),
    [anon_sym_case] = ACTIONS(2146),
    [anon_sym_default] = ACTIONS(2146),
    [anon_sym_while] = ACTIONS(2146),
    [anon_sym_do] = ACTIONS(2146),
    [anon_sym_for] = ACTIONS(2146),
    [anon_sym_return] = ACTIONS(2146),
    [anon_sym_break] = ACTIONS(2146),
    [anon_sym_continue] = ACTIONS(2146),
    [anon_sym_goto] = ACTIONS(2146),
    [anon_sym_AMP] = ACTIONS(2146),
    [anon_sym_AMP_AMP] = ACTIONS(2144),
    [anon_sym_BANG] = ACTIONS(2144),
    [anon_sym_TILDE] = ACTIONS(2144),
    [anon_sym_PLUS] = ACTIONS(2146),
    [anon_sym_DASH] = ACTIONS(2146),
    [anon_sym_DASH_DASH] = ACTIONS(2144),
    [anon_sym_PLUS_PLUS] = ACTIONS(2144),
    [anon_sym_sizeof] = ACTIONS(2146),
    [sym_number_literal] = ACTIONS(2144),
    [anon_sym_SQUOTE] = ACTIONS(2144),
    [anon_sym_DQUOTE] = ACTIONS(2144),
    [sym_true] = ACTIONS(2146),
    [sym_false] = ACTIONS(2146),
    [sym_null] = ACTIONS(2146),
    [sym_identifier] = ACTIONS(2146),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2146),
    [sym_auto] = ACTIONS(2146),
    [anon_sym_typename] = ACTIONS(2146),
    [anon_sym_template] = ACTIONS(2146),
    [anon_sym_delete] = ACTIONS(2146),
    [anon_sym_namespace] = ACTIONS(2146),
    [anon_sym_using] = ACTIONS(2146),
    [anon_sym_try] = ACTIONS(2146),
    [anon_sym_new] = ACTIONS(2146),
    [anon_sym_COLON_COLON] = ACTIONS(2144),
    [sym_operator_name] = ACTIONS(2144),
    [sym_nullptr] = ACTIONS(2146),
  },
  [419] = {
    [sym_enumerator] = STATE(1073),
    [anon_sym_COMMA] = ACTIONS(2148),
    [anon_sym_RBRACE] = ACTIONS(2150),
    [sym_identifier] = ACTIONS(1009),
    [sym_comment] = ACTIONS(91),
  },
  [420] = {
    [sym_enumerator_list] = STATE(1074),
    [anon_sym_COMMA] = ACTIONS(1011),
    [anon_sym_SEMI] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(746),
    [anon_sym_LPAREN2] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(1011),
    [anon_sym_LBRACK] = ACTIONS(1011),
    [anon_sym_const] = ACTIONS(1013),
    [anon_sym_restrict] = ACTIONS(1013),
    [anon_sym_volatile] = ACTIONS(1013),
    [anon_sym__Atomic] = ACTIONS(1013),
    [anon_sym_mutable] = ACTIONS(1013),
    [anon_sym_explicit] = ACTIONS(1013),
    [anon_sym_constexpr] = ACTIONS(1013),
    [anon_sym_COLON] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1013),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_DASH_GT] = ACTIONS(1011),
    [sym_identifier] = ACTIONS(1013),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1013),
    [anon_sym_override] = ACTIONS(1013),
    [sym_noexcept] = ACTIONS(1013),
  },
  [421] = {
    [anon_sym_COMMA] = ACTIONS(1015),
    [anon_sym_SEMI] = ACTIONS(1015),
    [anon_sym_LBRACE] = ACTIONS(1015),
    [anon_sym_LPAREN2] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1015),
    [anon_sym_LBRACK] = ACTIONS(1015),
    [anon_sym_EQ] = ACTIONS(1015),
    [anon_sym_const] = ACTIONS(1017),
    [anon_sym_restrict] = ACTIONS(1017),
    [anon_sym_volatile] = ACTIONS(1017),
    [anon_sym__Atomic] = ACTIONS(1017),
    [anon_sym_mutable] = ACTIONS(1017),
    [anon_sym_explicit] = ACTIONS(1017),
    [anon_sym_constexpr] = ACTIONS(1017),
    [anon_sym_COLON] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(1017),
    [anon_sym_AMP_AMP] = ACTIONS(1015),
    [anon_sym_DASH_GT] = ACTIONS(1015),
    [sym_identifier] = ACTIONS(1017),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1017),
    [anon_sym_override] = ACTIONS(1017),
    [sym_noexcept] = ACTIONS(1017),
  },
  [422] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(1076),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1076),
    [sym_type_definition] = STATE(1076),
    [sym__declaration_specifiers] = STATE(598),
    [sym__declarator] = STATE(599),
    [sym_pointer_declarator] = STATE(599),
    [sym_function_declarator] = STATE(600),
    [sym_array_declarator] = STATE(599),
    [sym_storage_class_specifier] = STATE(605),
    [sym_type_qualifier] = STATE(605),
    [sym__type_specifier] = STATE(601),
    [sym_sized_type_specifier] = STATE(601),
    [sym_enum_specifier] = STATE(601),
    [sym_struct_specifier] = STATE(601),
    [sym_union_specifier] = STATE(601),
    [sym__field_declaration_list_item] = STATE(1076),
    [sym_field_declaration] = STATE(1076),
    [sym_macro_type_specifier] = STATE(601),
    [sym_class_specifier] = STATE(601),
    [sym_dependent_type] = STATE(601),
    [sym_template_declaration] = STATE(1076),
    [sym_inline_method_definition] = STATE(1076),
    [sym_constructor_or_destructor_definition] = STATE(1076),
    [sym_constructor_or_destructor_declaration] = STATE(1076),
    [sym_friend_declaration] = STATE(1076),
    [sym_access_specifier] = STATE(1076),
    [sym_reference_declarator] = STATE(599),
    [sym_template_type] = STATE(602),
    [sym_template_function] = STATE(599),
    [sym_using_declaration] = STATE(1076),
    [sym_alias_declaration] = STATE(1076),
    [sym_destructor_name] = STATE(599),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(603),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1076),
    [aux_sym__declaration_specifiers_repeat1] = STATE(605),
    [aux_sym_sized_type_specifier_repeat1] = STATE(606),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1019),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1021),
    [anon_sym_typedef] = ACTIONS(1023),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(2152),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(425),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(1027),
    [anon_sym_long] = ACTIONS(1027),
    [anon_sym_short] = ACTIONS(1027),
    [sym_primitive_type] = ACTIONS(1029),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(1031),
    [anon_sym_union] = ACTIONS(1033),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(1035),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1039),
    [sym_auto] = ACTIONS(1029),
    [anon_sym_typename] = ACTIONS(1041),
    [anon_sym_template] = ACTIONS(1043),
    [anon_sym_friend] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1039),
    [anon_sym_protected] = ACTIONS(1039),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_COLON_COLON] = ACTIONS(1049),
    [sym_operator_name] = ACTIONS(1051),
  },
  [423] = {
    [sym_field_declaration_list] = STATE(1077),
    [sym_virtual_specifier] = STATE(1078),
    [sym_base_class_clause] = STATE(1079),
    [sym_template_argument_list] = STATE(437),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_LPAREN2] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1057),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(756),
    [sym_identifier] = ACTIONS(1059),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(758),
  },
  [424] = {
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_LBRACE] = ACTIONS(1069),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1069),
    [anon_sym_EQ] = ACTIONS(1069),
    [anon_sym_const] = ACTIONS(1071),
    [anon_sym_restrict] = ACTIONS(1071),
    [anon_sym_volatile] = ACTIONS(1071),
    [anon_sym__Atomic] = ACTIONS(1071),
    [anon_sym_mutable] = ACTIONS(1071),
    [anon_sym_explicit] = ACTIONS(1071),
    [anon_sym_constexpr] = ACTIONS(1071),
    [anon_sym_COLON] = ACTIONS(1069),
    [anon_sym_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1069),
    [anon_sym_DASH_GT] = ACTIONS(1069),
    [sym_identifier] = ACTIONS(1071),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1071),
    [anon_sym_override] = ACTIONS(1071),
    [sym_noexcept] = ACTIONS(1071),
  },
  [425] = {
    [sym_field_declaration_list] = STATE(1080),
    [sym_base_class_clause] = STATE(1081),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_COLON] = ACTIONS(1073),
    [sym_comment] = ACTIONS(91),
  },
  [426] = {
    [sym_field_declaration_list] = STATE(1080),
    [anon_sym_LBRACE] = ACTIONS(750),
    [sym_comment] = ACTIONS(91),
  },
  [427] = {
    [sym_field_declaration_list] = STATE(1080),
    [sym_virtual_specifier] = STATE(1082),
    [sym_base_class_clause] = STATE(1081),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(1071),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(772),
  },
  [428] = {
    [sym_field_declaration_list] = STATE(1080),
    [sym_virtual_specifier] = STATE(1082),
    [sym_base_class_clause] = STATE(1081),
    [sym_template_argument_list] = STATE(451),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_COLON] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(756),
    [sym_identifier] = ACTIONS(1071),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
  },
  [429] = {
    [sym_field_declaration_list] = STATE(1083),
    [sym_virtual_specifier] = STATE(1084),
    [sym_base_class_clause] = STATE(1085),
    [sym_template_argument_list] = STATE(437),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_LPAREN2] = ACTIONS(1077),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(756),
    [sym_identifier] = ACTIONS(1079),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(758),
  },
  [430] = {
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LBRACE] = ACTIONS(1081),
    [anon_sym_LPAREN2] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1081),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(1081),
    [anon_sym_const] = ACTIONS(1083),
    [anon_sym_restrict] = ACTIONS(1083),
    [anon_sym_volatile] = ACTIONS(1083),
    [anon_sym__Atomic] = ACTIONS(1083),
    [anon_sym_mutable] = ACTIONS(1083),
    [anon_sym_explicit] = ACTIONS(1083),
    [anon_sym_constexpr] = ACTIONS(1083),
    [anon_sym_COLON] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(1081),
    [sym_identifier] = ACTIONS(1083),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1083),
    [anon_sym_override] = ACTIONS(1083),
    [sym_noexcept] = ACTIONS(1083),
  },
  [431] = {
    [sym_field_declaration_list] = STATE(1086),
    [sym_base_class_clause] = STATE(1087),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_COLON] = ACTIONS(1073),
    [sym_comment] = ACTIONS(91),
  },
  [432] = {
    [sym_field_declaration_list] = STATE(1086),
    [anon_sym_LBRACE] = ACTIONS(750),
    [sym_comment] = ACTIONS(91),
  },
  [433] = {
    [sym_field_declaration_list] = STATE(1086),
    [sym_virtual_specifier] = STATE(1088),
    [sym_base_class_clause] = STATE(1087),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_LPAREN2] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1081),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(1083),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(772),
  },
  [434] = {
    [sym_field_declaration_list] = STATE(1086),
    [sym_virtual_specifier] = STATE(1088),
    [sym_base_class_clause] = STATE(1087),
    [sym_template_argument_list] = STATE(451),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_LPAREN2] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1081),
    [anon_sym_COLON] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(756),
    [sym_identifier] = ACTIONS(1083),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
  },
  [435] = {
    [sym_type_qualifier] = STATE(786),
    [sym__type_specifier] = STATE(777),
    [sym_sized_type_specifier] = STATE(777),
    [sym_enum_specifier] = STATE(777),
    [sym_struct_specifier] = STATE(777),
    [sym_union_specifier] = STATE(777),
    [sym__expression] = STATE(1090),
    [sym_conditional_expression] = STATE(1090),
    [sym_assignment_expression] = STATE(1090),
    [sym_pointer_expression] = STATE(1090),
    [sym_logical_expression] = STATE(1090),
    [sym_bitwise_expression] = STATE(1090),
    [sym_equality_expression] = STATE(1090),
    [sym_relational_expression] = STATE(1090),
    [sym_shift_expression] = STATE(1090),
    [sym_math_expression] = STATE(1090),
    [sym_cast_expression] = STATE(1090),
    [sym_type_descriptor] = STATE(1091),
    [sym_sizeof_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1090),
    [sym_call_expression] = STATE(1090),
    [sym_field_expression] = STATE(1090),
    [sym_compound_literal_expression] = STATE(1090),
    [sym_parenthesized_expression] = STATE(1090),
    [sym_char_literal] = STATE(1090),
    [sym_concatenated_string] = STATE(1090),
    [sym_string_literal] = STATE(780),
    [sym_macro_type_specifier] = STATE(777),
    [sym_class_specifier] = STATE(777),
    [sym_dependent_type] = STATE(777),
    [sym_template_type] = STATE(781),
    [sym_template_function] = STATE(1090),
    [sym_new_expression] = STATE(1090),
    [sym_delete_expression] = STATE(1090),
    [sym_lambda_expression] = STATE(1090),
    [sym_lambda_capture_specifier] = STATE(782),
    [sym_scoped_identifier] = STATE(783),
    [sym_scoped_type_identifier] = STATE(784),
    [sym_scoped_namespace_identifier] = STATE(785),
    [aux_sym_type_definition_repeat1] = STATE(786),
    [aux_sym_sized_type_specifier_repeat1] = STATE(787),
    [sym_raw_string_literal] = ACTIONS(2154),
    [anon_sym_LPAREN2] = ACTIONS(1380),
    [anon_sym_STAR] = ACTIONS(1382),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(1384),
    [anon_sym_long] = ACTIONS(1384),
    [anon_sym_short] = ACTIONS(1384),
    [sym_primitive_type] = ACTIONS(1386),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [anon_sym_AMP] = ACTIONS(1382),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1394),
    [anon_sym_PLUS_PLUS] = ACTIONS(1394),
    [anon_sym_sizeof] = ACTIONS(1396),
    [sym_number_literal] = ACTIONS(2154),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_true] = ACTIONS(2156),
    [sym_false] = ACTIONS(2156),
    [sym_null] = ACTIONS(2156),
    [sym_identifier] = ACTIONS(1404),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(1386),
    [anon_sym_typename] = ACTIONS(1406),
    [anon_sym_GT2] = ACTIONS(2158),
    [anon_sym_delete] = ACTIONS(1410),
    [anon_sym_new] = ACTIONS(1412),
    [anon_sym_COLON_COLON] = ACTIONS(1414),
    [sym_nullptr] = ACTIONS(2156),
  },
  [436] = {
    [sym_identifier] = ACTIONS(2160),
    [sym_comment] = ACTIONS(91),
  },
  [437] = {
    [anon_sym_COMMA] = ACTIONS(1431),
    [anon_sym_RPAREN] = ACTIONS(1431),
    [anon_sym_SEMI] = ACTIONS(1431),
    [anon_sym_LBRACE] = ACTIONS(1431),
    [anon_sym_LPAREN2] = ACTIONS(1431),
    [anon_sym_STAR] = ACTIONS(1431),
    [anon_sym_LBRACK] = ACTIONS(1431),
    [anon_sym_EQ] = ACTIONS(1431),
    [anon_sym_const] = ACTIONS(1429),
    [anon_sym_restrict] = ACTIONS(1429),
    [anon_sym_volatile] = ACTIONS(1429),
    [anon_sym__Atomic] = ACTIONS(1429),
    [anon_sym_mutable] = ACTIONS(1429),
    [anon_sym_explicit] = ACTIONS(1429),
    [anon_sym_constexpr] = ACTIONS(1429),
    [anon_sym_COLON] = ACTIONS(1429),
    [anon_sym_AMP] = ACTIONS(1429),
    [anon_sym_AMP_AMP] = ACTIONS(1431),
    [anon_sym_DASH_GT] = ACTIONS(1431),
    [sym_identifier] = ACTIONS(1429),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1429),
    [anon_sym_override] = ACTIONS(1429),
    [anon_sym_GT2] = ACTIONS(1431),
    [sym_noexcept] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1431),
  },
  [438] = {
    [sym_field_declaration_list] = STATE(1093),
    [sym_virtual_specifier] = STATE(1094),
    [sym_base_class_clause] = STATE(1095),
    [sym_template_argument_list] = STATE(437),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_LPAREN2] = ACTIONS(1438),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(756),
    [sym_identifier] = ACTIONS(1440),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(758),
  },
  [439] = {
    [anon_sym_COMMA] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1442),
    [anon_sym_LBRACE] = ACTIONS(1442),
    [anon_sym_LPAREN2] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(1442),
    [anon_sym_EQ] = ACTIONS(1442),
    [anon_sym_const] = ACTIONS(1444),
    [anon_sym_restrict] = ACTIONS(1444),
    [anon_sym_volatile] = ACTIONS(1444),
    [anon_sym__Atomic] = ACTIONS(1444),
    [anon_sym_mutable] = ACTIONS(1444),
    [anon_sym_explicit] = ACTIONS(1444),
    [anon_sym_constexpr] = ACTIONS(1444),
    [anon_sym_COLON] = ACTIONS(1442),
    [anon_sym_AMP] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1442),
    [anon_sym_DASH_GT] = ACTIONS(1442),
    [sym_identifier] = ACTIONS(1444),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1444),
    [anon_sym_override] = ACTIONS(1444),
    [sym_noexcept] = ACTIONS(1444),
  },
  [440] = {
    [sym_field_declaration_list] = STATE(1096),
    [sym_base_class_clause] = STATE(1097),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_COLON] = ACTIONS(1073),
    [sym_comment] = ACTIONS(91),
  },
  [441] = {
    [sym_field_declaration_list] = STATE(1096),
    [anon_sym_LBRACE] = ACTIONS(750),
    [sym_comment] = ACTIONS(91),
  },
  [442] = {
    [sym_field_declaration_list] = STATE(1096),
    [sym_virtual_specifier] = STATE(1098),
    [sym_base_class_clause] = STATE(1097),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_LPAREN2] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1442),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(1444),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(772),
  },
  [443] = {
    [sym_field_declaration_list] = STATE(1096),
    [sym_virtual_specifier] = STATE(1098),
    [sym_base_class_clause] = STATE(1097),
    [sym_template_argument_list] = STATE(451),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_LPAREN2] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1442),
    [anon_sym_COLON] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(756),
    [sym_identifier] = ACTIONS(1444),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
  },
  [444] = {
    [anon_sym_COMMA] = ACTIONS(1446),
    [anon_sym_SEMI] = ACTIONS(1446),
    [anon_sym_LBRACE] = ACTIONS(1446),
    [anon_sym_LPAREN2] = ACTIONS(1446),
    [anon_sym_STAR] = ACTIONS(1446),
    [anon_sym_LBRACK] = ACTIONS(1446),
    [anon_sym_EQ] = ACTIONS(1446),
    [anon_sym_const] = ACTIONS(1448),
    [anon_sym_restrict] = ACTIONS(1448),
    [anon_sym_volatile] = ACTIONS(1448),
    [anon_sym__Atomic] = ACTIONS(1448),
    [anon_sym_mutable] = ACTIONS(1448),
    [anon_sym_explicit] = ACTIONS(1448),
    [anon_sym_constexpr] = ACTIONS(1448),
    [anon_sym_COLON] = ACTIONS(1446),
    [anon_sym_AMP] = ACTIONS(1448),
    [anon_sym_AMP_AMP] = ACTIONS(1446),
    [anon_sym_DASH_GT] = ACTIONS(1446),
    [sym_identifier] = ACTIONS(1448),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1448),
    [anon_sym_override] = ACTIONS(1448),
    [sym_noexcept] = ACTIONS(1448),
  },
  [445] = {
    [anon_sym_COMMA] = ACTIONS(1582),
    [anon_sym_RPAREN] = ACTIONS(1582),
    [anon_sym_SEMI] = ACTIONS(1582),
    [anon_sym_LBRACE] = ACTIONS(1582),
    [anon_sym_LPAREN2] = ACTIONS(1582),
    [anon_sym_STAR] = ACTIONS(1582),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(1582),
    [anon_sym_const] = ACTIONS(1580),
    [anon_sym_restrict] = ACTIONS(1580),
    [anon_sym_volatile] = ACTIONS(1580),
    [anon_sym__Atomic] = ACTIONS(1580),
    [anon_sym_mutable] = ACTIONS(1580),
    [anon_sym_explicit] = ACTIONS(1580),
    [anon_sym_constexpr] = ACTIONS(1580),
    [anon_sym_COLON] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1582),
    [anon_sym_LT] = ACTIONS(1582),
    [anon_sym_DASH_GT] = ACTIONS(1582),
    [sym_identifier] = ACTIONS(1580),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1580),
    [anon_sym_override] = ACTIONS(1580),
    [anon_sym_GT2] = ACTIONS(1582),
    [sym_noexcept] = ACTIONS(1580),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
  },
  [446] = {
    [sym__type_declarator] = STATE(1100),
    [sym_pointer_type_declarator] = STATE(1100),
    [sym_function_type_declarator] = STATE(1100),
    [sym_array_type_declarator] = STATE(1100),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_STAR] = ACTIONS(2162),
    [sym_identifier] = ACTIONS(770),
    [sym_comment] = ACTIONS(91),
  },
  [447] = {
    [sym__type_declarator] = STATE(1101),
    [sym_pointer_type_declarator] = STATE(1101),
    [sym_function_type_declarator] = STATE(1101),
    [sym_array_type_declarator] = STATE(1101),
    [sym_type_qualifier] = STATE(1102),
    [aux_sym_type_definition_repeat1] = STATE(1102),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_STAR] = ACTIONS(768),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [sym_identifier] = ACTIONS(2164),
    [sym_comment] = ACTIONS(91),
  },
  [448] = {
    [anon_sym_RPAREN] = ACTIONS(2166),
    [anon_sym_SEMI] = ACTIONS(2166),
    [anon_sym_LPAREN2] = ACTIONS(2166),
    [anon_sym_LBRACK] = ACTIONS(2166),
    [sym_comment] = ACTIONS(91),
  },
  [449] = {
    [sym_parameter_list] = STATE(1105),
    [anon_sym_SEMI] = ACTIONS(2168),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [sym_comment] = ACTIONS(91),
  },
  [450] = {
    [sym_identifier] = ACTIONS(2172),
    [sym_comment] = ACTIONS(91),
  },
  [451] = {
    [anon_sym_LBRACE] = ACTIONS(1799),
    [anon_sym_LPAREN2] = ACTIONS(1799),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_COLON] = ACTIONS(1801),
    [sym_identifier] = ACTIONS(1801),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1801),
    [anon_sym_override] = ACTIONS(1801),
    [anon_sym_COLON_COLON] = ACTIONS(1799),
  },
  [452] = {
    [sym__type_declarator] = STATE(1107),
    [sym_pointer_type_declarator] = STATE(1107),
    [sym_function_type_declarator] = STATE(1107),
    [sym_array_type_declarator] = STATE(1107),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_STAR] = ACTIONS(768),
    [sym_identifier] = ACTIONS(770),
    [sym_comment] = ACTIONS(91),
  },
  [453] = {
    [sym_type_qualifier] = STATE(453),
    [aux_sym_type_definition_repeat1] = STATE(453),
    [anon_sym_const] = ACTIONS(2174),
    [anon_sym_restrict] = ACTIONS(2174),
    [anon_sym_volatile] = ACTIONS(2174),
    [anon_sym__Atomic] = ACTIONS(2174),
    [anon_sym_mutable] = ACTIONS(2174),
    [anon_sym_explicit] = ACTIONS(2174),
    [anon_sym_constexpr] = ACTIONS(2174),
    [anon_sym_unsigned] = ACTIONS(2177),
    [anon_sym_long] = ACTIONS(2177),
    [anon_sym_short] = ACTIONS(2177),
    [sym_primitive_type] = ACTIONS(2177),
    [anon_sym_enum] = ACTIONS(2177),
    [anon_sym_struct] = ACTIONS(2177),
    [anon_sym_union] = ACTIONS(2177),
    [sym_identifier] = ACTIONS(2177),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2177),
    [sym_auto] = ACTIONS(2177),
    [anon_sym_typename] = ACTIONS(2177),
    [anon_sym_COLON_COLON] = ACTIONS(2179),
  },
  [454] = {
    [anon_sym_COMMA] = ACTIONS(1977),
    [anon_sym_SEMI] = ACTIONS(1977),
    [anon_sym_LBRACE] = ACTIONS(1977),
    [anon_sym_LPAREN2] = ACTIONS(1977),
    [anon_sym_STAR] = ACTIONS(1977),
    [anon_sym_LBRACK] = ACTIONS(1977),
    [anon_sym_EQ] = ACTIONS(1977),
    [anon_sym_const] = ACTIONS(1979),
    [anon_sym_restrict] = ACTIONS(1979),
    [anon_sym_volatile] = ACTIONS(1979),
    [anon_sym__Atomic] = ACTIONS(1979),
    [anon_sym_mutable] = ACTIONS(1979),
    [anon_sym_explicit] = ACTIONS(1979),
    [anon_sym_constexpr] = ACTIONS(1979),
    [anon_sym_COLON] = ACTIONS(1977),
    [anon_sym_AMP] = ACTIONS(1979),
    [anon_sym_AMP_AMP] = ACTIONS(1977),
    [anon_sym_DASH_GT] = ACTIONS(1977),
    [sym_identifier] = ACTIONS(1979),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1979),
    [anon_sym_override] = ACTIONS(1979),
    [sym_noexcept] = ACTIONS(1979),
  },
  [455] = {
    [anon_sym_COMMA] = ACTIONS(1981),
    [anon_sym_SEMI] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1981),
    [anon_sym_LPAREN2] = ACTIONS(1981),
    [anon_sym_STAR] = ACTIONS(1981),
    [anon_sym_LBRACK] = ACTIONS(1981),
    [anon_sym_EQ] = ACTIONS(1981),
    [anon_sym_const] = ACTIONS(1983),
    [anon_sym_restrict] = ACTIONS(1983),
    [anon_sym_volatile] = ACTIONS(1983),
    [anon_sym__Atomic] = ACTIONS(1983),
    [anon_sym_mutable] = ACTIONS(1983),
    [anon_sym_explicit] = ACTIONS(1983),
    [anon_sym_constexpr] = ACTIONS(1983),
    [anon_sym_COLON] = ACTIONS(1981),
    [anon_sym_AMP] = ACTIONS(1983),
    [anon_sym_AMP_AMP] = ACTIONS(1981),
    [anon_sym_DASH_GT] = ACTIONS(1981),
    [sym_identifier] = ACTIONS(1983),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1983),
    [anon_sym_override] = ACTIONS(1983),
    [sym_noexcept] = ACTIONS(1983),
  },
  [456] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(456),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1985),
    [anon_sym_unsigned] = ACTIONS(2181),
    [anon_sym_long] = ACTIONS(2181),
    [anon_sym_short] = ACTIONS(2181),
    [sym_primitive_type] = ACTIONS(1987),
    [sym_identifier] = ACTIONS(1987),
    [sym_comment] = ACTIONS(91),
  },
  [457] = {
    [sym_raw_string_literal] = ACTIONS(2184),
    [ts_builtin_sym_end] = ACTIONS(2184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2186),
    [sym_preproc_directive] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2184),
    [anon_sym_typedef] = ACTIONS(2186),
    [anon_sym_extern] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2184),
    [anon_sym_RBRACE] = ACTIONS(2184),
    [anon_sym_LPAREN2] = ACTIONS(2184),
    [anon_sym_STAR] = ACTIONS(2184),
    [anon_sym_LBRACK] = ACTIONS(2184),
    [anon_sym_static] = ACTIONS(2186),
    [anon_sym_register] = ACTIONS(2186),
    [anon_sym_inline] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_restrict] = ACTIONS(2186),
    [anon_sym_volatile] = ACTIONS(2186),
    [anon_sym__Atomic] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_explicit] = ACTIONS(2186),
    [anon_sym_constexpr] = ACTIONS(2186),
    [anon_sym_unsigned] = ACTIONS(2186),
    [anon_sym_long] = ACTIONS(2186),
    [anon_sym_short] = ACTIONS(2186),
    [sym_primitive_type] = ACTIONS(2186),
    [anon_sym_enum] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_union] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_switch] = ACTIONS(2186),
    [anon_sym_case] = ACTIONS(2186),
    [anon_sym_default] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [anon_sym_do] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_break] = ACTIONS(2186),
    [anon_sym_continue] = ACTIONS(2186),
    [anon_sym_goto] = ACTIONS(2186),
    [anon_sym_AMP] = ACTIONS(2186),
    [anon_sym_AMP_AMP] = ACTIONS(2184),
    [anon_sym_BANG] = ACTIONS(2184),
    [anon_sym_TILDE] = ACTIONS(2184),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_DASH] = ACTIONS(2186),
    [anon_sym_DASH_DASH] = ACTIONS(2184),
    [anon_sym_PLUS_PLUS] = ACTIONS(2184),
    [anon_sym_sizeof] = ACTIONS(2186),
    [sym_number_literal] = ACTIONS(2184),
    [anon_sym_SQUOTE] = ACTIONS(2184),
    [anon_sym_DQUOTE] = ACTIONS(2184),
    [sym_true] = ACTIONS(2186),
    [sym_false] = ACTIONS(2186),
    [sym_null] = ACTIONS(2186),
    [sym_identifier] = ACTIONS(2186),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2186),
    [sym_auto] = ACTIONS(2186),
    [anon_sym_typename] = ACTIONS(2186),
    [anon_sym_template] = ACTIONS(2186),
    [anon_sym_delete] = ACTIONS(2186),
    [anon_sym_namespace] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_new] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2184),
    [sym_operator_name] = ACTIONS(2184),
    [sym_nullptr] = ACTIONS(2186),
  },
  [458] = {
    [sym__declarator] = STATE(321),
    [sym_pointer_declarator] = STATE(321),
    [sym_function_declarator] = STATE(321),
    [sym_array_declarator] = STATE(321),
    [sym_init_declarator] = STATE(322),
    [sym_reference_declarator] = STATE(321),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(321),
    [sym_destructor_name] = STATE(321),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(560),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(568),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(570),
  },
  [459] = {
    [aux_sym_string_literal_repeat1] = STATE(1109),
    [anon_sym_DQUOTE] = ACTIONS(2188),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_BSLASHn_RBRACK_SLASH] = ACTIONS(2190),
    [sym_escape_sequence] = ACTIONS(2190),
    [sym_comment] = ACTIONS(121),
  },
  [460] = {
    [sym_raw_string_literal] = ACTIONS(668),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(670),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(670),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(670),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(670),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(670),
    [sym_preproc_directive] = ACTIONS(670),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(670),
    [anon_sym_extern] = ACTIONS(670),
    [anon_sym_LBRACE] = ACTIONS(668),
    [anon_sym_RBRACE] = ACTIONS(668),
    [anon_sym_LPAREN2] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(668),
    [anon_sym_LBRACK] = ACTIONS(668),
    [anon_sym_static] = ACTIONS(670),
    [anon_sym_register] = ACTIONS(670),
    [anon_sym_inline] = ACTIONS(670),
    [anon_sym_const] = ACTIONS(670),
    [anon_sym_restrict] = ACTIONS(670),
    [anon_sym_volatile] = ACTIONS(670),
    [anon_sym__Atomic] = ACTIONS(670),
    [anon_sym_mutable] = ACTIONS(670),
    [anon_sym_explicit] = ACTIONS(670),
    [anon_sym_constexpr] = ACTIONS(670),
    [anon_sym_unsigned] = ACTIONS(670),
    [anon_sym_long] = ACTIONS(670),
    [anon_sym_short] = ACTIONS(670),
    [sym_primitive_type] = ACTIONS(670),
    [anon_sym_enum] = ACTIONS(670),
    [anon_sym_struct] = ACTIONS(670),
    [anon_sym_union] = ACTIONS(670),
    [anon_sym_if] = ACTIONS(670),
    [anon_sym_switch] = ACTIONS(670),
    [anon_sym_case] = ACTIONS(670),
    [anon_sym_default] = ACTIONS(670),
    [anon_sym_while] = ACTIONS(670),
    [anon_sym_do] = ACTIONS(670),
    [anon_sym_for] = ACTIONS(670),
    [anon_sym_return] = ACTIONS(670),
    [anon_sym_break] = ACTIONS(670),
    [anon_sym_continue] = ACTIONS(670),
    [anon_sym_goto] = ACTIONS(670),
    [anon_sym_AMP] = ACTIONS(668),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_PLUS] = ACTIONS(670),
    [anon_sym_DASH] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(668),
    [anon_sym_PLUS_PLUS] = ACTIONS(668),
    [anon_sym_sizeof] = ACTIONS(670),
    [sym_number_literal] = ACTIONS(668),
    [anon_sym_SQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE] = ACTIONS(668),
    [sym_true] = ACTIONS(670),
    [sym_false] = ACTIONS(670),
    [sym_null] = ACTIONS(670),
    [sym_identifier] = ACTIONS(670),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(670),
    [sym_auto] = ACTIONS(670),
    [anon_sym_typename] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_try] = ACTIONS(670),
    [anon_sym_new] = ACTIONS(670),
    [anon_sym_COLON_COLON] = ACTIONS(668),
    [sym_nullptr] = ACTIONS(670),
  },
  [461] = {
    [sym_preproc_params] = STATE(1112),
    [anon_sym_LF] = ACTIONS(2192),
    [anon_sym_LPAREN] = ACTIONS(674),
    [sym_preproc_arg] = ACTIONS(2194),
    [sym_comment] = ACTIONS(121),
  },
  [462] = {
    [sym_preproc_include] = STATE(1141),
    [sym_preproc_def] = STATE(1141),
    [sym_preproc_function_def] = STATE(1141),
    [sym_preproc_call] = STATE(1141),
    [sym_preproc_if_in_compound_statement] = STATE(1141),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1141),
    [sym_preproc_else_in_compound_statement] = STATE(1137),
    [sym_preproc_elif_in_compound_statement] = STATE(1137),
    [sym_declaration] = STATE(1141),
    [sym_type_definition] = STATE(1141),
    [sym__declaration_specifiers] = STATE(1138),
    [sym_compound_statement] = STATE(1141),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(1141),
    [sym_expression_statement] = STATE(1141),
    [sym_if_statement] = STATE(1141),
    [sym_switch_statement] = STATE(1141),
    [sym_case_statement] = STATE(1141),
    [sym_while_statement] = STATE(1141),
    [sym_do_statement] = STATE(1141),
    [sym_for_statement] = STATE(1141),
    [sym_return_statement] = STATE(1141),
    [sym_break_statement] = STATE(1141),
    [sym_continue_statement] = STATE(1141),
    [sym_goto_statement] = STATE(1141),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(1141),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(1141),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(1141),
    [sym_try_statement] = STATE(1141),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1141),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(2196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2198),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2200),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2204),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2208),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2210),
    [sym_preproc_directive] = ACTIONS(2212),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_typedef] = ACTIONS(2216),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(2220),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(2244),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_nullptr] = ACTIONS(2242),
  },
  [463] = {
    [sym_preproc_include] = STATE(1144),
    [sym_preproc_def] = STATE(1144),
    [sym_preproc_function_def] = STATE(1144),
    [sym_preproc_call] = STATE(1144),
    [sym_preproc_if_in_compound_statement] = STATE(1144),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1144),
    [sym_preproc_else_in_compound_statement] = STATE(1143),
    [sym_preproc_elif_in_compound_statement] = STATE(1143),
    [sym_declaration] = STATE(1144),
    [sym_type_definition] = STATE(1144),
    [sym__declaration_specifiers] = STATE(1138),
    [sym_compound_statement] = STATE(1144),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(1144),
    [sym_expression_statement] = STATE(1144),
    [sym_if_statement] = STATE(1144),
    [sym_switch_statement] = STATE(1144),
    [sym_case_statement] = STATE(1144),
    [sym_while_statement] = STATE(1144),
    [sym_do_statement] = STATE(1144),
    [sym_for_statement] = STATE(1144),
    [sym_return_statement] = STATE(1144),
    [sym_break_statement] = STATE(1144),
    [sym_continue_statement] = STATE(1144),
    [sym_goto_statement] = STATE(1144),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(1144),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(1144),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(1144),
    [sym_try_statement] = STATE(1144),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1144),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(2196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2198),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2200),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2208),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2210),
    [sym_preproc_directive] = ACTIONS(2212),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_typedef] = ACTIONS(2216),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(2220),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(2244),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_nullptr] = ACTIONS(2242),
  },
  [464] = {
    [sym_raw_string_literal] = ACTIONS(740),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(742),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(742),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(742),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(742),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(742),
    [sym_preproc_directive] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(740),
    [anon_sym_typedef] = ACTIONS(742),
    [anon_sym_extern] = ACTIONS(742),
    [anon_sym_LBRACE] = ACTIONS(740),
    [anon_sym_RBRACE] = ACTIONS(740),
    [anon_sym_LPAREN2] = ACTIONS(740),
    [anon_sym_STAR] = ACTIONS(740),
    [anon_sym_LBRACK] = ACTIONS(740),
    [anon_sym_static] = ACTIONS(742),
    [anon_sym_register] = ACTIONS(742),
    [anon_sym_inline] = ACTIONS(742),
    [anon_sym_const] = ACTIONS(742),
    [anon_sym_restrict] = ACTIONS(742),
    [anon_sym_volatile] = ACTIONS(742),
    [anon_sym__Atomic] = ACTIONS(742),
    [anon_sym_mutable] = ACTIONS(742),
    [anon_sym_explicit] = ACTIONS(742),
    [anon_sym_constexpr] = ACTIONS(742),
    [anon_sym_unsigned] = ACTIONS(742),
    [anon_sym_long] = ACTIONS(742),
    [anon_sym_short] = ACTIONS(742),
    [sym_primitive_type] = ACTIONS(742),
    [anon_sym_enum] = ACTIONS(742),
    [anon_sym_struct] = ACTIONS(742),
    [anon_sym_union] = ACTIONS(742),
    [anon_sym_if] = ACTIONS(742),
    [anon_sym_switch] = ACTIONS(742),
    [anon_sym_case] = ACTIONS(742),
    [anon_sym_default] = ACTIONS(742),
    [anon_sym_while] = ACTIONS(742),
    [anon_sym_do] = ACTIONS(742),
    [anon_sym_for] = ACTIONS(742),
    [anon_sym_return] = ACTIONS(742),
    [anon_sym_break] = ACTIONS(742),
    [anon_sym_continue] = ACTIONS(742),
    [anon_sym_goto] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(740),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(742),
    [anon_sym_DASH] = ACTIONS(742),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_sizeof] = ACTIONS(742),
    [sym_number_literal] = ACTIONS(740),
    [anon_sym_SQUOTE] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(740),
    [sym_true] = ACTIONS(742),
    [sym_false] = ACTIONS(742),
    [sym_null] = ACTIONS(742),
    [sym_identifier] = ACTIONS(742),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(742),
    [sym_auto] = ACTIONS(742),
    [anon_sym_typename] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(742),
    [anon_sym_try] = ACTIONS(742),
    [anon_sym_new] = ACTIONS(742),
    [anon_sym_COLON_COLON] = ACTIONS(740),
    [sym_nullptr] = ACTIONS(742),
  },
  [465] = {
    [anon_sym_LF] = ACTIONS(2250),
    [sym_comment] = ACTIONS(121),
  },
  [466] = {
    [sym__type_declarator] = STATE(1146),
    [sym_pointer_type_declarator] = STATE(1146),
    [sym_function_type_declarator] = STATE(1146),
    [sym_array_type_declarator] = STATE(1146),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_STAR] = ACTIONS(768),
    [sym_identifier] = ACTIONS(770),
    [sym_comment] = ACTIONS(91),
  },
  [467] = {
    [sym_type_qualifier] = STATE(453),
    [sym__type_specifier] = STATE(1147),
    [sym_sized_type_specifier] = STATE(1147),
    [sym_enum_specifier] = STATE(1147),
    [sym_struct_specifier] = STATE(1147),
    [sym_union_specifier] = STATE(1147),
    [sym_macro_type_specifier] = STATE(1147),
    [sym_class_specifier] = STATE(1147),
    [sym_dependent_type] = STATE(1147),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(82),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_type_definition_repeat1] = STATE(453),
    [aux_sym_sized_type_specifier_repeat1] = STATE(85),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(135),
    [anon_sym_long] = ACTIONS(135),
    [anon_sym_short] = ACTIONS(135),
    [sym_primitive_type] = ACTIONS(2252),
    [anon_sym_enum] = ACTIONS(139),
    [anon_sym_struct] = ACTIONS(141),
    [anon_sym_union] = ACTIONS(143),
    [sym_identifier] = ACTIONS(145),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(147),
    [sym_auto] = ACTIONS(2252),
    [anon_sym_typename] = ACTIONS(149),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [468] = {
    [sym_raw_string_literal] = ACTIONS(801),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(803),
    [sym_preproc_directive] = ACTIONS(803),
    [anon_sym_SEMI] = ACTIONS(801),
    [anon_sym_typedef] = ACTIONS(803),
    [anon_sym_extern] = ACTIONS(803),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(801),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(801),
    [anon_sym_LBRACK] = ACTIONS(801),
    [anon_sym_static] = ACTIONS(803),
    [anon_sym_register] = ACTIONS(803),
    [anon_sym_inline] = ACTIONS(803),
    [anon_sym_const] = ACTIONS(803),
    [anon_sym_restrict] = ACTIONS(803),
    [anon_sym_volatile] = ACTIONS(803),
    [anon_sym__Atomic] = ACTIONS(803),
    [anon_sym_mutable] = ACTIONS(803),
    [anon_sym_explicit] = ACTIONS(803),
    [anon_sym_constexpr] = ACTIONS(803),
    [anon_sym_unsigned] = ACTIONS(803),
    [anon_sym_long] = ACTIONS(803),
    [anon_sym_short] = ACTIONS(803),
    [sym_primitive_type] = ACTIONS(803),
    [anon_sym_enum] = ACTIONS(803),
    [anon_sym_struct] = ACTIONS(803),
    [anon_sym_union] = ACTIONS(803),
    [anon_sym_if] = ACTIONS(803),
    [anon_sym_else] = ACTIONS(803),
    [anon_sym_switch] = ACTIONS(803),
    [anon_sym_case] = ACTIONS(803),
    [anon_sym_default] = ACTIONS(803),
    [anon_sym_while] = ACTIONS(803),
    [anon_sym_do] = ACTIONS(803),
    [anon_sym_for] = ACTIONS(803),
    [anon_sym_return] = ACTIONS(803),
    [anon_sym_break] = ACTIONS(803),
    [anon_sym_continue] = ACTIONS(803),
    [anon_sym_goto] = ACTIONS(803),
    [anon_sym_AMP] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_DASH] = ACTIONS(803),
    [anon_sym_DASH_DASH] = ACTIONS(801),
    [anon_sym_PLUS_PLUS] = ACTIONS(801),
    [anon_sym_sizeof] = ACTIONS(803),
    [sym_number_literal] = ACTIONS(801),
    [anon_sym_SQUOTE] = ACTIONS(801),
    [anon_sym_DQUOTE] = ACTIONS(801),
    [sym_true] = ACTIONS(803),
    [sym_false] = ACTIONS(803),
    [sym_null] = ACTIONS(803),
    [sym_identifier] = ACTIONS(803),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(803),
    [sym_auto] = ACTIONS(803),
    [anon_sym_typename] = ACTIONS(803),
    [anon_sym_delete] = ACTIONS(803),
    [anon_sym_try] = ACTIONS(803),
    [anon_sym_catch] = ACTIONS(803),
    [anon_sym_new] = ACTIONS(803),
    [anon_sym_COLON_COLON] = ACTIONS(801),
    [sym_nullptr] = ACTIONS(803),
  },
  [469] = {
    [sym_preproc_include] = STATE(496),
    [sym_preproc_def] = STATE(496),
    [sym_preproc_function_def] = STATE(496),
    [sym_preproc_call] = STATE(496),
    [sym_preproc_if_in_compound_statement] = STATE(496),
    [sym_preproc_ifdef_in_compound_statement] = STATE(496),
    [sym_declaration] = STATE(496),
    [sym_type_definition] = STATE(496),
    [sym__declaration_specifiers] = STATE(113),
    [sym_compound_statement] = STATE(496),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(496),
    [sym_expression_statement] = STATE(496),
    [sym_if_statement] = STATE(496),
    [sym_switch_statement] = STATE(496),
    [sym_case_statement] = STATE(496),
    [sym_while_statement] = STATE(496),
    [sym_do_statement] = STATE(496),
    [sym_for_statement] = STATE(496),
    [sym_return_statement] = STATE(496),
    [sym_break_statement] = STATE(496),
    [sym_continue_statement] = STATE(496),
    [sym_goto_statement] = STATE(496),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(496),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(496),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(496),
    [sym_try_statement] = STATE(496),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(496),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(157),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(159),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(161),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(163),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(165),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(165),
    [sym_preproc_directive] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_typedef] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_RBRACE] = ACTIONS(2254),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(185),
    [anon_sym_case] = ACTIONS(187),
    [anon_sym_default] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(209),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_nullptr] = ACTIONS(207),
  },
  [470] = {
    [sym_type_qualifier] = STATE(141),
    [sym__type_specifier] = STATE(136),
    [sym_sized_type_specifier] = STATE(136),
    [sym_enum_specifier] = STATE(136),
    [sym_struct_specifier] = STATE(136),
    [sym_union_specifier] = STATE(136),
    [sym__expression] = STATE(137),
    [sym_comma_expression] = STATE(138),
    [sym_conditional_expression] = STATE(137),
    [sym_assignment_expression] = STATE(137),
    [sym_pointer_expression] = STATE(137),
    [sym_logical_expression] = STATE(137),
    [sym_bitwise_expression] = STATE(137),
    [sym_equality_expression] = STATE(137),
    [sym_relational_expression] = STATE(137),
    [sym_shift_expression] = STATE(137),
    [sym_math_expression] = STATE(137),
    [sym_cast_expression] = STATE(137),
    [sym_type_descriptor] = STATE(498),
    [sym_sizeof_expression] = STATE(137),
    [sym_subscript_expression] = STATE(137),
    [sym_call_expression] = STATE(137),
    [sym_field_expression] = STATE(137),
    [sym_compound_literal_expression] = STATE(137),
    [sym_parenthesized_expression] = STATE(137),
    [sym_char_literal] = STATE(137),
    [sym_concatenated_string] = STATE(137),
    [sym_string_literal] = STATE(140),
    [sym_macro_type_specifier] = STATE(136),
    [sym_class_specifier] = STATE(136),
    [sym_dependent_type] = STATE(136),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(137),
    [sym_new_expression] = STATE(137),
    [sym_delete_expression] = STATE(137),
    [sym_lambda_expression] = STATE(137),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_type_definition_repeat1] = STATE(141),
    [aux_sym_sized_type_specifier_repeat1] = STATE(142),
    [sym_raw_string_literal] = ACTIONS(213),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(219),
    [anon_sym_long] = ACTIONS(219),
    [anon_sym_short] = ACTIONS(219),
    [sym_primitive_type] = ACTIONS(221),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [sym_null] = ACTIONS(241),
    [sym_identifier] = ACTIONS(811),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(221),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(253),
    [sym_nullptr] = ACTIONS(241),
  },
  [471] = {
    [sym__expression] = STATE(146),
    [sym_conditional_expression] = STATE(146),
    [sym_assignment_expression] = STATE(146),
    [sym_pointer_expression] = STATE(146),
    [sym_logical_expression] = STATE(146),
    [sym_bitwise_expression] = STATE(146),
    [sym_equality_expression] = STATE(146),
    [sym_relational_expression] = STATE(146),
    [sym_shift_expression] = STATE(146),
    [sym_math_expression] = STATE(146),
    [sym_cast_expression] = STATE(146),
    [sym_sizeof_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_compound_literal_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_char_literal] = STATE(146),
    [sym_concatenated_string] = STATE(146),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(146),
    [sym_new_expression] = STATE(146),
    [sym_delete_expression] = STATE(146),
    [sym_lambda_expression] = STATE(146),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(257),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(257),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(259),
    [sym_false] = ACTIONS(259),
    [sym_null] = ACTIONS(259),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(259),
  },
  [472] = {
    [sym__expression] = STATE(252),
    [sym_conditional_expression] = STATE(252),
    [sym_assignment_expression] = STATE(252),
    [sym_pointer_expression] = STATE(252),
    [sym_logical_expression] = STATE(252),
    [sym_bitwise_expression] = STATE(252),
    [sym_equality_expression] = STATE(252),
    [sym_relational_expression] = STATE(252),
    [sym_shift_expression] = STATE(252),
    [sym_math_expression] = STATE(252),
    [sym_cast_expression] = STATE(252),
    [sym_sizeof_expression] = STATE(252),
    [sym_subscript_expression] = STATE(252),
    [sym_call_expression] = STATE(252),
    [sym_field_expression] = STATE(252),
    [sym_compound_literal_expression] = STATE(252),
    [sym_parenthesized_expression] = STATE(252),
    [sym_char_literal] = STATE(252),
    [sym_concatenated_string] = STATE(252),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(252),
    [sym_new_expression] = STATE(252),
    [sym_delete_expression] = STATE(252),
    [sym_lambda_expression] = STATE(252),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(439),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(439),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(441),
    [sym_false] = ACTIONS(441),
    [sym_null] = ACTIONS(441),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(441),
  },
  [473] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(263),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(465),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(465),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(474),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(486),
  },
  [474] = {
    [sym__expression] = STATE(1149),
    [sym_conditional_expression] = STATE(1149),
    [sym_assignment_expression] = STATE(1149),
    [sym_pointer_expression] = STATE(1149),
    [sym_logical_expression] = STATE(1149),
    [sym_bitwise_expression] = STATE(1149),
    [sym_equality_expression] = STATE(1149),
    [sym_relational_expression] = STATE(1149),
    [sym_shift_expression] = STATE(1149),
    [sym_math_expression] = STATE(1149),
    [sym_cast_expression] = STATE(1149),
    [sym_sizeof_expression] = STATE(1149),
    [sym_subscript_expression] = STATE(1149),
    [sym_call_expression] = STATE(1149),
    [sym_field_expression] = STATE(1149),
    [sym_compound_literal_expression] = STATE(1149),
    [sym_parenthesized_expression] = STATE(1149),
    [sym_char_literal] = STATE(1149),
    [sym_concatenated_string] = STATE(1149),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1149),
    [sym_new_expression] = STATE(1149),
    [sym_delete_expression] = STATE(1149),
    [sym_lambda_expression] = STATE(1149),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2256),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(2256),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2258),
    [sym_false] = ACTIONS(2258),
    [sym_null] = ACTIONS(2258),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(2258),
  },
  [475] = {
    [anon_sym_LPAREN2] = ACTIONS(2260),
    [sym_comment] = ACTIONS(91),
  },
  [476] = {
    [sym_compound_statement] = STATE(1152),
    [sym_labeled_statement] = STATE(1152),
    [sym_expression_statement] = STATE(1152),
    [sym_if_statement] = STATE(1152),
    [sym_switch_statement] = STATE(1152),
    [sym_case_statement] = STATE(1152),
    [sym_while_statement] = STATE(1152),
    [sym_do_statement] = STATE(1152),
    [sym_for_statement] = STATE(1152),
    [sym_return_statement] = STATE(1152),
    [sym_break_statement] = STATE(1152),
    [sym_continue_statement] = STATE(1152),
    [sym_goto_statement] = STATE(1152),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(1152),
    [sym_try_statement] = STATE(1152),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(157),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(185),
    [anon_sym_case] = ACTIONS(187),
    [anon_sym_default] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(2262),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(207),
  },
  [477] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_COLON] = ACTIONS(2264),
    [anon_sym_QMARK] = ACTIONS(1171),
    [anon_sym_STAR_EQ] = ACTIONS(1173),
    [anon_sym_SLASH_EQ] = ACTIONS(1173),
    [anon_sym_PERCENT_EQ] = ACTIONS(1173),
    [anon_sym_PLUS_EQ] = ACTIONS(1173),
    [anon_sym_DASH_EQ] = ACTIONS(1173),
    [anon_sym_LT_LT_EQ] = ACTIONS(1173),
    [anon_sym_GT_GT_EQ] = ACTIONS(1173),
    [anon_sym_AMP_EQ] = ACTIONS(1173),
    [anon_sym_CARET_EQ] = ACTIONS(1173),
    [anon_sym_PIPE_EQ] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_CARET] = ACTIONS(1183),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [478] = {
    [sym_declaration] = STATE(1155),
    [sym_type_definition] = STATE(1155),
    [sym__declaration_specifiers] = STATE(1156),
    [sym_compound_statement] = STATE(1155),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_labeled_statement] = STATE(1155),
    [sym_expression_statement] = STATE(1155),
    [sym_if_statement] = STATE(1155),
    [sym_switch_statement] = STATE(1155),
    [sym_case_statement] = STATE(1155),
    [sym_while_statement] = STATE(1155),
    [sym_do_statement] = STATE(1155),
    [sym_for_statement] = STATE(1155),
    [sym_return_statement] = STATE(1155),
    [sym_break_statement] = STATE(1155),
    [sym_continue_statement] = STATE(1155),
    [sym_goto_statement] = STATE(1155),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(1155),
    [sym_try_statement] = STATE(1155),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(157),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_typedef] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(185),
    [anon_sym_case] = ACTIONS(187),
    [anon_sym_default] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(2266),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(1202),
    [sym_nullptr] = ACTIONS(207),
  },
  [479] = {
    [sym_compound_statement] = STATE(1157),
    [sym_labeled_statement] = STATE(1157),
    [sym_expression_statement] = STATE(1157),
    [sym_if_statement] = STATE(1157),
    [sym_switch_statement] = STATE(1157),
    [sym_case_statement] = STATE(1157),
    [sym_while_statement] = STATE(1157),
    [sym_do_statement] = STATE(1157),
    [sym_for_statement] = STATE(1157),
    [sym_return_statement] = STATE(1157),
    [sym_break_statement] = STATE(1157),
    [sym_continue_statement] = STATE(1157),
    [sym_goto_statement] = STATE(1157),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(1157),
    [sym_try_statement] = STATE(1157),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(157),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(185),
    [anon_sym_case] = ACTIONS(187),
    [anon_sym_default] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(2262),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(207),
  },
  [480] = {
    [anon_sym_while] = ACTIONS(2268),
    [sym_comment] = ACTIONS(91),
  },
  [481] = {
    [sym_declaration] = STATE(1159),
    [sym__declaration_specifiers] = STATE(709),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym__expression] = STATE(1160),
    [sym_conditional_expression] = STATE(1160),
    [sym_assignment_expression] = STATE(1160),
    [sym_pointer_expression] = STATE(1160),
    [sym_logical_expression] = STATE(1160),
    [sym_bitwise_expression] = STATE(1160),
    [sym_equality_expression] = STATE(1160),
    [sym_relational_expression] = STATE(1160),
    [sym_shift_expression] = STATE(1160),
    [sym_math_expression] = STATE(1160),
    [sym_cast_expression] = STATE(1160),
    [sym_sizeof_expression] = STATE(1160),
    [sym_subscript_expression] = STATE(1160),
    [sym_call_expression] = STATE(1160),
    [sym_field_expression] = STATE(1160),
    [sym_compound_literal_expression] = STATE(1160),
    [sym_parenthesized_expression] = STATE(1160),
    [sym_char_literal] = STATE(1160),
    [sym_concatenated_string] = STATE(1160),
    [sym_string_literal] = STATE(238),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(1160),
    [sym_for_range_declaration] = STATE(1161),
    [sym_new_expression] = STATE(1160),
    [sym_delete_expression] = STATE(1160),
    [sym_lambda_expression] = STATE(1160),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(2270),
    [anon_sym_SEMI] = ACTIONS(2272),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(2270),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2274),
    [sym_false] = ACTIONS(2274),
    [sym_null] = ACTIONS(2274),
    [sym_identifier] = ACTIONS(1242),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(1244),
    [sym_nullptr] = ACTIONS(2274),
  },
  [482] = {
    [sym_raw_string_literal] = ACTIONS(1246),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1248),
    [sym_preproc_directive] = ACTIONS(1248),
    [anon_sym_SEMI] = ACTIONS(1246),
    [anon_sym_typedef] = ACTIONS(1248),
    [anon_sym_extern] = ACTIONS(1248),
    [anon_sym_LBRACE] = ACTIONS(1246),
    [anon_sym_RBRACE] = ACTIONS(1246),
    [anon_sym_LPAREN2] = ACTIONS(1246),
    [anon_sym_STAR] = ACTIONS(1246),
    [anon_sym_LBRACK] = ACTIONS(1246),
    [anon_sym_static] = ACTIONS(1248),
    [anon_sym_register] = ACTIONS(1248),
    [anon_sym_inline] = ACTIONS(1248),
    [anon_sym_const] = ACTIONS(1248),
    [anon_sym_restrict] = ACTIONS(1248),
    [anon_sym_volatile] = ACTIONS(1248),
    [anon_sym__Atomic] = ACTIONS(1248),
    [anon_sym_mutable] = ACTIONS(1248),
    [anon_sym_explicit] = ACTIONS(1248),
    [anon_sym_constexpr] = ACTIONS(1248),
    [anon_sym_unsigned] = ACTIONS(1248),
    [anon_sym_long] = ACTIONS(1248),
    [anon_sym_short] = ACTIONS(1248),
    [sym_primitive_type] = ACTIONS(1248),
    [anon_sym_enum] = ACTIONS(1248),
    [anon_sym_struct] = ACTIONS(1248),
    [anon_sym_union] = ACTIONS(1248),
    [anon_sym_if] = ACTIONS(1248),
    [anon_sym_else] = ACTIONS(1248),
    [anon_sym_switch] = ACTIONS(1248),
    [anon_sym_case] = ACTIONS(1248),
    [anon_sym_default] = ACTIONS(1248),
    [anon_sym_while] = ACTIONS(1248),
    [anon_sym_do] = ACTIONS(1248),
    [anon_sym_for] = ACTIONS(1248),
    [anon_sym_return] = ACTIONS(1248),
    [anon_sym_break] = ACTIONS(1248),
    [anon_sym_continue] = ACTIONS(1248),
    [anon_sym_goto] = ACTIONS(1248),
    [anon_sym_AMP] = ACTIONS(1246),
    [anon_sym_BANG] = ACTIONS(1246),
    [anon_sym_TILDE] = ACTIONS(1246),
    [anon_sym_PLUS] = ACTIONS(1248),
    [anon_sym_DASH] = ACTIONS(1248),
    [anon_sym_DASH_DASH] = ACTIONS(1246),
    [anon_sym_PLUS_PLUS] = ACTIONS(1246),
    [anon_sym_sizeof] = ACTIONS(1248),
    [sym_number_literal] = ACTIONS(1246),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [anon_sym_DQUOTE] = ACTIONS(1246),
    [sym_true] = ACTIONS(1248),
    [sym_false] = ACTIONS(1248),
    [sym_null] = ACTIONS(1248),
    [sym_identifier] = ACTIONS(1248),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1248),
    [sym_auto] = ACTIONS(1248),
    [anon_sym_typename] = ACTIONS(1248),
    [anon_sym_delete] = ACTIONS(1248),
    [anon_sym_try] = ACTIONS(1248),
    [anon_sym_new] = ACTIONS(1248),
    [anon_sym_COLON_COLON] = ACTIONS(1246),
    [sym_nullptr] = ACTIONS(1248),
  },
  [483] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(2276),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [484] = {
    [anon_sym_SEMI] = ACTIONS(2276),
    [sym_comment] = ACTIONS(91),
  },
  [485] = {
    [sym_raw_string_literal] = ACTIONS(1332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1334),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1334),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1334),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1334),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1334),
    [sym_preproc_directive] = ACTIONS(1334),
    [anon_sym_SEMI] = ACTIONS(1332),
    [anon_sym_typedef] = ACTIONS(1334),
    [anon_sym_extern] = ACTIONS(1334),
    [anon_sym_LBRACE] = ACTIONS(1332),
    [anon_sym_RBRACE] = ACTIONS(1332),
    [anon_sym_LPAREN2] = ACTIONS(1332),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_LBRACK] = ACTIONS(1332),
    [anon_sym_static] = ACTIONS(1334),
    [anon_sym_register] = ACTIONS(1334),
    [anon_sym_inline] = ACTIONS(1334),
    [anon_sym_const] = ACTIONS(1334),
    [anon_sym_restrict] = ACTIONS(1334),
    [anon_sym_volatile] = ACTIONS(1334),
    [anon_sym__Atomic] = ACTIONS(1334),
    [anon_sym_mutable] = ACTIONS(1334),
    [anon_sym_explicit] = ACTIONS(1334),
    [anon_sym_constexpr] = ACTIONS(1334),
    [anon_sym_unsigned] = ACTIONS(1334),
    [anon_sym_long] = ACTIONS(1334),
    [anon_sym_short] = ACTIONS(1334),
    [sym_primitive_type] = ACTIONS(1334),
    [anon_sym_enum] = ACTIONS(1334),
    [anon_sym_struct] = ACTIONS(1334),
    [anon_sym_union] = ACTIONS(1334),
    [anon_sym_if] = ACTIONS(1334),
    [anon_sym_else] = ACTIONS(1334),
    [anon_sym_switch] = ACTIONS(1334),
    [anon_sym_case] = ACTIONS(1334),
    [anon_sym_default] = ACTIONS(1334),
    [anon_sym_while] = ACTIONS(1334),
    [anon_sym_do] = ACTIONS(1334),
    [anon_sym_for] = ACTIONS(1334),
    [anon_sym_return] = ACTIONS(1334),
    [anon_sym_break] = ACTIONS(1334),
    [anon_sym_continue] = ACTIONS(1334),
    [anon_sym_goto] = ACTIONS(1334),
    [anon_sym_AMP] = ACTIONS(1332),
    [anon_sym_BANG] = ACTIONS(1332),
    [anon_sym_TILDE] = ACTIONS(1332),
    [anon_sym_PLUS] = ACTIONS(1334),
    [anon_sym_DASH] = ACTIONS(1334),
    [anon_sym_DASH_DASH] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(1332),
    [anon_sym_sizeof] = ACTIONS(1334),
    [sym_number_literal] = ACTIONS(1332),
    [anon_sym_SQUOTE] = ACTIONS(1332),
    [anon_sym_DQUOTE] = ACTIONS(1332),
    [sym_true] = ACTIONS(1334),
    [sym_false] = ACTIONS(1334),
    [sym_null] = ACTIONS(1334),
    [sym_identifier] = ACTIONS(1334),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1334),
    [sym_auto] = ACTIONS(1334),
    [anon_sym_typename] = ACTIONS(1334),
    [anon_sym_delete] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1334),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_COLON_COLON] = ACTIONS(1332),
    [sym_nullptr] = ACTIONS(1334),
  },
  [486] = {
    [sym_raw_string_literal] = ACTIONS(1336),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1338),
    [sym_preproc_directive] = ACTIONS(1338),
    [anon_sym_SEMI] = ACTIONS(1336),
    [anon_sym_typedef] = ACTIONS(1338),
    [anon_sym_extern] = ACTIONS(1338),
    [anon_sym_LBRACE] = ACTIONS(1336),
    [anon_sym_RBRACE] = ACTIONS(1336),
    [anon_sym_LPAREN2] = ACTIONS(1336),
    [anon_sym_STAR] = ACTIONS(1336),
    [anon_sym_LBRACK] = ACTIONS(1336),
    [anon_sym_static] = ACTIONS(1338),
    [anon_sym_register] = ACTIONS(1338),
    [anon_sym_inline] = ACTIONS(1338),
    [anon_sym_const] = ACTIONS(1338),
    [anon_sym_restrict] = ACTIONS(1338),
    [anon_sym_volatile] = ACTIONS(1338),
    [anon_sym__Atomic] = ACTIONS(1338),
    [anon_sym_mutable] = ACTIONS(1338),
    [anon_sym_explicit] = ACTIONS(1338),
    [anon_sym_constexpr] = ACTIONS(1338),
    [anon_sym_unsigned] = ACTIONS(1338),
    [anon_sym_long] = ACTIONS(1338),
    [anon_sym_short] = ACTIONS(1338),
    [sym_primitive_type] = ACTIONS(1338),
    [anon_sym_enum] = ACTIONS(1338),
    [anon_sym_struct] = ACTIONS(1338),
    [anon_sym_union] = ACTIONS(1338),
    [anon_sym_if] = ACTIONS(1338),
    [anon_sym_else] = ACTIONS(1338),
    [anon_sym_switch] = ACTIONS(1338),
    [anon_sym_case] = ACTIONS(1338),
    [anon_sym_default] = ACTIONS(1338),
    [anon_sym_while] = ACTIONS(1338),
    [anon_sym_do] = ACTIONS(1338),
    [anon_sym_for] = ACTIONS(1338),
    [anon_sym_return] = ACTIONS(1338),
    [anon_sym_break] = ACTIONS(1338),
    [anon_sym_continue] = ACTIONS(1338),
    [anon_sym_goto] = ACTIONS(1338),
    [anon_sym_AMP] = ACTIONS(1336),
    [anon_sym_BANG] = ACTIONS(1336),
    [anon_sym_TILDE] = ACTIONS(1336),
    [anon_sym_PLUS] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_DASH_DASH] = ACTIONS(1336),
    [anon_sym_PLUS_PLUS] = ACTIONS(1336),
    [anon_sym_sizeof] = ACTIONS(1338),
    [sym_number_literal] = ACTIONS(1336),
    [anon_sym_SQUOTE] = ACTIONS(1336),
    [anon_sym_DQUOTE] = ACTIONS(1336),
    [sym_true] = ACTIONS(1338),
    [sym_false] = ACTIONS(1338),
    [sym_null] = ACTIONS(1338),
    [sym_identifier] = ACTIONS(1338),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1338),
    [sym_auto] = ACTIONS(1338),
    [anon_sym_typename] = ACTIONS(1338),
    [anon_sym_delete] = ACTIONS(1338),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_new] = ACTIONS(1338),
    [anon_sym_COLON_COLON] = ACTIONS(1336),
    [sym_nullptr] = ACTIONS(1338),
  },
  [487] = {
    [anon_sym_SEMI] = ACTIONS(2278),
    [sym_comment] = ACTIONS(91),
  },
  [488] = {
    [sym_compound_statement] = STATE(1164),
    [sym_labeled_statement] = STATE(1164),
    [sym_expression_statement] = STATE(1164),
    [sym_if_statement] = STATE(1164),
    [sym_switch_statement] = STATE(1164),
    [sym_case_statement] = STATE(1164),
    [sym_while_statement] = STATE(1164),
    [sym_do_statement] = STATE(1164),
    [sym_for_statement] = STATE(1164),
    [sym_return_statement] = STATE(1164),
    [sym_break_statement] = STATE(1164),
    [sym_continue_statement] = STATE(1164),
    [sym_goto_statement] = STATE(1164),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(1164),
    [sym_try_statement] = STATE(1164),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(157),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(185),
    [anon_sym_case] = ACTIONS(187),
    [anon_sym_default] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(2262),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(207),
  },
  [489] = {
    [sym_catch_clause] = STATE(1166),
    [aux_sym_try_statement_repeat1] = STATE(1166),
    [sym_comment] = ACTIONS(91),
    [anon_sym_catch] = ACTIONS(2280),
  },
  [490] = {
    [sym_raw_string_literal] = ACTIONS(1597),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1599),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1599),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1599),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1599),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1599),
    [sym_preproc_directive] = ACTIONS(1599),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_typedef] = ACTIONS(1599),
    [anon_sym_extern] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(1597),
    [anon_sym_LPAREN2] = ACTIONS(1597),
    [anon_sym_STAR] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_static] = ACTIONS(1599),
    [anon_sym_register] = ACTIONS(1599),
    [anon_sym_inline] = ACTIONS(1599),
    [anon_sym_const] = ACTIONS(1599),
    [anon_sym_restrict] = ACTIONS(1599),
    [anon_sym_volatile] = ACTIONS(1599),
    [anon_sym__Atomic] = ACTIONS(1599),
    [anon_sym_mutable] = ACTIONS(1599),
    [anon_sym_explicit] = ACTIONS(1599),
    [anon_sym_constexpr] = ACTIONS(1599),
    [anon_sym_unsigned] = ACTIONS(1599),
    [anon_sym_long] = ACTIONS(1599),
    [anon_sym_short] = ACTIONS(1599),
    [sym_primitive_type] = ACTIONS(1599),
    [anon_sym_enum] = ACTIONS(1599),
    [anon_sym_struct] = ACTIONS(1599),
    [anon_sym_union] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(1599),
    [anon_sym_switch] = ACTIONS(1599),
    [anon_sym_case] = ACTIONS(1599),
    [anon_sym_default] = ACTIONS(1599),
    [anon_sym_while] = ACTIONS(1599),
    [anon_sym_do] = ACTIONS(1599),
    [anon_sym_for] = ACTIONS(1599),
    [anon_sym_return] = ACTIONS(1599),
    [anon_sym_break] = ACTIONS(1599),
    [anon_sym_continue] = ACTIONS(1599),
    [anon_sym_goto] = ACTIONS(1599),
    [anon_sym_AMP] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1597),
    [anon_sym_TILDE] = ACTIONS(1597),
    [anon_sym_PLUS] = ACTIONS(1599),
    [anon_sym_DASH] = ACTIONS(1599),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_sizeof] = ACTIONS(1599),
    [sym_number_literal] = ACTIONS(1597),
    [anon_sym_SQUOTE] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1597),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_null] = ACTIONS(1599),
    [sym_identifier] = ACTIONS(1599),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1599),
    [sym_auto] = ACTIONS(1599),
    [anon_sym_typename] = ACTIONS(1599),
    [anon_sym_delete] = ACTIONS(1599),
    [anon_sym_try] = ACTIONS(1599),
    [anon_sym_new] = ACTIONS(1599),
    [anon_sym_COLON_COLON] = ACTIONS(1597),
    [sym_nullptr] = ACTIONS(1599),
  },
  [491] = {
    [sym_parameter_list] = STATE(897),
    [sym_argument_list] = STATE(898),
    [sym_initializer_list] = STATE(898),
    [aux_sym_declaration_repeat1] = STATE(1168),
    [anon_sym_COMMA] = ACTIONS(1613),
    [anon_sym_SEMI] = ACTIONS(2282),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(1619),
    [anon_sym_LBRACK] = ACTIONS(574),
    [anon_sym_EQ] = ACTIONS(1621),
    [sym_comment] = ACTIONS(91),
  },
  [492] = {
    [aux_sym_declaration_repeat1] = STATE(1168),
    [anon_sym_COMMA] = ACTIONS(1613),
    [anon_sym_SEMI] = ACTIONS(2282),
    [sym_comment] = ACTIONS(91),
  },
  [493] = {
    [sym_argument_list] = STATE(1170),
    [sym_initializer_list] = STATE(1170),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(2284),
    [sym_comment] = ACTIONS(91),
  },
  [494] = {
    [sym_raw_string_literal] = ACTIONS(1697),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1699),
    [sym_preproc_directive] = ACTIONS(1699),
    [anon_sym_SEMI] = ACTIONS(1697),
    [anon_sym_typedef] = ACTIONS(1699),
    [anon_sym_extern] = ACTIONS(1699),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_RBRACE] = ACTIONS(1697),
    [anon_sym_LPAREN2] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1697),
    [anon_sym_LBRACK] = ACTIONS(1697),
    [anon_sym_static] = ACTIONS(1699),
    [anon_sym_register] = ACTIONS(1699),
    [anon_sym_inline] = ACTIONS(1699),
    [anon_sym_const] = ACTIONS(1699),
    [anon_sym_restrict] = ACTIONS(1699),
    [anon_sym_volatile] = ACTIONS(1699),
    [anon_sym__Atomic] = ACTIONS(1699),
    [anon_sym_mutable] = ACTIONS(1699),
    [anon_sym_explicit] = ACTIONS(1699),
    [anon_sym_constexpr] = ACTIONS(1699),
    [anon_sym_unsigned] = ACTIONS(1699),
    [anon_sym_long] = ACTIONS(1699),
    [anon_sym_short] = ACTIONS(1699),
    [sym_primitive_type] = ACTIONS(1699),
    [anon_sym_enum] = ACTIONS(1699),
    [anon_sym_struct] = ACTIONS(1699),
    [anon_sym_union] = ACTIONS(1699),
    [anon_sym_if] = ACTIONS(1699),
    [anon_sym_else] = ACTIONS(1699),
    [anon_sym_switch] = ACTIONS(1699),
    [anon_sym_case] = ACTIONS(1699),
    [anon_sym_default] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(1699),
    [anon_sym_do] = ACTIONS(1699),
    [anon_sym_for] = ACTIONS(1699),
    [anon_sym_return] = ACTIONS(1699),
    [anon_sym_break] = ACTIONS(1699),
    [anon_sym_continue] = ACTIONS(1699),
    [anon_sym_goto] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1697),
    [anon_sym_BANG] = ACTIONS(1697),
    [anon_sym_TILDE] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1697),
    [anon_sym_PLUS_PLUS] = ACTIONS(1697),
    [anon_sym_sizeof] = ACTIONS(1699),
    [sym_number_literal] = ACTIONS(1697),
    [anon_sym_SQUOTE] = ACTIONS(1697),
    [anon_sym_DQUOTE] = ACTIONS(1697),
    [sym_true] = ACTIONS(1699),
    [sym_false] = ACTIONS(1699),
    [sym_null] = ACTIONS(1699),
    [sym_identifier] = ACTIONS(1699),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1699),
    [sym_auto] = ACTIONS(1699),
    [anon_sym_typename] = ACTIONS(1699),
    [anon_sym_delete] = ACTIONS(1699),
    [anon_sym_try] = ACTIONS(1699),
    [anon_sym_new] = ACTIONS(1699),
    [anon_sym_COLON_COLON] = ACTIONS(1697),
    [sym_nullptr] = ACTIONS(1699),
  },
  [495] = {
    [sym_raw_string_literal] = ACTIONS(2286),
    [ts_builtin_sym_end] = ACTIONS(2286),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2288),
    [sym_preproc_directive] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym_typedef] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_RBRACE] = ACTIONS(2286),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_STAR] = ACTIONS(2286),
    [anon_sym_LBRACK] = ACTIONS(2286),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_register] = ACTIONS(2288),
    [anon_sym_inline] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_explicit] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_unsigned] = ACTIONS(2288),
    [anon_sym_long] = ACTIONS(2288),
    [anon_sym_short] = ACTIONS(2288),
    [sym_primitive_type] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [anon_sym_struct] = ACTIONS(2288),
    [anon_sym_union] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_else] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_goto] = ACTIONS(2288),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_BANG] = ACTIONS(2286),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_sizeof] = ACTIONS(2288),
    [sym_number_literal] = ACTIONS(2286),
    [anon_sym_SQUOTE] = ACTIONS(2286),
    [anon_sym_DQUOTE] = ACTIONS(2286),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [sym_null] = ACTIONS(2288),
    [sym_identifier] = ACTIONS(2288),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2288),
    [sym_auto] = ACTIONS(2288),
    [anon_sym_typename] = ACTIONS(2288),
    [anon_sym_template] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_catch] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [sym_operator_name] = ACTIONS(2286),
    [sym_nullptr] = ACTIONS(2288),
  },
  [496] = {
    [sym_preproc_include] = STATE(496),
    [sym_preproc_def] = STATE(496),
    [sym_preproc_function_def] = STATE(496),
    [sym_preproc_call] = STATE(496),
    [sym_preproc_if_in_compound_statement] = STATE(496),
    [sym_preproc_ifdef_in_compound_statement] = STATE(496),
    [sym_declaration] = STATE(496),
    [sym_type_definition] = STATE(496),
    [sym__declaration_specifiers] = STATE(113),
    [sym_compound_statement] = STATE(496),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(496),
    [sym_expression_statement] = STATE(496),
    [sym_if_statement] = STATE(496),
    [sym_switch_statement] = STATE(496),
    [sym_case_statement] = STATE(496),
    [sym_while_statement] = STATE(496),
    [sym_do_statement] = STATE(496),
    [sym_for_statement] = STATE(496),
    [sym_return_statement] = STATE(496),
    [sym_break_statement] = STATE(496),
    [sym_continue_statement] = STATE(496),
    [sym_goto_statement] = STATE(496),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(496),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(496),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(496),
    [sym_try_statement] = STATE(496),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(496),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(2290),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2296),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2299),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2302),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2302),
    [sym_preproc_directive] = ACTIONS(2305),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_typedef] = ACTIONS(2311),
    [anon_sym_extern] = ACTIONS(2314),
    [anon_sym_LBRACE] = ACTIONS(2317),
    [anon_sym_RBRACE] = ACTIONS(2320),
    [anon_sym_LPAREN2] = ACTIONS(2322),
    [anon_sym_STAR] = ACTIONS(2325),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_static] = ACTIONS(2314),
    [anon_sym_register] = ACTIONS(2314),
    [anon_sym_inline] = ACTIONS(2314),
    [anon_sym_const] = ACTIONS(2331),
    [anon_sym_restrict] = ACTIONS(2331),
    [anon_sym_volatile] = ACTIONS(2331),
    [anon_sym__Atomic] = ACTIONS(2331),
    [anon_sym_mutable] = ACTIONS(2331),
    [anon_sym_explicit] = ACTIONS(2331),
    [anon_sym_constexpr] = ACTIONS(2331),
    [anon_sym_unsigned] = ACTIONS(2334),
    [anon_sym_long] = ACTIONS(2334),
    [anon_sym_short] = ACTIONS(2334),
    [sym_primitive_type] = ACTIONS(2337),
    [anon_sym_enum] = ACTIONS(2340),
    [anon_sym_struct] = ACTIONS(2343),
    [anon_sym_union] = ACTIONS(2346),
    [anon_sym_if] = ACTIONS(2349),
    [anon_sym_switch] = ACTIONS(2352),
    [anon_sym_case] = ACTIONS(2355),
    [anon_sym_default] = ACTIONS(2358),
    [anon_sym_while] = ACTIONS(2361),
    [anon_sym_do] = ACTIONS(2364),
    [anon_sym_for] = ACTIONS(2367),
    [anon_sym_return] = ACTIONS(2370),
    [anon_sym_break] = ACTIONS(2373),
    [anon_sym_continue] = ACTIONS(2376),
    [anon_sym_goto] = ACTIONS(2379),
    [anon_sym_AMP] = ACTIONS(2325),
    [anon_sym_BANG] = ACTIONS(2382),
    [anon_sym_TILDE] = ACTIONS(2385),
    [anon_sym_PLUS] = ACTIONS(2388),
    [anon_sym_DASH] = ACTIONS(2388),
    [anon_sym_DASH_DASH] = ACTIONS(2391),
    [anon_sym_PLUS_PLUS] = ACTIONS(2391),
    [anon_sym_sizeof] = ACTIONS(2394),
    [sym_number_literal] = ACTIONS(2290),
    [anon_sym_SQUOTE] = ACTIONS(2397),
    [anon_sym_DQUOTE] = ACTIONS(2400),
    [sym_true] = ACTIONS(2403),
    [sym_false] = ACTIONS(2403),
    [sym_null] = ACTIONS(2403),
    [sym_identifier] = ACTIONS(2406),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2409),
    [sym_auto] = ACTIONS(2337),
    [anon_sym_typename] = ACTIONS(2412),
    [anon_sym_delete] = ACTIONS(2415),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_new] = ACTIONS(2421),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [sym_nullptr] = ACTIONS(2403),
  },
  [497] = {
    [sym_storage_class_specifier] = STATE(497),
    [sym_type_qualifier] = STATE(497),
    [aux_sym__declaration_specifiers_repeat1] = STATE(497),
    [anon_sym_extern] = ACTIONS(2427),
    [anon_sym_static] = ACTIONS(2427),
    [anon_sym_register] = ACTIONS(2427),
    [anon_sym_inline] = ACTIONS(2427),
    [anon_sym_const] = ACTIONS(2430),
    [anon_sym_restrict] = ACTIONS(2430),
    [anon_sym_volatile] = ACTIONS(2430),
    [anon_sym__Atomic] = ACTIONS(2430),
    [anon_sym_mutable] = ACTIONS(2430),
    [anon_sym_explicit] = ACTIONS(2430),
    [anon_sym_constexpr] = ACTIONS(2430),
    [anon_sym_unsigned] = ACTIONS(1975),
    [anon_sym_long] = ACTIONS(1975),
    [anon_sym_short] = ACTIONS(1975),
    [sym_primitive_type] = ACTIONS(1975),
    [anon_sym_enum] = ACTIONS(1975),
    [anon_sym_struct] = ACTIONS(1975),
    [anon_sym_union] = ACTIONS(1975),
    [sym_identifier] = ACTIONS(1975),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1975),
    [sym_auto] = ACTIONS(1975),
    [anon_sym_typename] = ACTIONS(1975),
    [anon_sym_COLON_COLON] = ACTIONS(1970),
  },
  [498] = {
    [anon_sym_RPAREN] = ACTIONS(2433),
    [sym_comment] = ACTIONS(91),
  },
  [499] = {
    [sym_destructor_name] = STATE(315),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(937),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(883),
    [sym_operator_name] = ACTIONS(554),
  },
  [500] = {
    [sym_parameter_list] = STATE(524),
    [anon_sym_RPAREN] = ACTIONS(2435),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(574),
    [sym_comment] = ACTIONS(91),
  },
  [501] = {
    [sym__declarator] = STATE(1172),
    [sym_pointer_declarator] = STATE(1172),
    [sym_function_declarator] = STATE(1172),
    [sym_array_declarator] = STATE(1172),
    [sym_type_qualifier] = STATE(552),
    [sym_reference_declarator] = STATE(1172),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(1172),
    [sym_destructor_name] = STATE(1172),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [aux_sym_type_definition_repeat1] = STATE(552),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(859),
    [anon_sym_AMP_AMP] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(431),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(2437),
  },
  [502] = {
    [sym_field_declaration_list] = STATE(612),
    [sym_virtual_specifier] = STATE(613),
    [sym_base_class_clause] = STATE(614),
    [sym_template_argument_list] = STATE(437),
    [anon_sym_COMMA] = ACTIONS(1057),
    [anon_sym_RPAREN] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LPAREN2] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(643),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [anon_sym_GT2] = ACTIONS(1057),
    [anon_sym_COLON_COLON] = ACTIONS(758),
  },
  [503] = {
    [sym_field_declaration_list] = STATE(617),
    [sym_virtual_specifier] = STATE(620),
    [sym_base_class_clause] = STATE(618),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_RPAREN] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1069),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1069),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [anon_sym_GT2] = ACTIONS(1069),
    [anon_sym_COLON_COLON] = ACTIONS(772),
  },
  [504] = {
    [sym_field_declaration_list] = STATE(617),
    [sym_virtual_specifier] = STATE(620),
    [sym_base_class_clause] = STATE(618),
    [sym_template_argument_list] = STATE(362),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_RPAREN] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1069),
    [anon_sym_COLON] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1069),
    [anon_sym_LT] = ACTIONS(643),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [anon_sym_GT2] = ACTIONS(1069),
  },
  [505] = {
    [sym_field_declaration_list] = STATE(621),
    [sym_virtual_specifier] = STATE(622),
    [sym_base_class_clause] = STATE(623),
    [sym_template_argument_list] = STATE(437),
    [anon_sym_COMMA] = ACTIONS(1077),
    [anon_sym_RPAREN] = ACTIONS(1077),
    [anon_sym_SEMI] = ACTIONS(1077),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LPAREN2] = ACTIONS(1077),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_LBRACK] = ACTIONS(1077),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_LT] = ACTIONS(643),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [anon_sym_GT2] = ACTIONS(1077),
    [anon_sym_COLON_COLON] = ACTIONS(758),
  },
  [506] = {
    [sym_field_declaration_list] = STATE(624),
    [sym_virtual_specifier] = STATE(626),
    [sym_base_class_clause] = STATE(625),
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_RPAREN] = ACTIONS(1081),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LPAREN2] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1081),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [anon_sym_GT2] = ACTIONS(1081),
    [anon_sym_COLON_COLON] = ACTIONS(772),
  },
  [507] = {
    [sym_field_declaration_list] = STATE(624),
    [sym_virtual_specifier] = STATE(626),
    [sym_base_class_clause] = STATE(625),
    [sym_template_argument_list] = STATE(362),
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_RPAREN] = ACTIONS(1081),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LPAREN2] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1081),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_COLON] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(643),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [anon_sym_GT2] = ACTIONS(1081),
  },
  [508] = {
    [sym_parameter_list] = STATE(524),
    [anon_sym_RPAREN] = ACTIONS(2439),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(574),
    [sym_comment] = ACTIONS(91),
  },
  [509] = {
    [sym__declarator] = STATE(500),
    [sym_pointer_declarator] = STATE(500),
    [sym_function_declarator] = STATE(500),
    [sym_array_declarator] = STATE(500),
    [sym_type_qualifier] = STATE(501),
    [sym_reference_declarator] = STATE(500),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(500),
    [sym_destructor_name] = STATE(500),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [aux_sym_type_definition_repeat1] = STATE(501),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(859),
    [anon_sym_AMP_AMP] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(431),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(849),
  },
  [510] = {
    [sym_type_qualifier] = STATE(141),
    [sym__type_specifier] = STATE(136),
    [sym_sized_type_specifier] = STATE(136),
    [sym_enum_specifier] = STATE(136),
    [sym_struct_specifier] = STATE(136),
    [sym_union_specifier] = STATE(136),
    [sym__expression] = STATE(137),
    [sym_comma_expression] = STATE(138),
    [sym_conditional_expression] = STATE(137),
    [sym_assignment_expression] = STATE(137),
    [sym_pointer_expression] = STATE(137),
    [sym_logical_expression] = STATE(137),
    [sym_bitwise_expression] = STATE(137),
    [sym_equality_expression] = STATE(137),
    [sym_relational_expression] = STATE(137),
    [sym_shift_expression] = STATE(137),
    [sym_math_expression] = STATE(137),
    [sym_cast_expression] = STATE(137),
    [sym_type_descriptor] = STATE(1173),
    [sym_sizeof_expression] = STATE(137),
    [sym_subscript_expression] = STATE(137),
    [sym_call_expression] = STATE(137),
    [sym_field_expression] = STATE(137),
    [sym_compound_literal_expression] = STATE(137),
    [sym_parenthesized_expression] = STATE(137),
    [sym_char_literal] = STATE(137),
    [sym_concatenated_string] = STATE(137),
    [sym_string_literal] = STATE(140),
    [sym_macro_type_specifier] = STATE(136),
    [sym_class_specifier] = STATE(136),
    [sym_dependent_type] = STATE(136),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(137),
    [sym_new_expression] = STATE(137),
    [sym_delete_expression] = STATE(137),
    [sym_lambda_expression] = STATE(137),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_type_definition_repeat1] = STATE(141),
    [aux_sym_sized_type_specifier_repeat1] = STATE(142),
    [sym_raw_string_literal] = ACTIONS(213),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(219),
    [anon_sym_long] = ACTIONS(219),
    [anon_sym_short] = ACTIONS(219),
    [sym_primitive_type] = ACTIONS(221),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [sym_null] = ACTIONS(241),
    [sym_identifier] = ACTIONS(811),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(221),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(253),
    [sym_nullptr] = ACTIONS(241),
  },
  [511] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(1364),
    [anon_sym_RPAREN] = ACTIONS(1364),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1366),
    [anon_sym_QMARK] = ACTIONS(1364),
    [anon_sym_STAR_EQ] = ACTIONS(1364),
    [anon_sym_SLASH_EQ] = ACTIONS(1364),
    [anon_sym_PERCENT_EQ] = ACTIONS(1364),
    [anon_sym_PLUS_EQ] = ACTIONS(1364),
    [anon_sym_DASH_EQ] = ACTIONS(1364),
    [anon_sym_LT_LT_EQ] = ACTIONS(1364),
    [anon_sym_GT_GT_EQ] = ACTIONS(1364),
    [anon_sym_AMP_EQ] = ACTIONS(1364),
    [anon_sym_CARET_EQ] = ACTIONS(1364),
    [anon_sym_PIPE_EQ] = ACTIONS(1364),
    [anon_sym_AMP] = ACTIONS(1366),
    [anon_sym_PIPE_PIPE] = ACTIONS(1364),
    [anon_sym_AMP_AMP] = ACTIONS(1364),
    [anon_sym_PIPE] = ACTIONS(1366),
    [anon_sym_CARET] = ACTIONS(1366),
    [anon_sym_EQ_EQ] = ACTIONS(1364),
    [anon_sym_BANG_EQ] = ACTIONS(1364),
    [anon_sym_LT] = ACTIONS(1366),
    [anon_sym_GT] = ACTIONS(1366),
    [anon_sym_LT_EQ] = ACTIONS(1364),
    [anon_sym_GT_EQ] = ACTIONS(1364),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [512] = {
    [sym_field_declaration_list] = STATE(790),
    [sym_virtual_specifier] = STATE(791),
    [sym_base_class_clause] = STATE(792),
    [sym_template_argument_list] = STATE(437),
    [anon_sym_COMMA] = ACTIONS(1438),
    [anon_sym_RPAREN] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1438),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LPAREN2] = ACTIONS(1438),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_LBRACK] = ACTIONS(1438),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_AMP_AMP] = ACTIONS(1438),
    [anon_sym_LT] = ACTIONS(643),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [anon_sym_GT2] = ACTIONS(1438),
    [anon_sym_COLON_COLON] = ACTIONS(758),
  },
  [513] = {
    [sym_field_declaration_list] = STATE(793),
    [sym_virtual_specifier] = STATE(795),
    [sym_base_class_clause] = STATE(794),
    [anon_sym_COMMA] = ACTIONS(1442),
    [anon_sym_RPAREN] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1442),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LPAREN2] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(1442),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1442),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [anon_sym_GT2] = ACTIONS(1442),
    [anon_sym_COLON_COLON] = ACTIONS(772),
  },
  [514] = {
    [sym_field_declaration_list] = STATE(793),
    [sym_virtual_specifier] = STATE(795),
    [sym_base_class_clause] = STATE(794),
    [sym_template_argument_list] = STATE(362),
    [anon_sym_COMMA] = ACTIONS(1442),
    [anon_sym_RPAREN] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1442),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LPAREN2] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(1442),
    [anon_sym_COLON] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1442),
    [anon_sym_LT] = ACTIONS(643),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [anon_sym_GT2] = ACTIONS(1442),
  },
  [515] = {
    [sym_template_argument_list] = STATE(437),
    [anon_sym_COMMA] = ACTIONS(481),
    [anon_sym_RPAREN] = ACTIONS(481),
    [anon_sym_SEMI] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_LPAREN2] = ACTIONS(481),
    [anon_sym_STAR] = ACTIONS(481),
    [anon_sym_LBRACK] = ACTIONS(481),
    [anon_sym_EQ] = ACTIONS(481),
    [anon_sym_const] = ACTIONS(468),
    [anon_sym_restrict] = ACTIONS(481),
    [anon_sym_volatile] = ACTIONS(481),
    [anon_sym__Atomic] = ACTIONS(481),
    [anon_sym_mutable] = ACTIONS(481),
    [anon_sym_explicit] = ACTIONS(481),
    [anon_sym_constexpr] = ACTIONS(481),
    [anon_sym_COLON] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(468),
    [anon_sym_AMP_AMP] = ACTIONS(481),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_DASH_GT] = ACTIONS(481),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(481),
    [anon_sym_override] = ACTIONS(481),
    [anon_sym_GT2] = ACTIONS(481),
    [sym_noexcept] = ACTIONS(481),
    [anon_sym_COLON_COLON] = ACTIONS(758),
  },
  [516] = {
    [sym__expression] = STATE(164),
    [sym_conditional_expression] = STATE(164),
    [sym_assignment_expression] = STATE(164),
    [sym_pointer_expression] = STATE(164),
    [sym_logical_expression] = STATE(164),
    [sym_bitwise_expression] = STATE(164),
    [sym_equality_expression] = STATE(164),
    [sym_relational_expression] = STATE(164),
    [sym_shift_expression] = STATE(164),
    [sym_math_expression] = STATE(164),
    [sym_cast_expression] = STATE(164),
    [sym_sizeof_expression] = STATE(164),
    [sym_subscript_expression] = STATE(164),
    [sym_call_expression] = STATE(164),
    [sym_field_expression] = STATE(164),
    [sym_compound_literal_expression] = STATE(164),
    [sym_parenthesized_expression] = STATE(164),
    [sym_char_literal] = STATE(164),
    [sym_concatenated_string] = STATE(164),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(164),
    [sym_new_expression] = STATE(164),
    [sym_delete_expression] = STATE(164),
    [sym_lambda_expression] = STATE(164),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_lambda_default_capture] = STATE(166),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(267),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(2441),
    [anon_sym_EQ] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(267),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(289),
    [sym_false] = ACTIONS(289),
    [sym_null] = ACTIONS(289),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(289),
  },
  [517] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(1489),
    [anon_sym_RPAREN] = ACTIONS(1489),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1491),
    [anon_sym_QMARK] = ACTIONS(1489),
    [anon_sym_STAR_EQ] = ACTIONS(1489),
    [anon_sym_SLASH_EQ] = ACTIONS(1489),
    [anon_sym_PERCENT_EQ] = ACTIONS(1489),
    [anon_sym_PLUS_EQ] = ACTIONS(1489),
    [anon_sym_DASH_EQ] = ACTIONS(1489),
    [anon_sym_LT_LT_EQ] = ACTIONS(1489),
    [anon_sym_GT_GT_EQ] = ACTIONS(1489),
    [anon_sym_AMP_EQ] = ACTIONS(1489),
    [anon_sym_CARET_EQ] = ACTIONS(1489),
    [anon_sym_PIPE_EQ] = ACTIONS(1489),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [518] = {
    [sym__type_specifier] = STATE(871),
    [sym_sized_type_specifier] = STATE(871),
    [sym_enum_specifier] = STATE(871),
    [sym_struct_specifier] = STATE(871),
    [sym_union_specifier] = STATE(871),
    [sym_macro_type_specifier] = STATE(871),
    [sym_class_specifier] = STATE(871),
    [sym_dependent_type] = STATE(871),
    [sym_template_type] = STATE(309),
    [sym_scoped_type_identifier] = STATE(310),
    [sym_scoped_namespace_identifier] = STATE(311),
    [aux_sym_sized_type_specifier_repeat1] = STATE(521),
    [anon_sym_unsigned] = ACTIONS(877),
    [anon_sym_long] = ACTIONS(877),
    [anon_sym_short] = ACTIONS(877),
    [sym_primitive_type] = ACTIONS(1552),
    [anon_sym_enum] = ACTIONS(536),
    [anon_sym_struct] = ACTIONS(538),
    [anon_sym_union] = ACTIONS(540),
    [sym_identifier] = ACTIONS(542),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(544),
    [sym_auto] = ACTIONS(1552),
    [anon_sym_typename] = ACTIONS(881),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [519] = {
    [sym_argument_list] = STATE(874),
    [sym_initializer_list] = STATE(874),
    [sym_new_declarator] = STATE(875),
    [anon_sym_COMMA] = ACTIONS(1556),
    [anon_sym_RPAREN] = ACTIONS(1556),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1558),
    [anon_sym_LBRACK] = ACTIONS(2443),
    [anon_sym_EQ] = ACTIONS(1558),
    [anon_sym_QMARK] = ACTIONS(1556),
    [anon_sym_STAR_EQ] = ACTIONS(1556),
    [anon_sym_SLASH_EQ] = ACTIONS(1556),
    [anon_sym_PERCENT_EQ] = ACTIONS(1556),
    [anon_sym_PLUS_EQ] = ACTIONS(1556),
    [anon_sym_DASH_EQ] = ACTIONS(1556),
    [anon_sym_LT_LT_EQ] = ACTIONS(1556),
    [anon_sym_GT_GT_EQ] = ACTIONS(1556),
    [anon_sym_AMP_EQ] = ACTIONS(1556),
    [anon_sym_CARET_EQ] = ACTIONS(1556),
    [anon_sym_PIPE_EQ] = ACTIONS(1556),
    [anon_sym_AMP] = ACTIONS(1558),
    [anon_sym_PIPE_PIPE] = ACTIONS(1556),
    [anon_sym_AMP_AMP] = ACTIONS(1556),
    [anon_sym_PIPE] = ACTIONS(1558),
    [anon_sym_CARET] = ACTIONS(1558),
    [anon_sym_EQ_EQ] = ACTIONS(1556),
    [anon_sym_BANG_EQ] = ACTIONS(1556),
    [anon_sym_LT] = ACTIONS(1558),
    [anon_sym_GT] = ACTIONS(1558),
    [anon_sym_LT_EQ] = ACTIONS(1556),
    [anon_sym_GT_EQ] = ACTIONS(1556),
    [anon_sym_LT_LT] = ACTIONS(1558),
    [anon_sym_GT_GT] = ACTIONS(1558),
    [anon_sym_PLUS] = ACTIONS(1558),
    [anon_sym_DASH] = ACTIONS(1558),
    [anon_sym_SLASH] = ACTIONS(1558),
    [anon_sym_PERCENT] = ACTIONS(1558),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DOT] = ACTIONS(1556),
    [anon_sym_DASH_GT] = ACTIONS(1556),
    [sym_comment] = ACTIONS(91),
  },
  [520] = {
    [sym__type_specifier] = STATE(1176),
    [sym_sized_type_specifier] = STATE(1176),
    [sym_enum_specifier] = STATE(1176),
    [sym_struct_specifier] = STATE(1176),
    [sym_union_specifier] = STATE(1176),
    [sym_macro_type_specifier] = STATE(1176),
    [sym_class_specifier] = STATE(1176),
    [sym_dependent_type] = STATE(1176),
    [sym_template_type] = STATE(309),
    [sym_scoped_type_identifier] = STATE(310),
    [sym_scoped_namespace_identifier] = STATE(311),
    [aux_sym_sized_type_specifier_repeat1] = STATE(521),
    [anon_sym_unsigned] = ACTIONS(877),
    [anon_sym_long] = ACTIONS(877),
    [anon_sym_short] = ACTIONS(877),
    [sym_primitive_type] = ACTIONS(2445),
    [anon_sym_enum] = ACTIONS(536),
    [anon_sym_struct] = ACTIONS(538),
    [anon_sym_union] = ACTIONS(540),
    [sym_identifier] = ACTIONS(542),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(544),
    [sym_auto] = ACTIONS(2445),
    [anon_sym_typename] = ACTIONS(881),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [521] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1177),
    [anon_sym_COMMA] = ACTIONS(653),
    [anon_sym_RPAREN] = ACTIONS(653),
    [anon_sym_LBRACE] = ACTIONS(653),
    [anon_sym_LPAREN2] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_EQ] = ACTIONS(655),
    [anon_sym_unsigned] = ACTIONS(2447),
    [anon_sym_long] = ACTIONS(2447),
    [anon_sym_short] = ACTIONS(2447),
    [sym_primitive_type] = ACTIONS(1571),
    [anon_sym_QMARK] = ACTIONS(653),
    [anon_sym_STAR_EQ] = ACTIONS(653),
    [anon_sym_SLASH_EQ] = ACTIONS(653),
    [anon_sym_PERCENT_EQ] = ACTIONS(653),
    [anon_sym_PLUS_EQ] = ACTIONS(653),
    [anon_sym_DASH_EQ] = ACTIONS(653),
    [anon_sym_LT_LT_EQ] = ACTIONS(653),
    [anon_sym_GT_GT_EQ] = ACTIONS(653),
    [anon_sym_AMP_EQ] = ACTIONS(653),
    [anon_sym_CARET_EQ] = ACTIONS(653),
    [anon_sym_PIPE_EQ] = ACTIONS(653),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_PIPE_PIPE] = ACTIONS(653),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(655),
    [anon_sym_EQ_EQ] = ACTIONS(653),
    [anon_sym_BANG_EQ] = ACTIONS(653),
    [anon_sym_LT] = ACTIONS(655),
    [anon_sym_GT] = ACTIONS(655),
    [anon_sym_LT_EQ] = ACTIONS(653),
    [anon_sym_GT_EQ] = ACTIONS(653),
    [anon_sym_LT_LT] = ACTIONS(655),
    [anon_sym_GT_GT] = ACTIONS(655),
    [anon_sym_PLUS] = ACTIONS(655),
    [anon_sym_DASH] = ACTIONS(655),
    [anon_sym_SLASH] = ACTIONS(655),
    [anon_sym_PERCENT] = ACTIONS(655),
    [anon_sym_DASH_DASH] = ACTIONS(653),
    [anon_sym_PLUS_PLUS] = ACTIONS(653),
    [anon_sym_DOT] = ACTIONS(653),
    [anon_sym_DASH_GT] = ACTIONS(653),
    [sym_identifier] = ACTIONS(1573),
    [sym_comment] = ACTIONS(91),
  },
  [522] = {
    [sym__expression] = STATE(1179),
    [sym_conditional_expression] = STATE(1179),
    [sym_assignment_expression] = STATE(1179),
    [sym_pointer_expression] = STATE(1179),
    [sym_logical_expression] = STATE(1179),
    [sym_bitwise_expression] = STATE(1179),
    [sym_equality_expression] = STATE(1179),
    [sym_relational_expression] = STATE(1179),
    [sym_shift_expression] = STATE(1179),
    [sym_math_expression] = STATE(1179),
    [sym_cast_expression] = STATE(1179),
    [sym_sizeof_expression] = STATE(1179),
    [sym_subscript_expression] = STATE(1179),
    [sym_call_expression] = STATE(1179),
    [sym_field_expression] = STATE(1179),
    [sym_compound_literal_expression] = STATE(1179),
    [sym_parenthesized_expression] = STATE(1179),
    [sym_char_literal] = STATE(1179),
    [sym_concatenated_string] = STATE(1179),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1179),
    [sym_new_expression] = STATE(1179),
    [sym_delete_expression] = STATE(1179),
    [sym_lambda_expression] = STATE(1179),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2449),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(2451),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(2449),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2453),
    [sym_false] = ACTIONS(2453),
    [sym_null] = ACTIONS(2453),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(2453),
  },
  [523] = {
    [anon_sym_COMMA] = ACTIONS(2455),
    [anon_sym_RPAREN] = ACTIONS(2455),
    [anon_sym_SEMI] = ACTIONS(2455),
    [anon_sym_LBRACE] = ACTIONS(2455),
    [anon_sym_LPAREN2] = ACTIONS(2455),
    [anon_sym_LBRACK] = ACTIONS(2455),
    [anon_sym_EQ] = ACTIONS(2455),
    [anon_sym_COLON] = ACTIONS(2455),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(2455),
  },
  [524] = {
    [sym_type_qualifier] = STATE(1181),
    [sym_virtual_specifier] = STATE(1181),
    [sym_trailing_return_type] = STATE(1181),
    [aux_sym_function_declarator_repeat1] = STATE(1181),
    [anon_sym_RPAREN] = ACTIONS(1665),
    [anon_sym_LPAREN2] = ACTIONS(1665),
    [anon_sym_LBRACK] = ACTIONS(1665),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(2457),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [sym_noexcept] = ACTIONS(2459),
  },
  [525] = {
    [sym__abstract_declarator] = STATE(1182),
    [sym_abstract_pointer_declarator] = STATE(1182),
    [sym_abstract_function_declarator] = STATE(1182),
    [sym_abstract_array_declarator] = STATE(1182),
    [sym_type_qualifier] = STATE(1183),
    [sym_parameter_list] = STATE(528),
    [sym_abstract_reference_declarator] = STATE(1182),
    [aux_sym_type_definition_repeat1] = STATE(1183),
    [anon_sym_RPAREN] = ACTIONS(2461),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_AMP_AMP] = ACTIONS(893),
    [sym_comment] = ACTIONS(91),
  },
  [526] = {
    [sym__abstract_declarator] = STATE(1184),
    [sym_abstract_pointer_declarator] = STATE(1184),
    [sym_abstract_function_declarator] = STATE(1184),
    [sym_abstract_array_declarator] = STATE(1184),
    [sym_parameter_list] = STATE(528),
    [sym_abstract_reference_declarator] = STATE(1184),
    [anon_sym_RPAREN] = ACTIONS(2463),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_AMP_AMP] = ACTIONS(893),
    [sym_comment] = ACTIONS(91),
  },
  [527] = {
    [sym_parameter_list] = STATE(1185),
    [anon_sym_RPAREN] = ACTIONS(2465),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [sym_comment] = ACTIONS(91),
  },
  [528] = {
    [sym_type_qualifier] = STATE(1187),
    [sym_trailing_return_type] = STATE(971),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1187),
    [anon_sym_RPAREN] = ACTIONS(1787),
    [anon_sym_LPAREN2] = ACTIONS(1787),
    [anon_sym_LBRACK] = ACTIONS(1787),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(2467),
    [sym_comment] = ACTIONS(91),
    [sym_noexcept] = ACTIONS(2469),
  },
  [529] = {
    [sym__expression] = STATE(1188),
    [sym_comma_expression] = STATE(937),
    [sym_conditional_expression] = STATE(1188),
    [sym_assignment_expression] = STATE(1188),
    [sym_pointer_expression] = STATE(1188),
    [sym_logical_expression] = STATE(1188),
    [sym_bitwise_expression] = STATE(1188),
    [sym_equality_expression] = STATE(1188),
    [sym_relational_expression] = STATE(1188),
    [sym_shift_expression] = STATE(1188),
    [sym_math_expression] = STATE(1188),
    [sym_cast_expression] = STATE(1188),
    [sym_sizeof_expression] = STATE(1188),
    [sym_subscript_expression] = STATE(1188),
    [sym_call_expression] = STATE(1188),
    [sym_field_expression] = STATE(1188),
    [sym_compound_literal_expression] = STATE(1188),
    [sym_parenthesized_expression] = STATE(1188),
    [sym_char_literal] = STATE(1188),
    [sym_concatenated_string] = STATE(1188),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1188),
    [sym_new_expression] = STATE(1188),
    [sym_delete_expression] = STATE(1188),
    [sym_lambda_expression] = STATE(1188),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2471),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(2471),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2473),
    [sym_false] = ACTIONS(2473),
    [sym_null] = ACTIONS(2473),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(2473),
  },
  [530] = {
    [anon_sym_COMMA] = ACTIONS(2475),
    [anon_sym_RPAREN] = ACTIONS(2475),
    [anon_sym_SEMI] = ACTIONS(2475),
    [anon_sym_RBRACE] = ACTIONS(2475),
    [anon_sym_LPAREN2] = ACTIONS(2475),
    [anon_sym_STAR] = ACTIONS(2477),
    [anon_sym_LBRACK] = ACTIONS(2475),
    [anon_sym_RBRACK] = ACTIONS(2475),
    [anon_sym_EQ] = ACTIONS(2477),
    [anon_sym_COLON] = ACTIONS(2475),
    [anon_sym_else] = ACTIONS(2475),
    [anon_sym_while] = ACTIONS(2475),
    [anon_sym_QMARK] = ACTIONS(2475),
    [anon_sym_STAR_EQ] = ACTIONS(2475),
    [anon_sym_SLASH_EQ] = ACTIONS(2475),
    [anon_sym_PERCENT_EQ] = ACTIONS(2475),
    [anon_sym_PLUS_EQ] = ACTIONS(2475),
    [anon_sym_DASH_EQ] = ACTIONS(2475),
    [anon_sym_LT_LT_EQ] = ACTIONS(2475),
    [anon_sym_GT_GT_EQ] = ACTIONS(2475),
    [anon_sym_AMP_EQ] = ACTIONS(2475),
    [anon_sym_CARET_EQ] = ACTIONS(2475),
    [anon_sym_PIPE_EQ] = ACTIONS(2475),
    [anon_sym_AMP] = ACTIONS(2477),
    [anon_sym_PIPE_PIPE] = ACTIONS(2475),
    [anon_sym_AMP_AMP] = ACTIONS(2475),
    [anon_sym_PIPE] = ACTIONS(2477),
    [anon_sym_CARET] = ACTIONS(2477),
    [anon_sym_EQ_EQ] = ACTIONS(2475),
    [anon_sym_BANG_EQ] = ACTIONS(2475),
    [anon_sym_LT] = ACTIONS(2477),
    [anon_sym_GT] = ACTIONS(2477),
    [anon_sym_LT_EQ] = ACTIONS(2475),
    [anon_sym_GT_EQ] = ACTIONS(2475),
    [anon_sym_LT_LT] = ACTIONS(2477),
    [anon_sym_GT_GT] = ACTIONS(2477),
    [anon_sym_PLUS] = ACTIONS(2477),
    [anon_sym_DASH] = ACTIONS(2477),
    [anon_sym_SLASH] = ACTIONS(2477),
    [anon_sym_PERCENT] = ACTIONS(2477),
    [anon_sym_DASH_DASH] = ACTIONS(2475),
    [anon_sym_PLUS_PLUS] = ACTIONS(2475),
    [anon_sym_DOT] = ACTIONS(2475),
    [anon_sym_DASH_GT] = ACTIONS(2475),
    [sym_comment] = ACTIONS(91),
  },
  [531] = {
    [sym__expression] = STATE(938),
    [sym_conditional_expression] = STATE(938),
    [sym_assignment_expression] = STATE(938),
    [sym_pointer_expression] = STATE(938),
    [sym_logical_expression] = STATE(938),
    [sym_bitwise_expression] = STATE(938),
    [sym_equality_expression] = STATE(938),
    [sym_relational_expression] = STATE(938),
    [sym_shift_expression] = STATE(938),
    [sym_math_expression] = STATE(938),
    [sym_cast_expression] = STATE(938),
    [sym_sizeof_expression] = STATE(938),
    [sym_subscript_expression] = STATE(938),
    [sym_call_expression] = STATE(938),
    [sym_field_expression] = STATE(938),
    [sym_compound_literal_expression] = STATE(938),
    [sym_parenthesized_expression] = STATE(938),
    [sym_char_literal] = STATE(938),
    [sym_concatenated_string] = STATE(938),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(938),
    [sym_new_expression] = STATE(938),
    [sym_delete_expression] = STATE(938),
    [sym_lambda_expression] = STATE(938),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(1701),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(1701),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(1703),
    [sym_false] = ACTIONS(1703),
    [sym_null] = ACTIONS(1703),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(1703),
  },
  [532] = {
    [sym__expression] = STATE(1189),
    [sym_conditional_expression] = STATE(1189),
    [sym_assignment_expression] = STATE(1189),
    [sym_pointer_expression] = STATE(1189),
    [sym_logical_expression] = STATE(1189),
    [sym_bitwise_expression] = STATE(1189),
    [sym_equality_expression] = STATE(1189),
    [sym_relational_expression] = STATE(1189),
    [sym_shift_expression] = STATE(1189),
    [sym_math_expression] = STATE(1189),
    [sym_cast_expression] = STATE(1189),
    [sym_sizeof_expression] = STATE(1189),
    [sym_subscript_expression] = STATE(1189),
    [sym_call_expression] = STATE(1189),
    [sym_field_expression] = STATE(1189),
    [sym_compound_literal_expression] = STATE(1189),
    [sym_parenthesized_expression] = STATE(1189),
    [sym_char_literal] = STATE(1189),
    [sym_concatenated_string] = STATE(1189),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1189),
    [sym_new_expression] = STATE(1189),
    [sym_delete_expression] = STATE(1189),
    [sym_lambda_expression] = STATE(1189),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2479),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(2479),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2481),
    [sym_false] = ACTIONS(2481),
    [sym_null] = ACTIONS(2481),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(2481),
  },
  [533] = {
    [sym__expression] = STATE(1190),
    [sym_conditional_expression] = STATE(1190),
    [sym_assignment_expression] = STATE(1190),
    [sym_pointer_expression] = STATE(1190),
    [sym_logical_expression] = STATE(1190),
    [sym_bitwise_expression] = STATE(1190),
    [sym_equality_expression] = STATE(1190),
    [sym_relational_expression] = STATE(1190),
    [sym_shift_expression] = STATE(1190),
    [sym_math_expression] = STATE(1190),
    [sym_cast_expression] = STATE(1190),
    [sym_sizeof_expression] = STATE(1190),
    [sym_subscript_expression] = STATE(1190),
    [sym_call_expression] = STATE(1190),
    [sym_field_expression] = STATE(1190),
    [sym_compound_literal_expression] = STATE(1190),
    [sym_parenthesized_expression] = STATE(1190),
    [sym_char_literal] = STATE(1190),
    [sym_concatenated_string] = STATE(1190),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1190),
    [sym_new_expression] = STATE(1190),
    [sym_delete_expression] = STATE(1190),
    [sym_lambda_expression] = STATE(1190),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2483),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(2483),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(2485),
    [sym_false] = ACTIONS(2485),
    [sym_null] = ACTIONS(2485),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(2485),
  },
  [534] = {
    [sym__expression] = STATE(1191),
    [sym_conditional_expression] = STATE(1191),
    [sym_assignment_expression] = STATE(1191),
    [sym_pointer_expression] = STATE(1191),
    [sym_logical_expression] = STATE(1191),
    [sym_bitwise_expression] = STATE(1191),
    [sym_equality_expression] = STATE(1191),
    [sym_relational_expression] = STATE(1191),
    [sym_shift_expression] = STATE(1191),
    [sym_math_expression] = STATE(1191),
    [sym_cast_expression] = STATE(1191),
    [sym_sizeof_expression] = STATE(1191),
    [sym_subscript_expression] = STATE(1191),
    [sym_call_expression] = STATE(1191),
    [sym_field_expression] = STATE(1191),
    [sym_compound_literal_expression] = STATE(1191),
    [sym_parenthesized_expression] = STATE(1191),
    [sym_char_literal] = STATE(1191),
    [sym_concatenated_string] = STATE(1191),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1191),
    [sym_new_expression] = STATE(1191),
    [sym_delete_expression] = STATE(1191),
    [sym_lambda_expression] = STATE(1191),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2487),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(2487),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2489),
    [sym_false] = ACTIONS(2489),
    [sym_null] = ACTIONS(2489),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(2489),
  },
  [535] = {
    [sym__expression] = STATE(1192),
    [sym_conditional_expression] = STATE(1192),
    [sym_assignment_expression] = STATE(1192),
    [sym_pointer_expression] = STATE(1192),
    [sym_logical_expression] = STATE(1192),
    [sym_bitwise_expression] = STATE(1192),
    [sym_equality_expression] = STATE(1192),
    [sym_relational_expression] = STATE(1192),
    [sym_shift_expression] = STATE(1192),
    [sym_math_expression] = STATE(1192),
    [sym_cast_expression] = STATE(1192),
    [sym_sizeof_expression] = STATE(1192),
    [sym_subscript_expression] = STATE(1192),
    [sym_call_expression] = STATE(1192),
    [sym_field_expression] = STATE(1192),
    [sym_compound_literal_expression] = STATE(1192),
    [sym_parenthesized_expression] = STATE(1192),
    [sym_char_literal] = STATE(1192),
    [sym_concatenated_string] = STATE(1192),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1192),
    [sym_new_expression] = STATE(1192),
    [sym_delete_expression] = STATE(1192),
    [sym_lambda_expression] = STATE(1192),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2491),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(2491),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2493),
    [sym_false] = ACTIONS(2493),
    [sym_null] = ACTIONS(2493),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(2493),
  },
  [536] = {
    [sym__expression] = STATE(1193),
    [sym_conditional_expression] = STATE(1193),
    [sym_assignment_expression] = STATE(1193),
    [sym_pointer_expression] = STATE(1193),
    [sym_logical_expression] = STATE(1193),
    [sym_bitwise_expression] = STATE(1193),
    [sym_equality_expression] = STATE(1193),
    [sym_relational_expression] = STATE(1193),
    [sym_shift_expression] = STATE(1193),
    [sym_math_expression] = STATE(1193),
    [sym_cast_expression] = STATE(1193),
    [sym_sizeof_expression] = STATE(1193),
    [sym_subscript_expression] = STATE(1193),
    [sym_call_expression] = STATE(1193),
    [sym_field_expression] = STATE(1193),
    [sym_compound_literal_expression] = STATE(1193),
    [sym_parenthesized_expression] = STATE(1193),
    [sym_char_literal] = STATE(1193),
    [sym_concatenated_string] = STATE(1193),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1193),
    [sym_new_expression] = STATE(1193),
    [sym_delete_expression] = STATE(1193),
    [sym_lambda_expression] = STATE(1193),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2495),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(2495),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2497),
    [sym_false] = ACTIONS(2497),
    [sym_null] = ACTIONS(2497),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(2497),
  },
  [537] = {
    [sym__expression] = STATE(1194),
    [sym_conditional_expression] = STATE(1194),
    [sym_assignment_expression] = STATE(1194),
    [sym_pointer_expression] = STATE(1194),
    [sym_logical_expression] = STATE(1194),
    [sym_bitwise_expression] = STATE(1194),
    [sym_equality_expression] = STATE(1194),
    [sym_relational_expression] = STATE(1194),
    [sym_shift_expression] = STATE(1194),
    [sym_math_expression] = STATE(1194),
    [sym_cast_expression] = STATE(1194),
    [sym_sizeof_expression] = STATE(1194),
    [sym_subscript_expression] = STATE(1194),
    [sym_call_expression] = STATE(1194),
    [sym_field_expression] = STATE(1194),
    [sym_compound_literal_expression] = STATE(1194),
    [sym_parenthesized_expression] = STATE(1194),
    [sym_char_literal] = STATE(1194),
    [sym_concatenated_string] = STATE(1194),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1194),
    [sym_new_expression] = STATE(1194),
    [sym_delete_expression] = STATE(1194),
    [sym_lambda_expression] = STATE(1194),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2499),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(2499),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2501),
    [sym_false] = ACTIONS(2501),
    [sym_null] = ACTIONS(2501),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(2501),
  },
  [538] = {
    [sym__expression] = STATE(1195),
    [sym_conditional_expression] = STATE(1195),
    [sym_assignment_expression] = STATE(1195),
    [sym_pointer_expression] = STATE(1195),
    [sym_logical_expression] = STATE(1195),
    [sym_bitwise_expression] = STATE(1195),
    [sym_equality_expression] = STATE(1195),
    [sym_relational_expression] = STATE(1195),
    [sym_shift_expression] = STATE(1195),
    [sym_math_expression] = STATE(1195),
    [sym_cast_expression] = STATE(1195),
    [sym_sizeof_expression] = STATE(1195),
    [sym_subscript_expression] = STATE(1195),
    [sym_call_expression] = STATE(1195),
    [sym_field_expression] = STATE(1195),
    [sym_compound_literal_expression] = STATE(1195),
    [sym_parenthesized_expression] = STATE(1195),
    [sym_char_literal] = STATE(1195),
    [sym_concatenated_string] = STATE(1195),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1195),
    [sym_new_expression] = STATE(1195),
    [sym_delete_expression] = STATE(1195),
    [sym_lambda_expression] = STATE(1195),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2503),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(2503),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2505),
    [sym_false] = ACTIONS(2505),
    [sym_null] = ACTIONS(2505),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(2505),
  },
  [539] = {
    [sym__expression] = STATE(1196),
    [sym_conditional_expression] = STATE(1196),
    [sym_assignment_expression] = STATE(1196),
    [sym_pointer_expression] = STATE(1196),
    [sym_logical_expression] = STATE(1196),
    [sym_bitwise_expression] = STATE(1196),
    [sym_equality_expression] = STATE(1196),
    [sym_relational_expression] = STATE(1196),
    [sym_shift_expression] = STATE(1196),
    [sym_math_expression] = STATE(1196),
    [sym_cast_expression] = STATE(1196),
    [sym_sizeof_expression] = STATE(1196),
    [sym_subscript_expression] = STATE(1196),
    [sym_call_expression] = STATE(1196),
    [sym_field_expression] = STATE(1196),
    [sym_compound_literal_expression] = STATE(1196),
    [sym_parenthesized_expression] = STATE(1196),
    [sym_char_literal] = STATE(1196),
    [sym_concatenated_string] = STATE(1196),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1196),
    [sym_new_expression] = STATE(1196),
    [sym_delete_expression] = STATE(1196),
    [sym_lambda_expression] = STATE(1196),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2507),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(2507),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2509),
    [sym_false] = ACTIONS(2509),
    [sym_null] = ACTIONS(2509),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(2509),
  },
  [540] = {
    [sym__expression] = STATE(1197),
    [sym_conditional_expression] = STATE(1197),
    [sym_assignment_expression] = STATE(1197),
    [sym_pointer_expression] = STATE(1197),
    [sym_logical_expression] = STATE(1197),
    [sym_bitwise_expression] = STATE(1197),
    [sym_equality_expression] = STATE(1197),
    [sym_relational_expression] = STATE(1197),
    [sym_shift_expression] = STATE(1197),
    [sym_math_expression] = STATE(1197),
    [sym_cast_expression] = STATE(1197),
    [sym_sizeof_expression] = STATE(1197),
    [sym_subscript_expression] = STATE(1197),
    [sym_call_expression] = STATE(1197),
    [sym_field_expression] = STATE(1197),
    [sym_compound_literal_expression] = STATE(1197),
    [sym_parenthesized_expression] = STATE(1197),
    [sym_char_literal] = STATE(1197),
    [sym_concatenated_string] = STATE(1197),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1197),
    [sym_new_expression] = STATE(1197),
    [sym_delete_expression] = STATE(1197),
    [sym_lambda_expression] = STATE(1197),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2511),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(2511),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2513),
    [sym_false] = ACTIONS(2513),
    [sym_null] = ACTIONS(2513),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(2513),
  },
  [541] = {
    [sym__expression] = STATE(1198),
    [sym_conditional_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(1198),
    [sym_pointer_expression] = STATE(1198),
    [sym_logical_expression] = STATE(1198),
    [sym_bitwise_expression] = STATE(1198),
    [sym_equality_expression] = STATE(1198),
    [sym_relational_expression] = STATE(1198),
    [sym_shift_expression] = STATE(1198),
    [sym_math_expression] = STATE(1198),
    [sym_cast_expression] = STATE(1198),
    [sym_sizeof_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_call_expression] = STATE(1198),
    [sym_field_expression] = STATE(1198),
    [sym_compound_literal_expression] = STATE(1198),
    [sym_parenthesized_expression] = STATE(1198),
    [sym_char_literal] = STATE(1198),
    [sym_concatenated_string] = STATE(1198),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1198),
    [sym_new_expression] = STATE(1198),
    [sym_delete_expression] = STATE(1198),
    [sym_lambda_expression] = STATE(1198),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2515),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(2515),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2517),
    [sym_false] = ACTIONS(2517),
    [sym_null] = ACTIONS(2517),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(2517),
  },
  [542] = {
    [sym__expression] = STATE(1199),
    [sym_conditional_expression] = STATE(1199),
    [sym_assignment_expression] = STATE(1199),
    [sym_pointer_expression] = STATE(1199),
    [sym_logical_expression] = STATE(1199),
    [sym_bitwise_expression] = STATE(1199),
    [sym_equality_expression] = STATE(1199),
    [sym_relational_expression] = STATE(1199),
    [sym_shift_expression] = STATE(1199),
    [sym_math_expression] = STATE(1199),
    [sym_cast_expression] = STATE(1199),
    [sym_sizeof_expression] = STATE(1199),
    [sym_subscript_expression] = STATE(1199),
    [sym_call_expression] = STATE(1199),
    [sym_field_expression] = STATE(1199),
    [sym_compound_literal_expression] = STATE(1199),
    [sym_parenthesized_expression] = STATE(1199),
    [sym_char_literal] = STATE(1199),
    [sym_concatenated_string] = STATE(1199),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1199),
    [sym_new_expression] = STATE(1199),
    [sym_delete_expression] = STATE(1199),
    [sym_lambda_expression] = STATE(1199),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2519),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(2519),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2521),
    [sym_false] = ACTIONS(2521),
    [sym_null] = ACTIONS(2521),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(2521),
  },
  [543] = {
    [sym__expression] = STATE(1200),
    [sym_conditional_expression] = STATE(1200),
    [sym_assignment_expression] = STATE(1200),
    [sym_pointer_expression] = STATE(1200),
    [sym_logical_expression] = STATE(1200),
    [sym_bitwise_expression] = STATE(1200),
    [sym_equality_expression] = STATE(1200),
    [sym_relational_expression] = STATE(1200),
    [sym_shift_expression] = STATE(1200),
    [sym_math_expression] = STATE(1200),
    [sym_cast_expression] = STATE(1200),
    [sym_sizeof_expression] = STATE(1200),
    [sym_subscript_expression] = STATE(1200),
    [sym_call_expression] = STATE(1200),
    [sym_field_expression] = STATE(1200),
    [sym_compound_literal_expression] = STATE(1200),
    [sym_parenthesized_expression] = STATE(1200),
    [sym_initializer_list] = STATE(1201),
    [sym_char_literal] = STATE(1200),
    [sym_concatenated_string] = STATE(1200),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1200),
    [sym_new_expression] = STATE(1200),
    [sym_delete_expression] = STATE(1200),
    [sym_lambda_expression] = STATE(1200),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2523),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2523),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2525),
    [sym_false] = ACTIONS(2525),
    [sym_null] = ACTIONS(2525),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2525),
  },
  [544] = {
    [sym_string_literal] = STATE(1202),
    [aux_sym_concatenated_string_repeat1] = STATE(1202),
    [anon_sym_COMMA] = ACTIONS(1761),
    [anon_sym_RPAREN] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_EQ] = ACTIONS(1763),
    [anon_sym_QMARK] = ACTIONS(1761),
    [anon_sym_STAR_EQ] = ACTIONS(1761),
    [anon_sym_SLASH_EQ] = ACTIONS(1761),
    [anon_sym_PERCENT_EQ] = ACTIONS(1761),
    [anon_sym_PLUS_EQ] = ACTIONS(1761),
    [anon_sym_DASH_EQ] = ACTIONS(1761),
    [anon_sym_LT_LT_EQ] = ACTIONS(1761),
    [anon_sym_GT_GT_EQ] = ACTIONS(1761),
    [anon_sym_AMP_EQ] = ACTIONS(1761),
    [anon_sym_CARET_EQ] = ACTIONS(1761),
    [anon_sym_PIPE_EQ] = ACTIONS(1761),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_PIPE_PIPE] = ACTIONS(1761),
    [anon_sym_AMP_AMP] = ACTIONS(1761),
    [anon_sym_PIPE] = ACTIONS(1763),
    [anon_sym_CARET] = ACTIONS(1763),
    [anon_sym_EQ_EQ] = ACTIONS(1761),
    [anon_sym_BANG_EQ] = ACTIONS(1761),
    [anon_sym_LT] = ACTIONS(1763),
    [anon_sym_GT] = ACTIONS(1763),
    [anon_sym_LT_EQ] = ACTIONS(1761),
    [anon_sym_GT_EQ] = ACTIONS(1761),
    [anon_sym_LT_LT] = ACTIONS(1763),
    [anon_sym_GT_GT] = ACTIONS(1763),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_SLASH] = ACTIONS(1763),
    [anon_sym_PERCENT] = ACTIONS(1763),
    [anon_sym_DASH_DASH] = ACTIONS(1761),
    [anon_sym_PLUS_PLUS] = ACTIONS(1761),
    [anon_sym_DOT] = ACTIONS(1761),
    [anon_sym_DASH_GT] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(91),
  },
  [545] = {
    [sym__abstract_declarator] = STATE(1203),
    [sym_abstract_pointer_declarator] = STATE(1203),
    [sym_abstract_function_declarator] = STATE(1203),
    [sym_abstract_array_declarator] = STATE(1203),
    [sym_parameter_list] = STATE(528),
    [sym_abstract_reference_declarator] = STATE(1203),
    [anon_sym_RPAREN] = ACTIONS(2465),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_AMP_AMP] = ACTIONS(893),
    [sym_comment] = ACTIONS(91),
  },
  [546] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(546),
    [anon_sym_RPAREN] = ACTIONS(1985),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1985),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_unsigned] = ACTIONS(2527),
    [anon_sym_long] = ACTIONS(2527),
    [anon_sym_short] = ACTIONS(2527),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [sym_comment] = ACTIONS(91),
  },
  [547] = {
    [sym_destructor_name] = STATE(789),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(2530),
    [sym_comment] = ACTIONS(91),
    [sym_operator_name] = ACTIONS(1418),
  },
  [548] = {
    [anon_sym_COMMA] = ACTIONS(1424),
    [anon_sym_RPAREN] = ACTIONS(1424),
    [anon_sym_SEMI] = ACTIONS(1424),
    [anon_sym_LBRACE] = ACTIONS(1431),
    [anon_sym_RBRACE] = ACTIONS(1424),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_STAR] = ACTIONS(1436),
    [anon_sym_LBRACK] = ACTIONS(1424),
    [anon_sym_RBRACK] = ACTIONS(1424),
    [anon_sym_EQ] = ACTIONS(1436),
    [anon_sym_COLON] = ACTIONS(1436),
    [anon_sym_QMARK] = ACTIONS(1424),
    [anon_sym_STAR_EQ] = ACTIONS(1424),
    [anon_sym_SLASH_EQ] = ACTIONS(1424),
    [anon_sym_PERCENT_EQ] = ACTIONS(1424),
    [anon_sym_PLUS_EQ] = ACTIONS(1424),
    [anon_sym_DASH_EQ] = ACTIONS(1424),
    [anon_sym_LT_LT_EQ] = ACTIONS(1424),
    [anon_sym_GT_GT_EQ] = ACTIONS(1424),
    [anon_sym_AMP_EQ] = ACTIONS(1424),
    [anon_sym_CARET_EQ] = ACTIONS(1424),
    [anon_sym_PIPE_EQ] = ACTIONS(1424),
    [anon_sym_AMP] = ACTIONS(1436),
    [anon_sym_PIPE_PIPE] = ACTIONS(1424),
    [anon_sym_AMP_AMP] = ACTIONS(1424),
    [anon_sym_PIPE] = ACTIONS(1436),
    [anon_sym_CARET] = ACTIONS(1436),
    [anon_sym_EQ_EQ] = ACTIONS(1424),
    [anon_sym_BANG_EQ] = ACTIONS(1424),
    [anon_sym_LT] = ACTIONS(1436),
    [anon_sym_GT] = ACTIONS(1436),
    [anon_sym_LT_EQ] = ACTIONS(1424),
    [anon_sym_GT_EQ] = ACTIONS(1424),
    [anon_sym_LT_LT] = ACTIONS(1436),
    [anon_sym_GT_GT] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1436),
    [anon_sym_DASH] = ACTIONS(1436),
    [anon_sym_SLASH] = ACTIONS(1436),
    [anon_sym_PERCENT] = ACTIONS(1436),
    [anon_sym_DASH_DASH] = ACTIONS(1424),
    [anon_sym_PLUS_PLUS] = ACTIONS(1424),
    [anon_sym_DOT] = ACTIONS(1424),
    [anon_sym_DASH_GT] = ACTIONS(1424),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1431),
  },
  [549] = {
    [anon_sym_COMMA] = ACTIONS(1575),
    [anon_sym_RPAREN] = ACTIONS(1575),
    [anon_sym_SEMI] = ACTIONS(1575),
    [anon_sym_LBRACE] = ACTIONS(1582),
    [anon_sym_RBRACE] = ACTIONS(1575),
    [anon_sym_LPAREN2] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(1587),
    [anon_sym_LBRACK] = ACTIONS(1575),
    [anon_sym_RBRACK] = ACTIONS(1575),
    [anon_sym_EQ] = ACTIONS(1587),
    [anon_sym_COLON] = ACTIONS(1587),
    [anon_sym_QMARK] = ACTIONS(1575),
    [anon_sym_STAR_EQ] = ACTIONS(1575),
    [anon_sym_SLASH_EQ] = ACTIONS(1575),
    [anon_sym_PERCENT_EQ] = ACTIONS(1575),
    [anon_sym_PLUS_EQ] = ACTIONS(1575),
    [anon_sym_DASH_EQ] = ACTIONS(1575),
    [anon_sym_LT_LT_EQ] = ACTIONS(1575),
    [anon_sym_GT_GT_EQ] = ACTIONS(1575),
    [anon_sym_AMP_EQ] = ACTIONS(1575),
    [anon_sym_CARET_EQ] = ACTIONS(1575),
    [anon_sym_PIPE_EQ] = ACTIONS(1575),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_PIPE_PIPE] = ACTIONS(1575),
    [anon_sym_AMP_AMP] = ACTIONS(1575),
    [anon_sym_PIPE] = ACTIONS(1587),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_EQ_EQ] = ACTIONS(1575),
    [anon_sym_BANG_EQ] = ACTIONS(1575),
    [anon_sym_LT] = ACTIONS(1584),
    [anon_sym_GT] = ACTIONS(1587),
    [anon_sym_LT_EQ] = ACTIONS(1575),
    [anon_sym_GT_EQ] = ACTIONS(1575),
    [anon_sym_LT_LT] = ACTIONS(1587),
    [anon_sym_GT_GT] = ACTIONS(1587),
    [anon_sym_PLUS] = ACTIONS(1587),
    [anon_sym_DASH] = ACTIONS(1587),
    [anon_sym_SLASH] = ACTIONS(1587),
    [anon_sym_PERCENT] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1575),
    [anon_sym_PLUS_PLUS] = ACTIONS(1575),
    [anon_sym_DOT] = ACTIONS(1575),
    [anon_sym_DASH_GT] = ACTIONS(1575),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
  },
  [550] = {
    [sym_type_qualifier] = STATE(1206),
    [sym_virtual_specifier] = STATE(1206),
    [sym_trailing_return_type] = STATE(1206),
    [aux_sym_function_declarator_repeat1] = STATE(1206),
    [anon_sym_LPAREN2] = ACTIONS(1665),
    [anon_sym_LBRACK] = ACTIONS(1665),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(2532),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [sym_noexcept] = ACTIONS(2534),
  },
  [551] = {
    [sym_destructor_name] = STATE(958),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(2536),
    [sym_comment] = ACTIONS(91),
    [sym_operator_name] = ACTIONS(1767),
  },
  [552] = {
    [sym_type_qualifier] = STATE(552),
    [aux_sym_type_definition_repeat1] = STATE(552),
    [anon_sym_LPAREN2] = ACTIONS(2179),
    [anon_sym_STAR] = ACTIONS(2179),
    [anon_sym_const] = ACTIONS(2538),
    [anon_sym_restrict] = ACTIONS(2538),
    [anon_sym_volatile] = ACTIONS(2538),
    [anon_sym__Atomic] = ACTIONS(2538),
    [anon_sym_mutable] = ACTIONS(2538),
    [anon_sym_explicit] = ACTIONS(2538),
    [anon_sym_constexpr] = ACTIONS(2538),
    [anon_sym_AMP] = ACTIONS(2177),
    [anon_sym_AMP_AMP] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2179),
    [sym_identifier] = ACTIONS(2177),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(2179),
    [sym_operator_name] = ACTIONS(2179),
  },
  [553] = {
    [anon_sym_RPAREN] = ACTIONS(2541),
    [sym_comment] = ACTIONS(91),
  },
  [554] = {
    [sym_type_qualifier] = STATE(141),
    [sym__type_specifier] = STATE(136),
    [sym_sized_type_specifier] = STATE(136),
    [sym_enum_specifier] = STATE(136),
    [sym_struct_specifier] = STATE(136),
    [sym_union_specifier] = STATE(136),
    [sym__expression] = STATE(137),
    [sym_comma_expression] = STATE(138),
    [sym_conditional_expression] = STATE(137),
    [sym_assignment_expression] = STATE(137),
    [sym_pointer_expression] = STATE(137),
    [sym_logical_expression] = STATE(137),
    [sym_bitwise_expression] = STATE(137),
    [sym_equality_expression] = STATE(137),
    [sym_relational_expression] = STATE(137),
    [sym_shift_expression] = STATE(137),
    [sym_math_expression] = STATE(137),
    [sym_cast_expression] = STATE(137),
    [sym_type_descriptor] = STATE(1209),
    [sym_sizeof_expression] = STATE(137),
    [sym_subscript_expression] = STATE(137),
    [sym_call_expression] = STATE(137),
    [sym_field_expression] = STATE(137),
    [sym_compound_literal_expression] = STATE(137),
    [sym_parenthesized_expression] = STATE(137),
    [sym_char_literal] = STATE(137),
    [sym_concatenated_string] = STATE(137),
    [sym_string_literal] = STATE(140),
    [sym_macro_type_specifier] = STATE(136),
    [sym_class_specifier] = STATE(136),
    [sym_dependent_type] = STATE(136),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(137),
    [sym_new_expression] = STATE(137),
    [sym_delete_expression] = STATE(137),
    [sym_lambda_expression] = STATE(137),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_type_definition_repeat1] = STATE(141),
    [aux_sym_sized_type_specifier_repeat1] = STATE(142),
    [sym_raw_string_literal] = ACTIONS(213),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(219),
    [anon_sym_long] = ACTIONS(219),
    [anon_sym_short] = ACTIONS(219),
    [sym_primitive_type] = ACTIONS(221),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [sym_null] = ACTIONS(241),
    [sym_identifier] = ACTIONS(811),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(221),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(253),
    [sym_nullptr] = ACTIONS(241),
  },
  [555] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(1364),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(1364),
    [anon_sym_EQ] = ACTIONS(1366),
    [anon_sym_QMARK] = ACTIONS(1364),
    [anon_sym_STAR_EQ] = ACTIONS(1364),
    [anon_sym_SLASH_EQ] = ACTIONS(1364),
    [anon_sym_PERCENT_EQ] = ACTIONS(1364),
    [anon_sym_PLUS_EQ] = ACTIONS(1364),
    [anon_sym_DASH_EQ] = ACTIONS(1364),
    [anon_sym_LT_LT_EQ] = ACTIONS(1364),
    [anon_sym_GT_GT_EQ] = ACTIONS(1364),
    [anon_sym_AMP_EQ] = ACTIONS(1364),
    [anon_sym_CARET_EQ] = ACTIONS(1364),
    [anon_sym_PIPE_EQ] = ACTIONS(1364),
    [anon_sym_AMP] = ACTIONS(1366),
    [anon_sym_PIPE_PIPE] = ACTIONS(1364),
    [anon_sym_AMP_AMP] = ACTIONS(1364),
    [anon_sym_PIPE] = ACTIONS(1366),
    [anon_sym_CARET] = ACTIONS(1366),
    [anon_sym_EQ_EQ] = ACTIONS(1364),
    [anon_sym_BANG_EQ] = ACTIONS(1364),
    [anon_sym_LT] = ACTIONS(1366),
    [anon_sym_GT] = ACTIONS(1366),
    [anon_sym_LT_EQ] = ACTIONS(1364),
    [anon_sym_GT_EQ] = ACTIONS(1364),
    [anon_sym_LT_LT] = ACTIONS(1001),
    [anon_sym_GT_GT] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(975),
    [anon_sym_PERCENT] = ACTIONS(975),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [556] = {
    [sym__expression] = STATE(164),
    [sym_conditional_expression] = STATE(164),
    [sym_assignment_expression] = STATE(164),
    [sym_pointer_expression] = STATE(164),
    [sym_logical_expression] = STATE(164),
    [sym_bitwise_expression] = STATE(164),
    [sym_equality_expression] = STATE(164),
    [sym_relational_expression] = STATE(164),
    [sym_shift_expression] = STATE(164),
    [sym_math_expression] = STATE(164),
    [sym_cast_expression] = STATE(164),
    [sym_sizeof_expression] = STATE(164),
    [sym_subscript_expression] = STATE(164),
    [sym_call_expression] = STATE(164),
    [sym_field_expression] = STATE(164),
    [sym_compound_literal_expression] = STATE(164),
    [sym_parenthesized_expression] = STATE(164),
    [sym_char_literal] = STATE(164),
    [sym_concatenated_string] = STATE(164),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(164),
    [sym_new_expression] = STATE(164),
    [sym_delete_expression] = STATE(164),
    [sym_lambda_expression] = STATE(164),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_lambda_default_capture] = STATE(166),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(267),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(2543),
    [anon_sym_EQ] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(267),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(289),
    [sym_false] = ACTIONS(289),
    [sym_null] = ACTIONS(289),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(289),
  },
  [557] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(1489),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(1489),
    [anon_sym_EQ] = ACTIONS(1491),
    [anon_sym_QMARK] = ACTIONS(1489),
    [anon_sym_STAR_EQ] = ACTIONS(1489),
    [anon_sym_SLASH_EQ] = ACTIONS(1489),
    [anon_sym_PERCENT_EQ] = ACTIONS(1489),
    [anon_sym_PLUS_EQ] = ACTIONS(1489),
    [anon_sym_DASH_EQ] = ACTIONS(1489),
    [anon_sym_LT_LT_EQ] = ACTIONS(1489),
    [anon_sym_GT_GT_EQ] = ACTIONS(1489),
    [anon_sym_AMP_EQ] = ACTIONS(1489),
    [anon_sym_CARET_EQ] = ACTIONS(1489),
    [anon_sym_PIPE_EQ] = ACTIONS(1489),
    [anon_sym_AMP] = ACTIONS(985),
    [anon_sym_PIPE_PIPE] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(989),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_CARET] = ACTIONS(993),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(999),
    [anon_sym_LT_LT] = ACTIONS(1001),
    [anon_sym_GT_GT] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(975),
    [anon_sym_PERCENT] = ACTIONS(975),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [558] = {
    [sym__type_specifier] = STATE(871),
    [sym_sized_type_specifier] = STATE(871),
    [sym_enum_specifier] = STATE(871),
    [sym_struct_specifier] = STATE(871),
    [sym_union_specifier] = STATE(871),
    [sym_macro_type_specifier] = STATE(871),
    [sym_class_specifier] = STATE(871),
    [sym_dependent_type] = STATE(871),
    [sym_template_type] = STATE(309),
    [sym_scoped_type_identifier] = STATE(310),
    [sym_scoped_namespace_identifier] = STATE(311),
    [aux_sym_sized_type_specifier_repeat1] = STATE(561),
    [anon_sym_unsigned] = ACTIONS(965),
    [anon_sym_long] = ACTIONS(965),
    [anon_sym_short] = ACTIONS(965),
    [sym_primitive_type] = ACTIONS(1552),
    [anon_sym_enum] = ACTIONS(536),
    [anon_sym_struct] = ACTIONS(538),
    [anon_sym_union] = ACTIONS(540),
    [sym_identifier] = ACTIONS(542),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(544),
    [sym_auto] = ACTIONS(1552),
    [anon_sym_typename] = ACTIONS(969),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [559] = {
    [sym_argument_list] = STATE(874),
    [sym_initializer_list] = STATE(874),
    [sym_new_declarator] = STATE(875),
    [anon_sym_COMMA] = ACTIONS(1556),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1558),
    [anon_sym_LBRACK] = ACTIONS(2545),
    [anon_sym_RBRACK] = ACTIONS(1556),
    [anon_sym_EQ] = ACTIONS(1558),
    [anon_sym_QMARK] = ACTIONS(1556),
    [anon_sym_STAR_EQ] = ACTIONS(1556),
    [anon_sym_SLASH_EQ] = ACTIONS(1556),
    [anon_sym_PERCENT_EQ] = ACTIONS(1556),
    [anon_sym_PLUS_EQ] = ACTIONS(1556),
    [anon_sym_DASH_EQ] = ACTIONS(1556),
    [anon_sym_LT_LT_EQ] = ACTIONS(1556),
    [anon_sym_GT_GT_EQ] = ACTIONS(1556),
    [anon_sym_AMP_EQ] = ACTIONS(1556),
    [anon_sym_CARET_EQ] = ACTIONS(1556),
    [anon_sym_PIPE_EQ] = ACTIONS(1556),
    [anon_sym_AMP] = ACTIONS(1558),
    [anon_sym_PIPE_PIPE] = ACTIONS(1556),
    [anon_sym_AMP_AMP] = ACTIONS(1556),
    [anon_sym_PIPE] = ACTIONS(1558),
    [anon_sym_CARET] = ACTIONS(1558),
    [anon_sym_EQ_EQ] = ACTIONS(1556),
    [anon_sym_BANG_EQ] = ACTIONS(1556),
    [anon_sym_LT] = ACTIONS(1558),
    [anon_sym_GT] = ACTIONS(1558),
    [anon_sym_LT_EQ] = ACTIONS(1556),
    [anon_sym_GT_EQ] = ACTIONS(1556),
    [anon_sym_LT_LT] = ACTIONS(1558),
    [anon_sym_GT_GT] = ACTIONS(1558),
    [anon_sym_PLUS] = ACTIONS(1558),
    [anon_sym_DASH] = ACTIONS(1558),
    [anon_sym_SLASH] = ACTIONS(1558),
    [anon_sym_PERCENT] = ACTIONS(1558),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DOT] = ACTIONS(1556),
    [anon_sym_DASH_GT] = ACTIONS(1556),
    [sym_comment] = ACTIONS(91),
  },
  [560] = {
    [sym__type_specifier] = STATE(1212),
    [sym_sized_type_specifier] = STATE(1212),
    [sym_enum_specifier] = STATE(1212),
    [sym_struct_specifier] = STATE(1212),
    [sym_union_specifier] = STATE(1212),
    [sym_macro_type_specifier] = STATE(1212),
    [sym_class_specifier] = STATE(1212),
    [sym_dependent_type] = STATE(1212),
    [sym_template_type] = STATE(309),
    [sym_scoped_type_identifier] = STATE(310),
    [sym_scoped_namespace_identifier] = STATE(311),
    [aux_sym_sized_type_specifier_repeat1] = STATE(561),
    [anon_sym_unsigned] = ACTIONS(965),
    [anon_sym_long] = ACTIONS(965),
    [anon_sym_short] = ACTIONS(965),
    [sym_primitive_type] = ACTIONS(2547),
    [anon_sym_enum] = ACTIONS(536),
    [anon_sym_struct] = ACTIONS(538),
    [anon_sym_union] = ACTIONS(540),
    [sym_identifier] = ACTIONS(542),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(544),
    [sym_auto] = ACTIONS(2547),
    [anon_sym_typename] = ACTIONS(969),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [561] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1213),
    [anon_sym_COMMA] = ACTIONS(653),
    [anon_sym_LBRACE] = ACTIONS(653),
    [anon_sym_LPAREN2] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_RBRACK] = ACTIONS(653),
    [anon_sym_EQ] = ACTIONS(655),
    [anon_sym_unsigned] = ACTIONS(2549),
    [anon_sym_long] = ACTIONS(2549),
    [anon_sym_short] = ACTIONS(2549),
    [sym_primitive_type] = ACTIONS(1571),
    [anon_sym_QMARK] = ACTIONS(653),
    [anon_sym_STAR_EQ] = ACTIONS(653),
    [anon_sym_SLASH_EQ] = ACTIONS(653),
    [anon_sym_PERCENT_EQ] = ACTIONS(653),
    [anon_sym_PLUS_EQ] = ACTIONS(653),
    [anon_sym_DASH_EQ] = ACTIONS(653),
    [anon_sym_LT_LT_EQ] = ACTIONS(653),
    [anon_sym_GT_GT_EQ] = ACTIONS(653),
    [anon_sym_AMP_EQ] = ACTIONS(653),
    [anon_sym_CARET_EQ] = ACTIONS(653),
    [anon_sym_PIPE_EQ] = ACTIONS(653),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_PIPE_PIPE] = ACTIONS(653),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(655),
    [anon_sym_EQ_EQ] = ACTIONS(653),
    [anon_sym_BANG_EQ] = ACTIONS(653),
    [anon_sym_LT] = ACTIONS(655),
    [anon_sym_GT] = ACTIONS(655),
    [anon_sym_LT_EQ] = ACTIONS(653),
    [anon_sym_GT_EQ] = ACTIONS(653),
    [anon_sym_LT_LT] = ACTIONS(655),
    [anon_sym_GT_GT] = ACTIONS(655),
    [anon_sym_PLUS] = ACTIONS(655),
    [anon_sym_DASH] = ACTIONS(655),
    [anon_sym_SLASH] = ACTIONS(655),
    [anon_sym_PERCENT] = ACTIONS(655),
    [anon_sym_DASH_DASH] = ACTIONS(653),
    [anon_sym_PLUS_PLUS] = ACTIONS(653),
    [anon_sym_DOT] = ACTIONS(653),
    [anon_sym_DASH_GT] = ACTIONS(653),
    [sym_identifier] = ACTIONS(1573),
    [sym_comment] = ACTIONS(91),
  },
  [562] = {
    [sym__expression] = STATE(1215),
    [sym_conditional_expression] = STATE(1215),
    [sym_assignment_expression] = STATE(1215),
    [sym_pointer_expression] = STATE(1215),
    [sym_logical_expression] = STATE(1215),
    [sym_bitwise_expression] = STATE(1215),
    [sym_equality_expression] = STATE(1215),
    [sym_relational_expression] = STATE(1215),
    [sym_shift_expression] = STATE(1215),
    [sym_math_expression] = STATE(1215),
    [sym_cast_expression] = STATE(1215),
    [sym_sizeof_expression] = STATE(1215),
    [sym_subscript_expression] = STATE(1215),
    [sym_call_expression] = STATE(1215),
    [sym_field_expression] = STATE(1215),
    [sym_compound_literal_expression] = STATE(1215),
    [sym_parenthesized_expression] = STATE(1215),
    [sym_char_literal] = STATE(1215),
    [sym_concatenated_string] = STATE(1215),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1215),
    [sym_new_expression] = STATE(1215),
    [sym_delete_expression] = STATE(1215),
    [sym_lambda_expression] = STATE(1215),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2551),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(2553),
    [anon_sym_AMP] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(2551),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2555),
    [sym_false] = ACTIONS(2555),
    [sym_null] = ACTIONS(2555),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(2555),
  },
  [563] = {
    [sym__expression] = STATE(1216),
    [sym_conditional_expression] = STATE(1216),
    [sym_assignment_expression] = STATE(1216),
    [sym_pointer_expression] = STATE(1216),
    [sym_logical_expression] = STATE(1216),
    [sym_bitwise_expression] = STATE(1216),
    [sym_equality_expression] = STATE(1216),
    [sym_relational_expression] = STATE(1216),
    [sym_shift_expression] = STATE(1216),
    [sym_math_expression] = STATE(1216),
    [sym_cast_expression] = STATE(1216),
    [sym_sizeof_expression] = STATE(1216),
    [sym_subscript_expression] = STATE(1216),
    [sym_call_expression] = STATE(1216),
    [sym_field_expression] = STATE(1216),
    [sym_compound_literal_expression] = STATE(1216),
    [sym_parenthesized_expression] = STATE(1216),
    [sym_char_literal] = STATE(1216),
    [sym_concatenated_string] = STATE(1216),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1216),
    [sym_new_expression] = STATE(1216),
    [sym_delete_expression] = STATE(1216),
    [sym_lambda_expression] = STATE(1216),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2557),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(2557),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2559),
    [sym_false] = ACTIONS(2559),
    [sym_null] = ACTIONS(2559),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(2559),
  },
  [564] = {
    [sym__expression] = STATE(938),
    [sym_conditional_expression] = STATE(938),
    [sym_assignment_expression] = STATE(938),
    [sym_pointer_expression] = STATE(938),
    [sym_logical_expression] = STATE(938),
    [sym_bitwise_expression] = STATE(938),
    [sym_equality_expression] = STATE(938),
    [sym_relational_expression] = STATE(938),
    [sym_shift_expression] = STATE(938),
    [sym_math_expression] = STATE(938),
    [sym_cast_expression] = STATE(938),
    [sym_sizeof_expression] = STATE(938),
    [sym_subscript_expression] = STATE(938),
    [sym_call_expression] = STATE(938),
    [sym_field_expression] = STATE(938),
    [sym_compound_literal_expression] = STATE(938),
    [sym_parenthesized_expression] = STATE(938),
    [sym_char_literal] = STATE(938),
    [sym_concatenated_string] = STATE(938),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(938),
    [sym_new_expression] = STATE(938),
    [sym_delete_expression] = STATE(938),
    [sym_lambda_expression] = STATE(938),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(1701),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(1701),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(1703),
    [sym_false] = ACTIONS(1703),
    [sym_null] = ACTIONS(1703),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(1703),
  },
  [565] = {
    [anon_sym_LPAREN2] = ACTIONS(2561),
    [anon_sym_STAR] = ACTIONS(2561),
    [anon_sym_LBRACK] = ACTIONS(2561),
    [anon_sym_AMP] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2561),
    [sym_comment] = ACTIONS(91),
  },
  [566] = {
    [sym__expression] = STATE(1217),
    [sym_conditional_expression] = STATE(1217),
    [sym_assignment_expression] = STATE(1217),
    [sym_pointer_expression] = STATE(1217),
    [sym_logical_expression] = STATE(1217),
    [sym_bitwise_expression] = STATE(1217),
    [sym_equality_expression] = STATE(1217),
    [sym_relational_expression] = STATE(1217),
    [sym_shift_expression] = STATE(1217),
    [sym_math_expression] = STATE(1217),
    [sym_cast_expression] = STATE(1217),
    [sym_sizeof_expression] = STATE(1217),
    [sym_subscript_expression] = STATE(1217),
    [sym_call_expression] = STATE(1217),
    [sym_field_expression] = STATE(1217),
    [sym_compound_literal_expression] = STATE(1217),
    [sym_parenthesized_expression] = STATE(1217),
    [sym_char_literal] = STATE(1217),
    [sym_concatenated_string] = STATE(1217),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1217),
    [sym_new_expression] = STATE(1217),
    [sym_delete_expression] = STATE(1217),
    [sym_lambda_expression] = STATE(1217),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2565),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(2565),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2567),
    [sym_false] = ACTIONS(2567),
    [sym_null] = ACTIONS(2567),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(2567),
  },
  [567] = {
    [sym__expression] = STATE(1218),
    [sym_conditional_expression] = STATE(1218),
    [sym_assignment_expression] = STATE(1218),
    [sym_pointer_expression] = STATE(1218),
    [sym_logical_expression] = STATE(1218),
    [sym_bitwise_expression] = STATE(1218),
    [sym_equality_expression] = STATE(1218),
    [sym_relational_expression] = STATE(1218),
    [sym_shift_expression] = STATE(1218),
    [sym_math_expression] = STATE(1218),
    [sym_cast_expression] = STATE(1218),
    [sym_sizeof_expression] = STATE(1218),
    [sym_subscript_expression] = STATE(1218),
    [sym_call_expression] = STATE(1218),
    [sym_field_expression] = STATE(1218),
    [sym_compound_literal_expression] = STATE(1218),
    [sym_parenthesized_expression] = STATE(1218),
    [sym_char_literal] = STATE(1218),
    [sym_concatenated_string] = STATE(1218),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1218),
    [sym_new_expression] = STATE(1218),
    [sym_delete_expression] = STATE(1218),
    [sym_lambda_expression] = STATE(1218),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2569),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(2569),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(2571),
    [sym_false] = ACTIONS(2571),
    [sym_null] = ACTIONS(2571),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(2571),
  },
  [568] = {
    [sym__expression] = STATE(1219),
    [sym_conditional_expression] = STATE(1219),
    [sym_assignment_expression] = STATE(1219),
    [sym_pointer_expression] = STATE(1219),
    [sym_logical_expression] = STATE(1219),
    [sym_bitwise_expression] = STATE(1219),
    [sym_equality_expression] = STATE(1219),
    [sym_relational_expression] = STATE(1219),
    [sym_shift_expression] = STATE(1219),
    [sym_math_expression] = STATE(1219),
    [sym_cast_expression] = STATE(1219),
    [sym_sizeof_expression] = STATE(1219),
    [sym_subscript_expression] = STATE(1219),
    [sym_call_expression] = STATE(1219),
    [sym_field_expression] = STATE(1219),
    [sym_compound_literal_expression] = STATE(1219),
    [sym_parenthesized_expression] = STATE(1219),
    [sym_char_literal] = STATE(1219),
    [sym_concatenated_string] = STATE(1219),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1219),
    [sym_new_expression] = STATE(1219),
    [sym_delete_expression] = STATE(1219),
    [sym_lambda_expression] = STATE(1219),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2573),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(2573),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2575),
    [sym_false] = ACTIONS(2575),
    [sym_null] = ACTIONS(2575),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(2575),
  },
  [569] = {
    [sym__expression] = STATE(1220),
    [sym_conditional_expression] = STATE(1220),
    [sym_assignment_expression] = STATE(1220),
    [sym_pointer_expression] = STATE(1220),
    [sym_logical_expression] = STATE(1220),
    [sym_bitwise_expression] = STATE(1220),
    [sym_equality_expression] = STATE(1220),
    [sym_relational_expression] = STATE(1220),
    [sym_shift_expression] = STATE(1220),
    [sym_math_expression] = STATE(1220),
    [sym_cast_expression] = STATE(1220),
    [sym_sizeof_expression] = STATE(1220),
    [sym_subscript_expression] = STATE(1220),
    [sym_call_expression] = STATE(1220),
    [sym_field_expression] = STATE(1220),
    [sym_compound_literal_expression] = STATE(1220),
    [sym_parenthesized_expression] = STATE(1220),
    [sym_char_literal] = STATE(1220),
    [sym_concatenated_string] = STATE(1220),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1220),
    [sym_new_expression] = STATE(1220),
    [sym_delete_expression] = STATE(1220),
    [sym_lambda_expression] = STATE(1220),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2577),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(2577),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2579),
    [sym_false] = ACTIONS(2579),
    [sym_null] = ACTIONS(2579),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(2579),
  },
  [570] = {
    [sym__expression] = STATE(1221),
    [sym_conditional_expression] = STATE(1221),
    [sym_assignment_expression] = STATE(1221),
    [sym_pointer_expression] = STATE(1221),
    [sym_logical_expression] = STATE(1221),
    [sym_bitwise_expression] = STATE(1221),
    [sym_equality_expression] = STATE(1221),
    [sym_relational_expression] = STATE(1221),
    [sym_shift_expression] = STATE(1221),
    [sym_math_expression] = STATE(1221),
    [sym_cast_expression] = STATE(1221),
    [sym_sizeof_expression] = STATE(1221),
    [sym_subscript_expression] = STATE(1221),
    [sym_call_expression] = STATE(1221),
    [sym_field_expression] = STATE(1221),
    [sym_compound_literal_expression] = STATE(1221),
    [sym_parenthesized_expression] = STATE(1221),
    [sym_char_literal] = STATE(1221),
    [sym_concatenated_string] = STATE(1221),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1221),
    [sym_new_expression] = STATE(1221),
    [sym_delete_expression] = STATE(1221),
    [sym_lambda_expression] = STATE(1221),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2581),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(2581),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2583),
    [sym_false] = ACTIONS(2583),
    [sym_null] = ACTIONS(2583),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(2583),
  },
  [571] = {
    [sym__expression] = STATE(1222),
    [sym_conditional_expression] = STATE(1222),
    [sym_assignment_expression] = STATE(1222),
    [sym_pointer_expression] = STATE(1222),
    [sym_logical_expression] = STATE(1222),
    [sym_bitwise_expression] = STATE(1222),
    [sym_equality_expression] = STATE(1222),
    [sym_relational_expression] = STATE(1222),
    [sym_shift_expression] = STATE(1222),
    [sym_math_expression] = STATE(1222),
    [sym_cast_expression] = STATE(1222),
    [sym_sizeof_expression] = STATE(1222),
    [sym_subscript_expression] = STATE(1222),
    [sym_call_expression] = STATE(1222),
    [sym_field_expression] = STATE(1222),
    [sym_compound_literal_expression] = STATE(1222),
    [sym_parenthesized_expression] = STATE(1222),
    [sym_char_literal] = STATE(1222),
    [sym_concatenated_string] = STATE(1222),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1222),
    [sym_new_expression] = STATE(1222),
    [sym_delete_expression] = STATE(1222),
    [sym_lambda_expression] = STATE(1222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2585),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(2585),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2587),
    [sym_false] = ACTIONS(2587),
    [sym_null] = ACTIONS(2587),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(2587),
  },
  [572] = {
    [sym__expression] = STATE(1223),
    [sym_conditional_expression] = STATE(1223),
    [sym_assignment_expression] = STATE(1223),
    [sym_pointer_expression] = STATE(1223),
    [sym_logical_expression] = STATE(1223),
    [sym_bitwise_expression] = STATE(1223),
    [sym_equality_expression] = STATE(1223),
    [sym_relational_expression] = STATE(1223),
    [sym_shift_expression] = STATE(1223),
    [sym_math_expression] = STATE(1223),
    [sym_cast_expression] = STATE(1223),
    [sym_sizeof_expression] = STATE(1223),
    [sym_subscript_expression] = STATE(1223),
    [sym_call_expression] = STATE(1223),
    [sym_field_expression] = STATE(1223),
    [sym_compound_literal_expression] = STATE(1223),
    [sym_parenthesized_expression] = STATE(1223),
    [sym_char_literal] = STATE(1223),
    [sym_concatenated_string] = STATE(1223),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1223),
    [sym_new_expression] = STATE(1223),
    [sym_delete_expression] = STATE(1223),
    [sym_lambda_expression] = STATE(1223),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2589),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(2589),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2591),
    [sym_false] = ACTIONS(2591),
    [sym_null] = ACTIONS(2591),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(2591),
  },
  [573] = {
    [sym__expression] = STATE(1224),
    [sym_conditional_expression] = STATE(1224),
    [sym_assignment_expression] = STATE(1224),
    [sym_pointer_expression] = STATE(1224),
    [sym_logical_expression] = STATE(1224),
    [sym_bitwise_expression] = STATE(1224),
    [sym_equality_expression] = STATE(1224),
    [sym_relational_expression] = STATE(1224),
    [sym_shift_expression] = STATE(1224),
    [sym_math_expression] = STATE(1224),
    [sym_cast_expression] = STATE(1224),
    [sym_sizeof_expression] = STATE(1224),
    [sym_subscript_expression] = STATE(1224),
    [sym_call_expression] = STATE(1224),
    [sym_field_expression] = STATE(1224),
    [sym_compound_literal_expression] = STATE(1224),
    [sym_parenthesized_expression] = STATE(1224),
    [sym_char_literal] = STATE(1224),
    [sym_concatenated_string] = STATE(1224),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_delete_expression] = STATE(1224),
    [sym_lambda_expression] = STATE(1224),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2593),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(2593),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [sym_null] = ACTIONS(2595),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(2595),
  },
  [574] = {
    [sym__expression] = STATE(1225),
    [sym_conditional_expression] = STATE(1225),
    [sym_assignment_expression] = STATE(1225),
    [sym_pointer_expression] = STATE(1225),
    [sym_logical_expression] = STATE(1225),
    [sym_bitwise_expression] = STATE(1225),
    [sym_equality_expression] = STATE(1225),
    [sym_relational_expression] = STATE(1225),
    [sym_shift_expression] = STATE(1225),
    [sym_math_expression] = STATE(1225),
    [sym_cast_expression] = STATE(1225),
    [sym_sizeof_expression] = STATE(1225),
    [sym_subscript_expression] = STATE(1225),
    [sym_call_expression] = STATE(1225),
    [sym_field_expression] = STATE(1225),
    [sym_compound_literal_expression] = STATE(1225),
    [sym_parenthesized_expression] = STATE(1225),
    [sym_char_literal] = STATE(1225),
    [sym_concatenated_string] = STATE(1225),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1225),
    [sym_new_expression] = STATE(1225),
    [sym_delete_expression] = STATE(1225),
    [sym_lambda_expression] = STATE(1225),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2597),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(2597),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2599),
    [sym_false] = ACTIONS(2599),
    [sym_null] = ACTIONS(2599),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(2599),
  },
  [575] = {
    [sym__expression] = STATE(1226),
    [sym_conditional_expression] = STATE(1226),
    [sym_assignment_expression] = STATE(1226),
    [sym_pointer_expression] = STATE(1226),
    [sym_logical_expression] = STATE(1226),
    [sym_bitwise_expression] = STATE(1226),
    [sym_equality_expression] = STATE(1226),
    [sym_relational_expression] = STATE(1226),
    [sym_shift_expression] = STATE(1226),
    [sym_math_expression] = STATE(1226),
    [sym_cast_expression] = STATE(1226),
    [sym_sizeof_expression] = STATE(1226),
    [sym_subscript_expression] = STATE(1226),
    [sym_call_expression] = STATE(1226),
    [sym_field_expression] = STATE(1226),
    [sym_compound_literal_expression] = STATE(1226),
    [sym_parenthesized_expression] = STATE(1226),
    [sym_char_literal] = STATE(1226),
    [sym_concatenated_string] = STATE(1226),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1226),
    [sym_new_expression] = STATE(1226),
    [sym_delete_expression] = STATE(1226),
    [sym_lambda_expression] = STATE(1226),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2601),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(2601),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2603),
    [sym_false] = ACTIONS(2603),
    [sym_null] = ACTIONS(2603),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(2603),
  },
  [576] = {
    [sym__expression] = STATE(1227),
    [sym_conditional_expression] = STATE(1227),
    [sym_assignment_expression] = STATE(1227),
    [sym_pointer_expression] = STATE(1227),
    [sym_logical_expression] = STATE(1227),
    [sym_bitwise_expression] = STATE(1227),
    [sym_equality_expression] = STATE(1227),
    [sym_relational_expression] = STATE(1227),
    [sym_shift_expression] = STATE(1227),
    [sym_math_expression] = STATE(1227),
    [sym_cast_expression] = STATE(1227),
    [sym_sizeof_expression] = STATE(1227),
    [sym_subscript_expression] = STATE(1227),
    [sym_call_expression] = STATE(1227),
    [sym_field_expression] = STATE(1227),
    [sym_compound_literal_expression] = STATE(1227),
    [sym_parenthesized_expression] = STATE(1227),
    [sym_char_literal] = STATE(1227),
    [sym_concatenated_string] = STATE(1227),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1227),
    [sym_new_expression] = STATE(1227),
    [sym_delete_expression] = STATE(1227),
    [sym_lambda_expression] = STATE(1227),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2605),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(2605),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2607),
    [sym_false] = ACTIONS(2607),
    [sym_null] = ACTIONS(2607),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(2607),
  },
  [577] = {
    [aux_sym_for_statement_repeat1] = STATE(1229),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_RBRACK] = ACTIONS(2609),
    [sym_comment] = ACTIONS(91),
  },
  [578] = {
    [sym_string_literal] = STATE(1230),
    [aux_sym_concatenated_string_repeat1] = STATE(1230),
    [anon_sym_COMMA] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_RBRACK] = ACTIONS(1761),
    [anon_sym_EQ] = ACTIONS(1763),
    [anon_sym_QMARK] = ACTIONS(1761),
    [anon_sym_STAR_EQ] = ACTIONS(1761),
    [anon_sym_SLASH_EQ] = ACTIONS(1761),
    [anon_sym_PERCENT_EQ] = ACTIONS(1761),
    [anon_sym_PLUS_EQ] = ACTIONS(1761),
    [anon_sym_DASH_EQ] = ACTIONS(1761),
    [anon_sym_LT_LT_EQ] = ACTIONS(1761),
    [anon_sym_GT_GT_EQ] = ACTIONS(1761),
    [anon_sym_AMP_EQ] = ACTIONS(1761),
    [anon_sym_CARET_EQ] = ACTIONS(1761),
    [anon_sym_PIPE_EQ] = ACTIONS(1761),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_PIPE_PIPE] = ACTIONS(1761),
    [anon_sym_AMP_AMP] = ACTIONS(1761),
    [anon_sym_PIPE] = ACTIONS(1763),
    [anon_sym_CARET] = ACTIONS(1763),
    [anon_sym_EQ_EQ] = ACTIONS(1761),
    [anon_sym_BANG_EQ] = ACTIONS(1761),
    [anon_sym_LT] = ACTIONS(1763),
    [anon_sym_GT] = ACTIONS(1763),
    [anon_sym_LT_EQ] = ACTIONS(1761),
    [anon_sym_GT_EQ] = ACTIONS(1761),
    [anon_sym_LT_LT] = ACTIONS(1763),
    [anon_sym_GT_GT] = ACTIONS(1763),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_SLASH] = ACTIONS(1763),
    [anon_sym_PERCENT] = ACTIONS(1763),
    [anon_sym_DASH_DASH] = ACTIONS(1761),
    [anon_sym_PLUS_PLUS] = ACTIONS(1761),
    [anon_sym_DOT] = ACTIONS(1761),
    [anon_sym_DASH_GT] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(91),
  },
  [579] = {
    [anon_sym_RBRACE] = ACTIONS(2611),
    [sym_comment] = ACTIONS(91),
  },
  [580] = {
    [anon_sym_COMMA] = ACTIONS(2613),
    [anon_sym_RPAREN] = ACTIONS(2613),
    [anon_sym_SEMI] = ACTIONS(2613),
    [anon_sym_extern] = ACTIONS(2615),
    [anon_sym_LBRACE] = ACTIONS(2613),
    [anon_sym_LPAREN2] = ACTIONS(2613),
    [anon_sym_STAR] = ACTIONS(2613),
    [anon_sym_LBRACK] = ACTIONS(2613),
    [anon_sym_EQ] = ACTIONS(2613),
    [anon_sym_static] = ACTIONS(2615),
    [anon_sym_register] = ACTIONS(2615),
    [anon_sym_inline] = ACTIONS(2615),
    [anon_sym_const] = ACTIONS(2615),
    [anon_sym_restrict] = ACTIONS(2615),
    [anon_sym_volatile] = ACTIONS(2615),
    [anon_sym__Atomic] = ACTIONS(2615),
    [anon_sym_mutable] = ACTIONS(2615),
    [anon_sym_explicit] = ACTIONS(2615),
    [anon_sym_constexpr] = ACTIONS(2615),
    [anon_sym_COLON] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2615),
    [anon_sym_AMP_AMP] = ACTIONS(2613),
    [anon_sym_TILDE] = ACTIONS(2613),
    [anon_sym_DASH_GT] = ACTIONS(2613),
    [sym_identifier] = ACTIONS(2615),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2615),
    [anon_sym_override] = ACTIONS(2615),
    [anon_sym_GT2] = ACTIONS(2613),
    [sym_noexcept] = ACTIONS(2615),
    [anon_sym_COLON_COLON] = ACTIONS(2613),
    [sym_operator_name] = ACTIONS(2613),
  },
  [581] = {
    [anon_sym_COMMA] = ACTIONS(2617),
    [anon_sym_RBRACE] = ACTIONS(2617),
    [anon_sym_EQ] = ACTIONS(2619),
    [sym_comment] = ACTIONS(91),
  },
  [582] = {
    [aux_sym_enumerator_list_repeat1] = STATE(1234),
    [anon_sym_COMMA] = ACTIONS(2621),
    [anon_sym_RBRACE] = ACTIONS(2611),
    [sym_comment] = ACTIONS(91),
  },
  [583] = {
    [anon_sym_COMMA] = ACTIONS(2623),
    [anon_sym_RPAREN] = ACTIONS(2623),
    [anon_sym_SEMI] = ACTIONS(2623),
    [anon_sym_extern] = ACTIONS(2625),
    [anon_sym_LBRACE] = ACTIONS(2623),
    [anon_sym_LPAREN2] = ACTIONS(2623),
    [anon_sym_STAR] = ACTIONS(2623),
    [anon_sym_LBRACK] = ACTIONS(2623),
    [anon_sym_EQ] = ACTIONS(2623),
    [anon_sym_static] = ACTIONS(2625),
    [anon_sym_register] = ACTIONS(2625),
    [anon_sym_inline] = ACTIONS(2625),
    [anon_sym_const] = ACTIONS(2625),
    [anon_sym_restrict] = ACTIONS(2625),
    [anon_sym_volatile] = ACTIONS(2625),
    [anon_sym__Atomic] = ACTIONS(2625),
    [anon_sym_mutable] = ACTIONS(2625),
    [anon_sym_explicit] = ACTIONS(2625),
    [anon_sym_constexpr] = ACTIONS(2625),
    [anon_sym_COLON] = ACTIONS(2625),
    [anon_sym_AMP] = ACTIONS(2625),
    [anon_sym_AMP_AMP] = ACTIONS(2623),
    [anon_sym_TILDE] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2623),
    [sym_identifier] = ACTIONS(2625),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2625),
    [anon_sym_override] = ACTIONS(2625),
    [anon_sym_GT2] = ACTIONS(2623),
    [sym_noexcept] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(2623),
    [sym_operator_name] = ACTIONS(2623),
  },
  [584] = {
    [sym_preproc_arg] = ACTIONS(2627),
    [sym_comment] = ACTIONS(121),
  },
  [585] = {
    [sym_identifier] = ACTIONS(2629),
    [sym_comment] = ACTIONS(91),
  },
  [586] = {
    [sym_type_qualifier] = STATE(1238),
    [sym__type_specifier] = STATE(1237),
    [sym_sized_type_specifier] = STATE(1237),
    [sym_enum_specifier] = STATE(1237),
    [sym_struct_specifier] = STATE(1237),
    [sym_union_specifier] = STATE(1237),
    [sym_macro_type_specifier] = STATE(1237),
    [sym_class_specifier] = STATE(1237),
    [sym_dependent_type] = STATE(1237),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(82),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_type_definition_repeat1] = STATE(1238),
    [aux_sym_sized_type_specifier_repeat1] = STATE(85),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(135),
    [anon_sym_long] = ACTIONS(135),
    [anon_sym_short] = ACTIONS(135),
    [sym_primitive_type] = ACTIONS(2631),
    [anon_sym_enum] = ACTIONS(139),
    [anon_sym_struct] = ACTIONS(141),
    [anon_sym_union] = ACTIONS(143),
    [sym_identifier] = ACTIONS(145),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(147),
    [sym_auto] = ACTIONS(2631),
    [anon_sym_typename] = ACTIONS(149),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [587] = {
    [anon_sym_COMMA] = ACTIONS(2633),
    [anon_sym_RPAREN] = ACTIONS(2633),
    [anon_sym_SEMI] = ACTIONS(2633),
    [anon_sym_extern] = ACTIONS(2635),
    [anon_sym_LBRACE] = ACTIONS(2633),
    [anon_sym_LPAREN2] = ACTIONS(2633),
    [anon_sym_STAR] = ACTIONS(2633),
    [anon_sym_LBRACK] = ACTIONS(2633),
    [anon_sym_EQ] = ACTIONS(2633),
    [anon_sym_static] = ACTIONS(2635),
    [anon_sym_register] = ACTIONS(2635),
    [anon_sym_inline] = ACTIONS(2635),
    [anon_sym_const] = ACTIONS(2635),
    [anon_sym_restrict] = ACTIONS(2635),
    [anon_sym_volatile] = ACTIONS(2635),
    [anon_sym__Atomic] = ACTIONS(2635),
    [anon_sym_mutable] = ACTIONS(2635),
    [anon_sym_explicit] = ACTIONS(2635),
    [anon_sym_constexpr] = ACTIONS(2635),
    [anon_sym_COLON] = ACTIONS(2635),
    [anon_sym_AMP] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2633),
    [anon_sym_TILDE] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(2633),
    [sym_identifier] = ACTIONS(2635),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2635),
    [anon_sym_override] = ACTIONS(2635),
    [anon_sym_GT2] = ACTIONS(2633),
    [sym_noexcept] = ACTIONS(2635),
    [anon_sym_COLON_COLON] = ACTIONS(2633),
    [sym_operator_name] = ACTIONS(2633),
  },
  [588] = {
    [sym_field_declaration_list] = STATE(175),
    [sym_virtual_specifier] = STATE(176),
    [sym_base_class_clause] = STATE(177),
    [sym_template_type] = STATE(1240),
    [sym_scoped_type_identifier] = STATE(1241),
    [sym_scoped_namespace_identifier] = STATE(180),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(2637),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(315),
  },
  [589] = {
    [sym_field_declaration_list] = STATE(182),
    [sym_virtual_specifier] = STATE(183),
    [sym_base_class_clause] = STATE(184),
    [sym_template_type] = STATE(1243),
    [sym_scoped_type_identifier] = STATE(1244),
    [sym_scoped_namespace_identifier] = STATE(180),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(2639),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(315),
  },
  [590] = {
    [sym_template_argument_list] = STATE(1246),
    [anon_sym_SEMI] = ACTIONS(481),
    [anon_sym_extern] = ACTIONS(468),
    [anon_sym_LPAREN2] = ACTIONS(1464),
    [anon_sym_STAR] = ACTIONS(481),
    [anon_sym_LBRACK] = ACTIONS(576),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_register] = ACTIONS(468),
    [anon_sym_inline] = ACTIONS(468),
    [anon_sym_const] = ACTIONS(468),
    [anon_sym_restrict] = ACTIONS(468),
    [anon_sym_volatile] = ACTIONS(468),
    [anon_sym__Atomic] = ACTIONS(468),
    [anon_sym_mutable] = ACTIONS(468),
    [anon_sym_explicit] = ACTIONS(468),
    [anon_sym_constexpr] = ACTIONS(468),
    [anon_sym_COLON] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(468),
    [anon_sym_AMP_AMP] = ACTIONS(481),
    [anon_sym_LT] = ACTIONS(643),
    [sym_identifier] = ACTIONS(468),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(2641),
    [sym_operator_name] = ACTIONS(481),
  },
  [591] = {
    [sym_field_declaration_list] = STATE(265),
    [sym_virtual_specifier] = STATE(266),
    [sym_base_class_clause] = STATE(267),
    [sym_template_type] = STATE(1248),
    [sym_scoped_type_identifier] = STATE(1249),
    [sym_scoped_namespace_identifier] = STATE(180),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(2643),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(315),
  },
  [592] = {
    [anon_sym_COLON] = ACTIONS(2645),
    [sym_comment] = ACTIONS(91),
  },
  [593] = {
    [sym__type_specifier] = STATE(271),
    [sym_sized_type_specifier] = STATE(271),
    [sym_enum_specifier] = STATE(271),
    [sym_struct_specifier] = STATE(271),
    [sym_union_specifier] = STATE(271),
    [sym_macro_type_specifier] = STATE(271),
    [sym_class_specifier] = STATE(271),
    [sym_dependent_type] = STATE(271),
    [sym_template_type] = STATE(272),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(180),
    [aux_sym_sized_type_specifier_repeat1] = STATE(606),
    [anon_sym_unsigned] = ACTIONS(1027),
    [anon_sym_long] = ACTIONS(1027),
    [anon_sym_short] = ACTIONS(1027),
    [sym_primitive_type] = ACTIONS(490),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(1031),
    [anon_sym_union] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(492),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1037),
    [sym_auto] = ACTIONS(490),
    [anon_sym_typename] = ACTIONS(1041),
    [anon_sym_COLON_COLON] = ACTIONS(315),
  },
  [594] = {
    [sym_template_parameter_list] = STATE(1251),
    [anon_sym_LT] = ACTIONS(504),
    [sym_comment] = ACTIONS(91),
  },
  [595] = {
    [sym_function_definition] = STATE(1252),
    [sym_declaration] = STATE(1252),
    [sym__declaration_specifiers] = STATE(1253),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(1254),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(272),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(180),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [sym_identifier] = ACTIONS(492),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_COLON_COLON] = ACTIONS(315),
  },
  [596] = {
    [sym_template_type] = STATE(296),
    [sym_scoped_identifier] = STATE(1257),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(296),
    [sym_identifier] = ACTIONS(2647),
    [sym_comment] = ACTIONS(91),
    [anon_sym_namespace] = ACTIONS(2649),
    [anon_sym_COLON_COLON] = ACTIONS(528),
  },
  [597] = {
    [sym_destructor_name] = STATE(315),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(2651),
    [sym_comment] = ACTIONS(91),
    [sym_operator_name] = ACTIONS(554),
  },
  [598] = {
    [sym__field_declarator] = STATE(1265),
    [sym_pointer_field_declarator] = STATE(1265),
    [sym_function_field_declarator] = STATE(1265),
    [sym_array_field_declarator] = STATE(1265),
    [sym_reference_field_declarator] = STATE(1265),
    [sym_template_type] = STATE(953),
    [sym_template_method] = STATE(1265),
    [sym_scoped_field_identifier] = STATE(1266),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(953),
    [anon_sym_SEMI] = ACTIONS(2653),
    [anon_sym_LPAREN2] = ACTIONS(2655),
    [anon_sym_STAR] = ACTIONS(2657),
    [anon_sym_COLON] = ACTIONS(2659),
    [anon_sym_AMP] = ACTIONS(2661),
    [anon_sym_AMP_AMP] = ACTIONS(2663),
    [sym_identifier] = ACTIONS(2665),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1755),
    [sym_operator_name] = ACTIONS(2667),
  },
  [599] = {
    [sym_parameter_list] = STATE(1267),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(574),
    [sym_comment] = ACTIONS(91),
  },
  [600] = {
    [sym_compound_statement] = STATE(1271),
    [sym_field_initializer_list] = STATE(1272),
    [sym_default_method_clause] = STATE(1271),
    [sym_delete_method_clause] = STATE(1271),
    [anon_sym_SEMI] = ACTIONS(2669),
    [anon_sym_LBRACE] = ACTIONS(2671),
    [anon_sym_LPAREN2] = ACTIONS(576),
    [anon_sym_LBRACK] = ACTIONS(576),
    [anon_sym_EQ] = ACTIONS(2673),
    [anon_sym_COLON] = ACTIONS(580),
    [sym_comment] = ACTIONS(91),
  },
  [601] = {
    [sym_storage_class_specifier] = STATE(1273),
    [sym_type_qualifier] = STATE(1273),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1273),
    [anon_sym_SEMI] = ACTIONS(582),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_LPAREN2] = ACTIONS(582),
    [anon_sym_STAR] = ACTIONS(582),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_COLON] = ACTIONS(584),
    [anon_sym_AMP] = ACTIONS(584),
    [anon_sym_AMP_AMP] = ACTIONS(582),
    [sym_identifier] = ACTIONS(584),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(582),
    [sym_operator_name] = ACTIONS(582),
  },
  [602] = {
    [anon_sym_SEMI] = ACTIONS(624),
    [anon_sym_extern] = ACTIONS(626),
    [anon_sym_LPAREN2] = ACTIONS(624),
    [anon_sym_STAR] = ACTIONS(624),
    [anon_sym_static] = ACTIONS(626),
    [anon_sym_register] = ACTIONS(626),
    [anon_sym_inline] = ACTIONS(626),
    [anon_sym_const] = ACTIONS(626),
    [anon_sym_restrict] = ACTIONS(626),
    [anon_sym_volatile] = ACTIONS(626),
    [anon_sym__Atomic] = ACTIONS(626),
    [anon_sym_mutable] = ACTIONS(626),
    [anon_sym_explicit] = ACTIONS(626),
    [anon_sym_constexpr] = ACTIONS(626),
    [anon_sym_COLON] = ACTIONS(626),
    [anon_sym_AMP] = ACTIONS(626),
    [anon_sym_AMP_AMP] = ACTIONS(624),
    [sym_identifier] = ACTIONS(626),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(2675),
    [sym_operator_name] = ACTIONS(624),
  },
  [603] = {
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(2675),
  },
  [604] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(1276),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1276),
    [sym_type_definition] = STATE(1276),
    [sym__declaration_specifiers] = STATE(598),
    [sym__declarator] = STATE(599),
    [sym_pointer_declarator] = STATE(599),
    [sym_function_declarator] = STATE(600),
    [sym_array_declarator] = STATE(599),
    [sym_storage_class_specifier] = STATE(605),
    [sym_type_qualifier] = STATE(605),
    [sym__type_specifier] = STATE(601),
    [sym_sized_type_specifier] = STATE(601),
    [sym_enum_specifier] = STATE(601),
    [sym_struct_specifier] = STATE(601),
    [sym_union_specifier] = STATE(601),
    [sym__field_declaration_list_item] = STATE(1276),
    [sym_field_declaration] = STATE(1276),
    [sym_macro_type_specifier] = STATE(601),
    [sym_class_specifier] = STATE(601),
    [sym_dependent_type] = STATE(601),
    [sym_template_declaration] = STATE(1276),
    [sym_inline_method_definition] = STATE(1276),
    [sym_constructor_or_destructor_definition] = STATE(1276),
    [sym_constructor_or_destructor_declaration] = STATE(1276),
    [sym_friend_declaration] = STATE(1276),
    [sym_access_specifier] = STATE(1276),
    [sym_reference_declarator] = STATE(599),
    [sym_template_type] = STATE(602),
    [sym_template_function] = STATE(599),
    [sym_using_declaration] = STATE(1276),
    [sym_alias_declaration] = STATE(1276),
    [sym_destructor_name] = STATE(599),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(603),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1276),
    [aux_sym__declaration_specifiers_repeat1] = STATE(605),
    [aux_sym_sized_type_specifier_repeat1] = STATE(606),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1019),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1021),
    [anon_sym_typedef] = ACTIONS(1023),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(2677),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(425),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(1027),
    [anon_sym_long] = ACTIONS(1027),
    [anon_sym_short] = ACTIONS(1027),
    [sym_primitive_type] = ACTIONS(1029),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(1031),
    [anon_sym_union] = ACTIONS(1033),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(1035),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1039),
    [sym_auto] = ACTIONS(1029),
    [anon_sym_typename] = ACTIONS(1041),
    [anon_sym_template] = ACTIONS(1043),
    [anon_sym_friend] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1039),
    [anon_sym_protected] = ACTIONS(1039),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_COLON_COLON] = ACTIONS(1049),
    [sym_operator_name] = ACTIONS(1051),
  },
  [605] = {
    [sym__declarator] = STATE(50),
    [sym_pointer_declarator] = STATE(50),
    [sym_function_declarator] = STATE(1277),
    [sym_array_declarator] = STATE(50),
    [sym_storage_class_specifier] = STATE(370),
    [sym_type_qualifier] = STATE(370),
    [sym__type_specifier] = STATE(1278),
    [sym_sized_type_specifier] = STATE(1278),
    [sym_enum_specifier] = STATE(1278),
    [sym_struct_specifier] = STATE(1278),
    [sym_union_specifier] = STATE(1278),
    [sym_macro_type_specifier] = STATE(1278),
    [sym_class_specifier] = STATE(1278),
    [sym_dependent_type] = STATE(1278),
    [sym_reference_declarator] = STATE(50),
    [sym_template_type] = STATE(602),
    [sym_template_function] = STATE(50),
    [sym_destructor_name] = STATE(50),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(603),
    [aux_sym__declaration_specifiers_repeat1] = STATE(370),
    [aux_sym_sized_type_specifier_repeat1] = STATE(606),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(425),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(1027),
    [anon_sym_long] = ACTIONS(1027),
    [anon_sym_short] = ACTIONS(1027),
    [sym_primitive_type] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(1031),
    [anon_sym_union] = ACTIONS(1033),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(1035),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1037),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(1041),
    [anon_sym_COLON_COLON] = ACTIONS(1049),
    [sym_operator_name] = ACTIONS(111),
  },
  [606] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1279),
    [anon_sym_SEMI] = ACTIONS(653),
    [anon_sym_extern] = ACTIONS(655),
    [anon_sym_LPAREN2] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(653),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_register] = ACTIONS(655),
    [anon_sym_inline] = ACTIONS(655),
    [anon_sym_const] = ACTIONS(655),
    [anon_sym_restrict] = ACTIONS(655),
    [anon_sym_volatile] = ACTIONS(655),
    [anon_sym__Atomic] = ACTIONS(655),
    [anon_sym_mutable] = ACTIONS(655),
    [anon_sym_explicit] = ACTIONS(655),
    [anon_sym_constexpr] = ACTIONS(655),
    [anon_sym_unsigned] = ACTIONS(2681),
    [anon_sym_long] = ACTIONS(2681),
    [anon_sym_short] = ACTIONS(2681),
    [sym_primitive_type] = ACTIONS(659),
    [anon_sym_COLON] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [sym_identifier] = ACTIONS(661),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(653),
    [sym_operator_name] = ACTIONS(653),
  },
  [607] = {
    [sym_template_argument_list] = STATE(437),
    [aux_sym_base_class_clause_repeat1] = STATE(1281),
    [anon_sym_COMMA] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LT] = ACTIONS(945),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(758),
  },
  [608] = {
    [sym_template_type] = STATE(1283),
    [sym_scoped_type_identifier] = STATE(1284),
    [sym_scoped_namespace_identifier] = STATE(83),
    [sym_identifier] = ACTIONS(2687),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [609] = {
    [aux_sym_base_class_clause_repeat1] = STATE(1285),
    [anon_sym_COMMA] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(772),
  },
  [610] = {
    [sym_template_argument_list] = STATE(362),
    [aux_sym_base_class_clause_repeat1] = STATE(1285),
    [anon_sym_COMMA] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [anon_sym_LT] = ACTIONS(945),
    [sym_comment] = ACTIONS(91),
  },
  [611] = {
    [sym_identifier] = ACTIONS(2691),
    [sym_comment] = ACTIONS(91),
  },
  [612] = {
    [anon_sym_COMMA] = ACTIONS(2693),
    [anon_sym_RPAREN] = ACTIONS(2693),
    [anon_sym_SEMI] = ACTIONS(2693),
    [anon_sym_extern] = ACTIONS(2695),
    [anon_sym_LBRACE] = ACTIONS(2693),
    [anon_sym_LPAREN2] = ACTIONS(2693),
    [anon_sym_STAR] = ACTIONS(2693),
    [anon_sym_LBRACK] = ACTIONS(2693),
    [anon_sym_EQ] = ACTIONS(2693),
    [anon_sym_static] = ACTIONS(2695),
    [anon_sym_register] = ACTIONS(2695),
    [anon_sym_inline] = ACTIONS(2695),
    [anon_sym_const] = ACTIONS(2695),
    [anon_sym_restrict] = ACTIONS(2695),
    [anon_sym_volatile] = ACTIONS(2695),
    [anon_sym__Atomic] = ACTIONS(2695),
    [anon_sym_mutable] = ACTIONS(2695),
    [anon_sym_explicit] = ACTIONS(2695),
    [anon_sym_constexpr] = ACTIONS(2695),
    [anon_sym_COLON] = ACTIONS(2695),
    [anon_sym_AMP] = ACTIONS(2695),
    [anon_sym_AMP_AMP] = ACTIONS(2693),
    [anon_sym_TILDE] = ACTIONS(2693),
    [anon_sym_DASH_GT] = ACTIONS(2693),
    [sym_identifier] = ACTIONS(2695),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2695),
    [anon_sym_override] = ACTIONS(2695),
    [anon_sym_GT2] = ACTIONS(2693),
    [sym_noexcept] = ACTIONS(2695),
    [anon_sym_COLON_COLON] = ACTIONS(2693),
    [sym_operator_name] = ACTIONS(2693),
  },
  [613] = {
    [sym_field_declaration_list] = STATE(1287),
    [sym_base_class_clause] = STATE(1288),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_COLON] = ACTIONS(1073),
    [sym_comment] = ACTIONS(91),
  },
  [614] = {
    [sym_field_declaration_list] = STATE(1287),
    [anon_sym_LBRACE] = ACTIONS(307),
    [sym_comment] = ACTIONS(91),
  },
  [615] = {
    [anon_sym_COMMA] = ACTIONS(1431),
    [anon_sym_RPAREN] = ACTIONS(1431),
    [anon_sym_SEMI] = ACTIONS(1431),
    [anon_sym_extern] = ACTIONS(1429),
    [anon_sym_LBRACE] = ACTIONS(1431),
    [anon_sym_LPAREN2] = ACTIONS(1431),
    [anon_sym_STAR] = ACTIONS(1431),
    [anon_sym_LBRACK] = ACTIONS(1431),
    [anon_sym_EQ] = ACTIONS(1431),
    [anon_sym_static] = ACTIONS(1429),
    [anon_sym_register] = ACTIONS(1429),
    [anon_sym_inline] = ACTIONS(1429),
    [anon_sym_const] = ACTIONS(1429),
    [anon_sym_restrict] = ACTIONS(1429),
    [anon_sym_volatile] = ACTIONS(1429),
    [anon_sym__Atomic] = ACTIONS(1429),
    [anon_sym_mutable] = ACTIONS(1429),
    [anon_sym_explicit] = ACTIONS(1429),
    [anon_sym_constexpr] = ACTIONS(1429),
    [anon_sym_COLON] = ACTIONS(1429),
    [anon_sym_AMP] = ACTIONS(1429),
    [anon_sym_AMP_AMP] = ACTIONS(1431),
    [anon_sym_TILDE] = ACTIONS(1431),
    [sym_identifier] = ACTIONS(1429),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1429),
    [anon_sym_override] = ACTIONS(1429),
    [anon_sym_GT2] = ACTIONS(1431),
    [anon_sym_COLON_COLON] = ACTIONS(1431),
    [sym_operator_name] = ACTIONS(1431),
  },
  [616] = {
    [anon_sym_COMMA] = ACTIONS(1582),
    [anon_sym_RPAREN] = ACTIONS(1582),
    [anon_sym_SEMI] = ACTIONS(1582),
    [anon_sym_extern] = ACTIONS(1580),
    [anon_sym_LBRACE] = ACTIONS(1582),
    [anon_sym_LPAREN2] = ACTIONS(1582),
    [anon_sym_STAR] = ACTIONS(1582),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(1582),
    [anon_sym_static] = ACTIONS(1580),
    [anon_sym_register] = ACTIONS(1580),
    [anon_sym_inline] = ACTIONS(1580),
    [anon_sym_const] = ACTIONS(1580),
    [anon_sym_restrict] = ACTIONS(1580),
    [anon_sym_volatile] = ACTIONS(1580),
    [anon_sym__Atomic] = ACTIONS(1580),
    [anon_sym_mutable] = ACTIONS(1580),
    [anon_sym_explicit] = ACTIONS(1580),
    [anon_sym_constexpr] = ACTIONS(1580),
    [anon_sym_COLON] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1582),
    [anon_sym_TILDE] = ACTIONS(1582),
    [anon_sym_LT] = ACTIONS(1582),
    [sym_identifier] = ACTIONS(1580),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1580),
    [anon_sym_override] = ACTIONS(1580),
    [anon_sym_GT2] = ACTIONS(1582),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [sym_operator_name] = ACTIONS(1582),
  },
  [617] = {
    [anon_sym_COMMA] = ACTIONS(2697),
    [anon_sym_RPAREN] = ACTIONS(2697),
    [anon_sym_SEMI] = ACTIONS(2697),
    [anon_sym_extern] = ACTIONS(2699),
    [anon_sym_LBRACE] = ACTIONS(2697),
    [anon_sym_LPAREN2] = ACTIONS(2697),
    [anon_sym_STAR] = ACTIONS(2697),
    [anon_sym_LBRACK] = ACTIONS(2697),
    [anon_sym_EQ] = ACTIONS(2697),
    [anon_sym_static] = ACTIONS(2699),
    [anon_sym_register] = ACTIONS(2699),
    [anon_sym_inline] = ACTIONS(2699),
    [anon_sym_const] = ACTIONS(2699),
    [anon_sym_restrict] = ACTIONS(2699),
    [anon_sym_volatile] = ACTIONS(2699),
    [anon_sym__Atomic] = ACTIONS(2699),
    [anon_sym_mutable] = ACTIONS(2699),
    [anon_sym_explicit] = ACTIONS(2699),
    [anon_sym_constexpr] = ACTIONS(2699),
    [anon_sym_COLON] = ACTIONS(2699),
    [anon_sym_AMP] = ACTIONS(2699),
    [anon_sym_AMP_AMP] = ACTIONS(2697),
    [anon_sym_TILDE] = ACTIONS(2697),
    [anon_sym_DASH_GT] = ACTIONS(2697),
    [sym_identifier] = ACTIONS(2699),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2699),
    [anon_sym_override] = ACTIONS(2699),
    [anon_sym_GT2] = ACTIONS(2697),
    [sym_noexcept] = ACTIONS(2699),
    [anon_sym_COLON_COLON] = ACTIONS(2697),
    [sym_operator_name] = ACTIONS(2697),
  },
  [618] = {
    [sym_field_declaration_list] = STATE(1289),
    [anon_sym_LBRACE] = ACTIONS(307),
    [sym_comment] = ACTIONS(91),
  },
  [619] = {
    [sym_identifier] = ACTIONS(2701),
    [sym_comment] = ACTIONS(91),
  },
  [620] = {
    [sym_field_declaration_list] = STATE(1289),
    [sym_base_class_clause] = STATE(1291),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_COLON] = ACTIONS(1073),
    [sym_comment] = ACTIONS(91),
  },
  [621] = {
    [anon_sym_COMMA] = ACTIONS(2703),
    [anon_sym_RPAREN] = ACTIONS(2703),
    [anon_sym_SEMI] = ACTIONS(2703),
    [anon_sym_extern] = ACTIONS(2705),
    [anon_sym_LBRACE] = ACTIONS(2703),
    [anon_sym_LPAREN2] = ACTIONS(2703),
    [anon_sym_STAR] = ACTIONS(2703),
    [anon_sym_LBRACK] = ACTIONS(2703),
    [anon_sym_EQ] = ACTIONS(2703),
    [anon_sym_static] = ACTIONS(2705),
    [anon_sym_register] = ACTIONS(2705),
    [anon_sym_inline] = ACTIONS(2705),
    [anon_sym_const] = ACTIONS(2705),
    [anon_sym_restrict] = ACTIONS(2705),
    [anon_sym_volatile] = ACTIONS(2705),
    [anon_sym__Atomic] = ACTIONS(2705),
    [anon_sym_mutable] = ACTIONS(2705),
    [anon_sym_explicit] = ACTIONS(2705),
    [anon_sym_constexpr] = ACTIONS(2705),
    [anon_sym_COLON] = ACTIONS(2705),
    [anon_sym_AMP] = ACTIONS(2705),
    [anon_sym_AMP_AMP] = ACTIONS(2703),
    [anon_sym_TILDE] = ACTIONS(2703),
    [anon_sym_DASH_GT] = ACTIONS(2703),
    [sym_identifier] = ACTIONS(2705),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2705),
    [anon_sym_override] = ACTIONS(2705),
    [anon_sym_GT2] = ACTIONS(2703),
    [sym_noexcept] = ACTIONS(2705),
    [anon_sym_COLON_COLON] = ACTIONS(2703),
    [sym_operator_name] = ACTIONS(2703),
  },
  [622] = {
    [sym_field_declaration_list] = STATE(1292),
    [sym_base_class_clause] = STATE(1293),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_COLON] = ACTIONS(1073),
    [sym_comment] = ACTIONS(91),
  },
  [623] = {
    [sym_field_declaration_list] = STATE(1292),
    [anon_sym_LBRACE] = ACTIONS(307),
    [sym_comment] = ACTIONS(91),
  },
  [624] = {
    [anon_sym_COMMA] = ACTIONS(2707),
    [anon_sym_RPAREN] = ACTIONS(2707),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_extern] = ACTIONS(2709),
    [anon_sym_LBRACE] = ACTIONS(2707),
    [anon_sym_LPAREN2] = ACTIONS(2707),
    [anon_sym_STAR] = ACTIONS(2707),
    [anon_sym_LBRACK] = ACTIONS(2707),
    [anon_sym_EQ] = ACTIONS(2707),
    [anon_sym_static] = ACTIONS(2709),
    [anon_sym_register] = ACTIONS(2709),
    [anon_sym_inline] = ACTIONS(2709),
    [anon_sym_const] = ACTIONS(2709),
    [anon_sym_restrict] = ACTIONS(2709),
    [anon_sym_volatile] = ACTIONS(2709),
    [anon_sym__Atomic] = ACTIONS(2709),
    [anon_sym_mutable] = ACTIONS(2709),
    [anon_sym_explicit] = ACTIONS(2709),
    [anon_sym_constexpr] = ACTIONS(2709),
    [anon_sym_COLON] = ACTIONS(2709),
    [anon_sym_AMP] = ACTIONS(2709),
    [anon_sym_AMP_AMP] = ACTIONS(2707),
    [anon_sym_TILDE] = ACTIONS(2707),
    [anon_sym_DASH_GT] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2709),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2709),
    [anon_sym_override] = ACTIONS(2709),
    [anon_sym_GT2] = ACTIONS(2707),
    [sym_noexcept] = ACTIONS(2709),
    [anon_sym_COLON_COLON] = ACTIONS(2707),
    [sym_operator_name] = ACTIONS(2707),
  },
  [625] = {
    [sym_field_declaration_list] = STATE(1294),
    [anon_sym_LBRACE] = ACTIONS(307),
    [sym_comment] = ACTIONS(91),
  },
  [626] = {
    [sym_field_declaration_list] = STATE(1294),
    [sym_base_class_clause] = STATE(1295),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_COLON] = ACTIONS(1073),
    [sym_comment] = ACTIONS(91),
  },
  [627] = {
    [sym_type_qualifier] = STATE(141),
    [sym__type_specifier] = STATE(136),
    [sym_sized_type_specifier] = STATE(136),
    [sym_enum_specifier] = STATE(136),
    [sym_struct_specifier] = STATE(136),
    [sym_union_specifier] = STATE(136),
    [sym__expression] = STATE(137),
    [sym_comma_expression] = STATE(138),
    [sym_conditional_expression] = STATE(137),
    [sym_assignment_expression] = STATE(137),
    [sym_pointer_expression] = STATE(137),
    [sym_logical_expression] = STATE(137),
    [sym_bitwise_expression] = STATE(137),
    [sym_equality_expression] = STATE(137),
    [sym_relational_expression] = STATE(137),
    [sym_shift_expression] = STATE(137),
    [sym_math_expression] = STATE(137),
    [sym_cast_expression] = STATE(137),
    [sym_type_descriptor] = STATE(1296),
    [sym_sizeof_expression] = STATE(137),
    [sym_subscript_expression] = STATE(137),
    [sym_call_expression] = STATE(137),
    [sym_field_expression] = STATE(137),
    [sym_compound_literal_expression] = STATE(137),
    [sym_parenthesized_expression] = STATE(137),
    [sym_char_literal] = STATE(137),
    [sym_concatenated_string] = STATE(137),
    [sym_string_literal] = STATE(140),
    [sym_macro_type_specifier] = STATE(136),
    [sym_class_specifier] = STATE(136),
    [sym_dependent_type] = STATE(136),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(137),
    [sym_new_expression] = STATE(137),
    [sym_delete_expression] = STATE(137),
    [sym_lambda_expression] = STATE(137),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_type_definition_repeat1] = STATE(141),
    [aux_sym_sized_type_specifier_repeat1] = STATE(142),
    [sym_raw_string_literal] = ACTIONS(213),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(219),
    [anon_sym_long] = ACTIONS(219),
    [anon_sym_short] = ACTIONS(219),
    [sym_primitive_type] = ACTIONS(221),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [sym_null] = ACTIONS(241),
    [sym_identifier] = ACTIONS(811),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(221),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(253),
    [sym_nullptr] = ACTIONS(241),
  },
  [628] = {
    [sym__expression] = STATE(146),
    [sym_conditional_expression] = STATE(146),
    [sym_assignment_expression] = STATE(146),
    [sym_pointer_expression] = STATE(146),
    [sym_logical_expression] = STATE(146),
    [sym_bitwise_expression] = STATE(146),
    [sym_equality_expression] = STATE(146),
    [sym_relational_expression] = STATE(146),
    [sym_shift_expression] = STATE(146),
    [sym_math_expression] = STATE(146),
    [sym_cast_expression] = STATE(146),
    [sym_sizeof_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_compound_literal_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_char_literal] = STATE(146),
    [sym_concatenated_string] = STATE(146),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(146),
    [sym_new_expression] = STATE(146),
    [sym_delete_expression] = STATE(146),
    [sym_lambda_expression] = STATE(146),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(257),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(257),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(259),
    [sym_false] = ACTIONS(259),
    [sym_null] = ACTIONS(259),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(259),
  },
  [629] = {
    [sym__expression] = STATE(250),
    [sym_conditional_expression] = STATE(250),
    [sym_assignment_expression] = STATE(250),
    [sym_pointer_expression] = STATE(250),
    [sym_logical_expression] = STATE(250),
    [sym_bitwise_expression] = STATE(250),
    [sym_equality_expression] = STATE(250),
    [sym_relational_expression] = STATE(250),
    [sym_shift_expression] = STATE(250),
    [sym_math_expression] = STATE(250),
    [sym_cast_expression] = STATE(250),
    [sym_sizeof_expression] = STATE(250),
    [sym_subscript_expression] = STATE(250),
    [sym_call_expression] = STATE(250),
    [sym_field_expression] = STATE(250),
    [sym_compound_literal_expression] = STATE(250),
    [sym_parenthesized_expression] = STATE(250),
    [sym_char_literal] = STATE(250),
    [sym_concatenated_string] = STATE(250),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(250),
    [sym_new_expression] = STATE(250),
    [sym_delete_expression] = STATE(250),
    [sym_lambda_expression] = STATE(250),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(435),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(435),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(437),
    [sym_false] = ACTIONS(437),
    [sym_null] = ACTIONS(437),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(437),
  },
  [630] = {
    [sym__expression] = STATE(252),
    [sym_conditional_expression] = STATE(252),
    [sym_assignment_expression] = STATE(252),
    [sym_pointer_expression] = STATE(252),
    [sym_logical_expression] = STATE(252),
    [sym_bitwise_expression] = STATE(252),
    [sym_equality_expression] = STATE(252),
    [sym_relational_expression] = STATE(252),
    [sym_shift_expression] = STATE(252),
    [sym_math_expression] = STATE(252),
    [sym_cast_expression] = STATE(252),
    [sym_sizeof_expression] = STATE(252),
    [sym_subscript_expression] = STATE(252),
    [sym_call_expression] = STATE(252),
    [sym_field_expression] = STATE(252),
    [sym_compound_literal_expression] = STATE(252),
    [sym_parenthesized_expression] = STATE(252),
    [sym_char_literal] = STATE(252),
    [sym_concatenated_string] = STATE(252),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(252),
    [sym_new_expression] = STATE(252),
    [sym_delete_expression] = STATE(252),
    [sym_lambda_expression] = STATE(252),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(439),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(439),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(441),
    [sym_false] = ACTIONS(441),
    [sym_null] = ACTIONS(441),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(441),
  },
  [631] = {
    [sym__expression] = STATE(253),
    [sym_conditional_expression] = STATE(253),
    [sym_assignment_expression] = STATE(253),
    [sym_pointer_expression] = STATE(253),
    [sym_logical_expression] = STATE(253),
    [sym_bitwise_expression] = STATE(253),
    [sym_equality_expression] = STATE(253),
    [sym_relational_expression] = STATE(253),
    [sym_shift_expression] = STATE(253),
    [sym_math_expression] = STATE(253),
    [sym_cast_expression] = STATE(253),
    [sym_sizeof_expression] = STATE(253),
    [sym_subscript_expression] = STATE(253),
    [sym_call_expression] = STATE(253),
    [sym_field_expression] = STATE(253),
    [sym_compound_literal_expression] = STATE(253),
    [sym_parenthesized_expression] = STATE(253),
    [sym_char_literal] = STATE(253),
    [sym_concatenated_string] = STATE(253),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(253),
    [sym_new_expression] = STATE(253),
    [sym_delete_expression] = STATE(253),
    [sym_lambda_expression] = STATE(253),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(445),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(445),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(447),
    [sym_false] = ACTIONS(447),
    [sym_null] = ACTIONS(447),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(447),
  },
  [632] = {
    [sym__expression] = STATE(1298),
    [sym_conditional_expression] = STATE(1298),
    [sym_assignment_expression] = STATE(1298),
    [sym_pointer_expression] = STATE(1298),
    [sym_logical_expression] = STATE(1298),
    [sym_bitwise_expression] = STATE(1298),
    [sym_equality_expression] = STATE(1298),
    [sym_relational_expression] = STATE(1298),
    [sym_shift_expression] = STATE(1298),
    [sym_math_expression] = STATE(1298),
    [sym_cast_expression] = STATE(1298),
    [sym_sizeof_expression] = STATE(1298),
    [sym_subscript_expression] = STATE(1298),
    [sym_call_expression] = STATE(1298),
    [sym_field_expression] = STATE(1298),
    [sym_compound_literal_expression] = STATE(1298),
    [sym_parenthesized_expression] = STATE(1298),
    [sym_char_literal] = STATE(1298),
    [sym_concatenated_string] = STATE(1298),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1298),
    [sym_new_expression] = STATE(1298),
    [sym_delete_expression] = STATE(1298),
    [sym_lambda_expression] = STATE(1298),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2711),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(2711),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2715),
    [sym_false] = ACTIONS(2715),
    [sym_null] = ACTIONS(2715),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(2715),
  },
  [633] = {
    [sym__expression] = STATE(1300),
    [sym_conditional_expression] = STATE(1300),
    [sym_assignment_expression] = STATE(1300),
    [sym_pointer_expression] = STATE(1300),
    [sym_logical_expression] = STATE(1300),
    [sym_bitwise_expression] = STATE(1300),
    [sym_equality_expression] = STATE(1300),
    [sym_relational_expression] = STATE(1300),
    [sym_shift_expression] = STATE(1300),
    [sym_math_expression] = STATE(1300),
    [sym_cast_expression] = STATE(1300),
    [sym_sizeof_expression] = STATE(1300),
    [sym_subscript_expression] = STATE(1300),
    [sym_call_expression] = STATE(1300),
    [sym_field_expression] = STATE(1300),
    [sym_compound_literal_expression] = STATE(1300),
    [sym_parenthesized_expression] = STATE(1300),
    [sym_char_literal] = STATE(1300),
    [sym_concatenated_string] = STATE(1300),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1300),
    [sym_new_expression] = STATE(1300),
    [sym_delete_expression] = STATE(1300),
    [sym_lambda_expression] = STATE(1300),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2717),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(2717),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2721),
    [sym_false] = ACTIONS(2721),
    [sym_null] = ACTIONS(2721),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(2721),
  },
  [634] = {
    [sym__type_specifier] = STATE(1302),
    [sym_sized_type_specifier] = STATE(1302),
    [sym_enum_specifier] = STATE(1302),
    [sym_struct_specifier] = STATE(1302),
    [sym_union_specifier] = STATE(1302),
    [sym_argument_list] = STATE(1303),
    [sym_macro_type_specifier] = STATE(1302),
    [sym_class_specifier] = STATE(1302),
    [sym_dependent_type] = STATE(1302),
    [sym_template_type] = STATE(309),
    [sym_scoped_type_identifier] = STATE(310),
    [sym_scoped_namespace_identifier] = STATE(311),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1304),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [sym_primitive_type] = ACTIONS(2725),
    [anon_sym_enum] = ACTIONS(536),
    [anon_sym_struct] = ACTIONS(538),
    [anon_sym_union] = ACTIONS(540),
    [sym_identifier] = ACTIONS(542),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(544),
    [sym_auto] = ACTIONS(2725),
    [anon_sym_typename] = ACTIONS(2727),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [635] = {
    [sym_destructor_name] = STATE(315),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(937),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(2729),
    [sym_operator_name] = ACTIONS(554),
  },
  [636] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [637] = {
    [sym_string_literal] = STATE(1319),
    [aux_sym_concatenated_string_repeat1] = STATE(1319),
    [anon_sym_RPAREN] = ACTIONS(463),
    [anon_sym_LPAREN2] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(91),
  },
  [638] = {
    [sym__expression] = STATE(1320),
    [sym_conditional_expression] = STATE(1320),
    [sym_assignment_expression] = STATE(1320),
    [sym_pointer_expression] = STATE(1320),
    [sym_logical_expression] = STATE(1320),
    [sym_bitwise_expression] = STATE(1320),
    [sym_equality_expression] = STATE(1320),
    [sym_relational_expression] = STATE(1320),
    [sym_shift_expression] = STATE(1320),
    [sym_math_expression] = STATE(1320),
    [sym_cast_expression] = STATE(1320),
    [sym_sizeof_expression] = STATE(1320),
    [sym_subscript_expression] = STATE(1320),
    [sym_call_expression] = STATE(1320),
    [sym_field_expression] = STATE(1320),
    [sym_compound_literal_expression] = STATE(1320),
    [sym_parenthesized_expression] = STATE(1320),
    [sym_char_literal] = STATE(1320),
    [sym_concatenated_string] = STATE(1320),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1320),
    [sym_new_expression] = STATE(1320),
    [sym_delete_expression] = STATE(1320),
    [sym_lambda_expression] = STATE(1320),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2761),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(2761),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2763),
    [sym_false] = ACTIONS(2763),
    [sym_null] = ACTIONS(2763),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(2763),
  },
  [639] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(895),
    [anon_sym_RPAREN] = ACTIONS(2765),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [640] = {
    [anon_sym_RPAREN] = ACTIONS(2765),
    [sym_comment] = ACTIONS(91),
  },
  [641] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(548),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_COLON] = ACTIONS(479),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(935),
  },
  [642] = {
    [sym_raw_string_literal] = ACTIONS(2767),
    [ts_builtin_sym_end] = ACTIONS(2767),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2769),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2769),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2769),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2769),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2769),
    [sym_preproc_directive] = ACTIONS(2769),
    [anon_sym_SEMI] = ACTIONS(2767),
    [anon_sym_typedef] = ACTIONS(2769),
    [anon_sym_extern] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_RBRACE] = ACTIONS(2767),
    [anon_sym_LPAREN2] = ACTIONS(2767),
    [anon_sym_STAR] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(2767),
    [anon_sym_static] = ACTIONS(2769),
    [anon_sym_register] = ACTIONS(2769),
    [anon_sym_inline] = ACTIONS(2769),
    [anon_sym_const] = ACTIONS(2769),
    [anon_sym_restrict] = ACTIONS(2769),
    [anon_sym_volatile] = ACTIONS(2769),
    [anon_sym__Atomic] = ACTIONS(2769),
    [anon_sym_mutable] = ACTIONS(2769),
    [anon_sym_explicit] = ACTIONS(2769),
    [anon_sym_constexpr] = ACTIONS(2769),
    [anon_sym_unsigned] = ACTIONS(2769),
    [anon_sym_long] = ACTIONS(2769),
    [anon_sym_short] = ACTIONS(2769),
    [sym_primitive_type] = ACTIONS(2769),
    [anon_sym_enum] = ACTIONS(2769),
    [anon_sym_struct] = ACTIONS(2769),
    [anon_sym_union] = ACTIONS(2769),
    [anon_sym_if] = ACTIONS(2769),
    [anon_sym_else] = ACTIONS(2769),
    [anon_sym_switch] = ACTIONS(2769),
    [anon_sym_case] = ACTIONS(2769),
    [anon_sym_default] = ACTIONS(2769),
    [anon_sym_while] = ACTIONS(2769),
    [anon_sym_do] = ACTIONS(2769),
    [anon_sym_for] = ACTIONS(2769),
    [anon_sym_return] = ACTIONS(2769),
    [anon_sym_break] = ACTIONS(2769),
    [anon_sym_continue] = ACTIONS(2769),
    [anon_sym_goto] = ACTIONS(2769),
    [anon_sym_AMP] = ACTIONS(2769),
    [anon_sym_AMP_AMP] = ACTIONS(2767),
    [anon_sym_BANG] = ACTIONS(2767),
    [anon_sym_TILDE] = ACTIONS(2767),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_DASH_DASH] = ACTIONS(2767),
    [anon_sym_PLUS_PLUS] = ACTIONS(2767),
    [anon_sym_sizeof] = ACTIONS(2769),
    [sym_number_literal] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(2767),
    [anon_sym_DQUOTE] = ACTIONS(2767),
    [sym_true] = ACTIONS(2769),
    [sym_false] = ACTIONS(2769),
    [sym_null] = ACTIONS(2769),
    [sym_identifier] = ACTIONS(2769),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2769),
    [sym_auto] = ACTIONS(2769),
    [anon_sym_typename] = ACTIONS(2769),
    [anon_sym_template] = ACTIONS(2769),
    [anon_sym_delete] = ACTIONS(2769),
    [anon_sym_namespace] = ACTIONS(2769),
    [anon_sym_using] = ACTIONS(2769),
    [anon_sym_try] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2769),
    [anon_sym_COLON_COLON] = ACTIONS(2767),
    [sym_operator_name] = ACTIONS(2767),
    [sym_nullptr] = ACTIONS(2769),
  },
  [643] = {
    [anon_sym_RPAREN] = ACTIONS(2771),
    [sym_comment] = ACTIONS(91),
  },
  [644] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(941),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_COLON] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(939),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(939),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_DASH] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [645] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_COLON] = ACTIONS(1350),
    [anon_sym_QMARK] = ACTIONS(1350),
    [anon_sym_STAR_EQ] = ACTIONS(1350),
    [anon_sym_SLASH_EQ] = ACTIONS(1350),
    [anon_sym_PERCENT_EQ] = ACTIONS(1350),
    [anon_sym_PLUS_EQ] = ACTIONS(1350),
    [anon_sym_DASH_EQ] = ACTIONS(1350),
    [anon_sym_LT_LT_EQ] = ACTIONS(1350),
    [anon_sym_GT_GT_EQ] = ACTIONS(1350),
    [anon_sym_AMP_EQ] = ACTIONS(1350),
    [anon_sym_CARET_EQ] = ACTIONS(1350),
    [anon_sym_PIPE_EQ] = ACTIONS(1350),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_PIPE_PIPE] = ACTIONS(1350),
    [anon_sym_AMP_AMP] = ACTIONS(1350),
    [anon_sym_PIPE] = ACTIONS(1352),
    [anon_sym_CARET] = ACTIONS(1352),
    [anon_sym_EQ_EQ] = ACTIONS(1350),
    [anon_sym_BANG_EQ] = ACTIONS(1350),
    [anon_sym_LT] = ACTIONS(1352),
    [anon_sym_GT] = ACTIONS(1352),
    [anon_sym_LT_EQ] = ACTIONS(1350),
    [anon_sym_GT_EQ] = ACTIONS(1350),
    [anon_sym_LT_LT] = ACTIONS(1352),
    [anon_sym_GT_GT] = ACTIONS(1352),
    [anon_sym_PLUS] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1352),
    [anon_sym_SLASH] = ACTIONS(1352),
    [anon_sym_PERCENT] = ACTIONS(1352),
    [anon_sym_DASH_DASH] = ACTIONS(1350),
    [anon_sym_PLUS_PLUS] = ACTIONS(1350),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [646] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1358),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1358),
    [anon_sym_COLON] = ACTIONS(1356),
    [anon_sym_QMARK] = ACTIONS(1356),
    [anon_sym_STAR_EQ] = ACTIONS(1356),
    [anon_sym_SLASH_EQ] = ACTIONS(1356),
    [anon_sym_PERCENT_EQ] = ACTIONS(1356),
    [anon_sym_PLUS_EQ] = ACTIONS(1356),
    [anon_sym_DASH_EQ] = ACTIONS(1356),
    [anon_sym_LT_LT_EQ] = ACTIONS(1356),
    [anon_sym_GT_GT_EQ] = ACTIONS(1356),
    [anon_sym_AMP_EQ] = ACTIONS(1356),
    [anon_sym_CARET_EQ] = ACTIONS(1356),
    [anon_sym_PIPE_EQ] = ACTIONS(1356),
    [anon_sym_AMP] = ACTIONS(1358),
    [anon_sym_PIPE_PIPE] = ACTIONS(1356),
    [anon_sym_AMP_AMP] = ACTIONS(1356),
    [anon_sym_PIPE] = ACTIONS(1358),
    [anon_sym_CARET] = ACTIONS(1358),
    [anon_sym_EQ_EQ] = ACTIONS(1356),
    [anon_sym_BANG_EQ] = ACTIONS(1356),
    [anon_sym_LT] = ACTIONS(1358),
    [anon_sym_GT] = ACTIONS(1358),
    [anon_sym_LT_EQ] = ACTIONS(1356),
    [anon_sym_GT_EQ] = ACTIONS(1356),
    [anon_sym_LT_LT] = ACTIONS(1358),
    [anon_sym_GT_GT] = ACTIONS(1358),
    [anon_sym_PLUS] = ACTIONS(1358),
    [anon_sym_DASH] = ACTIONS(1358),
    [anon_sym_SLASH] = ACTIONS(1358),
    [anon_sym_PERCENT] = ACTIONS(1358),
    [anon_sym_DASH_DASH] = ACTIONS(1356),
    [anon_sym_PLUS_PLUS] = ACTIONS(1356),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [647] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1362),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1362),
    [anon_sym_COLON] = ACTIONS(1360),
    [anon_sym_QMARK] = ACTIONS(1360),
    [anon_sym_STAR_EQ] = ACTIONS(1360),
    [anon_sym_SLASH_EQ] = ACTIONS(1360),
    [anon_sym_PERCENT_EQ] = ACTIONS(1360),
    [anon_sym_PLUS_EQ] = ACTIONS(1360),
    [anon_sym_DASH_EQ] = ACTIONS(1360),
    [anon_sym_LT_LT_EQ] = ACTIONS(1360),
    [anon_sym_GT_GT_EQ] = ACTIONS(1360),
    [anon_sym_AMP_EQ] = ACTIONS(1360),
    [anon_sym_CARET_EQ] = ACTIONS(1360),
    [anon_sym_PIPE_EQ] = ACTIONS(1360),
    [anon_sym_AMP] = ACTIONS(1362),
    [anon_sym_PIPE_PIPE] = ACTIONS(1360),
    [anon_sym_AMP_AMP] = ACTIONS(1360),
    [anon_sym_PIPE] = ACTIONS(1362),
    [anon_sym_CARET] = ACTIONS(1362),
    [anon_sym_EQ_EQ] = ACTIONS(1360),
    [anon_sym_BANG_EQ] = ACTIONS(1360),
    [anon_sym_LT] = ACTIONS(1362),
    [anon_sym_GT] = ACTIONS(1362),
    [anon_sym_LT_EQ] = ACTIONS(1360),
    [anon_sym_GT_EQ] = ACTIONS(1360),
    [anon_sym_LT_LT] = ACTIONS(1362),
    [anon_sym_GT_GT] = ACTIONS(1362),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_SLASH] = ACTIONS(1362),
    [anon_sym_PERCENT] = ACTIONS(1362),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [648] = {
    [sym_type_qualifier] = STATE(141),
    [sym__type_specifier] = STATE(136),
    [sym_sized_type_specifier] = STATE(136),
    [sym_enum_specifier] = STATE(136),
    [sym_struct_specifier] = STATE(136),
    [sym_union_specifier] = STATE(136),
    [sym__expression] = STATE(137),
    [sym_comma_expression] = STATE(138),
    [sym_conditional_expression] = STATE(137),
    [sym_assignment_expression] = STATE(137),
    [sym_pointer_expression] = STATE(137),
    [sym_logical_expression] = STATE(137),
    [sym_bitwise_expression] = STATE(137),
    [sym_equality_expression] = STATE(137),
    [sym_relational_expression] = STATE(137),
    [sym_shift_expression] = STATE(137),
    [sym_math_expression] = STATE(137),
    [sym_cast_expression] = STATE(137),
    [sym_type_descriptor] = STATE(1323),
    [sym_sizeof_expression] = STATE(137),
    [sym_subscript_expression] = STATE(137),
    [sym_call_expression] = STATE(137),
    [sym_field_expression] = STATE(137),
    [sym_compound_literal_expression] = STATE(137),
    [sym_parenthesized_expression] = STATE(137),
    [sym_char_literal] = STATE(137),
    [sym_concatenated_string] = STATE(137),
    [sym_string_literal] = STATE(140),
    [sym_macro_type_specifier] = STATE(136),
    [sym_class_specifier] = STATE(136),
    [sym_dependent_type] = STATE(136),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(137),
    [sym_new_expression] = STATE(137),
    [sym_delete_expression] = STATE(137),
    [sym_lambda_expression] = STATE(137),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_type_definition_repeat1] = STATE(141),
    [aux_sym_sized_type_specifier_repeat1] = STATE(142),
    [sym_raw_string_literal] = ACTIONS(213),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(219),
    [anon_sym_long] = ACTIONS(219),
    [anon_sym_short] = ACTIONS(219),
    [sym_primitive_type] = ACTIONS(221),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [sym_null] = ACTIONS(241),
    [sym_identifier] = ACTIONS(811),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(221),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(253),
    [sym_nullptr] = ACTIONS(241),
  },
  [649] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1366),
    [anon_sym_COLON] = ACTIONS(1364),
    [anon_sym_QMARK] = ACTIONS(1364),
    [anon_sym_STAR_EQ] = ACTIONS(1364),
    [anon_sym_SLASH_EQ] = ACTIONS(1364),
    [anon_sym_PERCENT_EQ] = ACTIONS(1364),
    [anon_sym_PLUS_EQ] = ACTIONS(1364),
    [anon_sym_DASH_EQ] = ACTIONS(1364),
    [anon_sym_LT_LT_EQ] = ACTIONS(1364),
    [anon_sym_GT_GT_EQ] = ACTIONS(1364),
    [anon_sym_AMP_EQ] = ACTIONS(1364),
    [anon_sym_CARET_EQ] = ACTIONS(1364),
    [anon_sym_PIPE_EQ] = ACTIONS(1364),
    [anon_sym_AMP] = ACTIONS(1366),
    [anon_sym_PIPE_PIPE] = ACTIONS(1364),
    [anon_sym_AMP_AMP] = ACTIONS(1364),
    [anon_sym_PIPE] = ACTIONS(1366),
    [anon_sym_CARET] = ACTIONS(1366),
    [anon_sym_EQ_EQ] = ACTIONS(1364),
    [anon_sym_BANG_EQ] = ACTIONS(1364),
    [anon_sym_LT] = ACTIONS(1366),
    [anon_sym_GT] = ACTIONS(1366),
    [anon_sym_LT_EQ] = ACTIONS(1364),
    [anon_sym_GT_EQ] = ACTIONS(1364),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [650] = {
    [anon_sym_LPAREN2] = ACTIONS(1370),
    [anon_sym_STAR] = ACTIONS(1372),
    [anon_sym_LBRACK] = ACTIONS(1370),
    [anon_sym_EQ] = ACTIONS(1372),
    [anon_sym_COLON] = ACTIONS(1370),
    [anon_sym_QMARK] = ACTIONS(1370),
    [anon_sym_STAR_EQ] = ACTIONS(1370),
    [anon_sym_SLASH_EQ] = ACTIONS(1370),
    [anon_sym_PERCENT_EQ] = ACTIONS(1370),
    [anon_sym_PLUS_EQ] = ACTIONS(1370),
    [anon_sym_DASH_EQ] = ACTIONS(1370),
    [anon_sym_LT_LT_EQ] = ACTIONS(1370),
    [anon_sym_GT_GT_EQ] = ACTIONS(1370),
    [anon_sym_AMP_EQ] = ACTIONS(1370),
    [anon_sym_CARET_EQ] = ACTIONS(1370),
    [anon_sym_PIPE_EQ] = ACTIONS(1370),
    [anon_sym_AMP] = ACTIONS(1372),
    [anon_sym_PIPE_PIPE] = ACTIONS(1370),
    [anon_sym_AMP_AMP] = ACTIONS(1370),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_CARET] = ACTIONS(1372),
    [anon_sym_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG_EQ] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1372),
    [anon_sym_GT] = ACTIONS(1372),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_LT_LT] = ACTIONS(1372),
    [anon_sym_GT_GT] = ACTIONS(1372),
    [anon_sym_PLUS] = ACTIONS(1372),
    [anon_sym_DASH] = ACTIONS(1372),
    [anon_sym_SLASH] = ACTIONS(1372),
    [anon_sym_PERCENT] = ACTIONS(1372),
    [anon_sym_DASH_DASH] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1370),
    [anon_sym_DOT] = ACTIONS(1370),
    [anon_sym_DASH_GT] = ACTIONS(1370),
    [anon_sym_DQUOTE] = ACTIONS(1370),
    [sym_comment] = ACTIONS(91),
  },
  [651] = {
    [aux_sym_string_literal_repeat1] = STATE(761),
    [anon_sym_DQUOTE] = ACTIONS(2773),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_BSLASHn_RBRACK_SLASH] = ACTIONS(1376),
    [sym_escape_sequence] = ACTIONS(1376),
    [sym_comment] = ACTIONS(121),
  },
  [652] = {
    [sym__expression] = STATE(164),
    [sym_conditional_expression] = STATE(164),
    [sym_assignment_expression] = STATE(164),
    [sym_pointer_expression] = STATE(164),
    [sym_logical_expression] = STATE(164),
    [sym_bitwise_expression] = STATE(164),
    [sym_equality_expression] = STATE(164),
    [sym_relational_expression] = STATE(164),
    [sym_shift_expression] = STATE(164),
    [sym_math_expression] = STATE(164),
    [sym_cast_expression] = STATE(164),
    [sym_sizeof_expression] = STATE(164),
    [sym_subscript_expression] = STATE(164),
    [sym_call_expression] = STATE(164),
    [sym_field_expression] = STATE(164),
    [sym_compound_literal_expression] = STATE(164),
    [sym_parenthesized_expression] = STATE(164),
    [sym_char_literal] = STATE(164),
    [sym_concatenated_string] = STATE(164),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(164),
    [sym_new_expression] = STATE(164),
    [sym_delete_expression] = STATE(164),
    [sym_lambda_expression] = STATE(164),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_lambda_default_capture] = STATE(166),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(267),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(2775),
    [anon_sym_EQ] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(267),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(289),
    [sym_false] = ACTIONS(289),
    [sym_null] = ACTIONS(289),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(289),
  },
  [653] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1491),
    [anon_sym_COLON] = ACTIONS(1489),
    [anon_sym_QMARK] = ACTIONS(1489),
    [anon_sym_STAR_EQ] = ACTIONS(1489),
    [anon_sym_SLASH_EQ] = ACTIONS(1489),
    [anon_sym_PERCENT_EQ] = ACTIONS(1489),
    [anon_sym_PLUS_EQ] = ACTIONS(1489),
    [anon_sym_DASH_EQ] = ACTIONS(1489),
    [anon_sym_LT_LT_EQ] = ACTIONS(1489),
    [anon_sym_GT_GT_EQ] = ACTIONS(1489),
    [anon_sym_AMP_EQ] = ACTIONS(1489),
    [anon_sym_CARET_EQ] = ACTIONS(1489),
    [anon_sym_PIPE_EQ] = ACTIONS(1489),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_CARET] = ACTIONS(1183),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [654] = {
    [sym_field_declaration_list] = STATE(852),
    [sym_virtual_specifier] = STATE(853),
    [sym_base_class_clause] = STATE(854),
    [sym_template_type] = STATE(1327),
    [sym_scoped_type_identifier] = STATE(1328),
    [sym_scoped_namespace_identifier] = STATE(311),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(2777),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [655] = {
    [sym_field_declaration_list] = STATE(858),
    [sym_virtual_specifier] = STATE(859),
    [sym_base_class_clause] = STATE(860),
    [sym_template_type] = STATE(1330),
    [sym_scoped_type_identifier] = STATE(1331),
    [sym_scoped_namespace_identifier] = STATE(311),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(2779),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [656] = {
    [sym_field_declaration_list] = STATE(866),
    [sym_virtual_specifier] = STATE(867),
    [sym_base_class_clause] = STATE(868),
    [sym_template_type] = STATE(1333),
    [sym_scoped_type_identifier] = STATE(1334),
    [sym_scoped_namespace_identifier] = STATE(311),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(2781),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [657] = {
    [sym__type_specifier] = STATE(871),
    [sym_sized_type_specifier] = STATE(871),
    [sym_enum_specifier] = STATE(871),
    [sym_struct_specifier] = STATE(871),
    [sym_union_specifier] = STATE(871),
    [sym_macro_type_specifier] = STATE(871),
    [sym_class_specifier] = STATE(871),
    [sym_dependent_type] = STATE(871),
    [sym_template_type] = STATE(309),
    [sym_scoped_type_identifier] = STATE(310),
    [sym_scoped_namespace_identifier] = STATE(311),
    [aux_sym_sized_type_specifier_repeat1] = STATE(660),
    [anon_sym_unsigned] = ACTIONS(1149),
    [anon_sym_long] = ACTIONS(1149),
    [anon_sym_short] = ACTIONS(1149),
    [sym_primitive_type] = ACTIONS(1552),
    [anon_sym_enum] = ACTIONS(536),
    [anon_sym_struct] = ACTIONS(1153),
    [anon_sym_union] = ACTIONS(1155),
    [sym_identifier] = ACTIONS(542),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1157),
    [sym_auto] = ACTIONS(1552),
    [anon_sym_typename] = ACTIONS(1159),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [658] = {
    [sym_argument_list] = STATE(874),
    [sym_initializer_list] = STATE(874),
    [sym_new_declarator] = STATE(1336),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1558),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_EQ] = ACTIONS(1558),
    [anon_sym_COLON] = ACTIONS(1556),
    [anon_sym_QMARK] = ACTIONS(1556),
    [anon_sym_STAR_EQ] = ACTIONS(1556),
    [anon_sym_SLASH_EQ] = ACTIONS(1556),
    [anon_sym_PERCENT_EQ] = ACTIONS(1556),
    [anon_sym_PLUS_EQ] = ACTIONS(1556),
    [anon_sym_DASH_EQ] = ACTIONS(1556),
    [anon_sym_LT_LT_EQ] = ACTIONS(1556),
    [anon_sym_GT_GT_EQ] = ACTIONS(1556),
    [anon_sym_AMP_EQ] = ACTIONS(1556),
    [anon_sym_CARET_EQ] = ACTIONS(1556),
    [anon_sym_PIPE_EQ] = ACTIONS(1556),
    [anon_sym_AMP] = ACTIONS(1558),
    [anon_sym_PIPE_PIPE] = ACTIONS(1556),
    [anon_sym_AMP_AMP] = ACTIONS(1556),
    [anon_sym_PIPE] = ACTIONS(1558),
    [anon_sym_CARET] = ACTIONS(1558),
    [anon_sym_EQ_EQ] = ACTIONS(1556),
    [anon_sym_BANG_EQ] = ACTIONS(1556),
    [anon_sym_LT] = ACTIONS(1558),
    [anon_sym_GT] = ACTIONS(1558),
    [anon_sym_LT_EQ] = ACTIONS(1556),
    [anon_sym_GT_EQ] = ACTIONS(1556),
    [anon_sym_LT_LT] = ACTIONS(1558),
    [anon_sym_GT_GT] = ACTIONS(1558),
    [anon_sym_PLUS] = ACTIONS(1558),
    [anon_sym_DASH] = ACTIONS(1558),
    [anon_sym_SLASH] = ACTIONS(1558),
    [anon_sym_PERCENT] = ACTIONS(1558),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DOT] = ACTIONS(1556),
    [anon_sym_DASH_GT] = ACTIONS(1556),
    [sym_comment] = ACTIONS(91),
  },
  [659] = {
    [sym__type_specifier] = STATE(1337),
    [sym_sized_type_specifier] = STATE(1337),
    [sym_enum_specifier] = STATE(1337),
    [sym_struct_specifier] = STATE(1337),
    [sym_union_specifier] = STATE(1337),
    [sym_macro_type_specifier] = STATE(1337),
    [sym_class_specifier] = STATE(1337),
    [sym_dependent_type] = STATE(1337),
    [sym_template_type] = STATE(309),
    [sym_scoped_type_identifier] = STATE(310),
    [sym_scoped_namespace_identifier] = STATE(311),
    [aux_sym_sized_type_specifier_repeat1] = STATE(660),
    [anon_sym_unsigned] = ACTIONS(1149),
    [anon_sym_long] = ACTIONS(1149),
    [anon_sym_short] = ACTIONS(1149),
    [sym_primitive_type] = ACTIONS(2785),
    [anon_sym_enum] = ACTIONS(536),
    [anon_sym_struct] = ACTIONS(1153),
    [anon_sym_union] = ACTIONS(1155),
    [sym_identifier] = ACTIONS(542),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1157),
    [sym_auto] = ACTIONS(2785),
    [anon_sym_typename] = ACTIONS(1159),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [660] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1338),
    [anon_sym_LBRACE] = ACTIONS(653),
    [anon_sym_LPAREN2] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_EQ] = ACTIONS(655),
    [anon_sym_unsigned] = ACTIONS(2787),
    [anon_sym_long] = ACTIONS(2787),
    [anon_sym_short] = ACTIONS(2787),
    [sym_primitive_type] = ACTIONS(1571),
    [anon_sym_COLON] = ACTIONS(653),
    [anon_sym_QMARK] = ACTIONS(653),
    [anon_sym_STAR_EQ] = ACTIONS(653),
    [anon_sym_SLASH_EQ] = ACTIONS(653),
    [anon_sym_PERCENT_EQ] = ACTIONS(653),
    [anon_sym_PLUS_EQ] = ACTIONS(653),
    [anon_sym_DASH_EQ] = ACTIONS(653),
    [anon_sym_LT_LT_EQ] = ACTIONS(653),
    [anon_sym_GT_GT_EQ] = ACTIONS(653),
    [anon_sym_AMP_EQ] = ACTIONS(653),
    [anon_sym_CARET_EQ] = ACTIONS(653),
    [anon_sym_PIPE_EQ] = ACTIONS(653),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_PIPE_PIPE] = ACTIONS(653),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(655),
    [anon_sym_EQ_EQ] = ACTIONS(653),
    [anon_sym_BANG_EQ] = ACTIONS(653),
    [anon_sym_LT] = ACTIONS(655),
    [anon_sym_GT] = ACTIONS(655),
    [anon_sym_LT_EQ] = ACTIONS(653),
    [anon_sym_GT_EQ] = ACTIONS(653),
    [anon_sym_LT_LT] = ACTIONS(655),
    [anon_sym_GT_GT] = ACTIONS(655),
    [anon_sym_PLUS] = ACTIONS(655),
    [anon_sym_DASH] = ACTIONS(655),
    [anon_sym_SLASH] = ACTIONS(655),
    [anon_sym_PERCENT] = ACTIONS(655),
    [anon_sym_DASH_DASH] = ACTIONS(653),
    [anon_sym_PLUS_PLUS] = ACTIONS(653),
    [anon_sym_DOT] = ACTIONS(653),
    [anon_sym_DASH_GT] = ACTIONS(653),
    [sym_identifier] = ACTIONS(1573),
    [sym_comment] = ACTIONS(91),
  },
  [661] = {
    [sym__expression] = STATE(1340),
    [sym_conditional_expression] = STATE(1340),
    [sym_assignment_expression] = STATE(1340),
    [sym_pointer_expression] = STATE(1340),
    [sym_logical_expression] = STATE(1340),
    [sym_bitwise_expression] = STATE(1340),
    [sym_equality_expression] = STATE(1340),
    [sym_relational_expression] = STATE(1340),
    [sym_shift_expression] = STATE(1340),
    [sym_math_expression] = STATE(1340),
    [sym_cast_expression] = STATE(1340),
    [sym_sizeof_expression] = STATE(1340),
    [sym_subscript_expression] = STATE(1340),
    [sym_call_expression] = STATE(1340),
    [sym_field_expression] = STATE(1340),
    [sym_compound_literal_expression] = STATE(1340),
    [sym_parenthesized_expression] = STATE(1340),
    [sym_char_literal] = STATE(1340),
    [sym_concatenated_string] = STATE(1340),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1340),
    [sym_new_expression] = STATE(1340),
    [sym_delete_expression] = STATE(1340),
    [sym_lambda_expression] = STATE(1340),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2789),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(2791),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(2789),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(2793),
    [sym_false] = ACTIONS(2793),
    [sym_null] = ACTIONS(2793),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(2793),
  },
  [662] = {
    [sym__expression] = STATE(1342),
    [sym_conditional_expression] = STATE(1342),
    [sym_assignment_expression] = STATE(1342),
    [sym_pointer_expression] = STATE(1342),
    [sym_logical_expression] = STATE(1342),
    [sym_bitwise_expression] = STATE(1342),
    [sym_equality_expression] = STATE(1342),
    [sym_relational_expression] = STATE(1342),
    [sym_shift_expression] = STATE(1342),
    [sym_math_expression] = STATE(1342),
    [sym_cast_expression] = STATE(1342),
    [sym_sizeof_expression] = STATE(1342),
    [sym_subscript_expression] = STATE(1342),
    [sym_call_expression] = STATE(1342),
    [sym_field_expression] = STATE(1342),
    [sym_compound_literal_expression] = STATE(1342),
    [sym_parenthesized_expression] = STATE(1342),
    [sym_initializer_list] = STATE(1343),
    [sym_char_literal] = STATE(1342),
    [sym_concatenated_string] = STATE(1342),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1342),
    [sym_new_expression] = STATE(1342),
    [sym_delete_expression] = STATE(1342),
    [sym_lambda_expression] = STATE(1342),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2795),
    [anon_sym_RPAREN] = ACTIONS(2797),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(2795),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2799),
    [sym_false] = ACTIONS(2799),
    [sym_null] = ACTIONS(2799),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(2799),
  },
  [663] = {
    [sym__expression] = STATE(1344),
    [sym_conditional_expression] = STATE(1344),
    [sym_assignment_expression] = STATE(1344),
    [sym_pointer_expression] = STATE(1344),
    [sym_logical_expression] = STATE(1344),
    [sym_bitwise_expression] = STATE(1344),
    [sym_equality_expression] = STATE(1344),
    [sym_relational_expression] = STATE(1344),
    [sym_shift_expression] = STATE(1344),
    [sym_math_expression] = STATE(1344),
    [sym_cast_expression] = STATE(1344),
    [sym_sizeof_expression] = STATE(1344),
    [sym_subscript_expression] = STATE(1344),
    [sym_call_expression] = STATE(1344),
    [sym_field_expression] = STATE(1344),
    [sym_compound_literal_expression] = STATE(1344),
    [sym_parenthesized_expression] = STATE(1344),
    [sym_char_literal] = STATE(1344),
    [sym_concatenated_string] = STATE(1344),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1344),
    [sym_new_expression] = STATE(1344),
    [sym_delete_expression] = STATE(1344),
    [sym_lambda_expression] = STATE(1344),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2801),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(2801),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(2803),
    [sym_false] = ACTIONS(2803),
    [sym_null] = ACTIONS(2803),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(2803),
  },
  [664] = {
    [sym__expression] = STATE(1345),
    [sym_conditional_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(1345),
    [sym_pointer_expression] = STATE(1345),
    [sym_logical_expression] = STATE(1345),
    [sym_bitwise_expression] = STATE(1345),
    [sym_equality_expression] = STATE(1345),
    [sym_relational_expression] = STATE(1345),
    [sym_shift_expression] = STATE(1345),
    [sym_math_expression] = STATE(1345),
    [sym_cast_expression] = STATE(1345),
    [sym_sizeof_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_call_expression] = STATE(1345),
    [sym_field_expression] = STATE(1345),
    [sym_compound_literal_expression] = STATE(1345),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_char_literal] = STATE(1345),
    [sym_concatenated_string] = STATE(1345),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1345),
    [sym_new_expression] = STATE(1345),
    [sym_delete_expression] = STATE(1345),
    [sym_lambda_expression] = STATE(1345),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2805),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(2805),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(2807),
    [sym_false] = ACTIONS(2807),
    [sym_null] = ACTIONS(2807),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(2807),
  },
  [665] = {
    [sym_declaration] = STATE(1346),
    [sym_type_definition] = STATE(1346),
    [sym__declaration_specifiers] = STATE(682),
    [sym_compound_statement] = STATE(1346),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_labeled_statement] = STATE(1346),
    [sym_expression_statement] = STATE(1346),
    [sym_if_statement] = STATE(1346),
    [sym_switch_statement] = STATE(1346),
    [sym_case_statement] = STATE(1346),
    [sym_while_statement] = STATE(1346),
    [sym_do_statement] = STATE(1346),
    [sym_for_statement] = STATE(1346),
    [sym_return_statement] = STATE(1346),
    [sym_break_statement] = STATE(1346),
    [sym_continue_statement] = STATE(1346),
    [sym_goto_statement] = STATE(1346),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(1346),
    [sym_try_statement] = STATE(1346),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_switch] = ACTIONS(49),
    [anon_sym_case] = ACTIONS(51),
    [anon_sym_default] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(1200),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(105),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(1202),
    [sym_nullptr] = ACTIONS(87),
  },
  [666] = {
    [sym__expression] = STATE(1347),
    [sym_conditional_expression] = STATE(1347),
    [sym_assignment_expression] = STATE(1347),
    [sym_pointer_expression] = STATE(1347),
    [sym_logical_expression] = STATE(1347),
    [sym_bitwise_expression] = STATE(1347),
    [sym_equality_expression] = STATE(1347),
    [sym_relational_expression] = STATE(1347),
    [sym_shift_expression] = STATE(1347),
    [sym_math_expression] = STATE(1347),
    [sym_cast_expression] = STATE(1347),
    [sym_sizeof_expression] = STATE(1347),
    [sym_subscript_expression] = STATE(1347),
    [sym_call_expression] = STATE(1347),
    [sym_field_expression] = STATE(1347),
    [sym_compound_literal_expression] = STATE(1347),
    [sym_parenthesized_expression] = STATE(1347),
    [sym_char_literal] = STATE(1347),
    [sym_concatenated_string] = STATE(1347),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1347),
    [sym_new_expression] = STATE(1347),
    [sym_delete_expression] = STATE(1347),
    [sym_lambda_expression] = STATE(1347),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2809),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(2809),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(2811),
    [sym_false] = ACTIONS(2811),
    [sym_null] = ACTIONS(2811),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(2811),
  },
  [667] = {
    [sym__expression] = STATE(1348),
    [sym_conditional_expression] = STATE(1348),
    [sym_assignment_expression] = STATE(1348),
    [sym_pointer_expression] = STATE(1348),
    [sym_logical_expression] = STATE(1348),
    [sym_bitwise_expression] = STATE(1348),
    [sym_equality_expression] = STATE(1348),
    [sym_relational_expression] = STATE(1348),
    [sym_shift_expression] = STATE(1348),
    [sym_math_expression] = STATE(1348),
    [sym_cast_expression] = STATE(1348),
    [sym_sizeof_expression] = STATE(1348),
    [sym_subscript_expression] = STATE(1348),
    [sym_call_expression] = STATE(1348),
    [sym_field_expression] = STATE(1348),
    [sym_compound_literal_expression] = STATE(1348),
    [sym_parenthesized_expression] = STATE(1348),
    [sym_char_literal] = STATE(1348),
    [sym_concatenated_string] = STATE(1348),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1348),
    [sym_new_expression] = STATE(1348),
    [sym_delete_expression] = STATE(1348),
    [sym_lambda_expression] = STATE(1348),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2813),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(2815),
    [sym_false] = ACTIONS(2815),
    [sym_null] = ACTIONS(2815),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(2815),
  },
  [668] = {
    [sym__expression] = STATE(1349),
    [sym_conditional_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(1349),
    [sym_pointer_expression] = STATE(1349),
    [sym_logical_expression] = STATE(1349),
    [sym_bitwise_expression] = STATE(1349),
    [sym_equality_expression] = STATE(1349),
    [sym_relational_expression] = STATE(1349),
    [sym_shift_expression] = STATE(1349),
    [sym_math_expression] = STATE(1349),
    [sym_cast_expression] = STATE(1349),
    [sym_sizeof_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_call_expression] = STATE(1349),
    [sym_field_expression] = STATE(1349),
    [sym_compound_literal_expression] = STATE(1349),
    [sym_parenthesized_expression] = STATE(1349),
    [sym_char_literal] = STATE(1349),
    [sym_concatenated_string] = STATE(1349),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1349),
    [sym_new_expression] = STATE(1349),
    [sym_delete_expression] = STATE(1349),
    [sym_lambda_expression] = STATE(1349),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(2817),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(2819),
    [sym_false] = ACTIONS(2819),
    [sym_null] = ACTIONS(2819),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(2819),
  },
  [669] = {
    [sym__expression] = STATE(1350),
    [sym_conditional_expression] = STATE(1350),
    [sym_assignment_expression] = STATE(1350),
    [sym_pointer_expression] = STATE(1350),
    [sym_logical_expression] = STATE(1350),
    [sym_bitwise_expression] = STATE(1350),
    [sym_equality_expression] = STATE(1350),
    [sym_relational_expression] = STATE(1350),
    [sym_shift_expression] = STATE(1350),
    [sym_math_expression] = STATE(1350),
    [sym_cast_expression] = STATE(1350),
    [sym_sizeof_expression] = STATE(1350),
    [sym_subscript_expression] = STATE(1350),
    [sym_call_expression] = STATE(1350),
    [sym_field_expression] = STATE(1350),
    [sym_compound_literal_expression] = STATE(1350),
    [sym_parenthesized_expression] = STATE(1350),
    [sym_char_literal] = STATE(1350),
    [sym_concatenated_string] = STATE(1350),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1350),
    [sym_new_expression] = STATE(1350),
    [sym_delete_expression] = STATE(1350),
    [sym_lambda_expression] = STATE(1350),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2821),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(2821),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(2823),
    [sym_false] = ACTIONS(2823),
    [sym_null] = ACTIONS(2823),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(2823),
  },
  [670] = {
    [sym__expression] = STATE(1351),
    [sym_conditional_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1351),
    [sym_pointer_expression] = STATE(1351),
    [sym_logical_expression] = STATE(1351),
    [sym_bitwise_expression] = STATE(1351),
    [sym_equality_expression] = STATE(1351),
    [sym_relational_expression] = STATE(1351),
    [sym_shift_expression] = STATE(1351),
    [sym_math_expression] = STATE(1351),
    [sym_cast_expression] = STATE(1351),
    [sym_sizeof_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_call_expression] = STATE(1351),
    [sym_field_expression] = STATE(1351),
    [sym_compound_literal_expression] = STATE(1351),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_char_literal] = STATE(1351),
    [sym_concatenated_string] = STATE(1351),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1351),
    [sym_new_expression] = STATE(1351),
    [sym_delete_expression] = STATE(1351),
    [sym_lambda_expression] = STATE(1351),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2825),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(2825),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(2827),
    [sym_false] = ACTIONS(2827),
    [sym_null] = ACTIONS(2827),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(2827),
  },
  [671] = {
    [sym__expression] = STATE(1352),
    [sym_conditional_expression] = STATE(1352),
    [sym_assignment_expression] = STATE(1352),
    [sym_pointer_expression] = STATE(1352),
    [sym_logical_expression] = STATE(1352),
    [sym_bitwise_expression] = STATE(1352),
    [sym_equality_expression] = STATE(1352),
    [sym_relational_expression] = STATE(1352),
    [sym_shift_expression] = STATE(1352),
    [sym_math_expression] = STATE(1352),
    [sym_cast_expression] = STATE(1352),
    [sym_sizeof_expression] = STATE(1352),
    [sym_subscript_expression] = STATE(1352),
    [sym_call_expression] = STATE(1352),
    [sym_field_expression] = STATE(1352),
    [sym_compound_literal_expression] = STATE(1352),
    [sym_parenthesized_expression] = STATE(1352),
    [sym_char_literal] = STATE(1352),
    [sym_concatenated_string] = STATE(1352),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1352),
    [sym_new_expression] = STATE(1352),
    [sym_delete_expression] = STATE(1352),
    [sym_lambda_expression] = STATE(1352),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2829),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(2829),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(2831),
    [sym_false] = ACTIONS(2831),
    [sym_null] = ACTIONS(2831),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(2831),
  },
  [672] = {
    [sym__expression] = STATE(1353),
    [sym_conditional_expression] = STATE(1353),
    [sym_assignment_expression] = STATE(1353),
    [sym_pointer_expression] = STATE(1353),
    [sym_logical_expression] = STATE(1353),
    [sym_bitwise_expression] = STATE(1353),
    [sym_equality_expression] = STATE(1353),
    [sym_relational_expression] = STATE(1353),
    [sym_shift_expression] = STATE(1353),
    [sym_math_expression] = STATE(1353),
    [sym_cast_expression] = STATE(1353),
    [sym_sizeof_expression] = STATE(1353),
    [sym_subscript_expression] = STATE(1353),
    [sym_call_expression] = STATE(1353),
    [sym_field_expression] = STATE(1353),
    [sym_compound_literal_expression] = STATE(1353),
    [sym_parenthesized_expression] = STATE(1353),
    [sym_char_literal] = STATE(1353),
    [sym_concatenated_string] = STATE(1353),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1353),
    [sym_new_expression] = STATE(1353),
    [sym_delete_expression] = STATE(1353),
    [sym_lambda_expression] = STATE(1353),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2833),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(2833),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(2835),
    [sym_false] = ACTIONS(2835),
    [sym_null] = ACTIONS(2835),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(2835),
  },
  [673] = {
    [sym__expression] = STATE(1354),
    [sym_conditional_expression] = STATE(1354),
    [sym_assignment_expression] = STATE(1354),
    [sym_pointer_expression] = STATE(1354),
    [sym_logical_expression] = STATE(1354),
    [sym_bitwise_expression] = STATE(1354),
    [sym_equality_expression] = STATE(1354),
    [sym_relational_expression] = STATE(1354),
    [sym_shift_expression] = STATE(1354),
    [sym_math_expression] = STATE(1354),
    [sym_cast_expression] = STATE(1354),
    [sym_sizeof_expression] = STATE(1354),
    [sym_subscript_expression] = STATE(1354),
    [sym_call_expression] = STATE(1354),
    [sym_field_expression] = STATE(1354),
    [sym_compound_literal_expression] = STATE(1354),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_char_literal] = STATE(1354),
    [sym_concatenated_string] = STATE(1354),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1354),
    [sym_new_expression] = STATE(1354),
    [sym_delete_expression] = STATE(1354),
    [sym_lambda_expression] = STATE(1354),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2837),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(2837),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(2839),
    [sym_false] = ACTIONS(2839),
    [sym_null] = ACTIONS(2839),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(2839),
  },
  [674] = {
    [sym__expression] = STATE(1355),
    [sym_conditional_expression] = STATE(1355),
    [sym_assignment_expression] = STATE(1355),
    [sym_pointer_expression] = STATE(1355),
    [sym_logical_expression] = STATE(1355),
    [sym_bitwise_expression] = STATE(1355),
    [sym_equality_expression] = STATE(1355),
    [sym_relational_expression] = STATE(1355),
    [sym_shift_expression] = STATE(1355),
    [sym_math_expression] = STATE(1355),
    [sym_cast_expression] = STATE(1355),
    [sym_sizeof_expression] = STATE(1355),
    [sym_subscript_expression] = STATE(1355),
    [sym_call_expression] = STATE(1355),
    [sym_field_expression] = STATE(1355),
    [sym_compound_literal_expression] = STATE(1355),
    [sym_parenthesized_expression] = STATE(1355),
    [sym_char_literal] = STATE(1355),
    [sym_concatenated_string] = STATE(1355),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1355),
    [sym_new_expression] = STATE(1355),
    [sym_delete_expression] = STATE(1355),
    [sym_lambda_expression] = STATE(1355),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2841),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(2841),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(2843),
    [sym_false] = ACTIONS(2843),
    [sym_null] = ACTIONS(2843),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(2843),
  },
  [675] = {
    [sym__expression] = STATE(1356),
    [sym_conditional_expression] = STATE(1356),
    [sym_assignment_expression] = STATE(1356),
    [sym_pointer_expression] = STATE(1356),
    [sym_logical_expression] = STATE(1356),
    [sym_bitwise_expression] = STATE(1356),
    [sym_equality_expression] = STATE(1356),
    [sym_relational_expression] = STATE(1356),
    [sym_shift_expression] = STATE(1356),
    [sym_math_expression] = STATE(1356),
    [sym_cast_expression] = STATE(1356),
    [sym_sizeof_expression] = STATE(1356),
    [sym_subscript_expression] = STATE(1356),
    [sym_call_expression] = STATE(1356),
    [sym_field_expression] = STATE(1356),
    [sym_compound_literal_expression] = STATE(1356),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_char_literal] = STATE(1356),
    [sym_concatenated_string] = STATE(1356),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1356),
    [sym_new_expression] = STATE(1356),
    [sym_delete_expression] = STATE(1356),
    [sym_lambda_expression] = STATE(1356),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2845),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(2847),
    [sym_false] = ACTIONS(2847),
    [sym_null] = ACTIONS(2847),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(2847),
  },
  [676] = {
    [sym_template_type] = STATE(953),
    [sym_template_method] = STATE(954),
    [sym_destructor_name] = STATE(954),
    [sym_scoped_field_identifier] = STATE(1266),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(953),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(1753),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1755),
  },
  [677] = {
    [sym_string_literal] = STATE(1357),
    [aux_sym_concatenated_string_repeat1] = STATE(1357),
    [anon_sym_LPAREN2] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_EQ] = ACTIONS(1763),
    [anon_sym_COLON] = ACTIONS(1761),
    [anon_sym_QMARK] = ACTIONS(1761),
    [anon_sym_STAR_EQ] = ACTIONS(1761),
    [anon_sym_SLASH_EQ] = ACTIONS(1761),
    [anon_sym_PERCENT_EQ] = ACTIONS(1761),
    [anon_sym_PLUS_EQ] = ACTIONS(1761),
    [anon_sym_DASH_EQ] = ACTIONS(1761),
    [anon_sym_LT_LT_EQ] = ACTIONS(1761),
    [anon_sym_GT_GT_EQ] = ACTIONS(1761),
    [anon_sym_AMP_EQ] = ACTIONS(1761),
    [anon_sym_CARET_EQ] = ACTIONS(1761),
    [anon_sym_PIPE_EQ] = ACTIONS(1761),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_PIPE_PIPE] = ACTIONS(1761),
    [anon_sym_AMP_AMP] = ACTIONS(1761),
    [anon_sym_PIPE] = ACTIONS(1763),
    [anon_sym_CARET] = ACTIONS(1763),
    [anon_sym_EQ_EQ] = ACTIONS(1761),
    [anon_sym_BANG_EQ] = ACTIONS(1761),
    [anon_sym_LT] = ACTIONS(1763),
    [anon_sym_GT] = ACTIONS(1763),
    [anon_sym_LT_EQ] = ACTIONS(1761),
    [anon_sym_GT_EQ] = ACTIONS(1761),
    [anon_sym_LT_LT] = ACTIONS(1763),
    [anon_sym_GT_GT] = ACTIONS(1763),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_SLASH] = ACTIONS(1763),
    [anon_sym_PERCENT] = ACTIONS(1763),
    [anon_sym_DASH_DASH] = ACTIONS(1761),
    [anon_sym_PLUS_PLUS] = ACTIONS(1761),
    [anon_sym_DOT] = ACTIONS(1761),
    [anon_sym_DASH_GT] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(91),
  },
  [678] = {
    [sym_type_qualifier] = STATE(786),
    [sym__type_specifier] = STATE(777),
    [sym_sized_type_specifier] = STATE(777),
    [sym_enum_specifier] = STATE(777),
    [sym_struct_specifier] = STATE(777),
    [sym_union_specifier] = STATE(777),
    [sym__expression] = STATE(1359),
    [sym_conditional_expression] = STATE(1359),
    [sym_assignment_expression] = STATE(1359),
    [sym_pointer_expression] = STATE(1359),
    [sym_logical_expression] = STATE(1359),
    [sym_bitwise_expression] = STATE(1359),
    [sym_equality_expression] = STATE(1359),
    [sym_relational_expression] = STATE(1359),
    [sym_shift_expression] = STATE(1359),
    [sym_math_expression] = STATE(1359),
    [sym_cast_expression] = STATE(1359),
    [sym_type_descriptor] = STATE(1360),
    [sym_sizeof_expression] = STATE(1359),
    [sym_subscript_expression] = STATE(1359),
    [sym_call_expression] = STATE(1359),
    [sym_field_expression] = STATE(1359),
    [sym_compound_literal_expression] = STATE(1359),
    [sym_parenthesized_expression] = STATE(1359),
    [sym_char_literal] = STATE(1359),
    [sym_concatenated_string] = STATE(1359),
    [sym_string_literal] = STATE(780),
    [sym_macro_type_specifier] = STATE(777),
    [sym_class_specifier] = STATE(777),
    [sym_dependent_type] = STATE(777),
    [sym_template_type] = STATE(781),
    [sym_template_function] = STATE(1359),
    [sym_new_expression] = STATE(1359),
    [sym_delete_expression] = STATE(1359),
    [sym_lambda_expression] = STATE(1359),
    [sym_lambda_capture_specifier] = STATE(782),
    [sym_scoped_identifier] = STATE(783),
    [sym_scoped_type_identifier] = STATE(784),
    [sym_scoped_namespace_identifier] = STATE(785),
    [aux_sym_type_definition_repeat1] = STATE(786),
    [aux_sym_sized_type_specifier_repeat1] = STATE(787),
    [sym_raw_string_literal] = ACTIONS(2849),
    [anon_sym_LPAREN2] = ACTIONS(1380),
    [anon_sym_STAR] = ACTIONS(1382),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(1384),
    [anon_sym_long] = ACTIONS(1384),
    [anon_sym_short] = ACTIONS(1384),
    [sym_primitive_type] = ACTIONS(1386),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [anon_sym_AMP] = ACTIONS(1382),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1394),
    [anon_sym_PLUS_PLUS] = ACTIONS(1394),
    [anon_sym_sizeof] = ACTIONS(1396),
    [sym_number_literal] = ACTIONS(2849),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [sym_null] = ACTIONS(2851),
    [sym_identifier] = ACTIONS(1404),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(1386),
    [anon_sym_typename] = ACTIONS(1406),
    [anon_sym_GT2] = ACTIONS(2853),
    [anon_sym_delete] = ACTIONS(1410),
    [anon_sym_new] = ACTIONS(1412),
    [anon_sym_COLON_COLON] = ACTIONS(1414),
    [sym_nullptr] = ACTIONS(2851),
  },
  [679] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(1362),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_extern] = ACTIONS(468),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(465),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_register] = ACTIONS(468),
    [anon_sym_inline] = ACTIONS(468),
    [anon_sym_const] = ACTIONS(468),
    [anon_sym_restrict] = ACTIONS(468),
    [anon_sym_volatile] = ACTIONS(468),
    [anon_sym__Atomic] = ACTIONS(468),
    [anon_sym_mutable] = ACTIONS(468),
    [anon_sym_explicit] = ACTIONS(468),
    [anon_sym_constexpr] = ACTIONS(468),
    [anon_sym_COLON] = ACTIONS(479),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(474),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_TILDE] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_identifier] = ACTIONS(468),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(2855),
    [sym_operator_name] = ACTIONS(481),
  },
  [680] = {
    [sym_destructor_name] = STATE(315),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(2857),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(552),
    [sym_operator_name] = ACTIONS(554),
  },
  [681] = {
    [sym_raw_string_literal] = ACTIONS(2859),
    [ts_builtin_sym_end] = ACTIONS(2859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2861),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2861),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2861),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2861),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2861),
    [sym_preproc_directive] = ACTIONS(2861),
    [anon_sym_SEMI] = ACTIONS(2859),
    [anon_sym_typedef] = ACTIONS(2861),
    [anon_sym_extern] = ACTIONS(2861),
    [anon_sym_LBRACE] = ACTIONS(2859),
    [anon_sym_RBRACE] = ACTIONS(2859),
    [anon_sym_LPAREN2] = ACTIONS(2859),
    [anon_sym_STAR] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_static] = ACTIONS(2861),
    [anon_sym_register] = ACTIONS(2861),
    [anon_sym_inline] = ACTIONS(2861),
    [anon_sym_const] = ACTIONS(2861),
    [anon_sym_restrict] = ACTIONS(2861),
    [anon_sym_volatile] = ACTIONS(2861),
    [anon_sym__Atomic] = ACTIONS(2861),
    [anon_sym_mutable] = ACTIONS(2861),
    [anon_sym_explicit] = ACTIONS(2861),
    [anon_sym_constexpr] = ACTIONS(2861),
    [anon_sym_unsigned] = ACTIONS(2861),
    [anon_sym_long] = ACTIONS(2861),
    [anon_sym_short] = ACTIONS(2861),
    [sym_primitive_type] = ACTIONS(2861),
    [anon_sym_enum] = ACTIONS(2861),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2861),
    [anon_sym_if] = ACTIONS(2861),
    [anon_sym_else] = ACTIONS(2861),
    [anon_sym_switch] = ACTIONS(2861),
    [anon_sym_case] = ACTIONS(2861),
    [anon_sym_default] = ACTIONS(2861),
    [anon_sym_while] = ACTIONS(2861),
    [anon_sym_do] = ACTIONS(2861),
    [anon_sym_for] = ACTIONS(2861),
    [anon_sym_return] = ACTIONS(2861),
    [anon_sym_break] = ACTIONS(2861),
    [anon_sym_continue] = ACTIONS(2861),
    [anon_sym_goto] = ACTIONS(2861),
    [anon_sym_AMP] = ACTIONS(2861),
    [anon_sym_AMP_AMP] = ACTIONS(2859),
    [anon_sym_BANG] = ACTIONS(2859),
    [anon_sym_TILDE] = ACTIONS(2859),
    [anon_sym_PLUS] = ACTIONS(2861),
    [anon_sym_DASH] = ACTIONS(2861),
    [anon_sym_DASH_DASH] = ACTIONS(2859),
    [anon_sym_PLUS_PLUS] = ACTIONS(2859),
    [anon_sym_sizeof] = ACTIONS(2861),
    [sym_number_literal] = ACTIONS(2859),
    [anon_sym_SQUOTE] = ACTIONS(2859),
    [anon_sym_DQUOTE] = ACTIONS(2859),
    [sym_true] = ACTIONS(2861),
    [sym_false] = ACTIONS(2861),
    [sym_null] = ACTIONS(2861),
    [sym_identifier] = ACTIONS(2861),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2861),
    [sym_auto] = ACTIONS(2861),
    [anon_sym_typename] = ACTIONS(2861),
    [anon_sym_template] = ACTIONS(2861),
    [anon_sym_delete] = ACTIONS(2861),
    [anon_sym_namespace] = ACTIONS(2861),
    [anon_sym_using] = ACTIONS(2861),
    [anon_sym_try] = ACTIONS(2861),
    [anon_sym_new] = ACTIONS(2861),
    [anon_sym_COLON_COLON] = ACTIONS(2859),
    [sym_operator_name] = ACTIONS(2859),
    [sym_nullptr] = ACTIONS(2861),
  },
  [682] = {
    [sym__declarator] = STATE(1364),
    [sym_pointer_declarator] = STATE(1364),
    [sym_function_declarator] = STATE(1364),
    [sym_array_declarator] = STATE(1364),
    [sym_init_declarator] = STATE(322),
    [sym_reference_declarator] = STATE(1364),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(1364),
    [sym_destructor_name] = STATE(1364),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(560),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(568),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(2863),
  },
  [683] = {
    [sym_initializer_list] = STATE(352),
    [anon_sym_extern] = ACTIONS(626),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(624),
    [anon_sym_STAR] = ACTIONS(624),
    [anon_sym_static] = ACTIONS(626),
    [anon_sym_register] = ACTIONS(626),
    [anon_sym_inline] = ACTIONS(626),
    [anon_sym_const] = ACTIONS(626),
    [anon_sym_restrict] = ACTIONS(626),
    [anon_sym_volatile] = ACTIONS(626),
    [anon_sym__Atomic] = ACTIONS(626),
    [anon_sym_mutable] = ACTIONS(626),
    [anon_sym_explicit] = ACTIONS(626),
    [anon_sym_constexpr] = ACTIONS(626),
    [anon_sym_AMP] = ACTIONS(626),
    [anon_sym_AMP_AMP] = ACTIONS(624),
    [anon_sym_TILDE] = ACTIONS(624),
    [sym_identifier] = ACTIONS(626),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(2865),
    [sym_operator_name] = ACTIONS(624),
  },
  [684] = {
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(2865),
  },
  [685] = {
    [sym_raw_string_literal] = ACTIONS(2867),
    [ts_builtin_sym_end] = ACTIONS(2867),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2869),
    [sym_preproc_directive] = ACTIONS(2869),
    [anon_sym_SEMI] = ACTIONS(2867),
    [anon_sym_typedef] = ACTIONS(2869),
    [anon_sym_extern] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_RBRACE] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2867),
    [anon_sym_STAR] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_static] = ACTIONS(2869),
    [anon_sym_register] = ACTIONS(2869),
    [anon_sym_inline] = ACTIONS(2869),
    [anon_sym_const] = ACTIONS(2869),
    [anon_sym_restrict] = ACTIONS(2869),
    [anon_sym_volatile] = ACTIONS(2869),
    [anon_sym__Atomic] = ACTIONS(2869),
    [anon_sym_mutable] = ACTIONS(2869),
    [anon_sym_explicit] = ACTIONS(2869),
    [anon_sym_constexpr] = ACTIONS(2869),
    [anon_sym_unsigned] = ACTIONS(2869),
    [anon_sym_long] = ACTIONS(2869),
    [anon_sym_short] = ACTIONS(2869),
    [sym_primitive_type] = ACTIONS(2869),
    [anon_sym_enum] = ACTIONS(2869),
    [anon_sym_struct] = ACTIONS(2869),
    [anon_sym_union] = ACTIONS(2869),
    [anon_sym_if] = ACTIONS(2869),
    [anon_sym_else] = ACTIONS(2869),
    [anon_sym_switch] = ACTIONS(2869),
    [anon_sym_case] = ACTIONS(2869),
    [anon_sym_default] = ACTIONS(2869),
    [anon_sym_while] = ACTIONS(2869),
    [anon_sym_do] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2869),
    [anon_sym_return] = ACTIONS(2869),
    [anon_sym_break] = ACTIONS(2869),
    [anon_sym_continue] = ACTIONS(2869),
    [anon_sym_goto] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2869),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_BANG] = ACTIONS(2867),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2869),
    [anon_sym_DASH] = ACTIONS(2869),
    [anon_sym_DASH_DASH] = ACTIONS(2867),
    [anon_sym_PLUS_PLUS] = ACTIONS(2867),
    [anon_sym_sizeof] = ACTIONS(2869),
    [sym_number_literal] = ACTIONS(2867),
    [anon_sym_SQUOTE] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [sym_true] = ACTIONS(2869),
    [sym_false] = ACTIONS(2869),
    [sym_null] = ACTIONS(2869),
    [sym_identifier] = ACTIONS(2869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2869),
    [sym_auto] = ACTIONS(2869),
    [anon_sym_typename] = ACTIONS(2869),
    [anon_sym_template] = ACTIONS(2869),
    [anon_sym_delete] = ACTIONS(2869),
    [anon_sym_namespace] = ACTIONS(2869),
    [anon_sym_using] = ACTIONS(2869),
    [anon_sym_try] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_COLON_COLON] = ACTIONS(2867),
    [sym_operator_name] = ACTIONS(2867),
    [sym_nullptr] = ACTIONS(2869),
  },
  [686] = {
    [anon_sym_COMMA] = ACTIONS(801),
    [anon_sym_RPAREN] = ACTIONS(801),
    [anon_sym_SEMI] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(801),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(801),
    [anon_sym_RBRACK] = ACTIONS(801),
    [anon_sym_EQ] = ACTIONS(803),
    [anon_sym_COLON] = ACTIONS(801),
    [anon_sym_else] = ACTIONS(801),
    [anon_sym_while] = ACTIONS(801),
    [anon_sym_QMARK] = ACTIONS(801),
    [anon_sym_STAR_EQ] = ACTIONS(801),
    [anon_sym_SLASH_EQ] = ACTIONS(801),
    [anon_sym_PERCENT_EQ] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(801),
    [anon_sym_DASH_EQ] = ACTIONS(801),
    [anon_sym_LT_LT_EQ] = ACTIONS(801),
    [anon_sym_GT_GT_EQ] = ACTIONS(801),
    [anon_sym_AMP_EQ] = ACTIONS(801),
    [anon_sym_CARET_EQ] = ACTIONS(801),
    [anon_sym_PIPE_EQ] = ACTIONS(801),
    [anon_sym_AMP] = ACTIONS(803),
    [anon_sym_PIPE_PIPE] = ACTIONS(801),
    [anon_sym_AMP_AMP] = ACTIONS(801),
    [anon_sym_PIPE] = ACTIONS(803),
    [anon_sym_CARET] = ACTIONS(803),
    [anon_sym_EQ_EQ] = ACTIONS(801),
    [anon_sym_BANG_EQ] = ACTIONS(801),
    [anon_sym_LT] = ACTIONS(803),
    [anon_sym_GT] = ACTIONS(803),
    [anon_sym_LT_EQ] = ACTIONS(801),
    [anon_sym_GT_EQ] = ACTIONS(801),
    [anon_sym_LT_LT] = ACTIONS(803),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_DASH] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_PERCENT] = ACTIONS(803),
    [anon_sym_DASH_DASH] = ACTIONS(801),
    [anon_sym_PLUS_PLUS] = ACTIONS(801),
    [anon_sym_DOT] = ACTIONS(801),
    [anon_sym_DASH_GT] = ACTIONS(801),
    [sym_comment] = ACTIONS(91),
    [anon_sym_catch] = ACTIONS(801),
  },
  [687] = {
    [sym_preproc_include] = STATE(496),
    [sym_preproc_def] = STATE(496),
    [sym_preproc_function_def] = STATE(496),
    [sym_preproc_call] = STATE(496),
    [sym_preproc_if_in_compound_statement] = STATE(496),
    [sym_preproc_ifdef_in_compound_statement] = STATE(496),
    [sym_declaration] = STATE(496),
    [sym_type_definition] = STATE(496),
    [sym__declaration_specifiers] = STATE(113),
    [sym_compound_statement] = STATE(496),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(496),
    [sym_expression_statement] = STATE(496),
    [sym_if_statement] = STATE(496),
    [sym_switch_statement] = STATE(496),
    [sym_case_statement] = STATE(496),
    [sym_while_statement] = STATE(496),
    [sym_do_statement] = STATE(496),
    [sym_for_statement] = STATE(496),
    [sym_return_statement] = STATE(496),
    [sym_break_statement] = STATE(496),
    [sym_continue_statement] = STATE(496),
    [sym_goto_statement] = STATE(496),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(496),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(496),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(496),
    [sym_try_statement] = STATE(496),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(496),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(157),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(159),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(161),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(163),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(165),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(165),
    [sym_preproc_directive] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_typedef] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_RBRACE] = ACTIONS(2871),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(185),
    [anon_sym_case] = ACTIONS(187),
    [anon_sym_default] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(209),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_nullptr] = ACTIONS(207),
  },
  [688] = {
    [sym__expression] = STATE(1367),
    [sym_conditional_expression] = STATE(1367),
    [sym_assignment_expression] = STATE(1367),
    [sym_pointer_expression] = STATE(1367),
    [sym_logical_expression] = STATE(1367),
    [sym_bitwise_expression] = STATE(1367),
    [sym_equality_expression] = STATE(1367),
    [sym_relational_expression] = STATE(1367),
    [sym_shift_expression] = STATE(1367),
    [sym_math_expression] = STATE(1367),
    [sym_cast_expression] = STATE(1367),
    [sym_sizeof_expression] = STATE(1367),
    [sym_subscript_expression] = STATE(1367),
    [sym_call_expression] = STATE(1367),
    [sym_field_expression] = STATE(1367),
    [sym_compound_literal_expression] = STATE(1367),
    [sym_parenthesized_expression] = STATE(1367),
    [sym_char_literal] = STATE(1367),
    [sym_concatenated_string] = STATE(1367),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1367),
    [sym_new_expression] = STATE(1367),
    [sym_delete_expression] = STATE(1367),
    [sym_lambda_expression] = STATE(1367),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2873),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(2873),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2875),
    [sym_false] = ACTIONS(2875),
    [sym_null] = ACTIONS(2875),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(2875),
  },
  [689] = {
    [anon_sym_LPAREN2] = ACTIONS(2877),
    [sym_comment] = ACTIONS(91),
  },
  [690] = {
    [sym_compound_statement] = STATE(1369),
    [sym_labeled_statement] = STATE(1369),
    [sym_expression_statement] = STATE(1369),
    [sym_if_statement] = STATE(1369),
    [sym_switch_statement] = STATE(1369),
    [sym_case_statement] = STATE(1369),
    [sym_while_statement] = STATE(1369),
    [sym_do_statement] = STATE(1369),
    [sym_for_statement] = STATE(1369),
    [sym_return_statement] = STATE(1369),
    [sym_break_statement] = STATE(1369),
    [sym_continue_statement] = STATE(1369),
    [sym_goto_statement] = STATE(1369),
    [sym__expression] = STATE(222),
    [sym_comma_expression] = STATE(223),
    [sym_conditional_expression] = STATE(222),
    [sym_assignment_expression] = STATE(222),
    [sym_pointer_expression] = STATE(222),
    [sym_logical_expression] = STATE(222),
    [sym_bitwise_expression] = STATE(222),
    [sym_equality_expression] = STATE(222),
    [sym_relational_expression] = STATE(222),
    [sym_shift_expression] = STATE(222),
    [sym_math_expression] = STATE(222),
    [sym_cast_expression] = STATE(222),
    [sym_sizeof_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_call_expression] = STATE(222),
    [sym_field_expression] = STATE(222),
    [sym_compound_literal_expression] = STATE(222),
    [sym_parenthesized_expression] = STATE(222),
    [sym_char_literal] = STATE(222),
    [sym_concatenated_string] = STATE(222),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(222),
    [sym_for_range_loop] = STATE(1369),
    [sym_try_statement] = STATE(1369),
    [sym_new_expression] = STATE(222),
    [sym_delete_expression] = STATE(222),
    [sym_lambda_expression] = STATE(222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(359),
    [anon_sym_switch] = ACTIONS(361),
    [anon_sym_case] = ACTIONS(363),
    [anon_sym_default] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [anon_sym_do] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(373),
    [anon_sym_break] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_goto] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(353),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_identifier] = ACTIONS(383),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(381),
  },
  [691] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_COLON] = ACTIONS(2879),
    [anon_sym_QMARK] = ACTIONS(1171),
    [anon_sym_STAR_EQ] = ACTIONS(1173),
    [anon_sym_SLASH_EQ] = ACTIONS(1173),
    [anon_sym_PERCENT_EQ] = ACTIONS(1173),
    [anon_sym_PLUS_EQ] = ACTIONS(1173),
    [anon_sym_DASH_EQ] = ACTIONS(1173),
    [anon_sym_LT_LT_EQ] = ACTIONS(1173),
    [anon_sym_GT_GT_EQ] = ACTIONS(1173),
    [anon_sym_AMP_EQ] = ACTIONS(1173),
    [anon_sym_CARET_EQ] = ACTIONS(1173),
    [anon_sym_PIPE_EQ] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_CARET] = ACTIONS(1183),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [692] = {
    [sym_declaration] = STATE(1372),
    [sym_type_definition] = STATE(1372),
    [sym__declaration_specifiers] = STATE(1373),
    [sym_compound_statement] = STATE(1372),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_labeled_statement] = STATE(1372),
    [sym_expression_statement] = STATE(1372),
    [sym_if_statement] = STATE(1372),
    [sym_switch_statement] = STATE(1372),
    [sym_case_statement] = STATE(1372),
    [sym_while_statement] = STATE(1372),
    [sym_do_statement] = STATE(1372),
    [sym_for_statement] = STATE(1372),
    [sym_return_statement] = STATE(1372),
    [sym_break_statement] = STATE(1372),
    [sym_continue_statement] = STATE(1372),
    [sym_goto_statement] = STATE(1372),
    [sym__expression] = STATE(222),
    [sym_comma_expression] = STATE(223),
    [sym_conditional_expression] = STATE(222),
    [sym_assignment_expression] = STATE(222),
    [sym_pointer_expression] = STATE(222),
    [sym_logical_expression] = STATE(222),
    [sym_bitwise_expression] = STATE(222),
    [sym_equality_expression] = STATE(222),
    [sym_relational_expression] = STATE(222),
    [sym_shift_expression] = STATE(222),
    [sym_math_expression] = STATE(222),
    [sym_cast_expression] = STATE(222),
    [sym_sizeof_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_call_expression] = STATE(222),
    [sym_field_expression] = STATE(222),
    [sym_compound_literal_expression] = STATE(222),
    [sym_parenthesized_expression] = STATE(222),
    [sym_char_literal] = STATE(222),
    [sym_concatenated_string] = STATE(222),
    [sym_string_literal] = STATE(55),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(222),
    [sym_for_range_loop] = STATE(1372),
    [sym_try_statement] = STATE(1372),
    [sym_new_expression] = STATE(222),
    [sym_delete_expression] = STATE(222),
    [sym_lambda_expression] = STATE(222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_typedef] = ACTIONS(1023),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(359),
    [anon_sym_switch] = ACTIONS(361),
    [anon_sym_case] = ACTIONS(363),
    [anon_sym_default] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [anon_sym_do] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(373),
    [anon_sym_break] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_goto] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(353),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_identifier] = ACTIONS(2881),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(1202),
    [sym_nullptr] = ACTIONS(381),
  },
  [693] = {
    [sym_compound_statement] = STATE(1374),
    [sym_labeled_statement] = STATE(1374),
    [sym_expression_statement] = STATE(1374),
    [sym_if_statement] = STATE(1374),
    [sym_switch_statement] = STATE(1374),
    [sym_case_statement] = STATE(1374),
    [sym_while_statement] = STATE(1374),
    [sym_do_statement] = STATE(1374),
    [sym_for_statement] = STATE(1374),
    [sym_return_statement] = STATE(1374),
    [sym_break_statement] = STATE(1374),
    [sym_continue_statement] = STATE(1374),
    [sym_goto_statement] = STATE(1374),
    [sym__expression] = STATE(222),
    [sym_comma_expression] = STATE(223),
    [sym_conditional_expression] = STATE(222),
    [sym_assignment_expression] = STATE(222),
    [sym_pointer_expression] = STATE(222),
    [sym_logical_expression] = STATE(222),
    [sym_bitwise_expression] = STATE(222),
    [sym_equality_expression] = STATE(222),
    [sym_relational_expression] = STATE(222),
    [sym_shift_expression] = STATE(222),
    [sym_math_expression] = STATE(222),
    [sym_cast_expression] = STATE(222),
    [sym_sizeof_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_call_expression] = STATE(222),
    [sym_field_expression] = STATE(222),
    [sym_compound_literal_expression] = STATE(222),
    [sym_parenthesized_expression] = STATE(222),
    [sym_char_literal] = STATE(222),
    [sym_concatenated_string] = STATE(222),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(222),
    [sym_for_range_loop] = STATE(1374),
    [sym_try_statement] = STATE(1374),
    [sym_new_expression] = STATE(222),
    [sym_delete_expression] = STATE(222),
    [sym_lambda_expression] = STATE(222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(359),
    [anon_sym_switch] = ACTIONS(361),
    [anon_sym_case] = ACTIONS(363),
    [anon_sym_default] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [anon_sym_do] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(373),
    [anon_sym_break] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_goto] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(353),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_identifier] = ACTIONS(383),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(381),
  },
  [694] = {
    [anon_sym_while] = ACTIONS(2883),
    [sym_comment] = ACTIONS(91),
  },
  [695] = {
    [sym_declaration] = STATE(1376),
    [sym__declaration_specifiers] = STATE(709),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym__expression] = STATE(1377),
    [sym_conditional_expression] = STATE(1377),
    [sym_assignment_expression] = STATE(1377),
    [sym_pointer_expression] = STATE(1377),
    [sym_logical_expression] = STATE(1377),
    [sym_bitwise_expression] = STATE(1377),
    [sym_equality_expression] = STATE(1377),
    [sym_relational_expression] = STATE(1377),
    [sym_shift_expression] = STATE(1377),
    [sym_math_expression] = STATE(1377),
    [sym_cast_expression] = STATE(1377),
    [sym_sizeof_expression] = STATE(1377),
    [sym_subscript_expression] = STATE(1377),
    [sym_call_expression] = STATE(1377),
    [sym_field_expression] = STATE(1377),
    [sym_compound_literal_expression] = STATE(1377),
    [sym_parenthesized_expression] = STATE(1377),
    [sym_char_literal] = STATE(1377),
    [sym_concatenated_string] = STATE(1377),
    [sym_string_literal] = STATE(238),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(1377),
    [sym_for_range_declaration] = STATE(1378),
    [sym_new_expression] = STATE(1377),
    [sym_delete_expression] = STATE(1377),
    [sym_lambda_expression] = STATE(1377),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(2885),
    [anon_sym_SEMI] = ACTIONS(2887),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(2885),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2889),
    [sym_false] = ACTIONS(2889),
    [sym_null] = ACTIONS(2889),
    [sym_identifier] = ACTIONS(1242),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(1244),
    [sym_nullptr] = ACTIONS(2889),
  },
  [696] = {
    [anon_sym_else] = ACTIONS(1246),
    [anon_sym_while] = ACTIONS(1246),
    [sym_comment] = ACTIONS(91),
  },
  [697] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(2891),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [698] = {
    [anon_sym_SEMI] = ACTIONS(2891),
    [sym_comment] = ACTIONS(91),
  },
  [699] = {
    [anon_sym_else] = ACTIONS(1332),
    [anon_sym_while] = ACTIONS(1332),
    [sym_comment] = ACTIONS(91),
  },
  [700] = {
    [anon_sym_else] = ACTIONS(1336),
    [anon_sym_while] = ACTIONS(1336),
    [sym_comment] = ACTIONS(91),
  },
  [701] = {
    [anon_sym_SEMI] = ACTIONS(2893),
    [sym_comment] = ACTIONS(91),
  },
  [702] = {
    [sym_compound_statement] = STATE(1381),
    [sym_labeled_statement] = STATE(1381),
    [sym_expression_statement] = STATE(1381),
    [sym_if_statement] = STATE(1381),
    [sym_switch_statement] = STATE(1381),
    [sym_case_statement] = STATE(1381),
    [sym_while_statement] = STATE(1381),
    [sym_do_statement] = STATE(1381),
    [sym_for_statement] = STATE(1381),
    [sym_return_statement] = STATE(1381),
    [sym_break_statement] = STATE(1381),
    [sym_continue_statement] = STATE(1381),
    [sym_goto_statement] = STATE(1381),
    [sym__expression] = STATE(222),
    [sym_comma_expression] = STATE(223),
    [sym_conditional_expression] = STATE(222),
    [sym_assignment_expression] = STATE(222),
    [sym_pointer_expression] = STATE(222),
    [sym_logical_expression] = STATE(222),
    [sym_bitwise_expression] = STATE(222),
    [sym_equality_expression] = STATE(222),
    [sym_relational_expression] = STATE(222),
    [sym_shift_expression] = STATE(222),
    [sym_math_expression] = STATE(222),
    [sym_cast_expression] = STATE(222),
    [sym_sizeof_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_call_expression] = STATE(222),
    [sym_field_expression] = STATE(222),
    [sym_compound_literal_expression] = STATE(222),
    [sym_parenthesized_expression] = STATE(222),
    [sym_char_literal] = STATE(222),
    [sym_concatenated_string] = STATE(222),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(222),
    [sym_for_range_loop] = STATE(1381),
    [sym_try_statement] = STATE(1381),
    [sym_new_expression] = STATE(222),
    [sym_delete_expression] = STATE(222),
    [sym_lambda_expression] = STATE(222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(359),
    [anon_sym_switch] = ACTIONS(361),
    [anon_sym_case] = ACTIONS(363),
    [anon_sym_default] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [anon_sym_do] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(373),
    [anon_sym_break] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_goto] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(353),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_identifier] = ACTIONS(383),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(381),
  },
  [703] = {
    [sym_catch_clause] = STATE(1383),
    [aux_sym_try_statement_repeat1] = STATE(1383),
    [sym_comment] = ACTIONS(91),
    [anon_sym_catch] = ACTIONS(2895),
  },
  [704] = {
    [sym_parenthesized_expression] = STATE(1385),
    [anon_sym_LPAREN2] = ACTIONS(2897),
    [sym_comment] = ACTIONS(91),
  },
  [705] = {
    [anon_sym_else] = ACTIONS(1697),
    [anon_sym_while] = ACTIONS(1697),
    [sym_comment] = ACTIONS(91),
  },
  [706] = {
    [sym__expression] = STATE(1387),
    [sym_conditional_expression] = STATE(1387),
    [sym_assignment_expression] = STATE(1387),
    [sym_pointer_expression] = STATE(1387),
    [sym_logical_expression] = STATE(1387),
    [sym_bitwise_expression] = STATE(1387),
    [sym_equality_expression] = STATE(1387),
    [sym_relational_expression] = STATE(1387),
    [sym_shift_expression] = STATE(1387),
    [sym_math_expression] = STATE(1387),
    [sym_cast_expression] = STATE(1387),
    [sym_sizeof_expression] = STATE(1387),
    [sym_subscript_expression] = STATE(1387),
    [sym_call_expression] = STATE(1387),
    [sym_field_expression] = STATE(1387),
    [sym_compound_literal_expression] = STATE(1387),
    [sym_parenthesized_expression] = STATE(1387),
    [sym_char_literal] = STATE(1387),
    [sym_concatenated_string] = STATE(1387),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1387),
    [sym_new_expression] = STATE(1387),
    [sym_delete_expression] = STATE(1387),
    [sym_lambda_expression] = STATE(1387),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2899),
    [anon_sym_SEMI] = ACTIONS(2901),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(2899),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2903),
    [sym_false] = ACTIONS(2903),
    [sym_null] = ACTIONS(2903),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(2903),
  },
  [707] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(1362),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_extern] = ACTIONS(468),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(465),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_register] = ACTIONS(468),
    [anon_sym_inline] = ACTIONS(468),
    [anon_sym_const] = ACTIONS(468),
    [anon_sym_restrict] = ACTIONS(468),
    [anon_sym_volatile] = ACTIONS(468),
    [anon_sym__Atomic] = ACTIONS(468),
    [anon_sym_mutable] = ACTIONS(468),
    [anon_sym_explicit] = ACTIONS(468),
    [anon_sym_constexpr] = ACTIONS(468),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(474),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_TILDE] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_identifier] = ACTIONS(468),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(2855),
    [sym_operator_name] = ACTIONS(481),
  },
  [708] = {
    [sym_destructor_name] = STATE(315),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(2857),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1300),
    [sym_operator_name] = ACTIONS(554),
  },
  [709] = {
    [sym__declarator] = STATE(1390),
    [sym_pointer_declarator] = STATE(1390),
    [sym_function_declarator] = STATE(1390),
    [sym_array_declarator] = STATE(1390),
    [sym_init_declarator] = STATE(492),
    [sym_reference_declarator] = STATE(1390),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(1390),
    [sym_destructor_name] = STATE(1390),
    [sym_scoped_identifier] = STATE(1391),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(2905),
    [anon_sym_AMP] = ACTIONS(2907),
    [anon_sym_AMP_AMP] = ACTIONS(2909),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(568),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(2911),
  },
  [710] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(2913),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [711] = {
    [anon_sym_COLON] = ACTIONS(2915),
    [sym_comment] = ACTIONS(91),
  },
  [712] = {
    [anon_sym_RBRACE] = ACTIONS(2917),
    [sym_comment] = ACTIONS(91),
  },
  [713] = {
    [anon_sym_COMMA] = ACTIONS(2919),
    [anon_sym_RPAREN] = ACTIONS(2919),
    [anon_sym_SEMI] = ACTIONS(2919),
    [anon_sym_LBRACE] = ACTIONS(2919),
    [anon_sym_RBRACE] = ACTIONS(2919),
    [anon_sym_LPAREN2] = ACTIONS(2919),
    [anon_sym_STAR] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2919),
    [anon_sym_RBRACK] = ACTIONS(2919),
    [anon_sym_EQ] = ACTIONS(2921),
    [anon_sym_COLON] = ACTIONS(2919),
    [anon_sym_QMARK] = ACTIONS(2919),
    [anon_sym_STAR_EQ] = ACTIONS(2919),
    [anon_sym_SLASH_EQ] = ACTIONS(2919),
    [anon_sym_PERCENT_EQ] = ACTIONS(2919),
    [anon_sym_PLUS_EQ] = ACTIONS(2919),
    [anon_sym_DASH_EQ] = ACTIONS(2919),
    [anon_sym_LT_LT_EQ] = ACTIONS(2919),
    [anon_sym_GT_GT_EQ] = ACTIONS(2919),
    [anon_sym_AMP_EQ] = ACTIONS(2919),
    [anon_sym_CARET_EQ] = ACTIONS(2919),
    [anon_sym_PIPE_EQ] = ACTIONS(2919),
    [anon_sym_AMP] = ACTIONS(2921),
    [anon_sym_PIPE_PIPE] = ACTIONS(2919),
    [anon_sym_AMP_AMP] = ACTIONS(2919),
    [anon_sym_PIPE] = ACTIONS(2921),
    [anon_sym_CARET] = ACTIONS(2921),
    [anon_sym_EQ_EQ] = ACTIONS(2919),
    [anon_sym_BANG_EQ] = ACTIONS(2919),
    [anon_sym_LT] = ACTIONS(2921),
    [anon_sym_GT] = ACTIONS(2921),
    [anon_sym_LT_EQ] = ACTIONS(2919),
    [anon_sym_GT_EQ] = ACTIONS(2919),
    [anon_sym_LT_LT] = ACTIONS(2921),
    [anon_sym_GT_GT] = ACTIONS(2921),
    [anon_sym_PLUS] = ACTIONS(2921),
    [anon_sym_DASH] = ACTIONS(2921),
    [anon_sym_SLASH] = ACTIONS(2921),
    [anon_sym_PERCENT] = ACTIONS(2921),
    [anon_sym_DASH_DASH] = ACTIONS(2919),
    [anon_sym_PLUS_PLUS] = ACTIONS(2919),
    [anon_sym_DOT] = ACTIONS(2919),
    [anon_sym_DASH_GT] = ACTIONS(2919),
    [sym_comment] = ACTIONS(91),
  },
  [714] = {
    [sym_type_qualifier] = STATE(141),
    [sym__type_specifier] = STATE(136),
    [sym_sized_type_specifier] = STATE(136),
    [sym_enum_specifier] = STATE(136),
    [sym_struct_specifier] = STATE(136),
    [sym_union_specifier] = STATE(136),
    [sym__expression] = STATE(137),
    [sym_comma_expression] = STATE(138),
    [sym_conditional_expression] = STATE(137),
    [sym_assignment_expression] = STATE(137),
    [sym_pointer_expression] = STATE(137),
    [sym_logical_expression] = STATE(137),
    [sym_bitwise_expression] = STATE(137),
    [sym_equality_expression] = STATE(137),
    [sym_relational_expression] = STATE(137),
    [sym_shift_expression] = STATE(137),
    [sym_math_expression] = STATE(137),
    [sym_cast_expression] = STATE(137),
    [sym_type_descriptor] = STATE(1395),
    [sym_sizeof_expression] = STATE(137),
    [sym_subscript_expression] = STATE(137),
    [sym_call_expression] = STATE(137),
    [sym_field_expression] = STATE(137),
    [sym_compound_literal_expression] = STATE(137),
    [sym_parenthesized_expression] = STATE(137),
    [sym_char_literal] = STATE(137),
    [sym_concatenated_string] = STATE(137),
    [sym_string_literal] = STATE(140),
    [sym_macro_type_specifier] = STATE(136),
    [sym_class_specifier] = STATE(136),
    [sym_dependent_type] = STATE(136),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(137),
    [sym_new_expression] = STATE(137),
    [sym_delete_expression] = STATE(137),
    [sym_lambda_expression] = STATE(137),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_type_definition_repeat1] = STATE(141),
    [aux_sym_sized_type_specifier_repeat1] = STATE(142),
    [sym_raw_string_literal] = ACTIONS(213),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(219),
    [anon_sym_long] = ACTIONS(219),
    [anon_sym_short] = ACTIONS(219),
    [sym_primitive_type] = ACTIONS(221),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [sym_null] = ACTIONS(241),
    [sym_identifier] = ACTIONS(811),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(221),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(253),
    [sym_nullptr] = ACTIONS(241),
  },
  [715] = {
    [sym__expression] = STATE(146),
    [sym_conditional_expression] = STATE(146),
    [sym_assignment_expression] = STATE(146),
    [sym_pointer_expression] = STATE(146),
    [sym_logical_expression] = STATE(146),
    [sym_bitwise_expression] = STATE(146),
    [sym_equality_expression] = STATE(146),
    [sym_relational_expression] = STATE(146),
    [sym_shift_expression] = STATE(146),
    [sym_math_expression] = STATE(146),
    [sym_cast_expression] = STATE(146),
    [sym_sizeof_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_compound_literal_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_char_literal] = STATE(146),
    [sym_concatenated_string] = STATE(146),
    [sym_string_literal] = STATE(727),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(146),
    [sym_new_expression] = STATE(146),
    [sym_delete_expression] = STATE(146),
    [sym_lambda_expression] = STATE(146),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(257),
    [anon_sym_LPAREN2] = ACTIONS(1256),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(1262),
    [anon_sym_TILDE] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_DASH_DASH] = ACTIONS(1268),
    [anon_sym_PLUS_PLUS] = ACTIONS(1268),
    [anon_sym_sizeof] = ACTIONS(1270),
    [sym_number_literal] = ACTIONS(257),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(259),
    [sym_false] = ACTIONS(259),
    [sym_null] = ACTIONS(259),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1276),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1280),
    [sym_nullptr] = ACTIONS(259),
  },
  [716] = {
    [sym__expression] = STATE(1396),
    [sym_conditional_expression] = STATE(1396),
    [sym_assignment_expression] = STATE(1396),
    [sym_pointer_expression] = STATE(1396),
    [sym_logical_expression] = STATE(1396),
    [sym_bitwise_expression] = STATE(1396),
    [sym_equality_expression] = STATE(1396),
    [sym_relational_expression] = STATE(1396),
    [sym_shift_expression] = STATE(1396),
    [sym_math_expression] = STATE(1396),
    [sym_cast_expression] = STATE(1396),
    [sym_sizeof_expression] = STATE(1396),
    [sym_subscript_expression] = STATE(1396),
    [sym_call_expression] = STATE(1396),
    [sym_field_expression] = STATE(1396),
    [sym_compound_literal_expression] = STATE(1396),
    [sym_parenthesized_expression] = STATE(1396),
    [sym_char_literal] = STATE(1396),
    [sym_concatenated_string] = STATE(1396),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1396),
    [sym_new_expression] = STATE(1396),
    [sym_delete_expression] = STATE(1396),
    [sym_lambda_expression] = STATE(1396),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_lambda_default_capture] = STATE(166),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2923),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(273),
    [anon_sym_EQ] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(2923),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2925),
    [sym_false] = ACTIONS(2925),
    [sym_null] = ACTIONS(2925),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(2925),
  },
  [717] = {
    [sym__expression] = STATE(250),
    [sym_conditional_expression] = STATE(250),
    [sym_assignment_expression] = STATE(250),
    [sym_pointer_expression] = STATE(250),
    [sym_logical_expression] = STATE(250),
    [sym_bitwise_expression] = STATE(250),
    [sym_equality_expression] = STATE(250),
    [sym_relational_expression] = STATE(250),
    [sym_shift_expression] = STATE(250),
    [sym_math_expression] = STATE(250),
    [sym_cast_expression] = STATE(250),
    [sym_sizeof_expression] = STATE(250),
    [sym_subscript_expression] = STATE(250),
    [sym_call_expression] = STATE(250),
    [sym_field_expression] = STATE(250),
    [sym_compound_literal_expression] = STATE(250),
    [sym_parenthesized_expression] = STATE(250),
    [sym_char_literal] = STATE(250),
    [sym_concatenated_string] = STATE(250),
    [sym_string_literal] = STATE(727),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(250),
    [sym_new_expression] = STATE(250),
    [sym_delete_expression] = STATE(250),
    [sym_lambda_expression] = STATE(250),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(435),
    [anon_sym_LPAREN2] = ACTIONS(1256),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(1262),
    [anon_sym_TILDE] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_DASH_DASH] = ACTIONS(1268),
    [anon_sym_PLUS_PLUS] = ACTIONS(1268),
    [anon_sym_sizeof] = ACTIONS(1270),
    [sym_number_literal] = ACTIONS(435),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(437),
    [sym_false] = ACTIONS(437),
    [sym_null] = ACTIONS(437),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1276),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1280),
    [sym_nullptr] = ACTIONS(437),
  },
  [718] = {
    [sym__expression] = STATE(252),
    [sym_conditional_expression] = STATE(252),
    [sym_assignment_expression] = STATE(252),
    [sym_pointer_expression] = STATE(252),
    [sym_logical_expression] = STATE(252),
    [sym_bitwise_expression] = STATE(252),
    [sym_equality_expression] = STATE(252),
    [sym_relational_expression] = STATE(252),
    [sym_shift_expression] = STATE(252),
    [sym_math_expression] = STATE(252),
    [sym_cast_expression] = STATE(252),
    [sym_sizeof_expression] = STATE(252),
    [sym_subscript_expression] = STATE(252),
    [sym_call_expression] = STATE(252),
    [sym_field_expression] = STATE(252),
    [sym_compound_literal_expression] = STATE(252),
    [sym_parenthesized_expression] = STATE(252),
    [sym_char_literal] = STATE(252),
    [sym_concatenated_string] = STATE(252),
    [sym_string_literal] = STATE(727),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(252),
    [sym_new_expression] = STATE(252),
    [sym_delete_expression] = STATE(252),
    [sym_lambda_expression] = STATE(252),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(439),
    [anon_sym_LPAREN2] = ACTIONS(1256),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(1262),
    [anon_sym_TILDE] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_DASH_DASH] = ACTIONS(1268),
    [anon_sym_PLUS_PLUS] = ACTIONS(1268),
    [anon_sym_sizeof] = ACTIONS(1270),
    [sym_number_literal] = ACTIONS(439),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(441),
    [sym_false] = ACTIONS(441),
    [sym_null] = ACTIONS(441),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1276),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1280),
    [sym_nullptr] = ACTIONS(441),
  },
  [719] = {
    [sym__expression] = STATE(253),
    [sym_conditional_expression] = STATE(253),
    [sym_assignment_expression] = STATE(253),
    [sym_pointer_expression] = STATE(253),
    [sym_logical_expression] = STATE(253),
    [sym_bitwise_expression] = STATE(253),
    [sym_equality_expression] = STATE(253),
    [sym_relational_expression] = STATE(253),
    [sym_shift_expression] = STATE(253),
    [sym_math_expression] = STATE(253),
    [sym_cast_expression] = STATE(253),
    [sym_sizeof_expression] = STATE(253),
    [sym_subscript_expression] = STATE(253),
    [sym_call_expression] = STATE(253),
    [sym_field_expression] = STATE(253),
    [sym_compound_literal_expression] = STATE(253),
    [sym_parenthesized_expression] = STATE(253),
    [sym_char_literal] = STATE(253),
    [sym_concatenated_string] = STATE(253),
    [sym_string_literal] = STATE(727),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(253),
    [sym_new_expression] = STATE(253),
    [sym_delete_expression] = STATE(253),
    [sym_lambda_expression] = STATE(253),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(445),
    [anon_sym_LPAREN2] = ACTIONS(1256),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(1262),
    [anon_sym_TILDE] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_DASH_DASH] = ACTIONS(1268),
    [anon_sym_PLUS_PLUS] = ACTIONS(1268),
    [anon_sym_sizeof] = ACTIONS(1270),
    [sym_number_literal] = ACTIONS(445),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(447),
    [sym_false] = ACTIONS(447),
    [sym_null] = ACTIONS(447),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1276),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1280),
    [sym_nullptr] = ACTIONS(447),
  },
  [720] = {
    [sym__expression] = STATE(1398),
    [sym_conditional_expression] = STATE(1398),
    [sym_assignment_expression] = STATE(1398),
    [sym_pointer_expression] = STATE(1398),
    [sym_logical_expression] = STATE(1398),
    [sym_bitwise_expression] = STATE(1398),
    [sym_equality_expression] = STATE(1398),
    [sym_relational_expression] = STATE(1398),
    [sym_shift_expression] = STATE(1398),
    [sym_math_expression] = STATE(1398),
    [sym_cast_expression] = STATE(1398),
    [sym_sizeof_expression] = STATE(1398),
    [sym_subscript_expression] = STATE(1398),
    [sym_call_expression] = STATE(1398),
    [sym_field_expression] = STATE(1398),
    [sym_compound_literal_expression] = STATE(1398),
    [sym_parenthesized_expression] = STATE(1398),
    [sym_char_literal] = STATE(1398),
    [sym_concatenated_string] = STATE(1398),
    [sym_string_literal] = STATE(727),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1398),
    [sym_new_expression] = STATE(1398),
    [sym_delete_expression] = STATE(1398),
    [sym_lambda_expression] = STATE(1398),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2927),
    [anon_sym_LPAREN2] = ACTIONS(2929),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(1262),
    [anon_sym_TILDE] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_DASH_DASH] = ACTIONS(1268),
    [anon_sym_PLUS_PLUS] = ACTIONS(1268),
    [anon_sym_sizeof] = ACTIONS(1270),
    [sym_number_literal] = ACTIONS(2927),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2931),
    [sym_false] = ACTIONS(2931),
    [sym_null] = ACTIONS(2931),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1276),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1280),
    [sym_nullptr] = ACTIONS(2931),
  },
  [721] = {
    [sym_identifier] = ACTIONS(2933),
    [sym_comment] = ACTIONS(91),
  },
  [722] = {
    [sym__expression] = STATE(1401),
    [sym_conditional_expression] = STATE(1401),
    [sym_assignment_expression] = STATE(1401),
    [sym_pointer_expression] = STATE(1401),
    [sym_logical_expression] = STATE(1401),
    [sym_bitwise_expression] = STATE(1401),
    [sym_equality_expression] = STATE(1401),
    [sym_relational_expression] = STATE(1401),
    [sym_shift_expression] = STATE(1401),
    [sym_math_expression] = STATE(1401),
    [sym_cast_expression] = STATE(1401),
    [sym_sizeof_expression] = STATE(1401),
    [sym_subscript_expression] = STATE(1401),
    [sym_call_expression] = STATE(1401),
    [sym_field_expression] = STATE(1401),
    [sym_compound_literal_expression] = STATE(1401),
    [sym_parenthesized_expression] = STATE(1401),
    [sym_char_literal] = STATE(1401),
    [sym_concatenated_string] = STATE(1401),
    [sym_string_literal] = STATE(727),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1401),
    [sym_new_expression] = STATE(1401),
    [sym_delete_expression] = STATE(1401),
    [sym_lambda_expression] = STATE(1401),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2935),
    [anon_sym_LPAREN2] = ACTIONS(1256),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_LBRACK] = ACTIONS(2937),
    [anon_sym_AMP] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(1262),
    [anon_sym_TILDE] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_DASH_DASH] = ACTIONS(1268),
    [anon_sym_PLUS_PLUS] = ACTIONS(1268),
    [anon_sym_sizeof] = ACTIONS(1270),
    [sym_number_literal] = ACTIONS(2935),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2939),
    [sym_false] = ACTIONS(2939),
    [sym_null] = ACTIONS(2939),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1276),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1280),
    [sym_nullptr] = ACTIONS(2939),
  },
  [723] = {
    [sym__type_specifier] = STATE(1403),
    [sym_sized_type_specifier] = STATE(1403),
    [sym_enum_specifier] = STATE(1403),
    [sym_struct_specifier] = STATE(1403),
    [sym_union_specifier] = STATE(1403),
    [sym_argument_list] = STATE(1404),
    [sym_macro_type_specifier] = STATE(1403),
    [sym_class_specifier] = STATE(1403),
    [sym_dependent_type] = STATE(1403),
    [sym_template_type] = STATE(309),
    [sym_scoped_type_identifier] = STATE(310),
    [sym_scoped_namespace_identifier] = STATE(311),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1405),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_unsigned] = ACTIONS(2941),
    [anon_sym_long] = ACTIONS(2941),
    [anon_sym_short] = ACTIONS(2941),
    [sym_primitive_type] = ACTIONS(2943),
    [anon_sym_enum] = ACTIONS(536),
    [anon_sym_struct] = ACTIONS(538),
    [anon_sym_union] = ACTIONS(540),
    [sym_identifier] = ACTIONS(542),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(544),
    [sym_auto] = ACTIONS(2943),
    [anon_sym_typename] = ACTIONS(2945),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [724] = {
    [sym_destructor_name] = STATE(315),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(937),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(2947),
    [sym_operator_name] = ACTIONS(554),
  },
  [725] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_initializer_list_repeat1] = STATE(1420),
    [anon_sym_COMMA] = ACTIONS(2949),
    [anon_sym_RBRACE] = ACTIONS(2917),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2953),
    [anon_sym_QMARK] = ACTIONS(2955),
    [anon_sym_STAR_EQ] = ACTIONS(2957),
    [anon_sym_SLASH_EQ] = ACTIONS(2957),
    [anon_sym_PERCENT_EQ] = ACTIONS(2957),
    [anon_sym_PLUS_EQ] = ACTIONS(2957),
    [anon_sym_DASH_EQ] = ACTIONS(2957),
    [anon_sym_LT_LT_EQ] = ACTIONS(2957),
    [anon_sym_GT_GT_EQ] = ACTIONS(2957),
    [anon_sym_AMP_EQ] = ACTIONS(2957),
    [anon_sym_CARET_EQ] = ACTIONS(2957),
    [anon_sym_PIPE_EQ] = ACTIONS(2957),
    [anon_sym_AMP] = ACTIONS(2959),
    [anon_sym_PIPE_PIPE] = ACTIONS(2961),
    [anon_sym_AMP_AMP] = ACTIONS(2963),
    [anon_sym_PIPE] = ACTIONS(2965),
    [anon_sym_CARET] = ACTIONS(2967),
    [anon_sym_EQ_EQ] = ACTIONS(2969),
    [anon_sym_BANG_EQ] = ACTIONS(2969),
    [anon_sym_LT] = ACTIONS(2971),
    [anon_sym_GT] = ACTIONS(2971),
    [anon_sym_LT_EQ] = ACTIONS(2973),
    [anon_sym_GT_EQ] = ACTIONS(2973),
    [anon_sym_LT_LT] = ACTIONS(2975),
    [anon_sym_GT_GT] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_SLASH] = ACTIONS(2951),
    [anon_sym_PERCENT] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [726] = {
    [aux_sym_initializer_list_repeat1] = STATE(1420),
    [anon_sym_COMMA] = ACTIONS(2949),
    [anon_sym_RBRACE] = ACTIONS(2917),
    [sym_comment] = ACTIONS(91),
  },
  [727] = {
    [sym_string_literal] = STATE(1421),
    [aux_sym_concatenated_string_repeat1] = STATE(1421),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_RBRACE] = ACTIONS(463),
    [anon_sym_LPAREN2] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(91),
  },
  [728] = {
    [sym_subscript_designator] = STATE(1424),
    [sym_field_designator] = STATE(1424),
    [aux_sym_initializer_pair_repeat1] = STATE(1424),
    [anon_sym_LBRACK] = ACTIONS(2979),
    [anon_sym_EQ] = ACTIONS(2981),
    [anon_sym_DOT] = ACTIONS(1272),
    [sym_comment] = ACTIONS(91),
  },
  [729] = {
    [anon_sym_RPAREN] = ACTIONS(2983),
    [sym_comment] = ACTIONS(91),
  },
  [730] = {
    [sym_type_qualifier] = STATE(141),
    [sym__type_specifier] = STATE(136),
    [sym_sized_type_specifier] = STATE(136),
    [sym_enum_specifier] = STATE(136),
    [sym_struct_specifier] = STATE(136),
    [sym_union_specifier] = STATE(136),
    [sym__expression] = STATE(137),
    [sym_comma_expression] = STATE(138),
    [sym_conditional_expression] = STATE(137),
    [sym_assignment_expression] = STATE(137),
    [sym_pointer_expression] = STATE(137),
    [sym_logical_expression] = STATE(137),
    [sym_bitwise_expression] = STATE(137),
    [sym_equality_expression] = STATE(137),
    [sym_relational_expression] = STATE(137),
    [sym_shift_expression] = STATE(137),
    [sym_math_expression] = STATE(137),
    [sym_cast_expression] = STATE(137),
    [sym_type_descriptor] = STATE(1426),
    [sym_sizeof_expression] = STATE(137),
    [sym_subscript_expression] = STATE(137),
    [sym_call_expression] = STATE(137),
    [sym_field_expression] = STATE(137),
    [sym_compound_literal_expression] = STATE(137),
    [sym_parenthesized_expression] = STATE(137),
    [sym_char_literal] = STATE(137),
    [sym_concatenated_string] = STATE(137),
    [sym_string_literal] = STATE(140),
    [sym_macro_type_specifier] = STATE(136),
    [sym_class_specifier] = STATE(136),
    [sym_dependent_type] = STATE(136),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(137),
    [sym_new_expression] = STATE(137),
    [sym_delete_expression] = STATE(137),
    [sym_lambda_expression] = STATE(137),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_type_definition_repeat1] = STATE(141),
    [aux_sym_sized_type_specifier_repeat1] = STATE(142),
    [sym_raw_string_literal] = ACTIONS(213),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(219),
    [anon_sym_long] = ACTIONS(219),
    [anon_sym_short] = ACTIONS(219),
    [sym_primitive_type] = ACTIONS(221),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [sym_null] = ACTIONS(241),
    [sym_identifier] = ACTIONS(811),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(221),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(253),
    [sym_nullptr] = ACTIONS(241),
  },
  [731] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(1364),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1366),
    [anon_sym_QMARK] = ACTIONS(1364),
    [anon_sym_STAR_EQ] = ACTIONS(1364),
    [anon_sym_SLASH_EQ] = ACTIONS(1364),
    [anon_sym_PERCENT_EQ] = ACTIONS(1364),
    [anon_sym_PLUS_EQ] = ACTIONS(1364),
    [anon_sym_DASH_EQ] = ACTIONS(1364),
    [anon_sym_LT_LT_EQ] = ACTIONS(1364),
    [anon_sym_GT_GT_EQ] = ACTIONS(1364),
    [anon_sym_AMP_EQ] = ACTIONS(1364),
    [anon_sym_CARET_EQ] = ACTIONS(1364),
    [anon_sym_PIPE_EQ] = ACTIONS(1364),
    [anon_sym_AMP] = ACTIONS(1366),
    [anon_sym_PIPE_PIPE] = ACTIONS(1364),
    [anon_sym_AMP_AMP] = ACTIONS(1364),
    [anon_sym_PIPE] = ACTIONS(1366),
    [anon_sym_CARET] = ACTIONS(1366),
    [anon_sym_EQ_EQ] = ACTIONS(1364),
    [anon_sym_BANG_EQ] = ACTIONS(1364),
    [anon_sym_LT] = ACTIONS(1366),
    [anon_sym_GT] = ACTIONS(1366),
    [anon_sym_LT_EQ] = ACTIONS(1364),
    [anon_sym_GT_EQ] = ACTIONS(1364),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [732] = {
    [sym__expression] = STATE(164),
    [sym_conditional_expression] = STATE(164),
    [sym_assignment_expression] = STATE(164),
    [sym_pointer_expression] = STATE(164),
    [sym_logical_expression] = STATE(164),
    [sym_bitwise_expression] = STATE(164),
    [sym_equality_expression] = STATE(164),
    [sym_relational_expression] = STATE(164),
    [sym_shift_expression] = STATE(164),
    [sym_math_expression] = STATE(164),
    [sym_cast_expression] = STATE(164),
    [sym_sizeof_expression] = STATE(164),
    [sym_subscript_expression] = STATE(164),
    [sym_call_expression] = STATE(164),
    [sym_field_expression] = STATE(164),
    [sym_compound_literal_expression] = STATE(164),
    [sym_parenthesized_expression] = STATE(164),
    [sym_char_literal] = STATE(164),
    [sym_concatenated_string] = STATE(164),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(164),
    [sym_new_expression] = STATE(164),
    [sym_delete_expression] = STATE(164),
    [sym_lambda_expression] = STATE(164),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_lambda_default_capture] = STATE(166),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(267),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(2985),
    [anon_sym_EQ] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(267),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(289),
    [sym_false] = ACTIONS(289),
    [sym_null] = ACTIONS(289),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(289),
  },
  [733] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(1489),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1491),
    [anon_sym_QMARK] = ACTIONS(1489),
    [anon_sym_STAR_EQ] = ACTIONS(1489),
    [anon_sym_SLASH_EQ] = ACTIONS(1489),
    [anon_sym_PERCENT_EQ] = ACTIONS(1489),
    [anon_sym_PLUS_EQ] = ACTIONS(1489),
    [anon_sym_DASH_EQ] = ACTIONS(1489),
    [anon_sym_LT_LT_EQ] = ACTIONS(1489),
    [anon_sym_GT_GT_EQ] = ACTIONS(1489),
    [anon_sym_AMP_EQ] = ACTIONS(1489),
    [anon_sym_CARET_EQ] = ACTIONS(1489),
    [anon_sym_PIPE_EQ] = ACTIONS(1489),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [734] = {
    [sym__type_specifier] = STATE(871),
    [sym_sized_type_specifier] = STATE(871),
    [sym_enum_specifier] = STATE(871),
    [sym_struct_specifier] = STATE(871),
    [sym_union_specifier] = STATE(871),
    [sym_macro_type_specifier] = STATE(871),
    [sym_class_specifier] = STATE(871),
    [sym_dependent_type] = STATE(871),
    [sym_template_type] = STATE(309),
    [sym_scoped_type_identifier] = STATE(310),
    [sym_scoped_namespace_identifier] = STATE(311),
    [aux_sym_sized_type_specifier_repeat1] = STATE(737),
    [anon_sym_unsigned] = ACTIONS(1294),
    [anon_sym_long] = ACTIONS(1294),
    [anon_sym_short] = ACTIONS(1294),
    [sym_primitive_type] = ACTIONS(1552),
    [anon_sym_enum] = ACTIONS(536),
    [anon_sym_struct] = ACTIONS(538),
    [anon_sym_union] = ACTIONS(540),
    [sym_identifier] = ACTIONS(542),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(544),
    [sym_auto] = ACTIONS(1552),
    [anon_sym_typename] = ACTIONS(1298),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [735] = {
    [sym_argument_list] = STATE(874),
    [sym_initializer_list] = STATE(874),
    [sym_new_declarator] = STATE(875),
    [anon_sym_SEMI] = ACTIONS(1556),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1558),
    [anon_sym_LBRACK] = ACTIONS(2987),
    [anon_sym_EQ] = ACTIONS(1558),
    [anon_sym_QMARK] = ACTIONS(1556),
    [anon_sym_STAR_EQ] = ACTIONS(1556),
    [anon_sym_SLASH_EQ] = ACTIONS(1556),
    [anon_sym_PERCENT_EQ] = ACTIONS(1556),
    [anon_sym_PLUS_EQ] = ACTIONS(1556),
    [anon_sym_DASH_EQ] = ACTIONS(1556),
    [anon_sym_LT_LT_EQ] = ACTIONS(1556),
    [anon_sym_GT_GT_EQ] = ACTIONS(1556),
    [anon_sym_AMP_EQ] = ACTIONS(1556),
    [anon_sym_CARET_EQ] = ACTIONS(1556),
    [anon_sym_PIPE_EQ] = ACTIONS(1556),
    [anon_sym_AMP] = ACTIONS(1558),
    [anon_sym_PIPE_PIPE] = ACTIONS(1556),
    [anon_sym_AMP_AMP] = ACTIONS(1556),
    [anon_sym_PIPE] = ACTIONS(1558),
    [anon_sym_CARET] = ACTIONS(1558),
    [anon_sym_EQ_EQ] = ACTIONS(1556),
    [anon_sym_BANG_EQ] = ACTIONS(1556),
    [anon_sym_LT] = ACTIONS(1558),
    [anon_sym_GT] = ACTIONS(1558),
    [anon_sym_LT_EQ] = ACTIONS(1556),
    [anon_sym_GT_EQ] = ACTIONS(1556),
    [anon_sym_LT_LT] = ACTIONS(1558),
    [anon_sym_GT_GT] = ACTIONS(1558),
    [anon_sym_PLUS] = ACTIONS(1558),
    [anon_sym_DASH] = ACTIONS(1558),
    [anon_sym_SLASH] = ACTIONS(1558),
    [anon_sym_PERCENT] = ACTIONS(1558),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DOT] = ACTIONS(1556),
    [anon_sym_DASH_GT] = ACTIONS(1556),
    [sym_comment] = ACTIONS(91),
  },
  [736] = {
    [sym__type_specifier] = STATE(1429),
    [sym_sized_type_specifier] = STATE(1429),
    [sym_enum_specifier] = STATE(1429),
    [sym_struct_specifier] = STATE(1429),
    [sym_union_specifier] = STATE(1429),
    [sym_macro_type_specifier] = STATE(1429),
    [sym_class_specifier] = STATE(1429),
    [sym_dependent_type] = STATE(1429),
    [sym_template_type] = STATE(309),
    [sym_scoped_type_identifier] = STATE(310),
    [sym_scoped_namespace_identifier] = STATE(311),
    [aux_sym_sized_type_specifier_repeat1] = STATE(737),
    [anon_sym_unsigned] = ACTIONS(1294),
    [anon_sym_long] = ACTIONS(1294),
    [anon_sym_short] = ACTIONS(1294),
    [sym_primitive_type] = ACTIONS(2989),
    [anon_sym_enum] = ACTIONS(536),
    [anon_sym_struct] = ACTIONS(538),
    [anon_sym_union] = ACTIONS(540),
    [sym_identifier] = ACTIONS(542),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(544),
    [sym_auto] = ACTIONS(2989),
    [anon_sym_typename] = ACTIONS(1298),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [737] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1430),
    [anon_sym_SEMI] = ACTIONS(653),
    [anon_sym_LBRACE] = ACTIONS(653),
    [anon_sym_LPAREN2] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_EQ] = ACTIONS(655),
    [anon_sym_unsigned] = ACTIONS(2991),
    [anon_sym_long] = ACTIONS(2991),
    [anon_sym_short] = ACTIONS(2991),
    [sym_primitive_type] = ACTIONS(1571),
    [anon_sym_QMARK] = ACTIONS(653),
    [anon_sym_STAR_EQ] = ACTIONS(653),
    [anon_sym_SLASH_EQ] = ACTIONS(653),
    [anon_sym_PERCENT_EQ] = ACTIONS(653),
    [anon_sym_PLUS_EQ] = ACTIONS(653),
    [anon_sym_DASH_EQ] = ACTIONS(653),
    [anon_sym_LT_LT_EQ] = ACTIONS(653),
    [anon_sym_GT_GT_EQ] = ACTIONS(653),
    [anon_sym_AMP_EQ] = ACTIONS(653),
    [anon_sym_CARET_EQ] = ACTIONS(653),
    [anon_sym_PIPE_EQ] = ACTIONS(653),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_PIPE_PIPE] = ACTIONS(653),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(655),
    [anon_sym_EQ_EQ] = ACTIONS(653),
    [anon_sym_BANG_EQ] = ACTIONS(653),
    [anon_sym_LT] = ACTIONS(655),
    [anon_sym_GT] = ACTIONS(655),
    [anon_sym_LT_EQ] = ACTIONS(653),
    [anon_sym_GT_EQ] = ACTIONS(653),
    [anon_sym_LT_LT] = ACTIONS(655),
    [anon_sym_GT_GT] = ACTIONS(655),
    [anon_sym_PLUS] = ACTIONS(655),
    [anon_sym_DASH] = ACTIONS(655),
    [anon_sym_SLASH] = ACTIONS(655),
    [anon_sym_PERCENT] = ACTIONS(655),
    [anon_sym_DASH_DASH] = ACTIONS(653),
    [anon_sym_PLUS_PLUS] = ACTIONS(653),
    [anon_sym_DOT] = ACTIONS(653),
    [anon_sym_DASH_GT] = ACTIONS(653),
    [sym_identifier] = ACTIONS(1573),
    [sym_comment] = ACTIONS(91),
  },
  [738] = {
    [sym__expression] = STATE(1432),
    [sym_conditional_expression] = STATE(1432),
    [sym_assignment_expression] = STATE(1432),
    [sym_pointer_expression] = STATE(1432),
    [sym_logical_expression] = STATE(1432),
    [sym_bitwise_expression] = STATE(1432),
    [sym_equality_expression] = STATE(1432),
    [sym_relational_expression] = STATE(1432),
    [sym_shift_expression] = STATE(1432),
    [sym_math_expression] = STATE(1432),
    [sym_cast_expression] = STATE(1432),
    [sym_sizeof_expression] = STATE(1432),
    [sym_subscript_expression] = STATE(1432),
    [sym_call_expression] = STATE(1432),
    [sym_field_expression] = STATE(1432),
    [sym_compound_literal_expression] = STATE(1432),
    [sym_parenthesized_expression] = STATE(1432),
    [sym_char_literal] = STATE(1432),
    [sym_concatenated_string] = STATE(1432),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1432),
    [sym_new_expression] = STATE(1432),
    [sym_delete_expression] = STATE(1432),
    [sym_lambda_expression] = STATE(1432),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2993),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(2993),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2997),
    [sym_false] = ACTIONS(2997),
    [sym_null] = ACTIONS(2997),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(2997),
  },
  [739] = {
    [sym_raw_string_literal] = ACTIONS(2999),
    [ts_builtin_sym_end] = ACTIONS(2999),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3001),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3001),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3001),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3001),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3001),
    [sym_preproc_directive] = ACTIONS(3001),
    [anon_sym_SEMI] = ACTIONS(2999),
    [anon_sym_typedef] = ACTIONS(3001),
    [anon_sym_extern] = ACTIONS(3001),
    [anon_sym_LBRACE] = ACTIONS(2999),
    [anon_sym_RBRACE] = ACTIONS(2999),
    [anon_sym_LPAREN2] = ACTIONS(2999),
    [anon_sym_STAR] = ACTIONS(2999),
    [anon_sym_LBRACK] = ACTIONS(2999),
    [anon_sym_static] = ACTIONS(3001),
    [anon_sym_register] = ACTIONS(3001),
    [anon_sym_inline] = ACTIONS(3001),
    [anon_sym_const] = ACTIONS(3001),
    [anon_sym_restrict] = ACTIONS(3001),
    [anon_sym_volatile] = ACTIONS(3001),
    [anon_sym__Atomic] = ACTIONS(3001),
    [anon_sym_mutable] = ACTIONS(3001),
    [anon_sym_explicit] = ACTIONS(3001),
    [anon_sym_constexpr] = ACTIONS(3001),
    [anon_sym_unsigned] = ACTIONS(3001),
    [anon_sym_long] = ACTIONS(3001),
    [anon_sym_short] = ACTIONS(3001),
    [sym_primitive_type] = ACTIONS(3001),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_struct] = ACTIONS(3001),
    [anon_sym_union] = ACTIONS(3001),
    [anon_sym_if] = ACTIONS(3001),
    [anon_sym_else] = ACTIONS(3001),
    [anon_sym_switch] = ACTIONS(3001),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3001),
    [anon_sym_while] = ACTIONS(3001),
    [anon_sym_do] = ACTIONS(3001),
    [anon_sym_for] = ACTIONS(3001),
    [anon_sym_return] = ACTIONS(3001),
    [anon_sym_break] = ACTIONS(3001),
    [anon_sym_continue] = ACTIONS(3001),
    [anon_sym_goto] = ACTIONS(3001),
    [anon_sym_AMP] = ACTIONS(3001),
    [anon_sym_AMP_AMP] = ACTIONS(2999),
    [anon_sym_BANG] = ACTIONS(2999),
    [anon_sym_TILDE] = ACTIONS(2999),
    [anon_sym_PLUS] = ACTIONS(3001),
    [anon_sym_DASH] = ACTIONS(3001),
    [anon_sym_DASH_DASH] = ACTIONS(2999),
    [anon_sym_PLUS_PLUS] = ACTIONS(2999),
    [anon_sym_sizeof] = ACTIONS(3001),
    [sym_number_literal] = ACTIONS(2999),
    [anon_sym_SQUOTE] = ACTIONS(2999),
    [anon_sym_DQUOTE] = ACTIONS(2999),
    [sym_true] = ACTIONS(3001),
    [sym_false] = ACTIONS(3001),
    [sym_null] = ACTIONS(3001),
    [sym_identifier] = ACTIONS(3001),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3001),
    [sym_auto] = ACTIONS(3001),
    [anon_sym_typename] = ACTIONS(3001),
    [anon_sym_template] = ACTIONS(3001),
    [anon_sym_delete] = ACTIONS(3001),
    [anon_sym_namespace] = ACTIONS(3001),
    [anon_sym_using] = ACTIONS(3001),
    [anon_sym_try] = ACTIONS(3001),
    [anon_sym_new] = ACTIONS(3001),
    [anon_sym_COLON_COLON] = ACTIONS(2999),
    [sym_operator_name] = ACTIONS(2999),
    [sym_nullptr] = ACTIONS(3001),
  },
  [740] = {
    [sym__expression] = STATE(938),
    [sym_conditional_expression] = STATE(938),
    [sym_assignment_expression] = STATE(938),
    [sym_pointer_expression] = STATE(938),
    [sym_logical_expression] = STATE(938),
    [sym_bitwise_expression] = STATE(938),
    [sym_equality_expression] = STATE(938),
    [sym_relational_expression] = STATE(938),
    [sym_shift_expression] = STATE(938),
    [sym_math_expression] = STATE(938),
    [sym_cast_expression] = STATE(938),
    [sym_sizeof_expression] = STATE(938),
    [sym_subscript_expression] = STATE(938),
    [sym_call_expression] = STATE(938),
    [sym_field_expression] = STATE(938),
    [sym_compound_literal_expression] = STATE(938),
    [sym_parenthesized_expression] = STATE(938),
    [sym_char_literal] = STATE(938),
    [sym_concatenated_string] = STATE(938),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(938),
    [sym_new_expression] = STATE(938),
    [sym_delete_expression] = STATE(938),
    [sym_lambda_expression] = STATE(938),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(1701),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(1701),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(1703),
    [sym_false] = ACTIONS(1703),
    [sym_null] = ACTIONS(1703),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(1703),
  },
  [741] = {
    [sym__expression] = STATE(1433),
    [sym_conditional_expression] = STATE(1433),
    [sym_assignment_expression] = STATE(1433),
    [sym_pointer_expression] = STATE(1433),
    [sym_logical_expression] = STATE(1433),
    [sym_bitwise_expression] = STATE(1433),
    [sym_equality_expression] = STATE(1433),
    [sym_relational_expression] = STATE(1433),
    [sym_shift_expression] = STATE(1433),
    [sym_math_expression] = STATE(1433),
    [sym_cast_expression] = STATE(1433),
    [sym_sizeof_expression] = STATE(1433),
    [sym_subscript_expression] = STATE(1433),
    [sym_call_expression] = STATE(1433),
    [sym_field_expression] = STATE(1433),
    [sym_compound_literal_expression] = STATE(1433),
    [sym_parenthesized_expression] = STATE(1433),
    [sym_char_literal] = STATE(1433),
    [sym_concatenated_string] = STATE(1433),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1433),
    [sym_new_expression] = STATE(1433),
    [sym_delete_expression] = STATE(1433),
    [sym_lambda_expression] = STATE(1433),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3003),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(3003),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(3005),
    [sym_false] = ACTIONS(3005),
    [sym_null] = ACTIONS(3005),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(3005),
  },
  [742] = {
    [sym__expression] = STATE(1434),
    [sym_conditional_expression] = STATE(1434),
    [sym_assignment_expression] = STATE(1434),
    [sym_pointer_expression] = STATE(1434),
    [sym_logical_expression] = STATE(1434),
    [sym_bitwise_expression] = STATE(1434),
    [sym_equality_expression] = STATE(1434),
    [sym_relational_expression] = STATE(1434),
    [sym_shift_expression] = STATE(1434),
    [sym_math_expression] = STATE(1434),
    [sym_cast_expression] = STATE(1434),
    [sym_sizeof_expression] = STATE(1434),
    [sym_subscript_expression] = STATE(1434),
    [sym_call_expression] = STATE(1434),
    [sym_field_expression] = STATE(1434),
    [sym_compound_literal_expression] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1434),
    [sym_char_literal] = STATE(1434),
    [sym_concatenated_string] = STATE(1434),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1434),
    [sym_new_expression] = STATE(1434),
    [sym_delete_expression] = STATE(1434),
    [sym_lambda_expression] = STATE(1434),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3007),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(3007),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(3009),
    [sym_false] = ACTIONS(3009),
    [sym_null] = ACTIONS(3009),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(3009),
  },
  [743] = {
    [sym__expression] = STATE(1435),
    [sym_conditional_expression] = STATE(1435),
    [sym_assignment_expression] = STATE(1435),
    [sym_pointer_expression] = STATE(1435),
    [sym_logical_expression] = STATE(1435),
    [sym_bitwise_expression] = STATE(1435),
    [sym_equality_expression] = STATE(1435),
    [sym_relational_expression] = STATE(1435),
    [sym_shift_expression] = STATE(1435),
    [sym_math_expression] = STATE(1435),
    [sym_cast_expression] = STATE(1435),
    [sym_sizeof_expression] = STATE(1435),
    [sym_subscript_expression] = STATE(1435),
    [sym_call_expression] = STATE(1435),
    [sym_field_expression] = STATE(1435),
    [sym_compound_literal_expression] = STATE(1435),
    [sym_parenthesized_expression] = STATE(1435),
    [sym_char_literal] = STATE(1435),
    [sym_concatenated_string] = STATE(1435),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1435),
    [sym_new_expression] = STATE(1435),
    [sym_delete_expression] = STATE(1435),
    [sym_lambda_expression] = STATE(1435),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3011),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(3011),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(3013),
    [sym_false] = ACTIONS(3013),
    [sym_null] = ACTIONS(3013),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(3013),
  },
  [744] = {
    [sym__expression] = STATE(1436),
    [sym_conditional_expression] = STATE(1436),
    [sym_assignment_expression] = STATE(1436),
    [sym_pointer_expression] = STATE(1436),
    [sym_logical_expression] = STATE(1436),
    [sym_bitwise_expression] = STATE(1436),
    [sym_equality_expression] = STATE(1436),
    [sym_relational_expression] = STATE(1436),
    [sym_shift_expression] = STATE(1436),
    [sym_math_expression] = STATE(1436),
    [sym_cast_expression] = STATE(1436),
    [sym_sizeof_expression] = STATE(1436),
    [sym_subscript_expression] = STATE(1436),
    [sym_call_expression] = STATE(1436),
    [sym_field_expression] = STATE(1436),
    [sym_compound_literal_expression] = STATE(1436),
    [sym_parenthesized_expression] = STATE(1436),
    [sym_char_literal] = STATE(1436),
    [sym_concatenated_string] = STATE(1436),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1436),
    [sym_new_expression] = STATE(1436),
    [sym_delete_expression] = STATE(1436),
    [sym_lambda_expression] = STATE(1436),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3015),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(3015),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(3017),
    [sym_false] = ACTIONS(3017),
    [sym_null] = ACTIONS(3017),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(3017),
  },
  [745] = {
    [sym__expression] = STATE(1437),
    [sym_conditional_expression] = STATE(1437),
    [sym_assignment_expression] = STATE(1437),
    [sym_pointer_expression] = STATE(1437),
    [sym_logical_expression] = STATE(1437),
    [sym_bitwise_expression] = STATE(1437),
    [sym_equality_expression] = STATE(1437),
    [sym_relational_expression] = STATE(1437),
    [sym_shift_expression] = STATE(1437),
    [sym_math_expression] = STATE(1437),
    [sym_cast_expression] = STATE(1437),
    [sym_sizeof_expression] = STATE(1437),
    [sym_subscript_expression] = STATE(1437),
    [sym_call_expression] = STATE(1437),
    [sym_field_expression] = STATE(1437),
    [sym_compound_literal_expression] = STATE(1437),
    [sym_parenthesized_expression] = STATE(1437),
    [sym_char_literal] = STATE(1437),
    [sym_concatenated_string] = STATE(1437),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1437),
    [sym_new_expression] = STATE(1437),
    [sym_delete_expression] = STATE(1437),
    [sym_lambda_expression] = STATE(1437),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3019),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(3019),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(3021),
    [sym_false] = ACTIONS(3021),
    [sym_null] = ACTIONS(3021),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(3021),
  },
  [746] = {
    [sym__expression] = STATE(1438),
    [sym_conditional_expression] = STATE(1438),
    [sym_assignment_expression] = STATE(1438),
    [sym_pointer_expression] = STATE(1438),
    [sym_logical_expression] = STATE(1438),
    [sym_bitwise_expression] = STATE(1438),
    [sym_equality_expression] = STATE(1438),
    [sym_relational_expression] = STATE(1438),
    [sym_shift_expression] = STATE(1438),
    [sym_math_expression] = STATE(1438),
    [sym_cast_expression] = STATE(1438),
    [sym_sizeof_expression] = STATE(1438),
    [sym_subscript_expression] = STATE(1438),
    [sym_call_expression] = STATE(1438),
    [sym_field_expression] = STATE(1438),
    [sym_compound_literal_expression] = STATE(1438),
    [sym_parenthesized_expression] = STATE(1438),
    [sym_char_literal] = STATE(1438),
    [sym_concatenated_string] = STATE(1438),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1438),
    [sym_new_expression] = STATE(1438),
    [sym_delete_expression] = STATE(1438),
    [sym_lambda_expression] = STATE(1438),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3023),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(3023),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(3025),
    [sym_false] = ACTIONS(3025),
    [sym_null] = ACTIONS(3025),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(3025),
  },
  [747] = {
    [sym__expression] = STATE(1439),
    [sym_conditional_expression] = STATE(1439),
    [sym_assignment_expression] = STATE(1439),
    [sym_pointer_expression] = STATE(1439),
    [sym_logical_expression] = STATE(1439),
    [sym_bitwise_expression] = STATE(1439),
    [sym_equality_expression] = STATE(1439),
    [sym_relational_expression] = STATE(1439),
    [sym_shift_expression] = STATE(1439),
    [sym_math_expression] = STATE(1439),
    [sym_cast_expression] = STATE(1439),
    [sym_sizeof_expression] = STATE(1439),
    [sym_subscript_expression] = STATE(1439),
    [sym_call_expression] = STATE(1439),
    [sym_field_expression] = STATE(1439),
    [sym_compound_literal_expression] = STATE(1439),
    [sym_parenthesized_expression] = STATE(1439),
    [sym_char_literal] = STATE(1439),
    [sym_concatenated_string] = STATE(1439),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1439),
    [sym_new_expression] = STATE(1439),
    [sym_delete_expression] = STATE(1439),
    [sym_lambda_expression] = STATE(1439),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3027),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(3027),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(3029),
    [sym_false] = ACTIONS(3029),
    [sym_null] = ACTIONS(3029),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(3029),
  },
  [748] = {
    [sym__expression] = STATE(1440),
    [sym_conditional_expression] = STATE(1440),
    [sym_assignment_expression] = STATE(1440),
    [sym_pointer_expression] = STATE(1440),
    [sym_logical_expression] = STATE(1440),
    [sym_bitwise_expression] = STATE(1440),
    [sym_equality_expression] = STATE(1440),
    [sym_relational_expression] = STATE(1440),
    [sym_shift_expression] = STATE(1440),
    [sym_math_expression] = STATE(1440),
    [sym_cast_expression] = STATE(1440),
    [sym_sizeof_expression] = STATE(1440),
    [sym_subscript_expression] = STATE(1440),
    [sym_call_expression] = STATE(1440),
    [sym_field_expression] = STATE(1440),
    [sym_compound_literal_expression] = STATE(1440),
    [sym_parenthesized_expression] = STATE(1440),
    [sym_char_literal] = STATE(1440),
    [sym_concatenated_string] = STATE(1440),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1440),
    [sym_new_expression] = STATE(1440),
    [sym_delete_expression] = STATE(1440),
    [sym_lambda_expression] = STATE(1440),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3031),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(3031),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(3033),
    [sym_false] = ACTIONS(3033),
    [sym_null] = ACTIONS(3033),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(3033),
  },
  [749] = {
    [sym__expression] = STATE(1441),
    [sym_conditional_expression] = STATE(1441),
    [sym_assignment_expression] = STATE(1441),
    [sym_pointer_expression] = STATE(1441),
    [sym_logical_expression] = STATE(1441),
    [sym_bitwise_expression] = STATE(1441),
    [sym_equality_expression] = STATE(1441),
    [sym_relational_expression] = STATE(1441),
    [sym_shift_expression] = STATE(1441),
    [sym_math_expression] = STATE(1441),
    [sym_cast_expression] = STATE(1441),
    [sym_sizeof_expression] = STATE(1441),
    [sym_subscript_expression] = STATE(1441),
    [sym_call_expression] = STATE(1441),
    [sym_field_expression] = STATE(1441),
    [sym_compound_literal_expression] = STATE(1441),
    [sym_parenthesized_expression] = STATE(1441),
    [sym_char_literal] = STATE(1441),
    [sym_concatenated_string] = STATE(1441),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1441),
    [sym_new_expression] = STATE(1441),
    [sym_delete_expression] = STATE(1441),
    [sym_lambda_expression] = STATE(1441),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3035),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(3035),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(3037),
    [sym_false] = ACTIONS(3037),
    [sym_null] = ACTIONS(3037),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(3037),
  },
  [750] = {
    [sym__expression] = STATE(1442),
    [sym_conditional_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1442),
    [sym_pointer_expression] = STATE(1442),
    [sym_logical_expression] = STATE(1442),
    [sym_bitwise_expression] = STATE(1442),
    [sym_equality_expression] = STATE(1442),
    [sym_relational_expression] = STATE(1442),
    [sym_shift_expression] = STATE(1442),
    [sym_math_expression] = STATE(1442),
    [sym_cast_expression] = STATE(1442),
    [sym_sizeof_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_call_expression] = STATE(1442),
    [sym_field_expression] = STATE(1442),
    [sym_compound_literal_expression] = STATE(1442),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_char_literal] = STATE(1442),
    [sym_concatenated_string] = STATE(1442),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1442),
    [sym_new_expression] = STATE(1442),
    [sym_delete_expression] = STATE(1442),
    [sym_lambda_expression] = STATE(1442),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3039),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(3039),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(3041),
    [sym_false] = ACTIONS(3041),
    [sym_null] = ACTIONS(3041),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(3041),
  },
  [751] = {
    [sym__expression] = STATE(1443),
    [sym_conditional_expression] = STATE(1443),
    [sym_assignment_expression] = STATE(1443),
    [sym_pointer_expression] = STATE(1443),
    [sym_logical_expression] = STATE(1443),
    [sym_bitwise_expression] = STATE(1443),
    [sym_equality_expression] = STATE(1443),
    [sym_relational_expression] = STATE(1443),
    [sym_shift_expression] = STATE(1443),
    [sym_math_expression] = STATE(1443),
    [sym_cast_expression] = STATE(1443),
    [sym_sizeof_expression] = STATE(1443),
    [sym_subscript_expression] = STATE(1443),
    [sym_call_expression] = STATE(1443),
    [sym_field_expression] = STATE(1443),
    [sym_compound_literal_expression] = STATE(1443),
    [sym_parenthesized_expression] = STATE(1443),
    [sym_char_literal] = STATE(1443),
    [sym_concatenated_string] = STATE(1443),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1443),
    [sym_new_expression] = STATE(1443),
    [sym_delete_expression] = STATE(1443),
    [sym_lambda_expression] = STATE(1443),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3043),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(3043),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(3045),
    [sym_false] = ACTIONS(3045),
    [sym_null] = ACTIONS(3045),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(3045),
  },
  [752] = {
    [sym_string_literal] = STATE(1444),
    [aux_sym_concatenated_string_repeat1] = STATE(1444),
    [anon_sym_SEMI] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_EQ] = ACTIONS(1763),
    [anon_sym_QMARK] = ACTIONS(1761),
    [anon_sym_STAR_EQ] = ACTIONS(1761),
    [anon_sym_SLASH_EQ] = ACTIONS(1761),
    [anon_sym_PERCENT_EQ] = ACTIONS(1761),
    [anon_sym_PLUS_EQ] = ACTIONS(1761),
    [anon_sym_DASH_EQ] = ACTIONS(1761),
    [anon_sym_LT_LT_EQ] = ACTIONS(1761),
    [anon_sym_GT_GT_EQ] = ACTIONS(1761),
    [anon_sym_AMP_EQ] = ACTIONS(1761),
    [anon_sym_CARET_EQ] = ACTIONS(1761),
    [anon_sym_PIPE_EQ] = ACTIONS(1761),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_PIPE_PIPE] = ACTIONS(1761),
    [anon_sym_AMP_AMP] = ACTIONS(1761),
    [anon_sym_PIPE] = ACTIONS(1763),
    [anon_sym_CARET] = ACTIONS(1763),
    [anon_sym_EQ_EQ] = ACTIONS(1761),
    [anon_sym_BANG_EQ] = ACTIONS(1761),
    [anon_sym_LT] = ACTIONS(1763),
    [anon_sym_GT] = ACTIONS(1763),
    [anon_sym_LT_EQ] = ACTIONS(1761),
    [anon_sym_GT_EQ] = ACTIONS(1761),
    [anon_sym_LT_LT] = ACTIONS(1763),
    [anon_sym_GT_GT] = ACTIONS(1763),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_SLASH] = ACTIONS(1763),
    [anon_sym_PERCENT] = ACTIONS(1763),
    [anon_sym_DASH_DASH] = ACTIONS(1761),
    [anon_sym_PLUS_PLUS] = ACTIONS(1761),
    [anon_sym_DOT] = ACTIONS(1761),
    [anon_sym_DASH_GT] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(91),
  },
  [753] = {
    [sym_raw_string_literal] = ACTIONS(3047),
    [ts_builtin_sym_end] = ACTIONS(3047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3049),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3049),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3049),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3049),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3049),
    [sym_preproc_directive] = ACTIONS(3049),
    [anon_sym_SEMI] = ACTIONS(3047),
    [anon_sym_typedef] = ACTIONS(3049),
    [anon_sym_extern] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(3047),
    [anon_sym_RBRACE] = ACTIONS(3047),
    [anon_sym_LPAREN2] = ACTIONS(3047),
    [anon_sym_STAR] = ACTIONS(3047),
    [anon_sym_LBRACK] = ACTIONS(3047),
    [anon_sym_static] = ACTIONS(3049),
    [anon_sym_register] = ACTIONS(3049),
    [anon_sym_inline] = ACTIONS(3049),
    [anon_sym_const] = ACTIONS(3049),
    [anon_sym_restrict] = ACTIONS(3049),
    [anon_sym_volatile] = ACTIONS(3049),
    [anon_sym__Atomic] = ACTIONS(3049),
    [anon_sym_mutable] = ACTIONS(3049),
    [anon_sym_explicit] = ACTIONS(3049),
    [anon_sym_constexpr] = ACTIONS(3049),
    [anon_sym_unsigned] = ACTIONS(3049),
    [anon_sym_long] = ACTIONS(3049),
    [anon_sym_short] = ACTIONS(3049),
    [sym_primitive_type] = ACTIONS(3049),
    [anon_sym_enum] = ACTIONS(3049),
    [anon_sym_struct] = ACTIONS(3049),
    [anon_sym_union] = ACTIONS(3049),
    [anon_sym_if] = ACTIONS(3049),
    [anon_sym_else] = ACTIONS(3049),
    [anon_sym_switch] = ACTIONS(3049),
    [anon_sym_case] = ACTIONS(3049),
    [anon_sym_default] = ACTIONS(3049),
    [anon_sym_while] = ACTIONS(3049),
    [anon_sym_do] = ACTIONS(3049),
    [anon_sym_for] = ACTIONS(3049),
    [anon_sym_return] = ACTIONS(3049),
    [anon_sym_break] = ACTIONS(3049),
    [anon_sym_continue] = ACTIONS(3049),
    [anon_sym_goto] = ACTIONS(3049),
    [anon_sym_AMP] = ACTIONS(3049),
    [anon_sym_AMP_AMP] = ACTIONS(3047),
    [anon_sym_BANG] = ACTIONS(3047),
    [anon_sym_TILDE] = ACTIONS(3047),
    [anon_sym_PLUS] = ACTIONS(3049),
    [anon_sym_DASH] = ACTIONS(3049),
    [anon_sym_DASH_DASH] = ACTIONS(3047),
    [anon_sym_PLUS_PLUS] = ACTIONS(3047),
    [anon_sym_sizeof] = ACTIONS(3049),
    [sym_number_literal] = ACTIONS(3047),
    [anon_sym_SQUOTE] = ACTIONS(3047),
    [anon_sym_DQUOTE] = ACTIONS(3047),
    [sym_true] = ACTIONS(3049),
    [sym_false] = ACTIONS(3049),
    [sym_null] = ACTIONS(3049),
    [sym_identifier] = ACTIONS(3049),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3049),
    [sym_auto] = ACTIONS(3049),
    [anon_sym_typename] = ACTIONS(3049),
    [anon_sym_template] = ACTIONS(3049),
    [anon_sym_delete] = ACTIONS(3049),
    [anon_sym_namespace] = ACTIONS(3049),
    [anon_sym_using] = ACTIONS(3049),
    [anon_sym_try] = ACTIONS(3049),
    [anon_sym_new] = ACTIONS(3049),
    [anon_sym_COLON_COLON] = ACTIONS(3047),
    [sym_operator_name] = ACTIONS(3047),
    [sym_nullptr] = ACTIONS(3049),
  },
  [754] = {
    [anon_sym_COMMA] = ACTIONS(1354),
    [anon_sym_RPAREN] = ACTIONS(1354),
    [anon_sym_SEMI] = ACTIONS(1354),
    [anon_sym_LBRACE] = ACTIONS(1354),
    [anon_sym_RBRACE] = ACTIONS(1354),
    [anon_sym_LPAREN2] = ACTIONS(1354),
    [anon_sym_STAR] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(1354),
    [anon_sym_RBRACK] = ACTIONS(1354),
    [anon_sym_EQ] = ACTIONS(3051),
    [anon_sym_COLON] = ACTIONS(1354),
    [anon_sym_QMARK] = ACTIONS(1354),
    [anon_sym_STAR_EQ] = ACTIONS(1354),
    [anon_sym_SLASH_EQ] = ACTIONS(1354),
    [anon_sym_PERCENT_EQ] = ACTIONS(1354),
    [anon_sym_PLUS_EQ] = ACTIONS(1354),
    [anon_sym_DASH_EQ] = ACTIONS(1354),
    [anon_sym_LT_LT_EQ] = ACTIONS(1354),
    [anon_sym_GT_GT_EQ] = ACTIONS(1354),
    [anon_sym_AMP_EQ] = ACTIONS(1354),
    [anon_sym_CARET_EQ] = ACTIONS(1354),
    [anon_sym_PIPE_EQ] = ACTIONS(1354),
    [anon_sym_AMP] = ACTIONS(3051),
    [anon_sym_PIPE_PIPE] = ACTIONS(1354),
    [anon_sym_AMP_AMP] = ACTIONS(1354),
    [anon_sym_PIPE] = ACTIONS(3051),
    [anon_sym_CARET] = ACTIONS(3051),
    [anon_sym_EQ_EQ] = ACTIONS(1354),
    [anon_sym_BANG_EQ] = ACTIONS(1354),
    [anon_sym_LT] = ACTIONS(3051),
    [anon_sym_GT] = ACTIONS(3051),
    [anon_sym_LT_EQ] = ACTIONS(1354),
    [anon_sym_GT_EQ] = ACTIONS(1354),
    [anon_sym_LT_LT] = ACTIONS(3051),
    [anon_sym_GT_GT] = ACTIONS(3051),
    [anon_sym_PLUS] = ACTIONS(3051),
    [anon_sym_DASH] = ACTIONS(3051),
    [anon_sym_SLASH] = ACTIONS(3051),
    [anon_sym_PERCENT] = ACTIONS(3051),
    [anon_sym_DASH_DASH] = ACTIONS(1354),
    [anon_sym_PLUS_PLUS] = ACTIONS(1354),
    [anon_sym_DOT] = ACTIONS(1354),
    [anon_sym_DASH_GT] = ACTIONS(1354),
    [sym_comment] = ACTIONS(91),
  },
  [755] = {
    [sym_destructor_name] = STATE(789),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(3053),
    [sym_comment] = ACTIONS(91),
    [sym_operator_name] = ACTIONS(1418),
  },
  [756] = {
    [anon_sym_COMMA] = ACTIONS(1575),
    [anon_sym_RPAREN] = ACTIONS(1575),
    [anon_sym_SEMI] = ACTIONS(1575),
    [anon_sym_LBRACE] = ACTIONS(1575),
    [anon_sym_LPAREN2] = ACTIONS(1575),
    [anon_sym_LBRACK] = ACTIONS(1575),
    [anon_sym_EQ] = ACTIONS(1575),
    [anon_sym_COLON] = ACTIONS(1587),
    [anon_sym_LT] = ACTIONS(1577),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(1575),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
  },
  [757] = {
    [sym_destructor_name] = STATE(958),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(3055),
    [sym_comment] = ACTIONS(91),
    [sym_operator_name] = ACTIONS(1767),
  },
  [758] = {
    [anon_sym_RPAREN] = ACTIONS(3057),
    [sym_comment] = ACTIONS(91),
  },
  [759] = {
    [anon_sym_COMMA] = ACTIONS(3059),
    [anon_sym_RPAREN] = ACTIONS(3059),
    [anon_sym_SEMI] = ACTIONS(3059),
    [anon_sym_RBRACE] = ACTIONS(3059),
    [anon_sym_LPAREN2] = ACTIONS(3059),
    [anon_sym_STAR] = ACTIONS(3061),
    [anon_sym_LBRACK] = ACTIONS(3059),
    [anon_sym_RBRACK] = ACTIONS(3059),
    [anon_sym_EQ] = ACTIONS(3061),
    [anon_sym_COLON] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3059),
    [anon_sym_STAR_EQ] = ACTIONS(3059),
    [anon_sym_SLASH_EQ] = ACTIONS(3059),
    [anon_sym_PERCENT_EQ] = ACTIONS(3059),
    [anon_sym_PLUS_EQ] = ACTIONS(3059),
    [anon_sym_DASH_EQ] = ACTIONS(3059),
    [anon_sym_LT_LT_EQ] = ACTIONS(3059),
    [anon_sym_GT_GT_EQ] = ACTIONS(3059),
    [anon_sym_AMP_EQ] = ACTIONS(3059),
    [anon_sym_CARET_EQ] = ACTIONS(3059),
    [anon_sym_PIPE_EQ] = ACTIONS(3059),
    [anon_sym_AMP] = ACTIONS(3061),
    [anon_sym_PIPE_PIPE] = ACTIONS(3059),
    [anon_sym_AMP_AMP] = ACTIONS(3059),
    [anon_sym_PIPE] = ACTIONS(3061),
    [anon_sym_CARET] = ACTIONS(3061),
    [anon_sym_EQ_EQ] = ACTIONS(3059),
    [anon_sym_BANG_EQ] = ACTIONS(3059),
    [anon_sym_LT] = ACTIONS(3061),
    [anon_sym_GT] = ACTIONS(3061),
    [anon_sym_LT_EQ] = ACTIONS(3059),
    [anon_sym_GT_EQ] = ACTIONS(3059),
    [anon_sym_LT_LT] = ACTIONS(3061),
    [anon_sym_GT_GT] = ACTIONS(3061),
    [anon_sym_PLUS] = ACTIONS(3061),
    [anon_sym_DASH] = ACTIONS(3061),
    [anon_sym_SLASH] = ACTIONS(3061),
    [anon_sym_PERCENT] = ACTIONS(3061),
    [anon_sym_DASH_DASH] = ACTIONS(3059),
    [anon_sym_PLUS_PLUS] = ACTIONS(3059),
    [anon_sym_DOT] = ACTIONS(3059),
    [anon_sym_DASH_GT] = ACTIONS(3059),
    [sym_comment] = ACTIONS(91),
  },
  [760] = {
    [anon_sym_COMMA] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3063),
    [anon_sym_SEMI] = ACTIONS(3063),
    [anon_sym_extern] = ACTIONS(3065),
    [anon_sym_LBRACE] = ACTIONS(3063),
    [anon_sym_RBRACE] = ACTIONS(3063),
    [anon_sym_LPAREN2] = ACTIONS(3063),
    [anon_sym_STAR] = ACTIONS(3065),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_RBRACK] = ACTIONS(3063),
    [anon_sym_EQ] = ACTIONS(3065),
    [anon_sym_static] = ACTIONS(3065),
    [anon_sym_register] = ACTIONS(3065),
    [anon_sym_inline] = ACTIONS(3065),
    [anon_sym_const] = ACTIONS(3065),
    [anon_sym_restrict] = ACTIONS(3065),
    [anon_sym_volatile] = ACTIONS(3065),
    [anon_sym__Atomic] = ACTIONS(3065),
    [anon_sym_mutable] = ACTIONS(3065),
    [anon_sym_explicit] = ACTIONS(3065),
    [anon_sym_constexpr] = ACTIONS(3065),
    [anon_sym_unsigned] = ACTIONS(3065),
    [anon_sym_long] = ACTIONS(3065),
    [anon_sym_short] = ACTIONS(3065),
    [sym_primitive_type] = ACTIONS(3065),
    [anon_sym_enum] = ACTIONS(3065),
    [anon_sym_struct] = ACTIONS(3065),
    [anon_sym_union] = ACTIONS(3065),
    [anon_sym_QMARK] = ACTIONS(3063),
    [anon_sym_STAR_EQ] = ACTIONS(3063),
    [anon_sym_SLASH_EQ] = ACTIONS(3063),
    [anon_sym_PERCENT_EQ] = ACTIONS(3063),
    [anon_sym_PLUS_EQ] = ACTIONS(3063),
    [anon_sym_DASH_EQ] = ACTIONS(3063),
    [anon_sym_LT_LT_EQ] = ACTIONS(3063),
    [anon_sym_GT_GT_EQ] = ACTIONS(3063),
    [anon_sym_AMP_EQ] = ACTIONS(3063),
    [anon_sym_CARET_EQ] = ACTIONS(3063),
    [anon_sym_PIPE_EQ] = ACTIONS(3063),
    [anon_sym_AMP] = ACTIONS(3065),
    [anon_sym_PIPE_PIPE] = ACTIONS(3063),
    [anon_sym_AMP_AMP] = ACTIONS(3063),
    [anon_sym_PIPE] = ACTIONS(3065),
    [anon_sym_CARET] = ACTIONS(3065),
    [anon_sym_EQ_EQ] = ACTIONS(3063),
    [anon_sym_BANG_EQ] = ACTIONS(3063),
    [anon_sym_LT] = ACTIONS(3065),
    [anon_sym_GT] = ACTIONS(3065),
    [anon_sym_LT_EQ] = ACTIONS(3063),
    [anon_sym_GT_EQ] = ACTIONS(3063),
    [anon_sym_LT_LT] = ACTIONS(3065),
    [anon_sym_GT_GT] = ACTIONS(3065),
    [anon_sym_PLUS] = ACTIONS(3065),
    [anon_sym_DASH] = ACTIONS(3065),
    [anon_sym_SLASH] = ACTIONS(3065),
    [anon_sym_PERCENT] = ACTIONS(3065),
    [anon_sym_DASH_DASH] = ACTIONS(3063),
    [anon_sym_PLUS_PLUS] = ACTIONS(3063),
    [anon_sym_DOT] = ACTIONS(3063),
    [anon_sym_DASH_GT] = ACTIONS(3063),
    [anon_sym_DQUOTE] = ACTIONS(3063),
    [sym_identifier] = ACTIONS(3065),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3065),
    [sym_auto] = ACTIONS(3065),
    [anon_sym_typename] = ACTIONS(3065),
    [anon_sym_COLON_COLON] = ACTIONS(3063),
  },
  [761] = {
    [aux_sym_string_literal_repeat1] = STATE(761),
    [anon_sym_DQUOTE] = ACTIONS(3067),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_BSLASHn_RBRACK_SLASH] = ACTIONS(3069),
    [sym_escape_sequence] = ACTIONS(3069),
    [sym_comment] = ACTIONS(121),
  },
  [762] = {
    [sym_raw_string_literal] = ACTIONS(3072),
    [ts_builtin_sym_end] = ACTIONS(3072),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3074),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3074),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3074),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3074),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3074),
    [sym_preproc_directive] = ACTIONS(3074),
    [anon_sym_SEMI] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3074),
    [anon_sym_extern] = ACTIONS(3074),
    [anon_sym_LBRACE] = ACTIONS(3072),
    [anon_sym_RBRACE] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3074),
    [anon_sym_register] = ACTIONS(3074),
    [anon_sym_inline] = ACTIONS(3074),
    [anon_sym_const] = ACTIONS(3074),
    [anon_sym_restrict] = ACTIONS(3074),
    [anon_sym_volatile] = ACTIONS(3074),
    [anon_sym__Atomic] = ACTIONS(3074),
    [anon_sym_mutable] = ACTIONS(3074),
    [anon_sym_explicit] = ACTIONS(3074),
    [anon_sym_constexpr] = ACTIONS(3074),
    [anon_sym_unsigned] = ACTIONS(3074),
    [anon_sym_long] = ACTIONS(3074),
    [anon_sym_short] = ACTIONS(3074),
    [sym_primitive_type] = ACTIONS(3074),
    [anon_sym_enum] = ACTIONS(3074),
    [anon_sym_struct] = ACTIONS(3074),
    [anon_sym_union] = ACTIONS(3074),
    [anon_sym_if] = ACTIONS(3074),
    [anon_sym_else] = ACTIONS(3074),
    [anon_sym_switch] = ACTIONS(3074),
    [anon_sym_case] = ACTIONS(3074),
    [anon_sym_default] = ACTIONS(3074),
    [anon_sym_while] = ACTIONS(3074),
    [anon_sym_do] = ACTIONS(3074),
    [anon_sym_for] = ACTIONS(3074),
    [anon_sym_return] = ACTIONS(3074),
    [anon_sym_break] = ACTIONS(3074),
    [anon_sym_continue] = ACTIONS(3074),
    [anon_sym_goto] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3072),
    [anon_sym_BANG] = ACTIONS(3072),
    [anon_sym_TILDE] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3074),
    [anon_sym_DASH_DASH] = ACTIONS(3072),
    [anon_sym_PLUS_PLUS] = ACTIONS(3072),
    [anon_sym_sizeof] = ACTIONS(3074),
    [sym_number_literal] = ACTIONS(3072),
    [anon_sym_SQUOTE] = ACTIONS(3072),
    [anon_sym_DQUOTE] = ACTIONS(3072),
    [sym_true] = ACTIONS(3074),
    [sym_false] = ACTIONS(3074),
    [sym_null] = ACTIONS(3074),
    [sym_identifier] = ACTIONS(3074),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3074),
    [sym_auto] = ACTIONS(3074),
    [anon_sym_typename] = ACTIONS(3074),
    [anon_sym_template] = ACTIONS(3074),
    [anon_sym_delete] = ACTIONS(3074),
    [anon_sym_namespace] = ACTIONS(3074),
    [anon_sym_using] = ACTIONS(3074),
    [anon_sym_try] = ACTIONS(3074),
    [anon_sym_new] = ACTIONS(3074),
    [anon_sym_COLON_COLON] = ACTIONS(3072),
    [sym_operator_name] = ACTIONS(3072),
    [sym_nullptr] = ACTIONS(3074),
  },
  [763] = {
    [sym_type_qualifier] = STATE(141),
    [sym__type_specifier] = STATE(136),
    [sym_sized_type_specifier] = STATE(136),
    [sym_enum_specifier] = STATE(136),
    [sym_struct_specifier] = STATE(136),
    [sym_union_specifier] = STATE(136),
    [sym__expression] = STATE(1448),
    [sym_comma_expression] = STATE(1449),
    [sym_conditional_expression] = STATE(1448),
    [sym_assignment_expression] = STATE(1448),
    [sym_pointer_expression] = STATE(1448),
    [sym_logical_expression] = STATE(1448),
    [sym_bitwise_expression] = STATE(1448),
    [sym_equality_expression] = STATE(1448),
    [sym_relational_expression] = STATE(1448),
    [sym_shift_expression] = STATE(1448),
    [sym_math_expression] = STATE(1448),
    [sym_cast_expression] = STATE(1448),
    [sym_type_descriptor] = STATE(1450),
    [sym_sizeof_expression] = STATE(1448),
    [sym_subscript_expression] = STATE(1448),
    [sym_call_expression] = STATE(1448),
    [sym_field_expression] = STATE(1448),
    [sym_compound_literal_expression] = STATE(1448),
    [sym_parenthesized_expression] = STATE(1448),
    [sym_char_literal] = STATE(1448),
    [sym_concatenated_string] = STATE(1448),
    [sym_string_literal] = STATE(140),
    [sym_macro_type_specifier] = STATE(136),
    [sym_class_specifier] = STATE(136),
    [sym_dependent_type] = STATE(136),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(1448),
    [sym_new_expression] = STATE(1448),
    [sym_delete_expression] = STATE(1448),
    [sym_lambda_expression] = STATE(1448),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_type_definition_repeat1] = STATE(141),
    [aux_sym_sized_type_specifier_repeat1] = STATE(142),
    [sym_raw_string_literal] = ACTIONS(3076),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(219),
    [anon_sym_long] = ACTIONS(219),
    [anon_sym_short] = ACTIONS(219),
    [sym_primitive_type] = ACTIONS(221),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(3076),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(3078),
    [sym_false] = ACTIONS(3078),
    [sym_null] = ACTIONS(3078),
    [sym_identifier] = ACTIONS(811),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(221),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(253),
    [sym_nullptr] = ACTIONS(3078),
  },
  [764] = {
    [sym__expression] = STATE(1453),
    [sym_conditional_expression] = STATE(1453),
    [sym_assignment_expression] = STATE(1453),
    [sym_pointer_expression] = STATE(1453),
    [sym_logical_expression] = STATE(1453),
    [sym_bitwise_expression] = STATE(1453),
    [sym_equality_expression] = STATE(1453),
    [sym_relational_expression] = STATE(1453),
    [sym_shift_expression] = STATE(1453),
    [sym_math_expression] = STATE(1453),
    [sym_cast_expression] = STATE(1453),
    [sym_sizeof_expression] = STATE(1453),
    [sym_subscript_expression] = STATE(1453),
    [sym_call_expression] = STATE(1453),
    [sym_field_expression] = STATE(1453),
    [sym_compound_literal_expression] = STATE(1453),
    [sym_parenthesized_expression] = STATE(1453),
    [sym_char_literal] = STATE(1453),
    [sym_concatenated_string] = STATE(1453),
    [sym_string_literal] = STATE(780),
    [sym_template_type] = STATE(1454),
    [sym_template_function] = STATE(1453),
    [sym_new_expression] = STATE(1453),
    [sym_delete_expression] = STATE(1453),
    [sym_lambda_expression] = STATE(1453),
    [sym_lambda_capture_specifier] = STATE(782),
    [sym_scoped_identifier] = STATE(783),
    [sym_scoped_type_identifier] = STATE(1455),
    [sym_scoped_namespace_identifier] = STATE(1456),
    [sym_raw_string_literal] = ACTIONS(3080),
    [anon_sym_LPAREN2] = ACTIONS(1380),
    [anon_sym_STAR] = ACTIONS(1382),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1382),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1394),
    [anon_sym_PLUS_PLUS] = ACTIONS(1394),
    [anon_sym_sizeof] = ACTIONS(1396),
    [sym_number_literal] = ACTIONS(3080),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_true] = ACTIONS(3082),
    [sym_false] = ACTIONS(3082),
    [sym_null] = ACTIONS(3082),
    [sym_identifier] = ACTIONS(3084),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1410),
    [anon_sym_new] = ACTIONS(1412),
    [anon_sym_COLON_COLON] = ACTIONS(3086),
    [sym_nullptr] = ACTIONS(3082),
  },
  [765] = {
    [sym__expression] = STATE(1457),
    [sym_conditional_expression] = STATE(1457),
    [sym_assignment_expression] = STATE(1457),
    [sym_pointer_expression] = STATE(1457),
    [sym_logical_expression] = STATE(1457),
    [sym_bitwise_expression] = STATE(1457),
    [sym_equality_expression] = STATE(1457),
    [sym_relational_expression] = STATE(1457),
    [sym_shift_expression] = STATE(1457),
    [sym_math_expression] = STATE(1457),
    [sym_cast_expression] = STATE(1457),
    [sym_sizeof_expression] = STATE(1457),
    [sym_subscript_expression] = STATE(1457),
    [sym_call_expression] = STATE(1457),
    [sym_field_expression] = STATE(1457),
    [sym_compound_literal_expression] = STATE(1457),
    [sym_parenthesized_expression] = STATE(1457),
    [sym_char_literal] = STATE(1457),
    [sym_concatenated_string] = STATE(1457),
    [sym_string_literal] = STATE(780),
    [sym_template_type] = STATE(1454),
    [sym_template_function] = STATE(1457),
    [sym_new_expression] = STATE(1457),
    [sym_delete_expression] = STATE(1457),
    [sym_lambda_expression] = STATE(1457),
    [sym_lambda_capture_specifier] = STATE(782),
    [sym_scoped_identifier] = STATE(783),
    [sym_scoped_type_identifier] = STATE(1455),
    [sym_scoped_namespace_identifier] = STATE(1456),
    [sym_raw_string_literal] = ACTIONS(3088),
    [anon_sym_LPAREN2] = ACTIONS(1380),
    [anon_sym_STAR] = ACTIONS(1382),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1382),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1394),
    [anon_sym_PLUS_PLUS] = ACTIONS(1394),
    [anon_sym_sizeof] = ACTIONS(1396),
    [sym_number_literal] = ACTIONS(3088),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_true] = ACTIONS(3090),
    [sym_false] = ACTIONS(3090),
    [sym_null] = ACTIONS(3090),
    [sym_identifier] = ACTIONS(3084),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1410),
    [anon_sym_new] = ACTIONS(1412),
    [anon_sym_COLON_COLON] = ACTIONS(3086),
    [sym_nullptr] = ACTIONS(3090),
  },
  [766] = {
    [sym__expression] = STATE(1458),
    [sym_conditional_expression] = STATE(1458),
    [sym_assignment_expression] = STATE(1458),
    [sym_pointer_expression] = STATE(1458),
    [sym_logical_expression] = STATE(1458),
    [sym_bitwise_expression] = STATE(1458),
    [sym_equality_expression] = STATE(1458),
    [sym_relational_expression] = STATE(1458),
    [sym_shift_expression] = STATE(1458),
    [sym_math_expression] = STATE(1458),
    [sym_cast_expression] = STATE(1458),
    [sym_sizeof_expression] = STATE(1458),
    [sym_subscript_expression] = STATE(1458),
    [sym_call_expression] = STATE(1458),
    [sym_field_expression] = STATE(1458),
    [sym_compound_literal_expression] = STATE(1458),
    [sym_parenthesized_expression] = STATE(1458),
    [sym_char_literal] = STATE(1458),
    [sym_concatenated_string] = STATE(1458),
    [sym_string_literal] = STATE(780),
    [sym_template_type] = STATE(1454),
    [sym_template_function] = STATE(1458),
    [sym_new_expression] = STATE(1458),
    [sym_delete_expression] = STATE(1458),
    [sym_lambda_expression] = STATE(1458),
    [sym_lambda_capture_specifier] = STATE(782),
    [sym_scoped_identifier] = STATE(783),
    [sym_scoped_type_identifier] = STATE(1455),
    [sym_scoped_namespace_identifier] = STATE(1456),
    [sym_raw_string_literal] = ACTIONS(3092),
    [anon_sym_LPAREN2] = ACTIONS(1380),
    [anon_sym_STAR] = ACTIONS(1382),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1382),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1394),
    [anon_sym_PLUS_PLUS] = ACTIONS(1394),
    [anon_sym_sizeof] = ACTIONS(1396),
    [sym_number_literal] = ACTIONS(3092),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_true] = ACTIONS(3094),
    [sym_false] = ACTIONS(3094),
    [sym_null] = ACTIONS(3094),
    [sym_identifier] = ACTIONS(3084),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1410),
    [anon_sym_new] = ACTIONS(1412),
    [anon_sym_COLON_COLON] = ACTIONS(3086),
    [sym_nullptr] = ACTIONS(3094),
  },
  [767] = {
    [sym__expression] = STATE(1459),
    [sym_conditional_expression] = STATE(1459),
    [sym_assignment_expression] = STATE(1459),
    [sym_pointer_expression] = STATE(1459),
    [sym_logical_expression] = STATE(1459),
    [sym_bitwise_expression] = STATE(1459),
    [sym_equality_expression] = STATE(1459),
    [sym_relational_expression] = STATE(1459),
    [sym_shift_expression] = STATE(1459),
    [sym_math_expression] = STATE(1459),
    [sym_cast_expression] = STATE(1459),
    [sym_sizeof_expression] = STATE(1459),
    [sym_subscript_expression] = STATE(1459),
    [sym_call_expression] = STATE(1459),
    [sym_field_expression] = STATE(1459),
    [sym_compound_literal_expression] = STATE(1459),
    [sym_parenthesized_expression] = STATE(1459),
    [sym_char_literal] = STATE(1459),
    [sym_concatenated_string] = STATE(1459),
    [sym_string_literal] = STATE(780),
    [sym_template_type] = STATE(1454),
    [sym_template_function] = STATE(1459),
    [sym_new_expression] = STATE(1459),
    [sym_delete_expression] = STATE(1459),
    [sym_lambda_expression] = STATE(1459),
    [sym_lambda_capture_specifier] = STATE(782),
    [sym_scoped_identifier] = STATE(783),
    [sym_scoped_type_identifier] = STATE(1455),
    [sym_scoped_namespace_identifier] = STATE(1456),
    [sym_raw_string_literal] = ACTIONS(3096),
    [anon_sym_LPAREN2] = ACTIONS(1380),
    [anon_sym_STAR] = ACTIONS(1382),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1382),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1394),
    [anon_sym_PLUS_PLUS] = ACTIONS(1394),
    [anon_sym_sizeof] = ACTIONS(1396),
    [sym_number_literal] = ACTIONS(3096),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_true] = ACTIONS(3098),
    [sym_false] = ACTIONS(3098),
    [sym_null] = ACTIONS(3098),
    [sym_identifier] = ACTIONS(3084),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1410),
    [anon_sym_new] = ACTIONS(1412),
    [anon_sym_COLON_COLON] = ACTIONS(3086),
    [sym_nullptr] = ACTIONS(3098),
  },
  [768] = {
    [sym__expression] = STATE(1461),
    [sym_conditional_expression] = STATE(1461),
    [sym_assignment_expression] = STATE(1461),
    [sym_pointer_expression] = STATE(1461),
    [sym_logical_expression] = STATE(1461),
    [sym_bitwise_expression] = STATE(1461),
    [sym_equality_expression] = STATE(1461),
    [sym_relational_expression] = STATE(1461),
    [sym_shift_expression] = STATE(1461),
    [sym_math_expression] = STATE(1461),
    [sym_cast_expression] = STATE(1461),
    [sym_sizeof_expression] = STATE(1461),
    [sym_subscript_expression] = STATE(1461),
    [sym_call_expression] = STATE(1461),
    [sym_field_expression] = STATE(1461),
    [sym_compound_literal_expression] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1461),
    [sym_char_literal] = STATE(1461),
    [sym_concatenated_string] = STATE(1461),
    [sym_string_literal] = STATE(780),
    [sym_template_type] = STATE(1454),
    [sym_template_function] = STATE(1461),
    [sym_new_expression] = STATE(1461),
    [sym_delete_expression] = STATE(1461),
    [sym_lambda_expression] = STATE(1461),
    [sym_lambda_capture_specifier] = STATE(782),
    [sym_scoped_identifier] = STATE(783),
    [sym_scoped_type_identifier] = STATE(1455),
    [sym_scoped_namespace_identifier] = STATE(1456),
    [sym_raw_string_literal] = ACTIONS(3100),
    [anon_sym_LPAREN2] = ACTIONS(3102),
    [anon_sym_STAR] = ACTIONS(1382),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1382),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1394),
    [anon_sym_PLUS_PLUS] = ACTIONS(1394),
    [anon_sym_sizeof] = ACTIONS(1396),
    [sym_number_literal] = ACTIONS(3100),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_true] = ACTIONS(3104),
    [sym_false] = ACTIONS(3104),
    [sym_null] = ACTIONS(3104),
    [sym_identifier] = ACTIONS(3084),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1410),
    [anon_sym_new] = ACTIONS(1412),
    [anon_sym_COLON_COLON] = ACTIONS(3086),
    [sym_nullptr] = ACTIONS(3104),
  },
  [769] = {
    [aux_sym_SLASH_LBRACK_CARET_BSLASHn_SQUOTE_RBRACK_SLASH] = ACTIONS(3106),
    [sym_escape_sequence] = ACTIONS(3108),
    [sym_comment] = ACTIONS(121),
  },
  [770] = {
    [aux_sym_string_literal_repeat1] = STATE(1464),
    [anon_sym_DQUOTE] = ACTIONS(3110),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_BSLASHn_RBRACK_SLASH] = ACTIONS(3112),
    [sym_escape_sequence] = ACTIONS(3112),
    [sym_comment] = ACTIONS(121),
  },
  [771] = {
    [sym_initializer_list] = STATE(1468),
    [sym_template_argument_list] = STATE(1469),
    [anon_sym_COMMA] = ACTIONS(465),
    [anon_sym_LBRACE] = ACTIONS(3114),
    [anon_sym_LPAREN2] = ACTIONS(465),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(474),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(3116),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(465),
    [anon_sym_COLON_COLON] = ACTIONS(3119),
  },
  [772] = {
    [sym__type_specifier] = STATE(271),
    [sym_sized_type_specifier] = STATE(271),
    [sym_enum_specifier] = STATE(271),
    [sym_struct_specifier] = STATE(271),
    [sym_union_specifier] = STATE(271),
    [sym_macro_type_specifier] = STATE(271),
    [sym_class_specifier] = STATE(271),
    [sym_dependent_type] = STATE(271),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_sized_type_specifier_repeat1] = STATE(787),
    [anon_sym_unsigned] = ACTIONS(1384),
    [anon_sym_long] = ACTIONS(1384),
    [anon_sym_short] = ACTIONS(1384),
    [sym_primitive_type] = ACTIONS(490),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(490),
    [anon_sym_typename] = ACTIONS(1406),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [773] = {
    [anon_sym_COMMA] = ACTIONS(3121),
    [anon_sym_RPAREN] = ACTIONS(3121),
    [anon_sym_SEMI] = ACTIONS(3121),
    [anon_sym_extern] = ACTIONS(3123),
    [anon_sym_LBRACE] = ACTIONS(3121),
    [anon_sym_RBRACE] = ACTIONS(3121),
    [anon_sym_LPAREN2] = ACTIONS(3121),
    [anon_sym_STAR] = ACTIONS(3123),
    [anon_sym_LBRACK] = ACTIONS(3121),
    [anon_sym_RBRACK] = ACTIONS(3121),
    [anon_sym_EQ] = ACTIONS(3123),
    [anon_sym_static] = ACTIONS(3123),
    [anon_sym_register] = ACTIONS(3123),
    [anon_sym_inline] = ACTIONS(3123),
    [anon_sym_const] = ACTIONS(3123),
    [anon_sym_restrict] = ACTIONS(3123),
    [anon_sym_volatile] = ACTIONS(3123),
    [anon_sym__Atomic] = ACTIONS(3123),
    [anon_sym_mutable] = ACTIONS(3123),
    [anon_sym_explicit] = ACTIONS(3123),
    [anon_sym_constexpr] = ACTIONS(3123),
    [anon_sym_COLON] = ACTIONS(3123),
    [anon_sym_QMARK] = ACTIONS(3121),
    [anon_sym_STAR_EQ] = ACTIONS(3121),
    [anon_sym_SLASH_EQ] = ACTIONS(3121),
    [anon_sym_PERCENT_EQ] = ACTIONS(3121),
    [anon_sym_PLUS_EQ] = ACTIONS(3121),
    [anon_sym_DASH_EQ] = ACTIONS(3121),
    [anon_sym_LT_LT_EQ] = ACTIONS(3121),
    [anon_sym_GT_GT_EQ] = ACTIONS(3121),
    [anon_sym_AMP_EQ] = ACTIONS(3121),
    [anon_sym_CARET_EQ] = ACTIONS(3121),
    [anon_sym_PIPE_EQ] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_PIPE_PIPE] = ACTIONS(3121),
    [anon_sym_AMP_AMP] = ACTIONS(3121),
    [anon_sym_PIPE] = ACTIONS(3123),
    [anon_sym_CARET] = ACTIONS(3123),
    [anon_sym_TILDE] = ACTIONS(3121),
    [anon_sym_EQ_EQ] = ACTIONS(3121),
    [anon_sym_BANG_EQ] = ACTIONS(3121),
    [anon_sym_LT] = ACTIONS(3123),
    [anon_sym_GT] = ACTIONS(3123),
    [anon_sym_LT_EQ] = ACTIONS(3121),
    [anon_sym_GT_EQ] = ACTIONS(3121),
    [anon_sym_LT_LT] = ACTIONS(3123),
    [anon_sym_GT_GT] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3123),
    [anon_sym_PERCENT] = ACTIONS(3123),
    [anon_sym_DASH_DASH] = ACTIONS(3121),
    [anon_sym_PLUS_PLUS] = ACTIONS(3121),
    [anon_sym_DOT] = ACTIONS(3121),
    [anon_sym_DASH_GT] = ACTIONS(3121),
    [sym_identifier] = ACTIONS(3123),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3123),
    [anon_sym_override] = ACTIONS(3123),
    [anon_sym_COLON_COLON] = ACTIONS(3121),
    [sym_operator_name] = ACTIONS(3121),
  },
  [774] = {
    [sym__expression] = STATE(1471),
    [sym_conditional_expression] = STATE(1471),
    [sym_assignment_expression] = STATE(1471),
    [sym_pointer_expression] = STATE(1471),
    [sym_logical_expression] = STATE(1471),
    [sym_bitwise_expression] = STATE(1471),
    [sym_equality_expression] = STATE(1471),
    [sym_relational_expression] = STATE(1471),
    [sym_shift_expression] = STATE(1471),
    [sym_math_expression] = STATE(1471),
    [sym_cast_expression] = STATE(1471),
    [sym_sizeof_expression] = STATE(1471),
    [sym_subscript_expression] = STATE(1471),
    [sym_call_expression] = STATE(1471),
    [sym_field_expression] = STATE(1471),
    [sym_compound_literal_expression] = STATE(1471),
    [sym_parenthesized_expression] = STATE(1471),
    [sym_char_literal] = STATE(1471),
    [sym_concatenated_string] = STATE(1471),
    [sym_string_literal] = STATE(780),
    [sym_template_type] = STATE(1454),
    [sym_template_function] = STATE(1471),
    [sym_new_expression] = STATE(1471),
    [sym_delete_expression] = STATE(1471),
    [sym_lambda_expression] = STATE(1471),
    [sym_lambda_capture_specifier] = STATE(782),
    [sym_scoped_identifier] = STATE(783),
    [sym_scoped_type_identifier] = STATE(1455),
    [sym_scoped_namespace_identifier] = STATE(1456),
    [sym_raw_string_literal] = ACTIONS(3125),
    [anon_sym_LPAREN2] = ACTIONS(1380),
    [anon_sym_STAR] = ACTIONS(1382),
    [anon_sym_LBRACK] = ACTIONS(3127),
    [anon_sym_AMP] = ACTIONS(1382),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1394),
    [anon_sym_PLUS_PLUS] = ACTIONS(1394),
    [anon_sym_sizeof] = ACTIONS(1396),
    [sym_number_literal] = ACTIONS(3125),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_true] = ACTIONS(3129),
    [sym_false] = ACTIONS(3129),
    [sym_null] = ACTIONS(3129),
    [sym_identifier] = ACTIONS(3084),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1410),
    [anon_sym_new] = ACTIONS(1412),
    [anon_sym_COLON_COLON] = ACTIONS(3086),
    [sym_nullptr] = ACTIONS(3129),
  },
  [775] = {
    [sym__type_specifier] = STATE(1479),
    [sym_sized_type_specifier] = STATE(1479),
    [sym_enum_specifier] = STATE(1479),
    [sym_struct_specifier] = STATE(1479),
    [sym_union_specifier] = STATE(1479),
    [sym_argument_list] = STATE(1480),
    [sym_macro_type_specifier] = STATE(1479),
    [sym_class_specifier] = STATE(1479),
    [sym_dependent_type] = STATE(1479),
    [sym_template_type] = STATE(1481),
    [sym_scoped_type_identifier] = STATE(1482),
    [sym_scoped_namespace_identifier] = STATE(1483),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1484),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_unsigned] = ACTIONS(3131),
    [anon_sym_long] = ACTIONS(3131),
    [anon_sym_short] = ACTIONS(3131),
    [sym_primitive_type] = ACTIONS(3133),
    [anon_sym_enum] = ACTIONS(3135),
    [anon_sym_struct] = ACTIONS(3137),
    [anon_sym_union] = ACTIONS(3139),
    [sym_identifier] = ACTIONS(3141),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3143),
    [sym_auto] = ACTIONS(3133),
    [anon_sym_typename] = ACTIONS(3145),
    [anon_sym_COLON_COLON] = ACTIONS(3147),
  },
  [776] = {
    [sym_destructor_name] = STATE(1488),
    [anon_sym_TILDE] = ACTIONS(3149),
    [sym_identifier] = ACTIONS(3151),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(3153),
    [sym_operator_name] = ACTIONS(3155),
  },
  [777] = {
    [sym__abstract_declarator] = STATE(1491),
    [sym_abstract_pointer_declarator] = STATE(1491),
    [sym_abstract_function_declarator] = STATE(1491),
    [sym_abstract_array_declarator] = STATE(1491),
    [sym_parameter_list] = STATE(1492),
    [sym_abstract_reference_declarator] = STATE(1491),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(3157),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_AMP] = ACTIONS(3159),
    [anon_sym_AMP_AMP] = ACTIONS(3161),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(887),
  },
  [778] = {
    [sym_argument_list] = STATE(1511),
    [aux_sym_template_argument_list_repeat1] = STATE(1512),
    [anon_sym_COMMA] = ACTIONS(3163),
    [anon_sym_LPAREN2] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_EQ] = ACTIONS(3171),
    [anon_sym_QMARK] = ACTIONS(3173),
    [anon_sym_STAR_EQ] = ACTIONS(3175),
    [anon_sym_SLASH_EQ] = ACTIONS(3175),
    [anon_sym_PERCENT_EQ] = ACTIONS(3175),
    [anon_sym_PLUS_EQ] = ACTIONS(3175),
    [anon_sym_DASH_EQ] = ACTIONS(3175),
    [anon_sym_LT_LT_EQ] = ACTIONS(3175),
    [anon_sym_GT_GT_EQ] = ACTIONS(3175),
    [anon_sym_AMP_EQ] = ACTIONS(3175),
    [anon_sym_CARET_EQ] = ACTIONS(3175),
    [anon_sym_PIPE_EQ] = ACTIONS(3175),
    [anon_sym_AMP] = ACTIONS(3177),
    [anon_sym_PIPE_PIPE] = ACTIONS(3179),
    [anon_sym_AMP_AMP] = ACTIONS(3181),
    [anon_sym_PIPE] = ACTIONS(3183),
    [anon_sym_CARET] = ACTIONS(3185),
    [anon_sym_EQ_EQ] = ACTIONS(3187),
    [anon_sym_BANG_EQ] = ACTIONS(3187),
    [anon_sym_LT] = ACTIONS(3189),
    [anon_sym_GT] = ACTIONS(3189),
    [anon_sym_LT_EQ] = ACTIONS(3191),
    [anon_sym_GT_EQ] = ACTIONS(3191),
    [anon_sym_LT_LT] = ACTIONS(3193),
    [anon_sym_GT_GT] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_SLASH] = ACTIONS(3167),
    [anon_sym_PERCENT] = ACTIONS(3167),
    [anon_sym_DASH_DASH] = ACTIONS(3197),
    [anon_sym_PLUS_PLUS] = ACTIONS(3197),
    [anon_sym_DOT] = ACTIONS(3199),
    [anon_sym_DASH_GT] = ACTIONS(3199),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3201),
  },
  [779] = {
    [aux_sym_template_argument_list_repeat1] = STATE(1514),
    [anon_sym_COMMA] = ACTIONS(3163),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3203),
  },
  [780] = {
    [sym_string_literal] = STATE(1515),
    [aux_sym_concatenated_string_repeat1] = STATE(1515),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_LPAREN2] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(463),
  },
  [781] = {
    [sym_initializer_list] = STATE(1517),
    [anon_sym_COMMA] = ACTIONS(624),
    [anon_sym_LBRACE] = ACTIONS(3114),
    [anon_sym_LPAREN2] = ACTIONS(624),
    [anon_sym_STAR] = ACTIONS(624),
    [anon_sym_LBRACK] = ACTIONS(624),
    [anon_sym_AMP] = ACTIONS(626),
    [anon_sym_AMP_AMP] = ACTIONS(624),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(624),
    [anon_sym_COLON_COLON] = ACTIONS(3205),
  },
  [782] = {
    [sym__abstract_declarator] = STATE(357),
    [sym_abstract_pointer_declarator] = STATE(357),
    [sym_abstract_function_declarator] = STATE(1518),
    [sym_abstract_array_declarator] = STATE(357),
    [sym_parameter_list] = STATE(359),
    [sym_abstract_reference_declarator] = STATE(357),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_AMP] = ACTIONS(639),
    [anon_sym_AMP_AMP] = ACTIONS(641),
    [sym_comment] = ACTIONS(91),
  },
  [783] = {
    [sym_template_argument_list] = STATE(1519),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_LPAREN2] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(3116),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(463),
  },
  [784] = {
    [sym_initializer_list] = STATE(1517),
    [sym_template_argument_list] = STATE(362),
    [anon_sym_COMMA] = ACTIONS(624),
    [anon_sym_LBRACE] = ACTIONS(3114),
    [anon_sym_LPAREN2] = ACTIONS(624),
    [anon_sym_STAR] = ACTIONS(624),
    [anon_sym_LBRACK] = ACTIONS(624),
    [anon_sym_AMP] = ACTIONS(626),
    [anon_sym_AMP_AMP] = ACTIONS(624),
    [anon_sym_LT] = ACTIONS(643),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(624),
  },
  [785] = {
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(3205),
  },
  [786] = {
    [sym_type_qualifier] = STATE(453),
    [sym__type_specifier] = STATE(1520),
    [sym_sized_type_specifier] = STATE(1520),
    [sym_enum_specifier] = STATE(1520),
    [sym_struct_specifier] = STATE(1520),
    [sym_union_specifier] = STATE(1520),
    [sym_macro_type_specifier] = STATE(1520),
    [sym_class_specifier] = STATE(1520),
    [sym_dependent_type] = STATE(1520),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_type_definition_repeat1] = STATE(453),
    [aux_sym_sized_type_specifier_repeat1] = STATE(787),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(1384),
    [anon_sym_long] = ACTIONS(1384),
    [anon_sym_short] = ACTIONS(1384),
    [sym_primitive_type] = ACTIONS(3207),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(3207),
    [anon_sym_typename] = ACTIONS(1406),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [787] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1521),
    [anon_sym_COMMA] = ACTIONS(653),
    [anon_sym_LPAREN2] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_unsigned] = ACTIONS(3209),
    [anon_sym_long] = ACTIONS(3209),
    [anon_sym_short] = ACTIONS(3209),
    [sym_primitive_type] = ACTIONS(659),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [sym_identifier] = ACTIONS(933),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(653),
  },
  [788] = {
    [anon_sym_COMMA] = ACTIONS(3211),
    [anon_sym_RPAREN] = ACTIONS(3213),
    [anon_sym_SEMI] = ACTIONS(3213),
    [anon_sym_extern] = ACTIONS(3216),
    [anon_sym_LBRACE] = ACTIONS(3218),
    [anon_sym_RBRACE] = ACTIONS(3211),
    [anon_sym_LPAREN2] = ACTIONS(3213),
    [anon_sym_STAR] = ACTIONS(3220),
    [anon_sym_LBRACK] = ACTIONS(3213),
    [anon_sym_EQ] = ACTIONS(3223),
    [anon_sym_static] = ACTIONS(3216),
    [anon_sym_register] = ACTIONS(3216),
    [anon_sym_inline] = ACTIONS(3216),
    [anon_sym_const] = ACTIONS(3216),
    [anon_sym_restrict] = ACTIONS(3216),
    [anon_sym_volatile] = ACTIONS(3216),
    [anon_sym__Atomic] = ACTIONS(3216),
    [anon_sym_mutable] = ACTIONS(3216),
    [anon_sym_explicit] = ACTIONS(3216),
    [anon_sym_constexpr] = ACTIONS(3216),
    [anon_sym_QMARK] = ACTIONS(3211),
    [anon_sym_STAR_EQ] = ACTIONS(3211),
    [anon_sym_SLASH_EQ] = ACTIONS(3211),
    [anon_sym_PERCENT_EQ] = ACTIONS(3211),
    [anon_sym_PLUS_EQ] = ACTIONS(3211),
    [anon_sym_DASH_EQ] = ACTIONS(3211),
    [anon_sym_LT_LT_EQ] = ACTIONS(3211),
    [anon_sym_GT_GT_EQ] = ACTIONS(3211),
    [anon_sym_AMP_EQ] = ACTIONS(3211),
    [anon_sym_CARET_EQ] = ACTIONS(3211),
    [anon_sym_PIPE_EQ] = ACTIONS(3211),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym_PIPE_PIPE] = ACTIONS(3211),
    [anon_sym_AMP_AMP] = ACTIONS(3213),
    [anon_sym_PIPE] = ACTIONS(3223),
    [anon_sym_CARET] = ACTIONS(3223),
    [anon_sym_TILDE] = ACTIONS(3218),
    [anon_sym_EQ_EQ] = ACTIONS(3211),
    [anon_sym_BANG_EQ] = ACTIONS(3211),
    [anon_sym_LT] = ACTIONS(3220),
    [anon_sym_GT] = ACTIONS(3223),
    [anon_sym_LT_EQ] = ACTIONS(3211),
    [anon_sym_GT_EQ] = ACTIONS(3211),
    [anon_sym_LT_LT] = ACTIONS(3223),
    [anon_sym_GT_GT] = ACTIONS(3223),
    [anon_sym_PLUS] = ACTIONS(3223),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_SLASH] = ACTIONS(3223),
    [anon_sym_PERCENT] = ACTIONS(3223),
    [anon_sym_DASH_DASH] = ACTIONS(3211),
    [anon_sym_PLUS_PLUS] = ACTIONS(3211),
    [anon_sym_DOT] = ACTIONS(3211),
    [anon_sym_DASH_GT] = ACTIONS(3211),
    [sym_identifier] = ACTIONS(3216),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(3225),
    [sym_operator_name] = ACTIONS(3218),
  },
  [789] = {
    [anon_sym_COMMA] = ACTIONS(3211),
    [anon_sym_RPAREN] = ACTIONS(3211),
    [anon_sym_SEMI] = ACTIONS(3211),
    [anon_sym_LBRACE] = ACTIONS(3211),
    [anon_sym_RBRACE] = ACTIONS(3211),
    [anon_sym_LPAREN2] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(3211),
    [anon_sym_RBRACK] = ACTIONS(3211),
    [anon_sym_EQ] = ACTIONS(3223),
    [anon_sym_COLON] = ACTIONS(3211),
    [anon_sym_QMARK] = ACTIONS(3211),
    [anon_sym_STAR_EQ] = ACTIONS(3211),
    [anon_sym_SLASH_EQ] = ACTIONS(3211),
    [anon_sym_PERCENT_EQ] = ACTIONS(3211),
    [anon_sym_PLUS_EQ] = ACTIONS(3211),
    [anon_sym_DASH_EQ] = ACTIONS(3211),
    [anon_sym_LT_LT_EQ] = ACTIONS(3211),
    [anon_sym_GT_GT_EQ] = ACTIONS(3211),
    [anon_sym_AMP_EQ] = ACTIONS(3211),
    [anon_sym_CARET_EQ] = ACTIONS(3211),
    [anon_sym_PIPE_EQ] = ACTIONS(3211),
    [anon_sym_AMP] = ACTIONS(3223),
    [anon_sym_PIPE_PIPE] = ACTIONS(3211),
    [anon_sym_AMP_AMP] = ACTIONS(3211),
    [anon_sym_PIPE] = ACTIONS(3223),
    [anon_sym_CARET] = ACTIONS(3223),
    [anon_sym_EQ_EQ] = ACTIONS(3211),
    [anon_sym_BANG_EQ] = ACTIONS(3211),
    [anon_sym_LT] = ACTIONS(3223),
    [anon_sym_GT] = ACTIONS(3223),
    [anon_sym_LT_EQ] = ACTIONS(3211),
    [anon_sym_GT_EQ] = ACTIONS(3211),
    [anon_sym_LT_LT] = ACTIONS(3223),
    [anon_sym_GT_GT] = ACTIONS(3223),
    [anon_sym_PLUS] = ACTIONS(3223),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_SLASH] = ACTIONS(3223),
    [anon_sym_PERCENT] = ACTIONS(3223),
    [anon_sym_DASH_DASH] = ACTIONS(3211),
    [anon_sym_PLUS_PLUS] = ACTIONS(3211),
    [anon_sym_DOT] = ACTIONS(3211),
    [anon_sym_DASH_GT] = ACTIONS(3211),
    [sym_comment] = ACTIONS(91),
  },
  [790] = {
    [anon_sym_COMMA] = ACTIONS(3227),
    [anon_sym_RPAREN] = ACTIONS(3227),
    [anon_sym_SEMI] = ACTIONS(3227),
    [anon_sym_extern] = ACTIONS(3229),
    [anon_sym_LBRACE] = ACTIONS(3227),
    [anon_sym_LPAREN2] = ACTIONS(3227),
    [anon_sym_STAR] = ACTIONS(3227),
    [anon_sym_LBRACK] = ACTIONS(3227),
    [anon_sym_EQ] = ACTIONS(3227),
    [anon_sym_static] = ACTIONS(3229),
    [anon_sym_register] = ACTIONS(3229),
    [anon_sym_inline] = ACTIONS(3229),
    [anon_sym_const] = ACTIONS(3229),
    [anon_sym_restrict] = ACTIONS(3229),
    [anon_sym_volatile] = ACTIONS(3229),
    [anon_sym__Atomic] = ACTIONS(3229),
    [anon_sym_mutable] = ACTIONS(3229),
    [anon_sym_explicit] = ACTIONS(3229),
    [anon_sym_constexpr] = ACTIONS(3229),
    [anon_sym_COLON] = ACTIONS(3229),
    [anon_sym_AMP] = ACTIONS(3229),
    [anon_sym_AMP_AMP] = ACTIONS(3227),
    [anon_sym_TILDE] = ACTIONS(3227),
    [anon_sym_DASH_GT] = ACTIONS(3227),
    [sym_identifier] = ACTIONS(3229),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3229),
    [anon_sym_override] = ACTIONS(3229),
    [anon_sym_GT2] = ACTIONS(3227),
    [sym_noexcept] = ACTIONS(3229),
    [anon_sym_COLON_COLON] = ACTIONS(3227),
    [sym_operator_name] = ACTIONS(3227),
  },
  [791] = {
    [sym_field_declaration_list] = STATE(1522),
    [sym_base_class_clause] = STATE(1523),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_COLON] = ACTIONS(1073),
    [sym_comment] = ACTIONS(91),
  },
  [792] = {
    [sym_field_declaration_list] = STATE(1522),
    [anon_sym_LBRACE] = ACTIONS(307),
    [sym_comment] = ACTIONS(91),
  },
  [793] = {
    [anon_sym_COMMA] = ACTIONS(3231),
    [anon_sym_RPAREN] = ACTIONS(3231),
    [anon_sym_SEMI] = ACTIONS(3231),
    [anon_sym_extern] = ACTIONS(3233),
    [anon_sym_LBRACE] = ACTIONS(3231),
    [anon_sym_LPAREN2] = ACTIONS(3231),
    [anon_sym_STAR] = ACTIONS(3231),
    [anon_sym_LBRACK] = ACTIONS(3231),
    [anon_sym_EQ] = ACTIONS(3231),
    [anon_sym_static] = ACTIONS(3233),
    [anon_sym_register] = ACTIONS(3233),
    [anon_sym_inline] = ACTIONS(3233),
    [anon_sym_const] = ACTIONS(3233),
    [anon_sym_restrict] = ACTIONS(3233),
    [anon_sym_volatile] = ACTIONS(3233),
    [anon_sym__Atomic] = ACTIONS(3233),
    [anon_sym_mutable] = ACTIONS(3233),
    [anon_sym_explicit] = ACTIONS(3233),
    [anon_sym_constexpr] = ACTIONS(3233),
    [anon_sym_COLON] = ACTIONS(3233),
    [anon_sym_AMP] = ACTIONS(3233),
    [anon_sym_AMP_AMP] = ACTIONS(3231),
    [anon_sym_TILDE] = ACTIONS(3231),
    [anon_sym_DASH_GT] = ACTIONS(3231),
    [sym_identifier] = ACTIONS(3233),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3233),
    [anon_sym_override] = ACTIONS(3233),
    [anon_sym_GT2] = ACTIONS(3231),
    [sym_noexcept] = ACTIONS(3233),
    [anon_sym_COLON_COLON] = ACTIONS(3231),
    [sym_operator_name] = ACTIONS(3231),
  },
  [794] = {
    [sym_field_declaration_list] = STATE(1524),
    [anon_sym_LBRACE] = ACTIONS(307),
    [sym_comment] = ACTIONS(91),
  },
  [795] = {
    [sym_field_declaration_list] = STATE(1524),
    [sym_base_class_clause] = STATE(1525),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_COLON] = ACTIONS(1073),
    [sym_comment] = ACTIONS(91),
  },
  [796] = {
    [sym_parameter_list] = STATE(812),
    [anon_sym_SEMI] = ACTIONS(2435),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(574),
    [sym_comment] = ACTIONS(91),
  },
  [797] = {
    [sym__declarator] = STATE(1526),
    [sym_pointer_declarator] = STATE(1526),
    [sym_function_declarator] = STATE(1526),
    [sym_array_declarator] = STATE(1526),
    [sym_type_qualifier] = STATE(552),
    [sym_reference_declarator] = STATE(1526),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(1526),
    [sym_destructor_name] = STATE(1526),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [aux_sym_type_definition_repeat1] = STATE(552),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(500),
    [anon_sym_AMP_AMP] = ACTIONS(502),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(431),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(3235),
  },
  [798] = {
    [sym_parameter_list] = STATE(812),
    [anon_sym_SEMI] = ACTIONS(2439),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(574),
    [sym_comment] = ACTIONS(91),
  },
  [799] = {
    [sym_field_declaration_list] = STATE(265),
    [sym_virtual_specifier] = STATE(266),
    [sym_base_class_clause] = STATE(267),
    [sym_template_type] = STATE(268),
    [sym_scoped_type_identifier] = STATE(269),
    [sym_scoped_namespace_identifier] = STATE(180),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(3237),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(315),
  },
  [800] = {
    [sym__type_specifier] = STATE(271),
    [sym_sized_type_specifier] = STATE(271),
    [sym_enum_specifier] = STATE(271),
    [sym_struct_specifier] = STATE(271),
    [sym_union_specifier] = STATE(271),
    [sym_macro_type_specifier] = STATE(271),
    [sym_class_specifier] = STATE(271),
    [sym_dependent_type] = STATE(271),
    [sym_template_type] = STATE(272),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(180),
    [aux_sym_sized_type_specifier_repeat1] = STATE(806),
    [anon_sym_unsigned] = ACTIONS(1454),
    [anon_sym_long] = ACTIONS(1454),
    [anon_sym_short] = ACTIONS(1454),
    [sym_primitive_type] = ACTIONS(490),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [sym_identifier] = ACTIONS(3239),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(490),
    [anon_sym_typename] = ACTIONS(3241),
    [anon_sym_COLON_COLON] = ACTIONS(315),
  },
  [801] = {
    [anon_sym_extern] = ACTIONS(3243),
    [anon_sym_static] = ACTIONS(3243),
    [anon_sym_register] = ACTIONS(3243),
    [anon_sym_inline] = ACTIONS(3243),
    [anon_sym_const] = ACTIONS(3243),
    [anon_sym_restrict] = ACTIONS(3243),
    [anon_sym_volatile] = ACTIONS(3243),
    [anon_sym__Atomic] = ACTIONS(3243),
    [anon_sym_mutable] = ACTIONS(3243),
    [anon_sym_explicit] = ACTIONS(3243),
    [anon_sym_constexpr] = ACTIONS(3243),
    [anon_sym_unsigned] = ACTIONS(3243),
    [anon_sym_long] = ACTIONS(3243),
    [anon_sym_short] = ACTIONS(3243),
    [sym_primitive_type] = ACTIONS(3243),
    [anon_sym_enum] = ACTIONS(3243),
    [anon_sym_struct] = ACTIONS(3243),
    [anon_sym_union] = ACTIONS(3243),
    [sym_identifier] = ACTIONS(3243),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3243),
    [sym_auto] = ACTIONS(3243),
    [anon_sym_typename] = ACTIONS(3243),
    [anon_sym_COLON_COLON] = ACTIONS(3245),
  },
  [802] = {
    [sym__declarator] = STATE(1535),
    [sym__abstract_declarator] = STATE(1536),
    [sym_pointer_declarator] = STATE(1535),
    [sym_abstract_pointer_declarator] = STATE(1536),
    [sym_function_declarator] = STATE(1535),
    [sym_abstract_function_declarator] = STATE(1536),
    [sym_array_declarator] = STATE(1535),
    [sym_abstract_array_declarator] = STATE(1536),
    [sym_init_declarator] = STATE(1537),
    [sym_parameter_list] = STATE(1492),
    [sym_reference_declarator] = STATE(1535),
    [sym_abstract_reference_declarator] = STATE(1536),
    [sym_template_type] = STATE(1538),
    [sym_template_function] = STATE(1535),
    [sym_destructor_name] = STATE(1535),
    [sym_scoped_identifier] = STATE(1539),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(1538),
    [anon_sym_COMMA] = ACTIONS(3247),
    [anon_sym_LPAREN2] = ACTIONS(3249),
    [anon_sym_STAR] = ACTIONS(3251),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_AMP] = ACTIONS(3253),
    [anon_sym_AMP_AMP] = ACTIONS(3255),
    [anon_sym_TILDE] = ACTIONS(3149),
    [sym_identifier] = ACTIONS(3257),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3247),
    [anon_sym_COLON_COLON] = ACTIONS(3259),
    [sym_operator_name] = ACTIONS(3261),
  },
  [803] = {
    [sym_storage_class_specifier] = STATE(1541),
    [sym_type_qualifier] = STATE(1541),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1541),
    [anon_sym_COMMA] = ACTIONS(582),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_LPAREN2] = ACTIONS(582),
    [anon_sym_STAR] = ACTIONS(582),
    [anon_sym_LBRACK] = ACTIONS(582),
    [anon_sym_EQ] = ACTIONS(3263),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(584),
    [anon_sym_AMP_AMP] = ACTIONS(582),
    [anon_sym_TILDE] = ACTIONS(582),
    [sym_identifier] = ACTIONS(584),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(582),
    [anon_sym_COLON_COLON] = ACTIONS(582),
    [sym_operator_name] = ACTIONS(582),
  },
  [804] = {
    [aux_sym_template_parameter_list_repeat1] = STATE(1544),
    [anon_sym_COMMA] = ACTIONS(3265),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3267),
  },
  [805] = {
    [sym_storage_class_specifier] = STATE(497),
    [sym_type_qualifier] = STATE(497),
    [sym__type_specifier] = STATE(1546),
    [sym_sized_type_specifier] = STATE(1546),
    [sym_enum_specifier] = STATE(1546),
    [sym_struct_specifier] = STATE(1546),
    [sym_union_specifier] = STATE(1546),
    [sym_macro_type_specifier] = STATE(1546),
    [sym_class_specifier] = STATE(1546),
    [sym_dependent_type] = STATE(1546),
    [sym_template_type] = STATE(272),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(180),
    [aux_sym__declaration_specifiers_repeat1] = STATE(497),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1547),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(3269),
    [anon_sym_long] = ACTIONS(3269),
    [anon_sym_short] = ACTIONS(3269),
    [sym_primitive_type] = ACTIONS(3271),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [sym_identifier] = ACTIONS(492),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(3271),
    [anon_sym_typename] = ACTIONS(3273),
    [anon_sym_COLON_COLON] = ACTIONS(315),
  },
  [806] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1548),
    [anon_sym_COMMA] = ACTIONS(653),
    [anon_sym_extern] = ACTIONS(655),
    [anon_sym_LPAREN2] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_EQ] = ACTIONS(653),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_register] = ACTIONS(655),
    [anon_sym_inline] = ACTIONS(655),
    [anon_sym_const] = ACTIONS(655),
    [anon_sym_restrict] = ACTIONS(655),
    [anon_sym_volatile] = ACTIONS(655),
    [anon_sym__Atomic] = ACTIONS(655),
    [anon_sym_mutable] = ACTIONS(655),
    [anon_sym_explicit] = ACTIONS(655),
    [anon_sym_constexpr] = ACTIONS(655),
    [anon_sym_unsigned] = ACTIONS(3275),
    [anon_sym_long] = ACTIONS(3275),
    [anon_sym_short] = ACTIONS(3275),
    [sym_primitive_type] = ACTIONS(659),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [anon_sym_TILDE] = ACTIONS(653),
    [sym_identifier] = ACTIONS(661),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(653),
    [anon_sym_COLON_COLON] = ACTIONS(653),
    [sym_operator_name] = ACTIONS(653),
  },
  [807] = {
    [sym_destructor_name] = STATE(789),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(3277),
    [sym_comment] = ACTIONS(91),
    [sym_operator_name] = ACTIONS(1418),
  },
  [808] = {
    [anon_sym_SEMI] = ACTIONS(1424),
    [anon_sym_extern] = ACTIONS(1429),
    [anon_sym_LPAREN2] = ACTIONS(1426),
    [anon_sym_STAR] = ACTIONS(1431),
    [anon_sym_LBRACK] = ACTIONS(1424),
    [anon_sym_static] = ACTIONS(1429),
    [anon_sym_register] = ACTIONS(1429),
    [anon_sym_inline] = ACTIONS(1429),
    [anon_sym_const] = ACTIONS(1429),
    [anon_sym_restrict] = ACTIONS(1429),
    [anon_sym_volatile] = ACTIONS(1429),
    [anon_sym__Atomic] = ACTIONS(1429),
    [anon_sym_mutable] = ACTIONS(1429),
    [anon_sym_explicit] = ACTIONS(1429),
    [anon_sym_constexpr] = ACTIONS(1429),
    [anon_sym_AMP] = ACTIONS(1429),
    [anon_sym_AMP_AMP] = ACTIONS(1431),
    [anon_sym_TILDE] = ACTIONS(1431),
    [sym_identifier] = ACTIONS(1429),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1431),
    [sym_operator_name] = ACTIONS(1431),
  },
  [809] = {
    [anon_sym_SEMI] = ACTIONS(1575),
    [anon_sym_extern] = ACTIONS(1580),
    [anon_sym_LPAREN2] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1582),
    [anon_sym_LBRACK] = ACTIONS(1575),
    [anon_sym_static] = ACTIONS(1580),
    [anon_sym_register] = ACTIONS(1580),
    [anon_sym_inline] = ACTIONS(1580),
    [anon_sym_const] = ACTIONS(1580),
    [anon_sym_restrict] = ACTIONS(1580),
    [anon_sym_volatile] = ACTIONS(1580),
    [anon_sym__Atomic] = ACTIONS(1580),
    [anon_sym_mutable] = ACTIONS(1580),
    [anon_sym_explicit] = ACTIONS(1580),
    [anon_sym_constexpr] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1582),
    [anon_sym_TILDE] = ACTIONS(1582),
    [anon_sym_LT] = ACTIONS(1577),
    [sym_identifier] = ACTIONS(1580),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [sym_operator_name] = ACTIONS(1582),
  },
  [810] = {
    [sym_parameter_list] = STATE(812),
    [anon_sym_SEMI] = ACTIONS(3279),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(574),
    [sym_comment] = ACTIONS(91),
  },
  [811] = {
    [sym_raw_string_literal] = ACTIONS(3281),
    [ts_builtin_sym_end] = ACTIONS(3281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3283),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3283),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3283),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3283),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3283),
    [sym_preproc_directive] = ACTIONS(3283),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_typedef] = ACTIONS(3283),
    [anon_sym_extern] = ACTIONS(3283),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_RBRACE] = ACTIONS(3281),
    [anon_sym_LPAREN2] = ACTIONS(3281),
    [anon_sym_STAR] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_static] = ACTIONS(3283),
    [anon_sym_register] = ACTIONS(3283),
    [anon_sym_inline] = ACTIONS(3283),
    [anon_sym_const] = ACTIONS(3283),
    [anon_sym_restrict] = ACTIONS(3283),
    [anon_sym_volatile] = ACTIONS(3283),
    [anon_sym__Atomic] = ACTIONS(3283),
    [anon_sym_mutable] = ACTIONS(3283),
    [anon_sym_explicit] = ACTIONS(3283),
    [anon_sym_constexpr] = ACTIONS(3283),
    [anon_sym_unsigned] = ACTIONS(3283),
    [anon_sym_long] = ACTIONS(3283),
    [anon_sym_short] = ACTIONS(3283),
    [sym_primitive_type] = ACTIONS(3283),
    [anon_sym_enum] = ACTIONS(3283),
    [anon_sym_struct] = ACTIONS(3283),
    [anon_sym_union] = ACTIONS(3283),
    [anon_sym_if] = ACTIONS(3283),
    [anon_sym_switch] = ACTIONS(3283),
    [anon_sym_case] = ACTIONS(3283),
    [anon_sym_default] = ACTIONS(3283),
    [anon_sym_while] = ACTIONS(3283),
    [anon_sym_do] = ACTIONS(3283),
    [anon_sym_for] = ACTIONS(3283),
    [anon_sym_return] = ACTIONS(3283),
    [anon_sym_break] = ACTIONS(3283),
    [anon_sym_continue] = ACTIONS(3283),
    [anon_sym_goto] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3283),
    [anon_sym_AMP_AMP] = ACTIONS(3281),
    [anon_sym_BANG] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3281),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_DASH_DASH] = ACTIONS(3281),
    [anon_sym_PLUS_PLUS] = ACTIONS(3281),
    [anon_sym_sizeof] = ACTIONS(3283),
    [sym_number_literal] = ACTIONS(3281),
    [anon_sym_SQUOTE] = ACTIONS(3281),
    [anon_sym_DQUOTE] = ACTIONS(3281),
    [sym_true] = ACTIONS(3283),
    [sym_false] = ACTIONS(3283),
    [sym_null] = ACTIONS(3283),
    [sym_identifier] = ACTIONS(3283),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3283),
    [sym_auto] = ACTIONS(3283),
    [anon_sym_typename] = ACTIONS(3283),
    [anon_sym_template] = ACTIONS(3283),
    [anon_sym_delete] = ACTIONS(3283),
    [anon_sym_namespace] = ACTIONS(3283),
    [anon_sym_using] = ACTIONS(3283),
    [anon_sym_try] = ACTIONS(3283),
    [anon_sym_new] = ACTIONS(3283),
    [anon_sym_COLON_COLON] = ACTIONS(3281),
    [sym_operator_name] = ACTIONS(3281),
    [sym_nullptr] = ACTIONS(3283),
  },
  [812] = {
    [sym_type_qualifier] = STATE(1552),
    [sym_virtual_specifier] = STATE(1552),
    [sym_trailing_return_type] = STATE(1552),
    [aux_sym_function_declarator_repeat1] = STATE(1552),
    [anon_sym_SEMI] = ACTIONS(1665),
    [anon_sym_LPAREN2] = ACTIONS(1665),
    [anon_sym_LBRACK] = ACTIONS(1665),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(3285),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [sym_noexcept] = ACTIONS(3287),
  },
  [813] = {
    [sym_storage_class_specifier] = STATE(1553),
    [sym_type_qualifier] = STATE(1553),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1553),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_LPAREN2] = ACTIONS(1689),
    [anon_sym_STAR] = ACTIONS(1689),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(1691),
    [anon_sym_AMP_AMP] = ACTIONS(1689),
    [anon_sym_TILDE] = ACTIONS(1689),
    [sym_identifier] = ACTIONS(1691),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1689),
    [sym_operator_name] = ACTIONS(1689),
  },
  [814] = {
    [sym__type_specifier] = STATE(271),
    [sym_sized_type_specifier] = STATE(271),
    [sym_enum_specifier] = STATE(271),
    [sym_struct_specifier] = STATE(271),
    [sym_union_specifier] = STATE(271),
    [sym_macro_type_specifier] = STATE(271),
    [sym_class_specifier] = STATE(271),
    [sym_dependent_type] = STATE(271),
    [sym_template_type] = STATE(272),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(180),
    [aux_sym_sized_type_specifier_repeat1] = STATE(819),
    [anon_sym_unsigned] = ACTIONS(1475),
    [anon_sym_long] = ACTIONS(1475),
    [anon_sym_short] = ACTIONS(1475),
    [sym_primitive_type] = ACTIONS(490),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [sym_identifier] = ACTIONS(492),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(490),
    [anon_sym_typename] = ACTIONS(1479),
    [anon_sym_COLON_COLON] = ACTIONS(315),
  },
  [815] = {
    [sym_raw_string_literal] = ACTIONS(3289),
    [ts_builtin_sym_end] = ACTIONS(3289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3291),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3291),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3291),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3291),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3291),
    [sym_preproc_directive] = ACTIONS(3291),
    [anon_sym_SEMI] = ACTIONS(3289),
    [anon_sym_typedef] = ACTIONS(3291),
    [anon_sym_extern] = ACTIONS(3291),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_RBRACE] = ACTIONS(3289),
    [anon_sym_LPAREN2] = ACTIONS(3289),
    [anon_sym_STAR] = ACTIONS(3289),
    [anon_sym_LBRACK] = ACTIONS(3289),
    [anon_sym_static] = ACTIONS(3291),
    [anon_sym_register] = ACTIONS(3291),
    [anon_sym_inline] = ACTIONS(3291),
    [anon_sym_const] = ACTIONS(3291),
    [anon_sym_restrict] = ACTIONS(3291),
    [anon_sym_volatile] = ACTIONS(3291),
    [anon_sym__Atomic] = ACTIONS(3291),
    [anon_sym_mutable] = ACTIONS(3291),
    [anon_sym_explicit] = ACTIONS(3291),
    [anon_sym_constexpr] = ACTIONS(3291),
    [anon_sym_unsigned] = ACTIONS(3291),
    [anon_sym_long] = ACTIONS(3291),
    [anon_sym_short] = ACTIONS(3291),
    [sym_primitive_type] = ACTIONS(3291),
    [anon_sym_enum] = ACTIONS(3291),
    [anon_sym_struct] = ACTIONS(3291),
    [anon_sym_union] = ACTIONS(3291),
    [anon_sym_if] = ACTIONS(3291),
    [anon_sym_switch] = ACTIONS(3291),
    [anon_sym_case] = ACTIONS(3291),
    [anon_sym_default] = ACTIONS(3291),
    [anon_sym_while] = ACTIONS(3291),
    [anon_sym_do] = ACTIONS(3291),
    [anon_sym_for] = ACTIONS(3291),
    [anon_sym_return] = ACTIONS(3291),
    [anon_sym_break] = ACTIONS(3291),
    [anon_sym_continue] = ACTIONS(3291),
    [anon_sym_goto] = ACTIONS(3291),
    [anon_sym_AMP] = ACTIONS(3291),
    [anon_sym_AMP_AMP] = ACTIONS(3289),
    [anon_sym_BANG] = ACTIONS(3289),
    [anon_sym_TILDE] = ACTIONS(3289),
    [anon_sym_PLUS] = ACTIONS(3291),
    [anon_sym_DASH] = ACTIONS(3291),
    [anon_sym_DASH_DASH] = ACTIONS(3289),
    [anon_sym_PLUS_PLUS] = ACTIONS(3289),
    [anon_sym_sizeof] = ACTIONS(3291),
    [sym_number_literal] = ACTIONS(3289),
    [anon_sym_SQUOTE] = ACTIONS(3289),
    [anon_sym_DQUOTE] = ACTIONS(3289),
    [sym_true] = ACTIONS(3291),
    [sym_false] = ACTIONS(3291),
    [sym_null] = ACTIONS(3291),
    [sym_identifier] = ACTIONS(3291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3291),
    [sym_auto] = ACTIONS(3291),
    [anon_sym_typename] = ACTIONS(3291),
    [anon_sym_template] = ACTIONS(3291),
    [anon_sym_delete] = ACTIONS(3291),
    [anon_sym_namespace] = ACTIONS(3291),
    [anon_sym_using] = ACTIONS(3291),
    [anon_sym_try] = ACTIONS(3291),
    [anon_sym_new] = ACTIONS(3291),
    [anon_sym_COLON_COLON] = ACTIONS(3289),
    [sym_operator_name] = ACTIONS(3289),
    [sym_nullptr] = ACTIONS(3291),
  },
  [816] = {
    [sym__declarator] = STATE(321),
    [sym_pointer_declarator] = STATE(321),
    [sym_function_declarator] = STATE(321),
    [sym_array_declarator] = STATE(321),
    [sym_init_declarator] = STATE(322),
    [sym_reference_declarator] = STATE(321),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(321),
    [sym_destructor_name] = STATE(321),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [anon_sym_SEMI] = ACTIONS(558),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(560),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(568),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(570),
  },
  [817] = {
    [sym_storage_class_specifier] = STATE(1554),
    [sym_type_qualifier] = STATE(1554),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1554),
    [anon_sym_SEMI] = ACTIONS(582),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_LPAREN2] = ACTIONS(582),
    [anon_sym_STAR] = ACTIONS(582),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(584),
    [anon_sym_AMP_AMP] = ACTIONS(582),
    [anon_sym_TILDE] = ACTIONS(582),
    [sym_identifier] = ACTIONS(584),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(582),
    [sym_operator_name] = ACTIONS(582),
  },
  [818] = {
    [sym_storage_class_specifier] = STATE(497),
    [sym_type_qualifier] = STATE(497),
    [sym__type_specifier] = STATE(1555),
    [sym_sized_type_specifier] = STATE(1555),
    [sym_enum_specifier] = STATE(1555),
    [sym_struct_specifier] = STATE(1555),
    [sym_union_specifier] = STATE(1555),
    [sym_macro_type_specifier] = STATE(1555),
    [sym_class_specifier] = STATE(1555),
    [sym_dependent_type] = STATE(1555),
    [sym_template_type] = STATE(272),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(180),
    [aux_sym__declaration_specifiers_repeat1] = STATE(497),
    [aux_sym_sized_type_specifier_repeat1] = STATE(819),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(1475),
    [anon_sym_long] = ACTIONS(1475),
    [anon_sym_short] = ACTIONS(1475),
    [sym_primitive_type] = ACTIONS(3293),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [sym_identifier] = ACTIONS(492),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(3293),
    [anon_sym_typename] = ACTIONS(1479),
    [anon_sym_COLON_COLON] = ACTIONS(315),
  },
  [819] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1556),
    [anon_sym_SEMI] = ACTIONS(653),
    [anon_sym_extern] = ACTIONS(655),
    [anon_sym_LPAREN2] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(653),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_register] = ACTIONS(655),
    [anon_sym_inline] = ACTIONS(655),
    [anon_sym_const] = ACTIONS(655),
    [anon_sym_restrict] = ACTIONS(655),
    [anon_sym_volatile] = ACTIONS(655),
    [anon_sym__Atomic] = ACTIONS(655),
    [anon_sym_mutable] = ACTIONS(655),
    [anon_sym_explicit] = ACTIONS(655),
    [anon_sym_constexpr] = ACTIONS(655),
    [anon_sym_unsigned] = ACTIONS(3295),
    [anon_sym_long] = ACTIONS(3295),
    [anon_sym_short] = ACTIONS(3295),
    [sym_primitive_type] = ACTIONS(659),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [anon_sym_TILDE] = ACTIONS(653),
    [sym_identifier] = ACTIONS(661),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(653),
    [sym_operator_name] = ACTIONS(653),
  },
  [820] = {
    [sym_destructor_name] = STATE(958),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(3297),
    [sym_comment] = ACTIONS(91),
    [sym_operator_name] = ACTIONS(1767),
  },
  [821] = {
    [sym_storage_class_specifier] = STATE(1558),
    [sym_type_qualifier] = STATE(1558),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1558),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_LPAREN2] = ACTIONS(1689),
    [anon_sym_STAR] = ACTIONS(1689),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(1691),
    [anon_sym_AMP_AMP] = ACTIONS(1689),
    [anon_sym_TILDE] = ACTIONS(1689),
    [sym_identifier] = ACTIONS(1691),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1689),
    [sym_operator_name] = ACTIONS(1689),
  },
  [822] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(822),
    [anon_sym_extern] = ACTIONS(1987),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1985),
    [anon_sym_static] = ACTIONS(1987),
    [anon_sym_register] = ACTIONS(1987),
    [anon_sym_inline] = ACTIONS(1987),
    [anon_sym_const] = ACTIONS(1987),
    [anon_sym_restrict] = ACTIONS(1987),
    [anon_sym_volatile] = ACTIONS(1987),
    [anon_sym__Atomic] = ACTIONS(1987),
    [anon_sym_mutable] = ACTIONS(1987),
    [anon_sym_explicit] = ACTIONS(1987),
    [anon_sym_constexpr] = ACTIONS(1987),
    [anon_sym_unsigned] = ACTIONS(3299),
    [anon_sym_long] = ACTIONS(3299),
    [anon_sym_short] = ACTIONS(3299),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1985),
    [sym_operator_name] = ACTIONS(1985),
  },
  [823] = {
    [sym__expression] = STATE(1559),
    [sym_conditional_expression] = STATE(1559),
    [sym_assignment_expression] = STATE(1559),
    [sym_pointer_expression] = STATE(1559),
    [sym_logical_expression] = STATE(1559),
    [sym_bitwise_expression] = STATE(1559),
    [sym_equality_expression] = STATE(1559),
    [sym_relational_expression] = STATE(1559),
    [sym_shift_expression] = STATE(1559),
    [sym_math_expression] = STATE(1559),
    [sym_cast_expression] = STATE(1559),
    [sym_sizeof_expression] = STATE(1559),
    [sym_subscript_expression] = STATE(1559),
    [sym_call_expression] = STATE(1559),
    [sym_field_expression] = STATE(1559),
    [sym_compound_literal_expression] = STATE(1559),
    [sym_parenthesized_expression] = STATE(1559),
    [sym_char_literal] = STATE(1559),
    [sym_concatenated_string] = STATE(1559),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1559),
    [sym_new_expression] = STATE(1559),
    [sym_delete_expression] = STATE(1559),
    [sym_lambda_expression] = STATE(1559),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3302),
    [anon_sym_LPAREN2] = ACTIONS(947),
    [anon_sym_STAR] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(947),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(3302),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(3304),
    [sym_false] = ACTIONS(3304),
    [sym_null] = ACTIONS(3304),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(3304),
  },
  [824] = {
    [sym_raw_string_literal] = ACTIONS(3306),
    [ts_builtin_sym_end] = ACTIONS(3306),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3308),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3308),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3308),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3308),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3308),
    [sym_preproc_directive] = ACTIONS(3308),
    [anon_sym_SEMI] = ACTIONS(3306),
    [anon_sym_typedef] = ACTIONS(3308),
    [anon_sym_extern] = ACTIONS(3308),
    [anon_sym_LBRACE] = ACTIONS(3306),
    [anon_sym_RBRACE] = ACTIONS(3306),
    [anon_sym_LPAREN2] = ACTIONS(3306),
    [anon_sym_STAR] = ACTIONS(3306),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_static] = ACTIONS(3308),
    [anon_sym_register] = ACTIONS(3308),
    [anon_sym_inline] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3308),
    [anon_sym_restrict] = ACTIONS(3308),
    [anon_sym_volatile] = ACTIONS(3308),
    [anon_sym__Atomic] = ACTIONS(3308),
    [anon_sym_mutable] = ACTIONS(3308),
    [anon_sym_explicit] = ACTIONS(3308),
    [anon_sym_constexpr] = ACTIONS(3308),
    [anon_sym_unsigned] = ACTIONS(3308),
    [anon_sym_long] = ACTIONS(3308),
    [anon_sym_short] = ACTIONS(3308),
    [sym_primitive_type] = ACTIONS(3308),
    [anon_sym_enum] = ACTIONS(3308),
    [anon_sym_struct] = ACTIONS(3308),
    [anon_sym_union] = ACTIONS(3308),
    [anon_sym_if] = ACTIONS(3308),
    [anon_sym_switch] = ACTIONS(3308),
    [anon_sym_case] = ACTIONS(3308),
    [anon_sym_default] = ACTIONS(3308),
    [anon_sym_while] = ACTIONS(3308),
    [anon_sym_do] = ACTIONS(3308),
    [anon_sym_for] = ACTIONS(3308),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_break] = ACTIONS(3308),
    [anon_sym_continue] = ACTIONS(3308),
    [anon_sym_goto] = ACTIONS(3308),
    [anon_sym_AMP] = ACTIONS(3308),
    [anon_sym_AMP_AMP] = ACTIONS(3306),
    [anon_sym_BANG] = ACTIONS(3306),
    [anon_sym_TILDE] = ACTIONS(3306),
    [anon_sym_PLUS] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_DASH_DASH] = ACTIONS(3306),
    [anon_sym_PLUS_PLUS] = ACTIONS(3306),
    [anon_sym_sizeof] = ACTIONS(3308),
    [sym_number_literal] = ACTIONS(3306),
    [anon_sym_SQUOTE] = ACTIONS(3306),
    [anon_sym_DQUOTE] = ACTIONS(3306),
    [sym_true] = ACTIONS(3308),
    [sym_false] = ACTIONS(3308),
    [sym_null] = ACTIONS(3308),
    [sym_identifier] = ACTIONS(3308),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3308),
    [sym_auto] = ACTIONS(3308),
    [anon_sym_typename] = ACTIONS(3308),
    [anon_sym_template] = ACTIONS(3308),
    [anon_sym_delete] = ACTIONS(3308),
    [anon_sym_namespace] = ACTIONS(3308),
    [anon_sym_using] = ACTIONS(3308),
    [anon_sym_try] = ACTIONS(3308),
    [anon_sym_new] = ACTIONS(3308),
    [anon_sym_COLON_COLON] = ACTIONS(3306),
    [sym_operator_name] = ACTIONS(3306),
    [sym_nullptr] = ACTIONS(3308),
  },
  [825] = {
    [anon_sym_LPAREN2] = ACTIONS(3310),
    [anon_sym_constexpr] = ACTIONS(3312),
    [sym_comment] = ACTIONS(91),
  },
  [826] = {
    [sym_parenthesized_expression] = STATE(1562),
    [anon_sym_LPAREN2] = ACTIONS(323),
    [sym_comment] = ACTIONS(91),
  },
  [827] = {
    [sym__expression] = STATE(1563),
    [sym_conditional_expression] = STATE(1563),
    [sym_assignment_expression] = STATE(1563),
    [sym_pointer_expression] = STATE(1563),
    [sym_logical_expression] = STATE(1563),
    [sym_bitwise_expression] = STATE(1563),
    [sym_equality_expression] = STATE(1563),
    [sym_relational_expression] = STATE(1563),
    [sym_shift_expression] = STATE(1563),
    [sym_math_expression] = STATE(1563),
    [sym_cast_expression] = STATE(1563),
    [sym_sizeof_expression] = STATE(1563),
    [sym_subscript_expression] = STATE(1563),
    [sym_call_expression] = STATE(1563),
    [sym_field_expression] = STATE(1563),
    [sym_compound_literal_expression] = STATE(1563),
    [sym_parenthesized_expression] = STATE(1563),
    [sym_char_literal] = STATE(1563),
    [sym_concatenated_string] = STATE(1563),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1563),
    [sym_new_expression] = STATE(1563),
    [sym_delete_expression] = STATE(1563),
    [sym_lambda_expression] = STATE(1563),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(3314),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(3316),
    [sym_false] = ACTIONS(3316),
    [sym_null] = ACTIONS(3316),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(3316),
  },
  [828] = {
    [anon_sym_COLON] = ACTIONS(3318),
    [sym_comment] = ACTIONS(91),
  },
  [829] = {
    [sym_parenthesized_expression] = STATE(1565),
    [anon_sym_LPAREN2] = ACTIONS(323),
    [sym_comment] = ACTIONS(91),
  },
  [830] = {
    [anon_sym_LPAREN2] = ACTIONS(3320),
    [sym_comment] = ACTIONS(91),
  },
  [831] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(263),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(465),
    [anon_sym_extern] = ACTIONS(468),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(470),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_LBRACK] = ACTIONS(470),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_register] = ACTIONS(468),
    [anon_sym_inline] = ACTIONS(468),
    [anon_sym_const] = ACTIONS(468),
    [anon_sym_restrict] = ACTIONS(468),
    [anon_sym_volatile] = ACTIONS(468),
    [anon_sym__Atomic] = ACTIONS(468),
    [anon_sym_mutable] = ACTIONS(468),
    [anon_sym_explicit] = ACTIONS(468),
    [anon_sym_constexpr] = ACTIONS(468),
    [anon_sym_COLON] = ACTIONS(3322),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(474),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_TILDE] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_identifier] = ACTIONS(468),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(486),
    [sym_operator_name] = ACTIONS(481),
  },
  [832] = {
    [sym_compound_statement] = STATE(1568),
    [anon_sym_LBRACE] = ACTIONS(357),
    [sym_comment] = ACTIONS(91),
  },
  [833] = {
    [sym_preproc_include] = STATE(1570),
    [sym_preproc_def] = STATE(1570),
    [sym_preproc_function_def] = STATE(1570),
    [sym_preproc_call] = STATE(1570),
    [sym_preproc_if] = STATE(1570),
    [sym_preproc_ifdef] = STATE(1570),
    [sym_function_definition] = STATE(1570),
    [sym_declaration] = STATE(1570),
    [sym_type_definition] = STATE(1570),
    [sym__declaration_specifiers] = STATE(49),
    [sym_linkage_specification] = STATE(1570),
    [sym__declarator] = STATE(50),
    [sym_pointer_declarator] = STATE(50),
    [sym_function_declarator] = STATE(51),
    [sym_array_declarator] = STATE(50),
    [sym_compound_statement] = STATE(1570),
    [sym_storage_class_specifier] = STATE(63),
    [sym_type_qualifier] = STATE(63),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(1570),
    [sym_expression_statement] = STATE(1570),
    [sym_if_statement] = STATE(1570),
    [sym_switch_statement] = STATE(1570),
    [sym_case_statement] = STATE(1570),
    [sym_while_statement] = STATE(1570),
    [sym_do_statement] = STATE(1570),
    [sym_for_statement] = STATE(1570),
    [sym_return_statement] = STATE(1570),
    [sym_break_statement] = STATE(1570),
    [sym_continue_statement] = STATE(1570),
    [sym_goto_statement] = STATE(1570),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(1570),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(1570),
    [sym_template_declaration] = STATE(1570),
    [sym_template_instantiation] = STATE(1570),
    [sym_constructor_or_destructor_definition] = STATE(1570),
    [sym_reference_declarator] = STATE(50),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(57),
    [sym_namespace_definition] = STATE(1570),
    [sym_using_declaration] = STATE(1570),
    [sym_alias_declaration] = STATE(1570),
    [sym_for_range_loop] = STATE(1570),
    [sym_try_statement] = STATE(1570),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_destructor_name] = STATE(50),
    [sym_scoped_identifier] = STATE(59),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_translation_unit_repeat1] = STATE(1570),
    [aux_sym__declaration_specifiers_repeat1] = STATE(63),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(5),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(9),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(13),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(15),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(15),
    [sym_preproc_directive] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_RBRACE] = ACTIONS(3324),
    [anon_sym_LPAREN2] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(1495),
    [anon_sym_switch] = ACTIONS(1497),
    [anon_sym_case] = ACTIONS(1499),
    [anon_sym_default] = ACTIONS(1501),
    [anon_sym_while] = ACTIONS(1503),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(1505),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(1507),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_template] = ACTIONS(97),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_namespace] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(103),
    [anon_sym_try] = ACTIONS(1509),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_operator_name] = ACTIONS(111),
    [sym_nullptr] = ACTIONS(87),
  },
  [834] = {
    [sym_raw_string_literal] = ACTIONS(3326),
    [ts_builtin_sym_end] = ACTIONS(3326),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3328),
    [sym_preproc_directive] = ACTIONS(3328),
    [anon_sym_SEMI] = ACTIONS(3326),
    [anon_sym_typedef] = ACTIONS(3328),
    [anon_sym_extern] = ACTIONS(3328),
    [anon_sym_LBRACE] = ACTIONS(3326),
    [anon_sym_RBRACE] = ACTIONS(3326),
    [anon_sym_LPAREN2] = ACTIONS(3326),
    [anon_sym_STAR] = ACTIONS(3326),
    [anon_sym_LBRACK] = ACTIONS(3326),
    [anon_sym_static] = ACTIONS(3328),
    [anon_sym_register] = ACTIONS(3328),
    [anon_sym_inline] = ACTIONS(3328),
    [anon_sym_const] = ACTIONS(3328),
    [anon_sym_restrict] = ACTIONS(3328),
    [anon_sym_volatile] = ACTIONS(3328),
    [anon_sym__Atomic] = ACTIONS(3328),
    [anon_sym_mutable] = ACTIONS(3328),
    [anon_sym_explicit] = ACTIONS(3328),
    [anon_sym_constexpr] = ACTIONS(3328),
    [anon_sym_unsigned] = ACTIONS(3328),
    [anon_sym_long] = ACTIONS(3328),
    [anon_sym_short] = ACTIONS(3328),
    [sym_primitive_type] = ACTIONS(3328),
    [anon_sym_enum] = ACTIONS(3328),
    [anon_sym_struct] = ACTIONS(3328),
    [anon_sym_union] = ACTIONS(3328),
    [anon_sym_if] = ACTIONS(3328),
    [anon_sym_switch] = ACTIONS(3328),
    [anon_sym_case] = ACTIONS(3328),
    [anon_sym_default] = ACTIONS(3328),
    [anon_sym_while] = ACTIONS(3328),
    [anon_sym_do] = ACTIONS(3328),
    [anon_sym_for] = ACTIONS(3328),
    [anon_sym_return] = ACTIONS(3328),
    [anon_sym_break] = ACTIONS(3328),
    [anon_sym_continue] = ACTIONS(3328),
    [anon_sym_goto] = ACTIONS(3328),
    [anon_sym_AMP] = ACTIONS(3328),
    [anon_sym_AMP_AMP] = ACTIONS(3326),
    [anon_sym_BANG] = ACTIONS(3326),
    [anon_sym_TILDE] = ACTIONS(3326),
    [anon_sym_PLUS] = ACTIONS(3328),
    [anon_sym_DASH] = ACTIONS(3328),
    [anon_sym_DASH_DASH] = ACTIONS(3326),
    [anon_sym_PLUS_PLUS] = ACTIONS(3326),
    [anon_sym_sizeof] = ACTIONS(3328),
    [sym_number_literal] = ACTIONS(3326),
    [anon_sym_SQUOTE] = ACTIONS(3326),
    [anon_sym_DQUOTE] = ACTIONS(3326),
    [sym_true] = ACTIONS(3328),
    [sym_false] = ACTIONS(3328),
    [sym_null] = ACTIONS(3328),
    [sym_identifier] = ACTIONS(3328),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3328),
    [sym_auto] = ACTIONS(3328),
    [anon_sym_typename] = ACTIONS(3328),
    [anon_sym_template] = ACTIONS(3328),
    [anon_sym_delete] = ACTIONS(3328),
    [anon_sym_namespace] = ACTIONS(3328),
    [anon_sym_using] = ACTIONS(3328),
    [anon_sym_try] = ACTIONS(3328),
    [anon_sym_new] = ACTIONS(3328),
    [anon_sym_COLON_COLON] = ACTIONS(3326),
    [sym_operator_name] = ACTIONS(3326),
    [sym_nullptr] = ACTIONS(3328),
  },
  [835] = {
    [sym_raw_string_literal] = ACTIONS(3330),
    [ts_builtin_sym_end] = ACTIONS(3330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3332),
    [sym_preproc_directive] = ACTIONS(3332),
    [anon_sym_SEMI] = ACTIONS(3330),
    [anon_sym_typedef] = ACTIONS(3332),
    [anon_sym_extern] = ACTIONS(3332),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_RBRACE] = ACTIONS(3330),
    [anon_sym_LPAREN2] = ACTIONS(3330),
    [anon_sym_STAR] = ACTIONS(3330),
    [anon_sym_LBRACK] = ACTIONS(3330),
    [anon_sym_static] = ACTIONS(3332),
    [anon_sym_register] = ACTIONS(3332),
    [anon_sym_inline] = ACTIONS(3332),
    [anon_sym_const] = ACTIONS(3332),
    [anon_sym_restrict] = ACTIONS(3332),
    [anon_sym_volatile] = ACTIONS(3332),
    [anon_sym__Atomic] = ACTIONS(3332),
    [anon_sym_mutable] = ACTIONS(3332),
    [anon_sym_explicit] = ACTIONS(3332),
    [anon_sym_constexpr] = ACTIONS(3332),
    [anon_sym_unsigned] = ACTIONS(3332),
    [anon_sym_long] = ACTIONS(3332),
    [anon_sym_short] = ACTIONS(3332),
    [sym_primitive_type] = ACTIONS(3332),
    [anon_sym_enum] = ACTIONS(3332),
    [anon_sym_struct] = ACTIONS(3332),
    [anon_sym_union] = ACTIONS(3332),
    [anon_sym_if] = ACTIONS(3332),
    [anon_sym_switch] = ACTIONS(3332),
    [anon_sym_case] = ACTIONS(3332),
    [anon_sym_default] = ACTIONS(3332),
    [anon_sym_while] = ACTIONS(3332),
    [anon_sym_do] = ACTIONS(3332),
    [anon_sym_for] = ACTIONS(3332),
    [anon_sym_return] = ACTIONS(3332),
    [anon_sym_break] = ACTIONS(3332),
    [anon_sym_continue] = ACTIONS(3332),
    [anon_sym_goto] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(3332),
    [anon_sym_AMP_AMP] = ACTIONS(3330),
    [anon_sym_BANG] = ACTIONS(3330),
    [anon_sym_TILDE] = ACTIONS(3330),
    [anon_sym_PLUS] = ACTIONS(3332),
    [anon_sym_DASH] = ACTIONS(3332),
    [anon_sym_DASH_DASH] = ACTIONS(3330),
    [anon_sym_PLUS_PLUS] = ACTIONS(3330),
    [anon_sym_sizeof] = ACTIONS(3332),
    [sym_number_literal] = ACTIONS(3330),
    [anon_sym_SQUOTE] = ACTIONS(3330),
    [anon_sym_DQUOTE] = ACTIONS(3330),
    [sym_true] = ACTIONS(3332),
    [sym_false] = ACTIONS(3332),
    [sym_null] = ACTIONS(3332),
    [sym_identifier] = ACTIONS(3332),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3332),
    [sym_auto] = ACTIONS(3332),
    [anon_sym_typename] = ACTIONS(3332),
    [anon_sym_template] = ACTIONS(3332),
    [anon_sym_delete] = ACTIONS(3332),
    [anon_sym_namespace] = ACTIONS(3332),
    [anon_sym_using] = ACTIONS(3332),
    [anon_sym_try] = ACTIONS(3332),
    [anon_sym_new] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(3330),
    [sym_operator_name] = ACTIONS(3330),
    [sym_nullptr] = ACTIONS(3332),
  },
  [836] = {
    [sym_type_qualifier] = STATE(1574),
    [sym__type_specifier] = STATE(1572),
    [sym_sized_type_specifier] = STATE(1572),
    [sym_enum_specifier] = STATE(1572),
    [sym_struct_specifier] = STATE(1572),
    [sym_union_specifier] = STATE(1572),
    [sym_type_descriptor] = STATE(1573),
    [sym_macro_type_specifier] = STATE(1572),
    [sym_class_specifier] = STATE(1572),
    [sym_dependent_type] = STATE(1572),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_type_definition_repeat1] = STATE(1574),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1575),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(3334),
    [anon_sym_long] = ACTIONS(3334),
    [anon_sym_short] = ACTIONS(3334),
    [sym_primitive_type] = ACTIONS(3336),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(3336),
    [anon_sym_typename] = ACTIONS(3338),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [837] = {
    [sym_destructor_name] = STATE(789),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(3340),
    [sym_comment] = ACTIONS(91),
    [sym_operator_name] = ACTIONS(1418),
  },
  [838] = {
    [sym_template_argument_list] = STATE(437),
    [anon_sym_SEMI] = ACTIONS(3342),
    [anon_sym_LT] = ACTIONS(945),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1519),
  },
  [839] = {
    [anon_sym_SEMI] = ACTIONS(3342),
    [sym_comment] = ACTIONS(91),
  },
  [840] = {
    [anon_sym_SEMI] = ACTIONS(1575),
    [anon_sym_LT] = ACTIONS(1582),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
  },
  [841] = {
    [sym_destructor_name] = STATE(958),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(3344),
    [sym_comment] = ACTIONS(91),
    [sym_operator_name] = ACTIONS(1767),
  },
  [842] = {
    [sym_parameter_list] = STATE(1579),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [sym_comment] = ACTIONS(91),
  },
  [843] = {
    [sym_catch_clause] = STATE(1580),
    [aux_sym_try_statement_repeat1] = STATE(1580),
    [sym_raw_string_literal] = ACTIONS(3346),
    [ts_builtin_sym_end] = ACTIONS(3346),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3348),
    [sym_preproc_directive] = ACTIONS(3348),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym_typedef] = ACTIONS(3348),
    [anon_sym_extern] = ACTIONS(3348),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(3346),
    [anon_sym_static] = ACTIONS(3348),
    [anon_sym_register] = ACTIONS(3348),
    [anon_sym_inline] = ACTIONS(3348),
    [anon_sym_const] = ACTIONS(3348),
    [anon_sym_restrict] = ACTIONS(3348),
    [anon_sym_volatile] = ACTIONS(3348),
    [anon_sym__Atomic] = ACTIONS(3348),
    [anon_sym_mutable] = ACTIONS(3348),
    [anon_sym_explicit] = ACTIONS(3348),
    [anon_sym_constexpr] = ACTIONS(3348),
    [anon_sym_unsigned] = ACTIONS(3348),
    [anon_sym_long] = ACTIONS(3348),
    [anon_sym_short] = ACTIONS(3348),
    [sym_primitive_type] = ACTIONS(3348),
    [anon_sym_enum] = ACTIONS(3348),
    [anon_sym_struct] = ACTIONS(3348),
    [anon_sym_union] = ACTIONS(3348),
    [anon_sym_if] = ACTIONS(3348),
    [anon_sym_switch] = ACTIONS(3348),
    [anon_sym_case] = ACTIONS(3348),
    [anon_sym_default] = ACTIONS(3348),
    [anon_sym_while] = ACTIONS(3348),
    [anon_sym_do] = ACTIONS(3348),
    [anon_sym_for] = ACTIONS(3348),
    [anon_sym_return] = ACTIONS(3348),
    [anon_sym_break] = ACTIONS(3348),
    [anon_sym_continue] = ACTIONS(3348),
    [anon_sym_goto] = ACTIONS(3348),
    [anon_sym_AMP] = ACTIONS(3348),
    [anon_sym_AMP_AMP] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_PLUS] = ACTIONS(3348),
    [anon_sym_DASH] = ACTIONS(3348),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_sizeof] = ACTIONS(3348),
    [sym_number_literal] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [sym_true] = ACTIONS(3348),
    [sym_false] = ACTIONS(3348),
    [sym_null] = ACTIONS(3348),
    [sym_identifier] = ACTIONS(3348),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3348),
    [sym_auto] = ACTIONS(3348),
    [anon_sym_typename] = ACTIONS(3348),
    [anon_sym_template] = ACTIONS(3348),
    [anon_sym_delete] = ACTIONS(3348),
    [anon_sym_namespace] = ACTIONS(3348),
    [anon_sym_using] = ACTIONS(3348),
    [anon_sym_try] = ACTIONS(3348),
    [anon_sym_catch] = ACTIONS(3350),
    [anon_sym_new] = ACTIONS(3348),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [sym_operator_name] = ACTIONS(3346),
    [sym_nullptr] = ACTIONS(3348),
  },
  [844] = {
    [anon_sym_COMMA] = ACTIONS(3352),
    [anon_sym_RPAREN] = ACTIONS(3352),
    [anon_sym_SEMI] = ACTIONS(3352),
    [anon_sym_LBRACE] = ACTIONS(3352),
    [anon_sym_RBRACE] = ACTIONS(3352),
    [anon_sym_LPAREN2] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(3354),
    [anon_sym_LBRACK] = ACTIONS(3352),
    [anon_sym_RBRACK] = ACTIONS(3352),
    [anon_sym_EQ] = ACTIONS(3354),
    [anon_sym_unsigned] = ACTIONS(3354),
    [anon_sym_long] = ACTIONS(3354),
    [anon_sym_short] = ACTIONS(3354),
    [sym_primitive_type] = ACTIONS(3354),
    [anon_sym_enum] = ACTIONS(3354),
    [anon_sym_struct] = ACTIONS(3354),
    [anon_sym_union] = ACTIONS(3354),
    [anon_sym_QMARK] = ACTIONS(3352),
    [anon_sym_STAR_EQ] = ACTIONS(3352),
    [anon_sym_SLASH_EQ] = ACTIONS(3352),
    [anon_sym_PERCENT_EQ] = ACTIONS(3352),
    [anon_sym_PLUS_EQ] = ACTIONS(3352),
    [anon_sym_DASH_EQ] = ACTIONS(3352),
    [anon_sym_LT_LT_EQ] = ACTIONS(3352),
    [anon_sym_GT_GT_EQ] = ACTIONS(3352),
    [anon_sym_AMP_EQ] = ACTIONS(3352),
    [anon_sym_CARET_EQ] = ACTIONS(3352),
    [anon_sym_PIPE_EQ] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3354),
    [anon_sym_PIPE_PIPE] = ACTIONS(3352),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_PIPE] = ACTIONS(3354),
    [anon_sym_CARET] = ACTIONS(3354),
    [anon_sym_EQ_EQ] = ACTIONS(3352),
    [anon_sym_BANG_EQ] = ACTIONS(3352),
    [anon_sym_LT] = ACTIONS(3354),
    [anon_sym_GT] = ACTIONS(3354),
    [anon_sym_LT_EQ] = ACTIONS(3352),
    [anon_sym_GT_EQ] = ACTIONS(3352),
    [anon_sym_LT_LT] = ACTIONS(3354),
    [anon_sym_GT_GT] = ACTIONS(3354),
    [anon_sym_PLUS] = ACTIONS(3354),
    [anon_sym_DASH] = ACTIONS(3354),
    [anon_sym_SLASH] = ACTIONS(3354),
    [anon_sym_PERCENT] = ACTIONS(3354),
    [anon_sym_DASH_DASH] = ACTIONS(3352),
    [anon_sym_PLUS_PLUS] = ACTIONS(3352),
    [anon_sym_DOT] = ACTIONS(3352),
    [anon_sym_DASH_GT] = ACTIONS(3352),
    [sym_identifier] = ACTIONS(3354),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3354),
    [sym_auto] = ACTIONS(3354),
    [anon_sym_typename] = ACTIONS(3354),
    [anon_sym_COLON_COLON] = ACTIONS(3352),
  },
  [845] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_argument_list_repeat1] = STATE(1583),
    [anon_sym_COMMA] = ACTIONS(3356),
    [anon_sym_RPAREN] = ACTIONS(3358),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [846] = {
    [aux_sym_argument_list_repeat1] = STATE(1583),
    [anon_sym_COMMA] = ACTIONS(3356),
    [anon_sym_RPAREN] = ACTIONS(3358),
    [sym_comment] = ACTIONS(91),
  },
  [847] = {
    [sym_enumerator] = STATE(1586),
    [anon_sym_COMMA] = ACTIONS(3360),
    [anon_sym_RBRACE] = ACTIONS(3362),
    [sym_identifier] = ACTIONS(1009),
    [sym_comment] = ACTIONS(91),
  },
  [848] = {
    [sym_enumerator_list] = STATE(1587),
    [anon_sym_COMMA] = ACTIONS(1011),
    [anon_sym_RPAREN] = ACTIONS(1011),
    [anon_sym_SEMI] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_RBRACE] = ACTIONS(1011),
    [anon_sym_LPAREN2] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(1011),
    [anon_sym_RBRACK] = ACTIONS(1011),
    [anon_sym_EQ] = ACTIONS(1013),
    [anon_sym_COLON] = ACTIONS(1011),
    [anon_sym_QMARK] = ACTIONS(1011),
    [anon_sym_STAR_EQ] = ACTIONS(1011),
    [anon_sym_SLASH_EQ] = ACTIONS(1011),
    [anon_sym_PERCENT_EQ] = ACTIONS(1011),
    [anon_sym_PLUS_EQ] = ACTIONS(1011),
    [anon_sym_DASH_EQ] = ACTIONS(1011),
    [anon_sym_LT_LT_EQ] = ACTIONS(1011),
    [anon_sym_GT_GT_EQ] = ACTIONS(1011),
    [anon_sym_AMP_EQ] = ACTIONS(1011),
    [anon_sym_CARET_EQ] = ACTIONS(1011),
    [anon_sym_PIPE_EQ] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1013),
    [anon_sym_PIPE_PIPE] = ACTIONS(1011),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_PIPE] = ACTIONS(1013),
    [anon_sym_CARET] = ACTIONS(1013),
    [anon_sym_EQ_EQ] = ACTIONS(1011),
    [anon_sym_BANG_EQ] = ACTIONS(1011),
    [anon_sym_LT] = ACTIONS(1013),
    [anon_sym_GT] = ACTIONS(1013),
    [anon_sym_LT_EQ] = ACTIONS(1011),
    [anon_sym_GT_EQ] = ACTIONS(1011),
    [anon_sym_LT_LT] = ACTIONS(1013),
    [anon_sym_GT_GT] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_SLASH] = ACTIONS(1013),
    [anon_sym_PERCENT] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1011),
    [anon_sym_PLUS_PLUS] = ACTIONS(1011),
    [anon_sym_DOT] = ACTIONS(1011),
    [anon_sym_DASH_GT] = ACTIONS(1011),
    [sym_comment] = ACTIONS(91),
  },
  [849] = {
    [anon_sym_COMMA] = ACTIONS(1015),
    [anon_sym_RPAREN] = ACTIONS(1015),
    [anon_sym_SEMI] = ACTIONS(1015),
    [anon_sym_LBRACE] = ACTIONS(1015),
    [anon_sym_RBRACE] = ACTIONS(1015),
    [anon_sym_LPAREN2] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1015),
    [anon_sym_RBRACK] = ACTIONS(1015),
    [anon_sym_EQ] = ACTIONS(1017),
    [anon_sym_COLON] = ACTIONS(1015),
    [anon_sym_QMARK] = ACTIONS(1015),
    [anon_sym_STAR_EQ] = ACTIONS(1015),
    [anon_sym_SLASH_EQ] = ACTIONS(1015),
    [anon_sym_PERCENT_EQ] = ACTIONS(1015),
    [anon_sym_PLUS_EQ] = ACTIONS(1015),
    [anon_sym_DASH_EQ] = ACTIONS(1015),
    [anon_sym_LT_LT_EQ] = ACTIONS(1015),
    [anon_sym_GT_GT_EQ] = ACTIONS(1015),
    [anon_sym_AMP_EQ] = ACTIONS(1015),
    [anon_sym_CARET_EQ] = ACTIONS(1015),
    [anon_sym_PIPE_EQ] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(1017),
    [anon_sym_PIPE_PIPE] = ACTIONS(1015),
    [anon_sym_AMP_AMP] = ACTIONS(1015),
    [anon_sym_PIPE] = ACTIONS(1017),
    [anon_sym_CARET] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1015),
    [anon_sym_BANG_EQ] = ACTIONS(1015),
    [anon_sym_LT] = ACTIONS(1017),
    [anon_sym_GT] = ACTIONS(1017),
    [anon_sym_LT_EQ] = ACTIONS(1015),
    [anon_sym_GT_EQ] = ACTIONS(1015),
    [anon_sym_LT_LT] = ACTIONS(1017),
    [anon_sym_GT_GT] = ACTIONS(1017),
    [anon_sym_PLUS] = ACTIONS(1017),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1017),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_DOT] = ACTIONS(1015),
    [anon_sym_DASH_GT] = ACTIONS(1015),
    [sym_comment] = ACTIONS(91),
  },
  [850] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(1589),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1589),
    [sym_type_definition] = STATE(1589),
    [sym__declaration_specifiers] = STATE(598),
    [sym__declarator] = STATE(599),
    [sym_pointer_declarator] = STATE(599),
    [sym_function_declarator] = STATE(600),
    [sym_array_declarator] = STATE(599),
    [sym_storage_class_specifier] = STATE(605),
    [sym_type_qualifier] = STATE(605),
    [sym__type_specifier] = STATE(601),
    [sym_sized_type_specifier] = STATE(601),
    [sym_enum_specifier] = STATE(601),
    [sym_struct_specifier] = STATE(601),
    [sym_union_specifier] = STATE(601),
    [sym__field_declaration_list_item] = STATE(1589),
    [sym_field_declaration] = STATE(1589),
    [sym_macro_type_specifier] = STATE(601),
    [sym_class_specifier] = STATE(601),
    [sym_dependent_type] = STATE(601),
    [sym_template_declaration] = STATE(1589),
    [sym_inline_method_definition] = STATE(1589),
    [sym_constructor_or_destructor_definition] = STATE(1589),
    [sym_constructor_or_destructor_declaration] = STATE(1589),
    [sym_friend_declaration] = STATE(1589),
    [sym_access_specifier] = STATE(1589),
    [sym_reference_declarator] = STATE(599),
    [sym_template_type] = STATE(602),
    [sym_template_function] = STATE(599),
    [sym_using_declaration] = STATE(1589),
    [sym_alias_declaration] = STATE(1589),
    [sym_destructor_name] = STATE(599),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(603),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1589),
    [aux_sym__declaration_specifiers_repeat1] = STATE(605),
    [aux_sym_sized_type_specifier_repeat1] = STATE(606),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1019),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1021),
    [anon_sym_typedef] = ACTIONS(1023),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(3364),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(425),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(1027),
    [anon_sym_long] = ACTIONS(1027),
    [anon_sym_short] = ACTIONS(1027),
    [sym_primitive_type] = ACTIONS(1029),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(1031),
    [anon_sym_union] = ACTIONS(1033),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(1035),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1039),
    [sym_auto] = ACTIONS(1029),
    [anon_sym_typename] = ACTIONS(1041),
    [anon_sym_template] = ACTIONS(1043),
    [anon_sym_friend] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1039),
    [anon_sym_protected] = ACTIONS(1039),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_COLON_COLON] = ACTIONS(1049),
    [sym_operator_name] = ACTIONS(1051),
  },
  [851] = {
    [sym_field_declaration_list] = STATE(1590),
    [sym_virtual_specifier] = STATE(1591),
    [sym_base_class_clause] = STATE(1592),
    [sym_template_argument_list] = STATE(864),
    [anon_sym_COMMA] = ACTIONS(1057),
    [anon_sym_RPAREN] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(1057),
    [anon_sym_LPAREN2] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_RBRACK] = ACTIONS(1057),
    [anon_sym_EQ] = ACTIONS(1059),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_QMARK] = ACTIONS(1057),
    [anon_sym_STAR_EQ] = ACTIONS(1057),
    [anon_sym_SLASH_EQ] = ACTIONS(1057),
    [anon_sym_PERCENT_EQ] = ACTIONS(1057),
    [anon_sym_PLUS_EQ] = ACTIONS(1057),
    [anon_sym_DASH_EQ] = ACTIONS(1057),
    [anon_sym_LT_LT_EQ] = ACTIONS(1057),
    [anon_sym_GT_GT_EQ] = ACTIONS(1057),
    [anon_sym_AMP_EQ] = ACTIONS(1057),
    [anon_sym_CARET_EQ] = ACTIONS(1057),
    [anon_sym_PIPE_EQ] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_EQ_EQ] = ACTIONS(1057),
    [anon_sym_BANG_EQ] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_LT_EQ] = ACTIONS(1057),
    [anon_sym_GT_EQ] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_SLASH] = ACTIONS(1059),
    [anon_sym_PERCENT] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1057),
    [anon_sym_PLUS_PLUS] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(1057),
    [anon_sym_DASH_GT] = ACTIONS(1057),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [anon_sym_COLON_COLON] = ACTIONS(1548),
  },
  [852] = {
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_RPAREN] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_LBRACE] = ACTIONS(1069),
    [anon_sym_RBRACE] = ACTIONS(1069),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(1069),
    [anon_sym_RBRACK] = ACTIONS(1069),
    [anon_sym_EQ] = ACTIONS(1071),
    [anon_sym_COLON] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(1069),
    [anon_sym_STAR_EQ] = ACTIONS(1069),
    [anon_sym_SLASH_EQ] = ACTIONS(1069),
    [anon_sym_PERCENT_EQ] = ACTIONS(1069),
    [anon_sym_PLUS_EQ] = ACTIONS(1069),
    [anon_sym_DASH_EQ] = ACTIONS(1069),
    [anon_sym_LT_LT_EQ] = ACTIONS(1069),
    [anon_sym_GT_GT_EQ] = ACTIONS(1069),
    [anon_sym_AMP_EQ] = ACTIONS(1069),
    [anon_sym_CARET_EQ] = ACTIONS(1069),
    [anon_sym_PIPE_EQ] = ACTIONS(1069),
    [anon_sym_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1069),
    [anon_sym_AMP_AMP] = ACTIONS(1069),
    [anon_sym_PIPE] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1071),
    [anon_sym_EQ_EQ] = ACTIONS(1069),
    [anon_sym_BANG_EQ] = ACTIONS(1069),
    [anon_sym_LT] = ACTIONS(1071),
    [anon_sym_GT] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1069),
    [anon_sym_GT_EQ] = ACTIONS(1069),
    [anon_sym_LT_LT] = ACTIONS(1071),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_DASH] = ACTIONS(1071),
    [anon_sym_SLASH] = ACTIONS(1071),
    [anon_sym_PERCENT] = ACTIONS(1071),
    [anon_sym_DASH_DASH] = ACTIONS(1069),
    [anon_sym_PLUS_PLUS] = ACTIONS(1069),
    [anon_sym_DOT] = ACTIONS(1069),
    [anon_sym_DASH_GT] = ACTIONS(1069),
    [sym_comment] = ACTIONS(91),
  },
  [853] = {
    [sym_field_declaration_list] = STATE(1593),
    [sym_base_class_clause] = STATE(1594),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [anon_sym_COLON] = ACTIONS(1073),
    [sym_comment] = ACTIONS(91),
  },
  [854] = {
    [sym_field_declaration_list] = STATE(1593),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [sym_comment] = ACTIONS(91),
  },
  [855] = {
    [sym_field_declaration_list] = STATE(1593),
    [sym_virtual_specifier] = STATE(1595),
    [sym_base_class_clause] = STATE(1594),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_RPAREN] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_LBRACE] = ACTIONS(1069),
    [anon_sym_RBRACE] = ACTIONS(1069),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(1069),
    [anon_sym_RBRACK] = ACTIONS(1069),
    [anon_sym_EQ] = ACTIONS(1071),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_QMARK] = ACTIONS(1069),
    [anon_sym_STAR_EQ] = ACTIONS(1069),
    [anon_sym_SLASH_EQ] = ACTIONS(1069),
    [anon_sym_PERCENT_EQ] = ACTIONS(1069),
    [anon_sym_PLUS_EQ] = ACTIONS(1069),
    [anon_sym_DASH_EQ] = ACTIONS(1069),
    [anon_sym_LT_LT_EQ] = ACTIONS(1069),
    [anon_sym_GT_GT_EQ] = ACTIONS(1069),
    [anon_sym_AMP_EQ] = ACTIONS(1069),
    [anon_sym_CARET_EQ] = ACTIONS(1069),
    [anon_sym_PIPE_EQ] = ACTIONS(1069),
    [anon_sym_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1069),
    [anon_sym_AMP_AMP] = ACTIONS(1069),
    [anon_sym_PIPE] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1071),
    [anon_sym_EQ_EQ] = ACTIONS(1069),
    [anon_sym_BANG_EQ] = ACTIONS(1069),
    [anon_sym_LT] = ACTIONS(1071),
    [anon_sym_GT] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1069),
    [anon_sym_GT_EQ] = ACTIONS(1069),
    [anon_sym_LT_LT] = ACTIONS(1071),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_DASH] = ACTIONS(1071),
    [anon_sym_SLASH] = ACTIONS(1071),
    [anon_sym_PERCENT] = ACTIONS(1071),
    [anon_sym_DASH_DASH] = ACTIONS(1069),
    [anon_sym_PLUS_PLUS] = ACTIONS(1069),
    [anon_sym_DOT] = ACTIONS(1069),
    [anon_sym_DASH_GT] = ACTIONS(1069),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [anon_sym_COLON_COLON] = ACTIONS(1564),
  },
  [856] = {
    [sym_field_declaration_list] = STATE(1593),
    [sym_virtual_specifier] = STATE(1595),
    [sym_base_class_clause] = STATE(1594),
    [sym_template_argument_list] = STATE(878),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_RPAREN] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_LBRACE] = ACTIONS(1069),
    [anon_sym_RBRACE] = ACTIONS(1069),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(1069),
    [anon_sym_RBRACK] = ACTIONS(1069),
    [anon_sym_EQ] = ACTIONS(1071),
    [anon_sym_COLON] = ACTIONS(1073),
    [anon_sym_QMARK] = ACTIONS(1069),
    [anon_sym_STAR_EQ] = ACTIONS(1069),
    [anon_sym_SLASH_EQ] = ACTIONS(1069),
    [anon_sym_PERCENT_EQ] = ACTIONS(1069),
    [anon_sym_PLUS_EQ] = ACTIONS(1069),
    [anon_sym_DASH_EQ] = ACTIONS(1069),
    [anon_sym_LT_LT_EQ] = ACTIONS(1069),
    [anon_sym_GT_GT_EQ] = ACTIONS(1069),
    [anon_sym_AMP_EQ] = ACTIONS(1069),
    [anon_sym_CARET_EQ] = ACTIONS(1069),
    [anon_sym_PIPE_EQ] = ACTIONS(1069),
    [anon_sym_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1069),
    [anon_sym_AMP_AMP] = ACTIONS(1069),
    [anon_sym_PIPE] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1071),
    [anon_sym_EQ_EQ] = ACTIONS(1069),
    [anon_sym_BANG_EQ] = ACTIONS(1069),
    [anon_sym_LT] = ACTIONS(1071),
    [anon_sym_GT] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1069),
    [anon_sym_GT_EQ] = ACTIONS(1069),
    [anon_sym_LT_LT] = ACTIONS(1071),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_DASH] = ACTIONS(1071),
    [anon_sym_SLASH] = ACTIONS(1071),
    [anon_sym_PERCENT] = ACTIONS(1071),
    [anon_sym_DASH_DASH] = ACTIONS(1069),
    [anon_sym_PLUS_PLUS] = ACTIONS(1069),
    [anon_sym_DOT] = ACTIONS(1069),
    [anon_sym_DASH_GT] = ACTIONS(1069),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
  },
  [857] = {
    [sym_field_declaration_list] = STATE(1596),
    [sym_virtual_specifier] = STATE(1597),
    [sym_base_class_clause] = STATE(1598),
    [sym_template_argument_list] = STATE(864),
    [anon_sym_COMMA] = ACTIONS(1077),
    [anon_sym_RPAREN] = ACTIONS(1077),
    [anon_sym_SEMI] = ACTIONS(1077),
    [anon_sym_LBRACE] = ACTIONS(1077),
    [anon_sym_RBRACE] = ACTIONS(1077),
    [anon_sym_LPAREN2] = ACTIONS(1077),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_LBRACK] = ACTIONS(1077),
    [anon_sym_RBRACK] = ACTIONS(1077),
    [anon_sym_EQ] = ACTIONS(1079),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_STAR_EQ] = ACTIONS(1077),
    [anon_sym_SLASH_EQ] = ACTIONS(1077),
    [anon_sym_PERCENT_EQ] = ACTIONS(1077),
    [anon_sym_PLUS_EQ] = ACTIONS(1077),
    [anon_sym_DASH_EQ] = ACTIONS(1077),
    [anon_sym_LT_LT_EQ] = ACTIONS(1077),
    [anon_sym_GT_GT_EQ] = ACTIONS(1077),
    [anon_sym_AMP_EQ] = ACTIONS(1077),
    [anon_sym_CARET_EQ] = ACTIONS(1077),
    [anon_sym_PIPE_EQ] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_PIPE_PIPE] = ACTIONS(1077),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_CARET] = ACTIONS(1079),
    [anon_sym_EQ_EQ] = ACTIONS(1077),
    [anon_sym_BANG_EQ] = ACTIONS(1077),
    [anon_sym_LT] = ACTIONS(1079),
    [anon_sym_GT] = ACTIONS(1079),
    [anon_sym_LT_EQ] = ACTIONS(1077),
    [anon_sym_GT_EQ] = ACTIONS(1077),
    [anon_sym_LT_LT] = ACTIONS(1079),
    [anon_sym_GT_GT] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(1079),
    [anon_sym_DASH] = ACTIONS(1079),
    [anon_sym_SLASH] = ACTIONS(1079),
    [anon_sym_PERCENT] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1077),
    [anon_sym_PLUS_PLUS] = ACTIONS(1077),
    [anon_sym_DOT] = ACTIONS(1077),
    [anon_sym_DASH_GT] = ACTIONS(1077),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [anon_sym_COLON_COLON] = ACTIONS(1548),
  },
  [858] = {
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_RPAREN] = ACTIONS(1081),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LBRACE] = ACTIONS(1081),
    [anon_sym_RBRACE] = ACTIONS(1081),
    [anon_sym_LPAREN2] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1083),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_RBRACK] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(1083),
    [anon_sym_COLON] = ACTIONS(1081),
    [anon_sym_QMARK] = ACTIONS(1081),
    [anon_sym_STAR_EQ] = ACTIONS(1081),
    [anon_sym_SLASH_EQ] = ACTIONS(1081),
    [anon_sym_PERCENT_EQ] = ACTIONS(1081),
    [anon_sym_PLUS_EQ] = ACTIONS(1081),
    [anon_sym_DASH_EQ] = ACTIONS(1081),
    [anon_sym_LT_LT_EQ] = ACTIONS(1081),
    [anon_sym_GT_GT_EQ] = ACTIONS(1081),
    [anon_sym_AMP_EQ] = ACTIONS(1081),
    [anon_sym_CARET_EQ] = ACTIONS(1081),
    [anon_sym_PIPE_EQ] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_PIPE] = ACTIONS(1083),
    [anon_sym_CARET] = ACTIONS(1083),
    [anon_sym_EQ_EQ] = ACTIONS(1081),
    [anon_sym_BANG_EQ] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(1083),
    [anon_sym_GT] = ACTIONS(1083),
    [anon_sym_LT_EQ] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1081),
    [anon_sym_LT_LT] = ACTIONS(1083),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_SLASH] = ACTIONS(1083),
    [anon_sym_PERCENT] = ACTIONS(1083),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DOT] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(1081),
    [sym_comment] = ACTIONS(91),
  },
  [859] = {
    [sym_field_declaration_list] = STATE(1599),
    [sym_base_class_clause] = STATE(1600),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [anon_sym_COLON] = ACTIONS(1073),
    [sym_comment] = ACTIONS(91),
  },
  [860] = {
    [sym_field_declaration_list] = STATE(1599),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [sym_comment] = ACTIONS(91),
  },
  [861] = {
    [sym_field_declaration_list] = STATE(1599),
    [sym_virtual_specifier] = STATE(1601),
    [sym_base_class_clause] = STATE(1600),
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_RPAREN] = ACTIONS(1081),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LBRACE] = ACTIONS(1081),
    [anon_sym_RBRACE] = ACTIONS(1081),
    [anon_sym_LPAREN2] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1083),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_RBRACK] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(1083),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_QMARK] = ACTIONS(1081),
    [anon_sym_STAR_EQ] = ACTIONS(1081),
    [anon_sym_SLASH_EQ] = ACTIONS(1081),
    [anon_sym_PERCENT_EQ] = ACTIONS(1081),
    [anon_sym_PLUS_EQ] = ACTIONS(1081),
    [anon_sym_DASH_EQ] = ACTIONS(1081),
    [anon_sym_LT_LT_EQ] = ACTIONS(1081),
    [anon_sym_GT_GT_EQ] = ACTIONS(1081),
    [anon_sym_AMP_EQ] = ACTIONS(1081),
    [anon_sym_CARET_EQ] = ACTIONS(1081),
    [anon_sym_PIPE_EQ] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_PIPE] = ACTIONS(1083),
    [anon_sym_CARET] = ACTIONS(1083),
    [anon_sym_EQ_EQ] = ACTIONS(1081),
    [anon_sym_BANG_EQ] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(1083),
    [anon_sym_GT] = ACTIONS(1083),
    [anon_sym_LT_EQ] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1081),
    [anon_sym_LT_LT] = ACTIONS(1083),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_SLASH] = ACTIONS(1083),
    [anon_sym_PERCENT] = ACTIONS(1083),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DOT] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(1081),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [anon_sym_COLON_COLON] = ACTIONS(1564),
  },
  [862] = {
    [sym_field_declaration_list] = STATE(1599),
    [sym_virtual_specifier] = STATE(1601),
    [sym_base_class_clause] = STATE(1600),
    [sym_template_argument_list] = STATE(878),
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_RPAREN] = ACTIONS(1081),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LBRACE] = ACTIONS(1081),
    [anon_sym_RBRACE] = ACTIONS(1081),
    [anon_sym_LPAREN2] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1083),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_RBRACK] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(1083),
    [anon_sym_COLON] = ACTIONS(1073),
    [anon_sym_QMARK] = ACTIONS(1081),
    [anon_sym_STAR_EQ] = ACTIONS(1081),
    [anon_sym_SLASH_EQ] = ACTIONS(1081),
    [anon_sym_PERCENT_EQ] = ACTIONS(1081),
    [anon_sym_PLUS_EQ] = ACTIONS(1081),
    [anon_sym_DASH_EQ] = ACTIONS(1081),
    [anon_sym_LT_LT_EQ] = ACTIONS(1081),
    [anon_sym_GT_GT_EQ] = ACTIONS(1081),
    [anon_sym_AMP_EQ] = ACTIONS(1081),
    [anon_sym_CARET_EQ] = ACTIONS(1081),
    [anon_sym_PIPE_EQ] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_PIPE] = ACTIONS(1083),
    [anon_sym_CARET] = ACTIONS(1083),
    [anon_sym_EQ_EQ] = ACTIONS(1081),
    [anon_sym_BANG_EQ] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(1083),
    [anon_sym_GT] = ACTIONS(1083),
    [anon_sym_LT_EQ] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1081),
    [anon_sym_LT_LT] = ACTIONS(1083),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_SLASH] = ACTIONS(1083),
    [anon_sym_PERCENT] = ACTIONS(1083),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DOT] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(1081),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
  },
  [863] = {
    [sym_identifier] = ACTIONS(3366),
    [sym_comment] = ACTIONS(91),
  },
  [864] = {
    [anon_sym_COMMA] = ACTIONS(1431),
    [anon_sym_RPAREN] = ACTIONS(1431),
    [anon_sym_SEMI] = ACTIONS(1431),
    [anon_sym_LBRACE] = ACTIONS(1431),
    [anon_sym_RBRACE] = ACTIONS(1431),
    [anon_sym_LPAREN2] = ACTIONS(1431),
    [anon_sym_STAR] = ACTIONS(1429),
    [anon_sym_LBRACK] = ACTIONS(1431),
    [anon_sym_RBRACK] = ACTIONS(1431),
    [anon_sym_EQ] = ACTIONS(1429),
    [anon_sym_COLON] = ACTIONS(1429),
    [anon_sym_QMARK] = ACTIONS(1431),
    [anon_sym_STAR_EQ] = ACTIONS(1431),
    [anon_sym_SLASH_EQ] = ACTIONS(1431),
    [anon_sym_PERCENT_EQ] = ACTIONS(1431),
    [anon_sym_PLUS_EQ] = ACTIONS(1431),
    [anon_sym_DASH_EQ] = ACTIONS(1431),
    [anon_sym_LT_LT_EQ] = ACTIONS(1431),
    [anon_sym_GT_GT_EQ] = ACTIONS(1431),
    [anon_sym_AMP_EQ] = ACTIONS(1431),
    [anon_sym_CARET_EQ] = ACTIONS(1431),
    [anon_sym_PIPE_EQ] = ACTIONS(1431),
    [anon_sym_AMP] = ACTIONS(1429),
    [anon_sym_PIPE_PIPE] = ACTIONS(1431),
    [anon_sym_AMP_AMP] = ACTIONS(1431),
    [anon_sym_PIPE] = ACTIONS(1429),
    [anon_sym_CARET] = ACTIONS(1429),
    [anon_sym_EQ_EQ] = ACTIONS(1431),
    [anon_sym_BANG_EQ] = ACTIONS(1431),
    [anon_sym_LT] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1429),
    [anon_sym_LT_EQ] = ACTIONS(1431),
    [anon_sym_GT_EQ] = ACTIONS(1431),
    [anon_sym_LT_LT] = ACTIONS(1429),
    [anon_sym_GT_GT] = ACTIONS(1429),
    [anon_sym_PLUS] = ACTIONS(1429),
    [anon_sym_DASH] = ACTIONS(1429),
    [anon_sym_SLASH] = ACTIONS(1429),
    [anon_sym_PERCENT] = ACTIONS(1429),
    [anon_sym_DASH_DASH] = ACTIONS(1431),
    [anon_sym_PLUS_PLUS] = ACTIONS(1431),
    [anon_sym_DOT] = ACTIONS(1431),
    [anon_sym_DASH_GT] = ACTIONS(1431),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1431),
    [anon_sym_override] = ACTIONS(1431),
    [anon_sym_COLON_COLON] = ACTIONS(1431),
  },
  [865] = {
    [sym_field_declaration_list] = STATE(1603),
    [sym_virtual_specifier] = STATE(1604),
    [sym_base_class_clause] = STATE(1605),
    [sym_template_argument_list] = STATE(864),
    [anon_sym_COMMA] = ACTIONS(1438),
    [anon_sym_RPAREN] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1438),
    [anon_sym_LBRACE] = ACTIONS(1438),
    [anon_sym_RBRACE] = ACTIONS(1438),
    [anon_sym_LPAREN2] = ACTIONS(1438),
    [anon_sym_STAR] = ACTIONS(1440),
    [anon_sym_LBRACK] = ACTIONS(1438),
    [anon_sym_RBRACK] = ACTIONS(1438),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_QMARK] = ACTIONS(1438),
    [anon_sym_STAR_EQ] = ACTIONS(1438),
    [anon_sym_SLASH_EQ] = ACTIONS(1438),
    [anon_sym_PERCENT_EQ] = ACTIONS(1438),
    [anon_sym_PLUS_EQ] = ACTIONS(1438),
    [anon_sym_DASH_EQ] = ACTIONS(1438),
    [anon_sym_LT_LT_EQ] = ACTIONS(1438),
    [anon_sym_GT_GT_EQ] = ACTIONS(1438),
    [anon_sym_AMP_EQ] = ACTIONS(1438),
    [anon_sym_CARET_EQ] = ACTIONS(1438),
    [anon_sym_PIPE_EQ] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_PIPE_PIPE] = ACTIONS(1438),
    [anon_sym_AMP_AMP] = ACTIONS(1438),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_CARET] = ACTIONS(1440),
    [anon_sym_EQ_EQ] = ACTIONS(1438),
    [anon_sym_BANG_EQ] = ACTIONS(1438),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_LT_EQ] = ACTIONS(1438),
    [anon_sym_GT_EQ] = ACTIONS(1438),
    [anon_sym_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_GT] = ACTIONS(1440),
    [anon_sym_PLUS] = ACTIONS(1440),
    [anon_sym_DASH] = ACTIONS(1440),
    [anon_sym_SLASH] = ACTIONS(1440),
    [anon_sym_PERCENT] = ACTIONS(1440),
    [anon_sym_DASH_DASH] = ACTIONS(1438),
    [anon_sym_PLUS_PLUS] = ACTIONS(1438),
    [anon_sym_DOT] = ACTIONS(1438),
    [anon_sym_DASH_GT] = ACTIONS(1438),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [anon_sym_COLON_COLON] = ACTIONS(1548),
  },
  [866] = {
    [anon_sym_COMMA] = ACTIONS(1442),
    [anon_sym_RPAREN] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1442),
    [anon_sym_LBRACE] = ACTIONS(1442),
    [anon_sym_RBRACE] = ACTIONS(1442),
    [anon_sym_LPAREN2] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1444),
    [anon_sym_LBRACK] = ACTIONS(1442),
    [anon_sym_RBRACK] = ACTIONS(1442),
    [anon_sym_EQ] = ACTIONS(1444),
    [anon_sym_COLON] = ACTIONS(1442),
    [anon_sym_QMARK] = ACTIONS(1442),
    [anon_sym_STAR_EQ] = ACTIONS(1442),
    [anon_sym_SLASH_EQ] = ACTIONS(1442),
    [anon_sym_PERCENT_EQ] = ACTIONS(1442),
    [anon_sym_PLUS_EQ] = ACTIONS(1442),
    [anon_sym_DASH_EQ] = ACTIONS(1442),
    [anon_sym_LT_LT_EQ] = ACTIONS(1442),
    [anon_sym_GT_GT_EQ] = ACTIONS(1442),
    [anon_sym_AMP_EQ] = ACTIONS(1442),
    [anon_sym_CARET_EQ] = ACTIONS(1442),
    [anon_sym_PIPE_EQ] = ACTIONS(1442),
    [anon_sym_AMP] = ACTIONS(1444),
    [anon_sym_PIPE_PIPE] = ACTIONS(1442),
    [anon_sym_AMP_AMP] = ACTIONS(1442),
    [anon_sym_PIPE] = ACTIONS(1444),
    [anon_sym_CARET] = ACTIONS(1444),
    [anon_sym_EQ_EQ] = ACTIONS(1442),
    [anon_sym_BANG_EQ] = ACTIONS(1442),
    [anon_sym_LT] = ACTIONS(1444),
    [anon_sym_GT] = ACTIONS(1444),
    [anon_sym_LT_EQ] = ACTIONS(1442),
    [anon_sym_GT_EQ] = ACTIONS(1442),
    [anon_sym_LT_LT] = ACTIONS(1444),
    [anon_sym_GT_GT] = ACTIONS(1444),
    [anon_sym_PLUS] = ACTIONS(1444),
    [anon_sym_DASH] = ACTIONS(1444),
    [anon_sym_SLASH] = ACTIONS(1444),
    [anon_sym_PERCENT] = ACTIONS(1444),
    [anon_sym_DASH_DASH] = ACTIONS(1442),
    [anon_sym_PLUS_PLUS] = ACTIONS(1442),
    [anon_sym_DOT] = ACTIONS(1442),
    [anon_sym_DASH_GT] = ACTIONS(1442),
    [sym_comment] = ACTIONS(91),
  },
  [867] = {
    [sym_field_declaration_list] = STATE(1606),
    [sym_base_class_clause] = STATE(1607),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [anon_sym_COLON] = ACTIONS(1073),
    [sym_comment] = ACTIONS(91),
  },
  [868] = {
    [sym_field_declaration_list] = STATE(1606),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [sym_comment] = ACTIONS(91),
  },
  [869] = {
    [sym_field_declaration_list] = STATE(1606),
    [sym_virtual_specifier] = STATE(1608),
    [sym_base_class_clause] = STATE(1607),
    [anon_sym_COMMA] = ACTIONS(1442),
    [anon_sym_RPAREN] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1442),
    [anon_sym_LBRACE] = ACTIONS(1442),
    [anon_sym_RBRACE] = ACTIONS(1442),
    [anon_sym_LPAREN2] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1444),
    [anon_sym_LBRACK] = ACTIONS(1442),
    [anon_sym_RBRACK] = ACTIONS(1442),
    [anon_sym_EQ] = ACTIONS(1444),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_QMARK] = ACTIONS(1442),
    [anon_sym_STAR_EQ] = ACTIONS(1442),
    [anon_sym_SLASH_EQ] = ACTIONS(1442),
    [anon_sym_PERCENT_EQ] = ACTIONS(1442),
    [anon_sym_PLUS_EQ] = ACTIONS(1442),
    [anon_sym_DASH_EQ] = ACTIONS(1442),
    [anon_sym_LT_LT_EQ] = ACTIONS(1442),
    [anon_sym_GT_GT_EQ] = ACTIONS(1442),
    [anon_sym_AMP_EQ] = ACTIONS(1442),
    [anon_sym_CARET_EQ] = ACTIONS(1442),
    [anon_sym_PIPE_EQ] = ACTIONS(1442),
    [anon_sym_AMP] = ACTIONS(1444),
    [anon_sym_PIPE_PIPE] = ACTIONS(1442),
    [anon_sym_AMP_AMP] = ACTIONS(1442),
    [anon_sym_PIPE] = ACTIONS(1444),
    [anon_sym_CARET] = ACTIONS(1444),
    [anon_sym_EQ_EQ] = ACTIONS(1442),
    [anon_sym_BANG_EQ] = ACTIONS(1442),
    [anon_sym_LT] = ACTIONS(1444),
    [anon_sym_GT] = ACTIONS(1444),
    [anon_sym_LT_EQ] = ACTIONS(1442),
    [anon_sym_GT_EQ] = ACTIONS(1442),
    [anon_sym_LT_LT] = ACTIONS(1444),
    [anon_sym_GT_GT] = ACTIONS(1444),
    [anon_sym_PLUS] = ACTIONS(1444),
    [anon_sym_DASH] = ACTIONS(1444),
    [anon_sym_SLASH] = ACTIONS(1444),
    [anon_sym_PERCENT] = ACTIONS(1444),
    [anon_sym_DASH_DASH] = ACTIONS(1442),
    [anon_sym_PLUS_PLUS] = ACTIONS(1442),
    [anon_sym_DOT] = ACTIONS(1442),
    [anon_sym_DASH_GT] = ACTIONS(1442),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [anon_sym_COLON_COLON] = ACTIONS(1564),
  },
  [870] = {
    [sym_field_declaration_list] = STATE(1606),
    [sym_virtual_specifier] = STATE(1608),
    [sym_base_class_clause] = STATE(1607),
    [sym_template_argument_list] = STATE(878),
    [anon_sym_COMMA] = ACTIONS(1442),
    [anon_sym_RPAREN] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1442),
    [anon_sym_LBRACE] = ACTIONS(1442),
    [anon_sym_RBRACE] = ACTIONS(1442),
    [anon_sym_LPAREN2] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1444),
    [anon_sym_LBRACK] = ACTIONS(1442),
    [anon_sym_RBRACK] = ACTIONS(1442),
    [anon_sym_EQ] = ACTIONS(1444),
    [anon_sym_COLON] = ACTIONS(1073),
    [anon_sym_QMARK] = ACTIONS(1442),
    [anon_sym_STAR_EQ] = ACTIONS(1442),
    [anon_sym_SLASH_EQ] = ACTIONS(1442),
    [anon_sym_PERCENT_EQ] = ACTIONS(1442),
    [anon_sym_PLUS_EQ] = ACTIONS(1442),
    [anon_sym_DASH_EQ] = ACTIONS(1442),
    [anon_sym_LT_LT_EQ] = ACTIONS(1442),
    [anon_sym_GT_GT_EQ] = ACTIONS(1442),
    [anon_sym_AMP_EQ] = ACTIONS(1442),
    [anon_sym_CARET_EQ] = ACTIONS(1442),
    [anon_sym_PIPE_EQ] = ACTIONS(1442),
    [anon_sym_AMP] = ACTIONS(1444),
    [anon_sym_PIPE_PIPE] = ACTIONS(1442),
    [anon_sym_AMP_AMP] = ACTIONS(1442),
    [anon_sym_PIPE] = ACTIONS(1444),
    [anon_sym_CARET] = ACTIONS(1444),
    [anon_sym_EQ_EQ] = ACTIONS(1442),
    [anon_sym_BANG_EQ] = ACTIONS(1442),
    [anon_sym_LT] = ACTIONS(1444),
    [anon_sym_GT] = ACTIONS(1444),
    [anon_sym_LT_EQ] = ACTIONS(1442),
    [anon_sym_GT_EQ] = ACTIONS(1442),
    [anon_sym_LT_LT] = ACTIONS(1444),
    [anon_sym_GT_GT] = ACTIONS(1444),
    [anon_sym_PLUS] = ACTIONS(1444),
    [anon_sym_DASH] = ACTIONS(1444),
    [anon_sym_SLASH] = ACTIONS(1444),
    [anon_sym_PERCENT] = ACTIONS(1444),
    [anon_sym_DASH_DASH] = ACTIONS(1442),
    [anon_sym_PLUS_PLUS] = ACTIONS(1442),
    [anon_sym_DOT] = ACTIONS(1442),
    [anon_sym_DASH_GT] = ACTIONS(1442),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
  },
  [871] = {
    [anon_sym_COMMA] = ACTIONS(1446),
    [anon_sym_RPAREN] = ACTIONS(1446),
    [anon_sym_SEMI] = ACTIONS(1446),
    [anon_sym_LBRACE] = ACTIONS(1446),
    [anon_sym_RBRACE] = ACTIONS(1446),
    [anon_sym_LPAREN2] = ACTIONS(1446),
    [anon_sym_STAR] = ACTIONS(1448),
    [anon_sym_LBRACK] = ACTIONS(1446),
    [anon_sym_RBRACK] = ACTIONS(1446),
    [anon_sym_EQ] = ACTIONS(1448),
    [anon_sym_COLON] = ACTIONS(1446),
    [anon_sym_QMARK] = ACTIONS(1446),
    [anon_sym_STAR_EQ] = ACTIONS(1446),
    [anon_sym_SLASH_EQ] = ACTIONS(1446),
    [anon_sym_PERCENT_EQ] = ACTIONS(1446),
    [anon_sym_PLUS_EQ] = ACTIONS(1446),
    [anon_sym_DASH_EQ] = ACTIONS(1446),
    [anon_sym_LT_LT_EQ] = ACTIONS(1446),
    [anon_sym_GT_GT_EQ] = ACTIONS(1446),
    [anon_sym_AMP_EQ] = ACTIONS(1446),
    [anon_sym_CARET_EQ] = ACTIONS(1446),
    [anon_sym_PIPE_EQ] = ACTIONS(1446),
    [anon_sym_AMP] = ACTIONS(1448),
    [anon_sym_PIPE_PIPE] = ACTIONS(1446),
    [anon_sym_AMP_AMP] = ACTIONS(1446),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_CARET] = ACTIONS(1448),
    [anon_sym_EQ_EQ] = ACTIONS(1446),
    [anon_sym_BANG_EQ] = ACTIONS(1446),
    [anon_sym_LT] = ACTIONS(1448),
    [anon_sym_GT] = ACTIONS(1448),
    [anon_sym_LT_EQ] = ACTIONS(1446),
    [anon_sym_GT_EQ] = ACTIONS(1446),
    [anon_sym_LT_LT] = ACTIONS(1448),
    [anon_sym_GT_GT] = ACTIONS(1448),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [anon_sym_SLASH] = ACTIONS(1448),
    [anon_sym_PERCENT] = ACTIONS(1448),
    [anon_sym_DASH_DASH] = ACTIONS(1446),
    [anon_sym_PLUS_PLUS] = ACTIONS(1446),
    [anon_sym_DOT] = ACTIONS(1446),
    [anon_sym_DASH_GT] = ACTIONS(1446),
    [sym_comment] = ACTIONS(91),
  },
  [872] = {
    [anon_sym_COMMA] = ACTIONS(1582),
    [anon_sym_RPAREN] = ACTIONS(1582),
    [anon_sym_SEMI] = ACTIONS(1582),
    [anon_sym_LBRACE] = ACTIONS(1582),
    [anon_sym_RBRACE] = ACTIONS(1582),
    [anon_sym_LPAREN2] = ACTIONS(1582),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(1580),
    [anon_sym_COLON] = ACTIONS(1580),
    [anon_sym_QMARK] = ACTIONS(1582),
    [anon_sym_STAR_EQ] = ACTIONS(1582),
    [anon_sym_SLASH_EQ] = ACTIONS(1582),
    [anon_sym_PERCENT_EQ] = ACTIONS(1582),
    [anon_sym_PLUS_EQ] = ACTIONS(1582),
    [anon_sym_DASH_EQ] = ACTIONS(1582),
    [anon_sym_LT_LT_EQ] = ACTIONS(1582),
    [anon_sym_GT_GT_EQ] = ACTIONS(1582),
    [anon_sym_AMP_EQ] = ACTIONS(1582),
    [anon_sym_CARET_EQ] = ACTIONS(1582),
    [anon_sym_PIPE_EQ] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1582),
    [anon_sym_AMP_AMP] = ACTIONS(1582),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_EQ_EQ] = ACTIONS(1582),
    [anon_sym_BANG_EQ] = ACTIONS(1582),
    [anon_sym_LT] = ACTIONS(1580),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1582),
    [anon_sym_GT_EQ] = ACTIONS(1582),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1582),
    [anon_sym_DOT] = ACTIONS(1582),
    [anon_sym_DASH_GT] = ACTIONS(1582),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1582),
    [anon_sym_override] = ACTIONS(1582),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
  },
  [873] = {
    [sym__expression] = STATE(1609),
    [sym_conditional_expression] = STATE(1609),
    [sym_assignment_expression] = STATE(1609),
    [sym_pointer_expression] = STATE(1609),
    [sym_logical_expression] = STATE(1609),
    [sym_bitwise_expression] = STATE(1609),
    [sym_equality_expression] = STATE(1609),
    [sym_relational_expression] = STATE(1609),
    [sym_shift_expression] = STATE(1609),
    [sym_math_expression] = STATE(1609),
    [sym_cast_expression] = STATE(1609),
    [sym_sizeof_expression] = STATE(1609),
    [sym_subscript_expression] = STATE(1609),
    [sym_call_expression] = STATE(1609),
    [sym_field_expression] = STATE(1609),
    [sym_compound_literal_expression] = STATE(1609),
    [sym_parenthesized_expression] = STATE(1609),
    [sym_char_literal] = STATE(1609),
    [sym_concatenated_string] = STATE(1609),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1609),
    [sym_new_expression] = STATE(1609),
    [sym_delete_expression] = STATE(1609),
    [sym_lambda_expression] = STATE(1609),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3368),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(3368),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(3370),
    [sym_false] = ACTIONS(3370),
    [sym_null] = ACTIONS(3370),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(3370),
  },
  [874] = {
    [anon_sym_COMMA] = ACTIONS(3372),
    [anon_sym_RPAREN] = ACTIONS(3372),
    [anon_sym_SEMI] = ACTIONS(3372),
    [anon_sym_RBRACE] = ACTIONS(3372),
    [anon_sym_LPAREN2] = ACTIONS(3372),
    [anon_sym_STAR] = ACTIONS(3374),
    [anon_sym_LBRACK] = ACTIONS(3372),
    [anon_sym_RBRACK] = ACTIONS(3372),
    [anon_sym_EQ] = ACTIONS(3374),
    [anon_sym_COLON] = ACTIONS(3372),
    [anon_sym_QMARK] = ACTIONS(3372),
    [anon_sym_STAR_EQ] = ACTIONS(3372),
    [anon_sym_SLASH_EQ] = ACTIONS(3372),
    [anon_sym_PERCENT_EQ] = ACTIONS(3372),
    [anon_sym_PLUS_EQ] = ACTIONS(3372),
    [anon_sym_DASH_EQ] = ACTIONS(3372),
    [anon_sym_LT_LT_EQ] = ACTIONS(3372),
    [anon_sym_GT_GT_EQ] = ACTIONS(3372),
    [anon_sym_AMP_EQ] = ACTIONS(3372),
    [anon_sym_CARET_EQ] = ACTIONS(3372),
    [anon_sym_PIPE_EQ] = ACTIONS(3372),
    [anon_sym_AMP] = ACTIONS(3374),
    [anon_sym_PIPE_PIPE] = ACTIONS(3372),
    [anon_sym_AMP_AMP] = ACTIONS(3372),
    [anon_sym_PIPE] = ACTIONS(3374),
    [anon_sym_CARET] = ACTIONS(3374),
    [anon_sym_EQ_EQ] = ACTIONS(3372),
    [anon_sym_BANG_EQ] = ACTIONS(3372),
    [anon_sym_LT] = ACTIONS(3374),
    [anon_sym_GT] = ACTIONS(3374),
    [anon_sym_LT_EQ] = ACTIONS(3372),
    [anon_sym_GT_EQ] = ACTIONS(3372),
    [anon_sym_LT_LT] = ACTIONS(3374),
    [anon_sym_GT_GT] = ACTIONS(3374),
    [anon_sym_PLUS] = ACTIONS(3374),
    [anon_sym_DASH] = ACTIONS(3374),
    [anon_sym_SLASH] = ACTIONS(3374),
    [anon_sym_PERCENT] = ACTIONS(3374),
    [anon_sym_DASH_DASH] = ACTIONS(3372),
    [anon_sym_PLUS_PLUS] = ACTIONS(3372),
    [anon_sym_DOT] = ACTIONS(3372),
    [anon_sym_DASH_GT] = ACTIONS(3372),
    [sym_comment] = ACTIONS(91),
  },
  [875] = {
    [sym_argument_list] = STATE(1610),
    [sym_initializer_list] = STATE(1610),
    [anon_sym_COMMA] = ACTIONS(3372),
    [anon_sym_RPAREN] = ACTIONS(3372),
    [anon_sym_SEMI] = ACTIONS(3372),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_RBRACE] = ACTIONS(3372),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3374),
    [anon_sym_LBRACK] = ACTIONS(3372),
    [anon_sym_RBRACK] = ACTIONS(3372),
    [anon_sym_EQ] = ACTIONS(3374),
    [anon_sym_QMARK] = ACTIONS(3372),
    [anon_sym_STAR_EQ] = ACTIONS(3372),
    [anon_sym_SLASH_EQ] = ACTIONS(3372),
    [anon_sym_PERCENT_EQ] = ACTIONS(3372),
    [anon_sym_PLUS_EQ] = ACTIONS(3372),
    [anon_sym_DASH_EQ] = ACTIONS(3372),
    [anon_sym_LT_LT_EQ] = ACTIONS(3372),
    [anon_sym_GT_GT_EQ] = ACTIONS(3372),
    [anon_sym_AMP_EQ] = ACTIONS(3372),
    [anon_sym_CARET_EQ] = ACTIONS(3372),
    [anon_sym_PIPE_EQ] = ACTIONS(3372),
    [anon_sym_AMP] = ACTIONS(3374),
    [anon_sym_PIPE_PIPE] = ACTIONS(3372),
    [anon_sym_AMP_AMP] = ACTIONS(3372),
    [anon_sym_PIPE] = ACTIONS(3374),
    [anon_sym_CARET] = ACTIONS(3374),
    [anon_sym_EQ_EQ] = ACTIONS(3372),
    [anon_sym_BANG_EQ] = ACTIONS(3372),
    [anon_sym_LT] = ACTIONS(3374),
    [anon_sym_GT] = ACTIONS(3374),
    [anon_sym_LT_EQ] = ACTIONS(3372),
    [anon_sym_GT_EQ] = ACTIONS(3372),
    [anon_sym_LT_LT] = ACTIONS(3374),
    [anon_sym_GT_GT] = ACTIONS(3374),
    [anon_sym_PLUS] = ACTIONS(3374),
    [anon_sym_DASH] = ACTIONS(3374),
    [anon_sym_SLASH] = ACTIONS(3374),
    [anon_sym_PERCENT] = ACTIONS(3374),
    [anon_sym_DASH_DASH] = ACTIONS(3372),
    [anon_sym_PLUS_PLUS] = ACTIONS(3372),
    [anon_sym_DOT] = ACTIONS(3372),
    [anon_sym_DASH_GT] = ACTIONS(3372),
    [sym_comment] = ACTIONS(91),
  },
  [876] = {
    [sym_argument_list] = STATE(1610),
    [sym_initializer_list] = STATE(1610),
    [sym_new_declarator] = STATE(1611),
    [anon_sym_COMMA] = ACTIONS(3372),
    [anon_sym_SEMI] = ACTIONS(3372),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3374),
    [anon_sym_LBRACK] = ACTIONS(1560),
    [anon_sym_EQ] = ACTIONS(3374),
    [anon_sym_QMARK] = ACTIONS(3372),
    [anon_sym_STAR_EQ] = ACTIONS(3372),
    [anon_sym_SLASH_EQ] = ACTIONS(3372),
    [anon_sym_PERCENT_EQ] = ACTIONS(3372),
    [anon_sym_PLUS_EQ] = ACTIONS(3372),
    [anon_sym_DASH_EQ] = ACTIONS(3372),
    [anon_sym_LT_LT_EQ] = ACTIONS(3372),
    [anon_sym_GT_GT_EQ] = ACTIONS(3372),
    [anon_sym_AMP_EQ] = ACTIONS(3372),
    [anon_sym_CARET_EQ] = ACTIONS(3372),
    [anon_sym_PIPE_EQ] = ACTIONS(3372),
    [anon_sym_AMP] = ACTIONS(3374),
    [anon_sym_PIPE_PIPE] = ACTIONS(3372),
    [anon_sym_AMP_AMP] = ACTIONS(3372),
    [anon_sym_PIPE] = ACTIONS(3374),
    [anon_sym_CARET] = ACTIONS(3374),
    [anon_sym_EQ_EQ] = ACTIONS(3372),
    [anon_sym_BANG_EQ] = ACTIONS(3372),
    [anon_sym_LT] = ACTIONS(3374),
    [anon_sym_GT] = ACTIONS(3374),
    [anon_sym_LT_EQ] = ACTIONS(3372),
    [anon_sym_GT_EQ] = ACTIONS(3372),
    [anon_sym_LT_LT] = ACTIONS(3374),
    [anon_sym_GT_GT] = ACTIONS(3374),
    [anon_sym_PLUS] = ACTIONS(3374),
    [anon_sym_DASH] = ACTIONS(3374),
    [anon_sym_SLASH] = ACTIONS(3374),
    [anon_sym_PERCENT] = ACTIONS(3374),
    [anon_sym_DASH_DASH] = ACTIONS(3372),
    [anon_sym_PLUS_PLUS] = ACTIONS(3372),
    [anon_sym_DOT] = ACTIONS(3372),
    [anon_sym_DASH_GT] = ACTIONS(3372),
    [sym_comment] = ACTIONS(91),
  },
  [877] = {
    [sym_identifier] = ACTIONS(3376),
    [sym_comment] = ACTIONS(91),
  },
  [878] = {
    [anon_sym_COMMA] = ACTIONS(1799),
    [anon_sym_RPAREN] = ACTIONS(1799),
    [anon_sym_SEMI] = ACTIONS(1799),
    [anon_sym_LBRACE] = ACTIONS(1799),
    [anon_sym_RBRACE] = ACTIONS(1799),
    [anon_sym_LPAREN2] = ACTIONS(1799),
    [anon_sym_STAR] = ACTIONS(1801),
    [anon_sym_LBRACK] = ACTIONS(1799),
    [anon_sym_RBRACK] = ACTIONS(1799),
    [anon_sym_EQ] = ACTIONS(1801),
    [anon_sym_COLON] = ACTIONS(1801),
    [anon_sym_QMARK] = ACTIONS(1799),
    [anon_sym_STAR_EQ] = ACTIONS(1799),
    [anon_sym_SLASH_EQ] = ACTIONS(1799),
    [anon_sym_PERCENT_EQ] = ACTIONS(1799),
    [anon_sym_PLUS_EQ] = ACTIONS(1799),
    [anon_sym_DASH_EQ] = ACTIONS(1799),
    [anon_sym_LT_LT_EQ] = ACTIONS(1799),
    [anon_sym_GT_GT_EQ] = ACTIONS(1799),
    [anon_sym_AMP_EQ] = ACTIONS(1799),
    [anon_sym_CARET_EQ] = ACTIONS(1799),
    [anon_sym_PIPE_EQ] = ACTIONS(1799),
    [anon_sym_AMP] = ACTIONS(1801),
    [anon_sym_PIPE_PIPE] = ACTIONS(1799),
    [anon_sym_AMP_AMP] = ACTIONS(1799),
    [anon_sym_PIPE] = ACTIONS(1801),
    [anon_sym_CARET] = ACTIONS(1801),
    [anon_sym_EQ_EQ] = ACTIONS(1799),
    [anon_sym_BANG_EQ] = ACTIONS(1799),
    [anon_sym_LT] = ACTIONS(1801),
    [anon_sym_GT] = ACTIONS(1801),
    [anon_sym_LT_EQ] = ACTIONS(1799),
    [anon_sym_GT_EQ] = ACTIONS(1799),
    [anon_sym_LT_LT] = ACTIONS(1801),
    [anon_sym_GT_GT] = ACTIONS(1801),
    [anon_sym_PLUS] = ACTIONS(1801),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_SLASH] = ACTIONS(1801),
    [anon_sym_PERCENT] = ACTIONS(1801),
    [anon_sym_DASH_DASH] = ACTIONS(1799),
    [anon_sym_PLUS_PLUS] = ACTIONS(1799),
    [anon_sym_DOT] = ACTIONS(1799),
    [anon_sym_DASH_GT] = ACTIONS(1799),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1799),
    [anon_sym_override] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(1799),
  },
  [879] = {
    [anon_sym_COMMA] = ACTIONS(1977),
    [anon_sym_RPAREN] = ACTIONS(1977),
    [anon_sym_SEMI] = ACTIONS(1977),
    [anon_sym_LBRACE] = ACTIONS(1977),
    [anon_sym_RBRACE] = ACTIONS(1977),
    [anon_sym_LPAREN2] = ACTIONS(1977),
    [anon_sym_STAR] = ACTIONS(1979),
    [anon_sym_LBRACK] = ACTIONS(1977),
    [anon_sym_RBRACK] = ACTIONS(1977),
    [anon_sym_EQ] = ACTIONS(1979),
    [anon_sym_COLON] = ACTIONS(1977),
    [anon_sym_QMARK] = ACTIONS(1977),
    [anon_sym_STAR_EQ] = ACTIONS(1977),
    [anon_sym_SLASH_EQ] = ACTIONS(1977),
    [anon_sym_PERCENT_EQ] = ACTIONS(1977),
    [anon_sym_PLUS_EQ] = ACTIONS(1977),
    [anon_sym_DASH_EQ] = ACTIONS(1977),
    [anon_sym_LT_LT_EQ] = ACTIONS(1977),
    [anon_sym_GT_GT_EQ] = ACTIONS(1977),
    [anon_sym_AMP_EQ] = ACTIONS(1977),
    [anon_sym_CARET_EQ] = ACTIONS(1977),
    [anon_sym_PIPE_EQ] = ACTIONS(1977),
    [anon_sym_AMP] = ACTIONS(1979),
    [anon_sym_PIPE_PIPE] = ACTIONS(1977),
    [anon_sym_AMP_AMP] = ACTIONS(1977),
    [anon_sym_PIPE] = ACTIONS(1979),
    [anon_sym_CARET] = ACTIONS(1979),
    [anon_sym_EQ_EQ] = ACTIONS(1977),
    [anon_sym_BANG_EQ] = ACTIONS(1977),
    [anon_sym_LT] = ACTIONS(1979),
    [anon_sym_GT] = ACTIONS(1979),
    [anon_sym_LT_EQ] = ACTIONS(1977),
    [anon_sym_GT_EQ] = ACTIONS(1977),
    [anon_sym_LT_LT] = ACTIONS(1979),
    [anon_sym_GT_GT] = ACTIONS(1979),
    [anon_sym_PLUS] = ACTIONS(1979),
    [anon_sym_DASH] = ACTIONS(1979),
    [anon_sym_SLASH] = ACTIONS(1979),
    [anon_sym_PERCENT] = ACTIONS(1979),
    [anon_sym_DASH_DASH] = ACTIONS(1977),
    [anon_sym_PLUS_PLUS] = ACTIONS(1977),
    [anon_sym_DOT] = ACTIONS(1977),
    [anon_sym_DASH_GT] = ACTIONS(1977),
    [sym_comment] = ACTIONS(91),
  },
  [880] = {
    [anon_sym_COMMA] = ACTIONS(1981),
    [anon_sym_RPAREN] = ACTIONS(1981),
    [anon_sym_SEMI] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1981),
    [anon_sym_RBRACE] = ACTIONS(1981),
    [anon_sym_LPAREN2] = ACTIONS(1981),
    [anon_sym_STAR] = ACTIONS(1983),
    [anon_sym_LBRACK] = ACTIONS(1981),
    [anon_sym_RBRACK] = ACTIONS(1981),
    [anon_sym_EQ] = ACTIONS(1983),
    [anon_sym_COLON] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(1981),
    [anon_sym_STAR_EQ] = ACTIONS(1981),
    [anon_sym_SLASH_EQ] = ACTIONS(1981),
    [anon_sym_PERCENT_EQ] = ACTIONS(1981),
    [anon_sym_PLUS_EQ] = ACTIONS(1981),
    [anon_sym_DASH_EQ] = ACTIONS(1981),
    [anon_sym_LT_LT_EQ] = ACTIONS(1981),
    [anon_sym_GT_GT_EQ] = ACTIONS(1981),
    [anon_sym_AMP_EQ] = ACTIONS(1981),
    [anon_sym_CARET_EQ] = ACTIONS(1981),
    [anon_sym_PIPE_EQ] = ACTIONS(1981),
    [anon_sym_AMP] = ACTIONS(1983),
    [anon_sym_PIPE_PIPE] = ACTIONS(1981),
    [anon_sym_AMP_AMP] = ACTIONS(1981),
    [anon_sym_PIPE] = ACTIONS(1983),
    [anon_sym_CARET] = ACTIONS(1983),
    [anon_sym_EQ_EQ] = ACTIONS(1981),
    [anon_sym_BANG_EQ] = ACTIONS(1981),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_LT_EQ] = ACTIONS(1981),
    [anon_sym_GT_EQ] = ACTIONS(1981),
    [anon_sym_LT_LT] = ACTIONS(1983),
    [anon_sym_GT_GT] = ACTIONS(1983),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_SLASH] = ACTIONS(1983),
    [anon_sym_PERCENT] = ACTIONS(1983),
    [anon_sym_DASH_DASH] = ACTIONS(1981),
    [anon_sym_PLUS_PLUS] = ACTIONS(1981),
    [anon_sym_DOT] = ACTIONS(1981),
    [anon_sym_DASH_GT] = ACTIONS(1981),
    [sym_comment] = ACTIONS(91),
  },
  [881] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(881),
    [anon_sym_COMMA] = ACTIONS(1985),
    [anon_sym_SEMI] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(1985),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_EQ] = ACTIONS(1987),
    [anon_sym_unsigned] = ACTIONS(3378),
    [anon_sym_long] = ACTIONS(3378),
    [anon_sym_short] = ACTIONS(3378),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_QMARK] = ACTIONS(1985),
    [anon_sym_STAR_EQ] = ACTIONS(1985),
    [anon_sym_SLASH_EQ] = ACTIONS(1985),
    [anon_sym_PERCENT_EQ] = ACTIONS(1985),
    [anon_sym_PLUS_EQ] = ACTIONS(1985),
    [anon_sym_DASH_EQ] = ACTIONS(1985),
    [anon_sym_LT_LT_EQ] = ACTIONS(1985),
    [anon_sym_GT_GT_EQ] = ACTIONS(1985),
    [anon_sym_AMP_EQ] = ACTIONS(1985),
    [anon_sym_CARET_EQ] = ACTIONS(1985),
    [anon_sym_PIPE_EQ] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_PIPE_PIPE] = ACTIONS(1985),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_PIPE] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1987),
    [anon_sym_EQ_EQ] = ACTIONS(1985),
    [anon_sym_BANG_EQ] = ACTIONS(1985),
    [anon_sym_LT] = ACTIONS(1987),
    [anon_sym_GT] = ACTIONS(1987),
    [anon_sym_LT_EQ] = ACTIONS(1985),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_LT] = ACTIONS(1987),
    [anon_sym_GT_GT] = ACTIONS(1987),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_DASH] = ACTIONS(1987),
    [anon_sym_SLASH] = ACTIONS(1987),
    [anon_sym_PERCENT] = ACTIONS(1987),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DOT] = ACTIONS(1985),
    [anon_sym_DASH_GT] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [sym_comment] = ACTIONS(91),
  },
  [882] = {
    [sym__expression] = STATE(164),
    [sym_conditional_expression] = STATE(164),
    [sym_assignment_expression] = STATE(164),
    [sym_pointer_expression] = STATE(164),
    [sym_logical_expression] = STATE(164),
    [sym_bitwise_expression] = STATE(164),
    [sym_equality_expression] = STATE(164),
    [sym_relational_expression] = STATE(164),
    [sym_shift_expression] = STATE(164),
    [sym_math_expression] = STATE(164),
    [sym_cast_expression] = STATE(164),
    [sym_sizeof_expression] = STATE(164),
    [sym_subscript_expression] = STATE(164),
    [sym_call_expression] = STATE(164),
    [sym_field_expression] = STATE(164),
    [sym_compound_literal_expression] = STATE(164),
    [sym_parenthesized_expression] = STATE(164),
    [sym_char_literal] = STATE(164),
    [sym_concatenated_string] = STATE(164),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(164),
    [sym_new_expression] = STATE(164),
    [sym_delete_expression] = STATE(164),
    [sym_lambda_expression] = STATE(164),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_lambda_default_capture] = STATE(166),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(267),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(3381),
    [anon_sym_EQ] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(267),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(289),
    [sym_false] = ACTIONS(289),
    [sym_null] = ACTIONS(289),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(289),
  },
  [883] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3383),
    [anon_sym_SEMI] = ACTIONS(3383),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(590),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3385),
    [anon_sym_QMARK] = ACTIONS(3383),
    [anon_sym_STAR_EQ] = ACTIONS(3383),
    [anon_sym_SLASH_EQ] = ACTIONS(3383),
    [anon_sym_PERCENT_EQ] = ACTIONS(3383),
    [anon_sym_PLUS_EQ] = ACTIONS(3383),
    [anon_sym_DASH_EQ] = ACTIONS(3383),
    [anon_sym_LT_LT_EQ] = ACTIONS(3383),
    [anon_sym_GT_GT_EQ] = ACTIONS(3383),
    [anon_sym_AMP_EQ] = ACTIONS(3383),
    [anon_sym_CARET_EQ] = ACTIONS(3383),
    [anon_sym_PIPE_EQ] = ACTIONS(3383),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_PIPE_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(604),
    [anon_sym_PIPE] = ACTIONS(606),
    [anon_sym_CARET] = ACTIONS(608),
    [anon_sym_EQ_EQ] = ACTIONS(610),
    [anon_sym_BANG_EQ] = ACTIONS(610),
    [anon_sym_LT] = ACTIONS(612),
    [anon_sym_GT] = ACTIONS(612),
    [anon_sym_LT_EQ] = ACTIONS(614),
    [anon_sym_GT_EQ] = ACTIONS(614),
    [anon_sym_LT_LT] = ACTIONS(616),
    [anon_sym_GT_GT] = ACTIONS(616),
    [anon_sym_PLUS] = ACTIONS(618),
    [anon_sym_DASH] = ACTIONS(618),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [884] = {
    [sym__declarator] = STATE(888),
    [sym_pointer_declarator] = STATE(888),
    [sym_function_declarator] = STATE(888),
    [sym_array_declarator] = STATE(888),
    [sym_reference_declarator] = STATE(888),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(888),
    [sym_destructor_name] = STATE(888),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(560),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(568),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(1609),
  },
  [885] = {
    [sym_parameter_list] = STATE(897),
    [anon_sym_COMMA] = ACTIONS(2435),
    [anon_sym_SEMI] = ACTIONS(2435),
    [anon_sym_LBRACE] = ACTIONS(2435),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(574),
    [anon_sym_EQ] = ACTIONS(2435),
    [sym_comment] = ACTIONS(91),
  },
  [886] = {
    [sym__declarator] = STATE(1614),
    [sym_pointer_declarator] = STATE(1614),
    [sym_function_declarator] = STATE(1614),
    [sym_array_declarator] = STATE(1614),
    [sym_type_qualifier] = STATE(552),
    [sym_reference_declarator] = STATE(1614),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(1614),
    [sym_destructor_name] = STATE(1614),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [aux_sym_type_definition_repeat1] = STATE(552),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(560),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(568),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(3387),
  },
  [887] = {
    [aux_sym_structured_binding_declarator_repeat1] = STATE(1617),
    [anon_sym_COMMA] = ACTIONS(3389),
    [anon_sym_RBRACK] = ACTIONS(3391),
    [sym_comment] = ACTIONS(91),
  },
  [888] = {
    [sym_parameter_list] = STATE(897),
    [anon_sym_COMMA] = ACTIONS(2439),
    [anon_sym_SEMI] = ACTIONS(2439),
    [anon_sym_LBRACE] = ACTIONS(2439),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(574),
    [anon_sym_EQ] = ACTIONS(2439),
    [sym_comment] = ACTIONS(91),
  },
  [889] = {
    [anon_sym_LBRACE] = ACTIONS(3393),
    [anon_sym_LPAREN2] = ACTIONS(3393),
    [anon_sym_EQ] = ACTIONS(3393),
    [sym_comment] = ACTIONS(91),
  },
  [890] = {
    [anon_sym_COMMA] = ACTIONS(1424),
    [anon_sym_RPAREN] = ACTIONS(1424),
    [anon_sym_SEMI] = ACTIONS(1424),
    [anon_sym_LBRACE] = ACTIONS(1424),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_LBRACK] = ACTIONS(1424),
    [anon_sym_EQ] = ACTIONS(1424),
    [anon_sym_COLON] = ACTIONS(1436),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(1424),
    [anon_sym_COLON_COLON] = ACTIONS(1431),
  },
  [891] = {
    [sym__declarator] = STATE(1618),
    [sym_pointer_declarator] = STATE(1618),
    [sym_function_declarator] = STATE(1618),
    [sym_array_declarator] = STATE(1618),
    [sym_init_declarator] = STATE(1619),
    [sym_reference_declarator] = STATE(1618),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(1618),
    [sym_destructor_name] = STATE(1618),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(560),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(568),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(3395),
  },
  [892] = {
    [sym_raw_string_literal] = ACTIONS(3397),
    [ts_builtin_sym_end] = ACTIONS(3397),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3399),
    [sym_preproc_directive] = ACTIONS(3399),
    [anon_sym_SEMI] = ACTIONS(3397),
    [anon_sym_typedef] = ACTIONS(3399),
    [anon_sym_extern] = ACTIONS(3399),
    [anon_sym_LBRACE] = ACTIONS(3397),
    [anon_sym_RBRACE] = ACTIONS(3397),
    [anon_sym_LPAREN2] = ACTIONS(3397),
    [anon_sym_STAR] = ACTIONS(3397),
    [anon_sym_LBRACK] = ACTIONS(3397),
    [anon_sym_static] = ACTIONS(3399),
    [anon_sym_register] = ACTIONS(3399),
    [anon_sym_inline] = ACTIONS(3399),
    [anon_sym_const] = ACTIONS(3399),
    [anon_sym_restrict] = ACTIONS(3399),
    [anon_sym_volatile] = ACTIONS(3399),
    [anon_sym__Atomic] = ACTIONS(3399),
    [anon_sym_mutable] = ACTIONS(3399),
    [anon_sym_explicit] = ACTIONS(3399),
    [anon_sym_constexpr] = ACTIONS(3399),
    [anon_sym_unsigned] = ACTIONS(3399),
    [anon_sym_long] = ACTIONS(3399),
    [anon_sym_short] = ACTIONS(3399),
    [sym_primitive_type] = ACTIONS(3399),
    [anon_sym_enum] = ACTIONS(3399),
    [anon_sym_struct] = ACTIONS(3399),
    [anon_sym_union] = ACTIONS(3399),
    [anon_sym_if] = ACTIONS(3399),
    [anon_sym_else] = ACTIONS(3399),
    [anon_sym_switch] = ACTIONS(3399),
    [anon_sym_case] = ACTIONS(3399),
    [anon_sym_default] = ACTIONS(3399),
    [anon_sym_while] = ACTIONS(3399),
    [anon_sym_do] = ACTIONS(3399),
    [anon_sym_for] = ACTIONS(3399),
    [anon_sym_return] = ACTIONS(3399),
    [anon_sym_break] = ACTIONS(3399),
    [anon_sym_continue] = ACTIONS(3399),
    [anon_sym_goto] = ACTIONS(3399),
    [anon_sym_AMP] = ACTIONS(3399),
    [anon_sym_AMP_AMP] = ACTIONS(3397),
    [anon_sym_BANG] = ACTIONS(3397),
    [anon_sym_TILDE] = ACTIONS(3397),
    [anon_sym_PLUS] = ACTIONS(3399),
    [anon_sym_DASH] = ACTIONS(3399),
    [anon_sym_DASH_DASH] = ACTIONS(3397),
    [anon_sym_PLUS_PLUS] = ACTIONS(3397),
    [anon_sym_sizeof] = ACTIONS(3399),
    [sym_number_literal] = ACTIONS(3397),
    [anon_sym_SQUOTE] = ACTIONS(3397),
    [anon_sym_DQUOTE] = ACTIONS(3397),
    [sym_true] = ACTIONS(3399),
    [sym_false] = ACTIONS(3399),
    [sym_null] = ACTIONS(3399),
    [sym_identifier] = ACTIONS(3399),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3399),
    [sym_auto] = ACTIONS(3399),
    [anon_sym_typename] = ACTIONS(3399),
    [anon_sym_template] = ACTIONS(3399),
    [anon_sym_delete] = ACTIONS(3399),
    [anon_sym_namespace] = ACTIONS(3399),
    [anon_sym_using] = ACTIONS(3399),
    [anon_sym_try] = ACTIONS(3399),
    [anon_sym_new] = ACTIONS(3399),
    [anon_sym_COLON_COLON] = ACTIONS(3397),
    [sym_operator_name] = ACTIONS(3397),
    [sym_nullptr] = ACTIONS(3399),
  },
  [893] = {
    [sym_preproc_include] = STATE(117),
    [sym_preproc_def] = STATE(117),
    [sym_preproc_function_def] = STATE(117),
    [sym_preproc_call] = STATE(117),
    [sym_preproc_if_in_compound_statement] = STATE(117),
    [sym_preproc_ifdef_in_compound_statement] = STATE(117),
    [sym_declaration] = STATE(117),
    [sym_type_definition] = STATE(117),
    [sym__declaration_specifiers] = STATE(113),
    [sym_compound_statement] = STATE(117),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(117),
    [sym_expression_statement] = STATE(117),
    [sym_if_statement] = STATE(117),
    [sym_switch_statement] = STATE(117),
    [sym_case_statement] = STATE(117),
    [sym_while_statement] = STATE(117),
    [sym_do_statement] = STATE(117),
    [sym_for_statement] = STATE(117),
    [sym_return_statement] = STATE(117),
    [sym_break_statement] = STATE(117),
    [sym_continue_statement] = STATE(117),
    [sym_goto_statement] = STATE(117),
    [sym__expression] = STATE(1631),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(1631),
    [sym_assignment_expression] = STATE(1631),
    [sym_pointer_expression] = STATE(1631),
    [sym_logical_expression] = STATE(1631),
    [sym_bitwise_expression] = STATE(1631),
    [sym_equality_expression] = STATE(1631),
    [sym_relational_expression] = STATE(1631),
    [sym_shift_expression] = STATE(1631),
    [sym_math_expression] = STATE(1631),
    [sym_cast_expression] = STATE(1631),
    [sym_sizeof_expression] = STATE(1631),
    [sym_subscript_expression] = STATE(1631),
    [sym_call_expression] = STATE(1631),
    [sym_field_expression] = STATE(1631),
    [sym_compound_literal_expression] = STATE(1631),
    [sym_parenthesized_expression] = STATE(1631),
    [sym_initializer_list] = STATE(726),
    [sym_initializer_pair] = STATE(726),
    [sym_subscript_designator] = STATE(728),
    [sym_field_designator] = STATE(728),
    [sym_char_literal] = STATE(1631),
    [sym_concatenated_string] = STATE(1631),
    [sym_string_literal] = STATE(1632),
    [sym__empty_declaration] = STATE(117),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(117),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(1631),
    [sym_for_range_loop] = STATE(117),
    [sym_try_statement] = STATE(117),
    [sym_new_expression] = STATE(1631),
    [sym_delete_expression] = STATE(1631),
    [sym_lambda_expression] = STATE(1631),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(117),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [aux_sym_initializer_pair_repeat1] = STATE(728),
    [sym_raw_string_literal] = ACTIONS(3401),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(159),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(161),
    [anon_sym_COMMA] = ACTIONS(1252),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(163),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(165),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(165),
    [sym_preproc_directive] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_typedef] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(3403),
    [anon_sym_RBRACE] = ACTIONS(3405),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_LBRACK] = ACTIONS(1260),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(185),
    [anon_sym_case] = ACTIONS(187),
    [anon_sym_default] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3411),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_sizeof] = ACTIONS(3419),
    [anon_sym_DOT] = ACTIONS(1272),
    [sym_number_literal] = ACTIONS(3401),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(3421),
    [sym_false] = ACTIONS(3421),
    [sym_null] = ACTIONS(3421),
    [sym_identifier] = ACTIONS(209),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(3423),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_COLON_COLON] = ACTIONS(3427),
    [sym_nullptr] = ACTIONS(3421),
  },
  [894] = {
    [sym__declaration_specifiers] = STATE(905),
    [sym_storage_class_specifier] = STATE(907),
    [sym_type_qualifier] = STATE(907),
    [sym__type_specifier] = STATE(906),
    [sym_sized_type_specifier] = STATE(906),
    [sym_enum_specifier] = STATE(906),
    [sym_struct_specifier] = STATE(906),
    [sym_union_specifier] = STATE(906),
    [sym_parameter_declaration] = STATE(902),
    [sym__expression] = STATE(845),
    [sym_conditional_expression] = STATE(845),
    [sym_assignment_expression] = STATE(845),
    [sym_pointer_expression] = STATE(845),
    [sym_logical_expression] = STATE(845),
    [sym_bitwise_expression] = STATE(845),
    [sym_equality_expression] = STATE(845),
    [sym_relational_expression] = STATE(845),
    [sym_shift_expression] = STATE(845),
    [sym_math_expression] = STATE(845),
    [sym_cast_expression] = STATE(845),
    [sym_sizeof_expression] = STATE(845),
    [sym_subscript_expression] = STATE(845),
    [sym_call_expression] = STATE(845),
    [sym_field_expression] = STATE(845),
    [sym_compound_literal_expression] = STATE(845),
    [sym_parenthesized_expression] = STATE(845),
    [sym_initializer_list] = STATE(846),
    [sym_char_literal] = STATE(845),
    [sym_concatenated_string] = STATE(845),
    [sym_string_literal] = STATE(140),
    [sym_macro_type_specifier] = STATE(906),
    [sym_class_specifier] = STATE(906),
    [sym_dependent_type] = STATE(906),
    [sym_template_type] = STATE(1636),
    [sym_template_function] = STATE(845),
    [sym_new_expression] = STATE(845),
    [sym_delete_expression] = STATE(845),
    [sym_lambda_expression] = STATE(845),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(1637),
    [aux_sym__declaration_specifiers_repeat1] = STATE(907),
    [aux_sym_sized_type_specifier_repeat1] = STATE(908),
    [sym_raw_string_literal] = ACTIONS(1529),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1625),
    [anon_sym_RPAREN] = ACTIONS(3429),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(1629),
    [anon_sym_long] = ACTIONS(1629),
    [anon_sym_short] = ACTIONS(1629),
    [sym_primitive_type] = ACTIONS(1631),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(1529),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(1533),
    [sym_false] = ACTIONS(1533),
    [sym_null] = ACTIONS(1533),
    [sym_identifier] = ACTIONS(3431),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(1631),
    [anon_sym_typename] = ACTIONS(1633),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(3433),
    [sym_nullptr] = ACTIONS(1533),
  },
  [895] = {
    [sym__expression] = STATE(1638),
    [sym_conditional_expression] = STATE(1638),
    [sym_assignment_expression] = STATE(1638),
    [sym_pointer_expression] = STATE(1638),
    [sym_logical_expression] = STATE(1638),
    [sym_bitwise_expression] = STATE(1638),
    [sym_equality_expression] = STATE(1638),
    [sym_relational_expression] = STATE(1638),
    [sym_shift_expression] = STATE(1638),
    [sym_math_expression] = STATE(1638),
    [sym_cast_expression] = STATE(1638),
    [sym_sizeof_expression] = STATE(1638),
    [sym_subscript_expression] = STATE(1638),
    [sym_call_expression] = STATE(1638),
    [sym_field_expression] = STATE(1638),
    [sym_compound_literal_expression] = STATE(1638),
    [sym_parenthesized_expression] = STATE(1638),
    [sym_initializer_list] = STATE(1639),
    [sym_char_literal] = STATE(1638),
    [sym_concatenated_string] = STATE(1638),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1638),
    [sym_new_expression] = STATE(1638),
    [sym_delete_expression] = STATE(1638),
    [sym_lambda_expression] = STATE(1638),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3435),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(3435),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(3437),
    [sym_false] = ACTIONS(3437),
    [sym_null] = ACTIONS(3437),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(3437),
  },
  [896] = {
    [sym_raw_string_literal] = ACTIONS(3439),
    [ts_builtin_sym_end] = ACTIONS(3439),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3441),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3441),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3441),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3441),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3441),
    [sym_preproc_directive] = ACTIONS(3441),
    [anon_sym_SEMI] = ACTIONS(3439),
    [anon_sym_typedef] = ACTIONS(3441),
    [anon_sym_extern] = ACTIONS(3441),
    [anon_sym_LBRACE] = ACTIONS(3439),
    [anon_sym_RBRACE] = ACTIONS(3439),
    [anon_sym_LPAREN2] = ACTIONS(3439),
    [anon_sym_STAR] = ACTIONS(3439),
    [anon_sym_LBRACK] = ACTIONS(3439),
    [anon_sym_static] = ACTIONS(3441),
    [anon_sym_register] = ACTIONS(3441),
    [anon_sym_inline] = ACTIONS(3441),
    [anon_sym_const] = ACTIONS(3441),
    [anon_sym_restrict] = ACTIONS(3441),
    [anon_sym_volatile] = ACTIONS(3441),
    [anon_sym__Atomic] = ACTIONS(3441),
    [anon_sym_mutable] = ACTIONS(3441),
    [anon_sym_explicit] = ACTIONS(3441),
    [anon_sym_constexpr] = ACTIONS(3441),
    [anon_sym_unsigned] = ACTIONS(3441),
    [anon_sym_long] = ACTIONS(3441),
    [anon_sym_short] = ACTIONS(3441),
    [sym_primitive_type] = ACTIONS(3441),
    [anon_sym_enum] = ACTIONS(3441),
    [anon_sym_struct] = ACTIONS(3441),
    [anon_sym_union] = ACTIONS(3441),
    [anon_sym_if] = ACTIONS(3441),
    [anon_sym_switch] = ACTIONS(3441),
    [anon_sym_case] = ACTIONS(3441),
    [anon_sym_default] = ACTIONS(3441),
    [anon_sym_while] = ACTIONS(3441),
    [anon_sym_do] = ACTIONS(3441),
    [anon_sym_for] = ACTIONS(3441),
    [anon_sym_return] = ACTIONS(3441),
    [anon_sym_break] = ACTIONS(3441),
    [anon_sym_continue] = ACTIONS(3441),
    [anon_sym_goto] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3441),
    [anon_sym_AMP_AMP] = ACTIONS(3439),
    [anon_sym_BANG] = ACTIONS(3439),
    [anon_sym_TILDE] = ACTIONS(3439),
    [anon_sym_PLUS] = ACTIONS(3441),
    [anon_sym_DASH] = ACTIONS(3441),
    [anon_sym_DASH_DASH] = ACTIONS(3439),
    [anon_sym_PLUS_PLUS] = ACTIONS(3439),
    [anon_sym_sizeof] = ACTIONS(3441),
    [sym_number_literal] = ACTIONS(3439),
    [anon_sym_SQUOTE] = ACTIONS(3439),
    [anon_sym_DQUOTE] = ACTIONS(3439),
    [sym_true] = ACTIONS(3441),
    [sym_false] = ACTIONS(3441),
    [sym_null] = ACTIONS(3441),
    [sym_identifier] = ACTIONS(3441),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3441),
    [sym_auto] = ACTIONS(3441),
    [anon_sym_typename] = ACTIONS(3441),
    [anon_sym_template] = ACTIONS(3441),
    [anon_sym_delete] = ACTIONS(3441),
    [anon_sym_namespace] = ACTIONS(3441),
    [anon_sym_using] = ACTIONS(3441),
    [anon_sym_try] = ACTIONS(3441),
    [anon_sym_new] = ACTIONS(3441),
    [anon_sym_COLON_COLON] = ACTIONS(3439),
    [sym_operator_name] = ACTIONS(3439),
    [sym_nullptr] = ACTIONS(3441),
  },
  [897] = {
    [sym_type_qualifier] = STATE(1641),
    [sym_virtual_specifier] = STATE(1641),
    [sym_trailing_return_type] = STATE(1641),
    [aux_sym_function_declarator_repeat1] = STATE(1641),
    [anon_sym_COMMA] = ACTIONS(1665),
    [anon_sym_SEMI] = ACTIONS(1665),
    [anon_sym_LBRACE] = ACTIONS(1665),
    [anon_sym_LPAREN2] = ACTIONS(1665),
    [anon_sym_LBRACK] = ACTIONS(1665),
    [anon_sym_EQ] = ACTIONS(1665),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(3443),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [sym_noexcept] = ACTIONS(3445),
  },
  [898] = {
    [anon_sym_COMMA] = ACTIONS(3447),
    [anon_sym_RPAREN] = ACTIONS(3447),
    [anon_sym_SEMI] = ACTIONS(3447),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3447),
  },
  [899] = {
    [aux_sym_declaration_repeat1] = STATE(1643),
    [anon_sym_COMMA] = ACTIONS(1613),
    [anon_sym_SEMI] = ACTIONS(3449),
    [sym_comment] = ACTIONS(91),
  },
  [900] = {
    [sym__expression] = STATE(1644),
    [sym_conditional_expression] = STATE(1644),
    [sym_assignment_expression] = STATE(1644),
    [sym_pointer_expression] = STATE(1644),
    [sym_logical_expression] = STATE(1644),
    [sym_bitwise_expression] = STATE(1644),
    [sym_equality_expression] = STATE(1644),
    [sym_relational_expression] = STATE(1644),
    [sym_shift_expression] = STATE(1644),
    [sym_math_expression] = STATE(1644),
    [sym_cast_expression] = STATE(1644),
    [sym_sizeof_expression] = STATE(1644),
    [sym_subscript_expression] = STATE(1644),
    [sym_call_expression] = STATE(1644),
    [sym_field_expression] = STATE(1644),
    [sym_compound_literal_expression] = STATE(1644),
    [sym_parenthesized_expression] = STATE(1644),
    [sym_initializer_list] = STATE(1645),
    [sym_char_literal] = STATE(1644),
    [sym_concatenated_string] = STATE(1644),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1644),
    [sym_new_expression] = STATE(1644),
    [sym_delete_expression] = STATE(1644),
    [sym_lambda_expression] = STATE(1644),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3451),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(3451),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(3453),
    [sym_false] = ACTIONS(3453),
    [sym_null] = ACTIONS(3453),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(3453),
  },
  [901] = {
    [anon_sym_SEMI] = ACTIONS(3455),
    [sym_comment] = ACTIONS(91),
  },
  [902] = {
    [aux_sym_parameter_list_repeat1] = STATE(1649),
    [anon_sym_COMMA] = ACTIONS(3457),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [sym_comment] = ACTIONS(91),
  },
  [903] = {
    [anon_sym_COMMA] = ACTIONS(3461),
    [anon_sym_RPAREN] = ACTIONS(3461),
    [anon_sym_SEMI] = ACTIONS(3461),
    [anon_sym_LBRACE] = ACTIONS(3461),
    [anon_sym_LPAREN2] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3461),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_const] = ACTIONS(3463),
    [anon_sym_restrict] = ACTIONS(3461),
    [anon_sym_volatile] = ACTIONS(3461),
    [anon_sym__Atomic] = ACTIONS(3461),
    [anon_sym_mutable] = ACTIONS(3461),
    [anon_sym_explicit] = ACTIONS(3461),
    [anon_sym_constexpr] = ACTIONS(3461),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3461),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3461),
    [anon_sym_override] = ACTIONS(3461),
    [anon_sym_GT2] = ACTIONS(3461),
    [sym_noexcept] = ACTIONS(3461),
  },
  [904] = {
    [sym__type_specifier] = STATE(271),
    [sym_sized_type_specifier] = STATE(271),
    [sym_enum_specifier] = STATE(271),
    [sym_struct_specifier] = STATE(271),
    [sym_union_specifier] = STATE(271),
    [sym_macro_type_specifier] = STATE(271),
    [sym_class_specifier] = STATE(271),
    [sym_dependent_type] = STATE(271),
    [sym_template_type] = STATE(272),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(180),
    [aux_sym_sized_type_specifier_repeat1] = STATE(908),
    [anon_sym_unsigned] = ACTIONS(1629),
    [anon_sym_long] = ACTIONS(1629),
    [anon_sym_short] = ACTIONS(1629),
    [sym_primitive_type] = ACTIONS(490),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [sym_identifier] = ACTIONS(492),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(490),
    [anon_sym_typename] = ACTIONS(1633),
    [anon_sym_COLON_COLON] = ACTIONS(315),
  },
  [905] = {
    [sym__declarator] = STATE(1652),
    [sym__abstract_declarator] = STATE(1653),
    [sym_pointer_declarator] = STATE(1652),
    [sym_abstract_pointer_declarator] = STATE(1653),
    [sym_function_declarator] = STATE(1652),
    [sym_abstract_function_declarator] = STATE(1653),
    [sym_array_declarator] = STATE(1652),
    [sym_abstract_array_declarator] = STATE(1653),
    [sym_init_declarator] = STATE(1537),
    [sym_parameter_list] = STATE(1654),
    [sym_reference_declarator] = STATE(1652),
    [sym_abstract_reference_declarator] = STATE(1653),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(1652),
    [sym_destructor_name] = STATE(1652),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [anon_sym_COMMA] = ACTIONS(3247),
    [anon_sym_RPAREN] = ACTIONS(3247),
    [anon_sym_LPAREN2] = ACTIONS(3249),
    [anon_sym_STAR] = ACTIONS(3465),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_AMP] = ACTIONS(3467),
    [anon_sym_AMP_AMP] = ACTIONS(3469),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(568),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(3471),
  },
  [906] = {
    [sym_storage_class_specifier] = STATE(1655),
    [sym_type_qualifier] = STATE(1655),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1655),
    [anon_sym_COMMA] = ACTIONS(582),
    [anon_sym_RPAREN] = ACTIONS(582),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_LPAREN2] = ACTIONS(582),
    [anon_sym_STAR] = ACTIONS(582),
    [anon_sym_LBRACK] = ACTIONS(582),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(584),
    [anon_sym_AMP_AMP] = ACTIONS(582),
    [anon_sym_TILDE] = ACTIONS(582),
    [sym_identifier] = ACTIONS(584),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(582),
    [sym_operator_name] = ACTIONS(582),
  },
  [907] = {
    [sym_storage_class_specifier] = STATE(497),
    [sym_type_qualifier] = STATE(497),
    [sym__type_specifier] = STATE(1656),
    [sym_sized_type_specifier] = STATE(1656),
    [sym_enum_specifier] = STATE(1656),
    [sym_struct_specifier] = STATE(1656),
    [sym_union_specifier] = STATE(1656),
    [sym_macro_type_specifier] = STATE(1656),
    [sym_class_specifier] = STATE(1656),
    [sym_dependent_type] = STATE(1656),
    [sym_template_type] = STATE(272),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(180),
    [aux_sym__declaration_specifiers_repeat1] = STATE(497),
    [aux_sym_sized_type_specifier_repeat1] = STATE(908),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(1629),
    [anon_sym_long] = ACTIONS(1629),
    [anon_sym_short] = ACTIONS(1629),
    [sym_primitive_type] = ACTIONS(3473),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [sym_identifier] = ACTIONS(492),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(3473),
    [anon_sym_typename] = ACTIONS(1633),
    [anon_sym_COLON_COLON] = ACTIONS(315),
  },
  [908] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1657),
    [anon_sym_COMMA] = ACTIONS(653),
    [anon_sym_RPAREN] = ACTIONS(653),
    [anon_sym_extern] = ACTIONS(655),
    [anon_sym_LPAREN2] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_register] = ACTIONS(655),
    [anon_sym_inline] = ACTIONS(655),
    [anon_sym_const] = ACTIONS(655),
    [anon_sym_restrict] = ACTIONS(655),
    [anon_sym_volatile] = ACTIONS(655),
    [anon_sym__Atomic] = ACTIONS(655),
    [anon_sym_mutable] = ACTIONS(655),
    [anon_sym_explicit] = ACTIONS(655),
    [anon_sym_constexpr] = ACTIONS(655),
    [anon_sym_unsigned] = ACTIONS(3475),
    [anon_sym_long] = ACTIONS(3475),
    [anon_sym_short] = ACTIONS(3475),
    [sym_primitive_type] = ACTIONS(659),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [anon_sym_TILDE] = ACTIONS(653),
    [sym_identifier] = ACTIONS(661),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(653),
    [sym_operator_name] = ACTIONS(653),
  },
  [909] = {
    [sym_type_qualifier] = STATE(141),
    [sym__type_specifier] = STATE(136),
    [sym_sized_type_specifier] = STATE(136),
    [sym_enum_specifier] = STATE(136),
    [sym_struct_specifier] = STATE(136),
    [sym_union_specifier] = STATE(136),
    [sym__expression] = STATE(137),
    [sym_comma_expression] = STATE(138),
    [sym_conditional_expression] = STATE(137),
    [sym_assignment_expression] = STATE(137),
    [sym_pointer_expression] = STATE(137),
    [sym_logical_expression] = STATE(137),
    [sym_bitwise_expression] = STATE(137),
    [sym_equality_expression] = STATE(137),
    [sym_relational_expression] = STATE(137),
    [sym_shift_expression] = STATE(137),
    [sym_math_expression] = STATE(137),
    [sym_cast_expression] = STATE(137),
    [sym_type_descriptor] = STATE(1658),
    [sym_sizeof_expression] = STATE(137),
    [sym_subscript_expression] = STATE(137),
    [sym_call_expression] = STATE(137),
    [sym_field_expression] = STATE(137),
    [sym_compound_literal_expression] = STATE(137),
    [sym_parenthesized_expression] = STATE(137),
    [sym_char_literal] = STATE(137),
    [sym_concatenated_string] = STATE(137),
    [sym_string_literal] = STATE(140),
    [sym_macro_type_specifier] = STATE(136),
    [sym_class_specifier] = STATE(136),
    [sym_dependent_type] = STATE(136),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(137),
    [sym_new_expression] = STATE(137),
    [sym_delete_expression] = STATE(137),
    [sym_lambda_expression] = STATE(137),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_type_definition_repeat1] = STATE(141),
    [aux_sym_sized_type_specifier_repeat1] = STATE(142),
    [sym_raw_string_literal] = ACTIONS(213),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(219),
    [anon_sym_long] = ACTIONS(219),
    [anon_sym_short] = ACTIONS(219),
    [sym_primitive_type] = ACTIONS(221),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [sym_null] = ACTIONS(241),
    [sym_identifier] = ACTIONS(811),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(221),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(253),
    [sym_nullptr] = ACTIONS(241),
  },
  [910] = {
    [sym__expression] = STATE(146),
    [sym_conditional_expression] = STATE(146),
    [sym_assignment_expression] = STATE(146),
    [sym_pointer_expression] = STATE(146),
    [sym_logical_expression] = STATE(146),
    [sym_bitwise_expression] = STATE(146),
    [sym_equality_expression] = STATE(146),
    [sym_relational_expression] = STATE(146),
    [sym_shift_expression] = STATE(146),
    [sym_math_expression] = STATE(146),
    [sym_cast_expression] = STATE(146),
    [sym_sizeof_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_compound_literal_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_char_literal] = STATE(146),
    [sym_concatenated_string] = STATE(146),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(146),
    [sym_new_expression] = STATE(146),
    [sym_delete_expression] = STATE(146),
    [sym_lambda_expression] = STATE(146),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(257),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(3477),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(257),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(259),
    [sym_false] = ACTIONS(259),
    [sym_null] = ACTIONS(259),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(259),
  },
  [911] = {
    [anon_sym_COMMA] = ACTIONS(3479),
    [anon_sym_RPAREN] = ACTIONS(3479),
    [anon_sym_SEMI] = ACTIONS(3479),
    [anon_sym_LBRACE] = ACTIONS(3479),
    [anon_sym_LPAREN2] = ACTIONS(3479),
    [anon_sym_LBRACK] = ACTIONS(3479),
    [anon_sym_EQ] = ACTIONS(3479),
    [anon_sym_COLON] = ACTIONS(3479),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3479),
  },
  [912] = {
    [sym_raw_string_literal] = ACTIONS(299),
    [anon_sym_LPAREN2] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(299),
    [anon_sym_RBRACK] = ACTIONS(299),
    [anon_sym_const] = ACTIONS(301),
    [anon_sym_restrict] = ACTIONS(301),
    [anon_sym_volatile] = ACTIONS(301),
    [anon_sym__Atomic] = ACTIONS(301),
    [anon_sym_mutable] = ACTIONS(301),
    [anon_sym_explicit] = ACTIONS(301),
    [anon_sym_constexpr] = ACTIONS(301),
    [anon_sym_AMP] = ACTIONS(299),
    [anon_sym_BANG] = ACTIONS(299),
    [anon_sym_TILDE] = ACTIONS(299),
    [anon_sym_PLUS] = ACTIONS(301),
    [anon_sym_DASH] = ACTIONS(301),
    [anon_sym_DASH_DASH] = ACTIONS(299),
    [anon_sym_PLUS_PLUS] = ACTIONS(299),
    [anon_sym_sizeof] = ACTIONS(301),
    [sym_number_literal] = ACTIONS(299),
    [anon_sym_SQUOTE] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_true] = ACTIONS(301),
    [sym_false] = ACTIONS(301),
    [sym_null] = ACTIONS(301),
    [sym_identifier] = ACTIONS(301),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(301),
    [anon_sym_new] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(299),
    [sym_nullptr] = ACTIONS(301),
  },
  [913] = {
    [sym__expression] = STATE(146),
    [sym_conditional_expression] = STATE(146),
    [sym_assignment_expression] = STATE(146),
    [sym_pointer_expression] = STATE(146),
    [sym_logical_expression] = STATE(146),
    [sym_bitwise_expression] = STATE(146),
    [sym_equality_expression] = STATE(146),
    [sym_relational_expression] = STATE(146),
    [sym_shift_expression] = STATE(146),
    [sym_math_expression] = STATE(146),
    [sym_cast_expression] = STATE(146),
    [sym_sizeof_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_compound_literal_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_char_literal] = STATE(146),
    [sym_concatenated_string] = STATE(146),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(146),
    [sym_new_expression] = STATE(146),
    [sym_delete_expression] = STATE(146),
    [sym_lambda_expression] = STATE(146),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(257),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(257),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(259),
    [sym_false] = ACTIONS(259),
    [sym_null] = ACTIONS(259),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(259),
  },
  [914] = {
    [sym__expression] = STATE(250),
    [sym_conditional_expression] = STATE(250),
    [sym_assignment_expression] = STATE(250),
    [sym_pointer_expression] = STATE(250),
    [sym_logical_expression] = STATE(250),
    [sym_bitwise_expression] = STATE(250),
    [sym_equality_expression] = STATE(250),
    [sym_relational_expression] = STATE(250),
    [sym_shift_expression] = STATE(250),
    [sym_math_expression] = STATE(250),
    [sym_cast_expression] = STATE(250),
    [sym_sizeof_expression] = STATE(250),
    [sym_subscript_expression] = STATE(250),
    [sym_call_expression] = STATE(250),
    [sym_field_expression] = STATE(250),
    [sym_compound_literal_expression] = STATE(250),
    [sym_parenthesized_expression] = STATE(250),
    [sym_char_literal] = STATE(250),
    [sym_concatenated_string] = STATE(250),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(250),
    [sym_new_expression] = STATE(250),
    [sym_delete_expression] = STATE(250),
    [sym_lambda_expression] = STATE(250),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(435),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(435),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(437),
    [sym_false] = ACTIONS(437),
    [sym_null] = ACTIONS(437),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(437),
  },
  [915] = {
    [sym__expression] = STATE(252),
    [sym_conditional_expression] = STATE(252),
    [sym_assignment_expression] = STATE(252),
    [sym_pointer_expression] = STATE(252),
    [sym_logical_expression] = STATE(252),
    [sym_bitwise_expression] = STATE(252),
    [sym_equality_expression] = STATE(252),
    [sym_relational_expression] = STATE(252),
    [sym_shift_expression] = STATE(252),
    [sym_math_expression] = STATE(252),
    [sym_cast_expression] = STATE(252),
    [sym_sizeof_expression] = STATE(252),
    [sym_subscript_expression] = STATE(252),
    [sym_call_expression] = STATE(252),
    [sym_field_expression] = STATE(252),
    [sym_compound_literal_expression] = STATE(252),
    [sym_parenthesized_expression] = STATE(252),
    [sym_char_literal] = STATE(252),
    [sym_concatenated_string] = STATE(252),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(252),
    [sym_new_expression] = STATE(252),
    [sym_delete_expression] = STATE(252),
    [sym_lambda_expression] = STATE(252),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(439),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(439),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(441),
    [sym_false] = ACTIONS(441),
    [sym_null] = ACTIONS(441),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(441),
  },
  [916] = {
    [sym__expression] = STATE(253),
    [sym_conditional_expression] = STATE(253),
    [sym_assignment_expression] = STATE(253),
    [sym_pointer_expression] = STATE(253),
    [sym_logical_expression] = STATE(253),
    [sym_bitwise_expression] = STATE(253),
    [sym_equality_expression] = STATE(253),
    [sym_relational_expression] = STATE(253),
    [sym_shift_expression] = STATE(253),
    [sym_math_expression] = STATE(253),
    [sym_cast_expression] = STATE(253),
    [sym_sizeof_expression] = STATE(253),
    [sym_subscript_expression] = STATE(253),
    [sym_call_expression] = STATE(253),
    [sym_field_expression] = STATE(253),
    [sym_compound_literal_expression] = STATE(253),
    [sym_parenthesized_expression] = STATE(253),
    [sym_char_literal] = STATE(253),
    [sym_concatenated_string] = STATE(253),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(253),
    [sym_new_expression] = STATE(253),
    [sym_delete_expression] = STATE(253),
    [sym_lambda_expression] = STATE(253),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(445),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(445),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(447),
    [sym_false] = ACTIONS(447),
    [sym_null] = ACTIONS(447),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(447),
  },
  [917] = {
    [sym__expression] = STATE(1661),
    [sym_conditional_expression] = STATE(1661),
    [sym_assignment_expression] = STATE(1661),
    [sym_pointer_expression] = STATE(1661),
    [sym_logical_expression] = STATE(1661),
    [sym_bitwise_expression] = STATE(1661),
    [sym_equality_expression] = STATE(1661),
    [sym_relational_expression] = STATE(1661),
    [sym_shift_expression] = STATE(1661),
    [sym_math_expression] = STATE(1661),
    [sym_cast_expression] = STATE(1661),
    [sym_sizeof_expression] = STATE(1661),
    [sym_subscript_expression] = STATE(1661),
    [sym_call_expression] = STATE(1661),
    [sym_field_expression] = STATE(1661),
    [sym_compound_literal_expression] = STATE(1661),
    [sym_parenthesized_expression] = STATE(1661),
    [sym_char_literal] = STATE(1661),
    [sym_concatenated_string] = STATE(1661),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1661),
    [sym_new_expression] = STATE(1661),
    [sym_delete_expression] = STATE(1661),
    [sym_lambda_expression] = STATE(1661),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3481),
    [anon_sym_LPAREN2] = ACTIONS(3483),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(3481),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(3485),
    [sym_false] = ACTIONS(3485),
    [sym_null] = ACTIONS(3485),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(3485),
  },
  [918] = {
    [sym__expression] = STATE(1663),
    [sym_conditional_expression] = STATE(1663),
    [sym_assignment_expression] = STATE(1663),
    [sym_pointer_expression] = STATE(1663),
    [sym_logical_expression] = STATE(1663),
    [sym_bitwise_expression] = STATE(1663),
    [sym_equality_expression] = STATE(1663),
    [sym_relational_expression] = STATE(1663),
    [sym_shift_expression] = STATE(1663),
    [sym_math_expression] = STATE(1663),
    [sym_cast_expression] = STATE(1663),
    [sym_sizeof_expression] = STATE(1663),
    [sym_subscript_expression] = STATE(1663),
    [sym_call_expression] = STATE(1663),
    [sym_field_expression] = STATE(1663),
    [sym_compound_literal_expression] = STATE(1663),
    [sym_parenthesized_expression] = STATE(1663),
    [sym_char_literal] = STATE(1663),
    [sym_concatenated_string] = STATE(1663),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1663),
    [sym_new_expression] = STATE(1663),
    [sym_delete_expression] = STATE(1663),
    [sym_lambda_expression] = STATE(1663),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(3489),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(3487),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(3491),
    [sym_false] = ACTIONS(3491),
    [sym_null] = ACTIONS(3491),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(3491),
  },
  [919] = {
    [sym__type_specifier] = STATE(1665),
    [sym_sized_type_specifier] = STATE(1665),
    [sym_enum_specifier] = STATE(1665),
    [sym_struct_specifier] = STATE(1665),
    [sym_union_specifier] = STATE(1665),
    [sym_argument_list] = STATE(1666),
    [sym_macro_type_specifier] = STATE(1665),
    [sym_class_specifier] = STATE(1665),
    [sym_dependent_type] = STATE(1665),
    [sym_template_type] = STATE(309),
    [sym_scoped_type_identifier] = STATE(310),
    [sym_scoped_namespace_identifier] = STATE(311),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1667),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_unsigned] = ACTIONS(3493),
    [anon_sym_long] = ACTIONS(3493),
    [anon_sym_short] = ACTIONS(3493),
    [sym_primitive_type] = ACTIONS(3495),
    [anon_sym_enum] = ACTIONS(536),
    [anon_sym_struct] = ACTIONS(538),
    [anon_sym_union] = ACTIONS(540),
    [sym_identifier] = ACTIONS(542),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(544),
    [sym_auto] = ACTIONS(3495),
    [anon_sym_typename] = ACTIONS(3497),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [920] = {
    [sym_destructor_name] = STATE(315),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(937),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(3499),
    [sym_operator_name] = ACTIONS(554),
  },
  [921] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(3477),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_STAR_EQ] = ACTIONS(3507),
    [anon_sym_SLASH_EQ] = ACTIONS(3507),
    [anon_sym_PERCENT_EQ] = ACTIONS(3507),
    [anon_sym_PLUS_EQ] = ACTIONS(3507),
    [anon_sym_DASH_EQ] = ACTIONS(3507),
    [anon_sym_LT_LT_EQ] = ACTIONS(3507),
    [anon_sym_GT_GT_EQ] = ACTIONS(3507),
    [anon_sym_AMP_EQ] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(3507),
    [anon_sym_PIPE_EQ] = ACTIONS(3507),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_CARET] = ACTIONS(3517),
    [anon_sym_EQ_EQ] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3521),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3525),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [922] = {
    [sym_string_literal] = STATE(1681),
    [aux_sym_concatenated_string_repeat1] = STATE(1681),
    [anon_sym_LPAREN2] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_RBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(91),
  },
  [923] = {
    [sym_type_qualifier] = STATE(1684),
    [sym__expression] = STATE(1683),
    [sym_conditional_expression] = STATE(1683),
    [sym_assignment_expression] = STATE(1683),
    [sym_pointer_expression] = STATE(1683),
    [sym_logical_expression] = STATE(1683),
    [sym_bitwise_expression] = STATE(1683),
    [sym_equality_expression] = STATE(1683),
    [sym_relational_expression] = STATE(1683),
    [sym_shift_expression] = STATE(1683),
    [sym_math_expression] = STATE(1683),
    [sym_cast_expression] = STATE(1683),
    [sym_sizeof_expression] = STATE(1683),
    [sym_subscript_expression] = STATE(1683),
    [sym_call_expression] = STATE(1683),
    [sym_field_expression] = STATE(1683),
    [sym_compound_literal_expression] = STATE(1683),
    [sym_parenthesized_expression] = STATE(1683),
    [sym_char_literal] = STATE(1683),
    [sym_concatenated_string] = STATE(1683),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1683),
    [sym_new_expression] = STATE(1683),
    [sym_delete_expression] = STATE(1683),
    [sym_lambda_expression] = STATE(1683),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [aux_sym_type_definition_repeat1] = STATE(1684),
    [sym_raw_string_literal] = ACTIONS(3529),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(3477),
    [anon_sym_const] = ACTIONS(1643),
    [anon_sym_restrict] = ACTIONS(1643),
    [anon_sym_volatile] = ACTIONS(1643),
    [anon_sym__Atomic] = ACTIONS(1643),
    [anon_sym_mutable] = ACTIONS(1643),
    [anon_sym_explicit] = ACTIONS(1643),
    [anon_sym_constexpr] = ACTIONS(1643),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(3529),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(3533),
    [sym_false] = ACTIONS(3533),
    [sym_null] = ACTIONS(3533),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(3533),
  },
  [924] = {
    [anon_sym_COMMA] = ACTIONS(299),
    [anon_sym_SEMI] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_LPAREN2] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(299),
    [anon_sym_EQ] = ACTIONS(299),
    [anon_sym_const] = ACTIONS(301),
    [anon_sym_restrict] = ACTIONS(299),
    [anon_sym_volatile] = ACTIONS(299),
    [anon_sym__Atomic] = ACTIONS(299),
    [anon_sym_mutable] = ACTIONS(299),
    [anon_sym_explicit] = ACTIONS(299),
    [anon_sym_constexpr] = ACTIONS(299),
    [anon_sym_COLON] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(299),
    [anon_sym_DASH_GT] = ACTIONS(299),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(299),
    [anon_sym_override] = ACTIONS(299),
    [sym_noexcept] = ACTIONS(299),
  },
  [925] = {
    [sym__type_specifier] = STATE(1690),
    [sym_sized_type_specifier] = STATE(1690),
    [sym_enum_specifier] = STATE(1690),
    [sym_struct_specifier] = STATE(1690),
    [sym_union_specifier] = STATE(1690),
    [sym_macro_type_specifier] = STATE(1690),
    [sym_class_specifier] = STATE(1690),
    [sym_dependent_type] = STATE(1690),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(1691),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1692),
    [anon_sym_unsigned] = ACTIONS(3535),
    [anon_sym_long] = ACTIONS(3535),
    [anon_sym_short] = ACTIONS(3535),
    [sym_primitive_type] = ACTIONS(3537),
    [anon_sym_enum] = ACTIONS(3539),
    [anon_sym_struct] = ACTIONS(3541),
    [anon_sym_union] = ACTIONS(3543),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3545),
    [sym_auto] = ACTIONS(3537),
    [anon_sym_typename] = ACTIONS(3547),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [926] = {
    [sym_type_qualifier] = STATE(1693),
    [sym_virtual_specifier] = STATE(1693),
    [sym_trailing_return_type] = STATE(1693),
    [aux_sym_function_declarator_repeat1] = STATE(1693),
    [anon_sym_LBRACE] = ACTIONS(3549),
    [anon_sym_LPAREN2] = ACTIONS(3549),
    [anon_sym_LBRACK] = ACTIONS(3549),
    [anon_sym_EQ] = ACTIONS(3549),
    [anon_sym_const] = ACTIONS(1667),
    [anon_sym_restrict] = ACTIONS(1669),
    [anon_sym_volatile] = ACTIONS(1669),
    [anon_sym__Atomic] = ACTIONS(1669),
    [anon_sym_mutable] = ACTIONS(1669),
    [anon_sym_explicit] = ACTIONS(1669),
    [anon_sym_constexpr] = ACTIONS(1669),
    [anon_sym_COLON] = ACTIONS(3549),
    [anon_sym_DASH_GT] = ACTIONS(1671),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [sym_noexcept] = ACTIONS(3551),
  },
  [927] = {
    [anon_sym_SEMI] = ACTIONS(3553),
    [sym_comment] = ACTIONS(91),
  },
  [928] = {
    [anon_sym_SEMI] = ACTIONS(3555),
    [sym_comment] = ACTIONS(91),
  },
  [929] = {
    [sym_argument_list] = STATE(1697),
    [sym_initializer_list] = STATE(1697),
    [sym_template_argument_list] = STATE(437),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_LT] = ACTIONS(945),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(3557),
  },
  [930] = {
    [sym_destructor_name] = STATE(1699),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(3559),
    [sym_comment] = ACTIONS(91),
    [sym_operator_name] = ACTIONS(3561),
  },
  [931] = {
    [aux_sym_field_initializer_list_repeat1] = STATE(1701),
    [anon_sym_COMMA] = ACTIONS(3563),
    [anon_sym_LBRACE] = ACTIONS(3565),
    [anon_sym_EQ] = ACTIONS(3565),
    [sym_comment] = ACTIONS(91),
  },
  [932] = {
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(3567),
  },
  [933] = {
    [sym_argument_list] = STATE(1703),
    [sym_initializer_list] = STATE(1703),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [sym_comment] = ACTIONS(91),
  },
  [934] = {
    [sym_raw_string_literal] = ACTIONS(3569),
    [ts_builtin_sym_end] = ACTIONS(3569),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3571),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3571),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3571),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3571),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3571),
    [sym_preproc_directive] = ACTIONS(3571),
    [anon_sym_SEMI] = ACTIONS(3569),
    [anon_sym_typedef] = ACTIONS(3571),
    [anon_sym_extern] = ACTIONS(3571),
    [anon_sym_LBRACE] = ACTIONS(3569),
    [anon_sym_RBRACE] = ACTIONS(3569),
    [anon_sym_LPAREN2] = ACTIONS(3569),
    [anon_sym_STAR] = ACTIONS(3569),
    [anon_sym_LBRACK] = ACTIONS(3569),
    [anon_sym_static] = ACTIONS(3571),
    [anon_sym_register] = ACTIONS(3571),
    [anon_sym_inline] = ACTIONS(3571),
    [anon_sym_const] = ACTIONS(3571),
    [anon_sym_restrict] = ACTIONS(3571),
    [anon_sym_volatile] = ACTIONS(3571),
    [anon_sym__Atomic] = ACTIONS(3571),
    [anon_sym_mutable] = ACTIONS(3571),
    [anon_sym_explicit] = ACTIONS(3571),
    [anon_sym_constexpr] = ACTIONS(3571),
    [anon_sym_unsigned] = ACTIONS(3571),
    [anon_sym_long] = ACTIONS(3571),
    [anon_sym_short] = ACTIONS(3571),
    [sym_primitive_type] = ACTIONS(3571),
    [anon_sym_enum] = ACTIONS(3571),
    [anon_sym_struct] = ACTIONS(3571),
    [anon_sym_union] = ACTIONS(3571),
    [anon_sym_if] = ACTIONS(3571),
    [anon_sym_switch] = ACTIONS(3571),
    [anon_sym_case] = ACTIONS(3571),
    [anon_sym_default] = ACTIONS(3571),
    [anon_sym_while] = ACTIONS(3571),
    [anon_sym_do] = ACTIONS(3571),
    [anon_sym_for] = ACTIONS(3571),
    [anon_sym_return] = ACTIONS(3571),
    [anon_sym_break] = ACTIONS(3571),
    [anon_sym_continue] = ACTIONS(3571),
    [anon_sym_goto] = ACTIONS(3571),
    [anon_sym_AMP] = ACTIONS(3571),
    [anon_sym_AMP_AMP] = ACTIONS(3569),
    [anon_sym_BANG] = ACTIONS(3569),
    [anon_sym_TILDE] = ACTIONS(3569),
    [anon_sym_PLUS] = ACTIONS(3571),
    [anon_sym_DASH] = ACTIONS(3571),
    [anon_sym_DASH_DASH] = ACTIONS(3569),
    [anon_sym_PLUS_PLUS] = ACTIONS(3569),
    [anon_sym_sizeof] = ACTIONS(3571),
    [sym_number_literal] = ACTIONS(3569),
    [anon_sym_SQUOTE] = ACTIONS(3569),
    [anon_sym_DQUOTE] = ACTIONS(3569),
    [sym_true] = ACTIONS(3571),
    [sym_false] = ACTIONS(3571),
    [sym_null] = ACTIONS(3571),
    [sym_identifier] = ACTIONS(3571),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3571),
    [sym_auto] = ACTIONS(3571),
    [anon_sym_typename] = ACTIONS(3571),
    [anon_sym_template] = ACTIONS(3571),
    [anon_sym_delete] = ACTIONS(3571),
    [anon_sym_namespace] = ACTIONS(3571),
    [anon_sym_using] = ACTIONS(3571),
    [anon_sym_try] = ACTIONS(3571),
    [anon_sym_new] = ACTIONS(3571),
    [anon_sym_COLON_COLON] = ACTIONS(3569),
    [sym_operator_name] = ACTIONS(3569),
    [sym_nullptr] = ACTIONS(3571),
  },
  [935] = {
    [sym_storage_class_specifier] = STATE(935),
    [sym_type_qualifier] = STATE(935),
    [aux_sym__declaration_specifiers_repeat1] = STATE(935),
    [anon_sym_SEMI] = ACTIONS(1970),
    [anon_sym_extern] = ACTIONS(1967),
    [anon_sym_LPAREN2] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(1970),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_static] = ACTIONS(1967),
    [anon_sym_register] = ACTIONS(1967),
    [anon_sym_inline] = ACTIONS(1967),
    [anon_sym_const] = ACTIONS(1972),
    [anon_sym_restrict] = ACTIONS(1972),
    [anon_sym_volatile] = ACTIONS(1972),
    [anon_sym__Atomic] = ACTIONS(1972),
    [anon_sym_mutable] = ACTIONS(1972),
    [anon_sym_explicit] = ACTIONS(1972),
    [anon_sym_constexpr] = ACTIONS(1972),
    [anon_sym_AMP] = ACTIONS(1975),
    [anon_sym_AMP_AMP] = ACTIONS(1970),
    [anon_sym_TILDE] = ACTIONS(1970),
    [sym_identifier] = ACTIONS(1975),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1970),
    [sym_operator_name] = ACTIONS(1970),
  },
  [936] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(586),
    [anon_sym_SEMI] = ACTIONS(3573),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(590),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(594),
    [anon_sym_QMARK] = ACTIONS(596),
    [anon_sym_STAR_EQ] = ACTIONS(598),
    [anon_sym_SLASH_EQ] = ACTIONS(598),
    [anon_sym_PERCENT_EQ] = ACTIONS(598),
    [anon_sym_PLUS_EQ] = ACTIONS(598),
    [anon_sym_DASH_EQ] = ACTIONS(598),
    [anon_sym_LT_LT_EQ] = ACTIONS(598),
    [anon_sym_GT_GT_EQ] = ACTIONS(598),
    [anon_sym_AMP_EQ] = ACTIONS(598),
    [anon_sym_CARET_EQ] = ACTIONS(598),
    [anon_sym_PIPE_EQ] = ACTIONS(598),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_PIPE_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(604),
    [anon_sym_PIPE] = ACTIONS(606),
    [anon_sym_CARET] = ACTIONS(608),
    [anon_sym_EQ_EQ] = ACTIONS(610),
    [anon_sym_BANG_EQ] = ACTIONS(610),
    [anon_sym_LT] = ACTIONS(612),
    [anon_sym_GT] = ACTIONS(612),
    [anon_sym_LT_EQ] = ACTIONS(614),
    [anon_sym_GT_EQ] = ACTIONS(614),
    [anon_sym_LT_LT] = ACTIONS(616),
    [anon_sym_GT_GT] = ACTIONS(616),
    [anon_sym_PLUS] = ACTIONS(618),
    [anon_sym_DASH] = ACTIONS(618),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [937] = {
    [anon_sym_RPAREN] = ACTIONS(3573),
    [anon_sym_SEMI] = ACTIONS(3573),
    [sym_comment] = ACTIONS(91),
  },
  [938] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3575),
    [anon_sym_RPAREN] = ACTIONS(3575),
    [anon_sym_SEMI] = ACTIONS(3575),
    [anon_sym_RBRACE] = ACTIONS(3575),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3577),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(3575),
    [anon_sym_EQ] = ACTIONS(3577),
    [anon_sym_QMARK] = ACTIONS(3575),
    [anon_sym_STAR_EQ] = ACTIONS(3575),
    [anon_sym_SLASH_EQ] = ACTIONS(3575),
    [anon_sym_PERCENT_EQ] = ACTIONS(3575),
    [anon_sym_PLUS_EQ] = ACTIONS(3575),
    [anon_sym_DASH_EQ] = ACTIONS(3575),
    [anon_sym_LT_LT_EQ] = ACTIONS(3575),
    [anon_sym_GT_GT_EQ] = ACTIONS(3575),
    [anon_sym_AMP_EQ] = ACTIONS(3575),
    [anon_sym_CARET_EQ] = ACTIONS(3575),
    [anon_sym_PIPE_EQ] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_PIPE_PIPE] = ACTIONS(3575),
    [anon_sym_AMP_AMP] = ACTIONS(3575),
    [anon_sym_PIPE] = ACTIONS(3577),
    [anon_sym_CARET] = ACTIONS(3577),
    [anon_sym_EQ_EQ] = ACTIONS(3575),
    [anon_sym_BANG_EQ] = ACTIONS(3575),
    [anon_sym_LT] = ACTIONS(3577),
    [anon_sym_GT] = ACTIONS(3577),
    [anon_sym_LT_EQ] = ACTIONS(3575),
    [anon_sym_GT_EQ] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3577),
    [anon_sym_GT_GT] = ACTIONS(3577),
    [anon_sym_PLUS] = ACTIONS(3577),
    [anon_sym_DASH] = ACTIONS(3577),
    [anon_sym_SLASH] = ACTIONS(3577),
    [anon_sym_PERCENT] = ACTIONS(3577),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [939] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(3579),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_STAR_EQ] = ACTIONS(3507),
    [anon_sym_SLASH_EQ] = ACTIONS(3507),
    [anon_sym_PERCENT_EQ] = ACTIONS(3507),
    [anon_sym_PLUS_EQ] = ACTIONS(3507),
    [anon_sym_DASH_EQ] = ACTIONS(3507),
    [anon_sym_LT_LT_EQ] = ACTIONS(3507),
    [anon_sym_GT_GT_EQ] = ACTIONS(3507),
    [anon_sym_AMP_EQ] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(3507),
    [anon_sym_PIPE_EQ] = ACTIONS(3507),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_CARET] = ACTIONS(3517),
    [anon_sym_EQ_EQ] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3521),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3525),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [940] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3581),
    [anon_sym_SEMI] = ACTIONS(3581),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(590),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(594),
    [anon_sym_QMARK] = ACTIONS(3581),
    [anon_sym_STAR_EQ] = ACTIONS(598),
    [anon_sym_SLASH_EQ] = ACTIONS(598),
    [anon_sym_PERCENT_EQ] = ACTIONS(598),
    [anon_sym_PLUS_EQ] = ACTIONS(598),
    [anon_sym_DASH_EQ] = ACTIONS(598),
    [anon_sym_LT_LT_EQ] = ACTIONS(598),
    [anon_sym_GT_GT_EQ] = ACTIONS(598),
    [anon_sym_AMP_EQ] = ACTIONS(598),
    [anon_sym_CARET_EQ] = ACTIONS(598),
    [anon_sym_PIPE_EQ] = ACTIONS(598),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_PIPE_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(604),
    [anon_sym_PIPE] = ACTIONS(606),
    [anon_sym_CARET] = ACTIONS(608),
    [anon_sym_EQ_EQ] = ACTIONS(610),
    [anon_sym_BANG_EQ] = ACTIONS(610),
    [anon_sym_LT] = ACTIONS(612),
    [anon_sym_GT] = ACTIONS(612),
    [anon_sym_LT_EQ] = ACTIONS(614),
    [anon_sym_GT_EQ] = ACTIONS(614),
    [anon_sym_LT_LT] = ACTIONS(616),
    [anon_sym_GT_GT] = ACTIONS(616),
    [anon_sym_PLUS] = ACTIONS(618),
    [anon_sym_DASH] = ACTIONS(618),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [941] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_COLON] = ACTIONS(3583),
    [anon_sym_QMARK] = ACTIONS(1171),
    [anon_sym_STAR_EQ] = ACTIONS(1173),
    [anon_sym_SLASH_EQ] = ACTIONS(1173),
    [anon_sym_PERCENT_EQ] = ACTIONS(1173),
    [anon_sym_PLUS_EQ] = ACTIONS(1173),
    [anon_sym_DASH_EQ] = ACTIONS(1173),
    [anon_sym_LT_LT_EQ] = ACTIONS(1173),
    [anon_sym_GT_GT_EQ] = ACTIONS(1173),
    [anon_sym_AMP_EQ] = ACTIONS(1173),
    [anon_sym_CARET_EQ] = ACTIONS(1173),
    [anon_sym_PIPE_EQ] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_CARET] = ACTIONS(1183),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [942] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3585),
    [anon_sym_SEMI] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(590),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_STAR_EQ] = ACTIONS(3585),
    [anon_sym_SLASH_EQ] = ACTIONS(3585),
    [anon_sym_PERCENT_EQ] = ACTIONS(3585),
    [anon_sym_PLUS_EQ] = ACTIONS(3585),
    [anon_sym_DASH_EQ] = ACTIONS(3585),
    [anon_sym_LT_LT_EQ] = ACTIONS(3585),
    [anon_sym_GT_GT_EQ] = ACTIONS(3585),
    [anon_sym_AMP_EQ] = ACTIONS(3585),
    [anon_sym_CARET_EQ] = ACTIONS(3585),
    [anon_sym_PIPE_EQ] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(3587),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3587),
    [anon_sym_CARET] = ACTIONS(3587),
    [anon_sym_EQ_EQ] = ACTIONS(610),
    [anon_sym_BANG_EQ] = ACTIONS(610),
    [anon_sym_LT] = ACTIONS(612),
    [anon_sym_GT] = ACTIONS(612),
    [anon_sym_LT_EQ] = ACTIONS(614),
    [anon_sym_GT_EQ] = ACTIONS(614),
    [anon_sym_LT_LT] = ACTIONS(616),
    [anon_sym_GT_GT] = ACTIONS(616),
    [anon_sym_PLUS] = ACTIONS(618),
    [anon_sym_DASH] = ACTIONS(618),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [943] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3589),
    [anon_sym_SEMI] = ACTIONS(3589),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(590),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3591),
    [anon_sym_QMARK] = ACTIONS(3589),
    [anon_sym_STAR_EQ] = ACTIONS(3589),
    [anon_sym_SLASH_EQ] = ACTIONS(3589),
    [anon_sym_PERCENT_EQ] = ACTIONS(3589),
    [anon_sym_PLUS_EQ] = ACTIONS(3589),
    [anon_sym_DASH_EQ] = ACTIONS(3589),
    [anon_sym_LT_LT_EQ] = ACTIONS(3589),
    [anon_sym_GT_GT_EQ] = ACTIONS(3589),
    [anon_sym_AMP_EQ] = ACTIONS(3589),
    [anon_sym_CARET_EQ] = ACTIONS(3589),
    [anon_sym_PIPE_EQ] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_PIPE_PIPE] = ACTIONS(3589),
    [anon_sym_AMP_AMP] = ACTIONS(604),
    [anon_sym_PIPE] = ACTIONS(606),
    [anon_sym_CARET] = ACTIONS(608),
    [anon_sym_EQ_EQ] = ACTIONS(610),
    [anon_sym_BANG_EQ] = ACTIONS(610),
    [anon_sym_LT] = ACTIONS(612),
    [anon_sym_GT] = ACTIONS(612),
    [anon_sym_LT_EQ] = ACTIONS(614),
    [anon_sym_GT_EQ] = ACTIONS(614),
    [anon_sym_LT_LT] = ACTIONS(616),
    [anon_sym_GT_GT] = ACTIONS(616),
    [anon_sym_PLUS] = ACTIONS(618),
    [anon_sym_DASH] = ACTIONS(618),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [944] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3589),
    [anon_sym_SEMI] = ACTIONS(3589),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(590),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3591),
    [anon_sym_QMARK] = ACTIONS(3589),
    [anon_sym_STAR_EQ] = ACTIONS(3589),
    [anon_sym_SLASH_EQ] = ACTIONS(3589),
    [anon_sym_PERCENT_EQ] = ACTIONS(3589),
    [anon_sym_PLUS_EQ] = ACTIONS(3589),
    [anon_sym_DASH_EQ] = ACTIONS(3589),
    [anon_sym_LT_LT_EQ] = ACTIONS(3589),
    [anon_sym_GT_GT_EQ] = ACTIONS(3589),
    [anon_sym_AMP_EQ] = ACTIONS(3589),
    [anon_sym_CARET_EQ] = ACTIONS(3589),
    [anon_sym_PIPE_EQ] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_PIPE_PIPE] = ACTIONS(3589),
    [anon_sym_AMP_AMP] = ACTIONS(3589),
    [anon_sym_PIPE] = ACTIONS(606),
    [anon_sym_CARET] = ACTIONS(608),
    [anon_sym_EQ_EQ] = ACTIONS(610),
    [anon_sym_BANG_EQ] = ACTIONS(610),
    [anon_sym_LT] = ACTIONS(612),
    [anon_sym_GT] = ACTIONS(612),
    [anon_sym_LT_EQ] = ACTIONS(614),
    [anon_sym_GT_EQ] = ACTIONS(614),
    [anon_sym_LT_LT] = ACTIONS(616),
    [anon_sym_GT_GT] = ACTIONS(616),
    [anon_sym_PLUS] = ACTIONS(618),
    [anon_sym_DASH] = ACTIONS(618),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [945] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3585),
    [anon_sym_SEMI] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(590),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_STAR_EQ] = ACTIONS(3585),
    [anon_sym_SLASH_EQ] = ACTIONS(3585),
    [anon_sym_PERCENT_EQ] = ACTIONS(3585),
    [anon_sym_PLUS_EQ] = ACTIONS(3585),
    [anon_sym_DASH_EQ] = ACTIONS(3585),
    [anon_sym_LT_LT_EQ] = ACTIONS(3585),
    [anon_sym_GT_GT_EQ] = ACTIONS(3585),
    [anon_sym_AMP_EQ] = ACTIONS(3585),
    [anon_sym_CARET_EQ] = ACTIONS(3585),
    [anon_sym_PIPE_EQ] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3587),
    [anon_sym_CARET] = ACTIONS(608),
    [anon_sym_EQ_EQ] = ACTIONS(610),
    [anon_sym_BANG_EQ] = ACTIONS(610),
    [anon_sym_LT] = ACTIONS(612),
    [anon_sym_GT] = ACTIONS(612),
    [anon_sym_LT_EQ] = ACTIONS(614),
    [anon_sym_GT_EQ] = ACTIONS(614),
    [anon_sym_LT_LT] = ACTIONS(616),
    [anon_sym_GT_GT] = ACTIONS(616),
    [anon_sym_PLUS] = ACTIONS(618),
    [anon_sym_DASH] = ACTIONS(618),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [946] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3585),
    [anon_sym_SEMI] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(590),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_STAR_EQ] = ACTIONS(3585),
    [anon_sym_SLASH_EQ] = ACTIONS(3585),
    [anon_sym_PERCENT_EQ] = ACTIONS(3585),
    [anon_sym_PLUS_EQ] = ACTIONS(3585),
    [anon_sym_DASH_EQ] = ACTIONS(3585),
    [anon_sym_LT_LT_EQ] = ACTIONS(3585),
    [anon_sym_GT_GT_EQ] = ACTIONS(3585),
    [anon_sym_AMP_EQ] = ACTIONS(3585),
    [anon_sym_CARET_EQ] = ACTIONS(3585),
    [anon_sym_PIPE_EQ] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3587),
    [anon_sym_CARET] = ACTIONS(3587),
    [anon_sym_EQ_EQ] = ACTIONS(610),
    [anon_sym_BANG_EQ] = ACTIONS(610),
    [anon_sym_LT] = ACTIONS(612),
    [anon_sym_GT] = ACTIONS(612),
    [anon_sym_LT_EQ] = ACTIONS(614),
    [anon_sym_GT_EQ] = ACTIONS(614),
    [anon_sym_LT_LT] = ACTIONS(616),
    [anon_sym_GT_GT] = ACTIONS(616),
    [anon_sym_PLUS] = ACTIONS(618),
    [anon_sym_DASH] = ACTIONS(618),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [947] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3593),
    [anon_sym_SEMI] = ACTIONS(3593),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(590),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3595),
    [anon_sym_QMARK] = ACTIONS(3593),
    [anon_sym_STAR_EQ] = ACTIONS(3593),
    [anon_sym_SLASH_EQ] = ACTIONS(3593),
    [anon_sym_PERCENT_EQ] = ACTIONS(3593),
    [anon_sym_PLUS_EQ] = ACTIONS(3593),
    [anon_sym_DASH_EQ] = ACTIONS(3593),
    [anon_sym_LT_LT_EQ] = ACTIONS(3593),
    [anon_sym_GT_GT_EQ] = ACTIONS(3593),
    [anon_sym_AMP_EQ] = ACTIONS(3593),
    [anon_sym_CARET_EQ] = ACTIONS(3593),
    [anon_sym_PIPE_EQ] = ACTIONS(3593),
    [anon_sym_AMP] = ACTIONS(3595),
    [anon_sym_PIPE_PIPE] = ACTIONS(3593),
    [anon_sym_AMP_AMP] = ACTIONS(3593),
    [anon_sym_PIPE] = ACTIONS(3595),
    [anon_sym_CARET] = ACTIONS(3595),
    [anon_sym_EQ_EQ] = ACTIONS(3593),
    [anon_sym_BANG_EQ] = ACTIONS(3593),
    [anon_sym_LT] = ACTIONS(612),
    [anon_sym_GT] = ACTIONS(612),
    [anon_sym_LT_EQ] = ACTIONS(614),
    [anon_sym_GT_EQ] = ACTIONS(614),
    [anon_sym_LT_LT] = ACTIONS(616),
    [anon_sym_GT_GT] = ACTIONS(616),
    [anon_sym_PLUS] = ACTIONS(618),
    [anon_sym_DASH] = ACTIONS(618),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [948] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3597),
    [anon_sym_SEMI] = ACTIONS(3597),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(590),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3599),
    [anon_sym_QMARK] = ACTIONS(3597),
    [anon_sym_STAR_EQ] = ACTIONS(3597),
    [anon_sym_SLASH_EQ] = ACTIONS(3597),
    [anon_sym_PERCENT_EQ] = ACTIONS(3597),
    [anon_sym_PLUS_EQ] = ACTIONS(3597),
    [anon_sym_DASH_EQ] = ACTIONS(3597),
    [anon_sym_LT_LT_EQ] = ACTIONS(3597),
    [anon_sym_GT_GT_EQ] = ACTIONS(3597),
    [anon_sym_AMP_EQ] = ACTIONS(3597),
    [anon_sym_CARET_EQ] = ACTIONS(3597),
    [anon_sym_PIPE_EQ] = ACTIONS(3597),
    [anon_sym_AMP] = ACTIONS(3599),
    [anon_sym_PIPE_PIPE] = ACTIONS(3597),
    [anon_sym_AMP_AMP] = ACTIONS(3597),
    [anon_sym_PIPE] = ACTIONS(3599),
    [anon_sym_CARET] = ACTIONS(3599),
    [anon_sym_EQ_EQ] = ACTIONS(3597),
    [anon_sym_BANG_EQ] = ACTIONS(3597),
    [anon_sym_LT] = ACTIONS(3599),
    [anon_sym_GT] = ACTIONS(3599),
    [anon_sym_LT_EQ] = ACTIONS(3597),
    [anon_sym_GT_EQ] = ACTIONS(3597),
    [anon_sym_LT_LT] = ACTIONS(616),
    [anon_sym_GT_GT] = ACTIONS(616),
    [anon_sym_PLUS] = ACTIONS(618),
    [anon_sym_DASH] = ACTIONS(618),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [949] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3601),
    [anon_sym_SEMI] = ACTIONS(3601),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(590),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3603),
    [anon_sym_QMARK] = ACTIONS(3601),
    [anon_sym_STAR_EQ] = ACTIONS(3601),
    [anon_sym_SLASH_EQ] = ACTIONS(3601),
    [anon_sym_PERCENT_EQ] = ACTIONS(3601),
    [anon_sym_PLUS_EQ] = ACTIONS(3601),
    [anon_sym_DASH_EQ] = ACTIONS(3601),
    [anon_sym_LT_LT_EQ] = ACTIONS(3601),
    [anon_sym_GT_GT_EQ] = ACTIONS(3601),
    [anon_sym_AMP_EQ] = ACTIONS(3601),
    [anon_sym_CARET_EQ] = ACTIONS(3601),
    [anon_sym_PIPE_EQ] = ACTIONS(3601),
    [anon_sym_AMP] = ACTIONS(3603),
    [anon_sym_PIPE_PIPE] = ACTIONS(3601),
    [anon_sym_AMP_AMP] = ACTIONS(3601),
    [anon_sym_PIPE] = ACTIONS(3603),
    [anon_sym_CARET] = ACTIONS(3603),
    [anon_sym_EQ_EQ] = ACTIONS(3601),
    [anon_sym_BANG_EQ] = ACTIONS(3601),
    [anon_sym_LT] = ACTIONS(3603),
    [anon_sym_GT] = ACTIONS(3603),
    [anon_sym_LT_EQ] = ACTIONS(3601),
    [anon_sym_GT_EQ] = ACTIONS(3601),
    [anon_sym_LT_LT] = ACTIONS(3603),
    [anon_sym_GT_GT] = ACTIONS(3603),
    [anon_sym_PLUS] = ACTIONS(618),
    [anon_sym_DASH] = ACTIONS(618),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [950] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3575),
    [anon_sym_SEMI] = ACTIONS(3575),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(590),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3577),
    [anon_sym_QMARK] = ACTIONS(3575),
    [anon_sym_STAR_EQ] = ACTIONS(3575),
    [anon_sym_SLASH_EQ] = ACTIONS(3575),
    [anon_sym_PERCENT_EQ] = ACTIONS(3575),
    [anon_sym_PLUS_EQ] = ACTIONS(3575),
    [anon_sym_DASH_EQ] = ACTIONS(3575),
    [anon_sym_LT_LT_EQ] = ACTIONS(3575),
    [anon_sym_GT_GT_EQ] = ACTIONS(3575),
    [anon_sym_AMP_EQ] = ACTIONS(3575),
    [anon_sym_CARET_EQ] = ACTIONS(3575),
    [anon_sym_PIPE_EQ] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_PIPE_PIPE] = ACTIONS(3575),
    [anon_sym_AMP_AMP] = ACTIONS(3575),
    [anon_sym_PIPE] = ACTIONS(3577),
    [anon_sym_CARET] = ACTIONS(3577),
    [anon_sym_EQ_EQ] = ACTIONS(3575),
    [anon_sym_BANG_EQ] = ACTIONS(3575),
    [anon_sym_LT] = ACTIONS(3577),
    [anon_sym_GT] = ACTIONS(3577),
    [anon_sym_LT_EQ] = ACTIONS(3575),
    [anon_sym_GT_EQ] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3577),
    [anon_sym_GT_GT] = ACTIONS(3577),
    [anon_sym_PLUS] = ACTIONS(3577),
    [anon_sym_DASH] = ACTIONS(3577),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [951] = {
    [sym_template_argument_list] = STATE(1707),
    [anon_sym_COMMA] = ACTIONS(3605),
    [anon_sym_RPAREN] = ACTIONS(3605),
    [anon_sym_SEMI] = ACTIONS(3605),
    [anon_sym_RBRACE] = ACTIONS(3605),
    [anon_sym_LPAREN2] = ACTIONS(3605),
    [anon_sym_STAR] = ACTIONS(3607),
    [anon_sym_LBRACK] = ACTIONS(3605),
    [anon_sym_RBRACK] = ACTIONS(3605),
    [anon_sym_EQ] = ACTIONS(3607),
    [anon_sym_COLON] = ACTIONS(3607),
    [anon_sym_QMARK] = ACTIONS(3605),
    [anon_sym_STAR_EQ] = ACTIONS(3605),
    [anon_sym_SLASH_EQ] = ACTIONS(3605),
    [anon_sym_PERCENT_EQ] = ACTIONS(3605),
    [anon_sym_PLUS_EQ] = ACTIONS(3605),
    [anon_sym_DASH_EQ] = ACTIONS(3605),
    [anon_sym_LT_LT_EQ] = ACTIONS(3605),
    [anon_sym_GT_GT_EQ] = ACTIONS(3605),
    [anon_sym_AMP_EQ] = ACTIONS(3605),
    [anon_sym_CARET_EQ] = ACTIONS(3605),
    [anon_sym_PIPE_EQ] = ACTIONS(3605),
    [anon_sym_AMP] = ACTIONS(3607),
    [anon_sym_PIPE_PIPE] = ACTIONS(3605),
    [anon_sym_AMP_AMP] = ACTIONS(3605),
    [anon_sym_PIPE] = ACTIONS(3607),
    [anon_sym_CARET] = ACTIONS(3607),
    [anon_sym_EQ_EQ] = ACTIONS(3605),
    [anon_sym_BANG_EQ] = ACTIONS(3605),
    [anon_sym_LT] = ACTIONS(3609),
    [anon_sym_GT] = ACTIONS(3607),
    [anon_sym_LT_EQ] = ACTIONS(3605),
    [anon_sym_GT_EQ] = ACTIONS(3605),
    [anon_sym_LT_LT] = ACTIONS(3607),
    [anon_sym_GT_GT] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3607),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_SLASH] = ACTIONS(3607),
    [anon_sym_PERCENT] = ACTIONS(3607),
    [anon_sym_DASH_DASH] = ACTIONS(3605),
    [anon_sym_PLUS_PLUS] = ACTIONS(3605),
    [anon_sym_DOT] = ACTIONS(3605),
    [anon_sym_DASH_GT] = ACTIONS(3605),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(3612),
  },
  [952] = {
    [sym_destructor_name] = STATE(1699),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(3614),
    [sym_comment] = ACTIONS(91),
    [sym_operator_name] = ACTIONS(3561),
  },
  [953] = {
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(3616),
  },
  [954] = {
    [anon_sym_COMMA] = ACTIONS(3618),
    [anon_sym_RPAREN] = ACTIONS(3618),
    [anon_sym_SEMI] = ACTIONS(3618),
    [anon_sym_RBRACE] = ACTIONS(3618),
    [anon_sym_LPAREN2] = ACTIONS(3618),
    [anon_sym_STAR] = ACTIONS(3620),
    [anon_sym_LBRACK] = ACTIONS(3618),
    [anon_sym_RBRACK] = ACTIONS(3618),
    [anon_sym_EQ] = ACTIONS(3620),
    [anon_sym_COLON] = ACTIONS(3618),
    [anon_sym_QMARK] = ACTIONS(3618),
    [anon_sym_STAR_EQ] = ACTIONS(3618),
    [anon_sym_SLASH_EQ] = ACTIONS(3618),
    [anon_sym_PERCENT_EQ] = ACTIONS(3618),
    [anon_sym_PLUS_EQ] = ACTIONS(3618),
    [anon_sym_DASH_EQ] = ACTIONS(3618),
    [anon_sym_LT_LT_EQ] = ACTIONS(3618),
    [anon_sym_GT_GT_EQ] = ACTIONS(3618),
    [anon_sym_AMP_EQ] = ACTIONS(3618),
    [anon_sym_CARET_EQ] = ACTIONS(3618),
    [anon_sym_PIPE_EQ] = ACTIONS(3618),
    [anon_sym_AMP] = ACTIONS(3620),
    [anon_sym_PIPE_PIPE] = ACTIONS(3618),
    [anon_sym_AMP_AMP] = ACTIONS(3618),
    [anon_sym_PIPE] = ACTIONS(3620),
    [anon_sym_CARET] = ACTIONS(3620),
    [anon_sym_EQ_EQ] = ACTIONS(3618),
    [anon_sym_BANG_EQ] = ACTIONS(3618),
    [anon_sym_LT] = ACTIONS(3620),
    [anon_sym_GT] = ACTIONS(3620),
    [anon_sym_LT_EQ] = ACTIONS(3618),
    [anon_sym_GT_EQ] = ACTIONS(3618),
    [anon_sym_LT_LT] = ACTIONS(3620),
    [anon_sym_GT_GT] = ACTIONS(3620),
    [anon_sym_PLUS] = ACTIONS(3620),
    [anon_sym_DASH] = ACTIONS(3620),
    [anon_sym_SLASH] = ACTIONS(3620),
    [anon_sym_PERCENT] = ACTIONS(3620),
    [anon_sym_DASH_DASH] = ACTIONS(3618),
    [anon_sym_PLUS_PLUS] = ACTIONS(3618),
    [anon_sym_DOT] = ACTIONS(3618),
    [anon_sym_DASH_GT] = ACTIONS(3618),
    [sym_comment] = ACTIONS(91),
  },
  [955] = {
    [sym_template_argument_list] = STATE(1710),
    [anon_sym_LT] = ACTIONS(945),
    [sym_comment] = ACTIONS(91),
  },
  [956] = {
    [sym_string_literal] = STATE(956),
    [aux_sym_concatenated_string_repeat1] = STATE(956),
    [anon_sym_COMMA] = ACTIONS(3622),
    [anon_sym_SEMI] = ACTIONS(3622),
    [anon_sym_LPAREN2] = ACTIONS(3622),
    [anon_sym_STAR] = ACTIONS(3624),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_EQ] = ACTIONS(3624),
    [anon_sym_QMARK] = ACTIONS(3622),
    [anon_sym_STAR_EQ] = ACTIONS(3622),
    [anon_sym_SLASH_EQ] = ACTIONS(3622),
    [anon_sym_PERCENT_EQ] = ACTIONS(3622),
    [anon_sym_PLUS_EQ] = ACTIONS(3622),
    [anon_sym_DASH_EQ] = ACTIONS(3622),
    [anon_sym_LT_LT_EQ] = ACTIONS(3622),
    [anon_sym_GT_GT_EQ] = ACTIONS(3622),
    [anon_sym_AMP_EQ] = ACTIONS(3622),
    [anon_sym_CARET_EQ] = ACTIONS(3622),
    [anon_sym_PIPE_EQ] = ACTIONS(3622),
    [anon_sym_AMP] = ACTIONS(3624),
    [anon_sym_PIPE_PIPE] = ACTIONS(3622),
    [anon_sym_AMP_AMP] = ACTIONS(3622),
    [anon_sym_PIPE] = ACTIONS(3624),
    [anon_sym_CARET] = ACTIONS(3624),
    [anon_sym_EQ_EQ] = ACTIONS(3622),
    [anon_sym_BANG_EQ] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3624),
    [anon_sym_GT] = ACTIONS(3624),
    [anon_sym_LT_EQ] = ACTIONS(3622),
    [anon_sym_GT_EQ] = ACTIONS(3622),
    [anon_sym_LT_LT] = ACTIONS(3624),
    [anon_sym_GT_GT] = ACTIONS(3624),
    [anon_sym_PLUS] = ACTIONS(3624),
    [anon_sym_DASH] = ACTIONS(3624),
    [anon_sym_SLASH] = ACTIONS(3624),
    [anon_sym_PERCENT] = ACTIONS(3624),
    [anon_sym_DASH_DASH] = ACTIONS(3622),
    [anon_sym_PLUS_PLUS] = ACTIONS(3622),
    [anon_sym_DOT] = ACTIONS(3622),
    [anon_sym_DASH_GT] = ACTIONS(3622),
    [anon_sym_DQUOTE] = ACTIONS(3626),
    [sym_comment] = ACTIONS(91),
  },
  [957] = {
    [anon_sym_COMMA] = ACTIONS(3629),
    [anon_sym_RPAREN] = ACTIONS(3631),
    [anon_sym_SEMI] = ACTIONS(3631),
    [anon_sym_extern] = ACTIONS(3634),
    [anon_sym_LBRACE] = ACTIONS(3636),
    [anon_sym_RBRACE] = ACTIONS(3629),
    [anon_sym_LPAREN2] = ACTIONS(3631),
    [anon_sym_STAR] = ACTIONS(3638),
    [anon_sym_LBRACK] = ACTIONS(3631),
    [anon_sym_EQ] = ACTIONS(3641),
    [anon_sym_static] = ACTIONS(3634),
    [anon_sym_register] = ACTIONS(3634),
    [anon_sym_inline] = ACTIONS(3634),
    [anon_sym_const] = ACTIONS(3634),
    [anon_sym_restrict] = ACTIONS(3634),
    [anon_sym_volatile] = ACTIONS(3634),
    [anon_sym__Atomic] = ACTIONS(3634),
    [anon_sym_mutable] = ACTIONS(3634),
    [anon_sym_explicit] = ACTIONS(3634),
    [anon_sym_constexpr] = ACTIONS(3634),
    [anon_sym_QMARK] = ACTIONS(3629),
    [anon_sym_STAR_EQ] = ACTIONS(3629),
    [anon_sym_SLASH_EQ] = ACTIONS(3629),
    [anon_sym_PERCENT_EQ] = ACTIONS(3629),
    [anon_sym_PLUS_EQ] = ACTIONS(3629),
    [anon_sym_DASH_EQ] = ACTIONS(3629),
    [anon_sym_LT_LT_EQ] = ACTIONS(3629),
    [anon_sym_GT_GT_EQ] = ACTIONS(3629),
    [anon_sym_AMP_EQ] = ACTIONS(3629),
    [anon_sym_CARET_EQ] = ACTIONS(3629),
    [anon_sym_PIPE_EQ] = ACTIONS(3629),
    [anon_sym_AMP] = ACTIONS(3638),
    [anon_sym_PIPE_PIPE] = ACTIONS(3629),
    [anon_sym_AMP_AMP] = ACTIONS(3631),
    [anon_sym_PIPE] = ACTIONS(3641),
    [anon_sym_CARET] = ACTIONS(3641),
    [anon_sym_TILDE] = ACTIONS(3636),
    [anon_sym_EQ_EQ] = ACTIONS(3629),
    [anon_sym_BANG_EQ] = ACTIONS(3629),
    [anon_sym_LT] = ACTIONS(3638),
    [anon_sym_GT] = ACTIONS(3641),
    [anon_sym_LT_EQ] = ACTIONS(3629),
    [anon_sym_GT_EQ] = ACTIONS(3629),
    [anon_sym_LT_LT] = ACTIONS(3641),
    [anon_sym_GT_GT] = ACTIONS(3641),
    [anon_sym_PLUS] = ACTIONS(3641),
    [anon_sym_DASH] = ACTIONS(3641),
    [anon_sym_SLASH] = ACTIONS(3641),
    [anon_sym_PERCENT] = ACTIONS(3641),
    [anon_sym_DASH_DASH] = ACTIONS(3629),
    [anon_sym_PLUS_PLUS] = ACTIONS(3629),
    [anon_sym_DOT] = ACTIONS(3629),
    [anon_sym_DASH_GT] = ACTIONS(3629),
    [sym_identifier] = ACTIONS(3634),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(3643),
    [sym_operator_name] = ACTIONS(3636),
  },
  [958] = {
    [anon_sym_COMMA] = ACTIONS(3629),
    [anon_sym_RPAREN] = ACTIONS(3629),
    [anon_sym_SEMI] = ACTIONS(3629),
    [anon_sym_LBRACE] = ACTIONS(3629),
    [anon_sym_RBRACE] = ACTIONS(3629),
    [anon_sym_LPAREN2] = ACTIONS(3629),
    [anon_sym_STAR] = ACTIONS(3641),
    [anon_sym_LBRACK] = ACTIONS(3629),
    [anon_sym_RBRACK] = ACTIONS(3629),
    [anon_sym_EQ] = ACTIONS(3641),
    [anon_sym_COLON] = ACTIONS(3629),
    [anon_sym_QMARK] = ACTIONS(3629),
    [anon_sym_STAR_EQ] = ACTIONS(3629),
    [anon_sym_SLASH_EQ] = ACTIONS(3629),
    [anon_sym_PERCENT_EQ] = ACTIONS(3629),
    [anon_sym_PLUS_EQ] = ACTIONS(3629),
    [anon_sym_DASH_EQ] = ACTIONS(3629),
    [anon_sym_LT_LT_EQ] = ACTIONS(3629),
    [anon_sym_GT_GT_EQ] = ACTIONS(3629),
    [anon_sym_AMP_EQ] = ACTIONS(3629),
    [anon_sym_CARET_EQ] = ACTIONS(3629),
    [anon_sym_PIPE_EQ] = ACTIONS(3629),
    [anon_sym_AMP] = ACTIONS(3641),
    [anon_sym_PIPE_PIPE] = ACTIONS(3629),
    [anon_sym_AMP_AMP] = ACTIONS(3629),
    [anon_sym_PIPE] = ACTIONS(3641),
    [anon_sym_CARET] = ACTIONS(3641),
    [anon_sym_EQ_EQ] = ACTIONS(3629),
    [anon_sym_BANG_EQ] = ACTIONS(3629),
    [anon_sym_LT] = ACTIONS(3641),
    [anon_sym_GT] = ACTIONS(3641),
    [anon_sym_LT_EQ] = ACTIONS(3629),
    [anon_sym_GT_EQ] = ACTIONS(3629),
    [anon_sym_LT_LT] = ACTIONS(3641),
    [anon_sym_GT_GT] = ACTIONS(3641),
    [anon_sym_PLUS] = ACTIONS(3641),
    [anon_sym_DASH] = ACTIONS(3641),
    [anon_sym_SLASH] = ACTIONS(3641),
    [anon_sym_PERCENT] = ACTIONS(3641),
    [anon_sym_DASH_DASH] = ACTIONS(3629),
    [anon_sym_PLUS_PLUS] = ACTIONS(3629),
    [anon_sym_DOT] = ACTIONS(3629),
    [anon_sym_DASH_GT] = ACTIONS(3629),
    [sym_comment] = ACTIONS(91),
  },
  [959] = {
    [sym_parameter_list] = STATE(1185),
    [anon_sym_RPAREN] = ACTIONS(3645),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [sym_comment] = ACTIONS(91),
  },
  [960] = {
    [sym_parameter_list] = STATE(1712),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [sym_comment] = ACTIONS(91),
  },
  [961] = {
    [sym_type_qualifier] = STATE(1714),
    [sym_trailing_return_type] = STATE(971),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1714),
    [anon_sym_LPAREN2] = ACTIONS(1787),
    [anon_sym_LBRACK] = ACTIONS(1787),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(3647),
    [sym_comment] = ACTIONS(91),
    [sym_noexcept] = ACTIONS(3649),
  },
  [962] = {
    [sym__abstract_declarator] = STATE(960),
    [sym_abstract_pointer_declarator] = STATE(960),
    [sym_abstract_function_declarator] = STATE(960),
    [sym_abstract_array_declarator] = STATE(960),
    [sym_type_qualifier] = STATE(1715),
    [sym_parameter_list] = STATE(961),
    [sym_abstract_reference_declarator] = STATE(960),
    [aux_sym_type_definition_repeat1] = STATE(1715),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(639),
    [anon_sym_AMP_AMP] = ACTIONS(641),
    [sym_comment] = ACTIONS(91),
  },
  [963] = {
    [sym__expression] = STATE(146),
    [sym_conditional_expression] = STATE(146),
    [sym_assignment_expression] = STATE(146),
    [sym_pointer_expression] = STATE(146),
    [sym_logical_expression] = STATE(146),
    [sym_bitwise_expression] = STATE(146),
    [sym_equality_expression] = STATE(146),
    [sym_relational_expression] = STATE(146),
    [sym_shift_expression] = STATE(146),
    [sym_math_expression] = STATE(146),
    [sym_cast_expression] = STATE(146),
    [sym_sizeof_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_compound_literal_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_char_literal] = STATE(146),
    [sym_concatenated_string] = STATE(146),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(146),
    [sym_new_expression] = STATE(146),
    [sym_delete_expression] = STATE(146),
    [sym_lambda_expression] = STATE(146),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(257),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(3651),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(257),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(259),
    [sym_false] = ACTIONS(259),
    [sym_null] = ACTIONS(259),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(259),
  },
  [964] = {
    [anon_sym_COMMA] = ACTIONS(3653),
    [anon_sym_RPAREN] = ACTIONS(3653),
    [anon_sym_SEMI] = ACTIONS(3653),
    [anon_sym_LBRACE] = ACTIONS(3653),
    [anon_sym_LPAREN2] = ACTIONS(3653),
    [anon_sym_LBRACK] = ACTIONS(3653),
    [anon_sym_EQ] = ACTIONS(3653),
    [anon_sym_const] = ACTIONS(3655),
    [anon_sym_restrict] = ACTIONS(3653),
    [anon_sym_volatile] = ACTIONS(3653),
    [anon_sym__Atomic] = ACTIONS(3653),
    [anon_sym_mutable] = ACTIONS(3653),
    [anon_sym_explicit] = ACTIONS(3653),
    [anon_sym_constexpr] = ACTIONS(3653),
    [anon_sym_COLON] = ACTIONS(3653),
    [anon_sym_DASH_GT] = ACTIONS(3653),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3653),
    [anon_sym_override] = ACTIONS(3653),
    [anon_sym_GT2] = ACTIONS(3653),
    [sym_noexcept] = ACTIONS(3653),
  },
  [965] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(3651),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_STAR_EQ] = ACTIONS(3507),
    [anon_sym_SLASH_EQ] = ACTIONS(3507),
    [anon_sym_PERCENT_EQ] = ACTIONS(3507),
    [anon_sym_PLUS_EQ] = ACTIONS(3507),
    [anon_sym_DASH_EQ] = ACTIONS(3507),
    [anon_sym_LT_LT_EQ] = ACTIONS(3507),
    [anon_sym_GT_GT_EQ] = ACTIONS(3507),
    [anon_sym_AMP_EQ] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(3507),
    [anon_sym_PIPE_EQ] = ACTIONS(3507),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_CARET] = ACTIONS(3517),
    [anon_sym_EQ_EQ] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3521),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3525),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [966] = {
    [sym_type_qualifier] = STATE(1684),
    [sym__expression] = STATE(1718),
    [sym_conditional_expression] = STATE(1718),
    [sym_assignment_expression] = STATE(1718),
    [sym_pointer_expression] = STATE(1718),
    [sym_logical_expression] = STATE(1718),
    [sym_bitwise_expression] = STATE(1718),
    [sym_equality_expression] = STATE(1718),
    [sym_relational_expression] = STATE(1718),
    [sym_shift_expression] = STATE(1718),
    [sym_math_expression] = STATE(1718),
    [sym_cast_expression] = STATE(1718),
    [sym_sizeof_expression] = STATE(1718),
    [sym_subscript_expression] = STATE(1718),
    [sym_call_expression] = STATE(1718),
    [sym_field_expression] = STATE(1718),
    [sym_compound_literal_expression] = STATE(1718),
    [sym_parenthesized_expression] = STATE(1718),
    [sym_char_literal] = STATE(1718),
    [sym_concatenated_string] = STATE(1718),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1718),
    [sym_new_expression] = STATE(1718),
    [sym_delete_expression] = STATE(1718),
    [sym_lambda_expression] = STATE(1718),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [aux_sym_type_definition_repeat1] = STATE(1684),
    [sym_raw_string_literal] = ACTIONS(3657),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(3659),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(3651),
    [anon_sym_const] = ACTIONS(1643),
    [anon_sym_restrict] = ACTIONS(1643),
    [anon_sym_volatile] = ACTIONS(1643),
    [anon_sym__Atomic] = ACTIONS(1643),
    [anon_sym_mutable] = ACTIONS(1643),
    [anon_sym_explicit] = ACTIONS(1643),
    [anon_sym_constexpr] = ACTIONS(1643),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(3657),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(3661),
    [sym_false] = ACTIONS(3661),
    [sym_null] = ACTIONS(3661),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(3661),
  },
  [967] = {
    [sym_type_qualifier] = STATE(1719),
    [sym__expression] = STATE(1718),
    [sym_conditional_expression] = STATE(1718),
    [sym_assignment_expression] = STATE(1718),
    [sym_pointer_expression] = STATE(1718),
    [sym_logical_expression] = STATE(1718),
    [sym_bitwise_expression] = STATE(1718),
    [sym_equality_expression] = STATE(1718),
    [sym_relational_expression] = STATE(1718),
    [sym_shift_expression] = STATE(1718),
    [sym_math_expression] = STATE(1718),
    [sym_cast_expression] = STATE(1718),
    [sym_sizeof_expression] = STATE(1718),
    [sym_subscript_expression] = STATE(1718),
    [sym_call_expression] = STATE(1718),
    [sym_field_expression] = STATE(1718),
    [sym_compound_literal_expression] = STATE(1718),
    [sym_parenthesized_expression] = STATE(1718),
    [sym_char_literal] = STATE(1718),
    [sym_concatenated_string] = STATE(1718),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1718),
    [sym_new_expression] = STATE(1718),
    [sym_delete_expression] = STATE(1718),
    [sym_lambda_expression] = STATE(1718),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [aux_sym_type_definition_repeat1] = STATE(1719),
    [sym_raw_string_literal] = ACTIONS(3657),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(3659),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(3651),
    [anon_sym_const] = ACTIONS(1643),
    [anon_sym_restrict] = ACTIONS(1643),
    [anon_sym_volatile] = ACTIONS(1643),
    [anon_sym__Atomic] = ACTIONS(1643),
    [anon_sym_mutable] = ACTIONS(1643),
    [anon_sym_explicit] = ACTIONS(1643),
    [anon_sym_constexpr] = ACTIONS(1643),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(3657),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(3661),
    [sym_false] = ACTIONS(3661),
    [sym_null] = ACTIONS(3661),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(3661),
  },
  [968] = {
    [sym_type_qualifier] = STATE(1721),
    [sym_trailing_return_type] = STATE(1720),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1721),
    [anon_sym_LBRACE] = ACTIONS(3663),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(1789),
    [sym_comment] = ACTIONS(91),
    [sym_noexcept] = ACTIONS(3665),
  },
  [969] = {
    [anon_sym_COMMA] = ACTIONS(3667),
    [anon_sym_RPAREN] = ACTIONS(3667),
    [anon_sym_SEMI] = ACTIONS(3667),
    [anon_sym_RBRACE] = ACTIONS(3667),
    [anon_sym_LPAREN2] = ACTIONS(3667),
    [anon_sym_STAR] = ACTIONS(3669),
    [anon_sym_LBRACK] = ACTIONS(3667),
    [anon_sym_RBRACK] = ACTIONS(3667),
    [anon_sym_EQ] = ACTIONS(3669),
    [anon_sym_COLON] = ACTIONS(3667),
    [anon_sym_QMARK] = ACTIONS(3667),
    [anon_sym_STAR_EQ] = ACTIONS(3667),
    [anon_sym_SLASH_EQ] = ACTIONS(3667),
    [anon_sym_PERCENT_EQ] = ACTIONS(3667),
    [anon_sym_PLUS_EQ] = ACTIONS(3667),
    [anon_sym_DASH_EQ] = ACTIONS(3667),
    [anon_sym_LT_LT_EQ] = ACTIONS(3667),
    [anon_sym_GT_GT_EQ] = ACTIONS(3667),
    [anon_sym_AMP_EQ] = ACTIONS(3667),
    [anon_sym_CARET_EQ] = ACTIONS(3667),
    [anon_sym_PIPE_EQ] = ACTIONS(3667),
    [anon_sym_AMP] = ACTIONS(3669),
    [anon_sym_PIPE_PIPE] = ACTIONS(3667),
    [anon_sym_AMP_AMP] = ACTIONS(3667),
    [anon_sym_PIPE] = ACTIONS(3669),
    [anon_sym_CARET] = ACTIONS(3669),
    [anon_sym_EQ_EQ] = ACTIONS(3667),
    [anon_sym_BANG_EQ] = ACTIONS(3667),
    [anon_sym_LT] = ACTIONS(3669),
    [anon_sym_GT] = ACTIONS(3669),
    [anon_sym_LT_EQ] = ACTIONS(3667),
    [anon_sym_GT_EQ] = ACTIONS(3667),
    [anon_sym_LT_LT] = ACTIONS(3669),
    [anon_sym_GT_GT] = ACTIONS(3669),
    [anon_sym_PLUS] = ACTIONS(3669),
    [anon_sym_DASH] = ACTIONS(3669),
    [anon_sym_SLASH] = ACTIONS(3669),
    [anon_sym_PERCENT] = ACTIONS(3669),
    [anon_sym_DASH_DASH] = ACTIONS(3667),
    [anon_sym_PLUS_PLUS] = ACTIONS(3667),
    [anon_sym_DOT] = ACTIONS(3667),
    [anon_sym_DASH_GT] = ACTIONS(3667),
    [sym_comment] = ACTIONS(91),
  },
  [970] = {
    [sym__type_specifier] = STATE(1727),
    [sym_sized_type_specifier] = STATE(1727),
    [sym_enum_specifier] = STATE(1727),
    [sym_struct_specifier] = STATE(1727),
    [sym_union_specifier] = STATE(1727),
    [sym_macro_type_specifier] = STATE(1727),
    [sym_class_specifier] = STATE(1727),
    [sym_dependent_type] = STATE(1727),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1728),
    [anon_sym_unsigned] = ACTIONS(3671),
    [anon_sym_long] = ACTIONS(3671),
    [anon_sym_short] = ACTIONS(3671),
    [sym_primitive_type] = ACTIONS(3673),
    [anon_sym_enum] = ACTIONS(3675),
    [anon_sym_struct] = ACTIONS(3677),
    [anon_sym_union] = ACTIONS(3679),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3681),
    [sym_auto] = ACTIONS(3673),
    [anon_sym_typename] = ACTIONS(3683),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [971] = {
    [anon_sym_COMMA] = ACTIONS(3663),
    [anon_sym_RPAREN] = ACTIONS(3663),
    [anon_sym_SEMI] = ACTIONS(3663),
    [anon_sym_LBRACE] = ACTIONS(3663),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_EQ] = ACTIONS(3663),
    [anon_sym_const] = ACTIONS(3685),
    [anon_sym_restrict] = ACTIONS(3663),
    [anon_sym_volatile] = ACTIONS(3663),
    [anon_sym__Atomic] = ACTIONS(3663),
    [anon_sym_mutable] = ACTIONS(3663),
    [anon_sym_explicit] = ACTIONS(3663),
    [anon_sym_constexpr] = ACTIONS(3663),
    [anon_sym_COLON] = ACTIONS(3663),
    [anon_sym_DASH_GT] = ACTIONS(3663),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3663),
    [anon_sym_override] = ACTIONS(3663),
    [anon_sym_GT2] = ACTIONS(3663),
    [sym_noexcept] = ACTIONS(3663),
  },
  [972] = {
    [sym_type_qualifier] = STATE(1729),
    [sym_trailing_return_type] = STATE(1720),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1729),
    [anon_sym_LBRACE] = ACTIONS(3663),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(1789),
    [sym_comment] = ACTIONS(91),
    [sym_noexcept] = ACTIONS(3687),
  },
  [973] = {
    [anon_sym_COMMA] = ACTIONS(3121),
    [anon_sym_RPAREN] = ACTIONS(3121),
    [anon_sym_SEMI] = ACTIONS(3121),
    [anon_sym_extern] = ACTIONS(3123),
    [anon_sym_LBRACE] = ACTIONS(3121),
    [anon_sym_LPAREN2] = ACTIONS(3121),
    [anon_sym_STAR] = ACTIONS(3121),
    [anon_sym_LBRACK] = ACTIONS(3121),
    [anon_sym_EQ] = ACTIONS(3121),
    [anon_sym_static] = ACTIONS(3123),
    [anon_sym_register] = ACTIONS(3123),
    [anon_sym_inline] = ACTIONS(3123),
    [anon_sym_const] = ACTIONS(3123),
    [anon_sym_restrict] = ACTIONS(3123),
    [anon_sym_volatile] = ACTIONS(3123),
    [anon_sym__Atomic] = ACTIONS(3123),
    [anon_sym_mutable] = ACTIONS(3123),
    [anon_sym_explicit] = ACTIONS(3123),
    [anon_sym_constexpr] = ACTIONS(3123),
    [anon_sym_COLON] = ACTIONS(3123),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_AMP_AMP] = ACTIONS(3121),
    [anon_sym_TILDE] = ACTIONS(3121),
    [anon_sym_DASH_GT] = ACTIONS(3121),
    [sym_identifier] = ACTIONS(3123),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3123),
    [anon_sym_override] = ACTIONS(3123),
    [anon_sym_GT2] = ACTIONS(3121),
    [sym_noexcept] = ACTIONS(3123),
    [anon_sym_COLON_COLON] = ACTIONS(3121),
    [sym_operator_name] = ACTIONS(3121),
  },
  [974] = {
    [sym_argument_list] = STATE(1511),
    [aux_sym_template_argument_list_repeat1] = STATE(1731),
    [anon_sym_COMMA] = ACTIONS(3163),
    [anon_sym_LPAREN2] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_EQ] = ACTIONS(3171),
    [anon_sym_QMARK] = ACTIONS(3173),
    [anon_sym_STAR_EQ] = ACTIONS(3175),
    [anon_sym_SLASH_EQ] = ACTIONS(3175),
    [anon_sym_PERCENT_EQ] = ACTIONS(3175),
    [anon_sym_PLUS_EQ] = ACTIONS(3175),
    [anon_sym_DASH_EQ] = ACTIONS(3175),
    [anon_sym_LT_LT_EQ] = ACTIONS(3175),
    [anon_sym_GT_GT_EQ] = ACTIONS(3175),
    [anon_sym_AMP_EQ] = ACTIONS(3175),
    [anon_sym_CARET_EQ] = ACTIONS(3175),
    [anon_sym_PIPE_EQ] = ACTIONS(3175),
    [anon_sym_AMP] = ACTIONS(3177),
    [anon_sym_PIPE_PIPE] = ACTIONS(3179),
    [anon_sym_AMP_AMP] = ACTIONS(3181),
    [anon_sym_PIPE] = ACTIONS(3183),
    [anon_sym_CARET] = ACTIONS(3185),
    [anon_sym_EQ_EQ] = ACTIONS(3187),
    [anon_sym_BANG_EQ] = ACTIONS(3187),
    [anon_sym_LT] = ACTIONS(3189),
    [anon_sym_GT] = ACTIONS(3189),
    [anon_sym_LT_EQ] = ACTIONS(3191),
    [anon_sym_GT_EQ] = ACTIONS(3191),
    [anon_sym_LT_LT] = ACTIONS(3193),
    [anon_sym_GT_GT] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_SLASH] = ACTIONS(3167),
    [anon_sym_PERCENT] = ACTIONS(3167),
    [anon_sym_DASH_DASH] = ACTIONS(3197),
    [anon_sym_PLUS_PLUS] = ACTIONS(3197),
    [anon_sym_DOT] = ACTIONS(3199),
    [anon_sym_DASH_GT] = ACTIONS(3199),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3689),
  },
  [975] = {
    [aux_sym_template_argument_list_repeat1] = STATE(1733),
    [anon_sym_COMMA] = ACTIONS(3163),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3691),
  },
  [976] = {
    [sym_destructor_name] = STATE(789),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(3693),
    [sym_comment] = ACTIONS(91),
    [sym_operator_name] = ACTIONS(1418),
  },
  [977] = {
    [anon_sym_COMMA] = ACTIONS(1431),
    [anon_sym_RPAREN] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1431),
    [anon_sym_extern] = ACTIONS(1429),
    [anon_sym_LPAREN2] = ACTIONS(1426),
    [anon_sym_STAR] = ACTIONS(1431),
    [anon_sym_LBRACK] = ACTIONS(1426),
    [anon_sym_static] = ACTIONS(1429),
    [anon_sym_register] = ACTIONS(1429),
    [anon_sym_inline] = ACTIONS(1429),
    [anon_sym_const] = ACTIONS(1429),
    [anon_sym_restrict] = ACTIONS(1429),
    [anon_sym_volatile] = ACTIONS(1429),
    [anon_sym__Atomic] = ACTIONS(1429),
    [anon_sym_mutable] = ACTIONS(1429),
    [anon_sym_explicit] = ACTIONS(1429),
    [anon_sym_constexpr] = ACTIONS(1429),
    [anon_sym_AMP] = ACTIONS(1429),
    [anon_sym_AMP_AMP] = ACTIONS(1431),
    [anon_sym_TILDE] = ACTIONS(1431),
    [sym_identifier] = ACTIONS(1429),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1431),
    [sym_operator_name] = ACTIONS(1431),
  },
  [978] = {
    [anon_sym_COMMA] = ACTIONS(1582),
    [anon_sym_RPAREN] = ACTIONS(1577),
    [anon_sym_SEMI] = ACTIONS(1582),
    [anon_sym_extern] = ACTIONS(1580),
    [anon_sym_LPAREN2] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1582),
    [anon_sym_LBRACK] = ACTIONS(1577),
    [anon_sym_static] = ACTIONS(1580),
    [anon_sym_register] = ACTIONS(1580),
    [anon_sym_inline] = ACTIONS(1580),
    [anon_sym_const] = ACTIONS(1580),
    [anon_sym_restrict] = ACTIONS(1580),
    [anon_sym_volatile] = ACTIONS(1580),
    [anon_sym__Atomic] = ACTIONS(1580),
    [anon_sym_mutable] = ACTIONS(1580),
    [anon_sym_explicit] = ACTIONS(1580),
    [anon_sym_constexpr] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1582),
    [anon_sym_TILDE] = ACTIONS(1582),
    [anon_sym_LT] = ACTIONS(1577),
    [sym_identifier] = ACTIONS(1580),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [sym_operator_name] = ACTIONS(1582),
  },
  [979] = {
    [sym_compound_statement] = STATE(1735),
    [sym_default_method_clause] = STATE(1735),
    [sym_delete_method_clause] = STATE(1735),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_EQ] = ACTIONS(578),
    [sym_comment] = ACTIONS(91),
  },
  [980] = {
    [sym_storage_class_specifier] = STATE(935),
    [sym_type_qualifier] = STATE(935),
    [aux_sym__declaration_specifiers_repeat1] = STATE(935),
    [anon_sym_SEMI] = ACTIONS(3695),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_LPAREN2] = ACTIONS(3695),
    [anon_sym_STAR] = ACTIONS(3695),
    [anon_sym_LBRACK] = ACTIONS(3695),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3695),
    [anon_sym_TILDE] = ACTIONS(3695),
    [sym_identifier] = ACTIONS(3697),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(3695),
    [sym_operator_name] = ACTIONS(3695),
  },
  [981] = {
    [sym_destructor_name] = STATE(958),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(3699),
    [sym_comment] = ACTIONS(91),
    [sym_operator_name] = ACTIONS(1767),
  },
  [982] = {
    [sym_raw_string_literal] = ACTIONS(3063),
    [ts_builtin_sym_end] = ACTIONS(3063),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3065),
    [sym_preproc_directive] = ACTIONS(3065),
    [anon_sym_SEMI] = ACTIONS(3063),
    [anon_sym_typedef] = ACTIONS(3065),
    [anon_sym_extern] = ACTIONS(3065),
    [anon_sym_LBRACE] = ACTIONS(3063),
    [anon_sym_RBRACE] = ACTIONS(3063),
    [anon_sym_LPAREN2] = ACTIONS(3063),
    [anon_sym_STAR] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_static] = ACTIONS(3065),
    [anon_sym_register] = ACTIONS(3065),
    [anon_sym_inline] = ACTIONS(3065),
    [anon_sym_const] = ACTIONS(3065),
    [anon_sym_restrict] = ACTIONS(3065),
    [anon_sym_volatile] = ACTIONS(3065),
    [anon_sym__Atomic] = ACTIONS(3065),
    [anon_sym_mutable] = ACTIONS(3065),
    [anon_sym_explicit] = ACTIONS(3065),
    [anon_sym_constexpr] = ACTIONS(3065),
    [anon_sym_unsigned] = ACTIONS(3065),
    [anon_sym_long] = ACTIONS(3065),
    [anon_sym_short] = ACTIONS(3065),
    [sym_primitive_type] = ACTIONS(3065),
    [anon_sym_enum] = ACTIONS(3065),
    [anon_sym_struct] = ACTIONS(3065),
    [anon_sym_union] = ACTIONS(3065),
    [anon_sym_if] = ACTIONS(3065),
    [anon_sym_switch] = ACTIONS(3065),
    [anon_sym_case] = ACTIONS(3065),
    [anon_sym_default] = ACTIONS(3065),
    [anon_sym_while] = ACTIONS(3065),
    [anon_sym_do] = ACTIONS(3065),
    [anon_sym_for] = ACTIONS(3065),
    [anon_sym_return] = ACTIONS(3065),
    [anon_sym_break] = ACTIONS(3065),
    [anon_sym_continue] = ACTIONS(3065),
    [anon_sym_goto] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3065),
    [anon_sym_AMP_AMP] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3063),
    [anon_sym_TILDE] = ACTIONS(3063),
    [anon_sym_PLUS] = ACTIONS(3065),
    [anon_sym_DASH] = ACTIONS(3065),
    [anon_sym_DASH_DASH] = ACTIONS(3063),
    [anon_sym_PLUS_PLUS] = ACTIONS(3063),
    [anon_sym_sizeof] = ACTIONS(3065),
    [sym_number_literal] = ACTIONS(3063),
    [anon_sym_SQUOTE] = ACTIONS(3063),
    [anon_sym_DQUOTE] = ACTIONS(3063),
    [sym_true] = ACTIONS(3065),
    [sym_false] = ACTIONS(3065),
    [sym_null] = ACTIONS(3065),
    [sym_identifier] = ACTIONS(3065),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3065),
    [sym_auto] = ACTIONS(3065),
    [anon_sym_typename] = ACTIONS(3065),
    [anon_sym_template] = ACTIONS(3065),
    [anon_sym_delete] = ACTIONS(3065),
    [anon_sym_namespace] = ACTIONS(3065),
    [anon_sym_using] = ACTIONS(3065),
    [anon_sym_try] = ACTIONS(3065),
    [anon_sym_new] = ACTIONS(3065),
    [anon_sym_COLON_COLON] = ACTIONS(3063),
    [sym_operator_name] = ACTIONS(3063),
    [sym_nullptr] = ACTIONS(3065),
  },
  [983] = {
    [aux_sym_preproc_params_repeat1] = STATE(1739),
    [anon_sym_COMMA] = ACTIONS(3701),
    [anon_sym_RPAREN] = ACTIONS(3703),
    [sym_comment] = ACTIONS(91),
  },
  [984] = {
    [anon_sym_LF] = ACTIONS(3705),
    [sym_preproc_arg] = ACTIONS(3705),
    [sym_comment] = ACTIONS(121),
  },
  [985] = {
    [sym_raw_string_literal] = ACTIONS(3707),
    [ts_builtin_sym_end] = ACTIONS(3707),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3709),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3709),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3709),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3709),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3709),
    [sym_preproc_directive] = ACTIONS(3709),
    [anon_sym_SEMI] = ACTIONS(3707),
    [anon_sym_typedef] = ACTIONS(3709),
    [anon_sym_extern] = ACTIONS(3709),
    [anon_sym_LBRACE] = ACTIONS(3707),
    [anon_sym_RBRACE] = ACTIONS(3707),
    [anon_sym_LPAREN2] = ACTIONS(3707),
    [anon_sym_STAR] = ACTIONS(3707),
    [anon_sym_LBRACK] = ACTIONS(3707),
    [anon_sym_static] = ACTIONS(3709),
    [anon_sym_register] = ACTIONS(3709),
    [anon_sym_inline] = ACTIONS(3709),
    [anon_sym_const] = ACTIONS(3709),
    [anon_sym_restrict] = ACTIONS(3709),
    [anon_sym_volatile] = ACTIONS(3709),
    [anon_sym__Atomic] = ACTIONS(3709),
    [anon_sym_mutable] = ACTIONS(3709),
    [anon_sym_explicit] = ACTIONS(3709),
    [anon_sym_constexpr] = ACTIONS(3709),
    [anon_sym_unsigned] = ACTIONS(3709),
    [anon_sym_long] = ACTIONS(3709),
    [anon_sym_short] = ACTIONS(3709),
    [sym_primitive_type] = ACTIONS(3709),
    [anon_sym_enum] = ACTIONS(3709),
    [anon_sym_struct] = ACTIONS(3709),
    [anon_sym_union] = ACTIONS(3709),
    [anon_sym_if] = ACTIONS(3709),
    [anon_sym_switch] = ACTIONS(3709),
    [anon_sym_case] = ACTIONS(3709),
    [anon_sym_default] = ACTIONS(3709),
    [anon_sym_while] = ACTIONS(3709),
    [anon_sym_do] = ACTIONS(3709),
    [anon_sym_for] = ACTIONS(3709),
    [anon_sym_return] = ACTIONS(3709),
    [anon_sym_break] = ACTIONS(3709),
    [anon_sym_continue] = ACTIONS(3709),
    [anon_sym_goto] = ACTIONS(3709),
    [anon_sym_AMP] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3707),
    [anon_sym_BANG] = ACTIONS(3707),
    [anon_sym_TILDE] = ACTIONS(3707),
    [anon_sym_PLUS] = ACTIONS(3709),
    [anon_sym_DASH] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3707),
    [anon_sym_PLUS_PLUS] = ACTIONS(3707),
    [anon_sym_sizeof] = ACTIONS(3709),
    [sym_number_literal] = ACTIONS(3707),
    [anon_sym_SQUOTE] = ACTIONS(3707),
    [anon_sym_DQUOTE] = ACTIONS(3707),
    [sym_true] = ACTIONS(3709),
    [sym_false] = ACTIONS(3709),
    [sym_null] = ACTIONS(3709),
    [sym_identifier] = ACTIONS(3709),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3709),
    [sym_auto] = ACTIONS(3709),
    [anon_sym_typename] = ACTIONS(3709),
    [anon_sym_template] = ACTIONS(3709),
    [anon_sym_delete] = ACTIONS(3709),
    [anon_sym_namespace] = ACTIONS(3709),
    [anon_sym_using] = ACTIONS(3709),
    [anon_sym_try] = ACTIONS(3709),
    [anon_sym_new] = ACTIONS(3709),
    [anon_sym_COLON_COLON] = ACTIONS(3707),
    [sym_operator_name] = ACTIONS(3707),
    [sym_nullptr] = ACTIONS(3709),
  },
  [986] = {
    [sym_raw_string_literal] = ACTIONS(3711),
    [ts_builtin_sym_end] = ACTIONS(3711),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3713),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3713),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3713),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3713),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3713),
    [sym_preproc_directive] = ACTIONS(3713),
    [anon_sym_SEMI] = ACTIONS(3711),
    [anon_sym_typedef] = ACTIONS(3713),
    [anon_sym_extern] = ACTIONS(3713),
    [anon_sym_LBRACE] = ACTIONS(3711),
    [anon_sym_RBRACE] = ACTIONS(3711),
    [anon_sym_LPAREN2] = ACTIONS(3711),
    [anon_sym_STAR] = ACTIONS(3711),
    [anon_sym_LBRACK] = ACTIONS(3711),
    [anon_sym_static] = ACTIONS(3713),
    [anon_sym_register] = ACTIONS(3713),
    [anon_sym_inline] = ACTIONS(3713),
    [anon_sym_const] = ACTIONS(3713),
    [anon_sym_restrict] = ACTIONS(3713),
    [anon_sym_volatile] = ACTIONS(3713),
    [anon_sym__Atomic] = ACTIONS(3713),
    [anon_sym_mutable] = ACTIONS(3713),
    [anon_sym_explicit] = ACTIONS(3713),
    [anon_sym_constexpr] = ACTIONS(3713),
    [anon_sym_unsigned] = ACTIONS(3713),
    [anon_sym_long] = ACTIONS(3713),
    [anon_sym_short] = ACTIONS(3713),
    [sym_primitive_type] = ACTIONS(3713),
    [anon_sym_enum] = ACTIONS(3713),
    [anon_sym_struct] = ACTIONS(3713),
    [anon_sym_union] = ACTIONS(3713),
    [anon_sym_if] = ACTIONS(3713),
    [anon_sym_switch] = ACTIONS(3713),
    [anon_sym_case] = ACTIONS(3713),
    [anon_sym_default] = ACTIONS(3713),
    [anon_sym_while] = ACTIONS(3713),
    [anon_sym_do] = ACTIONS(3713),
    [anon_sym_for] = ACTIONS(3713),
    [anon_sym_return] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3713),
    [anon_sym_continue] = ACTIONS(3713),
    [anon_sym_goto] = ACTIONS(3713),
    [anon_sym_AMP] = ACTIONS(3713),
    [anon_sym_AMP_AMP] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3711),
    [anon_sym_TILDE] = ACTIONS(3711),
    [anon_sym_PLUS] = ACTIONS(3713),
    [anon_sym_DASH] = ACTIONS(3713),
    [anon_sym_DASH_DASH] = ACTIONS(3711),
    [anon_sym_PLUS_PLUS] = ACTIONS(3711),
    [anon_sym_sizeof] = ACTIONS(3713),
    [sym_number_literal] = ACTIONS(3711),
    [anon_sym_SQUOTE] = ACTIONS(3711),
    [anon_sym_DQUOTE] = ACTIONS(3711),
    [sym_true] = ACTIONS(3713),
    [sym_false] = ACTIONS(3713),
    [sym_null] = ACTIONS(3713),
    [sym_identifier] = ACTIONS(3713),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3713),
    [sym_auto] = ACTIONS(3713),
    [anon_sym_typename] = ACTIONS(3713),
    [anon_sym_template] = ACTIONS(3713),
    [anon_sym_delete] = ACTIONS(3713),
    [anon_sym_namespace] = ACTIONS(3713),
    [anon_sym_using] = ACTIONS(3713),
    [anon_sym_try] = ACTIONS(3713),
    [anon_sym_new] = ACTIONS(3713),
    [anon_sym_COLON_COLON] = ACTIONS(3711),
    [sym_operator_name] = ACTIONS(3711),
    [sym_nullptr] = ACTIONS(3713),
  },
  [987] = {
    [anon_sym_LF] = ACTIONS(3715),
    [sym_comment] = ACTIONS(121),
  },
  [988] = {
    [aux_sym_string_literal_repeat1] = STATE(1742),
    [anon_sym_DQUOTE] = ACTIONS(3717),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_BSLASHn_RBRACK_SLASH] = ACTIONS(3719),
    [sym_escape_sequence] = ACTIONS(3719),
    [sym_comment] = ACTIONS(121),
  },
  [989] = {
    [sym_raw_string_literal] = ACTIONS(668),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(670),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(670),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(670),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(670),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(670),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(670),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(670),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(670),
    [sym_preproc_directive] = ACTIONS(670),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(670),
    [anon_sym_extern] = ACTIONS(670),
    [anon_sym_LBRACE] = ACTIONS(668),
    [anon_sym_LPAREN2] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(668),
    [anon_sym_LBRACK] = ACTIONS(668),
    [anon_sym_static] = ACTIONS(670),
    [anon_sym_register] = ACTIONS(670),
    [anon_sym_inline] = ACTIONS(670),
    [anon_sym_const] = ACTIONS(670),
    [anon_sym_restrict] = ACTIONS(670),
    [anon_sym_volatile] = ACTIONS(670),
    [anon_sym__Atomic] = ACTIONS(670),
    [anon_sym_mutable] = ACTIONS(670),
    [anon_sym_explicit] = ACTIONS(670),
    [anon_sym_constexpr] = ACTIONS(670),
    [anon_sym_unsigned] = ACTIONS(670),
    [anon_sym_long] = ACTIONS(670),
    [anon_sym_short] = ACTIONS(670),
    [sym_primitive_type] = ACTIONS(670),
    [anon_sym_enum] = ACTIONS(670),
    [anon_sym_struct] = ACTIONS(670),
    [anon_sym_union] = ACTIONS(670),
    [anon_sym_if] = ACTIONS(670),
    [anon_sym_switch] = ACTIONS(670),
    [anon_sym_case] = ACTIONS(670),
    [anon_sym_default] = ACTIONS(670),
    [anon_sym_while] = ACTIONS(670),
    [anon_sym_do] = ACTIONS(670),
    [anon_sym_for] = ACTIONS(670),
    [anon_sym_return] = ACTIONS(670),
    [anon_sym_break] = ACTIONS(670),
    [anon_sym_continue] = ACTIONS(670),
    [anon_sym_goto] = ACTIONS(670),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_AMP_AMP] = ACTIONS(668),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_PLUS] = ACTIONS(670),
    [anon_sym_DASH] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(668),
    [anon_sym_PLUS_PLUS] = ACTIONS(668),
    [anon_sym_sizeof] = ACTIONS(670),
    [sym_number_literal] = ACTIONS(668),
    [anon_sym_SQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE] = ACTIONS(668),
    [sym_true] = ACTIONS(670),
    [sym_false] = ACTIONS(670),
    [sym_null] = ACTIONS(670),
    [sym_identifier] = ACTIONS(670),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(670),
    [sym_auto] = ACTIONS(670),
    [anon_sym_typename] = ACTIONS(670),
    [anon_sym_template] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_namespace] = ACTIONS(670),
    [anon_sym_using] = ACTIONS(670),
    [anon_sym_try] = ACTIONS(670),
    [anon_sym_new] = ACTIONS(670),
    [anon_sym_COLON_COLON] = ACTIONS(668),
    [sym_operator_name] = ACTIONS(668),
    [sym_nullptr] = ACTIONS(670),
  },
  [990] = {
    [sym_preproc_params] = STATE(1745),
    [anon_sym_LF] = ACTIONS(3721),
    [anon_sym_LPAREN] = ACTIONS(674),
    [sym_preproc_arg] = ACTIONS(3723),
    [sym_comment] = ACTIONS(121),
  },
  [991] = {
    [sym_preproc_include] = STATE(1748),
    [sym_preproc_def] = STATE(1748),
    [sym_preproc_function_def] = STATE(1748),
    [sym_preproc_call] = STATE(1748),
    [sym_preproc_if] = STATE(1748),
    [sym_preproc_ifdef] = STATE(1748),
    [sym_preproc_else] = STATE(1747),
    [sym_preproc_elif] = STATE(1747),
    [sym_function_definition] = STATE(1748),
    [sym_declaration] = STATE(1748),
    [sym_type_definition] = STATE(1748),
    [sym__declaration_specifiers] = STATE(409),
    [sym_linkage_specification] = STATE(1748),
    [sym__declarator] = STATE(50),
    [sym_pointer_declarator] = STATE(50),
    [sym_function_declarator] = STATE(410),
    [sym_array_declarator] = STATE(50),
    [sym_compound_statement] = STATE(1748),
    [sym_storage_class_specifier] = STATE(414),
    [sym_type_qualifier] = STATE(414),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(1748),
    [sym_expression_statement] = STATE(1748),
    [sym_if_statement] = STATE(1748),
    [sym_switch_statement] = STATE(1748),
    [sym_case_statement] = STATE(1748),
    [sym_while_statement] = STATE(1748),
    [sym_do_statement] = STATE(1748),
    [sym_for_statement] = STATE(1748),
    [sym_return_statement] = STATE(1748),
    [sym_break_statement] = STATE(1748),
    [sym_continue_statement] = STATE(1748),
    [sym_goto_statement] = STATE(1748),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(1748),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(1748),
    [sym_template_declaration] = STATE(1748),
    [sym_template_instantiation] = STATE(1748),
    [sym_constructor_or_destructor_definition] = STATE(1748),
    [sym_reference_declarator] = STATE(50),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(57),
    [sym_namespace_definition] = STATE(1748),
    [sym_using_declaration] = STATE(1748),
    [sym_alias_declaration] = STATE(1748),
    [sym_for_range_loop] = STATE(1748),
    [sym_try_statement] = STATE(1748),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_destructor_name] = STATE(50),
    [sym_scoped_identifier] = STATE(59),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_translation_unit_repeat1] = STATE(1748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(414),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(678),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(684),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3725),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(688),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(688),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(690),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(692),
    [sym_preproc_directive] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_typedef] = ACTIONS(698),
    [anon_sym_extern] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(704),
    [anon_sym_switch] = ACTIONS(706),
    [anon_sym_case] = ACTIONS(708),
    [anon_sym_default] = ACTIONS(710),
    [anon_sym_while] = ACTIONS(712),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(728),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_template] = ACTIONS(730),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_namespace] = ACTIONS(732),
    [anon_sym_using] = ACTIONS(734),
    [anon_sym_try] = ACTIONS(736),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_operator_name] = ACTIONS(111),
    [sym_nullptr] = ACTIONS(726),
  },
  [992] = {
    [sym_preproc_include] = STATE(1751),
    [sym_preproc_def] = STATE(1751),
    [sym_preproc_function_def] = STATE(1751),
    [sym_preproc_call] = STATE(1751),
    [sym_preproc_if] = STATE(1751),
    [sym_preproc_ifdef] = STATE(1751),
    [sym_preproc_else] = STATE(1750),
    [sym_preproc_elif] = STATE(1750),
    [sym_function_definition] = STATE(1751),
    [sym_declaration] = STATE(1751),
    [sym_type_definition] = STATE(1751),
    [sym__declaration_specifiers] = STATE(409),
    [sym_linkage_specification] = STATE(1751),
    [sym__declarator] = STATE(50),
    [sym_pointer_declarator] = STATE(50),
    [sym_function_declarator] = STATE(410),
    [sym_array_declarator] = STATE(50),
    [sym_compound_statement] = STATE(1751),
    [sym_storage_class_specifier] = STATE(414),
    [sym_type_qualifier] = STATE(414),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(1751),
    [sym_expression_statement] = STATE(1751),
    [sym_if_statement] = STATE(1751),
    [sym_switch_statement] = STATE(1751),
    [sym_case_statement] = STATE(1751),
    [sym_while_statement] = STATE(1751),
    [sym_do_statement] = STATE(1751),
    [sym_for_statement] = STATE(1751),
    [sym_return_statement] = STATE(1751),
    [sym_break_statement] = STATE(1751),
    [sym_continue_statement] = STATE(1751),
    [sym_goto_statement] = STATE(1751),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(1751),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(1751),
    [sym_template_declaration] = STATE(1751),
    [sym_template_instantiation] = STATE(1751),
    [sym_constructor_or_destructor_definition] = STATE(1751),
    [sym_reference_declarator] = STATE(50),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(57),
    [sym_namespace_definition] = STATE(1751),
    [sym_using_declaration] = STATE(1751),
    [sym_alias_declaration] = STATE(1751),
    [sym_for_range_loop] = STATE(1751),
    [sym_try_statement] = STATE(1751),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_destructor_name] = STATE(50),
    [sym_scoped_identifier] = STATE(59),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_translation_unit_repeat1] = STATE(1751),
    [aux_sym__declaration_specifiers_repeat1] = STATE(414),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(678),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(684),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(688),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(688),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(690),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(692),
    [sym_preproc_directive] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_typedef] = ACTIONS(698),
    [anon_sym_extern] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(704),
    [anon_sym_switch] = ACTIONS(706),
    [anon_sym_case] = ACTIONS(708),
    [anon_sym_default] = ACTIONS(710),
    [anon_sym_while] = ACTIONS(712),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(728),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_template] = ACTIONS(730),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_namespace] = ACTIONS(732),
    [anon_sym_using] = ACTIONS(734),
    [anon_sym_try] = ACTIONS(736),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_operator_name] = ACTIONS(111),
    [sym_nullptr] = ACTIONS(726),
  },
  [993] = {
    [sym_string_literal] = STATE(1753),
    [anon_sym_DQUOTE] = ACTIONS(3729),
    [sym_system_lib_string] = ACTIONS(3731),
    [sym_comment] = ACTIONS(91),
  },
  [994] = {
    [sym_identifier] = ACTIONS(3733),
    [sym_comment] = ACTIONS(91),
  },
  [995] = {
    [sym_preproc_arg] = ACTIONS(3735),
    [sym_comment] = ACTIONS(121),
  },
  [996] = {
    [sym_identifier] = ACTIONS(3737),
    [sym_comment] = ACTIONS(91),
  },
  [997] = {
    [anon_sym_LF] = ACTIONS(3739),
    [sym_preproc_arg] = ACTIONS(3741),
    [sym_comment] = ACTIONS(121),
  },
  [998] = {
    [sym_raw_string_literal] = ACTIONS(129),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(131),
    [sym_preproc_directive] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(129),
    [anon_sym_typedef] = ACTIONS(131),
    [anon_sym_extern] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_LPAREN2] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(129),
    [anon_sym_static] = ACTIONS(131),
    [anon_sym_register] = ACTIONS(131),
    [anon_sym_inline] = ACTIONS(131),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_restrict] = ACTIONS(131),
    [anon_sym_volatile] = ACTIONS(131),
    [anon_sym__Atomic] = ACTIONS(131),
    [anon_sym_mutable] = ACTIONS(131),
    [anon_sym_explicit] = ACTIONS(131),
    [anon_sym_constexpr] = ACTIONS(131),
    [anon_sym_unsigned] = ACTIONS(131),
    [anon_sym_long] = ACTIONS(131),
    [anon_sym_short] = ACTIONS(131),
    [sym_primitive_type] = ACTIONS(131),
    [anon_sym_enum] = ACTIONS(131),
    [anon_sym_struct] = ACTIONS(131),
    [anon_sym_union] = ACTIONS(131),
    [anon_sym_if] = ACTIONS(131),
    [anon_sym_else] = ACTIONS(131),
    [anon_sym_switch] = ACTIONS(131),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(131),
    [anon_sym_break] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_goto] = ACTIONS(131),
    [anon_sym_AMP] = ACTIONS(131),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_BANG] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_PLUS] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(129),
    [anon_sym_PLUS_PLUS] = ACTIONS(129),
    [anon_sym_sizeof] = ACTIONS(131),
    [sym_number_literal] = ACTIONS(129),
    [anon_sym_SQUOTE] = ACTIONS(129),
    [anon_sym_DQUOTE] = ACTIONS(129),
    [sym_true] = ACTIONS(131),
    [sym_false] = ACTIONS(131),
    [sym_null] = ACTIONS(131),
    [sym_identifier] = ACTIONS(131),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(131),
    [sym_auto] = ACTIONS(131),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(131),
    [anon_sym_delete] = ACTIONS(131),
    [anon_sym_namespace] = ACTIONS(131),
    [anon_sym_using] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(131),
    [anon_sym_new] = ACTIONS(131),
    [anon_sym_COLON_COLON] = ACTIONS(129),
    [sym_operator_name] = ACTIONS(129),
    [sym_nullptr] = ACTIONS(131),
  },
  [999] = {
    [sym_type_qualifier] = STATE(1760),
    [sym__type_specifier] = STATE(1759),
    [sym_sized_type_specifier] = STATE(1759),
    [sym_enum_specifier] = STATE(1759),
    [sym_struct_specifier] = STATE(1759),
    [sym_union_specifier] = STATE(1759),
    [sym_macro_type_specifier] = STATE(1759),
    [sym_class_specifier] = STATE(1759),
    [sym_dependent_type] = STATE(1759),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(82),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_type_definition_repeat1] = STATE(1760),
    [aux_sym_sized_type_specifier_repeat1] = STATE(85),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(135),
    [anon_sym_long] = ACTIONS(135),
    [anon_sym_short] = ACTIONS(135),
    [sym_primitive_type] = ACTIONS(3743),
    [anon_sym_enum] = ACTIONS(139),
    [anon_sym_struct] = ACTIONS(141),
    [anon_sym_union] = ACTIONS(143),
    [sym_identifier] = ACTIONS(145),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(147),
    [sym_auto] = ACTIONS(3743),
    [anon_sym_typename] = ACTIONS(149),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [1000] = {
    [sym_string_literal] = STATE(1761),
    [anon_sym_extern] = ACTIONS(153),
    [anon_sym_LPAREN2] = ACTIONS(155),
    [anon_sym_STAR] = ACTIONS(155),
    [anon_sym_static] = ACTIONS(153),
    [anon_sym_register] = ACTIONS(153),
    [anon_sym_inline] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(153),
    [anon_sym_restrict] = ACTIONS(153),
    [anon_sym_volatile] = ACTIONS(153),
    [anon_sym__Atomic] = ACTIONS(153),
    [anon_sym_mutable] = ACTIONS(153),
    [anon_sym_explicit] = ACTIONS(153),
    [anon_sym_constexpr] = ACTIONS(153),
    [anon_sym_unsigned] = ACTIONS(153),
    [anon_sym_long] = ACTIONS(153),
    [anon_sym_short] = ACTIONS(153),
    [sym_primitive_type] = ACTIONS(153),
    [anon_sym_enum] = ACTIONS(153),
    [anon_sym_struct] = ACTIONS(153),
    [anon_sym_union] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_identifier] = ACTIONS(153),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(153),
    [sym_auto] = ACTIONS(153),
    [anon_sym_typename] = ACTIONS(153),
    [anon_sym_COLON_COLON] = ACTIONS(155),
    [sym_operator_name] = ACTIONS(155),
  },
  [1001] = {
    [sym_preproc_include] = STATE(1763),
    [sym_preproc_def] = STATE(1763),
    [sym_preproc_function_def] = STATE(1763),
    [sym_preproc_call] = STATE(1763),
    [sym_preproc_if_in_compound_statement] = STATE(1763),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1763),
    [sym_declaration] = STATE(1763),
    [sym_type_definition] = STATE(1763),
    [sym__declaration_specifiers] = STATE(113),
    [sym_compound_statement] = STATE(1763),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(1763),
    [sym_expression_statement] = STATE(1763),
    [sym_if_statement] = STATE(1763),
    [sym_switch_statement] = STATE(1763),
    [sym_case_statement] = STATE(1763),
    [sym_while_statement] = STATE(1763),
    [sym_do_statement] = STATE(1763),
    [sym_for_statement] = STATE(1763),
    [sym_return_statement] = STATE(1763),
    [sym_break_statement] = STATE(1763),
    [sym_continue_statement] = STATE(1763),
    [sym_goto_statement] = STATE(1763),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(1763),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(1763),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(1763),
    [sym_try_statement] = STATE(1763),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1763),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(157),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(159),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(161),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(163),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(165),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(165),
    [sym_preproc_directive] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_typedef] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_RBRACE] = ACTIONS(3745),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(185),
    [anon_sym_case] = ACTIONS(187),
    [anon_sym_default] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(209),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_nullptr] = ACTIONS(207),
  },
  [1002] = {
    [anon_sym_LPAREN2] = ACTIONS(3747),
    [anon_sym_constexpr] = ACTIONS(3749),
    [sym_comment] = ACTIONS(91),
  },
  [1003] = {
    [sym_parenthesized_expression] = STATE(1766),
    [anon_sym_LPAREN2] = ACTIONS(323),
    [sym_comment] = ACTIONS(91),
  },
  [1004] = {
    [sym__expression] = STATE(1767),
    [sym_conditional_expression] = STATE(1767),
    [sym_assignment_expression] = STATE(1767),
    [sym_pointer_expression] = STATE(1767),
    [sym_logical_expression] = STATE(1767),
    [sym_bitwise_expression] = STATE(1767),
    [sym_equality_expression] = STATE(1767),
    [sym_relational_expression] = STATE(1767),
    [sym_shift_expression] = STATE(1767),
    [sym_math_expression] = STATE(1767),
    [sym_cast_expression] = STATE(1767),
    [sym_sizeof_expression] = STATE(1767),
    [sym_subscript_expression] = STATE(1767),
    [sym_call_expression] = STATE(1767),
    [sym_field_expression] = STATE(1767),
    [sym_compound_literal_expression] = STATE(1767),
    [sym_parenthesized_expression] = STATE(1767),
    [sym_char_literal] = STATE(1767),
    [sym_concatenated_string] = STATE(1767),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1767),
    [sym_new_expression] = STATE(1767),
    [sym_delete_expression] = STATE(1767),
    [sym_lambda_expression] = STATE(1767),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3751),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(3751),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(3753),
    [sym_false] = ACTIONS(3753),
    [sym_null] = ACTIONS(3753),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(3753),
  },
  [1005] = {
    [anon_sym_COLON] = ACTIONS(3755),
    [sym_comment] = ACTIONS(91),
  },
  [1006] = {
    [sym_parenthesized_expression] = STATE(1769),
    [anon_sym_LPAREN2] = ACTIONS(323),
    [sym_comment] = ACTIONS(91),
  },
  [1007] = {
    [sym_compound_statement] = STATE(1770),
    [sym_labeled_statement] = STATE(1770),
    [sym_expression_statement] = STATE(1770),
    [sym_if_statement] = STATE(1770),
    [sym_switch_statement] = STATE(1770),
    [sym_case_statement] = STATE(1770),
    [sym_while_statement] = STATE(1770),
    [sym_do_statement] = STATE(1770),
    [sym_for_statement] = STATE(1770),
    [sym_return_statement] = STATE(1770),
    [sym_break_statement] = STATE(1770),
    [sym_continue_statement] = STATE(1770),
    [sym_goto_statement] = STATE(1770),
    [sym__expression] = STATE(222),
    [sym_comma_expression] = STATE(223),
    [sym_conditional_expression] = STATE(222),
    [sym_assignment_expression] = STATE(222),
    [sym_pointer_expression] = STATE(222),
    [sym_logical_expression] = STATE(222),
    [sym_bitwise_expression] = STATE(222),
    [sym_equality_expression] = STATE(222),
    [sym_relational_expression] = STATE(222),
    [sym_shift_expression] = STATE(222),
    [sym_math_expression] = STATE(222),
    [sym_cast_expression] = STATE(222),
    [sym_sizeof_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_call_expression] = STATE(222),
    [sym_field_expression] = STATE(222),
    [sym_compound_literal_expression] = STATE(222),
    [sym_parenthesized_expression] = STATE(222),
    [sym_char_literal] = STATE(222),
    [sym_concatenated_string] = STATE(222),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(222),
    [sym_for_range_loop] = STATE(1770),
    [sym_try_statement] = STATE(1770),
    [sym_new_expression] = STATE(222),
    [sym_delete_expression] = STATE(222),
    [sym_lambda_expression] = STATE(222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(359),
    [anon_sym_switch] = ACTIONS(361),
    [anon_sym_case] = ACTIONS(363),
    [anon_sym_default] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [anon_sym_do] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(373),
    [anon_sym_break] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_goto] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(353),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_identifier] = ACTIONS(383),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(381),
  },
  [1008] = {
    [anon_sym_LPAREN2] = ACTIONS(3757),
    [sym_comment] = ACTIONS(91),
  },
  [1009] = {
    [sym__expression] = STATE(1773),
    [sym_conditional_expression] = STATE(1773),
    [sym_assignment_expression] = STATE(1773),
    [sym_pointer_expression] = STATE(1773),
    [sym_logical_expression] = STATE(1773),
    [sym_bitwise_expression] = STATE(1773),
    [sym_equality_expression] = STATE(1773),
    [sym_relational_expression] = STATE(1773),
    [sym_shift_expression] = STATE(1773),
    [sym_math_expression] = STATE(1773),
    [sym_cast_expression] = STATE(1773),
    [sym_sizeof_expression] = STATE(1773),
    [sym_subscript_expression] = STATE(1773),
    [sym_call_expression] = STATE(1773),
    [sym_field_expression] = STATE(1773),
    [sym_compound_literal_expression] = STATE(1773),
    [sym_parenthesized_expression] = STATE(1773),
    [sym_initializer_list] = STATE(1774),
    [sym_char_literal] = STATE(1773),
    [sym_concatenated_string] = STATE(1773),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1773),
    [sym_new_expression] = STATE(1773),
    [sym_delete_expression] = STATE(1773),
    [sym_lambda_expression] = STATE(1773),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3759),
    [anon_sym_SEMI] = ACTIONS(3761),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(3759),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(3763),
    [sym_false] = ACTIONS(3763),
    [sym_null] = ACTIONS(3763),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(3763),
  },
  [1010] = {
    [anon_sym_SEMI] = ACTIONS(3765),
    [sym_comment] = ACTIONS(91),
  },
  [1011] = {
    [anon_sym_SEMI] = ACTIONS(3767),
    [sym_comment] = ACTIONS(91),
  },
  [1012] = {
    [sym_identifier] = ACTIONS(3769),
    [sym_comment] = ACTIONS(91),
  },
  [1013] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(263),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(465),
    [anon_sym_extern] = ACTIONS(468),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(470),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_LBRACK] = ACTIONS(470),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_register] = ACTIONS(468),
    [anon_sym_inline] = ACTIONS(468),
    [anon_sym_const] = ACTIONS(468),
    [anon_sym_restrict] = ACTIONS(468),
    [anon_sym_volatile] = ACTIONS(468),
    [anon_sym__Atomic] = ACTIONS(468),
    [anon_sym_mutable] = ACTIONS(468),
    [anon_sym_explicit] = ACTIONS(468),
    [anon_sym_constexpr] = ACTIONS(468),
    [anon_sym_COLON] = ACTIONS(3771),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(474),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_TILDE] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_identifier] = ACTIONS(468),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(486),
    [sym_operator_name] = ACTIONS(481),
  },
  [1014] = {
    [sym__declaration_specifiers] = STATE(1779),
    [sym__declarator] = STATE(1780),
    [sym_pointer_declarator] = STATE(1780),
    [sym_function_declarator] = STATE(1780),
    [sym_array_declarator] = STATE(1780),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_parameter_list] = STATE(1781),
    [sym_reference_declarator] = STATE(1780),
    [sym_template_type] = STATE(284),
    [sym_template_function] = STATE(1780),
    [sym_destructor_name] = STATE(1780),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(285),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(494),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_AMP] = ACTIONS(500),
    [anon_sym_AMP_AMP] = ACTIONS(502),
    [anon_sym_TILDE] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(504),
    [sym_identifier] = ACTIONS(506),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_COLON_COLON] = ACTIONS(510),
    [sym_operator_name] = ACTIONS(3773),
  },
  [1015] = {
    [sym_declaration_list] = STATE(1784),
    [anon_sym_LBRACE] = ACTIONS(3775),
    [sym_identifier] = ACTIONS(3777),
    [sym_comment] = ACTIONS(91),
  },
  [1016] = {
    [sym_template_type] = STATE(296),
    [sym_scoped_identifier] = STATE(1787),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(296),
    [sym_identifier] = ACTIONS(3779),
    [sym_comment] = ACTIONS(91),
    [anon_sym_namespace] = ACTIONS(3781),
    [anon_sym_COLON_COLON] = ACTIONS(528),
  },
  [1017] = {
    [sym_compound_statement] = STATE(1788),
    [anon_sym_LBRACE] = ACTIONS(357),
    [sym_comment] = ACTIONS(91),
  },
  [1018] = {
    [sym__declarator] = STATE(1790),
    [sym_pointer_declarator] = STATE(1790),
    [sym_function_declarator] = STATE(1790),
    [sym_array_declarator] = STATE(1790),
    [sym_init_declarator] = STATE(1791),
    [sym_reference_declarator] = STATE(1790),
    [sym_structured_binding_reference_declarator] = STATE(1792),
    [sym_structured_binding_declarator] = STATE(1792),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(1790),
    [sym_destructor_name] = STATE(1790),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [anon_sym_SEMI] = ACTIONS(3783),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(566),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(568),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(3785),
  },
  [1019] = {
    [sym_compound_statement] = STATE(1794),
    [sym_field_initializer_list] = STATE(1795),
    [sym_default_method_clause] = STATE(1794),
    [sym_delete_method_clause] = STATE(1794),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(576),
    [anon_sym_LBRACK] = ACTIONS(576),
    [anon_sym_EQ] = ACTIONS(3787),
    [anon_sym_COLON] = ACTIONS(580),
    [sym_comment] = ACTIONS(91),
  },
  [1020] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(586),
    [anon_sym_SEMI] = ACTIONS(3789),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(590),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(594),
    [anon_sym_QMARK] = ACTIONS(596),
    [anon_sym_STAR_EQ] = ACTIONS(598),
    [anon_sym_SLASH_EQ] = ACTIONS(598),
    [anon_sym_PERCENT_EQ] = ACTIONS(598),
    [anon_sym_PLUS_EQ] = ACTIONS(598),
    [anon_sym_DASH_EQ] = ACTIONS(598),
    [anon_sym_LT_LT_EQ] = ACTIONS(598),
    [anon_sym_GT_GT_EQ] = ACTIONS(598),
    [anon_sym_AMP_EQ] = ACTIONS(598),
    [anon_sym_CARET_EQ] = ACTIONS(598),
    [anon_sym_PIPE_EQ] = ACTIONS(598),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_PIPE_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(604),
    [anon_sym_PIPE] = ACTIONS(606),
    [anon_sym_CARET] = ACTIONS(608),
    [anon_sym_EQ_EQ] = ACTIONS(610),
    [anon_sym_BANG_EQ] = ACTIONS(610),
    [anon_sym_LT] = ACTIONS(612),
    [anon_sym_GT] = ACTIONS(612),
    [anon_sym_LT_EQ] = ACTIONS(614),
    [anon_sym_GT_EQ] = ACTIONS(614),
    [anon_sym_LT_LT] = ACTIONS(616),
    [anon_sym_GT_GT] = ACTIONS(616),
    [anon_sym_PLUS] = ACTIONS(618),
    [anon_sym_DASH] = ACTIONS(618),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1021] = {
    [anon_sym_SEMI] = ACTIONS(3789),
    [sym_comment] = ACTIONS(91),
  },
  [1022] = {
    [sym_preproc_include] = STATE(1797),
    [sym_preproc_def] = STATE(1797),
    [sym_preproc_function_def] = STATE(1797),
    [sym_preproc_call] = STATE(1797),
    [sym_preproc_if] = STATE(1797),
    [sym_preproc_ifdef] = STATE(1797),
    [sym_function_definition] = STATE(1797),
    [sym_declaration] = STATE(1797),
    [sym_type_definition] = STATE(1797),
    [sym__declaration_specifiers] = STATE(1018),
    [sym_linkage_specification] = STATE(1797),
    [sym__declarator] = STATE(50),
    [sym_pointer_declarator] = STATE(50),
    [sym_function_declarator] = STATE(1019),
    [sym_array_declarator] = STATE(50),
    [sym_compound_statement] = STATE(1797),
    [sym_storage_class_specifier] = STATE(1023),
    [sym_type_qualifier] = STATE(1023),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(1797),
    [sym_expression_statement] = STATE(1797),
    [sym_if_statement] = STATE(1797),
    [sym_switch_statement] = STATE(1797),
    [sym_case_statement] = STATE(1797),
    [sym_while_statement] = STATE(1797),
    [sym_do_statement] = STATE(1797),
    [sym_for_statement] = STATE(1797),
    [sym_return_statement] = STATE(1797),
    [sym_break_statement] = STATE(1797),
    [sym_continue_statement] = STATE(1797),
    [sym_goto_statement] = STATE(1797),
    [sym__expression] = STATE(1020),
    [sym_comma_expression] = STATE(1021),
    [sym_conditional_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1020),
    [sym_pointer_expression] = STATE(1020),
    [sym_logical_expression] = STATE(1020),
    [sym_bitwise_expression] = STATE(1020),
    [sym_equality_expression] = STATE(1020),
    [sym_relational_expression] = STATE(1020),
    [sym_shift_expression] = STATE(1020),
    [sym_math_expression] = STATE(1020),
    [sym_cast_expression] = STATE(1020),
    [sym_sizeof_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_field_expression] = STATE(1020),
    [sym_compound_literal_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_char_literal] = STATE(1020),
    [sym_concatenated_string] = STATE(1020),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(1797),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(1797),
    [sym_template_declaration] = STATE(1797),
    [sym_template_instantiation] = STATE(1797),
    [sym_constructor_or_destructor_definition] = STATE(1797),
    [sym_reference_declarator] = STATE(50),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(57),
    [sym_namespace_definition] = STATE(1797),
    [sym_using_declaration] = STATE(1797),
    [sym_alias_declaration] = STATE(1797),
    [sym_for_range_loop] = STATE(1797),
    [sym_try_statement] = STATE(1797),
    [sym_new_expression] = STATE(1020),
    [sym_delete_expression] = STATE(1020),
    [sym_lambda_expression] = STATE(1020),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_destructor_name] = STATE(50),
    [sym_scoped_identifier] = STATE(59),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_translation_unit_repeat1] = STATE(1797),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1023),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(2022),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2024),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2026),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2028),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3791),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2032),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2032),
    [sym_preproc_directive] = ACTIONS(2034),
    [anon_sym_SEMI] = ACTIONS(2036),
    [anon_sym_typedef] = ACTIONS(2038),
    [anon_sym_extern] = ACTIONS(2040),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(2044),
    [anon_sym_switch] = ACTIONS(2046),
    [anon_sym_case] = ACTIONS(2048),
    [anon_sym_default] = ACTIONS(2050),
    [anon_sym_while] = ACTIONS(2052),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(2056),
    [anon_sym_return] = ACTIONS(2058),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2062),
    [anon_sym_goto] = ACTIONS(2064),
    [anon_sym_AMP] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(2068),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_template] = ACTIONS(2070),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_namespace] = ACTIONS(2072),
    [anon_sym_using] = ACTIONS(2074),
    [anon_sym_try] = ACTIONS(2076),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_operator_name] = ACTIONS(111),
    [sym_nullptr] = ACTIONS(2066),
  },
  [1023] = {
    [sym__declarator] = STATE(50),
    [sym_pointer_declarator] = STATE(50),
    [sym_function_declarator] = STATE(1798),
    [sym_array_declarator] = STATE(50),
    [sym_storage_class_specifier] = STATE(370),
    [sym_type_qualifier] = STATE(370),
    [sym__type_specifier] = STATE(367),
    [sym_sized_type_specifier] = STATE(367),
    [sym_enum_specifier] = STATE(367),
    [sym_struct_specifier] = STATE(367),
    [sym_union_specifier] = STATE(367),
    [sym_macro_type_specifier] = STATE(367),
    [sym_class_specifier] = STATE(367),
    [sym_dependent_type] = STATE(367),
    [sym_reference_declarator] = STATE(50),
    [sym_template_type] = STATE(368),
    [sym_template_function] = STATE(50),
    [sym_destructor_name] = STATE(50),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(369),
    [aux_sym__declaration_specifiers_repeat1] = STATE(370),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(425),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(647),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(649),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(647),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_COLON_COLON] = ACTIONS(651),
    [sym_operator_name] = ACTIONS(111),
  },
  [1024] = {
    [sym_preproc_include] = STATE(1800),
    [sym_preproc_def] = STATE(1800),
    [sym_preproc_function_def] = STATE(1800),
    [sym_preproc_call] = STATE(1800),
    [sym_preproc_if] = STATE(1800),
    [sym_preproc_ifdef] = STATE(1800),
    [sym_preproc_else] = STATE(1799),
    [sym_preproc_elif] = STATE(1799),
    [sym_function_definition] = STATE(1800),
    [sym_declaration] = STATE(1800),
    [sym_type_definition] = STATE(1800),
    [sym__declaration_specifiers] = STATE(409),
    [sym_linkage_specification] = STATE(1800),
    [sym__declarator] = STATE(50),
    [sym_pointer_declarator] = STATE(50),
    [sym_function_declarator] = STATE(410),
    [sym_array_declarator] = STATE(50),
    [sym_compound_statement] = STATE(1800),
    [sym_storage_class_specifier] = STATE(414),
    [sym_type_qualifier] = STATE(414),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(1800),
    [sym_expression_statement] = STATE(1800),
    [sym_if_statement] = STATE(1800),
    [sym_switch_statement] = STATE(1800),
    [sym_case_statement] = STATE(1800),
    [sym_while_statement] = STATE(1800),
    [sym_do_statement] = STATE(1800),
    [sym_for_statement] = STATE(1800),
    [sym_return_statement] = STATE(1800),
    [sym_break_statement] = STATE(1800),
    [sym_continue_statement] = STATE(1800),
    [sym_goto_statement] = STATE(1800),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(1800),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(1800),
    [sym_template_declaration] = STATE(1800),
    [sym_template_instantiation] = STATE(1800),
    [sym_constructor_or_destructor_definition] = STATE(1800),
    [sym_reference_declarator] = STATE(50),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(57),
    [sym_namespace_definition] = STATE(1800),
    [sym_using_declaration] = STATE(1800),
    [sym_alias_declaration] = STATE(1800),
    [sym_for_range_loop] = STATE(1800),
    [sym_try_statement] = STATE(1800),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_destructor_name] = STATE(50),
    [sym_scoped_identifier] = STATE(59),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_translation_unit_repeat1] = STATE(1800),
    [aux_sym__declaration_specifiers_repeat1] = STATE(414),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(678),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(684),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3793),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(688),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(688),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(690),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(692),
    [sym_preproc_directive] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_typedef] = ACTIONS(698),
    [anon_sym_extern] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(704),
    [anon_sym_switch] = ACTIONS(706),
    [anon_sym_case] = ACTIONS(708),
    [anon_sym_default] = ACTIONS(710),
    [anon_sym_while] = ACTIONS(712),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(728),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_template] = ACTIONS(730),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_namespace] = ACTIONS(732),
    [anon_sym_using] = ACTIONS(734),
    [anon_sym_try] = ACTIONS(736),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_operator_name] = ACTIONS(111),
    [sym_nullptr] = ACTIONS(726),
  },
  [1025] = {
    [sym_raw_string_literal] = ACTIONS(740),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(742),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(742),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(742),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(742),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(742),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(742),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(742),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(742),
    [sym_preproc_directive] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(740),
    [anon_sym_typedef] = ACTIONS(742),
    [anon_sym_extern] = ACTIONS(742),
    [anon_sym_LBRACE] = ACTIONS(740),
    [anon_sym_LPAREN2] = ACTIONS(740),
    [anon_sym_STAR] = ACTIONS(740),
    [anon_sym_LBRACK] = ACTIONS(740),
    [anon_sym_static] = ACTIONS(742),
    [anon_sym_register] = ACTIONS(742),
    [anon_sym_inline] = ACTIONS(742),
    [anon_sym_const] = ACTIONS(742),
    [anon_sym_restrict] = ACTIONS(742),
    [anon_sym_volatile] = ACTIONS(742),
    [anon_sym__Atomic] = ACTIONS(742),
    [anon_sym_mutable] = ACTIONS(742),
    [anon_sym_explicit] = ACTIONS(742),
    [anon_sym_constexpr] = ACTIONS(742),
    [anon_sym_unsigned] = ACTIONS(742),
    [anon_sym_long] = ACTIONS(742),
    [anon_sym_short] = ACTIONS(742),
    [sym_primitive_type] = ACTIONS(742),
    [anon_sym_enum] = ACTIONS(742),
    [anon_sym_struct] = ACTIONS(742),
    [anon_sym_union] = ACTIONS(742),
    [anon_sym_if] = ACTIONS(742),
    [anon_sym_switch] = ACTIONS(742),
    [anon_sym_case] = ACTIONS(742),
    [anon_sym_default] = ACTIONS(742),
    [anon_sym_while] = ACTIONS(742),
    [anon_sym_do] = ACTIONS(742),
    [anon_sym_for] = ACTIONS(742),
    [anon_sym_return] = ACTIONS(742),
    [anon_sym_break] = ACTIONS(742),
    [anon_sym_continue] = ACTIONS(742),
    [anon_sym_goto] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_AMP_AMP] = ACTIONS(740),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(742),
    [anon_sym_DASH] = ACTIONS(742),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_sizeof] = ACTIONS(742),
    [sym_number_literal] = ACTIONS(740),
    [anon_sym_SQUOTE] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(740),
    [sym_true] = ACTIONS(742),
    [sym_false] = ACTIONS(742),
    [sym_null] = ACTIONS(742),
    [sym_identifier] = ACTIONS(742),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(742),
    [sym_auto] = ACTIONS(742),
    [anon_sym_typename] = ACTIONS(742),
    [anon_sym_template] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(742),
    [anon_sym_namespace] = ACTIONS(742),
    [anon_sym_using] = ACTIONS(742),
    [anon_sym_try] = ACTIONS(742),
    [anon_sym_new] = ACTIONS(742),
    [anon_sym_COLON_COLON] = ACTIONS(740),
    [sym_operator_name] = ACTIONS(740),
    [sym_nullptr] = ACTIONS(742),
  },
  [1026] = {
    [anon_sym_LF] = ACTIONS(3795),
    [sym_comment] = ACTIONS(121),
  },
  [1027] = {
    [sym__type_declarator] = STATE(1802),
    [sym_pointer_type_declarator] = STATE(1802),
    [sym_function_type_declarator] = STATE(1802),
    [sym_array_type_declarator] = STATE(1802),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_STAR] = ACTIONS(768),
    [sym_identifier] = ACTIONS(770),
    [sym_comment] = ACTIONS(91),
  },
  [1028] = {
    [sym_type_qualifier] = STATE(453),
    [sym__type_specifier] = STATE(1803),
    [sym_sized_type_specifier] = STATE(1803),
    [sym_enum_specifier] = STATE(1803),
    [sym_struct_specifier] = STATE(1803),
    [sym_union_specifier] = STATE(1803),
    [sym_macro_type_specifier] = STATE(1803),
    [sym_class_specifier] = STATE(1803),
    [sym_dependent_type] = STATE(1803),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(82),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_type_definition_repeat1] = STATE(453),
    [aux_sym_sized_type_specifier_repeat1] = STATE(85),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(135),
    [anon_sym_long] = ACTIONS(135),
    [anon_sym_short] = ACTIONS(135),
    [sym_primitive_type] = ACTIONS(3797),
    [anon_sym_enum] = ACTIONS(139),
    [anon_sym_struct] = ACTIONS(141),
    [anon_sym_union] = ACTIONS(143),
    [sym_identifier] = ACTIONS(145),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(147),
    [sym_auto] = ACTIONS(3797),
    [anon_sym_typename] = ACTIONS(149),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [1029] = {
    [sym_function_definition] = STATE(1804),
    [sym_declaration] = STATE(1804),
    [sym__declaration_specifiers] = STATE(1805),
    [sym_declaration_list] = STATE(1804),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(272),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(180),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(2116),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [sym_identifier] = ACTIONS(492),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_COLON_COLON] = ACTIONS(315),
  },
  [1030] = {
    [sym_raw_string_literal] = ACTIONS(801),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(803),
    [sym_preproc_directive] = ACTIONS(803),
    [anon_sym_SEMI] = ACTIONS(801),
    [anon_sym_typedef] = ACTIONS(803),
    [anon_sym_extern] = ACTIONS(803),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(801),
    [anon_sym_LBRACK] = ACTIONS(801),
    [anon_sym_static] = ACTIONS(803),
    [anon_sym_register] = ACTIONS(803),
    [anon_sym_inline] = ACTIONS(803),
    [anon_sym_const] = ACTIONS(803),
    [anon_sym_restrict] = ACTIONS(803),
    [anon_sym_volatile] = ACTIONS(803),
    [anon_sym__Atomic] = ACTIONS(803),
    [anon_sym_mutable] = ACTIONS(803),
    [anon_sym_explicit] = ACTIONS(803),
    [anon_sym_constexpr] = ACTIONS(803),
    [anon_sym_unsigned] = ACTIONS(803),
    [anon_sym_long] = ACTIONS(803),
    [anon_sym_short] = ACTIONS(803),
    [sym_primitive_type] = ACTIONS(803),
    [anon_sym_enum] = ACTIONS(803),
    [anon_sym_struct] = ACTIONS(803),
    [anon_sym_union] = ACTIONS(803),
    [anon_sym_if] = ACTIONS(803),
    [anon_sym_else] = ACTIONS(803),
    [anon_sym_switch] = ACTIONS(803),
    [anon_sym_case] = ACTIONS(803),
    [anon_sym_default] = ACTIONS(803),
    [anon_sym_while] = ACTIONS(803),
    [anon_sym_do] = ACTIONS(803),
    [anon_sym_for] = ACTIONS(803),
    [anon_sym_return] = ACTIONS(803),
    [anon_sym_break] = ACTIONS(803),
    [anon_sym_continue] = ACTIONS(803),
    [anon_sym_goto] = ACTIONS(803),
    [anon_sym_AMP] = ACTIONS(803),
    [anon_sym_AMP_AMP] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_DASH] = ACTIONS(803),
    [anon_sym_DASH_DASH] = ACTIONS(801),
    [anon_sym_PLUS_PLUS] = ACTIONS(801),
    [anon_sym_sizeof] = ACTIONS(803),
    [sym_number_literal] = ACTIONS(801),
    [anon_sym_SQUOTE] = ACTIONS(801),
    [anon_sym_DQUOTE] = ACTIONS(801),
    [sym_true] = ACTIONS(803),
    [sym_false] = ACTIONS(803),
    [sym_null] = ACTIONS(803),
    [sym_identifier] = ACTIONS(803),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(803),
    [sym_auto] = ACTIONS(803),
    [anon_sym_typename] = ACTIONS(803),
    [anon_sym_template] = ACTIONS(803),
    [anon_sym_delete] = ACTIONS(803),
    [anon_sym_namespace] = ACTIONS(803),
    [anon_sym_using] = ACTIONS(803),
    [anon_sym_try] = ACTIONS(803),
    [anon_sym_catch] = ACTIONS(803),
    [anon_sym_new] = ACTIONS(803),
    [anon_sym_COLON_COLON] = ACTIONS(801),
    [sym_operator_name] = ACTIONS(801),
    [sym_nullptr] = ACTIONS(803),
  },
  [1031] = {
    [sym_preproc_include] = STATE(496),
    [sym_preproc_def] = STATE(496),
    [sym_preproc_function_def] = STATE(496),
    [sym_preproc_call] = STATE(496),
    [sym_preproc_if_in_compound_statement] = STATE(496),
    [sym_preproc_ifdef_in_compound_statement] = STATE(496),
    [sym_declaration] = STATE(496),
    [sym_type_definition] = STATE(496),
    [sym__declaration_specifiers] = STATE(113),
    [sym_compound_statement] = STATE(496),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(496),
    [sym_expression_statement] = STATE(496),
    [sym_if_statement] = STATE(496),
    [sym_switch_statement] = STATE(496),
    [sym_case_statement] = STATE(496),
    [sym_while_statement] = STATE(496),
    [sym_do_statement] = STATE(496),
    [sym_for_statement] = STATE(496),
    [sym_return_statement] = STATE(496),
    [sym_break_statement] = STATE(496),
    [sym_continue_statement] = STATE(496),
    [sym_goto_statement] = STATE(496),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(496),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(496),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(496),
    [sym_try_statement] = STATE(496),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(496),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(157),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(159),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(161),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(163),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(165),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(165),
    [sym_preproc_directive] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_typedef] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_RBRACE] = ACTIONS(3799),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(185),
    [anon_sym_case] = ACTIONS(187),
    [anon_sym_default] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(209),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_nullptr] = ACTIONS(207),
  },
  [1032] = {
    [sym__expression] = STATE(1807),
    [sym_conditional_expression] = STATE(1807),
    [sym_assignment_expression] = STATE(1807),
    [sym_pointer_expression] = STATE(1807),
    [sym_logical_expression] = STATE(1807),
    [sym_bitwise_expression] = STATE(1807),
    [sym_equality_expression] = STATE(1807),
    [sym_relational_expression] = STATE(1807),
    [sym_shift_expression] = STATE(1807),
    [sym_math_expression] = STATE(1807),
    [sym_cast_expression] = STATE(1807),
    [sym_sizeof_expression] = STATE(1807),
    [sym_subscript_expression] = STATE(1807),
    [sym_call_expression] = STATE(1807),
    [sym_field_expression] = STATE(1807),
    [sym_compound_literal_expression] = STATE(1807),
    [sym_parenthesized_expression] = STATE(1807),
    [sym_char_literal] = STATE(1807),
    [sym_concatenated_string] = STATE(1807),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1807),
    [sym_new_expression] = STATE(1807),
    [sym_delete_expression] = STATE(1807),
    [sym_lambda_expression] = STATE(1807),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3801),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(3801),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(3803),
    [sym_false] = ACTIONS(3803),
    [sym_null] = ACTIONS(3803),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(3803),
  },
  [1033] = {
    [anon_sym_LPAREN2] = ACTIONS(3805),
    [sym_comment] = ACTIONS(91),
  },
  [1034] = {
    [sym_compound_statement] = STATE(1810),
    [sym_labeled_statement] = STATE(1810),
    [sym_expression_statement] = STATE(1810),
    [sym_if_statement] = STATE(1810),
    [sym_switch_statement] = STATE(1810),
    [sym_case_statement] = STATE(1810),
    [sym_while_statement] = STATE(1810),
    [sym_do_statement] = STATE(1810),
    [sym_for_statement] = STATE(1810),
    [sym_return_statement] = STATE(1810),
    [sym_break_statement] = STATE(1810),
    [sym_continue_statement] = STATE(1810),
    [sym_goto_statement] = STATE(1810),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(411),
    [sym_for_range_loop] = STATE(1810),
    [sym_try_statement] = STATE(1810),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(678),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(704),
    [anon_sym_switch] = ACTIONS(706),
    [anon_sym_case] = ACTIONS(708),
    [anon_sym_default] = ACTIONS(710),
    [anon_sym_while] = ACTIONS(712),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(3807),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(736),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(726),
  },
  [1035] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_COLON] = ACTIONS(3809),
    [anon_sym_QMARK] = ACTIONS(1171),
    [anon_sym_STAR_EQ] = ACTIONS(1173),
    [anon_sym_SLASH_EQ] = ACTIONS(1173),
    [anon_sym_PERCENT_EQ] = ACTIONS(1173),
    [anon_sym_PLUS_EQ] = ACTIONS(1173),
    [anon_sym_DASH_EQ] = ACTIONS(1173),
    [anon_sym_LT_LT_EQ] = ACTIONS(1173),
    [anon_sym_GT_GT_EQ] = ACTIONS(1173),
    [anon_sym_AMP_EQ] = ACTIONS(1173),
    [anon_sym_CARET_EQ] = ACTIONS(1173),
    [anon_sym_PIPE_EQ] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_CARET] = ACTIONS(1183),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [1036] = {
    [sym_declaration] = STATE(1813),
    [sym_type_definition] = STATE(1813),
    [sym__declaration_specifiers] = STATE(1814),
    [sym_compound_statement] = STATE(1813),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_labeled_statement] = STATE(1813),
    [sym_expression_statement] = STATE(1813),
    [sym_if_statement] = STATE(1813),
    [sym_switch_statement] = STATE(1813),
    [sym_case_statement] = STATE(1813),
    [sym_while_statement] = STATE(1813),
    [sym_do_statement] = STATE(1813),
    [sym_for_statement] = STATE(1813),
    [sym_return_statement] = STATE(1813),
    [sym_break_statement] = STATE(1813),
    [sym_continue_statement] = STATE(1813),
    [sym_goto_statement] = STATE(1813),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(411),
    [sym_for_range_loop] = STATE(1813),
    [sym_try_statement] = STATE(1813),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(678),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_typedef] = ACTIONS(698),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(704),
    [anon_sym_switch] = ACTIONS(706),
    [anon_sym_case] = ACTIONS(708),
    [anon_sym_default] = ACTIONS(710),
    [anon_sym_while] = ACTIONS(712),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(3811),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(736),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(1202),
    [sym_nullptr] = ACTIONS(726),
  },
  [1037] = {
    [sym_compound_statement] = STATE(1815),
    [sym_labeled_statement] = STATE(1815),
    [sym_expression_statement] = STATE(1815),
    [sym_if_statement] = STATE(1815),
    [sym_switch_statement] = STATE(1815),
    [sym_case_statement] = STATE(1815),
    [sym_while_statement] = STATE(1815),
    [sym_do_statement] = STATE(1815),
    [sym_for_statement] = STATE(1815),
    [sym_return_statement] = STATE(1815),
    [sym_break_statement] = STATE(1815),
    [sym_continue_statement] = STATE(1815),
    [sym_goto_statement] = STATE(1815),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(411),
    [sym_for_range_loop] = STATE(1815),
    [sym_try_statement] = STATE(1815),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(678),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(704),
    [anon_sym_switch] = ACTIONS(706),
    [anon_sym_case] = ACTIONS(708),
    [anon_sym_default] = ACTIONS(710),
    [anon_sym_while] = ACTIONS(712),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(3807),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(736),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(726),
  },
  [1038] = {
    [anon_sym_while] = ACTIONS(3813),
    [sym_comment] = ACTIONS(91),
  },
  [1039] = {
    [sym_declaration] = STATE(1817),
    [sym__declaration_specifiers] = STATE(709),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym__expression] = STATE(1818),
    [sym_conditional_expression] = STATE(1818),
    [sym_assignment_expression] = STATE(1818),
    [sym_pointer_expression] = STATE(1818),
    [sym_logical_expression] = STATE(1818),
    [sym_bitwise_expression] = STATE(1818),
    [sym_equality_expression] = STATE(1818),
    [sym_relational_expression] = STATE(1818),
    [sym_shift_expression] = STATE(1818),
    [sym_math_expression] = STATE(1818),
    [sym_cast_expression] = STATE(1818),
    [sym_sizeof_expression] = STATE(1818),
    [sym_subscript_expression] = STATE(1818),
    [sym_call_expression] = STATE(1818),
    [sym_field_expression] = STATE(1818),
    [sym_compound_literal_expression] = STATE(1818),
    [sym_parenthesized_expression] = STATE(1818),
    [sym_char_literal] = STATE(1818),
    [sym_concatenated_string] = STATE(1818),
    [sym_string_literal] = STATE(238),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(1818),
    [sym_for_range_declaration] = STATE(1819),
    [sym_new_expression] = STATE(1818),
    [sym_delete_expression] = STATE(1818),
    [sym_lambda_expression] = STATE(1818),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(3815),
    [anon_sym_SEMI] = ACTIONS(3817),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(3815),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(3819),
    [sym_false] = ACTIONS(3819),
    [sym_null] = ACTIONS(3819),
    [sym_identifier] = ACTIONS(1242),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(1244),
    [sym_nullptr] = ACTIONS(3819),
  },
  [1040] = {
    [sym_raw_string_literal] = ACTIONS(1246),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1248),
    [sym_preproc_directive] = ACTIONS(1248),
    [anon_sym_SEMI] = ACTIONS(1246),
    [anon_sym_typedef] = ACTIONS(1248),
    [anon_sym_extern] = ACTIONS(1248),
    [anon_sym_LBRACE] = ACTIONS(1246),
    [anon_sym_LPAREN2] = ACTIONS(1246),
    [anon_sym_STAR] = ACTIONS(1246),
    [anon_sym_LBRACK] = ACTIONS(1246),
    [anon_sym_static] = ACTIONS(1248),
    [anon_sym_register] = ACTIONS(1248),
    [anon_sym_inline] = ACTIONS(1248),
    [anon_sym_const] = ACTIONS(1248),
    [anon_sym_restrict] = ACTIONS(1248),
    [anon_sym_volatile] = ACTIONS(1248),
    [anon_sym__Atomic] = ACTIONS(1248),
    [anon_sym_mutable] = ACTIONS(1248),
    [anon_sym_explicit] = ACTIONS(1248),
    [anon_sym_constexpr] = ACTIONS(1248),
    [anon_sym_unsigned] = ACTIONS(1248),
    [anon_sym_long] = ACTIONS(1248),
    [anon_sym_short] = ACTIONS(1248),
    [sym_primitive_type] = ACTIONS(1248),
    [anon_sym_enum] = ACTIONS(1248),
    [anon_sym_struct] = ACTIONS(1248),
    [anon_sym_union] = ACTIONS(1248),
    [anon_sym_if] = ACTIONS(1248),
    [anon_sym_else] = ACTIONS(1248),
    [anon_sym_switch] = ACTIONS(1248),
    [anon_sym_case] = ACTIONS(1248),
    [anon_sym_default] = ACTIONS(1248),
    [anon_sym_while] = ACTIONS(1248),
    [anon_sym_do] = ACTIONS(1248),
    [anon_sym_for] = ACTIONS(1248),
    [anon_sym_return] = ACTIONS(1248),
    [anon_sym_break] = ACTIONS(1248),
    [anon_sym_continue] = ACTIONS(1248),
    [anon_sym_goto] = ACTIONS(1248),
    [anon_sym_AMP] = ACTIONS(1248),
    [anon_sym_AMP_AMP] = ACTIONS(1246),
    [anon_sym_BANG] = ACTIONS(1246),
    [anon_sym_TILDE] = ACTIONS(1246),
    [anon_sym_PLUS] = ACTIONS(1248),
    [anon_sym_DASH] = ACTIONS(1248),
    [anon_sym_DASH_DASH] = ACTIONS(1246),
    [anon_sym_PLUS_PLUS] = ACTIONS(1246),
    [anon_sym_sizeof] = ACTIONS(1248),
    [sym_number_literal] = ACTIONS(1246),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [anon_sym_DQUOTE] = ACTIONS(1246),
    [sym_true] = ACTIONS(1248),
    [sym_false] = ACTIONS(1248),
    [sym_null] = ACTIONS(1248),
    [sym_identifier] = ACTIONS(1248),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1248),
    [sym_auto] = ACTIONS(1248),
    [anon_sym_typename] = ACTIONS(1248),
    [anon_sym_template] = ACTIONS(1248),
    [anon_sym_delete] = ACTIONS(1248),
    [anon_sym_namespace] = ACTIONS(1248),
    [anon_sym_using] = ACTIONS(1248),
    [anon_sym_try] = ACTIONS(1248),
    [anon_sym_new] = ACTIONS(1248),
    [anon_sym_COLON_COLON] = ACTIONS(1246),
    [sym_operator_name] = ACTIONS(1246),
    [sym_nullptr] = ACTIONS(1248),
  },
  [1041] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(3821),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1042] = {
    [anon_sym_SEMI] = ACTIONS(3821),
    [sym_comment] = ACTIONS(91),
  },
  [1043] = {
    [sym_raw_string_literal] = ACTIONS(1332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1334),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1334),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1334),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1334),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1334),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1334),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1334),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1334),
    [sym_preproc_directive] = ACTIONS(1334),
    [anon_sym_SEMI] = ACTIONS(1332),
    [anon_sym_typedef] = ACTIONS(1334),
    [anon_sym_extern] = ACTIONS(1334),
    [anon_sym_LBRACE] = ACTIONS(1332),
    [anon_sym_LPAREN2] = ACTIONS(1332),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_LBRACK] = ACTIONS(1332),
    [anon_sym_static] = ACTIONS(1334),
    [anon_sym_register] = ACTIONS(1334),
    [anon_sym_inline] = ACTIONS(1334),
    [anon_sym_const] = ACTIONS(1334),
    [anon_sym_restrict] = ACTIONS(1334),
    [anon_sym_volatile] = ACTIONS(1334),
    [anon_sym__Atomic] = ACTIONS(1334),
    [anon_sym_mutable] = ACTIONS(1334),
    [anon_sym_explicit] = ACTIONS(1334),
    [anon_sym_constexpr] = ACTIONS(1334),
    [anon_sym_unsigned] = ACTIONS(1334),
    [anon_sym_long] = ACTIONS(1334),
    [anon_sym_short] = ACTIONS(1334),
    [sym_primitive_type] = ACTIONS(1334),
    [anon_sym_enum] = ACTIONS(1334),
    [anon_sym_struct] = ACTIONS(1334),
    [anon_sym_union] = ACTIONS(1334),
    [anon_sym_if] = ACTIONS(1334),
    [anon_sym_else] = ACTIONS(1334),
    [anon_sym_switch] = ACTIONS(1334),
    [anon_sym_case] = ACTIONS(1334),
    [anon_sym_default] = ACTIONS(1334),
    [anon_sym_while] = ACTIONS(1334),
    [anon_sym_do] = ACTIONS(1334),
    [anon_sym_for] = ACTIONS(1334),
    [anon_sym_return] = ACTIONS(1334),
    [anon_sym_break] = ACTIONS(1334),
    [anon_sym_continue] = ACTIONS(1334),
    [anon_sym_goto] = ACTIONS(1334),
    [anon_sym_AMP] = ACTIONS(1334),
    [anon_sym_AMP_AMP] = ACTIONS(1332),
    [anon_sym_BANG] = ACTIONS(1332),
    [anon_sym_TILDE] = ACTIONS(1332),
    [anon_sym_PLUS] = ACTIONS(1334),
    [anon_sym_DASH] = ACTIONS(1334),
    [anon_sym_DASH_DASH] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(1332),
    [anon_sym_sizeof] = ACTIONS(1334),
    [sym_number_literal] = ACTIONS(1332),
    [anon_sym_SQUOTE] = ACTIONS(1332),
    [anon_sym_DQUOTE] = ACTIONS(1332),
    [sym_true] = ACTIONS(1334),
    [sym_false] = ACTIONS(1334),
    [sym_null] = ACTIONS(1334),
    [sym_identifier] = ACTIONS(1334),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1334),
    [sym_auto] = ACTIONS(1334),
    [anon_sym_typename] = ACTIONS(1334),
    [anon_sym_template] = ACTIONS(1334),
    [anon_sym_delete] = ACTIONS(1334),
    [anon_sym_namespace] = ACTIONS(1334),
    [anon_sym_using] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1334),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_COLON_COLON] = ACTIONS(1332),
    [sym_operator_name] = ACTIONS(1332),
    [sym_nullptr] = ACTIONS(1334),
  },
  [1044] = {
    [sym_raw_string_literal] = ACTIONS(1336),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1338),
    [sym_preproc_directive] = ACTIONS(1338),
    [anon_sym_SEMI] = ACTIONS(1336),
    [anon_sym_typedef] = ACTIONS(1338),
    [anon_sym_extern] = ACTIONS(1338),
    [anon_sym_LBRACE] = ACTIONS(1336),
    [anon_sym_LPAREN2] = ACTIONS(1336),
    [anon_sym_STAR] = ACTIONS(1336),
    [anon_sym_LBRACK] = ACTIONS(1336),
    [anon_sym_static] = ACTIONS(1338),
    [anon_sym_register] = ACTIONS(1338),
    [anon_sym_inline] = ACTIONS(1338),
    [anon_sym_const] = ACTIONS(1338),
    [anon_sym_restrict] = ACTIONS(1338),
    [anon_sym_volatile] = ACTIONS(1338),
    [anon_sym__Atomic] = ACTIONS(1338),
    [anon_sym_mutable] = ACTIONS(1338),
    [anon_sym_explicit] = ACTIONS(1338),
    [anon_sym_constexpr] = ACTIONS(1338),
    [anon_sym_unsigned] = ACTIONS(1338),
    [anon_sym_long] = ACTIONS(1338),
    [anon_sym_short] = ACTIONS(1338),
    [sym_primitive_type] = ACTIONS(1338),
    [anon_sym_enum] = ACTIONS(1338),
    [anon_sym_struct] = ACTIONS(1338),
    [anon_sym_union] = ACTIONS(1338),
    [anon_sym_if] = ACTIONS(1338),
    [anon_sym_else] = ACTIONS(1338),
    [anon_sym_switch] = ACTIONS(1338),
    [anon_sym_case] = ACTIONS(1338),
    [anon_sym_default] = ACTIONS(1338),
    [anon_sym_while] = ACTIONS(1338),
    [anon_sym_do] = ACTIONS(1338),
    [anon_sym_for] = ACTIONS(1338),
    [anon_sym_return] = ACTIONS(1338),
    [anon_sym_break] = ACTIONS(1338),
    [anon_sym_continue] = ACTIONS(1338),
    [anon_sym_goto] = ACTIONS(1338),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_AMP_AMP] = ACTIONS(1336),
    [anon_sym_BANG] = ACTIONS(1336),
    [anon_sym_TILDE] = ACTIONS(1336),
    [anon_sym_PLUS] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_DASH_DASH] = ACTIONS(1336),
    [anon_sym_PLUS_PLUS] = ACTIONS(1336),
    [anon_sym_sizeof] = ACTIONS(1338),
    [sym_number_literal] = ACTIONS(1336),
    [anon_sym_SQUOTE] = ACTIONS(1336),
    [anon_sym_DQUOTE] = ACTIONS(1336),
    [sym_true] = ACTIONS(1338),
    [sym_false] = ACTIONS(1338),
    [sym_null] = ACTIONS(1338),
    [sym_identifier] = ACTIONS(1338),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1338),
    [sym_auto] = ACTIONS(1338),
    [anon_sym_typename] = ACTIONS(1338),
    [anon_sym_template] = ACTIONS(1338),
    [anon_sym_delete] = ACTIONS(1338),
    [anon_sym_namespace] = ACTIONS(1338),
    [anon_sym_using] = ACTIONS(1338),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_new] = ACTIONS(1338),
    [anon_sym_COLON_COLON] = ACTIONS(1336),
    [sym_operator_name] = ACTIONS(1336),
    [sym_nullptr] = ACTIONS(1338),
  },
  [1045] = {
    [anon_sym_SEMI] = ACTIONS(3823),
    [sym_comment] = ACTIONS(91),
  },
  [1046] = {
    [sym_compound_statement] = STATE(1822),
    [sym_labeled_statement] = STATE(1822),
    [sym_expression_statement] = STATE(1822),
    [sym_if_statement] = STATE(1822),
    [sym_switch_statement] = STATE(1822),
    [sym_case_statement] = STATE(1822),
    [sym_while_statement] = STATE(1822),
    [sym_do_statement] = STATE(1822),
    [sym_for_statement] = STATE(1822),
    [sym_return_statement] = STATE(1822),
    [sym_break_statement] = STATE(1822),
    [sym_continue_statement] = STATE(1822),
    [sym_goto_statement] = STATE(1822),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(411),
    [sym_for_range_loop] = STATE(1822),
    [sym_try_statement] = STATE(1822),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(678),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(704),
    [anon_sym_switch] = ACTIONS(706),
    [anon_sym_case] = ACTIONS(708),
    [anon_sym_default] = ACTIONS(710),
    [anon_sym_while] = ACTIONS(712),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(3807),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(736),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(726),
  },
  [1047] = {
    [sym__declarator] = STATE(1823),
    [sym_pointer_declarator] = STATE(1823),
    [sym_function_declarator] = STATE(1823),
    [sym_array_declarator] = STATE(1823),
    [sym_reference_declarator] = STATE(1823),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(1823),
    [sym_destructor_name] = STATE(1823),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(494),
    [anon_sym_AMP] = ACTIONS(500),
    [anon_sym_AMP_AMP] = ACTIONS(502),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(431),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(3825),
  },
  [1048] = {
    [sym_parameter_list] = STATE(812),
    [anon_sym_SEMI] = ACTIONS(3827),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(574),
    [sym_comment] = ACTIONS(91),
  },
  [1049] = {
    [sym_function_definition] = STATE(1825),
    [sym_declaration] = STATE(1825),
    [sym__declaration_specifiers] = STATE(1826),
    [sym_storage_class_specifier] = STATE(818),
    [sym_type_qualifier] = STATE(818),
    [sym__type_specifier] = STATE(817),
    [sym_sized_type_specifier] = STATE(817),
    [sym_enum_specifier] = STATE(817),
    [sym_struct_specifier] = STATE(817),
    [sym_union_specifier] = STATE(817),
    [sym__empty_declaration] = STATE(1825),
    [sym_macro_type_specifier] = STATE(817),
    [sym_class_specifier] = STATE(817),
    [sym_dependent_type] = STATE(817),
    [sym_template_type] = STATE(272),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(180),
    [aux_sym__declaration_specifiers_repeat1] = STATE(818),
    [aux_sym_sized_type_specifier_repeat1] = STATE(819),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(1475),
    [anon_sym_long] = ACTIONS(1475),
    [anon_sym_short] = ACTIONS(1475),
    [sym_primitive_type] = ACTIONS(1477),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [sym_identifier] = ACTIONS(492),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(1477),
    [anon_sym_typename] = ACTIONS(1479),
    [anon_sym_COLON_COLON] = ACTIONS(315),
  },
  [1050] = {
    [sym_preproc_include] = STATE(1828),
    [sym_preproc_def] = STATE(1828),
    [sym_preproc_function_def] = STATE(1828),
    [sym_preproc_call] = STATE(1828),
    [sym_preproc_if] = STATE(1828),
    [sym_preproc_ifdef] = STATE(1828),
    [sym_function_definition] = STATE(1828),
    [sym_declaration] = STATE(1828),
    [sym_type_definition] = STATE(1828),
    [sym__declaration_specifiers] = STATE(49),
    [sym_linkage_specification] = STATE(1828),
    [sym__declarator] = STATE(50),
    [sym_pointer_declarator] = STATE(50),
    [sym_function_declarator] = STATE(51),
    [sym_array_declarator] = STATE(50),
    [sym_compound_statement] = STATE(1828),
    [sym_storage_class_specifier] = STATE(63),
    [sym_type_qualifier] = STATE(63),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(1828),
    [sym_expression_statement] = STATE(1828),
    [sym_if_statement] = STATE(1828),
    [sym_switch_statement] = STATE(1828),
    [sym_case_statement] = STATE(1828),
    [sym_while_statement] = STATE(1828),
    [sym_do_statement] = STATE(1828),
    [sym_for_statement] = STATE(1828),
    [sym_return_statement] = STATE(1828),
    [sym_break_statement] = STATE(1828),
    [sym_continue_statement] = STATE(1828),
    [sym_goto_statement] = STATE(1828),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(1828),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(1828),
    [sym_template_declaration] = STATE(1828),
    [sym_template_instantiation] = STATE(1828),
    [sym_constructor_or_destructor_definition] = STATE(1828),
    [sym_reference_declarator] = STATE(50),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(57),
    [sym_namespace_definition] = STATE(1828),
    [sym_using_declaration] = STATE(1828),
    [sym_alias_declaration] = STATE(1828),
    [sym_for_range_loop] = STATE(1828),
    [sym_try_statement] = STATE(1828),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_destructor_name] = STATE(50),
    [sym_scoped_identifier] = STATE(59),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_translation_unit_repeat1] = STATE(1828),
    [aux_sym__declaration_specifiers_repeat1] = STATE(63),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(5),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(9),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(13),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(15),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(15),
    [sym_preproc_directive] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_RBRACE] = ACTIONS(3829),
    [anon_sym_LPAREN2] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(1495),
    [anon_sym_switch] = ACTIONS(1497),
    [anon_sym_case] = ACTIONS(1499),
    [anon_sym_default] = ACTIONS(1501),
    [anon_sym_while] = ACTIONS(1503),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(1505),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(1507),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_template] = ACTIONS(97),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_namespace] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(103),
    [anon_sym_try] = ACTIONS(1509),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_operator_name] = ACTIONS(111),
    [sym_nullptr] = ACTIONS(87),
  },
  [1051] = {
    [sym_declaration_list] = STATE(1829),
    [anon_sym_LBRACE] = ACTIONS(2116),
    [sym_comment] = ACTIONS(91),
  },
  [1052] = {
    [sym_raw_string_literal] = ACTIONS(1511),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1513),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1513),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1513),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1513),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1513),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1513),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1513),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1513),
    [sym_preproc_directive] = ACTIONS(1513),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_typedef] = ACTIONS(1513),
    [anon_sym_extern] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_LPAREN2] = ACTIONS(1511),
    [anon_sym_STAR] = ACTIONS(1511),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_static] = ACTIONS(1513),
    [anon_sym_register] = ACTIONS(1513),
    [anon_sym_inline] = ACTIONS(1513),
    [anon_sym_const] = ACTIONS(1513),
    [anon_sym_restrict] = ACTIONS(1513),
    [anon_sym_volatile] = ACTIONS(1513),
    [anon_sym__Atomic] = ACTIONS(1513),
    [anon_sym_mutable] = ACTIONS(1513),
    [anon_sym_explicit] = ACTIONS(1513),
    [anon_sym_constexpr] = ACTIONS(1513),
    [anon_sym_unsigned] = ACTIONS(1513),
    [anon_sym_long] = ACTIONS(1513),
    [anon_sym_short] = ACTIONS(1513),
    [sym_primitive_type] = ACTIONS(1513),
    [anon_sym_enum] = ACTIONS(1513),
    [anon_sym_struct] = ACTIONS(1513),
    [anon_sym_union] = ACTIONS(1513),
    [anon_sym_if] = ACTIONS(1513),
    [anon_sym_switch] = ACTIONS(1513),
    [anon_sym_case] = ACTIONS(1513),
    [anon_sym_default] = ACTIONS(1513),
    [anon_sym_while] = ACTIONS(1513),
    [anon_sym_do] = ACTIONS(1513),
    [anon_sym_for] = ACTIONS(1513),
    [anon_sym_return] = ACTIONS(1513),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_continue] = ACTIONS(1513),
    [anon_sym_goto] = ACTIONS(1513),
    [anon_sym_AMP] = ACTIONS(1513),
    [anon_sym_AMP_AMP] = ACTIONS(1511),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_DASH_DASH] = ACTIONS(1511),
    [anon_sym_PLUS_PLUS] = ACTIONS(1511),
    [anon_sym_sizeof] = ACTIONS(1513),
    [sym_number_literal] = ACTIONS(1511),
    [anon_sym_SQUOTE] = ACTIONS(1511),
    [anon_sym_DQUOTE] = ACTIONS(1511),
    [sym_true] = ACTIONS(1513),
    [sym_false] = ACTIONS(1513),
    [sym_null] = ACTIONS(1513),
    [sym_identifier] = ACTIONS(1513),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1513),
    [sym_auto] = ACTIONS(1513),
    [anon_sym_typename] = ACTIONS(1513),
    [anon_sym_template] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_namespace] = ACTIONS(1513),
    [anon_sym_using] = ACTIONS(1513),
    [anon_sym_try] = ACTIONS(1513),
    [anon_sym_new] = ACTIONS(1513),
    [anon_sym_COLON_COLON] = ACTIONS(1511),
    [sym_operator_name] = ACTIONS(1511),
    [sym_nullptr] = ACTIONS(1513),
  },
  [1053] = {
    [sym_template_argument_list] = STATE(437),
    [anon_sym_SEMI] = ACTIONS(3831),
    [anon_sym_EQ] = ACTIONS(3833),
    [anon_sym_LT] = ACTIONS(945),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1519),
  },
  [1054] = {
    [sym_template_type] = STATE(296),
    [sym_scoped_identifier] = STATE(1833),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(296),
    [sym_identifier] = ACTIONS(3835),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(528),
  },
  [1055] = {
    [anon_sym_SEMI] = ACTIONS(3831),
    [sym_comment] = ACTIONS(91),
  },
  [1056] = {
    [sym_catch_clause] = STATE(1835),
    [aux_sym_try_statement_repeat1] = STATE(1835),
    [sym_comment] = ACTIONS(91),
    [anon_sym_catch] = ACTIONS(3837),
  },
  [1057] = {
    [sym_raw_string_literal] = ACTIONS(3839),
    [ts_builtin_sym_end] = ACTIONS(3839),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3841),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3841),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3841),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3841),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3841),
    [sym_preproc_directive] = ACTIONS(3841),
    [anon_sym_SEMI] = ACTIONS(3839),
    [anon_sym_typedef] = ACTIONS(3841),
    [anon_sym_extern] = ACTIONS(3841),
    [anon_sym_LBRACE] = ACTIONS(3839),
    [anon_sym_RBRACE] = ACTIONS(3839),
    [anon_sym_LPAREN2] = ACTIONS(3839),
    [anon_sym_STAR] = ACTIONS(3839),
    [anon_sym_LBRACK] = ACTIONS(3839),
    [anon_sym_static] = ACTIONS(3841),
    [anon_sym_register] = ACTIONS(3841),
    [anon_sym_inline] = ACTIONS(3841),
    [anon_sym_const] = ACTIONS(3841),
    [anon_sym_restrict] = ACTIONS(3841),
    [anon_sym_volatile] = ACTIONS(3841),
    [anon_sym__Atomic] = ACTIONS(3841),
    [anon_sym_mutable] = ACTIONS(3841),
    [anon_sym_explicit] = ACTIONS(3841),
    [anon_sym_constexpr] = ACTIONS(3841),
    [anon_sym_unsigned] = ACTIONS(3841),
    [anon_sym_long] = ACTIONS(3841),
    [anon_sym_short] = ACTIONS(3841),
    [sym_primitive_type] = ACTIONS(3841),
    [anon_sym_enum] = ACTIONS(3841),
    [anon_sym_struct] = ACTIONS(3841),
    [anon_sym_union] = ACTIONS(3841),
    [anon_sym_if] = ACTIONS(3841),
    [anon_sym_switch] = ACTIONS(3841),
    [anon_sym_case] = ACTIONS(3841),
    [anon_sym_default] = ACTIONS(3841),
    [anon_sym_while] = ACTIONS(3841),
    [anon_sym_do] = ACTIONS(3841),
    [anon_sym_for] = ACTIONS(3841),
    [anon_sym_return] = ACTIONS(3841),
    [anon_sym_break] = ACTIONS(3841),
    [anon_sym_continue] = ACTIONS(3841),
    [anon_sym_goto] = ACTIONS(3841),
    [anon_sym_AMP] = ACTIONS(3841),
    [anon_sym_AMP_AMP] = ACTIONS(3839),
    [anon_sym_BANG] = ACTIONS(3839),
    [anon_sym_TILDE] = ACTIONS(3839),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_DASH_DASH] = ACTIONS(3839),
    [anon_sym_PLUS_PLUS] = ACTIONS(3839),
    [anon_sym_sizeof] = ACTIONS(3841),
    [sym_number_literal] = ACTIONS(3839),
    [anon_sym_SQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(3839),
    [sym_true] = ACTIONS(3841),
    [sym_false] = ACTIONS(3841),
    [sym_null] = ACTIONS(3841),
    [sym_identifier] = ACTIONS(3841),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3841),
    [sym_auto] = ACTIONS(3841),
    [anon_sym_typename] = ACTIONS(3841),
    [anon_sym_template] = ACTIONS(3841),
    [anon_sym_delete] = ACTIONS(3841),
    [anon_sym_namespace] = ACTIONS(3841),
    [anon_sym_using] = ACTIONS(3841),
    [anon_sym_try] = ACTIONS(3841),
    [anon_sym_new] = ACTIONS(3841),
    [anon_sym_COLON_COLON] = ACTIONS(3839),
    [sym_operator_name] = ACTIONS(3839),
    [sym_nullptr] = ACTIONS(3841),
  },
  [1058] = {
    [sym_raw_string_literal] = ACTIONS(1597),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1599),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1599),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1599),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1599),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1599),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1599),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1599),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1599),
    [sym_preproc_directive] = ACTIONS(1599),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_typedef] = ACTIONS(1599),
    [anon_sym_extern] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1597),
    [anon_sym_LPAREN2] = ACTIONS(1597),
    [anon_sym_STAR] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_static] = ACTIONS(1599),
    [anon_sym_register] = ACTIONS(1599),
    [anon_sym_inline] = ACTIONS(1599),
    [anon_sym_const] = ACTIONS(1599),
    [anon_sym_restrict] = ACTIONS(1599),
    [anon_sym_volatile] = ACTIONS(1599),
    [anon_sym__Atomic] = ACTIONS(1599),
    [anon_sym_mutable] = ACTIONS(1599),
    [anon_sym_explicit] = ACTIONS(1599),
    [anon_sym_constexpr] = ACTIONS(1599),
    [anon_sym_unsigned] = ACTIONS(1599),
    [anon_sym_long] = ACTIONS(1599),
    [anon_sym_short] = ACTIONS(1599),
    [sym_primitive_type] = ACTIONS(1599),
    [anon_sym_enum] = ACTIONS(1599),
    [anon_sym_struct] = ACTIONS(1599),
    [anon_sym_union] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(1599),
    [anon_sym_switch] = ACTIONS(1599),
    [anon_sym_case] = ACTIONS(1599),
    [anon_sym_default] = ACTIONS(1599),
    [anon_sym_while] = ACTIONS(1599),
    [anon_sym_do] = ACTIONS(1599),
    [anon_sym_for] = ACTIONS(1599),
    [anon_sym_return] = ACTIONS(1599),
    [anon_sym_break] = ACTIONS(1599),
    [anon_sym_continue] = ACTIONS(1599),
    [anon_sym_goto] = ACTIONS(1599),
    [anon_sym_AMP] = ACTIONS(1599),
    [anon_sym_AMP_AMP] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1597),
    [anon_sym_TILDE] = ACTIONS(1597),
    [anon_sym_PLUS] = ACTIONS(1599),
    [anon_sym_DASH] = ACTIONS(1599),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_sizeof] = ACTIONS(1599),
    [sym_number_literal] = ACTIONS(1597),
    [anon_sym_SQUOTE] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1597),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_null] = ACTIONS(1599),
    [sym_identifier] = ACTIONS(1599),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1599),
    [sym_auto] = ACTIONS(1599),
    [anon_sym_typename] = ACTIONS(1599),
    [anon_sym_template] = ACTIONS(1599),
    [anon_sym_delete] = ACTIONS(1599),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_using] = ACTIONS(1599),
    [anon_sym_try] = ACTIONS(1599),
    [anon_sym_new] = ACTIONS(1599),
    [anon_sym_COLON_COLON] = ACTIONS(1597),
    [sym_operator_name] = ACTIONS(1597),
    [sym_nullptr] = ACTIONS(1599),
  },
  [1059] = {
    [sym_compound_statement] = STATE(1838),
    [sym_parameter_list] = STATE(897),
    [sym_argument_list] = STATE(898),
    [sym_initializer_list] = STATE(898),
    [aux_sym_declaration_repeat1] = STATE(1839),
    [anon_sym_COMMA] = ACTIONS(1613),
    [anon_sym_SEMI] = ACTIONS(3843),
    [anon_sym_LBRACE] = ACTIONS(3845),
    [anon_sym_LPAREN2] = ACTIONS(1619),
    [anon_sym_LBRACK] = ACTIONS(574),
    [anon_sym_EQ] = ACTIONS(1621),
    [sym_comment] = ACTIONS(91),
  },
  [1060] = {
    [aux_sym_declaration_repeat1] = STATE(1839),
    [anon_sym_COMMA] = ACTIONS(1613),
    [anon_sym_SEMI] = ACTIONS(3843),
    [sym_comment] = ACTIONS(91),
  },
  [1061] = {
    [sym_argument_list] = STATE(1841),
    [sym_initializer_list] = STATE(1841),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(3847),
    [sym_comment] = ACTIONS(91),
  },
  [1062] = {
    [anon_sym_default] = ACTIONS(3849),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(3851),
  },
  [1063] = {
    [sym_raw_string_literal] = ACTIONS(1685),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1687),
    [sym_preproc_directive] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1685),
    [anon_sym_typedef] = ACTIONS(1687),
    [anon_sym_extern] = ACTIONS(1687),
    [anon_sym_LBRACE] = ACTIONS(1685),
    [anon_sym_LPAREN2] = ACTIONS(1685),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_LBRACK] = ACTIONS(1685),
    [anon_sym_static] = ACTIONS(1687),
    [anon_sym_register] = ACTIONS(1687),
    [anon_sym_inline] = ACTIONS(1687),
    [anon_sym_const] = ACTIONS(1687),
    [anon_sym_restrict] = ACTIONS(1687),
    [anon_sym_volatile] = ACTIONS(1687),
    [anon_sym__Atomic] = ACTIONS(1687),
    [anon_sym_mutable] = ACTIONS(1687),
    [anon_sym_explicit] = ACTIONS(1687),
    [anon_sym_constexpr] = ACTIONS(1687),
    [anon_sym_unsigned] = ACTIONS(1687),
    [anon_sym_long] = ACTIONS(1687),
    [anon_sym_short] = ACTIONS(1687),
    [sym_primitive_type] = ACTIONS(1687),
    [anon_sym_enum] = ACTIONS(1687),
    [anon_sym_struct] = ACTIONS(1687),
    [anon_sym_union] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1687),
    [anon_sym_switch] = ACTIONS(1687),
    [anon_sym_case] = ACTIONS(1687),
    [anon_sym_default] = ACTIONS(1687),
    [anon_sym_while] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1687),
    [anon_sym_for] = ACTIONS(1687),
    [anon_sym_return] = ACTIONS(1687),
    [anon_sym_break] = ACTIONS(1687),
    [anon_sym_continue] = ACTIONS(1687),
    [anon_sym_goto] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_BANG] = ACTIONS(1685),
    [anon_sym_TILDE] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_DASH] = ACTIONS(1687),
    [anon_sym_DASH_DASH] = ACTIONS(1685),
    [anon_sym_PLUS_PLUS] = ACTIONS(1685),
    [anon_sym_sizeof] = ACTIONS(1687),
    [sym_number_literal] = ACTIONS(1685),
    [anon_sym_SQUOTE] = ACTIONS(1685),
    [anon_sym_DQUOTE] = ACTIONS(1685),
    [sym_true] = ACTIONS(1687),
    [sym_false] = ACTIONS(1687),
    [sym_null] = ACTIONS(1687),
    [sym_identifier] = ACTIONS(1687),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1687),
    [sym_auto] = ACTIONS(1687),
    [anon_sym_typename] = ACTIONS(1687),
    [anon_sym_template] = ACTIONS(1687),
    [anon_sym_delete] = ACTIONS(1687),
    [anon_sym_namespace] = ACTIONS(1687),
    [anon_sym_using] = ACTIONS(1687),
    [anon_sym_try] = ACTIONS(1687),
    [anon_sym_new] = ACTIONS(1687),
    [anon_sym_COLON_COLON] = ACTIONS(1685),
    [sym_operator_name] = ACTIONS(1685),
    [sym_nullptr] = ACTIONS(1687),
  },
  [1064] = {
    [sym_compound_statement] = STATE(1844),
    [sym_default_method_clause] = STATE(1844),
    [sym_delete_method_clause] = STATE(1844),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_EQ] = ACTIONS(2130),
    [sym_comment] = ACTIONS(91),
  },
  [1065] = {
    [sym_raw_string_literal] = ACTIONS(1697),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1699),
    [sym_preproc_directive] = ACTIONS(1699),
    [anon_sym_SEMI] = ACTIONS(1697),
    [anon_sym_typedef] = ACTIONS(1699),
    [anon_sym_extern] = ACTIONS(1699),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_LPAREN2] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1697),
    [anon_sym_LBRACK] = ACTIONS(1697),
    [anon_sym_static] = ACTIONS(1699),
    [anon_sym_register] = ACTIONS(1699),
    [anon_sym_inline] = ACTIONS(1699),
    [anon_sym_const] = ACTIONS(1699),
    [anon_sym_restrict] = ACTIONS(1699),
    [anon_sym_volatile] = ACTIONS(1699),
    [anon_sym__Atomic] = ACTIONS(1699),
    [anon_sym_mutable] = ACTIONS(1699),
    [anon_sym_explicit] = ACTIONS(1699),
    [anon_sym_constexpr] = ACTIONS(1699),
    [anon_sym_unsigned] = ACTIONS(1699),
    [anon_sym_long] = ACTIONS(1699),
    [anon_sym_short] = ACTIONS(1699),
    [sym_primitive_type] = ACTIONS(1699),
    [anon_sym_enum] = ACTIONS(1699),
    [anon_sym_struct] = ACTIONS(1699),
    [anon_sym_union] = ACTIONS(1699),
    [anon_sym_if] = ACTIONS(1699),
    [anon_sym_else] = ACTIONS(1699),
    [anon_sym_switch] = ACTIONS(1699),
    [anon_sym_case] = ACTIONS(1699),
    [anon_sym_default] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(1699),
    [anon_sym_do] = ACTIONS(1699),
    [anon_sym_for] = ACTIONS(1699),
    [anon_sym_return] = ACTIONS(1699),
    [anon_sym_break] = ACTIONS(1699),
    [anon_sym_continue] = ACTIONS(1699),
    [anon_sym_goto] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_AMP_AMP] = ACTIONS(1697),
    [anon_sym_BANG] = ACTIONS(1697),
    [anon_sym_TILDE] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1697),
    [anon_sym_PLUS_PLUS] = ACTIONS(1697),
    [anon_sym_sizeof] = ACTIONS(1699),
    [sym_number_literal] = ACTIONS(1697),
    [anon_sym_SQUOTE] = ACTIONS(1697),
    [anon_sym_DQUOTE] = ACTIONS(1697),
    [sym_true] = ACTIONS(1699),
    [sym_false] = ACTIONS(1699),
    [sym_null] = ACTIONS(1699),
    [sym_identifier] = ACTIONS(1699),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1699),
    [sym_auto] = ACTIONS(1699),
    [anon_sym_typename] = ACTIONS(1699),
    [anon_sym_template] = ACTIONS(1699),
    [anon_sym_delete] = ACTIONS(1699),
    [anon_sym_namespace] = ACTIONS(1699),
    [anon_sym_using] = ACTIONS(1699),
    [anon_sym_try] = ACTIONS(1699),
    [anon_sym_new] = ACTIONS(1699),
    [anon_sym_COLON_COLON] = ACTIONS(1697),
    [sym_operator_name] = ACTIONS(1697),
    [sym_nullptr] = ACTIONS(1699),
  },
  [1066] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3853),
    [sym_comment] = ACTIONS(91),
  },
  [1067] = {
    [sym_preproc_include] = STATE(1067),
    [sym_preproc_def] = STATE(1067),
    [sym_preproc_function_def] = STATE(1067),
    [sym_preproc_call] = STATE(1067),
    [sym_preproc_if] = STATE(1067),
    [sym_preproc_ifdef] = STATE(1067),
    [sym_function_definition] = STATE(1067),
    [sym_declaration] = STATE(1067),
    [sym_type_definition] = STATE(1067),
    [sym__declaration_specifiers] = STATE(409),
    [sym_linkage_specification] = STATE(1067),
    [sym__declarator] = STATE(50),
    [sym_pointer_declarator] = STATE(50),
    [sym_function_declarator] = STATE(410),
    [sym_array_declarator] = STATE(50),
    [sym_compound_statement] = STATE(1067),
    [sym_storage_class_specifier] = STATE(414),
    [sym_type_qualifier] = STATE(414),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(1067),
    [sym_expression_statement] = STATE(1067),
    [sym_if_statement] = STATE(1067),
    [sym_switch_statement] = STATE(1067),
    [sym_case_statement] = STATE(1067),
    [sym_while_statement] = STATE(1067),
    [sym_do_statement] = STATE(1067),
    [sym_for_statement] = STATE(1067),
    [sym_return_statement] = STATE(1067),
    [sym_break_statement] = STATE(1067),
    [sym_continue_statement] = STATE(1067),
    [sym_goto_statement] = STATE(1067),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(1067),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(1067),
    [sym_template_declaration] = STATE(1067),
    [sym_template_instantiation] = STATE(1067),
    [sym_constructor_or_destructor_definition] = STATE(1067),
    [sym_reference_declarator] = STATE(50),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(57),
    [sym_namespace_definition] = STATE(1067),
    [sym_using_declaration] = STATE(1067),
    [sym_alias_declaration] = STATE(1067),
    [sym_for_range_loop] = STATE(1067),
    [sym_try_statement] = STATE(1067),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_destructor_name] = STATE(50),
    [sym_scoped_identifier] = STATE(59),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_translation_unit_repeat1] = STATE(1067),
    [aux_sym__declaration_specifiers_repeat1] = STATE(414),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(3855),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3858),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3861),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3864),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3867),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3867),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3867),
    [sym_preproc_directive] = ACTIONS(3872),
    [anon_sym_SEMI] = ACTIONS(3875),
    [anon_sym_typedef] = ACTIONS(3878),
    [anon_sym_extern] = ACTIONS(3881),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_LPAREN2] = ACTIONS(1835),
    [anon_sym_STAR] = ACTIONS(1838),
    [anon_sym_LBRACK] = ACTIONS(1841),
    [anon_sym_static] = ACTIONS(1844),
    [anon_sym_register] = ACTIONS(1844),
    [anon_sym_inline] = ACTIONS(1844),
    [anon_sym_const] = ACTIONS(1847),
    [anon_sym_restrict] = ACTIONS(1847),
    [anon_sym_volatile] = ACTIONS(1847),
    [anon_sym__Atomic] = ACTIONS(1847),
    [anon_sym_mutable] = ACTIONS(1847),
    [anon_sym_explicit] = ACTIONS(1847),
    [anon_sym_constexpr] = ACTIONS(1847),
    [anon_sym_unsigned] = ACTIONS(1850),
    [anon_sym_long] = ACTIONS(1850),
    [anon_sym_short] = ACTIONS(1850),
    [sym_primitive_type] = ACTIONS(1853),
    [anon_sym_enum] = ACTIONS(1856),
    [anon_sym_struct] = ACTIONS(1859),
    [anon_sym_union] = ACTIONS(1862),
    [anon_sym_if] = ACTIONS(3887),
    [anon_sym_switch] = ACTIONS(3890),
    [anon_sym_case] = ACTIONS(3893),
    [anon_sym_default] = ACTIONS(3896),
    [anon_sym_while] = ACTIONS(3899),
    [anon_sym_do] = ACTIONS(3902),
    [anon_sym_for] = ACTIONS(3905),
    [anon_sym_return] = ACTIONS(3908),
    [anon_sym_break] = ACTIONS(3911),
    [anon_sym_continue] = ACTIONS(3914),
    [anon_sym_goto] = ACTIONS(3917),
    [anon_sym_AMP] = ACTIONS(1898),
    [anon_sym_AMP_AMP] = ACTIONS(1901),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1907),
    [anon_sym_PLUS] = ACTIONS(1910),
    [anon_sym_DASH] = ACTIONS(1910),
    [anon_sym_DASH_DASH] = ACTIONS(1913),
    [anon_sym_PLUS_PLUS] = ACTIONS(1913),
    [anon_sym_sizeof] = ACTIONS(1916),
    [sym_number_literal] = ACTIONS(3855),
    [anon_sym_SQUOTE] = ACTIONS(1919),
    [anon_sym_DQUOTE] = ACTIONS(1922),
    [sym_true] = ACTIONS(3920),
    [sym_false] = ACTIONS(3920),
    [sym_null] = ACTIONS(3920),
    [sym_identifier] = ACTIONS(3923),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1931),
    [sym_auto] = ACTIONS(1853),
    [anon_sym_typename] = ACTIONS(1934),
    [anon_sym_template] = ACTIONS(3926),
    [anon_sym_delete] = ACTIONS(1940),
    [anon_sym_namespace] = ACTIONS(3929),
    [anon_sym_using] = ACTIONS(3932),
    [anon_sym_try] = ACTIONS(3935),
    [anon_sym_new] = ACTIONS(1952),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [sym_operator_name] = ACTIONS(1958),
    [sym_nullptr] = ACTIONS(3920),
  },
  [1068] = {
    [sym_compound_statement] = STATE(1844),
    [sym_field_initializer_list] = STATE(1846),
    [sym_default_method_clause] = STATE(1844),
    [sym_delete_method_clause] = STATE(1844),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(576),
    [anon_sym_LBRACK] = ACTIONS(576),
    [anon_sym_EQ] = ACTIONS(2130),
    [anon_sym_COLON] = ACTIONS(580),
    [sym_comment] = ACTIONS(91),
  },
  [1069] = {
    [sym_raw_string_literal] = ACTIONS(3938),
    [ts_builtin_sym_end] = ACTIONS(3938),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3940),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3940),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3940),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3940),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3940),
    [sym_preproc_directive] = ACTIONS(3940),
    [anon_sym_SEMI] = ACTIONS(3938),
    [anon_sym_typedef] = ACTIONS(3940),
    [anon_sym_extern] = ACTIONS(3940),
    [anon_sym_LBRACE] = ACTIONS(3938),
    [anon_sym_RBRACE] = ACTIONS(3938),
    [anon_sym_LPAREN2] = ACTIONS(3938),
    [anon_sym_STAR] = ACTIONS(3938),
    [anon_sym_LBRACK] = ACTIONS(3938),
    [anon_sym_static] = ACTIONS(3940),
    [anon_sym_register] = ACTIONS(3940),
    [anon_sym_inline] = ACTIONS(3940),
    [anon_sym_const] = ACTIONS(3940),
    [anon_sym_restrict] = ACTIONS(3940),
    [anon_sym_volatile] = ACTIONS(3940),
    [anon_sym__Atomic] = ACTIONS(3940),
    [anon_sym_mutable] = ACTIONS(3940),
    [anon_sym_explicit] = ACTIONS(3940),
    [anon_sym_constexpr] = ACTIONS(3940),
    [anon_sym_unsigned] = ACTIONS(3940),
    [anon_sym_long] = ACTIONS(3940),
    [anon_sym_short] = ACTIONS(3940),
    [sym_primitive_type] = ACTIONS(3940),
    [anon_sym_enum] = ACTIONS(3940),
    [anon_sym_struct] = ACTIONS(3940),
    [anon_sym_union] = ACTIONS(3940),
    [anon_sym_if] = ACTIONS(3940),
    [anon_sym_switch] = ACTIONS(3940),
    [anon_sym_case] = ACTIONS(3940),
    [anon_sym_default] = ACTIONS(3940),
    [anon_sym_while] = ACTIONS(3940),
    [anon_sym_do] = ACTIONS(3940),
    [anon_sym_for] = ACTIONS(3940),
    [anon_sym_return] = ACTIONS(3940),
    [anon_sym_break] = ACTIONS(3940),
    [anon_sym_continue] = ACTIONS(3940),
    [anon_sym_goto] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3940),
    [anon_sym_AMP_AMP] = ACTIONS(3938),
    [anon_sym_BANG] = ACTIONS(3938),
    [anon_sym_TILDE] = ACTIONS(3938),
    [anon_sym_PLUS] = ACTIONS(3940),
    [anon_sym_DASH] = ACTIONS(3940),
    [anon_sym_DASH_DASH] = ACTIONS(3938),
    [anon_sym_PLUS_PLUS] = ACTIONS(3938),
    [anon_sym_sizeof] = ACTIONS(3940),
    [sym_number_literal] = ACTIONS(3938),
    [anon_sym_SQUOTE] = ACTIONS(3938),
    [anon_sym_DQUOTE] = ACTIONS(3938),
    [sym_true] = ACTIONS(3940),
    [sym_false] = ACTIONS(3940),
    [sym_null] = ACTIONS(3940),
    [sym_identifier] = ACTIONS(3940),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3940),
    [sym_auto] = ACTIONS(3940),
    [anon_sym_typename] = ACTIONS(3940),
    [anon_sym_template] = ACTIONS(3940),
    [anon_sym_delete] = ACTIONS(3940),
    [anon_sym_namespace] = ACTIONS(3940),
    [anon_sym_using] = ACTIONS(3940),
    [anon_sym_try] = ACTIONS(3940),
    [anon_sym_new] = ACTIONS(3940),
    [anon_sym_COLON_COLON] = ACTIONS(3938),
    [sym_operator_name] = ACTIONS(3938),
    [sym_nullptr] = ACTIONS(3940),
  },
  [1070] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3942),
    [sym_comment] = ACTIONS(91),
  },
  [1071] = {
    [anon_sym_RBRACE] = ACTIONS(3944),
    [sym_comment] = ACTIONS(91),
  },
  [1072] = {
    [anon_sym_COMMA] = ACTIONS(2613),
    [anon_sym_SEMI] = ACTIONS(2613),
    [anon_sym_LBRACE] = ACTIONS(2613),
    [anon_sym_LPAREN2] = ACTIONS(2613),
    [anon_sym_STAR] = ACTIONS(2613),
    [anon_sym_LBRACK] = ACTIONS(2613),
    [anon_sym_EQ] = ACTIONS(2613),
    [anon_sym_const] = ACTIONS(2615),
    [anon_sym_restrict] = ACTIONS(2615),
    [anon_sym_volatile] = ACTIONS(2615),
    [anon_sym__Atomic] = ACTIONS(2615),
    [anon_sym_mutable] = ACTIONS(2615),
    [anon_sym_explicit] = ACTIONS(2615),
    [anon_sym_constexpr] = ACTIONS(2615),
    [anon_sym_COLON] = ACTIONS(2613),
    [anon_sym_AMP] = ACTIONS(2615),
    [anon_sym_AMP_AMP] = ACTIONS(2613),
    [anon_sym_DASH_GT] = ACTIONS(2613),
    [sym_identifier] = ACTIONS(2615),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2615),
    [anon_sym_override] = ACTIONS(2615),
    [sym_noexcept] = ACTIONS(2615),
  },
  [1073] = {
    [aux_sym_enumerator_list_repeat1] = STATE(1850),
    [anon_sym_COMMA] = ACTIONS(3946),
    [anon_sym_RBRACE] = ACTIONS(3944),
    [sym_comment] = ACTIONS(91),
  },
  [1074] = {
    [anon_sym_COMMA] = ACTIONS(2623),
    [anon_sym_SEMI] = ACTIONS(2623),
    [anon_sym_LBRACE] = ACTIONS(2623),
    [anon_sym_LPAREN2] = ACTIONS(2623),
    [anon_sym_STAR] = ACTIONS(2623),
    [anon_sym_LBRACK] = ACTIONS(2623),
    [anon_sym_EQ] = ACTIONS(2623),
    [anon_sym_const] = ACTIONS(2625),
    [anon_sym_restrict] = ACTIONS(2625),
    [anon_sym_volatile] = ACTIONS(2625),
    [anon_sym__Atomic] = ACTIONS(2625),
    [anon_sym_mutable] = ACTIONS(2625),
    [anon_sym_explicit] = ACTIONS(2625),
    [anon_sym_constexpr] = ACTIONS(2625),
    [anon_sym_COLON] = ACTIONS(2623),
    [anon_sym_AMP] = ACTIONS(2625),
    [anon_sym_AMP_AMP] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2623),
    [sym_identifier] = ACTIONS(2625),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2625),
    [anon_sym_override] = ACTIONS(2625),
    [sym_noexcept] = ACTIONS(2625),
  },
  [1075] = {
    [anon_sym_COMMA] = ACTIONS(2633),
    [anon_sym_SEMI] = ACTIONS(2633),
    [anon_sym_LBRACE] = ACTIONS(2633),
    [anon_sym_LPAREN2] = ACTIONS(2633),
    [anon_sym_STAR] = ACTIONS(2633),
    [anon_sym_LBRACK] = ACTIONS(2633),
    [anon_sym_EQ] = ACTIONS(2633),
    [anon_sym_const] = ACTIONS(2635),
    [anon_sym_restrict] = ACTIONS(2635),
    [anon_sym_volatile] = ACTIONS(2635),
    [anon_sym__Atomic] = ACTIONS(2635),
    [anon_sym_mutable] = ACTIONS(2635),
    [anon_sym_explicit] = ACTIONS(2635),
    [anon_sym_constexpr] = ACTIONS(2635),
    [anon_sym_COLON] = ACTIONS(2633),
    [anon_sym_AMP] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(2633),
    [sym_identifier] = ACTIONS(2635),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2635),
    [anon_sym_override] = ACTIONS(2635),
    [sym_noexcept] = ACTIONS(2635),
  },
  [1076] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(1276),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1276),
    [sym_type_definition] = STATE(1276),
    [sym__declaration_specifiers] = STATE(598),
    [sym__declarator] = STATE(599),
    [sym_pointer_declarator] = STATE(599),
    [sym_function_declarator] = STATE(600),
    [sym_array_declarator] = STATE(599),
    [sym_storage_class_specifier] = STATE(605),
    [sym_type_qualifier] = STATE(605),
    [sym__type_specifier] = STATE(601),
    [sym_sized_type_specifier] = STATE(601),
    [sym_enum_specifier] = STATE(601),
    [sym_struct_specifier] = STATE(601),
    [sym_union_specifier] = STATE(601),
    [sym__field_declaration_list_item] = STATE(1276),
    [sym_field_declaration] = STATE(1276),
    [sym_macro_type_specifier] = STATE(601),
    [sym_class_specifier] = STATE(601),
    [sym_dependent_type] = STATE(601),
    [sym_template_declaration] = STATE(1276),
    [sym_inline_method_definition] = STATE(1276),
    [sym_constructor_or_destructor_definition] = STATE(1276),
    [sym_constructor_or_destructor_declaration] = STATE(1276),
    [sym_friend_declaration] = STATE(1276),
    [sym_access_specifier] = STATE(1276),
    [sym_reference_declarator] = STATE(599),
    [sym_template_type] = STATE(602),
    [sym_template_function] = STATE(599),
    [sym_using_declaration] = STATE(1276),
    [sym_alias_declaration] = STATE(1276),
    [sym_destructor_name] = STATE(599),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(603),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1276),
    [aux_sym__declaration_specifiers_repeat1] = STATE(605),
    [aux_sym_sized_type_specifier_repeat1] = STATE(606),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1019),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1021),
    [anon_sym_typedef] = ACTIONS(1023),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(3948),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(425),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(1027),
    [anon_sym_long] = ACTIONS(1027),
    [anon_sym_short] = ACTIONS(1027),
    [sym_primitive_type] = ACTIONS(1029),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(1031),
    [anon_sym_union] = ACTIONS(1033),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(1035),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1039),
    [sym_auto] = ACTIONS(1029),
    [anon_sym_typename] = ACTIONS(1041),
    [anon_sym_template] = ACTIONS(1043),
    [anon_sym_friend] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1039),
    [anon_sym_protected] = ACTIONS(1039),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_COLON_COLON] = ACTIONS(1049),
    [sym_operator_name] = ACTIONS(1051),
  },
  [1077] = {
    [anon_sym_COMMA] = ACTIONS(2693),
    [anon_sym_SEMI] = ACTIONS(2693),
    [anon_sym_LBRACE] = ACTIONS(2693),
    [anon_sym_LPAREN2] = ACTIONS(2693),
    [anon_sym_STAR] = ACTIONS(2693),
    [anon_sym_LBRACK] = ACTIONS(2693),
    [anon_sym_EQ] = ACTIONS(2693),
    [anon_sym_const] = ACTIONS(2695),
    [anon_sym_restrict] = ACTIONS(2695),
    [anon_sym_volatile] = ACTIONS(2695),
    [anon_sym__Atomic] = ACTIONS(2695),
    [anon_sym_mutable] = ACTIONS(2695),
    [anon_sym_explicit] = ACTIONS(2695),
    [anon_sym_constexpr] = ACTIONS(2695),
    [anon_sym_COLON] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(2695),
    [anon_sym_AMP_AMP] = ACTIONS(2693),
    [anon_sym_DASH_GT] = ACTIONS(2693),
    [sym_identifier] = ACTIONS(2695),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2695),
    [anon_sym_override] = ACTIONS(2695),
    [sym_noexcept] = ACTIONS(2695),
  },
  [1078] = {
    [sym_field_declaration_list] = STATE(1852),
    [sym_base_class_clause] = STATE(1853),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_COLON] = ACTIONS(1073),
    [sym_comment] = ACTIONS(91),
  },
  [1079] = {
    [sym_field_declaration_list] = STATE(1852),
    [anon_sym_LBRACE] = ACTIONS(750),
    [sym_comment] = ACTIONS(91),
  },
  [1080] = {
    [anon_sym_COMMA] = ACTIONS(2697),
    [anon_sym_SEMI] = ACTIONS(2697),
    [anon_sym_LBRACE] = ACTIONS(2697),
    [anon_sym_LPAREN2] = ACTIONS(2697),
    [anon_sym_STAR] = ACTIONS(2697),
    [anon_sym_LBRACK] = ACTIONS(2697),
    [anon_sym_EQ] = ACTIONS(2697),
    [anon_sym_const] = ACTIONS(2699),
    [anon_sym_restrict] = ACTIONS(2699),
    [anon_sym_volatile] = ACTIONS(2699),
    [anon_sym__Atomic] = ACTIONS(2699),
    [anon_sym_mutable] = ACTIONS(2699),
    [anon_sym_explicit] = ACTIONS(2699),
    [anon_sym_constexpr] = ACTIONS(2699),
    [anon_sym_COLON] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2699),
    [anon_sym_AMP_AMP] = ACTIONS(2697),
    [anon_sym_DASH_GT] = ACTIONS(2697),
    [sym_identifier] = ACTIONS(2699),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2699),
    [anon_sym_override] = ACTIONS(2699),
    [sym_noexcept] = ACTIONS(2699),
  },
  [1081] = {
    [sym_field_declaration_list] = STATE(1854),
    [anon_sym_LBRACE] = ACTIONS(750),
    [sym_comment] = ACTIONS(91),
  },
  [1082] = {
    [sym_field_declaration_list] = STATE(1854),
    [sym_base_class_clause] = STATE(1855),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_COLON] = ACTIONS(1073),
    [sym_comment] = ACTIONS(91),
  },
  [1083] = {
    [anon_sym_COMMA] = ACTIONS(2703),
    [anon_sym_SEMI] = ACTIONS(2703),
    [anon_sym_LBRACE] = ACTIONS(2703),
    [anon_sym_LPAREN2] = ACTIONS(2703),
    [anon_sym_STAR] = ACTIONS(2703),
    [anon_sym_LBRACK] = ACTIONS(2703),
    [anon_sym_EQ] = ACTIONS(2703),
    [anon_sym_const] = ACTIONS(2705),
    [anon_sym_restrict] = ACTIONS(2705),
    [anon_sym_volatile] = ACTIONS(2705),
    [anon_sym__Atomic] = ACTIONS(2705),
    [anon_sym_mutable] = ACTIONS(2705),
    [anon_sym_explicit] = ACTIONS(2705),
    [anon_sym_constexpr] = ACTIONS(2705),
    [anon_sym_COLON] = ACTIONS(2703),
    [anon_sym_AMP] = ACTIONS(2705),
    [anon_sym_AMP_AMP] = ACTIONS(2703),
    [anon_sym_DASH_GT] = ACTIONS(2703),
    [sym_identifier] = ACTIONS(2705),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2705),
    [anon_sym_override] = ACTIONS(2705),
    [sym_noexcept] = ACTIONS(2705),
  },
  [1084] = {
    [sym_field_declaration_list] = STATE(1856),
    [sym_base_class_clause] = STATE(1857),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_COLON] = ACTIONS(1073),
    [sym_comment] = ACTIONS(91),
  },
  [1085] = {
    [sym_field_declaration_list] = STATE(1856),
    [anon_sym_LBRACE] = ACTIONS(750),
    [sym_comment] = ACTIONS(91),
  },
  [1086] = {
    [anon_sym_COMMA] = ACTIONS(2707),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LBRACE] = ACTIONS(2707),
    [anon_sym_LPAREN2] = ACTIONS(2707),
    [anon_sym_STAR] = ACTIONS(2707),
    [anon_sym_LBRACK] = ACTIONS(2707),
    [anon_sym_EQ] = ACTIONS(2707),
    [anon_sym_const] = ACTIONS(2709),
    [anon_sym_restrict] = ACTIONS(2709),
    [anon_sym_volatile] = ACTIONS(2709),
    [anon_sym__Atomic] = ACTIONS(2709),
    [anon_sym_mutable] = ACTIONS(2709),
    [anon_sym_explicit] = ACTIONS(2709),
    [anon_sym_constexpr] = ACTIONS(2709),
    [anon_sym_COLON] = ACTIONS(2707),
    [anon_sym_AMP] = ACTIONS(2709),
    [anon_sym_AMP_AMP] = ACTIONS(2707),
    [anon_sym_DASH_GT] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2709),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2709),
    [anon_sym_override] = ACTIONS(2709),
    [sym_noexcept] = ACTIONS(2709),
  },
  [1087] = {
    [sym_field_declaration_list] = STATE(1858),
    [anon_sym_LBRACE] = ACTIONS(750),
    [sym_comment] = ACTIONS(91),
  },
  [1088] = {
    [sym_field_declaration_list] = STATE(1858),
    [sym_base_class_clause] = STATE(1859),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_COLON] = ACTIONS(1073),
    [sym_comment] = ACTIONS(91),
  },
  [1089] = {
    [anon_sym_LBRACE] = ACTIONS(3121),
    [anon_sym_LPAREN2] = ACTIONS(3121),
    [anon_sym_STAR] = ACTIONS(3121),
    [anon_sym_COLON] = ACTIONS(3123),
    [sym_identifier] = ACTIONS(3123),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3123),
    [anon_sym_override] = ACTIONS(3123),
    [anon_sym_COLON_COLON] = ACTIONS(3121),
  },
  [1090] = {
    [sym_argument_list] = STATE(1511),
    [aux_sym_template_argument_list_repeat1] = STATE(1861),
    [anon_sym_COMMA] = ACTIONS(3163),
    [anon_sym_LPAREN2] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_EQ] = ACTIONS(3171),
    [anon_sym_QMARK] = ACTIONS(3173),
    [anon_sym_STAR_EQ] = ACTIONS(3175),
    [anon_sym_SLASH_EQ] = ACTIONS(3175),
    [anon_sym_PERCENT_EQ] = ACTIONS(3175),
    [anon_sym_PLUS_EQ] = ACTIONS(3175),
    [anon_sym_DASH_EQ] = ACTIONS(3175),
    [anon_sym_LT_LT_EQ] = ACTIONS(3175),
    [anon_sym_GT_GT_EQ] = ACTIONS(3175),
    [anon_sym_AMP_EQ] = ACTIONS(3175),
    [anon_sym_CARET_EQ] = ACTIONS(3175),
    [anon_sym_PIPE_EQ] = ACTIONS(3175),
    [anon_sym_AMP] = ACTIONS(3177),
    [anon_sym_PIPE_PIPE] = ACTIONS(3179),
    [anon_sym_AMP_AMP] = ACTIONS(3181),
    [anon_sym_PIPE] = ACTIONS(3183),
    [anon_sym_CARET] = ACTIONS(3185),
    [anon_sym_EQ_EQ] = ACTIONS(3187),
    [anon_sym_BANG_EQ] = ACTIONS(3187),
    [anon_sym_LT] = ACTIONS(3189),
    [anon_sym_GT] = ACTIONS(3189),
    [anon_sym_LT_EQ] = ACTIONS(3191),
    [anon_sym_GT_EQ] = ACTIONS(3191),
    [anon_sym_LT_LT] = ACTIONS(3193),
    [anon_sym_GT_GT] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_SLASH] = ACTIONS(3167),
    [anon_sym_PERCENT] = ACTIONS(3167),
    [anon_sym_DASH_DASH] = ACTIONS(3197),
    [anon_sym_PLUS_PLUS] = ACTIONS(3197),
    [anon_sym_DOT] = ACTIONS(3199),
    [anon_sym_DASH_GT] = ACTIONS(3199),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3950),
  },
  [1091] = {
    [aux_sym_template_argument_list_repeat1] = STATE(1863),
    [anon_sym_COMMA] = ACTIONS(3163),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3952),
  },
  [1092] = {
    [anon_sym_COMMA] = ACTIONS(3218),
    [anon_sym_RPAREN] = ACTIONS(3218),
    [anon_sym_SEMI] = ACTIONS(3218),
    [anon_sym_LBRACE] = ACTIONS(3218),
    [anon_sym_LPAREN2] = ACTIONS(3218),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_LBRACK] = ACTIONS(3218),
    [anon_sym_EQ] = ACTIONS(3218),
    [anon_sym_const] = ACTIONS(3216),
    [anon_sym_restrict] = ACTIONS(3216),
    [anon_sym_volatile] = ACTIONS(3216),
    [anon_sym__Atomic] = ACTIONS(3216),
    [anon_sym_mutable] = ACTIONS(3216),
    [anon_sym_explicit] = ACTIONS(3216),
    [anon_sym_constexpr] = ACTIONS(3216),
    [anon_sym_COLON] = ACTIONS(3216),
    [anon_sym_AMP] = ACTIONS(3216),
    [anon_sym_AMP_AMP] = ACTIONS(3218),
    [anon_sym_LT] = ACTIONS(3218),
    [anon_sym_DASH_GT] = ACTIONS(3218),
    [sym_identifier] = ACTIONS(3216),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3216),
    [anon_sym_override] = ACTIONS(3216),
    [anon_sym_GT2] = ACTIONS(3218),
    [sym_noexcept] = ACTIONS(3216),
    [anon_sym_COLON_COLON] = ACTIONS(3225),
  },
  [1093] = {
    [anon_sym_COMMA] = ACTIONS(3227),
    [anon_sym_SEMI] = ACTIONS(3227),
    [anon_sym_LBRACE] = ACTIONS(3227),
    [anon_sym_LPAREN2] = ACTIONS(3227),
    [anon_sym_STAR] = ACTIONS(3227),
    [anon_sym_LBRACK] = ACTIONS(3227),
    [anon_sym_EQ] = ACTIONS(3227),
    [anon_sym_const] = ACTIONS(3229),
    [anon_sym_restrict] = ACTIONS(3229),
    [anon_sym_volatile] = ACTIONS(3229),
    [anon_sym__Atomic] = ACTIONS(3229),
    [anon_sym_mutable] = ACTIONS(3229),
    [anon_sym_explicit] = ACTIONS(3229),
    [anon_sym_constexpr] = ACTIONS(3229),
    [anon_sym_COLON] = ACTIONS(3227),
    [anon_sym_AMP] = ACTIONS(3229),
    [anon_sym_AMP_AMP] = ACTIONS(3227),
    [anon_sym_DASH_GT] = ACTIONS(3227),
    [sym_identifier] = ACTIONS(3229),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3229),
    [anon_sym_override] = ACTIONS(3229),
    [sym_noexcept] = ACTIONS(3229),
  },
  [1094] = {
    [sym_field_declaration_list] = STATE(1864),
    [sym_base_class_clause] = STATE(1865),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_COLON] = ACTIONS(1073),
    [sym_comment] = ACTIONS(91),
  },
  [1095] = {
    [sym_field_declaration_list] = STATE(1864),
    [anon_sym_LBRACE] = ACTIONS(750),
    [sym_comment] = ACTIONS(91),
  },
  [1096] = {
    [anon_sym_COMMA] = ACTIONS(3231),
    [anon_sym_SEMI] = ACTIONS(3231),
    [anon_sym_LBRACE] = ACTIONS(3231),
    [anon_sym_LPAREN2] = ACTIONS(3231),
    [anon_sym_STAR] = ACTIONS(3231),
    [anon_sym_LBRACK] = ACTIONS(3231),
    [anon_sym_EQ] = ACTIONS(3231),
    [anon_sym_const] = ACTIONS(3233),
    [anon_sym_restrict] = ACTIONS(3233),
    [anon_sym_volatile] = ACTIONS(3233),
    [anon_sym__Atomic] = ACTIONS(3233),
    [anon_sym_mutable] = ACTIONS(3233),
    [anon_sym_explicit] = ACTIONS(3233),
    [anon_sym_constexpr] = ACTIONS(3233),
    [anon_sym_COLON] = ACTIONS(3231),
    [anon_sym_AMP] = ACTIONS(3233),
    [anon_sym_AMP_AMP] = ACTIONS(3231),
    [anon_sym_DASH_GT] = ACTIONS(3231),
    [sym_identifier] = ACTIONS(3233),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3233),
    [anon_sym_override] = ACTIONS(3233),
    [sym_noexcept] = ACTIONS(3233),
  },
  [1097] = {
    [sym_field_declaration_list] = STATE(1866),
    [anon_sym_LBRACE] = ACTIONS(750),
    [sym_comment] = ACTIONS(91),
  },
  [1098] = {
    [sym_field_declaration_list] = STATE(1866),
    [sym_base_class_clause] = STATE(1867),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_COLON] = ACTIONS(1073),
    [sym_comment] = ACTIONS(91),
  },
  [1099] = {
    [sym__type_declarator] = STATE(1101),
    [sym_pointer_type_declarator] = STATE(1101),
    [sym_function_type_declarator] = STATE(1101),
    [sym_array_type_declarator] = STATE(1101),
    [sym_type_qualifier] = STATE(1868),
    [aux_sym_type_definition_repeat1] = STATE(1868),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_STAR] = ACTIONS(2162),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [sym_identifier] = ACTIONS(2164),
    [sym_comment] = ACTIONS(91),
  },
  [1100] = {
    [sym_parameter_list] = STATE(1105),
    [anon_sym_RPAREN] = ACTIONS(3954),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [sym_comment] = ACTIONS(91),
  },
  [1101] = {
    [sym_parameter_list] = STATE(1105),
    [anon_sym_RPAREN] = ACTIONS(3956),
    [anon_sym_SEMI] = ACTIONS(3956),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [sym_comment] = ACTIONS(91),
  },
  [1102] = {
    [sym__type_declarator] = STATE(1870),
    [sym_pointer_type_declarator] = STATE(1870),
    [sym_function_type_declarator] = STATE(1870),
    [sym_array_type_declarator] = STATE(1870),
    [sym_type_qualifier] = STATE(1871),
    [aux_sym_type_definition_repeat1] = STATE(1871),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_STAR] = ACTIONS(768),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [sym_identifier] = ACTIONS(2164),
    [sym_comment] = ACTIONS(91),
  },
  [1103] = {
    [sym_raw_string_literal] = ACTIONS(3958),
    [ts_builtin_sym_end] = ACTIONS(3958),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3960),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3960),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3960),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3960),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3960),
    [sym_preproc_directive] = ACTIONS(3960),
    [anon_sym_SEMI] = ACTIONS(3958),
    [anon_sym_typedef] = ACTIONS(3960),
    [anon_sym_extern] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3958),
    [anon_sym_RBRACE] = ACTIONS(3958),
    [anon_sym_LPAREN2] = ACTIONS(3958),
    [anon_sym_STAR] = ACTIONS(3958),
    [anon_sym_LBRACK] = ACTIONS(3958),
    [anon_sym_static] = ACTIONS(3960),
    [anon_sym_register] = ACTIONS(3960),
    [anon_sym_inline] = ACTIONS(3960),
    [anon_sym_const] = ACTIONS(3960),
    [anon_sym_restrict] = ACTIONS(3960),
    [anon_sym_volatile] = ACTIONS(3960),
    [anon_sym__Atomic] = ACTIONS(3960),
    [anon_sym_mutable] = ACTIONS(3960),
    [anon_sym_explicit] = ACTIONS(3960),
    [anon_sym_constexpr] = ACTIONS(3960),
    [anon_sym_unsigned] = ACTIONS(3960),
    [anon_sym_long] = ACTIONS(3960),
    [anon_sym_short] = ACTIONS(3960),
    [sym_primitive_type] = ACTIONS(3960),
    [anon_sym_enum] = ACTIONS(3960),
    [anon_sym_struct] = ACTIONS(3960),
    [anon_sym_union] = ACTIONS(3960),
    [anon_sym_if] = ACTIONS(3960),
    [anon_sym_else] = ACTIONS(3960),
    [anon_sym_switch] = ACTIONS(3960),
    [anon_sym_case] = ACTIONS(3960),
    [anon_sym_default] = ACTIONS(3960),
    [anon_sym_while] = ACTIONS(3960),
    [anon_sym_do] = ACTIONS(3960),
    [anon_sym_for] = ACTIONS(3960),
    [anon_sym_return] = ACTIONS(3960),
    [anon_sym_break] = ACTIONS(3960),
    [anon_sym_continue] = ACTIONS(3960),
    [anon_sym_goto] = ACTIONS(3960),
    [anon_sym_AMP] = ACTIONS(3960),
    [anon_sym_AMP_AMP] = ACTIONS(3958),
    [anon_sym_BANG] = ACTIONS(3958),
    [anon_sym_TILDE] = ACTIONS(3958),
    [anon_sym_PLUS] = ACTIONS(3960),
    [anon_sym_DASH] = ACTIONS(3960),
    [anon_sym_DASH_DASH] = ACTIONS(3958),
    [anon_sym_PLUS_PLUS] = ACTIONS(3958),
    [anon_sym_sizeof] = ACTIONS(3960),
    [sym_number_literal] = ACTIONS(3958),
    [anon_sym_SQUOTE] = ACTIONS(3958),
    [anon_sym_DQUOTE] = ACTIONS(3958),
    [sym_true] = ACTIONS(3960),
    [sym_false] = ACTIONS(3960),
    [sym_null] = ACTIONS(3960),
    [sym_identifier] = ACTIONS(3960),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3960),
    [sym_auto] = ACTIONS(3960),
    [anon_sym_typename] = ACTIONS(3960),
    [anon_sym_template] = ACTIONS(3960),
    [anon_sym_delete] = ACTIONS(3960),
    [anon_sym_namespace] = ACTIONS(3960),
    [anon_sym_using] = ACTIONS(3960),
    [anon_sym_try] = ACTIONS(3960),
    [anon_sym_new] = ACTIONS(3960),
    [anon_sym_COLON_COLON] = ACTIONS(3958),
    [sym_operator_name] = ACTIONS(3958),
    [sym_nullptr] = ACTIONS(3960),
  },
  [1104] = {
    [sym_type_qualifier] = STATE(1875),
    [sym__expression] = STATE(1874),
    [sym_conditional_expression] = STATE(1874),
    [sym_assignment_expression] = STATE(1874),
    [sym_pointer_expression] = STATE(1874),
    [sym_logical_expression] = STATE(1874),
    [sym_bitwise_expression] = STATE(1874),
    [sym_equality_expression] = STATE(1874),
    [sym_relational_expression] = STATE(1874),
    [sym_shift_expression] = STATE(1874),
    [sym_math_expression] = STATE(1874),
    [sym_cast_expression] = STATE(1874),
    [sym_sizeof_expression] = STATE(1874),
    [sym_subscript_expression] = STATE(1874),
    [sym_call_expression] = STATE(1874),
    [sym_field_expression] = STATE(1874),
    [sym_compound_literal_expression] = STATE(1874),
    [sym_parenthesized_expression] = STATE(1874),
    [sym_char_literal] = STATE(1874),
    [sym_concatenated_string] = STATE(1874),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1874),
    [sym_new_expression] = STATE(1874),
    [sym_delete_expression] = STATE(1874),
    [sym_lambda_expression] = STATE(1874),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [aux_sym_type_definition_repeat1] = STATE(1875),
    [sym_raw_string_literal] = ACTIONS(3962),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(3964),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(3966),
    [anon_sym_const] = ACTIONS(1643),
    [anon_sym_restrict] = ACTIONS(1643),
    [anon_sym_volatile] = ACTIONS(1643),
    [anon_sym__Atomic] = ACTIONS(1643),
    [anon_sym_mutable] = ACTIONS(1643),
    [anon_sym_explicit] = ACTIONS(1643),
    [anon_sym_constexpr] = ACTIONS(1643),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(3962),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(3968),
    [sym_false] = ACTIONS(3968),
    [sym_null] = ACTIONS(3968),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(3968),
  },
  [1105] = {
    [anon_sym_RPAREN] = ACTIONS(3970),
    [anon_sym_SEMI] = ACTIONS(3970),
    [anon_sym_LPAREN2] = ACTIONS(3970),
    [anon_sym_LBRACK] = ACTIONS(3970),
    [sym_comment] = ACTIONS(91),
  },
  [1106] = {
    [anon_sym_COMMA] = ACTIONS(3636),
    [anon_sym_RPAREN] = ACTIONS(3636),
    [anon_sym_SEMI] = ACTIONS(3636),
    [anon_sym_LBRACE] = ACTIONS(3636),
    [anon_sym_LPAREN2] = ACTIONS(3636),
    [anon_sym_STAR] = ACTIONS(3636),
    [anon_sym_LBRACK] = ACTIONS(3636),
    [anon_sym_EQ] = ACTIONS(3636),
    [anon_sym_const] = ACTIONS(3634),
    [anon_sym_restrict] = ACTIONS(3634),
    [anon_sym_volatile] = ACTIONS(3634),
    [anon_sym__Atomic] = ACTIONS(3634),
    [anon_sym_mutable] = ACTIONS(3634),
    [anon_sym_explicit] = ACTIONS(3634),
    [anon_sym_constexpr] = ACTIONS(3634),
    [anon_sym_COLON] = ACTIONS(3634),
    [anon_sym_AMP] = ACTIONS(3634),
    [anon_sym_AMP_AMP] = ACTIONS(3636),
    [anon_sym_LT] = ACTIONS(3636),
    [anon_sym_DASH_GT] = ACTIONS(3636),
    [sym_identifier] = ACTIONS(3634),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3634),
    [anon_sym_override] = ACTIONS(3634),
    [anon_sym_GT2] = ACTIONS(3636),
    [sym_noexcept] = ACTIONS(3634),
    [anon_sym_COLON_COLON] = ACTIONS(3643),
  },
  [1107] = {
    [sym_parameter_list] = STATE(1105),
    [anon_sym_SEMI] = ACTIONS(3972),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [sym_comment] = ACTIONS(91),
  },
  [1108] = {
    [sym_raw_string_literal] = ACTIONS(1370),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1372),
    [sym_preproc_directive] = ACTIONS(1372),
    [anon_sym_SEMI] = ACTIONS(1370),
    [anon_sym_typedef] = ACTIONS(1372),
    [anon_sym_extern] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1370),
    [anon_sym_RBRACE] = ACTIONS(1370),
    [anon_sym_LPAREN2] = ACTIONS(1370),
    [anon_sym_STAR] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(1370),
    [anon_sym_static] = ACTIONS(1372),
    [anon_sym_register] = ACTIONS(1372),
    [anon_sym_inline] = ACTIONS(1372),
    [anon_sym_const] = ACTIONS(1372),
    [anon_sym_restrict] = ACTIONS(1372),
    [anon_sym_volatile] = ACTIONS(1372),
    [anon_sym__Atomic] = ACTIONS(1372),
    [anon_sym_mutable] = ACTIONS(1372),
    [anon_sym_explicit] = ACTIONS(1372),
    [anon_sym_constexpr] = ACTIONS(1372),
    [anon_sym_unsigned] = ACTIONS(1372),
    [anon_sym_long] = ACTIONS(1372),
    [anon_sym_short] = ACTIONS(1372),
    [sym_primitive_type] = ACTIONS(1372),
    [anon_sym_enum] = ACTIONS(1372),
    [anon_sym_struct] = ACTIONS(1372),
    [anon_sym_union] = ACTIONS(1372),
    [anon_sym_if] = ACTIONS(1372),
    [anon_sym_switch] = ACTIONS(1372),
    [anon_sym_case] = ACTIONS(1372),
    [anon_sym_default] = ACTIONS(1372),
    [anon_sym_while] = ACTIONS(1372),
    [anon_sym_do] = ACTIONS(1372),
    [anon_sym_for] = ACTIONS(1372),
    [anon_sym_return] = ACTIONS(1372),
    [anon_sym_break] = ACTIONS(1372),
    [anon_sym_continue] = ACTIONS(1372),
    [anon_sym_goto] = ACTIONS(1372),
    [anon_sym_AMP] = ACTIONS(1370),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_PLUS] = ACTIONS(1372),
    [anon_sym_DASH] = ACTIONS(1372),
    [anon_sym_DASH_DASH] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1370),
    [anon_sym_sizeof] = ACTIONS(1372),
    [sym_number_literal] = ACTIONS(1370),
    [anon_sym_SQUOTE] = ACTIONS(1370),
    [anon_sym_DQUOTE] = ACTIONS(1370),
    [sym_true] = ACTIONS(1372),
    [sym_false] = ACTIONS(1372),
    [sym_null] = ACTIONS(1372),
    [sym_identifier] = ACTIONS(1372),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1372),
    [sym_auto] = ACTIONS(1372),
    [anon_sym_typename] = ACTIONS(1372),
    [anon_sym_delete] = ACTIONS(1372),
    [anon_sym_try] = ACTIONS(1372),
    [anon_sym_new] = ACTIONS(1372),
    [anon_sym_COLON_COLON] = ACTIONS(1370),
    [sym_nullptr] = ACTIONS(1372),
  },
  [1109] = {
    [aux_sym_string_literal_repeat1] = STATE(761),
    [anon_sym_DQUOTE] = ACTIONS(3974),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_BSLASHn_RBRACK_SLASH] = ACTIONS(1376),
    [sym_escape_sequence] = ACTIONS(1376),
    [sym_comment] = ACTIONS(121),
  },
  [1110] = {
    [sym_raw_string_literal] = ACTIONS(1994),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1996),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1996),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1996),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1996),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1996),
    [sym_preproc_directive] = ACTIONS(1996),
    [anon_sym_SEMI] = ACTIONS(1994),
    [anon_sym_typedef] = ACTIONS(1996),
    [anon_sym_extern] = ACTIONS(1996),
    [anon_sym_LBRACE] = ACTIONS(1994),
    [anon_sym_RBRACE] = ACTIONS(1994),
    [anon_sym_LPAREN2] = ACTIONS(1994),
    [anon_sym_STAR] = ACTIONS(1994),
    [anon_sym_LBRACK] = ACTIONS(1994),
    [anon_sym_static] = ACTIONS(1996),
    [anon_sym_register] = ACTIONS(1996),
    [anon_sym_inline] = ACTIONS(1996),
    [anon_sym_const] = ACTIONS(1996),
    [anon_sym_restrict] = ACTIONS(1996),
    [anon_sym_volatile] = ACTIONS(1996),
    [anon_sym__Atomic] = ACTIONS(1996),
    [anon_sym_mutable] = ACTIONS(1996),
    [anon_sym_explicit] = ACTIONS(1996),
    [anon_sym_constexpr] = ACTIONS(1996),
    [anon_sym_unsigned] = ACTIONS(1996),
    [anon_sym_long] = ACTIONS(1996),
    [anon_sym_short] = ACTIONS(1996),
    [sym_primitive_type] = ACTIONS(1996),
    [anon_sym_enum] = ACTIONS(1996),
    [anon_sym_struct] = ACTIONS(1996),
    [anon_sym_union] = ACTIONS(1996),
    [anon_sym_if] = ACTIONS(1996),
    [anon_sym_switch] = ACTIONS(1996),
    [anon_sym_case] = ACTIONS(1996),
    [anon_sym_default] = ACTIONS(1996),
    [anon_sym_while] = ACTIONS(1996),
    [anon_sym_do] = ACTIONS(1996),
    [anon_sym_for] = ACTIONS(1996),
    [anon_sym_return] = ACTIONS(1996),
    [anon_sym_break] = ACTIONS(1996),
    [anon_sym_continue] = ACTIONS(1996),
    [anon_sym_goto] = ACTIONS(1996),
    [anon_sym_AMP] = ACTIONS(1994),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_PLUS] = ACTIONS(1996),
    [anon_sym_DASH] = ACTIONS(1996),
    [anon_sym_DASH_DASH] = ACTIONS(1994),
    [anon_sym_PLUS_PLUS] = ACTIONS(1994),
    [anon_sym_sizeof] = ACTIONS(1996),
    [sym_number_literal] = ACTIONS(1994),
    [anon_sym_SQUOTE] = ACTIONS(1994),
    [anon_sym_DQUOTE] = ACTIONS(1994),
    [sym_true] = ACTIONS(1996),
    [sym_false] = ACTIONS(1996),
    [sym_null] = ACTIONS(1996),
    [sym_identifier] = ACTIONS(1996),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1996),
    [sym_auto] = ACTIONS(1996),
    [anon_sym_typename] = ACTIONS(1996),
    [anon_sym_delete] = ACTIONS(1996),
    [anon_sym_try] = ACTIONS(1996),
    [anon_sym_new] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1994),
    [sym_nullptr] = ACTIONS(1996),
  },
  [1111] = {
    [anon_sym_LF] = ACTIONS(3976),
    [sym_comment] = ACTIONS(121),
  },
  [1112] = {
    [anon_sym_LF] = ACTIONS(3978),
    [sym_preproc_arg] = ACTIONS(3980),
    [sym_comment] = ACTIONS(121),
  },
  [1113] = {
    [sym_string_literal] = STATE(1882),
    [anon_sym_DQUOTE] = ACTIONS(3982),
    [sym_system_lib_string] = ACTIONS(3984),
    [sym_comment] = ACTIONS(91),
  },
  [1114] = {
    [sym_identifier] = ACTIONS(3986),
    [sym_comment] = ACTIONS(91),
  },
  [1115] = {
    [sym_preproc_arg] = ACTIONS(3988),
    [sym_comment] = ACTIONS(121),
  },
  [1116] = {
    [sym_raw_string_literal] = ACTIONS(3990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3992),
    [sym_preproc_directive] = ACTIONS(3992),
    [anon_sym_SEMI] = ACTIONS(3990),
    [anon_sym_typedef] = ACTIONS(3992),
    [anon_sym_extern] = ACTIONS(3992),
    [anon_sym_LBRACE] = ACTIONS(3990),
    [anon_sym_RBRACE] = ACTIONS(3990),
    [anon_sym_LPAREN2] = ACTIONS(3990),
    [anon_sym_STAR] = ACTIONS(3990),
    [anon_sym_LBRACK] = ACTIONS(3990),
    [anon_sym_static] = ACTIONS(3992),
    [anon_sym_register] = ACTIONS(3992),
    [anon_sym_inline] = ACTIONS(3992),
    [anon_sym_const] = ACTIONS(3992),
    [anon_sym_restrict] = ACTIONS(3992),
    [anon_sym_volatile] = ACTIONS(3992),
    [anon_sym__Atomic] = ACTIONS(3992),
    [anon_sym_mutable] = ACTIONS(3992),
    [anon_sym_explicit] = ACTIONS(3992),
    [anon_sym_constexpr] = ACTIONS(3992),
    [anon_sym_unsigned] = ACTIONS(3992),
    [anon_sym_long] = ACTIONS(3992),
    [anon_sym_short] = ACTIONS(3992),
    [sym_primitive_type] = ACTIONS(3992),
    [anon_sym_enum] = ACTIONS(3992),
    [anon_sym_struct] = ACTIONS(3992),
    [anon_sym_union] = ACTIONS(3992),
    [anon_sym_if] = ACTIONS(3992),
    [anon_sym_switch] = ACTIONS(3992),
    [anon_sym_case] = ACTIONS(3992),
    [anon_sym_default] = ACTIONS(3992),
    [anon_sym_while] = ACTIONS(3992),
    [anon_sym_do] = ACTIONS(3992),
    [anon_sym_for] = ACTIONS(3992),
    [anon_sym_return] = ACTIONS(3992),
    [anon_sym_break] = ACTIONS(3992),
    [anon_sym_continue] = ACTIONS(3992),
    [anon_sym_goto] = ACTIONS(3992),
    [anon_sym_AMP] = ACTIONS(3990),
    [anon_sym_BANG] = ACTIONS(3990),
    [anon_sym_TILDE] = ACTIONS(3990),
    [anon_sym_PLUS] = ACTIONS(3992),
    [anon_sym_DASH] = ACTIONS(3992),
    [anon_sym_DASH_DASH] = ACTIONS(3990),
    [anon_sym_PLUS_PLUS] = ACTIONS(3990),
    [anon_sym_sizeof] = ACTIONS(3992),
    [sym_number_literal] = ACTIONS(3990),
    [anon_sym_SQUOTE] = ACTIONS(3990),
    [anon_sym_DQUOTE] = ACTIONS(3990),
    [sym_true] = ACTIONS(3992),
    [sym_false] = ACTIONS(3992),
    [sym_null] = ACTIONS(3992),
    [sym_identifier] = ACTIONS(3992),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3992),
    [sym_auto] = ACTIONS(3992),
    [anon_sym_typename] = ACTIONS(3992),
    [anon_sym_delete] = ACTIONS(3992),
    [anon_sym_try] = ACTIONS(3992),
    [anon_sym_new] = ACTIONS(3992),
    [anon_sym_COLON_COLON] = ACTIONS(3990),
    [sym_nullptr] = ACTIONS(3992),
  },
  [1117] = {
    [sym_identifier] = ACTIONS(3994),
    [sym_comment] = ACTIONS(91),
  },
  [1118] = {
    [sym_preproc_include] = STATE(1910),
    [sym_preproc_def] = STATE(1910),
    [sym_preproc_function_def] = STATE(1910),
    [sym_preproc_call] = STATE(1910),
    [sym_preproc_if_in_compound_statement] = STATE(1910),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1910),
    [sym_declaration] = STATE(1910),
    [sym_type_definition] = STATE(1910),
    [sym__declaration_specifiers] = STATE(1907),
    [sym_compound_statement] = STATE(1910),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(1910),
    [sym_expression_statement] = STATE(1910),
    [sym_if_statement] = STATE(1910),
    [sym_switch_statement] = STATE(1910),
    [sym_case_statement] = STATE(1910),
    [sym_while_statement] = STATE(1910),
    [sym_do_statement] = STATE(1910),
    [sym_for_statement] = STATE(1910),
    [sym_return_statement] = STATE(1910),
    [sym_break_statement] = STATE(1910),
    [sym_continue_statement] = STATE(1910),
    [sym_goto_statement] = STATE(1910),
    [sym__expression] = STATE(1908),
    [sym_comma_expression] = STATE(1909),
    [sym_conditional_expression] = STATE(1908),
    [sym_assignment_expression] = STATE(1908),
    [sym_pointer_expression] = STATE(1908),
    [sym_logical_expression] = STATE(1908),
    [sym_bitwise_expression] = STATE(1908),
    [sym_equality_expression] = STATE(1908),
    [sym_relational_expression] = STATE(1908),
    [sym_shift_expression] = STATE(1908),
    [sym_math_expression] = STATE(1908),
    [sym_cast_expression] = STATE(1908),
    [sym_sizeof_expression] = STATE(1908),
    [sym_subscript_expression] = STATE(1908),
    [sym_call_expression] = STATE(1908),
    [sym_field_expression] = STATE(1908),
    [sym_compound_literal_expression] = STATE(1908),
    [sym_parenthesized_expression] = STATE(1908),
    [sym_char_literal] = STATE(1908),
    [sym_concatenated_string] = STATE(1908),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(1910),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(1910),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(1908),
    [sym_for_range_loop] = STATE(1910),
    [sym_try_statement] = STATE(1910),
    [sym_new_expression] = STATE(1908),
    [sym_delete_expression] = STATE(1908),
    [sym_lambda_expression] = STATE(1908),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1910),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(3996),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3998),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4000),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4002),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4004),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4006),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4006),
    [sym_preproc_directive] = ACTIONS(4008),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_typedef] = ACTIONS(4012),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(4016),
    [anon_sym_switch] = ACTIONS(4018),
    [anon_sym_case] = ACTIONS(4020),
    [anon_sym_default] = ACTIONS(4022),
    [anon_sym_while] = ACTIONS(4024),
    [anon_sym_do] = ACTIONS(4026),
    [anon_sym_for] = ACTIONS(4028),
    [anon_sym_return] = ACTIONS(4030),
    [anon_sym_break] = ACTIONS(4032),
    [anon_sym_continue] = ACTIONS(4034),
    [anon_sym_goto] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(3996),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4038),
    [sym_false] = ACTIONS(4038),
    [sym_null] = ACTIONS(4038),
    [sym_identifier] = ACTIONS(4040),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(4042),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_nullptr] = ACTIONS(4038),
  },
  [1119] = {
    [sym_preproc_arg] = ACTIONS(4044),
    [sym_comment] = ACTIONS(121),
  },
  [1120] = {
    [anon_sym_LF] = ACTIONS(4046),
    [sym_preproc_arg] = ACTIONS(4048),
    [sym_comment] = ACTIONS(121),
  },
  [1121] = {
    [sym_raw_string_literal] = ACTIONS(129),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(131),
    [sym_preproc_directive] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(129),
    [anon_sym_typedef] = ACTIONS(131),
    [anon_sym_extern] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_LPAREN2] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(129),
    [anon_sym_static] = ACTIONS(131),
    [anon_sym_register] = ACTIONS(131),
    [anon_sym_inline] = ACTIONS(131),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_restrict] = ACTIONS(131),
    [anon_sym_volatile] = ACTIONS(131),
    [anon_sym__Atomic] = ACTIONS(131),
    [anon_sym_mutable] = ACTIONS(131),
    [anon_sym_explicit] = ACTIONS(131),
    [anon_sym_constexpr] = ACTIONS(131),
    [anon_sym_unsigned] = ACTIONS(131),
    [anon_sym_long] = ACTIONS(131),
    [anon_sym_short] = ACTIONS(131),
    [sym_primitive_type] = ACTIONS(131),
    [anon_sym_enum] = ACTIONS(131),
    [anon_sym_struct] = ACTIONS(131),
    [anon_sym_union] = ACTIONS(131),
    [anon_sym_if] = ACTIONS(131),
    [anon_sym_else] = ACTIONS(131),
    [anon_sym_switch] = ACTIONS(131),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(131),
    [anon_sym_break] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_goto] = ACTIONS(131),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_BANG] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_PLUS] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(129),
    [anon_sym_PLUS_PLUS] = ACTIONS(129),
    [anon_sym_sizeof] = ACTIONS(131),
    [sym_number_literal] = ACTIONS(129),
    [anon_sym_SQUOTE] = ACTIONS(129),
    [anon_sym_DQUOTE] = ACTIONS(129),
    [sym_true] = ACTIONS(131),
    [sym_false] = ACTIONS(131),
    [sym_null] = ACTIONS(131),
    [sym_identifier] = ACTIONS(131),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(131),
    [sym_auto] = ACTIONS(131),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_delete] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(131),
    [anon_sym_new] = ACTIONS(131),
    [anon_sym_COLON_COLON] = ACTIONS(129),
    [sym_nullptr] = ACTIONS(131),
  },
  [1122] = {
    [sym_type_qualifier] = STATE(1915),
    [sym__type_specifier] = STATE(1914),
    [sym_sized_type_specifier] = STATE(1914),
    [sym_enum_specifier] = STATE(1914),
    [sym_struct_specifier] = STATE(1914),
    [sym_union_specifier] = STATE(1914),
    [sym_macro_type_specifier] = STATE(1914),
    [sym_class_specifier] = STATE(1914),
    [sym_dependent_type] = STATE(1914),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(82),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_type_definition_repeat1] = STATE(1915),
    [aux_sym_sized_type_specifier_repeat1] = STATE(85),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(135),
    [anon_sym_long] = ACTIONS(135),
    [anon_sym_short] = ACTIONS(135),
    [sym_primitive_type] = ACTIONS(4050),
    [anon_sym_enum] = ACTIONS(139),
    [anon_sym_struct] = ACTIONS(141),
    [anon_sym_union] = ACTIONS(143),
    [sym_identifier] = ACTIONS(145),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(147),
    [sym_auto] = ACTIONS(4050),
    [anon_sym_typename] = ACTIONS(149),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [1123] = {
    [sym_preproc_include] = STATE(1917),
    [sym_preproc_def] = STATE(1917),
    [sym_preproc_function_def] = STATE(1917),
    [sym_preproc_call] = STATE(1917),
    [sym_preproc_if_in_compound_statement] = STATE(1917),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1917),
    [sym_declaration] = STATE(1917),
    [sym_type_definition] = STATE(1917),
    [sym__declaration_specifiers] = STATE(113),
    [sym_compound_statement] = STATE(1917),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(1917),
    [sym_expression_statement] = STATE(1917),
    [sym_if_statement] = STATE(1917),
    [sym_switch_statement] = STATE(1917),
    [sym_case_statement] = STATE(1917),
    [sym_while_statement] = STATE(1917),
    [sym_do_statement] = STATE(1917),
    [sym_for_statement] = STATE(1917),
    [sym_return_statement] = STATE(1917),
    [sym_break_statement] = STATE(1917),
    [sym_continue_statement] = STATE(1917),
    [sym_goto_statement] = STATE(1917),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(1917),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(1917),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(1917),
    [sym_try_statement] = STATE(1917),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1917),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(157),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(159),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(161),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(163),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(165),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(165),
    [sym_preproc_directive] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_typedef] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_RBRACE] = ACTIONS(4052),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(185),
    [anon_sym_case] = ACTIONS(187),
    [anon_sym_default] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(209),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_nullptr] = ACTIONS(207),
  },
  [1124] = {
    [anon_sym_LPAREN2] = ACTIONS(4054),
    [anon_sym_constexpr] = ACTIONS(4056),
    [sym_comment] = ACTIONS(91),
  },
  [1125] = {
    [sym_parenthesized_expression] = STATE(1920),
    [anon_sym_LPAREN2] = ACTIONS(323),
    [sym_comment] = ACTIONS(91),
  },
  [1126] = {
    [sym__expression] = STATE(1921),
    [sym_conditional_expression] = STATE(1921),
    [sym_assignment_expression] = STATE(1921),
    [sym_pointer_expression] = STATE(1921),
    [sym_logical_expression] = STATE(1921),
    [sym_bitwise_expression] = STATE(1921),
    [sym_equality_expression] = STATE(1921),
    [sym_relational_expression] = STATE(1921),
    [sym_shift_expression] = STATE(1921),
    [sym_math_expression] = STATE(1921),
    [sym_cast_expression] = STATE(1921),
    [sym_sizeof_expression] = STATE(1921),
    [sym_subscript_expression] = STATE(1921),
    [sym_call_expression] = STATE(1921),
    [sym_field_expression] = STATE(1921),
    [sym_compound_literal_expression] = STATE(1921),
    [sym_parenthesized_expression] = STATE(1921),
    [sym_char_literal] = STATE(1921),
    [sym_concatenated_string] = STATE(1921),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1921),
    [sym_new_expression] = STATE(1921),
    [sym_delete_expression] = STATE(1921),
    [sym_lambda_expression] = STATE(1921),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4058),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(4058),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(4060),
    [sym_false] = ACTIONS(4060),
    [sym_null] = ACTIONS(4060),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(4060),
  },
  [1127] = {
    [anon_sym_COLON] = ACTIONS(4062),
    [sym_comment] = ACTIONS(91),
  },
  [1128] = {
    [sym_parenthesized_expression] = STATE(1923),
    [anon_sym_LPAREN2] = ACTIONS(323),
    [sym_comment] = ACTIONS(91),
  },
  [1129] = {
    [sym_compound_statement] = STATE(1924),
    [sym_labeled_statement] = STATE(1924),
    [sym_expression_statement] = STATE(1924),
    [sym_if_statement] = STATE(1924),
    [sym_switch_statement] = STATE(1924),
    [sym_case_statement] = STATE(1924),
    [sym_while_statement] = STATE(1924),
    [sym_do_statement] = STATE(1924),
    [sym_for_statement] = STATE(1924),
    [sym_return_statement] = STATE(1924),
    [sym_break_statement] = STATE(1924),
    [sym_continue_statement] = STATE(1924),
    [sym_goto_statement] = STATE(1924),
    [sym__expression] = STATE(222),
    [sym_comma_expression] = STATE(223),
    [sym_conditional_expression] = STATE(222),
    [sym_assignment_expression] = STATE(222),
    [sym_pointer_expression] = STATE(222),
    [sym_logical_expression] = STATE(222),
    [sym_bitwise_expression] = STATE(222),
    [sym_equality_expression] = STATE(222),
    [sym_relational_expression] = STATE(222),
    [sym_shift_expression] = STATE(222),
    [sym_math_expression] = STATE(222),
    [sym_cast_expression] = STATE(222),
    [sym_sizeof_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_call_expression] = STATE(222),
    [sym_field_expression] = STATE(222),
    [sym_compound_literal_expression] = STATE(222),
    [sym_parenthesized_expression] = STATE(222),
    [sym_char_literal] = STATE(222),
    [sym_concatenated_string] = STATE(222),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(222),
    [sym_for_range_loop] = STATE(1924),
    [sym_try_statement] = STATE(1924),
    [sym_new_expression] = STATE(222),
    [sym_delete_expression] = STATE(222),
    [sym_lambda_expression] = STATE(222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(359),
    [anon_sym_switch] = ACTIONS(361),
    [anon_sym_case] = ACTIONS(363),
    [anon_sym_default] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [anon_sym_do] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(373),
    [anon_sym_break] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_goto] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(353),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_identifier] = ACTIONS(383),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(381),
  },
  [1130] = {
    [anon_sym_LPAREN2] = ACTIONS(4064),
    [sym_comment] = ACTIONS(91),
  },
  [1131] = {
    [sym__expression] = STATE(1927),
    [sym_conditional_expression] = STATE(1927),
    [sym_assignment_expression] = STATE(1927),
    [sym_pointer_expression] = STATE(1927),
    [sym_logical_expression] = STATE(1927),
    [sym_bitwise_expression] = STATE(1927),
    [sym_equality_expression] = STATE(1927),
    [sym_relational_expression] = STATE(1927),
    [sym_shift_expression] = STATE(1927),
    [sym_math_expression] = STATE(1927),
    [sym_cast_expression] = STATE(1927),
    [sym_sizeof_expression] = STATE(1927),
    [sym_subscript_expression] = STATE(1927),
    [sym_call_expression] = STATE(1927),
    [sym_field_expression] = STATE(1927),
    [sym_compound_literal_expression] = STATE(1927),
    [sym_parenthesized_expression] = STATE(1927),
    [sym_initializer_list] = STATE(1928),
    [sym_char_literal] = STATE(1927),
    [sym_concatenated_string] = STATE(1927),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1927),
    [sym_new_expression] = STATE(1927),
    [sym_delete_expression] = STATE(1927),
    [sym_lambda_expression] = STATE(1927),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4066),
    [anon_sym_SEMI] = ACTIONS(4068),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(4066),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4070),
    [sym_false] = ACTIONS(4070),
    [sym_null] = ACTIONS(4070),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(4070),
  },
  [1132] = {
    [anon_sym_SEMI] = ACTIONS(4072),
    [sym_comment] = ACTIONS(91),
  },
  [1133] = {
    [anon_sym_SEMI] = ACTIONS(4074),
    [sym_comment] = ACTIONS(91),
  },
  [1134] = {
    [sym_identifier] = ACTIONS(4076),
    [sym_comment] = ACTIONS(91),
  },
  [1135] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(263),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(465),
    [anon_sym_extern] = ACTIONS(468),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(465),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_register] = ACTIONS(468),
    [anon_sym_inline] = ACTIONS(468),
    [anon_sym_const] = ACTIONS(468),
    [anon_sym_restrict] = ACTIONS(468),
    [anon_sym_volatile] = ACTIONS(468),
    [anon_sym__Atomic] = ACTIONS(468),
    [anon_sym_mutable] = ACTIONS(468),
    [anon_sym_explicit] = ACTIONS(468),
    [anon_sym_constexpr] = ACTIONS(468),
    [anon_sym_COLON] = ACTIONS(4078),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(474),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_TILDE] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_identifier] = ACTIONS(468),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(486),
    [sym_operator_name] = ACTIONS(481),
  },
  [1136] = {
    [sym_compound_statement] = STATE(1933),
    [anon_sym_LBRACE] = ACTIONS(357),
    [sym_comment] = ACTIONS(91),
  },
  [1137] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4080),
    [sym_comment] = ACTIONS(91),
  },
  [1138] = {
    [sym__declarator] = STATE(1936),
    [sym_pointer_declarator] = STATE(1936),
    [sym_function_declarator] = STATE(1936),
    [sym_array_declarator] = STATE(1936),
    [sym_init_declarator] = STATE(1937),
    [sym_reference_declarator] = STATE(1936),
    [sym_structured_binding_reference_declarator] = STATE(1938),
    [sym_structured_binding_declarator] = STATE(1938),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(1936),
    [sym_destructor_name] = STATE(1936),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [anon_sym_SEMI] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(566),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(568),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(4084),
  },
  [1139] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(586),
    [anon_sym_SEMI] = ACTIONS(4086),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(590),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(594),
    [anon_sym_QMARK] = ACTIONS(596),
    [anon_sym_STAR_EQ] = ACTIONS(598),
    [anon_sym_SLASH_EQ] = ACTIONS(598),
    [anon_sym_PERCENT_EQ] = ACTIONS(598),
    [anon_sym_PLUS_EQ] = ACTIONS(598),
    [anon_sym_DASH_EQ] = ACTIONS(598),
    [anon_sym_LT_LT_EQ] = ACTIONS(598),
    [anon_sym_GT_GT_EQ] = ACTIONS(598),
    [anon_sym_AMP_EQ] = ACTIONS(598),
    [anon_sym_CARET_EQ] = ACTIONS(598),
    [anon_sym_PIPE_EQ] = ACTIONS(598),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_PIPE_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(604),
    [anon_sym_PIPE] = ACTIONS(606),
    [anon_sym_CARET] = ACTIONS(608),
    [anon_sym_EQ_EQ] = ACTIONS(610),
    [anon_sym_BANG_EQ] = ACTIONS(610),
    [anon_sym_LT] = ACTIONS(612),
    [anon_sym_GT] = ACTIONS(612),
    [anon_sym_LT_EQ] = ACTIONS(614),
    [anon_sym_GT_EQ] = ACTIONS(614),
    [anon_sym_LT_LT] = ACTIONS(616),
    [anon_sym_GT_GT] = ACTIONS(616),
    [anon_sym_PLUS] = ACTIONS(618),
    [anon_sym_DASH] = ACTIONS(618),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1140] = {
    [anon_sym_SEMI] = ACTIONS(4086),
    [sym_comment] = ACTIONS(91),
  },
  [1141] = {
    [sym_preproc_include] = STATE(1941),
    [sym_preproc_def] = STATE(1941),
    [sym_preproc_function_def] = STATE(1941),
    [sym_preproc_call] = STATE(1941),
    [sym_preproc_if_in_compound_statement] = STATE(1941),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1941),
    [sym_preproc_else_in_compound_statement] = STATE(1940),
    [sym_preproc_elif_in_compound_statement] = STATE(1940),
    [sym_declaration] = STATE(1941),
    [sym_type_definition] = STATE(1941),
    [sym__declaration_specifiers] = STATE(1138),
    [sym_compound_statement] = STATE(1941),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(1941),
    [sym_expression_statement] = STATE(1941),
    [sym_if_statement] = STATE(1941),
    [sym_switch_statement] = STATE(1941),
    [sym_case_statement] = STATE(1941),
    [sym_while_statement] = STATE(1941),
    [sym_do_statement] = STATE(1941),
    [sym_for_statement] = STATE(1941),
    [sym_return_statement] = STATE(1941),
    [sym_break_statement] = STATE(1941),
    [sym_continue_statement] = STATE(1941),
    [sym_goto_statement] = STATE(1941),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(1941),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(1941),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(1941),
    [sym_try_statement] = STATE(1941),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1941),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(2196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2198),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2200),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4088),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2208),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2210),
    [sym_preproc_directive] = ACTIONS(2212),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_typedef] = ACTIONS(2216),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(2220),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(2244),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_nullptr] = ACTIONS(2242),
  },
  [1142] = {
    [sym_raw_string_literal] = ACTIONS(4090),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4092),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4092),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4092),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4092),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4092),
    [sym_preproc_directive] = ACTIONS(4092),
    [anon_sym_SEMI] = ACTIONS(4090),
    [anon_sym_typedef] = ACTIONS(4092),
    [anon_sym_extern] = ACTIONS(4092),
    [anon_sym_LBRACE] = ACTIONS(4090),
    [anon_sym_RBRACE] = ACTIONS(4090),
    [anon_sym_LPAREN2] = ACTIONS(4090),
    [anon_sym_STAR] = ACTIONS(4090),
    [anon_sym_LBRACK] = ACTIONS(4090),
    [anon_sym_static] = ACTIONS(4092),
    [anon_sym_register] = ACTIONS(4092),
    [anon_sym_inline] = ACTIONS(4092),
    [anon_sym_const] = ACTIONS(4092),
    [anon_sym_restrict] = ACTIONS(4092),
    [anon_sym_volatile] = ACTIONS(4092),
    [anon_sym__Atomic] = ACTIONS(4092),
    [anon_sym_mutable] = ACTIONS(4092),
    [anon_sym_explicit] = ACTIONS(4092),
    [anon_sym_constexpr] = ACTIONS(4092),
    [anon_sym_unsigned] = ACTIONS(4092),
    [anon_sym_long] = ACTIONS(4092),
    [anon_sym_short] = ACTIONS(4092),
    [sym_primitive_type] = ACTIONS(4092),
    [anon_sym_enum] = ACTIONS(4092),
    [anon_sym_struct] = ACTIONS(4092),
    [anon_sym_union] = ACTIONS(4092),
    [anon_sym_if] = ACTIONS(4092),
    [anon_sym_switch] = ACTIONS(4092),
    [anon_sym_case] = ACTIONS(4092),
    [anon_sym_default] = ACTIONS(4092),
    [anon_sym_while] = ACTIONS(4092),
    [anon_sym_do] = ACTIONS(4092),
    [anon_sym_for] = ACTIONS(4092),
    [anon_sym_return] = ACTIONS(4092),
    [anon_sym_break] = ACTIONS(4092),
    [anon_sym_continue] = ACTIONS(4092),
    [anon_sym_goto] = ACTIONS(4092),
    [anon_sym_AMP] = ACTIONS(4090),
    [anon_sym_BANG] = ACTIONS(4090),
    [anon_sym_TILDE] = ACTIONS(4090),
    [anon_sym_PLUS] = ACTIONS(4092),
    [anon_sym_DASH] = ACTIONS(4092),
    [anon_sym_DASH_DASH] = ACTIONS(4090),
    [anon_sym_PLUS_PLUS] = ACTIONS(4090),
    [anon_sym_sizeof] = ACTIONS(4092),
    [sym_number_literal] = ACTIONS(4090),
    [anon_sym_SQUOTE] = ACTIONS(4090),
    [anon_sym_DQUOTE] = ACTIONS(4090),
    [sym_true] = ACTIONS(4092),
    [sym_false] = ACTIONS(4092),
    [sym_null] = ACTIONS(4092),
    [sym_identifier] = ACTIONS(4092),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4092),
    [sym_auto] = ACTIONS(4092),
    [anon_sym_typename] = ACTIONS(4092),
    [anon_sym_delete] = ACTIONS(4092),
    [anon_sym_try] = ACTIONS(4092),
    [anon_sym_new] = ACTIONS(4092),
    [anon_sym_COLON_COLON] = ACTIONS(4090),
    [sym_nullptr] = ACTIONS(4092),
  },
  [1143] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4094),
    [sym_comment] = ACTIONS(91),
  },
  [1144] = {
    [sym_preproc_include] = STATE(1941),
    [sym_preproc_def] = STATE(1941),
    [sym_preproc_function_def] = STATE(1941),
    [sym_preproc_call] = STATE(1941),
    [sym_preproc_if_in_compound_statement] = STATE(1941),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1941),
    [sym_preproc_else_in_compound_statement] = STATE(1943),
    [sym_preproc_elif_in_compound_statement] = STATE(1943),
    [sym_declaration] = STATE(1941),
    [sym_type_definition] = STATE(1941),
    [sym__declaration_specifiers] = STATE(1138),
    [sym_compound_statement] = STATE(1941),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(1941),
    [sym_expression_statement] = STATE(1941),
    [sym_if_statement] = STATE(1941),
    [sym_switch_statement] = STATE(1941),
    [sym_case_statement] = STATE(1941),
    [sym_while_statement] = STATE(1941),
    [sym_do_statement] = STATE(1941),
    [sym_for_statement] = STATE(1941),
    [sym_return_statement] = STATE(1941),
    [sym_break_statement] = STATE(1941),
    [sym_continue_statement] = STATE(1941),
    [sym_goto_statement] = STATE(1941),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(1941),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(1941),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(1941),
    [sym_try_statement] = STATE(1941),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1941),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(2196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2198),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2200),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4096),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2208),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2210),
    [sym_preproc_directive] = ACTIONS(2212),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_typedef] = ACTIONS(2216),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(2220),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(2244),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_nullptr] = ACTIONS(2242),
  },
  [1145] = {
    [sym_raw_string_literal] = ACTIONS(2144),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2146),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2146),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2146),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2146),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2146),
    [sym_preproc_directive] = ACTIONS(2146),
    [anon_sym_SEMI] = ACTIONS(2144),
    [anon_sym_typedef] = ACTIONS(2146),
    [anon_sym_extern] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(2144),
    [anon_sym_RBRACE] = ACTIONS(2144),
    [anon_sym_LPAREN2] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(2144),
    [anon_sym_LBRACK] = ACTIONS(2144),
    [anon_sym_static] = ACTIONS(2146),
    [anon_sym_register] = ACTIONS(2146),
    [anon_sym_inline] = ACTIONS(2146),
    [anon_sym_const] = ACTIONS(2146),
    [anon_sym_restrict] = ACTIONS(2146),
    [anon_sym_volatile] = ACTIONS(2146),
    [anon_sym__Atomic] = ACTIONS(2146),
    [anon_sym_mutable] = ACTIONS(2146),
    [anon_sym_explicit] = ACTIONS(2146),
    [anon_sym_constexpr] = ACTIONS(2146),
    [anon_sym_unsigned] = ACTIONS(2146),
    [anon_sym_long] = ACTIONS(2146),
    [anon_sym_short] = ACTIONS(2146),
    [sym_primitive_type] = ACTIONS(2146),
    [anon_sym_enum] = ACTIONS(2146),
    [anon_sym_struct] = ACTIONS(2146),
    [anon_sym_union] = ACTIONS(2146),
    [anon_sym_if] = ACTIONS(2146),
    [anon_sym_switch] = ACTIONS(2146),
    [anon_sym_case] = ACTIONS(2146),
    [anon_sym_default] = ACTIONS(2146),
    [anon_sym_while] = ACTIONS(2146),
    [anon_sym_do] = ACTIONS(2146),
    [anon_sym_for] = ACTIONS(2146),
    [anon_sym_return] = ACTIONS(2146),
    [anon_sym_break] = ACTIONS(2146),
    [anon_sym_continue] = ACTIONS(2146),
    [anon_sym_goto] = ACTIONS(2146),
    [anon_sym_AMP] = ACTIONS(2144),
    [anon_sym_BANG] = ACTIONS(2144),
    [anon_sym_TILDE] = ACTIONS(2144),
    [anon_sym_PLUS] = ACTIONS(2146),
    [anon_sym_DASH] = ACTIONS(2146),
    [anon_sym_DASH_DASH] = ACTIONS(2144),
    [anon_sym_PLUS_PLUS] = ACTIONS(2144),
    [anon_sym_sizeof] = ACTIONS(2146),
    [sym_number_literal] = ACTIONS(2144),
    [anon_sym_SQUOTE] = ACTIONS(2144),
    [anon_sym_DQUOTE] = ACTIONS(2144),
    [sym_true] = ACTIONS(2146),
    [sym_false] = ACTIONS(2146),
    [sym_null] = ACTIONS(2146),
    [sym_identifier] = ACTIONS(2146),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2146),
    [sym_auto] = ACTIONS(2146),
    [anon_sym_typename] = ACTIONS(2146),
    [anon_sym_delete] = ACTIONS(2146),
    [anon_sym_try] = ACTIONS(2146),
    [anon_sym_new] = ACTIONS(2146),
    [anon_sym_COLON_COLON] = ACTIONS(2144),
    [sym_nullptr] = ACTIONS(2146),
  },
  [1146] = {
    [sym_parameter_list] = STATE(1105),
    [anon_sym_SEMI] = ACTIONS(4098),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [sym_comment] = ACTIONS(91),
  },
  [1147] = {
    [sym__type_declarator] = STATE(1945),
    [sym_pointer_type_declarator] = STATE(1945),
    [sym_function_type_declarator] = STATE(1945),
    [sym_array_type_declarator] = STATE(1945),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_STAR] = ACTIONS(768),
    [sym_identifier] = ACTIONS(770),
    [sym_comment] = ACTIONS(91),
  },
  [1148] = {
    [sym_raw_string_literal] = ACTIONS(2286),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2288),
    [sym_preproc_directive] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym_typedef] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_RBRACE] = ACTIONS(2286),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_STAR] = ACTIONS(2286),
    [anon_sym_LBRACK] = ACTIONS(2286),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_register] = ACTIONS(2288),
    [anon_sym_inline] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_explicit] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_unsigned] = ACTIONS(2288),
    [anon_sym_long] = ACTIONS(2288),
    [anon_sym_short] = ACTIONS(2288),
    [sym_primitive_type] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [anon_sym_struct] = ACTIONS(2288),
    [anon_sym_union] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_else] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_goto] = ACTIONS(2288),
    [anon_sym_AMP] = ACTIONS(2286),
    [anon_sym_BANG] = ACTIONS(2286),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_sizeof] = ACTIONS(2288),
    [sym_number_literal] = ACTIONS(2286),
    [anon_sym_SQUOTE] = ACTIONS(2286),
    [anon_sym_DQUOTE] = ACTIONS(2286),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [sym_null] = ACTIONS(2288),
    [sym_identifier] = ACTIONS(2288),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2288),
    [sym_auto] = ACTIONS(2288),
    [anon_sym_typename] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_catch] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [sym_nullptr] = ACTIONS(2288),
  },
  [1149] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(4100),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1150] = {
    [sym__expression] = STATE(1947),
    [sym_conditional_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(1947),
    [sym_pointer_expression] = STATE(1947),
    [sym_logical_expression] = STATE(1947),
    [sym_bitwise_expression] = STATE(1947),
    [sym_equality_expression] = STATE(1947),
    [sym_relational_expression] = STATE(1947),
    [sym_shift_expression] = STATE(1947),
    [sym_math_expression] = STATE(1947),
    [sym_cast_expression] = STATE(1947),
    [sym_sizeof_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_call_expression] = STATE(1947),
    [sym_field_expression] = STATE(1947),
    [sym_compound_literal_expression] = STATE(1947),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_char_literal] = STATE(1947),
    [sym_concatenated_string] = STATE(1947),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1947),
    [sym_new_expression] = STATE(1947),
    [sym_delete_expression] = STATE(1947),
    [sym_lambda_expression] = STATE(1947),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4102),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(4102),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4104),
    [sym_false] = ACTIONS(4104),
    [sym_null] = ACTIONS(4104),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(4104),
  },
  [1151] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(548),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_COLON] = ACTIONS(837),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(935),
  },
  [1152] = {
    [sym_raw_string_literal] = ACTIONS(2767),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2769),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2769),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2769),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2769),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2769),
    [sym_preproc_directive] = ACTIONS(2769),
    [anon_sym_SEMI] = ACTIONS(2767),
    [anon_sym_typedef] = ACTIONS(2769),
    [anon_sym_extern] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_RBRACE] = ACTIONS(2767),
    [anon_sym_LPAREN2] = ACTIONS(2767),
    [anon_sym_STAR] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(2767),
    [anon_sym_static] = ACTIONS(2769),
    [anon_sym_register] = ACTIONS(2769),
    [anon_sym_inline] = ACTIONS(2769),
    [anon_sym_const] = ACTIONS(2769),
    [anon_sym_restrict] = ACTIONS(2769),
    [anon_sym_volatile] = ACTIONS(2769),
    [anon_sym__Atomic] = ACTIONS(2769),
    [anon_sym_mutable] = ACTIONS(2769),
    [anon_sym_explicit] = ACTIONS(2769),
    [anon_sym_constexpr] = ACTIONS(2769),
    [anon_sym_unsigned] = ACTIONS(2769),
    [anon_sym_long] = ACTIONS(2769),
    [anon_sym_short] = ACTIONS(2769),
    [sym_primitive_type] = ACTIONS(2769),
    [anon_sym_enum] = ACTIONS(2769),
    [anon_sym_struct] = ACTIONS(2769),
    [anon_sym_union] = ACTIONS(2769),
    [anon_sym_if] = ACTIONS(2769),
    [anon_sym_else] = ACTIONS(2769),
    [anon_sym_switch] = ACTIONS(2769),
    [anon_sym_case] = ACTIONS(2769),
    [anon_sym_default] = ACTIONS(2769),
    [anon_sym_while] = ACTIONS(2769),
    [anon_sym_do] = ACTIONS(2769),
    [anon_sym_for] = ACTIONS(2769),
    [anon_sym_return] = ACTIONS(2769),
    [anon_sym_break] = ACTIONS(2769),
    [anon_sym_continue] = ACTIONS(2769),
    [anon_sym_goto] = ACTIONS(2769),
    [anon_sym_AMP] = ACTIONS(2767),
    [anon_sym_BANG] = ACTIONS(2767),
    [anon_sym_TILDE] = ACTIONS(2767),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_DASH_DASH] = ACTIONS(2767),
    [anon_sym_PLUS_PLUS] = ACTIONS(2767),
    [anon_sym_sizeof] = ACTIONS(2769),
    [sym_number_literal] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(2767),
    [anon_sym_DQUOTE] = ACTIONS(2767),
    [sym_true] = ACTIONS(2769),
    [sym_false] = ACTIONS(2769),
    [sym_null] = ACTIONS(2769),
    [sym_identifier] = ACTIONS(2769),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2769),
    [sym_auto] = ACTIONS(2769),
    [anon_sym_typename] = ACTIONS(2769),
    [anon_sym_delete] = ACTIONS(2769),
    [anon_sym_try] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2769),
    [anon_sym_COLON_COLON] = ACTIONS(2767),
    [sym_nullptr] = ACTIONS(2769),
  },
  [1153] = {
    [sym_declaration] = STATE(1948),
    [sym_type_definition] = STATE(1948),
    [sym__declaration_specifiers] = STATE(1156),
    [sym_compound_statement] = STATE(1948),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_labeled_statement] = STATE(1948),
    [sym_expression_statement] = STATE(1948),
    [sym_if_statement] = STATE(1948),
    [sym_switch_statement] = STATE(1948),
    [sym_case_statement] = STATE(1948),
    [sym_while_statement] = STATE(1948),
    [sym_do_statement] = STATE(1948),
    [sym_for_statement] = STATE(1948),
    [sym_return_statement] = STATE(1948),
    [sym_break_statement] = STATE(1948),
    [sym_continue_statement] = STATE(1948),
    [sym_goto_statement] = STATE(1948),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(1948),
    [sym_try_statement] = STATE(1948),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(157),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_typedef] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(185),
    [anon_sym_case] = ACTIONS(187),
    [anon_sym_default] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(2266),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(1202),
    [sym_nullptr] = ACTIONS(207),
  },
  [1154] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(1362),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_extern] = ACTIONS(468),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(465),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_register] = ACTIONS(468),
    [anon_sym_inline] = ACTIONS(468),
    [anon_sym_const] = ACTIONS(468),
    [anon_sym_restrict] = ACTIONS(468),
    [anon_sym_volatile] = ACTIONS(468),
    [anon_sym__Atomic] = ACTIONS(468),
    [anon_sym_mutable] = ACTIONS(468),
    [anon_sym_explicit] = ACTIONS(468),
    [anon_sym_constexpr] = ACTIONS(468),
    [anon_sym_COLON] = ACTIONS(837),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(474),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_TILDE] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_identifier] = ACTIONS(468),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(2855),
    [sym_operator_name] = ACTIONS(481),
  },
  [1155] = {
    [sym_raw_string_literal] = ACTIONS(2859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2861),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2861),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2861),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2861),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2861),
    [sym_preproc_directive] = ACTIONS(2861),
    [anon_sym_SEMI] = ACTIONS(2859),
    [anon_sym_typedef] = ACTIONS(2861),
    [anon_sym_extern] = ACTIONS(2861),
    [anon_sym_LBRACE] = ACTIONS(2859),
    [anon_sym_RBRACE] = ACTIONS(2859),
    [anon_sym_LPAREN2] = ACTIONS(2859),
    [anon_sym_STAR] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_static] = ACTIONS(2861),
    [anon_sym_register] = ACTIONS(2861),
    [anon_sym_inline] = ACTIONS(2861),
    [anon_sym_const] = ACTIONS(2861),
    [anon_sym_restrict] = ACTIONS(2861),
    [anon_sym_volatile] = ACTIONS(2861),
    [anon_sym__Atomic] = ACTIONS(2861),
    [anon_sym_mutable] = ACTIONS(2861),
    [anon_sym_explicit] = ACTIONS(2861),
    [anon_sym_constexpr] = ACTIONS(2861),
    [anon_sym_unsigned] = ACTIONS(2861),
    [anon_sym_long] = ACTIONS(2861),
    [anon_sym_short] = ACTIONS(2861),
    [sym_primitive_type] = ACTIONS(2861),
    [anon_sym_enum] = ACTIONS(2861),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2861),
    [anon_sym_if] = ACTIONS(2861),
    [anon_sym_else] = ACTIONS(2861),
    [anon_sym_switch] = ACTIONS(2861),
    [anon_sym_case] = ACTIONS(2861),
    [anon_sym_default] = ACTIONS(2861),
    [anon_sym_while] = ACTIONS(2861),
    [anon_sym_do] = ACTIONS(2861),
    [anon_sym_for] = ACTIONS(2861),
    [anon_sym_return] = ACTIONS(2861),
    [anon_sym_break] = ACTIONS(2861),
    [anon_sym_continue] = ACTIONS(2861),
    [anon_sym_goto] = ACTIONS(2861),
    [anon_sym_AMP] = ACTIONS(2859),
    [anon_sym_BANG] = ACTIONS(2859),
    [anon_sym_TILDE] = ACTIONS(2859),
    [anon_sym_PLUS] = ACTIONS(2861),
    [anon_sym_DASH] = ACTIONS(2861),
    [anon_sym_DASH_DASH] = ACTIONS(2859),
    [anon_sym_PLUS_PLUS] = ACTIONS(2859),
    [anon_sym_sizeof] = ACTIONS(2861),
    [sym_number_literal] = ACTIONS(2859),
    [anon_sym_SQUOTE] = ACTIONS(2859),
    [anon_sym_DQUOTE] = ACTIONS(2859),
    [sym_true] = ACTIONS(2861),
    [sym_false] = ACTIONS(2861),
    [sym_null] = ACTIONS(2861),
    [sym_identifier] = ACTIONS(2861),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2861),
    [sym_auto] = ACTIONS(2861),
    [anon_sym_typename] = ACTIONS(2861),
    [anon_sym_delete] = ACTIONS(2861),
    [anon_sym_try] = ACTIONS(2861),
    [anon_sym_new] = ACTIONS(2861),
    [anon_sym_COLON_COLON] = ACTIONS(2859),
    [sym_nullptr] = ACTIONS(2861),
  },
  [1156] = {
    [sym__declarator] = STATE(491),
    [sym_pointer_declarator] = STATE(491),
    [sym_function_declarator] = STATE(491),
    [sym_array_declarator] = STATE(491),
    [sym_init_declarator] = STATE(492),
    [sym_reference_declarator] = STATE(491),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(491),
    [sym_destructor_name] = STATE(491),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(560),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(568),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(841),
  },
  [1157] = {
    [sym_raw_string_literal] = ACTIONS(2867),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2869),
    [sym_preproc_directive] = ACTIONS(2869),
    [anon_sym_SEMI] = ACTIONS(2867),
    [anon_sym_typedef] = ACTIONS(2869),
    [anon_sym_extern] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_RBRACE] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2867),
    [anon_sym_STAR] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_static] = ACTIONS(2869),
    [anon_sym_register] = ACTIONS(2869),
    [anon_sym_inline] = ACTIONS(2869),
    [anon_sym_const] = ACTIONS(2869),
    [anon_sym_restrict] = ACTIONS(2869),
    [anon_sym_volatile] = ACTIONS(2869),
    [anon_sym__Atomic] = ACTIONS(2869),
    [anon_sym_mutable] = ACTIONS(2869),
    [anon_sym_explicit] = ACTIONS(2869),
    [anon_sym_constexpr] = ACTIONS(2869),
    [anon_sym_unsigned] = ACTIONS(2869),
    [anon_sym_long] = ACTIONS(2869),
    [anon_sym_short] = ACTIONS(2869),
    [sym_primitive_type] = ACTIONS(2869),
    [anon_sym_enum] = ACTIONS(2869),
    [anon_sym_struct] = ACTIONS(2869),
    [anon_sym_union] = ACTIONS(2869),
    [anon_sym_if] = ACTIONS(2869),
    [anon_sym_else] = ACTIONS(2869),
    [anon_sym_switch] = ACTIONS(2869),
    [anon_sym_case] = ACTIONS(2869),
    [anon_sym_default] = ACTIONS(2869),
    [anon_sym_while] = ACTIONS(2869),
    [anon_sym_do] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2869),
    [anon_sym_return] = ACTIONS(2869),
    [anon_sym_break] = ACTIONS(2869),
    [anon_sym_continue] = ACTIONS(2869),
    [anon_sym_goto] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_BANG] = ACTIONS(2867),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2869),
    [anon_sym_DASH] = ACTIONS(2869),
    [anon_sym_DASH_DASH] = ACTIONS(2867),
    [anon_sym_PLUS_PLUS] = ACTIONS(2867),
    [anon_sym_sizeof] = ACTIONS(2869),
    [sym_number_literal] = ACTIONS(2867),
    [anon_sym_SQUOTE] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [sym_true] = ACTIONS(2869),
    [sym_false] = ACTIONS(2869),
    [sym_null] = ACTIONS(2869),
    [sym_identifier] = ACTIONS(2869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2869),
    [sym_auto] = ACTIONS(2869),
    [anon_sym_typename] = ACTIONS(2869),
    [anon_sym_delete] = ACTIONS(2869),
    [anon_sym_try] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_COLON_COLON] = ACTIONS(2867),
    [sym_nullptr] = ACTIONS(2869),
  },
  [1158] = {
    [sym_parenthesized_expression] = STATE(1949),
    [anon_sym_LPAREN2] = ACTIONS(323),
    [sym_comment] = ACTIONS(91),
  },
  [1159] = {
    [sym__expression] = STATE(1951),
    [sym_conditional_expression] = STATE(1951),
    [sym_assignment_expression] = STATE(1951),
    [sym_pointer_expression] = STATE(1951),
    [sym_logical_expression] = STATE(1951),
    [sym_bitwise_expression] = STATE(1951),
    [sym_equality_expression] = STATE(1951),
    [sym_relational_expression] = STATE(1951),
    [sym_shift_expression] = STATE(1951),
    [sym_math_expression] = STATE(1951),
    [sym_cast_expression] = STATE(1951),
    [sym_sizeof_expression] = STATE(1951),
    [sym_subscript_expression] = STATE(1951),
    [sym_call_expression] = STATE(1951),
    [sym_field_expression] = STATE(1951),
    [sym_compound_literal_expression] = STATE(1951),
    [sym_parenthesized_expression] = STATE(1951),
    [sym_char_literal] = STATE(1951),
    [sym_concatenated_string] = STATE(1951),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1951),
    [sym_new_expression] = STATE(1951),
    [sym_delete_expression] = STATE(1951),
    [sym_lambda_expression] = STATE(1951),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4106),
    [anon_sym_SEMI] = ACTIONS(4108),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(4106),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4110),
    [sym_false] = ACTIONS(4110),
    [sym_null] = ACTIONS(4110),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(4110),
  },
  [1160] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(4112),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1161] = {
    [anon_sym_COLON] = ACTIONS(4114),
    [sym_comment] = ACTIONS(91),
  },
  [1162] = {
    [sym_raw_string_literal] = ACTIONS(2999),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3001),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3001),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3001),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3001),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3001),
    [sym_preproc_directive] = ACTIONS(3001),
    [anon_sym_SEMI] = ACTIONS(2999),
    [anon_sym_typedef] = ACTIONS(3001),
    [anon_sym_extern] = ACTIONS(3001),
    [anon_sym_LBRACE] = ACTIONS(2999),
    [anon_sym_RBRACE] = ACTIONS(2999),
    [anon_sym_LPAREN2] = ACTIONS(2999),
    [anon_sym_STAR] = ACTIONS(2999),
    [anon_sym_LBRACK] = ACTIONS(2999),
    [anon_sym_static] = ACTIONS(3001),
    [anon_sym_register] = ACTIONS(3001),
    [anon_sym_inline] = ACTIONS(3001),
    [anon_sym_const] = ACTIONS(3001),
    [anon_sym_restrict] = ACTIONS(3001),
    [anon_sym_volatile] = ACTIONS(3001),
    [anon_sym__Atomic] = ACTIONS(3001),
    [anon_sym_mutable] = ACTIONS(3001),
    [anon_sym_explicit] = ACTIONS(3001),
    [anon_sym_constexpr] = ACTIONS(3001),
    [anon_sym_unsigned] = ACTIONS(3001),
    [anon_sym_long] = ACTIONS(3001),
    [anon_sym_short] = ACTIONS(3001),
    [sym_primitive_type] = ACTIONS(3001),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_struct] = ACTIONS(3001),
    [anon_sym_union] = ACTIONS(3001),
    [anon_sym_if] = ACTIONS(3001),
    [anon_sym_else] = ACTIONS(3001),
    [anon_sym_switch] = ACTIONS(3001),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3001),
    [anon_sym_while] = ACTIONS(3001),
    [anon_sym_do] = ACTIONS(3001),
    [anon_sym_for] = ACTIONS(3001),
    [anon_sym_return] = ACTIONS(3001),
    [anon_sym_break] = ACTIONS(3001),
    [anon_sym_continue] = ACTIONS(3001),
    [anon_sym_goto] = ACTIONS(3001),
    [anon_sym_AMP] = ACTIONS(2999),
    [anon_sym_BANG] = ACTIONS(2999),
    [anon_sym_TILDE] = ACTIONS(2999),
    [anon_sym_PLUS] = ACTIONS(3001),
    [anon_sym_DASH] = ACTIONS(3001),
    [anon_sym_DASH_DASH] = ACTIONS(2999),
    [anon_sym_PLUS_PLUS] = ACTIONS(2999),
    [anon_sym_sizeof] = ACTIONS(3001),
    [sym_number_literal] = ACTIONS(2999),
    [anon_sym_SQUOTE] = ACTIONS(2999),
    [anon_sym_DQUOTE] = ACTIONS(2999),
    [sym_true] = ACTIONS(3001),
    [sym_false] = ACTIONS(3001),
    [sym_null] = ACTIONS(3001),
    [sym_identifier] = ACTIONS(3001),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3001),
    [sym_auto] = ACTIONS(3001),
    [anon_sym_typename] = ACTIONS(3001),
    [anon_sym_delete] = ACTIONS(3001),
    [anon_sym_try] = ACTIONS(3001),
    [anon_sym_new] = ACTIONS(3001),
    [anon_sym_COLON_COLON] = ACTIONS(2999),
    [sym_nullptr] = ACTIONS(3001),
  },
  [1163] = {
    [sym_raw_string_literal] = ACTIONS(3047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3049),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3049),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3049),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3049),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3049),
    [sym_preproc_directive] = ACTIONS(3049),
    [anon_sym_SEMI] = ACTIONS(3047),
    [anon_sym_typedef] = ACTIONS(3049),
    [anon_sym_extern] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(3047),
    [anon_sym_RBRACE] = ACTIONS(3047),
    [anon_sym_LPAREN2] = ACTIONS(3047),
    [anon_sym_STAR] = ACTIONS(3047),
    [anon_sym_LBRACK] = ACTIONS(3047),
    [anon_sym_static] = ACTIONS(3049),
    [anon_sym_register] = ACTIONS(3049),
    [anon_sym_inline] = ACTIONS(3049),
    [anon_sym_const] = ACTIONS(3049),
    [anon_sym_restrict] = ACTIONS(3049),
    [anon_sym_volatile] = ACTIONS(3049),
    [anon_sym__Atomic] = ACTIONS(3049),
    [anon_sym_mutable] = ACTIONS(3049),
    [anon_sym_explicit] = ACTIONS(3049),
    [anon_sym_constexpr] = ACTIONS(3049),
    [anon_sym_unsigned] = ACTIONS(3049),
    [anon_sym_long] = ACTIONS(3049),
    [anon_sym_short] = ACTIONS(3049),
    [sym_primitive_type] = ACTIONS(3049),
    [anon_sym_enum] = ACTIONS(3049),
    [anon_sym_struct] = ACTIONS(3049),
    [anon_sym_union] = ACTIONS(3049),
    [anon_sym_if] = ACTIONS(3049),
    [anon_sym_else] = ACTIONS(3049),
    [anon_sym_switch] = ACTIONS(3049),
    [anon_sym_case] = ACTIONS(3049),
    [anon_sym_default] = ACTIONS(3049),
    [anon_sym_while] = ACTIONS(3049),
    [anon_sym_do] = ACTIONS(3049),
    [anon_sym_for] = ACTIONS(3049),
    [anon_sym_return] = ACTIONS(3049),
    [anon_sym_break] = ACTIONS(3049),
    [anon_sym_continue] = ACTIONS(3049),
    [anon_sym_goto] = ACTIONS(3049),
    [anon_sym_AMP] = ACTIONS(3047),
    [anon_sym_BANG] = ACTIONS(3047),
    [anon_sym_TILDE] = ACTIONS(3047),
    [anon_sym_PLUS] = ACTIONS(3049),
    [anon_sym_DASH] = ACTIONS(3049),
    [anon_sym_DASH_DASH] = ACTIONS(3047),
    [anon_sym_PLUS_PLUS] = ACTIONS(3047),
    [anon_sym_sizeof] = ACTIONS(3049),
    [sym_number_literal] = ACTIONS(3047),
    [anon_sym_SQUOTE] = ACTIONS(3047),
    [anon_sym_DQUOTE] = ACTIONS(3047),
    [sym_true] = ACTIONS(3049),
    [sym_false] = ACTIONS(3049),
    [sym_null] = ACTIONS(3049),
    [sym_identifier] = ACTIONS(3049),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3049),
    [sym_auto] = ACTIONS(3049),
    [anon_sym_typename] = ACTIONS(3049),
    [anon_sym_delete] = ACTIONS(3049),
    [anon_sym_try] = ACTIONS(3049),
    [anon_sym_new] = ACTIONS(3049),
    [anon_sym_COLON_COLON] = ACTIONS(3047),
    [sym_nullptr] = ACTIONS(3049),
  },
  [1164] = {
    [sym_raw_string_literal] = ACTIONS(3072),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3074),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3074),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3074),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3074),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3074),
    [sym_preproc_directive] = ACTIONS(3074),
    [anon_sym_SEMI] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3074),
    [anon_sym_extern] = ACTIONS(3074),
    [anon_sym_LBRACE] = ACTIONS(3072),
    [anon_sym_RBRACE] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3074),
    [anon_sym_register] = ACTIONS(3074),
    [anon_sym_inline] = ACTIONS(3074),
    [anon_sym_const] = ACTIONS(3074),
    [anon_sym_restrict] = ACTIONS(3074),
    [anon_sym_volatile] = ACTIONS(3074),
    [anon_sym__Atomic] = ACTIONS(3074),
    [anon_sym_mutable] = ACTIONS(3074),
    [anon_sym_explicit] = ACTIONS(3074),
    [anon_sym_constexpr] = ACTIONS(3074),
    [anon_sym_unsigned] = ACTIONS(3074),
    [anon_sym_long] = ACTIONS(3074),
    [anon_sym_short] = ACTIONS(3074),
    [sym_primitive_type] = ACTIONS(3074),
    [anon_sym_enum] = ACTIONS(3074),
    [anon_sym_struct] = ACTIONS(3074),
    [anon_sym_union] = ACTIONS(3074),
    [anon_sym_if] = ACTIONS(3074),
    [anon_sym_else] = ACTIONS(3074),
    [anon_sym_switch] = ACTIONS(3074),
    [anon_sym_case] = ACTIONS(3074),
    [anon_sym_default] = ACTIONS(3074),
    [anon_sym_while] = ACTIONS(3074),
    [anon_sym_do] = ACTIONS(3074),
    [anon_sym_for] = ACTIONS(3074),
    [anon_sym_return] = ACTIONS(3074),
    [anon_sym_break] = ACTIONS(3074),
    [anon_sym_continue] = ACTIONS(3074),
    [anon_sym_goto] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_BANG] = ACTIONS(3072),
    [anon_sym_TILDE] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3074),
    [anon_sym_DASH_DASH] = ACTIONS(3072),
    [anon_sym_PLUS_PLUS] = ACTIONS(3072),
    [anon_sym_sizeof] = ACTIONS(3074),
    [sym_number_literal] = ACTIONS(3072),
    [anon_sym_SQUOTE] = ACTIONS(3072),
    [anon_sym_DQUOTE] = ACTIONS(3072),
    [sym_true] = ACTIONS(3074),
    [sym_false] = ACTIONS(3074),
    [sym_null] = ACTIONS(3074),
    [sym_identifier] = ACTIONS(3074),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3074),
    [sym_auto] = ACTIONS(3074),
    [anon_sym_typename] = ACTIONS(3074),
    [anon_sym_delete] = ACTIONS(3074),
    [anon_sym_try] = ACTIONS(3074),
    [anon_sym_new] = ACTIONS(3074),
    [anon_sym_COLON_COLON] = ACTIONS(3072),
    [sym_nullptr] = ACTIONS(3074),
  },
  [1165] = {
    [sym_parameter_list] = STATE(1954),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [sym_comment] = ACTIONS(91),
  },
  [1166] = {
    [sym_catch_clause] = STATE(1955),
    [aux_sym_try_statement_repeat1] = STATE(1955),
    [sym_raw_string_literal] = ACTIONS(3346),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3348),
    [sym_preproc_directive] = ACTIONS(3348),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym_typedef] = ACTIONS(3348),
    [anon_sym_extern] = ACTIONS(3348),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_RBRACE] = ACTIONS(3346),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(3346),
    [anon_sym_static] = ACTIONS(3348),
    [anon_sym_register] = ACTIONS(3348),
    [anon_sym_inline] = ACTIONS(3348),
    [anon_sym_const] = ACTIONS(3348),
    [anon_sym_restrict] = ACTIONS(3348),
    [anon_sym_volatile] = ACTIONS(3348),
    [anon_sym__Atomic] = ACTIONS(3348),
    [anon_sym_mutable] = ACTIONS(3348),
    [anon_sym_explicit] = ACTIONS(3348),
    [anon_sym_constexpr] = ACTIONS(3348),
    [anon_sym_unsigned] = ACTIONS(3348),
    [anon_sym_long] = ACTIONS(3348),
    [anon_sym_short] = ACTIONS(3348),
    [sym_primitive_type] = ACTIONS(3348),
    [anon_sym_enum] = ACTIONS(3348),
    [anon_sym_struct] = ACTIONS(3348),
    [anon_sym_union] = ACTIONS(3348),
    [anon_sym_if] = ACTIONS(3348),
    [anon_sym_switch] = ACTIONS(3348),
    [anon_sym_case] = ACTIONS(3348),
    [anon_sym_default] = ACTIONS(3348),
    [anon_sym_while] = ACTIONS(3348),
    [anon_sym_do] = ACTIONS(3348),
    [anon_sym_for] = ACTIONS(3348),
    [anon_sym_return] = ACTIONS(3348),
    [anon_sym_break] = ACTIONS(3348),
    [anon_sym_continue] = ACTIONS(3348),
    [anon_sym_goto] = ACTIONS(3348),
    [anon_sym_AMP] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_PLUS] = ACTIONS(3348),
    [anon_sym_DASH] = ACTIONS(3348),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_sizeof] = ACTIONS(3348),
    [sym_number_literal] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [sym_true] = ACTIONS(3348),
    [sym_false] = ACTIONS(3348),
    [sym_null] = ACTIONS(3348),
    [sym_identifier] = ACTIONS(3348),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3348),
    [sym_auto] = ACTIONS(3348),
    [anon_sym_typename] = ACTIONS(3348),
    [anon_sym_delete] = ACTIONS(3348),
    [anon_sym_try] = ACTIONS(3348),
    [anon_sym_catch] = ACTIONS(4116),
    [anon_sym_new] = ACTIONS(3348),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [sym_nullptr] = ACTIONS(3348),
  },
  [1167] = {
    [sym_raw_string_literal] = ACTIONS(3397),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3399),
    [sym_preproc_directive] = ACTIONS(3399),
    [anon_sym_SEMI] = ACTIONS(3397),
    [anon_sym_typedef] = ACTIONS(3399),
    [anon_sym_extern] = ACTIONS(3399),
    [anon_sym_LBRACE] = ACTIONS(3397),
    [anon_sym_RBRACE] = ACTIONS(3397),
    [anon_sym_LPAREN2] = ACTIONS(3397),
    [anon_sym_STAR] = ACTIONS(3397),
    [anon_sym_LBRACK] = ACTIONS(3397),
    [anon_sym_static] = ACTIONS(3399),
    [anon_sym_register] = ACTIONS(3399),
    [anon_sym_inline] = ACTIONS(3399),
    [anon_sym_const] = ACTIONS(3399),
    [anon_sym_restrict] = ACTIONS(3399),
    [anon_sym_volatile] = ACTIONS(3399),
    [anon_sym__Atomic] = ACTIONS(3399),
    [anon_sym_mutable] = ACTIONS(3399),
    [anon_sym_explicit] = ACTIONS(3399),
    [anon_sym_constexpr] = ACTIONS(3399),
    [anon_sym_unsigned] = ACTIONS(3399),
    [anon_sym_long] = ACTIONS(3399),
    [anon_sym_short] = ACTIONS(3399),
    [sym_primitive_type] = ACTIONS(3399),
    [anon_sym_enum] = ACTIONS(3399),
    [anon_sym_struct] = ACTIONS(3399),
    [anon_sym_union] = ACTIONS(3399),
    [anon_sym_if] = ACTIONS(3399),
    [anon_sym_else] = ACTIONS(3399),
    [anon_sym_switch] = ACTIONS(3399),
    [anon_sym_case] = ACTIONS(3399),
    [anon_sym_default] = ACTIONS(3399),
    [anon_sym_while] = ACTIONS(3399),
    [anon_sym_do] = ACTIONS(3399),
    [anon_sym_for] = ACTIONS(3399),
    [anon_sym_return] = ACTIONS(3399),
    [anon_sym_break] = ACTIONS(3399),
    [anon_sym_continue] = ACTIONS(3399),
    [anon_sym_goto] = ACTIONS(3399),
    [anon_sym_AMP] = ACTIONS(3397),
    [anon_sym_BANG] = ACTIONS(3397),
    [anon_sym_TILDE] = ACTIONS(3397),
    [anon_sym_PLUS] = ACTIONS(3399),
    [anon_sym_DASH] = ACTIONS(3399),
    [anon_sym_DASH_DASH] = ACTIONS(3397),
    [anon_sym_PLUS_PLUS] = ACTIONS(3397),
    [anon_sym_sizeof] = ACTIONS(3399),
    [sym_number_literal] = ACTIONS(3397),
    [anon_sym_SQUOTE] = ACTIONS(3397),
    [anon_sym_DQUOTE] = ACTIONS(3397),
    [sym_true] = ACTIONS(3399),
    [sym_false] = ACTIONS(3399),
    [sym_null] = ACTIONS(3399),
    [sym_identifier] = ACTIONS(3399),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3399),
    [sym_auto] = ACTIONS(3399),
    [anon_sym_typename] = ACTIONS(3399),
    [anon_sym_delete] = ACTIONS(3399),
    [anon_sym_try] = ACTIONS(3399),
    [anon_sym_new] = ACTIONS(3399),
    [anon_sym_COLON_COLON] = ACTIONS(3397),
    [sym_nullptr] = ACTIONS(3399),
  },
  [1168] = {
    [aux_sym_declaration_repeat1] = STATE(1643),
    [anon_sym_COMMA] = ACTIONS(1613),
    [anon_sym_SEMI] = ACTIONS(4118),
    [sym_comment] = ACTIONS(91),
  },
  [1169] = {
    [sym__expression] = STATE(1957),
    [sym_conditional_expression] = STATE(1957),
    [sym_assignment_expression] = STATE(1957),
    [sym_pointer_expression] = STATE(1957),
    [sym_logical_expression] = STATE(1957),
    [sym_bitwise_expression] = STATE(1957),
    [sym_equality_expression] = STATE(1957),
    [sym_relational_expression] = STATE(1957),
    [sym_shift_expression] = STATE(1957),
    [sym_math_expression] = STATE(1957),
    [sym_cast_expression] = STATE(1957),
    [sym_sizeof_expression] = STATE(1957),
    [sym_subscript_expression] = STATE(1957),
    [sym_call_expression] = STATE(1957),
    [sym_field_expression] = STATE(1957),
    [sym_compound_literal_expression] = STATE(1957),
    [sym_parenthesized_expression] = STATE(1957),
    [sym_initializer_list] = STATE(1958),
    [sym_char_literal] = STATE(1957),
    [sym_concatenated_string] = STATE(1957),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1957),
    [sym_new_expression] = STATE(1957),
    [sym_delete_expression] = STATE(1957),
    [sym_lambda_expression] = STATE(1957),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4120),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(4120),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4122),
    [sym_false] = ACTIONS(4122),
    [sym_null] = ACTIONS(4122),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(4122),
  },
  [1170] = {
    [anon_sym_SEMI] = ACTIONS(4124),
    [sym_comment] = ACTIONS(91),
  },
  [1171] = {
    [sym__expression] = STATE(1200),
    [sym_conditional_expression] = STATE(1200),
    [sym_assignment_expression] = STATE(1200),
    [sym_pointer_expression] = STATE(1200),
    [sym_logical_expression] = STATE(1200),
    [sym_bitwise_expression] = STATE(1200),
    [sym_equality_expression] = STATE(1200),
    [sym_relational_expression] = STATE(1200),
    [sym_shift_expression] = STATE(1200),
    [sym_math_expression] = STATE(1200),
    [sym_cast_expression] = STATE(1200),
    [sym_sizeof_expression] = STATE(1200),
    [sym_subscript_expression] = STATE(1200),
    [sym_call_expression] = STATE(1200),
    [sym_field_expression] = STATE(1200),
    [sym_compound_literal_expression] = STATE(1200),
    [sym_parenthesized_expression] = STATE(1200),
    [sym_initializer_list] = STATE(1201),
    [sym_char_literal] = STATE(1200),
    [sym_concatenated_string] = STATE(1200),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1200),
    [sym_new_expression] = STATE(1200),
    [sym_delete_expression] = STATE(1200),
    [sym_lambda_expression] = STATE(1200),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2523),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(2523),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2525),
    [sym_false] = ACTIONS(2525),
    [sym_null] = ACTIONS(2525),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(2525),
  },
  [1172] = {
    [sym_parameter_list] = STATE(524),
    [anon_sym_RPAREN] = ACTIONS(4126),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(574),
    [sym_comment] = ACTIONS(91),
  },
  [1173] = {
    [anon_sym_RPAREN] = ACTIONS(4128),
    [sym_comment] = ACTIONS(91),
  },
  [1174] = {
    [sym__expression] = STATE(1961),
    [sym_conditional_expression] = STATE(1961),
    [sym_assignment_expression] = STATE(1961),
    [sym_pointer_expression] = STATE(1961),
    [sym_logical_expression] = STATE(1961),
    [sym_bitwise_expression] = STATE(1961),
    [sym_equality_expression] = STATE(1961),
    [sym_relational_expression] = STATE(1961),
    [sym_shift_expression] = STATE(1961),
    [sym_math_expression] = STATE(1961),
    [sym_cast_expression] = STATE(1961),
    [sym_sizeof_expression] = STATE(1961),
    [sym_subscript_expression] = STATE(1961),
    [sym_call_expression] = STATE(1961),
    [sym_field_expression] = STATE(1961),
    [sym_compound_literal_expression] = STATE(1961),
    [sym_parenthesized_expression] = STATE(1961),
    [sym_char_literal] = STATE(1961),
    [sym_concatenated_string] = STATE(1961),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1961),
    [sym_new_expression] = STATE(1961),
    [sym_delete_expression] = STATE(1961),
    [sym_lambda_expression] = STATE(1961),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4130),
    [anon_sym_LPAREN2] = ACTIONS(947),
    [anon_sym_STAR] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(947),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(4130),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4132),
    [sym_false] = ACTIONS(4132),
    [sym_null] = ACTIONS(4132),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(4132),
  },
  [1175] = {
    [sym__expression] = STATE(1962),
    [sym_conditional_expression] = STATE(1962),
    [sym_assignment_expression] = STATE(1962),
    [sym_pointer_expression] = STATE(1962),
    [sym_logical_expression] = STATE(1962),
    [sym_bitwise_expression] = STATE(1962),
    [sym_equality_expression] = STATE(1962),
    [sym_relational_expression] = STATE(1962),
    [sym_shift_expression] = STATE(1962),
    [sym_math_expression] = STATE(1962),
    [sym_cast_expression] = STATE(1962),
    [sym_sizeof_expression] = STATE(1962),
    [sym_subscript_expression] = STATE(1962),
    [sym_call_expression] = STATE(1962),
    [sym_field_expression] = STATE(1962),
    [sym_compound_literal_expression] = STATE(1962),
    [sym_parenthesized_expression] = STATE(1962),
    [sym_char_literal] = STATE(1962),
    [sym_concatenated_string] = STATE(1962),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1962),
    [sym_new_expression] = STATE(1962),
    [sym_delete_expression] = STATE(1962),
    [sym_lambda_expression] = STATE(1962),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4134),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(4134),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4136),
    [sym_false] = ACTIONS(4136),
    [sym_null] = ACTIONS(4136),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(4136),
  },
  [1176] = {
    [sym_argument_list] = STATE(1610),
    [sym_initializer_list] = STATE(1610),
    [sym_new_declarator] = STATE(1611),
    [anon_sym_COMMA] = ACTIONS(3372),
    [anon_sym_RPAREN] = ACTIONS(3372),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3374),
    [anon_sym_LBRACK] = ACTIONS(2443),
    [anon_sym_EQ] = ACTIONS(3374),
    [anon_sym_QMARK] = ACTIONS(3372),
    [anon_sym_STAR_EQ] = ACTIONS(3372),
    [anon_sym_SLASH_EQ] = ACTIONS(3372),
    [anon_sym_PERCENT_EQ] = ACTIONS(3372),
    [anon_sym_PLUS_EQ] = ACTIONS(3372),
    [anon_sym_DASH_EQ] = ACTIONS(3372),
    [anon_sym_LT_LT_EQ] = ACTIONS(3372),
    [anon_sym_GT_GT_EQ] = ACTIONS(3372),
    [anon_sym_AMP_EQ] = ACTIONS(3372),
    [anon_sym_CARET_EQ] = ACTIONS(3372),
    [anon_sym_PIPE_EQ] = ACTIONS(3372),
    [anon_sym_AMP] = ACTIONS(3374),
    [anon_sym_PIPE_PIPE] = ACTIONS(3372),
    [anon_sym_AMP_AMP] = ACTIONS(3372),
    [anon_sym_PIPE] = ACTIONS(3374),
    [anon_sym_CARET] = ACTIONS(3374),
    [anon_sym_EQ_EQ] = ACTIONS(3372),
    [anon_sym_BANG_EQ] = ACTIONS(3372),
    [anon_sym_LT] = ACTIONS(3374),
    [anon_sym_GT] = ACTIONS(3374),
    [anon_sym_LT_EQ] = ACTIONS(3372),
    [anon_sym_GT_EQ] = ACTIONS(3372),
    [anon_sym_LT_LT] = ACTIONS(3374),
    [anon_sym_GT_GT] = ACTIONS(3374),
    [anon_sym_PLUS] = ACTIONS(3374),
    [anon_sym_DASH] = ACTIONS(3374),
    [anon_sym_SLASH] = ACTIONS(3374),
    [anon_sym_PERCENT] = ACTIONS(3374),
    [anon_sym_DASH_DASH] = ACTIONS(3372),
    [anon_sym_PLUS_PLUS] = ACTIONS(3372),
    [anon_sym_DOT] = ACTIONS(3372),
    [anon_sym_DASH_GT] = ACTIONS(3372),
    [sym_comment] = ACTIONS(91),
  },
  [1177] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1177),
    [anon_sym_COMMA] = ACTIONS(1985),
    [anon_sym_RPAREN] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(1985),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_EQ] = ACTIONS(1987),
    [anon_sym_unsigned] = ACTIONS(4138),
    [anon_sym_long] = ACTIONS(4138),
    [anon_sym_short] = ACTIONS(4138),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_QMARK] = ACTIONS(1985),
    [anon_sym_STAR_EQ] = ACTIONS(1985),
    [anon_sym_SLASH_EQ] = ACTIONS(1985),
    [anon_sym_PERCENT_EQ] = ACTIONS(1985),
    [anon_sym_PLUS_EQ] = ACTIONS(1985),
    [anon_sym_DASH_EQ] = ACTIONS(1985),
    [anon_sym_LT_LT_EQ] = ACTIONS(1985),
    [anon_sym_GT_GT_EQ] = ACTIONS(1985),
    [anon_sym_AMP_EQ] = ACTIONS(1985),
    [anon_sym_CARET_EQ] = ACTIONS(1985),
    [anon_sym_PIPE_EQ] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_PIPE_PIPE] = ACTIONS(1985),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_PIPE] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1987),
    [anon_sym_EQ_EQ] = ACTIONS(1985),
    [anon_sym_BANG_EQ] = ACTIONS(1985),
    [anon_sym_LT] = ACTIONS(1987),
    [anon_sym_GT] = ACTIONS(1987),
    [anon_sym_LT_EQ] = ACTIONS(1985),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_LT] = ACTIONS(1987),
    [anon_sym_GT_GT] = ACTIONS(1987),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_DASH] = ACTIONS(1987),
    [anon_sym_SLASH] = ACTIONS(1987),
    [anon_sym_PERCENT] = ACTIONS(1987),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DOT] = ACTIONS(1985),
    [anon_sym_DASH_GT] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [sym_comment] = ACTIONS(91),
  },
  [1178] = {
    [sym__expression] = STATE(164),
    [sym_conditional_expression] = STATE(164),
    [sym_assignment_expression] = STATE(164),
    [sym_pointer_expression] = STATE(164),
    [sym_logical_expression] = STATE(164),
    [sym_bitwise_expression] = STATE(164),
    [sym_equality_expression] = STATE(164),
    [sym_relational_expression] = STATE(164),
    [sym_shift_expression] = STATE(164),
    [sym_math_expression] = STATE(164),
    [sym_cast_expression] = STATE(164),
    [sym_sizeof_expression] = STATE(164),
    [sym_subscript_expression] = STATE(164),
    [sym_call_expression] = STATE(164),
    [sym_field_expression] = STATE(164),
    [sym_compound_literal_expression] = STATE(164),
    [sym_parenthesized_expression] = STATE(164),
    [sym_char_literal] = STATE(164),
    [sym_concatenated_string] = STATE(164),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(164),
    [sym_new_expression] = STATE(164),
    [sym_delete_expression] = STATE(164),
    [sym_lambda_expression] = STATE(164),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_lambda_default_capture] = STATE(166),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(267),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(4141),
    [anon_sym_EQ] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(267),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(289),
    [sym_false] = ACTIONS(289),
    [sym_null] = ACTIONS(289),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(289),
  },
  [1179] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3383),
    [anon_sym_RPAREN] = ACTIONS(3383),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3385),
    [anon_sym_QMARK] = ACTIONS(3383),
    [anon_sym_STAR_EQ] = ACTIONS(3383),
    [anon_sym_SLASH_EQ] = ACTIONS(3383),
    [anon_sym_PERCENT_EQ] = ACTIONS(3383),
    [anon_sym_PLUS_EQ] = ACTIONS(3383),
    [anon_sym_DASH_EQ] = ACTIONS(3383),
    [anon_sym_LT_LT_EQ] = ACTIONS(3383),
    [anon_sym_GT_GT_EQ] = ACTIONS(3383),
    [anon_sym_AMP_EQ] = ACTIONS(3383),
    [anon_sym_CARET_EQ] = ACTIONS(3383),
    [anon_sym_PIPE_EQ] = ACTIONS(3383),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1180] = {
    [sym__type_specifier] = STATE(1968),
    [sym_sized_type_specifier] = STATE(1968),
    [sym_enum_specifier] = STATE(1968),
    [sym_struct_specifier] = STATE(1968),
    [sym_union_specifier] = STATE(1968),
    [sym_macro_type_specifier] = STATE(1968),
    [sym_class_specifier] = STATE(1968),
    [sym_dependent_type] = STATE(1968),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1969),
    [anon_sym_unsigned] = ACTIONS(4143),
    [anon_sym_long] = ACTIONS(4143),
    [anon_sym_short] = ACTIONS(4143),
    [sym_primitive_type] = ACTIONS(4145),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(4147),
    [anon_sym_union] = ACTIONS(4149),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4151),
    [sym_auto] = ACTIONS(4145),
    [anon_sym_typename] = ACTIONS(4153),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [1181] = {
    [sym_type_qualifier] = STATE(1970),
    [sym_virtual_specifier] = STATE(1970),
    [sym_trailing_return_type] = STATE(1970),
    [aux_sym_function_declarator_repeat1] = STATE(1970),
    [anon_sym_RPAREN] = ACTIONS(3549),
    [anon_sym_LPAREN2] = ACTIONS(3549),
    [anon_sym_LBRACK] = ACTIONS(3549),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(2457),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [sym_noexcept] = ACTIONS(4155),
  },
  [1182] = {
    [sym_parameter_list] = STATE(1185),
    [anon_sym_RPAREN] = ACTIONS(4157),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [sym_comment] = ACTIONS(91),
  },
  [1183] = {
    [sym__abstract_declarator] = STATE(1971),
    [sym_abstract_pointer_declarator] = STATE(1971),
    [sym_abstract_function_declarator] = STATE(1971),
    [sym_abstract_array_declarator] = STATE(1971),
    [sym_type_qualifier] = STATE(1972),
    [sym_parameter_list] = STATE(528),
    [sym_abstract_reference_declarator] = STATE(1971),
    [aux_sym_type_definition_repeat1] = STATE(1972),
    [anon_sym_RPAREN] = ACTIONS(4157),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_AMP_AMP] = ACTIONS(893),
    [sym_comment] = ACTIONS(91),
  },
  [1184] = {
    [sym_parameter_list] = STATE(1185),
    [anon_sym_RPAREN] = ACTIONS(4159),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [sym_comment] = ACTIONS(91),
  },
  [1185] = {
    [sym_type_qualifier] = STATE(1973),
    [sym_trailing_return_type] = STATE(1720),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1973),
    [anon_sym_RPAREN] = ACTIONS(3663),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(2467),
    [sym_comment] = ACTIONS(91),
    [sym_noexcept] = ACTIONS(4161),
  },
  [1186] = {
    [sym__type_specifier] = STATE(1974),
    [sym_sized_type_specifier] = STATE(1974),
    [sym_enum_specifier] = STATE(1974),
    [sym_struct_specifier] = STATE(1974),
    [sym_union_specifier] = STATE(1974),
    [sym_macro_type_specifier] = STATE(1974),
    [sym_class_specifier] = STATE(1974),
    [sym_dependent_type] = STATE(1974),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_sized_type_specifier_repeat1] = STATE(142),
    [anon_sym_unsigned] = ACTIONS(219),
    [anon_sym_long] = ACTIONS(219),
    [anon_sym_short] = ACTIONS(219),
    [sym_primitive_type] = ACTIONS(4163),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(4163),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [1187] = {
    [sym_type_qualifier] = STATE(1975),
    [sym_trailing_return_type] = STATE(1720),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1975),
    [anon_sym_RPAREN] = ACTIONS(3663),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(2467),
    [sym_comment] = ACTIONS(91),
    [sym_noexcept] = ACTIONS(4165),
  },
  [1188] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(895),
    [anon_sym_RPAREN] = ACTIONS(3573),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1189] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3581),
    [anon_sym_RPAREN] = ACTIONS(3581),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(3581),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1190] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_COLON] = ACTIONS(4167),
    [anon_sym_QMARK] = ACTIONS(1171),
    [anon_sym_STAR_EQ] = ACTIONS(1173),
    [anon_sym_SLASH_EQ] = ACTIONS(1173),
    [anon_sym_PERCENT_EQ] = ACTIONS(1173),
    [anon_sym_PLUS_EQ] = ACTIONS(1173),
    [anon_sym_DASH_EQ] = ACTIONS(1173),
    [anon_sym_LT_LT_EQ] = ACTIONS(1173),
    [anon_sym_GT_GT_EQ] = ACTIONS(1173),
    [anon_sym_AMP_EQ] = ACTIONS(1173),
    [anon_sym_CARET_EQ] = ACTIONS(1173),
    [anon_sym_PIPE_EQ] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_CARET] = ACTIONS(1183),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [1191] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3585),
    [anon_sym_RPAREN] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_STAR_EQ] = ACTIONS(3585),
    [anon_sym_SLASH_EQ] = ACTIONS(3585),
    [anon_sym_PERCENT_EQ] = ACTIONS(3585),
    [anon_sym_PLUS_EQ] = ACTIONS(3585),
    [anon_sym_DASH_EQ] = ACTIONS(3585),
    [anon_sym_LT_LT_EQ] = ACTIONS(3585),
    [anon_sym_GT_GT_EQ] = ACTIONS(3585),
    [anon_sym_AMP_EQ] = ACTIONS(3585),
    [anon_sym_CARET_EQ] = ACTIONS(3585),
    [anon_sym_PIPE_EQ] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(3587),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3587),
    [anon_sym_CARET] = ACTIONS(3587),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1192] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3589),
    [anon_sym_RPAREN] = ACTIONS(3589),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3591),
    [anon_sym_QMARK] = ACTIONS(3589),
    [anon_sym_STAR_EQ] = ACTIONS(3589),
    [anon_sym_SLASH_EQ] = ACTIONS(3589),
    [anon_sym_PERCENT_EQ] = ACTIONS(3589),
    [anon_sym_PLUS_EQ] = ACTIONS(3589),
    [anon_sym_DASH_EQ] = ACTIONS(3589),
    [anon_sym_LT_LT_EQ] = ACTIONS(3589),
    [anon_sym_GT_GT_EQ] = ACTIONS(3589),
    [anon_sym_AMP_EQ] = ACTIONS(3589),
    [anon_sym_CARET_EQ] = ACTIONS(3589),
    [anon_sym_PIPE_EQ] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(3589),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1193] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3589),
    [anon_sym_RPAREN] = ACTIONS(3589),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3591),
    [anon_sym_QMARK] = ACTIONS(3589),
    [anon_sym_STAR_EQ] = ACTIONS(3589),
    [anon_sym_SLASH_EQ] = ACTIONS(3589),
    [anon_sym_PERCENT_EQ] = ACTIONS(3589),
    [anon_sym_PLUS_EQ] = ACTIONS(3589),
    [anon_sym_DASH_EQ] = ACTIONS(3589),
    [anon_sym_LT_LT_EQ] = ACTIONS(3589),
    [anon_sym_GT_GT_EQ] = ACTIONS(3589),
    [anon_sym_AMP_EQ] = ACTIONS(3589),
    [anon_sym_CARET_EQ] = ACTIONS(3589),
    [anon_sym_PIPE_EQ] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(3589),
    [anon_sym_AMP_AMP] = ACTIONS(3589),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1194] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3585),
    [anon_sym_RPAREN] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_STAR_EQ] = ACTIONS(3585),
    [anon_sym_SLASH_EQ] = ACTIONS(3585),
    [anon_sym_PERCENT_EQ] = ACTIONS(3585),
    [anon_sym_PLUS_EQ] = ACTIONS(3585),
    [anon_sym_DASH_EQ] = ACTIONS(3585),
    [anon_sym_LT_LT_EQ] = ACTIONS(3585),
    [anon_sym_GT_GT_EQ] = ACTIONS(3585),
    [anon_sym_AMP_EQ] = ACTIONS(3585),
    [anon_sym_CARET_EQ] = ACTIONS(3585),
    [anon_sym_PIPE_EQ] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3587),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1195] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3585),
    [anon_sym_RPAREN] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_STAR_EQ] = ACTIONS(3585),
    [anon_sym_SLASH_EQ] = ACTIONS(3585),
    [anon_sym_PERCENT_EQ] = ACTIONS(3585),
    [anon_sym_PLUS_EQ] = ACTIONS(3585),
    [anon_sym_DASH_EQ] = ACTIONS(3585),
    [anon_sym_LT_LT_EQ] = ACTIONS(3585),
    [anon_sym_GT_GT_EQ] = ACTIONS(3585),
    [anon_sym_AMP_EQ] = ACTIONS(3585),
    [anon_sym_CARET_EQ] = ACTIONS(3585),
    [anon_sym_PIPE_EQ] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3587),
    [anon_sym_CARET] = ACTIONS(3587),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1196] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3593),
    [anon_sym_RPAREN] = ACTIONS(3593),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3595),
    [anon_sym_QMARK] = ACTIONS(3593),
    [anon_sym_STAR_EQ] = ACTIONS(3593),
    [anon_sym_SLASH_EQ] = ACTIONS(3593),
    [anon_sym_PERCENT_EQ] = ACTIONS(3593),
    [anon_sym_PLUS_EQ] = ACTIONS(3593),
    [anon_sym_DASH_EQ] = ACTIONS(3593),
    [anon_sym_LT_LT_EQ] = ACTIONS(3593),
    [anon_sym_GT_GT_EQ] = ACTIONS(3593),
    [anon_sym_AMP_EQ] = ACTIONS(3593),
    [anon_sym_CARET_EQ] = ACTIONS(3593),
    [anon_sym_PIPE_EQ] = ACTIONS(3593),
    [anon_sym_AMP] = ACTIONS(3595),
    [anon_sym_PIPE_PIPE] = ACTIONS(3593),
    [anon_sym_AMP_AMP] = ACTIONS(3593),
    [anon_sym_PIPE] = ACTIONS(3595),
    [anon_sym_CARET] = ACTIONS(3595),
    [anon_sym_EQ_EQ] = ACTIONS(3593),
    [anon_sym_BANG_EQ] = ACTIONS(3593),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1197] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3597),
    [anon_sym_RPAREN] = ACTIONS(3597),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3599),
    [anon_sym_QMARK] = ACTIONS(3597),
    [anon_sym_STAR_EQ] = ACTIONS(3597),
    [anon_sym_SLASH_EQ] = ACTIONS(3597),
    [anon_sym_PERCENT_EQ] = ACTIONS(3597),
    [anon_sym_PLUS_EQ] = ACTIONS(3597),
    [anon_sym_DASH_EQ] = ACTIONS(3597),
    [anon_sym_LT_LT_EQ] = ACTIONS(3597),
    [anon_sym_GT_GT_EQ] = ACTIONS(3597),
    [anon_sym_AMP_EQ] = ACTIONS(3597),
    [anon_sym_CARET_EQ] = ACTIONS(3597),
    [anon_sym_PIPE_EQ] = ACTIONS(3597),
    [anon_sym_AMP] = ACTIONS(3599),
    [anon_sym_PIPE_PIPE] = ACTIONS(3597),
    [anon_sym_AMP_AMP] = ACTIONS(3597),
    [anon_sym_PIPE] = ACTIONS(3599),
    [anon_sym_CARET] = ACTIONS(3599),
    [anon_sym_EQ_EQ] = ACTIONS(3597),
    [anon_sym_BANG_EQ] = ACTIONS(3597),
    [anon_sym_LT] = ACTIONS(3599),
    [anon_sym_GT] = ACTIONS(3599),
    [anon_sym_LT_EQ] = ACTIONS(3597),
    [anon_sym_GT_EQ] = ACTIONS(3597),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1198] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3601),
    [anon_sym_RPAREN] = ACTIONS(3601),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3603),
    [anon_sym_QMARK] = ACTIONS(3601),
    [anon_sym_STAR_EQ] = ACTIONS(3601),
    [anon_sym_SLASH_EQ] = ACTIONS(3601),
    [anon_sym_PERCENT_EQ] = ACTIONS(3601),
    [anon_sym_PLUS_EQ] = ACTIONS(3601),
    [anon_sym_DASH_EQ] = ACTIONS(3601),
    [anon_sym_LT_LT_EQ] = ACTIONS(3601),
    [anon_sym_GT_GT_EQ] = ACTIONS(3601),
    [anon_sym_AMP_EQ] = ACTIONS(3601),
    [anon_sym_CARET_EQ] = ACTIONS(3601),
    [anon_sym_PIPE_EQ] = ACTIONS(3601),
    [anon_sym_AMP] = ACTIONS(3603),
    [anon_sym_PIPE_PIPE] = ACTIONS(3601),
    [anon_sym_AMP_AMP] = ACTIONS(3601),
    [anon_sym_PIPE] = ACTIONS(3603),
    [anon_sym_CARET] = ACTIONS(3603),
    [anon_sym_EQ_EQ] = ACTIONS(3601),
    [anon_sym_BANG_EQ] = ACTIONS(3601),
    [anon_sym_LT] = ACTIONS(3603),
    [anon_sym_GT] = ACTIONS(3603),
    [anon_sym_LT_EQ] = ACTIONS(3601),
    [anon_sym_GT_EQ] = ACTIONS(3601),
    [anon_sym_LT_LT] = ACTIONS(3603),
    [anon_sym_GT_GT] = ACTIONS(3603),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1199] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3575),
    [anon_sym_RPAREN] = ACTIONS(3575),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3577),
    [anon_sym_QMARK] = ACTIONS(3575),
    [anon_sym_STAR_EQ] = ACTIONS(3575),
    [anon_sym_SLASH_EQ] = ACTIONS(3575),
    [anon_sym_PERCENT_EQ] = ACTIONS(3575),
    [anon_sym_PLUS_EQ] = ACTIONS(3575),
    [anon_sym_DASH_EQ] = ACTIONS(3575),
    [anon_sym_LT_LT_EQ] = ACTIONS(3575),
    [anon_sym_GT_GT_EQ] = ACTIONS(3575),
    [anon_sym_AMP_EQ] = ACTIONS(3575),
    [anon_sym_CARET_EQ] = ACTIONS(3575),
    [anon_sym_PIPE_EQ] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_PIPE_PIPE] = ACTIONS(3575),
    [anon_sym_AMP_AMP] = ACTIONS(3575),
    [anon_sym_PIPE] = ACTIONS(3577),
    [anon_sym_CARET] = ACTIONS(3577),
    [anon_sym_EQ_EQ] = ACTIONS(3575),
    [anon_sym_BANG_EQ] = ACTIONS(3575),
    [anon_sym_LT] = ACTIONS(3577),
    [anon_sym_GT] = ACTIONS(3577),
    [anon_sym_LT_EQ] = ACTIONS(3575),
    [anon_sym_GT_EQ] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3577),
    [anon_sym_GT_GT] = ACTIONS(3577),
    [anon_sym_PLUS] = ACTIONS(3577),
    [anon_sym_DASH] = ACTIONS(3577),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1200] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(4169),
    [anon_sym_RPAREN] = ACTIONS(4169),
    [anon_sym_SEMI] = ACTIONS(4169),
    [anon_sym_RBRACE] = ACTIONS(4169),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(4171),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4171),
    [anon_sym_QMARK] = ACTIONS(4169),
    [anon_sym_STAR_EQ] = ACTIONS(4169),
    [anon_sym_SLASH_EQ] = ACTIONS(4169),
    [anon_sym_PERCENT_EQ] = ACTIONS(4169),
    [anon_sym_PLUS_EQ] = ACTIONS(4169),
    [anon_sym_DASH_EQ] = ACTIONS(4169),
    [anon_sym_LT_LT_EQ] = ACTIONS(4169),
    [anon_sym_GT_GT_EQ] = ACTIONS(4169),
    [anon_sym_AMP_EQ] = ACTIONS(4169),
    [anon_sym_CARET_EQ] = ACTIONS(4169),
    [anon_sym_PIPE_EQ] = ACTIONS(4169),
    [anon_sym_AMP] = ACTIONS(4171),
    [anon_sym_PIPE_PIPE] = ACTIONS(4169),
    [anon_sym_AMP_AMP] = ACTIONS(4169),
    [anon_sym_PIPE] = ACTIONS(4171),
    [anon_sym_CARET] = ACTIONS(4171),
    [anon_sym_EQ_EQ] = ACTIONS(4169),
    [anon_sym_BANG_EQ] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4171),
    [anon_sym_GT] = ACTIONS(4171),
    [anon_sym_LT_EQ] = ACTIONS(4169),
    [anon_sym_GT_EQ] = ACTIONS(4169),
    [anon_sym_LT_LT] = ACTIONS(4171),
    [anon_sym_GT_GT] = ACTIONS(4171),
    [anon_sym_PLUS] = ACTIONS(4171),
    [anon_sym_DASH] = ACTIONS(4171),
    [anon_sym_SLASH] = ACTIONS(4171),
    [anon_sym_PERCENT] = ACTIONS(4171),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1201] = {
    [anon_sym_COMMA] = ACTIONS(4173),
    [anon_sym_RPAREN] = ACTIONS(4173),
    [anon_sym_SEMI] = ACTIONS(4173),
    [anon_sym_RBRACE] = ACTIONS(4173),
    [anon_sym_LPAREN2] = ACTIONS(4173),
    [anon_sym_STAR] = ACTIONS(4175),
    [anon_sym_LBRACK] = ACTIONS(4173),
    [anon_sym_RBRACK] = ACTIONS(4173),
    [anon_sym_EQ] = ACTIONS(4175),
    [anon_sym_COLON] = ACTIONS(4173),
    [anon_sym_QMARK] = ACTIONS(4173),
    [anon_sym_STAR_EQ] = ACTIONS(4173),
    [anon_sym_SLASH_EQ] = ACTIONS(4173),
    [anon_sym_PERCENT_EQ] = ACTIONS(4173),
    [anon_sym_PLUS_EQ] = ACTIONS(4173),
    [anon_sym_DASH_EQ] = ACTIONS(4173),
    [anon_sym_LT_LT_EQ] = ACTIONS(4173),
    [anon_sym_GT_GT_EQ] = ACTIONS(4173),
    [anon_sym_AMP_EQ] = ACTIONS(4173),
    [anon_sym_CARET_EQ] = ACTIONS(4173),
    [anon_sym_PIPE_EQ] = ACTIONS(4173),
    [anon_sym_AMP] = ACTIONS(4175),
    [anon_sym_PIPE_PIPE] = ACTIONS(4173),
    [anon_sym_AMP_AMP] = ACTIONS(4173),
    [anon_sym_PIPE] = ACTIONS(4175),
    [anon_sym_CARET] = ACTIONS(4175),
    [anon_sym_EQ_EQ] = ACTIONS(4173),
    [anon_sym_BANG_EQ] = ACTIONS(4173),
    [anon_sym_LT] = ACTIONS(4175),
    [anon_sym_GT] = ACTIONS(4175),
    [anon_sym_LT_EQ] = ACTIONS(4173),
    [anon_sym_GT_EQ] = ACTIONS(4173),
    [anon_sym_LT_LT] = ACTIONS(4175),
    [anon_sym_GT_GT] = ACTIONS(4175),
    [anon_sym_PLUS] = ACTIONS(4175),
    [anon_sym_DASH] = ACTIONS(4175),
    [anon_sym_SLASH] = ACTIONS(4175),
    [anon_sym_PERCENT] = ACTIONS(4175),
    [anon_sym_DASH_DASH] = ACTIONS(4173),
    [anon_sym_PLUS_PLUS] = ACTIONS(4173),
    [anon_sym_DOT] = ACTIONS(4173),
    [anon_sym_DASH_GT] = ACTIONS(4173),
    [sym_comment] = ACTIONS(91),
  },
  [1202] = {
    [sym_string_literal] = STATE(1202),
    [aux_sym_concatenated_string_repeat1] = STATE(1202),
    [anon_sym_COMMA] = ACTIONS(3622),
    [anon_sym_RPAREN] = ACTIONS(3622),
    [anon_sym_LPAREN2] = ACTIONS(3622),
    [anon_sym_STAR] = ACTIONS(3624),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_EQ] = ACTIONS(3624),
    [anon_sym_QMARK] = ACTIONS(3622),
    [anon_sym_STAR_EQ] = ACTIONS(3622),
    [anon_sym_SLASH_EQ] = ACTIONS(3622),
    [anon_sym_PERCENT_EQ] = ACTIONS(3622),
    [anon_sym_PLUS_EQ] = ACTIONS(3622),
    [anon_sym_DASH_EQ] = ACTIONS(3622),
    [anon_sym_LT_LT_EQ] = ACTIONS(3622),
    [anon_sym_GT_GT_EQ] = ACTIONS(3622),
    [anon_sym_AMP_EQ] = ACTIONS(3622),
    [anon_sym_CARET_EQ] = ACTIONS(3622),
    [anon_sym_PIPE_EQ] = ACTIONS(3622),
    [anon_sym_AMP] = ACTIONS(3624),
    [anon_sym_PIPE_PIPE] = ACTIONS(3622),
    [anon_sym_AMP_AMP] = ACTIONS(3622),
    [anon_sym_PIPE] = ACTIONS(3624),
    [anon_sym_CARET] = ACTIONS(3624),
    [anon_sym_EQ_EQ] = ACTIONS(3622),
    [anon_sym_BANG_EQ] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3624),
    [anon_sym_GT] = ACTIONS(3624),
    [anon_sym_LT_EQ] = ACTIONS(3622),
    [anon_sym_GT_EQ] = ACTIONS(3622),
    [anon_sym_LT_LT] = ACTIONS(3624),
    [anon_sym_GT_GT] = ACTIONS(3624),
    [anon_sym_PLUS] = ACTIONS(3624),
    [anon_sym_DASH] = ACTIONS(3624),
    [anon_sym_SLASH] = ACTIONS(3624),
    [anon_sym_PERCENT] = ACTIONS(3624),
    [anon_sym_DASH_DASH] = ACTIONS(3622),
    [anon_sym_PLUS_PLUS] = ACTIONS(3622),
    [anon_sym_DOT] = ACTIONS(3622),
    [anon_sym_DASH_GT] = ACTIONS(3622),
    [anon_sym_DQUOTE] = ACTIONS(3626),
    [sym_comment] = ACTIONS(91),
  },
  [1203] = {
    [sym_parameter_list] = STATE(1185),
    [anon_sym_RPAREN] = ACTIONS(4177),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [sym_comment] = ACTIONS(91),
  },
  [1204] = {
    [anon_sym_COMMA] = ACTIONS(3211),
    [anon_sym_RPAREN] = ACTIONS(3211),
    [anon_sym_SEMI] = ACTIONS(3211),
    [anon_sym_LBRACE] = ACTIONS(3218),
    [anon_sym_RBRACE] = ACTIONS(3211),
    [anon_sym_LPAREN2] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(3211),
    [anon_sym_RBRACK] = ACTIONS(3211),
    [anon_sym_EQ] = ACTIONS(3223),
    [anon_sym_COLON] = ACTIONS(3223),
    [anon_sym_QMARK] = ACTIONS(3211),
    [anon_sym_STAR_EQ] = ACTIONS(3211),
    [anon_sym_SLASH_EQ] = ACTIONS(3211),
    [anon_sym_PERCENT_EQ] = ACTIONS(3211),
    [anon_sym_PLUS_EQ] = ACTIONS(3211),
    [anon_sym_DASH_EQ] = ACTIONS(3211),
    [anon_sym_LT_LT_EQ] = ACTIONS(3211),
    [anon_sym_GT_GT_EQ] = ACTIONS(3211),
    [anon_sym_AMP_EQ] = ACTIONS(3211),
    [anon_sym_CARET_EQ] = ACTIONS(3211),
    [anon_sym_PIPE_EQ] = ACTIONS(3211),
    [anon_sym_AMP] = ACTIONS(3223),
    [anon_sym_PIPE_PIPE] = ACTIONS(3211),
    [anon_sym_AMP_AMP] = ACTIONS(3211),
    [anon_sym_PIPE] = ACTIONS(3223),
    [anon_sym_CARET] = ACTIONS(3223),
    [anon_sym_EQ_EQ] = ACTIONS(3211),
    [anon_sym_BANG_EQ] = ACTIONS(3211),
    [anon_sym_LT] = ACTIONS(3220),
    [anon_sym_GT] = ACTIONS(3223),
    [anon_sym_LT_EQ] = ACTIONS(3211),
    [anon_sym_GT_EQ] = ACTIONS(3211),
    [anon_sym_LT_LT] = ACTIONS(3223),
    [anon_sym_GT_GT] = ACTIONS(3223),
    [anon_sym_PLUS] = ACTIONS(3223),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_SLASH] = ACTIONS(3223),
    [anon_sym_PERCENT] = ACTIONS(3223),
    [anon_sym_DASH_DASH] = ACTIONS(3211),
    [anon_sym_PLUS_PLUS] = ACTIONS(3211),
    [anon_sym_DOT] = ACTIONS(3211),
    [anon_sym_DASH_GT] = ACTIONS(3211),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(3225),
  },
  [1205] = {
    [sym__type_specifier] = STATE(1978),
    [sym_sized_type_specifier] = STATE(1978),
    [sym_enum_specifier] = STATE(1978),
    [sym_struct_specifier] = STATE(1978),
    [sym_union_specifier] = STATE(1978),
    [sym_macro_type_specifier] = STATE(1978),
    [sym_class_specifier] = STATE(1978),
    [sym_dependent_type] = STATE(1978),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1979),
    [anon_sym_unsigned] = ACTIONS(4179),
    [anon_sym_long] = ACTIONS(4179),
    [anon_sym_short] = ACTIONS(4179),
    [sym_primitive_type] = ACTIONS(4181),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(4147),
    [anon_sym_union] = ACTIONS(4149),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4151),
    [sym_auto] = ACTIONS(4181),
    [anon_sym_typename] = ACTIONS(4183),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [1206] = {
    [sym_type_qualifier] = STATE(1980),
    [sym_virtual_specifier] = STATE(1980),
    [sym_trailing_return_type] = STATE(1980),
    [aux_sym_function_declarator_repeat1] = STATE(1980),
    [anon_sym_LPAREN2] = ACTIONS(3549),
    [anon_sym_LBRACK] = ACTIONS(3549),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(2532),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [sym_noexcept] = ACTIONS(4185),
  },
  [1207] = {
    [anon_sym_COMMA] = ACTIONS(3629),
    [anon_sym_RPAREN] = ACTIONS(3629),
    [anon_sym_SEMI] = ACTIONS(3629),
    [anon_sym_LBRACE] = ACTIONS(3636),
    [anon_sym_RBRACE] = ACTIONS(3629),
    [anon_sym_LPAREN2] = ACTIONS(3629),
    [anon_sym_STAR] = ACTIONS(3641),
    [anon_sym_LBRACK] = ACTIONS(3629),
    [anon_sym_RBRACK] = ACTIONS(3629),
    [anon_sym_EQ] = ACTIONS(3641),
    [anon_sym_COLON] = ACTIONS(3641),
    [anon_sym_QMARK] = ACTIONS(3629),
    [anon_sym_STAR_EQ] = ACTIONS(3629),
    [anon_sym_SLASH_EQ] = ACTIONS(3629),
    [anon_sym_PERCENT_EQ] = ACTIONS(3629),
    [anon_sym_PLUS_EQ] = ACTIONS(3629),
    [anon_sym_DASH_EQ] = ACTIONS(3629),
    [anon_sym_LT_LT_EQ] = ACTIONS(3629),
    [anon_sym_GT_GT_EQ] = ACTIONS(3629),
    [anon_sym_AMP_EQ] = ACTIONS(3629),
    [anon_sym_CARET_EQ] = ACTIONS(3629),
    [anon_sym_PIPE_EQ] = ACTIONS(3629),
    [anon_sym_AMP] = ACTIONS(3641),
    [anon_sym_PIPE_PIPE] = ACTIONS(3629),
    [anon_sym_AMP_AMP] = ACTIONS(3629),
    [anon_sym_PIPE] = ACTIONS(3641),
    [anon_sym_CARET] = ACTIONS(3641),
    [anon_sym_EQ_EQ] = ACTIONS(3629),
    [anon_sym_BANG_EQ] = ACTIONS(3629),
    [anon_sym_LT] = ACTIONS(3638),
    [anon_sym_GT] = ACTIONS(3641),
    [anon_sym_LT_EQ] = ACTIONS(3629),
    [anon_sym_GT_EQ] = ACTIONS(3629),
    [anon_sym_LT_LT] = ACTIONS(3641),
    [anon_sym_GT_GT] = ACTIONS(3641),
    [anon_sym_PLUS] = ACTIONS(3641),
    [anon_sym_DASH] = ACTIONS(3641),
    [anon_sym_SLASH] = ACTIONS(3641),
    [anon_sym_PERCENT] = ACTIONS(3641),
    [anon_sym_DASH_DASH] = ACTIONS(3629),
    [anon_sym_PLUS_PLUS] = ACTIONS(3629),
    [anon_sym_DOT] = ACTIONS(3629),
    [anon_sym_DASH_GT] = ACTIONS(3629),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(3643),
  },
  [1208] = {
    [sym__expression] = STATE(1200),
    [sym_conditional_expression] = STATE(1200),
    [sym_assignment_expression] = STATE(1200),
    [sym_pointer_expression] = STATE(1200),
    [sym_logical_expression] = STATE(1200),
    [sym_bitwise_expression] = STATE(1200),
    [sym_equality_expression] = STATE(1200),
    [sym_relational_expression] = STATE(1200),
    [sym_shift_expression] = STATE(1200),
    [sym_math_expression] = STATE(1200),
    [sym_cast_expression] = STATE(1200),
    [sym_sizeof_expression] = STATE(1200),
    [sym_subscript_expression] = STATE(1200),
    [sym_call_expression] = STATE(1200),
    [sym_field_expression] = STATE(1200),
    [sym_compound_literal_expression] = STATE(1200),
    [sym_parenthesized_expression] = STATE(1200),
    [sym_initializer_list] = STATE(1201),
    [sym_char_literal] = STATE(1200),
    [sym_concatenated_string] = STATE(1200),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1200),
    [sym_new_expression] = STATE(1200),
    [sym_delete_expression] = STATE(1200),
    [sym_lambda_expression] = STATE(1200),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2523),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(2523),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2525),
    [sym_false] = ACTIONS(2525),
    [sym_null] = ACTIONS(2525),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(2525),
  },
  [1209] = {
    [anon_sym_RPAREN] = ACTIONS(4187),
    [sym_comment] = ACTIONS(91),
  },
  [1210] = {
    [sym__expression] = STATE(1982),
    [sym_conditional_expression] = STATE(1982),
    [sym_assignment_expression] = STATE(1982),
    [sym_pointer_expression] = STATE(1982),
    [sym_logical_expression] = STATE(1982),
    [sym_bitwise_expression] = STATE(1982),
    [sym_equality_expression] = STATE(1982),
    [sym_relational_expression] = STATE(1982),
    [sym_shift_expression] = STATE(1982),
    [sym_math_expression] = STATE(1982),
    [sym_cast_expression] = STATE(1982),
    [sym_sizeof_expression] = STATE(1982),
    [sym_subscript_expression] = STATE(1982),
    [sym_call_expression] = STATE(1982),
    [sym_field_expression] = STATE(1982),
    [sym_compound_literal_expression] = STATE(1982),
    [sym_parenthesized_expression] = STATE(1982),
    [sym_char_literal] = STATE(1982),
    [sym_concatenated_string] = STATE(1982),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1982),
    [sym_new_expression] = STATE(1982),
    [sym_delete_expression] = STATE(1982),
    [sym_lambda_expression] = STATE(1982),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4189),
    [anon_sym_LPAREN2] = ACTIONS(947),
    [anon_sym_STAR] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(947),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(4189),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4191),
    [sym_false] = ACTIONS(4191),
    [sym_null] = ACTIONS(4191),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(4191),
  },
  [1211] = {
    [sym__expression] = STATE(1983),
    [sym_conditional_expression] = STATE(1983),
    [sym_assignment_expression] = STATE(1983),
    [sym_pointer_expression] = STATE(1983),
    [sym_logical_expression] = STATE(1983),
    [sym_bitwise_expression] = STATE(1983),
    [sym_equality_expression] = STATE(1983),
    [sym_relational_expression] = STATE(1983),
    [sym_shift_expression] = STATE(1983),
    [sym_math_expression] = STATE(1983),
    [sym_cast_expression] = STATE(1983),
    [sym_sizeof_expression] = STATE(1983),
    [sym_subscript_expression] = STATE(1983),
    [sym_call_expression] = STATE(1983),
    [sym_field_expression] = STATE(1983),
    [sym_compound_literal_expression] = STATE(1983),
    [sym_parenthesized_expression] = STATE(1983),
    [sym_char_literal] = STATE(1983),
    [sym_concatenated_string] = STATE(1983),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1983),
    [sym_new_expression] = STATE(1983),
    [sym_delete_expression] = STATE(1983),
    [sym_lambda_expression] = STATE(1983),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4193),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(4193),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4195),
    [sym_false] = ACTIONS(4195),
    [sym_null] = ACTIONS(4195),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(4195),
  },
  [1212] = {
    [sym_argument_list] = STATE(1610),
    [sym_initializer_list] = STATE(1610),
    [sym_new_declarator] = STATE(1611),
    [anon_sym_COMMA] = ACTIONS(3372),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3374),
    [anon_sym_LBRACK] = ACTIONS(2545),
    [anon_sym_RBRACK] = ACTIONS(3372),
    [anon_sym_EQ] = ACTIONS(3374),
    [anon_sym_QMARK] = ACTIONS(3372),
    [anon_sym_STAR_EQ] = ACTIONS(3372),
    [anon_sym_SLASH_EQ] = ACTIONS(3372),
    [anon_sym_PERCENT_EQ] = ACTIONS(3372),
    [anon_sym_PLUS_EQ] = ACTIONS(3372),
    [anon_sym_DASH_EQ] = ACTIONS(3372),
    [anon_sym_LT_LT_EQ] = ACTIONS(3372),
    [anon_sym_GT_GT_EQ] = ACTIONS(3372),
    [anon_sym_AMP_EQ] = ACTIONS(3372),
    [anon_sym_CARET_EQ] = ACTIONS(3372),
    [anon_sym_PIPE_EQ] = ACTIONS(3372),
    [anon_sym_AMP] = ACTIONS(3374),
    [anon_sym_PIPE_PIPE] = ACTIONS(3372),
    [anon_sym_AMP_AMP] = ACTIONS(3372),
    [anon_sym_PIPE] = ACTIONS(3374),
    [anon_sym_CARET] = ACTIONS(3374),
    [anon_sym_EQ_EQ] = ACTIONS(3372),
    [anon_sym_BANG_EQ] = ACTIONS(3372),
    [anon_sym_LT] = ACTIONS(3374),
    [anon_sym_GT] = ACTIONS(3374),
    [anon_sym_LT_EQ] = ACTIONS(3372),
    [anon_sym_GT_EQ] = ACTIONS(3372),
    [anon_sym_LT_LT] = ACTIONS(3374),
    [anon_sym_GT_GT] = ACTIONS(3374),
    [anon_sym_PLUS] = ACTIONS(3374),
    [anon_sym_DASH] = ACTIONS(3374),
    [anon_sym_SLASH] = ACTIONS(3374),
    [anon_sym_PERCENT] = ACTIONS(3374),
    [anon_sym_DASH_DASH] = ACTIONS(3372),
    [anon_sym_PLUS_PLUS] = ACTIONS(3372),
    [anon_sym_DOT] = ACTIONS(3372),
    [anon_sym_DASH_GT] = ACTIONS(3372),
    [sym_comment] = ACTIONS(91),
  },
  [1213] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1213),
    [anon_sym_COMMA] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(1985),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(1985),
    [anon_sym_EQ] = ACTIONS(1987),
    [anon_sym_unsigned] = ACTIONS(4197),
    [anon_sym_long] = ACTIONS(4197),
    [anon_sym_short] = ACTIONS(4197),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_QMARK] = ACTIONS(1985),
    [anon_sym_STAR_EQ] = ACTIONS(1985),
    [anon_sym_SLASH_EQ] = ACTIONS(1985),
    [anon_sym_PERCENT_EQ] = ACTIONS(1985),
    [anon_sym_PLUS_EQ] = ACTIONS(1985),
    [anon_sym_DASH_EQ] = ACTIONS(1985),
    [anon_sym_LT_LT_EQ] = ACTIONS(1985),
    [anon_sym_GT_GT_EQ] = ACTIONS(1985),
    [anon_sym_AMP_EQ] = ACTIONS(1985),
    [anon_sym_CARET_EQ] = ACTIONS(1985),
    [anon_sym_PIPE_EQ] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_PIPE_PIPE] = ACTIONS(1985),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_PIPE] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1987),
    [anon_sym_EQ_EQ] = ACTIONS(1985),
    [anon_sym_BANG_EQ] = ACTIONS(1985),
    [anon_sym_LT] = ACTIONS(1987),
    [anon_sym_GT] = ACTIONS(1987),
    [anon_sym_LT_EQ] = ACTIONS(1985),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_LT] = ACTIONS(1987),
    [anon_sym_GT_GT] = ACTIONS(1987),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_DASH] = ACTIONS(1987),
    [anon_sym_SLASH] = ACTIONS(1987),
    [anon_sym_PERCENT] = ACTIONS(1987),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DOT] = ACTIONS(1985),
    [anon_sym_DASH_GT] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [sym_comment] = ACTIONS(91),
  },
  [1214] = {
    [sym__expression] = STATE(164),
    [sym_conditional_expression] = STATE(164),
    [sym_assignment_expression] = STATE(164),
    [sym_pointer_expression] = STATE(164),
    [sym_logical_expression] = STATE(164),
    [sym_bitwise_expression] = STATE(164),
    [sym_equality_expression] = STATE(164),
    [sym_relational_expression] = STATE(164),
    [sym_shift_expression] = STATE(164),
    [sym_math_expression] = STATE(164),
    [sym_cast_expression] = STATE(164),
    [sym_sizeof_expression] = STATE(164),
    [sym_subscript_expression] = STATE(164),
    [sym_call_expression] = STATE(164),
    [sym_field_expression] = STATE(164),
    [sym_compound_literal_expression] = STATE(164),
    [sym_parenthesized_expression] = STATE(164),
    [sym_char_literal] = STATE(164),
    [sym_concatenated_string] = STATE(164),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(164),
    [sym_new_expression] = STATE(164),
    [sym_delete_expression] = STATE(164),
    [sym_lambda_expression] = STATE(164),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_lambda_default_capture] = STATE(166),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(267),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(4200),
    [anon_sym_EQ] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(267),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(289),
    [sym_false] = ACTIONS(289),
    [sym_null] = ACTIONS(289),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(289),
  },
  [1215] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3383),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(3383),
    [anon_sym_EQ] = ACTIONS(3385),
    [anon_sym_QMARK] = ACTIONS(3383),
    [anon_sym_STAR_EQ] = ACTIONS(3383),
    [anon_sym_SLASH_EQ] = ACTIONS(3383),
    [anon_sym_PERCENT_EQ] = ACTIONS(3383),
    [anon_sym_PLUS_EQ] = ACTIONS(3383),
    [anon_sym_DASH_EQ] = ACTIONS(3383),
    [anon_sym_LT_LT_EQ] = ACTIONS(3383),
    [anon_sym_GT_GT_EQ] = ACTIONS(3383),
    [anon_sym_AMP_EQ] = ACTIONS(3383),
    [anon_sym_CARET_EQ] = ACTIONS(3383),
    [anon_sym_PIPE_EQ] = ACTIONS(3383),
    [anon_sym_AMP] = ACTIONS(985),
    [anon_sym_PIPE_PIPE] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(989),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_CARET] = ACTIONS(993),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(999),
    [anon_sym_LT_LT] = ACTIONS(1001),
    [anon_sym_GT_GT] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(975),
    [anon_sym_PERCENT] = ACTIONS(975),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1216] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(4202),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(4202),
    [anon_sym_EQ] = ACTIONS(979),
    [anon_sym_QMARK] = ACTIONS(981),
    [anon_sym_STAR_EQ] = ACTIONS(983),
    [anon_sym_SLASH_EQ] = ACTIONS(983),
    [anon_sym_PERCENT_EQ] = ACTIONS(983),
    [anon_sym_PLUS_EQ] = ACTIONS(983),
    [anon_sym_DASH_EQ] = ACTIONS(983),
    [anon_sym_LT_LT_EQ] = ACTIONS(983),
    [anon_sym_GT_GT_EQ] = ACTIONS(983),
    [anon_sym_AMP_EQ] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(983),
    [anon_sym_PIPE_EQ] = ACTIONS(983),
    [anon_sym_AMP] = ACTIONS(985),
    [anon_sym_PIPE_PIPE] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(989),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_CARET] = ACTIONS(993),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(999),
    [anon_sym_LT_LT] = ACTIONS(1001),
    [anon_sym_GT_GT] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(975),
    [anon_sym_PERCENT] = ACTIONS(975),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1217] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3581),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(3581),
    [anon_sym_EQ] = ACTIONS(979),
    [anon_sym_QMARK] = ACTIONS(3581),
    [anon_sym_STAR_EQ] = ACTIONS(983),
    [anon_sym_SLASH_EQ] = ACTIONS(983),
    [anon_sym_PERCENT_EQ] = ACTIONS(983),
    [anon_sym_PLUS_EQ] = ACTIONS(983),
    [anon_sym_DASH_EQ] = ACTIONS(983),
    [anon_sym_LT_LT_EQ] = ACTIONS(983),
    [anon_sym_GT_GT_EQ] = ACTIONS(983),
    [anon_sym_AMP_EQ] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(983),
    [anon_sym_PIPE_EQ] = ACTIONS(983),
    [anon_sym_AMP] = ACTIONS(985),
    [anon_sym_PIPE_PIPE] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(989),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_CARET] = ACTIONS(993),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(999),
    [anon_sym_LT_LT] = ACTIONS(1001),
    [anon_sym_GT_GT] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(975),
    [anon_sym_PERCENT] = ACTIONS(975),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1218] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_COLON] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(1171),
    [anon_sym_STAR_EQ] = ACTIONS(1173),
    [anon_sym_SLASH_EQ] = ACTIONS(1173),
    [anon_sym_PERCENT_EQ] = ACTIONS(1173),
    [anon_sym_PLUS_EQ] = ACTIONS(1173),
    [anon_sym_DASH_EQ] = ACTIONS(1173),
    [anon_sym_LT_LT_EQ] = ACTIONS(1173),
    [anon_sym_GT_GT_EQ] = ACTIONS(1173),
    [anon_sym_AMP_EQ] = ACTIONS(1173),
    [anon_sym_CARET_EQ] = ACTIONS(1173),
    [anon_sym_PIPE_EQ] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_CARET] = ACTIONS(1183),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [1219] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(3585),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_STAR_EQ] = ACTIONS(3585),
    [anon_sym_SLASH_EQ] = ACTIONS(3585),
    [anon_sym_PERCENT_EQ] = ACTIONS(3585),
    [anon_sym_PLUS_EQ] = ACTIONS(3585),
    [anon_sym_DASH_EQ] = ACTIONS(3585),
    [anon_sym_LT_LT_EQ] = ACTIONS(3585),
    [anon_sym_GT_GT_EQ] = ACTIONS(3585),
    [anon_sym_AMP_EQ] = ACTIONS(3585),
    [anon_sym_CARET_EQ] = ACTIONS(3585),
    [anon_sym_PIPE_EQ] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(3587),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3587),
    [anon_sym_CARET] = ACTIONS(3587),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(999),
    [anon_sym_LT_LT] = ACTIONS(1001),
    [anon_sym_GT_GT] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(975),
    [anon_sym_PERCENT] = ACTIONS(975),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1220] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3589),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(3589),
    [anon_sym_EQ] = ACTIONS(3591),
    [anon_sym_QMARK] = ACTIONS(3589),
    [anon_sym_STAR_EQ] = ACTIONS(3589),
    [anon_sym_SLASH_EQ] = ACTIONS(3589),
    [anon_sym_PERCENT_EQ] = ACTIONS(3589),
    [anon_sym_PLUS_EQ] = ACTIONS(3589),
    [anon_sym_DASH_EQ] = ACTIONS(3589),
    [anon_sym_LT_LT_EQ] = ACTIONS(3589),
    [anon_sym_GT_GT_EQ] = ACTIONS(3589),
    [anon_sym_AMP_EQ] = ACTIONS(3589),
    [anon_sym_CARET_EQ] = ACTIONS(3589),
    [anon_sym_PIPE_EQ] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3589),
    [anon_sym_AMP_AMP] = ACTIONS(989),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_CARET] = ACTIONS(993),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(999),
    [anon_sym_LT_LT] = ACTIONS(1001),
    [anon_sym_GT_GT] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(975),
    [anon_sym_PERCENT] = ACTIONS(975),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1221] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3589),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(3589),
    [anon_sym_EQ] = ACTIONS(3591),
    [anon_sym_QMARK] = ACTIONS(3589),
    [anon_sym_STAR_EQ] = ACTIONS(3589),
    [anon_sym_SLASH_EQ] = ACTIONS(3589),
    [anon_sym_PERCENT_EQ] = ACTIONS(3589),
    [anon_sym_PLUS_EQ] = ACTIONS(3589),
    [anon_sym_DASH_EQ] = ACTIONS(3589),
    [anon_sym_LT_LT_EQ] = ACTIONS(3589),
    [anon_sym_GT_GT_EQ] = ACTIONS(3589),
    [anon_sym_AMP_EQ] = ACTIONS(3589),
    [anon_sym_CARET_EQ] = ACTIONS(3589),
    [anon_sym_PIPE_EQ] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3589),
    [anon_sym_AMP_AMP] = ACTIONS(3589),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_CARET] = ACTIONS(993),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(999),
    [anon_sym_LT_LT] = ACTIONS(1001),
    [anon_sym_GT_GT] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(975),
    [anon_sym_PERCENT] = ACTIONS(975),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1222] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(3585),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_STAR_EQ] = ACTIONS(3585),
    [anon_sym_SLASH_EQ] = ACTIONS(3585),
    [anon_sym_PERCENT_EQ] = ACTIONS(3585),
    [anon_sym_PLUS_EQ] = ACTIONS(3585),
    [anon_sym_DASH_EQ] = ACTIONS(3585),
    [anon_sym_LT_LT_EQ] = ACTIONS(3585),
    [anon_sym_GT_GT_EQ] = ACTIONS(3585),
    [anon_sym_AMP_EQ] = ACTIONS(3585),
    [anon_sym_CARET_EQ] = ACTIONS(3585),
    [anon_sym_PIPE_EQ] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3587),
    [anon_sym_CARET] = ACTIONS(993),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(999),
    [anon_sym_LT_LT] = ACTIONS(1001),
    [anon_sym_GT_GT] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(975),
    [anon_sym_PERCENT] = ACTIONS(975),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1223] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(3585),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_STAR_EQ] = ACTIONS(3585),
    [anon_sym_SLASH_EQ] = ACTIONS(3585),
    [anon_sym_PERCENT_EQ] = ACTIONS(3585),
    [anon_sym_PLUS_EQ] = ACTIONS(3585),
    [anon_sym_DASH_EQ] = ACTIONS(3585),
    [anon_sym_LT_LT_EQ] = ACTIONS(3585),
    [anon_sym_GT_GT_EQ] = ACTIONS(3585),
    [anon_sym_AMP_EQ] = ACTIONS(3585),
    [anon_sym_CARET_EQ] = ACTIONS(3585),
    [anon_sym_PIPE_EQ] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3587),
    [anon_sym_CARET] = ACTIONS(3587),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(999),
    [anon_sym_LT_LT] = ACTIONS(1001),
    [anon_sym_GT_GT] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(975),
    [anon_sym_PERCENT] = ACTIONS(975),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1224] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3593),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(3593),
    [anon_sym_EQ] = ACTIONS(3595),
    [anon_sym_QMARK] = ACTIONS(3593),
    [anon_sym_STAR_EQ] = ACTIONS(3593),
    [anon_sym_SLASH_EQ] = ACTIONS(3593),
    [anon_sym_PERCENT_EQ] = ACTIONS(3593),
    [anon_sym_PLUS_EQ] = ACTIONS(3593),
    [anon_sym_DASH_EQ] = ACTIONS(3593),
    [anon_sym_LT_LT_EQ] = ACTIONS(3593),
    [anon_sym_GT_GT_EQ] = ACTIONS(3593),
    [anon_sym_AMP_EQ] = ACTIONS(3593),
    [anon_sym_CARET_EQ] = ACTIONS(3593),
    [anon_sym_PIPE_EQ] = ACTIONS(3593),
    [anon_sym_AMP] = ACTIONS(3595),
    [anon_sym_PIPE_PIPE] = ACTIONS(3593),
    [anon_sym_AMP_AMP] = ACTIONS(3593),
    [anon_sym_PIPE] = ACTIONS(3595),
    [anon_sym_CARET] = ACTIONS(3595),
    [anon_sym_EQ_EQ] = ACTIONS(3593),
    [anon_sym_BANG_EQ] = ACTIONS(3593),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(999),
    [anon_sym_LT_LT] = ACTIONS(1001),
    [anon_sym_GT_GT] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(975),
    [anon_sym_PERCENT] = ACTIONS(975),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1225] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3597),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(3597),
    [anon_sym_EQ] = ACTIONS(3599),
    [anon_sym_QMARK] = ACTIONS(3597),
    [anon_sym_STAR_EQ] = ACTIONS(3597),
    [anon_sym_SLASH_EQ] = ACTIONS(3597),
    [anon_sym_PERCENT_EQ] = ACTIONS(3597),
    [anon_sym_PLUS_EQ] = ACTIONS(3597),
    [anon_sym_DASH_EQ] = ACTIONS(3597),
    [anon_sym_LT_LT_EQ] = ACTIONS(3597),
    [anon_sym_GT_GT_EQ] = ACTIONS(3597),
    [anon_sym_AMP_EQ] = ACTIONS(3597),
    [anon_sym_CARET_EQ] = ACTIONS(3597),
    [anon_sym_PIPE_EQ] = ACTIONS(3597),
    [anon_sym_AMP] = ACTIONS(3599),
    [anon_sym_PIPE_PIPE] = ACTIONS(3597),
    [anon_sym_AMP_AMP] = ACTIONS(3597),
    [anon_sym_PIPE] = ACTIONS(3599),
    [anon_sym_CARET] = ACTIONS(3599),
    [anon_sym_EQ_EQ] = ACTIONS(3597),
    [anon_sym_BANG_EQ] = ACTIONS(3597),
    [anon_sym_LT] = ACTIONS(3599),
    [anon_sym_GT] = ACTIONS(3599),
    [anon_sym_LT_EQ] = ACTIONS(3597),
    [anon_sym_GT_EQ] = ACTIONS(3597),
    [anon_sym_LT_LT] = ACTIONS(1001),
    [anon_sym_GT_GT] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(975),
    [anon_sym_PERCENT] = ACTIONS(975),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1226] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3601),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(3601),
    [anon_sym_EQ] = ACTIONS(3603),
    [anon_sym_QMARK] = ACTIONS(3601),
    [anon_sym_STAR_EQ] = ACTIONS(3601),
    [anon_sym_SLASH_EQ] = ACTIONS(3601),
    [anon_sym_PERCENT_EQ] = ACTIONS(3601),
    [anon_sym_PLUS_EQ] = ACTIONS(3601),
    [anon_sym_DASH_EQ] = ACTIONS(3601),
    [anon_sym_LT_LT_EQ] = ACTIONS(3601),
    [anon_sym_GT_GT_EQ] = ACTIONS(3601),
    [anon_sym_AMP_EQ] = ACTIONS(3601),
    [anon_sym_CARET_EQ] = ACTIONS(3601),
    [anon_sym_PIPE_EQ] = ACTIONS(3601),
    [anon_sym_AMP] = ACTIONS(3603),
    [anon_sym_PIPE_PIPE] = ACTIONS(3601),
    [anon_sym_AMP_AMP] = ACTIONS(3601),
    [anon_sym_PIPE] = ACTIONS(3603),
    [anon_sym_CARET] = ACTIONS(3603),
    [anon_sym_EQ_EQ] = ACTIONS(3601),
    [anon_sym_BANG_EQ] = ACTIONS(3601),
    [anon_sym_LT] = ACTIONS(3603),
    [anon_sym_GT] = ACTIONS(3603),
    [anon_sym_LT_EQ] = ACTIONS(3601),
    [anon_sym_GT_EQ] = ACTIONS(3601),
    [anon_sym_LT_LT] = ACTIONS(3603),
    [anon_sym_GT_GT] = ACTIONS(3603),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(975),
    [anon_sym_PERCENT] = ACTIONS(975),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1227] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3575),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(3575),
    [anon_sym_EQ] = ACTIONS(3577),
    [anon_sym_QMARK] = ACTIONS(3575),
    [anon_sym_STAR_EQ] = ACTIONS(3575),
    [anon_sym_SLASH_EQ] = ACTIONS(3575),
    [anon_sym_PERCENT_EQ] = ACTIONS(3575),
    [anon_sym_PLUS_EQ] = ACTIONS(3575),
    [anon_sym_DASH_EQ] = ACTIONS(3575),
    [anon_sym_LT_LT_EQ] = ACTIONS(3575),
    [anon_sym_GT_GT_EQ] = ACTIONS(3575),
    [anon_sym_AMP_EQ] = ACTIONS(3575),
    [anon_sym_CARET_EQ] = ACTIONS(3575),
    [anon_sym_PIPE_EQ] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_PIPE_PIPE] = ACTIONS(3575),
    [anon_sym_AMP_AMP] = ACTIONS(3575),
    [anon_sym_PIPE] = ACTIONS(3577),
    [anon_sym_CARET] = ACTIONS(3577),
    [anon_sym_EQ_EQ] = ACTIONS(3575),
    [anon_sym_BANG_EQ] = ACTIONS(3575),
    [anon_sym_LT] = ACTIONS(3577),
    [anon_sym_GT] = ACTIONS(3577),
    [anon_sym_LT_EQ] = ACTIONS(3575),
    [anon_sym_GT_EQ] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3577),
    [anon_sym_GT_GT] = ACTIONS(3577),
    [anon_sym_PLUS] = ACTIONS(3577),
    [anon_sym_DASH] = ACTIONS(3577),
    [anon_sym_SLASH] = ACTIONS(975),
    [anon_sym_PERCENT] = ACTIONS(975),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1228] = {
    [anon_sym_LPAREN2] = ACTIONS(4206),
    [anon_sym_STAR] = ACTIONS(4206),
    [anon_sym_LBRACK] = ACTIONS(4206),
    [anon_sym_AMP] = ACTIONS(4208),
    [anon_sym_AMP_AMP] = ACTIONS(4206),
    [sym_comment] = ACTIONS(91),
  },
  [1229] = {
    [aux_sym_for_statement_repeat1] = STATE(1229),
    [anon_sym_COMMA] = ACTIONS(4210),
    [anon_sym_RBRACK] = ACTIONS(4202),
    [sym_comment] = ACTIONS(91),
  },
  [1230] = {
    [sym_string_literal] = STATE(1230),
    [aux_sym_concatenated_string_repeat1] = STATE(1230),
    [anon_sym_COMMA] = ACTIONS(3622),
    [anon_sym_LPAREN2] = ACTIONS(3622),
    [anon_sym_STAR] = ACTIONS(3624),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3622),
    [anon_sym_EQ] = ACTIONS(3624),
    [anon_sym_QMARK] = ACTIONS(3622),
    [anon_sym_STAR_EQ] = ACTIONS(3622),
    [anon_sym_SLASH_EQ] = ACTIONS(3622),
    [anon_sym_PERCENT_EQ] = ACTIONS(3622),
    [anon_sym_PLUS_EQ] = ACTIONS(3622),
    [anon_sym_DASH_EQ] = ACTIONS(3622),
    [anon_sym_LT_LT_EQ] = ACTIONS(3622),
    [anon_sym_GT_GT_EQ] = ACTIONS(3622),
    [anon_sym_AMP_EQ] = ACTIONS(3622),
    [anon_sym_CARET_EQ] = ACTIONS(3622),
    [anon_sym_PIPE_EQ] = ACTIONS(3622),
    [anon_sym_AMP] = ACTIONS(3624),
    [anon_sym_PIPE_PIPE] = ACTIONS(3622),
    [anon_sym_AMP_AMP] = ACTIONS(3622),
    [anon_sym_PIPE] = ACTIONS(3624),
    [anon_sym_CARET] = ACTIONS(3624),
    [anon_sym_EQ_EQ] = ACTIONS(3622),
    [anon_sym_BANG_EQ] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3624),
    [anon_sym_GT] = ACTIONS(3624),
    [anon_sym_LT_EQ] = ACTIONS(3622),
    [anon_sym_GT_EQ] = ACTIONS(3622),
    [anon_sym_LT_LT] = ACTIONS(3624),
    [anon_sym_GT_GT] = ACTIONS(3624),
    [anon_sym_PLUS] = ACTIONS(3624),
    [anon_sym_DASH] = ACTIONS(3624),
    [anon_sym_SLASH] = ACTIONS(3624),
    [anon_sym_PERCENT] = ACTIONS(3624),
    [anon_sym_DASH_DASH] = ACTIONS(3622),
    [anon_sym_PLUS_PLUS] = ACTIONS(3622),
    [anon_sym_DOT] = ACTIONS(3622),
    [anon_sym_DASH_GT] = ACTIONS(3622),
    [anon_sym_DQUOTE] = ACTIONS(3626),
    [sym_comment] = ACTIONS(91),
  },
  [1231] = {
    [anon_sym_COMMA] = ACTIONS(4213),
    [anon_sym_RPAREN] = ACTIONS(4213),
    [anon_sym_SEMI] = ACTIONS(4213),
    [anon_sym_extern] = ACTIONS(4215),
    [anon_sym_LBRACE] = ACTIONS(4213),
    [anon_sym_LPAREN2] = ACTIONS(4213),
    [anon_sym_STAR] = ACTIONS(4213),
    [anon_sym_LBRACK] = ACTIONS(4213),
    [anon_sym_EQ] = ACTIONS(4213),
    [anon_sym_static] = ACTIONS(4215),
    [anon_sym_register] = ACTIONS(4215),
    [anon_sym_inline] = ACTIONS(4215),
    [anon_sym_const] = ACTIONS(4215),
    [anon_sym_restrict] = ACTIONS(4215),
    [anon_sym_volatile] = ACTIONS(4215),
    [anon_sym__Atomic] = ACTIONS(4215),
    [anon_sym_mutable] = ACTIONS(4215),
    [anon_sym_explicit] = ACTIONS(4215),
    [anon_sym_constexpr] = ACTIONS(4215),
    [anon_sym_COLON] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(4215),
    [anon_sym_AMP_AMP] = ACTIONS(4213),
    [anon_sym_TILDE] = ACTIONS(4213),
    [anon_sym_DASH_GT] = ACTIONS(4213),
    [sym_identifier] = ACTIONS(4215),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4215),
    [anon_sym_override] = ACTIONS(4215),
    [anon_sym_GT2] = ACTIONS(4213),
    [sym_noexcept] = ACTIONS(4215),
    [anon_sym_COLON_COLON] = ACTIONS(4213),
    [sym_operator_name] = ACTIONS(4213),
  },
  [1232] = {
    [sym__expression] = STATE(1986),
    [sym_conditional_expression] = STATE(1986),
    [sym_assignment_expression] = STATE(1986),
    [sym_pointer_expression] = STATE(1986),
    [sym_logical_expression] = STATE(1986),
    [sym_bitwise_expression] = STATE(1986),
    [sym_equality_expression] = STATE(1986),
    [sym_relational_expression] = STATE(1986),
    [sym_shift_expression] = STATE(1986),
    [sym_math_expression] = STATE(1986),
    [sym_cast_expression] = STATE(1986),
    [sym_sizeof_expression] = STATE(1986),
    [sym_subscript_expression] = STATE(1986),
    [sym_call_expression] = STATE(1986),
    [sym_field_expression] = STATE(1986),
    [sym_compound_literal_expression] = STATE(1986),
    [sym_parenthesized_expression] = STATE(1986),
    [sym_char_literal] = STATE(1986),
    [sym_concatenated_string] = STATE(1986),
    [sym_string_literal] = STATE(727),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1986),
    [sym_new_expression] = STATE(1986),
    [sym_delete_expression] = STATE(1986),
    [sym_lambda_expression] = STATE(1986),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4217),
    [anon_sym_LPAREN2] = ACTIONS(1256),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(1262),
    [anon_sym_TILDE] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_DASH_DASH] = ACTIONS(1268),
    [anon_sym_PLUS_PLUS] = ACTIONS(1268),
    [anon_sym_sizeof] = ACTIONS(1270),
    [sym_number_literal] = ACTIONS(4217),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4219),
    [sym_false] = ACTIONS(4219),
    [sym_null] = ACTIONS(4219),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1276),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1280),
    [sym_nullptr] = ACTIONS(4219),
  },
  [1233] = {
    [sym_enumerator] = STATE(1988),
    [anon_sym_RBRACE] = ACTIONS(4221),
    [sym_identifier] = ACTIONS(1009),
    [sym_comment] = ACTIONS(91),
  },
  [1234] = {
    [aux_sym_enumerator_list_repeat1] = STATE(1990),
    [anon_sym_COMMA] = ACTIONS(4223),
    [anon_sym_RBRACE] = ACTIONS(4221),
    [sym_comment] = ACTIONS(91),
  },
  [1235] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(1995),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1995),
    [sym_preproc_else_in_field_declaration_list] = STATE(1994),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1994),
    [sym_type_definition] = STATE(1995),
    [sym__declaration_specifiers] = STATE(598),
    [sym__declarator] = STATE(599),
    [sym_pointer_declarator] = STATE(599),
    [sym_function_declarator] = STATE(600),
    [sym_array_declarator] = STATE(599),
    [sym_storage_class_specifier] = STATE(605),
    [sym_type_qualifier] = STATE(605),
    [sym__type_specifier] = STATE(601),
    [sym_sized_type_specifier] = STATE(601),
    [sym_enum_specifier] = STATE(601),
    [sym_struct_specifier] = STATE(601),
    [sym_union_specifier] = STATE(601),
    [sym__field_declaration_list_item] = STATE(1995),
    [sym_field_declaration] = STATE(1995),
    [sym_macro_type_specifier] = STATE(601),
    [sym_class_specifier] = STATE(601),
    [sym_dependent_type] = STATE(601),
    [sym_template_declaration] = STATE(1995),
    [sym_inline_method_definition] = STATE(1995),
    [sym_constructor_or_destructor_definition] = STATE(1995),
    [sym_constructor_or_destructor_declaration] = STATE(1995),
    [sym_friend_declaration] = STATE(1995),
    [sym_access_specifier] = STATE(1995),
    [sym_reference_declarator] = STATE(599),
    [sym_template_type] = STATE(602),
    [sym_template_function] = STATE(599),
    [sym_using_declaration] = STATE(1995),
    [sym_alias_declaration] = STATE(1995),
    [sym_destructor_name] = STATE(599),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(603),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1995),
    [aux_sym__declaration_specifiers_repeat1] = STATE(605),
    [aux_sym_sized_type_specifier_repeat1] = STATE(606),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1019),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4225),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4227),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4229),
    [anon_sym_typedef] = ACTIONS(1023),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(425),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(1027),
    [anon_sym_long] = ACTIONS(1027),
    [anon_sym_short] = ACTIONS(1027),
    [sym_primitive_type] = ACTIONS(1029),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(1031),
    [anon_sym_union] = ACTIONS(1033),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(1035),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1039),
    [sym_auto] = ACTIONS(1029),
    [anon_sym_typename] = ACTIONS(1041),
    [anon_sym_template] = ACTIONS(1043),
    [anon_sym_friend] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1039),
    [anon_sym_protected] = ACTIONS(1039),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_COLON_COLON] = ACTIONS(1049),
    [sym_operator_name] = ACTIONS(1051),
  },
  [1236] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(1998),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1998),
    [sym_preproc_else_in_field_declaration_list] = STATE(1997),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1997),
    [sym_type_definition] = STATE(1998),
    [sym__declaration_specifiers] = STATE(598),
    [sym__declarator] = STATE(599),
    [sym_pointer_declarator] = STATE(599),
    [sym_function_declarator] = STATE(600),
    [sym_array_declarator] = STATE(599),
    [sym_storage_class_specifier] = STATE(605),
    [sym_type_qualifier] = STATE(605),
    [sym__type_specifier] = STATE(601),
    [sym_sized_type_specifier] = STATE(601),
    [sym_enum_specifier] = STATE(601),
    [sym_struct_specifier] = STATE(601),
    [sym_union_specifier] = STATE(601),
    [sym__field_declaration_list_item] = STATE(1998),
    [sym_field_declaration] = STATE(1998),
    [sym_macro_type_specifier] = STATE(601),
    [sym_class_specifier] = STATE(601),
    [sym_dependent_type] = STATE(601),
    [sym_template_declaration] = STATE(1998),
    [sym_inline_method_definition] = STATE(1998),
    [sym_constructor_or_destructor_definition] = STATE(1998),
    [sym_constructor_or_destructor_declaration] = STATE(1998),
    [sym_friend_declaration] = STATE(1998),
    [sym_access_specifier] = STATE(1998),
    [sym_reference_declarator] = STATE(599),
    [sym_template_type] = STATE(602),
    [sym_template_function] = STATE(599),
    [sym_using_declaration] = STATE(1998),
    [sym_alias_declaration] = STATE(1998),
    [sym_destructor_name] = STATE(599),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(603),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(605),
    [aux_sym_sized_type_specifier_repeat1] = STATE(606),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1019),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4231),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4227),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4229),
    [anon_sym_typedef] = ACTIONS(1023),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(425),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(1027),
    [anon_sym_long] = ACTIONS(1027),
    [anon_sym_short] = ACTIONS(1027),
    [sym_primitive_type] = ACTIONS(1029),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(1031),
    [anon_sym_union] = ACTIONS(1033),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(1035),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1039),
    [sym_auto] = ACTIONS(1029),
    [anon_sym_typename] = ACTIONS(1041),
    [anon_sym_template] = ACTIONS(1043),
    [anon_sym_friend] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1039),
    [anon_sym_protected] = ACTIONS(1039),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_COLON_COLON] = ACTIONS(1049),
    [sym_operator_name] = ACTIONS(1051),
  },
  [1237] = {
    [sym__type_declarator] = STATE(1999),
    [sym_pointer_type_declarator] = STATE(1999),
    [sym_function_type_declarator] = STATE(1999),
    [sym_array_type_declarator] = STATE(1999),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_STAR] = ACTIONS(768),
    [sym_identifier] = ACTIONS(770),
    [sym_comment] = ACTIONS(91),
  },
  [1238] = {
    [sym_type_qualifier] = STATE(453),
    [sym__type_specifier] = STATE(2000),
    [sym_sized_type_specifier] = STATE(2000),
    [sym_enum_specifier] = STATE(2000),
    [sym_struct_specifier] = STATE(2000),
    [sym_union_specifier] = STATE(2000),
    [sym_macro_type_specifier] = STATE(2000),
    [sym_class_specifier] = STATE(2000),
    [sym_dependent_type] = STATE(2000),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(82),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_type_definition_repeat1] = STATE(453),
    [aux_sym_sized_type_specifier_repeat1] = STATE(85),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(135),
    [anon_sym_long] = ACTIONS(135),
    [anon_sym_short] = ACTIONS(135),
    [sym_primitive_type] = ACTIONS(4233),
    [anon_sym_enum] = ACTIONS(139),
    [anon_sym_struct] = ACTIONS(141),
    [anon_sym_union] = ACTIONS(143),
    [sym_identifier] = ACTIONS(145),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(147),
    [sym_auto] = ACTIONS(4233),
    [anon_sym_typename] = ACTIONS(149),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [1239] = {
    [sym_field_declaration_list] = STATE(612),
    [sym_virtual_specifier] = STATE(613),
    [sym_base_class_clause] = STATE(614),
    [sym_template_argument_list] = STATE(615),
    [anon_sym_SEMI] = ACTIONS(1057),
    [anon_sym_extern] = ACTIONS(1059),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LPAREN2] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1057),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_register] = ACTIONS(1059),
    [anon_sym_inline] = ACTIONS(1059),
    [anon_sym_const] = ACTIONS(1059),
    [anon_sym_restrict] = ACTIONS(1059),
    [anon_sym_volatile] = ACTIONS(1059),
    [anon_sym__Atomic] = ACTIONS(1059),
    [anon_sym_mutable] = ACTIONS(1059),
    [anon_sym_explicit] = ACTIONS(1059),
    [anon_sym_constexpr] = ACTIONS(1059),
    [anon_sym_COLON] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(643),
    [sym_identifier] = ACTIONS(1059),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(1061),
    [sym_operator_name] = ACTIONS(1057),
  },
  [1240] = {
    [sym_field_declaration_list] = STATE(617),
    [sym_virtual_specifier] = STATE(620),
    [sym_base_class_clause] = STATE(618),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_extern] = ACTIONS(1071),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_static] = ACTIONS(1071),
    [anon_sym_register] = ACTIONS(1071),
    [anon_sym_inline] = ACTIONS(1071),
    [anon_sym_const] = ACTIONS(1071),
    [anon_sym_restrict] = ACTIONS(1071),
    [anon_sym_volatile] = ACTIONS(1071),
    [anon_sym__Atomic] = ACTIONS(1071),
    [anon_sym_mutable] = ACTIONS(1071),
    [anon_sym_explicit] = ACTIONS(1071),
    [anon_sym_constexpr] = ACTIONS(1071),
    [anon_sym_COLON] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1069),
    [sym_identifier] = ACTIONS(1071),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [sym_operator_name] = ACTIONS(1069),
  },
  [1241] = {
    [sym_field_declaration_list] = STATE(617),
    [sym_virtual_specifier] = STATE(620),
    [sym_base_class_clause] = STATE(618),
    [sym_template_argument_list] = STATE(362),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_extern] = ACTIONS(1071),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_static] = ACTIONS(1071),
    [anon_sym_register] = ACTIONS(1071),
    [anon_sym_inline] = ACTIONS(1071),
    [anon_sym_const] = ACTIONS(1071),
    [anon_sym_restrict] = ACTIONS(1071),
    [anon_sym_volatile] = ACTIONS(1071),
    [anon_sym__Atomic] = ACTIONS(1071),
    [anon_sym_mutable] = ACTIONS(1071),
    [anon_sym_explicit] = ACTIONS(1071),
    [anon_sym_constexpr] = ACTIONS(1071),
    [anon_sym_COLON] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1069),
    [anon_sym_LT] = ACTIONS(643),
    [sym_identifier] = ACTIONS(1071),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(1069),
    [sym_operator_name] = ACTIONS(1069),
  },
  [1242] = {
    [sym_field_declaration_list] = STATE(621),
    [sym_virtual_specifier] = STATE(622),
    [sym_base_class_clause] = STATE(623),
    [sym_template_argument_list] = STATE(615),
    [anon_sym_SEMI] = ACTIONS(1077),
    [anon_sym_extern] = ACTIONS(1079),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LPAREN2] = ACTIONS(1077),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_static] = ACTIONS(1079),
    [anon_sym_register] = ACTIONS(1079),
    [anon_sym_inline] = ACTIONS(1079),
    [anon_sym_const] = ACTIONS(1079),
    [anon_sym_restrict] = ACTIONS(1079),
    [anon_sym_volatile] = ACTIONS(1079),
    [anon_sym__Atomic] = ACTIONS(1079),
    [anon_sym_mutable] = ACTIONS(1079),
    [anon_sym_explicit] = ACTIONS(1079),
    [anon_sym_constexpr] = ACTIONS(1079),
    [anon_sym_COLON] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_LT] = ACTIONS(643),
    [sym_identifier] = ACTIONS(1079),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(1061),
    [sym_operator_name] = ACTIONS(1077),
  },
  [1243] = {
    [sym_field_declaration_list] = STATE(624),
    [sym_virtual_specifier] = STATE(626),
    [sym_base_class_clause] = STATE(625),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_extern] = ACTIONS(1083),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LPAREN2] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1081),
    [anon_sym_static] = ACTIONS(1083),
    [anon_sym_register] = ACTIONS(1083),
    [anon_sym_inline] = ACTIONS(1083),
    [anon_sym_const] = ACTIONS(1083),
    [anon_sym_restrict] = ACTIONS(1083),
    [anon_sym_volatile] = ACTIONS(1083),
    [anon_sym__Atomic] = ACTIONS(1083),
    [anon_sym_mutable] = ACTIONS(1083),
    [anon_sym_explicit] = ACTIONS(1083),
    [anon_sym_constexpr] = ACTIONS(1083),
    [anon_sym_COLON] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [sym_identifier] = ACTIONS(1083),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [sym_operator_name] = ACTIONS(1081),
  },
  [1244] = {
    [sym_field_declaration_list] = STATE(624),
    [sym_virtual_specifier] = STATE(626),
    [sym_base_class_clause] = STATE(625),
    [sym_template_argument_list] = STATE(362),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_extern] = ACTIONS(1083),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LPAREN2] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1081),
    [anon_sym_static] = ACTIONS(1083),
    [anon_sym_register] = ACTIONS(1083),
    [anon_sym_inline] = ACTIONS(1083),
    [anon_sym_const] = ACTIONS(1083),
    [anon_sym_restrict] = ACTIONS(1083),
    [anon_sym_volatile] = ACTIONS(1083),
    [anon_sym__Atomic] = ACTIONS(1083),
    [anon_sym_mutable] = ACTIONS(1083),
    [anon_sym_explicit] = ACTIONS(1083),
    [anon_sym_constexpr] = ACTIONS(1083),
    [anon_sym_COLON] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(643),
    [sym_identifier] = ACTIONS(1083),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(1081),
    [sym_operator_name] = ACTIONS(1081),
  },
  [1245] = {
    [sym_destructor_name] = STATE(789),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(4235),
    [sym_comment] = ACTIONS(91),
    [sym_operator_name] = ACTIONS(1418),
  },
  [1246] = {
    [anon_sym_SEMI] = ACTIONS(1431),
    [anon_sym_extern] = ACTIONS(1429),
    [anon_sym_LPAREN2] = ACTIONS(1426),
    [anon_sym_STAR] = ACTIONS(1431),
    [anon_sym_LBRACK] = ACTIONS(1424),
    [anon_sym_static] = ACTIONS(1429),
    [anon_sym_register] = ACTIONS(1429),
    [anon_sym_inline] = ACTIONS(1429),
    [anon_sym_const] = ACTIONS(1429),
    [anon_sym_restrict] = ACTIONS(1429),
    [anon_sym_volatile] = ACTIONS(1429),
    [anon_sym__Atomic] = ACTIONS(1429),
    [anon_sym_mutable] = ACTIONS(1429),
    [anon_sym_explicit] = ACTIONS(1429),
    [anon_sym_constexpr] = ACTIONS(1429),
    [anon_sym_COLON] = ACTIONS(1429),
    [anon_sym_AMP] = ACTIONS(1429),
    [anon_sym_AMP_AMP] = ACTIONS(1431),
    [sym_identifier] = ACTIONS(1429),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1431),
    [sym_operator_name] = ACTIONS(1431),
  },
  [1247] = {
    [sym_field_declaration_list] = STATE(790),
    [sym_virtual_specifier] = STATE(791),
    [sym_base_class_clause] = STATE(792),
    [sym_template_argument_list] = STATE(615),
    [anon_sym_SEMI] = ACTIONS(1438),
    [anon_sym_extern] = ACTIONS(1440),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LPAREN2] = ACTIONS(1438),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_static] = ACTIONS(1440),
    [anon_sym_register] = ACTIONS(1440),
    [anon_sym_inline] = ACTIONS(1440),
    [anon_sym_const] = ACTIONS(1440),
    [anon_sym_restrict] = ACTIONS(1440),
    [anon_sym_volatile] = ACTIONS(1440),
    [anon_sym__Atomic] = ACTIONS(1440),
    [anon_sym_mutable] = ACTIONS(1440),
    [anon_sym_explicit] = ACTIONS(1440),
    [anon_sym_constexpr] = ACTIONS(1440),
    [anon_sym_COLON] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_AMP_AMP] = ACTIONS(1438),
    [anon_sym_LT] = ACTIONS(643),
    [sym_identifier] = ACTIONS(1440),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(1061),
    [sym_operator_name] = ACTIONS(1438),
  },
  [1248] = {
    [sym_field_declaration_list] = STATE(793),
    [sym_virtual_specifier] = STATE(795),
    [sym_base_class_clause] = STATE(794),
    [anon_sym_SEMI] = ACTIONS(1442),
    [anon_sym_extern] = ACTIONS(1444),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LPAREN2] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1442),
    [anon_sym_static] = ACTIONS(1444),
    [anon_sym_register] = ACTIONS(1444),
    [anon_sym_inline] = ACTIONS(1444),
    [anon_sym_const] = ACTIONS(1444),
    [anon_sym_restrict] = ACTIONS(1444),
    [anon_sym_volatile] = ACTIONS(1444),
    [anon_sym__Atomic] = ACTIONS(1444),
    [anon_sym_mutable] = ACTIONS(1444),
    [anon_sym_explicit] = ACTIONS(1444),
    [anon_sym_constexpr] = ACTIONS(1444),
    [anon_sym_COLON] = ACTIONS(1444),
    [anon_sym_AMP] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1442),
    [sym_identifier] = ACTIONS(1444),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [sym_operator_name] = ACTIONS(1442),
  },
  [1249] = {
    [sym_field_declaration_list] = STATE(793),
    [sym_virtual_specifier] = STATE(795),
    [sym_base_class_clause] = STATE(794),
    [sym_template_argument_list] = STATE(362),
    [anon_sym_SEMI] = ACTIONS(1442),
    [anon_sym_extern] = ACTIONS(1444),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LPAREN2] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1442),
    [anon_sym_static] = ACTIONS(1444),
    [anon_sym_register] = ACTIONS(1444),
    [anon_sym_inline] = ACTIONS(1444),
    [anon_sym_const] = ACTIONS(1444),
    [anon_sym_restrict] = ACTIONS(1444),
    [anon_sym_volatile] = ACTIONS(1444),
    [anon_sym__Atomic] = ACTIONS(1444),
    [anon_sym_mutable] = ACTIONS(1444),
    [anon_sym_explicit] = ACTIONS(1444),
    [anon_sym_constexpr] = ACTIONS(1444),
    [anon_sym_COLON] = ACTIONS(1444),
    [anon_sym_AMP] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1442),
    [anon_sym_LT] = ACTIONS(643),
    [sym_identifier] = ACTIONS(1444),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(1442),
    [sym_operator_name] = ACTIONS(1442),
  },
  [1250] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4237),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4239),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4239),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4239),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4239),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4239),
    [anon_sym_typedef] = ACTIONS(4237),
    [anon_sym_extern] = ACTIONS(4237),
    [anon_sym_RBRACE] = ACTIONS(4239),
    [anon_sym_LPAREN2] = ACTIONS(4239),
    [anon_sym_STAR] = ACTIONS(4239),
    [anon_sym_static] = ACTIONS(4237),
    [anon_sym_register] = ACTIONS(4237),
    [anon_sym_inline] = ACTIONS(4237),
    [anon_sym_const] = ACTIONS(4237),
    [anon_sym_restrict] = ACTIONS(4237),
    [anon_sym_volatile] = ACTIONS(4237),
    [anon_sym__Atomic] = ACTIONS(4237),
    [anon_sym_mutable] = ACTIONS(4237),
    [anon_sym_explicit] = ACTIONS(4237),
    [anon_sym_constexpr] = ACTIONS(4237),
    [anon_sym_unsigned] = ACTIONS(4237),
    [anon_sym_long] = ACTIONS(4237),
    [anon_sym_short] = ACTIONS(4237),
    [sym_primitive_type] = ACTIONS(4237),
    [anon_sym_enum] = ACTIONS(4237),
    [anon_sym_struct] = ACTIONS(4237),
    [anon_sym_union] = ACTIONS(4237),
    [anon_sym_AMP] = ACTIONS(4237),
    [anon_sym_AMP_AMP] = ACTIONS(4239),
    [anon_sym_TILDE] = ACTIONS(4239),
    [sym_identifier] = ACTIONS(4237),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4237),
    [anon_sym_public] = ACTIONS(4237),
    [sym_auto] = ACTIONS(4237),
    [anon_sym_typename] = ACTIONS(4237),
    [anon_sym_template] = ACTIONS(4237),
    [anon_sym_friend] = ACTIONS(4237),
    [anon_sym_private] = ACTIONS(4237),
    [anon_sym_protected] = ACTIONS(4237),
    [anon_sym_using] = ACTIONS(4237),
    [anon_sym_COLON_COLON] = ACTIONS(4239),
    [sym_operator_name] = ACTIONS(4239),
  },
  [1251] = {
    [sym_function_definition] = STATE(2002),
    [sym_declaration] = STATE(2002),
    [sym__declaration_specifiers] = STATE(2003),
    [sym_storage_class_specifier] = STATE(818),
    [sym_type_qualifier] = STATE(818),
    [sym__type_specifier] = STATE(817),
    [sym_sized_type_specifier] = STATE(817),
    [sym_enum_specifier] = STATE(817),
    [sym_struct_specifier] = STATE(817),
    [sym_union_specifier] = STATE(817),
    [sym__empty_declaration] = STATE(2002),
    [sym_macro_type_specifier] = STATE(817),
    [sym_class_specifier] = STATE(817),
    [sym_dependent_type] = STATE(817),
    [sym_template_type] = STATE(272),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(180),
    [aux_sym__declaration_specifiers_repeat1] = STATE(818),
    [aux_sym_sized_type_specifier_repeat1] = STATE(819),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(1475),
    [anon_sym_long] = ACTIONS(1475),
    [anon_sym_short] = ACTIONS(1475),
    [sym_primitive_type] = ACTIONS(1477),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [sym_identifier] = ACTIONS(492),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(1477),
    [anon_sym_typename] = ACTIONS(1479),
    [anon_sym_COLON_COLON] = ACTIONS(315),
  },
  [1252] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4241),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4243),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4243),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4243),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4243),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4243),
    [anon_sym_typedef] = ACTIONS(4241),
    [anon_sym_extern] = ACTIONS(4241),
    [anon_sym_RBRACE] = ACTIONS(4243),
    [anon_sym_LPAREN2] = ACTIONS(4243),
    [anon_sym_STAR] = ACTIONS(4243),
    [anon_sym_static] = ACTIONS(4241),
    [anon_sym_register] = ACTIONS(4241),
    [anon_sym_inline] = ACTIONS(4241),
    [anon_sym_const] = ACTIONS(4241),
    [anon_sym_restrict] = ACTIONS(4241),
    [anon_sym_volatile] = ACTIONS(4241),
    [anon_sym__Atomic] = ACTIONS(4241),
    [anon_sym_mutable] = ACTIONS(4241),
    [anon_sym_explicit] = ACTIONS(4241),
    [anon_sym_constexpr] = ACTIONS(4241),
    [anon_sym_unsigned] = ACTIONS(4241),
    [anon_sym_long] = ACTIONS(4241),
    [anon_sym_short] = ACTIONS(4241),
    [sym_primitive_type] = ACTIONS(4241),
    [anon_sym_enum] = ACTIONS(4241),
    [anon_sym_struct] = ACTIONS(4241),
    [anon_sym_union] = ACTIONS(4241),
    [anon_sym_AMP] = ACTIONS(4241),
    [anon_sym_AMP_AMP] = ACTIONS(4243),
    [anon_sym_TILDE] = ACTIONS(4243),
    [sym_identifier] = ACTIONS(4241),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4241),
    [anon_sym_public] = ACTIONS(4241),
    [sym_auto] = ACTIONS(4241),
    [anon_sym_typename] = ACTIONS(4241),
    [anon_sym_template] = ACTIONS(4241),
    [anon_sym_friend] = ACTIONS(4241),
    [anon_sym_private] = ACTIONS(4241),
    [anon_sym_protected] = ACTIONS(4241),
    [anon_sym_using] = ACTIONS(4241),
    [anon_sym_COLON_COLON] = ACTIONS(4243),
    [sym_operator_name] = ACTIONS(4243),
  },
  [1253] = {
    [sym__declarator] = STATE(2004),
    [sym_pointer_declarator] = STATE(2004),
    [sym_function_declarator] = STATE(2004),
    [sym_array_declarator] = STATE(2004),
    [sym_init_declarator] = STATE(2005),
    [sym_reference_declarator] = STATE(2004),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(2004),
    [sym_destructor_name] = STATE(2004),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(560),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(568),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(4245),
  },
  [1254] = {
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_extern] = ACTIONS(626),
    [anon_sym_LPAREN2] = ACTIONS(624),
    [anon_sym_STAR] = ACTIONS(624),
    [anon_sym_static] = ACTIONS(626),
    [anon_sym_register] = ACTIONS(626),
    [anon_sym_inline] = ACTIONS(626),
    [anon_sym_const] = ACTIONS(626),
    [anon_sym_restrict] = ACTIONS(626),
    [anon_sym_volatile] = ACTIONS(626),
    [anon_sym__Atomic] = ACTIONS(626),
    [anon_sym_mutable] = ACTIONS(626),
    [anon_sym_explicit] = ACTIONS(626),
    [anon_sym_constexpr] = ACTIONS(626),
    [anon_sym_AMP] = ACTIONS(626),
    [anon_sym_AMP_AMP] = ACTIONS(624),
    [anon_sym_TILDE] = ACTIONS(624),
    [sym_identifier] = ACTIONS(626),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(624),
    [sym_operator_name] = ACTIONS(624),
  },
  [1255] = {
    [sym_template_argument_list] = STATE(437),
    [anon_sym_SEMI] = ACTIONS(4249),
    [anon_sym_EQ] = ACTIONS(4251),
    [anon_sym_LT] = ACTIONS(945),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1519),
  },
  [1256] = {
    [sym_template_type] = STATE(296),
    [sym_scoped_identifier] = STATE(2010),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(296),
    [sym_identifier] = ACTIONS(4253),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(528),
  },
  [1257] = {
    [anon_sym_SEMI] = ACTIONS(4249),
    [sym_comment] = ACTIONS(91),
  },
  [1258] = {
    [anon_sym_SEMI] = ACTIONS(1582),
    [anon_sym_extern] = ACTIONS(1580),
    [anon_sym_LPAREN2] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1582),
    [anon_sym_LBRACK] = ACTIONS(1575),
    [anon_sym_static] = ACTIONS(1580),
    [anon_sym_register] = ACTIONS(1580),
    [anon_sym_inline] = ACTIONS(1580),
    [anon_sym_const] = ACTIONS(1580),
    [anon_sym_restrict] = ACTIONS(1580),
    [anon_sym_volatile] = ACTIONS(1580),
    [anon_sym__Atomic] = ACTIONS(1580),
    [anon_sym_mutable] = ACTIONS(1580),
    [anon_sym_explicit] = ACTIONS(1580),
    [anon_sym_constexpr] = ACTIONS(1580),
    [anon_sym_COLON] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1582),
    [anon_sym_LT] = ACTIONS(1577),
    [sym_identifier] = ACTIONS(1580),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [sym_operator_name] = ACTIONS(1582),
  },
  [1259] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4255),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4257),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4257),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4257),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4257),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4257),
    [anon_sym_typedef] = ACTIONS(4255),
    [anon_sym_extern] = ACTIONS(4255),
    [anon_sym_RBRACE] = ACTIONS(4257),
    [anon_sym_LPAREN2] = ACTIONS(4257),
    [anon_sym_STAR] = ACTIONS(4257),
    [anon_sym_static] = ACTIONS(4255),
    [anon_sym_register] = ACTIONS(4255),
    [anon_sym_inline] = ACTIONS(4255),
    [anon_sym_const] = ACTIONS(4255),
    [anon_sym_restrict] = ACTIONS(4255),
    [anon_sym_volatile] = ACTIONS(4255),
    [anon_sym__Atomic] = ACTIONS(4255),
    [anon_sym_mutable] = ACTIONS(4255),
    [anon_sym_explicit] = ACTIONS(4255),
    [anon_sym_constexpr] = ACTIONS(4255),
    [anon_sym_unsigned] = ACTIONS(4255),
    [anon_sym_long] = ACTIONS(4255),
    [anon_sym_short] = ACTIONS(4255),
    [sym_primitive_type] = ACTIONS(4255),
    [anon_sym_enum] = ACTIONS(4255),
    [anon_sym_struct] = ACTIONS(4255),
    [anon_sym_union] = ACTIONS(4255),
    [anon_sym_AMP] = ACTIONS(4255),
    [anon_sym_AMP_AMP] = ACTIONS(4257),
    [anon_sym_TILDE] = ACTIONS(4257),
    [sym_identifier] = ACTIONS(4255),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4255),
    [anon_sym_public] = ACTIONS(4255),
    [sym_auto] = ACTIONS(4255),
    [anon_sym_typename] = ACTIONS(4255),
    [anon_sym_template] = ACTIONS(4255),
    [anon_sym_friend] = ACTIONS(4255),
    [anon_sym_private] = ACTIONS(4255),
    [anon_sym_protected] = ACTIONS(4255),
    [anon_sym_using] = ACTIONS(4255),
    [anon_sym_COLON_COLON] = ACTIONS(4257),
    [sym_operator_name] = ACTIONS(4257),
  },
  [1260] = {
    [sym__field_declarator] = STATE(2013),
    [sym_pointer_field_declarator] = STATE(2013),
    [sym_function_field_declarator] = STATE(2013),
    [sym_array_field_declarator] = STATE(2013),
    [sym_reference_field_declarator] = STATE(2013),
    [sym_template_type] = STATE(953),
    [sym_template_method] = STATE(2013),
    [sym_scoped_field_identifier] = STATE(955),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(953),
    [anon_sym_LPAREN2] = ACTIONS(2655),
    [anon_sym_STAR] = ACTIONS(4259),
    [anon_sym_AMP] = ACTIONS(4261),
    [anon_sym_AMP_AMP] = ACTIONS(4263),
    [sym_identifier] = ACTIONS(2665),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1755),
    [sym_operator_name] = ACTIONS(4265),
  },
  [1261] = {
    [sym__field_declarator] = STATE(2014),
    [sym_pointer_field_declarator] = STATE(2014),
    [sym_function_field_declarator] = STATE(2014),
    [sym_array_field_declarator] = STATE(2014),
    [sym_type_qualifier] = STATE(2015),
    [sym_reference_field_declarator] = STATE(2014),
    [sym_template_type] = STATE(953),
    [sym_template_method] = STATE(2014),
    [sym_scoped_field_identifier] = STATE(1266),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(953),
    [aux_sym_type_definition_repeat1] = STATE(2015),
    [anon_sym_LPAREN2] = ACTIONS(2655),
    [anon_sym_STAR] = ACTIONS(2657),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(2661),
    [anon_sym_AMP_AMP] = ACTIONS(2663),
    [sym_identifier] = ACTIONS(2665),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1755),
    [sym_operator_name] = ACTIONS(4267),
  },
  [1262] = {
    [sym__expression] = STATE(2016),
    [sym_conditional_expression] = STATE(2016),
    [sym_assignment_expression] = STATE(2016),
    [sym_pointer_expression] = STATE(2016),
    [sym_logical_expression] = STATE(2016),
    [sym_bitwise_expression] = STATE(2016),
    [sym_equality_expression] = STATE(2016),
    [sym_relational_expression] = STATE(2016),
    [sym_shift_expression] = STATE(2016),
    [sym_math_expression] = STATE(2016),
    [sym_cast_expression] = STATE(2016),
    [sym_sizeof_expression] = STATE(2016),
    [sym_subscript_expression] = STATE(2016),
    [sym_call_expression] = STATE(2016),
    [sym_field_expression] = STATE(2016),
    [sym_compound_literal_expression] = STATE(2016),
    [sym_parenthesized_expression] = STATE(2016),
    [sym_char_literal] = STATE(2016),
    [sym_concatenated_string] = STATE(2016),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2016),
    [sym_new_expression] = STATE(2016),
    [sym_delete_expression] = STATE(2016),
    [sym_lambda_expression] = STATE(2016),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4269),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(4269),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4271),
    [sym_false] = ACTIONS(4271),
    [sym_null] = ACTIONS(4271),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(4271),
  },
  [1263] = {
    [sym__field_declarator] = STATE(2017),
    [sym_pointer_field_declarator] = STATE(2017),
    [sym_function_field_declarator] = STATE(2017),
    [sym_array_field_declarator] = STATE(2017),
    [sym_reference_field_declarator] = STATE(2017),
    [sym_template_type] = STATE(953),
    [sym_template_method] = STATE(2017),
    [sym_scoped_field_identifier] = STATE(1266),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(953),
    [anon_sym_LPAREN2] = ACTIONS(2655),
    [anon_sym_STAR] = ACTIONS(2657),
    [anon_sym_AMP] = ACTIONS(2661),
    [anon_sym_AMP_AMP] = ACTIONS(2663),
    [sym_identifier] = ACTIONS(2665),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1755),
    [sym_operator_name] = ACTIONS(4273),
  },
  [1264] = {
    [sym_template_argument_list] = STATE(1707),
    [anon_sym_COMMA] = ACTIONS(4275),
    [anon_sym_RPAREN] = ACTIONS(4275),
    [anon_sym_SEMI] = ACTIONS(4275),
    [anon_sym_LBRACE] = ACTIONS(4275),
    [anon_sym_LPAREN2] = ACTIONS(4275),
    [anon_sym_LBRACK] = ACTIONS(4275),
    [anon_sym_EQ] = ACTIONS(4275),
    [anon_sym_COLON] = ACTIONS(4277),
    [anon_sym_LT] = ACTIONS(945),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(3612),
  },
  [1265] = {
    [sym_compound_statement] = STATE(2023),
    [sym_parameter_list] = STATE(2024),
    [sym_delete_method_clause] = STATE(2023),
    [aux_sym_field_declaration_repeat1] = STATE(2025),
    [anon_sym_COMMA] = ACTIONS(4279),
    [anon_sym_SEMI] = ACTIONS(4281),
    [anon_sym_LBRACE] = ACTIONS(2671),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_EQ] = ACTIONS(4285),
    [anon_sym_COLON] = ACTIONS(4287),
    [sym_comment] = ACTIONS(91),
  },
  [1266] = {
    [sym_template_argument_list] = STATE(1710),
    [anon_sym_LT] = ACTIONS(4289),
    [sym_comment] = ACTIONS(91),
  },
  [1267] = {
    [sym_type_qualifier] = STATE(2027),
    [sym_virtual_specifier] = STATE(2027),
    [sym_trailing_return_type] = STATE(2027),
    [aux_sym_function_declarator_repeat1] = STATE(2027),
    [anon_sym_SEMI] = ACTIONS(1665),
    [anon_sym_LBRACE] = ACTIONS(1665),
    [anon_sym_LPAREN2] = ACTIONS(1665),
    [anon_sym_LBRACK] = ACTIONS(1665),
    [anon_sym_EQ] = ACTIONS(1665),
    [anon_sym_const] = ACTIONS(1667),
    [anon_sym_restrict] = ACTIONS(1669),
    [anon_sym_volatile] = ACTIONS(1669),
    [anon_sym__Atomic] = ACTIONS(1669),
    [anon_sym_mutable] = ACTIONS(1669),
    [anon_sym_explicit] = ACTIONS(1669),
    [anon_sym_constexpr] = ACTIONS(1669),
    [anon_sym_COLON] = ACTIONS(1665),
    [anon_sym_DASH_GT] = ACTIONS(4291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [sym_noexcept] = ACTIONS(4293),
  },
  [1268] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4297),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4297),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4297),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4297),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4297),
    [anon_sym_typedef] = ACTIONS(4295),
    [anon_sym_extern] = ACTIONS(4295),
    [anon_sym_RBRACE] = ACTIONS(4297),
    [anon_sym_LPAREN2] = ACTIONS(4297),
    [anon_sym_STAR] = ACTIONS(4297),
    [anon_sym_static] = ACTIONS(4295),
    [anon_sym_register] = ACTIONS(4295),
    [anon_sym_inline] = ACTIONS(4295),
    [anon_sym_const] = ACTIONS(4295),
    [anon_sym_restrict] = ACTIONS(4295),
    [anon_sym_volatile] = ACTIONS(4295),
    [anon_sym__Atomic] = ACTIONS(4295),
    [anon_sym_mutable] = ACTIONS(4295),
    [anon_sym_explicit] = ACTIONS(4295),
    [anon_sym_constexpr] = ACTIONS(4295),
    [anon_sym_unsigned] = ACTIONS(4295),
    [anon_sym_long] = ACTIONS(4295),
    [anon_sym_short] = ACTIONS(4295),
    [sym_primitive_type] = ACTIONS(4295),
    [anon_sym_enum] = ACTIONS(4295),
    [anon_sym_struct] = ACTIONS(4295),
    [anon_sym_union] = ACTIONS(4295),
    [anon_sym_AMP] = ACTIONS(4295),
    [anon_sym_AMP_AMP] = ACTIONS(4297),
    [anon_sym_TILDE] = ACTIONS(4297),
    [sym_identifier] = ACTIONS(4295),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4295),
    [anon_sym_public] = ACTIONS(4295),
    [sym_auto] = ACTIONS(4295),
    [anon_sym_typename] = ACTIONS(4295),
    [anon_sym_template] = ACTIONS(4295),
    [anon_sym_friend] = ACTIONS(4295),
    [anon_sym_private] = ACTIONS(4295),
    [anon_sym_protected] = ACTIONS(4295),
    [anon_sym_using] = ACTIONS(4295),
    [anon_sym_COLON_COLON] = ACTIONS(4297),
    [sym_operator_name] = ACTIONS(4297),
  },
  [1269] = {
    [sym_preproc_include] = STATE(2029),
    [sym_preproc_def] = STATE(2029),
    [sym_preproc_function_def] = STATE(2029),
    [sym_preproc_call] = STATE(2029),
    [sym_preproc_if_in_compound_statement] = STATE(2029),
    [sym_preproc_ifdef_in_compound_statement] = STATE(2029),
    [sym_declaration] = STATE(2029),
    [sym_type_definition] = STATE(2029),
    [sym__declaration_specifiers] = STATE(113),
    [sym_compound_statement] = STATE(2029),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(2029),
    [sym_expression_statement] = STATE(2029),
    [sym_if_statement] = STATE(2029),
    [sym_switch_statement] = STATE(2029),
    [sym_case_statement] = STATE(2029),
    [sym_while_statement] = STATE(2029),
    [sym_do_statement] = STATE(2029),
    [sym_for_statement] = STATE(2029),
    [sym_return_statement] = STATE(2029),
    [sym_break_statement] = STATE(2029),
    [sym_continue_statement] = STATE(2029),
    [sym_goto_statement] = STATE(2029),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(2029),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(2029),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(2029),
    [sym_try_statement] = STATE(2029),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2029),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(157),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(159),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(161),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(163),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(165),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(165),
    [sym_preproc_directive] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_typedef] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_RBRACE] = ACTIONS(4299),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(185),
    [anon_sym_case] = ACTIONS(187),
    [anon_sym_default] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(209),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_nullptr] = ACTIONS(207),
  },
  [1270] = {
    [anon_sym_default] = ACTIONS(4301),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(4303),
  },
  [1271] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1685),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1685),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1685),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1685),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1685),
    [anon_sym_typedef] = ACTIONS(1687),
    [anon_sym_extern] = ACTIONS(1687),
    [anon_sym_RBRACE] = ACTIONS(1685),
    [anon_sym_LPAREN2] = ACTIONS(1685),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_static] = ACTIONS(1687),
    [anon_sym_register] = ACTIONS(1687),
    [anon_sym_inline] = ACTIONS(1687),
    [anon_sym_const] = ACTIONS(1687),
    [anon_sym_restrict] = ACTIONS(1687),
    [anon_sym_volatile] = ACTIONS(1687),
    [anon_sym__Atomic] = ACTIONS(1687),
    [anon_sym_mutable] = ACTIONS(1687),
    [anon_sym_explicit] = ACTIONS(1687),
    [anon_sym_constexpr] = ACTIONS(1687),
    [anon_sym_unsigned] = ACTIONS(1687),
    [anon_sym_long] = ACTIONS(1687),
    [anon_sym_short] = ACTIONS(1687),
    [sym_primitive_type] = ACTIONS(1687),
    [anon_sym_enum] = ACTIONS(1687),
    [anon_sym_struct] = ACTIONS(1687),
    [anon_sym_union] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_TILDE] = ACTIONS(1685),
    [sym_identifier] = ACTIONS(1687),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1687),
    [anon_sym_public] = ACTIONS(1687),
    [sym_auto] = ACTIONS(1687),
    [anon_sym_typename] = ACTIONS(1687),
    [anon_sym_template] = ACTIONS(1687),
    [anon_sym_friend] = ACTIONS(1687),
    [anon_sym_private] = ACTIONS(1687),
    [anon_sym_protected] = ACTIONS(1687),
    [anon_sym_using] = ACTIONS(1687),
    [anon_sym_COLON_COLON] = ACTIONS(1685),
    [sym_operator_name] = ACTIONS(1685),
  },
  [1272] = {
    [sym_compound_statement] = STATE(2032),
    [sym_default_method_clause] = STATE(2032),
    [sym_delete_method_clause] = STATE(2032),
    [anon_sym_LBRACE] = ACTIONS(2671),
    [anon_sym_EQ] = ACTIONS(2673),
    [sym_comment] = ACTIONS(91),
  },
  [1273] = {
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [anon_sym_SEMI] = ACTIONS(1689),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_LPAREN2] = ACTIONS(1689),
    [anon_sym_STAR] = ACTIONS(1689),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_COLON] = ACTIONS(1691),
    [anon_sym_AMP] = ACTIONS(1691),
    [anon_sym_AMP_AMP] = ACTIONS(1689),
    [sym_identifier] = ACTIONS(1691),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1689),
    [sym_operator_name] = ACTIONS(1689),
  },
  [1274] = {
    [sym_destructor_name] = STATE(958),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(4305),
    [sym_comment] = ACTIONS(91),
    [sym_operator_name] = ACTIONS(1767),
  },
  [1275] = {
    [anon_sym_COMMA] = ACTIONS(4307),
    [anon_sym_RPAREN] = ACTIONS(4307),
    [anon_sym_SEMI] = ACTIONS(4307),
    [anon_sym_extern] = ACTIONS(4309),
    [anon_sym_LBRACE] = ACTIONS(4307),
    [anon_sym_LPAREN2] = ACTIONS(4307),
    [anon_sym_STAR] = ACTIONS(4307),
    [anon_sym_LBRACK] = ACTIONS(4307),
    [anon_sym_EQ] = ACTIONS(4307),
    [anon_sym_static] = ACTIONS(4309),
    [anon_sym_register] = ACTIONS(4309),
    [anon_sym_inline] = ACTIONS(4309),
    [anon_sym_const] = ACTIONS(4309),
    [anon_sym_restrict] = ACTIONS(4309),
    [anon_sym_volatile] = ACTIONS(4309),
    [anon_sym__Atomic] = ACTIONS(4309),
    [anon_sym_mutable] = ACTIONS(4309),
    [anon_sym_explicit] = ACTIONS(4309),
    [anon_sym_constexpr] = ACTIONS(4309),
    [anon_sym_COLON] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_AMP_AMP] = ACTIONS(4307),
    [anon_sym_TILDE] = ACTIONS(4307),
    [anon_sym_DASH_GT] = ACTIONS(4307),
    [sym_identifier] = ACTIONS(4309),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4309),
    [anon_sym_override] = ACTIONS(4309),
    [anon_sym_GT2] = ACTIONS(4307),
    [sym_noexcept] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(4307),
    [sym_operator_name] = ACTIONS(4307),
  },
  [1276] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(1276),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1276),
    [sym_type_definition] = STATE(1276),
    [sym__declaration_specifiers] = STATE(598),
    [sym__declarator] = STATE(599),
    [sym_pointer_declarator] = STATE(599),
    [sym_function_declarator] = STATE(600),
    [sym_array_declarator] = STATE(599),
    [sym_storage_class_specifier] = STATE(605),
    [sym_type_qualifier] = STATE(605),
    [sym__type_specifier] = STATE(601),
    [sym_sized_type_specifier] = STATE(601),
    [sym_enum_specifier] = STATE(601),
    [sym_struct_specifier] = STATE(601),
    [sym_union_specifier] = STATE(601),
    [sym__field_declaration_list_item] = STATE(1276),
    [sym_field_declaration] = STATE(1276),
    [sym_macro_type_specifier] = STATE(601),
    [sym_class_specifier] = STATE(601),
    [sym_dependent_type] = STATE(601),
    [sym_template_declaration] = STATE(1276),
    [sym_inline_method_definition] = STATE(1276),
    [sym_constructor_or_destructor_definition] = STATE(1276),
    [sym_constructor_or_destructor_declaration] = STATE(1276),
    [sym_friend_declaration] = STATE(1276),
    [sym_access_specifier] = STATE(1276),
    [sym_reference_declarator] = STATE(599),
    [sym_template_type] = STATE(602),
    [sym_template_function] = STATE(599),
    [sym_using_declaration] = STATE(1276),
    [sym_alias_declaration] = STATE(1276),
    [sym_destructor_name] = STATE(599),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(603),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1276),
    [aux_sym__declaration_specifiers_repeat1] = STATE(605),
    [aux_sym_sized_type_specifier_repeat1] = STATE(606),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4311),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4314),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4314),
    [anon_sym_typedef] = ACTIONS(4317),
    [anon_sym_extern] = ACTIONS(4320),
    [anon_sym_RBRACE] = ACTIONS(4323),
    [anon_sym_LPAREN2] = ACTIONS(4325),
    [anon_sym_STAR] = ACTIONS(4328),
    [anon_sym_static] = ACTIONS(4320),
    [anon_sym_register] = ACTIONS(4320),
    [anon_sym_inline] = ACTIONS(4320),
    [anon_sym_const] = ACTIONS(4331),
    [anon_sym_restrict] = ACTIONS(4331),
    [anon_sym_volatile] = ACTIONS(4331),
    [anon_sym__Atomic] = ACTIONS(4331),
    [anon_sym_mutable] = ACTIONS(4331),
    [anon_sym_explicit] = ACTIONS(4331),
    [anon_sym_constexpr] = ACTIONS(4331),
    [anon_sym_unsigned] = ACTIONS(4334),
    [anon_sym_long] = ACTIONS(4334),
    [anon_sym_short] = ACTIONS(4334),
    [sym_primitive_type] = ACTIONS(4337),
    [anon_sym_enum] = ACTIONS(4340),
    [anon_sym_struct] = ACTIONS(4343),
    [anon_sym_union] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4349),
    [anon_sym_AMP_AMP] = ACTIONS(4352),
    [anon_sym_TILDE] = ACTIONS(4355),
    [sym_identifier] = ACTIONS(4358),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4361),
    [anon_sym_public] = ACTIONS(4364),
    [sym_auto] = ACTIONS(4337),
    [anon_sym_typename] = ACTIONS(4367),
    [anon_sym_template] = ACTIONS(4370),
    [anon_sym_friend] = ACTIONS(4373),
    [anon_sym_private] = ACTIONS(4364),
    [anon_sym_protected] = ACTIONS(4364),
    [anon_sym_using] = ACTIONS(4376),
    [anon_sym_COLON_COLON] = ACTIONS(4379),
    [sym_operator_name] = ACTIONS(4382),
  },
  [1277] = {
    [sym_compound_statement] = STATE(2032),
    [sym_field_initializer_list] = STATE(2035),
    [sym_default_method_clause] = STATE(2032),
    [sym_delete_method_clause] = STATE(2032),
    [anon_sym_LBRACE] = ACTIONS(2671),
    [anon_sym_LPAREN2] = ACTIONS(576),
    [anon_sym_LBRACK] = ACTIONS(576),
    [anon_sym_EQ] = ACTIONS(2673),
    [anon_sym_COLON] = ACTIONS(580),
    [sym_comment] = ACTIONS(91),
  },
  [1278] = {
    [sym_storage_class_specifier] = STATE(2036),
    [sym_type_qualifier] = STATE(2036),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2036),
    [anon_sym_SEMI] = ACTIONS(1689),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_LPAREN2] = ACTIONS(1689),
    [anon_sym_STAR] = ACTIONS(1689),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_COLON] = ACTIONS(1691),
    [anon_sym_AMP] = ACTIONS(1691),
    [anon_sym_AMP_AMP] = ACTIONS(1689),
    [sym_identifier] = ACTIONS(1691),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1689),
    [sym_operator_name] = ACTIONS(1689),
  },
  [1279] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1279),
    [anon_sym_SEMI] = ACTIONS(1985),
    [anon_sym_extern] = ACTIONS(1987),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1985),
    [anon_sym_static] = ACTIONS(1987),
    [anon_sym_register] = ACTIONS(1987),
    [anon_sym_inline] = ACTIONS(1987),
    [anon_sym_const] = ACTIONS(1987),
    [anon_sym_restrict] = ACTIONS(1987),
    [anon_sym_volatile] = ACTIONS(1987),
    [anon_sym__Atomic] = ACTIONS(1987),
    [anon_sym_mutable] = ACTIONS(1987),
    [anon_sym_explicit] = ACTIONS(1987),
    [anon_sym_constexpr] = ACTIONS(1987),
    [anon_sym_unsigned] = ACTIONS(4385),
    [anon_sym_long] = ACTIONS(4385),
    [anon_sym_short] = ACTIONS(4385),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_COLON] = ACTIONS(1987),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1985),
    [sym_operator_name] = ACTIONS(1985),
  },
  [1280] = {
    [sym_template_type] = STATE(2039),
    [sym_scoped_type_identifier] = STATE(2040),
    [sym_scoped_namespace_identifier] = STATE(83),
    [sym_identifier] = ACTIONS(4388),
    [sym_comment] = ACTIONS(91),
    [anon_sym_public] = ACTIONS(4390),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [1281] = {
    [aux_sym_base_class_clause_repeat1] = STATE(2041),
    [anon_sym_COMMA] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(4392),
    [sym_comment] = ACTIONS(91),
  },
  [1282] = {
    [sym_template_argument_list] = STATE(437),
    [aux_sym_base_class_clause_repeat1] = STATE(2042),
    [anon_sym_COMMA] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(4394),
    [anon_sym_LT] = ACTIONS(945),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(758),
  },
  [1283] = {
    [aux_sym_base_class_clause_repeat1] = STATE(2043),
    [anon_sym_COMMA] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(4396),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(772),
  },
  [1284] = {
    [sym_template_argument_list] = STATE(362),
    [aux_sym_base_class_clause_repeat1] = STATE(2043),
    [anon_sym_COMMA] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(4396),
    [anon_sym_LT] = ACTIONS(945),
    [sym_comment] = ACTIONS(91),
  },
  [1285] = {
    [aux_sym_base_class_clause_repeat1] = STATE(2041),
    [anon_sym_COMMA] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(4396),
    [sym_comment] = ACTIONS(91),
  },
  [1286] = {
    [anon_sym_COMMA] = ACTIONS(3218),
    [anon_sym_RPAREN] = ACTIONS(3218),
    [anon_sym_SEMI] = ACTIONS(3218),
    [anon_sym_extern] = ACTIONS(3216),
    [anon_sym_LBRACE] = ACTIONS(3218),
    [anon_sym_LPAREN2] = ACTIONS(3218),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_LBRACK] = ACTIONS(3218),
    [anon_sym_EQ] = ACTIONS(3218),
    [anon_sym_static] = ACTIONS(3216),
    [anon_sym_register] = ACTIONS(3216),
    [anon_sym_inline] = ACTIONS(3216),
    [anon_sym_const] = ACTIONS(3216),
    [anon_sym_restrict] = ACTIONS(3216),
    [anon_sym_volatile] = ACTIONS(3216),
    [anon_sym__Atomic] = ACTIONS(3216),
    [anon_sym_mutable] = ACTIONS(3216),
    [anon_sym_explicit] = ACTIONS(3216),
    [anon_sym_constexpr] = ACTIONS(3216),
    [anon_sym_COLON] = ACTIONS(3216),
    [anon_sym_AMP] = ACTIONS(3216),
    [anon_sym_AMP_AMP] = ACTIONS(3218),
    [anon_sym_TILDE] = ACTIONS(3218),
    [anon_sym_LT] = ACTIONS(3218),
    [sym_identifier] = ACTIONS(3216),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3216),
    [anon_sym_override] = ACTIONS(3216),
    [anon_sym_GT2] = ACTIONS(3218),
    [anon_sym_COLON_COLON] = ACTIONS(3225),
    [sym_operator_name] = ACTIONS(3218),
  },
  [1287] = {
    [anon_sym_COMMA] = ACTIONS(4398),
    [anon_sym_RPAREN] = ACTIONS(4398),
    [anon_sym_SEMI] = ACTIONS(4398),
    [anon_sym_extern] = ACTIONS(4400),
    [anon_sym_LBRACE] = ACTIONS(4398),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_STAR] = ACTIONS(4398),
    [anon_sym_LBRACK] = ACTIONS(4398),
    [anon_sym_EQ] = ACTIONS(4398),
    [anon_sym_static] = ACTIONS(4400),
    [anon_sym_register] = ACTIONS(4400),
    [anon_sym_inline] = ACTIONS(4400),
    [anon_sym_const] = ACTIONS(4400),
    [anon_sym_restrict] = ACTIONS(4400),
    [anon_sym_volatile] = ACTIONS(4400),
    [anon_sym__Atomic] = ACTIONS(4400),
    [anon_sym_mutable] = ACTIONS(4400),
    [anon_sym_explicit] = ACTIONS(4400),
    [anon_sym_constexpr] = ACTIONS(4400),
    [anon_sym_COLON] = ACTIONS(4400),
    [anon_sym_AMP] = ACTIONS(4400),
    [anon_sym_AMP_AMP] = ACTIONS(4398),
    [anon_sym_TILDE] = ACTIONS(4398),
    [anon_sym_DASH_GT] = ACTIONS(4398),
    [sym_identifier] = ACTIONS(4400),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4400),
    [anon_sym_override] = ACTIONS(4400),
    [anon_sym_GT2] = ACTIONS(4398),
    [sym_noexcept] = ACTIONS(4400),
    [anon_sym_COLON_COLON] = ACTIONS(4398),
    [sym_operator_name] = ACTIONS(4398),
  },
  [1288] = {
    [sym_field_declaration_list] = STATE(2044),
    [anon_sym_LBRACE] = ACTIONS(307),
    [sym_comment] = ACTIONS(91),
  },
  [1289] = {
    [anon_sym_COMMA] = ACTIONS(4402),
    [anon_sym_RPAREN] = ACTIONS(4402),
    [anon_sym_SEMI] = ACTIONS(4402),
    [anon_sym_extern] = ACTIONS(4404),
    [anon_sym_LBRACE] = ACTIONS(4402),
    [anon_sym_LPAREN2] = ACTIONS(4402),
    [anon_sym_STAR] = ACTIONS(4402),
    [anon_sym_LBRACK] = ACTIONS(4402),
    [anon_sym_EQ] = ACTIONS(4402),
    [anon_sym_static] = ACTIONS(4404),
    [anon_sym_register] = ACTIONS(4404),
    [anon_sym_inline] = ACTIONS(4404),
    [anon_sym_const] = ACTIONS(4404),
    [anon_sym_restrict] = ACTIONS(4404),
    [anon_sym_volatile] = ACTIONS(4404),
    [anon_sym__Atomic] = ACTIONS(4404),
    [anon_sym_mutable] = ACTIONS(4404),
    [anon_sym_explicit] = ACTIONS(4404),
    [anon_sym_constexpr] = ACTIONS(4404),
    [anon_sym_COLON] = ACTIONS(4404),
    [anon_sym_AMP] = ACTIONS(4404),
    [anon_sym_AMP_AMP] = ACTIONS(4402),
    [anon_sym_TILDE] = ACTIONS(4402),
    [anon_sym_DASH_GT] = ACTIONS(4402),
    [sym_identifier] = ACTIONS(4404),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4404),
    [anon_sym_override] = ACTIONS(4404),
    [anon_sym_GT2] = ACTIONS(4402),
    [sym_noexcept] = ACTIONS(4404),
    [anon_sym_COLON_COLON] = ACTIONS(4402),
    [sym_operator_name] = ACTIONS(4402),
  },
  [1290] = {
    [anon_sym_COMMA] = ACTIONS(3636),
    [anon_sym_RPAREN] = ACTIONS(3636),
    [anon_sym_SEMI] = ACTIONS(3636),
    [anon_sym_extern] = ACTIONS(3634),
    [anon_sym_LBRACE] = ACTIONS(3636),
    [anon_sym_LPAREN2] = ACTIONS(3636),
    [anon_sym_STAR] = ACTIONS(3636),
    [anon_sym_LBRACK] = ACTIONS(3636),
    [anon_sym_EQ] = ACTIONS(3636),
    [anon_sym_static] = ACTIONS(3634),
    [anon_sym_register] = ACTIONS(3634),
    [anon_sym_inline] = ACTIONS(3634),
    [anon_sym_const] = ACTIONS(3634),
    [anon_sym_restrict] = ACTIONS(3634),
    [anon_sym_volatile] = ACTIONS(3634),
    [anon_sym__Atomic] = ACTIONS(3634),
    [anon_sym_mutable] = ACTIONS(3634),
    [anon_sym_explicit] = ACTIONS(3634),
    [anon_sym_constexpr] = ACTIONS(3634),
    [anon_sym_COLON] = ACTIONS(3634),
    [anon_sym_AMP] = ACTIONS(3634),
    [anon_sym_AMP_AMP] = ACTIONS(3636),
    [anon_sym_TILDE] = ACTIONS(3636),
    [anon_sym_LT] = ACTIONS(3636),
    [sym_identifier] = ACTIONS(3634),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3634),
    [anon_sym_override] = ACTIONS(3634),
    [anon_sym_GT2] = ACTIONS(3636),
    [anon_sym_COLON_COLON] = ACTIONS(3643),
    [sym_operator_name] = ACTIONS(3636),
  },
  [1291] = {
    [sym_field_declaration_list] = STATE(2045),
    [anon_sym_LBRACE] = ACTIONS(307),
    [sym_comment] = ACTIONS(91),
  },
  [1292] = {
    [anon_sym_COMMA] = ACTIONS(4406),
    [anon_sym_RPAREN] = ACTIONS(4406),
    [anon_sym_SEMI] = ACTIONS(4406),
    [anon_sym_extern] = ACTIONS(4408),
    [anon_sym_LBRACE] = ACTIONS(4406),
    [anon_sym_LPAREN2] = ACTIONS(4406),
    [anon_sym_STAR] = ACTIONS(4406),
    [anon_sym_LBRACK] = ACTIONS(4406),
    [anon_sym_EQ] = ACTIONS(4406),
    [anon_sym_static] = ACTIONS(4408),
    [anon_sym_register] = ACTIONS(4408),
    [anon_sym_inline] = ACTIONS(4408),
    [anon_sym_const] = ACTIONS(4408),
    [anon_sym_restrict] = ACTIONS(4408),
    [anon_sym_volatile] = ACTIONS(4408),
    [anon_sym__Atomic] = ACTIONS(4408),
    [anon_sym_mutable] = ACTIONS(4408),
    [anon_sym_explicit] = ACTIONS(4408),
    [anon_sym_constexpr] = ACTIONS(4408),
    [anon_sym_COLON] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_TILDE] = ACTIONS(4406),
    [anon_sym_DASH_GT] = ACTIONS(4406),
    [sym_identifier] = ACTIONS(4408),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4408),
    [anon_sym_override] = ACTIONS(4408),
    [anon_sym_GT2] = ACTIONS(4406),
    [sym_noexcept] = ACTIONS(4408),
    [anon_sym_COLON_COLON] = ACTIONS(4406),
    [sym_operator_name] = ACTIONS(4406),
  },
  [1293] = {
    [sym_field_declaration_list] = STATE(2046),
    [anon_sym_LBRACE] = ACTIONS(307),
    [sym_comment] = ACTIONS(91),
  },
  [1294] = {
    [anon_sym_COMMA] = ACTIONS(4410),
    [anon_sym_RPAREN] = ACTIONS(4410),
    [anon_sym_SEMI] = ACTIONS(4410),
    [anon_sym_extern] = ACTIONS(4412),
    [anon_sym_LBRACE] = ACTIONS(4410),
    [anon_sym_LPAREN2] = ACTIONS(4410),
    [anon_sym_STAR] = ACTIONS(4410),
    [anon_sym_LBRACK] = ACTIONS(4410),
    [anon_sym_EQ] = ACTIONS(4410),
    [anon_sym_static] = ACTIONS(4412),
    [anon_sym_register] = ACTIONS(4412),
    [anon_sym_inline] = ACTIONS(4412),
    [anon_sym_const] = ACTIONS(4412),
    [anon_sym_restrict] = ACTIONS(4412),
    [anon_sym_volatile] = ACTIONS(4412),
    [anon_sym__Atomic] = ACTIONS(4412),
    [anon_sym_mutable] = ACTIONS(4412),
    [anon_sym_explicit] = ACTIONS(4412),
    [anon_sym_constexpr] = ACTIONS(4412),
    [anon_sym_COLON] = ACTIONS(4412),
    [anon_sym_AMP] = ACTIONS(4412),
    [anon_sym_AMP_AMP] = ACTIONS(4410),
    [anon_sym_TILDE] = ACTIONS(4410),
    [anon_sym_DASH_GT] = ACTIONS(4410),
    [sym_identifier] = ACTIONS(4412),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4412),
    [anon_sym_override] = ACTIONS(4412),
    [anon_sym_GT2] = ACTIONS(4410),
    [sym_noexcept] = ACTIONS(4412),
    [anon_sym_COLON_COLON] = ACTIONS(4410),
    [sym_operator_name] = ACTIONS(4410),
  },
  [1295] = {
    [sym_field_declaration_list] = STATE(2047),
    [anon_sym_LBRACE] = ACTIONS(307),
    [sym_comment] = ACTIONS(91),
  },
  [1296] = {
    [anon_sym_RPAREN] = ACTIONS(4414),
    [sym_comment] = ACTIONS(91),
  },
  [1297] = {
    [sym_type_qualifier] = STATE(141),
    [sym__type_specifier] = STATE(136),
    [sym_sized_type_specifier] = STATE(136),
    [sym_enum_specifier] = STATE(136),
    [sym_struct_specifier] = STATE(136),
    [sym_union_specifier] = STATE(136),
    [sym__expression] = STATE(137),
    [sym_comma_expression] = STATE(138),
    [sym_conditional_expression] = STATE(137),
    [sym_assignment_expression] = STATE(137),
    [sym_pointer_expression] = STATE(137),
    [sym_logical_expression] = STATE(137),
    [sym_bitwise_expression] = STATE(137),
    [sym_equality_expression] = STATE(137),
    [sym_relational_expression] = STATE(137),
    [sym_shift_expression] = STATE(137),
    [sym_math_expression] = STATE(137),
    [sym_cast_expression] = STATE(137),
    [sym_type_descriptor] = STATE(2049),
    [sym_sizeof_expression] = STATE(137),
    [sym_subscript_expression] = STATE(137),
    [sym_call_expression] = STATE(137),
    [sym_field_expression] = STATE(137),
    [sym_compound_literal_expression] = STATE(137),
    [sym_parenthesized_expression] = STATE(137),
    [sym_char_literal] = STATE(137),
    [sym_concatenated_string] = STATE(137),
    [sym_string_literal] = STATE(140),
    [sym_macro_type_specifier] = STATE(136),
    [sym_class_specifier] = STATE(136),
    [sym_dependent_type] = STATE(136),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(137),
    [sym_new_expression] = STATE(137),
    [sym_delete_expression] = STATE(137),
    [sym_lambda_expression] = STATE(137),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_type_definition_repeat1] = STATE(141),
    [aux_sym_sized_type_specifier_repeat1] = STATE(142),
    [sym_raw_string_literal] = ACTIONS(213),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(219),
    [anon_sym_long] = ACTIONS(219),
    [anon_sym_short] = ACTIONS(219),
    [sym_primitive_type] = ACTIONS(221),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [sym_null] = ACTIONS(241),
    [sym_identifier] = ACTIONS(811),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(221),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(253),
    [sym_nullptr] = ACTIONS(241),
  },
  [1298] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(1364),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1366),
    [anon_sym_QMARK] = ACTIONS(1364),
    [anon_sym_STAR_EQ] = ACTIONS(1364),
    [anon_sym_SLASH_EQ] = ACTIONS(1364),
    [anon_sym_PERCENT_EQ] = ACTIONS(1364),
    [anon_sym_PLUS_EQ] = ACTIONS(1364),
    [anon_sym_DASH_EQ] = ACTIONS(1364),
    [anon_sym_LT_LT_EQ] = ACTIONS(1364),
    [anon_sym_GT_GT_EQ] = ACTIONS(1364),
    [anon_sym_AMP_EQ] = ACTIONS(1364),
    [anon_sym_CARET_EQ] = ACTIONS(1364),
    [anon_sym_PIPE_EQ] = ACTIONS(1364),
    [anon_sym_AMP] = ACTIONS(1366),
    [anon_sym_PIPE_PIPE] = ACTIONS(1364),
    [anon_sym_AMP_AMP] = ACTIONS(1364),
    [anon_sym_PIPE] = ACTIONS(1366),
    [anon_sym_CARET] = ACTIONS(1366),
    [anon_sym_EQ_EQ] = ACTIONS(1364),
    [anon_sym_BANG_EQ] = ACTIONS(1364),
    [anon_sym_LT] = ACTIONS(1366),
    [anon_sym_GT] = ACTIONS(1366),
    [anon_sym_LT_EQ] = ACTIONS(1364),
    [anon_sym_GT_EQ] = ACTIONS(1364),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1299] = {
    [sym__expression] = STATE(164),
    [sym_conditional_expression] = STATE(164),
    [sym_assignment_expression] = STATE(164),
    [sym_pointer_expression] = STATE(164),
    [sym_logical_expression] = STATE(164),
    [sym_bitwise_expression] = STATE(164),
    [sym_equality_expression] = STATE(164),
    [sym_relational_expression] = STATE(164),
    [sym_shift_expression] = STATE(164),
    [sym_math_expression] = STATE(164),
    [sym_cast_expression] = STATE(164),
    [sym_sizeof_expression] = STATE(164),
    [sym_subscript_expression] = STATE(164),
    [sym_call_expression] = STATE(164),
    [sym_field_expression] = STATE(164),
    [sym_compound_literal_expression] = STATE(164),
    [sym_parenthesized_expression] = STATE(164),
    [sym_char_literal] = STATE(164),
    [sym_concatenated_string] = STATE(164),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(164),
    [sym_new_expression] = STATE(164),
    [sym_delete_expression] = STATE(164),
    [sym_lambda_expression] = STATE(164),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_lambda_default_capture] = STATE(166),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(267),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(4416),
    [anon_sym_EQ] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(267),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(289),
    [sym_false] = ACTIONS(289),
    [sym_null] = ACTIONS(289),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(289),
  },
  [1300] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(1489),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1491),
    [anon_sym_QMARK] = ACTIONS(1489),
    [anon_sym_STAR_EQ] = ACTIONS(1489),
    [anon_sym_SLASH_EQ] = ACTIONS(1489),
    [anon_sym_PERCENT_EQ] = ACTIONS(1489),
    [anon_sym_PLUS_EQ] = ACTIONS(1489),
    [anon_sym_DASH_EQ] = ACTIONS(1489),
    [anon_sym_LT_LT_EQ] = ACTIONS(1489),
    [anon_sym_GT_GT_EQ] = ACTIONS(1489),
    [anon_sym_AMP_EQ] = ACTIONS(1489),
    [anon_sym_CARET_EQ] = ACTIONS(1489),
    [anon_sym_PIPE_EQ] = ACTIONS(1489),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1301] = {
    [sym__type_specifier] = STATE(871),
    [sym_sized_type_specifier] = STATE(871),
    [sym_enum_specifier] = STATE(871),
    [sym_struct_specifier] = STATE(871),
    [sym_union_specifier] = STATE(871),
    [sym_macro_type_specifier] = STATE(871),
    [sym_class_specifier] = STATE(871),
    [sym_dependent_type] = STATE(871),
    [sym_template_type] = STATE(309),
    [sym_scoped_type_identifier] = STATE(310),
    [sym_scoped_namespace_identifier] = STATE(311),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1304),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [sym_primitive_type] = ACTIONS(1552),
    [anon_sym_enum] = ACTIONS(536),
    [anon_sym_struct] = ACTIONS(538),
    [anon_sym_union] = ACTIONS(540),
    [sym_identifier] = ACTIONS(542),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(544),
    [sym_auto] = ACTIONS(1552),
    [anon_sym_typename] = ACTIONS(2727),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [1302] = {
    [sym_argument_list] = STATE(874),
    [sym_initializer_list] = STATE(874),
    [sym_new_declarator] = STATE(875),
    [anon_sym_RPAREN] = ACTIONS(1556),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1558),
    [anon_sym_LBRACK] = ACTIONS(4418),
    [anon_sym_EQ] = ACTIONS(1558),
    [anon_sym_QMARK] = ACTIONS(1556),
    [anon_sym_STAR_EQ] = ACTIONS(1556),
    [anon_sym_SLASH_EQ] = ACTIONS(1556),
    [anon_sym_PERCENT_EQ] = ACTIONS(1556),
    [anon_sym_PLUS_EQ] = ACTIONS(1556),
    [anon_sym_DASH_EQ] = ACTIONS(1556),
    [anon_sym_LT_LT_EQ] = ACTIONS(1556),
    [anon_sym_GT_GT_EQ] = ACTIONS(1556),
    [anon_sym_AMP_EQ] = ACTIONS(1556),
    [anon_sym_CARET_EQ] = ACTIONS(1556),
    [anon_sym_PIPE_EQ] = ACTIONS(1556),
    [anon_sym_AMP] = ACTIONS(1558),
    [anon_sym_PIPE_PIPE] = ACTIONS(1556),
    [anon_sym_AMP_AMP] = ACTIONS(1556),
    [anon_sym_PIPE] = ACTIONS(1558),
    [anon_sym_CARET] = ACTIONS(1558),
    [anon_sym_EQ_EQ] = ACTIONS(1556),
    [anon_sym_BANG_EQ] = ACTIONS(1556),
    [anon_sym_LT] = ACTIONS(1558),
    [anon_sym_GT] = ACTIONS(1558),
    [anon_sym_LT_EQ] = ACTIONS(1556),
    [anon_sym_GT_EQ] = ACTIONS(1556),
    [anon_sym_LT_LT] = ACTIONS(1558),
    [anon_sym_GT_GT] = ACTIONS(1558),
    [anon_sym_PLUS] = ACTIONS(1558),
    [anon_sym_DASH] = ACTIONS(1558),
    [anon_sym_SLASH] = ACTIONS(1558),
    [anon_sym_PERCENT] = ACTIONS(1558),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DOT] = ACTIONS(1556),
    [anon_sym_DASH_GT] = ACTIONS(1556),
    [sym_comment] = ACTIONS(91),
  },
  [1303] = {
    [sym__type_specifier] = STATE(2052),
    [sym_sized_type_specifier] = STATE(2052),
    [sym_enum_specifier] = STATE(2052),
    [sym_struct_specifier] = STATE(2052),
    [sym_union_specifier] = STATE(2052),
    [sym_macro_type_specifier] = STATE(2052),
    [sym_class_specifier] = STATE(2052),
    [sym_dependent_type] = STATE(2052),
    [sym_template_type] = STATE(309),
    [sym_scoped_type_identifier] = STATE(310),
    [sym_scoped_namespace_identifier] = STATE(311),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1304),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [sym_primitive_type] = ACTIONS(4420),
    [anon_sym_enum] = ACTIONS(536),
    [anon_sym_struct] = ACTIONS(538),
    [anon_sym_union] = ACTIONS(540),
    [sym_identifier] = ACTIONS(542),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(544),
    [sym_auto] = ACTIONS(4420),
    [anon_sym_typename] = ACTIONS(2727),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [1304] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2053),
    [anon_sym_RPAREN] = ACTIONS(653),
    [anon_sym_LBRACE] = ACTIONS(653),
    [anon_sym_LPAREN2] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_EQ] = ACTIONS(655),
    [anon_sym_unsigned] = ACTIONS(4422),
    [anon_sym_long] = ACTIONS(4422),
    [anon_sym_short] = ACTIONS(4422),
    [sym_primitive_type] = ACTIONS(1571),
    [anon_sym_QMARK] = ACTIONS(653),
    [anon_sym_STAR_EQ] = ACTIONS(653),
    [anon_sym_SLASH_EQ] = ACTIONS(653),
    [anon_sym_PERCENT_EQ] = ACTIONS(653),
    [anon_sym_PLUS_EQ] = ACTIONS(653),
    [anon_sym_DASH_EQ] = ACTIONS(653),
    [anon_sym_LT_LT_EQ] = ACTIONS(653),
    [anon_sym_GT_GT_EQ] = ACTIONS(653),
    [anon_sym_AMP_EQ] = ACTIONS(653),
    [anon_sym_CARET_EQ] = ACTIONS(653),
    [anon_sym_PIPE_EQ] = ACTIONS(653),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_PIPE_PIPE] = ACTIONS(653),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(655),
    [anon_sym_EQ_EQ] = ACTIONS(653),
    [anon_sym_BANG_EQ] = ACTIONS(653),
    [anon_sym_LT] = ACTIONS(655),
    [anon_sym_GT] = ACTIONS(655),
    [anon_sym_LT_EQ] = ACTIONS(653),
    [anon_sym_GT_EQ] = ACTIONS(653),
    [anon_sym_LT_LT] = ACTIONS(655),
    [anon_sym_GT_GT] = ACTIONS(655),
    [anon_sym_PLUS] = ACTIONS(655),
    [anon_sym_DASH] = ACTIONS(655),
    [anon_sym_SLASH] = ACTIONS(655),
    [anon_sym_PERCENT] = ACTIONS(655),
    [anon_sym_DASH_DASH] = ACTIONS(653),
    [anon_sym_PLUS_PLUS] = ACTIONS(653),
    [anon_sym_DOT] = ACTIONS(653),
    [anon_sym_DASH_GT] = ACTIONS(653),
    [sym_identifier] = ACTIONS(1573),
    [sym_comment] = ACTIONS(91),
  },
  [1305] = {
    [sym__expression] = STATE(2055),
    [sym_conditional_expression] = STATE(2055),
    [sym_assignment_expression] = STATE(2055),
    [sym_pointer_expression] = STATE(2055),
    [sym_logical_expression] = STATE(2055),
    [sym_bitwise_expression] = STATE(2055),
    [sym_equality_expression] = STATE(2055),
    [sym_relational_expression] = STATE(2055),
    [sym_shift_expression] = STATE(2055),
    [sym_math_expression] = STATE(2055),
    [sym_cast_expression] = STATE(2055),
    [sym_sizeof_expression] = STATE(2055),
    [sym_subscript_expression] = STATE(2055),
    [sym_call_expression] = STATE(2055),
    [sym_field_expression] = STATE(2055),
    [sym_compound_literal_expression] = STATE(2055),
    [sym_parenthesized_expression] = STATE(2055),
    [sym_char_literal] = STATE(2055),
    [sym_concatenated_string] = STATE(2055),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2055),
    [sym_new_expression] = STATE(2055),
    [sym_delete_expression] = STATE(2055),
    [sym_lambda_expression] = STATE(2055),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4424),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(4426),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(4424),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4428),
    [sym_false] = ACTIONS(4428),
    [sym_null] = ACTIONS(4428),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(4428),
  },
  [1306] = {
    [sym_compound_statement] = STATE(2064),
    [sym_labeled_statement] = STATE(2064),
    [sym_expression_statement] = STATE(2064),
    [sym_if_statement] = STATE(2064),
    [sym_switch_statement] = STATE(2064),
    [sym_case_statement] = STATE(2064),
    [sym_while_statement] = STATE(2064),
    [sym_do_statement] = STATE(2064),
    [sym_for_statement] = STATE(2064),
    [sym_return_statement] = STATE(2064),
    [sym_break_statement] = STATE(2064),
    [sym_continue_statement] = STATE(2064),
    [sym_goto_statement] = STATE(2064),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(2064),
    [sym_try_statement] = STATE(2064),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(4430),
    [anon_sym_switch] = ACTIONS(4432),
    [anon_sym_case] = ACTIONS(4434),
    [anon_sym_default] = ACTIONS(4436),
    [anon_sym_while] = ACTIONS(4438),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(4440),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(4442),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(4444),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [1307] = {
    [sym__expression] = STATE(938),
    [sym_conditional_expression] = STATE(938),
    [sym_assignment_expression] = STATE(938),
    [sym_pointer_expression] = STATE(938),
    [sym_logical_expression] = STATE(938),
    [sym_bitwise_expression] = STATE(938),
    [sym_equality_expression] = STATE(938),
    [sym_relational_expression] = STATE(938),
    [sym_shift_expression] = STATE(938),
    [sym_math_expression] = STATE(938),
    [sym_cast_expression] = STATE(938),
    [sym_sizeof_expression] = STATE(938),
    [sym_subscript_expression] = STATE(938),
    [sym_call_expression] = STATE(938),
    [sym_field_expression] = STATE(938),
    [sym_compound_literal_expression] = STATE(938),
    [sym_parenthesized_expression] = STATE(938),
    [sym_char_literal] = STATE(938),
    [sym_concatenated_string] = STATE(938),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(938),
    [sym_new_expression] = STATE(938),
    [sym_delete_expression] = STATE(938),
    [sym_lambda_expression] = STATE(938),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(1701),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(1701),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(1703),
    [sym_false] = ACTIONS(1703),
    [sym_null] = ACTIONS(1703),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(1703),
  },
  [1308] = {
    [sym__expression] = STATE(2065),
    [sym_conditional_expression] = STATE(2065),
    [sym_assignment_expression] = STATE(2065),
    [sym_pointer_expression] = STATE(2065),
    [sym_logical_expression] = STATE(2065),
    [sym_bitwise_expression] = STATE(2065),
    [sym_equality_expression] = STATE(2065),
    [sym_relational_expression] = STATE(2065),
    [sym_shift_expression] = STATE(2065),
    [sym_math_expression] = STATE(2065),
    [sym_cast_expression] = STATE(2065),
    [sym_sizeof_expression] = STATE(2065),
    [sym_subscript_expression] = STATE(2065),
    [sym_call_expression] = STATE(2065),
    [sym_field_expression] = STATE(2065),
    [sym_compound_literal_expression] = STATE(2065),
    [sym_parenthesized_expression] = STATE(2065),
    [sym_char_literal] = STATE(2065),
    [sym_concatenated_string] = STATE(2065),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2065),
    [sym_new_expression] = STATE(2065),
    [sym_delete_expression] = STATE(2065),
    [sym_lambda_expression] = STATE(2065),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4446),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(4446),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4448),
    [sym_false] = ACTIONS(4448),
    [sym_null] = ACTIONS(4448),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(4448),
  },
  [1309] = {
    [sym__expression] = STATE(2066),
    [sym_conditional_expression] = STATE(2066),
    [sym_assignment_expression] = STATE(2066),
    [sym_pointer_expression] = STATE(2066),
    [sym_logical_expression] = STATE(2066),
    [sym_bitwise_expression] = STATE(2066),
    [sym_equality_expression] = STATE(2066),
    [sym_relational_expression] = STATE(2066),
    [sym_shift_expression] = STATE(2066),
    [sym_math_expression] = STATE(2066),
    [sym_cast_expression] = STATE(2066),
    [sym_sizeof_expression] = STATE(2066),
    [sym_subscript_expression] = STATE(2066),
    [sym_call_expression] = STATE(2066),
    [sym_field_expression] = STATE(2066),
    [sym_compound_literal_expression] = STATE(2066),
    [sym_parenthesized_expression] = STATE(2066),
    [sym_char_literal] = STATE(2066),
    [sym_concatenated_string] = STATE(2066),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2066),
    [sym_new_expression] = STATE(2066),
    [sym_delete_expression] = STATE(2066),
    [sym_lambda_expression] = STATE(2066),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4450),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(4450),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(4452),
    [sym_false] = ACTIONS(4452),
    [sym_null] = ACTIONS(4452),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(4452),
  },
  [1310] = {
    [sym__expression] = STATE(2067),
    [sym_conditional_expression] = STATE(2067),
    [sym_assignment_expression] = STATE(2067),
    [sym_pointer_expression] = STATE(2067),
    [sym_logical_expression] = STATE(2067),
    [sym_bitwise_expression] = STATE(2067),
    [sym_equality_expression] = STATE(2067),
    [sym_relational_expression] = STATE(2067),
    [sym_shift_expression] = STATE(2067),
    [sym_math_expression] = STATE(2067),
    [sym_cast_expression] = STATE(2067),
    [sym_sizeof_expression] = STATE(2067),
    [sym_subscript_expression] = STATE(2067),
    [sym_call_expression] = STATE(2067),
    [sym_field_expression] = STATE(2067),
    [sym_compound_literal_expression] = STATE(2067),
    [sym_parenthesized_expression] = STATE(2067),
    [sym_char_literal] = STATE(2067),
    [sym_concatenated_string] = STATE(2067),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2067),
    [sym_new_expression] = STATE(2067),
    [sym_delete_expression] = STATE(2067),
    [sym_lambda_expression] = STATE(2067),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4454),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(4454),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4456),
    [sym_false] = ACTIONS(4456),
    [sym_null] = ACTIONS(4456),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(4456),
  },
  [1311] = {
    [sym__expression] = STATE(2068),
    [sym_conditional_expression] = STATE(2068),
    [sym_assignment_expression] = STATE(2068),
    [sym_pointer_expression] = STATE(2068),
    [sym_logical_expression] = STATE(2068),
    [sym_bitwise_expression] = STATE(2068),
    [sym_equality_expression] = STATE(2068),
    [sym_relational_expression] = STATE(2068),
    [sym_shift_expression] = STATE(2068),
    [sym_math_expression] = STATE(2068),
    [sym_cast_expression] = STATE(2068),
    [sym_sizeof_expression] = STATE(2068),
    [sym_subscript_expression] = STATE(2068),
    [sym_call_expression] = STATE(2068),
    [sym_field_expression] = STATE(2068),
    [sym_compound_literal_expression] = STATE(2068),
    [sym_parenthesized_expression] = STATE(2068),
    [sym_char_literal] = STATE(2068),
    [sym_concatenated_string] = STATE(2068),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2068),
    [sym_new_expression] = STATE(2068),
    [sym_delete_expression] = STATE(2068),
    [sym_lambda_expression] = STATE(2068),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4458),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(4458),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4460),
    [sym_false] = ACTIONS(4460),
    [sym_null] = ACTIONS(4460),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(4460),
  },
  [1312] = {
    [sym__expression] = STATE(2069),
    [sym_conditional_expression] = STATE(2069),
    [sym_assignment_expression] = STATE(2069),
    [sym_pointer_expression] = STATE(2069),
    [sym_logical_expression] = STATE(2069),
    [sym_bitwise_expression] = STATE(2069),
    [sym_equality_expression] = STATE(2069),
    [sym_relational_expression] = STATE(2069),
    [sym_shift_expression] = STATE(2069),
    [sym_math_expression] = STATE(2069),
    [sym_cast_expression] = STATE(2069),
    [sym_sizeof_expression] = STATE(2069),
    [sym_subscript_expression] = STATE(2069),
    [sym_call_expression] = STATE(2069),
    [sym_field_expression] = STATE(2069),
    [sym_compound_literal_expression] = STATE(2069),
    [sym_parenthesized_expression] = STATE(2069),
    [sym_char_literal] = STATE(2069),
    [sym_concatenated_string] = STATE(2069),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2069),
    [sym_new_expression] = STATE(2069),
    [sym_delete_expression] = STATE(2069),
    [sym_lambda_expression] = STATE(2069),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4462),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(4462),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4464),
    [sym_false] = ACTIONS(4464),
    [sym_null] = ACTIONS(4464),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(4464),
  },
  [1313] = {
    [sym__expression] = STATE(2070),
    [sym_conditional_expression] = STATE(2070),
    [sym_assignment_expression] = STATE(2070),
    [sym_pointer_expression] = STATE(2070),
    [sym_logical_expression] = STATE(2070),
    [sym_bitwise_expression] = STATE(2070),
    [sym_equality_expression] = STATE(2070),
    [sym_relational_expression] = STATE(2070),
    [sym_shift_expression] = STATE(2070),
    [sym_math_expression] = STATE(2070),
    [sym_cast_expression] = STATE(2070),
    [sym_sizeof_expression] = STATE(2070),
    [sym_subscript_expression] = STATE(2070),
    [sym_call_expression] = STATE(2070),
    [sym_field_expression] = STATE(2070),
    [sym_compound_literal_expression] = STATE(2070),
    [sym_parenthesized_expression] = STATE(2070),
    [sym_char_literal] = STATE(2070),
    [sym_concatenated_string] = STATE(2070),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2070),
    [sym_new_expression] = STATE(2070),
    [sym_delete_expression] = STATE(2070),
    [sym_lambda_expression] = STATE(2070),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4466),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(4466),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4468),
    [sym_false] = ACTIONS(4468),
    [sym_null] = ACTIONS(4468),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(4468),
  },
  [1314] = {
    [sym__expression] = STATE(2071),
    [sym_conditional_expression] = STATE(2071),
    [sym_assignment_expression] = STATE(2071),
    [sym_pointer_expression] = STATE(2071),
    [sym_logical_expression] = STATE(2071),
    [sym_bitwise_expression] = STATE(2071),
    [sym_equality_expression] = STATE(2071),
    [sym_relational_expression] = STATE(2071),
    [sym_shift_expression] = STATE(2071),
    [sym_math_expression] = STATE(2071),
    [sym_cast_expression] = STATE(2071),
    [sym_sizeof_expression] = STATE(2071),
    [sym_subscript_expression] = STATE(2071),
    [sym_call_expression] = STATE(2071),
    [sym_field_expression] = STATE(2071),
    [sym_compound_literal_expression] = STATE(2071),
    [sym_parenthesized_expression] = STATE(2071),
    [sym_char_literal] = STATE(2071),
    [sym_concatenated_string] = STATE(2071),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2071),
    [sym_new_expression] = STATE(2071),
    [sym_delete_expression] = STATE(2071),
    [sym_lambda_expression] = STATE(2071),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4470),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(4470),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4472),
    [sym_false] = ACTIONS(4472),
    [sym_null] = ACTIONS(4472),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(4472),
  },
  [1315] = {
    [sym__expression] = STATE(2072),
    [sym_conditional_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2072),
    [sym_pointer_expression] = STATE(2072),
    [sym_logical_expression] = STATE(2072),
    [sym_bitwise_expression] = STATE(2072),
    [sym_equality_expression] = STATE(2072),
    [sym_relational_expression] = STATE(2072),
    [sym_shift_expression] = STATE(2072),
    [sym_math_expression] = STATE(2072),
    [sym_cast_expression] = STATE(2072),
    [sym_sizeof_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_call_expression] = STATE(2072),
    [sym_field_expression] = STATE(2072),
    [sym_compound_literal_expression] = STATE(2072),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_char_literal] = STATE(2072),
    [sym_concatenated_string] = STATE(2072),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2072),
    [sym_new_expression] = STATE(2072),
    [sym_delete_expression] = STATE(2072),
    [sym_lambda_expression] = STATE(2072),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4474),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(4474),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4476),
    [sym_false] = ACTIONS(4476),
    [sym_null] = ACTIONS(4476),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(4476),
  },
  [1316] = {
    [sym__expression] = STATE(2073),
    [sym_conditional_expression] = STATE(2073),
    [sym_assignment_expression] = STATE(2073),
    [sym_pointer_expression] = STATE(2073),
    [sym_logical_expression] = STATE(2073),
    [sym_bitwise_expression] = STATE(2073),
    [sym_equality_expression] = STATE(2073),
    [sym_relational_expression] = STATE(2073),
    [sym_shift_expression] = STATE(2073),
    [sym_math_expression] = STATE(2073),
    [sym_cast_expression] = STATE(2073),
    [sym_sizeof_expression] = STATE(2073),
    [sym_subscript_expression] = STATE(2073),
    [sym_call_expression] = STATE(2073),
    [sym_field_expression] = STATE(2073),
    [sym_compound_literal_expression] = STATE(2073),
    [sym_parenthesized_expression] = STATE(2073),
    [sym_char_literal] = STATE(2073),
    [sym_concatenated_string] = STATE(2073),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2073),
    [sym_new_expression] = STATE(2073),
    [sym_delete_expression] = STATE(2073),
    [sym_lambda_expression] = STATE(2073),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4478),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(4478),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4480),
    [sym_false] = ACTIONS(4480),
    [sym_null] = ACTIONS(4480),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(4480),
  },
  [1317] = {
    [sym__expression] = STATE(2074),
    [sym_conditional_expression] = STATE(2074),
    [sym_assignment_expression] = STATE(2074),
    [sym_pointer_expression] = STATE(2074),
    [sym_logical_expression] = STATE(2074),
    [sym_bitwise_expression] = STATE(2074),
    [sym_equality_expression] = STATE(2074),
    [sym_relational_expression] = STATE(2074),
    [sym_shift_expression] = STATE(2074),
    [sym_math_expression] = STATE(2074),
    [sym_cast_expression] = STATE(2074),
    [sym_sizeof_expression] = STATE(2074),
    [sym_subscript_expression] = STATE(2074),
    [sym_call_expression] = STATE(2074),
    [sym_field_expression] = STATE(2074),
    [sym_compound_literal_expression] = STATE(2074),
    [sym_parenthesized_expression] = STATE(2074),
    [sym_char_literal] = STATE(2074),
    [sym_concatenated_string] = STATE(2074),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2074),
    [sym_new_expression] = STATE(2074),
    [sym_delete_expression] = STATE(2074),
    [sym_lambda_expression] = STATE(2074),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4482),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(4482),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4484),
    [sym_false] = ACTIONS(4484),
    [sym_null] = ACTIONS(4484),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(4484),
  },
  [1318] = {
    [sym__expression] = STATE(2075),
    [sym_conditional_expression] = STATE(2075),
    [sym_assignment_expression] = STATE(2075),
    [sym_pointer_expression] = STATE(2075),
    [sym_logical_expression] = STATE(2075),
    [sym_bitwise_expression] = STATE(2075),
    [sym_equality_expression] = STATE(2075),
    [sym_relational_expression] = STATE(2075),
    [sym_shift_expression] = STATE(2075),
    [sym_math_expression] = STATE(2075),
    [sym_cast_expression] = STATE(2075),
    [sym_sizeof_expression] = STATE(2075),
    [sym_subscript_expression] = STATE(2075),
    [sym_call_expression] = STATE(2075),
    [sym_field_expression] = STATE(2075),
    [sym_compound_literal_expression] = STATE(2075),
    [sym_parenthesized_expression] = STATE(2075),
    [sym_char_literal] = STATE(2075),
    [sym_concatenated_string] = STATE(2075),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2075),
    [sym_new_expression] = STATE(2075),
    [sym_delete_expression] = STATE(2075),
    [sym_lambda_expression] = STATE(2075),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4486),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(4486),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4488),
    [sym_false] = ACTIONS(4488),
    [sym_null] = ACTIONS(4488),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(4488),
  },
  [1319] = {
    [sym_string_literal] = STATE(2076),
    [aux_sym_concatenated_string_repeat1] = STATE(2076),
    [anon_sym_RPAREN] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_EQ] = ACTIONS(1763),
    [anon_sym_QMARK] = ACTIONS(1761),
    [anon_sym_STAR_EQ] = ACTIONS(1761),
    [anon_sym_SLASH_EQ] = ACTIONS(1761),
    [anon_sym_PERCENT_EQ] = ACTIONS(1761),
    [anon_sym_PLUS_EQ] = ACTIONS(1761),
    [anon_sym_DASH_EQ] = ACTIONS(1761),
    [anon_sym_LT_LT_EQ] = ACTIONS(1761),
    [anon_sym_GT_GT_EQ] = ACTIONS(1761),
    [anon_sym_AMP_EQ] = ACTIONS(1761),
    [anon_sym_CARET_EQ] = ACTIONS(1761),
    [anon_sym_PIPE_EQ] = ACTIONS(1761),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_PIPE_PIPE] = ACTIONS(1761),
    [anon_sym_AMP_AMP] = ACTIONS(1761),
    [anon_sym_PIPE] = ACTIONS(1763),
    [anon_sym_CARET] = ACTIONS(1763),
    [anon_sym_EQ_EQ] = ACTIONS(1761),
    [anon_sym_BANG_EQ] = ACTIONS(1761),
    [anon_sym_LT] = ACTIONS(1763),
    [anon_sym_GT] = ACTIONS(1763),
    [anon_sym_LT_EQ] = ACTIONS(1761),
    [anon_sym_GT_EQ] = ACTIONS(1761),
    [anon_sym_LT_LT] = ACTIONS(1763),
    [anon_sym_GT_GT] = ACTIONS(1763),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_SLASH] = ACTIONS(1763),
    [anon_sym_PERCENT] = ACTIONS(1763),
    [anon_sym_DASH_DASH] = ACTIONS(1761),
    [anon_sym_PLUS_PLUS] = ACTIONS(1761),
    [anon_sym_DOT] = ACTIONS(1761),
    [anon_sym_DASH_GT] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(91),
  },
  [1320] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(4490),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1321] = {
    [sym_raw_string_literal] = ACTIONS(2475),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2477),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2477),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2477),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2477),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2477),
    [sym_preproc_directive] = ACTIONS(2477),
    [anon_sym_SEMI] = ACTIONS(2475),
    [anon_sym_typedef] = ACTIONS(2477),
    [anon_sym_extern] = ACTIONS(2477),
    [anon_sym_LBRACE] = ACTIONS(2475),
    [anon_sym_RBRACE] = ACTIONS(2475),
    [anon_sym_LPAREN2] = ACTIONS(2475),
    [anon_sym_STAR] = ACTIONS(2475),
    [anon_sym_LBRACK] = ACTIONS(2475),
    [anon_sym_static] = ACTIONS(2477),
    [anon_sym_register] = ACTIONS(2477),
    [anon_sym_inline] = ACTIONS(2477),
    [anon_sym_const] = ACTIONS(2477),
    [anon_sym_restrict] = ACTIONS(2477),
    [anon_sym_volatile] = ACTIONS(2477),
    [anon_sym__Atomic] = ACTIONS(2477),
    [anon_sym_mutable] = ACTIONS(2477),
    [anon_sym_explicit] = ACTIONS(2477),
    [anon_sym_constexpr] = ACTIONS(2477),
    [anon_sym_unsigned] = ACTIONS(2477),
    [anon_sym_long] = ACTIONS(2477),
    [anon_sym_short] = ACTIONS(2477),
    [sym_primitive_type] = ACTIONS(2477),
    [anon_sym_enum] = ACTIONS(2477),
    [anon_sym_struct] = ACTIONS(2477),
    [anon_sym_union] = ACTIONS(2477),
    [anon_sym_if] = ACTIONS(2477),
    [anon_sym_else] = ACTIONS(2477),
    [anon_sym_switch] = ACTIONS(2477),
    [anon_sym_case] = ACTIONS(2477),
    [anon_sym_default] = ACTIONS(2477),
    [anon_sym_while] = ACTIONS(2477),
    [anon_sym_do] = ACTIONS(2477),
    [anon_sym_for] = ACTIONS(2477),
    [anon_sym_return] = ACTIONS(2477),
    [anon_sym_break] = ACTIONS(2477),
    [anon_sym_continue] = ACTIONS(2477),
    [anon_sym_goto] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2475),
    [anon_sym_BANG] = ACTIONS(2475),
    [anon_sym_TILDE] = ACTIONS(2475),
    [anon_sym_PLUS] = ACTIONS(2477),
    [anon_sym_DASH] = ACTIONS(2477),
    [anon_sym_DASH_DASH] = ACTIONS(2475),
    [anon_sym_PLUS_PLUS] = ACTIONS(2475),
    [anon_sym_sizeof] = ACTIONS(2477),
    [sym_number_literal] = ACTIONS(2475),
    [anon_sym_SQUOTE] = ACTIONS(2475),
    [anon_sym_DQUOTE] = ACTIONS(2475),
    [sym_true] = ACTIONS(2477),
    [sym_false] = ACTIONS(2477),
    [sym_null] = ACTIONS(2477),
    [sym_identifier] = ACTIONS(2477),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2477),
    [sym_auto] = ACTIONS(2477),
    [anon_sym_typename] = ACTIONS(2477),
    [anon_sym_delete] = ACTIONS(2477),
    [anon_sym_try] = ACTIONS(2477),
    [anon_sym_new] = ACTIONS(2477),
    [anon_sym_COLON_COLON] = ACTIONS(2475),
    [sym_nullptr] = ACTIONS(2477),
  },
  [1322] = {
    [sym__expression] = STATE(2078),
    [sym_conditional_expression] = STATE(2078),
    [sym_assignment_expression] = STATE(2078),
    [sym_pointer_expression] = STATE(2078),
    [sym_logical_expression] = STATE(2078),
    [sym_bitwise_expression] = STATE(2078),
    [sym_equality_expression] = STATE(2078),
    [sym_relational_expression] = STATE(2078),
    [sym_shift_expression] = STATE(2078),
    [sym_math_expression] = STATE(2078),
    [sym_cast_expression] = STATE(2078),
    [sym_sizeof_expression] = STATE(2078),
    [sym_subscript_expression] = STATE(2078),
    [sym_call_expression] = STATE(2078),
    [sym_field_expression] = STATE(2078),
    [sym_compound_literal_expression] = STATE(2078),
    [sym_parenthesized_expression] = STATE(2078),
    [sym_initializer_list] = STATE(1201),
    [sym_char_literal] = STATE(2078),
    [sym_concatenated_string] = STATE(2078),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2078),
    [sym_new_expression] = STATE(2078),
    [sym_delete_expression] = STATE(2078),
    [sym_lambda_expression] = STATE(2078),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(4492),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(4494),
    [sym_false] = ACTIONS(4494),
    [sym_null] = ACTIONS(4494),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(4494),
  },
  [1323] = {
    [anon_sym_RPAREN] = ACTIONS(4496),
    [sym_comment] = ACTIONS(91),
  },
  [1324] = {
    [anon_sym_LPAREN2] = ACTIONS(3063),
    [anon_sym_STAR] = ACTIONS(3065),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_EQ] = ACTIONS(3065),
    [anon_sym_COLON] = ACTIONS(3063),
    [anon_sym_QMARK] = ACTIONS(3063),
    [anon_sym_STAR_EQ] = ACTIONS(3063),
    [anon_sym_SLASH_EQ] = ACTIONS(3063),
    [anon_sym_PERCENT_EQ] = ACTIONS(3063),
    [anon_sym_PLUS_EQ] = ACTIONS(3063),
    [anon_sym_DASH_EQ] = ACTIONS(3063),
    [anon_sym_LT_LT_EQ] = ACTIONS(3063),
    [anon_sym_GT_GT_EQ] = ACTIONS(3063),
    [anon_sym_AMP_EQ] = ACTIONS(3063),
    [anon_sym_CARET_EQ] = ACTIONS(3063),
    [anon_sym_PIPE_EQ] = ACTIONS(3063),
    [anon_sym_AMP] = ACTIONS(3065),
    [anon_sym_PIPE_PIPE] = ACTIONS(3063),
    [anon_sym_AMP_AMP] = ACTIONS(3063),
    [anon_sym_PIPE] = ACTIONS(3065),
    [anon_sym_CARET] = ACTIONS(3065),
    [anon_sym_EQ_EQ] = ACTIONS(3063),
    [anon_sym_BANG_EQ] = ACTIONS(3063),
    [anon_sym_LT] = ACTIONS(3065),
    [anon_sym_GT] = ACTIONS(3065),
    [anon_sym_LT_EQ] = ACTIONS(3063),
    [anon_sym_GT_EQ] = ACTIONS(3063),
    [anon_sym_LT_LT] = ACTIONS(3065),
    [anon_sym_GT_GT] = ACTIONS(3065),
    [anon_sym_PLUS] = ACTIONS(3065),
    [anon_sym_DASH] = ACTIONS(3065),
    [anon_sym_SLASH] = ACTIONS(3065),
    [anon_sym_PERCENT] = ACTIONS(3065),
    [anon_sym_DASH_DASH] = ACTIONS(3063),
    [anon_sym_PLUS_PLUS] = ACTIONS(3063),
    [anon_sym_DOT] = ACTIONS(3063),
    [anon_sym_DASH_GT] = ACTIONS(3063),
    [anon_sym_DQUOTE] = ACTIONS(3063),
    [sym_comment] = ACTIONS(91),
  },
  [1325] = {
    [sym__expression] = STATE(2080),
    [sym_conditional_expression] = STATE(2080),
    [sym_assignment_expression] = STATE(2080),
    [sym_pointer_expression] = STATE(2080),
    [sym_logical_expression] = STATE(2080),
    [sym_bitwise_expression] = STATE(2080),
    [sym_equality_expression] = STATE(2080),
    [sym_relational_expression] = STATE(2080),
    [sym_shift_expression] = STATE(2080),
    [sym_math_expression] = STATE(2080),
    [sym_cast_expression] = STATE(2080),
    [sym_sizeof_expression] = STATE(2080),
    [sym_subscript_expression] = STATE(2080),
    [sym_call_expression] = STATE(2080),
    [sym_field_expression] = STATE(2080),
    [sym_compound_literal_expression] = STATE(2080),
    [sym_parenthesized_expression] = STATE(2080),
    [sym_char_literal] = STATE(2080),
    [sym_concatenated_string] = STATE(2080),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2080),
    [sym_new_expression] = STATE(2080),
    [sym_delete_expression] = STATE(2080),
    [sym_lambda_expression] = STATE(2080),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4498),
    [anon_sym_LPAREN2] = ACTIONS(947),
    [anon_sym_STAR] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(947),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(4498),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(4500),
    [sym_false] = ACTIONS(4500),
    [sym_null] = ACTIONS(4500),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(4500),
  },
  [1326] = {
    [sym_field_declaration_list] = STATE(1590),
    [sym_virtual_specifier] = STATE(1591),
    [sym_base_class_clause] = STATE(1592),
    [sym_template_argument_list] = STATE(864),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_LPAREN2] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_EQ] = ACTIONS(1059),
    [anon_sym_COLON] = ACTIONS(1059),
    [anon_sym_QMARK] = ACTIONS(1057),
    [anon_sym_STAR_EQ] = ACTIONS(1057),
    [anon_sym_SLASH_EQ] = ACTIONS(1057),
    [anon_sym_PERCENT_EQ] = ACTIONS(1057),
    [anon_sym_PLUS_EQ] = ACTIONS(1057),
    [anon_sym_DASH_EQ] = ACTIONS(1057),
    [anon_sym_LT_LT_EQ] = ACTIONS(1057),
    [anon_sym_GT_GT_EQ] = ACTIONS(1057),
    [anon_sym_AMP_EQ] = ACTIONS(1057),
    [anon_sym_CARET_EQ] = ACTIONS(1057),
    [anon_sym_PIPE_EQ] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_EQ_EQ] = ACTIONS(1057),
    [anon_sym_BANG_EQ] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_LT_EQ] = ACTIONS(1057),
    [anon_sym_GT_EQ] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_SLASH] = ACTIONS(1059),
    [anon_sym_PERCENT] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1057),
    [anon_sym_PLUS_PLUS] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(1057),
    [anon_sym_DASH_GT] = ACTIONS(1057),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [anon_sym_COLON_COLON] = ACTIONS(1548),
  },
  [1327] = {
    [sym_field_declaration_list] = STATE(1593),
    [sym_virtual_specifier] = STATE(1595),
    [sym_base_class_clause] = STATE(1594),
    [anon_sym_LBRACE] = ACTIONS(1069),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(1069),
    [anon_sym_EQ] = ACTIONS(1071),
    [anon_sym_COLON] = ACTIONS(1071),
    [anon_sym_QMARK] = ACTIONS(1069),
    [anon_sym_STAR_EQ] = ACTIONS(1069),
    [anon_sym_SLASH_EQ] = ACTIONS(1069),
    [anon_sym_PERCENT_EQ] = ACTIONS(1069),
    [anon_sym_PLUS_EQ] = ACTIONS(1069),
    [anon_sym_DASH_EQ] = ACTIONS(1069),
    [anon_sym_LT_LT_EQ] = ACTIONS(1069),
    [anon_sym_GT_GT_EQ] = ACTIONS(1069),
    [anon_sym_AMP_EQ] = ACTIONS(1069),
    [anon_sym_CARET_EQ] = ACTIONS(1069),
    [anon_sym_PIPE_EQ] = ACTIONS(1069),
    [anon_sym_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1069),
    [anon_sym_AMP_AMP] = ACTIONS(1069),
    [anon_sym_PIPE] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1071),
    [anon_sym_EQ_EQ] = ACTIONS(1069),
    [anon_sym_BANG_EQ] = ACTIONS(1069),
    [anon_sym_LT] = ACTIONS(1071),
    [anon_sym_GT] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1069),
    [anon_sym_GT_EQ] = ACTIONS(1069),
    [anon_sym_LT_LT] = ACTIONS(1071),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_DASH] = ACTIONS(1071),
    [anon_sym_SLASH] = ACTIONS(1071),
    [anon_sym_PERCENT] = ACTIONS(1071),
    [anon_sym_DASH_DASH] = ACTIONS(1069),
    [anon_sym_PLUS_PLUS] = ACTIONS(1069),
    [anon_sym_DOT] = ACTIONS(1069),
    [anon_sym_DASH_GT] = ACTIONS(1069),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [anon_sym_COLON_COLON] = ACTIONS(1564),
  },
  [1328] = {
    [sym_field_declaration_list] = STATE(1593),
    [sym_virtual_specifier] = STATE(1595),
    [sym_base_class_clause] = STATE(1594),
    [sym_template_argument_list] = STATE(878),
    [anon_sym_LBRACE] = ACTIONS(1069),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(1069),
    [anon_sym_EQ] = ACTIONS(1071),
    [anon_sym_COLON] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(1069),
    [anon_sym_STAR_EQ] = ACTIONS(1069),
    [anon_sym_SLASH_EQ] = ACTIONS(1069),
    [anon_sym_PERCENT_EQ] = ACTIONS(1069),
    [anon_sym_PLUS_EQ] = ACTIONS(1069),
    [anon_sym_DASH_EQ] = ACTIONS(1069),
    [anon_sym_LT_LT_EQ] = ACTIONS(1069),
    [anon_sym_GT_GT_EQ] = ACTIONS(1069),
    [anon_sym_AMP_EQ] = ACTIONS(1069),
    [anon_sym_CARET_EQ] = ACTIONS(1069),
    [anon_sym_PIPE_EQ] = ACTIONS(1069),
    [anon_sym_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1069),
    [anon_sym_AMP_AMP] = ACTIONS(1069),
    [anon_sym_PIPE] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1071),
    [anon_sym_EQ_EQ] = ACTIONS(1069),
    [anon_sym_BANG_EQ] = ACTIONS(1069),
    [anon_sym_LT] = ACTIONS(1071),
    [anon_sym_GT] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1069),
    [anon_sym_GT_EQ] = ACTIONS(1069),
    [anon_sym_LT_LT] = ACTIONS(1071),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_DASH] = ACTIONS(1071),
    [anon_sym_SLASH] = ACTIONS(1071),
    [anon_sym_PERCENT] = ACTIONS(1071),
    [anon_sym_DASH_DASH] = ACTIONS(1069),
    [anon_sym_PLUS_PLUS] = ACTIONS(1069),
    [anon_sym_DOT] = ACTIONS(1069),
    [anon_sym_DASH_GT] = ACTIONS(1069),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
  },
  [1329] = {
    [sym_field_declaration_list] = STATE(1596),
    [sym_virtual_specifier] = STATE(1597),
    [sym_base_class_clause] = STATE(1598),
    [sym_template_argument_list] = STATE(864),
    [anon_sym_LBRACE] = ACTIONS(1077),
    [anon_sym_LPAREN2] = ACTIONS(1077),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_LBRACK] = ACTIONS(1077),
    [anon_sym_EQ] = ACTIONS(1079),
    [anon_sym_COLON] = ACTIONS(1079),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_STAR_EQ] = ACTIONS(1077),
    [anon_sym_SLASH_EQ] = ACTIONS(1077),
    [anon_sym_PERCENT_EQ] = ACTIONS(1077),
    [anon_sym_PLUS_EQ] = ACTIONS(1077),
    [anon_sym_DASH_EQ] = ACTIONS(1077),
    [anon_sym_LT_LT_EQ] = ACTIONS(1077),
    [anon_sym_GT_GT_EQ] = ACTIONS(1077),
    [anon_sym_AMP_EQ] = ACTIONS(1077),
    [anon_sym_CARET_EQ] = ACTIONS(1077),
    [anon_sym_PIPE_EQ] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_PIPE_PIPE] = ACTIONS(1077),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_CARET] = ACTIONS(1079),
    [anon_sym_EQ_EQ] = ACTIONS(1077),
    [anon_sym_BANG_EQ] = ACTIONS(1077),
    [anon_sym_LT] = ACTIONS(1079),
    [anon_sym_GT] = ACTIONS(1079),
    [anon_sym_LT_EQ] = ACTIONS(1077),
    [anon_sym_GT_EQ] = ACTIONS(1077),
    [anon_sym_LT_LT] = ACTIONS(1079),
    [anon_sym_GT_GT] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(1079),
    [anon_sym_DASH] = ACTIONS(1079),
    [anon_sym_SLASH] = ACTIONS(1079),
    [anon_sym_PERCENT] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1077),
    [anon_sym_PLUS_PLUS] = ACTIONS(1077),
    [anon_sym_DOT] = ACTIONS(1077),
    [anon_sym_DASH_GT] = ACTIONS(1077),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [anon_sym_COLON_COLON] = ACTIONS(1548),
  },
  [1330] = {
    [sym_field_declaration_list] = STATE(1599),
    [sym_virtual_specifier] = STATE(1601),
    [sym_base_class_clause] = STATE(1600),
    [anon_sym_LBRACE] = ACTIONS(1081),
    [anon_sym_LPAREN2] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1083),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(1083),
    [anon_sym_COLON] = ACTIONS(1083),
    [anon_sym_QMARK] = ACTIONS(1081),
    [anon_sym_STAR_EQ] = ACTIONS(1081),
    [anon_sym_SLASH_EQ] = ACTIONS(1081),
    [anon_sym_PERCENT_EQ] = ACTIONS(1081),
    [anon_sym_PLUS_EQ] = ACTIONS(1081),
    [anon_sym_DASH_EQ] = ACTIONS(1081),
    [anon_sym_LT_LT_EQ] = ACTIONS(1081),
    [anon_sym_GT_GT_EQ] = ACTIONS(1081),
    [anon_sym_AMP_EQ] = ACTIONS(1081),
    [anon_sym_CARET_EQ] = ACTIONS(1081),
    [anon_sym_PIPE_EQ] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_PIPE] = ACTIONS(1083),
    [anon_sym_CARET] = ACTIONS(1083),
    [anon_sym_EQ_EQ] = ACTIONS(1081),
    [anon_sym_BANG_EQ] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(1083),
    [anon_sym_GT] = ACTIONS(1083),
    [anon_sym_LT_EQ] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1081),
    [anon_sym_LT_LT] = ACTIONS(1083),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_SLASH] = ACTIONS(1083),
    [anon_sym_PERCENT] = ACTIONS(1083),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DOT] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(1081),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [anon_sym_COLON_COLON] = ACTIONS(1564),
  },
  [1331] = {
    [sym_field_declaration_list] = STATE(1599),
    [sym_virtual_specifier] = STATE(1601),
    [sym_base_class_clause] = STATE(1600),
    [sym_template_argument_list] = STATE(878),
    [anon_sym_LBRACE] = ACTIONS(1081),
    [anon_sym_LPAREN2] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1083),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(1083),
    [anon_sym_COLON] = ACTIONS(1081),
    [anon_sym_QMARK] = ACTIONS(1081),
    [anon_sym_STAR_EQ] = ACTIONS(1081),
    [anon_sym_SLASH_EQ] = ACTIONS(1081),
    [anon_sym_PERCENT_EQ] = ACTIONS(1081),
    [anon_sym_PLUS_EQ] = ACTIONS(1081),
    [anon_sym_DASH_EQ] = ACTIONS(1081),
    [anon_sym_LT_LT_EQ] = ACTIONS(1081),
    [anon_sym_GT_GT_EQ] = ACTIONS(1081),
    [anon_sym_AMP_EQ] = ACTIONS(1081),
    [anon_sym_CARET_EQ] = ACTIONS(1081),
    [anon_sym_PIPE_EQ] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_PIPE] = ACTIONS(1083),
    [anon_sym_CARET] = ACTIONS(1083),
    [anon_sym_EQ_EQ] = ACTIONS(1081),
    [anon_sym_BANG_EQ] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(1083),
    [anon_sym_GT] = ACTIONS(1083),
    [anon_sym_LT_EQ] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1081),
    [anon_sym_LT_LT] = ACTIONS(1083),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_SLASH] = ACTIONS(1083),
    [anon_sym_PERCENT] = ACTIONS(1083),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DOT] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(1081),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
  },
  [1332] = {
    [sym_field_declaration_list] = STATE(1603),
    [sym_virtual_specifier] = STATE(1604),
    [sym_base_class_clause] = STATE(1605),
    [sym_template_argument_list] = STATE(864),
    [anon_sym_LBRACE] = ACTIONS(1438),
    [anon_sym_LPAREN2] = ACTIONS(1438),
    [anon_sym_STAR] = ACTIONS(1440),
    [anon_sym_LBRACK] = ACTIONS(1438),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_COLON] = ACTIONS(1440),
    [anon_sym_QMARK] = ACTIONS(1438),
    [anon_sym_STAR_EQ] = ACTIONS(1438),
    [anon_sym_SLASH_EQ] = ACTIONS(1438),
    [anon_sym_PERCENT_EQ] = ACTIONS(1438),
    [anon_sym_PLUS_EQ] = ACTIONS(1438),
    [anon_sym_DASH_EQ] = ACTIONS(1438),
    [anon_sym_LT_LT_EQ] = ACTIONS(1438),
    [anon_sym_GT_GT_EQ] = ACTIONS(1438),
    [anon_sym_AMP_EQ] = ACTIONS(1438),
    [anon_sym_CARET_EQ] = ACTIONS(1438),
    [anon_sym_PIPE_EQ] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_PIPE_PIPE] = ACTIONS(1438),
    [anon_sym_AMP_AMP] = ACTIONS(1438),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_CARET] = ACTIONS(1440),
    [anon_sym_EQ_EQ] = ACTIONS(1438),
    [anon_sym_BANG_EQ] = ACTIONS(1438),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_LT_EQ] = ACTIONS(1438),
    [anon_sym_GT_EQ] = ACTIONS(1438),
    [anon_sym_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_GT] = ACTIONS(1440),
    [anon_sym_PLUS] = ACTIONS(1440),
    [anon_sym_DASH] = ACTIONS(1440),
    [anon_sym_SLASH] = ACTIONS(1440),
    [anon_sym_PERCENT] = ACTIONS(1440),
    [anon_sym_DASH_DASH] = ACTIONS(1438),
    [anon_sym_PLUS_PLUS] = ACTIONS(1438),
    [anon_sym_DOT] = ACTIONS(1438),
    [anon_sym_DASH_GT] = ACTIONS(1438),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [anon_sym_COLON_COLON] = ACTIONS(1548),
  },
  [1333] = {
    [sym_field_declaration_list] = STATE(1606),
    [sym_virtual_specifier] = STATE(1608),
    [sym_base_class_clause] = STATE(1607),
    [anon_sym_LBRACE] = ACTIONS(1442),
    [anon_sym_LPAREN2] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1444),
    [anon_sym_LBRACK] = ACTIONS(1442),
    [anon_sym_EQ] = ACTIONS(1444),
    [anon_sym_COLON] = ACTIONS(1444),
    [anon_sym_QMARK] = ACTIONS(1442),
    [anon_sym_STAR_EQ] = ACTIONS(1442),
    [anon_sym_SLASH_EQ] = ACTIONS(1442),
    [anon_sym_PERCENT_EQ] = ACTIONS(1442),
    [anon_sym_PLUS_EQ] = ACTIONS(1442),
    [anon_sym_DASH_EQ] = ACTIONS(1442),
    [anon_sym_LT_LT_EQ] = ACTIONS(1442),
    [anon_sym_GT_GT_EQ] = ACTIONS(1442),
    [anon_sym_AMP_EQ] = ACTIONS(1442),
    [anon_sym_CARET_EQ] = ACTIONS(1442),
    [anon_sym_PIPE_EQ] = ACTIONS(1442),
    [anon_sym_AMP] = ACTIONS(1444),
    [anon_sym_PIPE_PIPE] = ACTIONS(1442),
    [anon_sym_AMP_AMP] = ACTIONS(1442),
    [anon_sym_PIPE] = ACTIONS(1444),
    [anon_sym_CARET] = ACTIONS(1444),
    [anon_sym_EQ_EQ] = ACTIONS(1442),
    [anon_sym_BANG_EQ] = ACTIONS(1442),
    [anon_sym_LT] = ACTIONS(1444),
    [anon_sym_GT] = ACTIONS(1444),
    [anon_sym_LT_EQ] = ACTIONS(1442),
    [anon_sym_GT_EQ] = ACTIONS(1442),
    [anon_sym_LT_LT] = ACTIONS(1444),
    [anon_sym_GT_GT] = ACTIONS(1444),
    [anon_sym_PLUS] = ACTIONS(1444),
    [anon_sym_DASH] = ACTIONS(1444),
    [anon_sym_SLASH] = ACTIONS(1444),
    [anon_sym_PERCENT] = ACTIONS(1444),
    [anon_sym_DASH_DASH] = ACTIONS(1442),
    [anon_sym_PLUS_PLUS] = ACTIONS(1442),
    [anon_sym_DOT] = ACTIONS(1442),
    [anon_sym_DASH_GT] = ACTIONS(1442),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [anon_sym_COLON_COLON] = ACTIONS(1564),
  },
  [1334] = {
    [sym_field_declaration_list] = STATE(1606),
    [sym_virtual_specifier] = STATE(1608),
    [sym_base_class_clause] = STATE(1607),
    [sym_template_argument_list] = STATE(878),
    [anon_sym_LBRACE] = ACTIONS(1442),
    [anon_sym_LPAREN2] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1444),
    [anon_sym_LBRACK] = ACTIONS(1442),
    [anon_sym_EQ] = ACTIONS(1444),
    [anon_sym_COLON] = ACTIONS(1442),
    [anon_sym_QMARK] = ACTIONS(1442),
    [anon_sym_STAR_EQ] = ACTIONS(1442),
    [anon_sym_SLASH_EQ] = ACTIONS(1442),
    [anon_sym_PERCENT_EQ] = ACTIONS(1442),
    [anon_sym_PLUS_EQ] = ACTIONS(1442),
    [anon_sym_DASH_EQ] = ACTIONS(1442),
    [anon_sym_LT_LT_EQ] = ACTIONS(1442),
    [anon_sym_GT_GT_EQ] = ACTIONS(1442),
    [anon_sym_AMP_EQ] = ACTIONS(1442),
    [anon_sym_CARET_EQ] = ACTIONS(1442),
    [anon_sym_PIPE_EQ] = ACTIONS(1442),
    [anon_sym_AMP] = ACTIONS(1444),
    [anon_sym_PIPE_PIPE] = ACTIONS(1442),
    [anon_sym_AMP_AMP] = ACTIONS(1442),
    [anon_sym_PIPE] = ACTIONS(1444),
    [anon_sym_CARET] = ACTIONS(1444),
    [anon_sym_EQ_EQ] = ACTIONS(1442),
    [anon_sym_BANG_EQ] = ACTIONS(1442),
    [anon_sym_LT] = ACTIONS(1444),
    [anon_sym_GT] = ACTIONS(1444),
    [anon_sym_LT_EQ] = ACTIONS(1442),
    [anon_sym_GT_EQ] = ACTIONS(1442),
    [anon_sym_LT_LT] = ACTIONS(1444),
    [anon_sym_GT_GT] = ACTIONS(1444),
    [anon_sym_PLUS] = ACTIONS(1444),
    [anon_sym_DASH] = ACTIONS(1444),
    [anon_sym_SLASH] = ACTIONS(1444),
    [anon_sym_PERCENT] = ACTIONS(1444),
    [anon_sym_DASH_DASH] = ACTIONS(1442),
    [anon_sym_PLUS_PLUS] = ACTIONS(1442),
    [anon_sym_DOT] = ACTIONS(1442),
    [anon_sym_DASH_GT] = ACTIONS(1442),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
  },
  [1335] = {
    [sym__expression] = STATE(2081),
    [sym_conditional_expression] = STATE(2081),
    [sym_assignment_expression] = STATE(2081),
    [sym_pointer_expression] = STATE(2081),
    [sym_logical_expression] = STATE(2081),
    [sym_bitwise_expression] = STATE(2081),
    [sym_equality_expression] = STATE(2081),
    [sym_relational_expression] = STATE(2081),
    [sym_shift_expression] = STATE(2081),
    [sym_math_expression] = STATE(2081),
    [sym_cast_expression] = STATE(2081),
    [sym_sizeof_expression] = STATE(2081),
    [sym_subscript_expression] = STATE(2081),
    [sym_call_expression] = STATE(2081),
    [sym_field_expression] = STATE(2081),
    [sym_compound_literal_expression] = STATE(2081),
    [sym_parenthesized_expression] = STATE(2081),
    [sym_char_literal] = STATE(2081),
    [sym_concatenated_string] = STATE(2081),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2081),
    [sym_new_expression] = STATE(2081),
    [sym_delete_expression] = STATE(2081),
    [sym_lambda_expression] = STATE(2081),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4502),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(4502),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4504),
    [sym_false] = ACTIONS(4504),
    [sym_null] = ACTIONS(4504),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(4504),
  },
  [1336] = {
    [sym_argument_list] = STATE(1610),
    [sym_initializer_list] = STATE(1610),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(3374),
    [anon_sym_LBRACK] = ACTIONS(3372),
    [anon_sym_EQ] = ACTIONS(3374),
    [anon_sym_COLON] = ACTIONS(3372),
    [anon_sym_QMARK] = ACTIONS(3372),
    [anon_sym_STAR_EQ] = ACTIONS(3372),
    [anon_sym_SLASH_EQ] = ACTIONS(3372),
    [anon_sym_PERCENT_EQ] = ACTIONS(3372),
    [anon_sym_PLUS_EQ] = ACTIONS(3372),
    [anon_sym_DASH_EQ] = ACTIONS(3372),
    [anon_sym_LT_LT_EQ] = ACTIONS(3372),
    [anon_sym_GT_GT_EQ] = ACTIONS(3372),
    [anon_sym_AMP_EQ] = ACTIONS(3372),
    [anon_sym_CARET_EQ] = ACTIONS(3372),
    [anon_sym_PIPE_EQ] = ACTIONS(3372),
    [anon_sym_AMP] = ACTIONS(3374),
    [anon_sym_PIPE_PIPE] = ACTIONS(3372),
    [anon_sym_AMP_AMP] = ACTIONS(3372),
    [anon_sym_PIPE] = ACTIONS(3374),
    [anon_sym_CARET] = ACTIONS(3374),
    [anon_sym_EQ_EQ] = ACTIONS(3372),
    [anon_sym_BANG_EQ] = ACTIONS(3372),
    [anon_sym_LT] = ACTIONS(3374),
    [anon_sym_GT] = ACTIONS(3374),
    [anon_sym_LT_EQ] = ACTIONS(3372),
    [anon_sym_GT_EQ] = ACTIONS(3372),
    [anon_sym_LT_LT] = ACTIONS(3374),
    [anon_sym_GT_GT] = ACTIONS(3374),
    [anon_sym_PLUS] = ACTIONS(3374),
    [anon_sym_DASH] = ACTIONS(3374),
    [anon_sym_SLASH] = ACTIONS(3374),
    [anon_sym_PERCENT] = ACTIONS(3374),
    [anon_sym_DASH_DASH] = ACTIONS(3372),
    [anon_sym_PLUS_PLUS] = ACTIONS(3372),
    [anon_sym_DOT] = ACTIONS(3372),
    [anon_sym_DASH_GT] = ACTIONS(3372),
    [sym_comment] = ACTIONS(91),
  },
  [1337] = {
    [sym_argument_list] = STATE(1610),
    [sym_initializer_list] = STATE(1610),
    [sym_new_declarator] = STATE(2082),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(3374),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_EQ] = ACTIONS(3374),
    [anon_sym_COLON] = ACTIONS(3372),
    [anon_sym_QMARK] = ACTIONS(3372),
    [anon_sym_STAR_EQ] = ACTIONS(3372),
    [anon_sym_SLASH_EQ] = ACTIONS(3372),
    [anon_sym_PERCENT_EQ] = ACTIONS(3372),
    [anon_sym_PLUS_EQ] = ACTIONS(3372),
    [anon_sym_DASH_EQ] = ACTIONS(3372),
    [anon_sym_LT_LT_EQ] = ACTIONS(3372),
    [anon_sym_GT_GT_EQ] = ACTIONS(3372),
    [anon_sym_AMP_EQ] = ACTIONS(3372),
    [anon_sym_CARET_EQ] = ACTIONS(3372),
    [anon_sym_PIPE_EQ] = ACTIONS(3372),
    [anon_sym_AMP] = ACTIONS(3374),
    [anon_sym_PIPE_PIPE] = ACTIONS(3372),
    [anon_sym_AMP_AMP] = ACTIONS(3372),
    [anon_sym_PIPE] = ACTIONS(3374),
    [anon_sym_CARET] = ACTIONS(3374),
    [anon_sym_EQ_EQ] = ACTIONS(3372),
    [anon_sym_BANG_EQ] = ACTIONS(3372),
    [anon_sym_LT] = ACTIONS(3374),
    [anon_sym_GT] = ACTIONS(3374),
    [anon_sym_LT_EQ] = ACTIONS(3372),
    [anon_sym_GT_EQ] = ACTIONS(3372),
    [anon_sym_LT_LT] = ACTIONS(3374),
    [anon_sym_GT_GT] = ACTIONS(3374),
    [anon_sym_PLUS] = ACTIONS(3374),
    [anon_sym_DASH] = ACTIONS(3374),
    [anon_sym_SLASH] = ACTIONS(3374),
    [anon_sym_PERCENT] = ACTIONS(3374),
    [anon_sym_DASH_DASH] = ACTIONS(3372),
    [anon_sym_PLUS_PLUS] = ACTIONS(3372),
    [anon_sym_DOT] = ACTIONS(3372),
    [anon_sym_DASH_GT] = ACTIONS(3372),
    [sym_comment] = ACTIONS(91),
  },
  [1338] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1338),
    [anon_sym_LBRACE] = ACTIONS(1985),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_EQ] = ACTIONS(1987),
    [anon_sym_unsigned] = ACTIONS(4506),
    [anon_sym_long] = ACTIONS(4506),
    [anon_sym_short] = ACTIONS(4506),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_COLON] = ACTIONS(1985),
    [anon_sym_QMARK] = ACTIONS(1985),
    [anon_sym_STAR_EQ] = ACTIONS(1985),
    [anon_sym_SLASH_EQ] = ACTIONS(1985),
    [anon_sym_PERCENT_EQ] = ACTIONS(1985),
    [anon_sym_PLUS_EQ] = ACTIONS(1985),
    [anon_sym_DASH_EQ] = ACTIONS(1985),
    [anon_sym_LT_LT_EQ] = ACTIONS(1985),
    [anon_sym_GT_GT_EQ] = ACTIONS(1985),
    [anon_sym_AMP_EQ] = ACTIONS(1985),
    [anon_sym_CARET_EQ] = ACTIONS(1985),
    [anon_sym_PIPE_EQ] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_PIPE_PIPE] = ACTIONS(1985),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_PIPE] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1987),
    [anon_sym_EQ_EQ] = ACTIONS(1985),
    [anon_sym_BANG_EQ] = ACTIONS(1985),
    [anon_sym_LT] = ACTIONS(1987),
    [anon_sym_GT] = ACTIONS(1987),
    [anon_sym_LT_EQ] = ACTIONS(1985),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_LT] = ACTIONS(1987),
    [anon_sym_GT_GT] = ACTIONS(1987),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_DASH] = ACTIONS(1987),
    [anon_sym_SLASH] = ACTIONS(1987),
    [anon_sym_PERCENT] = ACTIONS(1987),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DOT] = ACTIONS(1985),
    [anon_sym_DASH_GT] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [sym_comment] = ACTIONS(91),
  },
  [1339] = {
    [sym__expression] = STATE(164),
    [sym_conditional_expression] = STATE(164),
    [sym_assignment_expression] = STATE(164),
    [sym_pointer_expression] = STATE(164),
    [sym_logical_expression] = STATE(164),
    [sym_bitwise_expression] = STATE(164),
    [sym_equality_expression] = STATE(164),
    [sym_relational_expression] = STATE(164),
    [sym_shift_expression] = STATE(164),
    [sym_math_expression] = STATE(164),
    [sym_cast_expression] = STATE(164),
    [sym_sizeof_expression] = STATE(164),
    [sym_subscript_expression] = STATE(164),
    [sym_call_expression] = STATE(164),
    [sym_field_expression] = STATE(164),
    [sym_compound_literal_expression] = STATE(164),
    [sym_parenthesized_expression] = STATE(164),
    [sym_char_literal] = STATE(164),
    [sym_concatenated_string] = STATE(164),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(164),
    [sym_new_expression] = STATE(164),
    [sym_delete_expression] = STATE(164),
    [sym_lambda_expression] = STATE(164),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_lambda_default_capture] = STATE(166),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(267),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(4509),
    [anon_sym_EQ] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(267),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(289),
    [sym_false] = ACTIONS(289),
    [sym_null] = ACTIONS(289),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(289),
  },
  [1340] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3385),
    [anon_sym_COLON] = ACTIONS(3383),
    [anon_sym_QMARK] = ACTIONS(3383),
    [anon_sym_STAR_EQ] = ACTIONS(3383),
    [anon_sym_SLASH_EQ] = ACTIONS(3383),
    [anon_sym_PERCENT_EQ] = ACTIONS(3383),
    [anon_sym_PLUS_EQ] = ACTIONS(3383),
    [anon_sym_DASH_EQ] = ACTIONS(3383),
    [anon_sym_LT_LT_EQ] = ACTIONS(3383),
    [anon_sym_GT_GT_EQ] = ACTIONS(3383),
    [anon_sym_AMP_EQ] = ACTIONS(3383),
    [anon_sym_CARET_EQ] = ACTIONS(3383),
    [anon_sym_PIPE_EQ] = ACTIONS(3383),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_CARET] = ACTIONS(1183),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [1341] = {
    [anon_sym_LPAREN2] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(3354),
    [anon_sym_LBRACK] = ACTIONS(3352),
    [anon_sym_EQ] = ACTIONS(3354),
    [anon_sym_COLON] = ACTIONS(3352),
    [anon_sym_QMARK] = ACTIONS(3352),
    [anon_sym_STAR_EQ] = ACTIONS(3352),
    [anon_sym_SLASH_EQ] = ACTIONS(3352),
    [anon_sym_PERCENT_EQ] = ACTIONS(3352),
    [anon_sym_PLUS_EQ] = ACTIONS(3352),
    [anon_sym_DASH_EQ] = ACTIONS(3352),
    [anon_sym_LT_LT_EQ] = ACTIONS(3352),
    [anon_sym_GT_GT_EQ] = ACTIONS(3352),
    [anon_sym_AMP_EQ] = ACTIONS(3352),
    [anon_sym_CARET_EQ] = ACTIONS(3352),
    [anon_sym_PIPE_EQ] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3354),
    [anon_sym_PIPE_PIPE] = ACTIONS(3352),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_PIPE] = ACTIONS(3354),
    [anon_sym_CARET] = ACTIONS(3354),
    [anon_sym_EQ_EQ] = ACTIONS(3352),
    [anon_sym_BANG_EQ] = ACTIONS(3352),
    [anon_sym_LT] = ACTIONS(3354),
    [anon_sym_GT] = ACTIONS(3354),
    [anon_sym_LT_EQ] = ACTIONS(3352),
    [anon_sym_GT_EQ] = ACTIONS(3352),
    [anon_sym_LT_LT] = ACTIONS(3354),
    [anon_sym_GT_GT] = ACTIONS(3354),
    [anon_sym_PLUS] = ACTIONS(3354),
    [anon_sym_DASH] = ACTIONS(3354),
    [anon_sym_SLASH] = ACTIONS(3354),
    [anon_sym_PERCENT] = ACTIONS(3354),
    [anon_sym_DASH_DASH] = ACTIONS(3352),
    [anon_sym_PLUS_PLUS] = ACTIONS(3352),
    [anon_sym_DOT] = ACTIONS(3352),
    [anon_sym_DASH_GT] = ACTIONS(3352),
    [sym_comment] = ACTIONS(91),
  },
  [1342] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_argument_list_repeat1] = STATE(2085),
    [anon_sym_COMMA] = ACTIONS(3356),
    [anon_sym_RPAREN] = ACTIONS(4511),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1343] = {
    [aux_sym_argument_list_repeat1] = STATE(2085),
    [anon_sym_COMMA] = ACTIONS(3356),
    [anon_sym_RPAREN] = ACTIONS(4511),
    [sym_comment] = ACTIONS(91),
  },
  [1344] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(3577),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3577),
    [anon_sym_COLON] = ACTIONS(3575),
    [anon_sym_QMARK] = ACTIONS(3575),
    [anon_sym_STAR_EQ] = ACTIONS(3575),
    [anon_sym_SLASH_EQ] = ACTIONS(3575),
    [anon_sym_PERCENT_EQ] = ACTIONS(3575),
    [anon_sym_PLUS_EQ] = ACTIONS(3575),
    [anon_sym_DASH_EQ] = ACTIONS(3575),
    [anon_sym_LT_LT_EQ] = ACTIONS(3575),
    [anon_sym_GT_GT_EQ] = ACTIONS(3575),
    [anon_sym_AMP_EQ] = ACTIONS(3575),
    [anon_sym_CARET_EQ] = ACTIONS(3575),
    [anon_sym_PIPE_EQ] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_PIPE_PIPE] = ACTIONS(3575),
    [anon_sym_AMP_AMP] = ACTIONS(3575),
    [anon_sym_PIPE] = ACTIONS(3577),
    [anon_sym_CARET] = ACTIONS(3577),
    [anon_sym_EQ_EQ] = ACTIONS(3575),
    [anon_sym_BANG_EQ] = ACTIONS(3575),
    [anon_sym_LT] = ACTIONS(3577),
    [anon_sym_GT] = ACTIONS(3577),
    [anon_sym_LT_EQ] = ACTIONS(3575),
    [anon_sym_GT_EQ] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3577),
    [anon_sym_GT_GT] = ACTIONS(3577),
    [anon_sym_PLUS] = ACTIONS(3577),
    [anon_sym_DASH] = ACTIONS(3577),
    [anon_sym_SLASH] = ACTIONS(3577),
    [anon_sym_PERCENT] = ACTIONS(3577),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [1345] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_COLON] = ACTIONS(3581),
    [anon_sym_QMARK] = ACTIONS(3581),
    [anon_sym_STAR_EQ] = ACTIONS(1173),
    [anon_sym_SLASH_EQ] = ACTIONS(1173),
    [anon_sym_PERCENT_EQ] = ACTIONS(1173),
    [anon_sym_PLUS_EQ] = ACTIONS(1173),
    [anon_sym_DASH_EQ] = ACTIONS(1173),
    [anon_sym_LT_LT_EQ] = ACTIONS(1173),
    [anon_sym_GT_GT_EQ] = ACTIONS(1173),
    [anon_sym_AMP_EQ] = ACTIONS(1173),
    [anon_sym_CARET_EQ] = ACTIONS(1173),
    [anon_sym_PIPE_EQ] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_CARET] = ACTIONS(1183),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [1346] = {
    [sym_raw_string_literal] = ACTIONS(4513),
    [ts_builtin_sym_end] = ACTIONS(4513),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4515),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4515),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4515),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4515),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4515),
    [sym_preproc_directive] = ACTIONS(4515),
    [anon_sym_SEMI] = ACTIONS(4513),
    [anon_sym_typedef] = ACTIONS(4515),
    [anon_sym_extern] = ACTIONS(4515),
    [anon_sym_LBRACE] = ACTIONS(4513),
    [anon_sym_RBRACE] = ACTIONS(4513),
    [anon_sym_LPAREN2] = ACTIONS(4513),
    [anon_sym_STAR] = ACTIONS(4513),
    [anon_sym_LBRACK] = ACTIONS(4513),
    [anon_sym_static] = ACTIONS(4515),
    [anon_sym_register] = ACTIONS(4515),
    [anon_sym_inline] = ACTIONS(4515),
    [anon_sym_const] = ACTIONS(4515),
    [anon_sym_restrict] = ACTIONS(4515),
    [anon_sym_volatile] = ACTIONS(4515),
    [anon_sym__Atomic] = ACTIONS(4515),
    [anon_sym_mutable] = ACTIONS(4515),
    [anon_sym_explicit] = ACTIONS(4515),
    [anon_sym_constexpr] = ACTIONS(4515),
    [anon_sym_unsigned] = ACTIONS(4515),
    [anon_sym_long] = ACTIONS(4515),
    [anon_sym_short] = ACTIONS(4515),
    [sym_primitive_type] = ACTIONS(4515),
    [anon_sym_enum] = ACTIONS(4515),
    [anon_sym_struct] = ACTIONS(4515),
    [anon_sym_union] = ACTIONS(4515),
    [anon_sym_if] = ACTIONS(4515),
    [anon_sym_else] = ACTIONS(4515),
    [anon_sym_switch] = ACTIONS(4515),
    [anon_sym_case] = ACTIONS(4515),
    [anon_sym_default] = ACTIONS(4515),
    [anon_sym_while] = ACTIONS(4515),
    [anon_sym_do] = ACTIONS(4515),
    [anon_sym_for] = ACTIONS(4515),
    [anon_sym_return] = ACTIONS(4515),
    [anon_sym_break] = ACTIONS(4515),
    [anon_sym_continue] = ACTIONS(4515),
    [anon_sym_goto] = ACTIONS(4515),
    [anon_sym_AMP] = ACTIONS(4515),
    [anon_sym_AMP_AMP] = ACTIONS(4513),
    [anon_sym_BANG] = ACTIONS(4513),
    [anon_sym_TILDE] = ACTIONS(4513),
    [anon_sym_PLUS] = ACTIONS(4515),
    [anon_sym_DASH] = ACTIONS(4515),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
    [anon_sym_sizeof] = ACTIONS(4515),
    [sym_number_literal] = ACTIONS(4513),
    [anon_sym_SQUOTE] = ACTIONS(4513),
    [anon_sym_DQUOTE] = ACTIONS(4513),
    [sym_true] = ACTIONS(4515),
    [sym_false] = ACTIONS(4515),
    [sym_null] = ACTIONS(4515),
    [sym_identifier] = ACTIONS(4515),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4515),
    [sym_auto] = ACTIONS(4515),
    [anon_sym_typename] = ACTIONS(4515),
    [anon_sym_template] = ACTIONS(4515),
    [anon_sym_delete] = ACTIONS(4515),
    [anon_sym_namespace] = ACTIONS(4515),
    [anon_sym_using] = ACTIONS(4515),
    [anon_sym_try] = ACTIONS(4515),
    [anon_sym_new] = ACTIONS(4515),
    [anon_sym_COLON_COLON] = ACTIONS(4513),
    [sym_operator_name] = ACTIONS(4513),
    [sym_nullptr] = ACTIONS(4515),
  },
  [1347] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_COLON] = ACTIONS(4517),
    [anon_sym_QMARK] = ACTIONS(1171),
    [anon_sym_STAR_EQ] = ACTIONS(1173),
    [anon_sym_SLASH_EQ] = ACTIONS(1173),
    [anon_sym_PERCENT_EQ] = ACTIONS(1173),
    [anon_sym_PLUS_EQ] = ACTIONS(1173),
    [anon_sym_DASH_EQ] = ACTIONS(1173),
    [anon_sym_LT_LT_EQ] = ACTIONS(1173),
    [anon_sym_GT_GT_EQ] = ACTIONS(1173),
    [anon_sym_AMP_EQ] = ACTIONS(1173),
    [anon_sym_CARET_EQ] = ACTIONS(1173),
    [anon_sym_PIPE_EQ] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_CARET] = ACTIONS(1183),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [1348] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_COLON] = ACTIONS(3585),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_STAR_EQ] = ACTIONS(3585),
    [anon_sym_SLASH_EQ] = ACTIONS(3585),
    [anon_sym_PERCENT_EQ] = ACTIONS(3585),
    [anon_sym_PLUS_EQ] = ACTIONS(3585),
    [anon_sym_DASH_EQ] = ACTIONS(3585),
    [anon_sym_LT_LT_EQ] = ACTIONS(3585),
    [anon_sym_GT_GT_EQ] = ACTIONS(3585),
    [anon_sym_AMP_EQ] = ACTIONS(3585),
    [anon_sym_CARET_EQ] = ACTIONS(3585),
    [anon_sym_PIPE_EQ] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(3587),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3587),
    [anon_sym_CARET] = ACTIONS(3587),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [1349] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3591),
    [anon_sym_COLON] = ACTIONS(3589),
    [anon_sym_QMARK] = ACTIONS(3589),
    [anon_sym_STAR_EQ] = ACTIONS(3589),
    [anon_sym_SLASH_EQ] = ACTIONS(3589),
    [anon_sym_PERCENT_EQ] = ACTIONS(3589),
    [anon_sym_PLUS_EQ] = ACTIONS(3589),
    [anon_sym_DASH_EQ] = ACTIONS(3589),
    [anon_sym_LT_LT_EQ] = ACTIONS(3589),
    [anon_sym_GT_GT_EQ] = ACTIONS(3589),
    [anon_sym_AMP_EQ] = ACTIONS(3589),
    [anon_sym_CARET_EQ] = ACTIONS(3589),
    [anon_sym_PIPE_EQ] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(3589),
    [anon_sym_AMP_AMP] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_CARET] = ACTIONS(1183),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [1350] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3591),
    [anon_sym_COLON] = ACTIONS(3589),
    [anon_sym_QMARK] = ACTIONS(3589),
    [anon_sym_STAR_EQ] = ACTIONS(3589),
    [anon_sym_SLASH_EQ] = ACTIONS(3589),
    [anon_sym_PERCENT_EQ] = ACTIONS(3589),
    [anon_sym_PLUS_EQ] = ACTIONS(3589),
    [anon_sym_DASH_EQ] = ACTIONS(3589),
    [anon_sym_LT_LT_EQ] = ACTIONS(3589),
    [anon_sym_GT_GT_EQ] = ACTIONS(3589),
    [anon_sym_AMP_EQ] = ACTIONS(3589),
    [anon_sym_CARET_EQ] = ACTIONS(3589),
    [anon_sym_PIPE_EQ] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(3589),
    [anon_sym_AMP_AMP] = ACTIONS(3589),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_CARET] = ACTIONS(1183),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [1351] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_COLON] = ACTIONS(3585),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_STAR_EQ] = ACTIONS(3585),
    [anon_sym_SLASH_EQ] = ACTIONS(3585),
    [anon_sym_PERCENT_EQ] = ACTIONS(3585),
    [anon_sym_PLUS_EQ] = ACTIONS(3585),
    [anon_sym_DASH_EQ] = ACTIONS(3585),
    [anon_sym_LT_LT_EQ] = ACTIONS(3585),
    [anon_sym_GT_GT_EQ] = ACTIONS(3585),
    [anon_sym_AMP_EQ] = ACTIONS(3585),
    [anon_sym_CARET_EQ] = ACTIONS(3585),
    [anon_sym_PIPE_EQ] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3587),
    [anon_sym_CARET] = ACTIONS(1183),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [1352] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_COLON] = ACTIONS(3585),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_STAR_EQ] = ACTIONS(3585),
    [anon_sym_SLASH_EQ] = ACTIONS(3585),
    [anon_sym_PERCENT_EQ] = ACTIONS(3585),
    [anon_sym_PLUS_EQ] = ACTIONS(3585),
    [anon_sym_DASH_EQ] = ACTIONS(3585),
    [anon_sym_LT_LT_EQ] = ACTIONS(3585),
    [anon_sym_GT_GT_EQ] = ACTIONS(3585),
    [anon_sym_AMP_EQ] = ACTIONS(3585),
    [anon_sym_CARET_EQ] = ACTIONS(3585),
    [anon_sym_PIPE_EQ] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3587),
    [anon_sym_CARET] = ACTIONS(3587),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [1353] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3595),
    [anon_sym_COLON] = ACTIONS(3593),
    [anon_sym_QMARK] = ACTIONS(3593),
    [anon_sym_STAR_EQ] = ACTIONS(3593),
    [anon_sym_SLASH_EQ] = ACTIONS(3593),
    [anon_sym_PERCENT_EQ] = ACTIONS(3593),
    [anon_sym_PLUS_EQ] = ACTIONS(3593),
    [anon_sym_DASH_EQ] = ACTIONS(3593),
    [anon_sym_LT_LT_EQ] = ACTIONS(3593),
    [anon_sym_GT_GT_EQ] = ACTIONS(3593),
    [anon_sym_AMP_EQ] = ACTIONS(3593),
    [anon_sym_CARET_EQ] = ACTIONS(3593),
    [anon_sym_PIPE_EQ] = ACTIONS(3593),
    [anon_sym_AMP] = ACTIONS(3595),
    [anon_sym_PIPE_PIPE] = ACTIONS(3593),
    [anon_sym_AMP_AMP] = ACTIONS(3593),
    [anon_sym_PIPE] = ACTIONS(3595),
    [anon_sym_CARET] = ACTIONS(3595),
    [anon_sym_EQ_EQ] = ACTIONS(3593),
    [anon_sym_BANG_EQ] = ACTIONS(3593),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [1354] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3599),
    [anon_sym_COLON] = ACTIONS(3597),
    [anon_sym_QMARK] = ACTIONS(3597),
    [anon_sym_STAR_EQ] = ACTIONS(3597),
    [anon_sym_SLASH_EQ] = ACTIONS(3597),
    [anon_sym_PERCENT_EQ] = ACTIONS(3597),
    [anon_sym_PLUS_EQ] = ACTIONS(3597),
    [anon_sym_DASH_EQ] = ACTIONS(3597),
    [anon_sym_LT_LT_EQ] = ACTIONS(3597),
    [anon_sym_GT_GT_EQ] = ACTIONS(3597),
    [anon_sym_AMP_EQ] = ACTIONS(3597),
    [anon_sym_CARET_EQ] = ACTIONS(3597),
    [anon_sym_PIPE_EQ] = ACTIONS(3597),
    [anon_sym_AMP] = ACTIONS(3599),
    [anon_sym_PIPE_PIPE] = ACTIONS(3597),
    [anon_sym_AMP_AMP] = ACTIONS(3597),
    [anon_sym_PIPE] = ACTIONS(3599),
    [anon_sym_CARET] = ACTIONS(3599),
    [anon_sym_EQ_EQ] = ACTIONS(3597),
    [anon_sym_BANG_EQ] = ACTIONS(3597),
    [anon_sym_LT] = ACTIONS(3599),
    [anon_sym_GT] = ACTIONS(3599),
    [anon_sym_LT_EQ] = ACTIONS(3597),
    [anon_sym_GT_EQ] = ACTIONS(3597),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [1355] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3603),
    [anon_sym_COLON] = ACTIONS(3601),
    [anon_sym_QMARK] = ACTIONS(3601),
    [anon_sym_STAR_EQ] = ACTIONS(3601),
    [anon_sym_SLASH_EQ] = ACTIONS(3601),
    [anon_sym_PERCENT_EQ] = ACTIONS(3601),
    [anon_sym_PLUS_EQ] = ACTIONS(3601),
    [anon_sym_DASH_EQ] = ACTIONS(3601),
    [anon_sym_LT_LT_EQ] = ACTIONS(3601),
    [anon_sym_GT_GT_EQ] = ACTIONS(3601),
    [anon_sym_AMP_EQ] = ACTIONS(3601),
    [anon_sym_CARET_EQ] = ACTIONS(3601),
    [anon_sym_PIPE_EQ] = ACTIONS(3601),
    [anon_sym_AMP] = ACTIONS(3603),
    [anon_sym_PIPE_PIPE] = ACTIONS(3601),
    [anon_sym_AMP_AMP] = ACTIONS(3601),
    [anon_sym_PIPE] = ACTIONS(3603),
    [anon_sym_CARET] = ACTIONS(3603),
    [anon_sym_EQ_EQ] = ACTIONS(3601),
    [anon_sym_BANG_EQ] = ACTIONS(3601),
    [anon_sym_LT] = ACTIONS(3603),
    [anon_sym_GT] = ACTIONS(3603),
    [anon_sym_LT_EQ] = ACTIONS(3601),
    [anon_sym_GT_EQ] = ACTIONS(3601),
    [anon_sym_LT_LT] = ACTIONS(3603),
    [anon_sym_GT_GT] = ACTIONS(3603),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [1356] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3577),
    [anon_sym_COLON] = ACTIONS(3575),
    [anon_sym_QMARK] = ACTIONS(3575),
    [anon_sym_STAR_EQ] = ACTIONS(3575),
    [anon_sym_SLASH_EQ] = ACTIONS(3575),
    [anon_sym_PERCENT_EQ] = ACTIONS(3575),
    [anon_sym_PLUS_EQ] = ACTIONS(3575),
    [anon_sym_DASH_EQ] = ACTIONS(3575),
    [anon_sym_LT_LT_EQ] = ACTIONS(3575),
    [anon_sym_GT_GT_EQ] = ACTIONS(3575),
    [anon_sym_AMP_EQ] = ACTIONS(3575),
    [anon_sym_CARET_EQ] = ACTIONS(3575),
    [anon_sym_PIPE_EQ] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_PIPE_PIPE] = ACTIONS(3575),
    [anon_sym_AMP_AMP] = ACTIONS(3575),
    [anon_sym_PIPE] = ACTIONS(3577),
    [anon_sym_CARET] = ACTIONS(3577),
    [anon_sym_EQ_EQ] = ACTIONS(3575),
    [anon_sym_BANG_EQ] = ACTIONS(3575),
    [anon_sym_LT] = ACTIONS(3577),
    [anon_sym_GT] = ACTIONS(3577),
    [anon_sym_LT_EQ] = ACTIONS(3575),
    [anon_sym_GT_EQ] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3577),
    [anon_sym_GT_GT] = ACTIONS(3577),
    [anon_sym_PLUS] = ACTIONS(3577),
    [anon_sym_DASH] = ACTIONS(3577),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [1357] = {
    [sym_string_literal] = STATE(1357),
    [aux_sym_concatenated_string_repeat1] = STATE(1357),
    [anon_sym_LPAREN2] = ACTIONS(3622),
    [anon_sym_STAR] = ACTIONS(3624),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_EQ] = ACTIONS(3624),
    [anon_sym_COLON] = ACTIONS(3622),
    [anon_sym_QMARK] = ACTIONS(3622),
    [anon_sym_STAR_EQ] = ACTIONS(3622),
    [anon_sym_SLASH_EQ] = ACTIONS(3622),
    [anon_sym_PERCENT_EQ] = ACTIONS(3622),
    [anon_sym_PLUS_EQ] = ACTIONS(3622),
    [anon_sym_DASH_EQ] = ACTIONS(3622),
    [anon_sym_LT_LT_EQ] = ACTIONS(3622),
    [anon_sym_GT_GT_EQ] = ACTIONS(3622),
    [anon_sym_AMP_EQ] = ACTIONS(3622),
    [anon_sym_CARET_EQ] = ACTIONS(3622),
    [anon_sym_PIPE_EQ] = ACTIONS(3622),
    [anon_sym_AMP] = ACTIONS(3624),
    [anon_sym_PIPE_PIPE] = ACTIONS(3622),
    [anon_sym_AMP_AMP] = ACTIONS(3622),
    [anon_sym_PIPE] = ACTIONS(3624),
    [anon_sym_CARET] = ACTIONS(3624),
    [anon_sym_EQ_EQ] = ACTIONS(3622),
    [anon_sym_BANG_EQ] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3624),
    [anon_sym_GT] = ACTIONS(3624),
    [anon_sym_LT_EQ] = ACTIONS(3622),
    [anon_sym_GT_EQ] = ACTIONS(3622),
    [anon_sym_LT_LT] = ACTIONS(3624),
    [anon_sym_GT_GT] = ACTIONS(3624),
    [anon_sym_PLUS] = ACTIONS(3624),
    [anon_sym_DASH] = ACTIONS(3624),
    [anon_sym_SLASH] = ACTIONS(3624),
    [anon_sym_PERCENT] = ACTIONS(3624),
    [anon_sym_DASH_DASH] = ACTIONS(3622),
    [anon_sym_PLUS_PLUS] = ACTIONS(3622),
    [anon_sym_DOT] = ACTIONS(3622),
    [anon_sym_DASH_GT] = ACTIONS(3622),
    [anon_sym_DQUOTE] = ACTIONS(4519),
    [sym_comment] = ACTIONS(91),
  },
  [1358] = {
    [anon_sym_COMMA] = ACTIONS(3121),
    [anon_sym_SEMI] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3121),
    [anon_sym_LPAREN2] = ACTIONS(3121),
    [anon_sym_STAR] = ACTIONS(3123),
    [anon_sym_LBRACK] = ACTIONS(3121),
    [anon_sym_EQ] = ACTIONS(3123),
    [anon_sym_COLON] = ACTIONS(3121),
    [anon_sym_QMARK] = ACTIONS(3121),
    [anon_sym_STAR_EQ] = ACTIONS(3121),
    [anon_sym_SLASH_EQ] = ACTIONS(3121),
    [anon_sym_PERCENT_EQ] = ACTIONS(3121),
    [anon_sym_PLUS_EQ] = ACTIONS(3121),
    [anon_sym_DASH_EQ] = ACTIONS(3121),
    [anon_sym_LT_LT_EQ] = ACTIONS(3121),
    [anon_sym_GT_GT_EQ] = ACTIONS(3121),
    [anon_sym_AMP_EQ] = ACTIONS(3121),
    [anon_sym_CARET_EQ] = ACTIONS(3121),
    [anon_sym_PIPE_EQ] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_PIPE_PIPE] = ACTIONS(3121),
    [anon_sym_AMP_AMP] = ACTIONS(3121),
    [anon_sym_PIPE] = ACTIONS(3123),
    [anon_sym_CARET] = ACTIONS(3123),
    [anon_sym_EQ_EQ] = ACTIONS(3121),
    [anon_sym_BANG_EQ] = ACTIONS(3121),
    [anon_sym_LT] = ACTIONS(3123),
    [anon_sym_GT] = ACTIONS(3123),
    [anon_sym_LT_EQ] = ACTIONS(3121),
    [anon_sym_GT_EQ] = ACTIONS(3121),
    [anon_sym_LT_LT] = ACTIONS(3123),
    [anon_sym_GT_GT] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3123),
    [anon_sym_PERCENT] = ACTIONS(3123),
    [anon_sym_DASH_DASH] = ACTIONS(3121),
    [anon_sym_PLUS_PLUS] = ACTIONS(3121),
    [anon_sym_DOT] = ACTIONS(3121),
    [anon_sym_DASH_GT] = ACTIONS(3121),
    [sym_comment] = ACTIONS(91),
  },
  [1359] = {
    [sym_argument_list] = STATE(1511),
    [aux_sym_template_argument_list_repeat1] = STATE(2088),
    [anon_sym_COMMA] = ACTIONS(3163),
    [anon_sym_LPAREN2] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_EQ] = ACTIONS(3171),
    [anon_sym_QMARK] = ACTIONS(3173),
    [anon_sym_STAR_EQ] = ACTIONS(3175),
    [anon_sym_SLASH_EQ] = ACTIONS(3175),
    [anon_sym_PERCENT_EQ] = ACTIONS(3175),
    [anon_sym_PLUS_EQ] = ACTIONS(3175),
    [anon_sym_DASH_EQ] = ACTIONS(3175),
    [anon_sym_LT_LT_EQ] = ACTIONS(3175),
    [anon_sym_GT_GT_EQ] = ACTIONS(3175),
    [anon_sym_AMP_EQ] = ACTIONS(3175),
    [anon_sym_CARET_EQ] = ACTIONS(3175),
    [anon_sym_PIPE_EQ] = ACTIONS(3175),
    [anon_sym_AMP] = ACTIONS(3177),
    [anon_sym_PIPE_PIPE] = ACTIONS(3179),
    [anon_sym_AMP_AMP] = ACTIONS(3181),
    [anon_sym_PIPE] = ACTIONS(3183),
    [anon_sym_CARET] = ACTIONS(3185),
    [anon_sym_EQ_EQ] = ACTIONS(3187),
    [anon_sym_BANG_EQ] = ACTIONS(3187),
    [anon_sym_LT] = ACTIONS(3189),
    [anon_sym_GT] = ACTIONS(3189),
    [anon_sym_LT_EQ] = ACTIONS(3191),
    [anon_sym_GT_EQ] = ACTIONS(3191),
    [anon_sym_LT_LT] = ACTIONS(3193),
    [anon_sym_GT_GT] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_SLASH] = ACTIONS(3167),
    [anon_sym_PERCENT] = ACTIONS(3167),
    [anon_sym_DASH_DASH] = ACTIONS(3197),
    [anon_sym_PLUS_PLUS] = ACTIONS(3197),
    [anon_sym_DOT] = ACTIONS(3199),
    [anon_sym_DASH_GT] = ACTIONS(3199),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(4522),
  },
  [1360] = {
    [aux_sym_template_argument_list_repeat1] = STATE(2090),
    [anon_sym_COMMA] = ACTIONS(3163),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(4524),
  },
  [1361] = {
    [sym_destructor_name] = STATE(789),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(4526),
    [sym_comment] = ACTIONS(91),
    [sym_operator_name] = ACTIONS(1418),
  },
  [1362] = {
    [anon_sym_COMMA] = ACTIONS(1424),
    [anon_sym_SEMI] = ACTIONS(1424),
    [anon_sym_extern] = ACTIONS(1429),
    [anon_sym_LBRACE] = ACTIONS(1431),
    [anon_sym_LPAREN2] = ACTIONS(1426),
    [anon_sym_STAR] = ACTIONS(1433),
    [anon_sym_LBRACK] = ACTIONS(1424),
    [anon_sym_EQ] = ACTIONS(1436),
    [anon_sym_static] = ACTIONS(1429),
    [anon_sym_register] = ACTIONS(1429),
    [anon_sym_inline] = ACTIONS(1429),
    [anon_sym_const] = ACTIONS(1429),
    [anon_sym_restrict] = ACTIONS(1429),
    [anon_sym_volatile] = ACTIONS(1429),
    [anon_sym__Atomic] = ACTIONS(1429),
    [anon_sym_mutable] = ACTIONS(1429),
    [anon_sym_explicit] = ACTIONS(1429),
    [anon_sym_constexpr] = ACTIONS(1429),
    [anon_sym_QMARK] = ACTIONS(1424),
    [anon_sym_STAR_EQ] = ACTIONS(1424),
    [anon_sym_SLASH_EQ] = ACTIONS(1424),
    [anon_sym_PERCENT_EQ] = ACTIONS(1424),
    [anon_sym_PLUS_EQ] = ACTIONS(1424),
    [anon_sym_DASH_EQ] = ACTIONS(1424),
    [anon_sym_LT_LT_EQ] = ACTIONS(1424),
    [anon_sym_GT_GT_EQ] = ACTIONS(1424),
    [anon_sym_AMP_EQ] = ACTIONS(1424),
    [anon_sym_CARET_EQ] = ACTIONS(1424),
    [anon_sym_PIPE_EQ] = ACTIONS(1424),
    [anon_sym_AMP] = ACTIONS(1433),
    [anon_sym_PIPE_PIPE] = ACTIONS(1424),
    [anon_sym_AMP_AMP] = ACTIONS(1426),
    [anon_sym_PIPE] = ACTIONS(1436),
    [anon_sym_CARET] = ACTIONS(1436),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_EQ_EQ] = ACTIONS(1424),
    [anon_sym_BANG_EQ] = ACTIONS(1424),
    [anon_sym_LT] = ACTIONS(1436),
    [anon_sym_GT] = ACTIONS(1436),
    [anon_sym_LT_EQ] = ACTIONS(1424),
    [anon_sym_GT_EQ] = ACTIONS(1424),
    [anon_sym_LT_LT] = ACTIONS(1436),
    [anon_sym_GT_GT] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1436),
    [anon_sym_DASH] = ACTIONS(1436),
    [anon_sym_SLASH] = ACTIONS(1436),
    [anon_sym_PERCENT] = ACTIONS(1436),
    [anon_sym_DASH_DASH] = ACTIONS(1424),
    [anon_sym_PLUS_PLUS] = ACTIONS(1424),
    [anon_sym_DOT] = ACTIONS(1424),
    [anon_sym_DASH_GT] = ACTIONS(1424),
    [sym_identifier] = ACTIONS(1429),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1431),
    [sym_operator_name] = ACTIONS(1431),
  },
  [1363] = {
    [anon_sym_COMMA] = ACTIONS(1575),
    [anon_sym_SEMI] = ACTIONS(1575),
    [anon_sym_extern] = ACTIONS(1580),
    [anon_sym_LBRACE] = ACTIONS(1582),
    [anon_sym_LPAREN2] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1584),
    [anon_sym_LBRACK] = ACTIONS(1575),
    [anon_sym_EQ] = ACTIONS(1587),
    [anon_sym_static] = ACTIONS(1580),
    [anon_sym_register] = ACTIONS(1580),
    [anon_sym_inline] = ACTIONS(1580),
    [anon_sym_const] = ACTIONS(1580),
    [anon_sym_restrict] = ACTIONS(1580),
    [anon_sym_volatile] = ACTIONS(1580),
    [anon_sym__Atomic] = ACTIONS(1580),
    [anon_sym_mutable] = ACTIONS(1580),
    [anon_sym_explicit] = ACTIONS(1580),
    [anon_sym_constexpr] = ACTIONS(1580),
    [anon_sym_QMARK] = ACTIONS(1575),
    [anon_sym_STAR_EQ] = ACTIONS(1575),
    [anon_sym_SLASH_EQ] = ACTIONS(1575),
    [anon_sym_PERCENT_EQ] = ACTIONS(1575),
    [anon_sym_PLUS_EQ] = ACTIONS(1575),
    [anon_sym_DASH_EQ] = ACTIONS(1575),
    [anon_sym_LT_LT_EQ] = ACTIONS(1575),
    [anon_sym_GT_GT_EQ] = ACTIONS(1575),
    [anon_sym_AMP_EQ] = ACTIONS(1575),
    [anon_sym_CARET_EQ] = ACTIONS(1575),
    [anon_sym_PIPE_EQ] = ACTIONS(1575),
    [anon_sym_AMP] = ACTIONS(1584),
    [anon_sym_PIPE_PIPE] = ACTIONS(1575),
    [anon_sym_AMP_AMP] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(1587),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1582),
    [anon_sym_EQ_EQ] = ACTIONS(1575),
    [anon_sym_BANG_EQ] = ACTIONS(1575),
    [anon_sym_LT] = ACTIONS(1584),
    [anon_sym_GT] = ACTIONS(1587),
    [anon_sym_LT_EQ] = ACTIONS(1575),
    [anon_sym_GT_EQ] = ACTIONS(1575),
    [anon_sym_LT_LT] = ACTIONS(1587),
    [anon_sym_GT_GT] = ACTIONS(1587),
    [anon_sym_PLUS] = ACTIONS(1587),
    [anon_sym_DASH] = ACTIONS(1587),
    [anon_sym_SLASH] = ACTIONS(1587),
    [anon_sym_PERCENT] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1575),
    [anon_sym_PLUS_PLUS] = ACTIONS(1575),
    [anon_sym_DOT] = ACTIONS(1575),
    [anon_sym_DASH_GT] = ACTIONS(1575),
    [sym_identifier] = ACTIONS(1580),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [sym_operator_name] = ACTIONS(1582),
  },
  [1364] = {
    [sym_parameter_list] = STATE(897),
    [sym_argument_list] = STATE(898),
    [sym_initializer_list] = STATE(898),
    [aux_sym_declaration_repeat1] = STATE(899),
    [anon_sym_COMMA] = ACTIONS(1613),
    [anon_sym_SEMI] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(1619),
    [anon_sym_LBRACK] = ACTIONS(574),
    [anon_sym_EQ] = ACTIONS(1621),
    [sym_comment] = ACTIONS(91),
  },
  [1365] = {
    [sym_destructor_name] = STATE(958),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(4528),
    [sym_comment] = ACTIONS(91),
    [sym_operator_name] = ACTIONS(1767),
  },
  [1366] = {
    [anon_sym_COMMA] = ACTIONS(2286),
    [anon_sym_RPAREN] = ACTIONS(2286),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym_RBRACE] = ACTIONS(2286),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_STAR] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2286),
    [anon_sym_RBRACK] = ACTIONS(2286),
    [anon_sym_EQ] = ACTIONS(2288),
    [anon_sym_COLON] = ACTIONS(2286),
    [anon_sym_else] = ACTIONS(2286),
    [anon_sym_while] = ACTIONS(2286),
    [anon_sym_QMARK] = ACTIONS(2286),
    [anon_sym_STAR_EQ] = ACTIONS(2286),
    [anon_sym_SLASH_EQ] = ACTIONS(2286),
    [anon_sym_PERCENT_EQ] = ACTIONS(2286),
    [anon_sym_PLUS_EQ] = ACTIONS(2286),
    [anon_sym_DASH_EQ] = ACTIONS(2286),
    [anon_sym_LT_LT_EQ] = ACTIONS(2286),
    [anon_sym_GT_GT_EQ] = ACTIONS(2286),
    [anon_sym_AMP_EQ] = ACTIONS(2286),
    [anon_sym_CARET_EQ] = ACTIONS(2286),
    [anon_sym_PIPE_EQ] = ACTIONS(2286),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_PIPE_PIPE] = ACTIONS(2286),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2288),
    [anon_sym_CARET] = ACTIONS(2288),
    [anon_sym_EQ_EQ] = ACTIONS(2286),
    [anon_sym_BANG_EQ] = ACTIONS(2286),
    [anon_sym_LT] = ACTIONS(2288),
    [anon_sym_GT] = ACTIONS(2288),
    [anon_sym_LT_EQ] = ACTIONS(2286),
    [anon_sym_GT_EQ] = ACTIONS(2286),
    [anon_sym_LT_LT] = ACTIONS(2288),
    [anon_sym_GT_GT] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_PERCENT] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_DOT] = ACTIONS(2286),
    [anon_sym_DASH_GT] = ACTIONS(2286),
    [sym_comment] = ACTIONS(91),
    [anon_sym_catch] = ACTIONS(2286),
  },
  [1367] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(4530),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1368] = {
    [sym__expression] = STATE(2094),
    [sym_conditional_expression] = STATE(2094),
    [sym_assignment_expression] = STATE(2094),
    [sym_pointer_expression] = STATE(2094),
    [sym_logical_expression] = STATE(2094),
    [sym_bitwise_expression] = STATE(2094),
    [sym_equality_expression] = STATE(2094),
    [sym_relational_expression] = STATE(2094),
    [sym_shift_expression] = STATE(2094),
    [sym_math_expression] = STATE(2094),
    [sym_cast_expression] = STATE(2094),
    [sym_sizeof_expression] = STATE(2094),
    [sym_subscript_expression] = STATE(2094),
    [sym_call_expression] = STATE(2094),
    [sym_field_expression] = STATE(2094),
    [sym_compound_literal_expression] = STATE(2094),
    [sym_parenthesized_expression] = STATE(2094),
    [sym_char_literal] = STATE(2094),
    [sym_concatenated_string] = STATE(2094),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2094),
    [sym_new_expression] = STATE(2094),
    [sym_delete_expression] = STATE(2094),
    [sym_lambda_expression] = STATE(2094),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4532),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(4532),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4534),
    [sym_false] = ACTIONS(4534),
    [sym_null] = ACTIONS(4534),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(4534),
  },
  [1369] = {
    [anon_sym_else] = ACTIONS(2767),
    [anon_sym_while] = ACTIONS(2767),
    [sym_comment] = ACTIONS(91),
  },
  [1370] = {
    [sym_declaration] = STATE(2095),
    [sym_type_definition] = STATE(2095),
    [sym__declaration_specifiers] = STATE(1373),
    [sym_compound_statement] = STATE(2095),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_labeled_statement] = STATE(2095),
    [sym_expression_statement] = STATE(2095),
    [sym_if_statement] = STATE(2095),
    [sym_switch_statement] = STATE(2095),
    [sym_case_statement] = STATE(2095),
    [sym_while_statement] = STATE(2095),
    [sym_do_statement] = STATE(2095),
    [sym_for_statement] = STATE(2095),
    [sym_return_statement] = STATE(2095),
    [sym_break_statement] = STATE(2095),
    [sym_continue_statement] = STATE(2095),
    [sym_goto_statement] = STATE(2095),
    [sym__expression] = STATE(222),
    [sym_comma_expression] = STATE(223),
    [sym_conditional_expression] = STATE(222),
    [sym_assignment_expression] = STATE(222),
    [sym_pointer_expression] = STATE(222),
    [sym_logical_expression] = STATE(222),
    [sym_bitwise_expression] = STATE(222),
    [sym_equality_expression] = STATE(222),
    [sym_relational_expression] = STATE(222),
    [sym_shift_expression] = STATE(222),
    [sym_math_expression] = STATE(222),
    [sym_cast_expression] = STATE(222),
    [sym_sizeof_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_call_expression] = STATE(222),
    [sym_field_expression] = STATE(222),
    [sym_compound_literal_expression] = STATE(222),
    [sym_parenthesized_expression] = STATE(222),
    [sym_char_literal] = STATE(222),
    [sym_concatenated_string] = STATE(222),
    [sym_string_literal] = STATE(55),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(222),
    [sym_for_range_loop] = STATE(2095),
    [sym_try_statement] = STATE(2095),
    [sym_new_expression] = STATE(222),
    [sym_delete_expression] = STATE(222),
    [sym_lambda_expression] = STATE(222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_typedef] = ACTIONS(1023),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(359),
    [anon_sym_switch] = ACTIONS(361),
    [anon_sym_case] = ACTIONS(363),
    [anon_sym_default] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [anon_sym_do] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(373),
    [anon_sym_break] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_goto] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(353),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_identifier] = ACTIONS(2881),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(1202),
    [sym_nullptr] = ACTIONS(381),
  },
  [1371] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(1362),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_extern] = ACTIONS(468),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(465),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_register] = ACTIONS(468),
    [anon_sym_inline] = ACTIONS(468),
    [anon_sym_const] = ACTIONS(468),
    [anon_sym_restrict] = ACTIONS(468),
    [anon_sym_volatile] = ACTIONS(468),
    [anon_sym__Atomic] = ACTIONS(468),
    [anon_sym_mutable] = ACTIONS(468),
    [anon_sym_explicit] = ACTIONS(468),
    [anon_sym_constexpr] = ACTIONS(468),
    [anon_sym_COLON] = ACTIONS(1230),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(474),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_TILDE] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_identifier] = ACTIONS(468),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(2855),
    [sym_operator_name] = ACTIONS(481),
  },
  [1372] = {
    [anon_sym_else] = ACTIONS(2859),
    [anon_sym_while] = ACTIONS(2859),
    [sym_comment] = ACTIONS(91),
  },
  [1373] = {
    [sym__declarator] = STATE(2096),
    [sym_pointer_declarator] = STATE(2096),
    [sym_function_declarator] = STATE(2096),
    [sym_array_declarator] = STATE(2096),
    [sym_init_declarator] = STATE(2005),
    [sym_reference_declarator] = STATE(2096),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(2096),
    [sym_destructor_name] = STATE(2096),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(560),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(568),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(4536),
  },
  [1374] = {
    [anon_sym_else] = ACTIONS(2867),
    [anon_sym_while] = ACTIONS(2867),
    [sym_comment] = ACTIONS(91),
  },
  [1375] = {
    [sym_parenthesized_expression] = STATE(2098),
    [anon_sym_LPAREN2] = ACTIONS(4538),
    [sym_comment] = ACTIONS(91),
  },
  [1376] = {
    [sym__expression] = STATE(2100),
    [sym_conditional_expression] = STATE(2100),
    [sym_assignment_expression] = STATE(2100),
    [sym_pointer_expression] = STATE(2100),
    [sym_logical_expression] = STATE(2100),
    [sym_bitwise_expression] = STATE(2100),
    [sym_equality_expression] = STATE(2100),
    [sym_relational_expression] = STATE(2100),
    [sym_shift_expression] = STATE(2100),
    [sym_math_expression] = STATE(2100),
    [sym_cast_expression] = STATE(2100),
    [sym_sizeof_expression] = STATE(2100),
    [sym_subscript_expression] = STATE(2100),
    [sym_call_expression] = STATE(2100),
    [sym_field_expression] = STATE(2100),
    [sym_compound_literal_expression] = STATE(2100),
    [sym_parenthesized_expression] = STATE(2100),
    [sym_char_literal] = STATE(2100),
    [sym_concatenated_string] = STATE(2100),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2100),
    [sym_new_expression] = STATE(2100),
    [sym_delete_expression] = STATE(2100),
    [sym_lambda_expression] = STATE(2100),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4540),
    [anon_sym_SEMI] = ACTIONS(4542),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(4540),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4544),
    [sym_false] = ACTIONS(4544),
    [sym_null] = ACTIONS(4544),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(4544),
  },
  [1377] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(4546),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1378] = {
    [anon_sym_COLON] = ACTIONS(4548),
    [sym_comment] = ACTIONS(91),
  },
  [1379] = {
    [anon_sym_else] = ACTIONS(2999),
    [anon_sym_while] = ACTIONS(2999),
    [sym_comment] = ACTIONS(91),
  },
  [1380] = {
    [anon_sym_else] = ACTIONS(3047),
    [anon_sym_while] = ACTIONS(3047),
    [sym_comment] = ACTIONS(91),
  },
  [1381] = {
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [sym_comment] = ACTIONS(91),
  },
  [1382] = {
    [sym_parameter_list] = STATE(2103),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [sym_comment] = ACTIONS(91),
  },
  [1383] = {
    [sym_catch_clause] = STATE(2104),
    [aux_sym_try_statement_repeat1] = STATE(2104),
    [anon_sym_while] = ACTIONS(3346),
    [sym_comment] = ACTIONS(91),
    [anon_sym_catch] = ACTIONS(2895),
  },
  [1384] = {
    [sym__expression] = STATE(2105),
    [sym_comma_expression] = STATE(2106),
    [sym_conditional_expression] = STATE(2105),
    [sym_assignment_expression] = STATE(2105),
    [sym_pointer_expression] = STATE(2105),
    [sym_logical_expression] = STATE(2105),
    [sym_bitwise_expression] = STATE(2105),
    [sym_equality_expression] = STATE(2105),
    [sym_relational_expression] = STATE(2105),
    [sym_shift_expression] = STATE(2105),
    [sym_math_expression] = STATE(2105),
    [sym_cast_expression] = STATE(2105),
    [sym_sizeof_expression] = STATE(2105),
    [sym_subscript_expression] = STATE(2105),
    [sym_call_expression] = STATE(2105),
    [sym_field_expression] = STATE(2105),
    [sym_compound_literal_expression] = STATE(2105),
    [sym_parenthesized_expression] = STATE(2105),
    [sym_char_literal] = STATE(2105),
    [sym_concatenated_string] = STATE(2105),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2105),
    [sym_new_expression] = STATE(2105),
    [sym_delete_expression] = STATE(2105),
    [sym_lambda_expression] = STATE(2105),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4550),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(4550),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4552),
    [sym_false] = ACTIONS(4552),
    [sym_null] = ACTIONS(4552),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(4552),
  },
  [1385] = {
    [sym_raw_string_literal] = ACTIONS(4554),
    [ts_builtin_sym_end] = ACTIONS(4554),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4556),
    [sym_preproc_directive] = ACTIONS(4556),
    [anon_sym_SEMI] = ACTIONS(4554),
    [anon_sym_typedef] = ACTIONS(4556),
    [anon_sym_extern] = ACTIONS(4556),
    [anon_sym_LBRACE] = ACTIONS(4554),
    [anon_sym_RBRACE] = ACTIONS(4554),
    [anon_sym_LPAREN2] = ACTIONS(4554),
    [anon_sym_STAR] = ACTIONS(4554),
    [anon_sym_LBRACK] = ACTIONS(4554),
    [anon_sym_static] = ACTIONS(4556),
    [anon_sym_register] = ACTIONS(4556),
    [anon_sym_inline] = ACTIONS(4556),
    [anon_sym_const] = ACTIONS(4556),
    [anon_sym_restrict] = ACTIONS(4556),
    [anon_sym_volatile] = ACTIONS(4556),
    [anon_sym__Atomic] = ACTIONS(4556),
    [anon_sym_mutable] = ACTIONS(4556),
    [anon_sym_explicit] = ACTIONS(4556),
    [anon_sym_constexpr] = ACTIONS(4556),
    [anon_sym_unsigned] = ACTIONS(4556),
    [anon_sym_long] = ACTIONS(4556),
    [anon_sym_short] = ACTIONS(4556),
    [sym_primitive_type] = ACTIONS(4556),
    [anon_sym_enum] = ACTIONS(4556),
    [anon_sym_struct] = ACTIONS(4556),
    [anon_sym_union] = ACTIONS(4556),
    [anon_sym_if] = ACTIONS(4556),
    [anon_sym_else] = ACTIONS(4556),
    [anon_sym_switch] = ACTIONS(4556),
    [anon_sym_case] = ACTIONS(4556),
    [anon_sym_default] = ACTIONS(4556),
    [anon_sym_while] = ACTIONS(4556),
    [anon_sym_do] = ACTIONS(4556),
    [anon_sym_for] = ACTIONS(4556),
    [anon_sym_return] = ACTIONS(4556),
    [anon_sym_break] = ACTIONS(4556),
    [anon_sym_continue] = ACTIONS(4556),
    [anon_sym_goto] = ACTIONS(4556),
    [anon_sym_AMP] = ACTIONS(4556),
    [anon_sym_AMP_AMP] = ACTIONS(4554),
    [anon_sym_BANG] = ACTIONS(4554),
    [anon_sym_TILDE] = ACTIONS(4554),
    [anon_sym_PLUS] = ACTIONS(4556),
    [anon_sym_DASH] = ACTIONS(4556),
    [anon_sym_DASH_DASH] = ACTIONS(4554),
    [anon_sym_PLUS_PLUS] = ACTIONS(4554),
    [anon_sym_sizeof] = ACTIONS(4556),
    [sym_number_literal] = ACTIONS(4554),
    [anon_sym_SQUOTE] = ACTIONS(4554),
    [anon_sym_DQUOTE] = ACTIONS(4554),
    [sym_true] = ACTIONS(4556),
    [sym_false] = ACTIONS(4556),
    [sym_null] = ACTIONS(4556),
    [sym_identifier] = ACTIONS(4556),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4556),
    [sym_auto] = ACTIONS(4556),
    [anon_sym_typename] = ACTIONS(4556),
    [anon_sym_template] = ACTIONS(4556),
    [anon_sym_delete] = ACTIONS(4556),
    [anon_sym_namespace] = ACTIONS(4556),
    [anon_sym_using] = ACTIONS(4556),
    [anon_sym_try] = ACTIONS(4556),
    [anon_sym_new] = ACTIONS(4556),
    [anon_sym_COLON_COLON] = ACTIONS(4554),
    [sym_operator_name] = ACTIONS(4554),
    [sym_nullptr] = ACTIONS(4556),
  },
  [1386] = {
    [sym__expression] = STATE(2108),
    [sym_conditional_expression] = STATE(2108),
    [sym_assignment_expression] = STATE(2108),
    [sym_pointer_expression] = STATE(2108),
    [sym_logical_expression] = STATE(2108),
    [sym_bitwise_expression] = STATE(2108),
    [sym_equality_expression] = STATE(2108),
    [sym_relational_expression] = STATE(2108),
    [sym_shift_expression] = STATE(2108),
    [sym_math_expression] = STATE(2108),
    [sym_cast_expression] = STATE(2108),
    [sym_sizeof_expression] = STATE(2108),
    [sym_subscript_expression] = STATE(2108),
    [sym_call_expression] = STATE(2108),
    [sym_field_expression] = STATE(2108),
    [sym_compound_literal_expression] = STATE(2108),
    [sym_parenthesized_expression] = STATE(2108),
    [sym_char_literal] = STATE(2108),
    [sym_concatenated_string] = STATE(2108),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2108),
    [sym_new_expression] = STATE(2108),
    [sym_delete_expression] = STATE(2108),
    [sym_lambda_expression] = STATE(2108),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4558),
    [anon_sym_RPAREN] = ACTIONS(4560),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(4558),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4562),
    [sym_false] = ACTIONS(4562),
    [sym_null] = ACTIONS(4562),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(4562),
  },
  [1387] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(4564),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1388] = {
    [sym__declarator] = STATE(2110),
    [sym_pointer_declarator] = STATE(2110),
    [sym_function_declarator] = STATE(2110),
    [sym_array_declarator] = STATE(2110),
    [sym_type_qualifier] = STATE(2111),
    [sym_reference_declarator] = STATE(2110),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(2110),
    [sym_destructor_name] = STATE(2110),
    [sym_scoped_identifier] = STATE(1391),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [aux_sym_type_definition_repeat1] = STATE(2111),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(2905),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(2907),
    [anon_sym_AMP_AMP] = ACTIONS(2909),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(568),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(4566),
  },
  [1389] = {
    [sym__declarator] = STATE(2112),
    [sym_pointer_declarator] = STATE(2112),
    [sym_function_declarator] = STATE(2112),
    [sym_array_declarator] = STATE(2112),
    [sym_reference_declarator] = STATE(2112),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(2112),
    [sym_destructor_name] = STATE(2112),
    [sym_scoped_identifier] = STATE(1391),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(2905),
    [anon_sym_AMP] = ACTIONS(2907),
    [anon_sym_AMP_AMP] = ACTIONS(2909),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(568),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(4568),
  },
  [1390] = {
    [sym_parameter_list] = STATE(2113),
    [sym_argument_list] = STATE(898),
    [sym_initializer_list] = STATE(898),
    [aux_sym_declaration_repeat1] = STATE(1168),
    [anon_sym_COMMA] = ACTIONS(1613),
    [anon_sym_SEMI] = ACTIONS(2282),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(1619),
    [anon_sym_LBRACK] = ACTIONS(574),
    [anon_sym_EQ] = ACTIONS(1621),
    [anon_sym_COLON] = ACTIONS(4570),
    [sym_comment] = ACTIONS(91),
  },
  [1391] = {
    [sym_template_argument_list] = STATE(360),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_SEMI] = ACTIONS(576),
    [anon_sym_LBRACE] = ACTIONS(576),
    [anon_sym_LPAREN2] = ACTIONS(576),
    [anon_sym_LBRACK] = ACTIONS(576),
    [anon_sym_EQ] = ACTIONS(576),
    [anon_sym_COLON] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(4289),
    [sym_comment] = ACTIONS(91),
  },
  [1392] = {
    [sym__expression] = STATE(2114),
    [sym_conditional_expression] = STATE(2114),
    [sym_assignment_expression] = STATE(2114),
    [sym_pointer_expression] = STATE(2114),
    [sym_logical_expression] = STATE(2114),
    [sym_bitwise_expression] = STATE(2114),
    [sym_equality_expression] = STATE(2114),
    [sym_relational_expression] = STATE(2114),
    [sym_shift_expression] = STATE(2114),
    [sym_math_expression] = STATE(2114),
    [sym_cast_expression] = STATE(2114),
    [sym_sizeof_expression] = STATE(2114),
    [sym_subscript_expression] = STATE(2114),
    [sym_call_expression] = STATE(2114),
    [sym_field_expression] = STATE(2114),
    [sym_compound_literal_expression] = STATE(2114),
    [sym_parenthesized_expression] = STATE(2114),
    [sym_char_literal] = STATE(2114),
    [sym_concatenated_string] = STATE(2114),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2114),
    [sym_new_expression] = STATE(2114),
    [sym_delete_expression] = STATE(2114),
    [sym_lambda_expression] = STATE(2114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4572),
    [anon_sym_SEMI] = ACTIONS(4564),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(4572),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4574),
    [sym_false] = ACTIONS(4574),
    [sym_null] = ACTIONS(4574),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(4574),
  },
  [1393] = {
    [sym__expression] = STATE(2115),
    [sym_conditional_expression] = STATE(2115),
    [sym_assignment_expression] = STATE(2115),
    [sym_pointer_expression] = STATE(2115),
    [sym_logical_expression] = STATE(2115),
    [sym_bitwise_expression] = STATE(2115),
    [sym_equality_expression] = STATE(2115),
    [sym_relational_expression] = STATE(2115),
    [sym_shift_expression] = STATE(2115),
    [sym_math_expression] = STATE(2115),
    [sym_cast_expression] = STATE(2115),
    [sym_sizeof_expression] = STATE(2115),
    [sym_subscript_expression] = STATE(2115),
    [sym_call_expression] = STATE(2115),
    [sym_field_expression] = STATE(2115),
    [sym_compound_literal_expression] = STATE(2115),
    [sym_parenthesized_expression] = STATE(2115),
    [sym_char_literal] = STATE(2115),
    [sym_concatenated_string] = STATE(2115),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2115),
    [sym_new_expression] = STATE(2115),
    [sym_delete_expression] = STATE(2115),
    [sym_lambda_expression] = STATE(2115),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4576),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(4576),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4578),
    [sym_false] = ACTIONS(4578),
    [sym_null] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(4578),
  },
  [1394] = {
    [anon_sym_COMMA] = ACTIONS(4580),
    [anon_sym_RPAREN] = ACTIONS(4580),
    [anon_sym_SEMI] = ACTIONS(4580),
    [anon_sym_LBRACE] = ACTIONS(4580),
    [anon_sym_RBRACE] = ACTIONS(4580),
    [anon_sym_LPAREN2] = ACTIONS(4580),
    [anon_sym_STAR] = ACTIONS(4582),
    [anon_sym_LBRACK] = ACTIONS(4580),
    [anon_sym_RBRACK] = ACTIONS(4580),
    [anon_sym_EQ] = ACTIONS(4582),
    [anon_sym_COLON] = ACTIONS(4580),
    [anon_sym_QMARK] = ACTIONS(4580),
    [anon_sym_STAR_EQ] = ACTIONS(4580),
    [anon_sym_SLASH_EQ] = ACTIONS(4580),
    [anon_sym_PERCENT_EQ] = ACTIONS(4580),
    [anon_sym_PLUS_EQ] = ACTIONS(4580),
    [anon_sym_DASH_EQ] = ACTIONS(4580),
    [anon_sym_LT_LT_EQ] = ACTIONS(4580),
    [anon_sym_GT_GT_EQ] = ACTIONS(4580),
    [anon_sym_AMP_EQ] = ACTIONS(4580),
    [anon_sym_CARET_EQ] = ACTIONS(4580),
    [anon_sym_PIPE_EQ] = ACTIONS(4580),
    [anon_sym_AMP] = ACTIONS(4582),
    [anon_sym_PIPE_PIPE] = ACTIONS(4580),
    [anon_sym_AMP_AMP] = ACTIONS(4580),
    [anon_sym_PIPE] = ACTIONS(4582),
    [anon_sym_CARET] = ACTIONS(4582),
    [anon_sym_EQ_EQ] = ACTIONS(4580),
    [anon_sym_BANG_EQ] = ACTIONS(4580),
    [anon_sym_LT] = ACTIONS(4582),
    [anon_sym_GT] = ACTIONS(4582),
    [anon_sym_LT_EQ] = ACTIONS(4580),
    [anon_sym_GT_EQ] = ACTIONS(4580),
    [anon_sym_LT_LT] = ACTIONS(4582),
    [anon_sym_GT_GT] = ACTIONS(4582),
    [anon_sym_PLUS] = ACTIONS(4582),
    [anon_sym_DASH] = ACTIONS(4582),
    [anon_sym_SLASH] = ACTIONS(4582),
    [anon_sym_PERCENT] = ACTIONS(4582),
    [anon_sym_DASH_DASH] = ACTIONS(4580),
    [anon_sym_PLUS_PLUS] = ACTIONS(4580),
    [anon_sym_DOT] = ACTIONS(4580),
    [anon_sym_DASH_GT] = ACTIONS(4580),
    [sym_comment] = ACTIONS(91),
  },
  [1395] = {
    [anon_sym_RPAREN] = ACTIONS(4584),
    [sym_comment] = ACTIONS(91),
  },
  [1396] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(577),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(4586),
    [anon_sym_EQ] = ACTIONS(979),
    [anon_sym_QMARK] = ACTIONS(981),
    [anon_sym_STAR_EQ] = ACTIONS(983),
    [anon_sym_SLASH_EQ] = ACTIONS(983),
    [anon_sym_PERCENT_EQ] = ACTIONS(983),
    [anon_sym_PLUS_EQ] = ACTIONS(983),
    [anon_sym_DASH_EQ] = ACTIONS(983),
    [anon_sym_LT_LT_EQ] = ACTIONS(983),
    [anon_sym_GT_GT_EQ] = ACTIONS(983),
    [anon_sym_AMP_EQ] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(983),
    [anon_sym_PIPE_EQ] = ACTIONS(983),
    [anon_sym_AMP] = ACTIONS(985),
    [anon_sym_PIPE_PIPE] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(989),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_CARET] = ACTIONS(993),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(999),
    [anon_sym_LT_LT] = ACTIONS(1001),
    [anon_sym_GT_GT] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(975),
    [anon_sym_PERCENT] = ACTIONS(975),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1397] = {
    [sym_type_qualifier] = STATE(141),
    [sym__type_specifier] = STATE(136),
    [sym_sized_type_specifier] = STATE(136),
    [sym_enum_specifier] = STATE(136),
    [sym_struct_specifier] = STATE(136),
    [sym_union_specifier] = STATE(136),
    [sym__expression] = STATE(137),
    [sym_comma_expression] = STATE(138),
    [sym_conditional_expression] = STATE(137),
    [sym_assignment_expression] = STATE(137),
    [sym_pointer_expression] = STATE(137),
    [sym_logical_expression] = STATE(137),
    [sym_bitwise_expression] = STATE(137),
    [sym_equality_expression] = STATE(137),
    [sym_relational_expression] = STATE(137),
    [sym_shift_expression] = STATE(137),
    [sym_math_expression] = STATE(137),
    [sym_cast_expression] = STATE(137),
    [sym_type_descriptor] = STATE(2118),
    [sym_sizeof_expression] = STATE(137),
    [sym_subscript_expression] = STATE(137),
    [sym_call_expression] = STATE(137),
    [sym_field_expression] = STATE(137),
    [sym_compound_literal_expression] = STATE(137),
    [sym_parenthesized_expression] = STATE(137),
    [sym_char_literal] = STATE(137),
    [sym_concatenated_string] = STATE(137),
    [sym_string_literal] = STATE(140),
    [sym_macro_type_specifier] = STATE(136),
    [sym_class_specifier] = STATE(136),
    [sym_dependent_type] = STATE(136),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(137),
    [sym_new_expression] = STATE(137),
    [sym_delete_expression] = STATE(137),
    [sym_lambda_expression] = STATE(137),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_type_definition_repeat1] = STATE(141),
    [aux_sym_sized_type_specifier_repeat1] = STATE(142),
    [sym_raw_string_literal] = ACTIONS(213),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(219),
    [anon_sym_long] = ACTIONS(219),
    [anon_sym_short] = ACTIONS(219),
    [sym_primitive_type] = ACTIONS(221),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [sym_null] = ACTIONS(241),
    [sym_identifier] = ACTIONS(811),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(221),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(253),
    [sym_nullptr] = ACTIONS(241),
  },
  [1398] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(1364),
    [anon_sym_RBRACE] = ACTIONS(1364),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1366),
    [anon_sym_QMARK] = ACTIONS(1364),
    [anon_sym_STAR_EQ] = ACTIONS(1364),
    [anon_sym_SLASH_EQ] = ACTIONS(1364),
    [anon_sym_PERCENT_EQ] = ACTIONS(1364),
    [anon_sym_PLUS_EQ] = ACTIONS(1364),
    [anon_sym_DASH_EQ] = ACTIONS(1364),
    [anon_sym_LT_LT_EQ] = ACTIONS(1364),
    [anon_sym_GT_GT_EQ] = ACTIONS(1364),
    [anon_sym_AMP_EQ] = ACTIONS(1364),
    [anon_sym_CARET_EQ] = ACTIONS(1364),
    [anon_sym_PIPE_EQ] = ACTIONS(1364),
    [anon_sym_AMP] = ACTIONS(1366),
    [anon_sym_PIPE_PIPE] = ACTIONS(1364),
    [anon_sym_AMP_AMP] = ACTIONS(1364),
    [anon_sym_PIPE] = ACTIONS(1366),
    [anon_sym_CARET] = ACTIONS(1366),
    [anon_sym_EQ_EQ] = ACTIONS(1364),
    [anon_sym_BANG_EQ] = ACTIONS(1364),
    [anon_sym_LT] = ACTIONS(1366),
    [anon_sym_GT] = ACTIONS(1366),
    [anon_sym_LT_EQ] = ACTIONS(1364),
    [anon_sym_GT_EQ] = ACTIONS(1364),
    [anon_sym_LT_LT] = ACTIONS(2975),
    [anon_sym_GT_GT] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_SLASH] = ACTIONS(2951),
    [anon_sym_PERCENT] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1399] = {
    [anon_sym_LBRACK] = ACTIONS(4588),
    [anon_sym_EQ] = ACTIONS(4588),
    [anon_sym_DOT] = ACTIONS(4588),
    [sym_comment] = ACTIONS(91),
  },
  [1400] = {
    [sym__expression] = STATE(164),
    [sym_conditional_expression] = STATE(164),
    [sym_assignment_expression] = STATE(164),
    [sym_pointer_expression] = STATE(164),
    [sym_logical_expression] = STATE(164),
    [sym_bitwise_expression] = STATE(164),
    [sym_equality_expression] = STATE(164),
    [sym_relational_expression] = STATE(164),
    [sym_shift_expression] = STATE(164),
    [sym_math_expression] = STATE(164),
    [sym_cast_expression] = STATE(164),
    [sym_sizeof_expression] = STATE(164),
    [sym_subscript_expression] = STATE(164),
    [sym_call_expression] = STATE(164),
    [sym_field_expression] = STATE(164),
    [sym_compound_literal_expression] = STATE(164),
    [sym_parenthesized_expression] = STATE(164),
    [sym_char_literal] = STATE(164),
    [sym_concatenated_string] = STATE(164),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(164),
    [sym_new_expression] = STATE(164),
    [sym_delete_expression] = STATE(164),
    [sym_lambda_expression] = STATE(164),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_lambda_default_capture] = STATE(166),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(267),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(4590),
    [anon_sym_EQ] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(267),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(289),
    [sym_false] = ACTIONS(289),
    [sym_null] = ACTIONS(289),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(289),
  },
  [1401] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(1489),
    [anon_sym_RBRACE] = ACTIONS(1489),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1491),
    [anon_sym_QMARK] = ACTIONS(1489),
    [anon_sym_STAR_EQ] = ACTIONS(1489),
    [anon_sym_SLASH_EQ] = ACTIONS(1489),
    [anon_sym_PERCENT_EQ] = ACTIONS(1489),
    [anon_sym_PLUS_EQ] = ACTIONS(1489),
    [anon_sym_DASH_EQ] = ACTIONS(1489),
    [anon_sym_LT_LT_EQ] = ACTIONS(1489),
    [anon_sym_GT_GT_EQ] = ACTIONS(1489),
    [anon_sym_AMP_EQ] = ACTIONS(1489),
    [anon_sym_CARET_EQ] = ACTIONS(1489),
    [anon_sym_PIPE_EQ] = ACTIONS(1489),
    [anon_sym_AMP] = ACTIONS(2959),
    [anon_sym_PIPE_PIPE] = ACTIONS(2961),
    [anon_sym_AMP_AMP] = ACTIONS(2963),
    [anon_sym_PIPE] = ACTIONS(2965),
    [anon_sym_CARET] = ACTIONS(2967),
    [anon_sym_EQ_EQ] = ACTIONS(2969),
    [anon_sym_BANG_EQ] = ACTIONS(2969),
    [anon_sym_LT] = ACTIONS(2971),
    [anon_sym_GT] = ACTIONS(2971),
    [anon_sym_LT_EQ] = ACTIONS(2973),
    [anon_sym_GT_EQ] = ACTIONS(2973),
    [anon_sym_LT_LT] = ACTIONS(2975),
    [anon_sym_GT_GT] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_SLASH] = ACTIONS(2951),
    [anon_sym_PERCENT] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1402] = {
    [sym__type_specifier] = STATE(871),
    [sym_sized_type_specifier] = STATE(871),
    [sym_enum_specifier] = STATE(871),
    [sym_struct_specifier] = STATE(871),
    [sym_union_specifier] = STATE(871),
    [sym_macro_type_specifier] = STATE(871),
    [sym_class_specifier] = STATE(871),
    [sym_dependent_type] = STATE(871),
    [sym_template_type] = STATE(309),
    [sym_scoped_type_identifier] = STATE(310),
    [sym_scoped_namespace_identifier] = STATE(311),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1405),
    [anon_sym_unsigned] = ACTIONS(2941),
    [anon_sym_long] = ACTIONS(2941),
    [anon_sym_short] = ACTIONS(2941),
    [sym_primitive_type] = ACTIONS(1552),
    [anon_sym_enum] = ACTIONS(536),
    [anon_sym_struct] = ACTIONS(538),
    [anon_sym_union] = ACTIONS(540),
    [sym_identifier] = ACTIONS(542),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(544),
    [sym_auto] = ACTIONS(1552),
    [anon_sym_typename] = ACTIONS(2945),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [1403] = {
    [sym_argument_list] = STATE(874),
    [sym_initializer_list] = STATE(874),
    [sym_new_declarator] = STATE(875),
    [anon_sym_COMMA] = ACTIONS(1556),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_RBRACE] = ACTIONS(1556),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1558),
    [anon_sym_LBRACK] = ACTIONS(4592),
    [anon_sym_EQ] = ACTIONS(1558),
    [anon_sym_QMARK] = ACTIONS(1556),
    [anon_sym_STAR_EQ] = ACTIONS(1556),
    [anon_sym_SLASH_EQ] = ACTIONS(1556),
    [anon_sym_PERCENT_EQ] = ACTIONS(1556),
    [anon_sym_PLUS_EQ] = ACTIONS(1556),
    [anon_sym_DASH_EQ] = ACTIONS(1556),
    [anon_sym_LT_LT_EQ] = ACTIONS(1556),
    [anon_sym_GT_GT_EQ] = ACTIONS(1556),
    [anon_sym_AMP_EQ] = ACTIONS(1556),
    [anon_sym_CARET_EQ] = ACTIONS(1556),
    [anon_sym_PIPE_EQ] = ACTIONS(1556),
    [anon_sym_AMP] = ACTIONS(1558),
    [anon_sym_PIPE_PIPE] = ACTIONS(1556),
    [anon_sym_AMP_AMP] = ACTIONS(1556),
    [anon_sym_PIPE] = ACTIONS(1558),
    [anon_sym_CARET] = ACTIONS(1558),
    [anon_sym_EQ_EQ] = ACTIONS(1556),
    [anon_sym_BANG_EQ] = ACTIONS(1556),
    [anon_sym_LT] = ACTIONS(1558),
    [anon_sym_GT] = ACTIONS(1558),
    [anon_sym_LT_EQ] = ACTIONS(1556),
    [anon_sym_GT_EQ] = ACTIONS(1556),
    [anon_sym_LT_LT] = ACTIONS(1558),
    [anon_sym_GT_GT] = ACTIONS(1558),
    [anon_sym_PLUS] = ACTIONS(1558),
    [anon_sym_DASH] = ACTIONS(1558),
    [anon_sym_SLASH] = ACTIONS(1558),
    [anon_sym_PERCENT] = ACTIONS(1558),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DOT] = ACTIONS(1556),
    [anon_sym_DASH_GT] = ACTIONS(1556),
    [sym_comment] = ACTIONS(91),
  },
  [1404] = {
    [sym__type_specifier] = STATE(2121),
    [sym_sized_type_specifier] = STATE(2121),
    [sym_enum_specifier] = STATE(2121),
    [sym_struct_specifier] = STATE(2121),
    [sym_union_specifier] = STATE(2121),
    [sym_macro_type_specifier] = STATE(2121),
    [sym_class_specifier] = STATE(2121),
    [sym_dependent_type] = STATE(2121),
    [sym_template_type] = STATE(309),
    [sym_scoped_type_identifier] = STATE(310),
    [sym_scoped_namespace_identifier] = STATE(311),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1405),
    [anon_sym_unsigned] = ACTIONS(2941),
    [anon_sym_long] = ACTIONS(2941),
    [anon_sym_short] = ACTIONS(2941),
    [sym_primitive_type] = ACTIONS(4594),
    [anon_sym_enum] = ACTIONS(536),
    [anon_sym_struct] = ACTIONS(538),
    [anon_sym_union] = ACTIONS(540),
    [sym_identifier] = ACTIONS(542),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(544),
    [sym_auto] = ACTIONS(4594),
    [anon_sym_typename] = ACTIONS(2945),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [1405] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2122),
    [anon_sym_COMMA] = ACTIONS(653),
    [anon_sym_LBRACE] = ACTIONS(653),
    [anon_sym_RBRACE] = ACTIONS(653),
    [anon_sym_LPAREN2] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_EQ] = ACTIONS(655),
    [anon_sym_unsigned] = ACTIONS(4596),
    [anon_sym_long] = ACTIONS(4596),
    [anon_sym_short] = ACTIONS(4596),
    [sym_primitive_type] = ACTIONS(1571),
    [anon_sym_QMARK] = ACTIONS(653),
    [anon_sym_STAR_EQ] = ACTIONS(653),
    [anon_sym_SLASH_EQ] = ACTIONS(653),
    [anon_sym_PERCENT_EQ] = ACTIONS(653),
    [anon_sym_PLUS_EQ] = ACTIONS(653),
    [anon_sym_DASH_EQ] = ACTIONS(653),
    [anon_sym_LT_LT_EQ] = ACTIONS(653),
    [anon_sym_GT_GT_EQ] = ACTIONS(653),
    [anon_sym_AMP_EQ] = ACTIONS(653),
    [anon_sym_CARET_EQ] = ACTIONS(653),
    [anon_sym_PIPE_EQ] = ACTIONS(653),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_PIPE_PIPE] = ACTIONS(653),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(655),
    [anon_sym_EQ_EQ] = ACTIONS(653),
    [anon_sym_BANG_EQ] = ACTIONS(653),
    [anon_sym_LT] = ACTIONS(655),
    [anon_sym_GT] = ACTIONS(655),
    [anon_sym_LT_EQ] = ACTIONS(653),
    [anon_sym_GT_EQ] = ACTIONS(653),
    [anon_sym_LT_LT] = ACTIONS(655),
    [anon_sym_GT_GT] = ACTIONS(655),
    [anon_sym_PLUS] = ACTIONS(655),
    [anon_sym_DASH] = ACTIONS(655),
    [anon_sym_SLASH] = ACTIONS(655),
    [anon_sym_PERCENT] = ACTIONS(655),
    [anon_sym_DASH_DASH] = ACTIONS(653),
    [anon_sym_PLUS_PLUS] = ACTIONS(653),
    [anon_sym_DOT] = ACTIONS(653),
    [anon_sym_DASH_GT] = ACTIONS(653),
    [sym_identifier] = ACTIONS(1573),
    [sym_comment] = ACTIONS(91),
  },
  [1406] = {
    [sym__expression] = STATE(2124),
    [sym_conditional_expression] = STATE(2124),
    [sym_assignment_expression] = STATE(2124),
    [sym_pointer_expression] = STATE(2124),
    [sym_logical_expression] = STATE(2124),
    [sym_bitwise_expression] = STATE(2124),
    [sym_equality_expression] = STATE(2124),
    [sym_relational_expression] = STATE(2124),
    [sym_shift_expression] = STATE(2124),
    [sym_math_expression] = STATE(2124),
    [sym_cast_expression] = STATE(2124),
    [sym_sizeof_expression] = STATE(2124),
    [sym_subscript_expression] = STATE(2124),
    [sym_call_expression] = STATE(2124),
    [sym_field_expression] = STATE(2124),
    [sym_compound_literal_expression] = STATE(2124),
    [sym_parenthesized_expression] = STATE(2124),
    [sym_char_literal] = STATE(2124),
    [sym_concatenated_string] = STATE(2124),
    [sym_string_literal] = STATE(727),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2124),
    [sym_new_expression] = STATE(2124),
    [sym_delete_expression] = STATE(2124),
    [sym_lambda_expression] = STATE(2124),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4598),
    [anon_sym_LPAREN2] = ACTIONS(1256),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_LBRACK] = ACTIONS(4600),
    [anon_sym_AMP] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(1262),
    [anon_sym_TILDE] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_DASH_DASH] = ACTIONS(1268),
    [anon_sym_PLUS_PLUS] = ACTIONS(1268),
    [anon_sym_sizeof] = ACTIONS(1270),
    [sym_number_literal] = ACTIONS(4598),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4602),
    [sym_false] = ACTIONS(4602),
    [sym_null] = ACTIONS(4602),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1276),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1280),
    [sym_nullptr] = ACTIONS(4602),
  },
  [1407] = {
    [sym__expression] = STATE(2126),
    [sym_conditional_expression] = STATE(2126),
    [sym_assignment_expression] = STATE(2126),
    [sym_pointer_expression] = STATE(2126),
    [sym_logical_expression] = STATE(2126),
    [sym_bitwise_expression] = STATE(2126),
    [sym_equality_expression] = STATE(2126),
    [sym_relational_expression] = STATE(2126),
    [sym_shift_expression] = STATE(2126),
    [sym_math_expression] = STATE(2126),
    [sym_cast_expression] = STATE(2126),
    [sym_sizeof_expression] = STATE(2126),
    [sym_subscript_expression] = STATE(2126),
    [sym_call_expression] = STATE(2126),
    [sym_field_expression] = STATE(2126),
    [sym_compound_literal_expression] = STATE(2126),
    [sym_parenthesized_expression] = STATE(2126),
    [sym_initializer_list] = STATE(2127),
    [sym_initializer_pair] = STATE(2127),
    [sym_subscript_designator] = STATE(728),
    [sym_field_designator] = STATE(728),
    [sym_char_literal] = STATE(2126),
    [sym_concatenated_string] = STATE(2126),
    [sym_string_literal] = STATE(727),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2126),
    [sym_new_expression] = STATE(2126),
    [sym_delete_expression] = STATE(2126),
    [sym_lambda_expression] = STATE(2126),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [aux_sym_initializer_pair_repeat1] = STATE(728),
    [sym_raw_string_literal] = ACTIONS(4604),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_RBRACE] = ACTIONS(4606),
    [anon_sym_LPAREN2] = ACTIONS(1256),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_LBRACK] = ACTIONS(1260),
    [anon_sym_AMP] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(1262),
    [anon_sym_TILDE] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_DASH_DASH] = ACTIONS(1268),
    [anon_sym_PLUS_PLUS] = ACTIONS(1268),
    [anon_sym_sizeof] = ACTIONS(1270),
    [anon_sym_DOT] = ACTIONS(1272),
    [sym_number_literal] = ACTIONS(4604),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4608),
    [sym_false] = ACTIONS(4608),
    [sym_null] = ACTIONS(4608),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1276),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1280),
    [sym_nullptr] = ACTIONS(4608),
  },
  [1408] = {
    [sym__expression] = STATE(938),
    [sym_conditional_expression] = STATE(938),
    [sym_assignment_expression] = STATE(938),
    [sym_pointer_expression] = STATE(938),
    [sym_logical_expression] = STATE(938),
    [sym_bitwise_expression] = STATE(938),
    [sym_equality_expression] = STATE(938),
    [sym_relational_expression] = STATE(938),
    [sym_shift_expression] = STATE(938),
    [sym_math_expression] = STATE(938),
    [sym_cast_expression] = STATE(938),
    [sym_sizeof_expression] = STATE(938),
    [sym_subscript_expression] = STATE(938),
    [sym_call_expression] = STATE(938),
    [sym_field_expression] = STATE(938),
    [sym_compound_literal_expression] = STATE(938),
    [sym_parenthesized_expression] = STATE(938),
    [sym_char_literal] = STATE(938),
    [sym_concatenated_string] = STATE(938),
    [sym_string_literal] = STATE(727),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(938),
    [sym_new_expression] = STATE(938),
    [sym_delete_expression] = STATE(938),
    [sym_lambda_expression] = STATE(938),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(1701),
    [anon_sym_LPAREN2] = ACTIONS(1256),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(1262),
    [anon_sym_TILDE] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_DASH_DASH] = ACTIONS(1268),
    [anon_sym_PLUS_PLUS] = ACTIONS(1268),
    [anon_sym_sizeof] = ACTIONS(1270),
    [sym_number_literal] = ACTIONS(1701),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(1703),
    [sym_false] = ACTIONS(1703),
    [sym_null] = ACTIONS(1703),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1276),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1280),
    [sym_nullptr] = ACTIONS(1703),
  },
  [1409] = {
    [sym__expression] = STATE(2128),
    [sym_conditional_expression] = STATE(2128),
    [sym_assignment_expression] = STATE(2128),
    [sym_pointer_expression] = STATE(2128),
    [sym_logical_expression] = STATE(2128),
    [sym_bitwise_expression] = STATE(2128),
    [sym_equality_expression] = STATE(2128),
    [sym_relational_expression] = STATE(2128),
    [sym_shift_expression] = STATE(2128),
    [sym_math_expression] = STATE(2128),
    [sym_cast_expression] = STATE(2128),
    [sym_sizeof_expression] = STATE(2128),
    [sym_subscript_expression] = STATE(2128),
    [sym_call_expression] = STATE(2128),
    [sym_field_expression] = STATE(2128),
    [sym_compound_literal_expression] = STATE(2128),
    [sym_parenthesized_expression] = STATE(2128),
    [sym_char_literal] = STATE(2128),
    [sym_concatenated_string] = STATE(2128),
    [sym_string_literal] = STATE(727),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2128),
    [sym_new_expression] = STATE(2128),
    [sym_delete_expression] = STATE(2128),
    [sym_lambda_expression] = STATE(2128),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4610),
    [anon_sym_LPAREN2] = ACTIONS(1256),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(1262),
    [anon_sym_TILDE] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_DASH_DASH] = ACTIONS(1268),
    [anon_sym_PLUS_PLUS] = ACTIONS(1268),
    [anon_sym_sizeof] = ACTIONS(1270),
    [sym_number_literal] = ACTIONS(4610),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4612),
    [sym_false] = ACTIONS(4612),
    [sym_null] = ACTIONS(4612),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1276),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1280),
    [sym_nullptr] = ACTIONS(4612),
  },
  [1410] = {
    [sym__expression] = STATE(2129),
    [sym_conditional_expression] = STATE(2129),
    [sym_assignment_expression] = STATE(2129),
    [sym_pointer_expression] = STATE(2129),
    [sym_logical_expression] = STATE(2129),
    [sym_bitwise_expression] = STATE(2129),
    [sym_equality_expression] = STATE(2129),
    [sym_relational_expression] = STATE(2129),
    [sym_shift_expression] = STATE(2129),
    [sym_math_expression] = STATE(2129),
    [sym_cast_expression] = STATE(2129),
    [sym_sizeof_expression] = STATE(2129),
    [sym_subscript_expression] = STATE(2129),
    [sym_call_expression] = STATE(2129),
    [sym_field_expression] = STATE(2129),
    [sym_compound_literal_expression] = STATE(2129),
    [sym_parenthesized_expression] = STATE(2129),
    [sym_char_literal] = STATE(2129),
    [sym_concatenated_string] = STATE(2129),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2129),
    [sym_new_expression] = STATE(2129),
    [sym_delete_expression] = STATE(2129),
    [sym_lambda_expression] = STATE(2129),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4614),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(4614),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(4616),
    [sym_false] = ACTIONS(4616),
    [sym_null] = ACTIONS(4616),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(4616),
  },
  [1411] = {
    [sym__expression] = STATE(2130),
    [sym_conditional_expression] = STATE(2130),
    [sym_assignment_expression] = STATE(2130),
    [sym_pointer_expression] = STATE(2130),
    [sym_logical_expression] = STATE(2130),
    [sym_bitwise_expression] = STATE(2130),
    [sym_equality_expression] = STATE(2130),
    [sym_relational_expression] = STATE(2130),
    [sym_shift_expression] = STATE(2130),
    [sym_math_expression] = STATE(2130),
    [sym_cast_expression] = STATE(2130),
    [sym_sizeof_expression] = STATE(2130),
    [sym_subscript_expression] = STATE(2130),
    [sym_call_expression] = STATE(2130),
    [sym_field_expression] = STATE(2130),
    [sym_compound_literal_expression] = STATE(2130),
    [sym_parenthesized_expression] = STATE(2130),
    [sym_char_literal] = STATE(2130),
    [sym_concatenated_string] = STATE(2130),
    [sym_string_literal] = STATE(727),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2130),
    [sym_new_expression] = STATE(2130),
    [sym_delete_expression] = STATE(2130),
    [sym_lambda_expression] = STATE(2130),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4618),
    [anon_sym_LPAREN2] = ACTIONS(1256),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(1262),
    [anon_sym_TILDE] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_DASH_DASH] = ACTIONS(1268),
    [anon_sym_PLUS_PLUS] = ACTIONS(1268),
    [anon_sym_sizeof] = ACTIONS(1270),
    [sym_number_literal] = ACTIONS(4618),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4620),
    [sym_false] = ACTIONS(4620),
    [sym_null] = ACTIONS(4620),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1276),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1280),
    [sym_nullptr] = ACTIONS(4620),
  },
  [1412] = {
    [sym__expression] = STATE(2131),
    [sym_conditional_expression] = STATE(2131),
    [sym_assignment_expression] = STATE(2131),
    [sym_pointer_expression] = STATE(2131),
    [sym_logical_expression] = STATE(2131),
    [sym_bitwise_expression] = STATE(2131),
    [sym_equality_expression] = STATE(2131),
    [sym_relational_expression] = STATE(2131),
    [sym_shift_expression] = STATE(2131),
    [sym_math_expression] = STATE(2131),
    [sym_cast_expression] = STATE(2131),
    [sym_sizeof_expression] = STATE(2131),
    [sym_subscript_expression] = STATE(2131),
    [sym_call_expression] = STATE(2131),
    [sym_field_expression] = STATE(2131),
    [sym_compound_literal_expression] = STATE(2131),
    [sym_parenthesized_expression] = STATE(2131),
    [sym_char_literal] = STATE(2131),
    [sym_concatenated_string] = STATE(2131),
    [sym_string_literal] = STATE(727),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2131),
    [sym_new_expression] = STATE(2131),
    [sym_delete_expression] = STATE(2131),
    [sym_lambda_expression] = STATE(2131),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4622),
    [anon_sym_LPAREN2] = ACTIONS(1256),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(1262),
    [anon_sym_TILDE] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_DASH_DASH] = ACTIONS(1268),
    [anon_sym_PLUS_PLUS] = ACTIONS(1268),
    [anon_sym_sizeof] = ACTIONS(1270),
    [sym_number_literal] = ACTIONS(4622),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4624),
    [sym_false] = ACTIONS(4624),
    [sym_null] = ACTIONS(4624),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1276),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1280),
    [sym_nullptr] = ACTIONS(4624),
  },
  [1413] = {
    [sym__expression] = STATE(2132),
    [sym_conditional_expression] = STATE(2132),
    [sym_assignment_expression] = STATE(2132),
    [sym_pointer_expression] = STATE(2132),
    [sym_logical_expression] = STATE(2132),
    [sym_bitwise_expression] = STATE(2132),
    [sym_equality_expression] = STATE(2132),
    [sym_relational_expression] = STATE(2132),
    [sym_shift_expression] = STATE(2132),
    [sym_math_expression] = STATE(2132),
    [sym_cast_expression] = STATE(2132),
    [sym_sizeof_expression] = STATE(2132),
    [sym_subscript_expression] = STATE(2132),
    [sym_call_expression] = STATE(2132),
    [sym_field_expression] = STATE(2132),
    [sym_compound_literal_expression] = STATE(2132),
    [sym_parenthesized_expression] = STATE(2132),
    [sym_char_literal] = STATE(2132),
    [sym_concatenated_string] = STATE(2132),
    [sym_string_literal] = STATE(727),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2132),
    [sym_new_expression] = STATE(2132),
    [sym_delete_expression] = STATE(2132),
    [sym_lambda_expression] = STATE(2132),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4626),
    [anon_sym_LPAREN2] = ACTIONS(1256),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(1262),
    [anon_sym_TILDE] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_DASH_DASH] = ACTIONS(1268),
    [anon_sym_PLUS_PLUS] = ACTIONS(1268),
    [anon_sym_sizeof] = ACTIONS(1270),
    [sym_number_literal] = ACTIONS(4626),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4628),
    [sym_false] = ACTIONS(4628),
    [sym_null] = ACTIONS(4628),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1276),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1280),
    [sym_nullptr] = ACTIONS(4628),
  },
  [1414] = {
    [sym__expression] = STATE(2133),
    [sym_conditional_expression] = STATE(2133),
    [sym_assignment_expression] = STATE(2133),
    [sym_pointer_expression] = STATE(2133),
    [sym_logical_expression] = STATE(2133),
    [sym_bitwise_expression] = STATE(2133),
    [sym_equality_expression] = STATE(2133),
    [sym_relational_expression] = STATE(2133),
    [sym_shift_expression] = STATE(2133),
    [sym_math_expression] = STATE(2133),
    [sym_cast_expression] = STATE(2133),
    [sym_sizeof_expression] = STATE(2133),
    [sym_subscript_expression] = STATE(2133),
    [sym_call_expression] = STATE(2133),
    [sym_field_expression] = STATE(2133),
    [sym_compound_literal_expression] = STATE(2133),
    [sym_parenthesized_expression] = STATE(2133),
    [sym_char_literal] = STATE(2133),
    [sym_concatenated_string] = STATE(2133),
    [sym_string_literal] = STATE(727),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2133),
    [sym_new_expression] = STATE(2133),
    [sym_delete_expression] = STATE(2133),
    [sym_lambda_expression] = STATE(2133),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4630),
    [anon_sym_LPAREN2] = ACTIONS(1256),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(1262),
    [anon_sym_TILDE] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_DASH_DASH] = ACTIONS(1268),
    [anon_sym_PLUS_PLUS] = ACTIONS(1268),
    [anon_sym_sizeof] = ACTIONS(1270),
    [sym_number_literal] = ACTIONS(4630),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4632),
    [sym_false] = ACTIONS(4632),
    [sym_null] = ACTIONS(4632),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1276),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1280),
    [sym_nullptr] = ACTIONS(4632),
  },
  [1415] = {
    [sym__expression] = STATE(2134),
    [sym_conditional_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(2134),
    [sym_pointer_expression] = STATE(2134),
    [sym_logical_expression] = STATE(2134),
    [sym_bitwise_expression] = STATE(2134),
    [sym_equality_expression] = STATE(2134),
    [sym_relational_expression] = STATE(2134),
    [sym_shift_expression] = STATE(2134),
    [sym_math_expression] = STATE(2134),
    [sym_cast_expression] = STATE(2134),
    [sym_sizeof_expression] = STATE(2134),
    [sym_subscript_expression] = STATE(2134),
    [sym_call_expression] = STATE(2134),
    [sym_field_expression] = STATE(2134),
    [sym_compound_literal_expression] = STATE(2134),
    [sym_parenthesized_expression] = STATE(2134),
    [sym_char_literal] = STATE(2134),
    [sym_concatenated_string] = STATE(2134),
    [sym_string_literal] = STATE(727),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2134),
    [sym_new_expression] = STATE(2134),
    [sym_delete_expression] = STATE(2134),
    [sym_lambda_expression] = STATE(2134),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4634),
    [anon_sym_LPAREN2] = ACTIONS(1256),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(1262),
    [anon_sym_TILDE] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_DASH_DASH] = ACTIONS(1268),
    [anon_sym_PLUS_PLUS] = ACTIONS(1268),
    [anon_sym_sizeof] = ACTIONS(1270),
    [sym_number_literal] = ACTIONS(4634),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4636),
    [sym_false] = ACTIONS(4636),
    [sym_null] = ACTIONS(4636),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1276),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1280),
    [sym_nullptr] = ACTIONS(4636),
  },
  [1416] = {
    [sym__expression] = STATE(2135),
    [sym_conditional_expression] = STATE(2135),
    [sym_assignment_expression] = STATE(2135),
    [sym_pointer_expression] = STATE(2135),
    [sym_logical_expression] = STATE(2135),
    [sym_bitwise_expression] = STATE(2135),
    [sym_equality_expression] = STATE(2135),
    [sym_relational_expression] = STATE(2135),
    [sym_shift_expression] = STATE(2135),
    [sym_math_expression] = STATE(2135),
    [sym_cast_expression] = STATE(2135),
    [sym_sizeof_expression] = STATE(2135),
    [sym_subscript_expression] = STATE(2135),
    [sym_call_expression] = STATE(2135),
    [sym_field_expression] = STATE(2135),
    [sym_compound_literal_expression] = STATE(2135),
    [sym_parenthesized_expression] = STATE(2135),
    [sym_char_literal] = STATE(2135),
    [sym_concatenated_string] = STATE(2135),
    [sym_string_literal] = STATE(727),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2135),
    [sym_new_expression] = STATE(2135),
    [sym_delete_expression] = STATE(2135),
    [sym_lambda_expression] = STATE(2135),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4638),
    [anon_sym_LPAREN2] = ACTIONS(1256),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(1262),
    [anon_sym_TILDE] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_DASH_DASH] = ACTIONS(1268),
    [anon_sym_PLUS_PLUS] = ACTIONS(1268),
    [anon_sym_sizeof] = ACTIONS(1270),
    [sym_number_literal] = ACTIONS(4638),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4640),
    [sym_false] = ACTIONS(4640),
    [sym_null] = ACTIONS(4640),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1276),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1280),
    [sym_nullptr] = ACTIONS(4640),
  },
  [1417] = {
    [sym__expression] = STATE(2136),
    [sym_conditional_expression] = STATE(2136),
    [sym_assignment_expression] = STATE(2136),
    [sym_pointer_expression] = STATE(2136),
    [sym_logical_expression] = STATE(2136),
    [sym_bitwise_expression] = STATE(2136),
    [sym_equality_expression] = STATE(2136),
    [sym_relational_expression] = STATE(2136),
    [sym_shift_expression] = STATE(2136),
    [sym_math_expression] = STATE(2136),
    [sym_cast_expression] = STATE(2136),
    [sym_sizeof_expression] = STATE(2136),
    [sym_subscript_expression] = STATE(2136),
    [sym_call_expression] = STATE(2136),
    [sym_field_expression] = STATE(2136),
    [sym_compound_literal_expression] = STATE(2136),
    [sym_parenthesized_expression] = STATE(2136),
    [sym_char_literal] = STATE(2136),
    [sym_concatenated_string] = STATE(2136),
    [sym_string_literal] = STATE(727),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2136),
    [sym_new_expression] = STATE(2136),
    [sym_delete_expression] = STATE(2136),
    [sym_lambda_expression] = STATE(2136),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4642),
    [anon_sym_LPAREN2] = ACTIONS(1256),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(1262),
    [anon_sym_TILDE] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_DASH_DASH] = ACTIONS(1268),
    [anon_sym_PLUS_PLUS] = ACTIONS(1268),
    [anon_sym_sizeof] = ACTIONS(1270),
    [sym_number_literal] = ACTIONS(4642),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4644),
    [sym_false] = ACTIONS(4644),
    [sym_null] = ACTIONS(4644),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1276),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1280),
    [sym_nullptr] = ACTIONS(4644),
  },
  [1418] = {
    [sym__expression] = STATE(2137),
    [sym_conditional_expression] = STATE(2137),
    [sym_assignment_expression] = STATE(2137),
    [sym_pointer_expression] = STATE(2137),
    [sym_logical_expression] = STATE(2137),
    [sym_bitwise_expression] = STATE(2137),
    [sym_equality_expression] = STATE(2137),
    [sym_relational_expression] = STATE(2137),
    [sym_shift_expression] = STATE(2137),
    [sym_math_expression] = STATE(2137),
    [sym_cast_expression] = STATE(2137),
    [sym_sizeof_expression] = STATE(2137),
    [sym_subscript_expression] = STATE(2137),
    [sym_call_expression] = STATE(2137),
    [sym_field_expression] = STATE(2137),
    [sym_compound_literal_expression] = STATE(2137),
    [sym_parenthesized_expression] = STATE(2137),
    [sym_char_literal] = STATE(2137),
    [sym_concatenated_string] = STATE(2137),
    [sym_string_literal] = STATE(727),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2137),
    [sym_new_expression] = STATE(2137),
    [sym_delete_expression] = STATE(2137),
    [sym_lambda_expression] = STATE(2137),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4646),
    [anon_sym_LPAREN2] = ACTIONS(1256),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(1262),
    [anon_sym_TILDE] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_DASH_DASH] = ACTIONS(1268),
    [anon_sym_PLUS_PLUS] = ACTIONS(1268),
    [anon_sym_sizeof] = ACTIONS(1270),
    [sym_number_literal] = ACTIONS(4646),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4648),
    [sym_false] = ACTIONS(4648),
    [sym_null] = ACTIONS(4648),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1276),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1280),
    [sym_nullptr] = ACTIONS(4648),
  },
  [1419] = {
    [sym__expression] = STATE(2138),
    [sym_conditional_expression] = STATE(2138),
    [sym_assignment_expression] = STATE(2138),
    [sym_pointer_expression] = STATE(2138),
    [sym_logical_expression] = STATE(2138),
    [sym_bitwise_expression] = STATE(2138),
    [sym_equality_expression] = STATE(2138),
    [sym_relational_expression] = STATE(2138),
    [sym_shift_expression] = STATE(2138),
    [sym_math_expression] = STATE(2138),
    [sym_cast_expression] = STATE(2138),
    [sym_sizeof_expression] = STATE(2138),
    [sym_subscript_expression] = STATE(2138),
    [sym_call_expression] = STATE(2138),
    [sym_field_expression] = STATE(2138),
    [sym_compound_literal_expression] = STATE(2138),
    [sym_parenthesized_expression] = STATE(2138),
    [sym_char_literal] = STATE(2138),
    [sym_concatenated_string] = STATE(2138),
    [sym_string_literal] = STATE(727),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2138),
    [sym_new_expression] = STATE(2138),
    [sym_delete_expression] = STATE(2138),
    [sym_lambda_expression] = STATE(2138),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4650),
    [anon_sym_LPAREN2] = ACTIONS(1256),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(1262),
    [anon_sym_TILDE] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_DASH_DASH] = ACTIONS(1268),
    [anon_sym_PLUS_PLUS] = ACTIONS(1268),
    [anon_sym_sizeof] = ACTIONS(1270),
    [sym_number_literal] = ACTIONS(4650),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4652),
    [sym_false] = ACTIONS(4652),
    [sym_null] = ACTIONS(4652),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1276),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1280),
    [sym_nullptr] = ACTIONS(4652),
  },
  [1420] = {
    [aux_sym_initializer_list_repeat1] = STATE(2140),
    [anon_sym_COMMA] = ACTIONS(4654),
    [anon_sym_RBRACE] = ACTIONS(4606),
    [sym_comment] = ACTIONS(91),
  },
  [1421] = {
    [sym_string_literal] = STATE(2141),
    [aux_sym_concatenated_string_repeat1] = STATE(2141),
    [anon_sym_COMMA] = ACTIONS(1761),
    [anon_sym_RBRACE] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_EQ] = ACTIONS(1763),
    [anon_sym_QMARK] = ACTIONS(1761),
    [anon_sym_STAR_EQ] = ACTIONS(1761),
    [anon_sym_SLASH_EQ] = ACTIONS(1761),
    [anon_sym_PERCENT_EQ] = ACTIONS(1761),
    [anon_sym_PLUS_EQ] = ACTIONS(1761),
    [anon_sym_DASH_EQ] = ACTIONS(1761),
    [anon_sym_LT_LT_EQ] = ACTIONS(1761),
    [anon_sym_GT_GT_EQ] = ACTIONS(1761),
    [anon_sym_AMP_EQ] = ACTIONS(1761),
    [anon_sym_CARET_EQ] = ACTIONS(1761),
    [anon_sym_PIPE_EQ] = ACTIONS(1761),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_PIPE_PIPE] = ACTIONS(1761),
    [anon_sym_AMP_AMP] = ACTIONS(1761),
    [anon_sym_PIPE] = ACTIONS(1763),
    [anon_sym_CARET] = ACTIONS(1763),
    [anon_sym_EQ_EQ] = ACTIONS(1761),
    [anon_sym_BANG_EQ] = ACTIONS(1761),
    [anon_sym_LT] = ACTIONS(1763),
    [anon_sym_GT] = ACTIONS(1763),
    [anon_sym_LT_EQ] = ACTIONS(1761),
    [anon_sym_GT_EQ] = ACTIONS(1761),
    [anon_sym_LT_LT] = ACTIONS(1763),
    [anon_sym_GT_GT] = ACTIONS(1763),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_SLASH] = ACTIONS(1763),
    [anon_sym_PERCENT] = ACTIONS(1763),
    [anon_sym_DASH_DASH] = ACTIONS(1761),
    [anon_sym_PLUS_PLUS] = ACTIONS(1761),
    [anon_sym_DOT] = ACTIONS(1761),
    [anon_sym_DASH_GT] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(91),
  },
  [1422] = {
    [sym__expression] = STATE(2142),
    [sym_conditional_expression] = STATE(2142),
    [sym_assignment_expression] = STATE(2142),
    [sym_pointer_expression] = STATE(2142),
    [sym_logical_expression] = STATE(2142),
    [sym_bitwise_expression] = STATE(2142),
    [sym_equality_expression] = STATE(2142),
    [sym_relational_expression] = STATE(2142),
    [sym_shift_expression] = STATE(2142),
    [sym_math_expression] = STATE(2142),
    [sym_cast_expression] = STATE(2142),
    [sym_sizeof_expression] = STATE(2142),
    [sym_subscript_expression] = STATE(2142),
    [sym_call_expression] = STATE(2142),
    [sym_field_expression] = STATE(2142),
    [sym_compound_literal_expression] = STATE(2142),
    [sym_parenthesized_expression] = STATE(2142),
    [sym_char_literal] = STATE(2142),
    [sym_concatenated_string] = STATE(2142),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2142),
    [sym_new_expression] = STATE(2142),
    [sym_delete_expression] = STATE(2142),
    [sym_lambda_expression] = STATE(2142),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4656),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(4656),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4658),
    [sym_false] = ACTIONS(4658),
    [sym_null] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(4658),
  },
  [1423] = {
    [sym__expression] = STATE(2143),
    [sym_conditional_expression] = STATE(2143),
    [sym_assignment_expression] = STATE(2143),
    [sym_pointer_expression] = STATE(2143),
    [sym_logical_expression] = STATE(2143),
    [sym_bitwise_expression] = STATE(2143),
    [sym_equality_expression] = STATE(2143),
    [sym_relational_expression] = STATE(2143),
    [sym_shift_expression] = STATE(2143),
    [sym_math_expression] = STATE(2143),
    [sym_cast_expression] = STATE(2143),
    [sym_sizeof_expression] = STATE(2143),
    [sym_subscript_expression] = STATE(2143),
    [sym_call_expression] = STATE(2143),
    [sym_field_expression] = STATE(2143),
    [sym_compound_literal_expression] = STATE(2143),
    [sym_parenthesized_expression] = STATE(2143),
    [sym_initializer_list] = STATE(2144),
    [sym_char_literal] = STATE(2143),
    [sym_concatenated_string] = STATE(2143),
    [sym_string_literal] = STATE(727),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2143),
    [sym_new_expression] = STATE(2143),
    [sym_delete_expression] = STATE(2143),
    [sym_lambda_expression] = STATE(2143),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4660),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(1256),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(1262),
    [anon_sym_TILDE] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_DASH_DASH] = ACTIONS(1268),
    [anon_sym_PLUS_PLUS] = ACTIONS(1268),
    [anon_sym_sizeof] = ACTIONS(1270),
    [sym_number_literal] = ACTIONS(4660),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4662),
    [sym_false] = ACTIONS(4662),
    [sym_null] = ACTIONS(4662),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1276),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1280),
    [sym_nullptr] = ACTIONS(4662),
  },
  [1424] = {
    [sym_subscript_designator] = STATE(1424),
    [sym_field_designator] = STATE(1424),
    [aux_sym_initializer_pair_repeat1] = STATE(1424),
    [anon_sym_LBRACK] = ACTIONS(4664),
    [anon_sym_EQ] = ACTIONS(4667),
    [anon_sym_DOT] = ACTIONS(4669),
    [sym_comment] = ACTIONS(91),
  },
  [1425] = {
    [sym__expression] = STATE(1200),
    [sym_conditional_expression] = STATE(1200),
    [sym_assignment_expression] = STATE(1200),
    [sym_pointer_expression] = STATE(1200),
    [sym_logical_expression] = STATE(1200),
    [sym_bitwise_expression] = STATE(1200),
    [sym_equality_expression] = STATE(1200),
    [sym_relational_expression] = STATE(1200),
    [sym_shift_expression] = STATE(1200),
    [sym_math_expression] = STATE(1200),
    [sym_cast_expression] = STATE(1200),
    [sym_sizeof_expression] = STATE(1200),
    [sym_subscript_expression] = STATE(1200),
    [sym_call_expression] = STATE(1200),
    [sym_field_expression] = STATE(1200),
    [sym_compound_literal_expression] = STATE(1200),
    [sym_parenthesized_expression] = STATE(1200),
    [sym_initializer_list] = STATE(1201),
    [sym_char_literal] = STATE(1200),
    [sym_concatenated_string] = STATE(1200),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1200),
    [sym_new_expression] = STATE(1200),
    [sym_delete_expression] = STATE(1200),
    [sym_lambda_expression] = STATE(1200),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2523),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(2523),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2525),
    [sym_false] = ACTIONS(2525),
    [sym_null] = ACTIONS(2525),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(2525),
  },
  [1426] = {
    [anon_sym_RPAREN] = ACTIONS(4672),
    [sym_comment] = ACTIONS(91),
  },
  [1427] = {
    [sym__expression] = STATE(2146),
    [sym_conditional_expression] = STATE(2146),
    [sym_assignment_expression] = STATE(2146),
    [sym_pointer_expression] = STATE(2146),
    [sym_logical_expression] = STATE(2146),
    [sym_bitwise_expression] = STATE(2146),
    [sym_equality_expression] = STATE(2146),
    [sym_relational_expression] = STATE(2146),
    [sym_shift_expression] = STATE(2146),
    [sym_math_expression] = STATE(2146),
    [sym_cast_expression] = STATE(2146),
    [sym_sizeof_expression] = STATE(2146),
    [sym_subscript_expression] = STATE(2146),
    [sym_call_expression] = STATE(2146),
    [sym_field_expression] = STATE(2146),
    [sym_compound_literal_expression] = STATE(2146),
    [sym_parenthesized_expression] = STATE(2146),
    [sym_char_literal] = STATE(2146),
    [sym_concatenated_string] = STATE(2146),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2146),
    [sym_new_expression] = STATE(2146),
    [sym_delete_expression] = STATE(2146),
    [sym_lambda_expression] = STATE(2146),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4674),
    [anon_sym_LPAREN2] = ACTIONS(947),
    [anon_sym_STAR] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(947),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(4674),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4676),
    [sym_false] = ACTIONS(4676),
    [sym_null] = ACTIONS(4676),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(4676),
  },
  [1428] = {
    [sym__expression] = STATE(2147),
    [sym_conditional_expression] = STATE(2147),
    [sym_assignment_expression] = STATE(2147),
    [sym_pointer_expression] = STATE(2147),
    [sym_logical_expression] = STATE(2147),
    [sym_bitwise_expression] = STATE(2147),
    [sym_equality_expression] = STATE(2147),
    [sym_relational_expression] = STATE(2147),
    [sym_shift_expression] = STATE(2147),
    [sym_math_expression] = STATE(2147),
    [sym_cast_expression] = STATE(2147),
    [sym_sizeof_expression] = STATE(2147),
    [sym_subscript_expression] = STATE(2147),
    [sym_call_expression] = STATE(2147),
    [sym_field_expression] = STATE(2147),
    [sym_compound_literal_expression] = STATE(2147),
    [sym_parenthesized_expression] = STATE(2147),
    [sym_char_literal] = STATE(2147),
    [sym_concatenated_string] = STATE(2147),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2147),
    [sym_new_expression] = STATE(2147),
    [sym_delete_expression] = STATE(2147),
    [sym_lambda_expression] = STATE(2147),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4678),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(4678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4680),
    [sym_false] = ACTIONS(4680),
    [sym_null] = ACTIONS(4680),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(4680),
  },
  [1429] = {
    [sym_argument_list] = STATE(1610),
    [sym_initializer_list] = STATE(1610),
    [sym_new_declarator] = STATE(1611),
    [anon_sym_SEMI] = ACTIONS(3372),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3374),
    [anon_sym_LBRACK] = ACTIONS(2987),
    [anon_sym_EQ] = ACTIONS(3374),
    [anon_sym_QMARK] = ACTIONS(3372),
    [anon_sym_STAR_EQ] = ACTIONS(3372),
    [anon_sym_SLASH_EQ] = ACTIONS(3372),
    [anon_sym_PERCENT_EQ] = ACTIONS(3372),
    [anon_sym_PLUS_EQ] = ACTIONS(3372),
    [anon_sym_DASH_EQ] = ACTIONS(3372),
    [anon_sym_LT_LT_EQ] = ACTIONS(3372),
    [anon_sym_GT_GT_EQ] = ACTIONS(3372),
    [anon_sym_AMP_EQ] = ACTIONS(3372),
    [anon_sym_CARET_EQ] = ACTIONS(3372),
    [anon_sym_PIPE_EQ] = ACTIONS(3372),
    [anon_sym_AMP] = ACTIONS(3374),
    [anon_sym_PIPE_PIPE] = ACTIONS(3372),
    [anon_sym_AMP_AMP] = ACTIONS(3372),
    [anon_sym_PIPE] = ACTIONS(3374),
    [anon_sym_CARET] = ACTIONS(3374),
    [anon_sym_EQ_EQ] = ACTIONS(3372),
    [anon_sym_BANG_EQ] = ACTIONS(3372),
    [anon_sym_LT] = ACTIONS(3374),
    [anon_sym_GT] = ACTIONS(3374),
    [anon_sym_LT_EQ] = ACTIONS(3372),
    [anon_sym_GT_EQ] = ACTIONS(3372),
    [anon_sym_LT_LT] = ACTIONS(3374),
    [anon_sym_GT_GT] = ACTIONS(3374),
    [anon_sym_PLUS] = ACTIONS(3374),
    [anon_sym_DASH] = ACTIONS(3374),
    [anon_sym_SLASH] = ACTIONS(3374),
    [anon_sym_PERCENT] = ACTIONS(3374),
    [anon_sym_DASH_DASH] = ACTIONS(3372),
    [anon_sym_PLUS_PLUS] = ACTIONS(3372),
    [anon_sym_DOT] = ACTIONS(3372),
    [anon_sym_DASH_GT] = ACTIONS(3372),
    [sym_comment] = ACTIONS(91),
  },
  [1430] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1430),
    [anon_sym_SEMI] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(1985),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_EQ] = ACTIONS(1987),
    [anon_sym_unsigned] = ACTIONS(4682),
    [anon_sym_long] = ACTIONS(4682),
    [anon_sym_short] = ACTIONS(4682),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_QMARK] = ACTIONS(1985),
    [anon_sym_STAR_EQ] = ACTIONS(1985),
    [anon_sym_SLASH_EQ] = ACTIONS(1985),
    [anon_sym_PERCENT_EQ] = ACTIONS(1985),
    [anon_sym_PLUS_EQ] = ACTIONS(1985),
    [anon_sym_DASH_EQ] = ACTIONS(1985),
    [anon_sym_LT_LT_EQ] = ACTIONS(1985),
    [anon_sym_GT_GT_EQ] = ACTIONS(1985),
    [anon_sym_AMP_EQ] = ACTIONS(1985),
    [anon_sym_CARET_EQ] = ACTIONS(1985),
    [anon_sym_PIPE_EQ] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_PIPE_PIPE] = ACTIONS(1985),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_PIPE] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1987),
    [anon_sym_EQ_EQ] = ACTIONS(1985),
    [anon_sym_BANG_EQ] = ACTIONS(1985),
    [anon_sym_LT] = ACTIONS(1987),
    [anon_sym_GT] = ACTIONS(1987),
    [anon_sym_LT_EQ] = ACTIONS(1985),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_LT] = ACTIONS(1987),
    [anon_sym_GT_GT] = ACTIONS(1987),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_DASH] = ACTIONS(1987),
    [anon_sym_SLASH] = ACTIONS(1987),
    [anon_sym_PERCENT] = ACTIONS(1987),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DOT] = ACTIONS(1985),
    [anon_sym_DASH_GT] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [sym_comment] = ACTIONS(91),
  },
  [1431] = {
    [sym__expression] = STATE(164),
    [sym_conditional_expression] = STATE(164),
    [sym_assignment_expression] = STATE(164),
    [sym_pointer_expression] = STATE(164),
    [sym_logical_expression] = STATE(164),
    [sym_bitwise_expression] = STATE(164),
    [sym_equality_expression] = STATE(164),
    [sym_relational_expression] = STATE(164),
    [sym_shift_expression] = STATE(164),
    [sym_math_expression] = STATE(164),
    [sym_cast_expression] = STATE(164),
    [sym_sizeof_expression] = STATE(164),
    [sym_subscript_expression] = STATE(164),
    [sym_call_expression] = STATE(164),
    [sym_field_expression] = STATE(164),
    [sym_compound_literal_expression] = STATE(164),
    [sym_parenthesized_expression] = STATE(164),
    [sym_char_literal] = STATE(164),
    [sym_concatenated_string] = STATE(164),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(164),
    [sym_new_expression] = STATE(164),
    [sym_delete_expression] = STATE(164),
    [sym_lambda_expression] = STATE(164),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_lambda_default_capture] = STATE(166),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(267),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(4685),
    [anon_sym_EQ] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(267),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(289),
    [sym_false] = ACTIONS(289),
    [sym_null] = ACTIONS(289),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(289),
  },
  [1432] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(3383),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3385),
    [anon_sym_QMARK] = ACTIONS(3383),
    [anon_sym_STAR_EQ] = ACTIONS(3383),
    [anon_sym_SLASH_EQ] = ACTIONS(3383),
    [anon_sym_PERCENT_EQ] = ACTIONS(3383),
    [anon_sym_PLUS_EQ] = ACTIONS(3383),
    [anon_sym_DASH_EQ] = ACTIONS(3383),
    [anon_sym_LT_LT_EQ] = ACTIONS(3383),
    [anon_sym_GT_GT_EQ] = ACTIONS(3383),
    [anon_sym_AMP_EQ] = ACTIONS(3383),
    [anon_sym_CARET_EQ] = ACTIONS(3383),
    [anon_sym_PIPE_EQ] = ACTIONS(3383),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1433] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(3581),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(3581),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1434] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_COLON] = ACTIONS(4687),
    [anon_sym_QMARK] = ACTIONS(1171),
    [anon_sym_STAR_EQ] = ACTIONS(1173),
    [anon_sym_SLASH_EQ] = ACTIONS(1173),
    [anon_sym_PERCENT_EQ] = ACTIONS(1173),
    [anon_sym_PLUS_EQ] = ACTIONS(1173),
    [anon_sym_DASH_EQ] = ACTIONS(1173),
    [anon_sym_LT_LT_EQ] = ACTIONS(1173),
    [anon_sym_GT_GT_EQ] = ACTIONS(1173),
    [anon_sym_AMP_EQ] = ACTIONS(1173),
    [anon_sym_CARET_EQ] = ACTIONS(1173),
    [anon_sym_PIPE_EQ] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_CARET] = ACTIONS(1183),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [1435] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_STAR_EQ] = ACTIONS(3585),
    [anon_sym_SLASH_EQ] = ACTIONS(3585),
    [anon_sym_PERCENT_EQ] = ACTIONS(3585),
    [anon_sym_PLUS_EQ] = ACTIONS(3585),
    [anon_sym_DASH_EQ] = ACTIONS(3585),
    [anon_sym_LT_LT_EQ] = ACTIONS(3585),
    [anon_sym_GT_GT_EQ] = ACTIONS(3585),
    [anon_sym_AMP_EQ] = ACTIONS(3585),
    [anon_sym_CARET_EQ] = ACTIONS(3585),
    [anon_sym_PIPE_EQ] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(3587),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3587),
    [anon_sym_CARET] = ACTIONS(3587),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1436] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(3589),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3591),
    [anon_sym_QMARK] = ACTIONS(3589),
    [anon_sym_STAR_EQ] = ACTIONS(3589),
    [anon_sym_SLASH_EQ] = ACTIONS(3589),
    [anon_sym_PERCENT_EQ] = ACTIONS(3589),
    [anon_sym_PLUS_EQ] = ACTIONS(3589),
    [anon_sym_DASH_EQ] = ACTIONS(3589),
    [anon_sym_LT_LT_EQ] = ACTIONS(3589),
    [anon_sym_GT_GT_EQ] = ACTIONS(3589),
    [anon_sym_AMP_EQ] = ACTIONS(3589),
    [anon_sym_CARET_EQ] = ACTIONS(3589),
    [anon_sym_PIPE_EQ] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(3589),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1437] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(3589),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3591),
    [anon_sym_QMARK] = ACTIONS(3589),
    [anon_sym_STAR_EQ] = ACTIONS(3589),
    [anon_sym_SLASH_EQ] = ACTIONS(3589),
    [anon_sym_PERCENT_EQ] = ACTIONS(3589),
    [anon_sym_PLUS_EQ] = ACTIONS(3589),
    [anon_sym_DASH_EQ] = ACTIONS(3589),
    [anon_sym_LT_LT_EQ] = ACTIONS(3589),
    [anon_sym_GT_GT_EQ] = ACTIONS(3589),
    [anon_sym_AMP_EQ] = ACTIONS(3589),
    [anon_sym_CARET_EQ] = ACTIONS(3589),
    [anon_sym_PIPE_EQ] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(3589),
    [anon_sym_AMP_AMP] = ACTIONS(3589),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1438] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_STAR_EQ] = ACTIONS(3585),
    [anon_sym_SLASH_EQ] = ACTIONS(3585),
    [anon_sym_PERCENT_EQ] = ACTIONS(3585),
    [anon_sym_PLUS_EQ] = ACTIONS(3585),
    [anon_sym_DASH_EQ] = ACTIONS(3585),
    [anon_sym_LT_LT_EQ] = ACTIONS(3585),
    [anon_sym_GT_GT_EQ] = ACTIONS(3585),
    [anon_sym_AMP_EQ] = ACTIONS(3585),
    [anon_sym_CARET_EQ] = ACTIONS(3585),
    [anon_sym_PIPE_EQ] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3587),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1439] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_STAR_EQ] = ACTIONS(3585),
    [anon_sym_SLASH_EQ] = ACTIONS(3585),
    [anon_sym_PERCENT_EQ] = ACTIONS(3585),
    [anon_sym_PLUS_EQ] = ACTIONS(3585),
    [anon_sym_DASH_EQ] = ACTIONS(3585),
    [anon_sym_LT_LT_EQ] = ACTIONS(3585),
    [anon_sym_GT_GT_EQ] = ACTIONS(3585),
    [anon_sym_AMP_EQ] = ACTIONS(3585),
    [anon_sym_CARET_EQ] = ACTIONS(3585),
    [anon_sym_PIPE_EQ] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3587),
    [anon_sym_CARET] = ACTIONS(3587),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1440] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(3593),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3595),
    [anon_sym_QMARK] = ACTIONS(3593),
    [anon_sym_STAR_EQ] = ACTIONS(3593),
    [anon_sym_SLASH_EQ] = ACTIONS(3593),
    [anon_sym_PERCENT_EQ] = ACTIONS(3593),
    [anon_sym_PLUS_EQ] = ACTIONS(3593),
    [anon_sym_DASH_EQ] = ACTIONS(3593),
    [anon_sym_LT_LT_EQ] = ACTIONS(3593),
    [anon_sym_GT_GT_EQ] = ACTIONS(3593),
    [anon_sym_AMP_EQ] = ACTIONS(3593),
    [anon_sym_CARET_EQ] = ACTIONS(3593),
    [anon_sym_PIPE_EQ] = ACTIONS(3593),
    [anon_sym_AMP] = ACTIONS(3595),
    [anon_sym_PIPE_PIPE] = ACTIONS(3593),
    [anon_sym_AMP_AMP] = ACTIONS(3593),
    [anon_sym_PIPE] = ACTIONS(3595),
    [anon_sym_CARET] = ACTIONS(3595),
    [anon_sym_EQ_EQ] = ACTIONS(3593),
    [anon_sym_BANG_EQ] = ACTIONS(3593),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1441] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(3597),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3599),
    [anon_sym_QMARK] = ACTIONS(3597),
    [anon_sym_STAR_EQ] = ACTIONS(3597),
    [anon_sym_SLASH_EQ] = ACTIONS(3597),
    [anon_sym_PERCENT_EQ] = ACTIONS(3597),
    [anon_sym_PLUS_EQ] = ACTIONS(3597),
    [anon_sym_DASH_EQ] = ACTIONS(3597),
    [anon_sym_LT_LT_EQ] = ACTIONS(3597),
    [anon_sym_GT_GT_EQ] = ACTIONS(3597),
    [anon_sym_AMP_EQ] = ACTIONS(3597),
    [anon_sym_CARET_EQ] = ACTIONS(3597),
    [anon_sym_PIPE_EQ] = ACTIONS(3597),
    [anon_sym_AMP] = ACTIONS(3599),
    [anon_sym_PIPE_PIPE] = ACTIONS(3597),
    [anon_sym_AMP_AMP] = ACTIONS(3597),
    [anon_sym_PIPE] = ACTIONS(3599),
    [anon_sym_CARET] = ACTIONS(3599),
    [anon_sym_EQ_EQ] = ACTIONS(3597),
    [anon_sym_BANG_EQ] = ACTIONS(3597),
    [anon_sym_LT] = ACTIONS(3599),
    [anon_sym_GT] = ACTIONS(3599),
    [anon_sym_LT_EQ] = ACTIONS(3597),
    [anon_sym_GT_EQ] = ACTIONS(3597),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1442] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(3601),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3603),
    [anon_sym_QMARK] = ACTIONS(3601),
    [anon_sym_STAR_EQ] = ACTIONS(3601),
    [anon_sym_SLASH_EQ] = ACTIONS(3601),
    [anon_sym_PERCENT_EQ] = ACTIONS(3601),
    [anon_sym_PLUS_EQ] = ACTIONS(3601),
    [anon_sym_DASH_EQ] = ACTIONS(3601),
    [anon_sym_LT_LT_EQ] = ACTIONS(3601),
    [anon_sym_GT_GT_EQ] = ACTIONS(3601),
    [anon_sym_AMP_EQ] = ACTIONS(3601),
    [anon_sym_CARET_EQ] = ACTIONS(3601),
    [anon_sym_PIPE_EQ] = ACTIONS(3601),
    [anon_sym_AMP] = ACTIONS(3603),
    [anon_sym_PIPE_PIPE] = ACTIONS(3601),
    [anon_sym_AMP_AMP] = ACTIONS(3601),
    [anon_sym_PIPE] = ACTIONS(3603),
    [anon_sym_CARET] = ACTIONS(3603),
    [anon_sym_EQ_EQ] = ACTIONS(3601),
    [anon_sym_BANG_EQ] = ACTIONS(3601),
    [anon_sym_LT] = ACTIONS(3603),
    [anon_sym_GT] = ACTIONS(3603),
    [anon_sym_LT_EQ] = ACTIONS(3601),
    [anon_sym_GT_EQ] = ACTIONS(3601),
    [anon_sym_LT_LT] = ACTIONS(3603),
    [anon_sym_GT_GT] = ACTIONS(3603),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1443] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(3575),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3577),
    [anon_sym_QMARK] = ACTIONS(3575),
    [anon_sym_STAR_EQ] = ACTIONS(3575),
    [anon_sym_SLASH_EQ] = ACTIONS(3575),
    [anon_sym_PERCENT_EQ] = ACTIONS(3575),
    [anon_sym_PLUS_EQ] = ACTIONS(3575),
    [anon_sym_DASH_EQ] = ACTIONS(3575),
    [anon_sym_LT_LT_EQ] = ACTIONS(3575),
    [anon_sym_GT_GT_EQ] = ACTIONS(3575),
    [anon_sym_AMP_EQ] = ACTIONS(3575),
    [anon_sym_CARET_EQ] = ACTIONS(3575),
    [anon_sym_PIPE_EQ] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_PIPE_PIPE] = ACTIONS(3575),
    [anon_sym_AMP_AMP] = ACTIONS(3575),
    [anon_sym_PIPE] = ACTIONS(3577),
    [anon_sym_CARET] = ACTIONS(3577),
    [anon_sym_EQ_EQ] = ACTIONS(3575),
    [anon_sym_BANG_EQ] = ACTIONS(3575),
    [anon_sym_LT] = ACTIONS(3577),
    [anon_sym_GT] = ACTIONS(3577),
    [anon_sym_LT_EQ] = ACTIONS(3575),
    [anon_sym_GT_EQ] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3577),
    [anon_sym_GT_GT] = ACTIONS(3577),
    [anon_sym_PLUS] = ACTIONS(3577),
    [anon_sym_DASH] = ACTIONS(3577),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1444] = {
    [sym_string_literal] = STATE(1444),
    [aux_sym_concatenated_string_repeat1] = STATE(1444),
    [anon_sym_SEMI] = ACTIONS(3622),
    [anon_sym_LPAREN2] = ACTIONS(3622),
    [anon_sym_STAR] = ACTIONS(3624),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_EQ] = ACTIONS(3624),
    [anon_sym_QMARK] = ACTIONS(3622),
    [anon_sym_STAR_EQ] = ACTIONS(3622),
    [anon_sym_SLASH_EQ] = ACTIONS(3622),
    [anon_sym_PERCENT_EQ] = ACTIONS(3622),
    [anon_sym_PLUS_EQ] = ACTIONS(3622),
    [anon_sym_DASH_EQ] = ACTIONS(3622),
    [anon_sym_LT_LT_EQ] = ACTIONS(3622),
    [anon_sym_GT_GT_EQ] = ACTIONS(3622),
    [anon_sym_AMP_EQ] = ACTIONS(3622),
    [anon_sym_CARET_EQ] = ACTIONS(3622),
    [anon_sym_PIPE_EQ] = ACTIONS(3622),
    [anon_sym_AMP] = ACTIONS(3624),
    [anon_sym_PIPE_PIPE] = ACTIONS(3622),
    [anon_sym_AMP_AMP] = ACTIONS(3622),
    [anon_sym_PIPE] = ACTIONS(3624),
    [anon_sym_CARET] = ACTIONS(3624),
    [anon_sym_EQ_EQ] = ACTIONS(3622),
    [anon_sym_BANG_EQ] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3624),
    [anon_sym_GT] = ACTIONS(3624),
    [anon_sym_LT_EQ] = ACTIONS(3622),
    [anon_sym_GT_EQ] = ACTIONS(3622),
    [anon_sym_LT_LT] = ACTIONS(3624),
    [anon_sym_GT_GT] = ACTIONS(3624),
    [anon_sym_PLUS] = ACTIONS(3624),
    [anon_sym_DASH] = ACTIONS(3624),
    [anon_sym_SLASH] = ACTIONS(3624),
    [anon_sym_PERCENT] = ACTIONS(3624),
    [anon_sym_DASH_DASH] = ACTIONS(3622),
    [anon_sym_PLUS_PLUS] = ACTIONS(3622),
    [anon_sym_DOT] = ACTIONS(3622),
    [anon_sym_DASH_GT] = ACTIONS(3622),
    [anon_sym_DQUOTE] = ACTIONS(3626),
    [sym_comment] = ACTIONS(91),
  },
  [1445] = {
    [anon_sym_COMMA] = ACTIONS(3211),
    [anon_sym_RPAREN] = ACTIONS(3211),
    [anon_sym_SEMI] = ACTIONS(3211),
    [anon_sym_LBRACE] = ACTIONS(3211),
    [anon_sym_LPAREN2] = ACTIONS(3211),
    [anon_sym_LBRACK] = ACTIONS(3211),
    [anon_sym_EQ] = ACTIONS(3211),
    [anon_sym_COLON] = ACTIONS(3223),
    [anon_sym_LT] = ACTIONS(3213),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3211),
    [anon_sym_COLON_COLON] = ACTIONS(3225),
  },
  [1446] = {
    [anon_sym_COMMA] = ACTIONS(3629),
    [anon_sym_RPAREN] = ACTIONS(3629),
    [anon_sym_SEMI] = ACTIONS(3629),
    [anon_sym_LBRACE] = ACTIONS(3629),
    [anon_sym_LPAREN2] = ACTIONS(3629),
    [anon_sym_LBRACK] = ACTIONS(3629),
    [anon_sym_EQ] = ACTIONS(3629),
    [anon_sym_COLON] = ACTIONS(3641),
    [anon_sym_LT] = ACTIONS(3631),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3629),
    [anon_sym_COLON_COLON] = ACTIONS(3643),
  },
  [1447] = {
    [sym__expression] = STATE(1200),
    [sym_conditional_expression] = STATE(1200),
    [sym_assignment_expression] = STATE(1200),
    [sym_pointer_expression] = STATE(1200),
    [sym_logical_expression] = STATE(1200),
    [sym_bitwise_expression] = STATE(1200),
    [sym_equality_expression] = STATE(1200),
    [sym_relational_expression] = STATE(1200),
    [sym_shift_expression] = STATE(1200),
    [sym_math_expression] = STATE(1200),
    [sym_cast_expression] = STATE(1200),
    [sym_sizeof_expression] = STATE(1200),
    [sym_subscript_expression] = STATE(1200),
    [sym_call_expression] = STATE(1200),
    [sym_field_expression] = STATE(1200),
    [sym_compound_literal_expression] = STATE(1200),
    [sym_parenthesized_expression] = STATE(1200),
    [sym_initializer_list] = STATE(1201),
    [sym_char_literal] = STATE(1200),
    [sym_concatenated_string] = STATE(1200),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1200),
    [sym_new_expression] = STATE(1200),
    [sym_delete_expression] = STATE(1200),
    [sym_lambda_expression] = STATE(1200),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2523),
    [anon_sym_COMMA] = ACTIONS(4689),
    [anon_sym_SEMI] = ACTIONS(4689),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(4691),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_EQ] = ACTIONS(4693),
    [anon_sym_QMARK] = ACTIONS(4689),
    [anon_sym_STAR_EQ] = ACTIONS(4689),
    [anon_sym_SLASH_EQ] = ACTIONS(4689),
    [anon_sym_PERCENT_EQ] = ACTIONS(4689),
    [anon_sym_PLUS_EQ] = ACTIONS(4689),
    [anon_sym_DASH_EQ] = ACTIONS(4689),
    [anon_sym_LT_LT_EQ] = ACTIONS(4689),
    [anon_sym_GT_GT_EQ] = ACTIONS(4689),
    [anon_sym_AMP_EQ] = ACTIONS(4689),
    [anon_sym_CARET_EQ] = ACTIONS(4689),
    [anon_sym_PIPE_EQ] = ACTIONS(4689),
    [anon_sym_AMP] = ACTIONS(4691),
    [anon_sym_PIPE_PIPE] = ACTIONS(4689),
    [anon_sym_AMP_AMP] = ACTIONS(4689),
    [anon_sym_BANG] = ACTIONS(4695),
    [anon_sym_PIPE] = ACTIONS(4693),
    [anon_sym_CARET] = ACTIONS(4693),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_EQ_EQ] = ACTIONS(4689),
    [anon_sym_BANG_EQ] = ACTIONS(4689),
    [anon_sym_LT] = ACTIONS(4693),
    [anon_sym_GT] = ACTIONS(4693),
    [anon_sym_LT_EQ] = ACTIONS(4689),
    [anon_sym_GT_EQ] = ACTIONS(4689),
    [anon_sym_LT_LT] = ACTIONS(4693),
    [anon_sym_GT_GT] = ACTIONS(4693),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_SLASH] = ACTIONS(4693),
    [anon_sym_PERCENT] = ACTIONS(4693),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(4689),
    [anon_sym_DASH_GT] = ACTIONS(4689),
    [sym_number_literal] = ACTIONS(2523),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2525),
    [sym_false] = ACTIONS(2525),
    [sym_null] = ACTIONS(2525),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2525),
  },
  [1448] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(895),
    [anon_sym_RPAREN] = ACTIONS(4697),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1449] = {
    [anon_sym_RPAREN] = ACTIONS(4697),
    [sym_comment] = ACTIONS(91),
  },
  [1450] = {
    [anon_sym_RPAREN] = ACTIONS(4699),
    [sym_comment] = ACTIONS(91),
  },
  [1451] = {
    [sym_initializer_list] = STATE(1468),
    [sym_template_argument_list] = STATE(2153),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(3114),
    [anon_sym_LPAREN2] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(3116),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(463),
    [anon_sym_COLON_COLON] = ACTIONS(4701),
  },
  [1452] = {
    [sym_destructor_name] = STATE(1488),
    [anon_sym_TILDE] = ACTIONS(3149),
    [sym_identifier] = ACTIONS(4703),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(3153),
    [sym_operator_name] = ACTIONS(3155),
  },
  [1453] = {
    [sym_argument_list] = STATE(1511),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_LPAREN2] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(941),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(939),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(939),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_DASH] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(3199),
    [anon_sym_DASH_GT] = ACTIONS(3199),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(939),
  },
  [1454] = {
    [sym_initializer_list] = STATE(1517),
    [anon_sym_LBRACE] = ACTIONS(3114),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(4705),
  },
  [1455] = {
    [sym_initializer_list] = STATE(1517),
    [sym_template_argument_list] = STATE(362),
    [anon_sym_LBRACE] = ACTIONS(3114),
    [anon_sym_LT] = ACTIONS(945),
    [sym_comment] = ACTIONS(91),
  },
  [1456] = {
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(4705),
  },
  [1457] = {
    [sym_argument_list] = STATE(1511),
    [anon_sym_COMMA] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_QMARK] = ACTIONS(1350),
    [anon_sym_STAR_EQ] = ACTIONS(1350),
    [anon_sym_SLASH_EQ] = ACTIONS(1350),
    [anon_sym_PERCENT_EQ] = ACTIONS(1350),
    [anon_sym_PLUS_EQ] = ACTIONS(1350),
    [anon_sym_DASH_EQ] = ACTIONS(1350),
    [anon_sym_LT_LT_EQ] = ACTIONS(1350),
    [anon_sym_GT_GT_EQ] = ACTIONS(1350),
    [anon_sym_AMP_EQ] = ACTIONS(1350),
    [anon_sym_CARET_EQ] = ACTIONS(1350),
    [anon_sym_PIPE_EQ] = ACTIONS(1350),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_PIPE_PIPE] = ACTIONS(1350),
    [anon_sym_AMP_AMP] = ACTIONS(1350),
    [anon_sym_PIPE] = ACTIONS(1352),
    [anon_sym_CARET] = ACTIONS(1352),
    [anon_sym_EQ_EQ] = ACTIONS(1350),
    [anon_sym_BANG_EQ] = ACTIONS(1350),
    [anon_sym_LT] = ACTIONS(1352),
    [anon_sym_GT] = ACTIONS(1352),
    [anon_sym_LT_EQ] = ACTIONS(1350),
    [anon_sym_GT_EQ] = ACTIONS(1350),
    [anon_sym_LT_LT] = ACTIONS(1352),
    [anon_sym_GT_GT] = ACTIONS(1352),
    [anon_sym_PLUS] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1352),
    [anon_sym_SLASH] = ACTIONS(1352),
    [anon_sym_PERCENT] = ACTIONS(1352),
    [anon_sym_DASH_DASH] = ACTIONS(1350),
    [anon_sym_PLUS_PLUS] = ACTIONS(1350),
    [anon_sym_DOT] = ACTIONS(3199),
    [anon_sym_DASH_GT] = ACTIONS(3199),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(1350),
  },
  [1458] = {
    [sym_argument_list] = STATE(1511),
    [anon_sym_COMMA] = ACTIONS(1356),
    [anon_sym_LPAREN2] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(1358),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_EQ] = ACTIONS(1358),
    [anon_sym_QMARK] = ACTIONS(1356),
    [anon_sym_STAR_EQ] = ACTIONS(1356),
    [anon_sym_SLASH_EQ] = ACTIONS(1356),
    [anon_sym_PERCENT_EQ] = ACTIONS(1356),
    [anon_sym_PLUS_EQ] = ACTIONS(1356),
    [anon_sym_DASH_EQ] = ACTIONS(1356),
    [anon_sym_LT_LT_EQ] = ACTIONS(1356),
    [anon_sym_GT_GT_EQ] = ACTIONS(1356),
    [anon_sym_AMP_EQ] = ACTIONS(1356),
    [anon_sym_CARET_EQ] = ACTIONS(1356),
    [anon_sym_PIPE_EQ] = ACTIONS(1356),
    [anon_sym_AMP] = ACTIONS(1358),
    [anon_sym_PIPE_PIPE] = ACTIONS(1356),
    [anon_sym_AMP_AMP] = ACTIONS(1356),
    [anon_sym_PIPE] = ACTIONS(1358),
    [anon_sym_CARET] = ACTIONS(1358),
    [anon_sym_EQ_EQ] = ACTIONS(1356),
    [anon_sym_BANG_EQ] = ACTIONS(1356),
    [anon_sym_LT] = ACTIONS(1358),
    [anon_sym_GT] = ACTIONS(1358),
    [anon_sym_LT_EQ] = ACTIONS(1356),
    [anon_sym_GT_EQ] = ACTIONS(1356),
    [anon_sym_LT_LT] = ACTIONS(1358),
    [anon_sym_GT_GT] = ACTIONS(1358),
    [anon_sym_PLUS] = ACTIONS(1358),
    [anon_sym_DASH] = ACTIONS(1358),
    [anon_sym_SLASH] = ACTIONS(1358),
    [anon_sym_PERCENT] = ACTIONS(1358),
    [anon_sym_DASH_DASH] = ACTIONS(1356),
    [anon_sym_PLUS_PLUS] = ACTIONS(1356),
    [anon_sym_DOT] = ACTIONS(3199),
    [anon_sym_DASH_GT] = ACTIONS(3199),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(1356),
  },
  [1459] = {
    [sym_argument_list] = STATE(1511),
    [anon_sym_COMMA] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(1362),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_EQ] = ACTIONS(1362),
    [anon_sym_QMARK] = ACTIONS(1360),
    [anon_sym_STAR_EQ] = ACTIONS(1360),
    [anon_sym_SLASH_EQ] = ACTIONS(1360),
    [anon_sym_PERCENT_EQ] = ACTIONS(1360),
    [anon_sym_PLUS_EQ] = ACTIONS(1360),
    [anon_sym_DASH_EQ] = ACTIONS(1360),
    [anon_sym_LT_LT_EQ] = ACTIONS(1360),
    [anon_sym_GT_GT_EQ] = ACTIONS(1360),
    [anon_sym_AMP_EQ] = ACTIONS(1360),
    [anon_sym_CARET_EQ] = ACTIONS(1360),
    [anon_sym_PIPE_EQ] = ACTIONS(1360),
    [anon_sym_AMP] = ACTIONS(1362),
    [anon_sym_PIPE_PIPE] = ACTIONS(1360),
    [anon_sym_AMP_AMP] = ACTIONS(1360),
    [anon_sym_PIPE] = ACTIONS(1362),
    [anon_sym_CARET] = ACTIONS(1362),
    [anon_sym_EQ_EQ] = ACTIONS(1360),
    [anon_sym_BANG_EQ] = ACTIONS(1360),
    [anon_sym_LT] = ACTIONS(1362),
    [anon_sym_GT] = ACTIONS(1362),
    [anon_sym_LT_EQ] = ACTIONS(1360),
    [anon_sym_GT_EQ] = ACTIONS(1360),
    [anon_sym_LT_LT] = ACTIONS(1362),
    [anon_sym_GT_GT] = ACTIONS(1362),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_SLASH] = ACTIONS(1362),
    [anon_sym_PERCENT] = ACTIONS(1362),
    [anon_sym_DASH_DASH] = ACTIONS(3197),
    [anon_sym_PLUS_PLUS] = ACTIONS(3197),
    [anon_sym_DOT] = ACTIONS(3199),
    [anon_sym_DASH_GT] = ACTIONS(3199),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(1360),
  },
  [1460] = {
    [sym_type_qualifier] = STATE(141),
    [sym__type_specifier] = STATE(136),
    [sym_sized_type_specifier] = STATE(136),
    [sym_enum_specifier] = STATE(136),
    [sym_struct_specifier] = STATE(136),
    [sym_union_specifier] = STATE(136),
    [sym__expression] = STATE(1448),
    [sym_comma_expression] = STATE(1449),
    [sym_conditional_expression] = STATE(1448),
    [sym_assignment_expression] = STATE(1448),
    [sym_pointer_expression] = STATE(1448),
    [sym_logical_expression] = STATE(1448),
    [sym_bitwise_expression] = STATE(1448),
    [sym_equality_expression] = STATE(1448),
    [sym_relational_expression] = STATE(1448),
    [sym_shift_expression] = STATE(1448),
    [sym_math_expression] = STATE(1448),
    [sym_cast_expression] = STATE(1448),
    [sym_type_descriptor] = STATE(2156),
    [sym_sizeof_expression] = STATE(1448),
    [sym_subscript_expression] = STATE(1448),
    [sym_call_expression] = STATE(1448),
    [sym_field_expression] = STATE(1448),
    [sym_compound_literal_expression] = STATE(1448),
    [sym_parenthesized_expression] = STATE(1448),
    [sym_char_literal] = STATE(1448),
    [sym_concatenated_string] = STATE(1448),
    [sym_string_literal] = STATE(140),
    [sym_macro_type_specifier] = STATE(136),
    [sym_class_specifier] = STATE(136),
    [sym_dependent_type] = STATE(136),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(1448),
    [sym_new_expression] = STATE(1448),
    [sym_delete_expression] = STATE(1448),
    [sym_lambda_expression] = STATE(1448),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_type_definition_repeat1] = STATE(141),
    [aux_sym_sized_type_specifier_repeat1] = STATE(142),
    [sym_raw_string_literal] = ACTIONS(3076),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(219),
    [anon_sym_long] = ACTIONS(219),
    [anon_sym_short] = ACTIONS(219),
    [sym_primitive_type] = ACTIONS(221),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(3076),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(3078),
    [sym_false] = ACTIONS(3078),
    [sym_null] = ACTIONS(3078),
    [sym_identifier] = ACTIONS(811),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(221),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(253),
    [sym_nullptr] = ACTIONS(3078),
  },
  [1461] = {
    [sym_argument_list] = STATE(1511),
    [anon_sym_COMMA] = ACTIONS(1364),
    [anon_sym_LPAREN2] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_EQ] = ACTIONS(1366),
    [anon_sym_QMARK] = ACTIONS(1364),
    [anon_sym_STAR_EQ] = ACTIONS(1364),
    [anon_sym_SLASH_EQ] = ACTIONS(1364),
    [anon_sym_PERCENT_EQ] = ACTIONS(1364),
    [anon_sym_PLUS_EQ] = ACTIONS(1364),
    [anon_sym_DASH_EQ] = ACTIONS(1364),
    [anon_sym_LT_LT_EQ] = ACTIONS(1364),
    [anon_sym_GT_GT_EQ] = ACTIONS(1364),
    [anon_sym_AMP_EQ] = ACTIONS(1364),
    [anon_sym_CARET_EQ] = ACTIONS(1364),
    [anon_sym_PIPE_EQ] = ACTIONS(1364),
    [anon_sym_AMP] = ACTIONS(1366),
    [anon_sym_PIPE_PIPE] = ACTIONS(1364),
    [anon_sym_AMP_AMP] = ACTIONS(1364),
    [anon_sym_PIPE] = ACTIONS(1366),
    [anon_sym_CARET] = ACTIONS(1366),
    [anon_sym_EQ_EQ] = ACTIONS(1364),
    [anon_sym_BANG_EQ] = ACTIONS(1364),
    [anon_sym_LT] = ACTIONS(1366),
    [anon_sym_GT] = ACTIONS(1366),
    [anon_sym_LT_EQ] = ACTIONS(1364),
    [anon_sym_GT_EQ] = ACTIONS(1364),
    [anon_sym_LT_LT] = ACTIONS(3193),
    [anon_sym_GT_GT] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_SLASH] = ACTIONS(3167),
    [anon_sym_PERCENT] = ACTIONS(3167),
    [anon_sym_DASH_DASH] = ACTIONS(3197),
    [anon_sym_PLUS_PLUS] = ACTIONS(3197),
    [anon_sym_DOT] = ACTIONS(3199),
    [anon_sym_DASH_GT] = ACTIONS(3199),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(1364),
  },
  [1462] = {
    [anon_sym_SQUOTE] = ACTIONS(4707),
    [sym_comment] = ACTIONS(91),
  },
  [1463] = {
    [anon_sym_COMMA] = ACTIONS(1370),
    [anon_sym_LPAREN2] = ACTIONS(1370),
    [anon_sym_STAR] = ACTIONS(1372),
    [anon_sym_LBRACK] = ACTIONS(1370),
    [anon_sym_EQ] = ACTIONS(1372),
    [anon_sym_QMARK] = ACTIONS(1370),
    [anon_sym_STAR_EQ] = ACTIONS(1370),
    [anon_sym_SLASH_EQ] = ACTIONS(1370),
    [anon_sym_PERCENT_EQ] = ACTIONS(1370),
    [anon_sym_PLUS_EQ] = ACTIONS(1370),
    [anon_sym_DASH_EQ] = ACTIONS(1370),
    [anon_sym_LT_LT_EQ] = ACTIONS(1370),
    [anon_sym_GT_GT_EQ] = ACTIONS(1370),
    [anon_sym_AMP_EQ] = ACTIONS(1370),
    [anon_sym_CARET_EQ] = ACTIONS(1370),
    [anon_sym_PIPE_EQ] = ACTIONS(1370),
    [anon_sym_AMP] = ACTIONS(1372),
    [anon_sym_PIPE_PIPE] = ACTIONS(1370),
    [anon_sym_AMP_AMP] = ACTIONS(1370),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_CARET] = ACTIONS(1372),
    [anon_sym_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG_EQ] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1372),
    [anon_sym_GT] = ACTIONS(1372),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_LT_LT] = ACTIONS(1372),
    [anon_sym_GT_GT] = ACTIONS(1372),
    [anon_sym_PLUS] = ACTIONS(1372),
    [anon_sym_DASH] = ACTIONS(1372),
    [anon_sym_SLASH] = ACTIONS(1372),
    [anon_sym_PERCENT] = ACTIONS(1372),
    [anon_sym_DASH_DASH] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1370),
    [anon_sym_DOT] = ACTIONS(1370),
    [anon_sym_DASH_GT] = ACTIONS(1370),
    [anon_sym_DQUOTE] = ACTIONS(1370),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(1370),
  },
  [1464] = {
    [aux_sym_string_literal_repeat1] = STATE(761),
    [anon_sym_DQUOTE] = ACTIONS(4709),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_BSLASHn_RBRACK_SLASH] = ACTIONS(1376),
    [sym_escape_sequence] = ACTIONS(1376),
    [sym_comment] = ACTIONS(121),
  },
  [1465] = {
    [sym__expression] = STATE(2161),
    [sym_conditional_expression] = STATE(2161),
    [sym_assignment_expression] = STATE(2161),
    [sym_pointer_expression] = STATE(2161),
    [sym_logical_expression] = STATE(2161),
    [sym_bitwise_expression] = STATE(2161),
    [sym_equality_expression] = STATE(2161),
    [sym_relational_expression] = STATE(2161),
    [sym_shift_expression] = STATE(2161),
    [sym_math_expression] = STATE(2161),
    [sym_cast_expression] = STATE(2161),
    [sym_sizeof_expression] = STATE(2161),
    [sym_subscript_expression] = STATE(2161),
    [sym_call_expression] = STATE(2161),
    [sym_field_expression] = STATE(2161),
    [sym_compound_literal_expression] = STATE(2161),
    [sym_parenthesized_expression] = STATE(2161),
    [sym_initializer_list] = STATE(2162),
    [sym_initializer_pair] = STATE(2162),
    [sym_subscript_designator] = STATE(728),
    [sym_field_designator] = STATE(728),
    [sym_char_literal] = STATE(2161),
    [sym_concatenated_string] = STATE(2161),
    [sym_string_literal] = STATE(727),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2161),
    [sym_new_expression] = STATE(2161),
    [sym_delete_expression] = STATE(2161),
    [sym_lambda_expression] = STATE(2161),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [aux_sym_initializer_pair_repeat1] = STATE(728),
    [sym_raw_string_literal] = ACTIONS(4711),
    [anon_sym_COMMA] = ACTIONS(4713),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_RBRACE] = ACTIONS(4715),
    [anon_sym_LPAREN2] = ACTIONS(1256),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_LBRACK] = ACTIONS(1260),
    [anon_sym_AMP] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(1262),
    [anon_sym_TILDE] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_DASH_DASH] = ACTIONS(1268),
    [anon_sym_PLUS_PLUS] = ACTIONS(1268),
    [anon_sym_sizeof] = ACTIONS(1270),
    [anon_sym_DOT] = ACTIONS(1272),
    [sym_number_literal] = ACTIONS(4711),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4717),
    [sym_false] = ACTIONS(4717),
    [sym_null] = ACTIONS(4717),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1276),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1280),
    [sym_nullptr] = ACTIONS(4717),
  },
  [1466] = {
    [sym_type_qualifier] = STATE(786),
    [sym__type_specifier] = STATE(777),
    [sym_sized_type_specifier] = STATE(777),
    [sym_enum_specifier] = STATE(777),
    [sym_struct_specifier] = STATE(777),
    [sym_union_specifier] = STATE(777),
    [sym__expression] = STATE(2164),
    [sym_conditional_expression] = STATE(2164),
    [sym_assignment_expression] = STATE(2164),
    [sym_pointer_expression] = STATE(2164),
    [sym_logical_expression] = STATE(2164),
    [sym_bitwise_expression] = STATE(2164),
    [sym_equality_expression] = STATE(2164),
    [sym_relational_expression] = STATE(2164),
    [sym_shift_expression] = STATE(2164),
    [sym_math_expression] = STATE(2164),
    [sym_cast_expression] = STATE(2164),
    [sym_type_descriptor] = STATE(2165),
    [sym_sizeof_expression] = STATE(2164),
    [sym_subscript_expression] = STATE(2164),
    [sym_call_expression] = STATE(2164),
    [sym_field_expression] = STATE(2164),
    [sym_compound_literal_expression] = STATE(2164),
    [sym_parenthesized_expression] = STATE(2164),
    [sym_char_literal] = STATE(2164),
    [sym_concatenated_string] = STATE(2164),
    [sym_string_literal] = STATE(780),
    [sym_macro_type_specifier] = STATE(777),
    [sym_class_specifier] = STATE(777),
    [sym_dependent_type] = STATE(777),
    [sym_template_type] = STATE(781),
    [sym_template_function] = STATE(2164),
    [sym_new_expression] = STATE(2164),
    [sym_delete_expression] = STATE(2164),
    [sym_lambda_expression] = STATE(2164),
    [sym_lambda_capture_specifier] = STATE(782),
    [sym_scoped_identifier] = STATE(783),
    [sym_scoped_type_identifier] = STATE(784),
    [sym_scoped_namespace_identifier] = STATE(785),
    [aux_sym_type_definition_repeat1] = STATE(786),
    [aux_sym_sized_type_specifier_repeat1] = STATE(787),
    [sym_raw_string_literal] = ACTIONS(4719),
    [anon_sym_LPAREN2] = ACTIONS(1380),
    [anon_sym_STAR] = ACTIONS(1382),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(1384),
    [anon_sym_long] = ACTIONS(1384),
    [anon_sym_short] = ACTIONS(1384),
    [sym_primitive_type] = ACTIONS(1386),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [anon_sym_AMP] = ACTIONS(1382),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1394),
    [anon_sym_PLUS_PLUS] = ACTIONS(1394),
    [anon_sym_sizeof] = ACTIONS(1396),
    [sym_number_literal] = ACTIONS(4719),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_true] = ACTIONS(4721),
    [sym_false] = ACTIONS(4721),
    [sym_null] = ACTIONS(4721),
    [sym_identifier] = ACTIONS(1404),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(1386),
    [anon_sym_typename] = ACTIONS(1406),
    [anon_sym_GT2] = ACTIONS(4723),
    [anon_sym_delete] = ACTIONS(1410),
    [anon_sym_new] = ACTIONS(1412),
    [anon_sym_COLON_COLON] = ACTIONS(1414),
    [sym_nullptr] = ACTIONS(4721),
  },
  [1467] = {
    [sym_destructor_name] = STATE(2167),
    [anon_sym_TILDE] = ACTIONS(3149),
    [sym_identifier] = ACTIONS(4725),
    [sym_comment] = ACTIONS(91),
    [sym_operator_name] = ACTIONS(4727),
  },
  [1468] = {
    [anon_sym_COMMA] = ACTIONS(1420),
    [anon_sym_LPAREN2] = ACTIONS(1420),
    [anon_sym_STAR] = ACTIONS(1422),
    [anon_sym_LBRACK] = ACTIONS(1420),
    [anon_sym_EQ] = ACTIONS(1422),
    [anon_sym_QMARK] = ACTIONS(1420),
    [anon_sym_STAR_EQ] = ACTIONS(1420),
    [anon_sym_SLASH_EQ] = ACTIONS(1420),
    [anon_sym_PERCENT_EQ] = ACTIONS(1420),
    [anon_sym_PLUS_EQ] = ACTIONS(1420),
    [anon_sym_DASH_EQ] = ACTIONS(1420),
    [anon_sym_LT_LT_EQ] = ACTIONS(1420),
    [anon_sym_GT_GT_EQ] = ACTIONS(1420),
    [anon_sym_AMP_EQ] = ACTIONS(1420),
    [anon_sym_CARET_EQ] = ACTIONS(1420),
    [anon_sym_PIPE_EQ] = ACTIONS(1420),
    [anon_sym_AMP] = ACTIONS(1422),
    [anon_sym_PIPE_PIPE] = ACTIONS(1420),
    [anon_sym_AMP_AMP] = ACTIONS(1420),
    [anon_sym_PIPE] = ACTIONS(1422),
    [anon_sym_CARET] = ACTIONS(1422),
    [anon_sym_EQ_EQ] = ACTIONS(1420),
    [anon_sym_BANG_EQ] = ACTIONS(1420),
    [anon_sym_LT] = ACTIONS(1422),
    [anon_sym_GT] = ACTIONS(1422),
    [anon_sym_LT_EQ] = ACTIONS(1420),
    [anon_sym_GT_EQ] = ACTIONS(1420),
    [anon_sym_LT_LT] = ACTIONS(1422),
    [anon_sym_GT_GT] = ACTIONS(1422),
    [anon_sym_PLUS] = ACTIONS(1422),
    [anon_sym_DASH] = ACTIONS(1422),
    [anon_sym_SLASH] = ACTIONS(1422),
    [anon_sym_PERCENT] = ACTIONS(1422),
    [anon_sym_DASH_DASH] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1420),
    [anon_sym_DOT] = ACTIONS(1420),
    [anon_sym_DASH_GT] = ACTIONS(1420),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(1420),
  },
  [1469] = {
    [anon_sym_COMMA] = ACTIONS(1426),
    [anon_sym_LBRACE] = ACTIONS(1431),
    [anon_sym_LPAREN2] = ACTIONS(1426),
    [anon_sym_STAR] = ACTIONS(1433),
    [anon_sym_LBRACK] = ACTIONS(1426),
    [anon_sym_EQ] = ACTIONS(1436),
    [anon_sym_QMARK] = ACTIONS(1424),
    [anon_sym_STAR_EQ] = ACTIONS(1424),
    [anon_sym_SLASH_EQ] = ACTIONS(1424),
    [anon_sym_PERCENT_EQ] = ACTIONS(1424),
    [anon_sym_PLUS_EQ] = ACTIONS(1424),
    [anon_sym_DASH_EQ] = ACTIONS(1424),
    [anon_sym_LT_LT_EQ] = ACTIONS(1424),
    [anon_sym_GT_GT_EQ] = ACTIONS(1424),
    [anon_sym_AMP_EQ] = ACTIONS(1424),
    [anon_sym_CARET_EQ] = ACTIONS(1424),
    [anon_sym_PIPE_EQ] = ACTIONS(1424),
    [anon_sym_AMP] = ACTIONS(1433),
    [anon_sym_PIPE_PIPE] = ACTIONS(1424),
    [anon_sym_AMP_AMP] = ACTIONS(1426),
    [anon_sym_PIPE] = ACTIONS(1436),
    [anon_sym_CARET] = ACTIONS(1436),
    [anon_sym_EQ_EQ] = ACTIONS(1424),
    [anon_sym_BANG_EQ] = ACTIONS(1424),
    [anon_sym_LT] = ACTIONS(1436),
    [anon_sym_GT] = ACTIONS(1436),
    [anon_sym_LT_EQ] = ACTIONS(1424),
    [anon_sym_GT_EQ] = ACTIONS(1424),
    [anon_sym_LT_LT] = ACTIONS(1436),
    [anon_sym_GT_GT] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1436),
    [anon_sym_DASH] = ACTIONS(1436),
    [anon_sym_SLASH] = ACTIONS(1436),
    [anon_sym_PERCENT] = ACTIONS(1436),
    [anon_sym_DASH_DASH] = ACTIONS(1424),
    [anon_sym_PLUS_PLUS] = ACTIONS(1424),
    [anon_sym_DOT] = ACTIONS(1424),
    [anon_sym_DASH_GT] = ACTIONS(1424),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(1431),
  },
  [1470] = {
    [sym__expression] = STATE(164),
    [sym_conditional_expression] = STATE(164),
    [sym_assignment_expression] = STATE(164),
    [sym_pointer_expression] = STATE(164),
    [sym_logical_expression] = STATE(164),
    [sym_bitwise_expression] = STATE(164),
    [sym_equality_expression] = STATE(164),
    [sym_relational_expression] = STATE(164),
    [sym_shift_expression] = STATE(164),
    [sym_math_expression] = STATE(164),
    [sym_cast_expression] = STATE(164),
    [sym_sizeof_expression] = STATE(164),
    [sym_subscript_expression] = STATE(164),
    [sym_call_expression] = STATE(164),
    [sym_field_expression] = STATE(164),
    [sym_compound_literal_expression] = STATE(164),
    [sym_parenthesized_expression] = STATE(164),
    [sym_char_literal] = STATE(164),
    [sym_concatenated_string] = STATE(164),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(164),
    [sym_new_expression] = STATE(164),
    [sym_delete_expression] = STATE(164),
    [sym_lambda_expression] = STATE(164),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_lambda_default_capture] = STATE(166),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(267),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(4729),
    [anon_sym_EQ] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(267),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(289),
    [sym_false] = ACTIONS(289),
    [sym_null] = ACTIONS(289),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(289),
  },
  [1471] = {
    [sym_argument_list] = STATE(1511),
    [anon_sym_COMMA] = ACTIONS(1489),
    [anon_sym_LPAREN2] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_EQ] = ACTIONS(1491),
    [anon_sym_QMARK] = ACTIONS(1489),
    [anon_sym_STAR_EQ] = ACTIONS(1489),
    [anon_sym_SLASH_EQ] = ACTIONS(1489),
    [anon_sym_PERCENT_EQ] = ACTIONS(1489),
    [anon_sym_PLUS_EQ] = ACTIONS(1489),
    [anon_sym_DASH_EQ] = ACTIONS(1489),
    [anon_sym_LT_LT_EQ] = ACTIONS(1489),
    [anon_sym_GT_GT_EQ] = ACTIONS(1489),
    [anon_sym_AMP_EQ] = ACTIONS(1489),
    [anon_sym_CARET_EQ] = ACTIONS(1489),
    [anon_sym_PIPE_EQ] = ACTIONS(1489),
    [anon_sym_AMP] = ACTIONS(3177),
    [anon_sym_PIPE_PIPE] = ACTIONS(3179),
    [anon_sym_AMP_AMP] = ACTIONS(3181),
    [anon_sym_PIPE] = ACTIONS(3183),
    [anon_sym_CARET] = ACTIONS(3185),
    [anon_sym_EQ_EQ] = ACTIONS(3187),
    [anon_sym_BANG_EQ] = ACTIONS(3187),
    [anon_sym_LT] = ACTIONS(3189),
    [anon_sym_GT] = ACTIONS(3189),
    [anon_sym_LT_EQ] = ACTIONS(3191),
    [anon_sym_GT_EQ] = ACTIONS(3191),
    [anon_sym_LT_LT] = ACTIONS(3193),
    [anon_sym_GT_GT] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_SLASH] = ACTIONS(3167),
    [anon_sym_PERCENT] = ACTIONS(3167),
    [anon_sym_DASH_DASH] = ACTIONS(3197),
    [anon_sym_PLUS_PLUS] = ACTIONS(3197),
    [anon_sym_DOT] = ACTIONS(3199),
    [anon_sym_DASH_GT] = ACTIONS(3199),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(1489),
  },
  [1472] = {
    [sym_enumerator_list] = STATE(2171),
    [anon_sym_LBRACE] = ACTIONS(4731),
    [sym_identifier] = ACTIONS(4733),
    [sym_comment] = ACTIONS(91),
  },
  [1473] = {
    [sym_field_declaration_list] = STATE(2174),
    [sym_virtual_specifier] = STATE(2175),
    [sym_base_class_clause] = STATE(2176),
    [sym_template_type] = STATE(2177),
    [sym_scoped_type_identifier] = STATE(2178),
    [sym_scoped_namespace_identifier] = STATE(1483),
    [anon_sym_LBRACE] = ACTIONS(4735),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(4737),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(3147),
  },
  [1474] = {
    [sym_field_declaration_list] = STATE(2180),
    [sym_virtual_specifier] = STATE(2181),
    [sym_base_class_clause] = STATE(2182),
    [sym_template_type] = STATE(2183),
    [sym_scoped_type_identifier] = STATE(2184),
    [sym_scoped_namespace_identifier] = STATE(1483),
    [anon_sym_LBRACE] = ACTIONS(4735),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(4739),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(3147),
  },
  [1475] = {
    [sym_template_argument_list] = STATE(2186),
    [anon_sym_COMMA] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_LPAREN2] = ACTIONS(481),
    [anon_sym_STAR] = ACTIONS(468),
    [anon_sym_LBRACK] = ACTIONS(481),
    [anon_sym_EQ] = ACTIONS(468),
    [anon_sym_QMARK] = ACTIONS(481),
    [anon_sym_STAR_EQ] = ACTIONS(481),
    [anon_sym_SLASH_EQ] = ACTIONS(481),
    [anon_sym_PERCENT_EQ] = ACTIONS(481),
    [anon_sym_PLUS_EQ] = ACTIONS(481),
    [anon_sym_DASH_EQ] = ACTIONS(481),
    [anon_sym_LT_LT_EQ] = ACTIONS(481),
    [anon_sym_GT_GT_EQ] = ACTIONS(481),
    [anon_sym_AMP_EQ] = ACTIONS(481),
    [anon_sym_CARET_EQ] = ACTIONS(481),
    [anon_sym_PIPE_EQ] = ACTIONS(481),
    [anon_sym_AMP] = ACTIONS(468),
    [anon_sym_PIPE_PIPE] = ACTIONS(481),
    [anon_sym_AMP_AMP] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(468),
    [anon_sym_CARET] = ACTIONS(468),
    [anon_sym_EQ_EQ] = ACTIONS(481),
    [anon_sym_BANG_EQ] = ACTIONS(481),
    [anon_sym_LT] = ACTIONS(4741),
    [anon_sym_GT] = ACTIONS(468),
    [anon_sym_LT_EQ] = ACTIONS(481),
    [anon_sym_GT_EQ] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(468),
    [anon_sym_GT_GT] = ACTIONS(468),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_SLASH] = ACTIONS(468),
    [anon_sym_PERCENT] = ACTIONS(468),
    [anon_sym_DASH_DASH] = ACTIONS(481),
    [anon_sym_PLUS_PLUS] = ACTIONS(481),
    [anon_sym_DOT] = ACTIONS(481),
    [anon_sym_DASH_GT] = ACTIONS(481),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(481),
    [anon_sym_COLON_COLON] = ACTIONS(4744),
  },
  [1476] = {
    [sym_field_declaration_list] = STATE(2188),
    [sym_virtual_specifier] = STATE(2189),
    [sym_base_class_clause] = STATE(2190),
    [sym_template_type] = STATE(2191),
    [sym_scoped_type_identifier] = STATE(2192),
    [sym_scoped_namespace_identifier] = STATE(1483),
    [anon_sym_LBRACE] = ACTIONS(4735),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(4746),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(3147),
  },
  [1477] = {
    [sym__type_specifier] = STATE(2193),
    [sym_sized_type_specifier] = STATE(2193),
    [sym_enum_specifier] = STATE(2193),
    [sym_struct_specifier] = STATE(2193),
    [sym_union_specifier] = STATE(2193),
    [sym_macro_type_specifier] = STATE(2193),
    [sym_class_specifier] = STATE(2193),
    [sym_dependent_type] = STATE(2193),
    [sym_template_type] = STATE(1481),
    [sym_scoped_type_identifier] = STATE(1482),
    [sym_scoped_namespace_identifier] = STATE(1483),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1484),
    [anon_sym_unsigned] = ACTIONS(3131),
    [anon_sym_long] = ACTIONS(3131),
    [anon_sym_short] = ACTIONS(3131),
    [sym_primitive_type] = ACTIONS(4748),
    [anon_sym_enum] = ACTIONS(3135),
    [anon_sym_struct] = ACTIONS(3137),
    [anon_sym_union] = ACTIONS(3139),
    [sym_identifier] = ACTIONS(3141),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3143),
    [sym_auto] = ACTIONS(4748),
    [anon_sym_typename] = ACTIONS(3145),
    [anon_sym_COLON_COLON] = ACTIONS(3147),
  },
  [1478] = {
    [sym_identifier] = ACTIONS(4750),
    [sym_comment] = ACTIONS(91),
  },
  [1479] = {
    [sym_argument_list] = STATE(2196),
    [sym_initializer_list] = STATE(2196),
    [sym_new_declarator] = STATE(2197),
    [anon_sym_COMMA] = ACTIONS(1556),
    [anon_sym_LBRACE] = ACTIONS(3114),
    [anon_sym_LPAREN2] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(1558),
    [anon_sym_LBRACK] = ACTIONS(4752),
    [anon_sym_EQ] = ACTIONS(1558),
    [anon_sym_QMARK] = ACTIONS(1556),
    [anon_sym_STAR_EQ] = ACTIONS(1556),
    [anon_sym_SLASH_EQ] = ACTIONS(1556),
    [anon_sym_PERCENT_EQ] = ACTIONS(1556),
    [anon_sym_PLUS_EQ] = ACTIONS(1556),
    [anon_sym_DASH_EQ] = ACTIONS(1556),
    [anon_sym_LT_LT_EQ] = ACTIONS(1556),
    [anon_sym_GT_GT_EQ] = ACTIONS(1556),
    [anon_sym_AMP_EQ] = ACTIONS(1556),
    [anon_sym_CARET_EQ] = ACTIONS(1556),
    [anon_sym_PIPE_EQ] = ACTIONS(1556),
    [anon_sym_AMP] = ACTIONS(1558),
    [anon_sym_PIPE_PIPE] = ACTIONS(1556),
    [anon_sym_AMP_AMP] = ACTIONS(1556),
    [anon_sym_PIPE] = ACTIONS(1558),
    [anon_sym_CARET] = ACTIONS(1558),
    [anon_sym_EQ_EQ] = ACTIONS(1556),
    [anon_sym_BANG_EQ] = ACTIONS(1556),
    [anon_sym_LT] = ACTIONS(1558),
    [anon_sym_GT] = ACTIONS(1558),
    [anon_sym_LT_EQ] = ACTIONS(1556),
    [anon_sym_GT_EQ] = ACTIONS(1556),
    [anon_sym_LT_LT] = ACTIONS(1558),
    [anon_sym_GT_GT] = ACTIONS(1558),
    [anon_sym_PLUS] = ACTIONS(1558),
    [anon_sym_DASH] = ACTIONS(1558),
    [anon_sym_SLASH] = ACTIONS(1558),
    [anon_sym_PERCENT] = ACTIONS(1558),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DOT] = ACTIONS(1556),
    [anon_sym_DASH_GT] = ACTIONS(1556),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(1556),
  },
  [1480] = {
    [sym__type_specifier] = STATE(2198),
    [sym_sized_type_specifier] = STATE(2198),
    [sym_enum_specifier] = STATE(2198),
    [sym_struct_specifier] = STATE(2198),
    [sym_union_specifier] = STATE(2198),
    [sym_macro_type_specifier] = STATE(2198),
    [sym_class_specifier] = STATE(2198),
    [sym_dependent_type] = STATE(2198),
    [sym_template_type] = STATE(1481),
    [sym_scoped_type_identifier] = STATE(1482),
    [sym_scoped_namespace_identifier] = STATE(1483),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1484),
    [anon_sym_unsigned] = ACTIONS(3131),
    [anon_sym_long] = ACTIONS(3131),
    [anon_sym_short] = ACTIONS(3131),
    [sym_primitive_type] = ACTIONS(4754),
    [anon_sym_enum] = ACTIONS(3135),
    [anon_sym_struct] = ACTIONS(3137),
    [anon_sym_union] = ACTIONS(3139),
    [sym_identifier] = ACTIONS(3141),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3143),
    [sym_auto] = ACTIONS(4754),
    [anon_sym_typename] = ACTIONS(3145),
    [anon_sym_COLON_COLON] = ACTIONS(3147),
  },
  [1481] = {
    [anon_sym_COMMA] = ACTIONS(624),
    [anon_sym_LBRACE] = ACTIONS(624),
    [anon_sym_LPAREN2] = ACTIONS(624),
    [anon_sym_STAR] = ACTIONS(626),
    [anon_sym_LBRACK] = ACTIONS(624),
    [anon_sym_EQ] = ACTIONS(626),
    [anon_sym_QMARK] = ACTIONS(624),
    [anon_sym_STAR_EQ] = ACTIONS(624),
    [anon_sym_SLASH_EQ] = ACTIONS(624),
    [anon_sym_PERCENT_EQ] = ACTIONS(624),
    [anon_sym_PLUS_EQ] = ACTIONS(624),
    [anon_sym_DASH_EQ] = ACTIONS(624),
    [anon_sym_LT_LT_EQ] = ACTIONS(624),
    [anon_sym_GT_GT_EQ] = ACTIONS(624),
    [anon_sym_AMP_EQ] = ACTIONS(624),
    [anon_sym_CARET_EQ] = ACTIONS(624),
    [anon_sym_PIPE_EQ] = ACTIONS(624),
    [anon_sym_AMP] = ACTIONS(626),
    [anon_sym_PIPE_PIPE] = ACTIONS(624),
    [anon_sym_AMP_AMP] = ACTIONS(624),
    [anon_sym_PIPE] = ACTIONS(626),
    [anon_sym_CARET] = ACTIONS(626),
    [anon_sym_EQ_EQ] = ACTIONS(624),
    [anon_sym_BANG_EQ] = ACTIONS(624),
    [anon_sym_LT] = ACTIONS(626),
    [anon_sym_GT] = ACTIONS(626),
    [anon_sym_LT_EQ] = ACTIONS(624),
    [anon_sym_GT_EQ] = ACTIONS(624),
    [anon_sym_LT_LT] = ACTIONS(626),
    [anon_sym_GT_GT] = ACTIONS(626),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_SLASH] = ACTIONS(626),
    [anon_sym_PERCENT] = ACTIONS(626),
    [anon_sym_DASH_DASH] = ACTIONS(624),
    [anon_sym_PLUS_PLUS] = ACTIONS(624),
    [anon_sym_DOT] = ACTIONS(624),
    [anon_sym_DASH_GT] = ACTIONS(624),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(624),
    [anon_sym_COLON_COLON] = ACTIONS(4756),
  },
  [1482] = {
    [sym_template_argument_list] = STATE(2200),
    [anon_sym_COMMA] = ACTIONS(624),
    [anon_sym_LBRACE] = ACTIONS(624),
    [anon_sym_LPAREN2] = ACTIONS(624),
    [anon_sym_STAR] = ACTIONS(626),
    [anon_sym_LBRACK] = ACTIONS(624),
    [anon_sym_EQ] = ACTIONS(626),
    [anon_sym_QMARK] = ACTIONS(624),
    [anon_sym_STAR_EQ] = ACTIONS(624),
    [anon_sym_SLASH_EQ] = ACTIONS(624),
    [anon_sym_PERCENT_EQ] = ACTIONS(624),
    [anon_sym_PLUS_EQ] = ACTIONS(624),
    [anon_sym_DASH_EQ] = ACTIONS(624),
    [anon_sym_LT_LT_EQ] = ACTIONS(624),
    [anon_sym_GT_GT_EQ] = ACTIONS(624),
    [anon_sym_AMP_EQ] = ACTIONS(624),
    [anon_sym_CARET_EQ] = ACTIONS(624),
    [anon_sym_PIPE_EQ] = ACTIONS(624),
    [anon_sym_AMP] = ACTIONS(626),
    [anon_sym_PIPE_PIPE] = ACTIONS(624),
    [anon_sym_AMP_AMP] = ACTIONS(624),
    [anon_sym_PIPE] = ACTIONS(626),
    [anon_sym_CARET] = ACTIONS(626),
    [anon_sym_EQ_EQ] = ACTIONS(624),
    [anon_sym_BANG_EQ] = ACTIONS(624),
    [anon_sym_LT] = ACTIONS(4758),
    [anon_sym_GT] = ACTIONS(626),
    [anon_sym_LT_EQ] = ACTIONS(624),
    [anon_sym_GT_EQ] = ACTIONS(624),
    [anon_sym_LT_LT] = ACTIONS(626),
    [anon_sym_GT_GT] = ACTIONS(626),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_SLASH] = ACTIONS(626),
    [anon_sym_PERCENT] = ACTIONS(626),
    [anon_sym_DASH_DASH] = ACTIONS(624),
    [anon_sym_PLUS_PLUS] = ACTIONS(624),
    [anon_sym_DOT] = ACTIONS(624),
    [anon_sym_DASH_GT] = ACTIONS(624),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(624),
  },
  [1483] = {
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(4756),
  },
  [1484] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2203),
    [anon_sym_COMMA] = ACTIONS(653),
    [anon_sym_LBRACE] = ACTIONS(653),
    [anon_sym_LPAREN2] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_EQ] = ACTIONS(655),
    [anon_sym_unsigned] = ACTIONS(4761),
    [anon_sym_long] = ACTIONS(4761),
    [anon_sym_short] = ACTIONS(4761),
    [sym_primitive_type] = ACTIONS(4763),
    [anon_sym_QMARK] = ACTIONS(653),
    [anon_sym_STAR_EQ] = ACTIONS(653),
    [anon_sym_SLASH_EQ] = ACTIONS(653),
    [anon_sym_PERCENT_EQ] = ACTIONS(653),
    [anon_sym_PLUS_EQ] = ACTIONS(653),
    [anon_sym_DASH_EQ] = ACTIONS(653),
    [anon_sym_LT_LT_EQ] = ACTIONS(653),
    [anon_sym_GT_GT_EQ] = ACTIONS(653),
    [anon_sym_AMP_EQ] = ACTIONS(653),
    [anon_sym_CARET_EQ] = ACTIONS(653),
    [anon_sym_PIPE_EQ] = ACTIONS(653),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_PIPE_PIPE] = ACTIONS(653),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(655),
    [anon_sym_EQ_EQ] = ACTIONS(653),
    [anon_sym_BANG_EQ] = ACTIONS(653),
    [anon_sym_LT] = ACTIONS(655),
    [anon_sym_GT] = ACTIONS(655),
    [anon_sym_LT_EQ] = ACTIONS(653),
    [anon_sym_GT_EQ] = ACTIONS(653),
    [anon_sym_LT_LT] = ACTIONS(655),
    [anon_sym_GT_GT] = ACTIONS(655),
    [anon_sym_PLUS] = ACTIONS(655),
    [anon_sym_DASH] = ACTIONS(655),
    [anon_sym_SLASH] = ACTIONS(655),
    [anon_sym_PERCENT] = ACTIONS(655),
    [anon_sym_DASH_DASH] = ACTIONS(653),
    [anon_sym_PLUS_PLUS] = ACTIONS(653),
    [anon_sym_DOT] = ACTIONS(653),
    [anon_sym_DASH_GT] = ACTIONS(653),
    [sym_identifier] = ACTIONS(4765),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(653),
  },
  [1485] = {
    [sym_identifier] = ACTIONS(4767),
    [sym_comment] = ACTIONS(91),
  },
  [1486] = {
    [anon_sym_COMMA] = ACTIONS(1577),
    [anon_sym_LBRACE] = ACTIONS(1582),
    [anon_sym_LPAREN2] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1584),
    [anon_sym_LBRACK] = ACTIONS(1577),
    [anon_sym_EQ] = ACTIONS(1587),
    [anon_sym_QMARK] = ACTIONS(1575),
    [anon_sym_STAR_EQ] = ACTIONS(1575),
    [anon_sym_SLASH_EQ] = ACTIONS(1575),
    [anon_sym_PERCENT_EQ] = ACTIONS(1575),
    [anon_sym_PLUS_EQ] = ACTIONS(1575),
    [anon_sym_DASH_EQ] = ACTIONS(1575),
    [anon_sym_LT_LT_EQ] = ACTIONS(1575),
    [anon_sym_GT_GT_EQ] = ACTIONS(1575),
    [anon_sym_AMP_EQ] = ACTIONS(1575),
    [anon_sym_CARET_EQ] = ACTIONS(1575),
    [anon_sym_PIPE_EQ] = ACTIONS(1575),
    [anon_sym_AMP] = ACTIONS(1584),
    [anon_sym_PIPE_PIPE] = ACTIONS(1575),
    [anon_sym_AMP_AMP] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(1587),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_EQ_EQ] = ACTIONS(1575),
    [anon_sym_BANG_EQ] = ACTIONS(1575),
    [anon_sym_LT] = ACTIONS(1584),
    [anon_sym_GT] = ACTIONS(1587),
    [anon_sym_LT_EQ] = ACTIONS(1575),
    [anon_sym_GT_EQ] = ACTIONS(1575),
    [anon_sym_LT_LT] = ACTIONS(1587),
    [anon_sym_GT_GT] = ACTIONS(1587),
    [anon_sym_PLUS] = ACTIONS(1587),
    [anon_sym_DASH] = ACTIONS(1587),
    [anon_sym_SLASH] = ACTIONS(1587),
    [anon_sym_PERCENT] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1575),
    [anon_sym_PLUS_PLUS] = ACTIONS(1575),
    [anon_sym_DOT] = ACTIONS(1575),
    [anon_sym_DASH_GT] = ACTIONS(1575),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(1577),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
  },
  [1487] = {
    [sym__expression] = STATE(2206),
    [sym_conditional_expression] = STATE(2206),
    [sym_assignment_expression] = STATE(2206),
    [sym_pointer_expression] = STATE(2206),
    [sym_logical_expression] = STATE(2206),
    [sym_bitwise_expression] = STATE(2206),
    [sym_equality_expression] = STATE(2206),
    [sym_relational_expression] = STATE(2206),
    [sym_shift_expression] = STATE(2206),
    [sym_math_expression] = STATE(2206),
    [sym_cast_expression] = STATE(2206),
    [sym_sizeof_expression] = STATE(2206),
    [sym_subscript_expression] = STATE(2206),
    [sym_call_expression] = STATE(2206),
    [sym_field_expression] = STATE(2206),
    [sym_compound_literal_expression] = STATE(2206),
    [sym_parenthesized_expression] = STATE(2206),
    [sym_char_literal] = STATE(2206),
    [sym_concatenated_string] = STATE(2206),
    [sym_string_literal] = STATE(780),
    [sym_template_type] = STATE(1454),
    [sym_template_function] = STATE(2206),
    [sym_new_expression] = STATE(2206),
    [sym_delete_expression] = STATE(2206),
    [sym_lambda_expression] = STATE(2206),
    [sym_lambda_capture_specifier] = STATE(782),
    [sym_scoped_identifier] = STATE(783),
    [sym_scoped_type_identifier] = STATE(1455),
    [sym_scoped_namespace_identifier] = STATE(1456),
    [sym_raw_string_literal] = ACTIONS(4769),
    [anon_sym_LPAREN2] = ACTIONS(1380),
    [anon_sym_STAR] = ACTIONS(1382),
    [anon_sym_LBRACK] = ACTIONS(4771),
    [anon_sym_AMP] = ACTIONS(1382),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1394),
    [anon_sym_PLUS_PLUS] = ACTIONS(1394),
    [anon_sym_sizeof] = ACTIONS(1396),
    [sym_number_literal] = ACTIONS(4769),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_true] = ACTIONS(4773),
    [sym_false] = ACTIONS(4773),
    [sym_null] = ACTIONS(4773),
    [sym_identifier] = ACTIONS(3084),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1410),
    [anon_sym_new] = ACTIONS(1412),
    [anon_sym_COLON_COLON] = ACTIONS(3086),
    [sym_nullptr] = ACTIONS(4773),
  },
  [1488] = {
    [anon_sym_COMMA] = ACTIONS(1575),
    [anon_sym_LBRACE] = ACTIONS(1575),
    [anon_sym_LPAREN2] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(1587),
    [anon_sym_LBRACK] = ACTIONS(1575),
    [anon_sym_EQ] = ACTIONS(1587),
    [anon_sym_QMARK] = ACTIONS(1575),
    [anon_sym_STAR_EQ] = ACTIONS(1575),
    [anon_sym_SLASH_EQ] = ACTIONS(1575),
    [anon_sym_PERCENT_EQ] = ACTIONS(1575),
    [anon_sym_PLUS_EQ] = ACTIONS(1575),
    [anon_sym_DASH_EQ] = ACTIONS(1575),
    [anon_sym_LT_LT_EQ] = ACTIONS(1575),
    [anon_sym_GT_GT_EQ] = ACTIONS(1575),
    [anon_sym_AMP_EQ] = ACTIONS(1575),
    [anon_sym_CARET_EQ] = ACTIONS(1575),
    [anon_sym_PIPE_EQ] = ACTIONS(1575),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_PIPE_PIPE] = ACTIONS(1575),
    [anon_sym_AMP_AMP] = ACTIONS(1575),
    [anon_sym_PIPE] = ACTIONS(1587),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_EQ_EQ] = ACTIONS(1575),
    [anon_sym_BANG_EQ] = ACTIONS(1575),
    [anon_sym_LT] = ACTIONS(1587),
    [anon_sym_GT] = ACTIONS(1587),
    [anon_sym_LT_EQ] = ACTIONS(1575),
    [anon_sym_GT_EQ] = ACTIONS(1575),
    [anon_sym_LT_LT] = ACTIONS(1587),
    [anon_sym_GT_GT] = ACTIONS(1587),
    [anon_sym_PLUS] = ACTIONS(1587),
    [anon_sym_DASH] = ACTIONS(1587),
    [anon_sym_SLASH] = ACTIONS(1587),
    [anon_sym_PERCENT] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1575),
    [anon_sym_PLUS_PLUS] = ACTIONS(1575),
    [anon_sym_DOT] = ACTIONS(1575),
    [anon_sym_DASH_GT] = ACTIONS(1575),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(1575),
  },
  [1489] = {
    [sym__abstract_declarator] = STATE(2207),
    [sym_abstract_pointer_declarator] = STATE(2207),
    [sym_abstract_function_declarator] = STATE(2207),
    [sym_abstract_array_declarator] = STATE(2207),
    [sym_type_qualifier] = STATE(2208),
    [sym_parameter_list] = STATE(1492),
    [sym_abstract_reference_declarator] = STATE(2207),
    [aux_sym_type_definition_repeat1] = STATE(2208),
    [anon_sym_COMMA] = ACTIONS(2461),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(3157),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(3159),
    [anon_sym_AMP_AMP] = ACTIONS(3161),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(2461),
  },
  [1490] = {
    [sym__abstract_declarator] = STATE(2209),
    [sym_abstract_pointer_declarator] = STATE(2209),
    [sym_abstract_function_declarator] = STATE(2209),
    [sym_abstract_array_declarator] = STATE(2209),
    [sym_parameter_list] = STATE(1492),
    [sym_abstract_reference_declarator] = STATE(2209),
    [anon_sym_COMMA] = ACTIONS(2463),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(3157),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_AMP] = ACTIONS(3159),
    [anon_sym_AMP_AMP] = ACTIONS(3161),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(2463),
  },
  [1491] = {
    [sym_parameter_list] = STATE(2210),
    [anon_sym_COMMA] = ACTIONS(2465),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(2465),
  },
  [1492] = {
    [sym_type_qualifier] = STATE(2212),
    [sym_trailing_return_type] = STATE(971),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2212),
    [anon_sym_COMMA] = ACTIONS(1787),
    [anon_sym_LPAREN2] = ACTIONS(1787),
    [anon_sym_LBRACK] = ACTIONS(1787),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(4775),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(1787),
    [sym_noexcept] = ACTIONS(4777),
  },
  [1493] = {
    [sym_type_qualifier] = STATE(786),
    [sym__type_specifier] = STATE(777),
    [sym_sized_type_specifier] = STATE(777),
    [sym_enum_specifier] = STATE(777),
    [sym_struct_specifier] = STATE(777),
    [sym_union_specifier] = STATE(777),
    [sym__expression] = STATE(2213),
    [sym_conditional_expression] = STATE(2213),
    [sym_assignment_expression] = STATE(2213),
    [sym_pointer_expression] = STATE(2213),
    [sym_logical_expression] = STATE(2213),
    [sym_bitwise_expression] = STATE(2213),
    [sym_equality_expression] = STATE(2213),
    [sym_relational_expression] = STATE(2213),
    [sym_shift_expression] = STATE(2213),
    [sym_math_expression] = STATE(2213),
    [sym_cast_expression] = STATE(2213),
    [sym_type_descriptor] = STATE(2214),
    [sym_sizeof_expression] = STATE(2213),
    [sym_subscript_expression] = STATE(2213),
    [sym_call_expression] = STATE(2213),
    [sym_field_expression] = STATE(2213),
    [sym_compound_literal_expression] = STATE(2213),
    [sym_parenthesized_expression] = STATE(2213),
    [sym_char_literal] = STATE(2213),
    [sym_concatenated_string] = STATE(2213),
    [sym_string_literal] = STATE(780),
    [sym_macro_type_specifier] = STATE(777),
    [sym_class_specifier] = STATE(777),
    [sym_dependent_type] = STATE(777),
    [sym_template_type] = STATE(781),
    [sym_template_function] = STATE(2213),
    [sym_new_expression] = STATE(2213),
    [sym_delete_expression] = STATE(2213),
    [sym_lambda_expression] = STATE(2213),
    [sym_lambda_capture_specifier] = STATE(782),
    [sym_scoped_identifier] = STATE(783),
    [sym_scoped_type_identifier] = STATE(784),
    [sym_scoped_namespace_identifier] = STATE(785),
    [aux_sym_type_definition_repeat1] = STATE(786),
    [aux_sym_sized_type_specifier_repeat1] = STATE(787),
    [sym_raw_string_literal] = ACTIONS(4779),
    [anon_sym_LPAREN2] = ACTIONS(1380),
    [anon_sym_STAR] = ACTIONS(1382),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(1384),
    [anon_sym_long] = ACTIONS(1384),
    [anon_sym_short] = ACTIONS(1384),
    [sym_primitive_type] = ACTIONS(1386),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [anon_sym_AMP] = ACTIONS(1382),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1394),
    [anon_sym_PLUS_PLUS] = ACTIONS(1394),
    [anon_sym_sizeof] = ACTIONS(1396),
    [sym_number_literal] = ACTIONS(4779),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_true] = ACTIONS(4781),
    [sym_false] = ACTIONS(4781),
    [sym_null] = ACTIONS(4781),
    [sym_identifier] = ACTIONS(1404),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(1386),
    [anon_sym_typename] = ACTIONS(1406),
    [anon_sym_delete] = ACTIONS(1410),
    [anon_sym_new] = ACTIONS(1412),
    [anon_sym_COLON_COLON] = ACTIONS(1414),
    [sym_nullptr] = ACTIONS(4781),
  },
  [1494] = {
    [sym__expression] = STATE(2216),
    [sym_conditional_expression] = STATE(2216),
    [sym_assignment_expression] = STATE(2216),
    [sym_pointer_expression] = STATE(2216),
    [sym_logical_expression] = STATE(2216),
    [sym_bitwise_expression] = STATE(2216),
    [sym_equality_expression] = STATE(2216),
    [sym_relational_expression] = STATE(2216),
    [sym_shift_expression] = STATE(2216),
    [sym_math_expression] = STATE(2216),
    [sym_cast_expression] = STATE(2216),
    [sym_sizeof_expression] = STATE(2216),
    [sym_subscript_expression] = STATE(2216),
    [sym_call_expression] = STATE(2216),
    [sym_field_expression] = STATE(2216),
    [sym_compound_literal_expression] = STATE(2216),
    [sym_parenthesized_expression] = STATE(2216),
    [sym_initializer_list] = STATE(2217),
    [sym_char_literal] = STATE(2216),
    [sym_concatenated_string] = STATE(2216),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2216),
    [sym_new_expression] = STATE(2216),
    [sym_delete_expression] = STATE(2216),
    [sym_lambda_expression] = STATE(2216),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4783),
    [anon_sym_RPAREN] = ACTIONS(4785),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(4783),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4787),
    [sym_false] = ACTIONS(4787),
    [sym_null] = ACTIONS(4787),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(4787),
  },
  [1495] = {
    [sym__expression] = STATE(2218),
    [sym_conditional_expression] = STATE(2218),
    [sym_assignment_expression] = STATE(2218),
    [sym_pointer_expression] = STATE(2218),
    [sym_logical_expression] = STATE(2218),
    [sym_bitwise_expression] = STATE(2218),
    [sym_equality_expression] = STATE(2218),
    [sym_relational_expression] = STATE(2218),
    [sym_shift_expression] = STATE(2218),
    [sym_math_expression] = STATE(2218),
    [sym_cast_expression] = STATE(2218),
    [sym_sizeof_expression] = STATE(2218),
    [sym_subscript_expression] = STATE(2218),
    [sym_call_expression] = STATE(2218),
    [sym_field_expression] = STATE(2218),
    [sym_compound_literal_expression] = STATE(2218),
    [sym_parenthesized_expression] = STATE(2218),
    [sym_char_literal] = STATE(2218),
    [sym_concatenated_string] = STATE(2218),
    [sym_string_literal] = STATE(780),
    [sym_template_type] = STATE(1454),
    [sym_template_function] = STATE(2218),
    [sym_new_expression] = STATE(2218),
    [sym_delete_expression] = STATE(2218),
    [sym_lambda_expression] = STATE(2218),
    [sym_lambda_capture_specifier] = STATE(782),
    [sym_scoped_identifier] = STATE(783),
    [sym_scoped_type_identifier] = STATE(1455),
    [sym_scoped_namespace_identifier] = STATE(1456),
    [sym_raw_string_literal] = ACTIONS(4789),
    [anon_sym_LPAREN2] = ACTIONS(1380),
    [anon_sym_STAR] = ACTIONS(1382),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1382),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1394),
    [anon_sym_PLUS_PLUS] = ACTIONS(1394),
    [anon_sym_sizeof] = ACTIONS(1396),
    [sym_number_literal] = ACTIONS(4789),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_true] = ACTIONS(4791),
    [sym_false] = ACTIONS(4791),
    [sym_null] = ACTIONS(4791),
    [sym_identifier] = ACTIONS(3084),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1410),
    [anon_sym_new] = ACTIONS(1412),
    [anon_sym_COLON_COLON] = ACTIONS(3086),
    [sym_nullptr] = ACTIONS(4791),
  },
  [1496] = {
    [sym__expression] = STATE(2219),
    [sym_conditional_expression] = STATE(2219),
    [sym_assignment_expression] = STATE(2219),
    [sym_pointer_expression] = STATE(2219),
    [sym_logical_expression] = STATE(2219),
    [sym_bitwise_expression] = STATE(2219),
    [sym_equality_expression] = STATE(2219),
    [sym_relational_expression] = STATE(2219),
    [sym_shift_expression] = STATE(2219),
    [sym_math_expression] = STATE(2219),
    [sym_cast_expression] = STATE(2219),
    [sym_sizeof_expression] = STATE(2219),
    [sym_subscript_expression] = STATE(2219),
    [sym_call_expression] = STATE(2219),
    [sym_field_expression] = STATE(2219),
    [sym_compound_literal_expression] = STATE(2219),
    [sym_parenthesized_expression] = STATE(2219),
    [sym_char_literal] = STATE(2219),
    [sym_concatenated_string] = STATE(2219),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2219),
    [sym_new_expression] = STATE(2219),
    [sym_delete_expression] = STATE(2219),
    [sym_lambda_expression] = STATE(2219),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4793),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(4793),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4795),
    [sym_false] = ACTIONS(4795),
    [sym_null] = ACTIONS(4795),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(4795),
  },
  [1497] = {
    [sym__expression] = STATE(2220),
    [sym_conditional_expression] = STATE(2220),
    [sym_assignment_expression] = STATE(2220),
    [sym_pointer_expression] = STATE(2220),
    [sym_logical_expression] = STATE(2220),
    [sym_bitwise_expression] = STATE(2220),
    [sym_equality_expression] = STATE(2220),
    [sym_relational_expression] = STATE(2220),
    [sym_shift_expression] = STATE(2220),
    [sym_math_expression] = STATE(2220),
    [sym_cast_expression] = STATE(2220),
    [sym_sizeof_expression] = STATE(2220),
    [sym_subscript_expression] = STATE(2220),
    [sym_call_expression] = STATE(2220),
    [sym_field_expression] = STATE(2220),
    [sym_compound_literal_expression] = STATE(2220),
    [sym_parenthesized_expression] = STATE(2220),
    [sym_char_literal] = STATE(2220),
    [sym_concatenated_string] = STATE(2220),
    [sym_string_literal] = STATE(780),
    [sym_template_type] = STATE(1454),
    [sym_template_function] = STATE(2220),
    [sym_new_expression] = STATE(2220),
    [sym_delete_expression] = STATE(2220),
    [sym_lambda_expression] = STATE(2220),
    [sym_lambda_capture_specifier] = STATE(782),
    [sym_scoped_identifier] = STATE(783),
    [sym_scoped_type_identifier] = STATE(1455),
    [sym_scoped_namespace_identifier] = STATE(1456),
    [sym_raw_string_literal] = ACTIONS(4797),
    [anon_sym_LPAREN2] = ACTIONS(1380),
    [anon_sym_STAR] = ACTIONS(1382),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1382),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1394),
    [anon_sym_PLUS_PLUS] = ACTIONS(1394),
    [anon_sym_sizeof] = ACTIONS(1396),
    [sym_number_literal] = ACTIONS(4797),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_true] = ACTIONS(4799),
    [sym_false] = ACTIONS(4799),
    [sym_null] = ACTIONS(4799),
    [sym_identifier] = ACTIONS(3084),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1410),
    [anon_sym_new] = ACTIONS(1412),
    [anon_sym_COLON_COLON] = ACTIONS(3086),
    [sym_nullptr] = ACTIONS(4799),
  },
  [1498] = {
    [sym__expression] = STATE(2221),
    [sym_conditional_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2221),
    [sym_pointer_expression] = STATE(2221),
    [sym_logical_expression] = STATE(2221),
    [sym_bitwise_expression] = STATE(2221),
    [sym_equality_expression] = STATE(2221),
    [sym_relational_expression] = STATE(2221),
    [sym_shift_expression] = STATE(2221),
    [sym_math_expression] = STATE(2221),
    [sym_cast_expression] = STATE(2221),
    [sym_sizeof_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_call_expression] = STATE(2221),
    [sym_field_expression] = STATE(2221),
    [sym_compound_literal_expression] = STATE(2221),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_char_literal] = STATE(2221),
    [sym_concatenated_string] = STATE(2221),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2221),
    [sym_new_expression] = STATE(2221),
    [sym_delete_expression] = STATE(2221),
    [sym_lambda_expression] = STATE(2221),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4801),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(4801),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(4803),
    [sym_false] = ACTIONS(4803),
    [sym_null] = ACTIONS(4803),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(4803),
  },
  [1499] = {
    [sym__expression] = STATE(2222),
    [sym_conditional_expression] = STATE(2222),
    [sym_assignment_expression] = STATE(2222),
    [sym_pointer_expression] = STATE(2222),
    [sym_logical_expression] = STATE(2222),
    [sym_bitwise_expression] = STATE(2222),
    [sym_equality_expression] = STATE(2222),
    [sym_relational_expression] = STATE(2222),
    [sym_shift_expression] = STATE(2222),
    [sym_math_expression] = STATE(2222),
    [sym_cast_expression] = STATE(2222),
    [sym_sizeof_expression] = STATE(2222),
    [sym_subscript_expression] = STATE(2222),
    [sym_call_expression] = STATE(2222),
    [sym_field_expression] = STATE(2222),
    [sym_compound_literal_expression] = STATE(2222),
    [sym_parenthesized_expression] = STATE(2222),
    [sym_char_literal] = STATE(2222),
    [sym_concatenated_string] = STATE(2222),
    [sym_string_literal] = STATE(780),
    [sym_template_type] = STATE(1454),
    [sym_template_function] = STATE(2222),
    [sym_new_expression] = STATE(2222),
    [sym_delete_expression] = STATE(2222),
    [sym_lambda_expression] = STATE(2222),
    [sym_lambda_capture_specifier] = STATE(782),
    [sym_scoped_identifier] = STATE(783),
    [sym_scoped_type_identifier] = STATE(1455),
    [sym_scoped_namespace_identifier] = STATE(1456),
    [sym_raw_string_literal] = ACTIONS(4805),
    [anon_sym_LPAREN2] = ACTIONS(1380),
    [anon_sym_STAR] = ACTIONS(1382),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1382),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1394),
    [anon_sym_PLUS_PLUS] = ACTIONS(1394),
    [anon_sym_sizeof] = ACTIONS(1396),
    [sym_number_literal] = ACTIONS(4805),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_true] = ACTIONS(4807),
    [sym_false] = ACTIONS(4807),
    [sym_null] = ACTIONS(4807),
    [sym_identifier] = ACTIONS(3084),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1410),
    [anon_sym_new] = ACTIONS(1412),
    [anon_sym_COLON_COLON] = ACTIONS(3086),
    [sym_nullptr] = ACTIONS(4807),
  },
  [1500] = {
    [sym__expression] = STATE(2223),
    [sym_conditional_expression] = STATE(2223),
    [sym_assignment_expression] = STATE(2223),
    [sym_pointer_expression] = STATE(2223),
    [sym_logical_expression] = STATE(2223),
    [sym_bitwise_expression] = STATE(2223),
    [sym_equality_expression] = STATE(2223),
    [sym_relational_expression] = STATE(2223),
    [sym_shift_expression] = STATE(2223),
    [sym_math_expression] = STATE(2223),
    [sym_cast_expression] = STATE(2223),
    [sym_sizeof_expression] = STATE(2223),
    [sym_subscript_expression] = STATE(2223),
    [sym_call_expression] = STATE(2223),
    [sym_field_expression] = STATE(2223),
    [sym_compound_literal_expression] = STATE(2223),
    [sym_parenthesized_expression] = STATE(2223),
    [sym_char_literal] = STATE(2223),
    [sym_concatenated_string] = STATE(2223),
    [sym_string_literal] = STATE(780),
    [sym_template_type] = STATE(1454),
    [sym_template_function] = STATE(2223),
    [sym_new_expression] = STATE(2223),
    [sym_delete_expression] = STATE(2223),
    [sym_lambda_expression] = STATE(2223),
    [sym_lambda_capture_specifier] = STATE(782),
    [sym_scoped_identifier] = STATE(783),
    [sym_scoped_type_identifier] = STATE(1455),
    [sym_scoped_namespace_identifier] = STATE(1456),
    [sym_raw_string_literal] = ACTIONS(4809),
    [anon_sym_LPAREN2] = ACTIONS(1380),
    [anon_sym_STAR] = ACTIONS(1382),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1382),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1394),
    [anon_sym_PLUS_PLUS] = ACTIONS(1394),
    [anon_sym_sizeof] = ACTIONS(1396),
    [sym_number_literal] = ACTIONS(4809),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_true] = ACTIONS(4811),
    [sym_false] = ACTIONS(4811),
    [sym_null] = ACTIONS(4811),
    [sym_identifier] = ACTIONS(3084),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1410),
    [anon_sym_new] = ACTIONS(1412),
    [anon_sym_COLON_COLON] = ACTIONS(3086),
    [sym_nullptr] = ACTIONS(4811),
  },
  [1501] = {
    [sym__expression] = STATE(2224),
    [sym_conditional_expression] = STATE(2224),
    [sym_assignment_expression] = STATE(2224),
    [sym_pointer_expression] = STATE(2224),
    [sym_logical_expression] = STATE(2224),
    [sym_bitwise_expression] = STATE(2224),
    [sym_equality_expression] = STATE(2224),
    [sym_relational_expression] = STATE(2224),
    [sym_shift_expression] = STATE(2224),
    [sym_math_expression] = STATE(2224),
    [sym_cast_expression] = STATE(2224),
    [sym_sizeof_expression] = STATE(2224),
    [sym_subscript_expression] = STATE(2224),
    [sym_call_expression] = STATE(2224),
    [sym_field_expression] = STATE(2224),
    [sym_compound_literal_expression] = STATE(2224),
    [sym_parenthesized_expression] = STATE(2224),
    [sym_char_literal] = STATE(2224),
    [sym_concatenated_string] = STATE(2224),
    [sym_string_literal] = STATE(780),
    [sym_template_type] = STATE(1454),
    [sym_template_function] = STATE(2224),
    [sym_new_expression] = STATE(2224),
    [sym_delete_expression] = STATE(2224),
    [sym_lambda_expression] = STATE(2224),
    [sym_lambda_capture_specifier] = STATE(782),
    [sym_scoped_identifier] = STATE(783),
    [sym_scoped_type_identifier] = STATE(1455),
    [sym_scoped_namespace_identifier] = STATE(1456),
    [sym_raw_string_literal] = ACTIONS(4813),
    [anon_sym_LPAREN2] = ACTIONS(1380),
    [anon_sym_STAR] = ACTIONS(1382),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1382),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1394),
    [anon_sym_PLUS_PLUS] = ACTIONS(1394),
    [anon_sym_sizeof] = ACTIONS(1396),
    [sym_number_literal] = ACTIONS(4813),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_true] = ACTIONS(4815),
    [sym_false] = ACTIONS(4815),
    [sym_null] = ACTIONS(4815),
    [sym_identifier] = ACTIONS(3084),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1410),
    [anon_sym_new] = ACTIONS(1412),
    [anon_sym_COLON_COLON] = ACTIONS(3086),
    [sym_nullptr] = ACTIONS(4815),
  },
  [1502] = {
    [sym__expression] = STATE(2225),
    [sym_conditional_expression] = STATE(2225),
    [sym_assignment_expression] = STATE(2225),
    [sym_pointer_expression] = STATE(2225),
    [sym_logical_expression] = STATE(2225),
    [sym_bitwise_expression] = STATE(2225),
    [sym_equality_expression] = STATE(2225),
    [sym_relational_expression] = STATE(2225),
    [sym_shift_expression] = STATE(2225),
    [sym_math_expression] = STATE(2225),
    [sym_cast_expression] = STATE(2225),
    [sym_sizeof_expression] = STATE(2225),
    [sym_subscript_expression] = STATE(2225),
    [sym_call_expression] = STATE(2225),
    [sym_field_expression] = STATE(2225),
    [sym_compound_literal_expression] = STATE(2225),
    [sym_parenthesized_expression] = STATE(2225),
    [sym_char_literal] = STATE(2225),
    [sym_concatenated_string] = STATE(2225),
    [sym_string_literal] = STATE(780),
    [sym_template_type] = STATE(1454),
    [sym_template_function] = STATE(2225),
    [sym_new_expression] = STATE(2225),
    [sym_delete_expression] = STATE(2225),
    [sym_lambda_expression] = STATE(2225),
    [sym_lambda_capture_specifier] = STATE(782),
    [sym_scoped_identifier] = STATE(783),
    [sym_scoped_type_identifier] = STATE(1455),
    [sym_scoped_namespace_identifier] = STATE(1456),
    [sym_raw_string_literal] = ACTIONS(4817),
    [anon_sym_LPAREN2] = ACTIONS(1380),
    [anon_sym_STAR] = ACTIONS(1382),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1382),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1394),
    [anon_sym_PLUS_PLUS] = ACTIONS(1394),
    [anon_sym_sizeof] = ACTIONS(1396),
    [sym_number_literal] = ACTIONS(4817),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_true] = ACTIONS(4819),
    [sym_false] = ACTIONS(4819),
    [sym_null] = ACTIONS(4819),
    [sym_identifier] = ACTIONS(3084),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1410),
    [anon_sym_new] = ACTIONS(1412),
    [anon_sym_COLON_COLON] = ACTIONS(3086),
    [sym_nullptr] = ACTIONS(4819),
  },
  [1503] = {
    [sym__expression] = STATE(2226),
    [sym_conditional_expression] = STATE(2226),
    [sym_assignment_expression] = STATE(2226),
    [sym_pointer_expression] = STATE(2226),
    [sym_logical_expression] = STATE(2226),
    [sym_bitwise_expression] = STATE(2226),
    [sym_equality_expression] = STATE(2226),
    [sym_relational_expression] = STATE(2226),
    [sym_shift_expression] = STATE(2226),
    [sym_math_expression] = STATE(2226),
    [sym_cast_expression] = STATE(2226),
    [sym_sizeof_expression] = STATE(2226),
    [sym_subscript_expression] = STATE(2226),
    [sym_call_expression] = STATE(2226),
    [sym_field_expression] = STATE(2226),
    [sym_compound_literal_expression] = STATE(2226),
    [sym_parenthesized_expression] = STATE(2226),
    [sym_char_literal] = STATE(2226),
    [sym_concatenated_string] = STATE(2226),
    [sym_string_literal] = STATE(780),
    [sym_template_type] = STATE(1454),
    [sym_template_function] = STATE(2226),
    [sym_new_expression] = STATE(2226),
    [sym_delete_expression] = STATE(2226),
    [sym_lambda_expression] = STATE(2226),
    [sym_lambda_capture_specifier] = STATE(782),
    [sym_scoped_identifier] = STATE(783),
    [sym_scoped_type_identifier] = STATE(1455),
    [sym_scoped_namespace_identifier] = STATE(1456),
    [sym_raw_string_literal] = ACTIONS(4821),
    [anon_sym_LPAREN2] = ACTIONS(1380),
    [anon_sym_STAR] = ACTIONS(1382),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1382),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1394),
    [anon_sym_PLUS_PLUS] = ACTIONS(1394),
    [anon_sym_sizeof] = ACTIONS(1396),
    [sym_number_literal] = ACTIONS(4821),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_true] = ACTIONS(4823),
    [sym_false] = ACTIONS(4823),
    [sym_null] = ACTIONS(4823),
    [sym_identifier] = ACTIONS(3084),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1410),
    [anon_sym_new] = ACTIONS(1412),
    [anon_sym_COLON_COLON] = ACTIONS(3086),
    [sym_nullptr] = ACTIONS(4823),
  },
  [1504] = {
    [sym__expression] = STATE(2227),
    [sym_conditional_expression] = STATE(2227),
    [sym_assignment_expression] = STATE(2227),
    [sym_pointer_expression] = STATE(2227),
    [sym_logical_expression] = STATE(2227),
    [sym_bitwise_expression] = STATE(2227),
    [sym_equality_expression] = STATE(2227),
    [sym_relational_expression] = STATE(2227),
    [sym_shift_expression] = STATE(2227),
    [sym_math_expression] = STATE(2227),
    [sym_cast_expression] = STATE(2227),
    [sym_sizeof_expression] = STATE(2227),
    [sym_subscript_expression] = STATE(2227),
    [sym_call_expression] = STATE(2227),
    [sym_field_expression] = STATE(2227),
    [sym_compound_literal_expression] = STATE(2227),
    [sym_parenthesized_expression] = STATE(2227),
    [sym_char_literal] = STATE(2227),
    [sym_concatenated_string] = STATE(2227),
    [sym_string_literal] = STATE(780),
    [sym_template_type] = STATE(1454),
    [sym_template_function] = STATE(2227),
    [sym_new_expression] = STATE(2227),
    [sym_delete_expression] = STATE(2227),
    [sym_lambda_expression] = STATE(2227),
    [sym_lambda_capture_specifier] = STATE(782),
    [sym_scoped_identifier] = STATE(783),
    [sym_scoped_type_identifier] = STATE(1455),
    [sym_scoped_namespace_identifier] = STATE(1456),
    [sym_raw_string_literal] = ACTIONS(4825),
    [anon_sym_LPAREN2] = ACTIONS(1380),
    [anon_sym_STAR] = ACTIONS(1382),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1382),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1394),
    [anon_sym_PLUS_PLUS] = ACTIONS(1394),
    [anon_sym_sizeof] = ACTIONS(1396),
    [sym_number_literal] = ACTIONS(4825),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_true] = ACTIONS(4827),
    [sym_false] = ACTIONS(4827),
    [sym_null] = ACTIONS(4827),
    [sym_identifier] = ACTIONS(3084),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1410),
    [anon_sym_new] = ACTIONS(1412),
    [anon_sym_COLON_COLON] = ACTIONS(3086),
    [sym_nullptr] = ACTIONS(4827),
  },
  [1505] = {
    [sym__expression] = STATE(2228),
    [sym_conditional_expression] = STATE(2228),
    [sym_assignment_expression] = STATE(2228),
    [sym_pointer_expression] = STATE(2228),
    [sym_logical_expression] = STATE(2228),
    [sym_bitwise_expression] = STATE(2228),
    [sym_equality_expression] = STATE(2228),
    [sym_relational_expression] = STATE(2228),
    [sym_shift_expression] = STATE(2228),
    [sym_math_expression] = STATE(2228),
    [sym_cast_expression] = STATE(2228),
    [sym_sizeof_expression] = STATE(2228),
    [sym_subscript_expression] = STATE(2228),
    [sym_call_expression] = STATE(2228),
    [sym_field_expression] = STATE(2228),
    [sym_compound_literal_expression] = STATE(2228),
    [sym_parenthesized_expression] = STATE(2228),
    [sym_char_literal] = STATE(2228),
    [sym_concatenated_string] = STATE(2228),
    [sym_string_literal] = STATE(780),
    [sym_template_type] = STATE(1454),
    [sym_template_function] = STATE(2228),
    [sym_new_expression] = STATE(2228),
    [sym_delete_expression] = STATE(2228),
    [sym_lambda_expression] = STATE(2228),
    [sym_lambda_capture_specifier] = STATE(782),
    [sym_scoped_identifier] = STATE(783),
    [sym_scoped_type_identifier] = STATE(1455),
    [sym_scoped_namespace_identifier] = STATE(1456),
    [sym_raw_string_literal] = ACTIONS(4829),
    [anon_sym_LPAREN2] = ACTIONS(1380),
    [anon_sym_STAR] = ACTIONS(1382),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1382),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1394),
    [anon_sym_PLUS_PLUS] = ACTIONS(1394),
    [anon_sym_sizeof] = ACTIONS(1396),
    [sym_number_literal] = ACTIONS(4829),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_true] = ACTIONS(4831),
    [sym_false] = ACTIONS(4831),
    [sym_null] = ACTIONS(4831),
    [sym_identifier] = ACTIONS(3084),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1410),
    [anon_sym_new] = ACTIONS(1412),
    [anon_sym_COLON_COLON] = ACTIONS(3086),
    [sym_nullptr] = ACTIONS(4831),
  },
  [1506] = {
    [sym__expression] = STATE(2229),
    [sym_conditional_expression] = STATE(2229),
    [sym_assignment_expression] = STATE(2229),
    [sym_pointer_expression] = STATE(2229),
    [sym_logical_expression] = STATE(2229),
    [sym_bitwise_expression] = STATE(2229),
    [sym_equality_expression] = STATE(2229),
    [sym_relational_expression] = STATE(2229),
    [sym_shift_expression] = STATE(2229),
    [sym_math_expression] = STATE(2229),
    [sym_cast_expression] = STATE(2229),
    [sym_sizeof_expression] = STATE(2229),
    [sym_subscript_expression] = STATE(2229),
    [sym_call_expression] = STATE(2229),
    [sym_field_expression] = STATE(2229),
    [sym_compound_literal_expression] = STATE(2229),
    [sym_parenthesized_expression] = STATE(2229),
    [sym_char_literal] = STATE(2229),
    [sym_concatenated_string] = STATE(2229),
    [sym_string_literal] = STATE(780),
    [sym_template_type] = STATE(1454),
    [sym_template_function] = STATE(2229),
    [sym_new_expression] = STATE(2229),
    [sym_delete_expression] = STATE(2229),
    [sym_lambda_expression] = STATE(2229),
    [sym_lambda_capture_specifier] = STATE(782),
    [sym_scoped_identifier] = STATE(783),
    [sym_scoped_type_identifier] = STATE(1455),
    [sym_scoped_namespace_identifier] = STATE(1456),
    [sym_raw_string_literal] = ACTIONS(4833),
    [anon_sym_LPAREN2] = ACTIONS(1380),
    [anon_sym_STAR] = ACTIONS(1382),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1382),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1394),
    [anon_sym_PLUS_PLUS] = ACTIONS(1394),
    [anon_sym_sizeof] = ACTIONS(1396),
    [sym_number_literal] = ACTIONS(4833),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_true] = ACTIONS(4835),
    [sym_false] = ACTIONS(4835),
    [sym_null] = ACTIONS(4835),
    [sym_identifier] = ACTIONS(3084),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1410),
    [anon_sym_new] = ACTIONS(1412),
    [anon_sym_COLON_COLON] = ACTIONS(3086),
    [sym_nullptr] = ACTIONS(4835),
  },
  [1507] = {
    [sym__expression] = STATE(2230),
    [sym_conditional_expression] = STATE(2230),
    [sym_assignment_expression] = STATE(2230),
    [sym_pointer_expression] = STATE(2230),
    [sym_logical_expression] = STATE(2230),
    [sym_bitwise_expression] = STATE(2230),
    [sym_equality_expression] = STATE(2230),
    [sym_relational_expression] = STATE(2230),
    [sym_shift_expression] = STATE(2230),
    [sym_math_expression] = STATE(2230),
    [sym_cast_expression] = STATE(2230),
    [sym_sizeof_expression] = STATE(2230),
    [sym_subscript_expression] = STATE(2230),
    [sym_call_expression] = STATE(2230),
    [sym_field_expression] = STATE(2230),
    [sym_compound_literal_expression] = STATE(2230),
    [sym_parenthesized_expression] = STATE(2230),
    [sym_char_literal] = STATE(2230),
    [sym_concatenated_string] = STATE(2230),
    [sym_string_literal] = STATE(780),
    [sym_template_type] = STATE(1454),
    [sym_template_function] = STATE(2230),
    [sym_new_expression] = STATE(2230),
    [sym_delete_expression] = STATE(2230),
    [sym_lambda_expression] = STATE(2230),
    [sym_lambda_capture_specifier] = STATE(782),
    [sym_scoped_identifier] = STATE(783),
    [sym_scoped_type_identifier] = STATE(1455),
    [sym_scoped_namespace_identifier] = STATE(1456),
    [sym_raw_string_literal] = ACTIONS(4837),
    [anon_sym_LPAREN2] = ACTIONS(1380),
    [anon_sym_STAR] = ACTIONS(1382),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1382),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1394),
    [anon_sym_PLUS_PLUS] = ACTIONS(1394),
    [anon_sym_sizeof] = ACTIONS(1396),
    [sym_number_literal] = ACTIONS(4837),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_true] = ACTIONS(4839),
    [sym_false] = ACTIONS(4839),
    [sym_null] = ACTIONS(4839),
    [sym_identifier] = ACTIONS(3084),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1410),
    [anon_sym_new] = ACTIONS(1412),
    [anon_sym_COLON_COLON] = ACTIONS(3086),
    [sym_nullptr] = ACTIONS(4839),
  },
  [1508] = {
    [anon_sym_COMMA] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(1360),
    [anon_sym_STAR] = ACTIONS(1362),
    [anon_sym_LBRACK] = ACTIONS(1360),
    [anon_sym_EQ] = ACTIONS(1362),
    [anon_sym_QMARK] = ACTIONS(1360),
    [anon_sym_STAR_EQ] = ACTIONS(1360),
    [anon_sym_SLASH_EQ] = ACTIONS(1360),
    [anon_sym_PERCENT_EQ] = ACTIONS(1360),
    [anon_sym_PLUS_EQ] = ACTIONS(1360),
    [anon_sym_DASH_EQ] = ACTIONS(1360),
    [anon_sym_LT_LT_EQ] = ACTIONS(1360),
    [anon_sym_GT_GT_EQ] = ACTIONS(1360),
    [anon_sym_AMP_EQ] = ACTIONS(1360),
    [anon_sym_CARET_EQ] = ACTIONS(1360),
    [anon_sym_PIPE_EQ] = ACTIONS(1360),
    [anon_sym_AMP] = ACTIONS(1362),
    [anon_sym_PIPE_PIPE] = ACTIONS(1360),
    [anon_sym_AMP_AMP] = ACTIONS(1360),
    [anon_sym_PIPE] = ACTIONS(1362),
    [anon_sym_CARET] = ACTIONS(1362),
    [anon_sym_EQ_EQ] = ACTIONS(1360),
    [anon_sym_BANG_EQ] = ACTIONS(1360),
    [anon_sym_LT] = ACTIONS(1362),
    [anon_sym_GT] = ACTIONS(1362),
    [anon_sym_LT_EQ] = ACTIONS(1360),
    [anon_sym_GT_EQ] = ACTIONS(1360),
    [anon_sym_LT_LT] = ACTIONS(1362),
    [anon_sym_GT_GT] = ACTIONS(1362),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_SLASH] = ACTIONS(1362),
    [anon_sym_PERCENT] = ACTIONS(1362),
    [anon_sym_DASH_DASH] = ACTIONS(1360),
    [anon_sym_PLUS_PLUS] = ACTIONS(1360),
    [anon_sym_DOT] = ACTIONS(1360),
    [anon_sym_DASH_GT] = ACTIONS(1360),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(1360),
  },
  [1509] = {
    [sym_template_type] = STATE(953),
    [sym_template_method] = STATE(2232),
    [sym_destructor_name] = STATE(2232),
    [sym_scoped_field_identifier] = STATE(2233),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(953),
    [anon_sym_TILDE] = ACTIONS(3149),
    [sym_identifier] = ACTIONS(4841),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1755),
  },
  [1510] = {
    [anon_sym_COMMA] = ACTIONS(4843),
    [anon_sym_RPAREN] = ACTIONS(4843),
    [anon_sym_SEMI] = ACTIONS(4843),
    [anon_sym_extern] = ACTIONS(4845),
    [anon_sym_LBRACE] = ACTIONS(4843),
    [anon_sym_RBRACE] = ACTIONS(4843),
    [anon_sym_LPAREN2] = ACTIONS(4843),
    [anon_sym_STAR] = ACTIONS(4845),
    [anon_sym_LBRACK] = ACTIONS(4843),
    [anon_sym_RBRACK] = ACTIONS(4843),
    [anon_sym_EQ] = ACTIONS(4845),
    [anon_sym_static] = ACTIONS(4845),
    [anon_sym_register] = ACTIONS(4845),
    [anon_sym_inline] = ACTIONS(4845),
    [anon_sym_const] = ACTIONS(4845),
    [anon_sym_restrict] = ACTIONS(4845),
    [anon_sym_volatile] = ACTIONS(4845),
    [anon_sym__Atomic] = ACTIONS(4845),
    [anon_sym_mutable] = ACTIONS(4845),
    [anon_sym_explicit] = ACTIONS(4845),
    [anon_sym_constexpr] = ACTIONS(4845),
    [anon_sym_COLON] = ACTIONS(4845),
    [anon_sym_QMARK] = ACTIONS(4843),
    [anon_sym_STAR_EQ] = ACTIONS(4843),
    [anon_sym_SLASH_EQ] = ACTIONS(4843),
    [anon_sym_PERCENT_EQ] = ACTIONS(4843),
    [anon_sym_PLUS_EQ] = ACTIONS(4843),
    [anon_sym_DASH_EQ] = ACTIONS(4843),
    [anon_sym_LT_LT_EQ] = ACTIONS(4843),
    [anon_sym_GT_GT_EQ] = ACTIONS(4843),
    [anon_sym_AMP_EQ] = ACTIONS(4843),
    [anon_sym_CARET_EQ] = ACTIONS(4843),
    [anon_sym_PIPE_EQ] = ACTIONS(4843),
    [anon_sym_AMP] = ACTIONS(4845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4843),
    [anon_sym_AMP_AMP] = ACTIONS(4843),
    [anon_sym_PIPE] = ACTIONS(4845),
    [anon_sym_CARET] = ACTIONS(4845),
    [anon_sym_TILDE] = ACTIONS(4843),
    [anon_sym_EQ_EQ] = ACTIONS(4843),
    [anon_sym_BANG_EQ] = ACTIONS(4843),
    [anon_sym_LT] = ACTIONS(4845),
    [anon_sym_GT] = ACTIONS(4845),
    [anon_sym_LT_EQ] = ACTIONS(4843),
    [anon_sym_GT_EQ] = ACTIONS(4843),
    [anon_sym_LT_LT] = ACTIONS(4845),
    [anon_sym_GT_GT] = ACTIONS(4845),
    [anon_sym_PLUS] = ACTIONS(4845),
    [anon_sym_DASH] = ACTIONS(4845),
    [anon_sym_SLASH] = ACTIONS(4845),
    [anon_sym_PERCENT] = ACTIONS(4845),
    [anon_sym_DASH_DASH] = ACTIONS(4843),
    [anon_sym_PLUS_PLUS] = ACTIONS(4843),
    [anon_sym_DOT] = ACTIONS(4843),
    [anon_sym_DASH_GT] = ACTIONS(4843),
    [sym_identifier] = ACTIONS(4845),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4845),
    [anon_sym_override] = ACTIONS(4845),
    [anon_sym_COLON_COLON] = ACTIONS(4843),
    [sym_operator_name] = ACTIONS(4843),
  },
  [1511] = {
    [anon_sym_COMMA] = ACTIONS(1757),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_STAR] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1757),
    [anon_sym_EQ] = ACTIONS(1759),
    [anon_sym_QMARK] = ACTIONS(1757),
    [anon_sym_STAR_EQ] = ACTIONS(1757),
    [anon_sym_SLASH_EQ] = ACTIONS(1757),
    [anon_sym_PERCENT_EQ] = ACTIONS(1757),
    [anon_sym_PLUS_EQ] = ACTIONS(1757),
    [anon_sym_DASH_EQ] = ACTIONS(1757),
    [anon_sym_LT_LT_EQ] = ACTIONS(1757),
    [anon_sym_GT_GT_EQ] = ACTIONS(1757),
    [anon_sym_AMP_EQ] = ACTIONS(1757),
    [anon_sym_CARET_EQ] = ACTIONS(1757),
    [anon_sym_PIPE_EQ] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1759),
    [anon_sym_PIPE_PIPE] = ACTIONS(1757),
    [anon_sym_AMP_AMP] = ACTIONS(1757),
    [anon_sym_PIPE] = ACTIONS(1759),
    [anon_sym_CARET] = ACTIONS(1759),
    [anon_sym_EQ_EQ] = ACTIONS(1757),
    [anon_sym_BANG_EQ] = ACTIONS(1757),
    [anon_sym_LT] = ACTIONS(1759),
    [anon_sym_GT] = ACTIONS(1759),
    [anon_sym_LT_EQ] = ACTIONS(1757),
    [anon_sym_GT_EQ] = ACTIONS(1757),
    [anon_sym_LT_LT] = ACTIONS(1759),
    [anon_sym_GT_GT] = ACTIONS(1759),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1759),
    [anon_sym_SLASH] = ACTIONS(1759),
    [anon_sym_PERCENT] = ACTIONS(1759),
    [anon_sym_DASH_DASH] = ACTIONS(1757),
    [anon_sym_PLUS_PLUS] = ACTIONS(1757),
    [anon_sym_DOT] = ACTIONS(1757),
    [anon_sym_DASH_GT] = ACTIONS(1757),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(1757),
  },
  [1512] = {
    [aux_sym_template_argument_list_repeat1] = STATE(2235),
    [anon_sym_COMMA] = ACTIONS(3163),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(4847),
  },
  [1513] = {
    [anon_sym_COMMA] = ACTIONS(4849),
    [anon_sym_RPAREN] = ACTIONS(4849),
    [anon_sym_SEMI] = ACTIONS(4849),
    [anon_sym_extern] = ACTIONS(4851),
    [anon_sym_LBRACE] = ACTIONS(4849),
    [anon_sym_RBRACE] = ACTIONS(4849),
    [anon_sym_LPAREN2] = ACTIONS(4849),
    [anon_sym_STAR] = ACTIONS(4851),
    [anon_sym_LBRACK] = ACTIONS(4849),
    [anon_sym_RBRACK] = ACTIONS(4849),
    [anon_sym_EQ] = ACTIONS(4851),
    [anon_sym_static] = ACTIONS(4851),
    [anon_sym_register] = ACTIONS(4851),
    [anon_sym_inline] = ACTIONS(4851),
    [anon_sym_const] = ACTIONS(4851),
    [anon_sym_restrict] = ACTIONS(4851),
    [anon_sym_volatile] = ACTIONS(4851),
    [anon_sym__Atomic] = ACTIONS(4851),
    [anon_sym_mutable] = ACTIONS(4851),
    [anon_sym_explicit] = ACTIONS(4851),
    [anon_sym_constexpr] = ACTIONS(4851),
    [anon_sym_COLON] = ACTIONS(4851),
    [anon_sym_QMARK] = ACTIONS(4849),
    [anon_sym_STAR_EQ] = ACTIONS(4849),
    [anon_sym_SLASH_EQ] = ACTIONS(4849),
    [anon_sym_PERCENT_EQ] = ACTIONS(4849),
    [anon_sym_PLUS_EQ] = ACTIONS(4849),
    [anon_sym_DASH_EQ] = ACTIONS(4849),
    [anon_sym_LT_LT_EQ] = ACTIONS(4849),
    [anon_sym_GT_GT_EQ] = ACTIONS(4849),
    [anon_sym_AMP_EQ] = ACTIONS(4849),
    [anon_sym_CARET_EQ] = ACTIONS(4849),
    [anon_sym_PIPE_EQ] = ACTIONS(4849),
    [anon_sym_AMP] = ACTIONS(4851),
    [anon_sym_PIPE_PIPE] = ACTIONS(4849),
    [anon_sym_AMP_AMP] = ACTIONS(4849),
    [anon_sym_PIPE] = ACTIONS(4851),
    [anon_sym_CARET] = ACTIONS(4851),
    [anon_sym_TILDE] = ACTIONS(4849),
    [anon_sym_EQ_EQ] = ACTIONS(4849),
    [anon_sym_BANG_EQ] = ACTIONS(4849),
    [anon_sym_LT] = ACTIONS(4851),
    [anon_sym_GT] = ACTIONS(4851),
    [anon_sym_LT_EQ] = ACTIONS(4849),
    [anon_sym_GT_EQ] = ACTIONS(4849),
    [anon_sym_LT_LT] = ACTIONS(4851),
    [anon_sym_GT_GT] = ACTIONS(4851),
    [anon_sym_PLUS] = ACTIONS(4851),
    [anon_sym_DASH] = ACTIONS(4851),
    [anon_sym_SLASH] = ACTIONS(4851),
    [anon_sym_PERCENT] = ACTIONS(4851),
    [anon_sym_DASH_DASH] = ACTIONS(4849),
    [anon_sym_PLUS_PLUS] = ACTIONS(4849),
    [anon_sym_DOT] = ACTIONS(4849),
    [anon_sym_DASH_GT] = ACTIONS(4849),
    [sym_identifier] = ACTIONS(4851),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4851),
    [anon_sym_override] = ACTIONS(4851),
    [anon_sym_COLON_COLON] = ACTIONS(4849),
    [sym_operator_name] = ACTIONS(4849),
  },
  [1514] = {
    [aux_sym_template_argument_list_repeat1] = STATE(2235),
    [anon_sym_COMMA] = ACTIONS(3163),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(4853),
  },
  [1515] = {
    [sym_string_literal] = STATE(2237),
    [aux_sym_concatenated_string_repeat1] = STATE(2237),
    [anon_sym_COMMA] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_EQ] = ACTIONS(1763),
    [anon_sym_QMARK] = ACTIONS(1761),
    [anon_sym_STAR_EQ] = ACTIONS(1761),
    [anon_sym_SLASH_EQ] = ACTIONS(1761),
    [anon_sym_PERCENT_EQ] = ACTIONS(1761),
    [anon_sym_PLUS_EQ] = ACTIONS(1761),
    [anon_sym_DASH_EQ] = ACTIONS(1761),
    [anon_sym_LT_LT_EQ] = ACTIONS(1761),
    [anon_sym_GT_GT_EQ] = ACTIONS(1761),
    [anon_sym_AMP_EQ] = ACTIONS(1761),
    [anon_sym_CARET_EQ] = ACTIONS(1761),
    [anon_sym_PIPE_EQ] = ACTIONS(1761),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_PIPE_PIPE] = ACTIONS(1761),
    [anon_sym_AMP_AMP] = ACTIONS(1761),
    [anon_sym_PIPE] = ACTIONS(1763),
    [anon_sym_CARET] = ACTIONS(1763),
    [anon_sym_EQ_EQ] = ACTIONS(1761),
    [anon_sym_BANG_EQ] = ACTIONS(1761),
    [anon_sym_LT] = ACTIONS(1763),
    [anon_sym_GT] = ACTIONS(1763),
    [anon_sym_LT_EQ] = ACTIONS(1761),
    [anon_sym_GT_EQ] = ACTIONS(1761),
    [anon_sym_LT_LT] = ACTIONS(1763),
    [anon_sym_GT_GT] = ACTIONS(1763),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_SLASH] = ACTIONS(1763),
    [anon_sym_PERCENT] = ACTIONS(1763),
    [anon_sym_DASH_DASH] = ACTIONS(1761),
    [anon_sym_PLUS_PLUS] = ACTIONS(1761),
    [anon_sym_DOT] = ACTIONS(1761),
    [anon_sym_DASH_GT] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(1761),
  },
  [1516] = {
    [sym_destructor_name] = STATE(2239),
    [anon_sym_TILDE] = ACTIONS(3149),
    [sym_identifier] = ACTIONS(4855),
    [sym_comment] = ACTIONS(91),
    [sym_operator_name] = ACTIONS(4857),
  },
  [1517] = {
    [anon_sym_COMMA] = ACTIONS(1769),
    [anon_sym_LPAREN2] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1771),
    [anon_sym_LBRACK] = ACTIONS(1769),
    [anon_sym_EQ] = ACTIONS(1771),
    [anon_sym_QMARK] = ACTIONS(1769),
    [anon_sym_STAR_EQ] = ACTIONS(1769),
    [anon_sym_SLASH_EQ] = ACTIONS(1769),
    [anon_sym_PERCENT_EQ] = ACTIONS(1769),
    [anon_sym_PLUS_EQ] = ACTIONS(1769),
    [anon_sym_DASH_EQ] = ACTIONS(1769),
    [anon_sym_LT_LT_EQ] = ACTIONS(1769),
    [anon_sym_GT_GT_EQ] = ACTIONS(1769),
    [anon_sym_AMP_EQ] = ACTIONS(1769),
    [anon_sym_CARET_EQ] = ACTIONS(1769),
    [anon_sym_PIPE_EQ] = ACTIONS(1769),
    [anon_sym_AMP] = ACTIONS(1771),
    [anon_sym_PIPE_PIPE] = ACTIONS(1769),
    [anon_sym_AMP_AMP] = ACTIONS(1769),
    [anon_sym_PIPE] = ACTIONS(1771),
    [anon_sym_CARET] = ACTIONS(1771),
    [anon_sym_EQ_EQ] = ACTIONS(1769),
    [anon_sym_BANG_EQ] = ACTIONS(1769),
    [anon_sym_LT] = ACTIONS(1771),
    [anon_sym_GT] = ACTIONS(1771),
    [anon_sym_LT_EQ] = ACTIONS(1769),
    [anon_sym_GT_EQ] = ACTIONS(1769),
    [anon_sym_LT_LT] = ACTIONS(1771),
    [anon_sym_GT_GT] = ACTIONS(1771),
    [anon_sym_PLUS] = ACTIONS(1771),
    [anon_sym_DASH] = ACTIONS(1771),
    [anon_sym_SLASH] = ACTIONS(1771),
    [anon_sym_PERCENT] = ACTIONS(1771),
    [anon_sym_DASH_DASH] = ACTIONS(1769),
    [anon_sym_PLUS_PLUS] = ACTIONS(1769),
    [anon_sym_DOT] = ACTIONS(1769),
    [anon_sym_DASH_GT] = ACTIONS(1769),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(1769),
  },
  [1518] = {
    [sym_compound_statement] = STATE(2241),
    [anon_sym_LBRACE] = ACTIONS(4859),
    [anon_sym_LPAREN2] = ACTIONS(1785),
    [anon_sym_LBRACK] = ACTIONS(1785),
    [sym_comment] = ACTIONS(91),
  },
  [1519] = {
    [anon_sym_COMMA] = ACTIONS(1424),
    [anon_sym_LBRACE] = ACTIONS(1424),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_STAR] = ACTIONS(1436),
    [anon_sym_LBRACK] = ACTIONS(1424),
    [anon_sym_EQ] = ACTIONS(1436),
    [anon_sym_QMARK] = ACTIONS(1424),
    [anon_sym_STAR_EQ] = ACTIONS(1424),
    [anon_sym_SLASH_EQ] = ACTIONS(1424),
    [anon_sym_PERCENT_EQ] = ACTIONS(1424),
    [anon_sym_PLUS_EQ] = ACTIONS(1424),
    [anon_sym_DASH_EQ] = ACTIONS(1424),
    [anon_sym_LT_LT_EQ] = ACTIONS(1424),
    [anon_sym_GT_GT_EQ] = ACTIONS(1424),
    [anon_sym_AMP_EQ] = ACTIONS(1424),
    [anon_sym_CARET_EQ] = ACTIONS(1424),
    [anon_sym_PIPE_EQ] = ACTIONS(1424),
    [anon_sym_AMP] = ACTIONS(1436),
    [anon_sym_PIPE_PIPE] = ACTIONS(1424),
    [anon_sym_AMP_AMP] = ACTIONS(1424),
    [anon_sym_PIPE] = ACTIONS(1436),
    [anon_sym_CARET] = ACTIONS(1436),
    [anon_sym_EQ_EQ] = ACTIONS(1424),
    [anon_sym_BANG_EQ] = ACTIONS(1424),
    [anon_sym_LT] = ACTIONS(1436),
    [anon_sym_GT] = ACTIONS(1436),
    [anon_sym_LT_EQ] = ACTIONS(1424),
    [anon_sym_GT_EQ] = ACTIONS(1424),
    [anon_sym_LT_LT] = ACTIONS(1436),
    [anon_sym_GT_GT] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1436),
    [anon_sym_DASH] = ACTIONS(1436),
    [anon_sym_SLASH] = ACTIONS(1436),
    [anon_sym_PERCENT] = ACTIONS(1436),
    [anon_sym_DASH_DASH] = ACTIONS(1424),
    [anon_sym_PLUS_PLUS] = ACTIONS(1424),
    [anon_sym_DOT] = ACTIONS(1424),
    [anon_sym_DASH_GT] = ACTIONS(1424),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(1424),
  },
  [1520] = {
    [sym__abstract_declarator] = STATE(2242),
    [sym_abstract_pointer_declarator] = STATE(2242),
    [sym_abstract_function_declarator] = STATE(2242),
    [sym_abstract_array_declarator] = STATE(2242),
    [sym_parameter_list] = STATE(1492),
    [sym_abstract_reference_declarator] = STATE(2242),
    [anon_sym_COMMA] = ACTIONS(2465),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(3157),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_AMP] = ACTIONS(3159),
    [anon_sym_AMP_AMP] = ACTIONS(3161),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(2465),
  },
  [1521] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1521),
    [anon_sym_COMMA] = ACTIONS(1985),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1985),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_unsigned] = ACTIONS(4861),
    [anon_sym_long] = ACTIONS(4861),
    [anon_sym_short] = ACTIONS(4861),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(1985),
  },
  [1522] = {
    [anon_sym_COMMA] = ACTIONS(4864),
    [anon_sym_RPAREN] = ACTIONS(4864),
    [anon_sym_SEMI] = ACTIONS(4864),
    [anon_sym_extern] = ACTIONS(4866),
    [anon_sym_LBRACE] = ACTIONS(4864),
    [anon_sym_LPAREN2] = ACTIONS(4864),
    [anon_sym_STAR] = ACTIONS(4864),
    [anon_sym_LBRACK] = ACTIONS(4864),
    [anon_sym_EQ] = ACTIONS(4864),
    [anon_sym_static] = ACTIONS(4866),
    [anon_sym_register] = ACTIONS(4866),
    [anon_sym_inline] = ACTIONS(4866),
    [anon_sym_const] = ACTIONS(4866),
    [anon_sym_restrict] = ACTIONS(4866),
    [anon_sym_volatile] = ACTIONS(4866),
    [anon_sym__Atomic] = ACTIONS(4866),
    [anon_sym_mutable] = ACTIONS(4866),
    [anon_sym_explicit] = ACTIONS(4866),
    [anon_sym_constexpr] = ACTIONS(4866),
    [anon_sym_COLON] = ACTIONS(4866),
    [anon_sym_AMP] = ACTIONS(4866),
    [anon_sym_AMP_AMP] = ACTIONS(4864),
    [anon_sym_TILDE] = ACTIONS(4864),
    [anon_sym_DASH_GT] = ACTIONS(4864),
    [sym_identifier] = ACTIONS(4866),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4866),
    [anon_sym_override] = ACTIONS(4866),
    [anon_sym_GT2] = ACTIONS(4864),
    [sym_noexcept] = ACTIONS(4866),
    [anon_sym_COLON_COLON] = ACTIONS(4864),
    [sym_operator_name] = ACTIONS(4864),
  },
  [1523] = {
    [sym_field_declaration_list] = STATE(2243),
    [anon_sym_LBRACE] = ACTIONS(307),
    [sym_comment] = ACTIONS(91),
  },
  [1524] = {
    [anon_sym_COMMA] = ACTIONS(4868),
    [anon_sym_RPAREN] = ACTIONS(4868),
    [anon_sym_SEMI] = ACTIONS(4868),
    [anon_sym_extern] = ACTIONS(4870),
    [anon_sym_LBRACE] = ACTIONS(4868),
    [anon_sym_LPAREN2] = ACTIONS(4868),
    [anon_sym_STAR] = ACTIONS(4868),
    [anon_sym_LBRACK] = ACTIONS(4868),
    [anon_sym_EQ] = ACTIONS(4868),
    [anon_sym_static] = ACTIONS(4870),
    [anon_sym_register] = ACTIONS(4870),
    [anon_sym_inline] = ACTIONS(4870),
    [anon_sym_const] = ACTIONS(4870),
    [anon_sym_restrict] = ACTIONS(4870),
    [anon_sym_volatile] = ACTIONS(4870),
    [anon_sym__Atomic] = ACTIONS(4870),
    [anon_sym_mutable] = ACTIONS(4870),
    [anon_sym_explicit] = ACTIONS(4870),
    [anon_sym_constexpr] = ACTIONS(4870),
    [anon_sym_COLON] = ACTIONS(4870),
    [anon_sym_AMP] = ACTIONS(4870),
    [anon_sym_AMP_AMP] = ACTIONS(4868),
    [anon_sym_TILDE] = ACTIONS(4868),
    [anon_sym_DASH_GT] = ACTIONS(4868),
    [sym_identifier] = ACTIONS(4870),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4870),
    [anon_sym_override] = ACTIONS(4870),
    [anon_sym_GT2] = ACTIONS(4868),
    [sym_noexcept] = ACTIONS(4870),
    [anon_sym_COLON_COLON] = ACTIONS(4868),
    [sym_operator_name] = ACTIONS(4868),
  },
  [1525] = {
    [sym_field_declaration_list] = STATE(2244),
    [anon_sym_LBRACE] = ACTIONS(307),
    [sym_comment] = ACTIONS(91),
  },
  [1526] = {
    [sym_parameter_list] = STATE(812),
    [anon_sym_SEMI] = ACTIONS(4126),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(574),
    [sym_comment] = ACTIONS(91),
  },
  [1527] = {
    [sym_field_declaration_list] = STATE(790),
    [sym_virtual_specifier] = STATE(791),
    [sym_base_class_clause] = STATE(792),
    [sym_template_argument_list] = STATE(615),
    [anon_sym_COMMA] = ACTIONS(4872),
    [anon_sym_extern] = ACTIONS(1440),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LPAREN2] = ACTIONS(1438),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_LBRACK] = ACTIONS(1438),
    [anon_sym_EQ] = ACTIONS(1438),
    [anon_sym_static] = ACTIONS(1440),
    [anon_sym_register] = ACTIONS(1440),
    [anon_sym_inline] = ACTIONS(1440),
    [anon_sym_const] = ACTIONS(1440),
    [anon_sym_restrict] = ACTIONS(1440),
    [anon_sym_volatile] = ACTIONS(1440),
    [anon_sym__Atomic] = ACTIONS(1440),
    [anon_sym_mutable] = ACTIONS(1440),
    [anon_sym_explicit] = ACTIONS(1440),
    [anon_sym_constexpr] = ACTIONS(1440),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_AMP_AMP] = ACTIONS(1438),
    [anon_sym_TILDE] = ACTIONS(1438),
    [anon_sym_LT] = ACTIONS(643),
    [sym_identifier] = ACTIONS(1440),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_GT2] = ACTIONS(4872),
    [anon_sym_COLON_COLON] = ACTIONS(1061),
    [sym_operator_name] = ACTIONS(1438),
  },
  [1528] = {
    [sym_template_argument_list] = STATE(615),
    [anon_sym_COMMA] = ACTIONS(4872),
    [anon_sym_extern] = ACTIONS(468),
    [anon_sym_LPAREN2] = ACTIONS(481),
    [anon_sym_STAR] = ACTIONS(481),
    [anon_sym_LBRACK] = ACTIONS(481),
    [anon_sym_EQ] = ACTIONS(4874),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_register] = ACTIONS(468),
    [anon_sym_inline] = ACTIONS(468),
    [anon_sym_const] = ACTIONS(468),
    [anon_sym_restrict] = ACTIONS(468),
    [anon_sym_volatile] = ACTIONS(468),
    [anon_sym__Atomic] = ACTIONS(468),
    [anon_sym_mutable] = ACTIONS(468),
    [anon_sym_explicit] = ACTIONS(468),
    [anon_sym_constexpr] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(468),
    [anon_sym_AMP_AMP] = ACTIONS(481),
    [anon_sym_TILDE] = ACTIONS(481),
    [anon_sym_LT] = ACTIONS(643),
    [sym_identifier] = ACTIONS(468),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(4872),
    [anon_sym_COLON_COLON] = ACTIONS(1061),
    [sym_operator_name] = ACTIONS(481),
  },
  [1529] = {
    [sym__type_specifier] = STATE(271),
    [sym_sized_type_specifier] = STATE(271),
    [sym_enum_specifier] = STATE(271),
    [sym_struct_specifier] = STATE(271),
    [sym_union_specifier] = STATE(271),
    [sym_macro_type_specifier] = STATE(271),
    [sym_class_specifier] = STATE(271),
    [sym_dependent_type] = STATE(271),
    [sym_template_type] = STATE(272),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(180),
    [aux_sym_sized_type_specifier_repeat1] = STATE(806),
    [anon_sym_unsigned] = ACTIONS(1454),
    [anon_sym_long] = ACTIONS(1454),
    [anon_sym_short] = ACTIONS(1454),
    [sym_primitive_type] = ACTIONS(490),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [sym_identifier] = ACTIONS(492),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(490),
    [anon_sym_typename] = ACTIONS(3241),
    [anon_sym_COLON_COLON] = ACTIONS(315),
  },
  [1530] = {
    [sym__declaration_specifiers] = STATE(905),
    [sym__declarator] = STATE(135),
    [sym__abstract_declarator] = STATE(959),
    [sym_pointer_declarator] = STATE(135),
    [sym_abstract_pointer_declarator] = STATE(959),
    [sym_function_declarator] = STATE(135),
    [sym_abstract_function_declarator] = STATE(959),
    [sym_array_declarator] = STATE(135),
    [sym_abstract_array_declarator] = STATE(959),
    [sym_storage_class_specifier] = STATE(907),
    [sym_type_qualifier] = STATE(907),
    [sym__type_specifier] = STATE(906),
    [sym_sized_type_specifier] = STATE(906),
    [sym_enum_specifier] = STATE(906),
    [sym_struct_specifier] = STATE(906),
    [sym_union_specifier] = STATE(906),
    [sym_parameter_list] = STATE(528),
    [sym_parameter_declaration] = STATE(902),
    [sym_macro_type_specifier] = STATE(906),
    [sym_class_specifier] = STATE(906),
    [sym_dependent_type] = STATE(906),
    [sym_reference_declarator] = STATE(135),
    [sym_abstract_reference_declarator] = STATE(959),
    [sym_template_type] = STATE(368),
    [sym_template_function] = STATE(135),
    [sym_destructor_name] = STATE(135),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(369),
    [aux_sym__declaration_specifiers_repeat1] = STATE(907),
    [aux_sym_sized_type_specifier_repeat1] = STATE(908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1625),
    [anon_sym_RPAREN] = ACTIONS(1627),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(3249),
    [anon_sym_STAR] = ACTIONS(4877),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(1629),
    [anon_sym_long] = ACTIONS(1629),
    [anon_sym_short] = ACTIONS(1629),
    [sym_primitive_type] = ACTIONS(1631),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_AMP] = ACTIONS(4879),
    [anon_sym_AMP_AMP] = ACTIONS(4881),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(649),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(1631),
    [anon_sym_typename] = ACTIONS(1633),
    [anon_sym_COLON_COLON] = ACTIONS(651),
    [sym_operator_name] = ACTIONS(255),
  },
  [1531] = {
    [sym__declarator] = STATE(2248),
    [sym__abstract_declarator] = STATE(2207),
    [sym_pointer_declarator] = STATE(2248),
    [sym_abstract_pointer_declarator] = STATE(2207),
    [sym_function_declarator] = STATE(2248),
    [sym_abstract_function_declarator] = STATE(2207),
    [sym_array_declarator] = STATE(2248),
    [sym_abstract_array_declarator] = STATE(2207),
    [sym_type_qualifier] = STATE(2249),
    [sym_parameter_list] = STATE(1492),
    [sym_reference_declarator] = STATE(2248),
    [sym_abstract_reference_declarator] = STATE(2207),
    [sym_template_type] = STATE(1538),
    [sym_template_function] = STATE(2248),
    [sym_destructor_name] = STATE(2248),
    [sym_scoped_identifier] = STATE(1539),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(1538),
    [aux_sym_type_definition_repeat1] = STATE(2249),
    [anon_sym_COMMA] = ACTIONS(2461),
    [anon_sym_LPAREN2] = ACTIONS(3249),
    [anon_sym_STAR] = ACTIONS(3251),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(3253),
    [anon_sym_AMP_AMP] = ACTIONS(3255),
    [anon_sym_TILDE] = ACTIONS(3149),
    [sym_identifier] = ACTIONS(3257),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(2461),
    [anon_sym_COLON_COLON] = ACTIONS(3259),
    [sym_operator_name] = ACTIONS(4883),
  },
  [1532] = {
    [sym__declarator] = STATE(2250),
    [sym__abstract_declarator] = STATE(2209),
    [sym_pointer_declarator] = STATE(2250),
    [sym_abstract_pointer_declarator] = STATE(2209),
    [sym_function_declarator] = STATE(2250),
    [sym_abstract_function_declarator] = STATE(2209),
    [sym_array_declarator] = STATE(2250),
    [sym_abstract_array_declarator] = STATE(2209),
    [sym_parameter_list] = STATE(1492),
    [sym_reference_declarator] = STATE(2250),
    [sym_abstract_reference_declarator] = STATE(2209),
    [sym_template_type] = STATE(1538),
    [sym_template_function] = STATE(2250),
    [sym_destructor_name] = STATE(2250),
    [sym_scoped_identifier] = STATE(1539),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(1538),
    [anon_sym_COMMA] = ACTIONS(2463),
    [anon_sym_LPAREN2] = ACTIONS(3249),
    [anon_sym_STAR] = ACTIONS(3251),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_AMP] = ACTIONS(3253),
    [anon_sym_AMP_AMP] = ACTIONS(3255),
    [anon_sym_TILDE] = ACTIONS(3149),
    [sym_identifier] = ACTIONS(3257),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(2463),
    [anon_sym_COLON_COLON] = ACTIONS(3259),
    [sym_operator_name] = ACTIONS(4885),
  },
  [1533] = {
    [sym_template_argument_list] = STATE(890),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_LBRACE] = ACTIONS(576),
    [anon_sym_LPAREN2] = ACTIONS(576),
    [anon_sym_LBRACK] = ACTIONS(576),
    [anon_sym_EQ] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(643),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(576),
    [anon_sym_COLON_COLON] = ACTIONS(4887),
  },
  [1534] = {
    [sym_destructor_name] = STATE(1488),
    [anon_sym_TILDE] = ACTIONS(3149),
    [sym_identifier] = ACTIONS(1346),
    [sym_comment] = ACTIONS(91),
    [sym_operator_name] = ACTIONS(3155),
  },
  [1535] = {
    [sym_parameter_list] = STATE(2254),
    [sym_argument_list] = STATE(898),
    [sym_initializer_list] = STATE(898),
    [anon_sym_COMMA] = ACTIONS(4889),
    [anon_sym_LBRACE] = ACTIONS(3114),
    [anon_sym_LPAREN2] = ACTIONS(4891),
    [anon_sym_LBRACK] = ACTIONS(574),
    [anon_sym_EQ] = ACTIONS(4893),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(4889),
  },
  [1536] = {
    [sym_parameter_list] = STATE(2210),
    [anon_sym_COMMA] = ACTIONS(4889),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(4889),
  },
  [1537] = {
    [anon_sym_COMMA] = ACTIONS(4889),
    [anon_sym_RPAREN] = ACTIONS(4889),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(4889),
  },
  [1538] = {
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(4895),
  },
  [1539] = {
    [sym_template_argument_list] = STATE(1519),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_LBRACE] = ACTIONS(576),
    [anon_sym_LPAREN2] = ACTIONS(576),
    [anon_sym_LBRACK] = ACTIONS(576),
    [anon_sym_EQ] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(643),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(576),
  },
  [1540] = {
    [sym__expression] = STATE(2256),
    [sym_conditional_expression] = STATE(2256),
    [sym_assignment_expression] = STATE(2256),
    [sym_pointer_expression] = STATE(2256),
    [sym_logical_expression] = STATE(2256),
    [sym_bitwise_expression] = STATE(2256),
    [sym_equality_expression] = STATE(2256),
    [sym_relational_expression] = STATE(2256),
    [sym_shift_expression] = STATE(2256),
    [sym_math_expression] = STATE(2256),
    [sym_cast_expression] = STATE(2256),
    [sym_sizeof_expression] = STATE(2256),
    [sym_subscript_expression] = STATE(2256),
    [sym_call_expression] = STATE(2256),
    [sym_field_expression] = STATE(2256),
    [sym_compound_literal_expression] = STATE(2256),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_char_literal] = STATE(2256),
    [sym_concatenated_string] = STATE(2256),
    [sym_string_literal] = STATE(780),
    [sym_template_type] = STATE(1454),
    [sym_template_function] = STATE(2256),
    [sym_new_expression] = STATE(2256),
    [sym_delete_expression] = STATE(2256),
    [sym_lambda_expression] = STATE(2256),
    [sym_lambda_capture_specifier] = STATE(782),
    [sym_scoped_identifier] = STATE(783),
    [sym_scoped_type_identifier] = STATE(1455),
    [sym_scoped_namespace_identifier] = STATE(1456),
    [sym_raw_string_literal] = ACTIONS(4897),
    [anon_sym_LPAREN2] = ACTIONS(1380),
    [anon_sym_STAR] = ACTIONS(1382),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1382),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1394),
    [anon_sym_PLUS_PLUS] = ACTIONS(1394),
    [anon_sym_sizeof] = ACTIONS(1396),
    [sym_number_literal] = ACTIONS(4897),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_true] = ACTIONS(4899),
    [sym_false] = ACTIONS(4899),
    [sym_null] = ACTIONS(4899),
    [sym_identifier] = ACTIONS(3084),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1410),
    [anon_sym_new] = ACTIONS(1412),
    [anon_sym_COLON_COLON] = ACTIONS(3086),
    [sym_nullptr] = ACTIONS(4899),
  },
  [1541] = {
    [sym_storage_class_specifier] = STATE(2257),
    [sym_type_qualifier] = STATE(2257),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2257),
    [anon_sym_COMMA] = ACTIONS(1689),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_LPAREN2] = ACTIONS(1689),
    [anon_sym_STAR] = ACTIONS(1689),
    [anon_sym_LBRACK] = ACTIONS(1689),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(1691),
    [anon_sym_AMP_AMP] = ACTIONS(1689),
    [anon_sym_TILDE] = ACTIONS(1689),
    [sym_identifier] = ACTIONS(1691),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(1689),
    [anon_sym_COLON_COLON] = ACTIONS(1689),
    [sym_operator_name] = ACTIONS(1689),
  },
  [1542] = {
    [sym__declaration_specifiers] = STATE(802),
    [sym_storage_class_specifier] = STATE(805),
    [sym_type_qualifier] = STATE(805),
    [sym__type_specifier] = STATE(803),
    [sym_sized_type_specifier] = STATE(803),
    [sym_enum_specifier] = STATE(803),
    [sym_struct_specifier] = STATE(803),
    [sym_union_specifier] = STATE(803),
    [sym_parameter_declaration] = STATE(2258),
    [sym_macro_type_specifier] = STATE(803),
    [sym_class_specifier] = STATE(803),
    [sym_dependent_type] = STATE(803),
    [sym_type_parameter_declaration] = STATE(2258),
    [sym_optional_type_parameter_declaration] = STATE(2258),
    [sym_optional_parameter_declaration] = STATE(2258),
    [sym_template_type] = STATE(272),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(180),
    [aux_sym__declaration_specifiers_repeat1] = STATE(805),
    [aux_sym_sized_type_specifier_repeat1] = STATE(806),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(1454),
    [anon_sym_long] = ACTIONS(1454),
    [anon_sym_short] = ACTIONS(1454),
    [sym_primitive_type] = ACTIONS(1456),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [sym_identifier] = ACTIONS(492),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1458),
    [sym_auto] = ACTIONS(1456),
    [anon_sym_typename] = ACTIONS(1460),
    [anon_sym_COLON_COLON] = ACTIONS(315),
  },
  [1543] = {
    [anon_sym_extern] = ACTIONS(4901),
    [anon_sym_static] = ACTIONS(4901),
    [anon_sym_register] = ACTIONS(4901),
    [anon_sym_inline] = ACTIONS(4901),
    [anon_sym_const] = ACTIONS(4901),
    [anon_sym_restrict] = ACTIONS(4901),
    [anon_sym_volatile] = ACTIONS(4901),
    [anon_sym__Atomic] = ACTIONS(4901),
    [anon_sym_mutable] = ACTIONS(4901),
    [anon_sym_explicit] = ACTIONS(4901),
    [anon_sym_constexpr] = ACTIONS(4901),
    [anon_sym_unsigned] = ACTIONS(4901),
    [anon_sym_long] = ACTIONS(4901),
    [anon_sym_short] = ACTIONS(4901),
    [sym_primitive_type] = ACTIONS(4901),
    [anon_sym_enum] = ACTIONS(4901),
    [anon_sym_struct] = ACTIONS(4901),
    [anon_sym_union] = ACTIONS(4901),
    [sym_identifier] = ACTIONS(4901),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4901),
    [sym_auto] = ACTIONS(4901),
    [anon_sym_typename] = ACTIONS(4901),
    [anon_sym_COLON_COLON] = ACTIONS(4903),
  },
  [1544] = {
    [aux_sym_template_parameter_list_repeat1] = STATE(2260),
    [anon_sym_COMMA] = ACTIONS(3265),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(4905),
  },
  [1545] = {
    [sym__type_specifier] = STATE(271),
    [sym_sized_type_specifier] = STATE(271),
    [sym_enum_specifier] = STATE(271),
    [sym_struct_specifier] = STATE(271),
    [sym_union_specifier] = STATE(271),
    [sym_macro_type_specifier] = STATE(271),
    [sym_class_specifier] = STATE(271),
    [sym_dependent_type] = STATE(271),
    [sym_template_type] = STATE(272),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(180),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1547),
    [anon_sym_unsigned] = ACTIONS(3269),
    [anon_sym_long] = ACTIONS(3269),
    [anon_sym_short] = ACTIONS(3269),
    [sym_primitive_type] = ACTIONS(490),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [sym_identifier] = ACTIONS(492),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(490),
    [anon_sym_typename] = ACTIONS(3273),
    [anon_sym_COLON_COLON] = ACTIONS(315),
  },
  [1546] = {
    [sym_storage_class_specifier] = STATE(2261),
    [sym_type_qualifier] = STATE(2261),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2261),
    [anon_sym_COMMA] = ACTIONS(1689),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_LPAREN2] = ACTIONS(1689),
    [anon_sym_STAR] = ACTIONS(1689),
    [anon_sym_LBRACK] = ACTIONS(1689),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(1691),
    [anon_sym_AMP_AMP] = ACTIONS(1689),
    [anon_sym_TILDE] = ACTIONS(1689),
    [sym_identifier] = ACTIONS(1691),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(1689),
    [anon_sym_COLON_COLON] = ACTIONS(1689),
    [sym_operator_name] = ACTIONS(1689),
  },
  [1547] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2262),
    [anon_sym_COMMA] = ACTIONS(653),
    [anon_sym_extern] = ACTIONS(655),
    [anon_sym_LPAREN2] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_register] = ACTIONS(655),
    [anon_sym_inline] = ACTIONS(655),
    [anon_sym_const] = ACTIONS(655),
    [anon_sym_restrict] = ACTIONS(655),
    [anon_sym_volatile] = ACTIONS(655),
    [anon_sym__Atomic] = ACTIONS(655),
    [anon_sym_mutable] = ACTIONS(655),
    [anon_sym_explicit] = ACTIONS(655),
    [anon_sym_constexpr] = ACTIONS(655),
    [anon_sym_unsigned] = ACTIONS(4907),
    [anon_sym_long] = ACTIONS(4907),
    [anon_sym_short] = ACTIONS(4907),
    [sym_primitive_type] = ACTIONS(659),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [anon_sym_TILDE] = ACTIONS(653),
    [sym_identifier] = ACTIONS(661),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(653),
    [anon_sym_COLON_COLON] = ACTIONS(653),
    [sym_operator_name] = ACTIONS(653),
  },
  [1548] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1548),
    [anon_sym_COMMA] = ACTIONS(1985),
    [anon_sym_extern] = ACTIONS(1987),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1985),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_EQ] = ACTIONS(1985),
    [anon_sym_static] = ACTIONS(1987),
    [anon_sym_register] = ACTIONS(1987),
    [anon_sym_inline] = ACTIONS(1987),
    [anon_sym_const] = ACTIONS(1987),
    [anon_sym_restrict] = ACTIONS(1987),
    [anon_sym_volatile] = ACTIONS(1987),
    [anon_sym__Atomic] = ACTIONS(1987),
    [anon_sym_mutable] = ACTIONS(1987),
    [anon_sym_explicit] = ACTIONS(1987),
    [anon_sym_constexpr] = ACTIONS(1987),
    [anon_sym_unsigned] = ACTIONS(4909),
    [anon_sym_long] = ACTIONS(4909),
    [anon_sym_short] = ACTIONS(4909),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(1985),
    [anon_sym_COLON_COLON] = ACTIONS(1985),
    [sym_operator_name] = ACTIONS(1985),
  },
  [1549] = {
    [anon_sym_SEMI] = ACTIONS(3211),
    [anon_sym_extern] = ACTIONS(3216),
    [anon_sym_LPAREN2] = ACTIONS(3213),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_LBRACK] = ACTIONS(3211),
    [anon_sym_static] = ACTIONS(3216),
    [anon_sym_register] = ACTIONS(3216),
    [anon_sym_inline] = ACTIONS(3216),
    [anon_sym_const] = ACTIONS(3216),
    [anon_sym_restrict] = ACTIONS(3216),
    [anon_sym_volatile] = ACTIONS(3216),
    [anon_sym__Atomic] = ACTIONS(3216),
    [anon_sym_mutable] = ACTIONS(3216),
    [anon_sym_explicit] = ACTIONS(3216),
    [anon_sym_constexpr] = ACTIONS(3216),
    [anon_sym_AMP] = ACTIONS(3216),
    [anon_sym_AMP_AMP] = ACTIONS(3218),
    [anon_sym_TILDE] = ACTIONS(3218),
    [anon_sym_LT] = ACTIONS(3213),
    [sym_identifier] = ACTIONS(3216),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(3225),
    [sym_operator_name] = ACTIONS(3218),
  },
  [1550] = {
    [sym_raw_string_literal] = ACTIONS(4912),
    [ts_builtin_sym_end] = ACTIONS(4912),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4914),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4914),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4914),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4914),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4914),
    [sym_preproc_directive] = ACTIONS(4914),
    [anon_sym_SEMI] = ACTIONS(4912),
    [anon_sym_typedef] = ACTIONS(4914),
    [anon_sym_extern] = ACTIONS(4914),
    [anon_sym_LBRACE] = ACTIONS(4912),
    [anon_sym_RBRACE] = ACTIONS(4912),
    [anon_sym_LPAREN2] = ACTIONS(4912),
    [anon_sym_STAR] = ACTIONS(4912),
    [anon_sym_LBRACK] = ACTIONS(4912),
    [anon_sym_static] = ACTIONS(4914),
    [anon_sym_register] = ACTIONS(4914),
    [anon_sym_inline] = ACTIONS(4914),
    [anon_sym_const] = ACTIONS(4914),
    [anon_sym_restrict] = ACTIONS(4914),
    [anon_sym_volatile] = ACTIONS(4914),
    [anon_sym__Atomic] = ACTIONS(4914),
    [anon_sym_mutable] = ACTIONS(4914),
    [anon_sym_explicit] = ACTIONS(4914),
    [anon_sym_constexpr] = ACTIONS(4914),
    [anon_sym_unsigned] = ACTIONS(4914),
    [anon_sym_long] = ACTIONS(4914),
    [anon_sym_short] = ACTIONS(4914),
    [sym_primitive_type] = ACTIONS(4914),
    [anon_sym_enum] = ACTIONS(4914),
    [anon_sym_struct] = ACTIONS(4914),
    [anon_sym_union] = ACTIONS(4914),
    [anon_sym_if] = ACTIONS(4914),
    [anon_sym_switch] = ACTIONS(4914),
    [anon_sym_case] = ACTIONS(4914),
    [anon_sym_default] = ACTIONS(4914),
    [anon_sym_while] = ACTIONS(4914),
    [anon_sym_do] = ACTIONS(4914),
    [anon_sym_for] = ACTIONS(4914),
    [anon_sym_return] = ACTIONS(4914),
    [anon_sym_break] = ACTIONS(4914),
    [anon_sym_continue] = ACTIONS(4914),
    [anon_sym_goto] = ACTIONS(4914),
    [anon_sym_AMP] = ACTIONS(4914),
    [anon_sym_AMP_AMP] = ACTIONS(4912),
    [anon_sym_BANG] = ACTIONS(4912),
    [anon_sym_TILDE] = ACTIONS(4912),
    [anon_sym_PLUS] = ACTIONS(4914),
    [anon_sym_DASH] = ACTIONS(4914),
    [anon_sym_DASH_DASH] = ACTIONS(4912),
    [anon_sym_PLUS_PLUS] = ACTIONS(4912),
    [anon_sym_sizeof] = ACTIONS(4914),
    [sym_number_literal] = ACTIONS(4912),
    [anon_sym_SQUOTE] = ACTIONS(4912),
    [anon_sym_DQUOTE] = ACTIONS(4912),
    [sym_true] = ACTIONS(4914),
    [sym_false] = ACTIONS(4914),
    [sym_null] = ACTIONS(4914),
    [sym_identifier] = ACTIONS(4914),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4914),
    [sym_auto] = ACTIONS(4914),
    [anon_sym_typename] = ACTIONS(4914),
    [anon_sym_template] = ACTIONS(4914),
    [anon_sym_delete] = ACTIONS(4914),
    [anon_sym_namespace] = ACTIONS(4914),
    [anon_sym_using] = ACTIONS(4914),
    [anon_sym_try] = ACTIONS(4914),
    [anon_sym_new] = ACTIONS(4914),
    [anon_sym_COLON_COLON] = ACTIONS(4912),
    [sym_operator_name] = ACTIONS(4912),
    [sym_nullptr] = ACTIONS(4914),
  },
  [1551] = {
    [sym__type_specifier] = STATE(2264),
    [sym_sized_type_specifier] = STATE(2264),
    [sym_enum_specifier] = STATE(2264),
    [sym_struct_specifier] = STATE(2264),
    [sym_union_specifier] = STATE(2264),
    [sym_macro_type_specifier] = STATE(2264),
    [sym_class_specifier] = STATE(2264),
    [sym_dependent_type] = STATE(2264),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2265),
    [anon_sym_unsigned] = ACTIONS(4916),
    [anon_sym_long] = ACTIONS(4916),
    [anon_sym_short] = ACTIONS(4916),
    [sym_primitive_type] = ACTIONS(4918),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(4147),
    [anon_sym_union] = ACTIONS(4149),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4151),
    [sym_auto] = ACTIONS(4918),
    [anon_sym_typename] = ACTIONS(4920),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [1552] = {
    [sym_type_qualifier] = STATE(2266),
    [sym_virtual_specifier] = STATE(2266),
    [sym_trailing_return_type] = STATE(2266),
    [aux_sym_function_declarator_repeat1] = STATE(2266),
    [anon_sym_SEMI] = ACTIONS(3549),
    [anon_sym_LPAREN2] = ACTIONS(3549),
    [anon_sym_LBRACK] = ACTIONS(3549),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(3285),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [sym_noexcept] = ACTIONS(4922),
  },
  [1553] = {
    [sym_storage_class_specifier] = STATE(1553),
    [sym_type_qualifier] = STATE(1553),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1553),
    [anon_sym_extern] = ACTIONS(1967),
    [anon_sym_LPAREN2] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(1970),
    [anon_sym_static] = ACTIONS(1967),
    [anon_sym_register] = ACTIONS(1967),
    [anon_sym_inline] = ACTIONS(1967),
    [anon_sym_const] = ACTIONS(1972),
    [anon_sym_restrict] = ACTIONS(1972),
    [anon_sym_volatile] = ACTIONS(1972),
    [anon_sym__Atomic] = ACTIONS(1972),
    [anon_sym_mutable] = ACTIONS(1972),
    [anon_sym_explicit] = ACTIONS(1972),
    [anon_sym_constexpr] = ACTIONS(1972),
    [anon_sym_AMP] = ACTIONS(1975),
    [anon_sym_AMP_AMP] = ACTIONS(1970),
    [anon_sym_TILDE] = ACTIONS(1970),
    [sym_identifier] = ACTIONS(1975),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1970),
    [sym_operator_name] = ACTIONS(1970),
  },
  [1554] = {
    [sym_storage_class_specifier] = STATE(2267),
    [sym_type_qualifier] = STATE(2267),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2267),
    [anon_sym_SEMI] = ACTIONS(1689),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_LPAREN2] = ACTIONS(1689),
    [anon_sym_STAR] = ACTIONS(1689),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(1691),
    [anon_sym_AMP_AMP] = ACTIONS(1689),
    [anon_sym_TILDE] = ACTIONS(1689),
    [sym_identifier] = ACTIONS(1691),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1689),
    [sym_operator_name] = ACTIONS(1689),
  },
  [1555] = {
    [sym_storage_class_specifier] = STATE(2268),
    [sym_type_qualifier] = STATE(2268),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2268),
    [anon_sym_SEMI] = ACTIONS(1689),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_LPAREN2] = ACTIONS(1689),
    [anon_sym_STAR] = ACTIONS(1689),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(1691),
    [anon_sym_AMP_AMP] = ACTIONS(1689),
    [anon_sym_TILDE] = ACTIONS(1689),
    [sym_identifier] = ACTIONS(1691),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1689),
    [sym_operator_name] = ACTIONS(1689),
  },
  [1556] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1556),
    [anon_sym_SEMI] = ACTIONS(1985),
    [anon_sym_extern] = ACTIONS(1987),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1985),
    [anon_sym_static] = ACTIONS(1987),
    [anon_sym_register] = ACTIONS(1987),
    [anon_sym_inline] = ACTIONS(1987),
    [anon_sym_const] = ACTIONS(1987),
    [anon_sym_restrict] = ACTIONS(1987),
    [anon_sym_volatile] = ACTIONS(1987),
    [anon_sym__Atomic] = ACTIONS(1987),
    [anon_sym_mutable] = ACTIONS(1987),
    [anon_sym_explicit] = ACTIONS(1987),
    [anon_sym_constexpr] = ACTIONS(1987),
    [anon_sym_unsigned] = ACTIONS(4924),
    [anon_sym_long] = ACTIONS(4924),
    [anon_sym_short] = ACTIONS(4924),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1985),
    [sym_operator_name] = ACTIONS(1985),
  },
  [1557] = {
    [anon_sym_SEMI] = ACTIONS(3629),
    [anon_sym_extern] = ACTIONS(3634),
    [anon_sym_LPAREN2] = ACTIONS(3631),
    [anon_sym_STAR] = ACTIONS(3636),
    [anon_sym_LBRACK] = ACTIONS(3629),
    [anon_sym_static] = ACTIONS(3634),
    [anon_sym_register] = ACTIONS(3634),
    [anon_sym_inline] = ACTIONS(3634),
    [anon_sym_const] = ACTIONS(3634),
    [anon_sym_restrict] = ACTIONS(3634),
    [anon_sym_volatile] = ACTIONS(3634),
    [anon_sym__Atomic] = ACTIONS(3634),
    [anon_sym_mutable] = ACTIONS(3634),
    [anon_sym_explicit] = ACTIONS(3634),
    [anon_sym_constexpr] = ACTIONS(3634),
    [anon_sym_AMP] = ACTIONS(3634),
    [anon_sym_AMP_AMP] = ACTIONS(3636),
    [anon_sym_TILDE] = ACTIONS(3636),
    [anon_sym_LT] = ACTIONS(3631),
    [sym_identifier] = ACTIONS(3634),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(3643),
    [sym_operator_name] = ACTIONS(3636),
  },
  [1558] = {
    [sym_storage_class_specifier] = STATE(1553),
    [sym_type_qualifier] = STATE(1553),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1553),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_LPAREN2] = ACTIONS(3695),
    [anon_sym_STAR] = ACTIONS(3695),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3695),
    [anon_sym_TILDE] = ACTIONS(3695),
    [sym_identifier] = ACTIONS(3697),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(3695),
    [sym_operator_name] = ACTIONS(3695),
  },
  [1559] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(4927),
    [anon_sym_SEMI] = ACTIONS(4927),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(590),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(4929),
    [anon_sym_QMARK] = ACTIONS(4927),
    [anon_sym_STAR_EQ] = ACTIONS(4927),
    [anon_sym_SLASH_EQ] = ACTIONS(4927),
    [anon_sym_PERCENT_EQ] = ACTIONS(4927),
    [anon_sym_PLUS_EQ] = ACTIONS(4927),
    [anon_sym_DASH_EQ] = ACTIONS(4927),
    [anon_sym_LT_LT_EQ] = ACTIONS(4927),
    [anon_sym_GT_GT_EQ] = ACTIONS(4927),
    [anon_sym_AMP_EQ] = ACTIONS(4927),
    [anon_sym_CARET_EQ] = ACTIONS(4927),
    [anon_sym_PIPE_EQ] = ACTIONS(4927),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_PIPE_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(604),
    [anon_sym_PIPE] = ACTIONS(606),
    [anon_sym_CARET] = ACTIONS(608),
    [anon_sym_EQ_EQ] = ACTIONS(610),
    [anon_sym_BANG_EQ] = ACTIONS(610),
    [anon_sym_LT] = ACTIONS(612),
    [anon_sym_GT] = ACTIONS(612),
    [anon_sym_LT_EQ] = ACTIONS(614),
    [anon_sym_GT_EQ] = ACTIONS(614),
    [anon_sym_LT_LT] = ACTIONS(616),
    [anon_sym_GT_GT] = ACTIONS(616),
    [anon_sym_PLUS] = ACTIONS(618),
    [anon_sym_DASH] = ACTIONS(618),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1560] = {
    [sym__expression] = STATE(2269),
    [sym_conditional_expression] = STATE(2269),
    [sym_assignment_expression] = STATE(2269),
    [sym_pointer_expression] = STATE(2269),
    [sym_logical_expression] = STATE(2269),
    [sym_bitwise_expression] = STATE(2269),
    [sym_equality_expression] = STATE(2269),
    [sym_relational_expression] = STATE(2269),
    [sym_shift_expression] = STATE(2269),
    [sym_math_expression] = STATE(2269),
    [sym_cast_expression] = STATE(2269),
    [sym_sizeof_expression] = STATE(2269),
    [sym_subscript_expression] = STATE(2269),
    [sym_call_expression] = STATE(2269),
    [sym_field_expression] = STATE(2269),
    [sym_compound_literal_expression] = STATE(2269),
    [sym_parenthesized_expression] = STATE(2269),
    [sym_char_literal] = STATE(2269),
    [sym_concatenated_string] = STATE(2269),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2269),
    [sym_new_expression] = STATE(2269),
    [sym_delete_expression] = STATE(2269),
    [sym_lambda_expression] = STATE(2269),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4931),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(4931),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4933),
    [sym_false] = ACTIONS(4933),
    [sym_null] = ACTIONS(4933),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(4933),
  },
  [1561] = {
    [anon_sym_LPAREN2] = ACTIONS(4935),
    [sym_comment] = ACTIONS(91),
  },
  [1562] = {
    [sym_compound_statement] = STATE(642),
    [sym_labeled_statement] = STATE(642),
    [sym_expression_statement] = STATE(642),
    [sym_if_statement] = STATE(642),
    [sym_switch_statement] = STATE(642),
    [sym_case_statement] = STATE(642),
    [sym_while_statement] = STATE(642),
    [sym_do_statement] = STATE(642),
    [sym_for_statement] = STATE(642),
    [sym_return_statement] = STATE(642),
    [sym_break_statement] = STATE(642),
    [sym_continue_statement] = STATE(642),
    [sym_goto_statement] = STATE(642),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(642),
    [sym_try_statement] = STATE(642),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(1495),
    [anon_sym_switch] = ACTIONS(1497),
    [anon_sym_case] = ACTIONS(1499),
    [anon_sym_default] = ACTIONS(1501),
    [anon_sym_while] = ACTIONS(1503),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(1505),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(4937),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(1509),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [1563] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_COLON] = ACTIONS(4939),
    [anon_sym_QMARK] = ACTIONS(1171),
    [anon_sym_STAR_EQ] = ACTIONS(1173),
    [anon_sym_SLASH_EQ] = ACTIONS(1173),
    [anon_sym_PERCENT_EQ] = ACTIONS(1173),
    [anon_sym_PLUS_EQ] = ACTIONS(1173),
    [anon_sym_DASH_EQ] = ACTIONS(1173),
    [anon_sym_LT_LT_EQ] = ACTIONS(1173),
    [anon_sym_GT_GT_EQ] = ACTIONS(1173),
    [anon_sym_AMP_EQ] = ACTIONS(1173),
    [anon_sym_CARET_EQ] = ACTIONS(1173),
    [anon_sym_PIPE_EQ] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_CARET] = ACTIONS(1183),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [1564] = {
    [sym_declaration] = STATE(681),
    [sym_type_definition] = STATE(681),
    [sym__declaration_specifiers] = STATE(682),
    [sym_compound_statement] = STATE(681),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_labeled_statement] = STATE(681),
    [sym_expression_statement] = STATE(681),
    [sym_if_statement] = STATE(681),
    [sym_switch_statement] = STATE(681),
    [sym_case_statement] = STATE(681),
    [sym_while_statement] = STATE(681),
    [sym_do_statement] = STATE(681),
    [sym_for_statement] = STATE(681),
    [sym_return_statement] = STATE(681),
    [sym_break_statement] = STATE(681),
    [sym_continue_statement] = STATE(681),
    [sym_goto_statement] = STATE(681),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(681),
    [sym_try_statement] = STATE(681),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(1495),
    [anon_sym_switch] = ACTIONS(1497),
    [anon_sym_case] = ACTIONS(1499),
    [anon_sym_default] = ACTIONS(1501),
    [anon_sym_while] = ACTIONS(1503),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(1505),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(4941),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(1509),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(1202),
    [sym_nullptr] = ACTIONS(87),
  },
  [1565] = {
    [sym_compound_statement] = STATE(685),
    [sym_labeled_statement] = STATE(685),
    [sym_expression_statement] = STATE(685),
    [sym_if_statement] = STATE(685),
    [sym_switch_statement] = STATE(685),
    [sym_case_statement] = STATE(685),
    [sym_while_statement] = STATE(685),
    [sym_do_statement] = STATE(685),
    [sym_for_statement] = STATE(685),
    [sym_return_statement] = STATE(685),
    [sym_break_statement] = STATE(685),
    [sym_continue_statement] = STATE(685),
    [sym_goto_statement] = STATE(685),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(685),
    [sym_try_statement] = STATE(685),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(1495),
    [anon_sym_switch] = ACTIONS(1497),
    [anon_sym_case] = ACTIONS(1499),
    [anon_sym_default] = ACTIONS(1501),
    [anon_sym_while] = ACTIONS(1503),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(1505),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(4937),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(1509),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [1566] = {
    [sym_declaration] = STATE(2274),
    [sym__declaration_specifiers] = STATE(709),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym__expression] = STATE(2275),
    [sym_conditional_expression] = STATE(2275),
    [sym_assignment_expression] = STATE(2275),
    [sym_pointer_expression] = STATE(2275),
    [sym_logical_expression] = STATE(2275),
    [sym_bitwise_expression] = STATE(2275),
    [sym_equality_expression] = STATE(2275),
    [sym_relational_expression] = STATE(2275),
    [sym_shift_expression] = STATE(2275),
    [sym_math_expression] = STATE(2275),
    [sym_cast_expression] = STATE(2275),
    [sym_sizeof_expression] = STATE(2275),
    [sym_subscript_expression] = STATE(2275),
    [sym_call_expression] = STATE(2275),
    [sym_field_expression] = STATE(2275),
    [sym_compound_literal_expression] = STATE(2275),
    [sym_parenthesized_expression] = STATE(2275),
    [sym_char_literal] = STATE(2275),
    [sym_concatenated_string] = STATE(2275),
    [sym_string_literal] = STATE(238),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(2275),
    [sym_for_range_declaration] = STATE(2276),
    [sym_new_expression] = STATE(2275),
    [sym_delete_expression] = STATE(2275),
    [sym_lambda_expression] = STATE(2275),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(4943),
    [anon_sym_SEMI] = ACTIONS(4945),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(4943),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4947),
    [sym_false] = ACTIONS(4947),
    [sym_null] = ACTIONS(4947),
    [sym_identifier] = ACTIONS(1242),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(1244),
    [sym_nullptr] = ACTIONS(4947),
  },
  [1567] = {
    [sym_compound_statement] = STATE(762),
    [sym_labeled_statement] = STATE(762),
    [sym_expression_statement] = STATE(762),
    [sym_if_statement] = STATE(762),
    [sym_switch_statement] = STATE(762),
    [sym_case_statement] = STATE(762),
    [sym_while_statement] = STATE(762),
    [sym_do_statement] = STATE(762),
    [sym_for_statement] = STATE(762),
    [sym_return_statement] = STATE(762),
    [sym_break_statement] = STATE(762),
    [sym_continue_statement] = STATE(762),
    [sym_goto_statement] = STATE(762),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(762),
    [sym_try_statement] = STATE(762),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(1495),
    [anon_sym_switch] = ACTIONS(1497),
    [anon_sym_case] = ACTIONS(1499),
    [anon_sym_default] = ACTIONS(1501),
    [anon_sym_while] = ACTIONS(1503),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(1505),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(4937),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(1509),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [1568] = {
    [sym_catch_clause] = STATE(2277),
    [aux_sym_try_statement_repeat1] = STATE(2277),
    [sym_comment] = ACTIONS(91),
    [anon_sym_catch] = ACTIONS(1527),
  },
  [1569] = {
    [sym_raw_string_literal] = ACTIONS(4949),
    [ts_builtin_sym_end] = ACTIONS(4949),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4951),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4951),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4951),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4951),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4951),
    [sym_preproc_directive] = ACTIONS(4951),
    [anon_sym_SEMI] = ACTIONS(4949),
    [anon_sym_typedef] = ACTIONS(4951),
    [anon_sym_extern] = ACTIONS(4951),
    [anon_sym_LBRACE] = ACTIONS(4949),
    [anon_sym_RBRACE] = ACTIONS(4949),
    [anon_sym_LPAREN2] = ACTIONS(4949),
    [anon_sym_STAR] = ACTIONS(4949),
    [anon_sym_LBRACK] = ACTIONS(4949),
    [anon_sym_static] = ACTIONS(4951),
    [anon_sym_register] = ACTIONS(4951),
    [anon_sym_inline] = ACTIONS(4951),
    [anon_sym_const] = ACTIONS(4951),
    [anon_sym_restrict] = ACTIONS(4951),
    [anon_sym_volatile] = ACTIONS(4951),
    [anon_sym__Atomic] = ACTIONS(4951),
    [anon_sym_mutable] = ACTIONS(4951),
    [anon_sym_explicit] = ACTIONS(4951),
    [anon_sym_constexpr] = ACTIONS(4951),
    [anon_sym_unsigned] = ACTIONS(4951),
    [anon_sym_long] = ACTIONS(4951),
    [anon_sym_short] = ACTIONS(4951),
    [sym_primitive_type] = ACTIONS(4951),
    [anon_sym_enum] = ACTIONS(4951),
    [anon_sym_struct] = ACTIONS(4951),
    [anon_sym_union] = ACTIONS(4951),
    [anon_sym_if] = ACTIONS(4951),
    [anon_sym_switch] = ACTIONS(4951),
    [anon_sym_case] = ACTIONS(4951),
    [anon_sym_default] = ACTIONS(4951),
    [anon_sym_while] = ACTIONS(4951),
    [anon_sym_do] = ACTIONS(4951),
    [anon_sym_for] = ACTIONS(4951),
    [anon_sym_return] = ACTIONS(4951),
    [anon_sym_break] = ACTIONS(4951),
    [anon_sym_continue] = ACTIONS(4951),
    [anon_sym_goto] = ACTIONS(4951),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_AMP_AMP] = ACTIONS(4949),
    [anon_sym_BANG] = ACTIONS(4949),
    [anon_sym_TILDE] = ACTIONS(4949),
    [anon_sym_PLUS] = ACTIONS(4951),
    [anon_sym_DASH] = ACTIONS(4951),
    [anon_sym_DASH_DASH] = ACTIONS(4949),
    [anon_sym_PLUS_PLUS] = ACTIONS(4949),
    [anon_sym_sizeof] = ACTIONS(4951),
    [sym_number_literal] = ACTIONS(4949),
    [anon_sym_SQUOTE] = ACTIONS(4949),
    [anon_sym_DQUOTE] = ACTIONS(4949),
    [sym_true] = ACTIONS(4951),
    [sym_false] = ACTIONS(4951),
    [sym_null] = ACTIONS(4951),
    [sym_identifier] = ACTIONS(4951),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4951),
    [sym_auto] = ACTIONS(4951),
    [anon_sym_typename] = ACTIONS(4951),
    [anon_sym_template] = ACTIONS(4951),
    [anon_sym_delete] = ACTIONS(4951),
    [anon_sym_namespace] = ACTIONS(4951),
    [anon_sym_using] = ACTIONS(4951),
    [anon_sym_try] = ACTIONS(4951),
    [anon_sym_new] = ACTIONS(4951),
    [anon_sym_COLON_COLON] = ACTIONS(4949),
    [sym_operator_name] = ACTIONS(4949),
    [sym_nullptr] = ACTIONS(4951),
  },
  [1570] = {
    [sym_preproc_include] = STATE(1570),
    [sym_preproc_def] = STATE(1570),
    [sym_preproc_function_def] = STATE(1570),
    [sym_preproc_call] = STATE(1570),
    [sym_preproc_if] = STATE(1570),
    [sym_preproc_ifdef] = STATE(1570),
    [sym_function_definition] = STATE(1570),
    [sym_declaration] = STATE(1570),
    [sym_type_definition] = STATE(1570),
    [sym__declaration_specifiers] = STATE(49),
    [sym_linkage_specification] = STATE(1570),
    [sym__declarator] = STATE(50),
    [sym_pointer_declarator] = STATE(50),
    [sym_function_declarator] = STATE(51),
    [sym_array_declarator] = STATE(50),
    [sym_compound_statement] = STATE(1570),
    [sym_storage_class_specifier] = STATE(63),
    [sym_type_qualifier] = STATE(63),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(1570),
    [sym_expression_statement] = STATE(1570),
    [sym_if_statement] = STATE(1570),
    [sym_switch_statement] = STATE(1570),
    [sym_case_statement] = STATE(1570),
    [sym_while_statement] = STATE(1570),
    [sym_do_statement] = STATE(1570),
    [sym_for_statement] = STATE(1570),
    [sym_return_statement] = STATE(1570),
    [sym_break_statement] = STATE(1570),
    [sym_continue_statement] = STATE(1570),
    [sym_goto_statement] = STATE(1570),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(1570),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(1570),
    [sym_template_declaration] = STATE(1570),
    [sym_template_instantiation] = STATE(1570),
    [sym_constructor_or_destructor_definition] = STATE(1570),
    [sym_reference_declarator] = STATE(50),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(57),
    [sym_namespace_definition] = STATE(1570),
    [sym_using_declaration] = STATE(1570),
    [sym_alias_declaration] = STATE(1570),
    [sym_for_range_loop] = STATE(1570),
    [sym_try_statement] = STATE(1570),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_destructor_name] = STATE(50),
    [sym_scoped_identifier] = STATE(59),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_translation_unit_repeat1] = STATE(1570),
    [aux_sym__declaration_specifiers_repeat1] = STATE(63),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(1803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1808),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1811),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1814),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1817),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1817),
    [sym_preproc_directive] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(1823),
    [anon_sym_typedef] = ACTIONS(1826),
    [anon_sym_extern] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(1832),
    [anon_sym_RBRACE] = ACTIONS(1806),
    [anon_sym_LPAREN2] = ACTIONS(1835),
    [anon_sym_STAR] = ACTIONS(1838),
    [anon_sym_LBRACK] = ACTIONS(1841),
    [anon_sym_static] = ACTIONS(1844),
    [anon_sym_register] = ACTIONS(1844),
    [anon_sym_inline] = ACTIONS(1844),
    [anon_sym_const] = ACTIONS(1847),
    [anon_sym_restrict] = ACTIONS(1847),
    [anon_sym_volatile] = ACTIONS(1847),
    [anon_sym__Atomic] = ACTIONS(1847),
    [anon_sym_mutable] = ACTIONS(1847),
    [anon_sym_explicit] = ACTIONS(1847),
    [anon_sym_constexpr] = ACTIONS(1847),
    [anon_sym_unsigned] = ACTIONS(1850),
    [anon_sym_long] = ACTIONS(1850),
    [anon_sym_short] = ACTIONS(1850),
    [sym_primitive_type] = ACTIONS(1853),
    [anon_sym_enum] = ACTIONS(1856),
    [anon_sym_struct] = ACTIONS(1859),
    [anon_sym_union] = ACTIONS(1862),
    [anon_sym_if] = ACTIONS(4953),
    [anon_sym_switch] = ACTIONS(4956),
    [anon_sym_case] = ACTIONS(4959),
    [anon_sym_default] = ACTIONS(4962),
    [anon_sym_while] = ACTIONS(4965),
    [anon_sym_do] = ACTIONS(1880),
    [anon_sym_for] = ACTIONS(4968),
    [anon_sym_return] = ACTIONS(1886),
    [anon_sym_break] = ACTIONS(1889),
    [anon_sym_continue] = ACTIONS(1892),
    [anon_sym_goto] = ACTIONS(1895),
    [anon_sym_AMP] = ACTIONS(1898),
    [anon_sym_AMP_AMP] = ACTIONS(1901),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1907),
    [anon_sym_PLUS] = ACTIONS(1910),
    [anon_sym_DASH] = ACTIONS(1910),
    [anon_sym_DASH_DASH] = ACTIONS(1913),
    [anon_sym_PLUS_PLUS] = ACTIONS(1913),
    [anon_sym_sizeof] = ACTIONS(1916),
    [sym_number_literal] = ACTIONS(1803),
    [anon_sym_SQUOTE] = ACTIONS(1919),
    [anon_sym_DQUOTE] = ACTIONS(1922),
    [sym_true] = ACTIONS(1925),
    [sym_false] = ACTIONS(1925),
    [sym_null] = ACTIONS(1925),
    [sym_identifier] = ACTIONS(4971),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1931),
    [sym_auto] = ACTIONS(1853),
    [anon_sym_typename] = ACTIONS(1934),
    [anon_sym_template] = ACTIONS(1937),
    [anon_sym_delete] = ACTIONS(1940),
    [anon_sym_namespace] = ACTIONS(1943),
    [anon_sym_using] = ACTIONS(1946),
    [anon_sym_try] = ACTIONS(4974),
    [anon_sym_new] = ACTIONS(1952),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [sym_operator_name] = ACTIONS(1958),
    [sym_nullptr] = ACTIONS(1925),
  },
  [1571] = {
    [sym__type_specifier] = STATE(271),
    [sym_sized_type_specifier] = STATE(271),
    [sym_enum_specifier] = STATE(271),
    [sym_struct_specifier] = STATE(271),
    [sym_union_specifier] = STATE(271),
    [sym_macro_type_specifier] = STATE(271),
    [sym_class_specifier] = STATE(271),
    [sym_dependent_type] = STATE(271),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1575),
    [anon_sym_unsigned] = ACTIONS(3334),
    [anon_sym_long] = ACTIONS(3334),
    [anon_sym_short] = ACTIONS(3334),
    [sym_primitive_type] = ACTIONS(490),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(490),
    [anon_sym_typename] = ACTIONS(3338),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [1572] = {
    [sym__abstract_declarator] = STATE(2280),
    [sym_abstract_pointer_declarator] = STATE(2280),
    [sym_abstract_function_declarator] = STATE(2280),
    [sym_abstract_array_declarator] = STATE(2280),
    [sym_parameter_list] = STATE(2281),
    [sym_abstract_reference_declarator] = STATE(2280),
    [anon_sym_SEMI] = ACTIONS(887),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(4977),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_AMP] = ACTIONS(4979),
    [anon_sym_AMP_AMP] = ACTIONS(4981),
    [sym_comment] = ACTIONS(91),
  },
  [1573] = {
    [anon_sym_SEMI] = ACTIONS(4983),
    [sym_comment] = ACTIONS(91),
  },
  [1574] = {
    [sym_type_qualifier] = STATE(453),
    [sym__type_specifier] = STATE(2283),
    [sym_sized_type_specifier] = STATE(2283),
    [sym_enum_specifier] = STATE(2283),
    [sym_struct_specifier] = STATE(2283),
    [sym_union_specifier] = STATE(2283),
    [sym_macro_type_specifier] = STATE(2283),
    [sym_class_specifier] = STATE(2283),
    [sym_dependent_type] = STATE(2283),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_type_definition_repeat1] = STATE(453),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1575),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(3334),
    [anon_sym_long] = ACTIONS(3334),
    [anon_sym_short] = ACTIONS(3334),
    [sym_primitive_type] = ACTIONS(4985),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(4985),
    [anon_sym_typename] = ACTIONS(3338),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [1575] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2284),
    [anon_sym_SEMI] = ACTIONS(653),
    [anon_sym_LPAREN2] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_unsigned] = ACTIONS(4987),
    [anon_sym_long] = ACTIONS(4987),
    [anon_sym_short] = ACTIONS(4987),
    [sym_primitive_type] = ACTIONS(659),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [sym_identifier] = ACTIONS(933),
    [sym_comment] = ACTIONS(91),
  },
  [1576] = {
    [anon_sym_SEMI] = ACTIONS(3211),
    [anon_sym_LT] = ACTIONS(3218),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(3225),
  },
  [1577] = {
    [sym_raw_string_literal] = ACTIONS(4989),
    [ts_builtin_sym_end] = ACTIONS(4989),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4991),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4991),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4991),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4991),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4991),
    [sym_preproc_directive] = ACTIONS(4991),
    [anon_sym_SEMI] = ACTIONS(4989),
    [anon_sym_typedef] = ACTIONS(4991),
    [anon_sym_extern] = ACTIONS(4991),
    [anon_sym_LBRACE] = ACTIONS(4989),
    [anon_sym_RBRACE] = ACTIONS(4989),
    [anon_sym_LPAREN2] = ACTIONS(4989),
    [anon_sym_STAR] = ACTIONS(4989),
    [anon_sym_LBRACK] = ACTIONS(4989),
    [anon_sym_static] = ACTIONS(4991),
    [anon_sym_register] = ACTIONS(4991),
    [anon_sym_inline] = ACTIONS(4991),
    [anon_sym_const] = ACTIONS(4991),
    [anon_sym_restrict] = ACTIONS(4991),
    [anon_sym_volatile] = ACTIONS(4991),
    [anon_sym__Atomic] = ACTIONS(4991),
    [anon_sym_mutable] = ACTIONS(4991),
    [anon_sym_explicit] = ACTIONS(4991),
    [anon_sym_constexpr] = ACTIONS(4991),
    [anon_sym_unsigned] = ACTIONS(4991),
    [anon_sym_long] = ACTIONS(4991),
    [anon_sym_short] = ACTIONS(4991),
    [sym_primitive_type] = ACTIONS(4991),
    [anon_sym_enum] = ACTIONS(4991),
    [anon_sym_struct] = ACTIONS(4991),
    [anon_sym_union] = ACTIONS(4991),
    [anon_sym_if] = ACTIONS(4991),
    [anon_sym_switch] = ACTIONS(4991),
    [anon_sym_case] = ACTIONS(4991),
    [anon_sym_default] = ACTIONS(4991),
    [anon_sym_while] = ACTIONS(4991),
    [anon_sym_do] = ACTIONS(4991),
    [anon_sym_for] = ACTIONS(4991),
    [anon_sym_return] = ACTIONS(4991),
    [anon_sym_break] = ACTIONS(4991),
    [anon_sym_continue] = ACTIONS(4991),
    [anon_sym_goto] = ACTIONS(4991),
    [anon_sym_AMP] = ACTIONS(4991),
    [anon_sym_AMP_AMP] = ACTIONS(4989),
    [anon_sym_BANG] = ACTIONS(4989),
    [anon_sym_TILDE] = ACTIONS(4989),
    [anon_sym_PLUS] = ACTIONS(4991),
    [anon_sym_DASH] = ACTIONS(4991),
    [anon_sym_DASH_DASH] = ACTIONS(4989),
    [anon_sym_PLUS_PLUS] = ACTIONS(4989),
    [anon_sym_sizeof] = ACTIONS(4991),
    [sym_number_literal] = ACTIONS(4989),
    [anon_sym_SQUOTE] = ACTIONS(4989),
    [anon_sym_DQUOTE] = ACTIONS(4989),
    [sym_true] = ACTIONS(4991),
    [sym_false] = ACTIONS(4991),
    [sym_null] = ACTIONS(4991),
    [sym_identifier] = ACTIONS(4991),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4991),
    [sym_auto] = ACTIONS(4991),
    [anon_sym_typename] = ACTIONS(4991),
    [anon_sym_template] = ACTIONS(4991),
    [anon_sym_delete] = ACTIONS(4991),
    [anon_sym_namespace] = ACTIONS(4991),
    [anon_sym_using] = ACTIONS(4991),
    [anon_sym_try] = ACTIONS(4991),
    [anon_sym_new] = ACTIONS(4991),
    [anon_sym_COLON_COLON] = ACTIONS(4989),
    [sym_operator_name] = ACTIONS(4989),
    [sym_nullptr] = ACTIONS(4991),
  },
  [1578] = {
    [anon_sym_SEMI] = ACTIONS(3629),
    [anon_sym_LT] = ACTIONS(3636),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(3643),
  },
  [1579] = {
    [sym_compound_statement] = STATE(2285),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(91),
  },
  [1580] = {
    [sym_catch_clause] = STATE(1580),
    [aux_sym_try_statement_repeat1] = STATE(1580),
    [sym_raw_string_literal] = ACTIONS(4993),
    [ts_builtin_sym_end] = ACTIONS(4993),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4995),
    [sym_preproc_directive] = ACTIONS(4995),
    [anon_sym_SEMI] = ACTIONS(4993),
    [anon_sym_typedef] = ACTIONS(4995),
    [anon_sym_extern] = ACTIONS(4995),
    [anon_sym_LBRACE] = ACTIONS(4993),
    [anon_sym_LPAREN2] = ACTIONS(4993),
    [anon_sym_STAR] = ACTIONS(4993),
    [anon_sym_LBRACK] = ACTIONS(4993),
    [anon_sym_static] = ACTIONS(4995),
    [anon_sym_register] = ACTIONS(4995),
    [anon_sym_inline] = ACTIONS(4995),
    [anon_sym_const] = ACTIONS(4995),
    [anon_sym_restrict] = ACTIONS(4995),
    [anon_sym_volatile] = ACTIONS(4995),
    [anon_sym__Atomic] = ACTIONS(4995),
    [anon_sym_mutable] = ACTIONS(4995),
    [anon_sym_explicit] = ACTIONS(4995),
    [anon_sym_constexpr] = ACTIONS(4995),
    [anon_sym_unsigned] = ACTIONS(4995),
    [anon_sym_long] = ACTIONS(4995),
    [anon_sym_short] = ACTIONS(4995),
    [sym_primitive_type] = ACTIONS(4995),
    [anon_sym_enum] = ACTIONS(4995),
    [anon_sym_struct] = ACTIONS(4995),
    [anon_sym_union] = ACTIONS(4995),
    [anon_sym_if] = ACTIONS(4995),
    [anon_sym_switch] = ACTIONS(4995),
    [anon_sym_case] = ACTIONS(4995),
    [anon_sym_default] = ACTIONS(4995),
    [anon_sym_while] = ACTIONS(4995),
    [anon_sym_do] = ACTIONS(4995),
    [anon_sym_for] = ACTIONS(4995),
    [anon_sym_return] = ACTIONS(4995),
    [anon_sym_break] = ACTIONS(4995),
    [anon_sym_continue] = ACTIONS(4995),
    [anon_sym_goto] = ACTIONS(4995),
    [anon_sym_AMP] = ACTIONS(4995),
    [anon_sym_AMP_AMP] = ACTIONS(4993),
    [anon_sym_BANG] = ACTIONS(4993),
    [anon_sym_TILDE] = ACTIONS(4993),
    [anon_sym_PLUS] = ACTIONS(4995),
    [anon_sym_DASH] = ACTIONS(4995),
    [anon_sym_DASH_DASH] = ACTIONS(4993),
    [anon_sym_PLUS_PLUS] = ACTIONS(4993),
    [anon_sym_sizeof] = ACTIONS(4995),
    [sym_number_literal] = ACTIONS(4993),
    [anon_sym_SQUOTE] = ACTIONS(4993),
    [anon_sym_DQUOTE] = ACTIONS(4993),
    [sym_true] = ACTIONS(4995),
    [sym_false] = ACTIONS(4995),
    [sym_null] = ACTIONS(4995),
    [sym_identifier] = ACTIONS(4995),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4995),
    [sym_auto] = ACTIONS(4995),
    [anon_sym_typename] = ACTIONS(4995),
    [anon_sym_template] = ACTIONS(4995),
    [anon_sym_delete] = ACTIONS(4995),
    [anon_sym_namespace] = ACTIONS(4995),
    [anon_sym_using] = ACTIONS(4995),
    [anon_sym_try] = ACTIONS(4995),
    [anon_sym_catch] = ACTIONS(4997),
    [anon_sym_new] = ACTIONS(4995),
    [anon_sym_COLON_COLON] = ACTIONS(4993),
    [sym_operator_name] = ACTIONS(4993),
    [sym_nullptr] = ACTIONS(4995),
  },
  [1581] = {
    [sym__expression] = STATE(2286),
    [sym_conditional_expression] = STATE(2286),
    [sym_assignment_expression] = STATE(2286),
    [sym_pointer_expression] = STATE(2286),
    [sym_logical_expression] = STATE(2286),
    [sym_bitwise_expression] = STATE(2286),
    [sym_equality_expression] = STATE(2286),
    [sym_relational_expression] = STATE(2286),
    [sym_shift_expression] = STATE(2286),
    [sym_math_expression] = STATE(2286),
    [sym_cast_expression] = STATE(2286),
    [sym_sizeof_expression] = STATE(2286),
    [sym_subscript_expression] = STATE(2286),
    [sym_call_expression] = STATE(2286),
    [sym_field_expression] = STATE(2286),
    [sym_compound_literal_expression] = STATE(2286),
    [sym_parenthesized_expression] = STATE(2286),
    [sym_initializer_list] = STATE(2287),
    [sym_char_literal] = STATE(2286),
    [sym_concatenated_string] = STATE(2286),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2286),
    [sym_new_expression] = STATE(2286),
    [sym_delete_expression] = STATE(2286),
    [sym_lambda_expression] = STATE(2286),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5000),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(5000),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(5002),
    [sym_false] = ACTIONS(5002),
    [sym_null] = ACTIONS(5002),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(5002),
  },
  [1582] = {
    [anon_sym_COMMA] = ACTIONS(5004),
    [anon_sym_RPAREN] = ACTIONS(5004),
    [anon_sym_SEMI] = ACTIONS(5004),
    [anon_sym_LBRACE] = ACTIONS(5004),
    [anon_sym_RBRACE] = ACTIONS(5004),
    [anon_sym_LPAREN2] = ACTIONS(5004),
    [anon_sym_STAR] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(5004),
    [anon_sym_RBRACK] = ACTIONS(5004),
    [anon_sym_EQ] = ACTIONS(5006),
    [anon_sym_unsigned] = ACTIONS(5006),
    [anon_sym_long] = ACTIONS(5006),
    [anon_sym_short] = ACTIONS(5006),
    [sym_primitive_type] = ACTIONS(5006),
    [anon_sym_enum] = ACTIONS(5006),
    [anon_sym_struct] = ACTIONS(5006),
    [anon_sym_union] = ACTIONS(5006),
    [anon_sym_QMARK] = ACTIONS(5004),
    [anon_sym_STAR_EQ] = ACTIONS(5004),
    [anon_sym_SLASH_EQ] = ACTIONS(5004),
    [anon_sym_PERCENT_EQ] = ACTIONS(5004),
    [anon_sym_PLUS_EQ] = ACTIONS(5004),
    [anon_sym_DASH_EQ] = ACTIONS(5004),
    [anon_sym_LT_LT_EQ] = ACTIONS(5004),
    [anon_sym_GT_GT_EQ] = ACTIONS(5004),
    [anon_sym_AMP_EQ] = ACTIONS(5004),
    [anon_sym_CARET_EQ] = ACTIONS(5004),
    [anon_sym_PIPE_EQ] = ACTIONS(5004),
    [anon_sym_AMP] = ACTIONS(5006),
    [anon_sym_PIPE_PIPE] = ACTIONS(5004),
    [anon_sym_AMP_AMP] = ACTIONS(5004),
    [anon_sym_PIPE] = ACTIONS(5006),
    [anon_sym_CARET] = ACTIONS(5006),
    [anon_sym_EQ_EQ] = ACTIONS(5004),
    [anon_sym_BANG_EQ] = ACTIONS(5004),
    [anon_sym_LT] = ACTIONS(5006),
    [anon_sym_GT] = ACTIONS(5006),
    [anon_sym_LT_EQ] = ACTIONS(5004),
    [anon_sym_GT_EQ] = ACTIONS(5004),
    [anon_sym_LT_LT] = ACTIONS(5006),
    [anon_sym_GT_GT] = ACTIONS(5006),
    [anon_sym_PLUS] = ACTIONS(5006),
    [anon_sym_DASH] = ACTIONS(5006),
    [anon_sym_SLASH] = ACTIONS(5006),
    [anon_sym_PERCENT] = ACTIONS(5006),
    [anon_sym_DASH_DASH] = ACTIONS(5004),
    [anon_sym_PLUS_PLUS] = ACTIONS(5004),
    [anon_sym_DOT] = ACTIONS(5004),
    [anon_sym_DASH_GT] = ACTIONS(5004),
    [sym_identifier] = ACTIONS(5006),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5006),
    [sym_auto] = ACTIONS(5006),
    [anon_sym_typename] = ACTIONS(5006),
    [anon_sym_COLON_COLON] = ACTIONS(5004),
  },
  [1583] = {
    [aux_sym_argument_list_repeat1] = STATE(2289),
    [anon_sym_COMMA] = ACTIONS(3356),
    [anon_sym_RPAREN] = ACTIONS(5008),
    [sym_comment] = ACTIONS(91),
  },
  [1584] = {
    [anon_sym_RBRACE] = ACTIONS(5010),
    [sym_comment] = ACTIONS(91),
  },
  [1585] = {
    [anon_sym_COMMA] = ACTIONS(2613),
    [anon_sym_RPAREN] = ACTIONS(2613),
    [anon_sym_SEMI] = ACTIONS(2613),
    [anon_sym_LBRACE] = ACTIONS(2613),
    [anon_sym_RBRACE] = ACTIONS(2613),
    [anon_sym_LPAREN2] = ACTIONS(2613),
    [anon_sym_STAR] = ACTIONS(2615),
    [anon_sym_LBRACK] = ACTIONS(2613),
    [anon_sym_RBRACK] = ACTIONS(2613),
    [anon_sym_EQ] = ACTIONS(2615),
    [anon_sym_COLON] = ACTIONS(2613),
    [anon_sym_QMARK] = ACTIONS(2613),
    [anon_sym_STAR_EQ] = ACTIONS(2613),
    [anon_sym_SLASH_EQ] = ACTIONS(2613),
    [anon_sym_PERCENT_EQ] = ACTIONS(2613),
    [anon_sym_PLUS_EQ] = ACTIONS(2613),
    [anon_sym_DASH_EQ] = ACTIONS(2613),
    [anon_sym_LT_LT_EQ] = ACTIONS(2613),
    [anon_sym_GT_GT_EQ] = ACTIONS(2613),
    [anon_sym_AMP_EQ] = ACTIONS(2613),
    [anon_sym_CARET_EQ] = ACTIONS(2613),
    [anon_sym_PIPE_EQ] = ACTIONS(2613),
    [anon_sym_AMP] = ACTIONS(2615),
    [anon_sym_PIPE_PIPE] = ACTIONS(2613),
    [anon_sym_AMP_AMP] = ACTIONS(2613),
    [anon_sym_PIPE] = ACTIONS(2615),
    [anon_sym_CARET] = ACTIONS(2615),
    [anon_sym_EQ_EQ] = ACTIONS(2613),
    [anon_sym_BANG_EQ] = ACTIONS(2613),
    [anon_sym_LT] = ACTIONS(2615),
    [anon_sym_GT] = ACTIONS(2615),
    [anon_sym_LT_EQ] = ACTIONS(2613),
    [anon_sym_GT_EQ] = ACTIONS(2613),
    [anon_sym_LT_LT] = ACTIONS(2615),
    [anon_sym_GT_GT] = ACTIONS(2615),
    [anon_sym_PLUS] = ACTIONS(2615),
    [anon_sym_DASH] = ACTIONS(2615),
    [anon_sym_SLASH] = ACTIONS(2615),
    [anon_sym_PERCENT] = ACTIONS(2615),
    [anon_sym_DASH_DASH] = ACTIONS(2613),
    [anon_sym_PLUS_PLUS] = ACTIONS(2613),
    [anon_sym_DOT] = ACTIONS(2613),
    [anon_sym_DASH_GT] = ACTIONS(2613),
    [sym_comment] = ACTIONS(91),
  },
  [1586] = {
    [aux_sym_enumerator_list_repeat1] = STATE(2292),
    [anon_sym_COMMA] = ACTIONS(5012),
    [anon_sym_RBRACE] = ACTIONS(5010),
    [sym_comment] = ACTIONS(91),
  },
  [1587] = {
    [anon_sym_COMMA] = ACTIONS(2623),
    [anon_sym_RPAREN] = ACTIONS(2623),
    [anon_sym_SEMI] = ACTIONS(2623),
    [anon_sym_LBRACE] = ACTIONS(2623),
    [anon_sym_RBRACE] = ACTIONS(2623),
    [anon_sym_LPAREN2] = ACTIONS(2623),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(2623),
    [anon_sym_RBRACK] = ACTIONS(2623),
    [anon_sym_EQ] = ACTIONS(2625),
    [anon_sym_COLON] = ACTIONS(2623),
    [anon_sym_QMARK] = ACTIONS(2623),
    [anon_sym_STAR_EQ] = ACTIONS(2623),
    [anon_sym_SLASH_EQ] = ACTIONS(2623),
    [anon_sym_PERCENT_EQ] = ACTIONS(2623),
    [anon_sym_PLUS_EQ] = ACTIONS(2623),
    [anon_sym_DASH_EQ] = ACTIONS(2623),
    [anon_sym_LT_LT_EQ] = ACTIONS(2623),
    [anon_sym_GT_GT_EQ] = ACTIONS(2623),
    [anon_sym_AMP_EQ] = ACTIONS(2623),
    [anon_sym_CARET_EQ] = ACTIONS(2623),
    [anon_sym_PIPE_EQ] = ACTIONS(2623),
    [anon_sym_AMP] = ACTIONS(2625),
    [anon_sym_PIPE_PIPE] = ACTIONS(2623),
    [anon_sym_AMP_AMP] = ACTIONS(2623),
    [anon_sym_PIPE] = ACTIONS(2625),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_EQ_EQ] = ACTIONS(2623),
    [anon_sym_BANG_EQ] = ACTIONS(2623),
    [anon_sym_LT] = ACTIONS(2625),
    [anon_sym_GT] = ACTIONS(2625),
    [anon_sym_LT_EQ] = ACTIONS(2623),
    [anon_sym_GT_EQ] = ACTIONS(2623),
    [anon_sym_LT_LT] = ACTIONS(2625),
    [anon_sym_GT_GT] = ACTIONS(2625),
    [anon_sym_PLUS] = ACTIONS(2625),
    [anon_sym_DASH] = ACTIONS(2625),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(2623),
    [anon_sym_PLUS_PLUS] = ACTIONS(2623),
    [anon_sym_DOT] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2623),
    [sym_comment] = ACTIONS(91),
  },
  [1588] = {
    [anon_sym_COMMA] = ACTIONS(2633),
    [anon_sym_RPAREN] = ACTIONS(2633),
    [anon_sym_SEMI] = ACTIONS(2633),
    [anon_sym_LBRACE] = ACTIONS(2633),
    [anon_sym_RBRACE] = ACTIONS(2633),
    [anon_sym_LPAREN2] = ACTIONS(2633),
    [anon_sym_STAR] = ACTIONS(2635),
    [anon_sym_LBRACK] = ACTIONS(2633),
    [anon_sym_RBRACK] = ACTIONS(2633),
    [anon_sym_EQ] = ACTIONS(2635),
    [anon_sym_COLON] = ACTIONS(2633),
    [anon_sym_QMARK] = ACTIONS(2633),
    [anon_sym_STAR_EQ] = ACTIONS(2633),
    [anon_sym_SLASH_EQ] = ACTIONS(2633),
    [anon_sym_PERCENT_EQ] = ACTIONS(2633),
    [anon_sym_PLUS_EQ] = ACTIONS(2633),
    [anon_sym_DASH_EQ] = ACTIONS(2633),
    [anon_sym_LT_LT_EQ] = ACTIONS(2633),
    [anon_sym_GT_GT_EQ] = ACTIONS(2633),
    [anon_sym_AMP_EQ] = ACTIONS(2633),
    [anon_sym_CARET_EQ] = ACTIONS(2633),
    [anon_sym_PIPE_EQ] = ACTIONS(2633),
    [anon_sym_AMP] = ACTIONS(2635),
    [anon_sym_PIPE_PIPE] = ACTIONS(2633),
    [anon_sym_AMP_AMP] = ACTIONS(2633),
    [anon_sym_PIPE] = ACTIONS(2635),
    [anon_sym_CARET] = ACTIONS(2635),
    [anon_sym_EQ_EQ] = ACTIONS(2633),
    [anon_sym_BANG_EQ] = ACTIONS(2633),
    [anon_sym_LT] = ACTIONS(2635),
    [anon_sym_GT] = ACTIONS(2635),
    [anon_sym_LT_EQ] = ACTIONS(2633),
    [anon_sym_GT_EQ] = ACTIONS(2633),
    [anon_sym_LT_LT] = ACTIONS(2635),
    [anon_sym_GT_GT] = ACTIONS(2635),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2635),
    [anon_sym_PERCENT] = ACTIONS(2635),
    [anon_sym_DASH_DASH] = ACTIONS(2633),
    [anon_sym_PLUS_PLUS] = ACTIONS(2633),
    [anon_sym_DOT] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(2633),
    [sym_comment] = ACTIONS(91),
  },
  [1589] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(1276),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1276),
    [sym_type_definition] = STATE(1276),
    [sym__declaration_specifiers] = STATE(598),
    [sym__declarator] = STATE(599),
    [sym_pointer_declarator] = STATE(599),
    [sym_function_declarator] = STATE(600),
    [sym_array_declarator] = STATE(599),
    [sym_storage_class_specifier] = STATE(605),
    [sym_type_qualifier] = STATE(605),
    [sym__type_specifier] = STATE(601),
    [sym_sized_type_specifier] = STATE(601),
    [sym_enum_specifier] = STATE(601),
    [sym_struct_specifier] = STATE(601),
    [sym_union_specifier] = STATE(601),
    [sym__field_declaration_list_item] = STATE(1276),
    [sym_field_declaration] = STATE(1276),
    [sym_macro_type_specifier] = STATE(601),
    [sym_class_specifier] = STATE(601),
    [sym_dependent_type] = STATE(601),
    [sym_template_declaration] = STATE(1276),
    [sym_inline_method_definition] = STATE(1276),
    [sym_constructor_or_destructor_definition] = STATE(1276),
    [sym_constructor_or_destructor_declaration] = STATE(1276),
    [sym_friend_declaration] = STATE(1276),
    [sym_access_specifier] = STATE(1276),
    [sym_reference_declarator] = STATE(599),
    [sym_template_type] = STATE(602),
    [sym_template_function] = STATE(599),
    [sym_using_declaration] = STATE(1276),
    [sym_alias_declaration] = STATE(1276),
    [sym_destructor_name] = STATE(599),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(603),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1276),
    [aux_sym__declaration_specifiers_repeat1] = STATE(605),
    [aux_sym_sized_type_specifier_repeat1] = STATE(606),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1019),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1021),
    [anon_sym_typedef] = ACTIONS(1023),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(5014),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(425),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(1027),
    [anon_sym_long] = ACTIONS(1027),
    [anon_sym_short] = ACTIONS(1027),
    [sym_primitive_type] = ACTIONS(1029),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(1031),
    [anon_sym_union] = ACTIONS(1033),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(1035),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1039),
    [sym_auto] = ACTIONS(1029),
    [anon_sym_typename] = ACTIONS(1041),
    [anon_sym_template] = ACTIONS(1043),
    [anon_sym_friend] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1039),
    [anon_sym_protected] = ACTIONS(1039),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_COLON_COLON] = ACTIONS(1049),
    [sym_operator_name] = ACTIONS(1051),
  },
  [1590] = {
    [anon_sym_COMMA] = ACTIONS(2693),
    [anon_sym_RPAREN] = ACTIONS(2693),
    [anon_sym_SEMI] = ACTIONS(2693),
    [anon_sym_LBRACE] = ACTIONS(2693),
    [anon_sym_RBRACE] = ACTIONS(2693),
    [anon_sym_LPAREN2] = ACTIONS(2693),
    [anon_sym_STAR] = ACTIONS(2695),
    [anon_sym_LBRACK] = ACTIONS(2693),
    [anon_sym_RBRACK] = ACTIONS(2693),
    [anon_sym_EQ] = ACTIONS(2695),
    [anon_sym_COLON] = ACTIONS(2693),
    [anon_sym_QMARK] = ACTIONS(2693),
    [anon_sym_STAR_EQ] = ACTIONS(2693),
    [anon_sym_SLASH_EQ] = ACTIONS(2693),
    [anon_sym_PERCENT_EQ] = ACTIONS(2693),
    [anon_sym_PLUS_EQ] = ACTIONS(2693),
    [anon_sym_DASH_EQ] = ACTIONS(2693),
    [anon_sym_LT_LT_EQ] = ACTIONS(2693),
    [anon_sym_GT_GT_EQ] = ACTIONS(2693),
    [anon_sym_AMP_EQ] = ACTIONS(2693),
    [anon_sym_CARET_EQ] = ACTIONS(2693),
    [anon_sym_PIPE_EQ] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(2695),
    [anon_sym_PIPE_PIPE] = ACTIONS(2693),
    [anon_sym_AMP_AMP] = ACTIONS(2693),
    [anon_sym_PIPE] = ACTIONS(2695),
    [anon_sym_CARET] = ACTIONS(2695),
    [anon_sym_EQ_EQ] = ACTIONS(2693),
    [anon_sym_BANG_EQ] = ACTIONS(2693),
    [anon_sym_LT] = ACTIONS(2695),
    [anon_sym_GT] = ACTIONS(2695),
    [anon_sym_LT_EQ] = ACTIONS(2693),
    [anon_sym_GT_EQ] = ACTIONS(2693),
    [anon_sym_LT_LT] = ACTIONS(2695),
    [anon_sym_GT_GT] = ACTIONS(2695),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_DASH] = ACTIONS(2695),
    [anon_sym_SLASH] = ACTIONS(2695),
    [anon_sym_PERCENT] = ACTIONS(2695),
    [anon_sym_DASH_DASH] = ACTIONS(2693),
    [anon_sym_PLUS_PLUS] = ACTIONS(2693),
    [anon_sym_DOT] = ACTIONS(2693),
    [anon_sym_DASH_GT] = ACTIONS(2693),
    [sym_comment] = ACTIONS(91),
  },
  [1591] = {
    [sym_field_declaration_list] = STATE(2294),
    [sym_base_class_clause] = STATE(2295),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [anon_sym_COLON] = ACTIONS(1073),
    [sym_comment] = ACTIONS(91),
  },
  [1592] = {
    [sym_field_declaration_list] = STATE(2294),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [sym_comment] = ACTIONS(91),
  },
  [1593] = {
    [anon_sym_COMMA] = ACTIONS(2697),
    [anon_sym_RPAREN] = ACTIONS(2697),
    [anon_sym_SEMI] = ACTIONS(2697),
    [anon_sym_LBRACE] = ACTIONS(2697),
    [anon_sym_RBRACE] = ACTIONS(2697),
    [anon_sym_LPAREN2] = ACTIONS(2697),
    [anon_sym_STAR] = ACTIONS(2699),
    [anon_sym_LBRACK] = ACTIONS(2697),
    [anon_sym_RBRACK] = ACTIONS(2697),
    [anon_sym_EQ] = ACTIONS(2699),
    [anon_sym_COLON] = ACTIONS(2697),
    [anon_sym_QMARK] = ACTIONS(2697),
    [anon_sym_STAR_EQ] = ACTIONS(2697),
    [anon_sym_SLASH_EQ] = ACTIONS(2697),
    [anon_sym_PERCENT_EQ] = ACTIONS(2697),
    [anon_sym_PLUS_EQ] = ACTIONS(2697),
    [anon_sym_DASH_EQ] = ACTIONS(2697),
    [anon_sym_LT_LT_EQ] = ACTIONS(2697),
    [anon_sym_GT_GT_EQ] = ACTIONS(2697),
    [anon_sym_AMP_EQ] = ACTIONS(2697),
    [anon_sym_CARET_EQ] = ACTIONS(2697),
    [anon_sym_PIPE_EQ] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2697),
    [anon_sym_AMP_AMP] = ACTIONS(2697),
    [anon_sym_PIPE] = ACTIONS(2699),
    [anon_sym_CARET] = ACTIONS(2699),
    [anon_sym_EQ_EQ] = ACTIONS(2697),
    [anon_sym_BANG_EQ] = ACTIONS(2697),
    [anon_sym_LT] = ACTIONS(2699),
    [anon_sym_GT] = ACTIONS(2699),
    [anon_sym_LT_EQ] = ACTIONS(2697),
    [anon_sym_GT_EQ] = ACTIONS(2697),
    [anon_sym_LT_LT] = ACTIONS(2699),
    [anon_sym_GT_GT] = ACTIONS(2699),
    [anon_sym_PLUS] = ACTIONS(2699),
    [anon_sym_DASH] = ACTIONS(2699),
    [anon_sym_SLASH] = ACTIONS(2699),
    [anon_sym_PERCENT] = ACTIONS(2699),
    [anon_sym_DASH_DASH] = ACTIONS(2697),
    [anon_sym_PLUS_PLUS] = ACTIONS(2697),
    [anon_sym_DOT] = ACTIONS(2697),
    [anon_sym_DASH_GT] = ACTIONS(2697),
    [sym_comment] = ACTIONS(91),
  },
  [1594] = {
    [sym_field_declaration_list] = STATE(2296),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [sym_comment] = ACTIONS(91),
  },
  [1595] = {
    [sym_field_declaration_list] = STATE(2296),
    [sym_base_class_clause] = STATE(2297),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [anon_sym_COLON] = ACTIONS(1073),
    [sym_comment] = ACTIONS(91),
  },
  [1596] = {
    [anon_sym_COMMA] = ACTIONS(2703),
    [anon_sym_RPAREN] = ACTIONS(2703),
    [anon_sym_SEMI] = ACTIONS(2703),
    [anon_sym_LBRACE] = ACTIONS(2703),
    [anon_sym_RBRACE] = ACTIONS(2703),
    [anon_sym_LPAREN2] = ACTIONS(2703),
    [anon_sym_STAR] = ACTIONS(2705),
    [anon_sym_LBRACK] = ACTIONS(2703),
    [anon_sym_RBRACK] = ACTIONS(2703),
    [anon_sym_EQ] = ACTIONS(2705),
    [anon_sym_COLON] = ACTIONS(2703),
    [anon_sym_QMARK] = ACTIONS(2703),
    [anon_sym_STAR_EQ] = ACTIONS(2703),
    [anon_sym_SLASH_EQ] = ACTIONS(2703),
    [anon_sym_PERCENT_EQ] = ACTIONS(2703),
    [anon_sym_PLUS_EQ] = ACTIONS(2703),
    [anon_sym_DASH_EQ] = ACTIONS(2703),
    [anon_sym_LT_LT_EQ] = ACTIONS(2703),
    [anon_sym_GT_GT_EQ] = ACTIONS(2703),
    [anon_sym_AMP_EQ] = ACTIONS(2703),
    [anon_sym_CARET_EQ] = ACTIONS(2703),
    [anon_sym_PIPE_EQ] = ACTIONS(2703),
    [anon_sym_AMP] = ACTIONS(2705),
    [anon_sym_PIPE_PIPE] = ACTIONS(2703),
    [anon_sym_AMP_AMP] = ACTIONS(2703),
    [anon_sym_PIPE] = ACTIONS(2705),
    [anon_sym_CARET] = ACTIONS(2705),
    [anon_sym_EQ_EQ] = ACTIONS(2703),
    [anon_sym_BANG_EQ] = ACTIONS(2703),
    [anon_sym_LT] = ACTIONS(2705),
    [anon_sym_GT] = ACTIONS(2705),
    [anon_sym_LT_EQ] = ACTIONS(2703),
    [anon_sym_GT_EQ] = ACTIONS(2703),
    [anon_sym_LT_LT] = ACTIONS(2705),
    [anon_sym_GT_GT] = ACTIONS(2705),
    [anon_sym_PLUS] = ACTIONS(2705),
    [anon_sym_DASH] = ACTIONS(2705),
    [anon_sym_SLASH] = ACTIONS(2705),
    [anon_sym_PERCENT] = ACTIONS(2705),
    [anon_sym_DASH_DASH] = ACTIONS(2703),
    [anon_sym_PLUS_PLUS] = ACTIONS(2703),
    [anon_sym_DOT] = ACTIONS(2703),
    [anon_sym_DASH_GT] = ACTIONS(2703),
    [sym_comment] = ACTIONS(91),
  },
  [1597] = {
    [sym_field_declaration_list] = STATE(2298),
    [sym_base_class_clause] = STATE(2299),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [anon_sym_COLON] = ACTIONS(1073),
    [sym_comment] = ACTIONS(91),
  },
  [1598] = {
    [sym_field_declaration_list] = STATE(2298),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [sym_comment] = ACTIONS(91),
  },
  [1599] = {
    [anon_sym_COMMA] = ACTIONS(2707),
    [anon_sym_RPAREN] = ACTIONS(2707),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LBRACE] = ACTIONS(2707),
    [anon_sym_RBRACE] = ACTIONS(2707),
    [anon_sym_LPAREN2] = ACTIONS(2707),
    [anon_sym_STAR] = ACTIONS(2709),
    [anon_sym_LBRACK] = ACTIONS(2707),
    [anon_sym_RBRACK] = ACTIONS(2707),
    [anon_sym_EQ] = ACTIONS(2709),
    [anon_sym_COLON] = ACTIONS(2707),
    [anon_sym_QMARK] = ACTIONS(2707),
    [anon_sym_STAR_EQ] = ACTIONS(2707),
    [anon_sym_SLASH_EQ] = ACTIONS(2707),
    [anon_sym_PERCENT_EQ] = ACTIONS(2707),
    [anon_sym_PLUS_EQ] = ACTIONS(2707),
    [anon_sym_DASH_EQ] = ACTIONS(2707),
    [anon_sym_LT_LT_EQ] = ACTIONS(2707),
    [anon_sym_GT_GT_EQ] = ACTIONS(2707),
    [anon_sym_AMP_EQ] = ACTIONS(2707),
    [anon_sym_CARET_EQ] = ACTIONS(2707),
    [anon_sym_PIPE_EQ] = ACTIONS(2707),
    [anon_sym_AMP] = ACTIONS(2709),
    [anon_sym_PIPE_PIPE] = ACTIONS(2707),
    [anon_sym_AMP_AMP] = ACTIONS(2707),
    [anon_sym_PIPE] = ACTIONS(2709),
    [anon_sym_CARET] = ACTIONS(2709),
    [anon_sym_EQ_EQ] = ACTIONS(2707),
    [anon_sym_BANG_EQ] = ACTIONS(2707),
    [anon_sym_LT] = ACTIONS(2709),
    [anon_sym_GT] = ACTIONS(2709),
    [anon_sym_LT_EQ] = ACTIONS(2707),
    [anon_sym_GT_EQ] = ACTIONS(2707),
    [anon_sym_LT_LT] = ACTIONS(2709),
    [anon_sym_GT_GT] = ACTIONS(2709),
    [anon_sym_PLUS] = ACTIONS(2709),
    [anon_sym_DASH] = ACTIONS(2709),
    [anon_sym_SLASH] = ACTIONS(2709),
    [anon_sym_PERCENT] = ACTIONS(2709),
    [anon_sym_DASH_DASH] = ACTIONS(2707),
    [anon_sym_PLUS_PLUS] = ACTIONS(2707),
    [anon_sym_DOT] = ACTIONS(2707),
    [anon_sym_DASH_GT] = ACTIONS(2707),
    [sym_comment] = ACTIONS(91),
  },
  [1600] = {
    [sym_field_declaration_list] = STATE(2300),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [sym_comment] = ACTIONS(91),
  },
  [1601] = {
    [sym_field_declaration_list] = STATE(2300),
    [sym_base_class_clause] = STATE(2301),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [anon_sym_COLON] = ACTIONS(1073),
    [sym_comment] = ACTIONS(91),
  },
  [1602] = {
    [anon_sym_COMMA] = ACTIONS(3218),
    [anon_sym_RPAREN] = ACTIONS(3218),
    [anon_sym_SEMI] = ACTIONS(3218),
    [anon_sym_LBRACE] = ACTIONS(3218),
    [anon_sym_RBRACE] = ACTIONS(3218),
    [anon_sym_LPAREN2] = ACTIONS(3218),
    [anon_sym_STAR] = ACTIONS(3216),
    [anon_sym_LBRACK] = ACTIONS(3218),
    [anon_sym_RBRACK] = ACTIONS(3218),
    [anon_sym_EQ] = ACTIONS(3216),
    [anon_sym_COLON] = ACTIONS(3216),
    [anon_sym_QMARK] = ACTIONS(3218),
    [anon_sym_STAR_EQ] = ACTIONS(3218),
    [anon_sym_SLASH_EQ] = ACTIONS(3218),
    [anon_sym_PERCENT_EQ] = ACTIONS(3218),
    [anon_sym_PLUS_EQ] = ACTIONS(3218),
    [anon_sym_DASH_EQ] = ACTIONS(3218),
    [anon_sym_LT_LT_EQ] = ACTIONS(3218),
    [anon_sym_GT_GT_EQ] = ACTIONS(3218),
    [anon_sym_AMP_EQ] = ACTIONS(3218),
    [anon_sym_CARET_EQ] = ACTIONS(3218),
    [anon_sym_PIPE_EQ] = ACTIONS(3218),
    [anon_sym_AMP] = ACTIONS(3216),
    [anon_sym_PIPE_PIPE] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(3218),
    [anon_sym_PIPE] = ACTIONS(3216),
    [anon_sym_CARET] = ACTIONS(3216),
    [anon_sym_EQ_EQ] = ACTIONS(3218),
    [anon_sym_BANG_EQ] = ACTIONS(3218),
    [anon_sym_LT] = ACTIONS(3216),
    [anon_sym_GT] = ACTIONS(3216),
    [anon_sym_LT_EQ] = ACTIONS(3218),
    [anon_sym_GT_EQ] = ACTIONS(3218),
    [anon_sym_LT_LT] = ACTIONS(3216),
    [anon_sym_GT_GT] = ACTIONS(3216),
    [anon_sym_PLUS] = ACTIONS(3216),
    [anon_sym_DASH] = ACTIONS(3216),
    [anon_sym_SLASH] = ACTIONS(3216),
    [anon_sym_PERCENT] = ACTIONS(3216),
    [anon_sym_DASH_DASH] = ACTIONS(3218),
    [anon_sym_PLUS_PLUS] = ACTIONS(3218),
    [anon_sym_DOT] = ACTIONS(3218),
    [anon_sym_DASH_GT] = ACTIONS(3218),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3218),
    [anon_sym_override] = ACTIONS(3218),
    [anon_sym_COLON_COLON] = ACTIONS(3225),
  },
  [1603] = {
    [anon_sym_COMMA] = ACTIONS(3227),
    [anon_sym_RPAREN] = ACTIONS(3227),
    [anon_sym_SEMI] = ACTIONS(3227),
    [anon_sym_LBRACE] = ACTIONS(3227),
    [anon_sym_RBRACE] = ACTIONS(3227),
    [anon_sym_LPAREN2] = ACTIONS(3227),
    [anon_sym_STAR] = ACTIONS(3229),
    [anon_sym_LBRACK] = ACTIONS(3227),
    [anon_sym_RBRACK] = ACTIONS(3227),
    [anon_sym_EQ] = ACTIONS(3229),
    [anon_sym_COLON] = ACTIONS(3227),
    [anon_sym_QMARK] = ACTIONS(3227),
    [anon_sym_STAR_EQ] = ACTIONS(3227),
    [anon_sym_SLASH_EQ] = ACTIONS(3227),
    [anon_sym_PERCENT_EQ] = ACTIONS(3227),
    [anon_sym_PLUS_EQ] = ACTIONS(3227),
    [anon_sym_DASH_EQ] = ACTIONS(3227),
    [anon_sym_LT_LT_EQ] = ACTIONS(3227),
    [anon_sym_GT_GT_EQ] = ACTIONS(3227),
    [anon_sym_AMP_EQ] = ACTIONS(3227),
    [anon_sym_CARET_EQ] = ACTIONS(3227),
    [anon_sym_PIPE_EQ] = ACTIONS(3227),
    [anon_sym_AMP] = ACTIONS(3229),
    [anon_sym_PIPE_PIPE] = ACTIONS(3227),
    [anon_sym_AMP_AMP] = ACTIONS(3227),
    [anon_sym_PIPE] = ACTIONS(3229),
    [anon_sym_CARET] = ACTIONS(3229),
    [anon_sym_EQ_EQ] = ACTIONS(3227),
    [anon_sym_BANG_EQ] = ACTIONS(3227),
    [anon_sym_LT] = ACTIONS(3229),
    [anon_sym_GT] = ACTIONS(3229),
    [anon_sym_LT_EQ] = ACTIONS(3227),
    [anon_sym_GT_EQ] = ACTIONS(3227),
    [anon_sym_LT_LT] = ACTIONS(3229),
    [anon_sym_GT_GT] = ACTIONS(3229),
    [anon_sym_PLUS] = ACTIONS(3229),
    [anon_sym_DASH] = ACTIONS(3229),
    [anon_sym_SLASH] = ACTIONS(3229),
    [anon_sym_PERCENT] = ACTIONS(3229),
    [anon_sym_DASH_DASH] = ACTIONS(3227),
    [anon_sym_PLUS_PLUS] = ACTIONS(3227),
    [anon_sym_DOT] = ACTIONS(3227),
    [anon_sym_DASH_GT] = ACTIONS(3227),
    [sym_comment] = ACTIONS(91),
  },
  [1604] = {
    [sym_field_declaration_list] = STATE(2302),
    [sym_base_class_clause] = STATE(2303),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [anon_sym_COLON] = ACTIONS(1073),
    [sym_comment] = ACTIONS(91),
  },
  [1605] = {
    [sym_field_declaration_list] = STATE(2302),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [sym_comment] = ACTIONS(91),
  },
  [1606] = {
    [anon_sym_COMMA] = ACTIONS(3231),
    [anon_sym_RPAREN] = ACTIONS(3231),
    [anon_sym_SEMI] = ACTIONS(3231),
    [anon_sym_LBRACE] = ACTIONS(3231),
    [anon_sym_RBRACE] = ACTIONS(3231),
    [anon_sym_LPAREN2] = ACTIONS(3231),
    [anon_sym_STAR] = ACTIONS(3233),
    [anon_sym_LBRACK] = ACTIONS(3231),
    [anon_sym_RBRACK] = ACTIONS(3231),
    [anon_sym_EQ] = ACTIONS(3233),
    [anon_sym_COLON] = ACTIONS(3231),
    [anon_sym_QMARK] = ACTIONS(3231),
    [anon_sym_STAR_EQ] = ACTIONS(3231),
    [anon_sym_SLASH_EQ] = ACTIONS(3231),
    [anon_sym_PERCENT_EQ] = ACTIONS(3231),
    [anon_sym_PLUS_EQ] = ACTIONS(3231),
    [anon_sym_DASH_EQ] = ACTIONS(3231),
    [anon_sym_LT_LT_EQ] = ACTIONS(3231),
    [anon_sym_GT_GT_EQ] = ACTIONS(3231),
    [anon_sym_AMP_EQ] = ACTIONS(3231),
    [anon_sym_CARET_EQ] = ACTIONS(3231),
    [anon_sym_PIPE_EQ] = ACTIONS(3231),
    [anon_sym_AMP] = ACTIONS(3233),
    [anon_sym_PIPE_PIPE] = ACTIONS(3231),
    [anon_sym_AMP_AMP] = ACTIONS(3231),
    [anon_sym_PIPE] = ACTIONS(3233),
    [anon_sym_CARET] = ACTIONS(3233),
    [anon_sym_EQ_EQ] = ACTIONS(3231),
    [anon_sym_BANG_EQ] = ACTIONS(3231),
    [anon_sym_LT] = ACTIONS(3233),
    [anon_sym_GT] = ACTIONS(3233),
    [anon_sym_LT_EQ] = ACTIONS(3231),
    [anon_sym_GT_EQ] = ACTIONS(3231),
    [anon_sym_LT_LT] = ACTIONS(3233),
    [anon_sym_GT_GT] = ACTIONS(3233),
    [anon_sym_PLUS] = ACTIONS(3233),
    [anon_sym_DASH] = ACTIONS(3233),
    [anon_sym_SLASH] = ACTIONS(3233),
    [anon_sym_PERCENT] = ACTIONS(3233),
    [anon_sym_DASH_DASH] = ACTIONS(3231),
    [anon_sym_PLUS_PLUS] = ACTIONS(3231),
    [anon_sym_DOT] = ACTIONS(3231),
    [anon_sym_DASH_GT] = ACTIONS(3231),
    [sym_comment] = ACTIONS(91),
  },
  [1607] = {
    [sym_field_declaration_list] = STATE(2304),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [sym_comment] = ACTIONS(91),
  },
  [1608] = {
    [sym_field_declaration_list] = STATE(2304),
    [sym_base_class_clause] = STATE(2305),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [anon_sym_COLON] = ACTIONS(1073),
    [sym_comment] = ACTIONS(91),
  },
  [1609] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(5016),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_STAR_EQ] = ACTIONS(3507),
    [anon_sym_SLASH_EQ] = ACTIONS(3507),
    [anon_sym_PERCENT_EQ] = ACTIONS(3507),
    [anon_sym_PLUS_EQ] = ACTIONS(3507),
    [anon_sym_DASH_EQ] = ACTIONS(3507),
    [anon_sym_LT_LT_EQ] = ACTIONS(3507),
    [anon_sym_GT_GT_EQ] = ACTIONS(3507),
    [anon_sym_AMP_EQ] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(3507),
    [anon_sym_PIPE_EQ] = ACTIONS(3507),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_CARET] = ACTIONS(3517),
    [anon_sym_EQ_EQ] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3521),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3525),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1610] = {
    [anon_sym_COMMA] = ACTIONS(5018),
    [anon_sym_RPAREN] = ACTIONS(5018),
    [anon_sym_SEMI] = ACTIONS(5018),
    [anon_sym_RBRACE] = ACTIONS(5018),
    [anon_sym_LPAREN2] = ACTIONS(5018),
    [anon_sym_STAR] = ACTIONS(5020),
    [anon_sym_LBRACK] = ACTIONS(5018),
    [anon_sym_RBRACK] = ACTIONS(5018),
    [anon_sym_EQ] = ACTIONS(5020),
    [anon_sym_COLON] = ACTIONS(5018),
    [anon_sym_QMARK] = ACTIONS(5018),
    [anon_sym_STAR_EQ] = ACTIONS(5018),
    [anon_sym_SLASH_EQ] = ACTIONS(5018),
    [anon_sym_PERCENT_EQ] = ACTIONS(5018),
    [anon_sym_PLUS_EQ] = ACTIONS(5018),
    [anon_sym_DASH_EQ] = ACTIONS(5018),
    [anon_sym_LT_LT_EQ] = ACTIONS(5018),
    [anon_sym_GT_GT_EQ] = ACTIONS(5018),
    [anon_sym_AMP_EQ] = ACTIONS(5018),
    [anon_sym_CARET_EQ] = ACTIONS(5018),
    [anon_sym_PIPE_EQ] = ACTIONS(5018),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_PIPE_PIPE] = ACTIONS(5018),
    [anon_sym_AMP_AMP] = ACTIONS(5018),
    [anon_sym_PIPE] = ACTIONS(5020),
    [anon_sym_CARET] = ACTIONS(5020),
    [anon_sym_EQ_EQ] = ACTIONS(5018),
    [anon_sym_BANG_EQ] = ACTIONS(5018),
    [anon_sym_LT] = ACTIONS(5020),
    [anon_sym_GT] = ACTIONS(5020),
    [anon_sym_LT_EQ] = ACTIONS(5018),
    [anon_sym_GT_EQ] = ACTIONS(5018),
    [anon_sym_LT_LT] = ACTIONS(5020),
    [anon_sym_GT_GT] = ACTIONS(5020),
    [anon_sym_PLUS] = ACTIONS(5020),
    [anon_sym_DASH] = ACTIONS(5020),
    [anon_sym_SLASH] = ACTIONS(5020),
    [anon_sym_PERCENT] = ACTIONS(5020),
    [anon_sym_DASH_DASH] = ACTIONS(5018),
    [anon_sym_PLUS_PLUS] = ACTIONS(5018),
    [anon_sym_DOT] = ACTIONS(5018),
    [anon_sym_DASH_GT] = ACTIONS(5018),
    [sym_comment] = ACTIONS(91),
  },
  [1611] = {
    [sym_argument_list] = STATE(2307),
    [sym_initializer_list] = STATE(2307),
    [anon_sym_COMMA] = ACTIONS(5018),
    [anon_sym_RPAREN] = ACTIONS(5018),
    [anon_sym_SEMI] = ACTIONS(5018),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_RBRACE] = ACTIONS(5018),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(5020),
    [anon_sym_LBRACK] = ACTIONS(5018),
    [anon_sym_RBRACK] = ACTIONS(5018),
    [anon_sym_EQ] = ACTIONS(5020),
    [anon_sym_QMARK] = ACTIONS(5018),
    [anon_sym_STAR_EQ] = ACTIONS(5018),
    [anon_sym_SLASH_EQ] = ACTIONS(5018),
    [anon_sym_PERCENT_EQ] = ACTIONS(5018),
    [anon_sym_PLUS_EQ] = ACTIONS(5018),
    [anon_sym_DASH_EQ] = ACTIONS(5018),
    [anon_sym_LT_LT_EQ] = ACTIONS(5018),
    [anon_sym_GT_GT_EQ] = ACTIONS(5018),
    [anon_sym_AMP_EQ] = ACTIONS(5018),
    [anon_sym_CARET_EQ] = ACTIONS(5018),
    [anon_sym_PIPE_EQ] = ACTIONS(5018),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_PIPE_PIPE] = ACTIONS(5018),
    [anon_sym_AMP_AMP] = ACTIONS(5018),
    [anon_sym_PIPE] = ACTIONS(5020),
    [anon_sym_CARET] = ACTIONS(5020),
    [anon_sym_EQ_EQ] = ACTIONS(5018),
    [anon_sym_BANG_EQ] = ACTIONS(5018),
    [anon_sym_LT] = ACTIONS(5020),
    [anon_sym_GT] = ACTIONS(5020),
    [anon_sym_LT_EQ] = ACTIONS(5018),
    [anon_sym_GT_EQ] = ACTIONS(5018),
    [anon_sym_LT_LT] = ACTIONS(5020),
    [anon_sym_GT_GT] = ACTIONS(5020),
    [anon_sym_PLUS] = ACTIONS(5020),
    [anon_sym_DASH] = ACTIONS(5020),
    [anon_sym_SLASH] = ACTIONS(5020),
    [anon_sym_PERCENT] = ACTIONS(5020),
    [anon_sym_DASH_DASH] = ACTIONS(5018),
    [anon_sym_PLUS_PLUS] = ACTIONS(5018),
    [anon_sym_DOT] = ACTIONS(5018),
    [anon_sym_DASH_GT] = ACTIONS(5018),
    [sym_comment] = ACTIONS(91),
  },
  [1612] = {
    [anon_sym_COMMA] = ACTIONS(3636),
    [anon_sym_RPAREN] = ACTIONS(3636),
    [anon_sym_SEMI] = ACTIONS(3636),
    [anon_sym_LBRACE] = ACTIONS(3636),
    [anon_sym_RBRACE] = ACTIONS(3636),
    [anon_sym_LPAREN2] = ACTIONS(3636),
    [anon_sym_STAR] = ACTIONS(3634),
    [anon_sym_LBRACK] = ACTIONS(3636),
    [anon_sym_RBRACK] = ACTIONS(3636),
    [anon_sym_EQ] = ACTIONS(3634),
    [anon_sym_COLON] = ACTIONS(3634),
    [anon_sym_QMARK] = ACTIONS(3636),
    [anon_sym_STAR_EQ] = ACTIONS(3636),
    [anon_sym_SLASH_EQ] = ACTIONS(3636),
    [anon_sym_PERCENT_EQ] = ACTIONS(3636),
    [anon_sym_PLUS_EQ] = ACTIONS(3636),
    [anon_sym_DASH_EQ] = ACTIONS(3636),
    [anon_sym_LT_LT_EQ] = ACTIONS(3636),
    [anon_sym_GT_GT_EQ] = ACTIONS(3636),
    [anon_sym_AMP_EQ] = ACTIONS(3636),
    [anon_sym_CARET_EQ] = ACTIONS(3636),
    [anon_sym_PIPE_EQ] = ACTIONS(3636),
    [anon_sym_AMP] = ACTIONS(3634),
    [anon_sym_PIPE_PIPE] = ACTIONS(3636),
    [anon_sym_AMP_AMP] = ACTIONS(3636),
    [anon_sym_PIPE] = ACTIONS(3634),
    [anon_sym_CARET] = ACTIONS(3634),
    [anon_sym_EQ_EQ] = ACTIONS(3636),
    [anon_sym_BANG_EQ] = ACTIONS(3636),
    [anon_sym_LT] = ACTIONS(3634),
    [anon_sym_GT] = ACTIONS(3634),
    [anon_sym_LT_EQ] = ACTIONS(3636),
    [anon_sym_GT_EQ] = ACTIONS(3636),
    [anon_sym_LT_LT] = ACTIONS(3634),
    [anon_sym_GT_GT] = ACTIONS(3634),
    [anon_sym_PLUS] = ACTIONS(3634),
    [anon_sym_DASH] = ACTIONS(3634),
    [anon_sym_SLASH] = ACTIONS(3634),
    [anon_sym_PERCENT] = ACTIONS(3634),
    [anon_sym_DASH_DASH] = ACTIONS(3636),
    [anon_sym_PLUS_PLUS] = ACTIONS(3636),
    [anon_sym_DOT] = ACTIONS(3636),
    [anon_sym_DASH_GT] = ACTIONS(3636),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3636),
    [anon_sym_override] = ACTIONS(3636),
    [anon_sym_COLON_COLON] = ACTIONS(3643),
  },
  [1613] = {
    [sym__expression] = STATE(2308),
    [sym_conditional_expression] = STATE(2308),
    [sym_assignment_expression] = STATE(2308),
    [sym_pointer_expression] = STATE(2308),
    [sym_logical_expression] = STATE(2308),
    [sym_bitwise_expression] = STATE(2308),
    [sym_equality_expression] = STATE(2308),
    [sym_relational_expression] = STATE(2308),
    [sym_shift_expression] = STATE(2308),
    [sym_math_expression] = STATE(2308),
    [sym_cast_expression] = STATE(2308),
    [sym_sizeof_expression] = STATE(2308),
    [sym_subscript_expression] = STATE(2308),
    [sym_call_expression] = STATE(2308),
    [sym_field_expression] = STATE(2308),
    [sym_compound_literal_expression] = STATE(2308),
    [sym_parenthesized_expression] = STATE(2308),
    [sym_char_literal] = STATE(2308),
    [sym_concatenated_string] = STATE(2308),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2308),
    [sym_new_expression] = STATE(2308),
    [sym_delete_expression] = STATE(2308),
    [sym_lambda_expression] = STATE(2308),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5022),
    [anon_sym_LPAREN2] = ACTIONS(947),
    [anon_sym_STAR] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(947),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5022),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(5024),
    [sym_false] = ACTIONS(5024),
    [sym_null] = ACTIONS(5024),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(5024),
  },
  [1614] = {
    [sym_parameter_list] = STATE(897),
    [anon_sym_COMMA] = ACTIONS(4126),
    [anon_sym_SEMI] = ACTIONS(4126),
    [anon_sym_LBRACE] = ACTIONS(4126),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(574),
    [anon_sym_EQ] = ACTIONS(4126),
    [sym_comment] = ACTIONS(91),
  },
  [1615] = {
    [sym_identifier] = ACTIONS(5026),
    [sym_comment] = ACTIONS(91),
  },
  [1616] = {
    [anon_sym_LBRACE] = ACTIONS(5028),
    [anon_sym_LPAREN2] = ACTIONS(5028),
    [anon_sym_EQ] = ACTIONS(5028),
    [sym_comment] = ACTIONS(91),
  },
  [1617] = {
    [aux_sym_structured_binding_declarator_repeat1] = STATE(2311),
    [anon_sym_COMMA] = ACTIONS(3389),
    [anon_sym_RBRACK] = ACTIONS(5030),
    [sym_comment] = ACTIONS(91),
  },
  [1618] = {
    [sym_parameter_list] = STATE(897),
    [sym_argument_list] = STATE(898),
    [sym_initializer_list] = STATE(898),
    [anon_sym_COMMA] = ACTIONS(5032),
    [anon_sym_SEMI] = ACTIONS(5032),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(1619),
    [anon_sym_LBRACK] = ACTIONS(574),
    [anon_sym_EQ] = ACTIONS(1621),
    [sym_comment] = ACTIONS(91),
  },
  [1619] = {
    [anon_sym_COMMA] = ACTIONS(5032),
    [anon_sym_SEMI] = ACTIONS(5032),
    [sym_comment] = ACTIONS(91),
  },
  [1620] = {
    [sym_preproc_include] = STATE(469),
    [sym_preproc_def] = STATE(469),
    [sym_preproc_function_def] = STATE(469),
    [sym_preproc_call] = STATE(469),
    [sym_preproc_if_in_compound_statement] = STATE(469),
    [sym_preproc_ifdef_in_compound_statement] = STATE(469),
    [sym_declaration] = STATE(469),
    [sym_type_definition] = STATE(469),
    [sym__declaration_specifiers] = STATE(113),
    [sym_compound_statement] = STATE(469),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(469),
    [sym_expression_statement] = STATE(469),
    [sym_if_statement] = STATE(469),
    [sym_switch_statement] = STATE(469),
    [sym_case_statement] = STATE(469),
    [sym_while_statement] = STATE(469),
    [sym_do_statement] = STATE(469),
    [sym_for_statement] = STATE(469),
    [sym_return_statement] = STATE(469),
    [sym_break_statement] = STATE(469),
    [sym_continue_statement] = STATE(469),
    [sym_goto_statement] = STATE(469),
    [sym__expression] = STATE(1631),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(1631),
    [sym_assignment_expression] = STATE(1631),
    [sym_pointer_expression] = STATE(1631),
    [sym_logical_expression] = STATE(1631),
    [sym_bitwise_expression] = STATE(1631),
    [sym_equality_expression] = STATE(1631),
    [sym_relational_expression] = STATE(1631),
    [sym_shift_expression] = STATE(1631),
    [sym_math_expression] = STATE(1631),
    [sym_cast_expression] = STATE(1631),
    [sym_sizeof_expression] = STATE(1631),
    [sym_subscript_expression] = STATE(1631),
    [sym_call_expression] = STATE(1631),
    [sym_field_expression] = STATE(1631),
    [sym_compound_literal_expression] = STATE(1631),
    [sym_parenthesized_expression] = STATE(1631),
    [sym_initializer_list] = STATE(726),
    [sym_initializer_pair] = STATE(726),
    [sym_subscript_designator] = STATE(728),
    [sym_field_designator] = STATE(728),
    [sym_char_literal] = STATE(1631),
    [sym_concatenated_string] = STATE(1631),
    [sym_string_literal] = STATE(1632),
    [sym__empty_declaration] = STATE(469),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(469),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(1631),
    [sym_for_range_loop] = STATE(469),
    [sym_try_statement] = STATE(469),
    [sym_new_expression] = STATE(1631),
    [sym_delete_expression] = STATE(1631),
    [sym_lambda_expression] = STATE(1631),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(469),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [aux_sym_initializer_pair_repeat1] = STATE(728),
    [sym_raw_string_literal] = ACTIONS(3401),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(159),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(161),
    [anon_sym_COMMA] = ACTIONS(1252),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(163),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(165),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(165),
    [sym_preproc_directive] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_typedef] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(3403),
    [anon_sym_RBRACE] = ACTIONS(5034),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_LBRACK] = ACTIONS(1260),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(185),
    [anon_sym_case] = ACTIONS(187),
    [anon_sym_default] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3411),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_sizeof] = ACTIONS(3419),
    [anon_sym_DOT] = ACTIONS(1272),
    [sym_number_literal] = ACTIONS(3401),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(3421),
    [sym_false] = ACTIONS(3421),
    [sym_null] = ACTIONS(3421),
    [sym_identifier] = ACTIONS(209),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(3423),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_COLON_COLON] = ACTIONS(3427),
    [sym_nullptr] = ACTIONS(3421),
  },
  [1621] = {
    [sym_raw_string_literal] = ACTIONS(801),
    [ts_builtin_sym_end] = ACTIONS(801),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(803),
    [anon_sym_COMMA] = ACTIONS(2919),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(803),
    [sym_preproc_directive] = ACTIONS(803),
    [anon_sym_SEMI] = ACTIONS(2919),
    [anon_sym_typedef] = ACTIONS(803),
    [anon_sym_extern] = ACTIONS(803),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(801),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(801),
    [anon_sym_LBRACK] = ACTIONS(801),
    [anon_sym_static] = ACTIONS(803),
    [anon_sym_register] = ACTIONS(803),
    [anon_sym_inline] = ACTIONS(803),
    [anon_sym_const] = ACTIONS(803),
    [anon_sym_restrict] = ACTIONS(803),
    [anon_sym_volatile] = ACTIONS(803),
    [anon_sym__Atomic] = ACTIONS(803),
    [anon_sym_mutable] = ACTIONS(803),
    [anon_sym_explicit] = ACTIONS(803),
    [anon_sym_constexpr] = ACTIONS(803),
    [anon_sym_unsigned] = ACTIONS(803),
    [anon_sym_long] = ACTIONS(803),
    [anon_sym_short] = ACTIONS(803),
    [sym_primitive_type] = ACTIONS(803),
    [anon_sym_enum] = ACTIONS(803),
    [anon_sym_struct] = ACTIONS(803),
    [anon_sym_union] = ACTIONS(803),
    [anon_sym_if] = ACTIONS(803),
    [anon_sym_switch] = ACTIONS(803),
    [anon_sym_case] = ACTIONS(803),
    [anon_sym_default] = ACTIONS(803),
    [anon_sym_while] = ACTIONS(803),
    [anon_sym_do] = ACTIONS(803),
    [anon_sym_for] = ACTIONS(803),
    [anon_sym_return] = ACTIONS(803),
    [anon_sym_break] = ACTIONS(803),
    [anon_sym_continue] = ACTIONS(803),
    [anon_sym_goto] = ACTIONS(803),
    [anon_sym_AMP] = ACTIONS(803),
    [anon_sym_AMP_AMP] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_DASH] = ACTIONS(803),
    [anon_sym_DASH_DASH] = ACTIONS(801),
    [anon_sym_PLUS_PLUS] = ACTIONS(801),
    [anon_sym_sizeof] = ACTIONS(803),
    [sym_number_literal] = ACTIONS(801),
    [anon_sym_SQUOTE] = ACTIONS(801),
    [anon_sym_DQUOTE] = ACTIONS(801),
    [sym_true] = ACTIONS(803),
    [sym_false] = ACTIONS(803),
    [sym_null] = ACTIONS(803),
    [sym_identifier] = ACTIONS(803),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(803),
    [sym_auto] = ACTIONS(803),
    [anon_sym_typename] = ACTIONS(803),
    [anon_sym_template] = ACTIONS(803),
    [anon_sym_delete] = ACTIONS(803),
    [anon_sym_namespace] = ACTIONS(803),
    [anon_sym_using] = ACTIONS(803),
    [anon_sym_try] = ACTIONS(803),
    [anon_sym_new] = ACTIONS(803),
    [anon_sym_COLON_COLON] = ACTIONS(801),
    [sym_operator_name] = ACTIONS(801),
    [sym_nullptr] = ACTIONS(803),
  },
  [1622] = {
    [sym_type_qualifier] = STATE(141),
    [sym__type_specifier] = STATE(136),
    [sym_sized_type_specifier] = STATE(136),
    [sym_enum_specifier] = STATE(136),
    [sym_struct_specifier] = STATE(136),
    [sym_union_specifier] = STATE(136),
    [sym__expression] = STATE(137),
    [sym_comma_expression] = STATE(138),
    [sym_conditional_expression] = STATE(137),
    [sym_assignment_expression] = STATE(137),
    [sym_pointer_expression] = STATE(137),
    [sym_logical_expression] = STATE(137),
    [sym_bitwise_expression] = STATE(137),
    [sym_equality_expression] = STATE(137),
    [sym_relational_expression] = STATE(137),
    [sym_shift_expression] = STATE(137),
    [sym_math_expression] = STATE(137),
    [sym_cast_expression] = STATE(137),
    [sym_type_descriptor] = STATE(2313),
    [sym_sizeof_expression] = STATE(137),
    [sym_subscript_expression] = STATE(137),
    [sym_call_expression] = STATE(137),
    [sym_field_expression] = STATE(137),
    [sym_compound_literal_expression] = STATE(137),
    [sym_parenthesized_expression] = STATE(137),
    [sym_char_literal] = STATE(137),
    [sym_concatenated_string] = STATE(137),
    [sym_string_literal] = STATE(140),
    [sym_macro_type_specifier] = STATE(136),
    [sym_class_specifier] = STATE(136),
    [sym_dependent_type] = STATE(136),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(137),
    [sym_new_expression] = STATE(137),
    [sym_delete_expression] = STATE(137),
    [sym_lambda_expression] = STATE(137),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_type_definition_repeat1] = STATE(141),
    [aux_sym_sized_type_specifier_repeat1] = STATE(142),
    [sym_raw_string_literal] = ACTIONS(213),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(219),
    [anon_sym_long] = ACTIONS(219),
    [anon_sym_short] = ACTIONS(219),
    [sym_primitive_type] = ACTIONS(221),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [sym_null] = ACTIONS(241),
    [sym_identifier] = ACTIONS(811),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(221),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(253),
    [sym_nullptr] = ACTIONS(241),
  },
  [1623] = {
    [sym__expression] = STATE(146),
    [sym_conditional_expression] = STATE(146),
    [sym_assignment_expression] = STATE(146),
    [sym_pointer_expression] = STATE(146),
    [sym_logical_expression] = STATE(146),
    [sym_bitwise_expression] = STATE(146),
    [sym_equality_expression] = STATE(146),
    [sym_relational_expression] = STATE(146),
    [sym_shift_expression] = STATE(146),
    [sym_math_expression] = STATE(146),
    [sym_cast_expression] = STATE(146),
    [sym_sizeof_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_compound_literal_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_char_literal] = STATE(146),
    [sym_concatenated_string] = STATE(146),
    [sym_string_literal] = STATE(1632),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(146),
    [sym_new_expression] = STATE(146),
    [sym_delete_expression] = STATE(146),
    [sym_lambda_expression] = STATE(146),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(257),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3411),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_sizeof] = ACTIONS(3419),
    [sym_number_literal] = ACTIONS(257),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(259),
    [sym_false] = ACTIONS(259),
    [sym_null] = ACTIONS(259),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_COLON_COLON] = ACTIONS(5036),
    [sym_nullptr] = ACTIONS(259),
  },
  [1624] = {
    [sym__expression] = STATE(250),
    [sym_conditional_expression] = STATE(250),
    [sym_assignment_expression] = STATE(250),
    [sym_pointer_expression] = STATE(250),
    [sym_logical_expression] = STATE(250),
    [sym_bitwise_expression] = STATE(250),
    [sym_equality_expression] = STATE(250),
    [sym_relational_expression] = STATE(250),
    [sym_shift_expression] = STATE(250),
    [sym_math_expression] = STATE(250),
    [sym_cast_expression] = STATE(250),
    [sym_sizeof_expression] = STATE(250),
    [sym_subscript_expression] = STATE(250),
    [sym_call_expression] = STATE(250),
    [sym_field_expression] = STATE(250),
    [sym_compound_literal_expression] = STATE(250),
    [sym_parenthesized_expression] = STATE(250),
    [sym_char_literal] = STATE(250),
    [sym_concatenated_string] = STATE(250),
    [sym_string_literal] = STATE(1632),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(250),
    [sym_new_expression] = STATE(250),
    [sym_delete_expression] = STATE(250),
    [sym_lambda_expression] = STATE(250),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(435),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3411),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_sizeof] = ACTIONS(3419),
    [sym_number_literal] = ACTIONS(435),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(437),
    [sym_false] = ACTIONS(437),
    [sym_null] = ACTIONS(437),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_COLON_COLON] = ACTIONS(5036),
    [sym_nullptr] = ACTIONS(437),
  },
  [1625] = {
    [sym__expression] = STATE(252),
    [sym_conditional_expression] = STATE(252),
    [sym_assignment_expression] = STATE(252),
    [sym_pointer_expression] = STATE(252),
    [sym_logical_expression] = STATE(252),
    [sym_bitwise_expression] = STATE(252),
    [sym_equality_expression] = STATE(252),
    [sym_relational_expression] = STATE(252),
    [sym_shift_expression] = STATE(252),
    [sym_math_expression] = STATE(252),
    [sym_cast_expression] = STATE(252),
    [sym_sizeof_expression] = STATE(252),
    [sym_subscript_expression] = STATE(252),
    [sym_call_expression] = STATE(252),
    [sym_field_expression] = STATE(252),
    [sym_compound_literal_expression] = STATE(252),
    [sym_parenthesized_expression] = STATE(252),
    [sym_char_literal] = STATE(252),
    [sym_concatenated_string] = STATE(252),
    [sym_string_literal] = STATE(1632),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(252),
    [sym_new_expression] = STATE(252),
    [sym_delete_expression] = STATE(252),
    [sym_lambda_expression] = STATE(252),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(439),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3411),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_sizeof] = ACTIONS(3419),
    [sym_number_literal] = ACTIONS(439),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(441),
    [sym_false] = ACTIONS(441),
    [sym_null] = ACTIONS(441),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_COLON_COLON] = ACTIONS(5036),
    [sym_nullptr] = ACTIONS(441),
  },
  [1626] = {
    [sym__expression] = STATE(253),
    [sym_conditional_expression] = STATE(253),
    [sym_assignment_expression] = STATE(253),
    [sym_pointer_expression] = STATE(253),
    [sym_logical_expression] = STATE(253),
    [sym_bitwise_expression] = STATE(253),
    [sym_equality_expression] = STATE(253),
    [sym_relational_expression] = STATE(253),
    [sym_shift_expression] = STATE(253),
    [sym_math_expression] = STATE(253),
    [sym_cast_expression] = STATE(253),
    [sym_sizeof_expression] = STATE(253),
    [sym_subscript_expression] = STATE(253),
    [sym_call_expression] = STATE(253),
    [sym_field_expression] = STATE(253),
    [sym_compound_literal_expression] = STATE(253),
    [sym_parenthesized_expression] = STATE(253),
    [sym_char_literal] = STATE(253),
    [sym_concatenated_string] = STATE(253),
    [sym_string_literal] = STATE(1632),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(253),
    [sym_new_expression] = STATE(253),
    [sym_delete_expression] = STATE(253),
    [sym_lambda_expression] = STATE(253),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(445),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3411),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_sizeof] = ACTIONS(3419),
    [sym_number_literal] = ACTIONS(445),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(447),
    [sym_false] = ACTIONS(447),
    [sym_null] = ACTIONS(447),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_COLON_COLON] = ACTIONS(5036),
    [sym_nullptr] = ACTIONS(447),
  },
  [1627] = {
    [sym__expression] = STATE(2316),
    [sym_conditional_expression] = STATE(2316),
    [sym_assignment_expression] = STATE(2316),
    [sym_pointer_expression] = STATE(2316),
    [sym_logical_expression] = STATE(2316),
    [sym_bitwise_expression] = STATE(2316),
    [sym_equality_expression] = STATE(2316),
    [sym_relational_expression] = STATE(2316),
    [sym_shift_expression] = STATE(2316),
    [sym_math_expression] = STATE(2316),
    [sym_cast_expression] = STATE(2316),
    [sym_sizeof_expression] = STATE(2316),
    [sym_subscript_expression] = STATE(2316),
    [sym_call_expression] = STATE(2316),
    [sym_field_expression] = STATE(2316),
    [sym_compound_literal_expression] = STATE(2316),
    [sym_parenthesized_expression] = STATE(2316),
    [sym_char_literal] = STATE(2316),
    [sym_concatenated_string] = STATE(2316),
    [sym_string_literal] = STATE(1632),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2316),
    [sym_new_expression] = STATE(2316),
    [sym_delete_expression] = STATE(2316),
    [sym_lambda_expression] = STATE(2316),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5038),
    [anon_sym_LPAREN2] = ACTIONS(5040),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3411),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_sizeof] = ACTIONS(3419),
    [sym_number_literal] = ACTIONS(5038),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(5042),
    [sym_false] = ACTIONS(5042),
    [sym_null] = ACTIONS(5042),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_COLON_COLON] = ACTIONS(5036),
    [sym_nullptr] = ACTIONS(5042),
  },
  [1628] = {
    [sym__expression] = STATE(2318),
    [sym_conditional_expression] = STATE(2318),
    [sym_assignment_expression] = STATE(2318),
    [sym_pointer_expression] = STATE(2318),
    [sym_logical_expression] = STATE(2318),
    [sym_bitwise_expression] = STATE(2318),
    [sym_equality_expression] = STATE(2318),
    [sym_relational_expression] = STATE(2318),
    [sym_shift_expression] = STATE(2318),
    [sym_math_expression] = STATE(2318),
    [sym_cast_expression] = STATE(2318),
    [sym_sizeof_expression] = STATE(2318),
    [sym_subscript_expression] = STATE(2318),
    [sym_call_expression] = STATE(2318),
    [sym_field_expression] = STATE(2318),
    [sym_compound_literal_expression] = STATE(2318),
    [sym_parenthesized_expression] = STATE(2318),
    [sym_char_literal] = STATE(2318),
    [sym_concatenated_string] = STATE(2318),
    [sym_string_literal] = STATE(1632),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2318),
    [sym_new_expression] = STATE(2318),
    [sym_delete_expression] = STATE(2318),
    [sym_lambda_expression] = STATE(2318),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5044),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_LBRACK] = ACTIONS(5046),
    [anon_sym_AMP] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3411),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_sizeof] = ACTIONS(3419),
    [sym_number_literal] = ACTIONS(5044),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(5048),
    [sym_false] = ACTIONS(5048),
    [sym_null] = ACTIONS(5048),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_COLON_COLON] = ACTIONS(5036),
    [sym_nullptr] = ACTIONS(5048),
  },
  [1629] = {
    [sym__type_specifier] = STATE(2320),
    [sym_sized_type_specifier] = STATE(2320),
    [sym_enum_specifier] = STATE(2320),
    [sym_struct_specifier] = STATE(2320),
    [sym_union_specifier] = STATE(2320),
    [sym_argument_list] = STATE(2321),
    [sym_macro_type_specifier] = STATE(2320),
    [sym_class_specifier] = STATE(2320),
    [sym_dependent_type] = STATE(2320),
    [sym_template_type] = STATE(309),
    [sym_scoped_type_identifier] = STATE(310),
    [sym_scoped_namespace_identifier] = STATE(311),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2322),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_unsigned] = ACTIONS(5050),
    [anon_sym_long] = ACTIONS(5050),
    [anon_sym_short] = ACTIONS(5050),
    [sym_primitive_type] = ACTIONS(5052),
    [anon_sym_enum] = ACTIONS(536),
    [anon_sym_struct] = ACTIONS(538),
    [anon_sym_union] = ACTIONS(540),
    [sym_identifier] = ACTIONS(542),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(544),
    [sym_auto] = ACTIONS(5052),
    [anon_sym_typename] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [1630] = {
    [sym_destructor_name] = STATE(315),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(550),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(5056),
    [sym_operator_name] = ACTIONS(554),
  },
  [1631] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_initializer_list_repeat1] = STATE(1420),
    [anon_sym_COMMA] = ACTIONS(5058),
    [anon_sym_SEMI] = ACTIONS(843),
    [anon_sym_RBRACE] = ACTIONS(2917),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(5060),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(5062),
    [anon_sym_QMARK] = ACTIONS(5064),
    [anon_sym_STAR_EQ] = ACTIONS(5066),
    [anon_sym_SLASH_EQ] = ACTIONS(5066),
    [anon_sym_PERCENT_EQ] = ACTIONS(5066),
    [anon_sym_PLUS_EQ] = ACTIONS(5066),
    [anon_sym_DASH_EQ] = ACTIONS(5066),
    [anon_sym_LT_LT_EQ] = ACTIONS(5066),
    [anon_sym_GT_GT_EQ] = ACTIONS(5066),
    [anon_sym_AMP_EQ] = ACTIONS(5066),
    [anon_sym_CARET_EQ] = ACTIONS(5066),
    [anon_sym_PIPE_EQ] = ACTIONS(5066),
    [anon_sym_AMP] = ACTIONS(5068),
    [anon_sym_PIPE_PIPE] = ACTIONS(5070),
    [anon_sym_AMP_AMP] = ACTIONS(5072),
    [anon_sym_PIPE] = ACTIONS(5074),
    [anon_sym_CARET] = ACTIONS(5076),
    [anon_sym_EQ_EQ] = ACTIONS(5078),
    [anon_sym_BANG_EQ] = ACTIONS(5078),
    [anon_sym_LT] = ACTIONS(5080),
    [anon_sym_GT] = ACTIONS(5080),
    [anon_sym_LT_EQ] = ACTIONS(5082),
    [anon_sym_GT_EQ] = ACTIONS(5082),
    [anon_sym_LT_LT] = ACTIONS(5084),
    [anon_sym_GT_GT] = ACTIONS(5084),
    [anon_sym_PLUS] = ACTIONS(5086),
    [anon_sym_DASH] = ACTIONS(5086),
    [anon_sym_SLASH] = ACTIONS(5060),
    [anon_sym_PERCENT] = ACTIONS(5060),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1632] = {
    [sym_string_literal] = STATE(2337),
    [aux_sym_concatenated_string_repeat1] = STATE(2337),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_RBRACE] = ACTIONS(463),
    [anon_sym_LPAREN2] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(91),
  },
  [1633] = {
    [anon_sym_COMMA] = ACTIONS(5088),
    [anon_sym_RPAREN] = ACTIONS(5088),
    [anon_sym_SEMI] = ACTIONS(5088),
    [anon_sym_LBRACE] = ACTIONS(3461),
    [anon_sym_LPAREN2] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3461),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_const] = ACTIONS(3463),
    [anon_sym_restrict] = ACTIONS(3461),
    [anon_sym_volatile] = ACTIONS(3461),
    [anon_sym__Atomic] = ACTIONS(3461),
    [anon_sym_mutable] = ACTIONS(3461),
    [anon_sym_explicit] = ACTIONS(3461),
    [anon_sym_constexpr] = ACTIONS(3461),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3461),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3461),
    [anon_sym_override] = ACTIONS(3461),
    [anon_sym_GT2] = ACTIONS(5088),
    [sym_noexcept] = ACTIONS(3461),
  },
  [1634] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(2339),
    [anon_sym_COMMA] = ACTIONS(465),
    [anon_sym_RPAREN] = ACTIONS(465),
    [anon_sym_extern] = ACTIONS(468),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(465),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_register] = ACTIONS(468),
    [anon_sym_inline] = ACTIONS(468),
    [anon_sym_const] = ACTIONS(468),
    [anon_sym_restrict] = ACTIONS(468),
    [anon_sym_volatile] = ACTIONS(468),
    [anon_sym__Atomic] = ACTIONS(468),
    [anon_sym_mutable] = ACTIONS(468),
    [anon_sym_explicit] = ACTIONS(468),
    [anon_sym_constexpr] = ACTIONS(468),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(474),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_TILDE] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_identifier] = ACTIONS(468),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(5091),
    [sym_operator_name] = ACTIONS(481),
  },
  [1635] = {
    [sym_destructor_name] = STATE(315),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(5093),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(883),
    [sym_operator_name] = ACTIONS(554),
  },
  [1636] = {
    [sym_initializer_list] = STATE(352),
    [anon_sym_COMMA] = ACTIONS(624),
    [anon_sym_RPAREN] = ACTIONS(624),
    [anon_sym_extern] = ACTIONS(626),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(624),
    [anon_sym_STAR] = ACTIONS(624),
    [anon_sym_LBRACK] = ACTIONS(624),
    [anon_sym_static] = ACTIONS(626),
    [anon_sym_register] = ACTIONS(626),
    [anon_sym_inline] = ACTIONS(626),
    [anon_sym_const] = ACTIONS(626),
    [anon_sym_restrict] = ACTIONS(626),
    [anon_sym_volatile] = ACTIONS(626),
    [anon_sym__Atomic] = ACTIONS(626),
    [anon_sym_mutable] = ACTIONS(626),
    [anon_sym_explicit] = ACTIONS(626),
    [anon_sym_constexpr] = ACTIONS(626),
    [anon_sym_AMP] = ACTIONS(626),
    [anon_sym_AMP_AMP] = ACTIONS(624),
    [anon_sym_TILDE] = ACTIONS(624),
    [sym_identifier] = ACTIONS(626),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(5095),
    [sym_operator_name] = ACTIONS(624),
  },
  [1637] = {
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(5095),
  },
  [1638] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(5097),
    [anon_sym_SEMI] = ACTIONS(5097),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(590),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(594),
    [anon_sym_QMARK] = ACTIONS(596),
    [anon_sym_STAR_EQ] = ACTIONS(598),
    [anon_sym_SLASH_EQ] = ACTIONS(598),
    [anon_sym_PERCENT_EQ] = ACTIONS(598),
    [anon_sym_PLUS_EQ] = ACTIONS(598),
    [anon_sym_DASH_EQ] = ACTIONS(598),
    [anon_sym_LT_LT_EQ] = ACTIONS(598),
    [anon_sym_GT_GT_EQ] = ACTIONS(598),
    [anon_sym_AMP_EQ] = ACTIONS(598),
    [anon_sym_CARET_EQ] = ACTIONS(598),
    [anon_sym_PIPE_EQ] = ACTIONS(598),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_PIPE_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(604),
    [anon_sym_PIPE] = ACTIONS(606),
    [anon_sym_CARET] = ACTIONS(608),
    [anon_sym_EQ_EQ] = ACTIONS(610),
    [anon_sym_BANG_EQ] = ACTIONS(610),
    [anon_sym_LT] = ACTIONS(612),
    [anon_sym_GT] = ACTIONS(612),
    [anon_sym_LT_EQ] = ACTIONS(614),
    [anon_sym_GT_EQ] = ACTIONS(614),
    [anon_sym_LT_LT] = ACTIONS(616),
    [anon_sym_GT_GT] = ACTIONS(616),
    [anon_sym_PLUS] = ACTIONS(618),
    [anon_sym_DASH] = ACTIONS(618),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1639] = {
    [anon_sym_COMMA] = ACTIONS(5097),
    [anon_sym_RPAREN] = ACTIONS(5097),
    [anon_sym_SEMI] = ACTIONS(5097),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(5097),
  },
  [1640] = {
    [sym__type_specifier] = STATE(2346),
    [sym_sized_type_specifier] = STATE(2346),
    [sym_enum_specifier] = STATE(2346),
    [sym_struct_specifier] = STATE(2346),
    [sym_union_specifier] = STATE(2346),
    [sym_macro_type_specifier] = STATE(2346),
    [sym_class_specifier] = STATE(2346),
    [sym_dependent_type] = STATE(2346),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2347),
    [anon_sym_unsigned] = ACTIONS(5099),
    [anon_sym_long] = ACTIONS(5099),
    [anon_sym_short] = ACTIONS(5099),
    [sym_primitive_type] = ACTIONS(5101),
    [anon_sym_enum] = ACTIONS(3675),
    [anon_sym_struct] = ACTIONS(5103),
    [anon_sym_union] = ACTIONS(5105),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5107),
    [sym_auto] = ACTIONS(5101),
    [anon_sym_typename] = ACTIONS(5109),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [1641] = {
    [sym_type_qualifier] = STATE(2348),
    [sym_virtual_specifier] = STATE(2348),
    [sym_trailing_return_type] = STATE(2348),
    [aux_sym_function_declarator_repeat1] = STATE(2348),
    [anon_sym_COMMA] = ACTIONS(3549),
    [anon_sym_SEMI] = ACTIONS(3549),
    [anon_sym_LBRACE] = ACTIONS(3549),
    [anon_sym_LPAREN2] = ACTIONS(3549),
    [anon_sym_LBRACK] = ACTIONS(3549),
    [anon_sym_EQ] = ACTIONS(3549),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(3443),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [sym_noexcept] = ACTIONS(5111),
  },
  [1642] = {
    [sym_raw_string_literal] = ACTIONS(5113),
    [ts_builtin_sym_end] = ACTIONS(5113),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5115),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5115),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5115),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5115),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5115),
    [sym_preproc_directive] = ACTIONS(5115),
    [anon_sym_SEMI] = ACTIONS(5113),
    [anon_sym_typedef] = ACTIONS(5115),
    [anon_sym_extern] = ACTIONS(5115),
    [anon_sym_LBRACE] = ACTIONS(5113),
    [anon_sym_RBRACE] = ACTIONS(5113),
    [anon_sym_LPAREN2] = ACTIONS(5113),
    [anon_sym_STAR] = ACTIONS(5113),
    [anon_sym_LBRACK] = ACTIONS(5113),
    [anon_sym_static] = ACTIONS(5115),
    [anon_sym_register] = ACTIONS(5115),
    [anon_sym_inline] = ACTIONS(5115),
    [anon_sym_const] = ACTIONS(5115),
    [anon_sym_restrict] = ACTIONS(5115),
    [anon_sym_volatile] = ACTIONS(5115),
    [anon_sym__Atomic] = ACTIONS(5115),
    [anon_sym_mutable] = ACTIONS(5115),
    [anon_sym_explicit] = ACTIONS(5115),
    [anon_sym_constexpr] = ACTIONS(5115),
    [anon_sym_unsigned] = ACTIONS(5115),
    [anon_sym_long] = ACTIONS(5115),
    [anon_sym_short] = ACTIONS(5115),
    [sym_primitive_type] = ACTIONS(5115),
    [anon_sym_enum] = ACTIONS(5115),
    [anon_sym_struct] = ACTIONS(5115),
    [anon_sym_union] = ACTIONS(5115),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_else] = ACTIONS(5115),
    [anon_sym_switch] = ACTIONS(5115),
    [anon_sym_case] = ACTIONS(5115),
    [anon_sym_default] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_for] = ACTIONS(5115),
    [anon_sym_return] = ACTIONS(5115),
    [anon_sym_break] = ACTIONS(5115),
    [anon_sym_continue] = ACTIONS(5115),
    [anon_sym_goto] = ACTIONS(5115),
    [anon_sym_AMP] = ACTIONS(5115),
    [anon_sym_AMP_AMP] = ACTIONS(5113),
    [anon_sym_BANG] = ACTIONS(5113),
    [anon_sym_TILDE] = ACTIONS(5113),
    [anon_sym_PLUS] = ACTIONS(5115),
    [anon_sym_DASH] = ACTIONS(5115),
    [anon_sym_DASH_DASH] = ACTIONS(5113),
    [anon_sym_PLUS_PLUS] = ACTIONS(5113),
    [anon_sym_sizeof] = ACTIONS(5115),
    [sym_number_literal] = ACTIONS(5113),
    [anon_sym_SQUOTE] = ACTIONS(5113),
    [anon_sym_DQUOTE] = ACTIONS(5113),
    [sym_true] = ACTIONS(5115),
    [sym_false] = ACTIONS(5115),
    [sym_null] = ACTIONS(5115),
    [sym_identifier] = ACTIONS(5115),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5115),
    [sym_auto] = ACTIONS(5115),
    [anon_sym_typename] = ACTIONS(5115),
    [anon_sym_template] = ACTIONS(5115),
    [anon_sym_delete] = ACTIONS(5115),
    [anon_sym_namespace] = ACTIONS(5115),
    [anon_sym_using] = ACTIONS(5115),
    [anon_sym_try] = ACTIONS(5115),
    [anon_sym_new] = ACTIONS(5115),
    [anon_sym_COLON_COLON] = ACTIONS(5113),
    [sym_operator_name] = ACTIONS(5113),
    [sym_nullptr] = ACTIONS(5115),
  },
  [1643] = {
    [aux_sym_declaration_repeat1] = STATE(1643),
    [anon_sym_COMMA] = ACTIONS(5117),
    [anon_sym_SEMI] = ACTIONS(5032),
    [sym_comment] = ACTIONS(91),
  },
  [1644] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(5120),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1645] = {
    [anon_sym_SEMI] = ACTIONS(5120),
    [sym_comment] = ACTIONS(91),
  },
  [1646] = {
    [sym_raw_string_literal] = ACTIONS(5122),
    [ts_builtin_sym_end] = ACTIONS(5122),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5124),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5124),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5124),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5124),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5124),
    [sym_preproc_directive] = ACTIONS(5124),
    [anon_sym_SEMI] = ACTIONS(5122),
    [anon_sym_typedef] = ACTIONS(5124),
    [anon_sym_extern] = ACTIONS(5124),
    [anon_sym_LBRACE] = ACTIONS(5122),
    [anon_sym_RBRACE] = ACTIONS(5122),
    [anon_sym_LPAREN2] = ACTIONS(5122),
    [anon_sym_STAR] = ACTIONS(5122),
    [anon_sym_LBRACK] = ACTIONS(5122),
    [anon_sym_static] = ACTIONS(5124),
    [anon_sym_register] = ACTIONS(5124),
    [anon_sym_inline] = ACTIONS(5124),
    [anon_sym_const] = ACTIONS(5124),
    [anon_sym_restrict] = ACTIONS(5124),
    [anon_sym_volatile] = ACTIONS(5124),
    [anon_sym__Atomic] = ACTIONS(5124),
    [anon_sym_mutable] = ACTIONS(5124),
    [anon_sym_explicit] = ACTIONS(5124),
    [anon_sym_constexpr] = ACTIONS(5124),
    [anon_sym_unsigned] = ACTIONS(5124),
    [anon_sym_long] = ACTIONS(5124),
    [anon_sym_short] = ACTIONS(5124),
    [sym_primitive_type] = ACTIONS(5124),
    [anon_sym_enum] = ACTIONS(5124),
    [anon_sym_struct] = ACTIONS(5124),
    [anon_sym_union] = ACTIONS(5124),
    [anon_sym_if] = ACTIONS(5124),
    [anon_sym_switch] = ACTIONS(5124),
    [anon_sym_case] = ACTIONS(5124),
    [anon_sym_default] = ACTIONS(5124),
    [anon_sym_while] = ACTIONS(5124),
    [anon_sym_do] = ACTIONS(5124),
    [anon_sym_for] = ACTIONS(5124),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_break] = ACTIONS(5124),
    [anon_sym_continue] = ACTIONS(5124),
    [anon_sym_goto] = ACTIONS(5124),
    [anon_sym_AMP] = ACTIONS(5124),
    [anon_sym_AMP_AMP] = ACTIONS(5122),
    [anon_sym_BANG] = ACTIONS(5122),
    [anon_sym_TILDE] = ACTIONS(5122),
    [anon_sym_PLUS] = ACTIONS(5124),
    [anon_sym_DASH] = ACTIONS(5124),
    [anon_sym_DASH_DASH] = ACTIONS(5122),
    [anon_sym_PLUS_PLUS] = ACTIONS(5122),
    [anon_sym_sizeof] = ACTIONS(5124),
    [sym_number_literal] = ACTIONS(5122),
    [anon_sym_SQUOTE] = ACTIONS(5122),
    [anon_sym_DQUOTE] = ACTIONS(5122),
    [sym_true] = ACTIONS(5124),
    [sym_false] = ACTIONS(5124),
    [sym_null] = ACTIONS(5124),
    [sym_identifier] = ACTIONS(5124),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5124),
    [sym_auto] = ACTIONS(5124),
    [anon_sym_typename] = ACTIONS(5124),
    [anon_sym_template] = ACTIONS(5124),
    [anon_sym_delete] = ACTIONS(5124),
    [anon_sym_namespace] = ACTIONS(5124),
    [anon_sym_using] = ACTIONS(5124),
    [anon_sym_try] = ACTIONS(5124),
    [anon_sym_new] = ACTIONS(5124),
    [anon_sym_COLON_COLON] = ACTIONS(5122),
    [sym_operator_name] = ACTIONS(5122),
    [sym_nullptr] = ACTIONS(5124),
  },
  [1647] = {
    [sym__declaration_specifiers] = STATE(905),
    [sym_storage_class_specifier] = STATE(907),
    [sym_type_qualifier] = STATE(907),
    [sym__type_specifier] = STATE(906),
    [sym_sized_type_specifier] = STATE(906),
    [sym_enum_specifier] = STATE(906),
    [sym_struct_specifier] = STATE(906),
    [sym_union_specifier] = STATE(906),
    [sym_parameter_declaration] = STATE(2350),
    [sym_macro_type_specifier] = STATE(906),
    [sym_class_specifier] = STATE(906),
    [sym_dependent_type] = STATE(906),
    [sym_template_type] = STATE(272),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(180),
    [aux_sym__declaration_specifiers_repeat1] = STATE(907),
    [aux_sym_sized_type_specifier_repeat1] = STATE(908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5126),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(1629),
    [anon_sym_long] = ACTIONS(1629),
    [anon_sym_short] = ACTIONS(1629),
    [sym_primitive_type] = ACTIONS(1631),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [sym_identifier] = ACTIONS(492),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(1631),
    [anon_sym_typename] = ACTIONS(1633),
    [anon_sym_COLON_COLON] = ACTIONS(315),
  },
  [1648] = {
    [anon_sym_COMMA] = ACTIONS(5128),
    [anon_sym_RPAREN] = ACTIONS(5128),
    [anon_sym_SEMI] = ACTIONS(5128),
    [anon_sym_LBRACE] = ACTIONS(5128),
    [anon_sym_LPAREN2] = ACTIONS(5128),
    [anon_sym_LBRACK] = ACTIONS(5128),
    [anon_sym_EQ] = ACTIONS(5128),
    [anon_sym_const] = ACTIONS(5130),
    [anon_sym_restrict] = ACTIONS(5128),
    [anon_sym_volatile] = ACTIONS(5128),
    [anon_sym__Atomic] = ACTIONS(5128),
    [anon_sym_mutable] = ACTIONS(5128),
    [anon_sym_explicit] = ACTIONS(5128),
    [anon_sym_constexpr] = ACTIONS(5128),
    [anon_sym_COLON] = ACTIONS(5128),
    [anon_sym_DASH_GT] = ACTIONS(5128),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5128),
    [anon_sym_override] = ACTIONS(5128),
    [anon_sym_GT2] = ACTIONS(5128),
    [sym_noexcept] = ACTIONS(5128),
  },
  [1649] = {
    [aux_sym_parameter_list_repeat1] = STATE(2352),
    [anon_sym_COMMA] = ACTIONS(3457),
    [anon_sym_RPAREN] = ACTIONS(5132),
    [sym_comment] = ACTIONS(91),
  },
  [1650] = {
    [sym__declarator] = STATE(2353),
    [sym__abstract_declarator] = STATE(2354),
    [sym_pointer_declarator] = STATE(2353),
    [sym_abstract_pointer_declarator] = STATE(2354),
    [sym_function_declarator] = STATE(2353),
    [sym_abstract_function_declarator] = STATE(2354),
    [sym_array_declarator] = STATE(2353),
    [sym_abstract_array_declarator] = STATE(2354),
    [sym_type_qualifier] = STATE(2355),
    [sym_parameter_list] = STATE(1654),
    [sym_reference_declarator] = STATE(2353),
    [sym_abstract_reference_declarator] = STATE(2354),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(2353),
    [sym_destructor_name] = STATE(2353),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [aux_sym_type_definition_repeat1] = STATE(2355),
    [anon_sym_COMMA] = ACTIONS(2461),
    [anon_sym_RPAREN] = ACTIONS(2461),
    [anon_sym_LPAREN2] = ACTIONS(3249),
    [anon_sym_STAR] = ACTIONS(3465),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(3467),
    [anon_sym_AMP_AMP] = ACTIONS(3469),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(568),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(5134),
  },
  [1651] = {
    [sym__declarator] = STATE(2356),
    [sym__abstract_declarator] = STATE(2357),
    [sym_pointer_declarator] = STATE(2356),
    [sym_abstract_pointer_declarator] = STATE(2357),
    [sym_function_declarator] = STATE(2356),
    [sym_abstract_function_declarator] = STATE(2357),
    [sym_array_declarator] = STATE(2356),
    [sym_abstract_array_declarator] = STATE(2357),
    [sym_parameter_list] = STATE(1654),
    [sym_reference_declarator] = STATE(2356),
    [sym_abstract_reference_declarator] = STATE(2357),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(2356),
    [sym_destructor_name] = STATE(2356),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [anon_sym_COMMA] = ACTIONS(2463),
    [anon_sym_RPAREN] = ACTIONS(2463),
    [anon_sym_LPAREN2] = ACTIONS(3249),
    [anon_sym_STAR] = ACTIONS(3465),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_AMP] = ACTIONS(3467),
    [anon_sym_AMP_AMP] = ACTIONS(3469),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(568),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(5136),
  },
  [1652] = {
    [sym_parameter_list] = STATE(2359),
    [sym_argument_list] = STATE(898),
    [sym_initializer_list] = STATE(898),
    [anon_sym_COMMA] = ACTIONS(4889),
    [anon_sym_RPAREN] = ACTIONS(4889),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(1619),
    [anon_sym_LBRACK] = ACTIONS(574),
    [anon_sym_EQ] = ACTIONS(5138),
    [sym_comment] = ACTIONS(91),
  },
  [1653] = {
    [sym_parameter_list] = STATE(2360),
    [anon_sym_COMMA] = ACTIONS(4889),
    [anon_sym_RPAREN] = ACTIONS(4889),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [sym_comment] = ACTIONS(91),
  },
  [1654] = {
    [sym_type_qualifier] = STATE(2362),
    [sym_trailing_return_type] = STATE(971),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2362),
    [anon_sym_COMMA] = ACTIONS(1787),
    [anon_sym_RPAREN] = ACTIONS(1787),
    [anon_sym_LPAREN2] = ACTIONS(1787),
    [anon_sym_LBRACK] = ACTIONS(1787),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(5140),
    [sym_comment] = ACTIONS(91),
    [sym_noexcept] = ACTIONS(5142),
  },
  [1655] = {
    [sym_storage_class_specifier] = STATE(2363),
    [sym_type_qualifier] = STATE(2363),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2363),
    [anon_sym_COMMA] = ACTIONS(1689),
    [anon_sym_RPAREN] = ACTIONS(1689),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_LPAREN2] = ACTIONS(1689),
    [anon_sym_STAR] = ACTIONS(1689),
    [anon_sym_LBRACK] = ACTIONS(1689),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(1691),
    [anon_sym_AMP_AMP] = ACTIONS(1689),
    [anon_sym_TILDE] = ACTIONS(1689),
    [sym_identifier] = ACTIONS(1691),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1689),
    [sym_operator_name] = ACTIONS(1689),
  },
  [1656] = {
    [sym_storage_class_specifier] = STATE(2364),
    [sym_type_qualifier] = STATE(2364),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2364),
    [anon_sym_COMMA] = ACTIONS(1689),
    [anon_sym_RPAREN] = ACTIONS(1689),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_LPAREN2] = ACTIONS(1689),
    [anon_sym_STAR] = ACTIONS(1689),
    [anon_sym_LBRACK] = ACTIONS(1689),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(1691),
    [anon_sym_AMP_AMP] = ACTIONS(1689),
    [anon_sym_TILDE] = ACTIONS(1689),
    [sym_identifier] = ACTIONS(1691),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1689),
    [sym_operator_name] = ACTIONS(1689),
  },
  [1657] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1657),
    [anon_sym_COMMA] = ACTIONS(1985),
    [anon_sym_RPAREN] = ACTIONS(1985),
    [anon_sym_extern] = ACTIONS(1987),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1985),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_static] = ACTIONS(1987),
    [anon_sym_register] = ACTIONS(1987),
    [anon_sym_inline] = ACTIONS(1987),
    [anon_sym_const] = ACTIONS(1987),
    [anon_sym_restrict] = ACTIONS(1987),
    [anon_sym_volatile] = ACTIONS(1987),
    [anon_sym__Atomic] = ACTIONS(1987),
    [anon_sym_mutable] = ACTIONS(1987),
    [anon_sym_explicit] = ACTIONS(1987),
    [anon_sym_constexpr] = ACTIONS(1987),
    [anon_sym_unsigned] = ACTIONS(5144),
    [anon_sym_long] = ACTIONS(5144),
    [anon_sym_short] = ACTIONS(5144),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1985),
    [sym_operator_name] = ACTIONS(1985),
  },
  [1658] = {
    [anon_sym_RPAREN] = ACTIONS(5147),
    [sym_comment] = ACTIONS(91),
  },
  [1659] = {
    [anon_sym_COMMA] = ACTIONS(5149),
    [anon_sym_RPAREN] = ACTIONS(5149),
    [anon_sym_SEMI] = ACTIONS(5149),
    [anon_sym_LBRACE] = ACTIONS(5149),
    [anon_sym_LPAREN2] = ACTIONS(5149),
    [anon_sym_LBRACK] = ACTIONS(5149),
    [anon_sym_EQ] = ACTIONS(5149),
    [anon_sym_COLON] = ACTIONS(5149),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(5149),
  },
  [1660] = {
    [sym_type_qualifier] = STATE(141),
    [sym__type_specifier] = STATE(136),
    [sym_sized_type_specifier] = STATE(136),
    [sym_enum_specifier] = STATE(136),
    [sym_struct_specifier] = STATE(136),
    [sym_union_specifier] = STATE(136),
    [sym__expression] = STATE(137),
    [sym_comma_expression] = STATE(138),
    [sym_conditional_expression] = STATE(137),
    [sym_assignment_expression] = STATE(137),
    [sym_pointer_expression] = STATE(137),
    [sym_logical_expression] = STATE(137),
    [sym_bitwise_expression] = STATE(137),
    [sym_equality_expression] = STATE(137),
    [sym_relational_expression] = STATE(137),
    [sym_shift_expression] = STATE(137),
    [sym_math_expression] = STATE(137),
    [sym_cast_expression] = STATE(137),
    [sym_type_descriptor] = STATE(2366),
    [sym_sizeof_expression] = STATE(137),
    [sym_subscript_expression] = STATE(137),
    [sym_call_expression] = STATE(137),
    [sym_field_expression] = STATE(137),
    [sym_compound_literal_expression] = STATE(137),
    [sym_parenthesized_expression] = STATE(137),
    [sym_char_literal] = STATE(137),
    [sym_concatenated_string] = STATE(137),
    [sym_string_literal] = STATE(140),
    [sym_macro_type_specifier] = STATE(136),
    [sym_class_specifier] = STATE(136),
    [sym_dependent_type] = STATE(136),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(137),
    [sym_new_expression] = STATE(137),
    [sym_delete_expression] = STATE(137),
    [sym_lambda_expression] = STATE(137),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_type_definition_repeat1] = STATE(141),
    [aux_sym_sized_type_specifier_repeat1] = STATE(142),
    [sym_raw_string_literal] = ACTIONS(213),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(219),
    [anon_sym_long] = ACTIONS(219),
    [anon_sym_short] = ACTIONS(219),
    [sym_primitive_type] = ACTIONS(221),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [sym_null] = ACTIONS(241),
    [sym_identifier] = ACTIONS(811),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(221),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(253),
    [sym_nullptr] = ACTIONS(241),
  },
  [1661] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(1364),
    [anon_sym_EQ] = ACTIONS(1366),
    [anon_sym_QMARK] = ACTIONS(1364),
    [anon_sym_STAR_EQ] = ACTIONS(1364),
    [anon_sym_SLASH_EQ] = ACTIONS(1364),
    [anon_sym_PERCENT_EQ] = ACTIONS(1364),
    [anon_sym_PLUS_EQ] = ACTIONS(1364),
    [anon_sym_DASH_EQ] = ACTIONS(1364),
    [anon_sym_LT_LT_EQ] = ACTIONS(1364),
    [anon_sym_GT_GT_EQ] = ACTIONS(1364),
    [anon_sym_AMP_EQ] = ACTIONS(1364),
    [anon_sym_CARET_EQ] = ACTIONS(1364),
    [anon_sym_PIPE_EQ] = ACTIONS(1364),
    [anon_sym_AMP] = ACTIONS(1366),
    [anon_sym_PIPE_PIPE] = ACTIONS(1364),
    [anon_sym_AMP_AMP] = ACTIONS(1364),
    [anon_sym_PIPE] = ACTIONS(1366),
    [anon_sym_CARET] = ACTIONS(1366),
    [anon_sym_EQ_EQ] = ACTIONS(1364),
    [anon_sym_BANG_EQ] = ACTIONS(1364),
    [anon_sym_LT] = ACTIONS(1366),
    [anon_sym_GT] = ACTIONS(1366),
    [anon_sym_LT_EQ] = ACTIONS(1364),
    [anon_sym_GT_EQ] = ACTIONS(1364),
    [anon_sym_LT_LT] = ACTIONS(3525),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1662] = {
    [sym__expression] = STATE(164),
    [sym_conditional_expression] = STATE(164),
    [sym_assignment_expression] = STATE(164),
    [sym_pointer_expression] = STATE(164),
    [sym_logical_expression] = STATE(164),
    [sym_bitwise_expression] = STATE(164),
    [sym_equality_expression] = STATE(164),
    [sym_relational_expression] = STATE(164),
    [sym_shift_expression] = STATE(164),
    [sym_math_expression] = STATE(164),
    [sym_cast_expression] = STATE(164),
    [sym_sizeof_expression] = STATE(164),
    [sym_subscript_expression] = STATE(164),
    [sym_call_expression] = STATE(164),
    [sym_field_expression] = STATE(164),
    [sym_compound_literal_expression] = STATE(164),
    [sym_parenthesized_expression] = STATE(164),
    [sym_char_literal] = STATE(164),
    [sym_concatenated_string] = STATE(164),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(164),
    [sym_new_expression] = STATE(164),
    [sym_delete_expression] = STATE(164),
    [sym_lambda_expression] = STATE(164),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_lambda_default_capture] = STATE(166),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(267),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(5151),
    [anon_sym_EQ] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(267),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(289),
    [sym_false] = ACTIONS(289),
    [sym_null] = ACTIONS(289),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(289),
  },
  [1663] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(1489),
    [anon_sym_EQ] = ACTIONS(1491),
    [anon_sym_QMARK] = ACTIONS(1489),
    [anon_sym_STAR_EQ] = ACTIONS(1489),
    [anon_sym_SLASH_EQ] = ACTIONS(1489),
    [anon_sym_PERCENT_EQ] = ACTIONS(1489),
    [anon_sym_PLUS_EQ] = ACTIONS(1489),
    [anon_sym_DASH_EQ] = ACTIONS(1489),
    [anon_sym_LT_LT_EQ] = ACTIONS(1489),
    [anon_sym_GT_GT_EQ] = ACTIONS(1489),
    [anon_sym_AMP_EQ] = ACTIONS(1489),
    [anon_sym_CARET_EQ] = ACTIONS(1489),
    [anon_sym_PIPE_EQ] = ACTIONS(1489),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_CARET] = ACTIONS(3517),
    [anon_sym_EQ_EQ] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3521),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3525),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1664] = {
    [sym__type_specifier] = STATE(871),
    [sym_sized_type_specifier] = STATE(871),
    [sym_enum_specifier] = STATE(871),
    [sym_struct_specifier] = STATE(871),
    [sym_union_specifier] = STATE(871),
    [sym_macro_type_specifier] = STATE(871),
    [sym_class_specifier] = STATE(871),
    [sym_dependent_type] = STATE(871),
    [sym_template_type] = STATE(309),
    [sym_scoped_type_identifier] = STATE(310),
    [sym_scoped_namespace_identifier] = STATE(311),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1667),
    [anon_sym_unsigned] = ACTIONS(3493),
    [anon_sym_long] = ACTIONS(3493),
    [anon_sym_short] = ACTIONS(3493),
    [sym_primitive_type] = ACTIONS(1552),
    [anon_sym_enum] = ACTIONS(536),
    [anon_sym_struct] = ACTIONS(538),
    [anon_sym_union] = ACTIONS(540),
    [sym_identifier] = ACTIONS(542),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(544),
    [sym_auto] = ACTIONS(1552),
    [anon_sym_typename] = ACTIONS(3497),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [1665] = {
    [sym_argument_list] = STATE(874),
    [sym_initializer_list] = STATE(874),
    [sym_new_declarator] = STATE(875),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1558),
    [anon_sym_LBRACK] = ACTIONS(5153),
    [anon_sym_RBRACK] = ACTIONS(1556),
    [anon_sym_EQ] = ACTIONS(1558),
    [anon_sym_QMARK] = ACTIONS(1556),
    [anon_sym_STAR_EQ] = ACTIONS(1556),
    [anon_sym_SLASH_EQ] = ACTIONS(1556),
    [anon_sym_PERCENT_EQ] = ACTIONS(1556),
    [anon_sym_PLUS_EQ] = ACTIONS(1556),
    [anon_sym_DASH_EQ] = ACTIONS(1556),
    [anon_sym_LT_LT_EQ] = ACTIONS(1556),
    [anon_sym_GT_GT_EQ] = ACTIONS(1556),
    [anon_sym_AMP_EQ] = ACTIONS(1556),
    [anon_sym_CARET_EQ] = ACTIONS(1556),
    [anon_sym_PIPE_EQ] = ACTIONS(1556),
    [anon_sym_AMP] = ACTIONS(1558),
    [anon_sym_PIPE_PIPE] = ACTIONS(1556),
    [anon_sym_AMP_AMP] = ACTIONS(1556),
    [anon_sym_PIPE] = ACTIONS(1558),
    [anon_sym_CARET] = ACTIONS(1558),
    [anon_sym_EQ_EQ] = ACTIONS(1556),
    [anon_sym_BANG_EQ] = ACTIONS(1556),
    [anon_sym_LT] = ACTIONS(1558),
    [anon_sym_GT] = ACTIONS(1558),
    [anon_sym_LT_EQ] = ACTIONS(1556),
    [anon_sym_GT_EQ] = ACTIONS(1556),
    [anon_sym_LT_LT] = ACTIONS(1558),
    [anon_sym_GT_GT] = ACTIONS(1558),
    [anon_sym_PLUS] = ACTIONS(1558),
    [anon_sym_DASH] = ACTIONS(1558),
    [anon_sym_SLASH] = ACTIONS(1558),
    [anon_sym_PERCENT] = ACTIONS(1558),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DOT] = ACTIONS(1556),
    [anon_sym_DASH_GT] = ACTIONS(1556),
    [sym_comment] = ACTIONS(91),
  },
  [1666] = {
    [sym__type_specifier] = STATE(2369),
    [sym_sized_type_specifier] = STATE(2369),
    [sym_enum_specifier] = STATE(2369),
    [sym_struct_specifier] = STATE(2369),
    [sym_union_specifier] = STATE(2369),
    [sym_macro_type_specifier] = STATE(2369),
    [sym_class_specifier] = STATE(2369),
    [sym_dependent_type] = STATE(2369),
    [sym_template_type] = STATE(309),
    [sym_scoped_type_identifier] = STATE(310),
    [sym_scoped_namespace_identifier] = STATE(311),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1667),
    [anon_sym_unsigned] = ACTIONS(3493),
    [anon_sym_long] = ACTIONS(3493),
    [anon_sym_short] = ACTIONS(3493),
    [sym_primitive_type] = ACTIONS(5155),
    [anon_sym_enum] = ACTIONS(536),
    [anon_sym_struct] = ACTIONS(538),
    [anon_sym_union] = ACTIONS(540),
    [sym_identifier] = ACTIONS(542),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(544),
    [sym_auto] = ACTIONS(5155),
    [anon_sym_typename] = ACTIONS(3497),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [1667] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2370),
    [anon_sym_LBRACE] = ACTIONS(653),
    [anon_sym_LPAREN2] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_RBRACK] = ACTIONS(653),
    [anon_sym_EQ] = ACTIONS(655),
    [anon_sym_unsigned] = ACTIONS(5157),
    [anon_sym_long] = ACTIONS(5157),
    [anon_sym_short] = ACTIONS(5157),
    [sym_primitive_type] = ACTIONS(1571),
    [anon_sym_QMARK] = ACTIONS(653),
    [anon_sym_STAR_EQ] = ACTIONS(653),
    [anon_sym_SLASH_EQ] = ACTIONS(653),
    [anon_sym_PERCENT_EQ] = ACTIONS(653),
    [anon_sym_PLUS_EQ] = ACTIONS(653),
    [anon_sym_DASH_EQ] = ACTIONS(653),
    [anon_sym_LT_LT_EQ] = ACTIONS(653),
    [anon_sym_GT_GT_EQ] = ACTIONS(653),
    [anon_sym_AMP_EQ] = ACTIONS(653),
    [anon_sym_CARET_EQ] = ACTIONS(653),
    [anon_sym_PIPE_EQ] = ACTIONS(653),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_PIPE_PIPE] = ACTIONS(653),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(655),
    [anon_sym_EQ_EQ] = ACTIONS(653),
    [anon_sym_BANG_EQ] = ACTIONS(653),
    [anon_sym_LT] = ACTIONS(655),
    [anon_sym_GT] = ACTIONS(655),
    [anon_sym_LT_EQ] = ACTIONS(653),
    [anon_sym_GT_EQ] = ACTIONS(653),
    [anon_sym_LT_LT] = ACTIONS(655),
    [anon_sym_GT_GT] = ACTIONS(655),
    [anon_sym_PLUS] = ACTIONS(655),
    [anon_sym_DASH] = ACTIONS(655),
    [anon_sym_SLASH] = ACTIONS(655),
    [anon_sym_PERCENT] = ACTIONS(655),
    [anon_sym_DASH_DASH] = ACTIONS(653),
    [anon_sym_PLUS_PLUS] = ACTIONS(653),
    [anon_sym_DOT] = ACTIONS(653),
    [anon_sym_DASH_GT] = ACTIONS(653),
    [sym_identifier] = ACTIONS(1573),
    [sym_comment] = ACTIONS(91),
  },
  [1668] = {
    [sym__expression] = STATE(2372),
    [sym_conditional_expression] = STATE(2372),
    [sym_assignment_expression] = STATE(2372),
    [sym_pointer_expression] = STATE(2372),
    [sym_logical_expression] = STATE(2372),
    [sym_bitwise_expression] = STATE(2372),
    [sym_equality_expression] = STATE(2372),
    [sym_relational_expression] = STATE(2372),
    [sym_shift_expression] = STATE(2372),
    [sym_math_expression] = STATE(2372),
    [sym_cast_expression] = STATE(2372),
    [sym_sizeof_expression] = STATE(2372),
    [sym_subscript_expression] = STATE(2372),
    [sym_call_expression] = STATE(2372),
    [sym_field_expression] = STATE(2372),
    [sym_compound_literal_expression] = STATE(2372),
    [sym_parenthesized_expression] = STATE(2372),
    [sym_char_literal] = STATE(2372),
    [sym_concatenated_string] = STATE(2372),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2372),
    [sym_new_expression] = STATE(2372),
    [sym_delete_expression] = STATE(2372),
    [sym_lambda_expression] = STATE(2372),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5159),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(5161),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(5159),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(5163),
    [sym_false] = ACTIONS(5163),
    [sym_null] = ACTIONS(5163),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(5163),
  },
  [1669] = {
    [sym__expression] = STATE(938),
    [sym_conditional_expression] = STATE(938),
    [sym_assignment_expression] = STATE(938),
    [sym_pointer_expression] = STATE(938),
    [sym_logical_expression] = STATE(938),
    [sym_bitwise_expression] = STATE(938),
    [sym_equality_expression] = STATE(938),
    [sym_relational_expression] = STATE(938),
    [sym_shift_expression] = STATE(938),
    [sym_math_expression] = STATE(938),
    [sym_cast_expression] = STATE(938),
    [sym_sizeof_expression] = STATE(938),
    [sym_subscript_expression] = STATE(938),
    [sym_call_expression] = STATE(938),
    [sym_field_expression] = STATE(938),
    [sym_compound_literal_expression] = STATE(938),
    [sym_parenthesized_expression] = STATE(938),
    [sym_char_literal] = STATE(938),
    [sym_concatenated_string] = STATE(938),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(938),
    [sym_new_expression] = STATE(938),
    [sym_delete_expression] = STATE(938),
    [sym_lambda_expression] = STATE(938),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(1701),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(1701),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(1703),
    [sym_false] = ACTIONS(1703),
    [sym_null] = ACTIONS(1703),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(1703),
  },
  [1670] = {
    [sym__expression] = STATE(2373),
    [sym_conditional_expression] = STATE(2373),
    [sym_assignment_expression] = STATE(2373),
    [sym_pointer_expression] = STATE(2373),
    [sym_logical_expression] = STATE(2373),
    [sym_bitwise_expression] = STATE(2373),
    [sym_equality_expression] = STATE(2373),
    [sym_relational_expression] = STATE(2373),
    [sym_shift_expression] = STATE(2373),
    [sym_math_expression] = STATE(2373),
    [sym_cast_expression] = STATE(2373),
    [sym_sizeof_expression] = STATE(2373),
    [sym_subscript_expression] = STATE(2373),
    [sym_call_expression] = STATE(2373),
    [sym_field_expression] = STATE(2373),
    [sym_compound_literal_expression] = STATE(2373),
    [sym_parenthesized_expression] = STATE(2373),
    [sym_char_literal] = STATE(2373),
    [sym_concatenated_string] = STATE(2373),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2373),
    [sym_new_expression] = STATE(2373),
    [sym_delete_expression] = STATE(2373),
    [sym_lambda_expression] = STATE(2373),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5165),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(5165),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(5167),
    [sym_false] = ACTIONS(5167),
    [sym_null] = ACTIONS(5167),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(5167),
  },
  [1671] = {
    [sym__expression] = STATE(2374),
    [sym_conditional_expression] = STATE(2374),
    [sym_assignment_expression] = STATE(2374),
    [sym_pointer_expression] = STATE(2374),
    [sym_logical_expression] = STATE(2374),
    [sym_bitwise_expression] = STATE(2374),
    [sym_equality_expression] = STATE(2374),
    [sym_relational_expression] = STATE(2374),
    [sym_shift_expression] = STATE(2374),
    [sym_math_expression] = STATE(2374),
    [sym_cast_expression] = STATE(2374),
    [sym_sizeof_expression] = STATE(2374),
    [sym_subscript_expression] = STATE(2374),
    [sym_call_expression] = STATE(2374),
    [sym_field_expression] = STATE(2374),
    [sym_compound_literal_expression] = STATE(2374),
    [sym_parenthesized_expression] = STATE(2374),
    [sym_char_literal] = STATE(2374),
    [sym_concatenated_string] = STATE(2374),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2374),
    [sym_new_expression] = STATE(2374),
    [sym_delete_expression] = STATE(2374),
    [sym_lambda_expression] = STATE(2374),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5169),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(5169),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(5171),
    [sym_false] = ACTIONS(5171),
    [sym_null] = ACTIONS(5171),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(5171),
  },
  [1672] = {
    [sym__expression] = STATE(2375),
    [sym_conditional_expression] = STATE(2375),
    [sym_assignment_expression] = STATE(2375),
    [sym_pointer_expression] = STATE(2375),
    [sym_logical_expression] = STATE(2375),
    [sym_bitwise_expression] = STATE(2375),
    [sym_equality_expression] = STATE(2375),
    [sym_relational_expression] = STATE(2375),
    [sym_shift_expression] = STATE(2375),
    [sym_math_expression] = STATE(2375),
    [sym_cast_expression] = STATE(2375),
    [sym_sizeof_expression] = STATE(2375),
    [sym_subscript_expression] = STATE(2375),
    [sym_call_expression] = STATE(2375),
    [sym_field_expression] = STATE(2375),
    [sym_compound_literal_expression] = STATE(2375),
    [sym_parenthesized_expression] = STATE(2375),
    [sym_char_literal] = STATE(2375),
    [sym_concatenated_string] = STATE(2375),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2375),
    [sym_new_expression] = STATE(2375),
    [sym_delete_expression] = STATE(2375),
    [sym_lambda_expression] = STATE(2375),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5173),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(5173),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(5175),
    [sym_false] = ACTIONS(5175),
    [sym_null] = ACTIONS(5175),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(5175),
  },
  [1673] = {
    [sym__expression] = STATE(2376),
    [sym_conditional_expression] = STATE(2376),
    [sym_assignment_expression] = STATE(2376),
    [sym_pointer_expression] = STATE(2376),
    [sym_logical_expression] = STATE(2376),
    [sym_bitwise_expression] = STATE(2376),
    [sym_equality_expression] = STATE(2376),
    [sym_relational_expression] = STATE(2376),
    [sym_shift_expression] = STATE(2376),
    [sym_math_expression] = STATE(2376),
    [sym_cast_expression] = STATE(2376),
    [sym_sizeof_expression] = STATE(2376),
    [sym_subscript_expression] = STATE(2376),
    [sym_call_expression] = STATE(2376),
    [sym_field_expression] = STATE(2376),
    [sym_compound_literal_expression] = STATE(2376),
    [sym_parenthesized_expression] = STATE(2376),
    [sym_char_literal] = STATE(2376),
    [sym_concatenated_string] = STATE(2376),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2376),
    [sym_new_expression] = STATE(2376),
    [sym_delete_expression] = STATE(2376),
    [sym_lambda_expression] = STATE(2376),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5177),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(5177),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(5179),
    [sym_false] = ACTIONS(5179),
    [sym_null] = ACTIONS(5179),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(5179),
  },
  [1674] = {
    [sym__expression] = STATE(2377),
    [sym_conditional_expression] = STATE(2377),
    [sym_assignment_expression] = STATE(2377),
    [sym_pointer_expression] = STATE(2377),
    [sym_logical_expression] = STATE(2377),
    [sym_bitwise_expression] = STATE(2377),
    [sym_equality_expression] = STATE(2377),
    [sym_relational_expression] = STATE(2377),
    [sym_shift_expression] = STATE(2377),
    [sym_math_expression] = STATE(2377),
    [sym_cast_expression] = STATE(2377),
    [sym_sizeof_expression] = STATE(2377),
    [sym_subscript_expression] = STATE(2377),
    [sym_call_expression] = STATE(2377),
    [sym_field_expression] = STATE(2377),
    [sym_compound_literal_expression] = STATE(2377),
    [sym_parenthesized_expression] = STATE(2377),
    [sym_char_literal] = STATE(2377),
    [sym_concatenated_string] = STATE(2377),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2377),
    [sym_new_expression] = STATE(2377),
    [sym_delete_expression] = STATE(2377),
    [sym_lambda_expression] = STATE(2377),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5181),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(5181),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(5183),
    [sym_false] = ACTIONS(5183),
    [sym_null] = ACTIONS(5183),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(5183),
  },
  [1675] = {
    [sym__expression] = STATE(2378),
    [sym_conditional_expression] = STATE(2378),
    [sym_assignment_expression] = STATE(2378),
    [sym_pointer_expression] = STATE(2378),
    [sym_logical_expression] = STATE(2378),
    [sym_bitwise_expression] = STATE(2378),
    [sym_equality_expression] = STATE(2378),
    [sym_relational_expression] = STATE(2378),
    [sym_shift_expression] = STATE(2378),
    [sym_math_expression] = STATE(2378),
    [sym_cast_expression] = STATE(2378),
    [sym_sizeof_expression] = STATE(2378),
    [sym_subscript_expression] = STATE(2378),
    [sym_call_expression] = STATE(2378),
    [sym_field_expression] = STATE(2378),
    [sym_compound_literal_expression] = STATE(2378),
    [sym_parenthesized_expression] = STATE(2378),
    [sym_char_literal] = STATE(2378),
    [sym_concatenated_string] = STATE(2378),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2378),
    [sym_new_expression] = STATE(2378),
    [sym_delete_expression] = STATE(2378),
    [sym_lambda_expression] = STATE(2378),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5185),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(5185),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(5187),
    [sym_false] = ACTIONS(5187),
    [sym_null] = ACTIONS(5187),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(5187),
  },
  [1676] = {
    [sym__expression] = STATE(2379),
    [sym_conditional_expression] = STATE(2379),
    [sym_assignment_expression] = STATE(2379),
    [sym_pointer_expression] = STATE(2379),
    [sym_logical_expression] = STATE(2379),
    [sym_bitwise_expression] = STATE(2379),
    [sym_equality_expression] = STATE(2379),
    [sym_relational_expression] = STATE(2379),
    [sym_shift_expression] = STATE(2379),
    [sym_math_expression] = STATE(2379),
    [sym_cast_expression] = STATE(2379),
    [sym_sizeof_expression] = STATE(2379),
    [sym_subscript_expression] = STATE(2379),
    [sym_call_expression] = STATE(2379),
    [sym_field_expression] = STATE(2379),
    [sym_compound_literal_expression] = STATE(2379),
    [sym_parenthesized_expression] = STATE(2379),
    [sym_char_literal] = STATE(2379),
    [sym_concatenated_string] = STATE(2379),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2379),
    [sym_new_expression] = STATE(2379),
    [sym_delete_expression] = STATE(2379),
    [sym_lambda_expression] = STATE(2379),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5189),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(5189),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(5191),
    [sym_false] = ACTIONS(5191),
    [sym_null] = ACTIONS(5191),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(5191),
  },
  [1677] = {
    [sym__expression] = STATE(2380),
    [sym_conditional_expression] = STATE(2380),
    [sym_assignment_expression] = STATE(2380),
    [sym_pointer_expression] = STATE(2380),
    [sym_logical_expression] = STATE(2380),
    [sym_bitwise_expression] = STATE(2380),
    [sym_equality_expression] = STATE(2380),
    [sym_relational_expression] = STATE(2380),
    [sym_shift_expression] = STATE(2380),
    [sym_math_expression] = STATE(2380),
    [sym_cast_expression] = STATE(2380),
    [sym_sizeof_expression] = STATE(2380),
    [sym_subscript_expression] = STATE(2380),
    [sym_call_expression] = STATE(2380),
    [sym_field_expression] = STATE(2380),
    [sym_compound_literal_expression] = STATE(2380),
    [sym_parenthesized_expression] = STATE(2380),
    [sym_char_literal] = STATE(2380),
    [sym_concatenated_string] = STATE(2380),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2380),
    [sym_new_expression] = STATE(2380),
    [sym_delete_expression] = STATE(2380),
    [sym_lambda_expression] = STATE(2380),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5193),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(5193),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(5195),
    [sym_false] = ACTIONS(5195),
    [sym_null] = ACTIONS(5195),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(5195),
  },
  [1678] = {
    [sym__expression] = STATE(2381),
    [sym_conditional_expression] = STATE(2381),
    [sym_assignment_expression] = STATE(2381),
    [sym_pointer_expression] = STATE(2381),
    [sym_logical_expression] = STATE(2381),
    [sym_bitwise_expression] = STATE(2381),
    [sym_equality_expression] = STATE(2381),
    [sym_relational_expression] = STATE(2381),
    [sym_shift_expression] = STATE(2381),
    [sym_math_expression] = STATE(2381),
    [sym_cast_expression] = STATE(2381),
    [sym_sizeof_expression] = STATE(2381),
    [sym_subscript_expression] = STATE(2381),
    [sym_call_expression] = STATE(2381),
    [sym_field_expression] = STATE(2381),
    [sym_compound_literal_expression] = STATE(2381),
    [sym_parenthesized_expression] = STATE(2381),
    [sym_char_literal] = STATE(2381),
    [sym_concatenated_string] = STATE(2381),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2381),
    [sym_new_expression] = STATE(2381),
    [sym_delete_expression] = STATE(2381),
    [sym_lambda_expression] = STATE(2381),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5197),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(5197),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(5199),
    [sym_false] = ACTIONS(5199),
    [sym_null] = ACTIONS(5199),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(5199),
  },
  [1679] = {
    [sym__expression] = STATE(2382),
    [sym_conditional_expression] = STATE(2382),
    [sym_assignment_expression] = STATE(2382),
    [sym_pointer_expression] = STATE(2382),
    [sym_logical_expression] = STATE(2382),
    [sym_bitwise_expression] = STATE(2382),
    [sym_equality_expression] = STATE(2382),
    [sym_relational_expression] = STATE(2382),
    [sym_shift_expression] = STATE(2382),
    [sym_math_expression] = STATE(2382),
    [sym_cast_expression] = STATE(2382),
    [sym_sizeof_expression] = STATE(2382),
    [sym_subscript_expression] = STATE(2382),
    [sym_call_expression] = STATE(2382),
    [sym_field_expression] = STATE(2382),
    [sym_compound_literal_expression] = STATE(2382),
    [sym_parenthesized_expression] = STATE(2382),
    [sym_char_literal] = STATE(2382),
    [sym_concatenated_string] = STATE(2382),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2382),
    [sym_new_expression] = STATE(2382),
    [sym_delete_expression] = STATE(2382),
    [sym_lambda_expression] = STATE(2382),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5201),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(5201),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(5203),
    [sym_false] = ACTIONS(5203),
    [sym_null] = ACTIONS(5203),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(5203),
  },
  [1680] = {
    [sym__expression] = STATE(2383),
    [sym_conditional_expression] = STATE(2383),
    [sym_assignment_expression] = STATE(2383),
    [sym_pointer_expression] = STATE(2383),
    [sym_logical_expression] = STATE(2383),
    [sym_bitwise_expression] = STATE(2383),
    [sym_equality_expression] = STATE(2383),
    [sym_relational_expression] = STATE(2383),
    [sym_shift_expression] = STATE(2383),
    [sym_math_expression] = STATE(2383),
    [sym_cast_expression] = STATE(2383),
    [sym_sizeof_expression] = STATE(2383),
    [sym_subscript_expression] = STATE(2383),
    [sym_call_expression] = STATE(2383),
    [sym_field_expression] = STATE(2383),
    [sym_compound_literal_expression] = STATE(2383),
    [sym_parenthesized_expression] = STATE(2383),
    [sym_char_literal] = STATE(2383),
    [sym_concatenated_string] = STATE(2383),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2383),
    [sym_new_expression] = STATE(2383),
    [sym_delete_expression] = STATE(2383),
    [sym_lambda_expression] = STATE(2383),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5205),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(5205),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(5207),
    [sym_false] = ACTIONS(5207),
    [sym_null] = ACTIONS(5207),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(5207),
  },
  [1681] = {
    [sym_string_literal] = STATE(2384),
    [aux_sym_concatenated_string_repeat1] = STATE(2384),
    [anon_sym_LPAREN2] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_RBRACK] = ACTIONS(1761),
    [anon_sym_EQ] = ACTIONS(1763),
    [anon_sym_QMARK] = ACTIONS(1761),
    [anon_sym_STAR_EQ] = ACTIONS(1761),
    [anon_sym_SLASH_EQ] = ACTIONS(1761),
    [anon_sym_PERCENT_EQ] = ACTIONS(1761),
    [anon_sym_PLUS_EQ] = ACTIONS(1761),
    [anon_sym_DASH_EQ] = ACTIONS(1761),
    [anon_sym_LT_LT_EQ] = ACTIONS(1761),
    [anon_sym_GT_GT_EQ] = ACTIONS(1761),
    [anon_sym_AMP_EQ] = ACTIONS(1761),
    [anon_sym_CARET_EQ] = ACTIONS(1761),
    [anon_sym_PIPE_EQ] = ACTIONS(1761),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_PIPE_PIPE] = ACTIONS(1761),
    [anon_sym_AMP_AMP] = ACTIONS(1761),
    [anon_sym_PIPE] = ACTIONS(1763),
    [anon_sym_CARET] = ACTIONS(1763),
    [anon_sym_EQ_EQ] = ACTIONS(1761),
    [anon_sym_BANG_EQ] = ACTIONS(1761),
    [anon_sym_LT] = ACTIONS(1763),
    [anon_sym_GT] = ACTIONS(1763),
    [anon_sym_LT_EQ] = ACTIONS(1761),
    [anon_sym_GT_EQ] = ACTIONS(1761),
    [anon_sym_LT_LT] = ACTIONS(1763),
    [anon_sym_GT_GT] = ACTIONS(1763),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_SLASH] = ACTIONS(1763),
    [anon_sym_PERCENT] = ACTIONS(1763),
    [anon_sym_DASH_DASH] = ACTIONS(1761),
    [anon_sym_PLUS_PLUS] = ACTIONS(1761),
    [anon_sym_DOT] = ACTIONS(1761),
    [anon_sym_DASH_GT] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(91),
  },
  [1682] = {
    [sym__expression] = STATE(146),
    [sym_conditional_expression] = STATE(146),
    [sym_assignment_expression] = STATE(146),
    [sym_pointer_expression] = STATE(146),
    [sym_logical_expression] = STATE(146),
    [sym_bitwise_expression] = STATE(146),
    [sym_equality_expression] = STATE(146),
    [sym_relational_expression] = STATE(146),
    [sym_shift_expression] = STATE(146),
    [sym_math_expression] = STATE(146),
    [sym_cast_expression] = STATE(146),
    [sym_sizeof_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_compound_literal_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_char_literal] = STATE(146),
    [sym_concatenated_string] = STATE(146),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(146),
    [sym_new_expression] = STATE(146),
    [sym_delete_expression] = STATE(146),
    [sym_lambda_expression] = STATE(146),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(257),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(5209),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(257),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(259),
    [sym_false] = ACTIONS(259),
    [sym_null] = ACTIONS(259),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(259),
  },
  [1683] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(5209),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_STAR_EQ] = ACTIONS(3507),
    [anon_sym_SLASH_EQ] = ACTIONS(3507),
    [anon_sym_PERCENT_EQ] = ACTIONS(3507),
    [anon_sym_PLUS_EQ] = ACTIONS(3507),
    [anon_sym_DASH_EQ] = ACTIONS(3507),
    [anon_sym_LT_LT_EQ] = ACTIONS(3507),
    [anon_sym_GT_GT_EQ] = ACTIONS(3507),
    [anon_sym_AMP_EQ] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(3507),
    [anon_sym_PIPE_EQ] = ACTIONS(3507),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_CARET] = ACTIONS(3517),
    [anon_sym_EQ_EQ] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3521),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3525),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1684] = {
    [sym_type_qualifier] = STATE(1684),
    [aux_sym_type_definition_repeat1] = STATE(1684),
    [sym_raw_string_literal] = ACTIONS(2179),
    [anon_sym_LPAREN2] = ACTIONS(2179),
    [anon_sym_STAR] = ACTIONS(2179),
    [anon_sym_LBRACK] = ACTIONS(2179),
    [anon_sym_RBRACK] = ACTIONS(2179),
    [anon_sym_const] = ACTIONS(5211),
    [anon_sym_restrict] = ACTIONS(5211),
    [anon_sym_volatile] = ACTIONS(5211),
    [anon_sym__Atomic] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5211),
    [anon_sym_explicit] = ACTIONS(5211),
    [anon_sym_constexpr] = ACTIONS(5211),
    [anon_sym_AMP] = ACTIONS(2179),
    [anon_sym_BANG] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2179),
    [anon_sym_PLUS] = ACTIONS(2177),
    [anon_sym_DASH] = ACTIONS(2177),
    [anon_sym_DASH_DASH] = ACTIONS(2179),
    [anon_sym_PLUS_PLUS] = ACTIONS(2179),
    [anon_sym_sizeof] = ACTIONS(2177),
    [sym_number_literal] = ACTIONS(2179),
    [anon_sym_SQUOTE] = ACTIONS(2179),
    [anon_sym_DQUOTE] = ACTIONS(2179),
    [sym_true] = ACTIONS(2177),
    [sym_false] = ACTIONS(2177),
    [sym_null] = ACTIONS(2177),
    [sym_identifier] = ACTIONS(2177),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(2177),
    [anon_sym_new] = ACTIONS(2177),
    [anon_sym_COLON_COLON] = ACTIONS(2179),
    [sym_nullptr] = ACTIONS(2177),
  },
  [1685] = {
    [sym_enumerator_list] = STATE(421),
    [anon_sym_LBRACE] = ACTIONS(746),
    [sym_identifier] = ACTIONS(5214),
    [sym_comment] = ACTIONS(91),
  },
  [1686] = {
    [sym_field_declaration_list] = STATE(424),
    [sym_virtual_specifier] = STATE(425),
    [sym_base_class_clause] = STATE(426),
    [sym_template_type] = STATE(2388),
    [sym_scoped_type_identifier] = STATE(2389),
    [sym_scoped_namespace_identifier] = STATE(83),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(5216),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [1687] = {
    [sym_field_declaration_list] = STATE(430),
    [sym_virtual_specifier] = STATE(431),
    [sym_base_class_clause] = STATE(432),
    [sym_template_type] = STATE(2391),
    [sym_scoped_type_identifier] = STATE(2392),
    [sym_scoped_namespace_identifier] = STATE(83),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(5218),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [1688] = {
    [sym_field_declaration_list] = STATE(439),
    [sym_virtual_specifier] = STATE(440),
    [sym_base_class_clause] = STATE(441),
    [sym_template_type] = STATE(2394),
    [sym_scoped_type_identifier] = STATE(2395),
    [sym_scoped_namespace_identifier] = STATE(83),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(5220),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [1689] = {
    [sym__type_specifier] = STATE(444),
    [sym_sized_type_specifier] = STATE(444),
    [sym_enum_specifier] = STATE(444),
    [sym_struct_specifier] = STATE(444),
    [sym_union_specifier] = STATE(444),
    [sym_macro_type_specifier] = STATE(444),
    [sym_class_specifier] = STATE(444),
    [sym_dependent_type] = STATE(444),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(1691),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1692),
    [anon_sym_unsigned] = ACTIONS(3535),
    [anon_sym_long] = ACTIONS(3535),
    [anon_sym_short] = ACTIONS(3535),
    [sym_primitive_type] = ACTIONS(762),
    [anon_sym_enum] = ACTIONS(3539),
    [anon_sym_struct] = ACTIONS(3541),
    [anon_sym_union] = ACTIONS(3543),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3545),
    [sym_auto] = ACTIONS(762),
    [anon_sym_typename] = ACTIONS(3547),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [1690] = {
    [sym__abstract_declarator] = STATE(2398),
    [sym_abstract_pointer_declarator] = STATE(2398),
    [sym_abstract_function_declarator] = STATE(2398),
    [sym_abstract_array_declarator] = STATE(2398),
    [sym_parameter_list] = STATE(2399),
    [sym_abstract_reference_declarator] = STATE(2398),
    [anon_sym_LBRACE] = ACTIONS(5222),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(5224),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_EQ] = ACTIONS(5222),
    [anon_sym_const] = ACTIONS(5226),
    [anon_sym_restrict] = ACTIONS(5222),
    [anon_sym_volatile] = ACTIONS(5222),
    [anon_sym__Atomic] = ACTIONS(5222),
    [anon_sym_mutable] = ACTIONS(5222),
    [anon_sym_explicit] = ACTIONS(5222),
    [anon_sym_constexpr] = ACTIONS(5222),
    [anon_sym_COLON] = ACTIONS(5222),
    [anon_sym_AMP] = ACTIONS(5228),
    [anon_sym_AMP_AMP] = ACTIONS(5230),
    [anon_sym_DASH_GT] = ACTIONS(5222),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5222),
    [anon_sym_override] = ACTIONS(5222),
    [sym_noexcept] = ACTIONS(5222),
  },
  [1691] = {
    [sym_template_argument_list] = STATE(362),
    [anon_sym_COMMA] = ACTIONS(624),
    [anon_sym_SEMI] = ACTIONS(624),
    [anon_sym_LBRACE] = ACTIONS(624),
    [anon_sym_LPAREN2] = ACTIONS(624),
    [anon_sym_STAR] = ACTIONS(624),
    [anon_sym_LBRACK] = ACTIONS(624),
    [anon_sym_EQ] = ACTIONS(624),
    [anon_sym_const] = ACTIONS(626),
    [anon_sym_restrict] = ACTIONS(624),
    [anon_sym_volatile] = ACTIONS(624),
    [anon_sym__Atomic] = ACTIONS(624),
    [anon_sym_mutable] = ACTIONS(624),
    [anon_sym_explicit] = ACTIONS(624),
    [anon_sym_constexpr] = ACTIONS(624),
    [anon_sym_COLON] = ACTIONS(624),
    [anon_sym_AMP] = ACTIONS(626),
    [anon_sym_AMP_AMP] = ACTIONS(624),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_DASH_GT] = ACTIONS(624),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(624),
    [anon_sym_override] = ACTIONS(624),
    [sym_noexcept] = ACTIONS(624),
  },
  [1692] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2400),
    [anon_sym_LBRACE] = ACTIONS(653),
    [anon_sym_LPAREN2] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_EQ] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(655),
    [anon_sym_restrict] = ACTIONS(655),
    [anon_sym_volatile] = ACTIONS(655),
    [anon_sym__Atomic] = ACTIONS(655),
    [anon_sym_mutable] = ACTIONS(655),
    [anon_sym_explicit] = ACTIONS(655),
    [anon_sym_constexpr] = ACTIONS(655),
    [anon_sym_unsigned] = ACTIONS(5232),
    [anon_sym_long] = ACTIONS(5232),
    [anon_sym_short] = ACTIONS(5232),
    [sym_primitive_type] = ACTIONS(778),
    [anon_sym_COLON] = ACTIONS(653),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [anon_sym_DASH_GT] = ACTIONS(653),
    [sym_identifier] = ACTIONS(5234),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(655),
    [anon_sym_override] = ACTIONS(655),
    [sym_noexcept] = ACTIONS(655),
  },
  [1693] = {
    [sym_type_qualifier] = STATE(1693),
    [sym_virtual_specifier] = STATE(1693),
    [sym_trailing_return_type] = STATE(1693),
    [aux_sym_function_declarator_repeat1] = STATE(1693),
    [anon_sym_LBRACE] = ACTIONS(5236),
    [anon_sym_LPAREN2] = ACTIONS(5236),
    [anon_sym_LBRACK] = ACTIONS(5236),
    [anon_sym_EQ] = ACTIONS(5236),
    [anon_sym_const] = ACTIONS(5238),
    [anon_sym_restrict] = ACTIONS(5241),
    [anon_sym_volatile] = ACTIONS(5241),
    [anon_sym__Atomic] = ACTIONS(5241),
    [anon_sym_mutable] = ACTIONS(5241),
    [anon_sym_explicit] = ACTIONS(5241),
    [anon_sym_constexpr] = ACTIONS(5241),
    [anon_sym_COLON] = ACTIONS(5236),
    [anon_sym_DASH_GT] = ACTIONS(5244),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5247),
    [anon_sym_override] = ACTIONS(5247),
    [sym_noexcept] = ACTIONS(5250),
  },
  [1694] = {
    [sym_raw_string_literal] = ACTIONS(5253),
    [ts_builtin_sym_end] = ACTIONS(5253),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5255),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5255),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5255),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5255),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5255),
    [sym_preproc_directive] = ACTIONS(5255),
    [anon_sym_SEMI] = ACTIONS(5253),
    [anon_sym_typedef] = ACTIONS(5255),
    [anon_sym_extern] = ACTIONS(5255),
    [anon_sym_LBRACE] = ACTIONS(5253),
    [anon_sym_RBRACE] = ACTIONS(5253),
    [anon_sym_LPAREN2] = ACTIONS(5253),
    [anon_sym_STAR] = ACTIONS(5253),
    [anon_sym_LBRACK] = ACTIONS(5253),
    [anon_sym_static] = ACTIONS(5255),
    [anon_sym_register] = ACTIONS(5255),
    [anon_sym_inline] = ACTIONS(5255),
    [anon_sym_const] = ACTIONS(5255),
    [anon_sym_restrict] = ACTIONS(5255),
    [anon_sym_volatile] = ACTIONS(5255),
    [anon_sym__Atomic] = ACTIONS(5255),
    [anon_sym_mutable] = ACTIONS(5255),
    [anon_sym_explicit] = ACTIONS(5255),
    [anon_sym_constexpr] = ACTIONS(5255),
    [anon_sym_unsigned] = ACTIONS(5255),
    [anon_sym_long] = ACTIONS(5255),
    [anon_sym_short] = ACTIONS(5255),
    [sym_primitive_type] = ACTIONS(5255),
    [anon_sym_enum] = ACTIONS(5255),
    [anon_sym_struct] = ACTIONS(5255),
    [anon_sym_union] = ACTIONS(5255),
    [anon_sym_if] = ACTIONS(5255),
    [anon_sym_switch] = ACTIONS(5255),
    [anon_sym_case] = ACTIONS(5255),
    [anon_sym_default] = ACTIONS(5255),
    [anon_sym_while] = ACTIONS(5255),
    [anon_sym_do] = ACTIONS(5255),
    [anon_sym_for] = ACTIONS(5255),
    [anon_sym_return] = ACTIONS(5255),
    [anon_sym_break] = ACTIONS(5255),
    [anon_sym_continue] = ACTIONS(5255),
    [anon_sym_goto] = ACTIONS(5255),
    [anon_sym_AMP] = ACTIONS(5255),
    [anon_sym_AMP_AMP] = ACTIONS(5253),
    [anon_sym_BANG] = ACTIONS(5253),
    [anon_sym_TILDE] = ACTIONS(5253),
    [anon_sym_PLUS] = ACTIONS(5255),
    [anon_sym_DASH] = ACTIONS(5255),
    [anon_sym_DASH_DASH] = ACTIONS(5253),
    [anon_sym_PLUS_PLUS] = ACTIONS(5253),
    [anon_sym_sizeof] = ACTIONS(5255),
    [sym_number_literal] = ACTIONS(5253),
    [anon_sym_SQUOTE] = ACTIONS(5253),
    [anon_sym_DQUOTE] = ACTIONS(5253),
    [sym_true] = ACTIONS(5255),
    [sym_false] = ACTIONS(5255),
    [sym_null] = ACTIONS(5255),
    [sym_identifier] = ACTIONS(5255),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5255),
    [sym_auto] = ACTIONS(5255),
    [anon_sym_typename] = ACTIONS(5255),
    [anon_sym_template] = ACTIONS(5255),
    [anon_sym_delete] = ACTIONS(5255),
    [anon_sym_namespace] = ACTIONS(5255),
    [anon_sym_using] = ACTIONS(5255),
    [anon_sym_try] = ACTIONS(5255),
    [anon_sym_new] = ACTIONS(5255),
    [anon_sym_COLON_COLON] = ACTIONS(5253),
    [sym_operator_name] = ACTIONS(5253),
    [sym_nullptr] = ACTIONS(5255),
  },
  [1695] = {
    [sym_raw_string_literal] = ACTIONS(5257),
    [ts_builtin_sym_end] = ACTIONS(5257),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5259),
    [sym_preproc_directive] = ACTIONS(5259),
    [anon_sym_SEMI] = ACTIONS(5257),
    [anon_sym_typedef] = ACTIONS(5259),
    [anon_sym_extern] = ACTIONS(5259),
    [anon_sym_LBRACE] = ACTIONS(5257),
    [anon_sym_RBRACE] = ACTIONS(5257),
    [anon_sym_LPAREN2] = ACTIONS(5257),
    [anon_sym_STAR] = ACTIONS(5257),
    [anon_sym_LBRACK] = ACTIONS(5257),
    [anon_sym_static] = ACTIONS(5259),
    [anon_sym_register] = ACTIONS(5259),
    [anon_sym_inline] = ACTIONS(5259),
    [anon_sym_const] = ACTIONS(5259),
    [anon_sym_restrict] = ACTIONS(5259),
    [anon_sym_volatile] = ACTIONS(5259),
    [anon_sym__Atomic] = ACTIONS(5259),
    [anon_sym_mutable] = ACTIONS(5259),
    [anon_sym_explicit] = ACTIONS(5259),
    [anon_sym_constexpr] = ACTIONS(5259),
    [anon_sym_unsigned] = ACTIONS(5259),
    [anon_sym_long] = ACTIONS(5259),
    [anon_sym_short] = ACTIONS(5259),
    [sym_primitive_type] = ACTIONS(5259),
    [anon_sym_enum] = ACTIONS(5259),
    [anon_sym_struct] = ACTIONS(5259),
    [anon_sym_union] = ACTIONS(5259),
    [anon_sym_if] = ACTIONS(5259),
    [anon_sym_switch] = ACTIONS(5259),
    [anon_sym_case] = ACTIONS(5259),
    [anon_sym_default] = ACTIONS(5259),
    [anon_sym_while] = ACTIONS(5259),
    [anon_sym_do] = ACTIONS(5259),
    [anon_sym_for] = ACTIONS(5259),
    [anon_sym_return] = ACTIONS(5259),
    [anon_sym_break] = ACTIONS(5259),
    [anon_sym_continue] = ACTIONS(5259),
    [anon_sym_goto] = ACTIONS(5259),
    [anon_sym_AMP] = ACTIONS(5259),
    [anon_sym_AMP_AMP] = ACTIONS(5257),
    [anon_sym_BANG] = ACTIONS(5257),
    [anon_sym_TILDE] = ACTIONS(5257),
    [anon_sym_PLUS] = ACTIONS(5259),
    [anon_sym_DASH] = ACTIONS(5259),
    [anon_sym_DASH_DASH] = ACTIONS(5257),
    [anon_sym_PLUS_PLUS] = ACTIONS(5257),
    [anon_sym_sizeof] = ACTIONS(5259),
    [sym_number_literal] = ACTIONS(5257),
    [anon_sym_SQUOTE] = ACTIONS(5257),
    [anon_sym_DQUOTE] = ACTIONS(5257),
    [sym_true] = ACTIONS(5259),
    [sym_false] = ACTIONS(5259),
    [sym_null] = ACTIONS(5259),
    [sym_identifier] = ACTIONS(5259),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5259),
    [sym_auto] = ACTIONS(5259),
    [anon_sym_typename] = ACTIONS(5259),
    [anon_sym_template] = ACTIONS(5259),
    [anon_sym_delete] = ACTIONS(5259),
    [anon_sym_namespace] = ACTIONS(5259),
    [anon_sym_using] = ACTIONS(5259),
    [anon_sym_try] = ACTIONS(5259),
    [anon_sym_new] = ACTIONS(5259),
    [anon_sym_COLON_COLON] = ACTIONS(5257),
    [sym_operator_name] = ACTIONS(5257),
    [sym_nullptr] = ACTIONS(5259),
  },
  [1696] = {
    [sym_destructor_name] = STATE(2402),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(5261),
    [sym_comment] = ACTIONS(91),
    [sym_operator_name] = ACTIONS(5263),
  },
  [1697] = {
    [anon_sym_COMMA] = ACTIONS(5265),
    [anon_sym_LBRACE] = ACTIONS(5265),
    [anon_sym_EQ] = ACTIONS(5265),
    [sym_comment] = ACTIONS(91),
  },
  [1698] = {
    [anon_sym_LBRACE] = ACTIONS(5267),
    [anon_sym_LPAREN2] = ACTIONS(5267),
    [anon_sym_LT] = ACTIONS(1582),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
  },
  [1699] = {
    [anon_sym_LBRACE] = ACTIONS(5269),
    [anon_sym_LPAREN2] = ACTIONS(5269),
    [anon_sym_LT] = ACTIONS(5269),
    [sym_comment] = ACTIONS(91),
  },
  [1700] = {
    [sym_field_initializer] = STATE(2403),
    [sym_template_type] = STATE(932),
    [sym_scoped_field_identifier] = STATE(933),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(932),
    [sym_identifier] = ACTIONS(1681),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
  },
  [1701] = {
    [aux_sym_field_initializer_list_repeat1] = STATE(2404),
    [anon_sym_COMMA] = ACTIONS(3563),
    [anon_sym_LBRACE] = ACTIONS(5271),
    [anon_sym_EQ] = ACTIONS(5271),
    [sym_comment] = ACTIONS(91),
  },
  [1702] = {
    [sym_destructor_name] = STATE(2406),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(5273),
    [sym_comment] = ACTIONS(91),
    [sym_operator_name] = ACTIONS(5275),
  },
  [1703] = {
    [anon_sym_COMMA] = ACTIONS(5277),
    [anon_sym_LBRACE] = ACTIONS(5277),
    [anon_sym_EQ] = ACTIONS(5277),
    [sym_comment] = ACTIONS(91),
  },
  [1704] = {
    [anon_sym_COMMA] = ACTIONS(5279),
    [anon_sym_RPAREN] = ACTIONS(5279),
    [anon_sym_SEMI] = ACTIONS(5279),
    [anon_sym_RBRACE] = ACTIONS(5279),
    [anon_sym_LPAREN2] = ACTIONS(5279),
    [anon_sym_STAR] = ACTIONS(5281),
    [anon_sym_LBRACK] = ACTIONS(5279),
    [anon_sym_RBRACK] = ACTIONS(5279),
    [anon_sym_EQ] = ACTIONS(5281),
    [anon_sym_COLON] = ACTIONS(5279),
    [anon_sym_QMARK] = ACTIONS(5279),
    [anon_sym_STAR_EQ] = ACTIONS(5279),
    [anon_sym_SLASH_EQ] = ACTIONS(5279),
    [anon_sym_PERCENT_EQ] = ACTIONS(5279),
    [anon_sym_PLUS_EQ] = ACTIONS(5279),
    [anon_sym_DASH_EQ] = ACTIONS(5279),
    [anon_sym_LT_LT_EQ] = ACTIONS(5279),
    [anon_sym_GT_GT_EQ] = ACTIONS(5279),
    [anon_sym_AMP_EQ] = ACTIONS(5279),
    [anon_sym_CARET_EQ] = ACTIONS(5279),
    [anon_sym_PIPE_EQ] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5279),
    [anon_sym_AMP_AMP] = ACTIONS(5279),
    [anon_sym_PIPE] = ACTIONS(5281),
    [anon_sym_CARET] = ACTIONS(5281),
    [anon_sym_EQ_EQ] = ACTIONS(5279),
    [anon_sym_BANG_EQ] = ACTIONS(5279),
    [anon_sym_LT] = ACTIONS(5281),
    [anon_sym_GT] = ACTIONS(5281),
    [anon_sym_LT_EQ] = ACTIONS(5279),
    [anon_sym_GT_EQ] = ACTIONS(5279),
    [anon_sym_LT_LT] = ACTIONS(5281),
    [anon_sym_GT_GT] = ACTIONS(5281),
    [anon_sym_PLUS] = ACTIONS(5281),
    [anon_sym_DASH] = ACTIONS(5281),
    [anon_sym_SLASH] = ACTIONS(5281),
    [anon_sym_PERCENT] = ACTIONS(5281),
    [anon_sym_DASH_DASH] = ACTIONS(5279),
    [anon_sym_PLUS_PLUS] = ACTIONS(5279),
    [anon_sym_DOT] = ACTIONS(5279),
    [anon_sym_DASH_GT] = ACTIONS(5279),
    [sym_comment] = ACTIONS(91),
  },
  [1705] = {
    [sym__expression] = STATE(2407),
    [sym_conditional_expression] = STATE(2407),
    [sym_assignment_expression] = STATE(2407),
    [sym_pointer_expression] = STATE(2407),
    [sym_logical_expression] = STATE(2407),
    [sym_bitwise_expression] = STATE(2407),
    [sym_equality_expression] = STATE(2407),
    [sym_relational_expression] = STATE(2407),
    [sym_shift_expression] = STATE(2407),
    [sym_math_expression] = STATE(2407),
    [sym_cast_expression] = STATE(2407),
    [sym_sizeof_expression] = STATE(2407),
    [sym_subscript_expression] = STATE(2407),
    [sym_call_expression] = STATE(2407),
    [sym_field_expression] = STATE(2407),
    [sym_compound_literal_expression] = STATE(2407),
    [sym_parenthesized_expression] = STATE(2407),
    [sym_char_literal] = STATE(2407),
    [sym_concatenated_string] = STATE(2407),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2407),
    [sym_new_expression] = STATE(2407),
    [sym_delete_expression] = STATE(2407),
    [sym_lambda_expression] = STATE(2407),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5283),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5283),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(5285),
    [sym_false] = ACTIONS(5285),
    [sym_null] = ACTIONS(5285),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(5285),
  },
  [1706] = {
    [sym_destructor_name] = STATE(2402),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(5287),
    [sym_comment] = ACTIONS(91),
    [sym_operator_name] = ACTIONS(5263),
  },
  [1707] = {
    [anon_sym_COMMA] = ACTIONS(5289),
    [anon_sym_RPAREN] = ACTIONS(5289),
    [anon_sym_SEMI] = ACTIONS(5289),
    [anon_sym_LBRACE] = ACTIONS(5289),
    [anon_sym_RBRACE] = ACTIONS(5289),
    [anon_sym_LPAREN2] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_LBRACK] = ACTIONS(5289),
    [anon_sym_RBRACK] = ACTIONS(5289),
    [anon_sym_EQ] = ACTIONS(5291),
    [anon_sym_COLON] = ACTIONS(5291),
    [anon_sym_QMARK] = ACTIONS(5289),
    [anon_sym_STAR_EQ] = ACTIONS(5289),
    [anon_sym_SLASH_EQ] = ACTIONS(5289),
    [anon_sym_PERCENT_EQ] = ACTIONS(5289),
    [anon_sym_PLUS_EQ] = ACTIONS(5289),
    [anon_sym_DASH_EQ] = ACTIONS(5289),
    [anon_sym_LT_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT_GT_EQ] = ACTIONS(5289),
    [anon_sym_AMP_EQ] = ACTIONS(5289),
    [anon_sym_CARET_EQ] = ACTIONS(5289),
    [anon_sym_PIPE_EQ] = ACTIONS(5289),
    [anon_sym_AMP] = ACTIONS(5291),
    [anon_sym_PIPE_PIPE] = ACTIONS(5289),
    [anon_sym_AMP_AMP] = ACTIONS(5289),
    [anon_sym_PIPE] = ACTIONS(5291),
    [anon_sym_CARET] = ACTIONS(5291),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_LT] = ACTIONS(5291),
    [anon_sym_GT] = ACTIONS(5291),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_LT_LT] = ACTIONS(5291),
    [anon_sym_GT_GT] = ACTIONS(5291),
    [anon_sym_PLUS] = ACTIONS(5291),
    [anon_sym_DASH] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5291),
    [anon_sym_PERCENT] = ACTIONS(5291),
    [anon_sym_DASH_DASH] = ACTIONS(5289),
    [anon_sym_PLUS_PLUS] = ACTIONS(5289),
    [anon_sym_DOT] = ACTIONS(5289),
    [anon_sym_DASH_GT] = ACTIONS(5289),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1431),
  },
  [1708] = {
    [anon_sym_LT] = ACTIONS(5293),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
  },
  [1709] = {
    [sym_destructor_name] = STATE(2406),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(5296),
    [sym_comment] = ACTIONS(91),
    [sym_operator_name] = ACTIONS(5275),
  },
  [1710] = {
    [anon_sym_COMMA] = ACTIONS(5298),
    [anon_sym_RPAREN] = ACTIONS(5298),
    [anon_sym_SEMI] = ACTIONS(5298),
    [anon_sym_LBRACE] = ACTIONS(5298),
    [anon_sym_RBRACE] = ACTIONS(5298),
    [anon_sym_LPAREN2] = ACTIONS(5298),
    [anon_sym_STAR] = ACTIONS(5300),
    [anon_sym_LBRACK] = ACTIONS(5298),
    [anon_sym_RBRACK] = ACTIONS(5298),
    [anon_sym_EQ] = ACTIONS(5300),
    [anon_sym_COLON] = ACTIONS(5298),
    [anon_sym_QMARK] = ACTIONS(5298),
    [anon_sym_STAR_EQ] = ACTIONS(5298),
    [anon_sym_SLASH_EQ] = ACTIONS(5298),
    [anon_sym_PERCENT_EQ] = ACTIONS(5298),
    [anon_sym_PLUS_EQ] = ACTIONS(5298),
    [anon_sym_DASH_EQ] = ACTIONS(5298),
    [anon_sym_LT_LT_EQ] = ACTIONS(5298),
    [anon_sym_GT_GT_EQ] = ACTIONS(5298),
    [anon_sym_AMP_EQ] = ACTIONS(5298),
    [anon_sym_CARET_EQ] = ACTIONS(5298),
    [anon_sym_PIPE_EQ] = ACTIONS(5298),
    [anon_sym_AMP] = ACTIONS(5300),
    [anon_sym_PIPE_PIPE] = ACTIONS(5298),
    [anon_sym_AMP_AMP] = ACTIONS(5298),
    [anon_sym_PIPE] = ACTIONS(5300),
    [anon_sym_CARET] = ACTIONS(5300),
    [anon_sym_EQ_EQ] = ACTIONS(5298),
    [anon_sym_BANG_EQ] = ACTIONS(5298),
    [anon_sym_LT] = ACTIONS(5300),
    [anon_sym_GT] = ACTIONS(5300),
    [anon_sym_LT_EQ] = ACTIONS(5298),
    [anon_sym_GT_EQ] = ACTIONS(5298),
    [anon_sym_LT_LT] = ACTIONS(5300),
    [anon_sym_GT_GT] = ACTIONS(5300),
    [anon_sym_PLUS] = ACTIONS(5300),
    [anon_sym_DASH] = ACTIONS(5300),
    [anon_sym_SLASH] = ACTIONS(5300),
    [anon_sym_PERCENT] = ACTIONS(5300),
    [anon_sym_DASH_DASH] = ACTIONS(5298),
    [anon_sym_PLUS_PLUS] = ACTIONS(5298),
    [anon_sym_DOT] = ACTIONS(5298),
    [anon_sym_DASH_GT] = ACTIONS(5298),
    [sym_comment] = ACTIONS(91),
  },
  [1711] = {
    [anon_sym_COMMA] = ACTIONS(5302),
    [anon_sym_RPAREN] = ACTIONS(5302),
    [anon_sym_SEMI] = ACTIONS(5302),
    [anon_sym_LBRACE] = ACTIONS(5302),
    [anon_sym_LPAREN2] = ACTIONS(5302),
    [anon_sym_LBRACK] = ACTIONS(5302),
    [anon_sym_EQ] = ACTIONS(5302),
    [anon_sym_const] = ACTIONS(5304),
    [anon_sym_restrict] = ACTIONS(5302),
    [anon_sym_volatile] = ACTIONS(5302),
    [anon_sym__Atomic] = ACTIONS(5302),
    [anon_sym_mutable] = ACTIONS(5302),
    [anon_sym_explicit] = ACTIONS(5302),
    [anon_sym_constexpr] = ACTIONS(5302),
    [anon_sym_COLON] = ACTIONS(5302),
    [anon_sym_DASH_GT] = ACTIONS(5302),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5302),
    [anon_sym_override] = ACTIONS(5302),
    [anon_sym_GT2] = ACTIONS(5302),
    [sym_noexcept] = ACTIONS(5302),
  },
  [1712] = {
    [sym_type_qualifier] = STATE(2410),
    [sym_trailing_return_type] = STATE(1720),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2410),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(3647),
    [sym_comment] = ACTIONS(91),
    [sym_noexcept] = ACTIONS(5306),
  },
  [1713] = {
    [sym__type_specifier] = STATE(2412),
    [sym_sized_type_specifier] = STATE(2412),
    [sym_enum_specifier] = STATE(2412),
    [sym_struct_specifier] = STATE(2412),
    [sym_union_specifier] = STATE(2412),
    [sym_macro_type_specifier] = STATE(2412),
    [sym_class_specifier] = STATE(2412),
    [sym_dependent_type] = STATE(2412),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2413),
    [anon_sym_unsigned] = ACTIONS(5308),
    [anon_sym_long] = ACTIONS(5308),
    [anon_sym_short] = ACTIONS(5308),
    [sym_primitive_type] = ACTIONS(5310),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(5310),
    [anon_sym_typename] = ACTIONS(5312),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [1714] = {
    [sym_type_qualifier] = STATE(2414),
    [sym_trailing_return_type] = STATE(1720),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2414),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(3647),
    [sym_comment] = ACTIONS(91),
    [sym_noexcept] = ACTIONS(5314),
  },
  [1715] = {
    [sym_type_qualifier] = STATE(1715),
    [aux_sym_type_definition_repeat1] = STATE(1715),
    [anon_sym_LPAREN2] = ACTIONS(2179),
    [anon_sym_STAR] = ACTIONS(2179),
    [anon_sym_LBRACK] = ACTIONS(2179),
    [anon_sym_const] = ACTIONS(2538),
    [anon_sym_restrict] = ACTIONS(5316),
    [anon_sym_volatile] = ACTIONS(5316),
    [anon_sym__Atomic] = ACTIONS(5316),
    [anon_sym_mutable] = ACTIONS(5316),
    [anon_sym_explicit] = ACTIONS(5316),
    [anon_sym_constexpr] = ACTIONS(5316),
    [anon_sym_AMP] = ACTIONS(2177),
    [anon_sym_AMP_AMP] = ACTIONS(2179),
    [sym_comment] = ACTIONS(91),
  },
  [1716] = {
    [anon_sym_COMMA] = ACTIONS(5319),
    [anon_sym_RPAREN] = ACTIONS(5319),
    [anon_sym_SEMI] = ACTIONS(5319),
    [anon_sym_LBRACE] = ACTIONS(5319),
    [anon_sym_LPAREN2] = ACTIONS(5319),
    [anon_sym_LBRACK] = ACTIONS(5319),
    [anon_sym_EQ] = ACTIONS(5319),
    [anon_sym_const] = ACTIONS(5321),
    [anon_sym_restrict] = ACTIONS(5319),
    [anon_sym_volatile] = ACTIONS(5319),
    [anon_sym__Atomic] = ACTIONS(5319),
    [anon_sym_mutable] = ACTIONS(5319),
    [anon_sym_explicit] = ACTIONS(5319),
    [anon_sym_constexpr] = ACTIONS(5319),
    [anon_sym_COLON] = ACTIONS(5319),
    [anon_sym_DASH_GT] = ACTIONS(5319),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5319),
    [anon_sym_override] = ACTIONS(5319),
    [anon_sym_GT2] = ACTIONS(5319),
    [sym_noexcept] = ACTIONS(5319),
  },
  [1717] = {
    [sym__expression] = STATE(146),
    [sym_conditional_expression] = STATE(146),
    [sym_assignment_expression] = STATE(146),
    [sym_pointer_expression] = STATE(146),
    [sym_logical_expression] = STATE(146),
    [sym_bitwise_expression] = STATE(146),
    [sym_equality_expression] = STATE(146),
    [sym_relational_expression] = STATE(146),
    [sym_shift_expression] = STATE(146),
    [sym_math_expression] = STATE(146),
    [sym_cast_expression] = STATE(146),
    [sym_sizeof_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_compound_literal_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_char_literal] = STATE(146),
    [sym_concatenated_string] = STATE(146),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(146),
    [sym_new_expression] = STATE(146),
    [sym_delete_expression] = STATE(146),
    [sym_lambda_expression] = STATE(146),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(257),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(5323),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(257),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(259),
    [sym_false] = ACTIONS(259),
    [sym_null] = ACTIONS(259),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(259),
  },
  [1718] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(5323),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_STAR_EQ] = ACTIONS(3507),
    [anon_sym_SLASH_EQ] = ACTIONS(3507),
    [anon_sym_PERCENT_EQ] = ACTIONS(3507),
    [anon_sym_PLUS_EQ] = ACTIONS(3507),
    [anon_sym_DASH_EQ] = ACTIONS(3507),
    [anon_sym_LT_LT_EQ] = ACTIONS(3507),
    [anon_sym_GT_GT_EQ] = ACTIONS(3507),
    [anon_sym_AMP_EQ] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(3507),
    [anon_sym_PIPE_EQ] = ACTIONS(3507),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_CARET] = ACTIONS(3517),
    [anon_sym_EQ_EQ] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3521),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3525),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1719] = {
    [sym_type_qualifier] = STATE(1684),
    [sym__expression] = STATE(2417),
    [sym_conditional_expression] = STATE(2417),
    [sym_assignment_expression] = STATE(2417),
    [sym_pointer_expression] = STATE(2417),
    [sym_logical_expression] = STATE(2417),
    [sym_bitwise_expression] = STATE(2417),
    [sym_equality_expression] = STATE(2417),
    [sym_relational_expression] = STATE(2417),
    [sym_shift_expression] = STATE(2417),
    [sym_math_expression] = STATE(2417),
    [sym_cast_expression] = STATE(2417),
    [sym_sizeof_expression] = STATE(2417),
    [sym_subscript_expression] = STATE(2417),
    [sym_call_expression] = STATE(2417),
    [sym_field_expression] = STATE(2417),
    [sym_compound_literal_expression] = STATE(2417),
    [sym_parenthesized_expression] = STATE(2417),
    [sym_char_literal] = STATE(2417),
    [sym_concatenated_string] = STATE(2417),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2417),
    [sym_new_expression] = STATE(2417),
    [sym_delete_expression] = STATE(2417),
    [sym_lambda_expression] = STATE(2417),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [aux_sym_type_definition_repeat1] = STATE(1684),
    [sym_raw_string_literal] = ACTIONS(5325),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(5327),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(5323),
    [anon_sym_const] = ACTIONS(1643),
    [anon_sym_restrict] = ACTIONS(1643),
    [anon_sym_volatile] = ACTIONS(1643),
    [anon_sym__Atomic] = ACTIONS(1643),
    [anon_sym_mutable] = ACTIONS(1643),
    [anon_sym_explicit] = ACTIONS(1643),
    [anon_sym_constexpr] = ACTIONS(1643),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(5325),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(5329),
    [sym_false] = ACTIONS(5329),
    [sym_null] = ACTIONS(5329),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(5329),
  },
  [1720] = {
    [anon_sym_COMMA] = ACTIONS(5331),
    [anon_sym_RPAREN] = ACTIONS(5331),
    [anon_sym_SEMI] = ACTIONS(5331),
    [anon_sym_LBRACE] = ACTIONS(5331),
    [anon_sym_LPAREN2] = ACTIONS(5331),
    [anon_sym_LBRACK] = ACTIONS(5331),
    [anon_sym_EQ] = ACTIONS(5331),
    [anon_sym_const] = ACTIONS(5333),
    [anon_sym_restrict] = ACTIONS(5331),
    [anon_sym_volatile] = ACTIONS(5331),
    [anon_sym__Atomic] = ACTIONS(5331),
    [anon_sym_mutable] = ACTIONS(5331),
    [anon_sym_explicit] = ACTIONS(5331),
    [anon_sym_constexpr] = ACTIONS(5331),
    [anon_sym_COLON] = ACTIONS(5331),
    [anon_sym_DASH_GT] = ACTIONS(5331),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5331),
    [anon_sym_override] = ACTIONS(5331),
    [anon_sym_GT2] = ACTIONS(5331),
    [sym_noexcept] = ACTIONS(5331),
  },
  [1721] = {
    [sym_type_qualifier] = STATE(1729),
    [sym_trailing_return_type] = STATE(2418),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1729),
    [anon_sym_LBRACE] = ACTIONS(5331),
    [anon_sym_LPAREN2] = ACTIONS(5331),
    [anon_sym_LBRACK] = ACTIONS(5331),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(1789),
    [sym_comment] = ACTIONS(91),
    [sym_noexcept] = ACTIONS(3687),
  },
  [1722] = {
    [sym_enumerator_list] = STATE(169),
    [anon_sym_LBRACE] = ACTIONS(303),
    [sym_identifier] = ACTIONS(5335),
    [sym_comment] = ACTIONS(91),
  },
  [1723] = {
    [sym_field_declaration_list] = STATE(175),
    [sym_virtual_specifier] = STATE(176),
    [sym_base_class_clause] = STATE(177),
    [sym_template_type] = STATE(2421),
    [sym_scoped_type_identifier] = STATE(2422),
    [sym_scoped_namespace_identifier] = STATE(83),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(5337),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [1724] = {
    [sym_field_declaration_list] = STATE(182),
    [sym_virtual_specifier] = STATE(183),
    [sym_base_class_clause] = STATE(184),
    [sym_template_type] = STATE(2424),
    [sym_scoped_type_identifier] = STATE(2425),
    [sym_scoped_namespace_identifier] = STATE(83),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(5339),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [1725] = {
    [sym_field_declaration_list] = STATE(265),
    [sym_virtual_specifier] = STATE(266),
    [sym_base_class_clause] = STATE(267),
    [sym_template_type] = STATE(2427),
    [sym_scoped_type_identifier] = STATE(2428),
    [sym_scoped_namespace_identifier] = STATE(83),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(5341),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [1726] = {
    [sym__type_specifier] = STATE(271),
    [sym_sized_type_specifier] = STATE(271),
    [sym_enum_specifier] = STATE(271),
    [sym_struct_specifier] = STATE(271),
    [sym_union_specifier] = STATE(271),
    [sym_macro_type_specifier] = STATE(271),
    [sym_class_specifier] = STATE(271),
    [sym_dependent_type] = STATE(271),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1728),
    [anon_sym_unsigned] = ACTIONS(3671),
    [anon_sym_long] = ACTIONS(3671),
    [anon_sym_short] = ACTIONS(3671),
    [sym_primitive_type] = ACTIONS(490),
    [anon_sym_enum] = ACTIONS(3675),
    [anon_sym_struct] = ACTIONS(3677),
    [anon_sym_union] = ACTIONS(3679),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3681),
    [sym_auto] = ACTIONS(490),
    [anon_sym_typename] = ACTIONS(3683),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [1727] = {
    [sym__abstract_declarator] = STATE(2431),
    [sym_abstract_pointer_declarator] = STATE(2431),
    [sym_abstract_function_declarator] = STATE(2431),
    [sym_abstract_array_declarator] = STATE(2431),
    [sym_parameter_list] = STATE(359),
    [sym_abstract_reference_declarator] = STATE(2431),
    [anon_sym_LBRACE] = ACTIONS(5222),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(5343),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_AMP] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5347),
    [sym_comment] = ACTIONS(91),
  },
  [1728] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2432),
    [anon_sym_LBRACE] = ACTIONS(653),
    [anon_sym_LPAREN2] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_unsigned] = ACTIONS(5349),
    [anon_sym_long] = ACTIONS(5349),
    [anon_sym_short] = ACTIONS(5349),
    [sym_primitive_type] = ACTIONS(659),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [sym_identifier] = ACTIONS(933),
    [sym_comment] = ACTIONS(91),
  },
  [1729] = {
    [sym_type_qualifier] = STATE(1729),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1729),
    [anon_sym_LBRACE] = ACTIONS(5351),
    [anon_sym_LPAREN2] = ACTIONS(5351),
    [anon_sym_LBRACK] = ACTIONS(5351),
    [anon_sym_const] = ACTIONS(5353),
    [anon_sym_restrict] = ACTIONS(5356),
    [anon_sym_volatile] = ACTIONS(5356),
    [anon_sym__Atomic] = ACTIONS(5356),
    [anon_sym_mutable] = ACTIONS(5356),
    [anon_sym_explicit] = ACTIONS(5356),
    [anon_sym_constexpr] = ACTIONS(5356),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [sym_comment] = ACTIONS(91),
    [sym_noexcept] = ACTIONS(5359),
  },
  [1730] = {
    [anon_sym_COMMA] = ACTIONS(4843),
    [anon_sym_RPAREN] = ACTIONS(4843),
    [anon_sym_SEMI] = ACTIONS(4843),
    [anon_sym_extern] = ACTIONS(4845),
    [anon_sym_LBRACE] = ACTIONS(4843),
    [anon_sym_LPAREN2] = ACTIONS(4843),
    [anon_sym_STAR] = ACTIONS(4843),
    [anon_sym_LBRACK] = ACTIONS(4843),
    [anon_sym_EQ] = ACTIONS(4843),
    [anon_sym_static] = ACTIONS(4845),
    [anon_sym_register] = ACTIONS(4845),
    [anon_sym_inline] = ACTIONS(4845),
    [anon_sym_const] = ACTIONS(4845),
    [anon_sym_restrict] = ACTIONS(4845),
    [anon_sym_volatile] = ACTIONS(4845),
    [anon_sym__Atomic] = ACTIONS(4845),
    [anon_sym_mutable] = ACTIONS(4845),
    [anon_sym_explicit] = ACTIONS(4845),
    [anon_sym_constexpr] = ACTIONS(4845),
    [anon_sym_COLON] = ACTIONS(4845),
    [anon_sym_AMP] = ACTIONS(4845),
    [anon_sym_AMP_AMP] = ACTIONS(4843),
    [anon_sym_TILDE] = ACTIONS(4843),
    [anon_sym_DASH_GT] = ACTIONS(4843),
    [sym_identifier] = ACTIONS(4845),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4845),
    [anon_sym_override] = ACTIONS(4845),
    [anon_sym_GT2] = ACTIONS(4843),
    [sym_noexcept] = ACTIONS(4845),
    [anon_sym_COLON_COLON] = ACTIONS(4843),
    [sym_operator_name] = ACTIONS(4843),
  },
  [1731] = {
    [aux_sym_template_argument_list_repeat1] = STATE(2235),
    [anon_sym_COMMA] = ACTIONS(3163),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(5362),
  },
  [1732] = {
    [anon_sym_COMMA] = ACTIONS(4849),
    [anon_sym_RPAREN] = ACTIONS(4849),
    [anon_sym_SEMI] = ACTIONS(4849),
    [anon_sym_extern] = ACTIONS(4851),
    [anon_sym_LBRACE] = ACTIONS(4849),
    [anon_sym_LPAREN2] = ACTIONS(4849),
    [anon_sym_STAR] = ACTIONS(4849),
    [anon_sym_LBRACK] = ACTIONS(4849),
    [anon_sym_EQ] = ACTIONS(4849),
    [anon_sym_static] = ACTIONS(4851),
    [anon_sym_register] = ACTIONS(4851),
    [anon_sym_inline] = ACTIONS(4851),
    [anon_sym_const] = ACTIONS(4851),
    [anon_sym_restrict] = ACTIONS(4851),
    [anon_sym_volatile] = ACTIONS(4851),
    [anon_sym__Atomic] = ACTIONS(4851),
    [anon_sym_mutable] = ACTIONS(4851),
    [anon_sym_explicit] = ACTIONS(4851),
    [anon_sym_constexpr] = ACTIONS(4851),
    [anon_sym_COLON] = ACTIONS(4851),
    [anon_sym_AMP] = ACTIONS(4851),
    [anon_sym_AMP_AMP] = ACTIONS(4849),
    [anon_sym_TILDE] = ACTIONS(4849),
    [anon_sym_DASH_GT] = ACTIONS(4849),
    [sym_identifier] = ACTIONS(4851),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4851),
    [anon_sym_override] = ACTIONS(4851),
    [anon_sym_GT2] = ACTIONS(4849),
    [sym_noexcept] = ACTIONS(4851),
    [anon_sym_COLON_COLON] = ACTIONS(4849),
    [sym_operator_name] = ACTIONS(4849),
  },
  [1733] = {
    [aux_sym_template_argument_list_repeat1] = STATE(2235),
    [anon_sym_COMMA] = ACTIONS(3163),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(5364),
  },
  [1734] = {
    [anon_sym_COMMA] = ACTIONS(3218),
    [anon_sym_RPAREN] = ACTIONS(3213),
    [anon_sym_SEMI] = ACTIONS(3218),
    [anon_sym_extern] = ACTIONS(3216),
    [anon_sym_LPAREN2] = ACTIONS(3213),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_LBRACK] = ACTIONS(3213),
    [anon_sym_static] = ACTIONS(3216),
    [anon_sym_register] = ACTIONS(3216),
    [anon_sym_inline] = ACTIONS(3216),
    [anon_sym_const] = ACTIONS(3216),
    [anon_sym_restrict] = ACTIONS(3216),
    [anon_sym_volatile] = ACTIONS(3216),
    [anon_sym__Atomic] = ACTIONS(3216),
    [anon_sym_mutable] = ACTIONS(3216),
    [anon_sym_explicit] = ACTIONS(3216),
    [anon_sym_constexpr] = ACTIONS(3216),
    [anon_sym_AMP] = ACTIONS(3216),
    [anon_sym_AMP_AMP] = ACTIONS(3218),
    [anon_sym_TILDE] = ACTIONS(3218),
    [anon_sym_LT] = ACTIONS(3213),
    [sym_identifier] = ACTIONS(3216),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(3225),
    [sym_operator_name] = ACTIONS(3218),
  },
  [1735] = {
    [sym_raw_string_literal] = ACTIONS(5366),
    [ts_builtin_sym_end] = ACTIONS(5366),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5368),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5368),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5368),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5368),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5368),
    [sym_preproc_directive] = ACTIONS(5368),
    [anon_sym_SEMI] = ACTIONS(5366),
    [anon_sym_typedef] = ACTIONS(5368),
    [anon_sym_extern] = ACTIONS(5368),
    [anon_sym_LBRACE] = ACTIONS(5366),
    [anon_sym_RBRACE] = ACTIONS(5366),
    [anon_sym_LPAREN2] = ACTIONS(5366),
    [anon_sym_STAR] = ACTIONS(5366),
    [anon_sym_LBRACK] = ACTIONS(5366),
    [anon_sym_static] = ACTIONS(5368),
    [anon_sym_register] = ACTIONS(5368),
    [anon_sym_inline] = ACTIONS(5368),
    [anon_sym_const] = ACTIONS(5368),
    [anon_sym_restrict] = ACTIONS(5368),
    [anon_sym_volatile] = ACTIONS(5368),
    [anon_sym__Atomic] = ACTIONS(5368),
    [anon_sym_mutable] = ACTIONS(5368),
    [anon_sym_explicit] = ACTIONS(5368),
    [anon_sym_constexpr] = ACTIONS(5368),
    [anon_sym_unsigned] = ACTIONS(5368),
    [anon_sym_long] = ACTIONS(5368),
    [anon_sym_short] = ACTIONS(5368),
    [sym_primitive_type] = ACTIONS(5368),
    [anon_sym_enum] = ACTIONS(5368),
    [anon_sym_struct] = ACTIONS(5368),
    [anon_sym_union] = ACTIONS(5368),
    [anon_sym_if] = ACTIONS(5368),
    [anon_sym_switch] = ACTIONS(5368),
    [anon_sym_case] = ACTIONS(5368),
    [anon_sym_default] = ACTIONS(5368),
    [anon_sym_while] = ACTIONS(5368),
    [anon_sym_do] = ACTIONS(5368),
    [anon_sym_for] = ACTIONS(5368),
    [anon_sym_return] = ACTIONS(5368),
    [anon_sym_break] = ACTIONS(5368),
    [anon_sym_continue] = ACTIONS(5368),
    [anon_sym_goto] = ACTIONS(5368),
    [anon_sym_AMP] = ACTIONS(5368),
    [anon_sym_AMP_AMP] = ACTIONS(5366),
    [anon_sym_BANG] = ACTIONS(5366),
    [anon_sym_TILDE] = ACTIONS(5366),
    [anon_sym_PLUS] = ACTIONS(5368),
    [anon_sym_DASH] = ACTIONS(5368),
    [anon_sym_DASH_DASH] = ACTIONS(5366),
    [anon_sym_PLUS_PLUS] = ACTIONS(5366),
    [anon_sym_sizeof] = ACTIONS(5368),
    [sym_number_literal] = ACTIONS(5366),
    [anon_sym_SQUOTE] = ACTIONS(5366),
    [anon_sym_DQUOTE] = ACTIONS(5366),
    [sym_true] = ACTIONS(5368),
    [sym_false] = ACTIONS(5368),
    [sym_null] = ACTIONS(5368),
    [sym_identifier] = ACTIONS(5368),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5368),
    [sym_auto] = ACTIONS(5368),
    [anon_sym_typename] = ACTIONS(5368),
    [anon_sym_template] = ACTIONS(5368),
    [anon_sym_delete] = ACTIONS(5368),
    [anon_sym_namespace] = ACTIONS(5368),
    [anon_sym_using] = ACTIONS(5368),
    [anon_sym_try] = ACTIONS(5368),
    [anon_sym_new] = ACTIONS(5368),
    [anon_sym_COLON_COLON] = ACTIONS(5366),
    [sym_operator_name] = ACTIONS(5366),
    [sym_nullptr] = ACTIONS(5368),
  },
  [1736] = {
    [anon_sym_COMMA] = ACTIONS(3636),
    [anon_sym_RPAREN] = ACTIONS(3631),
    [anon_sym_SEMI] = ACTIONS(3636),
    [anon_sym_extern] = ACTIONS(3634),
    [anon_sym_LPAREN2] = ACTIONS(3631),
    [anon_sym_STAR] = ACTIONS(3636),
    [anon_sym_LBRACK] = ACTIONS(3631),
    [anon_sym_static] = ACTIONS(3634),
    [anon_sym_register] = ACTIONS(3634),
    [anon_sym_inline] = ACTIONS(3634),
    [anon_sym_const] = ACTIONS(3634),
    [anon_sym_restrict] = ACTIONS(3634),
    [anon_sym_volatile] = ACTIONS(3634),
    [anon_sym__Atomic] = ACTIONS(3634),
    [anon_sym_mutable] = ACTIONS(3634),
    [anon_sym_explicit] = ACTIONS(3634),
    [anon_sym_constexpr] = ACTIONS(3634),
    [anon_sym_AMP] = ACTIONS(3634),
    [anon_sym_AMP_AMP] = ACTIONS(3636),
    [anon_sym_TILDE] = ACTIONS(3636),
    [anon_sym_LT] = ACTIONS(3631),
    [sym_identifier] = ACTIONS(3634),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(3643),
    [sym_operator_name] = ACTIONS(3636),
  },
  [1737] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5370),
    [sym_identifier] = ACTIONS(5370),
    [sym_comment] = ACTIONS(91),
  },
  [1738] = {
    [anon_sym_LF] = ACTIONS(5372),
    [sym_preproc_arg] = ACTIONS(5372),
    [sym_comment] = ACTIONS(121),
  },
  [1739] = {
    [aux_sym_preproc_params_repeat1] = STATE(2437),
    [anon_sym_COMMA] = ACTIONS(3701),
    [anon_sym_RPAREN] = ACTIONS(5374),
    [sym_comment] = ACTIONS(91),
  },
  [1740] = {
    [sym_raw_string_literal] = ACTIONS(5376),
    [ts_builtin_sym_end] = ACTIONS(5376),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5378),
    [sym_preproc_directive] = ACTIONS(5378),
    [anon_sym_SEMI] = ACTIONS(5376),
    [anon_sym_typedef] = ACTIONS(5378),
    [anon_sym_extern] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(5376),
    [anon_sym_RBRACE] = ACTIONS(5376),
    [anon_sym_LPAREN2] = ACTIONS(5376),
    [anon_sym_STAR] = ACTIONS(5376),
    [anon_sym_LBRACK] = ACTIONS(5376),
    [anon_sym_static] = ACTIONS(5378),
    [anon_sym_register] = ACTIONS(5378),
    [anon_sym_inline] = ACTIONS(5378),
    [anon_sym_const] = ACTIONS(5378),
    [anon_sym_restrict] = ACTIONS(5378),
    [anon_sym_volatile] = ACTIONS(5378),
    [anon_sym__Atomic] = ACTIONS(5378),
    [anon_sym_mutable] = ACTIONS(5378),
    [anon_sym_explicit] = ACTIONS(5378),
    [anon_sym_constexpr] = ACTIONS(5378),
    [anon_sym_unsigned] = ACTIONS(5378),
    [anon_sym_long] = ACTIONS(5378),
    [anon_sym_short] = ACTIONS(5378),
    [sym_primitive_type] = ACTIONS(5378),
    [anon_sym_enum] = ACTIONS(5378),
    [anon_sym_struct] = ACTIONS(5378),
    [anon_sym_union] = ACTIONS(5378),
    [anon_sym_if] = ACTIONS(5378),
    [anon_sym_switch] = ACTIONS(5378),
    [anon_sym_case] = ACTIONS(5378),
    [anon_sym_default] = ACTIONS(5378),
    [anon_sym_while] = ACTIONS(5378),
    [anon_sym_do] = ACTIONS(5378),
    [anon_sym_for] = ACTIONS(5378),
    [anon_sym_return] = ACTIONS(5378),
    [anon_sym_break] = ACTIONS(5378),
    [anon_sym_continue] = ACTIONS(5378),
    [anon_sym_goto] = ACTIONS(5378),
    [anon_sym_AMP] = ACTIONS(5378),
    [anon_sym_AMP_AMP] = ACTIONS(5376),
    [anon_sym_BANG] = ACTIONS(5376),
    [anon_sym_TILDE] = ACTIONS(5376),
    [anon_sym_PLUS] = ACTIONS(5378),
    [anon_sym_DASH] = ACTIONS(5378),
    [anon_sym_DASH_DASH] = ACTIONS(5376),
    [anon_sym_PLUS_PLUS] = ACTIONS(5376),
    [anon_sym_sizeof] = ACTIONS(5378),
    [sym_number_literal] = ACTIONS(5376),
    [anon_sym_SQUOTE] = ACTIONS(5376),
    [anon_sym_DQUOTE] = ACTIONS(5376),
    [sym_true] = ACTIONS(5378),
    [sym_false] = ACTIONS(5378),
    [sym_null] = ACTIONS(5378),
    [sym_identifier] = ACTIONS(5378),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5378),
    [sym_auto] = ACTIONS(5378),
    [anon_sym_typename] = ACTIONS(5378),
    [anon_sym_template] = ACTIONS(5378),
    [anon_sym_delete] = ACTIONS(5378),
    [anon_sym_namespace] = ACTIONS(5378),
    [anon_sym_using] = ACTIONS(5378),
    [anon_sym_try] = ACTIONS(5378),
    [anon_sym_new] = ACTIONS(5378),
    [anon_sym_COLON_COLON] = ACTIONS(5376),
    [sym_operator_name] = ACTIONS(5376),
    [sym_nullptr] = ACTIONS(5378),
  },
  [1741] = {
    [sym_raw_string_literal] = ACTIONS(1370),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1372),
    [sym_preproc_directive] = ACTIONS(1372),
    [anon_sym_SEMI] = ACTIONS(1370),
    [anon_sym_typedef] = ACTIONS(1372),
    [anon_sym_extern] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1370),
    [anon_sym_LPAREN2] = ACTIONS(1370),
    [anon_sym_STAR] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(1370),
    [anon_sym_static] = ACTIONS(1372),
    [anon_sym_register] = ACTIONS(1372),
    [anon_sym_inline] = ACTIONS(1372),
    [anon_sym_const] = ACTIONS(1372),
    [anon_sym_restrict] = ACTIONS(1372),
    [anon_sym_volatile] = ACTIONS(1372),
    [anon_sym__Atomic] = ACTIONS(1372),
    [anon_sym_mutable] = ACTIONS(1372),
    [anon_sym_explicit] = ACTIONS(1372),
    [anon_sym_constexpr] = ACTIONS(1372),
    [anon_sym_unsigned] = ACTIONS(1372),
    [anon_sym_long] = ACTIONS(1372),
    [anon_sym_short] = ACTIONS(1372),
    [sym_primitive_type] = ACTIONS(1372),
    [anon_sym_enum] = ACTIONS(1372),
    [anon_sym_struct] = ACTIONS(1372),
    [anon_sym_union] = ACTIONS(1372),
    [anon_sym_if] = ACTIONS(1372),
    [anon_sym_switch] = ACTIONS(1372),
    [anon_sym_case] = ACTIONS(1372),
    [anon_sym_default] = ACTIONS(1372),
    [anon_sym_while] = ACTIONS(1372),
    [anon_sym_do] = ACTIONS(1372),
    [anon_sym_for] = ACTIONS(1372),
    [anon_sym_return] = ACTIONS(1372),
    [anon_sym_break] = ACTIONS(1372),
    [anon_sym_continue] = ACTIONS(1372),
    [anon_sym_goto] = ACTIONS(1372),
    [anon_sym_AMP] = ACTIONS(1372),
    [anon_sym_AMP_AMP] = ACTIONS(1370),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_PLUS] = ACTIONS(1372),
    [anon_sym_DASH] = ACTIONS(1372),
    [anon_sym_DASH_DASH] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1370),
    [anon_sym_sizeof] = ACTIONS(1372),
    [sym_number_literal] = ACTIONS(1370),
    [anon_sym_SQUOTE] = ACTIONS(1370),
    [anon_sym_DQUOTE] = ACTIONS(1370),
    [sym_true] = ACTIONS(1372),
    [sym_false] = ACTIONS(1372),
    [sym_null] = ACTIONS(1372),
    [sym_identifier] = ACTIONS(1372),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1372),
    [sym_auto] = ACTIONS(1372),
    [anon_sym_typename] = ACTIONS(1372),
    [anon_sym_template] = ACTIONS(1372),
    [anon_sym_delete] = ACTIONS(1372),
    [anon_sym_namespace] = ACTIONS(1372),
    [anon_sym_using] = ACTIONS(1372),
    [anon_sym_try] = ACTIONS(1372),
    [anon_sym_new] = ACTIONS(1372),
    [anon_sym_COLON_COLON] = ACTIONS(1370),
    [sym_operator_name] = ACTIONS(1370),
    [sym_nullptr] = ACTIONS(1372),
  },
  [1742] = {
    [aux_sym_string_literal_repeat1] = STATE(761),
    [anon_sym_DQUOTE] = ACTIONS(5380),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_BSLASHn_RBRACK_SLASH] = ACTIONS(1376),
    [sym_escape_sequence] = ACTIONS(1376),
    [sym_comment] = ACTIONS(121),
  },
  [1743] = {
    [sym_raw_string_literal] = ACTIONS(1994),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1996),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1996),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1996),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1996),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1996),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1996),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1996),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1996),
    [sym_preproc_directive] = ACTIONS(1996),
    [anon_sym_SEMI] = ACTIONS(1994),
    [anon_sym_typedef] = ACTIONS(1996),
    [anon_sym_extern] = ACTIONS(1996),
    [anon_sym_LBRACE] = ACTIONS(1994),
    [anon_sym_LPAREN2] = ACTIONS(1994),
    [anon_sym_STAR] = ACTIONS(1994),
    [anon_sym_LBRACK] = ACTIONS(1994),
    [anon_sym_static] = ACTIONS(1996),
    [anon_sym_register] = ACTIONS(1996),
    [anon_sym_inline] = ACTIONS(1996),
    [anon_sym_const] = ACTIONS(1996),
    [anon_sym_restrict] = ACTIONS(1996),
    [anon_sym_volatile] = ACTIONS(1996),
    [anon_sym__Atomic] = ACTIONS(1996),
    [anon_sym_mutable] = ACTIONS(1996),
    [anon_sym_explicit] = ACTIONS(1996),
    [anon_sym_constexpr] = ACTIONS(1996),
    [anon_sym_unsigned] = ACTIONS(1996),
    [anon_sym_long] = ACTIONS(1996),
    [anon_sym_short] = ACTIONS(1996),
    [sym_primitive_type] = ACTIONS(1996),
    [anon_sym_enum] = ACTIONS(1996),
    [anon_sym_struct] = ACTIONS(1996),
    [anon_sym_union] = ACTIONS(1996),
    [anon_sym_if] = ACTIONS(1996),
    [anon_sym_switch] = ACTIONS(1996),
    [anon_sym_case] = ACTIONS(1996),
    [anon_sym_default] = ACTIONS(1996),
    [anon_sym_while] = ACTIONS(1996),
    [anon_sym_do] = ACTIONS(1996),
    [anon_sym_for] = ACTIONS(1996),
    [anon_sym_return] = ACTIONS(1996),
    [anon_sym_break] = ACTIONS(1996),
    [anon_sym_continue] = ACTIONS(1996),
    [anon_sym_goto] = ACTIONS(1996),
    [anon_sym_AMP] = ACTIONS(1996),
    [anon_sym_AMP_AMP] = ACTIONS(1994),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_PLUS] = ACTIONS(1996),
    [anon_sym_DASH] = ACTIONS(1996),
    [anon_sym_DASH_DASH] = ACTIONS(1994),
    [anon_sym_PLUS_PLUS] = ACTIONS(1994),
    [anon_sym_sizeof] = ACTIONS(1996),
    [sym_number_literal] = ACTIONS(1994),
    [anon_sym_SQUOTE] = ACTIONS(1994),
    [anon_sym_DQUOTE] = ACTIONS(1994),
    [sym_true] = ACTIONS(1996),
    [sym_false] = ACTIONS(1996),
    [sym_null] = ACTIONS(1996),
    [sym_identifier] = ACTIONS(1996),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1996),
    [sym_auto] = ACTIONS(1996),
    [anon_sym_typename] = ACTIONS(1996),
    [anon_sym_template] = ACTIONS(1996),
    [anon_sym_delete] = ACTIONS(1996),
    [anon_sym_namespace] = ACTIONS(1996),
    [anon_sym_using] = ACTIONS(1996),
    [anon_sym_try] = ACTIONS(1996),
    [anon_sym_new] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1994),
    [sym_operator_name] = ACTIONS(1994),
    [sym_nullptr] = ACTIONS(1996),
  },
  [1744] = {
    [anon_sym_LF] = ACTIONS(5382),
    [sym_comment] = ACTIONS(121),
  },
  [1745] = {
    [anon_sym_LF] = ACTIONS(5384),
    [sym_preproc_arg] = ACTIONS(5386),
    [sym_comment] = ACTIONS(121),
  },
  [1746] = {
    [sym_raw_string_literal] = ACTIONS(2016),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2018),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2018),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2018),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2018),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2018),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2018),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2018),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2018),
    [sym_preproc_directive] = ACTIONS(2018),
    [anon_sym_SEMI] = ACTIONS(2016),
    [anon_sym_typedef] = ACTIONS(2018),
    [anon_sym_extern] = ACTIONS(2018),
    [anon_sym_LBRACE] = ACTIONS(2016),
    [anon_sym_LPAREN2] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(2016),
    [anon_sym_LBRACK] = ACTIONS(2016),
    [anon_sym_static] = ACTIONS(2018),
    [anon_sym_register] = ACTIONS(2018),
    [anon_sym_inline] = ACTIONS(2018),
    [anon_sym_const] = ACTIONS(2018),
    [anon_sym_restrict] = ACTIONS(2018),
    [anon_sym_volatile] = ACTIONS(2018),
    [anon_sym__Atomic] = ACTIONS(2018),
    [anon_sym_mutable] = ACTIONS(2018),
    [anon_sym_explicit] = ACTIONS(2018),
    [anon_sym_constexpr] = ACTIONS(2018),
    [anon_sym_unsigned] = ACTIONS(2018),
    [anon_sym_long] = ACTIONS(2018),
    [anon_sym_short] = ACTIONS(2018),
    [sym_primitive_type] = ACTIONS(2018),
    [anon_sym_enum] = ACTIONS(2018),
    [anon_sym_struct] = ACTIONS(2018),
    [anon_sym_union] = ACTIONS(2018),
    [anon_sym_if] = ACTIONS(2018),
    [anon_sym_switch] = ACTIONS(2018),
    [anon_sym_case] = ACTIONS(2018),
    [anon_sym_default] = ACTIONS(2018),
    [anon_sym_while] = ACTIONS(2018),
    [anon_sym_do] = ACTIONS(2018),
    [anon_sym_for] = ACTIONS(2018),
    [anon_sym_return] = ACTIONS(2018),
    [anon_sym_break] = ACTIONS(2018),
    [anon_sym_continue] = ACTIONS(2018),
    [anon_sym_goto] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(2018),
    [anon_sym_AMP_AMP] = ACTIONS(2016),
    [anon_sym_BANG] = ACTIONS(2016),
    [anon_sym_TILDE] = ACTIONS(2016),
    [anon_sym_PLUS] = ACTIONS(2018),
    [anon_sym_DASH] = ACTIONS(2018),
    [anon_sym_DASH_DASH] = ACTIONS(2016),
    [anon_sym_PLUS_PLUS] = ACTIONS(2016),
    [anon_sym_sizeof] = ACTIONS(2018),
    [sym_number_literal] = ACTIONS(2016),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_DQUOTE] = ACTIONS(2016),
    [sym_true] = ACTIONS(2018),
    [sym_false] = ACTIONS(2018),
    [sym_null] = ACTIONS(2018),
    [sym_identifier] = ACTIONS(2018),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2018),
    [sym_auto] = ACTIONS(2018),
    [anon_sym_typename] = ACTIONS(2018),
    [anon_sym_template] = ACTIONS(2018),
    [anon_sym_delete] = ACTIONS(2018),
    [anon_sym_namespace] = ACTIONS(2018),
    [anon_sym_using] = ACTIONS(2018),
    [anon_sym_try] = ACTIONS(2018),
    [anon_sym_new] = ACTIONS(2018),
    [anon_sym_COLON_COLON] = ACTIONS(2016),
    [sym_operator_name] = ACTIONS(2016),
    [sym_nullptr] = ACTIONS(2018),
  },
  [1747] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5388),
    [sym_comment] = ACTIONS(91),
  },
  [1748] = {
    [sym_preproc_include] = STATE(1067),
    [sym_preproc_def] = STATE(1067),
    [sym_preproc_function_def] = STATE(1067),
    [sym_preproc_call] = STATE(1067),
    [sym_preproc_if] = STATE(1067),
    [sym_preproc_ifdef] = STATE(1067),
    [sym_preproc_else] = STATE(2443),
    [sym_preproc_elif] = STATE(2443),
    [sym_function_definition] = STATE(1067),
    [sym_declaration] = STATE(1067),
    [sym_type_definition] = STATE(1067),
    [sym__declaration_specifiers] = STATE(409),
    [sym_linkage_specification] = STATE(1067),
    [sym__declarator] = STATE(50),
    [sym_pointer_declarator] = STATE(50),
    [sym_function_declarator] = STATE(410),
    [sym_array_declarator] = STATE(50),
    [sym_compound_statement] = STATE(1067),
    [sym_storage_class_specifier] = STATE(414),
    [sym_type_qualifier] = STATE(414),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(1067),
    [sym_expression_statement] = STATE(1067),
    [sym_if_statement] = STATE(1067),
    [sym_switch_statement] = STATE(1067),
    [sym_case_statement] = STATE(1067),
    [sym_while_statement] = STATE(1067),
    [sym_do_statement] = STATE(1067),
    [sym_for_statement] = STATE(1067),
    [sym_return_statement] = STATE(1067),
    [sym_break_statement] = STATE(1067),
    [sym_continue_statement] = STATE(1067),
    [sym_goto_statement] = STATE(1067),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(1067),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(1067),
    [sym_template_declaration] = STATE(1067),
    [sym_template_instantiation] = STATE(1067),
    [sym_constructor_or_destructor_definition] = STATE(1067),
    [sym_reference_declarator] = STATE(50),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(57),
    [sym_namespace_definition] = STATE(1067),
    [sym_using_declaration] = STATE(1067),
    [sym_alias_declaration] = STATE(1067),
    [sym_for_range_loop] = STATE(1067),
    [sym_try_statement] = STATE(1067),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_destructor_name] = STATE(50),
    [sym_scoped_identifier] = STATE(59),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_translation_unit_repeat1] = STATE(1067),
    [aux_sym__declaration_specifiers_repeat1] = STATE(414),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(678),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(684),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5390),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(688),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(688),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(690),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(692),
    [sym_preproc_directive] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_typedef] = ACTIONS(698),
    [anon_sym_extern] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(704),
    [anon_sym_switch] = ACTIONS(706),
    [anon_sym_case] = ACTIONS(708),
    [anon_sym_default] = ACTIONS(710),
    [anon_sym_while] = ACTIONS(712),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(728),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_template] = ACTIONS(730),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_namespace] = ACTIONS(732),
    [anon_sym_using] = ACTIONS(734),
    [anon_sym_try] = ACTIONS(736),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_operator_name] = ACTIONS(111),
    [sym_nullptr] = ACTIONS(726),
  },
  [1749] = {
    [sym_raw_string_literal] = ACTIONS(2136),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2138),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2138),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2138),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2138),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2138),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2138),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2138),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2138),
    [sym_preproc_directive] = ACTIONS(2138),
    [anon_sym_SEMI] = ACTIONS(2136),
    [anon_sym_typedef] = ACTIONS(2138),
    [anon_sym_extern] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2136),
    [anon_sym_LPAREN2] = ACTIONS(2136),
    [anon_sym_STAR] = ACTIONS(2136),
    [anon_sym_LBRACK] = ACTIONS(2136),
    [anon_sym_static] = ACTIONS(2138),
    [anon_sym_register] = ACTIONS(2138),
    [anon_sym_inline] = ACTIONS(2138),
    [anon_sym_const] = ACTIONS(2138),
    [anon_sym_restrict] = ACTIONS(2138),
    [anon_sym_volatile] = ACTIONS(2138),
    [anon_sym__Atomic] = ACTIONS(2138),
    [anon_sym_mutable] = ACTIONS(2138),
    [anon_sym_explicit] = ACTIONS(2138),
    [anon_sym_constexpr] = ACTIONS(2138),
    [anon_sym_unsigned] = ACTIONS(2138),
    [anon_sym_long] = ACTIONS(2138),
    [anon_sym_short] = ACTIONS(2138),
    [sym_primitive_type] = ACTIONS(2138),
    [anon_sym_enum] = ACTIONS(2138),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2138),
    [anon_sym_if] = ACTIONS(2138),
    [anon_sym_switch] = ACTIONS(2138),
    [anon_sym_case] = ACTIONS(2138),
    [anon_sym_default] = ACTIONS(2138),
    [anon_sym_while] = ACTIONS(2138),
    [anon_sym_do] = ACTIONS(2138),
    [anon_sym_for] = ACTIONS(2138),
    [anon_sym_return] = ACTIONS(2138),
    [anon_sym_break] = ACTIONS(2138),
    [anon_sym_continue] = ACTIONS(2138),
    [anon_sym_goto] = ACTIONS(2138),
    [anon_sym_AMP] = ACTIONS(2138),
    [anon_sym_AMP_AMP] = ACTIONS(2136),
    [anon_sym_BANG] = ACTIONS(2136),
    [anon_sym_TILDE] = ACTIONS(2136),
    [anon_sym_PLUS] = ACTIONS(2138),
    [anon_sym_DASH] = ACTIONS(2138),
    [anon_sym_DASH_DASH] = ACTIONS(2136),
    [anon_sym_PLUS_PLUS] = ACTIONS(2136),
    [anon_sym_sizeof] = ACTIONS(2138),
    [sym_number_literal] = ACTIONS(2136),
    [anon_sym_SQUOTE] = ACTIONS(2136),
    [anon_sym_DQUOTE] = ACTIONS(2136),
    [sym_true] = ACTIONS(2138),
    [sym_false] = ACTIONS(2138),
    [sym_null] = ACTIONS(2138),
    [sym_identifier] = ACTIONS(2138),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2138),
    [sym_auto] = ACTIONS(2138),
    [anon_sym_typename] = ACTIONS(2138),
    [anon_sym_template] = ACTIONS(2138),
    [anon_sym_delete] = ACTIONS(2138),
    [anon_sym_namespace] = ACTIONS(2138),
    [anon_sym_using] = ACTIONS(2138),
    [anon_sym_try] = ACTIONS(2138),
    [anon_sym_new] = ACTIONS(2138),
    [anon_sym_COLON_COLON] = ACTIONS(2136),
    [sym_operator_name] = ACTIONS(2136),
    [sym_nullptr] = ACTIONS(2138),
  },
  [1750] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5392),
    [sym_comment] = ACTIONS(91),
  },
  [1751] = {
    [sym_preproc_include] = STATE(1067),
    [sym_preproc_def] = STATE(1067),
    [sym_preproc_function_def] = STATE(1067),
    [sym_preproc_call] = STATE(1067),
    [sym_preproc_if] = STATE(1067),
    [sym_preproc_ifdef] = STATE(1067),
    [sym_preproc_else] = STATE(2445),
    [sym_preproc_elif] = STATE(2445),
    [sym_function_definition] = STATE(1067),
    [sym_declaration] = STATE(1067),
    [sym_type_definition] = STATE(1067),
    [sym__declaration_specifiers] = STATE(409),
    [sym_linkage_specification] = STATE(1067),
    [sym__declarator] = STATE(50),
    [sym_pointer_declarator] = STATE(50),
    [sym_function_declarator] = STATE(410),
    [sym_array_declarator] = STATE(50),
    [sym_compound_statement] = STATE(1067),
    [sym_storage_class_specifier] = STATE(414),
    [sym_type_qualifier] = STATE(414),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(1067),
    [sym_expression_statement] = STATE(1067),
    [sym_if_statement] = STATE(1067),
    [sym_switch_statement] = STATE(1067),
    [sym_case_statement] = STATE(1067),
    [sym_while_statement] = STATE(1067),
    [sym_do_statement] = STATE(1067),
    [sym_for_statement] = STATE(1067),
    [sym_return_statement] = STATE(1067),
    [sym_break_statement] = STATE(1067),
    [sym_continue_statement] = STATE(1067),
    [sym_goto_statement] = STATE(1067),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(1067),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(1067),
    [sym_template_declaration] = STATE(1067),
    [sym_template_instantiation] = STATE(1067),
    [sym_constructor_or_destructor_definition] = STATE(1067),
    [sym_reference_declarator] = STATE(50),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(57),
    [sym_namespace_definition] = STATE(1067),
    [sym_using_declaration] = STATE(1067),
    [sym_alias_declaration] = STATE(1067),
    [sym_for_range_loop] = STATE(1067),
    [sym_try_statement] = STATE(1067),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_destructor_name] = STATE(50),
    [sym_scoped_identifier] = STATE(59),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_translation_unit_repeat1] = STATE(1067),
    [aux_sym__declaration_specifiers_repeat1] = STATE(414),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(678),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(684),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5394),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(688),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(688),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(690),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(692),
    [sym_preproc_directive] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_typedef] = ACTIONS(698),
    [anon_sym_extern] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(704),
    [anon_sym_switch] = ACTIONS(706),
    [anon_sym_case] = ACTIONS(708),
    [anon_sym_default] = ACTIONS(710),
    [anon_sym_while] = ACTIONS(712),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(728),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_template] = ACTIONS(730),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_namespace] = ACTIONS(732),
    [anon_sym_using] = ACTIONS(734),
    [anon_sym_try] = ACTIONS(736),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_operator_name] = ACTIONS(111),
    [sym_nullptr] = ACTIONS(726),
  },
  [1752] = {
    [aux_sym_string_literal_repeat1] = STATE(2447),
    [anon_sym_DQUOTE] = ACTIONS(5396),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_BSLASHn_RBRACK_SLASH] = ACTIONS(5398),
    [sym_escape_sequence] = ACTIONS(5398),
    [sym_comment] = ACTIONS(121),
  },
  [1753] = {
    [sym_raw_string_literal] = ACTIONS(668),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(670),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(670),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(670),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(670),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(670),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(670),
    [sym_preproc_directive] = ACTIONS(670),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(670),
    [anon_sym_extern] = ACTIONS(670),
    [anon_sym_LBRACE] = ACTIONS(668),
    [anon_sym_LPAREN2] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(668),
    [anon_sym_LBRACK] = ACTIONS(668),
    [anon_sym_static] = ACTIONS(670),
    [anon_sym_register] = ACTIONS(670),
    [anon_sym_inline] = ACTIONS(670),
    [anon_sym_const] = ACTIONS(670),
    [anon_sym_restrict] = ACTIONS(670),
    [anon_sym_volatile] = ACTIONS(670),
    [anon_sym__Atomic] = ACTIONS(670),
    [anon_sym_mutable] = ACTIONS(670),
    [anon_sym_explicit] = ACTIONS(670),
    [anon_sym_constexpr] = ACTIONS(670),
    [anon_sym_unsigned] = ACTIONS(670),
    [anon_sym_long] = ACTIONS(670),
    [anon_sym_short] = ACTIONS(670),
    [sym_primitive_type] = ACTIONS(670),
    [anon_sym_enum] = ACTIONS(670),
    [anon_sym_struct] = ACTIONS(670),
    [anon_sym_union] = ACTIONS(670),
    [anon_sym_if] = ACTIONS(670),
    [anon_sym_switch] = ACTIONS(670),
    [anon_sym_case] = ACTIONS(670),
    [anon_sym_default] = ACTIONS(670),
    [anon_sym_while] = ACTIONS(670),
    [anon_sym_do] = ACTIONS(670),
    [anon_sym_for] = ACTIONS(670),
    [anon_sym_return] = ACTIONS(670),
    [anon_sym_break] = ACTIONS(670),
    [anon_sym_continue] = ACTIONS(670),
    [anon_sym_goto] = ACTIONS(670),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_AMP_AMP] = ACTIONS(668),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_PLUS] = ACTIONS(670),
    [anon_sym_DASH] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(668),
    [anon_sym_PLUS_PLUS] = ACTIONS(668),
    [anon_sym_sizeof] = ACTIONS(670),
    [sym_number_literal] = ACTIONS(668),
    [anon_sym_SQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE] = ACTIONS(668),
    [sym_true] = ACTIONS(670),
    [sym_false] = ACTIONS(670),
    [sym_null] = ACTIONS(670),
    [sym_identifier] = ACTIONS(670),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(670),
    [sym_auto] = ACTIONS(670),
    [anon_sym_typename] = ACTIONS(670),
    [anon_sym_template] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_namespace] = ACTIONS(670),
    [anon_sym_using] = ACTIONS(670),
    [anon_sym_try] = ACTIONS(670),
    [anon_sym_new] = ACTIONS(670),
    [anon_sym_COLON_COLON] = ACTIONS(668),
    [sym_operator_name] = ACTIONS(668),
    [sym_nullptr] = ACTIONS(670),
  },
  [1754] = {
    [sym_preproc_params] = STATE(2450),
    [anon_sym_LF] = ACTIONS(5400),
    [anon_sym_LPAREN] = ACTIONS(674),
    [sym_preproc_arg] = ACTIONS(5402),
    [sym_comment] = ACTIONS(121),
  },
  [1755] = {
    [sym_preproc_include] = STATE(2453),
    [sym_preproc_def] = STATE(2453),
    [sym_preproc_function_def] = STATE(2453),
    [sym_preproc_call] = STATE(2453),
    [sym_preproc_if] = STATE(2453),
    [sym_preproc_ifdef] = STATE(2453),
    [sym_preproc_else] = STATE(2452),
    [sym_preproc_elif] = STATE(2452),
    [sym_function_definition] = STATE(2453),
    [sym_declaration] = STATE(2453),
    [sym_type_definition] = STATE(2453),
    [sym__declaration_specifiers] = STATE(409),
    [sym_linkage_specification] = STATE(2453),
    [sym__declarator] = STATE(50),
    [sym_pointer_declarator] = STATE(50),
    [sym_function_declarator] = STATE(410),
    [sym_array_declarator] = STATE(50),
    [sym_compound_statement] = STATE(2453),
    [sym_storage_class_specifier] = STATE(414),
    [sym_type_qualifier] = STATE(414),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(2453),
    [sym_expression_statement] = STATE(2453),
    [sym_if_statement] = STATE(2453),
    [sym_switch_statement] = STATE(2453),
    [sym_case_statement] = STATE(2453),
    [sym_while_statement] = STATE(2453),
    [sym_do_statement] = STATE(2453),
    [sym_for_statement] = STATE(2453),
    [sym_return_statement] = STATE(2453),
    [sym_break_statement] = STATE(2453),
    [sym_continue_statement] = STATE(2453),
    [sym_goto_statement] = STATE(2453),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(2453),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(2453),
    [sym_template_declaration] = STATE(2453),
    [sym_template_instantiation] = STATE(2453),
    [sym_constructor_or_destructor_definition] = STATE(2453),
    [sym_reference_declarator] = STATE(50),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(57),
    [sym_namespace_definition] = STATE(2453),
    [sym_using_declaration] = STATE(2453),
    [sym_alias_declaration] = STATE(2453),
    [sym_for_range_loop] = STATE(2453),
    [sym_try_statement] = STATE(2453),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_destructor_name] = STATE(50),
    [sym_scoped_identifier] = STATE(59),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_translation_unit_repeat1] = STATE(2453),
    [aux_sym__declaration_specifiers_repeat1] = STATE(414),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(678),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(684),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5404),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(688),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(688),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(690),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(692),
    [sym_preproc_directive] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_typedef] = ACTIONS(698),
    [anon_sym_extern] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(704),
    [anon_sym_switch] = ACTIONS(706),
    [anon_sym_case] = ACTIONS(708),
    [anon_sym_default] = ACTIONS(710),
    [anon_sym_while] = ACTIONS(712),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(728),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_template] = ACTIONS(730),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_namespace] = ACTIONS(732),
    [anon_sym_using] = ACTIONS(734),
    [anon_sym_try] = ACTIONS(736),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_operator_name] = ACTIONS(111),
    [sym_nullptr] = ACTIONS(726),
  },
  [1756] = {
    [sym_preproc_include] = STATE(2456),
    [sym_preproc_def] = STATE(2456),
    [sym_preproc_function_def] = STATE(2456),
    [sym_preproc_call] = STATE(2456),
    [sym_preproc_if] = STATE(2456),
    [sym_preproc_ifdef] = STATE(2456),
    [sym_preproc_else] = STATE(2455),
    [sym_preproc_elif] = STATE(2455),
    [sym_function_definition] = STATE(2456),
    [sym_declaration] = STATE(2456),
    [sym_type_definition] = STATE(2456),
    [sym__declaration_specifiers] = STATE(409),
    [sym_linkage_specification] = STATE(2456),
    [sym__declarator] = STATE(50),
    [sym_pointer_declarator] = STATE(50),
    [sym_function_declarator] = STATE(410),
    [sym_array_declarator] = STATE(50),
    [sym_compound_statement] = STATE(2456),
    [sym_storage_class_specifier] = STATE(414),
    [sym_type_qualifier] = STATE(414),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(2456),
    [sym_expression_statement] = STATE(2456),
    [sym_if_statement] = STATE(2456),
    [sym_switch_statement] = STATE(2456),
    [sym_case_statement] = STATE(2456),
    [sym_while_statement] = STATE(2456),
    [sym_do_statement] = STATE(2456),
    [sym_for_statement] = STATE(2456),
    [sym_return_statement] = STATE(2456),
    [sym_break_statement] = STATE(2456),
    [sym_continue_statement] = STATE(2456),
    [sym_goto_statement] = STATE(2456),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(2456),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(2456),
    [sym_template_declaration] = STATE(2456),
    [sym_template_instantiation] = STATE(2456),
    [sym_constructor_or_destructor_definition] = STATE(2456),
    [sym_reference_declarator] = STATE(50),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(57),
    [sym_namespace_definition] = STATE(2456),
    [sym_using_declaration] = STATE(2456),
    [sym_alias_declaration] = STATE(2456),
    [sym_for_range_loop] = STATE(2456),
    [sym_try_statement] = STATE(2456),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_destructor_name] = STATE(50),
    [sym_scoped_identifier] = STATE(59),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_translation_unit_repeat1] = STATE(2456),
    [aux_sym__declaration_specifiers_repeat1] = STATE(414),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(678),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(684),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5406),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(688),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(688),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(690),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(692),
    [sym_preproc_directive] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_typedef] = ACTIONS(698),
    [anon_sym_extern] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(704),
    [anon_sym_switch] = ACTIONS(706),
    [anon_sym_case] = ACTIONS(708),
    [anon_sym_default] = ACTIONS(710),
    [anon_sym_while] = ACTIONS(712),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(728),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_template] = ACTIONS(730),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_namespace] = ACTIONS(732),
    [anon_sym_using] = ACTIONS(734),
    [anon_sym_try] = ACTIONS(736),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_operator_name] = ACTIONS(111),
    [sym_nullptr] = ACTIONS(726),
  },
  [1757] = {
    [sym_raw_string_literal] = ACTIONS(740),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(742),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(742),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(742),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(742),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(742),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(742),
    [sym_preproc_directive] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(740),
    [anon_sym_typedef] = ACTIONS(742),
    [anon_sym_extern] = ACTIONS(742),
    [anon_sym_LBRACE] = ACTIONS(740),
    [anon_sym_LPAREN2] = ACTIONS(740),
    [anon_sym_STAR] = ACTIONS(740),
    [anon_sym_LBRACK] = ACTIONS(740),
    [anon_sym_static] = ACTIONS(742),
    [anon_sym_register] = ACTIONS(742),
    [anon_sym_inline] = ACTIONS(742),
    [anon_sym_const] = ACTIONS(742),
    [anon_sym_restrict] = ACTIONS(742),
    [anon_sym_volatile] = ACTIONS(742),
    [anon_sym__Atomic] = ACTIONS(742),
    [anon_sym_mutable] = ACTIONS(742),
    [anon_sym_explicit] = ACTIONS(742),
    [anon_sym_constexpr] = ACTIONS(742),
    [anon_sym_unsigned] = ACTIONS(742),
    [anon_sym_long] = ACTIONS(742),
    [anon_sym_short] = ACTIONS(742),
    [sym_primitive_type] = ACTIONS(742),
    [anon_sym_enum] = ACTIONS(742),
    [anon_sym_struct] = ACTIONS(742),
    [anon_sym_union] = ACTIONS(742),
    [anon_sym_if] = ACTIONS(742),
    [anon_sym_switch] = ACTIONS(742),
    [anon_sym_case] = ACTIONS(742),
    [anon_sym_default] = ACTIONS(742),
    [anon_sym_while] = ACTIONS(742),
    [anon_sym_do] = ACTIONS(742),
    [anon_sym_for] = ACTIONS(742),
    [anon_sym_return] = ACTIONS(742),
    [anon_sym_break] = ACTIONS(742),
    [anon_sym_continue] = ACTIONS(742),
    [anon_sym_goto] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_AMP_AMP] = ACTIONS(740),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(742),
    [anon_sym_DASH] = ACTIONS(742),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_sizeof] = ACTIONS(742),
    [sym_number_literal] = ACTIONS(740),
    [anon_sym_SQUOTE] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(740),
    [sym_true] = ACTIONS(742),
    [sym_false] = ACTIONS(742),
    [sym_null] = ACTIONS(742),
    [sym_identifier] = ACTIONS(742),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(742),
    [sym_auto] = ACTIONS(742),
    [anon_sym_typename] = ACTIONS(742),
    [anon_sym_template] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(742),
    [anon_sym_namespace] = ACTIONS(742),
    [anon_sym_using] = ACTIONS(742),
    [anon_sym_try] = ACTIONS(742),
    [anon_sym_new] = ACTIONS(742),
    [anon_sym_COLON_COLON] = ACTIONS(740),
    [sym_operator_name] = ACTIONS(740),
    [sym_nullptr] = ACTIONS(742),
  },
  [1758] = {
    [anon_sym_LF] = ACTIONS(5408),
    [sym_comment] = ACTIONS(121),
  },
  [1759] = {
    [sym__type_declarator] = STATE(2458),
    [sym_pointer_type_declarator] = STATE(2458),
    [sym_function_type_declarator] = STATE(2458),
    [sym_array_type_declarator] = STATE(2458),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_STAR] = ACTIONS(768),
    [sym_identifier] = ACTIONS(770),
    [sym_comment] = ACTIONS(91),
  },
  [1760] = {
    [sym_type_qualifier] = STATE(453),
    [sym__type_specifier] = STATE(2459),
    [sym_sized_type_specifier] = STATE(2459),
    [sym_enum_specifier] = STATE(2459),
    [sym_struct_specifier] = STATE(2459),
    [sym_union_specifier] = STATE(2459),
    [sym_macro_type_specifier] = STATE(2459),
    [sym_class_specifier] = STATE(2459),
    [sym_dependent_type] = STATE(2459),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(82),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_type_definition_repeat1] = STATE(453),
    [aux_sym_sized_type_specifier_repeat1] = STATE(85),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(135),
    [anon_sym_long] = ACTIONS(135),
    [anon_sym_short] = ACTIONS(135),
    [sym_primitive_type] = ACTIONS(5410),
    [anon_sym_enum] = ACTIONS(139),
    [anon_sym_struct] = ACTIONS(141),
    [anon_sym_union] = ACTIONS(143),
    [sym_identifier] = ACTIONS(145),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(147),
    [sym_auto] = ACTIONS(5410),
    [anon_sym_typename] = ACTIONS(149),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [1761] = {
    [sym_function_definition] = STATE(2460),
    [sym_declaration] = STATE(2460),
    [sym__declaration_specifiers] = STATE(2461),
    [sym_declaration_list] = STATE(2460),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(272),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(180),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(3775),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [sym_identifier] = ACTIONS(492),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_COLON_COLON] = ACTIONS(315),
  },
  [1762] = {
    [sym_raw_string_literal] = ACTIONS(801),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(803),
    [sym_preproc_directive] = ACTIONS(803),
    [anon_sym_SEMI] = ACTIONS(801),
    [anon_sym_typedef] = ACTIONS(803),
    [anon_sym_extern] = ACTIONS(803),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(801),
    [anon_sym_LBRACK] = ACTIONS(801),
    [anon_sym_static] = ACTIONS(803),
    [anon_sym_register] = ACTIONS(803),
    [anon_sym_inline] = ACTIONS(803),
    [anon_sym_const] = ACTIONS(803),
    [anon_sym_restrict] = ACTIONS(803),
    [anon_sym_volatile] = ACTIONS(803),
    [anon_sym__Atomic] = ACTIONS(803),
    [anon_sym_mutable] = ACTIONS(803),
    [anon_sym_explicit] = ACTIONS(803),
    [anon_sym_constexpr] = ACTIONS(803),
    [anon_sym_unsigned] = ACTIONS(803),
    [anon_sym_long] = ACTIONS(803),
    [anon_sym_short] = ACTIONS(803),
    [sym_primitive_type] = ACTIONS(803),
    [anon_sym_enum] = ACTIONS(803),
    [anon_sym_struct] = ACTIONS(803),
    [anon_sym_union] = ACTIONS(803),
    [anon_sym_if] = ACTIONS(803),
    [anon_sym_else] = ACTIONS(803),
    [anon_sym_switch] = ACTIONS(803),
    [anon_sym_case] = ACTIONS(803),
    [anon_sym_default] = ACTIONS(803),
    [anon_sym_while] = ACTIONS(803),
    [anon_sym_do] = ACTIONS(803),
    [anon_sym_for] = ACTIONS(803),
    [anon_sym_return] = ACTIONS(803),
    [anon_sym_break] = ACTIONS(803),
    [anon_sym_continue] = ACTIONS(803),
    [anon_sym_goto] = ACTIONS(803),
    [anon_sym_AMP] = ACTIONS(803),
    [anon_sym_AMP_AMP] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_DASH] = ACTIONS(803),
    [anon_sym_DASH_DASH] = ACTIONS(801),
    [anon_sym_PLUS_PLUS] = ACTIONS(801),
    [anon_sym_sizeof] = ACTIONS(803),
    [sym_number_literal] = ACTIONS(801),
    [anon_sym_SQUOTE] = ACTIONS(801),
    [anon_sym_DQUOTE] = ACTIONS(801),
    [sym_true] = ACTIONS(803),
    [sym_false] = ACTIONS(803),
    [sym_null] = ACTIONS(803),
    [sym_identifier] = ACTIONS(803),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(803),
    [sym_auto] = ACTIONS(803),
    [anon_sym_typename] = ACTIONS(803),
    [anon_sym_template] = ACTIONS(803),
    [anon_sym_delete] = ACTIONS(803),
    [anon_sym_namespace] = ACTIONS(803),
    [anon_sym_using] = ACTIONS(803),
    [anon_sym_try] = ACTIONS(803),
    [anon_sym_catch] = ACTIONS(803),
    [anon_sym_new] = ACTIONS(803),
    [anon_sym_COLON_COLON] = ACTIONS(801),
    [sym_operator_name] = ACTIONS(801),
    [sym_nullptr] = ACTIONS(803),
  },
  [1763] = {
    [sym_preproc_include] = STATE(496),
    [sym_preproc_def] = STATE(496),
    [sym_preproc_function_def] = STATE(496),
    [sym_preproc_call] = STATE(496),
    [sym_preproc_if_in_compound_statement] = STATE(496),
    [sym_preproc_ifdef_in_compound_statement] = STATE(496),
    [sym_declaration] = STATE(496),
    [sym_type_definition] = STATE(496),
    [sym__declaration_specifiers] = STATE(113),
    [sym_compound_statement] = STATE(496),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(496),
    [sym_expression_statement] = STATE(496),
    [sym_if_statement] = STATE(496),
    [sym_switch_statement] = STATE(496),
    [sym_case_statement] = STATE(496),
    [sym_while_statement] = STATE(496),
    [sym_do_statement] = STATE(496),
    [sym_for_statement] = STATE(496),
    [sym_return_statement] = STATE(496),
    [sym_break_statement] = STATE(496),
    [sym_continue_statement] = STATE(496),
    [sym_goto_statement] = STATE(496),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(496),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(496),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(496),
    [sym_try_statement] = STATE(496),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(496),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(157),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(159),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(161),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(163),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(165),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(165),
    [sym_preproc_directive] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_typedef] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_RBRACE] = ACTIONS(5412),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(185),
    [anon_sym_case] = ACTIONS(187),
    [anon_sym_default] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(209),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_nullptr] = ACTIONS(207),
  },
  [1764] = {
    [sym__expression] = STATE(2463),
    [sym_conditional_expression] = STATE(2463),
    [sym_assignment_expression] = STATE(2463),
    [sym_pointer_expression] = STATE(2463),
    [sym_logical_expression] = STATE(2463),
    [sym_bitwise_expression] = STATE(2463),
    [sym_equality_expression] = STATE(2463),
    [sym_relational_expression] = STATE(2463),
    [sym_shift_expression] = STATE(2463),
    [sym_math_expression] = STATE(2463),
    [sym_cast_expression] = STATE(2463),
    [sym_sizeof_expression] = STATE(2463),
    [sym_subscript_expression] = STATE(2463),
    [sym_call_expression] = STATE(2463),
    [sym_field_expression] = STATE(2463),
    [sym_compound_literal_expression] = STATE(2463),
    [sym_parenthesized_expression] = STATE(2463),
    [sym_char_literal] = STATE(2463),
    [sym_concatenated_string] = STATE(2463),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2463),
    [sym_new_expression] = STATE(2463),
    [sym_delete_expression] = STATE(2463),
    [sym_lambda_expression] = STATE(2463),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5414),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(5414),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(5416),
    [sym_false] = ACTIONS(5416),
    [sym_null] = ACTIONS(5416),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(5416),
  },
  [1765] = {
    [anon_sym_LPAREN2] = ACTIONS(5418),
    [sym_comment] = ACTIONS(91),
  },
  [1766] = {
    [sym_compound_statement] = STATE(2466),
    [sym_labeled_statement] = STATE(2466),
    [sym_expression_statement] = STATE(2466),
    [sym_if_statement] = STATE(2466),
    [sym_switch_statement] = STATE(2466),
    [sym_case_statement] = STATE(2466),
    [sym_while_statement] = STATE(2466),
    [sym_do_statement] = STATE(2466),
    [sym_for_statement] = STATE(2466),
    [sym_return_statement] = STATE(2466),
    [sym_break_statement] = STATE(2466),
    [sym_continue_statement] = STATE(2466),
    [sym_goto_statement] = STATE(2466),
    [sym__expression] = STATE(1020),
    [sym_comma_expression] = STATE(1021),
    [sym_conditional_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1020),
    [sym_pointer_expression] = STATE(1020),
    [sym_logical_expression] = STATE(1020),
    [sym_bitwise_expression] = STATE(1020),
    [sym_equality_expression] = STATE(1020),
    [sym_relational_expression] = STATE(1020),
    [sym_shift_expression] = STATE(1020),
    [sym_math_expression] = STATE(1020),
    [sym_cast_expression] = STATE(1020),
    [sym_sizeof_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_field_expression] = STATE(1020),
    [sym_compound_literal_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_char_literal] = STATE(1020),
    [sym_concatenated_string] = STATE(1020),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1020),
    [sym_for_range_loop] = STATE(2466),
    [sym_try_statement] = STATE(2466),
    [sym_new_expression] = STATE(1020),
    [sym_delete_expression] = STATE(1020),
    [sym_lambda_expression] = STATE(1020),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2022),
    [anon_sym_SEMI] = ACTIONS(2036),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(2044),
    [anon_sym_switch] = ACTIONS(2046),
    [anon_sym_case] = ACTIONS(2048),
    [anon_sym_default] = ACTIONS(2050),
    [anon_sym_while] = ACTIONS(2052),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(2056),
    [anon_sym_return] = ACTIONS(2058),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2062),
    [anon_sym_goto] = ACTIONS(2064),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(5420),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2076),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2066),
  },
  [1767] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_COLON] = ACTIONS(5422),
    [anon_sym_QMARK] = ACTIONS(1171),
    [anon_sym_STAR_EQ] = ACTIONS(1173),
    [anon_sym_SLASH_EQ] = ACTIONS(1173),
    [anon_sym_PERCENT_EQ] = ACTIONS(1173),
    [anon_sym_PLUS_EQ] = ACTIONS(1173),
    [anon_sym_DASH_EQ] = ACTIONS(1173),
    [anon_sym_LT_LT_EQ] = ACTIONS(1173),
    [anon_sym_GT_GT_EQ] = ACTIONS(1173),
    [anon_sym_AMP_EQ] = ACTIONS(1173),
    [anon_sym_CARET_EQ] = ACTIONS(1173),
    [anon_sym_PIPE_EQ] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_CARET] = ACTIONS(1183),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [1768] = {
    [sym_declaration] = STATE(2469),
    [sym_type_definition] = STATE(2469),
    [sym__declaration_specifiers] = STATE(2470),
    [sym_compound_statement] = STATE(2469),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_labeled_statement] = STATE(2469),
    [sym_expression_statement] = STATE(2469),
    [sym_if_statement] = STATE(2469),
    [sym_switch_statement] = STATE(2469),
    [sym_case_statement] = STATE(2469),
    [sym_while_statement] = STATE(2469),
    [sym_do_statement] = STATE(2469),
    [sym_for_statement] = STATE(2469),
    [sym_return_statement] = STATE(2469),
    [sym_break_statement] = STATE(2469),
    [sym_continue_statement] = STATE(2469),
    [sym_goto_statement] = STATE(2469),
    [sym__expression] = STATE(1020),
    [sym_comma_expression] = STATE(1021),
    [sym_conditional_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1020),
    [sym_pointer_expression] = STATE(1020),
    [sym_logical_expression] = STATE(1020),
    [sym_bitwise_expression] = STATE(1020),
    [sym_equality_expression] = STATE(1020),
    [sym_relational_expression] = STATE(1020),
    [sym_shift_expression] = STATE(1020),
    [sym_math_expression] = STATE(1020),
    [sym_cast_expression] = STATE(1020),
    [sym_sizeof_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_field_expression] = STATE(1020),
    [sym_compound_literal_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_char_literal] = STATE(1020),
    [sym_concatenated_string] = STATE(1020),
    [sym_string_literal] = STATE(55),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(1020),
    [sym_for_range_loop] = STATE(2469),
    [sym_try_statement] = STATE(2469),
    [sym_new_expression] = STATE(1020),
    [sym_delete_expression] = STATE(1020),
    [sym_lambda_expression] = STATE(1020),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(2022),
    [anon_sym_SEMI] = ACTIONS(2036),
    [anon_sym_typedef] = ACTIONS(2038),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(2044),
    [anon_sym_switch] = ACTIONS(2046),
    [anon_sym_case] = ACTIONS(2048),
    [anon_sym_default] = ACTIONS(2050),
    [anon_sym_while] = ACTIONS(2052),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(2056),
    [anon_sym_return] = ACTIONS(2058),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2062),
    [anon_sym_goto] = ACTIONS(2064),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(5424),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2076),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(1202),
    [sym_nullptr] = ACTIONS(2066),
  },
  [1769] = {
    [sym_compound_statement] = STATE(2471),
    [sym_labeled_statement] = STATE(2471),
    [sym_expression_statement] = STATE(2471),
    [sym_if_statement] = STATE(2471),
    [sym_switch_statement] = STATE(2471),
    [sym_case_statement] = STATE(2471),
    [sym_while_statement] = STATE(2471),
    [sym_do_statement] = STATE(2471),
    [sym_for_statement] = STATE(2471),
    [sym_return_statement] = STATE(2471),
    [sym_break_statement] = STATE(2471),
    [sym_continue_statement] = STATE(2471),
    [sym_goto_statement] = STATE(2471),
    [sym__expression] = STATE(1020),
    [sym_comma_expression] = STATE(1021),
    [sym_conditional_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1020),
    [sym_pointer_expression] = STATE(1020),
    [sym_logical_expression] = STATE(1020),
    [sym_bitwise_expression] = STATE(1020),
    [sym_equality_expression] = STATE(1020),
    [sym_relational_expression] = STATE(1020),
    [sym_shift_expression] = STATE(1020),
    [sym_math_expression] = STATE(1020),
    [sym_cast_expression] = STATE(1020),
    [sym_sizeof_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_field_expression] = STATE(1020),
    [sym_compound_literal_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_char_literal] = STATE(1020),
    [sym_concatenated_string] = STATE(1020),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1020),
    [sym_for_range_loop] = STATE(2471),
    [sym_try_statement] = STATE(2471),
    [sym_new_expression] = STATE(1020),
    [sym_delete_expression] = STATE(1020),
    [sym_lambda_expression] = STATE(1020),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2022),
    [anon_sym_SEMI] = ACTIONS(2036),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(2044),
    [anon_sym_switch] = ACTIONS(2046),
    [anon_sym_case] = ACTIONS(2048),
    [anon_sym_default] = ACTIONS(2050),
    [anon_sym_while] = ACTIONS(2052),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(2056),
    [anon_sym_return] = ACTIONS(2058),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2062),
    [anon_sym_goto] = ACTIONS(2064),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(5420),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2076),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2066),
  },
  [1770] = {
    [anon_sym_while] = ACTIONS(5426),
    [sym_comment] = ACTIONS(91),
  },
  [1771] = {
    [sym_declaration] = STATE(2473),
    [sym__declaration_specifiers] = STATE(709),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym__expression] = STATE(2474),
    [sym_conditional_expression] = STATE(2474),
    [sym_assignment_expression] = STATE(2474),
    [sym_pointer_expression] = STATE(2474),
    [sym_logical_expression] = STATE(2474),
    [sym_bitwise_expression] = STATE(2474),
    [sym_equality_expression] = STATE(2474),
    [sym_relational_expression] = STATE(2474),
    [sym_shift_expression] = STATE(2474),
    [sym_math_expression] = STATE(2474),
    [sym_cast_expression] = STATE(2474),
    [sym_sizeof_expression] = STATE(2474),
    [sym_subscript_expression] = STATE(2474),
    [sym_call_expression] = STATE(2474),
    [sym_field_expression] = STATE(2474),
    [sym_compound_literal_expression] = STATE(2474),
    [sym_parenthesized_expression] = STATE(2474),
    [sym_char_literal] = STATE(2474),
    [sym_concatenated_string] = STATE(2474),
    [sym_string_literal] = STATE(238),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(2474),
    [sym_for_range_declaration] = STATE(2475),
    [sym_new_expression] = STATE(2474),
    [sym_delete_expression] = STATE(2474),
    [sym_lambda_expression] = STATE(2474),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(5428),
    [anon_sym_SEMI] = ACTIONS(5430),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(5428),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(5432),
    [sym_false] = ACTIONS(5432),
    [sym_null] = ACTIONS(5432),
    [sym_identifier] = ACTIONS(1242),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(1244),
    [sym_nullptr] = ACTIONS(5432),
  },
  [1772] = {
    [sym_raw_string_literal] = ACTIONS(1246),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1248),
    [sym_preproc_directive] = ACTIONS(1248),
    [anon_sym_SEMI] = ACTIONS(1246),
    [anon_sym_typedef] = ACTIONS(1248),
    [anon_sym_extern] = ACTIONS(1248),
    [anon_sym_LBRACE] = ACTIONS(1246),
    [anon_sym_LPAREN2] = ACTIONS(1246),
    [anon_sym_STAR] = ACTIONS(1246),
    [anon_sym_LBRACK] = ACTIONS(1246),
    [anon_sym_static] = ACTIONS(1248),
    [anon_sym_register] = ACTIONS(1248),
    [anon_sym_inline] = ACTIONS(1248),
    [anon_sym_const] = ACTIONS(1248),
    [anon_sym_restrict] = ACTIONS(1248),
    [anon_sym_volatile] = ACTIONS(1248),
    [anon_sym__Atomic] = ACTIONS(1248),
    [anon_sym_mutable] = ACTIONS(1248),
    [anon_sym_explicit] = ACTIONS(1248),
    [anon_sym_constexpr] = ACTIONS(1248),
    [anon_sym_unsigned] = ACTIONS(1248),
    [anon_sym_long] = ACTIONS(1248),
    [anon_sym_short] = ACTIONS(1248),
    [sym_primitive_type] = ACTIONS(1248),
    [anon_sym_enum] = ACTIONS(1248),
    [anon_sym_struct] = ACTIONS(1248),
    [anon_sym_union] = ACTIONS(1248),
    [anon_sym_if] = ACTIONS(1248),
    [anon_sym_else] = ACTIONS(1248),
    [anon_sym_switch] = ACTIONS(1248),
    [anon_sym_case] = ACTIONS(1248),
    [anon_sym_default] = ACTIONS(1248),
    [anon_sym_while] = ACTIONS(1248),
    [anon_sym_do] = ACTIONS(1248),
    [anon_sym_for] = ACTIONS(1248),
    [anon_sym_return] = ACTIONS(1248),
    [anon_sym_break] = ACTIONS(1248),
    [anon_sym_continue] = ACTIONS(1248),
    [anon_sym_goto] = ACTIONS(1248),
    [anon_sym_AMP] = ACTIONS(1248),
    [anon_sym_AMP_AMP] = ACTIONS(1246),
    [anon_sym_BANG] = ACTIONS(1246),
    [anon_sym_TILDE] = ACTIONS(1246),
    [anon_sym_PLUS] = ACTIONS(1248),
    [anon_sym_DASH] = ACTIONS(1248),
    [anon_sym_DASH_DASH] = ACTIONS(1246),
    [anon_sym_PLUS_PLUS] = ACTIONS(1246),
    [anon_sym_sizeof] = ACTIONS(1248),
    [sym_number_literal] = ACTIONS(1246),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [anon_sym_DQUOTE] = ACTIONS(1246),
    [sym_true] = ACTIONS(1248),
    [sym_false] = ACTIONS(1248),
    [sym_null] = ACTIONS(1248),
    [sym_identifier] = ACTIONS(1248),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1248),
    [sym_auto] = ACTIONS(1248),
    [anon_sym_typename] = ACTIONS(1248),
    [anon_sym_template] = ACTIONS(1248),
    [anon_sym_delete] = ACTIONS(1248),
    [anon_sym_namespace] = ACTIONS(1248),
    [anon_sym_using] = ACTIONS(1248),
    [anon_sym_try] = ACTIONS(1248),
    [anon_sym_new] = ACTIONS(1248),
    [anon_sym_COLON_COLON] = ACTIONS(1246),
    [sym_operator_name] = ACTIONS(1246),
    [sym_nullptr] = ACTIONS(1248),
  },
  [1773] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(5434),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1774] = {
    [anon_sym_SEMI] = ACTIONS(5434),
    [sym_comment] = ACTIONS(91),
  },
  [1775] = {
    [sym_raw_string_literal] = ACTIONS(1332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1334),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1334),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1334),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1334),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1334),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1334),
    [sym_preproc_directive] = ACTIONS(1334),
    [anon_sym_SEMI] = ACTIONS(1332),
    [anon_sym_typedef] = ACTIONS(1334),
    [anon_sym_extern] = ACTIONS(1334),
    [anon_sym_LBRACE] = ACTIONS(1332),
    [anon_sym_LPAREN2] = ACTIONS(1332),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_LBRACK] = ACTIONS(1332),
    [anon_sym_static] = ACTIONS(1334),
    [anon_sym_register] = ACTIONS(1334),
    [anon_sym_inline] = ACTIONS(1334),
    [anon_sym_const] = ACTIONS(1334),
    [anon_sym_restrict] = ACTIONS(1334),
    [anon_sym_volatile] = ACTIONS(1334),
    [anon_sym__Atomic] = ACTIONS(1334),
    [anon_sym_mutable] = ACTIONS(1334),
    [anon_sym_explicit] = ACTIONS(1334),
    [anon_sym_constexpr] = ACTIONS(1334),
    [anon_sym_unsigned] = ACTIONS(1334),
    [anon_sym_long] = ACTIONS(1334),
    [anon_sym_short] = ACTIONS(1334),
    [sym_primitive_type] = ACTIONS(1334),
    [anon_sym_enum] = ACTIONS(1334),
    [anon_sym_struct] = ACTIONS(1334),
    [anon_sym_union] = ACTIONS(1334),
    [anon_sym_if] = ACTIONS(1334),
    [anon_sym_else] = ACTIONS(1334),
    [anon_sym_switch] = ACTIONS(1334),
    [anon_sym_case] = ACTIONS(1334),
    [anon_sym_default] = ACTIONS(1334),
    [anon_sym_while] = ACTIONS(1334),
    [anon_sym_do] = ACTIONS(1334),
    [anon_sym_for] = ACTIONS(1334),
    [anon_sym_return] = ACTIONS(1334),
    [anon_sym_break] = ACTIONS(1334),
    [anon_sym_continue] = ACTIONS(1334),
    [anon_sym_goto] = ACTIONS(1334),
    [anon_sym_AMP] = ACTIONS(1334),
    [anon_sym_AMP_AMP] = ACTIONS(1332),
    [anon_sym_BANG] = ACTIONS(1332),
    [anon_sym_TILDE] = ACTIONS(1332),
    [anon_sym_PLUS] = ACTIONS(1334),
    [anon_sym_DASH] = ACTIONS(1334),
    [anon_sym_DASH_DASH] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(1332),
    [anon_sym_sizeof] = ACTIONS(1334),
    [sym_number_literal] = ACTIONS(1332),
    [anon_sym_SQUOTE] = ACTIONS(1332),
    [anon_sym_DQUOTE] = ACTIONS(1332),
    [sym_true] = ACTIONS(1334),
    [sym_false] = ACTIONS(1334),
    [sym_null] = ACTIONS(1334),
    [sym_identifier] = ACTIONS(1334),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1334),
    [sym_auto] = ACTIONS(1334),
    [anon_sym_typename] = ACTIONS(1334),
    [anon_sym_template] = ACTIONS(1334),
    [anon_sym_delete] = ACTIONS(1334),
    [anon_sym_namespace] = ACTIONS(1334),
    [anon_sym_using] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1334),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_COLON_COLON] = ACTIONS(1332),
    [sym_operator_name] = ACTIONS(1332),
    [sym_nullptr] = ACTIONS(1334),
  },
  [1776] = {
    [sym_raw_string_literal] = ACTIONS(1336),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1338),
    [sym_preproc_directive] = ACTIONS(1338),
    [anon_sym_SEMI] = ACTIONS(1336),
    [anon_sym_typedef] = ACTIONS(1338),
    [anon_sym_extern] = ACTIONS(1338),
    [anon_sym_LBRACE] = ACTIONS(1336),
    [anon_sym_LPAREN2] = ACTIONS(1336),
    [anon_sym_STAR] = ACTIONS(1336),
    [anon_sym_LBRACK] = ACTIONS(1336),
    [anon_sym_static] = ACTIONS(1338),
    [anon_sym_register] = ACTIONS(1338),
    [anon_sym_inline] = ACTIONS(1338),
    [anon_sym_const] = ACTIONS(1338),
    [anon_sym_restrict] = ACTIONS(1338),
    [anon_sym_volatile] = ACTIONS(1338),
    [anon_sym__Atomic] = ACTIONS(1338),
    [anon_sym_mutable] = ACTIONS(1338),
    [anon_sym_explicit] = ACTIONS(1338),
    [anon_sym_constexpr] = ACTIONS(1338),
    [anon_sym_unsigned] = ACTIONS(1338),
    [anon_sym_long] = ACTIONS(1338),
    [anon_sym_short] = ACTIONS(1338),
    [sym_primitive_type] = ACTIONS(1338),
    [anon_sym_enum] = ACTIONS(1338),
    [anon_sym_struct] = ACTIONS(1338),
    [anon_sym_union] = ACTIONS(1338),
    [anon_sym_if] = ACTIONS(1338),
    [anon_sym_else] = ACTIONS(1338),
    [anon_sym_switch] = ACTIONS(1338),
    [anon_sym_case] = ACTIONS(1338),
    [anon_sym_default] = ACTIONS(1338),
    [anon_sym_while] = ACTIONS(1338),
    [anon_sym_do] = ACTIONS(1338),
    [anon_sym_for] = ACTIONS(1338),
    [anon_sym_return] = ACTIONS(1338),
    [anon_sym_break] = ACTIONS(1338),
    [anon_sym_continue] = ACTIONS(1338),
    [anon_sym_goto] = ACTIONS(1338),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_AMP_AMP] = ACTIONS(1336),
    [anon_sym_BANG] = ACTIONS(1336),
    [anon_sym_TILDE] = ACTIONS(1336),
    [anon_sym_PLUS] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_DASH_DASH] = ACTIONS(1336),
    [anon_sym_PLUS_PLUS] = ACTIONS(1336),
    [anon_sym_sizeof] = ACTIONS(1338),
    [sym_number_literal] = ACTIONS(1336),
    [anon_sym_SQUOTE] = ACTIONS(1336),
    [anon_sym_DQUOTE] = ACTIONS(1336),
    [sym_true] = ACTIONS(1338),
    [sym_false] = ACTIONS(1338),
    [sym_null] = ACTIONS(1338),
    [sym_identifier] = ACTIONS(1338),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1338),
    [sym_auto] = ACTIONS(1338),
    [anon_sym_typename] = ACTIONS(1338),
    [anon_sym_template] = ACTIONS(1338),
    [anon_sym_delete] = ACTIONS(1338),
    [anon_sym_namespace] = ACTIONS(1338),
    [anon_sym_using] = ACTIONS(1338),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_new] = ACTIONS(1338),
    [anon_sym_COLON_COLON] = ACTIONS(1336),
    [sym_operator_name] = ACTIONS(1336),
    [sym_nullptr] = ACTIONS(1338),
  },
  [1777] = {
    [anon_sym_SEMI] = ACTIONS(5436),
    [sym_comment] = ACTIONS(91),
  },
  [1778] = {
    [sym_compound_statement] = STATE(2478),
    [sym_labeled_statement] = STATE(2478),
    [sym_expression_statement] = STATE(2478),
    [sym_if_statement] = STATE(2478),
    [sym_switch_statement] = STATE(2478),
    [sym_case_statement] = STATE(2478),
    [sym_while_statement] = STATE(2478),
    [sym_do_statement] = STATE(2478),
    [sym_for_statement] = STATE(2478),
    [sym_return_statement] = STATE(2478),
    [sym_break_statement] = STATE(2478),
    [sym_continue_statement] = STATE(2478),
    [sym_goto_statement] = STATE(2478),
    [sym__expression] = STATE(1020),
    [sym_comma_expression] = STATE(1021),
    [sym_conditional_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1020),
    [sym_pointer_expression] = STATE(1020),
    [sym_logical_expression] = STATE(1020),
    [sym_bitwise_expression] = STATE(1020),
    [sym_equality_expression] = STATE(1020),
    [sym_relational_expression] = STATE(1020),
    [sym_shift_expression] = STATE(1020),
    [sym_math_expression] = STATE(1020),
    [sym_cast_expression] = STATE(1020),
    [sym_sizeof_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_field_expression] = STATE(1020),
    [sym_compound_literal_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_char_literal] = STATE(1020),
    [sym_concatenated_string] = STATE(1020),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1020),
    [sym_for_range_loop] = STATE(2478),
    [sym_try_statement] = STATE(2478),
    [sym_new_expression] = STATE(1020),
    [sym_delete_expression] = STATE(1020),
    [sym_lambda_expression] = STATE(1020),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2022),
    [anon_sym_SEMI] = ACTIONS(2036),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(2044),
    [anon_sym_switch] = ACTIONS(2046),
    [anon_sym_case] = ACTIONS(2048),
    [anon_sym_default] = ACTIONS(2050),
    [anon_sym_while] = ACTIONS(2052),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(2056),
    [anon_sym_return] = ACTIONS(2058),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2062),
    [anon_sym_goto] = ACTIONS(2064),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(5420),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2076),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2066),
  },
  [1779] = {
    [sym__declarator] = STATE(2479),
    [sym_pointer_declarator] = STATE(2479),
    [sym_function_declarator] = STATE(2479),
    [sym_array_declarator] = STATE(2479),
    [sym_reference_declarator] = STATE(2479),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(2479),
    [sym_destructor_name] = STATE(2479),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(494),
    [anon_sym_AMP] = ACTIONS(500),
    [anon_sym_AMP_AMP] = ACTIONS(502),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(431),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(5438),
  },
  [1780] = {
    [sym_parameter_list] = STATE(812),
    [anon_sym_SEMI] = ACTIONS(5440),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(574),
    [sym_comment] = ACTIONS(91),
  },
  [1781] = {
    [sym_function_definition] = STATE(2481),
    [sym_declaration] = STATE(2481),
    [sym__declaration_specifiers] = STATE(2482),
    [sym_storage_class_specifier] = STATE(818),
    [sym_type_qualifier] = STATE(818),
    [sym__type_specifier] = STATE(817),
    [sym_sized_type_specifier] = STATE(817),
    [sym_enum_specifier] = STATE(817),
    [sym_struct_specifier] = STATE(817),
    [sym_union_specifier] = STATE(817),
    [sym__empty_declaration] = STATE(2481),
    [sym_macro_type_specifier] = STATE(817),
    [sym_class_specifier] = STATE(817),
    [sym_dependent_type] = STATE(817),
    [sym_template_type] = STATE(272),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(180),
    [aux_sym__declaration_specifiers_repeat1] = STATE(818),
    [aux_sym_sized_type_specifier_repeat1] = STATE(819),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(1475),
    [anon_sym_long] = ACTIONS(1475),
    [anon_sym_short] = ACTIONS(1475),
    [sym_primitive_type] = ACTIONS(1477),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [sym_identifier] = ACTIONS(492),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(1477),
    [anon_sym_typename] = ACTIONS(1479),
    [anon_sym_COLON_COLON] = ACTIONS(315),
  },
  [1782] = {
    [sym_preproc_include] = STATE(2484),
    [sym_preproc_def] = STATE(2484),
    [sym_preproc_function_def] = STATE(2484),
    [sym_preproc_call] = STATE(2484),
    [sym_preproc_if] = STATE(2484),
    [sym_preproc_ifdef] = STATE(2484),
    [sym_function_definition] = STATE(2484),
    [sym_declaration] = STATE(2484),
    [sym_type_definition] = STATE(2484),
    [sym__declaration_specifiers] = STATE(49),
    [sym_linkage_specification] = STATE(2484),
    [sym__declarator] = STATE(50),
    [sym_pointer_declarator] = STATE(50),
    [sym_function_declarator] = STATE(51),
    [sym_array_declarator] = STATE(50),
    [sym_compound_statement] = STATE(2484),
    [sym_storage_class_specifier] = STATE(63),
    [sym_type_qualifier] = STATE(63),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(2484),
    [sym_expression_statement] = STATE(2484),
    [sym_if_statement] = STATE(2484),
    [sym_switch_statement] = STATE(2484),
    [sym_case_statement] = STATE(2484),
    [sym_while_statement] = STATE(2484),
    [sym_do_statement] = STATE(2484),
    [sym_for_statement] = STATE(2484),
    [sym_return_statement] = STATE(2484),
    [sym_break_statement] = STATE(2484),
    [sym_continue_statement] = STATE(2484),
    [sym_goto_statement] = STATE(2484),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(2484),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(2484),
    [sym_template_declaration] = STATE(2484),
    [sym_template_instantiation] = STATE(2484),
    [sym_constructor_or_destructor_definition] = STATE(2484),
    [sym_reference_declarator] = STATE(50),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(57),
    [sym_namespace_definition] = STATE(2484),
    [sym_using_declaration] = STATE(2484),
    [sym_alias_declaration] = STATE(2484),
    [sym_for_range_loop] = STATE(2484),
    [sym_try_statement] = STATE(2484),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_destructor_name] = STATE(50),
    [sym_scoped_identifier] = STATE(59),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_translation_unit_repeat1] = STATE(2484),
    [aux_sym__declaration_specifiers_repeat1] = STATE(63),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(5),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(9),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(13),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(15),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(15),
    [sym_preproc_directive] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_RBRACE] = ACTIONS(5442),
    [anon_sym_LPAREN2] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(1495),
    [anon_sym_switch] = ACTIONS(1497),
    [anon_sym_case] = ACTIONS(1499),
    [anon_sym_default] = ACTIONS(1501),
    [anon_sym_while] = ACTIONS(1503),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(1505),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(1507),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_template] = ACTIONS(97),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_namespace] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(103),
    [anon_sym_try] = ACTIONS(1509),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_operator_name] = ACTIONS(111),
    [sym_nullptr] = ACTIONS(87),
  },
  [1783] = {
    [sym_declaration_list] = STATE(2485),
    [anon_sym_LBRACE] = ACTIONS(3775),
    [sym_comment] = ACTIONS(91),
  },
  [1784] = {
    [sym_raw_string_literal] = ACTIONS(1511),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1513),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1513),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1513),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1513),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1513),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1513),
    [sym_preproc_directive] = ACTIONS(1513),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_typedef] = ACTIONS(1513),
    [anon_sym_extern] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_LPAREN2] = ACTIONS(1511),
    [anon_sym_STAR] = ACTIONS(1511),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_static] = ACTIONS(1513),
    [anon_sym_register] = ACTIONS(1513),
    [anon_sym_inline] = ACTIONS(1513),
    [anon_sym_const] = ACTIONS(1513),
    [anon_sym_restrict] = ACTIONS(1513),
    [anon_sym_volatile] = ACTIONS(1513),
    [anon_sym__Atomic] = ACTIONS(1513),
    [anon_sym_mutable] = ACTIONS(1513),
    [anon_sym_explicit] = ACTIONS(1513),
    [anon_sym_constexpr] = ACTIONS(1513),
    [anon_sym_unsigned] = ACTIONS(1513),
    [anon_sym_long] = ACTIONS(1513),
    [anon_sym_short] = ACTIONS(1513),
    [sym_primitive_type] = ACTIONS(1513),
    [anon_sym_enum] = ACTIONS(1513),
    [anon_sym_struct] = ACTIONS(1513),
    [anon_sym_union] = ACTIONS(1513),
    [anon_sym_if] = ACTIONS(1513),
    [anon_sym_switch] = ACTIONS(1513),
    [anon_sym_case] = ACTIONS(1513),
    [anon_sym_default] = ACTIONS(1513),
    [anon_sym_while] = ACTIONS(1513),
    [anon_sym_do] = ACTIONS(1513),
    [anon_sym_for] = ACTIONS(1513),
    [anon_sym_return] = ACTIONS(1513),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_continue] = ACTIONS(1513),
    [anon_sym_goto] = ACTIONS(1513),
    [anon_sym_AMP] = ACTIONS(1513),
    [anon_sym_AMP_AMP] = ACTIONS(1511),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_DASH_DASH] = ACTIONS(1511),
    [anon_sym_PLUS_PLUS] = ACTIONS(1511),
    [anon_sym_sizeof] = ACTIONS(1513),
    [sym_number_literal] = ACTIONS(1511),
    [anon_sym_SQUOTE] = ACTIONS(1511),
    [anon_sym_DQUOTE] = ACTIONS(1511),
    [sym_true] = ACTIONS(1513),
    [sym_false] = ACTIONS(1513),
    [sym_null] = ACTIONS(1513),
    [sym_identifier] = ACTIONS(1513),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1513),
    [sym_auto] = ACTIONS(1513),
    [anon_sym_typename] = ACTIONS(1513),
    [anon_sym_template] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_namespace] = ACTIONS(1513),
    [anon_sym_using] = ACTIONS(1513),
    [anon_sym_try] = ACTIONS(1513),
    [anon_sym_new] = ACTIONS(1513),
    [anon_sym_COLON_COLON] = ACTIONS(1511),
    [sym_operator_name] = ACTIONS(1511),
    [sym_nullptr] = ACTIONS(1513),
  },
  [1785] = {
    [sym_template_argument_list] = STATE(437),
    [anon_sym_SEMI] = ACTIONS(5444),
    [anon_sym_EQ] = ACTIONS(5446),
    [anon_sym_LT] = ACTIONS(945),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1519),
  },
  [1786] = {
    [sym_template_type] = STATE(296),
    [sym_scoped_identifier] = STATE(2489),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(296),
    [sym_identifier] = ACTIONS(5448),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(528),
  },
  [1787] = {
    [anon_sym_SEMI] = ACTIONS(5444),
    [sym_comment] = ACTIONS(91),
  },
  [1788] = {
    [sym_catch_clause] = STATE(2491),
    [aux_sym_try_statement_repeat1] = STATE(2491),
    [sym_comment] = ACTIONS(91),
    [anon_sym_catch] = ACTIONS(5450),
  },
  [1789] = {
    [sym_raw_string_literal] = ACTIONS(1597),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1599),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1599),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1599),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1599),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1599),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1599),
    [sym_preproc_directive] = ACTIONS(1599),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_typedef] = ACTIONS(1599),
    [anon_sym_extern] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1597),
    [anon_sym_LPAREN2] = ACTIONS(1597),
    [anon_sym_STAR] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_static] = ACTIONS(1599),
    [anon_sym_register] = ACTIONS(1599),
    [anon_sym_inline] = ACTIONS(1599),
    [anon_sym_const] = ACTIONS(1599),
    [anon_sym_restrict] = ACTIONS(1599),
    [anon_sym_volatile] = ACTIONS(1599),
    [anon_sym__Atomic] = ACTIONS(1599),
    [anon_sym_mutable] = ACTIONS(1599),
    [anon_sym_explicit] = ACTIONS(1599),
    [anon_sym_constexpr] = ACTIONS(1599),
    [anon_sym_unsigned] = ACTIONS(1599),
    [anon_sym_long] = ACTIONS(1599),
    [anon_sym_short] = ACTIONS(1599),
    [sym_primitive_type] = ACTIONS(1599),
    [anon_sym_enum] = ACTIONS(1599),
    [anon_sym_struct] = ACTIONS(1599),
    [anon_sym_union] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(1599),
    [anon_sym_switch] = ACTIONS(1599),
    [anon_sym_case] = ACTIONS(1599),
    [anon_sym_default] = ACTIONS(1599),
    [anon_sym_while] = ACTIONS(1599),
    [anon_sym_do] = ACTIONS(1599),
    [anon_sym_for] = ACTIONS(1599),
    [anon_sym_return] = ACTIONS(1599),
    [anon_sym_break] = ACTIONS(1599),
    [anon_sym_continue] = ACTIONS(1599),
    [anon_sym_goto] = ACTIONS(1599),
    [anon_sym_AMP] = ACTIONS(1599),
    [anon_sym_AMP_AMP] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1597),
    [anon_sym_TILDE] = ACTIONS(1597),
    [anon_sym_PLUS] = ACTIONS(1599),
    [anon_sym_DASH] = ACTIONS(1599),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_sizeof] = ACTIONS(1599),
    [sym_number_literal] = ACTIONS(1597),
    [anon_sym_SQUOTE] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1597),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_null] = ACTIONS(1599),
    [sym_identifier] = ACTIONS(1599),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1599),
    [sym_auto] = ACTIONS(1599),
    [anon_sym_typename] = ACTIONS(1599),
    [anon_sym_template] = ACTIONS(1599),
    [anon_sym_delete] = ACTIONS(1599),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_using] = ACTIONS(1599),
    [anon_sym_try] = ACTIONS(1599),
    [anon_sym_new] = ACTIONS(1599),
    [anon_sym_COLON_COLON] = ACTIONS(1597),
    [sym_operator_name] = ACTIONS(1597),
    [sym_nullptr] = ACTIONS(1599),
  },
  [1790] = {
    [sym_compound_statement] = STATE(2494),
    [sym_parameter_list] = STATE(897),
    [sym_argument_list] = STATE(898),
    [sym_initializer_list] = STATE(898),
    [aux_sym_declaration_repeat1] = STATE(2495),
    [anon_sym_COMMA] = ACTIONS(1613),
    [anon_sym_SEMI] = ACTIONS(5452),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [anon_sym_LPAREN2] = ACTIONS(1619),
    [anon_sym_LBRACK] = ACTIONS(574),
    [anon_sym_EQ] = ACTIONS(1621),
    [sym_comment] = ACTIONS(91),
  },
  [1791] = {
    [aux_sym_declaration_repeat1] = STATE(2495),
    [anon_sym_COMMA] = ACTIONS(1613),
    [anon_sym_SEMI] = ACTIONS(5452),
    [sym_comment] = ACTIONS(91),
  },
  [1792] = {
    [sym_argument_list] = STATE(2497),
    [sym_initializer_list] = STATE(2497),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(5456),
    [sym_comment] = ACTIONS(91),
  },
  [1793] = {
    [anon_sym_default] = ACTIONS(5458),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(5460),
  },
  [1794] = {
    [sym_raw_string_literal] = ACTIONS(1685),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1687),
    [sym_preproc_directive] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1685),
    [anon_sym_typedef] = ACTIONS(1687),
    [anon_sym_extern] = ACTIONS(1687),
    [anon_sym_LBRACE] = ACTIONS(1685),
    [anon_sym_LPAREN2] = ACTIONS(1685),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_LBRACK] = ACTIONS(1685),
    [anon_sym_static] = ACTIONS(1687),
    [anon_sym_register] = ACTIONS(1687),
    [anon_sym_inline] = ACTIONS(1687),
    [anon_sym_const] = ACTIONS(1687),
    [anon_sym_restrict] = ACTIONS(1687),
    [anon_sym_volatile] = ACTIONS(1687),
    [anon_sym__Atomic] = ACTIONS(1687),
    [anon_sym_mutable] = ACTIONS(1687),
    [anon_sym_explicit] = ACTIONS(1687),
    [anon_sym_constexpr] = ACTIONS(1687),
    [anon_sym_unsigned] = ACTIONS(1687),
    [anon_sym_long] = ACTIONS(1687),
    [anon_sym_short] = ACTIONS(1687),
    [sym_primitive_type] = ACTIONS(1687),
    [anon_sym_enum] = ACTIONS(1687),
    [anon_sym_struct] = ACTIONS(1687),
    [anon_sym_union] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1687),
    [anon_sym_switch] = ACTIONS(1687),
    [anon_sym_case] = ACTIONS(1687),
    [anon_sym_default] = ACTIONS(1687),
    [anon_sym_while] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1687),
    [anon_sym_for] = ACTIONS(1687),
    [anon_sym_return] = ACTIONS(1687),
    [anon_sym_break] = ACTIONS(1687),
    [anon_sym_continue] = ACTIONS(1687),
    [anon_sym_goto] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1685),
    [anon_sym_BANG] = ACTIONS(1685),
    [anon_sym_TILDE] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_DASH] = ACTIONS(1687),
    [anon_sym_DASH_DASH] = ACTIONS(1685),
    [anon_sym_PLUS_PLUS] = ACTIONS(1685),
    [anon_sym_sizeof] = ACTIONS(1687),
    [sym_number_literal] = ACTIONS(1685),
    [anon_sym_SQUOTE] = ACTIONS(1685),
    [anon_sym_DQUOTE] = ACTIONS(1685),
    [sym_true] = ACTIONS(1687),
    [sym_false] = ACTIONS(1687),
    [sym_null] = ACTIONS(1687),
    [sym_identifier] = ACTIONS(1687),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1687),
    [sym_auto] = ACTIONS(1687),
    [anon_sym_typename] = ACTIONS(1687),
    [anon_sym_template] = ACTIONS(1687),
    [anon_sym_delete] = ACTIONS(1687),
    [anon_sym_namespace] = ACTIONS(1687),
    [anon_sym_using] = ACTIONS(1687),
    [anon_sym_try] = ACTIONS(1687),
    [anon_sym_new] = ACTIONS(1687),
    [anon_sym_COLON_COLON] = ACTIONS(1685),
    [sym_operator_name] = ACTIONS(1685),
    [sym_nullptr] = ACTIONS(1687),
  },
  [1795] = {
    [sym_compound_statement] = STATE(2500),
    [sym_default_method_clause] = STATE(2500),
    [sym_delete_method_clause] = STATE(2500),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_EQ] = ACTIONS(3787),
    [sym_comment] = ACTIONS(91),
  },
  [1796] = {
    [sym_raw_string_literal] = ACTIONS(1697),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1699),
    [sym_preproc_directive] = ACTIONS(1699),
    [anon_sym_SEMI] = ACTIONS(1697),
    [anon_sym_typedef] = ACTIONS(1699),
    [anon_sym_extern] = ACTIONS(1699),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_LPAREN2] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1697),
    [anon_sym_LBRACK] = ACTIONS(1697),
    [anon_sym_static] = ACTIONS(1699),
    [anon_sym_register] = ACTIONS(1699),
    [anon_sym_inline] = ACTIONS(1699),
    [anon_sym_const] = ACTIONS(1699),
    [anon_sym_restrict] = ACTIONS(1699),
    [anon_sym_volatile] = ACTIONS(1699),
    [anon_sym__Atomic] = ACTIONS(1699),
    [anon_sym_mutable] = ACTIONS(1699),
    [anon_sym_explicit] = ACTIONS(1699),
    [anon_sym_constexpr] = ACTIONS(1699),
    [anon_sym_unsigned] = ACTIONS(1699),
    [anon_sym_long] = ACTIONS(1699),
    [anon_sym_short] = ACTIONS(1699),
    [sym_primitive_type] = ACTIONS(1699),
    [anon_sym_enum] = ACTIONS(1699),
    [anon_sym_struct] = ACTIONS(1699),
    [anon_sym_union] = ACTIONS(1699),
    [anon_sym_if] = ACTIONS(1699),
    [anon_sym_else] = ACTIONS(1699),
    [anon_sym_switch] = ACTIONS(1699),
    [anon_sym_case] = ACTIONS(1699),
    [anon_sym_default] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(1699),
    [anon_sym_do] = ACTIONS(1699),
    [anon_sym_for] = ACTIONS(1699),
    [anon_sym_return] = ACTIONS(1699),
    [anon_sym_break] = ACTIONS(1699),
    [anon_sym_continue] = ACTIONS(1699),
    [anon_sym_goto] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_AMP_AMP] = ACTIONS(1697),
    [anon_sym_BANG] = ACTIONS(1697),
    [anon_sym_TILDE] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1697),
    [anon_sym_PLUS_PLUS] = ACTIONS(1697),
    [anon_sym_sizeof] = ACTIONS(1699),
    [sym_number_literal] = ACTIONS(1697),
    [anon_sym_SQUOTE] = ACTIONS(1697),
    [anon_sym_DQUOTE] = ACTIONS(1697),
    [sym_true] = ACTIONS(1699),
    [sym_false] = ACTIONS(1699),
    [sym_null] = ACTIONS(1699),
    [sym_identifier] = ACTIONS(1699),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1699),
    [sym_auto] = ACTIONS(1699),
    [anon_sym_typename] = ACTIONS(1699),
    [anon_sym_template] = ACTIONS(1699),
    [anon_sym_delete] = ACTIONS(1699),
    [anon_sym_namespace] = ACTIONS(1699),
    [anon_sym_using] = ACTIONS(1699),
    [anon_sym_try] = ACTIONS(1699),
    [anon_sym_new] = ACTIONS(1699),
    [anon_sym_COLON_COLON] = ACTIONS(1697),
    [sym_operator_name] = ACTIONS(1697),
    [sym_nullptr] = ACTIONS(1699),
  },
  [1797] = {
    [sym_preproc_include] = STATE(1797),
    [sym_preproc_def] = STATE(1797),
    [sym_preproc_function_def] = STATE(1797),
    [sym_preproc_call] = STATE(1797),
    [sym_preproc_if] = STATE(1797),
    [sym_preproc_ifdef] = STATE(1797),
    [sym_function_definition] = STATE(1797),
    [sym_declaration] = STATE(1797),
    [sym_type_definition] = STATE(1797),
    [sym__declaration_specifiers] = STATE(1018),
    [sym_linkage_specification] = STATE(1797),
    [sym__declarator] = STATE(50),
    [sym_pointer_declarator] = STATE(50),
    [sym_function_declarator] = STATE(1019),
    [sym_array_declarator] = STATE(50),
    [sym_compound_statement] = STATE(1797),
    [sym_storage_class_specifier] = STATE(1023),
    [sym_type_qualifier] = STATE(1023),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(1797),
    [sym_expression_statement] = STATE(1797),
    [sym_if_statement] = STATE(1797),
    [sym_switch_statement] = STATE(1797),
    [sym_case_statement] = STATE(1797),
    [sym_while_statement] = STATE(1797),
    [sym_do_statement] = STATE(1797),
    [sym_for_statement] = STATE(1797),
    [sym_return_statement] = STATE(1797),
    [sym_break_statement] = STATE(1797),
    [sym_continue_statement] = STATE(1797),
    [sym_goto_statement] = STATE(1797),
    [sym__expression] = STATE(1020),
    [sym_comma_expression] = STATE(1021),
    [sym_conditional_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1020),
    [sym_pointer_expression] = STATE(1020),
    [sym_logical_expression] = STATE(1020),
    [sym_bitwise_expression] = STATE(1020),
    [sym_equality_expression] = STATE(1020),
    [sym_relational_expression] = STATE(1020),
    [sym_shift_expression] = STATE(1020),
    [sym_math_expression] = STATE(1020),
    [sym_cast_expression] = STATE(1020),
    [sym_sizeof_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_field_expression] = STATE(1020),
    [sym_compound_literal_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_char_literal] = STATE(1020),
    [sym_concatenated_string] = STATE(1020),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(1797),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(1797),
    [sym_template_declaration] = STATE(1797),
    [sym_template_instantiation] = STATE(1797),
    [sym_constructor_or_destructor_definition] = STATE(1797),
    [sym_reference_declarator] = STATE(50),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(57),
    [sym_namespace_definition] = STATE(1797),
    [sym_using_declaration] = STATE(1797),
    [sym_alias_declaration] = STATE(1797),
    [sym_for_range_loop] = STATE(1797),
    [sym_try_statement] = STATE(1797),
    [sym_new_expression] = STATE(1020),
    [sym_delete_expression] = STATE(1020),
    [sym_lambda_expression] = STATE(1020),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_destructor_name] = STATE(50),
    [sym_scoped_identifier] = STATE(59),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_translation_unit_repeat1] = STATE(1797),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1023),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(5462),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5465),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5468),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5471),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3867),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5474),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5474),
    [sym_preproc_directive] = ACTIONS(5477),
    [anon_sym_SEMI] = ACTIONS(5480),
    [anon_sym_typedef] = ACTIONS(5483),
    [anon_sym_extern] = ACTIONS(5486),
    [anon_sym_LBRACE] = ACTIONS(5489),
    [anon_sym_LPAREN2] = ACTIONS(1835),
    [anon_sym_STAR] = ACTIONS(1838),
    [anon_sym_LBRACK] = ACTIONS(1841),
    [anon_sym_static] = ACTIONS(1844),
    [anon_sym_register] = ACTIONS(1844),
    [anon_sym_inline] = ACTIONS(1844),
    [anon_sym_const] = ACTIONS(1847),
    [anon_sym_restrict] = ACTIONS(1847),
    [anon_sym_volatile] = ACTIONS(1847),
    [anon_sym__Atomic] = ACTIONS(1847),
    [anon_sym_mutable] = ACTIONS(1847),
    [anon_sym_explicit] = ACTIONS(1847),
    [anon_sym_constexpr] = ACTIONS(1847),
    [anon_sym_unsigned] = ACTIONS(1850),
    [anon_sym_long] = ACTIONS(1850),
    [anon_sym_short] = ACTIONS(1850),
    [sym_primitive_type] = ACTIONS(1853),
    [anon_sym_enum] = ACTIONS(1856),
    [anon_sym_struct] = ACTIONS(1859),
    [anon_sym_union] = ACTIONS(1862),
    [anon_sym_if] = ACTIONS(5492),
    [anon_sym_switch] = ACTIONS(5495),
    [anon_sym_case] = ACTIONS(5498),
    [anon_sym_default] = ACTIONS(5501),
    [anon_sym_while] = ACTIONS(5504),
    [anon_sym_do] = ACTIONS(5507),
    [anon_sym_for] = ACTIONS(5510),
    [anon_sym_return] = ACTIONS(5513),
    [anon_sym_break] = ACTIONS(5516),
    [anon_sym_continue] = ACTIONS(5519),
    [anon_sym_goto] = ACTIONS(5522),
    [anon_sym_AMP] = ACTIONS(1898),
    [anon_sym_AMP_AMP] = ACTIONS(1901),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1907),
    [anon_sym_PLUS] = ACTIONS(1910),
    [anon_sym_DASH] = ACTIONS(1910),
    [anon_sym_DASH_DASH] = ACTIONS(1913),
    [anon_sym_PLUS_PLUS] = ACTIONS(1913),
    [anon_sym_sizeof] = ACTIONS(1916),
    [sym_number_literal] = ACTIONS(5462),
    [anon_sym_SQUOTE] = ACTIONS(1919),
    [anon_sym_DQUOTE] = ACTIONS(1922),
    [sym_true] = ACTIONS(5525),
    [sym_false] = ACTIONS(5525),
    [sym_null] = ACTIONS(5525),
    [sym_identifier] = ACTIONS(5528),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1931),
    [sym_auto] = ACTIONS(1853),
    [anon_sym_typename] = ACTIONS(1934),
    [anon_sym_template] = ACTIONS(5531),
    [anon_sym_delete] = ACTIONS(1940),
    [anon_sym_namespace] = ACTIONS(5534),
    [anon_sym_using] = ACTIONS(5537),
    [anon_sym_try] = ACTIONS(5540),
    [anon_sym_new] = ACTIONS(1952),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [sym_operator_name] = ACTIONS(1958),
    [sym_nullptr] = ACTIONS(5525),
  },
  [1798] = {
    [sym_compound_statement] = STATE(2500),
    [sym_field_initializer_list] = STATE(2501),
    [sym_default_method_clause] = STATE(2500),
    [sym_delete_method_clause] = STATE(2500),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(576),
    [anon_sym_LBRACK] = ACTIONS(576),
    [anon_sym_EQ] = ACTIONS(3787),
    [anon_sym_COLON] = ACTIONS(580),
    [sym_comment] = ACTIONS(91),
  },
  [1799] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5543),
    [sym_comment] = ACTIONS(91),
  },
  [1800] = {
    [sym_preproc_include] = STATE(1067),
    [sym_preproc_def] = STATE(1067),
    [sym_preproc_function_def] = STATE(1067),
    [sym_preproc_call] = STATE(1067),
    [sym_preproc_if] = STATE(1067),
    [sym_preproc_ifdef] = STATE(1067),
    [sym_preproc_else] = STATE(2502),
    [sym_preproc_elif] = STATE(2502),
    [sym_function_definition] = STATE(1067),
    [sym_declaration] = STATE(1067),
    [sym_type_definition] = STATE(1067),
    [sym__declaration_specifiers] = STATE(409),
    [sym_linkage_specification] = STATE(1067),
    [sym__declarator] = STATE(50),
    [sym_pointer_declarator] = STATE(50),
    [sym_function_declarator] = STATE(410),
    [sym_array_declarator] = STATE(50),
    [sym_compound_statement] = STATE(1067),
    [sym_storage_class_specifier] = STATE(414),
    [sym_type_qualifier] = STATE(414),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(1067),
    [sym_expression_statement] = STATE(1067),
    [sym_if_statement] = STATE(1067),
    [sym_switch_statement] = STATE(1067),
    [sym_case_statement] = STATE(1067),
    [sym_while_statement] = STATE(1067),
    [sym_do_statement] = STATE(1067),
    [sym_for_statement] = STATE(1067),
    [sym_return_statement] = STATE(1067),
    [sym_break_statement] = STATE(1067),
    [sym_continue_statement] = STATE(1067),
    [sym_goto_statement] = STATE(1067),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(1067),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(1067),
    [sym_template_declaration] = STATE(1067),
    [sym_template_instantiation] = STATE(1067),
    [sym_constructor_or_destructor_definition] = STATE(1067),
    [sym_reference_declarator] = STATE(50),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(57),
    [sym_namespace_definition] = STATE(1067),
    [sym_using_declaration] = STATE(1067),
    [sym_alias_declaration] = STATE(1067),
    [sym_for_range_loop] = STATE(1067),
    [sym_try_statement] = STATE(1067),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_destructor_name] = STATE(50),
    [sym_scoped_identifier] = STATE(59),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_translation_unit_repeat1] = STATE(1067),
    [aux_sym__declaration_specifiers_repeat1] = STATE(414),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(678),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(684),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5545),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(688),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(688),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(690),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(692),
    [sym_preproc_directive] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_typedef] = ACTIONS(698),
    [anon_sym_extern] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(704),
    [anon_sym_switch] = ACTIONS(706),
    [anon_sym_case] = ACTIONS(708),
    [anon_sym_default] = ACTIONS(710),
    [anon_sym_while] = ACTIONS(712),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(728),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_template] = ACTIONS(730),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_namespace] = ACTIONS(732),
    [anon_sym_using] = ACTIONS(734),
    [anon_sym_try] = ACTIONS(736),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_operator_name] = ACTIONS(111),
    [sym_nullptr] = ACTIONS(726),
  },
  [1801] = {
    [sym_raw_string_literal] = ACTIONS(2144),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2146),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2146),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2146),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2146),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2146),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2146),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2146),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2146),
    [sym_preproc_directive] = ACTIONS(2146),
    [anon_sym_SEMI] = ACTIONS(2144),
    [anon_sym_typedef] = ACTIONS(2146),
    [anon_sym_extern] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(2144),
    [anon_sym_LPAREN2] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(2144),
    [anon_sym_LBRACK] = ACTIONS(2144),
    [anon_sym_static] = ACTIONS(2146),
    [anon_sym_register] = ACTIONS(2146),
    [anon_sym_inline] = ACTIONS(2146),
    [anon_sym_const] = ACTIONS(2146),
    [anon_sym_restrict] = ACTIONS(2146),
    [anon_sym_volatile] = ACTIONS(2146),
    [anon_sym__Atomic] = ACTIONS(2146),
    [anon_sym_mutable] = ACTIONS(2146),
    [anon_sym_explicit] = ACTIONS(2146),
    [anon_sym_constexpr] = ACTIONS(2146),
    [anon_sym_unsigned] = ACTIONS(2146),
    [anon_sym_long] = ACTIONS(2146),
    [anon_sym_short] = ACTIONS(2146),
    [sym_primitive_type] = ACTIONS(2146),
    [anon_sym_enum] = ACTIONS(2146),
    [anon_sym_struct] = ACTIONS(2146),
    [anon_sym_union] = ACTIONS(2146),
    [anon_sym_if] = ACTIONS(2146),
    [anon_sym_switch] = ACTIONS(2146),
    [anon_sym_case] = ACTIONS(2146),
    [anon_sym_default] = ACTIONS(2146),
    [anon_sym_while] = ACTIONS(2146),
    [anon_sym_do] = ACTIONS(2146),
    [anon_sym_for] = ACTIONS(2146),
    [anon_sym_return] = ACTIONS(2146),
    [anon_sym_break] = ACTIONS(2146),
    [anon_sym_continue] = ACTIONS(2146),
    [anon_sym_goto] = ACTIONS(2146),
    [anon_sym_AMP] = ACTIONS(2146),
    [anon_sym_AMP_AMP] = ACTIONS(2144),
    [anon_sym_BANG] = ACTIONS(2144),
    [anon_sym_TILDE] = ACTIONS(2144),
    [anon_sym_PLUS] = ACTIONS(2146),
    [anon_sym_DASH] = ACTIONS(2146),
    [anon_sym_DASH_DASH] = ACTIONS(2144),
    [anon_sym_PLUS_PLUS] = ACTIONS(2144),
    [anon_sym_sizeof] = ACTIONS(2146),
    [sym_number_literal] = ACTIONS(2144),
    [anon_sym_SQUOTE] = ACTIONS(2144),
    [anon_sym_DQUOTE] = ACTIONS(2144),
    [sym_true] = ACTIONS(2146),
    [sym_false] = ACTIONS(2146),
    [sym_null] = ACTIONS(2146),
    [sym_identifier] = ACTIONS(2146),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2146),
    [sym_auto] = ACTIONS(2146),
    [anon_sym_typename] = ACTIONS(2146),
    [anon_sym_template] = ACTIONS(2146),
    [anon_sym_delete] = ACTIONS(2146),
    [anon_sym_namespace] = ACTIONS(2146),
    [anon_sym_using] = ACTIONS(2146),
    [anon_sym_try] = ACTIONS(2146),
    [anon_sym_new] = ACTIONS(2146),
    [anon_sym_COLON_COLON] = ACTIONS(2144),
    [sym_operator_name] = ACTIONS(2144),
    [sym_nullptr] = ACTIONS(2146),
  },
  [1802] = {
    [sym_parameter_list] = STATE(1105),
    [anon_sym_SEMI] = ACTIONS(5547),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [sym_comment] = ACTIONS(91),
  },
  [1803] = {
    [sym__type_declarator] = STATE(2504),
    [sym_pointer_type_declarator] = STATE(2504),
    [sym_function_type_declarator] = STATE(2504),
    [sym_array_type_declarator] = STATE(2504),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_STAR] = ACTIONS(768),
    [sym_identifier] = ACTIONS(770),
    [sym_comment] = ACTIONS(91),
  },
  [1804] = {
    [sym_raw_string_literal] = ACTIONS(2184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2186),
    [sym_preproc_directive] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2184),
    [anon_sym_typedef] = ACTIONS(2186),
    [anon_sym_extern] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2184),
    [anon_sym_LPAREN2] = ACTIONS(2184),
    [anon_sym_STAR] = ACTIONS(2184),
    [anon_sym_LBRACK] = ACTIONS(2184),
    [anon_sym_static] = ACTIONS(2186),
    [anon_sym_register] = ACTIONS(2186),
    [anon_sym_inline] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_restrict] = ACTIONS(2186),
    [anon_sym_volatile] = ACTIONS(2186),
    [anon_sym__Atomic] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_explicit] = ACTIONS(2186),
    [anon_sym_constexpr] = ACTIONS(2186),
    [anon_sym_unsigned] = ACTIONS(2186),
    [anon_sym_long] = ACTIONS(2186),
    [anon_sym_short] = ACTIONS(2186),
    [sym_primitive_type] = ACTIONS(2186),
    [anon_sym_enum] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_union] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_switch] = ACTIONS(2186),
    [anon_sym_case] = ACTIONS(2186),
    [anon_sym_default] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [anon_sym_do] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_break] = ACTIONS(2186),
    [anon_sym_continue] = ACTIONS(2186),
    [anon_sym_goto] = ACTIONS(2186),
    [anon_sym_AMP] = ACTIONS(2186),
    [anon_sym_AMP_AMP] = ACTIONS(2184),
    [anon_sym_BANG] = ACTIONS(2184),
    [anon_sym_TILDE] = ACTIONS(2184),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_DASH] = ACTIONS(2186),
    [anon_sym_DASH_DASH] = ACTIONS(2184),
    [anon_sym_PLUS_PLUS] = ACTIONS(2184),
    [anon_sym_sizeof] = ACTIONS(2186),
    [sym_number_literal] = ACTIONS(2184),
    [anon_sym_SQUOTE] = ACTIONS(2184),
    [anon_sym_DQUOTE] = ACTIONS(2184),
    [sym_true] = ACTIONS(2186),
    [sym_false] = ACTIONS(2186),
    [sym_null] = ACTIONS(2186),
    [sym_identifier] = ACTIONS(2186),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2186),
    [sym_auto] = ACTIONS(2186),
    [anon_sym_typename] = ACTIONS(2186),
    [anon_sym_template] = ACTIONS(2186),
    [anon_sym_delete] = ACTIONS(2186),
    [anon_sym_namespace] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_new] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2184),
    [sym_operator_name] = ACTIONS(2184),
    [sym_nullptr] = ACTIONS(2186),
  },
  [1805] = {
    [sym__declarator] = STATE(1059),
    [sym_pointer_declarator] = STATE(1059),
    [sym_function_declarator] = STATE(1059),
    [sym_array_declarator] = STATE(1059),
    [sym_init_declarator] = STATE(1060),
    [sym_reference_declarator] = STATE(1059),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(1059),
    [sym_destructor_name] = STATE(1059),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(560),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(568),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(2128),
  },
  [1806] = {
    [sym_raw_string_literal] = ACTIONS(2286),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2288),
    [sym_preproc_directive] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym_typedef] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_STAR] = ACTIONS(2286),
    [anon_sym_LBRACK] = ACTIONS(2286),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_register] = ACTIONS(2288),
    [anon_sym_inline] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_explicit] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_unsigned] = ACTIONS(2288),
    [anon_sym_long] = ACTIONS(2288),
    [anon_sym_short] = ACTIONS(2288),
    [sym_primitive_type] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [anon_sym_struct] = ACTIONS(2288),
    [anon_sym_union] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_else] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_goto] = ACTIONS(2288),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_BANG] = ACTIONS(2286),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_sizeof] = ACTIONS(2288),
    [sym_number_literal] = ACTIONS(2286),
    [anon_sym_SQUOTE] = ACTIONS(2286),
    [anon_sym_DQUOTE] = ACTIONS(2286),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [sym_null] = ACTIONS(2288),
    [sym_identifier] = ACTIONS(2288),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2288),
    [sym_auto] = ACTIONS(2288),
    [anon_sym_typename] = ACTIONS(2288),
    [anon_sym_template] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_catch] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [sym_operator_name] = ACTIONS(2286),
    [sym_nullptr] = ACTIONS(2288),
  },
  [1807] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(5549),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1808] = {
    [sym__expression] = STATE(2506),
    [sym_conditional_expression] = STATE(2506),
    [sym_assignment_expression] = STATE(2506),
    [sym_pointer_expression] = STATE(2506),
    [sym_logical_expression] = STATE(2506),
    [sym_bitwise_expression] = STATE(2506),
    [sym_equality_expression] = STATE(2506),
    [sym_relational_expression] = STATE(2506),
    [sym_shift_expression] = STATE(2506),
    [sym_math_expression] = STATE(2506),
    [sym_cast_expression] = STATE(2506),
    [sym_sizeof_expression] = STATE(2506),
    [sym_subscript_expression] = STATE(2506),
    [sym_call_expression] = STATE(2506),
    [sym_field_expression] = STATE(2506),
    [sym_compound_literal_expression] = STATE(2506),
    [sym_parenthesized_expression] = STATE(2506),
    [sym_char_literal] = STATE(2506),
    [sym_concatenated_string] = STATE(2506),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2506),
    [sym_new_expression] = STATE(2506),
    [sym_delete_expression] = STATE(2506),
    [sym_lambda_expression] = STATE(2506),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5551),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(5551),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(5553),
    [sym_false] = ACTIONS(5553),
    [sym_null] = ACTIONS(5553),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(5553),
  },
  [1809] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(548),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_COLON] = ACTIONS(2112),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(935),
  },
  [1810] = {
    [sym_raw_string_literal] = ACTIONS(2767),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2769),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2769),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2769),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2769),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2769),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2769),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2769),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2769),
    [sym_preproc_directive] = ACTIONS(2769),
    [anon_sym_SEMI] = ACTIONS(2767),
    [anon_sym_typedef] = ACTIONS(2769),
    [anon_sym_extern] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_LPAREN2] = ACTIONS(2767),
    [anon_sym_STAR] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(2767),
    [anon_sym_static] = ACTIONS(2769),
    [anon_sym_register] = ACTIONS(2769),
    [anon_sym_inline] = ACTIONS(2769),
    [anon_sym_const] = ACTIONS(2769),
    [anon_sym_restrict] = ACTIONS(2769),
    [anon_sym_volatile] = ACTIONS(2769),
    [anon_sym__Atomic] = ACTIONS(2769),
    [anon_sym_mutable] = ACTIONS(2769),
    [anon_sym_explicit] = ACTIONS(2769),
    [anon_sym_constexpr] = ACTIONS(2769),
    [anon_sym_unsigned] = ACTIONS(2769),
    [anon_sym_long] = ACTIONS(2769),
    [anon_sym_short] = ACTIONS(2769),
    [sym_primitive_type] = ACTIONS(2769),
    [anon_sym_enum] = ACTIONS(2769),
    [anon_sym_struct] = ACTIONS(2769),
    [anon_sym_union] = ACTIONS(2769),
    [anon_sym_if] = ACTIONS(2769),
    [anon_sym_else] = ACTIONS(2769),
    [anon_sym_switch] = ACTIONS(2769),
    [anon_sym_case] = ACTIONS(2769),
    [anon_sym_default] = ACTIONS(2769),
    [anon_sym_while] = ACTIONS(2769),
    [anon_sym_do] = ACTIONS(2769),
    [anon_sym_for] = ACTIONS(2769),
    [anon_sym_return] = ACTIONS(2769),
    [anon_sym_break] = ACTIONS(2769),
    [anon_sym_continue] = ACTIONS(2769),
    [anon_sym_goto] = ACTIONS(2769),
    [anon_sym_AMP] = ACTIONS(2769),
    [anon_sym_AMP_AMP] = ACTIONS(2767),
    [anon_sym_BANG] = ACTIONS(2767),
    [anon_sym_TILDE] = ACTIONS(2767),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_DASH_DASH] = ACTIONS(2767),
    [anon_sym_PLUS_PLUS] = ACTIONS(2767),
    [anon_sym_sizeof] = ACTIONS(2769),
    [sym_number_literal] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(2767),
    [anon_sym_DQUOTE] = ACTIONS(2767),
    [sym_true] = ACTIONS(2769),
    [sym_false] = ACTIONS(2769),
    [sym_null] = ACTIONS(2769),
    [sym_identifier] = ACTIONS(2769),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2769),
    [sym_auto] = ACTIONS(2769),
    [anon_sym_typename] = ACTIONS(2769),
    [anon_sym_template] = ACTIONS(2769),
    [anon_sym_delete] = ACTIONS(2769),
    [anon_sym_namespace] = ACTIONS(2769),
    [anon_sym_using] = ACTIONS(2769),
    [anon_sym_try] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2769),
    [anon_sym_COLON_COLON] = ACTIONS(2767),
    [sym_operator_name] = ACTIONS(2767),
    [sym_nullptr] = ACTIONS(2769),
  },
  [1811] = {
    [sym_declaration] = STATE(2507),
    [sym_type_definition] = STATE(2507),
    [sym__declaration_specifiers] = STATE(1814),
    [sym_compound_statement] = STATE(2507),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_labeled_statement] = STATE(2507),
    [sym_expression_statement] = STATE(2507),
    [sym_if_statement] = STATE(2507),
    [sym_switch_statement] = STATE(2507),
    [sym_case_statement] = STATE(2507),
    [sym_while_statement] = STATE(2507),
    [sym_do_statement] = STATE(2507),
    [sym_for_statement] = STATE(2507),
    [sym_return_statement] = STATE(2507),
    [sym_break_statement] = STATE(2507),
    [sym_continue_statement] = STATE(2507),
    [sym_goto_statement] = STATE(2507),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(411),
    [sym_for_range_loop] = STATE(2507),
    [sym_try_statement] = STATE(2507),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(678),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_typedef] = ACTIONS(698),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(704),
    [anon_sym_switch] = ACTIONS(706),
    [anon_sym_case] = ACTIONS(708),
    [anon_sym_default] = ACTIONS(710),
    [anon_sym_while] = ACTIONS(712),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(3811),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(736),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(1202),
    [sym_nullptr] = ACTIONS(726),
  },
  [1812] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(1362),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_extern] = ACTIONS(468),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(465),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_register] = ACTIONS(468),
    [anon_sym_inline] = ACTIONS(468),
    [anon_sym_const] = ACTIONS(468),
    [anon_sym_restrict] = ACTIONS(468),
    [anon_sym_volatile] = ACTIONS(468),
    [anon_sym__Atomic] = ACTIONS(468),
    [anon_sym_mutable] = ACTIONS(468),
    [anon_sym_explicit] = ACTIONS(468),
    [anon_sym_constexpr] = ACTIONS(468),
    [anon_sym_COLON] = ACTIONS(2112),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(474),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_TILDE] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_identifier] = ACTIONS(468),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(2855),
    [sym_operator_name] = ACTIONS(481),
  },
  [1813] = {
    [sym_raw_string_literal] = ACTIONS(2859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2861),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2861),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2861),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2861),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2861),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2861),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2861),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2861),
    [sym_preproc_directive] = ACTIONS(2861),
    [anon_sym_SEMI] = ACTIONS(2859),
    [anon_sym_typedef] = ACTIONS(2861),
    [anon_sym_extern] = ACTIONS(2861),
    [anon_sym_LBRACE] = ACTIONS(2859),
    [anon_sym_LPAREN2] = ACTIONS(2859),
    [anon_sym_STAR] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_static] = ACTIONS(2861),
    [anon_sym_register] = ACTIONS(2861),
    [anon_sym_inline] = ACTIONS(2861),
    [anon_sym_const] = ACTIONS(2861),
    [anon_sym_restrict] = ACTIONS(2861),
    [anon_sym_volatile] = ACTIONS(2861),
    [anon_sym__Atomic] = ACTIONS(2861),
    [anon_sym_mutable] = ACTIONS(2861),
    [anon_sym_explicit] = ACTIONS(2861),
    [anon_sym_constexpr] = ACTIONS(2861),
    [anon_sym_unsigned] = ACTIONS(2861),
    [anon_sym_long] = ACTIONS(2861),
    [anon_sym_short] = ACTIONS(2861),
    [sym_primitive_type] = ACTIONS(2861),
    [anon_sym_enum] = ACTIONS(2861),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2861),
    [anon_sym_if] = ACTIONS(2861),
    [anon_sym_else] = ACTIONS(2861),
    [anon_sym_switch] = ACTIONS(2861),
    [anon_sym_case] = ACTIONS(2861),
    [anon_sym_default] = ACTIONS(2861),
    [anon_sym_while] = ACTIONS(2861),
    [anon_sym_do] = ACTIONS(2861),
    [anon_sym_for] = ACTIONS(2861),
    [anon_sym_return] = ACTIONS(2861),
    [anon_sym_break] = ACTIONS(2861),
    [anon_sym_continue] = ACTIONS(2861),
    [anon_sym_goto] = ACTIONS(2861),
    [anon_sym_AMP] = ACTIONS(2861),
    [anon_sym_AMP_AMP] = ACTIONS(2859),
    [anon_sym_BANG] = ACTIONS(2859),
    [anon_sym_TILDE] = ACTIONS(2859),
    [anon_sym_PLUS] = ACTIONS(2861),
    [anon_sym_DASH] = ACTIONS(2861),
    [anon_sym_DASH_DASH] = ACTIONS(2859),
    [anon_sym_PLUS_PLUS] = ACTIONS(2859),
    [anon_sym_sizeof] = ACTIONS(2861),
    [sym_number_literal] = ACTIONS(2859),
    [anon_sym_SQUOTE] = ACTIONS(2859),
    [anon_sym_DQUOTE] = ACTIONS(2859),
    [sym_true] = ACTIONS(2861),
    [sym_false] = ACTIONS(2861),
    [sym_null] = ACTIONS(2861),
    [sym_identifier] = ACTIONS(2861),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2861),
    [sym_auto] = ACTIONS(2861),
    [anon_sym_typename] = ACTIONS(2861),
    [anon_sym_template] = ACTIONS(2861),
    [anon_sym_delete] = ACTIONS(2861),
    [anon_sym_namespace] = ACTIONS(2861),
    [anon_sym_using] = ACTIONS(2861),
    [anon_sym_try] = ACTIONS(2861),
    [anon_sym_new] = ACTIONS(2861),
    [anon_sym_COLON_COLON] = ACTIONS(2859),
    [sym_operator_name] = ACTIONS(2859),
    [sym_nullptr] = ACTIONS(2861),
  },
  [1814] = {
    [sym__declarator] = STATE(2508),
    [sym_pointer_declarator] = STATE(2508),
    [sym_function_declarator] = STATE(2508),
    [sym_array_declarator] = STATE(2508),
    [sym_init_declarator] = STATE(1060),
    [sym_reference_declarator] = STATE(2508),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(2508),
    [sym_destructor_name] = STATE(2508),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(560),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(568),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(5555),
  },
  [1815] = {
    [sym_raw_string_literal] = ACTIONS(2867),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2869),
    [sym_preproc_directive] = ACTIONS(2869),
    [anon_sym_SEMI] = ACTIONS(2867),
    [anon_sym_typedef] = ACTIONS(2869),
    [anon_sym_extern] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2867),
    [anon_sym_STAR] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_static] = ACTIONS(2869),
    [anon_sym_register] = ACTIONS(2869),
    [anon_sym_inline] = ACTIONS(2869),
    [anon_sym_const] = ACTIONS(2869),
    [anon_sym_restrict] = ACTIONS(2869),
    [anon_sym_volatile] = ACTIONS(2869),
    [anon_sym__Atomic] = ACTIONS(2869),
    [anon_sym_mutable] = ACTIONS(2869),
    [anon_sym_explicit] = ACTIONS(2869),
    [anon_sym_constexpr] = ACTIONS(2869),
    [anon_sym_unsigned] = ACTIONS(2869),
    [anon_sym_long] = ACTIONS(2869),
    [anon_sym_short] = ACTIONS(2869),
    [sym_primitive_type] = ACTIONS(2869),
    [anon_sym_enum] = ACTIONS(2869),
    [anon_sym_struct] = ACTIONS(2869),
    [anon_sym_union] = ACTIONS(2869),
    [anon_sym_if] = ACTIONS(2869),
    [anon_sym_else] = ACTIONS(2869),
    [anon_sym_switch] = ACTIONS(2869),
    [anon_sym_case] = ACTIONS(2869),
    [anon_sym_default] = ACTIONS(2869),
    [anon_sym_while] = ACTIONS(2869),
    [anon_sym_do] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2869),
    [anon_sym_return] = ACTIONS(2869),
    [anon_sym_break] = ACTIONS(2869),
    [anon_sym_continue] = ACTIONS(2869),
    [anon_sym_goto] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2869),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_BANG] = ACTIONS(2867),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2869),
    [anon_sym_DASH] = ACTIONS(2869),
    [anon_sym_DASH_DASH] = ACTIONS(2867),
    [anon_sym_PLUS_PLUS] = ACTIONS(2867),
    [anon_sym_sizeof] = ACTIONS(2869),
    [sym_number_literal] = ACTIONS(2867),
    [anon_sym_SQUOTE] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [sym_true] = ACTIONS(2869),
    [sym_false] = ACTIONS(2869),
    [sym_null] = ACTIONS(2869),
    [sym_identifier] = ACTIONS(2869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2869),
    [sym_auto] = ACTIONS(2869),
    [anon_sym_typename] = ACTIONS(2869),
    [anon_sym_template] = ACTIONS(2869),
    [anon_sym_delete] = ACTIONS(2869),
    [anon_sym_namespace] = ACTIONS(2869),
    [anon_sym_using] = ACTIONS(2869),
    [anon_sym_try] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_COLON_COLON] = ACTIONS(2867),
    [sym_operator_name] = ACTIONS(2867),
    [sym_nullptr] = ACTIONS(2869),
  },
  [1816] = {
    [sym_parenthesized_expression] = STATE(2510),
    [anon_sym_LPAREN2] = ACTIONS(5557),
    [sym_comment] = ACTIONS(91),
  },
  [1817] = {
    [sym__expression] = STATE(2512),
    [sym_conditional_expression] = STATE(2512),
    [sym_assignment_expression] = STATE(2512),
    [sym_pointer_expression] = STATE(2512),
    [sym_logical_expression] = STATE(2512),
    [sym_bitwise_expression] = STATE(2512),
    [sym_equality_expression] = STATE(2512),
    [sym_relational_expression] = STATE(2512),
    [sym_shift_expression] = STATE(2512),
    [sym_math_expression] = STATE(2512),
    [sym_cast_expression] = STATE(2512),
    [sym_sizeof_expression] = STATE(2512),
    [sym_subscript_expression] = STATE(2512),
    [sym_call_expression] = STATE(2512),
    [sym_field_expression] = STATE(2512),
    [sym_compound_literal_expression] = STATE(2512),
    [sym_parenthesized_expression] = STATE(2512),
    [sym_char_literal] = STATE(2512),
    [sym_concatenated_string] = STATE(2512),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2512),
    [sym_new_expression] = STATE(2512),
    [sym_delete_expression] = STATE(2512),
    [sym_lambda_expression] = STATE(2512),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5559),
    [anon_sym_SEMI] = ACTIONS(5561),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(5559),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(5563),
    [sym_false] = ACTIONS(5563),
    [sym_null] = ACTIONS(5563),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(5563),
  },
  [1818] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(5565),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1819] = {
    [anon_sym_COLON] = ACTIONS(5567),
    [sym_comment] = ACTIONS(91),
  },
  [1820] = {
    [sym_raw_string_literal] = ACTIONS(2999),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3001),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3001),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3001),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3001),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3001),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3001),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3001),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3001),
    [sym_preproc_directive] = ACTIONS(3001),
    [anon_sym_SEMI] = ACTIONS(2999),
    [anon_sym_typedef] = ACTIONS(3001),
    [anon_sym_extern] = ACTIONS(3001),
    [anon_sym_LBRACE] = ACTIONS(2999),
    [anon_sym_LPAREN2] = ACTIONS(2999),
    [anon_sym_STAR] = ACTIONS(2999),
    [anon_sym_LBRACK] = ACTIONS(2999),
    [anon_sym_static] = ACTIONS(3001),
    [anon_sym_register] = ACTIONS(3001),
    [anon_sym_inline] = ACTIONS(3001),
    [anon_sym_const] = ACTIONS(3001),
    [anon_sym_restrict] = ACTIONS(3001),
    [anon_sym_volatile] = ACTIONS(3001),
    [anon_sym__Atomic] = ACTIONS(3001),
    [anon_sym_mutable] = ACTIONS(3001),
    [anon_sym_explicit] = ACTIONS(3001),
    [anon_sym_constexpr] = ACTIONS(3001),
    [anon_sym_unsigned] = ACTIONS(3001),
    [anon_sym_long] = ACTIONS(3001),
    [anon_sym_short] = ACTIONS(3001),
    [sym_primitive_type] = ACTIONS(3001),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_struct] = ACTIONS(3001),
    [anon_sym_union] = ACTIONS(3001),
    [anon_sym_if] = ACTIONS(3001),
    [anon_sym_else] = ACTIONS(3001),
    [anon_sym_switch] = ACTIONS(3001),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3001),
    [anon_sym_while] = ACTIONS(3001),
    [anon_sym_do] = ACTIONS(3001),
    [anon_sym_for] = ACTIONS(3001),
    [anon_sym_return] = ACTIONS(3001),
    [anon_sym_break] = ACTIONS(3001),
    [anon_sym_continue] = ACTIONS(3001),
    [anon_sym_goto] = ACTIONS(3001),
    [anon_sym_AMP] = ACTIONS(3001),
    [anon_sym_AMP_AMP] = ACTIONS(2999),
    [anon_sym_BANG] = ACTIONS(2999),
    [anon_sym_TILDE] = ACTIONS(2999),
    [anon_sym_PLUS] = ACTIONS(3001),
    [anon_sym_DASH] = ACTIONS(3001),
    [anon_sym_DASH_DASH] = ACTIONS(2999),
    [anon_sym_PLUS_PLUS] = ACTIONS(2999),
    [anon_sym_sizeof] = ACTIONS(3001),
    [sym_number_literal] = ACTIONS(2999),
    [anon_sym_SQUOTE] = ACTIONS(2999),
    [anon_sym_DQUOTE] = ACTIONS(2999),
    [sym_true] = ACTIONS(3001),
    [sym_false] = ACTIONS(3001),
    [sym_null] = ACTIONS(3001),
    [sym_identifier] = ACTIONS(3001),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3001),
    [sym_auto] = ACTIONS(3001),
    [anon_sym_typename] = ACTIONS(3001),
    [anon_sym_template] = ACTIONS(3001),
    [anon_sym_delete] = ACTIONS(3001),
    [anon_sym_namespace] = ACTIONS(3001),
    [anon_sym_using] = ACTIONS(3001),
    [anon_sym_try] = ACTIONS(3001),
    [anon_sym_new] = ACTIONS(3001),
    [anon_sym_COLON_COLON] = ACTIONS(2999),
    [sym_operator_name] = ACTIONS(2999),
    [sym_nullptr] = ACTIONS(3001),
  },
  [1821] = {
    [sym_raw_string_literal] = ACTIONS(3047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3049),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3049),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3049),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3049),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3049),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3049),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3049),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3049),
    [sym_preproc_directive] = ACTIONS(3049),
    [anon_sym_SEMI] = ACTIONS(3047),
    [anon_sym_typedef] = ACTIONS(3049),
    [anon_sym_extern] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(3047),
    [anon_sym_LPAREN2] = ACTIONS(3047),
    [anon_sym_STAR] = ACTIONS(3047),
    [anon_sym_LBRACK] = ACTIONS(3047),
    [anon_sym_static] = ACTIONS(3049),
    [anon_sym_register] = ACTIONS(3049),
    [anon_sym_inline] = ACTIONS(3049),
    [anon_sym_const] = ACTIONS(3049),
    [anon_sym_restrict] = ACTIONS(3049),
    [anon_sym_volatile] = ACTIONS(3049),
    [anon_sym__Atomic] = ACTIONS(3049),
    [anon_sym_mutable] = ACTIONS(3049),
    [anon_sym_explicit] = ACTIONS(3049),
    [anon_sym_constexpr] = ACTIONS(3049),
    [anon_sym_unsigned] = ACTIONS(3049),
    [anon_sym_long] = ACTIONS(3049),
    [anon_sym_short] = ACTIONS(3049),
    [sym_primitive_type] = ACTIONS(3049),
    [anon_sym_enum] = ACTIONS(3049),
    [anon_sym_struct] = ACTIONS(3049),
    [anon_sym_union] = ACTIONS(3049),
    [anon_sym_if] = ACTIONS(3049),
    [anon_sym_else] = ACTIONS(3049),
    [anon_sym_switch] = ACTIONS(3049),
    [anon_sym_case] = ACTIONS(3049),
    [anon_sym_default] = ACTIONS(3049),
    [anon_sym_while] = ACTIONS(3049),
    [anon_sym_do] = ACTIONS(3049),
    [anon_sym_for] = ACTIONS(3049),
    [anon_sym_return] = ACTIONS(3049),
    [anon_sym_break] = ACTIONS(3049),
    [anon_sym_continue] = ACTIONS(3049),
    [anon_sym_goto] = ACTIONS(3049),
    [anon_sym_AMP] = ACTIONS(3049),
    [anon_sym_AMP_AMP] = ACTIONS(3047),
    [anon_sym_BANG] = ACTIONS(3047),
    [anon_sym_TILDE] = ACTIONS(3047),
    [anon_sym_PLUS] = ACTIONS(3049),
    [anon_sym_DASH] = ACTIONS(3049),
    [anon_sym_DASH_DASH] = ACTIONS(3047),
    [anon_sym_PLUS_PLUS] = ACTIONS(3047),
    [anon_sym_sizeof] = ACTIONS(3049),
    [sym_number_literal] = ACTIONS(3047),
    [anon_sym_SQUOTE] = ACTIONS(3047),
    [anon_sym_DQUOTE] = ACTIONS(3047),
    [sym_true] = ACTIONS(3049),
    [sym_false] = ACTIONS(3049),
    [sym_null] = ACTIONS(3049),
    [sym_identifier] = ACTIONS(3049),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3049),
    [sym_auto] = ACTIONS(3049),
    [anon_sym_typename] = ACTIONS(3049),
    [anon_sym_template] = ACTIONS(3049),
    [anon_sym_delete] = ACTIONS(3049),
    [anon_sym_namespace] = ACTIONS(3049),
    [anon_sym_using] = ACTIONS(3049),
    [anon_sym_try] = ACTIONS(3049),
    [anon_sym_new] = ACTIONS(3049),
    [anon_sym_COLON_COLON] = ACTIONS(3047),
    [sym_operator_name] = ACTIONS(3047),
    [sym_nullptr] = ACTIONS(3049),
  },
  [1822] = {
    [sym_raw_string_literal] = ACTIONS(3072),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3074),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3074),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3074),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3074),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3074),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3074),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3074),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3074),
    [sym_preproc_directive] = ACTIONS(3074),
    [anon_sym_SEMI] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3074),
    [anon_sym_extern] = ACTIONS(3074),
    [anon_sym_LBRACE] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3074),
    [anon_sym_register] = ACTIONS(3074),
    [anon_sym_inline] = ACTIONS(3074),
    [anon_sym_const] = ACTIONS(3074),
    [anon_sym_restrict] = ACTIONS(3074),
    [anon_sym_volatile] = ACTIONS(3074),
    [anon_sym__Atomic] = ACTIONS(3074),
    [anon_sym_mutable] = ACTIONS(3074),
    [anon_sym_explicit] = ACTIONS(3074),
    [anon_sym_constexpr] = ACTIONS(3074),
    [anon_sym_unsigned] = ACTIONS(3074),
    [anon_sym_long] = ACTIONS(3074),
    [anon_sym_short] = ACTIONS(3074),
    [sym_primitive_type] = ACTIONS(3074),
    [anon_sym_enum] = ACTIONS(3074),
    [anon_sym_struct] = ACTIONS(3074),
    [anon_sym_union] = ACTIONS(3074),
    [anon_sym_if] = ACTIONS(3074),
    [anon_sym_else] = ACTIONS(3074),
    [anon_sym_switch] = ACTIONS(3074),
    [anon_sym_case] = ACTIONS(3074),
    [anon_sym_default] = ACTIONS(3074),
    [anon_sym_while] = ACTIONS(3074),
    [anon_sym_do] = ACTIONS(3074),
    [anon_sym_for] = ACTIONS(3074),
    [anon_sym_return] = ACTIONS(3074),
    [anon_sym_break] = ACTIONS(3074),
    [anon_sym_continue] = ACTIONS(3074),
    [anon_sym_goto] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3072),
    [anon_sym_BANG] = ACTIONS(3072),
    [anon_sym_TILDE] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3074),
    [anon_sym_DASH_DASH] = ACTIONS(3072),
    [anon_sym_PLUS_PLUS] = ACTIONS(3072),
    [anon_sym_sizeof] = ACTIONS(3074),
    [sym_number_literal] = ACTIONS(3072),
    [anon_sym_SQUOTE] = ACTIONS(3072),
    [anon_sym_DQUOTE] = ACTIONS(3072),
    [sym_true] = ACTIONS(3074),
    [sym_false] = ACTIONS(3074),
    [sym_null] = ACTIONS(3074),
    [sym_identifier] = ACTIONS(3074),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3074),
    [sym_auto] = ACTIONS(3074),
    [anon_sym_typename] = ACTIONS(3074),
    [anon_sym_template] = ACTIONS(3074),
    [anon_sym_delete] = ACTIONS(3074),
    [anon_sym_namespace] = ACTIONS(3074),
    [anon_sym_using] = ACTIONS(3074),
    [anon_sym_try] = ACTIONS(3074),
    [anon_sym_new] = ACTIONS(3074),
    [anon_sym_COLON_COLON] = ACTIONS(3072),
    [sym_operator_name] = ACTIONS(3072),
    [sym_nullptr] = ACTIONS(3074),
  },
  [1823] = {
    [sym_parameter_list] = STATE(812),
    [anon_sym_SEMI] = ACTIONS(5569),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(574),
    [sym_comment] = ACTIONS(91),
  },
  [1824] = {
    [sym_raw_string_literal] = ACTIONS(3281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3283),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3283),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3283),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3283),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3283),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3283),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3283),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3283),
    [sym_preproc_directive] = ACTIONS(3283),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_typedef] = ACTIONS(3283),
    [anon_sym_extern] = ACTIONS(3283),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_LPAREN2] = ACTIONS(3281),
    [anon_sym_STAR] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_static] = ACTIONS(3283),
    [anon_sym_register] = ACTIONS(3283),
    [anon_sym_inline] = ACTIONS(3283),
    [anon_sym_const] = ACTIONS(3283),
    [anon_sym_restrict] = ACTIONS(3283),
    [anon_sym_volatile] = ACTIONS(3283),
    [anon_sym__Atomic] = ACTIONS(3283),
    [anon_sym_mutable] = ACTIONS(3283),
    [anon_sym_explicit] = ACTIONS(3283),
    [anon_sym_constexpr] = ACTIONS(3283),
    [anon_sym_unsigned] = ACTIONS(3283),
    [anon_sym_long] = ACTIONS(3283),
    [anon_sym_short] = ACTIONS(3283),
    [sym_primitive_type] = ACTIONS(3283),
    [anon_sym_enum] = ACTIONS(3283),
    [anon_sym_struct] = ACTIONS(3283),
    [anon_sym_union] = ACTIONS(3283),
    [anon_sym_if] = ACTIONS(3283),
    [anon_sym_switch] = ACTIONS(3283),
    [anon_sym_case] = ACTIONS(3283),
    [anon_sym_default] = ACTIONS(3283),
    [anon_sym_while] = ACTIONS(3283),
    [anon_sym_do] = ACTIONS(3283),
    [anon_sym_for] = ACTIONS(3283),
    [anon_sym_return] = ACTIONS(3283),
    [anon_sym_break] = ACTIONS(3283),
    [anon_sym_continue] = ACTIONS(3283),
    [anon_sym_goto] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3283),
    [anon_sym_AMP_AMP] = ACTIONS(3281),
    [anon_sym_BANG] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3281),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_DASH_DASH] = ACTIONS(3281),
    [anon_sym_PLUS_PLUS] = ACTIONS(3281),
    [anon_sym_sizeof] = ACTIONS(3283),
    [sym_number_literal] = ACTIONS(3281),
    [anon_sym_SQUOTE] = ACTIONS(3281),
    [anon_sym_DQUOTE] = ACTIONS(3281),
    [sym_true] = ACTIONS(3283),
    [sym_false] = ACTIONS(3283),
    [sym_null] = ACTIONS(3283),
    [sym_identifier] = ACTIONS(3283),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3283),
    [sym_auto] = ACTIONS(3283),
    [anon_sym_typename] = ACTIONS(3283),
    [anon_sym_template] = ACTIONS(3283),
    [anon_sym_delete] = ACTIONS(3283),
    [anon_sym_namespace] = ACTIONS(3283),
    [anon_sym_using] = ACTIONS(3283),
    [anon_sym_try] = ACTIONS(3283),
    [anon_sym_new] = ACTIONS(3283),
    [anon_sym_COLON_COLON] = ACTIONS(3281),
    [sym_operator_name] = ACTIONS(3281),
    [sym_nullptr] = ACTIONS(3283),
  },
  [1825] = {
    [sym_raw_string_literal] = ACTIONS(3289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3291),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3291),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3291),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3291),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3291),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3291),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3291),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3291),
    [sym_preproc_directive] = ACTIONS(3291),
    [anon_sym_SEMI] = ACTIONS(3289),
    [anon_sym_typedef] = ACTIONS(3291),
    [anon_sym_extern] = ACTIONS(3291),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_LPAREN2] = ACTIONS(3289),
    [anon_sym_STAR] = ACTIONS(3289),
    [anon_sym_LBRACK] = ACTIONS(3289),
    [anon_sym_static] = ACTIONS(3291),
    [anon_sym_register] = ACTIONS(3291),
    [anon_sym_inline] = ACTIONS(3291),
    [anon_sym_const] = ACTIONS(3291),
    [anon_sym_restrict] = ACTIONS(3291),
    [anon_sym_volatile] = ACTIONS(3291),
    [anon_sym__Atomic] = ACTIONS(3291),
    [anon_sym_mutable] = ACTIONS(3291),
    [anon_sym_explicit] = ACTIONS(3291),
    [anon_sym_constexpr] = ACTIONS(3291),
    [anon_sym_unsigned] = ACTIONS(3291),
    [anon_sym_long] = ACTIONS(3291),
    [anon_sym_short] = ACTIONS(3291),
    [sym_primitive_type] = ACTIONS(3291),
    [anon_sym_enum] = ACTIONS(3291),
    [anon_sym_struct] = ACTIONS(3291),
    [anon_sym_union] = ACTIONS(3291),
    [anon_sym_if] = ACTIONS(3291),
    [anon_sym_switch] = ACTIONS(3291),
    [anon_sym_case] = ACTIONS(3291),
    [anon_sym_default] = ACTIONS(3291),
    [anon_sym_while] = ACTIONS(3291),
    [anon_sym_do] = ACTIONS(3291),
    [anon_sym_for] = ACTIONS(3291),
    [anon_sym_return] = ACTIONS(3291),
    [anon_sym_break] = ACTIONS(3291),
    [anon_sym_continue] = ACTIONS(3291),
    [anon_sym_goto] = ACTIONS(3291),
    [anon_sym_AMP] = ACTIONS(3291),
    [anon_sym_AMP_AMP] = ACTIONS(3289),
    [anon_sym_BANG] = ACTIONS(3289),
    [anon_sym_TILDE] = ACTIONS(3289),
    [anon_sym_PLUS] = ACTIONS(3291),
    [anon_sym_DASH] = ACTIONS(3291),
    [anon_sym_DASH_DASH] = ACTIONS(3289),
    [anon_sym_PLUS_PLUS] = ACTIONS(3289),
    [anon_sym_sizeof] = ACTIONS(3291),
    [sym_number_literal] = ACTIONS(3289),
    [anon_sym_SQUOTE] = ACTIONS(3289),
    [anon_sym_DQUOTE] = ACTIONS(3289),
    [sym_true] = ACTIONS(3291),
    [sym_false] = ACTIONS(3291),
    [sym_null] = ACTIONS(3291),
    [sym_identifier] = ACTIONS(3291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3291),
    [sym_auto] = ACTIONS(3291),
    [anon_sym_typename] = ACTIONS(3291),
    [anon_sym_template] = ACTIONS(3291),
    [anon_sym_delete] = ACTIONS(3291),
    [anon_sym_namespace] = ACTIONS(3291),
    [anon_sym_using] = ACTIONS(3291),
    [anon_sym_try] = ACTIONS(3291),
    [anon_sym_new] = ACTIONS(3291),
    [anon_sym_COLON_COLON] = ACTIONS(3289),
    [sym_operator_name] = ACTIONS(3289),
    [sym_nullptr] = ACTIONS(3291),
  },
  [1826] = {
    [sym__declarator] = STATE(1059),
    [sym_pointer_declarator] = STATE(1059),
    [sym_function_declarator] = STATE(1059),
    [sym_array_declarator] = STATE(1059),
    [sym_init_declarator] = STATE(1060),
    [sym_reference_declarator] = STATE(1059),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(1059),
    [sym_destructor_name] = STATE(1059),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [anon_sym_SEMI] = ACTIONS(2126),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(560),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(568),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(2128),
  },
  [1827] = {
    [sym_raw_string_literal] = ACTIONS(3306),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3308),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3308),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3308),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3308),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3308),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3308),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3308),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3308),
    [sym_preproc_directive] = ACTIONS(3308),
    [anon_sym_SEMI] = ACTIONS(3306),
    [anon_sym_typedef] = ACTIONS(3308),
    [anon_sym_extern] = ACTIONS(3308),
    [anon_sym_LBRACE] = ACTIONS(3306),
    [anon_sym_LPAREN2] = ACTIONS(3306),
    [anon_sym_STAR] = ACTIONS(3306),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_static] = ACTIONS(3308),
    [anon_sym_register] = ACTIONS(3308),
    [anon_sym_inline] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3308),
    [anon_sym_restrict] = ACTIONS(3308),
    [anon_sym_volatile] = ACTIONS(3308),
    [anon_sym__Atomic] = ACTIONS(3308),
    [anon_sym_mutable] = ACTIONS(3308),
    [anon_sym_explicit] = ACTIONS(3308),
    [anon_sym_constexpr] = ACTIONS(3308),
    [anon_sym_unsigned] = ACTIONS(3308),
    [anon_sym_long] = ACTIONS(3308),
    [anon_sym_short] = ACTIONS(3308),
    [sym_primitive_type] = ACTIONS(3308),
    [anon_sym_enum] = ACTIONS(3308),
    [anon_sym_struct] = ACTIONS(3308),
    [anon_sym_union] = ACTIONS(3308),
    [anon_sym_if] = ACTIONS(3308),
    [anon_sym_switch] = ACTIONS(3308),
    [anon_sym_case] = ACTIONS(3308),
    [anon_sym_default] = ACTIONS(3308),
    [anon_sym_while] = ACTIONS(3308),
    [anon_sym_do] = ACTIONS(3308),
    [anon_sym_for] = ACTIONS(3308),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_break] = ACTIONS(3308),
    [anon_sym_continue] = ACTIONS(3308),
    [anon_sym_goto] = ACTIONS(3308),
    [anon_sym_AMP] = ACTIONS(3308),
    [anon_sym_AMP_AMP] = ACTIONS(3306),
    [anon_sym_BANG] = ACTIONS(3306),
    [anon_sym_TILDE] = ACTIONS(3306),
    [anon_sym_PLUS] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_DASH_DASH] = ACTIONS(3306),
    [anon_sym_PLUS_PLUS] = ACTIONS(3306),
    [anon_sym_sizeof] = ACTIONS(3308),
    [sym_number_literal] = ACTIONS(3306),
    [anon_sym_SQUOTE] = ACTIONS(3306),
    [anon_sym_DQUOTE] = ACTIONS(3306),
    [sym_true] = ACTIONS(3308),
    [sym_false] = ACTIONS(3308),
    [sym_null] = ACTIONS(3308),
    [sym_identifier] = ACTIONS(3308),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3308),
    [sym_auto] = ACTIONS(3308),
    [anon_sym_typename] = ACTIONS(3308),
    [anon_sym_template] = ACTIONS(3308),
    [anon_sym_delete] = ACTIONS(3308),
    [anon_sym_namespace] = ACTIONS(3308),
    [anon_sym_using] = ACTIONS(3308),
    [anon_sym_try] = ACTIONS(3308),
    [anon_sym_new] = ACTIONS(3308),
    [anon_sym_COLON_COLON] = ACTIONS(3306),
    [sym_operator_name] = ACTIONS(3306),
    [sym_nullptr] = ACTIONS(3308),
  },
  [1828] = {
    [sym_preproc_include] = STATE(1570),
    [sym_preproc_def] = STATE(1570),
    [sym_preproc_function_def] = STATE(1570),
    [sym_preproc_call] = STATE(1570),
    [sym_preproc_if] = STATE(1570),
    [sym_preproc_ifdef] = STATE(1570),
    [sym_function_definition] = STATE(1570),
    [sym_declaration] = STATE(1570),
    [sym_type_definition] = STATE(1570),
    [sym__declaration_specifiers] = STATE(49),
    [sym_linkage_specification] = STATE(1570),
    [sym__declarator] = STATE(50),
    [sym_pointer_declarator] = STATE(50),
    [sym_function_declarator] = STATE(51),
    [sym_array_declarator] = STATE(50),
    [sym_compound_statement] = STATE(1570),
    [sym_storage_class_specifier] = STATE(63),
    [sym_type_qualifier] = STATE(63),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(1570),
    [sym_expression_statement] = STATE(1570),
    [sym_if_statement] = STATE(1570),
    [sym_switch_statement] = STATE(1570),
    [sym_case_statement] = STATE(1570),
    [sym_while_statement] = STATE(1570),
    [sym_do_statement] = STATE(1570),
    [sym_for_statement] = STATE(1570),
    [sym_return_statement] = STATE(1570),
    [sym_break_statement] = STATE(1570),
    [sym_continue_statement] = STATE(1570),
    [sym_goto_statement] = STATE(1570),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(1570),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(1570),
    [sym_template_declaration] = STATE(1570),
    [sym_template_instantiation] = STATE(1570),
    [sym_constructor_or_destructor_definition] = STATE(1570),
    [sym_reference_declarator] = STATE(50),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(57),
    [sym_namespace_definition] = STATE(1570),
    [sym_using_declaration] = STATE(1570),
    [sym_alias_declaration] = STATE(1570),
    [sym_for_range_loop] = STATE(1570),
    [sym_try_statement] = STATE(1570),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_destructor_name] = STATE(50),
    [sym_scoped_identifier] = STATE(59),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_translation_unit_repeat1] = STATE(1570),
    [aux_sym__declaration_specifiers_repeat1] = STATE(63),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(5),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(9),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(13),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(15),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(15),
    [sym_preproc_directive] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_RBRACE] = ACTIONS(5571),
    [anon_sym_LPAREN2] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(1495),
    [anon_sym_switch] = ACTIONS(1497),
    [anon_sym_case] = ACTIONS(1499),
    [anon_sym_default] = ACTIONS(1501),
    [anon_sym_while] = ACTIONS(1503),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(1505),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(1507),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_template] = ACTIONS(97),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_namespace] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(103),
    [anon_sym_try] = ACTIONS(1509),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_operator_name] = ACTIONS(111),
    [sym_nullptr] = ACTIONS(87),
  },
  [1829] = {
    [sym_raw_string_literal] = ACTIONS(3326),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3328),
    [sym_preproc_directive] = ACTIONS(3328),
    [anon_sym_SEMI] = ACTIONS(3326),
    [anon_sym_typedef] = ACTIONS(3328),
    [anon_sym_extern] = ACTIONS(3328),
    [anon_sym_LBRACE] = ACTIONS(3326),
    [anon_sym_LPAREN2] = ACTIONS(3326),
    [anon_sym_STAR] = ACTIONS(3326),
    [anon_sym_LBRACK] = ACTIONS(3326),
    [anon_sym_static] = ACTIONS(3328),
    [anon_sym_register] = ACTIONS(3328),
    [anon_sym_inline] = ACTIONS(3328),
    [anon_sym_const] = ACTIONS(3328),
    [anon_sym_restrict] = ACTIONS(3328),
    [anon_sym_volatile] = ACTIONS(3328),
    [anon_sym__Atomic] = ACTIONS(3328),
    [anon_sym_mutable] = ACTIONS(3328),
    [anon_sym_explicit] = ACTIONS(3328),
    [anon_sym_constexpr] = ACTIONS(3328),
    [anon_sym_unsigned] = ACTIONS(3328),
    [anon_sym_long] = ACTIONS(3328),
    [anon_sym_short] = ACTIONS(3328),
    [sym_primitive_type] = ACTIONS(3328),
    [anon_sym_enum] = ACTIONS(3328),
    [anon_sym_struct] = ACTIONS(3328),
    [anon_sym_union] = ACTIONS(3328),
    [anon_sym_if] = ACTIONS(3328),
    [anon_sym_switch] = ACTIONS(3328),
    [anon_sym_case] = ACTIONS(3328),
    [anon_sym_default] = ACTIONS(3328),
    [anon_sym_while] = ACTIONS(3328),
    [anon_sym_do] = ACTIONS(3328),
    [anon_sym_for] = ACTIONS(3328),
    [anon_sym_return] = ACTIONS(3328),
    [anon_sym_break] = ACTIONS(3328),
    [anon_sym_continue] = ACTIONS(3328),
    [anon_sym_goto] = ACTIONS(3328),
    [anon_sym_AMP] = ACTIONS(3328),
    [anon_sym_AMP_AMP] = ACTIONS(3326),
    [anon_sym_BANG] = ACTIONS(3326),
    [anon_sym_TILDE] = ACTIONS(3326),
    [anon_sym_PLUS] = ACTIONS(3328),
    [anon_sym_DASH] = ACTIONS(3328),
    [anon_sym_DASH_DASH] = ACTIONS(3326),
    [anon_sym_PLUS_PLUS] = ACTIONS(3326),
    [anon_sym_sizeof] = ACTIONS(3328),
    [sym_number_literal] = ACTIONS(3326),
    [anon_sym_SQUOTE] = ACTIONS(3326),
    [anon_sym_DQUOTE] = ACTIONS(3326),
    [sym_true] = ACTIONS(3328),
    [sym_false] = ACTIONS(3328),
    [sym_null] = ACTIONS(3328),
    [sym_identifier] = ACTIONS(3328),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3328),
    [sym_auto] = ACTIONS(3328),
    [anon_sym_typename] = ACTIONS(3328),
    [anon_sym_template] = ACTIONS(3328),
    [anon_sym_delete] = ACTIONS(3328),
    [anon_sym_namespace] = ACTIONS(3328),
    [anon_sym_using] = ACTIONS(3328),
    [anon_sym_try] = ACTIONS(3328),
    [anon_sym_new] = ACTIONS(3328),
    [anon_sym_COLON_COLON] = ACTIONS(3326),
    [sym_operator_name] = ACTIONS(3326),
    [sym_nullptr] = ACTIONS(3328),
  },
  [1830] = {
    [sym_raw_string_literal] = ACTIONS(3330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3332),
    [sym_preproc_directive] = ACTIONS(3332),
    [anon_sym_SEMI] = ACTIONS(3330),
    [anon_sym_typedef] = ACTIONS(3332),
    [anon_sym_extern] = ACTIONS(3332),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_LPAREN2] = ACTIONS(3330),
    [anon_sym_STAR] = ACTIONS(3330),
    [anon_sym_LBRACK] = ACTIONS(3330),
    [anon_sym_static] = ACTIONS(3332),
    [anon_sym_register] = ACTIONS(3332),
    [anon_sym_inline] = ACTIONS(3332),
    [anon_sym_const] = ACTIONS(3332),
    [anon_sym_restrict] = ACTIONS(3332),
    [anon_sym_volatile] = ACTIONS(3332),
    [anon_sym__Atomic] = ACTIONS(3332),
    [anon_sym_mutable] = ACTIONS(3332),
    [anon_sym_explicit] = ACTIONS(3332),
    [anon_sym_constexpr] = ACTIONS(3332),
    [anon_sym_unsigned] = ACTIONS(3332),
    [anon_sym_long] = ACTIONS(3332),
    [anon_sym_short] = ACTIONS(3332),
    [sym_primitive_type] = ACTIONS(3332),
    [anon_sym_enum] = ACTIONS(3332),
    [anon_sym_struct] = ACTIONS(3332),
    [anon_sym_union] = ACTIONS(3332),
    [anon_sym_if] = ACTIONS(3332),
    [anon_sym_switch] = ACTIONS(3332),
    [anon_sym_case] = ACTIONS(3332),
    [anon_sym_default] = ACTIONS(3332),
    [anon_sym_while] = ACTIONS(3332),
    [anon_sym_do] = ACTIONS(3332),
    [anon_sym_for] = ACTIONS(3332),
    [anon_sym_return] = ACTIONS(3332),
    [anon_sym_break] = ACTIONS(3332),
    [anon_sym_continue] = ACTIONS(3332),
    [anon_sym_goto] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(3332),
    [anon_sym_AMP_AMP] = ACTIONS(3330),
    [anon_sym_BANG] = ACTIONS(3330),
    [anon_sym_TILDE] = ACTIONS(3330),
    [anon_sym_PLUS] = ACTIONS(3332),
    [anon_sym_DASH] = ACTIONS(3332),
    [anon_sym_DASH_DASH] = ACTIONS(3330),
    [anon_sym_PLUS_PLUS] = ACTIONS(3330),
    [anon_sym_sizeof] = ACTIONS(3332),
    [sym_number_literal] = ACTIONS(3330),
    [anon_sym_SQUOTE] = ACTIONS(3330),
    [anon_sym_DQUOTE] = ACTIONS(3330),
    [sym_true] = ACTIONS(3332),
    [sym_false] = ACTIONS(3332),
    [sym_null] = ACTIONS(3332),
    [sym_identifier] = ACTIONS(3332),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3332),
    [sym_auto] = ACTIONS(3332),
    [anon_sym_typename] = ACTIONS(3332),
    [anon_sym_template] = ACTIONS(3332),
    [anon_sym_delete] = ACTIONS(3332),
    [anon_sym_namespace] = ACTIONS(3332),
    [anon_sym_using] = ACTIONS(3332),
    [anon_sym_try] = ACTIONS(3332),
    [anon_sym_new] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(3330),
    [sym_operator_name] = ACTIONS(3330),
    [sym_nullptr] = ACTIONS(3332),
  },
  [1831] = {
    [sym_type_qualifier] = STATE(1574),
    [sym__type_specifier] = STATE(1572),
    [sym_sized_type_specifier] = STATE(1572),
    [sym_enum_specifier] = STATE(1572),
    [sym_struct_specifier] = STATE(1572),
    [sym_union_specifier] = STATE(1572),
    [sym_type_descriptor] = STATE(2517),
    [sym_macro_type_specifier] = STATE(1572),
    [sym_class_specifier] = STATE(1572),
    [sym_dependent_type] = STATE(1572),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_type_definition_repeat1] = STATE(1574),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1575),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(3334),
    [anon_sym_long] = ACTIONS(3334),
    [anon_sym_short] = ACTIONS(3334),
    [sym_primitive_type] = ACTIONS(3336),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(3336),
    [anon_sym_typename] = ACTIONS(3338),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [1832] = {
    [sym_template_argument_list] = STATE(437),
    [anon_sym_SEMI] = ACTIONS(5573),
    [anon_sym_LT] = ACTIONS(945),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1519),
  },
  [1833] = {
    [anon_sym_SEMI] = ACTIONS(5573),
    [sym_comment] = ACTIONS(91),
  },
  [1834] = {
    [sym_parameter_list] = STATE(2519),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [sym_comment] = ACTIONS(91),
  },
  [1835] = {
    [sym_catch_clause] = STATE(2520),
    [aux_sym_try_statement_repeat1] = STATE(2520),
    [sym_raw_string_literal] = ACTIONS(3346),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3348),
    [sym_preproc_directive] = ACTIONS(3348),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym_typedef] = ACTIONS(3348),
    [anon_sym_extern] = ACTIONS(3348),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(3346),
    [anon_sym_static] = ACTIONS(3348),
    [anon_sym_register] = ACTIONS(3348),
    [anon_sym_inline] = ACTIONS(3348),
    [anon_sym_const] = ACTIONS(3348),
    [anon_sym_restrict] = ACTIONS(3348),
    [anon_sym_volatile] = ACTIONS(3348),
    [anon_sym__Atomic] = ACTIONS(3348),
    [anon_sym_mutable] = ACTIONS(3348),
    [anon_sym_explicit] = ACTIONS(3348),
    [anon_sym_constexpr] = ACTIONS(3348),
    [anon_sym_unsigned] = ACTIONS(3348),
    [anon_sym_long] = ACTIONS(3348),
    [anon_sym_short] = ACTIONS(3348),
    [sym_primitive_type] = ACTIONS(3348),
    [anon_sym_enum] = ACTIONS(3348),
    [anon_sym_struct] = ACTIONS(3348),
    [anon_sym_union] = ACTIONS(3348),
    [anon_sym_if] = ACTIONS(3348),
    [anon_sym_switch] = ACTIONS(3348),
    [anon_sym_case] = ACTIONS(3348),
    [anon_sym_default] = ACTIONS(3348),
    [anon_sym_while] = ACTIONS(3348),
    [anon_sym_do] = ACTIONS(3348),
    [anon_sym_for] = ACTIONS(3348),
    [anon_sym_return] = ACTIONS(3348),
    [anon_sym_break] = ACTIONS(3348),
    [anon_sym_continue] = ACTIONS(3348),
    [anon_sym_goto] = ACTIONS(3348),
    [anon_sym_AMP] = ACTIONS(3348),
    [anon_sym_AMP_AMP] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_PLUS] = ACTIONS(3348),
    [anon_sym_DASH] = ACTIONS(3348),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_sizeof] = ACTIONS(3348),
    [sym_number_literal] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [sym_true] = ACTIONS(3348),
    [sym_false] = ACTIONS(3348),
    [sym_null] = ACTIONS(3348),
    [sym_identifier] = ACTIONS(3348),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3348),
    [sym_auto] = ACTIONS(3348),
    [anon_sym_typename] = ACTIONS(3348),
    [anon_sym_template] = ACTIONS(3348),
    [anon_sym_delete] = ACTIONS(3348),
    [anon_sym_namespace] = ACTIONS(3348),
    [anon_sym_using] = ACTIONS(3348),
    [anon_sym_try] = ACTIONS(3348),
    [anon_sym_catch] = ACTIONS(5575),
    [anon_sym_new] = ACTIONS(3348),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [sym_operator_name] = ACTIONS(3346),
    [sym_nullptr] = ACTIONS(3348),
  },
  [1836] = {
    [sym_raw_string_literal] = ACTIONS(3397),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3399),
    [sym_preproc_directive] = ACTIONS(3399),
    [anon_sym_SEMI] = ACTIONS(3397),
    [anon_sym_typedef] = ACTIONS(3399),
    [anon_sym_extern] = ACTIONS(3399),
    [anon_sym_LBRACE] = ACTIONS(3397),
    [anon_sym_LPAREN2] = ACTIONS(3397),
    [anon_sym_STAR] = ACTIONS(3397),
    [anon_sym_LBRACK] = ACTIONS(3397),
    [anon_sym_static] = ACTIONS(3399),
    [anon_sym_register] = ACTIONS(3399),
    [anon_sym_inline] = ACTIONS(3399),
    [anon_sym_const] = ACTIONS(3399),
    [anon_sym_restrict] = ACTIONS(3399),
    [anon_sym_volatile] = ACTIONS(3399),
    [anon_sym__Atomic] = ACTIONS(3399),
    [anon_sym_mutable] = ACTIONS(3399),
    [anon_sym_explicit] = ACTIONS(3399),
    [anon_sym_constexpr] = ACTIONS(3399),
    [anon_sym_unsigned] = ACTIONS(3399),
    [anon_sym_long] = ACTIONS(3399),
    [anon_sym_short] = ACTIONS(3399),
    [sym_primitive_type] = ACTIONS(3399),
    [anon_sym_enum] = ACTIONS(3399),
    [anon_sym_struct] = ACTIONS(3399),
    [anon_sym_union] = ACTIONS(3399),
    [anon_sym_if] = ACTIONS(3399),
    [anon_sym_else] = ACTIONS(3399),
    [anon_sym_switch] = ACTIONS(3399),
    [anon_sym_case] = ACTIONS(3399),
    [anon_sym_default] = ACTIONS(3399),
    [anon_sym_while] = ACTIONS(3399),
    [anon_sym_do] = ACTIONS(3399),
    [anon_sym_for] = ACTIONS(3399),
    [anon_sym_return] = ACTIONS(3399),
    [anon_sym_break] = ACTIONS(3399),
    [anon_sym_continue] = ACTIONS(3399),
    [anon_sym_goto] = ACTIONS(3399),
    [anon_sym_AMP] = ACTIONS(3399),
    [anon_sym_AMP_AMP] = ACTIONS(3397),
    [anon_sym_BANG] = ACTIONS(3397),
    [anon_sym_TILDE] = ACTIONS(3397),
    [anon_sym_PLUS] = ACTIONS(3399),
    [anon_sym_DASH] = ACTIONS(3399),
    [anon_sym_DASH_DASH] = ACTIONS(3397),
    [anon_sym_PLUS_PLUS] = ACTIONS(3397),
    [anon_sym_sizeof] = ACTIONS(3399),
    [sym_number_literal] = ACTIONS(3397),
    [anon_sym_SQUOTE] = ACTIONS(3397),
    [anon_sym_DQUOTE] = ACTIONS(3397),
    [sym_true] = ACTIONS(3399),
    [sym_false] = ACTIONS(3399),
    [sym_null] = ACTIONS(3399),
    [sym_identifier] = ACTIONS(3399),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3399),
    [sym_auto] = ACTIONS(3399),
    [anon_sym_typename] = ACTIONS(3399),
    [anon_sym_template] = ACTIONS(3399),
    [anon_sym_delete] = ACTIONS(3399),
    [anon_sym_namespace] = ACTIONS(3399),
    [anon_sym_using] = ACTIONS(3399),
    [anon_sym_try] = ACTIONS(3399),
    [anon_sym_new] = ACTIONS(3399),
    [anon_sym_COLON_COLON] = ACTIONS(3397),
    [sym_operator_name] = ACTIONS(3397),
    [sym_nullptr] = ACTIONS(3399),
  },
  [1837] = {
    [sym_preproc_include] = STATE(1031),
    [sym_preproc_def] = STATE(1031),
    [sym_preproc_function_def] = STATE(1031),
    [sym_preproc_call] = STATE(1031),
    [sym_preproc_if_in_compound_statement] = STATE(1031),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1031),
    [sym_declaration] = STATE(1031),
    [sym_type_definition] = STATE(1031),
    [sym__declaration_specifiers] = STATE(113),
    [sym_compound_statement] = STATE(1031),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(1031),
    [sym_expression_statement] = STATE(1031),
    [sym_if_statement] = STATE(1031),
    [sym_switch_statement] = STATE(1031),
    [sym_case_statement] = STATE(1031),
    [sym_while_statement] = STATE(1031),
    [sym_do_statement] = STATE(1031),
    [sym_for_statement] = STATE(1031),
    [sym_return_statement] = STATE(1031),
    [sym_break_statement] = STATE(1031),
    [sym_continue_statement] = STATE(1031),
    [sym_goto_statement] = STATE(1031),
    [sym__expression] = STATE(1631),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(1631),
    [sym_assignment_expression] = STATE(1631),
    [sym_pointer_expression] = STATE(1631),
    [sym_logical_expression] = STATE(1631),
    [sym_bitwise_expression] = STATE(1631),
    [sym_equality_expression] = STATE(1631),
    [sym_relational_expression] = STATE(1631),
    [sym_shift_expression] = STATE(1631),
    [sym_math_expression] = STATE(1631),
    [sym_cast_expression] = STATE(1631),
    [sym_sizeof_expression] = STATE(1631),
    [sym_subscript_expression] = STATE(1631),
    [sym_call_expression] = STATE(1631),
    [sym_field_expression] = STATE(1631),
    [sym_compound_literal_expression] = STATE(1631),
    [sym_parenthesized_expression] = STATE(1631),
    [sym_initializer_list] = STATE(726),
    [sym_initializer_pair] = STATE(726),
    [sym_subscript_designator] = STATE(728),
    [sym_field_designator] = STATE(728),
    [sym_char_literal] = STATE(1631),
    [sym_concatenated_string] = STATE(1631),
    [sym_string_literal] = STATE(1632),
    [sym__empty_declaration] = STATE(1031),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(1031),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(1631),
    [sym_for_range_loop] = STATE(1031),
    [sym_try_statement] = STATE(1031),
    [sym_new_expression] = STATE(1631),
    [sym_delete_expression] = STATE(1631),
    [sym_lambda_expression] = STATE(1631),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1031),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [aux_sym_initializer_pair_repeat1] = STATE(728),
    [sym_raw_string_literal] = ACTIONS(3401),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(159),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(161),
    [anon_sym_COMMA] = ACTIONS(1252),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(163),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(165),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(165),
    [sym_preproc_directive] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_typedef] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(3403),
    [anon_sym_RBRACE] = ACTIONS(5577),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_LBRACK] = ACTIONS(1260),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(185),
    [anon_sym_case] = ACTIONS(187),
    [anon_sym_default] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3411),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_sizeof] = ACTIONS(3419),
    [anon_sym_DOT] = ACTIONS(1272),
    [sym_number_literal] = ACTIONS(3401),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(3421),
    [sym_false] = ACTIONS(3421),
    [sym_null] = ACTIONS(3421),
    [sym_identifier] = ACTIONS(209),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(3423),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_COLON_COLON] = ACTIONS(3427),
    [sym_nullptr] = ACTIONS(3421),
  },
  [1838] = {
    [sym_raw_string_literal] = ACTIONS(3439),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3441),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3441),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3441),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3441),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3441),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3441),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3441),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3441),
    [sym_preproc_directive] = ACTIONS(3441),
    [anon_sym_SEMI] = ACTIONS(3439),
    [anon_sym_typedef] = ACTIONS(3441),
    [anon_sym_extern] = ACTIONS(3441),
    [anon_sym_LBRACE] = ACTIONS(3439),
    [anon_sym_LPAREN2] = ACTIONS(3439),
    [anon_sym_STAR] = ACTIONS(3439),
    [anon_sym_LBRACK] = ACTIONS(3439),
    [anon_sym_static] = ACTIONS(3441),
    [anon_sym_register] = ACTIONS(3441),
    [anon_sym_inline] = ACTIONS(3441),
    [anon_sym_const] = ACTIONS(3441),
    [anon_sym_restrict] = ACTIONS(3441),
    [anon_sym_volatile] = ACTIONS(3441),
    [anon_sym__Atomic] = ACTIONS(3441),
    [anon_sym_mutable] = ACTIONS(3441),
    [anon_sym_explicit] = ACTIONS(3441),
    [anon_sym_constexpr] = ACTIONS(3441),
    [anon_sym_unsigned] = ACTIONS(3441),
    [anon_sym_long] = ACTIONS(3441),
    [anon_sym_short] = ACTIONS(3441),
    [sym_primitive_type] = ACTIONS(3441),
    [anon_sym_enum] = ACTIONS(3441),
    [anon_sym_struct] = ACTIONS(3441),
    [anon_sym_union] = ACTIONS(3441),
    [anon_sym_if] = ACTIONS(3441),
    [anon_sym_switch] = ACTIONS(3441),
    [anon_sym_case] = ACTIONS(3441),
    [anon_sym_default] = ACTIONS(3441),
    [anon_sym_while] = ACTIONS(3441),
    [anon_sym_do] = ACTIONS(3441),
    [anon_sym_for] = ACTIONS(3441),
    [anon_sym_return] = ACTIONS(3441),
    [anon_sym_break] = ACTIONS(3441),
    [anon_sym_continue] = ACTIONS(3441),
    [anon_sym_goto] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3441),
    [anon_sym_AMP_AMP] = ACTIONS(3439),
    [anon_sym_BANG] = ACTIONS(3439),
    [anon_sym_TILDE] = ACTIONS(3439),
    [anon_sym_PLUS] = ACTIONS(3441),
    [anon_sym_DASH] = ACTIONS(3441),
    [anon_sym_DASH_DASH] = ACTIONS(3439),
    [anon_sym_PLUS_PLUS] = ACTIONS(3439),
    [anon_sym_sizeof] = ACTIONS(3441),
    [sym_number_literal] = ACTIONS(3439),
    [anon_sym_SQUOTE] = ACTIONS(3439),
    [anon_sym_DQUOTE] = ACTIONS(3439),
    [sym_true] = ACTIONS(3441),
    [sym_false] = ACTIONS(3441),
    [sym_null] = ACTIONS(3441),
    [sym_identifier] = ACTIONS(3441),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3441),
    [sym_auto] = ACTIONS(3441),
    [anon_sym_typename] = ACTIONS(3441),
    [anon_sym_template] = ACTIONS(3441),
    [anon_sym_delete] = ACTIONS(3441),
    [anon_sym_namespace] = ACTIONS(3441),
    [anon_sym_using] = ACTIONS(3441),
    [anon_sym_try] = ACTIONS(3441),
    [anon_sym_new] = ACTIONS(3441),
    [anon_sym_COLON_COLON] = ACTIONS(3439),
    [sym_operator_name] = ACTIONS(3439),
    [sym_nullptr] = ACTIONS(3441),
  },
  [1839] = {
    [aux_sym_declaration_repeat1] = STATE(1643),
    [anon_sym_COMMA] = ACTIONS(1613),
    [anon_sym_SEMI] = ACTIONS(5579),
    [sym_comment] = ACTIONS(91),
  },
  [1840] = {
    [sym__expression] = STATE(2523),
    [sym_conditional_expression] = STATE(2523),
    [sym_assignment_expression] = STATE(2523),
    [sym_pointer_expression] = STATE(2523),
    [sym_logical_expression] = STATE(2523),
    [sym_bitwise_expression] = STATE(2523),
    [sym_equality_expression] = STATE(2523),
    [sym_relational_expression] = STATE(2523),
    [sym_shift_expression] = STATE(2523),
    [sym_math_expression] = STATE(2523),
    [sym_cast_expression] = STATE(2523),
    [sym_sizeof_expression] = STATE(2523),
    [sym_subscript_expression] = STATE(2523),
    [sym_call_expression] = STATE(2523),
    [sym_field_expression] = STATE(2523),
    [sym_compound_literal_expression] = STATE(2523),
    [sym_parenthesized_expression] = STATE(2523),
    [sym_initializer_list] = STATE(2524),
    [sym_char_literal] = STATE(2523),
    [sym_concatenated_string] = STATE(2523),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2523),
    [sym_new_expression] = STATE(2523),
    [sym_delete_expression] = STATE(2523),
    [sym_lambda_expression] = STATE(2523),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5581),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(5581),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(5583),
    [sym_false] = ACTIONS(5583),
    [sym_null] = ACTIONS(5583),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(5583),
  },
  [1841] = {
    [anon_sym_SEMI] = ACTIONS(5585),
    [sym_comment] = ACTIONS(91),
  },
  [1842] = {
    [anon_sym_SEMI] = ACTIONS(5587),
    [sym_comment] = ACTIONS(91),
  },
  [1843] = {
    [anon_sym_SEMI] = ACTIONS(5589),
    [sym_comment] = ACTIONS(91),
  },
  [1844] = {
    [sym_raw_string_literal] = ACTIONS(3569),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3571),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3571),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3571),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3571),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3571),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3571),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3571),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3571),
    [sym_preproc_directive] = ACTIONS(3571),
    [anon_sym_SEMI] = ACTIONS(3569),
    [anon_sym_typedef] = ACTIONS(3571),
    [anon_sym_extern] = ACTIONS(3571),
    [anon_sym_LBRACE] = ACTIONS(3569),
    [anon_sym_LPAREN2] = ACTIONS(3569),
    [anon_sym_STAR] = ACTIONS(3569),
    [anon_sym_LBRACK] = ACTIONS(3569),
    [anon_sym_static] = ACTIONS(3571),
    [anon_sym_register] = ACTIONS(3571),
    [anon_sym_inline] = ACTIONS(3571),
    [anon_sym_const] = ACTIONS(3571),
    [anon_sym_restrict] = ACTIONS(3571),
    [anon_sym_volatile] = ACTIONS(3571),
    [anon_sym__Atomic] = ACTIONS(3571),
    [anon_sym_mutable] = ACTIONS(3571),
    [anon_sym_explicit] = ACTIONS(3571),
    [anon_sym_constexpr] = ACTIONS(3571),
    [anon_sym_unsigned] = ACTIONS(3571),
    [anon_sym_long] = ACTIONS(3571),
    [anon_sym_short] = ACTIONS(3571),
    [sym_primitive_type] = ACTIONS(3571),
    [anon_sym_enum] = ACTIONS(3571),
    [anon_sym_struct] = ACTIONS(3571),
    [anon_sym_union] = ACTIONS(3571),
    [anon_sym_if] = ACTIONS(3571),
    [anon_sym_switch] = ACTIONS(3571),
    [anon_sym_case] = ACTIONS(3571),
    [anon_sym_default] = ACTIONS(3571),
    [anon_sym_while] = ACTIONS(3571),
    [anon_sym_do] = ACTIONS(3571),
    [anon_sym_for] = ACTIONS(3571),
    [anon_sym_return] = ACTIONS(3571),
    [anon_sym_break] = ACTIONS(3571),
    [anon_sym_continue] = ACTIONS(3571),
    [anon_sym_goto] = ACTIONS(3571),
    [anon_sym_AMP] = ACTIONS(3571),
    [anon_sym_AMP_AMP] = ACTIONS(3569),
    [anon_sym_BANG] = ACTIONS(3569),
    [anon_sym_TILDE] = ACTIONS(3569),
    [anon_sym_PLUS] = ACTIONS(3571),
    [anon_sym_DASH] = ACTIONS(3571),
    [anon_sym_DASH_DASH] = ACTIONS(3569),
    [anon_sym_PLUS_PLUS] = ACTIONS(3569),
    [anon_sym_sizeof] = ACTIONS(3571),
    [sym_number_literal] = ACTIONS(3569),
    [anon_sym_SQUOTE] = ACTIONS(3569),
    [anon_sym_DQUOTE] = ACTIONS(3569),
    [sym_true] = ACTIONS(3571),
    [sym_false] = ACTIONS(3571),
    [sym_null] = ACTIONS(3571),
    [sym_identifier] = ACTIONS(3571),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3571),
    [sym_auto] = ACTIONS(3571),
    [anon_sym_typename] = ACTIONS(3571),
    [anon_sym_template] = ACTIONS(3571),
    [anon_sym_delete] = ACTIONS(3571),
    [anon_sym_namespace] = ACTIONS(3571),
    [anon_sym_using] = ACTIONS(3571),
    [anon_sym_try] = ACTIONS(3571),
    [anon_sym_new] = ACTIONS(3571),
    [anon_sym_COLON_COLON] = ACTIONS(3569),
    [sym_operator_name] = ACTIONS(3569),
    [sym_nullptr] = ACTIONS(3571),
  },
  [1845] = {
    [sym_raw_string_literal] = ACTIONS(5591),
    [ts_builtin_sym_end] = ACTIONS(5591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5593),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5593),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5593),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5593),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5593),
    [sym_preproc_directive] = ACTIONS(5593),
    [anon_sym_SEMI] = ACTIONS(5591),
    [anon_sym_typedef] = ACTIONS(5593),
    [anon_sym_extern] = ACTIONS(5593),
    [anon_sym_LBRACE] = ACTIONS(5591),
    [anon_sym_RBRACE] = ACTIONS(5591),
    [anon_sym_LPAREN2] = ACTIONS(5591),
    [anon_sym_STAR] = ACTIONS(5591),
    [anon_sym_LBRACK] = ACTIONS(5591),
    [anon_sym_static] = ACTIONS(5593),
    [anon_sym_register] = ACTIONS(5593),
    [anon_sym_inline] = ACTIONS(5593),
    [anon_sym_const] = ACTIONS(5593),
    [anon_sym_restrict] = ACTIONS(5593),
    [anon_sym_volatile] = ACTIONS(5593),
    [anon_sym__Atomic] = ACTIONS(5593),
    [anon_sym_mutable] = ACTIONS(5593),
    [anon_sym_explicit] = ACTIONS(5593),
    [anon_sym_constexpr] = ACTIONS(5593),
    [anon_sym_unsigned] = ACTIONS(5593),
    [anon_sym_long] = ACTIONS(5593),
    [anon_sym_short] = ACTIONS(5593),
    [sym_primitive_type] = ACTIONS(5593),
    [anon_sym_enum] = ACTIONS(5593),
    [anon_sym_struct] = ACTIONS(5593),
    [anon_sym_union] = ACTIONS(5593),
    [anon_sym_if] = ACTIONS(5593),
    [anon_sym_switch] = ACTIONS(5593),
    [anon_sym_case] = ACTIONS(5593),
    [anon_sym_default] = ACTIONS(5593),
    [anon_sym_while] = ACTIONS(5593),
    [anon_sym_do] = ACTIONS(5593),
    [anon_sym_for] = ACTIONS(5593),
    [anon_sym_return] = ACTIONS(5593),
    [anon_sym_break] = ACTIONS(5593),
    [anon_sym_continue] = ACTIONS(5593),
    [anon_sym_goto] = ACTIONS(5593),
    [anon_sym_AMP] = ACTIONS(5593),
    [anon_sym_AMP_AMP] = ACTIONS(5591),
    [anon_sym_BANG] = ACTIONS(5591),
    [anon_sym_TILDE] = ACTIONS(5591),
    [anon_sym_PLUS] = ACTIONS(5593),
    [anon_sym_DASH] = ACTIONS(5593),
    [anon_sym_DASH_DASH] = ACTIONS(5591),
    [anon_sym_PLUS_PLUS] = ACTIONS(5591),
    [anon_sym_sizeof] = ACTIONS(5593),
    [sym_number_literal] = ACTIONS(5591),
    [anon_sym_SQUOTE] = ACTIONS(5591),
    [anon_sym_DQUOTE] = ACTIONS(5591),
    [sym_true] = ACTIONS(5593),
    [sym_false] = ACTIONS(5593),
    [sym_null] = ACTIONS(5593),
    [sym_identifier] = ACTIONS(5593),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5593),
    [sym_auto] = ACTIONS(5593),
    [anon_sym_typename] = ACTIONS(5593),
    [anon_sym_template] = ACTIONS(5593),
    [anon_sym_delete] = ACTIONS(5593),
    [anon_sym_namespace] = ACTIONS(5593),
    [anon_sym_using] = ACTIONS(5593),
    [anon_sym_try] = ACTIONS(5593),
    [anon_sym_new] = ACTIONS(5593),
    [anon_sym_COLON_COLON] = ACTIONS(5591),
    [sym_operator_name] = ACTIONS(5591),
    [sym_nullptr] = ACTIONS(5593),
  },
  [1846] = {
    [sym_compound_statement] = STATE(2528),
    [sym_default_method_clause] = STATE(2528),
    [sym_delete_method_clause] = STATE(2528),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_EQ] = ACTIONS(2130),
    [sym_comment] = ACTIONS(91),
  },
  [1847] = {
    [sym_raw_string_literal] = ACTIONS(5595),
    [ts_builtin_sym_end] = ACTIONS(5595),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5597),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5597),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5597),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5597),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5597),
    [sym_preproc_directive] = ACTIONS(5597),
    [anon_sym_SEMI] = ACTIONS(5595),
    [anon_sym_typedef] = ACTIONS(5597),
    [anon_sym_extern] = ACTIONS(5597),
    [anon_sym_LBRACE] = ACTIONS(5595),
    [anon_sym_RBRACE] = ACTIONS(5595),
    [anon_sym_LPAREN2] = ACTIONS(5595),
    [anon_sym_STAR] = ACTIONS(5595),
    [anon_sym_LBRACK] = ACTIONS(5595),
    [anon_sym_static] = ACTIONS(5597),
    [anon_sym_register] = ACTIONS(5597),
    [anon_sym_inline] = ACTIONS(5597),
    [anon_sym_const] = ACTIONS(5597),
    [anon_sym_restrict] = ACTIONS(5597),
    [anon_sym_volatile] = ACTIONS(5597),
    [anon_sym__Atomic] = ACTIONS(5597),
    [anon_sym_mutable] = ACTIONS(5597),
    [anon_sym_explicit] = ACTIONS(5597),
    [anon_sym_constexpr] = ACTIONS(5597),
    [anon_sym_unsigned] = ACTIONS(5597),
    [anon_sym_long] = ACTIONS(5597),
    [anon_sym_short] = ACTIONS(5597),
    [sym_primitive_type] = ACTIONS(5597),
    [anon_sym_enum] = ACTIONS(5597),
    [anon_sym_struct] = ACTIONS(5597),
    [anon_sym_union] = ACTIONS(5597),
    [anon_sym_if] = ACTIONS(5597),
    [anon_sym_switch] = ACTIONS(5597),
    [anon_sym_case] = ACTIONS(5597),
    [anon_sym_default] = ACTIONS(5597),
    [anon_sym_while] = ACTIONS(5597),
    [anon_sym_do] = ACTIONS(5597),
    [anon_sym_for] = ACTIONS(5597),
    [anon_sym_return] = ACTIONS(5597),
    [anon_sym_break] = ACTIONS(5597),
    [anon_sym_continue] = ACTIONS(5597),
    [anon_sym_goto] = ACTIONS(5597),
    [anon_sym_AMP] = ACTIONS(5597),
    [anon_sym_AMP_AMP] = ACTIONS(5595),
    [anon_sym_BANG] = ACTIONS(5595),
    [anon_sym_TILDE] = ACTIONS(5595),
    [anon_sym_PLUS] = ACTIONS(5597),
    [anon_sym_DASH] = ACTIONS(5597),
    [anon_sym_DASH_DASH] = ACTIONS(5595),
    [anon_sym_PLUS_PLUS] = ACTIONS(5595),
    [anon_sym_sizeof] = ACTIONS(5597),
    [sym_number_literal] = ACTIONS(5595),
    [anon_sym_SQUOTE] = ACTIONS(5595),
    [anon_sym_DQUOTE] = ACTIONS(5595),
    [sym_true] = ACTIONS(5597),
    [sym_false] = ACTIONS(5597),
    [sym_null] = ACTIONS(5597),
    [sym_identifier] = ACTIONS(5597),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5597),
    [sym_auto] = ACTIONS(5597),
    [anon_sym_typename] = ACTIONS(5597),
    [anon_sym_template] = ACTIONS(5597),
    [anon_sym_delete] = ACTIONS(5597),
    [anon_sym_namespace] = ACTIONS(5597),
    [anon_sym_using] = ACTIONS(5597),
    [anon_sym_try] = ACTIONS(5597),
    [anon_sym_new] = ACTIONS(5597),
    [anon_sym_COLON_COLON] = ACTIONS(5595),
    [sym_operator_name] = ACTIONS(5595),
    [sym_nullptr] = ACTIONS(5597),
  },
  [1848] = {
    [anon_sym_COMMA] = ACTIONS(4213),
    [anon_sym_SEMI] = ACTIONS(4213),
    [anon_sym_LBRACE] = ACTIONS(4213),
    [anon_sym_LPAREN2] = ACTIONS(4213),
    [anon_sym_STAR] = ACTIONS(4213),
    [anon_sym_LBRACK] = ACTIONS(4213),
    [anon_sym_EQ] = ACTIONS(4213),
    [anon_sym_const] = ACTIONS(4215),
    [anon_sym_restrict] = ACTIONS(4215),
    [anon_sym_volatile] = ACTIONS(4215),
    [anon_sym__Atomic] = ACTIONS(4215),
    [anon_sym_mutable] = ACTIONS(4215),
    [anon_sym_explicit] = ACTIONS(4215),
    [anon_sym_constexpr] = ACTIONS(4215),
    [anon_sym_COLON] = ACTIONS(4213),
    [anon_sym_AMP] = ACTIONS(4215),
    [anon_sym_AMP_AMP] = ACTIONS(4213),
    [anon_sym_DASH_GT] = ACTIONS(4213),
    [sym_identifier] = ACTIONS(4215),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4215),
    [anon_sym_override] = ACTIONS(4215),
    [sym_noexcept] = ACTIONS(4215),
  },
  [1849] = {
    [sym_enumerator] = STATE(1988),
    [anon_sym_RBRACE] = ACTIONS(5599),
    [sym_identifier] = ACTIONS(1009),
    [sym_comment] = ACTIONS(91),
  },
  [1850] = {
    [aux_sym_enumerator_list_repeat1] = STATE(1990),
    [anon_sym_COMMA] = ACTIONS(5601),
    [anon_sym_RBRACE] = ACTIONS(5599),
    [sym_comment] = ACTIONS(91),
  },
  [1851] = {
    [anon_sym_COMMA] = ACTIONS(4307),
    [anon_sym_SEMI] = ACTIONS(4307),
    [anon_sym_LBRACE] = ACTIONS(4307),
    [anon_sym_LPAREN2] = ACTIONS(4307),
    [anon_sym_STAR] = ACTIONS(4307),
    [anon_sym_LBRACK] = ACTIONS(4307),
    [anon_sym_EQ] = ACTIONS(4307),
    [anon_sym_const] = ACTIONS(4309),
    [anon_sym_restrict] = ACTIONS(4309),
    [anon_sym_volatile] = ACTIONS(4309),
    [anon_sym__Atomic] = ACTIONS(4309),
    [anon_sym_mutable] = ACTIONS(4309),
    [anon_sym_explicit] = ACTIONS(4309),
    [anon_sym_constexpr] = ACTIONS(4309),
    [anon_sym_COLON] = ACTIONS(4307),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_AMP_AMP] = ACTIONS(4307),
    [anon_sym_DASH_GT] = ACTIONS(4307),
    [sym_identifier] = ACTIONS(4309),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4309),
    [anon_sym_override] = ACTIONS(4309),
    [sym_noexcept] = ACTIONS(4309),
  },
  [1852] = {
    [anon_sym_COMMA] = ACTIONS(4398),
    [anon_sym_SEMI] = ACTIONS(4398),
    [anon_sym_LBRACE] = ACTIONS(4398),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_STAR] = ACTIONS(4398),
    [anon_sym_LBRACK] = ACTIONS(4398),
    [anon_sym_EQ] = ACTIONS(4398),
    [anon_sym_const] = ACTIONS(4400),
    [anon_sym_restrict] = ACTIONS(4400),
    [anon_sym_volatile] = ACTIONS(4400),
    [anon_sym__Atomic] = ACTIONS(4400),
    [anon_sym_mutable] = ACTIONS(4400),
    [anon_sym_explicit] = ACTIONS(4400),
    [anon_sym_constexpr] = ACTIONS(4400),
    [anon_sym_COLON] = ACTIONS(4398),
    [anon_sym_AMP] = ACTIONS(4400),
    [anon_sym_AMP_AMP] = ACTIONS(4398),
    [anon_sym_DASH_GT] = ACTIONS(4398),
    [sym_identifier] = ACTIONS(4400),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4400),
    [anon_sym_override] = ACTIONS(4400),
    [sym_noexcept] = ACTIONS(4400),
  },
  [1853] = {
    [sym_field_declaration_list] = STATE(2531),
    [anon_sym_LBRACE] = ACTIONS(750),
    [sym_comment] = ACTIONS(91),
  },
  [1854] = {
    [anon_sym_COMMA] = ACTIONS(4402),
    [anon_sym_SEMI] = ACTIONS(4402),
    [anon_sym_LBRACE] = ACTIONS(4402),
    [anon_sym_LPAREN2] = ACTIONS(4402),
    [anon_sym_STAR] = ACTIONS(4402),
    [anon_sym_LBRACK] = ACTIONS(4402),
    [anon_sym_EQ] = ACTIONS(4402),
    [anon_sym_const] = ACTIONS(4404),
    [anon_sym_restrict] = ACTIONS(4404),
    [anon_sym_volatile] = ACTIONS(4404),
    [anon_sym__Atomic] = ACTIONS(4404),
    [anon_sym_mutable] = ACTIONS(4404),
    [anon_sym_explicit] = ACTIONS(4404),
    [anon_sym_constexpr] = ACTIONS(4404),
    [anon_sym_COLON] = ACTIONS(4402),
    [anon_sym_AMP] = ACTIONS(4404),
    [anon_sym_AMP_AMP] = ACTIONS(4402),
    [anon_sym_DASH_GT] = ACTIONS(4402),
    [sym_identifier] = ACTIONS(4404),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4404),
    [anon_sym_override] = ACTIONS(4404),
    [sym_noexcept] = ACTIONS(4404),
  },
  [1855] = {
    [sym_field_declaration_list] = STATE(2532),
    [anon_sym_LBRACE] = ACTIONS(750),
    [sym_comment] = ACTIONS(91),
  },
  [1856] = {
    [anon_sym_COMMA] = ACTIONS(4406),
    [anon_sym_SEMI] = ACTIONS(4406),
    [anon_sym_LBRACE] = ACTIONS(4406),
    [anon_sym_LPAREN2] = ACTIONS(4406),
    [anon_sym_STAR] = ACTIONS(4406),
    [anon_sym_LBRACK] = ACTIONS(4406),
    [anon_sym_EQ] = ACTIONS(4406),
    [anon_sym_const] = ACTIONS(4408),
    [anon_sym_restrict] = ACTIONS(4408),
    [anon_sym_volatile] = ACTIONS(4408),
    [anon_sym__Atomic] = ACTIONS(4408),
    [anon_sym_mutable] = ACTIONS(4408),
    [anon_sym_explicit] = ACTIONS(4408),
    [anon_sym_constexpr] = ACTIONS(4408),
    [anon_sym_COLON] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_DASH_GT] = ACTIONS(4406),
    [sym_identifier] = ACTIONS(4408),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4408),
    [anon_sym_override] = ACTIONS(4408),
    [sym_noexcept] = ACTIONS(4408),
  },
  [1857] = {
    [sym_field_declaration_list] = STATE(2533),
    [anon_sym_LBRACE] = ACTIONS(750),
    [sym_comment] = ACTIONS(91),
  },
  [1858] = {
    [anon_sym_COMMA] = ACTIONS(4410),
    [anon_sym_SEMI] = ACTIONS(4410),
    [anon_sym_LBRACE] = ACTIONS(4410),
    [anon_sym_LPAREN2] = ACTIONS(4410),
    [anon_sym_STAR] = ACTIONS(4410),
    [anon_sym_LBRACK] = ACTIONS(4410),
    [anon_sym_EQ] = ACTIONS(4410),
    [anon_sym_const] = ACTIONS(4412),
    [anon_sym_restrict] = ACTIONS(4412),
    [anon_sym_volatile] = ACTIONS(4412),
    [anon_sym__Atomic] = ACTIONS(4412),
    [anon_sym_mutable] = ACTIONS(4412),
    [anon_sym_explicit] = ACTIONS(4412),
    [anon_sym_constexpr] = ACTIONS(4412),
    [anon_sym_COLON] = ACTIONS(4410),
    [anon_sym_AMP] = ACTIONS(4412),
    [anon_sym_AMP_AMP] = ACTIONS(4410),
    [anon_sym_DASH_GT] = ACTIONS(4410),
    [sym_identifier] = ACTIONS(4412),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4412),
    [anon_sym_override] = ACTIONS(4412),
    [sym_noexcept] = ACTIONS(4412),
  },
  [1859] = {
    [sym_field_declaration_list] = STATE(2534),
    [anon_sym_LBRACE] = ACTIONS(750),
    [sym_comment] = ACTIONS(91),
  },
  [1860] = {
    [anon_sym_LBRACE] = ACTIONS(4843),
    [anon_sym_LPAREN2] = ACTIONS(4843),
    [anon_sym_STAR] = ACTIONS(4843),
    [anon_sym_COLON] = ACTIONS(4845),
    [sym_identifier] = ACTIONS(4845),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4845),
    [anon_sym_override] = ACTIONS(4845),
    [anon_sym_COLON_COLON] = ACTIONS(4843),
  },
  [1861] = {
    [aux_sym_template_argument_list_repeat1] = STATE(2235),
    [anon_sym_COMMA] = ACTIONS(3163),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(5603),
  },
  [1862] = {
    [anon_sym_LBRACE] = ACTIONS(4849),
    [anon_sym_LPAREN2] = ACTIONS(4849),
    [anon_sym_STAR] = ACTIONS(4849),
    [anon_sym_COLON] = ACTIONS(4851),
    [sym_identifier] = ACTIONS(4851),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4851),
    [anon_sym_override] = ACTIONS(4851),
    [anon_sym_COLON_COLON] = ACTIONS(4849),
  },
  [1863] = {
    [aux_sym_template_argument_list_repeat1] = STATE(2235),
    [anon_sym_COMMA] = ACTIONS(3163),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(5605),
  },
  [1864] = {
    [anon_sym_COMMA] = ACTIONS(4864),
    [anon_sym_SEMI] = ACTIONS(4864),
    [anon_sym_LBRACE] = ACTIONS(4864),
    [anon_sym_LPAREN2] = ACTIONS(4864),
    [anon_sym_STAR] = ACTIONS(4864),
    [anon_sym_LBRACK] = ACTIONS(4864),
    [anon_sym_EQ] = ACTIONS(4864),
    [anon_sym_const] = ACTIONS(4866),
    [anon_sym_restrict] = ACTIONS(4866),
    [anon_sym_volatile] = ACTIONS(4866),
    [anon_sym__Atomic] = ACTIONS(4866),
    [anon_sym_mutable] = ACTIONS(4866),
    [anon_sym_explicit] = ACTIONS(4866),
    [anon_sym_constexpr] = ACTIONS(4866),
    [anon_sym_COLON] = ACTIONS(4864),
    [anon_sym_AMP] = ACTIONS(4866),
    [anon_sym_AMP_AMP] = ACTIONS(4864),
    [anon_sym_DASH_GT] = ACTIONS(4864),
    [sym_identifier] = ACTIONS(4866),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4866),
    [anon_sym_override] = ACTIONS(4866),
    [sym_noexcept] = ACTIONS(4866),
  },
  [1865] = {
    [sym_field_declaration_list] = STATE(2537),
    [anon_sym_LBRACE] = ACTIONS(750),
    [sym_comment] = ACTIONS(91),
  },
  [1866] = {
    [anon_sym_COMMA] = ACTIONS(4868),
    [anon_sym_SEMI] = ACTIONS(4868),
    [anon_sym_LBRACE] = ACTIONS(4868),
    [anon_sym_LPAREN2] = ACTIONS(4868),
    [anon_sym_STAR] = ACTIONS(4868),
    [anon_sym_LBRACK] = ACTIONS(4868),
    [anon_sym_EQ] = ACTIONS(4868),
    [anon_sym_const] = ACTIONS(4870),
    [anon_sym_restrict] = ACTIONS(4870),
    [anon_sym_volatile] = ACTIONS(4870),
    [anon_sym__Atomic] = ACTIONS(4870),
    [anon_sym_mutable] = ACTIONS(4870),
    [anon_sym_explicit] = ACTIONS(4870),
    [anon_sym_constexpr] = ACTIONS(4870),
    [anon_sym_COLON] = ACTIONS(4868),
    [anon_sym_AMP] = ACTIONS(4870),
    [anon_sym_AMP_AMP] = ACTIONS(4868),
    [anon_sym_DASH_GT] = ACTIONS(4868),
    [sym_identifier] = ACTIONS(4870),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4870),
    [anon_sym_override] = ACTIONS(4870),
    [sym_noexcept] = ACTIONS(4870),
  },
  [1867] = {
    [sym_field_declaration_list] = STATE(2538),
    [anon_sym_LBRACE] = ACTIONS(750),
    [sym_comment] = ACTIONS(91),
  },
  [1868] = {
    [sym__type_declarator] = STATE(1870),
    [sym_pointer_type_declarator] = STATE(1870),
    [sym_function_type_declarator] = STATE(1870),
    [sym_array_type_declarator] = STATE(1870),
    [sym_type_qualifier] = STATE(1871),
    [aux_sym_type_definition_repeat1] = STATE(1871),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_STAR] = ACTIONS(2162),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [sym_identifier] = ACTIONS(2164),
    [sym_comment] = ACTIONS(91),
  },
  [1869] = {
    [anon_sym_RPAREN] = ACTIONS(5607),
    [anon_sym_SEMI] = ACTIONS(5607),
    [anon_sym_LPAREN2] = ACTIONS(5607),
    [anon_sym_LBRACK] = ACTIONS(5607),
    [sym_comment] = ACTIONS(91),
  },
  [1870] = {
    [sym_parameter_list] = STATE(1105),
    [anon_sym_RPAREN] = ACTIONS(5609),
    [anon_sym_SEMI] = ACTIONS(5609),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [sym_comment] = ACTIONS(91),
  },
  [1871] = {
    [sym_type_qualifier] = STATE(1871),
    [aux_sym_type_definition_repeat1] = STATE(1871),
    [anon_sym_LPAREN2] = ACTIONS(2179),
    [anon_sym_STAR] = ACTIONS(2179),
    [anon_sym_const] = ACTIONS(2174),
    [anon_sym_restrict] = ACTIONS(2174),
    [anon_sym_volatile] = ACTIONS(2174),
    [anon_sym__Atomic] = ACTIONS(2174),
    [anon_sym_mutable] = ACTIONS(2174),
    [anon_sym_explicit] = ACTIONS(2174),
    [anon_sym_constexpr] = ACTIONS(2174),
    [sym_identifier] = ACTIONS(2177),
    [sym_comment] = ACTIONS(91),
  },
  [1872] = {
    [sym__expression] = STATE(146),
    [sym_conditional_expression] = STATE(146),
    [sym_assignment_expression] = STATE(146),
    [sym_pointer_expression] = STATE(146),
    [sym_logical_expression] = STATE(146),
    [sym_bitwise_expression] = STATE(146),
    [sym_equality_expression] = STATE(146),
    [sym_relational_expression] = STATE(146),
    [sym_shift_expression] = STATE(146),
    [sym_math_expression] = STATE(146),
    [sym_cast_expression] = STATE(146),
    [sym_sizeof_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_compound_literal_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_char_literal] = STATE(146),
    [sym_concatenated_string] = STATE(146),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(146),
    [sym_new_expression] = STATE(146),
    [sym_delete_expression] = STATE(146),
    [sym_lambda_expression] = STATE(146),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(257),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(5611),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(257),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(259),
    [sym_false] = ACTIONS(259),
    [sym_null] = ACTIONS(259),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(259),
  },
  [1873] = {
    [anon_sym_RPAREN] = ACTIONS(5613),
    [anon_sym_SEMI] = ACTIONS(5613),
    [anon_sym_LPAREN2] = ACTIONS(5613),
    [anon_sym_LBRACK] = ACTIONS(5613),
    [sym_comment] = ACTIONS(91),
  },
  [1874] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(5611),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_STAR_EQ] = ACTIONS(3507),
    [anon_sym_SLASH_EQ] = ACTIONS(3507),
    [anon_sym_PERCENT_EQ] = ACTIONS(3507),
    [anon_sym_PLUS_EQ] = ACTIONS(3507),
    [anon_sym_DASH_EQ] = ACTIONS(3507),
    [anon_sym_LT_LT_EQ] = ACTIONS(3507),
    [anon_sym_GT_GT_EQ] = ACTIONS(3507),
    [anon_sym_AMP_EQ] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(3507),
    [anon_sym_PIPE_EQ] = ACTIONS(3507),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_CARET] = ACTIONS(3517),
    [anon_sym_EQ_EQ] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3521),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3525),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1875] = {
    [sym_type_qualifier] = STATE(1684),
    [sym__expression] = STATE(2541),
    [sym_conditional_expression] = STATE(2541),
    [sym_assignment_expression] = STATE(2541),
    [sym_pointer_expression] = STATE(2541),
    [sym_logical_expression] = STATE(2541),
    [sym_bitwise_expression] = STATE(2541),
    [sym_equality_expression] = STATE(2541),
    [sym_relational_expression] = STATE(2541),
    [sym_shift_expression] = STATE(2541),
    [sym_math_expression] = STATE(2541),
    [sym_cast_expression] = STATE(2541),
    [sym_sizeof_expression] = STATE(2541),
    [sym_subscript_expression] = STATE(2541),
    [sym_call_expression] = STATE(2541),
    [sym_field_expression] = STATE(2541),
    [sym_compound_literal_expression] = STATE(2541),
    [sym_parenthesized_expression] = STATE(2541),
    [sym_char_literal] = STATE(2541),
    [sym_concatenated_string] = STATE(2541),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2541),
    [sym_new_expression] = STATE(2541),
    [sym_delete_expression] = STATE(2541),
    [sym_lambda_expression] = STATE(2541),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [aux_sym_type_definition_repeat1] = STATE(1684),
    [sym_raw_string_literal] = ACTIONS(5615),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(5617),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(5611),
    [anon_sym_const] = ACTIONS(1643),
    [anon_sym_restrict] = ACTIONS(1643),
    [anon_sym_volatile] = ACTIONS(1643),
    [anon_sym__Atomic] = ACTIONS(1643),
    [anon_sym_mutable] = ACTIONS(1643),
    [anon_sym_explicit] = ACTIONS(1643),
    [anon_sym_constexpr] = ACTIONS(1643),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(5615),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(5619),
    [sym_false] = ACTIONS(5619),
    [sym_null] = ACTIONS(5619),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(5619),
  },
  [1876] = {
    [sym_raw_string_literal] = ACTIONS(5621),
    [ts_builtin_sym_end] = ACTIONS(5621),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5623),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5623),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5623),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5623),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5623),
    [sym_preproc_directive] = ACTIONS(5623),
    [anon_sym_SEMI] = ACTIONS(5621),
    [anon_sym_typedef] = ACTIONS(5623),
    [anon_sym_extern] = ACTIONS(5623),
    [anon_sym_LBRACE] = ACTIONS(5621),
    [anon_sym_RBRACE] = ACTIONS(5621),
    [anon_sym_LPAREN2] = ACTIONS(5621),
    [anon_sym_STAR] = ACTIONS(5621),
    [anon_sym_LBRACK] = ACTIONS(5621),
    [anon_sym_static] = ACTIONS(5623),
    [anon_sym_register] = ACTIONS(5623),
    [anon_sym_inline] = ACTIONS(5623),
    [anon_sym_const] = ACTIONS(5623),
    [anon_sym_restrict] = ACTIONS(5623),
    [anon_sym_volatile] = ACTIONS(5623),
    [anon_sym__Atomic] = ACTIONS(5623),
    [anon_sym_mutable] = ACTIONS(5623),
    [anon_sym_explicit] = ACTIONS(5623),
    [anon_sym_constexpr] = ACTIONS(5623),
    [anon_sym_unsigned] = ACTIONS(5623),
    [anon_sym_long] = ACTIONS(5623),
    [anon_sym_short] = ACTIONS(5623),
    [sym_primitive_type] = ACTIONS(5623),
    [anon_sym_enum] = ACTIONS(5623),
    [anon_sym_struct] = ACTIONS(5623),
    [anon_sym_union] = ACTIONS(5623),
    [anon_sym_if] = ACTIONS(5623),
    [anon_sym_else] = ACTIONS(5623),
    [anon_sym_switch] = ACTIONS(5623),
    [anon_sym_case] = ACTIONS(5623),
    [anon_sym_default] = ACTIONS(5623),
    [anon_sym_while] = ACTIONS(5623),
    [anon_sym_do] = ACTIONS(5623),
    [anon_sym_for] = ACTIONS(5623),
    [anon_sym_return] = ACTIONS(5623),
    [anon_sym_break] = ACTIONS(5623),
    [anon_sym_continue] = ACTIONS(5623),
    [anon_sym_goto] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5623),
    [anon_sym_AMP_AMP] = ACTIONS(5621),
    [anon_sym_BANG] = ACTIONS(5621),
    [anon_sym_TILDE] = ACTIONS(5621),
    [anon_sym_PLUS] = ACTIONS(5623),
    [anon_sym_DASH] = ACTIONS(5623),
    [anon_sym_DASH_DASH] = ACTIONS(5621),
    [anon_sym_PLUS_PLUS] = ACTIONS(5621),
    [anon_sym_sizeof] = ACTIONS(5623),
    [sym_number_literal] = ACTIONS(5621),
    [anon_sym_SQUOTE] = ACTIONS(5621),
    [anon_sym_DQUOTE] = ACTIONS(5621),
    [sym_true] = ACTIONS(5623),
    [sym_false] = ACTIONS(5623),
    [sym_null] = ACTIONS(5623),
    [sym_identifier] = ACTIONS(5623),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5623),
    [sym_auto] = ACTIONS(5623),
    [anon_sym_typename] = ACTIONS(5623),
    [anon_sym_template] = ACTIONS(5623),
    [anon_sym_delete] = ACTIONS(5623),
    [anon_sym_namespace] = ACTIONS(5623),
    [anon_sym_using] = ACTIONS(5623),
    [anon_sym_try] = ACTIONS(5623),
    [anon_sym_new] = ACTIONS(5623),
    [anon_sym_COLON_COLON] = ACTIONS(5621),
    [sym_operator_name] = ACTIONS(5621),
    [sym_nullptr] = ACTIONS(5623),
  },
  [1877] = {
    [sym_raw_string_literal] = ACTIONS(3063),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3065),
    [sym_preproc_directive] = ACTIONS(3065),
    [anon_sym_SEMI] = ACTIONS(3063),
    [anon_sym_typedef] = ACTIONS(3065),
    [anon_sym_extern] = ACTIONS(3065),
    [anon_sym_LBRACE] = ACTIONS(3063),
    [anon_sym_RBRACE] = ACTIONS(3063),
    [anon_sym_LPAREN2] = ACTIONS(3063),
    [anon_sym_STAR] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_static] = ACTIONS(3065),
    [anon_sym_register] = ACTIONS(3065),
    [anon_sym_inline] = ACTIONS(3065),
    [anon_sym_const] = ACTIONS(3065),
    [anon_sym_restrict] = ACTIONS(3065),
    [anon_sym_volatile] = ACTIONS(3065),
    [anon_sym__Atomic] = ACTIONS(3065),
    [anon_sym_mutable] = ACTIONS(3065),
    [anon_sym_explicit] = ACTIONS(3065),
    [anon_sym_constexpr] = ACTIONS(3065),
    [anon_sym_unsigned] = ACTIONS(3065),
    [anon_sym_long] = ACTIONS(3065),
    [anon_sym_short] = ACTIONS(3065),
    [sym_primitive_type] = ACTIONS(3065),
    [anon_sym_enum] = ACTIONS(3065),
    [anon_sym_struct] = ACTIONS(3065),
    [anon_sym_union] = ACTIONS(3065),
    [anon_sym_if] = ACTIONS(3065),
    [anon_sym_switch] = ACTIONS(3065),
    [anon_sym_case] = ACTIONS(3065),
    [anon_sym_default] = ACTIONS(3065),
    [anon_sym_while] = ACTIONS(3065),
    [anon_sym_do] = ACTIONS(3065),
    [anon_sym_for] = ACTIONS(3065),
    [anon_sym_return] = ACTIONS(3065),
    [anon_sym_break] = ACTIONS(3065),
    [anon_sym_continue] = ACTIONS(3065),
    [anon_sym_goto] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3063),
    [anon_sym_TILDE] = ACTIONS(3063),
    [anon_sym_PLUS] = ACTIONS(3065),
    [anon_sym_DASH] = ACTIONS(3065),
    [anon_sym_DASH_DASH] = ACTIONS(3063),
    [anon_sym_PLUS_PLUS] = ACTIONS(3063),
    [anon_sym_sizeof] = ACTIONS(3065),
    [sym_number_literal] = ACTIONS(3063),
    [anon_sym_SQUOTE] = ACTIONS(3063),
    [anon_sym_DQUOTE] = ACTIONS(3063),
    [sym_true] = ACTIONS(3065),
    [sym_false] = ACTIONS(3065),
    [sym_null] = ACTIONS(3065),
    [sym_identifier] = ACTIONS(3065),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3065),
    [sym_auto] = ACTIONS(3065),
    [anon_sym_typename] = ACTIONS(3065),
    [anon_sym_delete] = ACTIONS(3065),
    [anon_sym_try] = ACTIONS(3065),
    [anon_sym_new] = ACTIONS(3065),
    [anon_sym_COLON_COLON] = ACTIONS(3063),
    [sym_nullptr] = ACTIONS(3065),
  },
  [1878] = {
    [sym_raw_string_literal] = ACTIONS(3707),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3709),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3709),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3709),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3709),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3709),
    [sym_preproc_directive] = ACTIONS(3709),
    [anon_sym_SEMI] = ACTIONS(3707),
    [anon_sym_typedef] = ACTIONS(3709),
    [anon_sym_extern] = ACTIONS(3709),
    [anon_sym_LBRACE] = ACTIONS(3707),
    [anon_sym_RBRACE] = ACTIONS(3707),
    [anon_sym_LPAREN2] = ACTIONS(3707),
    [anon_sym_STAR] = ACTIONS(3707),
    [anon_sym_LBRACK] = ACTIONS(3707),
    [anon_sym_static] = ACTIONS(3709),
    [anon_sym_register] = ACTIONS(3709),
    [anon_sym_inline] = ACTIONS(3709),
    [anon_sym_const] = ACTIONS(3709),
    [anon_sym_restrict] = ACTIONS(3709),
    [anon_sym_volatile] = ACTIONS(3709),
    [anon_sym__Atomic] = ACTIONS(3709),
    [anon_sym_mutable] = ACTIONS(3709),
    [anon_sym_explicit] = ACTIONS(3709),
    [anon_sym_constexpr] = ACTIONS(3709),
    [anon_sym_unsigned] = ACTIONS(3709),
    [anon_sym_long] = ACTIONS(3709),
    [anon_sym_short] = ACTIONS(3709),
    [sym_primitive_type] = ACTIONS(3709),
    [anon_sym_enum] = ACTIONS(3709),
    [anon_sym_struct] = ACTIONS(3709),
    [anon_sym_union] = ACTIONS(3709),
    [anon_sym_if] = ACTIONS(3709),
    [anon_sym_switch] = ACTIONS(3709),
    [anon_sym_case] = ACTIONS(3709),
    [anon_sym_default] = ACTIONS(3709),
    [anon_sym_while] = ACTIONS(3709),
    [anon_sym_do] = ACTIONS(3709),
    [anon_sym_for] = ACTIONS(3709),
    [anon_sym_return] = ACTIONS(3709),
    [anon_sym_break] = ACTIONS(3709),
    [anon_sym_continue] = ACTIONS(3709),
    [anon_sym_goto] = ACTIONS(3709),
    [anon_sym_AMP] = ACTIONS(3707),
    [anon_sym_BANG] = ACTIONS(3707),
    [anon_sym_TILDE] = ACTIONS(3707),
    [anon_sym_PLUS] = ACTIONS(3709),
    [anon_sym_DASH] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3707),
    [anon_sym_PLUS_PLUS] = ACTIONS(3707),
    [anon_sym_sizeof] = ACTIONS(3709),
    [sym_number_literal] = ACTIONS(3707),
    [anon_sym_SQUOTE] = ACTIONS(3707),
    [anon_sym_DQUOTE] = ACTIONS(3707),
    [sym_true] = ACTIONS(3709),
    [sym_false] = ACTIONS(3709),
    [sym_null] = ACTIONS(3709),
    [sym_identifier] = ACTIONS(3709),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3709),
    [sym_auto] = ACTIONS(3709),
    [anon_sym_typename] = ACTIONS(3709),
    [anon_sym_delete] = ACTIONS(3709),
    [anon_sym_try] = ACTIONS(3709),
    [anon_sym_new] = ACTIONS(3709),
    [anon_sym_COLON_COLON] = ACTIONS(3707),
    [sym_nullptr] = ACTIONS(3709),
  },
  [1879] = {
    [sym_raw_string_literal] = ACTIONS(3711),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3713),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3713),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3713),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3713),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3713),
    [sym_preproc_directive] = ACTIONS(3713),
    [anon_sym_SEMI] = ACTIONS(3711),
    [anon_sym_typedef] = ACTIONS(3713),
    [anon_sym_extern] = ACTIONS(3713),
    [anon_sym_LBRACE] = ACTIONS(3711),
    [anon_sym_RBRACE] = ACTIONS(3711),
    [anon_sym_LPAREN2] = ACTIONS(3711),
    [anon_sym_STAR] = ACTIONS(3711),
    [anon_sym_LBRACK] = ACTIONS(3711),
    [anon_sym_static] = ACTIONS(3713),
    [anon_sym_register] = ACTIONS(3713),
    [anon_sym_inline] = ACTIONS(3713),
    [anon_sym_const] = ACTIONS(3713),
    [anon_sym_restrict] = ACTIONS(3713),
    [anon_sym_volatile] = ACTIONS(3713),
    [anon_sym__Atomic] = ACTIONS(3713),
    [anon_sym_mutable] = ACTIONS(3713),
    [anon_sym_explicit] = ACTIONS(3713),
    [anon_sym_constexpr] = ACTIONS(3713),
    [anon_sym_unsigned] = ACTIONS(3713),
    [anon_sym_long] = ACTIONS(3713),
    [anon_sym_short] = ACTIONS(3713),
    [sym_primitive_type] = ACTIONS(3713),
    [anon_sym_enum] = ACTIONS(3713),
    [anon_sym_struct] = ACTIONS(3713),
    [anon_sym_union] = ACTIONS(3713),
    [anon_sym_if] = ACTIONS(3713),
    [anon_sym_switch] = ACTIONS(3713),
    [anon_sym_case] = ACTIONS(3713),
    [anon_sym_default] = ACTIONS(3713),
    [anon_sym_while] = ACTIONS(3713),
    [anon_sym_do] = ACTIONS(3713),
    [anon_sym_for] = ACTIONS(3713),
    [anon_sym_return] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3713),
    [anon_sym_continue] = ACTIONS(3713),
    [anon_sym_goto] = ACTIONS(3713),
    [anon_sym_AMP] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3711),
    [anon_sym_TILDE] = ACTIONS(3711),
    [anon_sym_PLUS] = ACTIONS(3713),
    [anon_sym_DASH] = ACTIONS(3713),
    [anon_sym_DASH_DASH] = ACTIONS(3711),
    [anon_sym_PLUS_PLUS] = ACTIONS(3711),
    [anon_sym_sizeof] = ACTIONS(3713),
    [sym_number_literal] = ACTIONS(3711),
    [anon_sym_SQUOTE] = ACTIONS(3711),
    [anon_sym_DQUOTE] = ACTIONS(3711),
    [sym_true] = ACTIONS(3713),
    [sym_false] = ACTIONS(3713),
    [sym_null] = ACTIONS(3713),
    [sym_identifier] = ACTIONS(3713),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3713),
    [sym_auto] = ACTIONS(3713),
    [anon_sym_typename] = ACTIONS(3713),
    [anon_sym_delete] = ACTIONS(3713),
    [anon_sym_try] = ACTIONS(3713),
    [anon_sym_new] = ACTIONS(3713),
    [anon_sym_COLON_COLON] = ACTIONS(3711),
    [sym_nullptr] = ACTIONS(3713),
  },
  [1880] = {
    [anon_sym_LF] = ACTIONS(5625),
    [sym_comment] = ACTIONS(121),
  },
  [1881] = {
    [aux_sym_string_literal_repeat1] = STATE(2544),
    [anon_sym_DQUOTE] = ACTIONS(5627),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_BSLASHn_RBRACK_SLASH] = ACTIONS(5629),
    [sym_escape_sequence] = ACTIONS(5629),
    [sym_comment] = ACTIONS(121),
  },
  [1882] = {
    [sym_raw_string_literal] = ACTIONS(668),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(670),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(670),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(670),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(670),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(670),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(670),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(670),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(670),
    [sym_preproc_directive] = ACTIONS(670),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(670),
    [anon_sym_extern] = ACTIONS(670),
    [anon_sym_LBRACE] = ACTIONS(668),
    [anon_sym_LPAREN2] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(668),
    [anon_sym_LBRACK] = ACTIONS(668),
    [anon_sym_static] = ACTIONS(670),
    [anon_sym_register] = ACTIONS(670),
    [anon_sym_inline] = ACTIONS(670),
    [anon_sym_const] = ACTIONS(670),
    [anon_sym_restrict] = ACTIONS(670),
    [anon_sym_volatile] = ACTIONS(670),
    [anon_sym__Atomic] = ACTIONS(670),
    [anon_sym_mutable] = ACTIONS(670),
    [anon_sym_explicit] = ACTIONS(670),
    [anon_sym_constexpr] = ACTIONS(670),
    [anon_sym_unsigned] = ACTIONS(670),
    [anon_sym_long] = ACTIONS(670),
    [anon_sym_short] = ACTIONS(670),
    [sym_primitive_type] = ACTIONS(670),
    [anon_sym_enum] = ACTIONS(670),
    [anon_sym_struct] = ACTIONS(670),
    [anon_sym_union] = ACTIONS(670),
    [anon_sym_if] = ACTIONS(670),
    [anon_sym_switch] = ACTIONS(670),
    [anon_sym_case] = ACTIONS(670),
    [anon_sym_default] = ACTIONS(670),
    [anon_sym_while] = ACTIONS(670),
    [anon_sym_do] = ACTIONS(670),
    [anon_sym_for] = ACTIONS(670),
    [anon_sym_return] = ACTIONS(670),
    [anon_sym_break] = ACTIONS(670),
    [anon_sym_continue] = ACTIONS(670),
    [anon_sym_goto] = ACTIONS(670),
    [anon_sym_AMP] = ACTIONS(668),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_PLUS] = ACTIONS(670),
    [anon_sym_DASH] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(668),
    [anon_sym_PLUS_PLUS] = ACTIONS(668),
    [anon_sym_sizeof] = ACTIONS(670),
    [sym_number_literal] = ACTIONS(668),
    [anon_sym_SQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE] = ACTIONS(668),
    [sym_true] = ACTIONS(670),
    [sym_false] = ACTIONS(670),
    [sym_null] = ACTIONS(670),
    [sym_identifier] = ACTIONS(670),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(670),
    [sym_auto] = ACTIONS(670),
    [anon_sym_typename] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_try] = ACTIONS(670),
    [anon_sym_new] = ACTIONS(670),
    [anon_sym_COLON_COLON] = ACTIONS(668),
    [sym_nullptr] = ACTIONS(670),
  },
  [1883] = {
    [sym_preproc_params] = STATE(2547),
    [anon_sym_LF] = ACTIONS(5631),
    [anon_sym_LPAREN] = ACTIONS(674),
    [sym_preproc_arg] = ACTIONS(5633),
    [sym_comment] = ACTIONS(121),
  },
  [1884] = {
    [sym_preproc_include] = STATE(2550),
    [sym_preproc_def] = STATE(2550),
    [sym_preproc_function_def] = STATE(2550),
    [sym_preproc_call] = STATE(2550),
    [sym_preproc_if_in_compound_statement] = STATE(2550),
    [sym_preproc_ifdef_in_compound_statement] = STATE(2550),
    [sym_preproc_else_in_compound_statement] = STATE(2549),
    [sym_preproc_elif_in_compound_statement] = STATE(2549),
    [sym_declaration] = STATE(2550),
    [sym_type_definition] = STATE(2550),
    [sym__declaration_specifiers] = STATE(1138),
    [sym_compound_statement] = STATE(2550),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(2550),
    [sym_expression_statement] = STATE(2550),
    [sym_if_statement] = STATE(2550),
    [sym_switch_statement] = STATE(2550),
    [sym_case_statement] = STATE(2550),
    [sym_while_statement] = STATE(2550),
    [sym_do_statement] = STATE(2550),
    [sym_for_statement] = STATE(2550),
    [sym_return_statement] = STATE(2550),
    [sym_break_statement] = STATE(2550),
    [sym_continue_statement] = STATE(2550),
    [sym_goto_statement] = STATE(2550),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(2550),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(2550),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(2550),
    [sym_try_statement] = STATE(2550),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2550),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(2196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2198),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2200),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5635),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2208),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2210),
    [sym_preproc_directive] = ACTIONS(2212),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_typedef] = ACTIONS(2216),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(2220),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(2244),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_nullptr] = ACTIONS(2242),
  },
  [1885] = {
    [sym_preproc_include] = STATE(2553),
    [sym_preproc_def] = STATE(2553),
    [sym_preproc_function_def] = STATE(2553),
    [sym_preproc_call] = STATE(2553),
    [sym_preproc_if_in_compound_statement] = STATE(2553),
    [sym_preproc_ifdef_in_compound_statement] = STATE(2553),
    [sym_preproc_else_in_compound_statement] = STATE(2552),
    [sym_preproc_elif_in_compound_statement] = STATE(2552),
    [sym_declaration] = STATE(2553),
    [sym_type_definition] = STATE(2553),
    [sym__declaration_specifiers] = STATE(1138),
    [sym_compound_statement] = STATE(2553),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(2553),
    [sym_expression_statement] = STATE(2553),
    [sym_if_statement] = STATE(2553),
    [sym_switch_statement] = STATE(2553),
    [sym_case_statement] = STATE(2553),
    [sym_while_statement] = STATE(2553),
    [sym_do_statement] = STATE(2553),
    [sym_for_statement] = STATE(2553),
    [sym_return_statement] = STATE(2553),
    [sym_break_statement] = STATE(2553),
    [sym_continue_statement] = STATE(2553),
    [sym_goto_statement] = STATE(2553),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(2553),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(2553),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(2553),
    [sym_try_statement] = STATE(2553),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2553),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(2196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2198),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2200),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2208),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2210),
    [sym_preproc_directive] = ACTIONS(2212),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_typedef] = ACTIONS(2216),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(2220),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(2244),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_nullptr] = ACTIONS(2242),
  },
  [1886] = {
    [sym_string_literal] = STATE(2555),
    [anon_sym_DQUOTE] = ACTIONS(5639),
    [sym_system_lib_string] = ACTIONS(5641),
    [sym_comment] = ACTIONS(91),
  },
  [1887] = {
    [sym_identifier] = ACTIONS(5643),
    [sym_comment] = ACTIONS(91),
  },
  [1888] = {
    [sym_preproc_arg] = ACTIONS(5645),
    [sym_comment] = ACTIONS(121),
  },
  [1889] = {
    [sym_identifier] = ACTIONS(5647),
    [sym_comment] = ACTIONS(91),
  },
  [1890] = {
    [anon_sym_LF] = ACTIONS(5649),
    [sym_preproc_arg] = ACTIONS(5651),
    [sym_comment] = ACTIONS(121),
  },
  [1891] = {
    [sym_raw_string_literal] = ACTIONS(129),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(131),
    [sym_preproc_directive] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(129),
    [anon_sym_typedef] = ACTIONS(131),
    [anon_sym_extern] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_LPAREN2] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(129),
    [anon_sym_static] = ACTIONS(131),
    [anon_sym_register] = ACTIONS(131),
    [anon_sym_inline] = ACTIONS(131),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_restrict] = ACTIONS(131),
    [anon_sym_volatile] = ACTIONS(131),
    [anon_sym__Atomic] = ACTIONS(131),
    [anon_sym_mutable] = ACTIONS(131),
    [anon_sym_explicit] = ACTIONS(131),
    [anon_sym_constexpr] = ACTIONS(131),
    [anon_sym_unsigned] = ACTIONS(131),
    [anon_sym_long] = ACTIONS(131),
    [anon_sym_short] = ACTIONS(131),
    [sym_primitive_type] = ACTIONS(131),
    [anon_sym_enum] = ACTIONS(131),
    [anon_sym_struct] = ACTIONS(131),
    [anon_sym_union] = ACTIONS(131),
    [anon_sym_if] = ACTIONS(131),
    [anon_sym_else] = ACTIONS(131),
    [anon_sym_switch] = ACTIONS(131),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(131),
    [anon_sym_break] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_goto] = ACTIONS(131),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_BANG] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_PLUS] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(129),
    [anon_sym_PLUS_PLUS] = ACTIONS(129),
    [anon_sym_sizeof] = ACTIONS(131),
    [sym_number_literal] = ACTIONS(129),
    [anon_sym_SQUOTE] = ACTIONS(129),
    [anon_sym_DQUOTE] = ACTIONS(129),
    [sym_true] = ACTIONS(131),
    [sym_false] = ACTIONS(131),
    [sym_null] = ACTIONS(131),
    [sym_identifier] = ACTIONS(131),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(131),
    [sym_auto] = ACTIONS(131),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_delete] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(131),
    [anon_sym_new] = ACTIONS(131),
    [anon_sym_COLON_COLON] = ACTIONS(129),
    [sym_nullptr] = ACTIONS(131),
  },
  [1892] = {
    [sym_type_qualifier] = STATE(2562),
    [sym__type_specifier] = STATE(2561),
    [sym_sized_type_specifier] = STATE(2561),
    [sym_enum_specifier] = STATE(2561),
    [sym_struct_specifier] = STATE(2561),
    [sym_union_specifier] = STATE(2561),
    [sym_macro_type_specifier] = STATE(2561),
    [sym_class_specifier] = STATE(2561),
    [sym_dependent_type] = STATE(2561),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(82),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_type_definition_repeat1] = STATE(2562),
    [aux_sym_sized_type_specifier_repeat1] = STATE(85),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(135),
    [anon_sym_long] = ACTIONS(135),
    [anon_sym_short] = ACTIONS(135),
    [sym_primitive_type] = ACTIONS(5653),
    [anon_sym_enum] = ACTIONS(139),
    [anon_sym_struct] = ACTIONS(141),
    [anon_sym_union] = ACTIONS(143),
    [sym_identifier] = ACTIONS(145),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(147),
    [sym_auto] = ACTIONS(5653),
    [anon_sym_typename] = ACTIONS(149),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [1893] = {
    [sym_preproc_include] = STATE(2564),
    [sym_preproc_def] = STATE(2564),
    [sym_preproc_function_def] = STATE(2564),
    [sym_preproc_call] = STATE(2564),
    [sym_preproc_if_in_compound_statement] = STATE(2564),
    [sym_preproc_ifdef_in_compound_statement] = STATE(2564),
    [sym_declaration] = STATE(2564),
    [sym_type_definition] = STATE(2564),
    [sym__declaration_specifiers] = STATE(113),
    [sym_compound_statement] = STATE(2564),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(2564),
    [sym_expression_statement] = STATE(2564),
    [sym_if_statement] = STATE(2564),
    [sym_switch_statement] = STATE(2564),
    [sym_case_statement] = STATE(2564),
    [sym_while_statement] = STATE(2564),
    [sym_do_statement] = STATE(2564),
    [sym_for_statement] = STATE(2564),
    [sym_return_statement] = STATE(2564),
    [sym_break_statement] = STATE(2564),
    [sym_continue_statement] = STATE(2564),
    [sym_goto_statement] = STATE(2564),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(2564),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(2564),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(2564),
    [sym_try_statement] = STATE(2564),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2564),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(157),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(159),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(161),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(163),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(165),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(165),
    [sym_preproc_directive] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_typedef] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_RBRACE] = ACTIONS(5655),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(185),
    [anon_sym_case] = ACTIONS(187),
    [anon_sym_default] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(209),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_nullptr] = ACTIONS(207),
  },
  [1894] = {
    [anon_sym_LPAREN2] = ACTIONS(5657),
    [anon_sym_constexpr] = ACTIONS(5659),
    [sym_comment] = ACTIONS(91),
  },
  [1895] = {
    [sym_parenthesized_expression] = STATE(2567),
    [anon_sym_LPAREN2] = ACTIONS(323),
    [sym_comment] = ACTIONS(91),
  },
  [1896] = {
    [sym__expression] = STATE(2568),
    [sym_conditional_expression] = STATE(2568),
    [sym_assignment_expression] = STATE(2568),
    [sym_pointer_expression] = STATE(2568),
    [sym_logical_expression] = STATE(2568),
    [sym_bitwise_expression] = STATE(2568),
    [sym_equality_expression] = STATE(2568),
    [sym_relational_expression] = STATE(2568),
    [sym_shift_expression] = STATE(2568),
    [sym_math_expression] = STATE(2568),
    [sym_cast_expression] = STATE(2568),
    [sym_sizeof_expression] = STATE(2568),
    [sym_subscript_expression] = STATE(2568),
    [sym_call_expression] = STATE(2568),
    [sym_field_expression] = STATE(2568),
    [sym_compound_literal_expression] = STATE(2568),
    [sym_parenthesized_expression] = STATE(2568),
    [sym_char_literal] = STATE(2568),
    [sym_concatenated_string] = STATE(2568),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2568),
    [sym_new_expression] = STATE(2568),
    [sym_delete_expression] = STATE(2568),
    [sym_lambda_expression] = STATE(2568),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5661),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(5661),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(5663),
    [sym_false] = ACTIONS(5663),
    [sym_null] = ACTIONS(5663),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(5663),
  },
  [1897] = {
    [anon_sym_COLON] = ACTIONS(5665),
    [sym_comment] = ACTIONS(91),
  },
  [1898] = {
    [sym_parenthesized_expression] = STATE(2570),
    [anon_sym_LPAREN2] = ACTIONS(323),
    [sym_comment] = ACTIONS(91),
  },
  [1899] = {
    [sym_compound_statement] = STATE(2571),
    [sym_labeled_statement] = STATE(2571),
    [sym_expression_statement] = STATE(2571),
    [sym_if_statement] = STATE(2571),
    [sym_switch_statement] = STATE(2571),
    [sym_case_statement] = STATE(2571),
    [sym_while_statement] = STATE(2571),
    [sym_do_statement] = STATE(2571),
    [sym_for_statement] = STATE(2571),
    [sym_return_statement] = STATE(2571),
    [sym_break_statement] = STATE(2571),
    [sym_continue_statement] = STATE(2571),
    [sym_goto_statement] = STATE(2571),
    [sym__expression] = STATE(222),
    [sym_comma_expression] = STATE(223),
    [sym_conditional_expression] = STATE(222),
    [sym_assignment_expression] = STATE(222),
    [sym_pointer_expression] = STATE(222),
    [sym_logical_expression] = STATE(222),
    [sym_bitwise_expression] = STATE(222),
    [sym_equality_expression] = STATE(222),
    [sym_relational_expression] = STATE(222),
    [sym_shift_expression] = STATE(222),
    [sym_math_expression] = STATE(222),
    [sym_cast_expression] = STATE(222),
    [sym_sizeof_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_call_expression] = STATE(222),
    [sym_field_expression] = STATE(222),
    [sym_compound_literal_expression] = STATE(222),
    [sym_parenthesized_expression] = STATE(222),
    [sym_char_literal] = STATE(222),
    [sym_concatenated_string] = STATE(222),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(222),
    [sym_for_range_loop] = STATE(2571),
    [sym_try_statement] = STATE(2571),
    [sym_new_expression] = STATE(222),
    [sym_delete_expression] = STATE(222),
    [sym_lambda_expression] = STATE(222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(359),
    [anon_sym_switch] = ACTIONS(361),
    [anon_sym_case] = ACTIONS(363),
    [anon_sym_default] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [anon_sym_do] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(373),
    [anon_sym_break] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_goto] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(353),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_identifier] = ACTIONS(383),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(381),
  },
  [1900] = {
    [anon_sym_LPAREN2] = ACTIONS(5667),
    [sym_comment] = ACTIONS(91),
  },
  [1901] = {
    [sym__expression] = STATE(2574),
    [sym_conditional_expression] = STATE(2574),
    [sym_assignment_expression] = STATE(2574),
    [sym_pointer_expression] = STATE(2574),
    [sym_logical_expression] = STATE(2574),
    [sym_bitwise_expression] = STATE(2574),
    [sym_equality_expression] = STATE(2574),
    [sym_relational_expression] = STATE(2574),
    [sym_shift_expression] = STATE(2574),
    [sym_math_expression] = STATE(2574),
    [sym_cast_expression] = STATE(2574),
    [sym_sizeof_expression] = STATE(2574),
    [sym_subscript_expression] = STATE(2574),
    [sym_call_expression] = STATE(2574),
    [sym_field_expression] = STATE(2574),
    [sym_compound_literal_expression] = STATE(2574),
    [sym_parenthesized_expression] = STATE(2574),
    [sym_initializer_list] = STATE(2575),
    [sym_char_literal] = STATE(2574),
    [sym_concatenated_string] = STATE(2574),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2574),
    [sym_new_expression] = STATE(2574),
    [sym_delete_expression] = STATE(2574),
    [sym_lambda_expression] = STATE(2574),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5669),
    [anon_sym_SEMI] = ACTIONS(5671),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(5669),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(5673),
    [sym_false] = ACTIONS(5673),
    [sym_null] = ACTIONS(5673),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(5673),
  },
  [1902] = {
    [anon_sym_SEMI] = ACTIONS(5675),
    [sym_comment] = ACTIONS(91),
  },
  [1903] = {
    [anon_sym_SEMI] = ACTIONS(5677),
    [sym_comment] = ACTIONS(91),
  },
  [1904] = {
    [sym_identifier] = ACTIONS(5679),
    [sym_comment] = ACTIONS(91),
  },
  [1905] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(263),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(465),
    [anon_sym_extern] = ACTIONS(468),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(465),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_register] = ACTIONS(468),
    [anon_sym_inline] = ACTIONS(468),
    [anon_sym_const] = ACTIONS(468),
    [anon_sym_restrict] = ACTIONS(468),
    [anon_sym_volatile] = ACTIONS(468),
    [anon_sym__Atomic] = ACTIONS(468),
    [anon_sym_mutable] = ACTIONS(468),
    [anon_sym_explicit] = ACTIONS(468),
    [anon_sym_constexpr] = ACTIONS(468),
    [anon_sym_COLON] = ACTIONS(5681),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(474),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_TILDE] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_identifier] = ACTIONS(468),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(486),
    [sym_operator_name] = ACTIONS(481),
  },
  [1906] = {
    [sym_compound_statement] = STATE(2580),
    [anon_sym_LBRACE] = ACTIONS(357),
    [sym_comment] = ACTIONS(91),
  },
  [1907] = {
    [sym__declarator] = STATE(2582),
    [sym_pointer_declarator] = STATE(2582),
    [sym_function_declarator] = STATE(2582),
    [sym_array_declarator] = STATE(2582),
    [sym_init_declarator] = STATE(2583),
    [sym_reference_declarator] = STATE(2582),
    [sym_structured_binding_reference_declarator] = STATE(2584),
    [sym_structured_binding_declarator] = STATE(2584),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(2582),
    [sym_destructor_name] = STATE(2582),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [anon_sym_SEMI] = ACTIONS(5683),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(566),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(568),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(5685),
  },
  [1908] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(586),
    [anon_sym_SEMI] = ACTIONS(5687),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(590),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(594),
    [anon_sym_QMARK] = ACTIONS(596),
    [anon_sym_STAR_EQ] = ACTIONS(598),
    [anon_sym_SLASH_EQ] = ACTIONS(598),
    [anon_sym_PERCENT_EQ] = ACTIONS(598),
    [anon_sym_PLUS_EQ] = ACTIONS(598),
    [anon_sym_DASH_EQ] = ACTIONS(598),
    [anon_sym_LT_LT_EQ] = ACTIONS(598),
    [anon_sym_GT_GT_EQ] = ACTIONS(598),
    [anon_sym_AMP_EQ] = ACTIONS(598),
    [anon_sym_CARET_EQ] = ACTIONS(598),
    [anon_sym_PIPE_EQ] = ACTIONS(598),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_PIPE_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(604),
    [anon_sym_PIPE] = ACTIONS(606),
    [anon_sym_CARET] = ACTIONS(608),
    [anon_sym_EQ_EQ] = ACTIONS(610),
    [anon_sym_BANG_EQ] = ACTIONS(610),
    [anon_sym_LT] = ACTIONS(612),
    [anon_sym_GT] = ACTIONS(612),
    [anon_sym_LT_EQ] = ACTIONS(614),
    [anon_sym_GT_EQ] = ACTIONS(614),
    [anon_sym_LT_LT] = ACTIONS(616),
    [anon_sym_GT_GT] = ACTIONS(616),
    [anon_sym_PLUS] = ACTIONS(618),
    [anon_sym_DASH] = ACTIONS(618),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1909] = {
    [anon_sym_SEMI] = ACTIONS(5687),
    [sym_comment] = ACTIONS(91),
  },
  [1910] = {
    [sym_preproc_include] = STATE(2586),
    [sym_preproc_def] = STATE(2586),
    [sym_preproc_function_def] = STATE(2586),
    [sym_preproc_call] = STATE(2586),
    [sym_preproc_if_in_compound_statement] = STATE(2586),
    [sym_preproc_ifdef_in_compound_statement] = STATE(2586),
    [sym_declaration] = STATE(2586),
    [sym_type_definition] = STATE(2586),
    [sym__declaration_specifiers] = STATE(1907),
    [sym_compound_statement] = STATE(2586),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(2586),
    [sym_expression_statement] = STATE(2586),
    [sym_if_statement] = STATE(2586),
    [sym_switch_statement] = STATE(2586),
    [sym_case_statement] = STATE(2586),
    [sym_while_statement] = STATE(2586),
    [sym_do_statement] = STATE(2586),
    [sym_for_statement] = STATE(2586),
    [sym_return_statement] = STATE(2586),
    [sym_break_statement] = STATE(2586),
    [sym_continue_statement] = STATE(2586),
    [sym_goto_statement] = STATE(2586),
    [sym__expression] = STATE(1908),
    [sym_comma_expression] = STATE(1909),
    [sym_conditional_expression] = STATE(1908),
    [sym_assignment_expression] = STATE(1908),
    [sym_pointer_expression] = STATE(1908),
    [sym_logical_expression] = STATE(1908),
    [sym_bitwise_expression] = STATE(1908),
    [sym_equality_expression] = STATE(1908),
    [sym_relational_expression] = STATE(1908),
    [sym_shift_expression] = STATE(1908),
    [sym_math_expression] = STATE(1908),
    [sym_cast_expression] = STATE(1908),
    [sym_sizeof_expression] = STATE(1908),
    [sym_subscript_expression] = STATE(1908),
    [sym_call_expression] = STATE(1908),
    [sym_field_expression] = STATE(1908),
    [sym_compound_literal_expression] = STATE(1908),
    [sym_parenthesized_expression] = STATE(1908),
    [sym_char_literal] = STATE(1908),
    [sym_concatenated_string] = STATE(1908),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(2586),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(2586),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(1908),
    [sym_for_range_loop] = STATE(2586),
    [sym_try_statement] = STATE(2586),
    [sym_new_expression] = STATE(1908),
    [sym_delete_expression] = STATE(1908),
    [sym_lambda_expression] = STATE(1908),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2586),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(3996),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3998),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4000),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4002),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5689),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4006),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4006),
    [sym_preproc_directive] = ACTIONS(4008),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_typedef] = ACTIONS(4012),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(4016),
    [anon_sym_switch] = ACTIONS(4018),
    [anon_sym_case] = ACTIONS(4020),
    [anon_sym_default] = ACTIONS(4022),
    [anon_sym_while] = ACTIONS(4024),
    [anon_sym_do] = ACTIONS(4026),
    [anon_sym_for] = ACTIONS(4028),
    [anon_sym_return] = ACTIONS(4030),
    [anon_sym_break] = ACTIONS(4032),
    [anon_sym_continue] = ACTIONS(4034),
    [anon_sym_goto] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(3996),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4038),
    [sym_false] = ACTIONS(4038),
    [sym_null] = ACTIONS(4038),
    [sym_identifier] = ACTIONS(4040),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(4042),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_nullptr] = ACTIONS(4038),
  },
  [1911] = {
    [sym_preproc_include] = STATE(2588),
    [sym_preproc_def] = STATE(2588),
    [sym_preproc_function_def] = STATE(2588),
    [sym_preproc_call] = STATE(2588),
    [sym_preproc_if_in_compound_statement] = STATE(2588),
    [sym_preproc_ifdef_in_compound_statement] = STATE(2588),
    [sym_preproc_else_in_compound_statement] = STATE(2587),
    [sym_preproc_elif_in_compound_statement] = STATE(2587),
    [sym_declaration] = STATE(2588),
    [sym_type_definition] = STATE(2588),
    [sym__declaration_specifiers] = STATE(1138),
    [sym_compound_statement] = STATE(2588),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(2588),
    [sym_expression_statement] = STATE(2588),
    [sym_if_statement] = STATE(2588),
    [sym_switch_statement] = STATE(2588),
    [sym_case_statement] = STATE(2588),
    [sym_while_statement] = STATE(2588),
    [sym_do_statement] = STATE(2588),
    [sym_for_statement] = STATE(2588),
    [sym_return_statement] = STATE(2588),
    [sym_break_statement] = STATE(2588),
    [sym_continue_statement] = STATE(2588),
    [sym_goto_statement] = STATE(2588),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(2588),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(2588),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(2588),
    [sym_try_statement] = STATE(2588),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2588),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(2196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2198),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2200),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5691),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2208),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2210),
    [sym_preproc_directive] = ACTIONS(2212),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_typedef] = ACTIONS(2216),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(2220),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(2244),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_nullptr] = ACTIONS(2242),
  },
  [1912] = {
    [sym_raw_string_literal] = ACTIONS(740),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(742),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(742),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(742),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(742),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(742),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(742),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(742),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(742),
    [sym_preproc_directive] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(740),
    [anon_sym_typedef] = ACTIONS(742),
    [anon_sym_extern] = ACTIONS(742),
    [anon_sym_LBRACE] = ACTIONS(740),
    [anon_sym_LPAREN2] = ACTIONS(740),
    [anon_sym_STAR] = ACTIONS(740),
    [anon_sym_LBRACK] = ACTIONS(740),
    [anon_sym_static] = ACTIONS(742),
    [anon_sym_register] = ACTIONS(742),
    [anon_sym_inline] = ACTIONS(742),
    [anon_sym_const] = ACTIONS(742),
    [anon_sym_restrict] = ACTIONS(742),
    [anon_sym_volatile] = ACTIONS(742),
    [anon_sym__Atomic] = ACTIONS(742),
    [anon_sym_mutable] = ACTIONS(742),
    [anon_sym_explicit] = ACTIONS(742),
    [anon_sym_constexpr] = ACTIONS(742),
    [anon_sym_unsigned] = ACTIONS(742),
    [anon_sym_long] = ACTIONS(742),
    [anon_sym_short] = ACTIONS(742),
    [sym_primitive_type] = ACTIONS(742),
    [anon_sym_enum] = ACTIONS(742),
    [anon_sym_struct] = ACTIONS(742),
    [anon_sym_union] = ACTIONS(742),
    [anon_sym_if] = ACTIONS(742),
    [anon_sym_switch] = ACTIONS(742),
    [anon_sym_case] = ACTIONS(742),
    [anon_sym_default] = ACTIONS(742),
    [anon_sym_while] = ACTIONS(742),
    [anon_sym_do] = ACTIONS(742),
    [anon_sym_for] = ACTIONS(742),
    [anon_sym_return] = ACTIONS(742),
    [anon_sym_break] = ACTIONS(742),
    [anon_sym_continue] = ACTIONS(742),
    [anon_sym_goto] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(740),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(742),
    [anon_sym_DASH] = ACTIONS(742),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_sizeof] = ACTIONS(742),
    [sym_number_literal] = ACTIONS(740),
    [anon_sym_SQUOTE] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(740),
    [sym_true] = ACTIONS(742),
    [sym_false] = ACTIONS(742),
    [sym_null] = ACTIONS(742),
    [sym_identifier] = ACTIONS(742),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(742),
    [sym_auto] = ACTIONS(742),
    [anon_sym_typename] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(742),
    [anon_sym_try] = ACTIONS(742),
    [anon_sym_new] = ACTIONS(742),
    [anon_sym_COLON_COLON] = ACTIONS(740),
    [sym_nullptr] = ACTIONS(742),
  },
  [1913] = {
    [anon_sym_LF] = ACTIONS(5693),
    [sym_comment] = ACTIONS(121),
  },
  [1914] = {
    [sym__type_declarator] = STATE(2590),
    [sym_pointer_type_declarator] = STATE(2590),
    [sym_function_type_declarator] = STATE(2590),
    [sym_array_type_declarator] = STATE(2590),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_STAR] = ACTIONS(768),
    [sym_identifier] = ACTIONS(770),
    [sym_comment] = ACTIONS(91),
  },
  [1915] = {
    [sym_type_qualifier] = STATE(453),
    [sym__type_specifier] = STATE(2591),
    [sym_sized_type_specifier] = STATE(2591),
    [sym_enum_specifier] = STATE(2591),
    [sym_struct_specifier] = STATE(2591),
    [sym_union_specifier] = STATE(2591),
    [sym_macro_type_specifier] = STATE(2591),
    [sym_class_specifier] = STATE(2591),
    [sym_dependent_type] = STATE(2591),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(82),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_type_definition_repeat1] = STATE(453),
    [aux_sym_sized_type_specifier_repeat1] = STATE(85),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(135),
    [anon_sym_long] = ACTIONS(135),
    [anon_sym_short] = ACTIONS(135),
    [sym_primitive_type] = ACTIONS(5695),
    [anon_sym_enum] = ACTIONS(139),
    [anon_sym_struct] = ACTIONS(141),
    [anon_sym_union] = ACTIONS(143),
    [sym_identifier] = ACTIONS(145),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(147),
    [sym_auto] = ACTIONS(5695),
    [anon_sym_typename] = ACTIONS(149),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [1916] = {
    [sym_raw_string_literal] = ACTIONS(801),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(803),
    [sym_preproc_directive] = ACTIONS(803),
    [anon_sym_SEMI] = ACTIONS(801),
    [anon_sym_typedef] = ACTIONS(803),
    [anon_sym_extern] = ACTIONS(803),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(801),
    [anon_sym_LBRACK] = ACTIONS(801),
    [anon_sym_static] = ACTIONS(803),
    [anon_sym_register] = ACTIONS(803),
    [anon_sym_inline] = ACTIONS(803),
    [anon_sym_const] = ACTIONS(803),
    [anon_sym_restrict] = ACTIONS(803),
    [anon_sym_volatile] = ACTIONS(803),
    [anon_sym__Atomic] = ACTIONS(803),
    [anon_sym_mutable] = ACTIONS(803),
    [anon_sym_explicit] = ACTIONS(803),
    [anon_sym_constexpr] = ACTIONS(803),
    [anon_sym_unsigned] = ACTIONS(803),
    [anon_sym_long] = ACTIONS(803),
    [anon_sym_short] = ACTIONS(803),
    [sym_primitive_type] = ACTIONS(803),
    [anon_sym_enum] = ACTIONS(803),
    [anon_sym_struct] = ACTIONS(803),
    [anon_sym_union] = ACTIONS(803),
    [anon_sym_if] = ACTIONS(803),
    [anon_sym_else] = ACTIONS(803),
    [anon_sym_switch] = ACTIONS(803),
    [anon_sym_case] = ACTIONS(803),
    [anon_sym_default] = ACTIONS(803),
    [anon_sym_while] = ACTIONS(803),
    [anon_sym_do] = ACTIONS(803),
    [anon_sym_for] = ACTIONS(803),
    [anon_sym_return] = ACTIONS(803),
    [anon_sym_break] = ACTIONS(803),
    [anon_sym_continue] = ACTIONS(803),
    [anon_sym_goto] = ACTIONS(803),
    [anon_sym_AMP] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_DASH] = ACTIONS(803),
    [anon_sym_DASH_DASH] = ACTIONS(801),
    [anon_sym_PLUS_PLUS] = ACTIONS(801),
    [anon_sym_sizeof] = ACTIONS(803),
    [sym_number_literal] = ACTIONS(801),
    [anon_sym_SQUOTE] = ACTIONS(801),
    [anon_sym_DQUOTE] = ACTIONS(801),
    [sym_true] = ACTIONS(803),
    [sym_false] = ACTIONS(803),
    [sym_null] = ACTIONS(803),
    [sym_identifier] = ACTIONS(803),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(803),
    [sym_auto] = ACTIONS(803),
    [anon_sym_typename] = ACTIONS(803),
    [anon_sym_delete] = ACTIONS(803),
    [anon_sym_try] = ACTIONS(803),
    [anon_sym_catch] = ACTIONS(803),
    [anon_sym_new] = ACTIONS(803),
    [anon_sym_COLON_COLON] = ACTIONS(801),
    [sym_nullptr] = ACTIONS(803),
  },
  [1917] = {
    [sym_preproc_include] = STATE(496),
    [sym_preproc_def] = STATE(496),
    [sym_preproc_function_def] = STATE(496),
    [sym_preproc_call] = STATE(496),
    [sym_preproc_if_in_compound_statement] = STATE(496),
    [sym_preproc_ifdef_in_compound_statement] = STATE(496),
    [sym_declaration] = STATE(496),
    [sym_type_definition] = STATE(496),
    [sym__declaration_specifiers] = STATE(113),
    [sym_compound_statement] = STATE(496),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(496),
    [sym_expression_statement] = STATE(496),
    [sym_if_statement] = STATE(496),
    [sym_switch_statement] = STATE(496),
    [sym_case_statement] = STATE(496),
    [sym_while_statement] = STATE(496),
    [sym_do_statement] = STATE(496),
    [sym_for_statement] = STATE(496),
    [sym_return_statement] = STATE(496),
    [sym_break_statement] = STATE(496),
    [sym_continue_statement] = STATE(496),
    [sym_goto_statement] = STATE(496),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(496),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(496),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(496),
    [sym_try_statement] = STATE(496),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(496),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(157),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(159),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(161),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(163),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(165),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(165),
    [sym_preproc_directive] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_typedef] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_RBRACE] = ACTIONS(5697),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(185),
    [anon_sym_case] = ACTIONS(187),
    [anon_sym_default] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(209),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_nullptr] = ACTIONS(207),
  },
  [1918] = {
    [sym__expression] = STATE(2593),
    [sym_conditional_expression] = STATE(2593),
    [sym_assignment_expression] = STATE(2593),
    [sym_pointer_expression] = STATE(2593),
    [sym_logical_expression] = STATE(2593),
    [sym_bitwise_expression] = STATE(2593),
    [sym_equality_expression] = STATE(2593),
    [sym_relational_expression] = STATE(2593),
    [sym_shift_expression] = STATE(2593),
    [sym_math_expression] = STATE(2593),
    [sym_cast_expression] = STATE(2593),
    [sym_sizeof_expression] = STATE(2593),
    [sym_subscript_expression] = STATE(2593),
    [sym_call_expression] = STATE(2593),
    [sym_field_expression] = STATE(2593),
    [sym_compound_literal_expression] = STATE(2593),
    [sym_parenthesized_expression] = STATE(2593),
    [sym_char_literal] = STATE(2593),
    [sym_concatenated_string] = STATE(2593),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2593),
    [sym_new_expression] = STATE(2593),
    [sym_delete_expression] = STATE(2593),
    [sym_lambda_expression] = STATE(2593),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5699),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(5699),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(5701),
    [sym_false] = ACTIONS(5701),
    [sym_null] = ACTIONS(5701),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(5701),
  },
  [1919] = {
    [anon_sym_LPAREN2] = ACTIONS(5703),
    [sym_comment] = ACTIONS(91),
  },
  [1920] = {
    [sym_compound_statement] = STATE(2596),
    [sym_labeled_statement] = STATE(2596),
    [sym_expression_statement] = STATE(2596),
    [sym_if_statement] = STATE(2596),
    [sym_switch_statement] = STATE(2596),
    [sym_case_statement] = STATE(2596),
    [sym_while_statement] = STATE(2596),
    [sym_do_statement] = STATE(2596),
    [sym_for_statement] = STATE(2596),
    [sym_return_statement] = STATE(2596),
    [sym_break_statement] = STATE(2596),
    [sym_continue_statement] = STATE(2596),
    [sym_goto_statement] = STATE(2596),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(2596),
    [sym_try_statement] = STATE(2596),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(2220),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(5705),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2242),
  },
  [1921] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_COLON] = ACTIONS(5707),
    [anon_sym_QMARK] = ACTIONS(1171),
    [anon_sym_STAR_EQ] = ACTIONS(1173),
    [anon_sym_SLASH_EQ] = ACTIONS(1173),
    [anon_sym_PERCENT_EQ] = ACTIONS(1173),
    [anon_sym_PLUS_EQ] = ACTIONS(1173),
    [anon_sym_DASH_EQ] = ACTIONS(1173),
    [anon_sym_LT_LT_EQ] = ACTIONS(1173),
    [anon_sym_GT_GT_EQ] = ACTIONS(1173),
    [anon_sym_AMP_EQ] = ACTIONS(1173),
    [anon_sym_CARET_EQ] = ACTIONS(1173),
    [anon_sym_PIPE_EQ] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_CARET] = ACTIONS(1183),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [1922] = {
    [sym_declaration] = STATE(2599),
    [sym_type_definition] = STATE(2599),
    [sym__declaration_specifiers] = STATE(2600),
    [sym_compound_statement] = STATE(2599),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_labeled_statement] = STATE(2599),
    [sym_expression_statement] = STATE(2599),
    [sym_if_statement] = STATE(2599),
    [sym_switch_statement] = STATE(2599),
    [sym_case_statement] = STATE(2599),
    [sym_while_statement] = STATE(2599),
    [sym_do_statement] = STATE(2599),
    [sym_for_statement] = STATE(2599),
    [sym_return_statement] = STATE(2599),
    [sym_break_statement] = STATE(2599),
    [sym_continue_statement] = STATE(2599),
    [sym_goto_statement] = STATE(2599),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(2599),
    [sym_try_statement] = STATE(2599),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_typedef] = ACTIONS(2216),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(2220),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(5709),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(1202),
    [sym_nullptr] = ACTIONS(2242),
  },
  [1923] = {
    [sym_compound_statement] = STATE(2601),
    [sym_labeled_statement] = STATE(2601),
    [sym_expression_statement] = STATE(2601),
    [sym_if_statement] = STATE(2601),
    [sym_switch_statement] = STATE(2601),
    [sym_case_statement] = STATE(2601),
    [sym_while_statement] = STATE(2601),
    [sym_do_statement] = STATE(2601),
    [sym_for_statement] = STATE(2601),
    [sym_return_statement] = STATE(2601),
    [sym_break_statement] = STATE(2601),
    [sym_continue_statement] = STATE(2601),
    [sym_goto_statement] = STATE(2601),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(2601),
    [sym_try_statement] = STATE(2601),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(2220),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(5705),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2242),
  },
  [1924] = {
    [anon_sym_while] = ACTIONS(5711),
    [sym_comment] = ACTIONS(91),
  },
  [1925] = {
    [sym_declaration] = STATE(2603),
    [sym__declaration_specifiers] = STATE(709),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym__expression] = STATE(2604),
    [sym_conditional_expression] = STATE(2604),
    [sym_assignment_expression] = STATE(2604),
    [sym_pointer_expression] = STATE(2604),
    [sym_logical_expression] = STATE(2604),
    [sym_bitwise_expression] = STATE(2604),
    [sym_equality_expression] = STATE(2604),
    [sym_relational_expression] = STATE(2604),
    [sym_shift_expression] = STATE(2604),
    [sym_math_expression] = STATE(2604),
    [sym_cast_expression] = STATE(2604),
    [sym_sizeof_expression] = STATE(2604),
    [sym_subscript_expression] = STATE(2604),
    [sym_call_expression] = STATE(2604),
    [sym_field_expression] = STATE(2604),
    [sym_compound_literal_expression] = STATE(2604),
    [sym_parenthesized_expression] = STATE(2604),
    [sym_char_literal] = STATE(2604),
    [sym_concatenated_string] = STATE(2604),
    [sym_string_literal] = STATE(238),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(2604),
    [sym_for_range_declaration] = STATE(2605),
    [sym_new_expression] = STATE(2604),
    [sym_delete_expression] = STATE(2604),
    [sym_lambda_expression] = STATE(2604),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(5713),
    [anon_sym_SEMI] = ACTIONS(5715),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(5713),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(5717),
    [sym_false] = ACTIONS(5717),
    [sym_null] = ACTIONS(5717),
    [sym_identifier] = ACTIONS(1242),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(1244),
    [sym_nullptr] = ACTIONS(5717),
  },
  [1926] = {
    [sym_raw_string_literal] = ACTIONS(1246),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1248),
    [sym_preproc_directive] = ACTIONS(1248),
    [anon_sym_SEMI] = ACTIONS(1246),
    [anon_sym_typedef] = ACTIONS(1248),
    [anon_sym_extern] = ACTIONS(1248),
    [anon_sym_LBRACE] = ACTIONS(1246),
    [anon_sym_LPAREN2] = ACTIONS(1246),
    [anon_sym_STAR] = ACTIONS(1246),
    [anon_sym_LBRACK] = ACTIONS(1246),
    [anon_sym_static] = ACTIONS(1248),
    [anon_sym_register] = ACTIONS(1248),
    [anon_sym_inline] = ACTIONS(1248),
    [anon_sym_const] = ACTIONS(1248),
    [anon_sym_restrict] = ACTIONS(1248),
    [anon_sym_volatile] = ACTIONS(1248),
    [anon_sym__Atomic] = ACTIONS(1248),
    [anon_sym_mutable] = ACTIONS(1248),
    [anon_sym_explicit] = ACTIONS(1248),
    [anon_sym_constexpr] = ACTIONS(1248),
    [anon_sym_unsigned] = ACTIONS(1248),
    [anon_sym_long] = ACTIONS(1248),
    [anon_sym_short] = ACTIONS(1248),
    [sym_primitive_type] = ACTIONS(1248),
    [anon_sym_enum] = ACTIONS(1248),
    [anon_sym_struct] = ACTIONS(1248),
    [anon_sym_union] = ACTIONS(1248),
    [anon_sym_if] = ACTIONS(1248),
    [anon_sym_else] = ACTIONS(1248),
    [anon_sym_switch] = ACTIONS(1248),
    [anon_sym_case] = ACTIONS(1248),
    [anon_sym_default] = ACTIONS(1248),
    [anon_sym_while] = ACTIONS(1248),
    [anon_sym_do] = ACTIONS(1248),
    [anon_sym_for] = ACTIONS(1248),
    [anon_sym_return] = ACTIONS(1248),
    [anon_sym_break] = ACTIONS(1248),
    [anon_sym_continue] = ACTIONS(1248),
    [anon_sym_goto] = ACTIONS(1248),
    [anon_sym_AMP] = ACTIONS(1246),
    [anon_sym_BANG] = ACTIONS(1246),
    [anon_sym_TILDE] = ACTIONS(1246),
    [anon_sym_PLUS] = ACTIONS(1248),
    [anon_sym_DASH] = ACTIONS(1248),
    [anon_sym_DASH_DASH] = ACTIONS(1246),
    [anon_sym_PLUS_PLUS] = ACTIONS(1246),
    [anon_sym_sizeof] = ACTIONS(1248),
    [sym_number_literal] = ACTIONS(1246),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [anon_sym_DQUOTE] = ACTIONS(1246),
    [sym_true] = ACTIONS(1248),
    [sym_false] = ACTIONS(1248),
    [sym_null] = ACTIONS(1248),
    [sym_identifier] = ACTIONS(1248),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1248),
    [sym_auto] = ACTIONS(1248),
    [anon_sym_typename] = ACTIONS(1248),
    [anon_sym_delete] = ACTIONS(1248),
    [anon_sym_try] = ACTIONS(1248),
    [anon_sym_new] = ACTIONS(1248),
    [anon_sym_COLON_COLON] = ACTIONS(1246),
    [sym_nullptr] = ACTIONS(1248),
  },
  [1927] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(5719),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1928] = {
    [anon_sym_SEMI] = ACTIONS(5719),
    [sym_comment] = ACTIONS(91),
  },
  [1929] = {
    [sym_raw_string_literal] = ACTIONS(1332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1334),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1334),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1334),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1334),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1334),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1334),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1334),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1334),
    [sym_preproc_directive] = ACTIONS(1334),
    [anon_sym_SEMI] = ACTIONS(1332),
    [anon_sym_typedef] = ACTIONS(1334),
    [anon_sym_extern] = ACTIONS(1334),
    [anon_sym_LBRACE] = ACTIONS(1332),
    [anon_sym_LPAREN2] = ACTIONS(1332),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_LBRACK] = ACTIONS(1332),
    [anon_sym_static] = ACTIONS(1334),
    [anon_sym_register] = ACTIONS(1334),
    [anon_sym_inline] = ACTIONS(1334),
    [anon_sym_const] = ACTIONS(1334),
    [anon_sym_restrict] = ACTIONS(1334),
    [anon_sym_volatile] = ACTIONS(1334),
    [anon_sym__Atomic] = ACTIONS(1334),
    [anon_sym_mutable] = ACTIONS(1334),
    [anon_sym_explicit] = ACTIONS(1334),
    [anon_sym_constexpr] = ACTIONS(1334),
    [anon_sym_unsigned] = ACTIONS(1334),
    [anon_sym_long] = ACTIONS(1334),
    [anon_sym_short] = ACTIONS(1334),
    [sym_primitive_type] = ACTIONS(1334),
    [anon_sym_enum] = ACTIONS(1334),
    [anon_sym_struct] = ACTIONS(1334),
    [anon_sym_union] = ACTIONS(1334),
    [anon_sym_if] = ACTIONS(1334),
    [anon_sym_else] = ACTIONS(1334),
    [anon_sym_switch] = ACTIONS(1334),
    [anon_sym_case] = ACTIONS(1334),
    [anon_sym_default] = ACTIONS(1334),
    [anon_sym_while] = ACTIONS(1334),
    [anon_sym_do] = ACTIONS(1334),
    [anon_sym_for] = ACTIONS(1334),
    [anon_sym_return] = ACTIONS(1334),
    [anon_sym_break] = ACTIONS(1334),
    [anon_sym_continue] = ACTIONS(1334),
    [anon_sym_goto] = ACTIONS(1334),
    [anon_sym_AMP] = ACTIONS(1332),
    [anon_sym_BANG] = ACTIONS(1332),
    [anon_sym_TILDE] = ACTIONS(1332),
    [anon_sym_PLUS] = ACTIONS(1334),
    [anon_sym_DASH] = ACTIONS(1334),
    [anon_sym_DASH_DASH] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(1332),
    [anon_sym_sizeof] = ACTIONS(1334),
    [sym_number_literal] = ACTIONS(1332),
    [anon_sym_SQUOTE] = ACTIONS(1332),
    [anon_sym_DQUOTE] = ACTIONS(1332),
    [sym_true] = ACTIONS(1334),
    [sym_false] = ACTIONS(1334),
    [sym_null] = ACTIONS(1334),
    [sym_identifier] = ACTIONS(1334),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1334),
    [sym_auto] = ACTIONS(1334),
    [anon_sym_typename] = ACTIONS(1334),
    [anon_sym_delete] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1334),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_COLON_COLON] = ACTIONS(1332),
    [sym_nullptr] = ACTIONS(1334),
  },
  [1930] = {
    [sym_raw_string_literal] = ACTIONS(1336),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1338),
    [sym_preproc_directive] = ACTIONS(1338),
    [anon_sym_SEMI] = ACTIONS(1336),
    [anon_sym_typedef] = ACTIONS(1338),
    [anon_sym_extern] = ACTIONS(1338),
    [anon_sym_LBRACE] = ACTIONS(1336),
    [anon_sym_LPAREN2] = ACTIONS(1336),
    [anon_sym_STAR] = ACTIONS(1336),
    [anon_sym_LBRACK] = ACTIONS(1336),
    [anon_sym_static] = ACTIONS(1338),
    [anon_sym_register] = ACTIONS(1338),
    [anon_sym_inline] = ACTIONS(1338),
    [anon_sym_const] = ACTIONS(1338),
    [anon_sym_restrict] = ACTIONS(1338),
    [anon_sym_volatile] = ACTIONS(1338),
    [anon_sym__Atomic] = ACTIONS(1338),
    [anon_sym_mutable] = ACTIONS(1338),
    [anon_sym_explicit] = ACTIONS(1338),
    [anon_sym_constexpr] = ACTIONS(1338),
    [anon_sym_unsigned] = ACTIONS(1338),
    [anon_sym_long] = ACTIONS(1338),
    [anon_sym_short] = ACTIONS(1338),
    [sym_primitive_type] = ACTIONS(1338),
    [anon_sym_enum] = ACTIONS(1338),
    [anon_sym_struct] = ACTIONS(1338),
    [anon_sym_union] = ACTIONS(1338),
    [anon_sym_if] = ACTIONS(1338),
    [anon_sym_else] = ACTIONS(1338),
    [anon_sym_switch] = ACTIONS(1338),
    [anon_sym_case] = ACTIONS(1338),
    [anon_sym_default] = ACTIONS(1338),
    [anon_sym_while] = ACTIONS(1338),
    [anon_sym_do] = ACTIONS(1338),
    [anon_sym_for] = ACTIONS(1338),
    [anon_sym_return] = ACTIONS(1338),
    [anon_sym_break] = ACTIONS(1338),
    [anon_sym_continue] = ACTIONS(1338),
    [anon_sym_goto] = ACTIONS(1338),
    [anon_sym_AMP] = ACTIONS(1336),
    [anon_sym_BANG] = ACTIONS(1336),
    [anon_sym_TILDE] = ACTIONS(1336),
    [anon_sym_PLUS] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_DASH_DASH] = ACTIONS(1336),
    [anon_sym_PLUS_PLUS] = ACTIONS(1336),
    [anon_sym_sizeof] = ACTIONS(1338),
    [sym_number_literal] = ACTIONS(1336),
    [anon_sym_SQUOTE] = ACTIONS(1336),
    [anon_sym_DQUOTE] = ACTIONS(1336),
    [sym_true] = ACTIONS(1338),
    [sym_false] = ACTIONS(1338),
    [sym_null] = ACTIONS(1338),
    [sym_identifier] = ACTIONS(1338),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1338),
    [sym_auto] = ACTIONS(1338),
    [anon_sym_typename] = ACTIONS(1338),
    [anon_sym_delete] = ACTIONS(1338),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_new] = ACTIONS(1338),
    [anon_sym_COLON_COLON] = ACTIONS(1336),
    [sym_nullptr] = ACTIONS(1338),
  },
  [1931] = {
    [anon_sym_SEMI] = ACTIONS(5721),
    [sym_comment] = ACTIONS(91),
  },
  [1932] = {
    [sym_compound_statement] = STATE(2608),
    [sym_labeled_statement] = STATE(2608),
    [sym_expression_statement] = STATE(2608),
    [sym_if_statement] = STATE(2608),
    [sym_switch_statement] = STATE(2608),
    [sym_case_statement] = STATE(2608),
    [sym_while_statement] = STATE(2608),
    [sym_do_statement] = STATE(2608),
    [sym_for_statement] = STATE(2608),
    [sym_return_statement] = STATE(2608),
    [sym_break_statement] = STATE(2608),
    [sym_continue_statement] = STATE(2608),
    [sym_goto_statement] = STATE(2608),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(2608),
    [sym_try_statement] = STATE(2608),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(2220),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(5705),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2242),
  },
  [1933] = {
    [sym_catch_clause] = STATE(2610),
    [aux_sym_try_statement_repeat1] = STATE(2610),
    [sym_comment] = ACTIONS(91),
    [anon_sym_catch] = ACTIONS(5723),
  },
  [1934] = {
    [sym_raw_string_literal] = ACTIONS(5725),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5727),
    [sym_preproc_directive] = ACTIONS(5727),
    [anon_sym_SEMI] = ACTIONS(5725),
    [anon_sym_typedef] = ACTIONS(5727),
    [anon_sym_extern] = ACTIONS(5727),
    [anon_sym_LBRACE] = ACTIONS(5725),
    [anon_sym_RBRACE] = ACTIONS(5725),
    [anon_sym_LPAREN2] = ACTIONS(5725),
    [anon_sym_STAR] = ACTIONS(5725),
    [anon_sym_LBRACK] = ACTIONS(5725),
    [anon_sym_static] = ACTIONS(5727),
    [anon_sym_register] = ACTIONS(5727),
    [anon_sym_inline] = ACTIONS(5727),
    [anon_sym_const] = ACTIONS(5727),
    [anon_sym_restrict] = ACTIONS(5727),
    [anon_sym_volatile] = ACTIONS(5727),
    [anon_sym__Atomic] = ACTIONS(5727),
    [anon_sym_mutable] = ACTIONS(5727),
    [anon_sym_explicit] = ACTIONS(5727),
    [anon_sym_constexpr] = ACTIONS(5727),
    [anon_sym_unsigned] = ACTIONS(5727),
    [anon_sym_long] = ACTIONS(5727),
    [anon_sym_short] = ACTIONS(5727),
    [sym_primitive_type] = ACTIONS(5727),
    [anon_sym_enum] = ACTIONS(5727),
    [anon_sym_struct] = ACTIONS(5727),
    [anon_sym_union] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5727),
    [anon_sym_switch] = ACTIONS(5727),
    [anon_sym_case] = ACTIONS(5727),
    [anon_sym_default] = ACTIONS(5727),
    [anon_sym_while] = ACTIONS(5727),
    [anon_sym_do] = ACTIONS(5727),
    [anon_sym_for] = ACTIONS(5727),
    [anon_sym_return] = ACTIONS(5727),
    [anon_sym_break] = ACTIONS(5727),
    [anon_sym_continue] = ACTIONS(5727),
    [anon_sym_goto] = ACTIONS(5727),
    [anon_sym_AMP] = ACTIONS(5725),
    [anon_sym_BANG] = ACTIONS(5725),
    [anon_sym_TILDE] = ACTIONS(5725),
    [anon_sym_PLUS] = ACTIONS(5727),
    [anon_sym_DASH] = ACTIONS(5727),
    [anon_sym_DASH_DASH] = ACTIONS(5725),
    [anon_sym_PLUS_PLUS] = ACTIONS(5725),
    [anon_sym_sizeof] = ACTIONS(5727),
    [sym_number_literal] = ACTIONS(5725),
    [anon_sym_SQUOTE] = ACTIONS(5725),
    [anon_sym_DQUOTE] = ACTIONS(5725),
    [sym_true] = ACTIONS(5727),
    [sym_false] = ACTIONS(5727),
    [sym_null] = ACTIONS(5727),
    [sym_identifier] = ACTIONS(5727),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5727),
    [sym_auto] = ACTIONS(5727),
    [anon_sym_typename] = ACTIONS(5727),
    [anon_sym_delete] = ACTIONS(5727),
    [anon_sym_try] = ACTIONS(5727),
    [anon_sym_new] = ACTIONS(5727),
    [anon_sym_COLON_COLON] = ACTIONS(5725),
    [sym_nullptr] = ACTIONS(5727),
  },
  [1935] = {
    [sym_raw_string_literal] = ACTIONS(1597),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1599),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1599),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1599),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1599),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1599),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1599),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1599),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1599),
    [sym_preproc_directive] = ACTIONS(1599),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_typedef] = ACTIONS(1599),
    [anon_sym_extern] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1597),
    [anon_sym_LPAREN2] = ACTIONS(1597),
    [anon_sym_STAR] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_static] = ACTIONS(1599),
    [anon_sym_register] = ACTIONS(1599),
    [anon_sym_inline] = ACTIONS(1599),
    [anon_sym_const] = ACTIONS(1599),
    [anon_sym_restrict] = ACTIONS(1599),
    [anon_sym_volatile] = ACTIONS(1599),
    [anon_sym__Atomic] = ACTIONS(1599),
    [anon_sym_mutable] = ACTIONS(1599),
    [anon_sym_explicit] = ACTIONS(1599),
    [anon_sym_constexpr] = ACTIONS(1599),
    [anon_sym_unsigned] = ACTIONS(1599),
    [anon_sym_long] = ACTIONS(1599),
    [anon_sym_short] = ACTIONS(1599),
    [sym_primitive_type] = ACTIONS(1599),
    [anon_sym_enum] = ACTIONS(1599),
    [anon_sym_struct] = ACTIONS(1599),
    [anon_sym_union] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(1599),
    [anon_sym_switch] = ACTIONS(1599),
    [anon_sym_case] = ACTIONS(1599),
    [anon_sym_default] = ACTIONS(1599),
    [anon_sym_while] = ACTIONS(1599),
    [anon_sym_do] = ACTIONS(1599),
    [anon_sym_for] = ACTIONS(1599),
    [anon_sym_return] = ACTIONS(1599),
    [anon_sym_break] = ACTIONS(1599),
    [anon_sym_continue] = ACTIONS(1599),
    [anon_sym_goto] = ACTIONS(1599),
    [anon_sym_AMP] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1597),
    [anon_sym_TILDE] = ACTIONS(1597),
    [anon_sym_PLUS] = ACTIONS(1599),
    [anon_sym_DASH] = ACTIONS(1599),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_sizeof] = ACTIONS(1599),
    [sym_number_literal] = ACTIONS(1597),
    [anon_sym_SQUOTE] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1597),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_null] = ACTIONS(1599),
    [sym_identifier] = ACTIONS(1599),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1599),
    [sym_auto] = ACTIONS(1599),
    [anon_sym_typename] = ACTIONS(1599),
    [anon_sym_delete] = ACTIONS(1599),
    [anon_sym_try] = ACTIONS(1599),
    [anon_sym_new] = ACTIONS(1599),
    [anon_sym_COLON_COLON] = ACTIONS(1597),
    [sym_nullptr] = ACTIONS(1599),
  },
  [1936] = {
    [sym_parameter_list] = STATE(897),
    [sym_argument_list] = STATE(898),
    [sym_initializer_list] = STATE(898),
    [aux_sym_declaration_repeat1] = STATE(2612),
    [anon_sym_COMMA] = ACTIONS(1613),
    [anon_sym_SEMI] = ACTIONS(5729),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(1619),
    [anon_sym_LBRACK] = ACTIONS(574),
    [anon_sym_EQ] = ACTIONS(1621),
    [sym_comment] = ACTIONS(91),
  },
  [1937] = {
    [aux_sym_declaration_repeat1] = STATE(2612),
    [anon_sym_COMMA] = ACTIONS(1613),
    [anon_sym_SEMI] = ACTIONS(5729),
    [sym_comment] = ACTIONS(91),
  },
  [1938] = {
    [sym_argument_list] = STATE(2614),
    [sym_initializer_list] = STATE(2614),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(5731),
    [sym_comment] = ACTIONS(91),
  },
  [1939] = {
    [sym_raw_string_literal] = ACTIONS(1697),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1699),
    [sym_preproc_directive] = ACTIONS(1699),
    [anon_sym_SEMI] = ACTIONS(1697),
    [anon_sym_typedef] = ACTIONS(1699),
    [anon_sym_extern] = ACTIONS(1699),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_LPAREN2] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1697),
    [anon_sym_LBRACK] = ACTIONS(1697),
    [anon_sym_static] = ACTIONS(1699),
    [anon_sym_register] = ACTIONS(1699),
    [anon_sym_inline] = ACTIONS(1699),
    [anon_sym_const] = ACTIONS(1699),
    [anon_sym_restrict] = ACTIONS(1699),
    [anon_sym_volatile] = ACTIONS(1699),
    [anon_sym__Atomic] = ACTIONS(1699),
    [anon_sym_mutable] = ACTIONS(1699),
    [anon_sym_explicit] = ACTIONS(1699),
    [anon_sym_constexpr] = ACTIONS(1699),
    [anon_sym_unsigned] = ACTIONS(1699),
    [anon_sym_long] = ACTIONS(1699),
    [anon_sym_short] = ACTIONS(1699),
    [sym_primitive_type] = ACTIONS(1699),
    [anon_sym_enum] = ACTIONS(1699),
    [anon_sym_struct] = ACTIONS(1699),
    [anon_sym_union] = ACTIONS(1699),
    [anon_sym_if] = ACTIONS(1699),
    [anon_sym_else] = ACTIONS(1699),
    [anon_sym_switch] = ACTIONS(1699),
    [anon_sym_case] = ACTIONS(1699),
    [anon_sym_default] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(1699),
    [anon_sym_do] = ACTIONS(1699),
    [anon_sym_for] = ACTIONS(1699),
    [anon_sym_return] = ACTIONS(1699),
    [anon_sym_break] = ACTIONS(1699),
    [anon_sym_continue] = ACTIONS(1699),
    [anon_sym_goto] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1697),
    [anon_sym_BANG] = ACTIONS(1697),
    [anon_sym_TILDE] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1697),
    [anon_sym_PLUS_PLUS] = ACTIONS(1697),
    [anon_sym_sizeof] = ACTIONS(1699),
    [sym_number_literal] = ACTIONS(1697),
    [anon_sym_SQUOTE] = ACTIONS(1697),
    [anon_sym_DQUOTE] = ACTIONS(1697),
    [sym_true] = ACTIONS(1699),
    [sym_false] = ACTIONS(1699),
    [sym_null] = ACTIONS(1699),
    [sym_identifier] = ACTIONS(1699),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1699),
    [sym_auto] = ACTIONS(1699),
    [anon_sym_typename] = ACTIONS(1699),
    [anon_sym_delete] = ACTIONS(1699),
    [anon_sym_try] = ACTIONS(1699),
    [anon_sym_new] = ACTIONS(1699),
    [anon_sym_COLON_COLON] = ACTIONS(1697),
    [sym_nullptr] = ACTIONS(1699),
  },
  [1940] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5733),
    [sym_comment] = ACTIONS(91),
  },
  [1941] = {
    [sym_preproc_include] = STATE(1941),
    [sym_preproc_def] = STATE(1941),
    [sym_preproc_function_def] = STATE(1941),
    [sym_preproc_call] = STATE(1941),
    [sym_preproc_if_in_compound_statement] = STATE(1941),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1941),
    [sym_declaration] = STATE(1941),
    [sym_type_definition] = STATE(1941),
    [sym__declaration_specifiers] = STATE(1138),
    [sym_compound_statement] = STATE(1941),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(1941),
    [sym_expression_statement] = STATE(1941),
    [sym_if_statement] = STATE(1941),
    [sym_switch_statement] = STATE(1941),
    [sym_case_statement] = STATE(1941),
    [sym_while_statement] = STATE(1941),
    [sym_do_statement] = STATE(1941),
    [sym_for_statement] = STATE(1941),
    [sym_return_statement] = STATE(1941),
    [sym_break_statement] = STATE(1941),
    [sym_continue_statement] = STATE(1941),
    [sym_goto_statement] = STATE(1941),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(1941),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(1941),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(1941),
    [sym_try_statement] = STATE(1941),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1941),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(5735),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5738),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5741),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5747),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5749),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5749),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5747),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5747),
    [sym_preproc_directive] = ACTIONS(5752),
    [anon_sym_SEMI] = ACTIONS(5755),
    [anon_sym_typedef] = ACTIONS(5758),
    [anon_sym_extern] = ACTIONS(2314),
    [anon_sym_LBRACE] = ACTIONS(5761),
    [anon_sym_LPAREN2] = ACTIONS(2322),
    [anon_sym_STAR] = ACTIONS(2325),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_static] = ACTIONS(2314),
    [anon_sym_register] = ACTIONS(2314),
    [anon_sym_inline] = ACTIONS(2314),
    [anon_sym_const] = ACTIONS(2331),
    [anon_sym_restrict] = ACTIONS(2331),
    [anon_sym_volatile] = ACTIONS(2331),
    [anon_sym__Atomic] = ACTIONS(2331),
    [anon_sym_mutable] = ACTIONS(2331),
    [anon_sym_explicit] = ACTIONS(2331),
    [anon_sym_constexpr] = ACTIONS(2331),
    [anon_sym_unsigned] = ACTIONS(2334),
    [anon_sym_long] = ACTIONS(2334),
    [anon_sym_short] = ACTIONS(2334),
    [sym_primitive_type] = ACTIONS(2337),
    [anon_sym_enum] = ACTIONS(2340),
    [anon_sym_struct] = ACTIONS(2343),
    [anon_sym_union] = ACTIONS(2346),
    [anon_sym_if] = ACTIONS(5764),
    [anon_sym_switch] = ACTIONS(5767),
    [anon_sym_case] = ACTIONS(5770),
    [anon_sym_default] = ACTIONS(5773),
    [anon_sym_while] = ACTIONS(5776),
    [anon_sym_do] = ACTIONS(5779),
    [anon_sym_for] = ACTIONS(5782),
    [anon_sym_return] = ACTIONS(5785),
    [anon_sym_break] = ACTIONS(5788),
    [anon_sym_continue] = ACTIONS(5791),
    [anon_sym_goto] = ACTIONS(5794),
    [anon_sym_AMP] = ACTIONS(2325),
    [anon_sym_BANG] = ACTIONS(2382),
    [anon_sym_TILDE] = ACTIONS(2385),
    [anon_sym_PLUS] = ACTIONS(2388),
    [anon_sym_DASH] = ACTIONS(2388),
    [anon_sym_DASH_DASH] = ACTIONS(2391),
    [anon_sym_PLUS_PLUS] = ACTIONS(2391),
    [anon_sym_sizeof] = ACTIONS(2394),
    [sym_number_literal] = ACTIONS(5735),
    [anon_sym_SQUOTE] = ACTIONS(2397),
    [anon_sym_DQUOTE] = ACTIONS(2400),
    [sym_true] = ACTIONS(5797),
    [sym_false] = ACTIONS(5797),
    [sym_null] = ACTIONS(5797),
    [sym_identifier] = ACTIONS(5800),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2409),
    [sym_auto] = ACTIONS(2337),
    [anon_sym_typename] = ACTIONS(2412),
    [anon_sym_delete] = ACTIONS(2415),
    [anon_sym_try] = ACTIONS(5803),
    [anon_sym_new] = ACTIONS(2421),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [sym_nullptr] = ACTIONS(5797),
  },
  [1942] = {
    [sym_raw_string_literal] = ACTIONS(5806),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5808),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5808),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5808),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5808),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5808),
    [sym_preproc_directive] = ACTIONS(5808),
    [anon_sym_SEMI] = ACTIONS(5806),
    [anon_sym_typedef] = ACTIONS(5808),
    [anon_sym_extern] = ACTIONS(5808),
    [anon_sym_LBRACE] = ACTIONS(5806),
    [anon_sym_RBRACE] = ACTIONS(5806),
    [anon_sym_LPAREN2] = ACTIONS(5806),
    [anon_sym_STAR] = ACTIONS(5806),
    [anon_sym_LBRACK] = ACTIONS(5806),
    [anon_sym_static] = ACTIONS(5808),
    [anon_sym_register] = ACTIONS(5808),
    [anon_sym_inline] = ACTIONS(5808),
    [anon_sym_const] = ACTIONS(5808),
    [anon_sym_restrict] = ACTIONS(5808),
    [anon_sym_volatile] = ACTIONS(5808),
    [anon_sym__Atomic] = ACTIONS(5808),
    [anon_sym_mutable] = ACTIONS(5808),
    [anon_sym_explicit] = ACTIONS(5808),
    [anon_sym_constexpr] = ACTIONS(5808),
    [anon_sym_unsigned] = ACTIONS(5808),
    [anon_sym_long] = ACTIONS(5808),
    [anon_sym_short] = ACTIONS(5808),
    [sym_primitive_type] = ACTIONS(5808),
    [anon_sym_enum] = ACTIONS(5808),
    [anon_sym_struct] = ACTIONS(5808),
    [anon_sym_union] = ACTIONS(5808),
    [anon_sym_if] = ACTIONS(5808),
    [anon_sym_switch] = ACTIONS(5808),
    [anon_sym_case] = ACTIONS(5808),
    [anon_sym_default] = ACTIONS(5808),
    [anon_sym_while] = ACTIONS(5808),
    [anon_sym_do] = ACTIONS(5808),
    [anon_sym_for] = ACTIONS(5808),
    [anon_sym_return] = ACTIONS(5808),
    [anon_sym_break] = ACTIONS(5808),
    [anon_sym_continue] = ACTIONS(5808),
    [anon_sym_goto] = ACTIONS(5808),
    [anon_sym_AMP] = ACTIONS(5806),
    [anon_sym_BANG] = ACTIONS(5806),
    [anon_sym_TILDE] = ACTIONS(5806),
    [anon_sym_PLUS] = ACTIONS(5808),
    [anon_sym_DASH] = ACTIONS(5808),
    [anon_sym_DASH_DASH] = ACTIONS(5806),
    [anon_sym_PLUS_PLUS] = ACTIONS(5806),
    [anon_sym_sizeof] = ACTIONS(5808),
    [sym_number_literal] = ACTIONS(5806),
    [anon_sym_SQUOTE] = ACTIONS(5806),
    [anon_sym_DQUOTE] = ACTIONS(5806),
    [sym_true] = ACTIONS(5808),
    [sym_false] = ACTIONS(5808),
    [sym_null] = ACTIONS(5808),
    [sym_identifier] = ACTIONS(5808),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5808),
    [sym_auto] = ACTIONS(5808),
    [anon_sym_typename] = ACTIONS(5808),
    [anon_sym_delete] = ACTIONS(5808),
    [anon_sym_try] = ACTIONS(5808),
    [anon_sym_new] = ACTIONS(5808),
    [anon_sym_COLON_COLON] = ACTIONS(5806),
    [sym_nullptr] = ACTIONS(5808),
  },
  [1943] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5810),
    [sym_comment] = ACTIONS(91),
  },
  [1944] = {
    [sym_raw_string_literal] = ACTIONS(3958),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3960),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3960),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3960),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3960),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3960),
    [sym_preproc_directive] = ACTIONS(3960),
    [anon_sym_SEMI] = ACTIONS(3958),
    [anon_sym_typedef] = ACTIONS(3960),
    [anon_sym_extern] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3958),
    [anon_sym_RBRACE] = ACTIONS(3958),
    [anon_sym_LPAREN2] = ACTIONS(3958),
    [anon_sym_STAR] = ACTIONS(3958),
    [anon_sym_LBRACK] = ACTIONS(3958),
    [anon_sym_static] = ACTIONS(3960),
    [anon_sym_register] = ACTIONS(3960),
    [anon_sym_inline] = ACTIONS(3960),
    [anon_sym_const] = ACTIONS(3960),
    [anon_sym_restrict] = ACTIONS(3960),
    [anon_sym_volatile] = ACTIONS(3960),
    [anon_sym__Atomic] = ACTIONS(3960),
    [anon_sym_mutable] = ACTIONS(3960),
    [anon_sym_explicit] = ACTIONS(3960),
    [anon_sym_constexpr] = ACTIONS(3960),
    [anon_sym_unsigned] = ACTIONS(3960),
    [anon_sym_long] = ACTIONS(3960),
    [anon_sym_short] = ACTIONS(3960),
    [sym_primitive_type] = ACTIONS(3960),
    [anon_sym_enum] = ACTIONS(3960),
    [anon_sym_struct] = ACTIONS(3960),
    [anon_sym_union] = ACTIONS(3960),
    [anon_sym_if] = ACTIONS(3960),
    [anon_sym_else] = ACTIONS(3960),
    [anon_sym_switch] = ACTIONS(3960),
    [anon_sym_case] = ACTIONS(3960),
    [anon_sym_default] = ACTIONS(3960),
    [anon_sym_while] = ACTIONS(3960),
    [anon_sym_do] = ACTIONS(3960),
    [anon_sym_for] = ACTIONS(3960),
    [anon_sym_return] = ACTIONS(3960),
    [anon_sym_break] = ACTIONS(3960),
    [anon_sym_continue] = ACTIONS(3960),
    [anon_sym_goto] = ACTIONS(3960),
    [anon_sym_AMP] = ACTIONS(3958),
    [anon_sym_BANG] = ACTIONS(3958),
    [anon_sym_TILDE] = ACTIONS(3958),
    [anon_sym_PLUS] = ACTIONS(3960),
    [anon_sym_DASH] = ACTIONS(3960),
    [anon_sym_DASH_DASH] = ACTIONS(3958),
    [anon_sym_PLUS_PLUS] = ACTIONS(3958),
    [anon_sym_sizeof] = ACTIONS(3960),
    [sym_number_literal] = ACTIONS(3958),
    [anon_sym_SQUOTE] = ACTIONS(3958),
    [anon_sym_DQUOTE] = ACTIONS(3958),
    [sym_true] = ACTIONS(3960),
    [sym_false] = ACTIONS(3960),
    [sym_null] = ACTIONS(3960),
    [sym_identifier] = ACTIONS(3960),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3960),
    [sym_auto] = ACTIONS(3960),
    [anon_sym_typename] = ACTIONS(3960),
    [anon_sym_delete] = ACTIONS(3960),
    [anon_sym_try] = ACTIONS(3960),
    [anon_sym_new] = ACTIONS(3960),
    [anon_sym_COLON_COLON] = ACTIONS(3958),
    [sym_nullptr] = ACTIONS(3960),
  },
  [1945] = {
    [sym_parameter_list] = STATE(1105),
    [anon_sym_SEMI] = ACTIONS(5812),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [sym_comment] = ACTIONS(91),
  },
  [1946] = {
    [sym_compound_statement] = STATE(2626),
    [sym_labeled_statement] = STATE(2626),
    [sym_expression_statement] = STATE(2626),
    [sym_if_statement] = STATE(2626),
    [sym_switch_statement] = STATE(2626),
    [sym_case_statement] = STATE(2626),
    [sym_while_statement] = STATE(2626),
    [sym_do_statement] = STATE(2626),
    [sym_for_statement] = STATE(2626),
    [sym_return_statement] = STATE(2626),
    [sym_break_statement] = STATE(2626),
    [sym_continue_statement] = STATE(2626),
    [sym_goto_statement] = STATE(2626),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(2626),
    [sym_try_statement] = STATE(2626),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(157),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(5814),
    [anon_sym_switch] = ACTIONS(5816),
    [anon_sym_case] = ACTIONS(5818),
    [anon_sym_default] = ACTIONS(5820),
    [anon_sym_while] = ACTIONS(5822),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(5824),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(5826),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(5828),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(207),
  },
  [1947] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(5830),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1948] = {
    [sym_raw_string_literal] = ACTIONS(4513),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4515),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4515),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4515),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4515),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4515),
    [sym_preproc_directive] = ACTIONS(4515),
    [anon_sym_SEMI] = ACTIONS(4513),
    [anon_sym_typedef] = ACTIONS(4515),
    [anon_sym_extern] = ACTIONS(4515),
    [anon_sym_LBRACE] = ACTIONS(4513),
    [anon_sym_RBRACE] = ACTIONS(4513),
    [anon_sym_LPAREN2] = ACTIONS(4513),
    [anon_sym_STAR] = ACTIONS(4513),
    [anon_sym_LBRACK] = ACTIONS(4513),
    [anon_sym_static] = ACTIONS(4515),
    [anon_sym_register] = ACTIONS(4515),
    [anon_sym_inline] = ACTIONS(4515),
    [anon_sym_const] = ACTIONS(4515),
    [anon_sym_restrict] = ACTIONS(4515),
    [anon_sym_volatile] = ACTIONS(4515),
    [anon_sym__Atomic] = ACTIONS(4515),
    [anon_sym_mutable] = ACTIONS(4515),
    [anon_sym_explicit] = ACTIONS(4515),
    [anon_sym_constexpr] = ACTIONS(4515),
    [anon_sym_unsigned] = ACTIONS(4515),
    [anon_sym_long] = ACTIONS(4515),
    [anon_sym_short] = ACTIONS(4515),
    [sym_primitive_type] = ACTIONS(4515),
    [anon_sym_enum] = ACTIONS(4515),
    [anon_sym_struct] = ACTIONS(4515),
    [anon_sym_union] = ACTIONS(4515),
    [anon_sym_if] = ACTIONS(4515),
    [anon_sym_else] = ACTIONS(4515),
    [anon_sym_switch] = ACTIONS(4515),
    [anon_sym_case] = ACTIONS(4515),
    [anon_sym_default] = ACTIONS(4515),
    [anon_sym_while] = ACTIONS(4515),
    [anon_sym_do] = ACTIONS(4515),
    [anon_sym_for] = ACTIONS(4515),
    [anon_sym_return] = ACTIONS(4515),
    [anon_sym_break] = ACTIONS(4515),
    [anon_sym_continue] = ACTIONS(4515),
    [anon_sym_goto] = ACTIONS(4515),
    [anon_sym_AMP] = ACTIONS(4513),
    [anon_sym_BANG] = ACTIONS(4513),
    [anon_sym_TILDE] = ACTIONS(4513),
    [anon_sym_PLUS] = ACTIONS(4515),
    [anon_sym_DASH] = ACTIONS(4515),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
    [anon_sym_sizeof] = ACTIONS(4515),
    [sym_number_literal] = ACTIONS(4513),
    [anon_sym_SQUOTE] = ACTIONS(4513),
    [anon_sym_DQUOTE] = ACTIONS(4513),
    [sym_true] = ACTIONS(4515),
    [sym_false] = ACTIONS(4515),
    [sym_null] = ACTIONS(4515),
    [sym_identifier] = ACTIONS(4515),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4515),
    [sym_auto] = ACTIONS(4515),
    [anon_sym_typename] = ACTIONS(4515),
    [anon_sym_delete] = ACTIONS(4515),
    [anon_sym_try] = ACTIONS(4515),
    [anon_sym_new] = ACTIONS(4515),
    [anon_sym_COLON_COLON] = ACTIONS(4513),
    [sym_nullptr] = ACTIONS(4515),
  },
  [1949] = {
    [sym_raw_string_literal] = ACTIONS(4554),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4556),
    [sym_preproc_directive] = ACTIONS(4556),
    [anon_sym_SEMI] = ACTIONS(4554),
    [anon_sym_typedef] = ACTIONS(4556),
    [anon_sym_extern] = ACTIONS(4556),
    [anon_sym_LBRACE] = ACTIONS(4554),
    [anon_sym_RBRACE] = ACTIONS(4554),
    [anon_sym_LPAREN2] = ACTIONS(4554),
    [anon_sym_STAR] = ACTIONS(4554),
    [anon_sym_LBRACK] = ACTIONS(4554),
    [anon_sym_static] = ACTIONS(4556),
    [anon_sym_register] = ACTIONS(4556),
    [anon_sym_inline] = ACTIONS(4556),
    [anon_sym_const] = ACTIONS(4556),
    [anon_sym_restrict] = ACTIONS(4556),
    [anon_sym_volatile] = ACTIONS(4556),
    [anon_sym__Atomic] = ACTIONS(4556),
    [anon_sym_mutable] = ACTIONS(4556),
    [anon_sym_explicit] = ACTIONS(4556),
    [anon_sym_constexpr] = ACTIONS(4556),
    [anon_sym_unsigned] = ACTIONS(4556),
    [anon_sym_long] = ACTIONS(4556),
    [anon_sym_short] = ACTIONS(4556),
    [sym_primitive_type] = ACTIONS(4556),
    [anon_sym_enum] = ACTIONS(4556),
    [anon_sym_struct] = ACTIONS(4556),
    [anon_sym_union] = ACTIONS(4556),
    [anon_sym_if] = ACTIONS(4556),
    [anon_sym_else] = ACTIONS(4556),
    [anon_sym_switch] = ACTIONS(4556),
    [anon_sym_case] = ACTIONS(4556),
    [anon_sym_default] = ACTIONS(4556),
    [anon_sym_while] = ACTIONS(4556),
    [anon_sym_do] = ACTIONS(4556),
    [anon_sym_for] = ACTIONS(4556),
    [anon_sym_return] = ACTIONS(4556),
    [anon_sym_break] = ACTIONS(4556),
    [anon_sym_continue] = ACTIONS(4556),
    [anon_sym_goto] = ACTIONS(4556),
    [anon_sym_AMP] = ACTIONS(4554),
    [anon_sym_BANG] = ACTIONS(4554),
    [anon_sym_TILDE] = ACTIONS(4554),
    [anon_sym_PLUS] = ACTIONS(4556),
    [anon_sym_DASH] = ACTIONS(4556),
    [anon_sym_DASH_DASH] = ACTIONS(4554),
    [anon_sym_PLUS_PLUS] = ACTIONS(4554),
    [anon_sym_sizeof] = ACTIONS(4556),
    [sym_number_literal] = ACTIONS(4554),
    [anon_sym_SQUOTE] = ACTIONS(4554),
    [anon_sym_DQUOTE] = ACTIONS(4554),
    [sym_true] = ACTIONS(4556),
    [sym_false] = ACTIONS(4556),
    [sym_null] = ACTIONS(4556),
    [sym_identifier] = ACTIONS(4556),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4556),
    [sym_auto] = ACTIONS(4556),
    [anon_sym_typename] = ACTIONS(4556),
    [anon_sym_delete] = ACTIONS(4556),
    [anon_sym_try] = ACTIONS(4556),
    [anon_sym_new] = ACTIONS(4556),
    [anon_sym_COLON_COLON] = ACTIONS(4554),
    [sym_nullptr] = ACTIONS(4556),
  },
  [1950] = {
    [sym__expression] = STATE(2629),
    [sym_conditional_expression] = STATE(2629),
    [sym_assignment_expression] = STATE(2629),
    [sym_pointer_expression] = STATE(2629),
    [sym_logical_expression] = STATE(2629),
    [sym_bitwise_expression] = STATE(2629),
    [sym_equality_expression] = STATE(2629),
    [sym_relational_expression] = STATE(2629),
    [sym_shift_expression] = STATE(2629),
    [sym_math_expression] = STATE(2629),
    [sym_cast_expression] = STATE(2629),
    [sym_sizeof_expression] = STATE(2629),
    [sym_subscript_expression] = STATE(2629),
    [sym_call_expression] = STATE(2629),
    [sym_field_expression] = STATE(2629),
    [sym_compound_literal_expression] = STATE(2629),
    [sym_parenthesized_expression] = STATE(2629),
    [sym_char_literal] = STATE(2629),
    [sym_concatenated_string] = STATE(2629),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2629),
    [sym_new_expression] = STATE(2629),
    [sym_delete_expression] = STATE(2629),
    [sym_lambda_expression] = STATE(2629),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5832),
    [anon_sym_RPAREN] = ACTIONS(5834),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(5832),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(5836),
    [sym_false] = ACTIONS(5836),
    [sym_null] = ACTIONS(5836),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(5836),
  },
  [1951] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(5838),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1952] = {
    [sym__expression] = STATE(2631),
    [sym_conditional_expression] = STATE(2631),
    [sym_assignment_expression] = STATE(2631),
    [sym_pointer_expression] = STATE(2631),
    [sym_logical_expression] = STATE(2631),
    [sym_bitwise_expression] = STATE(2631),
    [sym_equality_expression] = STATE(2631),
    [sym_relational_expression] = STATE(2631),
    [sym_shift_expression] = STATE(2631),
    [sym_math_expression] = STATE(2631),
    [sym_cast_expression] = STATE(2631),
    [sym_sizeof_expression] = STATE(2631),
    [sym_subscript_expression] = STATE(2631),
    [sym_call_expression] = STATE(2631),
    [sym_field_expression] = STATE(2631),
    [sym_compound_literal_expression] = STATE(2631),
    [sym_parenthesized_expression] = STATE(2631),
    [sym_char_literal] = STATE(2631),
    [sym_concatenated_string] = STATE(2631),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2631),
    [sym_new_expression] = STATE(2631),
    [sym_delete_expression] = STATE(2631),
    [sym_lambda_expression] = STATE(2631),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5840),
    [anon_sym_SEMI] = ACTIONS(5838),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(5840),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(5842),
    [sym_false] = ACTIONS(5842),
    [sym_null] = ACTIONS(5842),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(5842),
  },
  [1953] = {
    [sym__expression] = STATE(2632),
    [sym_conditional_expression] = STATE(2632),
    [sym_assignment_expression] = STATE(2632),
    [sym_pointer_expression] = STATE(2632),
    [sym_logical_expression] = STATE(2632),
    [sym_bitwise_expression] = STATE(2632),
    [sym_equality_expression] = STATE(2632),
    [sym_relational_expression] = STATE(2632),
    [sym_shift_expression] = STATE(2632),
    [sym_math_expression] = STATE(2632),
    [sym_cast_expression] = STATE(2632),
    [sym_sizeof_expression] = STATE(2632),
    [sym_subscript_expression] = STATE(2632),
    [sym_call_expression] = STATE(2632),
    [sym_field_expression] = STATE(2632),
    [sym_compound_literal_expression] = STATE(2632),
    [sym_parenthesized_expression] = STATE(2632),
    [sym_char_literal] = STATE(2632),
    [sym_concatenated_string] = STATE(2632),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2632),
    [sym_new_expression] = STATE(2632),
    [sym_delete_expression] = STATE(2632),
    [sym_lambda_expression] = STATE(2632),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5844),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(5844),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(5846),
    [sym_false] = ACTIONS(5846),
    [sym_null] = ACTIONS(5846),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(5846),
  },
  [1954] = {
    [sym_compound_statement] = STATE(2633),
    [anon_sym_LBRACE] = ACTIONS(175),
    [sym_comment] = ACTIONS(91),
  },
  [1955] = {
    [sym_catch_clause] = STATE(1955),
    [aux_sym_try_statement_repeat1] = STATE(1955),
    [sym_raw_string_literal] = ACTIONS(4993),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4995),
    [sym_preproc_directive] = ACTIONS(4995),
    [anon_sym_SEMI] = ACTIONS(4993),
    [anon_sym_typedef] = ACTIONS(4995),
    [anon_sym_extern] = ACTIONS(4995),
    [anon_sym_LBRACE] = ACTIONS(4993),
    [anon_sym_RBRACE] = ACTIONS(4993),
    [anon_sym_LPAREN2] = ACTIONS(4993),
    [anon_sym_STAR] = ACTIONS(4993),
    [anon_sym_LBRACK] = ACTIONS(4993),
    [anon_sym_static] = ACTIONS(4995),
    [anon_sym_register] = ACTIONS(4995),
    [anon_sym_inline] = ACTIONS(4995),
    [anon_sym_const] = ACTIONS(4995),
    [anon_sym_restrict] = ACTIONS(4995),
    [anon_sym_volatile] = ACTIONS(4995),
    [anon_sym__Atomic] = ACTIONS(4995),
    [anon_sym_mutable] = ACTIONS(4995),
    [anon_sym_explicit] = ACTIONS(4995),
    [anon_sym_constexpr] = ACTIONS(4995),
    [anon_sym_unsigned] = ACTIONS(4995),
    [anon_sym_long] = ACTIONS(4995),
    [anon_sym_short] = ACTIONS(4995),
    [sym_primitive_type] = ACTIONS(4995),
    [anon_sym_enum] = ACTIONS(4995),
    [anon_sym_struct] = ACTIONS(4995),
    [anon_sym_union] = ACTIONS(4995),
    [anon_sym_if] = ACTIONS(4995),
    [anon_sym_switch] = ACTIONS(4995),
    [anon_sym_case] = ACTIONS(4995),
    [anon_sym_default] = ACTIONS(4995),
    [anon_sym_while] = ACTIONS(4995),
    [anon_sym_do] = ACTIONS(4995),
    [anon_sym_for] = ACTIONS(4995),
    [anon_sym_return] = ACTIONS(4995),
    [anon_sym_break] = ACTIONS(4995),
    [anon_sym_continue] = ACTIONS(4995),
    [anon_sym_goto] = ACTIONS(4995),
    [anon_sym_AMP] = ACTIONS(4993),
    [anon_sym_BANG] = ACTIONS(4993),
    [anon_sym_TILDE] = ACTIONS(4993),
    [anon_sym_PLUS] = ACTIONS(4995),
    [anon_sym_DASH] = ACTIONS(4995),
    [anon_sym_DASH_DASH] = ACTIONS(4993),
    [anon_sym_PLUS_PLUS] = ACTIONS(4993),
    [anon_sym_sizeof] = ACTIONS(4995),
    [sym_number_literal] = ACTIONS(4993),
    [anon_sym_SQUOTE] = ACTIONS(4993),
    [anon_sym_DQUOTE] = ACTIONS(4993),
    [sym_true] = ACTIONS(4995),
    [sym_false] = ACTIONS(4995),
    [sym_null] = ACTIONS(4995),
    [sym_identifier] = ACTIONS(4995),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4995),
    [sym_auto] = ACTIONS(4995),
    [anon_sym_typename] = ACTIONS(4995),
    [anon_sym_delete] = ACTIONS(4995),
    [anon_sym_try] = ACTIONS(4995),
    [anon_sym_catch] = ACTIONS(5848),
    [anon_sym_new] = ACTIONS(4995),
    [anon_sym_COLON_COLON] = ACTIONS(4993),
    [sym_nullptr] = ACTIONS(4995),
  },
  [1956] = {
    [sym_raw_string_literal] = ACTIONS(5113),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5115),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5115),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5115),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5115),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5115),
    [sym_preproc_directive] = ACTIONS(5115),
    [anon_sym_SEMI] = ACTIONS(5113),
    [anon_sym_typedef] = ACTIONS(5115),
    [anon_sym_extern] = ACTIONS(5115),
    [anon_sym_LBRACE] = ACTIONS(5113),
    [anon_sym_RBRACE] = ACTIONS(5113),
    [anon_sym_LPAREN2] = ACTIONS(5113),
    [anon_sym_STAR] = ACTIONS(5113),
    [anon_sym_LBRACK] = ACTIONS(5113),
    [anon_sym_static] = ACTIONS(5115),
    [anon_sym_register] = ACTIONS(5115),
    [anon_sym_inline] = ACTIONS(5115),
    [anon_sym_const] = ACTIONS(5115),
    [anon_sym_restrict] = ACTIONS(5115),
    [anon_sym_volatile] = ACTIONS(5115),
    [anon_sym__Atomic] = ACTIONS(5115),
    [anon_sym_mutable] = ACTIONS(5115),
    [anon_sym_explicit] = ACTIONS(5115),
    [anon_sym_constexpr] = ACTIONS(5115),
    [anon_sym_unsigned] = ACTIONS(5115),
    [anon_sym_long] = ACTIONS(5115),
    [anon_sym_short] = ACTIONS(5115),
    [sym_primitive_type] = ACTIONS(5115),
    [anon_sym_enum] = ACTIONS(5115),
    [anon_sym_struct] = ACTIONS(5115),
    [anon_sym_union] = ACTIONS(5115),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_else] = ACTIONS(5115),
    [anon_sym_switch] = ACTIONS(5115),
    [anon_sym_case] = ACTIONS(5115),
    [anon_sym_default] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_for] = ACTIONS(5115),
    [anon_sym_return] = ACTIONS(5115),
    [anon_sym_break] = ACTIONS(5115),
    [anon_sym_continue] = ACTIONS(5115),
    [anon_sym_goto] = ACTIONS(5115),
    [anon_sym_AMP] = ACTIONS(5113),
    [anon_sym_BANG] = ACTIONS(5113),
    [anon_sym_TILDE] = ACTIONS(5113),
    [anon_sym_PLUS] = ACTIONS(5115),
    [anon_sym_DASH] = ACTIONS(5115),
    [anon_sym_DASH_DASH] = ACTIONS(5113),
    [anon_sym_PLUS_PLUS] = ACTIONS(5113),
    [anon_sym_sizeof] = ACTIONS(5115),
    [sym_number_literal] = ACTIONS(5113),
    [anon_sym_SQUOTE] = ACTIONS(5113),
    [anon_sym_DQUOTE] = ACTIONS(5113),
    [sym_true] = ACTIONS(5115),
    [sym_false] = ACTIONS(5115),
    [sym_null] = ACTIONS(5115),
    [sym_identifier] = ACTIONS(5115),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5115),
    [sym_auto] = ACTIONS(5115),
    [anon_sym_typename] = ACTIONS(5115),
    [anon_sym_delete] = ACTIONS(5115),
    [anon_sym_try] = ACTIONS(5115),
    [anon_sym_new] = ACTIONS(5115),
    [anon_sym_COLON_COLON] = ACTIONS(5113),
    [sym_nullptr] = ACTIONS(5115),
  },
  [1957] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(5851),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1958] = {
    [anon_sym_SEMI] = ACTIONS(5851),
    [sym_comment] = ACTIONS(91),
  },
  [1959] = {
    [sym_raw_string_literal] = ACTIONS(5122),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5124),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5124),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5124),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5124),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5124),
    [sym_preproc_directive] = ACTIONS(5124),
    [anon_sym_SEMI] = ACTIONS(5122),
    [anon_sym_typedef] = ACTIONS(5124),
    [anon_sym_extern] = ACTIONS(5124),
    [anon_sym_LBRACE] = ACTIONS(5122),
    [anon_sym_RBRACE] = ACTIONS(5122),
    [anon_sym_LPAREN2] = ACTIONS(5122),
    [anon_sym_STAR] = ACTIONS(5122),
    [anon_sym_LBRACK] = ACTIONS(5122),
    [anon_sym_static] = ACTIONS(5124),
    [anon_sym_register] = ACTIONS(5124),
    [anon_sym_inline] = ACTIONS(5124),
    [anon_sym_const] = ACTIONS(5124),
    [anon_sym_restrict] = ACTIONS(5124),
    [anon_sym_volatile] = ACTIONS(5124),
    [anon_sym__Atomic] = ACTIONS(5124),
    [anon_sym_mutable] = ACTIONS(5124),
    [anon_sym_explicit] = ACTIONS(5124),
    [anon_sym_constexpr] = ACTIONS(5124),
    [anon_sym_unsigned] = ACTIONS(5124),
    [anon_sym_long] = ACTIONS(5124),
    [anon_sym_short] = ACTIONS(5124),
    [sym_primitive_type] = ACTIONS(5124),
    [anon_sym_enum] = ACTIONS(5124),
    [anon_sym_struct] = ACTIONS(5124),
    [anon_sym_union] = ACTIONS(5124),
    [anon_sym_if] = ACTIONS(5124),
    [anon_sym_switch] = ACTIONS(5124),
    [anon_sym_case] = ACTIONS(5124),
    [anon_sym_default] = ACTIONS(5124),
    [anon_sym_while] = ACTIONS(5124),
    [anon_sym_do] = ACTIONS(5124),
    [anon_sym_for] = ACTIONS(5124),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_break] = ACTIONS(5124),
    [anon_sym_continue] = ACTIONS(5124),
    [anon_sym_goto] = ACTIONS(5124),
    [anon_sym_AMP] = ACTIONS(5122),
    [anon_sym_BANG] = ACTIONS(5122),
    [anon_sym_TILDE] = ACTIONS(5122),
    [anon_sym_PLUS] = ACTIONS(5124),
    [anon_sym_DASH] = ACTIONS(5124),
    [anon_sym_DASH_DASH] = ACTIONS(5122),
    [anon_sym_PLUS_PLUS] = ACTIONS(5122),
    [anon_sym_sizeof] = ACTIONS(5124),
    [sym_number_literal] = ACTIONS(5122),
    [anon_sym_SQUOTE] = ACTIONS(5122),
    [anon_sym_DQUOTE] = ACTIONS(5122),
    [sym_true] = ACTIONS(5124),
    [sym_false] = ACTIONS(5124),
    [sym_null] = ACTIONS(5124),
    [sym_identifier] = ACTIONS(5124),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5124),
    [sym_auto] = ACTIONS(5124),
    [anon_sym_typename] = ACTIONS(5124),
    [anon_sym_delete] = ACTIONS(5124),
    [anon_sym_try] = ACTIONS(5124),
    [anon_sym_new] = ACTIONS(5124),
    [anon_sym_COLON_COLON] = ACTIONS(5122),
    [sym_nullptr] = ACTIONS(5124),
  },
  [1960] = {
    [sym__expression] = STATE(1200),
    [sym_conditional_expression] = STATE(1200),
    [sym_assignment_expression] = STATE(1200),
    [sym_pointer_expression] = STATE(1200),
    [sym_logical_expression] = STATE(1200),
    [sym_bitwise_expression] = STATE(1200),
    [sym_equality_expression] = STATE(1200),
    [sym_relational_expression] = STATE(1200),
    [sym_shift_expression] = STATE(1200),
    [sym_math_expression] = STATE(1200),
    [sym_cast_expression] = STATE(1200),
    [sym_sizeof_expression] = STATE(1200),
    [sym_subscript_expression] = STATE(1200),
    [sym_call_expression] = STATE(1200),
    [sym_field_expression] = STATE(1200),
    [sym_compound_literal_expression] = STATE(1200),
    [sym_parenthesized_expression] = STATE(1200),
    [sym_initializer_list] = STATE(1201),
    [sym_char_literal] = STATE(1200),
    [sym_concatenated_string] = STATE(1200),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1200),
    [sym_new_expression] = STATE(1200),
    [sym_delete_expression] = STATE(1200),
    [sym_lambda_expression] = STATE(1200),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2523),
    [anon_sym_COMMA] = ACTIONS(4689),
    [anon_sym_RPAREN] = ACTIONS(4689),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(5853),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_EQ] = ACTIONS(4693),
    [anon_sym_QMARK] = ACTIONS(4689),
    [anon_sym_STAR_EQ] = ACTIONS(4689),
    [anon_sym_SLASH_EQ] = ACTIONS(4689),
    [anon_sym_PERCENT_EQ] = ACTIONS(4689),
    [anon_sym_PLUS_EQ] = ACTIONS(4689),
    [anon_sym_DASH_EQ] = ACTIONS(4689),
    [anon_sym_LT_LT_EQ] = ACTIONS(4689),
    [anon_sym_GT_GT_EQ] = ACTIONS(4689),
    [anon_sym_AMP_EQ] = ACTIONS(4689),
    [anon_sym_CARET_EQ] = ACTIONS(4689),
    [anon_sym_PIPE_EQ] = ACTIONS(4689),
    [anon_sym_AMP] = ACTIONS(5853),
    [anon_sym_PIPE_PIPE] = ACTIONS(4689),
    [anon_sym_AMP_AMP] = ACTIONS(4689),
    [anon_sym_BANG] = ACTIONS(5855),
    [anon_sym_PIPE] = ACTIONS(4693),
    [anon_sym_CARET] = ACTIONS(4693),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_EQ_EQ] = ACTIONS(4689),
    [anon_sym_BANG_EQ] = ACTIONS(4689),
    [anon_sym_LT] = ACTIONS(4693),
    [anon_sym_GT] = ACTIONS(4693),
    [anon_sym_LT_EQ] = ACTIONS(4689),
    [anon_sym_GT_EQ] = ACTIONS(4689),
    [anon_sym_LT_LT] = ACTIONS(4693),
    [anon_sym_GT_GT] = ACTIONS(4693),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_SLASH] = ACTIONS(4693),
    [anon_sym_PERCENT] = ACTIONS(4693),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [anon_sym_DOT] = ACTIONS(4689),
    [anon_sym_DASH_GT] = ACTIONS(4689),
    [sym_number_literal] = ACTIONS(2523),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2525),
    [sym_false] = ACTIONS(2525),
    [sym_null] = ACTIONS(2525),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(2525),
  },
  [1961] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(4927),
    [anon_sym_RPAREN] = ACTIONS(4927),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(4929),
    [anon_sym_QMARK] = ACTIONS(4927),
    [anon_sym_STAR_EQ] = ACTIONS(4927),
    [anon_sym_SLASH_EQ] = ACTIONS(4927),
    [anon_sym_PERCENT_EQ] = ACTIONS(4927),
    [anon_sym_PLUS_EQ] = ACTIONS(4927),
    [anon_sym_DASH_EQ] = ACTIONS(4927),
    [anon_sym_LT_LT_EQ] = ACTIONS(4927),
    [anon_sym_GT_GT_EQ] = ACTIONS(4927),
    [anon_sym_AMP_EQ] = ACTIONS(4927),
    [anon_sym_CARET_EQ] = ACTIONS(4927),
    [anon_sym_PIPE_EQ] = ACTIONS(4927),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1962] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(5857),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_STAR_EQ] = ACTIONS(3507),
    [anon_sym_SLASH_EQ] = ACTIONS(3507),
    [anon_sym_PERCENT_EQ] = ACTIONS(3507),
    [anon_sym_PLUS_EQ] = ACTIONS(3507),
    [anon_sym_DASH_EQ] = ACTIONS(3507),
    [anon_sym_LT_LT_EQ] = ACTIONS(3507),
    [anon_sym_GT_GT_EQ] = ACTIONS(3507),
    [anon_sym_AMP_EQ] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(3507),
    [anon_sym_PIPE_EQ] = ACTIONS(3507),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_CARET] = ACTIONS(3517),
    [anon_sym_EQ_EQ] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3521),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3525),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1963] = {
    [sym__expression] = STATE(2636),
    [sym_conditional_expression] = STATE(2636),
    [sym_assignment_expression] = STATE(2636),
    [sym_pointer_expression] = STATE(2636),
    [sym_logical_expression] = STATE(2636),
    [sym_bitwise_expression] = STATE(2636),
    [sym_equality_expression] = STATE(2636),
    [sym_relational_expression] = STATE(2636),
    [sym_shift_expression] = STATE(2636),
    [sym_math_expression] = STATE(2636),
    [sym_cast_expression] = STATE(2636),
    [sym_sizeof_expression] = STATE(2636),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2636),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(2636),
    [sym_concatenated_string] = STATE(2636),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2636),
    [sym_new_expression] = STATE(2636),
    [sym_delete_expression] = STATE(2636),
    [sym_lambda_expression] = STATE(2636),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5859),
    [anon_sym_LPAREN2] = ACTIONS(947),
    [anon_sym_STAR] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(947),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(5859),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(5861),
    [sym_false] = ACTIONS(5861),
    [sym_null] = ACTIONS(5861),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(5861),
  },
  [1964] = {
    [sym_field_declaration_list] = STATE(175),
    [sym_virtual_specifier] = STATE(176),
    [sym_base_class_clause] = STATE(177),
    [sym_template_type] = STATE(2638),
    [sym_scoped_type_identifier] = STATE(2639),
    [sym_scoped_namespace_identifier] = STATE(83),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(5863),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [1965] = {
    [sym_field_declaration_list] = STATE(182),
    [sym_virtual_specifier] = STATE(183),
    [sym_base_class_clause] = STATE(184),
    [sym_template_type] = STATE(2641),
    [sym_scoped_type_identifier] = STATE(2642),
    [sym_scoped_namespace_identifier] = STATE(83),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(5865),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [1966] = {
    [sym_field_declaration_list] = STATE(265),
    [sym_virtual_specifier] = STATE(266),
    [sym_base_class_clause] = STATE(267),
    [sym_template_type] = STATE(2644),
    [sym_scoped_type_identifier] = STATE(2645),
    [sym_scoped_namespace_identifier] = STATE(83),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(5867),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [1967] = {
    [sym__type_specifier] = STATE(271),
    [sym_sized_type_specifier] = STATE(271),
    [sym_enum_specifier] = STATE(271),
    [sym_struct_specifier] = STATE(271),
    [sym_union_specifier] = STATE(271),
    [sym_macro_type_specifier] = STATE(271),
    [sym_class_specifier] = STATE(271),
    [sym_dependent_type] = STATE(271),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1969),
    [anon_sym_unsigned] = ACTIONS(4143),
    [anon_sym_long] = ACTIONS(4143),
    [anon_sym_short] = ACTIONS(4143),
    [sym_primitive_type] = ACTIONS(490),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(4147),
    [anon_sym_union] = ACTIONS(4149),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4151),
    [sym_auto] = ACTIONS(490),
    [anon_sym_typename] = ACTIONS(4153),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [1968] = {
    [sym__abstract_declarator] = STATE(2648),
    [sym_abstract_pointer_declarator] = STATE(2648),
    [sym_abstract_function_declarator] = STATE(2648),
    [sym_abstract_array_declarator] = STATE(2648),
    [sym_parameter_list] = STATE(2649),
    [sym_abstract_reference_declarator] = STATE(2648),
    [anon_sym_RPAREN] = ACTIONS(5222),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(5869),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_const] = ACTIONS(5226),
    [anon_sym_restrict] = ACTIONS(5222),
    [anon_sym_volatile] = ACTIONS(5222),
    [anon_sym__Atomic] = ACTIONS(5222),
    [anon_sym_mutable] = ACTIONS(5222),
    [anon_sym_explicit] = ACTIONS(5222),
    [anon_sym_constexpr] = ACTIONS(5222),
    [anon_sym_AMP] = ACTIONS(5871),
    [anon_sym_AMP_AMP] = ACTIONS(5873),
    [anon_sym_DASH_GT] = ACTIONS(5222),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5222),
    [anon_sym_override] = ACTIONS(5222),
    [sym_noexcept] = ACTIONS(5222),
  },
  [1969] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2650),
    [anon_sym_RPAREN] = ACTIONS(653),
    [anon_sym_LPAREN2] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(655),
    [anon_sym_restrict] = ACTIONS(655),
    [anon_sym_volatile] = ACTIONS(655),
    [anon_sym__Atomic] = ACTIONS(655),
    [anon_sym_mutable] = ACTIONS(655),
    [anon_sym_explicit] = ACTIONS(655),
    [anon_sym_constexpr] = ACTIONS(655),
    [anon_sym_unsigned] = ACTIONS(5875),
    [anon_sym_long] = ACTIONS(5875),
    [anon_sym_short] = ACTIONS(5875),
    [sym_primitive_type] = ACTIONS(659),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [anon_sym_DASH_GT] = ACTIONS(653),
    [sym_identifier] = ACTIONS(933),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(655),
    [anon_sym_override] = ACTIONS(655),
    [sym_noexcept] = ACTIONS(655),
  },
  [1970] = {
    [sym_type_qualifier] = STATE(1970),
    [sym_virtual_specifier] = STATE(1970),
    [sym_trailing_return_type] = STATE(1970),
    [aux_sym_function_declarator_repeat1] = STATE(1970),
    [anon_sym_RPAREN] = ACTIONS(5236),
    [anon_sym_LPAREN2] = ACTIONS(5236),
    [anon_sym_LBRACK] = ACTIONS(5236),
    [anon_sym_const] = ACTIONS(5877),
    [anon_sym_restrict] = ACTIONS(5880),
    [anon_sym_volatile] = ACTIONS(5880),
    [anon_sym__Atomic] = ACTIONS(5880),
    [anon_sym_mutable] = ACTIONS(5880),
    [anon_sym_explicit] = ACTIONS(5880),
    [anon_sym_constexpr] = ACTIONS(5880),
    [anon_sym_DASH_GT] = ACTIONS(5883),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5247),
    [anon_sym_override] = ACTIONS(5247),
    [sym_noexcept] = ACTIONS(5886),
  },
  [1971] = {
    [sym_parameter_list] = STATE(1185),
    [anon_sym_RPAREN] = ACTIONS(5889),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [sym_comment] = ACTIONS(91),
  },
  [1972] = {
    [sym_type_qualifier] = STATE(1972),
    [aux_sym_type_definition_repeat1] = STATE(1972),
    [anon_sym_RPAREN] = ACTIONS(2179),
    [anon_sym_LPAREN2] = ACTIONS(2179),
    [anon_sym_STAR] = ACTIONS(2179),
    [anon_sym_LBRACK] = ACTIONS(2179),
    [anon_sym_const] = ACTIONS(2538),
    [anon_sym_restrict] = ACTIONS(5316),
    [anon_sym_volatile] = ACTIONS(5316),
    [anon_sym__Atomic] = ACTIONS(5316),
    [anon_sym_mutable] = ACTIONS(5316),
    [anon_sym_explicit] = ACTIONS(5316),
    [anon_sym_constexpr] = ACTIONS(5316),
    [anon_sym_AMP] = ACTIONS(2177),
    [anon_sym_AMP_AMP] = ACTIONS(2179),
    [sym_comment] = ACTIONS(91),
  },
  [1973] = {
    [sym_type_qualifier] = STATE(1975),
    [sym_trailing_return_type] = STATE(2418),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1975),
    [anon_sym_RPAREN] = ACTIONS(5331),
    [anon_sym_LPAREN2] = ACTIONS(5331),
    [anon_sym_LBRACK] = ACTIONS(5331),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(2467),
    [sym_comment] = ACTIONS(91),
    [sym_noexcept] = ACTIONS(4165),
  },
  [1974] = {
    [sym__abstract_declarator] = STATE(2651),
    [sym_abstract_pointer_declarator] = STATE(2651),
    [sym_abstract_function_declarator] = STATE(2651),
    [sym_abstract_array_declarator] = STATE(2651),
    [sym_parameter_list] = STATE(528),
    [sym_abstract_reference_declarator] = STATE(2651),
    [anon_sym_RPAREN] = ACTIONS(5222),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_AMP_AMP] = ACTIONS(893),
    [sym_comment] = ACTIONS(91),
  },
  [1975] = {
    [sym_type_qualifier] = STATE(1975),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(1975),
    [anon_sym_RPAREN] = ACTIONS(5351),
    [anon_sym_LPAREN2] = ACTIONS(5351),
    [anon_sym_LBRACK] = ACTIONS(5351),
    [anon_sym_const] = ACTIONS(5353),
    [anon_sym_restrict] = ACTIONS(5356),
    [anon_sym_volatile] = ACTIONS(5356),
    [anon_sym__Atomic] = ACTIONS(5356),
    [anon_sym_mutable] = ACTIONS(5356),
    [anon_sym_explicit] = ACTIONS(5356),
    [anon_sym_constexpr] = ACTIONS(5356),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [sym_comment] = ACTIONS(91),
    [sym_noexcept] = ACTIONS(5891),
  },
  [1976] = {
    [sym__expression] = STATE(2652),
    [sym_conditional_expression] = STATE(2652),
    [sym_assignment_expression] = STATE(2652),
    [sym_pointer_expression] = STATE(2652),
    [sym_logical_expression] = STATE(2652),
    [sym_bitwise_expression] = STATE(2652),
    [sym_equality_expression] = STATE(2652),
    [sym_relational_expression] = STATE(2652),
    [sym_shift_expression] = STATE(2652),
    [sym_math_expression] = STATE(2652),
    [sym_cast_expression] = STATE(2652),
    [sym_sizeof_expression] = STATE(2652),
    [sym_subscript_expression] = STATE(2652),
    [sym_call_expression] = STATE(2652),
    [sym_field_expression] = STATE(2652),
    [sym_compound_literal_expression] = STATE(2652),
    [sym_parenthesized_expression] = STATE(2652),
    [sym_char_literal] = STATE(2652),
    [sym_concatenated_string] = STATE(2652),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2652),
    [sym_new_expression] = STATE(2652),
    [sym_delete_expression] = STATE(2652),
    [sym_lambda_expression] = STATE(2652),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5894),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(5894),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(5896),
    [sym_false] = ACTIONS(5896),
    [sym_null] = ACTIONS(5896),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(5896),
  },
  [1977] = {
    [sym__type_specifier] = STATE(271),
    [sym_sized_type_specifier] = STATE(271),
    [sym_enum_specifier] = STATE(271),
    [sym_struct_specifier] = STATE(271),
    [sym_union_specifier] = STATE(271),
    [sym_macro_type_specifier] = STATE(271),
    [sym_class_specifier] = STATE(271),
    [sym_dependent_type] = STATE(271),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1979),
    [anon_sym_unsigned] = ACTIONS(4179),
    [anon_sym_long] = ACTIONS(4179),
    [anon_sym_short] = ACTIONS(4179),
    [sym_primitive_type] = ACTIONS(490),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(4147),
    [anon_sym_union] = ACTIONS(4149),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4151),
    [sym_auto] = ACTIONS(490),
    [anon_sym_typename] = ACTIONS(4183),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [1978] = {
    [sym__abstract_declarator] = STATE(2655),
    [sym_abstract_pointer_declarator] = STATE(2655),
    [sym_abstract_function_declarator] = STATE(2655),
    [sym_abstract_array_declarator] = STATE(2655),
    [sym_parameter_list] = STATE(2656),
    [sym_abstract_reference_declarator] = STATE(2655),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(5898),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_const] = ACTIONS(5226),
    [anon_sym_restrict] = ACTIONS(5222),
    [anon_sym_volatile] = ACTIONS(5222),
    [anon_sym__Atomic] = ACTIONS(5222),
    [anon_sym_mutable] = ACTIONS(5222),
    [anon_sym_explicit] = ACTIONS(5222),
    [anon_sym_constexpr] = ACTIONS(5222),
    [anon_sym_AMP] = ACTIONS(5900),
    [anon_sym_AMP_AMP] = ACTIONS(5902),
    [anon_sym_DASH_GT] = ACTIONS(5222),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5222),
    [anon_sym_override] = ACTIONS(5222),
    [sym_noexcept] = ACTIONS(5222),
  },
  [1979] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2657),
    [anon_sym_LPAREN2] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(655),
    [anon_sym_restrict] = ACTIONS(655),
    [anon_sym_volatile] = ACTIONS(655),
    [anon_sym__Atomic] = ACTIONS(655),
    [anon_sym_mutable] = ACTIONS(655),
    [anon_sym_explicit] = ACTIONS(655),
    [anon_sym_constexpr] = ACTIONS(655),
    [anon_sym_unsigned] = ACTIONS(5904),
    [anon_sym_long] = ACTIONS(5904),
    [anon_sym_short] = ACTIONS(5904),
    [sym_primitive_type] = ACTIONS(659),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [anon_sym_DASH_GT] = ACTIONS(653),
    [sym_identifier] = ACTIONS(933),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(655),
    [anon_sym_override] = ACTIONS(655),
    [sym_noexcept] = ACTIONS(655),
  },
  [1980] = {
    [sym_type_qualifier] = STATE(1980),
    [sym_virtual_specifier] = STATE(1980),
    [sym_trailing_return_type] = STATE(1980),
    [aux_sym_function_declarator_repeat1] = STATE(1980),
    [anon_sym_LPAREN2] = ACTIONS(5236),
    [anon_sym_LBRACK] = ACTIONS(5236),
    [anon_sym_const] = ACTIONS(5877),
    [anon_sym_restrict] = ACTIONS(5880),
    [anon_sym_volatile] = ACTIONS(5880),
    [anon_sym__Atomic] = ACTIONS(5880),
    [anon_sym_mutable] = ACTIONS(5880),
    [anon_sym_explicit] = ACTIONS(5880),
    [anon_sym_constexpr] = ACTIONS(5880),
    [anon_sym_DASH_GT] = ACTIONS(5906),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5247),
    [anon_sym_override] = ACTIONS(5247),
    [sym_noexcept] = ACTIONS(5909),
  },
  [1981] = {
    [sym__expression] = STATE(1200),
    [sym_conditional_expression] = STATE(1200),
    [sym_assignment_expression] = STATE(1200),
    [sym_pointer_expression] = STATE(1200),
    [sym_logical_expression] = STATE(1200),
    [sym_bitwise_expression] = STATE(1200),
    [sym_equality_expression] = STATE(1200),
    [sym_relational_expression] = STATE(1200),
    [sym_shift_expression] = STATE(1200),
    [sym_math_expression] = STATE(1200),
    [sym_cast_expression] = STATE(1200),
    [sym_sizeof_expression] = STATE(1200),
    [sym_subscript_expression] = STATE(1200),
    [sym_call_expression] = STATE(1200),
    [sym_field_expression] = STATE(1200),
    [sym_compound_literal_expression] = STATE(1200),
    [sym_parenthesized_expression] = STATE(1200),
    [sym_initializer_list] = STATE(1201),
    [sym_char_literal] = STATE(1200),
    [sym_concatenated_string] = STATE(1200),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1200),
    [sym_new_expression] = STATE(1200),
    [sym_delete_expression] = STATE(1200),
    [sym_lambda_expression] = STATE(1200),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2523),
    [anon_sym_COMMA] = ACTIONS(4689),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(5912),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(4689),
    [anon_sym_EQ] = ACTIONS(4693),
    [anon_sym_QMARK] = ACTIONS(4689),
    [anon_sym_STAR_EQ] = ACTIONS(4689),
    [anon_sym_SLASH_EQ] = ACTIONS(4689),
    [anon_sym_PERCENT_EQ] = ACTIONS(4689),
    [anon_sym_PLUS_EQ] = ACTIONS(4689),
    [anon_sym_DASH_EQ] = ACTIONS(4689),
    [anon_sym_LT_LT_EQ] = ACTIONS(4689),
    [anon_sym_GT_GT_EQ] = ACTIONS(4689),
    [anon_sym_AMP_EQ] = ACTIONS(4689),
    [anon_sym_CARET_EQ] = ACTIONS(4689),
    [anon_sym_PIPE_EQ] = ACTIONS(4689),
    [anon_sym_AMP] = ACTIONS(5912),
    [anon_sym_PIPE_PIPE] = ACTIONS(4689),
    [anon_sym_AMP_AMP] = ACTIONS(4689),
    [anon_sym_BANG] = ACTIONS(5914),
    [anon_sym_PIPE] = ACTIONS(4693),
    [anon_sym_CARET] = ACTIONS(4693),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_EQ_EQ] = ACTIONS(4689),
    [anon_sym_BANG_EQ] = ACTIONS(4689),
    [anon_sym_LT] = ACTIONS(4693),
    [anon_sym_GT] = ACTIONS(4693),
    [anon_sym_LT_EQ] = ACTIONS(4689),
    [anon_sym_GT_EQ] = ACTIONS(4689),
    [anon_sym_LT_LT] = ACTIONS(4693),
    [anon_sym_GT_GT] = ACTIONS(4693),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_SLASH] = ACTIONS(4693),
    [anon_sym_PERCENT] = ACTIONS(4693),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [anon_sym_DOT] = ACTIONS(4689),
    [anon_sym_DASH_GT] = ACTIONS(4689),
    [sym_number_literal] = ACTIONS(2523),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2525),
    [sym_false] = ACTIONS(2525),
    [sym_null] = ACTIONS(2525),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(2525),
  },
  [1982] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(4927),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(4927),
    [anon_sym_EQ] = ACTIONS(4929),
    [anon_sym_QMARK] = ACTIONS(4927),
    [anon_sym_STAR_EQ] = ACTIONS(4927),
    [anon_sym_SLASH_EQ] = ACTIONS(4927),
    [anon_sym_PERCENT_EQ] = ACTIONS(4927),
    [anon_sym_PLUS_EQ] = ACTIONS(4927),
    [anon_sym_DASH_EQ] = ACTIONS(4927),
    [anon_sym_LT_LT_EQ] = ACTIONS(4927),
    [anon_sym_GT_GT_EQ] = ACTIONS(4927),
    [anon_sym_AMP_EQ] = ACTIONS(4927),
    [anon_sym_CARET_EQ] = ACTIONS(4927),
    [anon_sym_PIPE_EQ] = ACTIONS(4927),
    [anon_sym_AMP] = ACTIONS(985),
    [anon_sym_PIPE_PIPE] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(989),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_CARET] = ACTIONS(993),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(999),
    [anon_sym_LT_LT] = ACTIONS(1001),
    [anon_sym_GT_GT] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(975),
    [anon_sym_PERCENT] = ACTIONS(975),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1983] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(5916),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_STAR_EQ] = ACTIONS(3507),
    [anon_sym_SLASH_EQ] = ACTIONS(3507),
    [anon_sym_PERCENT_EQ] = ACTIONS(3507),
    [anon_sym_PLUS_EQ] = ACTIONS(3507),
    [anon_sym_DASH_EQ] = ACTIONS(3507),
    [anon_sym_LT_LT_EQ] = ACTIONS(3507),
    [anon_sym_GT_GT_EQ] = ACTIONS(3507),
    [anon_sym_AMP_EQ] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(3507),
    [anon_sym_PIPE_EQ] = ACTIONS(3507),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_CARET] = ACTIONS(3517),
    [anon_sym_EQ_EQ] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3521),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3525),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1984] = {
    [sym__expression] = STATE(2659),
    [sym_conditional_expression] = STATE(2659),
    [sym_assignment_expression] = STATE(2659),
    [sym_pointer_expression] = STATE(2659),
    [sym_logical_expression] = STATE(2659),
    [sym_bitwise_expression] = STATE(2659),
    [sym_equality_expression] = STATE(2659),
    [sym_relational_expression] = STATE(2659),
    [sym_shift_expression] = STATE(2659),
    [sym_math_expression] = STATE(2659),
    [sym_cast_expression] = STATE(2659),
    [sym_sizeof_expression] = STATE(2659),
    [sym_subscript_expression] = STATE(2659),
    [sym_call_expression] = STATE(2659),
    [sym_field_expression] = STATE(2659),
    [sym_compound_literal_expression] = STATE(2659),
    [sym_parenthesized_expression] = STATE(2659),
    [sym_char_literal] = STATE(2659),
    [sym_concatenated_string] = STATE(2659),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2659),
    [sym_new_expression] = STATE(2659),
    [sym_delete_expression] = STATE(2659),
    [sym_lambda_expression] = STATE(2659),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5918),
    [anon_sym_LPAREN2] = ACTIONS(947),
    [anon_sym_STAR] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(947),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(5918),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(5920),
    [sym_false] = ACTIONS(5920),
    [sym_null] = ACTIONS(5920),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(5920),
  },
  [1985] = {
    [sym__expression] = STATE(2660),
    [sym_conditional_expression] = STATE(2660),
    [sym_assignment_expression] = STATE(2660),
    [sym_pointer_expression] = STATE(2660),
    [sym_logical_expression] = STATE(2660),
    [sym_bitwise_expression] = STATE(2660),
    [sym_equality_expression] = STATE(2660),
    [sym_relational_expression] = STATE(2660),
    [sym_shift_expression] = STATE(2660),
    [sym_math_expression] = STATE(2660),
    [sym_cast_expression] = STATE(2660),
    [sym_sizeof_expression] = STATE(2660),
    [sym_subscript_expression] = STATE(2660),
    [sym_call_expression] = STATE(2660),
    [sym_field_expression] = STATE(2660),
    [sym_compound_literal_expression] = STATE(2660),
    [sym_parenthesized_expression] = STATE(2660),
    [sym_char_literal] = STATE(2660),
    [sym_concatenated_string] = STATE(2660),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2660),
    [sym_new_expression] = STATE(2660),
    [sym_delete_expression] = STATE(2660),
    [sym_lambda_expression] = STATE(2660),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5922),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(5922),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(5924),
    [sym_false] = ACTIONS(5924),
    [sym_null] = ACTIONS(5924),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(5924),
  },
  [1986] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(5926),
    [anon_sym_RBRACE] = ACTIONS(5926),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2953),
    [anon_sym_QMARK] = ACTIONS(2955),
    [anon_sym_STAR_EQ] = ACTIONS(2957),
    [anon_sym_SLASH_EQ] = ACTIONS(2957),
    [anon_sym_PERCENT_EQ] = ACTIONS(2957),
    [anon_sym_PLUS_EQ] = ACTIONS(2957),
    [anon_sym_DASH_EQ] = ACTIONS(2957),
    [anon_sym_LT_LT_EQ] = ACTIONS(2957),
    [anon_sym_GT_GT_EQ] = ACTIONS(2957),
    [anon_sym_AMP_EQ] = ACTIONS(2957),
    [anon_sym_CARET_EQ] = ACTIONS(2957),
    [anon_sym_PIPE_EQ] = ACTIONS(2957),
    [anon_sym_AMP] = ACTIONS(2959),
    [anon_sym_PIPE_PIPE] = ACTIONS(2961),
    [anon_sym_AMP_AMP] = ACTIONS(2963),
    [anon_sym_PIPE] = ACTIONS(2965),
    [anon_sym_CARET] = ACTIONS(2967),
    [anon_sym_EQ_EQ] = ACTIONS(2969),
    [anon_sym_BANG_EQ] = ACTIONS(2969),
    [anon_sym_LT] = ACTIONS(2971),
    [anon_sym_GT] = ACTIONS(2971),
    [anon_sym_LT_EQ] = ACTIONS(2973),
    [anon_sym_GT_EQ] = ACTIONS(2973),
    [anon_sym_LT_LT] = ACTIONS(2975),
    [anon_sym_GT_GT] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_SLASH] = ACTIONS(2951),
    [anon_sym_PERCENT] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [1987] = {
    [anon_sym_COMMA] = ACTIONS(5928),
    [anon_sym_RPAREN] = ACTIONS(5928),
    [anon_sym_SEMI] = ACTIONS(5928),
    [anon_sym_extern] = ACTIONS(5930),
    [anon_sym_LBRACE] = ACTIONS(5928),
    [anon_sym_LPAREN2] = ACTIONS(5928),
    [anon_sym_STAR] = ACTIONS(5928),
    [anon_sym_LBRACK] = ACTIONS(5928),
    [anon_sym_EQ] = ACTIONS(5928),
    [anon_sym_static] = ACTIONS(5930),
    [anon_sym_register] = ACTIONS(5930),
    [anon_sym_inline] = ACTIONS(5930),
    [anon_sym_const] = ACTIONS(5930),
    [anon_sym_restrict] = ACTIONS(5930),
    [anon_sym_volatile] = ACTIONS(5930),
    [anon_sym__Atomic] = ACTIONS(5930),
    [anon_sym_mutable] = ACTIONS(5930),
    [anon_sym_explicit] = ACTIONS(5930),
    [anon_sym_constexpr] = ACTIONS(5930),
    [anon_sym_COLON] = ACTIONS(5930),
    [anon_sym_AMP] = ACTIONS(5930),
    [anon_sym_AMP_AMP] = ACTIONS(5928),
    [anon_sym_TILDE] = ACTIONS(5928),
    [anon_sym_DASH_GT] = ACTIONS(5928),
    [sym_identifier] = ACTIONS(5930),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5930),
    [anon_sym_override] = ACTIONS(5930),
    [anon_sym_GT2] = ACTIONS(5928),
    [sym_noexcept] = ACTIONS(5930),
    [anon_sym_COLON_COLON] = ACTIONS(5928),
    [sym_operator_name] = ACTIONS(5928),
  },
  [1988] = {
    [anon_sym_COMMA] = ACTIONS(5932),
    [anon_sym_RBRACE] = ACTIONS(5932),
    [sym_comment] = ACTIONS(91),
  },
  [1989] = {
    [sym_enumerator] = STATE(1988),
    [anon_sym_RBRACE] = ACTIONS(5934),
    [sym_identifier] = ACTIONS(1009),
    [sym_comment] = ACTIONS(91),
  },
  [1990] = {
    [aux_sym_enumerator_list_repeat1] = STATE(1990),
    [anon_sym_COMMA] = ACTIONS(5936),
    [anon_sym_RBRACE] = ACTIONS(5932),
    [sym_comment] = ACTIONS(91),
  },
  [1991] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5939),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5941),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5941),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5941),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5941),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5941),
    [anon_sym_typedef] = ACTIONS(5939),
    [anon_sym_extern] = ACTIONS(5939),
    [anon_sym_RBRACE] = ACTIONS(5941),
    [anon_sym_LPAREN2] = ACTIONS(5941),
    [anon_sym_STAR] = ACTIONS(5941),
    [anon_sym_static] = ACTIONS(5939),
    [anon_sym_register] = ACTIONS(5939),
    [anon_sym_inline] = ACTIONS(5939),
    [anon_sym_const] = ACTIONS(5939),
    [anon_sym_restrict] = ACTIONS(5939),
    [anon_sym_volatile] = ACTIONS(5939),
    [anon_sym__Atomic] = ACTIONS(5939),
    [anon_sym_mutable] = ACTIONS(5939),
    [anon_sym_explicit] = ACTIONS(5939),
    [anon_sym_constexpr] = ACTIONS(5939),
    [anon_sym_unsigned] = ACTIONS(5939),
    [anon_sym_long] = ACTIONS(5939),
    [anon_sym_short] = ACTIONS(5939),
    [sym_primitive_type] = ACTIONS(5939),
    [anon_sym_enum] = ACTIONS(5939),
    [anon_sym_struct] = ACTIONS(5939),
    [anon_sym_union] = ACTIONS(5939),
    [anon_sym_AMP] = ACTIONS(5939),
    [anon_sym_AMP_AMP] = ACTIONS(5941),
    [anon_sym_TILDE] = ACTIONS(5941),
    [sym_identifier] = ACTIONS(5939),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5939),
    [anon_sym_public] = ACTIONS(5939),
    [sym_auto] = ACTIONS(5939),
    [anon_sym_typename] = ACTIONS(5939),
    [anon_sym_template] = ACTIONS(5939),
    [anon_sym_friend] = ACTIONS(5939),
    [anon_sym_private] = ACTIONS(5939),
    [anon_sym_protected] = ACTIONS(5939),
    [anon_sym_using] = ACTIONS(5939),
    [anon_sym_COLON_COLON] = ACTIONS(5941),
    [sym_operator_name] = ACTIONS(5941),
  },
  [1992] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(2663),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(2663),
    [sym_type_definition] = STATE(2663),
    [sym__declaration_specifiers] = STATE(598),
    [sym__declarator] = STATE(599),
    [sym_pointer_declarator] = STATE(599),
    [sym_function_declarator] = STATE(600),
    [sym_array_declarator] = STATE(599),
    [sym_storage_class_specifier] = STATE(605),
    [sym_type_qualifier] = STATE(605),
    [sym__type_specifier] = STATE(601),
    [sym_sized_type_specifier] = STATE(601),
    [sym_enum_specifier] = STATE(601),
    [sym_struct_specifier] = STATE(601),
    [sym_union_specifier] = STATE(601),
    [sym__field_declaration_list_item] = STATE(2663),
    [sym_field_declaration] = STATE(2663),
    [sym_macro_type_specifier] = STATE(601),
    [sym_class_specifier] = STATE(601),
    [sym_dependent_type] = STATE(601),
    [sym_template_declaration] = STATE(2663),
    [sym_inline_method_definition] = STATE(2663),
    [sym_constructor_or_destructor_definition] = STATE(2663),
    [sym_constructor_or_destructor_declaration] = STATE(2663),
    [sym_friend_declaration] = STATE(2663),
    [sym_access_specifier] = STATE(2663),
    [sym_reference_declarator] = STATE(599),
    [sym_template_type] = STATE(602),
    [sym_template_function] = STATE(599),
    [sym_using_declaration] = STATE(2663),
    [sym_alias_declaration] = STATE(2663),
    [sym_destructor_name] = STATE(599),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(603),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(2663),
    [aux_sym__declaration_specifiers_repeat1] = STATE(605),
    [aux_sym_sized_type_specifier_repeat1] = STATE(606),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1019),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5943),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1021),
    [anon_sym_typedef] = ACTIONS(1023),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(425),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(1027),
    [anon_sym_long] = ACTIONS(1027),
    [anon_sym_short] = ACTIONS(1027),
    [sym_primitive_type] = ACTIONS(1029),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(1031),
    [anon_sym_union] = ACTIONS(1033),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(1035),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1039),
    [sym_auto] = ACTIONS(1029),
    [anon_sym_typename] = ACTIONS(1041),
    [anon_sym_template] = ACTIONS(1043),
    [anon_sym_friend] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1039),
    [anon_sym_protected] = ACTIONS(1039),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_COLON_COLON] = ACTIONS(1049),
    [sym_operator_name] = ACTIONS(1051),
  },
  [1993] = {
    [sym_preproc_arg] = ACTIONS(5945),
    [sym_comment] = ACTIONS(121),
  },
  [1994] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5947),
    [sym_comment] = ACTIONS(91),
  },
  [1995] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(2667),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(2667),
    [sym_preproc_else_in_field_declaration_list] = STATE(2666),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2666),
    [sym_type_definition] = STATE(2667),
    [sym__declaration_specifiers] = STATE(598),
    [sym__declarator] = STATE(599),
    [sym_pointer_declarator] = STATE(599),
    [sym_function_declarator] = STATE(600),
    [sym_array_declarator] = STATE(599),
    [sym_storage_class_specifier] = STATE(605),
    [sym_type_qualifier] = STATE(605),
    [sym__type_specifier] = STATE(601),
    [sym_sized_type_specifier] = STATE(601),
    [sym_enum_specifier] = STATE(601),
    [sym_struct_specifier] = STATE(601),
    [sym_union_specifier] = STATE(601),
    [sym__field_declaration_list_item] = STATE(2667),
    [sym_field_declaration] = STATE(2667),
    [sym_macro_type_specifier] = STATE(601),
    [sym_class_specifier] = STATE(601),
    [sym_dependent_type] = STATE(601),
    [sym_template_declaration] = STATE(2667),
    [sym_inline_method_definition] = STATE(2667),
    [sym_constructor_or_destructor_definition] = STATE(2667),
    [sym_constructor_or_destructor_declaration] = STATE(2667),
    [sym_friend_declaration] = STATE(2667),
    [sym_access_specifier] = STATE(2667),
    [sym_reference_declarator] = STATE(599),
    [sym_template_type] = STATE(602),
    [sym_template_function] = STATE(599),
    [sym_using_declaration] = STATE(2667),
    [sym_alias_declaration] = STATE(2667),
    [sym_destructor_name] = STATE(599),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(603),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(2667),
    [aux_sym__declaration_specifiers_repeat1] = STATE(605),
    [aux_sym_sized_type_specifier_repeat1] = STATE(606),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1019),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5947),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4227),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4229),
    [anon_sym_typedef] = ACTIONS(1023),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(425),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(1027),
    [anon_sym_long] = ACTIONS(1027),
    [anon_sym_short] = ACTIONS(1027),
    [sym_primitive_type] = ACTIONS(1029),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(1031),
    [anon_sym_union] = ACTIONS(1033),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(1035),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1039),
    [sym_auto] = ACTIONS(1029),
    [anon_sym_typename] = ACTIONS(1041),
    [anon_sym_template] = ACTIONS(1043),
    [anon_sym_friend] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1039),
    [anon_sym_protected] = ACTIONS(1039),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_COLON_COLON] = ACTIONS(1049),
    [sym_operator_name] = ACTIONS(1051),
  },
  [1996] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5949),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5951),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5951),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5951),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5951),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5951),
    [anon_sym_typedef] = ACTIONS(5949),
    [anon_sym_extern] = ACTIONS(5949),
    [anon_sym_RBRACE] = ACTIONS(5951),
    [anon_sym_LPAREN2] = ACTIONS(5951),
    [anon_sym_STAR] = ACTIONS(5951),
    [anon_sym_static] = ACTIONS(5949),
    [anon_sym_register] = ACTIONS(5949),
    [anon_sym_inline] = ACTIONS(5949),
    [anon_sym_const] = ACTIONS(5949),
    [anon_sym_restrict] = ACTIONS(5949),
    [anon_sym_volatile] = ACTIONS(5949),
    [anon_sym__Atomic] = ACTIONS(5949),
    [anon_sym_mutable] = ACTIONS(5949),
    [anon_sym_explicit] = ACTIONS(5949),
    [anon_sym_constexpr] = ACTIONS(5949),
    [anon_sym_unsigned] = ACTIONS(5949),
    [anon_sym_long] = ACTIONS(5949),
    [anon_sym_short] = ACTIONS(5949),
    [sym_primitive_type] = ACTIONS(5949),
    [anon_sym_enum] = ACTIONS(5949),
    [anon_sym_struct] = ACTIONS(5949),
    [anon_sym_union] = ACTIONS(5949),
    [anon_sym_AMP] = ACTIONS(5949),
    [anon_sym_AMP_AMP] = ACTIONS(5951),
    [anon_sym_TILDE] = ACTIONS(5951),
    [sym_identifier] = ACTIONS(5949),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5949),
    [anon_sym_public] = ACTIONS(5949),
    [sym_auto] = ACTIONS(5949),
    [anon_sym_typename] = ACTIONS(5949),
    [anon_sym_template] = ACTIONS(5949),
    [anon_sym_friend] = ACTIONS(5949),
    [anon_sym_private] = ACTIONS(5949),
    [anon_sym_protected] = ACTIONS(5949),
    [anon_sym_using] = ACTIONS(5949),
    [anon_sym_COLON_COLON] = ACTIONS(5951),
    [sym_operator_name] = ACTIONS(5951),
  },
  [1997] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5953),
    [sym_comment] = ACTIONS(91),
  },
  [1998] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(2667),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(2667),
    [sym_preproc_else_in_field_declaration_list] = STATE(2669),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2669),
    [sym_type_definition] = STATE(2667),
    [sym__declaration_specifiers] = STATE(598),
    [sym__declarator] = STATE(599),
    [sym_pointer_declarator] = STATE(599),
    [sym_function_declarator] = STATE(600),
    [sym_array_declarator] = STATE(599),
    [sym_storage_class_specifier] = STATE(605),
    [sym_type_qualifier] = STATE(605),
    [sym__type_specifier] = STATE(601),
    [sym_sized_type_specifier] = STATE(601),
    [sym_enum_specifier] = STATE(601),
    [sym_struct_specifier] = STATE(601),
    [sym_union_specifier] = STATE(601),
    [sym__field_declaration_list_item] = STATE(2667),
    [sym_field_declaration] = STATE(2667),
    [sym_macro_type_specifier] = STATE(601),
    [sym_class_specifier] = STATE(601),
    [sym_dependent_type] = STATE(601),
    [sym_template_declaration] = STATE(2667),
    [sym_inline_method_definition] = STATE(2667),
    [sym_constructor_or_destructor_definition] = STATE(2667),
    [sym_constructor_or_destructor_declaration] = STATE(2667),
    [sym_friend_declaration] = STATE(2667),
    [sym_access_specifier] = STATE(2667),
    [sym_reference_declarator] = STATE(599),
    [sym_template_type] = STATE(602),
    [sym_template_function] = STATE(599),
    [sym_using_declaration] = STATE(2667),
    [sym_alias_declaration] = STATE(2667),
    [sym_destructor_name] = STATE(599),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(603),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(2667),
    [aux_sym__declaration_specifiers_repeat1] = STATE(605),
    [aux_sym_sized_type_specifier_repeat1] = STATE(606),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1019),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5953),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4227),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4229),
    [anon_sym_typedef] = ACTIONS(1023),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(425),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(1027),
    [anon_sym_long] = ACTIONS(1027),
    [anon_sym_short] = ACTIONS(1027),
    [sym_primitive_type] = ACTIONS(1029),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(1031),
    [anon_sym_union] = ACTIONS(1033),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(1035),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1039),
    [sym_auto] = ACTIONS(1029),
    [anon_sym_typename] = ACTIONS(1041),
    [anon_sym_template] = ACTIONS(1043),
    [anon_sym_friend] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1039),
    [anon_sym_protected] = ACTIONS(1039),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_COLON_COLON] = ACTIONS(1049),
    [sym_operator_name] = ACTIONS(1051),
  },
  [1999] = {
    [sym_parameter_list] = STATE(1105),
    [anon_sym_SEMI] = ACTIONS(5955),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [sym_comment] = ACTIONS(91),
  },
  [2000] = {
    [sym__type_declarator] = STATE(2671),
    [sym_pointer_type_declarator] = STATE(2671),
    [sym_function_type_declarator] = STATE(2671),
    [sym_array_type_declarator] = STATE(2671),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_STAR] = ACTIONS(768),
    [sym_identifier] = ACTIONS(770),
    [sym_comment] = ACTIONS(91),
  },
  [2001] = {
    [anon_sym_SEMI] = ACTIONS(3218),
    [anon_sym_extern] = ACTIONS(3216),
    [anon_sym_LPAREN2] = ACTIONS(3213),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_LBRACK] = ACTIONS(3211),
    [anon_sym_static] = ACTIONS(3216),
    [anon_sym_register] = ACTIONS(3216),
    [anon_sym_inline] = ACTIONS(3216),
    [anon_sym_const] = ACTIONS(3216),
    [anon_sym_restrict] = ACTIONS(3216),
    [anon_sym_volatile] = ACTIONS(3216),
    [anon_sym__Atomic] = ACTIONS(3216),
    [anon_sym_mutable] = ACTIONS(3216),
    [anon_sym_explicit] = ACTIONS(3216),
    [anon_sym_constexpr] = ACTIONS(3216),
    [anon_sym_COLON] = ACTIONS(3216),
    [anon_sym_AMP] = ACTIONS(3216),
    [anon_sym_AMP_AMP] = ACTIONS(3218),
    [anon_sym_LT] = ACTIONS(3213),
    [sym_identifier] = ACTIONS(3216),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(3225),
    [sym_operator_name] = ACTIONS(3218),
  },
  [2002] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3291),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3289),
    [anon_sym_typedef] = ACTIONS(3291),
    [anon_sym_extern] = ACTIONS(3291),
    [anon_sym_RBRACE] = ACTIONS(3289),
    [anon_sym_LPAREN2] = ACTIONS(3289),
    [anon_sym_STAR] = ACTIONS(3289),
    [anon_sym_static] = ACTIONS(3291),
    [anon_sym_register] = ACTIONS(3291),
    [anon_sym_inline] = ACTIONS(3291),
    [anon_sym_const] = ACTIONS(3291),
    [anon_sym_restrict] = ACTIONS(3291),
    [anon_sym_volatile] = ACTIONS(3291),
    [anon_sym__Atomic] = ACTIONS(3291),
    [anon_sym_mutable] = ACTIONS(3291),
    [anon_sym_explicit] = ACTIONS(3291),
    [anon_sym_constexpr] = ACTIONS(3291),
    [anon_sym_unsigned] = ACTIONS(3291),
    [anon_sym_long] = ACTIONS(3291),
    [anon_sym_short] = ACTIONS(3291),
    [sym_primitive_type] = ACTIONS(3291),
    [anon_sym_enum] = ACTIONS(3291),
    [anon_sym_struct] = ACTIONS(3291),
    [anon_sym_union] = ACTIONS(3291),
    [anon_sym_AMP] = ACTIONS(3291),
    [anon_sym_AMP_AMP] = ACTIONS(3289),
    [anon_sym_TILDE] = ACTIONS(3289),
    [sym_identifier] = ACTIONS(3291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3291),
    [anon_sym_public] = ACTIONS(3291),
    [sym_auto] = ACTIONS(3291),
    [anon_sym_typename] = ACTIONS(3291),
    [anon_sym_template] = ACTIONS(3291),
    [anon_sym_friend] = ACTIONS(3291),
    [anon_sym_private] = ACTIONS(3291),
    [anon_sym_protected] = ACTIONS(3291),
    [anon_sym_using] = ACTIONS(3291),
    [anon_sym_COLON_COLON] = ACTIONS(3289),
    [sym_operator_name] = ACTIONS(3289),
  },
  [2003] = {
    [sym__declarator] = STATE(2004),
    [sym_pointer_declarator] = STATE(2004),
    [sym_function_declarator] = STATE(2004),
    [sym_array_declarator] = STATE(2004),
    [sym_init_declarator] = STATE(2005),
    [sym_reference_declarator] = STATE(2004),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(2004),
    [sym_destructor_name] = STATE(2004),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [anon_sym_SEMI] = ACTIONS(5957),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(560),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(568),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(4245),
  },
  [2004] = {
    [sym_compound_statement] = STATE(2675),
    [sym_parameter_list] = STATE(897),
    [sym_argument_list] = STATE(898),
    [sym_initializer_list] = STATE(898),
    [aux_sym_declaration_repeat1] = STATE(2676),
    [anon_sym_COMMA] = ACTIONS(1613),
    [anon_sym_SEMI] = ACTIONS(5959),
    [anon_sym_LBRACE] = ACTIONS(5961),
    [anon_sym_LPAREN2] = ACTIONS(1619),
    [anon_sym_LBRACK] = ACTIONS(574),
    [anon_sym_EQ] = ACTIONS(1621),
    [sym_comment] = ACTIONS(91),
  },
  [2005] = {
    [aux_sym_declaration_repeat1] = STATE(2676),
    [anon_sym_COMMA] = ACTIONS(1613),
    [anon_sym_SEMI] = ACTIONS(5959),
    [sym_comment] = ACTIONS(91),
  },
  [2006] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5963),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5965),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5965),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5965),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5965),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5965),
    [anon_sym_typedef] = ACTIONS(5963),
    [anon_sym_extern] = ACTIONS(5963),
    [anon_sym_RBRACE] = ACTIONS(5965),
    [anon_sym_LPAREN2] = ACTIONS(5965),
    [anon_sym_STAR] = ACTIONS(5965),
    [anon_sym_static] = ACTIONS(5963),
    [anon_sym_register] = ACTIONS(5963),
    [anon_sym_inline] = ACTIONS(5963),
    [anon_sym_const] = ACTIONS(5963),
    [anon_sym_restrict] = ACTIONS(5963),
    [anon_sym_volatile] = ACTIONS(5963),
    [anon_sym__Atomic] = ACTIONS(5963),
    [anon_sym_mutable] = ACTIONS(5963),
    [anon_sym_explicit] = ACTIONS(5963),
    [anon_sym_constexpr] = ACTIONS(5963),
    [anon_sym_unsigned] = ACTIONS(5963),
    [anon_sym_long] = ACTIONS(5963),
    [anon_sym_short] = ACTIONS(5963),
    [sym_primitive_type] = ACTIONS(5963),
    [anon_sym_enum] = ACTIONS(5963),
    [anon_sym_struct] = ACTIONS(5963),
    [anon_sym_union] = ACTIONS(5963),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_AMP_AMP] = ACTIONS(5965),
    [anon_sym_TILDE] = ACTIONS(5965),
    [sym_identifier] = ACTIONS(5963),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5963),
    [anon_sym_public] = ACTIONS(5963),
    [sym_auto] = ACTIONS(5963),
    [anon_sym_typename] = ACTIONS(5963),
    [anon_sym_template] = ACTIONS(5963),
    [anon_sym_friend] = ACTIONS(5963),
    [anon_sym_private] = ACTIONS(5963),
    [anon_sym_protected] = ACTIONS(5963),
    [anon_sym_using] = ACTIONS(5963),
    [anon_sym_COLON_COLON] = ACTIONS(5965),
    [sym_operator_name] = ACTIONS(5965),
  },
  [2007] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3330),
    [anon_sym_typedef] = ACTIONS(3332),
    [anon_sym_extern] = ACTIONS(3332),
    [anon_sym_RBRACE] = ACTIONS(3330),
    [anon_sym_LPAREN2] = ACTIONS(3330),
    [anon_sym_STAR] = ACTIONS(3330),
    [anon_sym_static] = ACTIONS(3332),
    [anon_sym_register] = ACTIONS(3332),
    [anon_sym_inline] = ACTIONS(3332),
    [anon_sym_const] = ACTIONS(3332),
    [anon_sym_restrict] = ACTIONS(3332),
    [anon_sym_volatile] = ACTIONS(3332),
    [anon_sym__Atomic] = ACTIONS(3332),
    [anon_sym_mutable] = ACTIONS(3332),
    [anon_sym_explicit] = ACTIONS(3332),
    [anon_sym_constexpr] = ACTIONS(3332),
    [anon_sym_unsigned] = ACTIONS(3332),
    [anon_sym_long] = ACTIONS(3332),
    [anon_sym_short] = ACTIONS(3332),
    [sym_primitive_type] = ACTIONS(3332),
    [anon_sym_enum] = ACTIONS(3332),
    [anon_sym_struct] = ACTIONS(3332),
    [anon_sym_union] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(3332),
    [anon_sym_AMP_AMP] = ACTIONS(3330),
    [anon_sym_TILDE] = ACTIONS(3330),
    [sym_identifier] = ACTIONS(3332),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3332),
    [anon_sym_public] = ACTIONS(3332),
    [sym_auto] = ACTIONS(3332),
    [anon_sym_typename] = ACTIONS(3332),
    [anon_sym_template] = ACTIONS(3332),
    [anon_sym_friend] = ACTIONS(3332),
    [anon_sym_private] = ACTIONS(3332),
    [anon_sym_protected] = ACTIONS(3332),
    [anon_sym_using] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(3330),
    [sym_operator_name] = ACTIONS(3330),
  },
  [2008] = {
    [sym_type_qualifier] = STATE(1574),
    [sym__type_specifier] = STATE(1572),
    [sym_sized_type_specifier] = STATE(1572),
    [sym_enum_specifier] = STATE(1572),
    [sym_struct_specifier] = STATE(1572),
    [sym_union_specifier] = STATE(1572),
    [sym_type_descriptor] = STATE(2677),
    [sym_macro_type_specifier] = STATE(1572),
    [sym_class_specifier] = STATE(1572),
    [sym_dependent_type] = STATE(1572),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_type_definition_repeat1] = STATE(1574),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1575),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(3334),
    [anon_sym_long] = ACTIONS(3334),
    [anon_sym_short] = ACTIONS(3334),
    [sym_primitive_type] = ACTIONS(3336),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(3336),
    [anon_sym_typename] = ACTIONS(3338),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [2009] = {
    [sym_template_argument_list] = STATE(437),
    [anon_sym_SEMI] = ACTIONS(5967),
    [anon_sym_LT] = ACTIONS(945),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1519),
  },
  [2010] = {
    [anon_sym_SEMI] = ACTIONS(5967),
    [sym_comment] = ACTIONS(91),
  },
  [2011] = {
    [sym__field_declarator] = STATE(2679),
    [sym_pointer_field_declarator] = STATE(2679),
    [sym_function_field_declarator] = STATE(2679),
    [sym_array_field_declarator] = STATE(2679),
    [sym_type_qualifier] = STATE(2680),
    [sym_reference_field_declarator] = STATE(2679),
    [sym_template_type] = STATE(953),
    [sym_template_method] = STATE(2679),
    [sym_scoped_field_identifier] = STATE(955),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(953),
    [aux_sym_type_definition_repeat1] = STATE(2680),
    [anon_sym_LPAREN2] = ACTIONS(2655),
    [anon_sym_STAR] = ACTIONS(4259),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(4261),
    [anon_sym_AMP_AMP] = ACTIONS(4263),
    [sym_identifier] = ACTIONS(2665),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1755),
    [sym_operator_name] = ACTIONS(5969),
  },
  [2012] = {
    [sym__field_declarator] = STATE(2681),
    [sym_pointer_field_declarator] = STATE(2681),
    [sym_function_field_declarator] = STATE(2681),
    [sym_array_field_declarator] = STATE(2681),
    [sym_reference_field_declarator] = STATE(2681),
    [sym_template_type] = STATE(953),
    [sym_template_method] = STATE(2681),
    [sym_scoped_field_identifier] = STATE(955),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(953),
    [anon_sym_LPAREN2] = ACTIONS(2655),
    [anon_sym_STAR] = ACTIONS(4259),
    [anon_sym_AMP] = ACTIONS(4261),
    [anon_sym_AMP_AMP] = ACTIONS(4263),
    [sym_identifier] = ACTIONS(2665),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1755),
    [sym_operator_name] = ACTIONS(5971),
  },
  [2013] = {
    [sym_parameter_list] = STATE(2683),
    [anon_sym_RPAREN] = ACTIONS(5973),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [sym_comment] = ACTIONS(91),
  },
  [2014] = {
    [sym_parameter_list] = STATE(2024),
    [anon_sym_COMMA] = ACTIONS(5975),
    [anon_sym_SEMI] = ACTIONS(5975),
    [anon_sym_LBRACE] = ACTIONS(5975),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_EQ] = ACTIONS(5975),
    [anon_sym_COLON] = ACTIONS(5975),
    [sym_comment] = ACTIONS(91),
  },
  [2015] = {
    [sym__field_declarator] = STATE(2684),
    [sym_pointer_field_declarator] = STATE(2684),
    [sym_function_field_declarator] = STATE(2684),
    [sym_array_field_declarator] = STATE(2684),
    [sym_type_qualifier] = STATE(2685),
    [sym_reference_field_declarator] = STATE(2684),
    [sym_template_type] = STATE(953),
    [sym_template_method] = STATE(2684),
    [sym_scoped_field_identifier] = STATE(1266),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(953),
    [aux_sym_type_definition_repeat1] = STATE(2685),
    [anon_sym_LPAREN2] = ACTIONS(2655),
    [anon_sym_STAR] = ACTIONS(2657),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(2661),
    [anon_sym_AMP_AMP] = ACTIONS(2663),
    [sym_identifier] = ACTIONS(2665),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1755),
    [sym_operator_name] = ACTIONS(5977),
  },
  [2016] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(5979),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2017] = {
    [sym_parameter_list] = STATE(2024),
    [anon_sym_COMMA] = ACTIONS(5981),
    [anon_sym_SEMI] = ACTIONS(5981),
    [anon_sym_LBRACE] = ACTIONS(5981),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_EQ] = ACTIONS(5981),
    [anon_sym_COLON] = ACTIONS(5981),
    [sym_comment] = ACTIONS(91),
  },
  [2018] = {
    [sym__field_declarator] = STATE(2689),
    [sym_pointer_field_declarator] = STATE(2689),
    [sym_function_field_declarator] = STATE(2689),
    [sym_array_field_declarator] = STATE(2689),
    [sym_reference_field_declarator] = STATE(2689),
    [sym_template_type] = STATE(953),
    [sym_template_method] = STATE(2689),
    [sym_scoped_field_identifier] = STATE(1266),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(953),
    [anon_sym_LPAREN2] = ACTIONS(2655),
    [anon_sym_STAR] = ACTIONS(5983),
    [anon_sym_AMP] = ACTIONS(5985),
    [anon_sym_AMP_AMP] = ACTIONS(5987),
    [sym_identifier] = ACTIONS(2665),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1755),
    [sym_operator_name] = ACTIONS(5989),
  },
  [2019] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5991),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5993),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5993),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5993),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5993),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5993),
    [anon_sym_typedef] = ACTIONS(5991),
    [anon_sym_extern] = ACTIONS(5991),
    [anon_sym_RBRACE] = ACTIONS(5993),
    [anon_sym_LPAREN2] = ACTIONS(5993),
    [anon_sym_STAR] = ACTIONS(5993),
    [anon_sym_static] = ACTIONS(5991),
    [anon_sym_register] = ACTIONS(5991),
    [anon_sym_inline] = ACTIONS(5991),
    [anon_sym_const] = ACTIONS(5991),
    [anon_sym_restrict] = ACTIONS(5991),
    [anon_sym_volatile] = ACTIONS(5991),
    [anon_sym__Atomic] = ACTIONS(5991),
    [anon_sym_mutable] = ACTIONS(5991),
    [anon_sym_explicit] = ACTIONS(5991),
    [anon_sym_constexpr] = ACTIONS(5991),
    [anon_sym_unsigned] = ACTIONS(5991),
    [anon_sym_long] = ACTIONS(5991),
    [anon_sym_short] = ACTIONS(5991),
    [sym_primitive_type] = ACTIONS(5991),
    [anon_sym_enum] = ACTIONS(5991),
    [anon_sym_struct] = ACTIONS(5991),
    [anon_sym_union] = ACTIONS(5991),
    [anon_sym_AMP] = ACTIONS(5991),
    [anon_sym_AMP_AMP] = ACTIONS(5993),
    [anon_sym_TILDE] = ACTIONS(5993),
    [sym_identifier] = ACTIONS(5991),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5991),
    [anon_sym_public] = ACTIONS(5991),
    [sym_auto] = ACTIONS(5991),
    [anon_sym_typename] = ACTIONS(5991),
    [anon_sym_template] = ACTIONS(5991),
    [anon_sym_friend] = ACTIONS(5991),
    [anon_sym_private] = ACTIONS(5991),
    [anon_sym_protected] = ACTIONS(5991),
    [anon_sym_using] = ACTIONS(5991),
    [anon_sym_COLON_COLON] = ACTIONS(5993),
    [sym_operator_name] = ACTIONS(5993),
  },
  [2020] = {
    [sym_type_qualifier] = STATE(2693),
    [sym__expression] = STATE(2692),
    [sym_conditional_expression] = STATE(2692),
    [sym_assignment_expression] = STATE(2692),
    [sym_pointer_expression] = STATE(2692),
    [sym_logical_expression] = STATE(2692),
    [sym_bitwise_expression] = STATE(2692),
    [sym_equality_expression] = STATE(2692),
    [sym_relational_expression] = STATE(2692),
    [sym_shift_expression] = STATE(2692),
    [sym_math_expression] = STATE(2692),
    [sym_cast_expression] = STATE(2692),
    [sym_sizeof_expression] = STATE(2692),
    [sym_subscript_expression] = STATE(2692),
    [sym_call_expression] = STATE(2692),
    [sym_field_expression] = STATE(2692),
    [sym_compound_literal_expression] = STATE(2692),
    [sym_parenthesized_expression] = STATE(2692),
    [sym_char_literal] = STATE(2692),
    [sym_concatenated_string] = STATE(2692),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2692),
    [sym_new_expression] = STATE(2692),
    [sym_delete_expression] = STATE(2692),
    [sym_lambda_expression] = STATE(2692),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [aux_sym_type_definition_repeat1] = STATE(2693),
    [sym_raw_string_literal] = ACTIONS(5995),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(5997),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(5999),
    [anon_sym_const] = ACTIONS(1643),
    [anon_sym_restrict] = ACTIONS(1643),
    [anon_sym_volatile] = ACTIONS(1643),
    [anon_sym__Atomic] = ACTIONS(1643),
    [anon_sym_mutable] = ACTIONS(1643),
    [anon_sym_explicit] = ACTIONS(1643),
    [anon_sym_constexpr] = ACTIONS(1643),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(5995),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6001),
    [sym_false] = ACTIONS(6001),
    [sym_null] = ACTIONS(6001),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(6001),
  },
  [2021] = {
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(4303),
  },
  [2022] = {
    [sym__expression] = STATE(2694),
    [sym_conditional_expression] = STATE(2694),
    [sym_assignment_expression] = STATE(2694),
    [sym_pointer_expression] = STATE(2694),
    [sym_logical_expression] = STATE(2694),
    [sym_bitwise_expression] = STATE(2694),
    [sym_equality_expression] = STATE(2694),
    [sym_relational_expression] = STATE(2694),
    [sym_shift_expression] = STATE(2694),
    [sym_math_expression] = STATE(2694),
    [sym_cast_expression] = STATE(2694),
    [sym_sizeof_expression] = STATE(2694),
    [sym_subscript_expression] = STATE(2694),
    [sym_call_expression] = STATE(2694),
    [sym_field_expression] = STATE(2694),
    [sym_compound_literal_expression] = STATE(2694),
    [sym_parenthesized_expression] = STATE(2694),
    [sym_char_literal] = STATE(2694),
    [sym_concatenated_string] = STATE(2694),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2694),
    [sym_new_expression] = STATE(2694),
    [sym_delete_expression] = STATE(2694),
    [sym_lambda_expression] = STATE(2694),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6003),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(6003),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6005),
    [sym_false] = ACTIONS(6005),
    [sym_null] = ACTIONS(6005),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(6005),
  },
  [2023] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6007),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6009),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6009),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6009),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6009),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6009),
    [anon_sym_typedef] = ACTIONS(6007),
    [anon_sym_extern] = ACTIONS(6007),
    [anon_sym_RBRACE] = ACTIONS(6009),
    [anon_sym_LPAREN2] = ACTIONS(6009),
    [anon_sym_STAR] = ACTIONS(6009),
    [anon_sym_static] = ACTIONS(6007),
    [anon_sym_register] = ACTIONS(6007),
    [anon_sym_inline] = ACTIONS(6007),
    [anon_sym_const] = ACTIONS(6007),
    [anon_sym_restrict] = ACTIONS(6007),
    [anon_sym_volatile] = ACTIONS(6007),
    [anon_sym__Atomic] = ACTIONS(6007),
    [anon_sym_mutable] = ACTIONS(6007),
    [anon_sym_explicit] = ACTIONS(6007),
    [anon_sym_constexpr] = ACTIONS(6007),
    [anon_sym_unsigned] = ACTIONS(6007),
    [anon_sym_long] = ACTIONS(6007),
    [anon_sym_short] = ACTIONS(6007),
    [sym_primitive_type] = ACTIONS(6007),
    [anon_sym_enum] = ACTIONS(6007),
    [anon_sym_struct] = ACTIONS(6007),
    [anon_sym_union] = ACTIONS(6007),
    [anon_sym_AMP] = ACTIONS(6007),
    [anon_sym_AMP_AMP] = ACTIONS(6009),
    [anon_sym_TILDE] = ACTIONS(6009),
    [sym_identifier] = ACTIONS(6007),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6007),
    [anon_sym_public] = ACTIONS(6007),
    [sym_auto] = ACTIONS(6007),
    [anon_sym_typename] = ACTIONS(6007),
    [anon_sym_template] = ACTIONS(6007),
    [anon_sym_friend] = ACTIONS(6007),
    [anon_sym_private] = ACTIONS(6007),
    [anon_sym_protected] = ACTIONS(6007),
    [anon_sym_using] = ACTIONS(6007),
    [anon_sym_COLON_COLON] = ACTIONS(6009),
    [sym_operator_name] = ACTIONS(6009),
  },
  [2024] = {
    [sym_type_qualifier] = STATE(2696),
    [sym_virtual_specifier] = STATE(2696),
    [sym_trailing_return_type] = STATE(2696),
    [aux_sym_function_declarator_repeat1] = STATE(2696),
    [anon_sym_COMMA] = ACTIONS(6011),
    [anon_sym_SEMI] = ACTIONS(6011),
    [anon_sym_LBRACE] = ACTIONS(6011),
    [anon_sym_LPAREN2] = ACTIONS(6011),
    [anon_sym_LBRACK] = ACTIONS(6011),
    [anon_sym_EQ] = ACTIONS(6011),
    [anon_sym_const] = ACTIONS(1667),
    [anon_sym_restrict] = ACTIONS(1669),
    [anon_sym_volatile] = ACTIONS(1669),
    [anon_sym__Atomic] = ACTIONS(1669),
    [anon_sym_mutable] = ACTIONS(1669),
    [anon_sym_explicit] = ACTIONS(1669),
    [anon_sym_constexpr] = ACTIONS(1669),
    [anon_sym_COLON] = ACTIONS(6011),
    [anon_sym_DASH_GT] = ACTIONS(6013),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [sym_noexcept] = ACTIONS(6015),
  },
  [2025] = {
    [aux_sym_field_declaration_repeat1] = STATE(2698),
    [anon_sym_COMMA] = ACTIONS(4279),
    [anon_sym_SEMI] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(6017),
    [sym_comment] = ACTIONS(91),
  },
  [2026] = {
    [sym__type_specifier] = STATE(2700),
    [sym_sized_type_specifier] = STATE(2700),
    [sym_enum_specifier] = STATE(2700),
    [sym_struct_specifier] = STATE(2700),
    [sym_union_specifier] = STATE(2700),
    [sym_macro_type_specifier] = STATE(2700),
    [sym_class_specifier] = STATE(2700),
    [sym_dependent_type] = STATE(2700),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(1691),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2701),
    [anon_sym_unsigned] = ACTIONS(6019),
    [anon_sym_long] = ACTIONS(6019),
    [anon_sym_short] = ACTIONS(6019),
    [sym_primitive_type] = ACTIONS(6021),
    [anon_sym_enum] = ACTIONS(3539),
    [anon_sym_struct] = ACTIONS(3541),
    [anon_sym_union] = ACTIONS(3543),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3545),
    [sym_auto] = ACTIONS(6021),
    [anon_sym_typename] = ACTIONS(6023),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [2027] = {
    [sym_type_qualifier] = STATE(2702),
    [sym_virtual_specifier] = STATE(2702),
    [sym_trailing_return_type] = STATE(2702),
    [aux_sym_function_declarator_repeat1] = STATE(2702),
    [anon_sym_SEMI] = ACTIONS(3549),
    [anon_sym_LBRACE] = ACTIONS(3549),
    [anon_sym_LPAREN2] = ACTIONS(3549),
    [anon_sym_LBRACK] = ACTIONS(3549),
    [anon_sym_EQ] = ACTIONS(3549),
    [anon_sym_const] = ACTIONS(1667),
    [anon_sym_restrict] = ACTIONS(1669),
    [anon_sym_volatile] = ACTIONS(1669),
    [anon_sym__Atomic] = ACTIONS(1669),
    [anon_sym_mutable] = ACTIONS(1669),
    [anon_sym_explicit] = ACTIONS(1669),
    [anon_sym_constexpr] = ACTIONS(1669),
    [anon_sym_COLON] = ACTIONS(3549),
    [anon_sym_DASH_GT] = ACTIONS(4291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [sym_noexcept] = ACTIONS(6025),
  },
  [2028] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(801),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(801),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(801),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(801),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(801),
    [anon_sym_typedef] = ACTIONS(803),
    [anon_sym_extern] = ACTIONS(803),
    [anon_sym_RBRACE] = ACTIONS(801),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(801),
    [anon_sym_static] = ACTIONS(803),
    [anon_sym_register] = ACTIONS(803),
    [anon_sym_inline] = ACTIONS(803),
    [anon_sym_const] = ACTIONS(803),
    [anon_sym_restrict] = ACTIONS(803),
    [anon_sym_volatile] = ACTIONS(803),
    [anon_sym__Atomic] = ACTIONS(803),
    [anon_sym_mutable] = ACTIONS(803),
    [anon_sym_explicit] = ACTIONS(803),
    [anon_sym_constexpr] = ACTIONS(803),
    [anon_sym_unsigned] = ACTIONS(803),
    [anon_sym_long] = ACTIONS(803),
    [anon_sym_short] = ACTIONS(803),
    [sym_primitive_type] = ACTIONS(803),
    [anon_sym_enum] = ACTIONS(803),
    [anon_sym_struct] = ACTIONS(803),
    [anon_sym_union] = ACTIONS(803),
    [anon_sym_AMP] = ACTIONS(803),
    [anon_sym_AMP_AMP] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(801),
    [sym_identifier] = ACTIONS(803),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(803),
    [sym_auto] = ACTIONS(803),
    [anon_sym_typename] = ACTIONS(803),
    [anon_sym_template] = ACTIONS(803),
    [anon_sym_friend] = ACTIONS(803),
    [anon_sym_private] = ACTIONS(803),
    [anon_sym_protected] = ACTIONS(803),
    [anon_sym_using] = ACTIONS(803),
    [anon_sym_COLON_COLON] = ACTIONS(801),
    [sym_operator_name] = ACTIONS(801),
  },
  [2029] = {
    [sym_preproc_include] = STATE(496),
    [sym_preproc_def] = STATE(496),
    [sym_preproc_function_def] = STATE(496),
    [sym_preproc_call] = STATE(496),
    [sym_preproc_if_in_compound_statement] = STATE(496),
    [sym_preproc_ifdef_in_compound_statement] = STATE(496),
    [sym_declaration] = STATE(496),
    [sym_type_definition] = STATE(496),
    [sym__declaration_specifiers] = STATE(113),
    [sym_compound_statement] = STATE(496),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(496),
    [sym_expression_statement] = STATE(496),
    [sym_if_statement] = STATE(496),
    [sym_switch_statement] = STATE(496),
    [sym_case_statement] = STATE(496),
    [sym_while_statement] = STATE(496),
    [sym_do_statement] = STATE(496),
    [sym_for_statement] = STATE(496),
    [sym_return_statement] = STATE(496),
    [sym_break_statement] = STATE(496),
    [sym_continue_statement] = STATE(496),
    [sym_goto_statement] = STATE(496),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(496),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(496),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(496),
    [sym_try_statement] = STATE(496),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(496),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(157),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(159),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(161),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(163),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(165),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(165),
    [sym_preproc_directive] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_typedef] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_RBRACE] = ACTIONS(6027),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(185),
    [anon_sym_case] = ACTIONS(187),
    [anon_sym_default] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(209),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_nullptr] = ACTIONS(207),
  },
  [2030] = {
    [anon_sym_SEMI] = ACTIONS(6029),
    [sym_comment] = ACTIONS(91),
  },
  [2031] = {
    [anon_sym_SEMI] = ACTIONS(6031),
    [sym_comment] = ACTIONS(91),
  },
  [2032] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3571),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3569),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3569),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3569),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3569),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3569),
    [anon_sym_typedef] = ACTIONS(3571),
    [anon_sym_extern] = ACTIONS(3571),
    [anon_sym_RBRACE] = ACTIONS(3569),
    [anon_sym_LPAREN2] = ACTIONS(3569),
    [anon_sym_STAR] = ACTIONS(3569),
    [anon_sym_static] = ACTIONS(3571),
    [anon_sym_register] = ACTIONS(3571),
    [anon_sym_inline] = ACTIONS(3571),
    [anon_sym_const] = ACTIONS(3571),
    [anon_sym_restrict] = ACTIONS(3571),
    [anon_sym_volatile] = ACTIONS(3571),
    [anon_sym__Atomic] = ACTIONS(3571),
    [anon_sym_mutable] = ACTIONS(3571),
    [anon_sym_explicit] = ACTIONS(3571),
    [anon_sym_constexpr] = ACTIONS(3571),
    [anon_sym_unsigned] = ACTIONS(3571),
    [anon_sym_long] = ACTIONS(3571),
    [anon_sym_short] = ACTIONS(3571),
    [sym_primitive_type] = ACTIONS(3571),
    [anon_sym_enum] = ACTIONS(3571),
    [anon_sym_struct] = ACTIONS(3571),
    [anon_sym_union] = ACTIONS(3571),
    [anon_sym_AMP] = ACTIONS(3571),
    [anon_sym_AMP_AMP] = ACTIONS(3569),
    [anon_sym_TILDE] = ACTIONS(3569),
    [sym_identifier] = ACTIONS(3571),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3571),
    [anon_sym_public] = ACTIONS(3571),
    [sym_auto] = ACTIONS(3571),
    [anon_sym_typename] = ACTIONS(3571),
    [anon_sym_template] = ACTIONS(3571),
    [anon_sym_friend] = ACTIONS(3571),
    [anon_sym_private] = ACTIONS(3571),
    [anon_sym_protected] = ACTIONS(3571),
    [anon_sym_using] = ACTIONS(3571),
    [anon_sym_COLON_COLON] = ACTIONS(3569),
    [sym_operator_name] = ACTIONS(3569),
  },
  [2033] = {
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [anon_sym_SEMI] = ACTIONS(1970),
    [anon_sym_extern] = ACTIONS(1967),
    [anon_sym_LPAREN2] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(1970),
    [anon_sym_static] = ACTIONS(1967),
    [anon_sym_register] = ACTIONS(1967),
    [anon_sym_inline] = ACTIONS(1967),
    [anon_sym_const] = ACTIONS(1972),
    [anon_sym_restrict] = ACTIONS(1972),
    [anon_sym_volatile] = ACTIONS(1972),
    [anon_sym__Atomic] = ACTIONS(1972),
    [anon_sym_mutable] = ACTIONS(1972),
    [anon_sym_explicit] = ACTIONS(1972),
    [anon_sym_constexpr] = ACTIONS(1972),
    [anon_sym_COLON] = ACTIONS(1975),
    [anon_sym_AMP] = ACTIONS(1975),
    [anon_sym_AMP_AMP] = ACTIONS(1970),
    [sym_identifier] = ACTIONS(1975),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1970),
    [sym_operator_name] = ACTIONS(1970),
  },
  [2034] = {
    [anon_sym_SEMI] = ACTIONS(3636),
    [anon_sym_extern] = ACTIONS(3634),
    [anon_sym_LPAREN2] = ACTIONS(3631),
    [anon_sym_STAR] = ACTIONS(3636),
    [anon_sym_LBRACK] = ACTIONS(3629),
    [anon_sym_static] = ACTIONS(3634),
    [anon_sym_register] = ACTIONS(3634),
    [anon_sym_inline] = ACTIONS(3634),
    [anon_sym_const] = ACTIONS(3634),
    [anon_sym_restrict] = ACTIONS(3634),
    [anon_sym_volatile] = ACTIONS(3634),
    [anon_sym__Atomic] = ACTIONS(3634),
    [anon_sym_mutable] = ACTIONS(3634),
    [anon_sym_explicit] = ACTIONS(3634),
    [anon_sym_constexpr] = ACTIONS(3634),
    [anon_sym_COLON] = ACTIONS(3634),
    [anon_sym_AMP] = ACTIONS(3634),
    [anon_sym_AMP_AMP] = ACTIONS(3636),
    [anon_sym_LT] = ACTIONS(3631),
    [sym_identifier] = ACTIONS(3634),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(3643),
    [sym_operator_name] = ACTIONS(3636),
  },
  [2035] = {
    [sym_compound_statement] = STATE(2706),
    [sym_default_method_clause] = STATE(2706),
    [sym_delete_method_clause] = STATE(2706),
    [anon_sym_LBRACE] = ACTIONS(2671),
    [anon_sym_EQ] = ACTIONS(2673),
    [sym_comment] = ACTIONS(91),
  },
  [2036] = {
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [anon_sym_SEMI] = ACTIONS(3695),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_LPAREN2] = ACTIONS(3695),
    [anon_sym_STAR] = ACTIONS(3695),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_COLON] = ACTIONS(3697),
    [anon_sym_AMP] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3695),
    [sym_identifier] = ACTIONS(3697),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(3695),
    [sym_operator_name] = ACTIONS(3695),
  },
  [2037] = {
    [sym_template_argument_list] = STATE(437),
    [anon_sym_COMMA] = ACTIONS(6033),
    [anon_sym_LBRACE] = ACTIONS(6033),
    [anon_sym_LT] = ACTIONS(945),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(758),
  },
  [2038] = {
    [sym_template_type] = STATE(2708),
    [sym_scoped_type_identifier] = STATE(2709),
    [sym_scoped_namespace_identifier] = STATE(83),
    [sym_identifier] = ACTIONS(6035),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [2039] = {
    [anon_sym_COMMA] = ACTIONS(6037),
    [anon_sym_LBRACE] = ACTIONS(6037),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(772),
  },
  [2040] = {
    [sym_template_argument_list] = STATE(362),
    [anon_sym_COMMA] = ACTIONS(6037),
    [anon_sym_LBRACE] = ACTIONS(6037),
    [anon_sym_LT] = ACTIONS(945),
    [sym_comment] = ACTIONS(91),
  },
  [2041] = {
    [aux_sym_base_class_clause_repeat1] = STATE(2041),
    [anon_sym_COMMA] = ACTIONS(6039),
    [anon_sym_LBRACE] = ACTIONS(6037),
    [sym_comment] = ACTIONS(91),
  },
  [2042] = {
    [aux_sym_base_class_clause_repeat1] = STATE(2041),
    [anon_sym_COMMA] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(6042),
    [sym_comment] = ACTIONS(91),
  },
  [2043] = {
    [aux_sym_base_class_clause_repeat1] = STATE(2041),
    [anon_sym_COMMA] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(6044),
    [sym_comment] = ACTIONS(91),
  },
  [2044] = {
    [anon_sym_COMMA] = ACTIONS(6046),
    [anon_sym_RPAREN] = ACTIONS(6046),
    [anon_sym_SEMI] = ACTIONS(6046),
    [anon_sym_extern] = ACTIONS(6048),
    [anon_sym_LBRACE] = ACTIONS(6046),
    [anon_sym_LPAREN2] = ACTIONS(6046),
    [anon_sym_STAR] = ACTIONS(6046),
    [anon_sym_LBRACK] = ACTIONS(6046),
    [anon_sym_EQ] = ACTIONS(6046),
    [anon_sym_static] = ACTIONS(6048),
    [anon_sym_register] = ACTIONS(6048),
    [anon_sym_inline] = ACTIONS(6048),
    [anon_sym_const] = ACTIONS(6048),
    [anon_sym_restrict] = ACTIONS(6048),
    [anon_sym_volatile] = ACTIONS(6048),
    [anon_sym__Atomic] = ACTIONS(6048),
    [anon_sym_mutable] = ACTIONS(6048),
    [anon_sym_explicit] = ACTIONS(6048),
    [anon_sym_constexpr] = ACTIONS(6048),
    [anon_sym_COLON] = ACTIONS(6048),
    [anon_sym_AMP] = ACTIONS(6048),
    [anon_sym_AMP_AMP] = ACTIONS(6046),
    [anon_sym_TILDE] = ACTIONS(6046),
    [anon_sym_DASH_GT] = ACTIONS(6046),
    [sym_identifier] = ACTIONS(6048),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(6048),
    [anon_sym_override] = ACTIONS(6048),
    [anon_sym_GT2] = ACTIONS(6046),
    [sym_noexcept] = ACTIONS(6048),
    [anon_sym_COLON_COLON] = ACTIONS(6046),
    [sym_operator_name] = ACTIONS(6046),
  },
  [2045] = {
    [anon_sym_COMMA] = ACTIONS(6050),
    [anon_sym_RPAREN] = ACTIONS(6050),
    [anon_sym_SEMI] = ACTIONS(6050),
    [anon_sym_extern] = ACTIONS(6052),
    [anon_sym_LBRACE] = ACTIONS(6050),
    [anon_sym_LPAREN2] = ACTIONS(6050),
    [anon_sym_STAR] = ACTIONS(6050),
    [anon_sym_LBRACK] = ACTIONS(6050),
    [anon_sym_EQ] = ACTIONS(6050),
    [anon_sym_static] = ACTIONS(6052),
    [anon_sym_register] = ACTIONS(6052),
    [anon_sym_inline] = ACTIONS(6052),
    [anon_sym_const] = ACTIONS(6052),
    [anon_sym_restrict] = ACTIONS(6052),
    [anon_sym_volatile] = ACTIONS(6052),
    [anon_sym__Atomic] = ACTIONS(6052),
    [anon_sym_mutable] = ACTIONS(6052),
    [anon_sym_explicit] = ACTIONS(6052),
    [anon_sym_constexpr] = ACTIONS(6052),
    [anon_sym_COLON] = ACTIONS(6052),
    [anon_sym_AMP] = ACTIONS(6052),
    [anon_sym_AMP_AMP] = ACTIONS(6050),
    [anon_sym_TILDE] = ACTIONS(6050),
    [anon_sym_DASH_GT] = ACTIONS(6050),
    [sym_identifier] = ACTIONS(6052),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(6052),
    [anon_sym_override] = ACTIONS(6052),
    [anon_sym_GT2] = ACTIONS(6050),
    [sym_noexcept] = ACTIONS(6052),
    [anon_sym_COLON_COLON] = ACTIONS(6050),
    [sym_operator_name] = ACTIONS(6050),
  },
  [2046] = {
    [anon_sym_COMMA] = ACTIONS(6054),
    [anon_sym_RPAREN] = ACTIONS(6054),
    [anon_sym_SEMI] = ACTIONS(6054),
    [anon_sym_extern] = ACTIONS(6056),
    [anon_sym_LBRACE] = ACTIONS(6054),
    [anon_sym_LPAREN2] = ACTIONS(6054),
    [anon_sym_STAR] = ACTIONS(6054),
    [anon_sym_LBRACK] = ACTIONS(6054),
    [anon_sym_EQ] = ACTIONS(6054),
    [anon_sym_static] = ACTIONS(6056),
    [anon_sym_register] = ACTIONS(6056),
    [anon_sym_inline] = ACTIONS(6056),
    [anon_sym_const] = ACTIONS(6056),
    [anon_sym_restrict] = ACTIONS(6056),
    [anon_sym_volatile] = ACTIONS(6056),
    [anon_sym__Atomic] = ACTIONS(6056),
    [anon_sym_mutable] = ACTIONS(6056),
    [anon_sym_explicit] = ACTIONS(6056),
    [anon_sym_constexpr] = ACTIONS(6056),
    [anon_sym_COLON] = ACTIONS(6056),
    [anon_sym_AMP] = ACTIONS(6056),
    [anon_sym_AMP_AMP] = ACTIONS(6054),
    [anon_sym_TILDE] = ACTIONS(6054),
    [anon_sym_DASH_GT] = ACTIONS(6054),
    [sym_identifier] = ACTIONS(6056),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(6056),
    [anon_sym_override] = ACTIONS(6056),
    [anon_sym_GT2] = ACTIONS(6054),
    [sym_noexcept] = ACTIONS(6056),
    [anon_sym_COLON_COLON] = ACTIONS(6054),
    [sym_operator_name] = ACTIONS(6054),
  },
  [2047] = {
    [anon_sym_COMMA] = ACTIONS(6058),
    [anon_sym_RPAREN] = ACTIONS(6058),
    [anon_sym_SEMI] = ACTIONS(6058),
    [anon_sym_extern] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6058),
    [anon_sym_LPAREN2] = ACTIONS(6058),
    [anon_sym_STAR] = ACTIONS(6058),
    [anon_sym_LBRACK] = ACTIONS(6058),
    [anon_sym_EQ] = ACTIONS(6058),
    [anon_sym_static] = ACTIONS(6060),
    [anon_sym_register] = ACTIONS(6060),
    [anon_sym_inline] = ACTIONS(6060),
    [anon_sym_const] = ACTIONS(6060),
    [anon_sym_restrict] = ACTIONS(6060),
    [anon_sym_volatile] = ACTIONS(6060),
    [anon_sym__Atomic] = ACTIONS(6060),
    [anon_sym_mutable] = ACTIONS(6060),
    [anon_sym_explicit] = ACTIONS(6060),
    [anon_sym_constexpr] = ACTIONS(6060),
    [anon_sym_COLON] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6058),
    [anon_sym_TILDE] = ACTIONS(6058),
    [anon_sym_DASH_GT] = ACTIONS(6058),
    [sym_identifier] = ACTIONS(6060),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(6060),
    [anon_sym_override] = ACTIONS(6060),
    [anon_sym_GT2] = ACTIONS(6058),
    [sym_noexcept] = ACTIONS(6060),
    [anon_sym_COLON_COLON] = ACTIONS(6058),
    [sym_operator_name] = ACTIONS(6058),
  },
  [2048] = {
    [sym__expression] = STATE(1200),
    [sym_conditional_expression] = STATE(1200),
    [sym_assignment_expression] = STATE(1200),
    [sym_pointer_expression] = STATE(1200),
    [sym_logical_expression] = STATE(1200),
    [sym_bitwise_expression] = STATE(1200),
    [sym_equality_expression] = STATE(1200),
    [sym_relational_expression] = STATE(1200),
    [sym_shift_expression] = STATE(1200),
    [sym_math_expression] = STATE(1200),
    [sym_cast_expression] = STATE(1200),
    [sym_sizeof_expression] = STATE(1200),
    [sym_subscript_expression] = STATE(1200),
    [sym_call_expression] = STATE(1200),
    [sym_field_expression] = STATE(1200),
    [sym_compound_literal_expression] = STATE(1200),
    [sym_parenthesized_expression] = STATE(1200),
    [sym_initializer_list] = STATE(1201),
    [sym_char_literal] = STATE(1200),
    [sym_concatenated_string] = STATE(1200),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1200),
    [sym_new_expression] = STATE(1200),
    [sym_delete_expression] = STATE(1200),
    [sym_lambda_expression] = STATE(1200),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2523),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(2523),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2525),
    [sym_false] = ACTIONS(2525),
    [sym_null] = ACTIONS(2525),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(2525),
  },
  [2049] = {
    [anon_sym_RPAREN] = ACTIONS(6062),
    [sym_comment] = ACTIONS(91),
  },
  [2050] = {
    [sym__expression] = STATE(2711),
    [sym_conditional_expression] = STATE(2711),
    [sym_assignment_expression] = STATE(2711),
    [sym_pointer_expression] = STATE(2711),
    [sym_logical_expression] = STATE(2711),
    [sym_bitwise_expression] = STATE(2711),
    [sym_equality_expression] = STATE(2711),
    [sym_relational_expression] = STATE(2711),
    [sym_shift_expression] = STATE(2711),
    [sym_math_expression] = STATE(2711),
    [sym_cast_expression] = STATE(2711),
    [sym_sizeof_expression] = STATE(2711),
    [sym_subscript_expression] = STATE(2711),
    [sym_call_expression] = STATE(2711),
    [sym_field_expression] = STATE(2711),
    [sym_compound_literal_expression] = STATE(2711),
    [sym_parenthesized_expression] = STATE(2711),
    [sym_char_literal] = STATE(2711),
    [sym_concatenated_string] = STATE(2711),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2711),
    [sym_new_expression] = STATE(2711),
    [sym_delete_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(2711),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6064),
    [anon_sym_LPAREN2] = ACTIONS(947),
    [anon_sym_STAR] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(947),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(6064),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6066),
    [sym_false] = ACTIONS(6066),
    [sym_null] = ACTIONS(6066),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(6066),
  },
  [2051] = {
    [sym__expression] = STATE(2712),
    [sym_conditional_expression] = STATE(2712),
    [sym_assignment_expression] = STATE(2712),
    [sym_pointer_expression] = STATE(2712),
    [sym_logical_expression] = STATE(2712),
    [sym_bitwise_expression] = STATE(2712),
    [sym_equality_expression] = STATE(2712),
    [sym_relational_expression] = STATE(2712),
    [sym_shift_expression] = STATE(2712),
    [sym_math_expression] = STATE(2712),
    [sym_cast_expression] = STATE(2712),
    [sym_sizeof_expression] = STATE(2712),
    [sym_subscript_expression] = STATE(2712),
    [sym_call_expression] = STATE(2712),
    [sym_field_expression] = STATE(2712),
    [sym_compound_literal_expression] = STATE(2712),
    [sym_parenthesized_expression] = STATE(2712),
    [sym_char_literal] = STATE(2712),
    [sym_concatenated_string] = STATE(2712),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2712),
    [sym_new_expression] = STATE(2712),
    [sym_delete_expression] = STATE(2712),
    [sym_lambda_expression] = STATE(2712),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6068),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(6068),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6070),
    [sym_false] = ACTIONS(6070),
    [sym_null] = ACTIONS(6070),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(6070),
  },
  [2052] = {
    [sym_argument_list] = STATE(1610),
    [sym_initializer_list] = STATE(1610),
    [sym_new_declarator] = STATE(1611),
    [anon_sym_RPAREN] = ACTIONS(3372),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3374),
    [anon_sym_LBRACK] = ACTIONS(4418),
    [anon_sym_EQ] = ACTIONS(3374),
    [anon_sym_QMARK] = ACTIONS(3372),
    [anon_sym_STAR_EQ] = ACTIONS(3372),
    [anon_sym_SLASH_EQ] = ACTIONS(3372),
    [anon_sym_PERCENT_EQ] = ACTIONS(3372),
    [anon_sym_PLUS_EQ] = ACTIONS(3372),
    [anon_sym_DASH_EQ] = ACTIONS(3372),
    [anon_sym_LT_LT_EQ] = ACTIONS(3372),
    [anon_sym_GT_GT_EQ] = ACTIONS(3372),
    [anon_sym_AMP_EQ] = ACTIONS(3372),
    [anon_sym_CARET_EQ] = ACTIONS(3372),
    [anon_sym_PIPE_EQ] = ACTIONS(3372),
    [anon_sym_AMP] = ACTIONS(3374),
    [anon_sym_PIPE_PIPE] = ACTIONS(3372),
    [anon_sym_AMP_AMP] = ACTIONS(3372),
    [anon_sym_PIPE] = ACTIONS(3374),
    [anon_sym_CARET] = ACTIONS(3374),
    [anon_sym_EQ_EQ] = ACTIONS(3372),
    [anon_sym_BANG_EQ] = ACTIONS(3372),
    [anon_sym_LT] = ACTIONS(3374),
    [anon_sym_GT] = ACTIONS(3374),
    [anon_sym_LT_EQ] = ACTIONS(3372),
    [anon_sym_GT_EQ] = ACTIONS(3372),
    [anon_sym_LT_LT] = ACTIONS(3374),
    [anon_sym_GT_GT] = ACTIONS(3374),
    [anon_sym_PLUS] = ACTIONS(3374),
    [anon_sym_DASH] = ACTIONS(3374),
    [anon_sym_SLASH] = ACTIONS(3374),
    [anon_sym_PERCENT] = ACTIONS(3374),
    [anon_sym_DASH_DASH] = ACTIONS(3372),
    [anon_sym_PLUS_PLUS] = ACTIONS(3372),
    [anon_sym_DOT] = ACTIONS(3372),
    [anon_sym_DASH_GT] = ACTIONS(3372),
    [sym_comment] = ACTIONS(91),
  },
  [2053] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2053),
    [anon_sym_RPAREN] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(1985),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_EQ] = ACTIONS(1987),
    [anon_sym_unsigned] = ACTIONS(6072),
    [anon_sym_long] = ACTIONS(6072),
    [anon_sym_short] = ACTIONS(6072),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_QMARK] = ACTIONS(1985),
    [anon_sym_STAR_EQ] = ACTIONS(1985),
    [anon_sym_SLASH_EQ] = ACTIONS(1985),
    [anon_sym_PERCENT_EQ] = ACTIONS(1985),
    [anon_sym_PLUS_EQ] = ACTIONS(1985),
    [anon_sym_DASH_EQ] = ACTIONS(1985),
    [anon_sym_LT_LT_EQ] = ACTIONS(1985),
    [anon_sym_GT_GT_EQ] = ACTIONS(1985),
    [anon_sym_AMP_EQ] = ACTIONS(1985),
    [anon_sym_CARET_EQ] = ACTIONS(1985),
    [anon_sym_PIPE_EQ] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_PIPE_PIPE] = ACTIONS(1985),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_PIPE] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1987),
    [anon_sym_EQ_EQ] = ACTIONS(1985),
    [anon_sym_BANG_EQ] = ACTIONS(1985),
    [anon_sym_LT] = ACTIONS(1987),
    [anon_sym_GT] = ACTIONS(1987),
    [anon_sym_LT_EQ] = ACTIONS(1985),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_LT] = ACTIONS(1987),
    [anon_sym_GT_GT] = ACTIONS(1987),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_DASH] = ACTIONS(1987),
    [anon_sym_SLASH] = ACTIONS(1987),
    [anon_sym_PERCENT] = ACTIONS(1987),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DOT] = ACTIONS(1985),
    [anon_sym_DASH_GT] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [sym_comment] = ACTIONS(91),
  },
  [2054] = {
    [sym__expression] = STATE(164),
    [sym_conditional_expression] = STATE(164),
    [sym_assignment_expression] = STATE(164),
    [sym_pointer_expression] = STATE(164),
    [sym_logical_expression] = STATE(164),
    [sym_bitwise_expression] = STATE(164),
    [sym_equality_expression] = STATE(164),
    [sym_relational_expression] = STATE(164),
    [sym_shift_expression] = STATE(164),
    [sym_math_expression] = STATE(164),
    [sym_cast_expression] = STATE(164),
    [sym_sizeof_expression] = STATE(164),
    [sym_subscript_expression] = STATE(164),
    [sym_call_expression] = STATE(164),
    [sym_field_expression] = STATE(164),
    [sym_compound_literal_expression] = STATE(164),
    [sym_parenthesized_expression] = STATE(164),
    [sym_char_literal] = STATE(164),
    [sym_concatenated_string] = STATE(164),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(164),
    [sym_new_expression] = STATE(164),
    [sym_delete_expression] = STATE(164),
    [sym_lambda_expression] = STATE(164),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_lambda_default_capture] = STATE(166),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(267),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(6075),
    [anon_sym_EQ] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(267),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(289),
    [sym_false] = ACTIONS(289),
    [sym_null] = ACTIONS(289),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(289),
  },
  [2055] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(3383),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3385),
    [anon_sym_QMARK] = ACTIONS(3383),
    [anon_sym_STAR_EQ] = ACTIONS(3383),
    [anon_sym_SLASH_EQ] = ACTIONS(3383),
    [anon_sym_PERCENT_EQ] = ACTIONS(3383),
    [anon_sym_PLUS_EQ] = ACTIONS(3383),
    [anon_sym_DASH_EQ] = ACTIONS(3383),
    [anon_sym_LT_LT_EQ] = ACTIONS(3383),
    [anon_sym_GT_GT_EQ] = ACTIONS(3383),
    [anon_sym_AMP_EQ] = ACTIONS(3383),
    [anon_sym_CARET_EQ] = ACTIONS(3383),
    [anon_sym_PIPE_EQ] = ACTIONS(3383),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2056] = {
    [anon_sym_LPAREN2] = ACTIONS(6077),
    [anon_sym_constexpr] = ACTIONS(6079),
    [sym_comment] = ACTIONS(91),
  },
  [2057] = {
    [sym_parenthesized_expression] = STATE(2716),
    [anon_sym_LPAREN2] = ACTIONS(323),
    [sym_comment] = ACTIONS(91),
  },
  [2058] = {
    [sym__expression] = STATE(2717),
    [sym_conditional_expression] = STATE(2717),
    [sym_assignment_expression] = STATE(2717),
    [sym_pointer_expression] = STATE(2717),
    [sym_logical_expression] = STATE(2717),
    [sym_bitwise_expression] = STATE(2717),
    [sym_equality_expression] = STATE(2717),
    [sym_relational_expression] = STATE(2717),
    [sym_shift_expression] = STATE(2717),
    [sym_math_expression] = STATE(2717),
    [sym_cast_expression] = STATE(2717),
    [sym_sizeof_expression] = STATE(2717),
    [sym_subscript_expression] = STATE(2717),
    [sym_call_expression] = STATE(2717),
    [sym_field_expression] = STATE(2717),
    [sym_compound_literal_expression] = STATE(2717),
    [sym_parenthesized_expression] = STATE(2717),
    [sym_char_literal] = STATE(2717),
    [sym_concatenated_string] = STATE(2717),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2717),
    [sym_new_expression] = STATE(2717),
    [sym_delete_expression] = STATE(2717),
    [sym_lambda_expression] = STATE(2717),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6081),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(6081),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(6083),
    [sym_false] = ACTIONS(6083),
    [sym_null] = ACTIONS(6083),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(6083),
  },
  [2059] = {
    [anon_sym_COLON] = ACTIONS(6085),
    [sym_comment] = ACTIONS(91),
  },
  [2060] = {
    [sym_parenthesized_expression] = STATE(2719),
    [anon_sym_LPAREN2] = ACTIONS(323),
    [sym_comment] = ACTIONS(91),
  },
  [2061] = {
    [anon_sym_LPAREN2] = ACTIONS(6087),
    [sym_comment] = ACTIONS(91),
  },
  [2062] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(548),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(935),
  },
  [2063] = {
    [sym_compound_statement] = STATE(2722),
    [anon_sym_LBRACE] = ACTIONS(357),
    [sym_comment] = ACTIONS(91),
  },
  [2064] = {
    [sym_raw_string_literal] = ACTIONS(6091),
    [ts_builtin_sym_end] = ACTIONS(6091),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6093),
    [sym_preproc_directive] = ACTIONS(6093),
    [anon_sym_SEMI] = ACTIONS(6091),
    [anon_sym_typedef] = ACTIONS(6093),
    [anon_sym_extern] = ACTIONS(6093),
    [anon_sym_LBRACE] = ACTIONS(6091),
    [anon_sym_LPAREN2] = ACTIONS(6091),
    [anon_sym_STAR] = ACTIONS(6091),
    [anon_sym_LBRACK] = ACTIONS(6091),
    [anon_sym_static] = ACTIONS(6093),
    [anon_sym_register] = ACTIONS(6093),
    [anon_sym_inline] = ACTIONS(6093),
    [anon_sym_const] = ACTIONS(6093),
    [anon_sym_restrict] = ACTIONS(6093),
    [anon_sym_volatile] = ACTIONS(6093),
    [anon_sym__Atomic] = ACTIONS(6093),
    [anon_sym_mutable] = ACTIONS(6093),
    [anon_sym_explicit] = ACTIONS(6093),
    [anon_sym_constexpr] = ACTIONS(6093),
    [anon_sym_unsigned] = ACTIONS(6093),
    [anon_sym_long] = ACTIONS(6093),
    [anon_sym_short] = ACTIONS(6093),
    [sym_primitive_type] = ACTIONS(6093),
    [anon_sym_enum] = ACTIONS(6093),
    [anon_sym_struct] = ACTIONS(6093),
    [anon_sym_union] = ACTIONS(6093),
    [anon_sym_if] = ACTIONS(6093),
    [anon_sym_else] = ACTIONS(6095),
    [anon_sym_switch] = ACTIONS(6093),
    [anon_sym_case] = ACTIONS(6093),
    [anon_sym_default] = ACTIONS(6093),
    [anon_sym_while] = ACTIONS(6093),
    [anon_sym_do] = ACTIONS(6093),
    [anon_sym_for] = ACTIONS(6093),
    [anon_sym_return] = ACTIONS(6093),
    [anon_sym_break] = ACTIONS(6093),
    [anon_sym_continue] = ACTIONS(6093),
    [anon_sym_goto] = ACTIONS(6093),
    [anon_sym_AMP] = ACTIONS(6093),
    [anon_sym_AMP_AMP] = ACTIONS(6091),
    [anon_sym_BANG] = ACTIONS(6091),
    [anon_sym_TILDE] = ACTIONS(6091),
    [anon_sym_PLUS] = ACTIONS(6093),
    [anon_sym_DASH] = ACTIONS(6093),
    [anon_sym_DASH_DASH] = ACTIONS(6091),
    [anon_sym_PLUS_PLUS] = ACTIONS(6091),
    [anon_sym_sizeof] = ACTIONS(6093),
    [sym_number_literal] = ACTIONS(6091),
    [anon_sym_SQUOTE] = ACTIONS(6091),
    [anon_sym_DQUOTE] = ACTIONS(6091),
    [sym_true] = ACTIONS(6093),
    [sym_false] = ACTIONS(6093),
    [sym_null] = ACTIONS(6093),
    [sym_identifier] = ACTIONS(6093),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6093),
    [sym_auto] = ACTIONS(6093),
    [anon_sym_typename] = ACTIONS(6093),
    [anon_sym_template] = ACTIONS(6093),
    [anon_sym_delete] = ACTIONS(6093),
    [anon_sym_namespace] = ACTIONS(6093),
    [anon_sym_using] = ACTIONS(6093),
    [anon_sym_try] = ACTIONS(6093),
    [anon_sym_new] = ACTIONS(6093),
    [anon_sym_COLON_COLON] = ACTIONS(6091),
    [sym_operator_name] = ACTIONS(6091),
    [sym_nullptr] = ACTIONS(6093),
  },
  [2065] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(3581),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(3581),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2066] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_COLON] = ACTIONS(6097),
    [anon_sym_QMARK] = ACTIONS(1171),
    [anon_sym_STAR_EQ] = ACTIONS(1173),
    [anon_sym_SLASH_EQ] = ACTIONS(1173),
    [anon_sym_PERCENT_EQ] = ACTIONS(1173),
    [anon_sym_PLUS_EQ] = ACTIONS(1173),
    [anon_sym_DASH_EQ] = ACTIONS(1173),
    [anon_sym_LT_LT_EQ] = ACTIONS(1173),
    [anon_sym_GT_GT_EQ] = ACTIONS(1173),
    [anon_sym_AMP_EQ] = ACTIONS(1173),
    [anon_sym_CARET_EQ] = ACTIONS(1173),
    [anon_sym_PIPE_EQ] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_CARET] = ACTIONS(1183),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [2067] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_STAR_EQ] = ACTIONS(3585),
    [anon_sym_SLASH_EQ] = ACTIONS(3585),
    [anon_sym_PERCENT_EQ] = ACTIONS(3585),
    [anon_sym_PLUS_EQ] = ACTIONS(3585),
    [anon_sym_DASH_EQ] = ACTIONS(3585),
    [anon_sym_LT_LT_EQ] = ACTIONS(3585),
    [anon_sym_GT_GT_EQ] = ACTIONS(3585),
    [anon_sym_AMP_EQ] = ACTIONS(3585),
    [anon_sym_CARET_EQ] = ACTIONS(3585),
    [anon_sym_PIPE_EQ] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(3587),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3587),
    [anon_sym_CARET] = ACTIONS(3587),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2068] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(3589),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3591),
    [anon_sym_QMARK] = ACTIONS(3589),
    [anon_sym_STAR_EQ] = ACTIONS(3589),
    [anon_sym_SLASH_EQ] = ACTIONS(3589),
    [anon_sym_PERCENT_EQ] = ACTIONS(3589),
    [anon_sym_PLUS_EQ] = ACTIONS(3589),
    [anon_sym_DASH_EQ] = ACTIONS(3589),
    [anon_sym_LT_LT_EQ] = ACTIONS(3589),
    [anon_sym_GT_GT_EQ] = ACTIONS(3589),
    [anon_sym_AMP_EQ] = ACTIONS(3589),
    [anon_sym_CARET_EQ] = ACTIONS(3589),
    [anon_sym_PIPE_EQ] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(3589),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2069] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(3589),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3591),
    [anon_sym_QMARK] = ACTIONS(3589),
    [anon_sym_STAR_EQ] = ACTIONS(3589),
    [anon_sym_SLASH_EQ] = ACTIONS(3589),
    [anon_sym_PERCENT_EQ] = ACTIONS(3589),
    [anon_sym_PLUS_EQ] = ACTIONS(3589),
    [anon_sym_DASH_EQ] = ACTIONS(3589),
    [anon_sym_LT_LT_EQ] = ACTIONS(3589),
    [anon_sym_GT_GT_EQ] = ACTIONS(3589),
    [anon_sym_AMP_EQ] = ACTIONS(3589),
    [anon_sym_CARET_EQ] = ACTIONS(3589),
    [anon_sym_PIPE_EQ] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(3589),
    [anon_sym_AMP_AMP] = ACTIONS(3589),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2070] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_STAR_EQ] = ACTIONS(3585),
    [anon_sym_SLASH_EQ] = ACTIONS(3585),
    [anon_sym_PERCENT_EQ] = ACTIONS(3585),
    [anon_sym_PLUS_EQ] = ACTIONS(3585),
    [anon_sym_DASH_EQ] = ACTIONS(3585),
    [anon_sym_LT_LT_EQ] = ACTIONS(3585),
    [anon_sym_GT_GT_EQ] = ACTIONS(3585),
    [anon_sym_AMP_EQ] = ACTIONS(3585),
    [anon_sym_CARET_EQ] = ACTIONS(3585),
    [anon_sym_PIPE_EQ] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3587),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2071] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_STAR_EQ] = ACTIONS(3585),
    [anon_sym_SLASH_EQ] = ACTIONS(3585),
    [anon_sym_PERCENT_EQ] = ACTIONS(3585),
    [anon_sym_PLUS_EQ] = ACTIONS(3585),
    [anon_sym_DASH_EQ] = ACTIONS(3585),
    [anon_sym_LT_LT_EQ] = ACTIONS(3585),
    [anon_sym_GT_GT_EQ] = ACTIONS(3585),
    [anon_sym_AMP_EQ] = ACTIONS(3585),
    [anon_sym_CARET_EQ] = ACTIONS(3585),
    [anon_sym_PIPE_EQ] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3587),
    [anon_sym_CARET] = ACTIONS(3587),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2072] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(3593),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3595),
    [anon_sym_QMARK] = ACTIONS(3593),
    [anon_sym_STAR_EQ] = ACTIONS(3593),
    [anon_sym_SLASH_EQ] = ACTIONS(3593),
    [anon_sym_PERCENT_EQ] = ACTIONS(3593),
    [anon_sym_PLUS_EQ] = ACTIONS(3593),
    [anon_sym_DASH_EQ] = ACTIONS(3593),
    [anon_sym_LT_LT_EQ] = ACTIONS(3593),
    [anon_sym_GT_GT_EQ] = ACTIONS(3593),
    [anon_sym_AMP_EQ] = ACTIONS(3593),
    [anon_sym_CARET_EQ] = ACTIONS(3593),
    [anon_sym_PIPE_EQ] = ACTIONS(3593),
    [anon_sym_AMP] = ACTIONS(3595),
    [anon_sym_PIPE_PIPE] = ACTIONS(3593),
    [anon_sym_AMP_AMP] = ACTIONS(3593),
    [anon_sym_PIPE] = ACTIONS(3595),
    [anon_sym_CARET] = ACTIONS(3595),
    [anon_sym_EQ_EQ] = ACTIONS(3593),
    [anon_sym_BANG_EQ] = ACTIONS(3593),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2073] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(3597),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3599),
    [anon_sym_QMARK] = ACTIONS(3597),
    [anon_sym_STAR_EQ] = ACTIONS(3597),
    [anon_sym_SLASH_EQ] = ACTIONS(3597),
    [anon_sym_PERCENT_EQ] = ACTIONS(3597),
    [anon_sym_PLUS_EQ] = ACTIONS(3597),
    [anon_sym_DASH_EQ] = ACTIONS(3597),
    [anon_sym_LT_LT_EQ] = ACTIONS(3597),
    [anon_sym_GT_GT_EQ] = ACTIONS(3597),
    [anon_sym_AMP_EQ] = ACTIONS(3597),
    [anon_sym_CARET_EQ] = ACTIONS(3597),
    [anon_sym_PIPE_EQ] = ACTIONS(3597),
    [anon_sym_AMP] = ACTIONS(3599),
    [anon_sym_PIPE_PIPE] = ACTIONS(3597),
    [anon_sym_AMP_AMP] = ACTIONS(3597),
    [anon_sym_PIPE] = ACTIONS(3599),
    [anon_sym_CARET] = ACTIONS(3599),
    [anon_sym_EQ_EQ] = ACTIONS(3597),
    [anon_sym_BANG_EQ] = ACTIONS(3597),
    [anon_sym_LT] = ACTIONS(3599),
    [anon_sym_GT] = ACTIONS(3599),
    [anon_sym_LT_EQ] = ACTIONS(3597),
    [anon_sym_GT_EQ] = ACTIONS(3597),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2074] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(3601),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3603),
    [anon_sym_QMARK] = ACTIONS(3601),
    [anon_sym_STAR_EQ] = ACTIONS(3601),
    [anon_sym_SLASH_EQ] = ACTIONS(3601),
    [anon_sym_PERCENT_EQ] = ACTIONS(3601),
    [anon_sym_PLUS_EQ] = ACTIONS(3601),
    [anon_sym_DASH_EQ] = ACTIONS(3601),
    [anon_sym_LT_LT_EQ] = ACTIONS(3601),
    [anon_sym_GT_GT_EQ] = ACTIONS(3601),
    [anon_sym_AMP_EQ] = ACTIONS(3601),
    [anon_sym_CARET_EQ] = ACTIONS(3601),
    [anon_sym_PIPE_EQ] = ACTIONS(3601),
    [anon_sym_AMP] = ACTIONS(3603),
    [anon_sym_PIPE_PIPE] = ACTIONS(3601),
    [anon_sym_AMP_AMP] = ACTIONS(3601),
    [anon_sym_PIPE] = ACTIONS(3603),
    [anon_sym_CARET] = ACTIONS(3603),
    [anon_sym_EQ_EQ] = ACTIONS(3601),
    [anon_sym_BANG_EQ] = ACTIONS(3601),
    [anon_sym_LT] = ACTIONS(3603),
    [anon_sym_GT] = ACTIONS(3603),
    [anon_sym_LT_EQ] = ACTIONS(3601),
    [anon_sym_GT_EQ] = ACTIONS(3601),
    [anon_sym_LT_LT] = ACTIONS(3603),
    [anon_sym_GT_GT] = ACTIONS(3603),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2075] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(3575),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3577),
    [anon_sym_QMARK] = ACTIONS(3575),
    [anon_sym_STAR_EQ] = ACTIONS(3575),
    [anon_sym_SLASH_EQ] = ACTIONS(3575),
    [anon_sym_PERCENT_EQ] = ACTIONS(3575),
    [anon_sym_PLUS_EQ] = ACTIONS(3575),
    [anon_sym_DASH_EQ] = ACTIONS(3575),
    [anon_sym_LT_LT_EQ] = ACTIONS(3575),
    [anon_sym_GT_GT_EQ] = ACTIONS(3575),
    [anon_sym_AMP_EQ] = ACTIONS(3575),
    [anon_sym_CARET_EQ] = ACTIONS(3575),
    [anon_sym_PIPE_EQ] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_PIPE_PIPE] = ACTIONS(3575),
    [anon_sym_AMP_AMP] = ACTIONS(3575),
    [anon_sym_PIPE] = ACTIONS(3577),
    [anon_sym_CARET] = ACTIONS(3577),
    [anon_sym_EQ_EQ] = ACTIONS(3575),
    [anon_sym_BANG_EQ] = ACTIONS(3575),
    [anon_sym_LT] = ACTIONS(3577),
    [anon_sym_GT] = ACTIONS(3577),
    [anon_sym_LT_EQ] = ACTIONS(3575),
    [anon_sym_GT_EQ] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3577),
    [anon_sym_GT_GT] = ACTIONS(3577),
    [anon_sym_PLUS] = ACTIONS(3577),
    [anon_sym_DASH] = ACTIONS(3577),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2076] = {
    [sym_string_literal] = STATE(2076),
    [aux_sym_concatenated_string_repeat1] = STATE(2076),
    [anon_sym_RPAREN] = ACTIONS(3622),
    [anon_sym_LPAREN2] = ACTIONS(3622),
    [anon_sym_STAR] = ACTIONS(3624),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_EQ] = ACTIONS(3624),
    [anon_sym_QMARK] = ACTIONS(3622),
    [anon_sym_STAR_EQ] = ACTIONS(3622),
    [anon_sym_SLASH_EQ] = ACTIONS(3622),
    [anon_sym_PERCENT_EQ] = ACTIONS(3622),
    [anon_sym_PLUS_EQ] = ACTIONS(3622),
    [anon_sym_DASH_EQ] = ACTIONS(3622),
    [anon_sym_LT_LT_EQ] = ACTIONS(3622),
    [anon_sym_GT_GT_EQ] = ACTIONS(3622),
    [anon_sym_AMP_EQ] = ACTIONS(3622),
    [anon_sym_CARET_EQ] = ACTIONS(3622),
    [anon_sym_PIPE_EQ] = ACTIONS(3622),
    [anon_sym_AMP] = ACTIONS(3624),
    [anon_sym_PIPE_PIPE] = ACTIONS(3622),
    [anon_sym_AMP_AMP] = ACTIONS(3622),
    [anon_sym_PIPE] = ACTIONS(3624),
    [anon_sym_CARET] = ACTIONS(3624),
    [anon_sym_EQ_EQ] = ACTIONS(3622),
    [anon_sym_BANG_EQ] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3624),
    [anon_sym_GT] = ACTIONS(3624),
    [anon_sym_LT_EQ] = ACTIONS(3622),
    [anon_sym_GT_EQ] = ACTIONS(3622),
    [anon_sym_LT_LT] = ACTIONS(3624),
    [anon_sym_GT_GT] = ACTIONS(3624),
    [anon_sym_PLUS] = ACTIONS(3624),
    [anon_sym_DASH] = ACTIONS(3624),
    [anon_sym_SLASH] = ACTIONS(3624),
    [anon_sym_PERCENT] = ACTIONS(3624),
    [anon_sym_DASH_DASH] = ACTIONS(3622),
    [anon_sym_PLUS_PLUS] = ACTIONS(3622),
    [anon_sym_DOT] = ACTIONS(3622),
    [anon_sym_DASH_GT] = ACTIONS(3622),
    [anon_sym_DQUOTE] = ACTIONS(3626),
    [sym_comment] = ACTIONS(91),
  },
  [2077] = {
    [sym_compound_statement] = STATE(2725),
    [sym_labeled_statement] = STATE(2725),
    [sym_expression_statement] = STATE(2725),
    [sym_if_statement] = STATE(2725),
    [sym_switch_statement] = STATE(2725),
    [sym_case_statement] = STATE(2725),
    [sym_while_statement] = STATE(2725),
    [sym_do_statement] = STATE(2725),
    [sym_for_statement] = STATE(2725),
    [sym_return_statement] = STATE(2725),
    [sym_break_statement] = STATE(2725),
    [sym_continue_statement] = STATE(2725),
    [sym_goto_statement] = STATE(2725),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(2725),
    [sym_try_statement] = STATE(2725),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(4430),
    [anon_sym_switch] = ACTIONS(4432),
    [anon_sym_case] = ACTIONS(4434),
    [anon_sym_default] = ACTIONS(4436),
    [anon_sym_while] = ACTIONS(4438),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(4440),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(4442),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(4444),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [2078] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(4171),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(4171),
    [anon_sym_COLON] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4169),
    [anon_sym_STAR_EQ] = ACTIONS(4169),
    [anon_sym_SLASH_EQ] = ACTIONS(4169),
    [anon_sym_PERCENT_EQ] = ACTIONS(4169),
    [anon_sym_PLUS_EQ] = ACTIONS(4169),
    [anon_sym_DASH_EQ] = ACTIONS(4169),
    [anon_sym_LT_LT_EQ] = ACTIONS(4169),
    [anon_sym_GT_GT_EQ] = ACTIONS(4169),
    [anon_sym_AMP_EQ] = ACTIONS(4169),
    [anon_sym_CARET_EQ] = ACTIONS(4169),
    [anon_sym_PIPE_EQ] = ACTIONS(4169),
    [anon_sym_AMP] = ACTIONS(4171),
    [anon_sym_PIPE_PIPE] = ACTIONS(4169),
    [anon_sym_AMP_AMP] = ACTIONS(4169),
    [anon_sym_PIPE] = ACTIONS(4171),
    [anon_sym_CARET] = ACTIONS(4171),
    [anon_sym_EQ_EQ] = ACTIONS(4169),
    [anon_sym_BANG_EQ] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4171),
    [anon_sym_GT] = ACTIONS(4171),
    [anon_sym_LT_EQ] = ACTIONS(4169),
    [anon_sym_GT_EQ] = ACTIONS(4169),
    [anon_sym_LT_LT] = ACTIONS(4171),
    [anon_sym_GT_GT] = ACTIONS(4171),
    [anon_sym_PLUS] = ACTIONS(4171),
    [anon_sym_DASH] = ACTIONS(4171),
    [anon_sym_SLASH] = ACTIONS(4171),
    [anon_sym_PERCENT] = ACTIONS(4171),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [2079] = {
    [sym__expression] = STATE(2078),
    [sym_conditional_expression] = STATE(2078),
    [sym_assignment_expression] = STATE(2078),
    [sym_pointer_expression] = STATE(2078),
    [sym_logical_expression] = STATE(2078),
    [sym_bitwise_expression] = STATE(2078),
    [sym_equality_expression] = STATE(2078),
    [sym_relational_expression] = STATE(2078),
    [sym_shift_expression] = STATE(2078),
    [sym_math_expression] = STATE(2078),
    [sym_cast_expression] = STATE(2078),
    [sym_sizeof_expression] = STATE(2078),
    [sym_subscript_expression] = STATE(2078),
    [sym_call_expression] = STATE(2078),
    [sym_field_expression] = STATE(2078),
    [sym_compound_literal_expression] = STATE(2078),
    [sym_parenthesized_expression] = STATE(2078),
    [sym_initializer_list] = STATE(1201),
    [sym_char_literal] = STATE(2078),
    [sym_concatenated_string] = STATE(2078),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2078),
    [sym_new_expression] = STATE(2078),
    [sym_delete_expression] = STATE(2078),
    [sym_lambda_expression] = STATE(2078),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(6099),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_EQ] = ACTIONS(4693),
    [anon_sym_COLON] = ACTIONS(4693),
    [anon_sym_QMARK] = ACTIONS(4689),
    [anon_sym_STAR_EQ] = ACTIONS(4689),
    [anon_sym_SLASH_EQ] = ACTIONS(4689),
    [anon_sym_PERCENT_EQ] = ACTIONS(4689),
    [anon_sym_PLUS_EQ] = ACTIONS(4689),
    [anon_sym_DASH_EQ] = ACTIONS(4689),
    [anon_sym_LT_LT_EQ] = ACTIONS(4689),
    [anon_sym_GT_GT_EQ] = ACTIONS(4689),
    [anon_sym_AMP_EQ] = ACTIONS(4689),
    [anon_sym_CARET_EQ] = ACTIONS(4689),
    [anon_sym_PIPE_EQ] = ACTIONS(4689),
    [anon_sym_AMP] = ACTIONS(6099),
    [anon_sym_PIPE_PIPE] = ACTIONS(4689),
    [anon_sym_AMP_AMP] = ACTIONS(4689),
    [anon_sym_BANG] = ACTIONS(6101),
    [anon_sym_PIPE] = ACTIONS(4693),
    [anon_sym_CARET] = ACTIONS(4693),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(4689),
    [anon_sym_BANG_EQ] = ACTIONS(4689),
    [anon_sym_LT] = ACTIONS(4693),
    [anon_sym_GT] = ACTIONS(4693),
    [anon_sym_LT_EQ] = ACTIONS(4689),
    [anon_sym_GT_EQ] = ACTIONS(4689),
    [anon_sym_LT_LT] = ACTIONS(4693),
    [anon_sym_GT_GT] = ACTIONS(4693),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_SLASH] = ACTIONS(4693),
    [anon_sym_PERCENT] = ACTIONS(4693),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [anon_sym_DOT] = ACTIONS(4689),
    [anon_sym_DASH_GT] = ACTIONS(4689),
    [sym_number_literal] = ACTIONS(4492),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(4494),
    [sym_false] = ACTIONS(4494),
    [sym_null] = ACTIONS(4494),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(4494),
  },
  [2080] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(4929),
    [anon_sym_COLON] = ACTIONS(4927),
    [anon_sym_QMARK] = ACTIONS(4927),
    [anon_sym_STAR_EQ] = ACTIONS(4927),
    [anon_sym_SLASH_EQ] = ACTIONS(4927),
    [anon_sym_PERCENT_EQ] = ACTIONS(4927),
    [anon_sym_PLUS_EQ] = ACTIONS(4927),
    [anon_sym_DASH_EQ] = ACTIONS(4927),
    [anon_sym_LT_LT_EQ] = ACTIONS(4927),
    [anon_sym_GT_GT_EQ] = ACTIONS(4927),
    [anon_sym_AMP_EQ] = ACTIONS(4927),
    [anon_sym_CARET_EQ] = ACTIONS(4927),
    [anon_sym_PIPE_EQ] = ACTIONS(4927),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_CARET] = ACTIONS(1183),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [2081] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(6103),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_STAR_EQ] = ACTIONS(3507),
    [anon_sym_SLASH_EQ] = ACTIONS(3507),
    [anon_sym_PERCENT_EQ] = ACTIONS(3507),
    [anon_sym_PLUS_EQ] = ACTIONS(3507),
    [anon_sym_DASH_EQ] = ACTIONS(3507),
    [anon_sym_LT_LT_EQ] = ACTIONS(3507),
    [anon_sym_GT_GT_EQ] = ACTIONS(3507),
    [anon_sym_AMP_EQ] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(3507),
    [anon_sym_PIPE_EQ] = ACTIONS(3507),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_CARET] = ACTIONS(3517),
    [anon_sym_EQ_EQ] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3521),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3525),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2082] = {
    [sym_argument_list] = STATE(2307),
    [sym_initializer_list] = STATE(2307),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(5020),
    [anon_sym_LBRACK] = ACTIONS(5018),
    [anon_sym_EQ] = ACTIONS(5020),
    [anon_sym_COLON] = ACTIONS(5018),
    [anon_sym_QMARK] = ACTIONS(5018),
    [anon_sym_STAR_EQ] = ACTIONS(5018),
    [anon_sym_SLASH_EQ] = ACTIONS(5018),
    [anon_sym_PERCENT_EQ] = ACTIONS(5018),
    [anon_sym_PLUS_EQ] = ACTIONS(5018),
    [anon_sym_DASH_EQ] = ACTIONS(5018),
    [anon_sym_LT_LT_EQ] = ACTIONS(5018),
    [anon_sym_GT_GT_EQ] = ACTIONS(5018),
    [anon_sym_AMP_EQ] = ACTIONS(5018),
    [anon_sym_CARET_EQ] = ACTIONS(5018),
    [anon_sym_PIPE_EQ] = ACTIONS(5018),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_PIPE_PIPE] = ACTIONS(5018),
    [anon_sym_AMP_AMP] = ACTIONS(5018),
    [anon_sym_PIPE] = ACTIONS(5020),
    [anon_sym_CARET] = ACTIONS(5020),
    [anon_sym_EQ_EQ] = ACTIONS(5018),
    [anon_sym_BANG_EQ] = ACTIONS(5018),
    [anon_sym_LT] = ACTIONS(5020),
    [anon_sym_GT] = ACTIONS(5020),
    [anon_sym_LT_EQ] = ACTIONS(5018),
    [anon_sym_GT_EQ] = ACTIONS(5018),
    [anon_sym_LT_LT] = ACTIONS(5020),
    [anon_sym_GT_GT] = ACTIONS(5020),
    [anon_sym_PLUS] = ACTIONS(5020),
    [anon_sym_DASH] = ACTIONS(5020),
    [anon_sym_SLASH] = ACTIONS(5020),
    [anon_sym_PERCENT] = ACTIONS(5020),
    [anon_sym_DASH_DASH] = ACTIONS(5018),
    [anon_sym_PLUS_PLUS] = ACTIONS(5018),
    [anon_sym_DOT] = ACTIONS(5018),
    [anon_sym_DASH_GT] = ACTIONS(5018),
    [sym_comment] = ACTIONS(91),
  },
  [2083] = {
    [sym__expression] = STATE(2727),
    [sym_conditional_expression] = STATE(2727),
    [sym_assignment_expression] = STATE(2727),
    [sym_pointer_expression] = STATE(2727),
    [sym_logical_expression] = STATE(2727),
    [sym_bitwise_expression] = STATE(2727),
    [sym_equality_expression] = STATE(2727),
    [sym_relational_expression] = STATE(2727),
    [sym_shift_expression] = STATE(2727),
    [sym_math_expression] = STATE(2727),
    [sym_cast_expression] = STATE(2727),
    [sym_sizeof_expression] = STATE(2727),
    [sym_subscript_expression] = STATE(2727),
    [sym_call_expression] = STATE(2727),
    [sym_field_expression] = STATE(2727),
    [sym_compound_literal_expression] = STATE(2727),
    [sym_parenthesized_expression] = STATE(2727),
    [sym_char_literal] = STATE(2727),
    [sym_concatenated_string] = STATE(2727),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2727),
    [sym_new_expression] = STATE(2727),
    [sym_delete_expression] = STATE(2727),
    [sym_lambda_expression] = STATE(2727),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6105),
    [anon_sym_LPAREN2] = ACTIONS(947),
    [anon_sym_STAR] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(947),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(6105),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(6107),
    [sym_false] = ACTIONS(6107),
    [sym_null] = ACTIONS(6107),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(6107),
  },
  [2084] = {
    [anon_sym_LPAREN2] = ACTIONS(5004),
    [anon_sym_STAR] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(5004),
    [anon_sym_EQ] = ACTIONS(5006),
    [anon_sym_COLON] = ACTIONS(5004),
    [anon_sym_QMARK] = ACTIONS(5004),
    [anon_sym_STAR_EQ] = ACTIONS(5004),
    [anon_sym_SLASH_EQ] = ACTIONS(5004),
    [anon_sym_PERCENT_EQ] = ACTIONS(5004),
    [anon_sym_PLUS_EQ] = ACTIONS(5004),
    [anon_sym_DASH_EQ] = ACTIONS(5004),
    [anon_sym_LT_LT_EQ] = ACTIONS(5004),
    [anon_sym_GT_GT_EQ] = ACTIONS(5004),
    [anon_sym_AMP_EQ] = ACTIONS(5004),
    [anon_sym_CARET_EQ] = ACTIONS(5004),
    [anon_sym_PIPE_EQ] = ACTIONS(5004),
    [anon_sym_AMP] = ACTIONS(5006),
    [anon_sym_PIPE_PIPE] = ACTIONS(5004),
    [anon_sym_AMP_AMP] = ACTIONS(5004),
    [anon_sym_PIPE] = ACTIONS(5006),
    [anon_sym_CARET] = ACTIONS(5006),
    [anon_sym_EQ_EQ] = ACTIONS(5004),
    [anon_sym_BANG_EQ] = ACTIONS(5004),
    [anon_sym_LT] = ACTIONS(5006),
    [anon_sym_GT] = ACTIONS(5006),
    [anon_sym_LT_EQ] = ACTIONS(5004),
    [anon_sym_GT_EQ] = ACTIONS(5004),
    [anon_sym_LT_LT] = ACTIONS(5006),
    [anon_sym_GT_GT] = ACTIONS(5006),
    [anon_sym_PLUS] = ACTIONS(5006),
    [anon_sym_DASH] = ACTIONS(5006),
    [anon_sym_SLASH] = ACTIONS(5006),
    [anon_sym_PERCENT] = ACTIONS(5006),
    [anon_sym_DASH_DASH] = ACTIONS(5004),
    [anon_sym_PLUS_PLUS] = ACTIONS(5004),
    [anon_sym_DOT] = ACTIONS(5004),
    [anon_sym_DASH_GT] = ACTIONS(5004),
    [sym_comment] = ACTIONS(91),
  },
  [2085] = {
    [aux_sym_argument_list_repeat1] = STATE(2289),
    [anon_sym_COMMA] = ACTIONS(3356),
    [anon_sym_RPAREN] = ACTIONS(6109),
    [sym_comment] = ACTIONS(91),
  },
  [2086] = {
    [sym__expression] = STATE(2729),
    [sym_conditional_expression] = STATE(2729),
    [sym_assignment_expression] = STATE(2729),
    [sym_pointer_expression] = STATE(2729),
    [sym_logical_expression] = STATE(2729),
    [sym_bitwise_expression] = STATE(2729),
    [sym_equality_expression] = STATE(2729),
    [sym_relational_expression] = STATE(2729),
    [sym_shift_expression] = STATE(2729),
    [sym_math_expression] = STATE(2729),
    [sym_cast_expression] = STATE(2729),
    [sym_sizeof_expression] = STATE(2729),
    [sym_subscript_expression] = STATE(2729),
    [sym_call_expression] = STATE(2729),
    [sym_field_expression] = STATE(2729),
    [sym_compound_literal_expression] = STATE(2729),
    [sym_parenthesized_expression] = STATE(2729),
    [sym_char_literal] = STATE(2729),
    [sym_concatenated_string] = STATE(2729),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2729),
    [sym_new_expression] = STATE(2729),
    [sym_delete_expression] = STATE(2729),
    [sym_lambda_expression] = STATE(2729),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6111),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(6111),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(6113),
    [sym_false] = ACTIONS(6113),
    [sym_null] = ACTIONS(6113),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(6113),
  },
  [2087] = {
    [anon_sym_COMMA] = ACTIONS(4843),
    [anon_sym_SEMI] = ACTIONS(4843),
    [anon_sym_LBRACE] = ACTIONS(4843),
    [anon_sym_LPAREN2] = ACTIONS(4843),
    [anon_sym_STAR] = ACTIONS(4845),
    [anon_sym_LBRACK] = ACTIONS(4843),
    [anon_sym_EQ] = ACTIONS(4845),
    [anon_sym_COLON] = ACTIONS(4843),
    [anon_sym_QMARK] = ACTIONS(4843),
    [anon_sym_STAR_EQ] = ACTIONS(4843),
    [anon_sym_SLASH_EQ] = ACTIONS(4843),
    [anon_sym_PERCENT_EQ] = ACTIONS(4843),
    [anon_sym_PLUS_EQ] = ACTIONS(4843),
    [anon_sym_DASH_EQ] = ACTIONS(4843),
    [anon_sym_LT_LT_EQ] = ACTIONS(4843),
    [anon_sym_GT_GT_EQ] = ACTIONS(4843),
    [anon_sym_AMP_EQ] = ACTIONS(4843),
    [anon_sym_CARET_EQ] = ACTIONS(4843),
    [anon_sym_PIPE_EQ] = ACTIONS(4843),
    [anon_sym_AMP] = ACTIONS(4845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4843),
    [anon_sym_AMP_AMP] = ACTIONS(4843),
    [anon_sym_PIPE] = ACTIONS(4845),
    [anon_sym_CARET] = ACTIONS(4845),
    [anon_sym_EQ_EQ] = ACTIONS(4843),
    [anon_sym_BANG_EQ] = ACTIONS(4843),
    [anon_sym_LT] = ACTIONS(4845),
    [anon_sym_GT] = ACTIONS(4845),
    [anon_sym_LT_EQ] = ACTIONS(4843),
    [anon_sym_GT_EQ] = ACTIONS(4843),
    [anon_sym_LT_LT] = ACTIONS(4845),
    [anon_sym_GT_GT] = ACTIONS(4845),
    [anon_sym_PLUS] = ACTIONS(4845),
    [anon_sym_DASH] = ACTIONS(4845),
    [anon_sym_SLASH] = ACTIONS(4845),
    [anon_sym_PERCENT] = ACTIONS(4845),
    [anon_sym_DASH_DASH] = ACTIONS(4843),
    [anon_sym_PLUS_PLUS] = ACTIONS(4843),
    [anon_sym_DOT] = ACTIONS(4843),
    [anon_sym_DASH_GT] = ACTIONS(4843),
    [sym_comment] = ACTIONS(91),
  },
  [2088] = {
    [aux_sym_template_argument_list_repeat1] = STATE(2235),
    [anon_sym_COMMA] = ACTIONS(3163),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(6115),
  },
  [2089] = {
    [anon_sym_COMMA] = ACTIONS(4849),
    [anon_sym_SEMI] = ACTIONS(4849),
    [anon_sym_LBRACE] = ACTIONS(4849),
    [anon_sym_LPAREN2] = ACTIONS(4849),
    [anon_sym_STAR] = ACTIONS(4851),
    [anon_sym_LBRACK] = ACTIONS(4849),
    [anon_sym_EQ] = ACTIONS(4851),
    [anon_sym_COLON] = ACTIONS(4849),
    [anon_sym_QMARK] = ACTIONS(4849),
    [anon_sym_STAR_EQ] = ACTIONS(4849),
    [anon_sym_SLASH_EQ] = ACTIONS(4849),
    [anon_sym_PERCENT_EQ] = ACTIONS(4849),
    [anon_sym_PLUS_EQ] = ACTIONS(4849),
    [anon_sym_DASH_EQ] = ACTIONS(4849),
    [anon_sym_LT_LT_EQ] = ACTIONS(4849),
    [anon_sym_GT_GT_EQ] = ACTIONS(4849),
    [anon_sym_AMP_EQ] = ACTIONS(4849),
    [anon_sym_CARET_EQ] = ACTIONS(4849),
    [anon_sym_PIPE_EQ] = ACTIONS(4849),
    [anon_sym_AMP] = ACTIONS(4851),
    [anon_sym_PIPE_PIPE] = ACTIONS(4849),
    [anon_sym_AMP_AMP] = ACTIONS(4849),
    [anon_sym_PIPE] = ACTIONS(4851),
    [anon_sym_CARET] = ACTIONS(4851),
    [anon_sym_EQ_EQ] = ACTIONS(4849),
    [anon_sym_BANG_EQ] = ACTIONS(4849),
    [anon_sym_LT] = ACTIONS(4851),
    [anon_sym_GT] = ACTIONS(4851),
    [anon_sym_LT_EQ] = ACTIONS(4849),
    [anon_sym_GT_EQ] = ACTIONS(4849),
    [anon_sym_LT_LT] = ACTIONS(4851),
    [anon_sym_GT_GT] = ACTIONS(4851),
    [anon_sym_PLUS] = ACTIONS(4851),
    [anon_sym_DASH] = ACTIONS(4851),
    [anon_sym_SLASH] = ACTIONS(4851),
    [anon_sym_PERCENT] = ACTIONS(4851),
    [anon_sym_DASH_DASH] = ACTIONS(4849),
    [anon_sym_PLUS_PLUS] = ACTIONS(4849),
    [anon_sym_DOT] = ACTIONS(4849),
    [anon_sym_DASH_GT] = ACTIONS(4849),
    [sym_comment] = ACTIONS(91),
  },
  [2090] = {
    [aux_sym_template_argument_list_repeat1] = STATE(2235),
    [anon_sym_COMMA] = ACTIONS(3163),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(6117),
  },
  [2091] = {
    [anon_sym_COMMA] = ACTIONS(3211),
    [anon_sym_SEMI] = ACTIONS(3211),
    [anon_sym_extern] = ACTIONS(3216),
    [anon_sym_LBRACE] = ACTIONS(3218),
    [anon_sym_LPAREN2] = ACTIONS(3213),
    [anon_sym_STAR] = ACTIONS(3220),
    [anon_sym_LBRACK] = ACTIONS(3211),
    [anon_sym_EQ] = ACTIONS(3223),
    [anon_sym_static] = ACTIONS(3216),
    [anon_sym_register] = ACTIONS(3216),
    [anon_sym_inline] = ACTIONS(3216),
    [anon_sym_const] = ACTIONS(3216),
    [anon_sym_restrict] = ACTIONS(3216),
    [anon_sym_volatile] = ACTIONS(3216),
    [anon_sym__Atomic] = ACTIONS(3216),
    [anon_sym_mutable] = ACTIONS(3216),
    [anon_sym_explicit] = ACTIONS(3216),
    [anon_sym_constexpr] = ACTIONS(3216),
    [anon_sym_QMARK] = ACTIONS(3211),
    [anon_sym_STAR_EQ] = ACTIONS(3211),
    [anon_sym_SLASH_EQ] = ACTIONS(3211),
    [anon_sym_PERCENT_EQ] = ACTIONS(3211),
    [anon_sym_PLUS_EQ] = ACTIONS(3211),
    [anon_sym_DASH_EQ] = ACTIONS(3211),
    [anon_sym_LT_LT_EQ] = ACTIONS(3211),
    [anon_sym_GT_GT_EQ] = ACTIONS(3211),
    [anon_sym_AMP_EQ] = ACTIONS(3211),
    [anon_sym_CARET_EQ] = ACTIONS(3211),
    [anon_sym_PIPE_EQ] = ACTIONS(3211),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym_PIPE_PIPE] = ACTIONS(3211),
    [anon_sym_AMP_AMP] = ACTIONS(3213),
    [anon_sym_PIPE] = ACTIONS(3223),
    [anon_sym_CARET] = ACTIONS(3223),
    [anon_sym_TILDE] = ACTIONS(3218),
    [anon_sym_EQ_EQ] = ACTIONS(3211),
    [anon_sym_BANG_EQ] = ACTIONS(3211),
    [anon_sym_LT] = ACTIONS(3220),
    [anon_sym_GT] = ACTIONS(3223),
    [anon_sym_LT_EQ] = ACTIONS(3211),
    [anon_sym_GT_EQ] = ACTIONS(3211),
    [anon_sym_LT_LT] = ACTIONS(3223),
    [anon_sym_GT_GT] = ACTIONS(3223),
    [anon_sym_PLUS] = ACTIONS(3223),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_SLASH] = ACTIONS(3223),
    [anon_sym_PERCENT] = ACTIONS(3223),
    [anon_sym_DASH_DASH] = ACTIONS(3211),
    [anon_sym_PLUS_PLUS] = ACTIONS(3211),
    [anon_sym_DOT] = ACTIONS(3211),
    [anon_sym_DASH_GT] = ACTIONS(3211),
    [sym_identifier] = ACTIONS(3216),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(3225),
    [sym_operator_name] = ACTIONS(3218),
  },
  [2092] = {
    [anon_sym_COMMA] = ACTIONS(3629),
    [anon_sym_SEMI] = ACTIONS(3629),
    [anon_sym_extern] = ACTIONS(3634),
    [anon_sym_LBRACE] = ACTIONS(3636),
    [anon_sym_LPAREN2] = ACTIONS(3631),
    [anon_sym_STAR] = ACTIONS(3638),
    [anon_sym_LBRACK] = ACTIONS(3629),
    [anon_sym_EQ] = ACTIONS(3641),
    [anon_sym_static] = ACTIONS(3634),
    [anon_sym_register] = ACTIONS(3634),
    [anon_sym_inline] = ACTIONS(3634),
    [anon_sym_const] = ACTIONS(3634),
    [anon_sym_restrict] = ACTIONS(3634),
    [anon_sym_volatile] = ACTIONS(3634),
    [anon_sym__Atomic] = ACTIONS(3634),
    [anon_sym_mutable] = ACTIONS(3634),
    [anon_sym_explicit] = ACTIONS(3634),
    [anon_sym_constexpr] = ACTIONS(3634),
    [anon_sym_QMARK] = ACTIONS(3629),
    [anon_sym_STAR_EQ] = ACTIONS(3629),
    [anon_sym_SLASH_EQ] = ACTIONS(3629),
    [anon_sym_PERCENT_EQ] = ACTIONS(3629),
    [anon_sym_PLUS_EQ] = ACTIONS(3629),
    [anon_sym_DASH_EQ] = ACTIONS(3629),
    [anon_sym_LT_LT_EQ] = ACTIONS(3629),
    [anon_sym_GT_GT_EQ] = ACTIONS(3629),
    [anon_sym_AMP_EQ] = ACTIONS(3629),
    [anon_sym_CARET_EQ] = ACTIONS(3629),
    [anon_sym_PIPE_EQ] = ACTIONS(3629),
    [anon_sym_AMP] = ACTIONS(3638),
    [anon_sym_PIPE_PIPE] = ACTIONS(3629),
    [anon_sym_AMP_AMP] = ACTIONS(3631),
    [anon_sym_PIPE] = ACTIONS(3641),
    [anon_sym_CARET] = ACTIONS(3641),
    [anon_sym_TILDE] = ACTIONS(3636),
    [anon_sym_EQ_EQ] = ACTIONS(3629),
    [anon_sym_BANG_EQ] = ACTIONS(3629),
    [anon_sym_LT] = ACTIONS(3638),
    [anon_sym_GT] = ACTIONS(3641),
    [anon_sym_LT_EQ] = ACTIONS(3629),
    [anon_sym_GT_EQ] = ACTIONS(3629),
    [anon_sym_LT_LT] = ACTIONS(3641),
    [anon_sym_GT_GT] = ACTIONS(3641),
    [anon_sym_PLUS] = ACTIONS(3641),
    [anon_sym_DASH] = ACTIONS(3641),
    [anon_sym_SLASH] = ACTIONS(3641),
    [anon_sym_PERCENT] = ACTIONS(3641),
    [anon_sym_DASH_DASH] = ACTIONS(3629),
    [anon_sym_PLUS_PLUS] = ACTIONS(3629),
    [anon_sym_DOT] = ACTIONS(3629),
    [anon_sym_DASH_GT] = ACTIONS(3629),
    [sym_identifier] = ACTIONS(3634),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(3643),
    [sym_operator_name] = ACTIONS(3636),
  },
  [2093] = {
    [sym_compound_statement] = STATE(2740),
    [sym_labeled_statement] = STATE(2740),
    [sym_expression_statement] = STATE(2740),
    [sym_if_statement] = STATE(2740),
    [sym_switch_statement] = STATE(2740),
    [sym_case_statement] = STATE(2740),
    [sym_while_statement] = STATE(2740),
    [sym_do_statement] = STATE(2740),
    [sym_for_statement] = STATE(2740),
    [sym_return_statement] = STATE(2740),
    [sym_break_statement] = STATE(2740),
    [sym_continue_statement] = STATE(2740),
    [sym_goto_statement] = STATE(2740),
    [sym__expression] = STATE(222),
    [sym_comma_expression] = STATE(223),
    [sym_conditional_expression] = STATE(222),
    [sym_assignment_expression] = STATE(222),
    [sym_pointer_expression] = STATE(222),
    [sym_logical_expression] = STATE(222),
    [sym_bitwise_expression] = STATE(222),
    [sym_equality_expression] = STATE(222),
    [sym_relational_expression] = STATE(222),
    [sym_shift_expression] = STATE(222),
    [sym_math_expression] = STATE(222),
    [sym_cast_expression] = STATE(222),
    [sym_sizeof_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_call_expression] = STATE(222),
    [sym_field_expression] = STATE(222),
    [sym_compound_literal_expression] = STATE(222),
    [sym_parenthesized_expression] = STATE(222),
    [sym_char_literal] = STATE(222),
    [sym_concatenated_string] = STATE(222),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(222),
    [sym_for_range_loop] = STATE(2740),
    [sym_try_statement] = STATE(2740),
    [sym_new_expression] = STATE(222),
    [sym_delete_expression] = STATE(222),
    [sym_lambda_expression] = STATE(222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(6119),
    [anon_sym_switch] = ACTIONS(6121),
    [anon_sym_case] = ACTIONS(6123),
    [anon_sym_default] = ACTIONS(6125),
    [anon_sym_while] = ACTIONS(6127),
    [anon_sym_do] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(6129),
    [anon_sym_return] = ACTIONS(373),
    [anon_sym_break] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_goto] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(353),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_identifier] = ACTIONS(6131),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(6133),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(381),
  },
  [2094] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(6135),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2095] = {
    [anon_sym_else] = ACTIONS(4513),
    [anon_sym_while] = ACTIONS(4513),
    [sym_comment] = ACTIONS(91),
  },
  [2096] = {
    [sym_parameter_list] = STATE(897),
    [sym_argument_list] = STATE(898),
    [sym_initializer_list] = STATE(898),
    [aux_sym_declaration_repeat1] = STATE(2676),
    [anon_sym_COMMA] = ACTIONS(1613),
    [anon_sym_SEMI] = ACTIONS(5959),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(1619),
    [anon_sym_LBRACK] = ACTIONS(574),
    [anon_sym_EQ] = ACTIONS(1621),
    [sym_comment] = ACTIONS(91),
  },
  [2097] = {
    [sym__expression] = STATE(137),
    [sym_comma_expression] = STATE(138),
    [sym_conditional_expression] = STATE(137),
    [sym_assignment_expression] = STATE(137),
    [sym_pointer_expression] = STATE(137),
    [sym_logical_expression] = STATE(137),
    [sym_bitwise_expression] = STATE(137),
    [sym_equality_expression] = STATE(137),
    [sym_relational_expression] = STATE(137),
    [sym_shift_expression] = STATE(137),
    [sym_math_expression] = STATE(137),
    [sym_cast_expression] = STATE(137),
    [sym_sizeof_expression] = STATE(137),
    [sym_subscript_expression] = STATE(137),
    [sym_call_expression] = STATE(137),
    [sym_field_expression] = STATE(137),
    [sym_compound_literal_expression] = STATE(137),
    [sym_parenthesized_expression] = STATE(137),
    [sym_char_literal] = STATE(137),
    [sym_concatenated_string] = STATE(137),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(137),
    [sym_new_expression] = STATE(137),
    [sym_delete_expression] = STATE(137),
    [sym_lambda_expression] = STATE(137),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(213),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [sym_null] = ACTIONS(241),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(241),
  },
  [2098] = {
    [anon_sym_else] = ACTIONS(4554),
    [anon_sym_while] = ACTIONS(4554),
    [sym_comment] = ACTIONS(91),
  },
  [2099] = {
    [sym__expression] = STATE(2743),
    [sym_conditional_expression] = STATE(2743),
    [sym_assignment_expression] = STATE(2743),
    [sym_pointer_expression] = STATE(2743),
    [sym_logical_expression] = STATE(2743),
    [sym_bitwise_expression] = STATE(2743),
    [sym_equality_expression] = STATE(2743),
    [sym_relational_expression] = STATE(2743),
    [sym_shift_expression] = STATE(2743),
    [sym_math_expression] = STATE(2743),
    [sym_cast_expression] = STATE(2743),
    [sym_sizeof_expression] = STATE(2743),
    [sym_subscript_expression] = STATE(2743),
    [sym_call_expression] = STATE(2743),
    [sym_field_expression] = STATE(2743),
    [sym_compound_literal_expression] = STATE(2743),
    [sym_parenthesized_expression] = STATE(2743),
    [sym_char_literal] = STATE(2743),
    [sym_concatenated_string] = STATE(2743),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2743),
    [sym_new_expression] = STATE(2743),
    [sym_delete_expression] = STATE(2743),
    [sym_lambda_expression] = STATE(2743),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6137),
    [anon_sym_RPAREN] = ACTIONS(6139),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(6137),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6141),
    [sym_false] = ACTIONS(6141),
    [sym_null] = ACTIONS(6141),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(6141),
  },
  [2100] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(6143),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2101] = {
    [sym__expression] = STATE(2745),
    [sym_conditional_expression] = STATE(2745),
    [sym_assignment_expression] = STATE(2745),
    [sym_pointer_expression] = STATE(2745),
    [sym_logical_expression] = STATE(2745),
    [sym_bitwise_expression] = STATE(2745),
    [sym_equality_expression] = STATE(2745),
    [sym_relational_expression] = STATE(2745),
    [sym_shift_expression] = STATE(2745),
    [sym_math_expression] = STATE(2745),
    [sym_cast_expression] = STATE(2745),
    [sym_sizeof_expression] = STATE(2745),
    [sym_subscript_expression] = STATE(2745),
    [sym_call_expression] = STATE(2745),
    [sym_field_expression] = STATE(2745),
    [sym_compound_literal_expression] = STATE(2745),
    [sym_parenthesized_expression] = STATE(2745),
    [sym_char_literal] = STATE(2745),
    [sym_concatenated_string] = STATE(2745),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2745),
    [sym_new_expression] = STATE(2745),
    [sym_delete_expression] = STATE(2745),
    [sym_lambda_expression] = STATE(2745),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6145),
    [anon_sym_SEMI] = ACTIONS(6143),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(6145),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6147),
    [sym_false] = ACTIONS(6147),
    [sym_null] = ACTIONS(6147),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(6147),
  },
  [2102] = {
    [sym__expression] = STATE(2746),
    [sym_conditional_expression] = STATE(2746),
    [sym_assignment_expression] = STATE(2746),
    [sym_pointer_expression] = STATE(2746),
    [sym_logical_expression] = STATE(2746),
    [sym_bitwise_expression] = STATE(2746),
    [sym_equality_expression] = STATE(2746),
    [sym_relational_expression] = STATE(2746),
    [sym_shift_expression] = STATE(2746),
    [sym_math_expression] = STATE(2746),
    [sym_cast_expression] = STATE(2746),
    [sym_sizeof_expression] = STATE(2746),
    [sym_subscript_expression] = STATE(2746),
    [sym_call_expression] = STATE(2746),
    [sym_field_expression] = STATE(2746),
    [sym_compound_literal_expression] = STATE(2746),
    [sym_parenthesized_expression] = STATE(2746),
    [sym_char_literal] = STATE(2746),
    [sym_concatenated_string] = STATE(2746),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2746),
    [sym_new_expression] = STATE(2746),
    [sym_delete_expression] = STATE(2746),
    [sym_lambda_expression] = STATE(2746),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6149),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(6149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6151),
    [sym_false] = ACTIONS(6151),
    [sym_null] = ACTIONS(6151),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(6151),
  },
  [2103] = {
    [sym_compound_statement] = STATE(2747),
    [anon_sym_LBRACE] = ACTIONS(357),
    [sym_comment] = ACTIONS(91),
  },
  [2104] = {
    [sym_catch_clause] = STATE(2104),
    [aux_sym_try_statement_repeat1] = STATE(2104),
    [anon_sym_while] = ACTIONS(4993),
    [sym_comment] = ACTIONS(91),
    [anon_sym_catch] = ACTIONS(6153),
  },
  [2105] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(895),
    [anon_sym_RPAREN] = ACTIONS(6156),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2106] = {
    [anon_sym_RPAREN] = ACTIONS(6156),
    [sym_comment] = ACTIONS(91),
  },
  [2107] = {
    [sym_compound_statement] = STATE(2749),
    [sym_labeled_statement] = STATE(2749),
    [sym_expression_statement] = STATE(2749),
    [sym_if_statement] = STATE(2749),
    [sym_switch_statement] = STATE(2749),
    [sym_case_statement] = STATE(2749),
    [sym_while_statement] = STATE(2749),
    [sym_do_statement] = STATE(2749),
    [sym_for_statement] = STATE(2749),
    [sym_return_statement] = STATE(2749),
    [sym_break_statement] = STATE(2749),
    [sym_continue_statement] = STATE(2749),
    [sym_goto_statement] = STATE(2749),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(2749),
    [sym_try_statement] = STATE(2749),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_switch] = ACTIONS(49),
    [anon_sym_case] = ACTIONS(51),
    [anon_sym_default] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(1115),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(105),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [2108] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(2752),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(6160),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2109] = {
    [sym__expression] = STATE(2753),
    [sym_conditional_expression] = STATE(2753),
    [sym_assignment_expression] = STATE(2753),
    [sym_pointer_expression] = STATE(2753),
    [sym_logical_expression] = STATE(2753),
    [sym_bitwise_expression] = STATE(2753),
    [sym_equality_expression] = STATE(2753),
    [sym_relational_expression] = STATE(2753),
    [sym_shift_expression] = STATE(2753),
    [sym_math_expression] = STATE(2753),
    [sym_cast_expression] = STATE(2753),
    [sym_sizeof_expression] = STATE(2753),
    [sym_subscript_expression] = STATE(2753),
    [sym_call_expression] = STATE(2753),
    [sym_field_expression] = STATE(2753),
    [sym_compound_literal_expression] = STATE(2753),
    [sym_parenthesized_expression] = STATE(2753),
    [sym_char_literal] = STATE(2753),
    [sym_concatenated_string] = STATE(2753),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2753),
    [sym_new_expression] = STATE(2753),
    [sym_delete_expression] = STATE(2753),
    [sym_lambda_expression] = STATE(2753),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6162),
    [anon_sym_RPAREN] = ACTIONS(6160),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(6162),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6164),
    [sym_false] = ACTIONS(6164),
    [sym_null] = ACTIONS(6164),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(6164),
  },
  [2110] = {
    [sym_parameter_list] = STATE(2113),
    [anon_sym_COMMA] = ACTIONS(2435),
    [anon_sym_SEMI] = ACTIONS(2435),
    [anon_sym_LBRACE] = ACTIONS(2435),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(574),
    [anon_sym_EQ] = ACTIONS(2435),
    [anon_sym_COLON] = ACTIONS(2435),
    [sym_comment] = ACTIONS(91),
  },
  [2111] = {
    [sym__declarator] = STATE(2754),
    [sym_pointer_declarator] = STATE(2754),
    [sym_function_declarator] = STATE(2754),
    [sym_array_declarator] = STATE(2754),
    [sym_type_qualifier] = STATE(552),
    [sym_reference_declarator] = STATE(2754),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(2754),
    [sym_destructor_name] = STATE(2754),
    [sym_scoped_identifier] = STATE(1391),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [aux_sym_type_definition_repeat1] = STATE(552),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(2905),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(2907),
    [anon_sym_AMP_AMP] = ACTIONS(2909),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(568),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(6166),
  },
  [2112] = {
    [sym_parameter_list] = STATE(2113),
    [anon_sym_COMMA] = ACTIONS(2439),
    [anon_sym_SEMI] = ACTIONS(2439),
    [anon_sym_LBRACE] = ACTIONS(2439),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(574),
    [anon_sym_EQ] = ACTIONS(2439),
    [anon_sym_COLON] = ACTIONS(2439),
    [sym_comment] = ACTIONS(91),
  },
  [2113] = {
    [sym_type_qualifier] = STATE(2755),
    [sym_virtual_specifier] = STATE(2755),
    [sym_trailing_return_type] = STATE(2755),
    [aux_sym_function_declarator_repeat1] = STATE(2755),
    [anon_sym_COMMA] = ACTIONS(1665),
    [anon_sym_SEMI] = ACTIONS(1665),
    [anon_sym_LBRACE] = ACTIONS(1665),
    [anon_sym_LPAREN2] = ACTIONS(1665),
    [anon_sym_LBRACK] = ACTIONS(1665),
    [anon_sym_EQ] = ACTIONS(1665),
    [anon_sym_const] = ACTIONS(1667),
    [anon_sym_restrict] = ACTIONS(1669),
    [anon_sym_volatile] = ACTIONS(1669),
    [anon_sym__Atomic] = ACTIONS(1669),
    [anon_sym_mutable] = ACTIONS(1669),
    [anon_sym_explicit] = ACTIONS(1669),
    [anon_sym_constexpr] = ACTIONS(1669),
    [anon_sym_COLON] = ACTIONS(1665),
    [anon_sym_DASH_GT] = ACTIONS(6013),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [sym_noexcept] = ACTIONS(6168),
  },
  [2114] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(6170),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2115] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(6172),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2116] = {
    [sym__expression] = STATE(1200),
    [sym_conditional_expression] = STATE(1200),
    [sym_assignment_expression] = STATE(1200),
    [sym_pointer_expression] = STATE(1200),
    [sym_logical_expression] = STATE(1200),
    [sym_bitwise_expression] = STATE(1200),
    [sym_equality_expression] = STATE(1200),
    [sym_relational_expression] = STATE(1200),
    [sym_shift_expression] = STATE(1200),
    [sym_math_expression] = STATE(1200),
    [sym_cast_expression] = STATE(1200),
    [sym_sizeof_expression] = STATE(1200),
    [sym_subscript_expression] = STATE(1200),
    [sym_call_expression] = STATE(1200),
    [sym_field_expression] = STATE(1200),
    [sym_compound_literal_expression] = STATE(1200),
    [sym_parenthesized_expression] = STATE(1200),
    [sym_initializer_list] = STATE(1201),
    [sym_char_literal] = STATE(1200),
    [sym_concatenated_string] = STATE(1200),
    [sym_string_literal] = STATE(727),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1200),
    [sym_new_expression] = STATE(1200),
    [sym_delete_expression] = STATE(1200),
    [sym_lambda_expression] = STATE(1200),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2523),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(1256),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(1262),
    [anon_sym_TILDE] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_DASH_DASH] = ACTIONS(1268),
    [anon_sym_PLUS_PLUS] = ACTIONS(1268),
    [anon_sym_sizeof] = ACTIONS(1270),
    [sym_number_literal] = ACTIONS(2523),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2525),
    [sym_false] = ACTIONS(2525),
    [sym_null] = ACTIONS(2525),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1276),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1280),
    [sym_nullptr] = ACTIONS(2525),
  },
  [2117] = {
    [anon_sym_LPAREN2] = ACTIONS(2561),
    [anon_sym_STAR] = ACTIONS(2561),
    [anon_sym_LBRACK] = ACTIONS(2561),
    [anon_sym_EQ] = ACTIONS(6174),
    [anon_sym_AMP] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2561),
    [anon_sym_DOT] = ACTIONS(6174),
    [sym_comment] = ACTIONS(91),
  },
  [2118] = {
    [anon_sym_RPAREN] = ACTIONS(6176),
    [sym_comment] = ACTIONS(91),
  },
  [2119] = {
    [sym__expression] = STATE(2759),
    [sym_conditional_expression] = STATE(2759),
    [sym_assignment_expression] = STATE(2759),
    [sym_pointer_expression] = STATE(2759),
    [sym_logical_expression] = STATE(2759),
    [sym_bitwise_expression] = STATE(2759),
    [sym_equality_expression] = STATE(2759),
    [sym_relational_expression] = STATE(2759),
    [sym_shift_expression] = STATE(2759),
    [sym_math_expression] = STATE(2759),
    [sym_cast_expression] = STATE(2759),
    [sym_sizeof_expression] = STATE(2759),
    [sym_subscript_expression] = STATE(2759),
    [sym_call_expression] = STATE(2759),
    [sym_field_expression] = STATE(2759),
    [sym_compound_literal_expression] = STATE(2759),
    [sym_parenthesized_expression] = STATE(2759),
    [sym_char_literal] = STATE(2759),
    [sym_concatenated_string] = STATE(2759),
    [sym_string_literal] = STATE(727),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2759),
    [sym_new_expression] = STATE(2759),
    [sym_delete_expression] = STATE(2759),
    [sym_lambda_expression] = STATE(2759),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6178),
    [anon_sym_LPAREN2] = ACTIONS(947),
    [anon_sym_STAR] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(947),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_BANG] = ACTIONS(1262),
    [anon_sym_TILDE] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_DASH_DASH] = ACTIONS(1268),
    [anon_sym_PLUS_PLUS] = ACTIONS(1268),
    [anon_sym_sizeof] = ACTIONS(1270),
    [sym_number_literal] = ACTIONS(6178),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6180),
    [sym_false] = ACTIONS(6180),
    [sym_null] = ACTIONS(6180),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1276),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1280),
    [sym_nullptr] = ACTIONS(6180),
  },
  [2120] = {
    [sym__expression] = STATE(2760),
    [sym_conditional_expression] = STATE(2760),
    [sym_assignment_expression] = STATE(2760),
    [sym_pointer_expression] = STATE(2760),
    [sym_logical_expression] = STATE(2760),
    [sym_bitwise_expression] = STATE(2760),
    [sym_equality_expression] = STATE(2760),
    [sym_relational_expression] = STATE(2760),
    [sym_shift_expression] = STATE(2760),
    [sym_math_expression] = STATE(2760),
    [sym_cast_expression] = STATE(2760),
    [sym_sizeof_expression] = STATE(2760),
    [sym_subscript_expression] = STATE(2760),
    [sym_call_expression] = STATE(2760),
    [sym_field_expression] = STATE(2760),
    [sym_compound_literal_expression] = STATE(2760),
    [sym_parenthesized_expression] = STATE(2760),
    [sym_char_literal] = STATE(2760),
    [sym_concatenated_string] = STATE(2760),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2760),
    [sym_new_expression] = STATE(2760),
    [sym_delete_expression] = STATE(2760),
    [sym_lambda_expression] = STATE(2760),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6182),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(6182),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6184),
    [sym_false] = ACTIONS(6184),
    [sym_null] = ACTIONS(6184),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(6184),
  },
  [2121] = {
    [sym_argument_list] = STATE(1610),
    [sym_initializer_list] = STATE(1610),
    [sym_new_declarator] = STATE(1611),
    [anon_sym_COMMA] = ACTIONS(3372),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_RBRACE] = ACTIONS(3372),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3374),
    [anon_sym_LBRACK] = ACTIONS(4592),
    [anon_sym_EQ] = ACTIONS(3374),
    [anon_sym_QMARK] = ACTIONS(3372),
    [anon_sym_STAR_EQ] = ACTIONS(3372),
    [anon_sym_SLASH_EQ] = ACTIONS(3372),
    [anon_sym_PERCENT_EQ] = ACTIONS(3372),
    [anon_sym_PLUS_EQ] = ACTIONS(3372),
    [anon_sym_DASH_EQ] = ACTIONS(3372),
    [anon_sym_LT_LT_EQ] = ACTIONS(3372),
    [anon_sym_GT_GT_EQ] = ACTIONS(3372),
    [anon_sym_AMP_EQ] = ACTIONS(3372),
    [anon_sym_CARET_EQ] = ACTIONS(3372),
    [anon_sym_PIPE_EQ] = ACTIONS(3372),
    [anon_sym_AMP] = ACTIONS(3374),
    [anon_sym_PIPE_PIPE] = ACTIONS(3372),
    [anon_sym_AMP_AMP] = ACTIONS(3372),
    [anon_sym_PIPE] = ACTIONS(3374),
    [anon_sym_CARET] = ACTIONS(3374),
    [anon_sym_EQ_EQ] = ACTIONS(3372),
    [anon_sym_BANG_EQ] = ACTIONS(3372),
    [anon_sym_LT] = ACTIONS(3374),
    [anon_sym_GT] = ACTIONS(3374),
    [anon_sym_LT_EQ] = ACTIONS(3372),
    [anon_sym_GT_EQ] = ACTIONS(3372),
    [anon_sym_LT_LT] = ACTIONS(3374),
    [anon_sym_GT_GT] = ACTIONS(3374),
    [anon_sym_PLUS] = ACTIONS(3374),
    [anon_sym_DASH] = ACTIONS(3374),
    [anon_sym_SLASH] = ACTIONS(3374),
    [anon_sym_PERCENT] = ACTIONS(3374),
    [anon_sym_DASH_DASH] = ACTIONS(3372),
    [anon_sym_PLUS_PLUS] = ACTIONS(3372),
    [anon_sym_DOT] = ACTIONS(3372),
    [anon_sym_DASH_GT] = ACTIONS(3372),
    [sym_comment] = ACTIONS(91),
  },
  [2122] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2122),
    [anon_sym_COMMA] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(1985),
    [anon_sym_RBRACE] = ACTIONS(1985),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_EQ] = ACTIONS(1987),
    [anon_sym_unsigned] = ACTIONS(6186),
    [anon_sym_long] = ACTIONS(6186),
    [anon_sym_short] = ACTIONS(6186),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_QMARK] = ACTIONS(1985),
    [anon_sym_STAR_EQ] = ACTIONS(1985),
    [anon_sym_SLASH_EQ] = ACTIONS(1985),
    [anon_sym_PERCENT_EQ] = ACTIONS(1985),
    [anon_sym_PLUS_EQ] = ACTIONS(1985),
    [anon_sym_DASH_EQ] = ACTIONS(1985),
    [anon_sym_LT_LT_EQ] = ACTIONS(1985),
    [anon_sym_GT_GT_EQ] = ACTIONS(1985),
    [anon_sym_AMP_EQ] = ACTIONS(1985),
    [anon_sym_CARET_EQ] = ACTIONS(1985),
    [anon_sym_PIPE_EQ] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_PIPE_PIPE] = ACTIONS(1985),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_PIPE] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1987),
    [anon_sym_EQ_EQ] = ACTIONS(1985),
    [anon_sym_BANG_EQ] = ACTIONS(1985),
    [anon_sym_LT] = ACTIONS(1987),
    [anon_sym_GT] = ACTIONS(1987),
    [anon_sym_LT_EQ] = ACTIONS(1985),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_LT] = ACTIONS(1987),
    [anon_sym_GT_GT] = ACTIONS(1987),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_DASH] = ACTIONS(1987),
    [anon_sym_SLASH] = ACTIONS(1987),
    [anon_sym_PERCENT] = ACTIONS(1987),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DOT] = ACTIONS(1985),
    [anon_sym_DASH_GT] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [sym_comment] = ACTIONS(91),
  },
  [2123] = {
    [sym__expression] = STATE(164),
    [sym_conditional_expression] = STATE(164),
    [sym_assignment_expression] = STATE(164),
    [sym_pointer_expression] = STATE(164),
    [sym_logical_expression] = STATE(164),
    [sym_bitwise_expression] = STATE(164),
    [sym_equality_expression] = STATE(164),
    [sym_relational_expression] = STATE(164),
    [sym_shift_expression] = STATE(164),
    [sym_math_expression] = STATE(164),
    [sym_cast_expression] = STATE(164),
    [sym_sizeof_expression] = STATE(164),
    [sym_subscript_expression] = STATE(164),
    [sym_call_expression] = STATE(164),
    [sym_field_expression] = STATE(164),
    [sym_compound_literal_expression] = STATE(164),
    [sym_parenthesized_expression] = STATE(164),
    [sym_char_literal] = STATE(164),
    [sym_concatenated_string] = STATE(164),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(164),
    [sym_new_expression] = STATE(164),
    [sym_delete_expression] = STATE(164),
    [sym_lambda_expression] = STATE(164),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_lambda_default_capture] = STATE(166),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(267),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(6189),
    [anon_sym_EQ] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(267),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(289),
    [sym_false] = ACTIONS(289),
    [sym_null] = ACTIONS(289),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(289),
  },
  [2124] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3383),
    [anon_sym_RBRACE] = ACTIONS(3383),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3385),
    [anon_sym_QMARK] = ACTIONS(3383),
    [anon_sym_STAR_EQ] = ACTIONS(3383),
    [anon_sym_SLASH_EQ] = ACTIONS(3383),
    [anon_sym_PERCENT_EQ] = ACTIONS(3383),
    [anon_sym_PLUS_EQ] = ACTIONS(3383),
    [anon_sym_DASH_EQ] = ACTIONS(3383),
    [anon_sym_LT_LT_EQ] = ACTIONS(3383),
    [anon_sym_GT_GT_EQ] = ACTIONS(3383),
    [anon_sym_AMP_EQ] = ACTIONS(3383),
    [anon_sym_CARET_EQ] = ACTIONS(3383),
    [anon_sym_PIPE_EQ] = ACTIONS(3383),
    [anon_sym_AMP] = ACTIONS(2959),
    [anon_sym_PIPE_PIPE] = ACTIONS(2961),
    [anon_sym_AMP_AMP] = ACTIONS(2963),
    [anon_sym_PIPE] = ACTIONS(2965),
    [anon_sym_CARET] = ACTIONS(2967),
    [anon_sym_EQ_EQ] = ACTIONS(2969),
    [anon_sym_BANG_EQ] = ACTIONS(2969),
    [anon_sym_LT] = ACTIONS(2971),
    [anon_sym_GT] = ACTIONS(2971),
    [anon_sym_LT_EQ] = ACTIONS(2973),
    [anon_sym_GT_EQ] = ACTIONS(2973),
    [anon_sym_LT_LT] = ACTIONS(2975),
    [anon_sym_GT_GT] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_SLASH] = ACTIONS(2951),
    [anon_sym_PERCENT] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2125] = {
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_RPAREN] = ACTIONS(6191),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_RBRACE] = ACTIONS(6191),
    [anon_sym_LPAREN2] = ACTIONS(6191),
    [anon_sym_STAR] = ACTIONS(6193),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_RBRACK] = ACTIONS(6191),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_COLON] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6191),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_LT_EQ] = ACTIONS(6191),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_DASH] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [anon_sym_DASH_DASH] = ACTIONS(6191),
    [anon_sym_PLUS_PLUS] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6191),
    [anon_sym_DASH_GT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(91),
  },
  [2126] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(6195),
    [anon_sym_RBRACE] = ACTIONS(6195),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2953),
    [anon_sym_QMARK] = ACTIONS(2955),
    [anon_sym_STAR_EQ] = ACTIONS(2957),
    [anon_sym_SLASH_EQ] = ACTIONS(2957),
    [anon_sym_PERCENT_EQ] = ACTIONS(2957),
    [anon_sym_PLUS_EQ] = ACTIONS(2957),
    [anon_sym_DASH_EQ] = ACTIONS(2957),
    [anon_sym_LT_LT_EQ] = ACTIONS(2957),
    [anon_sym_GT_GT_EQ] = ACTIONS(2957),
    [anon_sym_AMP_EQ] = ACTIONS(2957),
    [anon_sym_CARET_EQ] = ACTIONS(2957),
    [anon_sym_PIPE_EQ] = ACTIONS(2957),
    [anon_sym_AMP] = ACTIONS(2959),
    [anon_sym_PIPE_PIPE] = ACTIONS(2961),
    [anon_sym_AMP_AMP] = ACTIONS(2963),
    [anon_sym_PIPE] = ACTIONS(2965),
    [anon_sym_CARET] = ACTIONS(2967),
    [anon_sym_EQ_EQ] = ACTIONS(2969),
    [anon_sym_BANG_EQ] = ACTIONS(2969),
    [anon_sym_LT] = ACTIONS(2971),
    [anon_sym_GT] = ACTIONS(2971),
    [anon_sym_LT_EQ] = ACTIONS(2973),
    [anon_sym_GT_EQ] = ACTIONS(2973),
    [anon_sym_LT_LT] = ACTIONS(2975),
    [anon_sym_GT_GT] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_SLASH] = ACTIONS(2951),
    [anon_sym_PERCENT] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2127] = {
    [anon_sym_COMMA] = ACTIONS(6195),
    [anon_sym_RBRACE] = ACTIONS(6195),
    [sym_comment] = ACTIONS(91),
  },
  [2128] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3581),
    [anon_sym_RBRACE] = ACTIONS(3581),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2953),
    [anon_sym_QMARK] = ACTIONS(3581),
    [anon_sym_STAR_EQ] = ACTIONS(2957),
    [anon_sym_SLASH_EQ] = ACTIONS(2957),
    [anon_sym_PERCENT_EQ] = ACTIONS(2957),
    [anon_sym_PLUS_EQ] = ACTIONS(2957),
    [anon_sym_DASH_EQ] = ACTIONS(2957),
    [anon_sym_LT_LT_EQ] = ACTIONS(2957),
    [anon_sym_GT_GT_EQ] = ACTIONS(2957),
    [anon_sym_AMP_EQ] = ACTIONS(2957),
    [anon_sym_CARET_EQ] = ACTIONS(2957),
    [anon_sym_PIPE_EQ] = ACTIONS(2957),
    [anon_sym_AMP] = ACTIONS(2959),
    [anon_sym_PIPE_PIPE] = ACTIONS(2961),
    [anon_sym_AMP_AMP] = ACTIONS(2963),
    [anon_sym_PIPE] = ACTIONS(2965),
    [anon_sym_CARET] = ACTIONS(2967),
    [anon_sym_EQ_EQ] = ACTIONS(2969),
    [anon_sym_BANG_EQ] = ACTIONS(2969),
    [anon_sym_LT] = ACTIONS(2971),
    [anon_sym_GT] = ACTIONS(2971),
    [anon_sym_LT_EQ] = ACTIONS(2973),
    [anon_sym_GT_EQ] = ACTIONS(2973),
    [anon_sym_LT_LT] = ACTIONS(2975),
    [anon_sym_GT_GT] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_SLASH] = ACTIONS(2951),
    [anon_sym_PERCENT] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2129] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_COLON] = ACTIONS(6197),
    [anon_sym_QMARK] = ACTIONS(1171),
    [anon_sym_STAR_EQ] = ACTIONS(1173),
    [anon_sym_SLASH_EQ] = ACTIONS(1173),
    [anon_sym_PERCENT_EQ] = ACTIONS(1173),
    [anon_sym_PLUS_EQ] = ACTIONS(1173),
    [anon_sym_DASH_EQ] = ACTIONS(1173),
    [anon_sym_LT_LT_EQ] = ACTIONS(1173),
    [anon_sym_GT_GT_EQ] = ACTIONS(1173),
    [anon_sym_AMP_EQ] = ACTIONS(1173),
    [anon_sym_CARET_EQ] = ACTIONS(1173),
    [anon_sym_PIPE_EQ] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_CARET] = ACTIONS(1183),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [2130] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3585),
    [anon_sym_RBRACE] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_STAR_EQ] = ACTIONS(3585),
    [anon_sym_SLASH_EQ] = ACTIONS(3585),
    [anon_sym_PERCENT_EQ] = ACTIONS(3585),
    [anon_sym_PLUS_EQ] = ACTIONS(3585),
    [anon_sym_DASH_EQ] = ACTIONS(3585),
    [anon_sym_LT_LT_EQ] = ACTIONS(3585),
    [anon_sym_GT_GT_EQ] = ACTIONS(3585),
    [anon_sym_AMP_EQ] = ACTIONS(3585),
    [anon_sym_CARET_EQ] = ACTIONS(3585),
    [anon_sym_PIPE_EQ] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(3587),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3587),
    [anon_sym_CARET] = ACTIONS(3587),
    [anon_sym_EQ_EQ] = ACTIONS(2969),
    [anon_sym_BANG_EQ] = ACTIONS(2969),
    [anon_sym_LT] = ACTIONS(2971),
    [anon_sym_GT] = ACTIONS(2971),
    [anon_sym_LT_EQ] = ACTIONS(2973),
    [anon_sym_GT_EQ] = ACTIONS(2973),
    [anon_sym_LT_LT] = ACTIONS(2975),
    [anon_sym_GT_GT] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_SLASH] = ACTIONS(2951),
    [anon_sym_PERCENT] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2131] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3589),
    [anon_sym_RBRACE] = ACTIONS(3589),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3591),
    [anon_sym_QMARK] = ACTIONS(3589),
    [anon_sym_STAR_EQ] = ACTIONS(3589),
    [anon_sym_SLASH_EQ] = ACTIONS(3589),
    [anon_sym_PERCENT_EQ] = ACTIONS(3589),
    [anon_sym_PLUS_EQ] = ACTIONS(3589),
    [anon_sym_DASH_EQ] = ACTIONS(3589),
    [anon_sym_LT_LT_EQ] = ACTIONS(3589),
    [anon_sym_GT_GT_EQ] = ACTIONS(3589),
    [anon_sym_AMP_EQ] = ACTIONS(3589),
    [anon_sym_CARET_EQ] = ACTIONS(3589),
    [anon_sym_PIPE_EQ] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(2959),
    [anon_sym_PIPE_PIPE] = ACTIONS(3589),
    [anon_sym_AMP_AMP] = ACTIONS(2963),
    [anon_sym_PIPE] = ACTIONS(2965),
    [anon_sym_CARET] = ACTIONS(2967),
    [anon_sym_EQ_EQ] = ACTIONS(2969),
    [anon_sym_BANG_EQ] = ACTIONS(2969),
    [anon_sym_LT] = ACTIONS(2971),
    [anon_sym_GT] = ACTIONS(2971),
    [anon_sym_LT_EQ] = ACTIONS(2973),
    [anon_sym_GT_EQ] = ACTIONS(2973),
    [anon_sym_LT_LT] = ACTIONS(2975),
    [anon_sym_GT_GT] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_SLASH] = ACTIONS(2951),
    [anon_sym_PERCENT] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2132] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3589),
    [anon_sym_RBRACE] = ACTIONS(3589),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3591),
    [anon_sym_QMARK] = ACTIONS(3589),
    [anon_sym_STAR_EQ] = ACTIONS(3589),
    [anon_sym_SLASH_EQ] = ACTIONS(3589),
    [anon_sym_PERCENT_EQ] = ACTIONS(3589),
    [anon_sym_PLUS_EQ] = ACTIONS(3589),
    [anon_sym_DASH_EQ] = ACTIONS(3589),
    [anon_sym_LT_LT_EQ] = ACTIONS(3589),
    [anon_sym_GT_GT_EQ] = ACTIONS(3589),
    [anon_sym_AMP_EQ] = ACTIONS(3589),
    [anon_sym_CARET_EQ] = ACTIONS(3589),
    [anon_sym_PIPE_EQ] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(2959),
    [anon_sym_PIPE_PIPE] = ACTIONS(3589),
    [anon_sym_AMP_AMP] = ACTIONS(3589),
    [anon_sym_PIPE] = ACTIONS(2965),
    [anon_sym_CARET] = ACTIONS(2967),
    [anon_sym_EQ_EQ] = ACTIONS(2969),
    [anon_sym_BANG_EQ] = ACTIONS(2969),
    [anon_sym_LT] = ACTIONS(2971),
    [anon_sym_GT] = ACTIONS(2971),
    [anon_sym_LT_EQ] = ACTIONS(2973),
    [anon_sym_GT_EQ] = ACTIONS(2973),
    [anon_sym_LT_LT] = ACTIONS(2975),
    [anon_sym_GT_GT] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_SLASH] = ACTIONS(2951),
    [anon_sym_PERCENT] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2133] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3585),
    [anon_sym_RBRACE] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_STAR_EQ] = ACTIONS(3585),
    [anon_sym_SLASH_EQ] = ACTIONS(3585),
    [anon_sym_PERCENT_EQ] = ACTIONS(3585),
    [anon_sym_PLUS_EQ] = ACTIONS(3585),
    [anon_sym_DASH_EQ] = ACTIONS(3585),
    [anon_sym_LT_LT_EQ] = ACTIONS(3585),
    [anon_sym_GT_GT_EQ] = ACTIONS(3585),
    [anon_sym_AMP_EQ] = ACTIONS(3585),
    [anon_sym_CARET_EQ] = ACTIONS(3585),
    [anon_sym_PIPE_EQ] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(2959),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3587),
    [anon_sym_CARET] = ACTIONS(2967),
    [anon_sym_EQ_EQ] = ACTIONS(2969),
    [anon_sym_BANG_EQ] = ACTIONS(2969),
    [anon_sym_LT] = ACTIONS(2971),
    [anon_sym_GT] = ACTIONS(2971),
    [anon_sym_LT_EQ] = ACTIONS(2973),
    [anon_sym_GT_EQ] = ACTIONS(2973),
    [anon_sym_LT_LT] = ACTIONS(2975),
    [anon_sym_GT_GT] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_SLASH] = ACTIONS(2951),
    [anon_sym_PERCENT] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2134] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3585),
    [anon_sym_RBRACE] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_STAR_EQ] = ACTIONS(3585),
    [anon_sym_SLASH_EQ] = ACTIONS(3585),
    [anon_sym_PERCENT_EQ] = ACTIONS(3585),
    [anon_sym_PLUS_EQ] = ACTIONS(3585),
    [anon_sym_DASH_EQ] = ACTIONS(3585),
    [anon_sym_LT_LT_EQ] = ACTIONS(3585),
    [anon_sym_GT_GT_EQ] = ACTIONS(3585),
    [anon_sym_AMP_EQ] = ACTIONS(3585),
    [anon_sym_CARET_EQ] = ACTIONS(3585),
    [anon_sym_PIPE_EQ] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(2959),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3587),
    [anon_sym_CARET] = ACTIONS(3587),
    [anon_sym_EQ_EQ] = ACTIONS(2969),
    [anon_sym_BANG_EQ] = ACTIONS(2969),
    [anon_sym_LT] = ACTIONS(2971),
    [anon_sym_GT] = ACTIONS(2971),
    [anon_sym_LT_EQ] = ACTIONS(2973),
    [anon_sym_GT_EQ] = ACTIONS(2973),
    [anon_sym_LT_LT] = ACTIONS(2975),
    [anon_sym_GT_GT] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_SLASH] = ACTIONS(2951),
    [anon_sym_PERCENT] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2135] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3593),
    [anon_sym_RBRACE] = ACTIONS(3593),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3595),
    [anon_sym_QMARK] = ACTIONS(3593),
    [anon_sym_STAR_EQ] = ACTIONS(3593),
    [anon_sym_SLASH_EQ] = ACTIONS(3593),
    [anon_sym_PERCENT_EQ] = ACTIONS(3593),
    [anon_sym_PLUS_EQ] = ACTIONS(3593),
    [anon_sym_DASH_EQ] = ACTIONS(3593),
    [anon_sym_LT_LT_EQ] = ACTIONS(3593),
    [anon_sym_GT_GT_EQ] = ACTIONS(3593),
    [anon_sym_AMP_EQ] = ACTIONS(3593),
    [anon_sym_CARET_EQ] = ACTIONS(3593),
    [anon_sym_PIPE_EQ] = ACTIONS(3593),
    [anon_sym_AMP] = ACTIONS(3595),
    [anon_sym_PIPE_PIPE] = ACTIONS(3593),
    [anon_sym_AMP_AMP] = ACTIONS(3593),
    [anon_sym_PIPE] = ACTIONS(3595),
    [anon_sym_CARET] = ACTIONS(3595),
    [anon_sym_EQ_EQ] = ACTIONS(3593),
    [anon_sym_BANG_EQ] = ACTIONS(3593),
    [anon_sym_LT] = ACTIONS(2971),
    [anon_sym_GT] = ACTIONS(2971),
    [anon_sym_LT_EQ] = ACTIONS(2973),
    [anon_sym_GT_EQ] = ACTIONS(2973),
    [anon_sym_LT_LT] = ACTIONS(2975),
    [anon_sym_GT_GT] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_SLASH] = ACTIONS(2951),
    [anon_sym_PERCENT] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2136] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3597),
    [anon_sym_RBRACE] = ACTIONS(3597),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3599),
    [anon_sym_QMARK] = ACTIONS(3597),
    [anon_sym_STAR_EQ] = ACTIONS(3597),
    [anon_sym_SLASH_EQ] = ACTIONS(3597),
    [anon_sym_PERCENT_EQ] = ACTIONS(3597),
    [anon_sym_PLUS_EQ] = ACTIONS(3597),
    [anon_sym_DASH_EQ] = ACTIONS(3597),
    [anon_sym_LT_LT_EQ] = ACTIONS(3597),
    [anon_sym_GT_GT_EQ] = ACTIONS(3597),
    [anon_sym_AMP_EQ] = ACTIONS(3597),
    [anon_sym_CARET_EQ] = ACTIONS(3597),
    [anon_sym_PIPE_EQ] = ACTIONS(3597),
    [anon_sym_AMP] = ACTIONS(3599),
    [anon_sym_PIPE_PIPE] = ACTIONS(3597),
    [anon_sym_AMP_AMP] = ACTIONS(3597),
    [anon_sym_PIPE] = ACTIONS(3599),
    [anon_sym_CARET] = ACTIONS(3599),
    [anon_sym_EQ_EQ] = ACTIONS(3597),
    [anon_sym_BANG_EQ] = ACTIONS(3597),
    [anon_sym_LT] = ACTIONS(3599),
    [anon_sym_GT] = ACTIONS(3599),
    [anon_sym_LT_EQ] = ACTIONS(3597),
    [anon_sym_GT_EQ] = ACTIONS(3597),
    [anon_sym_LT_LT] = ACTIONS(2975),
    [anon_sym_GT_GT] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_SLASH] = ACTIONS(2951),
    [anon_sym_PERCENT] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2137] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3601),
    [anon_sym_RBRACE] = ACTIONS(3601),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3603),
    [anon_sym_QMARK] = ACTIONS(3601),
    [anon_sym_STAR_EQ] = ACTIONS(3601),
    [anon_sym_SLASH_EQ] = ACTIONS(3601),
    [anon_sym_PERCENT_EQ] = ACTIONS(3601),
    [anon_sym_PLUS_EQ] = ACTIONS(3601),
    [anon_sym_DASH_EQ] = ACTIONS(3601),
    [anon_sym_LT_LT_EQ] = ACTIONS(3601),
    [anon_sym_GT_GT_EQ] = ACTIONS(3601),
    [anon_sym_AMP_EQ] = ACTIONS(3601),
    [anon_sym_CARET_EQ] = ACTIONS(3601),
    [anon_sym_PIPE_EQ] = ACTIONS(3601),
    [anon_sym_AMP] = ACTIONS(3603),
    [anon_sym_PIPE_PIPE] = ACTIONS(3601),
    [anon_sym_AMP_AMP] = ACTIONS(3601),
    [anon_sym_PIPE] = ACTIONS(3603),
    [anon_sym_CARET] = ACTIONS(3603),
    [anon_sym_EQ_EQ] = ACTIONS(3601),
    [anon_sym_BANG_EQ] = ACTIONS(3601),
    [anon_sym_LT] = ACTIONS(3603),
    [anon_sym_GT] = ACTIONS(3603),
    [anon_sym_LT_EQ] = ACTIONS(3601),
    [anon_sym_GT_EQ] = ACTIONS(3601),
    [anon_sym_LT_LT] = ACTIONS(3603),
    [anon_sym_GT_GT] = ACTIONS(3603),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_SLASH] = ACTIONS(2951),
    [anon_sym_PERCENT] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2138] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3575),
    [anon_sym_RBRACE] = ACTIONS(3575),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3577),
    [anon_sym_QMARK] = ACTIONS(3575),
    [anon_sym_STAR_EQ] = ACTIONS(3575),
    [anon_sym_SLASH_EQ] = ACTIONS(3575),
    [anon_sym_PERCENT_EQ] = ACTIONS(3575),
    [anon_sym_PLUS_EQ] = ACTIONS(3575),
    [anon_sym_DASH_EQ] = ACTIONS(3575),
    [anon_sym_LT_LT_EQ] = ACTIONS(3575),
    [anon_sym_GT_GT_EQ] = ACTIONS(3575),
    [anon_sym_AMP_EQ] = ACTIONS(3575),
    [anon_sym_CARET_EQ] = ACTIONS(3575),
    [anon_sym_PIPE_EQ] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_PIPE_PIPE] = ACTIONS(3575),
    [anon_sym_AMP_AMP] = ACTIONS(3575),
    [anon_sym_PIPE] = ACTIONS(3577),
    [anon_sym_CARET] = ACTIONS(3577),
    [anon_sym_EQ_EQ] = ACTIONS(3575),
    [anon_sym_BANG_EQ] = ACTIONS(3575),
    [anon_sym_LT] = ACTIONS(3577),
    [anon_sym_GT] = ACTIONS(3577),
    [anon_sym_LT_EQ] = ACTIONS(3575),
    [anon_sym_GT_EQ] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3577),
    [anon_sym_GT_GT] = ACTIONS(3577),
    [anon_sym_PLUS] = ACTIONS(3577),
    [anon_sym_DASH] = ACTIONS(3577),
    [anon_sym_SLASH] = ACTIONS(2951),
    [anon_sym_PERCENT] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2139] = {
    [sym__expression] = STATE(2126),
    [sym_conditional_expression] = STATE(2126),
    [sym_assignment_expression] = STATE(2126),
    [sym_pointer_expression] = STATE(2126),
    [sym_logical_expression] = STATE(2126),
    [sym_bitwise_expression] = STATE(2126),
    [sym_equality_expression] = STATE(2126),
    [sym_relational_expression] = STATE(2126),
    [sym_shift_expression] = STATE(2126),
    [sym_math_expression] = STATE(2126),
    [sym_cast_expression] = STATE(2126),
    [sym_sizeof_expression] = STATE(2126),
    [sym_subscript_expression] = STATE(2126),
    [sym_call_expression] = STATE(2126),
    [sym_field_expression] = STATE(2126),
    [sym_compound_literal_expression] = STATE(2126),
    [sym_parenthesized_expression] = STATE(2126),
    [sym_initializer_list] = STATE(2127),
    [sym_initializer_pair] = STATE(2127),
    [sym_subscript_designator] = STATE(728),
    [sym_field_designator] = STATE(728),
    [sym_char_literal] = STATE(2126),
    [sym_concatenated_string] = STATE(2126),
    [sym_string_literal] = STATE(727),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2126),
    [sym_new_expression] = STATE(2126),
    [sym_delete_expression] = STATE(2126),
    [sym_lambda_expression] = STATE(2126),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [aux_sym_initializer_pair_repeat1] = STATE(728),
    [sym_raw_string_literal] = ACTIONS(4604),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_RBRACE] = ACTIONS(6199),
    [anon_sym_LPAREN2] = ACTIONS(1256),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_LBRACK] = ACTIONS(1260),
    [anon_sym_AMP] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(1262),
    [anon_sym_TILDE] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_DASH_DASH] = ACTIONS(1268),
    [anon_sym_PLUS_PLUS] = ACTIONS(1268),
    [anon_sym_sizeof] = ACTIONS(1270),
    [anon_sym_DOT] = ACTIONS(1272),
    [sym_number_literal] = ACTIONS(4604),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4608),
    [sym_false] = ACTIONS(4608),
    [sym_null] = ACTIONS(4608),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1276),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1280),
    [sym_nullptr] = ACTIONS(4608),
  },
  [2140] = {
    [aux_sym_initializer_list_repeat1] = STATE(2140),
    [anon_sym_COMMA] = ACTIONS(6201),
    [anon_sym_RBRACE] = ACTIONS(6195),
    [sym_comment] = ACTIONS(91),
  },
  [2141] = {
    [sym_string_literal] = STATE(2141),
    [aux_sym_concatenated_string_repeat1] = STATE(2141),
    [anon_sym_COMMA] = ACTIONS(3622),
    [anon_sym_RBRACE] = ACTIONS(3622),
    [anon_sym_LPAREN2] = ACTIONS(3622),
    [anon_sym_STAR] = ACTIONS(3624),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_EQ] = ACTIONS(3624),
    [anon_sym_QMARK] = ACTIONS(3622),
    [anon_sym_STAR_EQ] = ACTIONS(3622),
    [anon_sym_SLASH_EQ] = ACTIONS(3622),
    [anon_sym_PERCENT_EQ] = ACTIONS(3622),
    [anon_sym_PLUS_EQ] = ACTIONS(3622),
    [anon_sym_DASH_EQ] = ACTIONS(3622),
    [anon_sym_LT_LT_EQ] = ACTIONS(3622),
    [anon_sym_GT_GT_EQ] = ACTIONS(3622),
    [anon_sym_AMP_EQ] = ACTIONS(3622),
    [anon_sym_CARET_EQ] = ACTIONS(3622),
    [anon_sym_PIPE_EQ] = ACTIONS(3622),
    [anon_sym_AMP] = ACTIONS(3624),
    [anon_sym_PIPE_PIPE] = ACTIONS(3622),
    [anon_sym_AMP_AMP] = ACTIONS(3622),
    [anon_sym_PIPE] = ACTIONS(3624),
    [anon_sym_CARET] = ACTIONS(3624),
    [anon_sym_EQ_EQ] = ACTIONS(3622),
    [anon_sym_BANG_EQ] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3624),
    [anon_sym_GT] = ACTIONS(3624),
    [anon_sym_LT_EQ] = ACTIONS(3622),
    [anon_sym_GT_EQ] = ACTIONS(3622),
    [anon_sym_LT_LT] = ACTIONS(3624),
    [anon_sym_GT_GT] = ACTIONS(3624),
    [anon_sym_PLUS] = ACTIONS(3624),
    [anon_sym_DASH] = ACTIONS(3624),
    [anon_sym_SLASH] = ACTIONS(3624),
    [anon_sym_PERCENT] = ACTIONS(3624),
    [anon_sym_DASH_DASH] = ACTIONS(3622),
    [anon_sym_PLUS_PLUS] = ACTIONS(3622),
    [anon_sym_DOT] = ACTIONS(3622),
    [anon_sym_DASH_GT] = ACTIONS(3622),
    [anon_sym_DQUOTE] = ACTIONS(3626),
    [sym_comment] = ACTIONS(91),
  },
  [2142] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(6204),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_STAR_EQ] = ACTIONS(3507),
    [anon_sym_SLASH_EQ] = ACTIONS(3507),
    [anon_sym_PERCENT_EQ] = ACTIONS(3507),
    [anon_sym_PLUS_EQ] = ACTIONS(3507),
    [anon_sym_DASH_EQ] = ACTIONS(3507),
    [anon_sym_LT_LT_EQ] = ACTIONS(3507),
    [anon_sym_GT_GT_EQ] = ACTIONS(3507),
    [anon_sym_AMP_EQ] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(3507),
    [anon_sym_PIPE_EQ] = ACTIONS(3507),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_CARET] = ACTIONS(3517),
    [anon_sym_EQ_EQ] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3521),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3525),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2143] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(6206),
    [anon_sym_RBRACE] = ACTIONS(6206),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2953),
    [anon_sym_QMARK] = ACTIONS(2955),
    [anon_sym_STAR_EQ] = ACTIONS(2957),
    [anon_sym_SLASH_EQ] = ACTIONS(2957),
    [anon_sym_PERCENT_EQ] = ACTIONS(2957),
    [anon_sym_PLUS_EQ] = ACTIONS(2957),
    [anon_sym_DASH_EQ] = ACTIONS(2957),
    [anon_sym_LT_LT_EQ] = ACTIONS(2957),
    [anon_sym_GT_GT_EQ] = ACTIONS(2957),
    [anon_sym_AMP_EQ] = ACTIONS(2957),
    [anon_sym_CARET_EQ] = ACTIONS(2957),
    [anon_sym_PIPE_EQ] = ACTIONS(2957),
    [anon_sym_AMP] = ACTIONS(2959),
    [anon_sym_PIPE_PIPE] = ACTIONS(2961),
    [anon_sym_AMP_AMP] = ACTIONS(2963),
    [anon_sym_PIPE] = ACTIONS(2965),
    [anon_sym_CARET] = ACTIONS(2967),
    [anon_sym_EQ_EQ] = ACTIONS(2969),
    [anon_sym_BANG_EQ] = ACTIONS(2969),
    [anon_sym_LT] = ACTIONS(2971),
    [anon_sym_GT] = ACTIONS(2971),
    [anon_sym_LT_EQ] = ACTIONS(2973),
    [anon_sym_GT_EQ] = ACTIONS(2973),
    [anon_sym_LT_LT] = ACTIONS(2975),
    [anon_sym_GT_GT] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_SLASH] = ACTIONS(2951),
    [anon_sym_PERCENT] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2144] = {
    [anon_sym_COMMA] = ACTIONS(6206),
    [anon_sym_RBRACE] = ACTIONS(6206),
    [sym_comment] = ACTIONS(91),
  },
  [2145] = {
    [sym__expression] = STATE(1200),
    [sym_conditional_expression] = STATE(1200),
    [sym_assignment_expression] = STATE(1200),
    [sym_pointer_expression] = STATE(1200),
    [sym_logical_expression] = STATE(1200),
    [sym_bitwise_expression] = STATE(1200),
    [sym_equality_expression] = STATE(1200),
    [sym_relational_expression] = STATE(1200),
    [sym_shift_expression] = STATE(1200),
    [sym_math_expression] = STATE(1200),
    [sym_cast_expression] = STATE(1200),
    [sym_sizeof_expression] = STATE(1200),
    [sym_subscript_expression] = STATE(1200),
    [sym_call_expression] = STATE(1200),
    [sym_field_expression] = STATE(1200),
    [sym_compound_literal_expression] = STATE(1200),
    [sym_parenthesized_expression] = STATE(1200),
    [sym_initializer_list] = STATE(1201),
    [sym_char_literal] = STATE(1200),
    [sym_concatenated_string] = STATE(1200),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1200),
    [sym_new_expression] = STATE(1200),
    [sym_delete_expression] = STATE(1200),
    [sym_lambda_expression] = STATE(1200),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2523),
    [anon_sym_SEMI] = ACTIONS(4689),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(6208),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_EQ] = ACTIONS(4693),
    [anon_sym_QMARK] = ACTIONS(4689),
    [anon_sym_STAR_EQ] = ACTIONS(4689),
    [anon_sym_SLASH_EQ] = ACTIONS(4689),
    [anon_sym_PERCENT_EQ] = ACTIONS(4689),
    [anon_sym_PLUS_EQ] = ACTIONS(4689),
    [anon_sym_DASH_EQ] = ACTIONS(4689),
    [anon_sym_LT_LT_EQ] = ACTIONS(4689),
    [anon_sym_GT_GT_EQ] = ACTIONS(4689),
    [anon_sym_AMP_EQ] = ACTIONS(4689),
    [anon_sym_CARET_EQ] = ACTIONS(4689),
    [anon_sym_PIPE_EQ] = ACTIONS(4689),
    [anon_sym_AMP] = ACTIONS(6208),
    [anon_sym_PIPE_PIPE] = ACTIONS(4689),
    [anon_sym_AMP_AMP] = ACTIONS(4689),
    [anon_sym_BANG] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(4693),
    [anon_sym_CARET] = ACTIONS(4693),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_EQ_EQ] = ACTIONS(4689),
    [anon_sym_BANG_EQ] = ACTIONS(4689),
    [anon_sym_LT] = ACTIONS(4693),
    [anon_sym_GT] = ACTIONS(4693),
    [anon_sym_LT_EQ] = ACTIONS(4689),
    [anon_sym_GT_EQ] = ACTIONS(4689),
    [anon_sym_LT_LT] = ACTIONS(4693),
    [anon_sym_GT_GT] = ACTIONS(4693),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_SLASH] = ACTIONS(4693),
    [anon_sym_PERCENT] = ACTIONS(4693),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [anon_sym_DOT] = ACTIONS(4689),
    [anon_sym_DASH_GT] = ACTIONS(4689),
    [sym_number_literal] = ACTIONS(2523),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2525),
    [sym_false] = ACTIONS(2525),
    [sym_null] = ACTIONS(2525),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(2525),
  },
  [2146] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(4927),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(4929),
    [anon_sym_QMARK] = ACTIONS(4927),
    [anon_sym_STAR_EQ] = ACTIONS(4927),
    [anon_sym_SLASH_EQ] = ACTIONS(4927),
    [anon_sym_PERCENT_EQ] = ACTIONS(4927),
    [anon_sym_PLUS_EQ] = ACTIONS(4927),
    [anon_sym_DASH_EQ] = ACTIONS(4927),
    [anon_sym_LT_LT_EQ] = ACTIONS(4927),
    [anon_sym_GT_GT_EQ] = ACTIONS(4927),
    [anon_sym_AMP_EQ] = ACTIONS(4927),
    [anon_sym_CARET_EQ] = ACTIONS(4927),
    [anon_sym_PIPE_EQ] = ACTIONS(4927),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2147] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(6212),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_STAR_EQ] = ACTIONS(3507),
    [anon_sym_SLASH_EQ] = ACTIONS(3507),
    [anon_sym_PERCENT_EQ] = ACTIONS(3507),
    [anon_sym_PLUS_EQ] = ACTIONS(3507),
    [anon_sym_DASH_EQ] = ACTIONS(3507),
    [anon_sym_LT_LT_EQ] = ACTIONS(3507),
    [anon_sym_GT_GT_EQ] = ACTIONS(3507),
    [anon_sym_AMP_EQ] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(3507),
    [anon_sym_PIPE_EQ] = ACTIONS(3507),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_CARET] = ACTIONS(3517),
    [anon_sym_EQ_EQ] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3521),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3525),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2148] = {
    [sym__expression] = STATE(2767),
    [sym_conditional_expression] = STATE(2767),
    [sym_assignment_expression] = STATE(2767),
    [sym_pointer_expression] = STATE(2767),
    [sym_logical_expression] = STATE(2767),
    [sym_bitwise_expression] = STATE(2767),
    [sym_equality_expression] = STATE(2767),
    [sym_relational_expression] = STATE(2767),
    [sym_shift_expression] = STATE(2767),
    [sym_math_expression] = STATE(2767),
    [sym_cast_expression] = STATE(2767),
    [sym_sizeof_expression] = STATE(2767),
    [sym_subscript_expression] = STATE(2767),
    [sym_call_expression] = STATE(2767),
    [sym_field_expression] = STATE(2767),
    [sym_compound_literal_expression] = STATE(2767),
    [sym_parenthesized_expression] = STATE(2767),
    [sym_char_literal] = STATE(2767),
    [sym_concatenated_string] = STATE(2767),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2767),
    [sym_new_expression] = STATE(2767),
    [sym_delete_expression] = STATE(2767),
    [sym_lambda_expression] = STATE(2767),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6214),
    [anon_sym_LPAREN2] = ACTIONS(947),
    [anon_sym_STAR] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(947),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(6214),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6216),
    [sym_false] = ACTIONS(6216),
    [sym_null] = ACTIONS(6216),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(6216),
  },
  [2149] = {
    [sym__expression] = STATE(2768),
    [sym_conditional_expression] = STATE(2768),
    [sym_assignment_expression] = STATE(2768),
    [sym_pointer_expression] = STATE(2768),
    [sym_logical_expression] = STATE(2768),
    [sym_bitwise_expression] = STATE(2768),
    [sym_equality_expression] = STATE(2768),
    [sym_relational_expression] = STATE(2768),
    [sym_shift_expression] = STATE(2768),
    [sym_math_expression] = STATE(2768),
    [sym_cast_expression] = STATE(2768),
    [sym_sizeof_expression] = STATE(2768),
    [sym_subscript_expression] = STATE(2768),
    [sym_call_expression] = STATE(2768),
    [sym_field_expression] = STATE(2768),
    [sym_compound_literal_expression] = STATE(2768),
    [sym_parenthesized_expression] = STATE(2768),
    [sym_char_literal] = STATE(2768),
    [sym_concatenated_string] = STATE(2768),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2768),
    [sym_new_expression] = STATE(2768),
    [sym_delete_expression] = STATE(2768),
    [sym_lambda_expression] = STATE(2768),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6218),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(6218),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6220),
    [sym_false] = ACTIONS(6220),
    [sym_null] = ACTIONS(6220),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(6220),
  },
  [2150] = {
    [anon_sym_COMMA] = ACTIONS(2475),
    [anon_sym_LPAREN2] = ACTIONS(2475),
    [anon_sym_STAR] = ACTIONS(2477),
    [anon_sym_LBRACK] = ACTIONS(2475),
    [anon_sym_EQ] = ACTIONS(2477),
    [anon_sym_QMARK] = ACTIONS(2475),
    [anon_sym_STAR_EQ] = ACTIONS(2475),
    [anon_sym_SLASH_EQ] = ACTIONS(2475),
    [anon_sym_PERCENT_EQ] = ACTIONS(2475),
    [anon_sym_PLUS_EQ] = ACTIONS(2475),
    [anon_sym_DASH_EQ] = ACTIONS(2475),
    [anon_sym_LT_LT_EQ] = ACTIONS(2475),
    [anon_sym_GT_GT_EQ] = ACTIONS(2475),
    [anon_sym_AMP_EQ] = ACTIONS(2475),
    [anon_sym_CARET_EQ] = ACTIONS(2475),
    [anon_sym_PIPE_EQ] = ACTIONS(2475),
    [anon_sym_AMP] = ACTIONS(2477),
    [anon_sym_PIPE_PIPE] = ACTIONS(2475),
    [anon_sym_AMP_AMP] = ACTIONS(2475),
    [anon_sym_PIPE] = ACTIONS(2477),
    [anon_sym_CARET] = ACTIONS(2477),
    [anon_sym_EQ_EQ] = ACTIONS(2475),
    [anon_sym_BANG_EQ] = ACTIONS(2475),
    [anon_sym_LT] = ACTIONS(2477),
    [anon_sym_GT] = ACTIONS(2477),
    [anon_sym_LT_EQ] = ACTIONS(2475),
    [anon_sym_GT_EQ] = ACTIONS(2475),
    [anon_sym_LT_LT] = ACTIONS(2477),
    [anon_sym_GT_GT] = ACTIONS(2477),
    [anon_sym_PLUS] = ACTIONS(2477),
    [anon_sym_DASH] = ACTIONS(2477),
    [anon_sym_SLASH] = ACTIONS(2477),
    [anon_sym_PERCENT] = ACTIONS(2477),
    [anon_sym_DASH_DASH] = ACTIONS(2475),
    [anon_sym_PLUS_PLUS] = ACTIONS(2475),
    [anon_sym_DOT] = ACTIONS(2475),
    [anon_sym_DASH_GT] = ACTIONS(2475),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(2475),
  },
  [2151] = {
    [sym__expression] = STATE(2769),
    [sym_conditional_expression] = STATE(2769),
    [sym_assignment_expression] = STATE(2769),
    [sym_pointer_expression] = STATE(2769),
    [sym_logical_expression] = STATE(2769),
    [sym_bitwise_expression] = STATE(2769),
    [sym_equality_expression] = STATE(2769),
    [sym_relational_expression] = STATE(2769),
    [sym_shift_expression] = STATE(2769),
    [sym_math_expression] = STATE(2769),
    [sym_cast_expression] = STATE(2769),
    [sym_sizeof_expression] = STATE(2769),
    [sym_subscript_expression] = STATE(2769),
    [sym_call_expression] = STATE(2769),
    [sym_field_expression] = STATE(2769),
    [sym_compound_literal_expression] = STATE(2769),
    [sym_parenthesized_expression] = STATE(2769),
    [sym_initializer_list] = STATE(2770),
    [sym_char_literal] = STATE(2769),
    [sym_concatenated_string] = STATE(2769),
    [sym_string_literal] = STATE(780),
    [sym_template_type] = STATE(1454),
    [sym_template_function] = STATE(2769),
    [sym_new_expression] = STATE(2769),
    [sym_delete_expression] = STATE(2769),
    [sym_lambda_expression] = STATE(2769),
    [sym_lambda_capture_specifier] = STATE(782),
    [sym_scoped_identifier] = STATE(783),
    [sym_scoped_type_identifier] = STATE(1455),
    [sym_scoped_namespace_identifier] = STATE(1456),
    [sym_raw_string_literal] = ACTIONS(6222),
    [anon_sym_LBRACE] = ACTIONS(3114),
    [anon_sym_LPAREN2] = ACTIONS(1380),
    [anon_sym_STAR] = ACTIONS(1382),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1382),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1394),
    [anon_sym_PLUS_PLUS] = ACTIONS(1394),
    [anon_sym_sizeof] = ACTIONS(1396),
    [sym_number_literal] = ACTIONS(6222),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_true] = ACTIONS(6224),
    [sym_false] = ACTIONS(6224),
    [sym_null] = ACTIONS(6224),
    [sym_identifier] = ACTIONS(3084),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1410),
    [anon_sym_new] = ACTIONS(1412),
    [anon_sym_COLON_COLON] = ACTIONS(3086),
    [sym_nullptr] = ACTIONS(6224),
  },
  [2152] = {
    [sym_destructor_name] = STATE(2167),
    [anon_sym_TILDE] = ACTIONS(3149),
    [sym_identifier] = ACTIONS(6226),
    [sym_comment] = ACTIONS(91),
    [sym_operator_name] = ACTIONS(4727),
  },
  [2153] = {
    [anon_sym_COMMA] = ACTIONS(1424),
    [anon_sym_LBRACE] = ACTIONS(1431),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_STAR] = ACTIONS(1436),
    [anon_sym_LBRACK] = ACTIONS(1424),
    [anon_sym_EQ] = ACTIONS(1436),
    [anon_sym_QMARK] = ACTIONS(1424),
    [anon_sym_STAR_EQ] = ACTIONS(1424),
    [anon_sym_SLASH_EQ] = ACTIONS(1424),
    [anon_sym_PERCENT_EQ] = ACTIONS(1424),
    [anon_sym_PLUS_EQ] = ACTIONS(1424),
    [anon_sym_DASH_EQ] = ACTIONS(1424),
    [anon_sym_LT_LT_EQ] = ACTIONS(1424),
    [anon_sym_GT_GT_EQ] = ACTIONS(1424),
    [anon_sym_AMP_EQ] = ACTIONS(1424),
    [anon_sym_CARET_EQ] = ACTIONS(1424),
    [anon_sym_PIPE_EQ] = ACTIONS(1424),
    [anon_sym_AMP] = ACTIONS(1436),
    [anon_sym_PIPE_PIPE] = ACTIONS(1424),
    [anon_sym_AMP_AMP] = ACTIONS(1424),
    [anon_sym_PIPE] = ACTIONS(1436),
    [anon_sym_CARET] = ACTIONS(1436),
    [anon_sym_EQ_EQ] = ACTIONS(1424),
    [anon_sym_BANG_EQ] = ACTIONS(1424),
    [anon_sym_LT] = ACTIONS(1436),
    [anon_sym_GT] = ACTIONS(1436),
    [anon_sym_LT_EQ] = ACTIONS(1424),
    [anon_sym_GT_EQ] = ACTIONS(1424),
    [anon_sym_LT_LT] = ACTIONS(1436),
    [anon_sym_GT_GT] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1436),
    [anon_sym_DASH] = ACTIONS(1436),
    [anon_sym_SLASH] = ACTIONS(1436),
    [anon_sym_PERCENT] = ACTIONS(1436),
    [anon_sym_DASH_DASH] = ACTIONS(1424),
    [anon_sym_PLUS_PLUS] = ACTIONS(1424),
    [anon_sym_DOT] = ACTIONS(1424),
    [anon_sym_DASH_GT] = ACTIONS(1424),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(1424),
    [anon_sym_COLON_COLON] = ACTIONS(1431),
  },
  [2154] = {
    [anon_sym_COMMA] = ACTIONS(1575),
    [anon_sym_LBRACE] = ACTIONS(1582),
    [anon_sym_LPAREN2] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(1587),
    [anon_sym_LBRACK] = ACTIONS(1575),
    [anon_sym_EQ] = ACTIONS(1587),
    [anon_sym_QMARK] = ACTIONS(1575),
    [anon_sym_STAR_EQ] = ACTIONS(1575),
    [anon_sym_SLASH_EQ] = ACTIONS(1575),
    [anon_sym_PERCENT_EQ] = ACTIONS(1575),
    [anon_sym_PLUS_EQ] = ACTIONS(1575),
    [anon_sym_DASH_EQ] = ACTIONS(1575),
    [anon_sym_LT_LT_EQ] = ACTIONS(1575),
    [anon_sym_GT_GT_EQ] = ACTIONS(1575),
    [anon_sym_AMP_EQ] = ACTIONS(1575),
    [anon_sym_CARET_EQ] = ACTIONS(1575),
    [anon_sym_PIPE_EQ] = ACTIONS(1575),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_PIPE_PIPE] = ACTIONS(1575),
    [anon_sym_AMP_AMP] = ACTIONS(1575),
    [anon_sym_PIPE] = ACTIONS(1587),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_EQ_EQ] = ACTIONS(1575),
    [anon_sym_BANG_EQ] = ACTIONS(1575),
    [anon_sym_LT] = ACTIONS(1584),
    [anon_sym_GT] = ACTIONS(1587),
    [anon_sym_LT_EQ] = ACTIONS(1575),
    [anon_sym_GT_EQ] = ACTIONS(1575),
    [anon_sym_LT_LT] = ACTIONS(1587),
    [anon_sym_GT_GT] = ACTIONS(1587),
    [anon_sym_PLUS] = ACTIONS(1587),
    [anon_sym_DASH] = ACTIONS(1587),
    [anon_sym_SLASH] = ACTIONS(1587),
    [anon_sym_PERCENT] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1575),
    [anon_sym_PLUS_PLUS] = ACTIONS(1575),
    [anon_sym_DOT] = ACTIONS(1575),
    [anon_sym_DASH_GT] = ACTIONS(1575),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(1575),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
  },
  [2155] = {
    [sym_destructor_name] = STATE(2239),
    [anon_sym_TILDE] = ACTIONS(3149),
    [sym_identifier] = ACTIONS(6228),
    [sym_comment] = ACTIONS(91),
    [sym_operator_name] = ACTIONS(4857),
  },
  [2156] = {
    [anon_sym_RPAREN] = ACTIONS(6230),
    [sym_comment] = ACTIONS(91),
  },
  [2157] = {
    [anon_sym_COMMA] = ACTIONS(3059),
    [anon_sym_LPAREN2] = ACTIONS(3059),
    [anon_sym_STAR] = ACTIONS(3061),
    [anon_sym_LBRACK] = ACTIONS(3059),
    [anon_sym_EQ] = ACTIONS(3061),
    [anon_sym_QMARK] = ACTIONS(3059),
    [anon_sym_STAR_EQ] = ACTIONS(3059),
    [anon_sym_SLASH_EQ] = ACTIONS(3059),
    [anon_sym_PERCENT_EQ] = ACTIONS(3059),
    [anon_sym_PLUS_EQ] = ACTIONS(3059),
    [anon_sym_DASH_EQ] = ACTIONS(3059),
    [anon_sym_LT_LT_EQ] = ACTIONS(3059),
    [anon_sym_GT_GT_EQ] = ACTIONS(3059),
    [anon_sym_AMP_EQ] = ACTIONS(3059),
    [anon_sym_CARET_EQ] = ACTIONS(3059),
    [anon_sym_PIPE_EQ] = ACTIONS(3059),
    [anon_sym_AMP] = ACTIONS(3061),
    [anon_sym_PIPE_PIPE] = ACTIONS(3059),
    [anon_sym_AMP_AMP] = ACTIONS(3059),
    [anon_sym_PIPE] = ACTIONS(3061),
    [anon_sym_CARET] = ACTIONS(3061),
    [anon_sym_EQ_EQ] = ACTIONS(3059),
    [anon_sym_BANG_EQ] = ACTIONS(3059),
    [anon_sym_LT] = ACTIONS(3061),
    [anon_sym_GT] = ACTIONS(3061),
    [anon_sym_LT_EQ] = ACTIONS(3059),
    [anon_sym_GT_EQ] = ACTIONS(3059),
    [anon_sym_LT_LT] = ACTIONS(3061),
    [anon_sym_GT_GT] = ACTIONS(3061),
    [anon_sym_PLUS] = ACTIONS(3061),
    [anon_sym_DASH] = ACTIONS(3061),
    [anon_sym_SLASH] = ACTIONS(3061),
    [anon_sym_PERCENT] = ACTIONS(3061),
    [anon_sym_DASH_DASH] = ACTIONS(3059),
    [anon_sym_PLUS_PLUS] = ACTIONS(3059),
    [anon_sym_DOT] = ACTIONS(3059),
    [anon_sym_DASH_GT] = ACTIONS(3059),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3059),
  },
  [2158] = {
    [anon_sym_COMMA] = ACTIONS(3063),
    [anon_sym_LPAREN2] = ACTIONS(3063),
    [anon_sym_STAR] = ACTIONS(3065),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_EQ] = ACTIONS(3065),
    [anon_sym_QMARK] = ACTIONS(3063),
    [anon_sym_STAR_EQ] = ACTIONS(3063),
    [anon_sym_SLASH_EQ] = ACTIONS(3063),
    [anon_sym_PERCENT_EQ] = ACTIONS(3063),
    [anon_sym_PLUS_EQ] = ACTIONS(3063),
    [anon_sym_DASH_EQ] = ACTIONS(3063),
    [anon_sym_LT_LT_EQ] = ACTIONS(3063),
    [anon_sym_GT_GT_EQ] = ACTIONS(3063),
    [anon_sym_AMP_EQ] = ACTIONS(3063),
    [anon_sym_CARET_EQ] = ACTIONS(3063),
    [anon_sym_PIPE_EQ] = ACTIONS(3063),
    [anon_sym_AMP] = ACTIONS(3065),
    [anon_sym_PIPE_PIPE] = ACTIONS(3063),
    [anon_sym_AMP_AMP] = ACTIONS(3063),
    [anon_sym_PIPE] = ACTIONS(3065),
    [anon_sym_CARET] = ACTIONS(3065),
    [anon_sym_EQ_EQ] = ACTIONS(3063),
    [anon_sym_BANG_EQ] = ACTIONS(3063),
    [anon_sym_LT] = ACTIONS(3065),
    [anon_sym_GT] = ACTIONS(3065),
    [anon_sym_LT_EQ] = ACTIONS(3063),
    [anon_sym_GT_EQ] = ACTIONS(3063),
    [anon_sym_LT_LT] = ACTIONS(3065),
    [anon_sym_GT_GT] = ACTIONS(3065),
    [anon_sym_PLUS] = ACTIONS(3065),
    [anon_sym_DASH] = ACTIONS(3065),
    [anon_sym_SLASH] = ACTIONS(3065),
    [anon_sym_PERCENT] = ACTIONS(3065),
    [anon_sym_DASH_DASH] = ACTIONS(3063),
    [anon_sym_PLUS_PLUS] = ACTIONS(3063),
    [anon_sym_DOT] = ACTIONS(3063),
    [anon_sym_DASH_GT] = ACTIONS(3063),
    [anon_sym_DQUOTE] = ACTIONS(3063),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3063),
  },
  [2159] = {
    [anon_sym_RBRACE] = ACTIONS(6232),
    [sym_comment] = ACTIONS(91),
  },
  [2160] = {
    [anon_sym_COMMA] = ACTIONS(2919),
    [anon_sym_LPAREN2] = ACTIONS(2919),
    [anon_sym_STAR] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2919),
    [anon_sym_EQ] = ACTIONS(2921),
    [anon_sym_QMARK] = ACTIONS(2919),
    [anon_sym_STAR_EQ] = ACTIONS(2919),
    [anon_sym_SLASH_EQ] = ACTIONS(2919),
    [anon_sym_PERCENT_EQ] = ACTIONS(2919),
    [anon_sym_PLUS_EQ] = ACTIONS(2919),
    [anon_sym_DASH_EQ] = ACTIONS(2919),
    [anon_sym_LT_LT_EQ] = ACTIONS(2919),
    [anon_sym_GT_GT_EQ] = ACTIONS(2919),
    [anon_sym_AMP_EQ] = ACTIONS(2919),
    [anon_sym_CARET_EQ] = ACTIONS(2919),
    [anon_sym_PIPE_EQ] = ACTIONS(2919),
    [anon_sym_AMP] = ACTIONS(2921),
    [anon_sym_PIPE_PIPE] = ACTIONS(2919),
    [anon_sym_AMP_AMP] = ACTIONS(2919),
    [anon_sym_PIPE] = ACTIONS(2921),
    [anon_sym_CARET] = ACTIONS(2921),
    [anon_sym_EQ_EQ] = ACTIONS(2919),
    [anon_sym_BANG_EQ] = ACTIONS(2919),
    [anon_sym_LT] = ACTIONS(2921),
    [anon_sym_GT] = ACTIONS(2921),
    [anon_sym_LT_EQ] = ACTIONS(2919),
    [anon_sym_GT_EQ] = ACTIONS(2919),
    [anon_sym_LT_LT] = ACTIONS(2921),
    [anon_sym_GT_GT] = ACTIONS(2921),
    [anon_sym_PLUS] = ACTIONS(2921),
    [anon_sym_DASH] = ACTIONS(2921),
    [anon_sym_SLASH] = ACTIONS(2921),
    [anon_sym_PERCENT] = ACTIONS(2921),
    [anon_sym_DASH_DASH] = ACTIONS(2919),
    [anon_sym_PLUS_PLUS] = ACTIONS(2919),
    [anon_sym_DOT] = ACTIONS(2919),
    [anon_sym_DASH_GT] = ACTIONS(2919),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(2919),
  },
  [2161] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_initializer_list_repeat1] = STATE(2776),
    [anon_sym_COMMA] = ACTIONS(6234),
    [anon_sym_RBRACE] = ACTIONS(6232),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2953),
    [anon_sym_QMARK] = ACTIONS(2955),
    [anon_sym_STAR_EQ] = ACTIONS(2957),
    [anon_sym_SLASH_EQ] = ACTIONS(2957),
    [anon_sym_PERCENT_EQ] = ACTIONS(2957),
    [anon_sym_PLUS_EQ] = ACTIONS(2957),
    [anon_sym_DASH_EQ] = ACTIONS(2957),
    [anon_sym_LT_LT_EQ] = ACTIONS(2957),
    [anon_sym_GT_GT_EQ] = ACTIONS(2957),
    [anon_sym_AMP_EQ] = ACTIONS(2957),
    [anon_sym_CARET_EQ] = ACTIONS(2957),
    [anon_sym_PIPE_EQ] = ACTIONS(2957),
    [anon_sym_AMP] = ACTIONS(2959),
    [anon_sym_PIPE_PIPE] = ACTIONS(2961),
    [anon_sym_AMP_AMP] = ACTIONS(2963),
    [anon_sym_PIPE] = ACTIONS(2965),
    [anon_sym_CARET] = ACTIONS(2967),
    [anon_sym_EQ_EQ] = ACTIONS(2969),
    [anon_sym_BANG_EQ] = ACTIONS(2969),
    [anon_sym_LT] = ACTIONS(2971),
    [anon_sym_GT] = ACTIONS(2971),
    [anon_sym_LT_EQ] = ACTIONS(2973),
    [anon_sym_GT_EQ] = ACTIONS(2973),
    [anon_sym_LT_LT] = ACTIONS(2975),
    [anon_sym_GT_GT] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_SLASH] = ACTIONS(2951),
    [anon_sym_PERCENT] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2162] = {
    [aux_sym_initializer_list_repeat1] = STATE(2776),
    [anon_sym_COMMA] = ACTIONS(6234),
    [anon_sym_RBRACE] = ACTIONS(6232),
    [sym_comment] = ACTIONS(91),
  },
  [2163] = {
    [anon_sym_COMMA] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3121),
    [anon_sym_LPAREN2] = ACTIONS(3121),
    [anon_sym_STAR] = ACTIONS(3123),
    [anon_sym_LBRACK] = ACTIONS(3121),
    [anon_sym_EQ] = ACTIONS(3123),
    [anon_sym_COLON] = ACTIONS(3123),
    [anon_sym_QMARK] = ACTIONS(3121),
    [anon_sym_STAR_EQ] = ACTIONS(3121),
    [anon_sym_SLASH_EQ] = ACTIONS(3121),
    [anon_sym_PERCENT_EQ] = ACTIONS(3121),
    [anon_sym_PLUS_EQ] = ACTIONS(3121),
    [anon_sym_DASH_EQ] = ACTIONS(3121),
    [anon_sym_LT_LT_EQ] = ACTIONS(3121),
    [anon_sym_GT_GT_EQ] = ACTIONS(3121),
    [anon_sym_AMP_EQ] = ACTIONS(3121),
    [anon_sym_CARET_EQ] = ACTIONS(3121),
    [anon_sym_PIPE_EQ] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_PIPE_PIPE] = ACTIONS(3121),
    [anon_sym_AMP_AMP] = ACTIONS(3121),
    [anon_sym_PIPE] = ACTIONS(3123),
    [anon_sym_CARET] = ACTIONS(3123),
    [anon_sym_EQ_EQ] = ACTIONS(3121),
    [anon_sym_BANG_EQ] = ACTIONS(3121),
    [anon_sym_LT] = ACTIONS(3123),
    [anon_sym_GT] = ACTIONS(3123),
    [anon_sym_LT_EQ] = ACTIONS(3121),
    [anon_sym_GT_EQ] = ACTIONS(3121),
    [anon_sym_LT_LT] = ACTIONS(3123),
    [anon_sym_GT_GT] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3123),
    [anon_sym_PERCENT] = ACTIONS(3123),
    [anon_sym_DASH_DASH] = ACTIONS(3121),
    [anon_sym_PLUS_PLUS] = ACTIONS(3121),
    [anon_sym_DOT] = ACTIONS(3121),
    [anon_sym_DASH_GT] = ACTIONS(3121),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3121),
    [anon_sym_override] = ACTIONS(3121),
    [anon_sym_GT2] = ACTIONS(3121),
    [anon_sym_COLON_COLON] = ACTIONS(3121),
  },
  [2164] = {
    [sym_argument_list] = STATE(1511),
    [aux_sym_template_argument_list_repeat1] = STATE(2778),
    [anon_sym_COMMA] = ACTIONS(3163),
    [anon_sym_LPAREN2] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_EQ] = ACTIONS(3171),
    [anon_sym_QMARK] = ACTIONS(3173),
    [anon_sym_STAR_EQ] = ACTIONS(3175),
    [anon_sym_SLASH_EQ] = ACTIONS(3175),
    [anon_sym_PERCENT_EQ] = ACTIONS(3175),
    [anon_sym_PLUS_EQ] = ACTIONS(3175),
    [anon_sym_DASH_EQ] = ACTIONS(3175),
    [anon_sym_LT_LT_EQ] = ACTIONS(3175),
    [anon_sym_GT_GT_EQ] = ACTIONS(3175),
    [anon_sym_AMP_EQ] = ACTIONS(3175),
    [anon_sym_CARET_EQ] = ACTIONS(3175),
    [anon_sym_PIPE_EQ] = ACTIONS(3175),
    [anon_sym_AMP] = ACTIONS(3177),
    [anon_sym_PIPE_PIPE] = ACTIONS(3179),
    [anon_sym_AMP_AMP] = ACTIONS(3181),
    [anon_sym_PIPE] = ACTIONS(3183),
    [anon_sym_CARET] = ACTIONS(3185),
    [anon_sym_EQ_EQ] = ACTIONS(3187),
    [anon_sym_BANG_EQ] = ACTIONS(3187),
    [anon_sym_LT] = ACTIONS(3189),
    [anon_sym_GT] = ACTIONS(3189),
    [anon_sym_LT_EQ] = ACTIONS(3191),
    [anon_sym_GT_EQ] = ACTIONS(3191),
    [anon_sym_LT_LT] = ACTIONS(3193),
    [anon_sym_GT_GT] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_SLASH] = ACTIONS(3167),
    [anon_sym_PERCENT] = ACTIONS(3167),
    [anon_sym_DASH_DASH] = ACTIONS(3197),
    [anon_sym_PLUS_PLUS] = ACTIONS(3197),
    [anon_sym_DOT] = ACTIONS(3199),
    [anon_sym_DASH_GT] = ACTIONS(3199),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(6236),
  },
  [2165] = {
    [aux_sym_template_argument_list_repeat1] = STATE(2780),
    [anon_sym_COMMA] = ACTIONS(3163),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(6238),
  },
  [2166] = {
    [anon_sym_COMMA] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3218),
    [anon_sym_LPAREN2] = ACTIONS(3213),
    [anon_sym_STAR] = ACTIONS(3220),
    [anon_sym_LBRACK] = ACTIONS(3213),
    [anon_sym_EQ] = ACTIONS(3223),
    [anon_sym_QMARK] = ACTIONS(3211),
    [anon_sym_STAR_EQ] = ACTIONS(3211),
    [anon_sym_SLASH_EQ] = ACTIONS(3211),
    [anon_sym_PERCENT_EQ] = ACTIONS(3211),
    [anon_sym_PLUS_EQ] = ACTIONS(3211),
    [anon_sym_DASH_EQ] = ACTIONS(3211),
    [anon_sym_LT_LT_EQ] = ACTIONS(3211),
    [anon_sym_GT_GT_EQ] = ACTIONS(3211),
    [anon_sym_AMP_EQ] = ACTIONS(3211),
    [anon_sym_CARET_EQ] = ACTIONS(3211),
    [anon_sym_PIPE_EQ] = ACTIONS(3211),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym_PIPE_PIPE] = ACTIONS(3211),
    [anon_sym_AMP_AMP] = ACTIONS(3213),
    [anon_sym_PIPE] = ACTIONS(3223),
    [anon_sym_CARET] = ACTIONS(3223),
    [anon_sym_EQ_EQ] = ACTIONS(3211),
    [anon_sym_BANG_EQ] = ACTIONS(3211),
    [anon_sym_LT] = ACTIONS(3220),
    [anon_sym_GT] = ACTIONS(3223),
    [anon_sym_LT_EQ] = ACTIONS(3211),
    [anon_sym_GT_EQ] = ACTIONS(3211),
    [anon_sym_LT_LT] = ACTIONS(3223),
    [anon_sym_GT_GT] = ACTIONS(3223),
    [anon_sym_PLUS] = ACTIONS(3223),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_SLASH] = ACTIONS(3223),
    [anon_sym_PERCENT] = ACTIONS(3223),
    [anon_sym_DASH_DASH] = ACTIONS(3211),
    [anon_sym_PLUS_PLUS] = ACTIONS(3211),
    [anon_sym_DOT] = ACTIONS(3211),
    [anon_sym_DASH_GT] = ACTIONS(3211),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3213),
    [anon_sym_COLON_COLON] = ACTIONS(3225),
  },
  [2167] = {
    [anon_sym_COMMA] = ACTIONS(3211),
    [anon_sym_LBRACE] = ACTIONS(3211),
    [anon_sym_LPAREN2] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(3211),
    [anon_sym_EQ] = ACTIONS(3223),
    [anon_sym_QMARK] = ACTIONS(3211),
    [anon_sym_STAR_EQ] = ACTIONS(3211),
    [anon_sym_SLASH_EQ] = ACTIONS(3211),
    [anon_sym_PERCENT_EQ] = ACTIONS(3211),
    [anon_sym_PLUS_EQ] = ACTIONS(3211),
    [anon_sym_DASH_EQ] = ACTIONS(3211),
    [anon_sym_LT_LT_EQ] = ACTIONS(3211),
    [anon_sym_GT_GT_EQ] = ACTIONS(3211),
    [anon_sym_AMP_EQ] = ACTIONS(3211),
    [anon_sym_CARET_EQ] = ACTIONS(3211),
    [anon_sym_PIPE_EQ] = ACTIONS(3211),
    [anon_sym_AMP] = ACTIONS(3223),
    [anon_sym_PIPE_PIPE] = ACTIONS(3211),
    [anon_sym_AMP_AMP] = ACTIONS(3211),
    [anon_sym_PIPE] = ACTIONS(3223),
    [anon_sym_CARET] = ACTIONS(3223),
    [anon_sym_EQ_EQ] = ACTIONS(3211),
    [anon_sym_BANG_EQ] = ACTIONS(3211),
    [anon_sym_LT] = ACTIONS(3223),
    [anon_sym_GT] = ACTIONS(3223),
    [anon_sym_LT_EQ] = ACTIONS(3211),
    [anon_sym_GT_EQ] = ACTIONS(3211),
    [anon_sym_LT_LT] = ACTIONS(3223),
    [anon_sym_GT_GT] = ACTIONS(3223),
    [anon_sym_PLUS] = ACTIONS(3223),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_SLASH] = ACTIONS(3223),
    [anon_sym_PERCENT] = ACTIONS(3223),
    [anon_sym_DASH_DASH] = ACTIONS(3211),
    [anon_sym_PLUS_PLUS] = ACTIONS(3211),
    [anon_sym_DOT] = ACTIONS(3211),
    [anon_sym_DASH_GT] = ACTIONS(3211),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3211),
  },
  [2168] = {
    [sym__expression] = STATE(2781),
    [sym_conditional_expression] = STATE(2781),
    [sym_assignment_expression] = STATE(2781),
    [sym_pointer_expression] = STATE(2781),
    [sym_logical_expression] = STATE(2781),
    [sym_bitwise_expression] = STATE(2781),
    [sym_equality_expression] = STATE(2781),
    [sym_relational_expression] = STATE(2781),
    [sym_shift_expression] = STATE(2781),
    [sym_math_expression] = STATE(2781),
    [sym_cast_expression] = STATE(2781),
    [sym_sizeof_expression] = STATE(2781),
    [sym_subscript_expression] = STATE(2781),
    [sym_call_expression] = STATE(2781),
    [sym_field_expression] = STATE(2781),
    [sym_compound_literal_expression] = STATE(2781),
    [sym_parenthesized_expression] = STATE(2781),
    [sym_char_literal] = STATE(2781),
    [sym_concatenated_string] = STATE(2781),
    [sym_string_literal] = STATE(780),
    [sym_template_type] = STATE(1454),
    [sym_template_function] = STATE(2781),
    [sym_new_expression] = STATE(2781),
    [sym_delete_expression] = STATE(2781),
    [sym_lambda_expression] = STATE(2781),
    [sym_lambda_capture_specifier] = STATE(782),
    [sym_scoped_identifier] = STATE(783),
    [sym_scoped_type_identifier] = STATE(1455),
    [sym_scoped_namespace_identifier] = STATE(1456),
    [sym_raw_string_literal] = ACTIONS(6240),
    [anon_sym_LPAREN2] = ACTIONS(947),
    [anon_sym_STAR] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(947),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1394),
    [anon_sym_PLUS_PLUS] = ACTIONS(1394),
    [anon_sym_sizeof] = ACTIONS(1396),
    [sym_number_literal] = ACTIONS(6240),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_true] = ACTIONS(6242),
    [sym_false] = ACTIONS(6242),
    [sym_null] = ACTIONS(6242),
    [sym_identifier] = ACTIONS(3084),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1410),
    [anon_sym_new] = ACTIONS(1412),
    [anon_sym_COLON_COLON] = ACTIONS(3086),
    [sym_nullptr] = ACTIONS(6242),
  },
  [2169] = {
    [sym_enumerator] = STATE(2784),
    [anon_sym_COMMA] = ACTIONS(6244),
    [anon_sym_RBRACE] = ACTIONS(6246),
    [sym_identifier] = ACTIONS(1009),
    [sym_comment] = ACTIONS(91),
  },
  [2170] = {
    [sym_enumerator_list] = STATE(2785),
    [anon_sym_COMMA] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_LPAREN2] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(1011),
    [anon_sym_EQ] = ACTIONS(1013),
    [anon_sym_QMARK] = ACTIONS(1011),
    [anon_sym_STAR_EQ] = ACTIONS(1011),
    [anon_sym_SLASH_EQ] = ACTIONS(1011),
    [anon_sym_PERCENT_EQ] = ACTIONS(1011),
    [anon_sym_PLUS_EQ] = ACTIONS(1011),
    [anon_sym_DASH_EQ] = ACTIONS(1011),
    [anon_sym_LT_LT_EQ] = ACTIONS(1011),
    [anon_sym_GT_GT_EQ] = ACTIONS(1011),
    [anon_sym_AMP_EQ] = ACTIONS(1011),
    [anon_sym_CARET_EQ] = ACTIONS(1011),
    [anon_sym_PIPE_EQ] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1013),
    [anon_sym_PIPE_PIPE] = ACTIONS(1011),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_PIPE] = ACTIONS(1013),
    [anon_sym_CARET] = ACTIONS(1013),
    [anon_sym_EQ_EQ] = ACTIONS(1011),
    [anon_sym_BANG_EQ] = ACTIONS(1011),
    [anon_sym_LT] = ACTIONS(1013),
    [anon_sym_GT] = ACTIONS(1013),
    [anon_sym_LT_EQ] = ACTIONS(1011),
    [anon_sym_GT_EQ] = ACTIONS(1011),
    [anon_sym_LT_LT] = ACTIONS(1013),
    [anon_sym_GT_GT] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_SLASH] = ACTIONS(1013),
    [anon_sym_PERCENT] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1011),
    [anon_sym_PLUS_PLUS] = ACTIONS(1011),
    [anon_sym_DOT] = ACTIONS(1011),
    [anon_sym_DASH_GT] = ACTIONS(1011),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(1011),
  },
  [2171] = {
    [anon_sym_COMMA] = ACTIONS(1015),
    [anon_sym_LBRACE] = ACTIONS(1015),
    [anon_sym_LPAREN2] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1015),
    [anon_sym_EQ] = ACTIONS(1017),
    [anon_sym_QMARK] = ACTIONS(1015),
    [anon_sym_STAR_EQ] = ACTIONS(1015),
    [anon_sym_SLASH_EQ] = ACTIONS(1015),
    [anon_sym_PERCENT_EQ] = ACTIONS(1015),
    [anon_sym_PLUS_EQ] = ACTIONS(1015),
    [anon_sym_DASH_EQ] = ACTIONS(1015),
    [anon_sym_LT_LT_EQ] = ACTIONS(1015),
    [anon_sym_GT_GT_EQ] = ACTIONS(1015),
    [anon_sym_AMP_EQ] = ACTIONS(1015),
    [anon_sym_CARET_EQ] = ACTIONS(1015),
    [anon_sym_PIPE_EQ] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(1017),
    [anon_sym_PIPE_PIPE] = ACTIONS(1015),
    [anon_sym_AMP_AMP] = ACTIONS(1015),
    [anon_sym_PIPE] = ACTIONS(1017),
    [anon_sym_CARET] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1015),
    [anon_sym_BANG_EQ] = ACTIONS(1015),
    [anon_sym_LT] = ACTIONS(1017),
    [anon_sym_GT] = ACTIONS(1017),
    [anon_sym_LT_EQ] = ACTIONS(1015),
    [anon_sym_GT_EQ] = ACTIONS(1015),
    [anon_sym_LT_LT] = ACTIONS(1017),
    [anon_sym_GT_GT] = ACTIONS(1017),
    [anon_sym_PLUS] = ACTIONS(1017),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1017),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_DOT] = ACTIONS(1015),
    [anon_sym_DASH_GT] = ACTIONS(1015),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(1015),
  },
  [2172] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(2787),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(2787),
    [sym_type_definition] = STATE(2787),
    [sym__declaration_specifiers] = STATE(598),
    [sym__declarator] = STATE(599),
    [sym_pointer_declarator] = STATE(599),
    [sym_function_declarator] = STATE(600),
    [sym_array_declarator] = STATE(599),
    [sym_storage_class_specifier] = STATE(605),
    [sym_type_qualifier] = STATE(605),
    [sym__type_specifier] = STATE(601),
    [sym_sized_type_specifier] = STATE(601),
    [sym_enum_specifier] = STATE(601),
    [sym_struct_specifier] = STATE(601),
    [sym_union_specifier] = STATE(601),
    [sym__field_declaration_list_item] = STATE(2787),
    [sym_field_declaration] = STATE(2787),
    [sym_macro_type_specifier] = STATE(601),
    [sym_class_specifier] = STATE(601),
    [sym_dependent_type] = STATE(601),
    [sym_template_declaration] = STATE(2787),
    [sym_inline_method_definition] = STATE(2787),
    [sym_constructor_or_destructor_definition] = STATE(2787),
    [sym_constructor_or_destructor_declaration] = STATE(2787),
    [sym_friend_declaration] = STATE(2787),
    [sym_access_specifier] = STATE(2787),
    [sym_reference_declarator] = STATE(599),
    [sym_template_type] = STATE(602),
    [sym_template_function] = STATE(599),
    [sym_using_declaration] = STATE(2787),
    [sym_alias_declaration] = STATE(2787),
    [sym_destructor_name] = STATE(599),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(603),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(2787),
    [aux_sym__declaration_specifiers_repeat1] = STATE(605),
    [aux_sym_sized_type_specifier_repeat1] = STATE(606),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1019),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1021),
    [anon_sym_typedef] = ACTIONS(1023),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(6248),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(425),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(1027),
    [anon_sym_long] = ACTIONS(1027),
    [anon_sym_short] = ACTIONS(1027),
    [sym_primitive_type] = ACTIONS(1029),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(1031),
    [anon_sym_union] = ACTIONS(1033),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(1035),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1039),
    [sym_auto] = ACTIONS(1029),
    [anon_sym_typename] = ACTIONS(1041),
    [anon_sym_template] = ACTIONS(1043),
    [anon_sym_friend] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1039),
    [anon_sym_protected] = ACTIONS(1039),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_COLON_COLON] = ACTIONS(1049),
    [sym_operator_name] = ACTIONS(1051),
  },
  [2173] = {
    [sym_field_declaration_list] = STATE(2788),
    [sym_virtual_specifier] = STATE(2789),
    [sym_base_class_clause] = STATE(2790),
    [sym_template_argument_list] = STATE(2186),
    [anon_sym_COMMA] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_LPAREN2] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_EQ] = ACTIONS(1059),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_QMARK] = ACTIONS(1057),
    [anon_sym_STAR_EQ] = ACTIONS(1057),
    [anon_sym_SLASH_EQ] = ACTIONS(1057),
    [anon_sym_PERCENT_EQ] = ACTIONS(1057),
    [anon_sym_PLUS_EQ] = ACTIONS(1057),
    [anon_sym_DASH_EQ] = ACTIONS(1057),
    [anon_sym_LT_LT_EQ] = ACTIONS(1057),
    [anon_sym_GT_GT_EQ] = ACTIONS(1057),
    [anon_sym_AMP_EQ] = ACTIONS(1057),
    [anon_sym_CARET_EQ] = ACTIONS(1057),
    [anon_sym_PIPE_EQ] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_EQ_EQ] = ACTIONS(1057),
    [anon_sym_BANG_EQ] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_LT_EQ] = ACTIONS(1057),
    [anon_sym_GT_EQ] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_SLASH] = ACTIONS(1059),
    [anon_sym_PERCENT] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1057),
    [anon_sym_PLUS_PLUS] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(1057),
    [anon_sym_DASH_GT] = ACTIONS(1057),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [anon_sym_GT2] = ACTIONS(1057),
    [anon_sym_COLON_COLON] = ACTIONS(4744),
  },
  [2174] = {
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_LBRACE] = ACTIONS(1069),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(1069),
    [anon_sym_EQ] = ACTIONS(1071),
    [anon_sym_QMARK] = ACTIONS(1069),
    [anon_sym_STAR_EQ] = ACTIONS(1069),
    [anon_sym_SLASH_EQ] = ACTIONS(1069),
    [anon_sym_PERCENT_EQ] = ACTIONS(1069),
    [anon_sym_PLUS_EQ] = ACTIONS(1069),
    [anon_sym_DASH_EQ] = ACTIONS(1069),
    [anon_sym_LT_LT_EQ] = ACTIONS(1069),
    [anon_sym_GT_GT_EQ] = ACTIONS(1069),
    [anon_sym_AMP_EQ] = ACTIONS(1069),
    [anon_sym_CARET_EQ] = ACTIONS(1069),
    [anon_sym_PIPE_EQ] = ACTIONS(1069),
    [anon_sym_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1069),
    [anon_sym_AMP_AMP] = ACTIONS(1069),
    [anon_sym_PIPE] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1071),
    [anon_sym_EQ_EQ] = ACTIONS(1069),
    [anon_sym_BANG_EQ] = ACTIONS(1069),
    [anon_sym_LT] = ACTIONS(1071),
    [anon_sym_GT] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1069),
    [anon_sym_GT_EQ] = ACTIONS(1069),
    [anon_sym_LT_LT] = ACTIONS(1071),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_DASH] = ACTIONS(1071),
    [anon_sym_SLASH] = ACTIONS(1071),
    [anon_sym_PERCENT] = ACTIONS(1071),
    [anon_sym_DASH_DASH] = ACTIONS(1069),
    [anon_sym_PLUS_PLUS] = ACTIONS(1069),
    [anon_sym_DOT] = ACTIONS(1069),
    [anon_sym_DASH_GT] = ACTIONS(1069),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(1069),
  },
  [2175] = {
    [sym_field_declaration_list] = STATE(2791),
    [sym_base_class_clause] = STATE(2792),
    [anon_sym_LBRACE] = ACTIONS(4735),
    [anon_sym_COLON] = ACTIONS(1073),
    [sym_comment] = ACTIONS(91),
  },
  [2176] = {
    [sym_field_declaration_list] = STATE(2791),
    [anon_sym_LBRACE] = ACTIONS(4735),
    [sym_comment] = ACTIONS(91),
  },
  [2177] = {
    [sym_field_declaration_list] = STATE(2791),
    [sym_virtual_specifier] = STATE(2793),
    [sym_base_class_clause] = STATE(2792),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_LBRACE] = ACTIONS(1069),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(1069),
    [anon_sym_EQ] = ACTIONS(1071),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_QMARK] = ACTIONS(1069),
    [anon_sym_STAR_EQ] = ACTIONS(1069),
    [anon_sym_SLASH_EQ] = ACTIONS(1069),
    [anon_sym_PERCENT_EQ] = ACTIONS(1069),
    [anon_sym_PLUS_EQ] = ACTIONS(1069),
    [anon_sym_DASH_EQ] = ACTIONS(1069),
    [anon_sym_LT_LT_EQ] = ACTIONS(1069),
    [anon_sym_GT_GT_EQ] = ACTIONS(1069),
    [anon_sym_AMP_EQ] = ACTIONS(1069),
    [anon_sym_CARET_EQ] = ACTIONS(1069),
    [anon_sym_PIPE_EQ] = ACTIONS(1069),
    [anon_sym_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1069),
    [anon_sym_AMP_AMP] = ACTIONS(1069),
    [anon_sym_PIPE] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1071),
    [anon_sym_EQ_EQ] = ACTIONS(1069),
    [anon_sym_BANG_EQ] = ACTIONS(1069),
    [anon_sym_LT] = ACTIONS(1071),
    [anon_sym_GT] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1069),
    [anon_sym_GT_EQ] = ACTIONS(1069),
    [anon_sym_LT_LT] = ACTIONS(1071),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_DASH] = ACTIONS(1071),
    [anon_sym_SLASH] = ACTIONS(1071),
    [anon_sym_PERCENT] = ACTIONS(1071),
    [anon_sym_DASH_DASH] = ACTIONS(1069),
    [anon_sym_PLUS_PLUS] = ACTIONS(1069),
    [anon_sym_DOT] = ACTIONS(1069),
    [anon_sym_DASH_GT] = ACTIONS(1069),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [anon_sym_GT2] = ACTIONS(1069),
    [anon_sym_COLON_COLON] = ACTIONS(4756),
  },
  [2178] = {
    [sym_field_declaration_list] = STATE(2791),
    [sym_virtual_specifier] = STATE(2793),
    [sym_base_class_clause] = STATE(2792),
    [sym_template_argument_list] = STATE(2200),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_LBRACE] = ACTIONS(1069),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(1069),
    [anon_sym_EQ] = ACTIONS(1071),
    [anon_sym_COLON] = ACTIONS(1073),
    [anon_sym_QMARK] = ACTIONS(1069),
    [anon_sym_STAR_EQ] = ACTIONS(1069),
    [anon_sym_SLASH_EQ] = ACTIONS(1069),
    [anon_sym_PERCENT_EQ] = ACTIONS(1069),
    [anon_sym_PLUS_EQ] = ACTIONS(1069),
    [anon_sym_DASH_EQ] = ACTIONS(1069),
    [anon_sym_LT_LT_EQ] = ACTIONS(1069),
    [anon_sym_GT_GT_EQ] = ACTIONS(1069),
    [anon_sym_AMP_EQ] = ACTIONS(1069),
    [anon_sym_CARET_EQ] = ACTIONS(1069),
    [anon_sym_PIPE_EQ] = ACTIONS(1069),
    [anon_sym_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1069),
    [anon_sym_AMP_AMP] = ACTIONS(1069),
    [anon_sym_PIPE] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1071),
    [anon_sym_EQ_EQ] = ACTIONS(1069),
    [anon_sym_BANG_EQ] = ACTIONS(1069),
    [anon_sym_LT] = ACTIONS(1071),
    [anon_sym_GT] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1069),
    [anon_sym_GT_EQ] = ACTIONS(1069),
    [anon_sym_LT_LT] = ACTIONS(1071),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_DASH] = ACTIONS(1071),
    [anon_sym_SLASH] = ACTIONS(1071),
    [anon_sym_PERCENT] = ACTIONS(1071),
    [anon_sym_DASH_DASH] = ACTIONS(1069),
    [anon_sym_PLUS_PLUS] = ACTIONS(1069),
    [anon_sym_DOT] = ACTIONS(1069),
    [anon_sym_DASH_GT] = ACTIONS(1069),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [anon_sym_GT2] = ACTIONS(1069),
  },
  [2179] = {
    [sym_field_declaration_list] = STATE(2794),
    [sym_virtual_specifier] = STATE(2795),
    [sym_base_class_clause] = STATE(2796),
    [sym_template_argument_list] = STATE(2186),
    [anon_sym_COMMA] = ACTIONS(1077),
    [anon_sym_LBRACE] = ACTIONS(1077),
    [anon_sym_LPAREN2] = ACTIONS(1077),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_LBRACK] = ACTIONS(1077),
    [anon_sym_EQ] = ACTIONS(1079),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_STAR_EQ] = ACTIONS(1077),
    [anon_sym_SLASH_EQ] = ACTIONS(1077),
    [anon_sym_PERCENT_EQ] = ACTIONS(1077),
    [anon_sym_PLUS_EQ] = ACTIONS(1077),
    [anon_sym_DASH_EQ] = ACTIONS(1077),
    [anon_sym_LT_LT_EQ] = ACTIONS(1077),
    [anon_sym_GT_GT_EQ] = ACTIONS(1077),
    [anon_sym_AMP_EQ] = ACTIONS(1077),
    [anon_sym_CARET_EQ] = ACTIONS(1077),
    [anon_sym_PIPE_EQ] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_PIPE_PIPE] = ACTIONS(1077),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_CARET] = ACTIONS(1079),
    [anon_sym_EQ_EQ] = ACTIONS(1077),
    [anon_sym_BANG_EQ] = ACTIONS(1077),
    [anon_sym_LT] = ACTIONS(1079),
    [anon_sym_GT] = ACTIONS(1079),
    [anon_sym_LT_EQ] = ACTIONS(1077),
    [anon_sym_GT_EQ] = ACTIONS(1077),
    [anon_sym_LT_LT] = ACTIONS(1079),
    [anon_sym_GT_GT] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(1079),
    [anon_sym_DASH] = ACTIONS(1079),
    [anon_sym_SLASH] = ACTIONS(1079),
    [anon_sym_PERCENT] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1077),
    [anon_sym_PLUS_PLUS] = ACTIONS(1077),
    [anon_sym_DOT] = ACTIONS(1077),
    [anon_sym_DASH_GT] = ACTIONS(1077),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [anon_sym_GT2] = ACTIONS(1077),
    [anon_sym_COLON_COLON] = ACTIONS(4744),
  },
  [2180] = {
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_LBRACE] = ACTIONS(1081),
    [anon_sym_LPAREN2] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1083),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(1083),
    [anon_sym_QMARK] = ACTIONS(1081),
    [anon_sym_STAR_EQ] = ACTIONS(1081),
    [anon_sym_SLASH_EQ] = ACTIONS(1081),
    [anon_sym_PERCENT_EQ] = ACTIONS(1081),
    [anon_sym_PLUS_EQ] = ACTIONS(1081),
    [anon_sym_DASH_EQ] = ACTIONS(1081),
    [anon_sym_LT_LT_EQ] = ACTIONS(1081),
    [anon_sym_GT_GT_EQ] = ACTIONS(1081),
    [anon_sym_AMP_EQ] = ACTIONS(1081),
    [anon_sym_CARET_EQ] = ACTIONS(1081),
    [anon_sym_PIPE_EQ] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_PIPE] = ACTIONS(1083),
    [anon_sym_CARET] = ACTIONS(1083),
    [anon_sym_EQ_EQ] = ACTIONS(1081),
    [anon_sym_BANG_EQ] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(1083),
    [anon_sym_GT] = ACTIONS(1083),
    [anon_sym_LT_EQ] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1081),
    [anon_sym_LT_LT] = ACTIONS(1083),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_SLASH] = ACTIONS(1083),
    [anon_sym_PERCENT] = ACTIONS(1083),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DOT] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(1081),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(1081),
  },
  [2181] = {
    [sym_field_declaration_list] = STATE(2797),
    [sym_base_class_clause] = STATE(2798),
    [anon_sym_LBRACE] = ACTIONS(4735),
    [anon_sym_COLON] = ACTIONS(1073),
    [sym_comment] = ACTIONS(91),
  },
  [2182] = {
    [sym_field_declaration_list] = STATE(2797),
    [anon_sym_LBRACE] = ACTIONS(4735),
    [sym_comment] = ACTIONS(91),
  },
  [2183] = {
    [sym_field_declaration_list] = STATE(2797),
    [sym_virtual_specifier] = STATE(2799),
    [sym_base_class_clause] = STATE(2798),
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_LBRACE] = ACTIONS(1081),
    [anon_sym_LPAREN2] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1083),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(1083),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_QMARK] = ACTIONS(1081),
    [anon_sym_STAR_EQ] = ACTIONS(1081),
    [anon_sym_SLASH_EQ] = ACTIONS(1081),
    [anon_sym_PERCENT_EQ] = ACTIONS(1081),
    [anon_sym_PLUS_EQ] = ACTIONS(1081),
    [anon_sym_DASH_EQ] = ACTIONS(1081),
    [anon_sym_LT_LT_EQ] = ACTIONS(1081),
    [anon_sym_GT_GT_EQ] = ACTIONS(1081),
    [anon_sym_AMP_EQ] = ACTIONS(1081),
    [anon_sym_CARET_EQ] = ACTIONS(1081),
    [anon_sym_PIPE_EQ] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_PIPE] = ACTIONS(1083),
    [anon_sym_CARET] = ACTIONS(1083),
    [anon_sym_EQ_EQ] = ACTIONS(1081),
    [anon_sym_BANG_EQ] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(1083),
    [anon_sym_GT] = ACTIONS(1083),
    [anon_sym_LT_EQ] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1081),
    [anon_sym_LT_LT] = ACTIONS(1083),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_SLASH] = ACTIONS(1083),
    [anon_sym_PERCENT] = ACTIONS(1083),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DOT] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(1081),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [anon_sym_GT2] = ACTIONS(1081),
    [anon_sym_COLON_COLON] = ACTIONS(4756),
  },
  [2184] = {
    [sym_field_declaration_list] = STATE(2797),
    [sym_virtual_specifier] = STATE(2799),
    [sym_base_class_clause] = STATE(2798),
    [sym_template_argument_list] = STATE(2200),
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_LBRACE] = ACTIONS(1081),
    [anon_sym_LPAREN2] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1083),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(1083),
    [anon_sym_COLON] = ACTIONS(1073),
    [anon_sym_QMARK] = ACTIONS(1081),
    [anon_sym_STAR_EQ] = ACTIONS(1081),
    [anon_sym_SLASH_EQ] = ACTIONS(1081),
    [anon_sym_PERCENT_EQ] = ACTIONS(1081),
    [anon_sym_PLUS_EQ] = ACTIONS(1081),
    [anon_sym_DASH_EQ] = ACTIONS(1081),
    [anon_sym_LT_LT_EQ] = ACTIONS(1081),
    [anon_sym_GT_GT_EQ] = ACTIONS(1081),
    [anon_sym_AMP_EQ] = ACTIONS(1081),
    [anon_sym_CARET_EQ] = ACTIONS(1081),
    [anon_sym_PIPE_EQ] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_PIPE] = ACTIONS(1083),
    [anon_sym_CARET] = ACTIONS(1083),
    [anon_sym_EQ_EQ] = ACTIONS(1081),
    [anon_sym_BANG_EQ] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(1083),
    [anon_sym_GT] = ACTIONS(1083),
    [anon_sym_LT_EQ] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1081),
    [anon_sym_LT_LT] = ACTIONS(1083),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_SLASH] = ACTIONS(1083),
    [anon_sym_PERCENT] = ACTIONS(1083),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DOT] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(1081),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [anon_sym_GT2] = ACTIONS(1081),
  },
  [2185] = {
    [sym_identifier] = ACTIONS(6250),
    [sym_comment] = ACTIONS(91),
  },
  [2186] = {
    [anon_sym_COMMA] = ACTIONS(1431),
    [anon_sym_LBRACE] = ACTIONS(1431),
    [anon_sym_LPAREN2] = ACTIONS(1431),
    [anon_sym_STAR] = ACTIONS(1429),
    [anon_sym_LBRACK] = ACTIONS(1431),
    [anon_sym_EQ] = ACTIONS(1429),
    [anon_sym_COLON] = ACTIONS(1429),
    [anon_sym_QMARK] = ACTIONS(1431),
    [anon_sym_STAR_EQ] = ACTIONS(1431),
    [anon_sym_SLASH_EQ] = ACTIONS(1431),
    [anon_sym_PERCENT_EQ] = ACTIONS(1431),
    [anon_sym_PLUS_EQ] = ACTIONS(1431),
    [anon_sym_DASH_EQ] = ACTIONS(1431),
    [anon_sym_LT_LT_EQ] = ACTIONS(1431),
    [anon_sym_GT_GT_EQ] = ACTIONS(1431),
    [anon_sym_AMP_EQ] = ACTIONS(1431),
    [anon_sym_CARET_EQ] = ACTIONS(1431),
    [anon_sym_PIPE_EQ] = ACTIONS(1431),
    [anon_sym_AMP] = ACTIONS(1429),
    [anon_sym_PIPE_PIPE] = ACTIONS(1431),
    [anon_sym_AMP_AMP] = ACTIONS(1431),
    [anon_sym_PIPE] = ACTIONS(1429),
    [anon_sym_CARET] = ACTIONS(1429),
    [anon_sym_EQ_EQ] = ACTIONS(1431),
    [anon_sym_BANG_EQ] = ACTIONS(1431),
    [anon_sym_LT] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1429),
    [anon_sym_LT_EQ] = ACTIONS(1431),
    [anon_sym_GT_EQ] = ACTIONS(1431),
    [anon_sym_LT_LT] = ACTIONS(1429),
    [anon_sym_GT_GT] = ACTIONS(1429),
    [anon_sym_PLUS] = ACTIONS(1429),
    [anon_sym_DASH] = ACTIONS(1429),
    [anon_sym_SLASH] = ACTIONS(1429),
    [anon_sym_PERCENT] = ACTIONS(1429),
    [anon_sym_DASH_DASH] = ACTIONS(1431),
    [anon_sym_PLUS_PLUS] = ACTIONS(1431),
    [anon_sym_DOT] = ACTIONS(1431),
    [anon_sym_DASH_GT] = ACTIONS(1431),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1431),
    [anon_sym_override] = ACTIONS(1431),
    [anon_sym_GT2] = ACTIONS(1431),
    [anon_sym_COLON_COLON] = ACTIONS(1431),
  },
  [2187] = {
    [sym_field_declaration_list] = STATE(2801),
    [sym_virtual_specifier] = STATE(2802),
    [sym_base_class_clause] = STATE(2803),
    [sym_template_argument_list] = STATE(2186),
    [anon_sym_COMMA] = ACTIONS(1438),
    [anon_sym_LBRACE] = ACTIONS(1438),
    [anon_sym_LPAREN2] = ACTIONS(1438),
    [anon_sym_STAR] = ACTIONS(1440),
    [anon_sym_LBRACK] = ACTIONS(1438),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_QMARK] = ACTIONS(1438),
    [anon_sym_STAR_EQ] = ACTIONS(1438),
    [anon_sym_SLASH_EQ] = ACTIONS(1438),
    [anon_sym_PERCENT_EQ] = ACTIONS(1438),
    [anon_sym_PLUS_EQ] = ACTIONS(1438),
    [anon_sym_DASH_EQ] = ACTIONS(1438),
    [anon_sym_LT_LT_EQ] = ACTIONS(1438),
    [anon_sym_GT_GT_EQ] = ACTIONS(1438),
    [anon_sym_AMP_EQ] = ACTIONS(1438),
    [anon_sym_CARET_EQ] = ACTIONS(1438),
    [anon_sym_PIPE_EQ] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_PIPE_PIPE] = ACTIONS(1438),
    [anon_sym_AMP_AMP] = ACTIONS(1438),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_CARET] = ACTIONS(1440),
    [anon_sym_EQ_EQ] = ACTIONS(1438),
    [anon_sym_BANG_EQ] = ACTIONS(1438),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_LT_EQ] = ACTIONS(1438),
    [anon_sym_GT_EQ] = ACTIONS(1438),
    [anon_sym_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_GT] = ACTIONS(1440),
    [anon_sym_PLUS] = ACTIONS(1440),
    [anon_sym_DASH] = ACTIONS(1440),
    [anon_sym_SLASH] = ACTIONS(1440),
    [anon_sym_PERCENT] = ACTIONS(1440),
    [anon_sym_DASH_DASH] = ACTIONS(1438),
    [anon_sym_PLUS_PLUS] = ACTIONS(1438),
    [anon_sym_DOT] = ACTIONS(1438),
    [anon_sym_DASH_GT] = ACTIONS(1438),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [anon_sym_GT2] = ACTIONS(1438),
    [anon_sym_COLON_COLON] = ACTIONS(4744),
  },
  [2188] = {
    [anon_sym_COMMA] = ACTIONS(1442),
    [anon_sym_LBRACE] = ACTIONS(1442),
    [anon_sym_LPAREN2] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1444),
    [anon_sym_LBRACK] = ACTIONS(1442),
    [anon_sym_EQ] = ACTIONS(1444),
    [anon_sym_QMARK] = ACTIONS(1442),
    [anon_sym_STAR_EQ] = ACTIONS(1442),
    [anon_sym_SLASH_EQ] = ACTIONS(1442),
    [anon_sym_PERCENT_EQ] = ACTIONS(1442),
    [anon_sym_PLUS_EQ] = ACTIONS(1442),
    [anon_sym_DASH_EQ] = ACTIONS(1442),
    [anon_sym_LT_LT_EQ] = ACTIONS(1442),
    [anon_sym_GT_GT_EQ] = ACTIONS(1442),
    [anon_sym_AMP_EQ] = ACTIONS(1442),
    [anon_sym_CARET_EQ] = ACTIONS(1442),
    [anon_sym_PIPE_EQ] = ACTIONS(1442),
    [anon_sym_AMP] = ACTIONS(1444),
    [anon_sym_PIPE_PIPE] = ACTIONS(1442),
    [anon_sym_AMP_AMP] = ACTIONS(1442),
    [anon_sym_PIPE] = ACTIONS(1444),
    [anon_sym_CARET] = ACTIONS(1444),
    [anon_sym_EQ_EQ] = ACTIONS(1442),
    [anon_sym_BANG_EQ] = ACTIONS(1442),
    [anon_sym_LT] = ACTIONS(1444),
    [anon_sym_GT] = ACTIONS(1444),
    [anon_sym_LT_EQ] = ACTIONS(1442),
    [anon_sym_GT_EQ] = ACTIONS(1442),
    [anon_sym_LT_LT] = ACTIONS(1444),
    [anon_sym_GT_GT] = ACTIONS(1444),
    [anon_sym_PLUS] = ACTIONS(1444),
    [anon_sym_DASH] = ACTIONS(1444),
    [anon_sym_SLASH] = ACTIONS(1444),
    [anon_sym_PERCENT] = ACTIONS(1444),
    [anon_sym_DASH_DASH] = ACTIONS(1442),
    [anon_sym_PLUS_PLUS] = ACTIONS(1442),
    [anon_sym_DOT] = ACTIONS(1442),
    [anon_sym_DASH_GT] = ACTIONS(1442),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(1442),
  },
  [2189] = {
    [sym_field_declaration_list] = STATE(2804),
    [sym_base_class_clause] = STATE(2805),
    [anon_sym_LBRACE] = ACTIONS(4735),
    [anon_sym_COLON] = ACTIONS(1073),
    [sym_comment] = ACTIONS(91),
  },
  [2190] = {
    [sym_field_declaration_list] = STATE(2804),
    [anon_sym_LBRACE] = ACTIONS(4735),
    [sym_comment] = ACTIONS(91),
  },
  [2191] = {
    [sym_field_declaration_list] = STATE(2804),
    [sym_virtual_specifier] = STATE(2806),
    [sym_base_class_clause] = STATE(2805),
    [anon_sym_COMMA] = ACTIONS(1442),
    [anon_sym_LBRACE] = ACTIONS(1442),
    [anon_sym_LPAREN2] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1444),
    [anon_sym_LBRACK] = ACTIONS(1442),
    [anon_sym_EQ] = ACTIONS(1444),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_QMARK] = ACTIONS(1442),
    [anon_sym_STAR_EQ] = ACTIONS(1442),
    [anon_sym_SLASH_EQ] = ACTIONS(1442),
    [anon_sym_PERCENT_EQ] = ACTIONS(1442),
    [anon_sym_PLUS_EQ] = ACTIONS(1442),
    [anon_sym_DASH_EQ] = ACTIONS(1442),
    [anon_sym_LT_LT_EQ] = ACTIONS(1442),
    [anon_sym_GT_GT_EQ] = ACTIONS(1442),
    [anon_sym_AMP_EQ] = ACTIONS(1442),
    [anon_sym_CARET_EQ] = ACTIONS(1442),
    [anon_sym_PIPE_EQ] = ACTIONS(1442),
    [anon_sym_AMP] = ACTIONS(1444),
    [anon_sym_PIPE_PIPE] = ACTIONS(1442),
    [anon_sym_AMP_AMP] = ACTIONS(1442),
    [anon_sym_PIPE] = ACTIONS(1444),
    [anon_sym_CARET] = ACTIONS(1444),
    [anon_sym_EQ_EQ] = ACTIONS(1442),
    [anon_sym_BANG_EQ] = ACTIONS(1442),
    [anon_sym_LT] = ACTIONS(1444),
    [anon_sym_GT] = ACTIONS(1444),
    [anon_sym_LT_EQ] = ACTIONS(1442),
    [anon_sym_GT_EQ] = ACTIONS(1442),
    [anon_sym_LT_LT] = ACTIONS(1444),
    [anon_sym_GT_GT] = ACTIONS(1444),
    [anon_sym_PLUS] = ACTIONS(1444),
    [anon_sym_DASH] = ACTIONS(1444),
    [anon_sym_SLASH] = ACTIONS(1444),
    [anon_sym_PERCENT] = ACTIONS(1444),
    [anon_sym_DASH_DASH] = ACTIONS(1442),
    [anon_sym_PLUS_PLUS] = ACTIONS(1442),
    [anon_sym_DOT] = ACTIONS(1442),
    [anon_sym_DASH_GT] = ACTIONS(1442),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [anon_sym_GT2] = ACTIONS(1442),
    [anon_sym_COLON_COLON] = ACTIONS(4756),
  },
  [2192] = {
    [sym_field_declaration_list] = STATE(2804),
    [sym_virtual_specifier] = STATE(2806),
    [sym_base_class_clause] = STATE(2805),
    [sym_template_argument_list] = STATE(2200),
    [anon_sym_COMMA] = ACTIONS(1442),
    [anon_sym_LBRACE] = ACTIONS(1442),
    [anon_sym_LPAREN2] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1444),
    [anon_sym_LBRACK] = ACTIONS(1442),
    [anon_sym_EQ] = ACTIONS(1444),
    [anon_sym_COLON] = ACTIONS(1073),
    [anon_sym_QMARK] = ACTIONS(1442),
    [anon_sym_STAR_EQ] = ACTIONS(1442),
    [anon_sym_SLASH_EQ] = ACTIONS(1442),
    [anon_sym_PERCENT_EQ] = ACTIONS(1442),
    [anon_sym_PLUS_EQ] = ACTIONS(1442),
    [anon_sym_DASH_EQ] = ACTIONS(1442),
    [anon_sym_LT_LT_EQ] = ACTIONS(1442),
    [anon_sym_GT_GT_EQ] = ACTIONS(1442),
    [anon_sym_AMP_EQ] = ACTIONS(1442),
    [anon_sym_CARET_EQ] = ACTIONS(1442),
    [anon_sym_PIPE_EQ] = ACTIONS(1442),
    [anon_sym_AMP] = ACTIONS(1444),
    [anon_sym_PIPE_PIPE] = ACTIONS(1442),
    [anon_sym_AMP_AMP] = ACTIONS(1442),
    [anon_sym_PIPE] = ACTIONS(1444),
    [anon_sym_CARET] = ACTIONS(1444),
    [anon_sym_EQ_EQ] = ACTIONS(1442),
    [anon_sym_BANG_EQ] = ACTIONS(1442),
    [anon_sym_LT] = ACTIONS(1444),
    [anon_sym_GT] = ACTIONS(1444),
    [anon_sym_LT_EQ] = ACTIONS(1442),
    [anon_sym_GT_EQ] = ACTIONS(1442),
    [anon_sym_LT_LT] = ACTIONS(1444),
    [anon_sym_GT_GT] = ACTIONS(1444),
    [anon_sym_PLUS] = ACTIONS(1444),
    [anon_sym_DASH] = ACTIONS(1444),
    [anon_sym_SLASH] = ACTIONS(1444),
    [anon_sym_PERCENT] = ACTIONS(1444),
    [anon_sym_DASH_DASH] = ACTIONS(1442),
    [anon_sym_PLUS_PLUS] = ACTIONS(1442),
    [anon_sym_DOT] = ACTIONS(1442),
    [anon_sym_DASH_GT] = ACTIONS(1442),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [anon_sym_GT2] = ACTIONS(1442),
  },
  [2193] = {
    [anon_sym_COMMA] = ACTIONS(1446),
    [anon_sym_LBRACE] = ACTIONS(1446),
    [anon_sym_LPAREN2] = ACTIONS(1446),
    [anon_sym_STAR] = ACTIONS(1448),
    [anon_sym_LBRACK] = ACTIONS(1446),
    [anon_sym_EQ] = ACTIONS(1448),
    [anon_sym_QMARK] = ACTIONS(1446),
    [anon_sym_STAR_EQ] = ACTIONS(1446),
    [anon_sym_SLASH_EQ] = ACTIONS(1446),
    [anon_sym_PERCENT_EQ] = ACTIONS(1446),
    [anon_sym_PLUS_EQ] = ACTIONS(1446),
    [anon_sym_DASH_EQ] = ACTIONS(1446),
    [anon_sym_LT_LT_EQ] = ACTIONS(1446),
    [anon_sym_GT_GT_EQ] = ACTIONS(1446),
    [anon_sym_AMP_EQ] = ACTIONS(1446),
    [anon_sym_CARET_EQ] = ACTIONS(1446),
    [anon_sym_PIPE_EQ] = ACTIONS(1446),
    [anon_sym_AMP] = ACTIONS(1448),
    [anon_sym_PIPE_PIPE] = ACTIONS(1446),
    [anon_sym_AMP_AMP] = ACTIONS(1446),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_CARET] = ACTIONS(1448),
    [anon_sym_EQ_EQ] = ACTIONS(1446),
    [anon_sym_BANG_EQ] = ACTIONS(1446),
    [anon_sym_LT] = ACTIONS(1448),
    [anon_sym_GT] = ACTIONS(1448),
    [anon_sym_LT_EQ] = ACTIONS(1446),
    [anon_sym_GT_EQ] = ACTIONS(1446),
    [anon_sym_LT_LT] = ACTIONS(1448),
    [anon_sym_GT_GT] = ACTIONS(1448),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [anon_sym_SLASH] = ACTIONS(1448),
    [anon_sym_PERCENT] = ACTIONS(1448),
    [anon_sym_DASH_DASH] = ACTIONS(1446),
    [anon_sym_PLUS_PLUS] = ACTIONS(1446),
    [anon_sym_DOT] = ACTIONS(1446),
    [anon_sym_DASH_GT] = ACTIONS(1446),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(1446),
  },
  [2194] = {
    [anon_sym_COMMA] = ACTIONS(1582),
    [anon_sym_LBRACE] = ACTIONS(1582),
    [anon_sym_LPAREN2] = ACTIONS(1582),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(1580),
    [anon_sym_COLON] = ACTIONS(1580),
    [anon_sym_QMARK] = ACTIONS(1582),
    [anon_sym_STAR_EQ] = ACTIONS(1582),
    [anon_sym_SLASH_EQ] = ACTIONS(1582),
    [anon_sym_PERCENT_EQ] = ACTIONS(1582),
    [anon_sym_PLUS_EQ] = ACTIONS(1582),
    [anon_sym_DASH_EQ] = ACTIONS(1582),
    [anon_sym_LT_LT_EQ] = ACTIONS(1582),
    [anon_sym_GT_GT_EQ] = ACTIONS(1582),
    [anon_sym_AMP_EQ] = ACTIONS(1582),
    [anon_sym_CARET_EQ] = ACTIONS(1582),
    [anon_sym_PIPE_EQ] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1582),
    [anon_sym_AMP_AMP] = ACTIONS(1582),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_EQ_EQ] = ACTIONS(1582),
    [anon_sym_BANG_EQ] = ACTIONS(1582),
    [anon_sym_LT] = ACTIONS(1580),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1582),
    [anon_sym_GT_EQ] = ACTIONS(1582),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1582),
    [anon_sym_DOT] = ACTIONS(1582),
    [anon_sym_DASH_GT] = ACTIONS(1582),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1582),
    [anon_sym_override] = ACTIONS(1582),
    [anon_sym_GT2] = ACTIONS(1582),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
  },
  [2195] = {
    [sym__expression] = STATE(2807),
    [sym_conditional_expression] = STATE(2807),
    [sym_assignment_expression] = STATE(2807),
    [sym_pointer_expression] = STATE(2807),
    [sym_logical_expression] = STATE(2807),
    [sym_bitwise_expression] = STATE(2807),
    [sym_equality_expression] = STATE(2807),
    [sym_relational_expression] = STATE(2807),
    [sym_shift_expression] = STATE(2807),
    [sym_math_expression] = STATE(2807),
    [sym_cast_expression] = STATE(2807),
    [sym_sizeof_expression] = STATE(2807),
    [sym_subscript_expression] = STATE(2807),
    [sym_call_expression] = STATE(2807),
    [sym_field_expression] = STATE(2807),
    [sym_compound_literal_expression] = STATE(2807),
    [sym_parenthesized_expression] = STATE(2807),
    [sym_char_literal] = STATE(2807),
    [sym_concatenated_string] = STATE(2807),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2807),
    [sym_new_expression] = STATE(2807),
    [sym_delete_expression] = STATE(2807),
    [sym_lambda_expression] = STATE(2807),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6252),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(6252),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6254),
    [sym_false] = ACTIONS(6254),
    [sym_null] = ACTIONS(6254),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(6254),
  },
  [2196] = {
    [anon_sym_COMMA] = ACTIONS(3372),
    [anon_sym_LPAREN2] = ACTIONS(3372),
    [anon_sym_STAR] = ACTIONS(3374),
    [anon_sym_LBRACK] = ACTIONS(3372),
    [anon_sym_EQ] = ACTIONS(3374),
    [anon_sym_QMARK] = ACTIONS(3372),
    [anon_sym_STAR_EQ] = ACTIONS(3372),
    [anon_sym_SLASH_EQ] = ACTIONS(3372),
    [anon_sym_PERCENT_EQ] = ACTIONS(3372),
    [anon_sym_PLUS_EQ] = ACTIONS(3372),
    [anon_sym_DASH_EQ] = ACTIONS(3372),
    [anon_sym_LT_LT_EQ] = ACTIONS(3372),
    [anon_sym_GT_GT_EQ] = ACTIONS(3372),
    [anon_sym_AMP_EQ] = ACTIONS(3372),
    [anon_sym_CARET_EQ] = ACTIONS(3372),
    [anon_sym_PIPE_EQ] = ACTIONS(3372),
    [anon_sym_AMP] = ACTIONS(3374),
    [anon_sym_PIPE_PIPE] = ACTIONS(3372),
    [anon_sym_AMP_AMP] = ACTIONS(3372),
    [anon_sym_PIPE] = ACTIONS(3374),
    [anon_sym_CARET] = ACTIONS(3374),
    [anon_sym_EQ_EQ] = ACTIONS(3372),
    [anon_sym_BANG_EQ] = ACTIONS(3372),
    [anon_sym_LT] = ACTIONS(3374),
    [anon_sym_GT] = ACTIONS(3374),
    [anon_sym_LT_EQ] = ACTIONS(3372),
    [anon_sym_GT_EQ] = ACTIONS(3372),
    [anon_sym_LT_LT] = ACTIONS(3374),
    [anon_sym_GT_GT] = ACTIONS(3374),
    [anon_sym_PLUS] = ACTIONS(3374),
    [anon_sym_DASH] = ACTIONS(3374),
    [anon_sym_SLASH] = ACTIONS(3374),
    [anon_sym_PERCENT] = ACTIONS(3374),
    [anon_sym_DASH_DASH] = ACTIONS(3372),
    [anon_sym_PLUS_PLUS] = ACTIONS(3372),
    [anon_sym_DOT] = ACTIONS(3372),
    [anon_sym_DASH_GT] = ACTIONS(3372),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3372),
  },
  [2197] = {
    [sym_argument_list] = STATE(2808),
    [sym_initializer_list] = STATE(2808),
    [anon_sym_COMMA] = ACTIONS(3372),
    [anon_sym_LBRACE] = ACTIONS(3114),
    [anon_sym_LPAREN2] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3374),
    [anon_sym_LBRACK] = ACTIONS(3372),
    [anon_sym_EQ] = ACTIONS(3374),
    [anon_sym_QMARK] = ACTIONS(3372),
    [anon_sym_STAR_EQ] = ACTIONS(3372),
    [anon_sym_SLASH_EQ] = ACTIONS(3372),
    [anon_sym_PERCENT_EQ] = ACTIONS(3372),
    [anon_sym_PLUS_EQ] = ACTIONS(3372),
    [anon_sym_DASH_EQ] = ACTIONS(3372),
    [anon_sym_LT_LT_EQ] = ACTIONS(3372),
    [anon_sym_GT_GT_EQ] = ACTIONS(3372),
    [anon_sym_AMP_EQ] = ACTIONS(3372),
    [anon_sym_CARET_EQ] = ACTIONS(3372),
    [anon_sym_PIPE_EQ] = ACTIONS(3372),
    [anon_sym_AMP] = ACTIONS(3374),
    [anon_sym_PIPE_PIPE] = ACTIONS(3372),
    [anon_sym_AMP_AMP] = ACTIONS(3372),
    [anon_sym_PIPE] = ACTIONS(3374),
    [anon_sym_CARET] = ACTIONS(3374),
    [anon_sym_EQ_EQ] = ACTIONS(3372),
    [anon_sym_BANG_EQ] = ACTIONS(3372),
    [anon_sym_LT] = ACTIONS(3374),
    [anon_sym_GT] = ACTIONS(3374),
    [anon_sym_LT_EQ] = ACTIONS(3372),
    [anon_sym_GT_EQ] = ACTIONS(3372),
    [anon_sym_LT_LT] = ACTIONS(3374),
    [anon_sym_GT_GT] = ACTIONS(3374),
    [anon_sym_PLUS] = ACTIONS(3374),
    [anon_sym_DASH] = ACTIONS(3374),
    [anon_sym_SLASH] = ACTIONS(3374),
    [anon_sym_PERCENT] = ACTIONS(3374),
    [anon_sym_DASH_DASH] = ACTIONS(3372),
    [anon_sym_PLUS_PLUS] = ACTIONS(3372),
    [anon_sym_DOT] = ACTIONS(3372),
    [anon_sym_DASH_GT] = ACTIONS(3372),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3372),
  },
  [2198] = {
    [sym_argument_list] = STATE(2808),
    [sym_initializer_list] = STATE(2808),
    [sym_new_declarator] = STATE(2809),
    [anon_sym_COMMA] = ACTIONS(3372),
    [anon_sym_LBRACE] = ACTIONS(3114),
    [anon_sym_LPAREN2] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3374),
    [anon_sym_LBRACK] = ACTIONS(4752),
    [anon_sym_EQ] = ACTIONS(3374),
    [anon_sym_QMARK] = ACTIONS(3372),
    [anon_sym_STAR_EQ] = ACTIONS(3372),
    [anon_sym_SLASH_EQ] = ACTIONS(3372),
    [anon_sym_PERCENT_EQ] = ACTIONS(3372),
    [anon_sym_PLUS_EQ] = ACTIONS(3372),
    [anon_sym_DASH_EQ] = ACTIONS(3372),
    [anon_sym_LT_LT_EQ] = ACTIONS(3372),
    [anon_sym_GT_GT_EQ] = ACTIONS(3372),
    [anon_sym_AMP_EQ] = ACTIONS(3372),
    [anon_sym_CARET_EQ] = ACTIONS(3372),
    [anon_sym_PIPE_EQ] = ACTIONS(3372),
    [anon_sym_AMP] = ACTIONS(3374),
    [anon_sym_PIPE_PIPE] = ACTIONS(3372),
    [anon_sym_AMP_AMP] = ACTIONS(3372),
    [anon_sym_PIPE] = ACTIONS(3374),
    [anon_sym_CARET] = ACTIONS(3374),
    [anon_sym_EQ_EQ] = ACTIONS(3372),
    [anon_sym_BANG_EQ] = ACTIONS(3372),
    [anon_sym_LT] = ACTIONS(3374),
    [anon_sym_GT] = ACTIONS(3374),
    [anon_sym_LT_EQ] = ACTIONS(3372),
    [anon_sym_GT_EQ] = ACTIONS(3372),
    [anon_sym_LT_LT] = ACTIONS(3374),
    [anon_sym_GT_GT] = ACTIONS(3374),
    [anon_sym_PLUS] = ACTIONS(3374),
    [anon_sym_DASH] = ACTIONS(3374),
    [anon_sym_SLASH] = ACTIONS(3374),
    [anon_sym_PERCENT] = ACTIONS(3374),
    [anon_sym_DASH_DASH] = ACTIONS(3372),
    [anon_sym_PLUS_PLUS] = ACTIONS(3372),
    [anon_sym_DOT] = ACTIONS(3372),
    [anon_sym_DASH_GT] = ACTIONS(3372),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3372),
  },
  [2199] = {
    [sym_identifier] = ACTIONS(6256),
    [sym_comment] = ACTIONS(91),
  },
  [2200] = {
    [anon_sym_COMMA] = ACTIONS(1799),
    [anon_sym_LBRACE] = ACTIONS(1799),
    [anon_sym_LPAREN2] = ACTIONS(1799),
    [anon_sym_STAR] = ACTIONS(1801),
    [anon_sym_LBRACK] = ACTIONS(1799),
    [anon_sym_EQ] = ACTIONS(1801),
    [anon_sym_COLON] = ACTIONS(1801),
    [anon_sym_QMARK] = ACTIONS(1799),
    [anon_sym_STAR_EQ] = ACTIONS(1799),
    [anon_sym_SLASH_EQ] = ACTIONS(1799),
    [anon_sym_PERCENT_EQ] = ACTIONS(1799),
    [anon_sym_PLUS_EQ] = ACTIONS(1799),
    [anon_sym_DASH_EQ] = ACTIONS(1799),
    [anon_sym_LT_LT_EQ] = ACTIONS(1799),
    [anon_sym_GT_GT_EQ] = ACTIONS(1799),
    [anon_sym_AMP_EQ] = ACTIONS(1799),
    [anon_sym_CARET_EQ] = ACTIONS(1799),
    [anon_sym_PIPE_EQ] = ACTIONS(1799),
    [anon_sym_AMP] = ACTIONS(1801),
    [anon_sym_PIPE_PIPE] = ACTIONS(1799),
    [anon_sym_AMP_AMP] = ACTIONS(1799),
    [anon_sym_PIPE] = ACTIONS(1801),
    [anon_sym_CARET] = ACTIONS(1801),
    [anon_sym_EQ_EQ] = ACTIONS(1799),
    [anon_sym_BANG_EQ] = ACTIONS(1799),
    [anon_sym_LT] = ACTIONS(1801),
    [anon_sym_GT] = ACTIONS(1801),
    [anon_sym_LT_EQ] = ACTIONS(1799),
    [anon_sym_GT_EQ] = ACTIONS(1799),
    [anon_sym_LT_LT] = ACTIONS(1801),
    [anon_sym_GT_GT] = ACTIONS(1801),
    [anon_sym_PLUS] = ACTIONS(1801),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_SLASH] = ACTIONS(1801),
    [anon_sym_PERCENT] = ACTIONS(1801),
    [anon_sym_DASH_DASH] = ACTIONS(1799),
    [anon_sym_PLUS_PLUS] = ACTIONS(1799),
    [anon_sym_DOT] = ACTIONS(1799),
    [anon_sym_DASH_GT] = ACTIONS(1799),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1799),
    [anon_sym_override] = ACTIONS(1799),
    [anon_sym_GT2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(1799),
  },
  [2201] = {
    [anon_sym_COMMA] = ACTIONS(1977),
    [anon_sym_LBRACE] = ACTIONS(1977),
    [anon_sym_LPAREN2] = ACTIONS(1977),
    [anon_sym_STAR] = ACTIONS(1979),
    [anon_sym_LBRACK] = ACTIONS(1977),
    [anon_sym_EQ] = ACTIONS(1979),
    [anon_sym_QMARK] = ACTIONS(1977),
    [anon_sym_STAR_EQ] = ACTIONS(1977),
    [anon_sym_SLASH_EQ] = ACTIONS(1977),
    [anon_sym_PERCENT_EQ] = ACTIONS(1977),
    [anon_sym_PLUS_EQ] = ACTIONS(1977),
    [anon_sym_DASH_EQ] = ACTIONS(1977),
    [anon_sym_LT_LT_EQ] = ACTIONS(1977),
    [anon_sym_GT_GT_EQ] = ACTIONS(1977),
    [anon_sym_AMP_EQ] = ACTIONS(1977),
    [anon_sym_CARET_EQ] = ACTIONS(1977),
    [anon_sym_PIPE_EQ] = ACTIONS(1977),
    [anon_sym_AMP] = ACTIONS(1979),
    [anon_sym_PIPE_PIPE] = ACTIONS(1977),
    [anon_sym_AMP_AMP] = ACTIONS(1977),
    [anon_sym_PIPE] = ACTIONS(1979),
    [anon_sym_CARET] = ACTIONS(1979),
    [anon_sym_EQ_EQ] = ACTIONS(1977),
    [anon_sym_BANG_EQ] = ACTIONS(1977),
    [anon_sym_LT] = ACTIONS(1979),
    [anon_sym_GT] = ACTIONS(1979),
    [anon_sym_LT_EQ] = ACTIONS(1977),
    [anon_sym_GT_EQ] = ACTIONS(1977),
    [anon_sym_LT_LT] = ACTIONS(1979),
    [anon_sym_GT_GT] = ACTIONS(1979),
    [anon_sym_PLUS] = ACTIONS(1979),
    [anon_sym_DASH] = ACTIONS(1979),
    [anon_sym_SLASH] = ACTIONS(1979),
    [anon_sym_PERCENT] = ACTIONS(1979),
    [anon_sym_DASH_DASH] = ACTIONS(1977),
    [anon_sym_PLUS_PLUS] = ACTIONS(1977),
    [anon_sym_DOT] = ACTIONS(1977),
    [anon_sym_DASH_GT] = ACTIONS(1977),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(1977),
  },
  [2202] = {
    [anon_sym_COMMA] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1981),
    [anon_sym_LPAREN2] = ACTIONS(1981),
    [anon_sym_STAR] = ACTIONS(1983),
    [anon_sym_LBRACK] = ACTIONS(1981),
    [anon_sym_EQ] = ACTIONS(1983),
    [anon_sym_QMARK] = ACTIONS(1981),
    [anon_sym_STAR_EQ] = ACTIONS(1981),
    [anon_sym_SLASH_EQ] = ACTIONS(1981),
    [anon_sym_PERCENT_EQ] = ACTIONS(1981),
    [anon_sym_PLUS_EQ] = ACTIONS(1981),
    [anon_sym_DASH_EQ] = ACTIONS(1981),
    [anon_sym_LT_LT_EQ] = ACTIONS(1981),
    [anon_sym_GT_GT_EQ] = ACTIONS(1981),
    [anon_sym_AMP_EQ] = ACTIONS(1981),
    [anon_sym_CARET_EQ] = ACTIONS(1981),
    [anon_sym_PIPE_EQ] = ACTIONS(1981),
    [anon_sym_AMP] = ACTIONS(1983),
    [anon_sym_PIPE_PIPE] = ACTIONS(1981),
    [anon_sym_AMP_AMP] = ACTIONS(1981),
    [anon_sym_PIPE] = ACTIONS(1983),
    [anon_sym_CARET] = ACTIONS(1983),
    [anon_sym_EQ_EQ] = ACTIONS(1981),
    [anon_sym_BANG_EQ] = ACTIONS(1981),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_LT_EQ] = ACTIONS(1981),
    [anon_sym_GT_EQ] = ACTIONS(1981),
    [anon_sym_LT_LT] = ACTIONS(1983),
    [anon_sym_GT_GT] = ACTIONS(1983),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_SLASH] = ACTIONS(1983),
    [anon_sym_PERCENT] = ACTIONS(1983),
    [anon_sym_DASH_DASH] = ACTIONS(1981),
    [anon_sym_PLUS_PLUS] = ACTIONS(1981),
    [anon_sym_DOT] = ACTIONS(1981),
    [anon_sym_DASH_GT] = ACTIONS(1981),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(1981),
  },
  [2203] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2203),
    [anon_sym_COMMA] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(1985),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_EQ] = ACTIONS(1987),
    [anon_sym_unsigned] = ACTIONS(6258),
    [anon_sym_long] = ACTIONS(6258),
    [anon_sym_short] = ACTIONS(6258),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_QMARK] = ACTIONS(1985),
    [anon_sym_STAR_EQ] = ACTIONS(1985),
    [anon_sym_SLASH_EQ] = ACTIONS(1985),
    [anon_sym_PERCENT_EQ] = ACTIONS(1985),
    [anon_sym_PLUS_EQ] = ACTIONS(1985),
    [anon_sym_DASH_EQ] = ACTIONS(1985),
    [anon_sym_LT_LT_EQ] = ACTIONS(1985),
    [anon_sym_GT_GT_EQ] = ACTIONS(1985),
    [anon_sym_AMP_EQ] = ACTIONS(1985),
    [anon_sym_CARET_EQ] = ACTIONS(1985),
    [anon_sym_PIPE_EQ] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_PIPE_PIPE] = ACTIONS(1985),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_PIPE] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1987),
    [anon_sym_EQ_EQ] = ACTIONS(1985),
    [anon_sym_BANG_EQ] = ACTIONS(1985),
    [anon_sym_LT] = ACTIONS(1987),
    [anon_sym_GT] = ACTIONS(1987),
    [anon_sym_LT_EQ] = ACTIONS(1985),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_LT] = ACTIONS(1987),
    [anon_sym_GT_GT] = ACTIONS(1987),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_DASH] = ACTIONS(1987),
    [anon_sym_SLASH] = ACTIONS(1987),
    [anon_sym_PERCENT] = ACTIONS(1987),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DOT] = ACTIONS(1985),
    [anon_sym_DASH_GT] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(1985),
  },
  [2204] = {
    [anon_sym_COMMA] = ACTIONS(1354),
    [anon_sym_LBRACE] = ACTIONS(1354),
    [anon_sym_LPAREN2] = ACTIONS(1354),
    [anon_sym_STAR] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(1354),
    [anon_sym_EQ] = ACTIONS(3051),
    [anon_sym_QMARK] = ACTIONS(1354),
    [anon_sym_STAR_EQ] = ACTIONS(1354),
    [anon_sym_SLASH_EQ] = ACTIONS(1354),
    [anon_sym_PERCENT_EQ] = ACTIONS(1354),
    [anon_sym_PLUS_EQ] = ACTIONS(1354),
    [anon_sym_DASH_EQ] = ACTIONS(1354),
    [anon_sym_LT_LT_EQ] = ACTIONS(1354),
    [anon_sym_GT_GT_EQ] = ACTIONS(1354),
    [anon_sym_AMP_EQ] = ACTIONS(1354),
    [anon_sym_CARET_EQ] = ACTIONS(1354),
    [anon_sym_PIPE_EQ] = ACTIONS(1354),
    [anon_sym_AMP] = ACTIONS(3051),
    [anon_sym_PIPE_PIPE] = ACTIONS(1354),
    [anon_sym_AMP_AMP] = ACTIONS(1354),
    [anon_sym_PIPE] = ACTIONS(3051),
    [anon_sym_CARET] = ACTIONS(3051),
    [anon_sym_EQ_EQ] = ACTIONS(1354),
    [anon_sym_BANG_EQ] = ACTIONS(1354),
    [anon_sym_LT] = ACTIONS(3051),
    [anon_sym_GT] = ACTIONS(3051),
    [anon_sym_LT_EQ] = ACTIONS(1354),
    [anon_sym_GT_EQ] = ACTIONS(1354),
    [anon_sym_LT_LT] = ACTIONS(3051),
    [anon_sym_GT_GT] = ACTIONS(3051),
    [anon_sym_PLUS] = ACTIONS(3051),
    [anon_sym_DASH] = ACTIONS(3051),
    [anon_sym_SLASH] = ACTIONS(3051),
    [anon_sym_PERCENT] = ACTIONS(3051),
    [anon_sym_DASH_DASH] = ACTIONS(1354),
    [anon_sym_PLUS_PLUS] = ACTIONS(1354),
    [anon_sym_DOT] = ACTIONS(1354),
    [anon_sym_DASH_GT] = ACTIONS(1354),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(1354),
  },
  [2205] = {
    [sym__expression] = STATE(164),
    [sym_conditional_expression] = STATE(164),
    [sym_assignment_expression] = STATE(164),
    [sym_pointer_expression] = STATE(164),
    [sym_logical_expression] = STATE(164),
    [sym_bitwise_expression] = STATE(164),
    [sym_equality_expression] = STATE(164),
    [sym_relational_expression] = STATE(164),
    [sym_shift_expression] = STATE(164),
    [sym_math_expression] = STATE(164),
    [sym_cast_expression] = STATE(164),
    [sym_sizeof_expression] = STATE(164),
    [sym_subscript_expression] = STATE(164),
    [sym_call_expression] = STATE(164),
    [sym_field_expression] = STATE(164),
    [sym_compound_literal_expression] = STATE(164),
    [sym_parenthesized_expression] = STATE(164),
    [sym_char_literal] = STATE(164),
    [sym_concatenated_string] = STATE(164),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(164),
    [sym_new_expression] = STATE(164),
    [sym_delete_expression] = STATE(164),
    [sym_lambda_expression] = STATE(164),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_lambda_default_capture] = STATE(166),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(267),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(6261),
    [anon_sym_EQ] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(267),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(289),
    [sym_false] = ACTIONS(289),
    [sym_null] = ACTIONS(289),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(289),
  },
  [2206] = {
    [sym_argument_list] = STATE(1511),
    [anon_sym_COMMA] = ACTIONS(3383),
    [anon_sym_LPAREN2] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_EQ] = ACTIONS(3385),
    [anon_sym_QMARK] = ACTIONS(3383),
    [anon_sym_STAR_EQ] = ACTIONS(3383),
    [anon_sym_SLASH_EQ] = ACTIONS(3383),
    [anon_sym_PERCENT_EQ] = ACTIONS(3383),
    [anon_sym_PLUS_EQ] = ACTIONS(3383),
    [anon_sym_DASH_EQ] = ACTIONS(3383),
    [anon_sym_LT_LT_EQ] = ACTIONS(3383),
    [anon_sym_GT_GT_EQ] = ACTIONS(3383),
    [anon_sym_AMP_EQ] = ACTIONS(3383),
    [anon_sym_CARET_EQ] = ACTIONS(3383),
    [anon_sym_PIPE_EQ] = ACTIONS(3383),
    [anon_sym_AMP] = ACTIONS(3177),
    [anon_sym_PIPE_PIPE] = ACTIONS(3179),
    [anon_sym_AMP_AMP] = ACTIONS(3181),
    [anon_sym_PIPE] = ACTIONS(3183),
    [anon_sym_CARET] = ACTIONS(3185),
    [anon_sym_EQ_EQ] = ACTIONS(3187),
    [anon_sym_BANG_EQ] = ACTIONS(3187),
    [anon_sym_LT] = ACTIONS(3189),
    [anon_sym_GT] = ACTIONS(3189),
    [anon_sym_LT_EQ] = ACTIONS(3191),
    [anon_sym_GT_EQ] = ACTIONS(3191),
    [anon_sym_LT_LT] = ACTIONS(3193),
    [anon_sym_GT_GT] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_SLASH] = ACTIONS(3167),
    [anon_sym_PERCENT] = ACTIONS(3167),
    [anon_sym_DASH_DASH] = ACTIONS(3197),
    [anon_sym_PLUS_PLUS] = ACTIONS(3197),
    [anon_sym_DOT] = ACTIONS(3199),
    [anon_sym_DASH_GT] = ACTIONS(3199),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3383),
  },
  [2207] = {
    [sym_parameter_list] = STATE(2210),
    [anon_sym_COMMA] = ACTIONS(4157),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(4157),
  },
  [2208] = {
    [sym__abstract_declarator] = STATE(2812),
    [sym_abstract_pointer_declarator] = STATE(2812),
    [sym_abstract_function_declarator] = STATE(2812),
    [sym_abstract_array_declarator] = STATE(2812),
    [sym_type_qualifier] = STATE(2813),
    [sym_parameter_list] = STATE(1492),
    [sym_abstract_reference_declarator] = STATE(2812),
    [aux_sym_type_definition_repeat1] = STATE(2813),
    [anon_sym_COMMA] = ACTIONS(4157),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(3157),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(3159),
    [anon_sym_AMP_AMP] = ACTIONS(3161),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(4157),
  },
  [2209] = {
    [sym_parameter_list] = STATE(2210),
    [anon_sym_COMMA] = ACTIONS(4159),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(4159),
  },
  [2210] = {
    [sym_type_qualifier] = STATE(2814),
    [sym_trailing_return_type] = STATE(1720),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2814),
    [anon_sym_COMMA] = ACTIONS(3663),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(4775),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3663),
    [sym_noexcept] = ACTIONS(6263),
  },
  [2211] = {
    [sym__type_specifier] = STATE(2815),
    [sym_sized_type_specifier] = STATE(2815),
    [sym_enum_specifier] = STATE(2815),
    [sym_struct_specifier] = STATE(2815),
    [sym_union_specifier] = STATE(2815),
    [sym_macro_type_specifier] = STATE(2815),
    [sym_class_specifier] = STATE(2815),
    [sym_dependent_type] = STATE(2815),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_sized_type_specifier_repeat1] = STATE(787),
    [anon_sym_unsigned] = ACTIONS(1384),
    [anon_sym_long] = ACTIONS(1384),
    [anon_sym_short] = ACTIONS(1384),
    [sym_primitive_type] = ACTIONS(6265),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(6265),
    [anon_sym_typename] = ACTIONS(1406),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [2212] = {
    [sym_type_qualifier] = STATE(2816),
    [sym_trailing_return_type] = STATE(1720),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2816),
    [anon_sym_COMMA] = ACTIONS(3663),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(4775),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3663),
    [sym_noexcept] = ACTIONS(6267),
  },
  [2213] = {
    [sym_argument_list] = STATE(1511),
    [anon_sym_COMMA] = ACTIONS(6269),
    [anon_sym_LPAREN2] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_EQ] = ACTIONS(3171),
    [anon_sym_QMARK] = ACTIONS(3173),
    [anon_sym_STAR_EQ] = ACTIONS(3175),
    [anon_sym_SLASH_EQ] = ACTIONS(3175),
    [anon_sym_PERCENT_EQ] = ACTIONS(3175),
    [anon_sym_PLUS_EQ] = ACTIONS(3175),
    [anon_sym_DASH_EQ] = ACTIONS(3175),
    [anon_sym_LT_LT_EQ] = ACTIONS(3175),
    [anon_sym_GT_GT_EQ] = ACTIONS(3175),
    [anon_sym_AMP_EQ] = ACTIONS(3175),
    [anon_sym_CARET_EQ] = ACTIONS(3175),
    [anon_sym_PIPE_EQ] = ACTIONS(3175),
    [anon_sym_AMP] = ACTIONS(3177),
    [anon_sym_PIPE_PIPE] = ACTIONS(3179),
    [anon_sym_AMP_AMP] = ACTIONS(3181),
    [anon_sym_PIPE] = ACTIONS(3183),
    [anon_sym_CARET] = ACTIONS(3185),
    [anon_sym_EQ_EQ] = ACTIONS(3187),
    [anon_sym_BANG_EQ] = ACTIONS(3187),
    [anon_sym_LT] = ACTIONS(3189),
    [anon_sym_GT] = ACTIONS(3189),
    [anon_sym_LT_EQ] = ACTIONS(3191),
    [anon_sym_GT_EQ] = ACTIONS(3191),
    [anon_sym_LT_LT] = ACTIONS(3193),
    [anon_sym_GT_GT] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_SLASH] = ACTIONS(3167),
    [anon_sym_PERCENT] = ACTIONS(3167),
    [anon_sym_DASH_DASH] = ACTIONS(3197),
    [anon_sym_PLUS_PLUS] = ACTIONS(3197),
    [anon_sym_DOT] = ACTIONS(3199),
    [anon_sym_DASH_GT] = ACTIONS(3199),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(6269),
  },
  [2214] = {
    [anon_sym_COMMA] = ACTIONS(6271),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(6271),
  },
  [2215] = {
    [anon_sym_COMMA] = ACTIONS(3352),
    [anon_sym_LPAREN2] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(3354),
    [anon_sym_LBRACK] = ACTIONS(3352),
    [anon_sym_EQ] = ACTIONS(3354),
    [anon_sym_QMARK] = ACTIONS(3352),
    [anon_sym_STAR_EQ] = ACTIONS(3352),
    [anon_sym_SLASH_EQ] = ACTIONS(3352),
    [anon_sym_PERCENT_EQ] = ACTIONS(3352),
    [anon_sym_PLUS_EQ] = ACTIONS(3352),
    [anon_sym_DASH_EQ] = ACTIONS(3352),
    [anon_sym_LT_LT_EQ] = ACTIONS(3352),
    [anon_sym_GT_GT_EQ] = ACTIONS(3352),
    [anon_sym_AMP_EQ] = ACTIONS(3352),
    [anon_sym_CARET_EQ] = ACTIONS(3352),
    [anon_sym_PIPE_EQ] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3354),
    [anon_sym_PIPE_PIPE] = ACTIONS(3352),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_PIPE] = ACTIONS(3354),
    [anon_sym_CARET] = ACTIONS(3354),
    [anon_sym_EQ_EQ] = ACTIONS(3352),
    [anon_sym_BANG_EQ] = ACTIONS(3352),
    [anon_sym_LT] = ACTIONS(3354),
    [anon_sym_GT] = ACTIONS(3354),
    [anon_sym_LT_EQ] = ACTIONS(3352),
    [anon_sym_GT_EQ] = ACTIONS(3352),
    [anon_sym_LT_LT] = ACTIONS(3354),
    [anon_sym_GT_GT] = ACTIONS(3354),
    [anon_sym_PLUS] = ACTIONS(3354),
    [anon_sym_DASH] = ACTIONS(3354),
    [anon_sym_SLASH] = ACTIONS(3354),
    [anon_sym_PERCENT] = ACTIONS(3354),
    [anon_sym_DASH_DASH] = ACTIONS(3352),
    [anon_sym_PLUS_PLUS] = ACTIONS(3352),
    [anon_sym_DOT] = ACTIONS(3352),
    [anon_sym_DASH_GT] = ACTIONS(3352),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3352),
  },
  [2216] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_argument_list_repeat1] = STATE(2818),
    [anon_sym_COMMA] = ACTIONS(3356),
    [anon_sym_RPAREN] = ACTIONS(6273),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2217] = {
    [aux_sym_argument_list_repeat1] = STATE(2818),
    [anon_sym_COMMA] = ACTIONS(3356),
    [anon_sym_RPAREN] = ACTIONS(6273),
    [sym_comment] = ACTIONS(91),
  },
  [2218] = {
    [sym_argument_list] = STATE(1511),
    [anon_sym_COMMA] = ACTIONS(3575),
    [anon_sym_LPAREN2] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3577),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_EQ] = ACTIONS(3577),
    [anon_sym_QMARK] = ACTIONS(3575),
    [anon_sym_STAR_EQ] = ACTIONS(3575),
    [anon_sym_SLASH_EQ] = ACTIONS(3575),
    [anon_sym_PERCENT_EQ] = ACTIONS(3575),
    [anon_sym_PLUS_EQ] = ACTIONS(3575),
    [anon_sym_DASH_EQ] = ACTIONS(3575),
    [anon_sym_LT_LT_EQ] = ACTIONS(3575),
    [anon_sym_GT_GT_EQ] = ACTIONS(3575),
    [anon_sym_AMP_EQ] = ACTIONS(3575),
    [anon_sym_CARET_EQ] = ACTIONS(3575),
    [anon_sym_PIPE_EQ] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_PIPE_PIPE] = ACTIONS(3575),
    [anon_sym_AMP_AMP] = ACTIONS(3575),
    [anon_sym_PIPE] = ACTIONS(3577),
    [anon_sym_CARET] = ACTIONS(3577),
    [anon_sym_EQ_EQ] = ACTIONS(3575),
    [anon_sym_BANG_EQ] = ACTIONS(3575),
    [anon_sym_LT] = ACTIONS(3577),
    [anon_sym_GT] = ACTIONS(3577),
    [anon_sym_LT_EQ] = ACTIONS(3575),
    [anon_sym_GT_EQ] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3577),
    [anon_sym_GT_GT] = ACTIONS(3577),
    [anon_sym_PLUS] = ACTIONS(3577),
    [anon_sym_DASH] = ACTIONS(3577),
    [anon_sym_SLASH] = ACTIONS(3577),
    [anon_sym_PERCENT] = ACTIONS(3577),
    [anon_sym_DASH_DASH] = ACTIONS(3197),
    [anon_sym_PLUS_PLUS] = ACTIONS(3197),
    [anon_sym_DOT] = ACTIONS(3199),
    [anon_sym_DASH_GT] = ACTIONS(3199),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3575),
  },
  [2219] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(6275),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_STAR_EQ] = ACTIONS(3507),
    [anon_sym_SLASH_EQ] = ACTIONS(3507),
    [anon_sym_PERCENT_EQ] = ACTIONS(3507),
    [anon_sym_PLUS_EQ] = ACTIONS(3507),
    [anon_sym_DASH_EQ] = ACTIONS(3507),
    [anon_sym_LT_LT_EQ] = ACTIONS(3507),
    [anon_sym_GT_GT_EQ] = ACTIONS(3507),
    [anon_sym_AMP_EQ] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(3507),
    [anon_sym_PIPE_EQ] = ACTIONS(3507),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_CARET] = ACTIONS(3517),
    [anon_sym_EQ_EQ] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3521),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3525),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2220] = {
    [sym_argument_list] = STATE(1511),
    [anon_sym_COMMA] = ACTIONS(3581),
    [anon_sym_LPAREN2] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_EQ] = ACTIONS(3171),
    [anon_sym_QMARK] = ACTIONS(3581),
    [anon_sym_STAR_EQ] = ACTIONS(3175),
    [anon_sym_SLASH_EQ] = ACTIONS(3175),
    [anon_sym_PERCENT_EQ] = ACTIONS(3175),
    [anon_sym_PLUS_EQ] = ACTIONS(3175),
    [anon_sym_DASH_EQ] = ACTIONS(3175),
    [anon_sym_LT_LT_EQ] = ACTIONS(3175),
    [anon_sym_GT_GT_EQ] = ACTIONS(3175),
    [anon_sym_AMP_EQ] = ACTIONS(3175),
    [anon_sym_CARET_EQ] = ACTIONS(3175),
    [anon_sym_PIPE_EQ] = ACTIONS(3175),
    [anon_sym_AMP] = ACTIONS(3177),
    [anon_sym_PIPE_PIPE] = ACTIONS(3179),
    [anon_sym_AMP_AMP] = ACTIONS(3181),
    [anon_sym_PIPE] = ACTIONS(3183),
    [anon_sym_CARET] = ACTIONS(3185),
    [anon_sym_EQ_EQ] = ACTIONS(3187),
    [anon_sym_BANG_EQ] = ACTIONS(3187),
    [anon_sym_LT] = ACTIONS(3189),
    [anon_sym_GT] = ACTIONS(3189),
    [anon_sym_LT_EQ] = ACTIONS(3191),
    [anon_sym_GT_EQ] = ACTIONS(3191),
    [anon_sym_LT_LT] = ACTIONS(3193),
    [anon_sym_GT_GT] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_SLASH] = ACTIONS(3167),
    [anon_sym_PERCENT] = ACTIONS(3167),
    [anon_sym_DASH_DASH] = ACTIONS(3197),
    [anon_sym_PLUS_PLUS] = ACTIONS(3197),
    [anon_sym_DOT] = ACTIONS(3199),
    [anon_sym_DASH_GT] = ACTIONS(3199),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3581),
  },
  [2221] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_COLON] = ACTIONS(6277),
    [anon_sym_QMARK] = ACTIONS(1171),
    [anon_sym_STAR_EQ] = ACTIONS(1173),
    [anon_sym_SLASH_EQ] = ACTIONS(1173),
    [anon_sym_PERCENT_EQ] = ACTIONS(1173),
    [anon_sym_PLUS_EQ] = ACTIONS(1173),
    [anon_sym_DASH_EQ] = ACTIONS(1173),
    [anon_sym_LT_LT_EQ] = ACTIONS(1173),
    [anon_sym_GT_GT_EQ] = ACTIONS(1173),
    [anon_sym_AMP_EQ] = ACTIONS(1173),
    [anon_sym_CARET_EQ] = ACTIONS(1173),
    [anon_sym_PIPE_EQ] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_CARET] = ACTIONS(1183),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [2222] = {
    [sym_argument_list] = STATE(1511),
    [anon_sym_COMMA] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_STAR_EQ] = ACTIONS(3585),
    [anon_sym_SLASH_EQ] = ACTIONS(3585),
    [anon_sym_PERCENT_EQ] = ACTIONS(3585),
    [anon_sym_PLUS_EQ] = ACTIONS(3585),
    [anon_sym_DASH_EQ] = ACTIONS(3585),
    [anon_sym_LT_LT_EQ] = ACTIONS(3585),
    [anon_sym_GT_GT_EQ] = ACTIONS(3585),
    [anon_sym_AMP_EQ] = ACTIONS(3585),
    [anon_sym_CARET_EQ] = ACTIONS(3585),
    [anon_sym_PIPE_EQ] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(3587),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3587),
    [anon_sym_CARET] = ACTIONS(3587),
    [anon_sym_EQ_EQ] = ACTIONS(3187),
    [anon_sym_BANG_EQ] = ACTIONS(3187),
    [anon_sym_LT] = ACTIONS(3189),
    [anon_sym_GT] = ACTIONS(3189),
    [anon_sym_LT_EQ] = ACTIONS(3191),
    [anon_sym_GT_EQ] = ACTIONS(3191),
    [anon_sym_LT_LT] = ACTIONS(3193),
    [anon_sym_GT_GT] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_SLASH] = ACTIONS(3167),
    [anon_sym_PERCENT] = ACTIONS(3167),
    [anon_sym_DASH_DASH] = ACTIONS(3197),
    [anon_sym_PLUS_PLUS] = ACTIONS(3197),
    [anon_sym_DOT] = ACTIONS(3199),
    [anon_sym_DASH_GT] = ACTIONS(3199),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3585),
  },
  [2223] = {
    [sym_argument_list] = STATE(1511),
    [anon_sym_COMMA] = ACTIONS(3589),
    [anon_sym_LPAREN2] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_EQ] = ACTIONS(3591),
    [anon_sym_QMARK] = ACTIONS(3589),
    [anon_sym_STAR_EQ] = ACTIONS(3589),
    [anon_sym_SLASH_EQ] = ACTIONS(3589),
    [anon_sym_PERCENT_EQ] = ACTIONS(3589),
    [anon_sym_PLUS_EQ] = ACTIONS(3589),
    [anon_sym_DASH_EQ] = ACTIONS(3589),
    [anon_sym_LT_LT_EQ] = ACTIONS(3589),
    [anon_sym_GT_GT_EQ] = ACTIONS(3589),
    [anon_sym_AMP_EQ] = ACTIONS(3589),
    [anon_sym_CARET_EQ] = ACTIONS(3589),
    [anon_sym_PIPE_EQ] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(3177),
    [anon_sym_PIPE_PIPE] = ACTIONS(3589),
    [anon_sym_AMP_AMP] = ACTIONS(3181),
    [anon_sym_PIPE] = ACTIONS(3183),
    [anon_sym_CARET] = ACTIONS(3185),
    [anon_sym_EQ_EQ] = ACTIONS(3187),
    [anon_sym_BANG_EQ] = ACTIONS(3187),
    [anon_sym_LT] = ACTIONS(3189),
    [anon_sym_GT] = ACTIONS(3189),
    [anon_sym_LT_EQ] = ACTIONS(3191),
    [anon_sym_GT_EQ] = ACTIONS(3191),
    [anon_sym_LT_LT] = ACTIONS(3193),
    [anon_sym_GT_GT] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_SLASH] = ACTIONS(3167),
    [anon_sym_PERCENT] = ACTIONS(3167),
    [anon_sym_DASH_DASH] = ACTIONS(3197),
    [anon_sym_PLUS_PLUS] = ACTIONS(3197),
    [anon_sym_DOT] = ACTIONS(3199),
    [anon_sym_DASH_GT] = ACTIONS(3199),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3589),
  },
  [2224] = {
    [sym_argument_list] = STATE(1511),
    [anon_sym_COMMA] = ACTIONS(3589),
    [anon_sym_LPAREN2] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_EQ] = ACTIONS(3591),
    [anon_sym_QMARK] = ACTIONS(3589),
    [anon_sym_STAR_EQ] = ACTIONS(3589),
    [anon_sym_SLASH_EQ] = ACTIONS(3589),
    [anon_sym_PERCENT_EQ] = ACTIONS(3589),
    [anon_sym_PLUS_EQ] = ACTIONS(3589),
    [anon_sym_DASH_EQ] = ACTIONS(3589),
    [anon_sym_LT_LT_EQ] = ACTIONS(3589),
    [anon_sym_GT_GT_EQ] = ACTIONS(3589),
    [anon_sym_AMP_EQ] = ACTIONS(3589),
    [anon_sym_CARET_EQ] = ACTIONS(3589),
    [anon_sym_PIPE_EQ] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(3177),
    [anon_sym_PIPE_PIPE] = ACTIONS(3589),
    [anon_sym_AMP_AMP] = ACTIONS(3589),
    [anon_sym_PIPE] = ACTIONS(3183),
    [anon_sym_CARET] = ACTIONS(3185),
    [anon_sym_EQ_EQ] = ACTIONS(3187),
    [anon_sym_BANG_EQ] = ACTIONS(3187),
    [anon_sym_LT] = ACTIONS(3189),
    [anon_sym_GT] = ACTIONS(3189),
    [anon_sym_LT_EQ] = ACTIONS(3191),
    [anon_sym_GT_EQ] = ACTIONS(3191),
    [anon_sym_LT_LT] = ACTIONS(3193),
    [anon_sym_GT_GT] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_SLASH] = ACTIONS(3167),
    [anon_sym_PERCENT] = ACTIONS(3167),
    [anon_sym_DASH_DASH] = ACTIONS(3197),
    [anon_sym_PLUS_PLUS] = ACTIONS(3197),
    [anon_sym_DOT] = ACTIONS(3199),
    [anon_sym_DASH_GT] = ACTIONS(3199),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3589),
  },
  [2225] = {
    [sym_argument_list] = STATE(1511),
    [anon_sym_COMMA] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_STAR_EQ] = ACTIONS(3585),
    [anon_sym_SLASH_EQ] = ACTIONS(3585),
    [anon_sym_PERCENT_EQ] = ACTIONS(3585),
    [anon_sym_PLUS_EQ] = ACTIONS(3585),
    [anon_sym_DASH_EQ] = ACTIONS(3585),
    [anon_sym_LT_LT_EQ] = ACTIONS(3585),
    [anon_sym_GT_GT_EQ] = ACTIONS(3585),
    [anon_sym_AMP_EQ] = ACTIONS(3585),
    [anon_sym_CARET_EQ] = ACTIONS(3585),
    [anon_sym_PIPE_EQ] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(3177),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3587),
    [anon_sym_CARET] = ACTIONS(3185),
    [anon_sym_EQ_EQ] = ACTIONS(3187),
    [anon_sym_BANG_EQ] = ACTIONS(3187),
    [anon_sym_LT] = ACTIONS(3189),
    [anon_sym_GT] = ACTIONS(3189),
    [anon_sym_LT_EQ] = ACTIONS(3191),
    [anon_sym_GT_EQ] = ACTIONS(3191),
    [anon_sym_LT_LT] = ACTIONS(3193),
    [anon_sym_GT_GT] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_SLASH] = ACTIONS(3167),
    [anon_sym_PERCENT] = ACTIONS(3167),
    [anon_sym_DASH_DASH] = ACTIONS(3197),
    [anon_sym_PLUS_PLUS] = ACTIONS(3197),
    [anon_sym_DOT] = ACTIONS(3199),
    [anon_sym_DASH_GT] = ACTIONS(3199),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3585),
  },
  [2226] = {
    [sym_argument_list] = STATE(1511),
    [anon_sym_COMMA] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_STAR_EQ] = ACTIONS(3585),
    [anon_sym_SLASH_EQ] = ACTIONS(3585),
    [anon_sym_PERCENT_EQ] = ACTIONS(3585),
    [anon_sym_PLUS_EQ] = ACTIONS(3585),
    [anon_sym_DASH_EQ] = ACTIONS(3585),
    [anon_sym_LT_LT_EQ] = ACTIONS(3585),
    [anon_sym_GT_GT_EQ] = ACTIONS(3585),
    [anon_sym_AMP_EQ] = ACTIONS(3585),
    [anon_sym_CARET_EQ] = ACTIONS(3585),
    [anon_sym_PIPE_EQ] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(3177),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3587),
    [anon_sym_CARET] = ACTIONS(3587),
    [anon_sym_EQ_EQ] = ACTIONS(3187),
    [anon_sym_BANG_EQ] = ACTIONS(3187),
    [anon_sym_LT] = ACTIONS(3189),
    [anon_sym_GT] = ACTIONS(3189),
    [anon_sym_LT_EQ] = ACTIONS(3191),
    [anon_sym_GT_EQ] = ACTIONS(3191),
    [anon_sym_LT_LT] = ACTIONS(3193),
    [anon_sym_GT_GT] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_SLASH] = ACTIONS(3167),
    [anon_sym_PERCENT] = ACTIONS(3167),
    [anon_sym_DASH_DASH] = ACTIONS(3197),
    [anon_sym_PLUS_PLUS] = ACTIONS(3197),
    [anon_sym_DOT] = ACTIONS(3199),
    [anon_sym_DASH_GT] = ACTIONS(3199),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3585),
  },
  [2227] = {
    [sym_argument_list] = STATE(1511),
    [anon_sym_COMMA] = ACTIONS(3593),
    [anon_sym_LPAREN2] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_EQ] = ACTIONS(3595),
    [anon_sym_QMARK] = ACTIONS(3593),
    [anon_sym_STAR_EQ] = ACTIONS(3593),
    [anon_sym_SLASH_EQ] = ACTIONS(3593),
    [anon_sym_PERCENT_EQ] = ACTIONS(3593),
    [anon_sym_PLUS_EQ] = ACTIONS(3593),
    [anon_sym_DASH_EQ] = ACTIONS(3593),
    [anon_sym_LT_LT_EQ] = ACTIONS(3593),
    [anon_sym_GT_GT_EQ] = ACTIONS(3593),
    [anon_sym_AMP_EQ] = ACTIONS(3593),
    [anon_sym_CARET_EQ] = ACTIONS(3593),
    [anon_sym_PIPE_EQ] = ACTIONS(3593),
    [anon_sym_AMP] = ACTIONS(3595),
    [anon_sym_PIPE_PIPE] = ACTIONS(3593),
    [anon_sym_AMP_AMP] = ACTIONS(3593),
    [anon_sym_PIPE] = ACTIONS(3595),
    [anon_sym_CARET] = ACTIONS(3595),
    [anon_sym_EQ_EQ] = ACTIONS(3593),
    [anon_sym_BANG_EQ] = ACTIONS(3593),
    [anon_sym_LT] = ACTIONS(3189),
    [anon_sym_GT] = ACTIONS(3189),
    [anon_sym_LT_EQ] = ACTIONS(3191),
    [anon_sym_GT_EQ] = ACTIONS(3191),
    [anon_sym_LT_LT] = ACTIONS(3193),
    [anon_sym_GT_GT] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_SLASH] = ACTIONS(3167),
    [anon_sym_PERCENT] = ACTIONS(3167),
    [anon_sym_DASH_DASH] = ACTIONS(3197),
    [anon_sym_PLUS_PLUS] = ACTIONS(3197),
    [anon_sym_DOT] = ACTIONS(3199),
    [anon_sym_DASH_GT] = ACTIONS(3199),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3593),
  },
  [2228] = {
    [sym_argument_list] = STATE(1511),
    [anon_sym_COMMA] = ACTIONS(3597),
    [anon_sym_LPAREN2] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_EQ] = ACTIONS(3599),
    [anon_sym_QMARK] = ACTIONS(3597),
    [anon_sym_STAR_EQ] = ACTIONS(3597),
    [anon_sym_SLASH_EQ] = ACTIONS(3597),
    [anon_sym_PERCENT_EQ] = ACTIONS(3597),
    [anon_sym_PLUS_EQ] = ACTIONS(3597),
    [anon_sym_DASH_EQ] = ACTIONS(3597),
    [anon_sym_LT_LT_EQ] = ACTIONS(3597),
    [anon_sym_GT_GT_EQ] = ACTIONS(3597),
    [anon_sym_AMP_EQ] = ACTIONS(3597),
    [anon_sym_CARET_EQ] = ACTIONS(3597),
    [anon_sym_PIPE_EQ] = ACTIONS(3597),
    [anon_sym_AMP] = ACTIONS(3599),
    [anon_sym_PIPE_PIPE] = ACTIONS(3597),
    [anon_sym_AMP_AMP] = ACTIONS(3597),
    [anon_sym_PIPE] = ACTIONS(3599),
    [anon_sym_CARET] = ACTIONS(3599),
    [anon_sym_EQ_EQ] = ACTIONS(3597),
    [anon_sym_BANG_EQ] = ACTIONS(3597),
    [anon_sym_LT] = ACTIONS(3599),
    [anon_sym_GT] = ACTIONS(3599),
    [anon_sym_LT_EQ] = ACTIONS(3597),
    [anon_sym_GT_EQ] = ACTIONS(3597),
    [anon_sym_LT_LT] = ACTIONS(3193),
    [anon_sym_GT_GT] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_SLASH] = ACTIONS(3167),
    [anon_sym_PERCENT] = ACTIONS(3167),
    [anon_sym_DASH_DASH] = ACTIONS(3197),
    [anon_sym_PLUS_PLUS] = ACTIONS(3197),
    [anon_sym_DOT] = ACTIONS(3199),
    [anon_sym_DASH_GT] = ACTIONS(3199),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3597),
  },
  [2229] = {
    [sym_argument_list] = STATE(1511),
    [anon_sym_COMMA] = ACTIONS(3601),
    [anon_sym_LPAREN2] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_EQ] = ACTIONS(3603),
    [anon_sym_QMARK] = ACTIONS(3601),
    [anon_sym_STAR_EQ] = ACTIONS(3601),
    [anon_sym_SLASH_EQ] = ACTIONS(3601),
    [anon_sym_PERCENT_EQ] = ACTIONS(3601),
    [anon_sym_PLUS_EQ] = ACTIONS(3601),
    [anon_sym_DASH_EQ] = ACTIONS(3601),
    [anon_sym_LT_LT_EQ] = ACTIONS(3601),
    [anon_sym_GT_GT_EQ] = ACTIONS(3601),
    [anon_sym_AMP_EQ] = ACTIONS(3601),
    [anon_sym_CARET_EQ] = ACTIONS(3601),
    [anon_sym_PIPE_EQ] = ACTIONS(3601),
    [anon_sym_AMP] = ACTIONS(3603),
    [anon_sym_PIPE_PIPE] = ACTIONS(3601),
    [anon_sym_AMP_AMP] = ACTIONS(3601),
    [anon_sym_PIPE] = ACTIONS(3603),
    [anon_sym_CARET] = ACTIONS(3603),
    [anon_sym_EQ_EQ] = ACTIONS(3601),
    [anon_sym_BANG_EQ] = ACTIONS(3601),
    [anon_sym_LT] = ACTIONS(3603),
    [anon_sym_GT] = ACTIONS(3603),
    [anon_sym_LT_EQ] = ACTIONS(3601),
    [anon_sym_GT_EQ] = ACTIONS(3601),
    [anon_sym_LT_LT] = ACTIONS(3603),
    [anon_sym_GT_GT] = ACTIONS(3603),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_SLASH] = ACTIONS(3167),
    [anon_sym_PERCENT] = ACTIONS(3167),
    [anon_sym_DASH_DASH] = ACTIONS(3197),
    [anon_sym_PLUS_PLUS] = ACTIONS(3197),
    [anon_sym_DOT] = ACTIONS(3199),
    [anon_sym_DASH_GT] = ACTIONS(3199),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3601),
  },
  [2230] = {
    [sym_argument_list] = STATE(1511),
    [anon_sym_COMMA] = ACTIONS(3575),
    [anon_sym_LPAREN2] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_EQ] = ACTIONS(3577),
    [anon_sym_QMARK] = ACTIONS(3575),
    [anon_sym_STAR_EQ] = ACTIONS(3575),
    [anon_sym_SLASH_EQ] = ACTIONS(3575),
    [anon_sym_PERCENT_EQ] = ACTIONS(3575),
    [anon_sym_PLUS_EQ] = ACTIONS(3575),
    [anon_sym_DASH_EQ] = ACTIONS(3575),
    [anon_sym_LT_LT_EQ] = ACTIONS(3575),
    [anon_sym_GT_GT_EQ] = ACTIONS(3575),
    [anon_sym_AMP_EQ] = ACTIONS(3575),
    [anon_sym_CARET_EQ] = ACTIONS(3575),
    [anon_sym_PIPE_EQ] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_PIPE_PIPE] = ACTIONS(3575),
    [anon_sym_AMP_AMP] = ACTIONS(3575),
    [anon_sym_PIPE] = ACTIONS(3577),
    [anon_sym_CARET] = ACTIONS(3577),
    [anon_sym_EQ_EQ] = ACTIONS(3575),
    [anon_sym_BANG_EQ] = ACTIONS(3575),
    [anon_sym_LT] = ACTIONS(3577),
    [anon_sym_GT] = ACTIONS(3577),
    [anon_sym_LT_EQ] = ACTIONS(3575),
    [anon_sym_GT_EQ] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3577),
    [anon_sym_GT_GT] = ACTIONS(3577),
    [anon_sym_PLUS] = ACTIONS(3577),
    [anon_sym_DASH] = ACTIONS(3577),
    [anon_sym_SLASH] = ACTIONS(3167),
    [anon_sym_PERCENT] = ACTIONS(3167),
    [anon_sym_DASH_DASH] = ACTIONS(3197),
    [anon_sym_PLUS_PLUS] = ACTIONS(3197),
    [anon_sym_DOT] = ACTIONS(3199),
    [anon_sym_DASH_GT] = ACTIONS(3199),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3575),
  },
  [2231] = {
    [sym_template_argument_list] = STATE(2821),
    [anon_sym_COMMA] = ACTIONS(3605),
    [anon_sym_LPAREN2] = ACTIONS(3605),
    [anon_sym_STAR] = ACTIONS(3607),
    [anon_sym_LBRACK] = ACTIONS(3605),
    [anon_sym_EQ] = ACTIONS(3607),
    [anon_sym_QMARK] = ACTIONS(3605),
    [anon_sym_STAR_EQ] = ACTIONS(3605),
    [anon_sym_SLASH_EQ] = ACTIONS(3605),
    [anon_sym_PERCENT_EQ] = ACTIONS(3605),
    [anon_sym_PLUS_EQ] = ACTIONS(3605),
    [anon_sym_DASH_EQ] = ACTIONS(3605),
    [anon_sym_LT_LT_EQ] = ACTIONS(3605),
    [anon_sym_GT_GT_EQ] = ACTIONS(3605),
    [anon_sym_AMP_EQ] = ACTIONS(3605),
    [anon_sym_CARET_EQ] = ACTIONS(3605),
    [anon_sym_PIPE_EQ] = ACTIONS(3605),
    [anon_sym_AMP] = ACTIONS(3607),
    [anon_sym_PIPE_PIPE] = ACTIONS(3605),
    [anon_sym_AMP_AMP] = ACTIONS(3605),
    [anon_sym_PIPE] = ACTIONS(3607),
    [anon_sym_CARET] = ACTIONS(3607),
    [anon_sym_EQ_EQ] = ACTIONS(3605),
    [anon_sym_BANG_EQ] = ACTIONS(3605),
    [anon_sym_LT] = ACTIONS(6279),
    [anon_sym_GT] = ACTIONS(3607),
    [anon_sym_LT_EQ] = ACTIONS(3605),
    [anon_sym_GT_EQ] = ACTIONS(3605),
    [anon_sym_LT_LT] = ACTIONS(3607),
    [anon_sym_GT_GT] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3607),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_SLASH] = ACTIONS(3607),
    [anon_sym_PERCENT] = ACTIONS(3607),
    [anon_sym_DASH_DASH] = ACTIONS(3605),
    [anon_sym_PLUS_PLUS] = ACTIONS(3605),
    [anon_sym_DOT] = ACTIONS(3605),
    [anon_sym_DASH_GT] = ACTIONS(3605),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3605),
    [anon_sym_COLON_COLON] = ACTIONS(3612),
  },
  [2232] = {
    [anon_sym_COMMA] = ACTIONS(3618),
    [anon_sym_LPAREN2] = ACTIONS(3618),
    [anon_sym_STAR] = ACTIONS(3620),
    [anon_sym_LBRACK] = ACTIONS(3618),
    [anon_sym_EQ] = ACTIONS(3620),
    [anon_sym_QMARK] = ACTIONS(3618),
    [anon_sym_STAR_EQ] = ACTIONS(3618),
    [anon_sym_SLASH_EQ] = ACTIONS(3618),
    [anon_sym_PERCENT_EQ] = ACTIONS(3618),
    [anon_sym_PLUS_EQ] = ACTIONS(3618),
    [anon_sym_DASH_EQ] = ACTIONS(3618),
    [anon_sym_LT_LT_EQ] = ACTIONS(3618),
    [anon_sym_GT_GT_EQ] = ACTIONS(3618),
    [anon_sym_AMP_EQ] = ACTIONS(3618),
    [anon_sym_CARET_EQ] = ACTIONS(3618),
    [anon_sym_PIPE_EQ] = ACTIONS(3618),
    [anon_sym_AMP] = ACTIONS(3620),
    [anon_sym_PIPE_PIPE] = ACTIONS(3618),
    [anon_sym_AMP_AMP] = ACTIONS(3618),
    [anon_sym_PIPE] = ACTIONS(3620),
    [anon_sym_CARET] = ACTIONS(3620),
    [anon_sym_EQ_EQ] = ACTIONS(3618),
    [anon_sym_BANG_EQ] = ACTIONS(3618),
    [anon_sym_LT] = ACTIONS(3620),
    [anon_sym_GT] = ACTIONS(3620),
    [anon_sym_LT_EQ] = ACTIONS(3618),
    [anon_sym_GT_EQ] = ACTIONS(3618),
    [anon_sym_LT_LT] = ACTIONS(3620),
    [anon_sym_GT_GT] = ACTIONS(3620),
    [anon_sym_PLUS] = ACTIONS(3620),
    [anon_sym_DASH] = ACTIONS(3620),
    [anon_sym_SLASH] = ACTIONS(3620),
    [anon_sym_PERCENT] = ACTIONS(3620),
    [anon_sym_DASH_DASH] = ACTIONS(3618),
    [anon_sym_PLUS_PLUS] = ACTIONS(3618),
    [anon_sym_DOT] = ACTIONS(3618),
    [anon_sym_DASH_GT] = ACTIONS(3618),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3618),
  },
  [2233] = {
    [sym_template_argument_list] = STATE(2822),
    [anon_sym_LT] = ACTIONS(6282),
    [sym_comment] = ACTIONS(91),
  },
  [2234] = {
    [anon_sym_COMMA] = ACTIONS(6284),
    [anon_sym_RPAREN] = ACTIONS(6284),
    [anon_sym_SEMI] = ACTIONS(6284),
    [anon_sym_extern] = ACTIONS(6286),
    [anon_sym_LBRACE] = ACTIONS(6284),
    [anon_sym_RBRACE] = ACTIONS(6284),
    [anon_sym_LPAREN2] = ACTIONS(6284),
    [anon_sym_STAR] = ACTIONS(6286),
    [anon_sym_LBRACK] = ACTIONS(6284),
    [anon_sym_RBRACK] = ACTIONS(6284),
    [anon_sym_EQ] = ACTIONS(6286),
    [anon_sym_static] = ACTIONS(6286),
    [anon_sym_register] = ACTIONS(6286),
    [anon_sym_inline] = ACTIONS(6286),
    [anon_sym_const] = ACTIONS(6286),
    [anon_sym_restrict] = ACTIONS(6286),
    [anon_sym_volatile] = ACTIONS(6286),
    [anon_sym__Atomic] = ACTIONS(6286),
    [anon_sym_mutable] = ACTIONS(6286),
    [anon_sym_explicit] = ACTIONS(6286),
    [anon_sym_constexpr] = ACTIONS(6286),
    [anon_sym_COLON] = ACTIONS(6286),
    [anon_sym_QMARK] = ACTIONS(6284),
    [anon_sym_STAR_EQ] = ACTIONS(6284),
    [anon_sym_SLASH_EQ] = ACTIONS(6284),
    [anon_sym_PERCENT_EQ] = ACTIONS(6284),
    [anon_sym_PLUS_EQ] = ACTIONS(6284),
    [anon_sym_DASH_EQ] = ACTIONS(6284),
    [anon_sym_LT_LT_EQ] = ACTIONS(6284),
    [anon_sym_GT_GT_EQ] = ACTIONS(6284),
    [anon_sym_AMP_EQ] = ACTIONS(6284),
    [anon_sym_CARET_EQ] = ACTIONS(6284),
    [anon_sym_PIPE_EQ] = ACTIONS(6284),
    [anon_sym_AMP] = ACTIONS(6286),
    [anon_sym_PIPE_PIPE] = ACTIONS(6284),
    [anon_sym_AMP_AMP] = ACTIONS(6284),
    [anon_sym_PIPE] = ACTIONS(6286),
    [anon_sym_CARET] = ACTIONS(6286),
    [anon_sym_TILDE] = ACTIONS(6284),
    [anon_sym_EQ_EQ] = ACTIONS(6284),
    [anon_sym_BANG_EQ] = ACTIONS(6284),
    [anon_sym_LT] = ACTIONS(6286),
    [anon_sym_GT] = ACTIONS(6286),
    [anon_sym_LT_EQ] = ACTIONS(6284),
    [anon_sym_GT_EQ] = ACTIONS(6284),
    [anon_sym_LT_LT] = ACTIONS(6286),
    [anon_sym_GT_GT] = ACTIONS(6286),
    [anon_sym_PLUS] = ACTIONS(6286),
    [anon_sym_DASH] = ACTIONS(6286),
    [anon_sym_SLASH] = ACTIONS(6286),
    [anon_sym_PERCENT] = ACTIONS(6286),
    [anon_sym_DASH_DASH] = ACTIONS(6284),
    [anon_sym_PLUS_PLUS] = ACTIONS(6284),
    [anon_sym_DOT] = ACTIONS(6284),
    [anon_sym_DASH_GT] = ACTIONS(6284),
    [sym_identifier] = ACTIONS(6286),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(6286),
    [anon_sym_override] = ACTIONS(6286),
    [anon_sym_COLON_COLON] = ACTIONS(6284),
    [sym_operator_name] = ACTIONS(6284),
  },
  [2235] = {
    [aux_sym_template_argument_list_repeat1] = STATE(2235),
    [anon_sym_COMMA] = ACTIONS(6288),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(6269),
  },
  [2236] = {
    [anon_sym_COMMA] = ACTIONS(6291),
    [anon_sym_RPAREN] = ACTIONS(6291),
    [anon_sym_SEMI] = ACTIONS(6291),
    [anon_sym_extern] = ACTIONS(6293),
    [anon_sym_LBRACE] = ACTIONS(6291),
    [anon_sym_RBRACE] = ACTIONS(6291),
    [anon_sym_LPAREN2] = ACTIONS(6291),
    [anon_sym_STAR] = ACTIONS(6293),
    [anon_sym_LBRACK] = ACTIONS(6291),
    [anon_sym_RBRACK] = ACTIONS(6291),
    [anon_sym_EQ] = ACTIONS(6293),
    [anon_sym_static] = ACTIONS(6293),
    [anon_sym_register] = ACTIONS(6293),
    [anon_sym_inline] = ACTIONS(6293),
    [anon_sym_const] = ACTIONS(6293),
    [anon_sym_restrict] = ACTIONS(6293),
    [anon_sym_volatile] = ACTIONS(6293),
    [anon_sym__Atomic] = ACTIONS(6293),
    [anon_sym_mutable] = ACTIONS(6293),
    [anon_sym_explicit] = ACTIONS(6293),
    [anon_sym_constexpr] = ACTIONS(6293),
    [anon_sym_COLON] = ACTIONS(6293),
    [anon_sym_QMARK] = ACTIONS(6291),
    [anon_sym_STAR_EQ] = ACTIONS(6291),
    [anon_sym_SLASH_EQ] = ACTIONS(6291),
    [anon_sym_PERCENT_EQ] = ACTIONS(6291),
    [anon_sym_PLUS_EQ] = ACTIONS(6291),
    [anon_sym_DASH_EQ] = ACTIONS(6291),
    [anon_sym_LT_LT_EQ] = ACTIONS(6291),
    [anon_sym_GT_GT_EQ] = ACTIONS(6291),
    [anon_sym_AMP_EQ] = ACTIONS(6291),
    [anon_sym_CARET_EQ] = ACTIONS(6291),
    [anon_sym_PIPE_EQ] = ACTIONS(6291),
    [anon_sym_AMP] = ACTIONS(6293),
    [anon_sym_PIPE_PIPE] = ACTIONS(6291),
    [anon_sym_AMP_AMP] = ACTIONS(6291),
    [anon_sym_PIPE] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [anon_sym_TILDE] = ACTIONS(6291),
    [anon_sym_EQ_EQ] = ACTIONS(6291),
    [anon_sym_BANG_EQ] = ACTIONS(6291),
    [anon_sym_LT] = ACTIONS(6293),
    [anon_sym_GT] = ACTIONS(6293),
    [anon_sym_LT_EQ] = ACTIONS(6291),
    [anon_sym_GT_EQ] = ACTIONS(6291),
    [anon_sym_LT_LT] = ACTIONS(6293),
    [anon_sym_GT_GT] = ACTIONS(6293),
    [anon_sym_PLUS] = ACTIONS(6293),
    [anon_sym_DASH] = ACTIONS(6293),
    [anon_sym_SLASH] = ACTIONS(6293),
    [anon_sym_PERCENT] = ACTIONS(6293),
    [anon_sym_DASH_DASH] = ACTIONS(6291),
    [anon_sym_PLUS_PLUS] = ACTIONS(6291),
    [anon_sym_DOT] = ACTIONS(6291),
    [anon_sym_DASH_GT] = ACTIONS(6291),
    [sym_identifier] = ACTIONS(6293),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(6293),
    [anon_sym_override] = ACTIONS(6293),
    [anon_sym_COLON_COLON] = ACTIONS(6291),
    [sym_operator_name] = ACTIONS(6291),
  },
  [2237] = {
    [sym_string_literal] = STATE(2237),
    [aux_sym_concatenated_string_repeat1] = STATE(2237),
    [anon_sym_COMMA] = ACTIONS(3622),
    [anon_sym_LPAREN2] = ACTIONS(3622),
    [anon_sym_STAR] = ACTIONS(3624),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_EQ] = ACTIONS(3624),
    [anon_sym_QMARK] = ACTIONS(3622),
    [anon_sym_STAR_EQ] = ACTIONS(3622),
    [anon_sym_SLASH_EQ] = ACTIONS(3622),
    [anon_sym_PERCENT_EQ] = ACTIONS(3622),
    [anon_sym_PLUS_EQ] = ACTIONS(3622),
    [anon_sym_DASH_EQ] = ACTIONS(3622),
    [anon_sym_LT_LT_EQ] = ACTIONS(3622),
    [anon_sym_GT_GT_EQ] = ACTIONS(3622),
    [anon_sym_AMP_EQ] = ACTIONS(3622),
    [anon_sym_CARET_EQ] = ACTIONS(3622),
    [anon_sym_PIPE_EQ] = ACTIONS(3622),
    [anon_sym_AMP] = ACTIONS(3624),
    [anon_sym_PIPE_PIPE] = ACTIONS(3622),
    [anon_sym_AMP_AMP] = ACTIONS(3622),
    [anon_sym_PIPE] = ACTIONS(3624),
    [anon_sym_CARET] = ACTIONS(3624),
    [anon_sym_EQ_EQ] = ACTIONS(3622),
    [anon_sym_BANG_EQ] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3624),
    [anon_sym_GT] = ACTIONS(3624),
    [anon_sym_LT_EQ] = ACTIONS(3622),
    [anon_sym_GT_EQ] = ACTIONS(3622),
    [anon_sym_LT_LT] = ACTIONS(3624),
    [anon_sym_GT_GT] = ACTIONS(3624),
    [anon_sym_PLUS] = ACTIONS(3624),
    [anon_sym_DASH] = ACTIONS(3624),
    [anon_sym_SLASH] = ACTIONS(3624),
    [anon_sym_PERCENT] = ACTIONS(3624),
    [anon_sym_DASH_DASH] = ACTIONS(3622),
    [anon_sym_PLUS_PLUS] = ACTIONS(3622),
    [anon_sym_DOT] = ACTIONS(3622),
    [anon_sym_DASH_GT] = ACTIONS(3622),
    [anon_sym_DQUOTE] = ACTIONS(6295),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3622),
  },
  [2238] = {
    [anon_sym_COMMA] = ACTIONS(3631),
    [anon_sym_LBRACE] = ACTIONS(3636),
    [anon_sym_LPAREN2] = ACTIONS(3631),
    [anon_sym_STAR] = ACTIONS(3638),
    [anon_sym_LBRACK] = ACTIONS(3631),
    [anon_sym_EQ] = ACTIONS(3641),
    [anon_sym_QMARK] = ACTIONS(3629),
    [anon_sym_STAR_EQ] = ACTIONS(3629),
    [anon_sym_SLASH_EQ] = ACTIONS(3629),
    [anon_sym_PERCENT_EQ] = ACTIONS(3629),
    [anon_sym_PLUS_EQ] = ACTIONS(3629),
    [anon_sym_DASH_EQ] = ACTIONS(3629),
    [anon_sym_LT_LT_EQ] = ACTIONS(3629),
    [anon_sym_GT_GT_EQ] = ACTIONS(3629),
    [anon_sym_AMP_EQ] = ACTIONS(3629),
    [anon_sym_CARET_EQ] = ACTIONS(3629),
    [anon_sym_PIPE_EQ] = ACTIONS(3629),
    [anon_sym_AMP] = ACTIONS(3638),
    [anon_sym_PIPE_PIPE] = ACTIONS(3629),
    [anon_sym_AMP_AMP] = ACTIONS(3631),
    [anon_sym_PIPE] = ACTIONS(3641),
    [anon_sym_CARET] = ACTIONS(3641),
    [anon_sym_EQ_EQ] = ACTIONS(3629),
    [anon_sym_BANG_EQ] = ACTIONS(3629),
    [anon_sym_LT] = ACTIONS(3638),
    [anon_sym_GT] = ACTIONS(3641),
    [anon_sym_LT_EQ] = ACTIONS(3629),
    [anon_sym_GT_EQ] = ACTIONS(3629),
    [anon_sym_LT_LT] = ACTIONS(3641),
    [anon_sym_GT_GT] = ACTIONS(3641),
    [anon_sym_PLUS] = ACTIONS(3641),
    [anon_sym_DASH] = ACTIONS(3641),
    [anon_sym_SLASH] = ACTIONS(3641),
    [anon_sym_PERCENT] = ACTIONS(3641),
    [anon_sym_DASH_DASH] = ACTIONS(3629),
    [anon_sym_PLUS_PLUS] = ACTIONS(3629),
    [anon_sym_DOT] = ACTIONS(3629),
    [anon_sym_DASH_GT] = ACTIONS(3629),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3631),
    [anon_sym_COLON_COLON] = ACTIONS(3643),
  },
  [2239] = {
    [anon_sym_COMMA] = ACTIONS(3629),
    [anon_sym_LBRACE] = ACTIONS(3629),
    [anon_sym_LPAREN2] = ACTIONS(3629),
    [anon_sym_STAR] = ACTIONS(3641),
    [anon_sym_LBRACK] = ACTIONS(3629),
    [anon_sym_EQ] = ACTIONS(3641),
    [anon_sym_QMARK] = ACTIONS(3629),
    [anon_sym_STAR_EQ] = ACTIONS(3629),
    [anon_sym_SLASH_EQ] = ACTIONS(3629),
    [anon_sym_PERCENT_EQ] = ACTIONS(3629),
    [anon_sym_PLUS_EQ] = ACTIONS(3629),
    [anon_sym_DASH_EQ] = ACTIONS(3629),
    [anon_sym_LT_LT_EQ] = ACTIONS(3629),
    [anon_sym_GT_GT_EQ] = ACTIONS(3629),
    [anon_sym_AMP_EQ] = ACTIONS(3629),
    [anon_sym_CARET_EQ] = ACTIONS(3629),
    [anon_sym_PIPE_EQ] = ACTIONS(3629),
    [anon_sym_AMP] = ACTIONS(3641),
    [anon_sym_PIPE_PIPE] = ACTIONS(3629),
    [anon_sym_AMP_AMP] = ACTIONS(3629),
    [anon_sym_PIPE] = ACTIONS(3641),
    [anon_sym_CARET] = ACTIONS(3641),
    [anon_sym_EQ_EQ] = ACTIONS(3629),
    [anon_sym_BANG_EQ] = ACTIONS(3629),
    [anon_sym_LT] = ACTIONS(3641),
    [anon_sym_GT] = ACTIONS(3641),
    [anon_sym_LT_EQ] = ACTIONS(3629),
    [anon_sym_GT_EQ] = ACTIONS(3629),
    [anon_sym_LT_LT] = ACTIONS(3641),
    [anon_sym_GT_GT] = ACTIONS(3641),
    [anon_sym_PLUS] = ACTIONS(3641),
    [anon_sym_DASH] = ACTIONS(3641),
    [anon_sym_SLASH] = ACTIONS(3641),
    [anon_sym_PERCENT] = ACTIONS(3641),
    [anon_sym_DASH_DASH] = ACTIONS(3629),
    [anon_sym_PLUS_PLUS] = ACTIONS(3629),
    [anon_sym_DOT] = ACTIONS(3629),
    [anon_sym_DASH_GT] = ACTIONS(3629),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3629),
  },
  [2240] = {
    [sym_preproc_include] = STATE(2824),
    [sym_preproc_def] = STATE(2824),
    [sym_preproc_function_def] = STATE(2824),
    [sym_preproc_call] = STATE(2824),
    [sym_preproc_if_in_compound_statement] = STATE(2824),
    [sym_preproc_ifdef_in_compound_statement] = STATE(2824),
    [sym_declaration] = STATE(2824),
    [sym_type_definition] = STATE(2824),
    [sym__declaration_specifiers] = STATE(113),
    [sym_compound_statement] = STATE(2824),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(2824),
    [sym_expression_statement] = STATE(2824),
    [sym_if_statement] = STATE(2824),
    [sym_switch_statement] = STATE(2824),
    [sym_case_statement] = STATE(2824),
    [sym_while_statement] = STATE(2824),
    [sym_do_statement] = STATE(2824),
    [sym_for_statement] = STATE(2824),
    [sym_return_statement] = STATE(2824),
    [sym_break_statement] = STATE(2824),
    [sym_continue_statement] = STATE(2824),
    [sym_goto_statement] = STATE(2824),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(2824),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(2824),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(2824),
    [sym_try_statement] = STATE(2824),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2824),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(157),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(159),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(161),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(163),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(165),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(165),
    [sym_preproc_directive] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_typedef] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_RBRACE] = ACTIONS(6298),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(185),
    [anon_sym_case] = ACTIONS(187),
    [anon_sym_default] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(209),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_nullptr] = ACTIONS(207),
  },
  [2241] = {
    [anon_sym_COMMA] = ACTIONS(3667),
    [anon_sym_LPAREN2] = ACTIONS(3667),
    [anon_sym_STAR] = ACTIONS(3669),
    [anon_sym_LBRACK] = ACTIONS(3667),
    [anon_sym_EQ] = ACTIONS(3669),
    [anon_sym_QMARK] = ACTIONS(3667),
    [anon_sym_STAR_EQ] = ACTIONS(3667),
    [anon_sym_SLASH_EQ] = ACTIONS(3667),
    [anon_sym_PERCENT_EQ] = ACTIONS(3667),
    [anon_sym_PLUS_EQ] = ACTIONS(3667),
    [anon_sym_DASH_EQ] = ACTIONS(3667),
    [anon_sym_LT_LT_EQ] = ACTIONS(3667),
    [anon_sym_GT_GT_EQ] = ACTIONS(3667),
    [anon_sym_AMP_EQ] = ACTIONS(3667),
    [anon_sym_CARET_EQ] = ACTIONS(3667),
    [anon_sym_PIPE_EQ] = ACTIONS(3667),
    [anon_sym_AMP] = ACTIONS(3669),
    [anon_sym_PIPE_PIPE] = ACTIONS(3667),
    [anon_sym_AMP_AMP] = ACTIONS(3667),
    [anon_sym_PIPE] = ACTIONS(3669),
    [anon_sym_CARET] = ACTIONS(3669),
    [anon_sym_EQ_EQ] = ACTIONS(3667),
    [anon_sym_BANG_EQ] = ACTIONS(3667),
    [anon_sym_LT] = ACTIONS(3669),
    [anon_sym_GT] = ACTIONS(3669),
    [anon_sym_LT_EQ] = ACTIONS(3667),
    [anon_sym_GT_EQ] = ACTIONS(3667),
    [anon_sym_LT_LT] = ACTIONS(3669),
    [anon_sym_GT_GT] = ACTIONS(3669),
    [anon_sym_PLUS] = ACTIONS(3669),
    [anon_sym_DASH] = ACTIONS(3669),
    [anon_sym_SLASH] = ACTIONS(3669),
    [anon_sym_PERCENT] = ACTIONS(3669),
    [anon_sym_DASH_DASH] = ACTIONS(3667),
    [anon_sym_PLUS_PLUS] = ACTIONS(3667),
    [anon_sym_DOT] = ACTIONS(3667),
    [anon_sym_DASH_GT] = ACTIONS(3667),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3667),
  },
  [2242] = {
    [sym_parameter_list] = STATE(2210),
    [anon_sym_COMMA] = ACTIONS(4177),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(4177),
  },
  [2243] = {
    [anon_sym_COMMA] = ACTIONS(6300),
    [anon_sym_RPAREN] = ACTIONS(6300),
    [anon_sym_SEMI] = ACTIONS(6300),
    [anon_sym_extern] = ACTIONS(6302),
    [anon_sym_LBRACE] = ACTIONS(6300),
    [anon_sym_LPAREN2] = ACTIONS(6300),
    [anon_sym_STAR] = ACTIONS(6300),
    [anon_sym_LBRACK] = ACTIONS(6300),
    [anon_sym_EQ] = ACTIONS(6300),
    [anon_sym_static] = ACTIONS(6302),
    [anon_sym_register] = ACTIONS(6302),
    [anon_sym_inline] = ACTIONS(6302),
    [anon_sym_const] = ACTIONS(6302),
    [anon_sym_restrict] = ACTIONS(6302),
    [anon_sym_volatile] = ACTIONS(6302),
    [anon_sym__Atomic] = ACTIONS(6302),
    [anon_sym_mutable] = ACTIONS(6302),
    [anon_sym_explicit] = ACTIONS(6302),
    [anon_sym_constexpr] = ACTIONS(6302),
    [anon_sym_COLON] = ACTIONS(6302),
    [anon_sym_AMP] = ACTIONS(6302),
    [anon_sym_AMP_AMP] = ACTIONS(6300),
    [anon_sym_TILDE] = ACTIONS(6300),
    [anon_sym_DASH_GT] = ACTIONS(6300),
    [sym_identifier] = ACTIONS(6302),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(6302),
    [anon_sym_override] = ACTIONS(6302),
    [anon_sym_GT2] = ACTIONS(6300),
    [sym_noexcept] = ACTIONS(6302),
    [anon_sym_COLON_COLON] = ACTIONS(6300),
    [sym_operator_name] = ACTIONS(6300),
  },
  [2244] = {
    [anon_sym_COMMA] = ACTIONS(6304),
    [anon_sym_RPAREN] = ACTIONS(6304),
    [anon_sym_SEMI] = ACTIONS(6304),
    [anon_sym_extern] = ACTIONS(6306),
    [anon_sym_LBRACE] = ACTIONS(6304),
    [anon_sym_LPAREN2] = ACTIONS(6304),
    [anon_sym_STAR] = ACTIONS(6304),
    [anon_sym_LBRACK] = ACTIONS(6304),
    [anon_sym_EQ] = ACTIONS(6304),
    [anon_sym_static] = ACTIONS(6306),
    [anon_sym_register] = ACTIONS(6306),
    [anon_sym_inline] = ACTIONS(6306),
    [anon_sym_const] = ACTIONS(6306),
    [anon_sym_restrict] = ACTIONS(6306),
    [anon_sym_volatile] = ACTIONS(6306),
    [anon_sym__Atomic] = ACTIONS(6306),
    [anon_sym_mutable] = ACTIONS(6306),
    [anon_sym_explicit] = ACTIONS(6306),
    [anon_sym_constexpr] = ACTIONS(6306),
    [anon_sym_COLON] = ACTIONS(6306),
    [anon_sym_AMP] = ACTIONS(6306),
    [anon_sym_AMP_AMP] = ACTIONS(6304),
    [anon_sym_TILDE] = ACTIONS(6304),
    [anon_sym_DASH_GT] = ACTIONS(6304),
    [sym_identifier] = ACTIONS(6306),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(6306),
    [anon_sym_override] = ACTIONS(6306),
    [anon_sym_GT2] = ACTIONS(6304),
    [sym_noexcept] = ACTIONS(6306),
    [anon_sym_COLON_COLON] = ACTIONS(6304),
    [sym_operator_name] = ACTIONS(6304),
  },
  [2245] = {
    [sym__type_specifier] = STATE(2826),
    [sym_sized_type_specifier] = STATE(2826),
    [sym_enum_specifier] = STATE(2826),
    [sym_struct_specifier] = STATE(2826),
    [sym_union_specifier] = STATE(2826),
    [sym_macro_type_specifier] = STATE(2826),
    [sym_class_specifier] = STATE(2826),
    [sym_dependent_type] = STATE(2826),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2827),
    [anon_sym_unsigned] = ACTIONS(6308),
    [anon_sym_long] = ACTIONS(6308),
    [anon_sym_short] = ACTIONS(6308),
    [sym_primitive_type] = ACTIONS(6310),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(6310),
    [anon_sym_typename] = ACTIONS(6312),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [2246] = {
    [sym__declarator] = STATE(500),
    [sym__abstract_declarator] = STATE(1182),
    [sym_pointer_declarator] = STATE(500),
    [sym_abstract_pointer_declarator] = STATE(1182),
    [sym_function_declarator] = STATE(500),
    [sym_abstract_function_declarator] = STATE(1182),
    [sym_array_declarator] = STATE(500),
    [sym_abstract_array_declarator] = STATE(1182),
    [sym_type_qualifier] = STATE(2828),
    [sym_parameter_list] = STATE(528),
    [sym_reference_declarator] = STATE(500),
    [sym_abstract_reference_declarator] = STATE(1182),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(500),
    [sym_destructor_name] = STATE(500),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [aux_sym_type_definition_repeat1] = STATE(2828),
    [anon_sym_RPAREN] = ACTIONS(2461),
    [anon_sym_LPAREN2] = ACTIONS(3249),
    [anon_sym_STAR] = ACTIONS(4877),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(4879),
    [anon_sym_AMP_AMP] = ACTIONS(4881),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(431),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(849),
  },
  [2247] = {
    [sym__declarator] = STATE(508),
    [sym__abstract_declarator] = STATE(1184),
    [sym_pointer_declarator] = STATE(508),
    [sym_abstract_pointer_declarator] = STATE(1184),
    [sym_function_declarator] = STATE(508),
    [sym_abstract_function_declarator] = STATE(1184),
    [sym_array_declarator] = STATE(508),
    [sym_abstract_array_declarator] = STATE(1184),
    [sym_parameter_list] = STATE(528),
    [sym_reference_declarator] = STATE(508),
    [sym_abstract_reference_declarator] = STATE(1184),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(508),
    [sym_destructor_name] = STATE(508),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [anon_sym_RPAREN] = ACTIONS(2463),
    [anon_sym_LPAREN2] = ACTIONS(3249),
    [anon_sym_STAR] = ACTIONS(4877),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_AMP] = ACTIONS(4879),
    [anon_sym_AMP_AMP] = ACTIONS(4881),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(431),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(855),
  },
  [2248] = {
    [sym_parameter_list] = STATE(2254),
    [anon_sym_COMMA] = ACTIONS(2435),
    [anon_sym_LBRACE] = ACTIONS(2435),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(574),
    [anon_sym_EQ] = ACTIONS(2435),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(2435),
  },
  [2249] = {
    [sym__declarator] = STATE(2829),
    [sym__abstract_declarator] = STATE(2812),
    [sym_pointer_declarator] = STATE(2829),
    [sym_abstract_pointer_declarator] = STATE(2812),
    [sym_function_declarator] = STATE(2829),
    [sym_abstract_function_declarator] = STATE(2812),
    [sym_array_declarator] = STATE(2829),
    [sym_abstract_array_declarator] = STATE(2812),
    [sym_type_qualifier] = STATE(2830),
    [sym_parameter_list] = STATE(1492),
    [sym_reference_declarator] = STATE(2829),
    [sym_abstract_reference_declarator] = STATE(2812),
    [sym_template_type] = STATE(1538),
    [sym_template_function] = STATE(2829),
    [sym_destructor_name] = STATE(2829),
    [sym_scoped_identifier] = STATE(1539),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(1538),
    [aux_sym_type_definition_repeat1] = STATE(2830),
    [anon_sym_COMMA] = ACTIONS(4157),
    [anon_sym_LPAREN2] = ACTIONS(3249),
    [anon_sym_STAR] = ACTIONS(3251),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(3253),
    [anon_sym_AMP_AMP] = ACTIONS(3255),
    [anon_sym_TILDE] = ACTIONS(3149),
    [sym_identifier] = ACTIONS(3257),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(4157),
    [anon_sym_COLON_COLON] = ACTIONS(3259),
    [sym_operator_name] = ACTIONS(6314),
  },
  [2250] = {
    [sym_parameter_list] = STATE(2254),
    [anon_sym_COMMA] = ACTIONS(2439),
    [anon_sym_LBRACE] = ACTIONS(2439),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(574),
    [anon_sym_EQ] = ACTIONS(2439),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(2439),
  },
  [2251] = {
    [sym_destructor_name] = STATE(2167),
    [anon_sym_TILDE] = ACTIONS(3149),
    [sym_identifier] = ACTIONS(3053),
    [sym_comment] = ACTIONS(91),
    [sym_operator_name] = ACTIONS(4727),
  },
  [2252] = {
    [sym__declaration_specifiers] = STATE(905),
    [sym_storage_class_specifier] = STATE(907),
    [sym_type_qualifier] = STATE(907),
    [sym__type_specifier] = STATE(906),
    [sym_sized_type_specifier] = STATE(906),
    [sym_enum_specifier] = STATE(906),
    [sym_struct_specifier] = STATE(906),
    [sym_union_specifier] = STATE(906),
    [sym_parameter_declaration] = STATE(902),
    [sym__expression] = STATE(2216),
    [sym_conditional_expression] = STATE(2216),
    [sym_assignment_expression] = STATE(2216),
    [sym_pointer_expression] = STATE(2216),
    [sym_logical_expression] = STATE(2216),
    [sym_bitwise_expression] = STATE(2216),
    [sym_equality_expression] = STATE(2216),
    [sym_relational_expression] = STATE(2216),
    [sym_shift_expression] = STATE(2216),
    [sym_math_expression] = STATE(2216),
    [sym_cast_expression] = STATE(2216),
    [sym_sizeof_expression] = STATE(2216),
    [sym_subscript_expression] = STATE(2216),
    [sym_call_expression] = STATE(2216),
    [sym_field_expression] = STATE(2216),
    [sym_compound_literal_expression] = STATE(2216),
    [sym_parenthesized_expression] = STATE(2216),
    [sym_initializer_list] = STATE(2217),
    [sym_char_literal] = STATE(2216),
    [sym_concatenated_string] = STATE(2216),
    [sym_string_literal] = STATE(140),
    [sym_macro_type_specifier] = STATE(906),
    [sym_class_specifier] = STATE(906),
    [sym_dependent_type] = STATE(906),
    [sym_template_type] = STATE(1636),
    [sym_template_function] = STATE(2216),
    [sym_new_expression] = STATE(2216),
    [sym_delete_expression] = STATE(2216),
    [sym_lambda_expression] = STATE(2216),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(1637),
    [aux_sym__declaration_specifiers_repeat1] = STATE(907),
    [aux_sym_sized_type_specifier_repeat1] = STATE(908),
    [sym_raw_string_literal] = ACTIONS(4783),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1625),
    [anon_sym_RPAREN] = ACTIONS(3429),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(1629),
    [anon_sym_long] = ACTIONS(1629),
    [anon_sym_short] = ACTIONS(1629),
    [sym_primitive_type] = ACTIONS(1631),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(4783),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4787),
    [sym_false] = ACTIONS(4787),
    [sym_null] = ACTIONS(4787),
    [sym_identifier] = ACTIONS(3431),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(1631),
    [anon_sym_typename] = ACTIONS(1633),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(3433),
    [sym_nullptr] = ACTIONS(4787),
  },
  [2253] = {
    [sym__expression] = STATE(2831),
    [sym_conditional_expression] = STATE(2831),
    [sym_assignment_expression] = STATE(2831),
    [sym_pointer_expression] = STATE(2831),
    [sym_logical_expression] = STATE(2831),
    [sym_bitwise_expression] = STATE(2831),
    [sym_equality_expression] = STATE(2831),
    [sym_relational_expression] = STATE(2831),
    [sym_shift_expression] = STATE(2831),
    [sym_math_expression] = STATE(2831),
    [sym_cast_expression] = STATE(2831),
    [sym_sizeof_expression] = STATE(2831),
    [sym_subscript_expression] = STATE(2831),
    [sym_call_expression] = STATE(2831),
    [sym_field_expression] = STATE(2831),
    [sym_compound_literal_expression] = STATE(2831),
    [sym_parenthesized_expression] = STATE(2831),
    [sym_initializer_list] = STATE(1639),
    [sym_char_literal] = STATE(2831),
    [sym_concatenated_string] = STATE(2831),
    [sym_string_literal] = STATE(780),
    [sym_template_type] = STATE(1454),
    [sym_template_function] = STATE(2831),
    [sym_new_expression] = STATE(2831),
    [sym_delete_expression] = STATE(2831),
    [sym_lambda_expression] = STATE(2831),
    [sym_lambda_capture_specifier] = STATE(782),
    [sym_scoped_identifier] = STATE(783),
    [sym_scoped_type_identifier] = STATE(1455),
    [sym_scoped_namespace_identifier] = STATE(1456),
    [sym_raw_string_literal] = ACTIONS(6316),
    [anon_sym_LBRACE] = ACTIONS(3114),
    [anon_sym_LPAREN2] = ACTIONS(1380),
    [anon_sym_STAR] = ACTIONS(1382),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1382),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1394),
    [anon_sym_PLUS_PLUS] = ACTIONS(1394),
    [anon_sym_sizeof] = ACTIONS(1396),
    [sym_number_literal] = ACTIONS(6316),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_true] = ACTIONS(6318),
    [sym_false] = ACTIONS(6318),
    [sym_null] = ACTIONS(6318),
    [sym_identifier] = ACTIONS(3084),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1410),
    [anon_sym_new] = ACTIONS(1412),
    [anon_sym_COLON_COLON] = ACTIONS(3086),
    [sym_nullptr] = ACTIONS(6318),
  },
  [2254] = {
    [sym_type_qualifier] = STATE(2833),
    [sym_virtual_specifier] = STATE(2833),
    [sym_trailing_return_type] = STATE(2833),
    [aux_sym_function_declarator_repeat1] = STATE(2833),
    [anon_sym_COMMA] = ACTIONS(1665),
    [anon_sym_LBRACE] = ACTIONS(1665),
    [anon_sym_LPAREN2] = ACTIONS(1665),
    [anon_sym_LBRACK] = ACTIONS(1665),
    [anon_sym_EQ] = ACTIONS(1665),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(6320),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [anon_sym_GT2] = ACTIONS(1665),
    [sym_noexcept] = ACTIONS(6322),
  },
  [2255] = {
    [sym_destructor_name] = STATE(2239),
    [anon_sym_TILDE] = ACTIONS(3149),
    [sym_identifier] = ACTIONS(3055),
    [sym_comment] = ACTIONS(91),
    [sym_operator_name] = ACTIONS(4857),
  },
  [2256] = {
    [sym_argument_list] = STATE(1511),
    [anon_sym_COMMA] = ACTIONS(6324),
    [anon_sym_LPAREN2] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_EQ] = ACTIONS(3171),
    [anon_sym_QMARK] = ACTIONS(3173),
    [anon_sym_STAR_EQ] = ACTIONS(3175),
    [anon_sym_SLASH_EQ] = ACTIONS(3175),
    [anon_sym_PERCENT_EQ] = ACTIONS(3175),
    [anon_sym_PLUS_EQ] = ACTIONS(3175),
    [anon_sym_DASH_EQ] = ACTIONS(3175),
    [anon_sym_LT_LT_EQ] = ACTIONS(3175),
    [anon_sym_GT_GT_EQ] = ACTIONS(3175),
    [anon_sym_AMP_EQ] = ACTIONS(3175),
    [anon_sym_CARET_EQ] = ACTIONS(3175),
    [anon_sym_PIPE_EQ] = ACTIONS(3175),
    [anon_sym_AMP] = ACTIONS(3177),
    [anon_sym_PIPE_PIPE] = ACTIONS(3179),
    [anon_sym_AMP_AMP] = ACTIONS(3181),
    [anon_sym_PIPE] = ACTIONS(3183),
    [anon_sym_CARET] = ACTIONS(3185),
    [anon_sym_EQ_EQ] = ACTIONS(3187),
    [anon_sym_BANG_EQ] = ACTIONS(3187),
    [anon_sym_LT] = ACTIONS(3189),
    [anon_sym_GT] = ACTIONS(3189),
    [anon_sym_LT_EQ] = ACTIONS(3191),
    [anon_sym_GT_EQ] = ACTIONS(3191),
    [anon_sym_LT_LT] = ACTIONS(3193),
    [anon_sym_GT_GT] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_SLASH] = ACTIONS(3167),
    [anon_sym_PERCENT] = ACTIONS(3167),
    [anon_sym_DASH_DASH] = ACTIONS(3197),
    [anon_sym_PLUS_PLUS] = ACTIONS(3197),
    [anon_sym_DOT] = ACTIONS(3199),
    [anon_sym_DASH_GT] = ACTIONS(3199),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(6324),
  },
  [2257] = {
    [sym_storage_class_specifier] = STATE(2257),
    [sym_type_qualifier] = STATE(2257),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2257),
    [anon_sym_COMMA] = ACTIONS(1970),
    [anon_sym_extern] = ACTIONS(1967),
    [anon_sym_LPAREN2] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(1970),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_static] = ACTIONS(1967),
    [anon_sym_register] = ACTIONS(1967),
    [anon_sym_inline] = ACTIONS(1967),
    [anon_sym_const] = ACTIONS(1972),
    [anon_sym_restrict] = ACTIONS(1972),
    [anon_sym_volatile] = ACTIONS(1972),
    [anon_sym__Atomic] = ACTIONS(1972),
    [anon_sym_mutable] = ACTIONS(1972),
    [anon_sym_explicit] = ACTIONS(1972),
    [anon_sym_constexpr] = ACTIONS(1972),
    [anon_sym_AMP] = ACTIONS(1975),
    [anon_sym_AMP_AMP] = ACTIONS(1970),
    [anon_sym_TILDE] = ACTIONS(1970),
    [sym_identifier] = ACTIONS(1975),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(1970),
    [anon_sym_COLON_COLON] = ACTIONS(1970),
    [sym_operator_name] = ACTIONS(1970),
  },
  [2258] = {
    [anon_sym_COMMA] = ACTIONS(6326),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(6326),
  },
  [2259] = {
    [anon_sym_extern] = ACTIONS(6328),
    [anon_sym_static] = ACTIONS(6328),
    [anon_sym_register] = ACTIONS(6328),
    [anon_sym_inline] = ACTIONS(6328),
    [anon_sym_const] = ACTIONS(6328),
    [anon_sym_restrict] = ACTIONS(6328),
    [anon_sym_volatile] = ACTIONS(6328),
    [anon_sym__Atomic] = ACTIONS(6328),
    [anon_sym_mutable] = ACTIONS(6328),
    [anon_sym_explicit] = ACTIONS(6328),
    [anon_sym_constexpr] = ACTIONS(6328),
    [anon_sym_unsigned] = ACTIONS(6328),
    [anon_sym_long] = ACTIONS(6328),
    [anon_sym_short] = ACTIONS(6328),
    [sym_primitive_type] = ACTIONS(6328),
    [anon_sym_enum] = ACTIONS(6328),
    [anon_sym_struct] = ACTIONS(6328),
    [anon_sym_union] = ACTIONS(6328),
    [sym_identifier] = ACTIONS(6328),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6328),
    [sym_auto] = ACTIONS(6328),
    [anon_sym_typename] = ACTIONS(6328),
    [anon_sym_COLON_COLON] = ACTIONS(6330),
  },
  [2260] = {
    [aux_sym_template_parameter_list_repeat1] = STATE(2260),
    [anon_sym_COMMA] = ACTIONS(6332),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(6326),
  },
  [2261] = {
    [sym_storage_class_specifier] = STATE(2257),
    [sym_type_qualifier] = STATE(2257),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2257),
    [anon_sym_COMMA] = ACTIONS(3695),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_LPAREN2] = ACTIONS(3695),
    [anon_sym_STAR] = ACTIONS(3695),
    [anon_sym_LBRACK] = ACTIONS(3695),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3695),
    [anon_sym_TILDE] = ACTIONS(3695),
    [sym_identifier] = ACTIONS(3697),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3695),
    [anon_sym_COLON_COLON] = ACTIONS(3695),
    [sym_operator_name] = ACTIONS(3695),
  },
  [2262] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2262),
    [anon_sym_COMMA] = ACTIONS(1985),
    [anon_sym_extern] = ACTIONS(1987),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1985),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_static] = ACTIONS(1987),
    [anon_sym_register] = ACTIONS(1987),
    [anon_sym_inline] = ACTIONS(1987),
    [anon_sym_const] = ACTIONS(1987),
    [anon_sym_restrict] = ACTIONS(1987),
    [anon_sym_volatile] = ACTIONS(1987),
    [anon_sym__Atomic] = ACTIONS(1987),
    [anon_sym_mutable] = ACTIONS(1987),
    [anon_sym_explicit] = ACTIONS(1987),
    [anon_sym_constexpr] = ACTIONS(1987),
    [anon_sym_unsigned] = ACTIONS(6335),
    [anon_sym_long] = ACTIONS(6335),
    [anon_sym_short] = ACTIONS(6335),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(1985),
    [anon_sym_COLON_COLON] = ACTIONS(1985),
    [sym_operator_name] = ACTIONS(1985),
  },
  [2263] = {
    [sym__type_specifier] = STATE(271),
    [sym_sized_type_specifier] = STATE(271),
    [sym_enum_specifier] = STATE(271),
    [sym_struct_specifier] = STATE(271),
    [sym_union_specifier] = STATE(271),
    [sym_macro_type_specifier] = STATE(271),
    [sym_class_specifier] = STATE(271),
    [sym_dependent_type] = STATE(271),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2265),
    [anon_sym_unsigned] = ACTIONS(4916),
    [anon_sym_long] = ACTIONS(4916),
    [anon_sym_short] = ACTIONS(4916),
    [sym_primitive_type] = ACTIONS(490),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(4147),
    [anon_sym_union] = ACTIONS(4149),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4151),
    [sym_auto] = ACTIONS(490),
    [anon_sym_typename] = ACTIONS(4920),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [2264] = {
    [sym__abstract_declarator] = STATE(2836),
    [sym_abstract_pointer_declarator] = STATE(2836),
    [sym_abstract_function_declarator] = STATE(2836),
    [sym_abstract_array_declarator] = STATE(2836),
    [sym_parameter_list] = STATE(2837),
    [sym_abstract_reference_declarator] = STATE(2836),
    [anon_sym_SEMI] = ACTIONS(5222),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(6338),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_const] = ACTIONS(5226),
    [anon_sym_restrict] = ACTIONS(5222),
    [anon_sym_volatile] = ACTIONS(5222),
    [anon_sym__Atomic] = ACTIONS(5222),
    [anon_sym_mutable] = ACTIONS(5222),
    [anon_sym_explicit] = ACTIONS(5222),
    [anon_sym_constexpr] = ACTIONS(5222),
    [anon_sym_AMP] = ACTIONS(6340),
    [anon_sym_AMP_AMP] = ACTIONS(6342),
    [anon_sym_DASH_GT] = ACTIONS(5222),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5222),
    [anon_sym_override] = ACTIONS(5222),
    [sym_noexcept] = ACTIONS(5222),
  },
  [2265] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2838),
    [anon_sym_SEMI] = ACTIONS(653),
    [anon_sym_LPAREN2] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(655),
    [anon_sym_restrict] = ACTIONS(655),
    [anon_sym_volatile] = ACTIONS(655),
    [anon_sym__Atomic] = ACTIONS(655),
    [anon_sym_mutable] = ACTIONS(655),
    [anon_sym_explicit] = ACTIONS(655),
    [anon_sym_constexpr] = ACTIONS(655),
    [anon_sym_unsigned] = ACTIONS(6344),
    [anon_sym_long] = ACTIONS(6344),
    [anon_sym_short] = ACTIONS(6344),
    [sym_primitive_type] = ACTIONS(659),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [anon_sym_DASH_GT] = ACTIONS(653),
    [sym_identifier] = ACTIONS(933),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(655),
    [anon_sym_override] = ACTIONS(655),
    [sym_noexcept] = ACTIONS(655),
  },
  [2266] = {
    [sym_type_qualifier] = STATE(2266),
    [sym_virtual_specifier] = STATE(2266),
    [sym_trailing_return_type] = STATE(2266),
    [aux_sym_function_declarator_repeat1] = STATE(2266),
    [anon_sym_SEMI] = ACTIONS(5236),
    [anon_sym_LPAREN2] = ACTIONS(5236),
    [anon_sym_LBRACK] = ACTIONS(5236),
    [anon_sym_const] = ACTIONS(5877),
    [anon_sym_restrict] = ACTIONS(5880),
    [anon_sym_volatile] = ACTIONS(5880),
    [anon_sym__Atomic] = ACTIONS(5880),
    [anon_sym_mutable] = ACTIONS(5880),
    [anon_sym_explicit] = ACTIONS(5880),
    [anon_sym_constexpr] = ACTIONS(5880),
    [anon_sym_DASH_GT] = ACTIONS(6346),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5247),
    [anon_sym_override] = ACTIONS(5247),
    [sym_noexcept] = ACTIONS(6349),
  },
  [2267] = {
    [sym_storage_class_specifier] = STATE(2267),
    [sym_type_qualifier] = STATE(2267),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2267),
    [anon_sym_SEMI] = ACTIONS(1970),
    [anon_sym_extern] = ACTIONS(1967),
    [anon_sym_LPAREN2] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(1970),
    [anon_sym_static] = ACTIONS(1967),
    [anon_sym_register] = ACTIONS(1967),
    [anon_sym_inline] = ACTIONS(1967),
    [anon_sym_const] = ACTIONS(1972),
    [anon_sym_restrict] = ACTIONS(1972),
    [anon_sym_volatile] = ACTIONS(1972),
    [anon_sym__Atomic] = ACTIONS(1972),
    [anon_sym_mutable] = ACTIONS(1972),
    [anon_sym_explicit] = ACTIONS(1972),
    [anon_sym_constexpr] = ACTIONS(1972),
    [anon_sym_AMP] = ACTIONS(1975),
    [anon_sym_AMP_AMP] = ACTIONS(1970),
    [anon_sym_TILDE] = ACTIONS(1970),
    [sym_identifier] = ACTIONS(1975),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1970),
    [sym_operator_name] = ACTIONS(1970),
  },
  [2268] = {
    [sym_storage_class_specifier] = STATE(2267),
    [sym_type_qualifier] = STATE(2267),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2267),
    [anon_sym_SEMI] = ACTIONS(3695),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_LPAREN2] = ACTIONS(3695),
    [anon_sym_STAR] = ACTIONS(3695),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3695),
    [anon_sym_TILDE] = ACTIONS(3695),
    [sym_identifier] = ACTIONS(3697),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(3695),
    [sym_operator_name] = ACTIONS(3695),
  },
  [2269] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(6352),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2270] = {
    [sym__expression] = STATE(2840),
    [sym_conditional_expression] = STATE(2840),
    [sym_assignment_expression] = STATE(2840),
    [sym_pointer_expression] = STATE(2840),
    [sym_logical_expression] = STATE(2840),
    [sym_bitwise_expression] = STATE(2840),
    [sym_equality_expression] = STATE(2840),
    [sym_relational_expression] = STATE(2840),
    [sym_shift_expression] = STATE(2840),
    [sym_math_expression] = STATE(2840),
    [sym_cast_expression] = STATE(2840),
    [sym_sizeof_expression] = STATE(2840),
    [sym_subscript_expression] = STATE(2840),
    [sym_call_expression] = STATE(2840),
    [sym_field_expression] = STATE(2840),
    [sym_compound_literal_expression] = STATE(2840),
    [sym_parenthesized_expression] = STATE(2840),
    [sym_char_literal] = STATE(2840),
    [sym_concatenated_string] = STATE(2840),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2840),
    [sym_new_expression] = STATE(2840),
    [sym_delete_expression] = STATE(2840),
    [sym_lambda_expression] = STATE(2840),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6354),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(6354),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6356),
    [sym_false] = ACTIONS(6356),
    [sym_null] = ACTIONS(6356),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(6356),
  },
  [2271] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(548),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_COLON] = ACTIONS(3322),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(935),
  },
  [2272] = {
    [sym_declaration] = STATE(1346),
    [sym_type_definition] = STATE(1346),
    [sym__declaration_specifiers] = STATE(682),
    [sym_compound_statement] = STATE(1346),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_labeled_statement] = STATE(1346),
    [sym_expression_statement] = STATE(1346),
    [sym_if_statement] = STATE(1346),
    [sym_switch_statement] = STATE(1346),
    [sym_case_statement] = STATE(1346),
    [sym_while_statement] = STATE(1346),
    [sym_do_statement] = STATE(1346),
    [sym_for_statement] = STATE(1346),
    [sym_return_statement] = STATE(1346),
    [sym_break_statement] = STATE(1346),
    [sym_continue_statement] = STATE(1346),
    [sym_goto_statement] = STATE(1346),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(1346),
    [sym_try_statement] = STATE(1346),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(1495),
    [anon_sym_switch] = ACTIONS(1497),
    [anon_sym_case] = ACTIONS(1499),
    [anon_sym_default] = ACTIONS(1501),
    [anon_sym_while] = ACTIONS(1503),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(1505),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(4941),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(1509),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(1202),
    [sym_nullptr] = ACTIONS(87),
  },
  [2273] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(1362),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_extern] = ACTIONS(468),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(465),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_register] = ACTIONS(468),
    [anon_sym_inline] = ACTIONS(468),
    [anon_sym_const] = ACTIONS(468),
    [anon_sym_restrict] = ACTIONS(468),
    [anon_sym_volatile] = ACTIONS(468),
    [anon_sym__Atomic] = ACTIONS(468),
    [anon_sym_mutable] = ACTIONS(468),
    [anon_sym_explicit] = ACTIONS(468),
    [anon_sym_constexpr] = ACTIONS(468),
    [anon_sym_COLON] = ACTIONS(3322),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(474),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_TILDE] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_identifier] = ACTIONS(468),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(2855),
    [sym_operator_name] = ACTIONS(481),
  },
  [2274] = {
    [sym__expression] = STATE(2842),
    [sym_conditional_expression] = STATE(2842),
    [sym_assignment_expression] = STATE(2842),
    [sym_pointer_expression] = STATE(2842),
    [sym_logical_expression] = STATE(2842),
    [sym_bitwise_expression] = STATE(2842),
    [sym_equality_expression] = STATE(2842),
    [sym_relational_expression] = STATE(2842),
    [sym_shift_expression] = STATE(2842),
    [sym_math_expression] = STATE(2842),
    [sym_cast_expression] = STATE(2842),
    [sym_sizeof_expression] = STATE(2842),
    [sym_subscript_expression] = STATE(2842),
    [sym_call_expression] = STATE(2842),
    [sym_field_expression] = STATE(2842),
    [sym_compound_literal_expression] = STATE(2842),
    [sym_parenthesized_expression] = STATE(2842),
    [sym_char_literal] = STATE(2842),
    [sym_concatenated_string] = STATE(2842),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2842),
    [sym_new_expression] = STATE(2842),
    [sym_delete_expression] = STATE(2842),
    [sym_lambda_expression] = STATE(2842),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6358),
    [anon_sym_SEMI] = ACTIONS(6360),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(6358),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6362),
    [sym_false] = ACTIONS(6362),
    [sym_null] = ACTIONS(6362),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(6362),
  },
  [2275] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(6364),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2276] = {
    [anon_sym_COLON] = ACTIONS(6366),
    [sym_comment] = ACTIONS(91),
  },
  [2277] = {
    [sym_catch_clause] = STATE(2845),
    [aux_sym_try_statement_repeat1] = STATE(2845),
    [sym_raw_string_literal] = ACTIONS(3346),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3348),
    [sym_preproc_directive] = ACTIONS(3348),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym_typedef] = ACTIONS(3348),
    [anon_sym_extern] = ACTIONS(3348),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_RBRACE] = ACTIONS(3346),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(3346),
    [anon_sym_static] = ACTIONS(3348),
    [anon_sym_register] = ACTIONS(3348),
    [anon_sym_inline] = ACTIONS(3348),
    [anon_sym_const] = ACTIONS(3348),
    [anon_sym_restrict] = ACTIONS(3348),
    [anon_sym_volatile] = ACTIONS(3348),
    [anon_sym__Atomic] = ACTIONS(3348),
    [anon_sym_mutable] = ACTIONS(3348),
    [anon_sym_explicit] = ACTIONS(3348),
    [anon_sym_constexpr] = ACTIONS(3348),
    [anon_sym_unsigned] = ACTIONS(3348),
    [anon_sym_long] = ACTIONS(3348),
    [anon_sym_short] = ACTIONS(3348),
    [sym_primitive_type] = ACTIONS(3348),
    [anon_sym_enum] = ACTIONS(3348),
    [anon_sym_struct] = ACTIONS(3348),
    [anon_sym_union] = ACTIONS(3348),
    [anon_sym_if] = ACTIONS(3348),
    [anon_sym_switch] = ACTIONS(3348),
    [anon_sym_case] = ACTIONS(3348),
    [anon_sym_default] = ACTIONS(3348),
    [anon_sym_while] = ACTIONS(3348),
    [anon_sym_do] = ACTIONS(3348),
    [anon_sym_for] = ACTIONS(3348),
    [anon_sym_return] = ACTIONS(3348),
    [anon_sym_break] = ACTIONS(3348),
    [anon_sym_continue] = ACTIONS(3348),
    [anon_sym_goto] = ACTIONS(3348),
    [anon_sym_AMP] = ACTIONS(3348),
    [anon_sym_AMP_AMP] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_PLUS] = ACTIONS(3348),
    [anon_sym_DASH] = ACTIONS(3348),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_sizeof] = ACTIONS(3348),
    [sym_number_literal] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [sym_true] = ACTIONS(3348),
    [sym_false] = ACTIONS(3348),
    [sym_null] = ACTIONS(3348),
    [sym_identifier] = ACTIONS(3348),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3348),
    [sym_auto] = ACTIONS(3348),
    [anon_sym_typename] = ACTIONS(3348),
    [anon_sym_template] = ACTIONS(3348),
    [anon_sym_delete] = ACTIONS(3348),
    [anon_sym_namespace] = ACTIONS(3348),
    [anon_sym_using] = ACTIONS(3348),
    [anon_sym_try] = ACTIONS(3348),
    [anon_sym_catch] = ACTIONS(3350),
    [anon_sym_new] = ACTIONS(3348),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [sym_operator_name] = ACTIONS(3346),
    [sym_nullptr] = ACTIONS(3348),
  },
  [2278] = {
    [sym__abstract_declarator] = STATE(2846),
    [sym_abstract_pointer_declarator] = STATE(2846),
    [sym_abstract_function_declarator] = STATE(2846),
    [sym_abstract_array_declarator] = STATE(2846),
    [sym_type_qualifier] = STATE(2847),
    [sym_parameter_list] = STATE(2281),
    [sym_abstract_reference_declarator] = STATE(2846),
    [aux_sym_type_definition_repeat1] = STATE(2847),
    [anon_sym_SEMI] = ACTIONS(2461),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(4977),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(4979),
    [anon_sym_AMP_AMP] = ACTIONS(4981),
    [sym_comment] = ACTIONS(91),
  },
  [2279] = {
    [sym__abstract_declarator] = STATE(2848),
    [sym_abstract_pointer_declarator] = STATE(2848),
    [sym_abstract_function_declarator] = STATE(2848),
    [sym_abstract_array_declarator] = STATE(2848),
    [sym_parameter_list] = STATE(2281),
    [sym_abstract_reference_declarator] = STATE(2848),
    [anon_sym_SEMI] = ACTIONS(2463),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(4977),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_AMP] = ACTIONS(4979),
    [anon_sym_AMP_AMP] = ACTIONS(4981),
    [sym_comment] = ACTIONS(91),
  },
  [2280] = {
    [sym_parameter_list] = STATE(2849),
    [anon_sym_SEMI] = ACTIONS(2465),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [sym_comment] = ACTIONS(91),
  },
  [2281] = {
    [sym_type_qualifier] = STATE(2851),
    [sym_trailing_return_type] = STATE(971),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2851),
    [anon_sym_SEMI] = ACTIONS(1787),
    [anon_sym_LPAREN2] = ACTIONS(1787),
    [anon_sym_LBRACK] = ACTIONS(1787),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(6368),
    [sym_comment] = ACTIONS(91),
    [sym_noexcept] = ACTIONS(6370),
  },
  [2282] = {
    [sym_raw_string_literal] = ACTIONS(6372),
    [ts_builtin_sym_end] = ACTIONS(6372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6374),
    [sym_preproc_directive] = ACTIONS(6374),
    [anon_sym_SEMI] = ACTIONS(6372),
    [anon_sym_typedef] = ACTIONS(6374),
    [anon_sym_extern] = ACTIONS(6374),
    [anon_sym_LBRACE] = ACTIONS(6372),
    [anon_sym_RBRACE] = ACTIONS(6372),
    [anon_sym_LPAREN2] = ACTIONS(6372),
    [anon_sym_STAR] = ACTIONS(6372),
    [anon_sym_LBRACK] = ACTIONS(6372),
    [anon_sym_static] = ACTIONS(6374),
    [anon_sym_register] = ACTIONS(6374),
    [anon_sym_inline] = ACTIONS(6374),
    [anon_sym_const] = ACTIONS(6374),
    [anon_sym_restrict] = ACTIONS(6374),
    [anon_sym_volatile] = ACTIONS(6374),
    [anon_sym__Atomic] = ACTIONS(6374),
    [anon_sym_mutable] = ACTIONS(6374),
    [anon_sym_explicit] = ACTIONS(6374),
    [anon_sym_constexpr] = ACTIONS(6374),
    [anon_sym_unsigned] = ACTIONS(6374),
    [anon_sym_long] = ACTIONS(6374),
    [anon_sym_short] = ACTIONS(6374),
    [sym_primitive_type] = ACTIONS(6374),
    [anon_sym_enum] = ACTIONS(6374),
    [anon_sym_struct] = ACTIONS(6374),
    [anon_sym_union] = ACTIONS(6374),
    [anon_sym_if] = ACTIONS(6374),
    [anon_sym_switch] = ACTIONS(6374),
    [anon_sym_case] = ACTIONS(6374),
    [anon_sym_default] = ACTIONS(6374),
    [anon_sym_while] = ACTIONS(6374),
    [anon_sym_do] = ACTIONS(6374),
    [anon_sym_for] = ACTIONS(6374),
    [anon_sym_return] = ACTIONS(6374),
    [anon_sym_break] = ACTIONS(6374),
    [anon_sym_continue] = ACTIONS(6374),
    [anon_sym_goto] = ACTIONS(6374),
    [anon_sym_AMP] = ACTIONS(6374),
    [anon_sym_AMP_AMP] = ACTIONS(6372),
    [anon_sym_BANG] = ACTIONS(6372),
    [anon_sym_TILDE] = ACTIONS(6372),
    [anon_sym_PLUS] = ACTIONS(6374),
    [anon_sym_DASH] = ACTIONS(6374),
    [anon_sym_DASH_DASH] = ACTIONS(6372),
    [anon_sym_PLUS_PLUS] = ACTIONS(6372),
    [anon_sym_sizeof] = ACTIONS(6374),
    [sym_number_literal] = ACTIONS(6372),
    [anon_sym_SQUOTE] = ACTIONS(6372),
    [anon_sym_DQUOTE] = ACTIONS(6372),
    [sym_true] = ACTIONS(6374),
    [sym_false] = ACTIONS(6374),
    [sym_null] = ACTIONS(6374),
    [sym_identifier] = ACTIONS(6374),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6374),
    [sym_auto] = ACTIONS(6374),
    [anon_sym_typename] = ACTIONS(6374),
    [anon_sym_template] = ACTIONS(6374),
    [anon_sym_delete] = ACTIONS(6374),
    [anon_sym_namespace] = ACTIONS(6374),
    [anon_sym_using] = ACTIONS(6374),
    [anon_sym_try] = ACTIONS(6374),
    [anon_sym_new] = ACTIONS(6374),
    [anon_sym_COLON_COLON] = ACTIONS(6372),
    [sym_operator_name] = ACTIONS(6372),
    [sym_nullptr] = ACTIONS(6374),
  },
  [2283] = {
    [sym__abstract_declarator] = STATE(2852),
    [sym_abstract_pointer_declarator] = STATE(2852),
    [sym_abstract_function_declarator] = STATE(2852),
    [sym_abstract_array_declarator] = STATE(2852),
    [sym_parameter_list] = STATE(2281),
    [sym_abstract_reference_declarator] = STATE(2852),
    [anon_sym_SEMI] = ACTIONS(2465),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(4977),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_AMP] = ACTIONS(4979),
    [anon_sym_AMP_AMP] = ACTIONS(4981),
    [sym_comment] = ACTIONS(91),
  },
  [2284] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2284),
    [anon_sym_SEMI] = ACTIONS(1985),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1985),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_unsigned] = ACTIONS(6376),
    [anon_sym_long] = ACTIONS(6376),
    [anon_sym_short] = ACTIONS(6376),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [sym_comment] = ACTIONS(91),
  },
  [2285] = {
    [sym_raw_string_literal] = ACTIONS(6379),
    [ts_builtin_sym_end] = ACTIONS(6379),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6381),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6381),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6381),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6381),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6381),
    [sym_preproc_directive] = ACTIONS(6381),
    [anon_sym_SEMI] = ACTIONS(6379),
    [anon_sym_typedef] = ACTIONS(6381),
    [anon_sym_extern] = ACTIONS(6381),
    [anon_sym_LBRACE] = ACTIONS(6379),
    [anon_sym_RBRACE] = ACTIONS(6379),
    [anon_sym_LPAREN2] = ACTIONS(6379),
    [anon_sym_STAR] = ACTIONS(6379),
    [anon_sym_LBRACK] = ACTIONS(6379),
    [anon_sym_static] = ACTIONS(6381),
    [anon_sym_register] = ACTIONS(6381),
    [anon_sym_inline] = ACTIONS(6381),
    [anon_sym_const] = ACTIONS(6381),
    [anon_sym_restrict] = ACTIONS(6381),
    [anon_sym_volatile] = ACTIONS(6381),
    [anon_sym__Atomic] = ACTIONS(6381),
    [anon_sym_mutable] = ACTIONS(6381),
    [anon_sym_explicit] = ACTIONS(6381),
    [anon_sym_constexpr] = ACTIONS(6381),
    [anon_sym_unsigned] = ACTIONS(6381),
    [anon_sym_long] = ACTIONS(6381),
    [anon_sym_short] = ACTIONS(6381),
    [sym_primitive_type] = ACTIONS(6381),
    [anon_sym_enum] = ACTIONS(6381),
    [anon_sym_struct] = ACTIONS(6381),
    [anon_sym_union] = ACTIONS(6381),
    [anon_sym_if] = ACTIONS(6381),
    [anon_sym_else] = ACTIONS(6381),
    [anon_sym_switch] = ACTIONS(6381),
    [anon_sym_case] = ACTIONS(6381),
    [anon_sym_default] = ACTIONS(6381),
    [anon_sym_while] = ACTIONS(6381),
    [anon_sym_do] = ACTIONS(6381),
    [anon_sym_for] = ACTIONS(6381),
    [anon_sym_return] = ACTIONS(6381),
    [anon_sym_break] = ACTIONS(6381),
    [anon_sym_continue] = ACTIONS(6381),
    [anon_sym_goto] = ACTIONS(6381),
    [anon_sym_AMP] = ACTIONS(6381),
    [anon_sym_AMP_AMP] = ACTIONS(6379),
    [anon_sym_BANG] = ACTIONS(6379),
    [anon_sym_TILDE] = ACTIONS(6379),
    [anon_sym_PLUS] = ACTIONS(6381),
    [anon_sym_DASH] = ACTIONS(6381),
    [anon_sym_DASH_DASH] = ACTIONS(6379),
    [anon_sym_PLUS_PLUS] = ACTIONS(6379),
    [anon_sym_sizeof] = ACTIONS(6381),
    [sym_number_literal] = ACTIONS(6379),
    [anon_sym_SQUOTE] = ACTIONS(6379),
    [anon_sym_DQUOTE] = ACTIONS(6379),
    [sym_true] = ACTIONS(6381),
    [sym_false] = ACTIONS(6381),
    [sym_null] = ACTIONS(6381),
    [sym_identifier] = ACTIONS(6381),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6381),
    [sym_auto] = ACTIONS(6381),
    [anon_sym_typename] = ACTIONS(6381),
    [anon_sym_template] = ACTIONS(6381),
    [anon_sym_delete] = ACTIONS(6381),
    [anon_sym_namespace] = ACTIONS(6381),
    [anon_sym_using] = ACTIONS(6381),
    [anon_sym_try] = ACTIONS(6381),
    [anon_sym_catch] = ACTIONS(6381),
    [anon_sym_new] = ACTIONS(6381),
    [anon_sym_COLON_COLON] = ACTIONS(6379),
    [sym_operator_name] = ACTIONS(6379),
    [sym_nullptr] = ACTIONS(6381),
  },
  [2286] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(6383),
    [anon_sym_RPAREN] = ACTIONS(6383),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2287] = {
    [anon_sym_COMMA] = ACTIONS(6383),
    [anon_sym_RPAREN] = ACTIONS(6383),
    [sym_comment] = ACTIONS(91),
  },
  [2288] = {
    [anon_sym_COMMA] = ACTIONS(6385),
    [anon_sym_RPAREN] = ACTIONS(6385),
    [anon_sym_SEMI] = ACTIONS(6385),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_RBRACE] = ACTIONS(6385),
    [anon_sym_LPAREN2] = ACTIONS(6385),
    [anon_sym_STAR] = ACTIONS(6387),
    [anon_sym_LBRACK] = ACTIONS(6385),
    [anon_sym_RBRACK] = ACTIONS(6385),
    [anon_sym_EQ] = ACTIONS(6387),
    [anon_sym_unsigned] = ACTIONS(6387),
    [anon_sym_long] = ACTIONS(6387),
    [anon_sym_short] = ACTIONS(6387),
    [sym_primitive_type] = ACTIONS(6387),
    [anon_sym_enum] = ACTIONS(6387),
    [anon_sym_struct] = ACTIONS(6387),
    [anon_sym_union] = ACTIONS(6387),
    [anon_sym_QMARK] = ACTIONS(6385),
    [anon_sym_STAR_EQ] = ACTIONS(6385),
    [anon_sym_SLASH_EQ] = ACTIONS(6385),
    [anon_sym_PERCENT_EQ] = ACTIONS(6385),
    [anon_sym_PLUS_EQ] = ACTIONS(6385),
    [anon_sym_DASH_EQ] = ACTIONS(6385),
    [anon_sym_LT_LT_EQ] = ACTIONS(6385),
    [anon_sym_GT_GT_EQ] = ACTIONS(6385),
    [anon_sym_AMP_EQ] = ACTIONS(6385),
    [anon_sym_CARET_EQ] = ACTIONS(6385),
    [anon_sym_PIPE_EQ] = ACTIONS(6385),
    [anon_sym_AMP] = ACTIONS(6387),
    [anon_sym_PIPE_PIPE] = ACTIONS(6385),
    [anon_sym_AMP_AMP] = ACTIONS(6385),
    [anon_sym_PIPE] = ACTIONS(6387),
    [anon_sym_CARET] = ACTIONS(6387),
    [anon_sym_EQ_EQ] = ACTIONS(6385),
    [anon_sym_BANG_EQ] = ACTIONS(6385),
    [anon_sym_LT] = ACTIONS(6387),
    [anon_sym_GT] = ACTIONS(6387),
    [anon_sym_LT_EQ] = ACTIONS(6385),
    [anon_sym_GT_EQ] = ACTIONS(6385),
    [anon_sym_LT_LT] = ACTIONS(6387),
    [anon_sym_GT_GT] = ACTIONS(6387),
    [anon_sym_PLUS] = ACTIONS(6387),
    [anon_sym_DASH] = ACTIONS(6387),
    [anon_sym_SLASH] = ACTIONS(6387),
    [anon_sym_PERCENT] = ACTIONS(6387),
    [anon_sym_DASH_DASH] = ACTIONS(6385),
    [anon_sym_PLUS_PLUS] = ACTIONS(6385),
    [anon_sym_DOT] = ACTIONS(6385),
    [anon_sym_DASH_GT] = ACTIONS(6385),
    [sym_identifier] = ACTIONS(6387),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6387),
    [sym_auto] = ACTIONS(6387),
    [anon_sym_typename] = ACTIONS(6387),
    [anon_sym_COLON_COLON] = ACTIONS(6385),
  },
  [2289] = {
    [aux_sym_argument_list_repeat1] = STATE(2289),
    [anon_sym_COMMA] = ACTIONS(6389),
    [anon_sym_RPAREN] = ACTIONS(6383),
    [sym_comment] = ACTIONS(91),
  },
  [2290] = {
    [anon_sym_COMMA] = ACTIONS(4213),
    [anon_sym_RPAREN] = ACTIONS(4213),
    [anon_sym_SEMI] = ACTIONS(4213),
    [anon_sym_LBRACE] = ACTIONS(4213),
    [anon_sym_RBRACE] = ACTIONS(4213),
    [anon_sym_LPAREN2] = ACTIONS(4213),
    [anon_sym_STAR] = ACTIONS(4215),
    [anon_sym_LBRACK] = ACTIONS(4213),
    [anon_sym_RBRACK] = ACTIONS(4213),
    [anon_sym_EQ] = ACTIONS(4215),
    [anon_sym_COLON] = ACTIONS(4213),
    [anon_sym_QMARK] = ACTIONS(4213),
    [anon_sym_STAR_EQ] = ACTIONS(4213),
    [anon_sym_SLASH_EQ] = ACTIONS(4213),
    [anon_sym_PERCENT_EQ] = ACTIONS(4213),
    [anon_sym_PLUS_EQ] = ACTIONS(4213),
    [anon_sym_DASH_EQ] = ACTIONS(4213),
    [anon_sym_LT_LT_EQ] = ACTIONS(4213),
    [anon_sym_GT_GT_EQ] = ACTIONS(4213),
    [anon_sym_AMP_EQ] = ACTIONS(4213),
    [anon_sym_CARET_EQ] = ACTIONS(4213),
    [anon_sym_PIPE_EQ] = ACTIONS(4213),
    [anon_sym_AMP] = ACTIONS(4215),
    [anon_sym_PIPE_PIPE] = ACTIONS(4213),
    [anon_sym_AMP_AMP] = ACTIONS(4213),
    [anon_sym_PIPE] = ACTIONS(4215),
    [anon_sym_CARET] = ACTIONS(4215),
    [anon_sym_EQ_EQ] = ACTIONS(4213),
    [anon_sym_BANG_EQ] = ACTIONS(4213),
    [anon_sym_LT] = ACTIONS(4215),
    [anon_sym_GT] = ACTIONS(4215),
    [anon_sym_LT_EQ] = ACTIONS(4213),
    [anon_sym_GT_EQ] = ACTIONS(4213),
    [anon_sym_LT_LT] = ACTIONS(4215),
    [anon_sym_GT_GT] = ACTIONS(4215),
    [anon_sym_PLUS] = ACTIONS(4215),
    [anon_sym_DASH] = ACTIONS(4215),
    [anon_sym_SLASH] = ACTIONS(4215),
    [anon_sym_PERCENT] = ACTIONS(4215),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_DOT] = ACTIONS(4213),
    [anon_sym_DASH_GT] = ACTIONS(4213),
    [sym_comment] = ACTIONS(91),
  },
  [2291] = {
    [sym_enumerator] = STATE(1988),
    [anon_sym_RBRACE] = ACTIONS(6392),
    [sym_identifier] = ACTIONS(1009),
    [sym_comment] = ACTIONS(91),
  },
  [2292] = {
    [aux_sym_enumerator_list_repeat1] = STATE(1990),
    [anon_sym_COMMA] = ACTIONS(6394),
    [anon_sym_RBRACE] = ACTIONS(6392),
    [sym_comment] = ACTIONS(91),
  },
  [2293] = {
    [anon_sym_COMMA] = ACTIONS(4307),
    [anon_sym_RPAREN] = ACTIONS(4307),
    [anon_sym_SEMI] = ACTIONS(4307),
    [anon_sym_LBRACE] = ACTIONS(4307),
    [anon_sym_RBRACE] = ACTIONS(4307),
    [anon_sym_LPAREN2] = ACTIONS(4307),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_LBRACK] = ACTIONS(4307),
    [anon_sym_RBRACK] = ACTIONS(4307),
    [anon_sym_EQ] = ACTIONS(4309),
    [anon_sym_COLON] = ACTIONS(4307),
    [anon_sym_QMARK] = ACTIONS(4307),
    [anon_sym_STAR_EQ] = ACTIONS(4307),
    [anon_sym_SLASH_EQ] = ACTIONS(4307),
    [anon_sym_PERCENT_EQ] = ACTIONS(4307),
    [anon_sym_PLUS_EQ] = ACTIONS(4307),
    [anon_sym_DASH_EQ] = ACTIONS(4307),
    [anon_sym_LT_LT_EQ] = ACTIONS(4307),
    [anon_sym_GT_GT_EQ] = ACTIONS(4307),
    [anon_sym_AMP_EQ] = ACTIONS(4307),
    [anon_sym_CARET_EQ] = ACTIONS(4307),
    [anon_sym_PIPE_EQ] = ACTIONS(4307),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_PIPE_PIPE] = ACTIONS(4307),
    [anon_sym_AMP_AMP] = ACTIONS(4307),
    [anon_sym_PIPE] = ACTIONS(4309),
    [anon_sym_CARET] = ACTIONS(4309),
    [anon_sym_EQ_EQ] = ACTIONS(4307),
    [anon_sym_BANG_EQ] = ACTIONS(4307),
    [anon_sym_LT] = ACTIONS(4309),
    [anon_sym_GT] = ACTIONS(4309),
    [anon_sym_LT_EQ] = ACTIONS(4307),
    [anon_sym_GT_EQ] = ACTIONS(4307),
    [anon_sym_LT_LT] = ACTIONS(4309),
    [anon_sym_GT_GT] = ACTIONS(4309),
    [anon_sym_PLUS] = ACTIONS(4309),
    [anon_sym_DASH] = ACTIONS(4309),
    [anon_sym_SLASH] = ACTIONS(4309),
    [anon_sym_PERCENT] = ACTIONS(4309),
    [anon_sym_DASH_DASH] = ACTIONS(4307),
    [anon_sym_PLUS_PLUS] = ACTIONS(4307),
    [anon_sym_DOT] = ACTIONS(4307),
    [anon_sym_DASH_GT] = ACTIONS(4307),
    [sym_comment] = ACTIONS(91),
  },
  [2294] = {
    [anon_sym_COMMA] = ACTIONS(4398),
    [anon_sym_RPAREN] = ACTIONS(4398),
    [anon_sym_SEMI] = ACTIONS(4398),
    [anon_sym_LBRACE] = ACTIONS(4398),
    [anon_sym_RBRACE] = ACTIONS(4398),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_STAR] = ACTIONS(4400),
    [anon_sym_LBRACK] = ACTIONS(4398),
    [anon_sym_RBRACK] = ACTIONS(4398),
    [anon_sym_EQ] = ACTIONS(4400),
    [anon_sym_COLON] = ACTIONS(4398),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_STAR_EQ] = ACTIONS(4398),
    [anon_sym_SLASH_EQ] = ACTIONS(4398),
    [anon_sym_PERCENT_EQ] = ACTIONS(4398),
    [anon_sym_PLUS_EQ] = ACTIONS(4398),
    [anon_sym_DASH_EQ] = ACTIONS(4398),
    [anon_sym_LT_LT_EQ] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(4398),
    [anon_sym_AMP_EQ] = ACTIONS(4398),
    [anon_sym_CARET_EQ] = ACTIONS(4398),
    [anon_sym_PIPE_EQ] = ACTIONS(4398),
    [anon_sym_AMP] = ACTIONS(4400),
    [anon_sym_PIPE_PIPE] = ACTIONS(4398),
    [anon_sym_AMP_AMP] = ACTIONS(4398),
    [anon_sym_PIPE] = ACTIONS(4400),
    [anon_sym_CARET] = ACTIONS(4400),
    [anon_sym_EQ_EQ] = ACTIONS(4398),
    [anon_sym_BANG_EQ] = ACTIONS(4398),
    [anon_sym_LT] = ACTIONS(4400),
    [anon_sym_GT] = ACTIONS(4400),
    [anon_sym_LT_EQ] = ACTIONS(4398),
    [anon_sym_GT_EQ] = ACTIONS(4398),
    [anon_sym_LT_LT] = ACTIONS(4400),
    [anon_sym_GT_GT] = ACTIONS(4400),
    [anon_sym_PLUS] = ACTIONS(4400),
    [anon_sym_DASH] = ACTIONS(4400),
    [anon_sym_SLASH] = ACTIONS(4400),
    [anon_sym_PERCENT] = ACTIONS(4400),
    [anon_sym_DASH_DASH] = ACTIONS(4398),
    [anon_sym_PLUS_PLUS] = ACTIONS(4398),
    [anon_sym_DOT] = ACTIONS(4398),
    [anon_sym_DASH_GT] = ACTIONS(4398),
    [sym_comment] = ACTIONS(91),
  },
  [2295] = {
    [sym_field_declaration_list] = STATE(2855),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [sym_comment] = ACTIONS(91),
  },
  [2296] = {
    [anon_sym_COMMA] = ACTIONS(4402),
    [anon_sym_RPAREN] = ACTIONS(4402),
    [anon_sym_SEMI] = ACTIONS(4402),
    [anon_sym_LBRACE] = ACTIONS(4402),
    [anon_sym_RBRACE] = ACTIONS(4402),
    [anon_sym_LPAREN2] = ACTIONS(4402),
    [anon_sym_STAR] = ACTIONS(4404),
    [anon_sym_LBRACK] = ACTIONS(4402),
    [anon_sym_RBRACK] = ACTIONS(4402),
    [anon_sym_EQ] = ACTIONS(4404),
    [anon_sym_COLON] = ACTIONS(4402),
    [anon_sym_QMARK] = ACTIONS(4402),
    [anon_sym_STAR_EQ] = ACTIONS(4402),
    [anon_sym_SLASH_EQ] = ACTIONS(4402),
    [anon_sym_PERCENT_EQ] = ACTIONS(4402),
    [anon_sym_PLUS_EQ] = ACTIONS(4402),
    [anon_sym_DASH_EQ] = ACTIONS(4402),
    [anon_sym_LT_LT_EQ] = ACTIONS(4402),
    [anon_sym_GT_GT_EQ] = ACTIONS(4402),
    [anon_sym_AMP_EQ] = ACTIONS(4402),
    [anon_sym_CARET_EQ] = ACTIONS(4402),
    [anon_sym_PIPE_EQ] = ACTIONS(4402),
    [anon_sym_AMP] = ACTIONS(4404),
    [anon_sym_PIPE_PIPE] = ACTIONS(4402),
    [anon_sym_AMP_AMP] = ACTIONS(4402),
    [anon_sym_PIPE] = ACTIONS(4404),
    [anon_sym_CARET] = ACTIONS(4404),
    [anon_sym_EQ_EQ] = ACTIONS(4402),
    [anon_sym_BANG_EQ] = ACTIONS(4402),
    [anon_sym_LT] = ACTIONS(4404),
    [anon_sym_GT] = ACTIONS(4404),
    [anon_sym_LT_EQ] = ACTIONS(4402),
    [anon_sym_GT_EQ] = ACTIONS(4402),
    [anon_sym_LT_LT] = ACTIONS(4404),
    [anon_sym_GT_GT] = ACTIONS(4404),
    [anon_sym_PLUS] = ACTIONS(4404),
    [anon_sym_DASH] = ACTIONS(4404),
    [anon_sym_SLASH] = ACTIONS(4404),
    [anon_sym_PERCENT] = ACTIONS(4404),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_DOT] = ACTIONS(4402),
    [anon_sym_DASH_GT] = ACTIONS(4402),
    [sym_comment] = ACTIONS(91),
  },
  [2297] = {
    [sym_field_declaration_list] = STATE(2856),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [sym_comment] = ACTIONS(91),
  },
  [2298] = {
    [anon_sym_COMMA] = ACTIONS(4406),
    [anon_sym_RPAREN] = ACTIONS(4406),
    [anon_sym_SEMI] = ACTIONS(4406),
    [anon_sym_LBRACE] = ACTIONS(4406),
    [anon_sym_RBRACE] = ACTIONS(4406),
    [anon_sym_LPAREN2] = ACTIONS(4406),
    [anon_sym_STAR] = ACTIONS(4408),
    [anon_sym_LBRACK] = ACTIONS(4406),
    [anon_sym_RBRACK] = ACTIONS(4406),
    [anon_sym_EQ] = ACTIONS(4408),
    [anon_sym_COLON] = ACTIONS(4406),
    [anon_sym_QMARK] = ACTIONS(4406),
    [anon_sym_STAR_EQ] = ACTIONS(4406),
    [anon_sym_SLASH_EQ] = ACTIONS(4406),
    [anon_sym_PERCENT_EQ] = ACTIONS(4406),
    [anon_sym_PLUS_EQ] = ACTIONS(4406),
    [anon_sym_DASH_EQ] = ACTIONS(4406),
    [anon_sym_LT_LT_EQ] = ACTIONS(4406),
    [anon_sym_GT_GT_EQ] = ACTIONS(4406),
    [anon_sym_AMP_EQ] = ACTIONS(4406),
    [anon_sym_CARET_EQ] = ACTIONS(4406),
    [anon_sym_PIPE_EQ] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_PIPE_PIPE] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_PIPE] = ACTIONS(4408),
    [anon_sym_CARET] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4406),
    [anon_sym_BANG_EQ] = ACTIONS(4406),
    [anon_sym_LT] = ACTIONS(4408),
    [anon_sym_GT] = ACTIONS(4408),
    [anon_sym_LT_EQ] = ACTIONS(4406),
    [anon_sym_GT_EQ] = ACTIONS(4406),
    [anon_sym_LT_LT] = ACTIONS(4408),
    [anon_sym_GT_GT] = ACTIONS(4408),
    [anon_sym_PLUS] = ACTIONS(4408),
    [anon_sym_DASH] = ACTIONS(4408),
    [anon_sym_SLASH] = ACTIONS(4408),
    [anon_sym_PERCENT] = ACTIONS(4408),
    [anon_sym_DASH_DASH] = ACTIONS(4406),
    [anon_sym_PLUS_PLUS] = ACTIONS(4406),
    [anon_sym_DOT] = ACTIONS(4406),
    [anon_sym_DASH_GT] = ACTIONS(4406),
    [sym_comment] = ACTIONS(91),
  },
  [2299] = {
    [sym_field_declaration_list] = STATE(2857),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [sym_comment] = ACTIONS(91),
  },
  [2300] = {
    [anon_sym_COMMA] = ACTIONS(4410),
    [anon_sym_RPAREN] = ACTIONS(4410),
    [anon_sym_SEMI] = ACTIONS(4410),
    [anon_sym_LBRACE] = ACTIONS(4410),
    [anon_sym_RBRACE] = ACTIONS(4410),
    [anon_sym_LPAREN2] = ACTIONS(4410),
    [anon_sym_STAR] = ACTIONS(4412),
    [anon_sym_LBRACK] = ACTIONS(4410),
    [anon_sym_RBRACK] = ACTIONS(4410),
    [anon_sym_EQ] = ACTIONS(4412),
    [anon_sym_COLON] = ACTIONS(4410),
    [anon_sym_QMARK] = ACTIONS(4410),
    [anon_sym_STAR_EQ] = ACTIONS(4410),
    [anon_sym_SLASH_EQ] = ACTIONS(4410),
    [anon_sym_PERCENT_EQ] = ACTIONS(4410),
    [anon_sym_PLUS_EQ] = ACTIONS(4410),
    [anon_sym_DASH_EQ] = ACTIONS(4410),
    [anon_sym_LT_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT_GT_EQ] = ACTIONS(4410),
    [anon_sym_AMP_EQ] = ACTIONS(4410),
    [anon_sym_CARET_EQ] = ACTIONS(4410),
    [anon_sym_PIPE_EQ] = ACTIONS(4410),
    [anon_sym_AMP] = ACTIONS(4412),
    [anon_sym_PIPE_PIPE] = ACTIONS(4410),
    [anon_sym_AMP_AMP] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4412),
    [anon_sym_CARET] = ACTIONS(4412),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4410),
    [anon_sym_LT] = ACTIONS(4412),
    [anon_sym_GT] = ACTIONS(4412),
    [anon_sym_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT_EQ] = ACTIONS(4410),
    [anon_sym_LT_LT] = ACTIONS(4412),
    [anon_sym_GT_GT] = ACTIONS(4412),
    [anon_sym_PLUS] = ACTIONS(4412),
    [anon_sym_DASH] = ACTIONS(4412),
    [anon_sym_SLASH] = ACTIONS(4412),
    [anon_sym_PERCENT] = ACTIONS(4412),
    [anon_sym_DASH_DASH] = ACTIONS(4410),
    [anon_sym_PLUS_PLUS] = ACTIONS(4410),
    [anon_sym_DOT] = ACTIONS(4410),
    [anon_sym_DASH_GT] = ACTIONS(4410),
    [sym_comment] = ACTIONS(91),
  },
  [2301] = {
    [sym_field_declaration_list] = STATE(2858),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [sym_comment] = ACTIONS(91),
  },
  [2302] = {
    [anon_sym_COMMA] = ACTIONS(4864),
    [anon_sym_RPAREN] = ACTIONS(4864),
    [anon_sym_SEMI] = ACTIONS(4864),
    [anon_sym_LBRACE] = ACTIONS(4864),
    [anon_sym_RBRACE] = ACTIONS(4864),
    [anon_sym_LPAREN2] = ACTIONS(4864),
    [anon_sym_STAR] = ACTIONS(4866),
    [anon_sym_LBRACK] = ACTIONS(4864),
    [anon_sym_RBRACK] = ACTIONS(4864),
    [anon_sym_EQ] = ACTIONS(4866),
    [anon_sym_COLON] = ACTIONS(4864),
    [anon_sym_QMARK] = ACTIONS(4864),
    [anon_sym_STAR_EQ] = ACTIONS(4864),
    [anon_sym_SLASH_EQ] = ACTIONS(4864),
    [anon_sym_PERCENT_EQ] = ACTIONS(4864),
    [anon_sym_PLUS_EQ] = ACTIONS(4864),
    [anon_sym_DASH_EQ] = ACTIONS(4864),
    [anon_sym_LT_LT_EQ] = ACTIONS(4864),
    [anon_sym_GT_GT_EQ] = ACTIONS(4864),
    [anon_sym_AMP_EQ] = ACTIONS(4864),
    [anon_sym_CARET_EQ] = ACTIONS(4864),
    [anon_sym_PIPE_EQ] = ACTIONS(4864),
    [anon_sym_AMP] = ACTIONS(4866),
    [anon_sym_PIPE_PIPE] = ACTIONS(4864),
    [anon_sym_AMP_AMP] = ACTIONS(4864),
    [anon_sym_PIPE] = ACTIONS(4866),
    [anon_sym_CARET] = ACTIONS(4866),
    [anon_sym_EQ_EQ] = ACTIONS(4864),
    [anon_sym_BANG_EQ] = ACTIONS(4864),
    [anon_sym_LT] = ACTIONS(4866),
    [anon_sym_GT] = ACTIONS(4866),
    [anon_sym_LT_EQ] = ACTIONS(4864),
    [anon_sym_GT_EQ] = ACTIONS(4864),
    [anon_sym_LT_LT] = ACTIONS(4866),
    [anon_sym_GT_GT] = ACTIONS(4866),
    [anon_sym_PLUS] = ACTIONS(4866),
    [anon_sym_DASH] = ACTIONS(4866),
    [anon_sym_SLASH] = ACTIONS(4866),
    [anon_sym_PERCENT] = ACTIONS(4866),
    [anon_sym_DASH_DASH] = ACTIONS(4864),
    [anon_sym_PLUS_PLUS] = ACTIONS(4864),
    [anon_sym_DOT] = ACTIONS(4864),
    [anon_sym_DASH_GT] = ACTIONS(4864),
    [sym_comment] = ACTIONS(91),
  },
  [2303] = {
    [sym_field_declaration_list] = STATE(2859),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [sym_comment] = ACTIONS(91),
  },
  [2304] = {
    [anon_sym_COMMA] = ACTIONS(4868),
    [anon_sym_RPAREN] = ACTIONS(4868),
    [anon_sym_SEMI] = ACTIONS(4868),
    [anon_sym_LBRACE] = ACTIONS(4868),
    [anon_sym_RBRACE] = ACTIONS(4868),
    [anon_sym_LPAREN2] = ACTIONS(4868),
    [anon_sym_STAR] = ACTIONS(4870),
    [anon_sym_LBRACK] = ACTIONS(4868),
    [anon_sym_RBRACK] = ACTIONS(4868),
    [anon_sym_EQ] = ACTIONS(4870),
    [anon_sym_COLON] = ACTIONS(4868),
    [anon_sym_QMARK] = ACTIONS(4868),
    [anon_sym_STAR_EQ] = ACTIONS(4868),
    [anon_sym_SLASH_EQ] = ACTIONS(4868),
    [anon_sym_PERCENT_EQ] = ACTIONS(4868),
    [anon_sym_PLUS_EQ] = ACTIONS(4868),
    [anon_sym_DASH_EQ] = ACTIONS(4868),
    [anon_sym_LT_LT_EQ] = ACTIONS(4868),
    [anon_sym_GT_GT_EQ] = ACTIONS(4868),
    [anon_sym_AMP_EQ] = ACTIONS(4868),
    [anon_sym_CARET_EQ] = ACTIONS(4868),
    [anon_sym_PIPE_EQ] = ACTIONS(4868),
    [anon_sym_AMP] = ACTIONS(4870),
    [anon_sym_PIPE_PIPE] = ACTIONS(4868),
    [anon_sym_AMP_AMP] = ACTIONS(4868),
    [anon_sym_PIPE] = ACTIONS(4870),
    [anon_sym_CARET] = ACTIONS(4870),
    [anon_sym_EQ_EQ] = ACTIONS(4868),
    [anon_sym_BANG_EQ] = ACTIONS(4868),
    [anon_sym_LT] = ACTIONS(4870),
    [anon_sym_GT] = ACTIONS(4870),
    [anon_sym_LT_EQ] = ACTIONS(4868),
    [anon_sym_GT_EQ] = ACTIONS(4868),
    [anon_sym_LT_LT] = ACTIONS(4870),
    [anon_sym_GT_GT] = ACTIONS(4870),
    [anon_sym_PLUS] = ACTIONS(4870),
    [anon_sym_DASH] = ACTIONS(4870),
    [anon_sym_SLASH] = ACTIONS(4870),
    [anon_sym_PERCENT] = ACTIONS(4870),
    [anon_sym_DASH_DASH] = ACTIONS(4868),
    [anon_sym_PLUS_PLUS] = ACTIONS(4868),
    [anon_sym_DOT] = ACTIONS(4868),
    [anon_sym_DASH_GT] = ACTIONS(4868),
    [sym_comment] = ACTIONS(91),
  },
  [2305] = {
    [sym_field_declaration_list] = STATE(2860),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [sym_comment] = ACTIONS(91),
  },
  [2306] = {
    [sym_new_declarator] = STATE(2861),
    [anon_sym_COMMA] = ACTIONS(6396),
    [anon_sym_SEMI] = ACTIONS(6396),
    [anon_sym_LBRACE] = ACTIONS(6396),
    [anon_sym_LPAREN2] = ACTIONS(6396),
    [anon_sym_STAR] = ACTIONS(6398),
    [anon_sym_LBRACK] = ACTIONS(1560),
    [anon_sym_EQ] = ACTIONS(6398),
    [anon_sym_QMARK] = ACTIONS(6396),
    [anon_sym_STAR_EQ] = ACTIONS(6396),
    [anon_sym_SLASH_EQ] = ACTIONS(6396),
    [anon_sym_PERCENT_EQ] = ACTIONS(6396),
    [anon_sym_PLUS_EQ] = ACTIONS(6396),
    [anon_sym_DASH_EQ] = ACTIONS(6396),
    [anon_sym_LT_LT_EQ] = ACTIONS(6396),
    [anon_sym_GT_GT_EQ] = ACTIONS(6396),
    [anon_sym_AMP_EQ] = ACTIONS(6396),
    [anon_sym_CARET_EQ] = ACTIONS(6396),
    [anon_sym_PIPE_EQ] = ACTIONS(6396),
    [anon_sym_AMP] = ACTIONS(6398),
    [anon_sym_PIPE_PIPE] = ACTIONS(6396),
    [anon_sym_AMP_AMP] = ACTIONS(6396),
    [anon_sym_PIPE] = ACTIONS(6398),
    [anon_sym_CARET] = ACTIONS(6398),
    [anon_sym_EQ_EQ] = ACTIONS(6396),
    [anon_sym_BANG_EQ] = ACTIONS(6396),
    [anon_sym_LT] = ACTIONS(6398),
    [anon_sym_GT] = ACTIONS(6398),
    [anon_sym_LT_EQ] = ACTIONS(6396),
    [anon_sym_GT_EQ] = ACTIONS(6396),
    [anon_sym_LT_LT] = ACTIONS(6398),
    [anon_sym_GT_GT] = ACTIONS(6398),
    [anon_sym_PLUS] = ACTIONS(6398),
    [anon_sym_DASH] = ACTIONS(6398),
    [anon_sym_SLASH] = ACTIONS(6398),
    [anon_sym_PERCENT] = ACTIONS(6398),
    [anon_sym_DASH_DASH] = ACTIONS(6396),
    [anon_sym_PLUS_PLUS] = ACTIONS(6396),
    [anon_sym_DOT] = ACTIONS(6396),
    [anon_sym_DASH_GT] = ACTIONS(6396),
    [sym_comment] = ACTIONS(91),
  },
  [2307] = {
    [anon_sym_COMMA] = ACTIONS(6400),
    [anon_sym_RPAREN] = ACTIONS(6400),
    [anon_sym_SEMI] = ACTIONS(6400),
    [anon_sym_RBRACE] = ACTIONS(6400),
    [anon_sym_LPAREN2] = ACTIONS(6400),
    [anon_sym_STAR] = ACTIONS(6402),
    [anon_sym_LBRACK] = ACTIONS(6400),
    [anon_sym_RBRACK] = ACTIONS(6400),
    [anon_sym_EQ] = ACTIONS(6402),
    [anon_sym_COLON] = ACTIONS(6400),
    [anon_sym_QMARK] = ACTIONS(6400),
    [anon_sym_STAR_EQ] = ACTIONS(6400),
    [anon_sym_SLASH_EQ] = ACTIONS(6400),
    [anon_sym_PERCENT_EQ] = ACTIONS(6400),
    [anon_sym_PLUS_EQ] = ACTIONS(6400),
    [anon_sym_DASH_EQ] = ACTIONS(6400),
    [anon_sym_LT_LT_EQ] = ACTIONS(6400),
    [anon_sym_GT_GT_EQ] = ACTIONS(6400),
    [anon_sym_AMP_EQ] = ACTIONS(6400),
    [anon_sym_CARET_EQ] = ACTIONS(6400),
    [anon_sym_PIPE_EQ] = ACTIONS(6400),
    [anon_sym_AMP] = ACTIONS(6402),
    [anon_sym_PIPE_PIPE] = ACTIONS(6400),
    [anon_sym_AMP_AMP] = ACTIONS(6400),
    [anon_sym_PIPE] = ACTIONS(6402),
    [anon_sym_CARET] = ACTIONS(6402),
    [anon_sym_EQ_EQ] = ACTIONS(6400),
    [anon_sym_BANG_EQ] = ACTIONS(6400),
    [anon_sym_LT] = ACTIONS(6402),
    [anon_sym_GT] = ACTIONS(6402),
    [anon_sym_LT_EQ] = ACTIONS(6400),
    [anon_sym_GT_EQ] = ACTIONS(6400),
    [anon_sym_LT_LT] = ACTIONS(6402),
    [anon_sym_GT_GT] = ACTIONS(6402),
    [anon_sym_PLUS] = ACTIONS(6402),
    [anon_sym_DASH] = ACTIONS(6402),
    [anon_sym_SLASH] = ACTIONS(6402),
    [anon_sym_PERCENT] = ACTIONS(6402),
    [anon_sym_DASH_DASH] = ACTIONS(6400),
    [anon_sym_PLUS_PLUS] = ACTIONS(6400),
    [anon_sym_DOT] = ACTIONS(6400),
    [anon_sym_DASH_GT] = ACTIONS(6400),
    [sym_comment] = ACTIONS(91),
  },
  [2308] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(6404),
    [anon_sym_SEMI] = ACTIONS(6404),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(590),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(6406),
    [anon_sym_QMARK] = ACTIONS(6404),
    [anon_sym_STAR_EQ] = ACTIONS(6404),
    [anon_sym_SLASH_EQ] = ACTIONS(6404),
    [anon_sym_PERCENT_EQ] = ACTIONS(6404),
    [anon_sym_PLUS_EQ] = ACTIONS(6404),
    [anon_sym_DASH_EQ] = ACTIONS(6404),
    [anon_sym_LT_LT_EQ] = ACTIONS(6404),
    [anon_sym_GT_GT_EQ] = ACTIONS(6404),
    [anon_sym_AMP_EQ] = ACTIONS(6404),
    [anon_sym_CARET_EQ] = ACTIONS(6404),
    [anon_sym_PIPE_EQ] = ACTIONS(6404),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_PIPE_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(604),
    [anon_sym_PIPE] = ACTIONS(606),
    [anon_sym_CARET] = ACTIONS(608),
    [anon_sym_EQ_EQ] = ACTIONS(610),
    [anon_sym_BANG_EQ] = ACTIONS(610),
    [anon_sym_LT] = ACTIONS(612),
    [anon_sym_GT] = ACTIONS(612),
    [anon_sym_LT_EQ] = ACTIONS(614),
    [anon_sym_GT_EQ] = ACTIONS(614),
    [anon_sym_LT_LT] = ACTIONS(616),
    [anon_sym_GT_GT] = ACTIONS(616),
    [anon_sym_PLUS] = ACTIONS(618),
    [anon_sym_DASH] = ACTIONS(618),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2309] = {
    [anon_sym_COMMA] = ACTIONS(6408),
    [anon_sym_RBRACK] = ACTIONS(6408),
    [sym_comment] = ACTIONS(91),
  },
  [2310] = {
    [anon_sym_LBRACE] = ACTIONS(6410),
    [anon_sym_LPAREN2] = ACTIONS(6410),
    [anon_sym_EQ] = ACTIONS(6410),
    [sym_comment] = ACTIONS(91),
  },
  [2311] = {
    [aux_sym_structured_binding_declarator_repeat1] = STATE(2311),
    [anon_sym_COMMA] = ACTIONS(6412),
    [anon_sym_RBRACK] = ACTIONS(6408),
    [sym_comment] = ACTIONS(91),
  },
  [2312] = {
    [sym_raw_string_literal] = ACTIONS(801),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(803),
    [anon_sym_COMMA] = ACTIONS(2919),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(803),
    [sym_preproc_directive] = ACTIONS(803),
    [anon_sym_SEMI] = ACTIONS(801),
    [anon_sym_typedef] = ACTIONS(803),
    [anon_sym_extern] = ACTIONS(803),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(2919),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(801),
    [anon_sym_LBRACK] = ACTIONS(801),
    [anon_sym_static] = ACTIONS(803),
    [anon_sym_register] = ACTIONS(803),
    [anon_sym_inline] = ACTIONS(803),
    [anon_sym_const] = ACTIONS(803),
    [anon_sym_restrict] = ACTIONS(803),
    [anon_sym_volatile] = ACTIONS(803),
    [anon_sym__Atomic] = ACTIONS(803),
    [anon_sym_mutable] = ACTIONS(803),
    [anon_sym_explicit] = ACTIONS(803),
    [anon_sym_constexpr] = ACTIONS(803),
    [anon_sym_unsigned] = ACTIONS(803),
    [anon_sym_long] = ACTIONS(803),
    [anon_sym_short] = ACTIONS(803),
    [sym_primitive_type] = ACTIONS(803),
    [anon_sym_enum] = ACTIONS(803),
    [anon_sym_struct] = ACTIONS(803),
    [anon_sym_union] = ACTIONS(803),
    [anon_sym_if] = ACTIONS(803),
    [anon_sym_switch] = ACTIONS(803),
    [anon_sym_case] = ACTIONS(803),
    [anon_sym_default] = ACTIONS(803),
    [anon_sym_while] = ACTIONS(803),
    [anon_sym_do] = ACTIONS(803),
    [anon_sym_for] = ACTIONS(803),
    [anon_sym_return] = ACTIONS(803),
    [anon_sym_break] = ACTIONS(803),
    [anon_sym_continue] = ACTIONS(803),
    [anon_sym_goto] = ACTIONS(803),
    [anon_sym_AMP] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_DASH] = ACTIONS(803),
    [anon_sym_DASH_DASH] = ACTIONS(801),
    [anon_sym_PLUS_PLUS] = ACTIONS(801),
    [anon_sym_sizeof] = ACTIONS(803),
    [sym_number_literal] = ACTIONS(801),
    [anon_sym_SQUOTE] = ACTIONS(801),
    [anon_sym_DQUOTE] = ACTIONS(801),
    [sym_true] = ACTIONS(803),
    [sym_false] = ACTIONS(803),
    [sym_null] = ACTIONS(803),
    [sym_identifier] = ACTIONS(803),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(803),
    [sym_auto] = ACTIONS(803),
    [anon_sym_typename] = ACTIONS(803),
    [anon_sym_delete] = ACTIONS(803),
    [anon_sym_try] = ACTIONS(803),
    [anon_sym_new] = ACTIONS(803),
    [anon_sym_COLON_COLON] = ACTIONS(801),
    [sym_nullptr] = ACTIONS(803),
  },
  [2313] = {
    [anon_sym_RPAREN] = ACTIONS(6415),
    [sym_comment] = ACTIONS(91),
  },
  [2314] = {
    [sym_destructor_name] = STATE(315),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(937),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(5056),
    [sym_operator_name] = ACTIONS(554),
  },
  [2315] = {
    [sym_type_qualifier] = STATE(141),
    [sym__type_specifier] = STATE(136),
    [sym_sized_type_specifier] = STATE(136),
    [sym_enum_specifier] = STATE(136),
    [sym_struct_specifier] = STATE(136),
    [sym_union_specifier] = STATE(136),
    [sym__expression] = STATE(137),
    [sym_comma_expression] = STATE(138),
    [sym_conditional_expression] = STATE(137),
    [sym_assignment_expression] = STATE(137),
    [sym_pointer_expression] = STATE(137),
    [sym_logical_expression] = STATE(137),
    [sym_bitwise_expression] = STATE(137),
    [sym_equality_expression] = STATE(137),
    [sym_relational_expression] = STATE(137),
    [sym_shift_expression] = STATE(137),
    [sym_math_expression] = STATE(137),
    [sym_cast_expression] = STATE(137),
    [sym_type_descriptor] = STATE(2863),
    [sym_sizeof_expression] = STATE(137),
    [sym_subscript_expression] = STATE(137),
    [sym_call_expression] = STATE(137),
    [sym_field_expression] = STATE(137),
    [sym_compound_literal_expression] = STATE(137),
    [sym_parenthesized_expression] = STATE(137),
    [sym_char_literal] = STATE(137),
    [sym_concatenated_string] = STATE(137),
    [sym_string_literal] = STATE(140),
    [sym_macro_type_specifier] = STATE(136),
    [sym_class_specifier] = STATE(136),
    [sym_dependent_type] = STATE(136),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(137),
    [sym_new_expression] = STATE(137),
    [sym_delete_expression] = STATE(137),
    [sym_lambda_expression] = STATE(137),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_type_definition_repeat1] = STATE(141),
    [aux_sym_sized_type_specifier_repeat1] = STATE(142),
    [sym_raw_string_literal] = ACTIONS(213),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(219),
    [anon_sym_long] = ACTIONS(219),
    [anon_sym_short] = ACTIONS(219),
    [sym_primitive_type] = ACTIONS(221),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [sym_null] = ACTIONS(241),
    [sym_identifier] = ACTIONS(811),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(221),
    [anon_sym_typename] = ACTIONS(247),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(253),
    [sym_nullptr] = ACTIONS(241),
  },
  [2316] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(1364),
    [anon_sym_SEMI] = ACTIONS(1364),
    [anon_sym_RBRACE] = ACTIONS(1364),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(5060),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1366),
    [anon_sym_QMARK] = ACTIONS(1364),
    [anon_sym_STAR_EQ] = ACTIONS(1364),
    [anon_sym_SLASH_EQ] = ACTIONS(1364),
    [anon_sym_PERCENT_EQ] = ACTIONS(1364),
    [anon_sym_PLUS_EQ] = ACTIONS(1364),
    [anon_sym_DASH_EQ] = ACTIONS(1364),
    [anon_sym_LT_LT_EQ] = ACTIONS(1364),
    [anon_sym_GT_GT_EQ] = ACTIONS(1364),
    [anon_sym_AMP_EQ] = ACTIONS(1364),
    [anon_sym_CARET_EQ] = ACTIONS(1364),
    [anon_sym_PIPE_EQ] = ACTIONS(1364),
    [anon_sym_AMP] = ACTIONS(1366),
    [anon_sym_PIPE_PIPE] = ACTIONS(1364),
    [anon_sym_AMP_AMP] = ACTIONS(1364),
    [anon_sym_PIPE] = ACTIONS(1366),
    [anon_sym_CARET] = ACTIONS(1366),
    [anon_sym_EQ_EQ] = ACTIONS(1364),
    [anon_sym_BANG_EQ] = ACTIONS(1364),
    [anon_sym_LT] = ACTIONS(1366),
    [anon_sym_GT] = ACTIONS(1366),
    [anon_sym_LT_EQ] = ACTIONS(1364),
    [anon_sym_GT_EQ] = ACTIONS(1364),
    [anon_sym_LT_LT] = ACTIONS(5084),
    [anon_sym_GT_GT] = ACTIONS(5084),
    [anon_sym_PLUS] = ACTIONS(5086),
    [anon_sym_DASH] = ACTIONS(5086),
    [anon_sym_SLASH] = ACTIONS(5060),
    [anon_sym_PERCENT] = ACTIONS(5060),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2317] = {
    [sym__expression] = STATE(164),
    [sym_conditional_expression] = STATE(164),
    [sym_assignment_expression] = STATE(164),
    [sym_pointer_expression] = STATE(164),
    [sym_logical_expression] = STATE(164),
    [sym_bitwise_expression] = STATE(164),
    [sym_equality_expression] = STATE(164),
    [sym_relational_expression] = STATE(164),
    [sym_shift_expression] = STATE(164),
    [sym_math_expression] = STATE(164),
    [sym_cast_expression] = STATE(164),
    [sym_sizeof_expression] = STATE(164),
    [sym_subscript_expression] = STATE(164),
    [sym_call_expression] = STATE(164),
    [sym_field_expression] = STATE(164),
    [sym_compound_literal_expression] = STATE(164),
    [sym_parenthesized_expression] = STATE(164),
    [sym_char_literal] = STATE(164),
    [sym_concatenated_string] = STATE(164),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(164),
    [sym_new_expression] = STATE(164),
    [sym_delete_expression] = STATE(164),
    [sym_lambda_expression] = STATE(164),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_lambda_default_capture] = STATE(166),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(267),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(6417),
    [anon_sym_EQ] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(267),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(289),
    [sym_false] = ACTIONS(289),
    [sym_null] = ACTIONS(289),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(289),
  },
  [2318] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(1489),
    [anon_sym_SEMI] = ACTIONS(1489),
    [anon_sym_RBRACE] = ACTIONS(1489),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(5060),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1491),
    [anon_sym_QMARK] = ACTIONS(1489),
    [anon_sym_STAR_EQ] = ACTIONS(1489),
    [anon_sym_SLASH_EQ] = ACTIONS(1489),
    [anon_sym_PERCENT_EQ] = ACTIONS(1489),
    [anon_sym_PLUS_EQ] = ACTIONS(1489),
    [anon_sym_DASH_EQ] = ACTIONS(1489),
    [anon_sym_LT_LT_EQ] = ACTIONS(1489),
    [anon_sym_GT_GT_EQ] = ACTIONS(1489),
    [anon_sym_AMP_EQ] = ACTIONS(1489),
    [anon_sym_CARET_EQ] = ACTIONS(1489),
    [anon_sym_PIPE_EQ] = ACTIONS(1489),
    [anon_sym_AMP] = ACTIONS(5068),
    [anon_sym_PIPE_PIPE] = ACTIONS(5070),
    [anon_sym_AMP_AMP] = ACTIONS(5072),
    [anon_sym_PIPE] = ACTIONS(5074),
    [anon_sym_CARET] = ACTIONS(5076),
    [anon_sym_EQ_EQ] = ACTIONS(5078),
    [anon_sym_BANG_EQ] = ACTIONS(5078),
    [anon_sym_LT] = ACTIONS(5080),
    [anon_sym_GT] = ACTIONS(5080),
    [anon_sym_LT_EQ] = ACTIONS(5082),
    [anon_sym_GT_EQ] = ACTIONS(5082),
    [anon_sym_LT_LT] = ACTIONS(5084),
    [anon_sym_GT_GT] = ACTIONS(5084),
    [anon_sym_PLUS] = ACTIONS(5086),
    [anon_sym_DASH] = ACTIONS(5086),
    [anon_sym_SLASH] = ACTIONS(5060),
    [anon_sym_PERCENT] = ACTIONS(5060),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2319] = {
    [sym__type_specifier] = STATE(871),
    [sym_sized_type_specifier] = STATE(871),
    [sym_enum_specifier] = STATE(871),
    [sym_struct_specifier] = STATE(871),
    [sym_union_specifier] = STATE(871),
    [sym_macro_type_specifier] = STATE(871),
    [sym_class_specifier] = STATE(871),
    [sym_dependent_type] = STATE(871),
    [sym_template_type] = STATE(309),
    [sym_scoped_type_identifier] = STATE(310),
    [sym_scoped_namespace_identifier] = STATE(311),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2322),
    [anon_sym_unsigned] = ACTIONS(5050),
    [anon_sym_long] = ACTIONS(5050),
    [anon_sym_short] = ACTIONS(5050),
    [sym_primitive_type] = ACTIONS(1552),
    [anon_sym_enum] = ACTIONS(536),
    [anon_sym_struct] = ACTIONS(538),
    [anon_sym_union] = ACTIONS(540),
    [sym_identifier] = ACTIONS(542),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(544),
    [sym_auto] = ACTIONS(1552),
    [anon_sym_typename] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [2320] = {
    [sym_argument_list] = STATE(874),
    [sym_initializer_list] = STATE(874),
    [sym_new_declarator] = STATE(875),
    [anon_sym_COMMA] = ACTIONS(1556),
    [anon_sym_SEMI] = ACTIONS(1556),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_RBRACE] = ACTIONS(1556),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1558),
    [anon_sym_LBRACK] = ACTIONS(6419),
    [anon_sym_EQ] = ACTIONS(1558),
    [anon_sym_QMARK] = ACTIONS(1556),
    [anon_sym_STAR_EQ] = ACTIONS(1556),
    [anon_sym_SLASH_EQ] = ACTIONS(1556),
    [anon_sym_PERCENT_EQ] = ACTIONS(1556),
    [anon_sym_PLUS_EQ] = ACTIONS(1556),
    [anon_sym_DASH_EQ] = ACTIONS(1556),
    [anon_sym_LT_LT_EQ] = ACTIONS(1556),
    [anon_sym_GT_GT_EQ] = ACTIONS(1556),
    [anon_sym_AMP_EQ] = ACTIONS(1556),
    [anon_sym_CARET_EQ] = ACTIONS(1556),
    [anon_sym_PIPE_EQ] = ACTIONS(1556),
    [anon_sym_AMP] = ACTIONS(1558),
    [anon_sym_PIPE_PIPE] = ACTIONS(1556),
    [anon_sym_AMP_AMP] = ACTIONS(1556),
    [anon_sym_PIPE] = ACTIONS(1558),
    [anon_sym_CARET] = ACTIONS(1558),
    [anon_sym_EQ_EQ] = ACTIONS(1556),
    [anon_sym_BANG_EQ] = ACTIONS(1556),
    [anon_sym_LT] = ACTIONS(1558),
    [anon_sym_GT] = ACTIONS(1558),
    [anon_sym_LT_EQ] = ACTIONS(1556),
    [anon_sym_GT_EQ] = ACTIONS(1556),
    [anon_sym_LT_LT] = ACTIONS(1558),
    [anon_sym_GT_GT] = ACTIONS(1558),
    [anon_sym_PLUS] = ACTIONS(1558),
    [anon_sym_DASH] = ACTIONS(1558),
    [anon_sym_SLASH] = ACTIONS(1558),
    [anon_sym_PERCENT] = ACTIONS(1558),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DOT] = ACTIONS(1556),
    [anon_sym_DASH_GT] = ACTIONS(1556),
    [sym_comment] = ACTIONS(91),
  },
  [2321] = {
    [sym__type_specifier] = STATE(2866),
    [sym_sized_type_specifier] = STATE(2866),
    [sym_enum_specifier] = STATE(2866),
    [sym_struct_specifier] = STATE(2866),
    [sym_union_specifier] = STATE(2866),
    [sym_macro_type_specifier] = STATE(2866),
    [sym_class_specifier] = STATE(2866),
    [sym_dependent_type] = STATE(2866),
    [sym_template_type] = STATE(309),
    [sym_scoped_type_identifier] = STATE(310),
    [sym_scoped_namespace_identifier] = STATE(311),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2322),
    [anon_sym_unsigned] = ACTIONS(5050),
    [anon_sym_long] = ACTIONS(5050),
    [anon_sym_short] = ACTIONS(5050),
    [sym_primitive_type] = ACTIONS(6421),
    [anon_sym_enum] = ACTIONS(536),
    [anon_sym_struct] = ACTIONS(538),
    [anon_sym_union] = ACTIONS(540),
    [sym_identifier] = ACTIONS(542),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(544),
    [sym_auto] = ACTIONS(6421),
    [anon_sym_typename] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(548),
  },
  [2322] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2867),
    [anon_sym_COMMA] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(653),
    [anon_sym_LBRACE] = ACTIONS(653),
    [anon_sym_RBRACE] = ACTIONS(653),
    [anon_sym_LPAREN2] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_EQ] = ACTIONS(655),
    [anon_sym_unsigned] = ACTIONS(6423),
    [anon_sym_long] = ACTIONS(6423),
    [anon_sym_short] = ACTIONS(6423),
    [sym_primitive_type] = ACTIONS(1571),
    [anon_sym_QMARK] = ACTIONS(653),
    [anon_sym_STAR_EQ] = ACTIONS(653),
    [anon_sym_SLASH_EQ] = ACTIONS(653),
    [anon_sym_PERCENT_EQ] = ACTIONS(653),
    [anon_sym_PLUS_EQ] = ACTIONS(653),
    [anon_sym_DASH_EQ] = ACTIONS(653),
    [anon_sym_LT_LT_EQ] = ACTIONS(653),
    [anon_sym_GT_GT_EQ] = ACTIONS(653),
    [anon_sym_AMP_EQ] = ACTIONS(653),
    [anon_sym_CARET_EQ] = ACTIONS(653),
    [anon_sym_PIPE_EQ] = ACTIONS(653),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_PIPE_PIPE] = ACTIONS(653),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(655),
    [anon_sym_EQ_EQ] = ACTIONS(653),
    [anon_sym_BANG_EQ] = ACTIONS(653),
    [anon_sym_LT] = ACTIONS(655),
    [anon_sym_GT] = ACTIONS(655),
    [anon_sym_LT_EQ] = ACTIONS(653),
    [anon_sym_GT_EQ] = ACTIONS(653),
    [anon_sym_LT_LT] = ACTIONS(655),
    [anon_sym_GT_GT] = ACTIONS(655),
    [anon_sym_PLUS] = ACTIONS(655),
    [anon_sym_DASH] = ACTIONS(655),
    [anon_sym_SLASH] = ACTIONS(655),
    [anon_sym_PERCENT] = ACTIONS(655),
    [anon_sym_DASH_DASH] = ACTIONS(653),
    [anon_sym_PLUS_PLUS] = ACTIONS(653),
    [anon_sym_DOT] = ACTIONS(653),
    [anon_sym_DASH_GT] = ACTIONS(653),
    [sym_identifier] = ACTIONS(1573),
    [sym_comment] = ACTIONS(91),
  },
  [2323] = {
    [sym__expression] = STATE(2869),
    [sym_conditional_expression] = STATE(2869),
    [sym_assignment_expression] = STATE(2869),
    [sym_pointer_expression] = STATE(2869),
    [sym_logical_expression] = STATE(2869),
    [sym_bitwise_expression] = STATE(2869),
    [sym_equality_expression] = STATE(2869),
    [sym_relational_expression] = STATE(2869),
    [sym_shift_expression] = STATE(2869),
    [sym_math_expression] = STATE(2869),
    [sym_cast_expression] = STATE(2869),
    [sym_sizeof_expression] = STATE(2869),
    [sym_subscript_expression] = STATE(2869),
    [sym_call_expression] = STATE(2869),
    [sym_field_expression] = STATE(2869),
    [sym_compound_literal_expression] = STATE(2869),
    [sym_parenthesized_expression] = STATE(2869),
    [sym_char_literal] = STATE(2869),
    [sym_concatenated_string] = STATE(2869),
    [sym_string_literal] = STATE(1632),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2869),
    [sym_new_expression] = STATE(2869),
    [sym_delete_expression] = STATE(2869),
    [sym_lambda_expression] = STATE(2869),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6425),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_LBRACK] = ACTIONS(6427),
    [anon_sym_AMP] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3411),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_sizeof] = ACTIONS(3419),
    [sym_number_literal] = ACTIONS(6425),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6429),
    [sym_false] = ACTIONS(6429),
    [sym_null] = ACTIONS(6429),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_COLON_COLON] = ACTIONS(5036),
    [sym_nullptr] = ACTIONS(6429),
  },
  [2324] = {
    [sym__expression] = STATE(2870),
    [sym_comma_expression] = STATE(937),
    [sym_conditional_expression] = STATE(2870),
    [sym_assignment_expression] = STATE(2870),
    [sym_pointer_expression] = STATE(2870),
    [sym_logical_expression] = STATE(2870),
    [sym_bitwise_expression] = STATE(2870),
    [sym_equality_expression] = STATE(2870),
    [sym_relational_expression] = STATE(2870),
    [sym_shift_expression] = STATE(2870),
    [sym_math_expression] = STATE(2870),
    [sym_cast_expression] = STATE(2870),
    [sym_sizeof_expression] = STATE(2870),
    [sym_subscript_expression] = STATE(2870),
    [sym_call_expression] = STATE(2870),
    [sym_field_expression] = STATE(2870),
    [sym_compound_literal_expression] = STATE(2870),
    [sym_parenthesized_expression] = STATE(2870),
    [sym_initializer_list] = STATE(2127),
    [sym_initializer_pair] = STATE(2127),
    [sym_subscript_designator] = STATE(728),
    [sym_field_designator] = STATE(728),
    [sym_char_literal] = STATE(2870),
    [sym_concatenated_string] = STATE(2870),
    [sym_string_literal] = STATE(1632),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2870),
    [sym_new_expression] = STATE(2870),
    [sym_delete_expression] = STATE(2870),
    [sym_lambda_expression] = STATE(2870),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [aux_sym_initializer_pair_repeat1] = STATE(728),
    [sym_raw_string_literal] = ACTIONS(6431),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_RBRACE] = ACTIONS(4606),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_LBRACK] = ACTIONS(1260),
    [anon_sym_AMP] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3411),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_sizeof] = ACTIONS(3419),
    [anon_sym_DOT] = ACTIONS(1272),
    [sym_number_literal] = ACTIONS(6431),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6433),
    [sym_false] = ACTIONS(6433),
    [sym_null] = ACTIONS(6433),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_COLON_COLON] = ACTIONS(5036),
    [sym_nullptr] = ACTIONS(6433),
  },
  [2325] = {
    [sym__expression] = STATE(938),
    [sym_conditional_expression] = STATE(938),
    [sym_assignment_expression] = STATE(938),
    [sym_pointer_expression] = STATE(938),
    [sym_logical_expression] = STATE(938),
    [sym_bitwise_expression] = STATE(938),
    [sym_equality_expression] = STATE(938),
    [sym_relational_expression] = STATE(938),
    [sym_shift_expression] = STATE(938),
    [sym_math_expression] = STATE(938),
    [sym_cast_expression] = STATE(938),
    [sym_sizeof_expression] = STATE(938),
    [sym_subscript_expression] = STATE(938),
    [sym_call_expression] = STATE(938),
    [sym_field_expression] = STATE(938),
    [sym_compound_literal_expression] = STATE(938),
    [sym_parenthesized_expression] = STATE(938),
    [sym_char_literal] = STATE(938),
    [sym_concatenated_string] = STATE(938),
    [sym_string_literal] = STATE(1632),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(938),
    [sym_new_expression] = STATE(938),
    [sym_delete_expression] = STATE(938),
    [sym_lambda_expression] = STATE(938),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(1701),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3411),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_sizeof] = ACTIONS(3419),
    [sym_number_literal] = ACTIONS(1701),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(1703),
    [sym_false] = ACTIONS(1703),
    [sym_null] = ACTIONS(1703),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_COLON_COLON] = ACTIONS(5036),
    [sym_nullptr] = ACTIONS(1703),
  },
  [2326] = {
    [sym__expression] = STATE(2871),
    [sym_conditional_expression] = STATE(2871),
    [sym_assignment_expression] = STATE(2871),
    [sym_pointer_expression] = STATE(2871),
    [sym_logical_expression] = STATE(2871),
    [sym_bitwise_expression] = STATE(2871),
    [sym_equality_expression] = STATE(2871),
    [sym_relational_expression] = STATE(2871),
    [sym_shift_expression] = STATE(2871),
    [sym_math_expression] = STATE(2871),
    [sym_cast_expression] = STATE(2871),
    [sym_sizeof_expression] = STATE(2871),
    [sym_subscript_expression] = STATE(2871),
    [sym_call_expression] = STATE(2871),
    [sym_field_expression] = STATE(2871),
    [sym_compound_literal_expression] = STATE(2871),
    [sym_parenthesized_expression] = STATE(2871),
    [sym_char_literal] = STATE(2871),
    [sym_concatenated_string] = STATE(2871),
    [sym_string_literal] = STATE(1632),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2871),
    [sym_new_expression] = STATE(2871),
    [sym_delete_expression] = STATE(2871),
    [sym_lambda_expression] = STATE(2871),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6435),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3411),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_sizeof] = ACTIONS(3419),
    [sym_number_literal] = ACTIONS(6435),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6437),
    [sym_false] = ACTIONS(6437),
    [sym_null] = ACTIONS(6437),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_COLON_COLON] = ACTIONS(5036),
    [sym_nullptr] = ACTIONS(6437),
  },
  [2327] = {
    [sym__expression] = STATE(2872),
    [sym_conditional_expression] = STATE(2872),
    [sym_assignment_expression] = STATE(2872),
    [sym_pointer_expression] = STATE(2872),
    [sym_logical_expression] = STATE(2872),
    [sym_bitwise_expression] = STATE(2872),
    [sym_equality_expression] = STATE(2872),
    [sym_relational_expression] = STATE(2872),
    [sym_shift_expression] = STATE(2872),
    [sym_math_expression] = STATE(2872),
    [sym_cast_expression] = STATE(2872),
    [sym_sizeof_expression] = STATE(2872),
    [sym_subscript_expression] = STATE(2872),
    [sym_call_expression] = STATE(2872),
    [sym_field_expression] = STATE(2872),
    [sym_compound_literal_expression] = STATE(2872),
    [sym_parenthesized_expression] = STATE(2872),
    [sym_char_literal] = STATE(2872),
    [sym_concatenated_string] = STATE(2872),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2872),
    [sym_new_expression] = STATE(2872),
    [sym_delete_expression] = STATE(2872),
    [sym_lambda_expression] = STATE(2872),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6439),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(6439),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(6441),
    [sym_false] = ACTIONS(6441),
    [sym_null] = ACTIONS(6441),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(6441),
  },
  [2328] = {
    [sym__expression] = STATE(2873),
    [sym_conditional_expression] = STATE(2873),
    [sym_assignment_expression] = STATE(2873),
    [sym_pointer_expression] = STATE(2873),
    [sym_logical_expression] = STATE(2873),
    [sym_bitwise_expression] = STATE(2873),
    [sym_equality_expression] = STATE(2873),
    [sym_relational_expression] = STATE(2873),
    [sym_shift_expression] = STATE(2873),
    [sym_math_expression] = STATE(2873),
    [sym_cast_expression] = STATE(2873),
    [sym_sizeof_expression] = STATE(2873),
    [sym_subscript_expression] = STATE(2873),
    [sym_call_expression] = STATE(2873),
    [sym_field_expression] = STATE(2873),
    [sym_compound_literal_expression] = STATE(2873),
    [sym_parenthesized_expression] = STATE(2873),
    [sym_char_literal] = STATE(2873),
    [sym_concatenated_string] = STATE(2873),
    [sym_string_literal] = STATE(1632),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2873),
    [sym_new_expression] = STATE(2873),
    [sym_delete_expression] = STATE(2873),
    [sym_lambda_expression] = STATE(2873),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6443),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3411),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_sizeof] = ACTIONS(3419),
    [sym_number_literal] = ACTIONS(6443),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6445),
    [sym_false] = ACTIONS(6445),
    [sym_null] = ACTIONS(6445),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_COLON_COLON] = ACTIONS(5036),
    [sym_nullptr] = ACTIONS(6445),
  },
  [2329] = {
    [sym__expression] = STATE(2874),
    [sym_conditional_expression] = STATE(2874),
    [sym_assignment_expression] = STATE(2874),
    [sym_pointer_expression] = STATE(2874),
    [sym_logical_expression] = STATE(2874),
    [sym_bitwise_expression] = STATE(2874),
    [sym_equality_expression] = STATE(2874),
    [sym_relational_expression] = STATE(2874),
    [sym_shift_expression] = STATE(2874),
    [sym_math_expression] = STATE(2874),
    [sym_cast_expression] = STATE(2874),
    [sym_sizeof_expression] = STATE(2874),
    [sym_subscript_expression] = STATE(2874),
    [sym_call_expression] = STATE(2874),
    [sym_field_expression] = STATE(2874),
    [sym_compound_literal_expression] = STATE(2874),
    [sym_parenthesized_expression] = STATE(2874),
    [sym_char_literal] = STATE(2874),
    [sym_concatenated_string] = STATE(2874),
    [sym_string_literal] = STATE(1632),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2874),
    [sym_new_expression] = STATE(2874),
    [sym_delete_expression] = STATE(2874),
    [sym_lambda_expression] = STATE(2874),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6447),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3411),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_sizeof] = ACTIONS(3419),
    [sym_number_literal] = ACTIONS(6447),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6449),
    [sym_false] = ACTIONS(6449),
    [sym_null] = ACTIONS(6449),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_COLON_COLON] = ACTIONS(5036),
    [sym_nullptr] = ACTIONS(6449),
  },
  [2330] = {
    [sym__expression] = STATE(2875),
    [sym_conditional_expression] = STATE(2875),
    [sym_assignment_expression] = STATE(2875),
    [sym_pointer_expression] = STATE(2875),
    [sym_logical_expression] = STATE(2875),
    [sym_bitwise_expression] = STATE(2875),
    [sym_equality_expression] = STATE(2875),
    [sym_relational_expression] = STATE(2875),
    [sym_shift_expression] = STATE(2875),
    [sym_math_expression] = STATE(2875),
    [sym_cast_expression] = STATE(2875),
    [sym_sizeof_expression] = STATE(2875),
    [sym_subscript_expression] = STATE(2875),
    [sym_call_expression] = STATE(2875),
    [sym_field_expression] = STATE(2875),
    [sym_compound_literal_expression] = STATE(2875),
    [sym_parenthesized_expression] = STATE(2875),
    [sym_char_literal] = STATE(2875),
    [sym_concatenated_string] = STATE(2875),
    [sym_string_literal] = STATE(1632),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2875),
    [sym_new_expression] = STATE(2875),
    [sym_delete_expression] = STATE(2875),
    [sym_lambda_expression] = STATE(2875),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6451),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3411),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_sizeof] = ACTIONS(3419),
    [sym_number_literal] = ACTIONS(6451),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6453),
    [sym_false] = ACTIONS(6453),
    [sym_null] = ACTIONS(6453),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_COLON_COLON] = ACTIONS(5036),
    [sym_nullptr] = ACTIONS(6453),
  },
  [2331] = {
    [sym__expression] = STATE(2876),
    [sym_conditional_expression] = STATE(2876),
    [sym_assignment_expression] = STATE(2876),
    [sym_pointer_expression] = STATE(2876),
    [sym_logical_expression] = STATE(2876),
    [sym_bitwise_expression] = STATE(2876),
    [sym_equality_expression] = STATE(2876),
    [sym_relational_expression] = STATE(2876),
    [sym_shift_expression] = STATE(2876),
    [sym_math_expression] = STATE(2876),
    [sym_cast_expression] = STATE(2876),
    [sym_sizeof_expression] = STATE(2876),
    [sym_subscript_expression] = STATE(2876),
    [sym_call_expression] = STATE(2876),
    [sym_field_expression] = STATE(2876),
    [sym_compound_literal_expression] = STATE(2876),
    [sym_parenthesized_expression] = STATE(2876),
    [sym_char_literal] = STATE(2876),
    [sym_concatenated_string] = STATE(2876),
    [sym_string_literal] = STATE(1632),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2876),
    [sym_new_expression] = STATE(2876),
    [sym_delete_expression] = STATE(2876),
    [sym_lambda_expression] = STATE(2876),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6455),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3411),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_sizeof] = ACTIONS(3419),
    [sym_number_literal] = ACTIONS(6455),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6457),
    [sym_false] = ACTIONS(6457),
    [sym_null] = ACTIONS(6457),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_COLON_COLON] = ACTIONS(5036),
    [sym_nullptr] = ACTIONS(6457),
  },
  [2332] = {
    [sym__expression] = STATE(2877),
    [sym_conditional_expression] = STATE(2877),
    [sym_assignment_expression] = STATE(2877),
    [sym_pointer_expression] = STATE(2877),
    [sym_logical_expression] = STATE(2877),
    [sym_bitwise_expression] = STATE(2877),
    [sym_equality_expression] = STATE(2877),
    [sym_relational_expression] = STATE(2877),
    [sym_shift_expression] = STATE(2877),
    [sym_math_expression] = STATE(2877),
    [sym_cast_expression] = STATE(2877),
    [sym_sizeof_expression] = STATE(2877),
    [sym_subscript_expression] = STATE(2877),
    [sym_call_expression] = STATE(2877),
    [sym_field_expression] = STATE(2877),
    [sym_compound_literal_expression] = STATE(2877),
    [sym_parenthesized_expression] = STATE(2877),
    [sym_char_literal] = STATE(2877),
    [sym_concatenated_string] = STATE(2877),
    [sym_string_literal] = STATE(1632),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2877),
    [sym_new_expression] = STATE(2877),
    [sym_delete_expression] = STATE(2877),
    [sym_lambda_expression] = STATE(2877),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6459),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3411),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_sizeof] = ACTIONS(3419),
    [sym_number_literal] = ACTIONS(6459),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6461),
    [sym_false] = ACTIONS(6461),
    [sym_null] = ACTIONS(6461),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_COLON_COLON] = ACTIONS(5036),
    [sym_nullptr] = ACTIONS(6461),
  },
  [2333] = {
    [sym__expression] = STATE(2878),
    [sym_conditional_expression] = STATE(2878),
    [sym_assignment_expression] = STATE(2878),
    [sym_pointer_expression] = STATE(2878),
    [sym_logical_expression] = STATE(2878),
    [sym_bitwise_expression] = STATE(2878),
    [sym_equality_expression] = STATE(2878),
    [sym_relational_expression] = STATE(2878),
    [sym_shift_expression] = STATE(2878),
    [sym_math_expression] = STATE(2878),
    [sym_cast_expression] = STATE(2878),
    [sym_sizeof_expression] = STATE(2878),
    [sym_subscript_expression] = STATE(2878),
    [sym_call_expression] = STATE(2878),
    [sym_field_expression] = STATE(2878),
    [sym_compound_literal_expression] = STATE(2878),
    [sym_parenthesized_expression] = STATE(2878),
    [sym_char_literal] = STATE(2878),
    [sym_concatenated_string] = STATE(2878),
    [sym_string_literal] = STATE(1632),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2878),
    [sym_new_expression] = STATE(2878),
    [sym_delete_expression] = STATE(2878),
    [sym_lambda_expression] = STATE(2878),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6463),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3411),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_sizeof] = ACTIONS(3419),
    [sym_number_literal] = ACTIONS(6463),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6465),
    [sym_false] = ACTIONS(6465),
    [sym_null] = ACTIONS(6465),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_COLON_COLON] = ACTIONS(5036),
    [sym_nullptr] = ACTIONS(6465),
  },
  [2334] = {
    [sym__expression] = STATE(2879),
    [sym_conditional_expression] = STATE(2879),
    [sym_assignment_expression] = STATE(2879),
    [sym_pointer_expression] = STATE(2879),
    [sym_logical_expression] = STATE(2879),
    [sym_bitwise_expression] = STATE(2879),
    [sym_equality_expression] = STATE(2879),
    [sym_relational_expression] = STATE(2879),
    [sym_shift_expression] = STATE(2879),
    [sym_math_expression] = STATE(2879),
    [sym_cast_expression] = STATE(2879),
    [sym_sizeof_expression] = STATE(2879),
    [sym_subscript_expression] = STATE(2879),
    [sym_call_expression] = STATE(2879),
    [sym_field_expression] = STATE(2879),
    [sym_compound_literal_expression] = STATE(2879),
    [sym_parenthesized_expression] = STATE(2879),
    [sym_char_literal] = STATE(2879),
    [sym_concatenated_string] = STATE(2879),
    [sym_string_literal] = STATE(1632),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2879),
    [sym_new_expression] = STATE(2879),
    [sym_delete_expression] = STATE(2879),
    [sym_lambda_expression] = STATE(2879),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6467),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3411),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_sizeof] = ACTIONS(3419),
    [sym_number_literal] = ACTIONS(6467),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6469),
    [sym_false] = ACTIONS(6469),
    [sym_null] = ACTIONS(6469),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_COLON_COLON] = ACTIONS(5036),
    [sym_nullptr] = ACTIONS(6469),
  },
  [2335] = {
    [sym__expression] = STATE(2880),
    [sym_conditional_expression] = STATE(2880),
    [sym_assignment_expression] = STATE(2880),
    [sym_pointer_expression] = STATE(2880),
    [sym_logical_expression] = STATE(2880),
    [sym_bitwise_expression] = STATE(2880),
    [sym_equality_expression] = STATE(2880),
    [sym_relational_expression] = STATE(2880),
    [sym_shift_expression] = STATE(2880),
    [sym_math_expression] = STATE(2880),
    [sym_cast_expression] = STATE(2880),
    [sym_sizeof_expression] = STATE(2880),
    [sym_subscript_expression] = STATE(2880),
    [sym_call_expression] = STATE(2880),
    [sym_field_expression] = STATE(2880),
    [sym_compound_literal_expression] = STATE(2880),
    [sym_parenthesized_expression] = STATE(2880),
    [sym_char_literal] = STATE(2880),
    [sym_concatenated_string] = STATE(2880),
    [sym_string_literal] = STATE(1632),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2880),
    [sym_new_expression] = STATE(2880),
    [sym_delete_expression] = STATE(2880),
    [sym_lambda_expression] = STATE(2880),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6471),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3411),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_sizeof] = ACTIONS(3419),
    [sym_number_literal] = ACTIONS(6471),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6473),
    [sym_false] = ACTIONS(6473),
    [sym_null] = ACTIONS(6473),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_COLON_COLON] = ACTIONS(5036),
    [sym_nullptr] = ACTIONS(6473),
  },
  [2336] = {
    [sym__expression] = STATE(2881),
    [sym_conditional_expression] = STATE(2881),
    [sym_assignment_expression] = STATE(2881),
    [sym_pointer_expression] = STATE(2881),
    [sym_logical_expression] = STATE(2881),
    [sym_bitwise_expression] = STATE(2881),
    [sym_equality_expression] = STATE(2881),
    [sym_relational_expression] = STATE(2881),
    [sym_shift_expression] = STATE(2881),
    [sym_math_expression] = STATE(2881),
    [sym_cast_expression] = STATE(2881),
    [sym_sizeof_expression] = STATE(2881),
    [sym_subscript_expression] = STATE(2881),
    [sym_call_expression] = STATE(2881),
    [sym_field_expression] = STATE(2881),
    [sym_compound_literal_expression] = STATE(2881),
    [sym_parenthesized_expression] = STATE(2881),
    [sym_char_literal] = STATE(2881),
    [sym_concatenated_string] = STATE(2881),
    [sym_string_literal] = STATE(1632),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2881),
    [sym_new_expression] = STATE(2881),
    [sym_delete_expression] = STATE(2881),
    [sym_lambda_expression] = STATE(2881),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6475),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3411),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_sizeof] = ACTIONS(3419),
    [sym_number_literal] = ACTIONS(6475),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6477),
    [sym_false] = ACTIONS(6477),
    [sym_null] = ACTIONS(6477),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_COLON_COLON] = ACTIONS(5036),
    [sym_nullptr] = ACTIONS(6477),
  },
  [2337] = {
    [sym_string_literal] = STATE(2882),
    [aux_sym_concatenated_string_repeat1] = STATE(2882),
    [anon_sym_COMMA] = ACTIONS(1761),
    [anon_sym_SEMI] = ACTIONS(1761),
    [anon_sym_RBRACE] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_EQ] = ACTIONS(1763),
    [anon_sym_QMARK] = ACTIONS(1761),
    [anon_sym_STAR_EQ] = ACTIONS(1761),
    [anon_sym_SLASH_EQ] = ACTIONS(1761),
    [anon_sym_PERCENT_EQ] = ACTIONS(1761),
    [anon_sym_PLUS_EQ] = ACTIONS(1761),
    [anon_sym_DASH_EQ] = ACTIONS(1761),
    [anon_sym_LT_LT_EQ] = ACTIONS(1761),
    [anon_sym_GT_GT_EQ] = ACTIONS(1761),
    [anon_sym_AMP_EQ] = ACTIONS(1761),
    [anon_sym_CARET_EQ] = ACTIONS(1761),
    [anon_sym_PIPE_EQ] = ACTIONS(1761),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_PIPE_PIPE] = ACTIONS(1761),
    [anon_sym_AMP_AMP] = ACTIONS(1761),
    [anon_sym_PIPE] = ACTIONS(1763),
    [anon_sym_CARET] = ACTIONS(1763),
    [anon_sym_EQ_EQ] = ACTIONS(1761),
    [anon_sym_BANG_EQ] = ACTIONS(1761),
    [anon_sym_LT] = ACTIONS(1763),
    [anon_sym_GT] = ACTIONS(1763),
    [anon_sym_LT_EQ] = ACTIONS(1761),
    [anon_sym_GT_EQ] = ACTIONS(1761),
    [anon_sym_LT_LT] = ACTIONS(1763),
    [anon_sym_GT_GT] = ACTIONS(1763),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_SLASH] = ACTIONS(1763),
    [anon_sym_PERCENT] = ACTIONS(1763),
    [anon_sym_DASH_DASH] = ACTIONS(1761),
    [anon_sym_PLUS_PLUS] = ACTIONS(1761),
    [anon_sym_DOT] = ACTIONS(1761),
    [anon_sym_DASH_GT] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(91),
  },
  [2338] = {
    [sym_destructor_name] = STATE(789),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(6479),
    [sym_comment] = ACTIONS(91),
    [sym_operator_name] = ACTIONS(1418),
  },
  [2339] = {
    [anon_sym_COMMA] = ACTIONS(1426),
    [anon_sym_RPAREN] = ACTIONS(1426),
    [anon_sym_extern] = ACTIONS(1429),
    [anon_sym_LBRACE] = ACTIONS(1431),
    [anon_sym_LPAREN2] = ACTIONS(1426),
    [anon_sym_STAR] = ACTIONS(1433),
    [anon_sym_LBRACK] = ACTIONS(1426),
    [anon_sym_EQ] = ACTIONS(1436),
    [anon_sym_static] = ACTIONS(1429),
    [anon_sym_register] = ACTIONS(1429),
    [anon_sym_inline] = ACTIONS(1429),
    [anon_sym_const] = ACTIONS(1429),
    [anon_sym_restrict] = ACTIONS(1429),
    [anon_sym_volatile] = ACTIONS(1429),
    [anon_sym__Atomic] = ACTIONS(1429),
    [anon_sym_mutable] = ACTIONS(1429),
    [anon_sym_explicit] = ACTIONS(1429),
    [anon_sym_constexpr] = ACTIONS(1429),
    [anon_sym_QMARK] = ACTIONS(1424),
    [anon_sym_STAR_EQ] = ACTIONS(1424),
    [anon_sym_SLASH_EQ] = ACTIONS(1424),
    [anon_sym_PERCENT_EQ] = ACTIONS(1424),
    [anon_sym_PLUS_EQ] = ACTIONS(1424),
    [anon_sym_DASH_EQ] = ACTIONS(1424),
    [anon_sym_LT_LT_EQ] = ACTIONS(1424),
    [anon_sym_GT_GT_EQ] = ACTIONS(1424),
    [anon_sym_AMP_EQ] = ACTIONS(1424),
    [anon_sym_CARET_EQ] = ACTIONS(1424),
    [anon_sym_PIPE_EQ] = ACTIONS(1424),
    [anon_sym_AMP] = ACTIONS(1433),
    [anon_sym_PIPE_PIPE] = ACTIONS(1424),
    [anon_sym_AMP_AMP] = ACTIONS(1426),
    [anon_sym_PIPE] = ACTIONS(1436),
    [anon_sym_CARET] = ACTIONS(1436),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_EQ_EQ] = ACTIONS(1424),
    [anon_sym_BANG_EQ] = ACTIONS(1424),
    [anon_sym_LT] = ACTIONS(1436),
    [anon_sym_GT] = ACTIONS(1436),
    [anon_sym_LT_EQ] = ACTIONS(1424),
    [anon_sym_GT_EQ] = ACTIONS(1424),
    [anon_sym_LT_LT] = ACTIONS(1436),
    [anon_sym_GT_GT] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1436),
    [anon_sym_DASH] = ACTIONS(1436),
    [anon_sym_SLASH] = ACTIONS(1436),
    [anon_sym_PERCENT] = ACTIONS(1436),
    [anon_sym_DASH_DASH] = ACTIONS(1424),
    [anon_sym_PLUS_PLUS] = ACTIONS(1424),
    [anon_sym_DOT] = ACTIONS(1424),
    [anon_sym_DASH_GT] = ACTIONS(1424),
    [sym_identifier] = ACTIONS(1429),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1431),
    [sym_operator_name] = ACTIONS(1431),
  },
  [2340] = {
    [anon_sym_COMMA] = ACTIONS(1577),
    [anon_sym_RPAREN] = ACTIONS(1577),
    [anon_sym_extern] = ACTIONS(1580),
    [anon_sym_LBRACE] = ACTIONS(1582),
    [anon_sym_LPAREN2] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1584),
    [anon_sym_LBRACK] = ACTIONS(1577),
    [anon_sym_EQ] = ACTIONS(1587),
    [anon_sym_static] = ACTIONS(1580),
    [anon_sym_register] = ACTIONS(1580),
    [anon_sym_inline] = ACTIONS(1580),
    [anon_sym_const] = ACTIONS(1580),
    [anon_sym_restrict] = ACTIONS(1580),
    [anon_sym_volatile] = ACTIONS(1580),
    [anon_sym__Atomic] = ACTIONS(1580),
    [anon_sym_mutable] = ACTIONS(1580),
    [anon_sym_explicit] = ACTIONS(1580),
    [anon_sym_constexpr] = ACTIONS(1580),
    [anon_sym_QMARK] = ACTIONS(1575),
    [anon_sym_STAR_EQ] = ACTIONS(1575),
    [anon_sym_SLASH_EQ] = ACTIONS(1575),
    [anon_sym_PERCENT_EQ] = ACTIONS(1575),
    [anon_sym_PLUS_EQ] = ACTIONS(1575),
    [anon_sym_DASH_EQ] = ACTIONS(1575),
    [anon_sym_LT_LT_EQ] = ACTIONS(1575),
    [anon_sym_GT_GT_EQ] = ACTIONS(1575),
    [anon_sym_AMP_EQ] = ACTIONS(1575),
    [anon_sym_CARET_EQ] = ACTIONS(1575),
    [anon_sym_PIPE_EQ] = ACTIONS(1575),
    [anon_sym_AMP] = ACTIONS(1584),
    [anon_sym_PIPE_PIPE] = ACTIONS(1575),
    [anon_sym_AMP_AMP] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(1587),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1582),
    [anon_sym_EQ_EQ] = ACTIONS(1575),
    [anon_sym_BANG_EQ] = ACTIONS(1575),
    [anon_sym_LT] = ACTIONS(1584),
    [anon_sym_GT] = ACTIONS(1587),
    [anon_sym_LT_EQ] = ACTIONS(1575),
    [anon_sym_GT_EQ] = ACTIONS(1575),
    [anon_sym_LT_LT] = ACTIONS(1587),
    [anon_sym_GT_GT] = ACTIONS(1587),
    [anon_sym_PLUS] = ACTIONS(1587),
    [anon_sym_DASH] = ACTIONS(1587),
    [anon_sym_SLASH] = ACTIONS(1587),
    [anon_sym_PERCENT] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1575),
    [anon_sym_PLUS_PLUS] = ACTIONS(1575),
    [anon_sym_DOT] = ACTIONS(1575),
    [anon_sym_DASH_GT] = ACTIONS(1575),
    [sym_identifier] = ACTIONS(1580),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [sym_operator_name] = ACTIONS(1582),
  },
  [2341] = {
    [sym_destructor_name] = STATE(958),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(6481),
    [sym_comment] = ACTIONS(91),
    [sym_operator_name] = ACTIONS(1767),
  },
  [2342] = {
    [sym_field_declaration_list] = STATE(175),
    [sym_virtual_specifier] = STATE(176),
    [sym_base_class_clause] = STATE(177),
    [sym_template_type] = STATE(2886),
    [sym_scoped_type_identifier] = STATE(2887),
    [sym_scoped_namespace_identifier] = STATE(83),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(6483),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [2343] = {
    [sym_field_declaration_list] = STATE(182),
    [sym_virtual_specifier] = STATE(183),
    [sym_base_class_clause] = STATE(184),
    [sym_template_type] = STATE(2889),
    [sym_scoped_type_identifier] = STATE(2890),
    [sym_scoped_namespace_identifier] = STATE(83),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(6485),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [2344] = {
    [sym_field_declaration_list] = STATE(265),
    [sym_virtual_specifier] = STATE(266),
    [sym_base_class_clause] = STATE(267),
    [sym_template_type] = STATE(2892),
    [sym_scoped_type_identifier] = STATE(2893),
    [sym_scoped_namespace_identifier] = STATE(83),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(6487),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [2345] = {
    [sym__type_specifier] = STATE(271),
    [sym_sized_type_specifier] = STATE(271),
    [sym_enum_specifier] = STATE(271),
    [sym_struct_specifier] = STATE(271),
    [sym_union_specifier] = STATE(271),
    [sym_macro_type_specifier] = STATE(271),
    [sym_class_specifier] = STATE(271),
    [sym_dependent_type] = STATE(271),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2347),
    [anon_sym_unsigned] = ACTIONS(5099),
    [anon_sym_long] = ACTIONS(5099),
    [anon_sym_short] = ACTIONS(5099),
    [sym_primitive_type] = ACTIONS(490),
    [anon_sym_enum] = ACTIONS(3675),
    [anon_sym_struct] = ACTIONS(5103),
    [anon_sym_union] = ACTIONS(5105),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5107),
    [sym_auto] = ACTIONS(490),
    [anon_sym_typename] = ACTIONS(5109),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [2346] = {
    [sym__abstract_declarator] = STATE(2896),
    [sym_abstract_pointer_declarator] = STATE(2896),
    [sym_abstract_function_declarator] = STATE(2896),
    [sym_abstract_array_declarator] = STATE(2896),
    [sym_parameter_list] = STATE(2897),
    [sym_abstract_reference_declarator] = STATE(2896),
    [anon_sym_COMMA] = ACTIONS(5222),
    [anon_sym_SEMI] = ACTIONS(5222),
    [anon_sym_LBRACE] = ACTIONS(5222),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(6489),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_EQ] = ACTIONS(5222),
    [anon_sym_const] = ACTIONS(5226),
    [anon_sym_restrict] = ACTIONS(5222),
    [anon_sym_volatile] = ACTIONS(5222),
    [anon_sym__Atomic] = ACTIONS(5222),
    [anon_sym_mutable] = ACTIONS(5222),
    [anon_sym_explicit] = ACTIONS(5222),
    [anon_sym_constexpr] = ACTIONS(5222),
    [anon_sym_AMP] = ACTIONS(6491),
    [anon_sym_AMP_AMP] = ACTIONS(6493),
    [anon_sym_DASH_GT] = ACTIONS(5222),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5222),
    [anon_sym_override] = ACTIONS(5222),
    [sym_noexcept] = ACTIONS(5222),
  },
  [2347] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2898),
    [anon_sym_COMMA] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(653),
    [anon_sym_LBRACE] = ACTIONS(653),
    [anon_sym_LPAREN2] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_EQ] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(655),
    [anon_sym_restrict] = ACTIONS(655),
    [anon_sym_volatile] = ACTIONS(655),
    [anon_sym__Atomic] = ACTIONS(655),
    [anon_sym_mutable] = ACTIONS(655),
    [anon_sym_explicit] = ACTIONS(655),
    [anon_sym_constexpr] = ACTIONS(655),
    [anon_sym_unsigned] = ACTIONS(6495),
    [anon_sym_long] = ACTIONS(6495),
    [anon_sym_short] = ACTIONS(6495),
    [sym_primitive_type] = ACTIONS(659),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [anon_sym_DASH_GT] = ACTIONS(653),
    [sym_identifier] = ACTIONS(933),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(655),
    [anon_sym_override] = ACTIONS(655),
    [sym_noexcept] = ACTIONS(655),
  },
  [2348] = {
    [sym_type_qualifier] = STATE(2348),
    [sym_virtual_specifier] = STATE(2348),
    [sym_trailing_return_type] = STATE(2348),
    [aux_sym_function_declarator_repeat1] = STATE(2348),
    [anon_sym_COMMA] = ACTIONS(5236),
    [anon_sym_SEMI] = ACTIONS(5236),
    [anon_sym_LBRACE] = ACTIONS(5236),
    [anon_sym_LPAREN2] = ACTIONS(5236),
    [anon_sym_LBRACK] = ACTIONS(5236),
    [anon_sym_EQ] = ACTIONS(5236),
    [anon_sym_const] = ACTIONS(5877),
    [anon_sym_restrict] = ACTIONS(5880),
    [anon_sym_volatile] = ACTIONS(5880),
    [anon_sym__Atomic] = ACTIONS(5880),
    [anon_sym_mutable] = ACTIONS(5880),
    [anon_sym_explicit] = ACTIONS(5880),
    [anon_sym_constexpr] = ACTIONS(5880),
    [anon_sym_DASH_GT] = ACTIONS(6497),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5247),
    [anon_sym_override] = ACTIONS(5247),
    [sym_noexcept] = ACTIONS(6500),
  },
  [2349] = {
    [sym_raw_string_literal] = ACTIONS(6503),
    [ts_builtin_sym_end] = ACTIONS(6503),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6505),
    [sym_preproc_directive] = ACTIONS(6505),
    [anon_sym_SEMI] = ACTIONS(6503),
    [anon_sym_typedef] = ACTIONS(6505),
    [anon_sym_extern] = ACTIONS(6505),
    [anon_sym_LBRACE] = ACTIONS(6503),
    [anon_sym_RBRACE] = ACTIONS(6503),
    [anon_sym_LPAREN2] = ACTIONS(6503),
    [anon_sym_STAR] = ACTIONS(6503),
    [anon_sym_LBRACK] = ACTIONS(6503),
    [anon_sym_static] = ACTIONS(6505),
    [anon_sym_register] = ACTIONS(6505),
    [anon_sym_inline] = ACTIONS(6505),
    [anon_sym_const] = ACTIONS(6505),
    [anon_sym_restrict] = ACTIONS(6505),
    [anon_sym_volatile] = ACTIONS(6505),
    [anon_sym__Atomic] = ACTIONS(6505),
    [anon_sym_mutable] = ACTIONS(6505),
    [anon_sym_explicit] = ACTIONS(6505),
    [anon_sym_constexpr] = ACTIONS(6505),
    [anon_sym_unsigned] = ACTIONS(6505),
    [anon_sym_long] = ACTIONS(6505),
    [anon_sym_short] = ACTIONS(6505),
    [sym_primitive_type] = ACTIONS(6505),
    [anon_sym_enum] = ACTIONS(6505),
    [anon_sym_struct] = ACTIONS(6505),
    [anon_sym_union] = ACTIONS(6505),
    [anon_sym_if] = ACTIONS(6505),
    [anon_sym_switch] = ACTIONS(6505),
    [anon_sym_case] = ACTIONS(6505),
    [anon_sym_default] = ACTIONS(6505),
    [anon_sym_while] = ACTIONS(6505),
    [anon_sym_do] = ACTIONS(6505),
    [anon_sym_for] = ACTIONS(6505),
    [anon_sym_return] = ACTIONS(6505),
    [anon_sym_break] = ACTIONS(6505),
    [anon_sym_continue] = ACTIONS(6505),
    [anon_sym_goto] = ACTIONS(6505),
    [anon_sym_AMP] = ACTIONS(6505),
    [anon_sym_AMP_AMP] = ACTIONS(6503),
    [anon_sym_BANG] = ACTIONS(6503),
    [anon_sym_TILDE] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6505),
    [anon_sym_DASH] = ACTIONS(6505),
    [anon_sym_DASH_DASH] = ACTIONS(6503),
    [anon_sym_PLUS_PLUS] = ACTIONS(6503),
    [anon_sym_sizeof] = ACTIONS(6505),
    [sym_number_literal] = ACTIONS(6503),
    [anon_sym_SQUOTE] = ACTIONS(6503),
    [anon_sym_DQUOTE] = ACTIONS(6503),
    [sym_true] = ACTIONS(6505),
    [sym_false] = ACTIONS(6505),
    [sym_null] = ACTIONS(6505),
    [sym_identifier] = ACTIONS(6505),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6505),
    [sym_auto] = ACTIONS(6505),
    [anon_sym_typename] = ACTIONS(6505),
    [anon_sym_template] = ACTIONS(6505),
    [anon_sym_delete] = ACTIONS(6505),
    [anon_sym_namespace] = ACTIONS(6505),
    [anon_sym_using] = ACTIONS(6505),
    [anon_sym_try] = ACTIONS(6505),
    [anon_sym_new] = ACTIONS(6505),
    [anon_sym_COLON_COLON] = ACTIONS(6503),
    [sym_operator_name] = ACTIONS(6503),
    [sym_nullptr] = ACTIONS(6505),
  },
  [2350] = {
    [anon_sym_COMMA] = ACTIONS(6507),
    [anon_sym_RPAREN] = ACTIONS(6507),
    [sym_comment] = ACTIONS(91),
  },
  [2351] = {
    [anon_sym_COMMA] = ACTIONS(6509),
    [anon_sym_RPAREN] = ACTIONS(6509),
    [anon_sym_SEMI] = ACTIONS(6509),
    [anon_sym_LBRACE] = ACTIONS(6509),
    [anon_sym_LPAREN2] = ACTIONS(6509),
    [anon_sym_LBRACK] = ACTIONS(6509),
    [anon_sym_EQ] = ACTIONS(6509),
    [anon_sym_const] = ACTIONS(6511),
    [anon_sym_restrict] = ACTIONS(6509),
    [anon_sym_volatile] = ACTIONS(6509),
    [anon_sym__Atomic] = ACTIONS(6509),
    [anon_sym_mutable] = ACTIONS(6509),
    [anon_sym_explicit] = ACTIONS(6509),
    [anon_sym_constexpr] = ACTIONS(6509),
    [anon_sym_COLON] = ACTIONS(6509),
    [anon_sym_DASH_GT] = ACTIONS(6509),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(6509),
    [anon_sym_override] = ACTIONS(6509),
    [anon_sym_GT2] = ACTIONS(6509),
    [sym_noexcept] = ACTIONS(6509),
  },
  [2352] = {
    [aux_sym_parameter_list_repeat1] = STATE(2352),
    [anon_sym_COMMA] = ACTIONS(6513),
    [anon_sym_RPAREN] = ACTIONS(6507),
    [sym_comment] = ACTIONS(91),
  },
  [2353] = {
    [sym_parameter_list] = STATE(2359),
    [anon_sym_COMMA] = ACTIONS(2435),
    [anon_sym_RPAREN] = ACTIONS(2435),
    [anon_sym_LBRACE] = ACTIONS(2435),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(574),
    [anon_sym_EQ] = ACTIONS(2435),
    [sym_comment] = ACTIONS(91),
  },
  [2354] = {
    [sym_parameter_list] = STATE(2360),
    [anon_sym_COMMA] = ACTIONS(4157),
    [anon_sym_RPAREN] = ACTIONS(4157),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [sym_comment] = ACTIONS(91),
  },
  [2355] = {
    [sym__declarator] = STATE(2899),
    [sym__abstract_declarator] = STATE(2900),
    [sym_pointer_declarator] = STATE(2899),
    [sym_abstract_pointer_declarator] = STATE(2900),
    [sym_function_declarator] = STATE(2899),
    [sym_abstract_function_declarator] = STATE(2900),
    [sym_array_declarator] = STATE(2899),
    [sym_abstract_array_declarator] = STATE(2900),
    [sym_type_qualifier] = STATE(2901),
    [sym_parameter_list] = STATE(1654),
    [sym_reference_declarator] = STATE(2899),
    [sym_abstract_reference_declarator] = STATE(2900),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(2899),
    [sym_destructor_name] = STATE(2899),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [aux_sym_type_definition_repeat1] = STATE(2901),
    [anon_sym_COMMA] = ACTIONS(4157),
    [anon_sym_RPAREN] = ACTIONS(4157),
    [anon_sym_LPAREN2] = ACTIONS(3249),
    [anon_sym_STAR] = ACTIONS(3465),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(3467),
    [anon_sym_AMP_AMP] = ACTIONS(3469),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(568),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(6516),
  },
  [2356] = {
    [sym_parameter_list] = STATE(2359),
    [anon_sym_COMMA] = ACTIONS(2439),
    [anon_sym_RPAREN] = ACTIONS(2439),
    [anon_sym_LBRACE] = ACTIONS(2439),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(574),
    [anon_sym_EQ] = ACTIONS(2439),
    [sym_comment] = ACTIONS(91),
  },
  [2357] = {
    [sym_parameter_list] = STATE(2360),
    [anon_sym_COMMA] = ACTIONS(4159),
    [anon_sym_RPAREN] = ACTIONS(4159),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [sym_comment] = ACTIONS(91),
  },
  [2358] = {
    [sym__expression] = STATE(2902),
    [sym_conditional_expression] = STATE(2902),
    [sym_assignment_expression] = STATE(2902),
    [sym_pointer_expression] = STATE(2902),
    [sym_logical_expression] = STATE(2902),
    [sym_bitwise_expression] = STATE(2902),
    [sym_equality_expression] = STATE(2902),
    [sym_relational_expression] = STATE(2902),
    [sym_shift_expression] = STATE(2902),
    [sym_math_expression] = STATE(2902),
    [sym_cast_expression] = STATE(2902),
    [sym_sizeof_expression] = STATE(2902),
    [sym_subscript_expression] = STATE(2902),
    [sym_call_expression] = STATE(2902),
    [sym_field_expression] = STATE(2902),
    [sym_compound_literal_expression] = STATE(2902),
    [sym_parenthesized_expression] = STATE(2902),
    [sym_initializer_list] = STATE(1639),
    [sym_char_literal] = STATE(2902),
    [sym_concatenated_string] = STATE(2902),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2902),
    [sym_new_expression] = STATE(2902),
    [sym_delete_expression] = STATE(2902),
    [sym_lambda_expression] = STATE(2902),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6518),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(6518),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6520),
    [sym_false] = ACTIONS(6520),
    [sym_null] = ACTIONS(6520),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(6520),
  },
  [2359] = {
    [sym_type_qualifier] = STATE(2904),
    [sym_virtual_specifier] = STATE(2904),
    [sym_trailing_return_type] = STATE(2904),
    [aux_sym_function_declarator_repeat1] = STATE(2904),
    [anon_sym_COMMA] = ACTIONS(1665),
    [anon_sym_RPAREN] = ACTIONS(1665),
    [anon_sym_LBRACE] = ACTIONS(1665),
    [anon_sym_LPAREN2] = ACTIONS(1665),
    [anon_sym_LBRACK] = ACTIONS(1665),
    [anon_sym_EQ] = ACTIONS(1665),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(6522),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [sym_noexcept] = ACTIONS(6524),
  },
  [2360] = {
    [sym_type_qualifier] = STATE(2905),
    [sym_trailing_return_type] = STATE(1720),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2905),
    [anon_sym_COMMA] = ACTIONS(3663),
    [anon_sym_RPAREN] = ACTIONS(3663),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(5140),
    [sym_comment] = ACTIONS(91),
    [sym_noexcept] = ACTIONS(6526),
  },
  [2361] = {
    [sym__type_specifier] = STATE(2907),
    [sym_sized_type_specifier] = STATE(2907),
    [sym_enum_specifier] = STATE(2907),
    [sym_struct_specifier] = STATE(2907),
    [sym_union_specifier] = STATE(2907),
    [sym_macro_type_specifier] = STATE(2907),
    [sym_class_specifier] = STATE(2907),
    [sym_dependent_type] = STATE(2907),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2908),
    [anon_sym_unsigned] = ACTIONS(6528),
    [anon_sym_long] = ACTIONS(6528),
    [anon_sym_short] = ACTIONS(6528),
    [sym_primitive_type] = ACTIONS(6530),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(6530),
    [anon_sym_typename] = ACTIONS(6532),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [2362] = {
    [sym_type_qualifier] = STATE(2909),
    [sym_trailing_return_type] = STATE(1720),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2909),
    [anon_sym_COMMA] = ACTIONS(3663),
    [anon_sym_RPAREN] = ACTIONS(3663),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(5140),
    [sym_comment] = ACTIONS(91),
    [sym_noexcept] = ACTIONS(6534),
  },
  [2363] = {
    [sym_storage_class_specifier] = STATE(2363),
    [sym_type_qualifier] = STATE(2363),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2363),
    [anon_sym_COMMA] = ACTIONS(1970),
    [anon_sym_RPAREN] = ACTIONS(1970),
    [anon_sym_extern] = ACTIONS(1967),
    [anon_sym_LPAREN2] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(1970),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_static] = ACTIONS(1967),
    [anon_sym_register] = ACTIONS(1967),
    [anon_sym_inline] = ACTIONS(1967),
    [anon_sym_const] = ACTIONS(1972),
    [anon_sym_restrict] = ACTIONS(1972),
    [anon_sym_volatile] = ACTIONS(1972),
    [anon_sym__Atomic] = ACTIONS(1972),
    [anon_sym_mutable] = ACTIONS(1972),
    [anon_sym_explicit] = ACTIONS(1972),
    [anon_sym_constexpr] = ACTIONS(1972),
    [anon_sym_AMP] = ACTIONS(1975),
    [anon_sym_AMP_AMP] = ACTIONS(1970),
    [anon_sym_TILDE] = ACTIONS(1970),
    [sym_identifier] = ACTIONS(1975),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1970),
    [sym_operator_name] = ACTIONS(1970),
  },
  [2364] = {
    [sym_storage_class_specifier] = STATE(2363),
    [sym_type_qualifier] = STATE(2363),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2363),
    [anon_sym_COMMA] = ACTIONS(3695),
    [anon_sym_RPAREN] = ACTIONS(3695),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_LPAREN2] = ACTIONS(3695),
    [anon_sym_STAR] = ACTIONS(3695),
    [anon_sym_LBRACK] = ACTIONS(3695),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3695),
    [anon_sym_TILDE] = ACTIONS(3695),
    [sym_identifier] = ACTIONS(3697),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(3695),
    [sym_operator_name] = ACTIONS(3695),
  },
  [2365] = {
    [sym__expression] = STATE(1200),
    [sym_conditional_expression] = STATE(1200),
    [sym_assignment_expression] = STATE(1200),
    [sym_pointer_expression] = STATE(1200),
    [sym_logical_expression] = STATE(1200),
    [sym_bitwise_expression] = STATE(1200),
    [sym_equality_expression] = STATE(1200),
    [sym_relational_expression] = STATE(1200),
    [sym_shift_expression] = STATE(1200),
    [sym_math_expression] = STATE(1200),
    [sym_cast_expression] = STATE(1200),
    [sym_sizeof_expression] = STATE(1200),
    [sym_subscript_expression] = STATE(1200),
    [sym_call_expression] = STATE(1200),
    [sym_field_expression] = STATE(1200),
    [sym_compound_literal_expression] = STATE(1200),
    [sym_parenthesized_expression] = STATE(1200),
    [sym_initializer_list] = STATE(1201),
    [sym_char_literal] = STATE(1200),
    [sym_concatenated_string] = STATE(1200),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1200),
    [sym_new_expression] = STATE(1200),
    [sym_delete_expression] = STATE(1200),
    [sym_lambda_expression] = STATE(1200),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2523),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(2523),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2525),
    [sym_false] = ACTIONS(2525),
    [sym_null] = ACTIONS(2525),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(2525),
  },
  [2366] = {
    [anon_sym_RPAREN] = ACTIONS(6536),
    [sym_comment] = ACTIONS(91),
  },
  [2367] = {
    [sym__expression] = STATE(2911),
    [sym_conditional_expression] = STATE(2911),
    [sym_assignment_expression] = STATE(2911),
    [sym_pointer_expression] = STATE(2911),
    [sym_logical_expression] = STATE(2911),
    [sym_bitwise_expression] = STATE(2911),
    [sym_equality_expression] = STATE(2911),
    [sym_relational_expression] = STATE(2911),
    [sym_shift_expression] = STATE(2911),
    [sym_math_expression] = STATE(2911),
    [sym_cast_expression] = STATE(2911),
    [sym_sizeof_expression] = STATE(2911),
    [sym_subscript_expression] = STATE(2911),
    [sym_call_expression] = STATE(2911),
    [sym_field_expression] = STATE(2911),
    [sym_compound_literal_expression] = STATE(2911),
    [sym_parenthesized_expression] = STATE(2911),
    [sym_char_literal] = STATE(2911),
    [sym_concatenated_string] = STATE(2911),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2911),
    [sym_new_expression] = STATE(2911),
    [sym_delete_expression] = STATE(2911),
    [sym_lambda_expression] = STATE(2911),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6538),
    [anon_sym_LPAREN2] = ACTIONS(947),
    [anon_sym_STAR] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(947),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(6538),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6540),
    [sym_false] = ACTIONS(6540),
    [sym_null] = ACTIONS(6540),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(6540),
  },
  [2368] = {
    [sym__expression] = STATE(2912),
    [sym_conditional_expression] = STATE(2912),
    [sym_assignment_expression] = STATE(2912),
    [sym_pointer_expression] = STATE(2912),
    [sym_logical_expression] = STATE(2912),
    [sym_bitwise_expression] = STATE(2912),
    [sym_equality_expression] = STATE(2912),
    [sym_relational_expression] = STATE(2912),
    [sym_shift_expression] = STATE(2912),
    [sym_math_expression] = STATE(2912),
    [sym_cast_expression] = STATE(2912),
    [sym_sizeof_expression] = STATE(2912),
    [sym_subscript_expression] = STATE(2912),
    [sym_call_expression] = STATE(2912),
    [sym_field_expression] = STATE(2912),
    [sym_compound_literal_expression] = STATE(2912),
    [sym_parenthesized_expression] = STATE(2912),
    [sym_char_literal] = STATE(2912),
    [sym_concatenated_string] = STATE(2912),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2912),
    [sym_new_expression] = STATE(2912),
    [sym_delete_expression] = STATE(2912),
    [sym_lambda_expression] = STATE(2912),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6542),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(6542),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6544),
    [sym_false] = ACTIONS(6544),
    [sym_null] = ACTIONS(6544),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(6544),
  },
  [2369] = {
    [sym_argument_list] = STATE(1610),
    [sym_initializer_list] = STATE(1610),
    [sym_new_declarator] = STATE(1611),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3374),
    [anon_sym_LBRACK] = ACTIONS(5153),
    [anon_sym_RBRACK] = ACTIONS(3372),
    [anon_sym_EQ] = ACTIONS(3374),
    [anon_sym_QMARK] = ACTIONS(3372),
    [anon_sym_STAR_EQ] = ACTIONS(3372),
    [anon_sym_SLASH_EQ] = ACTIONS(3372),
    [anon_sym_PERCENT_EQ] = ACTIONS(3372),
    [anon_sym_PLUS_EQ] = ACTIONS(3372),
    [anon_sym_DASH_EQ] = ACTIONS(3372),
    [anon_sym_LT_LT_EQ] = ACTIONS(3372),
    [anon_sym_GT_GT_EQ] = ACTIONS(3372),
    [anon_sym_AMP_EQ] = ACTIONS(3372),
    [anon_sym_CARET_EQ] = ACTIONS(3372),
    [anon_sym_PIPE_EQ] = ACTIONS(3372),
    [anon_sym_AMP] = ACTIONS(3374),
    [anon_sym_PIPE_PIPE] = ACTIONS(3372),
    [anon_sym_AMP_AMP] = ACTIONS(3372),
    [anon_sym_PIPE] = ACTIONS(3374),
    [anon_sym_CARET] = ACTIONS(3374),
    [anon_sym_EQ_EQ] = ACTIONS(3372),
    [anon_sym_BANG_EQ] = ACTIONS(3372),
    [anon_sym_LT] = ACTIONS(3374),
    [anon_sym_GT] = ACTIONS(3374),
    [anon_sym_LT_EQ] = ACTIONS(3372),
    [anon_sym_GT_EQ] = ACTIONS(3372),
    [anon_sym_LT_LT] = ACTIONS(3374),
    [anon_sym_GT_GT] = ACTIONS(3374),
    [anon_sym_PLUS] = ACTIONS(3374),
    [anon_sym_DASH] = ACTIONS(3374),
    [anon_sym_SLASH] = ACTIONS(3374),
    [anon_sym_PERCENT] = ACTIONS(3374),
    [anon_sym_DASH_DASH] = ACTIONS(3372),
    [anon_sym_PLUS_PLUS] = ACTIONS(3372),
    [anon_sym_DOT] = ACTIONS(3372),
    [anon_sym_DASH_GT] = ACTIONS(3372),
    [sym_comment] = ACTIONS(91),
  },
  [2370] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2370),
    [anon_sym_LBRACE] = ACTIONS(1985),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(1985),
    [anon_sym_EQ] = ACTIONS(1987),
    [anon_sym_unsigned] = ACTIONS(6546),
    [anon_sym_long] = ACTIONS(6546),
    [anon_sym_short] = ACTIONS(6546),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_QMARK] = ACTIONS(1985),
    [anon_sym_STAR_EQ] = ACTIONS(1985),
    [anon_sym_SLASH_EQ] = ACTIONS(1985),
    [anon_sym_PERCENT_EQ] = ACTIONS(1985),
    [anon_sym_PLUS_EQ] = ACTIONS(1985),
    [anon_sym_DASH_EQ] = ACTIONS(1985),
    [anon_sym_LT_LT_EQ] = ACTIONS(1985),
    [anon_sym_GT_GT_EQ] = ACTIONS(1985),
    [anon_sym_AMP_EQ] = ACTIONS(1985),
    [anon_sym_CARET_EQ] = ACTIONS(1985),
    [anon_sym_PIPE_EQ] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_PIPE_PIPE] = ACTIONS(1985),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_PIPE] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1987),
    [anon_sym_EQ_EQ] = ACTIONS(1985),
    [anon_sym_BANG_EQ] = ACTIONS(1985),
    [anon_sym_LT] = ACTIONS(1987),
    [anon_sym_GT] = ACTIONS(1987),
    [anon_sym_LT_EQ] = ACTIONS(1985),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_LT] = ACTIONS(1987),
    [anon_sym_GT_GT] = ACTIONS(1987),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_DASH] = ACTIONS(1987),
    [anon_sym_SLASH] = ACTIONS(1987),
    [anon_sym_PERCENT] = ACTIONS(1987),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DOT] = ACTIONS(1985),
    [anon_sym_DASH_GT] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [sym_comment] = ACTIONS(91),
  },
  [2371] = {
    [sym__expression] = STATE(164),
    [sym_conditional_expression] = STATE(164),
    [sym_assignment_expression] = STATE(164),
    [sym_pointer_expression] = STATE(164),
    [sym_logical_expression] = STATE(164),
    [sym_bitwise_expression] = STATE(164),
    [sym_equality_expression] = STATE(164),
    [sym_relational_expression] = STATE(164),
    [sym_shift_expression] = STATE(164),
    [sym_math_expression] = STATE(164),
    [sym_cast_expression] = STATE(164),
    [sym_sizeof_expression] = STATE(164),
    [sym_subscript_expression] = STATE(164),
    [sym_call_expression] = STATE(164),
    [sym_field_expression] = STATE(164),
    [sym_compound_literal_expression] = STATE(164),
    [sym_parenthesized_expression] = STATE(164),
    [sym_char_literal] = STATE(164),
    [sym_concatenated_string] = STATE(164),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(164),
    [sym_new_expression] = STATE(164),
    [sym_delete_expression] = STATE(164),
    [sym_lambda_expression] = STATE(164),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_lambda_default_capture] = STATE(166),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(267),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(6549),
    [anon_sym_EQ] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(267),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(289),
    [sym_false] = ACTIONS(289),
    [sym_null] = ACTIONS(289),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(289),
  },
  [2372] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(3383),
    [anon_sym_EQ] = ACTIONS(3385),
    [anon_sym_QMARK] = ACTIONS(3383),
    [anon_sym_STAR_EQ] = ACTIONS(3383),
    [anon_sym_SLASH_EQ] = ACTIONS(3383),
    [anon_sym_PERCENT_EQ] = ACTIONS(3383),
    [anon_sym_PLUS_EQ] = ACTIONS(3383),
    [anon_sym_DASH_EQ] = ACTIONS(3383),
    [anon_sym_LT_LT_EQ] = ACTIONS(3383),
    [anon_sym_GT_GT_EQ] = ACTIONS(3383),
    [anon_sym_AMP_EQ] = ACTIONS(3383),
    [anon_sym_CARET_EQ] = ACTIONS(3383),
    [anon_sym_PIPE_EQ] = ACTIONS(3383),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_CARET] = ACTIONS(3517),
    [anon_sym_EQ_EQ] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3521),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3525),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2373] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(3581),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_QMARK] = ACTIONS(3581),
    [anon_sym_STAR_EQ] = ACTIONS(3507),
    [anon_sym_SLASH_EQ] = ACTIONS(3507),
    [anon_sym_PERCENT_EQ] = ACTIONS(3507),
    [anon_sym_PLUS_EQ] = ACTIONS(3507),
    [anon_sym_DASH_EQ] = ACTIONS(3507),
    [anon_sym_LT_LT_EQ] = ACTIONS(3507),
    [anon_sym_GT_GT_EQ] = ACTIONS(3507),
    [anon_sym_AMP_EQ] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(3507),
    [anon_sym_PIPE_EQ] = ACTIONS(3507),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_CARET] = ACTIONS(3517),
    [anon_sym_EQ_EQ] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3521),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3525),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2374] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_COLON] = ACTIONS(6551),
    [anon_sym_QMARK] = ACTIONS(1171),
    [anon_sym_STAR_EQ] = ACTIONS(1173),
    [anon_sym_SLASH_EQ] = ACTIONS(1173),
    [anon_sym_PERCENT_EQ] = ACTIONS(1173),
    [anon_sym_PLUS_EQ] = ACTIONS(1173),
    [anon_sym_DASH_EQ] = ACTIONS(1173),
    [anon_sym_LT_LT_EQ] = ACTIONS(1173),
    [anon_sym_GT_GT_EQ] = ACTIONS(1173),
    [anon_sym_AMP_EQ] = ACTIONS(1173),
    [anon_sym_CARET_EQ] = ACTIONS(1173),
    [anon_sym_PIPE_EQ] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_CARET] = ACTIONS(1183),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [2375] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(3585),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_STAR_EQ] = ACTIONS(3585),
    [anon_sym_SLASH_EQ] = ACTIONS(3585),
    [anon_sym_PERCENT_EQ] = ACTIONS(3585),
    [anon_sym_PLUS_EQ] = ACTIONS(3585),
    [anon_sym_DASH_EQ] = ACTIONS(3585),
    [anon_sym_LT_LT_EQ] = ACTIONS(3585),
    [anon_sym_GT_GT_EQ] = ACTIONS(3585),
    [anon_sym_AMP_EQ] = ACTIONS(3585),
    [anon_sym_CARET_EQ] = ACTIONS(3585),
    [anon_sym_PIPE_EQ] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(3587),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3587),
    [anon_sym_CARET] = ACTIONS(3587),
    [anon_sym_EQ_EQ] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3521),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3525),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2376] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(3589),
    [anon_sym_EQ] = ACTIONS(3591),
    [anon_sym_QMARK] = ACTIONS(3589),
    [anon_sym_STAR_EQ] = ACTIONS(3589),
    [anon_sym_SLASH_EQ] = ACTIONS(3589),
    [anon_sym_PERCENT_EQ] = ACTIONS(3589),
    [anon_sym_PLUS_EQ] = ACTIONS(3589),
    [anon_sym_DASH_EQ] = ACTIONS(3589),
    [anon_sym_LT_LT_EQ] = ACTIONS(3589),
    [anon_sym_GT_GT_EQ] = ACTIONS(3589),
    [anon_sym_AMP_EQ] = ACTIONS(3589),
    [anon_sym_CARET_EQ] = ACTIONS(3589),
    [anon_sym_PIPE_EQ] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_PIPE_PIPE] = ACTIONS(3589),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_CARET] = ACTIONS(3517),
    [anon_sym_EQ_EQ] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3521),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3525),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2377] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(3589),
    [anon_sym_EQ] = ACTIONS(3591),
    [anon_sym_QMARK] = ACTIONS(3589),
    [anon_sym_STAR_EQ] = ACTIONS(3589),
    [anon_sym_SLASH_EQ] = ACTIONS(3589),
    [anon_sym_PERCENT_EQ] = ACTIONS(3589),
    [anon_sym_PLUS_EQ] = ACTIONS(3589),
    [anon_sym_DASH_EQ] = ACTIONS(3589),
    [anon_sym_LT_LT_EQ] = ACTIONS(3589),
    [anon_sym_GT_GT_EQ] = ACTIONS(3589),
    [anon_sym_AMP_EQ] = ACTIONS(3589),
    [anon_sym_CARET_EQ] = ACTIONS(3589),
    [anon_sym_PIPE_EQ] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_PIPE_PIPE] = ACTIONS(3589),
    [anon_sym_AMP_AMP] = ACTIONS(3589),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_CARET] = ACTIONS(3517),
    [anon_sym_EQ_EQ] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3521),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3525),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2378] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(3585),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_STAR_EQ] = ACTIONS(3585),
    [anon_sym_SLASH_EQ] = ACTIONS(3585),
    [anon_sym_PERCENT_EQ] = ACTIONS(3585),
    [anon_sym_PLUS_EQ] = ACTIONS(3585),
    [anon_sym_DASH_EQ] = ACTIONS(3585),
    [anon_sym_LT_LT_EQ] = ACTIONS(3585),
    [anon_sym_GT_GT_EQ] = ACTIONS(3585),
    [anon_sym_AMP_EQ] = ACTIONS(3585),
    [anon_sym_CARET_EQ] = ACTIONS(3585),
    [anon_sym_PIPE_EQ] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3587),
    [anon_sym_CARET] = ACTIONS(3517),
    [anon_sym_EQ_EQ] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3521),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3525),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2379] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(3585),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_STAR_EQ] = ACTIONS(3585),
    [anon_sym_SLASH_EQ] = ACTIONS(3585),
    [anon_sym_PERCENT_EQ] = ACTIONS(3585),
    [anon_sym_PLUS_EQ] = ACTIONS(3585),
    [anon_sym_DASH_EQ] = ACTIONS(3585),
    [anon_sym_LT_LT_EQ] = ACTIONS(3585),
    [anon_sym_GT_GT_EQ] = ACTIONS(3585),
    [anon_sym_AMP_EQ] = ACTIONS(3585),
    [anon_sym_CARET_EQ] = ACTIONS(3585),
    [anon_sym_PIPE_EQ] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3587),
    [anon_sym_CARET] = ACTIONS(3587),
    [anon_sym_EQ_EQ] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3521),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3525),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2380] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(3593),
    [anon_sym_EQ] = ACTIONS(3595),
    [anon_sym_QMARK] = ACTIONS(3593),
    [anon_sym_STAR_EQ] = ACTIONS(3593),
    [anon_sym_SLASH_EQ] = ACTIONS(3593),
    [anon_sym_PERCENT_EQ] = ACTIONS(3593),
    [anon_sym_PLUS_EQ] = ACTIONS(3593),
    [anon_sym_DASH_EQ] = ACTIONS(3593),
    [anon_sym_LT_LT_EQ] = ACTIONS(3593),
    [anon_sym_GT_GT_EQ] = ACTIONS(3593),
    [anon_sym_AMP_EQ] = ACTIONS(3593),
    [anon_sym_CARET_EQ] = ACTIONS(3593),
    [anon_sym_PIPE_EQ] = ACTIONS(3593),
    [anon_sym_AMP] = ACTIONS(3595),
    [anon_sym_PIPE_PIPE] = ACTIONS(3593),
    [anon_sym_AMP_AMP] = ACTIONS(3593),
    [anon_sym_PIPE] = ACTIONS(3595),
    [anon_sym_CARET] = ACTIONS(3595),
    [anon_sym_EQ_EQ] = ACTIONS(3593),
    [anon_sym_BANG_EQ] = ACTIONS(3593),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3521),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3525),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2381] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(3597),
    [anon_sym_EQ] = ACTIONS(3599),
    [anon_sym_QMARK] = ACTIONS(3597),
    [anon_sym_STAR_EQ] = ACTIONS(3597),
    [anon_sym_SLASH_EQ] = ACTIONS(3597),
    [anon_sym_PERCENT_EQ] = ACTIONS(3597),
    [anon_sym_PLUS_EQ] = ACTIONS(3597),
    [anon_sym_DASH_EQ] = ACTIONS(3597),
    [anon_sym_LT_LT_EQ] = ACTIONS(3597),
    [anon_sym_GT_GT_EQ] = ACTIONS(3597),
    [anon_sym_AMP_EQ] = ACTIONS(3597),
    [anon_sym_CARET_EQ] = ACTIONS(3597),
    [anon_sym_PIPE_EQ] = ACTIONS(3597),
    [anon_sym_AMP] = ACTIONS(3599),
    [anon_sym_PIPE_PIPE] = ACTIONS(3597),
    [anon_sym_AMP_AMP] = ACTIONS(3597),
    [anon_sym_PIPE] = ACTIONS(3599),
    [anon_sym_CARET] = ACTIONS(3599),
    [anon_sym_EQ_EQ] = ACTIONS(3597),
    [anon_sym_BANG_EQ] = ACTIONS(3597),
    [anon_sym_LT] = ACTIONS(3599),
    [anon_sym_GT] = ACTIONS(3599),
    [anon_sym_LT_EQ] = ACTIONS(3597),
    [anon_sym_GT_EQ] = ACTIONS(3597),
    [anon_sym_LT_LT] = ACTIONS(3525),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2382] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(3601),
    [anon_sym_EQ] = ACTIONS(3603),
    [anon_sym_QMARK] = ACTIONS(3601),
    [anon_sym_STAR_EQ] = ACTIONS(3601),
    [anon_sym_SLASH_EQ] = ACTIONS(3601),
    [anon_sym_PERCENT_EQ] = ACTIONS(3601),
    [anon_sym_PLUS_EQ] = ACTIONS(3601),
    [anon_sym_DASH_EQ] = ACTIONS(3601),
    [anon_sym_LT_LT_EQ] = ACTIONS(3601),
    [anon_sym_GT_GT_EQ] = ACTIONS(3601),
    [anon_sym_AMP_EQ] = ACTIONS(3601),
    [anon_sym_CARET_EQ] = ACTIONS(3601),
    [anon_sym_PIPE_EQ] = ACTIONS(3601),
    [anon_sym_AMP] = ACTIONS(3603),
    [anon_sym_PIPE_PIPE] = ACTIONS(3601),
    [anon_sym_AMP_AMP] = ACTIONS(3601),
    [anon_sym_PIPE] = ACTIONS(3603),
    [anon_sym_CARET] = ACTIONS(3603),
    [anon_sym_EQ_EQ] = ACTIONS(3601),
    [anon_sym_BANG_EQ] = ACTIONS(3601),
    [anon_sym_LT] = ACTIONS(3603),
    [anon_sym_GT] = ACTIONS(3603),
    [anon_sym_LT_EQ] = ACTIONS(3601),
    [anon_sym_GT_EQ] = ACTIONS(3601),
    [anon_sym_LT_LT] = ACTIONS(3603),
    [anon_sym_GT_GT] = ACTIONS(3603),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2383] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(3575),
    [anon_sym_EQ] = ACTIONS(3577),
    [anon_sym_QMARK] = ACTIONS(3575),
    [anon_sym_STAR_EQ] = ACTIONS(3575),
    [anon_sym_SLASH_EQ] = ACTIONS(3575),
    [anon_sym_PERCENT_EQ] = ACTIONS(3575),
    [anon_sym_PLUS_EQ] = ACTIONS(3575),
    [anon_sym_DASH_EQ] = ACTIONS(3575),
    [anon_sym_LT_LT_EQ] = ACTIONS(3575),
    [anon_sym_GT_GT_EQ] = ACTIONS(3575),
    [anon_sym_AMP_EQ] = ACTIONS(3575),
    [anon_sym_CARET_EQ] = ACTIONS(3575),
    [anon_sym_PIPE_EQ] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_PIPE_PIPE] = ACTIONS(3575),
    [anon_sym_AMP_AMP] = ACTIONS(3575),
    [anon_sym_PIPE] = ACTIONS(3577),
    [anon_sym_CARET] = ACTIONS(3577),
    [anon_sym_EQ_EQ] = ACTIONS(3575),
    [anon_sym_BANG_EQ] = ACTIONS(3575),
    [anon_sym_LT] = ACTIONS(3577),
    [anon_sym_GT] = ACTIONS(3577),
    [anon_sym_LT_EQ] = ACTIONS(3575),
    [anon_sym_GT_EQ] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3577),
    [anon_sym_GT_GT] = ACTIONS(3577),
    [anon_sym_PLUS] = ACTIONS(3577),
    [anon_sym_DASH] = ACTIONS(3577),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2384] = {
    [sym_string_literal] = STATE(2384),
    [aux_sym_concatenated_string_repeat1] = STATE(2384),
    [anon_sym_LPAREN2] = ACTIONS(3622),
    [anon_sym_STAR] = ACTIONS(3624),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3622),
    [anon_sym_EQ] = ACTIONS(3624),
    [anon_sym_QMARK] = ACTIONS(3622),
    [anon_sym_STAR_EQ] = ACTIONS(3622),
    [anon_sym_SLASH_EQ] = ACTIONS(3622),
    [anon_sym_PERCENT_EQ] = ACTIONS(3622),
    [anon_sym_PLUS_EQ] = ACTIONS(3622),
    [anon_sym_DASH_EQ] = ACTIONS(3622),
    [anon_sym_LT_LT_EQ] = ACTIONS(3622),
    [anon_sym_GT_GT_EQ] = ACTIONS(3622),
    [anon_sym_AMP_EQ] = ACTIONS(3622),
    [anon_sym_CARET_EQ] = ACTIONS(3622),
    [anon_sym_PIPE_EQ] = ACTIONS(3622),
    [anon_sym_AMP] = ACTIONS(3624),
    [anon_sym_PIPE_PIPE] = ACTIONS(3622),
    [anon_sym_AMP_AMP] = ACTIONS(3622),
    [anon_sym_PIPE] = ACTIONS(3624),
    [anon_sym_CARET] = ACTIONS(3624),
    [anon_sym_EQ_EQ] = ACTIONS(3622),
    [anon_sym_BANG_EQ] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3624),
    [anon_sym_GT] = ACTIONS(3624),
    [anon_sym_LT_EQ] = ACTIONS(3622),
    [anon_sym_GT_EQ] = ACTIONS(3622),
    [anon_sym_LT_LT] = ACTIONS(3624),
    [anon_sym_GT_GT] = ACTIONS(3624),
    [anon_sym_PLUS] = ACTIONS(3624),
    [anon_sym_DASH] = ACTIONS(3624),
    [anon_sym_SLASH] = ACTIONS(3624),
    [anon_sym_PERCENT] = ACTIONS(3624),
    [anon_sym_DASH_DASH] = ACTIONS(3622),
    [anon_sym_PLUS_PLUS] = ACTIONS(3622),
    [anon_sym_DOT] = ACTIONS(3622),
    [anon_sym_DASH_GT] = ACTIONS(3622),
    [anon_sym_DQUOTE] = ACTIONS(3626),
    [sym_comment] = ACTIONS(91),
  },
  [2385] = {
    [anon_sym_COMMA] = ACTIONS(6553),
    [anon_sym_RPAREN] = ACTIONS(6553),
    [anon_sym_SEMI] = ACTIONS(6553),
    [anon_sym_LBRACE] = ACTIONS(6553),
    [anon_sym_LPAREN2] = ACTIONS(6553),
    [anon_sym_LBRACK] = ACTIONS(6553),
    [anon_sym_EQ] = ACTIONS(6553),
    [anon_sym_COLON] = ACTIONS(6553),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(6553),
  },
  [2386] = {
    [sym_enumerator_list] = STATE(1074),
    [anon_sym_COMMA] = ACTIONS(1011),
    [anon_sym_SEMI] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_LPAREN2] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(1011),
    [anon_sym_LBRACK] = ACTIONS(1011),
    [anon_sym_EQ] = ACTIONS(1011),
    [anon_sym_const] = ACTIONS(1013),
    [anon_sym_restrict] = ACTIONS(1011),
    [anon_sym_volatile] = ACTIONS(1011),
    [anon_sym__Atomic] = ACTIONS(1011),
    [anon_sym_mutable] = ACTIONS(1011),
    [anon_sym_explicit] = ACTIONS(1011),
    [anon_sym_constexpr] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1013),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_DASH_GT] = ACTIONS(1011),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1011),
    [anon_sym_override] = ACTIONS(1011),
    [sym_noexcept] = ACTIONS(1011),
  },
  [2387] = {
    [sym_field_declaration_list] = STATE(1077),
    [sym_virtual_specifier] = STATE(1078),
    [sym_base_class_clause] = STATE(1079),
    [sym_template_argument_list] = STATE(437),
    [anon_sym_COMMA] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_LPAREN2] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_EQ] = ACTIONS(1057),
    [anon_sym_const] = ACTIONS(1059),
    [anon_sym_restrict] = ACTIONS(1057),
    [anon_sym_volatile] = ACTIONS(1057),
    [anon_sym__Atomic] = ACTIONS(1057),
    [anon_sym_mutable] = ACTIONS(1057),
    [anon_sym_explicit] = ACTIONS(1057),
    [anon_sym_constexpr] = ACTIONS(1057),
    [anon_sym_COLON] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_DASH_GT] = ACTIONS(1057),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1057),
    [anon_sym_override] = ACTIONS(1057),
    [sym_noexcept] = ACTIONS(1057),
    [anon_sym_COLON_COLON] = ACTIONS(758),
  },
  [2388] = {
    [sym_field_declaration_list] = STATE(1080),
    [sym_virtual_specifier] = STATE(1082),
    [sym_base_class_clause] = STATE(1081),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_LBRACE] = ACTIONS(1069),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1069),
    [anon_sym_EQ] = ACTIONS(1069),
    [anon_sym_const] = ACTIONS(1071),
    [anon_sym_restrict] = ACTIONS(1069),
    [anon_sym_volatile] = ACTIONS(1069),
    [anon_sym__Atomic] = ACTIONS(1069),
    [anon_sym_mutable] = ACTIONS(1069),
    [anon_sym_explicit] = ACTIONS(1069),
    [anon_sym_constexpr] = ACTIONS(1069),
    [anon_sym_COLON] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1069),
    [anon_sym_DASH_GT] = ACTIONS(1069),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1069),
    [anon_sym_override] = ACTIONS(1069),
    [sym_noexcept] = ACTIONS(1069),
    [anon_sym_COLON_COLON] = ACTIONS(772),
  },
  [2389] = {
    [sym_field_declaration_list] = STATE(1080),
    [sym_virtual_specifier] = STATE(1082),
    [sym_base_class_clause] = STATE(1081),
    [sym_template_argument_list] = STATE(362),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_LBRACE] = ACTIONS(1069),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1069),
    [anon_sym_EQ] = ACTIONS(1069),
    [anon_sym_const] = ACTIONS(1071),
    [anon_sym_restrict] = ACTIONS(1069),
    [anon_sym_volatile] = ACTIONS(1069),
    [anon_sym__Atomic] = ACTIONS(1069),
    [anon_sym_mutable] = ACTIONS(1069),
    [anon_sym_explicit] = ACTIONS(1069),
    [anon_sym_constexpr] = ACTIONS(1069),
    [anon_sym_COLON] = ACTIONS(1069),
    [anon_sym_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1069),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_DASH_GT] = ACTIONS(1069),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1069),
    [anon_sym_override] = ACTIONS(1069),
    [sym_noexcept] = ACTIONS(1069),
  },
  [2390] = {
    [sym_field_declaration_list] = STATE(1083),
    [sym_virtual_specifier] = STATE(1084),
    [sym_base_class_clause] = STATE(1085),
    [sym_template_argument_list] = STATE(437),
    [anon_sym_COMMA] = ACTIONS(1077),
    [anon_sym_SEMI] = ACTIONS(1077),
    [anon_sym_LBRACE] = ACTIONS(1077),
    [anon_sym_LPAREN2] = ACTIONS(1077),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_LBRACK] = ACTIONS(1077),
    [anon_sym_EQ] = ACTIONS(1077),
    [anon_sym_const] = ACTIONS(1079),
    [anon_sym_restrict] = ACTIONS(1077),
    [anon_sym_volatile] = ACTIONS(1077),
    [anon_sym__Atomic] = ACTIONS(1077),
    [anon_sym_mutable] = ACTIONS(1077),
    [anon_sym_explicit] = ACTIONS(1077),
    [anon_sym_constexpr] = ACTIONS(1077),
    [anon_sym_COLON] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_DASH_GT] = ACTIONS(1077),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1077),
    [anon_sym_override] = ACTIONS(1077),
    [sym_noexcept] = ACTIONS(1077),
    [anon_sym_COLON_COLON] = ACTIONS(758),
  },
  [2391] = {
    [sym_field_declaration_list] = STATE(1086),
    [sym_virtual_specifier] = STATE(1088),
    [sym_base_class_clause] = STATE(1087),
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LBRACE] = ACTIONS(1081),
    [anon_sym_LPAREN2] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1081),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(1081),
    [anon_sym_const] = ACTIONS(1083),
    [anon_sym_restrict] = ACTIONS(1081),
    [anon_sym_volatile] = ACTIONS(1081),
    [anon_sym__Atomic] = ACTIONS(1081),
    [anon_sym_mutable] = ACTIONS(1081),
    [anon_sym_explicit] = ACTIONS(1081),
    [anon_sym_constexpr] = ACTIONS(1081),
    [anon_sym_COLON] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(1081),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1081),
    [anon_sym_override] = ACTIONS(1081),
    [sym_noexcept] = ACTIONS(1081),
    [anon_sym_COLON_COLON] = ACTIONS(772),
  },
  [2392] = {
    [sym_field_declaration_list] = STATE(1086),
    [sym_virtual_specifier] = STATE(1088),
    [sym_base_class_clause] = STATE(1087),
    [sym_template_argument_list] = STATE(362),
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LBRACE] = ACTIONS(1081),
    [anon_sym_LPAREN2] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1081),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(1081),
    [anon_sym_const] = ACTIONS(1083),
    [anon_sym_restrict] = ACTIONS(1081),
    [anon_sym_volatile] = ACTIONS(1081),
    [anon_sym__Atomic] = ACTIONS(1081),
    [anon_sym_mutable] = ACTIONS(1081),
    [anon_sym_explicit] = ACTIONS(1081),
    [anon_sym_constexpr] = ACTIONS(1081),
    [anon_sym_COLON] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_DASH_GT] = ACTIONS(1081),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1081),
    [anon_sym_override] = ACTIONS(1081),
    [sym_noexcept] = ACTIONS(1081),
  },
  [2393] = {
    [sym_field_declaration_list] = STATE(1093),
    [sym_virtual_specifier] = STATE(1094),
    [sym_base_class_clause] = STATE(1095),
    [sym_template_argument_list] = STATE(437),
    [anon_sym_COMMA] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1438),
    [anon_sym_LBRACE] = ACTIONS(1438),
    [anon_sym_LPAREN2] = ACTIONS(1438),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_LBRACK] = ACTIONS(1438),
    [anon_sym_EQ] = ACTIONS(1438),
    [anon_sym_const] = ACTIONS(1440),
    [anon_sym_restrict] = ACTIONS(1438),
    [anon_sym_volatile] = ACTIONS(1438),
    [anon_sym__Atomic] = ACTIONS(1438),
    [anon_sym_mutable] = ACTIONS(1438),
    [anon_sym_explicit] = ACTIONS(1438),
    [anon_sym_constexpr] = ACTIONS(1438),
    [anon_sym_COLON] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_AMP_AMP] = ACTIONS(1438),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_DASH_GT] = ACTIONS(1438),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1438),
    [anon_sym_override] = ACTIONS(1438),
    [sym_noexcept] = ACTIONS(1438),
    [anon_sym_COLON_COLON] = ACTIONS(758),
  },
  [2394] = {
    [sym_field_declaration_list] = STATE(1096),
    [sym_virtual_specifier] = STATE(1098),
    [sym_base_class_clause] = STATE(1097),
    [anon_sym_COMMA] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1442),
    [anon_sym_LBRACE] = ACTIONS(1442),
    [anon_sym_LPAREN2] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(1442),
    [anon_sym_EQ] = ACTIONS(1442),
    [anon_sym_const] = ACTIONS(1444),
    [anon_sym_restrict] = ACTIONS(1442),
    [anon_sym_volatile] = ACTIONS(1442),
    [anon_sym__Atomic] = ACTIONS(1442),
    [anon_sym_mutable] = ACTIONS(1442),
    [anon_sym_explicit] = ACTIONS(1442),
    [anon_sym_constexpr] = ACTIONS(1442),
    [anon_sym_COLON] = ACTIONS(1444),
    [anon_sym_AMP] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1442),
    [anon_sym_DASH_GT] = ACTIONS(1442),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1442),
    [anon_sym_override] = ACTIONS(1442),
    [sym_noexcept] = ACTIONS(1442),
    [anon_sym_COLON_COLON] = ACTIONS(772),
  },
  [2395] = {
    [sym_field_declaration_list] = STATE(1096),
    [sym_virtual_specifier] = STATE(1098),
    [sym_base_class_clause] = STATE(1097),
    [sym_template_argument_list] = STATE(362),
    [anon_sym_COMMA] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1442),
    [anon_sym_LBRACE] = ACTIONS(1442),
    [anon_sym_LPAREN2] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(1442),
    [anon_sym_EQ] = ACTIONS(1442),
    [anon_sym_const] = ACTIONS(1444),
    [anon_sym_restrict] = ACTIONS(1442),
    [anon_sym_volatile] = ACTIONS(1442),
    [anon_sym__Atomic] = ACTIONS(1442),
    [anon_sym_mutable] = ACTIONS(1442),
    [anon_sym_explicit] = ACTIONS(1442),
    [anon_sym_constexpr] = ACTIONS(1442),
    [anon_sym_COLON] = ACTIONS(1442),
    [anon_sym_AMP] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1442),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_DASH_GT] = ACTIONS(1442),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1442),
    [anon_sym_override] = ACTIONS(1442),
    [sym_noexcept] = ACTIONS(1442),
  },
  [2396] = {
    [sym__abstract_declarator] = STATE(2915),
    [sym_abstract_pointer_declarator] = STATE(2915),
    [sym_abstract_function_declarator] = STATE(2915),
    [sym_abstract_array_declarator] = STATE(2915),
    [sym_type_qualifier] = STATE(2916),
    [sym_parameter_list] = STATE(2399),
    [sym_abstract_reference_declarator] = STATE(2915),
    [aux_sym_type_definition_repeat1] = STATE(2916),
    [anon_sym_LBRACE] = ACTIONS(2461),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(5224),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_EQ] = ACTIONS(2461),
    [anon_sym_const] = ACTIONS(1667),
    [anon_sym_restrict] = ACTIONS(1669),
    [anon_sym_volatile] = ACTIONS(1669),
    [anon_sym__Atomic] = ACTIONS(1669),
    [anon_sym_mutable] = ACTIONS(1669),
    [anon_sym_explicit] = ACTIONS(1669),
    [anon_sym_constexpr] = ACTIONS(1669),
    [anon_sym_COLON] = ACTIONS(2461),
    [anon_sym_AMP] = ACTIONS(5228),
    [anon_sym_AMP_AMP] = ACTIONS(5230),
    [anon_sym_DASH_GT] = ACTIONS(2461),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2461),
    [anon_sym_override] = ACTIONS(2461),
    [sym_noexcept] = ACTIONS(2461),
  },
  [2397] = {
    [sym__abstract_declarator] = STATE(2917),
    [sym_abstract_pointer_declarator] = STATE(2917),
    [sym_abstract_function_declarator] = STATE(2917),
    [sym_abstract_array_declarator] = STATE(2917),
    [sym_parameter_list] = STATE(2399),
    [sym_abstract_reference_declarator] = STATE(2917),
    [anon_sym_LBRACE] = ACTIONS(2463),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(5224),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_EQ] = ACTIONS(2463),
    [anon_sym_const] = ACTIONS(6555),
    [anon_sym_restrict] = ACTIONS(2463),
    [anon_sym_volatile] = ACTIONS(2463),
    [anon_sym__Atomic] = ACTIONS(2463),
    [anon_sym_mutable] = ACTIONS(2463),
    [anon_sym_explicit] = ACTIONS(2463),
    [anon_sym_constexpr] = ACTIONS(2463),
    [anon_sym_COLON] = ACTIONS(2463),
    [anon_sym_AMP] = ACTIONS(5228),
    [anon_sym_AMP_AMP] = ACTIONS(5230),
    [anon_sym_DASH_GT] = ACTIONS(2463),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2463),
    [anon_sym_override] = ACTIONS(2463),
    [sym_noexcept] = ACTIONS(2463),
  },
  [2398] = {
    [sym_parameter_list] = STATE(2918),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(6557),
    [anon_sym_const] = ACTIONS(6559),
    [anon_sym_restrict] = ACTIONS(6557),
    [anon_sym_volatile] = ACTIONS(6557),
    [anon_sym__Atomic] = ACTIONS(6557),
    [anon_sym_mutable] = ACTIONS(6557),
    [anon_sym_explicit] = ACTIONS(6557),
    [anon_sym_constexpr] = ACTIONS(6557),
    [anon_sym_COLON] = ACTIONS(6557),
    [anon_sym_DASH_GT] = ACTIONS(6557),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(6557),
    [anon_sym_override] = ACTIONS(6557),
    [sym_noexcept] = ACTIONS(6557),
  },
  [2399] = {
    [sym_type_qualifier] = STATE(2919),
    [sym_trailing_return_type] = STATE(971),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2919),
    [anon_sym_LBRACE] = ACTIONS(1787),
    [anon_sym_LPAREN2] = ACTIONS(1787),
    [anon_sym_LBRACK] = ACTIONS(1787),
    [anon_sym_EQ] = ACTIONS(1787),
    [anon_sym_const] = ACTIONS(6561),
    [anon_sym_restrict] = ACTIONS(1787),
    [anon_sym_volatile] = ACTIONS(1787),
    [anon_sym__Atomic] = ACTIONS(1787),
    [anon_sym_mutable] = ACTIONS(1787),
    [anon_sym_explicit] = ACTIONS(1787),
    [anon_sym_constexpr] = ACTIONS(1787),
    [anon_sym_COLON] = ACTIONS(1787),
    [anon_sym_DASH_GT] = ACTIONS(1787),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1787),
    [anon_sym_override] = ACTIONS(1787),
    [sym_noexcept] = ACTIONS(1787),
  },
  [2400] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2400),
    [anon_sym_LBRACE] = ACTIONS(1985),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1985),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_EQ] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1987),
    [anon_sym_restrict] = ACTIONS(1987),
    [anon_sym_volatile] = ACTIONS(1987),
    [anon_sym__Atomic] = ACTIONS(1987),
    [anon_sym_mutable] = ACTIONS(1987),
    [anon_sym_explicit] = ACTIONS(1987),
    [anon_sym_constexpr] = ACTIONS(1987),
    [anon_sym_unsigned] = ACTIONS(6563),
    [anon_sym_long] = ACTIONS(6563),
    [anon_sym_short] = ACTIONS(6563),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_COLON] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_DASH_GT] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1987),
    [anon_sym_override] = ACTIONS(1987),
    [sym_noexcept] = ACTIONS(1987),
  },
  [2401] = {
    [anon_sym_LBRACE] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(6566),
    [anon_sym_LT] = ACTIONS(3218),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(3225),
  },
  [2402] = {
    [anon_sym_LBRACE] = ACTIONS(6568),
    [anon_sym_LPAREN2] = ACTIONS(6568),
    [anon_sym_LT] = ACTIONS(6568),
    [sym_comment] = ACTIONS(91),
  },
  [2403] = {
    [anon_sym_COMMA] = ACTIONS(6570),
    [anon_sym_LBRACE] = ACTIONS(6570),
    [anon_sym_EQ] = ACTIONS(6570),
    [sym_comment] = ACTIONS(91),
  },
  [2404] = {
    [aux_sym_field_initializer_list_repeat1] = STATE(2404),
    [anon_sym_COMMA] = ACTIONS(6572),
    [anon_sym_LBRACE] = ACTIONS(6570),
    [anon_sym_EQ] = ACTIONS(6570),
    [sym_comment] = ACTIONS(91),
  },
  [2405] = {
    [anon_sym_LBRACE] = ACTIONS(6575),
    [anon_sym_LPAREN2] = ACTIONS(6575),
    [anon_sym_LT] = ACTIONS(3636),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(3643),
  },
  [2406] = {
    [anon_sym_LBRACE] = ACTIONS(6577),
    [anon_sym_LPAREN2] = ACTIONS(6577),
    [anon_sym_LT] = ACTIONS(6577),
    [sym_comment] = ACTIONS(91),
  },
  [2407] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(6579),
    [anon_sym_SEMI] = ACTIONS(6579),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(590),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(594),
    [anon_sym_QMARK] = ACTIONS(596),
    [anon_sym_STAR_EQ] = ACTIONS(598),
    [anon_sym_SLASH_EQ] = ACTIONS(598),
    [anon_sym_PERCENT_EQ] = ACTIONS(598),
    [anon_sym_PLUS_EQ] = ACTIONS(598),
    [anon_sym_DASH_EQ] = ACTIONS(598),
    [anon_sym_LT_LT_EQ] = ACTIONS(598),
    [anon_sym_GT_GT_EQ] = ACTIONS(598),
    [anon_sym_AMP_EQ] = ACTIONS(598),
    [anon_sym_CARET_EQ] = ACTIONS(598),
    [anon_sym_PIPE_EQ] = ACTIONS(598),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_PIPE_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(604),
    [anon_sym_PIPE] = ACTIONS(606),
    [anon_sym_CARET] = ACTIONS(608),
    [anon_sym_EQ_EQ] = ACTIONS(610),
    [anon_sym_BANG_EQ] = ACTIONS(610),
    [anon_sym_LT] = ACTIONS(612),
    [anon_sym_GT] = ACTIONS(612),
    [anon_sym_LT_EQ] = ACTIONS(614),
    [anon_sym_GT_EQ] = ACTIONS(614),
    [anon_sym_LT_LT] = ACTIONS(616),
    [anon_sym_GT_GT] = ACTIONS(616),
    [anon_sym_PLUS] = ACTIONS(618),
    [anon_sym_DASH] = ACTIONS(618),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2408] = {
    [anon_sym_LT] = ACTIONS(6581),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(3225),
  },
  [2409] = {
    [anon_sym_LT] = ACTIONS(6584),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(3643),
  },
  [2410] = {
    [sym_type_qualifier] = STATE(2414),
    [sym_trailing_return_type] = STATE(2418),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2414),
    [anon_sym_LPAREN2] = ACTIONS(5331),
    [anon_sym_LBRACK] = ACTIONS(5331),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(3647),
    [sym_comment] = ACTIONS(91),
    [sym_noexcept] = ACTIONS(5314),
  },
  [2411] = {
    [sym__type_specifier] = STATE(271),
    [sym_sized_type_specifier] = STATE(271),
    [sym_enum_specifier] = STATE(271),
    [sym_struct_specifier] = STATE(271),
    [sym_union_specifier] = STATE(271),
    [sym_macro_type_specifier] = STATE(271),
    [sym_class_specifier] = STATE(271),
    [sym_dependent_type] = STATE(271),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2413),
    [anon_sym_unsigned] = ACTIONS(5308),
    [anon_sym_long] = ACTIONS(5308),
    [anon_sym_short] = ACTIONS(5308),
    [sym_primitive_type] = ACTIONS(490),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(490),
    [anon_sym_typename] = ACTIONS(5312),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [2412] = {
    [sym__abstract_declarator] = STATE(960),
    [sym_abstract_pointer_declarator] = STATE(960),
    [sym_abstract_function_declarator] = STATE(960),
    [sym_abstract_array_declarator] = STATE(960),
    [sym_parameter_list] = STATE(961),
    [sym_abstract_reference_declarator] = STATE(960),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_AMP] = ACTIONS(639),
    [anon_sym_AMP_AMP] = ACTIONS(641),
    [sym_comment] = ACTIONS(91),
  },
  [2413] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2920),
    [anon_sym_LPAREN2] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_unsigned] = ACTIONS(6587),
    [anon_sym_long] = ACTIONS(6587),
    [anon_sym_short] = ACTIONS(6587),
    [sym_primitive_type] = ACTIONS(659),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [sym_identifier] = ACTIONS(933),
    [sym_comment] = ACTIONS(91),
  },
  [2414] = {
    [sym_type_qualifier] = STATE(2414),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2414),
    [anon_sym_LPAREN2] = ACTIONS(5351),
    [anon_sym_LBRACK] = ACTIONS(5351),
    [anon_sym_const] = ACTIONS(5353),
    [anon_sym_restrict] = ACTIONS(5356),
    [anon_sym_volatile] = ACTIONS(5356),
    [anon_sym__Atomic] = ACTIONS(5356),
    [anon_sym_mutable] = ACTIONS(5356),
    [anon_sym_explicit] = ACTIONS(5356),
    [anon_sym_constexpr] = ACTIONS(5356),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [sym_comment] = ACTIONS(91),
    [sym_noexcept] = ACTIONS(6589),
  },
  [2415] = {
    [anon_sym_COMMA] = ACTIONS(6592),
    [anon_sym_RPAREN] = ACTIONS(6592),
    [anon_sym_SEMI] = ACTIONS(6592),
    [anon_sym_LBRACE] = ACTIONS(6592),
    [anon_sym_LPAREN2] = ACTIONS(6592),
    [anon_sym_LBRACK] = ACTIONS(6592),
    [anon_sym_EQ] = ACTIONS(6592),
    [anon_sym_const] = ACTIONS(6594),
    [anon_sym_restrict] = ACTIONS(6592),
    [anon_sym_volatile] = ACTIONS(6592),
    [anon_sym__Atomic] = ACTIONS(6592),
    [anon_sym_mutable] = ACTIONS(6592),
    [anon_sym_explicit] = ACTIONS(6592),
    [anon_sym_constexpr] = ACTIONS(6592),
    [anon_sym_COLON] = ACTIONS(6592),
    [anon_sym_DASH_GT] = ACTIONS(6592),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(6592),
    [anon_sym_override] = ACTIONS(6592),
    [anon_sym_GT2] = ACTIONS(6592),
    [sym_noexcept] = ACTIONS(6592),
  },
  [2416] = {
    [sym__expression] = STATE(146),
    [sym_conditional_expression] = STATE(146),
    [sym_assignment_expression] = STATE(146),
    [sym_pointer_expression] = STATE(146),
    [sym_logical_expression] = STATE(146),
    [sym_bitwise_expression] = STATE(146),
    [sym_equality_expression] = STATE(146),
    [sym_relational_expression] = STATE(146),
    [sym_shift_expression] = STATE(146),
    [sym_math_expression] = STATE(146),
    [sym_cast_expression] = STATE(146),
    [sym_sizeof_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_compound_literal_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_char_literal] = STATE(146),
    [sym_concatenated_string] = STATE(146),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(146),
    [sym_new_expression] = STATE(146),
    [sym_delete_expression] = STATE(146),
    [sym_lambda_expression] = STATE(146),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(257),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(6596),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(257),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(259),
    [sym_false] = ACTIONS(259),
    [sym_null] = ACTIONS(259),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(259),
  },
  [2417] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(6596),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_STAR_EQ] = ACTIONS(3507),
    [anon_sym_SLASH_EQ] = ACTIONS(3507),
    [anon_sym_PERCENT_EQ] = ACTIONS(3507),
    [anon_sym_PLUS_EQ] = ACTIONS(3507),
    [anon_sym_DASH_EQ] = ACTIONS(3507),
    [anon_sym_LT_LT_EQ] = ACTIONS(3507),
    [anon_sym_GT_GT_EQ] = ACTIONS(3507),
    [anon_sym_AMP_EQ] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(3507),
    [anon_sym_PIPE_EQ] = ACTIONS(3507),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_CARET] = ACTIONS(3517),
    [anon_sym_EQ_EQ] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3521),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3525),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2418] = {
    [anon_sym_COMMA] = ACTIONS(6598),
    [anon_sym_RPAREN] = ACTIONS(6598),
    [anon_sym_SEMI] = ACTIONS(6598),
    [anon_sym_LBRACE] = ACTIONS(6598),
    [anon_sym_LPAREN2] = ACTIONS(6598),
    [anon_sym_LBRACK] = ACTIONS(6598),
    [anon_sym_EQ] = ACTIONS(6598),
    [anon_sym_const] = ACTIONS(6600),
    [anon_sym_restrict] = ACTIONS(6598),
    [anon_sym_volatile] = ACTIONS(6598),
    [anon_sym__Atomic] = ACTIONS(6598),
    [anon_sym_mutable] = ACTIONS(6598),
    [anon_sym_explicit] = ACTIONS(6598),
    [anon_sym_constexpr] = ACTIONS(6598),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_DASH_GT] = ACTIONS(6598),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(6598),
    [anon_sym_override] = ACTIONS(6598),
    [anon_sym_GT2] = ACTIONS(6598),
    [sym_noexcept] = ACTIONS(6598),
  },
  [2419] = {
    [sym_enumerator_list] = STATE(583),
    [anon_sym_COMMA] = ACTIONS(1011),
    [anon_sym_RPAREN] = ACTIONS(1011),
    [anon_sym_SEMI] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_LPAREN2] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(1011),
    [anon_sym_LBRACK] = ACTIONS(1011),
    [anon_sym_EQ] = ACTIONS(1011),
    [anon_sym_const] = ACTIONS(1013),
    [anon_sym_restrict] = ACTIONS(1011),
    [anon_sym_volatile] = ACTIONS(1011),
    [anon_sym__Atomic] = ACTIONS(1011),
    [anon_sym_mutable] = ACTIONS(1011),
    [anon_sym_explicit] = ACTIONS(1011),
    [anon_sym_constexpr] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1013),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_DASH_GT] = ACTIONS(1011),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1011),
    [anon_sym_override] = ACTIONS(1011),
    [anon_sym_GT2] = ACTIONS(1011),
    [sym_noexcept] = ACTIONS(1011),
  },
  [2420] = {
    [sym_field_declaration_list] = STATE(612),
    [sym_virtual_specifier] = STATE(613),
    [sym_base_class_clause] = STATE(614),
    [sym_template_argument_list] = STATE(437),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_LPAREN2] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(643),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [anon_sym_COLON_COLON] = ACTIONS(758),
  },
  [2421] = {
    [sym_field_declaration_list] = STATE(617),
    [sym_virtual_specifier] = STATE(620),
    [sym_base_class_clause] = STATE(618),
    [anon_sym_LBRACE] = ACTIONS(1069),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1069),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1069),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [anon_sym_COLON_COLON] = ACTIONS(772),
  },
  [2422] = {
    [sym_field_declaration_list] = STATE(617),
    [sym_virtual_specifier] = STATE(620),
    [sym_base_class_clause] = STATE(618),
    [sym_template_argument_list] = STATE(362),
    [anon_sym_LBRACE] = ACTIONS(1069),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1069),
    [anon_sym_COLON] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1069),
    [anon_sym_LT] = ACTIONS(643),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
  },
  [2423] = {
    [sym_field_declaration_list] = STATE(621),
    [sym_virtual_specifier] = STATE(622),
    [sym_base_class_clause] = STATE(623),
    [sym_template_argument_list] = STATE(437),
    [anon_sym_LBRACE] = ACTIONS(1077),
    [anon_sym_LPAREN2] = ACTIONS(1077),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_LBRACK] = ACTIONS(1077),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_LT] = ACTIONS(643),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [anon_sym_COLON_COLON] = ACTIONS(758),
  },
  [2424] = {
    [sym_field_declaration_list] = STATE(624),
    [sym_virtual_specifier] = STATE(626),
    [sym_base_class_clause] = STATE(625),
    [anon_sym_LBRACE] = ACTIONS(1081),
    [anon_sym_LPAREN2] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1081),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [anon_sym_COLON_COLON] = ACTIONS(772),
  },
  [2425] = {
    [sym_field_declaration_list] = STATE(624),
    [sym_virtual_specifier] = STATE(626),
    [sym_base_class_clause] = STATE(625),
    [sym_template_argument_list] = STATE(362),
    [anon_sym_LBRACE] = ACTIONS(1081),
    [anon_sym_LPAREN2] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1081),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_COLON] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(643),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
  },
  [2426] = {
    [sym_field_declaration_list] = STATE(790),
    [sym_virtual_specifier] = STATE(791),
    [sym_base_class_clause] = STATE(792),
    [sym_template_argument_list] = STATE(437),
    [anon_sym_LBRACE] = ACTIONS(1438),
    [anon_sym_LPAREN2] = ACTIONS(1438),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_LBRACK] = ACTIONS(1438),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_AMP_AMP] = ACTIONS(1438),
    [anon_sym_LT] = ACTIONS(643),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [anon_sym_COLON_COLON] = ACTIONS(758),
  },
  [2427] = {
    [sym_field_declaration_list] = STATE(793),
    [sym_virtual_specifier] = STATE(795),
    [sym_base_class_clause] = STATE(794),
    [anon_sym_LBRACE] = ACTIONS(1442),
    [anon_sym_LPAREN2] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(1442),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1442),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [anon_sym_COLON_COLON] = ACTIONS(772),
  },
  [2428] = {
    [sym_field_declaration_list] = STATE(793),
    [sym_virtual_specifier] = STATE(795),
    [sym_base_class_clause] = STATE(794),
    [sym_template_argument_list] = STATE(362),
    [anon_sym_LBRACE] = ACTIONS(1442),
    [anon_sym_LPAREN2] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(1442),
    [anon_sym_COLON] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1442),
    [anon_sym_LT] = ACTIONS(643),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
  },
  [2429] = {
    [sym__abstract_declarator] = STATE(2922),
    [sym_abstract_pointer_declarator] = STATE(2922),
    [sym_abstract_function_declarator] = STATE(2922),
    [sym_abstract_array_declarator] = STATE(2922),
    [sym_type_qualifier] = STATE(2923),
    [sym_parameter_list] = STATE(359),
    [sym_abstract_reference_declarator] = STATE(2922),
    [aux_sym_type_definition_repeat1] = STATE(2923),
    [anon_sym_LBRACE] = ACTIONS(2461),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(5343),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5347),
    [sym_comment] = ACTIONS(91),
  },
  [2430] = {
    [sym__abstract_declarator] = STATE(2924),
    [sym_abstract_pointer_declarator] = STATE(2924),
    [sym_abstract_function_declarator] = STATE(2924),
    [sym_abstract_array_declarator] = STATE(2924),
    [sym_parameter_list] = STATE(359),
    [sym_abstract_reference_declarator] = STATE(2924),
    [anon_sym_LBRACE] = ACTIONS(2463),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(5343),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_AMP] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5347),
    [sym_comment] = ACTIONS(91),
  },
  [2431] = {
    [sym_parameter_list] = STATE(968),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [sym_comment] = ACTIONS(91),
  },
  [2432] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2432),
    [anon_sym_LBRACE] = ACTIONS(1985),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1985),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_unsigned] = ACTIONS(6602),
    [anon_sym_long] = ACTIONS(6602),
    [anon_sym_short] = ACTIONS(6602),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [sym_comment] = ACTIONS(91),
  },
  [2433] = {
    [anon_sym_COMMA] = ACTIONS(6284),
    [anon_sym_RPAREN] = ACTIONS(6284),
    [anon_sym_SEMI] = ACTIONS(6284),
    [anon_sym_extern] = ACTIONS(6286),
    [anon_sym_LBRACE] = ACTIONS(6284),
    [anon_sym_LPAREN2] = ACTIONS(6284),
    [anon_sym_STAR] = ACTIONS(6284),
    [anon_sym_LBRACK] = ACTIONS(6284),
    [anon_sym_EQ] = ACTIONS(6284),
    [anon_sym_static] = ACTIONS(6286),
    [anon_sym_register] = ACTIONS(6286),
    [anon_sym_inline] = ACTIONS(6286),
    [anon_sym_const] = ACTIONS(6286),
    [anon_sym_restrict] = ACTIONS(6286),
    [anon_sym_volatile] = ACTIONS(6286),
    [anon_sym__Atomic] = ACTIONS(6286),
    [anon_sym_mutable] = ACTIONS(6286),
    [anon_sym_explicit] = ACTIONS(6286),
    [anon_sym_constexpr] = ACTIONS(6286),
    [anon_sym_COLON] = ACTIONS(6286),
    [anon_sym_AMP] = ACTIONS(6286),
    [anon_sym_AMP_AMP] = ACTIONS(6284),
    [anon_sym_TILDE] = ACTIONS(6284),
    [anon_sym_DASH_GT] = ACTIONS(6284),
    [sym_identifier] = ACTIONS(6286),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(6286),
    [anon_sym_override] = ACTIONS(6286),
    [anon_sym_GT2] = ACTIONS(6284),
    [sym_noexcept] = ACTIONS(6286),
    [anon_sym_COLON_COLON] = ACTIONS(6284),
    [sym_operator_name] = ACTIONS(6284),
  },
  [2434] = {
    [anon_sym_COMMA] = ACTIONS(6291),
    [anon_sym_RPAREN] = ACTIONS(6291),
    [anon_sym_SEMI] = ACTIONS(6291),
    [anon_sym_extern] = ACTIONS(6293),
    [anon_sym_LBRACE] = ACTIONS(6291),
    [anon_sym_LPAREN2] = ACTIONS(6291),
    [anon_sym_STAR] = ACTIONS(6291),
    [anon_sym_LBRACK] = ACTIONS(6291),
    [anon_sym_EQ] = ACTIONS(6291),
    [anon_sym_static] = ACTIONS(6293),
    [anon_sym_register] = ACTIONS(6293),
    [anon_sym_inline] = ACTIONS(6293),
    [anon_sym_const] = ACTIONS(6293),
    [anon_sym_restrict] = ACTIONS(6293),
    [anon_sym_volatile] = ACTIONS(6293),
    [anon_sym__Atomic] = ACTIONS(6293),
    [anon_sym_mutable] = ACTIONS(6293),
    [anon_sym_explicit] = ACTIONS(6293),
    [anon_sym_constexpr] = ACTIONS(6293),
    [anon_sym_COLON] = ACTIONS(6293),
    [anon_sym_AMP] = ACTIONS(6293),
    [anon_sym_AMP_AMP] = ACTIONS(6291),
    [anon_sym_TILDE] = ACTIONS(6291),
    [anon_sym_DASH_GT] = ACTIONS(6291),
    [sym_identifier] = ACTIONS(6293),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(6293),
    [anon_sym_override] = ACTIONS(6293),
    [anon_sym_GT2] = ACTIONS(6291),
    [sym_noexcept] = ACTIONS(6293),
    [anon_sym_COLON_COLON] = ACTIONS(6291),
    [sym_operator_name] = ACTIONS(6291),
  },
  [2435] = {
    [anon_sym_COMMA] = ACTIONS(6605),
    [anon_sym_RPAREN] = ACTIONS(6605),
    [sym_comment] = ACTIONS(91),
  },
  [2436] = {
    [anon_sym_LF] = ACTIONS(6607),
    [sym_preproc_arg] = ACTIONS(6607),
    [sym_comment] = ACTIONS(121),
  },
  [2437] = {
    [aux_sym_preproc_params_repeat1] = STATE(2437),
    [anon_sym_COMMA] = ACTIONS(6609),
    [anon_sym_RPAREN] = ACTIONS(6605),
    [sym_comment] = ACTIONS(91),
  },
  [2438] = {
    [sym_raw_string_literal] = ACTIONS(3063),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3065),
    [sym_preproc_directive] = ACTIONS(3065),
    [anon_sym_SEMI] = ACTIONS(3063),
    [anon_sym_typedef] = ACTIONS(3065),
    [anon_sym_extern] = ACTIONS(3065),
    [anon_sym_LBRACE] = ACTIONS(3063),
    [anon_sym_LPAREN2] = ACTIONS(3063),
    [anon_sym_STAR] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_static] = ACTIONS(3065),
    [anon_sym_register] = ACTIONS(3065),
    [anon_sym_inline] = ACTIONS(3065),
    [anon_sym_const] = ACTIONS(3065),
    [anon_sym_restrict] = ACTIONS(3065),
    [anon_sym_volatile] = ACTIONS(3065),
    [anon_sym__Atomic] = ACTIONS(3065),
    [anon_sym_mutable] = ACTIONS(3065),
    [anon_sym_explicit] = ACTIONS(3065),
    [anon_sym_constexpr] = ACTIONS(3065),
    [anon_sym_unsigned] = ACTIONS(3065),
    [anon_sym_long] = ACTIONS(3065),
    [anon_sym_short] = ACTIONS(3065),
    [sym_primitive_type] = ACTIONS(3065),
    [anon_sym_enum] = ACTIONS(3065),
    [anon_sym_struct] = ACTIONS(3065),
    [anon_sym_union] = ACTIONS(3065),
    [anon_sym_if] = ACTIONS(3065),
    [anon_sym_switch] = ACTIONS(3065),
    [anon_sym_case] = ACTIONS(3065),
    [anon_sym_default] = ACTIONS(3065),
    [anon_sym_while] = ACTIONS(3065),
    [anon_sym_do] = ACTIONS(3065),
    [anon_sym_for] = ACTIONS(3065),
    [anon_sym_return] = ACTIONS(3065),
    [anon_sym_break] = ACTIONS(3065),
    [anon_sym_continue] = ACTIONS(3065),
    [anon_sym_goto] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3065),
    [anon_sym_AMP_AMP] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3063),
    [anon_sym_TILDE] = ACTIONS(3063),
    [anon_sym_PLUS] = ACTIONS(3065),
    [anon_sym_DASH] = ACTIONS(3065),
    [anon_sym_DASH_DASH] = ACTIONS(3063),
    [anon_sym_PLUS_PLUS] = ACTIONS(3063),
    [anon_sym_sizeof] = ACTIONS(3065),
    [sym_number_literal] = ACTIONS(3063),
    [anon_sym_SQUOTE] = ACTIONS(3063),
    [anon_sym_DQUOTE] = ACTIONS(3063),
    [sym_true] = ACTIONS(3065),
    [sym_false] = ACTIONS(3065),
    [sym_null] = ACTIONS(3065),
    [sym_identifier] = ACTIONS(3065),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3065),
    [sym_auto] = ACTIONS(3065),
    [anon_sym_typename] = ACTIONS(3065),
    [anon_sym_template] = ACTIONS(3065),
    [anon_sym_delete] = ACTIONS(3065),
    [anon_sym_namespace] = ACTIONS(3065),
    [anon_sym_using] = ACTIONS(3065),
    [anon_sym_try] = ACTIONS(3065),
    [anon_sym_new] = ACTIONS(3065),
    [anon_sym_COLON_COLON] = ACTIONS(3063),
    [sym_operator_name] = ACTIONS(3063),
    [sym_nullptr] = ACTIONS(3065),
  },
  [2439] = {
    [sym_raw_string_literal] = ACTIONS(3707),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3709),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3709),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3709),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3709),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3709),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3709),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3709),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3709),
    [sym_preproc_directive] = ACTIONS(3709),
    [anon_sym_SEMI] = ACTIONS(3707),
    [anon_sym_typedef] = ACTIONS(3709),
    [anon_sym_extern] = ACTIONS(3709),
    [anon_sym_LBRACE] = ACTIONS(3707),
    [anon_sym_LPAREN2] = ACTIONS(3707),
    [anon_sym_STAR] = ACTIONS(3707),
    [anon_sym_LBRACK] = ACTIONS(3707),
    [anon_sym_static] = ACTIONS(3709),
    [anon_sym_register] = ACTIONS(3709),
    [anon_sym_inline] = ACTIONS(3709),
    [anon_sym_const] = ACTIONS(3709),
    [anon_sym_restrict] = ACTIONS(3709),
    [anon_sym_volatile] = ACTIONS(3709),
    [anon_sym__Atomic] = ACTIONS(3709),
    [anon_sym_mutable] = ACTIONS(3709),
    [anon_sym_explicit] = ACTIONS(3709),
    [anon_sym_constexpr] = ACTIONS(3709),
    [anon_sym_unsigned] = ACTIONS(3709),
    [anon_sym_long] = ACTIONS(3709),
    [anon_sym_short] = ACTIONS(3709),
    [sym_primitive_type] = ACTIONS(3709),
    [anon_sym_enum] = ACTIONS(3709),
    [anon_sym_struct] = ACTIONS(3709),
    [anon_sym_union] = ACTIONS(3709),
    [anon_sym_if] = ACTIONS(3709),
    [anon_sym_switch] = ACTIONS(3709),
    [anon_sym_case] = ACTIONS(3709),
    [anon_sym_default] = ACTIONS(3709),
    [anon_sym_while] = ACTIONS(3709),
    [anon_sym_do] = ACTIONS(3709),
    [anon_sym_for] = ACTIONS(3709),
    [anon_sym_return] = ACTIONS(3709),
    [anon_sym_break] = ACTIONS(3709),
    [anon_sym_continue] = ACTIONS(3709),
    [anon_sym_goto] = ACTIONS(3709),
    [anon_sym_AMP] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3707),
    [anon_sym_BANG] = ACTIONS(3707),
    [anon_sym_TILDE] = ACTIONS(3707),
    [anon_sym_PLUS] = ACTIONS(3709),
    [anon_sym_DASH] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3707),
    [anon_sym_PLUS_PLUS] = ACTIONS(3707),
    [anon_sym_sizeof] = ACTIONS(3709),
    [sym_number_literal] = ACTIONS(3707),
    [anon_sym_SQUOTE] = ACTIONS(3707),
    [anon_sym_DQUOTE] = ACTIONS(3707),
    [sym_true] = ACTIONS(3709),
    [sym_false] = ACTIONS(3709),
    [sym_null] = ACTIONS(3709),
    [sym_identifier] = ACTIONS(3709),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3709),
    [sym_auto] = ACTIONS(3709),
    [anon_sym_typename] = ACTIONS(3709),
    [anon_sym_template] = ACTIONS(3709),
    [anon_sym_delete] = ACTIONS(3709),
    [anon_sym_namespace] = ACTIONS(3709),
    [anon_sym_using] = ACTIONS(3709),
    [anon_sym_try] = ACTIONS(3709),
    [anon_sym_new] = ACTIONS(3709),
    [anon_sym_COLON_COLON] = ACTIONS(3707),
    [sym_operator_name] = ACTIONS(3707),
    [sym_nullptr] = ACTIONS(3709),
  },
  [2440] = {
    [sym_raw_string_literal] = ACTIONS(3711),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3713),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3713),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3713),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3713),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3713),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3713),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3713),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3713),
    [sym_preproc_directive] = ACTIONS(3713),
    [anon_sym_SEMI] = ACTIONS(3711),
    [anon_sym_typedef] = ACTIONS(3713),
    [anon_sym_extern] = ACTIONS(3713),
    [anon_sym_LBRACE] = ACTIONS(3711),
    [anon_sym_LPAREN2] = ACTIONS(3711),
    [anon_sym_STAR] = ACTIONS(3711),
    [anon_sym_LBRACK] = ACTIONS(3711),
    [anon_sym_static] = ACTIONS(3713),
    [anon_sym_register] = ACTIONS(3713),
    [anon_sym_inline] = ACTIONS(3713),
    [anon_sym_const] = ACTIONS(3713),
    [anon_sym_restrict] = ACTIONS(3713),
    [anon_sym_volatile] = ACTIONS(3713),
    [anon_sym__Atomic] = ACTIONS(3713),
    [anon_sym_mutable] = ACTIONS(3713),
    [anon_sym_explicit] = ACTIONS(3713),
    [anon_sym_constexpr] = ACTIONS(3713),
    [anon_sym_unsigned] = ACTIONS(3713),
    [anon_sym_long] = ACTIONS(3713),
    [anon_sym_short] = ACTIONS(3713),
    [sym_primitive_type] = ACTIONS(3713),
    [anon_sym_enum] = ACTIONS(3713),
    [anon_sym_struct] = ACTIONS(3713),
    [anon_sym_union] = ACTIONS(3713),
    [anon_sym_if] = ACTIONS(3713),
    [anon_sym_switch] = ACTIONS(3713),
    [anon_sym_case] = ACTIONS(3713),
    [anon_sym_default] = ACTIONS(3713),
    [anon_sym_while] = ACTIONS(3713),
    [anon_sym_do] = ACTIONS(3713),
    [anon_sym_for] = ACTIONS(3713),
    [anon_sym_return] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3713),
    [anon_sym_continue] = ACTIONS(3713),
    [anon_sym_goto] = ACTIONS(3713),
    [anon_sym_AMP] = ACTIONS(3713),
    [anon_sym_AMP_AMP] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3711),
    [anon_sym_TILDE] = ACTIONS(3711),
    [anon_sym_PLUS] = ACTIONS(3713),
    [anon_sym_DASH] = ACTIONS(3713),
    [anon_sym_DASH_DASH] = ACTIONS(3711),
    [anon_sym_PLUS_PLUS] = ACTIONS(3711),
    [anon_sym_sizeof] = ACTIONS(3713),
    [sym_number_literal] = ACTIONS(3711),
    [anon_sym_SQUOTE] = ACTIONS(3711),
    [anon_sym_DQUOTE] = ACTIONS(3711),
    [sym_true] = ACTIONS(3713),
    [sym_false] = ACTIONS(3713),
    [sym_null] = ACTIONS(3713),
    [sym_identifier] = ACTIONS(3713),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3713),
    [sym_auto] = ACTIONS(3713),
    [anon_sym_typename] = ACTIONS(3713),
    [anon_sym_template] = ACTIONS(3713),
    [anon_sym_delete] = ACTIONS(3713),
    [anon_sym_namespace] = ACTIONS(3713),
    [anon_sym_using] = ACTIONS(3713),
    [anon_sym_try] = ACTIONS(3713),
    [anon_sym_new] = ACTIONS(3713),
    [anon_sym_COLON_COLON] = ACTIONS(3711),
    [sym_operator_name] = ACTIONS(3711),
    [sym_nullptr] = ACTIONS(3713),
  },
  [2441] = {
    [anon_sym_LF] = ACTIONS(6612),
    [sym_comment] = ACTIONS(121),
  },
  [2442] = {
    [sym_raw_string_literal] = ACTIONS(3839),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3841),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3841),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3841),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3841),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3841),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3841),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3841),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3841),
    [sym_preproc_directive] = ACTIONS(3841),
    [anon_sym_SEMI] = ACTIONS(3839),
    [anon_sym_typedef] = ACTIONS(3841),
    [anon_sym_extern] = ACTIONS(3841),
    [anon_sym_LBRACE] = ACTIONS(3839),
    [anon_sym_LPAREN2] = ACTIONS(3839),
    [anon_sym_STAR] = ACTIONS(3839),
    [anon_sym_LBRACK] = ACTIONS(3839),
    [anon_sym_static] = ACTIONS(3841),
    [anon_sym_register] = ACTIONS(3841),
    [anon_sym_inline] = ACTIONS(3841),
    [anon_sym_const] = ACTIONS(3841),
    [anon_sym_restrict] = ACTIONS(3841),
    [anon_sym_volatile] = ACTIONS(3841),
    [anon_sym__Atomic] = ACTIONS(3841),
    [anon_sym_mutable] = ACTIONS(3841),
    [anon_sym_explicit] = ACTIONS(3841),
    [anon_sym_constexpr] = ACTIONS(3841),
    [anon_sym_unsigned] = ACTIONS(3841),
    [anon_sym_long] = ACTIONS(3841),
    [anon_sym_short] = ACTIONS(3841),
    [sym_primitive_type] = ACTIONS(3841),
    [anon_sym_enum] = ACTIONS(3841),
    [anon_sym_struct] = ACTIONS(3841),
    [anon_sym_union] = ACTIONS(3841),
    [anon_sym_if] = ACTIONS(3841),
    [anon_sym_switch] = ACTIONS(3841),
    [anon_sym_case] = ACTIONS(3841),
    [anon_sym_default] = ACTIONS(3841),
    [anon_sym_while] = ACTIONS(3841),
    [anon_sym_do] = ACTIONS(3841),
    [anon_sym_for] = ACTIONS(3841),
    [anon_sym_return] = ACTIONS(3841),
    [anon_sym_break] = ACTIONS(3841),
    [anon_sym_continue] = ACTIONS(3841),
    [anon_sym_goto] = ACTIONS(3841),
    [anon_sym_AMP] = ACTIONS(3841),
    [anon_sym_AMP_AMP] = ACTIONS(3839),
    [anon_sym_BANG] = ACTIONS(3839),
    [anon_sym_TILDE] = ACTIONS(3839),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_DASH_DASH] = ACTIONS(3839),
    [anon_sym_PLUS_PLUS] = ACTIONS(3839),
    [anon_sym_sizeof] = ACTIONS(3841),
    [sym_number_literal] = ACTIONS(3839),
    [anon_sym_SQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(3839),
    [sym_true] = ACTIONS(3841),
    [sym_false] = ACTIONS(3841),
    [sym_null] = ACTIONS(3841),
    [sym_identifier] = ACTIONS(3841),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3841),
    [sym_auto] = ACTIONS(3841),
    [anon_sym_typename] = ACTIONS(3841),
    [anon_sym_template] = ACTIONS(3841),
    [anon_sym_delete] = ACTIONS(3841),
    [anon_sym_namespace] = ACTIONS(3841),
    [anon_sym_using] = ACTIONS(3841),
    [anon_sym_try] = ACTIONS(3841),
    [anon_sym_new] = ACTIONS(3841),
    [anon_sym_COLON_COLON] = ACTIONS(3839),
    [sym_operator_name] = ACTIONS(3839),
    [sym_nullptr] = ACTIONS(3841),
  },
  [2443] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6614),
    [sym_comment] = ACTIONS(91),
  },
  [2444] = {
    [sym_raw_string_literal] = ACTIONS(3938),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3940),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3940),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3940),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3940),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3940),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3940),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3940),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3940),
    [sym_preproc_directive] = ACTIONS(3940),
    [anon_sym_SEMI] = ACTIONS(3938),
    [anon_sym_typedef] = ACTIONS(3940),
    [anon_sym_extern] = ACTIONS(3940),
    [anon_sym_LBRACE] = ACTIONS(3938),
    [anon_sym_LPAREN2] = ACTIONS(3938),
    [anon_sym_STAR] = ACTIONS(3938),
    [anon_sym_LBRACK] = ACTIONS(3938),
    [anon_sym_static] = ACTIONS(3940),
    [anon_sym_register] = ACTIONS(3940),
    [anon_sym_inline] = ACTIONS(3940),
    [anon_sym_const] = ACTIONS(3940),
    [anon_sym_restrict] = ACTIONS(3940),
    [anon_sym_volatile] = ACTIONS(3940),
    [anon_sym__Atomic] = ACTIONS(3940),
    [anon_sym_mutable] = ACTIONS(3940),
    [anon_sym_explicit] = ACTIONS(3940),
    [anon_sym_constexpr] = ACTIONS(3940),
    [anon_sym_unsigned] = ACTIONS(3940),
    [anon_sym_long] = ACTIONS(3940),
    [anon_sym_short] = ACTIONS(3940),
    [sym_primitive_type] = ACTIONS(3940),
    [anon_sym_enum] = ACTIONS(3940),
    [anon_sym_struct] = ACTIONS(3940),
    [anon_sym_union] = ACTIONS(3940),
    [anon_sym_if] = ACTIONS(3940),
    [anon_sym_switch] = ACTIONS(3940),
    [anon_sym_case] = ACTIONS(3940),
    [anon_sym_default] = ACTIONS(3940),
    [anon_sym_while] = ACTIONS(3940),
    [anon_sym_do] = ACTIONS(3940),
    [anon_sym_for] = ACTIONS(3940),
    [anon_sym_return] = ACTIONS(3940),
    [anon_sym_break] = ACTIONS(3940),
    [anon_sym_continue] = ACTIONS(3940),
    [anon_sym_goto] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3940),
    [anon_sym_AMP_AMP] = ACTIONS(3938),
    [anon_sym_BANG] = ACTIONS(3938),
    [anon_sym_TILDE] = ACTIONS(3938),
    [anon_sym_PLUS] = ACTIONS(3940),
    [anon_sym_DASH] = ACTIONS(3940),
    [anon_sym_DASH_DASH] = ACTIONS(3938),
    [anon_sym_PLUS_PLUS] = ACTIONS(3938),
    [anon_sym_sizeof] = ACTIONS(3940),
    [sym_number_literal] = ACTIONS(3938),
    [anon_sym_SQUOTE] = ACTIONS(3938),
    [anon_sym_DQUOTE] = ACTIONS(3938),
    [sym_true] = ACTIONS(3940),
    [sym_false] = ACTIONS(3940),
    [sym_null] = ACTIONS(3940),
    [sym_identifier] = ACTIONS(3940),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3940),
    [sym_auto] = ACTIONS(3940),
    [anon_sym_typename] = ACTIONS(3940),
    [anon_sym_template] = ACTIONS(3940),
    [anon_sym_delete] = ACTIONS(3940),
    [anon_sym_namespace] = ACTIONS(3940),
    [anon_sym_using] = ACTIONS(3940),
    [anon_sym_try] = ACTIONS(3940),
    [anon_sym_new] = ACTIONS(3940),
    [anon_sym_COLON_COLON] = ACTIONS(3938),
    [sym_operator_name] = ACTIONS(3938),
    [sym_nullptr] = ACTIONS(3940),
  },
  [2445] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6616),
    [sym_comment] = ACTIONS(91),
  },
  [2446] = {
    [sym_raw_string_literal] = ACTIONS(1370),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1372),
    [sym_preproc_directive] = ACTIONS(1372),
    [anon_sym_SEMI] = ACTIONS(1370),
    [anon_sym_typedef] = ACTIONS(1372),
    [anon_sym_extern] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1370),
    [anon_sym_LPAREN2] = ACTIONS(1370),
    [anon_sym_STAR] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(1370),
    [anon_sym_static] = ACTIONS(1372),
    [anon_sym_register] = ACTIONS(1372),
    [anon_sym_inline] = ACTIONS(1372),
    [anon_sym_const] = ACTIONS(1372),
    [anon_sym_restrict] = ACTIONS(1372),
    [anon_sym_volatile] = ACTIONS(1372),
    [anon_sym__Atomic] = ACTIONS(1372),
    [anon_sym_mutable] = ACTIONS(1372),
    [anon_sym_explicit] = ACTIONS(1372),
    [anon_sym_constexpr] = ACTIONS(1372),
    [anon_sym_unsigned] = ACTIONS(1372),
    [anon_sym_long] = ACTIONS(1372),
    [anon_sym_short] = ACTIONS(1372),
    [sym_primitive_type] = ACTIONS(1372),
    [anon_sym_enum] = ACTIONS(1372),
    [anon_sym_struct] = ACTIONS(1372),
    [anon_sym_union] = ACTIONS(1372),
    [anon_sym_if] = ACTIONS(1372),
    [anon_sym_switch] = ACTIONS(1372),
    [anon_sym_case] = ACTIONS(1372),
    [anon_sym_default] = ACTIONS(1372),
    [anon_sym_while] = ACTIONS(1372),
    [anon_sym_do] = ACTIONS(1372),
    [anon_sym_for] = ACTIONS(1372),
    [anon_sym_return] = ACTIONS(1372),
    [anon_sym_break] = ACTIONS(1372),
    [anon_sym_continue] = ACTIONS(1372),
    [anon_sym_goto] = ACTIONS(1372),
    [anon_sym_AMP] = ACTIONS(1372),
    [anon_sym_AMP_AMP] = ACTIONS(1370),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_PLUS] = ACTIONS(1372),
    [anon_sym_DASH] = ACTIONS(1372),
    [anon_sym_DASH_DASH] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1370),
    [anon_sym_sizeof] = ACTIONS(1372),
    [sym_number_literal] = ACTIONS(1370),
    [anon_sym_SQUOTE] = ACTIONS(1370),
    [anon_sym_DQUOTE] = ACTIONS(1370),
    [sym_true] = ACTIONS(1372),
    [sym_false] = ACTIONS(1372),
    [sym_null] = ACTIONS(1372),
    [sym_identifier] = ACTIONS(1372),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1372),
    [sym_auto] = ACTIONS(1372),
    [anon_sym_typename] = ACTIONS(1372),
    [anon_sym_template] = ACTIONS(1372),
    [anon_sym_delete] = ACTIONS(1372),
    [anon_sym_namespace] = ACTIONS(1372),
    [anon_sym_using] = ACTIONS(1372),
    [anon_sym_try] = ACTIONS(1372),
    [anon_sym_new] = ACTIONS(1372),
    [anon_sym_COLON_COLON] = ACTIONS(1370),
    [sym_operator_name] = ACTIONS(1370),
    [sym_nullptr] = ACTIONS(1372),
  },
  [2447] = {
    [aux_sym_string_literal_repeat1] = STATE(761),
    [anon_sym_DQUOTE] = ACTIONS(6618),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_BSLASHn_RBRACK_SLASH] = ACTIONS(1376),
    [sym_escape_sequence] = ACTIONS(1376),
    [sym_comment] = ACTIONS(121),
  },
  [2448] = {
    [sym_raw_string_literal] = ACTIONS(1994),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1996),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1996),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1996),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1996),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1996),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1996),
    [sym_preproc_directive] = ACTIONS(1996),
    [anon_sym_SEMI] = ACTIONS(1994),
    [anon_sym_typedef] = ACTIONS(1996),
    [anon_sym_extern] = ACTIONS(1996),
    [anon_sym_LBRACE] = ACTIONS(1994),
    [anon_sym_LPAREN2] = ACTIONS(1994),
    [anon_sym_STAR] = ACTIONS(1994),
    [anon_sym_LBRACK] = ACTIONS(1994),
    [anon_sym_static] = ACTIONS(1996),
    [anon_sym_register] = ACTIONS(1996),
    [anon_sym_inline] = ACTIONS(1996),
    [anon_sym_const] = ACTIONS(1996),
    [anon_sym_restrict] = ACTIONS(1996),
    [anon_sym_volatile] = ACTIONS(1996),
    [anon_sym__Atomic] = ACTIONS(1996),
    [anon_sym_mutable] = ACTIONS(1996),
    [anon_sym_explicit] = ACTIONS(1996),
    [anon_sym_constexpr] = ACTIONS(1996),
    [anon_sym_unsigned] = ACTIONS(1996),
    [anon_sym_long] = ACTIONS(1996),
    [anon_sym_short] = ACTIONS(1996),
    [sym_primitive_type] = ACTIONS(1996),
    [anon_sym_enum] = ACTIONS(1996),
    [anon_sym_struct] = ACTIONS(1996),
    [anon_sym_union] = ACTIONS(1996),
    [anon_sym_if] = ACTIONS(1996),
    [anon_sym_switch] = ACTIONS(1996),
    [anon_sym_case] = ACTIONS(1996),
    [anon_sym_default] = ACTIONS(1996),
    [anon_sym_while] = ACTIONS(1996),
    [anon_sym_do] = ACTIONS(1996),
    [anon_sym_for] = ACTIONS(1996),
    [anon_sym_return] = ACTIONS(1996),
    [anon_sym_break] = ACTIONS(1996),
    [anon_sym_continue] = ACTIONS(1996),
    [anon_sym_goto] = ACTIONS(1996),
    [anon_sym_AMP] = ACTIONS(1996),
    [anon_sym_AMP_AMP] = ACTIONS(1994),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_PLUS] = ACTIONS(1996),
    [anon_sym_DASH] = ACTIONS(1996),
    [anon_sym_DASH_DASH] = ACTIONS(1994),
    [anon_sym_PLUS_PLUS] = ACTIONS(1994),
    [anon_sym_sizeof] = ACTIONS(1996),
    [sym_number_literal] = ACTIONS(1994),
    [anon_sym_SQUOTE] = ACTIONS(1994),
    [anon_sym_DQUOTE] = ACTIONS(1994),
    [sym_true] = ACTIONS(1996),
    [sym_false] = ACTIONS(1996),
    [sym_null] = ACTIONS(1996),
    [sym_identifier] = ACTIONS(1996),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1996),
    [sym_auto] = ACTIONS(1996),
    [anon_sym_typename] = ACTIONS(1996),
    [anon_sym_template] = ACTIONS(1996),
    [anon_sym_delete] = ACTIONS(1996),
    [anon_sym_namespace] = ACTIONS(1996),
    [anon_sym_using] = ACTIONS(1996),
    [anon_sym_try] = ACTIONS(1996),
    [anon_sym_new] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1994),
    [sym_operator_name] = ACTIONS(1994),
    [sym_nullptr] = ACTIONS(1996),
  },
  [2449] = {
    [anon_sym_LF] = ACTIONS(6620),
    [sym_comment] = ACTIONS(121),
  },
  [2450] = {
    [anon_sym_LF] = ACTIONS(6622),
    [sym_preproc_arg] = ACTIONS(6624),
    [sym_comment] = ACTIONS(121),
  },
  [2451] = {
    [sym_raw_string_literal] = ACTIONS(2016),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2018),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2018),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2018),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2018),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2018),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2018),
    [sym_preproc_directive] = ACTIONS(2018),
    [anon_sym_SEMI] = ACTIONS(2016),
    [anon_sym_typedef] = ACTIONS(2018),
    [anon_sym_extern] = ACTIONS(2018),
    [anon_sym_LBRACE] = ACTIONS(2016),
    [anon_sym_LPAREN2] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(2016),
    [anon_sym_LBRACK] = ACTIONS(2016),
    [anon_sym_static] = ACTIONS(2018),
    [anon_sym_register] = ACTIONS(2018),
    [anon_sym_inline] = ACTIONS(2018),
    [anon_sym_const] = ACTIONS(2018),
    [anon_sym_restrict] = ACTIONS(2018),
    [anon_sym_volatile] = ACTIONS(2018),
    [anon_sym__Atomic] = ACTIONS(2018),
    [anon_sym_mutable] = ACTIONS(2018),
    [anon_sym_explicit] = ACTIONS(2018),
    [anon_sym_constexpr] = ACTIONS(2018),
    [anon_sym_unsigned] = ACTIONS(2018),
    [anon_sym_long] = ACTIONS(2018),
    [anon_sym_short] = ACTIONS(2018),
    [sym_primitive_type] = ACTIONS(2018),
    [anon_sym_enum] = ACTIONS(2018),
    [anon_sym_struct] = ACTIONS(2018),
    [anon_sym_union] = ACTIONS(2018),
    [anon_sym_if] = ACTIONS(2018),
    [anon_sym_switch] = ACTIONS(2018),
    [anon_sym_case] = ACTIONS(2018),
    [anon_sym_default] = ACTIONS(2018),
    [anon_sym_while] = ACTIONS(2018),
    [anon_sym_do] = ACTIONS(2018),
    [anon_sym_for] = ACTIONS(2018),
    [anon_sym_return] = ACTIONS(2018),
    [anon_sym_break] = ACTIONS(2018),
    [anon_sym_continue] = ACTIONS(2018),
    [anon_sym_goto] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(2018),
    [anon_sym_AMP_AMP] = ACTIONS(2016),
    [anon_sym_BANG] = ACTIONS(2016),
    [anon_sym_TILDE] = ACTIONS(2016),
    [anon_sym_PLUS] = ACTIONS(2018),
    [anon_sym_DASH] = ACTIONS(2018),
    [anon_sym_DASH_DASH] = ACTIONS(2016),
    [anon_sym_PLUS_PLUS] = ACTIONS(2016),
    [anon_sym_sizeof] = ACTIONS(2018),
    [sym_number_literal] = ACTIONS(2016),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_DQUOTE] = ACTIONS(2016),
    [sym_true] = ACTIONS(2018),
    [sym_false] = ACTIONS(2018),
    [sym_null] = ACTIONS(2018),
    [sym_identifier] = ACTIONS(2018),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2018),
    [sym_auto] = ACTIONS(2018),
    [anon_sym_typename] = ACTIONS(2018),
    [anon_sym_template] = ACTIONS(2018),
    [anon_sym_delete] = ACTIONS(2018),
    [anon_sym_namespace] = ACTIONS(2018),
    [anon_sym_using] = ACTIONS(2018),
    [anon_sym_try] = ACTIONS(2018),
    [anon_sym_new] = ACTIONS(2018),
    [anon_sym_COLON_COLON] = ACTIONS(2016),
    [sym_operator_name] = ACTIONS(2016),
    [sym_nullptr] = ACTIONS(2018),
  },
  [2452] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6626),
    [sym_comment] = ACTIONS(91),
  },
  [2453] = {
    [sym_preproc_include] = STATE(1067),
    [sym_preproc_def] = STATE(1067),
    [sym_preproc_function_def] = STATE(1067),
    [sym_preproc_call] = STATE(1067),
    [sym_preproc_if] = STATE(1067),
    [sym_preproc_ifdef] = STATE(1067),
    [sym_preproc_else] = STATE(2933),
    [sym_preproc_elif] = STATE(2933),
    [sym_function_definition] = STATE(1067),
    [sym_declaration] = STATE(1067),
    [sym_type_definition] = STATE(1067),
    [sym__declaration_specifiers] = STATE(409),
    [sym_linkage_specification] = STATE(1067),
    [sym__declarator] = STATE(50),
    [sym_pointer_declarator] = STATE(50),
    [sym_function_declarator] = STATE(410),
    [sym_array_declarator] = STATE(50),
    [sym_compound_statement] = STATE(1067),
    [sym_storage_class_specifier] = STATE(414),
    [sym_type_qualifier] = STATE(414),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(1067),
    [sym_expression_statement] = STATE(1067),
    [sym_if_statement] = STATE(1067),
    [sym_switch_statement] = STATE(1067),
    [sym_case_statement] = STATE(1067),
    [sym_while_statement] = STATE(1067),
    [sym_do_statement] = STATE(1067),
    [sym_for_statement] = STATE(1067),
    [sym_return_statement] = STATE(1067),
    [sym_break_statement] = STATE(1067),
    [sym_continue_statement] = STATE(1067),
    [sym_goto_statement] = STATE(1067),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(1067),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(1067),
    [sym_template_declaration] = STATE(1067),
    [sym_template_instantiation] = STATE(1067),
    [sym_constructor_or_destructor_definition] = STATE(1067),
    [sym_reference_declarator] = STATE(50),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(57),
    [sym_namespace_definition] = STATE(1067),
    [sym_using_declaration] = STATE(1067),
    [sym_alias_declaration] = STATE(1067),
    [sym_for_range_loop] = STATE(1067),
    [sym_try_statement] = STATE(1067),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_destructor_name] = STATE(50),
    [sym_scoped_identifier] = STATE(59),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_translation_unit_repeat1] = STATE(1067),
    [aux_sym__declaration_specifiers_repeat1] = STATE(414),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(678),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(684),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6628),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(688),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(688),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(690),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(692),
    [sym_preproc_directive] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_typedef] = ACTIONS(698),
    [anon_sym_extern] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(704),
    [anon_sym_switch] = ACTIONS(706),
    [anon_sym_case] = ACTIONS(708),
    [anon_sym_default] = ACTIONS(710),
    [anon_sym_while] = ACTIONS(712),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(728),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_template] = ACTIONS(730),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_namespace] = ACTIONS(732),
    [anon_sym_using] = ACTIONS(734),
    [anon_sym_try] = ACTIONS(736),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_operator_name] = ACTIONS(111),
    [sym_nullptr] = ACTIONS(726),
  },
  [2454] = {
    [sym_raw_string_literal] = ACTIONS(2136),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2138),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2138),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2138),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2138),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2138),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2138),
    [sym_preproc_directive] = ACTIONS(2138),
    [anon_sym_SEMI] = ACTIONS(2136),
    [anon_sym_typedef] = ACTIONS(2138),
    [anon_sym_extern] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2136),
    [anon_sym_LPAREN2] = ACTIONS(2136),
    [anon_sym_STAR] = ACTIONS(2136),
    [anon_sym_LBRACK] = ACTIONS(2136),
    [anon_sym_static] = ACTIONS(2138),
    [anon_sym_register] = ACTIONS(2138),
    [anon_sym_inline] = ACTIONS(2138),
    [anon_sym_const] = ACTIONS(2138),
    [anon_sym_restrict] = ACTIONS(2138),
    [anon_sym_volatile] = ACTIONS(2138),
    [anon_sym__Atomic] = ACTIONS(2138),
    [anon_sym_mutable] = ACTIONS(2138),
    [anon_sym_explicit] = ACTIONS(2138),
    [anon_sym_constexpr] = ACTIONS(2138),
    [anon_sym_unsigned] = ACTIONS(2138),
    [anon_sym_long] = ACTIONS(2138),
    [anon_sym_short] = ACTIONS(2138),
    [sym_primitive_type] = ACTIONS(2138),
    [anon_sym_enum] = ACTIONS(2138),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2138),
    [anon_sym_if] = ACTIONS(2138),
    [anon_sym_switch] = ACTIONS(2138),
    [anon_sym_case] = ACTIONS(2138),
    [anon_sym_default] = ACTIONS(2138),
    [anon_sym_while] = ACTIONS(2138),
    [anon_sym_do] = ACTIONS(2138),
    [anon_sym_for] = ACTIONS(2138),
    [anon_sym_return] = ACTIONS(2138),
    [anon_sym_break] = ACTIONS(2138),
    [anon_sym_continue] = ACTIONS(2138),
    [anon_sym_goto] = ACTIONS(2138),
    [anon_sym_AMP] = ACTIONS(2138),
    [anon_sym_AMP_AMP] = ACTIONS(2136),
    [anon_sym_BANG] = ACTIONS(2136),
    [anon_sym_TILDE] = ACTIONS(2136),
    [anon_sym_PLUS] = ACTIONS(2138),
    [anon_sym_DASH] = ACTIONS(2138),
    [anon_sym_DASH_DASH] = ACTIONS(2136),
    [anon_sym_PLUS_PLUS] = ACTIONS(2136),
    [anon_sym_sizeof] = ACTIONS(2138),
    [sym_number_literal] = ACTIONS(2136),
    [anon_sym_SQUOTE] = ACTIONS(2136),
    [anon_sym_DQUOTE] = ACTIONS(2136),
    [sym_true] = ACTIONS(2138),
    [sym_false] = ACTIONS(2138),
    [sym_null] = ACTIONS(2138),
    [sym_identifier] = ACTIONS(2138),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2138),
    [sym_auto] = ACTIONS(2138),
    [anon_sym_typename] = ACTIONS(2138),
    [anon_sym_template] = ACTIONS(2138),
    [anon_sym_delete] = ACTIONS(2138),
    [anon_sym_namespace] = ACTIONS(2138),
    [anon_sym_using] = ACTIONS(2138),
    [anon_sym_try] = ACTIONS(2138),
    [anon_sym_new] = ACTIONS(2138),
    [anon_sym_COLON_COLON] = ACTIONS(2136),
    [sym_operator_name] = ACTIONS(2136),
    [sym_nullptr] = ACTIONS(2138),
  },
  [2455] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6630),
    [sym_comment] = ACTIONS(91),
  },
  [2456] = {
    [sym_preproc_include] = STATE(1067),
    [sym_preproc_def] = STATE(1067),
    [sym_preproc_function_def] = STATE(1067),
    [sym_preproc_call] = STATE(1067),
    [sym_preproc_if] = STATE(1067),
    [sym_preproc_ifdef] = STATE(1067),
    [sym_preproc_else] = STATE(2935),
    [sym_preproc_elif] = STATE(2935),
    [sym_function_definition] = STATE(1067),
    [sym_declaration] = STATE(1067),
    [sym_type_definition] = STATE(1067),
    [sym__declaration_specifiers] = STATE(409),
    [sym_linkage_specification] = STATE(1067),
    [sym__declarator] = STATE(50),
    [sym_pointer_declarator] = STATE(50),
    [sym_function_declarator] = STATE(410),
    [sym_array_declarator] = STATE(50),
    [sym_compound_statement] = STATE(1067),
    [sym_storage_class_specifier] = STATE(414),
    [sym_type_qualifier] = STATE(414),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(1067),
    [sym_expression_statement] = STATE(1067),
    [sym_if_statement] = STATE(1067),
    [sym_switch_statement] = STATE(1067),
    [sym_case_statement] = STATE(1067),
    [sym_while_statement] = STATE(1067),
    [sym_do_statement] = STATE(1067),
    [sym_for_statement] = STATE(1067),
    [sym_return_statement] = STATE(1067),
    [sym_break_statement] = STATE(1067),
    [sym_continue_statement] = STATE(1067),
    [sym_goto_statement] = STATE(1067),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(1067),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(1067),
    [sym_template_declaration] = STATE(1067),
    [sym_template_instantiation] = STATE(1067),
    [sym_constructor_or_destructor_definition] = STATE(1067),
    [sym_reference_declarator] = STATE(50),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(57),
    [sym_namespace_definition] = STATE(1067),
    [sym_using_declaration] = STATE(1067),
    [sym_alias_declaration] = STATE(1067),
    [sym_for_range_loop] = STATE(1067),
    [sym_try_statement] = STATE(1067),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_destructor_name] = STATE(50),
    [sym_scoped_identifier] = STATE(59),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_translation_unit_repeat1] = STATE(1067),
    [aux_sym__declaration_specifiers_repeat1] = STATE(414),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(678),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(680),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(682),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(684),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6632),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(688),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(688),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(690),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(692),
    [sym_preproc_directive] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_typedef] = ACTIONS(698),
    [anon_sym_extern] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(704),
    [anon_sym_switch] = ACTIONS(706),
    [anon_sym_case] = ACTIONS(708),
    [anon_sym_default] = ACTIONS(710),
    [anon_sym_while] = ACTIONS(712),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(728),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_template] = ACTIONS(730),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_namespace] = ACTIONS(732),
    [anon_sym_using] = ACTIONS(734),
    [anon_sym_try] = ACTIONS(736),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_operator_name] = ACTIONS(111),
    [sym_nullptr] = ACTIONS(726),
  },
  [2457] = {
    [sym_raw_string_literal] = ACTIONS(2144),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2146),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2146),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2146),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2146),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2146),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2146),
    [sym_preproc_directive] = ACTIONS(2146),
    [anon_sym_SEMI] = ACTIONS(2144),
    [anon_sym_typedef] = ACTIONS(2146),
    [anon_sym_extern] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(2144),
    [anon_sym_LPAREN2] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(2144),
    [anon_sym_LBRACK] = ACTIONS(2144),
    [anon_sym_static] = ACTIONS(2146),
    [anon_sym_register] = ACTIONS(2146),
    [anon_sym_inline] = ACTIONS(2146),
    [anon_sym_const] = ACTIONS(2146),
    [anon_sym_restrict] = ACTIONS(2146),
    [anon_sym_volatile] = ACTIONS(2146),
    [anon_sym__Atomic] = ACTIONS(2146),
    [anon_sym_mutable] = ACTIONS(2146),
    [anon_sym_explicit] = ACTIONS(2146),
    [anon_sym_constexpr] = ACTIONS(2146),
    [anon_sym_unsigned] = ACTIONS(2146),
    [anon_sym_long] = ACTIONS(2146),
    [anon_sym_short] = ACTIONS(2146),
    [sym_primitive_type] = ACTIONS(2146),
    [anon_sym_enum] = ACTIONS(2146),
    [anon_sym_struct] = ACTIONS(2146),
    [anon_sym_union] = ACTIONS(2146),
    [anon_sym_if] = ACTIONS(2146),
    [anon_sym_switch] = ACTIONS(2146),
    [anon_sym_case] = ACTIONS(2146),
    [anon_sym_default] = ACTIONS(2146),
    [anon_sym_while] = ACTIONS(2146),
    [anon_sym_do] = ACTIONS(2146),
    [anon_sym_for] = ACTIONS(2146),
    [anon_sym_return] = ACTIONS(2146),
    [anon_sym_break] = ACTIONS(2146),
    [anon_sym_continue] = ACTIONS(2146),
    [anon_sym_goto] = ACTIONS(2146),
    [anon_sym_AMP] = ACTIONS(2146),
    [anon_sym_AMP_AMP] = ACTIONS(2144),
    [anon_sym_BANG] = ACTIONS(2144),
    [anon_sym_TILDE] = ACTIONS(2144),
    [anon_sym_PLUS] = ACTIONS(2146),
    [anon_sym_DASH] = ACTIONS(2146),
    [anon_sym_DASH_DASH] = ACTIONS(2144),
    [anon_sym_PLUS_PLUS] = ACTIONS(2144),
    [anon_sym_sizeof] = ACTIONS(2146),
    [sym_number_literal] = ACTIONS(2144),
    [anon_sym_SQUOTE] = ACTIONS(2144),
    [anon_sym_DQUOTE] = ACTIONS(2144),
    [sym_true] = ACTIONS(2146),
    [sym_false] = ACTIONS(2146),
    [sym_null] = ACTIONS(2146),
    [sym_identifier] = ACTIONS(2146),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2146),
    [sym_auto] = ACTIONS(2146),
    [anon_sym_typename] = ACTIONS(2146),
    [anon_sym_template] = ACTIONS(2146),
    [anon_sym_delete] = ACTIONS(2146),
    [anon_sym_namespace] = ACTIONS(2146),
    [anon_sym_using] = ACTIONS(2146),
    [anon_sym_try] = ACTIONS(2146),
    [anon_sym_new] = ACTIONS(2146),
    [anon_sym_COLON_COLON] = ACTIONS(2144),
    [sym_operator_name] = ACTIONS(2144),
    [sym_nullptr] = ACTIONS(2146),
  },
  [2458] = {
    [sym_parameter_list] = STATE(1105),
    [anon_sym_SEMI] = ACTIONS(6634),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [sym_comment] = ACTIONS(91),
  },
  [2459] = {
    [sym__type_declarator] = STATE(2937),
    [sym_pointer_type_declarator] = STATE(2937),
    [sym_function_type_declarator] = STATE(2937),
    [sym_array_type_declarator] = STATE(2937),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_STAR] = ACTIONS(768),
    [sym_identifier] = ACTIONS(770),
    [sym_comment] = ACTIONS(91),
  },
  [2460] = {
    [sym_raw_string_literal] = ACTIONS(2184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2186),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2186),
    [sym_preproc_directive] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2184),
    [anon_sym_typedef] = ACTIONS(2186),
    [anon_sym_extern] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2184),
    [anon_sym_LPAREN2] = ACTIONS(2184),
    [anon_sym_STAR] = ACTIONS(2184),
    [anon_sym_LBRACK] = ACTIONS(2184),
    [anon_sym_static] = ACTIONS(2186),
    [anon_sym_register] = ACTIONS(2186),
    [anon_sym_inline] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_restrict] = ACTIONS(2186),
    [anon_sym_volatile] = ACTIONS(2186),
    [anon_sym__Atomic] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_explicit] = ACTIONS(2186),
    [anon_sym_constexpr] = ACTIONS(2186),
    [anon_sym_unsigned] = ACTIONS(2186),
    [anon_sym_long] = ACTIONS(2186),
    [anon_sym_short] = ACTIONS(2186),
    [sym_primitive_type] = ACTIONS(2186),
    [anon_sym_enum] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_union] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_switch] = ACTIONS(2186),
    [anon_sym_case] = ACTIONS(2186),
    [anon_sym_default] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [anon_sym_do] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_break] = ACTIONS(2186),
    [anon_sym_continue] = ACTIONS(2186),
    [anon_sym_goto] = ACTIONS(2186),
    [anon_sym_AMP] = ACTIONS(2186),
    [anon_sym_AMP_AMP] = ACTIONS(2184),
    [anon_sym_BANG] = ACTIONS(2184),
    [anon_sym_TILDE] = ACTIONS(2184),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_DASH] = ACTIONS(2186),
    [anon_sym_DASH_DASH] = ACTIONS(2184),
    [anon_sym_PLUS_PLUS] = ACTIONS(2184),
    [anon_sym_sizeof] = ACTIONS(2186),
    [sym_number_literal] = ACTIONS(2184),
    [anon_sym_SQUOTE] = ACTIONS(2184),
    [anon_sym_DQUOTE] = ACTIONS(2184),
    [sym_true] = ACTIONS(2186),
    [sym_false] = ACTIONS(2186),
    [sym_null] = ACTIONS(2186),
    [sym_identifier] = ACTIONS(2186),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2186),
    [sym_auto] = ACTIONS(2186),
    [anon_sym_typename] = ACTIONS(2186),
    [anon_sym_template] = ACTIONS(2186),
    [anon_sym_delete] = ACTIONS(2186),
    [anon_sym_namespace] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_new] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2184),
    [sym_operator_name] = ACTIONS(2184),
    [sym_nullptr] = ACTIONS(2186),
  },
  [2461] = {
    [sym__declarator] = STATE(1790),
    [sym_pointer_declarator] = STATE(1790),
    [sym_function_declarator] = STATE(1790),
    [sym_array_declarator] = STATE(1790),
    [sym_init_declarator] = STATE(1791),
    [sym_reference_declarator] = STATE(1790),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(1790),
    [sym_destructor_name] = STATE(1790),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(560),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(568),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(3785),
  },
  [2462] = {
    [sym_raw_string_literal] = ACTIONS(2286),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2288),
    [sym_preproc_directive] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym_typedef] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_STAR] = ACTIONS(2286),
    [anon_sym_LBRACK] = ACTIONS(2286),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_register] = ACTIONS(2288),
    [anon_sym_inline] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_explicit] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_unsigned] = ACTIONS(2288),
    [anon_sym_long] = ACTIONS(2288),
    [anon_sym_short] = ACTIONS(2288),
    [sym_primitive_type] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [anon_sym_struct] = ACTIONS(2288),
    [anon_sym_union] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_else] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_goto] = ACTIONS(2288),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_BANG] = ACTIONS(2286),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_sizeof] = ACTIONS(2288),
    [sym_number_literal] = ACTIONS(2286),
    [anon_sym_SQUOTE] = ACTIONS(2286),
    [anon_sym_DQUOTE] = ACTIONS(2286),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [sym_null] = ACTIONS(2288),
    [sym_identifier] = ACTIONS(2288),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2288),
    [sym_auto] = ACTIONS(2288),
    [anon_sym_typename] = ACTIONS(2288),
    [anon_sym_template] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_catch] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [sym_operator_name] = ACTIONS(2286),
    [sym_nullptr] = ACTIONS(2288),
  },
  [2463] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(6636),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2464] = {
    [sym__expression] = STATE(2939),
    [sym_conditional_expression] = STATE(2939),
    [sym_assignment_expression] = STATE(2939),
    [sym_pointer_expression] = STATE(2939),
    [sym_logical_expression] = STATE(2939),
    [sym_bitwise_expression] = STATE(2939),
    [sym_equality_expression] = STATE(2939),
    [sym_relational_expression] = STATE(2939),
    [sym_shift_expression] = STATE(2939),
    [sym_math_expression] = STATE(2939),
    [sym_cast_expression] = STATE(2939),
    [sym_sizeof_expression] = STATE(2939),
    [sym_subscript_expression] = STATE(2939),
    [sym_call_expression] = STATE(2939),
    [sym_field_expression] = STATE(2939),
    [sym_compound_literal_expression] = STATE(2939),
    [sym_parenthesized_expression] = STATE(2939),
    [sym_char_literal] = STATE(2939),
    [sym_concatenated_string] = STATE(2939),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2939),
    [sym_new_expression] = STATE(2939),
    [sym_delete_expression] = STATE(2939),
    [sym_lambda_expression] = STATE(2939),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6638),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(6638),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6640),
    [sym_false] = ACTIONS(6640),
    [sym_null] = ACTIONS(6640),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(6640),
  },
  [2465] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(548),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_COLON] = ACTIONS(3771),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(935),
  },
  [2466] = {
    [sym_raw_string_literal] = ACTIONS(2767),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2769),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2769),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2769),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2769),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2769),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2769),
    [sym_preproc_directive] = ACTIONS(2769),
    [anon_sym_SEMI] = ACTIONS(2767),
    [anon_sym_typedef] = ACTIONS(2769),
    [anon_sym_extern] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_LPAREN2] = ACTIONS(2767),
    [anon_sym_STAR] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(2767),
    [anon_sym_static] = ACTIONS(2769),
    [anon_sym_register] = ACTIONS(2769),
    [anon_sym_inline] = ACTIONS(2769),
    [anon_sym_const] = ACTIONS(2769),
    [anon_sym_restrict] = ACTIONS(2769),
    [anon_sym_volatile] = ACTIONS(2769),
    [anon_sym__Atomic] = ACTIONS(2769),
    [anon_sym_mutable] = ACTIONS(2769),
    [anon_sym_explicit] = ACTIONS(2769),
    [anon_sym_constexpr] = ACTIONS(2769),
    [anon_sym_unsigned] = ACTIONS(2769),
    [anon_sym_long] = ACTIONS(2769),
    [anon_sym_short] = ACTIONS(2769),
    [sym_primitive_type] = ACTIONS(2769),
    [anon_sym_enum] = ACTIONS(2769),
    [anon_sym_struct] = ACTIONS(2769),
    [anon_sym_union] = ACTIONS(2769),
    [anon_sym_if] = ACTIONS(2769),
    [anon_sym_else] = ACTIONS(2769),
    [anon_sym_switch] = ACTIONS(2769),
    [anon_sym_case] = ACTIONS(2769),
    [anon_sym_default] = ACTIONS(2769),
    [anon_sym_while] = ACTIONS(2769),
    [anon_sym_do] = ACTIONS(2769),
    [anon_sym_for] = ACTIONS(2769),
    [anon_sym_return] = ACTIONS(2769),
    [anon_sym_break] = ACTIONS(2769),
    [anon_sym_continue] = ACTIONS(2769),
    [anon_sym_goto] = ACTIONS(2769),
    [anon_sym_AMP] = ACTIONS(2769),
    [anon_sym_AMP_AMP] = ACTIONS(2767),
    [anon_sym_BANG] = ACTIONS(2767),
    [anon_sym_TILDE] = ACTIONS(2767),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_DASH_DASH] = ACTIONS(2767),
    [anon_sym_PLUS_PLUS] = ACTIONS(2767),
    [anon_sym_sizeof] = ACTIONS(2769),
    [sym_number_literal] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(2767),
    [anon_sym_DQUOTE] = ACTIONS(2767),
    [sym_true] = ACTIONS(2769),
    [sym_false] = ACTIONS(2769),
    [sym_null] = ACTIONS(2769),
    [sym_identifier] = ACTIONS(2769),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2769),
    [sym_auto] = ACTIONS(2769),
    [anon_sym_typename] = ACTIONS(2769),
    [anon_sym_template] = ACTIONS(2769),
    [anon_sym_delete] = ACTIONS(2769),
    [anon_sym_namespace] = ACTIONS(2769),
    [anon_sym_using] = ACTIONS(2769),
    [anon_sym_try] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2769),
    [anon_sym_COLON_COLON] = ACTIONS(2767),
    [sym_operator_name] = ACTIONS(2767),
    [sym_nullptr] = ACTIONS(2769),
  },
  [2467] = {
    [sym_declaration] = STATE(2940),
    [sym_type_definition] = STATE(2940),
    [sym__declaration_specifiers] = STATE(2470),
    [sym_compound_statement] = STATE(2940),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_labeled_statement] = STATE(2940),
    [sym_expression_statement] = STATE(2940),
    [sym_if_statement] = STATE(2940),
    [sym_switch_statement] = STATE(2940),
    [sym_case_statement] = STATE(2940),
    [sym_while_statement] = STATE(2940),
    [sym_do_statement] = STATE(2940),
    [sym_for_statement] = STATE(2940),
    [sym_return_statement] = STATE(2940),
    [sym_break_statement] = STATE(2940),
    [sym_continue_statement] = STATE(2940),
    [sym_goto_statement] = STATE(2940),
    [sym__expression] = STATE(1020),
    [sym_comma_expression] = STATE(1021),
    [sym_conditional_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1020),
    [sym_pointer_expression] = STATE(1020),
    [sym_logical_expression] = STATE(1020),
    [sym_bitwise_expression] = STATE(1020),
    [sym_equality_expression] = STATE(1020),
    [sym_relational_expression] = STATE(1020),
    [sym_shift_expression] = STATE(1020),
    [sym_math_expression] = STATE(1020),
    [sym_cast_expression] = STATE(1020),
    [sym_sizeof_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_field_expression] = STATE(1020),
    [sym_compound_literal_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_char_literal] = STATE(1020),
    [sym_concatenated_string] = STATE(1020),
    [sym_string_literal] = STATE(55),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(1020),
    [sym_for_range_loop] = STATE(2940),
    [sym_try_statement] = STATE(2940),
    [sym_new_expression] = STATE(1020),
    [sym_delete_expression] = STATE(1020),
    [sym_lambda_expression] = STATE(1020),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(2022),
    [anon_sym_SEMI] = ACTIONS(2036),
    [anon_sym_typedef] = ACTIONS(2038),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(2044),
    [anon_sym_switch] = ACTIONS(2046),
    [anon_sym_case] = ACTIONS(2048),
    [anon_sym_default] = ACTIONS(2050),
    [anon_sym_while] = ACTIONS(2052),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(2056),
    [anon_sym_return] = ACTIONS(2058),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2062),
    [anon_sym_goto] = ACTIONS(2064),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(5424),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2076),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(1202),
    [sym_nullptr] = ACTIONS(2066),
  },
  [2468] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(1362),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_extern] = ACTIONS(468),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(465),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_register] = ACTIONS(468),
    [anon_sym_inline] = ACTIONS(468),
    [anon_sym_const] = ACTIONS(468),
    [anon_sym_restrict] = ACTIONS(468),
    [anon_sym_volatile] = ACTIONS(468),
    [anon_sym__Atomic] = ACTIONS(468),
    [anon_sym_mutable] = ACTIONS(468),
    [anon_sym_explicit] = ACTIONS(468),
    [anon_sym_constexpr] = ACTIONS(468),
    [anon_sym_COLON] = ACTIONS(3771),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(474),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_TILDE] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_identifier] = ACTIONS(468),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(2855),
    [sym_operator_name] = ACTIONS(481),
  },
  [2469] = {
    [sym_raw_string_literal] = ACTIONS(2859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2861),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2861),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2861),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2861),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2861),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2861),
    [sym_preproc_directive] = ACTIONS(2861),
    [anon_sym_SEMI] = ACTIONS(2859),
    [anon_sym_typedef] = ACTIONS(2861),
    [anon_sym_extern] = ACTIONS(2861),
    [anon_sym_LBRACE] = ACTIONS(2859),
    [anon_sym_LPAREN2] = ACTIONS(2859),
    [anon_sym_STAR] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_static] = ACTIONS(2861),
    [anon_sym_register] = ACTIONS(2861),
    [anon_sym_inline] = ACTIONS(2861),
    [anon_sym_const] = ACTIONS(2861),
    [anon_sym_restrict] = ACTIONS(2861),
    [anon_sym_volatile] = ACTIONS(2861),
    [anon_sym__Atomic] = ACTIONS(2861),
    [anon_sym_mutable] = ACTIONS(2861),
    [anon_sym_explicit] = ACTIONS(2861),
    [anon_sym_constexpr] = ACTIONS(2861),
    [anon_sym_unsigned] = ACTIONS(2861),
    [anon_sym_long] = ACTIONS(2861),
    [anon_sym_short] = ACTIONS(2861),
    [sym_primitive_type] = ACTIONS(2861),
    [anon_sym_enum] = ACTIONS(2861),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2861),
    [anon_sym_if] = ACTIONS(2861),
    [anon_sym_else] = ACTIONS(2861),
    [anon_sym_switch] = ACTIONS(2861),
    [anon_sym_case] = ACTIONS(2861),
    [anon_sym_default] = ACTIONS(2861),
    [anon_sym_while] = ACTIONS(2861),
    [anon_sym_do] = ACTIONS(2861),
    [anon_sym_for] = ACTIONS(2861),
    [anon_sym_return] = ACTIONS(2861),
    [anon_sym_break] = ACTIONS(2861),
    [anon_sym_continue] = ACTIONS(2861),
    [anon_sym_goto] = ACTIONS(2861),
    [anon_sym_AMP] = ACTIONS(2861),
    [anon_sym_AMP_AMP] = ACTIONS(2859),
    [anon_sym_BANG] = ACTIONS(2859),
    [anon_sym_TILDE] = ACTIONS(2859),
    [anon_sym_PLUS] = ACTIONS(2861),
    [anon_sym_DASH] = ACTIONS(2861),
    [anon_sym_DASH_DASH] = ACTIONS(2859),
    [anon_sym_PLUS_PLUS] = ACTIONS(2859),
    [anon_sym_sizeof] = ACTIONS(2861),
    [sym_number_literal] = ACTIONS(2859),
    [anon_sym_SQUOTE] = ACTIONS(2859),
    [anon_sym_DQUOTE] = ACTIONS(2859),
    [sym_true] = ACTIONS(2861),
    [sym_false] = ACTIONS(2861),
    [sym_null] = ACTIONS(2861),
    [sym_identifier] = ACTIONS(2861),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2861),
    [sym_auto] = ACTIONS(2861),
    [anon_sym_typename] = ACTIONS(2861),
    [anon_sym_template] = ACTIONS(2861),
    [anon_sym_delete] = ACTIONS(2861),
    [anon_sym_namespace] = ACTIONS(2861),
    [anon_sym_using] = ACTIONS(2861),
    [anon_sym_try] = ACTIONS(2861),
    [anon_sym_new] = ACTIONS(2861),
    [anon_sym_COLON_COLON] = ACTIONS(2859),
    [sym_operator_name] = ACTIONS(2859),
    [sym_nullptr] = ACTIONS(2861),
  },
  [2470] = {
    [sym__declarator] = STATE(2941),
    [sym_pointer_declarator] = STATE(2941),
    [sym_function_declarator] = STATE(2941),
    [sym_array_declarator] = STATE(2941),
    [sym_init_declarator] = STATE(1791),
    [sym_reference_declarator] = STATE(2941),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(2941),
    [sym_destructor_name] = STATE(2941),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(560),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(568),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(6642),
  },
  [2471] = {
    [sym_raw_string_literal] = ACTIONS(2867),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2869),
    [sym_preproc_directive] = ACTIONS(2869),
    [anon_sym_SEMI] = ACTIONS(2867),
    [anon_sym_typedef] = ACTIONS(2869),
    [anon_sym_extern] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2867),
    [anon_sym_STAR] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_static] = ACTIONS(2869),
    [anon_sym_register] = ACTIONS(2869),
    [anon_sym_inline] = ACTIONS(2869),
    [anon_sym_const] = ACTIONS(2869),
    [anon_sym_restrict] = ACTIONS(2869),
    [anon_sym_volatile] = ACTIONS(2869),
    [anon_sym__Atomic] = ACTIONS(2869),
    [anon_sym_mutable] = ACTIONS(2869),
    [anon_sym_explicit] = ACTIONS(2869),
    [anon_sym_constexpr] = ACTIONS(2869),
    [anon_sym_unsigned] = ACTIONS(2869),
    [anon_sym_long] = ACTIONS(2869),
    [anon_sym_short] = ACTIONS(2869),
    [sym_primitive_type] = ACTIONS(2869),
    [anon_sym_enum] = ACTIONS(2869),
    [anon_sym_struct] = ACTIONS(2869),
    [anon_sym_union] = ACTIONS(2869),
    [anon_sym_if] = ACTIONS(2869),
    [anon_sym_else] = ACTIONS(2869),
    [anon_sym_switch] = ACTIONS(2869),
    [anon_sym_case] = ACTIONS(2869),
    [anon_sym_default] = ACTIONS(2869),
    [anon_sym_while] = ACTIONS(2869),
    [anon_sym_do] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2869),
    [anon_sym_return] = ACTIONS(2869),
    [anon_sym_break] = ACTIONS(2869),
    [anon_sym_continue] = ACTIONS(2869),
    [anon_sym_goto] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2869),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_BANG] = ACTIONS(2867),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2869),
    [anon_sym_DASH] = ACTIONS(2869),
    [anon_sym_DASH_DASH] = ACTIONS(2867),
    [anon_sym_PLUS_PLUS] = ACTIONS(2867),
    [anon_sym_sizeof] = ACTIONS(2869),
    [sym_number_literal] = ACTIONS(2867),
    [anon_sym_SQUOTE] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [sym_true] = ACTIONS(2869),
    [sym_false] = ACTIONS(2869),
    [sym_null] = ACTIONS(2869),
    [sym_identifier] = ACTIONS(2869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2869),
    [sym_auto] = ACTIONS(2869),
    [anon_sym_typename] = ACTIONS(2869),
    [anon_sym_template] = ACTIONS(2869),
    [anon_sym_delete] = ACTIONS(2869),
    [anon_sym_namespace] = ACTIONS(2869),
    [anon_sym_using] = ACTIONS(2869),
    [anon_sym_try] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_COLON_COLON] = ACTIONS(2867),
    [sym_operator_name] = ACTIONS(2867),
    [sym_nullptr] = ACTIONS(2869),
  },
  [2472] = {
    [sym_parenthesized_expression] = STATE(2943),
    [anon_sym_LPAREN2] = ACTIONS(6644),
    [sym_comment] = ACTIONS(91),
  },
  [2473] = {
    [sym__expression] = STATE(2945),
    [sym_conditional_expression] = STATE(2945),
    [sym_assignment_expression] = STATE(2945),
    [sym_pointer_expression] = STATE(2945),
    [sym_logical_expression] = STATE(2945),
    [sym_bitwise_expression] = STATE(2945),
    [sym_equality_expression] = STATE(2945),
    [sym_relational_expression] = STATE(2945),
    [sym_shift_expression] = STATE(2945),
    [sym_math_expression] = STATE(2945),
    [sym_cast_expression] = STATE(2945),
    [sym_sizeof_expression] = STATE(2945),
    [sym_subscript_expression] = STATE(2945),
    [sym_call_expression] = STATE(2945),
    [sym_field_expression] = STATE(2945),
    [sym_compound_literal_expression] = STATE(2945),
    [sym_parenthesized_expression] = STATE(2945),
    [sym_char_literal] = STATE(2945),
    [sym_concatenated_string] = STATE(2945),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2945),
    [sym_new_expression] = STATE(2945),
    [sym_delete_expression] = STATE(2945),
    [sym_lambda_expression] = STATE(2945),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6646),
    [anon_sym_SEMI] = ACTIONS(6648),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(6646),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6650),
    [sym_false] = ACTIONS(6650),
    [sym_null] = ACTIONS(6650),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(6650),
  },
  [2474] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(6652),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2475] = {
    [anon_sym_COLON] = ACTIONS(6654),
    [sym_comment] = ACTIONS(91),
  },
  [2476] = {
    [sym_raw_string_literal] = ACTIONS(2999),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3001),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3001),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3001),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3001),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3001),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3001),
    [sym_preproc_directive] = ACTIONS(3001),
    [anon_sym_SEMI] = ACTIONS(2999),
    [anon_sym_typedef] = ACTIONS(3001),
    [anon_sym_extern] = ACTIONS(3001),
    [anon_sym_LBRACE] = ACTIONS(2999),
    [anon_sym_LPAREN2] = ACTIONS(2999),
    [anon_sym_STAR] = ACTIONS(2999),
    [anon_sym_LBRACK] = ACTIONS(2999),
    [anon_sym_static] = ACTIONS(3001),
    [anon_sym_register] = ACTIONS(3001),
    [anon_sym_inline] = ACTIONS(3001),
    [anon_sym_const] = ACTIONS(3001),
    [anon_sym_restrict] = ACTIONS(3001),
    [anon_sym_volatile] = ACTIONS(3001),
    [anon_sym__Atomic] = ACTIONS(3001),
    [anon_sym_mutable] = ACTIONS(3001),
    [anon_sym_explicit] = ACTIONS(3001),
    [anon_sym_constexpr] = ACTIONS(3001),
    [anon_sym_unsigned] = ACTIONS(3001),
    [anon_sym_long] = ACTIONS(3001),
    [anon_sym_short] = ACTIONS(3001),
    [sym_primitive_type] = ACTIONS(3001),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_struct] = ACTIONS(3001),
    [anon_sym_union] = ACTIONS(3001),
    [anon_sym_if] = ACTIONS(3001),
    [anon_sym_else] = ACTIONS(3001),
    [anon_sym_switch] = ACTIONS(3001),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3001),
    [anon_sym_while] = ACTIONS(3001),
    [anon_sym_do] = ACTIONS(3001),
    [anon_sym_for] = ACTIONS(3001),
    [anon_sym_return] = ACTIONS(3001),
    [anon_sym_break] = ACTIONS(3001),
    [anon_sym_continue] = ACTIONS(3001),
    [anon_sym_goto] = ACTIONS(3001),
    [anon_sym_AMP] = ACTIONS(3001),
    [anon_sym_AMP_AMP] = ACTIONS(2999),
    [anon_sym_BANG] = ACTIONS(2999),
    [anon_sym_TILDE] = ACTIONS(2999),
    [anon_sym_PLUS] = ACTIONS(3001),
    [anon_sym_DASH] = ACTIONS(3001),
    [anon_sym_DASH_DASH] = ACTIONS(2999),
    [anon_sym_PLUS_PLUS] = ACTIONS(2999),
    [anon_sym_sizeof] = ACTIONS(3001),
    [sym_number_literal] = ACTIONS(2999),
    [anon_sym_SQUOTE] = ACTIONS(2999),
    [anon_sym_DQUOTE] = ACTIONS(2999),
    [sym_true] = ACTIONS(3001),
    [sym_false] = ACTIONS(3001),
    [sym_null] = ACTIONS(3001),
    [sym_identifier] = ACTIONS(3001),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3001),
    [sym_auto] = ACTIONS(3001),
    [anon_sym_typename] = ACTIONS(3001),
    [anon_sym_template] = ACTIONS(3001),
    [anon_sym_delete] = ACTIONS(3001),
    [anon_sym_namespace] = ACTIONS(3001),
    [anon_sym_using] = ACTIONS(3001),
    [anon_sym_try] = ACTIONS(3001),
    [anon_sym_new] = ACTIONS(3001),
    [anon_sym_COLON_COLON] = ACTIONS(2999),
    [sym_operator_name] = ACTIONS(2999),
    [sym_nullptr] = ACTIONS(3001),
  },
  [2477] = {
    [sym_raw_string_literal] = ACTIONS(3047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3049),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3049),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3049),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3049),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3049),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3049),
    [sym_preproc_directive] = ACTIONS(3049),
    [anon_sym_SEMI] = ACTIONS(3047),
    [anon_sym_typedef] = ACTIONS(3049),
    [anon_sym_extern] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(3047),
    [anon_sym_LPAREN2] = ACTIONS(3047),
    [anon_sym_STAR] = ACTIONS(3047),
    [anon_sym_LBRACK] = ACTIONS(3047),
    [anon_sym_static] = ACTIONS(3049),
    [anon_sym_register] = ACTIONS(3049),
    [anon_sym_inline] = ACTIONS(3049),
    [anon_sym_const] = ACTIONS(3049),
    [anon_sym_restrict] = ACTIONS(3049),
    [anon_sym_volatile] = ACTIONS(3049),
    [anon_sym__Atomic] = ACTIONS(3049),
    [anon_sym_mutable] = ACTIONS(3049),
    [anon_sym_explicit] = ACTIONS(3049),
    [anon_sym_constexpr] = ACTIONS(3049),
    [anon_sym_unsigned] = ACTIONS(3049),
    [anon_sym_long] = ACTIONS(3049),
    [anon_sym_short] = ACTIONS(3049),
    [sym_primitive_type] = ACTIONS(3049),
    [anon_sym_enum] = ACTIONS(3049),
    [anon_sym_struct] = ACTIONS(3049),
    [anon_sym_union] = ACTIONS(3049),
    [anon_sym_if] = ACTIONS(3049),
    [anon_sym_else] = ACTIONS(3049),
    [anon_sym_switch] = ACTIONS(3049),
    [anon_sym_case] = ACTIONS(3049),
    [anon_sym_default] = ACTIONS(3049),
    [anon_sym_while] = ACTIONS(3049),
    [anon_sym_do] = ACTIONS(3049),
    [anon_sym_for] = ACTIONS(3049),
    [anon_sym_return] = ACTIONS(3049),
    [anon_sym_break] = ACTIONS(3049),
    [anon_sym_continue] = ACTIONS(3049),
    [anon_sym_goto] = ACTIONS(3049),
    [anon_sym_AMP] = ACTIONS(3049),
    [anon_sym_AMP_AMP] = ACTIONS(3047),
    [anon_sym_BANG] = ACTIONS(3047),
    [anon_sym_TILDE] = ACTIONS(3047),
    [anon_sym_PLUS] = ACTIONS(3049),
    [anon_sym_DASH] = ACTIONS(3049),
    [anon_sym_DASH_DASH] = ACTIONS(3047),
    [anon_sym_PLUS_PLUS] = ACTIONS(3047),
    [anon_sym_sizeof] = ACTIONS(3049),
    [sym_number_literal] = ACTIONS(3047),
    [anon_sym_SQUOTE] = ACTIONS(3047),
    [anon_sym_DQUOTE] = ACTIONS(3047),
    [sym_true] = ACTIONS(3049),
    [sym_false] = ACTIONS(3049),
    [sym_null] = ACTIONS(3049),
    [sym_identifier] = ACTIONS(3049),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3049),
    [sym_auto] = ACTIONS(3049),
    [anon_sym_typename] = ACTIONS(3049),
    [anon_sym_template] = ACTIONS(3049),
    [anon_sym_delete] = ACTIONS(3049),
    [anon_sym_namespace] = ACTIONS(3049),
    [anon_sym_using] = ACTIONS(3049),
    [anon_sym_try] = ACTIONS(3049),
    [anon_sym_new] = ACTIONS(3049),
    [anon_sym_COLON_COLON] = ACTIONS(3047),
    [sym_operator_name] = ACTIONS(3047),
    [sym_nullptr] = ACTIONS(3049),
  },
  [2478] = {
    [sym_raw_string_literal] = ACTIONS(3072),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3074),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3074),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3074),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3074),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3074),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3074),
    [sym_preproc_directive] = ACTIONS(3074),
    [anon_sym_SEMI] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3074),
    [anon_sym_extern] = ACTIONS(3074),
    [anon_sym_LBRACE] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3074),
    [anon_sym_register] = ACTIONS(3074),
    [anon_sym_inline] = ACTIONS(3074),
    [anon_sym_const] = ACTIONS(3074),
    [anon_sym_restrict] = ACTIONS(3074),
    [anon_sym_volatile] = ACTIONS(3074),
    [anon_sym__Atomic] = ACTIONS(3074),
    [anon_sym_mutable] = ACTIONS(3074),
    [anon_sym_explicit] = ACTIONS(3074),
    [anon_sym_constexpr] = ACTIONS(3074),
    [anon_sym_unsigned] = ACTIONS(3074),
    [anon_sym_long] = ACTIONS(3074),
    [anon_sym_short] = ACTIONS(3074),
    [sym_primitive_type] = ACTIONS(3074),
    [anon_sym_enum] = ACTIONS(3074),
    [anon_sym_struct] = ACTIONS(3074),
    [anon_sym_union] = ACTIONS(3074),
    [anon_sym_if] = ACTIONS(3074),
    [anon_sym_else] = ACTIONS(3074),
    [anon_sym_switch] = ACTIONS(3074),
    [anon_sym_case] = ACTIONS(3074),
    [anon_sym_default] = ACTIONS(3074),
    [anon_sym_while] = ACTIONS(3074),
    [anon_sym_do] = ACTIONS(3074),
    [anon_sym_for] = ACTIONS(3074),
    [anon_sym_return] = ACTIONS(3074),
    [anon_sym_break] = ACTIONS(3074),
    [anon_sym_continue] = ACTIONS(3074),
    [anon_sym_goto] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3072),
    [anon_sym_BANG] = ACTIONS(3072),
    [anon_sym_TILDE] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3074),
    [anon_sym_DASH_DASH] = ACTIONS(3072),
    [anon_sym_PLUS_PLUS] = ACTIONS(3072),
    [anon_sym_sizeof] = ACTIONS(3074),
    [sym_number_literal] = ACTIONS(3072),
    [anon_sym_SQUOTE] = ACTIONS(3072),
    [anon_sym_DQUOTE] = ACTIONS(3072),
    [sym_true] = ACTIONS(3074),
    [sym_false] = ACTIONS(3074),
    [sym_null] = ACTIONS(3074),
    [sym_identifier] = ACTIONS(3074),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3074),
    [sym_auto] = ACTIONS(3074),
    [anon_sym_typename] = ACTIONS(3074),
    [anon_sym_template] = ACTIONS(3074),
    [anon_sym_delete] = ACTIONS(3074),
    [anon_sym_namespace] = ACTIONS(3074),
    [anon_sym_using] = ACTIONS(3074),
    [anon_sym_try] = ACTIONS(3074),
    [anon_sym_new] = ACTIONS(3074),
    [anon_sym_COLON_COLON] = ACTIONS(3072),
    [sym_operator_name] = ACTIONS(3072),
    [sym_nullptr] = ACTIONS(3074),
  },
  [2479] = {
    [sym_parameter_list] = STATE(812),
    [anon_sym_SEMI] = ACTIONS(6656),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(574),
    [sym_comment] = ACTIONS(91),
  },
  [2480] = {
    [sym_raw_string_literal] = ACTIONS(3281),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3283),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3283),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3283),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3283),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3283),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3283),
    [sym_preproc_directive] = ACTIONS(3283),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_typedef] = ACTIONS(3283),
    [anon_sym_extern] = ACTIONS(3283),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_LPAREN2] = ACTIONS(3281),
    [anon_sym_STAR] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_static] = ACTIONS(3283),
    [anon_sym_register] = ACTIONS(3283),
    [anon_sym_inline] = ACTIONS(3283),
    [anon_sym_const] = ACTIONS(3283),
    [anon_sym_restrict] = ACTIONS(3283),
    [anon_sym_volatile] = ACTIONS(3283),
    [anon_sym__Atomic] = ACTIONS(3283),
    [anon_sym_mutable] = ACTIONS(3283),
    [anon_sym_explicit] = ACTIONS(3283),
    [anon_sym_constexpr] = ACTIONS(3283),
    [anon_sym_unsigned] = ACTIONS(3283),
    [anon_sym_long] = ACTIONS(3283),
    [anon_sym_short] = ACTIONS(3283),
    [sym_primitive_type] = ACTIONS(3283),
    [anon_sym_enum] = ACTIONS(3283),
    [anon_sym_struct] = ACTIONS(3283),
    [anon_sym_union] = ACTIONS(3283),
    [anon_sym_if] = ACTIONS(3283),
    [anon_sym_switch] = ACTIONS(3283),
    [anon_sym_case] = ACTIONS(3283),
    [anon_sym_default] = ACTIONS(3283),
    [anon_sym_while] = ACTIONS(3283),
    [anon_sym_do] = ACTIONS(3283),
    [anon_sym_for] = ACTIONS(3283),
    [anon_sym_return] = ACTIONS(3283),
    [anon_sym_break] = ACTIONS(3283),
    [anon_sym_continue] = ACTIONS(3283),
    [anon_sym_goto] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3283),
    [anon_sym_AMP_AMP] = ACTIONS(3281),
    [anon_sym_BANG] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3281),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_DASH_DASH] = ACTIONS(3281),
    [anon_sym_PLUS_PLUS] = ACTIONS(3281),
    [anon_sym_sizeof] = ACTIONS(3283),
    [sym_number_literal] = ACTIONS(3281),
    [anon_sym_SQUOTE] = ACTIONS(3281),
    [anon_sym_DQUOTE] = ACTIONS(3281),
    [sym_true] = ACTIONS(3283),
    [sym_false] = ACTIONS(3283),
    [sym_null] = ACTIONS(3283),
    [sym_identifier] = ACTIONS(3283),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3283),
    [sym_auto] = ACTIONS(3283),
    [anon_sym_typename] = ACTIONS(3283),
    [anon_sym_template] = ACTIONS(3283),
    [anon_sym_delete] = ACTIONS(3283),
    [anon_sym_namespace] = ACTIONS(3283),
    [anon_sym_using] = ACTIONS(3283),
    [anon_sym_try] = ACTIONS(3283),
    [anon_sym_new] = ACTIONS(3283),
    [anon_sym_COLON_COLON] = ACTIONS(3281),
    [sym_operator_name] = ACTIONS(3281),
    [sym_nullptr] = ACTIONS(3283),
  },
  [2481] = {
    [sym_raw_string_literal] = ACTIONS(3289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3291),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3291),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3291),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3291),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3291),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3291),
    [sym_preproc_directive] = ACTIONS(3291),
    [anon_sym_SEMI] = ACTIONS(3289),
    [anon_sym_typedef] = ACTIONS(3291),
    [anon_sym_extern] = ACTIONS(3291),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_LPAREN2] = ACTIONS(3289),
    [anon_sym_STAR] = ACTIONS(3289),
    [anon_sym_LBRACK] = ACTIONS(3289),
    [anon_sym_static] = ACTIONS(3291),
    [anon_sym_register] = ACTIONS(3291),
    [anon_sym_inline] = ACTIONS(3291),
    [anon_sym_const] = ACTIONS(3291),
    [anon_sym_restrict] = ACTIONS(3291),
    [anon_sym_volatile] = ACTIONS(3291),
    [anon_sym__Atomic] = ACTIONS(3291),
    [anon_sym_mutable] = ACTIONS(3291),
    [anon_sym_explicit] = ACTIONS(3291),
    [anon_sym_constexpr] = ACTIONS(3291),
    [anon_sym_unsigned] = ACTIONS(3291),
    [anon_sym_long] = ACTIONS(3291),
    [anon_sym_short] = ACTIONS(3291),
    [sym_primitive_type] = ACTIONS(3291),
    [anon_sym_enum] = ACTIONS(3291),
    [anon_sym_struct] = ACTIONS(3291),
    [anon_sym_union] = ACTIONS(3291),
    [anon_sym_if] = ACTIONS(3291),
    [anon_sym_switch] = ACTIONS(3291),
    [anon_sym_case] = ACTIONS(3291),
    [anon_sym_default] = ACTIONS(3291),
    [anon_sym_while] = ACTIONS(3291),
    [anon_sym_do] = ACTIONS(3291),
    [anon_sym_for] = ACTIONS(3291),
    [anon_sym_return] = ACTIONS(3291),
    [anon_sym_break] = ACTIONS(3291),
    [anon_sym_continue] = ACTIONS(3291),
    [anon_sym_goto] = ACTIONS(3291),
    [anon_sym_AMP] = ACTIONS(3291),
    [anon_sym_AMP_AMP] = ACTIONS(3289),
    [anon_sym_BANG] = ACTIONS(3289),
    [anon_sym_TILDE] = ACTIONS(3289),
    [anon_sym_PLUS] = ACTIONS(3291),
    [anon_sym_DASH] = ACTIONS(3291),
    [anon_sym_DASH_DASH] = ACTIONS(3289),
    [anon_sym_PLUS_PLUS] = ACTIONS(3289),
    [anon_sym_sizeof] = ACTIONS(3291),
    [sym_number_literal] = ACTIONS(3289),
    [anon_sym_SQUOTE] = ACTIONS(3289),
    [anon_sym_DQUOTE] = ACTIONS(3289),
    [sym_true] = ACTIONS(3291),
    [sym_false] = ACTIONS(3291),
    [sym_null] = ACTIONS(3291),
    [sym_identifier] = ACTIONS(3291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3291),
    [sym_auto] = ACTIONS(3291),
    [anon_sym_typename] = ACTIONS(3291),
    [anon_sym_template] = ACTIONS(3291),
    [anon_sym_delete] = ACTIONS(3291),
    [anon_sym_namespace] = ACTIONS(3291),
    [anon_sym_using] = ACTIONS(3291),
    [anon_sym_try] = ACTIONS(3291),
    [anon_sym_new] = ACTIONS(3291),
    [anon_sym_COLON_COLON] = ACTIONS(3289),
    [sym_operator_name] = ACTIONS(3289),
    [sym_nullptr] = ACTIONS(3291),
  },
  [2482] = {
    [sym__declarator] = STATE(1790),
    [sym_pointer_declarator] = STATE(1790),
    [sym_function_declarator] = STATE(1790),
    [sym_array_declarator] = STATE(1790),
    [sym_init_declarator] = STATE(1791),
    [sym_reference_declarator] = STATE(1790),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(1790),
    [sym_destructor_name] = STATE(1790),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [anon_sym_SEMI] = ACTIONS(3783),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(560),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(568),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(3785),
  },
  [2483] = {
    [sym_raw_string_literal] = ACTIONS(3306),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3308),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3308),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3308),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3308),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3308),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3308),
    [sym_preproc_directive] = ACTIONS(3308),
    [anon_sym_SEMI] = ACTIONS(3306),
    [anon_sym_typedef] = ACTIONS(3308),
    [anon_sym_extern] = ACTIONS(3308),
    [anon_sym_LBRACE] = ACTIONS(3306),
    [anon_sym_LPAREN2] = ACTIONS(3306),
    [anon_sym_STAR] = ACTIONS(3306),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_static] = ACTIONS(3308),
    [anon_sym_register] = ACTIONS(3308),
    [anon_sym_inline] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3308),
    [anon_sym_restrict] = ACTIONS(3308),
    [anon_sym_volatile] = ACTIONS(3308),
    [anon_sym__Atomic] = ACTIONS(3308),
    [anon_sym_mutable] = ACTIONS(3308),
    [anon_sym_explicit] = ACTIONS(3308),
    [anon_sym_constexpr] = ACTIONS(3308),
    [anon_sym_unsigned] = ACTIONS(3308),
    [anon_sym_long] = ACTIONS(3308),
    [anon_sym_short] = ACTIONS(3308),
    [sym_primitive_type] = ACTIONS(3308),
    [anon_sym_enum] = ACTIONS(3308),
    [anon_sym_struct] = ACTIONS(3308),
    [anon_sym_union] = ACTIONS(3308),
    [anon_sym_if] = ACTIONS(3308),
    [anon_sym_switch] = ACTIONS(3308),
    [anon_sym_case] = ACTIONS(3308),
    [anon_sym_default] = ACTIONS(3308),
    [anon_sym_while] = ACTIONS(3308),
    [anon_sym_do] = ACTIONS(3308),
    [anon_sym_for] = ACTIONS(3308),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_break] = ACTIONS(3308),
    [anon_sym_continue] = ACTIONS(3308),
    [anon_sym_goto] = ACTIONS(3308),
    [anon_sym_AMP] = ACTIONS(3308),
    [anon_sym_AMP_AMP] = ACTIONS(3306),
    [anon_sym_BANG] = ACTIONS(3306),
    [anon_sym_TILDE] = ACTIONS(3306),
    [anon_sym_PLUS] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_DASH_DASH] = ACTIONS(3306),
    [anon_sym_PLUS_PLUS] = ACTIONS(3306),
    [anon_sym_sizeof] = ACTIONS(3308),
    [sym_number_literal] = ACTIONS(3306),
    [anon_sym_SQUOTE] = ACTIONS(3306),
    [anon_sym_DQUOTE] = ACTIONS(3306),
    [sym_true] = ACTIONS(3308),
    [sym_false] = ACTIONS(3308),
    [sym_null] = ACTIONS(3308),
    [sym_identifier] = ACTIONS(3308),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3308),
    [sym_auto] = ACTIONS(3308),
    [anon_sym_typename] = ACTIONS(3308),
    [anon_sym_template] = ACTIONS(3308),
    [anon_sym_delete] = ACTIONS(3308),
    [anon_sym_namespace] = ACTIONS(3308),
    [anon_sym_using] = ACTIONS(3308),
    [anon_sym_try] = ACTIONS(3308),
    [anon_sym_new] = ACTIONS(3308),
    [anon_sym_COLON_COLON] = ACTIONS(3306),
    [sym_operator_name] = ACTIONS(3306),
    [sym_nullptr] = ACTIONS(3308),
  },
  [2484] = {
    [sym_preproc_include] = STATE(1570),
    [sym_preproc_def] = STATE(1570),
    [sym_preproc_function_def] = STATE(1570),
    [sym_preproc_call] = STATE(1570),
    [sym_preproc_if] = STATE(1570),
    [sym_preproc_ifdef] = STATE(1570),
    [sym_function_definition] = STATE(1570),
    [sym_declaration] = STATE(1570),
    [sym_type_definition] = STATE(1570),
    [sym__declaration_specifiers] = STATE(49),
    [sym_linkage_specification] = STATE(1570),
    [sym__declarator] = STATE(50),
    [sym_pointer_declarator] = STATE(50),
    [sym_function_declarator] = STATE(51),
    [sym_array_declarator] = STATE(50),
    [sym_compound_statement] = STATE(1570),
    [sym_storage_class_specifier] = STATE(63),
    [sym_type_qualifier] = STATE(63),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(1570),
    [sym_expression_statement] = STATE(1570),
    [sym_if_statement] = STATE(1570),
    [sym_switch_statement] = STATE(1570),
    [sym_case_statement] = STATE(1570),
    [sym_while_statement] = STATE(1570),
    [sym_do_statement] = STATE(1570),
    [sym_for_statement] = STATE(1570),
    [sym_return_statement] = STATE(1570),
    [sym_break_statement] = STATE(1570),
    [sym_continue_statement] = STATE(1570),
    [sym_goto_statement] = STATE(1570),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(1570),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(1570),
    [sym_template_declaration] = STATE(1570),
    [sym_template_instantiation] = STATE(1570),
    [sym_constructor_or_destructor_definition] = STATE(1570),
    [sym_reference_declarator] = STATE(50),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(57),
    [sym_namespace_definition] = STATE(1570),
    [sym_using_declaration] = STATE(1570),
    [sym_alias_declaration] = STATE(1570),
    [sym_for_range_loop] = STATE(1570),
    [sym_try_statement] = STATE(1570),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_destructor_name] = STATE(50),
    [sym_scoped_identifier] = STATE(59),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_translation_unit_repeat1] = STATE(1570),
    [aux_sym__declaration_specifiers_repeat1] = STATE(63),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(5),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(9),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(13),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(15),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(15),
    [sym_preproc_directive] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_RBRACE] = ACTIONS(6658),
    [anon_sym_LPAREN2] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(1495),
    [anon_sym_switch] = ACTIONS(1497),
    [anon_sym_case] = ACTIONS(1499),
    [anon_sym_default] = ACTIONS(1501),
    [anon_sym_while] = ACTIONS(1503),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(1505),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(1507),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_template] = ACTIONS(97),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_namespace] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(103),
    [anon_sym_try] = ACTIONS(1509),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_operator_name] = ACTIONS(111),
    [sym_nullptr] = ACTIONS(87),
  },
  [2485] = {
    [sym_raw_string_literal] = ACTIONS(3326),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3328),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3328),
    [sym_preproc_directive] = ACTIONS(3328),
    [anon_sym_SEMI] = ACTIONS(3326),
    [anon_sym_typedef] = ACTIONS(3328),
    [anon_sym_extern] = ACTIONS(3328),
    [anon_sym_LBRACE] = ACTIONS(3326),
    [anon_sym_LPAREN2] = ACTIONS(3326),
    [anon_sym_STAR] = ACTIONS(3326),
    [anon_sym_LBRACK] = ACTIONS(3326),
    [anon_sym_static] = ACTIONS(3328),
    [anon_sym_register] = ACTIONS(3328),
    [anon_sym_inline] = ACTIONS(3328),
    [anon_sym_const] = ACTIONS(3328),
    [anon_sym_restrict] = ACTIONS(3328),
    [anon_sym_volatile] = ACTIONS(3328),
    [anon_sym__Atomic] = ACTIONS(3328),
    [anon_sym_mutable] = ACTIONS(3328),
    [anon_sym_explicit] = ACTIONS(3328),
    [anon_sym_constexpr] = ACTIONS(3328),
    [anon_sym_unsigned] = ACTIONS(3328),
    [anon_sym_long] = ACTIONS(3328),
    [anon_sym_short] = ACTIONS(3328),
    [sym_primitive_type] = ACTIONS(3328),
    [anon_sym_enum] = ACTIONS(3328),
    [anon_sym_struct] = ACTIONS(3328),
    [anon_sym_union] = ACTIONS(3328),
    [anon_sym_if] = ACTIONS(3328),
    [anon_sym_switch] = ACTIONS(3328),
    [anon_sym_case] = ACTIONS(3328),
    [anon_sym_default] = ACTIONS(3328),
    [anon_sym_while] = ACTIONS(3328),
    [anon_sym_do] = ACTIONS(3328),
    [anon_sym_for] = ACTIONS(3328),
    [anon_sym_return] = ACTIONS(3328),
    [anon_sym_break] = ACTIONS(3328),
    [anon_sym_continue] = ACTIONS(3328),
    [anon_sym_goto] = ACTIONS(3328),
    [anon_sym_AMP] = ACTIONS(3328),
    [anon_sym_AMP_AMP] = ACTIONS(3326),
    [anon_sym_BANG] = ACTIONS(3326),
    [anon_sym_TILDE] = ACTIONS(3326),
    [anon_sym_PLUS] = ACTIONS(3328),
    [anon_sym_DASH] = ACTIONS(3328),
    [anon_sym_DASH_DASH] = ACTIONS(3326),
    [anon_sym_PLUS_PLUS] = ACTIONS(3326),
    [anon_sym_sizeof] = ACTIONS(3328),
    [sym_number_literal] = ACTIONS(3326),
    [anon_sym_SQUOTE] = ACTIONS(3326),
    [anon_sym_DQUOTE] = ACTIONS(3326),
    [sym_true] = ACTIONS(3328),
    [sym_false] = ACTIONS(3328),
    [sym_null] = ACTIONS(3328),
    [sym_identifier] = ACTIONS(3328),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3328),
    [sym_auto] = ACTIONS(3328),
    [anon_sym_typename] = ACTIONS(3328),
    [anon_sym_template] = ACTIONS(3328),
    [anon_sym_delete] = ACTIONS(3328),
    [anon_sym_namespace] = ACTIONS(3328),
    [anon_sym_using] = ACTIONS(3328),
    [anon_sym_try] = ACTIONS(3328),
    [anon_sym_new] = ACTIONS(3328),
    [anon_sym_COLON_COLON] = ACTIONS(3326),
    [sym_operator_name] = ACTIONS(3326),
    [sym_nullptr] = ACTIONS(3328),
  },
  [2486] = {
    [sym_raw_string_literal] = ACTIONS(3330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3332),
    [sym_preproc_directive] = ACTIONS(3332),
    [anon_sym_SEMI] = ACTIONS(3330),
    [anon_sym_typedef] = ACTIONS(3332),
    [anon_sym_extern] = ACTIONS(3332),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_LPAREN2] = ACTIONS(3330),
    [anon_sym_STAR] = ACTIONS(3330),
    [anon_sym_LBRACK] = ACTIONS(3330),
    [anon_sym_static] = ACTIONS(3332),
    [anon_sym_register] = ACTIONS(3332),
    [anon_sym_inline] = ACTIONS(3332),
    [anon_sym_const] = ACTIONS(3332),
    [anon_sym_restrict] = ACTIONS(3332),
    [anon_sym_volatile] = ACTIONS(3332),
    [anon_sym__Atomic] = ACTIONS(3332),
    [anon_sym_mutable] = ACTIONS(3332),
    [anon_sym_explicit] = ACTIONS(3332),
    [anon_sym_constexpr] = ACTIONS(3332),
    [anon_sym_unsigned] = ACTIONS(3332),
    [anon_sym_long] = ACTIONS(3332),
    [anon_sym_short] = ACTIONS(3332),
    [sym_primitive_type] = ACTIONS(3332),
    [anon_sym_enum] = ACTIONS(3332),
    [anon_sym_struct] = ACTIONS(3332),
    [anon_sym_union] = ACTIONS(3332),
    [anon_sym_if] = ACTIONS(3332),
    [anon_sym_switch] = ACTIONS(3332),
    [anon_sym_case] = ACTIONS(3332),
    [anon_sym_default] = ACTIONS(3332),
    [anon_sym_while] = ACTIONS(3332),
    [anon_sym_do] = ACTIONS(3332),
    [anon_sym_for] = ACTIONS(3332),
    [anon_sym_return] = ACTIONS(3332),
    [anon_sym_break] = ACTIONS(3332),
    [anon_sym_continue] = ACTIONS(3332),
    [anon_sym_goto] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(3332),
    [anon_sym_AMP_AMP] = ACTIONS(3330),
    [anon_sym_BANG] = ACTIONS(3330),
    [anon_sym_TILDE] = ACTIONS(3330),
    [anon_sym_PLUS] = ACTIONS(3332),
    [anon_sym_DASH] = ACTIONS(3332),
    [anon_sym_DASH_DASH] = ACTIONS(3330),
    [anon_sym_PLUS_PLUS] = ACTIONS(3330),
    [anon_sym_sizeof] = ACTIONS(3332),
    [sym_number_literal] = ACTIONS(3330),
    [anon_sym_SQUOTE] = ACTIONS(3330),
    [anon_sym_DQUOTE] = ACTIONS(3330),
    [sym_true] = ACTIONS(3332),
    [sym_false] = ACTIONS(3332),
    [sym_null] = ACTIONS(3332),
    [sym_identifier] = ACTIONS(3332),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3332),
    [sym_auto] = ACTIONS(3332),
    [anon_sym_typename] = ACTIONS(3332),
    [anon_sym_template] = ACTIONS(3332),
    [anon_sym_delete] = ACTIONS(3332),
    [anon_sym_namespace] = ACTIONS(3332),
    [anon_sym_using] = ACTIONS(3332),
    [anon_sym_try] = ACTIONS(3332),
    [anon_sym_new] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(3330),
    [sym_operator_name] = ACTIONS(3330),
    [sym_nullptr] = ACTIONS(3332),
  },
  [2487] = {
    [sym_type_qualifier] = STATE(1574),
    [sym__type_specifier] = STATE(1572),
    [sym_sized_type_specifier] = STATE(1572),
    [sym_enum_specifier] = STATE(1572),
    [sym_struct_specifier] = STATE(1572),
    [sym_union_specifier] = STATE(1572),
    [sym_type_descriptor] = STATE(2950),
    [sym_macro_type_specifier] = STATE(1572),
    [sym_class_specifier] = STATE(1572),
    [sym_dependent_type] = STATE(1572),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_type_definition_repeat1] = STATE(1574),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1575),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(3334),
    [anon_sym_long] = ACTIONS(3334),
    [anon_sym_short] = ACTIONS(3334),
    [sym_primitive_type] = ACTIONS(3336),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(3336),
    [anon_sym_typename] = ACTIONS(3338),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [2488] = {
    [sym_template_argument_list] = STATE(437),
    [anon_sym_SEMI] = ACTIONS(6660),
    [anon_sym_LT] = ACTIONS(945),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1519),
  },
  [2489] = {
    [anon_sym_SEMI] = ACTIONS(6660),
    [sym_comment] = ACTIONS(91),
  },
  [2490] = {
    [sym_parameter_list] = STATE(2952),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [sym_comment] = ACTIONS(91),
  },
  [2491] = {
    [sym_catch_clause] = STATE(2953),
    [aux_sym_try_statement_repeat1] = STATE(2953),
    [sym_raw_string_literal] = ACTIONS(3346),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3348),
    [sym_preproc_directive] = ACTIONS(3348),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym_typedef] = ACTIONS(3348),
    [anon_sym_extern] = ACTIONS(3348),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(3346),
    [anon_sym_static] = ACTIONS(3348),
    [anon_sym_register] = ACTIONS(3348),
    [anon_sym_inline] = ACTIONS(3348),
    [anon_sym_const] = ACTIONS(3348),
    [anon_sym_restrict] = ACTIONS(3348),
    [anon_sym_volatile] = ACTIONS(3348),
    [anon_sym__Atomic] = ACTIONS(3348),
    [anon_sym_mutable] = ACTIONS(3348),
    [anon_sym_explicit] = ACTIONS(3348),
    [anon_sym_constexpr] = ACTIONS(3348),
    [anon_sym_unsigned] = ACTIONS(3348),
    [anon_sym_long] = ACTIONS(3348),
    [anon_sym_short] = ACTIONS(3348),
    [sym_primitive_type] = ACTIONS(3348),
    [anon_sym_enum] = ACTIONS(3348),
    [anon_sym_struct] = ACTIONS(3348),
    [anon_sym_union] = ACTIONS(3348),
    [anon_sym_if] = ACTIONS(3348),
    [anon_sym_switch] = ACTIONS(3348),
    [anon_sym_case] = ACTIONS(3348),
    [anon_sym_default] = ACTIONS(3348),
    [anon_sym_while] = ACTIONS(3348),
    [anon_sym_do] = ACTIONS(3348),
    [anon_sym_for] = ACTIONS(3348),
    [anon_sym_return] = ACTIONS(3348),
    [anon_sym_break] = ACTIONS(3348),
    [anon_sym_continue] = ACTIONS(3348),
    [anon_sym_goto] = ACTIONS(3348),
    [anon_sym_AMP] = ACTIONS(3348),
    [anon_sym_AMP_AMP] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_PLUS] = ACTIONS(3348),
    [anon_sym_DASH] = ACTIONS(3348),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_sizeof] = ACTIONS(3348),
    [sym_number_literal] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [sym_true] = ACTIONS(3348),
    [sym_false] = ACTIONS(3348),
    [sym_null] = ACTIONS(3348),
    [sym_identifier] = ACTIONS(3348),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3348),
    [sym_auto] = ACTIONS(3348),
    [anon_sym_typename] = ACTIONS(3348),
    [anon_sym_template] = ACTIONS(3348),
    [anon_sym_delete] = ACTIONS(3348),
    [anon_sym_namespace] = ACTIONS(3348),
    [anon_sym_using] = ACTIONS(3348),
    [anon_sym_try] = ACTIONS(3348),
    [anon_sym_catch] = ACTIONS(6662),
    [anon_sym_new] = ACTIONS(3348),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [sym_operator_name] = ACTIONS(3346),
    [sym_nullptr] = ACTIONS(3348),
  },
  [2492] = {
    [sym_raw_string_literal] = ACTIONS(3397),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3399),
    [sym_preproc_directive] = ACTIONS(3399),
    [anon_sym_SEMI] = ACTIONS(3397),
    [anon_sym_typedef] = ACTIONS(3399),
    [anon_sym_extern] = ACTIONS(3399),
    [anon_sym_LBRACE] = ACTIONS(3397),
    [anon_sym_LPAREN2] = ACTIONS(3397),
    [anon_sym_STAR] = ACTIONS(3397),
    [anon_sym_LBRACK] = ACTIONS(3397),
    [anon_sym_static] = ACTIONS(3399),
    [anon_sym_register] = ACTIONS(3399),
    [anon_sym_inline] = ACTIONS(3399),
    [anon_sym_const] = ACTIONS(3399),
    [anon_sym_restrict] = ACTIONS(3399),
    [anon_sym_volatile] = ACTIONS(3399),
    [anon_sym__Atomic] = ACTIONS(3399),
    [anon_sym_mutable] = ACTIONS(3399),
    [anon_sym_explicit] = ACTIONS(3399),
    [anon_sym_constexpr] = ACTIONS(3399),
    [anon_sym_unsigned] = ACTIONS(3399),
    [anon_sym_long] = ACTIONS(3399),
    [anon_sym_short] = ACTIONS(3399),
    [sym_primitive_type] = ACTIONS(3399),
    [anon_sym_enum] = ACTIONS(3399),
    [anon_sym_struct] = ACTIONS(3399),
    [anon_sym_union] = ACTIONS(3399),
    [anon_sym_if] = ACTIONS(3399),
    [anon_sym_else] = ACTIONS(3399),
    [anon_sym_switch] = ACTIONS(3399),
    [anon_sym_case] = ACTIONS(3399),
    [anon_sym_default] = ACTIONS(3399),
    [anon_sym_while] = ACTIONS(3399),
    [anon_sym_do] = ACTIONS(3399),
    [anon_sym_for] = ACTIONS(3399),
    [anon_sym_return] = ACTIONS(3399),
    [anon_sym_break] = ACTIONS(3399),
    [anon_sym_continue] = ACTIONS(3399),
    [anon_sym_goto] = ACTIONS(3399),
    [anon_sym_AMP] = ACTIONS(3399),
    [anon_sym_AMP_AMP] = ACTIONS(3397),
    [anon_sym_BANG] = ACTIONS(3397),
    [anon_sym_TILDE] = ACTIONS(3397),
    [anon_sym_PLUS] = ACTIONS(3399),
    [anon_sym_DASH] = ACTIONS(3399),
    [anon_sym_DASH_DASH] = ACTIONS(3397),
    [anon_sym_PLUS_PLUS] = ACTIONS(3397),
    [anon_sym_sizeof] = ACTIONS(3399),
    [sym_number_literal] = ACTIONS(3397),
    [anon_sym_SQUOTE] = ACTIONS(3397),
    [anon_sym_DQUOTE] = ACTIONS(3397),
    [sym_true] = ACTIONS(3399),
    [sym_false] = ACTIONS(3399),
    [sym_null] = ACTIONS(3399),
    [sym_identifier] = ACTIONS(3399),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3399),
    [sym_auto] = ACTIONS(3399),
    [anon_sym_typename] = ACTIONS(3399),
    [anon_sym_template] = ACTIONS(3399),
    [anon_sym_delete] = ACTIONS(3399),
    [anon_sym_namespace] = ACTIONS(3399),
    [anon_sym_using] = ACTIONS(3399),
    [anon_sym_try] = ACTIONS(3399),
    [anon_sym_new] = ACTIONS(3399),
    [anon_sym_COLON_COLON] = ACTIONS(3397),
    [sym_operator_name] = ACTIONS(3397),
    [sym_nullptr] = ACTIONS(3399),
  },
  [2493] = {
    [sym_preproc_include] = STATE(1763),
    [sym_preproc_def] = STATE(1763),
    [sym_preproc_function_def] = STATE(1763),
    [sym_preproc_call] = STATE(1763),
    [sym_preproc_if_in_compound_statement] = STATE(1763),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1763),
    [sym_declaration] = STATE(1763),
    [sym_type_definition] = STATE(1763),
    [sym__declaration_specifiers] = STATE(113),
    [sym_compound_statement] = STATE(1763),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(1763),
    [sym_expression_statement] = STATE(1763),
    [sym_if_statement] = STATE(1763),
    [sym_switch_statement] = STATE(1763),
    [sym_case_statement] = STATE(1763),
    [sym_while_statement] = STATE(1763),
    [sym_do_statement] = STATE(1763),
    [sym_for_statement] = STATE(1763),
    [sym_return_statement] = STATE(1763),
    [sym_break_statement] = STATE(1763),
    [sym_continue_statement] = STATE(1763),
    [sym_goto_statement] = STATE(1763),
    [sym__expression] = STATE(1631),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(1631),
    [sym_assignment_expression] = STATE(1631),
    [sym_pointer_expression] = STATE(1631),
    [sym_logical_expression] = STATE(1631),
    [sym_bitwise_expression] = STATE(1631),
    [sym_equality_expression] = STATE(1631),
    [sym_relational_expression] = STATE(1631),
    [sym_shift_expression] = STATE(1631),
    [sym_math_expression] = STATE(1631),
    [sym_cast_expression] = STATE(1631),
    [sym_sizeof_expression] = STATE(1631),
    [sym_subscript_expression] = STATE(1631),
    [sym_call_expression] = STATE(1631),
    [sym_field_expression] = STATE(1631),
    [sym_compound_literal_expression] = STATE(1631),
    [sym_parenthesized_expression] = STATE(1631),
    [sym_initializer_list] = STATE(726),
    [sym_initializer_pair] = STATE(726),
    [sym_subscript_designator] = STATE(728),
    [sym_field_designator] = STATE(728),
    [sym_char_literal] = STATE(1631),
    [sym_concatenated_string] = STATE(1631),
    [sym_string_literal] = STATE(1632),
    [sym__empty_declaration] = STATE(1763),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(1763),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(1631),
    [sym_for_range_loop] = STATE(1763),
    [sym_try_statement] = STATE(1763),
    [sym_new_expression] = STATE(1631),
    [sym_delete_expression] = STATE(1631),
    [sym_lambda_expression] = STATE(1631),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1763),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [aux_sym_initializer_pair_repeat1] = STATE(728),
    [sym_raw_string_literal] = ACTIONS(3401),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(159),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(161),
    [anon_sym_COMMA] = ACTIONS(1252),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(163),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(165),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(165),
    [sym_preproc_directive] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_typedef] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(3403),
    [anon_sym_RBRACE] = ACTIONS(6664),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_LBRACK] = ACTIONS(1260),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(185),
    [anon_sym_case] = ACTIONS(187),
    [anon_sym_default] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3411),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_sizeof] = ACTIONS(3419),
    [anon_sym_DOT] = ACTIONS(1272),
    [sym_number_literal] = ACTIONS(3401),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(3421),
    [sym_false] = ACTIONS(3421),
    [sym_null] = ACTIONS(3421),
    [sym_identifier] = ACTIONS(209),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(3423),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_COLON_COLON] = ACTIONS(3427),
    [sym_nullptr] = ACTIONS(3421),
  },
  [2494] = {
    [sym_raw_string_literal] = ACTIONS(3439),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3441),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3441),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3441),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3441),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3441),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3441),
    [sym_preproc_directive] = ACTIONS(3441),
    [anon_sym_SEMI] = ACTIONS(3439),
    [anon_sym_typedef] = ACTIONS(3441),
    [anon_sym_extern] = ACTIONS(3441),
    [anon_sym_LBRACE] = ACTIONS(3439),
    [anon_sym_LPAREN2] = ACTIONS(3439),
    [anon_sym_STAR] = ACTIONS(3439),
    [anon_sym_LBRACK] = ACTIONS(3439),
    [anon_sym_static] = ACTIONS(3441),
    [anon_sym_register] = ACTIONS(3441),
    [anon_sym_inline] = ACTIONS(3441),
    [anon_sym_const] = ACTIONS(3441),
    [anon_sym_restrict] = ACTIONS(3441),
    [anon_sym_volatile] = ACTIONS(3441),
    [anon_sym__Atomic] = ACTIONS(3441),
    [anon_sym_mutable] = ACTIONS(3441),
    [anon_sym_explicit] = ACTIONS(3441),
    [anon_sym_constexpr] = ACTIONS(3441),
    [anon_sym_unsigned] = ACTIONS(3441),
    [anon_sym_long] = ACTIONS(3441),
    [anon_sym_short] = ACTIONS(3441),
    [sym_primitive_type] = ACTIONS(3441),
    [anon_sym_enum] = ACTIONS(3441),
    [anon_sym_struct] = ACTIONS(3441),
    [anon_sym_union] = ACTIONS(3441),
    [anon_sym_if] = ACTIONS(3441),
    [anon_sym_switch] = ACTIONS(3441),
    [anon_sym_case] = ACTIONS(3441),
    [anon_sym_default] = ACTIONS(3441),
    [anon_sym_while] = ACTIONS(3441),
    [anon_sym_do] = ACTIONS(3441),
    [anon_sym_for] = ACTIONS(3441),
    [anon_sym_return] = ACTIONS(3441),
    [anon_sym_break] = ACTIONS(3441),
    [anon_sym_continue] = ACTIONS(3441),
    [anon_sym_goto] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3441),
    [anon_sym_AMP_AMP] = ACTIONS(3439),
    [anon_sym_BANG] = ACTIONS(3439),
    [anon_sym_TILDE] = ACTIONS(3439),
    [anon_sym_PLUS] = ACTIONS(3441),
    [anon_sym_DASH] = ACTIONS(3441),
    [anon_sym_DASH_DASH] = ACTIONS(3439),
    [anon_sym_PLUS_PLUS] = ACTIONS(3439),
    [anon_sym_sizeof] = ACTIONS(3441),
    [sym_number_literal] = ACTIONS(3439),
    [anon_sym_SQUOTE] = ACTIONS(3439),
    [anon_sym_DQUOTE] = ACTIONS(3439),
    [sym_true] = ACTIONS(3441),
    [sym_false] = ACTIONS(3441),
    [sym_null] = ACTIONS(3441),
    [sym_identifier] = ACTIONS(3441),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3441),
    [sym_auto] = ACTIONS(3441),
    [anon_sym_typename] = ACTIONS(3441),
    [anon_sym_template] = ACTIONS(3441),
    [anon_sym_delete] = ACTIONS(3441),
    [anon_sym_namespace] = ACTIONS(3441),
    [anon_sym_using] = ACTIONS(3441),
    [anon_sym_try] = ACTIONS(3441),
    [anon_sym_new] = ACTIONS(3441),
    [anon_sym_COLON_COLON] = ACTIONS(3439),
    [sym_operator_name] = ACTIONS(3439),
    [sym_nullptr] = ACTIONS(3441),
  },
  [2495] = {
    [aux_sym_declaration_repeat1] = STATE(1643),
    [anon_sym_COMMA] = ACTIONS(1613),
    [anon_sym_SEMI] = ACTIONS(6666),
    [sym_comment] = ACTIONS(91),
  },
  [2496] = {
    [sym__expression] = STATE(2956),
    [sym_conditional_expression] = STATE(2956),
    [sym_assignment_expression] = STATE(2956),
    [sym_pointer_expression] = STATE(2956),
    [sym_logical_expression] = STATE(2956),
    [sym_bitwise_expression] = STATE(2956),
    [sym_equality_expression] = STATE(2956),
    [sym_relational_expression] = STATE(2956),
    [sym_shift_expression] = STATE(2956),
    [sym_math_expression] = STATE(2956),
    [sym_cast_expression] = STATE(2956),
    [sym_sizeof_expression] = STATE(2956),
    [sym_subscript_expression] = STATE(2956),
    [sym_call_expression] = STATE(2956),
    [sym_field_expression] = STATE(2956),
    [sym_compound_literal_expression] = STATE(2956),
    [sym_parenthesized_expression] = STATE(2956),
    [sym_initializer_list] = STATE(2957),
    [sym_char_literal] = STATE(2956),
    [sym_concatenated_string] = STATE(2956),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2956),
    [sym_new_expression] = STATE(2956),
    [sym_delete_expression] = STATE(2956),
    [sym_lambda_expression] = STATE(2956),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6668),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(6668),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6670),
    [sym_false] = ACTIONS(6670),
    [sym_null] = ACTIONS(6670),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(6670),
  },
  [2497] = {
    [anon_sym_SEMI] = ACTIONS(6672),
    [sym_comment] = ACTIONS(91),
  },
  [2498] = {
    [anon_sym_SEMI] = ACTIONS(6674),
    [sym_comment] = ACTIONS(91),
  },
  [2499] = {
    [anon_sym_SEMI] = ACTIONS(6676),
    [sym_comment] = ACTIONS(91),
  },
  [2500] = {
    [sym_raw_string_literal] = ACTIONS(3569),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3571),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3571),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3571),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3571),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3571),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3571),
    [sym_preproc_directive] = ACTIONS(3571),
    [anon_sym_SEMI] = ACTIONS(3569),
    [anon_sym_typedef] = ACTIONS(3571),
    [anon_sym_extern] = ACTIONS(3571),
    [anon_sym_LBRACE] = ACTIONS(3569),
    [anon_sym_LPAREN2] = ACTIONS(3569),
    [anon_sym_STAR] = ACTIONS(3569),
    [anon_sym_LBRACK] = ACTIONS(3569),
    [anon_sym_static] = ACTIONS(3571),
    [anon_sym_register] = ACTIONS(3571),
    [anon_sym_inline] = ACTIONS(3571),
    [anon_sym_const] = ACTIONS(3571),
    [anon_sym_restrict] = ACTIONS(3571),
    [anon_sym_volatile] = ACTIONS(3571),
    [anon_sym__Atomic] = ACTIONS(3571),
    [anon_sym_mutable] = ACTIONS(3571),
    [anon_sym_explicit] = ACTIONS(3571),
    [anon_sym_constexpr] = ACTIONS(3571),
    [anon_sym_unsigned] = ACTIONS(3571),
    [anon_sym_long] = ACTIONS(3571),
    [anon_sym_short] = ACTIONS(3571),
    [sym_primitive_type] = ACTIONS(3571),
    [anon_sym_enum] = ACTIONS(3571),
    [anon_sym_struct] = ACTIONS(3571),
    [anon_sym_union] = ACTIONS(3571),
    [anon_sym_if] = ACTIONS(3571),
    [anon_sym_switch] = ACTIONS(3571),
    [anon_sym_case] = ACTIONS(3571),
    [anon_sym_default] = ACTIONS(3571),
    [anon_sym_while] = ACTIONS(3571),
    [anon_sym_do] = ACTIONS(3571),
    [anon_sym_for] = ACTIONS(3571),
    [anon_sym_return] = ACTIONS(3571),
    [anon_sym_break] = ACTIONS(3571),
    [anon_sym_continue] = ACTIONS(3571),
    [anon_sym_goto] = ACTIONS(3571),
    [anon_sym_AMP] = ACTIONS(3571),
    [anon_sym_AMP_AMP] = ACTIONS(3569),
    [anon_sym_BANG] = ACTIONS(3569),
    [anon_sym_TILDE] = ACTIONS(3569),
    [anon_sym_PLUS] = ACTIONS(3571),
    [anon_sym_DASH] = ACTIONS(3571),
    [anon_sym_DASH_DASH] = ACTIONS(3569),
    [anon_sym_PLUS_PLUS] = ACTIONS(3569),
    [anon_sym_sizeof] = ACTIONS(3571),
    [sym_number_literal] = ACTIONS(3569),
    [anon_sym_SQUOTE] = ACTIONS(3569),
    [anon_sym_DQUOTE] = ACTIONS(3569),
    [sym_true] = ACTIONS(3571),
    [sym_false] = ACTIONS(3571),
    [sym_null] = ACTIONS(3571),
    [sym_identifier] = ACTIONS(3571),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3571),
    [sym_auto] = ACTIONS(3571),
    [anon_sym_typename] = ACTIONS(3571),
    [anon_sym_template] = ACTIONS(3571),
    [anon_sym_delete] = ACTIONS(3571),
    [anon_sym_namespace] = ACTIONS(3571),
    [anon_sym_using] = ACTIONS(3571),
    [anon_sym_try] = ACTIONS(3571),
    [anon_sym_new] = ACTIONS(3571),
    [anon_sym_COLON_COLON] = ACTIONS(3569),
    [sym_operator_name] = ACTIONS(3569),
    [sym_nullptr] = ACTIONS(3571),
  },
  [2501] = {
    [sym_compound_statement] = STATE(2961),
    [sym_default_method_clause] = STATE(2961),
    [sym_delete_method_clause] = STATE(2961),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_EQ] = ACTIONS(3787),
    [sym_comment] = ACTIONS(91),
  },
  [2502] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6678),
    [sym_comment] = ACTIONS(91),
  },
  [2503] = {
    [sym_raw_string_literal] = ACTIONS(3958),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3960),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3960),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3960),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3960),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3960),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3960),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3960),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3960),
    [sym_preproc_directive] = ACTIONS(3960),
    [anon_sym_SEMI] = ACTIONS(3958),
    [anon_sym_typedef] = ACTIONS(3960),
    [anon_sym_extern] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3958),
    [anon_sym_LPAREN2] = ACTIONS(3958),
    [anon_sym_STAR] = ACTIONS(3958),
    [anon_sym_LBRACK] = ACTIONS(3958),
    [anon_sym_static] = ACTIONS(3960),
    [anon_sym_register] = ACTIONS(3960),
    [anon_sym_inline] = ACTIONS(3960),
    [anon_sym_const] = ACTIONS(3960),
    [anon_sym_restrict] = ACTIONS(3960),
    [anon_sym_volatile] = ACTIONS(3960),
    [anon_sym__Atomic] = ACTIONS(3960),
    [anon_sym_mutable] = ACTIONS(3960),
    [anon_sym_explicit] = ACTIONS(3960),
    [anon_sym_constexpr] = ACTIONS(3960),
    [anon_sym_unsigned] = ACTIONS(3960),
    [anon_sym_long] = ACTIONS(3960),
    [anon_sym_short] = ACTIONS(3960),
    [sym_primitive_type] = ACTIONS(3960),
    [anon_sym_enum] = ACTIONS(3960),
    [anon_sym_struct] = ACTIONS(3960),
    [anon_sym_union] = ACTIONS(3960),
    [anon_sym_if] = ACTIONS(3960),
    [anon_sym_else] = ACTIONS(3960),
    [anon_sym_switch] = ACTIONS(3960),
    [anon_sym_case] = ACTIONS(3960),
    [anon_sym_default] = ACTIONS(3960),
    [anon_sym_while] = ACTIONS(3960),
    [anon_sym_do] = ACTIONS(3960),
    [anon_sym_for] = ACTIONS(3960),
    [anon_sym_return] = ACTIONS(3960),
    [anon_sym_break] = ACTIONS(3960),
    [anon_sym_continue] = ACTIONS(3960),
    [anon_sym_goto] = ACTIONS(3960),
    [anon_sym_AMP] = ACTIONS(3960),
    [anon_sym_AMP_AMP] = ACTIONS(3958),
    [anon_sym_BANG] = ACTIONS(3958),
    [anon_sym_TILDE] = ACTIONS(3958),
    [anon_sym_PLUS] = ACTIONS(3960),
    [anon_sym_DASH] = ACTIONS(3960),
    [anon_sym_DASH_DASH] = ACTIONS(3958),
    [anon_sym_PLUS_PLUS] = ACTIONS(3958),
    [anon_sym_sizeof] = ACTIONS(3960),
    [sym_number_literal] = ACTIONS(3958),
    [anon_sym_SQUOTE] = ACTIONS(3958),
    [anon_sym_DQUOTE] = ACTIONS(3958),
    [sym_true] = ACTIONS(3960),
    [sym_false] = ACTIONS(3960),
    [sym_null] = ACTIONS(3960),
    [sym_identifier] = ACTIONS(3960),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3960),
    [sym_auto] = ACTIONS(3960),
    [anon_sym_typename] = ACTIONS(3960),
    [anon_sym_template] = ACTIONS(3960),
    [anon_sym_delete] = ACTIONS(3960),
    [anon_sym_namespace] = ACTIONS(3960),
    [anon_sym_using] = ACTIONS(3960),
    [anon_sym_try] = ACTIONS(3960),
    [anon_sym_new] = ACTIONS(3960),
    [anon_sym_COLON_COLON] = ACTIONS(3958),
    [sym_operator_name] = ACTIONS(3958),
    [sym_nullptr] = ACTIONS(3960),
  },
  [2504] = {
    [sym_parameter_list] = STATE(1105),
    [anon_sym_SEMI] = ACTIONS(6680),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [sym_comment] = ACTIONS(91),
  },
  [2505] = {
    [sym_compound_statement] = STATE(2971),
    [sym_labeled_statement] = STATE(2971),
    [sym_expression_statement] = STATE(2971),
    [sym_if_statement] = STATE(2971),
    [sym_switch_statement] = STATE(2971),
    [sym_case_statement] = STATE(2971),
    [sym_while_statement] = STATE(2971),
    [sym_do_statement] = STATE(2971),
    [sym_for_statement] = STATE(2971),
    [sym_return_statement] = STATE(2971),
    [sym_break_statement] = STATE(2971),
    [sym_continue_statement] = STATE(2971),
    [sym_goto_statement] = STATE(2971),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(411),
    [sym_for_range_loop] = STATE(2971),
    [sym_try_statement] = STATE(2971),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(678),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(6682),
    [anon_sym_switch] = ACTIONS(6684),
    [anon_sym_case] = ACTIONS(6686),
    [anon_sym_default] = ACTIONS(6688),
    [anon_sym_while] = ACTIONS(6690),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(6692),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(6694),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(6696),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(726),
  },
  [2506] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(6698),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2507] = {
    [sym_raw_string_literal] = ACTIONS(4513),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4515),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4515),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4515),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4515),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4515),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4515),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4515),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4515),
    [sym_preproc_directive] = ACTIONS(4515),
    [anon_sym_SEMI] = ACTIONS(4513),
    [anon_sym_typedef] = ACTIONS(4515),
    [anon_sym_extern] = ACTIONS(4515),
    [anon_sym_LBRACE] = ACTIONS(4513),
    [anon_sym_LPAREN2] = ACTIONS(4513),
    [anon_sym_STAR] = ACTIONS(4513),
    [anon_sym_LBRACK] = ACTIONS(4513),
    [anon_sym_static] = ACTIONS(4515),
    [anon_sym_register] = ACTIONS(4515),
    [anon_sym_inline] = ACTIONS(4515),
    [anon_sym_const] = ACTIONS(4515),
    [anon_sym_restrict] = ACTIONS(4515),
    [anon_sym_volatile] = ACTIONS(4515),
    [anon_sym__Atomic] = ACTIONS(4515),
    [anon_sym_mutable] = ACTIONS(4515),
    [anon_sym_explicit] = ACTIONS(4515),
    [anon_sym_constexpr] = ACTIONS(4515),
    [anon_sym_unsigned] = ACTIONS(4515),
    [anon_sym_long] = ACTIONS(4515),
    [anon_sym_short] = ACTIONS(4515),
    [sym_primitive_type] = ACTIONS(4515),
    [anon_sym_enum] = ACTIONS(4515),
    [anon_sym_struct] = ACTIONS(4515),
    [anon_sym_union] = ACTIONS(4515),
    [anon_sym_if] = ACTIONS(4515),
    [anon_sym_else] = ACTIONS(4515),
    [anon_sym_switch] = ACTIONS(4515),
    [anon_sym_case] = ACTIONS(4515),
    [anon_sym_default] = ACTIONS(4515),
    [anon_sym_while] = ACTIONS(4515),
    [anon_sym_do] = ACTIONS(4515),
    [anon_sym_for] = ACTIONS(4515),
    [anon_sym_return] = ACTIONS(4515),
    [anon_sym_break] = ACTIONS(4515),
    [anon_sym_continue] = ACTIONS(4515),
    [anon_sym_goto] = ACTIONS(4515),
    [anon_sym_AMP] = ACTIONS(4515),
    [anon_sym_AMP_AMP] = ACTIONS(4513),
    [anon_sym_BANG] = ACTIONS(4513),
    [anon_sym_TILDE] = ACTIONS(4513),
    [anon_sym_PLUS] = ACTIONS(4515),
    [anon_sym_DASH] = ACTIONS(4515),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
    [anon_sym_sizeof] = ACTIONS(4515),
    [sym_number_literal] = ACTIONS(4513),
    [anon_sym_SQUOTE] = ACTIONS(4513),
    [anon_sym_DQUOTE] = ACTIONS(4513),
    [sym_true] = ACTIONS(4515),
    [sym_false] = ACTIONS(4515),
    [sym_null] = ACTIONS(4515),
    [sym_identifier] = ACTIONS(4515),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4515),
    [sym_auto] = ACTIONS(4515),
    [anon_sym_typename] = ACTIONS(4515),
    [anon_sym_template] = ACTIONS(4515),
    [anon_sym_delete] = ACTIONS(4515),
    [anon_sym_namespace] = ACTIONS(4515),
    [anon_sym_using] = ACTIONS(4515),
    [anon_sym_try] = ACTIONS(4515),
    [anon_sym_new] = ACTIONS(4515),
    [anon_sym_COLON_COLON] = ACTIONS(4513),
    [sym_operator_name] = ACTIONS(4513),
    [sym_nullptr] = ACTIONS(4515),
  },
  [2508] = {
    [sym_parameter_list] = STATE(897),
    [sym_argument_list] = STATE(898),
    [sym_initializer_list] = STATE(898),
    [aux_sym_declaration_repeat1] = STATE(1839),
    [anon_sym_COMMA] = ACTIONS(1613),
    [anon_sym_SEMI] = ACTIONS(3843),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(1619),
    [anon_sym_LBRACK] = ACTIONS(574),
    [anon_sym_EQ] = ACTIONS(1621),
    [sym_comment] = ACTIONS(91),
  },
  [2509] = {
    [sym__expression] = STATE(2973),
    [sym_comma_expression] = STATE(2974),
    [sym_conditional_expression] = STATE(2973),
    [sym_assignment_expression] = STATE(2973),
    [sym_pointer_expression] = STATE(2973),
    [sym_logical_expression] = STATE(2973),
    [sym_bitwise_expression] = STATE(2973),
    [sym_equality_expression] = STATE(2973),
    [sym_relational_expression] = STATE(2973),
    [sym_shift_expression] = STATE(2973),
    [sym_math_expression] = STATE(2973),
    [sym_cast_expression] = STATE(2973),
    [sym_sizeof_expression] = STATE(2973),
    [sym_subscript_expression] = STATE(2973),
    [sym_call_expression] = STATE(2973),
    [sym_field_expression] = STATE(2973),
    [sym_compound_literal_expression] = STATE(2973),
    [sym_parenthesized_expression] = STATE(2973),
    [sym_char_literal] = STATE(2973),
    [sym_concatenated_string] = STATE(2973),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2973),
    [sym_new_expression] = STATE(2973),
    [sym_delete_expression] = STATE(2973),
    [sym_lambda_expression] = STATE(2973),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6700),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(6700),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6702),
    [sym_false] = ACTIONS(6702),
    [sym_null] = ACTIONS(6702),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(6702),
  },
  [2510] = {
    [sym_raw_string_literal] = ACTIONS(4554),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4556),
    [sym_preproc_directive] = ACTIONS(4556),
    [anon_sym_SEMI] = ACTIONS(4554),
    [anon_sym_typedef] = ACTIONS(4556),
    [anon_sym_extern] = ACTIONS(4556),
    [anon_sym_LBRACE] = ACTIONS(4554),
    [anon_sym_LPAREN2] = ACTIONS(4554),
    [anon_sym_STAR] = ACTIONS(4554),
    [anon_sym_LBRACK] = ACTIONS(4554),
    [anon_sym_static] = ACTIONS(4556),
    [anon_sym_register] = ACTIONS(4556),
    [anon_sym_inline] = ACTIONS(4556),
    [anon_sym_const] = ACTIONS(4556),
    [anon_sym_restrict] = ACTIONS(4556),
    [anon_sym_volatile] = ACTIONS(4556),
    [anon_sym__Atomic] = ACTIONS(4556),
    [anon_sym_mutable] = ACTIONS(4556),
    [anon_sym_explicit] = ACTIONS(4556),
    [anon_sym_constexpr] = ACTIONS(4556),
    [anon_sym_unsigned] = ACTIONS(4556),
    [anon_sym_long] = ACTIONS(4556),
    [anon_sym_short] = ACTIONS(4556),
    [sym_primitive_type] = ACTIONS(4556),
    [anon_sym_enum] = ACTIONS(4556),
    [anon_sym_struct] = ACTIONS(4556),
    [anon_sym_union] = ACTIONS(4556),
    [anon_sym_if] = ACTIONS(4556),
    [anon_sym_else] = ACTIONS(4556),
    [anon_sym_switch] = ACTIONS(4556),
    [anon_sym_case] = ACTIONS(4556),
    [anon_sym_default] = ACTIONS(4556),
    [anon_sym_while] = ACTIONS(4556),
    [anon_sym_do] = ACTIONS(4556),
    [anon_sym_for] = ACTIONS(4556),
    [anon_sym_return] = ACTIONS(4556),
    [anon_sym_break] = ACTIONS(4556),
    [anon_sym_continue] = ACTIONS(4556),
    [anon_sym_goto] = ACTIONS(4556),
    [anon_sym_AMP] = ACTIONS(4556),
    [anon_sym_AMP_AMP] = ACTIONS(4554),
    [anon_sym_BANG] = ACTIONS(4554),
    [anon_sym_TILDE] = ACTIONS(4554),
    [anon_sym_PLUS] = ACTIONS(4556),
    [anon_sym_DASH] = ACTIONS(4556),
    [anon_sym_DASH_DASH] = ACTIONS(4554),
    [anon_sym_PLUS_PLUS] = ACTIONS(4554),
    [anon_sym_sizeof] = ACTIONS(4556),
    [sym_number_literal] = ACTIONS(4554),
    [anon_sym_SQUOTE] = ACTIONS(4554),
    [anon_sym_DQUOTE] = ACTIONS(4554),
    [sym_true] = ACTIONS(4556),
    [sym_false] = ACTIONS(4556),
    [sym_null] = ACTIONS(4556),
    [sym_identifier] = ACTIONS(4556),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4556),
    [sym_auto] = ACTIONS(4556),
    [anon_sym_typename] = ACTIONS(4556),
    [anon_sym_template] = ACTIONS(4556),
    [anon_sym_delete] = ACTIONS(4556),
    [anon_sym_namespace] = ACTIONS(4556),
    [anon_sym_using] = ACTIONS(4556),
    [anon_sym_try] = ACTIONS(4556),
    [anon_sym_new] = ACTIONS(4556),
    [anon_sym_COLON_COLON] = ACTIONS(4554),
    [sym_operator_name] = ACTIONS(4554),
    [sym_nullptr] = ACTIONS(4556),
  },
  [2511] = {
    [sym__expression] = STATE(2976),
    [sym_conditional_expression] = STATE(2976),
    [sym_assignment_expression] = STATE(2976),
    [sym_pointer_expression] = STATE(2976),
    [sym_logical_expression] = STATE(2976),
    [sym_bitwise_expression] = STATE(2976),
    [sym_equality_expression] = STATE(2976),
    [sym_relational_expression] = STATE(2976),
    [sym_shift_expression] = STATE(2976),
    [sym_math_expression] = STATE(2976),
    [sym_cast_expression] = STATE(2976),
    [sym_sizeof_expression] = STATE(2976),
    [sym_subscript_expression] = STATE(2976),
    [sym_call_expression] = STATE(2976),
    [sym_field_expression] = STATE(2976),
    [sym_compound_literal_expression] = STATE(2976),
    [sym_parenthesized_expression] = STATE(2976),
    [sym_char_literal] = STATE(2976),
    [sym_concatenated_string] = STATE(2976),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2976),
    [sym_new_expression] = STATE(2976),
    [sym_delete_expression] = STATE(2976),
    [sym_lambda_expression] = STATE(2976),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6704),
    [anon_sym_RPAREN] = ACTIONS(6706),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(6704),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6708),
    [sym_false] = ACTIONS(6708),
    [sym_null] = ACTIONS(6708),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(6708),
  },
  [2512] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(6710),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2513] = {
    [sym__expression] = STATE(2978),
    [sym_conditional_expression] = STATE(2978),
    [sym_assignment_expression] = STATE(2978),
    [sym_pointer_expression] = STATE(2978),
    [sym_logical_expression] = STATE(2978),
    [sym_bitwise_expression] = STATE(2978),
    [sym_equality_expression] = STATE(2978),
    [sym_relational_expression] = STATE(2978),
    [sym_shift_expression] = STATE(2978),
    [sym_math_expression] = STATE(2978),
    [sym_cast_expression] = STATE(2978),
    [sym_sizeof_expression] = STATE(2978),
    [sym_subscript_expression] = STATE(2978),
    [sym_call_expression] = STATE(2978),
    [sym_field_expression] = STATE(2978),
    [sym_compound_literal_expression] = STATE(2978),
    [sym_parenthesized_expression] = STATE(2978),
    [sym_char_literal] = STATE(2978),
    [sym_concatenated_string] = STATE(2978),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2978),
    [sym_new_expression] = STATE(2978),
    [sym_delete_expression] = STATE(2978),
    [sym_lambda_expression] = STATE(2978),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6712),
    [anon_sym_SEMI] = ACTIONS(6710),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(6712),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6714),
    [sym_false] = ACTIONS(6714),
    [sym_null] = ACTIONS(6714),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(6714),
  },
  [2514] = {
    [sym__expression] = STATE(2979),
    [sym_conditional_expression] = STATE(2979),
    [sym_assignment_expression] = STATE(2979),
    [sym_pointer_expression] = STATE(2979),
    [sym_logical_expression] = STATE(2979),
    [sym_bitwise_expression] = STATE(2979),
    [sym_equality_expression] = STATE(2979),
    [sym_relational_expression] = STATE(2979),
    [sym_shift_expression] = STATE(2979),
    [sym_math_expression] = STATE(2979),
    [sym_cast_expression] = STATE(2979),
    [sym_sizeof_expression] = STATE(2979),
    [sym_subscript_expression] = STATE(2979),
    [sym_call_expression] = STATE(2979),
    [sym_field_expression] = STATE(2979),
    [sym_compound_literal_expression] = STATE(2979),
    [sym_parenthesized_expression] = STATE(2979),
    [sym_char_literal] = STATE(2979),
    [sym_concatenated_string] = STATE(2979),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2979),
    [sym_new_expression] = STATE(2979),
    [sym_delete_expression] = STATE(2979),
    [sym_lambda_expression] = STATE(2979),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6716),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(6716),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6718),
    [sym_false] = ACTIONS(6718),
    [sym_null] = ACTIONS(6718),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(6718),
  },
  [2515] = {
    [sym_raw_string_literal] = ACTIONS(4912),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4914),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4914),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4914),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4914),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4914),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4914),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4914),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4914),
    [sym_preproc_directive] = ACTIONS(4914),
    [anon_sym_SEMI] = ACTIONS(4912),
    [anon_sym_typedef] = ACTIONS(4914),
    [anon_sym_extern] = ACTIONS(4914),
    [anon_sym_LBRACE] = ACTIONS(4912),
    [anon_sym_LPAREN2] = ACTIONS(4912),
    [anon_sym_STAR] = ACTIONS(4912),
    [anon_sym_LBRACK] = ACTIONS(4912),
    [anon_sym_static] = ACTIONS(4914),
    [anon_sym_register] = ACTIONS(4914),
    [anon_sym_inline] = ACTIONS(4914),
    [anon_sym_const] = ACTIONS(4914),
    [anon_sym_restrict] = ACTIONS(4914),
    [anon_sym_volatile] = ACTIONS(4914),
    [anon_sym__Atomic] = ACTIONS(4914),
    [anon_sym_mutable] = ACTIONS(4914),
    [anon_sym_explicit] = ACTIONS(4914),
    [anon_sym_constexpr] = ACTIONS(4914),
    [anon_sym_unsigned] = ACTIONS(4914),
    [anon_sym_long] = ACTIONS(4914),
    [anon_sym_short] = ACTIONS(4914),
    [sym_primitive_type] = ACTIONS(4914),
    [anon_sym_enum] = ACTIONS(4914),
    [anon_sym_struct] = ACTIONS(4914),
    [anon_sym_union] = ACTIONS(4914),
    [anon_sym_if] = ACTIONS(4914),
    [anon_sym_switch] = ACTIONS(4914),
    [anon_sym_case] = ACTIONS(4914),
    [anon_sym_default] = ACTIONS(4914),
    [anon_sym_while] = ACTIONS(4914),
    [anon_sym_do] = ACTIONS(4914),
    [anon_sym_for] = ACTIONS(4914),
    [anon_sym_return] = ACTIONS(4914),
    [anon_sym_break] = ACTIONS(4914),
    [anon_sym_continue] = ACTIONS(4914),
    [anon_sym_goto] = ACTIONS(4914),
    [anon_sym_AMP] = ACTIONS(4914),
    [anon_sym_AMP_AMP] = ACTIONS(4912),
    [anon_sym_BANG] = ACTIONS(4912),
    [anon_sym_TILDE] = ACTIONS(4912),
    [anon_sym_PLUS] = ACTIONS(4914),
    [anon_sym_DASH] = ACTIONS(4914),
    [anon_sym_DASH_DASH] = ACTIONS(4912),
    [anon_sym_PLUS_PLUS] = ACTIONS(4912),
    [anon_sym_sizeof] = ACTIONS(4914),
    [sym_number_literal] = ACTIONS(4912),
    [anon_sym_SQUOTE] = ACTIONS(4912),
    [anon_sym_DQUOTE] = ACTIONS(4912),
    [sym_true] = ACTIONS(4914),
    [sym_false] = ACTIONS(4914),
    [sym_null] = ACTIONS(4914),
    [sym_identifier] = ACTIONS(4914),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4914),
    [sym_auto] = ACTIONS(4914),
    [anon_sym_typename] = ACTIONS(4914),
    [anon_sym_template] = ACTIONS(4914),
    [anon_sym_delete] = ACTIONS(4914),
    [anon_sym_namespace] = ACTIONS(4914),
    [anon_sym_using] = ACTIONS(4914),
    [anon_sym_try] = ACTIONS(4914),
    [anon_sym_new] = ACTIONS(4914),
    [anon_sym_COLON_COLON] = ACTIONS(4912),
    [sym_operator_name] = ACTIONS(4912),
    [sym_nullptr] = ACTIONS(4914),
  },
  [2516] = {
    [sym_raw_string_literal] = ACTIONS(4949),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4951),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4951),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4951),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4951),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4951),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4951),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4951),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4951),
    [sym_preproc_directive] = ACTIONS(4951),
    [anon_sym_SEMI] = ACTIONS(4949),
    [anon_sym_typedef] = ACTIONS(4951),
    [anon_sym_extern] = ACTIONS(4951),
    [anon_sym_LBRACE] = ACTIONS(4949),
    [anon_sym_LPAREN2] = ACTIONS(4949),
    [anon_sym_STAR] = ACTIONS(4949),
    [anon_sym_LBRACK] = ACTIONS(4949),
    [anon_sym_static] = ACTIONS(4951),
    [anon_sym_register] = ACTIONS(4951),
    [anon_sym_inline] = ACTIONS(4951),
    [anon_sym_const] = ACTIONS(4951),
    [anon_sym_restrict] = ACTIONS(4951),
    [anon_sym_volatile] = ACTIONS(4951),
    [anon_sym__Atomic] = ACTIONS(4951),
    [anon_sym_mutable] = ACTIONS(4951),
    [anon_sym_explicit] = ACTIONS(4951),
    [anon_sym_constexpr] = ACTIONS(4951),
    [anon_sym_unsigned] = ACTIONS(4951),
    [anon_sym_long] = ACTIONS(4951),
    [anon_sym_short] = ACTIONS(4951),
    [sym_primitive_type] = ACTIONS(4951),
    [anon_sym_enum] = ACTIONS(4951),
    [anon_sym_struct] = ACTIONS(4951),
    [anon_sym_union] = ACTIONS(4951),
    [anon_sym_if] = ACTIONS(4951),
    [anon_sym_switch] = ACTIONS(4951),
    [anon_sym_case] = ACTIONS(4951),
    [anon_sym_default] = ACTIONS(4951),
    [anon_sym_while] = ACTIONS(4951),
    [anon_sym_do] = ACTIONS(4951),
    [anon_sym_for] = ACTIONS(4951),
    [anon_sym_return] = ACTIONS(4951),
    [anon_sym_break] = ACTIONS(4951),
    [anon_sym_continue] = ACTIONS(4951),
    [anon_sym_goto] = ACTIONS(4951),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_AMP_AMP] = ACTIONS(4949),
    [anon_sym_BANG] = ACTIONS(4949),
    [anon_sym_TILDE] = ACTIONS(4949),
    [anon_sym_PLUS] = ACTIONS(4951),
    [anon_sym_DASH] = ACTIONS(4951),
    [anon_sym_DASH_DASH] = ACTIONS(4949),
    [anon_sym_PLUS_PLUS] = ACTIONS(4949),
    [anon_sym_sizeof] = ACTIONS(4951),
    [sym_number_literal] = ACTIONS(4949),
    [anon_sym_SQUOTE] = ACTIONS(4949),
    [anon_sym_DQUOTE] = ACTIONS(4949),
    [sym_true] = ACTIONS(4951),
    [sym_false] = ACTIONS(4951),
    [sym_null] = ACTIONS(4951),
    [sym_identifier] = ACTIONS(4951),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4951),
    [sym_auto] = ACTIONS(4951),
    [anon_sym_typename] = ACTIONS(4951),
    [anon_sym_template] = ACTIONS(4951),
    [anon_sym_delete] = ACTIONS(4951),
    [anon_sym_namespace] = ACTIONS(4951),
    [anon_sym_using] = ACTIONS(4951),
    [anon_sym_try] = ACTIONS(4951),
    [anon_sym_new] = ACTIONS(4951),
    [anon_sym_COLON_COLON] = ACTIONS(4949),
    [sym_operator_name] = ACTIONS(4949),
    [sym_nullptr] = ACTIONS(4951),
  },
  [2517] = {
    [anon_sym_SEMI] = ACTIONS(6720),
    [sym_comment] = ACTIONS(91),
  },
  [2518] = {
    [sym_raw_string_literal] = ACTIONS(4989),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4991),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4991),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4991),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4991),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4991),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4991),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4991),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4991),
    [sym_preproc_directive] = ACTIONS(4991),
    [anon_sym_SEMI] = ACTIONS(4989),
    [anon_sym_typedef] = ACTIONS(4991),
    [anon_sym_extern] = ACTIONS(4991),
    [anon_sym_LBRACE] = ACTIONS(4989),
    [anon_sym_LPAREN2] = ACTIONS(4989),
    [anon_sym_STAR] = ACTIONS(4989),
    [anon_sym_LBRACK] = ACTIONS(4989),
    [anon_sym_static] = ACTIONS(4991),
    [anon_sym_register] = ACTIONS(4991),
    [anon_sym_inline] = ACTIONS(4991),
    [anon_sym_const] = ACTIONS(4991),
    [anon_sym_restrict] = ACTIONS(4991),
    [anon_sym_volatile] = ACTIONS(4991),
    [anon_sym__Atomic] = ACTIONS(4991),
    [anon_sym_mutable] = ACTIONS(4991),
    [anon_sym_explicit] = ACTIONS(4991),
    [anon_sym_constexpr] = ACTIONS(4991),
    [anon_sym_unsigned] = ACTIONS(4991),
    [anon_sym_long] = ACTIONS(4991),
    [anon_sym_short] = ACTIONS(4991),
    [sym_primitive_type] = ACTIONS(4991),
    [anon_sym_enum] = ACTIONS(4991),
    [anon_sym_struct] = ACTIONS(4991),
    [anon_sym_union] = ACTIONS(4991),
    [anon_sym_if] = ACTIONS(4991),
    [anon_sym_switch] = ACTIONS(4991),
    [anon_sym_case] = ACTIONS(4991),
    [anon_sym_default] = ACTIONS(4991),
    [anon_sym_while] = ACTIONS(4991),
    [anon_sym_do] = ACTIONS(4991),
    [anon_sym_for] = ACTIONS(4991),
    [anon_sym_return] = ACTIONS(4991),
    [anon_sym_break] = ACTIONS(4991),
    [anon_sym_continue] = ACTIONS(4991),
    [anon_sym_goto] = ACTIONS(4991),
    [anon_sym_AMP] = ACTIONS(4991),
    [anon_sym_AMP_AMP] = ACTIONS(4989),
    [anon_sym_BANG] = ACTIONS(4989),
    [anon_sym_TILDE] = ACTIONS(4989),
    [anon_sym_PLUS] = ACTIONS(4991),
    [anon_sym_DASH] = ACTIONS(4991),
    [anon_sym_DASH_DASH] = ACTIONS(4989),
    [anon_sym_PLUS_PLUS] = ACTIONS(4989),
    [anon_sym_sizeof] = ACTIONS(4991),
    [sym_number_literal] = ACTIONS(4989),
    [anon_sym_SQUOTE] = ACTIONS(4989),
    [anon_sym_DQUOTE] = ACTIONS(4989),
    [sym_true] = ACTIONS(4991),
    [sym_false] = ACTIONS(4991),
    [sym_null] = ACTIONS(4991),
    [sym_identifier] = ACTIONS(4991),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4991),
    [sym_auto] = ACTIONS(4991),
    [anon_sym_typename] = ACTIONS(4991),
    [anon_sym_template] = ACTIONS(4991),
    [anon_sym_delete] = ACTIONS(4991),
    [anon_sym_namespace] = ACTIONS(4991),
    [anon_sym_using] = ACTIONS(4991),
    [anon_sym_try] = ACTIONS(4991),
    [anon_sym_new] = ACTIONS(4991),
    [anon_sym_COLON_COLON] = ACTIONS(4989),
    [sym_operator_name] = ACTIONS(4989),
    [sym_nullptr] = ACTIONS(4991),
  },
  [2519] = {
    [sym_compound_statement] = STATE(2981),
    [anon_sym_LBRACE] = ACTIONS(702),
    [sym_comment] = ACTIONS(91),
  },
  [2520] = {
    [sym_catch_clause] = STATE(2520),
    [aux_sym_try_statement_repeat1] = STATE(2520),
    [sym_raw_string_literal] = ACTIONS(4993),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4995),
    [sym_preproc_directive] = ACTIONS(4995),
    [anon_sym_SEMI] = ACTIONS(4993),
    [anon_sym_typedef] = ACTIONS(4995),
    [anon_sym_extern] = ACTIONS(4995),
    [anon_sym_LBRACE] = ACTIONS(4993),
    [anon_sym_LPAREN2] = ACTIONS(4993),
    [anon_sym_STAR] = ACTIONS(4993),
    [anon_sym_LBRACK] = ACTIONS(4993),
    [anon_sym_static] = ACTIONS(4995),
    [anon_sym_register] = ACTIONS(4995),
    [anon_sym_inline] = ACTIONS(4995),
    [anon_sym_const] = ACTIONS(4995),
    [anon_sym_restrict] = ACTIONS(4995),
    [anon_sym_volatile] = ACTIONS(4995),
    [anon_sym__Atomic] = ACTIONS(4995),
    [anon_sym_mutable] = ACTIONS(4995),
    [anon_sym_explicit] = ACTIONS(4995),
    [anon_sym_constexpr] = ACTIONS(4995),
    [anon_sym_unsigned] = ACTIONS(4995),
    [anon_sym_long] = ACTIONS(4995),
    [anon_sym_short] = ACTIONS(4995),
    [sym_primitive_type] = ACTIONS(4995),
    [anon_sym_enum] = ACTIONS(4995),
    [anon_sym_struct] = ACTIONS(4995),
    [anon_sym_union] = ACTIONS(4995),
    [anon_sym_if] = ACTIONS(4995),
    [anon_sym_switch] = ACTIONS(4995),
    [anon_sym_case] = ACTIONS(4995),
    [anon_sym_default] = ACTIONS(4995),
    [anon_sym_while] = ACTIONS(4995),
    [anon_sym_do] = ACTIONS(4995),
    [anon_sym_for] = ACTIONS(4995),
    [anon_sym_return] = ACTIONS(4995),
    [anon_sym_break] = ACTIONS(4995),
    [anon_sym_continue] = ACTIONS(4995),
    [anon_sym_goto] = ACTIONS(4995),
    [anon_sym_AMP] = ACTIONS(4995),
    [anon_sym_AMP_AMP] = ACTIONS(4993),
    [anon_sym_BANG] = ACTIONS(4993),
    [anon_sym_TILDE] = ACTIONS(4993),
    [anon_sym_PLUS] = ACTIONS(4995),
    [anon_sym_DASH] = ACTIONS(4995),
    [anon_sym_DASH_DASH] = ACTIONS(4993),
    [anon_sym_PLUS_PLUS] = ACTIONS(4993),
    [anon_sym_sizeof] = ACTIONS(4995),
    [sym_number_literal] = ACTIONS(4993),
    [anon_sym_SQUOTE] = ACTIONS(4993),
    [anon_sym_DQUOTE] = ACTIONS(4993),
    [sym_true] = ACTIONS(4995),
    [sym_false] = ACTIONS(4995),
    [sym_null] = ACTIONS(4995),
    [sym_identifier] = ACTIONS(4995),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4995),
    [sym_auto] = ACTIONS(4995),
    [anon_sym_typename] = ACTIONS(4995),
    [anon_sym_template] = ACTIONS(4995),
    [anon_sym_delete] = ACTIONS(4995),
    [anon_sym_namespace] = ACTIONS(4995),
    [anon_sym_using] = ACTIONS(4995),
    [anon_sym_try] = ACTIONS(4995),
    [anon_sym_catch] = ACTIONS(6722),
    [anon_sym_new] = ACTIONS(4995),
    [anon_sym_COLON_COLON] = ACTIONS(4993),
    [sym_operator_name] = ACTIONS(4993),
    [sym_nullptr] = ACTIONS(4995),
  },
  [2521] = {
    [sym_raw_string_literal] = ACTIONS(801),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(803),
    [anon_sym_COMMA] = ACTIONS(2919),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(803),
    [sym_preproc_directive] = ACTIONS(803),
    [anon_sym_SEMI] = ACTIONS(2919),
    [anon_sym_typedef] = ACTIONS(803),
    [anon_sym_extern] = ACTIONS(803),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(801),
    [anon_sym_LBRACK] = ACTIONS(801),
    [anon_sym_static] = ACTIONS(803),
    [anon_sym_register] = ACTIONS(803),
    [anon_sym_inline] = ACTIONS(803),
    [anon_sym_const] = ACTIONS(803),
    [anon_sym_restrict] = ACTIONS(803),
    [anon_sym_volatile] = ACTIONS(803),
    [anon_sym__Atomic] = ACTIONS(803),
    [anon_sym_mutable] = ACTIONS(803),
    [anon_sym_explicit] = ACTIONS(803),
    [anon_sym_constexpr] = ACTIONS(803),
    [anon_sym_unsigned] = ACTIONS(803),
    [anon_sym_long] = ACTIONS(803),
    [anon_sym_short] = ACTIONS(803),
    [sym_primitive_type] = ACTIONS(803),
    [anon_sym_enum] = ACTIONS(803),
    [anon_sym_struct] = ACTIONS(803),
    [anon_sym_union] = ACTIONS(803),
    [anon_sym_if] = ACTIONS(803),
    [anon_sym_switch] = ACTIONS(803),
    [anon_sym_case] = ACTIONS(803),
    [anon_sym_default] = ACTIONS(803),
    [anon_sym_while] = ACTIONS(803),
    [anon_sym_do] = ACTIONS(803),
    [anon_sym_for] = ACTIONS(803),
    [anon_sym_return] = ACTIONS(803),
    [anon_sym_break] = ACTIONS(803),
    [anon_sym_continue] = ACTIONS(803),
    [anon_sym_goto] = ACTIONS(803),
    [anon_sym_AMP] = ACTIONS(803),
    [anon_sym_AMP_AMP] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_DASH] = ACTIONS(803),
    [anon_sym_DASH_DASH] = ACTIONS(801),
    [anon_sym_PLUS_PLUS] = ACTIONS(801),
    [anon_sym_sizeof] = ACTIONS(803),
    [sym_number_literal] = ACTIONS(801),
    [anon_sym_SQUOTE] = ACTIONS(801),
    [anon_sym_DQUOTE] = ACTIONS(801),
    [sym_true] = ACTIONS(803),
    [sym_false] = ACTIONS(803),
    [sym_null] = ACTIONS(803),
    [sym_identifier] = ACTIONS(803),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(803),
    [sym_auto] = ACTIONS(803),
    [anon_sym_typename] = ACTIONS(803),
    [anon_sym_template] = ACTIONS(803),
    [anon_sym_delete] = ACTIONS(803),
    [anon_sym_namespace] = ACTIONS(803),
    [anon_sym_using] = ACTIONS(803),
    [anon_sym_try] = ACTIONS(803),
    [anon_sym_new] = ACTIONS(803),
    [anon_sym_COLON_COLON] = ACTIONS(801),
    [sym_operator_name] = ACTIONS(801),
    [sym_nullptr] = ACTIONS(803),
  },
  [2522] = {
    [sym_raw_string_literal] = ACTIONS(5113),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5115),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5115),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5115),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5115),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5115),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5115),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5115),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5115),
    [sym_preproc_directive] = ACTIONS(5115),
    [anon_sym_SEMI] = ACTIONS(5113),
    [anon_sym_typedef] = ACTIONS(5115),
    [anon_sym_extern] = ACTIONS(5115),
    [anon_sym_LBRACE] = ACTIONS(5113),
    [anon_sym_LPAREN2] = ACTIONS(5113),
    [anon_sym_STAR] = ACTIONS(5113),
    [anon_sym_LBRACK] = ACTIONS(5113),
    [anon_sym_static] = ACTIONS(5115),
    [anon_sym_register] = ACTIONS(5115),
    [anon_sym_inline] = ACTIONS(5115),
    [anon_sym_const] = ACTIONS(5115),
    [anon_sym_restrict] = ACTIONS(5115),
    [anon_sym_volatile] = ACTIONS(5115),
    [anon_sym__Atomic] = ACTIONS(5115),
    [anon_sym_mutable] = ACTIONS(5115),
    [anon_sym_explicit] = ACTIONS(5115),
    [anon_sym_constexpr] = ACTIONS(5115),
    [anon_sym_unsigned] = ACTIONS(5115),
    [anon_sym_long] = ACTIONS(5115),
    [anon_sym_short] = ACTIONS(5115),
    [sym_primitive_type] = ACTIONS(5115),
    [anon_sym_enum] = ACTIONS(5115),
    [anon_sym_struct] = ACTIONS(5115),
    [anon_sym_union] = ACTIONS(5115),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_else] = ACTIONS(5115),
    [anon_sym_switch] = ACTIONS(5115),
    [anon_sym_case] = ACTIONS(5115),
    [anon_sym_default] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_for] = ACTIONS(5115),
    [anon_sym_return] = ACTIONS(5115),
    [anon_sym_break] = ACTIONS(5115),
    [anon_sym_continue] = ACTIONS(5115),
    [anon_sym_goto] = ACTIONS(5115),
    [anon_sym_AMP] = ACTIONS(5115),
    [anon_sym_AMP_AMP] = ACTIONS(5113),
    [anon_sym_BANG] = ACTIONS(5113),
    [anon_sym_TILDE] = ACTIONS(5113),
    [anon_sym_PLUS] = ACTIONS(5115),
    [anon_sym_DASH] = ACTIONS(5115),
    [anon_sym_DASH_DASH] = ACTIONS(5113),
    [anon_sym_PLUS_PLUS] = ACTIONS(5113),
    [anon_sym_sizeof] = ACTIONS(5115),
    [sym_number_literal] = ACTIONS(5113),
    [anon_sym_SQUOTE] = ACTIONS(5113),
    [anon_sym_DQUOTE] = ACTIONS(5113),
    [sym_true] = ACTIONS(5115),
    [sym_false] = ACTIONS(5115),
    [sym_null] = ACTIONS(5115),
    [sym_identifier] = ACTIONS(5115),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5115),
    [sym_auto] = ACTIONS(5115),
    [anon_sym_typename] = ACTIONS(5115),
    [anon_sym_template] = ACTIONS(5115),
    [anon_sym_delete] = ACTIONS(5115),
    [anon_sym_namespace] = ACTIONS(5115),
    [anon_sym_using] = ACTIONS(5115),
    [anon_sym_try] = ACTIONS(5115),
    [anon_sym_new] = ACTIONS(5115),
    [anon_sym_COLON_COLON] = ACTIONS(5113),
    [sym_operator_name] = ACTIONS(5113),
    [sym_nullptr] = ACTIONS(5115),
  },
  [2523] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(6725),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2524] = {
    [anon_sym_SEMI] = ACTIONS(6725),
    [sym_comment] = ACTIONS(91),
  },
  [2525] = {
    [sym_raw_string_literal] = ACTIONS(5122),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5124),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5124),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5124),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5124),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5124),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5124),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5124),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5124),
    [sym_preproc_directive] = ACTIONS(5124),
    [anon_sym_SEMI] = ACTIONS(5122),
    [anon_sym_typedef] = ACTIONS(5124),
    [anon_sym_extern] = ACTIONS(5124),
    [anon_sym_LBRACE] = ACTIONS(5122),
    [anon_sym_LPAREN2] = ACTIONS(5122),
    [anon_sym_STAR] = ACTIONS(5122),
    [anon_sym_LBRACK] = ACTIONS(5122),
    [anon_sym_static] = ACTIONS(5124),
    [anon_sym_register] = ACTIONS(5124),
    [anon_sym_inline] = ACTIONS(5124),
    [anon_sym_const] = ACTIONS(5124),
    [anon_sym_restrict] = ACTIONS(5124),
    [anon_sym_volatile] = ACTIONS(5124),
    [anon_sym__Atomic] = ACTIONS(5124),
    [anon_sym_mutable] = ACTIONS(5124),
    [anon_sym_explicit] = ACTIONS(5124),
    [anon_sym_constexpr] = ACTIONS(5124),
    [anon_sym_unsigned] = ACTIONS(5124),
    [anon_sym_long] = ACTIONS(5124),
    [anon_sym_short] = ACTIONS(5124),
    [sym_primitive_type] = ACTIONS(5124),
    [anon_sym_enum] = ACTIONS(5124),
    [anon_sym_struct] = ACTIONS(5124),
    [anon_sym_union] = ACTIONS(5124),
    [anon_sym_if] = ACTIONS(5124),
    [anon_sym_switch] = ACTIONS(5124),
    [anon_sym_case] = ACTIONS(5124),
    [anon_sym_default] = ACTIONS(5124),
    [anon_sym_while] = ACTIONS(5124),
    [anon_sym_do] = ACTIONS(5124),
    [anon_sym_for] = ACTIONS(5124),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_break] = ACTIONS(5124),
    [anon_sym_continue] = ACTIONS(5124),
    [anon_sym_goto] = ACTIONS(5124),
    [anon_sym_AMP] = ACTIONS(5124),
    [anon_sym_AMP_AMP] = ACTIONS(5122),
    [anon_sym_BANG] = ACTIONS(5122),
    [anon_sym_TILDE] = ACTIONS(5122),
    [anon_sym_PLUS] = ACTIONS(5124),
    [anon_sym_DASH] = ACTIONS(5124),
    [anon_sym_DASH_DASH] = ACTIONS(5122),
    [anon_sym_PLUS_PLUS] = ACTIONS(5122),
    [anon_sym_sizeof] = ACTIONS(5124),
    [sym_number_literal] = ACTIONS(5122),
    [anon_sym_SQUOTE] = ACTIONS(5122),
    [anon_sym_DQUOTE] = ACTIONS(5122),
    [sym_true] = ACTIONS(5124),
    [sym_false] = ACTIONS(5124),
    [sym_null] = ACTIONS(5124),
    [sym_identifier] = ACTIONS(5124),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5124),
    [sym_auto] = ACTIONS(5124),
    [anon_sym_typename] = ACTIONS(5124),
    [anon_sym_template] = ACTIONS(5124),
    [anon_sym_delete] = ACTIONS(5124),
    [anon_sym_namespace] = ACTIONS(5124),
    [anon_sym_using] = ACTIONS(5124),
    [anon_sym_try] = ACTIONS(5124),
    [anon_sym_new] = ACTIONS(5124),
    [anon_sym_COLON_COLON] = ACTIONS(5122),
    [sym_operator_name] = ACTIONS(5122),
    [sym_nullptr] = ACTIONS(5124),
  },
  [2526] = {
    [sym_raw_string_literal] = ACTIONS(5253),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5255),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5255),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5255),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5255),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5255),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5255),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5255),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5255),
    [sym_preproc_directive] = ACTIONS(5255),
    [anon_sym_SEMI] = ACTIONS(5253),
    [anon_sym_typedef] = ACTIONS(5255),
    [anon_sym_extern] = ACTIONS(5255),
    [anon_sym_LBRACE] = ACTIONS(5253),
    [anon_sym_LPAREN2] = ACTIONS(5253),
    [anon_sym_STAR] = ACTIONS(5253),
    [anon_sym_LBRACK] = ACTIONS(5253),
    [anon_sym_static] = ACTIONS(5255),
    [anon_sym_register] = ACTIONS(5255),
    [anon_sym_inline] = ACTIONS(5255),
    [anon_sym_const] = ACTIONS(5255),
    [anon_sym_restrict] = ACTIONS(5255),
    [anon_sym_volatile] = ACTIONS(5255),
    [anon_sym__Atomic] = ACTIONS(5255),
    [anon_sym_mutable] = ACTIONS(5255),
    [anon_sym_explicit] = ACTIONS(5255),
    [anon_sym_constexpr] = ACTIONS(5255),
    [anon_sym_unsigned] = ACTIONS(5255),
    [anon_sym_long] = ACTIONS(5255),
    [anon_sym_short] = ACTIONS(5255),
    [sym_primitive_type] = ACTIONS(5255),
    [anon_sym_enum] = ACTIONS(5255),
    [anon_sym_struct] = ACTIONS(5255),
    [anon_sym_union] = ACTIONS(5255),
    [anon_sym_if] = ACTIONS(5255),
    [anon_sym_switch] = ACTIONS(5255),
    [anon_sym_case] = ACTIONS(5255),
    [anon_sym_default] = ACTIONS(5255),
    [anon_sym_while] = ACTIONS(5255),
    [anon_sym_do] = ACTIONS(5255),
    [anon_sym_for] = ACTIONS(5255),
    [anon_sym_return] = ACTIONS(5255),
    [anon_sym_break] = ACTIONS(5255),
    [anon_sym_continue] = ACTIONS(5255),
    [anon_sym_goto] = ACTIONS(5255),
    [anon_sym_AMP] = ACTIONS(5255),
    [anon_sym_AMP_AMP] = ACTIONS(5253),
    [anon_sym_BANG] = ACTIONS(5253),
    [anon_sym_TILDE] = ACTIONS(5253),
    [anon_sym_PLUS] = ACTIONS(5255),
    [anon_sym_DASH] = ACTIONS(5255),
    [anon_sym_DASH_DASH] = ACTIONS(5253),
    [anon_sym_PLUS_PLUS] = ACTIONS(5253),
    [anon_sym_sizeof] = ACTIONS(5255),
    [sym_number_literal] = ACTIONS(5253),
    [anon_sym_SQUOTE] = ACTIONS(5253),
    [anon_sym_DQUOTE] = ACTIONS(5253),
    [sym_true] = ACTIONS(5255),
    [sym_false] = ACTIONS(5255),
    [sym_null] = ACTIONS(5255),
    [sym_identifier] = ACTIONS(5255),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5255),
    [sym_auto] = ACTIONS(5255),
    [anon_sym_typename] = ACTIONS(5255),
    [anon_sym_template] = ACTIONS(5255),
    [anon_sym_delete] = ACTIONS(5255),
    [anon_sym_namespace] = ACTIONS(5255),
    [anon_sym_using] = ACTIONS(5255),
    [anon_sym_try] = ACTIONS(5255),
    [anon_sym_new] = ACTIONS(5255),
    [anon_sym_COLON_COLON] = ACTIONS(5253),
    [sym_operator_name] = ACTIONS(5253),
    [sym_nullptr] = ACTIONS(5255),
  },
  [2527] = {
    [sym_raw_string_literal] = ACTIONS(5257),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5259),
    [sym_preproc_directive] = ACTIONS(5259),
    [anon_sym_SEMI] = ACTIONS(5257),
    [anon_sym_typedef] = ACTIONS(5259),
    [anon_sym_extern] = ACTIONS(5259),
    [anon_sym_LBRACE] = ACTIONS(5257),
    [anon_sym_LPAREN2] = ACTIONS(5257),
    [anon_sym_STAR] = ACTIONS(5257),
    [anon_sym_LBRACK] = ACTIONS(5257),
    [anon_sym_static] = ACTIONS(5259),
    [anon_sym_register] = ACTIONS(5259),
    [anon_sym_inline] = ACTIONS(5259),
    [anon_sym_const] = ACTIONS(5259),
    [anon_sym_restrict] = ACTIONS(5259),
    [anon_sym_volatile] = ACTIONS(5259),
    [anon_sym__Atomic] = ACTIONS(5259),
    [anon_sym_mutable] = ACTIONS(5259),
    [anon_sym_explicit] = ACTIONS(5259),
    [anon_sym_constexpr] = ACTIONS(5259),
    [anon_sym_unsigned] = ACTIONS(5259),
    [anon_sym_long] = ACTIONS(5259),
    [anon_sym_short] = ACTIONS(5259),
    [sym_primitive_type] = ACTIONS(5259),
    [anon_sym_enum] = ACTIONS(5259),
    [anon_sym_struct] = ACTIONS(5259),
    [anon_sym_union] = ACTIONS(5259),
    [anon_sym_if] = ACTIONS(5259),
    [anon_sym_switch] = ACTIONS(5259),
    [anon_sym_case] = ACTIONS(5259),
    [anon_sym_default] = ACTIONS(5259),
    [anon_sym_while] = ACTIONS(5259),
    [anon_sym_do] = ACTIONS(5259),
    [anon_sym_for] = ACTIONS(5259),
    [anon_sym_return] = ACTIONS(5259),
    [anon_sym_break] = ACTIONS(5259),
    [anon_sym_continue] = ACTIONS(5259),
    [anon_sym_goto] = ACTIONS(5259),
    [anon_sym_AMP] = ACTIONS(5259),
    [anon_sym_AMP_AMP] = ACTIONS(5257),
    [anon_sym_BANG] = ACTIONS(5257),
    [anon_sym_TILDE] = ACTIONS(5257),
    [anon_sym_PLUS] = ACTIONS(5259),
    [anon_sym_DASH] = ACTIONS(5259),
    [anon_sym_DASH_DASH] = ACTIONS(5257),
    [anon_sym_PLUS_PLUS] = ACTIONS(5257),
    [anon_sym_sizeof] = ACTIONS(5259),
    [sym_number_literal] = ACTIONS(5257),
    [anon_sym_SQUOTE] = ACTIONS(5257),
    [anon_sym_DQUOTE] = ACTIONS(5257),
    [sym_true] = ACTIONS(5259),
    [sym_false] = ACTIONS(5259),
    [sym_null] = ACTIONS(5259),
    [sym_identifier] = ACTIONS(5259),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5259),
    [sym_auto] = ACTIONS(5259),
    [anon_sym_typename] = ACTIONS(5259),
    [anon_sym_template] = ACTIONS(5259),
    [anon_sym_delete] = ACTIONS(5259),
    [anon_sym_namespace] = ACTIONS(5259),
    [anon_sym_using] = ACTIONS(5259),
    [anon_sym_try] = ACTIONS(5259),
    [anon_sym_new] = ACTIONS(5259),
    [anon_sym_COLON_COLON] = ACTIONS(5257),
    [sym_operator_name] = ACTIONS(5257),
    [sym_nullptr] = ACTIONS(5259),
  },
  [2528] = {
    [sym_raw_string_literal] = ACTIONS(5366),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5368),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5368),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5368),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5368),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5368),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5368),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5368),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5368),
    [sym_preproc_directive] = ACTIONS(5368),
    [anon_sym_SEMI] = ACTIONS(5366),
    [anon_sym_typedef] = ACTIONS(5368),
    [anon_sym_extern] = ACTIONS(5368),
    [anon_sym_LBRACE] = ACTIONS(5366),
    [anon_sym_LPAREN2] = ACTIONS(5366),
    [anon_sym_STAR] = ACTIONS(5366),
    [anon_sym_LBRACK] = ACTIONS(5366),
    [anon_sym_static] = ACTIONS(5368),
    [anon_sym_register] = ACTIONS(5368),
    [anon_sym_inline] = ACTIONS(5368),
    [anon_sym_const] = ACTIONS(5368),
    [anon_sym_restrict] = ACTIONS(5368),
    [anon_sym_volatile] = ACTIONS(5368),
    [anon_sym__Atomic] = ACTIONS(5368),
    [anon_sym_mutable] = ACTIONS(5368),
    [anon_sym_explicit] = ACTIONS(5368),
    [anon_sym_constexpr] = ACTIONS(5368),
    [anon_sym_unsigned] = ACTIONS(5368),
    [anon_sym_long] = ACTIONS(5368),
    [anon_sym_short] = ACTIONS(5368),
    [sym_primitive_type] = ACTIONS(5368),
    [anon_sym_enum] = ACTIONS(5368),
    [anon_sym_struct] = ACTIONS(5368),
    [anon_sym_union] = ACTIONS(5368),
    [anon_sym_if] = ACTIONS(5368),
    [anon_sym_switch] = ACTIONS(5368),
    [anon_sym_case] = ACTIONS(5368),
    [anon_sym_default] = ACTIONS(5368),
    [anon_sym_while] = ACTIONS(5368),
    [anon_sym_do] = ACTIONS(5368),
    [anon_sym_for] = ACTIONS(5368),
    [anon_sym_return] = ACTIONS(5368),
    [anon_sym_break] = ACTIONS(5368),
    [anon_sym_continue] = ACTIONS(5368),
    [anon_sym_goto] = ACTIONS(5368),
    [anon_sym_AMP] = ACTIONS(5368),
    [anon_sym_AMP_AMP] = ACTIONS(5366),
    [anon_sym_BANG] = ACTIONS(5366),
    [anon_sym_TILDE] = ACTIONS(5366),
    [anon_sym_PLUS] = ACTIONS(5368),
    [anon_sym_DASH] = ACTIONS(5368),
    [anon_sym_DASH_DASH] = ACTIONS(5366),
    [anon_sym_PLUS_PLUS] = ACTIONS(5366),
    [anon_sym_sizeof] = ACTIONS(5368),
    [sym_number_literal] = ACTIONS(5366),
    [anon_sym_SQUOTE] = ACTIONS(5366),
    [anon_sym_DQUOTE] = ACTIONS(5366),
    [sym_true] = ACTIONS(5368),
    [sym_false] = ACTIONS(5368),
    [sym_null] = ACTIONS(5368),
    [sym_identifier] = ACTIONS(5368),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5368),
    [sym_auto] = ACTIONS(5368),
    [anon_sym_typename] = ACTIONS(5368),
    [anon_sym_template] = ACTIONS(5368),
    [anon_sym_delete] = ACTIONS(5368),
    [anon_sym_namespace] = ACTIONS(5368),
    [anon_sym_using] = ACTIONS(5368),
    [anon_sym_try] = ACTIONS(5368),
    [anon_sym_new] = ACTIONS(5368),
    [anon_sym_COLON_COLON] = ACTIONS(5366),
    [sym_operator_name] = ACTIONS(5366),
    [sym_nullptr] = ACTIONS(5368),
  },
  [2529] = {
    [anon_sym_COMMA] = ACTIONS(5928),
    [anon_sym_SEMI] = ACTIONS(5928),
    [anon_sym_LBRACE] = ACTIONS(5928),
    [anon_sym_LPAREN2] = ACTIONS(5928),
    [anon_sym_STAR] = ACTIONS(5928),
    [anon_sym_LBRACK] = ACTIONS(5928),
    [anon_sym_EQ] = ACTIONS(5928),
    [anon_sym_const] = ACTIONS(5930),
    [anon_sym_restrict] = ACTIONS(5930),
    [anon_sym_volatile] = ACTIONS(5930),
    [anon_sym__Atomic] = ACTIONS(5930),
    [anon_sym_mutable] = ACTIONS(5930),
    [anon_sym_explicit] = ACTIONS(5930),
    [anon_sym_constexpr] = ACTIONS(5930),
    [anon_sym_COLON] = ACTIONS(5928),
    [anon_sym_AMP] = ACTIONS(5930),
    [anon_sym_AMP_AMP] = ACTIONS(5928),
    [anon_sym_DASH_GT] = ACTIONS(5928),
    [sym_identifier] = ACTIONS(5930),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5930),
    [anon_sym_override] = ACTIONS(5930),
    [sym_noexcept] = ACTIONS(5930),
  },
  [2530] = {
    [sym_enumerator] = STATE(1988),
    [anon_sym_RBRACE] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(1009),
    [sym_comment] = ACTIONS(91),
  },
  [2531] = {
    [anon_sym_COMMA] = ACTIONS(6046),
    [anon_sym_SEMI] = ACTIONS(6046),
    [anon_sym_LBRACE] = ACTIONS(6046),
    [anon_sym_LPAREN2] = ACTIONS(6046),
    [anon_sym_STAR] = ACTIONS(6046),
    [anon_sym_LBRACK] = ACTIONS(6046),
    [anon_sym_EQ] = ACTIONS(6046),
    [anon_sym_const] = ACTIONS(6048),
    [anon_sym_restrict] = ACTIONS(6048),
    [anon_sym_volatile] = ACTIONS(6048),
    [anon_sym__Atomic] = ACTIONS(6048),
    [anon_sym_mutable] = ACTIONS(6048),
    [anon_sym_explicit] = ACTIONS(6048),
    [anon_sym_constexpr] = ACTIONS(6048),
    [anon_sym_COLON] = ACTIONS(6046),
    [anon_sym_AMP] = ACTIONS(6048),
    [anon_sym_AMP_AMP] = ACTIONS(6046),
    [anon_sym_DASH_GT] = ACTIONS(6046),
    [sym_identifier] = ACTIONS(6048),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(6048),
    [anon_sym_override] = ACTIONS(6048),
    [sym_noexcept] = ACTIONS(6048),
  },
  [2532] = {
    [anon_sym_COMMA] = ACTIONS(6050),
    [anon_sym_SEMI] = ACTIONS(6050),
    [anon_sym_LBRACE] = ACTIONS(6050),
    [anon_sym_LPAREN2] = ACTIONS(6050),
    [anon_sym_STAR] = ACTIONS(6050),
    [anon_sym_LBRACK] = ACTIONS(6050),
    [anon_sym_EQ] = ACTIONS(6050),
    [anon_sym_const] = ACTIONS(6052),
    [anon_sym_restrict] = ACTIONS(6052),
    [anon_sym_volatile] = ACTIONS(6052),
    [anon_sym__Atomic] = ACTIONS(6052),
    [anon_sym_mutable] = ACTIONS(6052),
    [anon_sym_explicit] = ACTIONS(6052),
    [anon_sym_constexpr] = ACTIONS(6052),
    [anon_sym_COLON] = ACTIONS(6050),
    [anon_sym_AMP] = ACTIONS(6052),
    [anon_sym_AMP_AMP] = ACTIONS(6050),
    [anon_sym_DASH_GT] = ACTIONS(6050),
    [sym_identifier] = ACTIONS(6052),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(6052),
    [anon_sym_override] = ACTIONS(6052),
    [sym_noexcept] = ACTIONS(6052),
  },
  [2533] = {
    [anon_sym_COMMA] = ACTIONS(6054),
    [anon_sym_SEMI] = ACTIONS(6054),
    [anon_sym_LBRACE] = ACTIONS(6054),
    [anon_sym_LPAREN2] = ACTIONS(6054),
    [anon_sym_STAR] = ACTIONS(6054),
    [anon_sym_LBRACK] = ACTIONS(6054),
    [anon_sym_EQ] = ACTIONS(6054),
    [anon_sym_const] = ACTIONS(6056),
    [anon_sym_restrict] = ACTIONS(6056),
    [anon_sym_volatile] = ACTIONS(6056),
    [anon_sym__Atomic] = ACTIONS(6056),
    [anon_sym_mutable] = ACTIONS(6056),
    [anon_sym_explicit] = ACTIONS(6056),
    [anon_sym_constexpr] = ACTIONS(6056),
    [anon_sym_COLON] = ACTIONS(6054),
    [anon_sym_AMP] = ACTIONS(6056),
    [anon_sym_AMP_AMP] = ACTIONS(6054),
    [anon_sym_DASH_GT] = ACTIONS(6054),
    [sym_identifier] = ACTIONS(6056),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(6056),
    [anon_sym_override] = ACTIONS(6056),
    [sym_noexcept] = ACTIONS(6056),
  },
  [2534] = {
    [anon_sym_COMMA] = ACTIONS(6058),
    [anon_sym_SEMI] = ACTIONS(6058),
    [anon_sym_LBRACE] = ACTIONS(6058),
    [anon_sym_LPAREN2] = ACTIONS(6058),
    [anon_sym_STAR] = ACTIONS(6058),
    [anon_sym_LBRACK] = ACTIONS(6058),
    [anon_sym_EQ] = ACTIONS(6058),
    [anon_sym_const] = ACTIONS(6060),
    [anon_sym_restrict] = ACTIONS(6060),
    [anon_sym_volatile] = ACTIONS(6060),
    [anon_sym__Atomic] = ACTIONS(6060),
    [anon_sym_mutable] = ACTIONS(6060),
    [anon_sym_explicit] = ACTIONS(6060),
    [anon_sym_constexpr] = ACTIONS(6060),
    [anon_sym_COLON] = ACTIONS(6058),
    [anon_sym_AMP] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6058),
    [anon_sym_DASH_GT] = ACTIONS(6058),
    [sym_identifier] = ACTIONS(6060),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(6060),
    [anon_sym_override] = ACTIONS(6060),
    [sym_noexcept] = ACTIONS(6060),
  },
  [2535] = {
    [anon_sym_LBRACE] = ACTIONS(6284),
    [anon_sym_LPAREN2] = ACTIONS(6284),
    [anon_sym_STAR] = ACTIONS(6284),
    [anon_sym_COLON] = ACTIONS(6286),
    [sym_identifier] = ACTIONS(6286),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(6286),
    [anon_sym_override] = ACTIONS(6286),
    [anon_sym_COLON_COLON] = ACTIONS(6284),
  },
  [2536] = {
    [anon_sym_LBRACE] = ACTIONS(6291),
    [anon_sym_LPAREN2] = ACTIONS(6291),
    [anon_sym_STAR] = ACTIONS(6291),
    [anon_sym_COLON] = ACTIONS(6293),
    [sym_identifier] = ACTIONS(6293),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(6293),
    [anon_sym_override] = ACTIONS(6293),
    [anon_sym_COLON_COLON] = ACTIONS(6291),
  },
  [2537] = {
    [anon_sym_COMMA] = ACTIONS(6300),
    [anon_sym_SEMI] = ACTIONS(6300),
    [anon_sym_LBRACE] = ACTIONS(6300),
    [anon_sym_LPAREN2] = ACTIONS(6300),
    [anon_sym_STAR] = ACTIONS(6300),
    [anon_sym_LBRACK] = ACTIONS(6300),
    [anon_sym_EQ] = ACTIONS(6300),
    [anon_sym_const] = ACTIONS(6302),
    [anon_sym_restrict] = ACTIONS(6302),
    [anon_sym_volatile] = ACTIONS(6302),
    [anon_sym__Atomic] = ACTIONS(6302),
    [anon_sym_mutable] = ACTIONS(6302),
    [anon_sym_explicit] = ACTIONS(6302),
    [anon_sym_constexpr] = ACTIONS(6302),
    [anon_sym_COLON] = ACTIONS(6300),
    [anon_sym_AMP] = ACTIONS(6302),
    [anon_sym_AMP_AMP] = ACTIONS(6300),
    [anon_sym_DASH_GT] = ACTIONS(6300),
    [sym_identifier] = ACTIONS(6302),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(6302),
    [anon_sym_override] = ACTIONS(6302),
    [sym_noexcept] = ACTIONS(6302),
  },
  [2538] = {
    [anon_sym_COMMA] = ACTIONS(6304),
    [anon_sym_SEMI] = ACTIONS(6304),
    [anon_sym_LBRACE] = ACTIONS(6304),
    [anon_sym_LPAREN2] = ACTIONS(6304),
    [anon_sym_STAR] = ACTIONS(6304),
    [anon_sym_LBRACK] = ACTIONS(6304),
    [anon_sym_EQ] = ACTIONS(6304),
    [anon_sym_const] = ACTIONS(6306),
    [anon_sym_restrict] = ACTIONS(6306),
    [anon_sym_volatile] = ACTIONS(6306),
    [anon_sym__Atomic] = ACTIONS(6306),
    [anon_sym_mutable] = ACTIONS(6306),
    [anon_sym_explicit] = ACTIONS(6306),
    [anon_sym_constexpr] = ACTIONS(6306),
    [anon_sym_COLON] = ACTIONS(6304),
    [anon_sym_AMP] = ACTIONS(6306),
    [anon_sym_AMP_AMP] = ACTIONS(6304),
    [anon_sym_DASH_GT] = ACTIONS(6304),
    [sym_identifier] = ACTIONS(6306),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(6306),
    [anon_sym_override] = ACTIONS(6306),
    [sym_noexcept] = ACTIONS(6306),
  },
  [2539] = {
    [anon_sym_RPAREN] = ACTIONS(6729),
    [anon_sym_SEMI] = ACTIONS(6729),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [sym_comment] = ACTIONS(91),
  },
  [2540] = {
    [sym__expression] = STATE(146),
    [sym_conditional_expression] = STATE(146),
    [sym_assignment_expression] = STATE(146),
    [sym_pointer_expression] = STATE(146),
    [sym_logical_expression] = STATE(146),
    [sym_bitwise_expression] = STATE(146),
    [sym_equality_expression] = STATE(146),
    [sym_relational_expression] = STATE(146),
    [sym_shift_expression] = STATE(146),
    [sym_math_expression] = STATE(146),
    [sym_cast_expression] = STATE(146),
    [sym_sizeof_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_compound_literal_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_char_literal] = STATE(146),
    [sym_concatenated_string] = STATE(146),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(146),
    [sym_new_expression] = STATE(146),
    [sym_delete_expression] = STATE(146),
    [sym_lambda_expression] = STATE(146),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(257),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(6731),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(257),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(259),
    [sym_false] = ACTIONS(259),
    [sym_null] = ACTIONS(259),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(259),
  },
  [2541] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(6731),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_STAR_EQ] = ACTIONS(3507),
    [anon_sym_SLASH_EQ] = ACTIONS(3507),
    [anon_sym_PERCENT_EQ] = ACTIONS(3507),
    [anon_sym_PLUS_EQ] = ACTIONS(3507),
    [anon_sym_DASH_EQ] = ACTIONS(3507),
    [anon_sym_LT_LT_EQ] = ACTIONS(3507),
    [anon_sym_GT_GT_EQ] = ACTIONS(3507),
    [anon_sym_AMP_EQ] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(3507),
    [anon_sym_PIPE_EQ] = ACTIONS(3507),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_CARET] = ACTIONS(3517),
    [anon_sym_EQ_EQ] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3521),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3525),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2542] = {
    [sym_raw_string_literal] = ACTIONS(5376),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5378),
    [sym_preproc_directive] = ACTIONS(5378),
    [anon_sym_SEMI] = ACTIONS(5376),
    [anon_sym_typedef] = ACTIONS(5378),
    [anon_sym_extern] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(5376),
    [anon_sym_RBRACE] = ACTIONS(5376),
    [anon_sym_LPAREN2] = ACTIONS(5376),
    [anon_sym_STAR] = ACTIONS(5376),
    [anon_sym_LBRACK] = ACTIONS(5376),
    [anon_sym_static] = ACTIONS(5378),
    [anon_sym_register] = ACTIONS(5378),
    [anon_sym_inline] = ACTIONS(5378),
    [anon_sym_const] = ACTIONS(5378),
    [anon_sym_restrict] = ACTIONS(5378),
    [anon_sym_volatile] = ACTIONS(5378),
    [anon_sym__Atomic] = ACTIONS(5378),
    [anon_sym_mutable] = ACTIONS(5378),
    [anon_sym_explicit] = ACTIONS(5378),
    [anon_sym_constexpr] = ACTIONS(5378),
    [anon_sym_unsigned] = ACTIONS(5378),
    [anon_sym_long] = ACTIONS(5378),
    [anon_sym_short] = ACTIONS(5378),
    [sym_primitive_type] = ACTIONS(5378),
    [anon_sym_enum] = ACTIONS(5378),
    [anon_sym_struct] = ACTIONS(5378),
    [anon_sym_union] = ACTIONS(5378),
    [anon_sym_if] = ACTIONS(5378),
    [anon_sym_switch] = ACTIONS(5378),
    [anon_sym_case] = ACTIONS(5378),
    [anon_sym_default] = ACTIONS(5378),
    [anon_sym_while] = ACTIONS(5378),
    [anon_sym_do] = ACTIONS(5378),
    [anon_sym_for] = ACTIONS(5378),
    [anon_sym_return] = ACTIONS(5378),
    [anon_sym_break] = ACTIONS(5378),
    [anon_sym_continue] = ACTIONS(5378),
    [anon_sym_goto] = ACTIONS(5378),
    [anon_sym_AMP] = ACTIONS(5376),
    [anon_sym_BANG] = ACTIONS(5376),
    [anon_sym_TILDE] = ACTIONS(5376),
    [anon_sym_PLUS] = ACTIONS(5378),
    [anon_sym_DASH] = ACTIONS(5378),
    [anon_sym_DASH_DASH] = ACTIONS(5376),
    [anon_sym_PLUS_PLUS] = ACTIONS(5376),
    [anon_sym_sizeof] = ACTIONS(5378),
    [sym_number_literal] = ACTIONS(5376),
    [anon_sym_SQUOTE] = ACTIONS(5376),
    [anon_sym_DQUOTE] = ACTIONS(5376),
    [sym_true] = ACTIONS(5378),
    [sym_false] = ACTIONS(5378),
    [sym_null] = ACTIONS(5378),
    [sym_identifier] = ACTIONS(5378),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5378),
    [sym_auto] = ACTIONS(5378),
    [anon_sym_typename] = ACTIONS(5378),
    [anon_sym_delete] = ACTIONS(5378),
    [anon_sym_try] = ACTIONS(5378),
    [anon_sym_new] = ACTIONS(5378),
    [anon_sym_COLON_COLON] = ACTIONS(5376),
    [sym_nullptr] = ACTIONS(5378),
  },
  [2543] = {
    [sym_raw_string_literal] = ACTIONS(1370),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1372),
    [sym_preproc_directive] = ACTIONS(1372),
    [anon_sym_SEMI] = ACTIONS(1370),
    [anon_sym_typedef] = ACTIONS(1372),
    [anon_sym_extern] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1370),
    [anon_sym_LPAREN2] = ACTIONS(1370),
    [anon_sym_STAR] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(1370),
    [anon_sym_static] = ACTIONS(1372),
    [anon_sym_register] = ACTIONS(1372),
    [anon_sym_inline] = ACTIONS(1372),
    [anon_sym_const] = ACTIONS(1372),
    [anon_sym_restrict] = ACTIONS(1372),
    [anon_sym_volatile] = ACTIONS(1372),
    [anon_sym__Atomic] = ACTIONS(1372),
    [anon_sym_mutable] = ACTIONS(1372),
    [anon_sym_explicit] = ACTIONS(1372),
    [anon_sym_constexpr] = ACTIONS(1372),
    [anon_sym_unsigned] = ACTIONS(1372),
    [anon_sym_long] = ACTIONS(1372),
    [anon_sym_short] = ACTIONS(1372),
    [sym_primitive_type] = ACTIONS(1372),
    [anon_sym_enum] = ACTIONS(1372),
    [anon_sym_struct] = ACTIONS(1372),
    [anon_sym_union] = ACTIONS(1372),
    [anon_sym_if] = ACTIONS(1372),
    [anon_sym_switch] = ACTIONS(1372),
    [anon_sym_case] = ACTIONS(1372),
    [anon_sym_default] = ACTIONS(1372),
    [anon_sym_while] = ACTIONS(1372),
    [anon_sym_do] = ACTIONS(1372),
    [anon_sym_for] = ACTIONS(1372),
    [anon_sym_return] = ACTIONS(1372),
    [anon_sym_break] = ACTIONS(1372),
    [anon_sym_continue] = ACTIONS(1372),
    [anon_sym_goto] = ACTIONS(1372),
    [anon_sym_AMP] = ACTIONS(1370),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_PLUS] = ACTIONS(1372),
    [anon_sym_DASH] = ACTIONS(1372),
    [anon_sym_DASH_DASH] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1370),
    [anon_sym_sizeof] = ACTIONS(1372),
    [sym_number_literal] = ACTIONS(1370),
    [anon_sym_SQUOTE] = ACTIONS(1370),
    [anon_sym_DQUOTE] = ACTIONS(1370),
    [sym_true] = ACTIONS(1372),
    [sym_false] = ACTIONS(1372),
    [sym_null] = ACTIONS(1372),
    [sym_identifier] = ACTIONS(1372),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1372),
    [sym_auto] = ACTIONS(1372),
    [anon_sym_typename] = ACTIONS(1372),
    [anon_sym_delete] = ACTIONS(1372),
    [anon_sym_try] = ACTIONS(1372),
    [anon_sym_new] = ACTIONS(1372),
    [anon_sym_COLON_COLON] = ACTIONS(1370),
    [sym_nullptr] = ACTIONS(1372),
  },
  [2544] = {
    [aux_sym_string_literal_repeat1] = STATE(761),
    [anon_sym_DQUOTE] = ACTIONS(6733),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_BSLASHn_RBRACK_SLASH] = ACTIONS(1376),
    [sym_escape_sequence] = ACTIONS(1376),
    [sym_comment] = ACTIONS(121),
  },
  [2545] = {
    [sym_raw_string_literal] = ACTIONS(1994),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1996),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1996),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1996),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1996),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1996),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1996),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1996),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1996),
    [sym_preproc_directive] = ACTIONS(1996),
    [anon_sym_SEMI] = ACTIONS(1994),
    [anon_sym_typedef] = ACTIONS(1996),
    [anon_sym_extern] = ACTIONS(1996),
    [anon_sym_LBRACE] = ACTIONS(1994),
    [anon_sym_LPAREN2] = ACTIONS(1994),
    [anon_sym_STAR] = ACTIONS(1994),
    [anon_sym_LBRACK] = ACTIONS(1994),
    [anon_sym_static] = ACTIONS(1996),
    [anon_sym_register] = ACTIONS(1996),
    [anon_sym_inline] = ACTIONS(1996),
    [anon_sym_const] = ACTIONS(1996),
    [anon_sym_restrict] = ACTIONS(1996),
    [anon_sym_volatile] = ACTIONS(1996),
    [anon_sym__Atomic] = ACTIONS(1996),
    [anon_sym_mutable] = ACTIONS(1996),
    [anon_sym_explicit] = ACTIONS(1996),
    [anon_sym_constexpr] = ACTIONS(1996),
    [anon_sym_unsigned] = ACTIONS(1996),
    [anon_sym_long] = ACTIONS(1996),
    [anon_sym_short] = ACTIONS(1996),
    [sym_primitive_type] = ACTIONS(1996),
    [anon_sym_enum] = ACTIONS(1996),
    [anon_sym_struct] = ACTIONS(1996),
    [anon_sym_union] = ACTIONS(1996),
    [anon_sym_if] = ACTIONS(1996),
    [anon_sym_switch] = ACTIONS(1996),
    [anon_sym_case] = ACTIONS(1996),
    [anon_sym_default] = ACTIONS(1996),
    [anon_sym_while] = ACTIONS(1996),
    [anon_sym_do] = ACTIONS(1996),
    [anon_sym_for] = ACTIONS(1996),
    [anon_sym_return] = ACTIONS(1996),
    [anon_sym_break] = ACTIONS(1996),
    [anon_sym_continue] = ACTIONS(1996),
    [anon_sym_goto] = ACTIONS(1996),
    [anon_sym_AMP] = ACTIONS(1994),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_PLUS] = ACTIONS(1996),
    [anon_sym_DASH] = ACTIONS(1996),
    [anon_sym_DASH_DASH] = ACTIONS(1994),
    [anon_sym_PLUS_PLUS] = ACTIONS(1994),
    [anon_sym_sizeof] = ACTIONS(1996),
    [sym_number_literal] = ACTIONS(1994),
    [anon_sym_SQUOTE] = ACTIONS(1994),
    [anon_sym_DQUOTE] = ACTIONS(1994),
    [sym_true] = ACTIONS(1996),
    [sym_false] = ACTIONS(1996),
    [sym_null] = ACTIONS(1996),
    [sym_identifier] = ACTIONS(1996),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1996),
    [sym_auto] = ACTIONS(1996),
    [anon_sym_typename] = ACTIONS(1996),
    [anon_sym_delete] = ACTIONS(1996),
    [anon_sym_try] = ACTIONS(1996),
    [anon_sym_new] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1994),
    [sym_nullptr] = ACTIONS(1996),
  },
  [2546] = {
    [anon_sym_LF] = ACTIONS(6735),
    [sym_comment] = ACTIONS(121),
  },
  [2547] = {
    [anon_sym_LF] = ACTIONS(6737),
    [sym_preproc_arg] = ACTIONS(6739),
    [sym_comment] = ACTIONS(121),
  },
  [2548] = {
    [sym_raw_string_literal] = ACTIONS(3990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3992),
    [sym_preproc_directive] = ACTIONS(3992),
    [anon_sym_SEMI] = ACTIONS(3990),
    [anon_sym_typedef] = ACTIONS(3992),
    [anon_sym_extern] = ACTIONS(3992),
    [anon_sym_LBRACE] = ACTIONS(3990),
    [anon_sym_LPAREN2] = ACTIONS(3990),
    [anon_sym_STAR] = ACTIONS(3990),
    [anon_sym_LBRACK] = ACTIONS(3990),
    [anon_sym_static] = ACTIONS(3992),
    [anon_sym_register] = ACTIONS(3992),
    [anon_sym_inline] = ACTIONS(3992),
    [anon_sym_const] = ACTIONS(3992),
    [anon_sym_restrict] = ACTIONS(3992),
    [anon_sym_volatile] = ACTIONS(3992),
    [anon_sym__Atomic] = ACTIONS(3992),
    [anon_sym_mutable] = ACTIONS(3992),
    [anon_sym_explicit] = ACTIONS(3992),
    [anon_sym_constexpr] = ACTIONS(3992),
    [anon_sym_unsigned] = ACTIONS(3992),
    [anon_sym_long] = ACTIONS(3992),
    [anon_sym_short] = ACTIONS(3992),
    [sym_primitive_type] = ACTIONS(3992),
    [anon_sym_enum] = ACTIONS(3992),
    [anon_sym_struct] = ACTIONS(3992),
    [anon_sym_union] = ACTIONS(3992),
    [anon_sym_if] = ACTIONS(3992),
    [anon_sym_switch] = ACTIONS(3992),
    [anon_sym_case] = ACTIONS(3992),
    [anon_sym_default] = ACTIONS(3992),
    [anon_sym_while] = ACTIONS(3992),
    [anon_sym_do] = ACTIONS(3992),
    [anon_sym_for] = ACTIONS(3992),
    [anon_sym_return] = ACTIONS(3992),
    [anon_sym_break] = ACTIONS(3992),
    [anon_sym_continue] = ACTIONS(3992),
    [anon_sym_goto] = ACTIONS(3992),
    [anon_sym_AMP] = ACTIONS(3990),
    [anon_sym_BANG] = ACTIONS(3990),
    [anon_sym_TILDE] = ACTIONS(3990),
    [anon_sym_PLUS] = ACTIONS(3992),
    [anon_sym_DASH] = ACTIONS(3992),
    [anon_sym_DASH_DASH] = ACTIONS(3990),
    [anon_sym_PLUS_PLUS] = ACTIONS(3990),
    [anon_sym_sizeof] = ACTIONS(3992),
    [sym_number_literal] = ACTIONS(3990),
    [anon_sym_SQUOTE] = ACTIONS(3990),
    [anon_sym_DQUOTE] = ACTIONS(3990),
    [sym_true] = ACTIONS(3992),
    [sym_false] = ACTIONS(3992),
    [sym_null] = ACTIONS(3992),
    [sym_identifier] = ACTIONS(3992),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3992),
    [sym_auto] = ACTIONS(3992),
    [anon_sym_typename] = ACTIONS(3992),
    [anon_sym_delete] = ACTIONS(3992),
    [anon_sym_try] = ACTIONS(3992),
    [anon_sym_new] = ACTIONS(3992),
    [anon_sym_COLON_COLON] = ACTIONS(3990),
    [sym_nullptr] = ACTIONS(3992),
  },
  [2549] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6741),
    [sym_comment] = ACTIONS(91),
  },
  [2550] = {
    [sym_preproc_include] = STATE(1941),
    [sym_preproc_def] = STATE(1941),
    [sym_preproc_function_def] = STATE(1941),
    [sym_preproc_call] = STATE(1941),
    [sym_preproc_if_in_compound_statement] = STATE(1941),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1941),
    [sym_preproc_else_in_compound_statement] = STATE(2990),
    [sym_preproc_elif_in_compound_statement] = STATE(2990),
    [sym_declaration] = STATE(1941),
    [sym_type_definition] = STATE(1941),
    [sym__declaration_specifiers] = STATE(1138),
    [sym_compound_statement] = STATE(1941),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(1941),
    [sym_expression_statement] = STATE(1941),
    [sym_if_statement] = STATE(1941),
    [sym_switch_statement] = STATE(1941),
    [sym_case_statement] = STATE(1941),
    [sym_while_statement] = STATE(1941),
    [sym_do_statement] = STATE(1941),
    [sym_for_statement] = STATE(1941),
    [sym_return_statement] = STATE(1941),
    [sym_break_statement] = STATE(1941),
    [sym_continue_statement] = STATE(1941),
    [sym_goto_statement] = STATE(1941),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(1941),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(1941),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(1941),
    [sym_try_statement] = STATE(1941),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1941),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(2196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2198),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2200),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6743),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2208),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2210),
    [sym_preproc_directive] = ACTIONS(2212),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_typedef] = ACTIONS(2216),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(2220),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(2244),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_nullptr] = ACTIONS(2242),
  },
  [2551] = {
    [sym_raw_string_literal] = ACTIONS(4090),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4092),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4092),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4092),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4092),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4092),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4092),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4092),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4092),
    [sym_preproc_directive] = ACTIONS(4092),
    [anon_sym_SEMI] = ACTIONS(4090),
    [anon_sym_typedef] = ACTIONS(4092),
    [anon_sym_extern] = ACTIONS(4092),
    [anon_sym_LBRACE] = ACTIONS(4090),
    [anon_sym_LPAREN2] = ACTIONS(4090),
    [anon_sym_STAR] = ACTIONS(4090),
    [anon_sym_LBRACK] = ACTIONS(4090),
    [anon_sym_static] = ACTIONS(4092),
    [anon_sym_register] = ACTIONS(4092),
    [anon_sym_inline] = ACTIONS(4092),
    [anon_sym_const] = ACTIONS(4092),
    [anon_sym_restrict] = ACTIONS(4092),
    [anon_sym_volatile] = ACTIONS(4092),
    [anon_sym__Atomic] = ACTIONS(4092),
    [anon_sym_mutable] = ACTIONS(4092),
    [anon_sym_explicit] = ACTIONS(4092),
    [anon_sym_constexpr] = ACTIONS(4092),
    [anon_sym_unsigned] = ACTIONS(4092),
    [anon_sym_long] = ACTIONS(4092),
    [anon_sym_short] = ACTIONS(4092),
    [sym_primitive_type] = ACTIONS(4092),
    [anon_sym_enum] = ACTIONS(4092),
    [anon_sym_struct] = ACTIONS(4092),
    [anon_sym_union] = ACTIONS(4092),
    [anon_sym_if] = ACTIONS(4092),
    [anon_sym_switch] = ACTIONS(4092),
    [anon_sym_case] = ACTIONS(4092),
    [anon_sym_default] = ACTIONS(4092),
    [anon_sym_while] = ACTIONS(4092),
    [anon_sym_do] = ACTIONS(4092),
    [anon_sym_for] = ACTIONS(4092),
    [anon_sym_return] = ACTIONS(4092),
    [anon_sym_break] = ACTIONS(4092),
    [anon_sym_continue] = ACTIONS(4092),
    [anon_sym_goto] = ACTIONS(4092),
    [anon_sym_AMP] = ACTIONS(4090),
    [anon_sym_BANG] = ACTIONS(4090),
    [anon_sym_TILDE] = ACTIONS(4090),
    [anon_sym_PLUS] = ACTIONS(4092),
    [anon_sym_DASH] = ACTIONS(4092),
    [anon_sym_DASH_DASH] = ACTIONS(4090),
    [anon_sym_PLUS_PLUS] = ACTIONS(4090),
    [anon_sym_sizeof] = ACTIONS(4092),
    [sym_number_literal] = ACTIONS(4090),
    [anon_sym_SQUOTE] = ACTIONS(4090),
    [anon_sym_DQUOTE] = ACTIONS(4090),
    [sym_true] = ACTIONS(4092),
    [sym_false] = ACTIONS(4092),
    [sym_null] = ACTIONS(4092),
    [sym_identifier] = ACTIONS(4092),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4092),
    [sym_auto] = ACTIONS(4092),
    [anon_sym_typename] = ACTIONS(4092),
    [anon_sym_delete] = ACTIONS(4092),
    [anon_sym_try] = ACTIONS(4092),
    [anon_sym_new] = ACTIONS(4092),
    [anon_sym_COLON_COLON] = ACTIONS(4090),
    [sym_nullptr] = ACTIONS(4092),
  },
  [2552] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6745),
    [sym_comment] = ACTIONS(91),
  },
  [2553] = {
    [sym_preproc_include] = STATE(1941),
    [sym_preproc_def] = STATE(1941),
    [sym_preproc_function_def] = STATE(1941),
    [sym_preproc_call] = STATE(1941),
    [sym_preproc_if_in_compound_statement] = STATE(1941),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1941),
    [sym_preproc_else_in_compound_statement] = STATE(2992),
    [sym_preproc_elif_in_compound_statement] = STATE(2992),
    [sym_declaration] = STATE(1941),
    [sym_type_definition] = STATE(1941),
    [sym__declaration_specifiers] = STATE(1138),
    [sym_compound_statement] = STATE(1941),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(1941),
    [sym_expression_statement] = STATE(1941),
    [sym_if_statement] = STATE(1941),
    [sym_switch_statement] = STATE(1941),
    [sym_case_statement] = STATE(1941),
    [sym_while_statement] = STATE(1941),
    [sym_do_statement] = STATE(1941),
    [sym_for_statement] = STATE(1941),
    [sym_return_statement] = STATE(1941),
    [sym_break_statement] = STATE(1941),
    [sym_continue_statement] = STATE(1941),
    [sym_goto_statement] = STATE(1941),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(1941),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(1941),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(1941),
    [sym_try_statement] = STATE(1941),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1941),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(2196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2198),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2200),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6747),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2208),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2210),
    [sym_preproc_directive] = ACTIONS(2212),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_typedef] = ACTIONS(2216),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(2220),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(2244),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_nullptr] = ACTIONS(2242),
  },
  [2554] = {
    [aux_sym_string_literal_repeat1] = STATE(2994),
    [anon_sym_DQUOTE] = ACTIONS(6749),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_BSLASHn_RBRACK_SLASH] = ACTIONS(6751),
    [sym_escape_sequence] = ACTIONS(6751),
    [sym_comment] = ACTIONS(121),
  },
  [2555] = {
    [sym_raw_string_literal] = ACTIONS(668),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(670),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(670),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(670),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(670),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(670),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(670),
    [sym_preproc_directive] = ACTIONS(670),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(670),
    [anon_sym_extern] = ACTIONS(670),
    [anon_sym_LBRACE] = ACTIONS(668),
    [anon_sym_LPAREN2] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(668),
    [anon_sym_LBRACK] = ACTIONS(668),
    [anon_sym_static] = ACTIONS(670),
    [anon_sym_register] = ACTIONS(670),
    [anon_sym_inline] = ACTIONS(670),
    [anon_sym_const] = ACTIONS(670),
    [anon_sym_restrict] = ACTIONS(670),
    [anon_sym_volatile] = ACTIONS(670),
    [anon_sym__Atomic] = ACTIONS(670),
    [anon_sym_mutable] = ACTIONS(670),
    [anon_sym_explicit] = ACTIONS(670),
    [anon_sym_constexpr] = ACTIONS(670),
    [anon_sym_unsigned] = ACTIONS(670),
    [anon_sym_long] = ACTIONS(670),
    [anon_sym_short] = ACTIONS(670),
    [sym_primitive_type] = ACTIONS(670),
    [anon_sym_enum] = ACTIONS(670),
    [anon_sym_struct] = ACTIONS(670),
    [anon_sym_union] = ACTIONS(670),
    [anon_sym_if] = ACTIONS(670),
    [anon_sym_switch] = ACTIONS(670),
    [anon_sym_case] = ACTIONS(670),
    [anon_sym_default] = ACTIONS(670),
    [anon_sym_while] = ACTIONS(670),
    [anon_sym_do] = ACTIONS(670),
    [anon_sym_for] = ACTIONS(670),
    [anon_sym_return] = ACTIONS(670),
    [anon_sym_break] = ACTIONS(670),
    [anon_sym_continue] = ACTIONS(670),
    [anon_sym_goto] = ACTIONS(670),
    [anon_sym_AMP] = ACTIONS(668),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_PLUS] = ACTIONS(670),
    [anon_sym_DASH] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(668),
    [anon_sym_PLUS_PLUS] = ACTIONS(668),
    [anon_sym_sizeof] = ACTIONS(670),
    [sym_number_literal] = ACTIONS(668),
    [anon_sym_SQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE] = ACTIONS(668),
    [sym_true] = ACTIONS(670),
    [sym_false] = ACTIONS(670),
    [sym_null] = ACTIONS(670),
    [sym_identifier] = ACTIONS(670),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(670),
    [sym_auto] = ACTIONS(670),
    [anon_sym_typename] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_try] = ACTIONS(670),
    [anon_sym_new] = ACTIONS(670),
    [anon_sym_COLON_COLON] = ACTIONS(668),
    [sym_nullptr] = ACTIONS(670),
  },
  [2556] = {
    [sym_preproc_params] = STATE(2997),
    [anon_sym_LF] = ACTIONS(6753),
    [anon_sym_LPAREN] = ACTIONS(674),
    [sym_preproc_arg] = ACTIONS(6755),
    [sym_comment] = ACTIONS(121),
  },
  [2557] = {
    [sym_preproc_include] = STATE(3000),
    [sym_preproc_def] = STATE(3000),
    [sym_preproc_function_def] = STATE(3000),
    [sym_preproc_call] = STATE(3000),
    [sym_preproc_if_in_compound_statement] = STATE(3000),
    [sym_preproc_ifdef_in_compound_statement] = STATE(3000),
    [sym_preproc_else_in_compound_statement] = STATE(2999),
    [sym_preproc_elif_in_compound_statement] = STATE(2999),
    [sym_declaration] = STATE(3000),
    [sym_type_definition] = STATE(3000),
    [sym__declaration_specifiers] = STATE(1138),
    [sym_compound_statement] = STATE(3000),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(3000),
    [sym_expression_statement] = STATE(3000),
    [sym_if_statement] = STATE(3000),
    [sym_switch_statement] = STATE(3000),
    [sym_case_statement] = STATE(3000),
    [sym_while_statement] = STATE(3000),
    [sym_do_statement] = STATE(3000),
    [sym_for_statement] = STATE(3000),
    [sym_return_statement] = STATE(3000),
    [sym_break_statement] = STATE(3000),
    [sym_continue_statement] = STATE(3000),
    [sym_goto_statement] = STATE(3000),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(3000),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(3000),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(3000),
    [sym_try_statement] = STATE(3000),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(3000),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(2196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2198),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2200),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2208),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2210),
    [sym_preproc_directive] = ACTIONS(2212),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_typedef] = ACTIONS(2216),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(2220),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(2244),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_nullptr] = ACTIONS(2242),
  },
  [2558] = {
    [sym_preproc_include] = STATE(3003),
    [sym_preproc_def] = STATE(3003),
    [sym_preproc_function_def] = STATE(3003),
    [sym_preproc_call] = STATE(3003),
    [sym_preproc_if_in_compound_statement] = STATE(3003),
    [sym_preproc_ifdef_in_compound_statement] = STATE(3003),
    [sym_preproc_else_in_compound_statement] = STATE(3002),
    [sym_preproc_elif_in_compound_statement] = STATE(3002),
    [sym_declaration] = STATE(3003),
    [sym_type_definition] = STATE(3003),
    [sym__declaration_specifiers] = STATE(1138),
    [sym_compound_statement] = STATE(3003),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(3003),
    [sym_expression_statement] = STATE(3003),
    [sym_if_statement] = STATE(3003),
    [sym_switch_statement] = STATE(3003),
    [sym_case_statement] = STATE(3003),
    [sym_while_statement] = STATE(3003),
    [sym_do_statement] = STATE(3003),
    [sym_for_statement] = STATE(3003),
    [sym_return_statement] = STATE(3003),
    [sym_break_statement] = STATE(3003),
    [sym_continue_statement] = STATE(3003),
    [sym_goto_statement] = STATE(3003),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(3003),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(3003),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(3003),
    [sym_try_statement] = STATE(3003),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(3003),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(2196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2198),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2200),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6759),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2208),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2210),
    [sym_preproc_directive] = ACTIONS(2212),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_typedef] = ACTIONS(2216),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(2220),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(2244),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_nullptr] = ACTIONS(2242),
  },
  [2559] = {
    [sym_raw_string_literal] = ACTIONS(740),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(742),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(742),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(742),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(742),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(742),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(742),
    [sym_preproc_directive] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(740),
    [anon_sym_typedef] = ACTIONS(742),
    [anon_sym_extern] = ACTIONS(742),
    [anon_sym_LBRACE] = ACTIONS(740),
    [anon_sym_LPAREN2] = ACTIONS(740),
    [anon_sym_STAR] = ACTIONS(740),
    [anon_sym_LBRACK] = ACTIONS(740),
    [anon_sym_static] = ACTIONS(742),
    [anon_sym_register] = ACTIONS(742),
    [anon_sym_inline] = ACTIONS(742),
    [anon_sym_const] = ACTIONS(742),
    [anon_sym_restrict] = ACTIONS(742),
    [anon_sym_volatile] = ACTIONS(742),
    [anon_sym__Atomic] = ACTIONS(742),
    [anon_sym_mutable] = ACTIONS(742),
    [anon_sym_explicit] = ACTIONS(742),
    [anon_sym_constexpr] = ACTIONS(742),
    [anon_sym_unsigned] = ACTIONS(742),
    [anon_sym_long] = ACTIONS(742),
    [anon_sym_short] = ACTIONS(742),
    [sym_primitive_type] = ACTIONS(742),
    [anon_sym_enum] = ACTIONS(742),
    [anon_sym_struct] = ACTIONS(742),
    [anon_sym_union] = ACTIONS(742),
    [anon_sym_if] = ACTIONS(742),
    [anon_sym_switch] = ACTIONS(742),
    [anon_sym_case] = ACTIONS(742),
    [anon_sym_default] = ACTIONS(742),
    [anon_sym_while] = ACTIONS(742),
    [anon_sym_do] = ACTIONS(742),
    [anon_sym_for] = ACTIONS(742),
    [anon_sym_return] = ACTIONS(742),
    [anon_sym_break] = ACTIONS(742),
    [anon_sym_continue] = ACTIONS(742),
    [anon_sym_goto] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(740),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(742),
    [anon_sym_DASH] = ACTIONS(742),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_sizeof] = ACTIONS(742),
    [sym_number_literal] = ACTIONS(740),
    [anon_sym_SQUOTE] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(740),
    [sym_true] = ACTIONS(742),
    [sym_false] = ACTIONS(742),
    [sym_null] = ACTIONS(742),
    [sym_identifier] = ACTIONS(742),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(742),
    [sym_auto] = ACTIONS(742),
    [anon_sym_typename] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(742),
    [anon_sym_try] = ACTIONS(742),
    [anon_sym_new] = ACTIONS(742),
    [anon_sym_COLON_COLON] = ACTIONS(740),
    [sym_nullptr] = ACTIONS(742),
  },
  [2560] = {
    [anon_sym_LF] = ACTIONS(6761),
    [sym_comment] = ACTIONS(121),
  },
  [2561] = {
    [sym__type_declarator] = STATE(3005),
    [sym_pointer_type_declarator] = STATE(3005),
    [sym_function_type_declarator] = STATE(3005),
    [sym_array_type_declarator] = STATE(3005),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_STAR] = ACTIONS(768),
    [sym_identifier] = ACTIONS(770),
    [sym_comment] = ACTIONS(91),
  },
  [2562] = {
    [sym_type_qualifier] = STATE(453),
    [sym__type_specifier] = STATE(3006),
    [sym_sized_type_specifier] = STATE(3006),
    [sym_enum_specifier] = STATE(3006),
    [sym_struct_specifier] = STATE(3006),
    [sym_union_specifier] = STATE(3006),
    [sym_macro_type_specifier] = STATE(3006),
    [sym_class_specifier] = STATE(3006),
    [sym_dependent_type] = STATE(3006),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(82),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_type_definition_repeat1] = STATE(453),
    [aux_sym_sized_type_specifier_repeat1] = STATE(85),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(135),
    [anon_sym_long] = ACTIONS(135),
    [anon_sym_short] = ACTIONS(135),
    [sym_primitive_type] = ACTIONS(6763),
    [anon_sym_enum] = ACTIONS(139),
    [anon_sym_struct] = ACTIONS(141),
    [anon_sym_union] = ACTIONS(143),
    [sym_identifier] = ACTIONS(145),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(147),
    [sym_auto] = ACTIONS(6763),
    [anon_sym_typename] = ACTIONS(149),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [2563] = {
    [sym_raw_string_literal] = ACTIONS(801),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(803),
    [sym_preproc_directive] = ACTIONS(803),
    [anon_sym_SEMI] = ACTIONS(801),
    [anon_sym_typedef] = ACTIONS(803),
    [anon_sym_extern] = ACTIONS(803),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(801),
    [anon_sym_LBRACK] = ACTIONS(801),
    [anon_sym_static] = ACTIONS(803),
    [anon_sym_register] = ACTIONS(803),
    [anon_sym_inline] = ACTIONS(803),
    [anon_sym_const] = ACTIONS(803),
    [anon_sym_restrict] = ACTIONS(803),
    [anon_sym_volatile] = ACTIONS(803),
    [anon_sym__Atomic] = ACTIONS(803),
    [anon_sym_mutable] = ACTIONS(803),
    [anon_sym_explicit] = ACTIONS(803),
    [anon_sym_constexpr] = ACTIONS(803),
    [anon_sym_unsigned] = ACTIONS(803),
    [anon_sym_long] = ACTIONS(803),
    [anon_sym_short] = ACTIONS(803),
    [sym_primitive_type] = ACTIONS(803),
    [anon_sym_enum] = ACTIONS(803),
    [anon_sym_struct] = ACTIONS(803),
    [anon_sym_union] = ACTIONS(803),
    [anon_sym_if] = ACTIONS(803),
    [anon_sym_else] = ACTIONS(803),
    [anon_sym_switch] = ACTIONS(803),
    [anon_sym_case] = ACTIONS(803),
    [anon_sym_default] = ACTIONS(803),
    [anon_sym_while] = ACTIONS(803),
    [anon_sym_do] = ACTIONS(803),
    [anon_sym_for] = ACTIONS(803),
    [anon_sym_return] = ACTIONS(803),
    [anon_sym_break] = ACTIONS(803),
    [anon_sym_continue] = ACTIONS(803),
    [anon_sym_goto] = ACTIONS(803),
    [anon_sym_AMP] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_DASH] = ACTIONS(803),
    [anon_sym_DASH_DASH] = ACTIONS(801),
    [anon_sym_PLUS_PLUS] = ACTIONS(801),
    [anon_sym_sizeof] = ACTIONS(803),
    [sym_number_literal] = ACTIONS(801),
    [anon_sym_SQUOTE] = ACTIONS(801),
    [anon_sym_DQUOTE] = ACTIONS(801),
    [sym_true] = ACTIONS(803),
    [sym_false] = ACTIONS(803),
    [sym_null] = ACTIONS(803),
    [sym_identifier] = ACTIONS(803),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(803),
    [sym_auto] = ACTIONS(803),
    [anon_sym_typename] = ACTIONS(803),
    [anon_sym_delete] = ACTIONS(803),
    [anon_sym_try] = ACTIONS(803),
    [anon_sym_catch] = ACTIONS(803),
    [anon_sym_new] = ACTIONS(803),
    [anon_sym_COLON_COLON] = ACTIONS(801),
    [sym_nullptr] = ACTIONS(803),
  },
  [2564] = {
    [sym_preproc_include] = STATE(496),
    [sym_preproc_def] = STATE(496),
    [sym_preproc_function_def] = STATE(496),
    [sym_preproc_call] = STATE(496),
    [sym_preproc_if_in_compound_statement] = STATE(496),
    [sym_preproc_ifdef_in_compound_statement] = STATE(496),
    [sym_declaration] = STATE(496),
    [sym_type_definition] = STATE(496),
    [sym__declaration_specifiers] = STATE(113),
    [sym_compound_statement] = STATE(496),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(496),
    [sym_expression_statement] = STATE(496),
    [sym_if_statement] = STATE(496),
    [sym_switch_statement] = STATE(496),
    [sym_case_statement] = STATE(496),
    [sym_while_statement] = STATE(496),
    [sym_do_statement] = STATE(496),
    [sym_for_statement] = STATE(496),
    [sym_return_statement] = STATE(496),
    [sym_break_statement] = STATE(496),
    [sym_continue_statement] = STATE(496),
    [sym_goto_statement] = STATE(496),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(496),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(496),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(496),
    [sym_try_statement] = STATE(496),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(496),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(157),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(159),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(161),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(163),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(165),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(165),
    [sym_preproc_directive] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_typedef] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_RBRACE] = ACTIONS(6765),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(185),
    [anon_sym_case] = ACTIONS(187),
    [anon_sym_default] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(209),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_nullptr] = ACTIONS(207),
  },
  [2565] = {
    [sym__expression] = STATE(3008),
    [sym_conditional_expression] = STATE(3008),
    [sym_assignment_expression] = STATE(3008),
    [sym_pointer_expression] = STATE(3008),
    [sym_logical_expression] = STATE(3008),
    [sym_bitwise_expression] = STATE(3008),
    [sym_equality_expression] = STATE(3008),
    [sym_relational_expression] = STATE(3008),
    [sym_shift_expression] = STATE(3008),
    [sym_math_expression] = STATE(3008),
    [sym_cast_expression] = STATE(3008),
    [sym_sizeof_expression] = STATE(3008),
    [sym_subscript_expression] = STATE(3008),
    [sym_call_expression] = STATE(3008),
    [sym_field_expression] = STATE(3008),
    [sym_compound_literal_expression] = STATE(3008),
    [sym_parenthesized_expression] = STATE(3008),
    [sym_char_literal] = STATE(3008),
    [sym_concatenated_string] = STATE(3008),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3008),
    [sym_new_expression] = STATE(3008),
    [sym_delete_expression] = STATE(3008),
    [sym_lambda_expression] = STATE(3008),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6767),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(6767),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6769),
    [sym_false] = ACTIONS(6769),
    [sym_null] = ACTIONS(6769),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(6769),
  },
  [2566] = {
    [anon_sym_LPAREN2] = ACTIONS(6771),
    [sym_comment] = ACTIONS(91),
  },
  [2567] = {
    [sym_compound_statement] = STATE(3011),
    [sym_labeled_statement] = STATE(3011),
    [sym_expression_statement] = STATE(3011),
    [sym_if_statement] = STATE(3011),
    [sym_switch_statement] = STATE(3011),
    [sym_case_statement] = STATE(3011),
    [sym_while_statement] = STATE(3011),
    [sym_do_statement] = STATE(3011),
    [sym_for_statement] = STATE(3011),
    [sym_return_statement] = STATE(3011),
    [sym_break_statement] = STATE(3011),
    [sym_continue_statement] = STATE(3011),
    [sym_goto_statement] = STATE(3011),
    [sym__expression] = STATE(1908),
    [sym_comma_expression] = STATE(1909),
    [sym_conditional_expression] = STATE(1908),
    [sym_assignment_expression] = STATE(1908),
    [sym_pointer_expression] = STATE(1908),
    [sym_logical_expression] = STATE(1908),
    [sym_bitwise_expression] = STATE(1908),
    [sym_equality_expression] = STATE(1908),
    [sym_relational_expression] = STATE(1908),
    [sym_shift_expression] = STATE(1908),
    [sym_math_expression] = STATE(1908),
    [sym_cast_expression] = STATE(1908),
    [sym_sizeof_expression] = STATE(1908),
    [sym_subscript_expression] = STATE(1908),
    [sym_call_expression] = STATE(1908),
    [sym_field_expression] = STATE(1908),
    [sym_compound_literal_expression] = STATE(1908),
    [sym_parenthesized_expression] = STATE(1908),
    [sym_char_literal] = STATE(1908),
    [sym_concatenated_string] = STATE(1908),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1908),
    [sym_for_range_loop] = STATE(3011),
    [sym_try_statement] = STATE(3011),
    [sym_new_expression] = STATE(1908),
    [sym_delete_expression] = STATE(1908),
    [sym_lambda_expression] = STATE(1908),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3996),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(4016),
    [anon_sym_switch] = ACTIONS(4018),
    [anon_sym_case] = ACTIONS(4020),
    [anon_sym_default] = ACTIONS(4022),
    [anon_sym_while] = ACTIONS(4024),
    [anon_sym_do] = ACTIONS(4026),
    [anon_sym_for] = ACTIONS(4028),
    [anon_sym_return] = ACTIONS(4030),
    [anon_sym_break] = ACTIONS(4032),
    [anon_sym_continue] = ACTIONS(4034),
    [anon_sym_goto] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(3996),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4038),
    [sym_false] = ACTIONS(4038),
    [sym_null] = ACTIONS(4038),
    [sym_identifier] = ACTIONS(6773),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(4042),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(4038),
  },
  [2568] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_COLON] = ACTIONS(6775),
    [anon_sym_QMARK] = ACTIONS(1171),
    [anon_sym_STAR_EQ] = ACTIONS(1173),
    [anon_sym_SLASH_EQ] = ACTIONS(1173),
    [anon_sym_PERCENT_EQ] = ACTIONS(1173),
    [anon_sym_PLUS_EQ] = ACTIONS(1173),
    [anon_sym_DASH_EQ] = ACTIONS(1173),
    [anon_sym_LT_LT_EQ] = ACTIONS(1173),
    [anon_sym_GT_GT_EQ] = ACTIONS(1173),
    [anon_sym_AMP_EQ] = ACTIONS(1173),
    [anon_sym_CARET_EQ] = ACTIONS(1173),
    [anon_sym_PIPE_EQ] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_CARET] = ACTIONS(1183),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [2569] = {
    [sym_declaration] = STATE(3014),
    [sym_type_definition] = STATE(3014),
    [sym__declaration_specifiers] = STATE(3015),
    [sym_compound_statement] = STATE(3014),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_labeled_statement] = STATE(3014),
    [sym_expression_statement] = STATE(3014),
    [sym_if_statement] = STATE(3014),
    [sym_switch_statement] = STATE(3014),
    [sym_case_statement] = STATE(3014),
    [sym_while_statement] = STATE(3014),
    [sym_do_statement] = STATE(3014),
    [sym_for_statement] = STATE(3014),
    [sym_return_statement] = STATE(3014),
    [sym_break_statement] = STATE(3014),
    [sym_continue_statement] = STATE(3014),
    [sym_goto_statement] = STATE(3014),
    [sym__expression] = STATE(1908),
    [sym_comma_expression] = STATE(1909),
    [sym_conditional_expression] = STATE(1908),
    [sym_assignment_expression] = STATE(1908),
    [sym_pointer_expression] = STATE(1908),
    [sym_logical_expression] = STATE(1908),
    [sym_bitwise_expression] = STATE(1908),
    [sym_equality_expression] = STATE(1908),
    [sym_relational_expression] = STATE(1908),
    [sym_shift_expression] = STATE(1908),
    [sym_math_expression] = STATE(1908),
    [sym_cast_expression] = STATE(1908),
    [sym_sizeof_expression] = STATE(1908),
    [sym_subscript_expression] = STATE(1908),
    [sym_call_expression] = STATE(1908),
    [sym_field_expression] = STATE(1908),
    [sym_compound_literal_expression] = STATE(1908),
    [sym_parenthesized_expression] = STATE(1908),
    [sym_char_literal] = STATE(1908),
    [sym_concatenated_string] = STATE(1908),
    [sym_string_literal] = STATE(55),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(1908),
    [sym_for_range_loop] = STATE(3014),
    [sym_try_statement] = STATE(3014),
    [sym_new_expression] = STATE(1908),
    [sym_delete_expression] = STATE(1908),
    [sym_lambda_expression] = STATE(1908),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(3996),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_typedef] = ACTIONS(4012),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(4016),
    [anon_sym_switch] = ACTIONS(4018),
    [anon_sym_case] = ACTIONS(4020),
    [anon_sym_default] = ACTIONS(4022),
    [anon_sym_while] = ACTIONS(4024),
    [anon_sym_do] = ACTIONS(4026),
    [anon_sym_for] = ACTIONS(4028),
    [anon_sym_return] = ACTIONS(4030),
    [anon_sym_break] = ACTIONS(4032),
    [anon_sym_continue] = ACTIONS(4034),
    [anon_sym_goto] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(3996),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4038),
    [sym_false] = ACTIONS(4038),
    [sym_null] = ACTIONS(4038),
    [sym_identifier] = ACTIONS(6777),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(4042),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(1202),
    [sym_nullptr] = ACTIONS(4038),
  },
  [2570] = {
    [sym_compound_statement] = STATE(3016),
    [sym_labeled_statement] = STATE(3016),
    [sym_expression_statement] = STATE(3016),
    [sym_if_statement] = STATE(3016),
    [sym_switch_statement] = STATE(3016),
    [sym_case_statement] = STATE(3016),
    [sym_while_statement] = STATE(3016),
    [sym_do_statement] = STATE(3016),
    [sym_for_statement] = STATE(3016),
    [sym_return_statement] = STATE(3016),
    [sym_break_statement] = STATE(3016),
    [sym_continue_statement] = STATE(3016),
    [sym_goto_statement] = STATE(3016),
    [sym__expression] = STATE(1908),
    [sym_comma_expression] = STATE(1909),
    [sym_conditional_expression] = STATE(1908),
    [sym_assignment_expression] = STATE(1908),
    [sym_pointer_expression] = STATE(1908),
    [sym_logical_expression] = STATE(1908),
    [sym_bitwise_expression] = STATE(1908),
    [sym_equality_expression] = STATE(1908),
    [sym_relational_expression] = STATE(1908),
    [sym_shift_expression] = STATE(1908),
    [sym_math_expression] = STATE(1908),
    [sym_cast_expression] = STATE(1908),
    [sym_sizeof_expression] = STATE(1908),
    [sym_subscript_expression] = STATE(1908),
    [sym_call_expression] = STATE(1908),
    [sym_field_expression] = STATE(1908),
    [sym_compound_literal_expression] = STATE(1908),
    [sym_parenthesized_expression] = STATE(1908),
    [sym_char_literal] = STATE(1908),
    [sym_concatenated_string] = STATE(1908),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1908),
    [sym_for_range_loop] = STATE(3016),
    [sym_try_statement] = STATE(3016),
    [sym_new_expression] = STATE(1908),
    [sym_delete_expression] = STATE(1908),
    [sym_lambda_expression] = STATE(1908),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3996),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(4016),
    [anon_sym_switch] = ACTIONS(4018),
    [anon_sym_case] = ACTIONS(4020),
    [anon_sym_default] = ACTIONS(4022),
    [anon_sym_while] = ACTIONS(4024),
    [anon_sym_do] = ACTIONS(4026),
    [anon_sym_for] = ACTIONS(4028),
    [anon_sym_return] = ACTIONS(4030),
    [anon_sym_break] = ACTIONS(4032),
    [anon_sym_continue] = ACTIONS(4034),
    [anon_sym_goto] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(3996),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4038),
    [sym_false] = ACTIONS(4038),
    [sym_null] = ACTIONS(4038),
    [sym_identifier] = ACTIONS(6773),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(4042),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(4038),
  },
  [2571] = {
    [anon_sym_while] = ACTIONS(6779),
    [sym_comment] = ACTIONS(91),
  },
  [2572] = {
    [sym_declaration] = STATE(3018),
    [sym__declaration_specifiers] = STATE(709),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym__expression] = STATE(3019),
    [sym_conditional_expression] = STATE(3019),
    [sym_assignment_expression] = STATE(3019),
    [sym_pointer_expression] = STATE(3019),
    [sym_logical_expression] = STATE(3019),
    [sym_bitwise_expression] = STATE(3019),
    [sym_equality_expression] = STATE(3019),
    [sym_relational_expression] = STATE(3019),
    [sym_shift_expression] = STATE(3019),
    [sym_math_expression] = STATE(3019),
    [sym_cast_expression] = STATE(3019),
    [sym_sizeof_expression] = STATE(3019),
    [sym_subscript_expression] = STATE(3019),
    [sym_call_expression] = STATE(3019),
    [sym_field_expression] = STATE(3019),
    [sym_compound_literal_expression] = STATE(3019),
    [sym_parenthesized_expression] = STATE(3019),
    [sym_char_literal] = STATE(3019),
    [sym_concatenated_string] = STATE(3019),
    [sym_string_literal] = STATE(238),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(3019),
    [sym_for_range_declaration] = STATE(3020),
    [sym_new_expression] = STATE(3019),
    [sym_delete_expression] = STATE(3019),
    [sym_lambda_expression] = STATE(3019),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(6781),
    [anon_sym_SEMI] = ACTIONS(6783),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(6781),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6785),
    [sym_false] = ACTIONS(6785),
    [sym_null] = ACTIONS(6785),
    [sym_identifier] = ACTIONS(1242),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(1244),
    [sym_nullptr] = ACTIONS(6785),
  },
  [2573] = {
    [sym_raw_string_literal] = ACTIONS(1246),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1248),
    [sym_preproc_directive] = ACTIONS(1248),
    [anon_sym_SEMI] = ACTIONS(1246),
    [anon_sym_typedef] = ACTIONS(1248),
    [anon_sym_extern] = ACTIONS(1248),
    [anon_sym_LBRACE] = ACTIONS(1246),
    [anon_sym_LPAREN2] = ACTIONS(1246),
    [anon_sym_STAR] = ACTIONS(1246),
    [anon_sym_LBRACK] = ACTIONS(1246),
    [anon_sym_static] = ACTIONS(1248),
    [anon_sym_register] = ACTIONS(1248),
    [anon_sym_inline] = ACTIONS(1248),
    [anon_sym_const] = ACTIONS(1248),
    [anon_sym_restrict] = ACTIONS(1248),
    [anon_sym_volatile] = ACTIONS(1248),
    [anon_sym__Atomic] = ACTIONS(1248),
    [anon_sym_mutable] = ACTIONS(1248),
    [anon_sym_explicit] = ACTIONS(1248),
    [anon_sym_constexpr] = ACTIONS(1248),
    [anon_sym_unsigned] = ACTIONS(1248),
    [anon_sym_long] = ACTIONS(1248),
    [anon_sym_short] = ACTIONS(1248),
    [sym_primitive_type] = ACTIONS(1248),
    [anon_sym_enum] = ACTIONS(1248),
    [anon_sym_struct] = ACTIONS(1248),
    [anon_sym_union] = ACTIONS(1248),
    [anon_sym_if] = ACTIONS(1248),
    [anon_sym_else] = ACTIONS(1248),
    [anon_sym_switch] = ACTIONS(1248),
    [anon_sym_case] = ACTIONS(1248),
    [anon_sym_default] = ACTIONS(1248),
    [anon_sym_while] = ACTIONS(1248),
    [anon_sym_do] = ACTIONS(1248),
    [anon_sym_for] = ACTIONS(1248),
    [anon_sym_return] = ACTIONS(1248),
    [anon_sym_break] = ACTIONS(1248),
    [anon_sym_continue] = ACTIONS(1248),
    [anon_sym_goto] = ACTIONS(1248),
    [anon_sym_AMP] = ACTIONS(1246),
    [anon_sym_BANG] = ACTIONS(1246),
    [anon_sym_TILDE] = ACTIONS(1246),
    [anon_sym_PLUS] = ACTIONS(1248),
    [anon_sym_DASH] = ACTIONS(1248),
    [anon_sym_DASH_DASH] = ACTIONS(1246),
    [anon_sym_PLUS_PLUS] = ACTIONS(1246),
    [anon_sym_sizeof] = ACTIONS(1248),
    [sym_number_literal] = ACTIONS(1246),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [anon_sym_DQUOTE] = ACTIONS(1246),
    [sym_true] = ACTIONS(1248),
    [sym_false] = ACTIONS(1248),
    [sym_null] = ACTIONS(1248),
    [sym_identifier] = ACTIONS(1248),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1248),
    [sym_auto] = ACTIONS(1248),
    [anon_sym_typename] = ACTIONS(1248),
    [anon_sym_delete] = ACTIONS(1248),
    [anon_sym_try] = ACTIONS(1248),
    [anon_sym_new] = ACTIONS(1248),
    [anon_sym_COLON_COLON] = ACTIONS(1246),
    [sym_nullptr] = ACTIONS(1248),
  },
  [2574] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(6787),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2575] = {
    [anon_sym_SEMI] = ACTIONS(6787),
    [sym_comment] = ACTIONS(91),
  },
  [2576] = {
    [sym_raw_string_literal] = ACTIONS(1332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1334),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1334),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1334),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1334),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1334),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1334),
    [sym_preproc_directive] = ACTIONS(1334),
    [anon_sym_SEMI] = ACTIONS(1332),
    [anon_sym_typedef] = ACTIONS(1334),
    [anon_sym_extern] = ACTIONS(1334),
    [anon_sym_LBRACE] = ACTIONS(1332),
    [anon_sym_LPAREN2] = ACTIONS(1332),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_LBRACK] = ACTIONS(1332),
    [anon_sym_static] = ACTIONS(1334),
    [anon_sym_register] = ACTIONS(1334),
    [anon_sym_inline] = ACTIONS(1334),
    [anon_sym_const] = ACTIONS(1334),
    [anon_sym_restrict] = ACTIONS(1334),
    [anon_sym_volatile] = ACTIONS(1334),
    [anon_sym__Atomic] = ACTIONS(1334),
    [anon_sym_mutable] = ACTIONS(1334),
    [anon_sym_explicit] = ACTIONS(1334),
    [anon_sym_constexpr] = ACTIONS(1334),
    [anon_sym_unsigned] = ACTIONS(1334),
    [anon_sym_long] = ACTIONS(1334),
    [anon_sym_short] = ACTIONS(1334),
    [sym_primitive_type] = ACTIONS(1334),
    [anon_sym_enum] = ACTIONS(1334),
    [anon_sym_struct] = ACTIONS(1334),
    [anon_sym_union] = ACTIONS(1334),
    [anon_sym_if] = ACTIONS(1334),
    [anon_sym_else] = ACTIONS(1334),
    [anon_sym_switch] = ACTIONS(1334),
    [anon_sym_case] = ACTIONS(1334),
    [anon_sym_default] = ACTIONS(1334),
    [anon_sym_while] = ACTIONS(1334),
    [anon_sym_do] = ACTIONS(1334),
    [anon_sym_for] = ACTIONS(1334),
    [anon_sym_return] = ACTIONS(1334),
    [anon_sym_break] = ACTIONS(1334),
    [anon_sym_continue] = ACTIONS(1334),
    [anon_sym_goto] = ACTIONS(1334),
    [anon_sym_AMP] = ACTIONS(1332),
    [anon_sym_BANG] = ACTIONS(1332),
    [anon_sym_TILDE] = ACTIONS(1332),
    [anon_sym_PLUS] = ACTIONS(1334),
    [anon_sym_DASH] = ACTIONS(1334),
    [anon_sym_DASH_DASH] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(1332),
    [anon_sym_sizeof] = ACTIONS(1334),
    [sym_number_literal] = ACTIONS(1332),
    [anon_sym_SQUOTE] = ACTIONS(1332),
    [anon_sym_DQUOTE] = ACTIONS(1332),
    [sym_true] = ACTIONS(1334),
    [sym_false] = ACTIONS(1334),
    [sym_null] = ACTIONS(1334),
    [sym_identifier] = ACTIONS(1334),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1334),
    [sym_auto] = ACTIONS(1334),
    [anon_sym_typename] = ACTIONS(1334),
    [anon_sym_delete] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1334),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_COLON_COLON] = ACTIONS(1332),
    [sym_nullptr] = ACTIONS(1334),
  },
  [2577] = {
    [sym_raw_string_literal] = ACTIONS(1336),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1338),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1338),
    [sym_preproc_directive] = ACTIONS(1338),
    [anon_sym_SEMI] = ACTIONS(1336),
    [anon_sym_typedef] = ACTIONS(1338),
    [anon_sym_extern] = ACTIONS(1338),
    [anon_sym_LBRACE] = ACTIONS(1336),
    [anon_sym_LPAREN2] = ACTIONS(1336),
    [anon_sym_STAR] = ACTIONS(1336),
    [anon_sym_LBRACK] = ACTIONS(1336),
    [anon_sym_static] = ACTIONS(1338),
    [anon_sym_register] = ACTIONS(1338),
    [anon_sym_inline] = ACTIONS(1338),
    [anon_sym_const] = ACTIONS(1338),
    [anon_sym_restrict] = ACTIONS(1338),
    [anon_sym_volatile] = ACTIONS(1338),
    [anon_sym__Atomic] = ACTIONS(1338),
    [anon_sym_mutable] = ACTIONS(1338),
    [anon_sym_explicit] = ACTIONS(1338),
    [anon_sym_constexpr] = ACTIONS(1338),
    [anon_sym_unsigned] = ACTIONS(1338),
    [anon_sym_long] = ACTIONS(1338),
    [anon_sym_short] = ACTIONS(1338),
    [sym_primitive_type] = ACTIONS(1338),
    [anon_sym_enum] = ACTIONS(1338),
    [anon_sym_struct] = ACTIONS(1338),
    [anon_sym_union] = ACTIONS(1338),
    [anon_sym_if] = ACTIONS(1338),
    [anon_sym_else] = ACTIONS(1338),
    [anon_sym_switch] = ACTIONS(1338),
    [anon_sym_case] = ACTIONS(1338),
    [anon_sym_default] = ACTIONS(1338),
    [anon_sym_while] = ACTIONS(1338),
    [anon_sym_do] = ACTIONS(1338),
    [anon_sym_for] = ACTIONS(1338),
    [anon_sym_return] = ACTIONS(1338),
    [anon_sym_break] = ACTIONS(1338),
    [anon_sym_continue] = ACTIONS(1338),
    [anon_sym_goto] = ACTIONS(1338),
    [anon_sym_AMP] = ACTIONS(1336),
    [anon_sym_BANG] = ACTIONS(1336),
    [anon_sym_TILDE] = ACTIONS(1336),
    [anon_sym_PLUS] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_DASH_DASH] = ACTIONS(1336),
    [anon_sym_PLUS_PLUS] = ACTIONS(1336),
    [anon_sym_sizeof] = ACTIONS(1338),
    [sym_number_literal] = ACTIONS(1336),
    [anon_sym_SQUOTE] = ACTIONS(1336),
    [anon_sym_DQUOTE] = ACTIONS(1336),
    [sym_true] = ACTIONS(1338),
    [sym_false] = ACTIONS(1338),
    [sym_null] = ACTIONS(1338),
    [sym_identifier] = ACTIONS(1338),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1338),
    [sym_auto] = ACTIONS(1338),
    [anon_sym_typename] = ACTIONS(1338),
    [anon_sym_delete] = ACTIONS(1338),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_new] = ACTIONS(1338),
    [anon_sym_COLON_COLON] = ACTIONS(1336),
    [sym_nullptr] = ACTIONS(1338),
  },
  [2578] = {
    [anon_sym_SEMI] = ACTIONS(6789),
    [sym_comment] = ACTIONS(91),
  },
  [2579] = {
    [sym_compound_statement] = STATE(3023),
    [sym_labeled_statement] = STATE(3023),
    [sym_expression_statement] = STATE(3023),
    [sym_if_statement] = STATE(3023),
    [sym_switch_statement] = STATE(3023),
    [sym_case_statement] = STATE(3023),
    [sym_while_statement] = STATE(3023),
    [sym_do_statement] = STATE(3023),
    [sym_for_statement] = STATE(3023),
    [sym_return_statement] = STATE(3023),
    [sym_break_statement] = STATE(3023),
    [sym_continue_statement] = STATE(3023),
    [sym_goto_statement] = STATE(3023),
    [sym__expression] = STATE(1908),
    [sym_comma_expression] = STATE(1909),
    [sym_conditional_expression] = STATE(1908),
    [sym_assignment_expression] = STATE(1908),
    [sym_pointer_expression] = STATE(1908),
    [sym_logical_expression] = STATE(1908),
    [sym_bitwise_expression] = STATE(1908),
    [sym_equality_expression] = STATE(1908),
    [sym_relational_expression] = STATE(1908),
    [sym_shift_expression] = STATE(1908),
    [sym_math_expression] = STATE(1908),
    [sym_cast_expression] = STATE(1908),
    [sym_sizeof_expression] = STATE(1908),
    [sym_subscript_expression] = STATE(1908),
    [sym_call_expression] = STATE(1908),
    [sym_field_expression] = STATE(1908),
    [sym_compound_literal_expression] = STATE(1908),
    [sym_parenthesized_expression] = STATE(1908),
    [sym_char_literal] = STATE(1908),
    [sym_concatenated_string] = STATE(1908),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1908),
    [sym_for_range_loop] = STATE(3023),
    [sym_try_statement] = STATE(3023),
    [sym_new_expression] = STATE(1908),
    [sym_delete_expression] = STATE(1908),
    [sym_lambda_expression] = STATE(1908),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3996),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(4016),
    [anon_sym_switch] = ACTIONS(4018),
    [anon_sym_case] = ACTIONS(4020),
    [anon_sym_default] = ACTIONS(4022),
    [anon_sym_while] = ACTIONS(4024),
    [anon_sym_do] = ACTIONS(4026),
    [anon_sym_for] = ACTIONS(4028),
    [anon_sym_return] = ACTIONS(4030),
    [anon_sym_break] = ACTIONS(4032),
    [anon_sym_continue] = ACTIONS(4034),
    [anon_sym_goto] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(3996),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4038),
    [sym_false] = ACTIONS(4038),
    [sym_null] = ACTIONS(4038),
    [sym_identifier] = ACTIONS(6773),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(4042),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(4038),
  },
  [2580] = {
    [sym_catch_clause] = STATE(3025),
    [aux_sym_try_statement_repeat1] = STATE(3025),
    [sym_comment] = ACTIONS(91),
    [anon_sym_catch] = ACTIONS(6791),
  },
  [2581] = {
    [sym_raw_string_literal] = ACTIONS(1597),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1599),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1599),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1599),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1599),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1599),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1599),
    [sym_preproc_directive] = ACTIONS(1599),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_typedef] = ACTIONS(1599),
    [anon_sym_extern] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1597),
    [anon_sym_LPAREN2] = ACTIONS(1597),
    [anon_sym_STAR] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_static] = ACTIONS(1599),
    [anon_sym_register] = ACTIONS(1599),
    [anon_sym_inline] = ACTIONS(1599),
    [anon_sym_const] = ACTIONS(1599),
    [anon_sym_restrict] = ACTIONS(1599),
    [anon_sym_volatile] = ACTIONS(1599),
    [anon_sym__Atomic] = ACTIONS(1599),
    [anon_sym_mutable] = ACTIONS(1599),
    [anon_sym_explicit] = ACTIONS(1599),
    [anon_sym_constexpr] = ACTIONS(1599),
    [anon_sym_unsigned] = ACTIONS(1599),
    [anon_sym_long] = ACTIONS(1599),
    [anon_sym_short] = ACTIONS(1599),
    [sym_primitive_type] = ACTIONS(1599),
    [anon_sym_enum] = ACTIONS(1599),
    [anon_sym_struct] = ACTIONS(1599),
    [anon_sym_union] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(1599),
    [anon_sym_switch] = ACTIONS(1599),
    [anon_sym_case] = ACTIONS(1599),
    [anon_sym_default] = ACTIONS(1599),
    [anon_sym_while] = ACTIONS(1599),
    [anon_sym_do] = ACTIONS(1599),
    [anon_sym_for] = ACTIONS(1599),
    [anon_sym_return] = ACTIONS(1599),
    [anon_sym_break] = ACTIONS(1599),
    [anon_sym_continue] = ACTIONS(1599),
    [anon_sym_goto] = ACTIONS(1599),
    [anon_sym_AMP] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1597),
    [anon_sym_TILDE] = ACTIONS(1597),
    [anon_sym_PLUS] = ACTIONS(1599),
    [anon_sym_DASH] = ACTIONS(1599),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_sizeof] = ACTIONS(1599),
    [sym_number_literal] = ACTIONS(1597),
    [anon_sym_SQUOTE] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1597),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_null] = ACTIONS(1599),
    [sym_identifier] = ACTIONS(1599),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1599),
    [sym_auto] = ACTIONS(1599),
    [anon_sym_typename] = ACTIONS(1599),
    [anon_sym_delete] = ACTIONS(1599),
    [anon_sym_try] = ACTIONS(1599),
    [anon_sym_new] = ACTIONS(1599),
    [anon_sym_COLON_COLON] = ACTIONS(1597),
    [sym_nullptr] = ACTIONS(1599),
  },
  [2582] = {
    [sym_parameter_list] = STATE(897),
    [sym_argument_list] = STATE(898),
    [sym_initializer_list] = STATE(898),
    [aux_sym_declaration_repeat1] = STATE(3027),
    [anon_sym_COMMA] = ACTIONS(1613),
    [anon_sym_SEMI] = ACTIONS(6793),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(1619),
    [anon_sym_LBRACK] = ACTIONS(574),
    [anon_sym_EQ] = ACTIONS(1621),
    [sym_comment] = ACTIONS(91),
  },
  [2583] = {
    [aux_sym_declaration_repeat1] = STATE(3027),
    [anon_sym_COMMA] = ACTIONS(1613),
    [anon_sym_SEMI] = ACTIONS(6793),
    [sym_comment] = ACTIONS(91),
  },
  [2584] = {
    [sym_argument_list] = STATE(3029),
    [sym_initializer_list] = STATE(3029),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(6795),
    [sym_comment] = ACTIONS(91),
  },
  [2585] = {
    [sym_raw_string_literal] = ACTIONS(1697),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1699),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1699),
    [sym_preproc_directive] = ACTIONS(1699),
    [anon_sym_SEMI] = ACTIONS(1697),
    [anon_sym_typedef] = ACTIONS(1699),
    [anon_sym_extern] = ACTIONS(1699),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_LPAREN2] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1697),
    [anon_sym_LBRACK] = ACTIONS(1697),
    [anon_sym_static] = ACTIONS(1699),
    [anon_sym_register] = ACTIONS(1699),
    [anon_sym_inline] = ACTIONS(1699),
    [anon_sym_const] = ACTIONS(1699),
    [anon_sym_restrict] = ACTIONS(1699),
    [anon_sym_volatile] = ACTIONS(1699),
    [anon_sym__Atomic] = ACTIONS(1699),
    [anon_sym_mutable] = ACTIONS(1699),
    [anon_sym_explicit] = ACTIONS(1699),
    [anon_sym_constexpr] = ACTIONS(1699),
    [anon_sym_unsigned] = ACTIONS(1699),
    [anon_sym_long] = ACTIONS(1699),
    [anon_sym_short] = ACTIONS(1699),
    [sym_primitive_type] = ACTIONS(1699),
    [anon_sym_enum] = ACTIONS(1699),
    [anon_sym_struct] = ACTIONS(1699),
    [anon_sym_union] = ACTIONS(1699),
    [anon_sym_if] = ACTIONS(1699),
    [anon_sym_else] = ACTIONS(1699),
    [anon_sym_switch] = ACTIONS(1699),
    [anon_sym_case] = ACTIONS(1699),
    [anon_sym_default] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(1699),
    [anon_sym_do] = ACTIONS(1699),
    [anon_sym_for] = ACTIONS(1699),
    [anon_sym_return] = ACTIONS(1699),
    [anon_sym_break] = ACTIONS(1699),
    [anon_sym_continue] = ACTIONS(1699),
    [anon_sym_goto] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1697),
    [anon_sym_BANG] = ACTIONS(1697),
    [anon_sym_TILDE] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1697),
    [anon_sym_PLUS_PLUS] = ACTIONS(1697),
    [anon_sym_sizeof] = ACTIONS(1699),
    [sym_number_literal] = ACTIONS(1697),
    [anon_sym_SQUOTE] = ACTIONS(1697),
    [anon_sym_DQUOTE] = ACTIONS(1697),
    [sym_true] = ACTIONS(1699),
    [sym_false] = ACTIONS(1699),
    [sym_null] = ACTIONS(1699),
    [sym_identifier] = ACTIONS(1699),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1699),
    [sym_auto] = ACTIONS(1699),
    [anon_sym_typename] = ACTIONS(1699),
    [anon_sym_delete] = ACTIONS(1699),
    [anon_sym_try] = ACTIONS(1699),
    [anon_sym_new] = ACTIONS(1699),
    [anon_sym_COLON_COLON] = ACTIONS(1697),
    [sym_nullptr] = ACTIONS(1699),
  },
  [2586] = {
    [sym_preproc_include] = STATE(2586),
    [sym_preproc_def] = STATE(2586),
    [sym_preproc_function_def] = STATE(2586),
    [sym_preproc_call] = STATE(2586),
    [sym_preproc_if_in_compound_statement] = STATE(2586),
    [sym_preproc_ifdef_in_compound_statement] = STATE(2586),
    [sym_declaration] = STATE(2586),
    [sym_type_definition] = STATE(2586),
    [sym__declaration_specifiers] = STATE(1907),
    [sym_compound_statement] = STATE(2586),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(2586),
    [sym_expression_statement] = STATE(2586),
    [sym_if_statement] = STATE(2586),
    [sym_switch_statement] = STATE(2586),
    [sym_case_statement] = STATE(2586),
    [sym_while_statement] = STATE(2586),
    [sym_do_statement] = STATE(2586),
    [sym_for_statement] = STATE(2586),
    [sym_return_statement] = STATE(2586),
    [sym_break_statement] = STATE(2586),
    [sym_continue_statement] = STATE(2586),
    [sym_goto_statement] = STATE(2586),
    [sym__expression] = STATE(1908),
    [sym_comma_expression] = STATE(1909),
    [sym_conditional_expression] = STATE(1908),
    [sym_assignment_expression] = STATE(1908),
    [sym_pointer_expression] = STATE(1908),
    [sym_logical_expression] = STATE(1908),
    [sym_bitwise_expression] = STATE(1908),
    [sym_equality_expression] = STATE(1908),
    [sym_relational_expression] = STATE(1908),
    [sym_shift_expression] = STATE(1908),
    [sym_math_expression] = STATE(1908),
    [sym_cast_expression] = STATE(1908),
    [sym_sizeof_expression] = STATE(1908),
    [sym_subscript_expression] = STATE(1908),
    [sym_call_expression] = STATE(1908),
    [sym_field_expression] = STATE(1908),
    [sym_compound_literal_expression] = STATE(1908),
    [sym_parenthesized_expression] = STATE(1908),
    [sym_char_literal] = STATE(1908),
    [sym_concatenated_string] = STATE(1908),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(2586),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(2586),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(1908),
    [sym_for_range_loop] = STATE(2586),
    [sym_try_statement] = STATE(2586),
    [sym_new_expression] = STATE(1908),
    [sym_delete_expression] = STATE(1908),
    [sym_lambda_expression] = STATE(1908),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2586),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(6797),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6800),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6806),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5747),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6809),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6809),
    [sym_preproc_directive] = ACTIONS(6812),
    [anon_sym_SEMI] = ACTIONS(6815),
    [anon_sym_typedef] = ACTIONS(6818),
    [anon_sym_extern] = ACTIONS(2314),
    [anon_sym_LBRACE] = ACTIONS(6821),
    [anon_sym_LPAREN2] = ACTIONS(2322),
    [anon_sym_STAR] = ACTIONS(2325),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_static] = ACTIONS(2314),
    [anon_sym_register] = ACTIONS(2314),
    [anon_sym_inline] = ACTIONS(2314),
    [anon_sym_const] = ACTIONS(2331),
    [anon_sym_restrict] = ACTIONS(2331),
    [anon_sym_volatile] = ACTIONS(2331),
    [anon_sym__Atomic] = ACTIONS(2331),
    [anon_sym_mutable] = ACTIONS(2331),
    [anon_sym_explicit] = ACTIONS(2331),
    [anon_sym_constexpr] = ACTIONS(2331),
    [anon_sym_unsigned] = ACTIONS(2334),
    [anon_sym_long] = ACTIONS(2334),
    [anon_sym_short] = ACTIONS(2334),
    [sym_primitive_type] = ACTIONS(2337),
    [anon_sym_enum] = ACTIONS(2340),
    [anon_sym_struct] = ACTIONS(2343),
    [anon_sym_union] = ACTIONS(2346),
    [anon_sym_if] = ACTIONS(6824),
    [anon_sym_switch] = ACTIONS(6827),
    [anon_sym_case] = ACTIONS(6830),
    [anon_sym_default] = ACTIONS(6833),
    [anon_sym_while] = ACTIONS(6836),
    [anon_sym_do] = ACTIONS(6839),
    [anon_sym_for] = ACTIONS(6842),
    [anon_sym_return] = ACTIONS(6845),
    [anon_sym_break] = ACTIONS(6848),
    [anon_sym_continue] = ACTIONS(6851),
    [anon_sym_goto] = ACTIONS(6854),
    [anon_sym_AMP] = ACTIONS(2325),
    [anon_sym_BANG] = ACTIONS(2382),
    [anon_sym_TILDE] = ACTIONS(2385),
    [anon_sym_PLUS] = ACTIONS(2388),
    [anon_sym_DASH] = ACTIONS(2388),
    [anon_sym_DASH_DASH] = ACTIONS(2391),
    [anon_sym_PLUS_PLUS] = ACTIONS(2391),
    [anon_sym_sizeof] = ACTIONS(2394),
    [sym_number_literal] = ACTIONS(6797),
    [anon_sym_SQUOTE] = ACTIONS(2397),
    [anon_sym_DQUOTE] = ACTIONS(2400),
    [sym_true] = ACTIONS(6857),
    [sym_false] = ACTIONS(6857),
    [sym_null] = ACTIONS(6857),
    [sym_identifier] = ACTIONS(6860),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2409),
    [sym_auto] = ACTIONS(2337),
    [anon_sym_typename] = ACTIONS(2412),
    [anon_sym_delete] = ACTIONS(2415),
    [anon_sym_try] = ACTIONS(6863),
    [anon_sym_new] = ACTIONS(2421),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [sym_nullptr] = ACTIONS(6857),
  },
  [2587] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6866),
    [sym_comment] = ACTIONS(91),
  },
  [2588] = {
    [sym_preproc_include] = STATE(1941),
    [sym_preproc_def] = STATE(1941),
    [sym_preproc_function_def] = STATE(1941),
    [sym_preproc_call] = STATE(1941),
    [sym_preproc_if_in_compound_statement] = STATE(1941),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1941),
    [sym_preproc_else_in_compound_statement] = STATE(3030),
    [sym_preproc_elif_in_compound_statement] = STATE(3030),
    [sym_declaration] = STATE(1941),
    [sym_type_definition] = STATE(1941),
    [sym__declaration_specifiers] = STATE(1138),
    [sym_compound_statement] = STATE(1941),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(1941),
    [sym_expression_statement] = STATE(1941),
    [sym_if_statement] = STATE(1941),
    [sym_switch_statement] = STATE(1941),
    [sym_case_statement] = STATE(1941),
    [sym_while_statement] = STATE(1941),
    [sym_do_statement] = STATE(1941),
    [sym_for_statement] = STATE(1941),
    [sym_return_statement] = STATE(1941),
    [sym_break_statement] = STATE(1941),
    [sym_continue_statement] = STATE(1941),
    [sym_goto_statement] = STATE(1941),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(1941),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(1941),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(1941),
    [sym_try_statement] = STATE(1941),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1941),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(2196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2198),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2200),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6868),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2208),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2210),
    [sym_preproc_directive] = ACTIONS(2212),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_typedef] = ACTIONS(2216),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(2220),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(2244),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_nullptr] = ACTIONS(2242),
  },
  [2589] = {
    [sym_raw_string_literal] = ACTIONS(2144),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2146),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2146),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2146),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2146),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2146),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2146),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2146),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2146),
    [sym_preproc_directive] = ACTIONS(2146),
    [anon_sym_SEMI] = ACTIONS(2144),
    [anon_sym_typedef] = ACTIONS(2146),
    [anon_sym_extern] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(2144),
    [anon_sym_LPAREN2] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(2144),
    [anon_sym_LBRACK] = ACTIONS(2144),
    [anon_sym_static] = ACTIONS(2146),
    [anon_sym_register] = ACTIONS(2146),
    [anon_sym_inline] = ACTIONS(2146),
    [anon_sym_const] = ACTIONS(2146),
    [anon_sym_restrict] = ACTIONS(2146),
    [anon_sym_volatile] = ACTIONS(2146),
    [anon_sym__Atomic] = ACTIONS(2146),
    [anon_sym_mutable] = ACTIONS(2146),
    [anon_sym_explicit] = ACTIONS(2146),
    [anon_sym_constexpr] = ACTIONS(2146),
    [anon_sym_unsigned] = ACTIONS(2146),
    [anon_sym_long] = ACTIONS(2146),
    [anon_sym_short] = ACTIONS(2146),
    [sym_primitive_type] = ACTIONS(2146),
    [anon_sym_enum] = ACTIONS(2146),
    [anon_sym_struct] = ACTIONS(2146),
    [anon_sym_union] = ACTIONS(2146),
    [anon_sym_if] = ACTIONS(2146),
    [anon_sym_switch] = ACTIONS(2146),
    [anon_sym_case] = ACTIONS(2146),
    [anon_sym_default] = ACTIONS(2146),
    [anon_sym_while] = ACTIONS(2146),
    [anon_sym_do] = ACTIONS(2146),
    [anon_sym_for] = ACTIONS(2146),
    [anon_sym_return] = ACTIONS(2146),
    [anon_sym_break] = ACTIONS(2146),
    [anon_sym_continue] = ACTIONS(2146),
    [anon_sym_goto] = ACTIONS(2146),
    [anon_sym_AMP] = ACTIONS(2144),
    [anon_sym_BANG] = ACTIONS(2144),
    [anon_sym_TILDE] = ACTIONS(2144),
    [anon_sym_PLUS] = ACTIONS(2146),
    [anon_sym_DASH] = ACTIONS(2146),
    [anon_sym_DASH_DASH] = ACTIONS(2144),
    [anon_sym_PLUS_PLUS] = ACTIONS(2144),
    [anon_sym_sizeof] = ACTIONS(2146),
    [sym_number_literal] = ACTIONS(2144),
    [anon_sym_SQUOTE] = ACTIONS(2144),
    [anon_sym_DQUOTE] = ACTIONS(2144),
    [sym_true] = ACTIONS(2146),
    [sym_false] = ACTIONS(2146),
    [sym_null] = ACTIONS(2146),
    [sym_identifier] = ACTIONS(2146),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2146),
    [sym_auto] = ACTIONS(2146),
    [anon_sym_typename] = ACTIONS(2146),
    [anon_sym_delete] = ACTIONS(2146),
    [anon_sym_try] = ACTIONS(2146),
    [anon_sym_new] = ACTIONS(2146),
    [anon_sym_COLON_COLON] = ACTIONS(2144),
    [sym_nullptr] = ACTIONS(2146),
  },
  [2590] = {
    [sym_parameter_list] = STATE(1105),
    [anon_sym_SEMI] = ACTIONS(6870),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [sym_comment] = ACTIONS(91),
  },
  [2591] = {
    [sym__type_declarator] = STATE(3032),
    [sym_pointer_type_declarator] = STATE(3032),
    [sym_function_type_declarator] = STATE(3032),
    [sym_array_type_declarator] = STATE(3032),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_STAR] = ACTIONS(768),
    [sym_identifier] = ACTIONS(770),
    [sym_comment] = ACTIONS(91),
  },
  [2592] = {
    [sym_raw_string_literal] = ACTIONS(2286),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2288),
    [sym_preproc_directive] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym_typedef] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_STAR] = ACTIONS(2286),
    [anon_sym_LBRACK] = ACTIONS(2286),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_register] = ACTIONS(2288),
    [anon_sym_inline] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_explicit] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_unsigned] = ACTIONS(2288),
    [anon_sym_long] = ACTIONS(2288),
    [anon_sym_short] = ACTIONS(2288),
    [sym_primitive_type] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [anon_sym_struct] = ACTIONS(2288),
    [anon_sym_union] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_else] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_goto] = ACTIONS(2288),
    [anon_sym_AMP] = ACTIONS(2286),
    [anon_sym_BANG] = ACTIONS(2286),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_sizeof] = ACTIONS(2288),
    [sym_number_literal] = ACTIONS(2286),
    [anon_sym_SQUOTE] = ACTIONS(2286),
    [anon_sym_DQUOTE] = ACTIONS(2286),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [sym_null] = ACTIONS(2288),
    [sym_identifier] = ACTIONS(2288),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2288),
    [sym_auto] = ACTIONS(2288),
    [anon_sym_typename] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_catch] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [sym_nullptr] = ACTIONS(2288),
  },
  [2593] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(6872),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2594] = {
    [sym__expression] = STATE(3034),
    [sym_conditional_expression] = STATE(3034),
    [sym_assignment_expression] = STATE(3034),
    [sym_pointer_expression] = STATE(3034),
    [sym_logical_expression] = STATE(3034),
    [sym_bitwise_expression] = STATE(3034),
    [sym_equality_expression] = STATE(3034),
    [sym_relational_expression] = STATE(3034),
    [sym_shift_expression] = STATE(3034),
    [sym_math_expression] = STATE(3034),
    [sym_cast_expression] = STATE(3034),
    [sym_sizeof_expression] = STATE(3034),
    [sym_subscript_expression] = STATE(3034),
    [sym_call_expression] = STATE(3034),
    [sym_field_expression] = STATE(3034),
    [sym_compound_literal_expression] = STATE(3034),
    [sym_parenthesized_expression] = STATE(3034),
    [sym_char_literal] = STATE(3034),
    [sym_concatenated_string] = STATE(3034),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3034),
    [sym_new_expression] = STATE(3034),
    [sym_delete_expression] = STATE(3034),
    [sym_lambda_expression] = STATE(3034),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6874),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(6874),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6876),
    [sym_false] = ACTIONS(6876),
    [sym_null] = ACTIONS(6876),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(6876),
  },
  [2595] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(548),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_COLON] = ACTIONS(4078),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(935),
  },
  [2596] = {
    [sym_raw_string_literal] = ACTIONS(2767),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2769),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2769),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2769),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2769),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2769),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2769),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2769),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2769),
    [sym_preproc_directive] = ACTIONS(2769),
    [anon_sym_SEMI] = ACTIONS(2767),
    [anon_sym_typedef] = ACTIONS(2769),
    [anon_sym_extern] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_LPAREN2] = ACTIONS(2767),
    [anon_sym_STAR] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(2767),
    [anon_sym_static] = ACTIONS(2769),
    [anon_sym_register] = ACTIONS(2769),
    [anon_sym_inline] = ACTIONS(2769),
    [anon_sym_const] = ACTIONS(2769),
    [anon_sym_restrict] = ACTIONS(2769),
    [anon_sym_volatile] = ACTIONS(2769),
    [anon_sym__Atomic] = ACTIONS(2769),
    [anon_sym_mutable] = ACTIONS(2769),
    [anon_sym_explicit] = ACTIONS(2769),
    [anon_sym_constexpr] = ACTIONS(2769),
    [anon_sym_unsigned] = ACTIONS(2769),
    [anon_sym_long] = ACTIONS(2769),
    [anon_sym_short] = ACTIONS(2769),
    [sym_primitive_type] = ACTIONS(2769),
    [anon_sym_enum] = ACTIONS(2769),
    [anon_sym_struct] = ACTIONS(2769),
    [anon_sym_union] = ACTIONS(2769),
    [anon_sym_if] = ACTIONS(2769),
    [anon_sym_else] = ACTIONS(2769),
    [anon_sym_switch] = ACTIONS(2769),
    [anon_sym_case] = ACTIONS(2769),
    [anon_sym_default] = ACTIONS(2769),
    [anon_sym_while] = ACTIONS(2769),
    [anon_sym_do] = ACTIONS(2769),
    [anon_sym_for] = ACTIONS(2769),
    [anon_sym_return] = ACTIONS(2769),
    [anon_sym_break] = ACTIONS(2769),
    [anon_sym_continue] = ACTIONS(2769),
    [anon_sym_goto] = ACTIONS(2769),
    [anon_sym_AMP] = ACTIONS(2767),
    [anon_sym_BANG] = ACTIONS(2767),
    [anon_sym_TILDE] = ACTIONS(2767),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_DASH_DASH] = ACTIONS(2767),
    [anon_sym_PLUS_PLUS] = ACTIONS(2767),
    [anon_sym_sizeof] = ACTIONS(2769),
    [sym_number_literal] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(2767),
    [anon_sym_DQUOTE] = ACTIONS(2767),
    [sym_true] = ACTIONS(2769),
    [sym_false] = ACTIONS(2769),
    [sym_null] = ACTIONS(2769),
    [sym_identifier] = ACTIONS(2769),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2769),
    [sym_auto] = ACTIONS(2769),
    [anon_sym_typename] = ACTIONS(2769),
    [anon_sym_delete] = ACTIONS(2769),
    [anon_sym_try] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2769),
    [anon_sym_COLON_COLON] = ACTIONS(2767),
    [sym_nullptr] = ACTIONS(2769),
  },
  [2597] = {
    [sym_declaration] = STATE(3035),
    [sym_type_definition] = STATE(3035),
    [sym__declaration_specifiers] = STATE(2600),
    [sym_compound_statement] = STATE(3035),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_labeled_statement] = STATE(3035),
    [sym_expression_statement] = STATE(3035),
    [sym_if_statement] = STATE(3035),
    [sym_switch_statement] = STATE(3035),
    [sym_case_statement] = STATE(3035),
    [sym_while_statement] = STATE(3035),
    [sym_do_statement] = STATE(3035),
    [sym_for_statement] = STATE(3035),
    [sym_return_statement] = STATE(3035),
    [sym_break_statement] = STATE(3035),
    [sym_continue_statement] = STATE(3035),
    [sym_goto_statement] = STATE(3035),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(3035),
    [sym_try_statement] = STATE(3035),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_typedef] = ACTIONS(2216),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(2220),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(5709),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(1202),
    [sym_nullptr] = ACTIONS(2242),
  },
  [2598] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(1362),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_extern] = ACTIONS(468),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(465),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_register] = ACTIONS(468),
    [anon_sym_inline] = ACTIONS(468),
    [anon_sym_const] = ACTIONS(468),
    [anon_sym_restrict] = ACTIONS(468),
    [anon_sym_volatile] = ACTIONS(468),
    [anon_sym__Atomic] = ACTIONS(468),
    [anon_sym_mutable] = ACTIONS(468),
    [anon_sym_explicit] = ACTIONS(468),
    [anon_sym_constexpr] = ACTIONS(468),
    [anon_sym_COLON] = ACTIONS(4078),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(474),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_TILDE] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_identifier] = ACTIONS(468),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(2855),
    [sym_operator_name] = ACTIONS(481),
  },
  [2599] = {
    [sym_raw_string_literal] = ACTIONS(2859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2861),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2861),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2861),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2861),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2861),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2861),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2861),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2861),
    [sym_preproc_directive] = ACTIONS(2861),
    [anon_sym_SEMI] = ACTIONS(2859),
    [anon_sym_typedef] = ACTIONS(2861),
    [anon_sym_extern] = ACTIONS(2861),
    [anon_sym_LBRACE] = ACTIONS(2859),
    [anon_sym_LPAREN2] = ACTIONS(2859),
    [anon_sym_STAR] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_static] = ACTIONS(2861),
    [anon_sym_register] = ACTIONS(2861),
    [anon_sym_inline] = ACTIONS(2861),
    [anon_sym_const] = ACTIONS(2861),
    [anon_sym_restrict] = ACTIONS(2861),
    [anon_sym_volatile] = ACTIONS(2861),
    [anon_sym__Atomic] = ACTIONS(2861),
    [anon_sym_mutable] = ACTIONS(2861),
    [anon_sym_explicit] = ACTIONS(2861),
    [anon_sym_constexpr] = ACTIONS(2861),
    [anon_sym_unsigned] = ACTIONS(2861),
    [anon_sym_long] = ACTIONS(2861),
    [anon_sym_short] = ACTIONS(2861),
    [sym_primitive_type] = ACTIONS(2861),
    [anon_sym_enum] = ACTIONS(2861),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2861),
    [anon_sym_if] = ACTIONS(2861),
    [anon_sym_else] = ACTIONS(2861),
    [anon_sym_switch] = ACTIONS(2861),
    [anon_sym_case] = ACTIONS(2861),
    [anon_sym_default] = ACTIONS(2861),
    [anon_sym_while] = ACTIONS(2861),
    [anon_sym_do] = ACTIONS(2861),
    [anon_sym_for] = ACTIONS(2861),
    [anon_sym_return] = ACTIONS(2861),
    [anon_sym_break] = ACTIONS(2861),
    [anon_sym_continue] = ACTIONS(2861),
    [anon_sym_goto] = ACTIONS(2861),
    [anon_sym_AMP] = ACTIONS(2859),
    [anon_sym_BANG] = ACTIONS(2859),
    [anon_sym_TILDE] = ACTIONS(2859),
    [anon_sym_PLUS] = ACTIONS(2861),
    [anon_sym_DASH] = ACTIONS(2861),
    [anon_sym_DASH_DASH] = ACTIONS(2859),
    [anon_sym_PLUS_PLUS] = ACTIONS(2859),
    [anon_sym_sizeof] = ACTIONS(2861),
    [sym_number_literal] = ACTIONS(2859),
    [anon_sym_SQUOTE] = ACTIONS(2859),
    [anon_sym_DQUOTE] = ACTIONS(2859),
    [sym_true] = ACTIONS(2861),
    [sym_false] = ACTIONS(2861),
    [sym_null] = ACTIONS(2861),
    [sym_identifier] = ACTIONS(2861),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2861),
    [sym_auto] = ACTIONS(2861),
    [anon_sym_typename] = ACTIONS(2861),
    [anon_sym_delete] = ACTIONS(2861),
    [anon_sym_try] = ACTIONS(2861),
    [anon_sym_new] = ACTIONS(2861),
    [anon_sym_COLON_COLON] = ACTIONS(2859),
    [sym_nullptr] = ACTIONS(2861),
  },
  [2600] = {
    [sym__declarator] = STATE(1936),
    [sym_pointer_declarator] = STATE(1936),
    [sym_function_declarator] = STATE(1936),
    [sym_array_declarator] = STATE(1936),
    [sym_init_declarator] = STATE(1937),
    [sym_reference_declarator] = STATE(1936),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(1936),
    [sym_destructor_name] = STATE(1936),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(560),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(568),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(4084),
  },
  [2601] = {
    [sym_raw_string_literal] = ACTIONS(2867),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2869),
    [sym_preproc_directive] = ACTIONS(2869),
    [anon_sym_SEMI] = ACTIONS(2867),
    [anon_sym_typedef] = ACTIONS(2869),
    [anon_sym_extern] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2867),
    [anon_sym_STAR] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_static] = ACTIONS(2869),
    [anon_sym_register] = ACTIONS(2869),
    [anon_sym_inline] = ACTIONS(2869),
    [anon_sym_const] = ACTIONS(2869),
    [anon_sym_restrict] = ACTIONS(2869),
    [anon_sym_volatile] = ACTIONS(2869),
    [anon_sym__Atomic] = ACTIONS(2869),
    [anon_sym_mutable] = ACTIONS(2869),
    [anon_sym_explicit] = ACTIONS(2869),
    [anon_sym_constexpr] = ACTIONS(2869),
    [anon_sym_unsigned] = ACTIONS(2869),
    [anon_sym_long] = ACTIONS(2869),
    [anon_sym_short] = ACTIONS(2869),
    [sym_primitive_type] = ACTIONS(2869),
    [anon_sym_enum] = ACTIONS(2869),
    [anon_sym_struct] = ACTIONS(2869),
    [anon_sym_union] = ACTIONS(2869),
    [anon_sym_if] = ACTIONS(2869),
    [anon_sym_else] = ACTIONS(2869),
    [anon_sym_switch] = ACTIONS(2869),
    [anon_sym_case] = ACTIONS(2869),
    [anon_sym_default] = ACTIONS(2869),
    [anon_sym_while] = ACTIONS(2869),
    [anon_sym_do] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2869),
    [anon_sym_return] = ACTIONS(2869),
    [anon_sym_break] = ACTIONS(2869),
    [anon_sym_continue] = ACTIONS(2869),
    [anon_sym_goto] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_BANG] = ACTIONS(2867),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2869),
    [anon_sym_DASH] = ACTIONS(2869),
    [anon_sym_DASH_DASH] = ACTIONS(2867),
    [anon_sym_PLUS_PLUS] = ACTIONS(2867),
    [anon_sym_sizeof] = ACTIONS(2869),
    [sym_number_literal] = ACTIONS(2867),
    [anon_sym_SQUOTE] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [sym_true] = ACTIONS(2869),
    [sym_false] = ACTIONS(2869),
    [sym_null] = ACTIONS(2869),
    [sym_identifier] = ACTIONS(2869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2869),
    [sym_auto] = ACTIONS(2869),
    [anon_sym_typename] = ACTIONS(2869),
    [anon_sym_delete] = ACTIONS(2869),
    [anon_sym_try] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_COLON_COLON] = ACTIONS(2867),
    [sym_nullptr] = ACTIONS(2869),
  },
  [2602] = {
    [sym_parenthesized_expression] = STATE(3037),
    [anon_sym_LPAREN2] = ACTIONS(6878),
    [sym_comment] = ACTIONS(91),
  },
  [2603] = {
    [sym__expression] = STATE(3039),
    [sym_conditional_expression] = STATE(3039),
    [sym_assignment_expression] = STATE(3039),
    [sym_pointer_expression] = STATE(3039),
    [sym_logical_expression] = STATE(3039),
    [sym_bitwise_expression] = STATE(3039),
    [sym_equality_expression] = STATE(3039),
    [sym_relational_expression] = STATE(3039),
    [sym_shift_expression] = STATE(3039),
    [sym_math_expression] = STATE(3039),
    [sym_cast_expression] = STATE(3039),
    [sym_sizeof_expression] = STATE(3039),
    [sym_subscript_expression] = STATE(3039),
    [sym_call_expression] = STATE(3039),
    [sym_field_expression] = STATE(3039),
    [sym_compound_literal_expression] = STATE(3039),
    [sym_parenthesized_expression] = STATE(3039),
    [sym_char_literal] = STATE(3039),
    [sym_concatenated_string] = STATE(3039),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3039),
    [sym_new_expression] = STATE(3039),
    [sym_delete_expression] = STATE(3039),
    [sym_lambda_expression] = STATE(3039),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6880),
    [anon_sym_SEMI] = ACTIONS(6882),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(6880),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6884),
    [sym_false] = ACTIONS(6884),
    [sym_null] = ACTIONS(6884),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(6884),
  },
  [2604] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(6886),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2605] = {
    [anon_sym_COLON] = ACTIONS(6888),
    [sym_comment] = ACTIONS(91),
  },
  [2606] = {
    [sym_raw_string_literal] = ACTIONS(2999),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3001),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3001),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3001),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3001),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3001),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3001),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3001),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3001),
    [sym_preproc_directive] = ACTIONS(3001),
    [anon_sym_SEMI] = ACTIONS(2999),
    [anon_sym_typedef] = ACTIONS(3001),
    [anon_sym_extern] = ACTIONS(3001),
    [anon_sym_LBRACE] = ACTIONS(2999),
    [anon_sym_LPAREN2] = ACTIONS(2999),
    [anon_sym_STAR] = ACTIONS(2999),
    [anon_sym_LBRACK] = ACTIONS(2999),
    [anon_sym_static] = ACTIONS(3001),
    [anon_sym_register] = ACTIONS(3001),
    [anon_sym_inline] = ACTIONS(3001),
    [anon_sym_const] = ACTIONS(3001),
    [anon_sym_restrict] = ACTIONS(3001),
    [anon_sym_volatile] = ACTIONS(3001),
    [anon_sym__Atomic] = ACTIONS(3001),
    [anon_sym_mutable] = ACTIONS(3001),
    [anon_sym_explicit] = ACTIONS(3001),
    [anon_sym_constexpr] = ACTIONS(3001),
    [anon_sym_unsigned] = ACTIONS(3001),
    [anon_sym_long] = ACTIONS(3001),
    [anon_sym_short] = ACTIONS(3001),
    [sym_primitive_type] = ACTIONS(3001),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_struct] = ACTIONS(3001),
    [anon_sym_union] = ACTIONS(3001),
    [anon_sym_if] = ACTIONS(3001),
    [anon_sym_else] = ACTIONS(3001),
    [anon_sym_switch] = ACTIONS(3001),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3001),
    [anon_sym_while] = ACTIONS(3001),
    [anon_sym_do] = ACTIONS(3001),
    [anon_sym_for] = ACTIONS(3001),
    [anon_sym_return] = ACTIONS(3001),
    [anon_sym_break] = ACTIONS(3001),
    [anon_sym_continue] = ACTIONS(3001),
    [anon_sym_goto] = ACTIONS(3001),
    [anon_sym_AMP] = ACTIONS(2999),
    [anon_sym_BANG] = ACTIONS(2999),
    [anon_sym_TILDE] = ACTIONS(2999),
    [anon_sym_PLUS] = ACTIONS(3001),
    [anon_sym_DASH] = ACTIONS(3001),
    [anon_sym_DASH_DASH] = ACTIONS(2999),
    [anon_sym_PLUS_PLUS] = ACTIONS(2999),
    [anon_sym_sizeof] = ACTIONS(3001),
    [sym_number_literal] = ACTIONS(2999),
    [anon_sym_SQUOTE] = ACTIONS(2999),
    [anon_sym_DQUOTE] = ACTIONS(2999),
    [sym_true] = ACTIONS(3001),
    [sym_false] = ACTIONS(3001),
    [sym_null] = ACTIONS(3001),
    [sym_identifier] = ACTIONS(3001),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3001),
    [sym_auto] = ACTIONS(3001),
    [anon_sym_typename] = ACTIONS(3001),
    [anon_sym_delete] = ACTIONS(3001),
    [anon_sym_try] = ACTIONS(3001),
    [anon_sym_new] = ACTIONS(3001),
    [anon_sym_COLON_COLON] = ACTIONS(2999),
    [sym_nullptr] = ACTIONS(3001),
  },
  [2607] = {
    [sym_raw_string_literal] = ACTIONS(3047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3049),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3049),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3049),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3049),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3049),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3049),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3049),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3049),
    [sym_preproc_directive] = ACTIONS(3049),
    [anon_sym_SEMI] = ACTIONS(3047),
    [anon_sym_typedef] = ACTIONS(3049),
    [anon_sym_extern] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(3047),
    [anon_sym_LPAREN2] = ACTIONS(3047),
    [anon_sym_STAR] = ACTIONS(3047),
    [anon_sym_LBRACK] = ACTIONS(3047),
    [anon_sym_static] = ACTIONS(3049),
    [anon_sym_register] = ACTIONS(3049),
    [anon_sym_inline] = ACTIONS(3049),
    [anon_sym_const] = ACTIONS(3049),
    [anon_sym_restrict] = ACTIONS(3049),
    [anon_sym_volatile] = ACTIONS(3049),
    [anon_sym__Atomic] = ACTIONS(3049),
    [anon_sym_mutable] = ACTIONS(3049),
    [anon_sym_explicit] = ACTIONS(3049),
    [anon_sym_constexpr] = ACTIONS(3049),
    [anon_sym_unsigned] = ACTIONS(3049),
    [anon_sym_long] = ACTIONS(3049),
    [anon_sym_short] = ACTIONS(3049),
    [sym_primitive_type] = ACTIONS(3049),
    [anon_sym_enum] = ACTIONS(3049),
    [anon_sym_struct] = ACTIONS(3049),
    [anon_sym_union] = ACTIONS(3049),
    [anon_sym_if] = ACTIONS(3049),
    [anon_sym_else] = ACTIONS(3049),
    [anon_sym_switch] = ACTIONS(3049),
    [anon_sym_case] = ACTIONS(3049),
    [anon_sym_default] = ACTIONS(3049),
    [anon_sym_while] = ACTIONS(3049),
    [anon_sym_do] = ACTIONS(3049),
    [anon_sym_for] = ACTIONS(3049),
    [anon_sym_return] = ACTIONS(3049),
    [anon_sym_break] = ACTIONS(3049),
    [anon_sym_continue] = ACTIONS(3049),
    [anon_sym_goto] = ACTIONS(3049),
    [anon_sym_AMP] = ACTIONS(3047),
    [anon_sym_BANG] = ACTIONS(3047),
    [anon_sym_TILDE] = ACTIONS(3047),
    [anon_sym_PLUS] = ACTIONS(3049),
    [anon_sym_DASH] = ACTIONS(3049),
    [anon_sym_DASH_DASH] = ACTIONS(3047),
    [anon_sym_PLUS_PLUS] = ACTIONS(3047),
    [anon_sym_sizeof] = ACTIONS(3049),
    [sym_number_literal] = ACTIONS(3047),
    [anon_sym_SQUOTE] = ACTIONS(3047),
    [anon_sym_DQUOTE] = ACTIONS(3047),
    [sym_true] = ACTIONS(3049),
    [sym_false] = ACTIONS(3049),
    [sym_null] = ACTIONS(3049),
    [sym_identifier] = ACTIONS(3049),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3049),
    [sym_auto] = ACTIONS(3049),
    [anon_sym_typename] = ACTIONS(3049),
    [anon_sym_delete] = ACTIONS(3049),
    [anon_sym_try] = ACTIONS(3049),
    [anon_sym_new] = ACTIONS(3049),
    [anon_sym_COLON_COLON] = ACTIONS(3047),
    [sym_nullptr] = ACTIONS(3049),
  },
  [2608] = {
    [sym_raw_string_literal] = ACTIONS(3072),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3074),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3074),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3074),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3074),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3074),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3074),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3074),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3074),
    [sym_preproc_directive] = ACTIONS(3074),
    [anon_sym_SEMI] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3074),
    [anon_sym_extern] = ACTIONS(3074),
    [anon_sym_LBRACE] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3074),
    [anon_sym_register] = ACTIONS(3074),
    [anon_sym_inline] = ACTIONS(3074),
    [anon_sym_const] = ACTIONS(3074),
    [anon_sym_restrict] = ACTIONS(3074),
    [anon_sym_volatile] = ACTIONS(3074),
    [anon_sym__Atomic] = ACTIONS(3074),
    [anon_sym_mutable] = ACTIONS(3074),
    [anon_sym_explicit] = ACTIONS(3074),
    [anon_sym_constexpr] = ACTIONS(3074),
    [anon_sym_unsigned] = ACTIONS(3074),
    [anon_sym_long] = ACTIONS(3074),
    [anon_sym_short] = ACTIONS(3074),
    [sym_primitive_type] = ACTIONS(3074),
    [anon_sym_enum] = ACTIONS(3074),
    [anon_sym_struct] = ACTIONS(3074),
    [anon_sym_union] = ACTIONS(3074),
    [anon_sym_if] = ACTIONS(3074),
    [anon_sym_else] = ACTIONS(3074),
    [anon_sym_switch] = ACTIONS(3074),
    [anon_sym_case] = ACTIONS(3074),
    [anon_sym_default] = ACTIONS(3074),
    [anon_sym_while] = ACTIONS(3074),
    [anon_sym_do] = ACTIONS(3074),
    [anon_sym_for] = ACTIONS(3074),
    [anon_sym_return] = ACTIONS(3074),
    [anon_sym_break] = ACTIONS(3074),
    [anon_sym_continue] = ACTIONS(3074),
    [anon_sym_goto] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_BANG] = ACTIONS(3072),
    [anon_sym_TILDE] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3074),
    [anon_sym_DASH_DASH] = ACTIONS(3072),
    [anon_sym_PLUS_PLUS] = ACTIONS(3072),
    [anon_sym_sizeof] = ACTIONS(3074),
    [sym_number_literal] = ACTIONS(3072),
    [anon_sym_SQUOTE] = ACTIONS(3072),
    [anon_sym_DQUOTE] = ACTIONS(3072),
    [sym_true] = ACTIONS(3074),
    [sym_false] = ACTIONS(3074),
    [sym_null] = ACTIONS(3074),
    [sym_identifier] = ACTIONS(3074),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3074),
    [sym_auto] = ACTIONS(3074),
    [anon_sym_typename] = ACTIONS(3074),
    [anon_sym_delete] = ACTIONS(3074),
    [anon_sym_try] = ACTIONS(3074),
    [anon_sym_new] = ACTIONS(3074),
    [anon_sym_COLON_COLON] = ACTIONS(3072),
    [sym_nullptr] = ACTIONS(3074),
  },
  [2609] = {
    [sym_parameter_list] = STATE(3042),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [sym_comment] = ACTIONS(91),
  },
  [2610] = {
    [sym_catch_clause] = STATE(3043),
    [aux_sym_try_statement_repeat1] = STATE(3043),
    [sym_raw_string_literal] = ACTIONS(3346),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3348),
    [sym_preproc_directive] = ACTIONS(3348),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym_typedef] = ACTIONS(3348),
    [anon_sym_extern] = ACTIONS(3348),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(3346),
    [anon_sym_static] = ACTIONS(3348),
    [anon_sym_register] = ACTIONS(3348),
    [anon_sym_inline] = ACTIONS(3348),
    [anon_sym_const] = ACTIONS(3348),
    [anon_sym_restrict] = ACTIONS(3348),
    [anon_sym_volatile] = ACTIONS(3348),
    [anon_sym__Atomic] = ACTIONS(3348),
    [anon_sym_mutable] = ACTIONS(3348),
    [anon_sym_explicit] = ACTIONS(3348),
    [anon_sym_constexpr] = ACTIONS(3348),
    [anon_sym_unsigned] = ACTIONS(3348),
    [anon_sym_long] = ACTIONS(3348),
    [anon_sym_short] = ACTIONS(3348),
    [sym_primitive_type] = ACTIONS(3348),
    [anon_sym_enum] = ACTIONS(3348),
    [anon_sym_struct] = ACTIONS(3348),
    [anon_sym_union] = ACTIONS(3348),
    [anon_sym_if] = ACTIONS(3348),
    [anon_sym_switch] = ACTIONS(3348),
    [anon_sym_case] = ACTIONS(3348),
    [anon_sym_default] = ACTIONS(3348),
    [anon_sym_while] = ACTIONS(3348),
    [anon_sym_do] = ACTIONS(3348),
    [anon_sym_for] = ACTIONS(3348),
    [anon_sym_return] = ACTIONS(3348),
    [anon_sym_break] = ACTIONS(3348),
    [anon_sym_continue] = ACTIONS(3348),
    [anon_sym_goto] = ACTIONS(3348),
    [anon_sym_AMP] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_PLUS] = ACTIONS(3348),
    [anon_sym_DASH] = ACTIONS(3348),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_sizeof] = ACTIONS(3348),
    [sym_number_literal] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [sym_true] = ACTIONS(3348),
    [sym_false] = ACTIONS(3348),
    [sym_null] = ACTIONS(3348),
    [sym_identifier] = ACTIONS(3348),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3348),
    [sym_auto] = ACTIONS(3348),
    [anon_sym_typename] = ACTIONS(3348),
    [anon_sym_delete] = ACTIONS(3348),
    [anon_sym_try] = ACTIONS(3348),
    [anon_sym_catch] = ACTIONS(6890),
    [anon_sym_new] = ACTIONS(3348),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [sym_nullptr] = ACTIONS(3348),
  },
  [2611] = {
    [sym_raw_string_literal] = ACTIONS(3397),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3399),
    [sym_preproc_directive] = ACTIONS(3399),
    [anon_sym_SEMI] = ACTIONS(3397),
    [anon_sym_typedef] = ACTIONS(3399),
    [anon_sym_extern] = ACTIONS(3399),
    [anon_sym_LBRACE] = ACTIONS(3397),
    [anon_sym_LPAREN2] = ACTIONS(3397),
    [anon_sym_STAR] = ACTIONS(3397),
    [anon_sym_LBRACK] = ACTIONS(3397),
    [anon_sym_static] = ACTIONS(3399),
    [anon_sym_register] = ACTIONS(3399),
    [anon_sym_inline] = ACTIONS(3399),
    [anon_sym_const] = ACTIONS(3399),
    [anon_sym_restrict] = ACTIONS(3399),
    [anon_sym_volatile] = ACTIONS(3399),
    [anon_sym__Atomic] = ACTIONS(3399),
    [anon_sym_mutable] = ACTIONS(3399),
    [anon_sym_explicit] = ACTIONS(3399),
    [anon_sym_constexpr] = ACTIONS(3399),
    [anon_sym_unsigned] = ACTIONS(3399),
    [anon_sym_long] = ACTIONS(3399),
    [anon_sym_short] = ACTIONS(3399),
    [sym_primitive_type] = ACTIONS(3399),
    [anon_sym_enum] = ACTIONS(3399),
    [anon_sym_struct] = ACTIONS(3399),
    [anon_sym_union] = ACTIONS(3399),
    [anon_sym_if] = ACTIONS(3399),
    [anon_sym_else] = ACTIONS(3399),
    [anon_sym_switch] = ACTIONS(3399),
    [anon_sym_case] = ACTIONS(3399),
    [anon_sym_default] = ACTIONS(3399),
    [anon_sym_while] = ACTIONS(3399),
    [anon_sym_do] = ACTIONS(3399),
    [anon_sym_for] = ACTIONS(3399),
    [anon_sym_return] = ACTIONS(3399),
    [anon_sym_break] = ACTIONS(3399),
    [anon_sym_continue] = ACTIONS(3399),
    [anon_sym_goto] = ACTIONS(3399),
    [anon_sym_AMP] = ACTIONS(3397),
    [anon_sym_BANG] = ACTIONS(3397),
    [anon_sym_TILDE] = ACTIONS(3397),
    [anon_sym_PLUS] = ACTIONS(3399),
    [anon_sym_DASH] = ACTIONS(3399),
    [anon_sym_DASH_DASH] = ACTIONS(3397),
    [anon_sym_PLUS_PLUS] = ACTIONS(3397),
    [anon_sym_sizeof] = ACTIONS(3399),
    [sym_number_literal] = ACTIONS(3397),
    [anon_sym_SQUOTE] = ACTIONS(3397),
    [anon_sym_DQUOTE] = ACTIONS(3397),
    [sym_true] = ACTIONS(3399),
    [sym_false] = ACTIONS(3399),
    [sym_null] = ACTIONS(3399),
    [sym_identifier] = ACTIONS(3399),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3399),
    [sym_auto] = ACTIONS(3399),
    [anon_sym_typename] = ACTIONS(3399),
    [anon_sym_delete] = ACTIONS(3399),
    [anon_sym_try] = ACTIONS(3399),
    [anon_sym_new] = ACTIONS(3399),
    [anon_sym_COLON_COLON] = ACTIONS(3397),
    [sym_nullptr] = ACTIONS(3399),
  },
  [2612] = {
    [aux_sym_declaration_repeat1] = STATE(1643),
    [anon_sym_COMMA] = ACTIONS(1613),
    [anon_sym_SEMI] = ACTIONS(6892),
    [sym_comment] = ACTIONS(91),
  },
  [2613] = {
    [sym__expression] = STATE(3045),
    [sym_conditional_expression] = STATE(3045),
    [sym_assignment_expression] = STATE(3045),
    [sym_pointer_expression] = STATE(3045),
    [sym_logical_expression] = STATE(3045),
    [sym_bitwise_expression] = STATE(3045),
    [sym_equality_expression] = STATE(3045),
    [sym_relational_expression] = STATE(3045),
    [sym_shift_expression] = STATE(3045),
    [sym_math_expression] = STATE(3045),
    [sym_cast_expression] = STATE(3045),
    [sym_sizeof_expression] = STATE(3045),
    [sym_subscript_expression] = STATE(3045),
    [sym_call_expression] = STATE(3045),
    [sym_field_expression] = STATE(3045),
    [sym_compound_literal_expression] = STATE(3045),
    [sym_parenthesized_expression] = STATE(3045),
    [sym_initializer_list] = STATE(3046),
    [sym_char_literal] = STATE(3045),
    [sym_concatenated_string] = STATE(3045),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3045),
    [sym_new_expression] = STATE(3045),
    [sym_delete_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3045),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6894),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(6894),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6896),
    [sym_false] = ACTIONS(6896),
    [sym_null] = ACTIONS(6896),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(6896),
  },
  [2614] = {
    [anon_sym_SEMI] = ACTIONS(6898),
    [sym_comment] = ACTIONS(91),
  },
  [2615] = {
    [sym_raw_string_literal] = ACTIONS(6900),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6902),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6902),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6902),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6902),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6902),
    [sym_preproc_directive] = ACTIONS(6902),
    [anon_sym_SEMI] = ACTIONS(6900),
    [anon_sym_typedef] = ACTIONS(6902),
    [anon_sym_extern] = ACTIONS(6902),
    [anon_sym_LBRACE] = ACTIONS(6900),
    [anon_sym_RBRACE] = ACTIONS(6900),
    [anon_sym_LPAREN2] = ACTIONS(6900),
    [anon_sym_STAR] = ACTIONS(6900),
    [anon_sym_LBRACK] = ACTIONS(6900),
    [anon_sym_static] = ACTIONS(6902),
    [anon_sym_register] = ACTIONS(6902),
    [anon_sym_inline] = ACTIONS(6902),
    [anon_sym_const] = ACTIONS(6902),
    [anon_sym_restrict] = ACTIONS(6902),
    [anon_sym_volatile] = ACTIONS(6902),
    [anon_sym__Atomic] = ACTIONS(6902),
    [anon_sym_mutable] = ACTIONS(6902),
    [anon_sym_explicit] = ACTIONS(6902),
    [anon_sym_constexpr] = ACTIONS(6902),
    [anon_sym_unsigned] = ACTIONS(6902),
    [anon_sym_long] = ACTIONS(6902),
    [anon_sym_short] = ACTIONS(6902),
    [sym_primitive_type] = ACTIONS(6902),
    [anon_sym_enum] = ACTIONS(6902),
    [anon_sym_struct] = ACTIONS(6902),
    [anon_sym_union] = ACTIONS(6902),
    [anon_sym_if] = ACTIONS(6902),
    [anon_sym_switch] = ACTIONS(6902),
    [anon_sym_case] = ACTIONS(6902),
    [anon_sym_default] = ACTIONS(6902),
    [anon_sym_while] = ACTIONS(6902),
    [anon_sym_do] = ACTIONS(6902),
    [anon_sym_for] = ACTIONS(6902),
    [anon_sym_return] = ACTIONS(6902),
    [anon_sym_break] = ACTIONS(6902),
    [anon_sym_continue] = ACTIONS(6902),
    [anon_sym_goto] = ACTIONS(6902),
    [anon_sym_AMP] = ACTIONS(6900),
    [anon_sym_BANG] = ACTIONS(6900),
    [anon_sym_TILDE] = ACTIONS(6900),
    [anon_sym_PLUS] = ACTIONS(6902),
    [anon_sym_DASH] = ACTIONS(6902),
    [anon_sym_DASH_DASH] = ACTIONS(6900),
    [anon_sym_PLUS_PLUS] = ACTIONS(6900),
    [anon_sym_sizeof] = ACTIONS(6902),
    [sym_number_literal] = ACTIONS(6900),
    [anon_sym_SQUOTE] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(6900),
    [sym_true] = ACTIONS(6902),
    [sym_false] = ACTIONS(6902),
    [sym_null] = ACTIONS(6902),
    [sym_identifier] = ACTIONS(6902),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6902),
    [sym_auto] = ACTIONS(6902),
    [anon_sym_typename] = ACTIONS(6902),
    [anon_sym_delete] = ACTIONS(6902),
    [anon_sym_try] = ACTIONS(6902),
    [anon_sym_new] = ACTIONS(6902),
    [anon_sym_COLON_COLON] = ACTIONS(6900),
    [sym_nullptr] = ACTIONS(6902),
  },
  [2616] = {
    [sym_raw_string_literal] = ACTIONS(6904),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6906),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6906),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6906),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6906),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6906),
    [sym_preproc_directive] = ACTIONS(6906),
    [anon_sym_SEMI] = ACTIONS(6904),
    [anon_sym_typedef] = ACTIONS(6906),
    [anon_sym_extern] = ACTIONS(6906),
    [anon_sym_LBRACE] = ACTIONS(6904),
    [anon_sym_RBRACE] = ACTIONS(6904),
    [anon_sym_LPAREN2] = ACTIONS(6904),
    [anon_sym_STAR] = ACTIONS(6904),
    [anon_sym_LBRACK] = ACTIONS(6904),
    [anon_sym_static] = ACTIONS(6906),
    [anon_sym_register] = ACTIONS(6906),
    [anon_sym_inline] = ACTIONS(6906),
    [anon_sym_const] = ACTIONS(6906),
    [anon_sym_restrict] = ACTIONS(6906),
    [anon_sym_volatile] = ACTIONS(6906),
    [anon_sym__Atomic] = ACTIONS(6906),
    [anon_sym_mutable] = ACTIONS(6906),
    [anon_sym_explicit] = ACTIONS(6906),
    [anon_sym_constexpr] = ACTIONS(6906),
    [anon_sym_unsigned] = ACTIONS(6906),
    [anon_sym_long] = ACTIONS(6906),
    [anon_sym_short] = ACTIONS(6906),
    [sym_primitive_type] = ACTIONS(6906),
    [anon_sym_enum] = ACTIONS(6906),
    [anon_sym_struct] = ACTIONS(6906),
    [anon_sym_union] = ACTIONS(6906),
    [anon_sym_if] = ACTIONS(6906),
    [anon_sym_switch] = ACTIONS(6906),
    [anon_sym_case] = ACTIONS(6906),
    [anon_sym_default] = ACTIONS(6906),
    [anon_sym_while] = ACTIONS(6906),
    [anon_sym_do] = ACTIONS(6906),
    [anon_sym_for] = ACTIONS(6906),
    [anon_sym_return] = ACTIONS(6906),
    [anon_sym_break] = ACTIONS(6906),
    [anon_sym_continue] = ACTIONS(6906),
    [anon_sym_goto] = ACTIONS(6906),
    [anon_sym_AMP] = ACTIONS(6904),
    [anon_sym_BANG] = ACTIONS(6904),
    [anon_sym_TILDE] = ACTIONS(6904),
    [anon_sym_PLUS] = ACTIONS(6906),
    [anon_sym_DASH] = ACTIONS(6906),
    [anon_sym_DASH_DASH] = ACTIONS(6904),
    [anon_sym_PLUS_PLUS] = ACTIONS(6904),
    [anon_sym_sizeof] = ACTIONS(6906),
    [sym_number_literal] = ACTIONS(6904),
    [anon_sym_SQUOTE] = ACTIONS(6904),
    [anon_sym_DQUOTE] = ACTIONS(6904),
    [sym_true] = ACTIONS(6906),
    [sym_false] = ACTIONS(6906),
    [sym_null] = ACTIONS(6906),
    [sym_identifier] = ACTIONS(6906),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6906),
    [sym_auto] = ACTIONS(6906),
    [anon_sym_typename] = ACTIONS(6906),
    [anon_sym_delete] = ACTIONS(6906),
    [anon_sym_try] = ACTIONS(6906),
    [anon_sym_new] = ACTIONS(6906),
    [anon_sym_COLON_COLON] = ACTIONS(6904),
    [sym_nullptr] = ACTIONS(6906),
  },
  [2617] = {
    [sym_raw_string_literal] = ACTIONS(5621),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5623),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5623),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5623),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5623),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5623),
    [sym_preproc_directive] = ACTIONS(5623),
    [anon_sym_SEMI] = ACTIONS(5621),
    [anon_sym_typedef] = ACTIONS(5623),
    [anon_sym_extern] = ACTIONS(5623),
    [anon_sym_LBRACE] = ACTIONS(5621),
    [anon_sym_RBRACE] = ACTIONS(5621),
    [anon_sym_LPAREN2] = ACTIONS(5621),
    [anon_sym_STAR] = ACTIONS(5621),
    [anon_sym_LBRACK] = ACTIONS(5621),
    [anon_sym_static] = ACTIONS(5623),
    [anon_sym_register] = ACTIONS(5623),
    [anon_sym_inline] = ACTIONS(5623),
    [anon_sym_const] = ACTIONS(5623),
    [anon_sym_restrict] = ACTIONS(5623),
    [anon_sym_volatile] = ACTIONS(5623),
    [anon_sym__Atomic] = ACTIONS(5623),
    [anon_sym_mutable] = ACTIONS(5623),
    [anon_sym_explicit] = ACTIONS(5623),
    [anon_sym_constexpr] = ACTIONS(5623),
    [anon_sym_unsigned] = ACTIONS(5623),
    [anon_sym_long] = ACTIONS(5623),
    [anon_sym_short] = ACTIONS(5623),
    [sym_primitive_type] = ACTIONS(5623),
    [anon_sym_enum] = ACTIONS(5623),
    [anon_sym_struct] = ACTIONS(5623),
    [anon_sym_union] = ACTIONS(5623),
    [anon_sym_if] = ACTIONS(5623),
    [anon_sym_else] = ACTIONS(5623),
    [anon_sym_switch] = ACTIONS(5623),
    [anon_sym_case] = ACTIONS(5623),
    [anon_sym_default] = ACTIONS(5623),
    [anon_sym_while] = ACTIONS(5623),
    [anon_sym_do] = ACTIONS(5623),
    [anon_sym_for] = ACTIONS(5623),
    [anon_sym_return] = ACTIONS(5623),
    [anon_sym_break] = ACTIONS(5623),
    [anon_sym_continue] = ACTIONS(5623),
    [anon_sym_goto] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5621),
    [anon_sym_BANG] = ACTIONS(5621),
    [anon_sym_TILDE] = ACTIONS(5621),
    [anon_sym_PLUS] = ACTIONS(5623),
    [anon_sym_DASH] = ACTIONS(5623),
    [anon_sym_DASH_DASH] = ACTIONS(5621),
    [anon_sym_PLUS_PLUS] = ACTIONS(5621),
    [anon_sym_sizeof] = ACTIONS(5623),
    [sym_number_literal] = ACTIONS(5621),
    [anon_sym_SQUOTE] = ACTIONS(5621),
    [anon_sym_DQUOTE] = ACTIONS(5621),
    [sym_true] = ACTIONS(5623),
    [sym_false] = ACTIONS(5623),
    [sym_null] = ACTIONS(5623),
    [sym_identifier] = ACTIONS(5623),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5623),
    [sym_auto] = ACTIONS(5623),
    [anon_sym_typename] = ACTIONS(5623),
    [anon_sym_delete] = ACTIONS(5623),
    [anon_sym_try] = ACTIONS(5623),
    [anon_sym_new] = ACTIONS(5623),
    [anon_sym_COLON_COLON] = ACTIONS(5621),
    [sym_nullptr] = ACTIONS(5623),
  },
  [2618] = {
    [anon_sym_LPAREN2] = ACTIONS(6908),
    [anon_sym_constexpr] = ACTIONS(6910),
    [sym_comment] = ACTIONS(91),
  },
  [2619] = {
    [sym_parenthesized_expression] = STATE(3050),
    [anon_sym_LPAREN2] = ACTIONS(323),
    [sym_comment] = ACTIONS(91),
  },
  [2620] = {
    [sym__expression] = STATE(3051),
    [sym_conditional_expression] = STATE(3051),
    [sym_assignment_expression] = STATE(3051),
    [sym_pointer_expression] = STATE(3051),
    [sym_logical_expression] = STATE(3051),
    [sym_bitwise_expression] = STATE(3051),
    [sym_equality_expression] = STATE(3051),
    [sym_relational_expression] = STATE(3051),
    [sym_shift_expression] = STATE(3051),
    [sym_math_expression] = STATE(3051),
    [sym_cast_expression] = STATE(3051),
    [sym_sizeof_expression] = STATE(3051),
    [sym_subscript_expression] = STATE(3051),
    [sym_call_expression] = STATE(3051),
    [sym_field_expression] = STATE(3051),
    [sym_compound_literal_expression] = STATE(3051),
    [sym_parenthesized_expression] = STATE(3051),
    [sym_char_literal] = STATE(3051),
    [sym_concatenated_string] = STATE(3051),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3051),
    [sym_new_expression] = STATE(3051),
    [sym_delete_expression] = STATE(3051),
    [sym_lambda_expression] = STATE(3051),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6912),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(6912),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(6914),
    [sym_false] = ACTIONS(6914),
    [sym_null] = ACTIONS(6914),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(6914),
  },
  [2621] = {
    [anon_sym_COLON] = ACTIONS(6916),
    [sym_comment] = ACTIONS(91),
  },
  [2622] = {
    [sym_parenthesized_expression] = STATE(3053),
    [anon_sym_LPAREN2] = ACTIONS(323),
    [sym_comment] = ACTIONS(91),
  },
  [2623] = {
    [anon_sym_LPAREN2] = ACTIONS(6918),
    [sym_comment] = ACTIONS(91),
  },
  [2624] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(548),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_COLON] = ACTIONS(6920),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(935),
  },
  [2625] = {
    [sym_compound_statement] = STATE(3056),
    [anon_sym_LBRACE] = ACTIONS(357),
    [sym_comment] = ACTIONS(91),
  },
  [2626] = {
    [sym_raw_string_literal] = ACTIONS(6091),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6093),
    [sym_preproc_directive] = ACTIONS(6093),
    [anon_sym_SEMI] = ACTIONS(6091),
    [anon_sym_typedef] = ACTIONS(6093),
    [anon_sym_extern] = ACTIONS(6093),
    [anon_sym_LBRACE] = ACTIONS(6091),
    [anon_sym_RBRACE] = ACTIONS(6091),
    [anon_sym_LPAREN2] = ACTIONS(6091),
    [anon_sym_STAR] = ACTIONS(6091),
    [anon_sym_LBRACK] = ACTIONS(6091),
    [anon_sym_static] = ACTIONS(6093),
    [anon_sym_register] = ACTIONS(6093),
    [anon_sym_inline] = ACTIONS(6093),
    [anon_sym_const] = ACTIONS(6093),
    [anon_sym_restrict] = ACTIONS(6093),
    [anon_sym_volatile] = ACTIONS(6093),
    [anon_sym__Atomic] = ACTIONS(6093),
    [anon_sym_mutable] = ACTIONS(6093),
    [anon_sym_explicit] = ACTIONS(6093),
    [anon_sym_constexpr] = ACTIONS(6093),
    [anon_sym_unsigned] = ACTIONS(6093),
    [anon_sym_long] = ACTIONS(6093),
    [anon_sym_short] = ACTIONS(6093),
    [sym_primitive_type] = ACTIONS(6093),
    [anon_sym_enum] = ACTIONS(6093),
    [anon_sym_struct] = ACTIONS(6093),
    [anon_sym_union] = ACTIONS(6093),
    [anon_sym_if] = ACTIONS(6093),
    [anon_sym_else] = ACTIONS(6922),
    [anon_sym_switch] = ACTIONS(6093),
    [anon_sym_case] = ACTIONS(6093),
    [anon_sym_default] = ACTIONS(6093),
    [anon_sym_while] = ACTIONS(6093),
    [anon_sym_do] = ACTIONS(6093),
    [anon_sym_for] = ACTIONS(6093),
    [anon_sym_return] = ACTIONS(6093),
    [anon_sym_break] = ACTIONS(6093),
    [anon_sym_continue] = ACTIONS(6093),
    [anon_sym_goto] = ACTIONS(6093),
    [anon_sym_AMP] = ACTIONS(6091),
    [anon_sym_BANG] = ACTIONS(6091),
    [anon_sym_TILDE] = ACTIONS(6091),
    [anon_sym_PLUS] = ACTIONS(6093),
    [anon_sym_DASH] = ACTIONS(6093),
    [anon_sym_DASH_DASH] = ACTIONS(6091),
    [anon_sym_PLUS_PLUS] = ACTIONS(6091),
    [anon_sym_sizeof] = ACTIONS(6093),
    [sym_number_literal] = ACTIONS(6091),
    [anon_sym_SQUOTE] = ACTIONS(6091),
    [anon_sym_DQUOTE] = ACTIONS(6091),
    [sym_true] = ACTIONS(6093),
    [sym_false] = ACTIONS(6093),
    [sym_null] = ACTIONS(6093),
    [sym_identifier] = ACTIONS(6093),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6093),
    [sym_auto] = ACTIONS(6093),
    [anon_sym_typename] = ACTIONS(6093),
    [anon_sym_delete] = ACTIONS(6093),
    [anon_sym_try] = ACTIONS(6093),
    [anon_sym_new] = ACTIONS(6093),
    [anon_sym_COLON_COLON] = ACTIONS(6091),
    [sym_nullptr] = ACTIONS(6093),
  },
  [2627] = {
    [sym_compound_statement] = STATE(3058),
    [sym_labeled_statement] = STATE(3058),
    [sym_expression_statement] = STATE(3058),
    [sym_if_statement] = STATE(3058),
    [sym_switch_statement] = STATE(3058),
    [sym_case_statement] = STATE(3058),
    [sym_while_statement] = STATE(3058),
    [sym_do_statement] = STATE(3058),
    [sym_for_statement] = STATE(3058),
    [sym_return_statement] = STATE(3058),
    [sym_break_statement] = STATE(3058),
    [sym_continue_statement] = STATE(3058),
    [sym_goto_statement] = STATE(3058),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(3058),
    [sym_try_statement] = STATE(3058),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(157),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(5814),
    [anon_sym_switch] = ACTIONS(5816),
    [anon_sym_case] = ACTIONS(5818),
    [anon_sym_default] = ACTIONS(5820),
    [anon_sym_while] = ACTIONS(5822),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(5824),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(5826),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(5828),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(207),
  },
  [2628] = {
    [sym_compound_statement] = STATE(3059),
    [sym_labeled_statement] = STATE(3059),
    [sym_expression_statement] = STATE(3059),
    [sym_if_statement] = STATE(3059),
    [sym_switch_statement] = STATE(3059),
    [sym_case_statement] = STATE(3059),
    [sym_while_statement] = STATE(3059),
    [sym_do_statement] = STATE(3059),
    [sym_for_statement] = STATE(3059),
    [sym_return_statement] = STATE(3059),
    [sym_break_statement] = STATE(3059),
    [sym_continue_statement] = STATE(3059),
    [sym_goto_statement] = STATE(3059),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(3059),
    [sym_try_statement] = STATE(3059),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(157),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(185),
    [anon_sym_case] = ACTIONS(187),
    [anon_sym_default] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(2262),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(207),
  },
  [2629] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3061),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(6924),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2630] = {
    [sym__expression] = STATE(3062),
    [sym_conditional_expression] = STATE(3062),
    [sym_assignment_expression] = STATE(3062),
    [sym_pointer_expression] = STATE(3062),
    [sym_logical_expression] = STATE(3062),
    [sym_bitwise_expression] = STATE(3062),
    [sym_equality_expression] = STATE(3062),
    [sym_relational_expression] = STATE(3062),
    [sym_shift_expression] = STATE(3062),
    [sym_math_expression] = STATE(3062),
    [sym_cast_expression] = STATE(3062),
    [sym_sizeof_expression] = STATE(3062),
    [sym_subscript_expression] = STATE(3062),
    [sym_call_expression] = STATE(3062),
    [sym_field_expression] = STATE(3062),
    [sym_compound_literal_expression] = STATE(3062),
    [sym_parenthesized_expression] = STATE(3062),
    [sym_char_literal] = STATE(3062),
    [sym_concatenated_string] = STATE(3062),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3062),
    [sym_new_expression] = STATE(3062),
    [sym_delete_expression] = STATE(3062),
    [sym_lambda_expression] = STATE(3062),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(6926),
    [anon_sym_RPAREN] = ACTIONS(6924),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(6926),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6928),
    [sym_false] = ACTIONS(6928),
    [sym_null] = ACTIONS(6928),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(6928),
  },
  [2631] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(6930),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2632] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(6932),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2633] = {
    [sym_raw_string_literal] = ACTIONS(6379),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6381),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6381),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6381),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6381),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6381),
    [sym_preproc_directive] = ACTIONS(6381),
    [anon_sym_SEMI] = ACTIONS(6379),
    [anon_sym_typedef] = ACTIONS(6381),
    [anon_sym_extern] = ACTIONS(6381),
    [anon_sym_LBRACE] = ACTIONS(6379),
    [anon_sym_RBRACE] = ACTIONS(6379),
    [anon_sym_LPAREN2] = ACTIONS(6379),
    [anon_sym_STAR] = ACTIONS(6379),
    [anon_sym_LBRACK] = ACTIONS(6379),
    [anon_sym_static] = ACTIONS(6381),
    [anon_sym_register] = ACTIONS(6381),
    [anon_sym_inline] = ACTIONS(6381),
    [anon_sym_const] = ACTIONS(6381),
    [anon_sym_restrict] = ACTIONS(6381),
    [anon_sym_volatile] = ACTIONS(6381),
    [anon_sym__Atomic] = ACTIONS(6381),
    [anon_sym_mutable] = ACTIONS(6381),
    [anon_sym_explicit] = ACTIONS(6381),
    [anon_sym_constexpr] = ACTIONS(6381),
    [anon_sym_unsigned] = ACTIONS(6381),
    [anon_sym_long] = ACTIONS(6381),
    [anon_sym_short] = ACTIONS(6381),
    [sym_primitive_type] = ACTIONS(6381),
    [anon_sym_enum] = ACTIONS(6381),
    [anon_sym_struct] = ACTIONS(6381),
    [anon_sym_union] = ACTIONS(6381),
    [anon_sym_if] = ACTIONS(6381),
    [anon_sym_else] = ACTIONS(6381),
    [anon_sym_switch] = ACTIONS(6381),
    [anon_sym_case] = ACTIONS(6381),
    [anon_sym_default] = ACTIONS(6381),
    [anon_sym_while] = ACTIONS(6381),
    [anon_sym_do] = ACTIONS(6381),
    [anon_sym_for] = ACTIONS(6381),
    [anon_sym_return] = ACTIONS(6381),
    [anon_sym_break] = ACTIONS(6381),
    [anon_sym_continue] = ACTIONS(6381),
    [anon_sym_goto] = ACTIONS(6381),
    [anon_sym_AMP] = ACTIONS(6379),
    [anon_sym_BANG] = ACTIONS(6379),
    [anon_sym_TILDE] = ACTIONS(6379),
    [anon_sym_PLUS] = ACTIONS(6381),
    [anon_sym_DASH] = ACTIONS(6381),
    [anon_sym_DASH_DASH] = ACTIONS(6379),
    [anon_sym_PLUS_PLUS] = ACTIONS(6379),
    [anon_sym_sizeof] = ACTIONS(6381),
    [sym_number_literal] = ACTIONS(6379),
    [anon_sym_SQUOTE] = ACTIONS(6379),
    [anon_sym_DQUOTE] = ACTIONS(6379),
    [sym_true] = ACTIONS(6381),
    [sym_false] = ACTIONS(6381),
    [sym_null] = ACTIONS(6381),
    [sym_identifier] = ACTIONS(6381),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6381),
    [sym_auto] = ACTIONS(6381),
    [anon_sym_typename] = ACTIONS(6381),
    [anon_sym_delete] = ACTIONS(6381),
    [anon_sym_try] = ACTIONS(6381),
    [anon_sym_catch] = ACTIONS(6381),
    [anon_sym_new] = ACTIONS(6381),
    [anon_sym_COLON_COLON] = ACTIONS(6379),
    [sym_nullptr] = ACTIONS(6381),
  },
  [2634] = {
    [sym_raw_string_literal] = ACTIONS(6503),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6505),
    [sym_preproc_directive] = ACTIONS(6505),
    [anon_sym_SEMI] = ACTIONS(6503),
    [anon_sym_typedef] = ACTIONS(6505),
    [anon_sym_extern] = ACTIONS(6505),
    [anon_sym_LBRACE] = ACTIONS(6503),
    [anon_sym_RBRACE] = ACTIONS(6503),
    [anon_sym_LPAREN2] = ACTIONS(6503),
    [anon_sym_STAR] = ACTIONS(6503),
    [anon_sym_LBRACK] = ACTIONS(6503),
    [anon_sym_static] = ACTIONS(6505),
    [anon_sym_register] = ACTIONS(6505),
    [anon_sym_inline] = ACTIONS(6505),
    [anon_sym_const] = ACTIONS(6505),
    [anon_sym_restrict] = ACTIONS(6505),
    [anon_sym_volatile] = ACTIONS(6505),
    [anon_sym__Atomic] = ACTIONS(6505),
    [anon_sym_mutable] = ACTIONS(6505),
    [anon_sym_explicit] = ACTIONS(6505),
    [anon_sym_constexpr] = ACTIONS(6505),
    [anon_sym_unsigned] = ACTIONS(6505),
    [anon_sym_long] = ACTIONS(6505),
    [anon_sym_short] = ACTIONS(6505),
    [sym_primitive_type] = ACTIONS(6505),
    [anon_sym_enum] = ACTIONS(6505),
    [anon_sym_struct] = ACTIONS(6505),
    [anon_sym_union] = ACTIONS(6505),
    [anon_sym_if] = ACTIONS(6505),
    [anon_sym_switch] = ACTIONS(6505),
    [anon_sym_case] = ACTIONS(6505),
    [anon_sym_default] = ACTIONS(6505),
    [anon_sym_while] = ACTIONS(6505),
    [anon_sym_do] = ACTIONS(6505),
    [anon_sym_for] = ACTIONS(6505),
    [anon_sym_return] = ACTIONS(6505),
    [anon_sym_break] = ACTIONS(6505),
    [anon_sym_continue] = ACTIONS(6505),
    [anon_sym_goto] = ACTIONS(6505),
    [anon_sym_AMP] = ACTIONS(6503),
    [anon_sym_BANG] = ACTIONS(6503),
    [anon_sym_TILDE] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6505),
    [anon_sym_DASH] = ACTIONS(6505),
    [anon_sym_DASH_DASH] = ACTIONS(6503),
    [anon_sym_PLUS_PLUS] = ACTIONS(6503),
    [anon_sym_sizeof] = ACTIONS(6505),
    [sym_number_literal] = ACTIONS(6503),
    [anon_sym_SQUOTE] = ACTIONS(6503),
    [anon_sym_DQUOTE] = ACTIONS(6503),
    [sym_true] = ACTIONS(6505),
    [sym_false] = ACTIONS(6505),
    [sym_null] = ACTIONS(6505),
    [sym_identifier] = ACTIONS(6505),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6505),
    [sym_auto] = ACTIONS(6505),
    [anon_sym_typename] = ACTIONS(6505),
    [anon_sym_delete] = ACTIONS(6505),
    [anon_sym_try] = ACTIONS(6505),
    [anon_sym_new] = ACTIONS(6505),
    [anon_sym_COLON_COLON] = ACTIONS(6503),
    [sym_nullptr] = ACTIONS(6505),
  },
  [2635] = {
    [sym_new_declarator] = STATE(2861),
    [anon_sym_COMMA] = ACTIONS(6396),
    [anon_sym_RPAREN] = ACTIONS(6396),
    [anon_sym_LBRACE] = ACTIONS(6396),
    [anon_sym_LPAREN2] = ACTIONS(6396),
    [anon_sym_STAR] = ACTIONS(6398),
    [anon_sym_LBRACK] = ACTIONS(2443),
    [anon_sym_EQ] = ACTIONS(6398),
    [anon_sym_QMARK] = ACTIONS(6396),
    [anon_sym_STAR_EQ] = ACTIONS(6396),
    [anon_sym_SLASH_EQ] = ACTIONS(6396),
    [anon_sym_PERCENT_EQ] = ACTIONS(6396),
    [anon_sym_PLUS_EQ] = ACTIONS(6396),
    [anon_sym_DASH_EQ] = ACTIONS(6396),
    [anon_sym_LT_LT_EQ] = ACTIONS(6396),
    [anon_sym_GT_GT_EQ] = ACTIONS(6396),
    [anon_sym_AMP_EQ] = ACTIONS(6396),
    [anon_sym_CARET_EQ] = ACTIONS(6396),
    [anon_sym_PIPE_EQ] = ACTIONS(6396),
    [anon_sym_AMP] = ACTIONS(6398),
    [anon_sym_PIPE_PIPE] = ACTIONS(6396),
    [anon_sym_AMP_AMP] = ACTIONS(6396),
    [anon_sym_PIPE] = ACTIONS(6398),
    [anon_sym_CARET] = ACTIONS(6398),
    [anon_sym_EQ_EQ] = ACTIONS(6396),
    [anon_sym_BANG_EQ] = ACTIONS(6396),
    [anon_sym_LT] = ACTIONS(6398),
    [anon_sym_GT] = ACTIONS(6398),
    [anon_sym_LT_EQ] = ACTIONS(6396),
    [anon_sym_GT_EQ] = ACTIONS(6396),
    [anon_sym_LT_LT] = ACTIONS(6398),
    [anon_sym_GT_GT] = ACTIONS(6398),
    [anon_sym_PLUS] = ACTIONS(6398),
    [anon_sym_DASH] = ACTIONS(6398),
    [anon_sym_SLASH] = ACTIONS(6398),
    [anon_sym_PERCENT] = ACTIONS(6398),
    [anon_sym_DASH_DASH] = ACTIONS(6396),
    [anon_sym_PLUS_PLUS] = ACTIONS(6396),
    [anon_sym_DOT] = ACTIONS(6396),
    [anon_sym_DASH_GT] = ACTIONS(6396),
    [sym_comment] = ACTIONS(91),
  },
  [2636] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(6404),
    [anon_sym_RPAREN] = ACTIONS(6404),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(6406),
    [anon_sym_QMARK] = ACTIONS(6404),
    [anon_sym_STAR_EQ] = ACTIONS(6404),
    [anon_sym_SLASH_EQ] = ACTIONS(6404),
    [anon_sym_PERCENT_EQ] = ACTIONS(6404),
    [anon_sym_PLUS_EQ] = ACTIONS(6404),
    [anon_sym_DASH_EQ] = ACTIONS(6404),
    [anon_sym_LT_LT_EQ] = ACTIONS(6404),
    [anon_sym_GT_GT_EQ] = ACTIONS(6404),
    [anon_sym_AMP_EQ] = ACTIONS(6404),
    [anon_sym_CARET_EQ] = ACTIONS(6404),
    [anon_sym_PIPE_EQ] = ACTIONS(6404),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2637] = {
    [sym_field_declaration_list] = STATE(612),
    [sym_virtual_specifier] = STATE(613),
    [sym_base_class_clause] = STATE(614),
    [sym_template_argument_list] = STATE(437),
    [anon_sym_RPAREN] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LPAREN2] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_const] = ACTIONS(1059),
    [anon_sym_restrict] = ACTIONS(1057),
    [anon_sym_volatile] = ACTIONS(1057),
    [anon_sym__Atomic] = ACTIONS(1057),
    [anon_sym_mutable] = ACTIONS(1057),
    [anon_sym_explicit] = ACTIONS(1057),
    [anon_sym_constexpr] = ACTIONS(1057),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_DASH_GT] = ACTIONS(1057),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1057),
    [anon_sym_override] = ACTIONS(1057),
    [sym_noexcept] = ACTIONS(1057),
    [anon_sym_COLON_COLON] = ACTIONS(758),
  },
  [2638] = {
    [sym_field_declaration_list] = STATE(617),
    [sym_virtual_specifier] = STATE(620),
    [sym_base_class_clause] = STATE(618),
    [anon_sym_RPAREN] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1069),
    [anon_sym_const] = ACTIONS(1071),
    [anon_sym_restrict] = ACTIONS(1069),
    [anon_sym_volatile] = ACTIONS(1069),
    [anon_sym__Atomic] = ACTIONS(1069),
    [anon_sym_mutable] = ACTIONS(1069),
    [anon_sym_explicit] = ACTIONS(1069),
    [anon_sym_constexpr] = ACTIONS(1069),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1069),
    [anon_sym_DASH_GT] = ACTIONS(1069),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1069),
    [anon_sym_override] = ACTIONS(1069),
    [sym_noexcept] = ACTIONS(1069),
    [anon_sym_COLON_COLON] = ACTIONS(772),
  },
  [2639] = {
    [sym_field_declaration_list] = STATE(617),
    [sym_virtual_specifier] = STATE(620),
    [sym_base_class_clause] = STATE(618),
    [sym_template_argument_list] = STATE(362),
    [anon_sym_RPAREN] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1069),
    [anon_sym_const] = ACTIONS(1071),
    [anon_sym_restrict] = ACTIONS(1069),
    [anon_sym_volatile] = ACTIONS(1069),
    [anon_sym__Atomic] = ACTIONS(1069),
    [anon_sym_mutable] = ACTIONS(1069),
    [anon_sym_explicit] = ACTIONS(1069),
    [anon_sym_constexpr] = ACTIONS(1069),
    [anon_sym_COLON] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1069),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_DASH_GT] = ACTIONS(1069),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1069),
    [anon_sym_override] = ACTIONS(1069),
    [sym_noexcept] = ACTIONS(1069),
  },
  [2640] = {
    [sym_field_declaration_list] = STATE(621),
    [sym_virtual_specifier] = STATE(622),
    [sym_base_class_clause] = STATE(623),
    [sym_template_argument_list] = STATE(437),
    [anon_sym_RPAREN] = ACTIONS(1077),
    [anon_sym_SEMI] = ACTIONS(1077),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LPAREN2] = ACTIONS(1077),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_LBRACK] = ACTIONS(1077),
    [anon_sym_const] = ACTIONS(1079),
    [anon_sym_restrict] = ACTIONS(1077),
    [anon_sym_volatile] = ACTIONS(1077),
    [anon_sym__Atomic] = ACTIONS(1077),
    [anon_sym_mutable] = ACTIONS(1077),
    [anon_sym_explicit] = ACTIONS(1077),
    [anon_sym_constexpr] = ACTIONS(1077),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_DASH_GT] = ACTIONS(1077),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1077),
    [anon_sym_override] = ACTIONS(1077),
    [sym_noexcept] = ACTIONS(1077),
    [anon_sym_COLON_COLON] = ACTIONS(758),
  },
  [2641] = {
    [sym_field_declaration_list] = STATE(624),
    [sym_virtual_specifier] = STATE(626),
    [sym_base_class_clause] = STATE(625),
    [anon_sym_RPAREN] = ACTIONS(1081),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LPAREN2] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1081),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_const] = ACTIONS(1083),
    [anon_sym_restrict] = ACTIONS(1081),
    [anon_sym_volatile] = ACTIONS(1081),
    [anon_sym__Atomic] = ACTIONS(1081),
    [anon_sym_mutable] = ACTIONS(1081),
    [anon_sym_explicit] = ACTIONS(1081),
    [anon_sym_constexpr] = ACTIONS(1081),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(1081),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1081),
    [anon_sym_override] = ACTIONS(1081),
    [sym_noexcept] = ACTIONS(1081),
    [anon_sym_COLON_COLON] = ACTIONS(772),
  },
  [2642] = {
    [sym_field_declaration_list] = STATE(624),
    [sym_virtual_specifier] = STATE(626),
    [sym_base_class_clause] = STATE(625),
    [sym_template_argument_list] = STATE(362),
    [anon_sym_RPAREN] = ACTIONS(1081),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LPAREN2] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1081),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_const] = ACTIONS(1083),
    [anon_sym_restrict] = ACTIONS(1081),
    [anon_sym_volatile] = ACTIONS(1081),
    [anon_sym__Atomic] = ACTIONS(1081),
    [anon_sym_mutable] = ACTIONS(1081),
    [anon_sym_explicit] = ACTIONS(1081),
    [anon_sym_constexpr] = ACTIONS(1081),
    [anon_sym_COLON] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_DASH_GT] = ACTIONS(1081),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1081),
    [anon_sym_override] = ACTIONS(1081),
    [sym_noexcept] = ACTIONS(1081),
  },
  [2643] = {
    [sym_field_declaration_list] = STATE(790),
    [sym_virtual_specifier] = STATE(791),
    [sym_base_class_clause] = STATE(792),
    [sym_template_argument_list] = STATE(437),
    [anon_sym_RPAREN] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1438),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LPAREN2] = ACTIONS(1438),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_LBRACK] = ACTIONS(1438),
    [anon_sym_const] = ACTIONS(1440),
    [anon_sym_restrict] = ACTIONS(1438),
    [anon_sym_volatile] = ACTIONS(1438),
    [anon_sym__Atomic] = ACTIONS(1438),
    [anon_sym_mutable] = ACTIONS(1438),
    [anon_sym_explicit] = ACTIONS(1438),
    [anon_sym_constexpr] = ACTIONS(1438),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_AMP_AMP] = ACTIONS(1438),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_DASH_GT] = ACTIONS(1438),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1438),
    [anon_sym_override] = ACTIONS(1438),
    [sym_noexcept] = ACTIONS(1438),
    [anon_sym_COLON_COLON] = ACTIONS(758),
  },
  [2644] = {
    [sym_field_declaration_list] = STATE(793),
    [sym_virtual_specifier] = STATE(795),
    [sym_base_class_clause] = STATE(794),
    [anon_sym_RPAREN] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1442),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LPAREN2] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(1442),
    [anon_sym_const] = ACTIONS(1444),
    [anon_sym_restrict] = ACTIONS(1442),
    [anon_sym_volatile] = ACTIONS(1442),
    [anon_sym__Atomic] = ACTIONS(1442),
    [anon_sym_mutable] = ACTIONS(1442),
    [anon_sym_explicit] = ACTIONS(1442),
    [anon_sym_constexpr] = ACTIONS(1442),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1442),
    [anon_sym_DASH_GT] = ACTIONS(1442),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1442),
    [anon_sym_override] = ACTIONS(1442),
    [sym_noexcept] = ACTIONS(1442),
    [anon_sym_COLON_COLON] = ACTIONS(772),
  },
  [2645] = {
    [sym_field_declaration_list] = STATE(793),
    [sym_virtual_specifier] = STATE(795),
    [sym_base_class_clause] = STATE(794),
    [sym_template_argument_list] = STATE(362),
    [anon_sym_RPAREN] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1442),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LPAREN2] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(1442),
    [anon_sym_const] = ACTIONS(1444),
    [anon_sym_restrict] = ACTIONS(1442),
    [anon_sym_volatile] = ACTIONS(1442),
    [anon_sym__Atomic] = ACTIONS(1442),
    [anon_sym_mutable] = ACTIONS(1442),
    [anon_sym_explicit] = ACTIONS(1442),
    [anon_sym_constexpr] = ACTIONS(1442),
    [anon_sym_COLON] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1442),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_DASH_GT] = ACTIONS(1442),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1442),
    [anon_sym_override] = ACTIONS(1442),
    [sym_noexcept] = ACTIONS(1442),
  },
  [2646] = {
    [sym__abstract_declarator] = STATE(3065),
    [sym_abstract_pointer_declarator] = STATE(3065),
    [sym_abstract_function_declarator] = STATE(3065),
    [sym_abstract_array_declarator] = STATE(3065),
    [sym_type_qualifier] = STATE(3066),
    [sym_parameter_list] = STATE(2649),
    [sym_abstract_reference_declarator] = STATE(3065),
    [aux_sym_type_definition_repeat1] = STATE(3066),
    [anon_sym_RPAREN] = ACTIONS(2461),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(5869),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(5871),
    [anon_sym_AMP_AMP] = ACTIONS(5873),
    [anon_sym_DASH_GT] = ACTIONS(2461),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2461),
    [anon_sym_override] = ACTIONS(2461),
    [sym_noexcept] = ACTIONS(2461),
  },
  [2647] = {
    [sym__abstract_declarator] = STATE(3067),
    [sym_abstract_pointer_declarator] = STATE(3067),
    [sym_abstract_function_declarator] = STATE(3067),
    [sym_abstract_array_declarator] = STATE(3067),
    [sym_parameter_list] = STATE(2649),
    [sym_abstract_reference_declarator] = STATE(3067),
    [anon_sym_RPAREN] = ACTIONS(2463),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(5869),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_const] = ACTIONS(6555),
    [anon_sym_restrict] = ACTIONS(2463),
    [anon_sym_volatile] = ACTIONS(2463),
    [anon_sym__Atomic] = ACTIONS(2463),
    [anon_sym_mutable] = ACTIONS(2463),
    [anon_sym_explicit] = ACTIONS(2463),
    [anon_sym_constexpr] = ACTIONS(2463),
    [anon_sym_AMP] = ACTIONS(5871),
    [anon_sym_AMP_AMP] = ACTIONS(5873),
    [anon_sym_DASH_GT] = ACTIONS(2463),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2463),
    [anon_sym_override] = ACTIONS(2463),
    [sym_noexcept] = ACTIONS(2463),
  },
  [2648] = {
    [sym_parameter_list] = STATE(3068),
    [anon_sym_RPAREN] = ACTIONS(6557),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_const] = ACTIONS(6559),
    [anon_sym_restrict] = ACTIONS(6557),
    [anon_sym_volatile] = ACTIONS(6557),
    [anon_sym__Atomic] = ACTIONS(6557),
    [anon_sym_mutable] = ACTIONS(6557),
    [anon_sym_explicit] = ACTIONS(6557),
    [anon_sym_constexpr] = ACTIONS(6557),
    [anon_sym_DASH_GT] = ACTIONS(6557),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(6557),
    [anon_sym_override] = ACTIONS(6557),
    [sym_noexcept] = ACTIONS(6557),
  },
  [2649] = {
    [sym_type_qualifier] = STATE(3069),
    [sym_trailing_return_type] = STATE(971),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3069),
    [anon_sym_RPAREN] = ACTIONS(1787),
    [anon_sym_LPAREN2] = ACTIONS(1787),
    [anon_sym_LBRACK] = ACTIONS(1787),
    [anon_sym_const] = ACTIONS(6561),
    [anon_sym_restrict] = ACTIONS(1787),
    [anon_sym_volatile] = ACTIONS(1787),
    [anon_sym__Atomic] = ACTIONS(1787),
    [anon_sym_mutable] = ACTIONS(1787),
    [anon_sym_explicit] = ACTIONS(1787),
    [anon_sym_constexpr] = ACTIONS(1787),
    [anon_sym_DASH_GT] = ACTIONS(1787),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1787),
    [anon_sym_override] = ACTIONS(1787),
    [sym_noexcept] = ACTIONS(1787),
  },
  [2650] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2650),
    [anon_sym_RPAREN] = ACTIONS(1985),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1985),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1987),
    [anon_sym_restrict] = ACTIONS(1987),
    [anon_sym_volatile] = ACTIONS(1987),
    [anon_sym__Atomic] = ACTIONS(1987),
    [anon_sym_mutable] = ACTIONS(1987),
    [anon_sym_explicit] = ACTIONS(1987),
    [anon_sym_constexpr] = ACTIONS(1987),
    [anon_sym_unsigned] = ACTIONS(6934),
    [anon_sym_long] = ACTIONS(6934),
    [anon_sym_short] = ACTIONS(6934),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_DASH_GT] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1987),
    [anon_sym_override] = ACTIONS(1987),
    [sym_noexcept] = ACTIONS(1987),
  },
  [2651] = {
    [sym_parameter_list] = STATE(1185),
    [anon_sym_RPAREN] = ACTIONS(6557),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [sym_comment] = ACTIONS(91),
  },
  [2652] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(6579),
    [anon_sym_RPAREN] = ACTIONS(6579),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2653] = {
    [sym__abstract_declarator] = STATE(3070),
    [sym_abstract_pointer_declarator] = STATE(3070),
    [sym_abstract_function_declarator] = STATE(3070),
    [sym_abstract_array_declarator] = STATE(3070),
    [sym_type_qualifier] = STATE(3071),
    [sym_parameter_list] = STATE(2656),
    [sym_abstract_reference_declarator] = STATE(3070),
    [aux_sym_type_definition_repeat1] = STATE(3071),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(5898),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(5900),
    [anon_sym_AMP_AMP] = ACTIONS(5902),
    [anon_sym_DASH_GT] = ACTIONS(2461),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2461),
    [anon_sym_override] = ACTIONS(2461),
    [sym_noexcept] = ACTIONS(2461),
  },
  [2654] = {
    [sym__abstract_declarator] = STATE(3072),
    [sym_abstract_pointer_declarator] = STATE(3072),
    [sym_abstract_function_declarator] = STATE(3072),
    [sym_abstract_array_declarator] = STATE(3072),
    [sym_parameter_list] = STATE(2656),
    [sym_abstract_reference_declarator] = STATE(3072),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(5898),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_const] = ACTIONS(6555),
    [anon_sym_restrict] = ACTIONS(2463),
    [anon_sym_volatile] = ACTIONS(2463),
    [anon_sym__Atomic] = ACTIONS(2463),
    [anon_sym_mutable] = ACTIONS(2463),
    [anon_sym_explicit] = ACTIONS(2463),
    [anon_sym_constexpr] = ACTIONS(2463),
    [anon_sym_AMP] = ACTIONS(5900),
    [anon_sym_AMP_AMP] = ACTIONS(5902),
    [anon_sym_DASH_GT] = ACTIONS(2463),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2463),
    [anon_sym_override] = ACTIONS(2463),
    [sym_noexcept] = ACTIONS(2463),
  },
  [2655] = {
    [sym_parameter_list] = STATE(3073),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_const] = ACTIONS(6559),
    [anon_sym_restrict] = ACTIONS(6557),
    [anon_sym_volatile] = ACTIONS(6557),
    [anon_sym__Atomic] = ACTIONS(6557),
    [anon_sym_mutable] = ACTIONS(6557),
    [anon_sym_explicit] = ACTIONS(6557),
    [anon_sym_constexpr] = ACTIONS(6557),
    [anon_sym_DASH_GT] = ACTIONS(6557),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(6557),
    [anon_sym_override] = ACTIONS(6557),
    [sym_noexcept] = ACTIONS(6557),
  },
  [2656] = {
    [sym_type_qualifier] = STATE(3074),
    [sym_trailing_return_type] = STATE(971),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3074),
    [anon_sym_LPAREN2] = ACTIONS(1787),
    [anon_sym_LBRACK] = ACTIONS(1787),
    [anon_sym_const] = ACTIONS(6561),
    [anon_sym_restrict] = ACTIONS(1787),
    [anon_sym_volatile] = ACTIONS(1787),
    [anon_sym__Atomic] = ACTIONS(1787),
    [anon_sym_mutable] = ACTIONS(1787),
    [anon_sym_explicit] = ACTIONS(1787),
    [anon_sym_constexpr] = ACTIONS(1787),
    [anon_sym_DASH_GT] = ACTIONS(1787),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1787),
    [anon_sym_override] = ACTIONS(1787),
    [sym_noexcept] = ACTIONS(1787),
  },
  [2657] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2657),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1985),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1987),
    [anon_sym_restrict] = ACTIONS(1987),
    [anon_sym_volatile] = ACTIONS(1987),
    [anon_sym__Atomic] = ACTIONS(1987),
    [anon_sym_mutable] = ACTIONS(1987),
    [anon_sym_explicit] = ACTIONS(1987),
    [anon_sym_constexpr] = ACTIONS(1987),
    [anon_sym_unsigned] = ACTIONS(6937),
    [anon_sym_long] = ACTIONS(6937),
    [anon_sym_short] = ACTIONS(6937),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_DASH_GT] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1987),
    [anon_sym_override] = ACTIONS(1987),
    [sym_noexcept] = ACTIONS(1987),
  },
  [2658] = {
    [sym_new_declarator] = STATE(2861),
    [anon_sym_COMMA] = ACTIONS(6396),
    [anon_sym_LBRACE] = ACTIONS(6396),
    [anon_sym_LPAREN2] = ACTIONS(6396),
    [anon_sym_STAR] = ACTIONS(6398),
    [anon_sym_LBRACK] = ACTIONS(2545),
    [anon_sym_RBRACK] = ACTIONS(6396),
    [anon_sym_EQ] = ACTIONS(6398),
    [anon_sym_QMARK] = ACTIONS(6396),
    [anon_sym_STAR_EQ] = ACTIONS(6396),
    [anon_sym_SLASH_EQ] = ACTIONS(6396),
    [anon_sym_PERCENT_EQ] = ACTIONS(6396),
    [anon_sym_PLUS_EQ] = ACTIONS(6396),
    [anon_sym_DASH_EQ] = ACTIONS(6396),
    [anon_sym_LT_LT_EQ] = ACTIONS(6396),
    [anon_sym_GT_GT_EQ] = ACTIONS(6396),
    [anon_sym_AMP_EQ] = ACTIONS(6396),
    [anon_sym_CARET_EQ] = ACTIONS(6396),
    [anon_sym_PIPE_EQ] = ACTIONS(6396),
    [anon_sym_AMP] = ACTIONS(6398),
    [anon_sym_PIPE_PIPE] = ACTIONS(6396),
    [anon_sym_AMP_AMP] = ACTIONS(6396),
    [anon_sym_PIPE] = ACTIONS(6398),
    [anon_sym_CARET] = ACTIONS(6398),
    [anon_sym_EQ_EQ] = ACTIONS(6396),
    [anon_sym_BANG_EQ] = ACTIONS(6396),
    [anon_sym_LT] = ACTIONS(6398),
    [anon_sym_GT] = ACTIONS(6398),
    [anon_sym_LT_EQ] = ACTIONS(6396),
    [anon_sym_GT_EQ] = ACTIONS(6396),
    [anon_sym_LT_LT] = ACTIONS(6398),
    [anon_sym_GT_GT] = ACTIONS(6398),
    [anon_sym_PLUS] = ACTIONS(6398),
    [anon_sym_DASH] = ACTIONS(6398),
    [anon_sym_SLASH] = ACTIONS(6398),
    [anon_sym_PERCENT] = ACTIONS(6398),
    [anon_sym_DASH_DASH] = ACTIONS(6396),
    [anon_sym_PLUS_PLUS] = ACTIONS(6396),
    [anon_sym_DOT] = ACTIONS(6396),
    [anon_sym_DASH_GT] = ACTIONS(6396),
    [sym_comment] = ACTIONS(91),
  },
  [2659] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(6404),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(6404),
    [anon_sym_EQ] = ACTIONS(6406),
    [anon_sym_QMARK] = ACTIONS(6404),
    [anon_sym_STAR_EQ] = ACTIONS(6404),
    [anon_sym_SLASH_EQ] = ACTIONS(6404),
    [anon_sym_PERCENT_EQ] = ACTIONS(6404),
    [anon_sym_PLUS_EQ] = ACTIONS(6404),
    [anon_sym_DASH_EQ] = ACTIONS(6404),
    [anon_sym_LT_LT_EQ] = ACTIONS(6404),
    [anon_sym_GT_GT_EQ] = ACTIONS(6404),
    [anon_sym_AMP_EQ] = ACTIONS(6404),
    [anon_sym_CARET_EQ] = ACTIONS(6404),
    [anon_sym_PIPE_EQ] = ACTIONS(6404),
    [anon_sym_AMP] = ACTIONS(985),
    [anon_sym_PIPE_PIPE] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(989),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_CARET] = ACTIONS(993),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(999),
    [anon_sym_LT_LT] = ACTIONS(1001),
    [anon_sym_GT_GT] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(975),
    [anon_sym_PERCENT] = ACTIONS(975),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2660] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(6579),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(6579),
    [anon_sym_EQ] = ACTIONS(979),
    [anon_sym_QMARK] = ACTIONS(981),
    [anon_sym_STAR_EQ] = ACTIONS(983),
    [anon_sym_SLASH_EQ] = ACTIONS(983),
    [anon_sym_PERCENT_EQ] = ACTIONS(983),
    [anon_sym_PLUS_EQ] = ACTIONS(983),
    [anon_sym_DASH_EQ] = ACTIONS(983),
    [anon_sym_LT_LT_EQ] = ACTIONS(983),
    [anon_sym_GT_GT_EQ] = ACTIONS(983),
    [anon_sym_AMP_EQ] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(983),
    [anon_sym_PIPE_EQ] = ACTIONS(983),
    [anon_sym_AMP] = ACTIONS(985),
    [anon_sym_PIPE_PIPE] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(989),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_CARET] = ACTIONS(993),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(999),
    [anon_sym_LT_LT] = ACTIONS(1001),
    [anon_sym_GT_GT] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(975),
    [anon_sym_PERCENT] = ACTIONS(975),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2661] = {
    [anon_sym_COMMA] = ACTIONS(6940),
    [anon_sym_RPAREN] = ACTIONS(6940),
    [anon_sym_SEMI] = ACTIONS(6940),
    [anon_sym_extern] = ACTIONS(6942),
    [anon_sym_LBRACE] = ACTIONS(6940),
    [anon_sym_LPAREN2] = ACTIONS(6940),
    [anon_sym_STAR] = ACTIONS(6940),
    [anon_sym_LBRACK] = ACTIONS(6940),
    [anon_sym_EQ] = ACTIONS(6940),
    [anon_sym_static] = ACTIONS(6942),
    [anon_sym_register] = ACTIONS(6942),
    [anon_sym_inline] = ACTIONS(6942),
    [anon_sym_const] = ACTIONS(6942),
    [anon_sym_restrict] = ACTIONS(6942),
    [anon_sym_volatile] = ACTIONS(6942),
    [anon_sym__Atomic] = ACTIONS(6942),
    [anon_sym_mutable] = ACTIONS(6942),
    [anon_sym_explicit] = ACTIONS(6942),
    [anon_sym_constexpr] = ACTIONS(6942),
    [anon_sym_COLON] = ACTIONS(6942),
    [anon_sym_AMP] = ACTIONS(6942),
    [anon_sym_AMP_AMP] = ACTIONS(6940),
    [anon_sym_TILDE] = ACTIONS(6940),
    [anon_sym_DASH_GT] = ACTIONS(6940),
    [sym_identifier] = ACTIONS(6942),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(6942),
    [anon_sym_override] = ACTIONS(6942),
    [anon_sym_GT2] = ACTIONS(6940),
    [sym_noexcept] = ACTIONS(6942),
    [anon_sym_COLON_COLON] = ACTIONS(6940),
    [sym_operator_name] = ACTIONS(6940),
  },
  [2662] = {
    [sym_enumerator] = STATE(1988),
    [sym_identifier] = ACTIONS(1009),
    [sym_comment] = ACTIONS(91),
  },
  [2663] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(3075),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(3075),
    [sym_type_definition] = STATE(3075),
    [sym__declaration_specifiers] = STATE(598),
    [sym__declarator] = STATE(599),
    [sym_pointer_declarator] = STATE(599),
    [sym_function_declarator] = STATE(600),
    [sym_array_declarator] = STATE(599),
    [sym_storage_class_specifier] = STATE(605),
    [sym_type_qualifier] = STATE(605),
    [sym__type_specifier] = STATE(601),
    [sym_sized_type_specifier] = STATE(601),
    [sym_enum_specifier] = STATE(601),
    [sym_struct_specifier] = STATE(601),
    [sym_union_specifier] = STATE(601),
    [sym__field_declaration_list_item] = STATE(3075),
    [sym_field_declaration] = STATE(3075),
    [sym_macro_type_specifier] = STATE(601),
    [sym_class_specifier] = STATE(601),
    [sym_dependent_type] = STATE(601),
    [sym_template_declaration] = STATE(3075),
    [sym_inline_method_definition] = STATE(3075),
    [sym_constructor_or_destructor_definition] = STATE(3075),
    [sym_constructor_or_destructor_declaration] = STATE(3075),
    [sym_friend_declaration] = STATE(3075),
    [sym_access_specifier] = STATE(3075),
    [sym_reference_declarator] = STATE(599),
    [sym_template_type] = STATE(602),
    [sym_template_function] = STATE(599),
    [sym_using_declaration] = STATE(3075),
    [sym_alias_declaration] = STATE(3075),
    [sym_destructor_name] = STATE(599),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(603),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(3075),
    [aux_sym__declaration_specifiers_repeat1] = STATE(605),
    [aux_sym_sized_type_specifier_repeat1] = STATE(606),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1019),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6944),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1021),
    [anon_sym_typedef] = ACTIONS(1023),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(425),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(1027),
    [anon_sym_long] = ACTIONS(1027),
    [anon_sym_short] = ACTIONS(1027),
    [sym_primitive_type] = ACTIONS(1029),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(1031),
    [anon_sym_union] = ACTIONS(1033),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(1035),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1039),
    [sym_auto] = ACTIONS(1029),
    [anon_sym_typename] = ACTIONS(1041),
    [anon_sym_template] = ACTIONS(1043),
    [anon_sym_friend] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1039),
    [anon_sym_protected] = ACTIONS(1039),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_COLON_COLON] = ACTIONS(1049),
    [sym_operator_name] = ACTIONS(1051),
  },
  [2664] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(3077),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(3077),
    [sym_preproc_else_in_field_declaration_list] = STATE(3076),
    [sym_preproc_elif_in_field_declaration_list] = STATE(3076),
    [sym_type_definition] = STATE(3077),
    [sym__declaration_specifiers] = STATE(598),
    [sym__declarator] = STATE(599),
    [sym_pointer_declarator] = STATE(599),
    [sym_function_declarator] = STATE(600),
    [sym_array_declarator] = STATE(599),
    [sym_storage_class_specifier] = STATE(605),
    [sym_type_qualifier] = STATE(605),
    [sym__type_specifier] = STATE(601),
    [sym_sized_type_specifier] = STATE(601),
    [sym_enum_specifier] = STATE(601),
    [sym_struct_specifier] = STATE(601),
    [sym_union_specifier] = STATE(601),
    [sym__field_declaration_list_item] = STATE(3077),
    [sym_field_declaration] = STATE(3077),
    [sym_macro_type_specifier] = STATE(601),
    [sym_class_specifier] = STATE(601),
    [sym_dependent_type] = STATE(601),
    [sym_template_declaration] = STATE(3077),
    [sym_inline_method_definition] = STATE(3077),
    [sym_constructor_or_destructor_definition] = STATE(3077),
    [sym_constructor_or_destructor_declaration] = STATE(3077),
    [sym_friend_declaration] = STATE(3077),
    [sym_access_specifier] = STATE(3077),
    [sym_reference_declarator] = STATE(599),
    [sym_template_type] = STATE(602),
    [sym_template_function] = STATE(599),
    [sym_using_declaration] = STATE(3077),
    [sym_alias_declaration] = STATE(3077),
    [sym_destructor_name] = STATE(599),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(603),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(3077),
    [aux_sym__declaration_specifiers_repeat1] = STATE(605),
    [aux_sym_sized_type_specifier_repeat1] = STATE(606),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1019),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6946),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4227),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4229),
    [anon_sym_typedef] = ACTIONS(1023),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(425),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(1027),
    [anon_sym_long] = ACTIONS(1027),
    [anon_sym_short] = ACTIONS(1027),
    [sym_primitive_type] = ACTIONS(1029),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(1031),
    [anon_sym_union] = ACTIONS(1033),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(1035),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1039),
    [sym_auto] = ACTIONS(1029),
    [anon_sym_typename] = ACTIONS(1041),
    [anon_sym_template] = ACTIONS(1043),
    [anon_sym_friend] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1039),
    [anon_sym_protected] = ACTIONS(1039),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_COLON_COLON] = ACTIONS(1049),
    [sym_operator_name] = ACTIONS(1051),
  },
  [2665] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6948),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6950),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6950),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6950),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6950),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6950),
    [anon_sym_typedef] = ACTIONS(6948),
    [anon_sym_extern] = ACTIONS(6948),
    [anon_sym_RBRACE] = ACTIONS(6950),
    [anon_sym_LPAREN2] = ACTIONS(6950),
    [anon_sym_STAR] = ACTIONS(6950),
    [anon_sym_static] = ACTIONS(6948),
    [anon_sym_register] = ACTIONS(6948),
    [anon_sym_inline] = ACTIONS(6948),
    [anon_sym_const] = ACTIONS(6948),
    [anon_sym_restrict] = ACTIONS(6948),
    [anon_sym_volatile] = ACTIONS(6948),
    [anon_sym__Atomic] = ACTIONS(6948),
    [anon_sym_mutable] = ACTIONS(6948),
    [anon_sym_explicit] = ACTIONS(6948),
    [anon_sym_constexpr] = ACTIONS(6948),
    [anon_sym_unsigned] = ACTIONS(6948),
    [anon_sym_long] = ACTIONS(6948),
    [anon_sym_short] = ACTIONS(6948),
    [sym_primitive_type] = ACTIONS(6948),
    [anon_sym_enum] = ACTIONS(6948),
    [anon_sym_struct] = ACTIONS(6948),
    [anon_sym_union] = ACTIONS(6948),
    [anon_sym_AMP] = ACTIONS(6948),
    [anon_sym_AMP_AMP] = ACTIONS(6950),
    [anon_sym_TILDE] = ACTIONS(6950),
    [sym_identifier] = ACTIONS(6948),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6948),
    [anon_sym_public] = ACTIONS(6948),
    [sym_auto] = ACTIONS(6948),
    [anon_sym_typename] = ACTIONS(6948),
    [anon_sym_template] = ACTIONS(6948),
    [anon_sym_friend] = ACTIONS(6948),
    [anon_sym_private] = ACTIONS(6948),
    [anon_sym_protected] = ACTIONS(6948),
    [anon_sym_using] = ACTIONS(6948),
    [anon_sym_COLON_COLON] = ACTIONS(6950),
    [sym_operator_name] = ACTIONS(6950),
  },
  [2666] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6952),
    [sym_comment] = ACTIONS(91),
  },
  [2667] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(2667),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(2667),
    [sym_type_definition] = STATE(2667),
    [sym__declaration_specifiers] = STATE(598),
    [sym__declarator] = STATE(599),
    [sym_pointer_declarator] = STATE(599),
    [sym_function_declarator] = STATE(600),
    [sym_array_declarator] = STATE(599),
    [sym_storage_class_specifier] = STATE(605),
    [sym_type_qualifier] = STATE(605),
    [sym__type_specifier] = STATE(601),
    [sym_sized_type_specifier] = STATE(601),
    [sym_enum_specifier] = STATE(601),
    [sym_struct_specifier] = STATE(601),
    [sym_union_specifier] = STATE(601),
    [sym__field_declaration_list_item] = STATE(2667),
    [sym_field_declaration] = STATE(2667),
    [sym_macro_type_specifier] = STATE(601),
    [sym_class_specifier] = STATE(601),
    [sym_dependent_type] = STATE(601),
    [sym_template_declaration] = STATE(2667),
    [sym_inline_method_definition] = STATE(2667),
    [sym_constructor_or_destructor_definition] = STATE(2667),
    [sym_constructor_or_destructor_declaration] = STATE(2667),
    [sym_friend_declaration] = STATE(2667),
    [sym_access_specifier] = STATE(2667),
    [sym_reference_declarator] = STATE(599),
    [sym_template_type] = STATE(602),
    [sym_template_function] = STATE(599),
    [sym_using_declaration] = STATE(2667),
    [sym_alias_declaration] = STATE(2667),
    [sym_destructor_name] = STATE(599),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(603),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(2667),
    [aux_sym__declaration_specifiers_repeat1] = STATE(605),
    [aux_sym_sized_type_specifier_repeat1] = STATE(606),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4311),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4323),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4314),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4314),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4323),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4323),
    [anon_sym_typedef] = ACTIONS(4317),
    [anon_sym_extern] = ACTIONS(4320),
    [anon_sym_LPAREN2] = ACTIONS(4325),
    [anon_sym_STAR] = ACTIONS(4328),
    [anon_sym_static] = ACTIONS(4320),
    [anon_sym_register] = ACTIONS(4320),
    [anon_sym_inline] = ACTIONS(4320),
    [anon_sym_const] = ACTIONS(4331),
    [anon_sym_restrict] = ACTIONS(4331),
    [anon_sym_volatile] = ACTIONS(4331),
    [anon_sym__Atomic] = ACTIONS(4331),
    [anon_sym_mutable] = ACTIONS(4331),
    [anon_sym_explicit] = ACTIONS(4331),
    [anon_sym_constexpr] = ACTIONS(4331),
    [anon_sym_unsigned] = ACTIONS(4334),
    [anon_sym_long] = ACTIONS(4334),
    [anon_sym_short] = ACTIONS(4334),
    [sym_primitive_type] = ACTIONS(4337),
    [anon_sym_enum] = ACTIONS(4340),
    [anon_sym_struct] = ACTIONS(4343),
    [anon_sym_union] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4349),
    [anon_sym_AMP_AMP] = ACTIONS(4352),
    [anon_sym_TILDE] = ACTIONS(4355),
    [sym_identifier] = ACTIONS(4358),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4361),
    [anon_sym_public] = ACTIONS(4364),
    [sym_auto] = ACTIONS(4337),
    [anon_sym_typename] = ACTIONS(4367),
    [anon_sym_template] = ACTIONS(4370),
    [anon_sym_friend] = ACTIONS(4373),
    [anon_sym_private] = ACTIONS(4364),
    [anon_sym_protected] = ACTIONS(4364),
    [anon_sym_using] = ACTIONS(4376),
    [anon_sym_COLON_COLON] = ACTIONS(4379),
    [sym_operator_name] = ACTIONS(4382),
  },
  [2668] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6954),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6956),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6956),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6956),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6956),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6956),
    [anon_sym_typedef] = ACTIONS(6954),
    [anon_sym_extern] = ACTIONS(6954),
    [anon_sym_RBRACE] = ACTIONS(6956),
    [anon_sym_LPAREN2] = ACTIONS(6956),
    [anon_sym_STAR] = ACTIONS(6956),
    [anon_sym_static] = ACTIONS(6954),
    [anon_sym_register] = ACTIONS(6954),
    [anon_sym_inline] = ACTIONS(6954),
    [anon_sym_const] = ACTIONS(6954),
    [anon_sym_restrict] = ACTIONS(6954),
    [anon_sym_volatile] = ACTIONS(6954),
    [anon_sym__Atomic] = ACTIONS(6954),
    [anon_sym_mutable] = ACTIONS(6954),
    [anon_sym_explicit] = ACTIONS(6954),
    [anon_sym_constexpr] = ACTIONS(6954),
    [anon_sym_unsigned] = ACTIONS(6954),
    [anon_sym_long] = ACTIONS(6954),
    [anon_sym_short] = ACTIONS(6954),
    [sym_primitive_type] = ACTIONS(6954),
    [anon_sym_enum] = ACTIONS(6954),
    [anon_sym_struct] = ACTIONS(6954),
    [anon_sym_union] = ACTIONS(6954),
    [anon_sym_AMP] = ACTIONS(6954),
    [anon_sym_AMP_AMP] = ACTIONS(6956),
    [anon_sym_TILDE] = ACTIONS(6956),
    [sym_identifier] = ACTIONS(6954),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6954),
    [anon_sym_public] = ACTIONS(6954),
    [sym_auto] = ACTIONS(6954),
    [anon_sym_typename] = ACTIONS(6954),
    [anon_sym_template] = ACTIONS(6954),
    [anon_sym_friend] = ACTIONS(6954),
    [anon_sym_private] = ACTIONS(6954),
    [anon_sym_protected] = ACTIONS(6954),
    [anon_sym_using] = ACTIONS(6954),
    [anon_sym_COLON_COLON] = ACTIONS(6956),
    [sym_operator_name] = ACTIONS(6956),
  },
  [2669] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6958),
    [sym_comment] = ACTIONS(91),
  },
  [2670] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3960),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3958),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3958),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3958),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3958),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3958),
    [anon_sym_typedef] = ACTIONS(3960),
    [anon_sym_extern] = ACTIONS(3960),
    [anon_sym_RBRACE] = ACTIONS(3958),
    [anon_sym_LPAREN2] = ACTIONS(3958),
    [anon_sym_STAR] = ACTIONS(3958),
    [anon_sym_static] = ACTIONS(3960),
    [anon_sym_register] = ACTIONS(3960),
    [anon_sym_inline] = ACTIONS(3960),
    [anon_sym_const] = ACTIONS(3960),
    [anon_sym_restrict] = ACTIONS(3960),
    [anon_sym_volatile] = ACTIONS(3960),
    [anon_sym__Atomic] = ACTIONS(3960),
    [anon_sym_mutable] = ACTIONS(3960),
    [anon_sym_explicit] = ACTIONS(3960),
    [anon_sym_constexpr] = ACTIONS(3960),
    [anon_sym_unsigned] = ACTIONS(3960),
    [anon_sym_long] = ACTIONS(3960),
    [anon_sym_short] = ACTIONS(3960),
    [sym_primitive_type] = ACTIONS(3960),
    [anon_sym_enum] = ACTIONS(3960),
    [anon_sym_struct] = ACTIONS(3960),
    [anon_sym_union] = ACTIONS(3960),
    [anon_sym_else] = ACTIONS(3960),
    [anon_sym_while] = ACTIONS(3960),
    [anon_sym_AMP] = ACTIONS(3960),
    [anon_sym_AMP_AMP] = ACTIONS(3958),
    [anon_sym_TILDE] = ACTIONS(3958),
    [sym_identifier] = ACTIONS(3960),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3960),
    [anon_sym_public] = ACTIONS(3960),
    [sym_auto] = ACTIONS(3960),
    [anon_sym_typename] = ACTIONS(3960),
    [anon_sym_template] = ACTIONS(3960),
    [anon_sym_friend] = ACTIONS(3960),
    [anon_sym_private] = ACTIONS(3960),
    [anon_sym_protected] = ACTIONS(3960),
    [anon_sym_using] = ACTIONS(3960),
    [anon_sym_COLON_COLON] = ACTIONS(3958),
    [sym_operator_name] = ACTIONS(3958),
  },
  [2671] = {
    [sym_parameter_list] = STATE(1105),
    [anon_sym_SEMI] = ACTIONS(6960),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [sym_comment] = ACTIONS(91),
  },
  [2672] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1599),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1597),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1597),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1597),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1597),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1597),
    [anon_sym_typedef] = ACTIONS(1599),
    [anon_sym_extern] = ACTIONS(1599),
    [anon_sym_RBRACE] = ACTIONS(1597),
    [anon_sym_LPAREN2] = ACTIONS(1597),
    [anon_sym_STAR] = ACTIONS(1597),
    [anon_sym_static] = ACTIONS(1599),
    [anon_sym_register] = ACTIONS(1599),
    [anon_sym_inline] = ACTIONS(1599),
    [anon_sym_const] = ACTIONS(1599),
    [anon_sym_restrict] = ACTIONS(1599),
    [anon_sym_volatile] = ACTIONS(1599),
    [anon_sym__Atomic] = ACTIONS(1599),
    [anon_sym_mutable] = ACTIONS(1599),
    [anon_sym_explicit] = ACTIONS(1599),
    [anon_sym_constexpr] = ACTIONS(1599),
    [anon_sym_unsigned] = ACTIONS(1599),
    [anon_sym_long] = ACTIONS(1599),
    [anon_sym_short] = ACTIONS(1599),
    [sym_primitive_type] = ACTIONS(1599),
    [anon_sym_enum] = ACTIONS(1599),
    [anon_sym_struct] = ACTIONS(1599),
    [anon_sym_union] = ACTIONS(1599),
    [anon_sym_AMP] = ACTIONS(1599),
    [anon_sym_AMP_AMP] = ACTIONS(1597),
    [anon_sym_TILDE] = ACTIONS(1597),
    [sym_identifier] = ACTIONS(1599),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1599),
    [anon_sym_public] = ACTIONS(1599),
    [sym_auto] = ACTIONS(1599),
    [anon_sym_typename] = ACTIONS(1599),
    [anon_sym_template] = ACTIONS(1599),
    [anon_sym_friend] = ACTIONS(1599),
    [anon_sym_private] = ACTIONS(1599),
    [anon_sym_protected] = ACTIONS(1599),
    [anon_sym_using] = ACTIONS(1599),
    [anon_sym_COLON_COLON] = ACTIONS(1597),
    [sym_operator_name] = ACTIONS(1597),
  },
  [2673] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3397),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3397),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3397),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3397),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3397),
    [anon_sym_typedef] = ACTIONS(3399),
    [anon_sym_extern] = ACTIONS(3399),
    [anon_sym_RBRACE] = ACTIONS(3397),
    [anon_sym_LPAREN2] = ACTIONS(3397),
    [anon_sym_STAR] = ACTIONS(3397),
    [anon_sym_static] = ACTIONS(3399),
    [anon_sym_register] = ACTIONS(3399),
    [anon_sym_inline] = ACTIONS(3399),
    [anon_sym_const] = ACTIONS(3399),
    [anon_sym_restrict] = ACTIONS(3399),
    [anon_sym_volatile] = ACTIONS(3399),
    [anon_sym__Atomic] = ACTIONS(3399),
    [anon_sym_mutable] = ACTIONS(3399),
    [anon_sym_explicit] = ACTIONS(3399),
    [anon_sym_constexpr] = ACTIONS(3399),
    [anon_sym_unsigned] = ACTIONS(3399),
    [anon_sym_long] = ACTIONS(3399),
    [anon_sym_short] = ACTIONS(3399),
    [sym_primitive_type] = ACTIONS(3399),
    [anon_sym_enum] = ACTIONS(3399),
    [anon_sym_struct] = ACTIONS(3399),
    [anon_sym_union] = ACTIONS(3399),
    [anon_sym_else] = ACTIONS(3399),
    [anon_sym_while] = ACTIONS(3399),
    [anon_sym_AMP] = ACTIONS(3399),
    [anon_sym_AMP_AMP] = ACTIONS(3397),
    [anon_sym_TILDE] = ACTIONS(3397),
    [sym_identifier] = ACTIONS(3399),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3399),
    [anon_sym_public] = ACTIONS(3399),
    [sym_auto] = ACTIONS(3399),
    [anon_sym_typename] = ACTIONS(3399),
    [anon_sym_template] = ACTIONS(3399),
    [anon_sym_friend] = ACTIONS(3399),
    [anon_sym_private] = ACTIONS(3399),
    [anon_sym_protected] = ACTIONS(3399),
    [anon_sym_using] = ACTIONS(3399),
    [anon_sym_COLON_COLON] = ACTIONS(3397),
    [sym_operator_name] = ACTIONS(3397),
  },
  [2674] = {
    [sym_preproc_include] = STATE(2029),
    [sym_preproc_def] = STATE(2029),
    [sym_preproc_function_def] = STATE(2029),
    [sym_preproc_call] = STATE(2029),
    [sym_preproc_if_in_compound_statement] = STATE(2029),
    [sym_preproc_ifdef_in_compound_statement] = STATE(2029),
    [sym_declaration] = STATE(2029),
    [sym_type_definition] = STATE(2029),
    [sym__declaration_specifiers] = STATE(113),
    [sym_compound_statement] = STATE(2029),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(2029),
    [sym_expression_statement] = STATE(2029),
    [sym_if_statement] = STATE(2029),
    [sym_switch_statement] = STATE(2029),
    [sym_case_statement] = STATE(2029),
    [sym_while_statement] = STATE(2029),
    [sym_do_statement] = STATE(2029),
    [sym_for_statement] = STATE(2029),
    [sym_return_statement] = STATE(2029),
    [sym_break_statement] = STATE(2029),
    [sym_continue_statement] = STATE(2029),
    [sym_goto_statement] = STATE(2029),
    [sym__expression] = STATE(1631),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(1631),
    [sym_assignment_expression] = STATE(1631),
    [sym_pointer_expression] = STATE(1631),
    [sym_logical_expression] = STATE(1631),
    [sym_bitwise_expression] = STATE(1631),
    [sym_equality_expression] = STATE(1631),
    [sym_relational_expression] = STATE(1631),
    [sym_shift_expression] = STATE(1631),
    [sym_math_expression] = STATE(1631),
    [sym_cast_expression] = STATE(1631),
    [sym_sizeof_expression] = STATE(1631),
    [sym_subscript_expression] = STATE(1631),
    [sym_call_expression] = STATE(1631),
    [sym_field_expression] = STATE(1631),
    [sym_compound_literal_expression] = STATE(1631),
    [sym_parenthesized_expression] = STATE(1631),
    [sym_initializer_list] = STATE(726),
    [sym_initializer_pair] = STATE(726),
    [sym_subscript_designator] = STATE(728),
    [sym_field_designator] = STATE(728),
    [sym_char_literal] = STATE(1631),
    [sym_concatenated_string] = STATE(1631),
    [sym_string_literal] = STATE(1632),
    [sym__empty_declaration] = STATE(2029),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(2029),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(1631),
    [sym_for_range_loop] = STATE(2029),
    [sym_try_statement] = STATE(2029),
    [sym_new_expression] = STATE(1631),
    [sym_delete_expression] = STATE(1631),
    [sym_lambda_expression] = STATE(1631),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(2029),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [aux_sym_initializer_pair_repeat1] = STATE(728),
    [sym_raw_string_literal] = ACTIONS(3401),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(159),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(161),
    [anon_sym_COMMA] = ACTIONS(1252),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(163),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(165),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(165),
    [sym_preproc_directive] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_typedef] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(3403),
    [anon_sym_RBRACE] = ACTIONS(6962),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_LBRACK] = ACTIONS(1260),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(185),
    [anon_sym_case] = ACTIONS(187),
    [anon_sym_default] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3411),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_sizeof] = ACTIONS(3419),
    [anon_sym_DOT] = ACTIONS(1272),
    [sym_number_literal] = ACTIONS(3401),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(3421),
    [sym_false] = ACTIONS(3421),
    [sym_null] = ACTIONS(3421),
    [sym_identifier] = ACTIONS(209),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(3423),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_COLON_COLON] = ACTIONS(3427),
    [sym_nullptr] = ACTIONS(3421),
  },
  [2675] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3441),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3439),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3439),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3439),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3439),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3439),
    [anon_sym_typedef] = ACTIONS(3441),
    [anon_sym_extern] = ACTIONS(3441),
    [anon_sym_RBRACE] = ACTIONS(3439),
    [anon_sym_LPAREN2] = ACTIONS(3439),
    [anon_sym_STAR] = ACTIONS(3439),
    [anon_sym_static] = ACTIONS(3441),
    [anon_sym_register] = ACTIONS(3441),
    [anon_sym_inline] = ACTIONS(3441),
    [anon_sym_const] = ACTIONS(3441),
    [anon_sym_restrict] = ACTIONS(3441),
    [anon_sym_volatile] = ACTIONS(3441),
    [anon_sym__Atomic] = ACTIONS(3441),
    [anon_sym_mutable] = ACTIONS(3441),
    [anon_sym_explicit] = ACTIONS(3441),
    [anon_sym_constexpr] = ACTIONS(3441),
    [anon_sym_unsigned] = ACTIONS(3441),
    [anon_sym_long] = ACTIONS(3441),
    [anon_sym_short] = ACTIONS(3441),
    [sym_primitive_type] = ACTIONS(3441),
    [anon_sym_enum] = ACTIONS(3441),
    [anon_sym_struct] = ACTIONS(3441),
    [anon_sym_union] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3441),
    [anon_sym_AMP_AMP] = ACTIONS(3439),
    [anon_sym_TILDE] = ACTIONS(3439),
    [sym_identifier] = ACTIONS(3441),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3441),
    [anon_sym_public] = ACTIONS(3441),
    [sym_auto] = ACTIONS(3441),
    [anon_sym_typename] = ACTIONS(3441),
    [anon_sym_template] = ACTIONS(3441),
    [anon_sym_friend] = ACTIONS(3441),
    [anon_sym_private] = ACTIONS(3441),
    [anon_sym_protected] = ACTIONS(3441),
    [anon_sym_using] = ACTIONS(3441),
    [anon_sym_COLON_COLON] = ACTIONS(3439),
    [sym_operator_name] = ACTIONS(3439),
  },
  [2676] = {
    [aux_sym_declaration_repeat1] = STATE(1643),
    [anon_sym_COMMA] = ACTIONS(1613),
    [anon_sym_SEMI] = ACTIONS(6964),
    [sym_comment] = ACTIONS(91),
  },
  [2677] = {
    [anon_sym_SEMI] = ACTIONS(6966),
    [sym_comment] = ACTIONS(91),
  },
  [2678] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4991),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4989),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4989),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4989),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4989),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4989),
    [anon_sym_typedef] = ACTIONS(4991),
    [anon_sym_extern] = ACTIONS(4991),
    [anon_sym_RBRACE] = ACTIONS(4989),
    [anon_sym_LPAREN2] = ACTIONS(4989),
    [anon_sym_STAR] = ACTIONS(4989),
    [anon_sym_static] = ACTIONS(4991),
    [anon_sym_register] = ACTIONS(4991),
    [anon_sym_inline] = ACTIONS(4991),
    [anon_sym_const] = ACTIONS(4991),
    [anon_sym_restrict] = ACTIONS(4991),
    [anon_sym_volatile] = ACTIONS(4991),
    [anon_sym__Atomic] = ACTIONS(4991),
    [anon_sym_mutable] = ACTIONS(4991),
    [anon_sym_explicit] = ACTIONS(4991),
    [anon_sym_constexpr] = ACTIONS(4991),
    [anon_sym_unsigned] = ACTIONS(4991),
    [anon_sym_long] = ACTIONS(4991),
    [anon_sym_short] = ACTIONS(4991),
    [sym_primitive_type] = ACTIONS(4991),
    [anon_sym_enum] = ACTIONS(4991),
    [anon_sym_struct] = ACTIONS(4991),
    [anon_sym_union] = ACTIONS(4991),
    [anon_sym_AMP] = ACTIONS(4991),
    [anon_sym_AMP_AMP] = ACTIONS(4989),
    [anon_sym_TILDE] = ACTIONS(4989),
    [sym_identifier] = ACTIONS(4991),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4991),
    [anon_sym_public] = ACTIONS(4991),
    [sym_auto] = ACTIONS(4991),
    [anon_sym_typename] = ACTIONS(4991),
    [anon_sym_template] = ACTIONS(4991),
    [anon_sym_friend] = ACTIONS(4991),
    [anon_sym_private] = ACTIONS(4991),
    [anon_sym_protected] = ACTIONS(4991),
    [anon_sym_using] = ACTIONS(4991),
    [anon_sym_COLON_COLON] = ACTIONS(4989),
    [sym_operator_name] = ACTIONS(4989),
  },
  [2679] = {
    [sym_parameter_list] = STATE(2683),
    [anon_sym_RPAREN] = ACTIONS(5975),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [sym_comment] = ACTIONS(91),
  },
  [2680] = {
    [sym__field_declarator] = STATE(3084),
    [sym_pointer_field_declarator] = STATE(3084),
    [sym_function_field_declarator] = STATE(3084),
    [sym_array_field_declarator] = STATE(3084),
    [sym_type_qualifier] = STATE(2685),
    [sym_reference_field_declarator] = STATE(3084),
    [sym_template_type] = STATE(953),
    [sym_template_method] = STATE(3084),
    [sym_scoped_field_identifier] = STATE(955),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(953),
    [aux_sym_type_definition_repeat1] = STATE(2685),
    [anon_sym_LPAREN2] = ACTIONS(2655),
    [anon_sym_STAR] = ACTIONS(4259),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(4261),
    [anon_sym_AMP_AMP] = ACTIONS(4263),
    [sym_identifier] = ACTIONS(2665),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1755),
    [sym_operator_name] = ACTIONS(6968),
  },
  [2681] = {
    [sym_parameter_list] = STATE(2683),
    [anon_sym_RPAREN] = ACTIONS(5981),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [sym_comment] = ACTIONS(91),
  },
  [2682] = {
    [anon_sym_COMMA] = ACTIONS(6970),
    [anon_sym_RPAREN] = ACTIONS(6970),
    [anon_sym_SEMI] = ACTIONS(6970),
    [anon_sym_LBRACE] = ACTIONS(6970),
    [anon_sym_LPAREN2] = ACTIONS(6970),
    [anon_sym_LBRACK] = ACTIONS(6970),
    [anon_sym_EQ] = ACTIONS(6970),
    [anon_sym_COLON] = ACTIONS(6970),
    [sym_comment] = ACTIONS(91),
  },
  [2683] = {
    [sym_type_qualifier] = STATE(3085),
    [sym_virtual_specifier] = STATE(3085),
    [sym_trailing_return_type] = STATE(3085),
    [aux_sym_function_declarator_repeat1] = STATE(3085),
    [anon_sym_RPAREN] = ACTIONS(6011),
    [anon_sym_LPAREN2] = ACTIONS(6011),
    [anon_sym_LBRACK] = ACTIONS(6011),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(2457),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [sym_noexcept] = ACTIONS(6972),
  },
  [2684] = {
    [sym_parameter_list] = STATE(2024),
    [anon_sym_COMMA] = ACTIONS(6974),
    [anon_sym_SEMI] = ACTIONS(6974),
    [anon_sym_LBRACE] = ACTIONS(6974),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_EQ] = ACTIONS(6974),
    [anon_sym_COLON] = ACTIONS(6974),
    [sym_comment] = ACTIONS(91),
  },
  [2685] = {
    [sym_type_qualifier] = STATE(2685),
    [aux_sym_type_definition_repeat1] = STATE(2685),
    [anon_sym_LPAREN2] = ACTIONS(2179),
    [anon_sym_STAR] = ACTIONS(2179),
    [anon_sym_const] = ACTIONS(2538),
    [anon_sym_restrict] = ACTIONS(2538),
    [anon_sym_volatile] = ACTIONS(2538),
    [anon_sym__Atomic] = ACTIONS(2538),
    [anon_sym_mutable] = ACTIONS(2538),
    [anon_sym_explicit] = ACTIONS(2538),
    [anon_sym_constexpr] = ACTIONS(2538),
    [anon_sym_AMP] = ACTIONS(2177),
    [anon_sym_AMP_AMP] = ACTIONS(2179),
    [sym_identifier] = ACTIONS(2177),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(2179),
    [sym_operator_name] = ACTIONS(2179),
  },
  [2686] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6976),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6978),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6978),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6978),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6978),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6978),
    [anon_sym_typedef] = ACTIONS(6976),
    [anon_sym_extern] = ACTIONS(6976),
    [anon_sym_RBRACE] = ACTIONS(6978),
    [anon_sym_LPAREN2] = ACTIONS(6978),
    [anon_sym_STAR] = ACTIONS(6978),
    [anon_sym_static] = ACTIONS(6976),
    [anon_sym_register] = ACTIONS(6976),
    [anon_sym_inline] = ACTIONS(6976),
    [anon_sym_const] = ACTIONS(6976),
    [anon_sym_restrict] = ACTIONS(6976),
    [anon_sym_volatile] = ACTIONS(6976),
    [anon_sym__Atomic] = ACTIONS(6976),
    [anon_sym_mutable] = ACTIONS(6976),
    [anon_sym_explicit] = ACTIONS(6976),
    [anon_sym_constexpr] = ACTIONS(6976),
    [anon_sym_unsigned] = ACTIONS(6976),
    [anon_sym_long] = ACTIONS(6976),
    [anon_sym_short] = ACTIONS(6976),
    [sym_primitive_type] = ACTIONS(6976),
    [anon_sym_enum] = ACTIONS(6976),
    [anon_sym_struct] = ACTIONS(6976),
    [anon_sym_union] = ACTIONS(6976),
    [anon_sym_AMP] = ACTIONS(6976),
    [anon_sym_AMP_AMP] = ACTIONS(6978),
    [anon_sym_TILDE] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6976),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6976),
    [anon_sym_public] = ACTIONS(6976),
    [sym_auto] = ACTIONS(6976),
    [anon_sym_typename] = ACTIONS(6976),
    [anon_sym_template] = ACTIONS(6976),
    [anon_sym_friend] = ACTIONS(6976),
    [anon_sym_private] = ACTIONS(6976),
    [anon_sym_protected] = ACTIONS(6976),
    [anon_sym_using] = ACTIONS(6976),
    [anon_sym_COLON_COLON] = ACTIONS(6978),
    [sym_operator_name] = ACTIONS(6978),
  },
  [2687] = {
    [sym__field_declarator] = STATE(3086),
    [sym_pointer_field_declarator] = STATE(3086),
    [sym_function_field_declarator] = STATE(3086),
    [sym_array_field_declarator] = STATE(3086),
    [sym_type_qualifier] = STATE(3087),
    [sym_reference_field_declarator] = STATE(3086),
    [sym_template_type] = STATE(953),
    [sym_template_method] = STATE(3086),
    [sym_scoped_field_identifier] = STATE(1266),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(953),
    [aux_sym_type_definition_repeat1] = STATE(3087),
    [anon_sym_LPAREN2] = ACTIONS(2655),
    [anon_sym_STAR] = ACTIONS(5983),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(5985),
    [anon_sym_AMP_AMP] = ACTIONS(5987),
    [sym_identifier] = ACTIONS(2665),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1755),
    [sym_operator_name] = ACTIONS(6980),
  },
  [2688] = {
    [sym__field_declarator] = STATE(3088),
    [sym_pointer_field_declarator] = STATE(3088),
    [sym_function_field_declarator] = STATE(3088),
    [sym_array_field_declarator] = STATE(3088),
    [sym_reference_field_declarator] = STATE(3088),
    [sym_template_type] = STATE(953),
    [sym_template_method] = STATE(3088),
    [sym_scoped_field_identifier] = STATE(1266),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(953),
    [anon_sym_LPAREN2] = ACTIONS(2655),
    [anon_sym_STAR] = ACTIONS(5983),
    [anon_sym_AMP] = ACTIONS(5985),
    [anon_sym_AMP_AMP] = ACTIONS(5987),
    [sym_identifier] = ACTIONS(2665),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1755),
    [sym_operator_name] = ACTIONS(6982),
  },
  [2689] = {
    [sym_parameter_list] = STATE(3089),
    [anon_sym_COMMA] = ACTIONS(6984),
    [anon_sym_SEMI] = ACTIONS(6984),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_COLON] = ACTIONS(6984),
    [sym_comment] = ACTIONS(91),
  },
  [2690] = {
    [sym__expression] = STATE(146),
    [sym_conditional_expression] = STATE(146),
    [sym_assignment_expression] = STATE(146),
    [sym_pointer_expression] = STATE(146),
    [sym_logical_expression] = STATE(146),
    [sym_bitwise_expression] = STATE(146),
    [sym_equality_expression] = STATE(146),
    [sym_relational_expression] = STATE(146),
    [sym_shift_expression] = STATE(146),
    [sym_math_expression] = STATE(146),
    [sym_cast_expression] = STATE(146),
    [sym_sizeof_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_compound_literal_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_char_literal] = STATE(146),
    [sym_concatenated_string] = STATE(146),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(146),
    [sym_new_expression] = STATE(146),
    [sym_delete_expression] = STATE(146),
    [sym_lambda_expression] = STATE(146),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(257),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(6986),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(257),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(259),
    [sym_false] = ACTIONS(259),
    [sym_null] = ACTIONS(259),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(259),
  },
  [2691] = {
    [anon_sym_COMMA] = ACTIONS(6988),
    [anon_sym_RPAREN] = ACTIONS(6988),
    [anon_sym_SEMI] = ACTIONS(6988),
    [anon_sym_LBRACE] = ACTIONS(6988),
    [anon_sym_LPAREN2] = ACTIONS(6988),
    [anon_sym_LBRACK] = ACTIONS(6988),
    [anon_sym_EQ] = ACTIONS(6988),
    [anon_sym_COLON] = ACTIONS(6988),
    [sym_comment] = ACTIONS(91),
  },
  [2692] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(6986),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_STAR_EQ] = ACTIONS(3507),
    [anon_sym_SLASH_EQ] = ACTIONS(3507),
    [anon_sym_PERCENT_EQ] = ACTIONS(3507),
    [anon_sym_PLUS_EQ] = ACTIONS(3507),
    [anon_sym_DASH_EQ] = ACTIONS(3507),
    [anon_sym_LT_LT_EQ] = ACTIONS(3507),
    [anon_sym_GT_GT_EQ] = ACTIONS(3507),
    [anon_sym_AMP_EQ] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(3507),
    [anon_sym_PIPE_EQ] = ACTIONS(3507),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_CARET] = ACTIONS(3517),
    [anon_sym_EQ_EQ] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3521),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3525),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2693] = {
    [sym_type_qualifier] = STATE(1684),
    [sym__expression] = STATE(3092),
    [sym_conditional_expression] = STATE(3092),
    [sym_assignment_expression] = STATE(3092),
    [sym_pointer_expression] = STATE(3092),
    [sym_logical_expression] = STATE(3092),
    [sym_bitwise_expression] = STATE(3092),
    [sym_equality_expression] = STATE(3092),
    [sym_relational_expression] = STATE(3092),
    [sym_shift_expression] = STATE(3092),
    [sym_math_expression] = STATE(3092),
    [sym_cast_expression] = STATE(3092),
    [sym_sizeof_expression] = STATE(3092),
    [sym_subscript_expression] = STATE(3092),
    [sym_call_expression] = STATE(3092),
    [sym_field_expression] = STATE(3092),
    [sym_compound_literal_expression] = STATE(3092),
    [sym_parenthesized_expression] = STATE(3092),
    [sym_char_literal] = STATE(3092),
    [sym_concatenated_string] = STATE(3092),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3092),
    [sym_new_expression] = STATE(3092),
    [sym_delete_expression] = STATE(3092),
    [sym_lambda_expression] = STATE(3092),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [aux_sym_type_definition_repeat1] = STATE(1684),
    [sym_raw_string_literal] = ACTIONS(6990),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(6992),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(6986),
    [anon_sym_const] = ACTIONS(1643),
    [anon_sym_restrict] = ACTIONS(1643),
    [anon_sym_volatile] = ACTIONS(1643),
    [anon_sym__Atomic] = ACTIONS(1643),
    [anon_sym_mutable] = ACTIONS(1643),
    [anon_sym_explicit] = ACTIONS(1643),
    [anon_sym_constexpr] = ACTIONS(1643),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(6990),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(6994),
    [sym_false] = ACTIONS(6994),
    [sym_null] = ACTIONS(6994),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(6994),
  },
  [2694] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(6996),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2695] = {
    [sym__type_specifier] = STATE(3095),
    [sym_sized_type_specifier] = STATE(3095),
    [sym_enum_specifier] = STATE(3095),
    [sym_struct_specifier] = STATE(3095),
    [sym_union_specifier] = STATE(3095),
    [sym_macro_type_specifier] = STATE(3095),
    [sym_class_specifier] = STATE(3095),
    [sym_dependent_type] = STATE(3095),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(1691),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3096),
    [anon_sym_unsigned] = ACTIONS(6998),
    [anon_sym_long] = ACTIONS(6998),
    [anon_sym_short] = ACTIONS(6998),
    [sym_primitive_type] = ACTIONS(7000),
    [anon_sym_enum] = ACTIONS(3539),
    [anon_sym_struct] = ACTIONS(3541),
    [anon_sym_union] = ACTIONS(3543),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3545),
    [sym_auto] = ACTIONS(7000),
    [anon_sym_typename] = ACTIONS(7002),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [2696] = {
    [sym_type_qualifier] = STATE(3097),
    [sym_virtual_specifier] = STATE(3097),
    [sym_trailing_return_type] = STATE(3097),
    [aux_sym_function_declarator_repeat1] = STATE(3097),
    [anon_sym_COMMA] = ACTIONS(7004),
    [anon_sym_SEMI] = ACTIONS(7004),
    [anon_sym_LBRACE] = ACTIONS(7004),
    [anon_sym_LPAREN2] = ACTIONS(7004),
    [anon_sym_LBRACK] = ACTIONS(7004),
    [anon_sym_EQ] = ACTIONS(7004),
    [anon_sym_const] = ACTIONS(1667),
    [anon_sym_restrict] = ACTIONS(1669),
    [anon_sym_volatile] = ACTIONS(1669),
    [anon_sym__Atomic] = ACTIONS(1669),
    [anon_sym_mutable] = ACTIONS(1669),
    [anon_sym_explicit] = ACTIONS(1669),
    [anon_sym_constexpr] = ACTIONS(1669),
    [anon_sym_COLON] = ACTIONS(7004),
    [anon_sym_DASH_GT] = ACTIONS(6013),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [sym_noexcept] = ACTIONS(7006),
  },
  [2697] = {
    [sym__expression] = STATE(3098),
    [sym_conditional_expression] = STATE(3098),
    [sym_assignment_expression] = STATE(3098),
    [sym_pointer_expression] = STATE(3098),
    [sym_logical_expression] = STATE(3098),
    [sym_bitwise_expression] = STATE(3098),
    [sym_equality_expression] = STATE(3098),
    [sym_relational_expression] = STATE(3098),
    [sym_shift_expression] = STATE(3098),
    [sym_math_expression] = STATE(3098),
    [sym_cast_expression] = STATE(3098),
    [sym_sizeof_expression] = STATE(3098),
    [sym_subscript_expression] = STATE(3098),
    [sym_call_expression] = STATE(3098),
    [sym_field_expression] = STATE(3098),
    [sym_compound_literal_expression] = STATE(3098),
    [sym_parenthesized_expression] = STATE(3098),
    [sym_char_literal] = STATE(3098),
    [sym_concatenated_string] = STATE(3098),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3098),
    [sym_new_expression] = STATE(3098),
    [sym_delete_expression] = STATE(3098),
    [sym_lambda_expression] = STATE(3098),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7008),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(7008),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7010),
    [sym_false] = ACTIONS(7010),
    [sym_null] = ACTIONS(7010),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(7010),
  },
  [2698] = {
    [aux_sym_field_declaration_repeat1] = STATE(2698),
    [anon_sym_COMMA] = ACTIONS(7012),
    [anon_sym_SEMI] = ACTIONS(6984),
    [anon_sym_COLON] = ACTIONS(6984),
    [sym_comment] = ACTIONS(91),
  },
  [2699] = {
    [sym__type_specifier] = STATE(444),
    [sym_sized_type_specifier] = STATE(444),
    [sym_enum_specifier] = STATE(444),
    [sym_struct_specifier] = STATE(444),
    [sym_union_specifier] = STATE(444),
    [sym_macro_type_specifier] = STATE(444),
    [sym_class_specifier] = STATE(444),
    [sym_dependent_type] = STATE(444),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(1691),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2701),
    [anon_sym_unsigned] = ACTIONS(6019),
    [anon_sym_long] = ACTIONS(6019),
    [anon_sym_short] = ACTIONS(6019),
    [sym_primitive_type] = ACTIONS(762),
    [anon_sym_enum] = ACTIONS(3539),
    [anon_sym_struct] = ACTIONS(3541),
    [anon_sym_union] = ACTIONS(3543),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3545),
    [sym_auto] = ACTIONS(762),
    [anon_sym_typename] = ACTIONS(6023),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [2700] = {
    [sym__abstract_declarator] = STATE(3101),
    [sym_abstract_pointer_declarator] = STATE(3101),
    [sym_abstract_function_declarator] = STATE(3101),
    [sym_abstract_array_declarator] = STATE(3101),
    [sym_parameter_list] = STATE(3102),
    [sym_abstract_reference_declarator] = STATE(3101),
    [anon_sym_SEMI] = ACTIONS(5222),
    [anon_sym_LBRACE] = ACTIONS(5222),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(7015),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_EQ] = ACTIONS(5222),
    [anon_sym_const] = ACTIONS(5226),
    [anon_sym_restrict] = ACTIONS(5222),
    [anon_sym_volatile] = ACTIONS(5222),
    [anon_sym__Atomic] = ACTIONS(5222),
    [anon_sym_mutable] = ACTIONS(5222),
    [anon_sym_explicit] = ACTIONS(5222),
    [anon_sym_constexpr] = ACTIONS(5222),
    [anon_sym_COLON] = ACTIONS(5222),
    [anon_sym_AMP] = ACTIONS(7017),
    [anon_sym_AMP_AMP] = ACTIONS(7019),
    [anon_sym_DASH_GT] = ACTIONS(5222),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5222),
    [anon_sym_override] = ACTIONS(5222),
    [sym_noexcept] = ACTIONS(5222),
  },
  [2701] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3103),
    [anon_sym_SEMI] = ACTIONS(653),
    [anon_sym_LBRACE] = ACTIONS(653),
    [anon_sym_LPAREN2] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_EQ] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(655),
    [anon_sym_restrict] = ACTIONS(655),
    [anon_sym_volatile] = ACTIONS(655),
    [anon_sym__Atomic] = ACTIONS(655),
    [anon_sym_mutable] = ACTIONS(655),
    [anon_sym_explicit] = ACTIONS(655),
    [anon_sym_constexpr] = ACTIONS(655),
    [anon_sym_unsigned] = ACTIONS(7021),
    [anon_sym_long] = ACTIONS(7021),
    [anon_sym_short] = ACTIONS(7021),
    [sym_primitive_type] = ACTIONS(778),
    [anon_sym_COLON] = ACTIONS(653),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [anon_sym_DASH_GT] = ACTIONS(653),
    [sym_identifier] = ACTIONS(5234),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(655),
    [anon_sym_override] = ACTIONS(655),
    [sym_noexcept] = ACTIONS(655),
  },
  [2702] = {
    [sym_type_qualifier] = STATE(2702),
    [sym_virtual_specifier] = STATE(2702),
    [sym_trailing_return_type] = STATE(2702),
    [aux_sym_function_declarator_repeat1] = STATE(2702),
    [anon_sym_SEMI] = ACTIONS(5236),
    [anon_sym_LBRACE] = ACTIONS(5236),
    [anon_sym_LPAREN2] = ACTIONS(5236),
    [anon_sym_LBRACK] = ACTIONS(5236),
    [anon_sym_EQ] = ACTIONS(5236),
    [anon_sym_const] = ACTIONS(5238),
    [anon_sym_restrict] = ACTIONS(5241),
    [anon_sym_volatile] = ACTIONS(5241),
    [anon_sym__Atomic] = ACTIONS(5241),
    [anon_sym_mutable] = ACTIONS(5241),
    [anon_sym_explicit] = ACTIONS(5241),
    [anon_sym_constexpr] = ACTIONS(5241),
    [anon_sym_COLON] = ACTIONS(5236),
    [anon_sym_DASH_GT] = ACTIONS(7023),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5247),
    [anon_sym_override] = ACTIONS(5247),
    [sym_noexcept] = ACTIONS(7026),
  },
  [2703] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2286),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2286),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2286),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2286),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2286),
    [anon_sym_typedef] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym_RBRACE] = ACTIONS(2286),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_STAR] = ACTIONS(2286),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_register] = ACTIONS(2288),
    [anon_sym_inline] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_explicit] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_unsigned] = ACTIONS(2288),
    [anon_sym_long] = ACTIONS(2288),
    [anon_sym_short] = ACTIONS(2288),
    [sym_primitive_type] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [anon_sym_struct] = ACTIONS(2288),
    [anon_sym_union] = ACTIONS(2288),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_TILDE] = ACTIONS(2286),
    [sym_identifier] = ACTIONS(2288),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_public] = ACTIONS(2288),
    [sym_auto] = ACTIONS(2288),
    [anon_sym_typename] = ACTIONS(2288),
    [anon_sym_template] = ACTIONS(2288),
    [anon_sym_friend] = ACTIONS(2288),
    [anon_sym_private] = ACTIONS(2288),
    [anon_sym_protected] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [sym_operator_name] = ACTIONS(2286),
  },
  [2704] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5255),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5253),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5253),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5253),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5253),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5253),
    [anon_sym_typedef] = ACTIONS(5255),
    [anon_sym_extern] = ACTIONS(5255),
    [anon_sym_RBRACE] = ACTIONS(5253),
    [anon_sym_LPAREN2] = ACTIONS(5253),
    [anon_sym_STAR] = ACTIONS(5253),
    [anon_sym_static] = ACTIONS(5255),
    [anon_sym_register] = ACTIONS(5255),
    [anon_sym_inline] = ACTIONS(5255),
    [anon_sym_const] = ACTIONS(5255),
    [anon_sym_restrict] = ACTIONS(5255),
    [anon_sym_volatile] = ACTIONS(5255),
    [anon_sym__Atomic] = ACTIONS(5255),
    [anon_sym_mutable] = ACTIONS(5255),
    [anon_sym_explicit] = ACTIONS(5255),
    [anon_sym_constexpr] = ACTIONS(5255),
    [anon_sym_unsigned] = ACTIONS(5255),
    [anon_sym_long] = ACTIONS(5255),
    [anon_sym_short] = ACTIONS(5255),
    [sym_primitive_type] = ACTIONS(5255),
    [anon_sym_enum] = ACTIONS(5255),
    [anon_sym_struct] = ACTIONS(5255),
    [anon_sym_union] = ACTIONS(5255),
    [anon_sym_AMP] = ACTIONS(5255),
    [anon_sym_AMP_AMP] = ACTIONS(5253),
    [anon_sym_TILDE] = ACTIONS(5253),
    [sym_identifier] = ACTIONS(5255),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5255),
    [anon_sym_public] = ACTIONS(5255),
    [sym_auto] = ACTIONS(5255),
    [anon_sym_typename] = ACTIONS(5255),
    [anon_sym_template] = ACTIONS(5255),
    [anon_sym_friend] = ACTIONS(5255),
    [anon_sym_private] = ACTIONS(5255),
    [anon_sym_protected] = ACTIONS(5255),
    [anon_sym_using] = ACTIONS(5255),
    [anon_sym_COLON_COLON] = ACTIONS(5253),
    [sym_operator_name] = ACTIONS(5253),
  },
  [2705] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5257),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5257),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5257),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5257),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5257),
    [anon_sym_typedef] = ACTIONS(5259),
    [anon_sym_extern] = ACTIONS(5259),
    [anon_sym_RBRACE] = ACTIONS(5257),
    [anon_sym_LPAREN2] = ACTIONS(5257),
    [anon_sym_STAR] = ACTIONS(5257),
    [anon_sym_static] = ACTIONS(5259),
    [anon_sym_register] = ACTIONS(5259),
    [anon_sym_inline] = ACTIONS(5259),
    [anon_sym_const] = ACTIONS(5259),
    [anon_sym_restrict] = ACTIONS(5259),
    [anon_sym_volatile] = ACTIONS(5259),
    [anon_sym__Atomic] = ACTIONS(5259),
    [anon_sym_mutable] = ACTIONS(5259),
    [anon_sym_explicit] = ACTIONS(5259),
    [anon_sym_constexpr] = ACTIONS(5259),
    [anon_sym_unsigned] = ACTIONS(5259),
    [anon_sym_long] = ACTIONS(5259),
    [anon_sym_short] = ACTIONS(5259),
    [sym_primitive_type] = ACTIONS(5259),
    [anon_sym_enum] = ACTIONS(5259),
    [anon_sym_struct] = ACTIONS(5259),
    [anon_sym_union] = ACTIONS(5259),
    [anon_sym_AMP] = ACTIONS(5259),
    [anon_sym_AMP_AMP] = ACTIONS(5257),
    [anon_sym_TILDE] = ACTIONS(5257),
    [sym_identifier] = ACTIONS(5259),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5259),
    [anon_sym_public] = ACTIONS(5259),
    [sym_auto] = ACTIONS(5259),
    [anon_sym_typename] = ACTIONS(5259),
    [anon_sym_template] = ACTIONS(5259),
    [anon_sym_friend] = ACTIONS(5259),
    [anon_sym_private] = ACTIONS(5259),
    [anon_sym_protected] = ACTIONS(5259),
    [anon_sym_using] = ACTIONS(5259),
    [anon_sym_COLON_COLON] = ACTIONS(5257),
    [sym_operator_name] = ACTIONS(5257),
  },
  [2706] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5368),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5366),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5366),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5366),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5366),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5366),
    [anon_sym_typedef] = ACTIONS(5368),
    [anon_sym_extern] = ACTIONS(5368),
    [anon_sym_RBRACE] = ACTIONS(5366),
    [anon_sym_LPAREN2] = ACTIONS(5366),
    [anon_sym_STAR] = ACTIONS(5366),
    [anon_sym_static] = ACTIONS(5368),
    [anon_sym_register] = ACTIONS(5368),
    [anon_sym_inline] = ACTIONS(5368),
    [anon_sym_const] = ACTIONS(5368),
    [anon_sym_restrict] = ACTIONS(5368),
    [anon_sym_volatile] = ACTIONS(5368),
    [anon_sym__Atomic] = ACTIONS(5368),
    [anon_sym_mutable] = ACTIONS(5368),
    [anon_sym_explicit] = ACTIONS(5368),
    [anon_sym_constexpr] = ACTIONS(5368),
    [anon_sym_unsigned] = ACTIONS(5368),
    [anon_sym_long] = ACTIONS(5368),
    [anon_sym_short] = ACTIONS(5368),
    [sym_primitive_type] = ACTIONS(5368),
    [anon_sym_enum] = ACTIONS(5368),
    [anon_sym_struct] = ACTIONS(5368),
    [anon_sym_union] = ACTIONS(5368),
    [anon_sym_AMP] = ACTIONS(5368),
    [anon_sym_AMP_AMP] = ACTIONS(5366),
    [anon_sym_TILDE] = ACTIONS(5366),
    [sym_identifier] = ACTIONS(5368),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5368),
    [anon_sym_public] = ACTIONS(5368),
    [sym_auto] = ACTIONS(5368),
    [anon_sym_typename] = ACTIONS(5368),
    [anon_sym_template] = ACTIONS(5368),
    [anon_sym_friend] = ACTIONS(5368),
    [anon_sym_private] = ACTIONS(5368),
    [anon_sym_protected] = ACTIONS(5368),
    [anon_sym_using] = ACTIONS(5368),
    [anon_sym_COLON_COLON] = ACTIONS(5366),
    [sym_operator_name] = ACTIONS(5366),
  },
  [2707] = {
    [sym_template_argument_list] = STATE(437),
    [anon_sym_COMMA] = ACTIONS(7029),
    [anon_sym_LBRACE] = ACTIONS(7029),
    [anon_sym_LT] = ACTIONS(945),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(758),
  },
  [2708] = {
    [anon_sym_COMMA] = ACTIONS(7031),
    [anon_sym_LBRACE] = ACTIONS(7031),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(772),
  },
  [2709] = {
    [sym_template_argument_list] = STATE(362),
    [anon_sym_COMMA] = ACTIONS(7031),
    [anon_sym_LBRACE] = ACTIONS(7031),
    [anon_sym_LT] = ACTIONS(945),
    [sym_comment] = ACTIONS(91),
  },
  [2710] = {
    [sym__expression] = STATE(1200),
    [sym_conditional_expression] = STATE(1200),
    [sym_assignment_expression] = STATE(1200),
    [sym_pointer_expression] = STATE(1200),
    [sym_logical_expression] = STATE(1200),
    [sym_bitwise_expression] = STATE(1200),
    [sym_equality_expression] = STATE(1200),
    [sym_relational_expression] = STATE(1200),
    [sym_shift_expression] = STATE(1200),
    [sym_math_expression] = STATE(1200),
    [sym_cast_expression] = STATE(1200),
    [sym_sizeof_expression] = STATE(1200),
    [sym_subscript_expression] = STATE(1200),
    [sym_call_expression] = STATE(1200),
    [sym_field_expression] = STATE(1200),
    [sym_compound_literal_expression] = STATE(1200),
    [sym_parenthesized_expression] = STATE(1200),
    [sym_initializer_list] = STATE(1201),
    [sym_char_literal] = STATE(1200),
    [sym_concatenated_string] = STATE(1200),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1200),
    [sym_new_expression] = STATE(1200),
    [sym_delete_expression] = STATE(1200),
    [sym_lambda_expression] = STATE(1200),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2523),
    [anon_sym_RPAREN] = ACTIONS(4689),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(7033),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_EQ] = ACTIONS(4693),
    [anon_sym_QMARK] = ACTIONS(4689),
    [anon_sym_STAR_EQ] = ACTIONS(4689),
    [anon_sym_SLASH_EQ] = ACTIONS(4689),
    [anon_sym_PERCENT_EQ] = ACTIONS(4689),
    [anon_sym_PLUS_EQ] = ACTIONS(4689),
    [anon_sym_DASH_EQ] = ACTIONS(4689),
    [anon_sym_LT_LT_EQ] = ACTIONS(4689),
    [anon_sym_GT_GT_EQ] = ACTIONS(4689),
    [anon_sym_AMP_EQ] = ACTIONS(4689),
    [anon_sym_CARET_EQ] = ACTIONS(4689),
    [anon_sym_PIPE_EQ] = ACTIONS(4689),
    [anon_sym_AMP] = ACTIONS(7033),
    [anon_sym_PIPE_PIPE] = ACTIONS(4689),
    [anon_sym_AMP_AMP] = ACTIONS(4689),
    [anon_sym_BANG] = ACTIONS(7035),
    [anon_sym_PIPE] = ACTIONS(4693),
    [anon_sym_CARET] = ACTIONS(4693),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_EQ_EQ] = ACTIONS(4689),
    [anon_sym_BANG_EQ] = ACTIONS(4689),
    [anon_sym_LT] = ACTIONS(4693),
    [anon_sym_GT] = ACTIONS(4693),
    [anon_sym_LT_EQ] = ACTIONS(4689),
    [anon_sym_GT_EQ] = ACTIONS(4689),
    [anon_sym_LT_LT] = ACTIONS(4693),
    [anon_sym_GT_GT] = ACTIONS(4693),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(4693),
    [anon_sym_PERCENT] = ACTIONS(4693),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [anon_sym_DOT] = ACTIONS(4689),
    [anon_sym_DASH_GT] = ACTIONS(4689),
    [sym_number_literal] = ACTIONS(2523),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2525),
    [sym_false] = ACTIONS(2525),
    [sym_null] = ACTIONS(2525),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(2525),
  },
  [2711] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(4927),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(4929),
    [anon_sym_QMARK] = ACTIONS(4927),
    [anon_sym_STAR_EQ] = ACTIONS(4927),
    [anon_sym_SLASH_EQ] = ACTIONS(4927),
    [anon_sym_PERCENT_EQ] = ACTIONS(4927),
    [anon_sym_PLUS_EQ] = ACTIONS(4927),
    [anon_sym_DASH_EQ] = ACTIONS(4927),
    [anon_sym_LT_LT_EQ] = ACTIONS(4927),
    [anon_sym_GT_GT_EQ] = ACTIONS(4927),
    [anon_sym_AMP_EQ] = ACTIONS(4927),
    [anon_sym_CARET_EQ] = ACTIONS(4927),
    [anon_sym_PIPE_EQ] = ACTIONS(4927),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2712] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(7037),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_STAR_EQ] = ACTIONS(3507),
    [anon_sym_SLASH_EQ] = ACTIONS(3507),
    [anon_sym_PERCENT_EQ] = ACTIONS(3507),
    [anon_sym_PLUS_EQ] = ACTIONS(3507),
    [anon_sym_DASH_EQ] = ACTIONS(3507),
    [anon_sym_LT_LT_EQ] = ACTIONS(3507),
    [anon_sym_GT_GT_EQ] = ACTIONS(3507),
    [anon_sym_AMP_EQ] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(3507),
    [anon_sym_PIPE_EQ] = ACTIONS(3507),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_CARET] = ACTIONS(3517),
    [anon_sym_EQ_EQ] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3521),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3525),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2713] = {
    [sym__expression] = STATE(3105),
    [sym_conditional_expression] = STATE(3105),
    [sym_assignment_expression] = STATE(3105),
    [sym_pointer_expression] = STATE(3105),
    [sym_logical_expression] = STATE(3105),
    [sym_bitwise_expression] = STATE(3105),
    [sym_equality_expression] = STATE(3105),
    [sym_relational_expression] = STATE(3105),
    [sym_shift_expression] = STATE(3105),
    [sym_math_expression] = STATE(3105),
    [sym_cast_expression] = STATE(3105),
    [sym_sizeof_expression] = STATE(3105),
    [sym_subscript_expression] = STATE(3105),
    [sym_call_expression] = STATE(3105),
    [sym_field_expression] = STATE(3105),
    [sym_compound_literal_expression] = STATE(3105),
    [sym_parenthesized_expression] = STATE(3105),
    [sym_char_literal] = STATE(3105),
    [sym_concatenated_string] = STATE(3105),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3105),
    [sym_new_expression] = STATE(3105),
    [sym_delete_expression] = STATE(3105),
    [sym_lambda_expression] = STATE(3105),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7039),
    [anon_sym_LPAREN2] = ACTIONS(947),
    [anon_sym_STAR] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(947),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(7039),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7041),
    [sym_false] = ACTIONS(7041),
    [sym_null] = ACTIONS(7041),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(7041),
  },
  [2714] = {
    [sym__expression] = STATE(3106),
    [sym_conditional_expression] = STATE(3106),
    [sym_assignment_expression] = STATE(3106),
    [sym_pointer_expression] = STATE(3106),
    [sym_logical_expression] = STATE(3106),
    [sym_bitwise_expression] = STATE(3106),
    [sym_equality_expression] = STATE(3106),
    [sym_relational_expression] = STATE(3106),
    [sym_shift_expression] = STATE(3106),
    [sym_math_expression] = STATE(3106),
    [sym_cast_expression] = STATE(3106),
    [sym_sizeof_expression] = STATE(3106),
    [sym_subscript_expression] = STATE(3106),
    [sym_call_expression] = STATE(3106),
    [sym_field_expression] = STATE(3106),
    [sym_compound_literal_expression] = STATE(3106),
    [sym_parenthesized_expression] = STATE(3106),
    [sym_char_literal] = STATE(3106),
    [sym_concatenated_string] = STATE(3106),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3106),
    [sym_new_expression] = STATE(3106),
    [sym_delete_expression] = STATE(3106),
    [sym_lambda_expression] = STATE(3106),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7043),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(7043),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7045),
    [sym_false] = ACTIONS(7045),
    [sym_null] = ACTIONS(7045),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(7045),
  },
  [2715] = {
    [anon_sym_LPAREN2] = ACTIONS(7047),
    [sym_comment] = ACTIONS(91),
  },
  [2716] = {
    [sym_compound_statement] = STATE(642),
    [sym_labeled_statement] = STATE(642),
    [sym_expression_statement] = STATE(642),
    [sym_if_statement] = STATE(642),
    [sym_switch_statement] = STATE(642),
    [sym_case_statement] = STATE(642),
    [sym_while_statement] = STATE(642),
    [sym_do_statement] = STATE(642),
    [sym_for_statement] = STATE(642),
    [sym_return_statement] = STATE(642),
    [sym_break_statement] = STATE(642),
    [sym_continue_statement] = STATE(642),
    [sym_goto_statement] = STATE(642),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(642),
    [sym_try_statement] = STATE(642),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(4430),
    [anon_sym_switch] = ACTIONS(4432),
    [anon_sym_case] = ACTIONS(4434),
    [anon_sym_default] = ACTIONS(4436),
    [anon_sym_while] = ACTIONS(4438),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(4440),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(4442),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(4444),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [2717] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_COLON] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(1171),
    [anon_sym_STAR_EQ] = ACTIONS(1173),
    [anon_sym_SLASH_EQ] = ACTIONS(1173),
    [anon_sym_PERCENT_EQ] = ACTIONS(1173),
    [anon_sym_PLUS_EQ] = ACTIONS(1173),
    [anon_sym_DASH_EQ] = ACTIONS(1173),
    [anon_sym_LT_LT_EQ] = ACTIONS(1173),
    [anon_sym_GT_GT_EQ] = ACTIONS(1173),
    [anon_sym_AMP_EQ] = ACTIONS(1173),
    [anon_sym_CARET_EQ] = ACTIONS(1173),
    [anon_sym_PIPE_EQ] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_CARET] = ACTIONS(1183),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [2718] = {
    [sym_declaration] = STATE(681),
    [sym_type_definition] = STATE(681),
    [sym__declaration_specifiers] = STATE(682),
    [sym_compound_statement] = STATE(681),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_labeled_statement] = STATE(681),
    [sym_expression_statement] = STATE(681),
    [sym_if_statement] = STATE(681),
    [sym_switch_statement] = STATE(681),
    [sym_case_statement] = STATE(681),
    [sym_while_statement] = STATE(681),
    [sym_do_statement] = STATE(681),
    [sym_for_statement] = STATE(681),
    [sym_return_statement] = STATE(681),
    [sym_break_statement] = STATE(681),
    [sym_continue_statement] = STATE(681),
    [sym_goto_statement] = STATE(681),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(681),
    [sym_try_statement] = STATE(681),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(4430),
    [anon_sym_switch] = ACTIONS(4432),
    [anon_sym_case] = ACTIONS(4434),
    [anon_sym_default] = ACTIONS(4436),
    [anon_sym_while] = ACTIONS(4438),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(4440),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(7051),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(4444),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(1202),
    [sym_nullptr] = ACTIONS(87),
  },
  [2719] = {
    [sym_compound_statement] = STATE(685),
    [sym_labeled_statement] = STATE(685),
    [sym_expression_statement] = STATE(685),
    [sym_if_statement] = STATE(685),
    [sym_switch_statement] = STATE(685),
    [sym_case_statement] = STATE(685),
    [sym_while_statement] = STATE(685),
    [sym_do_statement] = STATE(685),
    [sym_for_statement] = STATE(685),
    [sym_return_statement] = STATE(685),
    [sym_break_statement] = STATE(685),
    [sym_continue_statement] = STATE(685),
    [sym_goto_statement] = STATE(685),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(685),
    [sym_try_statement] = STATE(685),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(4430),
    [anon_sym_switch] = ACTIONS(4432),
    [anon_sym_case] = ACTIONS(4434),
    [anon_sym_default] = ACTIONS(4436),
    [anon_sym_while] = ACTIONS(4438),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(4440),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(4442),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(4444),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [2720] = {
    [sym_declaration] = STATE(3110),
    [sym__declaration_specifiers] = STATE(709),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym__expression] = STATE(3111),
    [sym_conditional_expression] = STATE(3111),
    [sym_assignment_expression] = STATE(3111),
    [sym_pointer_expression] = STATE(3111),
    [sym_logical_expression] = STATE(3111),
    [sym_bitwise_expression] = STATE(3111),
    [sym_equality_expression] = STATE(3111),
    [sym_relational_expression] = STATE(3111),
    [sym_shift_expression] = STATE(3111),
    [sym_math_expression] = STATE(3111),
    [sym_cast_expression] = STATE(3111),
    [sym_sizeof_expression] = STATE(3111),
    [sym_subscript_expression] = STATE(3111),
    [sym_call_expression] = STATE(3111),
    [sym_field_expression] = STATE(3111),
    [sym_compound_literal_expression] = STATE(3111),
    [sym_parenthesized_expression] = STATE(3111),
    [sym_char_literal] = STATE(3111),
    [sym_concatenated_string] = STATE(3111),
    [sym_string_literal] = STATE(238),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(3111),
    [sym_for_range_declaration] = STATE(3112),
    [sym_new_expression] = STATE(3111),
    [sym_delete_expression] = STATE(3111),
    [sym_lambda_expression] = STATE(3111),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(7053),
    [anon_sym_SEMI] = ACTIONS(7055),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(7053),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7057),
    [sym_false] = ACTIONS(7057),
    [sym_null] = ACTIONS(7057),
    [sym_identifier] = ACTIONS(1242),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(1244),
    [sym_nullptr] = ACTIONS(7057),
  },
  [2721] = {
    [sym_compound_statement] = STATE(762),
    [sym_labeled_statement] = STATE(762),
    [sym_expression_statement] = STATE(762),
    [sym_if_statement] = STATE(762),
    [sym_switch_statement] = STATE(762),
    [sym_case_statement] = STATE(762),
    [sym_while_statement] = STATE(762),
    [sym_do_statement] = STATE(762),
    [sym_for_statement] = STATE(762),
    [sym_return_statement] = STATE(762),
    [sym_break_statement] = STATE(762),
    [sym_continue_statement] = STATE(762),
    [sym_goto_statement] = STATE(762),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(762),
    [sym_try_statement] = STATE(762),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(4430),
    [anon_sym_switch] = ACTIONS(4432),
    [anon_sym_case] = ACTIONS(4434),
    [anon_sym_default] = ACTIONS(4436),
    [anon_sym_while] = ACTIONS(4438),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(4440),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(4442),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(4444),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [2722] = {
    [sym_catch_clause] = STATE(3113),
    [aux_sym_try_statement_repeat1] = STATE(3113),
    [sym_comment] = ACTIONS(91),
    [anon_sym_catch] = ACTIONS(1527),
  },
  [2723] = {
    [sym_compound_statement] = STATE(3114),
    [sym_labeled_statement] = STATE(3114),
    [sym_expression_statement] = STATE(3114),
    [sym_if_statement] = STATE(3114),
    [sym_switch_statement] = STATE(3114),
    [sym_case_statement] = STATE(3114),
    [sym_while_statement] = STATE(3114),
    [sym_do_statement] = STATE(3114),
    [sym_for_statement] = STATE(3114),
    [sym_return_statement] = STATE(3114),
    [sym_break_statement] = STATE(3114),
    [sym_continue_statement] = STATE(3114),
    [sym_goto_statement] = STATE(3114),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(3114),
    [sym_try_statement] = STATE(3114),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_switch] = ACTIONS(49),
    [anon_sym_case] = ACTIONS(51),
    [anon_sym_default] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(1115),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(105),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [2724] = {
    [sym__expression] = STATE(3115),
    [sym_conditional_expression] = STATE(3115),
    [sym_assignment_expression] = STATE(3115),
    [sym_pointer_expression] = STATE(3115),
    [sym_logical_expression] = STATE(3115),
    [sym_bitwise_expression] = STATE(3115),
    [sym_equality_expression] = STATE(3115),
    [sym_relational_expression] = STATE(3115),
    [sym_shift_expression] = STATE(3115),
    [sym_math_expression] = STATE(3115),
    [sym_cast_expression] = STATE(3115),
    [sym_sizeof_expression] = STATE(3115),
    [sym_subscript_expression] = STATE(3115),
    [sym_call_expression] = STATE(3115),
    [sym_field_expression] = STATE(3115),
    [sym_compound_literal_expression] = STATE(3115),
    [sym_parenthesized_expression] = STATE(3115),
    [sym_char_literal] = STATE(3115),
    [sym_concatenated_string] = STATE(3115),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3115),
    [sym_new_expression] = STATE(3115),
    [sym_delete_expression] = STATE(3115),
    [sym_lambda_expression] = STATE(3115),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7059),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(7059),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7061),
    [sym_false] = ACTIONS(7061),
    [sym_null] = ACTIONS(7061),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(7061),
  },
  [2725] = {
    [sym_raw_string_literal] = ACTIONS(7063),
    [ts_builtin_sym_end] = ACTIONS(7063),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7065),
    [sym_preproc_directive] = ACTIONS(7065),
    [anon_sym_SEMI] = ACTIONS(7063),
    [anon_sym_typedef] = ACTIONS(7065),
    [anon_sym_extern] = ACTIONS(7065),
    [anon_sym_LBRACE] = ACTIONS(7063),
    [anon_sym_LPAREN2] = ACTIONS(7063),
    [anon_sym_STAR] = ACTIONS(7063),
    [anon_sym_LBRACK] = ACTIONS(7063),
    [anon_sym_static] = ACTIONS(7065),
    [anon_sym_register] = ACTIONS(7065),
    [anon_sym_inline] = ACTIONS(7065),
    [anon_sym_const] = ACTIONS(7065),
    [anon_sym_restrict] = ACTIONS(7065),
    [anon_sym_volatile] = ACTIONS(7065),
    [anon_sym__Atomic] = ACTIONS(7065),
    [anon_sym_mutable] = ACTIONS(7065),
    [anon_sym_explicit] = ACTIONS(7065),
    [anon_sym_constexpr] = ACTIONS(7065),
    [anon_sym_unsigned] = ACTIONS(7065),
    [anon_sym_long] = ACTIONS(7065),
    [anon_sym_short] = ACTIONS(7065),
    [sym_primitive_type] = ACTIONS(7065),
    [anon_sym_enum] = ACTIONS(7065),
    [anon_sym_struct] = ACTIONS(7065),
    [anon_sym_union] = ACTIONS(7065),
    [anon_sym_if] = ACTIONS(7065),
    [anon_sym_else] = ACTIONS(7067),
    [anon_sym_switch] = ACTIONS(7065),
    [anon_sym_case] = ACTIONS(7065),
    [anon_sym_default] = ACTIONS(7065),
    [anon_sym_while] = ACTIONS(7065),
    [anon_sym_do] = ACTIONS(7065),
    [anon_sym_for] = ACTIONS(7065),
    [anon_sym_return] = ACTIONS(7065),
    [anon_sym_break] = ACTIONS(7065),
    [anon_sym_continue] = ACTIONS(7065),
    [anon_sym_goto] = ACTIONS(7065),
    [anon_sym_AMP] = ACTIONS(7065),
    [anon_sym_AMP_AMP] = ACTIONS(7063),
    [anon_sym_BANG] = ACTIONS(7063),
    [anon_sym_TILDE] = ACTIONS(7063),
    [anon_sym_PLUS] = ACTIONS(7065),
    [anon_sym_DASH] = ACTIONS(7065),
    [anon_sym_DASH_DASH] = ACTIONS(7063),
    [anon_sym_PLUS_PLUS] = ACTIONS(7063),
    [anon_sym_sizeof] = ACTIONS(7065),
    [sym_number_literal] = ACTIONS(7063),
    [anon_sym_SQUOTE] = ACTIONS(7063),
    [anon_sym_DQUOTE] = ACTIONS(7063),
    [sym_true] = ACTIONS(7065),
    [sym_false] = ACTIONS(7065),
    [sym_null] = ACTIONS(7065),
    [sym_identifier] = ACTIONS(7065),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7065),
    [sym_auto] = ACTIONS(7065),
    [anon_sym_typename] = ACTIONS(7065),
    [anon_sym_template] = ACTIONS(7065),
    [anon_sym_delete] = ACTIONS(7065),
    [anon_sym_namespace] = ACTIONS(7065),
    [anon_sym_using] = ACTIONS(7065),
    [anon_sym_try] = ACTIONS(7065),
    [anon_sym_new] = ACTIONS(7065),
    [anon_sym_COLON_COLON] = ACTIONS(7063),
    [sym_operator_name] = ACTIONS(7063),
    [sym_nullptr] = ACTIONS(7065),
  },
  [2726] = {
    [sym_new_declarator] = STATE(2861),
    [anon_sym_LBRACE] = ACTIONS(6396),
    [anon_sym_LPAREN2] = ACTIONS(6396),
    [anon_sym_STAR] = ACTIONS(6398),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_EQ] = ACTIONS(6398),
    [anon_sym_COLON] = ACTIONS(6396),
    [anon_sym_QMARK] = ACTIONS(6396),
    [anon_sym_STAR_EQ] = ACTIONS(6396),
    [anon_sym_SLASH_EQ] = ACTIONS(6396),
    [anon_sym_PERCENT_EQ] = ACTIONS(6396),
    [anon_sym_PLUS_EQ] = ACTIONS(6396),
    [anon_sym_DASH_EQ] = ACTIONS(6396),
    [anon_sym_LT_LT_EQ] = ACTIONS(6396),
    [anon_sym_GT_GT_EQ] = ACTIONS(6396),
    [anon_sym_AMP_EQ] = ACTIONS(6396),
    [anon_sym_CARET_EQ] = ACTIONS(6396),
    [anon_sym_PIPE_EQ] = ACTIONS(6396),
    [anon_sym_AMP] = ACTIONS(6398),
    [anon_sym_PIPE_PIPE] = ACTIONS(6396),
    [anon_sym_AMP_AMP] = ACTIONS(6396),
    [anon_sym_PIPE] = ACTIONS(6398),
    [anon_sym_CARET] = ACTIONS(6398),
    [anon_sym_EQ_EQ] = ACTIONS(6396),
    [anon_sym_BANG_EQ] = ACTIONS(6396),
    [anon_sym_LT] = ACTIONS(6398),
    [anon_sym_GT] = ACTIONS(6398),
    [anon_sym_LT_EQ] = ACTIONS(6396),
    [anon_sym_GT_EQ] = ACTIONS(6396),
    [anon_sym_LT_LT] = ACTIONS(6398),
    [anon_sym_GT_GT] = ACTIONS(6398),
    [anon_sym_PLUS] = ACTIONS(6398),
    [anon_sym_DASH] = ACTIONS(6398),
    [anon_sym_SLASH] = ACTIONS(6398),
    [anon_sym_PERCENT] = ACTIONS(6398),
    [anon_sym_DASH_DASH] = ACTIONS(6396),
    [anon_sym_PLUS_PLUS] = ACTIONS(6396),
    [anon_sym_DOT] = ACTIONS(6396),
    [anon_sym_DASH_GT] = ACTIONS(6396),
    [sym_comment] = ACTIONS(91),
  },
  [2727] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(6406),
    [anon_sym_COLON] = ACTIONS(6404),
    [anon_sym_QMARK] = ACTIONS(6404),
    [anon_sym_STAR_EQ] = ACTIONS(6404),
    [anon_sym_SLASH_EQ] = ACTIONS(6404),
    [anon_sym_PERCENT_EQ] = ACTIONS(6404),
    [anon_sym_PLUS_EQ] = ACTIONS(6404),
    [anon_sym_DASH_EQ] = ACTIONS(6404),
    [anon_sym_LT_LT_EQ] = ACTIONS(6404),
    [anon_sym_GT_GT_EQ] = ACTIONS(6404),
    [anon_sym_AMP_EQ] = ACTIONS(6404),
    [anon_sym_CARET_EQ] = ACTIONS(6404),
    [anon_sym_PIPE_EQ] = ACTIONS(6404),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_CARET] = ACTIONS(1183),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [2728] = {
    [anon_sym_LPAREN2] = ACTIONS(6385),
    [anon_sym_STAR] = ACTIONS(6387),
    [anon_sym_LBRACK] = ACTIONS(6385),
    [anon_sym_EQ] = ACTIONS(6387),
    [anon_sym_COLON] = ACTIONS(6385),
    [anon_sym_QMARK] = ACTIONS(6385),
    [anon_sym_STAR_EQ] = ACTIONS(6385),
    [anon_sym_SLASH_EQ] = ACTIONS(6385),
    [anon_sym_PERCENT_EQ] = ACTIONS(6385),
    [anon_sym_PLUS_EQ] = ACTIONS(6385),
    [anon_sym_DASH_EQ] = ACTIONS(6385),
    [anon_sym_LT_LT_EQ] = ACTIONS(6385),
    [anon_sym_GT_GT_EQ] = ACTIONS(6385),
    [anon_sym_AMP_EQ] = ACTIONS(6385),
    [anon_sym_CARET_EQ] = ACTIONS(6385),
    [anon_sym_PIPE_EQ] = ACTIONS(6385),
    [anon_sym_AMP] = ACTIONS(6387),
    [anon_sym_PIPE_PIPE] = ACTIONS(6385),
    [anon_sym_AMP_AMP] = ACTIONS(6385),
    [anon_sym_PIPE] = ACTIONS(6387),
    [anon_sym_CARET] = ACTIONS(6387),
    [anon_sym_EQ_EQ] = ACTIONS(6385),
    [anon_sym_BANG_EQ] = ACTIONS(6385),
    [anon_sym_LT] = ACTIONS(6387),
    [anon_sym_GT] = ACTIONS(6387),
    [anon_sym_LT_EQ] = ACTIONS(6385),
    [anon_sym_GT_EQ] = ACTIONS(6385),
    [anon_sym_LT_LT] = ACTIONS(6387),
    [anon_sym_GT_GT] = ACTIONS(6387),
    [anon_sym_PLUS] = ACTIONS(6387),
    [anon_sym_DASH] = ACTIONS(6387),
    [anon_sym_SLASH] = ACTIONS(6387),
    [anon_sym_PERCENT] = ACTIONS(6387),
    [anon_sym_DASH_DASH] = ACTIONS(6385),
    [anon_sym_PLUS_PLUS] = ACTIONS(6385),
    [anon_sym_DOT] = ACTIONS(6385),
    [anon_sym_DASH_GT] = ACTIONS(6385),
    [sym_comment] = ACTIONS(91),
  },
  [2729] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_COLON] = ACTIONS(6579),
    [anon_sym_QMARK] = ACTIONS(1171),
    [anon_sym_STAR_EQ] = ACTIONS(1173),
    [anon_sym_SLASH_EQ] = ACTIONS(1173),
    [anon_sym_PERCENT_EQ] = ACTIONS(1173),
    [anon_sym_PLUS_EQ] = ACTIONS(1173),
    [anon_sym_DASH_EQ] = ACTIONS(1173),
    [anon_sym_LT_LT_EQ] = ACTIONS(1173),
    [anon_sym_GT_GT_EQ] = ACTIONS(1173),
    [anon_sym_AMP_EQ] = ACTIONS(1173),
    [anon_sym_CARET_EQ] = ACTIONS(1173),
    [anon_sym_PIPE_EQ] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_CARET] = ACTIONS(1183),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [2730] = {
    [anon_sym_COMMA] = ACTIONS(6284),
    [anon_sym_SEMI] = ACTIONS(6284),
    [anon_sym_LBRACE] = ACTIONS(6284),
    [anon_sym_LPAREN2] = ACTIONS(6284),
    [anon_sym_STAR] = ACTIONS(6286),
    [anon_sym_LBRACK] = ACTIONS(6284),
    [anon_sym_EQ] = ACTIONS(6286),
    [anon_sym_COLON] = ACTIONS(6284),
    [anon_sym_QMARK] = ACTIONS(6284),
    [anon_sym_STAR_EQ] = ACTIONS(6284),
    [anon_sym_SLASH_EQ] = ACTIONS(6284),
    [anon_sym_PERCENT_EQ] = ACTIONS(6284),
    [anon_sym_PLUS_EQ] = ACTIONS(6284),
    [anon_sym_DASH_EQ] = ACTIONS(6284),
    [anon_sym_LT_LT_EQ] = ACTIONS(6284),
    [anon_sym_GT_GT_EQ] = ACTIONS(6284),
    [anon_sym_AMP_EQ] = ACTIONS(6284),
    [anon_sym_CARET_EQ] = ACTIONS(6284),
    [anon_sym_PIPE_EQ] = ACTIONS(6284),
    [anon_sym_AMP] = ACTIONS(6286),
    [anon_sym_PIPE_PIPE] = ACTIONS(6284),
    [anon_sym_AMP_AMP] = ACTIONS(6284),
    [anon_sym_PIPE] = ACTIONS(6286),
    [anon_sym_CARET] = ACTIONS(6286),
    [anon_sym_EQ_EQ] = ACTIONS(6284),
    [anon_sym_BANG_EQ] = ACTIONS(6284),
    [anon_sym_LT] = ACTIONS(6286),
    [anon_sym_GT] = ACTIONS(6286),
    [anon_sym_LT_EQ] = ACTIONS(6284),
    [anon_sym_GT_EQ] = ACTIONS(6284),
    [anon_sym_LT_LT] = ACTIONS(6286),
    [anon_sym_GT_GT] = ACTIONS(6286),
    [anon_sym_PLUS] = ACTIONS(6286),
    [anon_sym_DASH] = ACTIONS(6286),
    [anon_sym_SLASH] = ACTIONS(6286),
    [anon_sym_PERCENT] = ACTIONS(6286),
    [anon_sym_DASH_DASH] = ACTIONS(6284),
    [anon_sym_PLUS_PLUS] = ACTIONS(6284),
    [anon_sym_DOT] = ACTIONS(6284),
    [anon_sym_DASH_GT] = ACTIONS(6284),
    [sym_comment] = ACTIONS(91),
  },
  [2731] = {
    [anon_sym_COMMA] = ACTIONS(6291),
    [anon_sym_SEMI] = ACTIONS(6291),
    [anon_sym_LBRACE] = ACTIONS(6291),
    [anon_sym_LPAREN2] = ACTIONS(6291),
    [anon_sym_STAR] = ACTIONS(6293),
    [anon_sym_LBRACK] = ACTIONS(6291),
    [anon_sym_EQ] = ACTIONS(6293),
    [anon_sym_COLON] = ACTIONS(6291),
    [anon_sym_QMARK] = ACTIONS(6291),
    [anon_sym_STAR_EQ] = ACTIONS(6291),
    [anon_sym_SLASH_EQ] = ACTIONS(6291),
    [anon_sym_PERCENT_EQ] = ACTIONS(6291),
    [anon_sym_PLUS_EQ] = ACTIONS(6291),
    [anon_sym_DASH_EQ] = ACTIONS(6291),
    [anon_sym_LT_LT_EQ] = ACTIONS(6291),
    [anon_sym_GT_GT_EQ] = ACTIONS(6291),
    [anon_sym_AMP_EQ] = ACTIONS(6291),
    [anon_sym_CARET_EQ] = ACTIONS(6291),
    [anon_sym_PIPE_EQ] = ACTIONS(6291),
    [anon_sym_AMP] = ACTIONS(6293),
    [anon_sym_PIPE_PIPE] = ACTIONS(6291),
    [anon_sym_AMP_AMP] = ACTIONS(6291),
    [anon_sym_PIPE] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [anon_sym_EQ_EQ] = ACTIONS(6291),
    [anon_sym_BANG_EQ] = ACTIONS(6291),
    [anon_sym_LT] = ACTIONS(6293),
    [anon_sym_GT] = ACTIONS(6293),
    [anon_sym_LT_EQ] = ACTIONS(6291),
    [anon_sym_GT_EQ] = ACTIONS(6291),
    [anon_sym_LT_LT] = ACTIONS(6293),
    [anon_sym_GT_GT] = ACTIONS(6293),
    [anon_sym_PLUS] = ACTIONS(6293),
    [anon_sym_DASH] = ACTIONS(6293),
    [anon_sym_SLASH] = ACTIONS(6293),
    [anon_sym_PERCENT] = ACTIONS(6293),
    [anon_sym_DASH_DASH] = ACTIONS(6291),
    [anon_sym_PLUS_PLUS] = ACTIONS(6291),
    [anon_sym_DOT] = ACTIONS(6291),
    [anon_sym_DASH_GT] = ACTIONS(6291),
    [sym_comment] = ACTIONS(91),
  },
  [2732] = {
    [anon_sym_LPAREN2] = ACTIONS(7069),
    [anon_sym_constexpr] = ACTIONS(7071),
    [sym_comment] = ACTIONS(91),
  },
  [2733] = {
    [sym_parenthesized_expression] = STATE(3119),
    [anon_sym_LPAREN2] = ACTIONS(323),
    [sym_comment] = ACTIONS(91),
  },
  [2734] = {
    [sym__expression] = STATE(3120),
    [sym_conditional_expression] = STATE(3120),
    [sym_assignment_expression] = STATE(3120),
    [sym_pointer_expression] = STATE(3120),
    [sym_logical_expression] = STATE(3120),
    [sym_bitwise_expression] = STATE(3120),
    [sym_equality_expression] = STATE(3120),
    [sym_relational_expression] = STATE(3120),
    [sym_shift_expression] = STATE(3120),
    [sym_math_expression] = STATE(3120),
    [sym_cast_expression] = STATE(3120),
    [sym_sizeof_expression] = STATE(3120),
    [sym_subscript_expression] = STATE(3120),
    [sym_call_expression] = STATE(3120),
    [sym_field_expression] = STATE(3120),
    [sym_compound_literal_expression] = STATE(3120),
    [sym_parenthesized_expression] = STATE(3120),
    [sym_char_literal] = STATE(3120),
    [sym_concatenated_string] = STATE(3120),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3120),
    [sym_new_expression] = STATE(3120),
    [sym_delete_expression] = STATE(3120),
    [sym_lambda_expression] = STATE(3120),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7073),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(7073),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(7075),
    [sym_false] = ACTIONS(7075),
    [sym_null] = ACTIONS(7075),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(7075),
  },
  [2735] = {
    [anon_sym_COLON] = ACTIONS(7077),
    [sym_comment] = ACTIONS(91),
  },
  [2736] = {
    [sym_parenthesized_expression] = STATE(3122),
    [anon_sym_LPAREN2] = ACTIONS(323),
    [sym_comment] = ACTIONS(91),
  },
  [2737] = {
    [anon_sym_LPAREN2] = ACTIONS(7079),
    [sym_comment] = ACTIONS(91),
  },
  [2738] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(548),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_COLON] = ACTIONS(7081),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(935),
  },
  [2739] = {
    [sym_compound_statement] = STATE(3125),
    [anon_sym_LBRACE] = ACTIONS(357),
    [sym_comment] = ACTIONS(91),
  },
  [2740] = {
    [anon_sym_else] = ACTIONS(7083),
    [anon_sym_while] = ACTIONS(6091),
    [sym_comment] = ACTIONS(91),
  },
  [2741] = {
    [sym_compound_statement] = STATE(3127),
    [sym_labeled_statement] = STATE(3127),
    [sym_expression_statement] = STATE(3127),
    [sym_if_statement] = STATE(3127),
    [sym_switch_statement] = STATE(3127),
    [sym_case_statement] = STATE(3127),
    [sym_while_statement] = STATE(3127),
    [sym_do_statement] = STATE(3127),
    [sym_for_statement] = STATE(3127),
    [sym_return_statement] = STATE(3127),
    [sym_break_statement] = STATE(3127),
    [sym_continue_statement] = STATE(3127),
    [sym_goto_statement] = STATE(3127),
    [sym__expression] = STATE(222),
    [sym_comma_expression] = STATE(223),
    [sym_conditional_expression] = STATE(222),
    [sym_assignment_expression] = STATE(222),
    [sym_pointer_expression] = STATE(222),
    [sym_logical_expression] = STATE(222),
    [sym_bitwise_expression] = STATE(222),
    [sym_equality_expression] = STATE(222),
    [sym_relational_expression] = STATE(222),
    [sym_shift_expression] = STATE(222),
    [sym_math_expression] = STATE(222),
    [sym_cast_expression] = STATE(222),
    [sym_sizeof_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_call_expression] = STATE(222),
    [sym_field_expression] = STATE(222),
    [sym_compound_literal_expression] = STATE(222),
    [sym_parenthesized_expression] = STATE(222),
    [sym_char_literal] = STATE(222),
    [sym_concatenated_string] = STATE(222),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(222),
    [sym_for_range_loop] = STATE(3127),
    [sym_try_statement] = STATE(3127),
    [sym_new_expression] = STATE(222),
    [sym_delete_expression] = STATE(222),
    [sym_lambda_expression] = STATE(222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(6119),
    [anon_sym_switch] = ACTIONS(6121),
    [anon_sym_case] = ACTIONS(6123),
    [anon_sym_default] = ACTIONS(6125),
    [anon_sym_while] = ACTIONS(6127),
    [anon_sym_do] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(6129),
    [anon_sym_return] = ACTIONS(373),
    [anon_sym_break] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_goto] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(353),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_identifier] = ACTIONS(6131),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(6133),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(381),
  },
  [2742] = {
    [sym_compound_statement] = STATE(3128),
    [sym_labeled_statement] = STATE(3128),
    [sym_expression_statement] = STATE(3128),
    [sym_if_statement] = STATE(3128),
    [sym_switch_statement] = STATE(3128),
    [sym_case_statement] = STATE(3128),
    [sym_while_statement] = STATE(3128),
    [sym_do_statement] = STATE(3128),
    [sym_for_statement] = STATE(3128),
    [sym_return_statement] = STATE(3128),
    [sym_break_statement] = STATE(3128),
    [sym_continue_statement] = STATE(3128),
    [sym_goto_statement] = STATE(3128),
    [sym__expression] = STATE(222),
    [sym_comma_expression] = STATE(223),
    [sym_conditional_expression] = STATE(222),
    [sym_assignment_expression] = STATE(222),
    [sym_pointer_expression] = STATE(222),
    [sym_logical_expression] = STATE(222),
    [sym_bitwise_expression] = STATE(222),
    [sym_equality_expression] = STATE(222),
    [sym_relational_expression] = STATE(222),
    [sym_shift_expression] = STATE(222),
    [sym_math_expression] = STATE(222),
    [sym_cast_expression] = STATE(222),
    [sym_sizeof_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_call_expression] = STATE(222),
    [sym_field_expression] = STATE(222),
    [sym_compound_literal_expression] = STATE(222),
    [sym_parenthesized_expression] = STATE(222),
    [sym_char_literal] = STATE(222),
    [sym_concatenated_string] = STATE(222),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(222),
    [sym_for_range_loop] = STATE(3128),
    [sym_try_statement] = STATE(3128),
    [sym_new_expression] = STATE(222),
    [sym_delete_expression] = STATE(222),
    [sym_lambda_expression] = STATE(222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(359),
    [anon_sym_switch] = ACTIONS(361),
    [anon_sym_case] = ACTIONS(363),
    [anon_sym_default] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [anon_sym_do] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(373),
    [anon_sym_break] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_goto] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(353),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_identifier] = ACTIONS(383),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(381),
  },
  [2743] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3130),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(7085),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2744] = {
    [sym__expression] = STATE(3131),
    [sym_conditional_expression] = STATE(3131),
    [sym_assignment_expression] = STATE(3131),
    [sym_pointer_expression] = STATE(3131),
    [sym_logical_expression] = STATE(3131),
    [sym_bitwise_expression] = STATE(3131),
    [sym_equality_expression] = STATE(3131),
    [sym_relational_expression] = STATE(3131),
    [sym_shift_expression] = STATE(3131),
    [sym_math_expression] = STATE(3131),
    [sym_cast_expression] = STATE(3131),
    [sym_sizeof_expression] = STATE(3131),
    [sym_subscript_expression] = STATE(3131),
    [sym_call_expression] = STATE(3131),
    [sym_field_expression] = STATE(3131),
    [sym_compound_literal_expression] = STATE(3131),
    [sym_parenthesized_expression] = STATE(3131),
    [sym_char_literal] = STATE(3131),
    [sym_concatenated_string] = STATE(3131),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3131),
    [sym_new_expression] = STATE(3131),
    [sym_delete_expression] = STATE(3131),
    [sym_lambda_expression] = STATE(3131),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7087),
    [anon_sym_RPAREN] = ACTIONS(7085),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(7087),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7089),
    [sym_false] = ACTIONS(7089),
    [sym_null] = ACTIONS(7089),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(7089),
  },
  [2745] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(7091),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2746] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(7093),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2747] = {
    [anon_sym_else] = ACTIONS(6379),
    [anon_sym_while] = ACTIONS(6379),
    [sym_comment] = ACTIONS(91),
    [anon_sym_catch] = ACTIONS(6379),
  },
  [2748] = {
    [sym_raw_string_literal] = ACTIONS(2475),
    [ts_builtin_sym_end] = ACTIONS(2475),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2477),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2477),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2477),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2477),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2477),
    [sym_preproc_directive] = ACTIONS(2477),
    [anon_sym_SEMI] = ACTIONS(2475),
    [anon_sym_typedef] = ACTIONS(2477),
    [anon_sym_extern] = ACTIONS(2477),
    [anon_sym_LBRACE] = ACTIONS(2475),
    [anon_sym_RBRACE] = ACTIONS(2475),
    [anon_sym_LPAREN2] = ACTIONS(2475),
    [anon_sym_STAR] = ACTIONS(2475),
    [anon_sym_LBRACK] = ACTIONS(2475),
    [anon_sym_static] = ACTIONS(2477),
    [anon_sym_register] = ACTIONS(2477),
    [anon_sym_inline] = ACTIONS(2477),
    [anon_sym_const] = ACTIONS(2477),
    [anon_sym_restrict] = ACTIONS(2477),
    [anon_sym_volatile] = ACTIONS(2477),
    [anon_sym__Atomic] = ACTIONS(2477),
    [anon_sym_mutable] = ACTIONS(2477),
    [anon_sym_explicit] = ACTIONS(2477),
    [anon_sym_constexpr] = ACTIONS(2477),
    [anon_sym_unsigned] = ACTIONS(2477),
    [anon_sym_long] = ACTIONS(2477),
    [anon_sym_short] = ACTIONS(2477),
    [sym_primitive_type] = ACTIONS(2477),
    [anon_sym_enum] = ACTIONS(2477),
    [anon_sym_struct] = ACTIONS(2477),
    [anon_sym_union] = ACTIONS(2477),
    [anon_sym_if] = ACTIONS(2477),
    [anon_sym_else] = ACTIONS(2477),
    [anon_sym_switch] = ACTIONS(2477),
    [anon_sym_case] = ACTIONS(2477),
    [anon_sym_default] = ACTIONS(2477),
    [anon_sym_while] = ACTIONS(2477),
    [anon_sym_do] = ACTIONS(2477),
    [anon_sym_for] = ACTIONS(2477),
    [anon_sym_return] = ACTIONS(2477),
    [anon_sym_break] = ACTIONS(2477),
    [anon_sym_continue] = ACTIONS(2477),
    [anon_sym_goto] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2477),
    [anon_sym_AMP_AMP] = ACTIONS(2475),
    [anon_sym_BANG] = ACTIONS(2475),
    [anon_sym_TILDE] = ACTIONS(2475),
    [anon_sym_PLUS] = ACTIONS(2477),
    [anon_sym_DASH] = ACTIONS(2477),
    [anon_sym_DASH_DASH] = ACTIONS(2475),
    [anon_sym_PLUS_PLUS] = ACTIONS(2475),
    [anon_sym_sizeof] = ACTIONS(2477),
    [sym_number_literal] = ACTIONS(2475),
    [anon_sym_SQUOTE] = ACTIONS(2475),
    [anon_sym_DQUOTE] = ACTIONS(2475),
    [sym_true] = ACTIONS(2477),
    [sym_false] = ACTIONS(2477),
    [sym_null] = ACTIONS(2477),
    [sym_identifier] = ACTIONS(2477),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2477),
    [sym_auto] = ACTIONS(2477),
    [anon_sym_typename] = ACTIONS(2477),
    [anon_sym_template] = ACTIONS(2477),
    [anon_sym_delete] = ACTIONS(2477),
    [anon_sym_namespace] = ACTIONS(2477),
    [anon_sym_using] = ACTIONS(2477),
    [anon_sym_try] = ACTIONS(2477),
    [anon_sym_new] = ACTIONS(2477),
    [anon_sym_COLON_COLON] = ACTIONS(2475),
    [sym_operator_name] = ACTIONS(2475),
    [sym_nullptr] = ACTIONS(2477),
  },
  [2749] = {
    [sym_raw_string_literal] = ACTIONS(7095),
    [ts_builtin_sym_end] = ACTIONS(7095),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7097),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7097),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7097),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7097),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7097),
    [sym_preproc_directive] = ACTIONS(7097),
    [anon_sym_SEMI] = ACTIONS(7095),
    [anon_sym_typedef] = ACTIONS(7097),
    [anon_sym_extern] = ACTIONS(7097),
    [anon_sym_LBRACE] = ACTIONS(7095),
    [anon_sym_RBRACE] = ACTIONS(7095),
    [anon_sym_LPAREN2] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7095),
    [anon_sym_LBRACK] = ACTIONS(7095),
    [anon_sym_static] = ACTIONS(7097),
    [anon_sym_register] = ACTIONS(7097),
    [anon_sym_inline] = ACTIONS(7097),
    [anon_sym_const] = ACTIONS(7097),
    [anon_sym_restrict] = ACTIONS(7097),
    [anon_sym_volatile] = ACTIONS(7097),
    [anon_sym__Atomic] = ACTIONS(7097),
    [anon_sym_mutable] = ACTIONS(7097),
    [anon_sym_explicit] = ACTIONS(7097),
    [anon_sym_constexpr] = ACTIONS(7097),
    [anon_sym_unsigned] = ACTIONS(7097),
    [anon_sym_long] = ACTIONS(7097),
    [anon_sym_short] = ACTIONS(7097),
    [sym_primitive_type] = ACTIONS(7097),
    [anon_sym_enum] = ACTIONS(7097),
    [anon_sym_struct] = ACTIONS(7097),
    [anon_sym_union] = ACTIONS(7097),
    [anon_sym_if] = ACTIONS(7097),
    [anon_sym_else] = ACTIONS(7097),
    [anon_sym_switch] = ACTIONS(7097),
    [anon_sym_case] = ACTIONS(7097),
    [anon_sym_default] = ACTIONS(7097),
    [anon_sym_while] = ACTIONS(7097),
    [anon_sym_do] = ACTIONS(7097),
    [anon_sym_for] = ACTIONS(7097),
    [anon_sym_return] = ACTIONS(7097),
    [anon_sym_break] = ACTIONS(7097),
    [anon_sym_continue] = ACTIONS(7097),
    [anon_sym_goto] = ACTIONS(7097),
    [anon_sym_AMP] = ACTIONS(7097),
    [anon_sym_AMP_AMP] = ACTIONS(7095),
    [anon_sym_BANG] = ACTIONS(7095),
    [anon_sym_TILDE] = ACTIONS(7095),
    [anon_sym_PLUS] = ACTIONS(7097),
    [anon_sym_DASH] = ACTIONS(7097),
    [anon_sym_DASH_DASH] = ACTIONS(7095),
    [anon_sym_PLUS_PLUS] = ACTIONS(7095),
    [anon_sym_sizeof] = ACTIONS(7097),
    [sym_number_literal] = ACTIONS(7095),
    [anon_sym_SQUOTE] = ACTIONS(7095),
    [anon_sym_DQUOTE] = ACTIONS(7095),
    [sym_true] = ACTIONS(7097),
    [sym_false] = ACTIONS(7097),
    [sym_null] = ACTIONS(7097),
    [sym_identifier] = ACTIONS(7097),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7097),
    [sym_auto] = ACTIONS(7097),
    [anon_sym_typename] = ACTIONS(7097),
    [anon_sym_template] = ACTIONS(7097),
    [anon_sym_delete] = ACTIONS(7097),
    [anon_sym_namespace] = ACTIONS(7097),
    [anon_sym_using] = ACTIONS(7097),
    [anon_sym_try] = ACTIONS(7097),
    [anon_sym_new] = ACTIONS(7097),
    [anon_sym_COLON_COLON] = ACTIONS(7095),
    [sym_operator_name] = ACTIONS(7095),
    [sym_nullptr] = ACTIONS(7097),
  },
  [2750] = {
    [sym__expression] = STATE(3134),
    [sym_conditional_expression] = STATE(3134),
    [sym_assignment_expression] = STATE(3134),
    [sym_pointer_expression] = STATE(3134),
    [sym_logical_expression] = STATE(3134),
    [sym_bitwise_expression] = STATE(3134),
    [sym_equality_expression] = STATE(3134),
    [sym_relational_expression] = STATE(3134),
    [sym_shift_expression] = STATE(3134),
    [sym_math_expression] = STATE(3134),
    [sym_cast_expression] = STATE(3134),
    [sym_sizeof_expression] = STATE(3134),
    [sym_subscript_expression] = STATE(3134),
    [sym_call_expression] = STATE(3134),
    [sym_field_expression] = STATE(3134),
    [sym_compound_literal_expression] = STATE(3134),
    [sym_parenthesized_expression] = STATE(3134),
    [sym_char_literal] = STATE(3134),
    [sym_concatenated_string] = STATE(3134),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3134),
    [sym_new_expression] = STATE(3134),
    [sym_delete_expression] = STATE(3134),
    [sym_lambda_expression] = STATE(3134),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7099),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(7099),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7101),
    [sym_false] = ACTIONS(7101),
    [sym_null] = ACTIONS(7101),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(7101),
  },
  [2751] = {
    [sym_compound_statement] = STATE(3135),
    [sym_labeled_statement] = STATE(3135),
    [sym_expression_statement] = STATE(3135),
    [sym_if_statement] = STATE(3135),
    [sym_switch_statement] = STATE(3135),
    [sym_case_statement] = STATE(3135),
    [sym_while_statement] = STATE(3135),
    [sym_do_statement] = STATE(3135),
    [sym_for_statement] = STATE(3135),
    [sym_return_statement] = STATE(3135),
    [sym_break_statement] = STATE(3135),
    [sym_continue_statement] = STATE(3135),
    [sym_goto_statement] = STATE(3135),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(3135),
    [sym_try_statement] = STATE(3135),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_switch] = ACTIONS(49),
    [anon_sym_case] = ACTIONS(51),
    [anon_sym_default] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(1115),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(105),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [2752] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(7103),
    [sym_comment] = ACTIONS(91),
  },
  [2753] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3138),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(7103),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2754] = {
    [sym_parameter_list] = STATE(2113),
    [anon_sym_COMMA] = ACTIONS(4126),
    [anon_sym_SEMI] = ACTIONS(4126),
    [anon_sym_LBRACE] = ACTIONS(4126),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(574),
    [anon_sym_EQ] = ACTIONS(4126),
    [anon_sym_COLON] = ACTIONS(4126),
    [sym_comment] = ACTIONS(91),
  },
  [2755] = {
    [sym_type_qualifier] = STATE(3097),
    [sym_virtual_specifier] = STATE(3097),
    [sym_trailing_return_type] = STATE(3097),
    [aux_sym_function_declarator_repeat1] = STATE(3097),
    [anon_sym_COMMA] = ACTIONS(3549),
    [anon_sym_SEMI] = ACTIONS(3549),
    [anon_sym_LBRACE] = ACTIONS(3549),
    [anon_sym_LPAREN2] = ACTIONS(3549),
    [anon_sym_LBRACK] = ACTIONS(3549),
    [anon_sym_EQ] = ACTIONS(3549),
    [anon_sym_const] = ACTIONS(1667),
    [anon_sym_restrict] = ACTIONS(1669),
    [anon_sym_volatile] = ACTIONS(1669),
    [anon_sym__Atomic] = ACTIONS(1669),
    [anon_sym_mutable] = ACTIONS(1669),
    [anon_sym_explicit] = ACTIONS(1669),
    [anon_sym_constexpr] = ACTIONS(1669),
    [anon_sym_COLON] = ACTIONS(3549),
    [anon_sym_DASH_GT] = ACTIONS(6013),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [sym_noexcept] = ACTIONS(7006),
  },
  [2756] = {
    [sym__expression] = STATE(3139),
    [sym_conditional_expression] = STATE(3139),
    [sym_assignment_expression] = STATE(3139),
    [sym_pointer_expression] = STATE(3139),
    [sym_logical_expression] = STATE(3139),
    [sym_bitwise_expression] = STATE(3139),
    [sym_equality_expression] = STATE(3139),
    [sym_relational_expression] = STATE(3139),
    [sym_shift_expression] = STATE(3139),
    [sym_math_expression] = STATE(3139),
    [sym_cast_expression] = STATE(3139),
    [sym_sizeof_expression] = STATE(3139),
    [sym_subscript_expression] = STATE(3139),
    [sym_call_expression] = STATE(3139),
    [sym_field_expression] = STATE(3139),
    [sym_compound_literal_expression] = STATE(3139),
    [sym_parenthesized_expression] = STATE(3139),
    [sym_char_literal] = STATE(3139),
    [sym_concatenated_string] = STATE(3139),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3139),
    [sym_new_expression] = STATE(3139),
    [sym_delete_expression] = STATE(3139),
    [sym_lambda_expression] = STATE(3139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7105),
    [anon_sym_RPAREN] = ACTIONS(7103),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(7105),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7107),
    [sym_false] = ACTIONS(7107),
    [sym_null] = ACTIONS(7107),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(7107),
  },
  [2757] = {
    [sym_compound_statement] = STATE(3140),
    [sym_labeled_statement] = STATE(3140),
    [sym_expression_statement] = STATE(3140),
    [sym_if_statement] = STATE(3140),
    [sym_switch_statement] = STATE(3140),
    [sym_case_statement] = STATE(3140),
    [sym_while_statement] = STATE(3140),
    [sym_do_statement] = STATE(3140),
    [sym_for_statement] = STATE(3140),
    [sym_return_statement] = STATE(3140),
    [sym_break_statement] = STATE(3140),
    [sym_continue_statement] = STATE(3140),
    [sym_goto_statement] = STATE(3140),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(3140),
    [sym_try_statement] = STATE(3140),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_switch] = ACTIONS(49),
    [anon_sym_case] = ACTIONS(51),
    [anon_sym_default] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(1115),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(105),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [2758] = {
    [sym__expression] = STATE(1200),
    [sym_conditional_expression] = STATE(1200),
    [sym_assignment_expression] = STATE(1200),
    [sym_pointer_expression] = STATE(1200),
    [sym_logical_expression] = STATE(1200),
    [sym_bitwise_expression] = STATE(1200),
    [sym_equality_expression] = STATE(1200),
    [sym_relational_expression] = STATE(1200),
    [sym_shift_expression] = STATE(1200),
    [sym_math_expression] = STATE(1200),
    [sym_cast_expression] = STATE(1200),
    [sym_sizeof_expression] = STATE(1200),
    [sym_subscript_expression] = STATE(1200),
    [sym_call_expression] = STATE(1200),
    [sym_field_expression] = STATE(1200),
    [sym_compound_literal_expression] = STATE(1200),
    [sym_parenthesized_expression] = STATE(1200),
    [sym_initializer_list] = STATE(1201),
    [sym_char_literal] = STATE(1200),
    [sym_concatenated_string] = STATE(1200),
    [sym_string_literal] = STATE(727),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1200),
    [sym_new_expression] = STATE(1200),
    [sym_delete_expression] = STATE(1200),
    [sym_lambda_expression] = STATE(1200),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2523),
    [anon_sym_COMMA] = ACTIONS(4689),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_RBRACE] = ACTIONS(4689),
    [anon_sym_LPAREN2] = ACTIONS(1256),
    [anon_sym_STAR] = ACTIONS(7109),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_EQ] = ACTIONS(4693),
    [anon_sym_QMARK] = ACTIONS(4689),
    [anon_sym_STAR_EQ] = ACTIONS(4689),
    [anon_sym_SLASH_EQ] = ACTIONS(4689),
    [anon_sym_PERCENT_EQ] = ACTIONS(4689),
    [anon_sym_PLUS_EQ] = ACTIONS(4689),
    [anon_sym_DASH_EQ] = ACTIONS(4689),
    [anon_sym_LT_LT_EQ] = ACTIONS(4689),
    [anon_sym_GT_GT_EQ] = ACTIONS(4689),
    [anon_sym_AMP_EQ] = ACTIONS(4689),
    [anon_sym_CARET_EQ] = ACTIONS(4689),
    [anon_sym_PIPE_EQ] = ACTIONS(4689),
    [anon_sym_AMP] = ACTIONS(7109),
    [anon_sym_PIPE_PIPE] = ACTIONS(4689),
    [anon_sym_AMP_AMP] = ACTIONS(4689),
    [anon_sym_BANG] = ACTIONS(7111),
    [anon_sym_PIPE] = ACTIONS(4693),
    [anon_sym_CARET] = ACTIONS(4693),
    [anon_sym_TILDE] = ACTIONS(1264),
    [anon_sym_EQ_EQ] = ACTIONS(4689),
    [anon_sym_BANG_EQ] = ACTIONS(4689),
    [anon_sym_LT] = ACTIONS(4693),
    [anon_sym_GT] = ACTIONS(4693),
    [anon_sym_LT_EQ] = ACTIONS(4689),
    [anon_sym_GT_EQ] = ACTIONS(4689),
    [anon_sym_LT_LT] = ACTIONS(4693),
    [anon_sym_GT_GT] = ACTIONS(4693),
    [anon_sym_PLUS] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_SLASH] = ACTIONS(4693),
    [anon_sym_PERCENT] = ACTIONS(4693),
    [anon_sym_DASH_DASH] = ACTIONS(1268),
    [anon_sym_PLUS_PLUS] = ACTIONS(1268),
    [anon_sym_sizeof] = ACTIONS(1270),
    [anon_sym_DOT] = ACTIONS(4689),
    [anon_sym_DASH_GT] = ACTIONS(4689),
    [sym_number_literal] = ACTIONS(2523),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2525),
    [sym_false] = ACTIONS(2525),
    [sym_null] = ACTIONS(2525),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1276),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1280),
    [sym_nullptr] = ACTIONS(2525),
  },
  [2759] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(4927),
    [anon_sym_RBRACE] = ACTIONS(4927),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(4929),
    [anon_sym_QMARK] = ACTIONS(4927),
    [anon_sym_STAR_EQ] = ACTIONS(4927),
    [anon_sym_SLASH_EQ] = ACTIONS(4927),
    [anon_sym_PERCENT_EQ] = ACTIONS(4927),
    [anon_sym_PLUS_EQ] = ACTIONS(4927),
    [anon_sym_DASH_EQ] = ACTIONS(4927),
    [anon_sym_LT_LT_EQ] = ACTIONS(4927),
    [anon_sym_GT_GT_EQ] = ACTIONS(4927),
    [anon_sym_AMP_EQ] = ACTIONS(4927),
    [anon_sym_CARET_EQ] = ACTIONS(4927),
    [anon_sym_PIPE_EQ] = ACTIONS(4927),
    [anon_sym_AMP] = ACTIONS(2959),
    [anon_sym_PIPE_PIPE] = ACTIONS(2961),
    [anon_sym_AMP_AMP] = ACTIONS(2963),
    [anon_sym_PIPE] = ACTIONS(2965),
    [anon_sym_CARET] = ACTIONS(2967),
    [anon_sym_EQ_EQ] = ACTIONS(2969),
    [anon_sym_BANG_EQ] = ACTIONS(2969),
    [anon_sym_LT] = ACTIONS(2971),
    [anon_sym_GT] = ACTIONS(2971),
    [anon_sym_LT_EQ] = ACTIONS(2973),
    [anon_sym_GT_EQ] = ACTIONS(2973),
    [anon_sym_LT_LT] = ACTIONS(2975),
    [anon_sym_GT_GT] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_SLASH] = ACTIONS(2951),
    [anon_sym_PERCENT] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2760] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(7113),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_STAR_EQ] = ACTIONS(3507),
    [anon_sym_SLASH_EQ] = ACTIONS(3507),
    [anon_sym_PERCENT_EQ] = ACTIONS(3507),
    [anon_sym_PLUS_EQ] = ACTIONS(3507),
    [anon_sym_DASH_EQ] = ACTIONS(3507),
    [anon_sym_LT_LT_EQ] = ACTIONS(3507),
    [anon_sym_GT_GT_EQ] = ACTIONS(3507),
    [anon_sym_AMP_EQ] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(3507),
    [anon_sym_PIPE_EQ] = ACTIONS(3507),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_CARET] = ACTIONS(3517),
    [anon_sym_EQ_EQ] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3521),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3525),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2761] = {
    [sym__expression] = STATE(3142),
    [sym_conditional_expression] = STATE(3142),
    [sym_assignment_expression] = STATE(3142),
    [sym_pointer_expression] = STATE(3142),
    [sym_logical_expression] = STATE(3142),
    [sym_bitwise_expression] = STATE(3142),
    [sym_equality_expression] = STATE(3142),
    [sym_relational_expression] = STATE(3142),
    [sym_shift_expression] = STATE(3142),
    [sym_math_expression] = STATE(3142),
    [sym_cast_expression] = STATE(3142),
    [sym_sizeof_expression] = STATE(3142),
    [sym_subscript_expression] = STATE(3142),
    [sym_call_expression] = STATE(3142),
    [sym_field_expression] = STATE(3142),
    [sym_compound_literal_expression] = STATE(3142),
    [sym_parenthesized_expression] = STATE(3142),
    [sym_char_literal] = STATE(3142),
    [sym_concatenated_string] = STATE(3142),
    [sym_string_literal] = STATE(727),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3142),
    [sym_new_expression] = STATE(3142),
    [sym_delete_expression] = STATE(3142),
    [sym_lambda_expression] = STATE(3142),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7115),
    [anon_sym_LPAREN2] = ACTIONS(947),
    [anon_sym_STAR] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(947),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_BANG] = ACTIONS(1262),
    [anon_sym_TILDE] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_DASH_DASH] = ACTIONS(1268),
    [anon_sym_PLUS_PLUS] = ACTIONS(1268),
    [anon_sym_sizeof] = ACTIONS(1270),
    [sym_number_literal] = ACTIONS(7115),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7117),
    [sym_false] = ACTIONS(7117),
    [sym_null] = ACTIONS(7117),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1276),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1280),
    [sym_nullptr] = ACTIONS(7117),
  },
  [2762] = {
    [sym__expression] = STATE(3143),
    [sym_conditional_expression] = STATE(3143),
    [sym_assignment_expression] = STATE(3143),
    [sym_pointer_expression] = STATE(3143),
    [sym_logical_expression] = STATE(3143),
    [sym_bitwise_expression] = STATE(3143),
    [sym_equality_expression] = STATE(3143),
    [sym_relational_expression] = STATE(3143),
    [sym_shift_expression] = STATE(3143),
    [sym_math_expression] = STATE(3143),
    [sym_cast_expression] = STATE(3143),
    [sym_sizeof_expression] = STATE(3143),
    [sym_subscript_expression] = STATE(3143),
    [sym_call_expression] = STATE(3143),
    [sym_field_expression] = STATE(3143),
    [sym_compound_literal_expression] = STATE(3143),
    [sym_parenthesized_expression] = STATE(3143),
    [sym_char_literal] = STATE(3143),
    [sym_concatenated_string] = STATE(3143),
    [sym_string_literal] = STATE(727),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3143),
    [sym_new_expression] = STATE(3143),
    [sym_delete_expression] = STATE(3143),
    [sym_lambda_expression] = STATE(3143),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7119),
    [anon_sym_LPAREN2] = ACTIONS(1256),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(1262),
    [anon_sym_TILDE] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_DASH_DASH] = ACTIONS(1268),
    [anon_sym_PLUS_PLUS] = ACTIONS(1268),
    [anon_sym_sizeof] = ACTIONS(1270),
    [sym_number_literal] = ACTIONS(7119),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7121),
    [sym_false] = ACTIONS(7121),
    [sym_null] = ACTIONS(7121),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1276),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1280),
    [sym_nullptr] = ACTIONS(7121),
  },
  [2763] = {
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_RPAREN] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_RBRACE] = ACTIONS(7123),
    [anon_sym_LPAREN2] = ACTIONS(7123),
    [anon_sym_STAR] = ACTIONS(7125),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [anon_sym_RBRACK] = ACTIONS(7123),
    [anon_sym_EQ] = ACTIONS(7125),
    [anon_sym_COLON] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7125),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7125),
    [anon_sym_CARET] = ACTIONS(7125),
    [anon_sym_EQ_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_LT] = ACTIONS(7125),
    [anon_sym_GT] = ACTIONS(7125),
    [anon_sym_LT_EQ] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7125),
    [anon_sym_GT_GT] = ACTIONS(7125),
    [anon_sym_PLUS] = ACTIONS(7125),
    [anon_sym_DASH] = ACTIONS(7125),
    [anon_sym_SLASH] = ACTIONS(7125),
    [anon_sym_PERCENT] = ACTIONS(7125),
    [anon_sym_DASH_DASH] = ACTIONS(7123),
    [anon_sym_PLUS_PLUS] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7123),
    [anon_sym_DASH_GT] = ACTIONS(7123),
    [sym_comment] = ACTIONS(91),
  },
  [2764] = {
    [sym__expression] = STATE(2126),
    [sym_conditional_expression] = STATE(2126),
    [sym_assignment_expression] = STATE(2126),
    [sym_pointer_expression] = STATE(2126),
    [sym_logical_expression] = STATE(2126),
    [sym_bitwise_expression] = STATE(2126),
    [sym_equality_expression] = STATE(2126),
    [sym_relational_expression] = STATE(2126),
    [sym_shift_expression] = STATE(2126),
    [sym_math_expression] = STATE(2126),
    [sym_cast_expression] = STATE(2126),
    [sym_sizeof_expression] = STATE(2126),
    [sym_subscript_expression] = STATE(2126),
    [sym_call_expression] = STATE(2126),
    [sym_field_expression] = STATE(2126),
    [sym_compound_literal_expression] = STATE(2126),
    [sym_parenthesized_expression] = STATE(2126),
    [sym_initializer_list] = STATE(2127),
    [sym_initializer_pair] = STATE(2127),
    [sym_subscript_designator] = STATE(728),
    [sym_field_designator] = STATE(728),
    [sym_char_literal] = STATE(2126),
    [sym_concatenated_string] = STATE(2126),
    [sym_string_literal] = STATE(727),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2126),
    [sym_new_expression] = STATE(2126),
    [sym_delete_expression] = STATE(2126),
    [sym_lambda_expression] = STATE(2126),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [aux_sym_initializer_pair_repeat1] = STATE(728),
    [sym_raw_string_literal] = ACTIONS(4604),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(1256),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_LBRACK] = ACTIONS(1260),
    [anon_sym_AMP] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(1262),
    [anon_sym_TILDE] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_DASH_DASH] = ACTIONS(1268),
    [anon_sym_PLUS_PLUS] = ACTIONS(1268),
    [anon_sym_sizeof] = ACTIONS(1270),
    [anon_sym_DOT] = ACTIONS(1272),
    [sym_number_literal] = ACTIONS(4604),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4608),
    [sym_false] = ACTIONS(4608),
    [sym_null] = ACTIONS(4608),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1276),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1280),
    [sym_nullptr] = ACTIONS(4608),
  },
  [2765] = {
    [anon_sym_LBRACK] = ACTIONS(6174),
    [anon_sym_EQ] = ACTIONS(6174),
    [anon_sym_DOT] = ACTIONS(6174),
    [sym_comment] = ACTIONS(91),
  },
  [2766] = {
    [sym_new_declarator] = STATE(2861),
    [anon_sym_SEMI] = ACTIONS(6396),
    [anon_sym_LBRACE] = ACTIONS(6396),
    [anon_sym_LPAREN2] = ACTIONS(6396),
    [anon_sym_STAR] = ACTIONS(6398),
    [anon_sym_LBRACK] = ACTIONS(2987),
    [anon_sym_EQ] = ACTIONS(6398),
    [anon_sym_QMARK] = ACTIONS(6396),
    [anon_sym_STAR_EQ] = ACTIONS(6396),
    [anon_sym_SLASH_EQ] = ACTIONS(6396),
    [anon_sym_PERCENT_EQ] = ACTIONS(6396),
    [anon_sym_PLUS_EQ] = ACTIONS(6396),
    [anon_sym_DASH_EQ] = ACTIONS(6396),
    [anon_sym_LT_LT_EQ] = ACTIONS(6396),
    [anon_sym_GT_GT_EQ] = ACTIONS(6396),
    [anon_sym_AMP_EQ] = ACTIONS(6396),
    [anon_sym_CARET_EQ] = ACTIONS(6396),
    [anon_sym_PIPE_EQ] = ACTIONS(6396),
    [anon_sym_AMP] = ACTIONS(6398),
    [anon_sym_PIPE_PIPE] = ACTIONS(6396),
    [anon_sym_AMP_AMP] = ACTIONS(6396),
    [anon_sym_PIPE] = ACTIONS(6398),
    [anon_sym_CARET] = ACTIONS(6398),
    [anon_sym_EQ_EQ] = ACTIONS(6396),
    [anon_sym_BANG_EQ] = ACTIONS(6396),
    [anon_sym_LT] = ACTIONS(6398),
    [anon_sym_GT] = ACTIONS(6398),
    [anon_sym_LT_EQ] = ACTIONS(6396),
    [anon_sym_GT_EQ] = ACTIONS(6396),
    [anon_sym_LT_LT] = ACTIONS(6398),
    [anon_sym_GT_GT] = ACTIONS(6398),
    [anon_sym_PLUS] = ACTIONS(6398),
    [anon_sym_DASH] = ACTIONS(6398),
    [anon_sym_SLASH] = ACTIONS(6398),
    [anon_sym_PERCENT] = ACTIONS(6398),
    [anon_sym_DASH_DASH] = ACTIONS(6396),
    [anon_sym_PLUS_PLUS] = ACTIONS(6396),
    [anon_sym_DOT] = ACTIONS(6396),
    [anon_sym_DASH_GT] = ACTIONS(6396),
    [sym_comment] = ACTIONS(91),
  },
  [2767] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(6404),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(6406),
    [anon_sym_QMARK] = ACTIONS(6404),
    [anon_sym_STAR_EQ] = ACTIONS(6404),
    [anon_sym_SLASH_EQ] = ACTIONS(6404),
    [anon_sym_PERCENT_EQ] = ACTIONS(6404),
    [anon_sym_PLUS_EQ] = ACTIONS(6404),
    [anon_sym_DASH_EQ] = ACTIONS(6404),
    [anon_sym_LT_LT_EQ] = ACTIONS(6404),
    [anon_sym_GT_GT_EQ] = ACTIONS(6404),
    [anon_sym_AMP_EQ] = ACTIONS(6404),
    [anon_sym_CARET_EQ] = ACTIONS(6404),
    [anon_sym_PIPE_EQ] = ACTIONS(6404),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2768] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(6579),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2769] = {
    [sym_argument_list] = STATE(1511),
    [anon_sym_COMMA] = ACTIONS(4169),
    [anon_sym_LPAREN2] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(4171),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_EQ] = ACTIONS(4171),
    [anon_sym_QMARK] = ACTIONS(4169),
    [anon_sym_STAR_EQ] = ACTIONS(4169),
    [anon_sym_SLASH_EQ] = ACTIONS(4169),
    [anon_sym_PERCENT_EQ] = ACTIONS(4169),
    [anon_sym_PLUS_EQ] = ACTIONS(4169),
    [anon_sym_DASH_EQ] = ACTIONS(4169),
    [anon_sym_LT_LT_EQ] = ACTIONS(4169),
    [anon_sym_GT_GT_EQ] = ACTIONS(4169),
    [anon_sym_AMP_EQ] = ACTIONS(4169),
    [anon_sym_CARET_EQ] = ACTIONS(4169),
    [anon_sym_PIPE_EQ] = ACTIONS(4169),
    [anon_sym_AMP] = ACTIONS(4171),
    [anon_sym_PIPE_PIPE] = ACTIONS(4169),
    [anon_sym_AMP_AMP] = ACTIONS(4169),
    [anon_sym_PIPE] = ACTIONS(4171),
    [anon_sym_CARET] = ACTIONS(4171),
    [anon_sym_EQ_EQ] = ACTIONS(4169),
    [anon_sym_BANG_EQ] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4171),
    [anon_sym_GT] = ACTIONS(4171),
    [anon_sym_LT_EQ] = ACTIONS(4169),
    [anon_sym_GT_EQ] = ACTIONS(4169),
    [anon_sym_LT_LT] = ACTIONS(4171),
    [anon_sym_GT_GT] = ACTIONS(4171),
    [anon_sym_PLUS] = ACTIONS(4171),
    [anon_sym_DASH] = ACTIONS(4171),
    [anon_sym_SLASH] = ACTIONS(4171),
    [anon_sym_PERCENT] = ACTIONS(4171),
    [anon_sym_DASH_DASH] = ACTIONS(3197),
    [anon_sym_PLUS_PLUS] = ACTIONS(3197),
    [anon_sym_DOT] = ACTIONS(3199),
    [anon_sym_DASH_GT] = ACTIONS(3199),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(4169),
  },
  [2770] = {
    [anon_sym_COMMA] = ACTIONS(4173),
    [anon_sym_LPAREN2] = ACTIONS(4173),
    [anon_sym_STAR] = ACTIONS(4175),
    [anon_sym_LBRACK] = ACTIONS(4173),
    [anon_sym_EQ] = ACTIONS(4175),
    [anon_sym_QMARK] = ACTIONS(4173),
    [anon_sym_STAR_EQ] = ACTIONS(4173),
    [anon_sym_SLASH_EQ] = ACTIONS(4173),
    [anon_sym_PERCENT_EQ] = ACTIONS(4173),
    [anon_sym_PLUS_EQ] = ACTIONS(4173),
    [anon_sym_DASH_EQ] = ACTIONS(4173),
    [anon_sym_LT_LT_EQ] = ACTIONS(4173),
    [anon_sym_GT_GT_EQ] = ACTIONS(4173),
    [anon_sym_AMP_EQ] = ACTIONS(4173),
    [anon_sym_CARET_EQ] = ACTIONS(4173),
    [anon_sym_PIPE_EQ] = ACTIONS(4173),
    [anon_sym_AMP] = ACTIONS(4175),
    [anon_sym_PIPE_PIPE] = ACTIONS(4173),
    [anon_sym_AMP_AMP] = ACTIONS(4173),
    [anon_sym_PIPE] = ACTIONS(4175),
    [anon_sym_CARET] = ACTIONS(4175),
    [anon_sym_EQ_EQ] = ACTIONS(4173),
    [anon_sym_BANG_EQ] = ACTIONS(4173),
    [anon_sym_LT] = ACTIONS(4175),
    [anon_sym_GT] = ACTIONS(4175),
    [anon_sym_LT_EQ] = ACTIONS(4173),
    [anon_sym_GT_EQ] = ACTIONS(4173),
    [anon_sym_LT_LT] = ACTIONS(4175),
    [anon_sym_GT_GT] = ACTIONS(4175),
    [anon_sym_PLUS] = ACTIONS(4175),
    [anon_sym_DASH] = ACTIONS(4175),
    [anon_sym_SLASH] = ACTIONS(4175),
    [anon_sym_PERCENT] = ACTIONS(4175),
    [anon_sym_DASH_DASH] = ACTIONS(4173),
    [anon_sym_PLUS_PLUS] = ACTIONS(4173),
    [anon_sym_DOT] = ACTIONS(4173),
    [anon_sym_DASH_GT] = ACTIONS(4173),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(4173),
  },
  [2771] = {
    [anon_sym_COMMA] = ACTIONS(3211),
    [anon_sym_LBRACE] = ACTIONS(3218),
    [anon_sym_LPAREN2] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(3211),
    [anon_sym_EQ] = ACTIONS(3223),
    [anon_sym_QMARK] = ACTIONS(3211),
    [anon_sym_STAR_EQ] = ACTIONS(3211),
    [anon_sym_SLASH_EQ] = ACTIONS(3211),
    [anon_sym_PERCENT_EQ] = ACTIONS(3211),
    [anon_sym_PLUS_EQ] = ACTIONS(3211),
    [anon_sym_DASH_EQ] = ACTIONS(3211),
    [anon_sym_LT_LT_EQ] = ACTIONS(3211),
    [anon_sym_GT_GT_EQ] = ACTIONS(3211),
    [anon_sym_AMP_EQ] = ACTIONS(3211),
    [anon_sym_CARET_EQ] = ACTIONS(3211),
    [anon_sym_PIPE_EQ] = ACTIONS(3211),
    [anon_sym_AMP] = ACTIONS(3223),
    [anon_sym_PIPE_PIPE] = ACTIONS(3211),
    [anon_sym_AMP_AMP] = ACTIONS(3211),
    [anon_sym_PIPE] = ACTIONS(3223),
    [anon_sym_CARET] = ACTIONS(3223),
    [anon_sym_EQ_EQ] = ACTIONS(3211),
    [anon_sym_BANG_EQ] = ACTIONS(3211),
    [anon_sym_LT] = ACTIONS(3220),
    [anon_sym_GT] = ACTIONS(3223),
    [anon_sym_LT_EQ] = ACTIONS(3211),
    [anon_sym_GT_EQ] = ACTIONS(3211),
    [anon_sym_LT_LT] = ACTIONS(3223),
    [anon_sym_GT_GT] = ACTIONS(3223),
    [anon_sym_PLUS] = ACTIONS(3223),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_SLASH] = ACTIONS(3223),
    [anon_sym_PERCENT] = ACTIONS(3223),
    [anon_sym_DASH_DASH] = ACTIONS(3211),
    [anon_sym_PLUS_PLUS] = ACTIONS(3211),
    [anon_sym_DOT] = ACTIONS(3211),
    [anon_sym_DASH_GT] = ACTIONS(3211),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3211),
    [anon_sym_COLON_COLON] = ACTIONS(3225),
  },
  [2772] = {
    [anon_sym_COMMA] = ACTIONS(3629),
    [anon_sym_LBRACE] = ACTIONS(3636),
    [anon_sym_LPAREN2] = ACTIONS(3629),
    [anon_sym_STAR] = ACTIONS(3641),
    [anon_sym_LBRACK] = ACTIONS(3629),
    [anon_sym_EQ] = ACTIONS(3641),
    [anon_sym_QMARK] = ACTIONS(3629),
    [anon_sym_STAR_EQ] = ACTIONS(3629),
    [anon_sym_SLASH_EQ] = ACTIONS(3629),
    [anon_sym_PERCENT_EQ] = ACTIONS(3629),
    [anon_sym_PLUS_EQ] = ACTIONS(3629),
    [anon_sym_DASH_EQ] = ACTIONS(3629),
    [anon_sym_LT_LT_EQ] = ACTIONS(3629),
    [anon_sym_GT_GT_EQ] = ACTIONS(3629),
    [anon_sym_AMP_EQ] = ACTIONS(3629),
    [anon_sym_CARET_EQ] = ACTIONS(3629),
    [anon_sym_PIPE_EQ] = ACTIONS(3629),
    [anon_sym_AMP] = ACTIONS(3641),
    [anon_sym_PIPE_PIPE] = ACTIONS(3629),
    [anon_sym_AMP_AMP] = ACTIONS(3629),
    [anon_sym_PIPE] = ACTIONS(3641),
    [anon_sym_CARET] = ACTIONS(3641),
    [anon_sym_EQ_EQ] = ACTIONS(3629),
    [anon_sym_BANG_EQ] = ACTIONS(3629),
    [anon_sym_LT] = ACTIONS(3638),
    [anon_sym_GT] = ACTIONS(3641),
    [anon_sym_LT_EQ] = ACTIONS(3629),
    [anon_sym_GT_EQ] = ACTIONS(3629),
    [anon_sym_LT_LT] = ACTIONS(3641),
    [anon_sym_GT_GT] = ACTIONS(3641),
    [anon_sym_PLUS] = ACTIONS(3641),
    [anon_sym_DASH] = ACTIONS(3641),
    [anon_sym_SLASH] = ACTIONS(3641),
    [anon_sym_PERCENT] = ACTIONS(3641),
    [anon_sym_DASH_DASH] = ACTIONS(3629),
    [anon_sym_PLUS_PLUS] = ACTIONS(3629),
    [anon_sym_DOT] = ACTIONS(3629),
    [anon_sym_DASH_GT] = ACTIONS(3629),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3629),
    [anon_sym_COLON_COLON] = ACTIONS(3643),
  },
  [2773] = {
    [sym__expression] = STATE(2769),
    [sym_conditional_expression] = STATE(2769),
    [sym_assignment_expression] = STATE(2769),
    [sym_pointer_expression] = STATE(2769),
    [sym_logical_expression] = STATE(2769),
    [sym_bitwise_expression] = STATE(2769),
    [sym_equality_expression] = STATE(2769),
    [sym_relational_expression] = STATE(2769),
    [sym_shift_expression] = STATE(2769),
    [sym_math_expression] = STATE(2769),
    [sym_cast_expression] = STATE(2769),
    [sym_sizeof_expression] = STATE(2769),
    [sym_subscript_expression] = STATE(2769),
    [sym_call_expression] = STATE(2769),
    [sym_field_expression] = STATE(2769),
    [sym_compound_literal_expression] = STATE(2769),
    [sym_parenthesized_expression] = STATE(2769),
    [sym_initializer_list] = STATE(2770),
    [sym_char_literal] = STATE(2769),
    [sym_concatenated_string] = STATE(2769),
    [sym_string_literal] = STATE(780),
    [sym_template_type] = STATE(1454),
    [sym_template_function] = STATE(2769),
    [sym_new_expression] = STATE(2769),
    [sym_delete_expression] = STATE(2769),
    [sym_lambda_expression] = STATE(2769),
    [sym_lambda_capture_specifier] = STATE(782),
    [sym_scoped_identifier] = STATE(783),
    [sym_scoped_type_identifier] = STATE(1455),
    [sym_scoped_namespace_identifier] = STATE(1456),
    [sym_raw_string_literal] = ACTIONS(6222),
    [anon_sym_COMMA] = ACTIONS(4689),
    [anon_sym_LBRACE] = ACTIONS(3114),
    [anon_sym_LPAREN2] = ACTIONS(1380),
    [anon_sym_STAR] = ACTIONS(7127),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_EQ] = ACTIONS(4693),
    [anon_sym_QMARK] = ACTIONS(4689),
    [anon_sym_STAR_EQ] = ACTIONS(4689),
    [anon_sym_SLASH_EQ] = ACTIONS(4689),
    [anon_sym_PERCENT_EQ] = ACTIONS(4689),
    [anon_sym_PLUS_EQ] = ACTIONS(4689),
    [anon_sym_DASH_EQ] = ACTIONS(4689),
    [anon_sym_LT_LT_EQ] = ACTIONS(4689),
    [anon_sym_GT_GT_EQ] = ACTIONS(4689),
    [anon_sym_AMP_EQ] = ACTIONS(4689),
    [anon_sym_CARET_EQ] = ACTIONS(4689),
    [anon_sym_PIPE_EQ] = ACTIONS(4689),
    [anon_sym_AMP] = ACTIONS(7127),
    [anon_sym_PIPE_PIPE] = ACTIONS(4689),
    [anon_sym_AMP_AMP] = ACTIONS(4689),
    [anon_sym_BANG] = ACTIONS(7129),
    [anon_sym_PIPE] = ACTIONS(4693),
    [anon_sym_CARET] = ACTIONS(4693),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_EQ_EQ] = ACTIONS(4689),
    [anon_sym_BANG_EQ] = ACTIONS(4689),
    [anon_sym_LT] = ACTIONS(4693),
    [anon_sym_GT] = ACTIONS(4693),
    [anon_sym_LT_EQ] = ACTIONS(4689),
    [anon_sym_GT_EQ] = ACTIONS(4689),
    [anon_sym_LT_LT] = ACTIONS(4693),
    [anon_sym_GT_GT] = ACTIONS(4693),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_SLASH] = ACTIONS(4693),
    [anon_sym_PERCENT] = ACTIONS(4693),
    [anon_sym_DASH_DASH] = ACTIONS(1394),
    [anon_sym_PLUS_PLUS] = ACTIONS(1394),
    [anon_sym_sizeof] = ACTIONS(1396),
    [anon_sym_DOT] = ACTIONS(4689),
    [anon_sym_DASH_GT] = ACTIONS(4689),
    [sym_number_literal] = ACTIONS(6222),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_true] = ACTIONS(6224),
    [sym_false] = ACTIONS(6224),
    [sym_null] = ACTIONS(6224),
    [sym_identifier] = ACTIONS(3084),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(4689),
    [anon_sym_delete] = ACTIONS(1410),
    [anon_sym_new] = ACTIONS(1412),
    [anon_sym_COLON_COLON] = ACTIONS(3086),
    [sym_nullptr] = ACTIONS(6224),
  },
  [2774] = {
    [anon_sym_COMMA] = ACTIONS(4580),
    [anon_sym_LPAREN2] = ACTIONS(4580),
    [anon_sym_STAR] = ACTIONS(4582),
    [anon_sym_LBRACK] = ACTIONS(4580),
    [anon_sym_EQ] = ACTIONS(4582),
    [anon_sym_QMARK] = ACTIONS(4580),
    [anon_sym_STAR_EQ] = ACTIONS(4580),
    [anon_sym_SLASH_EQ] = ACTIONS(4580),
    [anon_sym_PERCENT_EQ] = ACTIONS(4580),
    [anon_sym_PLUS_EQ] = ACTIONS(4580),
    [anon_sym_DASH_EQ] = ACTIONS(4580),
    [anon_sym_LT_LT_EQ] = ACTIONS(4580),
    [anon_sym_GT_GT_EQ] = ACTIONS(4580),
    [anon_sym_AMP_EQ] = ACTIONS(4580),
    [anon_sym_CARET_EQ] = ACTIONS(4580),
    [anon_sym_PIPE_EQ] = ACTIONS(4580),
    [anon_sym_AMP] = ACTIONS(4582),
    [anon_sym_PIPE_PIPE] = ACTIONS(4580),
    [anon_sym_AMP_AMP] = ACTIONS(4580),
    [anon_sym_PIPE] = ACTIONS(4582),
    [anon_sym_CARET] = ACTIONS(4582),
    [anon_sym_EQ_EQ] = ACTIONS(4580),
    [anon_sym_BANG_EQ] = ACTIONS(4580),
    [anon_sym_LT] = ACTIONS(4582),
    [anon_sym_GT] = ACTIONS(4582),
    [anon_sym_LT_EQ] = ACTIONS(4580),
    [anon_sym_GT_EQ] = ACTIONS(4580),
    [anon_sym_LT_LT] = ACTIONS(4582),
    [anon_sym_GT_GT] = ACTIONS(4582),
    [anon_sym_PLUS] = ACTIONS(4582),
    [anon_sym_DASH] = ACTIONS(4582),
    [anon_sym_SLASH] = ACTIONS(4582),
    [anon_sym_PERCENT] = ACTIONS(4582),
    [anon_sym_DASH_DASH] = ACTIONS(4580),
    [anon_sym_PLUS_PLUS] = ACTIONS(4580),
    [anon_sym_DOT] = ACTIONS(4580),
    [anon_sym_DASH_GT] = ACTIONS(4580),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(4580),
  },
  [2775] = {
    [sym__expression] = STATE(2126),
    [sym_conditional_expression] = STATE(2126),
    [sym_assignment_expression] = STATE(2126),
    [sym_pointer_expression] = STATE(2126),
    [sym_logical_expression] = STATE(2126),
    [sym_bitwise_expression] = STATE(2126),
    [sym_equality_expression] = STATE(2126),
    [sym_relational_expression] = STATE(2126),
    [sym_shift_expression] = STATE(2126),
    [sym_math_expression] = STATE(2126),
    [sym_cast_expression] = STATE(2126),
    [sym_sizeof_expression] = STATE(2126),
    [sym_subscript_expression] = STATE(2126),
    [sym_call_expression] = STATE(2126),
    [sym_field_expression] = STATE(2126),
    [sym_compound_literal_expression] = STATE(2126),
    [sym_parenthesized_expression] = STATE(2126),
    [sym_initializer_list] = STATE(2127),
    [sym_initializer_pair] = STATE(2127),
    [sym_subscript_designator] = STATE(728),
    [sym_field_designator] = STATE(728),
    [sym_char_literal] = STATE(2126),
    [sym_concatenated_string] = STATE(2126),
    [sym_string_literal] = STATE(727),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2126),
    [sym_new_expression] = STATE(2126),
    [sym_delete_expression] = STATE(2126),
    [sym_lambda_expression] = STATE(2126),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [aux_sym_initializer_pair_repeat1] = STATE(728),
    [sym_raw_string_literal] = ACTIONS(4604),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_RBRACE] = ACTIONS(7131),
    [anon_sym_LPAREN2] = ACTIONS(1256),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_LBRACK] = ACTIONS(1260),
    [anon_sym_AMP] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(1262),
    [anon_sym_TILDE] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_DASH_DASH] = ACTIONS(1268),
    [anon_sym_PLUS_PLUS] = ACTIONS(1268),
    [anon_sym_sizeof] = ACTIONS(1270),
    [anon_sym_DOT] = ACTIONS(1272),
    [sym_number_literal] = ACTIONS(4604),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4608),
    [sym_false] = ACTIONS(4608),
    [sym_null] = ACTIONS(4608),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1276),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1280),
    [sym_nullptr] = ACTIONS(4608),
  },
  [2776] = {
    [aux_sym_initializer_list_repeat1] = STATE(2140),
    [anon_sym_COMMA] = ACTIONS(7133),
    [anon_sym_RBRACE] = ACTIONS(7131),
    [sym_comment] = ACTIONS(91),
  },
  [2777] = {
    [anon_sym_COMMA] = ACTIONS(4843),
    [anon_sym_LBRACE] = ACTIONS(4843),
    [anon_sym_LPAREN2] = ACTIONS(4843),
    [anon_sym_STAR] = ACTIONS(4845),
    [anon_sym_LBRACK] = ACTIONS(4843),
    [anon_sym_EQ] = ACTIONS(4845),
    [anon_sym_COLON] = ACTIONS(4845),
    [anon_sym_QMARK] = ACTIONS(4843),
    [anon_sym_STAR_EQ] = ACTIONS(4843),
    [anon_sym_SLASH_EQ] = ACTIONS(4843),
    [anon_sym_PERCENT_EQ] = ACTIONS(4843),
    [anon_sym_PLUS_EQ] = ACTIONS(4843),
    [anon_sym_DASH_EQ] = ACTIONS(4843),
    [anon_sym_LT_LT_EQ] = ACTIONS(4843),
    [anon_sym_GT_GT_EQ] = ACTIONS(4843),
    [anon_sym_AMP_EQ] = ACTIONS(4843),
    [anon_sym_CARET_EQ] = ACTIONS(4843),
    [anon_sym_PIPE_EQ] = ACTIONS(4843),
    [anon_sym_AMP] = ACTIONS(4845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4843),
    [anon_sym_AMP_AMP] = ACTIONS(4843),
    [anon_sym_PIPE] = ACTIONS(4845),
    [anon_sym_CARET] = ACTIONS(4845),
    [anon_sym_EQ_EQ] = ACTIONS(4843),
    [anon_sym_BANG_EQ] = ACTIONS(4843),
    [anon_sym_LT] = ACTIONS(4845),
    [anon_sym_GT] = ACTIONS(4845),
    [anon_sym_LT_EQ] = ACTIONS(4843),
    [anon_sym_GT_EQ] = ACTIONS(4843),
    [anon_sym_LT_LT] = ACTIONS(4845),
    [anon_sym_GT_GT] = ACTIONS(4845),
    [anon_sym_PLUS] = ACTIONS(4845),
    [anon_sym_DASH] = ACTIONS(4845),
    [anon_sym_SLASH] = ACTIONS(4845),
    [anon_sym_PERCENT] = ACTIONS(4845),
    [anon_sym_DASH_DASH] = ACTIONS(4843),
    [anon_sym_PLUS_PLUS] = ACTIONS(4843),
    [anon_sym_DOT] = ACTIONS(4843),
    [anon_sym_DASH_GT] = ACTIONS(4843),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4843),
    [anon_sym_override] = ACTIONS(4843),
    [anon_sym_GT2] = ACTIONS(4843),
    [anon_sym_COLON_COLON] = ACTIONS(4843),
  },
  [2778] = {
    [aux_sym_template_argument_list_repeat1] = STATE(2235),
    [anon_sym_COMMA] = ACTIONS(3163),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(7135),
  },
  [2779] = {
    [anon_sym_COMMA] = ACTIONS(4849),
    [anon_sym_LBRACE] = ACTIONS(4849),
    [anon_sym_LPAREN2] = ACTIONS(4849),
    [anon_sym_STAR] = ACTIONS(4851),
    [anon_sym_LBRACK] = ACTIONS(4849),
    [anon_sym_EQ] = ACTIONS(4851),
    [anon_sym_COLON] = ACTIONS(4851),
    [anon_sym_QMARK] = ACTIONS(4849),
    [anon_sym_STAR_EQ] = ACTIONS(4849),
    [anon_sym_SLASH_EQ] = ACTIONS(4849),
    [anon_sym_PERCENT_EQ] = ACTIONS(4849),
    [anon_sym_PLUS_EQ] = ACTIONS(4849),
    [anon_sym_DASH_EQ] = ACTIONS(4849),
    [anon_sym_LT_LT_EQ] = ACTIONS(4849),
    [anon_sym_GT_GT_EQ] = ACTIONS(4849),
    [anon_sym_AMP_EQ] = ACTIONS(4849),
    [anon_sym_CARET_EQ] = ACTIONS(4849),
    [anon_sym_PIPE_EQ] = ACTIONS(4849),
    [anon_sym_AMP] = ACTIONS(4851),
    [anon_sym_PIPE_PIPE] = ACTIONS(4849),
    [anon_sym_AMP_AMP] = ACTIONS(4849),
    [anon_sym_PIPE] = ACTIONS(4851),
    [anon_sym_CARET] = ACTIONS(4851),
    [anon_sym_EQ_EQ] = ACTIONS(4849),
    [anon_sym_BANG_EQ] = ACTIONS(4849),
    [anon_sym_LT] = ACTIONS(4851),
    [anon_sym_GT] = ACTIONS(4851),
    [anon_sym_LT_EQ] = ACTIONS(4849),
    [anon_sym_GT_EQ] = ACTIONS(4849),
    [anon_sym_LT_LT] = ACTIONS(4851),
    [anon_sym_GT_GT] = ACTIONS(4851),
    [anon_sym_PLUS] = ACTIONS(4851),
    [anon_sym_DASH] = ACTIONS(4851),
    [anon_sym_SLASH] = ACTIONS(4851),
    [anon_sym_PERCENT] = ACTIONS(4851),
    [anon_sym_DASH_DASH] = ACTIONS(4849),
    [anon_sym_PLUS_PLUS] = ACTIONS(4849),
    [anon_sym_DOT] = ACTIONS(4849),
    [anon_sym_DASH_GT] = ACTIONS(4849),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4849),
    [anon_sym_override] = ACTIONS(4849),
    [anon_sym_GT2] = ACTIONS(4849),
    [anon_sym_COLON_COLON] = ACTIONS(4849),
  },
  [2780] = {
    [aux_sym_template_argument_list_repeat1] = STATE(2235),
    [anon_sym_COMMA] = ACTIONS(3163),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(7137),
  },
  [2781] = {
    [sym_argument_list] = STATE(1511),
    [anon_sym_COMMA] = ACTIONS(4927),
    [anon_sym_LPAREN2] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_EQ] = ACTIONS(4929),
    [anon_sym_QMARK] = ACTIONS(4927),
    [anon_sym_STAR_EQ] = ACTIONS(4927),
    [anon_sym_SLASH_EQ] = ACTIONS(4927),
    [anon_sym_PERCENT_EQ] = ACTIONS(4927),
    [anon_sym_PLUS_EQ] = ACTIONS(4927),
    [anon_sym_DASH_EQ] = ACTIONS(4927),
    [anon_sym_LT_LT_EQ] = ACTIONS(4927),
    [anon_sym_GT_GT_EQ] = ACTIONS(4927),
    [anon_sym_AMP_EQ] = ACTIONS(4927),
    [anon_sym_CARET_EQ] = ACTIONS(4927),
    [anon_sym_PIPE_EQ] = ACTIONS(4927),
    [anon_sym_AMP] = ACTIONS(3177),
    [anon_sym_PIPE_PIPE] = ACTIONS(3179),
    [anon_sym_AMP_AMP] = ACTIONS(3181),
    [anon_sym_PIPE] = ACTIONS(3183),
    [anon_sym_CARET] = ACTIONS(3185),
    [anon_sym_EQ_EQ] = ACTIONS(3187),
    [anon_sym_BANG_EQ] = ACTIONS(3187),
    [anon_sym_LT] = ACTIONS(3189),
    [anon_sym_GT] = ACTIONS(3189),
    [anon_sym_LT_EQ] = ACTIONS(3191),
    [anon_sym_GT_EQ] = ACTIONS(3191),
    [anon_sym_LT_LT] = ACTIONS(3193),
    [anon_sym_GT_GT] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_SLASH] = ACTIONS(3167),
    [anon_sym_PERCENT] = ACTIONS(3167),
    [anon_sym_DASH_DASH] = ACTIONS(3197),
    [anon_sym_PLUS_PLUS] = ACTIONS(3197),
    [anon_sym_DOT] = ACTIONS(3199),
    [anon_sym_DASH_GT] = ACTIONS(3199),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(4927),
  },
  [2782] = {
    [anon_sym_RBRACE] = ACTIONS(7139),
    [sym_comment] = ACTIONS(91),
  },
  [2783] = {
    [anon_sym_COMMA] = ACTIONS(2613),
    [anon_sym_LBRACE] = ACTIONS(2613),
    [anon_sym_LPAREN2] = ACTIONS(2613),
    [anon_sym_STAR] = ACTIONS(2615),
    [anon_sym_LBRACK] = ACTIONS(2613),
    [anon_sym_EQ] = ACTIONS(2615),
    [anon_sym_QMARK] = ACTIONS(2613),
    [anon_sym_STAR_EQ] = ACTIONS(2613),
    [anon_sym_SLASH_EQ] = ACTIONS(2613),
    [anon_sym_PERCENT_EQ] = ACTIONS(2613),
    [anon_sym_PLUS_EQ] = ACTIONS(2613),
    [anon_sym_DASH_EQ] = ACTIONS(2613),
    [anon_sym_LT_LT_EQ] = ACTIONS(2613),
    [anon_sym_GT_GT_EQ] = ACTIONS(2613),
    [anon_sym_AMP_EQ] = ACTIONS(2613),
    [anon_sym_CARET_EQ] = ACTIONS(2613),
    [anon_sym_PIPE_EQ] = ACTIONS(2613),
    [anon_sym_AMP] = ACTIONS(2615),
    [anon_sym_PIPE_PIPE] = ACTIONS(2613),
    [anon_sym_AMP_AMP] = ACTIONS(2613),
    [anon_sym_PIPE] = ACTIONS(2615),
    [anon_sym_CARET] = ACTIONS(2615),
    [anon_sym_EQ_EQ] = ACTIONS(2613),
    [anon_sym_BANG_EQ] = ACTIONS(2613),
    [anon_sym_LT] = ACTIONS(2615),
    [anon_sym_GT] = ACTIONS(2615),
    [anon_sym_LT_EQ] = ACTIONS(2613),
    [anon_sym_GT_EQ] = ACTIONS(2613),
    [anon_sym_LT_LT] = ACTIONS(2615),
    [anon_sym_GT_GT] = ACTIONS(2615),
    [anon_sym_PLUS] = ACTIONS(2615),
    [anon_sym_DASH] = ACTIONS(2615),
    [anon_sym_SLASH] = ACTIONS(2615),
    [anon_sym_PERCENT] = ACTIONS(2615),
    [anon_sym_DASH_DASH] = ACTIONS(2613),
    [anon_sym_PLUS_PLUS] = ACTIONS(2613),
    [anon_sym_DOT] = ACTIONS(2613),
    [anon_sym_DASH_GT] = ACTIONS(2613),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(2613),
  },
  [2784] = {
    [aux_sym_enumerator_list_repeat1] = STATE(3150),
    [anon_sym_COMMA] = ACTIONS(7141),
    [anon_sym_RBRACE] = ACTIONS(7139),
    [sym_comment] = ACTIONS(91),
  },
  [2785] = {
    [anon_sym_COMMA] = ACTIONS(2623),
    [anon_sym_LBRACE] = ACTIONS(2623),
    [anon_sym_LPAREN2] = ACTIONS(2623),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(2623),
    [anon_sym_EQ] = ACTIONS(2625),
    [anon_sym_QMARK] = ACTIONS(2623),
    [anon_sym_STAR_EQ] = ACTIONS(2623),
    [anon_sym_SLASH_EQ] = ACTIONS(2623),
    [anon_sym_PERCENT_EQ] = ACTIONS(2623),
    [anon_sym_PLUS_EQ] = ACTIONS(2623),
    [anon_sym_DASH_EQ] = ACTIONS(2623),
    [anon_sym_LT_LT_EQ] = ACTIONS(2623),
    [anon_sym_GT_GT_EQ] = ACTIONS(2623),
    [anon_sym_AMP_EQ] = ACTIONS(2623),
    [anon_sym_CARET_EQ] = ACTIONS(2623),
    [anon_sym_PIPE_EQ] = ACTIONS(2623),
    [anon_sym_AMP] = ACTIONS(2625),
    [anon_sym_PIPE_PIPE] = ACTIONS(2623),
    [anon_sym_AMP_AMP] = ACTIONS(2623),
    [anon_sym_PIPE] = ACTIONS(2625),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_EQ_EQ] = ACTIONS(2623),
    [anon_sym_BANG_EQ] = ACTIONS(2623),
    [anon_sym_LT] = ACTIONS(2625),
    [anon_sym_GT] = ACTIONS(2625),
    [anon_sym_LT_EQ] = ACTIONS(2623),
    [anon_sym_GT_EQ] = ACTIONS(2623),
    [anon_sym_LT_LT] = ACTIONS(2625),
    [anon_sym_GT_GT] = ACTIONS(2625),
    [anon_sym_PLUS] = ACTIONS(2625),
    [anon_sym_DASH] = ACTIONS(2625),
    [anon_sym_SLASH] = ACTIONS(2625),
    [anon_sym_PERCENT] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(2623),
    [anon_sym_PLUS_PLUS] = ACTIONS(2623),
    [anon_sym_DOT] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2623),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(2623),
  },
  [2786] = {
    [anon_sym_COMMA] = ACTIONS(2633),
    [anon_sym_LBRACE] = ACTIONS(2633),
    [anon_sym_LPAREN2] = ACTIONS(2633),
    [anon_sym_STAR] = ACTIONS(2635),
    [anon_sym_LBRACK] = ACTIONS(2633),
    [anon_sym_EQ] = ACTIONS(2635),
    [anon_sym_QMARK] = ACTIONS(2633),
    [anon_sym_STAR_EQ] = ACTIONS(2633),
    [anon_sym_SLASH_EQ] = ACTIONS(2633),
    [anon_sym_PERCENT_EQ] = ACTIONS(2633),
    [anon_sym_PLUS_EQ] = ACTIONS(2633),
    [anon_sym_DASH_EQ] = ACTIONS(2633),
    [anon_sym_LT_LT_EQ] = ACTIONS(2633),
    [anon_sym_GT_GT_EQ] = ACTIONS(2633),
    [anon_sym_AMP_EQ] = ACTIONS(2633),
    [anon_sym_CARET_EQ] = ACTIONS(2633),
    [anon_sym_PIPE_EQ] = ACTIONS(2633),
    [anon_sym_AMP] = ACTIONS(2635),
    [anon_sym_PIPE_PIPE] = ACTIONS(2633),
    [anon_sym_AMP_AMP] = ACTIONS(2633),
    [anon_sym_PIPE] = ACTIONS(2635),
    [anon_sym_CARET] = ACTIONS(2635),
    [anon_sym_EQ_EQ] = ACTIONS(2633),
    [anon_sym_BANG_EQ] = ACTIONS(2633),
    [anon_sym_LT] = ACTIONS(2635),
    [anon_sym_GT] = ACTIONS(2635),
    [anon_sym_LT_EQ] = ACTIONS(2633),
    [anon_sym_GT_EQ] = ACTIONS(2633),
    [anon_sym_LT_LT] = ACTIONS(2635),
    [anon_sym_GT_GT] = ACTIONS(2635),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2635),
    [anon_sym_PERCENT] = ACTIONS(2635),
    [anon_sym_DASH_DASH] = ACTIONS(2633),
    [anon_sym_PLUS_PLUS] = ACTIONS(2633),
    [anon_sym_DOT] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(2633),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(2633),
  },
  [2787] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(1276),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(1276),
    [sym_type_definition] = STATE(1276),
    [sym__declaration_specifiers] = STATE(598),
    [sym__declarator] = STATE(599),
    [sym_pointer_declarator] = STATE(599),
    [sym_function_declarator] = STATE(600),
    [sym_array_declarator] = STATE(599),
    [sym_storage_class_specifier] = STATE(605),
    [sym_type_qualifier] = STATE(605),
    [sym__type_specifier] = STATE(601),
    [sym_sized_type_specifier] = STATE(601),
    [sym_enum_specifier] = STATE(601),
    [sym_struct_specifier] = STATE(601),
    [sym_union_specifier] = STATE(601),
    [sym__field_declaration_list_item] = STATE(1276),
    [sym_field_declaration] = STATE(1276),
    [sym_macro_type_specifier] = STATE(601),
    [sym_class_specifier] = STATE(601),
    [sym_dependent_type] = STATE(601),
    [sym_template_declaration] = STATE(1276),
    [sym_inline_method_definition] = STATE(1276),
    [sym_constructor_or_destructor_definition] = STATE(1276),
    [sym_constructor_or_destructor_declaration] = STATE(1276),
    [sym_friend_declaration] = STATE(1276),
    [sym_access_specifier] = STATE(1276),
    [sym_reference_declarator] = STATE(599),
    [sym_template_type] = STATE(602),
    [sym_template_function] = STATE(599),
    [sym_using_declaration] = STATE(1276),
    [sym_alias_declaration] = STATE(1276),
    [sym_destructor_name] = STATE(599),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(603),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(1276),
    [aux_sym__declaration_specifiers_repeat1] = STATE(605),
    [aux_sym_sized_type_specifier_repeat1] = STATE(606),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1019),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1021),
    [anon_sym_typedef] = ACTIONS(1023),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(7143),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(425),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(1027),
    [anon_sym_long] = ACTIONS(1027),
    [anon_sym_short] = ACTIONS(1027),
    [sym_primitive_type] = ACTIONS(1029),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(1031),
    [anon_sym_union] = ACTIONS(1033),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(1035),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1039),
    [sym_auto] = ACTIONS(1029),
    [anon_sym_typename] = ACTIONS(1041),
    [anon_sym_template] = ACTIONS(1043),
    [anon_sym_friend] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1039),
    [anon_sym_protected] = ACTIONS(1039),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_COLON_COLON] = ACTIONS(1049),
    [sym_operator_name] = ACTIONS(1051),
  },
  [2788] = {
    [anon_sym_COMMA] = ACTIONS(2693),
    [anon_sym_LBRACE] = ACTIONS(2693),
    [anon_sym_LPAREN2] = ACTIONS(2693),
    [anon_sym_STAR] = ACTIONS(2695),
    [anon_sym_LBRACK] = ACTIONS(2693),
    [anon_sym_EQ] = ACTIONS(2695),
    [anon_sym_QMARK] = ACTIONS(2693),
    [anon_sym_STAR_EQ] = ACTIONS(2693),
    [anon_sym_SLASH_EQ] = ACTIONS(2693),
    [anon_sym_PERCENT_EQ] = ACTIONS(2693),
    [anon_sym_PLUS_EQ] = ACTIONS(2693),
    [anon_sym_DASH_EQ] = ACTIONS(2693),
    [anon_sym_LT_LT_EQ] = ACTIONS(2693),
    [anon_sym_GT_GT_EQ] = ACTIONS(2693),
    [anon_sym_AMP_EQ] = ACTIONS(2693),
    [anon_sym_CARET_EQ] = ACTIONS(2693),
    [anon_sym_PIPE_EQ] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(2695),
    [anon_sym_PIPE_PIPE] = ACTIONS(2693),
    [anon_sym_AMP_AMP] = ACTIONS(2693),
    [anon_sym_PIPE] = ACTIONS(2695),
    [anon_sym_CARET] = ACTIONS(2695),
    [anon_sym_EQ_EQ] = ACTIONS(2693),
    [anon_sym_BANG_EQ] = ACTIONS(2693),
    [anon_sym_LT] = ACTIONS(2695),
    [anon_sym_GT] = ACTIONS(2695),
    [anon_sym_LT_EQ] = ACTIONS(2693),
    [anon_sym_GT_EQ] = ACTIONS(2693),
    [anon_sym_LT_LT] = ACTIONS(2695),
    [anon_sym_GT_GT] = ACTIONS(2695),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_DASH] = ACTIONS(2695),
    [anon_sym_SLASH] = ACTIONS(2695),
    [anon_sym_PERCENT] = ACTIONS(2695),
    [anon_sym_DASH_DASH] = ACTIONS(2693),
    [anon_sym_PLUS_PLUS] = ACTIONS(2693),
    [anon_sym_DOT] = ACTIONS(2693),
    [anon_sym_DASH_GT] = ACTIONS(2693),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(2693),
  },
  [2789] = {
    [sym_field_declaration_list] = STATE(3152),
    [sym_base_class_clause] = STATE(3153),
    [anon_sym_LBRACE] = ACTIONS(4735),
    [anon_sym_COLON] = ACTIONS(1073),
    [sym_comment] = ACTIONS(91),
  },
  [2790] = {
    [sym_field_declaration_list] = STATE(3152),
    [anon_sym_LBRACE] = ACTIONS(4735),
    [sym_comment] = ACTIONS(91),
  },
  [2791] = {
    [anon_sym_COMMA] = ACTIONS(2697),
    [anon_sym_LBRACE] = ACTIONS(2697),
    [anon_sym_LPAREN2] = ACTIONS(2697),
    [anon_sym_STAR] = ACTIONS(2699),
    [anon_sym_LBRACK] = ACTIONS(2697),
    [anon_sym_EQ] = ACTIONS(2699),
    [anon_sym_QMARK] = ACTIONS(2697),
    [anon_sym_STAR_EQ] = ACTIONS(2697),
    [anon_sym_SLASH_EQ] = ACTIONS(2697),
    [anon_sym_PERCENT_EQ] = ACTIONS(2697),
    [anon_sym_PLUS_EQ] = ACTIONS(2697),
    [anon_sym_DASH_EQ] = ACTIONS(2697),
    [anon_sym_LT_LT_EQ] = ACTIONS(2697),
    [anon_sym_GT_GT_EQ] = ACTIONS(2697),
    [anon_sym_AMP_EQ] = ACTIONS(2697),
    [anon_sym_CARET_EQ] = ACTIONS(2697),
    [anon_sym_PIPE_EQ] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2697),
    [anon_sym_AMP_AMP] = ACTIONS(2697),
    [anon_sym_PIPE] = ACTIONS(2699),
    [anon_sym_CARET] = ACTIONS(2699),
    [anon_sym_EQ_EQ] = ACTIONS(2697),
    [anon_sym_BANG_EQ] = ACTIONS(2697),
    [anon_sym_LT] = ACTIONS(2699),
    [anon_sym_GT] = ACTIONS(2699),
    [anon_sym_LT_EQ] = ACTIONS(2697),
    [anon_sym_GT_EQ] = ACTIONS(2697),
    [anon_sym_LT_LT] = ACTIONS(2699),
    [anon_sym_GT_GT] = ACTIONS(2699),
    [anon_sym_PLUS] = ACTIONS(2699),
    [anon_sym_DASH] = ACTIONS(2699),
    [anon_sym_SLASH] = ACTIONS(2699),
    [anon_sym_PERCENT] = ACTIONS(2699),
    [anon_sym_DASH_DASH] = ACTIONS(2697),
    [anon_sym_PLUS_PLUS] = ACTIONS(2697),
    [anon_sym_DOT] = ACTIONS(2697),
    [anon_sym_DASH_GT] = ACTIONS(2697),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(2697),
  },
  [2792] = {
    [sym_field_declaration_list] = STATE(3154),
    [anon_sym_LBRACE] = ACTIONS(4735),
    [sym_comment] = ACTIONS(91),
  },
  [2793] = {
    [sym_field_declaration_list] = STATE(3154),
    [sym_base_class_clause] = STATE(3155),
    [anon_sym_LBRACE] = ACTIONS(4735),
    [anon_sym_COLON] = ACTIONS(1073),
    [sym_comment] = ACTIONS(91),
  },
  [2794] = {
    [anon_sym_COMMA] = ACTIONS(2703),
    [anon_sym_LBRACE] = ACTIONS(2703),
    [anon_sym_LPAREN2] = ACTIONS(2703),
    [anon_sym_STAR] = ACTIONS(2705),
    [anon_sym_LBRACK] = ACTIONS(2703),
    [anon_sym_EQ] = ACTIONS(2705),
    [anon_sym_QMARK] = ACTIONS(2703),
    [anon_sym_STAR_EQ] = ACTIONS(2703),
    [anon_sym_SLASH_EQ] = ACTIONS(2703),
    [anon_sym_PERCENT_EQ] = ACTIONS(2703),
    [anon_sym_PLUS_EQ] = ACTIONS(2703),
    [anon_sym_DASH_EQ] = ACTIONS(2703),
    [anon_sym_LT_LT_EQ] = ACTIONS(2703),
    [anon_sym_GT_GT_EQ] = ACTIONS(2703),
    [anon_sym_AMP_EQ] = ACTIONS(2703),
    [anon_sym_CARET_EQ] = ACTIONS(2703),
    [anon_sym_PIPE_EQ] = ACTIONS(2703),
    [anon_sym_AMP] = ACTIONS(2705),
    [anon_sym_PIPE_PIPE] = ACTIONS(2703),
    [anon_sym_AMP_AMP] = ACTIONS(2703),
    [anon_sym_PIPE] = ACTIONS(2705),
    [anon_sym_CARET] = ACTIONS(2705),
    [anon_sym_EQ_EQ] = ACTIONS(2703),
    [anon_sym_BANG_EQ] = ACTIONS(2703),
    [anon_sym_LT] = ACTIONS(2705),
    [anon_sym_GT] = ACTIONS(2705),
    [anon_sym_LT_EQ] = ACTIONS(2703),
    [anon_sym_GT_EQ] = ACTIONS(2703),
    [anon_sym_LT_LT] = ACTIONS(2705),
    [anon_sym_GT_GT] = ACTIONS(2705),
    [anon_sym_PLUS] = ACTIONS(2705),
    [anon_sym_DASH] = ACTIONS(2705),
    [anon_sym_SLASH] = ACTIONS(2705),
    [anon_sym_PERCENT] = ACTIONS(2705),
    [anon_sym_DASH_DASH] = ACTIONS(2703),
    [anon_sym_PLUS_PLUS] = ACTIONS(2703),
    [anon_sym_DOT] = ACTIONS(2703),
    [anon_sym_DASH_GT] = ACTIONS(2703),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(2703),
  },
  [2795] = {
    [sym_field_declaration_list] = STATE(3156),
    [sym_base_class_clause] = STATE(3157),
    [anon_sym_LBRACE] = ACTIONS(4735),
    [anon_sym_COLON] = ACTIONS(1073),
    [sym_comment] = ACTIONS(91),
  },
  [2796] = {
    [sym_field_declaration_list] = STATE(3156),
    [anon_sym_LBRACE] = ACTIONS(4735),
    [sym_comment] = ACTIONS(91),
  },
  [2797] = {
    [anon_sym_COMMA] = ACTIONS(2707),
    [anon_sym_LBRACE] = ACTIONS(2707),
    [anon_sym_LPAREN2] = ACTIONS(2707),
    [anon_sym_STAR] = ACTIONS(2709),
    [anon_sym_LBRACK] = ACTIONS(2707),
    [anon_sym_EQ] = ACTIONS(2709),
    [anon_sym_QMARK] = ACTIONS(2707),
    [anon_sym_STAR_EQ] = ACTIONS(2707),
    [anon_sym_SLASH_EQ] = ACTIONS(2707),
    [anon_sym_PERCENT_EQ] = ACTIONS(2707),
    [anon_sym_PLUS_EQ] = ACTIONS(2707),
    [anon_sym_DASH_EQ] = ACTIONS(2707),
    [anon_sym_LT_LT_EQ] = ACTIONS(2707),
    [anon_sym_GT_GT_EQ] = ACTIONS(2707),
    [anon_sym_AMP_EQ] = ACTIONS(2707),
    [anon_sym_CARET_EQ] = ACTIONS(2707),
    [anon_sym_PIPE_EQ] = ACTIONS(2707),
    [anon_sym_AMP] = ACTIONS(2709),
    [anon_sym_PIPE_PIPE] = ACTIONS(2707),
    [anon_sym_AMP_AMP] = ACTIONS(2707),
    [anon_sym_PIPE] = ACTIONS(2709),
    [anon_sym_CARET] = ACTIONS(2709),
    [anon_sym_EQ_EQ] = ACTIONS(2707),
    [anon_sym_BANG_EQ] = ACTIONS(2707),
    [anon_sym_LT] = ACTIONS(2709),
    [anon_sym_GT] = ACTIONS(2709),
    [anon_sym_LT_EQ] = ACTIONS(2707),
    [anon_sym_GT_EQ] = ACTIONS(2707),
    [anon_sym_LT_LT] = ACTIONS(2709),
    [anon_sym_GT_GT] = ACTIONS(2709),
    [anon_sym_PLUS] = ACTIONS(2709),
    [anon_sym_DASH] = ACTIONS(2709),
    [anon_sym_SLASH] = ACTIONS(2709),
    [anon_sym_PERCENT] = ACTIONS(2709),
    [anon_sym_DASH_DASH] = ACTIONS(2707),
    [anon_sym_PLUS_PLUS] = ACTIONS(2707),
    [anon_sym_DOT] = ACTIONS(2707),
    [anon_sym_DASH_GT] = ACTIONS(2707),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(2707),
  },
  [2798] = {
    [sym_field_declaration_list] = STATE(3158),
    [anon_sym_LBRACE] = ACTIONS(4735),
    [sym_comment] = ACTIONS(91),
  },
  [2799] = {
    [sym_field_declaration_list] = STATE(3158),
    [sym_base_class_clause] = STATE(3159),
    [anon_sym_LBRACE] = ACTIONS(4735),
    [anon_sym_COLON] = ACTIONS(1073),
    [sym_comment] = ACTIONS(91),
  },
  [2800] = {
    [anon_sym_COMMA] = ACTIONS(3218),
    [anon_sym_LBRACE] = ACTIONS(3218),
    [anon_sym_LPAREN2] = ACTIONS(3218),
    [anon_sym_STAR] = ACTIONS(3216),
    [anon_sym_LBRACK] = ACTIONS(3218),
    [anon_sym_EQ] = ACTIONS(3216),
    [anon_sym_COLON] = ACTIONS(3216),
    [anon_sym_QMARK] = ACTIONS(3218),
    [anon_sym_STAR_EQ] = ACTIONS(3218),
    [anon_sym_SLASH_EQ] = ACTIONS(3218),
    [anon_sym_PERCENT_EQ] = ACTIONS(3218),
    [anon_sym_PLUS_EQ] = ACTIONS(3218),
    [anon_sym_DASH_EQ] = ACTIONS(3218),
    [anon_sym_LT_LT_EQ] = ACTIONS(3218),
    [anon_sym_GT_GT_EQ] = ACTIONS(3218),
    [anon_sym_AMP_EQ] = ACTIONS(3218),
    [anon_sym_CARET_EQ] = ACTIONS(3218),
    [anon_sym_PIPE_EQ] = ACTIONS(3218),
    [anon_sym_AMP] = ACTIONS(3216),
    [anon_sym_PIPE_PIPE] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(3218),
    [anon_sym_PIPE] = ACTIONS(3216),
    [anon_sym_CARET] = ACTIONS(3216),
    [anon_sym_EQ_EQ] = ACTIONS(3218),
    [anon_sym_BANG_EQ] = ACTIONS(3218),
    [anon_sym_LT] = ACTIONS(3216),
    [anon_sym_GT] = ACTIONS(3216),
    [anon_sym_LT_EQ] = ACTIONS(3218),
    [anon_sym_GT_EQ] = ACTIONS(3218),
    [anon_sym_LT_LT] = ACTIONS(3216),
    [anon_sym_GT_GT] = ACTIONS(3216),
    [anon_sym_PLUS] = ACTIONS(3216),
    [anon_sym_DASH] = ACTIONS(3216),
    [anon_sym_SLASH] = ACTIONS(3216),
    [anon_sym_PERCENT] = ACTIONS(3216),
    [anon_sym_DASH_DASH] = ACTIONS(3218),
    [anon_sym_PLUS_PLUS] = ACTIONS(3218),
    [anon_sym_DOT] = ACTIONS(3218),
    [anon_sym_DASH_GT] = ACTIONS(3218),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3218),
    [anon_sym_override] = ACTIONS(3218),
    [anon_sym_GT2] = ACTIONS(3218),
    [anon_sym_COLON_COLON] = ACTIONS(3225),
  },
  [2801] = {
    [anon_sym_COMMA] = ACTIONS(3227),
    [anon_sym_LBRACE] = ACTIONS(3227),
    [anon_sym_LPAREN2] = ACTIONS(3227),
    [anon_sym_STAR] = ACTIONS(3229),
    [anon_sym_LBRACK] = ACTIONS(3227),
    [anon_sym_EQ] = ACTIONS(3229),
    [anon_sym_QMARK] = ACTIONS(3227),
    [anon_sym_STAR_EQ] = ACTIONS(3227),
    [anon_sym_SLASH_EQ] = ACTIONS(3227),
    [anon_sym_PERCENT_EQ] = ACTIONS(3227),
    [anon_sym_PLUS_EQ] = ACTIONS(3227),
    [anon_sym_DASH_EQ] = ACTIONS(3227),
    [anon_sym_LT_LT_EQ] = ACTIONS(3227),
    [anon_sym_GT_GT_EQ] = ACTIONS(3227),
    [anon_sym_AMP_EQ] = ACTIONS(3227),
    [anon_sym_CARET_EQ] = ACTIONS(3227),
    [anon_sym_PIPE_EQ] = ACTIONS(3227),
    [anon_sym_AMP] = ACTIONS(3229),
    [anon_sym_PIPE_PIPE] = ACTIONS(3227),
    [anon_sym_AMP_AMP] = ACTIONS(3227),
    [anon_sym_PIPE] = ACTIONS(3229),
    [anon_sym_CARET] = ACTIONS(3229),
    [anon_sym_EQ_EQ] = ACTIONS(3227),
    [anon_sym_BANG_EQ] = ACTIONS(3227),
    [anon_sym_LT] = ACTIONS(3229),
    [anon_sym_GT] = ACTIONS(3229),
    [anon_sym_LT_EQ] = ACTIONS(3227),
    [anon_sym_GT_EQ] = ACTIONS(3227),
    [anon_sym_LT_LT] = ACTIONS(3229),
    [anon_sym_GT_GT] = ACTIONS(3229),
    [anon_sym_PLUS] = ACTIONS(3229),
    [anon_sym_DASH] = ACTIONS(3229),
    [anon_sym_SLASH] = ACTIONS(3229),
    [anon_sym_PERCENT] = ACTIONS(3229),
    [anon_sym_DASH_DASH] = ACTIONS(3227),
    [anon_sym_PLUS_PLUS] = ACTIONS(3227),
    [anon_sym_DOT] = ACTIONS(3227),
    [anon_sym_DASH_GT] = ACTIONS(3227),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3227),
  },
  [2802] = {
    [sym_field_declaration_list] = STATE(3160),
    [sym_base_class_clause] = STATE(3161),
    [anon_sym_LBRACE] = ACTIONS(4735),
    [anon_sym_COLON] = ACTIONS(1073),
    [sym_comment] = ACTIONS(91),
  },
  [2803] = {
    [sym_field_declaration_list] = STATE(3160),
    [anon_sym_LBRACE] = ACTIONS(4735),
    [sym_comment] = ACTIONS(91),
  },
  [2804] = {
    [anon_sym_COMMA] = ACTIONS(3231),
    [anon_sym_LBRACE] = ACTIONS(3231),
    [anon_sym_LPAREN2] = ACTIONS(3231),
    [anon_sym_STAR] = ACTIONS(3233),
    [anon_sym_LBRACK] = ACTIONS(3231),
    [anon_sym_EQ] = ACTIONS(3233),
    [anon_sym_QMARK] = ACTIONS(3231),
    [anon_sym_STAR_EQ] = ACTIONS(3231),
    [anon_sym_SLASH_EQ] = ACTIONS(3231),
    [anon_sym_PERCENT_EQ] = ACTIONS(3231),
    [anon_sym_PLUS_EQ] = ACTIONS(3231),
    [anon_sym_DASH_EQ] = ACTIONS(3231),
    [anon_sym_LT_LT_EQ] = ACTIONS(3231),
    [anon_sym_GT_GT_EQ] = ACTIONS(3231),
    [anon_sym_AMP_EQ] = ACTIONS(3231),
    [anon_sym_CARET_EQ] = ACTIONS(3231),
    [anon_sym_PIPE_EQ] = ACTIONS(3231),
    [anon_sym_AMP] = ACTIONS(3233),
    [anon_sym_PIPE_PIPE] = ACTIONS(3231),
    [anon_sym_AMP_AMP] = ACTIONS(3231),
    [anon_sym_PIPE] = ACTIONS(3233),
    [anon_sym_CARET] = ACTIONS(3233),
    [anon_sym_EQ_EQ] = ACTIONS(3231),
    [anon_sym_BANG_EQ] = ACTIONS(3231),
    [anon_sym_LT] = ACTIONS(3233),
    [anon_sym_GT] = ACTIONS(3233),
    [anon_sym_LT_EQ] = ACTIONS(3231),
    [anon_sym_GT_EQ] = ACTIONS(3231),
    [anon_sym_LT_LT] = ACTIONS(3233),
    [anon_sym_GT_GT] = ACTIONS(3233),
    [anon_sym_PLUS] = ACTIONS(3233),
    [anon_sym_DASH] = ACTIONS(3233),
    [anon_sym_SLASH] = ACTIONS(3233),
    [anon_sym_PERCENT] = ACTIONS(3233),
    [anon_sym_DASH_DASH] = ACTIONS(3231),
    [anon_sym_PLUS_PLUS] = ACTIONS(3231),
    [anon_sym_DOT] = ACTIONS(3231),
    [anon_sym_DASH_GT] = ACTIONS(3231),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(3231),
  },
  [2805] = {
    [sym_field_declaration_list] = STATE(3162),
    [anon_sym_LBRACE] = ACTIONS(4735),
    [sym_comment] = ACTIONS(91),
  },
  [2806] = {
    [sym_field_declaration_list] = STATE(3162),
    [sym_base_class_clause] = STATE(3163),
    [anon_sym_LBRACE] = ACTIONS(4735),
    [anon_sym_COLON] = ACTIONS(1073),
    [sym_comment] = ACTIONS(91),
  },
  [2807] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(7145),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_STAR_EQ] = ACTIONS(3507),
    [anon_sym_SLASH_EQ] = ACTIONS(3507),
    [anon_sym_PERCENT_EQ] = ACTIONS(3507),
    [anon_sym_PLUS_EQ] = ACTIONS(3507),
    [anon_sym_DASH_EQ] = ACTIONS(3507),
    [anon_sym_LT_LT_EQ] = ACTIONS(3507),
    [anon_sym_GT_GT_EQ] = ACTIONS(3507),
    [anon_sym_AMP_EQ] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(3507),
    [anon_sym_PIPE_EQ] = ACTIONS(3507),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_CARET] = ACTIONS(3517),
    [anon_sym_EQ_EQ] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3521),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3525),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2808] = {
    [anon_sym_COMMA] = ACTIONS(5018),
    [anon_sym_LPAREN2] = ACTIONS(5018),
    [anon_sym_STAR] = ACTIONS(5020),
    [anon_sym_LBRACK] = ACTIONS(5018),
    [anon_sym_EQ] = ACTIONS(5020),
    [anon_sym_QMARK] = ACTIONS(5018),
    [anon_sym_STAR_EQ] = ACTIONS(5018),
    [anon_sym_SLASH_EQ] = ACTIONS(5018),
    [anon_sym_PERCENT_EQ] = ACTIONS(5018),
    [anon_sym_PLUS_EQ] = ACTIONS(5018),
    [anon_sym_DASH_EQ] = ACTIONS(5018),
    [anon_sym_LT_LT_EQ] = ACTIONS(5018),
    [anon_sym_GT_GT_EQ] = ACTIONS(5018),
    [anon_sym_AMP_EQ] = ACTIONS(5018),
    [anon_sym_CARET_EQ] = ACTIONS(5018),
    [anon_sym_PIPE_EQ] = ACTIONS(5018),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_PIPE_PIPE] = ACTIONS(5018),
    [anon_sym_AMP_AMP] = ACTIONS(5018),
    [anon_sym_PIPE] = ACTIONS(5020),
    [anon_sym_CARET] = ACTIONS(5020),
    [anon_sym_EQ_EQ] = ACTIONS(5018),
    [anon_sym_BANG_EQ] = ACTIONS(5018),
    [anon_sym_LT] = ACTIONS(5020),
    [anon_sym_GT] = ACTIONS(5020),
    [anon_sym_LT_EQ] = ACTIONS(5018),
    [anon_sym_GT_EQ] = ACTIONS(5018),
    [anon_sym_LT_LT] = ACTIONS(5020),
    [anon_sym_GT_GT] = ACTIONS(5020),
    [anon_sym_PLUS] = ACTIONS(5020),
    [anon_sym_DASH] = ACTIONS(5020),
    [anon_sym_SLASH] = ACTIONS(5020),
    [anon_sym_PERCENT] = ACTIONS(5020),
    [anon_sym_DASH_DASH] = ACTIONS(5018),
    [anon_sym_PLUS_PLUS] = ACTIONS(5018),
    [anon_sym_DOT] = ACTIONS(5018),
    [anon_sym_DASH_GT] = ACTIONS(5018),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(5018),
  },
  [2809] = {
    [sym_argument_list] = STATE(3165),
    [sym_initializer_list] = STATE(3165),
    [anon_sym_COMMA] = ACTIONS(5018),
    [anon_sym_LBRACE] = ACTIONS(3114),
    [anon_sym_LPAREN2] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(5020),
    [anon_sym_LBRACK] = ACTIONS(5018),
    [anon_sym_EQ] = ACTIONS(5020),
    [anon_sym_QMARK] = ACTIONS(5018),
    [anon_sym_STAR_EQ] = ACTIONS(5018),
    [anon_sym_SLASH_EQ] = ACTIONS(5018),
    [anon_sym_PERCENT_EQ] = ACTIONS(5018),
    [anon_sym_PLUS_EQ] = ACTIONS(5018),
    [anon_sym_DASH_EQ] = ACTIONS(5018),
    [anon_sym_LT_LT_EQ] = ACTIONS(5018),
    [anon_sym_GT_GT_EQ] = ACTIONS(5018),
    [anon_sym_AMP_EQ] = ACTIONS(5018),
    [anon_sym_CARET_EQ] = ACTIONS(5018),
    [anon_sym_PIPE_EQ] = ACTIONS(5018),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_PIPE_PIPE] = ACTIONS(5018),
    [anon_sym_AMP_AMP] = ACTIONS(5018),
    [anon_sym_PIPE] = ACTIONS(5020),
    [anon_sym_CARET] = ACTIONS(5020),
    [anon_sym_EQ_EQ] = ACTIONS(5018),
    [anon_sym_BANG_EQ] = ACTIONS(5018),
    [anon_sym_LT] = ACTIONS(5020),
    [anon_sym_GT] = ACTIONS(5020),
    [anon_sym_LT_EQ] = ACTIONS(5018),
    [anon_sym_GT_EQ] = ACTIONS(5018),
    [anon_sym_LT_LT] = ACTIONS(5020),
    [anon_sym_GT_GT] = ACTIONS(5020),
    [anon_sym_PLUS] = ACTIONS(5020),
    [anon_sym_DASH] = ACTIONS(5020),
    [anon_sym_SLASH] = ACTIONS(5020),
    [anon_sym_PERCENT] = ACTIONS(5020),
    [anon_sym_DASH_DASH] = ACTIONS(5018),
    [anon_sym_PLUS_PLUS] = ACTIONS(5018),
    [anon_sym_DOT] = ACTIONS(5018),
    [anon_sym_DASH_GT] = ACTIONS(5018),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(5018),
  },
  [2810] = {
    [anon_sym_COMMA] = ACTIONS(3636),
    [anon_sym_LBRACE] = ACTIONS(3636),
    [anon_sym_LPAREN2] = ACTIONS(3636),
    [anon_sym_STAR] = ACTIONS(3634),
    [anon_sym_LBRACK] = ACTIONS(3636),
    [anon_sym_EQ] = ACTIONS(3634),
    [anon_sym_COLON] = ACTIONS(3634),
    [anon_sym_QMARK] = ACTIONS(3636),
    [anon_sym_STAR_EQ] = ACTIONS(3636),
    [anon_sym_SLASH_EQ] = ACTIONS(3636),
    [anon_sym_PERCENT_EQ] = ACTIONS(3636),
    [anon_sym_PLUS_EQ] = ACTIONS(3636),
    [anon_sym_DASH_EQ] = ACTIONS(3636),
    [anon_sym_LT_LT_EQ] = ACTIONS(3636),
    [anon_sym_GT_GT_EQ] = ACTIONS(3636),
    [anon_sym_AMP_EQ] = ACTIONS(3636),
    [anon_sym_CARET_EQ] = ACTIONS(3636),
    [anon_sym_PIPE_EQ] = ACTIONS(3636),
    [anon_sym_AMP] = ACTIONS(3634),
    [anon_sym_PIPE_PIPE] = ACTIONS(3636),
    [anon_sym_AMP_AMP] = ACTIONS(3636),
    [anon_sym_PIPE] = ACTIONS(3634),
    [anon_sym_CARET] = ACTIONS(3634),
    [anon_sym_EQ_EQ] = ACTIONS(3636),
    [anon_sym_BANG_EQ] = ACTIONS(3636),
    [anon_sym_LT] = ACTIONS(3634),
    [anon_sym_GT] = ACTIONS(3634),
    [anon_sym_LT_EQ] = ACTIONS(3636),
    [anon_sym_GT_EQ] = ACTIONS(3636),
    [anon_sym_LT_LT] = ACTIONS(3634),
    [anon_sym_GT_GT] = ACTIONS(3634),
    [anon_sym_PLUS] = ACTIONS(3634),
    [anon_sym_DASH] = ACTIONS(3634),
    [anon_sym_SLASH] = ACTIONS(3634),
    [anon_sym_PERCENT] = ACTIONS(3634),
    [anon_sym_DASH_DASH] = ACTIONS(3636),
    [anon_sym_PLUS_PLUS] = ACTIONS(3636),
    [anon_sym_DOT] = ACTIONS(3636),
    [anon_sym_DASH_GT] = ACTIONS(3636),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3636),
    [anon_sym_override] = ACTIONS(3636),
    [anon_sym_GT2] = ACTIONS(3636),
    [anon_sym_COLON_COLON] = ACTIONS(3643),
  },
  [2811] = {
    [sym__expression] = STATE(3166),
    [sym_conditional_expression] = STATE(3166),
    [sym_assignment_expression] = STATE(3166),
    [sym_pointer_expression] = STATE(3166),
    [sym_logical_expression] = STATE(3166),
    [sym_bitwise_expression] = STATE(3166),
    [sym_equality_expression] = STATE(3166),
    [sym_relational_expression] = STATE(3166),
    [sym_shift_expression] = STATE(3166),
    [sym_math_expression] = STATE(3166),
    [sym_cast_expression] = STATE(3166),
    [sym_sizeof_expression] = STATE(3166),
    [sym_subscript_expression] = STATE(3166),
    [sym_call_expression] = STATE(3166),
    [sym_field_expression] = STATE(3166),
    [sym_compound_literal_expression] = STATE(3166),
    [sym_parenthesized_expression] = STATE(3166),
    [sym_char_literal] = STATE(3166),
    [sym_concatenated_string] = STATE(3166),
    [sym_string_literal] = STATE(780),
    [sym_template_type] = STATE(1454),
    [sym_template_function] = STATE(3166),
    [sym_new_expression] = STATE(3166),
    [sym_delete_expression] = STATE(3166),
    [sym_lambda_expression] = STATE(3166),
    [sym_lambda_capture_specifier] = STATE(782),
    [sym_scoped_identifier] = STATE(783),
    [sym_scoped_type_identifier] = STATE(1455),
    [sym_scoped_namespace_identifier] = STATE(1456),
    [sym_raw_string_literal] = ACTIONS(7147),
    [anon_sym_LPAREN2] = ACTIONS(947),
    [anon_sym_STAR] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(947),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1394),
    [anon_sym_PLUS_PLUS] = ACTIONS(1394),
    [anon_sym_sizeof] = ACTIONS(1396),
    [sym_number_literal] = ACTIONS(7147),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_true] = ACTIONS(7149),
    [sym_false] = ACTIONS(7149),
    [sym_null] = ACTIONS(7149),
    [sym_identifier] = ACTIONS(3084),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1410),
    [anon_sym_new] = ACTIONS(1412),
    [anon_sym_COLON_COLON] = ACTIONS(3086),
    [sym_nullptr] = ACTIONS(7149),
  },
  [2812] = {
    [sym_parameter_list] = STATE(2210),
    [anon_sym_COMMA] = ACTIONS(5889),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(5889),
  },
  [2813] = {
    [sym_type_qualifier] = STATE(2813),
    [aux_sym_type_definition_repeat1] = STATE(2813),
    [anon_sym_COMMA] = ACTIONS(2179),
    [anon_sym_LPAREN2] = ACTIONS(2179),
    [anon_sym_STAR] = ACTIONS(2179),
    [anon_sym_LBRACK] = ACTIONS(2179),
    [anon_sym_const] = ACTIONS(2538),
    [anon_sym_restrict] = ACTIONS(5316),
    [anon_sym_volatile] = ACTIONS(5316),
    [anon_sym__Atomic] = ACTIONS(5316),
    [anon_sym_mutable] = ACTIONS(5316),
    [anon_sym_explicit] = ACTIONS(5316),
    [anon_sym_constexpr] = ACTIONS(5316),
    [anon_sym_AMP] = ACTIONS(2177),
    [anon_sym_AMP_AMP] = ACTIONS(2179),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(2179),
  },
  [2814] = {
    [sym_type_qualifier] = STATE(2816),
    [sym_trailing_return_type] = STATE(2418),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2816),
    [anon_sym_COMMA] = ACTIONS(5331),
    [anon_sym_LPAREN2] = ACTIONS(5331),
    [anon_sym_LBRACK] = ACTIONS(5331),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(4775),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(5331),
    [sym_noexcept] = ACTIONS(6267),
  },
  [2815] = {
    [sym__abstract_declarator] = STATE(3167),
    [sym_abstract_pointer_declarator] = STATE(3167),
    [sym_abstract_function_declarator] = STATE(3167),
    [sym_abstract_array_declarator] = STATE(3167),
    [sym_parameter_list] = STATE(1492),
    [sym_abstract_reference_declarator] = STATE(3167),
    [anon_sym_COMMA] = ACTIONS(5222),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(3157),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_AMP] = ACTIONS(3159),
    [anon_sym_AMP_AMP] = ACTIONS(3161),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(5222),
  },
  [2816] = {
    [sym_type_qualifier] = STATE(2816),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2816),
    [anon_sym_COMMA] = ACTIONS(5351),
    [anon_sym_LPAREN2] = ACTIONS(5351),
    [anon_sym_LBRACK] = ACTIONS(5351),
    [anon_sym_const] = ACTIONS(5353),
    [anon_sym_restrict] = ACTIONS(5356),
    [anon_sym_volatile] = ACTIONS(5356),
    [anon_sym__Atomic] = ACTIONS(5356),
    [anon_sym_mutable] = ACTIONS(5356),
    [anon_sym_explicit] = ACTIONS(5356),
    [anon_sym_constexpr] = ACTIONS(5356),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(5351),
    [sym_noexcept] = ACTIONS(7151),
  },
  [2817] = {
    [anon_sym_COMMA] = ACTIONS(5004),
    [anon_sym_LPAREN2] = ACTIONS(5004),
    [anon_sym_STAR] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(5004),
    [anon_sym_EQ] = ACTIONS(5006),
    [anon_sym_QMARK] = ACTIONS(5004),
    [anon_sym_STAR_EQ] = ACTIONS(5004),
    [anon_sym_SLASH_EQ] = ACTIONS(5004),
    [anon_sym_PERCENT_EQ] = ACTIONS(5004),
    [anon_sym_PLUS_EQ] = ACTIONS(5004),
    [anon_sym_DASH_EQ] = ACTIONS(5004),
    [anon_sym_LT_LT_EQ] = ACTIONS(5004),
    [anon_sym_GT_GT_EQ] = ACTIONS(5004),
    [anon_sym_AMP_EQ] = ACTIONS(5004),
    [anon_sym_CARET_EQ] = ACTIONS(5004),
    [anon_sym_PIPE_EQ] = ACTIONS(5004),
    [anon_sym_AMP] = ACTIONS(5006),
    [anon_sym_PIPE_PIPE] = ACTIONS(5004),
    [anon_sym_AMP_AMP] = ACTIONS(5004),
    [anon_sym_PIPE] = ACTIONS(5006),
    [anon_sym_CARET] = ACTIONS(5006),
    [anon_sym_EQ_EQ] = ACTIONS(5004),
    [anon_sym_BANG_EQ] = ACTIONS(5004),
    [anon_sym_LT] = ACTIONS(5006),
    [anon_sym_GT] = ACTIONS(5006),
    [anon_sym_LT_EQ] = ACTIONS(5004),
    [anon_sym_GT_EQ] = ACTIONS(5004),
    [anon_sym_LT_LT] = ACTIONS(5006),
    [anon_sym_GT_GT] = ACTIONS(5006),
    [anon_sym_PLUS] = ACTIONS(5006),
    [anon_sym_DASH] = ACTIONS(5006),
    [anon_sym_SLASH] = ACTIONS(5006),
    [anon_sym_PERCENT] = ACTIONS(5006),
    [anon_sym_DASH_DASH] = ACTIONS(5004),
    [anon_sym_PLUS_PLUS] = ACTIONS(5004),
    [anon_sym_DOT] = ACTIONS(5004),
    [anon_sym_DASH_GT] = ACTIONS(5004),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(5004),
  },
  [2818] = {
    [aux_sym_argument_list_repeat1] = STATE(2289),
    [anon_sym_COMMA] = ACTIONS(3356),
    [anon_sym_RPAREN] = ACTIONS(7154),
    [sym_comment] = ACTIONS(91),
  },
  [2819] = {
    [anon_sym_COMMA] = ACTIONS(5279),
    [anon_sym_LPAREN2] = ACTIONS(5279),
    [anon_sym_STAR] = ACTIONS(5281),
    [anon_sym_LBRACK] = ACTIONS(5279),
    [anon_sym_EQ] = ACTIONS(5281),
    [anon_sym_QMARK] = ACTIONS(5279),
    [anon_sym_STAR_EQ] = ACTIONS(5279),
    [anon_sym_SLASH_EQ] = ACTIONS(5279),
    [anon_sym_PERCENT_EQ] = ACTIONS(5279),
    [anon_sym_PLUS_EQ] = ACTIONS(5279),
    [anon_sym_DASH_EQ] = ACTIONS(5279),
    [anon_sym_LT_LT_EQ] = ACTIONS(5279),
    [anon_sym_GT_GT_EQ] = ACTIONS(5279),
    [anon_sym_AMP_EQ] = ACTIONS(5279),
    [anon_sym_CARET_EQ] = ACTIONS(5279),
    [anon_sym_PIPE_EQ] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5279),
    [anon_sym_AMP_AMP] = ACTIONS(5279),
    [anon_sym_PIPE] = ACTIONS(5281),
    [anon_sym_CARET] = ACTIONS(5281),
    [anon_sym_EQ_EQ] = ACTIONS(5279),
    [anon_sym_BANG_EQ] = ACTIONS(5279),
    [anon_sym_LT] = ACTIONS(5281),
    [anon_sym_GT] = ACTIONS(5281),
    [anon_sym_LT_EQ] = ACTIONS(5279),
    [anon_sym_GT_EQ] = ACTIONS(5279),
    [anon_sym_LT_LT] = ACTIONS(5281),
    [anon_sym_GT_GT] = ACTIONS(5281),
    [anon_sym_PLUS] = ACTIONS(5281),
    [anon_sym_DASH] = ACTIONS(5281),
    [anon_sym_SLASH] = ACTIONS(5281),
    [anon_sym_PERCENT] = ACTIONS(5281),
    [anon_sym_DASH_DASH] = ACTIONS(5279),
    [anon_sym_PLUS_PLUS] = ACTIONS(5279),
    [anon_sym_DOT] = ACTIONS(5279),
    [anon_sym_DASH_GT] = ACTIONS(5279),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(5279),
  },
  [2820] = {
    [sym__expression] = STATE(3169),
    [sym_conditional_expression] = STATE(3169),
    [sym_assignment_expression] = STATE(3169),
    [sym_pointer_expression] = STATE(3169),
    [sym_logical_expression] = STATE(3169),
    [sym_bitwise_expression] = STATE(3169),
    [sym_equality_expression] = STATE(3169),
    [sym_relational_expression] = STATE(3169),
    [sym_shift_expression] = STATE(3169),
    [sym_math_expression] = STATE(3169),
    [sym_cast_expression] = STATE(3169),
    [sym_sizeof_expression] = STATE(3169),
    [sym_subscript_expression] = STATE(3169),
    [sym_call_expression] = STATE(3169),
    [sym_field_expression] = STATE(3169),
    [sym_compound_literal_expression] = STATE(3169),
    [sym_parenthesized_expression] = STATE(3169),
    [sym_char_literal] = STATE(3169),
    [sym_concatenated_string] = STATE(3169),
    [sym_string_literal] = STATE(780),
    [sym_template_type] = STATE(1454),
    [sym_template_function] = STATE(3169),
    [sym_new_expression] = STATE(3169),
    [sym_delete_expression] = STATE(3169),
    [sym_lambda_expression] = STATE(3169),
    [sym_lambda_capture_specifier] = STATE(782),
    [sym_scoped_identifier] = STATE(783),
    [sym_scoped_type_identifier] = STATE(1455),
    [sym_scoped_namespace_identifier] = STATE(1456),
    [sym_raw_string_literal] = ACTIONS(7156),
    [anon_sym_LPAREN2] = ACTIONS(1380),
    [anon_sym_STAR] = ACTIONS(1382),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1382),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1394),
    [anon_sym_PLUS_PLUS] = ACTIONS(1394),
    [anon_sym_sizeof] = ACTIONS(1396),
    [sym_number_literal] = ACTIONS(7156),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_true] = ACTIONS(7158),
    [sym_false] = ACTIONS(7158),
    [sym_null] = ACTIONS(7158),
    [sym_identifier] = ACTIONS(3084),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1410),
    [anon_sym_new] = ACTIONS(1412),
    [anon_sym_COLON_COLON] = ACTIONS(3086),
    [sym_nullptr] = ACTIONS(7158),
  },
  [2821] = {
    [anon_sym_COMMA] = ACTIONS(5289),
    [anon_sym_LPAREN2] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_LBRACK] = ACTIONS(5289),
    [anon_sym_EQ] = ACTIONS(5291),
    [anon_sym_QMARK] = ACTIONS(5289),
    [anon_sym_STAR_EQ] = ACTIONS(5289),
    [anon_sym_SLASH_EQ] = ACTIONS(5289),
    [anon_sym_PERCENT_EQ] = ACTIONS(5289),
    [anon_sym_PLUS_EQ] = ACTIONS(5289),
    [anon_sym_DASH_EQ] = ACTIONS(5289),
    [anon_sym_LT_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT_GT_EQ] = ACTIONS(5289),
    [anon_sym_AMP_EQ] = ACTIONS(5289),
    [anon_sym_CARET_EQ] = ACTIONS(5289),
    [anon_sym_PIPE_EQ] = ACTIONS(5289),
    [anon_sym_AMP] = ACTIONS(5291),
    [anon_sym_PIPE_PIPE] = ACTIONS(5289),
    [anon_sym_AMP_AMP] = ACTIONS(5289),
    [anon_sym_PIPE] = ACTIONS(5291),
    [anon_sym_CARET] = ACTIONS(5291),
    [anon_sym_EQ_EQ] = ACTIONS(5289),
    [anon_sym_BANG_EQ] = ACTIONS(5289),
    [anon_sym_LT] = ACTIONS(5291),
    [anon_sym_GT] = ACTIONS(5291),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_GT_EQ] = ACTIONS(5289),
    [anon_sym_LT_LT] = ACTIONS(5291),
    [anon_sym_GT_GT] = ACTIONS(5291),
    [anon_sym_PLUS] = ACTIONS(5291),
    [anon_sym_DASH] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5291),
    [anon_sym_PERCENT] = ACTIONS(5291),
    [anon_sym_DASH_DASH] = ACTIONS(5289),
    [anon_sym_PLUS_PLUS] = ACTIONS(5289),
    [anon_sym_DOT] = ACTIONS(5289),
    [anon_sym_DASH_GT] = ACTIONS(5289),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(5289),
    [anon_sym_COLON_COLON] = ACTIONS(1431),
  },
  [2822] = {
    [anon_sym_COMMA] = ACTIONS(5298),
    [anon_sym_LPAREN2] = ACTIONS(5298),
    [anon_sym_STAR] = ACTIONS(5300),
    [anon_sym_LBRACK] = ACTIONS(5298),
    [anon_sym_EQ] = ACTIONS(5300),
    [anon_sym_QMARK] = ACTIONS(5298),
    [anon_sym_STAR_EQ] = ACTIONS(5298),
    [anon_sym_SLASH_EQ] = ACTIONS(5298),
    [anon_sym_PERCENT_EQ] = ACTIONS(5298),
    [anon_sym_PLUS_EQ] = ACTIONS(5298),
    [anon_sym_DASH_EQ] = ACTIONS(5298),
    [anon_sym_LT_LT_EQ] = ACTIONS(5298),
    [anon_sym_GT_GT_EQ] = ACTIONS(5298),
    [anon_sym_AMP_EQ] = ACTIONS(5298),
    [anon_sym_CARET_EQ] = ACTIONS(5298),
    [anon_sym_PIPE_EQ] = ACTIONS(5298),
    [anon_sym_AMP] = ACTIONS(5300),
    [anon_sym_PIPE_PIPE] = ACTIONS(5298),
    [anon_sym_AMP_AMP] = ACTIONS(5298),
    [anon_sym_PIPE] = ACTIONS(5300),
    [anon_sym_CARET] = ACTIONS(5300),
    [anon_sym_EQ_EQ] = ACTIONS(5298),
    [anon_sym_BANG_EQ] = ACTIONS(5298),
    [anon_sym_LT] = ACTIONS(5300),
    [anon_sym_GT] = ACTIONS(5300),
    [anon_sym_LT_EQ] = ACTIONS(5298),
    [anon_sym_GT_EQ] = ACTIONS(5298),
    [anon_sym_LT_LT] = ACTIONS(5300),
    [anon_sym_GT_GT] = ACTIONS(5300),
    [anon_sym_PLUS] = ACTIONS(5300),
    [anon_sym_DASH] = ACTIONS(5300),
    [anon_sym_SLASH] = ACTIONS(5300),
    [anon_sym_PERCENT] = ACTIONS(5300),
    [anon_sym_DASH_DASH] = ACTIONS(5298),
    [anon_sym_PLUS_PLUS] = ACTIONS(5298),
    [anon_sym_DOT] = ACTIONS(5298),
    [anon_sym_DASH_GT] = ACTIONS(5298),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(5298),
  },
  [2823] = {
    [anon_sym_COMMA] = ACTIONS(801),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(801),
    [anon_sym_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(801),
    [anon_sym_STAR_EQ] = ACTIONS(801),
    [anon_sym_SLASH_EQ] = ACTIONS(801),
    [anon_sym_PERCENT_EQ] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(801),
    [anon_sym_DASH_EQ] = ACTIONS(801),
    [anon_sym_LT_LT_EQ] = ACTIONS(801),
    [anon_sym_GT_GT_EQ] = ACTIONS(801),
    [anon_sym_AMP_EQ] = ACTIONS(801),
    [anon_sym_CARET_EQ] = ACTIONS(801),
    [anon_sym_PIPE_EQ] = ACTIONS(801),
    [anon_sym_AMP] = ACTIONS(803),
    [anon_sym_PIPE_PIPE] = ACTIONS(801),
    [anon_sym_AMP_AMP] = ACTIONS(801),
    [anon_sym_PIPE] = ACTIONS(803),
    [anon_sym_CARET] = ACTIONS(803),
    [anon_sym_EQ_EQ] = ACTIONS(801),
    [anon_sym_BANG_EQ] = ACTIONS(801),
    [anon_sym_LT] = ACTIONS(803),
    [anon_sym_GT] = ACTIONS(803),
    [anon_sym_LT_EQ] = ACTIONS(801),
    [anon_sym_GT_EQ] = ACTIONS(801),
    [anon_sym_LT_LT] = ACTIONS(803),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_DASH] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_PERCENT] = ACTIONS(803),
    [anon_sym_DASH_DASH] = ACTIONS(801),
    [anon_sym_PLUS_PLUS] = ACTIONS(801),
    [anon_sym_DOT] = ACTIONS(801),
    [anon_sym_DASH_GT] = ACTIONS(801),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(801),
  },
  [2824] = {
    [sym_preproc_include] = STATE(496),
    [sym_preproc_def] = STATE(496),
    [sym_preproc_function_def] = STATE(496),
    [sym_preproc_call] = STATE(496),
    [sym_preproc_if_in_compound_statement] = STATE(496),
    [sym_preproc_ifdef_in_compound_statement] = STATE(496),
    [sym_declaration] = STATE(496),
    [sym_type_definition] = STATE(496),
    [sym__declaration_specifiers] = STATE(113),
    [sym_compound_statement] = STATE(496),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(496),
    [sym_expression_statement] = STATE(496),
    [sym_if_statement] = STATE(496),
    [sym_switch_statement] = STATE(496),
    [sym_case_statement] = STATE(496),
    [sym_while_statement] = STATE(496),
    [sym_do_statement] = STATE(496),
    [sym_for_statement] = STATE(496),
    [sym_return_statement] = STATE(496),
    [sym_break_statement] = STATE(496),
    [sym_continue_statement] = STATE(496),
    [sym_goto_statement] = STATE(496),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(496),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(496),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(496),
    [sym_try_statement] = STATE(496),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(496),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(157),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(159),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(161),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(163),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(165),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(165),
    [sym_preproc_directive] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_typedef] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_RBRACE] = ACTIONS(7160),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(185),
    [anon_sym_case] = ACTIONS(187),
    [anon_sym_default] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(209),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_nullptr] = ACTIONS(207),
  },
  [2825] = {
    [sym__type_specifier] = STATE(271),
    [sym_sized_type_specifier] = STATE(271),
    [sym_enum_specifier] = STATE(271),
    [sym_struct_specifier] = STATE(271),
    [sym_union_specifier] = STATE(271),
    [sym_macro_type_specifier] = STATE(271),
    [sym_class_specifier] = STATE(271),
    [sym_dependent_type] = STATE(271),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2827),
    [anon_sym_unsigned] = ACTIONS(6308),
    [anon_sym_long] = ACTIONS(6308),
    [anon_sym_short] = ACTIONS(6308),
    [sym_primitive_type] = ACTIONS(490),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(490),
    [anon_sym_typename] = ACTIONS(6312),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [2826] = {
    [anon_sym_COMMA] = ACTIONS(7162),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(7162),
  },
  [2827] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3171),
    [anon_sym_COMMA] = ACTIONS(653),
    [anon_sym_unsigned] = ACTIONS(7164),
    [anon_sym_long] = ACTIONS(7164),
    [anon_sym_short] = ACTIONS(7164),
    [sym_primitive_type] = ACTIONS(659),
    [sym_identifier] = ACTIONS(933),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(653),
  },
  [2828] = {
    [sym__declarator] = STATE(1172),
    [sym__abstract_declarator] = STATE(1971),
    [sym_pointer_declarator] = STATE(1172),
    [sym_abstract_pointer_declarator] = STATE(1971),
    [sym_function_declarator] = STATE(1172),
    [sym_abstract_function_declarator] = STATE(1971),
    [sym_array_declarator] = STATE(1172),
    [sym_abstract_array_declarator] = STATE(1971),
    [sym_type_qualifier] = STATE(3172),
    [sym_parameter_list] = STATE(528),
    [sym_reference_declarator] = STATE(1172),
    [sym_abstract_reference_declarator] = STATE(1971),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(1172),
    [sym_destructor_name] = STATE(1172),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [aux_sym_type_definition_repeat1] = STATE(3172),
    [anon_sym_RPAREN] = ACTIONS(4157),
    [anon_sym_LPAREN2] = ACTIONS(3249),
    [anon_sym_STAR] = ACTIONS(4877),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(4879),
    [anon_sym_AMP_AMP] = ACTIONS(4881),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(431),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(2437),
  },
  [2829] = {
    [sym_parameter_list] = STATE(2254),
    [anon_sym_COMMA] = ACTIONS(4126),
    [anon_sym_LBRACE] = ACTIONS(4126),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(574),
    [anon_sym_EQ] = ACTIONS(4126),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(4126),
  },
  [2830] = {
    [sym_type_qualifier] = STATE(2830),
    [aux_sym_type_definition_repeat1] = STATE(2830),
    [anon_sym_COMMA] = ACTIONS(2179),
    [anon_sym_LPAREN2] = ACTIONS(2179),
    [anon_sym_STAR] = ACTIONS(2179),
    [anon_sym_LBRACK] = ACTIONS(2179),
    [anon_sym_const] = ACTIONS(2538),
    [anon_sym_restrict] = ACTIONS(2538),
    [anon_sym_volatile] = ACTIONS(2538),
    [anon_sym__Atomic] = ACTIONS(2538),
    [anon_sym_mutable] = ACTIONS(2538),
    [anon_sym_explicit] = ACTIONS(2538),
    [anon_sym_constexpr] = ACTIONS(2538),
    [anon_sym_AMP] = ACTIONS(2177),
    [anon_sym_AMP_AMP] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2179),
    [sym_identifier] = ACTIONS(2177),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(2179),
    [anon_sym_COLON_COLON] = ACTIONS(2179),
    [sym_operator_name] = ACTIONS(2179),
  },
  [2831] = {
    [sym_argument_list] = STATE(1511),
    [anon_sym_COMMA] = ACTIONS(5097),
    [anon_sym_LPAREN2] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_EQ] = ACTIONS(3171),
    [anon_sym_QMARK] = ACTIONS(3173),
    [anon_sym_STAR_EQ] = ACTIONS(3175),
    [anon_sym_SLASH_EQ] = ACTIONS(3175),
    [anon_sym_PERCENT_EQ] = ACTIONS(3175),
    [anon_sym_PLUS_EQ] = ACTIONS(3175),
    [anon_sym_DASH_EQ] = ACTIONS(3175),
    [anon_sym_LT_LT_EQ] = ACTIONS(3175),
    [anon_sym_GT_GT_EQ] = ACTIONS(3175),
    [anon_sym_AMP_EQ] = ACTIONS(3175),
    [anon_sym_CARET_EQ] = ACTIONS(3175),
    [anon_sym_PIPE_EQ] = ACTIONS(3175),
    [anon_sym_AMP] = ACTIONS(3177),
    [anon_sym_PIPE_PIPE] = ACTIONS(3179),
    [anon_sym_AMP_AMP] = ACTIONS(3181),
    [anon_sym_PIPE] = ACTIONS(3183),
    [anon_sym_CARET] = ACTIONS(3185),
    [anon_sym_EQ_EQ] = ACTIONS(3187),
    [anon_sym_BANG_EQ] = ACTIONS(3187),
    [anon_sym_LT] = ACTIONS(3189),
    [anon_sym_GT] = ACTIONS(3189),
    [anon_sym_LT_EQ] = ACTIONS(3191),
    [anon_sym_GT_EQ] = ACTIONS(3191),
    [anon_sym_LT_LT] = ACTIONS(3193),
    [anon_sym_GT_GT] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_SLASH] = ACTIONS(3167),
    [anon_sym_PERCENT] = ACTIONS(3167),
    [anon_sym_DASH_DASH] = ACTIONS(3197),
    [anon_sym_PLUS_PLUS] = ACTIONS(3197),
    [anon_sym_DOT] = ACTIONS(3199),
    [anon_sym_DASH_GT] = ACTIONS(3199),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(5097),
  },
  [2832] = {
    [sym__type_specifier] = STATE(3174),
    [sym_sized_type_specifier] = STATE(3174),
    [sym_enum_specifier] = STATE(3174),
    [sym_struct_specifier] = STATE(3174),
    [sym_union_specifier] = STATE(3174),
    [sym_macro_type_specifier] = STATE(3174),
    [sym_class_specifier] = STATE(3174),
    [sym_dependent_type] = STATE(3174),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3175),
    [anon_sym_unsigned] = ACTIONS(7166),
    [anon_sym_long] = ACTIONS(7166),
    [anon_sym_short] = ACTIONS(7166),
    [sym_primitive_type] = ACTIONS(7168),
    [anon_sym_enum] = ACTIONS(3675),
    [anon_sym_struct] = ACTIONS(5103),
    [anon_sym_union] = ACTIONS(5105),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5107),
    [sym_auto] = ACTIONS(7168),
    [anon_sym_typename] = ACTIONS(7170),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [2833] = {
    [sym_type_qualifier] = STATE(3176),
    [sym_virtual_specifier] = STATE(3176),
    [sym_trailing_return_type] = STATE(3176),
    [aux_sym_function_declarator_repeat1] = STATE(3176),
    [anon_sym_COMMA] = ACTIONS(3549),
    [anon_sym_LBRACE] = ACTIONS(3549),
    [anon_sym_LPAREN2] = ACTIONS(3549),
    [anon_sym_LBRACK] = ACTIONS(3549),
    [anon_sym_EQ] = ACTIONS(3549),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(6320),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [anon_sym_GT2] = ACTIONS(3549),
    [sym_noexcept] = ACTIONS(7172),
  },
  [2834] = {
    [sym__abstract_declarator] = STATE(3177),
    [sym_abstract_pointer_declarator] = STATE(3177),
    [sym_abstract_function_declarator] = STATE(3177),
    [sym_abstract_array_declarator] = STATE(3177),
    [sym_type_qualifier] = STATE(3178),
    [sym_parameter_list] = STATE(2837),
    [sym_abstract_reference_declarator] = STATE(3177),
    [aux_sym_type_definition_repeat1] = STATE(3178),
    [anon_sym_SEMI] = ACTIONS(2461),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(6338),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(6340),
    [anon_sym_AMP_AMP] = ACTIONS(6342),
    [anon_sym_DASH_GT] = ACTIONS(2461),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2461),
    [anon_sym_override] = ACTIONS(2461),
    [sym_noexcept] = ACTIONS(2461),
  },
  [2835] = {
    [sym__abstract_declarator] = STATE(3179),
    [sym_abstract_pointer_declarator] = STATE(3179),
    [sym_abstract_function_declarator] = STATE(3179),
    [sym_abstract_array_declarator] = STATE(3179),
    [sym_parameter_list] = STATE(2837),
    [sym_abstract_reference_declarator] = STATE(3179),
    [anon_sym_SEMI] = ACTIONS(2463),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(6338),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_const] = ACTIONS(6555),
    [anon_sym_restrict] = ACTIONS(2463),
    [anon_sym_volatile] = ACTIONS(2463),
    [anon_sym__Atomic] = ACTIONS(2463),
    [anon_sym_mutable] = ACTIONS(2463),
    [anon_sym_explicit] = ACTIONS(2463),
    [anon_sym_constexpr] = ACTIONS(2463),
    [anon_sym_AMP] = ACTIONS(6340),
    [anon_sym_AMP_AMP] = ACTIONS(6342),
    [anon_sym_DASH_GT] = ACTIONS(2463),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2463),
    [anon_sym_override] = ACTIONS(2463),
    [sym_noexcept] = ACTIONS(2463),
  },
  [2836] = {
    [sym_parameter_list] = STATE(3180),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_const] = ACTIONS(6559),
    [anon_sym_restrict] = ACTIONS(6557),
    [anon_sym_volatile] = ACTIONS(6557),
    [anon_sym__Atomic] = ACTIONS(6557),
    [anon_sym_mutable] = ACTIONS(6557),
    [anon_sym_explicit] = ACTIONS(6557),
    [anon_sym_constexpr] = ACTIONS(6557),
    [anon_sym_DASH_GT] = ACTIONS(6557),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(6557),
    [anon_sym_override] = ACTIONS(6557),
    [sym_noexcept] = ACTIONS(6557),
  },
  [2837] = {
    [sym_type_qualifier] = STATE(3181),
    [sym_trailing_return_type] = STATE(971),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3181),
    [anon_sym_SEMI] = ACTIONS(1787),
    [anon_sym_LPAREN2] = ACTIONS(1787),
    [anon_sym_LBRACK] = ACTIONS(1787),
    [anon_sym_const] = ACTIONS(6561),
    [anon_sym_restrict] = ACTIONS(1787),
    [anon_sym_volatile] = ACTIONS(1787),
    [anon_sym__Atomic] = ACTIONS(1787),
    [anon_sym_mutable] = ACTIONS(1787),
    [anon_sym_explicit] = ACTIONS(1787),
    [anon_sym_constexpr] = ACTIONS(1787),
    [anon_sym_DASH_GT] = ACTIONS(1787),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1787),
    [anon_sym_override] = ACTIONS(1787),
    [sym_noexcept] = ACTIONS(1787),
  },
  [2838] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2838),
    [anon_sym_SEMI] = ACTIONS(1985),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1985),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1987),
    [anon_sym_restrict] = ACTIONS(1987),
    [anon_sym_volatile] = ACTIONS(1987),
    [anon_sym__Atomic] = ACTIONS(1987),
    [anon_sym_mutable] = ACTIONS(1987),
    [anon_sym_explicit] = ACTIONS(1987),
    [anon_sym_constexpr] = ACTIONS(1987),
    [anon_sym_unsigned] = ACTIONS(7174),
    [anon_sym_long] = ACTIONS(7174),
    [anon_sym_short] = ACTIONS(7174),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_DASH_GT] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1987),
    [anon_sym_override] = ACTIONS(1987),
    [sym_noexcept] = ACTIONS(1987),
  },
  [2839] = {
    [sym_compound_statement] = STATE(3190),
    [sym_labeled_statement] = STATE(3190),
    [sym_expression_statement] = STATE(3190),
    [sym_if_statement] = STATE(3190),
    [sym_switch_statement] = STATE(3190),
    [sym_case_statement] = STATE(3190),
    [sym_while_statement] = STATE(3190),
    [sym_do_statement] = STATE(3190),
    [sym_for_statement] = STATE(3190),
    [sym_return_statement] = STATE(3190),
    [sym_break_statement] = STATE(3190),
    [sym_continue_statement] = STATE(3190),
    [sym_goto_statement] = STATE(3190),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(3190),
    [sym_try_statement] = STATE(3190),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7177),
    [anon_sym_switch] = ACTIONS(7179),
    [anon_sym_case] = ACTIONS(7181),
    [anon_sym_default] = ACTIONS(7183),
    [anon_sym_while] = ACTIONS(7185),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(7187),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(7189),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7191),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [2840] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(7193),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2841] = {
    [sym__expression] = STATE(3193),
    [sym_conditional_expression] = STATE(3193),
    [sym_assignment_expression] = STATE(3193),
    [sym_pointer_expression] = STATE(3193),
    [sym_logical_expression] = STATE(3193),
    [sym_bitwise_expression] = STATE(3193),
    [sym_equality_expression] = STATE(3193),
    [sym_relational_expression] = STATE(3193),
    [sym_shift_expression] = STATE(3193),
    [sym_math_expression] = STATE(3193),
    [sym_cast_expression] = STATE(3193),
    [sym_sizeof_expression] = STATE(3193),
    [sym_subscript_expression] = STATE(3193),
    [sym_call_expression] = STATE(3193),
    [sym_field_expression] = STATE(3193),
    [sym_compound_literal_expression] = STATE(3193),
    [sym_parenthesized_expression] = STATE(3193),
    [sym_char_literal] = STATE(3193),
    [sym_concatenated_string] = STATE(3193),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3193),
    [sym_new_expression] = STATE(3193),
    [sym_delete_expression] = STATE(3193),
    [sym_lambda_expression] = STATE(3193),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7195),
    [anon_sym_RPAREN] = ACTIONS(7197),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(7195),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7199),
    [sym_false] = ACTIONS(7199),
    [sym_null] = ACTIONS(7199),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(7199),
  },
  [2842] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(7201),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2843] = {
    [sym__expression] = STATE(3195),
    [sym_conditional_expression] = STATE(3195),
    [sym_assignment_expression] = STATE(3195),
    [sym_pointer_expression] = STATE(3195),
    [sym_logical_expression] = STATE(3195),
    [sym_bitwise_expression] = STATE(3195),
    [sym_equality_expression] = STATE(3195),
    [sym_relational_expression] = STATE(3195),
    [sym_shift_expression] = STATE(3195),
    [sym_math_expression] = STATE(3195),
    [sym_cast_expression] = STATE(3195),
    [sym_sizeof_expression] = STATE(3195),
    [sym_subscript_expression] = STATE(3195),
    [sym_call_expression] = STATE(3195),
    [sym_field_expression] = STATE(3195),
    [sym_compound_literal_expression] = STATE(3195),
    [sym_parenthesized_expression] = STATE(3195),
    [sym_char_literal] = STATE(3195),
    [sym_concatenated_string] = STATE(3195),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3195),
    [sym_new_expression] = STATE(3195),
    [sym_delete_expression] = STATE(3195),
    [sym_lambda_expression] = STATE(3195),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7203),
    [anon_sym_SEMI] = ACTIONS(7201),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(7203),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7205),
    [sym_false] = ACTIONS(7205),
    [sym_null] = ACTIONS(7205),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(7205),
  },
  [2844] = {
    [sym__expression] = STATE(3196),
    [sym_conditional_expression] = STATE(3196),
    [sym_assignment_expression] = STATE(3196),
    [sym_pointer_expression] = STATE(3196),
    [sym_logical_expression] = STATE(3196),
    [sym_bitwise_expression] = STATE(3196),
    [sym_equality_expression] = STATE(3196),
    [sym_relational_expression] = STATE(3196),
    [sym_shift_expression] = STATE(3196),
    [sym_math_expression] = STATE(3196),
    [sym_cast_expression] = STATE(3196),
    [sym_sizeof_expression] = STATE(3196),
    [sym_subscript_expression] = STATE(3196),
    [sym_call_expression] = STATE(3196),
    [sym_field_expression] = STATE(3196),
    [sym_compound_literal_expression] = STATE(3196),
    [sym_parenthesized_expression] = STATE(3196),
    [sym_char_literal] = STATE(3196),
    [sym_concatenated_string] = STATE(3196),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3196),
    [sym_new_expression] = STATE(3196),
    [sym_delete_expression] = STATE(3196),
    [sym_lambda_expression] = STATE(3196),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7207),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(7207),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7209),
    [sym_false] = ACTIONS(7209),
    [sym_null] = ACTIONS(7209),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(7209),
  },
  [2845] = {
    [sym_catch_clause] = STATE(2845),
    [aux_sym_try_statement_repeat1] = STATE(2845),
    [sym_raw_string_literal] = ACTIONS(4993),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4995),
    [sym_preproc_directive] = ACTIONS(4995),
    [anon_sym_SEMI] = ACTIONS(4993),
    [anon_sym_typedef] = ACTIONS(4995),
    [anon_sym_extern] = ACTIONS(4995),
    [anon_sym_LBRACE] = ACTIONS(4993),
    [anon_sym_RBRACE] = ACTIONS(4993),
    [anon_sym_LPAREN2] = ACTIONS(4993),
    [anon_sym_STAR] = ACTIONS(4993),
    [anon_sym_LBRACK] = ACTIONS(4993),
    [anon_sym_static] = ACTIONS(4995),
    [anon_sym_register] = ACTIONS(4995),
    [anon_sym_inline] = ACTIONS(4995),
    [anon_sym_const] = ACTIONS(4995),
    [anon_sym_restrict] = ACTIONS(4995),
    [anon_sym_volatile] = ACTIONS(4995),
    [anon_sym__Atomic] = ACTIONS(4995),
    [anon_sym_mutable] = ACTIONS(4995),
    [anon_sym_explicit] = ACTIONS(4995),
    [anon_sym_constexpr] = ACTIONS(4995),
    [anon_sym_unsigned] = ACTIONS(4995),
    [anon_sym_long] = ACTIONS(4995),
    [anon_sym_short] = ACTIONS(4995),
    [sym_primitive_type] = ACTIONS(4995),
    [anon_sym_enum] = ACTIONS(4995),
    [anon_sym_struct] = ACTIONS(4995),
    [anon_sym_union] = ACTIONS(4995),
    [anon_sym_if] = ACTIONS(4995),
    [anon_sym_switch] = ACTIONS(4995),
    [anon_sym_case] = ACTIONS(4995),
    [anon_sym_default] = ACTIONS(4995),
    [anon_sym_while] = ACTIONS(4995),
    [anon_sym_do] = ACTIONS(4995),
    [anon_sym_for] = ACTIONS(4995),
    [anon_sym_return] = ACTIONS(4995),
    [anon_sym_break] = ACTIONS(4995),
    [anon_sym_continue] = ACTIONS(4995),
    [anon_sym_goto] = ACTIONS(4995),
    [anon_sym_AMP] = ACTIONS(4995),
    [anon_sym_AMP_AMP] = ACTIONS(4993),
    [anon_sym_BANG] = ACTIONS(4993),
    [anon_sym_TILDE] = ACTIONS(4993),
    [anon_sym_PLUS] = ACTIONS(4995),
    [anon_sym_DASH] = ACTIONS(4995),
    [anon_sym_DASH_DASH] = ACTIONS(4993),
    [anon_sym_PLUS_PLUS] = ACTIONS(4993),
    [anon_sym_sizeof] = ACTIONS(4995),
    [sym_number_literal] = ACTIONS(4993),
    [anon_sym_SQUOTE] = ACTIONS(4993),
    [anon_sym_DQUOTE] = ACTIONS(4993),
    [sym_true] = ACTIONS(4995),
    [sym_false] = ACTIONS(4995),
    [sym_null] = ACTIONS(4995),
    [sym_identifier] = ACTIONS(4995),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4995),
    [sym_auto] = ACTIONS(4995),
    [anon_sym_typename] = ACTIONS(4995),
    [anon_sym_template] = ACTIONS(4995),
    [anon_sym_delete] = ACTIONS(4995),
    [anon_sym_namespace] = ACTIONS(4995),
    [anon_sym_using] = ACTIONS(4995),
    [anon_sym_try] = ACTIONS(4995),
    [anon_sym_catch] = ACTIONS(4997),
    [anon_sym_new] = ACTIONS(4995),
    [anon_sym_COLON_COLON] = ACTIONS(4993),
    [sym_operator_name] = ACTIONS(4993),
    [sym_nullptr] = ACTIONS(4995),
  },
  [2846] = {
    [sym_parameter_list] = STATE(2849),
    [anon_sym_SEMI] = ACTIONS(4157),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [sym_comment] = ACTIONS(91),
  },
  [2847] = {
    [sym__abstract_declarator] = STATE(3197),
    [sym_abstract_pointer_declarator] = STATE(3197),
    [sym_abstract_function_declarator] = STATE(3197),
    [sym_abstract_array_declarator] = STATE(3197),
    [sym_type_qualifier] = STATE(3198),
    [sym_parameter_list] = STATE(2281),
    [sym_abstract_reference_declarator] = STATE(3197),
    [aux_sym_type_definition_repeat1] = STATE(3198),
    [anon_sym_SEMI] = ACTIONS(4157),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(4977),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(4979),
    [anon_sym_AMP_AMP] = ACTIONS(4981),
    [sym_comment] = ACTIONS(91),
  },
  [2848] = {
    [sym_parameter_list] = STATE(2849),
    [anon_sym_SEMI] = ACTIONS(4159),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [sym_comment] = ACTIONS(91),
  },
  [2849] = {
    [sym_type_qualifier] = STATE(3199),
    [sym_trailing_return_type] = STATE(1720),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3199),
    [anon_sym_SEMI] = ACTIONS(3663),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(6368),
    [sym_comment] = ACTIONS(91),
    [sym_noexcept] = ACTIONS(7211),
  },
  [2850] = {
    [sym__type_specifier] = STATE(3200),
    [sym_sized_type_specifier] = STATE(3200),
    [sym_enum_specifier] = STATE(3200),
    [sym_struct_specifier] = STATE(3200),
    [sym_union_specifier] = STATE(3200),
    [sym_macro_type_specifier] = STATE(3200),
    [sym_class_specifier] = STATE(3200),
    [sym_dependent_type] = STATE(3200),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1575),
    [anon_sym_unsigned] = ACTIONS(3334),
    [anon_sym_long] = ACTIONS(3334),
    [anon_sym_short] = ACTIONS(3334),
    [sym_primitive_type] = ACTIONS(7213),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(7213),
    [anon_sym_typename] = ACTIONS(3338),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [2851] = {
    [sym_type_qualifier] = STATE(3201),
    [sym_trailing_return_type] = STATE(1720),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3201),
    [anon_sym_SEMI] = ACTIONS(3663),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(6368),
    [sym_comment] = ACTIONS(91),
    [sym_noexcept] = ACTIONS(7215),
  },
  [2852] = {
    [sym_parameter_list] = STATE(2849),
    [anon_sym_SEMI] = ACTIONS(4177),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [sym_comment] = ACTIONS(91),
  },
  [2853] = {
    [anon_sym_COMMA] = ACTIONS(5928),
    [anon_sym_RPAREN] = ACTIONS(5928),
    [anon_sym_SEMI] = ACTIONS(5928),
    [anon_sym_LBRACE] = ACTIONS(5928),
    [anon_sym_RBRACE] = ACTIONS(5928),
    [anon_sym_LPAREN2] = ACTIONS(5928),
    [anon_sym_STAR] = ACTIONS(5930),
    [anon_sym_LBRACK] = ACTIONS(5928),
    [anon_sym_RBRACK] = ACTIONS(5928),
    [anon_sym_EQ] = ACTIONS(5930),
    [anon_sym_COLON] = ACTIONS(5928),
    [anon_sym_QMARK] = ACTIONS(5928),
    [anon_sym_STAR_EQ] = ACTIONS(5928),
    [anon_sym_SLASH_EQ] = ACTIONS(5928),
    [anon_sym_PERCENT_EQ] = ACTIONS(5928),
    [anon_sym_PLUS_EQ] = ACTIONS(5928),
    [anon_sym_DASH_EQ] = ACTIONS(5928),
    [anon_sym_LT_LT_EQ] = ACTIONS(5928),
    [anon_sym_GT_GT_EQ] = ACTIONS(5928),
    [anon_sym_AMP_EQ] = ACTIONS(5928),
    [anon_sym_CARET_EQ] = ACTIONS(5928),
    [anon_sym_PIPE_EQ] = ACTIONS(5928),
    [anon_sym_AMP] = ACTIONS(5930),
    [anon_sym_PIPE_PIPE] = ACTIONS(5928),
    [anon_sym_AMP_AMP] = ACTIONS(5928),
    [anon_sym_PIPE] = ACTIONS(5930),
    [anon_sym_CARET] = ACTIONS(5930),
    [anon_sym_EQ_EQ] = ACTIONS(5928),
    [anon_sym_BANG_EQ] = ACTIONS(5928),
    [anon_sym_LT] = ACTIONS(5930),
    [anon_sym_GT] = ACTIONS(5930),
    [anon_sym_LT_EQ] = ACTIONS(5928),
    [anon_sym_GT_EQ] = ACTIONS(5928),
    [anon_sym_LT_LT] = ACTIONS(5930),
    [anon_sym_GT_GT] = ACTIONS(5930),
    [anon_sym_PLUS] = ACTIONS(5930),
    [anon_sym_DASH] = ACTIONS(5930),
    [anon_sym_SLASH] = ACTIONS(5930),
    [anon_sym_PERCENT] = ACTIONS(5930),
    [anon_sym_DASH_DASH] = ACTIONS(5928),
    [anon_sym_PLUS_PLUS] = ACTIONS(5928),
    [anon_sym_DOT] = ACTIONS(5928),
    [anon_sym_DASH_GT] = ACTIONS(5928),
    [sym_comment] = ACTIONS(91),
  },
  [2854] = {
    [sym_enumerator] = STATE(1988),
    [anon_sym_RBRACE] = ACTIONS(7217),
    [sym_identifier] = ACTIONS(1009),
    [sym_comment] = ACTIONS(91),
  },
  [2855] = {
    [anon_sym_COMMA] = ACTIONS(6046),
    [anon_sym_RPAREN] = ACTIONS(6046),
    [anon_sym_SEMI] = ACTIONS(6046),
    [anon_sym_LBRACE] = ACTIONS(6046),
    [anon_sym_RBRACE] = ACTIONS(6046),
    [anon_sym_LPAREN2] = ACTIONS(6046),
    [anon_sym_STAR] = ACTIONS(6048),
    [anon_sym_LBRACK] = ACTIONS(6046),
    [anon_sym_RBRACK] = ACTIONS(6046),
    [anon_sym_EQ] = ACTIONS(6048),
    [anon_sym_COLON] = ACTIONS(6046),
    [anon_sym_QMARK] = ACTIONS(6046),
    [anon_sym_STAR_EQ] = ACTIONS(6046),
    [anon_sym_SLASH_EQ] = ACTIONS(6046),
    [anon_sym_PERCENT_EQ] = ACTIONS(6046),
    [anon_sym_PLUS_EQ] = ACTIONS(6046),
    [anon_sym_DASH_EQ] = ACTIONS(6046),
    [anon_sym_LT_LT_EQ] = ACTIONS(6046),
    [anon_sym_GT_GT_EQ] = ACTIONS(6046),
    [anon_sym_AMP_EQ] = ACTIONS(6046),
    [anon_sym_CARET_EQ] = ACTIONS(6046),
    [anon_sym_PIPE_EQ] = ACTIONS(6046),
    [anon_sym_AMP] = ACTIONS(6048),
    [anon_sym_PIPE_PIPE] = ACTIONS(6046),
    [anon_sym_AMP_AMP] = ACTIONS(6046),
    [anon_sym_PIPE] = ACTIONS(6048),
    [anon_sym_CARET] = ACTIONS(6048),
    [anon_sym_EQ_EQ] = ACTIONS(6046),
    [anon_sym_BANG_EQ] = ACTIONS(6046),
    [anon_sym_LT] = ACTIONS(6048),
    [anon_sym_GT] = ACTIONS(6048),
    [anon_sym_LT_EQ] = ACTIONS(6046),
    [anon_sym_GT_EQ] = ACTIONS(6046),
    [anon_sym_LT_LT] = ACTIONS(6048),
    [anon_sym_GT_GT] = ACTIONS(6048),
    [anon_sym_PLUS] = ACTIONS(6048),
    [anon_sym_DASH] = ACTIONS(6048),
    [anon_sym_SLASH] = ACTIONS(6048),
    [anon_sym_PERCENT] = ACTIONS(6048),
    [anon_sym_DASH_DASH] = ACTIONS(6046),
    [anon_sym_PLUS_PLUS] = ACTIONS(6046),
    [anon_sym_DOT] = ACTIONS(6046),
    [anon_sym_DASH_GT] = ACTIONS(6046),
    [sym_comment] = ACTIONS(91),
  },
  [2856] = {
    [anon_sym_COMMA] = ACTIONS(6050),
    [anon_sym_RPAREN] = ACTIONS(6050),
    [anon_sym_SEMI] = ACTIONS(6050),
    [anon_sym_LBRACE] = ACTIONS(6050),
    [anon_sym_RBRACE] = ACTIONS(6050),
    [anon_sym_LPAREN2] = ACTIONS(6050),
    [anon_sym_STAR] = ACTIONS(6052),
    [anon_sym_LBRACK] = ACTIONS(6050),
    [anon_sym_RBRACK] = ACTIONS(6050),
    [anon_sym_EQ] = ACTIONS(6052),
    [anon_sym_COLON] = ACTIONS(6050),
    [anon_sym_QMARK] = ACTIONS(6050),
    [anon_sym_STAR_EQ] = ACTIONS(6050),
    [anon_sym_SLASH_EQ] = ACTIONS(6050),
    [anon_sym_PERCENT_EQ] = ACTIONS(6050),
    [anon_sym_PLUS_EQ] = ACTIONS(6050),
    [anon_sym_DASH_EQ] = ACTIONS(6050),
    [anon_sym_LT_LT_EQ] = ACTIONS(6050),
    [anon_sym_GT_GT_EQ] = ACTIONS(6050),
    [anon_sym_AMP_EQ] = ACTIONS(6050),
    [anon_sym_CARET_EQ] = ACTIONS(6050),
    [anon_sym_PIPE_EQ] = ACTIONS(6050),
    [anon_sym_AMP] = ACTIONS(6052),
    [anon_sym_PIPE_PIPE] = ACTIONS(6050),
    [anon_sym_AMP_AMP] = ACTIONS(6050),
    [anon_sym_PIPE] = ACTIONS(6052),
    [anon_sym_CARET] = ACTIONS(6052),
    [anon_sym_EQ_EQ] = ACTIONS(6050),
    [anon_sym_BANG_EQ] = ACTIONS(6050),
    [anon_sym_LT] = ACTIONS(6052),
    [anon_sym_GT] = ACTIONS(6052),
    [anon_sym_LT_EQ] = ACTIONS(6050),
    [anon_sym_GT_EQ] = ACTIONS(6050),
    [anon_sym_LT_LT] = ACTIONS(6052),
    [anon_sym_GT_GT] = ACTIONS(6052),
    [anon_sym_PLUS] = ACTIONS(6052),
    [anon_sym_DASH] = ACTIONS(6052),
    [anon_sym_SLASH] = ACTIONS(6052),
    [anon_sym_PERCENT] = ACTIONS(6052),
    [anon_sym_DASH_DASH] = ACTIONS(6050),
    [anon_sym_PLUS_PLUS] = ACTIONS(6050),
    [anon_sym_DOT] = ACTIONS(6050),
    [anon_sym_DASH_GT] = ACTIONS(6050),
    [sym_comment] = ACTIONS(91),
  },
  [2857] = {
    [anon_sym_COMMA] = ACTIONS(6054),
    [anon_sym_RPAREN] = ACTIONS(6054),
    [anon_sym_SEMI] = ACTIONS(6054),
    [anon_sym_LBRACE] = ACTIONS(6054),
    [anon_sym_RBRACE] = ACTIONS(6054),
    [anon_sym_LPAREN2] = ACTIONS(6054),
    [anon_sym_STAR] = ACTIONS(6056),
    [anon_sym_LBRACK] = ACTIONS(6054),
    [anon_sym_RBRACK] = ACTIONS(6054),
    [anon_sym_EQ] = ACTIONS(6056),
    [anon_sym_COLON] = ACTIONS(6054),
    [anon_sym_QMARK] = ACTIONS(6054),
    [anon_sym_STAR_EQ] = ACTIONS(6054),
    [anon_sym_SLASH_EQ] = ACTIONS(6054),
    [anon_sym_PERCENT_EQ] = ACTIONS(6054),
    [anon_sym_PLUS_EQ] = ACTIONS(6054),
    [anon_sym_DASH_EQ] = ACTIONS(6054),
    [anon_sym_LT_LT_EQ] = ACTIONS(6054),
    [anon_sym_GT_GT_EQ] = ACTIONS(6054),
    [anon_sym_AMP_EQ] = ACTIONS(6054),
    [anon_sym_CARET_EQ] = ACTIONS(6054),
    [anon_sym_PIPE_EQ] = ACTIONS(6054),
    [anon_sym_AMP] = ACTIONS(6056),
    [anon_sym_PIPE_PIPE] = ACTIONS(6054),
    [anon_sym_AMP_AMP] = ACTIONS(6054),
    [anon_sym_PIPE] = ACTIONS(6056),
    [anon_sym_CARET] = ACTIONS(6056),
    [anon_sym_EQ_EQ] = ACTIONS(6054),
    [anon_sym_BANG_EQ] = ACTIONS(6054),
    [anon_sym_LT] = ACTIONS(6056),
    [anon_sym_GT] = ACTIONS(6056),
    [anon_sym_LT_EQ] = ACTIONS(6054),
    [anon_sym_GT_EQ] = ACTIONS(6054),
    [anon_sym_LT_LT] = ACTIONS(6056),
    [anon_sym_GT_GT] = ACTIONS(6056),
    [anon_sym_PLUS] = ACTIONS(6056),
    [anon_sym_DASH] = ACTIONS(6056),
    [anon_sym_SLASH] = ACTIONS(6056),
    [anon_sym_PERCENT] = ACTIONS(6056),
    [anon_sym_DASH_DASH] = ACTIONS(6054),
    [anon_sym_PLUS_PLUS] = ACTIONS(6054),
    [anon_sym_DOT] = ACTIONS(6054),
    [anon_sym_DASH_GT] = ACTIONS(6054),
    [sym_comment] = ACTIONS(91),
  },
  [2858] = {
    [anon_sym_COMMA] = ACTIONS(6058),
    [anon_sym_RPAREN] = ACTIONS(6058),
    [anon_sym_SEMI] = ACTIONS(6058),
    [anon_sym_LBRACE] = ACTIONS(6058),
    [anon_sym_RBRACE] = ACTIONS(6058),
    [anon_sym_LPAREN2] = ACTIONS(6058),
    [anon_sym_STAR] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6058),
    [anon_sym_RBRACK] = ACTIONS(6058),
    [anon_sym_EQ] = ACTIONS(6060),
    [anon_sym_COLON] = ACTIONS(6058),
    [anon_sym_QMARK] = ACTIONS(6058),
    [anon_sym_STAR_EQ] = ACTIONS(6058),
    [anon_sym_SLASH_EQ] = ACTIONS(6058),
    [anon_sym_PERCENT_EQ] = ACTIONS(6058),
    [anon_sym_PLUS_EQ] = ACTIONS(6058),
    [anon_sym_DASH_EQ] = ACTIONS(6058),
    [anon_sym_LT_LT_EQ] = ACTIONS(6058),
    [anon_sym_GT_GT_EQ] = ACTIONS(6058),
    [anon_sym_AMP_EQ] = ACTIONS(6058),
    [anon_sym_CARET_EQ] = ACTIONS(6058),
    [anon_sym_PIPE_EQ] = ACTIONS(6058),
    [anon_sym_AMP] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6058),
    [anon_sym_AMP_AMP] = ACTIONS(6058),
    [anon_sym_PIPE] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6058),
    [anon_sym_BANG_EQ] = ACTIONS(6058),
    [anon_sym_LT] = ACTIONS(6060),
    [anon_sym_GT] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6058),
    [anon_sym_GT_EQ] = ACTIONS(6058),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_DASH] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [anon_sym_DASH_DASH] = ACTIONS(6058),
    [anon_sym_PLUS_PLUS] = ACTIONS(6058),
    [anon_sym_DOT] = ACTIONS(6058),
    [anon_sym_DASH_GT] = ACTIONS(6058),
    [sym_comment] = ACTIONS(91),
  },
  [2859] = {
    [anon_sym_COMMA] = ACTIONS(6300),
    [anon_sym_RPAREN] = ACTIONS(6300),
    [anon_sym_SEMI] = ACTIONS(6300),
    [anon_sym_LBRACE] = ACTIONS(6300),
    [anon_sym_RBRACE] = ACTIONS(6300),
    [anon_sym_LPAREN2] = ACTIONS(6300),
    [anon_sym_STAR] = ACTIONS(6302),
    [anon_sym_LBRACK] = ACTIONS(6300),
    [anon_sym_RBRACK] = ACTIONS(6300),
    [anon_sym_EQ] = ACTIONS(6302),
    [anon_sym_COLON] = ACTIONS(6300),
    [anon_sym_QMARK] = ACTIONS(6300),
    [anon_sym_STAR_EQ] = ACTIONS(6300),
    [anon_sym_SLASH_EQ] = ACTIONS(6300),
    [anon_sym_PERCENT_EQ] = ACTIONS(6300),
    [anon_sym_PLUS_EQ] = ACTIONS(6300),
    [anon_sym_DASH_EQ] = ACTIONS(6300),
    [anon_sym_LT_LT_EQ] = ACTIONS(6300),
    [anon_sym_GT_GT_EQ] = ACTIONS(6300),
    [anon_sym_AMP_EQ] = ACTIONS(6300),
    [anon_sym_CARET_EQ] = ACTIONS(6300),
    [anon_sym_PIPE_EQ] = ACTIONS(6300),
    [anon_sym_AMP] = ACTIONS(6302),
    [anon_sym_PIPE_PIPE] = ACTIONS(6300),
    [anon_sym_AMP_AMP] = ACTIONS(6300),
    [anon_sym_PIPE] = ACTIONS(6302),
    [anon_sym_CARET] = ACTIONS(6302),
    [anon_sym_EQ_EQ] = ACTIONS(6300),
    [anon_sym_BANG_EQ] = ACTIONS(6300),
    [anon_sym_LT] = ACTIONS(6302),
    [anon_sym_GT] = ACTIONS(6302),
    [anon_sym_LT_EQ] = ACTIONS(6300),
    [anon_sym_GT_EQ] = ACTIONS(6300),
    [anon_sym_LT_LT] = ACTIONS(6302),
    [anon_sym_GT_GT] = ACTIONS(6302),
    [anon_sym_PLUS] = ACTIONS(6302),
    [anon_sym_DASH] = ACTIONS(6302),
    [anon_sym_SLASH] = ACTIONS(6302),
    [anon_sym_PERCENT] = ACTIONS(6302),
    [anon_sym_DASH_DASH] = ACTIONS(6300),
    [anon_sym_PLUS_PLUS] = ACTIONS(6300),
    [anon_sym_DOT] = ACTIONS(6300),
    [anon_sym_DASH_GT] = ACTIONS(6300),
    [sym_comment] = ACTIONS(91),
  },
  [2860] = {
    [anon_sym_COMMA] = ACTIONS(6304),
    [anon_sym_RPAREN] = ACTIONS(6304),
    [anon_sym_SEMI] = ACTIONS(6304),
    [anon_sym_LBRACE] = ACTIONS(6304),
    [anon_sym_RBRACE] = ACTIONS(6304),
    [anon_sym_LPAREN2] = ACTIONS(6304),
    [anon_sym_STAR] = ACTIONS(6306),
    [anon_sym_LBRACK] = ACTIONS(6304),
    [anon_sym_RBRACK] = ACTIONS(6304),
    [anon_sym_EQ] = ACTIONS(6306),
    [anon_sym_COLON] = ACTIONS(6304),
    [anon_sym_QMARK] = ACTIONS(6304),
    [anon_sym_STAR_EQ] = ACTIONS(6304),
    [anon_sym_SLASH_EQ] = ACTIONS(6304),
    [anon_sym_PERCENT_EQ] = ACTIONS(6304),
    [anon_sym_PLUS_EQ] = ACTIONS(6304),
    [anon_sym_DASH_EQ] = ACTIONS(6304),
    [anon_sym_LT_LT_EQ] = ACTIONS(6304),
    [anon_sym_GT_GT_EQ] = ACTIONS(6304),
    [anon_sym_AMP_EQ] = ACTIONS(6304),
    [anon_sym_CARET_EQ] = ACTIONS(6304),
    [anon_sym_PIPE_EQ] = ACTIONS(6304),
    [anon_sym_AMP] = ACTIONS(6306),
    [anon_sym_PIPE_PIPE] = ACTIONS(6304),
    [anon_sym_AMP_AMP] = ACTIONS(6304),
    [anon_sym_PIPE] = ACTIONS(6306),
    [anon_sym_CARET] = ACTIONS(6306),
    [anon_sym_EQ_EQ] = ACTIONS(6304),
    [anon_sym_BANG_EQ] = ACTIONS(6304),
    [anon_sym_LT] = ACTIONS(6306),
    [anon_sym_GT] = ACTIONS(6306),
    [anon_sym_LT_EQ] = ACTIONS(6304),
    [anon_sym_GT_EQ] = ACTIONS(6304),
    [anon_sym_LT_LT] = ACTIONS(6306),
    [anon_sym_GT_GT] = ACTIONS(6306),
    [anon_sym_PLUS] = ACTIONS(6306),
    [anon_sym_DASH] = ACTIONS(6306),
    [anon_sym_SLASH] = ACTIONS(6306),
    [anon_sym_PERCENT] = ACTIONS(6306),
    [anon_sym_DASH_DASH] = ACTIONS(6304),
    [anon_sym_PLUS_PLUS] = ACTIONS(6304),
    [anon_sym_DOT] = ACTIONS(6304),
    [anon_sym_DASH_GT] = ACTIONS(6304),
    [sym_comment] = ACTIONS(91),
  },
  [2861] = {
    [anon_sym_COMMA] = ACTIONS(7219),
    [anon_sym_RPAREN] = ACTIONS(7219),
    [anon_sym_SEMI] = ACTIONS(7219),
    [anon_sym_LBRACE] = ACTIONS(7219),
    [anon_sym_RBRACE] = ACTIONS(7219),
    [anon_sym_LPAREN2] = ACTIONS(7219),
    [anon_sym_STAR] = ACTIONS(7221),
    [anon_sym_LBRACK] = ACTIONS(7219),
    [anon_sym_RBRACK] = ACTIONS(7219),
    [anon_sym_EQ] = ACTIONS(7221),
    [anon_sym_COLON] = ACTIONS(7219),
    [anon_sym_QMARK] = ACTIONS(7219),
    [anon_sym_STAR_EQ] = ACTIONS(7219),
    [anon_sym_SLASH_EQ] = ACTIONS(7219),
    [anon_sym_PERCENT_EQ] = ACTIONS(7219),
    [anon_sym_PLUS_EQ] = ACTIONS(7219),
    [anon_sym_DASH_EQ] = ACTIONS(7219),
    [anon_sym_LT_LT_EQ] = ACTIONS(7219),
    [anon_sym_GT_GT_EQ] = ACTIONS(7219),
    [anon_sym_AMP_EQ] = ACTIONS(7219),
    [anon_sym_CARET_EQ] = ACTIONS(7219),
    [anon_sym_PIPE_EQ] = ACTIONS(7219),
    [anon_sym_AMP] = ACTIONS(7221),
    [anon_sym_PIPE_PIPE] = ACTIONS(7219),
    [anon_sym_AMP_AMP] = ACTIONS(7219),
    [anon_sym_PIPE] = ACTIONS(7221),
    [anon_sym_CARET] = ACTIONS(7221),
    [anon_sym_EQ_EQ] = ACTIONS(7219),
    [anon_sym_BANG_EQ] = ACTIONS(7219),
    [anon_sym_LT] = ACTIONS(7221),
    [anon_sym_GT] = ACTIONS(7221),
    [anon_sym_LT_EQ] = ACTIONS(7219),
    [anon_sym_GT_EQ] = ACTIONS(7219),
    [anon_sym_LT_LT] = ACTIONS(7221),
    [anon_sym_GT_GT] = ACTIONS(7221),
    [anon_sym_PLUS] = ACTIONS(7221),
    [anon_sym_DASH] = ACTIONS(7221),
    [anon_sym_SLASH] = ACTIONS(7221),
    [anon_sym_PERCENT] = ACTIONS(7221),
    [anon_sym_DASH_DASH] = ACTIONS(7219),
    [anon_sym_PLUS_PLUS] = ACTIONS(7219),
    [anon_sym_DOT] = ACTIONS(7219),
    [anon_sym_DASH_GT] = ACTIONS(7219),
    [sym_comment] = ACTIONS(91),
  },
  [2862] = {
    [sym__expression] = STATE(1200),
    [sym_conditional_expression] = STATE(1200),
    [sym_assignment_expression] = STATE(1200),
    [sym_pointer_expression] = STATE(1200),
    [sym_logical_expression] = STATE(1200),
    [sym_bitwise_expression] = STATE(1200),
    [sym_equality_expression] = STATE(1200),
    [sym_relational_expression] = STATE(1200),
    [sym_shift_expression] = STATE(1200),
    [sym_math_expression] = STATE(1200),
    [sym_cast_expression] = STATE(1200),
    [sym_sizeof_expression] = STATE(1200),
    [sym_subscript_expression] = STATE(1200),
    [sym_call_expression] = STATE(1200),
    [sym_field_expression] = STATE(1200),
    [sym_compound_literal_expression] = STATE(1200),
    [sym_parenthesized_expression] = STATE(1200),
    [sym_initializer_list] = STATE(1201),
    [sym_char_literal] = STATE(1200),
    [sym_concatenated_string] = STATE(1200),
    [sym_string_literal] = STATE(1632),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1200),
    [sym_new_expression] = STATE(1200),
    [sym_delete_expression] = STATE(1200),
    [sym_lambda_expression] = STATE(1200),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2523),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3411),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_sizeof] = ACTIONS(3419),
    [sym_number_literal] = ACTIONS(2523),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2525),
    [sym_false] = ACTIONS(2525),
    [sym_null] = ACTIONS(2525),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_COLON_COLON] = ACTIONS(5036),
    [sym_nullptr] = ACTIONS(2525),
  },
  [2863] = {
    [anon_sym_RPAREN] = ACTIONS(7223),
    [sym_comment] = ACTIONS(91),
  },
  [2864] = {
    [sym__expression] = STATE(3204),
    [sym_conditional_expression] = STATE(3204),
    [sym_assignment_expression] = STATE(3204),
    [sym_pointer_expression] = STATE(3204),
    [sym_logical_expression] = STATE(3204),
    [sym_bitwise_expression] = STATE(3204),
    [sym_equality_expression] = STATE(3204),
    [sym_relational_expression] = STATE(3204),
    [sym_shift_expression] = STATE(3204),
    [sym_math_expression] = STATE(3204),
    [sym_cast_expression] = STATE(3204),
    [sym_sizeof_expression] = STATE(3204),
    [sym_subscript_expression] = STATE(3204),
    [sym_call_expression] = STATE(3204),
    [sym_field_expression] = STATE(3204),
    [sym_compound_literal_expression] = STATE(3204),
    [sym_parenthesized_expression] = STATE(3204),
    [sym_char_literal] = STATE(3204),
    [sym_concatenated_string] = STATE(3204),
    [sym_string_literal] = STATE(1632),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3204),
    [sym_new_expression] = STATE(3204),
    [sym_delete_expression] = STATE(3204),
    [sym_lambda_expression] = STATE(3204),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7225),
    [anon_sym_LPAREN2] = ACTIONS(947),
    [anon_sym_STAR] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(947),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_BANG] = ACTIONS(3411),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_sizeof] = ACTIONS(3419),
    [sym_number_literal] = ACTIONS(7225),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7227),
    [sym_false] = ACTIONS(7227),
    [sym_null] = ACTIONS(7227),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_COLON_COLON] = ACTIONS(5036),
    [sym_nullptr] = ACTIONS(7227),
  },
  [2865] = {
    [sym__expression] = STATE(3205),
    [sym_conditional_expression] = STATE(3205),
    [sym_assignment_expression] = STATE(3205),
    [sym_pointer_expression] = STATE(3205),
    [sym_logical_expression] = STATE(3205),
    [sym_bitwise_expression] = STATE(3205),
    [sym_equality_expression] = STATE(3205),
    [sym_relational_expression] = STATE(3205),
    [sym_shift_expression] = STATE(3205),
    [sym_math_expression] = STATE(3205),
    [sym_cast_expression] = STATE(3205),
    [sym_sizeof_expression] = STATE(3205),
    [sym_subscript_expression] = STATE(3205),
    [sym_call_expression] = STATE(3205),
    [sym_field_expression] = STATE(3205),
    [sym_compound_literal_expression] = STATE(3205),
    [sym_parenthesized_expression] = STATE(3205),
    [sym_char_literal] = STATE(3205),
    [sym_concatenated_string] = STATE(3205),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3205),
    [sym_new_expression] = STATE(3205),
    [sym_delete_expression] = STATE(3205),
    [sym_lambda_expression] = STATE(3205),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7229),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(7229),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7231),
    [sym_false] = ACTIONS(7231),
    [sym_null] = ACTIONS(7231),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(7231),
  },
  [2866] = {
    [sym_argument_list] = STATE(1610),
    [sym_initializer_list] = STATE(1610),
    [sym_new_declarator] = STATE(1611),
    [anon_sym_COMMA] = ACTIONS(3372),
    [anon_sym_SEMI] = ACTIONS(3372),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_RBRACE] = ACTIONS(3372),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3374),
    [anon_sym_LBRACK] = ACTIONS(6419),
    [anon_sym_EQ] = ACTIONS(3374),
    [anon_sym_QMARK] = ACTIONS(3372),
    [anon_sym_STAR_EQ] = ACTIONS(3372),
    [anon_sym_SLASH_EQ] = ACTIONS(3372),
    [anon_sym_PERCENT_EQ] = ACTIONS(3372),
    [anon_sym_PLUS_EQ] = ACTIONS(3372),
    [anon_sym_DASH_EQ] = ACTIONS(3372),
    [anon_sym_LT_LT_EQ] = ACTIONS(3372),
    [anon_sym_GT_GT_EQ] = ACTIONS(3372),
    [anon_sym_AMP_EQ] = ACTIONS(3372),
    [anon_sym_CARET_EQ] = ACTIONS(3372),
    [anon_sym_PIPE_EQ] = ACTIONS(3372),
    [anon_sym_AMP] = ACTIONS(3374),
    [anon_sym_PIPE_PIPE] = ACTIONS(3372),
    [anon_sym_AMP_AMP] = ACTIONS(3372),
    [anon_sym_PIPE] = ACTIONS(3374),
    [anon_sym_CARET] = ACTIONS(3374),
    [anon_sym_EQ_EQ] = ACTIONS(3372),
    [anon_sym_BANG_EQ] = ACTIONS(3372),
    [anon_sym_LT] = ACTIONS(3374),
    [anon_sym_GT] = ACTIONS(3374),
    [anon_sym_LT_EQ] = ACTIONS(3372),
    [anon_sym_GT_EQ] = ACTIONS(3372),
    [anon_sym_LT_LT] = ACTIONS(3374),
    [anon_sym_GT_GT] = ACTIONS(3374),
    [anon_sym_PLUS] = ACTIONS(3374),
    [anon_sym_DASH] = ACTIONS(3374),
    [anon_sym_SLASH] = ACTIONS(3374),
    [anon_sym_PERCENT] = ACTIONS(3374),
    [anon_sym_DASH_DASH] = ACTIONS(3372),
    [anon_sym_PLUS_PLUS] = ACTIONS(3372),
    [anon_sym_DOT] = ACTIONS(3372),
    [anon_sym_DASH_GT] = ACTIONS(3372),
    [sym_comment] = ACTIONS(91),
  },
  [2867] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2867),
    [anon_sym_COMMA] = ACTIONS(1985),
    [anon_sym_SEMI] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(1985),
    [anon_sym_RBRACE] = ACTIONS(1985),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_EQ] = ACTIONS(1987),
    [anon_sym_unsigned] = ACTIONS(7233),
    [anon_sym_long] = ACTIONS(7233),
    [anon_sym_short] = ACTIONS(7233),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_QMARK] = ACTIONS(1985),
    [anon_sym_STAR_EQ] = ACTIONS(1985),
    [anon_sym_SLASH_EQ] = ACTIONS(1985),
    [anon_sym_PERCENT_EQ] = ACTIONS(1985),
    [anon_sym_PLUS_EQ] = ACTIONS(1985),
    [anon_sym_DASH_EQ] = ACTIONS(1985),
    [anon_sym_LT_LT_EQ] = ACTIONS(1985),
    [anon_sym_GT_GT_EQ] = ACTIONS(1985),
    [anon_sym_AMP_EQ] = ACTIONS(1985),
    [anon_sym_CARET_EQ] = ACTIONS(1985),
    [anon_sym_PIPE_EQ] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_PIPE_PIPE] = ACTIONS(1985),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_PIPE] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1987),
    [anon_sym_EQ_EQ] = ACTIONS(1985),
    [anon_sym_BANG_EQ] = ACTIONS(1985),
    [anon_sym_LT] = ACTIONS(1987),
    [anon_sym_GT] = ACTIONS(1987),
    [anon_sym_LT_EQ] = ACTIONS(1985),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_LT] = ACTIONS(1987),
    [anon_sym_GT_GT] = ACTIONS(1987),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_DASH] = ACTIONS(1987),
    [anon_sym_SLASH] = ACTIONS(1987),
    [anon_sym_PERCENT] = ACTIONS(1987),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DOT] = ACTIONS(1985),
    [anon_sym_DASH_GT] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [sym_comment] = ACTIONS(91),
  },
  [2868] = {
    [sym__expression] = STATE(164),
    [sym_conditional_expression] = STATE(164),
    [sym_assignment_expression] = STATE(164),
    [sym_pointer_expression] = STATE(164),
    [sym_logical_expression] = STATE(164),
    [sym_bitwise_expression] = STATE(164),
    [sym_equality_expression] = STATE(164),
    [sym_relational_expression] = STATE(164),
    [sym_shift_expression] = STATE(164),
    [sym_math_expression] = STATE(164),
    [sym_cast_expression] = STATE(164),
    [sym_sizeof_expression] = STATE(164),
    [sym_subscript_expression] = STATE(164),
    [sym_call_expression] = STATE(164),
    [sym_field_expression] = STATE(164),
    [sym_compound_literal_expression] = STATE(164),
    [sym_parenthesized_expression] = STATE(164),
    [sym_char_literal] = STATE(164),
    [sym_concatenated_string] = STATE(164),
    [sym_string_literal] = STATE(165),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(164),
    [sym_new_expression] = STATE(164),
    [sym_delete_expression] = STATE(164),
    [sym_lambda_expression] = STATE(164),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_lambda_default_capture] = STATE(166),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(267),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(7236),
    [anon_sym_EQ] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_DASH] = ACTIONS(285),
    [anon_sym_PLUS_PLUS] = ACTIONS(285),
    [anon_sym_sizeof] = ACTIONS(287),
    [sym_number_literal] = ACTIONS(267),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(289),
    [sym_false] = ACTIONS(289),
    [sym_null] = ACTIONS(289),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(293),
    [anon_sym_new] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(297),
    [sym_nullptr] = ACTIONS(289),
  },
  [2869] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3383),
    [anon_sym_SEMI] = ACTIONS(3383),
    [anon_sym_RBRACE] = ACTIONS(3383),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(5060),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3385),
    [anon_sym_QMARK] = ACTIONS(3383),
    [anon_sym_STAR_EQ] = ACTIONS(3383),
    [anon_sym_SLASH_EQ] = ACTIONS(3383),
    [anon_sym_PERCENT_EQ] = ACTIONS(3383),
    [anon_sym_PLUS_EQ] = ACTIONS(3383),
    [anon_sym_DASH_EQ] = ACTIONS(3383),
    [anon_sym_LT_LT_EQ] = ACTIONS(3383),
    [anon_sym_GT_GT_EQ] = ACTIONS(3383),
    [anon_sym_AMP_EQ] = ACTIONS(3383),
    [anon_sym_CARET_EQ] = ACTIONS(3383),
    [anon_sym_PIPE_EQ] = ACTIONS(3383),
    [anon_sym_AMP] = ACTIONS(5068),
    [anon_sym_PIPE_PIPE] = ACTIONS(5070),
    [anon_sym_AMP_AMP] = ACTIONS(5072),
    [anon_sym_PIPE] = ACTIONS(5074),
    [anon_sym_CARET] = ACTIONS(5076),
    [anon_sym_EQ_EQ] = ACTIONS(5078),
    [anon_sym_BANG_EQ] = ACTIONS(5078),
    [anon_sym_LT] = ACTIONS(5080),
    [anon_sym_GT] = ACTIONS(5080),
    [anon_sym_LT_EQ] = ACTIONS(5082),
    [anon_sym_GT_EQ] = ACTIONS(5082),
    [anon_sym_LT_LT] = ACTIONS(5084),
    [anon_sym_GT_GT] = ACTIONS(5084),
    [anon_sym_PLUS] = ACTIONS(5086),
    [anon_sym_DASH] = ACTIONS(5086),
    [anon_sym_SLASH] = ACTIONS(5060),
    [anon_sym_PERCENT] = ACTIONS(5060),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2870] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(7238),
    [anon_sym_SEMI] = ACTIONS(3573),
    [anon_sym_RBRACE] = ACTIONS(6195),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(5060),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(5062),
    [anon_sym_QMARK] = ACTIONS(5064),
    [anon_sym_STAR_EQ] = ACTIONS(5066),
    [anon_sym_SLASH_EQ] = ACTIONS(5066),
    [anon_sym_PERCENT_EQ] = ACTIONS(5066),
    [anon_sym_PLUS_EQ] = ACTIONS(5066),
    [anon_sym_DASH_EQ] = ACTIONS(5066),
    [anon_sym_LT_LT_EQ] = ACTIONS(5066),
    [anon_sym_GT_GT_EQ] = ACTIONS(5066),
    [anon_sym_AMP_EQ] = ACTIONS(5066),
    [anon_sym_CARET_EQ] = ACTIONS(5066),
    [anon_sym_PIPE_EQ] = ACTIONS(5066),
    [anon_sym_AMP] = ACTIONS(5068),
    [anon_sym_PIPE_PIPE] = ACTIONS(5070),
    [anon_sym_AMP_AMP] = ACTIONS(5072),
    [anon_sym_PIPE] = ACTIONS(5074),
    [anon_sym_CARET] = ACTIONS(5076),
    [anon_sym_EQ_EQ] = ACTIONS(5078),
    [anon_sym_BANG_EQ] = ACTIONS(5078),
    [anon_sym_LT] = ACTIONS(5080),
    [anon_sym_GT] = ACTIONS(5080),
    [anon_sym_LT_EQ] = ACTIONS(5082),
    [anon_sym_GT_EQ] = ACTIONS(5082),
    [anon_sym_LT_LT] = ACTIONS(5084),
    [anon_sym_GT_GT] = ACTIONS(5084),
    [anon_sym_PLUS] = ACTIONS(5086),
    [anon_sym_DASH] = ACTIONS(5086),
    [anon_sym_SLASH] = ACTIONS(5060),
    [anon_sym_PERCENT] = ACTIONS(5060),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2871] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3581),
    [anon_sym_SEMI] = ACTIONS(3581),
    [anon_sym_RBRACE] = ACTIONS(3581),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(5060),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(5062),
    [anon_sym_QMARK] = ACTIONS(3581),
    [anon_sym_STAR_EQ] = ACTIONS(5066),
    [anon_sym_SLASH_EQ] = ACTIONS(5066),
    [anon_sym_PERCENT_EQ] = ACTIONS(5066),
    [anon_sym_PLUS_EQ] = ACTIONS(5066),
    [anon_sym_DASH_EQ] = ACTIONS(5066),
    [anon_sym_LT_LT_EQ] = ACTIONS(5066),
    [anon_sym_GT_GT_EQ] = ACTIONS(5066),
    [anon_sym_AMP_EQ] = ACTIONS(5066),
    [anon_sym_CARET_EQ] = ACTIONS(5066),
    [anon_sym_PIPE_EQ] = ACTIONS(5066),
    [anon_sym_AMP] = ACTIONS(5068),
    [anon_sym_PIPE_PIPE] = ACTIONS(5070),
    [anon_sym_AMP_AMP] = ACTIONS(5072),
    [anon_sym_PIPE] = ACTIONS(5074),
    [anon_sym_CARET] = ACTIONS(5076),
    [anon_sym_EQ_EQ] = ACTIONS(5078),
    [anon_sym_BANG_EQ] = ACTIONS(5078),
    [anon_sym_LT] = ACTIONS(5080),
    [anon_sym_GT] = ACTIONS(5080),
    [anon_sym_LT_EQ] = ACTIONS(5082),
    [anon_sym_GT_EQ] = ACTIONS(5082),
    [anon_sym_LT_LT] = ACTIONS(5084),
    [anon_sym_GT_GT] = ACTIONS(5084),
    [anon_sym_PLUS] = ACTIONS(5086),
    [anon_sym_DASH] = ACTIONS(5086),
    [anon_sym_SLASH] = ACTIONS(5060),
    [anon_sym_PERCENT] = ACTIONS(5060),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2872] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_COLON] = ACTIONS(7241),
    [anon_sym_QMARK] = ACTIONS(1171),
    [anon_sym_STAR_EQ] = ACTIONS(1173),
    [anon_sym_SLASH_EQ] = ACTIONS(1173),
    [anon_sym_PERCENT_EQ] = ACTIONS(1173),
    [anon_sym_PLUS_EQ] = ACTIONS(1173),
    [anon_sym_DASH_EQ] = ACTIONS(1173),
    [anon_sym_LT_LT_EQ] = ACTIONS(1173),
    [anon_sym_GT_GT_EQ] = ACTIONS(1173),
    [anon_sym_AMP_EQ] = ACTIONS(1173),
    [anon_sym_CARET_EQ] = ACTIONS(1173),
    [anon_sym_PIPE_EQ] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_CARET] = ACTIONS(1183),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [2873] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3585),
    [anon_sym_SEMI] = ACTIONS(3585),
    [anon_sym_RBRACE] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(5060),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_STAR_EQ] = ACTIONS(3585),
    [anon_sym_SLASH_EQ] = ACTIONS(3585),
    [anon_sym_PERCENT_EQ] = ACTIONS(3585),
    [anon_sym_PLUS_EQ] = ACTIONS(3585),
    [anon_sym_DASH_EQ] = ACTIONS(3585),
    [anon_sym_LT_LT_EQ] = ACTIONS(3585),
    [anon_sym_GT_GT_EQ] = ACTIONS(3585),
    [anon_sym_AMP_EQ] = ACTIONS(3585),
    [anon_sym_CARET_EQ] = ACTIONS(3585),
    [anon_sym_PIPE_EQ] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(3587),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3587),
    [anon_sym_CARET] = ACTIONS(3587),
    [anon_sym_EQ_EQ] = ACTIONS(5078),
    [anon_sym_BANG_EQ] = ACTIONS(5078),
    [anon_sym_LT] = ACTIONS(5080),
    [anon_sym_GT] = ACTIONS(5080),
    [anon_sym_LT_EQ] = ACTIONS(5082),
    [anon_sym_GT_EQ] = ACTIONS(5082),
    [anon_sym_LT_LT] = ACTIONS(5084),
    [anon_sym_GT_GT] = ACTIONS(5084),
    [anon_sym_PLUS] = ACTIONS(5086),
    [anon_sym_DASH] = ACTIONS(5086),
    [anon_sym_SLASH] = ACTIONS(5060),
    [anon_sym_PERCENT] = ACTIONS(5060),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2874] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3589),
    [anon_sym_SEMI] = ACTIONS(3589),
    [anon_sym_RBRACE] = ACTIONS(3589),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(5060),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3591),
    [anon_sym_QMARK] = ACTIONS(3589),
    [anon_sym_STAR_EQ] = ACTIONS(3589),
    [anon_sym_SLASH_EQ] = ACTIONS(3589),
    [anon_sym_PERCENT_EQ] = ACTIONS(3589),
    [anon_sym_PLUS_EQ] = ACTIONS(3589),
    [anon_sym_DASH_EQ] = ACTIONS(3589),
    [anon_sym_LT_LT_EQ] = ACTIONS(3589),
    [anon_sym_GT_GT_EQ] = ACTIONS(3589),
    [anon_sym_AMP_EQ] = ACTIONS(3589),
    [anon_sym_CARET_EQ] = ACTIONS(3589),
    [anon_sym_PIPE_EQ] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(5068),
    [anon_sym_PIPE_PIPE] = ACTIONS(3589),
    [anon_sym_AMP_AMP] = ACTIONS(5072),
    [anon_sym_PIPE] = ACTIONS(5074),
    [anon_sym_CARET] = ACTIONS(5076),
    [anon_sym_EQ_EQ] = ACTIONS(5078),
    [anon_sym_BANG_EQ] = ACTIONS(5078),
    [anon_sym_LT] = ACTIONS(5080),
    [anon_sym_GT] = ACTIONS(5080),
    [anon_sym_LT_EQ] = ACTIONS(5082),
    [anon_sym_GT_EQ] = ACTIONS(5082),
    [anon_sym_LT_LT] = ACTIONS(5084),
    [anon_sym_GT_GT] = ACTIONS(5084),
    [anon_sym_PLUS] = ACTIONS(5086),
    [anon_sym_DASH] = ACTIONS(5086),
    [anon_sym_SLASH] = ACTIONS(5060),
    [anon_sym_PERCENT] = ACTIONS(5060),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2875] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3589),
    [anon_sym_SEMI] = ACTIONS(3589),
    [anon_sym_RBRACE] = ACTIONS(3589),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(5060),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3591),
    [anon_sym_QMARK] = ACTIONS(3589),
    [anon_sym_STAR_EQ] = ACTIONS(3589),
    [anon_sym_SLASH_EQ] = ACTIONS(3589),
    [anon_sym_PERCENT_EQ] = ACTIONS(3589),
    [anon_sym_PLUS_EQ] = ACTIONS(3589),
    [anon_sym_DASH_EQ] = ACTIONS(3589),
    [anon_sym_LT_LT_EQ] = ACTIONS(3589),
    [anon_sym_GT_GT_EQ] = ACTIONS(3589),
    [anon_sym_AMP_EQ] = ACTIONS(3589),
    [anon_sym_CARET_EQ] = ACTIONS(3589),
    [anon_sym_PIPE_EQ] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(5068),
    [anon_sym_PIPE_PIPE] = ACTIONS(3589),
    [anon_sym_AMP_AMP] = ACTIONS(3589),
    [anon_sym_PIPE] = ACTIONS(5074),
    [anon_sym_CARET] = ACTIONS(5076),
    [anon_sym_EQ_EQ] = ACTIONS(5078),
    [anon_sym_BANG_EQ] = ACTIONS(5078),
    [anon_sym_LT] = ACTIONS(5080),
    [anon_sym_GT] = ACTIONS(5080),
    [anon_sym_LT_EQ] = ACTIONS(5082),
    [anon_sym_GT_EQ] = ACTIONS(5082),
    [anon_sym_LT_LT] = ACTIONS(5084),
    [anon_sym_GT_GT] = ACTIONS(5084),
    [anon_sym_PLUS] = ACTIONS(5086),
    [anon_sym_DASH] = ACTIONS(5086),
    [anon_sym_SLASH] = ACTIONS(5060),
    [anon_sym_PERCENT] = ACTIONS(5060),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2876] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3585),
    [anon_sym_SEMI] = ACTIONS(3585),
    [anon_sym_RBRACE] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(5060),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_STAR_EQ] = ACTIONS(3585),
    [anon_sym_SLASH_EQ] = ACTIONS(3585),
    [anon_sym_PERCENT_EQ] = ACTIONS(3585),
    [anon_sym_PLUS_EQ] = ACTIONS(3585),
    [anon_sym_DASH_EQ] = ACTIONS(3585),
    [anon_sym_LT_LT_EQ] = ACTIONS(3585),
    [anon_sym_GT_GT_EQ] = ACTIONS(3585),
    [anon_sym_AMP_EQ] = ACTIONS(3585),
    [anon_sym_CARET_EQ] = ACTIONS(3585),
    [anon_sym_PIPE_EQ] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(5068),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3587),
    [anon_sym_CARET] = ACTIONS(5076),
    [anon_sym_EQ_EQ] = ACTIONS(5078),
    [anon_sym_BANG_EQ] = ACTIONS(5078),
    [anon_sym_LT] = ACTIONS(5080),
    [anon_sym_GT] = ACTIONS(5080),
    [anon_sym_LT_EQ] = ACTIONS(5082),
    [anon_sym_GT_EQ] = ACTIONS(5082),
    [anon_sym_LT_LT] = ACTIONS(5084),
    [anon_sym_GT_GT] = ACTIONS(5084),
    [anon_sym_PLUS] = ACTIONS(5086),
    [anon_sym_DASH] = ACTIONS(5086),
    [anon_sym_SLASH] = ACTIONS(5060),
    [anon_sym_PERCENT] = ACTIONS(5060),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2877] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3585),
    [anon_sym_SEMI] = ACTIONS(3585),
    [anon_sym_RBRACE] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(5060),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_STAR_EQ] = ACTIONS(3585),
    [anon_sym_SLASH_EQ] = ACTIONS(3585),
    [anon_sym_PERCENT_EQ] = ACTIONS(3585),
    [anon_sym_PLUS_EQ] = ACTIONS(3585),
    [anon_sym_DASH_EQ] = ACTIONS(3585),
    [anon_sym_LT_LT_EQ] = ACTIONS(3585),
    [anon_sym_GT_GT_EQ] = ACTIONS(3585),
    [anon_sym_AMP_EQ] = ACTIONS(3585),
    [anon_sym_CARET_EQ] = ACTIONS(3585),
    [anon_sym_PIPE_EQ] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(5068),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3587),
    [anon_sym_CARET] = ACTIONS(3587),
    [anon_sym_EQ_EQ] = ACTIONS(5078),
    [anon_sym_BANG_EQ] = ACTIONS(5078),
    [anon_sym_LT] = ACTIONS(5080),
    [anon_sym_GT] = ACTIONS(5080),
    [anon_sym_LT_EQ] = ACTIONS(5082),
    [anon_sym_GT_EQ] = ACTIONS(5082),
    [anon_sym_LT_LT] = ACTIONS(5084),
    [anon_sym_GT_GT] = ACTIONS(5084),
    [anon_sym_PLUS] = ACTIONS(5086),
    [anon_sym_DASH] = ACTIONS(5086),
    [anon_sym_SLASH] = ACTIONS(5060),
    [anon_sym_PERCENT] = ACTIONS(5060),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2878] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3593),
    [anon_sym_SEMI] = ACTIONS(3593),
    [anon_sym_RBRACE] = ACTIONS(3593),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(5060),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3595),
    [anon_sym_QMARK] = ACTIONS(3593),
    [anon_sym_STAR_EQ] = ACTIONS(3593),
    [anon_sym_SLASH_EQ] = ACTIONS(3593),
    [anon_sym_PERCENT_EQ] = ACTIONS(3593),
    [anon_sym_PLUS_EQ] = ACTIONS(3593),
    [anon_sym_DASH_EQ] = ACTIONS(3593),
    [anon_sym_LT_LT_EQ] = ACTIONS(3593),
    [anon_sym_GT_GT_EQ] = ACTIONS(3593),
    [anon_sym_AMP_EQ] = ACTIONS(3593),
    [anon_sym_CARET_EQ] = ACTIONS(3593),
    [anon_sym_PIPE_EQ] = ACTIONS(3593),
    [anon_sym_AMP] = ACTIONS(3595),
    [anon_sym_PIPE_PIPE] = ACTIONS(3593),
    [anon_sym_AMP_AMP] = ACTIONS(3593),
    [anon_sym_PIPE] = ACTIONS(3595),
    [anon_sym_CARET] = ACTIONS(3595),
    [anon_sym_EQ_EQ] = ACTIONS(3593),
    [anon_sym_BANG_EQ] = ACTIONS(3593),
    [anon_sym_LT] = ACTIONS(5080),
    [anon_sym_GT] = ACTIONS(5080),
    [anon_sym_LT_EQ] = ACTIONS(5082),
    [anon_sym_GT_EQ] = ACTIONS(5082),
    [anon_sym_LT_LT] = ACTIONS(5084),
    [anon_sym_GT_GT] = ACTIONS(5084),
    [anon_sym_PLUS] = ACTIONS(5086),
    [anon_sym_DASH] = ACTIONS(5086),
    [anon_sym_SLASH] = ACTIONS(5060),
    [anon_sym_PERCENT] = ACTIONS(5060),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2879] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3597),
    [anon_sym_SEMI] = ACTIONS(3597),
    [anon_sym_RBRACE] = ACTIONS(3597),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(5060),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3599),
    [anon_sym_QMARK] = ACTIONS(3597),
    [anon_sym_STAR_EQ] = ACTIONS(3597),
    [anon_sym_SLASH_EQ] = ACTIONS(3597),
    [anon_sym_PERCENT_EQ] = ACTIONS(3597),
    [anon_sym_PLUS_EQ] = ACTIONS(3597),
    [anon_sym_DASH_EQ] = ACTIONS(3597),
    [anon_sym_LT_LT_EQ] = ACTIONS(3597),
    [anon_sym_GT_GT_EQ] = ACTIONS(3597),
    [anon_sym_AMP_EQ] = ACTIONS(3597),
    [anon_sym_CARET_EQ] = ACTIONS(3597),
    [anon_sym_PIPE_EQ] = ACTIONS(3597),
    [anon_sym_AMP] = ACTIONS(3599),
    [anon_sym_PIPE_PIPE] = ACTIONS(3597),
    [anon_sym_AMP_AMP] = ACTIONS(3597),
    [anon_sym_PIPE] = ACTIONS(3599),
    [anon_sym_CARET] = ACTIONS(3599),
    [anon_sym_EQ_EQ] = ACTIONS(3597),
    [anon_sym_BANG_EQ] = ACTIONS(3597),
    [anon_sym_LT] = ACTIONS(3599),
    [anon_sym_GT] = ACTIONS(3599),
    [anon_sym_LT_EQ] = ACTIONS(3597),
    [anon_sym_GT_EQ] = ACTIONS(3597),
    [anon_sym_LT_LT] = ACTIONS(5084),
    [anon_sym_GT_GT] = ACTIONS(5084),
    [anon_sym_PLUS] = ACTIONS(5086),
    [anon_sym_DASH] = ACTIONS(5086),
    [anon_sym_SLASH] = ACTIONS(5060),
    [anon_sym_PERCENT] = ACTIONS(5060),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2880] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3601),
    [anon_sym_SEMI] = ACTIONS(3601),
    [anon_sym_RBRACE] = ACTIONS(3601),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(5060),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3603),
    [anon_sym_QMARK] = ACTIONS(3601),
    [anon_sym_STAR_EQ] = ACTIONS(3601),
    [anon_sym_SLASH_EQ] = ACTIONS(3601),
    [anon_sym_PERCENT_EQ] = ACTIONS(3601),
    [anon_sym_PLUS_EQ] = ACTIONS(3601),
    [anon_sym_DASH_EQ] = ACTIONS(3601),
    [anon_sym_LT_LT_EQ] = ACTIONS(3601),
    [anon_sym_GT_GT_EQ] = ACTIONS(3601),
    [anon_sym_AMP_EQ] = ACTIONS(3601),
    [anon_sym_CARET_EQ] = ACTIONS(3601),
    [anon_sym_PIPE_EQ] = ACTIONS(3601),
    [anon_sym_AMP] = ACTIONS(3603),
    [anon_sym_PIPE_PIPE] = ACTIONS(3601),
    [anon_sym_AMP_AMP] = ACTIONS(3601),
    [anon_sym_PIPE] = ACTIONS(3603),
    [anon_sym_CARET] = ACTIONS(3603),
    [anon_sym_EQ_EQ] = ACTIONS(3601),
    [anon_sym_BANG_EQ] = ACTIONS(3601),
    [anon_sym_LT] = ACTIONS(3603),
    [anon_sym_GT] = ACTIONS(3603),
    [anon_sym_LT_EQ] = ACTIONS(3601),
    [anon_sym_GT_EQ] = ACTIONS(3601),
    [anon_sym_LT_LT] = ACTIONS(3603),
    [anon_sym_GT_GT] = ACTIONS(3603),
    [anon_sym_PLUS] = ACTIONS(5086),
    [anon_sym_DASH] = ACTIONS(5086),
    [anon_sym_SLASH] = ACTIONS(5060),
    [anon_sym_PERCENT] = ACTIONS(5060),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2881] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(3575),
    [anon_sym_SEMI] = ACTIONS(3575),
    [anon_sym_RBRACE] = ACTIONS(3575),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(5060),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(3577),
    [anon_sym_QMARK] = ACTIONS(3575),
    [anon_sym_STAR_EQ] = ACTIONS(3575),
    [anon_sym_SLASH_EQ] = ACTIONS(3575),
    [anon_sym_PERCENT_EQ] = ACTIONS(3575),
    [anon_sym_PLUS_EQ] = ACTIONS(3575),
    [anon_sym_DASH_EQ] = ACTIONS(3575),
    [anon_sym_LT_LT_EQ] = ACTIONS(3575),
    [anon_sym_GT_GT_EQ] = ACTIONS(3575),
    [anon_sym_AMP_EQ] = ACTIONS(3575),
    [anon_sym_CARET_EQ] = ACTIONS(3575),
    [anon_sym_PIPE_EQ] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_PIPE_PIPE] = ACTIONS(3575),
    [anon_sym_AMP_AMP] = ACTIONS(3575),
    [anon_sym_PIPE] = ACTIONS(3577),
    [anon_sym_CARET] = ACTIONS(3577),
    [anon_sym_EQ_EQ] = ACTIONS(3575),
    [anon_sym_BANG_EQ] = ACTIONS(3575),
    [anon_sym_LT] = ACTIONS(3577),
    [anon_sym_GT] = ACTIONS(3577),
    [anon_sym_LT_EQ] = ACTIONS(3575),
    [anon_sym_GT_EQ] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3577),
    [anon_sym_GT_GT] = ACTIONS(3577),
    [anon_sym_PLUS] = ACTIONS(3577),
    [anon_sym_DASH] = ACTIONS(3577),
    [anon_sym_SLASH] = ACTIONS(5060),
    [anon_sym_PERCENT] = ACTIONS(5060),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2882] = {
    [sym_string_literal] = STATE(2882),
    [aux_sym_concatenated_string_repeat1] = STATE(2882),
    [anon_sym_COMMA] = ACTIONS(3622),
    [anon_sym_SEMI] = ACTIONS(3622),
    [anon_sym_RBRACE] = ACTIONS(3622),
    [anon_sym_LPAREN2] = ACTIONS(3622),
    [anon_sym_STAR] = ACTIONS(3624),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_EQ] = ACTIONS(3624),
    [anon_sym_QMARK] = ACTIONS(3622),
    [anon_sym_STAR_EQ] = ACTIONS(3622),
    [anon_sym_SLASH_EQ] = ACTIONS(3622),
    [anon_sym_PERCENT_EQ] = ACTIONS(3622),
    [anon_sym_PLUS_EQ] = ACTIONS(3622),
    [anon_sym_DASH_EQ] = ACTIONS(3622),
    [anon_sym_LT_LT_EQ] = ACTIONS(3622),
    [anon_sym_GT_GT_EQ] = ACTIONS(3622),
    [anon_sym_AMP_EQ] = ACTIONS(3622),
    [anon_sym_CARET_EQ] = ACTIONS(3622),
    [anon_sym_PIPE_EQ] = ACTIONS(3622),
    [anon_sym_AMP] = ACTIONS(3624),
    [anon_sym_PIPE_PIPE] = ACTIONS(3622),
    [anon_sym_AMP_AMP] = ACTIONS(3622),
    [anon_sym_PIPE] = ACTIONS(3624),
    [anon_sym_CARET] = ACTIONS(3624),
    [anon_sym_EQ_EQ] = ACTIONS(3622),
    [anon_sym_BANG_EQ] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3624),
    [anon_sym_GT] = ACTIONS(3624),
    [anon_sym_LT_EQ] = ACTIONS(3622),
    [anon_sym_GT_EQ] = ACTIONS(3622),
    [anon_sym_LT_LT] = ACTIONS(3624),
    [anon_sym_GT_GT] = ACTIONS(3624),
    [anon_sym_PLUS] = ACTIONS(3624),
    [anon_sym_DASH] = ACTIONS(3624),
    [anon_sym_SLASH] = ACTIONS(3624),
    [anon_sym_PERCENT] = ACTIONS(3624),
    [anon_sym_DASH_DASH] = ACTIONS(3622),
    [anon_sym_PLUS_PLUS] = ACTIONS(3622),
    [anon_sym_DOT] = ACTIONS(3622),
    [anon_sym_DASH_GT] = ACTIONS(3622),
    [anon_sym_DQUOTE] = ACTIONS(3626),
    [sym_comment] = ACTIONS(91),
  },
  [2883] = {
    [anon_sym_COMMA] = ACTIONS(3213),
    [anon_sym_RPAREN] = ACTIONS(3213),
    [anon_sym_extern] = ACTIONS(3216),
    [anon_sym_LBRACE] = ACTIONS(3218),
    [anon_sym_LPAREN2] = ACTIONS(3213),
    [anon_sym_STAR] = ACTIONS(3220),
    [anon_sym_LBRACK] = ACTIONS(3213),
    [anon_sym_EQ] = ACTIONS(3223),
    [anon_sym_static] = ACTIONS(3216),
    [anon_sym_register] = ACTIONS(3216),
    [anon_sym_inline] = ACTIONS(3216),
    [anon_sym_const] = ACTIONS(3216),
    [anon_sym_restrict] = ACTIONS(3216),
    [anon_sym_volatile] = ACTIONS(3216),
    [anon_sym__Atomic] = ACTIONS(3216),
    [anon_sym_mutable] = ACTIONS(3216),
    [anon_sym_explicit] = ACTIONS(3216),
    [anon_sym_constexpr] = ACTIONS(3216),
    [anon_sym_QMARK] = ACTIONS(3211),
    [anon_sym_STAR_EQ] = ACTIONS(3211),
    [anon_sym_SLASH_EQ] = ACTIONS(3211),
    [anon_sym_PERCENT_EQ] = ACTIONS(3211),
    [anon_sym_PLUS_EQ] = ACTIONS(3211),
    [anon_sym_DASH_EQ] = ACTIONS(3211),
    [anon_sym_LT_LT_EQ] = ACTIONS(3211),
    [anon_sym_GT_GT_EQ] = ACTIONS(3211),
    [anon_sym_AMP_EQ] = ACTIONS(3211),
    [anon_sym_CARET_EQ] = ACTIONS(3211),
    [anon_sym_PIPE_EQ] = ACTIONS(3211),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym_PIPE_PIPE] = ACTIONS(3211),
    [anon_sym_AMP_AMP] = ACTIONS(3213),
    [anon_sym_PIPE] = ACTIONS(3223),
    [anon_sym_CARET] = ACTIONS(3223),
    [anon_sym_TILDE] = ACTIONS(3218),
    [anon_sym_EQ_EQ] = ACTIONS(3211),
    [anon_sym_BANG_EQ] = ACTIONS(3211),
    [anon_sym_LT] = ACTIONS(3220),
    [anon_sym_GT] = ACTIONS(3223),
    [anon_sym_LT_EQ] = ACTIONS(3211),
    [anon_sym_GT_EQ] = ACTIONS(3211),
    [anon_sym_LT_LT] = ACTIONS(3223),
    [anon_sym_GT_GT] = ACTIONS(3223),
    [anon_sym_PLUS] = ACTIONS(3223),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_SLASH] = ACTIONS(3223),
    [anon_sym_PERCENT] = ACTIONS(3223),
    [anon_sym_DASH_DASH] = ACTIONS(3211),
    [anon_sym_PLUS_PLUS] = ACTIONS(3211),
    [anon_sym_DOT] = ACTIONS(3211),
    [anon_sym_DASH_GT] = ACTIONS(3211),
    [sym_identifier] = ACTIONS(3216),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(3225),
    [sym_operator_name] = ACTIONS(3218),
  },
  [2884] = {
    [anon_sym_COMMA] = ACTIONS(3631),
    [anon_sym_RPAREN] = ACTIONS(3631),
    [anon_sym_extern] = ACTIONS(3634),
    [anon_sym_LBRACE] = ACTIONS(3636),
    [anon_sym_LPAREN2] = ACTIONS(3631),
    [anon_sym_STAR] = ACTIONS(3638),
    [anon_sym_LBRACK] = ACTIONS(3631),
    [anon_sym_EQ] = ACTIONS(3641),
    [anon_sym_static] = ACTIONS(3634),
    [anon_sym_register] = ACTIONS(3634),
    [anon_sym_inline] = ACTIONS(3634),
    [anon_sym_const] = ACTIONS(3634),
    [anon_sym_restrict] = ACTIONS(3634),
    [anon_sym_volatile] = ACTIONS(3634),
    [anon_sym__Atomic] = ACTIONS(3634),
    [anon_sym_mutable] = ACTIONS(3634),
    [anon_sym_explicit] = ACTIONS(3634),
    [anon_sym_constexpr] = ACTIONS(3634),
    [anon_sym_QMARK] = ACTIONS(3629),
    [anon_sym_STAR_EQ] = ACTIONS(3629),
    [anon_sym_SLASH_EQ] = ACTIONS(3629),
    [anon_sym_PERCENT_EQ] = ACTIONS(3629),
    [anon_sym_PLUS_EQ] = ACTIONS(3629),
    [anon_sym_DASH_EQ] = ACTIONS(3629),
    [anon_sym_LT_LT_EQ] = ACTIONS(3629),
    [anon_sym_GT_GT_EQ] = ACTIONS(3629),
    [anon_sym_AMP_EQ] = ACTIONS(3629),
    [anon_sym_CARET_EQ] = ACTIONS(3629),
    [anon_sym_PIPE_EQ] = ACTIONS(3629),
    [anon_sym_AMP] = ACTIONS(3638),
    [anon_sym_PIPE_PIPE] = ACTIONS(3629),
    [anon_sym_AMP_AMP] = ACTIONS(3631),
    [anon_sym_PIPE] = ACTIONS(3641),
    [anon_sym_CARET] = ACTIONS(3641),
    [anon_sym_TILDE] = ACTIONS(3636),
    [anon_sym_EQ_EQ] = ACTIONS(3629),
    [anon_sym_BANG_EQ] = ACTIONS(3629),
    [anon_sym_LT] = ACTIONS(3638),
    [anon_sym_GT] = ACTIONS(3641),
    [anon_sym_LT_EQ] = ACTIONS(3629),
    [anon_sym_GT_EQ] = ACTIONS(3629),
    [anon_sym_LT_LT] = ACTIONS(3641),
    [anon_sym_GT_GT] = ACTIONS(3641),
    [anon_sym_PLUS] = ACTIONS(3641),
    [anon_sym_DASH] = ACTIONS(3641),
    [anon_sym_SLASH] = ACTIONS(3641),
    [anon_sym_PERCENT] = ACTIONS(3641),
    [anon_sym_DASH_DASH] = ACTIONS(3629),
    [anon_sym_PLUS_PLUS] = ACTIONS(3629),
    [anon_sym_DOT] = ACTIONS(3629),
    [anon_sym_DASH_GT] = ACTIONS(3629),
    [sym_identifier] = ACTIONS(3634),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(3643),
    [sym_operator_name] = ACTIONS(3636),
  },
  [2885] = {
    [sym_field_declaration_list] = STATE(612),
    [sym_virtual_specifier] = STATE(613),
    [sym_base_class_clause] = STATE(614),
    [sym_template_argument_list] = STATE(437),
    [anon_sym_COMMA] = ACTIONS(1057),
    [anon_sym_RPAREN] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_LPAREN2] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_EQ] = ACTIONS(1057),
    [anon_sym_const] = ACTIONS(1059),
    [anon_sym_restrict] = ACTIONS(1057),
    [anon_sym_volatile] = ACTIONS(1057),
    [anon_sym__Atomic] = ACTIONS(1057),
    [anon_sym_mutable] = ACTIONS(1057),
    [anon_sym_explicit] = ACTIONS(1057),
    [anon_sym_constexpr] = ACTIONS(1057),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_DASH_GT] = ACTIONS(1057),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1057),
    [anon_sym_override] = ACTIONS(1057),
    [anon_sym_GT2] = ACTIONS(1057),
    [sym_noexcept] = ACTIONS(1057),
    [anon_sym_COLON_COLON] = ACTIONS(758),
  },
  [2886] = {
    [sym_field_declaration_list] = STATE(617),
    [sym_virtual_specifier] = STATE(620),
    [sym_base_class_clause] = STATE(618),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_RPAREN] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_LBRACE] = ACTIONS(1069),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1069),
    [anon_sym_EQ] = ACTIONS(1069),
    [anon_sym_const] = ACTIONS(1071),
    [anon_sym_restrict] = ACTIONS(1069),
    [anon_sym_volatile] = ACTIONS(1069),
    [anon_sym__Atomic] = ACTIONS(1069),
    [anon_sym_mutable] = ACTIONS(1069),
    [anon_sym_explicit] = ACTIONS(1069),
    [anon_sym_constexpr] = ACTIONS(1069),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1069),
    [anon_sym_DASH_GT] = ACTIONS(1069),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1069),
    [anon_sym_override] = ACTIONS(1069),
    [anon_sym_GT2] = ACTIONS(1069),
    [sym_noexcept] = ACTIONS(1069),
    [anon_sym_COLON_COLON] = ACTIONS(772),
  },
  [2887] = {
    [sym_field_declaration_list] = STATE(617),
    [sym_virtual_specifier] = STATE(620),
    [sym_base_class_clause] = STATE(618),
    [sym_template_argument_list] = STATE(362),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_RPAREN] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_LBRACE] = ACTIONS(1069),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1069),
    [anon_sym_EQ] = ACTIONS(1069),
    [anon_sym_const] = ACTIONS(1071),
    [anon_sym_restrict] = ACTIONS(1069),
    [anon_sym_volatile] = ACTIONS(1069),
    [anon_sym__Atomic] = ACTIONS(1069),
    [anon_sym_mutable] = ACTIONS(1069),
    [anon_sym_explicit] = ACTIONS(1069),
    [anon_sym_constexpr] = ACTIONS(1069),
    [anon_sym_COLON] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1069),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_DASH_GT] = ACTIONS(1069),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1069),
    [anon_sym_override] = ACTIONS(1069),
    [anon_sym_GT2] = ACTIONS(1069),
    [sym_noexcept] = ACTIONS(1069),
  },
  [2888] = {
    [sym_field_declaration_list] = STATE(621),
    [sym_virtual_specifier] = STATE(622),
    [sym_base_class_clause] = STATE(623),
    [sym_template_argument_list] = STATE(437),
    [anon_sym_COMMA] = ACTIONS(1077),
    [anon_sym_RPAREN] = ACTIONS(1077),
    [anon_sym_SEMI] = ACTIONS(1077),
    [anon_sym_LBRACE] = ACTIONS(1077),
    [anon_sym_LPAREN2] = ACTIONS(1077),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_LBRACK] = ACTIONS(1077),
    [anon_sym_EQ] = ACTIONS(1077),
    [anon_sym_const] = ACTIONS(1079),
    [anon_sym_restrict] = ACTIONS(1077),
    [anon_sym_volatile] = ACTIONS(1077),
    [anon_sym__Atomic] = ACTIONS(1077),
    [anon_sym_mutable] = ACTIONS(1077),
    [anon_sym_explicit] = ACTIONS(1077),
    [anon_sym_constexpr] = ACTIONS(1077),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_DASH_GT] = ACTIONS(1077),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1077),
    [anon_sym_override] = ACTIONS(1077),
    [anon_sym_GT2] = ACTIONS(1077),
    [sym_noexcept] = ACTIONS(1077),
    [anon_sym_COLON_COLON] = ACTIONS(758),
  },
  [2889] = {
    [sym_field_declaration_list] = STATE(624),
    [sym_virtual_specifier] = STATE(626),
    [sym_base_class_clause] = STATE(625),
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_RPAREN] = ACTIONS(1081),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LBRACE] = ACTIONS(1081),
    [anon_sym_LPAREN2] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1081),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(1081),
    [anon_sym_const] = ACTIONS(1083),
    [anon_sym_restrict] = ACTIONS(1081),
    [anon_sym_volatile] = ACTIONS(1081),
    [anon_sym__Atomic] = ACTIONS(1081),
    [anon_sym_mutable] = ACTIONS(1081),
    [anon_sym_explicit] = ACTIONS(1081),
    [anon_sym_constexpr] = ACTIONS(1081),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(1081),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1081),
    [anon_sym_override] = ACTIONS(1081),
    [anon_sym_GT2] = ACTIONS(1081),
    [sym_noexcept] = ACTIONS(1081),
    [anon_sym_COLON_COLON] = ACTIONS(772),
  },
  [2890] = {
    [sym_field_declaration_list] = STATE(624),
    [sym_virtual_specifier] = STATE(626),
    [sym_base_class_clause] = STATE(625),
    [sym_template_argument_list] = STATE(362),
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_RPAREN] = ACTIONS(1081),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LBRACE] = ACTIONS(1081),
    [anon_sym_LPAREN2] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1081),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(1081),
    [anon_sym_const] = ACTIONS(1083),
    [anon_sym_restrict] = ACTIONS(1081),
    [anon_sym_volatile] = ACTIONS(1081),
    [anon_sym__Atomic] = ACTIONS(1081),
    [anon_sym_mutable] = ACTIONS(1081),
    [anon_sym_explicit] = ACTIONS(1081),
    [anon_sym_constexpr] = ACTIONS(1081),
    [anon_sym_COLON] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_DASH_GT] = ACTIONS(1081),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1081),
    [anon_sym_override] = ACTIONS(1081),
    [anon_sym_GT2] = ACTIONS(1081),
    [sym_noexcept] = ACTIONS(1081),
  },
  [2891] = {
    [sym_field_declaration_list] = STATE(790),
    [sym_virtual_specifier] = STATE(791),
    [sym_base_class_clause] = STATE(792),
    [sym_template_argument_list] = STATE(437),
    [anon_sym_COMMA] = ACTIONS(1438),
    [anon_sym_RPAREN] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1438),
    [anon_sym_LBRACE] = ACTIONS(1438),
    [anon_sym_LPAREN2] = ACTIONS(1438),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_LBRACK] = ACTIONS(1438),
    [anon_sym_EQ] = ACTIONS(1438),
    [anon_sym_const] = ACTIONS(1440),
    [anon_sym_restrict] = ACTIONS(1438),
    [anon_sym_volatile] = ACTIONS(1438),
    [anon_sym__Atomic] = ACTIONS(1438),
    [anon_sym_mutable] = ACTIONS(1438),
    [anon_sym_explicit] = ACTIONS(1438),
    [anon_sym_constexpr] = ACTIONS(1438),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_AMP_AMP] = ACTIONS(1438),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_DASH_GT] = ACTIONS(1438),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1438),
    [anon_sym_override] = ACTIONS(1438),
    [anon_sym_GT2] = ACTIONS(1438),
    [sym_noexcept] = ACTIONS(1438),
    [anon_sym_COLON_COLON] = ACTIONS(758),
  },
  [2892] = {
    [sym_field_declaration_list] = STATE(793),
    [sym_virtual_specifier] = STATE(795),
    [sym_base_class_clause] = STATE(794),
    [anon_sym_COMMA] = ACTIONS(1442),
    [anon_sym_RPAREN] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1442),
    [anon_sym_LBRACE] = ACTIONS(1442),
    [anon_sym_LPAREN2] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(1442),
    [anon_sym_EQ] = ACTIONS(1442),
    [anon_sym_const] = ACTIONS(1444),
    [anon_sym_restrict] = ACTIONS(1442),
    [anon_sym_volatile] = ACTIONS(1442),
    [anon_sym__Atomic] = ACTIONS(1442),
    [anon_sym_mutable] = ACTIONS(1442),
    [anon_sym_explicit] = ACTIONS(1442),
    [anon_sym_constexpr] = ACTIONS(1442),
    [anon_sym_COLON] = ACTIONS(309),
    [anon_sym_AMP] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1442),
    [anon_sym_DASH_GT] = ACTIONS(1442),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1442),
    [anon_sym_override] = ACTIONS(1442),
    [anon_sym_GT2] = ACTIONS(1442),
    [sym_noexcept] = ACTIONS(1442),
    [anon_sym_COLON_COLON] = ACTIONS(772),
  },
  [2893] = {
    [sym_field_declaration_list] = STATE(793),
    [sym_virtual_specifier] = STATE(795),
    [sym_base_class_clause] = STATE(794),
    [sym_template_argument_list] = STATE(362),
    [anon_sym_COMMA] = ACTIONS(1442),
    [anon_sym_RPAREN] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1442),
    [anon_sym_LBRACE] = ACTIONS(1442),
    [anon_sym_LPAREN2] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(1442),
    [anon_sym_EQ] = ACTIONS(1442),
    [anon_sym_const] = ACTIONS(1444),
    [anon_sym_restrict] = ACTIONS(1442),
    [anon_sym_volatile] = ACTIONS(1442),
    [anon_sym__Atomic] = ACTIONS(1442),
    [anon_sym_mutable] = ACTIONS(1442),
    [anon_sym_explicit] = ACTIONS(1442),
    [anon_sym_constexpr] = ACTIONS(1442),
    [anon_sym_COLON] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1442),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_DASH_GT] = ACTIONS(1442),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1442),
    [anon_sym_override] = ACTIONS(1442),
    [anon_sym_GT2] = ACTIONS(1442),
    [sym_noexcept] = ACTIONS(1442),
  },
  [2894] = {
    [sym__abstract_declarator] = STATE(3208),
    [sym_abstract_pointer_declarator] = STATE(3208),
    [sym_abstract_function_declarator] = STATE(3208),
    [sym_abstract_array_declarator] = STATE(3208),
    [sym_type_qualifier] = STATE(3209),
    [sym_parameter_list] = STATE(2897),
    [sym_abstract_reference_declarator] = STATE(3208),
    [aux_sym_type_definition_repeat1] = STATE(3209),
    [anon_sym_COMMA] = ACTIONS(2461),
    [anon_sym_SEMI] = ACTIONS(2461),
    [anon_sym_LBRACE] = ACTIONS(2461),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(6489),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_EQ] = ACTIONS(2461),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(6491),
    [anon_sym_AMP_AMP] = ACTIONS(6493),
    [anon_sym_DASH_GT] = ACTIONS(2461),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2461),
    [anon_sym_override] = ACTIONS(2461),
    [sym_noexcept] = ACTIONS(2461),
  },
  [2895] = {
    [sym__abstract_declarator] = STATE(3210),
    [sym_abstract_pointer_declarator] = STATE(3210),
    [sym_abstract_function_declarator] = STATE(3210),
    [sym_abstract_array_declarator] = STATE(3210),
    [sym_parameter_list] = STATE(2897),
    [sym_abstract_reference_declarator] = STATE(3210),
    [anon_sym_COMMA] = ACTIONS(2463),
    [anon_sym_SEMI] = ACTIONS(2463),
    [anon_sym_LBRACE] = ACTIONS(2463),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(6489),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_EQ] = ACTIONS(2463),
    [anon_sym_const] = ACTIONS(6555),
    [anon_sym_restrict] = ACTIONS(2463),
    [anon_sym_volatile] = ACTIONS(2463),
    [anon_sym__Atomic] = ACTIONS(2463),
    [anon_sym_mutable] = ACTIONS(2463),
    [anon_sym_explicit] = ACTIONS(2463),
    [anon_sym_constexpr] = ACTIONS(2463),
    [anon_sym_AMP] = ACTIONS(6491),
    [anon_sym_AMP_AMP] = ACTIONS(6493),
    [anon_sym_DASH_GT] = ACTIONS(2463),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2463),
    [anon_sym_override] = ACTIONS(2463),
    [sym_noexcept] = ACTIONS(2463),
  },
  [2896] = {
    [sym_parameter_list] = STATE(3211),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(6557),
    [anon_sym_const] = ACTIONS(6559),
    [anon_sym_restrict] = ACTIONS(6557),
    [anon_sym_volatile] = ACTIONS(6557),
    [anon_sym__Atomic] = ACTIONS(6557),
    [anon_sym_mutable] = ACTIONS(6557),
    [anon_sym_explicit] = ACTIONS(6557),
    [anon_sym_constexpr] = ACTIONS(6557),
    [anon_sym_DASH_GT] = ACTIONS(6557),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(6557),
    [anon_sym_override] = ACTIONS(6557),
    [sym_noexcept] = ACTIONS(6557),
  },
  [2897] = {
    [sym_type_qualifier] = STATE(3212),
    [sym_trailing_return_type] = STATE(971),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3212),
    [anon_sym_COMMA] = ACTIONS(1787),
    [anon_sym_SEMI] = ACTIONS(1787),
    [anon_sym_LBRACE] = ACTIONS(1787),
    [anon_sym_LPAREN2] = ACTIONS(1787),
    [anon_sym_LBRACK] = ACTIONS(1787),
    [anon_sym_EQ] = ACTIONS(1787),
    [anon_sym_const] = ACTIONS(6561),
    [anon_sym_restrict] = ACTIONS(1787),
    [anon_sym_volatile] = ACTIONS(1787),
    [anon_sym__Atomic] = ACTIONS(1787),
    [anon_sym_mutable] = ACTIONS(1787),
    [anon_sym_explicit] = ACTIONS(1787),
    [anon_sym_constexpr] = ACTIONS(1787),
    [anon_sym_DASH_GT] = ACTIONS(1787),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1787),
    [anon_sym_override] = ACTIONS(1787),
    [sym_noexcept] = ACTIONS(1787),
  },
  [2898] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2898),
    [anon_sym_COMMA] = ACTIONS(1985),
    [anon_sym_SEMI] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(1985),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1985),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_EQ] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1987),
    [anon_sym_restrict] = ACTIONS(1987),
    [anon_sym_volatile] = ACTIONS(1987),
    [anon_sym__Atomic] = ACTIONS(1987),
    [anon_sym_mutable] = ACTIONS(1987),
    [anon_sym_explicit] = ACTIONS(1987),
    [anon_sym_constexpr] = ACTIONS(1987),
    [anon_sym_unsigned] = ACTIONS(7243),
    [anon_sym_long] = ACTIONS(7243),
    [anon_sym_short] = ACTIONS(7243),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_DASH_GT] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1987),
    [anon_sym_override] = ACTIONS(1987),
    [sym_noexcept] = ACTIONS(1987),
  },
  [2899] = {
    [sym_parameter_list] = STATE(2359),
    [anon_sym_COMMA] = ACTIONS(4126),
    [anon_sym_RPAREN] = ACTIONS(4126),
    [anon_sym_LBRACE] = ACTIONS(4126),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(574),
    [anon_sym_EQ] = ACTIONS(4126),
    [sym_comment] = ACTIONS(91),
  },
  [2900] = {
    [sym_parameter_list] = STATE(2360),
    [anon_sym_COMMA] = ACTIONS(5889),
    [anon_sym_RPAREN] = ACTIONS(5889),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [sym_comment] = ACTIONS(91),
  },
  [2901] = {
    [sym_type_qualifier] = STATE(2901),
    [aux_sym_type_definition_repeat1] = STATE(2901),
    [anon_sym_COMMA] = ACTIONS(2179),
    [anon_sym_RPAREN] = ACTIONS(2179),
    [anon_sym_LPAREN2] = ACTIONS(2179),
    [anon_sym_STAR] = ACTIONS(2179),
    [anon_sym_LBRACK] = ACTIONS(2179),
    [anon_sym_const] = ACTIONS(2538),
    [anon_sym_restrict] = ACTIONS(2538),
    [anon_sym_volatile] = ACTIONS(2538),
    [anon_sym__Atomic] = ACTIONS(2538),
    [anon_sym_mutable] = ACTIONS(2538),
    [anon_sym_explicit] = ACTIONS(2538),
    [anon_sym_constexpr] = ACTIONS(2538),
    [anon_sym_AMP] = ACTIONS(2177),
    [anon_sym_AMP_AMP] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2179),
    [sym_identifier] = ACTIONS(2177),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(2179),
    [sym_operator_name] = ACTIONS(2179),
  },
  [2902] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(5097),
    [anon_sym_RPAREN] = ACTIONS(5097),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2903] = {
    [sym__type_specifier] = STATE(3214),
    [sym_sized_type_specifier] = STATE(3214),
    [sym_enum_specifier] = STATE(3214),
    [sym_struct_specifier] = STATE(3214),
    [sym_union_specifier] = STATE(3214),
    [sym_macro_type_specifier] = STATE(3214),
    [sym_class_specifier] = STATE(3214),
    [sym_dependent_type] = STATE(3214),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3215),
    [anon_sym_unsigned] = ACTIONS(7246),
    [anon_sym_long] = ACTIONS(7246),
    [anon_sym_short] = ACTIONS(7246),
    [sym_primitive_type] = ACTIONS(7248),
    [anon_sym_enum] = ACTIONS(3675),
    [anon_sym_struct] = ACTIONS(5103),
    [anon_sym_union] = ACTIONS(5105),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5107),
    [sym_auto] = ACTIONS(7248),
    [anon_sym_typename] = ACTIONS(7250),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [2904] = {
    [sym_type_qualifier] = STATE(3216),
    [sym_virtual_specifier] = STATE(3216),
    [sym_trailing_return_type] = STATE(3216),
    [aux_sym_function_declarator_repeat1] = STATE(3216),
    [anon_sym_COMMA] = ACTIONS(3549),
    [anon_sym_RPAREN] = ACTIONS(3549),
    [anon_sym_LBRACE] = ACTIONS(3549),
    [anon_sym_LPAREN2] = ACTIONS(3549),
    [anon_sym_LBRACK] = ACTIONS(3549),
    [anon_sym_EQ] = ACTIONS(3549),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(6522),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [sym_noexcept] = ACTIONS(7252),
  },
  [2905] = {
    [sym_type_qualifier] = STATE(2909),
    [sym_trailing_return_type] = STATE(2418),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2909),
    [anon_sym_COMMA] = ACTIONS(5331),
    [anon_sym_RPAREN] = ACTIONS(5331),
    [anon_sym_LPAREN2] = ACTIONS(5331),
    [anon_sym_LBRACK] = ACTIONS(5331),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(5140),
    [sym_comment] = ACTIONS(91),
    [sym_noexcept] = ACTIONS(6534),
  },
  [2906] = {
    [sym__type_specifier] = STATE(271),
    [sym_sized_type_specifier] = STATE(271),
    [sym_enum_specifier] = STATE(271),
    [sym_struct_specifier] = STATE(271),
    [sym_union_specifier] = STATE(271),
    [sym_macro_type_specifier] = STATE(271),
    [sym_class_specifier] = STATE(271),
    [sym_dependent_type] = STATE(271),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2908),
    [anon_sym_unsigned] = ACTIONS(6528),
    [anon_sym_long] = ACTIONS(6528),
    [anon_sym_short] = ACTIONS(6528),
    [sym_primitive_type] = ACTIONS(490),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(223),
    [anon_sym_union] = ACTIONS(225),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(245),
    [sym_auto] = ACTIONS(490),
    [anon_sym_typename] = ACTIONS(6532),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [2907] = {
    [sym__abstract_declarator] = STATE(3219),
    [sym_abstract_pointer_declarator] = STATE(3219),
    [sym_abstract_function_declarator] = STATE(3219),
    [sym_abstract_array_declarator] = STATE(3219),
    [sym_parameter_list] = STATE(1654),
    [sym_abstract_reference_declarator] = STATE(3219),
    [anon_sym_COMMA] = ACTIONS(5222),
    [anon_sym_RPAREN] = ACTIONS(5222),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(7254),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_AMP] = ACTIONS(7256),
    [anon_sym_AMP_AMP] = ACTIONS(7258),
    [sym_comment] = ACTIONS(91),
  },
  [2908] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3220),
    [anon_sym_COMMA] = ACTIONS(653),
    [anon_sym_RPAREN] = ACTIONS(653),
    [anon_sym_LPAREN2] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_unsigned] = ACTIONS(7260),
    [anon_sym_long] = ACTIONS(7260),
    [anon_sym_short] = ACTIONS(7260),
    [sym_primitive_type] = ACTIONS(659),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [sym_identifier] = ACTIONS(933),
    [sym_comment] = ACTIONS(91),
  },
  [2909] = {
    [sym_type_qualifier] = STATE(2909),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(2909),
    [anon_sym_COMMA] = ACTIONS(5351),
    [anon_sym_RPAREN] = ACTIONS(5351),
    [anon_sym_LPAREN2] = ACTIONS(5351),
    [anon_sym_LBRACK] = ACTIONS(5351),
    [anon_sym_const] = ACTIONS(5353),
    [anon_sym_restrict] = ACTIONS(5356),
    [anon_sym_volatile] = ACTIONS(5356),
    [anon_sym__Atomic] = ACTIONS(5356),
    [anon_sym_mutable] = ACTIONS(5356),
    [anon_sym_explicit] = ACTIONS(5356),
    [anon_sym_constexpr] = ACTIONS(5356),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [sym_comment] = ACTIONS(91),
    [sym_noexcept] = ACTIONS(7262),
  },
  [2910] = {
    [sym__expression] = STATE(1200),
    [sym_conditional_expression] = STATE(1200),
    [sym_assignment_expression] = STATE(1200),
    [sym_pointer_expression] = STATE(1200),
    [sym_logical_expression] = STATE(1200),
    [sym_bitwise_expression] = STATE(1200),
    [sym_equality_expression] = STATE(1200),
    [sym_relational_expression] = STATE(1200),
    [sym_shift_expression] = STATE(1200),
    [sym_math_expression] = STATE(1200),
    [sym_cast_expression] = STATE(1200),
    [sym_sizeof_expression] = STATE(1200),
    [sym_subscript_expression] = STATE(1200),
    [sym_call_expression] = STATE(1200),
    [sym_field_expression] = STATE(1200),
    [sym_compound_literal_expression] = STATE(1200),
    [sym_parenthesized_expression] = STATE(1200),
    [sym_initializer_list] = STATE(1201),
    [sym_char_literal] = STATE(1200),
    [sym_concatenated_string] = STATE(1200),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1200),
    [sym_new_expression] = STATE(1200),
    [sym_delete_expression] = STATE(1200),
    [sym_lambda_expression] = STATE(1200),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2523),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(7265),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(4689),
    [anon_sym_EQ] = ACTIONS(4693),
    [anon_sym_QMARK] = ACTIONS(4689),
    [anon_sym_STAR_EQ] = ACTIONS(4689),
    [anon_sym_SLASH_EQ] = ACTIONS(4689),
    [anon_sym_PERCENT_EQ] = ACTIONS(4689),
    [anon_sym_PLUS_EQ] = ACTIONS(4689),
    [anon_sym_DASH_EQ] = ACTIONS(4689),
    [anon_sym_LT_LT_EQ] = ACTIONS(4689),
    [anon_sym_GT_GT_EQ] = ACTIONS(4689),
    [anon_sym_AMP_EQ] = ACTIONS(4689),
    [anon_sym_CARET_EQ] = ACTIONS(4689),
    [anon_sym_PIPE_EQ] = ACTIONS(4689),
    [anon_sym_AMP] = ACTIONS(7265),
    [anon_sym_PIPE_PIPE] = ACTIONS(4689),
    [anon_sym_AMP_AMP] = ACTIONS(4689),
    [anon_sym_BANG] = ACTIONS(7267),
    [anon_sym_PIPE] = ACTIONS(4693),
    [anon_sym_CARET] = ACTIONS(4693),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_EQ_EQ] = ACTIONS(4689),
    [anon_sym_BANG_EQ] = ACTIONS(4689),
    [anon_sym_LT] = ACTIONS(4693),
    [anon_sym_GT] = ACTIONS(4693),
    [anon_sym_LT_EQ] = ACTIONS(4689),
    [anon_sym_GT_EQ] = ACTIONS(4689),
    [anon_sym_LT_LT] = ACTIONS(4693),
    [anon_sym_GT_GT] = ACTIONS(4693),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_SLASH] = ACTIONS(4693),
    [anon_sym_PERCENT] = ACTIONS(4693),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [anon_sym_DOT] = ACTIONS(4689),
    [anon_sym_DASH_GT] = ACTIONS(4689),
    [sym_number_literal] = ACTIONS(2523),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2525),
    [sym_false] = ACTIONS(2525),
    [sym_null] = ACTIONS(2525),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(2525),
  },
  [2911] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(4927),
    [anon_sym_EQ] = ACTIONS(4929),
    [anon_sym_QMARK] = ACTIONS(4927),
    [anon_sym_STAR_EQ] = ACTIONS(4927),
    [anon_sym_SLASH_EQ] = ACTIONS(4927),
    [anon_sym_PERCENT_EQ] = ACTIONS(4927),
    [anon_sym_PLUS_EQ] = ACTIONS(4927),
    [anon_sym_DASH_EQ] = ACTIONS(4927),
    [anon_sym_LT_LT_EQ] = ACTIONS(4927),
    [anon_sym_GT_GT_EQ] = ACTIONS(4927),
    [anon_sym_AMP_EQ] = ACTIONS(4927),
    [anon_sym_CARET_EQ] = ACTIONS(4927),
    [anon_sym_PIPE_EQ] = ACTIONS(4927),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_CARET] = ACTIONS(3517),
    [anon_sym_EQ_EQ] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3521),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3525),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2912] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(7269),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_STAR_EQ] = ACTIONS(3507),
    [anon_sym_SLASH_EQ] = ACTIONS(3507),
    [anon_sym_PERCENT_EQ] = ACTIONS(3507),
    [anon_sym_PLUS_EQ] = ACTIONS(3507),
    [anon_sym_DASH_EQ] = ACTIONS(3507),
    [anon_sym_LT_LT_EQ] = ACTIONS(3507),
    [anon_sym_GT_GT_EQ] = ACTIONS(3507),
    [anon_sym_AMP_EQ] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(3507),
    [anon_sym_PIPE_EQ] = ACTIONS(3507),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_CARET] = ACTIONS(3517),
    [anon_sym_EQ_EQ] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3521),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3525),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2913] = {
    [sym__expression] = STATE(3222),
    [sym_conditional_expression] = STATE(3222),
    [sym_assignment_expression] = STATE(3222),
    [sym_pointer_expression] = STATE(3222),
    [sym_logical_expression] = STATE(3222),
    [sym_bitwise_expression] = STATE(3222),
    [sym_equality_expression] = STATE(3222),
    [sym_relational_expression] = STATE(3222),
    [sym_shift_expression] = STATE(3222),
    [sym_math_expression] = STATE(3222),
    [sym_cast_expression] = STATE(3222),
    [sym_sizeof_expression] = STATE(3222),
    [sym_subscript_expression] = STATE(3222),
    [sym_call_expression] = STATE(3222),
    [sym_field_expression] = STATE(3222),
    [sym_compound_literal_expression] = STATE(3222),
    [sym_parenthesized_expression] = STATE(3222),
    [sym_char_literal] = STATE(3222),
    [sym_concatenated_string] = STATE(3222),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3222),
    [sym_new_expression] = STATE(3222),
    [sym_delete_expression] = STATE(3222),
    [sym_lambda_expression] = STATE(3222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7271),
    [anon_sym_LPAREN2] = ACTIONS(947),
    [anon_sym_STAR] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(947),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(7271),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7273),
    [sym_false] = ACTIONS(7273),
    [sym_null] = ACTIONS(7273),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(7273),
  },
  [2914] = {
    [sym__expression] = STATE(3223),
    [sym_conditional_expression] = STATE(3223),
    [sym_assignment_expression] = STATE(3223),
    [sym_pointer_expression] = STATE(3223),
    [sym_logical_expression] = STATE(3223),
    [sym_bitwise_expression] = STATE(3223),
    [sym_equality_expression] = STATE(3223),
    [sym_relational_expression] = STATE(3223),
    [sym_shift_expression] = STATE(3223),
    [sym_math_expression] = STATE(3223),
    [sym_cast_expression] = STATE(3223),
    [sym_sizeof_expression] = STATE(3223),
    [sym_subscript_expression] = STATE(3223),
    [sym_call_expression] = STATE(3223),
    [sym_field_expression] = STATE(3223),
    [sym_compound_literal_expression] = STATE(3223),
    [sym_parenthesized_expression] = STATE(3223),
    [sym_char_literal] = STATE(3223),
    [sym_concatenated_string] = STATE(3223),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3223),
    [sym_new_expression] = STATE(3223),
    [sym_delete_expression] = STATE(3223),
    [sym_lambda_expression] = STATE(3223),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7275),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(7275),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7277),
    [sym_false] = ACTIONS(7277),
    [sym_null] = ACTIONS(7277),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(7277),
  },
  [2915] = {
    [sym_parameter_list] = STATE(2918),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(4157),
    [anon_sym_const] = ACTIONS(7279),
    [anon_sym_restrict] = ACTIONS(4157),
    [anon_sym_volatile] = ACTIONS(4157),
    [anon_sym__Atomic] = ACTIONS(4157),
    [anon_sym_mutable] = ACTIONS(4157),
    [anon_sym_explicit] = ACTIONS(4157),
    [anon_sym_constexpr] = ACTIONS(4157),
    [anon_sym_COLON] = ACTIONS(4157),
    [anon_sym_DASH_GT] = ACTIONS(4157),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4157),
    [anon_sym_override] = ACTIONS(4157),
    [sym_noexcept] = ACTIONS(4157),
  },
  [2916] = {
    [sym__abstract_declarator] = STATE(3224),
    [sym_abstract_pointer_declarator] = STATE(3224),
    [sym_abstract_function_declarator] = STATE(3224),
    [sym_abstract_array_declarator] = STATE(3224),
    [sym_type_qualifier] = STATE(3225),
    [sym_parameter_list] = STATE(2399),
    [sym_abstract_reference_declarator] = STATE(3224),
    [aux_sym_type_definition_repeat1] = STATE(3225),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(5224),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_EQ] = ACTIONS(4157),
    [anon_sym_const] = ACTIONS(1667),
    [anon_sym_restrict] = ACTIONS(1669),
    [anon_sym_volatile] = ACTIONS(1669),
    [anon_sym__Atomic] = ACTIONS(1669),
    [anon_sym_mutable] = ACTIONS(1669),
    [anon_sym_explicit] = ACTIONS(1669),
    [anon_sym_constexpr] = ACTIONS(1669),
    [anon_sym_COLON] = ACTIONS(4157),
    [anon_sym_AMP] = ACTIONS(5228),
    [anon_sym_AMP_AMP] = ACTIONS(5230),
    [anon_sym_DASH_GT] = ACTIONS(4157),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4157),
    [anon_sym_override] = ACTIONS(4157),
    [sym_noexcept] = ACTIONS(4157),
  },
  [2917] = {
    [sym_parameter_list] = STATE(2918),
    [anon_sym_LBRACE] = ACTIONS(4159),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_const] = ACTIONS(7281),
    [anon_sym_restrict] = ACTIONS(4159),
    [anon_sym_volatile] = ACTIONS(4159),
    [anon_sym__Atomic] = ACTIONS(4159),
    [anon_sym_mutable] = ACTIONS(4159),
    [anon_sym_explicit] = ACTIONS(4159),
    [anon_sym_constexpr] = ACTIONS(4159),
    [anon_sym_COLON] = ACTIONS(4159),
    [anon_sym_DASH_GT] = ACTIONS(4159),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4159),
    [anon_sym_override] = ACTIONS(4159),
    [sym_noexcept] = ACTIONS(4159),
  },
  [2918] = {
    [sym_type_qualifier] = STATE(3226),
    [sym_trailing_return_type] = STATE(1720),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3226),
    [anon_sym_LBRACE] = ACTIONS(3663),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_EQ] = ACTIONS(3663),
    [anon_sym_const] = ACTIONS(3685),
    [anon_sym_restrict] = ACTIONS(3663),
    [anon_sym_volatile] = ACTIONS(3663),
    [anon_sym__Atomic] = ACTIONS(3663),
    [anon_sym_mutable] = ACTIONS(3663),
    [anon_sym_explicit] = ACTIONS(3663),
    [anon_sym_constexpr] = ACTIONS(3663),
    [anon_sym_COLON] = ACTIONS(3663),
    [anon_sym_DASH_GT] = ACTIONS(3663),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3663),
    [anon_sym_override] = ACTIONS(3663),
    [sym_noexcept] = ACTIONS(3663),
  },
  [2919] = {
    [sym_type_qualifier] = STATE(3227),
    [sym_trailing_return_type] = STATE(1720),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3227),
    [anon_sym_LBRACE] = ACTIONS(3663),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_EQ] = ACTIONS(3663),
    [anon_sym_const] = ACTIONS(1667),
    [anon_sym_restrict] = ACTIONS(1669),
    [anon_sym_volatile] = ACTIONS(1669),
    [anon_sym__Atomic] = ACTIONS(1669),
    [anon_sym_mutable] = ACTIONS(1669),
    [anon_sym_explicit] = ACTIONS(1669),
    [anon_sym_constexpr] = ACTIONS(1669),
    [anon_sym_COLON] = ACTIONS(3663),
    [anon_sym_DASH_GT] = ACTIONS(1671),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3663),
    [anon_sym_override] = ACTIONS(3663),
    [sym_noexcept] = ACTIONS(7283),
  },
  [2920] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2920),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1985),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_unsigned] = ACTIONS(7285),
    [anon_sym_long] = ACTIONS(7285),
    [anon_sym_short] = ACTIONS(7285),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [sym_comment] = ACTIONS(91),
  },
  [2921] = {
    [anon_sym_COMMA] = ACTIONS(7288),
    [anon_sym_RPAREN] = ACTIONS(7288),
    [anon_sym_SEMI] = ACTIONS(7288),
    [anon_sym_LBRACE] = ACTIONS(7288),
    [anon_sym_LPAREN2] = ACTIONS(7288),
    [anon_sym_LBRACK] = ACTIONS(7288),
    [anon_sym_EQ] = ACTIONS(7288),
    [anon_sym_const] = ACTIONS(7290),
    [anon_sym_restrict] = ACTIONS(7288),
    [anon_sym_volatile] = ACTIONS(7288),
    [anon_sym__Atomic] = ACTIONS(7288),
    [anon_sym_mutable] = ACTIONS(7288),
    [anon_sym_explicit] = ACTIONS(7288),
    [anon_sym_constexpr] = ACTIONS(7288),
    [anon_sym_COLON] = ACTIONS(7288),
    [anon_sym_DASH_GT] = ACTIONS(7288),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(7288),
    [anon_sym_override] = ACTIONS(7288),
    [anon_sym_GT2] = ACTIONS(7288),
    [sym_noexcept] = ACTIONS(7288),
  },
  [2922] = {
    [sym_parameter_list] = STATE(968),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [sym_comment] = ACTIONS(91),
  },
  [2923] = {
    [sym__abstract_declarator] = STATE(3228),
    [sym_abstract_pointer_declarator] = STATE(3228),
    [sym_abstract_function_declarator] = STATE(3228),
    [sym_abstract_array_declarator] = STATE(3228),
    [sym_type_qualifier] = STATE(3229),
    [sym_parameter_list] = STATE(359),
    [sym_abstract_reference_declarator] = STATE(3228),
    [aux_sym_type_definition_repeat1] = STATE(3229),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(5343),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5347),
    [sym_comment] = ACTIONS(91),
  },
  [2924] = {
    [sym_parameter_list] = STATE(968),
    [anon_sym_LBRACE] = ACTIONS(4159),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [sym_comment] = ACTIONS(91),
  },
  [2925] = {
    [sym_raw_string_literal] = ACTIONS(5376),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5378),
    [sym_preproc_directive] = ACTIONS(5378),
    [anon_sym_SEMI] = ACTIONS(5376),
    [anon_sym_typedef] = ACTIONS(5378),
    [anon_sym_extern] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(5376),
    [anon_sym_LPAREN2] = ACTIONS(5376),
    [anon_sym_STAR] = ACTIONS(5376),
    [anon_sym_LBRACK] = ACTIONS(5376),
    [anon_sym_static] = ACTIONS(5378),
    [anon_sym_register] = ACTIONS(5378),
    [anon_sym_inline] = ACTIONS(5378),
    [anon_sym_const] = ACTIONS(5378),
    [anon_sym_restrict] = ACTIONS(5378),
    [anon_sym_volatile] = ACTIONS(5378),
    [anon_sym__Atomic] = ACTIONS(5378),
    [anon_sym_mutable] = ACTIONS(5378),
    [anon_sym_explicit] = ACTIONS(5378),
    [anon_sym_constexpr] = ACTIONS(5378),
    [anon_sym_unsigned] = ACTIONS(5378),
    [anon_sym_long] = ACTIONS(5378),
    [anon_sym_short] = ACTIONS(5378),
    [sym_primitive_type] = ACTIONS(5378),
    [anon_sym_enum] = ACTIONS(5378),
    [anon_sym_struct] = ACTIONS(5378),
    [anon_sym_union] = ACTIONS(5378),
    [anon_sym_if] = ACTIONS(5378),
    [anon_sym_switch] = ACTIONS(5378),
    [anon_sym_case] = ACTIONS(5378),
    [anon_sym_default] = ACTIONS(5378),
    [anon_sym_while] = ACTIONS(5378),
    [anon_sym_do] = ACTIONS(5378),
    [anon_sym_for] = ACTIONS(5378),
    [anon_sym_return] = ACTIONS(5378),
    [anon_sym_break] = ACTIONS(5378),
    [anon_sym_continue] = ACTIONS(5378),
    [anon_sym_goto] = ACTIONS(5378),
    [anon_sym_AMP] = ACTIONS(5378),
    [anon_sym_AMP_AMP] = ACTIONS(5376),
    [anon_sym_BANG] = ACTIONS(5376),
    [anon_sym_TILDE] = ACTIONS(5376),
    [anon_sym_PLUS] = ACTIONS(5378),
    [anon_sym_DASH] = ACTIONS(5378),
    [anon_sym_DASH_DASH] = ACTIONS(5376),
    [anon_sym_PLUS_PLUS] = ACTIONS(5376),
    [anon_sym_sizeof] = ACTIONS(5378),
    [sym_number_literal] = ACTIONS(5376),
    [anon_sym_SQUOTE] = ACTIONS(5376),
    [anon_sym_DQUOTE] = ACTIONS(5376),
    [sym_true] = ACTIONS(5378),
    [sym_false] = ACTIONS(5378),
    [sym_null] = ACTIONS(5378),
    [sym_identifier] = ACTIONS(5378),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5378),
    [sym_auto] = ACTIONS(5378),
    [anon_sym_typename] = ACTIONS(5378),
    [anon_sym_template] = ACTIONS(5378),
    [anon_sym_delete] = ACTIONS(5378),
    [anon_sym_namespace] = ACTIONS(5378),
    [anon_sym_using] = ACTIONS(5378),
    [anon_sym_try] = ACTIONS(5378),
    [anon_sym_new] = ACTIONS(5378),
    [anon_sym_COLON_COLON] = ACTIONS(5376),
    [sym_operator_name] = ACTIONS(5376),
    [sym_nullptr] = ACTIONS(5378),
  },
  [2926] = {
    [sym_raw_string_literal] = ACTIONS(5591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5593),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5593),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5593),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5593),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5593),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5593),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5593),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5593),
    [sym_preproc_directive] = ACTIONS(5593),
    [anon_sym_SEMI] = ACTIONS(5591),
    [anon_sym_typedef] = ACTIONS(5593),
    [anon_sym_extern] = ACTIONS(5593),
    [anon_sym_LBRACE] = ACTIONS(5591),
    [anon_sym_LPAREN2] = ACTIONS(5591),
    [anon_sym_STAR] = ACTIONS(5591),
    [anon_sym_LBRACK] = ACTIONS(5591),
    [anon_sym_static] = ACTIONS(5593),
    [anon_sym_register] = ACTIONS(5593),
    [anon_sym_inline] = ACTIONS(5593),
    [anon_sym_const] = ACTIONS(5593),
    [anon_sym_restrict] = ACTIONS(5593),
    [anon_sym_volatile] = ACTIONS(5593),
    [anon_sym__Atomic] = ACTIONS(5593),
    [anon_sym_mutable] = ACTIONS(5593),
    [anon_sym_explicit] = ACTIONS(5593),
    [anon_sym_constexpr] = ACTIONS(5593),
    [anon_sym_unsigned] = ACTIONS(5593),
    [anon_sym_long] = ACTIONS(5593),
    [anon_sym_short] = ACTIONS(5593),
    [sym_primitive_type] = ACTIONS(5593),
    [anon_sym_enum] = ACTIONS(5593),
    [anon_sym_struct] = ACTIONS(5593),
    [anon_sym_union] = ACTIONS(5593),
    [anon_sym_if] = ACTIONS(5593),
    [anon_sym_switch] = ACTIONS(5593),
    [anon_sym_case] = ACTIONS(5593),
    [anon_sym_default] = ACTIONS(5593),
    [anon_sym_while] = ACTIONS(5593),
    [anon_sym_do] = ACTIONS(5593),
    [anon_sym_for] = ACTIONS(5593),
    [anon_sym_return] = ACTIONS(5593),
    [anon_sym_break] = ACTIONS(5593),
    [anon_sym_continue] = ACTIONS(5593),
    [anon_sym_goto] = ACTIONS(5593),
    [anon_sym_AMP] = ACTIONS(5593),
    [anon_sym_AMP_AMP] = ACTIONS(5591),
    [anon_sym_BANG] = ACTIONS(5591),
    [anon_sym_TILDE] = ACTIONS(5591),
    [anon_sym_PLUS] = ACTIONS(5593),
    [anon_sym_DASH] = ACTIONS(5593),
    [anon_sym_DASH_DASH] = ACTIONS(5591),
    [anon_sym_PLUS_PLUS] = ACTIONS(5591),
    [anon_sym_sizeof] = ACTIONS(5593),
    [sym_number_literal] = ACTIONS(5591),
    [anon_sym_SQUOTE] = ACTIONS(5591),
    [anon_sym_DQUOTE] = ACTIONS(5591),
    [sym_true] = ACTIONS(5593),
    [sym_false] = ACTIONS(5593),
    [sym_null] = ACTIONS(5593),
    [sym_identifier] = ACTIONS(5593),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5593),
    [sym_auto] = ACTIONS(5593),
    [anon_sym_typename] = ACTIONS(5593),
    [anon_sym_template] = ACTIONS(5593),
    [anon_sym_delete] = ACTIONS(5593),
    [anon_sym_namespace] = ACTIONS(5593),
    [anon_sym_using] = ACTIONS(5593),
    [anon_sym_try] = ACTIONS(5593),
    [anon_sym_new] = ACTIONS(5593),
    [anon_sym_COLON_COLON] = ACTIONS(5591),
    [sym_operator_name] = ACTIONS(5591),
    [sym_nullptr] = ACTIONS(5593),
  },
  [2927] = {
    [sym_raw_string_literal] = ACTIONS(5595),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5597),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5597),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5597),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5597),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5597),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5597),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5597),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5597),
    [sym_preproc_directive] = ACTIONS(5597),
    [anon_sym_SEMI] = ACTIONS(5595),
    [anon_sym_typedef] = ACTIONS(5597),
    [anon_sym_extern] = ACTIONS(5597),
    [anon_sym_LBRACE] = ACTIONS(5595),
    [anon_sym_LPAREN2] = ACTIONS(5595),
    [anon_sym_STAR] = ACTIONS(5595),
    [anon_sym_LBRACK] = ACTIONS(5595),
    [anon_sym_static] = ACTIONS(5597),
    [anon_sym_register] = ACTIONS(5597),
    [anon_sym_inline] = ACTIONS(5597),
    [anon_sym_const] = ACTIONS(5597),
    [anon_sym_restrict] = ACTIONS(5597),
    [anon_sym_volatile] = ACTIONS(5597),
    [anon_sym__Atomic] = ACTIONS(5597),
    [anon_sym_mutable] = ACTIONS(5597),
    [anon_sym_explicit] = ACTIONS(5597),
    [anon_sym_constexpr] = ACTIONS(5597),
    [anon_sym_unsigned] = ACTIONS(5597),
    [anon_sym_long] = ACTIONS(5597),
    [anon_sym_short] = ACTIONS(5597),
    [sym_primitive_type] = ACTIONS(5597),
    [anon_sym_enum] = ACTIONS(5597),
    [anon_sym_struct] = ACTIONS(5597),
    [anon_sym_union] = ACTIONS(5597),
    [anon_sym_if] = ACTIONS(5597),
    [anon_sym_switch] = ACTIONS(5597),
    [anon_sym_case] = ACTIONS(5597),
    [anon_sym_default] = ACTIONS(5597),
    [anon_sym_while] = ACTIONS(5597),
    [anon_sym_do] = ACTIONS(5597),
    [anon_sym_for] = ACTIONS(5597),
    [anon_sym_return] = ACTIONS(5597),
    [anon_sym_break] = ACTIONS(5597),
    [anon_sym_continue] = ACTIONS(5597),
    [anon_sym_goto] = ACTIONS(5597),
    [anon_sym_AMP] = ACTIONS(5597),
    [anon_sym_AMP_AMP] = ACTIONS(5595),
    [anon_sym_BANG] = ACTIONS(5595),
    [anon_sym_TILDE] = ACTIONS(5595),
    [anon_sym_PLUS] = ACTIONS(5597),
    [anon_sym_DASH] = ACTIONS(5597),
    [anon_sym_DASH_DASH] = ACTIONS(5595),
    [anon_sym_PLUS_PLUS] = ACTIONS(5595),
    [anon_sym_sizeof] = ACTIONS(5597),
    [sym_number_literal] = ACTIONS(5595),
    [anon_sym_SQUOTE] = ACTIONS(5595),
    [anon_sym_DQUOTE] = ACTIONS(5595),
    [sym_true] = ACTIONS(5597),
    [sym_false] = ACTIONS(5597),
    [sym_null] = ACTIONS(5597),
    [sym_identifier] = ACTIONS(5597),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5597),
    [sym_auto] = ACTIONS(5597),
    [anon_sym_typename] = ACTIONS(5597),
    [anon_sym_template] = ACTIONS(5597),
    [anon_sym_delete] = ACTIONS(5597),
    [anon_sym_namespace] = ACTIONS(5597),
    [anon_sym_using] = ACTIONS(5597),
    [anon_sym_try] = ACTIONS(5597),
    [anon_sym_new] = ACTIONS(5597),
    [anon_sym_COLON_COLON] = ACTIONS(5595),
    [sym_operator_name] = ACTIONS(5595),
    [sym_nullptr] = ACTIONS(5597),
  },
  [2928] = {
    [sym_raw_string_literal] = ACTIONS(3063),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3065),
    [sym_preproc_directive] = ACTIONS(3065),
    [anon_sym_SEMI] = ACTIONS(3063),
    [anon_sym_typedef] = ACTIONS(3065),
    [anon_sym_extern] = ACTIONS(3065),
    [anon_sym_LBRACE] = ACTIONS(3063),
    [anon_sym_LPAREN2] = ACTIONS(3063),
    [anon_sym_STAR] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_static] = ACTIONS(3065),
    [anon_sym_register] = ACTIONS(3065),
    [anon_sym_inline] = ACTIONS(3065),
    [anon_sym_const] = ACTIONS(3065),
    [anon_sym_restrict] = ACTIONS(3065),
    [anon_sym_volatile] = ACTIONS(3065),
    [anon_sym__Atomic] = ACTIONS(3065),
    [anon_sym_mutable] = ACTIONS(3065),
    [anon_sym_explicit] = ACTIONS(3065),
    [anon_sym_constexpr] = ACTIONS(3065),
    [anon_sym_unsigned] = ACTIONS(3065),
    [anon_sym_long] = ACTIONS(3065),
    [anon_sym_short] = ACTIONS(3065),
    [sym_primitive_type] = ACTIONS(3065),
    [anon_sym_enum] = ACTIONS(3065),
    [anon_sym_struct] = ACTIONS(3065),
    [anon_sym_union] = ACTIONS(3065),
    [anon_sym_if] = ACTIONS(3065),
    [anon_sym_switch] = ACTIONS(3065),
    [anon_sym_case] = ACTIONS(3065),
    [anon_sym_default] = ACTIONS(3065),
    [anon_sym_while] = ACTIONS(3065),
    [anon_sym_do] = ACTIONS(3065),
    [anon_sym_for] = ACTIONS(3065),
    [anon_sym_return] = ACTIONS(3065),
    [anon_sym_break] = ACTIONS(3065),
    [anon_sym_continue] = ACTIONS(3065),
    [anon_sym_goto] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3065),
    [anon_sym_AMP_AMP] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3063),
    [anon_sym_TILDE] = ACTIONS(3063),
    [anon_sym_PLUS] = ACTIONS(3065),
    [anon_sym_DASH] = ACTIONS(3065),
    [anon_sym_DASH_DASH] = ACTIONS(3063),
    [anon_sym_PLUS_PLUS] = ACTIONS(3063),
    [anon_sym_sizeof] = ACTIONS(3065),
    [sym_number_literal] = ACTIONS(3063),
    [anon_sym_SQUOTE] = ACTIONS(3063),
    [anon_sym_DQUOTE] = ACTIONS(3063),
    [sym_true] = ACTIONS(3065),
    [sym_false] = ACTIONS(3065),
    [sym_null] = ACTIONS(3065),
    [sym_identifier] = ACTIONS(3065),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3065),
    [sym_auto] = ACTIONS(3065),
    [anon_sym_typename] = ACTIONS(3065),
    [anon_sym_template] = ACTIONS(3065),
    [anon_sym_delete] = ACTIONS(3065),
    [anon_sym_namespace] = ACTIONS(3065),
    [anon_sym_using] = ACTIONS(3065),
    [anon_sym_try] = ACTIONS(3065),
    [anon_sym_new] = ACTIONS(3065),
    [anon_sym_COLON_COLON] = ACTIONS(3063),
    [sym_operator_name] = ACTIONS(3063),
    [sym_nullptr] = ACTIONS(3065),
  },
  [2929] = {
    [sym_raw_string_literal] = ACTIONS(3707),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3709),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3709),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3709),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3709),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3709),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3709),
    [sym_preproc_directive] = ACTIONS(3709),
    [anon_sym_SEMI] = ACTIONS(3707),
    [anon_sym_typedef] = ACTIONS(3709),
    [anon_sym_extern] = ACTIONS(3709),
    [anon_sym_LBRACE] = ACTIONS(3707),
    [anon_sym_LPAREN2] = ACTIONS(3707),
    [anon_sym_STAR] = ACTIONS(3707),
    [anon_sym_LBRACK] = ACTIONS(3707),
    [anon_sym_static] = ACTIONS(3709),
    [anon_sym_register] = ACTIONS(3709),
    [anon_sym_inline] = ACTIONS(3709),
    [anon_sym_const] = ACTIONS(3709),
    [anon_sym_restrict] = ACTIONS(3709),
    [anon_sym_volatile] = ACTIONS(3709),
    [anon_sym__Atomic] = ACTIONS(3709),
    [anon_sym_mutable] = ACTIONS(3709),
    [anon_sym_explicit] = ACTIONS(3709),
    [anon_sym_constexpr] = ACTIONS(3709),
    [anon_sym_unsigned] = ACTIONS(3709),
    [anon_sym_long] = ACTIONS(3709),
    [anon_sym_short] = ACTIONS(3709),
    [sym_primitive_type] = ACTIONS(3709),
    [anon_sym_enum] = ACTIONS(3709),
    [anon_sym_struct] = ACTIONS(3709),
    [anon_sym_union] = ACTIONS(3709),
    [anon_sym_if] = ACTIONS(3709),
    [anon_sym_switch] = ACTIONS(3709),
    [anon_sym_case] = ACTIONS(3709),
    [anon_sym_default] = ACTIONS(3709),
    [anon_sym_while] = ACTIONS(3709),
    [anon_sym_do] = ACTIONS(3709),
    [anon_sym_for] = ACTIONS(3709),
    [anon_sym_return] = ACTIONS(3709),
    [anon_sym_break] = ACTIONS(3709),
    [anon_sym_continue] = ACTIONS(3709),
    [anon_sym_goto] = ACTIONS(3709),
    [anon_sym_AMP] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3707),
    [anon_sym_BANG] = ACTIONS(3707),
    [anon_sym_TILDE] = ACTIONS(3707),
    [anon_sym_PLUS] = ACTIONS(3709),
    [anon_sym_DASH] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3707),
    [anon_sym_PLUS_PLUS] = ACTIONS(3707),
    [anon_sym_sizeof] = ACTIONS(3709),
    [sym_number_literal] = ACTIONS(3707),
    [anon_sym_SQUOTE] = ACTIONS(3707),
    [anon_sym_DQUOTE] = ACTIONS(3707),
    [sym_true] = ACTIONS(3709),
    [sym_false] = ACTIONS(3709),
    [sym_null] = ACTIONS(3709),
    [sym_identifier] = ACTIONS(3709),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3709),
    [sym_auto] = ACTIONS(3709),
    [anon_sym_typename] = ACTIONS(3709),
    [anon_sym_template] = ACTIONS(3709),
    [anon_sym_delete] = ACTIONS(3709),
    [anon_sym_namespace] = ACTIONS(3709),
    [anon_sym_using] = ACTIONS(3709),
    [anon_sym_try] = ACTIONS(3709),
    [anon_sym_new] = ACTIONS(3709),
    [anon_sym_COLON_COLON] = ACTIONS(3707),
    [sym_operator_name] = ACTIONS(3707),
    [sym_nullptr] = ACTIONS(3709),
  },
  [2930] = {
    [sym_raw_string_literal] = ACTIONS(3711),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3713),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3713),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3713),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3713),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3713),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3713),
    [sym_preproc_directive] = ACTIONS(3713),
    [anon_sym_SEMI] = ACTIONS(3711),
    [anon_sym_typedef] = ACTIONS(3713),
    [anon_sym_extern] = ACTIONS(3713),
    [anon_sym_LBRACE] = ACTIONS(3711),
    [anon_sym_LPAREN2] = ACTIONS(3711),
    [anon_sym_STAR] = ACTIONS(3711),
    [anon_sym_LBRACK] = ACTIONS(3711),
    [anon_sym_static] = ACTIONS(3713),
    [anon_sym_register] = ACTIONS(3713),
    [anon_sym_inline] = ACTIONS(3713),
    [anon_sym_const] = ACTIONS(3713),
    [anon_sym_restrict] = ACTIONS(3713),
    [anon_sym_volatile] = ACTIONS(3713),
    [anon_sym__Atomic] = ACTIONS(3713),
    [anon_sym_mutable] = ACTIONS(3713),
    [anon_sym_explicit] = ACTIONS(3713),
    [anon_sym_constexpr] = ACTIONS(3713),
    [anon_sym_unsigned] = ACTIONS(3713),
    [anon_sym_long] = ACTIONS(3713),
    [anon_sym_short] = ACTIONS(3713),
    [sym_primitive_type] = ACTIONS(3713),
    [anon_sym_enum] = ACTIONS(3713),
    [anon_sym_struct] = ACTIONS(3713),
    [anon_sym_union] = ACTIONS(3713),
    [anon_sym_if] = ACTIONS(3713),
    [anon_sym_switch] = ACTIONS(3713),
    [anon_sym_case] = ACTIONS(3713),
    [anon_sym_default] = ACTIONS(3713),
    [anon_sym_while] = ACTIONS(3713),
    [anon_sym_do] = ACTIONS(3713),
    [anon_sym_for] = ACTIONS(3713),
    [anon_sym_return] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3713),
    [anon_sym_continue] = ACTIONS(3713),
    [anon_sym_goto] = ACTIONS(3713),
    [anon_sym_AMP] = ACTIONS(3713),
    [anon_sym_AMP_AMP] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3711),
    [anon_sym_TILDE] = ACTIONS(3711),
    [anon_sym_PLUS] = ACTIONS(3713),
    [anon_sym_DASH] = ACTIONS(3713),
    [anon_sym_DASH_DASH] = ACTIONS(3711),
    [anon_sym_PLUS_PLUS] = ACTIONS(3711),
    [anon_sym_sizeof] = ACTIONS(3713),
    [sym_number_literal] = ACTIONS(3711),
    [anon_sym_SQUOTE] = ACTIONS(3711),
    [anon_sym_DQUOTE] = ACTIONS(3711),
    [sym_true] = ACTIONS(3713),
    [sym_false] = ACTIONS(3713),
    [sym_null] = ACTIONS(3713),
    [sym_identifier] = ACTIONS(3713),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3713),
    [sym_auto] = ACTIONS(3713),
    [anon_sym_typename] = ACTIONS(3713),
    [anon_sym_template] = ACTIONS(3713),
    [anon_sym_delete] = ACTIONS(3713),
    [anon_sym_namespace] = ACTIONS(3713),
    [anon_sym_using] = ACTIONS(3713),
    [anon_sym_try] = ACTIONS(3713),
    [anon_sym_new] = ACTIONS(3713),
    [anon_sym_COLON_COLON] = ACTIONS(3711),
    [sym_operator_name] = ACTIONS(3711),
    [sym_nullptr] = ACTIONS(3713),
  },
  [2931] = {
    [anon_sym_LF] = ACTIONS(7292),
    [sym_comment] = ACTIONS(121),
  },
  [2932] = {
    [sym_raw_string_literal] = ACTIONS(3839),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3841),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3841),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3841),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3841),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3841),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3841),
    [sym_preproc_directive] = ACTIONS(3841),
    [anon_sym_SEMI] = ACTIONS(3839),
    [anon_sym_typedef] = ACTIONS(3841),
    [anon_sym_extern] = ACTIONS(3841),
    [anon_sym_LBRACE] = ACTIONS(3839),
    [anon_sym_LPAREN2] = ACTIONS(3839),
    [anon_sym_STAR] = ACTIONS(3839),
    [anon_sym_LBRACK] = ACTIONS(3839),
    [anon_sym_static] = ACTIONS(3841),
    [anon_sym_register] = ACTIONS(3841),
    [anon_sym_inline] = ACTIONS(3841),
    [anon_sym_const] = ACTIONS(3841),
    [anon_sym_restrict] = ACTIONS(3841),
    [anon_sym_volatile] = ACTIONS(3841),
    [anon_sym__Atomic] = ACTIONS(3841),
    [anon_sym_mutable] = ACTIONS(3841),
    [anon_sym_explicit] = ACTIONS(3841),
    [anon_sym_constexpr] = ACTIONS(3841),
    [anon_sym_unsigned] = ACTIONS(3841),
    [anon_sym_long] = ACTIONS(3841),
    [anon_sym_short] = ACTIONS(3841),
    [sym_primitive_type] = ACTIONS(3841),
    [anon_sym_enum] = ACTIONS(3841),
    [anon_sym_struct] = ACTIONS(3841),
    [anon_sym_union] = ACTIONS(3841),
    [anon_sym_if] = ACTIONS(3841),
    [anon_sym_switch] = ACTIONS(3841),
    [anon_sym_case] = ACTIONS(3841),
    [anon_sym_default] = ACTIONS(3841),
    [anon_sym_while] = ACTIONS(3841),
    [anon_sym_do] = ACTIONS(3841),
    [anon_sym_for] = ACTIONS(3841),
    [anon_sym_return] = ACTIONS(3841),
    [anon_sym_break] = ACTIONS(3841),
    [anon_sym_continue] = ACTIONS(3841),
    [anon_sym_goto] = ACTIONS(3841),
    [anon_sym_AMP] = ACTIONS(3841),
    [anon_sym_AMP_AMP] = ACTIONS(3839),
    [anon_sym_BANG] = ACTIONS(3839),
    [anon_sym_TILDE] = ACTIONS(3839),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_DASH_DASH] = ACTIONS(3839),
    [anon_sym_PLUS_PLUS] = ACTIONS(3839),
    [anon_sym_sizeof] = ACTIONS(3841),
    [sym_number_literal] = ACTIONS(3839),
    [anon_sym_SQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(3839),
    [sym_true] = ACTIONS(3841),
    [sym_false] = ACTIONS(3841),
    [sym_null] = ACTIONS(3841),
    [sym_identifier] = ACTIONS(3841),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3841),
    [sym_auto] = ACTIONS(3841),
    [anon_sym_typename] = ACTIONS(3841),
    [anon_sym_template] = ACTIONS(3841),
    [anon_sym_delete] = ACTIONS(3841),
    [anon_sym_namespace] = ACTIONS(3841),
    [anon_sym_using] = ACTIONS(3841),
    [anon_sym_try] = ACTIONS(3841),
    [anon_sym_new] = ACTIONS(3841),
    [anon_sym_COLON_COLON] = ACTIONS(3839),
    [sym_operator_name] = ACTIONS(3839),
    [sym_nullptr] = ACTIONS(3841),
  },
  [2933] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7294),
    [sym_comment] = ACTIONS(91),
  },
  [2934] = {
    [sym_raw_string_literal] = ACTIONS(3938),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3940),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3940),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3940),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3940),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3940),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3940),
    [sym_preproc_directive] = ACTIONS(3940),
    [anon_sym_SEMI] = ACTIONS(3938),
    [anon_sym_typedef] = ACTIONS(3940),
    [anon_sym_extern] = ACTIONS(3940),
    [anon_sym_LBRACE] = ACTIONS(3938),
    [anon_sym_LPAREN2] = ACTIONS(3938),
    [anon_sym_STAR] = ACTIONS(3938),
    [anon_sym_LBRACK] = ACTIONS(3938),
    [anon_sym_static] = ACTIONS(3940),
    [anon_sym_register] = ACTIONS(3940),
    [anon_sym_inline] = ACTIONS(3940),
    [anon_sym_const] = ACTIONS(3940),
    [anon_sym_restrict] = ACTIONS(3940),
    [anon_sym_volatile] = ACTIONS(3940),
    [anon_sym__Atomic] = ACTIONS(3940),
    [anon_sym_mutable] = ACTIONS(3940),
    [anon_sym_explicit] = ACTIONS(3940),
    [anon_sym_constexpr] = ACTIONS(3940),
    [anon_sym_unsigned] = ACTIONS(3940),
    [anon_sym_long] = ACTIONS(3940),
    [anon_sym_short] = ACTIONS(3940),
    [sym_primitive_type] = ACTIONS(3940),
    [anon_sym_enum] = ACTIONS(3940),
    [anon_sym_struct] = ACTIONS(3940),
    [anon_sym_union] = ACTIONS(3940),
    [anon_sym_if] = ACTIONS(3940),
    [anon_sym_switch] = ACTIONS(3940),
    [anon_sym_case] = ACTIONS(3940),
    [anon_sym_default] = ACTIONS(3940),
    [anon_sym_while] = ACTIONS(3940),
    [anon_sym_do] = ACTIONS(3940),
    [anon_sym_for] = ACTIONS(3940),
    [anon_sym_return] = ACTIONS(3940),
    [anon_sym_break] = ACTIONS(3940),
    [anon_sym_continue] = ACTIONS(3940),
    [anon_sym_goto] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3940),
    [anon_sym_AMP_AMP] = ACTIONS(3938),
    [anon_sym_BANG] = ACTIONS(3938),
    [anon_sym_TILDE] = ACTIONS(3938),
    [anon_sym_PLUS] = ACTIONS(3940),
    [anon_sym_DASH] = ACTIONS(3940),
    [anon_sym_DASH_DASH] = ACTIONS(3938),
    [anon_sym_PLUS_PLUS] = ACTIONS(3938),
    [anon_sym_sizeof] = ACTIONS(3940),
    [sym_number_literal] = ACTIONS(3938),
    [anon_sym_SQUOTE] = ACTIONS(3938),
    [anon_sym_DQUOTE] = ACTIONS(3938),
    [sym_true] = ACTIONS(3940),
    [sym_false] = ACTIONS(3940),
    [sym_null] = ACTIONS(3940),
    [sym_identifier] = ACTIONS(3940),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3940),
    [sym_auto] = ACTIONS(3940),
    [anon_sym_typename] = ACTIONS(3940),
    [anon_sym_template] = ACTIONS(3940),
    [anon_sym_delete] = ACTIONS(3940),
    [anon_sym_namespace] = ACTIONS(3940),
    [anon_sym_using] = ACTIONS(3940),
    [anon_sym_try] = ACTIONS(3940),
    [anon_sym_new] = ACTIONS(3940),
    [anon_sym_COLON_COLON] = ACTIONS(3938),
    [sym_operator_name] = ACTIONS(3938),
    [sym_nullptr] = ACTIONS(3940),
  },
  [2935] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7296),
    [sym_comment] = ACTIONS(91),
  },
  [2936] = {
    [sym_raw_string_literal] = ACTIONS(3958),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3960),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3960),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3960),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3960),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3960),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3960),
    [sym_preproc_directive] = ACTIONS(3960),
    [anon_sym_SEMI] = ACTIONS(3958),
    [anon_sym_typedef] = ACTIONS(3960),
    [anon_sym_extern] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3958),
    [anon_sym_LPAREN2] = ACTIONS(3958),
    [anon_sym_STAR] = ACTIONS(3958),
    [anon_sym_LBRACK] = ACTIONS(3958),
    [anon_sym_static] = ACTIONS(3960),
    [anon_sym_register] = ACTIONS(3960),
    [anon_sym_inline] = ACTIONS(3960),
    [anon_sym_const] = ACTIONS(3960),
    [anon_sym_restrict] = ACTIONS(3960),
    [anon_sym_volatile] = ACTIONS(3960),
    [anon_sym__Atomic] = ACTIONS(3960),
    [anon_sym_mutable] = ACTIONS(3960),
    [anon_sym_explicit] = ACTIONS(3960),
    [anon_sym_constexpr] = ACTIONS(3960),
    [anon_sym_unsigned] = ACTIONS(3960),
    [anon_sym_long] = ACTIONS(3960),
    [anon_sym_short] = ACTIONS(3960),
    [sym_primitive_type] = ACTIONS(3960),
    [anon_sym_enum] = ACTIONS(3960),
    [anon_sym_struct] = ACTIONS(3960),
    [anon_sym_union] = ACTIONS(3960),
    [anon_sym_if] = ACTIONS(3960),
    [anon_sym_else] = ACTIONS(3960),
    [anon_sym_switch] = ACTIONS(3960),
    [anon_sym_case] = ACTIONS(3960),
    [anon_sym_default] = ACTIONS(3960),
    [anon_sym_while] = ACTIONS(3960),
    [anon_sym_do] = ACTIONS(3960),
    [anon_sym_for] = ACTIONS(3960),
    [anon_sym_return] = ACTIONS(3960),
    [anon_sym_break] = ACTIONS(3960),
    [anon_sym_continue] = ACTIONS(3960),
    [anon_sym_goto] = ACTIONS(3960),
    [anon_sym_AMP] = ACTIONS(3960),
    [anon_sym_AMP_AMP] = ACTIONS(3958),
    [anon_sym_BANG] = ACTIONS(3958),
    [anon_sym_TILDE] = ACTIONS(3958),
    [anon_sym_PLUS] = ACTIONS(3960),
    [anon_sym_DASH] = ACTIONS(3960),
    [anon_sym_DASH_DASH] = ACTIONS(3958),
    [anon_sym_PLUS_PLUS] = ACTIONS(3958),
    [anon_sym_sizeof] = ACTIONS(3960),
    [sym_number_literal] = ACTIONS(3958),
    [anon_sym_SQUOTE] = ACTIONS(3958),
    [anon_sym_DQUOTE] = ACTIONS(3958),
    [sym_true] = ACTIONS(3960),
    [sym_false] = ACTIONS(3960),
    [sym_null] = ACTIONS(3960),
    [sym_identifier] = ACTIONS(3960),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3960),
    [sym_auto] = ACTIONS(3960),
    [anon_sym_typename] = ACTIONS(3960),
    [anon_sym_template] = ACTIONS(3960),
    [anon_sym_delete] = ACTIONS(3960),
    [anon_sym_namespace] = ACTIONS(3960),
    [anon_sym_using] = ACTIONS(3960),
    [anon_sym_try] = ACTIONS(3960),
    [anon_sym_new] = ACTIONS(3960),
    [anon_sym_COLON_COLON] = ACTIONS(3958),
    [sym_operator_name] = ACTIONS(3958),
    [sym_nullptr] = ACTIONS(3960),
  },
  [2937] = {
    [sym_parameter_list] = STATE(1105),
    [anon_sym_SEMI] = ACTIONS(7298),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [sym_comment] = ACTIONS(91),
  },
  [2938] = {
    [sym_compound_statement] = STATE(3242),
    [sym_labeled_statement] = STATE(3242),
    [sym_expression_statement] = STATE(3242),
    [sym_if_statement] = STATE(3242),
    [sym_switch_statement] = STATE(3242),
    [sym_case_statement] = STATE(3242),
    [sym_while_statement] = STATE(3242),
    [sym_do_statement] = STATE(3242),
    [sym_for_statement] = STATE(3242),
    [sym_return_statement] = STATE(3242),
    [sym_break_statement] = STATE(3242),
    [sym_continue_statement] = STATE(3242),
    [sym_goto_statement] = STATE(3242),
    [sym__expression] = STATE(1020),
    [sym_comma_expression] = STATE(1021),
    [sym_conditional_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1020),
    [sym_pointer_expression] = STATE(1020),
    [sym_logical_expression] = STATE(1020),
    [sym_bitwise_expression] = STATE(1020),
    [sym_equality_expression] = STATE(1020),
    [sym_relational_expression] = STATE(1020),
    [sym_shift_expression] = STATE(1020),
    [sym_math_expression] = STATE(1020),
    [sym_cast_expression] = STATE(1020),
    [sym_sizeof_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_field_expression] = STATE(1020),
    [sym_compound_literal_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_char_literal] = STATE(1020),
    [sym_concatenated_string] = STATE(1020),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1020),
    [sym_for_range_loop] = STATE(3242),
    [sym_try_statement] = STATE(3242),
    [sym_new_expression] = STATE(1020),
    [sym_delete_expression] = STATE(1020),
    [sym_lambda_expression] = STATE(1020),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2022),
    [anon_sym_SEMI] = ACTIONS(2036),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7300),
    [anon_sym_switch] = ACTIONS(7302),
    [anon_sym_case] = ACTIONS(7304),
    [anon_sym_default] = ACTIONS(7306),
    [anon_sym_while] = ACTIONS(7308),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(7310),
    [anon_sym_return] = ACTIONS(2058),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2062),
    [anon_sym_goto] = ACTIONS(2064),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(7312),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7314),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2066),
  },
  [2939] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(7316),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2940] = {
    [sym_raw_string_literal] = ACTIONS(4513),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4515),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4515),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4515),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4515),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4515),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4515),
    [sym_preproc_directive] = ACTIONS(4515),
    [anon_sym_SEMI] = ACTIONS(4513),
    [anon_sym_typedef] = ACTIONS(4515),
    [anon_sym_extern] = ACTIONS(4515),
    [anon_sym_LBRACE] = ACTIONS(4513),
    [anon_sym_LPAREN2] = ACTIONS(4513),
    [anon_sym_STAR] = ACTIONS(4513),
    [anon_sym_LBRACK] = ACTIONS(4513),
    [anon_sym_static] = ACTIONS(4515),
    [anon_sym_register] = ACTIONS(4515),
    [anon_sym_inline] = ACTIONS(4515),
    [anon_sym_const] = ACTIONS(4515),
    [anon_sym_restrict] = ACTIONS(4515),
    [anon_sym_volatile] = ACTIONS(4515),
    [anon_sym__Atomic] = ACTIONS(4515),
    [anon_sym_mutable] = ACTIONS(4515),
    [anon_sym_explicit] = ACTIONS(4515),
    [anon_sym_constexpr] = ACTIONS(4515),
    [anon_sym_unsigned] = ACTIONS(4515),
    [anon_sym_long] = ACTIONS(4515),
    [anon_sym_short] = ACTIONS(4515),
    [sym_primitive_type] = ACTIONS(4515),
    [anon_sym_enum] = ACTIONS(4515),
    [anon_sym_struct] = ACTIONS(4515),
    [anon_sym_union] = ACTIONS(4515),
    [anon_sym_if] = ACTIONS(4515),
    [anon_sym_else] = ACTIONS(4515),
    [anon_sym_switch] = ACTIONS(4515),
    [anon_sym_case] = ACTIONS(4515),
    [anon_sym_default] = ACTIONS(4515),
    [anon_sym_while] = ACTIONS(4515),
    [anon_sym_do] = ACTIONS(4515),
    [anon_sym_for] = ACTIONS(4515),
    [anon_sym_return] = ACTIONS(4515),
    [anon_sym_break] = ACTIONS(4515),
    [anon_sym_continue] = ACTIONS(4515),
    [anon_sym_goto] = ACTIONS(4515),
    [anon_sym_AMP] = ACTIONS(4515),
    [anon_sym_AMP_AMP] = ACTIONS(4513),
    [anon_sym_BANG] = ACTIONS(4513),
    [anon_sym_TILDE] = ACTIONS(4513),
    [anon_sym_PLUS] = ACTIONS(4515),
    [anon_sym_DASH] = ACTIONS(4515),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
    [anon_sym_sizeof] = ACTIONS(4515),
    [sym_number_literal] = ACTIONS(4513),
    [anon_sym_SQUOTE] = ACTIONS(4513),
    [anon_sym_DQUOTE] = ACTIONS(4513),
    [sym_true] = ACTIONS(4515),
    [sym_false] = ACTIONS(4515),
    [sym_null] = ACTIONS(4515),
    [sym_identifier] = ACTIONS(4515),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4515),
    [sym_auto] = ACTIONS(4515),
    [anon_sym_typename] = ACTIONS(4515),
    [anon_sym_template] = ACTIONS(4515),
    [anon_sym_delete] = ACTIONS(4515),
    [anon_sym_namespace] = ACTIONS(4515),
    [anon_sym_using] = ACTIONS(4515),
    [anon_sym_try] = ACTIONS(4515),
    [anon_sym_new] = ACTIONS(4515),
    [anon_sym_COLON_COLON] = ACTIONS(4513),
    [sym_operator_name] = ACTIONS(4513),
    [sym_nullptr] = ACTIONS(4515),
  },
  [2941] = {
    [sym_parameter_list] = STATE(897),
    [sym_argument_list] = STATE(898),
    [sym_initializer_list] = STATE(898),
    [aux_sym_declaration_repeat1] = STATE(2495),
    [anon_sym_COMMA] = ACTIONS(1613),
    [anon_sym_SEMI] = ACTIONS(5452),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(1619),
    [anon_sym_LBRACK] = ACTIONS(574),
    [anon_sym_EQ] = ACTIONS(1621),
    [sym_comment] = ACTIONS(91),
  },
  [2942] = {
    [sym__expression] = STATE(3244),
    [sym_comma_expression] = STATE(3245),
    [sym_conditional_expression] = STATE(3244),
    [sym_assignment_expression] = STATE(3244),
    [sym_pointer_expression] = STATE(3244),
    [sym_logical_expression] = STATE(3244),
    [sym_bitwise_expression] = STATE(3244),
    [sym_equality_expression] = STATE(3244),
    [sym_relational_expression] = STATE(3244),
    [sym_shift_expression] = STATE(3244),
    [sym_math_expression] = STATE(3244),
    [sym_cast_expression] = STATE(3244),
    [sym_sizeof_expression] = STATE(3244),
    [sym_subscript_expression] = STATE(3244),
    [sym_call_expression] = STATE(3244),
    [sym_field_expression] = STATE(3244),
    [sym_compound_literal_expression] = STATE(3244),
    [sym_parenthesized_expression] = STATE(3244),
    [sym_char_literal] = STATE(3244),
    [sym_concatenated_string] = STATE(3244),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3244),
    [sym_new_expression] = STATE(3244),
    [sym_delete_expression] = STATE(3244),
    [sym_lambda_expression] = STATE(3244),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7318),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(7318),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7320),
    [sym_false] = ACTIONS(7320),
    [sym_null] = ACTIONS(7320),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(7320),
  },
  [2943] = {
    [sym_raw_string_literal] = ACTIONS(4554),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4556),
    [sym_preproc_directive] = ACTIONS(4556),
    [anon_sym_SEMI] = ACTIONS(4554),
    [anon_sym_typedef] = ACTIONS(4556),
    [anon_sym_extern] = ACTIONS(4556),
    [anon_sym_LBRACE] = ACTIONS(4554),
    [anon_sym_LPAREN2] = ACTIONS(4554),
    [anon_sym_STAR] = ACTIONS(4554),
    [anon_sym_LBRACK] = ACTIONS(4554),
    [anon_sym_static] = ACTIONS(4556),
    [anon_sym_register] = ACTIONS(4556),
    [anon_sym_inline] = ACTIONS(4556),
    [anon_sym_const] = ACTIONS(4556),
    [anon_sym_restrict] = ACTIONS(4556),
    [anon_sym_volatile] = ACTIONS(4556),
    [anon_sym__Atomic] = ACTIONS(4556),
    [anon_sym_mutable] = ACTIONS(4556),
    [anon_sym_explicit] = ACTIONS(4556),
    [anon_sym_constexpr] = ACTIONS(4556),
    [anon_sym_unsigned] = ACTIONS(4556),
    [anon_sym_long] = ACTIONS(4556),
    [anon_sym_short] = ACTIONS(4556),
    [sym_primitive_type] = ACTIONS(4556),
    [anon_sym_enum] = ACTIONS(4556),
    [anon_sym_struct] = ACTIONS(4556),
    [anon_sym_union] = ACTIONS(4556),
    [anon_sym_if] = ACTIONS(4556),
    [anon_sym_else] = ACTIONS(4556),
    [anon_sym_switch] = ACTIONS(4556),
    [anon_sym_case] = ACTIONS(4556),
    [anon_sym_default] = ACTIONS(4556),
    [anon_sym_while] = ACTIONS(4556),
    [anon_sym_do] = ACTIONS(4556),
    [anon_sym_for] = ACTIONS(4556),
    [anon_sym_return] = ACTIONS(4556),
    [anon_sym_break] = ACTIONS(4556),
    [anon_sym_continue] = ACTIONS(4556),
    [anon_sym_goto] = ACTIONS(4556),
    [anon_sym_AMP] = ACTIONS(4556),
    [anon_sym_AMP_AMP] = ACTIONS(4554),
    [anon_sym_BANG] = ACTIONS(4554),
    [anon_sym_TILDE] = ACTIONS(4554),
    [anon_sym_PLUS] = ACTIONS(4556),
    [anon_sym_DASH] = ACTIONS(4556),
    [anon_sym_DASH_DASH] = ACTIONS(4554),
    [anon_sym_PLUS_PLUS] = ACTIONS(4554),
    [anon_sym_sizeof] = ACTIONS(4556),
    [sym_number_literal] = ACTIONS(4554),
    [anon_sym_SQUOTE] = ACTIONS(4554),
    [anon_sym_DQUOTE] = ACTIONS(4554),
    [sym_true] = ACTIONS(4556),
    [sym_false] = ACTIONS(4556),
    [sym_null] = ACTIONS(4556),
    [sym_identifier] = ACTIONS(4556),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4556),
    [sym_auto] = ACTIONS(4556),
    [anon_sym_typename] = ACTIONS(4556),
    [anon_sym_template] = ACTIONS(4556),
    [anon_sym_delete] = ACTIONS(4556),
    [anon_sym_namespace] = ACTIONS(4556),
    [anon_sym_using] = ACTIONS(4556),
    [anon_sym_try] = ACTIONS(4556),
    [anon_sym_new] = ACTIONS(4556),
    [anon_sym_COLON_COLON] = ACTIONS(4554),
    [sym_operator_name] = ACTIONS(4554),
    [sym_nullptr] = ACTIONS(4556),
  },
  [2944] = {
    [sym__expression] = STATE(3247),
    [sym_conditional_expression] = STATE(3247),
    [sym_assignment_expression] = STATE(3247),
    [sym_pointer_expression] = STATE(3247),
    [sym_logical_expression] = STATE(3247),
    [sym_bitwise_expression] = STATE(3247),
    [sym_equality_expression] = STATE(3247),
    [sym_relational_expression] = STATE(3247),
    [sym_shift_expression] = STATE(3247),
    [sym_math_expression] = STATE(3247),
    [sym_cast_expression] = STATE(3247),
    [sym_sizeof_expression] = STATE(3247),
    [sym_subscript_expression] = STATE(3247),
    [sym_call_expression] = STATE(3247),
    [sym_field_expression] = STATE(3247),
    [sym_compound_literal_expression] = STATE(3247),
    [sym_parenthesized_expression] = STATE(3247),
    [sym_char_literal] = STATE(3247),
    [sym_concatenated_string] = STATE(3247),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3247),
    [sym_new_expression] = STATE(3247),
    [sym_delete_expression] = STATE(3247),
    [sym_lambda_expression] = STATE(3247),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7322),
    [anon_sym_RPAREN] = ACTIONS(7324),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(7322),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7326),
    [sym_false] = ACTIONS(7326),
    [sym_null] = ACTIONS(7326),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(7326),
  },
  [2945] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(7328),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2946] = {
    [sym__expression] = STATE(3249),
    [sym_conditional_expression] = STATE(3249),
    [sym_assignment_expression] = STATE(3249),
    [sym_pointer_expression] = STATE(3249),
    [sym_logical_expression] = STATE(3249),
    [sym_bitwise_expression] = STATE(3249),
    [sym_equality_expression] = STATE(3249),
    [sym_relational_expression] = STATE(3249),
    [sym_shift_expression] = STATE(3249),
    [sym_math_expression] = STATE(3249),
    [sym_cast_expression] = STATE(3249),
    [sym_sizeof_expression] = STATE(3249),
    [sym_subscript_expression] = STATE(3249),
    [sym_call_expression] = STATE(3249),
    [sym_field_expression] = STATE(3249),
    [sym_compound_literal_expression] = STATE(3249),
    [sym_parenthesized_expression] = STATE(3249),
    [sym_char_literal] = STATE(3249),
    [sym_concatenated_string] = STATE(3249),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3249),
    [sym_new_expression] = STATE(3249),
    [sym_delete_expression] = STATE(3249),
    [sym_lambda_expression] = STATE(3249),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7330),
    [anon_sym_SEMI] = ACTIONS(7328),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(7330),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7332),
    [sym_false] = ACTIONS(7332),
    [sym_null] = ACTIONS(7332),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(7332),
  },
  [2947] = {
    [sym__expression] = STATE(3250),
    [sym_conditional_expression] = STATE(3250),
    [sym_assignment_expression] = STATE(3250),
    [sym_pointer_expression] = STATE(3250),
    [sym_logical_expression] = STATE(3250),
    [sym_bitwise_expression] = STATE(3250),
    [sym_equality_expression] = STATE(3250),
    [sym_relational_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_math_expression] = STATE(3250),
    [sym_cast_expression] = STATE(3250),
    [sym_sizeof_expression] = STATE(3250),
    [sym_subscript_expression] = STATE(3250),
    [sym_call_expression] = STATE(3250),
    [sym_field_expression] = STATE(3250),
    [sym_compound_literal_expression] = STATE(3250),
    [sym_parenthesized_expression] = STATE(3250),
    [sym_char_literal] = STATE(3250),
    [sym_concatenated_string] = STATE(3250),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3250),
    [sym_new_expression] = STATE(3250),
    [sym_delete_expression] = STATE(3250),
    [sym_lambda_expression] = STATE(3250),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7334),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(7334),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7336),
    [sym_false] = ACTIONS(7336),
    [sym_null] = ACTIONS(7336),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(7336),
  },
  [2948] = {
    [sym_raw_string_literal] = ACTIONS(4912),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4914),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4914),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4914),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4914),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4914),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4914),
    [sym_preproc_directive] = ACTIONS(4914),
    [anon_sym_SEMI] = ACTIONS(4912),
    [anon_sym_typedef] = ACTIONS(4914),
    [anon_sym_extern] = ACTIONS(4914),
    [anon_sym_LBRACE] = ACTIONS(4912),
    [anon_sym_LPAREN2] = ACTIONS(4912),
    [anon_sym_STAR] = ACTIONS(4912),
    [anon_sym_LBRACK] = ACTIONS(4912),
    [anon_sym_static] = ACTIONS(4914),
    [anon_sym_register] = ACTIONS(4914),
    [anon_sym_inline] = ACTIONS(4914),
    [anon_sym_const] = ACTIONS(4914),
    [anon_sym_restrict] = ACTIONS(4914),
    [anon_sym_volatile] = ACTIONS(4914),
    [anon_sym__Atomic] = ACTIONS(4914),
    [anon_sym_mutable] = ACTIONS(4914),
    [anon_sym_explicit] = ACTIONS(4914),
    [anon_sym_constexpr] = ACTIONS(4914),
    [anon_sym_unsigned] = ACTIONS(4914),
    [anon_sym_long] = ACTIONS(4914),
    [anon_sym_short] = ACTIONS(4914),
    [sym_primitive_type] = ACTIONS(4914),
    [anon_sym_enum] = ACTIONS(4914),
    [anon_sym_struct] = ACTIONS(4914),
    [anon_sym_union] = ACTIONS(4914),
    [anon_sym_if] = ACTIONS(4914),
    [anon_sym_switch] = ACTIONS(4914),
    [anon_sym_case] = ACTIONS(4914),
    [anon_sym_default] = ACTIONS(4914),
    [anon_sym_while] = ACTIONS(4914),
    [anon_sym_do] = ACTIONS(4914),
    [anon_sym_for] = ACTIONS(4914),
    [anon_sym_return] = ACTIONS(4914),
    [anon_sym_break] = ACTIONS(4914),
    [anon_sym_continue] = ACTIONS(4914),
    [anon_sym_goto] = ACTIONS(4914),
    [anon_sym_AMP] = ACTIONS(4914),
    [anon_sym_AMP_AMP] = ACTIONS(4912),
    [anon_sym_BANG] = ACTIONS(4912),
    [anon_sym_TILDE] = ACTIONS(4912),
    [anon_sym_PLUS] = ACTIONS(4914),
    [anon_sym_DASH] = ACTIONS(4914),
    [anon_sym_DASH_DASH] = ACTIONS(4912),
    [anon_sym_PLUS_PLUS] = ACTIONS(4912),
    [anon_sym_sizeof] = ACTIONS(4914),
    [sym_number_literal] = ACTIONS(4912),
    [anon_sym_SQUOTE] = ACTIONS(4912),
    [anon_sym_DQUOTE] = ACTIONS(4912),
    [sym_true] = ACTIONS(4914),
    [sym_false] = ACTIONS(4914),
    [sym_null] = ACTIONS(4914),
    [sym_identifier] = ACTIONS(4914),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4914),
    [sym_auto] = ACTIONS(4914),
    [anon_sym_typename] = ACTIONS(4914),
    [anon_sym_template] = ACTIONS(4914),
    [anon_sym_delete] = ACTIONS(4914),
    [anon_sym_namespace] = ACTIONS(4914),
    [anon_sym_using] = ACTIONS(4914),
    [anon_sym_try] = ACTIONS(4914),
    [anon_sym_new] = ACTIONS(4914),
    [anon_sym_COLON_COLON] = ACTIONS(4912),
    [sym_operator_name] = ACTIONS(4912),
    [sym_nullptr] = ACTIONS(4914),
  },
  [2949] = {
    [sym_raw_string_literal] = ACTIONS(4949),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4951),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4951),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4951),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4951),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4951),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4951),
    [sym_preproc_directive] = ACTIONS(4951),
    [anon_sym_SEMI] = ACTIONS(4949),
    [anon_sym_typedef] = ACTIONS(4951),
    [anon_sym_extern] = ACTIONS(4951),
    [anon_sym_LBRACE] = ACTIONS(4949),
    [anon_sym_LPAREN2] = ACTIONS(4949),
    [anon_sym_STAR] = ACTIONS(4949),
    [anon_sym_LBRACK] = ACTIONS(4949),
    [anon_sym_static] = ACTIONS(4951),
    [anon_sym_register] = ACTIONS(4951),
    [anon_sym_inline] = ACTIONS(4951),
    [anon_sym_const] = ACTIONS(4951),
    [anon_sym_restrict] = ACTIONS(4951),
    [anon_sym_volatile] = ACTIONS(4951),
    [anon_sym__Atomic] = ACTIONS(4951),
    [anon_sym_mutable] = ACTIONS(4951),
    [anon_sym_explicit] = ACTIONS(4951),
    [anon_sym_constexpr] = ACTIONS(4951),
    [anon_sym_unsigned] = ACTIONS(4951),
    [anon_sym_long] = ACTIONS(4951),
    [anon_sym_short] = ACTIONS(4951),
    [sym_primitive_type] = ACTIONS(4951),
    [anon_sym_enum] = ACTIONS(4951),
    [anon_sym_struct] = ACTIONS(4951),
    [anon_sym_union] = ACTIONS(4951),
    [anon_sym_if] = ACTIONS(4951),
    [anon_sym_switch] = ACTIONS(4951),
    [anon_sym_case] = ACTIONS(4951),
    [anon_sym_default] = ACTIONS(4951),
    [anon_sym_while] = ACTIONS(4951),
    [anon_sym_do] = ACTIONS(4951),
    [anon_sym_for] = ACTIONS(4951),
    [anon_sym_return] = ACTIONS(4951),
    [anon_sym_break] = ACTIONS(4951),
    [anon_sym_continue] = ACTIONS(4951),
    [anon_sym_goto] = ACTIONS(4951),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_AMP_AMP] = ACTIONS(4949),
    [anon_sym_BANG] = ACTIONS(4949),
    [anon_sym_TILDE] = ACTIONS(4949),
    [anon_sym_PLUS] = ACTIONS(4951),
    [anon_sym_DASH] = ACTIONS(4951),
    [anon_sym_DASH_DASH] = ACTIONS(4949),
    [anon_sym_PLUS_PLUS] = ACTIONS(4949),
    [anon_sym_sizeof] = ACTIONS(4951),
    [sym_number_literal] = ACTIONS(4949),
    [anon_sym_SQUOTE] = ACTIONS(4949),
    [anon_sym_DQUOTE] = ACTIONS(4949),
    [sym_true] = ACTIONS(4951),
    [sym_false] = ACTIONS(4951),
    [sym_null] = ACTIONS(4951),
    [sym_identifier] = ACTIONS(4951),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4951),
    [sym_auto] = ACTIONS(4951),
    [anon_sym_typename] = ACTIONS(4951),
    [anon_sym_template] = ACTIONS(4951),
    [anon_sym_delete] = ACTIONS(4951),
    [anon_sym_namespace] = ACTIONS(4951),
    [anon_sym_using] = ACTIONS(4951),
    [anon_sym_try] = ACTIONS(4951),
    [anon_sym_new] = ACTIONS(4951),
    [anon_sym_COLON_COLON] = ACTIONS(4949),
    [sym_operator_name] = ACTIONS(4949),
    [sym_nullptr] = ACTIONS(4951),
  },
  [2950] = {
    [anon_sym_SEMI] = ACTIONS(7338),
    [sym_comment] = ACTIONS(91),
  },
  [2951] = {
    [sym_raw_string_literal] = ACTIONS(4989),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4991),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4991),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4991),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4991),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4991),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4991),
    [sym_preproc_directive] = ACTIONS(4991),
    [anon_sym_SEMI] = ACTIONS(4989),
    [anon_sym_typedef] = ACTIONS(4991),
    [anon_sym_extern] = ACTIONS(4991),
    [anon_sym_LBRACE] = ACTIONS(4989),
    [anon_sym_LPAREN2] = ACTIONS(4989),
    [anon_sym_STAR] = ACTIONS(4989),
    [anon_sym_LBRACK] = ACTIONS(4989),
    [anon_sym_static] = ACTIONS(4991),
    [anon_sym_register] = ACTIONS(4991),
    [anon_sym_inline] = ACTIONS(4991),
    [anon_sym_const] = ACTIONS(4991),
    [anon_sym_restrict] = ACTIONS(4991),
    [anon_sym_volatile] = ACTIONS(4991),
    [anon_sym__Atomic] = ACTIONS(4991),
    [anon_sym_mutable] = ACTIONS(4991),
    [anon_sym_explicit] = ACTIONS(4991),
    [anon_sym_constexpr] = ACTIONS(4991),
    [anon_sym_unsigned] = ACTIONS(4991),
    [anon_sym_long] = ACTIONS(4991),
    [anon_sym_short] = ACTIONS(4991),
    [sym_primitive_type] = ACTIONS(4991),
    [anon_sym_enum] = ACTIONS(4991),
    [anon_sym_struct] = ACTIONS(4991),
    [anon_sym_union] = ACTIONS(4991),
    [anon_sym_if] = ACTIONS(4991),
    [anon_sym_switch] = ACTIONS(4991),
    [anon_sym_case] = ACTIONS(4991),
    [anon_sym_default] = ACTIONS(4991),
    [anon_sym_while] = ACTIONS(4991),
    [anon_sym_do] = ACTIONS(4991),
    [anon_sym_for] = ACTIONS(4991),
    [anon_sym_return] = ACTIONS(4991),
    [anon_sym_break] = ACTIONS(4991),
    [anon_sym_continue] = ACTIONS(4991),
    [anon_sym_goto] = ACTIONS(4991),
    [anon_sym_AMP] = ACTIONS(4991),
    [anon_sym_AMP_AMP] = ACTIONS(4989),
    [anon_sym_BANG] = ACTIONS(4989),
    [anon_sym_TILDE] = ACTIONS(4989),
    [anon_sym_PLUS] = ACTIONS(4991),
    [anon_sym_DASH] = ACTIONS(4991),
    [anon_sym_DASH_DASH] = ACTIONS(4989),
    [anon_sym_PLUS_PLUS] = ACTIONS(4989),
    [anon_sym_sizeof] = ACTIONS(4991),
    [sym_number_literal] = ACTIONS(4989),
    [anon_sym_SQUOTE] = ACTIONS(4989),
    [anon_sym_DQUOTE] = ACTIONS(4989),
    [sym_true] = ACTIONS(4991),
    [sym_false] = ACTIONS(4991),
    [sym_null] = ACTIONS(4991),
    [sym_identifier] = ACTIONS(4991),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4991),
    [sym_auto] = ACTIONS(4991),
    [anon_sym_typename] = ACTIONS(4991),
    [anon_sym_template] = ACTIONS(4991),
    [anon_sym_delete] = ACTIONS(4991),
    [anon_sym_namespace] = ACTIONS(4991),
    [anon_sym_using] = ACTIONS(4991),
    [anon_sym_try] = ACTIONS(4991),
    [anon_sym_new] = ACTIONS(4991),
    [anon_sym_COLON_COLON] = ACTIONS(4989),
    [sym_operator_name] = ACTIONS(4989),
    [sym_nullptr] = ACTIONS(4991),
  },
  [2952] = {
    [sym_compound_statement] = STATE(3252),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [sym_comment] = ACTIONS(91),
  },
  [2953] = {
    [sym_catch_clause] = STATE(2953),
    [aux_sym_try_statement_repeat1] = STATE(2953),
    [sym_raw_string_literal] = ACTIONS(4993),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4995),
    [sym_preproc_directive] = ACTIONS(4995),
    [anon_sym_SEMI] = ACTIONS(4993),
    [anon_sym_typedef] = ACTIONS(4995),
    [anon_sym_extern] = ACTIONS(4995),
    [anon_sym_LBRACE] = ACTIONS(4993),
    [anon_sym_LPAREN2] = ACTIONS(4993),
    [anon_sym_STAR] = ACTIONS(4993),
    [anon_sym_LBRACK] = ACTIONS(4993),
    [anon_sym_static] = ACTIONS(4995),
    [anon_sym_register] = ACTIONS(4995),
    [anon_sym_inline] = ACTIONS(4995),
    [anon_sym_const] = ACTIONS(4995),
    [anon_sym_restrict] = ACTIONS(4995),
    [anon_sym_volatile] = ACTIONS(4995),
    [anon_sym__Atomic] = ACTIONS(4995),
    [anon_sym_mutable] = ACTIONS(4995),
    [anon_sym_explicit] = ACTIONS(4995),
    [anon_sym_constexpr] = ACTIONS(4995),
    [anon_sym_unsigned] = ACTIONS(4995),
    [anon_sym_long] = ACTIONS(4995),
    [anon_sym_short] = ACTIONS(4995),
    [sym_primitive_type] = ACTIONS(4995),
    [anon_sym_enum] = ACTIONS(4995),
    [anon_sym_struct] = ACTIONS(4995),
    [anon_sym_union] = ACTIONS(4995),
    [anon_sym_if] = ACTIONS(4995),
    [anon_sym_switch] = ACTIONS(4995),
    [anon_sym_case] = ACTIONS(4995),
    [anon_sym_default] = ACTIONS(4995),
    [anon_sym_while] = ACTIONS(4995),
    [anon_sym_do] = ACTIONS(4995),
    [anon_sym_for] = ACTIONS(4995),
    [anon_sym_return] = ACTIONS(4995),
    [anon_sym_break] = ACTIONS(4995),
    [anon_sym_continue] = ACTIONS(4995),
    [anon_sym_goto] = ACTIONS(4995),
    [anon_sym_AMP] = ACTIONS(4995),
    [anon_sym_AMP_AMP] = ACTIONS(4993),
    [anon_sym_BANG] = ACTIONS(4993),
    [anon_sym_TILDE] = ACTIONS(4993),
    [anon_sym_PLUS] = ACTIONS(4995),
    [anon_sym_DASH] = ACTIONS(4995),
    [anon_sym_DASH_DASH] = ACTIONS(4993),
    [anon_sym_PLUS_PLUS] = ACTIONS(4993),
    [anon_sym_sizeof] = ACTIONS(4995),
    [sym_number_literal] = ACTIONS(4993),
    [anon_sym_SQUOTE] = ACTIONS(4993),
    [anon_sym_DQUOTE] = ACTIONS(4993),
    [sym_true] = ACTIONS(4995),
    [sym_false] = ACTIONS(4995),
    [sym_null] = ACTIONS(4995),
    [sym_identifier] = ACTIONS(4995),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4995),
    [sym_auto] = ACTIONS(4995),
    [anon_sym_typename] = ACTIONS(4995),
    [anon_sym_template] = ACTIONS(4995),
    [anon_sym_delete] = ACTIONS(4995),
    [anon_sym_namespace] = ACTIONS(4995),
    [anon_sym_using] = ACTIONS(4995),
    [anon_sym_try] = ACTIONS(4995),
    [anon_sym_catch] = ACTIONS(7340),
    [anon_sym_new] = ACTIONS(4995),
    [anon_sym_COLON_COLON] = ACTIONS(4993),
    [sym_operator_name] = ACTIONS(4993),
    [sym_nullptr] = ACTIONS(4995),
  },
  [2954] = {
    [sym_raw_string_literal] = ACTIONS(801),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(803),
    [anon_sym_COMMA] = ACTIONS(2919),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(803),
    [sym_preproc_directive] = ACTIONS(803),
    [anon_sym_SEMI] = ACTIONS(2919),
    [anon_sym_typedef] = ACTIONS(803),
    [anon_sym_extern] = ACTIONS(803),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(801),
    [anon_sym_LBRACK] = ACTIONS(801),
    [anon_sym_static] = ACTIONS(803),
    [anon_sym_register] = ACTIONS(803),
    [anon_sym_inline] = ACTIONS(803),
    [anon_sym_const] = ACTIONS(803),
    [anon_sym_restrict] = ACTIONS(803),
    [anon_sym_volatile] = ACTIONS(803),
    [anon_sym__Atomic] = ACTIONS(803),
    [anon_sym_mutable] = ACTIONS(803),
    [anon_sym_explicit] = ACTIONS(803),
    [anon_sym_constexpr] = ACTIONS(803),
    [anon_sym_unsigned] = ACTIONS(803),
    [anon_sym_long] = ACTIONS(803),
    [anon_sym_short] = ACTIONS(803),
    [sym_primitive_type] = ACTIONS(803),
    [anon_sym_enum] = ACTIONS(803),
    [anon_sym_struct] = ACTIONS(803),
    [anon_sym_union] = ACTIONS(803),
    [anon_sym_if] = ACTIONS(803),
    [anon_sym_switch] = ACTIONS(803),
    [anon_sym_case] = ACTIONS(803),
    [anon_sym_default] = ACTIONS(803),
    [anon_sym_while] = ACTIONS(803),
    [anon_sym_do] = ACTIONS(803),
    [anon_sym_for] = ACTIONS(803),
    [anon_sym_return] = ACTIONS(803),
    [anon_sym_break] = ACTIONS(803),
    [anon_sym_continue] = ACTIONS(803),
    [anon_sym_goto] = ACTIONS(803),
    [anon_sym_AMP] = ACTIONS(803),
    [anon_sym_AMP_AMP] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_DASH] = ACTIONS(803),
    [anon_sym_DASH_DASH] = ACTIONS(801),
    [anon_sym_PLUS_PLUS] = ACTIONS(801),
    [anon_sym_sizeof] = ACTIONS(803),
    [sym_number_literal] = ACTIONS(801),
    [anon_sym_SQUOTE] = ACTIONS(801),
    [anon_sym_DQUOTE] = ACTIONS(801),
    [sym_true] = ACTIONS(803),
    [sym_false] = ACTIONS(803),
    [sym_null] = ACTIONS(803),
    [sym_identifier] = ACTIONS(803),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(803),
    [sym_auto] = ACTIONS(803),
    [anon_sym_typename] = ACTIONS(803),
    [anon_sym_template] = ACTIONS(803),
    [anon_sym_delete] = ACTIONS(803),
    [anon_sym_namespace] = ACTIONS(803),
    [anon_sym_using] = ACTIONS(803),
    [anon_sym_try] = ACTIONS(803),
    [anon_sym_new] = ACTIONS(803),
    [anon_sym_COLON_COLON] = ACTIONS(801),
    [sym_operator_name] = ACTIONS(801),
    [sym_nullptr] = ACTIONS(803),
  },
  [2955] = {
    [sym_raw_string_literal] = ACTIONS(5113),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5115),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5115),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5115),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5115),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5115),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5115),
    [sym_preproc_directive] = ACTIONS(5115),
    [anon_sym_SEMI] = ACTIONS(5113),
    [anon_sym_typedef] = ACTIONS(5115),
    [anon_sym_extern] = ACTIONS(5115),
    [anon_sym_LBRACE] = ACTIONS(5113),
    [anon_sym_LPAREN2] = ACTIONS(5113),
    [anon_sym_STAR] = ACTIONS(5113),
    [anon_sym_LBRACK] = ACTIONS(5113),
    [anon_sym_static] = ACTIONS(5115),
    [anon_sym_register] = ACTIONS(5115),
    [anon_sym_inline] = ACTIONS(5115),
    [anon_sym_const] = ACTIONS(5115),
    [anon_sym_restrict] = ACTIONS(5115),
    [anon_sym_volatile] = ACTIONS(5115),
    [anon_sym__Atomic] = ACTIONS(5115),
    [anon_sym_mutable] = ACTIONS(5115),
    [anon_sym_explicit] = ACTIONS(5115),
    [anon_sym_constexpr] = ACTIONS(5115),
    [anon_sym_unsigned] = ACTIONS(5115),
    [anon_sym_long] = ACTIONS(5115),
    [anon_sym_short] = ACTIONS(5115),
    [sym_primitive_type] = ACTIONS(5115),
    [anon_sym_enum] = ACTIONS(5115),
    [anon_sym_struct] = ACTIONS(5115),
    [anon_sym_union] = ACTIONS(5115),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_else] = ACTIONS(5115),
    [anon_sym_switch] = ACTIONS(5115),
    [anon_sym_case] = ACTIONS(5115),
    [anon_sym_default] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_for] = ACTIONS(5115),
    [anon_sym_return] = ACTIONS(5115),
    [anon_sym_break] = ACTIONS(5115),
    [anon_sym_continue] = ACTIONS(5115),
    [anon_sym_goto] = ACTIONS(5115),
    [anon_sym_AMP] = ACTIONS(5115),
    [anon_sym_AMP_AMP] = ACTIONS(5113),
    [anon_sym_BANG] = ACTIONS(5113),
    [anon_sym_TILDE] = ACTIONS(5113),
    [anon_sym_PLUS] = ACTIONS(5115),
    [anon_sym_DASH] = ACTIONS(5115),
    [anon_sym_DASH_DASH] = ACTIONS(5113),
    [anon_sym_PLUS_PLUS] = ACTIONS(5113),
    [anon_sym_sizeof] = ACTIONS(5115),
    [sym_number_literal] = ACTIONS(5113),
    [anon_sym_SQUOTE] = ACTIONS(5113),
    [anon_sym_DQUOTE] = ACTIONS(5113),
    [sym_true] = ACTIONS(5115),
    [sym_false] = ACTIONS(5115),
    [sym_null] = ACTIONS(5115),
    [sym_identifier] = ACTIONS(5115),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5115),
    [sym_auto] = ACTIONS(5115),
    [anon_sym_typename] = ACTIONS(5115),
    [anon_sym_template] = ACTIONS(5115),
    [anon_sym_delete] = ACTIONS(5115),
    [anon_sym_namespace] = ACTIONS(5115),
    [anon_sym_using] = ACTIONS(5115),
    [anon_sym_try] = ACTIONS(5115),
    [anon_sym_new] = ACTIONS(5115),
    [anon_sym_COLON_COLON] = ACTIONS(5113),
    [sym_operator_name] = ACTIONS(5113),
    [sym_nullptr] = ACTIONS(5115),
  },
  [2956] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(7343),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2957] = {
    [anon_sym_SEMI] = ACTIONS(7343),
    [sym_comment] = ACTIONS(91),
  },
  [2958] = {
    [sym_raw_string_literal] = ACTIONS(5122),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5124),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5124),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5124),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5124),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5124),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5124),
    [sym_preproc_directive] = ACTIONS(5124),
    [anon_sym_SEMI] = ACTIONS(5122),
    [anon_sym_typedef] = ACTIONS(5124),
    [anon_sym_extern] = ACTIONS(5124),
    [anon_sym_LBRACE] = ACTIONS(5122),
    [anon_sym_LPAREN2] = ACTIONS(5122),
    [anon_sym_STAR] = ACTIONS(5122),
    [anon_sym_LBRACK] = ACTIONS(5122),
    [anon_sym_static] = ACTIONS(5124),
    [anon_sym_register] = ACTIONS(5124),
    [anon_sym_inline] = ACTIONS(5124),
    [anon_sym_const] = ACTIONS(5124),
    [anon_sym_restrict] = ACTIONS(5124),
    [anon_sym_volatile] = ACTIONS(5124),
    [anon_sym__Atomic] = ACTIONS(5124),
    [anon_sym_mutable] = ACTIONS(5124),
    [anon_sym_explicit] = ACTIONS(5124),
    [anon_sym_constexpr] = ACTIONS(5124),
    [anon_sym_unsigned] = ACTIONS(5124),
    [anon_sym_long] = ACTIONS(5124),
    [anon_sym_short] = ACTIONS(5124),
    [sym_primitive_type] = ACTIONS(5124),
    [anon_sym_enum] = ACTIONS(5124),
    [anon_sym_struct] = ACTIONS(5124),
    [anon_sym_union] = ACTIONS(5124),
    [anon_sym_if] = ACTIONS(5124),
    [anon_sym_switch] = ACTIONS(5124),
    [anon_sym_case] = ACTIONS(5124),
    [anon_sym_default] = ACTIONS(5124),
    [anon_sym_while] = ACTIONS(5124),
    [anon_sym_do] = ACTIONS(5124),
    [anon_sym_for] = ACTIONS(5124),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_break] = ACTIONS(5124),
    [anon_sym_continue] = ACTIONS(5124),
    [anon_sym_goto] = ACTIONS(5124),
    [anon_sym_AMP] = ACTIONS(5124),
    [anon_sym_AMP_AMP] = ACTIONS(5122),
    [anon_sym_BANG] = ACTIONS(5122),
    [anon_sym_TILDE] = ACTIONS(5122),
    [anon_sym_PLUS] = ACTIONS(5124),
    [anon_sym_DASH] = ACTIONS(5124),
    [anon_sym_DASH_DASH] = ACTIONS(5122),
    [anon_sym_PLUS_PLUS] = ACTIONS(5122),
    [anon_sym_sizeof] = ACTIONS(5124),
    [sym_number_literal] = ACTIONS(5122),
    [anon_sym_SQUOTE] = ACTIONS(5122),
    [anon_sym_DQUOTE] = ACTIONS(5122),
    [sym_true] = ACTIONS(5124),
    [sym_false] = ACTIONS(5124),
    [sym_null] = ACTIONS(5124),
    [sym_identifier] = ACTIONS(5124),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5124),
    [sym_auto] = ACTIONS(5124),
    [anon_sym_typename] = ACTIONS(5124),
    [anon_sym_template] = ACTIONS(5124),
    [anon_sym_delete] = ACTIONS(5124),
    [anon_sym_namespace] = ACTIONS(5124),
    [anon_sym_using] = ACTIONS(5124),
    [anon_sym_try] = ACTIONS(5124),
    [anon_sym_new] = ACTIONS(5124),
    [anon_sym_COLON_COLON] = ACTIONS(5122),
    [sym_operator_name] = ACTIONS(5122),
    [sym_nullptr] = ACTIONS(5124),
  },
  [2959] = {
    [sym_raw_string_literal] = ACTIONS(5253),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5255),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5255),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5255),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5255),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5255),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5255),
    [sym_preproc_directive] = ACTIONS(5255),
    [anon_sym_SEMI] = ACTIONS(5253),
    [anon_sym_typedef] = ACTIONS(5255),
    [anon_sym_extern] = ACTIONS(5255),
    [anon_sym_LBRACE] = ACTIONS(5253),
    [anon_sym_LPAREN2] = ACTIONS(5253),
    [anon_sym_STAR] = ACTIONS(5253),
    [anon_sym_LBRACK] = ACTIONS(5253),
    [anon_sym_static] = ACTIONS(5255),
    [anon_sym_register] = ACTIONS(5255),
    [anon_sym_inline] = ACTIONS(5255),
    [anon_sym_const] = ACTIONS(5255),
    [anon_sym_restrict] = ACTIONS(5255),
    [anon_sym_volatile] = ACTIONS(5255),
    [anon_sym__Atomic] = ACTIONS(5255),
    [anon_sym_mutable] = ACTIONS(5255),
    [anon_sym_explicit] = ACTIONS(5255),
    [anon_sym_constexpr] = ACTIONS(5255),
    [anon_sym_unsigned] = ACTIONS(5255),
    [anon_sym_long] = ACTIONS(5255),
    [anon_sym_short] = ACTIONS(5255),
    [sym_primitive_type] = ACTIONS(5255),
    [anon_sym_enum] = ACTIONS(5255),
    [anon_sym_struct] = ACTIONS(5255),
    [anon_sym_union] = ACTIONS(5255),
    [anon_sym_if] = ACTIONS(5255),
    [anon_sym_switch] = ACTIONS(5255),
    [anon_sym_case] = ACTIONS(5255),
    [anon_sym_default] = ACTIONS(5255),
    [anon_sym_while] = ACTIONS(5255),
    [anon_sym_do] = ACTIONS(5255),
    [anon_sym_for] = ACTIONS(5255),
    [anon_sym_return] = ACTIONS(5255),
    [anon_sym_break] = ACTIONS(5255),
    [anon_sym_continue] = ACTIONS(5255),
    [anon_sym_goto] = ACTIONS(5255),
    [anon_sym_AMP] = ACTIONS(5255),
    [anon_sym_AMP_AMP] = ACTIONS(5253),
    [anon_sym_BANG] = ACTIONS(5253),
    [anon_sym_TILDE] = ACTIONS(5253),
    [anon_sym_PLUS] = ACTIONS(5255),
    [anon_sym_DASH] = ACTIONS(5255),
    [anon_sym_DASH_DASH] = ACTIONS(5253),
    [anon_sym_PLUS_PLUS] = ACTIONS(5253),
    [anon_sym_sizeof] = ACTIONS(5255),
    [sym_number_literal] = ACTIONS(5253),
    [anon_sym_SQUOTE] = ACTIONS(5253),
    [anon_sym_DQUOTE] = ACTIONS(5253),
    [sym_true] = ACTIONS(5255),
    [sym_false] = ACTIONS(5255),
    [sym_null] = ACTIONS(5255),
    [sym_identifier] = ACTIONS(5255),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5255),
    [sym_auto] = ACTIONS(5255),
    [anon_sym_typename] = ACTIONS(5255),
    [anon_sym_template] = ACTIONS(5255),
    [anon_sym_delete] = ACTIONS(5255),
    [anon_sym_namespace] = ACTIONS(5255),
    [anon_sym_using] = ACTIONS(5255),
    [anon_sym_try] = ACTIONS(5255),
    [anon_sym_new] = ACTIONS(5255),
    [anon_sym_COLON_COLON] = ACTIONS(5253),
    [sym_operator_name] = ACTIONS(5253),
    [sym_nullptr] = ACTIONS(5255),
  },
  [2960] = {
    [sym_raw_string_literal] = ACTIONS(5257),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5259),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5259),
    [sym_preproc_directive] = ACTIONS(5259),
    [anon_sym_SEMI] = ACTIONS(5257),
    [anon_sym_typedef] = ACTIONS(5259),
    [anon_sym_extern] = ACTIONS(5259),
    [anon_sym_LBRACE] = ACTIONS(5257),
    [anon_sym_LPAREN2] = ACTIONS(5257),
    [anon_sym_STAR] = ACTIONS(5257),
    [anon_sym_LBRACK] = ACTIONS(5257),
    [anon_sym_static] = ACTIONS(5259),
    [anon_sym_register] = ACTIONS(5259),
    [anon_sym_inline] = ACTIONS(5259),
    [anon_sym_const] = ACTIONS(5259),
    [anon_sym_restrict] = ACTIONS(5259),
    [anon_sym_volatile] = ACTIONS(5259),
    [anon_sym__Atomic] = ACTIONS(5259),
    [anon_sym_mutable] = ACTIONS(5259),
    [anon_sym_explicit] = ACTIONS(5259),
    [anon_sym_constexpr] = ACTIONS(5259),
    [anon_sym_unsigned] = ACTIONS(5259),
    [anon_sym_long] = ACTIONS(5259),
    [anon_sym_short] = ACTIONS(5259),
    [sym_primitive_type] = ACTIONS(5259),
    [anon_sym_enum] = ACTIONS(5259),
    [anon_sym_struct] = ACTIONS(5259),
    [anon_sym_union] = ACTIONS(5259),
    [anon_sym_if] = ACTIONS(5259),
    [anon_sym_switch] = ACTIONS(5259),
    [anon_sym_case] = ACTIONS(5259),
    [anon_sym_default] = ACTIONS(5259),
    [anon_sym_while] = ACTIONS(5259),
    [anon_sym_do] = ACTIONS(5259),
    [anon_sym_for] = ACTIONS(5259),
    [anon_sym_return] = ACTIONS(5259),
    [anon_sym_break] = ACTIONS(5259),
    [anon_sym_continue] = ACTIONS(5259),
    [anon_sym_goto] = ACTIONS(5259),
    [anon_sym_AMP] = ACTIONS(5259),
    [anon_sym_AMP_AMP] = ACTIONS(5257),
    [anon_sym_BANG] = ACTIONS(5257),
    [anon_sym_TILDE] = ACTIONS(5257),
    [anon_sym_PLUS] = ACTIONS(5259),
    [anon_sym_DASH] = ACTIONS(5259),
    [anon_sym_DASH_DASH] = ACTIONS(5257),
    [anon_sym_PLUS_PLUS] = ACTIONS(5257),
    [anon_sym_sizeof] = ACTIONS(5259),
    [sym_number_literal] = ACTIONS(5257),
    [anon_sym_SQUOTE] = ACTIONS(5257),
    [anon_sym_DQUOTE] = ACTIONS(5257),
    [sym_true] = ACTIONS(5259),
    [sym_false] = ACTIONS(5259),
    [sym_null] = ACTIONS(5259),
    [sym_identifier] = ACTIONS(5259),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5259),
    [sym_auto] = ACTIONS(5259),
    [anon_sym_typename] = ACTIONS(5259),
    [anon_sym_template] = ACTIONS(5259),
    [anon_sym_delete] = ACTIONS(5259),
    [anon_sym_namespace] = ACTIONS(5259),
    [anon_sym_using] = ACTIONS(5259),
    [anon_sym_try] = ACTIONS(5259),
    [anon_sym_new] = ACTIONS(5259),
    [anon_sym_COLON_COLON] = ACTIONS(5257),
    [sym_operator_name] = ACTIONS(5257),
    [sym_nullptr] = ACTIONS(5259),
  },
  [2961] = {
    [sym_raw_string_literal] = ACTIONS(5366),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5368),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5368),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5368),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5368),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5368),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5368),
    [sym_preproc_directive] = ACTIONS(5368),
    [anon_sym_SEMI] = ACTIONS(5366),
    [anon_sym_typedef] = ACTIONS(5368),
    [anon_sym_extern] = ACTIONS(5368),
    [anon_sym_LBRACE] = ACTIONS(5366),
    [anon_sym_LPAREN2] = ACTIONS(5366),
    [anon_sym_STAR] = ACTIONS(5366),
    [anon_sym_LBRACK] = ACTIONS(5366),
    [anon_sym_static] = ACTIONS(5368),
    [anon_sym_register] = ACTIONS(5368),
    [anon_sym_inline] = ACTIONS(5368),
    [anon_sym_const] = ACTIONS(5368),
    [anon_sym_restrict] = ACTIONS(5368),
    [anon_sym_volatile] = ACTIONS(5368),
    [anon_sym__Atomic] = ACTIONS(5368),
    [anon_sym_mutable] = ACTIONS(5368),
    [anon_sym_explicit] = ACTIONS(5368),
    [anon_sym_constexpr] = ACTIONS(5368),
    [anon_sym_unsigned] = ACTIONS(5368),
    [anon_sym_long] = ACTIONS(5368),
    [anon_sym_short] = ACTIONS(5368),
    [sym_primitive_type] = ACTIONS(5368),
    [anon_sym_enum] = ACTIONS(5368),
    [anon_sym_struct] = ACTIONS(5368),
    [anon_sym_union] = ACTIONS(5368),
    [anon_sym_if] = ACTIONS(5368),
    [anon_sym_switch] = ACTIONS(5368),
    [anon_sym_case] = ACTIONS(5368),
    [anon_sym_default] = ACTIONS(5368),
    [anon_sym_while] = ACTIONS(5368),
    [anon_sym_do] = ACTIONS(5368),
    [anon_sym_for] = ACTIONS(5368),
    [anon_sym_return] = ACTIONS(5368),
    [anon_sym_break] = ACTIONS(5368),
    [anon_sym_continue] = ACTIONS(5368),
    [anon_sym_goto] = ACTIONS(5368),
    [anon_sym_AMP] = ACTIONS(5368),
    [anon_sym_AMP_AMP] = ACTIONS(5366),
    [anon_sym_BANG] = ACTIONS(5366),
    [anon_sym_TILDE] = ACTIONS(5366),
    [anon_sym_PLUS] = ACTIONS(5368),
    [anon_sym_DASH] = ACTIONS(5368),
    [anon_sym_DASH_DASH] = ACTIONS(5366),
    [anon_sym_PLUS_PLUS] = ACTIONS(5366),
    [anon_sym_sizeof] = ACTIONS(5368),
    [sym_number_literal] = ACTIONS(5366),
    [anon_sym_SQUOTE] = ACTIONS(5366),
    [anon_sym_DQUOTE] = ACTIONS(5366),
    [sym_true] = ACTIONS(5368),
    [sym_false] = ACTIONS(5368),
    [sym_null] = ACTIONS(5368),
    [sym_identifier] = ACTIONS(5368),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5368),
    [sym_auto] = ACTIONS(5368),
    [anon_sym_typename] = ACTIONS(5368),
    [anon_sym_template] = ACTIONS(5368),
    [anon_sym_delete] = ACTIONS(5368),
    [anon_sym_namespace] = ACTIONS(5368),
    [anon_sym_using] = ACTIONS(5368),
    [anon_sym_try] = ACTIONS(5368),
    [anon_sym_new] = ACTIONS(5368),
    [anon_sym_COLON_COLON] = ACTIONS(5366),
    [sym_operator_name] = ACTIONS(5366),
    [sym_nullptr] = ACTIONS(5368),
  },
  [2962] = {
    [sym_raw_string_literal] = ACTIONS(5621),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5623),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5623),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5623),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5623),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5623),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5623),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5623),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5623),
    [sym_preproc_directive] = ACTIONS(5623),
    [anon_sym_SEMI] = ACTIONS(5621),
    [anon_sym_typedef] = ACTIONS(5623),
    [anon_sym_extern] = ACTIONS(5623),
    [anon_sym_LBRACE] = ACTIONS(5621),
    [anon_sym_LPAREN2] = ACTIONS(5621),
    [anon_sym_STAR] = ACTIONS(5621),
    [anon_sym_LBRACK] = ACTIONS(5621),
    [anon_sym_static] = ACTIONS(5623),
    [anon_sym_register] = ACTIONS(5623),
    [anon_sym_inline] = ACTIONS(5623),
    [anon_sym_const] = ACTIONS(5623),
    [anon_sym_restrict] = ACTIONS(5623),
    [anon_sym_volatile] = ACTIONS(5623),
    [anon_sym__Atomic] = ACTIONS(5623),
    [anon_sym_mutable] = ACTIONS(5623),
    [anon_sym_explicit] = ACTIONS(5623),
    [anon_sym_constexpr] = ACTIONS(5623),
    [anon_sym_unsigned] = ACTIONS(5623),
    [anon_sym_long] = ACTIONS(5623),
    [anon_sym_short] = ACTIONS(5623),
    [sym_primitive_type] = ACTIONS(5623),
    [anon_sym_enum] = ACTIONS(5623),
    [anon_sym_struct] = ACTIONS(5623),
    [anon_sym_union] = ACTIONS(5623),
    [anon_sym_if] = ACTIONS(5623),
    [anon_sym_else] = ACTIONS(5623),
    [anon_sym_switch] = ACTIONS(5623),
    [anon_sym_case] = ACTIONS(5623),
    [anon_sym_default] = ACTIONS(5623),
    [anon_sym_while] = ACTIONS(5623),
    [anon_sym_do] = ACTIONS(5623),
    [anon_sym_for] = ACTIONS(5623),
    [anon_sym_return] = ACTIONS(5623),
    [anon_sym_break] = ACTIONS(5623),
    [anon_sym_continue] = ACTIONS(5623),
    [anon_sym_goto] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5623),
    [anon_sym_AMP_AMP] = ACTIONS(5621),
    [anon_sym_BANG] = ACTIONS(5621),
    [anon_sym_TILDE] = ACTIONS(5621),
    [anon_sym_PLUS] = ACTIONS(5623),
    [anon_sym_DASH] = ACTIONS(5623),
    [anon_sym_DASH_DASH] = ACTIONS(5621),
    [anon_sym_PLUS_PLUS] = ACTIONS(5621),
    [anon_sym_sizeof] = ACTIONS(5623),
    [sym_number_literal] = ACTIONS(5621),
    [anon_sym_SQUOTE] = ACTIONS(5621),
    [anon_sym_DQUOTE] = ACTIONS(5621),
    [sym_true] = ACTIONS(5623),
    [sym_false] = ACTIONS(5623),
    [sym_null] = ACTIONS(5623),
    [sym_identifier] = ACTIONS(5623),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5623),
    [sym_auto] = ACTIONS(5623),
    [anon_sym_typename] = ACTIONS(5623),
    [anon_sym_template] = ACTIONS(5623),
    [anon_sym_delete] = ACTIONS(5623),
    [anon_sym_namespace] = ACTIONS(5623),
    [anon_sym_using] = ACTIONS(5623),
    [anon_sym_try] = ACTIONS(5623),
    [anon_sym_new] = ACTIONS(5623),
    [anon_sym_COLON_COLON] = ACTIONS(5621),
    [sym_operator_name] = ACTIONS(5621),
    [sym_nullptr] = ACTIONS(5623),
  },
  [2963] = {
    [anon_sym_LPAREN2] = ACTIONS(7345),
    [anon_sym_constexpr] = ACTIONS(7347),
    [sym_comment] = ACTIONS(91),
  },
  [2964] = {
    [sym_parenthesized_expression] = STATE(3256),
    [anon_sym_LPAREN2] = ACTIONS(323),
    [sym_comment] = ACTIONS(91),
  },
  [2965] = {
    [sym__expression] = STATE(3257),
    [sym_conditional_expression] = STATE(3257),
    [sym_assignment_expression] = STATE(3257),
    [sym_pointer_expression] = STATE(3257),
    [sym_logical_expression] = STATE(3257),
    [sym_bitwise_expression] = STATE(3257),
    [sym_equality_expression] = STATE(3257),
    [sym_relational_expression] = STATE(3257),
    [sym_shift_expression] = STATE(3257),
    [sym_math_expression] = STATE(3257),
    [sym_cast_expression] = STATE(3257),
    [sym_sizeof_expression] = STATE(3257),
    [sym_subscript_expression] = STATE(3257),
    [sym_call_expression] = STATE(3257),
    [sym_field_expression] = STATE(3257),
    [sym_compound_literal_expression] = STATE(3257),
    [sym_parenthesized_expression] = STATE(3257),
    [sym_char_literal] = STATE(3257),
    [sym_concatenated_string] = STATE(3257),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3257),
    [sym_new_expression] = STATE(3257),
    [sym_delete_expression] = STATE(3257),
    [sym_lambda_expression] = STATE(3257),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7349),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(7349),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(7351),
    [sym_false] = ACTIONS(7351),
    [sym_null] = ACTIONS(7351),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(7351),
  },
  [2966] = {
    [anon_sym_COLON] = ACTIONS(7353),
    [sym_comment] = ACTIONS(91),
  },
  [2967] = {
    [sym_parenthesized_expression] = STATE(3259),
    [anon_sym_LPAREN2] = ACTIONS(323),
    [sym_comment] = ACTIONS(91),
  },
  [2968] = {
    [anon_sym_LPAREN2] = ACTIONS(7355),
    [sym_comment] = ACTIONS(91),
  },
  [2969] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(548),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_COLON] = ACTIONS(7357),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(935),
  },
  [2970] = {
    [sym_compound_statement] = STATE(3262),
    [anon_sym_LBRACE] = ACTIONS(357),
    [sym_comment] = ACTIONS(91),
  },
  [2971] = {
    [sym_raw_string_literal] = ACTIONS(6091),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6093),
    [sym_preproc_directive] = ACTIONS(6093),
    [anon_sym_SEMI] = ACTIONS(6091),
    [anon_sym_typedef] = ACTIONS(6093),
    [anon_sym_extern] = ACTIONS(6093),
    [anon_sym_LBRACE] = ACTIONS(6091),
    [anon_sym_LPAREN2] = ACTIONS(6091),
    [anon_sym_STAR] = ACTIONS(6091),
    [anon_sym_LBRACK] = ACTIONS(6091),
    [anon_sym_static] = ACTIONS(6093),
    [anon_sym_register] = ACTIONS(6093),
    [anon_sym_inline] = ACTIONS(6093),
    [anon_sym_const] = ACTIONS(6093),
    [anon_sym_restrict] = ACTIONS(6093),
    [anon_sym_volatile] = ACTIONS(6093),
    [anon_sym__Atomic] = ACTIONS(6093),
    [anon_sym_mutable] = ACTIONS(6093),
    [anon_sym_explicit] = ACTIONS(6093),
    [anon_sym_constexpr] = ACTIONS(6093),
    [anon_sym_unsigned] = ACTIONS(6093),
    [anon_sym_long] = ACTIONS(6093),
    [anon_sym_short] = ACTIONS(6093),
    [sym_primitive_type] = ACTIONS(6093),
    [anon_sym_enum] = ACTIONS(6093),
    [anon_sym_struct] = ACTIONS(6093),
    [anon_sym_union] = ACTIONS(6093),
    [anon_sym_if] = ACTIONS(6093),
    [anon_sym_else] = ACTIONS(7359),
    [anon_sym_switch] = ACTIONS(6093),
    [anon_sym_case] = ACTIONS(6093),
    [anon_sym_default] = ACTIONS(6093),
    [anon_sym_while] = ACTIONS(6093),
    [anon_sym_do] = ACTIONS(6093),
    [anon_sym_for] = ACTIONS(6093),
    [anon_sym_return] = ACTIONS(6093),
    [anon_sym_break] = ACTIONS(6093),
    [anon_sym_continue] = ACTIONS(6093),
    [anon_sym_goto] = ACTIONS(6093),
    [anon_sym_AMP] = ACTIONS(6093),
    [anon_sym_AMP_AMP] = ACTIONS(6091),
    [anon_sym_BANG] = ACTIONS(6091),
    [anon_sym_TILDE] = ACTIONS(6091),
    [anon_sym_PLUS] = ACTIONS(6093),
    [anon_sym_DASH] = ACTIONS(6093),
    [anon_sym_DASH_DASH] = ACTIONS(6091),
    [anon_sym_PLUS_PLUS] = ACTIONS(6091),
    [anon_sym_sizeof] = ACTIONS(6093),
    [sym_number_literal] = ACTIONS(6091),
    [anon_sym_SQUOTE] = ACTIONS(6091),
    [anon_sym_DQUOTE] = ACTIONS(6091),
    [sym_true] = ACTIONS(6093),
    [sym_false] = ACTIONS(6093),
    [sym_null] = ACTIONS(6093),
    [sym_identifier] = ACTIONS(6093),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6093),
    [sym_auto] = ACTIONS(6093),
    [anon_sym_typename] = ACTIONS(6093),
    [anon_sym_template] = ACTIONS(6093),
    [anon_sym_delete] = ACTIONS(6093),
    [anon_sym_namespace] = ACTIONS(6093),
    [anon_sym_using] = ACTIONS(6093),
    [anon_sym_try] = ACTIONS(6093),
    [anon_sym_new] = ACTIONS(6093),
    [anon_sym_COLON_COLON] = ACTIONS(6091),
    [sym_operator_name] = ACTIONS(6091),
    [sym_nullptr] = ACTIONS(6093),
  },
  [2972] = {
    [sym_compound_statement] = STATE(3264),
    [sym_labeled_statement] = STATE(3264),
    [sym_expression_statement] = STATE(3264),
    [sym_if_statement] = STATE(3264),
    [sym_switch_statement] = STATE(3264),
    [sym_case_statement] = STATE(3264),
    [sym_while_statement] = STATE(3264),
    [sym_do_statement] = STATE(3264),
    [sym_for_statement] = STATE(3264),
    [sym_return_statement] = STATE(3264),
    [sym_break_statement] = STATE(3264),
    [sym_continue_statement] = STATE(3264),
    [sym_goto_statement] = STATE(3264),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(411),
    [sym_for_range_loop] = STATE(3264),
    [sym_try_statement] = STATE(3264),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(678),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(6682),
    [anon_sym_switch] = ACTIONS(6684),
    [anon_sym_case] = ACTIONS(6686),
    [anon_sym_default] = ACTIONS(6688),
    [anon_sym_while] = ACTIONS(6690),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(6692),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(6694),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(6696),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(726),
  },
  [2973] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(895),
    [anon_sym_RPAREN] = ACTIONS(7361),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2974] = {
    [anon_sym_RPAREN] = ACTIONS(7361),
    [sym_comment] = ACTIONS(91),
  },
  [2975] = {
    [sym_compound_statement] = STATE(3266),
    [sym_labeled_statement] = STATE(3266),
    [sym_expression_statement] = STATE(3266),
    [sym_if_statement] = STATE(3266),
    [sym_switch_statement] = STATE(3266),
    [sym_case_statement] = STATE(3266),
    [sym_while_statement] = STATE(3266),
    [sym_do_statement] = STATE(3266),
    [sym_for_statement] = STATE(3266),
    [sym_return_statement] = STATE(3266),
    [sym_break_statement] = STATE(3266),
    [sym_continue_statement] = STATE(3266),
    [sym_goto_statement] = STATE(3266),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(411),
    [sym_for_range_loop] = STATE(3266),
    [sym_try_statement] = STATE(3266),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(678),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(704),
    [anon_sym_switch] = ACTIONS(706),
    [anon_sym_case] = ACTIONS(708),
    [anon_sym_default] = ACTIONS(710),
    [anon_sym_while] = ACTIONS(712),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(3807),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(736),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(726),
  },
  [2976] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3268),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(7363),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2977] = {
    [sym__expression] = STATE(3269),
    [sym_conditional_expression] = STATE(3269),
    [sym_assignment_expression] = STATE(3269),
    [sym_pointer_expression] = STATE(3269),
    [sym_logical_expression] = STATE(3269),
    [sym_bitwise_expression] = STATE(3269),
    [sym_equality_expression] = STATE(3269),
    [sym_relational_expression] = STATE(3269),
    [sym_shift_expression] = STATE(3269),
    [sym_math_expression] = STATE(3269),
    [sym_cast_expression] = STATE(3269),
    [sym_sizeof_expression] = STATE(3269),
    [sym_subscript_expression] = STATE(3269),
    [sym_call_expression] = STATE(3269),
    [sym_field_expression] = STATE(3269),
    [sym_compound_literal_expression] = STATE(3269),
    [sym_parenthesized_expression] = STATE(3269),
    [sym_char_literal] = STATE(3269),
    [sym_concatenated_string] = STATE(3269),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3269),
    [sym_new_expression] = STATE(3269),
    [sym_delete_expression] = STATE(3269),
    [sym_lambda_expression] = STATE(3269),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7365),
    [anon_sym_RPAREN] = ACTIONS(7363),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(7365),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7367),
    [sym_false] = ACTIONS(7367),
    [sym_null] = ACTIONS(7367),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(7367),
  },
  [2978] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(7369),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2979] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(7371),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [2980] = {
    [sym_raw_string_literal] = ACTIONS(6372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6374),
    [sym_preproc_directive] = ACTIONS(6374),
    [anon_sym_SEMI] = ACTIONS(6372),
    [anon_sym_typedef] = ACTIONS(6374),
    [anon_sym_extern] = ACTIONS(6374),
    [anon_sym_LBRACE] = ACTIONS(6372),
    [anon_sym_LPAREN2] = ACTIONS(6372),
    [anon_sym_STAR] = ACTIONS(6372),
    [anon_sym_LBRACK] = ACTIONS(6372),
    [anon_sym_static] = ACTIONS(6374),
    [anon_sym_register] = ACTIONS(6374),
    [anon_sym_inline] = ACTIONS(6374),
    [anon_sym_const] = ACTIONS(6374),
    [anon_sym_restrict] = ACTIONS(6374),
    [anon_sym_volatile] = ACTIONS(6374),
    [anon_sym__Atomic] = ACTIONS(6374),
    [anon_sym_mutable] = ACTIONS(6374),
    [anon_sym_explicit] = ACTIONS(6374),
    [anon_sym_constexpr] = ACTIONS(6374),
    [anon_sym_unsigned] = ACTIONS(6374),
    [anon_sym_long] = ACTIONS(6374),
    [anon_sym_short] = ACTIONS(6374),
    [sym_primitive_type] = ACTIONS(6374),
    [anon_sym_enum] = ACTIONS(6374),
    [anon_sym_struct] = ACTIONS(6374),
    [anon_sym_union] = ACTIONS(6374),
    [anon_sym_if] = ACTIONS(6374),
    [anon_sym_switch] = ACTIONS(6374),
    [anon_sym_case] = ACTIONS(6374),
    [anon_sym_default] = ACTIONS(6374),
    [anon_sym_while] = ACTIONS(6374),
    [anon_sym_do] = ACTIONS(6374),
    [anon_sym_for] = ACTIONS(6374),
    [anon_sym_return] = ACTIONS(6374),
    [anon_sym_break] = ACTIONS(6374),
    [anon_sym_continue] = ACTIONS(6374),
    [anon_sym_goto] = ACTIONS(6374),
    [anon_sym_AMP] = ACTIONS(6374),
    [anon_sym_AMP_AMP] = ACTIONS(6372),
    [anon_sym_BANG] = ACTIONS(6372),
    [anon_sym_TILDE] = ACTIONS(6372),
    [anon_sym_PLUS] = ACTIONS(6374),
    [anon_sym_DASH] = ACTIONS(6374),
    [anon_sym_DASH_DASH] = ACTIONS(6372),
    [anon_sym_PLUS_PLUS] = ACTIONS(6372),
    [anon_sym_sizeof] = ACTIONS(6374),
    [sym_number_literal] = ACTIONS(6372),
    [anon_sym_SQUOTE] = ACTIONS(6372),
    [anon_sym_DQUOTE] = ACTIONS(6372),
    [sym_true] = ACTIONS(6374),
    [sym_false] = ACTIONS(6374),
    [sym_null] = ACTIONS(6374),
    [sym_identifier] = ACTIONS(6374),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6374),
    [sym_auto] = ACTIONS(6374),
    [anon_sym_typename] = ACTIONS(6374),
    [anon_sym_template] = ACTIONS(6374),
    [anon_sym_delete] = ACTIONS(6374),
    [anon_sym_namespace] = ACTIONS(6374),
    [anon_sym_using] = ACTIONS(6374),
    [anon_sym_try] = ACTIONS(6374),
    [anon_sym_new] = ACTIONS(6374),
    [anon_sym_COLON_COLON] = ACTIONS(6372),
    [sym_operator_name] = ACTIONS(6372),
    [sym_nullptr] = ACTIONS(6374),
  },
  [2981] = {
    [sym_raw_string_literal] = ACTIONS(6379),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6381),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6381),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6381),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6381),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6381),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6381),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6381),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6381),
    [sym_preproc_directive] = ACTIONS(6381),
    [anon_sym_SEMI] = ACTIONS(6379),
    [anon_sym_typedef] = ACTIONS(6381),
    [anon_sym_extern] = ACTIONS(6381),
    [anon_sym_LBRACE] = ACTIONS(6379),
    [anon_sym_LPAREN2] = ACTIONS(6379),
    [anon_sym_STAR] = ACTIONS(6379),
    [anon_sym_LBRACK] = ACTIONS(6379),
    [anon_sym_static] = ACTIONS(6381),
    [anon_sym_register] = ACTIONS(6381),
    [anon_sym_inline] = ACTIONS(6381),
    [anon_sym_const] = ACTIONS(6381),
    [anon_sym_restrict] = ACTIONS(6381),
    [anon_sym_volatile] = ACTIONS(6381),
    [anon_sym__Atomic] = ACTIONS(6381),
    [anon_sym_mutable] = ACTIONS(6381),
    [anon_sym_explicit] = ACTIONS(6381),
    [anon_sym_constexpr] = ACTIONS(6381),
    [anon_sym_unsigned] = ACTIONS(6381),
    [anon_sym_long] = ACTIONS(6381),
    [anon_sym_short] = ACTIONS(6381),
    [sym_primitive_type] = ACTIONS(6381),
    [anon_sym_enum] = ACTIONS(6381),
    [anon_sym_struct] = ACTIONS(6381),
    [anon_sym_union] = ACTIONS(6381),
    [anon_sym_if] = ACTIONS(6381),
    [anon_sym_else] = ACTIONS(6381),
    [anon_sym_switch] = ACTIONS(6381),
    [anon_sym_case] = ACTIONS(6381),
    [anon_sym_default] = ACTIONS(6381),
    [anon_sym_while] = ACTIONS(6381),
    [anon_sym_do] = ACTIONS(6381),
    [anon_sym_for] = ACTIONS(6381),
    [anon_sym_return] = ACTIONS(6381),
    [anon_sym_break] = ACTIONS(6381),
    [anon_sym_continue] = ACTIONS(6381),
    [anon_sym_goto] = ACTIONS(6381),
    [anon_sym_AMP] = ACTIONS(6381),
    [anon_sym_AMP_AMP] = ACTIONS(6379),
    [anon_sym_BANG] = ACTIONS(6379),
    [anon_sym_TILDE] = ACTIONS(6379),
    [anon_sym_PLUS] = ACTIONS(6381),
    [anon_sym_DASH] = ACTIONS(6381),
    [anon_sym_DASH_DASH] = ACTIONS(6379),
    [anon_sym_PLUS_PLUS] = ACTIONS(6379),
    [anon_sym_sizeof] = ACTIONS(6381),
    [sym_number_literal] = ACTIONS(6379),
    [anon_sym_SQUOTE] = ACTIONS(6379),
    [anon_sym_DQUOTE] = ACTIONS(6379),
    [sym_true] = ACTIONS(6381),
    [sym_false] = ACTIONS(6381),
    [sym_null] = ACTIONS(6381),
    [sym_identifier] = ACTIONS(6381),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6381),
    [sym_auto] = ACTIONS(6381),
    [anon_sym_typename] = ACTIONS(6381),
    [anon_sym_template] = ACTIONS(6381),
    [anon_sym_delete] = ACTIONS(6381),
    [anon_sym_namespace] = ACTIONS(6381),
    [anon_sym_using] = ACTIONS(6381),
    [anon_sym_try] = ACTIONS(6381),
    [anon_sym_catch] = ACTIONS(6381),
    [anon_sym_new] = ACTIONS(6381),
    [anon_sym_COLON_COLON] = ACTIONS(6379),
    [sym_operator_name] = ACTIONS(6379),
    [sym_nullptr] = ACTIONS(6381),
  },
  [2982] = {
    [sym_raw_string_literal] = ACTIONS(6503),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6505),
    [sym_preproc_directive] = ACTIONS(6505),
    [anon_sym_SEMI] = ACTIONS(6503),
    [anon_sym_typedef] = ACTIONS(6505),
    [anon_sym_extern] = ACTIONS(6505),
    [anon_sym_LBRACE] = ACTIONS(6503),
    [anon_sym_LPAREN2] = ACTIONS(6503),
    [anon_sym_STAR] = ACTIONS(6503),
    [anon_sym_LBRACK] = ACTIONS(6503),
    [anon_sym_static] = ACTIONS(6505),
    [anon_sym_register] = ACTIONS(6505),
    [anon_sym_inline] = ACTIONS(6505),
    [anon_sym_const] = ACTIONS(6505),
    [anon_sym_restrict] = ACTIONS(6505),
    [anon_sym_volatile] = ACTIONS(6505),
    [anon_sym__Atomic] = ACTIONS(6505),
    [anon_sym_mutable] = ACTIONS(6505),
    [anon_sym_explicit] = ACTIONS(6505),
    [anon_sym_constexpr] = ACTIONS(6505),
    [anon_sym_unsigned] = ACTIONS(6505),
    [anon_sym_long] = ACTIONS(6505),
    [anon_sym_short] = ACTIONS(6505),
    [sym_primitive_type] = ACTIONS(6505),
    [anon_sym_enum] = ACTIONS(6505),
    [anon_sym_struct] = ACTIONS(6505),
    [anon_sym_union] = ACTIONS(6505),
    [anon_sym_if] = ACTIONS(6505),
    [anon_sym_switch] = ACTIONS(6505),
    [anon_sym_case] = ACTIONS(6505),
    [anon_sym_default] = ACTIONS(6505),
    [anon_sym_while] = ACTIONS(6505),
    [anon_sym_do] = ACTIONS(6505),
    [anon_sym_for] = ACTIONS(6505),
    [anon_sym_return] = ACTIONS(6505),
    [anon_sym_break] = ACTIONS(6505),
    [anon_sym_continue] = ACTIONS(6505),
    [anon_sym_goto] = ACTIONS(6505),
    [anon_sym_AMP] = ACTIONS(6505),
    [anon_sym_AMP_AMP] = ACTIONS(6503),
    [anon_sym_BANG] = ACTIONS(6503),
    [anon_sym_TILDE] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6505),
    [anon_sym_DASH] = ACTIONS(6505),
    [anon_sym_DASH_DASH] = ACTIONS(6503),
    [anon_sym_PLUS_PLUS] = ACTIONS(6503),
    [anon_sym_sizeof] = ACTIONS(6505),
    [sym_number_literal] = ACTIONS(6503),
    [anon_sym_SQUOTE] = ACTIONS(6503),
    [anon_sym_DQUOTE] = ACTIONS(6503),
    [sym_true] = ACTIONS(6505),
    [sym_false] = ACTIONS(6505),
    [sym_null] = ACTIONS(6505),
    [sym_identifier] = ACTIONS(6505),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6505),
    [sym_auto] = ACTIONS(6505),
    [anon_sym_typename] = ACTIONS(6505),
    [anon_sym_template] = ACTIONS(6505),
    [anon_sym_delete] = ACTIONS(6505),
    [anon_sym_namespace] = ACTIONS(6505),
    [anon_sym_using] = ACTIONS(6505),
    [anon_sym_try] = ACTIONS(6505),
    [anon_sym_new] = ACTIONS(6505),
    [anon_sym_COLON_COLON] = ACTIONS(6503),
    [sym_operator_name] = ACTIONS(6503),
    [sym_nullptr] = ACTIONS(6505),
  },
  [2983] = {
    [anon_sym_COMMA] = ACTIONS(6940),
    [anon_sym_SEMI] = ACTIONS(6940),
    [anon_sym_LBRACE] = ACTIONS(6940),
    [anon_sym_LPAREN2] = ACTIONS(6940),
    [anon_sym_STAR] = ACTIONS(6940),
    [anon_sym_LBRACK] = ACTIONS(6940),
    [anon_sym_EQ] = ACTIONS(6940),
    [anon_sym_const] = ACTIONS(6942),
    [anon_sym_restrict] = ACTIONS(6942),
    [anon_sym_volatile] = ACTIONS(6942),
    [anon_sym__Atomic] = ACTIONS(6942),
    [anon_sym_mutable] = ACTIONS(6942),
    [anon_sym_explicit] = ACTIONS(6942),
    [anon_sym_constexpr] = ACTIONS(6942),
    [anon_sym_COLON] = ACTIONS(6940),
    [anon_sym_AMP] = ACTIONS(6942),
    [anon_sym_AMP_AMP] = ACTIONS(6940),
    [anon_sym_DASH_GT] = ACTIONS(6940),
    [sym_identifier] = ACTIONS(6942),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(6942),
    [anon_sym_override] = ACTIONS(6942),
    [sym_noexcept] = ACTIONS(6942),
  },
  [2984] = {
    [anon_sym_RPAREN] = ACTIONS(7373),
    [anon_sym_SEMI] = ACTIONS(7373),
    [anon_sym_LPAREN2] = ACTIONS(7373),
    [anon_sym_LBRACK] = ACTIONS(7373),
    [sym_comment] = ACTIONS(91),
  },
  [2985] = {
    [sym_raw_string_literal] = ACTIONS(3063),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3065),
    [sym_preproc_directive] = ACTIONS(3065),
    [anon_sym_SEMI] = ACTIONS(3063),
    [anon_sym_typedef] = ACTIONS(3065),
    [anon_sym_extern] = ACTIONS(3065),
    [anon_sym_LBRACE] = ACTIONS(3063),
    [anon_sym_LPAREN2] = ACTIONS(3063),
    [anon_sym_STAR] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_static] = ACTIONS(3065),
    [anon_sym_register] = ACTIONS(3065),
    [anon_sym_inline] = ACTIONS(3065),
    [anon_sym_const] = ACTIONS(3065),
    [anon_sym_restrict] = ACTIONS(3065),
    [anon_sym_volatile] = ACTIONS(3065),
    [anon_sym__Atomic] = ACTIONS(3065),
    [anon_sym_mutable] = ACTIONS(3065),
    [anon_sym_explicit] = ACTIONS(3065),
    [anon_sym_constexpr] = ACTIONS(3065),
    [anon_sym_unsigned] = ACTIONS(3065),
    [anon_sym_long] = ACTIONS(3065),
    [anon_sym_short] = ACTIONS(3065),
    [sym_primitive_type] = ACTIONS(3065),
    [anon_sym_enum] = ACTIONS(3065),
    [anon_sym_struct] = ACTIONS(3065),
    [anon_sym_union] = ACTIONS(3065),
    [anon_sym_if] = ACTIONS(3065),
    [anon_sym_switch] = ACTIONS(3065),
    [anon_sym_case] = ACTIONS(3065),
    [anon_sym_default] = ACTIONS(3065),
    [anon_sym_while] = ACTIONS(3065),
    [anon_sym_do] = ACTIONS(3065),
    [anon_sym_for] = ACTIONS(3065),
    [anon_sym_return] = ACTIONS(3065),
    [anon_sym_break] = ACTIONS(3065),
    [anon_sym_continue] = ACTIONS(3065),
    [anon_sym_goto] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3063),
    [anon_sym_TILDE] = ACTIONS(3063),
    [anon_sym_PLUS] = ACTIONS(3065),
    [anon_sym_DASH] = ACTIONS(3065),
    [anon_sym_DASH_DASH] = ACTIONS(3063),
    [anon_sym_PLUS_PLUS] = ACTIONS(3063),
    [anon_sym_sizeof] = ACTIONS(3065),
    [sym_number_literal] = ACTIONS(3063),
    [anon_sym_SQUOTE] = ACTIONS(3063),
    [anon_sym_DQUOTE] = ACTIONS(3063),
    [sym_true] = ACTIONS(3065),
    [sym_false] = ACTIONS(3065),
    [sym_null] = ACTIONS(3065),
    [sym_identifier] = ACTIONS(3065),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3065),
    [sym_auto] = ACTIONS(3065),
    [anon_sym_typename] = ACTIONS(3065),
    [anon_sym_delete] = ACTIONS(3065),
    [anon_sym_try] = ACTIONS(3065),
    [anon_sym_new] = ACTIONS(3065),
    [anon_sym_COLON_COLON] = ACTIONS(3063),
    [sym_nullptr] = ACTIONS(3065),
  },
  [2986] = {
    [sym_raw_string_literal] = ACTIONS(3707),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3709),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3709),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3709),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3709),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3709),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3709),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3709),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3709),
    [sym_preproc_directive] = ACTIONS(3709),
    [anon_sym_SEMI] = ACTIONS(3707),
    [anon_sym_typedef] = ACTIONS(3709),
    [anon_sym_extern] = ACTIONS(3709),
    [anon_sym_LBRACE] = ACTIONS(3707),
    [anon_sym_LPAREN2] = ACTIONS(3707),
    [anon_sym_STAR] = ACTIONS(3707),
    [anon_sym_LBRACK] = ACTIONS(3707),
    [anon_sym_static] = ACTIONS(3709),
    [anon_sym_register] = ACTIONS(3709),
    [anon_sym_inline] = ACTIONS(3709),
    [anon_sym_const] = ACTIONS(3709),
    [anon_sym_restrict] = ACTIONS(3709),
    [anon_sym_volatile] = ACTIONS(3709),
    [anon_sym__Atomic] = ACTIONS(3709),
    [anon_sym_mutable] = ACTIONS(3709),
    [anon_sym_explicit] = ACTIONS(3709),
    [anon_sym_constexpr] = ACTIONS(3709),
    [anon_sym_unsigned] = ACTIONS(3709),
    [anon_sym_long] = ACTIONS(3709),
    [anon_sym_short] = ACTIONS(3709),
    [sym_primitive_type] = ACTIONS(3709),
    [anon_sym_enum] = ACTIONS(3709),
    [anon_sym_struct] = ACTIONS(3709),
    [anon_sym_union] = ACTIONS(3709),
    [anon_sym_if] = ACTIONS(3709),
    [anon_sym_switch] = ACTIONS(3709),
    [anon_sym_case] = ACTIONS(3709),
    [anon_sym_default] = ACTIONS(3709),
    [anon_sym_while] = ACTIONS(3709),
    [anon_sym_do] = ACTIONS(3709),
    [anon_sym_for] = ACTIONS(3709),
    [anon_sym_return] = ACTIONS(3709),
    [anon_sym_break] = ACTIONS(3709),
    [anon_sym_continue] = ACTIONS(3709),
    [anon_sym_goto] = ACTIONS(3709),
    [anon_sym_AMP] = ACTIONS(3707),
    [anon_sym_BANG] = ACTIONS(3707),
    [anon_sym_TILDE] = ACTIONS(3707),
    [anon_sym_PLUS] = ACTIONS(3709),
    [anon_sym_DASH] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3707),
    [anon_sym_PLUS_PLUS] = ACTIONS(3707),
    [anon_sym_sizeof] = ACTIONS(3709),
    [sym_number_literal] = ACTIONS(3707),
    [anon_sym_SQUOTE] = ACTIONS(3707),
    [anon_sym_DQUOTE] = ACTIONS(3707),
    [sym_true] = ACTIONS(3709),
    [sym_false] = ACTIONS(3709),
    [sym_null] = ACTIONS(3709),
    [sym_identifier] = ACTIONS(3709),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3709),
    [sym_auto] = ACTIONS(3709),
    [anon_sym_typename] = ACTIONS(3709),
    [anon_sym_delete] = ACTIONS(3709),
    [anon_sym_try] = ACTIONS(3709),
    [anon_sym_new] = ACTIONS(3709),
    [anon_sym_COLON_COLON] = ACTIONS(3707),
    [sym_nullptr] = ACTIONS(3709),
  },
  [2987] = {
    [sym_raw_string_literal] = ACTIONS(3711),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3713),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3713),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3713),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3713),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3713),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3713),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3713),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3713),
    [sym_preproc_directive] = ACTIONS(3713),
    [anon_sym_SEMI] = ACTIONS(3711),
    [anon_sym_typedef] = ACTIONS(3713),
    [anon_sym_extern] = ACTIONS(3713),
    [anon_sym_LBRACE] = ACTIONS(3711),
    [anon_sym_LPAREN2] = ACTIONS(3711),
    [anon_sym_STAR] = ACTIONS(3711),
    [anon_sym_LBRACK] = ACTIONS(3711),
    [anon_sym_static] = ACTIONS(3713),
    [anon_sym_register] = ACTIONS(3713),
    [anon_sym_inline] = ACTIONS(3713),
    [anon_sym_const] = ACTIONS(3713),
    [anon_sym_restrict] = ACTIONS(3713),
    [anon_sym_volatile] = ACTIONS(3713),
    [anon_sym__Atomic] = ACTIONS(3713),
    [anon_sym_mutable] = ACTIONS(3713),
    [anon_sym_explicit] = ACTIONS(3713),
    [anon_sym_constexpr] = ACTIONS(3713),
    [anon_sym_unsigned] = ACTIONS(3713),
    [anon_sym_long] = ACTIONS(3713),
    [anon_sym_short] = ACTIONS(3713),
    [sym_primitive_type] = ACTIONS(3713),
    [anon_sym_enum] = ACTIONS(3713),
    [anon_sym_struct] = ACTIONS(3713),
    [anon_sym_union] = ACTIONS(3713),
    [anon_sym_if] = ACTIONS(3713),
    [anon_sym_switch] = ACTIONS(3713),
    [anon_sym_case] = ACTIONS(3713),
    [anon_sym_default] = ACTIONS(3713),
    [anon_sym_while] = ACTIONS(3713),
    [anon_sym_do] = ACTIONS(3713),
    [anon_sym_for] = ACTIONS(3713),
    [anon_sym_return] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3713),
    [anon_sym_continue] = ACTIONS(3713),
    [anon_sym_goto] = ACTIONS(3713),
    [anon_sym_AMP] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3711),
    [anon_sym_TILDE] = ACTIONS(3711),
    [anon_sym_PLUS] = ACTIONS(3713),
    [anon_sym_DASH] = ACTIONS(3713),
    [anon_sym_DASH_DASH] = ACTIONS(3711),
    [anon_sym_PLUS_PLUS] = ACTIONS(3711),
    [anon_sym_sizeof] = ACTIONS(3713),
    [sym_number_literal] = ACTIONS(3711),
    [anon_sym_SQUOTE] = ACTIONS(3711),
    [anon_sym_DQUOTE] = ACTIONS(3711),
    [sym_true] = ACTIONS(3713),
    [sym_false] = ACTIONS(3713),
    [sym_null] = ACTIONS(3713),
    [sym_identifier] = ACTIONS(3713),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3713),
    [sym_auto] = ACTIONS(3713),
    [anon_sym_typename] = ACTIONS(3713),
    [anon_sym_delete] = ACTIONS(3713),
    [anon_sym_try] = ACTIONS(3713),
    [anon_sym_new] = ACTIONS(3713),
    [anon_sym_COLON_COLON] = ACTIONS(3711),
    [sym_nullptr] = ACTIONS(3713),
  },
  [2988] = {
    [anon_sym_LF] = ACTIONS(7375),
    [sym_comment] = ACTIONS(121),
  },
  [2989] = {
    [sym_raw_string_literal] = ACTIONS(5725),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5727),
    [sym_preproc_directive] = ACTIONS(5727),
    [anon_sym_SEMI] = ACTIONS(5725),
    [anon_sym_typedef] = ACTIONS(5727),
    [anon_sym_extern] = ACTIONS(5727),
    [anon_sym_LBRACE] = ACTIONS(5725),
    [anon_sym_LPAREN2] = ACTIONS(5725),
    [anon_sym_STAR] = ACTIONS(5725),
    [anon_sym_LBRACK] = ACTIONS(5725),
    [anon_sym_static] = ACTIONS(5727),
    [anon_sym_register] = ACTIONS(5727),
    [anon_sym_inline] = ACTIONS(5727),
    [anon_sym_const] = ACTIONS(5727),
    [anon_sym_restrict] = ACTIONS(5727),
    [anon_sym_volatile] = ACTIONS(5727),
    [anon_sym__Atomic] = ACTIONS(5727),
    [anon_sym_mutable] = ACTIONS(5727),
    [anon_sym_explicit] = ACTIONS(5727),
    [anon_sym_constexpr] = ACTIONS(5727),
    [anon_sym_unsigned] = ACTIONS(5727),
    [anon_sym_long] = ACTIONS(5727),
    [anon_sym_short] = ACTIONS(5727),
    [sym_primitive_type] = ACTIONS(5727),
    [anon_sym_enum] = ACTIONS(5727),
    [anon_sym_struct] = ACTIONS(5727),
    [anon_sym_union] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5727),
    [anon_sym_switch] = ACTIONS(5727),
    [anon_sym_case] = ACTIONS(5727),
    [anon_sym_default] = ACTIONS(5727),
    [anon_sym_while] = ACTIONS(5727),
    [anon_sym_do] = ACTIONS(5727),
    [anon_sym_for] = ACTIONS(5727),
    [anon_sym_return] = ACTIONS(5727),
    [anon_sym_break] = ACTIONS(5727),
    [anon_sym_continue] = ACTIONS(5727),
    [anon_sym_goto] = ACTIONS(5727),
    [anon_sym_AMP] = ACTIONS(5725),
    [anon_sym_BANG] = ACTIONS(5725),
    [anon_sym_TILDE] = ACTIONS(5725),
    [anon_sym_PLUS] = ACTIONS(5727),
    [anon_sym_DASH] = ACTIONS(5727),
    [anon_sym_DASH_DASH] = ACTIONS(5725),
    [anon_sym_PLUS_PLUS] = ACTIONS(5725),
    [anon_sym_sizeof] = ACTIONS(5727),
    [sym_number_literal] = ACTIONS(5725),
    [anon_sym_SQUOTE] = ACTIONS(5725),
    [anon_sym_DQUOTE] = ACTIONS(5725),
    [sym_true] = ACTIONS(5727),
    [sym_false] = ACTIONS(5727),
    [sym_null] = ACTIONS(5727),
    [sym_identifier] = ACTIONS(5727),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5727),
    [sym_auto] = ACTIONS(5727),
    [anon_sym_typename] = ACTIONS(5727),
    [anon_sym_delete] = ACTIONS(5727),
    [anon_sym_try] = ACTIONS(5727),
    [anon_sym_new] = ACTIONS(5727),
    [anon_sym_COLON_COLON] = ACTIONS(5725),
    [sym_nullptr] = ACTIONS(5727),
  },
  [2990] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7377),
    [sym_comment] = ACTIONS(91),
  },
  [2991] = {
    [sym_raw_string_literal] = ACTIONS(5806),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5808),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5808),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5808),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5808),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5808),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5808),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5808),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5808),
    [sym_preproc_directive] = ACTIONS(5808),
    [anon_sym_SEMI] = ACTIONS(5806),
    [anon_sym_typedef] = ACTIONS(5808),
    [anon_sym_extern] = ACTIONS(5808),
    [anon_sym_LBRACE] = ACTIONS(5806),
    [anon_sym_LPAREN2] = ACTIONS(5806),
    [anon_sym_STAR] = ACTIONS(5806),
    [anon_sym_LBRACK] = ACTIONS(5806),
    [anon_sym_static] = ACTIONS(5808),
    [anon_sym_register] = ACTIONS(5808),
    [anon_sym_inline] = ACTIONS(5808),
    [anon_sym_const] = ACTIONS(5808),
    [anon_sym_restrict] = ACTIONS(5808),
    [anon_sym_volatile] = ACTIONS(5808),
    [anon_sym__Atomic] = ACTIONS(5808),
    [anon_sym_mutable] = ACTIONS(5808),
    [anon_sym_explicit] = ACTIONS(5808),
    [anon_sym_constexpr] = ACTIONS(5808),
    [anon_sym_unsigned] = ACTIONS(5808),
    [anon_sym_long] = ACTIONS(5808),
    [anon_sym_short] = ACTIONS(5808),
    [sym_primitive_type] = ACTIONS(5808),
    [anon_sym_enum] = ACTIONS(5808),
    [anon_sym_struct] = ACTIONS(5808),
    [anon_sym_union] = ACTIONS(5808),
    [anon_sym_if] = ACTIONS(5808),
    [anon_sym_switch] = ACTIONS(5808),
    [anon_sym_case] = ACTIONS(5808),
    [anon_sym_default] = ACTIONS(5808),
    [anon_sym_while] = ACTIONS(5808),
    [anon_sym_do] = ACTIONS(5808),
    [anon_sym_for] = ACTIONS(5808),
    [anon_sym_return] = ACTIONS(5808),
    [anon_sym_break] = ACTIONS(5808),
    [anon_sym_continue] = ACTIONS(5808),
    [anon_sym_goto] = ACTIONS(5808),
    [anon_sym_AMP] = ACTIONS(5806),
    [anon_sym_BANG] = ACTIONS(5806),
    [anon_sym_TILDE] = ACTIONS(5806),
    [anon_sym_PLUS] = ACTIONS(5808),
    [anon_sym_DASH] = ACTIONS(5808),
    [anon_sym_DASH_DASH] = ACTIONS(5806),
    [anon_sym_PLUS_PLUS] = ACTIONS(5806),
    [anon_sym_sizeof] = ACTIONS(5808),
    [sym_number_literal] = ACTIONS(5806),
    [anon_sym_SQUOTE] = ACTIONS(5806),
    [anon_sym_DQUOTE] = ACTIONS(5806),
    [sym_true] = ACTIONS(5808),
    [sym_false] = ACTIONS(5808),
    [sym_null] = ACTIONS(5808),
    [sym_identifier] = ACTIONS(5808),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5808),
    [sym_auto] = ACTIONS(5808),
    [anon_sym_typename] = ACTIONS(5808),
    [anon_sym_delete] = ACTIONS(5808),
    [anon_sym_try] = ACTIONS(5808),
    [anon_sym_new] = ACTIONS(5808),
    [anon_sym_COLON_COLON] = ACTIONS(5806),
    [sym_nullptr] = ACTIONS(5808),
  },
  [2992] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7379),
    [sym_comment] = ACTIONS(91),
  },
  [2993] = {
    [sym_raw_string_literal] = ACTIONS(1370),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1372),
    [sym_preproc_directive] = ACTIONS(1372),
    [anon_sym_SEMI] = ACTIONS(1370),
    [anon_sym_typedef] = ACTIONS(1372),
    [anon_sym_extern] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1370),
    [anon_sym_LPAREN2] = ACTIONS(1370),
    [anon_sym_STAR] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(1370),
    [anon_sym_static] = ACTIONS(1372),
    [anon_sym_register] = ACTIONS(1372),
    [anon_sym_inline] = ACTIONS(1372),
    [anon_sym_const] = ACTIONS(1372),
    [anon_sym_restrict] = ACTIONS(1372),
    [anon_sym_volatile] = ACTIONS(1372),
    [anon_sym__Atomic] = ACTIONS(1372),
    [anon_sym_mutable] = ACTIONS(1372),
    [anon_sym_explicit] = ACTIONS(1372),
    [anon_sym_constexpr] = ACTIONS(1372),
    [anon_sym_unsigned] = ACTIONS(1372),
    [anon_sym_long] = ACTIONS(1372),
    [anon_sym_short] = ACTIONS(1372),
    [sym_primitive_type] = ACTIONS(1372),
    [anon_sym_enum] = ACTIONS(1372),
    [anon_sym_struct] = ACTIONS(1372),
    [anon_sym_union] = ACTIONS(1372),
    [anon_sym_if] = ACTIONS(1372),
    [anon_sym_switch] = ACTIONS(1372),
    [anon_sym_case] = ACTIONS(1372),
    [anon_sym_default] = ACTIONS(1372),
    [anon_sym_while] = ACTIONS(1372),
    [anon_sym_do] = ACTIONS(1372),
    [anon_sym_for] = ACTIONS(1372),
    [anon_sym_return] = ACTIONS(1372),
    [anon_sym_break] = ACTIONS(1372),
    [anon_sym_continue] = ACTIONS(1372),
    [anon_sym_goto] = ACTIONS(1372),
    [anon_sym_AMP] = ACTIONS(1370),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_PLUS] = ACTIONS(1372),
    [anon_sym_DASH] = ACTIONS(1372),
    [anon_sym_DASH_DASH] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1370),
    [anon_sym_sizeof] = ACTIONS(1372),
    [sym_number_literal] = ACTIONS(1370),
    [anon_sym_SQUOTE] = ACTIONS(1370),
    [anon_sym_DQUOTE] = ACTIONS(1370),
    [sym_true] = ACTIONS(1372),
    [sym_false] = ACTIONS(1372),
    [sym_null] = ACTIONS(1372),
    [sym_identifier] = ACTIONS(1372),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1372),
    [sym_auto] = ACTIONS(1372),
    [anon_sym_typename] = ACTIONS(1372),
    [anon_sym_delete] = ACTIONS(1372),
    [anon_sym_try] = ACTIONS(1372),
    [anon_sym_new] = ACTIONS(1372),
    [anon_sym_COLON_COLON] = ACTIONS(1370),
    [sym_nullptr] = ACTIONS(1372),
  },
  [2994] = {
    [aux_sym_string_literal_repeat1] = STATE(761),
    [anon_sym_DQUOTE] = ACTIONS(7381),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_BSLASHn_RBRACK_SLASH] = ACTIONS(1376),
    [sym_escape_sequence] = ACTIONS(1376),
    [sym_comment] = ACTIONS(121),
  },
  [2995] = {
    [sym_raw_string_literal] = ACTIONS(1994),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1996),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1996),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1996),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1996),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1996),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1996),
    [sym_preproc_directive] = ACTIONS(1996),
    [anon_sym_SEMI] = ACTIONS(1994),
    [anon_sym_typedef] = ACTIONS(1996),
    [anon_sym_extern] = ACTIONS(1996),
    [anon_sym_LBRACE] = ACTIONS(1994),
    [anon_sym_LPAREN2] = ACTIONS(1994),
    [anon_sym_STAR] = ACTIONS(1994),
    [anon_sym_LBRACK] = ACTIONS(1994),
    [anon_sym_static] = ACTIONS(1996),
    [anon_sym_register] = ACTIONS(1996),
    [anon_sym_inline] = ACTIONS(1996),
    [anon_sym_const] = ACTIONS(1996),
    [anon_sym_restrict] = ACTIONS(1996),
    [anon_sym_volatile] = ACTIONS(1996),
    [anon_sym__Atomic] = ACTIONS(1996),
    [anon_sym_mutable] = ACTIONS(1996),
    [anon_sym_explicit] = ACTIONS(1996),
    [anon_sym_constexpr] = ACTIONS(1996),
    [anon_sym_unsigned] = ACTIONS(1996),
    [anon_sym_long] = ACTIONS(1996),
    [anon_sym_short] = ACTIONS(1996),
    [sym_primitive_type] = ACTIONS(1996),
    [anon_sym_enum] = ACTIONS(1996),
    [anon_sym_struct] = ACTIONS(1996),
    [anon_sym_union] = ACTIONS(1996),
    [anon_sym_if] = ACTIONS(1996),
    [anon_sym_switch] = ACTIONS(1996),
    [anon_sym_case] = ACTIONS(1996),
    [anon_sym_default] = ACTIONS(1996),
    [anon_sym_while] = ACTIONS(1996),
    [anon_sym_do] = ACTIONS(1996),
    [anon_sym_for] = ACTIONS(1996),
    [anon_sym_return] = ACTIONS(1996),
    [anon_sym_break] = ACTIONS(1996),
    [anon_sym_continue] = ACTIONS(1996),
    [anon_sym_goto] = ACTIONS(1996),
    [anon_sym_AMP] = ACTIONS(1994),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_PLUS] = ACTIONS(1996),
    [anon_sym_DASH] = ACTIONS(1996),
    [anon_sym_DASH_DASH] = ACTIONS(1994),
    [anon_sym_PLUS_PLUS] = ACTIONS(1994),
    [anon_sym_sizeof] = ACTIONS(1996),
    [sym_number_literal] = ACTIONS(1994),
    [anon_sym_SQUOTE] = ACTIONS(1994),
    [anon_sym_DQUOTE] = ACTIONS(1994),
    [sym_true] = ACTIONS(1996),
    [sym_false] = ACTIONS(1996),
    [sym_null] = ACTIONS(1996),
    [sym_identifier] = ACTIONS(1996),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1996),
    [sym_auto] = ACTIONS(1996),
    [anon_sym_typename] = ACTIONS(1996),
    [anon_sym_delete] = ACTIONS(1996),
    [anon_sym_try] = ACTIONS(1996),
    [anon_sym_new] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1994),
    [sym_nullptr] = ACTIONS(1996),
  },
  [2996] = {
    [anon_sym_LF] = ACTIONS(7383),
    [sym_comment] = ACTIONS(121),
  },
  [2997] = {
    [anon_sym_LF] = ACTIONS(7385),
    [sym_preproc_arg] = ACTIONS(7387),
    [sym_comment] = ACTIONS(121),
  },
  [2998] = {
    [sym_raw_string_literal] = ACTIONS(3990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3992),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3992),
    [sym_preproc_directive] = ACTIONS(3992),
    [anon_sym_SEMI] = ACTIONS(3990),
    [anon_sym_typedef] = ACTIONS(3992),
    [anon_sym_extern] = ACTIONS(3992),
    [anon_sym_LBRACE] = ACTIONS(3990),
    [anon_sym_LPAREN2] = ACTIONS(3990),
    [anon_sym_STAR] = ACTIONS(3990),
    [anon_sym_LBRACK] = ACTIONS(3990),
    [anon_sym_static] = ACTIONS(3992),
    [anon_sym_register] = ACTIONS(3992),
    [anon_sym_inline] = ACTIONS(3992),
    [anon_sym_const] = ACTIONS(3992),
    [anon_sym_restrict] = ACTIONS(3992),
    [anon_sym_volatile] = ACTIONS(3992),
    [anon_sym__Atomic] = ACTIONS(3992),
    [anon_sym_mutable] = ACTIONS(3992),
    [anon_sym_explicit] = ACTIONS(3992),
    [anon_sym_constexpr] = ACTIONS(3992),
    [anon_sym_unsigned] = ACTIONS(3992),
    [anon_sym_long] = ACTIONS(3992),
    [anon_sym_short] = ACTIONS(3992),
    [sym_primitive_type] = ACTIONS(3992),
    [anon_sym_enum] = ACTIONS(3992),
    [anon_sym_struct] = ACTIONS(3992),
    [anon_sym_union] = ACTIONS(3992),
    [anon_sym_if] = ACTIONS(3992),
    [anon_sym_switch] = ACTIONS(3992),
    [anon_sym_case] = ACTIONS(3992),
    [anon_sym_default] = ACTIONS(3992),
    [anon_sym_while] = ACTIONS(3992),
    [anon_sym_do] = ACTIONS(3992),
    [anon_sym_for] = ACTIONS(3992),
    [anon_sym_return] = ACTIONS(3992),
    [anon_sym_break] = ACTIONS(3992),
    [anon_sym_continue] = ACTIONS(3992),
    [anon_sym_goto] = ACTIONS(3992),
    [anon_sym_AMP] = ACTIONS(3990),
    [anon_sym_BANG] = ACTIONS(3990),
    [anon_sym_TILDE] = ACTIONS(3990),
    [anon_sym_PLUS] = ACTIONS(3992),
    [anon_sym_DASH] = ACTIONS(3992),
    [anon_sym_DASH_DASH] = ACTIONS(3990),
    [anon_sym_PLUS_PLUS] = ACTIONS(3990),
    [anon_sym_sizeof] = ACTIONS(3992),
    [sym_number_literal] = ACTIONS(3990),
    [anon_sym_SQUOTE] = ACTIONS(3990),
    [anon_sym_DQUOTE] = ACTIONS(3990),
    [sym_true] = ACTIONS(3992),
    [sym_false] = ACTIONS(3992),
    [sym_null] = ACTIONS(3992),
    [sym_identifier] = ACTIONS(3992),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3992),
    [sym_auto] = ACTIONS(3992),
    [anon_sym_typename] = ACTIONS(3992),
    [anon_sym_delete] = ACTIONS(3992),
    [anon_sym_try] = ACTIONS(3992),
    [anon_sym_new] = ACTIONS(3992),
    [anon_sym_COLON_COLON] = ACTIONS(3990),
    [sym_nullptr] = ACTIONS(3992),
  },
  [2999] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7389),
    [sym_comment] = ACTIONS(91),
  },
  [3000] = {
    [sym_preproc_include] = STATE(1941),
    [sym_preproc_def] = STATE(1941),
    [sym_preproc_function_def] = STATE(1941),
    [sym_preproc_call] = STATE(1941),
    [sym_preproc_if_in_compound_statement] = STATE(1941),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1941),
    [sym_preproc_else_in_compound_statement] = STATE(3280),
    [sym_preproc_elif_in_compound_statement] = STATE(3280),
    [sym_declaration] = STATE(1941),
    [sym_type_definition] = STATE(1941),
    [sym__declaration_specifiers] = STATE(1138),
    [sym_compound_statement] = STATE(1941),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(1941),
    [sym_expression_statement] = STATE(1941),
    [sym_if_statement] = STATE(1941),
    [sym_switch_statement] = STATE(1941),
    [sym_case_statement] = STATE(1941),
    [sym_while_statement] = STATE(1941),
    [sym_do_statement] = STATE(1941),
    [sym_for_statement] = STATE(1941),
    [sym_return_statement] = STATE(1941),
    [sym_break_statement] = STATE(1941),
    [sym_continue_statement] = STATE(1941),
    [sym_goto_statement] = STATE(1941),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(1941),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(1941),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(1941),
    [sym_try_statement] = STATE(1941),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1941),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(2196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2198),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2200),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7391),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2208),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2210),
    [sym_preproc_directive] = ACTIONS(2212),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_typedef] = ACTIONS(2216),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(2220),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(2244),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_nullptr] = ACTIONS(2242),
  },
  [3001] = {
    [sym_raw_string_literal] = ACTIONS(4090),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4092),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4092),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4092),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4092),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4092),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4092),
    [sym_preproc_directive] = ACTIONS(4092),
    [anon_sym_SEMI] = ACTIONS(4090),
    [anon_sym_typedef] = ACTIONS(4092),
    [anon_sym_extern] = ACTIONS(4092),
    [anon_sym_LBRACE] = ACTIONS(4090),
    [anon_sym_LPAREN2] = ACTIONS(4090),
    [anon_sym_STAR] = ACTIONS(4090),
    [anon_sym_LBRACK] = ACTIONS(4090),
    [anon_sym_static] = ACTIONS(4092),
    [anon_sym_register] = ACTIONS(4092),
    [anon_sym_inline] = ACTIONS(4092),
    [anon_sym_const] = ACTIONS(4092),
    [anon_sym_restrict] = ACTIONS(4092),
    [anon_sym_volatile] = ACTIONS(4092),
    [anon_sym__Atomic] = ACTIONS(4092),
    [anon_sym_mutable] = ACTIONS(4092),
    [anon_sym_explicit] = ACTIONS(4092),
    [anon_sym_constexpr] = ACTIONS(4092),
    [anon_sym_unsigned] = ACTIONS(4092),
    [anon_sym_long] = ACTIONS(4092),
    [anon_sym_short] = ACTIONS(4092),
    [sym_primitive_type] = ACTIONS(4092),
    [anon_sym_enum] = ACTIONS(4092),
    [anon_sym_struct] = ACTIONS(4092),
    [anon_sym_union] = ACTIONS(4092),
    [anon_sym_if] = ACTIONS(4092),
    [anon_sym_switch] = ACTIONS(4092),
    [anon_sym_case] = ACTIONS(4092),
    [anon_sym_default] = ACTIONS(4092),
    [anon_sym_while] = ACTIONS(4092),
    [anon_sym_do] = ACTIONS(4092),
    [anon_sym_for] = ACTIONS(4092),
    [anon_sym_return] = ACTIONS(4092),
    [anon_sym_break] = ACTIONS(4092),
    [anon_sym_continue] = ACTIONS(4092),
    [anon_sym_goto] = ACTIONS(4092),
    [anon_sym_AMP] = ACTIONS(4090),
    [anon_sym_BANG] = ACTIONS(4090),
    [anon_sym_TILDE] = ACTIONS(4090),
    [anon_sym_PLUS] = ACTIONS(4092),
    [anon_sym_DASH] = ACTIONS(4092),
    [anon_sym_DASH_DASH] = ACTIONS(4090),
    [anon_sym_PLUS_PLUS] = ACTIONS(4090),
    [anon_sym_sizeof] = ACTIONS(4092),
    [sym_number_literal] = ACTIONS(4090),
    [anon_sym_SQUOTE] = ACTIONS(4090),
    [anon_sym_DQUOTE] = ACTIONS(4090),
    [sym_true] = ACTIONS(4092),
    [sym_false] = ACTIONS(4092),
    [sym_null] = ACTIONS(4092),
    [sym_identifier] = ACTIONS(4092),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4092),
    [sym_auto] = ACTIONS(4092),
    [anon_sym_typename] = ACTIONS(4092),
    [anon_sym_delete] = ACTIONS(4092),
    [anon_sym_try] = ACTIONS(4092),
    [anon_sym_new] = ACTIONS(4092),
    [anon_sym_COLON_COLON] = ACTIONS(4090),
    [sym_nullptr] = ACTIONS(4092),
  },
  [3002] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7393),
    [sym_comment] = ACTIONS(91),
  },
  [3003] = {
    [sym_preproc_include] = STATE(1941),
    [sym_preproc_def] = STATE(1941),
    [sym_preproc_function_def] = STATE(1941),
    [sym_preproc_call] = STATE(1941),
    [sym_preproc_if_in_compound_statement] = STATE(1941),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1941),
    [sym_preproc_else_in_compound_statement] = STATE(3282),
    [sym_preproc_elif_in_compound_statement] = STATE(3282),
    [sym_declaration] = STATE(1941),
    [sym_type_definition] = STATE(1941),
    [sym__declaration_specifiers] = STATE(1138),
    [sym_compound_statement] = STATE(1941),
    [sym_storage_class_specifier] = STATE(118),
    [sym_type_qualifier] = STATE(118),
    [sym__type_specifier] = STATE(52),
    [sym_sized_type_specifier] = STATE(52),
    [sym_enum_specifier] = STATE(52),
    [sym_struct_specifier] = STATE(52),
    [sym_union_specifier] = STATE(52),
    [sym_labeled_statement] = STATE(1941),
    [sym_expression_statement] = STATE(1941),
    [sym_if_statement] = STATE(1941),
    [sym_switch_statement] = STATE(1941),
    [sym_case_statement] = STATE(1941),
    [sym_while_statement] = STATE(1941),
    [sym_do_statement] = STATE(1941),
    [sym_for_statement] = STATE(1941),
    [sym_return_statement] = STATE(1941),
    [sym_break_statement] = STATE(1941),
    [sym_continue_statement] = STATE(1941),
    [sym_goto_statement] = STATE(1941),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym__empty_declaration] = STATE(1941),
    [sym_macro_type_specifier] = STATE(52),
    [sym_class_specifier] = STATE(52),
    [sym_dependent_type] = STATE(52),
    [sym_structured_binding_declaration] = STATE(1941),
    [sym_template_type] = STATE(56),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(1941),
    [sym_try_statement] = STATE(1941),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(61),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1941),
    [aux_sym__declaration_specifiers_repeat1] = STATE(118),
    [aux_sym_sized_type_specifier_repeat1] = STATE(64),
    [sym_raw_string_literal] = ACTIONS(2196),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2198),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2200),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2202),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7395),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2206),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2208),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2210),
    [sym_preproc_directive] = ACTIONS(2212),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_typedef] = ACTIONS(2216),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(37),
    [anon_sym_long] = ACTIONS(37),
    [anon_sym_short] = ACTIONS(37),
    [sym_primitive_type] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(2220),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(2244),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(39),
    [anon_sym_typename] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(109),
    [sym_nullptr] = ACTIONS(2242),
  },
  [3004] = {
    [sym_raw_string_literal] = ACTIONS(2144),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2146),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2146),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2146),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2146),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2146),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2146),
    [sym_preproc_directive] = ACTIONS(2146),
    [anon_sym_SEMI] = ACTIONS(2144),
    [anon_sym_typedef] = ACTIONS(2146),
    [anon_sym_extern] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(2144),
    [anon_sym_LPAREN2] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(2144),
    [anon_sym_LBRACK] = ACTIONS(2144),
    [anon_sym_static] = ACTIONS(2146),
    [anon_sym_register] = ACTIONS(2146),
    [anon_sym_inline] = ACTIONS(2146),
    [anon_sym_const] = ACTIONS(2146),
    [anon_sym_restrict] = ACTIONS(2146),
    [anon_sym_volatile] = ACTIONS(2146),
    [anon_sym__Atomic] = ACTIONS(2146),
    [anon_sym_mutable] = ACTIONS(2146),
    [anon_sym_explicit] = ACTIONS(2146),
    [anon_sym_constexpr] = ACTIONS(2146),
    [anon_sym_unsigned] = ACTIONS(2146),
    [anon_sym_long] = ACTIONS(2146),
    [anon_sym_short] = ACTIONS(2146),
    [sym_primitive_type] = ACTIONS(2146),
    [anon_sym_enum] = ACTIONS(2146),
    [anon_sym_struct] = ACTIONS(2146),
    [anon_sym_union] = ACTIONS(2146),
    [anon_sym_if] = ACTIONS(2146),
    [anon_sym_switch] = ACTIONS(2146),
    [anon_sym_case] = ACTIONS(2146),
    [anon_sym_default] = ACTIONS(2146),
    [anon_sym_while] = ACTIONS(2146),
    [anon_sym_do] = ACTIONS(2146),
    [anon_sym_for] = ACTIONS(2146),
    [anon_sym_return] = ACTIONS(2146),
    [anon_sym_break] = ACTIONS(2146),
    [anon_sym_continue] = ACTIONS(2146),
    [anon_sym_goto] = ACTIONS(2146),
    [anon_sym_AMP] = ACTIONS(2144),
    [anon_sym_BANG] = ACTIONS(2144),
    [anon_sym_TILDE] = ACTIONS(2144),
    [anon_sym_PLUS] = ACTIONS(2146),
    [anon_sym_DASH] = ACTIONS(2146),
    [anon_sym_DASH_DASH] = ACTIONS(2144),
    [anon_sym_PLUS_PLUS] = ACTIONS(2144),
    [anon_sym_sizeof] = ACTIONS(2146),
    [sym_number_literal] = ACTIONS(2144),
    [anon_sym_SQUOTE] = ACTIONS(2144),
    [anon_sym_DQUOTE] = ACTIONS(2144),
    [sym_true] = ACTIONS(2146),
    [sym_false] = ACTIONS(2146),
    [sym_null] = ACTIONS(2146),
    [sym_identifier] = ACTIONS(2146),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2146),
    [sym_auto] = ACTIONS(2146),
    [anon_sym_typename] = ACTIONS(2146),
    [anon_sym_delete] = ACTIONS(2146),
    [anon_sym_try] = ACTIONS(2146),
    [anon_sym_new] = ACTIONS(2146),
    [anon_sym_COLON_COLON] = ACTIONS(2144),
    [sym_nullptr] = ACTIONS(2146),
  },
  [3005] = {
    [sym_parameter_list] = STATE(1105),
    [anon_sym_SEMI] = ACTIONS(7397),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [sym_comment] = ACTIONS(91),
  },
  [3006] = {
    [sym__type_declarator] = STATE(3284),
    [sym_pointer_type_declarator] = STATE(3284),
    [sym_function_type_declarator] = STATE(3284),
    [sym_array_type_declarator] = STATE(3284),
    [anon_sym_LPAREN2] = ACTIONS(766),
    [anon_sym_STAR] = ACTIONS(768),
    [sym_identifier] = ACTIONS(770),
    [sym_comment] = ACTIONS(91),
  },
  [3007] = {
    [sym_raw_string_literal] = ACTIONS(2286),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2288),
    [sym_preproc_directive] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym_typedef] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_STAR] = ACTIONS(2286),
    [anon_sym_LBRACK] = ACTIONS(2286),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_register] = ACTIONS(2288),
    [anon_sym_inline] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_explicit] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_unsigned] = ACTIONS(2288),
    [anon_sym_long] = ACTIONS(2288),
    [anon_sym_short] = ACTIONS(2288),
    [sym_primitive_type] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [anon_sym_struct] = ACTIONS(2288),
    [anon_sym_union] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_else] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_goto] = ACTIONS(2288),
    [anon_sym_AMP] = ACTIONS(2286),
    [anon_sym_BANG] = ACTIONS(2286),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_sizeof] = ACTIONS(2288),
    [sym_number_literal] = ACTIONS(2286),
    [anon_sym_SQUOTE] = ACTIONS(2286),
    [anon_sym_DQUOTE] = ACTIONS(2286),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [sym_null] = ACTIONS(2288),
    [sym_identifier] = ACTIONS(2288),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2288),
    [sym_auto] = ACTIONS(2288),
    [anon_sym_typename] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_catch] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [sym_nullptr] = ACTIONS(2288),
  },
  [3008] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(7399),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3009] = {
    [sym__expression] = STATE(3286),
    [sym_conditional_expression] = STATE(3286),
    [sym_assignment_expression] = STATE(3286),
    [sym_pointer_expression] = STATE(3286),
    [sym_logical_expression] = STATE(3286),
    [sym_bitwise_expression] = STATE(3286),
    [sym_equality_expression] = STATE(3286),
    [sym_relational_expression] = STATE(3286),
    [sym_shift_expression] = STATE(3286),
    [sym_math_expression] = STATE(3286),
    [sym_cast_expression] = STATE(3286),
    [sym_sizeof_expression] = STATE(3286),
    [sym_subscript_expression] = STATE(3286),
    [sym_call_expression] = STATE(3286),
    [sym_field_expression] = STATE(3286),
    [sym_compound_literal_expression] = STATE(3286),
    [sym_parenthesized_expression] = STATE(3286),
    [sym_char_literal] = STATE(3286),
    [sym_concatenated_string] = STATE(3286),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3286),
    [sym_new_expression] = STATE(3286),
    [sym_delete_expression] = STATE(3286),
    [sym_lambda_expression] = STATE(3286),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7401),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(7401),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7403),
    [sym_false] = ACTIONS(7403),
    [sym_null] = ACTIONS(7403),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(7403),
  },
  [3010] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(548),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_COLON] = ACTIONS(5681),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(935),
  },
  [3011] = {
    [sym_raw_string_literal] = ACTIONS(2767),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2769),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2769),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2769),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2769),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2769),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2769),
    [sym_preproc_directive] = ACTIONS(2769),
    [anon_sym_SEMI] = ACTIONS(2767),
    [anon_sym_typedef] = ACTIONS(2769),
    [anon_sym_extern] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_LPAREN2] = ACTIONS(2767),
    [anon_sym_STAR] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(2767),
    [anon_sym_static] = ACTIONS(2769),
    [anon_sym_register] = ACTIONS(2769),
    [anon_sym_inline] = ACTIONS(2769),
    [anon_sym_const] = ACTIONS(2769),
    [anon_sym_restrict] = ACTIONS(2769),
    [anon_sym_volatile] = ACTIONS(2769),
    [anon_sym__Atomic] = ACTIONS(2769),
    [anon_sym_mutable] = ACTIONS(2769),
    [anon_sym_explicit] = ACTIONS(2769),
    [anon_sym_constexpr] = ACTIONS(2769),
    [anon_sym_unsigned] = ACTIONS(2769),
    [anon_sym_long] = ACTIONS(2769),
    [anon_sym_short] = ACTIONS(2769),
    [sym_primitive_type] = ACTIONS(2769),
    [anon_sym_enum] = ACTIONS(2769),
    [anon_sym_struct] = ACTIONS(2769),
    [anon_sym_union] = ACTIONS(2769),
    [anon_sym_if] = ACTIONS(2769),
    [anon_sym_else] = ACTIONS(2769),
    [anon_sym_switch] = ACTIONS(2769),
    [anon_sym_case] = ACTIONS(2769),
    [anon_sym_default] = ACTIONS(2769),
    [anon_sym_while] = ACTIONS(2769),
    [anon_sym_do] = ACTIONS(2769),
    [anon_sym_for] = ACTIONS(2769),
    [anon_sym_return] = ACTIONS(2769),
    [anon_sym_break] = ACTIONS(2769),
    [anon_sym_continue] = ACTIONS(2769),
    [anon_sym_goto] = ACTIONS(2769),
    [anon_sym_AMP] = ACTIONS(2767),
    [anon_sym_BANG] = ACTIONS(2767),
    [anon_sym_TILDE] = ACTIONS(2767),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_DASH_DASH] = ACTIONS(2767),
    [anon_sym_PLUS_PLUS] = ACTIONS(2767),
    [anon_sym_sizeof] = ACTIONS(2769),
    [sym_number_literal] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(2767),
    [anon_sym_DQUOTE] = ACTIONS(2767),
    [sym_true] = ACTIONS(2769),
    [sym_false] = ACTIONS(2769),
    [sym_null] = ACTIONS(2769),
    [sym_identifier] = ACTIONS(2769),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2769),
    [sym_auto] = ACTIONS(2769),
    [anon_sym_typename] = ACTIONS(2769),
    [anon_sym_delete] = ACTIONS(2769),
    [anon_sym_try] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2769),
    [anon_sym_COLON_COLON] = ACTIONS(2767),
    [sym_nullptr] = ACTIONS(2769),
  },
  [3012] = {
    [sym_declaration] = STATE(3287),
    [sym_type_definition] = STATE(3287),
    [sym__declaration_specifiers] = STATE(3015),
    [sym_compound_statement] = STATE(3287),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_labeled_statement] = STATE(3287),
    [sym_expression_statement] = STATE(3287),
    [sym_if_statement] = STATE(3287),
    [sym_switch_statement] = STATE(3287),
    [sym_case_statement] = STATE(3287),
    [sym_while_statement] = STATE(3287),
    [sym_do_statement] = STATE(3287),
    [sym_for_statement] = STATE(3287),
    [sym_return_statement] = STATE(3287),
    [sym_break_statement] = STATE(3287),
    [sym_continue_statement] = STATE(3287),
    [sym_goto_statement] = STATE(3287),
    [sym__expression] = STATE(1908),
    [sym_comma_expression] = STATE(1909),
    [sym_conditional_expression] = STATE(1908),
    [sym_assignment_expression] = STATE(1908),
    [sym_pointer_expression] = STATE(1908),
    [sym_logical_expression] = STATE(1908),
    [sym_bitwise_expression] = STATE(1908),
    [sym_equality_expression] = STATE(1908),
    [sym_relational_expression] = STATE(1908),
    [sym_shift_expression] = STATE(1908),
    [sym_math_expression] = STATE(1908),
    [sym_cast_expression] = STATE(1908),
    [sym_sizeof_expression] = STATE(1908),
    [sym_subscript_expression] = STATE(1908),
    [sym_call_expression] = STATE(1908),
    [sym_field_expression] = STATE(1908),
    [sym_compound_literal_expression] = STATE(1908),
    [sym_parenthesized_expression] = STATE(1908),
    [sym_char_literal] = STATE(1908),
    [sym_concatenated_string] = STATE(1908),
    [sym_string_literal] = STATE(55),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(1908),
    [sym_for_range_loop] = STATE(3287),
    [sym_try_statement] = STATE(3287),
    [sym_new_expression] = STATE(1908),
    [sym_delete_expression] = STATE(1908),
    [sym_lambda_expression] = STATE(1908),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(3996),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_typedef] = ACTIONS(4012),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(4016),
    [anon_sym_switch] = ACTIONS(4018),
    [anon_sym_case] = ACTIONS(4020),
    [anon_sym_default] = ACTIONS(4022),
    [anon_sym_while] = ACTIONS(4024),
    [anon_sym_do] = ACTIONS(4026),
    [anon_sym_for] = ACTIONS(4028),
    [anon_sym_return] = ACTIONS(4030),
    [anon_sym_break] = ACTIONS(4032),
    [anon_sym_continue] = ACTIONS(4034),
    [anon_sym_goto] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(3996),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4038),
    [sym_false] = ACTIONS(4038),
    [sym_null] = ACTIONS(4038),
    [sym_identifier] = ACTIONS(6777),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(4042),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(1202),
    [sym_nullptr] = ACTIONS(4038),
  },
  [3013] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(1362),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_extern] = ACTIONS(468),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(465),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_register] = ACTIONS(468),
    [anon_sym_inline] = ACTIONS(468),
    [anon_sym_const] = ACTIONS(468),
    [anon_sym_restrict] = ACTIONS(468),
    [anon_sym_volatile] = ACTIONS(468),
    [anon_sym__Atomic] = ACTIONS(468),
    [anon_sym_mutable] = ACTIONS(468),
    [anon_sym_explicit] = ACTIONS(468),
    [anon_sym_constexpr] = ACTIONS(468),
    [anon_sym_COLON] = ACTIONS(5681),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(474),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_TILDE] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_identifier] = ACTIONS(468),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(2855),
    [sym_operator_name] = ACTIONS(481),
  },
  [3014] = {
    [sym_raw_string_literal] = ACTIONS(2859),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2861),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2861),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2861),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2861),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2861),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2861),
    [sym_preproc_directive] = ACTIONS(2861),
    [anon_sym_SEMI] = ACTIONS(2859),
    [anon_sym_typedef] = ACTIONS(2861),
    [anon_sym_extern] = ACTIONS(2861),
    [anon_sym_LBRACE] = ACTIONS(2859),
    [anon_sym_LPAREN2] = ACTIONS(2859),
    [anon_sym_STAR] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_static] = ACTIONS(2861),
    [anon_sym_register] = ACTIONS(2861),
    [anon_sym_inline] = ACTIONS(2861),
    [anon_sym_const] = ACTIONS(2861),
    [anon_sym_restrict] = ACTIONS(2861),
    [anon_sym_volatile] = ACTIONS(2861),
    [anon_sym__Atomic] = ACTIONS(2861),
    [anon_sym_mutable] = ACTIONS(2861),
    [anon_sym_explicit] = ACTIONS(2861),
    [anon_sym_constexpr] = ACTIONS(2861),
    [anon_sym_unsigned] = ACTIONS(2861),
    [anon_sym_long] = ACTIONS(2861),
    [anon_sym_short] = ACTIONS(2861),
    [sym_primitive_type] = ACTIONS(2861),
    [anon_sym_enum] = ACTIONS(2861),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2861),
    [anon_sym_if] = ACTIONS(2861),
    [anon_sym_else] = ACTIONS(2861),
    [anon_sym_switch] = ACTIONS(2861),
    [anon_sym_case] = ACTIONS(2861),
    [anon_sym_default] = ACTIONS(2861),
    [anon_sym_while] = ACTIONS(2861),
    [anon_sym_do] = ACTIONS(2861),
    [anon_sym_for] = ACTIONS(2861),
    [anon_sym_return] = ACTIONS(2861),
    [anon_sym_break] = ACTIONS(2861),
    [anon_sym_continue] = ACTIONS(2861),
    [anon_sym_goto] = ACTIONS(2861),
    [anon_sym_AMP] = ACTIONS(2859),
    [anon_sym_BANG] = ACTIONS(2859),
    [anon_sym_TILDE] = ACTIONS(2859),
    [anon_sym_PLUS] = ACTIONS(2861),
    [anon_sym_DASH] = ACTIONS(2861),
    [anon_sym_DASH_DASH] = ACTIONS(2859),
    [anon_sym_PLUS_PLUS] = ACTIONS(2859),
    [anon_sym_sizeof] = ACTIONS(2861),
    [sym_number_literal] = ACTIONS(2859),
    [anon_sym_SQUOTE] = ACTIONS(2859),
    [anon_sym_DQUOTE] = ACTIONS(2859),
    [sym_true] = ACTIONS(2861),
    [sym_false] = ACTIONS(2861),
    [sym_null] = ACTIONS(2861),
    [sym_identifier] = ACTIONS(2861),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2861),
    [sym_auto] = ACTIONS(2861),
    [anon_sym_typename] = ACTIONS(2861),
    [anon_sym_delete] = ACTIONS(2861),
    [anon_sym_try] = ACTIONS(2861),
    [anon_sym_new] = ACTIONS(2861),
    [anon_sym_COLON_COLON] = ACTIONS(2859),
    [sym_nullptr] = ACTIONS(2861),
  },
  [3015] = {
    [sym__declarator] = STATE(2582),
    [sym_pointer_declarator] = STATE(2582),
    [sym_function_declarator] = STATE(2582),
    [sym_array_declarator] = STATE(2582),
    [sym_init_declarator] = STATE(2583),
    [sym_reference_declarator] = STATE(2582),
    [sym_template_type] = STATE(247),
    [sym_template_function] = STATE(2582),
    [sym_destructor_name] = STATE(2582),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(247),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(560),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(568),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(433),
    [sym_operator_name] = ACTIONS(5685),
  },
  [3016] = {
    [sym_raw_string_literal] = ACTIONS(2867),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2869),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2869),
    [sym_preproc_directive] = ACTIONS(2869),
    [anon_sym_SEMI] = ACTIONS(2867),
    [anon_sym_typedef] = ACTIONS(2869),
    [anon_sym_extern] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2867),
    [anon_sym_STAR] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_static] = ACTIONS(2869),
    [anon_sym_register] = ACTIONS(2869),
    [anon_sym_inline] = ACTIONS(2869),
    [anon_sym_const] = ACTIONS(2869),
    [anon_sym_restrict] = ACTIONS(2869),
    [anon_sym_volatile] = ACTIONS(2869),
    [anon_sym__Atomic] = ACTIONS(2869),
    [anon_sym_mutable] = ACTIONS(2869),
    [anon_sym_explicit] = ACTIONS(2869),
    [anon_sym_constexpr] = ACTIONS(2869),
    [anon_sym_unsigned] = ACTIONS(2869),
    [anon_sym_long] = ACTIONS(2869),
    [anon_sym_short] = ACTIONS(2869),
    [sym_primitive_type] = ACTIONS(2869),
    [anon_sym_enum] = ACTIONS(2869),
    [anon_sym_struct] = ACTIONS(2869),
    [anon_sym_union] = ACTIONS(2869),
    [anon_sym_if] = ACTIONS(2869),
    [anon_sym_else] = ACTIONS(2869),
    [anon_sym_switch] = ACTIONS(2869),
    [anon_sym_case] = ACTIONS(2869),
    [anon_sym_default] = ACTIONS(2869),
    [anon_sym_while] = ACTIONS(2869),
    [anon_sym_do] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2869),
    [anon_sym_return] = ACTIONS(2869),
    [anon_sym_break] = ACTIONS(2869),
    [anon_sym_continue] = ACTIONS(2869),
    [anon_sym_goto] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_BANG] = ACTIONS(2867),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2869),
    [anon_sym_DASH] = ACTIONS(2869),
    [anon_sym_DASH_DASH] = ACTIONS(2867),
    [anon_sym_PLUS_PLUS] = ACTIONS(2867),
    [anon_sym_sizeof] = ACTIONS(2869),
    [sym_number_literal] = ACTIONS(2867),
    [anon_sym_SQUOTE] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [sym_true] = ACTIONS(2869),
    [sym_false] = ACTIONS(2869),
    [sym_null] = ACTIONS(2869),
    [sym_identifier] = ACTIONS(2869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2869),
    [sym_auto] = ACTIONS(2869),
    [anon_sym_typename] = ACTIONS(2869),
    [anon_sym_delete] = ACTIONS(2869),
    [anon_sym_try] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_COLON_COLON] = ACTIONS(2867),
    [sym_nullptr] = ACTIONS(2869),
  },
  [3017] = {
    [sym_parenthesized_expression] = STATE(3289),
    [anon_sym_LPAREN2] = ACTIONS(7405),
    [sym_comment] = ACTIONS(91),
  },
  [3018] = {
    [sym__expression] = STATE(3291),
    [sym_conditional_expression] = STATE(3291),
    [sym_assignment_expression] = STATE(3291),
    [sym_pointer_expression] = STATE(3291),
    [sym_logical_expression] = STATE(3291),
    [sym_bitwise_expression] = STATE(3291),
    [sym_equality_expression] = STATE(3291),
    [sym_relational_expression] = STATE(3291),
    [sym_shift_expression] = STATE(3291),
    [sym_math_expression] = STATE(3291),
    [sym_cast_expression] = STATE(3291),
    [sym_sizeof_expression] = STATE(3291),
    [sym_subscript_expression] = STATE(3291),
    [sym_call_expression] = STATE(3291),
    [sym_field_expression] = STATE(3291),
    [sym_compound_literal_expression] = STATE(3291),
    [sym_parenthesized_expression] = STATE(3291),
    [sym_char_literal] = STATE(3291),
    [sym_concatenated_string] = STATE(3291),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3291),
    [sym_new_expression] = STATE(3291),
    [sym_delete_expression] = STATE(3291),
    [sym_lambda_expression] = STATE(3291),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7407),
    [anon_sym_SEMI] = ACTIONS(7409),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(7407),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7411),
    [sym_false] = ACTIONS(7411),
    [sym_null] = ACTIONS(7411),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(7411),
  },
  [3019] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(7413),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3020] = {
    [anon_sym_COLON] = ACTIONS(7415),
    [sym_comment] = ACTIONS(91),
  },
  [3021] = {
    [sym_raw_string_literal] = ACTIONS(2999),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3001),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3001),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3001),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3001),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3001),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3001),
    [sym_preproc_directive] = ACTIONS(3001),
    [anon_sym_SEMI] = ACTIONS(2999),
    [anon_sym_typedef] = ACTIONS(3001),
    [anon_sym_extern] = ACTIONS(3001),
    [anon_sym_LBRACE] = ACTIONS(2999),
    [anon_sym_LPAREN2] = ACTIONS(2999),
    [anon_sym_STAR] = ACTIONS(2999),
    [anon_sym_LBRACK] = ACTIONS(2999),
    [anon_sym_static] = ACTIONS(3001),
    [anon_sym_register] = ACTIONS(3001),
    [anon_sym_inline] = ACTIONS(3001),
    [anon_sym_const] = ACTIONS(3001),
    [anon_sym_restrict] = ACTIONS(3001),
    [anon_sym_volatile] = ACTIONS(3001),
    [anon_sym__Atomic] = ACTIONS(3001),
    [anon_sym_mutable] = ACTIONS(3001),
    [anon_sym_explicit] = ACTIONS(3001),
    [anon_sym_constexpr] = ACTIONS(3001),
    [anon_sym_unsigned] = ACTIONS(3001),
    [anon_sym_long] = ACTIONS(3001),
    [anon_sym_short] = ACTIONS(3001),
    [sym_primitive_type] = ACTIONS(3001),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_struct] = ACTIONS(3001),
    [anon_sym_union] = ACTIONS(3001),
    [anon_sym_if] = ACTIONS(3001),
    [anon_sym_else] = ACTIONS(3001),
    [anon_sym_switch] = ACTIONS(3001),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3001),
    [anon_sym_while] = ACTIONS(3001),
    [anon_sym_do] = ACTIONS(3001),
    [anon_sym_for] = ACTIONS(3001),
    [anon_sym_return] = ACTIONS(3001),
    [anon_sym_break] = ACTIONS(3001),
    [anon_sym_continue] = ACTIONS(3001),
    [anon_sym_goto] = ACTIONS(3001),
    [anon_sym_AMP] = ACTIONS(2999),
    [anon_sym_BANG] = ACTIONS(2999),
    [anon_sym_TILDE] = ACTIONS(2999),
    [anon_sym_PLUS] = ACTIONS(3001),
    [anon_sym_DASH] = ACTIONS(3001),
    [anon_sym_DASH_DASH] = ACTIONS(2999),
    [anon_sym_PLUS_PLUS] = ACTIONS(2999),
    [anon_sym_sizeof] = ACTIONS(3001),
    [sym_number_literal] = ACTIONS(2999),
    [anon_sym_SQUOTE] = ACTIONS(2999),
    [anon_sym_DQUOTE] = ACTIONS(2999),
    [sym_true] = ACTIONS(3001),
    [sym_false] = ACTIONS(3001),
    [sym_null] = ACTIONS(3001),
    [sym_identifier] = ACTIONS(3001),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3001),
    [sym_auto] = ACTIONS(3001),
    [anon_sym_typename] = ACTIONS(3001),
    [anon_sym_delete] = ACTIONS(3001),
    [anon_sym_try] = ACTIONS(3001),
    [anon_sym_new] = ACTIONS(3001),
    [anon_sym_COLON_COLON] = ACTIONS(2999),
    [sym_nullptr] = ACTIONS(3001),
  },
  [3022] = {
    [sym_raw_string_literal] = ACTIONS(3047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3049),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3049),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3049),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3049),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3049),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3049),
    [sym_preproc_directive] = ACTIONS(3049),
    [anon_sym_SEMI] = ACTIONS(3047),
    [anon_sym_typedef] = ACTIONS(3049),
    [anon_sym_extern] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(3047),
    [anon_sym_LPAREN2] = ACTIONS(3047),
    [anon_sym_STAR] = ACTIONS(3047),
    [anon_sym_LBRACK] = ACTIONS(3047),
    [anon_sym_static] = ACTIONS(3049),
    [anon_sym_register] = ACTIONS(3049),
    [anon_sym_inline] = ACTIONS(3049),
    [anon_sym_const] = ACTIONS(3049),
    [anon_sym_restrict] = ACTIONS(3049),
    [anon_sym_volatile] = ACTIONS(3049),
    [anon_sym__Atomic] = ACTIONS(3049),
    [anon_sym_mutable] = ACTIONS(3049),
    [anon_sym_explicit] = ACTIONS(3049),
    [anon_sym_constexpr] = ACTIONS(3049),
    [anon_sym_unsigned] = ACTIONS(3049),
    [anon_sym_long] = ACTIONS(3049),
    [anon_sym_short] = ACTIONS(3049),
    [sym_primitive_type] = ACTIONS(3049),
    [anon_sym_enum] = ACTIONS(3049),
    [anon_sym_struct] = ACTIONS(3049),
    [anon_sym_union] = ACTIONS(3049),
    [anon_sym_if] = ACTIONS(3049),
    [anon_sym_else] = ACTIONS(3049),
    [anon_sym_switch] = ACTIONS(3049),
    [anon_sym_case] = ACTIONS(3049),
    [anon_sym_default] = ACTIONS(3049),
    [anon_sym_while] = ACTIONS(3049),
    [anon_sym_do] = ACTIONS(3049),
    [anon_sym_for] = ACTIONS(3049),
    [anon_sym_return] = ACTIONS(3049),
    [anon_sym_break] = ACTIONS(3049),
    [anon_sym_continue] = ACTIONS(3049),
    [anon_sym_goto] = ACTIONS(3049),
    [anon_sym_AMP] = ACTIONS(3047),
    [anon_sym_BANG] = ACTIONS(3047),
    [anon_sym_TILDE] = ACTIONS(3047),
    [anon_sym_PLUS] = ACTIONS(3049),
    [anon_sym_DASH] = ACTIONS(3049),
    [anon_sym_DASH_DASH] = ACTIONS(3047),
    [anon_sym_PLUS_PLUS] = ACTIONS(3047),
    [anon_sym_sizeof] = ACTIONS(3049),
    [sym_number_literal] = ACTIONS(3047),
    [anon_sym_SQUOTE] = ACTIONS(3047),
    [anon_sym_DQUOTE] = ACTIONS(3047),
    [sym_true] = ACTIONS(3049),
    [sym_false] = ACTIONS(3049),
    [sym_null] = ACTIONS(3049),
    [sym_identifier] = ACTIONS(3049),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3049),
    [sym_auto] = ACTIONS(3049),
    [anon_sym_typename] = ACTIONS(3049),
    [anon_sym_delete] = ACTIONS(3049),
    [anon_sym_try] = ACTIONS(3049),
    [anon_sym_new] = ACTIONS(3049),
    [anon_sym_COLON_COLON] = ACTIONS(3047),
    [sym_nullptr] = ACTIONS(3049),
  },
  [3023] = {
    [sym_raw_string_literal] = ACTIONS(3072),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3074),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3074),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3074),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3074),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3074),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3074),
    [sym_preproc_directive] = ACTIONS(3074),
    [anon_sym_SEMI] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3074),
    [anon_sym_extern] = ACTIONS(3074),
    [anon_sym_LBRACE] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3074),
    [anon_sym_register] = ACTIONS(3074),
    [anon_sym_inline] = ACTIONS(3074),
    [anon_sym_const] = ACTIONS(3074),
    [anon_sym_restrict] = ACTIONS(3074),
    [anon_sym_volatile] = ACTIONS(3074),
    [anon_sym__Atomic] = ACTIONS(3074),
    [anon_sym_mutable] = ACTIONS(3074),
    [anon_sym_explicit] = ACTIONS(3074),
    [anon_sym_constexpr] = ACTIONS(3074),
    [anon_sym_unsigned] = ACTIONS(3074),
    [anon_sym_long] = ACTIONS(3074),
    [anon_sym_short] = ACTIONS(3074),
    [sym_primitive_type] = ACTIONS(3074),
    [anon_sym_enum] = ACTIONS(3074),
    [anon_sym_struct] = ACTIONS(3074),
    [anon_sym_union] = ACTIONS(3074),
    [anon_sym_if] = ACTIONS(3074),
    [anon_sym_else] = ACTIONS(3074),
    [anon_sym_switch] = ACTIONS(3074),
    [anon_sym_case] = ACTIONS(3074),
    [anon_sym_default] = ACTIONS(3074),
    [anon_sym_while] = ACTIONS(3074),
    [anon_sym_do] = ACTIONS(3074),
    [anon_sym_for] = ACTIONS(3074),
    [anon_sym_return] = ACTIONS(3074),
    [anon_sym_break] = ACTIONS(3074),
    [anon_sym_continue] = ACTIONS(3074),
    [anon_sym_goto] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_BANG] = ACTIONS(3072),
    [anon_sym_TILDE] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3074),
    [anon_sym_DASH_DASH] = ACTIONS(3072),
    [anon_sym_PLUS_PLUS] = ACTIONS(3072),
    [anon_sym_sizeof] = ACTIONS(3074),
    [sym_number_literal] = ACTIONS(3072),
    [anon_sym_SQUOTE] = ACTIONS(3072),
    [anon_sym_DQUOTE] = ACTIONS(3072),
    [sym_true] = ACTIONS(3074),
    [sym_false] = ACTIONS(3074),
    [sym_null] = ACTIONS(3074),
    [sym_identifier] = ACTIONS(3074),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3074),
    [sym_auto] = ACTIONS(3074),
    [anon_sym_typename] = ACTIONS(3074),
    [anon_sym_delete] = ACTIONS(3074),
    [anon_sym_try] = ACTIONS(3074),
    [anon_sym_new] = ACTIONS(3074),
    [anon_sym_COLON_COLON] = ACTIONS(3072),
    [sym_nullptr] = ACTIONS(3074),
  },
  [3024] = {
    [sym_parameter_list] = STATE(3294),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [sym_comment] = ACTIONS(91),
  },
  [3025] = {
    [sym_catch_clause] = STATE(3295),
    [aux_sym_try_statement_repeat1] = STATE(3295),
    [sym_raw_string_literal] = ACTIONS(3346),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3348),
    [sym_preproc_directive] = ACTIONS(3348),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym_typedef] = ACTIONS(3348),
    [anon_sym_extern] = ACTIONS(3348),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(3346),
    [anon_sym_static] = ACTIONS(3348),
    [anon_sym_register] = ACTIONS(3348),
    [anon_sym_inline] = ACTIONS(3348),
    [anon_sym_const] = ACTIONS(3348),
    [anon_sym_restrict] = ACTIONS(3348),
    [anon_sym_volatile] = ACTIONS(3348),
    [anon_sym__Atomic] = ACTIONS(3348),
    [anon_sym_mutable] = ACTIONS(3348),
    [anon_sym_explicit] = ACTIONS(3348),
    [anon_sym_constexpr] = ACTIONS(3348),
    [anon_sym_unsigned] = ACTIONS(3348),
    [anon_sym_long] = ACTIONS(3348),
    [anon_sym_short] = ACTIONS(3348),
    [sym_primitive_type] = ACTIONS(3348),
    [anon_sym_enum] = ACTIONS(3348),
    [anon_sym_struct] = ACTIONS(3348),
    [anon_sym_union] = ACTIONS(3348),
    [anon_sym_if] = ACTIONS(3348),
    [anon_sym_switch] = ACTIONS(3348),
    [anon_sym_case] = ACTIONS(3348),
    [anon_sym_default] = ACTIONS(3348),
    [anon_sym_while] = ACTIONS(3348),
    [anon_sym_do] = ACTIONS(3348),
    [anon_sym_for] = ACTIONS(3348),
    [anon_sym_return] = ACTIONS(3348),
    [anon_sym_break] = ACTIONS(3348),
    [anon_sym_continue] = ACTIONS(3348),
    [anon_sym_goto] = ACTIONS(3348),
    [anon_sym_AMP] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_PLUS] = ACTIONS(3348),
    [anon_sym_DASH] = ACTIONS(3348),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_sizeof] = ACTIONS(3348),
    [sym_number_literal] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [sym_true] = ACTIONS(3348),
    [sym_false] = ACTIONS(3348),
    [sym_null] = ACTIONS(3348),
    [sym_identifier] = ACTIONS(3348),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3348),
    [sym_auto] = ACTIONS(3348),
    [anon_sym_typename] = ACTIONS(3348),
    [anon_sym_delete] = ACTIONS(3348),
    [anon_sym_try] = ACTIONS(3348),
    [anon_sym_catch] = ACTIONS(7417),
    [anon_sym_new] = ACTIONS(3348),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [sym_nullptr] = ACTIONS(3348),
  },
  [3026] = {
    [sym_raw_string_literal] = ACTIONS(3397),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3399),
    [sym_preproc_directive] = ACTIONS(3399),
    [anon_sym_SEMI] = ACTIONS(3397),
    [anon_sym_typedef] = ACTIONS(3399),
    [anon_sym_extern] = ACTIONS(3399),
    [anon_sym_LBRACE] = ACTIONS(3397),
    [anon_sym_LPAREN2] = ACTIONS(3397),
    [anon_sym_STAR] = ACTIONS(3397),
    [anon_sym_LBRACK] = ACTIONS(3397),
    [anon_sym_static] = ACTIONS(3399),
    [anon_sym_register] = ACTIONS(3399),
    [anon_sym_inline] = ACTIONS(3399),
    [anon_sym_const] = ACTIONS(3399),
    [anon_sym_restrict] = ACTIONS(3399),
    [anon_sym_volatile] = ACTIONS(3399),
    [anon_sym__Atomic] = ACTIONS(3399),
    [anon_sym_mutable] = ACTIONS(3399),
    [anon_sym_explicit] = ACTIONS(3399),
    [anon_sym_constexpr] = ACTIONS(3399),
    [anon_sym_unsigned] = ACTIONS(3399),
    [anon_sym_long] = ACTIONS(3399),
    [anon_sym_short] = ACTIONS(3399),
    [sym_primitive_type] = ACTIONS(3399),
    [anon_sym_enum] = ACTIONS(3399),
    [anon_sym_struct] = ACTIONS(3399),
    [anon_sym_union] = ACTIONS(3399),
    [anon_sym_if] = ACTIONS(3399),
    [anon_sym_else] = ACTIONS(3399),
    [anon_sym_switch] = ACTIONS(3399),
    [anon_sym_case] = ACTIONS(3399),
    [anon_sym_default] = ACTIONS(3399),
    [anon_sym_while] = ACTIONS(3399),
    [anon_sym_do] = ACTIONS(3399),
    [anon_sym_for] = ACTIONS(3399),
    [anon_sym_return] = ACTIONS(3399),
    [anon_sym_break] = ACTIONS(3399),
    [anon_sym_continue] = ACTIONS(3399),
    [anon_sym_goto] = ACTIONS(3399),
    [anon_sym_AMP] = ACTIONS(3397),
    [anon_sym_BANG] = ACTIONS(3397),
    [anon_sym_TILDE] = ACTIONS(3397),
    [anon_sym_PLUS] = ACTIONS(3399),
    [anon_sym_DASH] = ACTIONS(3399),
    [anon_sym_DASH_DASH] = ACTIONS(3397),
    [anon_sym_PLUS_PLUS] = ACTIONS(3397),
    [anon_sym_sizeof] = ACTIONS(3399),
    [sym_number_literal] = ACTIONS(3397),
    [anon_sym_SQUOTE] = ACTIONS(3397),
    [anon_sym_DQUOTE] = ACTIONS(3397),
    [sym_true] = ACTIONS(3399),
    [sym_false] = ACTIONS(3399),
    [sym_null] = ACTIONS(3399),
    [sym_identifier] = ACTIONS(3399),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3399),
    [sym_auto] = ACTIONS(3399),
    [anon_sym_typename] = ACTIONS(3399),
    [anon_sym_delete] = ACTIONS(3399),
    [anon_sym_try] = ACTIONS(3399),
    [anon_sym_new] = ACTIONS(3399),
    [anon_sym_COLON_COLON] = ACTIONS(3397),
    [sym_nullptr] = ACTIONS(3399),
  },
  [3027] = {
    [aux_sym_declaration_repeat1] = STATE(1643),
    [anon_sym_COMMA] = ACTIONS(1613),
    [anon_sym_SEMI] = ACTIONS(7419),
    [sym_comment] = ACTIONS(91),
  },
  [3028] = {
    [sym__expression] = STATE(3297),
    [sym_conditional_expression] = STATE(3297),
    [sym_assignment_expression] = STATE(3297),
    [sym_pointer_expression] = STATE(3297),
    [sym_logical_expression] = STATE(3297),
    [sym_bitwise_expression] = STATE(3297),
    [sym_equality_expression] = STATE(3297),
    [sym_relational_expression] = STATE(3297),
    [sym_shift_expression] = STATE(3297),
    [sym_math_expression] = STATE(3297),
    [sym_cast_expression] = STATE(3297),
    [sym_sizeof_expression] = STATE(3297),
    [sym_subscript_expression] = STATE(3297),
    [sym_call_expression] = STATE(3297),
    [sym_field_expression] = STATE(3297),
    [sym_compound_literal_expression] = STATE(3297),
    [sym_parenthesized_expression] = STATE(3297),
    [sym_initializer_list] = STATE(3298),
    [sym_char_literal] = STATE(3297),
    [sym_concatenated_string] = STATE(3297),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3297),
    [sym_new_expression] = STATE(3297),
    [sym_delete_expression] = STATE(3297),
    [sym_lambda_expression] = STATE(3297),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7421),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(7421),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7423),
    [sym_false] = ACTIONS(7423),
    [sym_null] = ACTIONS(7423),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(7423),
  },
  [3029] = {
    [anon_sym_SEMI] = ACTIONS(7425),
    [sym_comment] = ACTIONS(91),
  },
  [3030] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7427),
    [sym_comment] = ACTIONS(91),
  },
  [3031] = {
    [sym_raw_string_literal] = ACTIONS(3958),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3960),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3960),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3960),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3960),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3960),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3960),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3960),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3960),
    [sym_preproc_directive] = ACTIONS(3960),
    [anon_sym_SEMI] = ACTIONS(3958),
    [anon_sym_typedef] = ACTIONS(3960),
    [anon_sym_extern] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3958),
    [anon_sym_LPAREN2] = ACTIONS(3958),
    [anon_sym_STAR] = ACTIONS(3958),
    [anon_sym_LBRACK] = ACTIONS(3958),
    [anon_sym_static] = ACTIONS(3960),
    [anon_sym_register] = ACTIONS(3960),
    [anon_sym_inline] = ACTIONS(3960),
    [anon_sym_const] = ACTIONS(3960),
    [anon_sym_restrict] = ACTIONS(3960),
    [anon_sym_volatile] = ACTIONS(3960),
    [anon_sym__Atomic] = ACTIONS(3960),
    [anon_sym_mutable] = ACTIONS(3960),
    [anon_sym_explicit] = ACTIONS(3960),
    [anon_sym_constexpr] = ACTIONS(3960),
    [anon_sym_unsigned] = ACTIONS(3960),
    [anon_sym_long] = ACTIONS(3960),
    [anon_sym_short] = ACTIONS(3960),
    [sym_primitive_type] = ACTIONS(3960),
    [anon_sym_enum] = ACTIONS(3960),
    [anon_sym_struct] = ACTIONS(3960),
    [anon_sym_union] = ACTIONS(3960),
    [anon_sym_if] = ACTIONS(3960),
    [anon_sym_else] = ACTIONS(3960),
    [anon_sym_switch] = ACTIONS(3960),
    [anon_sym_case] = ACTIONS(3960),
    [anon_sym_default] = ACTIONS(3960),
    [anon_sym_while] = ACTIONS(3960),
    [anon_sym_do] = ACTIONS(3960),
    [anon_sym_for] = ACTIONS(3960),
    [anon_sym_return] = ACTIONS(3960),
    [anon_sym_break] = ACTIONS(3960),
    [anon_sym_continue] = ACTIONS(3960),
    [anon_sym_goto] = ACTIONS(3960),
    [anon_sym_AMP] = ACTIONS(3958),
    [anon_sym_BANG] = ACTIONS(3958),
    [anon_sym_TILDE] = ACTIONS(3958),
    [anon_sym_PLUS] = ACTIONS(3960),
    [anon_sym_DASH] = ACTIONS(3960),
    [anon_sym_DASH_DASH] = ACTIONS(3958),
    [anon_sym_PLUS_PLUS] = ACTIONS(3958),
    [anon_sym_sizeof] = ACTIONS(3960),
    [sym_number_literal] = ACTIONS(3958),
    [anon_sym_SQUOTE] = ACTIONS(3958),
    [anon_sym_DQUOTE] = ACTIONS(3958),
    [sym_true] = ACTIONS(3960),
    [sym_false] = ACTIONS(3960),
    [sym_null] = ACTIONS(3960),
    [sym_identifier] = ACTIONS(3960),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3960),
    [sym_auto] = ACTIONS(3960),
    [anon_sym_typename] = ACTIONS(3960),
    [anon_sym_delete] = ACTIONS(3960),
    [anon_sym_try] = ACTIONS(3960),
    [anon_sym_new] = ACTIONS(3960),
    [anon_sym_COLON_COLON] = ACTIONS(3958),
    [sym_nullptr] = ACTIONS(3960),
  },
  [3032] = {
    [sym_parameter_list] = STATE(1105),
    [anon_sym_SEMI] = ACTIONS(7429),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [sym_comment] = ACTIONS(91),
  },
  [3033] = {
    [sym_compound_statement] = STATE(3309),
    [sym_labeled_statement] = STATE(3309),
    [sym_expression_statement] = STATE(3309),
    [sym_if_statement] = STATE(3309),
    [sym_switch_statement] = STATE(3309),
    [sym_case_statement] = STATE(3309),
    [sym_while_statement] = STATE(3309),
    [sym_do_statement] = STATE(3309),
    [sym_for_statement] = STATE(3309),
    [sym_return_statement] = STATE(3309),
    [sym_break_statement] = STATE(3309),
    [sym_continue_statement] = STATE(3309),
    [sym_goto_statement] = STATE(3309),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(3309),
    [sym_try_statement] = STATE(3309),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7431),
    [anon_sym_switch] = ACTIONS(7433),
    [anon_sym_case] = ACTIONS(7435),
    [anon_sym_default] = ACTIONS(7437),
    [anon_sym_while] = ACTIONS(7439),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(7441),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(7443),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7445),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2242),
  },
  [3034] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(7447),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3035] = {
    [sym_raw_string_literal] = ACTIONS(4513),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4515),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4515),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4515),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4515),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4515),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4515),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4515),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4515),
    [sym_preproc_directive] = ACTIONS(4515),
    [anon_sym_SEMI] = ACTIONS(4513),
    [anon_sym_typedef] = ACTIONS(4515),
    [anon_sym_extern] = ACTIONS(4515),
    [anon_sym_LBRACE] = ACTIONS(4513),
    [anon_sym_LPAREN2] = ACTIONS(4513),
    [anon_sym_STAR] = ACTIONS(4513),
    [anon_sym_LBRACK] = ACTIONS(4513),
    [anon_sym_static] = ACTIONS(4515),
    [anon_sym_register] = ACTIONS(4515),
    [anon_sym_inline] = ACTIONS(4515),
    [anon_sym_const] = ACTIONS(4515),
    [anon_sym_restrict] = ACTIONS(4515),
    [anon_sym_volatile] = ACTIONS(4515),
    [anon_sym__Atomic] = ACTIONS(4515),
    [anon_sym_mutable] = ACTIONS(4515),
    [anon_sym_explicit] = ACTIONS(4515),
    [anon_sym_constexpr] = ACTIONS(4515),
    [anon_sym_unsigned] = ACTIONS(4515),
    [anon_sym_long] = ACTIONS(4515),
    [anon_sym_short] = ACTIONS(4515),
    [sym_primitive_type] = ACTIONS(4515),
    [anon_sym_enum] = ACTIONS(4515),
    [anon_sym_struct] = ACTIONS(4515),
    [anon_sym_union] = ACTIONS(4515),
    [anon_sym_if] = ACTIONS(4515),
    [anon_sym_else] = ACTIONS(4515),
    [anon_sym_switch] = ACTIONS(4515),
    [anon_sym_case] = ACTIONS(4515),
    [anon_sym_default] = ACTIONS(4515),
    [anon_sym_while] = ACTIONS(4515),
    [anon_sym_do] = ACTIONS(4515),
    [anon_sym_for] = ACTIONS(4515),
    [anon_sym_return] = ACTIONS(4515),
    [anon_sym_break] = ACTIONS(4515),
    [anon_sym_continue] = ACTIONS(4515),
    [anon_sym_goto] = ACTIONS(4515),
    [anon_sym_AMP] = ACTIONS(4513),
    [anon_sym_BANG] = ACTIONS(4513),
    [anon_sym_TILDE] = ACTIONS(4513),
    [anon_sym_PLUS] = ACTIONS(4515),
    [anon_sym_DASH] = ACTIONS(4515),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
    [anon_sym_sizeof] = ACTIONS(4515),
    [sym_number_literal] = ACTIONS(4513),
    [anon_sym_SQUOTE] = ACTIONS(4513),
    [anon_sym_DQUOTE] = ACTIONS(4513),
    [sym_true] = ACTIONS(4515),
    [sym_false] = ACTIONS(4515),
    [sym_null] = ACTIONS(4515),
    [sym_identifier] = ACTIONS(4515),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4515),
    [sym_auto] = ACTIONS(4515),
    [anon_sym_typename] = ACTIONS(4515),
    [anon_sym_delete] = ACTIONS(4515),
    [anon_sym_try] = ACTIONS(4515),
    [anon_sym_new] = ACTIONS(4515),
    [anon_sym_COLON_COLON] = ACTIONS(4513),
    [sym_nullptr] = ACTIONS(4515),
  },
  [3036] = {
    [sym__expression] = STATE(3311),
    [sym_comma_expression] = STATE(3312),
    [sym_conditional_expression] = STATE(3311),
    [sym_assignment_expression] = STATE(3311),
    [sym_pointer_expression] = STATE(3311),
    [sym_logical_expression] = STATE(3311),
    [sym_bitwise_expression] = STATE(3311),
    [sym_equality_expression] = STATE(3311),
    [sym_relational_expression] = STATE(3311),
    [sym_shift_expression] = STATE(3311),
    [sym_math_expression] = STATE(3311),
    [sym_cast_expression] = STATE(3311),
    [sym_sizeof_expression] = STATE(3311),
    [sym_subscript_expression] = STATE(3311),
    [sym_call_expression] = STATE(3311),
    [sym_field_expression] = STATE(3311),
    [sym_compound_literal_expression] = STATE(3311),
    [sym_parenthesized_expression] = STATE(3311),
    [sym_char_literal] = STATE(3311),
    [sym_concatenated_string] = STATE(3311),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3311),
    [sym_new_expression] = STATE(3311),
    [sym_delete_expression] = STATE(3311),
    [sym_lambda_expression] = STATE(3311),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7449),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(7449),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7451),
    [sym_false] = ACTIONS(7451),
    [sym_null] = ACTIONS(7451),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(7451),
  },
  [3037] = {
    [sym_raw_string_literal] = ACTIONS(4554),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4556),
    [sym_preproc_directive] = ACTIONS(4556),
    [anon_sym_SEMI] = ACTIONS(4554),
    [anon_sym_typedef] = ACTIONS(4556),
    [anon_sym_extern] = ACTIONS(4556),
    [anon_sym_LBRACE] = ACTIONS(4554),
    [anon_sym_LPAREN2] = ACTIONS(4554),
    [anon_sym_STAR] = ACTIONS(4554),
    [anon_sym_LBRACK] = ACTIONS(4554),
    [anon_sym_static] = ACTIONS(4556),
    [anon_sym_register] = ACTIONS(4556),
    [anon_sym_inline] = ACTIONS(4556),
    [anon_sym_const] = ACTIONS(4556),
    [anon_sym_restrict] = ACTIONS(4556),
    [anon_sym_volatile] = ACTIONS(4556),
    [anon_sym__Atomic] = ACTIONS(4556),
    [anon_sym_mutable] = ACTIONS(4556),
    [anon_sym_explicit] = ACTIONS(4556),
    [anon_sym_constexpr] = ACTIONS(4556),
    [anon_sym_unsigned] = ACTIONS(4556),
    [anon_sym_long] = ACTIONS(4556),
    [anon_sym_short] = ACTIONS(4556),
    [sym_primitive_type] = ACTIONS(4556),
    [anon_sym_enum] = ACTIONS(4556),
    [anon_sym_struct] = ACTIONS(4556),
    [anon_sym_union] = ACTIONS(4556),
    [anon_sym_if] = ACTIONS(4556),
    [anon_sym_else] = ACTIONS(4556),
    [anon_sym_switch] = ACTIONS(4556),
    [anon_sym_case] = ACTIONS(4556),
    [anon_sym_default] = ACTIONS(4556),
    [anon_sym_while] = ACTIONS(4556),
    [anon_sym_do] = ACTIONS(4556),
    [anon_sym_for] = ACTIONS(4556),
    [anon_sym_return] = ACTIONS(4556),
    [anon_sym_break] = ACTIONS(4556),
    [anon_sym_continue] = ACTIONS(4556),
    [anon_sym_goto] = ACTIONS(4556),
    [anon_sym_AMP] = ACTIONS(4554),
    [anon_sym_BANG] = ACTIONS(4554),
    [anon_sym_TILDE] = ACTIONS(4554),
    [anon_sym_PLUS] = ACTIONS(4556),
    [anon_sym_DASH] = ACTIONS(4556),
    [anon_sym_DASH_DASH] = ACTIONS(4554),
    [anon_sym_PLUS_PLUS] = ACTIONS(4554),
    [anon_sym_sizeof] = ACTIONS(4556),
    [sym_number_literal] = ACTIONS(4554),
    [anon_sym_SQUOTE] = ACTIONS(4554),
    [anon_sym_DQUOTE] = ACTIONS(4554),
    [sym_true] = ACTIONS(4556),
    [sym_false] = ACTIONS(4556),
    [sym_null] = ACTIONS(4556),
    [sym_identifier] = ACTIONS(4556),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4556),
    [sym_auto] = ACTIONS(4556),
    [anon_sym_typename] = ACTIONS(4556),
    [anon_sym_delete] = ACTIONS(4556),
    [anon_sym_try] = ACTIONS(4556),
    [anon_sym_new] = ACTIONS(4556),
    [anon_sym_COLON_COLON] = ACTIONS(4554),
    [sym_nullptr] = ACTIONS(4556),
  },
  [3038] = {
    [sym__expression] = STATE(3314),
    [sym_conditional_expression] = STATE(3314),
    [sym_assignment_expression] = STATE(3314),
    [sym_pointer_expression] = STATE(3314),
    [sym_logical_expression] = STATE(3314),
    [sym_bitwise_expression] = STATE(3314),
    [sym_equality_expression] = STATE(3314),
    [sym_relational_expression] = STATE(3314),
    [sym_shift_expression] = STATE(3314),
    [sym_math_expression] = STATE(3314),
    [sym_cast_expression] = STATE(3314),
    [sym_sizeof_expression] = STATE(3314),
    [sym_subscript_expression] = STATE(3314),
    [sym_call_expression] = STATE(3314),
    [sym_field_expression] = STATE(3314),
    [sym_compound_literal_expression] = STATE(3314),
    [sym_parenthesized_expression] = STATE(3314),
    [sym_char_literal] = STATE(3314),
    [sym_concatenated_string] = STATE(3314),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3314),
    [sym_new_expression] = STATE(3314),
    [sym_delete_expression] = STATE(3314),
    [sym_lambda_expression] = STATE(3314),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7453),
    [anon_sym_RPAREN] = ACTIONS(7455),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(7453),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7457),
    [sym_false] = ACTIONS(7457),
    [sym_null] = ACTIONS(7457),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(7457),
  },
  [3039] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(7459),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3040] = {
    [sym__expression] = STATE(3316),
    [sym_conditional_expression] = STATE(3316),
    [sym_assignment_expression] = STATE(3316),
    [sym_pointer_expression] = STATE(3316),
    [sym_logical_expression] = STATE(3316),
    [sym_bitwise_expression] = STATE(3316),
    [sym_equality_expression] = STATE(3316),
    [sym_relational_expression] = STATE(3316),
    [sym_shift_expression] = STATE(3316),
    [sym_math_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_sizeof_expression] = STATE(3316),
    [sym_subscript_expression] = STATE(3316),
    [sym_call_expression] = STATE(3316),
    [sym_field_expression] = STATE(3316),
    [sym_compound_literal_expression] = STATE(3316),
    [sym_parenthesized_expression] = STATE(3316),
    [sym_char_literal] = STATE(3316),
    [sym_concatenated_string] = STATE(3316),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_lambda_expression] = STATE(3316),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7461),
    [anon_sym_SEMI] = ACTIONS(7459),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(7461),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7463),
    [sym_false] = ACTIONS(7463),
    [sym_null] = ACTIONS(7463),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(7463),
  },
  [3041] = {
    [sym__expression] = STATE(3317),
    [sym_conditional_expression] = STATE(3317),
    [sym_assignment_expression] = STATE(3317),
    [sym_pointer_expression] = STATE(3317),
    [sym_logical_expression] = STATE(3317),
    [sym_bitwise_expression] = STATE(3317),
    [sym_equality_expression] = STATE(3317),
    [sym_relational_expression] = STATE(3317),
    [sym_shift_expression] = STATE(3317),
    [sym_math_expression] = STATE(3317),
    [sym_cast_expression] = STATE(3317),
    [sym_sizeof_expression] = STATE(3317),
    [sym_subscript_expression] = STATE(3317),
    [sym_call_expression] = STATE(3317),
    [sym_field_expression] = STATE(3317),
    [sym_compound_literal_expression] = STATE(3317),
    [sym_parenthesized_expression] = STATE(3317),
    [sym_char_literal] = STATE(3317),
    [sym_concatenated_string] = STATE(3317),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3317),
    [sym_new_expression] = STATE(3317),
    [sym_delete_expression] = STATE(3317),
    [sym_lambda_expression] = STATE(3317),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7465),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(7465),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7467),
    [sym_false] = ACTIONS(7467),
    [sym_null] = ACTIONS(7467),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(7467),
  },
  [3042] = {
    [sym_compound_statement] = STATE(3318),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [sym_comment] = ACTIONS(91),
  },
  [3043] = {
    [sym_catch_clause] = STATE(3043),
    [aux_sym_try_statement_repeat1] = STATE(3043),
    [sym_raw_string_literal] = ACTIONS(4993),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4995),
    [sym_preproc_directive] = ACTIONS(4995),
    [anon_sym_SEMI] = ACTIONS(4993),
    [anon_sym_typedef] = ACTIONS(4995),
    [anon_sym_extern] = ACTIONS(4995),
    [anon_sym_LBRACE] = ACTIONS(4993),
    [anon_sym_LPAREN2] = ACTIONS(4993),
    [anon_sym_STAR] = ACTIONS(4993),
    [anon_sym_LBRACK] = ACTIONS(4993),
    [anon_sym_static] = ACTIONS(4995),
    [anon_sym_register] = ACTIONS(4995),
    [anon_sym_inline] = ACTIONS(4995),
    [anon_sym_const] = ACTIONS(4995),
    [anon_sym_restrict] = ACTIONS(4995),
    [anon_sym_volatile] = ACTIONS(4995),
    [anon_sym__Atomic] = ACTIONS(4995),
    [anon_sym_mutable] = ACTIONS(4995),
    [anon_sym_explicit] = ACTIONS(4995),
    [anon_sym_constexpr] = ACTIONS(4995),
    [anon_sym_unsigned] = ACTIONS(4995),
    [anon_sym_long] = ACTIONS(4995),
    [anon_sym_short] = ACTIONS(4995),
    [sym_primitive_type] = ACTIONS(4995),
    [anon_sym_enum] = ACTIONS(4995),
    [anon_sym_struct] = ACTIONS(4995),
    [anon_sym_union] = ACTIONS(4995),
    [anon_sym_if] = ACTIONS(4995),
    [anon_sym_switch] = ACTIONS(4995),
    [anon_sym_case] = ACTIONS(4995),
    [anon_sym_default] = ACTIONS(4995),
    [anon_sym_while] = ACTIONS(4995),
    [anon_sym_do] = ACTIONS(4995),
    [anon_sym_for] = ACTIONS(4995),
    [anon_sym_return] = ACTIONS(4995),
    [anon_sym_break] = ACTIONS(4995),
    [anon_sym_continue] = ACTIONS(4995),
    [anon_sym_goto] = ACTIONS(4995),
    [anon_sym_AMP] = ACTIONS(4993),
    [anon_sym_BANG] = ACTIONS(4993),
    [anon_sym_TILDE] = ACTIONS(4993),
    [anon_sym_PLUS] = ACTIONS(4995),
    [anon_sym_DASH] = ACTIONS(4995),
    [anon_sym_DASH_DASH] = ACTIONS(4993),
    [anon_sym_PLUS_PLUS] = ACTIONS(4993),
    [anon_sym_sizeof] = ACTIONS(4995),
    [sym_number_literal] = ACTIONS(4993),
    [anon_sym_SQUOTE] = ACTIONS(4993),
    [anon_sym_DQUOTE] = ACTIONS(4993),
    [sym_true] = ACTIONS(4995),
    [sym_false] = ACTIONS(4995),
    [sym_null] = ACTIONS(4995),
    [sym_identifier] = ACTIONS(4995),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4995),
    [sym_auto] = ACTIONS(4995),
    [anon_sym_typename] = ACTIONS(4995),
    [anon_sym_delete] = ACTIONS(4995),
    [anon_sym_try] = ACTIONS(4995),
    [anon_sym_catch] = ACTIONS(7469),
    [anon_sym_new] = ACTIONS(4995),
    [anon_sym_COLON_COLON] = ACTIONS(4993),
    [sym_nullptr] = ACTIONS(4995),
  },
  [3044] = {
    [sym_raw_string_literal] = ACTIONS(5113),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5115),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5115),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5115),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5115),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5115),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5115),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5115),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5115),
    [sym_preproc_directive] = ACTIONS(5115),
    [anon_sym_SEMI] = ACTIONS(5113),
    [anon_sym_typedef] = ACTIONS(5115),
    [anon_sym_extern] = ACTIONS(5115),
    [anon_sym_LBRACE] = ACTIONS(5113),
    [anon_sym_LPAREN2] = ACTIONS(5113),
    [anon_sym_STAR] = ACTIONS(5113),
    [anon_sym_LBRACK] = ACTIONS(5113),
    [anon_sym_static] = ACTIONS(5115),
    [anon_sym_register] = ACTIONS(5115),
    [anon_sym_inline] = ACTIONS(5115),
    [anon_sym_const] = ACTIONS(5115),
    [anon_sym_restrict] = ACTIONS(5115),
    [anon_sym_volatile] = ACTIONS(5115),
    [anon_sym__Atomic] = ACTIONS(5115),
    [anon_sym_mutable] = ACTIONS(5115),
    [anon_sym_explicit] = ACTIONS(5115),
    [anon_sym_constexpr] = ACTIONS(5115),
    [anon_sym_unsigned] = ACTIONS(5115),
    [anon_sym_long] = ACTIONS(5115),
    [anon_sym_short] = ACTIONS(5115),
    [sym_primitive_type] = ACTIONS(5115),
    [anon_sym_enum] = ACTIONS(5115),
    [anon_sym_struct] = ACTIONS(5115),
    [anon_sym_union] = ACTIONS(5115),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_else] = ACTIONS(5115),
    [anon_sym_switch] = ACTIONS(5115),
    [anon_sym_case] = ACTIONS(5115),
    [anon_sym_default] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_for] = ACTIONS(5115),
    [anon_sym_return] = ACTIONS(5115),
    [anon_sym_break] = ACTIONS(5115),
    [anon_sym_continue] = ACTIONS(5115),
    [anon_sym_goto] = ACTIONS(5115),
    [anon_sym_AMP] = ACTIONS(5113),
    [anon_sym_BANG] = ACTIONS(5113),
    [anon_sym_TILDE] = ACTIONS(5113),
    [anon_sym_PLUS] = ACTIONS(5115),
    [anon_sym_DASH] = ACTIONS(5115),
    [anon_sym_DASH_DASH] = ACTIONS(5113),
    [anon_sym_PLUS_PLUS] = ACTIONS(5113),
    [anon_sym_sizeof] = ACTIONS(5115),
    [sym_number_literal] = ACTIONS(5113),
    [anon_sym_SQUOTE] = ACTIONS(5113),
    [anon_sym_DQUOTE] = ACTIONS(5113),
    [sym_true] = ACTIONS(5115),
    [sym_false] = ACTIONS(5115),
    [sym_null] = ACTIONS(5115),
    [sym_identifier] = ACTIONS(5115),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5115),
    [sym_auto] = ACTIONS(5115),
    [anon_sym_typename] = ACTIONS(5115),
    [anon_sym_delete] = ACTIONS(5115),
    [anon_sym_try] = ACTIONS(5115),
    [anon_sym_new] = ACTIONS(5115),
    [anon_sym_COLON_COLON] = ACTIONS(5113),
    [sym_nullptr] = ACTIONS(5115),
  },
  [3045] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(7472),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3046] = {
    [anon_sym_SEMI] = ACTIONS(7472),
    [sym_comment] = ACTIONS(91),
  },
  [3047] = {
    [sym_raw_string_literal] = ACTIONS(5122),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5124),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5124),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5124),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5124),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5124),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5124),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5124),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5124),
    [sym_preproc_directive] = ACTIONS(5124),
    [anon_sym_SEMI] = ACTIONS(5122),
    [anon_sym_typedef] = ACTIONS(5124),
    [anon_sym_extern] = ACTIONS(5124),
    [anon_sym_LBRACE] = ACTIONS(5122),
    [anon_sym_LPAREN2] = ACTIONS(5122),
    [anon_sym_STAR] = ACTIONS(5122),
    [anon_sym_LBRACK] = ACTIONS(5122),
    [anon_sym_static] = ACTIONS(5124),
    [anon_sym_register] = ACTIONS(5124),
    [anon_sym_inline] = ACTIONS(5124),
    [anon_sym_const] = ACTIONS(5124),
    [anon_sym_restrict] = ACTIONS(5124),
    [anon_sym_volatile] = ACTIONS(5124),
    [anon_sym__Atomic] = ACTIONS(5124),
    [anon_sym_mutable] = ACTIONS(5124),
    [anon_sym_explicit] = ACTIONS(5124),
    [anon_sym_constexpr] = ACTIONS(5124),
    [anon_sym_unsigned] = ACTIONS(5124),
    [anon_sym_long] = ACTIONS(5124),
    [anon_sym_short] = ACTIONS(5124),
    [sym_primitive_type] = ACTIONS(5124),
    [anon_sym_enum] = ACTIONS(5124),
    [anon_sym_struct] = ACTIONS(5124),
    [anon_sym_union] = ACTIONS(5124),
    [anon_sym_if] = ACTIONS(5124),
    [anon_sym_switch] = ACTIONS(5124),
    [anon_sym_case] = ACTIONS(5124),
    [anon_sym_default] = ACTIONS(5124),
    [anon_sym_while] = ACTIONS(5124),
    [anon_sym_do] = ACTIONS(5124),
    [anon_sym_for] = ACTIONS(5124),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_break] = ACTIONS(5124),
    [anon_sym_continue] = ACTIONS(5124),
    [anon_sym_goto] = ACTIONS(5124),
    [anon_sym_AMP] = ACTIONS(5122),
    [anon_sym_BANG] = ACTIONS(5122),
    [anon_sym_TILDE] = ACTIONS(5122),
    [anon_sym_PLUS] = ACTIONS(5124),
    [anon_sym_DASH] = ACTIONS(5124),
    [anon_sym_DASH_DASH] = ACTIONS(5122),
    [anon_sym_PLUS_PLUS] = ACTIONS(5122),
    [anon_sym_sizeof] = ACTIONS(5124),
    [sym_number_literal] = ACTIONS(5122),
    [anon_sym_SQUOTE] = ACTIONS(5122),
    [anon_sym_DQUOTE] = ACTIONS(5122),
    [sym_true] = ACTIONS(5124),
    [sym_false] = ACTIONS(5124),
    [sym_null] = ACTIONS(5124),
    [sym_identifier] = ACTIONS(5124),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5124),
    [sym_auto] = ACTIONS(5124),
    [anon_sym_typename] = ACTIONS(5124),
    [anon_sym_delete] = ACTIONS(5124),
    [anon_sym_try] = ACTIONS(5124),
    [anon_sym_new] = ACTIONS(5124),
    [anon_sym_COLON_COLON] = ACTIONS(5122),
    [sym_nullptr] = ACTIONS(5124),
  },
  [3048] = {
    [sym__expression] = STATE(3320),
    [sym_conditional_expression] = STATE(3320),
    [sym_assignment_expression] = STATE(3320),
    [sym_pointer_expression] = STATE(3320),
    [sym_logical_expression] = STATE(3320),
    [sym_bitwise_expression] = STATE(3320),
    [sym_equality_expression] = STATE(3320),
    [sym_relational_expression] = STATE(3320),
    [sym_shift_expression] = STATE(3320),
    [sym_math_expression] = STATE(3320),
    [sym_cast_expression] = STATE(3320),
    [sym_sizeof_expression] = STATE(3320),
    [sym_subscript_expression] = STATE(3320),
    [sym_call_expression] = STATE(3320),
    [sym_field_expression] = STATE(3320),
    [sym_compound_literal_expression] = STATE(3320),
    [sym_parenthesized_expression] = STATE(3320),
    [sym_char_literal] = STATE(3320),
    [sym_concatenated_string] = STATE(3320),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3320),
    [sym_new_expression] = STATE(3320),
    [sym_delete_expression] = STATE(3320),
    [sym_lambda_expression] = STATE(3320),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7474),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(7474),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7476),
    [sym_false] = ACTIONS(7476),
    [sym_null] = ACTIONS(7476),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(7476),
  },
  [3049] = {
    [anon_sym_LPAREN2] = ACTIONS(7478),
    [sym_comment] = ACTIONS(91),
  },
  [3050] = {
    [sym_compound_statement] = STATE(1152),
    [sym_labeled_statement] = STATE(1152),
    [sym_expression_statement] = STATE(1152),
    [sym_if_statement] = STATE(1152),
    [sym_switch_statement] = STATE(1152),
    [sym_case_statement] = STATE(1152),
    [sym_while_statement] = STATE(1152),
    [sym_do_statement] = STATE(1152),
    [sym_for_statement] = STATE(1152),
    [sym_return_statement] = STATE(1152),
    [sym_break_statement] = STATE(1152),
    [sym_continue_statement] = STATE(1152),
    [sym_goto_statement] = STATE(1152),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(1152),
    [sym_try_statement] = STATE(1152),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(157),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(5814),
    [anon_sym_switch] = ACTIONS(5816),
    [anon_sym_case] = ACTIONS(5818),
    [anon_sym_default] = ACTIONS(5820),
    [anon_sym_while] = ACTIONS(5822),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(5824),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(5826),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(5828),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(207),
  },
  [3051] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_COLON] = ACTIONS(7480),
    [anon_sym_QMARK] = ACTIONS(1171),
    [anon_sym_STAR_EQ] = ACTIONS(1173),
    [anon_sym_SLASH_EQ] = ACTIONS(1173),
    [anon_sym_PERCENT_EQ] = ACTIONS(1173),
    [anon_sym_PLUS_EQ] = ACTIONS(1173),
    [anon_sym_DASH_EQ] = ACTIONS(1173),
    [anon_sym_LT_LT_EQ] = ACTIONS(1173),
    [anon_sym_GT_GT_EQ] = ACTIONS(1173),
    [anon_sym_AMP_EQ] = ACTIONS(1173),
    [anon_sym_CARET_EQ] = ACTIONS(1173),
    [anon_sym_PIPE_EQ] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_CARET] = ACTIONS(1183),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [3052] = {
    [sym_declaration] = STATE(1155),
    [sym_type_definition] = STATE(1155),
    [sym__declaration_specifiers] = STATE(1156),
    [sym_compound_statement] = STATE(1155),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_labeled_statement] = STATE(1155),
    [sym_expression_statement] = STATE(1155),
    [sym_if_statement] = STATE(1155),
    [sym_switch_statement] = STATE(1155),
    [sym_case_statement] = STATE(1155),
    [sym_while_statement] = STATE(1155),
    [sym_do_statement] = STATE(1155),
    [sym_for_statement] = STATE(1155),
    [sym_return_statement] = STATE(1155),
    [sym_break_statement] = STATE(1155),
    [sym_continue_statement] = STATE(1155),
    [sym_goto_statement] = STATE(1155),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(1155),
    [sym_try_statement] = STATE(1155),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(157),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_typedef] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(5814),
    [anon_sym_switch] = ACTIONS(5816),
    [anon_sym_case] = ACTIONS(5818),
    [anon_sym_default] = ACTIONS(5820),
    [anon_sym_while] = ACTIONS(5822),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(5824),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(7482),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(5828),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(1202),
    [sym_nullptr] = ACTIONS(207),
  },
  [3053] = {
    [sym_compound_statement] = STATE(1157),
    [sym_labeled_statement] = STATE(1157),
    [sym_expression_statement] = STATE(1157),
    [sym_if_statement] = STATE(1157),
    [sym_switch_statement] = STATE(1157),
    [sym_case_statement] = STATE(1157),
    [sym_while_statement] = STATE(1157),
    [sym_do_statement] = STATE(1157),
    [sym_for_statement] = STATE(1157),
    [sym_return_statement] = STATE(1157),
    [sym_break_statement] = STATE(1157),
    [sym_continue_statement] = STATE(1157),
    [sym_goto_statement] = STATE(1157),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(1157),
    [sym_try_statement] = STATE(1157),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(157),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(5814),
    [anon_sym_switch] = ACTIONS(5816),
    [anon_sym_case] = ACTIONS(5818),
    [anon_sym_default] = ACTIONS(5820),
    [anon_sym_while] = ACTIONS(5822),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(5824),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(5826),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(5828),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(207),
  },
  [3054] = {
    [sym_declaration] = STATE(3324),
    [sym__declaration_specifiers] = STATE(709),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym__expression] = STATE(3325),
    [sym_conditional_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3325),
    [sym_pointer_expression] = STATE(3325),
    [sym_logical_expression] = STATE(3325),
    [sym_bitwise_expression] = STATE(3325),
    [sym_equality_expression] = STATE(3325),
    [sym_relational_expression] = STATE(3325),
    [sym_shift_expression] = STATE(3325),
    [sym_math_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_subscript_expression] = STATE(3325),
    [sym_call_expression] = STATE(3325),
    [sym_field_expression] = STATE(3325),
    [sym_compound_literal_expression] = STATE(3325),
    [sym_parenthesized_expression] = STATE(3325),
    [sym_char_literal] = STATE(3325),
    [sym_concatenated_string] = STATE(3325),
    [sym_string_literal] = STATE(238),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(3325),
    [sym_for_range_declaration] = STATE(3326),
    [sym_new_expression] = STATE(3325),
    [sym_delete_expression] = STATE(3325),
    [sym_lambda_expression] = STATE(3325),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(7484),
    [anon_sym_SEMI] = ACTIONS(7486),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(7484),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7488),
    [sym_false] = ACTIONS(7488),
    [sym_null] = ACTIONS(7488),
    [sym_identifier] = ACTIONS(1242),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(1244),
    [sym_nullptr] = ACTIONS(7488),
  },
  [3055] = {
    [sym_compound_statement] = STATE(1164),
    [sym_labeled_statement] = STATE(1164),
    [sym_expression_statement] = STATE(1164),
    [sym_if_statement] = STATE(1164),
    [sym_switch_statement] = STATE(1164),
    [sym_case_statement] = STATE(1164),
    [sym_while_statement] = STATE(1164),
    [sym_do_statement] = STATE(1164),
    [sym_for_statement] = STATE(1164),
    [sym_return_statement] = STATE(1164),
    [sym_break_statement] = STATE(1164),
    [sym_continue_statement] = STATE(1164),
    [sym_goto_statement] = STATE(1164),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(1164),
    [sym_try_statement] = STATE(1164),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(157),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(5814),
    [anon_sym_switch] = ACTIONS(5816),
    [anon_sym_case] = ACTIONS(5818),
    [anon_sym_default] = ACTIONS(5820),
    [anon_sym_while] = ACTIONS(5822),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(5824),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(5826),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(5828),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(207),
  },
  [3056] = {
    [sym_catch_clause] = STATE(3327),
    [aux_sym_try_statement_repeat1] = STATE(3327),
    [sym_comment] = ACTIONS(91),
    [anon_sym_catch] = ACTIONS(2280),
  },
  [3057] = {
    [sym_compound_statement] = STATE(3328),
    [sym_labeled_statement] = STATE(3328),
    [sym_expression_statement] = STATE(3328),
    [sym_if_statement] = STATE(3328),
    [sym_switch_statement] = STATE(3328),
    [sym_case_statement] = STATE(3328),
    [sym_while_statement] = STATE(3328),
    [sym_do_statement] = STATE(3328),
    [sym_for_statement] = STATE(3328),
    [sym_return_statement] = STATE(3328),
    [sym_break_statement] = STATE(3328),
    [sym_continue_statement] = STATE(3328),
    [sym_goto_statement] = STATE(3328),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(3328),
    [sym_try_statement] = STATE(3328),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(157),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(185),
    [anon_sym_case] = ACTIONS(187),
    [anon_sym_default] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(2262),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(207),
  },
  [3058] = {
    [sym_raw_string_literal] = ACTIONS(7063),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7065),
    [sym_preproc_directive] = ACTIONS(7065),
    [anon_sym_SEMI] = ACTIONS(7063),
    [anon_sym_typedef] = ACTIONS(7065),
    [anon_sym_extern] = ACTIONS(7065),
    [anon_sym_LBRACE] = ACTIONS(7063),
    [anon_sym_RBRACE] = ACTIONS(7063),
    [anon_sym_LPAREN2] = ACTIONS(7063),
    [anon_sym_STAR] = ACTIONS(7063),
    [anon_sym_LBRACK] = ACTIONS(7063),
    [anon_sym_static] = ACTIONS(7065),
    [anon_sym_register] = ACTIONS(7065),
    [anon_sym_inline] = ACTIONS(7065),
    [anon_sym_const] = ACTIONS(7065),
    [anon_sym_restrict] = ACTIONS(7065),
    [anon_sym_volatile] = ACTIONS(7065),
    [anon_sym__Atomic] = ACTIONS(7065),
    [anon_sym_mutable] = ACTIONS(7065),
    [anon_sym_explicit] = ACTIONS(7065),
    [anon_sym_constexpr] = ACTIONS(7065),
    [anon_sym_unsigned] = ACTIONS(7065),
    [anon_sym_long] = ACTIONS(7065),
    [anon_sym_short] = ACTIONS(7065),
    [sym_primitive_type] = ACTIONS(7065),
    [anon_sym_enum] = ACTIONS(7065),
    [anon_sym_struct] = ACTIONS(7065),
    [anon_sym_union] = ACTIONS(7065),
    [anon_sym_if] = ACTIONS(7065),
    [anon_sym_else] = ACTIONS(7490),
    [anon_sym_switch] = ACTIONS(7065),
    [anon_sym_case] = ACTIONS(7065),
    [anon_sym_default] = ACTIONS(7065),
    [anon_sym_while] = ACTIONS(7065),
    [anon_sym_do] = ACTIONS(7065),
    [anon_sym_for] = ACTIONS(7065),
    [anon_sym_return] = ACTIONS(7065),
    [anon_sym_break] = ACTIONS(7065),
    [anon_sym_continue] = ACTIONS(7065),
    [anon_sym_goto] = ACTIONS(7065),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_BANG] = ACTIONS(7063),
    [anon_sym_TILDE] = ACTIONS(7063),
    [anon_sym_PLUS] = ACTIONS(7065),
    [anon_sym_DASH] = ACTIONS(7065),
    [anon_sym_DASH_DASH] = ACTIONS(7063),
    [anon_sym_PLUS_PLUS] = ACTIONS(7063),
    [anon_sym_sizeof] = ACTIONS(7065),
    [sym_number_literal] = ACTIONS(7063),
    [anon_sym_SQUOTE] = ACTIONS(7063),
    [anon_sym_DQUOTE] = ACTIONS(7063),
    [sym_true] = ACTIONS(7065),
    [sym_false] = ACTIONS(7065),
    [sym_null] = ACTIONS(7065),
    [sym_identifier] = ACTIONS(7065),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7065),
    [sym_auto] = ACTIONS(7065),
    [anon_sym_typename] = ACTIONS(7065),
    [anon_sym_delete] = ACTIONS(7065),
    [anon_sym_try] = ACTIONS(7065),
    [anon_sym_new] = ACTIONS(7065),
    [anon_sym_COLON_COLON] = ACTIONS(7063),
    [sym_nullptr] = ACTIONS(7065),
  },
  [3059] = {
    [sym_raw_string_literal] = ACTIONS(7095),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7097),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7097),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7097),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7097),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7097),
    [sym_preproc_directive] = ACTIONS(7097),
    [anon_sym_SEMI] = ACTIONS(7095),
    [anon_sym_typedef] = ACTIONS(7097),
    [anon_sym_extern] = ACTIONS(7097),
    [anon_sym_LBRACE] = ACTIONS(7095),
    [anon_sym_RBRACE] = ACTIONS(7095),
    [anon_sym_LPAREN2] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7095),
    [anon_sym_LBRACK] = ACTIONS(7095),
    [anon_sym_static] = ACTIONS(7097),
    [anon_sym_register] = ACTIONS(7097),
    [anon_sym_inline] = ACTIONS(7097),
    [anon_sym_const] = ACTIONS(7097),
    [anon_sym_restrict] = ACTIONS(7097),
    [anon_sym_volatile] = ACTIONS(7097),
    [anon_sym__Atomic] = ACTIONS(7097),
    [anon_sym_mutable] = ACTIONS(7097),
    [anon_sym_explicit] = ACTIONS(7097),
    [anon_sym_constexpr] = ACTIONS(7097),
    [anon_sym_unsigned] = ACTIONS(7097),
    [anon_sym_long] = ACTIONS(7097),
    [anon_sym_short] = ACTIONS(7097),
    [sym_primitive_type] = ACTIONS(7097),
    [anon_sym_enum] = ACTIONS(7097),
    [anon_sym_struct] = ACTIONS(7097),
    [anon_sym_union] = ACTIONS(7097),
    [anon_sym_if] = ACTIONS(7097),
    [anon_sym_else] = ACTIONS(7097),
    [anon_sym_switch] = ACTIONS(7097),
    [anon_sym_case] = ACTIONS(7097),
    [anon_sym_default] = ACTIONS(7097),
    [anon_sym_while] = ACTIONS(7097),
    [anon_sym_do] = ACTIONS(7097),
    [anon_sym_for] = ACTIONS(7097),
    [anon_sym_return] = ACTIONS(7097),
    [anon_sym_break] = ACTIONS(7097),
    [anon_sym_continue] = ACTIONS(7097),
    [anon_sym_goto] = ACTIONS(7097),
    [anon_sym_AMP] = ACTIONS(7095),
    [anon_sym_BANG] = ACTIONS(7095),
    [anon_sym_TILDE] = ACTIONS(7095),
    [anon_sym_PLUS] = ACTIONS(7097),
    [anon_sym_DASH] = ACTIONS(7097),
    [anon_sym_DASH_DASH] = ACTIONS(7095),
    [anon_sym_PLUS_PLUS] = ACTIONS(7095),
    [anon_sym_sizeof] = ACTIONS(7097),
    [sym_number_literal] = ACTIONS(7095),
    [anon_sym_SQUOTE] = ACTIONS(7095),
    [anon_sym_DQUOTE] = ACTIONS(7095),
    [sym_true] = ACTIONS(7097),
    [sym_false] = ACTIONS(7097),
    [sym_null] = ACTIONS(7097),
    [sym_identifier] = ACTIONS(7097),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7097),
    [sym_auto] = ACTIONS(7097),
    [anon_sym_typename] = ACTIONS(7097),
    [anon_sym_delete] = ACTIONS(7097),
    [anon_sym_try] = ACTIONS(7097),
    [anon_sym_new] = ACTIONS(7097),
    [anon_sym_COLON_COLON] = ACTIONS(7095),
    [sym_nullptr] = ACTIONS(7097),
  },
  [3060] = {
    [sym_compound_statement] = STATE(3330),
    [sym_labeled_statement] = STATE(3330),
    [sym_expression_statement] = STATE(3330),
    [sym_if_statement] = STATE(3330),
    [sym_switch_statement] = STATE(3330),
    [sym_case_statement] = STATE(3330),
    [sym_while_statement] = STATE(3330),
    [sym_do_statement] = STATE(3330),
    [sym_for_statement] = STATE(3330),
    [sym_return_statement] = STATE(3330),
    [sym_break_statement] = STATE(3330),
    [sym_continue_statement] = STATE(3330),
    [sym_goto_statement] = STATE(3330),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(3330),
    [sym_try_statement] = STATE(3330),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(157),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(185),
    [anon_sym_case] = ACTIONS(187),
    [anon_sym_default] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(2262),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(207),
  },
  [3061] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(7492),
    [sym_comment] = ACTIONS(91),
  },
  [3062] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3332),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(7492),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3063] = {
    [sym__expression] = STATE(3333),
    [sym_conditional_expression] = STATE(3333),
    [sym_assignment_expression] = STATE(3333),
    [sym_pointer_expression] = STATE(3333),
    [sym_logical_expression] = STATE(3333),
    [sym_bitwise_expression] = STATE(3333),
    [sym_equality_expression] = STATE(3333),
    [sym_relational_expression] = STATE(3333),
    [sym_shift_expression] = STATE(3333),
    [sym_math_expression] = STATE(3333),
    [sym_cast_expression] = STATE(3333),
    [sym_sizeof_expression] = STATE(3333),
    [sym_subscript_expression] = STATE(3333),
    [sym_call_expression] = STATE(3333),
    [sym_field_expression] = STATE(3333),
    [sym_compound_literal_expression] = STATE(3333),
    [sym_parenthesized_expression] = STATE(3333),
    [sym_char_literal] = STATE(3333),
    [sym_concatenated_string] = STATE(3333),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3333),
    [sym_new_expression] = STATE(3333),
    [sym_delete_expression] = STATE(3333),
    [sym_lambda_expression] = STATE(3333),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7494),
    [anon_sym_RPAREN] = ACTIONS(7492),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(7494),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7496),
    [sym_false] = ACTIONS(7496),
    [sym_null] = ACTIONS(7496),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(7496),
  },
  [3064] = {
    [sym_compound_statement] = STATE(3334),
    [sym_labeled_statement] = STATE(3334),
    [sym_expression_statement] = STATE(3334),
    [sym_if_statement] = STATE(3334),
    [sym_switch_statement] = STATE(3334),
    [sym_case_statement] = STATE(3334),
    [sym_while_statement] = STATE(3334),
    [sym_do_statement] = STATE(3334),
    [sym_for_statement] = STATE(3334),
    [sym_return_statement] = STATE(3334),
    [sym_break_statement] = STATE(3334),
    [sym_continue_statement] = STATE(3334),
    [sym_goto_statement] = STATE(3334),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(3334),
    [sym_try_statement] = STATE(3334),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(157),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(185),
    [anon_sym_case] = ACTIONS(187),
    [anon_sym_default] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(2262),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(207),
  },
  [3065] = {
    [sym_parameter_list] = STATE(3068),
    [anon_sym_RPAREN] = ACTIONS(4157),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_const] = ACTIONS(7279),
    [anon_sym_restrict] = ACTIONS(4157),
    [anon_sym_volatile] = ACTIONS(4157),
    [anon_sym__Atomic] = ACTIONS(4157),
    [anon_sym_mutable] = ACTIONS(4157),
    [anon_sym_explicit] = ACTIONS(4157),
    [anon_sym_constexpr] = ACTIONS(4157),
    [anon_sym_DASH_GT] = ACTIONS(4157),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4157),
    [anon_sym_override] = ACTIONS(4157),
    [sym_noexcept] = ACTIONS(4157),
  },
  [3066] = {
    [sym__abstract_declarator] = STATE(3335),
    [sym_abstract_pointer_declarator] = STATE(3335),
    [sym_abstract_function_declarator] = STATE(3335),
    [sym_abstract_array_declarator] = STATE(3335),
    [sym_type_qualifier] = STATE(3336),
    [sym_parameter_list] = STATE(2649),
    [sym_abstract_reference_declarator] = STATE(3335),
    [aux_sym_type_definition_repeat1] = STATE(3336),
    [anon_sym_RPAREN] = ACTIONS(4157),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(5869),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(5871),
    [anon_sym_AMP_AMP] = ACTIONS(5873),
    [anon_sym_DASH_GT] = ACTIONS(4157),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4157),
    [anon_sym_override] = ACTIONS(4157),
    [sym_noexcept] = ACTIONS(4157),
  },
  [3067] = {
    [sym_parameter_list] = STATE(3068),
    [anon_sym_RPAREN] = ACTIONS(4159),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_const] = ACTIONS(7281),
    [anon_sym_restrict] = ACTIONS(4159),
    [anon_sym_volatile] = ACTIONS(4159),
    [anon_sym__Atomic] = ACTIONS(4159),
    [anon_sym_mutable] = ACTIONS(4159),
    [anon_sym_explicit] = ACTIONS(4159),
    [anon_sym_constexpr] = ACTIONS(4159),
    [anon_sym_DASH_GT] = ACTIONS(4159),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4159),
    [anon_sym_override] = ACTIONS(4159),
    [sym_noexcept] = ACTIONS(4159),
  },
  [3068] = {
    [sym_type_qualifier] = STATE(3337),
    [sym_trailing_return_type] = STATE(1720),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3337),
    [anon_sym_RPAREN] = ACTIONS(3663),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_const] = ACTIONS(3685),
    [anon_sym_restrict] = ACTIONS(3663),
    [anon_sym_volatile] = ACTIONS(3663),
    [anon_sym__Atomic] = ACTIONS(3663),
    [anon_sym_mutable] = ACTIONS(3663),
    [anon_sym_explicit] = ACTIONS(3663),
    [anon_sym_constexpr] = ACTIONS(3663),
    [anon_sym_DASH_GT] = ACTIONS(3663),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3663),
    [anon_sym_override] = ACTIONS(3663),
    [sym_noexcept] = ACTIONS(3663),
  },
  [3069] = {
    [sym_type_qualifier] = STATE(3338),
    [sym_trailing_return_type] = STATE(1720),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3338),
    [anon_sym_RPAREN] = ACTIONS(3663),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(2457),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3663),
    [anon_sym_override] = ACTIONS(3663),
    [sym_noexcept] = ACTIONS(7498),
  },
  [3070] = {
    [sym_parameter_list] = STATE(3073),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_const] = ACTIONS(7279),
    [anon_sym_restrict] = ACTIONS(4157),
    [anon_sym_volatile] = ACTIONS(4157),
    [anon_sym__Atomic] = ACTIONS(4157),
    [anon_sym_mutable] = ACTIONS(4157),
    [anon_sym_explicit] = ACTIONS(4157),
    [anon_sym_constexpr] = ACTIONS(4157),
    [anon_sym_DASH_GT] = ACTIONS(4157),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4157),
    [anon_sym_override] = ACTIONS(4157),
    [sym_noexcept] = ACTIONS(4157),
  },
  [3071] = {
    [sym__abstract_declarator] = STATE(3339),
    [sym_abstract_pointer_declarator] = STATE(3339),
    [sym_abstract_function_declarator] = STATE(3339),
    [sym_abstract_array_declarator] = STATE(3339),
    [sym_type_qualifier] = STATE(3340),
    [sym_parameter_list] = STATE(2656),
    [sym_abstract_reference_declarator] = STATE(3339),
    [aux_sym_type_definition_repeat1] = STATE(3340),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(5898),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(5900),
    [anon_sym_AMP_AMP] = ACTIONS(5902),
    [anon_sym_DASH_GT] = ACTIONS(4157),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4157),
    [anon_sym_override] = ACTIONS(4157),
    [sym_noexcept] = ACTIONS(4157),
  },
  [3072] = {
    [sym_parameter_list] = STATE(3073),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_const] = ACTIONS(7281),
    [anon_sym_restrict] = ACTIONS(4159),
    [anon_sym_volatile] = ACTIONS(4159),
    [anon_sym__Atomic] = ACTIONS(4159),
    [anon_sym_mutable] = ACTIONS(4159),
    [anon_sym_explicit] = ACTIONS(4159),
    [anon_sym_constexpr] = ACTIONS(4159),
    [anon_sym_DASH_GT] = ACTIONS(4159),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4159),
    [anon_sym_override] = ACTIONS(4159),
    [sym_noexcept] = ACTIONS(4159),
  },
  [3073] = {
    [sym_type_qualifier] = STATE(3341),
    [sym_trailing_return_type] = STATE(1720),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3341),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_const] = ACTIONS(3685),
    [anon_sym_restrict] = ACTIONS(3663),
    [anon_sym_volatile] = ACTIONS(3663),
    [anon_sym__Atomic] = ACTIONS(3663),
    [anon_sym_mutable] = ACTIONS(3663),
    [anon_sym_explicit] = ACTIONS(3663),
    [anon_sym_constexpr] = ACTIONS(3663),
    [anon_sym_DASH_GT] = ACTIONS(3663),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3663),
    [anon_sym_override] = ACTIONS(3663),
    [sym_noexcept] = ACTIONS(3663),
  },
  [3074] = {
    [sym_type_qualifier] = STATE(3342),
    [sym_trailing_return_type] = STATE(1720),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3342),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(2532),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3663),
    [anon_sym_override] = ACTIONS(3663),
    [sym_noexcept] = ACTIONS(7500),
  },
  [3075] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(3075),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(3075),
    [sym_type_definition] = STATE(3075),
    [sym__declaration_specifiers] = STATE(598),
    [sym__declarator] = STATE(599),
    [sym_pointer_declarator] = STATE(599),
    [sym_function_declarator] = STATE(600),
    [sym_array_declarator] = STATE(599),
    [sym_storage_class_specifier] = STATE(605),
    [sym_type_qualifier] = STATE(605),
    [sym__type_specifier] = STATE(601),
    [sym_sized_type_specifier] = STATE(601),
    [sym_enum_specifier] = STATE(601),
    [sym_struct_specifier] = STATE(601),
    [sym_union_specifier] = STATE(601),
    [sym__field_declaration_list_item] = STATE(3075),
    [sym_field_declaration] = STATE(3075),
    [sym_macro_type_specifier] = STATE(601),
    [sym_class_specifier] = STATE(601),
    [sym_dependent_type] = STATE(601),
    [sym_template_declaration] = STATE(3075),
    [sym_inline_method_definition] = STATE(3075),
    [sym_constructor_or_destructor_definition] = STATE(3075),
    [sym_constructor_or_destructor_declaration] = STATE(3075),
    [sym_friend_declaration] = STATE(3075),
    [sym_access_specifier] = STATE(3075),
    [sym_reference_declarator] = STATE(599),
    [sym_template_type] = STATE(602),
    [sym_template_function] = STATE(599),
    [sym_using_declaration] = STATE(3075),
    [sym_alias_declaration] = STATE(3075),
    [sym_destructor_name] = STATE(599),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(603),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(3075),
    [aux_sym__declaration_specifiers_repeat1] = STATE(605),
    [aux_sym_sized_type_specifier_repeat1] = STATE(606),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4311),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4323),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4314),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4314),
    [anon_sym_typedef] = ACTIONS(4317),
    [anon_sym_extern] = ACTIONS(4320),
    [anon_sym_LPAREN2] = ACTIONS(4325),
    [anon_sym_STAR] = ACTIONS(4328),
    [anon_sym_static] = ACTIONS(4320),
    [anon_sym_register] = ACTIONS(4320),
    [anon_sym_inline] = ACTIONS(4320),
    [anon_sym_const] = ACTIONS(4331),
    [anon_sym_restrict] = ACTIONS(4331),
    [anon_sym_volatile] = ACTIONS(4331),
    [anon_sym__Atomic] = ACTIONS(4331),
    [anon_sym_mutable] = ACTIONS(4331),
    [anon_sym_explicit] = ACTIONS(4331),
    [anon_sym_constexpr] = ACTIONS(4331),
    [anon_sym_unsigned] = ACTIONS(4334),
    [anon_sym_long] = ACTIONS(4334),
    [anon_sym_short] = ACTIONS(4334),
    [sym_primitive_type] = ACTIONS(4337),
    [anon_sym_enum] = ACTIONS(4340),
    [anon_sym_struct] = ACTIONS(4343),
    [anon_sym_union] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4349),
    [anon_sym_AMP_AMP] = ACTIONS(4352),
    [anon_sym_TILDE] = ACTIONS(4355),
    [sym_identifier] = ACTIONS(4358),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4361),
    [anon_sym_public] = ACTIONS(4364),
    [sym_auto] = ACTIONS(4337),
    [anon_sym_typename] = ACTIONS(4367),
    [anon_sym_template] = ACTIONS(4370),
    [anon_sym_friend] = ACTIONS(4373),
    [anon_sym_private] = ACTIONS(4364),
    [anon_sym_protected] = ACTIONS(4364),
    [anon_sym_using] = ACTIONS(4376),
    [anon_sym_COLON_COLON] = ACTIONS(4379),
    [sym_operator_name] = ACTIONS(4382),
  },
  [3076] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7502),
    [sym_comment] = ACTIONS(91),
  },
  [3077] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(2667),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(2667),
    [sym_preproc_else_in_field_declaration_list] = STATE(3343),
    [sym_preproc_elif_in_field_declaration_list] = STATE(3343),
    [sym_type_definition] = STATE(2667),
    [sym__declaration_specifiers] = STATE(598),
    [sym__declarator] = STATE(599),
    [sym_pointer_declarator] = STATE(599),
    [sym_function_declarator] = STATE(600),
    [sym_array_declarator] = STATE(599),
    [sym_storage_class_specifier] = STATE(605),
    [sym_type_qualifier] = STATE(605),
    [sym__type_specifier] = STATE(601),
    [sym_sized_type_specifier] = STATE(601),
    [sym_enum_specifier] = STATE(601),
    [sym_struct_specifier] = STATE(601),
    [sym_union_specifier] = STATE(601),
    [sym__field_declaration_list_item] = STATE(2667),
    [sym_field_declaration] = STATE(2667),
    [sym_macro_type_specifier] = STATE(601),
    [sym_class_specifier] = STATE(601),
    [sym_dependent_type] = STATE(601),
    [sym_template_declaration] = STATE(2667),
    [sym_inline_method_definition] = STATE(2667),
    [sym_constructor_or_destructor_definition] = STATE(2667),
    [sym_constructor_or_destructor_declaration] = STATE(2667),
    [sym_friend_declaration] = STATE(2667),
    [sym_access_specifier] = STATE(2667),
    [sym_reference_declarator] = STATE(599),
    [sym_template_type] = STATE(602),
    [sym_template_function] = STATE(599),
    [sym_using_declaration] = STATE(2667),
    [sym_alias_declaration] = STATE(2667),
    [sym_destructor_name] = STATE(599),
    [sym_scoped_identifier] = STATE(248),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(603),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(2667),
    [aux_sym__declaration_specifiers_repeat1] = STATE(605),
    [aux_sym_sized_type_specifier_repeat1] = STATE(606),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1019),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7502),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1021),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4227),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4229),
    [anon_sym_typedef] = ACTIONS(1023),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_LPAREN2] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(425),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_register] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_unsigned] = ACTIONS(1027),
    [anon_sym_long] = ACTIONS(1027),
    [anon_sym_short] = ACTIONS(1027),
    [sym_primitive_type] = ACTIONS(1029),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(1031),
    [anon_sym_union] = ACTIONS(1033),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(429),
    [sym_identifier] = ACTIONS(1035),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1039),
    [sym_auto] = ACTIONS(1029),
    [anon_sym_typename] = ACTIONS(1041),
    [anon_sym_template] = ACTIONS(1043),
    [anon_sym_friend] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1039),
    [anon_sym_protected] = ACTIONS(1039),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_COLON_COLON] = ACTIONS(1049),
    [sym_operator_name] = ACTIONS(1051),
  },
  [3078] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7504),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7506),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7506),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7506),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7506),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7506),
    [anon_sym_typedef] = ACTIONS(7504),
    [anon_sym_extern] = ACTIONS(7504),
    [anon_sym_RBRACE] = ACTIONS(7506),
    [anon_sym_LPAREN2] = ACTIONS(7506),
    [anon_sym_STAR] = ACTIONS(7506),
    [anon_sym_static] = ACTIONS(7504),
    [anon_sym_register] = ACTIONS(7504),
    [anon_sym_inline] = ACTIONS(7504),
    [anon_sym_const] = ACTIONS(7504),
    [anon_sym_restrict] = ACTIONS(7504),
    [anon_sym_volatile] = ACTIONS(7504),
    [anon_sym__Atomic] = ACTIONS(7504),
    [anon_sym_mutable] = ACTIONS(7504),
    [anon_sym_explicit] = ACTIONS(7504),
    [anon_sym_constexpr] = ACTIONS(7504),
    [anon_sym_unsigned] = ACTIONS(7504),
    [anon_sym_long] = ACTIONS(7504),
    [anon_sym_short] = ACTIONS(7504),
    [sym_primitive_type] = ACTIONS(7504),
    [anon_sym_enum] = ACTIONS(7504),
    [anon_sym_struct] = ACTIONS(7504),
    [anon_sym_union] = ACTIONS(7504),
    [anon_sym_AMP] = ACTIONS(7504),
    [anon_sym_AMP_AMP] = ACTIONS(7506),
    [anon_sym_TILDE] = ACTIONS(7506),
    [sym_identifier] = ACTIONS(7504),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7504),
    [anon_sym_public] = ACTIONS(7504),
    [sym_auto] = ACTIONS(7504),
    [anon_sym_typename] = ACTIONS(7504),
    [anon_sym_template] = ACTIONS(7504),
    [anon_sym_friend] = ACTIONS(7504),
    [anon_sym_private] = ACTIONS(7504),
    [anon_sym_protected] = ACTIONS(7504),
    [anon_sym_using] = ACTIONS(7504),
    [anon_sym_COLON_COLON] = ACTIONS(7506),
    [sym_operator_name] = ACTIONS(7506),
  },
  [3079] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7508),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7510),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7510),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7510),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7510),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7510),
    [anon_sym_typedef] = ACTIONS(7508),
    [anon_sym_extern] = ACTIONS(7508),
    [anon_sym_RBRACE] = ACTIONS(7510),
    [anon_sym_LPAREN2] = ACTIONS(7510),
    [anon_sym_STAR] = ACTIONS(7510),
    [anon_sym_static] = ACTIONS(7508),
    [anon_sym_register] = ACTIONS(7508),
    [anon_sym_inline] = ACTIONS(7508),
    [anon_sym_const] = ACTIONS(7508),
    [anon_sym_restrict] = ACTIONS(7508),
    [anon_sym_volatile] = ACTIONS(7508),
    [anon_sym__Atomic] = ACTIONS(7508),
    [anon_sym_mutable] = ACTIONS(7508),
    [anon_sym_explicit] = ACTIONS(7508),
    [anon_sym_constexpr] = ACTIONS(7508),
    [anon_sym_unsigned] = ACTIONS(7508),
    [anon_sym_long] = ACTIONS(7508),
    [anon_sym_short] = ACTIONS(7508),
    [sym_primitive_type] = ACTIONS(7508),
    [anon_sym_enum] = ACTIONS(7508),
    [anon_sym_struct] = ACTIONS(7508),
    [anon_sym_union] = ACTIONS(7508),
    [anon_sym_AMP] = ACTIONS(7508),
    [anon_sym_AMP_AMP] = ACTIONS(7510),
    [anon_sym_TILDE] = ACTIONS(7510),
    [sym_identifier] = ACTIONS(7508),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7508),
    [anon_sym_public] = ACTIONS(7508),
    [sym_auto] = ACTIONS(7508),
    [anon_sym_typename] = ACTIONS(7508),
    [anon_sym_template] = ACTIONS(7508),
    [anon_sym_friend] = ACTIONS(7508),
    [anon_sym_private] = ACTIONS(7508),
    [anon_sym_protected] = ACTIONS(7508),
    [anon_sym_using] = ACTIONS(7508),
    [anon_sym_COLON_COLON] = ACTIONS(7510),
    [sym_operator_name] = ACTIONS(7510),
  },
  [3080] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5623),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5621),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5621),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5621),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5621),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5621),
    [anon_sym_typedef] = ACTIONS(5623),
    [anon_sym_extern] = ACTIONS(5623),
    [anon_sym_RBRACE] = ACTIONS(5621),
    [anon_sym_LPAREN2] = ACTIONS(5621),
    [anon_sym_STAR] = ACTIONS(5621),
    [anon_sym_static] = ACTIONS(5623),
    [anon_sym_register] = ACTIONS(5623),
    [anon_sym_inline] = ACTIONS(5623),
    [anon_sym_const] = ACTIONS(5623),
    [anon_sym_restrict] = ACTIONS(5623),
    [anon_sym_volatile] = ACTIONS(5623),
    [anon_sym__Atomic] = ACTIONS(5623),
    [anon_sym_mutable] = ACTIONS(5623),
    [anon_sym_explicit] = ACTIONS(5623),
    [anon_sym_constexpr] = ACTIONS(5623),
    [anon_sym_unsigned] = ACTIONS(5623),
    [anon_sym_long] = ACTIONS(5623),
    [anon_sym_short] = ACTIONS(5623),
    [sym_primitive_type] = ACTIONS(5623),
    [anon_sym_enum] = ACTIONS(5623),
    [anon_sym_struct] = ACTIONS(5623),
    [anon_sym_union] = ACTIONS(5623),
    [anon_sym_else] = ACTIONS(5623),
    [anon_sym_while] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5623),
    [anon_sym_AMP_AMP] = ACTIONS(5621),
    [anon_sym_TILDE] = ACTIONS(5621),
    [sym_identifier] = ACTIONS(5623),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5623),
    [anon_sym_public] = ACTIONS(5623),
    [sym_auto] = ACTIONS(5623),
    [anon_sym_typename] = ACTIONS(5623),
    [anon_sym_template] = ACTIONS(5623),
    [anon_sym_friend] = ACTIONS(5623),
    [anon_sym_private] = ACTIONS(5623),
    [anon_sym_protected] = ACTIONS(5623),
    [anon_sym_using] = ACTIONS(5623),
    [anon_sym_COLON_COLON] = ACTIONS(5621),
    [sym_operator_name] = ACTIONS(5621),
  },
  [3081] = {
    [anon_sym_COMMA] = ACTIONS(2919),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(801),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(801),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(801),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(801),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(801),
    [anon_sym_SEMI] = ACTIONS(2919),
    [anon_sym_typedef] = ACTIONS(803),
    [anon_sym_extern] = ACTIONS(803),
    [anon_sym_RBRACE] = ACTIONS(801),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(801),
    [anon_sym_static] = ACTIONS(803),
    [anon_sym_register] = ACTIONS(803),
    [anon_sym_inline] = ACTIONS(803),
    [anon_sym_const] = ACTIONS(803),
    [anon_sym_restrict] = ACTIONS(803),
    [anon_sym_volatile] = ACTIONS(803),
    [anon_sym__Atomic] = ACTIONS(803),
    [anon_sym_mutable] = ACTIONS(803),
    [anon_sym_explicit] = ACTIONS(803),
    [anon_sym_constexpr] = ACTIONS(803),
    [anon_sym_unsigned] = ACTIONS(803),
    [anon_sym_long] = ACTIONS(803),
    [anon_sym_short] = ACTIONS(803),
    [sym_primitive_type] = ACTIONS(803),
    [anon_sym_enum] = ACTIONS(803),
    [anon_sym_struct] = ACTIONS(803),
    [anon_sym_union] = ACTIONS(803),
    [anon_sym_AMP] = ACTIONS(803),
    [anon_sym_AMP_AMP] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(801),
    [sym_identifier] = ACTIONS(803),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(803),
    [sym_auto] = ACTIONS(803),
    [anon_sym_typename] = ACTIONS(803),
    [anon_sym_template] = ACTIONS(803),
    [anon_sym_friend] = ACTIONS(803),
    [anon_sym_private] = ACTIONS(803),
    [anon_sym_protected] = ACTIONS(803),
    [anon_sym_using] = ACTIONS(803),
    [anon_sym_COLON_COLON] = ACTIONS(801),
    [sym_operator_name] = ACTIONS(801),
  },
  [3082] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5115),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5113),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5113),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5113),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5113),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5113),
    [anon_sym_typedef] = ACTIONS(5115),
    [anon_sym_extern] = ACTIONS(5115),
    [anon_sym_RBRACE] = ACTIONS(5113),
    [anon_sym_LPAREN2] = ACTIONS(5113),
    [anon_sym_STAR] = ACTIONS(5113),
    [anon_sym_static] = ACTIONS(5115),
    [anon_sym_register] = ACTIONS(5115),
    [anon_sym_inline] = ACTIONS(5115),
    [anon_sym_const] = ACTIONS(5115),
    [anon_sym_restrict] = ACTIONS(5115),
    [anon_sym_volatile] = ACTIONS(5115),
    [anon_sym__Atomic] = ACTIONS(5115),
    [anon_sym_mutable] = ACTIONS(5115),
    [anon_sym_explicit] = ACTIONS(5115),
    [anon_sym_constexpr] = ACTIONS(5115),
    [anon_sym_unsigned] = ACTIONS(5115),
    [anon_sym_long] = ACTIONS(5115),
    [anon_sym_short] = ACTIONS(5115),
    [sym_primitive_type] = ACTIONS(5115),
    [anon_sym_enum] = ACTIONS(5115),
    [anon_sym_struct] = ACTIONS(5115),
    [anon_sym_union] = ACTIONS(5115),
    [anon_sym_else] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_AMP] = ACTIONS(5115),
    [anon_sym_AMP_AMP] = ACTIONS(5113),
    [anon_sym_TILDE] = ACTIONS(5113),
    [sym_identifier] = ACTIONS(5115),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5115),
    [anon_sym_public] = ACTIONS(5115),
    [sym_auto] = ACTIONS(5115),
    [anon_sym_typename] = ACTIONS(5115),
    [anon_sym_template] = ACTIONS(5115),
    [anon_sym_friend] = ACTIONS(5115),
    [anon_sym_private] = ACTIONS(5115),
    [anon_sym_protected] = ACTIONS(5115),
    [anon_sym_using] = ACTIONS(5115),
    [anon_sym_COLON_COLON] = ACTIONS(5113),
    [sym_operator_name] = ACTIONS(5113),
  },
  [3083] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6372),
    [anon_sym_typedef] = ACTIONS(6374),
    [anon_sym_extern] = ACTIONS(6374),
    [anon_sym_RBRACE] = ACTIONS(6372),
    [anon_sym_LPAREN2] = ACTIONS(6372),
    [anon_sym_STAR] = ACTIONS(6372),
    [anon_sym_static] = ACTIONS(6374),
    [anon_sym_register] = ACTIONS(6374),
    [anon_sym_inline] = ACTIONS(6374),
    [anon_sym_const] = ACTIONS(6374),
    [anon_sym_restrict] = ACTIONS(6374),
    [anon_sym_volatile] = ACTIONS(6374),
    [anon_sym__Atomic] = ACTIONS(6374),
    [anon_sym_mutable] = ACTIONS(6374),
    [anon_sym_explicit] = ACTIONS(6374),
    [anon_sym_constexpr] = ACTIONS(6374),
    [anon_sym_unsigned] = ACTIONS(6374),
    [anon_sym_long] = ACTIONS(6374),
    [anon_sym_short] = ACTIONS(6374),
    [sym_primitive_type] = ACTIONS(6374),
    [anon_sym_enum] = ACTIONS(6374),
    [anon_sym_struct] = ACTIONS(6374),
    [anon_sym_union] = ACTIONS(6374),
    [anon_sym_AMP] = ACTIONS(6374),
    [anon_sym_AMP_AMP] = ACTIONS(6372),
    [anon_sym_TILDE] = ACTIONS(6372),
    [sym_identifier] = ACTIONS(6374),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6374),
    [anon_sym_public] = ACTIONS(6374),
    [sym_auto] = ACTIONS(6374),
    [anon_sym_typename] = ACTIONS(6374),
    [anon_sym_template] = ACTIONS(6374),
    [anon_sym_friend] = ACTIONS(6374),
    [anon_sym_private] = ACTIONS(6374),
    [anon_sym_protected] = ACTIONS(6374),
    [anon_sym_using] = ACTIONS(6374),
    [anon_sym_COLON_COLON] = ACTIONS(6372),
    [sym_operator_name] = ACTIONS(6372),
  },
  [3084] = {
    [sym_parameter_list] = STATE(2683),
    [anon_sym_RPAREN] = ACTIONS(6974),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [sym_comment] = ACTIONS(91),
  },
  [3085] = {
    [sym_type_qualifier] = STATE(1970),
    [sym_virtual_specifier] = STATE(1970),
    [sym_trailing_return_type] = STATE(1970),
    [aux_sym_function_declarator_repeat1] = STATE(1970),
    [anon_sym_RPAREN] = ACTIONS(7004),
    [anon_sym_LPAREN2] = ACTIONS(7004),
    [anon_sym_LBRACK] = ACTIONS(7004),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(2457),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [sym_noexcept] = ACTIONS(4155),
  },
  [3086] = {
    [sym_parameter_list] = STATE(3089),
    [anon_sym_COMMA] = ACTIONS(5975),
    [anon_sym_SEMI] = ACTIONS(5975),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_COLON] = ACTIONS(5975),
    [sym_comment] = ACTIONS(91),
  },
  [3087] = {
    [sym__field_declarator] = STATE(3344),
    [sym_pointer_field_declarator] = STATE(3344),
    [sym_function_field_declarator] = STATE(3344),
    [sym_array_field_declarator] = STATE(3344),
    [sym_type_qualifier] = STATE(2685),
    [sym_reference_field_declarator] = STATE(3344),
    [sym_template_type] = STATE(953),
    [sym_template_method] = STATE(3344),
    [sym_scoped_field_identifier] = STATE(1266),
    [sym_scoped_type_identifier] = STATE(249),
    [sym_scoped_namespace_identifier] = STATE(953),
    [aux_sym_type_definition_repeat1] = STATE(2685),
    [anon_sym_LPAREN2] = ACTIONS(2655),
    [anon_sym_STAR] = ACTIONS(5983),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym__Atomic] = ACTIONS(35),
    [anon_sym_mutable] = ACTIONS(35),
    [anon_sym_explicit] = ACTIONS(35),
    [anon_sym_constexpr] = ACTIONS(35),
    [anon_sym_AMP] = ACTIONS(5985),
    [anon_sym_AMP_AMP] = ACTIONS(5987),
    [sym_identifier] = ACTIONS(2665),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(1755),
    [sym_operator_name] = ACTIONS(7512),
  },
  [3088] = {
    [sym_parameter_list] = STATE(3089),
    [anon_sym_COMMA] = ACTIONS(5981),
    [anon_sym_SEMI] = ACTIONS(5981),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_COLON] = ACTIONS(5981),
    [sym_comment] = ACTIONS(91),
  },
  [3089] = {
    [sym_type_qualifier] = STATE(3346),
    [sym_virtual_specifier] = STATE(3346),
    [sym_trailing_return_type] = STATE(3346),
    [aux_sym_function_declarator_repeat1] = STATE(3346),
    [anon_sym_COMMA] = ACTIONS(6011),
    [anon_sym_SEMI] = ACTIONS(6011),
    [anon_sym_LPAREN2] = ACTIONS(6011),
    [anon_sym_LBRACK] = ACTIONS(6011),
    [anon_sym_const] = ACTIONS(1667),
    [anon_sym_restrict] = ACTIONS(1669),
    [anon_sym_volatile] = ACTIONS(1669),
    [anon_sym__Atomic] = ACTIONS(1669),
    [anon_sym_mutable] = ACTIONS(1669),
    [anon_sym_explicit] = ACTIONS(1669),
    [anon_sym_constexpr] = ACTIONS(1669),
    [anon_sym_COLON] = ACTIONS(6011),
    [anon_sym_DASH_GT] = ACTIONS(7514),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [sym_noexcept] = ACTIONS(7516),
  },
  [3090] = {
    [anon_sym_COMMA] = ACTIONS(7518),
    [anon_sym_RPAREN] = ACTIONS(7518),
    [anon_sym_SEMI] = ACTIONS(7518),
    [anon_sym_LBRACE] = ACTIONS(7518),
    [anon_sym_LPAREN2] = ACTIONS(7518),
    [anon_sym_LBRACK] = ACTIONS(7518),
    [anon_sym_EQ] = ACTIONS(7518),
    [anon_sym_COLON] = ACTIONS(7518),
    [sym_comment] = ACTIONS(91),
  },
  [3091] = {
    [sym__expression] = STATE(146),
    [sym_conditional_expression] = STATE(146),
    [sym_assignment_expression] = STATE(146),
    [sym_pointer_expression] = STATE(146),
    [sym_logical_expression] = STATE(146),
    [sym_bitwise_expression] = STATE(146),
    [sym_equality_expression] = STATE(146),
    [sym_relational_expression] = STATE(146),
    [sym_shift_expression] = STATE(146),
    [sym_math_expression] = STATE(146),
    [sym_cast_expression] = STATE(146),
    [sym_sizeof_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_call_expression] = STATE(146),
    [sym_field_expression] = STATE(146),
    [sym_compound_literal_expression] = STATE(146),
    [sym_parenthesized_expression] = STATE(146),
    [sym_char_literal] = STATE(146),
    [sym_concatenated_string] = STATE(146),
    [sym_string_literal] = STATE(922),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(146),
    [sym_new_expression] = STATE(146),
    [sym_delete_expression] = STATE(146),
    [sym_lambda_expression] = STATE(146),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(257),
    [anon_sym_LPAREN2] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(7520),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_sizeof] = ACTIONS(1655),
    [sym_number_literal] = ACTIONS(257),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(259),
    [sym_false] = ACTIONS(259),
    [sym_null] = ACTIONS(259),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_new] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1663),
    [sym_nullptr] = ACTIONS(259),
  },
  [3092] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(7520),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_STAR_EQ] = ACTIONS(3507),
    [anon_sym_SLASH_EQ] = ACTIONS(3507),
    [anon_sym_PERCENT_EQ] = ACTIONS(3507),
    [anon_sym_PLUS_EQ] = ACTIONS(3507),
    [anon_sym_DASH_EQ] = ACTIONS(3507),
    [anon_sym_LT_LT_EQ] = ACTIONS(3507),
    [anon_sym_GT_GT_EQ] = ACTIONS(3507),
    [anon_sym_AMP_EQ] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(3507),
    [anon_sym_PIPE_EQ] = ACTIONS(3507),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_CARET] = ACTIONS(3517),
    [anon_sym_EQ_EQ] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3521),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3525),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3093] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7522),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7524),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7524),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7524),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7524),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7524),
    [anon_sym_typedef] = ACTIONS(7522),
    [anon_sym_extern] = ACTIONS(7522),
    [anon_sym_RBRACE] = ACTIONS(7524),
    [anon_sym_LPAREN2] = ACTIONS(7524),
    [anon_sym_STAR] = ACTIONS(7524),
    [anon_sym_static] = ACTIONS(7522),
    [anon_sym_register] = ACTIONS(7522),
    [anon_sym_inline] = ACTIONS(7522),
    [anon_sym_const] = ACTIONS(7522),
    [anon_sym_restrict] = ACTIONS(7522),
    [anon_sym_volatile] = ACTIONS(7522),
    [anon_sym__Atomic] = ACTIONS(7522),
    [anon_sym_mutable] = ACTIONS(7522),
    [anon_sym_explicit] = ACTIONS(7522),
    [anon_sym_constexpr] = ACTIONS(7522),
    [anon_sym_unsigned] = ACTIONS(7522),
    [anon_sym_long] = ACTIONS(7522),
    [anon_sym_short] = ACTIONS(7522),
    [sym_primitive_type] = ACTIONS(7522),
    [anon_sym_enum] = ACTIONS(7522),
    [anon_sym_struct] = ACTIONS(7522),
    [anon_sym_union] = ACTIONS(7522),
    [anon_sym_AMP] = ACTIONS(7522),
    [anon_sym_AMP_AMP] = ACTIONS(7524),
    [anon_sym_TILDE] = ACTIONS(7524),
    [sym_identifier] = ACTIONS(7522),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7522),
    [anon_sym_public] = ACTIONS(7522),
    [sym_auto] = ACTIONS(7522),
    [anon_sym_typename] = ACTIONS(7522),
    [anon_sym_template] = ACTIONS(7522),
    [anon_sym_friend] = ACTIONS(7522),
    [anon_sym_private] = ACTIONS(7522),
    [anon_sym_protected] = ACTIONS(7522),
    [anon_sym_using] = ACTIONS(7522),
    [anon_sym_COLON_COLON] = ACTIONS(7524),
    [sym_operator_name] = ACTIONS(7524),
  },
  [3094] = {
    [sym__type_specifier] = STATE(444),
    [sym_sized_type_specifier] = STATE(444),
    [sym_enum_specifier] = STATE(444),
    [sym_struct_specifier] = STATE(444),
    [sym_union_specifier] = STATE(444),
    [sym_macro_type_specifier] = STATE(444),
    [sym_class_specifier] = STATE(444),
    [sym_dependent_type] = STATE(444),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(1691),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3096),
    [anon_sym_unsigned] = ACTIONS(6998),
    [anon_sym_long] = ACTIONS(6998),
    [anon_sym_short] = ACTIONS(6998),
    [sym_primitive_type] = ACTIONS(762),
    [anon_sym_enum] = ACTIONS(3539),
    [anon_sym_struct] = ACTIONS(3541),
    [anon_sym_union] = ACTIONS(3543),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3545),
    [sym_auto] = ACTIONS(762),
    [anon_sym_typename] = ACTIONS(7002),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [3095] = {
    [sym__abstract_declarator] = STATE(3350),
    [sym_abstract_pointer_declarator] = STATE(3350),
    [sym_abstract_function_declarator] = STATE(3350),
    [sym_abstract_array_declarator] = STATE(3350),
    [sym_parameter_list] = STATE(3351),
    [sym_abstract_reference_declarator] = STATE(3350),
    [anon_sym_COMMA] = ACTIONS(5222),
    [anon_sym_SEMI] = ACTIONS(5222),
    [anon_sym_LBRACE] = ACTIONS(5222),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(7526),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_EQ] = ACTIONS(5222),
    [anon_sym_const] = ACTIONS(5226),
    [anon_sym_restrict] = ACTIONS(5222),
    [anon_sym_volatile] = ACTIONS(5222),
    [anon_sym__Atomic] = ACTIONS(5222),
    [anon_sym_mutable] = ACTIONS(5222),
    [anon_sym_explicit] = ACTIONS(5222),
    [anon_sym_constexpr] = ACTIONS(5222),
    [anon_sym_COLON] = ACTIONS(5222),
    [anon_sym_AMP] = ACTIONS(7528),
    [anon_sym_AMP_AMP] = ACTIONS(7530),
    [anon_sym_DASH_GT] = ACTIONS(5222),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5222),
    [anon_sym_override] = ACTIONS(5222),
    [sym_noexcept] = ACTIONS(5222),
  },
  [3096] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3352),
    [anon_sym_COMMA] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(653),
    [anon_sym_LBRACE] = ACTIONS(653),
    [anon_sym_LPAREN2] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_EQ] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(655),
    [anon_sym_restrict] = ACTIONS(655),
    [anon_sym_volatile] = ACTIONS(655),
    [anon_sym__Atomic] = ACTIONS(655),
    [anon_sym_mutable] = ACTIONS(655),
    [anon_sym_explicit] = ACTIONS(655),
    [anon_sym_constexpr] = ACTIONS(655),
    [anon_sym_unsigned] = ACTIONS(7532),
    [anon_sym_long] = ACTIONS(7532),
    [anon_sym_short] = ACTIONS(7532),
    [sym_primitive_type] = ACTIONS(778),
    [anon_sym_COLON] = ACTIONS(653),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [anon_sym_DASH_GT] = ACTIONS(653),
    [sym_identifier] = ACTIONS(5234),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(655),
    [anon_sym_override] = ACTIONS(655),
    [sym_noexcept] = ACTIONS(655),
  },
  [3097] = {
    [sym_type_qualifier] = STATE(3097),
    [sym_virtual_specifier] = STATE(3097),
    [sym_trailing_return_type] = STATE(3097),
    [aux_sym_function_declarator_repeat1] = STATE(3097),
    [anon_sym_COMMA] = ACTIONS(5236),
    [anon_sym_SEMI] = ACTIONS(5236),
    [anon_sym_LBRACE] = ACTIONS(5236),
    [anon_sym_LPAREN2] = ACTIONS(5236),
    [anon_sym_LBRACK] = ACTIONS(5236),
    [anon_sym_EQ] = ACTIONS(5236),
    [anon_sym_const] = ACTIONS(5238),
    [anon_sym_restrict] = ACTIONS(5241),
    [anon_sym_volatile] = ACTIONS(5241),
    [anon_sym__Atomic] = ACTIONS(5241),
    [anon_sym_mutable] = ACTIONS(5241),
    [anon_sym_explicit] = ACTIONS(5241),
    [anon_sym_constexpr] = ACTIONS(5241),
    [anon_sym_COLON] = ACTIONS(5236),
    [anon_sym_DASH_GT] = ACTIONS(7534),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5247),
    [anon_sym_override] = ACTIONS(5247),
    [sym_noexcept] = ACTIONS(7537),
  },
  [3098] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(7540),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3099] = {
    [sym__abstract_declarator] = STATE(3354),
    [sym_abstract_pointer_declarator] = STATE(3354),
    [sym_abstract_function_declarator] = STATE(3354),
    [sym_abstract_array_declarator] = STATE(3354),
    [sym_type_qualifier] = STATE(3355),
    [sym_parameter_list] = STATE(3102),
    [sym_abstract_reference_declarator] = STATE(3354),
    [aux_sym_type_definition_repeat1] = STATE(3355),
    [anon_sym_SEMI] = ACTIONS(2461),
    [anon_sym_LBRACE] = ACTIONS(2461),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(7015),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_EQ] = ACTIONS(2461),
    [anon_sym_const] = ACTIONS(1667),
    [anon_sym_restrict] = ACTIONS(1669),
    [anon_sym_volatile] = ACTIONS(1669),
    [anon_sym__Atomic] = ACTIONS(1669),
    [anon_sym_mutable] = ACTIONS(1669),
    [anon_sym_explicit] = ACTIONS(1669),
    [anon_sym_constexpr] = ACTIONS(1669),
    [anon_sym_COLON] = ACTIONS(2461),
    [anon_sym_AMP] = ACTIONS(7017),
    [anon_sym_AMP_AMP] = ACTIONS(7019),
    [anon_sym_DASH_GT] = ACTIONS(2461),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2461),
    [anon_sym_override] = ACTIONS(2461),
    [sym_noexcept] = ACTIONS(2461),
  },
  [3100] = {
    [sym__abstract_declarator] = STATE(3356),
    [sym_abstract_pointer_declarator] = STATE(3356),
    [sym_abstract_function_declarator] = STATE(3356),
    [sym_abstract_array_declarator] = STATE(3356),
    [sym_parameter_list] = STATE(3102),
    [sym_abstract_reference_declarator] = STATE(3356),
    [anon_sym_SEMI] = ACTIONS(2463),
    [anon_sym_LBRACE] = ACTIONS(2463),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(7015),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_EQ] = ACTIONS(2463),
    [anon_sym_const] = ACTIONS(6555),
    [anon_sym_restrict] = ACTIONS(2463),
    [anon_sym_volatile] = ACTIONS(2463),
    [anon_sym__Atomic] = ACTIONS(2463),
    [anon_sym_mutable] = ACTIONS(2463),
    [anon_sym_explicit] = ACTIONS(2463),
    [anon_sym_constexpr] = ACTIONS(2463),
    [anon_sym_COLON] = ACTIONS(2463),
    [anon_sym_AMP] = ACTIONS(7017),
    [anon_sym_AMP_AMP] = ACTIONS(7019),
    [anon_sym_DASH_GT] = ACTIONS(2463),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2463),
    [anon_sym_override] = ACTIONS(2463),
    [sym_noexcept] = ACTIONS(2463),
  },
  [3101] = {
    [sym_parameter_list] = STATE(3357),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(6557),
    [anon_sym_const] = ACTIONS(6559),
    [anon_sym_restrict] = ACTIONS(6557),
    [anon_sym_volatile] = ACTIONS(6557),
    [anon_sym__Atomic] = ACTIONS(6557),
    [anon_sym_mutable] = ACTIONS(6557),
    [anon_sym_explicit] = ACTIONS(6557),
    [anon_sym_constexpr] = ACTIONS(6557),
    [anon_sym_COLON] = ACTIONS(6557),
    [anon_sym_DASH_GT] = ACTIONS(6557),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(6557),
    [anon_sym_override] = ACTIONS(6557),
    [sym_noexcept] = ACTIONS(6557),
  },
  [3102] = {
    [sym_type_qualifier] = STATE(3358),
    [sym_trailing_return_type] = STATE(971),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3358),
    [anon_sym_SEMI] = ACTIONS(1787),
    [anon_sym_LBRACE] = ACTIONS(1787),
    [anon_sym_LPAREN2] = ACTIONS(1787),
    [anon_sym_LBRACK] = ACTIONS(1787),
    [anon_sym_EQ] = ACTIONS(1787),
    [anon_sym_const] = ACTIONS(6561),
    [anon_sym_restrict] = ACTIONS(1787),
    [anon_sym_volatile] = ACTIONS(1787),
    [anon_sym__Atomic] = ACTIONS(1787),
    [anon_sym_mutable] = ACTIONS(1787),
    [anon_sym_explicit] = ACTIONS(1787),
    [anon_sym_constexpr] = ACTIONS(1787),
    [anon_sym_COLON] = ACTIONS(1787),
    [anon_sym_DASH_GT] = ACTIONS(1787),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1787),
    [anon_sym_override] = ACTIONS(1787),
    [sym_noexcept] = ACTIONS(1787),
  },
  [3103] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3103),
    [anon_sym_SEMI] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(1985),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1985),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_EQ] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1987),
    [anon_sym_restrict] = ACTIONS(1987),
    [anon_sym_volatile] = ACTIONS(1987),
    [anon_sym__Atomic] = ACTIONS(1987),
    [anon_sym_mutable] = ACTIONS(1987),
    [anon_sym_explicit] = ACTIONS(1987),
    [anon_sym_constexpr] = ACTIONS(1987),
    [anon_sym_unsigned] = ACTIONS(7542),
    [anon_sym_long] = ACTIONS(7542),
    [anon_sym_short] = ACTIONS(7542),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_COLON] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_DASH_GT] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1987),
    [anon_sym_override] = ACTIONS(1987),
    [sym_noexcept] = ACTIONS(1987),
  },
  [3104] = {
    [sym_new_declarator] = STATE(2861),
    [anon_sym_RPAREN] = ACTIONS(6396),
    [anon_sym_LBRACE] = ACTIONS(6396),
    [anon_sym_LPAREN2] = ACTIONS(6396),
    [anon_sym_STAR] = ACTIONS(6398),
    [anon_sym_LBRACK] = ACTIONS(4418),
    [anon_sym_EQ] = ACTIONS(6398),
    [anon_sym_QMARK] = ACTIONS(6396),
    [anon_sym_STAR_EQ] = ACTIONS(6396),
    [anon_sym_SLASH_EQ] = ACTIONS(6396),
    [anon_sym_PERCENT_EQ] = ACTIONS(6396),
    [anon_sym_PLUS_EQ] = ACTIONS(6396),
    [anon_sym_DASH_EQ] = ACTIONS(6396),
    [anon_sym_LT_LT_EQ] = ACTIONS(6396),
    [anon_sym_GT_GT_EQ] = ACTIONS(6396),
    [anon_sym_AMP_EQ] = ACTIONS(6396),
    [anon_sym_CARET_EQ] = ACTIONS(6396),
    [anon_sym_PIPE_EQ] = ACTIONS(6396),
    [anon_sym_AMP] = ACTIONS(6398),
    [anon_sym_PIPE_PIPE] = ACTIONS(6396),
    [anon_sym_AMP_AMP] = ACTIONS(6396),
    [anon_sym_PIPE] = ACTIONS(6398),
    [anon_sym_CARET] = ACTIONS(6398),
    [anon_sym_EQ_EQ] = ACTIONS(6396),
    [anon_sym_BANG_EQ] = ACTIONS(6396),
    [anon_sym_LT] = ACTIONS(6398),
    [anon_sym_GT] = ACTIONS(6398),
    [anon_sym_LT_EQ] = ACTIONS(6396),
    [anon_sym_GT_EQ] = ACTIONS(6396),
    [anon_sym_LT_LT] = ACTIONS(6398),
    [anon_sym_GT_GT] = ACTIONS(6398),
    [anon_sym_PLUS] = ACTIONS(6398),
    [anon_sym_DASH] = ACTIONS(6398),
    [anon_sym_SLASH] = ACTIONS(6398),
    [anon_sym_PERCENT] = ACTIONS(6398),
    [anon_sym_DASH_DASH] = ACTIONS(6396),
    [anon_sym_PLUS_PLUS] = ACTIONS(6396),
    [anon_sym_DOT] = ACTIONS(6396),
    [anon_sym_DASH_GT] = ACTIONS(6396),
    [sym_comment] = ACTIONS(91),
  },
  [3105] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(6404),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(6406),
    [anon_sym_QMARK] = ACTIONS(6404),
    [anon_sym_STAR_EQ] = ACTIONS(6404),
    [anon_sym_SLASH_EQ] = ACTIONS(6404),
    [anon_sym_PERCENT_EQ] = ACTIONS(6404),
    [anon_sym_PLUS_EQ] = ACTIONS(6404),
    [anon_sym_DASH_EQ] = ACTIONS(6404),
    [anon_sym_LT_LT_EQ] = ACTIONS(6404),
    [anon_sym_GT_GT_EQ] = ACTIONS(6404),
    [anon_sym_AMP_EQ] = ACTIONS(6404),
    [anon_sym_CARET_EQ] = ACTIONS(6404),
    [anon_sym_PIPE_EQ] = ACTIONS(6404),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3106] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(7545),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3107] = {
    [sym__expression] = STATE(3360),
    [sym_conditional_expression] = STATE(3360),
    [sym_assignment_expression] = STATE(3360),
    [sym_pointer_expression] = STATE(3360),
    [sym_logical_expression] = STATE(3360),
    [sym_bitwise_expression] = STATE(3360),
    [sym_equality_expression] = STATE(3360),
    [sym_relational_expression] = STATE(3360),
    [sym_shift_expression] = STATE(3360),
    [sym_math_expression] = STATE(3360),
    [sym_cast_expression] = STATE(3360),
    [sym_sizeof_expression] = STATE(3360),
    [sym_subscript_expression] = STATE(3360),
    [sym_call_expression] = STATE(3360),
    [sym_field_expression] = STATE(3360),
    [sym_compound_literal_expression] = STATE(3360),
    [sym_parenthesized_expression] = STATE(3360),
    [sym_char_literal] = STATE(3360),
    [sym_concatenated_string] = STATE(3360),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3360),
    [sym_new_expression] = STATE(3360),
    [sym_delete_expression] = STATE(3360),
    [sym_lambda_expression] = STATE(3360),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7547),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(7547),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7549),
    [sym_false] = ACTIONS(7549),
    [sym_null] = ACTIONS(7549),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(7549),
  },
  [3108] = {
    [sym_declaration] = STATE(1346),
    [sym_type_definition] = STATE(1346),
    [sym__declaration_specifiers] = STATE(682),
    [sym_compound_statement] = STATE(1346),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_labeled_statement] = STATE(1346),
    [sym_expression_statement] = STATE(1346),
    [sym_if_statement] = STATE(1346),
    [sym_switch_statement] = STATE(1346),
    [sym_case_statement] = STATE(1346),
    [sym_while_statement] = STATE(1346),
    [sym_do_statement] = STATE(1346),
    [sym_for_statement] = STATE(1346),
    [sym_return_statement] = STATE(1346),
    [sym_break_statement] = STATE(1346),
    [sym_continue_statement] = STATE(1346),
    [sym_goto_statement] = STATE(1346),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(1346),
    [sym_try_statement] = STATE(1346),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(4430),
    [anon_sym_switch] = ACTIONS(4432),
    [anon_sym_case] = ACTIONS(4434),
    [anon_sym_default] = ACTIONS(4436),
    [anon_sym_while] = ACTIONS(4438),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(4440),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(7051),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(4444),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(1202),
    [sym_nullptr] = ACTIONS(87),
  },
  [3109] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(1362),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_extern] = ACTIONS(468),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(465),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_register] = ACTIONS(468),
    [anon_sym_inline] = ACTIONS(468),
    [anon_sym_const] = ACTIONS(468),
    [anon_sym_restrict] = ACTIONS(468),
    [anon_sym_volatile] = ACTIONS(468),
    [anon_sym__Atomic] = ACTIONS(468),
    [anon_sym_mutable] = ACTIONS(468),
    [anon_sym_explicit] = ACTIONS(468),
    [anon_sym_constexpr] = ACTIONS(468),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(474),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_TILDE] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_identifier] = ACTIONS(468),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(2855),
    [sym_operator_name] = ACTIONS(481),
  },
  [3110] = {
    [sym__expression] = STATE(3362),
    [sym_conditional_expression] = STATE(3362),
    [sym_assignment_expression] = STATE(3362),
    [sym_pointer_expression] = STATE(3362),
    [sym_logical_expression] = STATE(3362),
    [sym_bitwise_expression] = STATE(3362),
    [sym_equality_expression] = STATE(3362),
    [sym_relational_expression] = STATE(3362),
    [sym_shift_expression] = STATE(3362),
    [sym_math_expression] = STATE(3362),
    [sym_cast_expression] = STATE(3362),
    [sym_sizeof_expression] = STATE(3362),
    [sym_subscript_expression] = STATE(3362),
    [sym_call_expression] = STATE(3362),
    [sym_field_expression] = STATE(3362),
    [sym_compound_literal_expression] = STATE(3362),
    [sym_parenthesized_expression] = STATE(3362),
    [sym_char_literal] = STATE(3362),
    [sym_concatenated_string] = STATE(3362),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3362),
    [sym_new_expression] = STATE(3362),
    [sym_delete_expression] = STATE(3362),
    [sym_lambda_expression] = STATE(3362),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7551),
    [anon_sym_SEMI] = ACTIONS(7553),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(7551),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7555),
    [sym_false] = ACTIONS(7555),
    [sym_null] = ACTIONS(7555),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(7555),
  },
  [3111] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(7557),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3112] = {
    [anon_sym_COLON] = ACTIONS(7559),
    [sym_comment] = ACTIONS(91),
  },
  [3113] = {
    [sym_catch_clause] = STATE(3365),
    [aux_sym_try_statement_repeat1] = STATE(3365),
    [sym_raw_string_literal] = ACTIONS(3346),
    [ts_builtin_sym_end] = ACTIONS(3346),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3348),
    [sym_preproc_directive] = ACTIONS(3348),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym_typedef] = ACTIONS(3348),
    [anon_sym_extern] = ACTIONS(3348),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(3346),
    [anon_sym_static] = ACTIONS(3348),
    [anon_sym_register] = ACTIONS(3348),
    [anon_sym_inline] = ACTIONS(3348),
    [anon_sym_const] = ACTIONS(3348),
    [anon_sym_restrict] = ACTIONS(3348),
    [anon_sym_volatile] = ACTIONS(3348),
    [anon_sym__Atomic] = ACTIONS(3348),
    [anon_sym_mutable] = ACTIONS(3348),
    [anon_sym_explicit] = ACTIONS(3348),
    [anon_sym_constexpr] = ACTIONS(3348),
    [anon_sym_unsigned] = ACTIONS(3348),
    [anon_sym_long] = ACTIONS(3348),
    [anon_sym_short] = ACTIONS(3348),
    [sym_primitive_type] = ACTIONS(3348),
    [anon_sym_enum] = ACTIONS(3348),
    [anon_sym_struct] = ACTIONS(3348),
    [anon_sym_union] = ACTIONS(3348),
    [anon_sym_if] = ACTIONS(3348),
    [anon_sym_else] = ACTIONS(3348),
    [anon_sym_switch] = ACTIONS(3348),
    [anon_sym_case] = ACTIONS(3348),
    [anon_sym_default] = ACTIONS(3348),
    [anon_sym_while] = ACTIONS(3348),
    [anon_sym_do] = ACTIONS(3348),
    [anon_sym_for] = ACTIONS(3348),
    [anon_sym_return] = ACTIONS(3348),
    [anon_sym_break] = ACTIONS(3348),
    [anon_sym_continue] = ACTIONS(3348),
    [anon_sym_goto] = ACTIONS(3348),
    [anon_sym_AMP] = ACTIONS(3348),
    [anon_sym_AMP_AMP] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_PLUS] = ACTIONS(3348),
    [anon_sym_DASH] = ACTIONS(3348),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_sizeof] = ACTIONS(3348),
    [sym_number_literal] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [sym_true] = ACTIONS(3348),
    [sym_false] = ACTIONS(3348),
    [sym_null] = ACTIONS(3348),
    [sym_identifier] = ACTIONS(3348),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3348),
    [sym_auto] = ACTIONS(3348),
    [anon_sym_typename] = ACTIONS(3348),
    [anon_sym_template] = ACTIONS(3348),
    [anon_sym_delete] = ACTIONS(3348),
    [anon_sym_namespace] = ACTIONS(3348),
    [anon_sym_using] = ACTIONS(3348),
    [anon_sym_try] = ACTIONS(3348),
    [anon_sym_catch] = ACTIONS(3350),
    [anon_sym_new] = ACTIONS(3348),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [sym_operator_name] = ACTIONS(3346),
    [sym_nullptr] = ACTIONS(3348),
  },
  [3114] = {
    [sym_raw_string_literal] = ACTIONS(7561),
    [ts_builtin_sym_end] = ACTIONS(7561),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7563),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7563),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7563),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7563),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7563),
    [sym_preproc_directive] = ACTIONS(7563),
    [anon_sym_SEMI] = ACTIONS(7561),
    [anon_sym_typedef] = ACTIONS(7563),
    [anon_sym_extern] = ACTIONS(7563),
    [anon_sym_LBRACE] = ACTIONS(7561),
    [anon_sym_RBRACE] = ACTIONS(7561),
    [anon_sym_LPAREN2] = ACTIONS(7561),
    [anon_sym_STAR] = ACTIONS(7561),
    [anon_sym_LBRACK] = ACTIONS(7561),
    [anon_sym_static] = ACTIONS(7563),
    [anon_sym_register] = ACTIONS(7563),
    [anon_sym_inline] = ACTIONS(7563),
    [anon_sym_const] = ACTIONS(7563),
    [anon_sym_restrict] = ACTIONS(7563),
    [anon_sym_volatile] = ACTIONS(7563),
    [anon_sym__Atomic] = ACTIONS(7563),
    [anon_sym_mutable] = ACTIONS(7563),
    [anon_sym_explicit] = ACTIONS(7563),
    [anon_sym_constexpr] = ACTIONS(7563),
    [anon_sym_unsigned] = ACTIONS(7563),
    [anon_sym_long] = ACTIONS(7563),
    [anon_sym_short] = ACTIONS(7563),
    [sym_primitive_type] = ACTIONS(7563),
    [anon_sym_enum] = ACTIONS(7563),
    [anon_sym_struct] = ACTIONS(7563),
    [anon_sym_union] = ACTIONS(7563),
    [anon_sym_if] = ACTIONS(7563),
    [anon_sym_else] = ACTIONS(7563),
    [anon_sym_switch] = ACTIONS(7563),
    [anon_sym_case] = ACTIONS(7563),
    [anon_sym_default] = ACTIONS(7563),
    [anon_sym_while] = ACTIONS(7563),
    [anon_sym_do] = ACTIONS(7563),
    [anon_sym_for] = ACTIONS(7563),
    [anon_sym_return] = ACTIONS(7563),
    [anon_sym_break] = ACTIONS(7563),
    [anon_sym_continue] = ACTIONS(7563),
    [anon_sym_goto] = ACTIONS(7563),
    [anon_sym_AMP] = ACTIONS(7563),
    [anon_sym_AMP_AMP] = ACTIONS(7561),
    [anon_sym_BANG] = ACTIONS(7561),
    [anon_sym_TILDE] = ACTIONS(7561),
    [anon_sym_PLUS] = ACTIONS(7563),
    [anon_sym_DASH] = ACTIONS(7563),
    [anon_sym_DASH_DASH] = ACTIONS(7561),
    [anon_sym_PLUS_PLUS] = ACTIONS(7561),
    [anon_sym_sizeof] = ACTIONS(7563),
    [sym_number_literal] = ACTIONS(7561),
    [anon_sym_SQUOTE] = ACTIONS(7561),
    [anon_sym_DQUOTE] = ACTIONS(7561),
    [sym_true] = ACTIONS(7563),
    [sym_false] = ACTIONS(7563),
    [sym_null] = ACTIONS(7563),
    [sym_identifier] = ACTIONS(7563),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7563),
    [sym_auto] = ACTIONS(7563),
    [anon_sym_typename] = ACTIONS(7563),
    [anon_sym_template] = ACTIONS(7563),
    [anon_sym_delete] = ACTIONS(7563),
    [anon_sym_namespace] = ACTIONS(7563),
    [anon_sym_using] = ACTIONS(7563),
    [anon_sym_try] = ACTIONS(7563),
    [anon_sym_new] = ACTIONS(7563),
    [anon_sym_COLON_COLON] = ACTIONS(7561),
    [sym_operator_name] = ACTIONS(7561),
    [sym_nullptr] = ACTIONS(7563),
  },
  [3115] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(6579),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3116] = {
    [sym_compound_statement] = STATE(3366),
    [sym_labeled_statement] = STATE(3366),
    [sym_expression_statement] = STATE(3366),
    [sym_if_statement] = STATE(3366),
    [sym_switch_statement] = STATE(3366),
    [sym_case_statement] = STATE(3366),
    [sym_while_statement] = STATE(3366),
    [sym_do_statement] = STATE(3366),
    [sym_for_statement] = STATE(3366),
    [sym_return_statement] = STATE(3366),
    [sym_break_statement] = STATE(3366),
    [sym_continue_statement] = STATE(3366),
    [sym_goto_statement] = STATE(3366),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(3366),
    [sym_try_statement] = STATE(3366),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_switch] = ACTIONS(49),
    [anon_sym_case] = ACTIONS(51),
    [anon_sym_default] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(1115),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(105),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [3117] = {
    [sym__expression] = STATE(3367),
    [sym_conditional_expression] = STATE(3367),
    [sym_assignment_expression] = STATE(3367),
    [sym_pointer_expression] = STATE(3367),
    [sym_logical_expression] = STATE(3367),
    [sym_bitwise_expression] = STATE(3367),
    [sym_equality_expression] = STATE(3367),
    [sym_relational_expression] = STATE(3367),
    [sym_shift_expression] = STATE(3367),
    [sym_math_expression] = STATE(3367),
    [sym_cast_expression] = STATE(3367),
    [sym_sizeof_expression] = STATE(3367),
    [sym_subscript_expression] = STATE(3367),
    [sym_call_expression] = STATE(3367),
    [sym_field_expression] = STATE(3367),
    [sym_compound_literal_expression] = STATE(3367),
    [sym_parenthesized_expression] = STATE(3367),
    [sym_char_literal] = STATE(3367),
    [sym_concatenated_string] = STATE(3367),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3367),
    [sym_new_expression] = STATE(3367),
    [sym_delete_expression] = STATE(3367),
    [sym_lambda_expression] = STATE(3367),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7565),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(7565),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7567),
    [sym_false] = ACTIONS(7567),
    [sym_null] = ACTIONS(7567),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(7567),
  },
  [3118] = {
    [anon_sym_LPAREN2] = ACTIONS(7569),
    [sym_comment] = ACTIONS(91),
  },
  [3119] = {
    [sym_compound_statement] = STATE(1369),
    [sym_labeled_statement] = STATE(1369),
    [sym_expression_statement] = STATE(1369),
    [sym_if_statement] = STATE(1369),
    [sym_switch_statement] = STATE(1369),
    [sym_case_statement] = STATE(1369),
    [sym_while_statement] = STATE(1369),
    [sym_do_statement] = STATE(1369),
    [sym_for_statement] = STATE(1369),
    [sym_return_statement] = STATE(1369),
    [sym_break_statement] = STATE(1369),
    [sym_continue_statement] = STATE(1369),
    [sym_goto_statement] = STATE(1369),
    [sym__expression] = STATE(222),
    [sym_comma_expression] = STATE(223),
    [sym_conditional_expression] = STATE(222),
    [sym_assignment_expression] = STATE(222),
    [sym_pointer_expression] = STATE(222),
    [sym_logical_expression] = STATE(222),
    [sym_bitwise_expression] = STATE(222),
    [sym_equality_expression] = STATE(222),
    [sym_relational_expression] = STATE(222),
    [sym_shift_expression] = STATE(222),
    [sym_math_expression] = STATE(222),
    [sym_cast_expression] = STATE(222),
    [sym_sizeof_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_call_expression] = STATE(222),
    [sym_field_expression] = STATE(222),
    [sym_compound_literal_expression] = STATE(222),
    [sym_parenthesized_expression] = STATE(222),
    [sym_char_literal] = STATE(222),
    [sym_concatenated_string] = STATE(222),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(222),
    [sym_for_range_loop] = STATE(1369),
    [sym_try_statement] = STATE(1369),
    [sym_new_expression] = STATE(222),
    [sym_delete_expression] = STATE(222),
    [sym_lambda_expression] = STATE(222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(6119),
    [anon_sym_switch] = ACTIONS(6121),
    [anon_sym_case] = ACTIONS(6123),
    [anon_sym_default] = ACTIONS(6125),
    [anon_sym_while] = ACTIONS(6127),
    [anon_sym_do] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(6129),
    [anon_sym_return] = ACTIONS(373),
    [anon_sym_break] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_goto] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(353),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_identifier] = ACTIONS(6131),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(6133),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(381),
  },
  [3120] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_COLON] = ACTIONS(7571),
    [anon_sym_QMARK] = ACTIONS(1171),
    [anon_sym_STAR_EQ] = ACTIONS(1173),
    [anon_sym_SLASH_EQ] = ACTIONS(1173),
    [anon_sym_PERCENT_EQ] = ACTIONS(1173),
    [anon_sym_PLUS_EQ] = ACTIONS(1173),
    [anon_sym_DASH_EQ] = ACTIONS(1173),
    [anon_sym_LT_LT_EQ] = ACTIONS(1173),
    [anon_sym_GT_GT_EQ] = ACTIONS(1173),
    [anon_sym_AMP_EQ] = ACTIONS(1173),
    [anon_sym_CARET_EQ] = ACTIONS(1173),
    [anon_sym_PIPE_EQ] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_CARET] = ACTIONS(1183),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [3121] = {
    [sym_declaration] = STATE(1372),
    [sym_type_definition] = STATE(1372),
    [sym__declaration_specifiers] = STATE(1373),
    [sym_compound_statement] = STATE(1372),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_labeled_statement] = STATE(1372),
    [sym_expression_statement] = STATE(1372),
    [sym_if_statement] = STATE(1372),
    [sym_switch_statement] = STATE(1372),
    [sym_case_statement] = STATE(1372),
    [sym_while_statement] = STATE(1372),
    [sym_do_statement] = STATE(1372),
    [sym_for_statement] = STATE(1372),
    [sym_return_statement] = STATE(1372),
    [sym_break_statement] = STATE(1372),
    [sym_continue_statement] = STATE(1372),
    [sym_goto_statement] = STATE(1372),
    [sym__expression] = STATE(222),
    [sym_comma_expression] = STATE(223),
    [sym_conditional_expression] = STATE(222),
    [sym_assignment_expression] = STATE(222),
    [sym_pointer_expression] = STATE(222),
    [sym_logical_expression] = STATE(222),
    [sym_bitwise_expression] = STATE(222),
    [sym_equality_expression] = STATE(222),
    [sym_relational_expression] = STATE(222),
    [sym_shift_expression] = STATE(222),
    [sym_math_expression] = STATE(222),
    [sym_cast_expression] = STATE(222),
    [sym_sizeof_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_call_expression] = STATE(222),
    [sym_field_expression] = STATE(222),
    [sym_compound_literal_expression] = STATE(222),
    [sym_parenthesized_expression] = STATE(222),
    [sym_char_literal] = STATE(222),
    [sym_concatenated_string] = STATE(222),
    [sym_string_literal] = STATE(55),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(222),
    [sym_for_range_loop] = STATE(1372),
    [sym_try_statement] = STATE(1372),
    [sym_new_expression] = STATE(222),
    [sym_delete_expression] = STATE(222),
    [sym_lambda_expression] = STATE(222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_typedef] = ACTIONS(1023),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(6119),
    [anon_sym_switch] = ACTIONS(6121),
    [anon_sym_case] = ACTIONS(6123),
    [anon_sym_default] = ACTIONS(6125),
    [anon_sym_while] = ACTIONS(6127),
    [anon_sym_do] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(6129),
    [anon_sym_return] = ACTIONS(373),
    [anon_sym_break] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_goto] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(353),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_identifier] = ACTIONS(7573),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(6133),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(1202),
    [sym_nullptr] = ACTIONS(381),
  },
  [3122] = {
    [sym_compound_statement] = STATE(1374),
    [sym_labeled_statement] = STATE(1374),
    [sym_expression_statement] = STATE(1374),
    [sym_if_statement] = STATE(1374),
    [sym_switch_statement] = STATE(1374),
    [sym_case_statement] = STATE(1374),
    [sym_while_statement] = STATE(1374),
    [sym_do_statement] = STATE(1374),
    [sym_for_statement] = STATE(1374),
    [sym_return_statement] = STATE(1374),
    [sym_break_statement] = STATE(1374),
    [sym_continue_statement] = STATE(1374),
    [sym_goto_statement] = STATE(1374),
    [sym__expression] = STATE(222),
    [sym_comma_expression] = STATE(223),
    [sym_conditional_expression] = STATE(222),
    [sym_assignment_expression] = STATE(222),
    [sym_pointer_expression] = STATE(222),
    [sym_logical_expression] = STATE(222),
    [sym_bitwise_expression] = STATE(222),
    [sym_equality_expression] = STATE(222),
    [sym_relational_expression] = STATE(222),
    [sym_shift_expression] = STATE(222),
    [sym_math_expression] = STATE(222),
    [sym_cast_expression] = STATE(222),
    [sym_sizeof_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_call_expression] = STATE(222),
    [sym_field_expression] = STATE(222),
    [sym_compound_literal_expression] = STATE(222),
    [sym_parenthesized_expression] = STATE(222),
    [sym_char_literal] = STATE(222),
    [sym_concatenated_string] = STATE(222),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(222),
    [sym_for_range_loop] = STATE(1374),
    [sym_try_statement] = STATE(1374),
    [sym_new_expression] = STATE(222),
    [sym_delete_expression] = STATE(222),
    [sym_lambda_expression] = STATE(222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(6119),
    [anon_sym_switch] = ACTIONS(6121),
    [anon_sym_case] = ACTIONS(6123),
    [anon_sym_default] = ACTIONS(6125),
    [anon_sym_while] = ACTIONS(6127),
    [anon_sym_do] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(6129),
    [anon_sym_return] = ACTIONS(373),
    [anon_sym_break] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_goto] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(353),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_identifier] = ACTIONS(6131),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(6133),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(381),
  },
  [3123] = {
    [sym_declaration] = STATE(3371),
    [sym__declaration_specifiers] = STATE(709),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym__expression] = STATE(3372),
    [sym_conditional_expression] = STATE(3372),
    [sym_assignment_expression] = STATE(3372),
    [sym_pointer_expression] = STATE(3372),
    [sym_logical_expression] = STATE(3372),
    [sym_bitwise_expression] = STATE(3372),
    [sym_equality_expression] = STATE(3372),
    [sym_relational_expression] = STATE(3372),
    [sym_shift_expression] = STATE(3372),
    [sym_math_expression] = STATE(3372),
    [sym_cast_expression] = STATE(3372),
    [sym_sizeof_expression] = STATE(3372),
    [sym_subscript_expression] = STATE(3372),
    [sym_call_expression] = STATE(3372),
    [sym_field_expression] = STATE(3372),
    [sym_compound_literal_expression] = STATE(3372),
    [sym_parenthesized_expression] = STATE(3372),
    [sym_char_literal] = STATE(3372),
    [sym_concatenated_string] = STATE(3372),
    [sym_string_literal] = STATE(238),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(3372),
    [sym_for_range_declaration] = STATE(3373),
    [sym_new_expression] = STATE(3372),
    [sym_delete_expression] = STATE(3372),
    [sym_lambda_expression] = STATE(3372),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(7575),
    [anon_sym_SEMI] = ACTIONS(7577),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(7575),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7579),
    [sym_false] = ACTIONS(7579),
    [sym_null] = ACTIONS(7579),
    [sym_identifier] = ACTIONS(1242),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(1244),
    [sym_nullptr] = ACTIONS(7579),
  },
  [3124] = {
    [sym_compound_statement] = STATE(1381),
    [sym_labeled_statement] = STATE(1381),
    [sym_expression_statement] = STATE(1381),
    [sym_if_statement] = STATE(1381),
    [sym_switch_statement] = STATE(1381),
    [sym_case_statement] = STATE(1381),
    [sym_while_statement] = STATE(1381),
    [sym_do_statement] = STATE(1381),
    [sym_for_statement] = STATE(1381),
    [sym_return_statement] = STATE(1381),
    [sym_break_statement] = STATE(1381),
    [sym_continue_statement] = STATE(1381),
    [sym_goto_statement] = STATE(1381),
    [sym__expression] = STATE(222),
    [sym_comma_expression] = STATE(223),
    [sym_conditional_expression] = STATE(222),
    [sym_assignment_expression] = STATE(222),
    [sym_pointer_expression] = STATE(222),
    [sym_logical_expression] = STATE(222),
    [sym_bitwise_expression] = STATE(222),
    [sym_equality_expression] = STATE(222),
    [sym_relational_expression] = STATE(222),
    [sym_shift_expression] = STATE(222),
    [sym_math_expression] = STATE(222),
    [sym_cast_expression] = STATE(222),
    [sym_sizeof_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_call_expression] = STATE(222),
    [sym_field_expression] = STATE(222),
    [sym_compound_literal_expression] = STATE(222),
    [sym_parenthesized_expression] = STATE(222),
    [sym_char_literal] = STATE(222),
    [sym_concatenated_string] = STATE(222),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(222),
    [sym_for_range_loop] = STATE(1381),
    [sym_try_statement] = STATE(1381),
    [sym_new_expression] = STATE(222),
    [sym_delete_expression] = STATE(222),
    [sym_lambda_expression] = STATE(222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(6119),
    [anon_sym_switch] = ACTIONS(6121),
    [anon_sym_case] = ACTIONS(6123),
    [anon_sym_default] = ACTIONS(6125),
    [anon_sym_while] = ACTIONS(6127),
    [anon_sym_do] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(6129),
    [anon_sym_return] = ACTIONS(373),
    [anon_sym_break] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_goto] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(353),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_identifier] = ACTIONS(6131),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(6133),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(381),
  },
  [3125] = {
    [sym_catch_clause] = STATE(3374),
    [aux_sym_try_statement_repeat1] = STATE(3374),
    [sym_comment] = ACTIONS(91),
    [anon_sym_catch] = ACTIONS(2895),
  },
  [3126] = {
    [sym_compound_statement] = STATE(3375),
    [sym_labeled_statement] = STATE(3375),
    [sym_expression_statement] = STATE(3375),
    [sym_if_statement] = STATE(3375),
    [sym_switch_statement] = STATE(3375),
    [sym_case_statement] = STATE(3375),
    [sym_while_statement] = STATE(3375),
    [sym_do_statement] = STATE(3375),
    [sym_for_statement] = STATE(3375),
    [sym_return_statement] = STATE(3375),
    [sym_break_statement] = STATE(3375),
    [sym_continue_statement] = STATE(3375),
    [sym_goto_statement] = STATE(3375),
    [sym__expression] = STATE(222),
    [sym_comma_expression] = STATE(223),
    [sym_conditional_expression] = STATE(222),
    [sym_assignment_expression] = STATE(222),
    [sym_pointer_expression] = STATE(222),
    [sym_logical_expression] = STATE(222),
    [sym_bitwise_expression] = STATE(222),
    [sym_equality_expression] = STATE(222),
    [sym_relational_expression] = STATE(222),
    [sym_shift_expression] = STATE(222),
    [sym_math_expression] = STATE(222),
    [sym_cast_expression] = STATE(222),
    [sym_sizeof_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_call_expression] = STATE(222),
    [sym_field_expression] = STATE(222),
    [sym_compound_literal_expression] = STATE(222),
    [sym_parenthesized_expression] = STATE(222),
    [sym_char_literal] = STATE(222),
    [sym_concatenated_string] = STATE(222),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(222),
    [sym_for_range_loop] = STATE(3375),
    [sym_try_statement] = STATE(3375),
    [sym_new_expression] = STATE(222),
    [sym_delete_expression] = STATE(222),
    [sym_lambda_expression] = STATE(222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(359),
    [anon_sym_switch] = ACTIONS(361),
    [anon_sym_case] = ACTIONS(363),
    [anon_sym_default] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [anon_sym_do] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(373),
    [anon_sym_break] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_goto] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(353),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_identifier] = ACTIONS(383),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(381),
  },
  [3127] = {
    [anon_sym_else] = ACTIONS(7581),
    [anon_sym_while] = ACTIONS(7063),
    [sym_comment] = ACTIONS(91),
  },
  [3128] = {
    [anon_sym_else] = ACTIONS(7095),
    [anon_sym_while] = ACTIONS(7095),
    [sym_comment] = ACTIONS(91),
  },
  [3129] = {
    [sym_compound_statement] = STATE(3377),
    [sym_labeled_statement] = STATE(3377),
    [sym_expression_statement] = STATE(3377),
    [sym_if_statement] = STATE(3377),
    [sym_switch_statement] = STATE(3377),
    [sym_case_statement] = STATE(3377),
    [sym_while_statement] = STATE(3377),
    [sym_do_statement] = STATE(3377),
    [sym_for_statement] = STATE(3377),
    [sym_return_statement] = STATE(3377),
    [sym_break_statement] = STATE(3377),
    [sym_continue_statement] = STATE(3377),
    [sym_goto_statement] = STATE(3377),
    [sym__expression] = STATE(222),
    [sym_comma_expression] = STATE(223),
    [sym_conditional_expression] = STATE(222),
    [sym_assignment_expression] = STATE(222),
    [sym_pointer_expression] = STATE(222),
    [sym_logical_expression] = STATE(222),
    [sym_bitwise_expression] = STATE(222),
    [sym_equality_expression] = STATE(222),
    [sym_relational_expression] = STATE(222),
    [sym_shift_expression] = STATE(222),
    [sym_math_expression] = STATE(222),
    [sym_cast_expression] = STATE(222),
    [sym_sizeof_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_call_expression] = STATE(222),
    [sym_field_expression] = STATE(222),
    [sym_compound_literal_expression] = STATE(222),
    [sym_parenthesized_expression] = STATE(222),
    [sym_char_literal] = STATE(222),
    [sym_concatenated_string] = STATE(222),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(222),
    [sym_for_range_loop] = STATE(3377),
    [sym_try_statement] = STATE(3377),
    [sym_new_expression] = STATE(222),
    [sym_delete_expression] = STATE(222),
    [sym_lambda_expression] = STATE(222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(359),
    [anon_sym_switch] = ACTIONS(361),
    [anon_sym_case] = ACTIONS(363),
    [anon_sym_default] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [anon_sym_do] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(373),
    [anon_sym_break] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_goto] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(353),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_identifier] = ACTIONS(383),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(381),
  },
  [3130] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(7583),
    [sym_comment] = ACTIONS(91),
  },
  [3131] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3379),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(7583),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3132] = {
    [sym__expression] = STATE(3380),
    [sym_conditional_expression] = STATE(3380),
    [sym_assignment_expression] = STATE(3380),
    [sym_pointer_expression] = STATE(3380),
    [sym_logical_expression] = STATE(3380),
    [sym_bitwise_expression] = STATE(3380),
    [sym_equality_expression] = STATE(3380),
    [sym_relational_expression] = STATE(3380),
    [sym_shift_expression] = STATE(3380),
    [sym_math_expression] = STATE(3380),
    [sym_cast_expression] = STATE(3380),
    [sym_sizeof_expression] = STATE(3380),
    [sym_subscript_expression] = STATE(3380),
    [sym_call_expression] = STATE(3380),
    [sym_field_expression] = STATE(3380),
    [sym_compound_literal_expression] = STATE(3380),
    [sym_parenthesized_expression] = STATE(3380),
    [sym_char_literal] = STATE(3380),
    [sym_concatenated_string] = STATE(3380),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3380),
    [sym_new_expression] = STATE(3380),
    [sym_delete_expression] = STATE(3380),
    [sym_lambda_expression] = STATE(3380),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7585),
    [anon_sym_RPAREN] = ACTIONS(7583),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(7585),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7587),
    [sym_false] = ACTIONS(7587),
    [sym_null] = ACTIONS(7587),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(7587),
  },
  [3133] = {
    [sym_compound_statement] = STATE(3381),
    [sym_labeled_statement] = STATE(3381),
    [sym_expression_statement] = STATE(3381),
    [sym_if_statement] = STATE(3381),
    [sym_switch_statement] = STATE(3381),
    [sym_case_statement] = STATE(3381),
    [sym_while_statement] = STATE(3381),
    [sym_do_statement] = STATE(3381),
    [sym_for_statement] = STATE(3381),
    [sym_return_statement] = STATE(3381),
    [sym_break_statement] = STATE(3381),
    [sym_continue_statement] = STATE(3381),
    [sym_goto_statement] = STATE(3381),
    [sym__expression] = STATE(222),
    [sym_comma_expression] = STATE(223),
    [sym_conditional_expression] = STATE(222),
    [sym_assignment_expression] = STATE(222),
    [sym_pointer_expression] = STATE(222),
    [sym_logical_expression] = STATE(222),
    [sym_bitwise_expression] = STATE(222),
    [sym_equality_expression] = STATE(222),
    [sym_relational_expression] = STATE(222),
    [sym_shift_expression] = STATE(222),
    [sym_math_expression] = STATE(222),
    [sym_cast_expression] = STATE(222),
    [sym_sizeof_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_call_expression] = STATE(222),
    [sym_field_expression] = STATE(222),
    [sym_compound_literal_expression] = STATE(222),
    [sym_parenthesized_expression] = STATE(222),
    [sym_char_literal] = STATE(222),
    [sym_concatenated_string] = STATE(222),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(222),
    [sym_for_range_loop] = STATE(3381),
    [sym_try_statement] = STATE(3381),
    [sym_new_expression] = STATE(222),
    [sym_delete_expression] = STATE(222),
    [sym_lambda_expression] = STATE(222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(359),
    [anon_sym_switch] = ACTIONS(361),
    [anon_sym_case] = ACTIONS(363),
    [anon_sym_default] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [anon_sym_do] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(373),
    [anon_sym_break] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_goto] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(353),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_identifier] = ACTIONS(383),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(381),
  },
  [3134] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(4202),
    [anon_sym_RPAREN] = ACTIONS(4202),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3135] = {
    [sym_raw_string_literal] = ACTIONS(7589),
    [ts_builtin_sym_end] = ACTIONS(7589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7591),
    [sym_preproc_directive] = ACTIONS(7591),
    [anon_sym_SEMI] = ACTIONS(7589),
    [anon_sym_typedef] = ACTIONS(7591),
    [anon_sym_extern] = ACTIONS(7591),
    [anon_sym_LBRACE] = ACTIONS(7589),
    [anon_sym_RBRACE] = ACTIONS(7589),
    [anon_sym_LPAREN2] = ACTIONS(7589),
    [anon_sym_STAR] = ACTIONS(7589),
    [anon_sym_LBRACK] = ACTIONS(7589),
    [anon_sym_static] = ACTIONS(7591),
    [anon_sym_register] = ACTIONS(7591),
    [anon_sym_inline] = ACTIONS(7591),
    [anon_sym_const] = ACTIONS(7591),
    [anon_sym_restrict] = ACTIONS(7591),
    [anon_sym_volatile] = ACTIONS(7591),
    [anon_sym__Atomic] = ACTIONS(7591),
    [anon_sym_mutable] = ACTIONS(7591),
    [anon_sym_explicit] = ACTIONS(7591),
    [anon_sym_constexpr] = ACTIONS(7591),
    [anon_sym_unsigned] = ACTIONS(7591),
    [anon_sym_long] = ACTIONS(7591),
    [anon_sym_short] = ACTIONS(7591),
    [sym_primitive_type] = ACTIONS(7591),
    [anon_sym_enum] = ACTIONS(7591),
    [anon_sym_struct] = ACTIONS(7591),
    [anon_sym_union] = ACTIONS(7591),
    [anon_sym_if] = ACTIONS(7591),
    [anon_sym_else] = ACTIONS(7591),
    [anon_sym_switch] = ACTIONS(7591),
    [anon_sym_case] = ACTIONS(7591),
    [anon_sym_default] = ACTIONS(7591),
    [anon_sym_while] = ACTIONS(7591),
    [anon_sym_do] = ACTIONS(7591),
    [anon_sym_for] = ACTIONS(7591),
    [anon_sym_return] = ACTIONS(7591),
    [anon_sym_break] = ACTIONS(7591),
    [anon_sym_continue] = ACTIONS(7591),
    [anon_sym_goto] = ACTIONS(7591),
    [anon_sym_AMP] = ACTIONS(7591),
    [anon_sym_AMP_AMP] = ACTIONS(7589),
    [anon_sym_BANG] = ACTIONS(7589),
    [anon_sym_TILDE] = ACTIONS(7589),
    [anon_sym_PLUS] = ACTIONS(7591),
    [anon_sym_DASH] = ACTIONS(7591),
    [anon_sym_DASH_DASH] = ACTIONS(7589),
    [anon_sym_PLUS_PLUS] = ACTIONS(7589),
    [anon_sym_sizeof] = ACTIONS(7591),
    [sym_number_literal] = ACTIONS(7589),
    [anon_sym_SQUOTE] = ACTIONS(7589),
    [anon_sym_DQUOTE] = ACTIONS(7589),
    [sym_true] = ACTIONS(7591),
    [sym_false] = ACTIONS(7591),
    [sym_null] = ACTIONS(7591),
    [sym_identifier] = ACTIONS(7591),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7591),
    [sym_auto] = ACTIONS(7591),
    [anon_sym_typename] = ACTIONS(7591),
    [anon_sym_template] = ACTIONS(7591),
    [anon_sym_delete] = ACTIONS(7591),
    [anon_sym_namespace] = ACTIONS(7591),
    [anon_sym_using] = ACTIONS(7591),
    [anon_sym_try] = ACTIONS(7591),
    [anon_sym_new] = ACTIONS(7591),
    [anon_sym_COLON_COLON] = ACTIONS(7589),
    [sym_operator_name] = ACTIONS(7589),
    [sym_nullptr] = ACTIONS(7591),
  },
  [3136] = {
    [sym_compound_statement] = STATE(3382),
    [sym_labeled_statement] = STATE(3382),
    [sym_expression_statement] = STATE(3382),
    [sym_if_statement] = STATE(3382),
    [sym_switch_statement] = STATE(3382),
    [sym_case_statement] = STATE(3382),
    [sym_while_statement] = STATE(3382),
    [sym_do_statement] = STATE(3382),
    [sym_for_statement] = STATE(3382),
    [sym_return_statement] = STATE(3382),
    [sym_break_statement] = STATE(3382),
    [sym_continue_statement] = STATE(3382),
    [sym_goto_statement] = STATE(3382),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(3382),
    [sym_try_statement] = STATE(3382),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_switch] = ACTIONS(49),
    [anon_sym_case] = ACTIONS(51),
    [anon_sym_default] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(1115),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(105),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [3137] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(7593),
    [anon_sym_RPAREN] = ACTIONS(4202),
    [sym_comment] = ACTIONS(91),
  },
  [3138] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(7596),
    [sym_comment] = ACTIONS(91),
  },
  [3139] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3384),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(7596),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3140] = {
    [sym_raw_string_literal] = ACTIONS(7598),
    [ts_builtin_sym_end] = ACTIONS(7598),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7600),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7600),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7600),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7600),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7600),
    [sym_preproc_directive] = ACTIONS(7600),
    [anon_sym_SEMI] = ACTIONS(7598),
    [anon_sym_typedef] = ACTIONS(7600),
    [anon_sym_extern] = ACTIONS(7600),
    [anon_sym_LBRACE] = ACTIONS(7598),
    [anon_sym_RBRACE] = ACTIONS(7598),
    [anon_sym_LPAREN2] = ACTIONS(7598),
    [anon_sym_STAR] = ACTIONS(7598),
    [anon_sym_LBRACK] = ACTIONS(7598),
    [anon_sym_static] = ACTIONS(7600),
    [anon_sym_register] = ACTIONS(7600),
    [anon_sym_inline] = ACTIONS(7600),
    [anon_sym_const] = ACTIONS(7600),
    [anon_sym_restrict] = ACTIONS(7600),
    [anon_sym_volatile] = ACTIONS(7600),
    [anon_sym__Atomic] = ACTIONS(7600),
    [anon_sym_mutable] = ACTIONS(7600),
    [anon_sym_explicit] = ACTIONS(7600),
    [anon_sym_constexpr] = ACTIONS(7600),
    [anon_sym_unsigned] = ACTIONS(7600),
    [anon_sym_long] = ACTIONS(7600),
    [anon_sym_short] = ACTIONS(7600),
    [sym_primitive_type] = ACTIONS(7600),
    [anon_sym_enum] = ACTIONS(7600),
    [anon_sym_struct] = ACTIONS(7600),
    [anon_sym_union] = ACTIONS(7600),
    [anon_sym_if] = ACTIONS(7600),
    [anon_sym_else] = ACTIONS(7600),
    [anon_sym_switch] = ACTIONS(7600),
    [anon_sym_case] = ACTIONS(7600),
    [anon_sym_default] = ACTIONS(7600),
    [anon_sym_while] = ACTIONS(7600),
    [anon_sym_do] = ACTIONS(7600),
    [anon_sym_for] = ACTIONS(7600),
    [anon_sym_return] = ACTIONS(7600),
    [anon_sym_break] = ACTIONS(7600),
    [anon_sym_continue] = ACTIONS(7600),
    [anon_sym_goto] = ACTIONS(7600),
    [anon_sym_AMP] = ACTIONS(7600),
    [anon_sym_AMP_AMP] = ACTIONS(7598),
    [anon_sym_BANG] = ACTIONS(7598),
    [anon_sym_TILDE] = ACTIONS(7598),
    [anon_sym_PLUS] = ACTIONS(7600),
    [anon_sym_DASH] = ACTIONS(7600),
    [anon_sym_DASH_DASH] = ACTIONS(7598),
    [anon_sym_PLUS_PLUS] = ACTIONS(7598),
    [anon_sym_sizeof] = ACTIONS(7600),
    [sym_number_literal] = ACTIONS(7598),
    [anon_sym_SQUOTE] = ACTIONS(7598),
    [anon_sym_DQUOTE] = ACTIONS(7598),
    [sym_true] = ACTIONS(7600),
    [sym_false] = ACTIONS(7600),
    [sym_null] = ACTIONS(7600),
    [sym_identifier] = ACTIONS(7600),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7600),
    [sym_auto] = ACTIONS(7600),
    [anon_sym_typename] = ACTIONS(7600),
    [anon_sym_template] = ACTIONS(7600),
    [anon_sym_delete] = ACTIONS(7600),
    [anon_sym_namespace] = ACTIONS(7600),
    [anon_sym_using] = ACTIONS(7600),
    [anon_sym_try] = ACTIONS(7600),
    [anon_sym_new] = ACTIONS(7600),
    [anon_sym_COLON_COLON] = ACTIONS(7598),
    [sym_operator_name] = ACTIONS(7598),
    [sym_nullptr] = ACTIONS(7600),
  },
  [3141] = {
    [sym_new_declarator] = STATE(2861),
    [anon_sym_COMMA] = ACTIONS(6396),
    [anon_sym_LBRACE] = ACTIONS(6396),
    [anon_sym_RBRACE] = ACTIONS(6396),
    [anon_sym_LPAREN2] = ACTIONS(6396),
    [anon_sym_STAR] = ACTIONS(6398),
    [anon_sym_LBRACK] = ACTIONS(4592),
    [anon_sym_EQ] = ACTIONS(6398),
    [anon_sym_QMARK] = ACTIONS(6396),
    [anon_sym_STAR_EQ] = ACTIONS(6396),
    [anon_sym_SLASH_EQ] = ACTIONS(6396),
    [anon_sym_PERCENT_EQ] = ACTIONS(6396),
    [anon_sym_PLUS_EQ] = ACTIONS(6396),
    [anon_sym_DASH_EQ] = ACTIONS(6396),
    [anon_sym_LT_LT_EQ] = ACTIONS(6396),
    [anon_sym_GT_GT_EQ] = ACTIONS(6396),
    [anon_sym_AMP_EQ] = ACTIONS(6396),
    [anon_sym_CARET_EQ] = ACTIONS(6396),
    [anon_sym_PIPE_EQ] = ACTIONS(6396),
    [anon_sym_AMP] = ACTIONS(6398),
    [anon_sym_PIPE_PIPE] = ACTIONS(6396),
    [anon_sym_AMP_AMP] = ACTIONS(6396),
    [anon_sym_PIPE] = ACTIONS(6398),
    [anon_sym_CARET] = ACTIONS(6398),
    [anon_sym_EQ_EQ] = ACTIONS(6396),
    [anon_sym_BANG_EQ] = ACTIONS(6396),
    [anon_sym_LT] = ACTIONS(6398),
    [anon_sym_GT] = ACTIONS(6398),
    [anon_sym_LT_EQ] = ACTIONS(6396),
    [anon_sym_GT_EQ] = ACTIONS(6396),
    [anon_sym_LT_LT] = ACTIONS(6398),
    [anon_sym_GT_GT] = ACTIONS(6398),
    [anon_sym_PLUS] = ACTIONS(6398),
    [anon_sym_DASH] = ACTIONS(6398),
    [anon_sym_SLASH] = ACTIONS(6398),
    [anon_sym_PERCENT] = ACTIONS(6398),
    [anon_sym_DASH_DASH] = ACTIONS(6396),
    [anon_sym_PLUS_PLUS] = ACTIONS(6396),
    [anon_sym_DOT] = ACTIONS(6396),
    [anon_sym_DASH_GT] = ACTIONS(6396),
    [sym_comment] = ACTIONS(91),
  },
  [3142] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(6404),
    [anon_sym_RBRACE] = ACTIONS(6404),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(6406),
    [anon_sym_QMARK] = ACTIONS(6404),
    [anon_sym_STAR_EQ] = ACTIONS(6404),
    [anon_sym_SLASH_EQ] = ACTIONS(6404),
    [anon_sym_PERCENT_EQ] = ACTIONS(6404),
    [anon_sym_PLUS_EQ] = ACTIONS(6404),
    [anon_sym_DASH_EQ] = ACTIONS(6404),
    [anon_sym_LT_LT_EQ] = ACTIONS(6404),
    [anon_sym_GT_GT_EQ] = ACTIONS(6404),
    [anon_sym_AMP_EQ] = ACTIONS(6404),
    [anon_sym_CARET_EQ] = ACTIONS(6404),
    [anon_sym_PIPE_EQ] = ACTIONS(6404),
    [anon_sym_AMP] = ACTIONS(2959),
    [anon_sym_PIPE_PIPE] = ACTIONS(2961),
    [anon_sym_AMP_AMP] = ACTIONS(2963),
    [anon_sym_PIPE] = ACTIONS(2965),
    [anon_sym_CARET] = ACTIONS(2967),
    [anon_sym_EQ_EQ] = ACTIONS(2969),
    [anon_sym_BANG_EQ] = ACTIONS(2969),
    [anon_sym_LT] = ACTIONS(2971),
    [anon_sym_GT] = ACTIONS(2971),
    [anon_sym_LT_EQ] = ACTIONS(2973),
    [anon_sym_GT_EQ] = ACTIONS(2973),
    [anon_sym_LT_LT] = ACTIONS(2975),
    [anon_sym_GT_GT] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_SLASH] = ACTIONS(2951),
    [anon_sym_PERCENT] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3143] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(6579),
    [anon_sym_RBRACE] = ACTIONS(6579),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2953),
    [anon_sym_QMARK] = ACTIONS(2955),
    [anon_sym_STAR_EQ] = ACTIONS(2957),
    [anon_sym_SLASH_EQ] = ACTIONS(2957),
    [anon_sym_PERCENT_EQ] = ACTIONS(2957),
    [anon_sym_PLUS_EQ] = ACTIONS(2957),
    [anon_sym_DASH_EQ] = ACTIONS(2957),
    [anon_sym_LT_LT_EQ] = ACTIONS(2957),
    [anon_sym_GT_GT_EQ] = ACTIONS(2957),
    [anon_sym_AMP_EQ] = ACTIONS(2957),
    [anon_sym_CARET_EQ] = ACTIONS(2957),
    [anon_sym_PIPE_EQ] = ACTIONS(2957),
    [anon_sym_AMP] = ACTIONS(2959),
    [anon_sym_PIPE_PIPE] = ACTIONS(2961),
    [anon_sym_AMP_AMP] = ACTIONS(2963),
    [anon_sym_PIPE] = ACTIONS(2965),
    [anon_sym_CARET] = ACTIONS(2967),
    [anon_sym_EQ_EQ] = ACTIONS(2969),
    [anon_sym_BANG_EQ] = ACTIONS(2969),
    [anon_sym_LT] = ACTIONS(2971),
    [anon_sym_GT] = ACTIONS(2971),
    [anon_sym_LT_EQ] = ACTIONS(2973),
    [anon_sym_GT_EQ] = ACTIONS(2973),
    [anon_sym_LT_LT] = ACTIONS(2975),
    [anon_sym_GT_GT] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_SLASH] = ACTIONS(2951),
    [anon_sym_PERCENT] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3144] = {
    [anon_sym_COMMA] = ACTIONS(6191),
    [anon_sym_LPAREN2] = ACTIONS(6191),
    [anon_sym_STAR] = ACTIONS(6193),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_STAR_EQ] = ACTIONS(6191),
    [anon_sym_SLASH_EQ] = ACTIONS(6191),
    [anon_sym_PERCENT_EQ] = ACTIONS(6191),
    [anon_sym_PLUS_EQ] = ACTIONS(6191),
    [anon_sym_DASH_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT_EQ] = ACTIONS(6191),
    [anon_sym_GT_GT_EQ] = ACTIONS(6191),
    [anon_sym_AMP_EQ] = ACTIONS(6191),
    [anon_sym_CARET_EQ] = ACTIONS(6191),
    [anon_sym_PIPE_EQ] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6193),
    [anon_sym_PIPE_PIPE] = ACTIONS(6191),
    [anon_sym_AMP_AMP] = ACTIONS(6191),
    [anon_sym_PIPE] = ACTIONS(6193),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_EQ_EQ] = ACTIONS(6191),
    [anon_sym_BANG_EQ] = ACTIONS(6191),
    [anon_sym_LT] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6193),
    [anon_sym_LT_EQ] = ACTIONS(6191),
    [anon_sym_GT_EQ] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_PLUS] = ACTIONS(6193),
    [anon_sym_DASH] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6193),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [anon_sym_DASH_DASH] = ACTIONS(6191),
    [anon_sym_PLUS_PLUS] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6191),
    [anon_sym_DASH_GT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(6191),
  },
  [3145] = {
    [sym__expression] = STATE(2126),
    [sym_conditional_expression] = STATE(2126),
    [sym_assignment_expression] = STATE(2126),
    [sym_pointer_expression] = STATE(2126),
    [sym_logical_expression] = STATE(2126),
    [sym_bitwise_expression] = STATE(2126),
    [sym_equality_expression] = STATE(2126),
    [sym_relational_expression] = STATE(2126),
    [sym_shift_expression] = STATE(2126),
    [sym_math_expression] = STATE(2126),
    [sym_cast_expression] = STATE(2126),
    [sym_sizeof_expression] = STATE(2126),
    [sym_subscript_expression] = STATE(2126),
    [sym_call_expression] = STATE(2126),
    [sym_field_expression] = STATE(2126),
    [sym_compound_literal_expression] = STATE(2126),
    [sym_parenthesized_expression] = STATE(2126),
    [sym_initializer_list] = STATE(2127),
    [sym_initializer_pair] = STATE(2127),
    [sym_subscript_designator] = STATE(728),
    [sym_field_designator] = STATE(728),
    [sym_char_literal] = STATE(2126),
    [sym_concatenated_string] = STATE(2126),
    [sym_string_literal] = STATE(727),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(2126),
    [sym_new_expression] = STATE(2126),
    [sym_delete_expression] = STATE(2126),
    [sym_lambda_expression] = STATE(2126),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [aux_sym_initializer_pair_repeat1] = STATE(728),
    [sym_raw_string_literal] = ACTIONS(4604),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_RBRACE] = ACTIONS(7602),
    [anon_sym_LPAREN2] = ACTIONS(1256),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_LBRACK] = ACTIONS(1260),
    [anon_sym_AMP] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(1262),
    [anon_sym_TILDE] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_DASH_DASH] = ACTIONS(1268),
    [anon_sym_PLUS_PLUS] = ACTIONS(1268),
    [anon_sym_sizeof] = ACTIONS(1270),
    [anon_sym_DOT] = ACTIONS(1272),
    [sym_number_literal] = ACTIONS(4604),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4608),
    [sym_false] = ACTIONS(4608),
    [sym_null] = ACTIONS(4608),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1276),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1280),
    [sym_nullptr] = ACTIONS(4608),
  },
  [3146] = {
    [anon_sym_COMMA] = ACTIONS(6284),
    [anon_sym_LBRACE] = ACTIONS(6284),
    [anon_sym_LPAREN2] = ACTIONS(6284),
    [anon_sym_STAR] = ACTIONS(6286),
    [anon_sym_LBRACK] = ACTIONS(6284),
    [anon_sym_EQ] = ACTIONS(6286),
    [anon_sym_COLON] = ACTIONS(6286),
    [anon_sym_QMARK] = ACTIONS(6284),
    [anon_sym_STAR_EQ] = ACTIONS(6284),
    [anon_sym_SLASH_EQ] = ACTIONS(6284),
    [anon_sym_PERCENT_EQ] = ACTIONS(6284),
    [anon_sym_PLUS_EQ] = ACTIONS(6284),
    [anon_sym_DASH_EQ] = ACTIONS(6284),
    [anon_sym_LT_LT_EQ] = ACTIONS(6284),
    [anon_sym_GT_GT_EQ] = ACTIONS(6284),
    [anon_sym_AMP_EQ] = ACTIONS(6284),
    [anon_sym_CARET_EQ] = ACTIONS(6284),
    [anon_sym_PIPE_EQ] = ACTIONS(6284),
    [anon_sym_AMP] = ACTIONS(6286),
    [anon_sym_PIPE_PIPE] = ACTIONS(6284),
    [anon_sym_AMP_AMP] = ACTIONS(6284),
    [anon_sym_PIPE] = ACTIONS(6286),
    [anon_sym_CARET] = ACTIONS(6286),
    [anon_sym_EQ_EQ] = ACTIONS(6284),
    [anon_sym_BANG_EQ] = ACTIONS(6284),
    [anon_sym_LT] = ACTIONS(6286),
    [anon_sym_GT] = ACTIONS(6286),
    [anon_sym_LT_EQ] = ACTIONS(6284),
    [anon_sym_GT_EQ] = ACTIONS(6284),
    [anon_sym_LT_LT] = ACTIONS(6286),
    [anon_sym_GT_GT] = ACTIONS(6286),
    [anon_sym_PLUS] = ACTIONS(6286),
    [anon_sym_DASH] = ACTIONS(6286),
    [anon_sym_SLASH] = ACTIONS(6286),
    [anon_sym_PERCENT] = ACTIONS(6286),
    [anon_sym_DASH_DASH] = ACTIONS(6284),
    [anon_sym_PLUS_PLUS] = ACTIONS(6284),
    [anon_sym_DOT] = ACTIONS(6284),
    [anon_sym_DASH_GT] = ACTIONS(6284),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(6284),
    [anon_sym_override] = ACTIONS(6284),
    [anon_sym_GT2] = ACTIONS(6284),
    [anon_sym_COLON_COLON] = ACTIONS(6284),
  },
  [3147] = {
    [anon_sym_COMMA] = ACTIONS(6291),
    [anon_sym_LBRACE] = ACTIONS(6291),
    [anon_sym_LPAREN2] = ACTIONS(6291),
    [anon_sym_STAR] = ACTIONS(6293),
    [anon_sym_LBRACK] = ACTIONS(6291),
    [anon_sym_EQ] = ACTIONS(6293),
    [anon_sym_COLON] = ACTIONS(6293),
    [anon_sym_QMARK] = ACTIONS(6291),
    [anon_sym_STAR_EQ] = ACTIONS(6291),
    [anon_sym_SLASH_EQ] = ACTIONS(6291),
    [anon_sym_PERCENT_EQ] = ACTIONS(6291),
    [anon_sym_PLUS_EQ] = ACTIONS(6291),
    [anon_sym_DASH_EQ] = ACTIONS(6291),
    [anon_sym_LT_LT_EQ] = ACTIONS(6291),
    [anon_sym_GT_GT_EQ] = ACTIONS(6291),
    [anon_sym_AMP_EQ] = ACTIONS(6291),
    [anon_sym_CARET_EQ] = ACTIONS(6291),
    [anon_sym_PIPE_EQ] = ACTIONS(6291),
    [anon_sym_AMP] = ACTIONS(6293),
    [anon_sym_PIPE_PIPE] = ACTIONS(6291),
    [anon_sym_AMP_AMP] = ACTIONS(6291),
    [anon_sym_PIPE] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [anon_sym_EQ_EQ] = ACTIONS(6291),
    [anon_sym_BANG_EQ] = ACTIONS(6291),
    [anon_sym_LT] = ACTIONS(6293),
    [anon_sym_GT] = ACTIONS(6293),
    [anon_sym_LT_EQ] = ACTIONS(6291),
    [anon_sym_GT_EQ] = ACTIONS(6291),
    [anon_sym_LT_LT] = ACTIONS(6293),
    [anon_sym_GT_GT] = ACTIONS(6293),
    [anon_sym_PLUS] = ACTIONS(6293),
    [anon_sym_DASH] = ACTIONS(6293),
    [anon_sym_SLASH] = ACTIONS(6293),
    [anon_sym_PERCENT] = ACTIONS(6293),
    [anon_sym_DASH_DASH] = ACTIONS(6291),
    [anon_sym_PLUS_PLUS] = ACTIONS(6291),
    [anon_sym_DOT] = ACTIONS(6291),
    [anon_sym_DASH_GT] = ACTIONS(6291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(6291),
    [anon_sym_override] = ACTIONS(6291),
    [anon_sym_GT2] = ACTIONS(6291),
    [anon_sym_COLON_COLON] = ACTIONS(6291),
  },
  [3148] = {
    [anon_sym_COMMA] = ACTIONS(4213),
    [anon_sym_LBRACE] = ACTIONS(4213),
    [anon_sym_LPAREN2] = ACTIONS(4213),
    [anon_sym_STAR] = ACTIONS(4215),
    [anon_sym_LBRACK] = ACTIONS(4213),
    [anon_sym_EQ] = ACTIONS(4215),
    [anon_sym_QMARK] = ACTIONS(4213),
    [anon_sym_STAR_EQ] = ACTIONS(4213),
    [anon_sym_SLASH_EQ] = ACTIONS(4213),
    [anon_sym_PERCENT_EQ] = ACTIONS(4213),
    [anon_sym_PLUS_EQ] = ACTIONS(4213),
    [anon_sym_DASH_EQ] = ACTIONS(4213),
    [anon_sym_LT_LT_EQ] = ACTIONS(4213),
    [anon_sym_GT_GT_EQ] = ACTIONS(4213),
    [anon_sym_AMP_EQ] = ACTIONS(4213),
    [anon_sym_CARET_EQ] = ACTIONS(4213),
    [anon_sym_PIPE_EQ] = ACTIONS(4213),
    [anon_sym_AMP] = ACTIONS(4215),
    [anon_sym_PIPE_PIPE] = ACTIONS(4213),
    [anon_sym_AMP_AMP] = ACTIONS(4213),
    [anon_sym_PIPE] = ACTIONS(4215),
    [anon_sym_CARET] = ACTIONS(4215),
    [anon_sym_EQ_EQ] = ACTIONS(4213),
    [anon_sym_BANG_EQ] = ACTIONS(4213),
    [anon_sym_LT] = ACTIONS(4215),
    [anon_sym_GT] = ACTIONS(4215),
    [anon_sym_LT_EQ] = ACTIONS(4213),
    [anon_sym_GT_EQ] = ACTIONS(4213),
    [anon_sym_LT_LT] = ACTIONS(4215),
    [anon_sym_GT_GT] = ACTIONS(4215),
    [anon_sym_PLUS] = ACTIONS(4215),
    [anon_sym_DASH] = ACTIONS(4215),
    [anon_sym_SLASH] = ACTIONS(4215),
    [anon_sym_PERCENT] = ACTIONS(4215),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_DOT] = ACTIONS(4213),
    [anon_sym_DASH_GT] = ACTIONS(4213),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(4213),
  },
  [3149] = {
    [sym_enumerator] = STATE(1988),
    [anon_sym_RBRACE] = ACTIONS(7604),
    [sym_identifier] = ACTIONS(1009),
    [sym_comment] = ACTIONS(91),
  },
  [3150] = {
    [aux_sym_enumerator_list_repeat1] = STATE(1990),
    [anon_sym_COMMA] = ACTIONS(7606),
    [anon_sym_RBRACE] = ACTIONS(7604),
    [sym_comment] = ACTIONS(91),
  },
  [3151] = {
    [anon_sym_COMMA] = ACTIONS(4307),
    [anon_sym_LBRACE] = ACTIONS(4307),
    [anon_sym_LPAREN2] = ACTIONS(4307),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_LBRACK] = ACTIONS(4307),
    [anon_sym_EQ] = ACTIONS(4309),
    [anon_sym_QMARK] = ACTIONS(4307),
    [anon_sym_STAR_EQ] = ACTIONS(4307),
    [anon_sym_SLASH_EQ] = ACTIONS(4307),
    [anon_sym_PERCENT_EQ] = ACTIONS(4307),
    [anon_sym_PLUS_EQ] = ACTIONS(4307),
    [anon_sym_DASH_EQ] = ACTIONS(4307),
    [anon_sym_LT_LT_EQ] = ACTIONS(4307),
    [anon_sym_GT_GT_EQ] = ACTIONS(4307),
    [anon_sym_AMP_EQ] = ACTIONS(4307),
    [anon_sym_CARET_EQ] = ACTIONS(4307),
    [anon_sym_PIPE_EQ] = ACTIONS(4307),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_PIPE_PIPE] = ACTIONS(4307),
    [anon_sym_AMP_AMP] = ACTIONS(4307),
    [anon_sym_PIPE] = ACTIONS(4309),
    [anon_sym_CARET] = ACTIONS(4309),
    [anon_sym_EQ_EQ] = ACTIONS(4307),
    [anon_sym_BANG_EQ] = ACTIONS(4307),
    [anon_sym_LT] = ACTIONS(4309),
    [anon_sym_GT] = ACTIONS(4309),
    [anon_sym_LT_EQ] = ACTIONS(4307),
    [anon_sym_GT_EQ] = ACTIONS(4307),
    [anon_sym_LT_LT] = ACTIONS(4309),
    [anon_sym_GT_GT] = ACTIONS(4309),
    [anon_sym_PLUS] = ACTIONS(4309),
    [anon_sym_DASH] = ACTIONS(4309),
    [anon_sym_SLASH] = ACTIONS(4309),
    [anon_sym_PERCENT] = ACTIONS(4309),
    [anon_sym_DASH_DASH] = ACTIONS(4307),
    [anon_sym_PLUS_PLUS] = ACTIONS(4307),
    [anon_sym_DOT] = ACTIONS(4307),
    [anon_sym_DASH_GT] = ACTIONS(4307),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(4307),
  },
  [3152] = {
    [anon_sym_COMMA] = ACTIONS(4398),
    [anon_sym_LBRACE] = ACTIONS(4398),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_STAR] = ACTIONS(4400),
    [anon_sym_LBRACK] = ACTIONS(4398),
    [anon_sym_EQ] = ACTIONS(4400),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_STAR_EQ] = ACTIONS(4398),
    [anon_sym_SLASH_EQ] = ACTIONS(4398),
    [anon_sym_PERCENT_EQ] = ACTIONS(4398),
    [anon_sym_PLUS_EQ] = ACTIONS(4398),
    [anon_sym_DASH_EQ] = ACTIONS(4398),
    [anon_sym_LT_LT_EQ] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(4398),
    [anon_sym_AMP_EQ] = ACTIONS(4398),
    [anon_sym_CARET_EQ] = ACTIONS(4398),
    [anon_sym_PIPE_EQ] = ACTIONS(4398),
    [anon_sym_AMP] = ACTIONS(4400),
    [anon_sym_PIPE_PIPE] = ACTIONS(4398),
    [anon_sym_AMP_AMP] = ACTIONS(4398),
    [anon_sym_PIPE] = ACTIONS(4400),
    [anon_sym_CARET] = ACTIONS(4400),
    [anon_sym_EQ_EQ] = ACTIONS(4398),
    [anon_sym_BANG_EQ] = ACTIONS(4398),
    [anon_sym_LT] = ACTIONS(4400),
    [anon_sym_GT] = ACTIONS(4400),
    [anon_sym_LT_EQ] = ACTIONS(4398),
    [anon_sym_GT_EQ] = ACTIONS(4398),
    [anon_sym_LT_LT] = ACTIONS(4400),
    [anon_sym_GT_GT] = ACTIONS(4400),
    [anon_sym_PLUS] = ACTIONS(4400),
    [anon_sym_DASH] = ACTIONS(4400),
    [anon_sym_SLASH] = ACTIONS(4400),
    [anon_sym_PERCENT] = ACTIONS(4400),
    [anon_sym_DASH_DASH] = ACTIONS(4398),
    [anon_sym_PLUS_PLUS] = ACTIONS(4398),
    [anon_sym_DOT] = ACTIONS(4398),
    [anon_sym_DASH_GT] = ACTIONS(4398),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(4398),
  },
  [3153] = {
    [sym_field_declaration_list] = STATE(3388),
    [anon_sym_LBRACE] = ACTIONS(4735),
    [sym_comment] = ACTIONS(91),
  },
  [3154] = {
    [anon_sym_COMMA] = ACTIONS(4402),
    [anon_sym_LBRACE] = ACTIONS(4402),
    [anon_sym_LPAREN2] = ACTIONS(4402),
    [anon_sym_STAR] = ACTIONS(4404),
    [anon_sym_LBRACK] = ACTIONS(4402),
    [anon_sym_EQ] = ACTIONS(4404),
    [anon_sym_QMARK] = ACTIONS(4402),
    [anon_sym_STAR_EQ] = ACTIONS(4402),
    [anon_sym_SLASH_EQ] = ACTIONS(4402),
    [anon_sym_PERCENT_EQ] = ACTIONS(4402),
    [anon_sym_PLUS_EQ] = ACTIONS(4402),
    [anon_sym_DASH_EQ] = ACTIONS(4402),
    [anon_sym_LT_LT_EQ] = ACTIONS(4402),
    [anon_sym_GT_GT_EQ] = ACTIONS(4402),
    [anon_sym_AMP_EQ] = ACTIONS(4402),
    [anon_sym_CARET_EQ] = ACTIONS(4402),
    [anon_sym_PIPE_EQ] = ACTIONS(4402),
    [anon_sym_AMP] = ACTIONS(4404),
    [anon_sym_PIPE_PIPE] = ACTIONS(4402),
    [anon_sym_AMP_AMP] = ACTIONS(4402),
    [anon_sym_PIPE] = ACTIONS(4404),
    [anon_sym_CARET] = ACTIONS(4404),
    [anon_sym_EQ_EQ] = ACTIONS(4402),
    [anon_sym_BANG_EQ] = ACTIONS(4402),
    [anon_sym_LT] = ACTIONS(4404),
    [anon_sym_GT] = ACTIONS(4404),
    [anon_sym_LT_EQ] = ACTIONS(4402),
    [anon_sym_GT_EQ] = ACTIONS(4402),
    [anon_sym_LT_LT] = ACTIONS(4404),
    [anon_sym_GT_GT] = ACTIONS(4404),
    [anon_sym_PLUS] = ACTIONS(4404),
    [anon_sym_DASH] = ACTIONS(4404),
    [anon_sym_SLASH] = ACTIONS(4404),
    [anon_sym_PERCENT] = ACTIONS(4404),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_DOT] = ACTIONS(4402),
    [anon_sym_DASH_GT] = ACTIONS(4402),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(4402),
  },
  [3155] = {
    [sym_field_declaration_list] = STATE(3389),
    [anon_sym_LBRACE] = ACTIONS(4735),
    [sym_comment] = ACTIONS(91),
  },
  [3156] = {
    [anon_sym_COMMA] = ACTIONS(4406),
    [anon_sym_LBRACE] = ACTIONS(4406),
    [anon_sym_LPAREN2] = ACTIONS(4406),
    [anon_sym_STAR] = ACTIONS(4408),
    [anon_sym_LBRACK] = ACTIONS(4406),
    [anon_sym_EQ] = ACTIONS(4408),
    [anon_sym_QMARK] = ACTIONS(4406),
    [anon_sym_STAR_EQ] = ACTIONS(4406),
    [anon_sym_SLASH_EQ] = ACTIONS(4406),
    [anon_sym_PERCENT_EQ] = ACTIONS(4406),
    [anon_sym_PLUS_EQ] = ACTIONS(4406),
    [anon_sym_DASH_EQ] = ACTIONS(4406),
    [anon_sym_LT_LT_EQ] = ACTIONS(4406),
    [anon_sym_GT_GT_EQ] = ACTIONS(4406),
    [anon_sym_AMP_EQ] = ACTIONS(4406),
    [anon_sym_CARET_EQ] = ACTIONS(4406),
    [anon_sym_PIPE_EQ] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_PIPE_PIPE] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_PIPE] = ACTIONS(4408),
    [anon_sym_CARET] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4406),
    [anon_sym_BANG_EQ] = ACTIONS(4406),
    [anon_sym_LT] = ACTIONS(4408),
    [anon_sym_GT] = ACTIONS(4408),
    [anon_sym_LT_EQ] = ACTIONS(4406),
    [anon_sym_GT_EQ] = ACTIONS(4406),
    [anon_sym_LT_LT] = ACTIONS(4408),
    [anon_sym_GT_GT] = ACTIONS(4408),
    [anon_sym_PLUS] = ACTIONS(4408),
    [anon_sym_DASH] = ACTIONS(4408),
    [anon_sym_SLASH] = ACTIONS(4408),
    [anon_sym_PERCENT] = ACTIONS(4408),
    [anon_sym_DASH_DASH] = ACTIONS(4406),
    [anon_sym_PLUS_PLUS] = ACTIONS(4406),
    [anon_sym_DOT] = ACTIONS(4406),
    [anon_sym_DASH_GT] = ACTIONS(4406),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(4406),
  },
  [3157] = {
    [sym_field_declaration_list] = STATE(3390),
    [anon_sym_LBRACE] = ACTIONS(4735),
    [sym_comment] = ACTIONS(91),
  },
  [3158] = {
    [anon_sym_COMMA] = ACTIONS(4410),
    [anon_sym_LBRACE] = ACTIONS(4410),
    [anon_sym_LPAREN2] = ACTIONS(4410),
    [anon_sym_STAR] = ACTIONS(4412),
    [anon_sym_LBRACK] = ACTIONS(4410),
    [anon_sym_EQ] = ACTIONS(4412),
    [anon_sym_QMARK] = ACTIONS(4410),
    [anon_sym_STAR_EQ] = ACTIONS(4410),
    [anon_sym_SLASH_EQ] = ACTIONS(4410),
    [anon_sym_PERCENT_EQ] = ACTIONS(4410),
    [anon_sym_PLUS_EQ] = ACTIONS(4410),
    [anon_sym_DASH_EQ] = ACTIONS(4410),
    [anon_sym_LT_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT_GT_EQ] = ACTIONS(4410),
    [anon_sym_AMP_EQ] = ACTIONS(4410),
    [anon_sym_CARET_EQ] = ACTIONS(4410),
    [anon_sym_PIPE_EQ] = ACTIONS(4410),
    [anon_sym_AMP] = ACTIONS(4412),
    [anon_sym_PIPE_PIPE] = ACTIONS(4410),
    [anon_sym_AMP_AMP] = ACTIONS(4410),
    [anon_sym_PIPE] = ACTIONS(4412),
    [anon_sym_CARET] = ACTIONS(4412),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4410),
    [anon_sym_LT] = ACTIONS(4412),
    [anon_sym_GT] = ACTIONS(4412),
    [anon_sym_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT_EQ] = ACTIONS(4410),
    [anon_sym_LT_LT] = ACTIONS(4412),
    [anon_sym_GT_GT] = ACTIONS(4412),
    [anon_sym_PLUS] = ACTIONS(4412),
    [anon_sym_DASH] = ACTIONS(4412),
    [anon_sym_SLASH] = ACTIONS(4412),
    [anon_sym_PERCENT] = ACTIONS(4412),
    [anon_sym_DASH_DASH] = ACTIONS(4410),
    [anon_sym_PLUS_PLUS] = ACTIONS(4410),
    [anon_sym_DOT] = ACTIONS(4410),
    [anon_sym_DASH_GT] = ACTIONS(4410),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(4410),
  },
  [3159] = {
    [sym_field_declaration_list] = STATE(3391),
    [anon_sym_LBRACE] = ACTIONS(4735),
    [sym_comment] = ACTIONS(91),
  },
  [3160] = {
    [anon_sym_COMMA] = ACTIONS(4864),
    [anon_sym_LBRACE] = ACTIONS(4864),
    [anon_sym_LPAREN2] = ACTIONS(4864),
    [anon_sym_STAR] = ACTIONS(4866),
    [anon_sym_LBRACK] = ACTIONS(4864),
    [anon_sym_EQ] = ACTIONS(4866),
    [anon_sym_QMARK] = ACTIONS(4864),
    [anon_sym_STAR_EQ] = ACTIONS(4864),
    [anon_sym_SLASH_EQ] = ACTIONS(4864),
    [anon_sym_PERCENT_EQ] = ACTIONS(4864),
    [anon_sym_PLUS_EQ] = ACTIONS(4864),
    [anon_sym_DASH_EQ] = ACTIONS(4864),
    [anon_sym_LT_LT_EQ] = ACTIONS(4864),
    [anon_sym_GT_GT_EQ] = ACTIONS(4864),
    [anon_sym_AMP_EQ] = ACTIONS(4864),
    [anon_sym_CARET_EQ] = ACTIONS(4864),
    [anon_sym_PIPE_EQ] = ACTIONS(4864),
    [anon_sym_AMP] = ACTIONS(4866),
    [anon_sym_PIPE_PIPE] = ACTIONS(4864),
    [anon_sym_AMP_AMP] = ACTIONS(4864),
    [anon_sym_PIPE] = ACTIONS(4866),
    [anon_sym_CARET] = ACTIONS(4866),
    [anon_sym_EQ_EQ] = ACTIONS(4864),
    [anon_sym_BANG_EQ] = ACTIONS(4864),
    [anon_sym_LT] = ACTIONS(4866),
    [anon_sym_GT] = ACTIONS(4866),
    [anon_sym_LT_EQ] = ACTIONS(4864),
    [anon_sym_GT_EQ] = ACTIONS(4864),
    [anon_sym_LT_LT] = ACTIONS(4866),
    [anon_sym_GT_GT] = ACTIONS(4866),
    [anon_sym_PLUS] = ACTIONS(4866),
    [anon_sym_DASH] = ACTIONS(4866),
    [anon_sym_SLASH] = ACTIONS(4866),
    [anon_sym_PERCENT] = ACTIONS(4866),
    [anon_sym_DASH_DASH] = ACTIONS(4864),
    [anon_sym_PLUS_PLUS] = ACTIONS(4864),
    [anon_sym_DOT] = ACTIONS(4864),
    [anon_sym_DASH_GT] = ACTIONS(4864),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(4864),
  },
  [3161] = {
    [sym_field_declaration_list] = STATE(3392),
    [anon_sym_LBRACE] = ACTIONS(4735),
    [sym_comment] = ACTIONS(91),
  },
  [3162] = {
    [anon_sym_COMMA] = ACTIONS(4868),
    [anon_sym_LBRACE] = ACTIONS(4868),
    [anon_sym_LPAREN2] = ACTIONS(4868),
    [anon_sym_STAR] = ACTIONS(4870),
    [anon_sym_LBRACK] = ACTIONS(4868),
    [anon_sym_EQ] = ACTIONS(4870),
    [anon_sym_QMARK] = ACTIONS(4868),
    [anon_sym_STAR_EQ] = ACTIONS(4868),
    [anon_sym_SLASH_EQ] = ACTIONS(4868),
    [anon_sym_PERCENT_EQ] = ACTIONS(4868),
    [anon_sym_PLUS_EQ] = ACTIONS(4868),
    [anon_sym_DASH_EQ] = ACTIONS(4868),
    [anon_sym_LT_LT_EQ] = ACTIONS(4868),
    [anon_sym_GT_GT_EQ] = ACTIONS(4868),
    [anon_sym_AMP_EQ] = ACTIONS(4868),
    [anon_sym_CARET_EQ] = ACTIONS(4868),
    [anon_sym_PIPE_EQ] = ACTIONS(4868),
    [anon_sym_AMP] = ACTIONS(4870),
    [anon_sym_PIPE_PIPE] = ACTIONS(4868),
    [anon_sym_AMP_AMP] = ACTIONS(4868),
    [anon_sym_PIPE] = ACTIONS(4870),
    [anon_sym_CARET] = ACTIONS(4870),
    [anon_sym_EQ_EQ] = ACTIONS(4868),
    [anon_sym_BANG_EQ] = ACTIONS(4868),
    [anon_sym_LT] = ACTIONS(4870),
    [anon_sym_GT] = ACTIONS(4870),
    [anon_sym_LT_EQ] = ACTIONS(4868),
    [anon_sym_GT_EQ] = ACTIONS(4868),
    [anon_sym_LT_LT] = ACTIONS(4870),
    [anon_sym_GT_GT] = ACTIONS(4870),
    [anon_sym_PLUS] = ACTIONS(4870),
    [anon_sym_DASH] = ACTIONS(4870),
    [anon_sym_SLASH] = ACTIONS(4870),
    [anon_sym_PERCENT] = ACTIONS(4870),
    [anon_sym_DASH_DASH] = ACTIONS(4868),
    [anon_sym_PLUS_PLUS] = ACTIONS(4868),
    [anon_sym_DOT] = ACTIONS(4868),
    [anon_sym_DASH_GT] = ACTIONS(4868),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(4868),
  },
  [3163] = {
    [sym_field_declaration_list] = STATE(3393),
    [anon_sym_LBRACE] = ACTIONS(4735),
    [sym_comment] = ACTIONS(91),
  },
  [3164] = {
    [sym_new_declarator] = STATE(3394),
    [anon_sym_COMMA] = ACTIONS(6396),
    [anon_sym_LBRACE] = ACTIONS(6396),
    [anon_sym_LPAREN2] = ACTIONS(6396),
    [anon_sym_STAR] = ACTIONS(6398),
    [anon_sym_LBRACK] = ACTIONS(4752),
    [anon_sym_EQ] = ACTIONS(6398),
    [anon_sym_QMARK] = ACTIONS(6396),
    [anon_sym_STAR_EQ] = ACTIONS(6396),
    [anon_sym_SLASH_EQ] = ACTIONS(6396),
    [anon_sym_PERCENT_EQ] = ACTIONS(6396),
    [anon_sym_PLUS_EQ] = ACTIONS(6396),
    [anon_sym_DASH_EQ] = ACTIONS(6396),
    [anon_sym_LT_LT_EQ] = ACTIONS(6396),
    [anon_sym_GT_GT_EQ] = ACTIONS(6396),
    [anon_sym_AMP_EQ] = ACTIONS(6396),
    [anon_sym_CARET_EQ] = ACTIONS(6396),
    [anon_sym_PIPE_EQ] = ACTIONS(6396),
    [anon_sym_AMP] = ACTIONS(6398),
    [anon_sym_PIPE_PIPE] = ACTIONS(6396),
    [anon_sym_AMP_AMP] = ACTIONS(6396),
    [anon_sym_PIPE] = ACTIONS(6398),
    [anon_sym_CARET] = ACTIONS(6398),
    [anon_sym_EQ_EQ] = ACTIONS(6396),
    [anon_sym_BANG_EQ] = ACTIONS(6396),
    [anon_sym_LT] = ACTIONS(6398),
    [anon_sym_GT] = ACTIONS(6398),
    [anon_sym_LT_EQ] = ACTIONS(6396),
    [anon_sym_GT_EQ] = ACTIONS(6396),
    [anon_sym_LT_LT] = ACTIONS(6398),
    [anon_sym_GT_GT] = ACTIONS(6398),
    [anon_sym_PLUS] = ACTIONS(6398),
    [anon_sym_DASH] = ACTIONS(6398),
    [anon_sym_SLASH] = ACTIONS(6398),
    [anon_sym_PERCENT] = ACTIONS(6398),
    [anon_sym_DASH_DASH] = ACTIONS(6396),
    [anon_sym_PLUS_PLUS] = ACTIONS(6396),
    [anon_sym_DOT] = ACTIONS(6396),
    [anon_sym_DASH_GT] = ACTIONS(6396),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(6396),
  },
  [3165] = {
    [anon_sym_COMMA] = ACTIONS(6400),
    [anon_sym_LPAREN2] = ACTIONS(6400),
    [anon_sym_STAR] = ACTIONS(6402),
    [anon_sym_LBRACK] = ACTIONS(6400),
    [anon_sym_EQ] = ACTIONS(6402),
    [anon_sym_QMARK] = ACTIONS(6400),
    [anon_sym_STAR_EQ] = ACTIONS(6400),
    [anon_sym_SLASH_EQ] = ACTIONS(6400),
    [anon_sym_PERCENT_EQ] = ACTIONS(6400),
    [anon_sym_PLUS_EQ] = ACTIONS(6400),
    [anon_sym_DASH_EQ] = ACTIONS(6400),
    [anon_sym_LT_LT_EQ] = ACTIONS(6400),
    [anon_sym_GT_GT_EQ] = ACTIONS(6400),
    [anon_sym_AMP_EQ] = ACTIONS(6400),
    [anon_sym_CARET_EQ] = ACTIONS(6400),
    [anon_sym_PIPE_EQ] = ACTIONS(6400),
    [anon_sym_AMP] = ACTIONS(6402),
    [anon_sym_PIPE_PIPE] = ACTIONS(6400),
    [anon_sym_AMP_AMP] = ACTIONS(6400),
    [anon_sym_PIPE] = ACTIONS(6402),
    [anon_sym_CARET] = ACTIONS(6402),
    [anon_sym_EQ_EQ] = ACTIONS(6400),
    [anon_sym_BANG_EQ] = ACTIONS(6400),
    [anon_sym_LT] = ACTIONS(6402),
    [anon_sym_GT] = ACTIONS(6402),
    [anon_sym_LT_EQ] = ACTIONS(6400),
    [anon_sym_GT_EQ] = ACTIONS(6400),
    [anon_sym_LT_LT] = ACTIONS(6402),
    [anon_sym_GT_GT] = ACTIONS(6402),
    [anon_sym_PLUS] = ACTIONS(6402),
    [anon_sym_DASH] = ACTIONS(6402),
    [anon_sym_SLASH] = ACTIONS(6402),
    [anon_sym_PERCENT] = ACTIONS(6402),
    [anon_sym_DASH_DASH] = ACTIONS(6400),
    [anon_sym_PLUS_PLUS] = ACTIONS(6400),
    [anon_sym_DOT] = ACTIONS(6400),
    [anon_sym_DASH_GT] = ACTIONS(6400),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(6400),
  },
  [3166] = {
    [sym_argument_list] = STATE(1511),
    [anon_sym_COMMA] = ACTIONS(6404),
    [anon_sym_LPAREN2] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_EQ] = ACTIONS(6406),
    [anon_sym_QMARK] = ACTIONS(6404),
    [anon_sym_STAR_EQ] = ACTIONS(6404),
    [anon_sym_SLASH_EQ] = ACTIONS(6404),
    [anon_sym_PERCENT_EQ] = ACTIONS(6404),
    [anon_sym_PLUS_EQ] = ACTIONS(6404),
    [anon_sym_DASH_EQ] = ACTIONS(6404),
    [anon_sym_LT_LT_EQ] = ACTIONS(6404),
    [anon_sym_GT_GT_EQ] = ACTIONS(6404),
    [anon_sym_AMP_EQ] = ACTIONS(6404),
    [anon_sym_CARET_EQ] = ACTIONS(6404),
    [anon_sym_PIPE_EQ] = ACTIONS(6404),
    [anon_sym_AMP] = ACTIONS(3177),
    [anon_sym_PIPE_PIPE] = ACTIONS(3179),
    [anon_sym_AMP_AMP] = ACTIONS(3181),
    [anon_sym_PIPE] = ACTIONS(3183),
    [anon_sym_CARET] = ACTIONS(3185),
    [anon_sym_EQ_EQ] = ACTIONS(3187),
    [anon_sym_BANG_EQ] = ACTIONS(3187),
    [anon_sym_LT] = ACTIONS(3189),
    [anon_sym_GT] = ACTIONS(3189),
    [anon_sym_LT_EQ] = ACTIONS(3191),
    [anon_sym_GT_EQ] = ACTIONS(3191),
    [anon_sym_LT_LT] = ACTIONS(3193),
    [anon_sym_GT_GT] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_SLASH] = ACTIONS(3167),
    [anon_sym_PERCENT] = ACTIONS(3167),
    [anon_sym_DASH_DASH] = ACTIONS(3197),
    [anon_sym_PLUS_PLUS] = ACTIONS(3197),
    [anon_sym_DOT] = ACTIONS(3199),
    [anon_sym_DASH_GT] = ACTIONS(3199),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(6404),
  },
  [3167] = {
    [sym_parameter_list] = STATE(2210),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(6557),
  },
  [3168] = {
    [anon_sym_COMMA] = ACTIONS(6385),
    [anon_sym_LPAREN2] = ACTIONS(6385),
    [anon_sym_STAR] = ACTIONS(6387),
    [anon_sym_LBRACK] = ACTIONS(6385),
    [anon_sym_EQ] = ACTIONS(6387),
    [anon_sym_QMARK] = ACTIONS(6385),
    [anon_sym_STAR_EQ] = ACTIONS(6385),
    [anon_sym_SLASH_EQ] = ACTIONS(6385),
    [anon_sym_PERCENT_EQ] = ACTIONS(6385),
    [anon_sym_PLUS_EQ] = ACTIONS(6385),
    [anon_sym_DASH_EQ] = ACTIONS(6385),
    [anon_sym_LT_LT_EQ] = ACTIONS(6385),
    [anon_sym_GT_GT_EQ] = ACTIONS(6385),
    [anon_sym_AMP_EQ] = ACTIONS(6385),
    [anon_sym_CARET_EQ] = ACTIONS(6385),
    [anon_sym_PIPE_EQ] = ACTIONS(6385),
    [anon_sym_AMP] = ACTIONS(6387),
    [anon_sym_PIPE_PIPE] = ACTIONS(6385),
    [anon_sym_AMP_AMP] = ACTIONS(6385),
    [anon_sym_PIPE] = ACTIONS(6387),
    [anon_sym_CARET] = ACTIONS(6387),
    [anon_sym_EQ_EQ] = ACTIONS(6385),
    [anon_sym_BANG_EQ] = ACTIONS(6385),
    [anon_sym_LT] = ACTIONS(6387),
    [anon_sym_GT] = ACTIONS(6387),
    [anon_sym_LT_EQ] = ACTIONS(6385),
    [anon_sym_GT_EQ] = ACTIONS(6385),
    [anon_sym_LT_LT] = ACTIONS(6387),
    [anon_sym_GT_GT] = ACTIONS(6387),
    [anon_sym_PLUS] = ACTIONS(6387),
    [anon_sym_DASH] = ACTIONS(6387),
    [anon_sym_SLASH] = ACTIONS(6387),
    [anon_sym_PERCENT] = ACTIONS(6387),
    [anon_sym_DASH_DASH] = ACTIONS(6385),
    [anon_sym_PLUS_PLUS] = ACTIONS(6385),
    [anon_sym_DOT] = ACTIONS(6385),
    [anon_sym_DASH_GT] = ACTIONS(6385),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(6385),
  },
  [3169] = {
    [sym_argument_list] = STATE(1511),
    [anon_sym_COMMA] = ACTIONS(6579),
    [anon_sym_LPAREN2] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_EQ] = ACTIONS(3171),
    [anon_sym_QMARK] = ACTIONS(3173),
    [anon_sym_STAR_EQ] = ACTIONS(3175),
    [anon_sym_SLASH_EQ] = ACTIONS(3175),
    [anon_sym_PERCENT_EQ] = ACTIONS(3175),
    [anon_sym_PLUS_EQ] = ACTIONS(3175),
    [anon_sym_DASH_EQ] = ACTIONS(3175),
    [anon_sym_LT_LT_EQ] = ACTIONS(3175),
    [anon_sym_GT_GT_EQ] = ACTIONS(3175),
    [anon_sym_AMP_EQ] = ACTIONS(3175),
    [anon_sym_CARET_EQ] = ACTIONS(3175),
    [anon_sym_PIPE_EQ] = ACTIONS(3175),
    [anon_sym_AMP] = ACTIONS(3177),
    [anon_sym_PIPE_PIPE] = ACTIONS(3179),
    [anon_sym_AMP_AMP] = ACTIONS(3181),
    [anon_sym_PIPE] = ACTIONS(3183),
    [anon_sym_CARET] = ACTIONS(3185),
    [anon_sym_EQ_EQ] = ACTIONS(3187),
    [anon_sym_BANG_EQ] = ACTIONS(3187),
    [anon_sym_LT] = ACTIONS(3189),
    [anon_sym_GT] = ACTIONS(3189),
    [anon_sym_LT_EQ] = ACTIONS(3191),
    [anon_sym_GT_EQ] = ACTIONS(3191),
    [anon_sym_LT_LT] = ACTIONS(3193),
    [anon_sym_GT_GT] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_SLASH] = ACTIONS(3167),
    [anon_sym_PERCENT] = ACTIONS(3167),
    [anon_sym_DASH_DASH] = ACTIONS(3197),
    [anon_sym_PLUS_PLUS] = ACTIONS(3197),
    [anon_sym_DOT] = ACTIONS(3199),
    [anon_sym_DASH_GT] = ACTIONS(3199),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(6579),
  },
  [3170] = {
    [anon_sym_COMMA] = ACTIONS(2286),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_STAR] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2286),
    [anon_sym_EQ] = ACTIONS(2288),
    [anon_sym_QMARK] = ACTIONS(2286),
    [anon_sym_STAR_EQ] = ACTIONS(2286),
    [anon_sym_SLASH_EQ] = ACTIONS(2286),
    [anon_sym_PERCENT_EQ] = ACTIONS(2286),
    [anon_sym_PLUS_EQ] = ACTIONS(2286),
    [anon_sym_DASH_EQ] = ACTIONS(2286),
    [anon_sym_LT_LT_EQ] = ACTIONS(2286),
    [anon_sym_GT_GT_EQ] = ACTIONS(2286),
    [anon_sym_AMP_EQ] = ACTIONS(2286),
    [anon_sym_CARET_EQ] = ACTIONS(2286),
    [anon_sym_PIPE_EQ] = ACTIONS(2286),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_PIPE_PIPE] = ACTIONS(2286),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2288),
    [anon_sym_CARET] = ACTIONS(2288),
    [anon_sym_EQ_EQ] = ACTIONS(2286),
    [anon_sym_BANG_EQ] = ACTIONS(2286),
    [anon_sym_LT] = ACTIONS(2288),
    [anon_sym_GT] = ACTIONS(2288),
    [anon_sym_LT_EQ] = ACTIONS(2286),
    [anon_sym_GT_EQ] = ACTIONS(2286),
    [anon_sym_LT_LT] = ACTIONS(2288),
    [anon_sym_GT_GT] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_PERCENT] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_DOT] = ACTIONS(2286),
    [anon_sym_DASH_GT] = ACTIONS(2286),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(2286),
  },
  [3171] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3171),
    [anon_sym_COMMA] = ACTIONS(1985),
    [anon_sym_unsigned] = ACTIONS(7608),
    [anon_sym_long] = ACTIONS(7608),
    [anon_sym_short] = ACTIONS(7608),
    [sym_primitive_type] = ACTIONS(1987),
    [sym_identifier] = ACTIONS(1987),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(1985),
  },
  [3172] = {
    [sym_type_qualifier] = STATE(3172),
    [aux_sym_type_definition_repeat1] = STATE(3172),
    [anon_sym_RPAREN] = ACTIONS(2179),
    [anon_sym_LPAREN2] = ACTIONS(2179),
    [anon_sym_STAR] = ACTIONS(2179),
    [anon_sym_LBRACK] = ACTIONS(2179),
    [anon_sym_const] = ACTIONS(2538),
    [anon_sym_restrict] = ACTIONS(2538),
    [anon_sym_volatile] = ACTIONS(2538),
    [anon_sym__Atomic] = ACTIONS(2538),
    [anon_sym_mutable] = ACTIONS(2538),
    [anon_sym_explicit] = ACTIONS(2538),
    [anon_sym_constexpr] = ACTIONS(2538),
    [anon_sym_AMP] = ACTIONS(2177),
    [anon_sym_AMP_AMP] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2179),
    [sym_identifier] = ACTIONS(2177),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(2179),
    [sym_operator_name] = ACTIONS(2179),
  },
  [3173] = {
    [sym__type_specifier] = STATE(271),
    [sym_sized_type_specifier] = STATE(271),
    [sym_enum_specifier] = STATE(271),
    [sym_struct_specifier] = STATE(271),
    [sym_union_specifier] = STATE(271),
    [sym_macro_type_specifier] = STATE(271),
    [sym_class_specifier] = STATE(271),
    [sym_dependent_type] = STATE(271),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3175),
    [anon_sym_unsigned] = ACTIONS(7166),
    [anon_sym_long] = ACTIONS(7166),
    [anon_sym_short] = ACTIONS(7166),
    [sym_primitive_type] = ACTIONS(490),
    [anon_sym_enum] = ACTIONS(3675),
    [anon_sym_struct] = ACTIONS(5103),
    [anon_sym_union] = ACTIONS(5105),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5107),
    [sym_auto] = ACTIONS(490),
    [anon_sym_typename] = ACTIONS(7170),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [3174] = {
    [sym__abstract_declarator] = STATE(3397),
    [sym_abstract_pointer_declarator] = STATE(3397),
    [sym_abstract_function_declarator] = STATE(3397),
    [sym_abstract_array_declarator] = STATE(3397),
    [sym_parameter_list] = STATE(3398),
    [sym_abstract_reference_declarator] = STATE(3397),
    [anon_sym_COMMA] = ACTIONS(5222),
    [anon_sym_LBRACE] = ACTIONS(5222),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(7611),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_EQ] = ACTIONS(5222),
    [anon_sym_const] = ACTIONS(5226),
    [anon_sym_restrict] = ACTIONS(5222),
    [anon_sym_volatile] = ACTIONS(5222),
    [anon_sym__Atomic] = ACTIONS(5222),
    [anon_sym_mutable] = ACTIONS(5222),
    [anon_sym_explicit] = ACTIONS(5222),
    [anon_sym_constexpr] = ACTIONS(5222),
    [anon_sym_AMP] = ACTIONS(7613),
    [anon_sym_AMP_AMP] = ACTIONS(7615),
    [anon_sym_DASH_GT] = ACTIONS(5222),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5222),
    [anon_sym_override] = ACTIONS(5222),
    [anon_sym_GT2] = ACTIONS(5222),
    [sym_noexcept] = ACTIONS(5222),
  },
  [3175] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3399),
    [anon_sym_COMMA] = ACTIONS(653),
    [anon_sym_LBRACE] = ACTIONS(653),
    [anon_sym_LPAREN2] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_EQ] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(655),
    [anon_sym_restrict] = ACTIONS(655),
    [anon_sym_volatile] = ACTIONS(655),
    [anon_sym__Atomic] = ACTIONS(655),
    [anon_sym_mutable] = ACTIONS(655),
    [anon_sym_explicit] = ACTIONS(655),
    [anon_sym_constexpr] = ACTIONS(655),
    [anon_sym_unsigned] = ACTIONS(7617),
    [anon_sym_long] = ACTIONS(7617),
    [anon_sym_short] = ACTIONS(7617),
    [sym_primitive_type] = ACTIONS(659),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [anon_sym_DASH_GT] = ACTIONS(653),
    [sym_identifier] = ACTIONS(933),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(655),
    [anon_sym_override] = ACTIONS(655),
    [anon_sym_GT2] = ACTIONS(653),
    [sym_noexcept] = ACTIONS(655),
  },
  [3176] = {
    [sym_type_qualifier] = STATE(3176),
    [sym_virtual_specifier] = STATE(3176),
    [sym_trailing_return_type] = STATE(3176),
    [aux_sym_function_declarator_repeat1] = STATE(3176),
    [anon_sym_COMMA] = ACTIONS(5236),
    [anon_sym_LBRACE] = ACTIONS(5236),
    [anon_sym_LPAREN2] = ACTIONS(5236),
    [anon_sym_LBRACK] = ACTIONS(5236),
    [anon_sym_EQ] = ACTIONS(5236),
    [anon_sym_const] = ACTIONS(5877),
    [anon_sym_restrict] = ACTIONS(5880),
    [anon_sym_volatile] = ACTIONS(5880),
    [anon_sym__Atomic] = ACTIONS(5880),
    [anon_sym_mutable] = ACTIONS(5880),
    [anon_sym_explicit] = ACTIONS(5880),
    [anon_sym_constexpr] = ACTIONS(5880),
    [anon_sym_DASH_GT] = ACTIONS(7619),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5247),
    [anon_sym_override] = ACTIONS(5247),
    [anon_sym_GT2] = ACTIONS(5236),
    [sym_noexcept] = ACTIONS(7622),
  },
  [3177] = {
    [sym_parameter_list] = STATE(3180),
    [anon_sym_SEMI] = ACTIONS(4157),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_const] = ACTIONS(7279),
    [anon_sym_restrict] = ACTIONS(4157),
    [anon_sym_volatile] = ACTIONS(4157),
    [anon_sym__Atomic] = ACTIONS(4157),
    [anon_sym_mutable] = ACTIONS(4157),
    [anon_sym_explicit] = ACTIONS(4157),
    [anon_sym_constexpr] = ACTIONS(4157),
    [anon_sym_DASH_GT] = ACTIONS(4157),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4157),
    [anon_sym_override] = ACTIONS(4157),
    [sym_noexcept] = ACTIONS(4157),
  },
  [3178] = {
    [sym__abstract_declarator] = STATE(3400),
    [sym_abstract_pointer_declarator] = STATE(3400),
    [sym_abstract_function_declarator] = STATE(3400),
    [sym_abstract_array_declarator] = STATE(3400),
    [sym_type_qualifier] = STATE(3401),
    [sym_parameter_list] = STATE(2837),
    [sym_abstract_reference_declarator] = STATE(3400),
    [aux_sym_type_definition_repeat1] = STATE(3401),
    [anon_sym_SEMI] = ACTIONS(4157),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(6338),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(6340),
    [anon_sym_AMP_AMP] = ACTIONS(6342),
    [anon_sym_DASH_GT] = ACTIONS(4157),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4157),
    [anon_sym_override] = ACTIONS(4157),
    [sym_noexcept] = ACTIONS(4157),
  },
  [3179] = {
    [sym_parameter_list] = STATE(3180),
    [anon_sym_SEMI] = ACTIONS(4159),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_const] = ACTIONS(7281),
    [anon_sym_restrict] = ACTIONS(4159),
    [anon_sym_volatile] = ACTIONS(4159),
    [anon_sym__Atomic] = ACTIONS(4159),
    [anon_sym_mutable] = ACTIONS(4159),
    [anon_sym_explicit] = ACTIONS(4159),
    [anon_sym_constexpr] = ACTIONS(4159),
    [anon_sym_DASH_GT] = ACTIONS(4159),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4159),
    [anon_sym_override] = ACTIONS(4159),
    [sym_noexcept] = ACTIONS(4159),
  },
  [3180] = {
    [sym_type_qualifier] = STATE(3402),
    [sym_trailing_return_type] = STATE(1720),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3402),
    [anon_sym_SEMI] = ACTIONS(3663),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_const] = ACTIONS(3685),
    [anon_sym_restrict] = ACTIONS(3663),
    [anon_sym_volatile] = ACTIONS(3663),
    [anon_sym__Atomic] = ACTIONS(3663),
    [anon_sym_mutable] = ACTIONS(3663),
    [anon_sym_explicit] = ACTIONS(3663),
    [anon_sym_constexpr] = ACTIONS(3663),
    [anon_sym_DASH_GT] = ACTIONS(3663),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3663),
    [anon_sym_override] = ACTIONS(3663),
    [sym_noexcept] = ACTIONS(3663),
  },
  [3181] = {
    [sym_type_qualifier] = STATE(3403),
    [sym_trailing_return_type] = STATE(1720),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3403),
    [anon_sym_SEMI] = ACTIONS(3663),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(3285),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3663),
    [anon_sym_override] = ACTIONS(3663),
    [sym_noexcept] = ACTIONS(7625),
  },
  [3182] = {
    [anon_sym_LPAREN2] = ACTIONS(7627),
    [anon_sym_constexpr] = ACTIONS(7629),
    [sym_comment] = ACTIONS(91),
  },
  [3183] = {
    [sym_parenthesized_expression] = STATE(3406),
    [anon_sym_LPAREN2] = ACTIONS(323),
    [sym_comment] = ACTIONS(91),
  },
  [3184] = {
    [sym__expression] = STATE(3407),
    [sym_conditional_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3407),
    [sym_pointer_expression] = STATE(3407),
    [sym_logical_expression] = STATE(3407),
    [sym_bitwise_expression] = STATE(3407),
    [sym_equality_expression] = STATE(3407),
    [sym_relational_expression] = STATE(3407),
    [sym_shift_expression] = STATE(3407),
    [sym_math_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_subscript_expression] = STATE(3407),
    [sym_call_expression] = STATE(3407),
    [sym_field_expression] = STATE(3407),
    [sym_compound_literal_expression] = STATE(3407),
    [sym_parenthesized_expression] = STATE(3407),
    [sym_char_literal] = STATE(3407),
    [sym_concatenated_string] = STATE(3407),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3407),
    [sym_new_expression] = STATE(3407),
    [sym_delete_expression] = STATE(3407),
    [sym_lambda_expression] = STATE(3407),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7631),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(7631),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(7633),
    [sym_false] = ACTIONS(7633),
    [sym_null] = ACTIONS(7633),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(7633),
  },
  [3185] = {
    [anon_sym_COLON] = ACTIONS(7635),
    [sym_comment] = ACTIONS(91),
  },
  [3186] = {
    [sym_parenthesized_expression] = STATE(3409),
    [anon_sym_LPAREN2] = ACTIONS(323),
    [sym_comment] = ACTIONS(91),
  },
  [3187] = {
    [anon_sym_LPAREN2] = ACTIONS(7637),
    [sym_comment] = ACTIONS(91),
  },
  [3188] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(548),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_COLON] = ACTIONS(7639),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(935),
  },
  [3189] = {
    [sym_compound_statement] = STATE(3412),
    [anon_sym_LBRACE] = ACTIONS(357),
    [sym_comment] = ACTIONS(91),
  },
  [3190] = {
    [sym_raw_string_literal] = ACTIONS(6091),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6093),
    [sym_preproc_directive] = ACTIONS(6093),
    [anon_sym_SEMI] = ACTIONS(6091),
    [anon_sym_typedef] = ACTIONS(6093),
    [anon_sym_extern] = ACTIONS(6093),
    [anon_sym_LBRACE] = ACTIONS(6091),
    [anon_sym_RBRACE] = ACTIONS(6091),
    [anon_sym_LPAREN2] = ACTIONS(6091),
    [anon_sym_STAR] = ACTIONS(6091),
    [anon_sym_LBRACK] = ACTIONS(6091),
    [anon_sym_static] = ACTIONS(6093),
    [anon_sym_register] = ACTIONS(6093),
    [anon_sym_inline] = ACTIONS(6093),
    [anon_sym_const] = ACTIONS(6093),
    [anon_sym_restrict] = ACTIONS(6093),
    [anon_sym_volatile] = ACTIONS(6093),
    [anon_sym__Atomic] = ACTIONS(6093),
    [anon_sym_mutable] = ACTIONS(6093),
    [anon_sym_explicit] = ACTIONS(6093),
    [anon_sym_constexpr] = ACTIONS(6093),
    [anon_sym_unsigned] = ACTIONS(6093),
    [anon_sym_long] = ACTIONS(6093),
    [anon_sym_short] = ACTIONS(6093),
    [sym_primitive_type] = ACTIONS(6093),
    [anon_sym_enum] = ACTIONS(6093),
    [anon_sym_struct] = ACTIONS(6093),
    [anon_sym_union] = ACTIONS(6093),
    [anon_sym_if] = ACTIONS(6093),
    [anon_sym_else] = ACTIONS(7641),
    [anon_sym_switch] = ACTIONS(6093),
    [anon_sym_case] = ACTIONS(6093),
    [anon_sym_default] = ACTIONS(6093),
    [anon_sym_while] = ACTIONS(6093),
    [anon_sym_do] = ACTIONS(6093),
    [anon_sym_for] = ACTIONS(6093),
    [anon_sym_return] = ACTIONS(6093),
    [anon_sym_break] = ACTIONS(6093),
    [anon_sym_continue] = ACTIONS(6093),
    [anon_sym_goto] = ACTIONS(6093),
    [anon_sym_AMP] = ACTIONS(6093),
    [anon_sym_AMP_AMP] = ACTIONS(6091),
    [anon_sym_BANG] = ACTIONS(6091),
    [anon_sym_TILDE] = ACTIONS(6091),
    [anon_sym_PLUS] = ACTIONS(6093),
    [anon_sym_DASH] = ACTIONS(6093),
    [anon_sym_DASH_DASH] = ACTIONS(6091),
    [anon_sym_PLUS_PLUS] = ACTIONS(6091),
    [anon_sym_sizeof] = ACTIONS(6093),
    [sym_number_literal] = ACTIONS(6091),
    [anon_sym_SQUOTE] = ACTIONS(6091),
    [anon_sym_DQUOTE] = ACTIONS(6091),
    [sym_true] = ACTIONS(6093),
    [sym_false] = ACTIONS(6093),
    [sym_null] = ACTIONS(6093),
    [sym_identifier] = ACTIONS(6093),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6093),
    [sym_auto] = ACTIONS(6093),
    [anon_sym_typename] = ACTIONS(6093),
    [anon_sym_template] = ACTIONS(6093),
    [anon_sym_delete] = ACTIONS(6093),
    [anon_sym_namespace] = ACTIONS(6093),
    [anon_sym_using] = ACTIONS(6093),
    [anon_sym_try] = ACTIONS(6093),
    [anon_sym_new] = ACTIONS(6093),
    [anon_sym_COLON_COLON] = ACTIONS(6091),
    [sym_operator_name] = ACTIONS(6091),
    [sym_nullptr] = ACTIONS(6093),
  },
  [3191] = {
    [sym_compound_statement] = STATE(3414),
    [sym_labeled_statement] = STATE(3414),
    [sym_expression_statement] = STATE(3414),
    [sym_if_statement] = STATE(3414),
    [sym_switch_statement] = STATE(3414),
    [sym_case_statement] = STATE(3414),
    [sym_while_statement] = STATE(3414),
    [sym_do_statement] = STATE(3414),
    [sym_for_statement] = STATE(3414),
    [sym_return_statement] = STATE(3414),
    [sym_break_statement] = STATE(3414),
    [sym_continue_statement] = STATE(3414),
    [sym_goto_statement] = STATE(3414),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(3414),
    [sym_try_statement] = STATE(3414),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7177),
    [anon_sym_switch] = ACTIONS(7179),
    [anon_sym_case] = ACTIONS(7181),
    [anon_sym_default] = ACTIONS(7183),
    [anon_sym_while] = ACTIONS(7185),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(7187),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(7189),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7191),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [3192] = {
    [sym_compound_statement] = STATE(2749),
    [sym_labeled_statement] = STATE(2749),
    [sym_expression_statement] = STATE(2749),
    [sym_if_statement] = STATE(2749),
    [sym_switch_statement] = STATE(2749),
    [sym_case_statement] = STATE(2749),
    [sym_while_statement] = STATE(2749),
    [sym_do_statement] = STATE(2749),
    [sym_for_statement] = STATE(2749),
    [sym_return_statement] = STATE(2749),
    [sym_break_statement] = STATE(2749),
    [sym_continue_statement] = STATE(2749),
    [sym_goto_statement] = STATE(2749),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(2749),
    [sym_try_statement] = STATE(2749),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(1495),
    [anon_sym_switch] = ACTIONS(1497),
    [anon_sym_case] = ACTIONS(1499),
    [anon_sym_default] = ACTIONS(1501),
    [anon_sym_while] = ACTIONS(1503),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(1505),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(4937),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(1509),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [3193] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3416),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(7643),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3194] = {
    [sym__expression] = STATE(3417),
    [sym_conditional_expression] = STATE(3417),
    [sym_assignment_expression] = STATE(3417),
    [sym_pointer_expression] = STATE(3417),
    [sym_logical_expression] = STATE(3417),
    [sym_bitwise_expression] = STATE(3417),
    [sym_equality_expression] = STATE(3417),
    [sym_relational_expression] = STATE(3417),
    [sym_shift_expression] = STATE(3417),
    [sym_math_expression] = STATE(3417),
    [sym_cast_expression] = STATE(3417),
    [sym_sizeof_expression] = STATE(3417),
    [sym_subscript_expression] = STATE(3417),
    [sym_call_expression] = STATE(3417),
    [sym_field_expression] = STATE(3417),
    [sym_compound_literal_expression] = STATE(3417),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_char_literal] = STATE(3417),
    [sym_concatenated_string] = STATE(3417),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3417),
    [sym_new_expression] = STATE(3417),
    [sym_delete_expression] = STATE(3417),
    [sym_lambda_expression] = STATE(3417),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7645),
    [anon_sym_RPAREN] = ACTIONS(7643),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(7645),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7647),
    [sym_false] = ACTIONS(7647),
    [sym_null] = ACTIONS(7647),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(7647),
  },
  [3195] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(7649),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3196] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(7651),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3197] = {
    [sym_parameter_list] = STATE(2849),
    [anon_sym_SEMI] = ACTIONS(5889),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [sym_comment] = ACTIONS(91),
  },
  [3198] = {
    [sym_type_qualifier] = STATE(3198),
    [aux_sym_type_definition_repeat1] = STATE(3198),
    [anon_sym_SEMI] = ACTIONS(2179),
    [anon_sym_LPAREN2] = ACTIONS(2179),
    [anon_sym_STAR] = ACTIONS(2179),
    [anon_sym_LBRACK] = ACTIONS(2179),
    [anon_sym_const] = ACTIONS(2538),
    [anon_sym_restrict] = ACTIONS(5316),
    [anon_sym_volatile] = ACTIONS(5316),
    [anon_sym__Atomic] = ACTIONS(5316),
    [anon_sym_mutable] = ACTIONS(5316),
    [anon_sym_explicit] = ACTIONS(5316),
    [anon_sym_constexpr] = ACTIONS(5316),
    [anon_sym_AMP] = ACTIONS(2177),
    [anon_sym_AMP_AMP] = ACTIONS(2179),
    [sym_comment] = ACTIONS(91),
  },
  [3199] = {
    [sym_type_qualifier] = STATE(3201),
    [sym_trailing_return_type] = STATE(2418),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3201),
    [anon_sym_SEMI] = ACTIONS(5331),
    [anon_sym_LPAREN2] = ACTIONS(5331),
    [anon_sym_LBRACK] = ACTIONS(5331),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(6368),
    [sym_comment] = ACTIONS(91),
    [sym_noexcept] = ACTIONS(7215),
  },
  [3200] = {
    [sym__abstract_declarator] = STATE(3420),
    [sym_abstract_pointer_declarator] = STATE(3420),
    [sym_abstract_function_declarator] = STATE(3420),
    [sym_abstract_array_declarator] = STATE(3420),
    [sym_parameter_list] = STATE(2281),
    [sym_abstract_reference_declarator] = STATE(3420),
    [anon_sym_SEMI] = ACTIONS(5222),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(4977),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_AMP] = ACTIONS(4979),
    [anon_sym_AMP_AMP] = ACTIONS(4981),
    [sym_comment] = ACTIONS(91),
  },
  [3201] = {
    [sym_type_qualifier] = STATE(3201),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3201),
    [anon_sym_SEMI] = ACTIONS(5351),
    [anon_sym_LPAREN2] = ACTIONS(5351),
    [anon_sym_LBRACK] = ACTIONS(5351),
    [anon_sym_const] = ACTIONS(5353),
    [anon_sym_restrict] = ACTIONS(5356),
    [anon_sym_volatile] = ACTIONS(5356),
    [anon_sym__Atomic] = ACTIONS(5356),
    [anon_sym_mutable] = ACTIONS(5356),
    [anon_sym_explicit] = ACTIONS(5356),
    [anon_sym_constexpr] = ACTIONS(5356),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [sym_comment] = ACTIONS(91),
    [sym_noexcept] = ACTIONS(7653),
  },
  [3202] = {
    [anon_sym_COMMA] = ACTIONS(6940),
    [anon_sym_RPAREN] = ACTIONS(6940),
    [anon_sym_SEMI] = ACTIONS(6940),
    [anon_sym_LBRACE] = ACTIONS(6940),
    [anon_sym_RBRACE] = ACTIONS(6940),
    [anon_sym_LPAREN2] = ACTIONS(6940),
    [anon_sym_STAR] = ACTIONS(6942),
    [anon_sym_LBRACK] = ACTIONS(6940),
    [anon_sym_RBRACK] = ACTIONS(6940),
    [anon_sym_EQ] = ACTIONS(6942),
    [anon_sym_COLON] = ACTIONS(6940),
    [anon_sym_QMARK] = ACTIONS(6940),
    [anon_sym_STAR_EQ] = ACTIONS(6940),
    [anon_sym_SLASH_EQ] = ACTIONS(6940),
    [anon_sym_PERCENT_EQ] = ACTIONS(6940),
    [anon_sym_PLUS_EQ] = ACTIONS(6940),
    [anon_sym_DASH_EQ] = ACTIONS(6940),
    [anon_sym_LT_LT_EQ] = ACTIONS(6940),
    [anon_sym_GT_GT_EQ] = ACTIONS(6940),
    [anon_sym_AMP_EQ] = ACTIONS(6940),
    [anon_sym_CARET_EQ] = ACTIONS(6940),
    [anon_sym_PIPE_EQ] = ACTIONS(6940),
    [anon_sym_AMP] = ACTIONS(6942),
    [anon_sym_PIPE_PIPE] = ACTIONS(6940),
    [anon_sym_AMP_AMP] = ACTIONS(6940),
    [anon_sym_PIPE] = ACTIONS(6942),
    [anon_sym_CARET] = ACTIONS(6942),
    [anon_sym_EQ_EQ] = ACTIONS(6940),
    [anon_sym_BANG_EQ] = ACTIONS(6940),
    [anon_sym_LT] = ACTIONS(6942),
    [anon_sym_GT] = ACTIONS(6942),
    [anon_sym_LT_EQ] = ACTIONS(6940),
    [anon_sym_GT_EQ] = ACTIONS(6940),
    [anon_sym_LT_LT] = ACTIONS(6942),
    [anon_sym_GT_GT] = ACTIONS(6942),
    [anon_sym_PLUS] = ACTIONS(6942),
    [anon_sym_DASH] = ACTIONS(6942),
    [anon_sym_SLASH] = ACTIONS(6942),
    [anon_sym_PERCENT] = ACTIONS(6942),
    [anon_sym_DASH_DASH] = ACTIONS(6940),
    [anon_sym_PLUS_PLUS] = ACTIONS(6940),
    [anon_sym_DOT] = ACTIONS(6940),
    [anon_sym_DASH_GT] = ACTIONS(6940),
    [sym_comment] = ACTIONS(91),
  },
  [3203] = {
    [sym__expression] = STATE(1200),
    [sym_conditional_expression] = STATE(1200),
    [sym_assignment_expression] = STATE(1200),
    [sym_pointer_expression] = STATE(1200),
    [sym_logical_expression] = STATE(1200),
    [sym_bitwise_expression] = STATE(1200),
    [sym_equality_expression] = STATE(1200),
    [sym_relational_expression] = STATE(1200),
    [sym_shift_expression] = STATE(1200),
    [sym_math_expression] = STATE(1200),
    [sym_cast_expression] = STATE(1200),
    [sym_sizeof_expression] = STATE(1200),
    [sym_subscript_expression] = STATE(1200),
    [sym_call_expression] = STATE(1200),
    [sym_field_expression] = STATE(1200),
    [sym_compound_literal_expression] = STATE(1200),
    [sym_parenthesized_expression] = STATE(1200),
    [sym_initializer_list] = STATE(1201),
    [sym_char_literal] = STATE(1200),
    [sym_concatenated_string] = STATE(1200),
    [sym_string_literal] = STATE(1632),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1200),
    [sym_new_expression] = STATE(1200),
    [sym_delete_expression] = STATE(1200),
    [sym_lambda_expression] = STATE(1200),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2523),
    [anon_sym_COMMA] = ACTIONS(4689),
    [anon_sym_SEMI] = ACTIONS(4689),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_RBRACE] = ACTIONS(4689),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(7656),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_EQ] = ACTIONS(4693),
    [anon_sym_QMARK] = ACTIONS(4689),
    [anon_sym_STAR_EQ] = ACTIONS(4689),
    [anon_sym_SLASH_EQ] = ACTIONS(4689),
    [anon_sym_PERCENT_EQ] = ACTIONS(4689),
    [anon_sym_PLUS_EQ] = ACTIONS(4689),
    [anon_sym_DASH_EQ] = ACTIONS(4689),
    [anon_sym_LT_LT_EQ] = ACTIONS(4689),
    [anon_sym_GT_GT_EQ] = ACTIONS(4689),
    [anon_sym_AMP_EQ] = ACTIONS(4689),
    [anon_sym_CARET_EQ] = ACTIONS(4689),
    [anon_sym_PIPE_EQ] = ACTIONS(4689),
    [anon_sym_AMP] = ACTIONS(7656),
    [anon_sym_PIPE_PIPE] = ACTIONS(4689),
    [anon_sym_AMP_AMP] = ACTIONS(4689),
    [anon_sym_BANG] = ACTIONS(7658),
    [anon_sym_PIPE] = ACTIONS(4693),
    [anon_sym_CARET] = ACTIONS(4693),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_EQ_EQ] = ACTIONS(4689),
    [anon_sym_BANG_EQ] = ACTIONS(4689),
    [anon_sym_LT] = ACTIONS(4693),
    [anon_sym_GT] = ACTIONS(4693),
    [anon_sym_LT_EQ] = ACTIONS(4689),
    [anon_sym_GT_EQ] = ACTIONS(4689),
    [anon_sym_LT_LT] = ACTIONS(4693),
    [anon_sym_GT_GT] = ACTIONS(4693),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_SLASH] = ACTIONS(4693),
    [anon_sym_PERCENT] = ACTIONS(4693),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_sizeof] = ACTIONS(3419),
    [anon_sym_DOT] = ACTIONS(4689),
    [anon_sym_DASH_GT] = ACTIONS(4689),
    [sym_number_literal] = ACTIONS(2523),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2525),
    [sym_false] = ACTIONS(2525),
    [sym_null] = ACTIONS(2525),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_COLON_COLON] = ACTIONS(5036),
    [sym_nullptr] = ACTIONS(2525),
  },
  [3204] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(4927),
    [anon_sym_SEMI] = ACTIONS(4927),
    [anon_sym_RBRACE] = ACTIONS(4927),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(5060),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(4929),
    [anon_sym_QMARK] = ACTIONS(4927),
    [anon_sym_STAR_EQ] = ACTIONS(4927),
    [anon_sym_SLASH_EQ] = ACTIONS(4927),
    [anon_sym_PERCENT_EQ] = ACTIONS(4927),
    [anon_sym_PLUS_EQ] = ACTIONS(4927),
    [anon_sym_DASH_EQ] = ACTIONS(4927),
    [anon_sym_LT_LT_EQ] = ACTIONS(4927),
    [anon_sym_GT_GT_EQ] = ACTIONS(4927),
    [anon_sym_AMP_EQ] = ACTIONS(4927),
    [anon_sym_CARET_EQ] = ACTIONS(4927),
    [anon_sym_PIPE_EQ] = ACTIONS(4927),
    [anon_sym_AMP] = ACTIONS(5068),
    [anon_sym_PIPE_PIPE] = ACTIONS(5070),
    [anon_sym_AMP_AMP] = ACTIONS(5072),
    [anon_sym_PIPE] = ACTIONS(5074),
    [anon_sym_CARET] = ACTIONS(5076),
    [anon_sym_EQ_EQ] = ACTIONS(5078),
    [anon_sym_BANG_EQ] = ACTIONS(5078),
    [anon_sym_LT] = ACTIONS(5080),
    [anon_sym_GT] = ACTIONS(5080),
    [anon_sym_LT_EQ] = ACTIONS(5082),
    [anon_sym_GT_EQ] = ACTIONS(5082),
    [anon_sym_LT_LT] = ACTIONS(5084),
    [anon_sym_GT_GT] = ACTIONS(5084),
    [anon_sym_PLUS] = ACTIONS(5086),
    [anon_sym_DASH] = ACTIONS(5086),
    [anon_sym_SLASH] = ACTIONS(5060),
    [anon_sym_PERCENT] = ACTIONS(5060),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3205] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(7660),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_STAR_EQ] = ACTIONS(3507),
    [anon_sym_SLASH_EQ] = ACTIONS(3507),
    [anon_sym_PERCENT_EQ] = ACTIONS(3507),
    [anon_sym_PLUS_EQ] = ACTIONS(3507),
    [anon_sym_DASH_EQ] = ACTIONS(3507),
    [anon_sym_LT_LT_EQ] = ACTIONS(3507),
    [anon_sym_GT_GT_EQ] = ACTIONS(3507),
    [anon_sym_AMP_EQ] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(3507),
    [anon_sym_PIPE_EQ] = ACTIONS(3507),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_CARET] = ACTIONS(3517),
    [anon_sym_EQ_EQ] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3521),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3525),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3206] = {
    [sym__expression] = STATE(3422),
    [sym_conditional_expression] = STATE(3422),
    [sym_assignment_expression] = STATE(3422),
    [sym_pointer_expression] = STATE(3422),
    [sym_logical_expression] = STATE(3422),
    [sym_bitwise_expression] = STATE(3422),
    [sym_equality_expression] = STATE(3422),
    [sym_relational_expression] = STATE(3422),
    [sym_shift_expression] = STATE(3422),
    [sym_math_expression] = STATE(3422),
    [sym_cast_expression] = STATE(3422),
    [sym_sizeof_expression] = STATE(3422),
    [sym_subscript_expression] = STATE(3422),
    [sym_call_expression] = STATE(3422),
    [sym_field_expression] = STATE(3422),
    [sym_compound_literal_expression] = STATE(3422),
    [sym_parenthesized_expression] = STATE(3422),
    [sym_char_literal] = STATE(3422),
    [sym_concatenated_string] = STATE(3422),
    [sym_string_literal] = STATE(1632),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3422),
    [sym_new_expression] = STATE(3422),
    [sym_delete_expression] = STATE(3422),
    [sym_lambda_expression] = STATE(3422),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7662),
    [anon_sym_LPAREN2] = ACTIONS(947),
    [anon_sym_STAR] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(947),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_BANG] = ACTIONS(3411),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_sizeof] = ACTIONS(3419),
    [sym_number_literal] = ACTIONS(7662),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7664),
    [sym_false] = ACTIONS(7664),
    [sym_null] = ACTIONS(7664),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_COLON_COLON] = ACTIONS(5036),
    [sym_nullptr] = ACTIONS(7664),
  },
  [3207] = {
    [sym__expression] = STATE(3423),
    [sym_conditional_expression] = STATE(3423),
    [sym_assignment_expression] = STATE(3423),
    [sym_pointer_expression] = STATE(3423),
    [sym_logical_expression] = STATE(3423),
    [sym_bitwise_expression] = STATE(3423),
    [sym_equality_expression] = STATE(3423),
    [sym_relational_expression] = STATE(3423),
    [sym_shift_expression] = STATE(3423),
    [sym_math_expression] = STATE(3423),
    [sym_cast_expression] = STATE(3423),
    [sym_sizeof_expression] = STATE(3423),
    [sym_subscript_expression] = STATE(3423),
    [sym_call_expression] = STATE(3423),
    [sym_field_expression] = STATE(3423),
    [sym_compound_literal_expression] = STATE(3423),
    [sym_parenthesized_expression] = STATE(3423),
    [sym_char_literal] = STATE(3423),
    [sym_concatenated_string] = STATE(3423),
    [sym_string_literal] = STATE(1632),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3423),
    [sym_new_expression] = STATE(3423),
    [sym_delete_expression] = STATE(3423),
    [sym_lambda_expression] = STATE(3423),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7666),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3411),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_sizeof] = ACTIONS(3419),
    [sym_number_literal] = ACTIONS(7666),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7668),
    [sym_false] = ACTIONS(7668),
    [sym_null] = ACTIONS(7668),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_COLON_COLON] = ACTIONS(5036),
    [sym_nullptr] = ACTIONS(7668),
  },
  [3208] = {
    [sym_parameter_list] = STATE(3211),
    [anon_sym_COMMA] = ACTIONS(4157),
    [anon_sym_SEMI] = ACTIONS(4157),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(4157),
    [anon_sym_const] = ACTIONS(7279),
    [anon_sym_restrict] = ACTIONS(4157),
    [anon_sym_volatile] = ACTIONS(4157),
    [anon_sym__Atomic] = ACTIONS(4157),
    [anon_sym_mutable] = ACTIONS(4157),
    [anon_sym_explicit] = ACTIONS(4157),
    [anon_sym_constexpr] = ACTIONS(4157),
    [anon_sym_DASH_GT] = ACTIONS(4157),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4157),
    [anon_sym_override] = ACTIONS(4157),
    [sym_noexcept] = ACTIONS(4157),
  },
  [3209] = {
    [sym__abstract_declarator] = STATE(3424),
    [sym_abstract_pointer_declarator] = STATE(3424),
    [sym_abstract_function_declarator] = STATE(3424),
    [sym_abstract_array_declarator] = STATE(3424),
    [sym_type_qualifier] = STATE(3425),
    [sym_parameter_list] = STATE(2897),
    [sym_abstract_reference_declarator] = STATE(3424),
    [aux_sym_type_definition_repeat1] = STATE(3425),
    [anon_sym_COMMA] = ACTIONS(4157),
    [anon_sym_SEMI] = ACTIONS(4157),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(6489),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_EQ] = ACTIONS(4157),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(6491),
    [anon_sym_AMP_AMP] = ACTIONS(6493),
    [anon_sym_DASH_GT] = ACTIONS(4157),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4157),
    [anon_sym_override] = ACTIONS(4157),
    [sym_noexcept] = ACTIONS(4157),
  },
  [3210] = {
    [sym_parameter_list] = STATE(3211),
    [anon_sym_COMMA] = ACTIONS(4159),
    [anon_sym_SEMI] = ACTIONS(4159),
    [anon_sym_LBRACE] = ACTIONS(4159),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_const] = ACTIONS(7281),
    [anon_sym_restrict] = ACTIONS(4159),
    [anon_sym_volatile] = ACTIONS(4159),
    [anon_sym__Atomic] = ACTIONS(4159),
    [anon_sym_mutable] = ACTIONS(4159),
    [anon_sym_explicit] = ACTIONS(4159),
    [anon_sym_constexpr] = ACTIONS(4159),
    [anon_sym_DASH_GT] = ACTIONS(4159),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4159),
    [anon_sym_override] = ACTIONS(4159),
    [sym_noexcept] = ACTIONS(4159),
  },
  [3211] = {
    [sym_type_qualifier] = STATE(3426),
    [sym_trailing_return_type] = STATE(1720),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3426),
    [anon_sym_COMMA] = ACTIONS(3663),
    [anon_sym_SEMI] = ACTIONS(3663),
    [anon_sym_LBRACE] = ACTIONS(3663),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_EQ] = ACTIONS(3663),
    [anon_sym_const] = ACTIONS(3685),
    [anon_sym_restrict] = ACTIONS(3663),
    [anon_sym_volatile] = ACTIONS(3663),
    [anon_sym__Atomic] = ACTIONS(3663),
    [anon_sym_mutable] = ACTIONS(3663),
    [anon_sym_explicit] = ACTIONS(3663),
    [anon_sym_constexpr] = ACTIONS(3663),
    [anon_sym_DASH_GT] = ACTIONS(3663),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3663),
    [anon_sym_override] = ACTIONS(3663),
    [sym_noexcept] = ACTIONS(3663),
  },
  [3212] = {
    [sym_type_qualifier] = STATE(3427),
    [sym_trailing_return_type] = STATE(1720),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3427),
    [anon_sym_COMMA] = ACTIONS(3663),
    [anon_sym_SEMI] = ACTIONS(3663),
    [anon_sym_LBRACE] = ACTIONS(3663),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_EQ] = ACTIONS(3663),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(3443),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3663),
    [anon_sym_override] = ACTIONS(3663),
    [sym_noexcept] = ACTIONS(7670),
  },
  [3213] = {
    [sym__type_specifier] = STATE(271),
    [sym_sized_type_specifier] = STATE(271),
    [sym_enum_specifier] = STATE(271),
    [sym_struct_specifier] = STATE(271),
    [sym_union_specifier] = STATE(271),
    [sym_macro_type_specifier] = STATE(271),
    [sym_class_specifier] = STATE(271),
    [sym_dependent_type] = STATE(271),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(273),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3215),
    [anon_sym_unsigned] = ACTIONS(7246),
    [anon_sym_long] = ACTIONS(7246),
    [anon_sym_short] = ACTIONS(7246),
    [sym_primitive_type] = ACTIONS(490),
    [anon_sym_enum] = ACTIONS(3675),
    [anon_sym_struct] = ACTIONS(5103),
    [anon_sym_union] = ACTIONS(5105),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5107),
    [sym_auto] = ACTIONS(490),
    [anon_sym_typename] = ACTIONS(7250),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [3214] = {
    [sym__abstract_declarator] = STATE(3430),
    [sym_abstract_pointer_declarator] = STATE(3430),
    [sym_abstract_function_declarator] = STATE(3430),
    [sym_abstract_array_declarator] = STATE(3430),
    [sym_parameter_list] = STATE(3431),
    [sym_abstract_reference_declarator] = STATE(3430),
    [anon_sym_COMMA] = ACTIONS(5222),
    [anon_sym_RPAREN] = ACTIONS(5222),
    [anon_sym_LBRACE] = ACTIONS(5222),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(7672),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_EQ] = ACTIONS(5222),
    [anon_sym_const] = ACTIONS(5226),
    [anon_sym_restrict] = ACTIONS(5222),
    [anon_sym_volatile] = ACTIONS(5222),
    [anon_sym__Atomic] = ACTIONS(5222),
    [anon_sym_mutable] = ACTIONS(5222),
    [anon_sym_explicit] = ACTIONS(5222),
    [anon_sym_constexpr] = ACTIONS(5222),
    [anon_sym_AMP] = ACTIONS(7674),
    [anon_sym_AMP_AMP] = ACTIONS(7676),
    [anon_sym_DASH_GT] = ACTIONS(5222),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5222),
    [anon_sym_override] = ACTIONS(5222),
    [sym_noexcept] = ACTIONS(5222),
  },
  [3215] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3432),
    [anon_sym_COMMA] = ACTIONS(653),
    [anon_sym_RPAREN] = ACTIONS(653),
    [anon_sym_LBRACE] = ACTIONS(653),
    [anon_sym_LPAREN2] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_EQ] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(655),
    [anon_sym_restrict] = ACTIONS(655),
    [anon_sym_volatile] = ACTIONS(655),
    [anon_sym__Atomic] = ACTIONS(655),
    [anon_sym_mutable] = ACTIONS(655),
    [anon_sym_explicit] = ACTIONS(655),
    [anon_sym_constexpr] = ACTIONS(655),
    [anon_sym_unsigned] = ACTIONS(7678),
    [anon_sym_long] = ACTIONS(7678),
    [anon_sym_short] = ACTIONS(7678),
    [sym_primitive_type] = ACTIONS(659),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [anon_sym_DASH_GT] = ACTIONS(653),
    [sym_identifier] = ACTIONS(933),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(655),
    [anon_sym_override] = ACTIONS(655),
    [sym_noexcept] = ACTIONS(655),
  },
  [3216] = {
    [sym_type_qualifier] = STATE(3216),
    [sym_virtual_specifier] = STATE(3216),
    [sym_trailing_return_type] = STATE(3216),
    [aux_sym_function_declarator_repeat1] = STATE(3216),
    [anon_sym_COMMA] = ACTIONS(5236),
    [anon_sym_RPAREN] = ACTIONS(5236),
    [anon_sym_LBRACE] = ACTIONS(5236),
    [anon_sym_LPAREN2] = ACTIONS(5236),
    [anon_sym_LBRACK] = ACTIONS(5236),
    [anon_sym_EQ] = ACTIONS(5236),
    [anon_sym_const] = ACTIONS(5877),
    [anon_sym_restrict] = ACTIONS(5880),
    [anon_sym_volatile] = ACTIONS(5880),
    [anon_sym__Atomic] = ACTIONS(5880),
    [anon_sym_mutable] = ACTIONS(5880),
    [anon_sym_explicit] = ACTIONS(5880),
    [anon_sym_constexpr] = ACTIONS(5880),
    [anon_sym_DASH_GT] = ACTIONS(7680),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5247),
    [anon_sym_override] = ACTIONS(5247),
    [sym_noexcept] = ACTIONS(7683),
  },
  [3217] = {
    [sym__abstract_declarator] = STATE(2354),
    [sym_abstract_pointer_declarator] = STATE(2354),
    [sym_abstract_function_declarator] = STATE(2354),
    [sym_abstract_array_declarator] = STATE(2354),
    [sym_type_qualifier] = STATE(3433),
    [sym_parameter_list] = STATE(1654),
    [sym_abstract_reference_declarator] = STATE(2354),
    [aux_sym_type_definition_repeat1] = STATE(3433),
    [anon_sym_COMMA] = ACTIONS(2461),
    [anon_sym_RPAREN] = ACTIONS(2461),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(7254),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(7256),
    [anon_sym_AMP_AMP] = ACTIONS(7258),
    [sym_comment] = ACTIONS(91),
  },
  [3218] = {
    [sym__abstract_declarator] = STATE(2357),
    [sym_abstract_pointer_declarator] = STATE(2357),
    [sym_abstract_function_declarator] = STATE(2357),
    [sym_abstract_array_declarator] = STATE(2357),
    [sym_parameter_list] = STATE(1654),
    [sym_abstract_reference_declarator] = STATE(2357),
    [anon_sym_COMMA] = ACTIONS(2463),
    [anon_sym_RPAREN] = ACTIONS(2463),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(7254),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_AMP] = ACTIONS(7256),
    [anon_sym_AMP_AMP] = ACTIONS(7258),
    [sym_comment] = ACTIONS(91),
  },
  [3219] = {
    [sym_parameter_list] = STATE(2360),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_RPAREN] = ACTIONS(6557),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [sym_comment] = ACTIONS(91),
  },
  [3220] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3220),
    [anon_sym_COMMA] = ACTIONS(1985),
    [anon_sym_RPAREN] = ACTIONS(1985),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1985),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_unsigned] = ACTIONS(7686),
    [anon_sym_long] = ACTIONS(7686),
    [anon_sym_short] = ACTIONS(7686),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [sym_comment] = ACTIONS(91),
  },
  [3221] = {
    [sym_new_declarator] = STATE(2861),
    [anon_sym_LBRACE] = ACTIONS(6396),
    [anon_sym_LPAREN2] = ACTIONS(6396),
    [anon_sym_STAR] = ACTIONS(6398),
    [anon_sym_LBRACK] = ACTIONS(5153),
    [anon_sym_RBRACK] = ACTIONS(6396),
    [anon_sym_EQ] = ACTIONS(6398),
    [anon_sym_QMARK] = ACTIONS(6396),
    [anon_sym_STAR_EQ] = ACTIONS(6396),
    [anon_sym_SLASH_EQ] = ACTIONS(6396),
    [anon_sym_PERCENT_EQ] = ACTIONS(6396),
    [anon_sym_PLUS_EQ] = ACTIONS(6396),
    [anon_sym_DASH_EQ] = ACTIONS(6396),
    [anon_sym_LT_LT_EQ] = ACTIONS(6396),
    [anon_sym_GT_GT_EQ] = ACTIONS(6396),
    [anon_sym_AMP_EQ] = ACTIONS(6396),
    [anon_sym_CARET_EQ] = ACTIONS(6396),
    [anon_sym_PIPE_EQ] = ACTIONS(6396),
    [anon_sym_AMP] = ACTIONS(6398),
    [anon_sym_PIPE_PIPE] = ACTIONS(6396),
    [anon_sym_AMP_AMP] = ACTIONS(6396),
    [anon_sym_PIPE] = ACTIONS(6398),
    [anon_sym_CARET] = ACTIONS(6398),
    [anon_sym_EQ_EQ] = ACTIONS(6396),
    [anon_sym_BANG_EQ] = ACTIONS(6396),
    [anon_sym_LT] = ACTIONS(6398),
    [anon_sym_GT] = ACTIONS(6398),
    [anon_sym_LT_EQ] = ACTIONS(6396),
    [anon_sym_GT_EQ] = ACTIONS(6396),
    [anon_sym_LT_LT] = ACTIONS(6398),
    [anon_sym_GT_GT] = ACTIONS(6398),
    [anon_sym_PLUS] = ACTIONS(6398),
    [anon_sym_DASH] = ACTIONS(6398),
    [anon_sym_SLASH] = ACTIONS(6398),
    [anon_sym_PERCENT] = ACTIONS(6398),
    [anon_sym_DASH_DASH] = ACTIONS(6396),
    [anon_sym_PLUS_PLUS] = ACTIONS(6396),
    [anon_sym_DOT] = ACTIONS(6396),
    [anon_sym_DASH_GT] = ACTIONS(6396),
    [sym_comment] = ACTIONS(91),
  },
  [3222] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(6404),
    [anon_sym_EQ] = ACTIONS(6406),
    [anon_sym_QMARK] = ACTIONS(6404),
    [anon_sym_STAR_EQ] = ACTIONS(6404),
    [anon_sym_SLASH_EQ] = ACTIONS(6404),
    [anon_sym_PERCENT_EQ] = ACTIONS(6404),
    [anon_sym_PLUS_EQ] = ACTIONS(6404),
    [anon_sym_DASH_EQ] = ACTIONS(6404),
    [anon_sym_LT_LT_EQ] = ACTIONS(6404),
    [anon_sym_GT_GT_EQ] = ACTIONS(6404),
    [anon_sym_AMP_EQ] = ACTIONS(6404),
    [anon_sym_CARET_EQ] = ACTIONS(6404),
    [anon_sym_PIPE_EQ] = ACTIONS(6404),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_CARET] = ACTIONS(3517),
    [anon_sym_EQ_EQ] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3521),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3525),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3223] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_RBRACK] = ACTIONS(6579),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_STAR_EQ] = ACTIONS(3507),
    [anon_sym_SLASH_EQ] = ACTIONS(3507),
    [anon_sym_PERCENT_EQ] = ACTIONS(3507),
    [anon_sym_PLUS_EQ] = ACTIONS(3507),
    [anon_sym_DASH_EQ] = ACTIONS(3507),
    [anon_sym_LT_LT_EQ] = ACTIONS(3507),
    [anon_sym_GT_GT_EQ] = ACTIONS(3507),
    [anon_sym_AMP_EQ] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(3507),
    [anon_sym_PIPE_EQ] = ACTIONS(3507),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_CARET] = ACTIONS(3517),
    [anon_sym_EQ_EQ] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3521),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3525),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3224] = {
    [sym_parameter_list] = STATE(2918),
    [anon_sym_LBRACE] = ACTIONS(5889),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(5889),
    [anon_sym_const] = ACTIONS(7689),
    [anon_sym_restrict] = ACTIONS(5889),
    [anon_sym_volatile] = ACTIONS(5889),
    [anon_sym__Atomic] = ACTIONS(5889),
    [anon_sym_mutable] = ACTIONS(5889),
    [anon_sym_explicit] = ACTIONS(5889),
    [anon_sym_constexpr] = ACTIONS(5889),
    [anon_sym_COLON] = ACTIONS(5889),
    [anon_sym_DASH_GT] = ACTIONS(5889),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5889),
    [anon_sym_override] = ACTIONS(5889),
    [sym_noexcept] = ACTIONS(5889),
  },
  [3225] = {
    [sym_type_qualifier] = STATE(3225),
    [aux_sym_type_definition_repeat1] = STATE(3225),
    [anon_sym_LBRACE] = ACTIONS(2179),
    [anon_sym_LPAREN2] = ACTIONS(2179),
    [anon_sym_STAR] = ACTIONS(2179),
    [anon_sym_LBRACK] = ACTIONS(2179),
    [anon_sym_EQ] = ACTIONS(2179),
    [anon_sym_const] = ACTIONS(7691),
    [anon_sym_restrict] = ACTIONS(7694),
    [anon_sym_volatile] = ACTIONS(7694),
    [anon_sym__Atomic] = ACTIONS(7694),
    [anon_sym_mutable] = ACTIONS(7694),
    [anon_sym_explicit] = ACTIONS(7694),
    [anon_sym_constexpr] = ACTIONS(7694),
    [anon_sym_COLON] = ACTIONS(2179),
    [anon_sym_AMP] = ACTIONS(2177),
    [anon_sym_AMP_AMP] = ACTIONS(2179),
    [anon_sym_DASH_GT] = ACTIONS(2179),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2179),
    [anon_sym_override] = ACTIONS(2179),
    [sym_noexcept] = ACTIONS(2179),
  },
  [3226] = {
    [sym_type_qualifier] = STATE(3227),
    [sym_trailing_return_type] = STATE(2418),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3227),
    [anon_sym_LBRACE] = ACTIONS(5331),
    [anon_sym_LPAREN2] = ACTIONS(5331),
    [anon_sym_LBRACK] = ACTIONS(5331),
    [anon_sym_EQ] = ACTIONS(5331),
    [anon_sym_const] = ACTIONS(1667),
    [anon_sym_restrict] = ACTIONS(1669),
    [anon_sym_volatile] = ACTIONS(1669),
    [anon_sym__Atomic] = ACTIONS(1669),
    [anon_sym_mutable] = ACTIONS(1669),
    [anon_sym_explicit] = ACTIONS(1669),
    [anon_sym_constexpr] = ACTIONS(1669),
    [anon_sym_COLON] = ACTIONS(5331),
    [anon_sym_DASH_GT] = ACTIONS(1671),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5331),
    [anon_sym_override] = ACTIONS(5331),
    [sym_noexcept] = ACTIONS(7283),
  },
  [3227] = {
    [sym_type_qualifier] = STATE(3227),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3227),
    [anon_sym_LBRACE] = ACTIONS(5351),
    [anon_sym_LPAREN2] = ACTIONS(5351),
    [anon_sym_LBRACK] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_const] = ACTIONS(7697),
    [anon_sym_restrict] = ACTIONS(7700),
    [anon_sym_volatile] = ACTIONS(7700),
    [anon_sym__Atomic] = ACTIONS(7700),
    [anon_sym_mutable] = ACTIONS(7700),
    [anon_sym_explicit] = ACTIONS(7700),
    [anon_sym_constexpr] = ACTIONS(7700),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5351),
    [anon_sym_override] = ACTIONS(5351),
    [sym_noexcept] = ACTIONS(7703),
  },
  [3228] = {
    [sym_parameter_list] = STATE(968),
    [anon_sym_LBRACE] = ACTIONS(5889),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [sym_comment] = ACTIONS(91),
  },
  [3229] = {
    [sym_type_qualifier] = STATE(3229),
    [aux_sym_type_definition_repeat1] = STATE(3229),
    [anon_sym_LBRACE] = ACTIONS(2179),
    [anon_sym_LPAREN2] = ACTIONS(2179),
    [anon_sym_STAR] = ACTIONS(2179),
    [anon_sym_LBRACK] = ACTIONS(2179),
    [anon_sym_const] = ACTIONS(2538),
    [anon_sym_restrict] = ACTIONS(5316),
    [anon_sym_volatile] = ACTIONS(5316),
    [anon_sym__Atomic] = ACTIONS(5316),
    [anon_sym_mutable] = ACTIONS(5316),
    [anon_sym_explicit] = ACTIONS(5316),
    [anon_sym_constexpr] = ACTIONS(5316),
    [anon_sym_AMP] = ACTIONS(2177),
    [anon_sym_AMP_AMP] = ACTIONS(2179),
    [sym_comment] = ACTIONS(91),
  },
  [3230] = {
    [sym_raw_string_literal] = ACTIONS(5376),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5378),
    [sym_preproc_directive] = ACTIONS(5378),
    [anon_sym_SEMI] = ACTIONS(5376),
    [anon_sym_typedef] = ACTIONS(5378),
    [anon_sym_extern] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(5376),
    [anon_sym_LPAREN2] = ACTIONS(5376),
    [anon_sym_STAR] = ACTIONS(5376),
    [anon_sym_LBRACK] = ACTIONS(5376),
    [anon_sym_static] = ACTIONS(5378),
    [anon_sym_register] = ACTIONS(5378),
    [anon_sym_inline] = ACTIONS(5378),
    [anon_sym_const] = ACTIONS(5378),
    [anon_sym_restrict] = ACTIONS(5378),
    [anon_sym_volatile] = ACTIONS(5378),
    [anon_sym__Atomic] = ACTIONS(5378),
    [anon_sym_mutable] = ACTIONS(5378),
    [anon_sym_explicit] = ACTIONS(5378),
    [anon_sym_constexpr] = ACTIONS(5378),
    [anon_sym_unsigned] = ACTIONS(5378),
    [anon_sym_long] = ACTIONS(5378),
    [anon_sym_short] = ACTIONS(5378),
    [sym_primitive_type] = ACTIONS(5378),
    [anon_sym_enum] = ACTIONS(5378),
    [anon_sym_struct] = ACTIONS(5378),
    [anon_sym_union] = ACTIONS(5378),
    [anon_sym_if] = ACTIONS(5378),
    [anon_sym_switch] = ACTIONS(5378),
    [anon_sym_case] = ACTIONS(5378),
    [anon_sym_default] = ACTIONS(5378),
    [anon_sym_while] = ACTIONS(5378),
    [anon_sym_do] = ACTIONS(5378),
    [anon_sym_for] = ACTIONS(5378),
    [anon_sym_return] = ACTIONS(5378),
    [anon_sym_break] = ACTIONS(5378),
    [anon_sym_continue] = ACTIONS(5378),
    [anon_sym_goto] = ACTIONS(5378),
    [anon_sym_AMP] = ACTIONS(5378),
    [anon_sym_AMP_AMP] = ACTIONS(5376),
    [anon_sym_BANG] = ACTIONS(5376),
    [anon_sym_TILDE] = ACTIONS(5376),
    [anon_sym_PLUS] = ACTIONS(5378),
    [anon_sym_DASH] = ACTIONS(5378),
    [anon_sym_DASH_DASH] = ACTIONS(5376),
    [anon_sym_PLUS_PLUS] = ACTIONS(5376),
    [anon_sym_sizeof] = ACTIONS(5378),
    [sym_number_literal] = ACTIONS(5376),
    [anon_sym_SQUOTE] = ACTIONS(5376),
    [anon_sym_DQUOTE] = ACTIONS(5376),
    [sym_true] = ACTIONS(5378),
    [sym_false] = ACTIONS(5378),
    [sym_null] = ACTIONS(5378),
    [sym_identifier] = ACTIONS(5378),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5378),
    [sym_auto] = ACTIONS(5378),
    [anon_sym_typename] = ACTIONS(5378),
    [anon_sym_template] = ACTIONS(5378),
    [anon_sym_delete] = ACTIONS(5378),
    [anon_sym_namespace] = ACTIONS(5378),
    [anon_sym_using] = ACTIONS(5378),
    [anon_sym_try] = ACTIONS(5378),
    [anon_sym_new] = ACTIONS(5378),
    [anon_sym_COLON_COLON] = ACTIONS(5376),
    [sym_operator_name] = ACTIONS(5376),
    [sym_nullptr] = ACTIONS(5378),
  },
  [3231] = {
    [sym_raw_string_literal] = ACTIONS(5591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5593),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5593),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5593),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5593),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5593),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5593),
    [sym_preproc_directive] = ACTIONS(5593),
    [anon_sym_SEMI] = ACTIONS(5591),
    [anon_sym_typedef] = ACTIONS(5593),
    [anon_sym_extern] = ACTIONS(5593),
    [anon_sym_LBRACE] = ACTIONS(5591),
    [anon_sym_LPAREN2] = ACTIONS(5591),
    [anon_sym_STAR] = ACTIONS(5591),
    [anon_sym_LBRACK] = ACTIONS(5591),
    [anon_sym_static] = ACTIONS(5593),
    [anon_sym_register] = ACTIONS(5593),
    [anon_sym_inline] = ACTIONS(5593),
    [anon_sym_const] = ACTIONS(5593),
    [anon_sym_restrict] = ACTIONS(5593),
    [anon_sym_volatile] = ACTIONS(5593),
    [anon_sym__Atomic] = ACTIONS(5593),
    [anon_sym_mutable] = ACTIONS(5593),
    [anon_sym_explicit] = ACTIONS(5593),
    [anon_sym_constexpr] = ACTIONS(5593),
    [anon_sym_unsigned] = ACTIONS(5593),
    [anon_sym_long] = ACTIONS(5593),
    [anon_sym_short] = ACTIONS(5593),
    [sym_primitive_type] = ACTIONS(5593),
    [anon_sym_enum] = ACTIONS(5593),
    [anon_sym_struct] = ACTIONS(5593),
    [anon_sym_union] = ACTIONS(5593),
    [anon_sym_if] = ACTIONS(5593),
    [anon_sym_switch] = ACTIONS(5593),
    [anon_sym_case] = ACTIONS(5593),
    [anon_sym_default] = ACTIONS(5593),
    [anon_sym_while] = ACTIONS(5593),
    [anon_sym_do] = ACTIONS(5593),
    [anon_sym_for] = ACTIONS(5593),
    [anon_sym_return] = ACTIONS(5593),
    [anon_sym_break] = ACTIONS(5593),
    [anon_sym_continue] = ACTIONS(5593),
    [anon_sym_goto] = ACTIONS(5593),
    [anon_sym_AMP] = ACTIONS(5593),
    [anon_sym_AMP_AMP] = ACTIONS(5591),
    [anon_sym_BANG] = ACTIONS(5591),
    [anon_sym_TILDE] = ACTIONS(5591),
    [anon_sym_PLUS] = ACTIONS(5593),
    [anon_sym_DASH] = ACTIONS(5593),
    [anon_sym_DASH_DASH] = ACTIONS(5591),
    [anon_sym_PLUS_PLUS] = ACTIONS(5591),
    [anon_sym_sizeof] = ACTIONS(5593),
    [sym_number_literal] = ACTIONS(5591),
    [anon_sym_SQUOTE] = ACTIONS(5591),
    [anon_sym_DQUOTE] = ACTIONS(5591),
    [sym_true] = ACTIONS(5593),
    [sym_false] = ACTIONS(5593),
    [sym_null] = ACTIONS(5593),
    [sym_identifier] = ACTIONS(5593),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5593),
    [sym_auto] = ACTIONS(5593),
    [anon_sym_typename] = ACTIONS(5593),
    [anon_sym_template] = ACTIONS(5593),
    [anon_sym_delete] = ACTIONS(5593),
    [anon_sym_namespace] = ACTIONS(5593),
    [anon_sym_using] = ACTIONS(5593),
    [anon_sym_try] = ACTIONS(5593),
    [anon_sym_new] = ACTIONS(5593),
    [anon_sym_COLON_COLON] = ACTIONS(5591),
    [sym_operator_name] = ACTIONS(5591),
    [sym_nullptr] = ACTIONS(5593),
  },
  [3232] = {
    [sym_raw_string_literal] = ACTIONS(5595),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5597),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5597),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5597),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5597),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5597),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5597),
    [sym_preproc_directive] = ACTIONS(5597),
    [anon_sym_SEMI] = ACTIONS(5595),
    [anon_sym_typedef] = ACTIONS(5597),
    [anon_sym_extern] = ACTIONS(5597),
    [anon_sym_LBRACE] = ACTIONS(5595),
    [anon_sym_LPAREN2] = ACTIONS(5595),
    [anon_sym_STAR] = ACTIONS(5595),
    [anon_sym_LBRACK] = ACTIONS(5595),
    [anon_sym_static] = ACTIONS(5597),
    [anon_sym_register] = ACTIONS(5597),
    [anon_sym_inline] = ACTIONS(5597),
    [anon_sym_const] = ACTIONS(5597),
    [anon_sym_restrict] = ACTIONS(5597),
    [anon_sym_volatile] = ACTIONS(5597),
    [anon_sym__Atomic] = ACTIONS(5597),
    [anon_sym_mutable] = ACTIONS(5597),
    [anon_sym_explicit] = ACTIONS(5597),
    [anon_sym_constexpr] = ACTIONS(5597),
    [anon_sym_unsigned] = ACTIONS(5597),
    [anon_sym_long] = ACTIONS(5597),
    [anon_sym_short] = ACTIONS(5597),
    [sym_primitive_type] = ACTIONS(5597),
    [anon_sym_enum] = ACTIONS(5597),
    [anon_sym_struct] = ACTIONS(5597),
    [anon_sym_union] = ACTIONS(5597),
    [anon_sym_if] = ACTIONS(5597),
    [anon_sym_switch] = ACTIONS(5597),
    [anon_sym_case] = ACTIONS(5597),
    [anon_sym_default] = ACTIONS(5597),
    [anon_sym_while] = ACTIONS(5597),
    [anon_sym_do] = ACTIONS(5597),
    [anon_sym_for] = ACTIONS(5597),
    [anon_sym_return] = ACTIONS(5597),
    [anon_sym_break] = ACTIONS(5597),
    [anon_sym_continue] = ACTIONS(5597),
    [anon_sym_goto] = ACTIONS(5597),
    [anon_sym_AMP] = ACTIONS(5597),
    [anon_sym_AMP_AMP] = ACTIONS(5595),
    [anon_sym_BANG] = ACTIONS(5595),
    [anon_sym_TILDE] = ACTIONS(5595),
    [anon_sym_PLUS] = ACTIONS(5597),
    [anon_sym_DASH] = ACTIONS(5597),
    [anon_sym_DASH_DASH] = ACTIONS(5595),
    [anon_sym_PLUS_PLUS] = ACTIONS(5595),
    [anon_sym_sizeof] = ACTIONS(5597),
    [sym_number_literal] = ACTIONS(5595),
    [anon_sym_SQUOTE] = ACTIONS(5595),
    [anon_sym_DQUOTE] = ACTIONS(5595),
    [sym_true] = ACTIONS(5597),
    [sym_false] = ACTIONS(5597),
    [sym_null] = ACTIONS(5597),
    [sym_identifier] = ACTIONS(5597),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5597),
    [sym_auto] = ACTIONS(5597),
    [anon_sym_typename] = ACTIONS(5597),
    [anon_sym_template] = ACTIONS(5597),
    [anon_sym_delete] = ACTIONS(5597),
    [anon_sym_namespace] = ACTIONS(5597),
    [anon_sym_using] = ACTIONS(5597),
    [anon_sym_try] = ACTIONS(5597),
    [anon_sym_new] = ACTIONS(5597),
    [anon_sym_COLON_COLON] = ACTIONS(5595),
    [sym_operator_name] = ACTIONS(5595),
    [sym_nullptr] = ACTIONS(5597),
  },
  [3233] = {
    [sym_raw_string_literal] = ACTIONS(5621),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5623),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5623),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5623),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5623),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5623),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5623),
    [sym_preproc_directive] = ACTIONS(5623),
    [anon_sym_SEMI] = ACTIONS(5621),
    [anon_sym_typedef] = ACTIONS(5623),
    [anon_sym_extern] = ACTIONS(5623),
    [anon_sym_LBRACE] = ACTIONS(5621),
    [anon_sym_LPAREN2] = ACTIONS(5621),
    [anon_sym_STAR] = ACTIONS(5621),
    [anon_sym_LBRACK] = ACTIONS(5621),
    [anon_sym_static] = ACTIONS(5623),
    [anon_sym_register] = ACTIONS(5623),
    [anon_sym_inline] = ACTIONS(5623),
    [anon_sym_const] = ACTIONS(5623),
    [anon_sym_restrict] = ACTIONS(5623),
    [anon_sym_volatile] = ACTIONS(5623),
    [anon_sym__Atomic] = ACTIONS(5623),
    [anon_sym_mutable] = ACTIONS(5623),
    [anon_sym_explicit] = ACTIONS(5623),
    [anon_sym_constexpr] = ACTIONS(5623),
    [anon_sym_unsigned] = ACTIONS(5623),
    [anon_sym_long] = ACTIONS(5623),
    [anon_sym_short] = ACTIONS(5623),
    [sym_primitive_type] = ACTIONS(5623),
    [anon_sym_enum] = ACTIONS(5623),
    [anon_sym_struct] = ACTIONS(5623),
    [anon_sym_union] = ACTIONS(5623),
    [anon_sym_if] = ACTIONS(5623),
    [anon_sym_else] = ACTIONS(5623),
    [anon_sym_switch] = ACTIONS(5623),
    [anon_sym_case] = ACTIONS(5623),
    [anon_sym_default] = ACTIONS(5623),
    [anon_sym_while] = ACTIONS(5623),
    [anon_sym_do] = ACTIONS(5623),
    [anon_sym_for] = ACTIONS(5623),
    [anon_sym_return] = ACTIONS(5623),
    [anon_sym_break] = ACTIONS(5623),
    [anon_sym_continue] = ACTIONS(5623),
    [anon_sym_goto] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5623),
    [anon_sym_AMP_AMP] = ACTIONS(5621),
    [anon_sym_BANG] = ACTIONS(5621),
    [anon_sym_TILDE] = ACTIONS(5621),
    [anon_sym_PLUS] = ACTIONS(5623),
    [anon_sym_DASH] = ACTIONS(5623),
    [anon_sym_DASH_DASH] = ACTIONS(5621),
    [anon_sym_PLUS_PLUS] = ACTIONS(5621),
    [anon_sym_sizeof] = ACTIONS(5623),
    [sym_number_literal] = ACTIONS(5621),
    [anon_sym_SQUOTE] = ACTIONS(5621),
    [anon_sym_DQUOTE] = ACTIONS(5621),
    [sym_true] = ACTIONS(5623),
    [sym_false] = ACTIONS(5623),
    [sym_null] = ACTIONS(5623),
    [sym_identifier] = ACTIONS(5623),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5623),
    [sym_auto] = ACTIONS(5623),
    [anon_sym_typename] = ACTIONS(5623),
    [anon_sym_template] = ACTIONS(5623),
    [anon_sym_delete] = ACTIONS(5623),
    [anon_sym_namespace] = ACTIONS(5623),
    [anon_sym_using] = ACTIONS(5623),
    [anon_sym_try] = ACTIONS(5623),
    [anon_sym_new] = ACTIONS(5623),
    [anon_sym_COLON_COLON] = ACTIONS(5621),
    [sym_operator_name] = ACTIONS(5621),
    [sym_nullptr] = ACTIONS(5623),
  },
  [3234] = {
    [anon_sym_LPAREN2] = ACTIONS(7706),
    [anon_sym_constexpr] = ACTIONS(7708),
    [sym_comment] = ACTIONS(91),
  },
  [3235] = {
    [sym_parenthesized_expression] = STATE(3436),
    [anon_sym_LPAREN2] = ACTIONS(323),
    [sym_comment] = ACTIONS(91),
  },
  [3236] = {
    [sym__expression] = STATE(3437),
    [sym_conditional_expression] = STATE(3437),
    [sym_assignment_expression] = STATE(3437),
    [sym_pointer_expression] = STATE(3437),
    [sym_logical_expression] = STATE(3437),
    [sym_bitwise_expression] = STATE(3437),
    [sym_equality_expression] = STATE(3437),
    [sym_relational_expression] = STATE(3437),
    [sym_shift_expression] = STATE(3437),
    [sym_math_expression] = STATE(3437),
    [sym_cast_expression] = STATE(3437),
    [sym_sizeof_expression] = STATE(3437),
    [sym_subscript_expression] = STATE(3437),
    [sym_call_expression] = STATE(3437),
    [sym_field_expression] = STATE(3437),
    [sym_compound_literal_expression] = STATE(3437),
    [sym_parenthesized_expression] = STATE(3437),
    [sym_char_literal] = STATE(3437),
    [sym_concatenated_string] = STATE(3437),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3437),
    [sym_new_expression] = STATE(3437),
    [sym_delete_expression] = STATE(3437),
    [sym_lambda_expression] = STATE(3437),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7710),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(7710),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(7712),
    [sym_false] = ACTIONS(7712),
    [sym_null] = ACTIONS(7712),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(7712),
  },
  [3237] = {
    [anon_sym_COLON] = ACTIONS(7714),
    [sym_comment] = ACTIONS(91),
  },
  [3238] = {
    [sym_parenthesized_expression] = STATE(3439),
    [anon_sym_LPAREN2] = ACTIONS(323),
    [sym_comment] = ACTIONS(91),
  },
  [3239] = {
    [anon_sym_LPAREN2] = ACTIONS(7716),
    [sym_comment] = ACTIONS(91),
  },
  [3240] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(548),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_COLON] = ACTIONS(7718),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(935),
  },
  [3241] = {
    [sym_compound_statement] = STATE(3442),
    [anon_sym_LBRACE] = ACTIONS(357),
    [sym_comment] = ACTIONS(91),
  },
  [3242] = {
    [sym_raw_string_literal] = ACTIONS(6091),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6093),
    [sym_preproc_directive] = ACTIONS(6093),
    [anon_sym_SEMI] = ACTIONS(6091),
    [anon_sym_typedef] = ACTIONS(6093),
    [anon_sym_extern] = ACTIONS(6093),
    [anon_sym_LBRACE] = ACTIONS(6091),
    [anon_sym_LPAREN2] = ACTIONS(6091),
    [anon_sym_STAR] = ACTIONS(6091),
    [anon_sym_LBRACK] = ACTIONS(6091),
    [anon_sym_static] = ACTIONS(6093),
    [anon_sym_register] = ACTIONS(6093),
    [anon_sym_inline] = ACTIONS(6093),
    [anon_sym_const] = ACTIONS(6093),
    [anon_sym_restrict] = ACTIONS(6093),
    [anon_sym_volatile] = ACTIONS(6093),
    [anon_sym__Atomic] = ACTIONS(6093),
    [anon_sym_mutable] = ACTIONS(6093),
    [anon_sym_explicit] = ACTIONS(6093),
    [anon_sym_constexpr] = ACTIONS(6093),
    [anon_sym_unsigned] = ACTIONS(6093),
    [anon_sym_long] = ACTIONS(6093),
    [anon_sym_short] = ACTIONS(6093),
    [sym_primitive_type] = ACTIONS(6093),
    [anon_sym_enum] = ACTIONS(6093),
    [anon_sym_struct] = ACTIONS(6093),
    [anon_sym_union] = ACTIONS(6093),
    [anon_sym_if] = ACTIONS(6093),
    [anon_sym_else] = ACTIONS(7720),
    [anon_sym_switch] = ACTIONS(6093),
    [anon_sym_case] = ACTIONS(6093),
    [anon_sym_default] = ACTIONS(6093),
    [anon_sym_while] = ACTIONS(6093),
    [anon_sym_do] = ACTIONS(6093),
    [anon_sym_for] = ACTIONS(6093),
    [anon_sym_return] = ACTIONS(6093),
    [anon_sym_break] = ACTIONS(6093),
    [anon_sym_continue] = ACTIONS(6093),
    [anon_sym_goto] = ACTIONS(6093),
    [anon_sym_AMP] = ACTIONS(6093),
    [anon_sym_AMP_AMP] = ACTIONS(6091),
    [anon_sym_BANG] = ACTIONS(6091),
    [anon_sym_TILDE] = ACTIONS(6091),
    [anon_sym_PLUS] = ACTIONS(6093),
    [anon_sym_DASH] = ACTIONS(6093),
    [anon_sym_DASH_DASH] = ACTIONS(6091),
    [anon_sym_PLUS_PLUS] = ACTIONS(6091),
    [anon_sym_sizeof] = ACTIONS(6093),
    [sym_number_literal] = ACTIONS(6091),
    [anon_sym_SQUOTE] = ACTIONS(6091),
    [anon_sym_DQUOTE] = ACTIONS(6091),
    [sym_true] = ACTIONS(6093),
    [sym_false] = ACTIONS(6093),
    [sym_null] = ACTIONS(6093),
    [sym_identifier] = ACTIONS(6093),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6093),
    [sym_auto] = ACTIONS(6093),
    [anon_sym_typename] = ACTIONS(6093),
    [anon_sym_template] = ACTIONS(6093),
    [anon_sym_delete] = ACTIONS(6093),
    [anon_sym_namespace] = ACTIONS(6093),
    [anon_sym_using] = ACTIONS(6093),
    [anon_sym_try] = ACTIONS(6093),
    [anon_sym_new] = ACTIONS(6093),
    [anon_sym_COLON_COLON] = ACTIONS(6091),
    [sym_operator_name] = ACTIONS(6091),
    [sym_nullptr] = ACTIONS(6093),
  },
  [3243] = {
    [sym_compound_statement] = STATE(3444),
    [sym_labeled_statement] = STATE(3444),
    [sym_expression_statement] = STATE(3444),
    [sym_if_statement] = STATE(3444),
    [sym_switch_statement] = STATE(3444),
    [sym_case_statement] = STATE(3444),
    [sym_while_statement] = STATE(3444),
    [sym_do_statement] = STATE(3444),
    [sym_for_statement] = STATE(3444),
    [sym_return_statement] = STATE(3444),
    [sym_break_statement] = STATE(3444),
    [sym_continue_statement] = STATE(3444),
    [sym_goto_statement] = STATE(3444),
    [sym__expression] = STATE(1020),
    [sym_comma_expression] = STATE(1021),
    [sym_conditional_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1020),
    [sym_pointer_expression] = STATE(1020),
    [sym_logical_expression] = STATE(1020),
    [sym_bitwise_expression] = STATE(1020),
    [sym_equality_expression] = STATE(1020),
    [sym_relational_expression] = STATE(1020),
    [sym_shift_expression] = STATE(1020),
    [sym_math_expression] = STATE(1020),
    [sym_cast_expression] = STATE(1020),
    [sym_sizeof_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_field_expression] = STATE(1020),
    [sym_compound_literal_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_char_literal] = STATE(1020),
    [sym_concatenated_string] = STATE(1020),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1020),
    [sym_for_range_loop] = STATE(3444),
    [sym_try_statement] = STATE(3444),
    [sym_new_expression] = STATE(1020),
    [sym_delete_expression] = STATE(1020),
    [sym_lambda_expression] = STATE(1020),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2022),
    [anon_sym_SEMI] = ACTIONS(2036),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7300),
    [anon_sym_switch] = ACTIONS(7302),
    [anon_sym_case] = ACTIONS(7304),
    [anon_sym_default] = ACTIONS(7306),
    [anon_sym_while] = ACTIONS(7308),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(7310),
    [anon_sym_return] = ACTIONS(2058),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2062),
    [anon_sym_goto] = ACTIONS(2064),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(7312),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7314),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2066),
  },
  [3244] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(895),
    [anon_sym_RPAREN] = ACTIONS(7722),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3245] = {
    [anon_sym_RPAREN] = ACTIONS(7722),
    [sym_comment] = ACTIONS(91),
  },
  [3246] = {
    [sym_compound_statement] = STATE(3446),
    [sym_labeled_statement] = STATE(3446),
    [sym_expression_statement] = STATE(3446),
    [sym_if_statement] = STATE(3446),
    [sym_switch_statement] = STATE(3446),
    [sym_case_statement] = STATE(3446),
    [sym_while_statement] = STATE(3446),
    [sym_do_statement] = STATE(3446),
    [sym_for_statement] = STATE(3446),
    [sym_return_statement] = STATE(3446),
    [sym_break_statement] = STATE(3446),
    [sym_continue_statement] = STATE(3446),
    [sym_goto_statement] = STATE(3446),
    [sym__expression] = STATE(1020),
    [sym_comma_expression] = STATE(1021),
    [sym_conditional_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1020),
    [sym_pointer_expression] = STATE(1020),
    [sym_logical_expression] = STATE(1020),
    [sym_bitwise_expression] = STATE(1020),
    [sym_equality_expression] = STATE(1020),
    [sym_relational_expression] = STATE(1020),
    [sym_shift_expression] = STATE(1020),
    [sym_math_expression] = STATE(1020),
    [sym_cast_expression] = STATE(1020),
    [sym_sizeof_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_field_expression] = STATE(1020),
    [sym_compound_literal_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_char_literal] = STATE(1020),
    [sym_concatenated_string] = STATE(1020),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1020),
    [sym_for_range_loop] = STATE(3446),
    [sym_try_statement] = STATE(3446),
    [sym_new_expression] = STATE(1020),
    [sym_delete_expression] = STATE(1020),
    [sym_lambda_expression] = STATE(1020),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2022),
    [anon_sym_SEMI] = ACTIONS(2036),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(2044),
    [anon_sym_switch] = ACTIONS(2046),
    [anon_sym_case] = ACTIONS(2048),
    [anon_sym_default] = ACTIONS(2050),
    [anon_sym_while] = ACTIONS(2052),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(2056),
    [anon_sym_return] = ACTIONS(2058),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2062),
    [anon_sym_goto] = ACTIONS(2064),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(5420),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2076),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2066),
  },
  [3247] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3448),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(7724),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3248] = {
    [sym__expression] = STATE(3449),
    [sym_conditional_expression] = STATE(3449),
    [sym_assignment_expression] = STATE(3449),
    [sym_pointer_expression] = STATE(3449),
    [sym_logical_expression] = STATE(3449),
    [sym_bitwise_expression] = STATE(3449),
    [sym_equality_expression] = STATE(3449),
    [sym_relational_expression] = STATE(3449),
    [sym_shift_expression] = STATE(3449),
    [sym_math_expression] = STATE(3449),
    [sym_cast_expression] = STATE(3449),
    [sym_sizeof_expression] = STATE(3449),
    [sym_subscript_expression] = STATE(3449),
    [sym_call_expression] = STATE(3449),
    [sym_field_expression] = STATE(3449),
    [sym_compound_literal_expression] = STATE(3449),
    [sym_parenthesized_expression] = STATE(3449),
    [sym_char_literal] = STATE(3449),
    [sym_concatenated_string] = STATE(3449),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3449),
    [sym_new_expression] = STATE(3449),
    [sym_delete_expression] = STATE(3449),
    [sym_lambda_expression] = STATE(3449),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7726),
    [anon_sym_RPAREN] = ACTIONS(7724),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(7726),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7728),
    [sym_false] = ACTIONS(7728),
    [sym_null] = ACTIONS(7728),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(7728),
  },
  [3249] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(7730),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3250] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(7732),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3251] = {
    [sym_raw_string_literal] = ACTIONS(6372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6374),
    [sym_preproc_directive] = ACTIONS(6374),
    [anon_sym_SEMI] = ACTIONS(6372),
    [anon_sym_typedef] = ACTIONS(6374),
    [anon_sym_extern] = ACTIONS(6374),
    [anon_sym_LBRACE] = ACTIONS(6372),
    [anon_sym_LPAREN2] = ACTIONS(6372),
    [anon_sym_STAR] = ACTIONS(6372),
    [anon_sym_LBRACK] = ACTIONS(6372),
    [anon_sym_static] = ACTIONS(6374),
    [anon_sym_register] = ACTIONS(6374),
    [anon_sym_inline] = ACTIONS(6374),
    [anon_sym_const] = ACTIONS(6374),
    [anon_sym_restrict] = ACTIONS(6374),
    [anon_sym_volatile] = ACTIONS(6374),
    [anon_sym__Atomic] = ACTIONS(6374),
    [anon_sym_mutable] = ACTIONS(6374),
    [anon_sym_explicit] = ACTIONS(6374),
    [anon_sym_constexpr] = ACTIONS(6374),
    [anon_sym_unsigned] = ACTIONS(6374),
    [anon_sym_long] = ACTIONS(6374),
    [anon_sym_short] = ACTIONS(6374),
    [sym_primitive_type] = ACTIONS(6374),
    [anon_sym_enum] = ACTIONS(6374),
    [anon_sym_struct] = ACTIONS(6374),
    [anon_sym_union] = ACTIONS(6374),
    [anon_sym_if] = ACTIONS(6374),
    [anon_sym_switch] = ACTIONS(6374),
    [anon_sym_case] = ACTIONS(6374),
    [anon_sym_default] = ACTIONS(6374),
    [anon_sym_while] = ACTIONS(6374),
    [anon_sym_do] = ACTIONS(6374),
    [anon_sym_for] = ACTIONS(6374),
    [anon_sym_return] = ACTIONS(6374),
    [anon_sym_break] = ACTIONS(6374),
    [anon_sym_continue] = ACTIONS(6374),
    [anon_sym_goto] = ACTIONS(6374),
    [anon_sym_AMP] = ACTIONS(6374),
    [anon_sym_AMP_AMP] = ACTIONS(6372),
    [anon_sym_BANG] = ACTIONS(6372),
    [anon_sym_TILDE] = ACTIONS(6372),
    [anon_sym_PLUS] = ACTIONS(6374),
    [anon_sym_DASH] = ACTIONS(6374),
    [anon_sym_DASH_DASH] = ACTIONS(6372),
    [anon_sym_PLUS_PLUS] = ACTIONS(6372),
    [anon_sym_sizeof] = ACTIONS(6374),
    [sym_number_literal] = ACTIONS(6372),
    [anon_sym_SQUOTE] = ACTIONS(6372),
    [anon_sym_DQUOTE] = ACTIONS(6372),
    [sym_true] = ACTIONS(6374),
    [sym_false] = ACTIONS(6374),
    [sym_null] = ACTIONS(6374),
    [sym_identifier] = ACTIONS(6374),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6374),
    [sym_auto] = ACTIONS(6374),
    [anon_sym_typename] = ACTIONS(6374),
    [anon_sym_template] = ACTIONS(6374),
    [anon_sym_delete] = ACTIONS(6374),
    [anon_sym_namespace] = ACTIONS(6374),
    [anon_sym_using] = ACTIONS(6374),
    [anon_sym_try] = ACTIONS(6374),
    [anon_sym_new] = ACTIONS(6374),
    [anon_sym_COLON_COLON] = ACTIONS(6372),
    [sym_operator_name] = ACTIONS(6372),
    [sym_nullptr] = ACTIONS(6374),
  },
  [3252] = {
    [sym_raw_string_literal] = ACTIONS(6379),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6381),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6381),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6381),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6381),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6381),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6381),
    [sym_preproc_directive] = ACTIONS(6381),
    [anon_sym_SEMI] = ACTIONS(6379),
    [anon_sym_typedef] = ACTIONS(6381),
    [anon_sym_extern] = ACTIONS(6381),
    [anon_sym_LBRACE] = ACTIONS(6379),
    [anon_sym_LPAREN2] = ACTIONS(6379),
    [anon_sym_STAR] = ACTIONS(6379),
    [anon_sym_LBRACK] = ACTIONS(6379),
    [anon_sym_static] = ACTIONS(6381),
    [anon_sym_register] = ACTIONS(6381),
    [anon_sym_inline] = ACTIONS(6381),
    [anon_sym_const] = ACTIONS(6381),
    [anon_sym_restrict] = ACTIONS(6381),
    [anon_sym_volatile] = ACTIONS(6381),
    [anon_sym__Atomic] = ACTIONS(6381),
    [anon_sym_mutable] = ACTIONS(6381),
    [anon_sym_explicit] = ACTIONS(6381),
    [anon_sym_constexpr] = ACTIONS(6381),
    [anon_sym_unsigned] = ACTIONS(6381),
    [anon_sym_long] = ACTIONS(6381),
    [anon_sym_short] = ACTIONS(6381),
    [sym_primitive_type] = ACTIONS(6381),
    [anon_sym_enum] = ACTIONS(6381),
    [anon_sym_struct] = ACTIONS(6381),
    [anon_sym_union] = ACTIONS(6381),
    [anon_sym_if] = ACTIONS(6381),
    [anon_sym_else] = ACTIONS(6381),
    [anon_sym_switch] = ACTIONS(6381),
    [anon_sym_case] = ACTIONS(6381),
    [anon_sym_default] = ACTIONS(6381),
    [anon_sym_while] = ACTIONS(6381),
    [anon_sym_do] = ACTIONS(6381),
    [anon_sym_for] = ACTIONS(6381),
    [anon_sym_return] = ACTIONS(6381),
    [anon_sym_break] = ACTIONS(6381),
    [anon_sym_continue] = ACTIONS(6381),
    [anon_sym_goto] = ACTIONS(6381),
    [anon_sym_AMP] = ACTIONS(6381),
    [anon_sym_AMP_AMP] = ACTIONS(6379),
    [anon_sym_BANG] = ACTIONS(6379),
    [anon_sym_TILDE] = ACTIONS(6379),
    [anon_sym_PLUS] = ACTIONS(6381),
    [anon_sym_DASH] = ACTIONS(6381),
    [anon_sym_DASH_DASH] = ACTIONS(6379),
    [anon_sym_PLUS_PLUS] = ACTIONS(6379),
    [anon_sym_sizeof] = ACTIONS(6381),
    [sym_number_literal] = ACTIONS(6379),
    [anon_sym_SQUOTE] = ACTIONS(6379),
    [anon_sym_DQUOTE] = ACTIONS(6379),
    [sym_true] = ACTIONS(6381),
    [sym_false] = ACTIONS(6381),
    [sym_null] = ACTIONS(6381),
    [sym_identifier] = ACTIONS(6381),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6381),
    [sym_auto] = ACTIONS(6381),
    [anon_sym_typename] = ACTIONS(6381),
    [anon_sym_template] = ACTIONS(6381),
    [anon_sym_delete] = ACTIONS(6381),
    [anon_sym_namespace] = ACTIONS(6381),
    [anon_sym_using] = ACTIONS(6381),
    [anon_sym_try] = ACTIONS(6381),
    [anon_sym_catch] = ACTIONS(6381),
    [anon_sym_new] = ACTIONS(6381),
    [anon_sym_COLON_COLON] = ACTIONS(6379),
    [sym_operator_name] = ACTIONS(6379),
    [sym_nullptr] = ACTIONS(6381),
  },
  [3253] = {
    [sym_raw_string_literal] = ACTIONS(6503),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6505),
    [sym_preproc_directive] = ACTIONS(6505),
    [anon_sym_SEMI] = ACTIONS(6503),
    [anon_sym_typedef] = ACTIONS(6505),
    [anon_sym_extern] = ACTIONS(6505),
    [anon_sym_LBRACE] = ACTIONS(6503),
    [anon_sym_LPAREN2] = ACTIONS(6503),
    [anon_sym_STAR] = ACTIONS(6503),
    [anon_sym_LBRACK] = ACTIONS(6503),
    [anon_sym_static] = ACTIONS(6505),
    [anon_sym_register] = ACTIONS(6505),
    [anon_sym_inline] = ACTIONS(6505),
    [anon_sym_const] = ACTIONS(6505),
    [anon_sym_restrict] = ACTIONS(6505),
    [anon_sym_volatile] = ACTIONS(6505),
    [anon_sym__Atomic] = ACTIONS(6505),
    [anon_sym_mutable] = ACTIONS(6505),
    [anon_sym_explicit] = ACTIONS(6505),
    [anon_sym_constexpr] = ACTIONS(6505),
    [anon_sym_unsigned] = ACTIONS(6505),
    [anon_sym_long] = ACTIONS(6505),
    [anon_sym_short] = ACTIONS(6505),
    [sym_primitive_type] = ACTIONS(6505),
    [anon_sym_enum] = ACTIONS(6505),
    [anon_sym_struct] = ACTIONS(6505),
    [anon_sym_union] = ACTIONS(6505),
    [anon_sym_if] = ACTIONS(6505),
    [anon_sym_switch] = ACTIONS(6505),
    [anon_sym_case] = ACTIONS(6505),
    [anon_sym_default] = ACTIONS(6505),
    [anon_sym_while] = ACTIONS(6505),
    [anon_sym_do] = ACTIONS(6505),
    [anon_sym_for] = ACTIONS(6505),
    [anon_sym_return] = ACTIONS(6505),
    [anon_sym_break] = ACTIONS(6505),
    [anon_sym_continue] = ACTIONS(6505),
    [anon_sym_goto] = ACTIONS(6505),
    [anon_sym_AMP] = ACTIONS(6505),
    [anon_sym_AMP_AMP] = ACTIONS(6503),
    [anon_sym_BANG] = ACTIONS(6503),
    [anon_sym_TILDE] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6505),
    [anon_sym_DASH] = ACTIONS(6505),
    [anon_sym_DASH_DASH] = ACTIONS(6503),
    [anon_sym_PLUS_PLUS] = ACTIONS(6503),
    [anon_sym_sizeof] = ACTIONS(6505),
    [sym_number_literal] = ACTIONS(6503),
    [anon_sym_SQUOTE] = ACTIONS(6503),
    [anon_sym_DQUOTE] = ACTIONS(6503),
    [sym_true] = ACTIONS(6505),
    [sym_false] = ACTIONS(6505),
    [sym_null] = ACTIONS(6505),
    [sym_identifier] = ACTIONS(6505),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6505),
    [sym_auto] = ACTIONS(6505),
    [anon_sym_typename] = ACTIONS(6505),
    [anon_sym_template] = ACTIONS(6505),
    [anon_sym_delete] = ACTIONS(6505),
    [anon_sym_namespace] = ACTIONS(6505),
    [anon_sym_using] = ACTIONS(6505),
    [anon_sym_try] = ACTIONS(6505),
    [anon_sym_new] = ACTIONS(6505),
    [anon_sym_COLON_COLON] = ACTIONS(6503),
    [sym_operator_name] = ACTIONS(6503),
    [sym_nullptr] = ACTIONS(6505),
  },
  [3254] = {
    [sym__expression] = STATE(3452),
    [sym_conditional_expression] = STATE(3452),
    [sym_assignment_expression] = STATE(3452),
    [sym_pointer_expression] = STATE(3452),
    [sym_logical_expression] = STATE(3452),
    [sym_bitwise_expression] = STATE(3452),
    [sym_equality_expression] = STATE(3452),
    [sym_relational_expression] = STATE(3452),
    [sym_shift_expression] = STATE(3452),
    [sym_math_expression] = STATE(3452),
    [sym_cast_expression] = STATE(3452),
    [sym_sizeof_expression] = STATE(3452),
    [sym_subscript_expression] = STATE(3452),
    [sym_call_expression] = STATE(3452),
    [sym_field_expression] = STATE(3452),
    [sym_compound_literal_expression] = STATE(3452),
    [sym_parenthesized_expression] = STATE(3452),
    [sym_char_literal] = STATE(3452),
    [sym_concatenated_string] = STATE(3452),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3452),
    [sym_new_expression] = STATE(3452),
    [sym_delete_expression] = STATE(3452),
    [sym_lambda_expression] = STATE(3452),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7734),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(7734),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7736),
    [sym_false] = ACTIONS(7736),
    [sym_null] = ACTIONS(7736),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(7736),
  },
  [3255] = {
    [anon_sym_LPAREN2] = ACTIONS(7738),
    [sym_comment] = ACTIONS(91),
  },
  [3256] = {
    [sym_compound_statement] = STATE(1810),
    [sym_labeled_statement] = STATE(1810),
    [sym_expression_statement] = STATE(1810),
    [sym_if_statement] = STATE(1810),
    [sym_switch_statement] = STATE(1810),
    [sym_case_statement] = STATE(1810),
    [sym_while_statement] = STATE(1810),
    [sym_do_statement] = STATE(1810),
    [sym_for_statement] = STATE(1810),
    [sym_return_statement] = STATE(1810),
    [sym_break_statement] = STATE(1810),
    [sym_continue_statement] = STATE(1810),
    [sym_goto_statement] = STATE(1810),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(411),
    [sym_for_range_loop] = STATE(1810),
    [sym_try_statement] = STATE(1810),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(678),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(6682),
    [anon_sym_switch] = ACTIONS(6684),
    [anon_sym_case] = ACTIONS(6686),
    [anon_sym_default] = ACTIONS(6688),
    [anon_sym_while] = ACTIONS(6690),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(6692),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(6694),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(6696),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(726),
  },
  [3257] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_COLON] = ACTIONS(7740),
    [anon_sym_QMARK] = ACTIONS(1171),
    [anon_sym_STAR_EQ] = ACTIONS(1173),
    [anon_sym_SLASH_EQ] = ACTIONS(1173),
    [anon_sym_PERCENT_EQ] = ACTIONS(1173),
    [anon_sym_PLUS_EQ] = ACTIONS(1173),
    [anon_sym_DASH_EQ] = ACTIONS(1173),
    [anon_sym_LT_LT_EQ] = ACTIONS(1173),
    [anon_sym_GT_GT_EQ] = ACTIONS(1173),
    [anon_sym_AMP_EQ] = ACTIONS(1173),
    [anon_sym_CARET_EQ] = ACTIONS(1173),
    [anon_sym_PIPE_EQ] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_CARET] = ACTIONS(1183),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [3258] = {
    [sym_declaration] = STATE(1813),
    [sym_type_definition] = STATE(1813),
    [sym__declaration_specifiers] = STATE(1814),
    [sym_compound_statement] = STATE(1813),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_labeled_statement] = STATE(1813),
    [sym_expression_statement] = STATE(1813),
    [sym_if_statement] = STATE(1813),
    [sym_switch_statement] = STATE(1813),
    [sym_case_statement] = STATE(1813),
    [sym_while_statement] = STATE(1813),
    [sym_do_statement] = STATE(1813),
    [sym_for_statement] = STATE(1813),
    [sym_return_statement] = STATE(1813),
    [sym_break_statement] = STATE(1813),
    [sym_continue_statement] = STATE(1813),
    [sym_goto_statement] = STATE(1813),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(411),
    [sym_for_range_loop] = STATE(1813),
    [sym_try_statement] = STATE(1813),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(678),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_typedef] = ACTIONS(698),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(6682),
    [anon_sym_switch] = ACTIONS(6684),
    [anon_sym_case] = ACTIONS(6686),
    [anon_sym_default] = ACTIONS(6688),
    [anon_sym_while] = ACTIONS(6690),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(6692),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(7742),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(6696),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(1202),
    [sym_nullptr] = ACTIONS(726),
  },
  [3259] = {
    [sym_compound_statement] = STATE(1815),
    [sym_labeled_statement] = STATE(1815),
    [sym_expression_statement] = STATE(1815),
    [sym_if_statement] = STATE(1815),
    [sym_switch_statement] = STATE(1815),
    [sym_case_statement] = STATE(1815),
    [sym_while_statement] = STATE(1815),
    [sym_do_statement] = STATE(1815),
    [sym_for_statement] = STATE(1815),
    [sym_return_statement] = STATE(1815),
    [sym_break_statement] = STATE(1815),
    [sym_continue_statement] = STATE(1815),
    [sym_goto_statement] = STATE(1815),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(411),
    [sym_for_range_loop] = STATE(1815),
    [sym_try_statement] = STATE(1815),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(678),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(6682),
    [anon_sym_switch] = ACTIONS(6684),
    [anon_sym_case] = ACTIONS(6686),
    [anon_sym_default] = ACTIONS(6688),
    [anon_sym_while] = ACTIONS(6690),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(6692),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(6694),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(6696),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(726),
  },
  [3260] = {
    [sym_declaration] = STATE(3456),
    [sym__declaration_specifiers] = STATE(709),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym__expression] = STATE(3457),
    [sym_conditional_expression] = STATE(3457),
    [sym_assignment_expression] = STATE(3457),
    [sym_pointer_expression] = STATE(3457),
    [sym_logical_expression] = STATE(3457),
    [sym_bitwise_expression] = STATE(3457),
    [sym_equality_expression] = STATE(3457),
    [sym_relational_expression] = STATE(3457),
    [sym_shift_expression] = STATE(3457),
    [sym_math_expression] = STATE(3457),
    [sym_cast_expression] = STATE(3457),
    [sym_sizeof_expression] = STATE(3457),
    [sym_subscript_expression] = STATE(3457),
    [sym_call_expression] = STATE(3457),
    [sym_field_expression] = STATE(3457),
    [sym_compound_literal_expression] = STATE(3457),
    [sym_parenthesized_expression] = STATE(3457),
    [sym_char_literal] = STATE(3457),
    [sym_concatenated_string] = STATE(3457),
    [sym_string_literal] = STATE(238),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(3457),
    [sym_for_range_declaration] = STATE(3458),
    [sym_new_expression] = STATE(3457),
    [sym_delete_expression] = STATE(3457),
    [sym_lambda_expression] = STATE(3457),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(7744),
    [anon_sym_SEMI] = ACTIONS(7746),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(7744),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7748),
    [sym_false] = ACTIONS(7748),
    [sym_null] = ACTIONS(7748),
    [sym_identifier] = ACTIONS(1242),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(1244),
    [sym_nullptr] = ACTIONS(7748),
  },
  [3261] = {
    [sym_compound_statement] = STATE(1822),
    [sym_labeled_statement] = STATE(1822),
    [sym_expression_statement] = STATE(1822),
    [sym_if_statement] = STATE(1822),
    [sym_switch_statement] = STATE(1822),
    [sym_case_statement] = STATE(1822),
    [sym_while_statement] = STATE(1822),
    [sym_do_statement] = STATE(1822),
    [sym_for_statement] = STATE(1822),
    [sym_return_statement] = STATE(1822),
    [sym_break_statement] = STATE(1822),
    [sym_continue_statement] = STATE(1822),
    [sym_goto_statement] = STATE(1822),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(411),
    [sym_for_range_loop] = STATE(1822),
    [sym_try_statement] = STATE(1822),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(678),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(6682),
    [anon_sym_switch] = ACTIONS(6684),
    [anon_sym_case] = ACTIONS(6686),
    [anon_sym_default] = ACTIONS(6688),
    [anon_sym_while] = ACTIONS(6690),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(6692),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(6694),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(6696),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(726),
  },
  [3262] = {
    [sym_catch_clause] = STATE(3459),
    [aux_sym_try_statement_repeat1] = STATE(3459),
    [sym_comment] = ACTIONS(91),
    [anon_sym_catch] = ACTIONS(3837),
  },
  [3263] = {
    [sym_compound_statement] = STATE(3460),
    [sym_labeled_statement] = STATE(3460),
    [sym_expression_statement] = STATE(3460),
    [sym_if_statement] = STATE(3460),
    [sym_switch_statement] = STATE(3460),
    [sym_case_statement] = STATE(3460),
    [sym_while_statement] = STATE(3460),
    [sym_do_statement] = STATE(3460),
    [sym_for_statement] = STATE(3460),
    [sym_return_statement] = STATE(3460),
    [sym_break_statement] = STATE(3460),
    [sym_continue_statement] = STATE(3460),
    [sym_goto_statement] = STATE(3460),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(411),
    [sym_for_range_loop] = STATE(3460),
    [sym_try_statement] = STATE(3460),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(678),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(704),
    [anon_sym_switch] = ACTIONS(706),
    [anon_sym_case] = ACTIONS(708),
    [anon_sym_default] = ACTIONS(710),
    [anon_sym_while] = ACTIONS(712),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(3807),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(736),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(726),
  },
  [3264] = {
    [sym_raw_string_literal] = ACTIONS(7063),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7065),
    [sym_preproc_directive] = ACTIONS(7065),
    [anon_sym_SEMI] = ACTIONS(7063),
    [anon_sym_typedef] = ACTIONS(7065),
    [anon_sym_extern] = ACTIONS(7065),
    [anon_sym_LBRACE] = ACTIONS(7063),
    [anon_sym_LPAREN2] = ACTIONS(7063),
    [anon_sym_STAR] = ACTIONS(7063),
    [anon_sym_LBRACK] = ACTIONS(7063),
    [anon_sym_static] = ACTIONS(7065),
    [anon_sym_register] = ACTIONS(7065),
    [anon_sym_inline] = ACTIONS(7065),
    [anon_sym_const] = ACTIONS(7065),
    [anon_sym_restrict] = ACTIONS(7065),
    [anon_sym_volatile] = ACTIONS(7065),
    [anon_sym__Atomic] = ACTIONS(7065),
    [anon_sym_mutable] = ACTIONS(7065),
    [anon_sym_explicit] = ACTIONS(7065),
    [anon_sym_constexpr] = ACTIONS(7065),
    [anon_sym_unsigned] = ACTIONS(7065),
    [anon_sym_long] = ACTIONS(7065),
    [anon_sym_short] = ACTIONS(7065),
    [sym_primitive_type] = ACTIONS(7065),
    [anon_sym_enum] = ACTIONS(7065),
    [anon_sym_struct] = ACTIONS(7065),
    [anon_sym_union] = ACTIONS(7065),
    [anon_sym_if] = ACTIONS(7065),
    [anon_sym_else] = ACTIONS(7750),
    [anon_sym_switch] = ACTIONS(7065),
    [anon_sym_case] = ACTIONS(7065),
    [anon_sym_default] = ACTIONS(7065),
    [anon_sym_while] = ACTIONS(7065),
    [anon_sym_do] = ACTIONS(7065),
    [anon_sym_for] = ACTIONS(7065),
    [anon_sym_return] = ACTIONS(7065),
    [anon_sym_break] = ACTIONS(7065),
    [anon_sym_continue] = ACTIONS(7065),
    [anon_sym_goto] = ACTIONS(7065),
    [anon_sym_AMP] = ACTIONS(7065),
    [anon_sym_AMP_AMP] = ACTIONS(7063),
    [anon_sym_BANG] = ACTIONS(7063),
    [anon_sym_TILDE] = ACTIONS(7063),
    [anon_sym_PLUS] = ACTIONS(7065),
    [anon_sym_DASH] = ACTIONS(7065),
    [anon_sym_DASH_DASH] = ACTIONS(7063),
    [anon_sym_PLUS_PLUS] = ACTIONS(7063),
    [anon_sym_sizeof] = ACTIONS(7065),
    [sym_number_literal] = ACTIONS(7063),
    [anon_sym_SQUOTE] = ACTIONS(7063),
    [anon_sym_DQUOTE] = ACTIONS(7063),
    [sym_true] = ACTIONS(7065),
    [sym_false] = ACTIONS(7065),
    [sym_null] = ACTIONS(7065),
    [sym_identifier] = ACTIONS(7065),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7065),
    [sym_auto] = ACTIONS(7065),
    [anon_sym_typename] = ACTIONS(7065),
    [anon_sym_template] = ACTIONS(7065),
    [anon_sym_delete] = ACTIONS(7065),
    [anon_sym_namespace] = ACTIONS(7065),
    [anon_sym_using] = ACTIONS(7065),
    [anon_sym_try] = ACTIONS(7065),
    [anon_sym_new] = ACTIONS(7065),
    [anon_sym_COLON_COLON] = ACTIONS(7063),
    [sym_operator_name] = ACTIONS(7063),
    [sym_nullptr] = ACTIONS(7065),
  },
  [3265] = {
    [sym_raw_string_literal] = ACTIONS(2475),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2477),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2477),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2477),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2477),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2477),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2477),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2477),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2477),
    [sym_preproc_directive] = ACTIONS(2477),
    [anon_sym_SEMI] = ACTIONS(2475),
    [anon_sym_typedef] = ACTIONS(2477),
    [anon_sym_extern] = ACTIONS(2477),
    [anon_sym_LBRACE] = ACTIONS(2475),
    [anon_sym_LPAREN2] = ACTIONS(2475),
    [anon_sym_STAR] = ACTIONS(2475),
    [anon_sym_LBRACK] = ACTIONS(2475),
    [anon_sym_static] = ACTIONS(2477),
    [anon_sym_register] = ACTIONS(2477),
    [anon_sym_inline] = ACTIONS(2477),
    [anon_sym_const] = ACTIONS(2477),
    [anon_sym_restrict] = ACTIONS(2477),
    [anon_sym_volatile] = ACTIONS(2477),
    [anon_sym__Atomic] = ACTIONS(2477),
    [anon_sym_mutable] = ACTIONS(2477),
    [anon_sym_explicit] = ACTIONS(2477),
    [anon_sym_constexpr] = ACTIONS(2477),
    [anon_sym_unsigned] = ACTIONS(2477),
    [anon_sym_long] = ACTIONS(2477),
    [anon_sym_short] = ACTIONS(2477),
    [sym_primitive_type] = ACTIONS(2477),
    [anon_sym_enum] = ACTIONS(2477),
    [anon_sym_struct] = ACTIONS(2477),
    [anon_sym_union] = ACTIONS(2477),
    [anon_sym_if] = ACTIONS(2477),
    [anon_sym_else] = ACTIONS(2477),
    [anon_sym_switch] = ACTIONS(2477),
    [anon_sym_case] = ACTIONS(2477),
    [anon_sym_default] = ACTIONS(2477),
    [anon_sym_while] = ACTIONS(2477),
    [anon_sym_do] = ACTIONS(2477),
    [anon_sym_for] = ACTIONS(2477),
    [anon_sym_return] = ACTIONS(2477),
    [anon_sym_break] = ACTIONS(2477),
    [anon_sym_continue] = ACTIONS(2477),
    [anon_sym_goto] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2477),
    [anon_sym_AMP_AMP] = ACTIONS(2475),
    [anon_sym_BANG] = ACTIONS(2475),
    [anon_sym_TILDE] = ACTIONS(2475),
    [anon_sym_PLUS] = ACTIONS(2477),
    [anon_sym_DASH] = ACTIONS(2477),
    [anon_sym_DASH_DASH] = ACTIONS(2475),
    [anon_sym_PLUS_PLUS] = ACTIONS(2475),
    [anon_sym_sizeof] = ACTIONS(2477),
    [sym_number_literal] = ACTIONS(2475),
    [anon_sym_SQUOTE] = ACTIONS(2475),
    [anon_sym_DQUOTE] = ACTIONS(2475),
    [sym_true] = ACTIONS(2477),
    [sym_false] = ACTIONS(2477),
    [sym_null] = ACTIONS(2477),
    [sym_identifier] = ACTIONS(2477),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2477),
    [sym_auto] = ACTIONS(2477),
    [anon_sym_typename] = ACTIONS(2477),
    [anon_sym_template] = ACTIONS(2477),
    [anon_sym_delete] = ACTIONS(2477),
    [anon_sym_namespace] = ACTIONS(2477),
    [anon_sym_using] = ACTIONS(2477),
    [anon_sym_try] = ACTIONS(2477),
    [anon_sym_new] = ACTIONS(2477),
    [anon_sym_COLON_COLON] = ACTIONS(2475),
    [sym_operator_name] = ACTIONS(2475),
    [sym_nullptr] = ACTIONS(2477),
  },
  [3266] = {
    [sym_raw_string_literal] = ACTIONS(7095),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7097),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7097),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7097),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7097),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7097),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7097),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7097),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7097),
    [sym_preproc_directive] = ACTIONS(7097),
    [anon_sym_SEMI] = ACTIONS(7095),
    [anon_sym_typedef] = ACTIONS(7097),
    [anon_sym_extern] = ACTIONS(7097),
    [anon_sym_LBRACE] = ACTIONS(7095),
    [anon_sym_LPAREN2] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7095),
    [anon_sym_LBRACK] = ACTIONS(7095),
    [anon_sym_static] = ACTIONS(7097),
    [anon_sym_register] = ACTIONS(7097),
    [anon_sym_inline] = ACTIONS(7097),
    [anon_sym_const] = ACTIONS(7097),
    [anon_sym_restrict] = ACTIONS(7097),
    [anon_sym_volatile] = ACTIONS(7097),
    [anon_sym__Atomic] = ACTIONS(7097),
    [anon_sym_mutable] = ACTIONS(7097),
    [anon_sym_explicit] = ACTIONS(7097),
    [anon_sym_constexpr] = ACTIONS(7097),
    [anon_sym_unsigned] = ACTIONS(7097),
    [anon_sym_long] = ACTIONS(7097),
    [anon_sym_short] = ACTIONS(7097),
    [sym_primitive_type] = ACTIONS(7097),
    [anon_sym_enum] = ACTIONS(7097),
    [anon_sym_struct] = ACTIONS(7097),
    [anon_sym_union] = ACTIONS(7097),
    [anon_sym_if] = ACTIONS(7097),
    [anon_sym_else] = ACTIONS(7097),
    [anon_sym_switch] = ACTIONS(7097),
    [anon_sym_case] = ACTIONS(7097),
    [anon_sym_default] = ACTIONS(7097),
    [anon_sym_while] = ACTIONS(7097),
    [anon_sym_do] = ACTIONS(7097),
    [anon_sym_for] = ACTIONS(7097),
    [anon_sym_return] = ACTIONS(7097),
    [anon_sym_break] = ACTIONS(7097),
    [anon_sym_continue] = ACTIONS(7097),
    [anon_sym_goto] = ACTIONS(7097),
    [anon_sym_AMP] = ACTIONS(7097),
    [anon_sym_AMP_AMP] = ACTIONS(7095),
    [anon_sym_BANG] = ACTIONS(7095),
    [anon_sym_TILDE] = ACTIONS(7095),
    [anon_sym_PLUS] = ACTIONS(7097),
    [anon_sym_DASH] = ACTIONS(7097),
    [anon_sym_DASH_DASH] = ACTIONS(7095),
    [anon_sym_PLUS_PLUS] = ACTIONS(7095),
    [anon_sym_sizeof] = ACTIONS(7097),
    [sym_number_literal] = ACTIONS(7095),
    [anon_sym_SQUOTE] = ACTIONS(7095),
    [anon_sym_DQUOTE] = ACTIONS(7095),
    [sym_true] = ACTIONS(7097),
    [sym_false] = ACTIONS(7097),
    [sym_null] = ACTIONS(7097),
    [sym_identifier] = ACTIONS(7097),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7097),
    [sym_auto] = ACTIONS(7097),
    [anon_sym_typename] = ACTIONS(7097),
    [anon_sym_template] = ACTIONS(7097),
    [anon_sym_delete] = ACTIONS(7097),
    [anon_sym_namespace] = ACTIONS(7097),
    [anon_sym_using] = ACTIONS(7097),
    [anon_sym_try] = ACTIONS(7097),
    [anon_sym_new] = ACTIONS(7097),
    [anon_sym_COLON_COLON] = ACTIONS(7095),
    [sym_operator_name] = ACTIONS(7095),
    [sym_nullptr] = ACTIONS(7097),
  },
  [3267] = {
    [sym_compound_statement] = STATE(3462),
    [sym_labeled_statement] = STATE(3462),
    [sym_expression_statement] = STATE(3462),
    [sym_if_statement] = STATE(3462),
    [sym_switch_statement] = STATE(3462),
    [sym_case_statement] = STATE(3462),
    [sym_while_statement] = STATE(3462),
    [sym_do_statement] = STATE(3462),
    [sym_for_statement] = STATE(3462),
    [sym_return_statement] = STATE(3462),
    [sym_break_statement] = STATE(3462),
    [sym_continue_statement] = STATE(3462),
    [sym_goto_statement] = STATE(3462),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(411),
    [sym_for_range_loop] = STATE(3462),
    [sym_try_statement] = STATE(3462),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(678),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(704),
    [anon_sym_switch] = ACTIONS(706),
    [anon_sym_case] = ACTIONS(708),
    [anon_sym_default] = ACTIONS(710),
    [anon_sym_while] = ACTIONS(712),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(3807),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(736),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(726),
  },
  [3268] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(7752),
    [sym_comment] = ACTIONS(91),
  },
  [3269] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3464),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(7752),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3270] = {
    [sym__expression] = STATE(3465),
    [sym_conditional_expression] = STATE(3465),
    [sym_assignment_expression] = STATE(3465),
    [sym_pointer_expression] = STATE(3465),
    [sym_logical_expression] = STATE(3465),
    [sym_bitwise_expression] = STATE(3465),
    [sym_equality_expression] = STATE(3465),
    [sym_relational_expression] = STATE(3465),
    [sym_shift_expression] = STATE(3465),
    [sym_math_expression] = STATE(3465),
    [sym_cast_expression] = STATE(3465),
    [sym_sizeof_expression] = STATE(3465),
    [sym_subscript_expression] = STATE(3465),
    [sym_call_expression] = STATE(3465),
    [sym_field_expression] = STATE(3465),
    [sym_compound_literal_expression] = STATE(3465),
    [sym_parenthesized_expression] = STATE(3465),
    [sym_char_literal] = STATE(3465),
    [sym_concatenated_string] = STATE(3465),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3465),
    [sym_new_expression] = STATE(3465),
    [sym_delete_expression] = STATE(3465),
    [sym_lambda_expression] = STATE(3465),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7754),
    [anon_sym_RPAREN] = ACTIONS(7752),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(7754),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7756),
    [sym_false] = ACTIONS(7756),
    [sym_null] = ACTIONS(7756),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(7756),
  },
  [3271] = {
    [sym_compound_statement] = STATE(3466),
    [sym_labeled_statement] = STATE(3466),
    [sym_expression_statement] = STATE(3466),
    [sym_if_statement] = STATE(3466),
    [sym_switch_statement] = STATE(3466),
    [sym_case_statement] = STATE(3466),
    [sym_while_statement] = STATE(3466),
    [sym_do_statement] = STATE(3466),
    [sym_for_statement] = STATE(3466),
    [sym_return_statement] = STATE(3466),
    [sym_break_statement] = STATE(3466),
    [sym_continue_statement] = STATE(3466),
    [sym_goto_statement] = STATE(3466),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(411),
    [sym_for_range_loop] = STATE(3466),
    [sym_try_statement] = STATE(3466),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(678),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(704),
    [anon_sym_switch] = ACTIONS(706),
    [anon_sym_case] = ACTIONS(708),
    [anon_sym_default] = ACTIONS(710),
    [anon_sym_while] = ACTIONS(712),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(3807),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(736),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(726),
  },
  [3272] = {
    [sym_raw_string_literal] = ACTIONS(5376),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5378),
    [sym_preproc_directive] = ACTIONS(5378),
    [anon_sym_SEMI] = ACTIONS(5376),
    [anon_sym_typedef] = ACTIONS(5378),
    [anon_sym_extern] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(5376),
    [anon_sym_LPAREN2] = ACTIONS(5376),
    [anon_sym_STAR] = ACTIONS(5376),
    [anon_sym_LBRACK] = ACTIONS(5376),
    [anon_sym_static] = ACTIONS(5378),
    [anon_sym_register] = ACTIONS(5378),
    [anon_sym_inline] = ACTIONS(5378),
    [anon_sym_const] = ACTIONS(5378),
    [anon_sym_restrict] = ACTIONS(5378),
    [anon_sym_volatile] = ACTIONS(5378),
    [anon_sym__Atomic] = ACTIONS(5378),
    [anon_sym_mutable] = ACTIONS(5378),
    [anon_sym_explicit] = ACTIONS(5378),
    [anon_sym_constexpr] = ACTIONS(5378),
    [anon_sym_unsigned] = ACTIONS(5378),
    [anon_sym_long] = ACTIONS(5378),
    [anon_sym_short] = ACTIONS(5378),
    [sym_primitive_type] = ACTIONS(5378),
    [anon_sym_enum] = ACTIONS(5378),
    [anon_sym_struct] = ACTIONS(5378),
    [anon_sym_union] = ACTIONS(5378),
    [anon_sym_if] = ACTIONS(5378),
    [anon_sym_switch] = ACTIONS(5378),
    [anon_sym_case] = ACTIONS(5378),
    [anon_sym_default] = ACTIONS(5378),
    [anon_sym_while] = ACTIONS(5378),
    [anon_sym_do] = ACTIONS(5378),
    [anon_sym_for] = ACTIONS(5378),
    [anon_sym_return] = ACTIONS(5378),
    [anon_sym_break] = ACTIONS(5378),
    [anon_sym_continue] = ACTIONS(5378),
    [anon_sym_goto] = ACTIONS(5378),
    [anon_sym_AMP] = ACTIONS(5376),
    [anon_sym_BANG] = ACTIONS(5376),
    [anon_sym_TILDE] = ACTIONS(5376),
    [anon_sym_PLUS] = ACTIONS(5378),
    [anon_sym_DASH] = ACTIONS(5378),
    [anon_sym_DASH_DASH] = ACTIONS(5376),
    [anon_sym_PLUS_PLUS] = ACTIONS(5376),
    [anon_sym_sizeof] = ACTIONS(5378),
    [sym_number_literal] = ACTIONS(5376),
    [anon_sym_SQUOTE] = ACTIONS(5376),
    [anon_sym_DQUOTE] = ACTIONS(5376),
    [sym_true] = ACTIONS(5378),
    [sym_false] = ACTIONS(5378),
    [sym_null] = ACTIONS(5378),
    [sym_identifier] = ACTIONS(5378),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5378),
    [sym_auto] = ACTIONS(5378),
    [anon_sym_typename] = ACTIONS(5378),
    [anon_sym_delete] = ACTIONS(5378),
    [anon_sym_try] = ACTIONS(5378),
    [anon_sym_new] = ACTIONS(5378),
    [anon_sym_COLON_COLON] = ACTIONS(5376),
    [sym_nullptr] = ACTIONS(5378),
  },
  [3273] = {
    [sym_raw_string_literal] = ACTIONS(6900),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6902),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6902),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6902),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6902),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6902),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6902),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6902),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6902),
    [sym_preproc_directive] = ACTIONS(6902),
    [anon_sym_SEMI] = ACTIONS(6900),
    [anon_sym_typedef] = ACTIONS(6902),
    [anon_sym_extern] = ACTIONS(6902),
    [anon_sym_LBRACE] = ACTIONS(6900),
    [anon_sym_LPAREN2] = ACTIONS(6900),
    [anon_sym_STAR] = ACTIONS(6900),
    [anon_sym_LBRACK] = ACTIONS(6900),
    [anon_sym_static] = ACTIONS(6902),
    [anon_sym_register] = ACTIONS(6902),
    [anon_sym_inline] = ACTIONS(6902),
    [anon_sym_const] = ACTIONS(6902),
    [anon_sym_restrict] = ACTIONS(6902),
    [anon_sym_volatile] = ACTIONS(6902),
    [anon_sym__Atomic] = ACTIONS(6902),
    [anon_sym_mutable] = ACTIONS(6902),
    [anon_sym_explicit] = ACTIONS(6902),
    [anon_sym_constexpr] = ACTIONS(6902),
    [anon_sym_unsigned] = ACTIONS(6902),
    [anon_sym_long] = ACTIONS(6902),
    [anon_sym_short] = ACTIONS(6902),
    [sym_primitive_type] = ACTIONS(6902),
    [anon_sym_enum] = ACTIONS(6902),
    [anon_sym_struct] = ACTIONS(6902),
    [anon_sym_union] = ACTIONS(6902),
    [anon_sym_if] = ACTIONS(6902),
    [anon_sym_switch] = ACTIONS(6902),
    [anon_sym_case] = ACTIONS(6902),
    [anon_sym_default] = ACTIONS(6902),
    [anon_sym_while] = ACTIONS(6902),
    [anon_sym_do] = ACTIONS(6902),
    [anon_sym_for] = ACTIONS(6902),
    [anon_sym_return] = ACTIONS(6902),
    [anon_sym_break] = ACTIONS(6902),
    [anon_sym_continue] = ACTIONS(6902),
    [anon_sym_goto] = ACTIONS(6902),
    [anon_sym_AMP] = ACTIONS(6900),
    [anon_sym_BANG] = ACTIONS(6900),
    [anon_sym_TILDE] = ACTIONS(6900),
    [anon_sym_PLUS] = ACTIONS(6902),
    [anon_sym_DASH] = ACTIONS(6902),
    [anon_sym_DASH_DASH] = ACTIONS(6900),
    [anon_sym_PLUS_PLUS] = ACTIONS(6900),
    [anon_sym_sizeof] = ACTIONS(6902),
    [sym_number_literal] = ACTIONS(6900),
    [anon_sym_SQUOTE] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(6900),
    [sym_true] = ACTIONS(6902),
    [sym_false] = ACTIONS(6902),
    [sym_null] = ACTIONS(6902),
    [sym_identifier] = ACTIONS(6902),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6902),
    [sym_auto] = ACTIONS(6902),
    [anon_sym_typename] = ACTIONS(6902),
    [anon_sym_delete] = ACTIONS(6902),
    [anon_sym_try] = ACTIONS(6902),
    [anon_sym_new] = ACTIONS(6902),
    [anon_sym_COLON_COLON] = ACTIONS(6900),
    [sym_nullptr] = ACTIONS(6902),
  },
  [3274] = {
    [sym_raw_string_literal] = ACTIONS(6904),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6906),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6906),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6906),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6906),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6906),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6906),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6906),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6906),
    [sym_preproc_directive] = ACTIONS(6906),
    [anon_sym_SEMI] = ACTIONS(6904),
    [anon_sym_typedef] = ACTIONS(6906),
    [anon_sym_extern] = ACTIONS(6906),
    [anon_sym_LBRACE] = ACTIONS(6904),
    [anon_sym_LPAREN2] = ACTIONS(6904),
    [anon_sym_STAR] = ACTIONS(6904),
    [anon_sym_LBRACK] = ACTIONS(6904),
    [anon_sym_static] = ACTIONS(6906),
    [anon_sym_register] = ACTIONS(6906),
    [anon_sym_inline] = ACTIONS(6906),
    [anon_sym_const] = ACTIONS(6906),
    [anon_sym_restrict] = ACTIONS(6906),
    [anon_sym_volatile] = ACTIONS(6906),
    [anon_sym__Atomic] = ACTIONS(6906),
    [anon_sym_mutable] = ACTIONS(6906),
    [anon_sym_explicit] = ACTIONS(6906),
    [anon_sym_constexpr] = ACTIONS(6906),
    [anon_sym_unsigned] = ACTIONS(6906),
    [anon_sym_long] = ACTIONS(6906),
    [anon_sym_short] = ACTIONS(6906),
    [sym_primitive_type] = ACTIONS(6906),
    [anon_sym_enum] = ACTIONS(6906),
    [anon_sym_struct] = ACTIONS(6906),
    [anon_sym_union] = ACTIONS(6906),
    [anon_sym_if] = ACTIONS(6906),
    [anon_sym_switch] = ACTIONS(6906),
    [anon_sym_case] = ACTIONS(6906),
    [anon_sym_default] = ACTIONS(6906),
    [anon_sym_while] = ACTIONS(6906),
    [anon_sym_do] = ACTIONS(6906),
    [anon_sym_for] = ACTIONS(6906),
    [anon_sym_return] = ACTIONS(6906),
    [anon_sym_break] = ACTIONS(6906),
    [anon_sym_continue] = ACTIONS(6906),
    [anon_sym_goto] = ACTIONS(6906),
    [anon_sym_AMP] = ACTIONS(6904),
    [anon_sym_BANG] = ACTIONS(6904),
    [anon_sym_TILDE] = ACTIONS(6904),
    [anon_sym_PLUS] = ACTIONS(6906),
    [anon_sym_DASH] = ACTIONS(6906),
    [anon_sym_DASH_DASH] = ACTIONS(6904),
    [anon_sym_PLUS_PLUS] = ACTIONS(6904),
    [anon_sym_sizeof] = ACTIONS(6906),
    [sym_number_literal] = ACTIONS(6904),
    [anon_sym_SQUOTE] = ACTIONS(6904),
    [anon_sym_DQUOTE] = ACTIONS(6904),
    [sym_true] = ACTIONS(6906),
    [sym_false] = ACTIONS(6906),
    [sym_null] = ACTIONS(6906),
    [sym_identifier] = ACTIONS(6906),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6906),
    [sym_auto] = ACTIONS(6906),
    [anon_sym_typename] = ACTIONS(6906),
    [anon_sym_delete] = ACTIONS(6906),
    [anon_sym_try] = ACTIONS(6906),
    [anon_sym_new] = ACTIONS(6906),
    [anon_sym_COLON_COLON] = ACTIONS(6904),
    [sym_nullptr] = ACTIONS(6906),
  },
  [3275] = {
    [sym_raw_string_literal] = ACTIONS(3063),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3065),
    [sym_preproc_directive] = ACTIONS(3065),
    [anon_sym_SEMI] = ACTIONS(3063),
    [anon_sym_typedef] = ACTIONS(3065),
    [anon_sym_extern] = ACTIONS(3065),
    [anon_sym_LBRACE] = ACTIONS(3063),
    [anon_sym_LPAREN2] = ACTIONS(3063),
    [anon_sym_STAR] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_static] = ACTIONS(3065),
    [anon_sym_register] = ACTIONS(3065),
    [anon_sym_inline] = ACTIONS(3065),
    [anon_sym_const] = ACTIONS(3065),
    [anon_sym_restrict] = ACTIONS(3065),
    [anon_sym_volatile] = ACTIONS(3065),
    [anon_sym__Atomic] = ACTIONS(3065),
    [anon_sym_mutable] = ACTIONS(3065),
    [anon_sym_explicit] = ACTIONS(3065),
    [anon_sym_constexpr] = ACTIONS(3065),
    [anon_sym_unsigned] = ACTIONS(3065),
    [anon_sym_long] = ACTIONS(3065),
    [anon_sym_short] = ACTIONS(3065),
    [sym_primitive_type] = ACTIONS(3065),
    [anon_sym_enum] = ACTIONS(3065),
    [anon_sym_struct] = ACTIONS(3065),
    [anon_sym_union] = ACTIONS(3065),
    [anon_sym_if] = ACTIONS(3065),
    [anon_sym_switch] = ACTIONS(3065),
    [anon_sym_case] = ACTIONS(3065),
    [anon_sym_default] = ACTIONS(3065),
    [anon_sym_while] = ACTIONS(3065),
    [anon_sym_do] = ACTIONS(3065),
    [anon_sym_for] = ACTIONS(3065),
    [anon_sym_return] = ACTIONS(3065),
    [anon_sym_break] = ACTIONS(3065),
    [anon_sym_continue] = ACTIONS(3065),
    [anon_sym_goto] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3063),
    [anon_sym_TILDE] = ACTIONS(3063),
    [anon_sym_PLUS] = ACTIONS(3065),
    [anon_sym_DASH] = ACTIONS(3065),
    [anon_sym_DASH_DASH] = ACTIONS(3063),
    [anon_sym_PLUS_PLUS] = ACTIONS(3063),
    [anon_sym_sizeof] = ACTIONS(3065),
    [sym_number_literal] = ACTIONS(3063),
    [anon_sym_SQUOTE] = ACTIONS(3063),
    [anon_sym_DQUOTE] = ACTIONS(3063),
    [sym_true] = ACTIONS(3065),
    [sym_false] = ACTIONS(3065),
    [sym_null] = ACTIONS(3065),
    [sym_identifier] = ACTIONS(3065),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3065),
    [sym_auto] = ACTIONS(3065),
    [anon_sym_typename] = ACTIONS(3065),
    [anon_sym_delete] = ACTIONS(3065),
    [anon_sym_try] = ACTIONS(3065),
    [anon_sym_new] = ACTIONS(3065),
    [anon_sym_COLON_COLON] = ACTIONS(3063),
    [sym_nullptr] = ACTIONS(3065),
  },
  [3276] = {
    [sym_raw_string_literal] = ACTIONS(3707),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3709),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3709),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3709),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3709),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3709),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3709),
    [sym_preproc_directive] = ACTIONS(3709),
    [anon_sym_SEMI] = ACTIONS(3707),
    [anon_sym_typedef] = ACTIONS(3709),
    [anon_sym_extern] = ACTIONS(3709),
    [anon_sym_LBRACE] = ACTIONS(3707),
    [anon_sym_LPAREN2] = ACTIONS(3707),
    [anon_sym_STAR] = ACTIONS(3707),
    [anon_sym_LBRACK] = ACTIONS(3707),
    [anon_sym_static] = ACTIONS(3709),
    [anon_sym_register] = ACTIONS(3709),
    [anon_sym_inline] = ACTIONS(3709),
    [anon_sym_const] = ACTIONS(3709),
    [anon_sym_restrict] = ACTIONS(3709),
    [anon_sym_volatile] = ACTIONS(3709),
    [anon_sym__Atomic] = ACTIONS(3709),
    [anon_sym_mutable] = ACTIONS(3709),
    [anon_sym_explicit] = ACTIONS(3709),
    [anon_sym_constexpr] = ACTIONS(3709),
    [anon_sym_unsigned] = ACTIONS(3709),
    [anon_sym_long] = ACTIONS(3709),
    [anon_sym_short] = ACTIONS(3709),
    [sym_primitive_type] = ACTIONS(3709),
    [anon_sym_enum] = ACTIONS(3709),
    [anon_sym_struct] = ACTIONS(3709),
    [anon_sym_union] = ACTIONS(3709),
    [anon_sym_if] = ACTIONS(3709),
    [anon_sym_switch] = ACTIONS(3709),
    [anon_sym_case] = ACTIONS(3709),
    [anon_sym_default] = ACTIONS(3709),
    [anon_sym_while] = ACTIONS(3709),
    [anon_sym_do] = ACTIONS(3709),
    [anon_sym_for] = ACTIONS(3709),
    [anon_sym_return] = ACTIONS(3709),
    [anon_sym_break] = ACTIONS(3709),
    [anon_sym_continue] = ACTIONS(3709),
    [anon_sym_goto] = ACTIONS(3709),
    [anon_sym_AMP] = ACTIONS(3707),
    [anon_sym_BANG] = ACTIONS(3707),
    [anon_sym_TILDE] = ACTIONS(3707),
    [anon_sym_PLUS] = ACTIONS(3709),
    [anon_sym_DASH] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3707),
    [anon_sym_PLUS_PLUS] = ACTIONS(3707),
    [anon_sym_sizeof] = ACTIONS(3709),
    [sym_number_literal] = ACTIONS(3707),
    [anon_sym_SQUOTE] = ACTIONS(3707),
    [anon_sym_DQUOTE] = ACTIONS(3707),
    [sym_true] = ACTIONS(3709),
    [sym_false] = ACTIONS(3709),
    [sym_null] = ACTIONS(3709),
    [sym_identifier] = ACTIONS(3709),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3709),
    [sym_auto] = ACTIONS(3709),
    [anon_sym_typename] = ACTIONS(3709),
    [anon_sym_delete] = ACTIONS(3709),
    [anon_sym_try] = ACTIONS(3709),
    [anon_sym_new] = ACTIONS(3709),
    [anon_sym_COLON_COLON] = ACTIONS(3707),
    [sym_nullptr] = ACTIONS(3709),
  },
  [3277] = {
    [sym_raw_string_literal] = ACTIONS(3711),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3713),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3713),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3713),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3713),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3713),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3713),
    [sym_preproc_directive] = ACTIONS(3713),
    [anon_sym_SEMI] = ACTIONS(3711),
    [anon_sym_typedef] = ACTIONS(3713),
    [anon_sym_extern] = ACTIONS(3713),
    [anon_sym_LBRACE] = ACTIONS(3711),
    [anon_sym_LPAREN2] = ACTIONS(3711),
    [anon_sym_STAR] = ACTIONS(3711),
    [anon_sym_LBRACK] = ACTIONS(3711),
    [anon_sym_static] = ACTIONS(3713),
    [anon_sym_register] = ACTIONS(3713),
    [anon_sym_inline] = ACTIONS(3713),
    [anon_sym_const] = ACTIONS(3713),
    [anon_sym_restrict] = ACTIONS(3713),
    [anon_sym_volatile] = ACTIONS(3713),
    [anon_sym__Atomic] = ACTIONS(3713),
    [anon_sym_mutable] = ACTIONS(3713),
    [anon_sym_explicit] = ACTIONS(3713),
    [anon_sym_constexpr] = ACTIONS(3713),
    [anon_sym_unsigned] = ACTIONS(3713),
    [anon_sym_long] = ACTIONS(3713),
    [anon_sym_short] = ACTIONS(3713),
    [sym_primitive_type] = ACTIONS(3713),
    [anon_sym_enum] = ACTIONS(3713),
    [anon_sym_struct] = ACTIONS(3713),
    [anon_sym_union] = ACTIONS(3713),
    [anon_sym_if] = ACTIONS(3713),
    [anon_sym_switch] = ACTIONS(3713),
    [anon_sym_case] = ACTIONS(3713),
    [anon_sym_default] = ACTIONS(3713),
    [anon_sym_while] = ACTIONS(3713),
    [anon_sym_do] = ACTIONS(3713),
    [anon_sym_for] = ACTIONS(3713),
    [anon_sym_return] = ACTIONS(3713),
    [anon_sym_break] = ACTIONS(3713),
    [anon_sym_continue] = ACTIONS(3713),
    [anon_sym_goto] = ACTIONS(3713),
    [anon_sym_AMP] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3711),
    [anon_sym_TILDE] = ACTIONS(3711),
    [anon_sym_PLUS] = ACTIONS(3713),
    [anon_sym_DASH] = ACTIONS(3713),
    [anon_sym_DASH_DASH] = ACTIONS(3711),
    [anon_sym_PLUS_PLUS] = ACTIONS(3711),
    [anon_sym_sizeof] = ACTIONS(3713),
    [sym_number_literal] = ACTIONS(3711),
    [anon_sym_SQUOTE] = ACTIONS(3711),
    [anon_sym_DQUOTE] = ACTIONS(3711),
    [sym_true] = ACTIONS(3713),
    [sym_false] = ACTIONS(3713),
    [sym_null] = ACTIONS(3713),
    [sym_identifier] = ACTIONS(3713),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3713),
    [sym_auto] = ACTIONS(3713),
    [anon_sym_typename] = ACTIONS(3713),
    [anon_sym_delete] = ACTIONS(3713),
    [anon_sym_try] = ACTIONS(3713),
    [anon_sym_new] = ACTIONS(3713),
    [anon_sym_COLON_COLON] = ACTIONS(3711),
    [sym_nullptr] = ACTIONS(3713),
  },
  [3278] = {
    [anon_sym_LF] = ACTIONS(7758),
    [sym_comment] = ACTIONS(121),
  },
  [3279] = {
    [sym_raw_string_literal] = ACTIONS(5725),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5727),
    [sym_preproc_directive] = ACTIONS(5727),
    [anon_sym_SEMI] = ACTIONS(5725),
    [anon_sym_typedef] = ACTIONS(5727),
    [anon_sym_extern] = ACTIONS(5727),
    [anon_sym_LBRACE] = ACTIONS(5725),
    [anon_sym_LPAREN2] = ACTIONS(5725),
    [anon_sym_STAR] = ACTIONS(5725),
    [anon_sym_LBRACK] = ACTIONS(5725),
    [anon_sym_static] = ACTIONS(5727),
    [anon_sym_register] = ACTIONS(5727),
    [anon_sym_inline] = ACTIONS(5727),
    [anon_sym_const] = ACTIONS(5727),
    [anon_sym_restrict] = ACTIONS(5727),
    [anon_sym_volatile] = ACTIONS(5727),
    [anon_sym__Atomic] = ACTIONS(5727),
    [anon_sym_mutable] = ACTIONS(5727),
    [anon_sym_explicit] = ACTIONS(5727),
    [anon_sym_constexpr] = ACTIONS(5727),
    [anon_sym_unsigned] = ACTIONS(5727),
    [anon_sym_long] = ACTIONS(5727),
    [anon_sym_short] = ACTIONS(5727),
    [sym_primitive_type] = ACTIONS(5727),
    [anon_sym_enum] = ACTIONS(5727),
    [anon_sym_struct] = ACTIONS(5727),
    [anon_sym_union] = ACTIONS(5727),
    [anon_sym_if] = ACTIONS(5727),
    [anon_sym_switch] = ACTIONS(5727),
    [anon_sym_case] = ACTIONS(5727),
    [anon_sym_default] = ACTIONS(5727),
    [anon_sym_while] = ACTIONS(5727),
    [anon_sym_do] = ACTIONS(5727),
    [anon_sym_for] = ACTIONS(5727),
    [anon_sym_return] = ACTIONS(5727),
    [anon_sym_break] = ACTIONS(5727),
    [anon_sym_continue] = ACTIONS(5727),
    [anon_sym_goto] = ACTIONS(5727),
    [anon_sym_AMP] = ACTIONS(5725),
    [anon_sym_BANG] = ACTIONS(5725),
    [anon_sym_TILDE] = ACTIONS(5725),
    [anon_sym_PLUS] = ACTIONS(5727),
    [anon_sym_DASH] = ACTIONS(5727),
    [anon_sym_DASH_DASH] = ACTIONS(5725),
    [anon_sym_PLUS_PLUS] = ACTIONS(5725),
    [anon_sym_sizeof] = ACTIONS(5727),
    [sym_number_literal] = ACTIONS(5725),
    [anon_sym_SQUOTE] = ACTIONS(5725),
    [anon_sym_DQUOTE] = ACTIONS(5725),
    [sym_true] = ACTIONS(5727),
    [sym_false] = ACTIONS(5727),
    [sym_null] = ACTIONS(5727),
    [sym_identifier] = ACTIONS(5727),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5727),
    [sym_auto] = ACTIONS(5727),
    [anon_sym_typename] = ACTIONS(5727),
    [anon_sym_delete] = ACTIONS(5727),
    [anon_sym_try] = ACTIONS(5727),
    [anon_sym_new] = ACTIONS(5727),
    [anon_sym_COLON_COLON] = ACTIONS(5725),
    [sym_nullptr] = ACTIONS(5727),
  },
  [3280] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7760),
    [sym_comment] = ACTIONS(91),
  },
  [3281] = {
    [sym_raw_string_literal] = ACTIONS(5806),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5808),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5808),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5808),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5808),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5808),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5808),
    [sym_preproc_directive] = ACTIONS(5808),
    [anon_sym_SEMI] = ACTIONS(5806),
    [anon_sym_typedef] = ACTIONS(5808),
    [anon_sym_extern] = ACTIONS(5808),
    [anon_sym_LBRACE] = ACTIONS(5806),
    [anon_sym_LPAREN2] = ACTIONS(5806),
    [anon_sym_STAR] = ACTIONS(5806),
    [anon_sym_LBRACK] = ACTIONS(5806),
    [anon_sym_static] = ACTIONS(5808),
    [anon_sym_register] = ACTIONS(5808),
    [anon_sym_inline] = ACTIONS(5808),
    [anon_sym_const] = ACTIONS(5808),
    [anon_sym_restrict] = ACTIONS(5808),
    [anon_sym_volatile] = ACTIONS(5808),
    [anon_sym__Atomic] = ACTIONS(5808),
    [anon_sym_mutable] = ACTIONS(5808),
    [anon_sym_explicit] = ACTIONS(5808),
    [anon_sym_constexpr] = ACTIONS(5808),
    [anon_sym_unsigned] = ACTIONS(5808),
    [anon_sym_long] = ACTIONS(5808),
    [anon_sym_short] = ACTIONS(5808),
    [sym_primitive_type] = ACTIONS(5808),
    [anon_sym_enum] = ACTIONS(5808),
    [anon_sym_struct] = ACTIONS(5808),
    [anon_sym_union] = ACTIONS(5808),
    [anon_sym_if] = ACTIONS(5808),
    [anon_sym_switch] = ACTIONS(5808),
    [anon_sym_case] = ACTIONS(5808),
    [anon_sym_default] = ACTIONS(5808),
    [anon_sym_while] = ACTIONS(5808),
    [anon_sym_do] = ACTIONS(5808),
    [anon_sym_for] = ACTIONS(5808),
    [anon_sym_return] = ACTIONS(5808),
    [anon_sym_break] = ACTIONS(5808),
    [anon_sym_continue] = ACTIONS(5808),
    [anon_sym_goto] = ACTIONS(5808),
    [anon_sym_AMP] = ACTIONS(5806),
    [anon_sym_BANG] = ACTIONS(5806),
    [anon_sym_TILDE] = ACTIONS(5806),
    [anon_sym_PLUS] = ACTIONS(5808),
    [anon_sym_DASH] = ACTIONS(5808),
    [anon_sym_DASH_DASH] = ACTIONS(5806),
    [anon_sym_PLUS_PLUS] = ACTIONS(5806),
    [anon_sym_sizeof] = ACTIONS(5808),
    [sym_number_literal] = ACTIONS(5806),
    [anon_sym_SQUOTE] = ACTIONS(5806),
    [anon_sym_DQUOTE] = ACTIONS(5806),
    [sym_true] = ACTIONS(5808),
    [sym_false] = ACTIONS(5808),
    [sym_null] = ACTIONS(5808),
    [sym_identifier] = ACTIONS(5808),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5808),
    [sym_auto] = ACTIONS(5808),
    [anon_sym_typename] = ACTIONS(5808),
    [anon_sym_delete] = ACTIONS(5808),
    [anon_sym_try] = ACTIONS(5808),
    [anon_sym_new] = ACTIONS(5808),
    [anon_sym_COLON_COLON] = ACTIONS(5806),
    [sym_nullptr] = ACTIONS(5808),
  },
  [3282] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7762),
    [sym_comment] = ACTIONS(91),
  },
  [3283] = {
    [sym_raw_string_literal] = ACTIONS(3958),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3960),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3960),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3960),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3960),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3960),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3960),
    [sym_preproc_directive] = ACTIONS(3960),
    [anon_sym_SEMI] = ACTIONS(3958),
    [anon_sym_typedef] = ACTIONS(3960),
    [anon_sym_extern] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3958),
    [anon_sym_LPAREN2] = ACTIONS(3958),
    [anon_sym_STAR] = ACTIONS(3958),
    [anon_sym_LBRACK] = ACTIONS(3958),
    [anon_sym_static] = ACTIONS(3960),
    [anon_sym_register] = ACTIONS(3960),
    [anon_sym_inline] = ACTIONS(3960),
    [anon_sym_const] = ACTIONS(3960),
    [anon_sym_restrict] = ACTIONS(3960),
    [anon_sym_volatile] = ACTIONS(3960),
    [anon_sym__Atomic] = ACTIONS(3960),
    [anon_sym_mutable] = ACTIONS(3960),
    [anon_sym_explicit] = ACTIONS(3960),
    [anon_sym_constexpr] = ACTIONS(3960),
    [anon_sym_unsigned] = ACTIONS(3960),
    [anon_sym_long] = ACTIONS(3960),
    [anon_sym_short] = ACTIONS(3960),
    [sym_primitive_type] = ACTIONS(3960),
    [anon_sym_enum] = ACTIONS(3960),
    [anon_sym_struct] = ACTIONS(3960),
    [anon_sym_union] = ACTIONS(3960),
    [anon_sym_if] = ACTIONS(3960),
    [anon_sym_else] = ACTIONS(3960),
    [anon_sym_switch] = ACTIONS(3960),
    [anon_sym_case] = ACTIONS(3960),
    [anon_sym_default] = ACTIONS(3960),
    [anon_sym_while] = ACTIONS(3960),
    [anon_sym_do] = ACTIONS(3960),
    [anon_sym_for] = ACTIONS(3960),
    [anon_sym_return] = ACTIONS(3960),
    [anon_sym_break] = ACTIONS(3960),
    [anon_sym_continue] = ACTIONS(3960),
    [anon_sym_goto] = ACTIONS(3960),
    [anon_sym_AMP] = ACTIONS(3958),
    [anon_sym_BANG] = ACTIONS(3958),
    [anon_sym_TILDE] = ACTIONS(3958),
    [anon_sym_PLUS] = ACTIONS(3960),
    [anon_sym_DASH] = ACTIONS(3960),
    [anon_sym_DASH_DASH] = ACTIONS(3958),
    [anon_sym_PLUS_PLUS] = ACTIONS(3958),
    [anon_sym_sizeof] = ACTIONS(3960),
    [sym_number_literal] = ACTIONS(3958),
    [anon_sym_SQUOTE] = ACTIONS(3958),
    [anon_sym_DQUOTE] = ACTIONS(3958),
    [sym_true] = ACTIONS(3960),
    [sym_false] = ACTIONS(3960),
    [sym_null] = ACTIONS(3960),
    [sym_identifier] = ACTIONS(3960),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3960),
    [sym_auto] = ACTIONS(3960),
    [anon_sym_typename] = ACTIONS(3960),
    [anon_sym_delete] = ACTIONS(3960),
    [anon_sym_try] = ACTIONS(3960),
    [anon_sym_new] = ACTIONS(3960),
    [anon_sym_COLON_COLON] = ACTIONS(3958),
    [sym_nullptr] = ACTIONS(3960),
  },
  [3284] = {
    [sym_parameter_list] = STATE(1105),
    [anon_sym_SEMI] = ACTIONS(7764),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [sym_comment] = ACTIONS(91),
  },
  [3285] = {
    [sym_compound_statement] = STATE(3479),
    [sym_labeled_statement] = STATE(3479),
    [sym_expression_statement] = STATE(3479),
    [sym_if_statement] = STATE(3479),
    [sym_switch_statement] = STATE(3479),
    [sym_case_statement] = STATE(3479),
    [sym_while_statement] = STATE(3479),
    [sym_do_statement] = STATE(3479),
    [sym_for_statement] = STATE(3479),
    [sym_return_statement] = STATE(3479),
    [sym_break_statement] = STATE(3479),
    [sym_continue_statement] = STATE(3479),
    [sym_goto_statement] = STATE(3479),
    [sym__expression] = STATE(1908),
    [sym_comma_expression] = STATE(1909),
    [sym_conditional_expression] = STATE(1908),
    [sym_assignment_expression] = STATE(1908),
    [sym_pointer_expression] = STATE(1908),
    [sym_logical_expression] = STATE(1908),
    [sym_bitwise_expression] = STATE(1908),
    [sym_equality_expression] = STATE(1908),
    [sym_relational_expression] = STATE(1908),
    [sym_shift_expression] = STATE(1908),
    [sym_math_expression] = STATE(1908),
    [sym_cast_expression] = STATE(1908),
    [sym_sizeof_expression] = STATE(1908),
    [sym_subscript_expression] = STATE(1908),
    [sym_call_expression] = STATE(1908),
    [sym_field_expression] = STATE(1908),
    [sym_compound_literal_expression] = STATE(1908),
    [sym_parenthesized_expression] = STATE(1908),
    [sym_char_literal] = STATE(1908),
    [sym_concatenated_string] = STATE(1908),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1908),
    [sym_for_range_loop] = STATE(3479),
    [sym_try_statement] = STATE(3479),
    [sym_new_expression] = STATE(1908),
    [sym_delete_expression] = STATE(1908),
    [sym_lambda_expression] = STATE(1908),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3996),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7766),
    [anon_sym_switch] = ACTIONS(7768),
    [anon_sym_case] = ACTIONS(7770),
    [anon_sym_default] = ACTIONS(7772),
    [anon_sym_while] = ACTIONS(7774),
    [anon_sym_do] = ACTIONS(4026),
    [anon_sym_for] = ACTIONS(7776),
    [anon_sym_return] = ACTIONS(4030),
    [anon_sym_break] = ACTIONS(4032),
    [anon_sym_continue] = ACTIONS(4034),
    [anon_sym_goto] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(3996),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4038),
    [sym_false] = ACTIONS(4038),
    [sym_null] = ACTIONS(4038),
    [sym_identifier] = ACTIONS(7778),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7780),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(4038),
  },
  [3286] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(7782),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3287] = {
    [sym_raw_string_literal] = ACTIONS(4513),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4515),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4515),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4515),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4515),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4515),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4515),
    [sym_preproc_directive] = ACTIONS(4515),
    [anon_sym_SEMI] = ACTIONS(4513),
    [anon_sym_typedef] = ACTIONS(4515),
    [anon_sym_extern] = ACTIONS(4515),
    [anon_sym_LBRACE] = ACTIONS(4513),
    [anon_sym_LPAREN2] = ACTIONS(4513),
    [anon_sym_STAR] = ACTIONS(4513),
    [anon_sym_LBRACK] = ACTIONS(4513),
    [anon_sym_static] = ACTIONS(4515),
    [anon_sym_register] = ACTIONS(4515),
    [anon_sym_inline] = ACTIONS(4515),
    [anon_sym_const] = ACTIONS(4515),
    [anon_sym_restrict] = ACTIONS(4515),
    [anon_sym_volatile] = ACTIONS(4515),
    [anon_sym__Atomic] = ACTIONS(4515),
    [anon_sym_mutable] = ACTIONS(4515),
    [anon_sym_explicit] = ACTIONS(4515),
    [anon_sym_constexpr] = ACTIONS(4515),
    [anon_sym_unsigned] = ACTIONS(4515),
    [anon_sym_long] = ACTIONS(4515),
    [anon_sym_short] = ACTIONS(4515),
    [sym_primitive_type] = ACTIONS(4515),
    [anon_sym_enum] = ACTIONS(4515),
    [anon_sym_struct] = ACTIONS(4515),
    [anon_sym_union] = ACTIONS(4515),
    [anon_sym_if] = ACTIONS(4515),
    [anon_sym_else] = ACTIONS(4515),
    [anon_sym_switch] = ACTIONS(4515),
    [anon_sym_case] = ACTIONS(4515),
    [anon_sym_default] = ACTIONS(4515),
    [anon_sym_while] = ACTIONS(4515),
    [anon_sym_do] = ACTIONS(4515),
    [anon_sym_for] = ACTIONS(4515),
    [anon_sym_return] = ACTIONS(4515),
    [anon_sym_break] = ACTIONS(4515),
    [anon_sym_continue] = ACTIONS(4515),
    [anon_sym_goto] = ACTIONS(4515),
    [anon_sym_AMP] = ACTIONS(4513),
    [anon_sym_BANG] = ACTIONS(4513),
    [anon_sym_TILDE] = ACTIONS(4513),
    [anon_sym_PLUS] = ACTIONS(4515),
    [anon_sym_DASH] = ACTIONS(4515),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
    [anon_sym_sizeof] = ACTIONS(4515),
    [sym_number_literal] = ACTIONS(4513),
    [anon_sym_SQUOTE] = ACTIONS(4513),
    [anon_sym_DQUOTE] = ACTIONS(4513),
    [sym_true] = ACTIONS(4515),
    [sym_false] = ACTIONS(4515),
    [sym_null] = ACTIONS(4515),
    [sym_identifier] = ACTIONS(4515),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4515),
    [sym_auto] = ACTIONS(4515),
    [anon_sym_typename] = ACTIONS(4515),
    [anon_sym_delete] = ACTIONS(4515),
    [anon_sym_try] = ACTIONS(4515),
    [anon_sym_new] = ACTIONS(4515),
    [anon_sym_COLON_COLON] = ACTIONS(4513),
    [sym_nullptr] = ACTIONS(4515),
  },
  [3288] = {
    [sym__expression] = STATE(3481),
    [sym_comma_expression] = STATE(3482),
    [sym_conditional_expression] = STATE(3481),
    [sym_assignment_expression] = STATE(3481),
    [sym_pointer_expression] = STATE(3481),
    [sym_logical_expression] = STATE(3481),
    [sym_bitwise_expression] = STATE(3481),
    [sym_equality_expression] = STATE(3481),
    [sym_relational_expression] = STATE(3481),
    [sym_shift_expression] = STATE(3481),
    [sym_math_expression] = STATE(3481),
    [sym_cast_expression] = STATE(3481),
    [sym_sizeof_expression] = STATE(3481),
    [sym_subscript_expression] = STATE(3481),
    [sym_call_expression] = STATE(3481),
    [sym_field_expression] = STATE(3481),
    [sym_compound_literal_expression] = STATE(3481),
    [sym_parenthesized_expression] = STATE(3481),
    [sym_char_literal] = STATE(3481),
    [sym_concatenated_string] = STATE(3481),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3481),
    [sym_new_expression] = STATE(3481),
    [sym_delete_expression] = STATE(3481),
    [sym_lambda_expression] = STATE(3481),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7784),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(7784),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7786),
    [sym_false] = ACTIONS(7786),
    [sym_null] = ACTIONS(7786),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(7786),
  },
  [3289] = {
    [sym_raw_string_literal] = ACTIONS(4554),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4556),
    [sym_preproc_directive] = ACTIONS(4556),
    [anon_sym_SEMI] = ACTIONS(4554),
    [anon_sym_typedef] = ACTIONS(4556),
    [anon_sym_extern] = ACTIONS(4556),
    [anon_sym_LBRACE] = ACTIONS(4554),
    [anon_sym_LPAREN2] = ACTIONS(4554),
    [anon_sym_STAR] = ACTIONS(4554),
    [anon_sym_LBRACK] = ACTIONS(4554),
    [anon_sym_static] = ACTIONS(4556),
    [anon_sym_register] = ACTIONS(4556),
    [anon_sym_inline] = ACTIONS(4556),
    [anon_sym_const] = ACTIONS(4556),
    [anon_sym_restrict] = ACTIONS(4556),
    [anon_sym_volatile] = ACTIONS(4556),
    [anon_sym__Atomic] = ACTIONS(4556),
    [anon_sym_mutable] = ACTIONS(4556),
    [anon_sym_explicit] = ACTIONS(4556),
    [anon_sym_constexpr] = ACTIONS(4556),
    [anon_sym_unsigned] = ACTIONS(4556),
    [anon_sym_long] = ACTIONS(4556),
    [anon_sym_short] = ACTIONS(4556),
    [sym_primitive_type] = ACTIONS(4556),
    [anon_sym_enum] = ACTIONS(4556),
    [anon_sym_struct] = ACTIONS(4556),
    [anon_sym_union] = ACTIONS(4556),
    [anon_sym_if] = ACTIONS(4556),
    [anon_sym_else] = ACTIONS(4556),
    [anon_sym_switch] = ACTIONS(4556),
    [anon_sym_case] = ACTIONS(4556),
    [anon_sym_default] = ACTIONS(4556),
    [anon_sym_while] = ACTIONS(4556),
    [anon_sym_do] = ACTIONS(4556),
    [anon_sym_for] = ACTIONS(4556),
    [anon_sym_return] = ACTIONS(4556),
    [anon_sym_break] = ACTIONS(4556),
    [anon_sym_continue] = ACTIONS(4556),
    [anon_sym_goto] = ACTIONS(4556),
    [anon_sym_AMP] = ACTIONS(4554),
    [anon_sym_BANG] = ACTIONS(4554),
    [anon_sym_TILDE] = ACTIONS(4554),
    [anon_sym_PLUS] = ACTIONS(4556),
    [anon_sym_DASH] = ACTIONS(4556),
    [anon_sym_DASH_DASH] = ACTIONS(4554),
    [anon_sym_PLUS_PLUS] = ACTIONS(4554),
    [anon_sym_sizeof] = ACTIONS(4556),
    [sym_number_literal] = ACTIONS(4554),
    [anon_sym_SQUOTE] = ACTIONS(4554),
    [anon_sym_DQUOTE] = ACTIONS(4554),
    [sym_true] = ACTIONS(4556),
    [sym_false] = ACTIONS(4556),
    [sym_null] = ACTIONS(4556),
    [sym_identifier] = ACTIONS(4556),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4556),
    [sym_auto] = ACTIONS(4556),
    [anon_sym_typename] = ACTIONS(4556),
    [anon_sym_delete] = ACTIONS(4556),
    [anon_sym_try] = ACTIONS(4556),
    [anon_sym_new] = ACTIONS(4556),
    [anon_sym_COLON_COLON] = ACTIONS(4554),
    [sym_nullptr] = ACTIONS(4556),
  },
  [3290] = {
    [sym__expression] = STATE(3484),
    [sym_conditional_expression] = STATE(3484),
    [sym_assignment_expression] = STATE(3484),
    [sym_pointer_expression] = STATE(3484),
    [sym_logical_expression] = STATE(3484),
    [sym_bitwise_expression] = STATE(3484),
    [sym_equality_expression] = STATE(3484),
    [sym_relational_expression] = STATE(3484),
    [sym_shift_expression] = STATE(3484),
    [sym_math_expression] = STATE(3484),
    [sym_cast_expression] = STATE(3484),
    [sym_sizeof_expression] = STATE(3484),
    [sym_subscript_expression] = STATE(3484),
    [sym_call_expression] = STATE(3484),
    [sym_field_expression] = STATE(3484),
    [sym_compound_literal_expression] = STATE(3484),
    [sym_parenthesized_expression] = STATE(3484),
    [sym_char_literal] = STATE(3484),
    [sym_concatenated_string] = STATE(3484),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3484),
    [sym_new_expression] = STATE(3484),
    [sym_delete_expression] = STATE(3484),
    [sym_lambda_expression] = STATE(3484),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7788),
    [anon_sym_RPAREN] = ACTIONS(7790),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(7788),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7792),
    [sym_false] = ACTIONS(7792),
    [sym_null] = ACTIONS(7792),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(7792),
  },
  [3291] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(7794),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3292] = {
    [sym__expression] = STATE(3486),
    [sym_conditional_expression] = STATE(3486),
    [sym_assignment_expression] = STATE(3486),
    [sym_pointer_expression] = STATE(3486),
    [sym_logical_expression] = STATE(3486),
    [sym_bitwise_expression] = STATE(3486),
    [sym_equality_expression] = STATE(3486),
    [sym_relational_expression] = STATE(3486),
    [sym_shift_expression] = STATE(3486),
    [sym_math_expression] = STATE(3486),
    [sym_cast_expression] = STATE(3486),
    [sym_sizeof_expression] = STATE(3486),
    [sym_subscript_expression] = STATE(3486),
    [sym_call_expression] = STATE(3486),
    [sym_field_expression] = STATE(3486),
    [sym_compound_literal_expression] = STATE(3486),
    [sym_parenthesized_expression] = STATE(3486),
    [sym_char_literal] = STATE(3486),
    [sym_concatenated_string] = STATE(3486),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3486),
    [sym_new_expression] = STATE(3486),
    [sym_delete_expression] = STATE(3486),
    [sym_lambda_expression] = STATE(3486),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7796),
    [anon_sym_SEMI] = ACTIONS(7794),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(7796),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7798),
    [sym_false] = ACTIONS(7798),
    [sym_null] = ACTIONS(7798),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(7798),
  },
  [3293] = {
    [sym__expression] = STATE(3487),
    [sym_conditional_expression] = STATE(3487),
    [sym_assignment_expression] = STATE(3487),
    [sym_pointer_expression] = STATE(3487),
    [sym_logical_expression] = STATE(3487),
    [sym_bitwise_expression] = STATE(3487),
    [sym_equality_expression] = STATE(3487),
    [sym_relational_expression] = STATE(3487),
    [sym_shift_expression] = STATE(3487),
    [sym_math_expression] = STATE(3487),
    [sym_cast_expression] = STATE(3487),
    [sym_sizeof_expression] = STATE(3487),
    [sym_subscript_expression] = STATE(3487),
    [sym_call_expression] = STATE(3487),
    [sym_field_expression] = STATE(3487),
    [sym_compound_literal_expression] = STATE(3487),
    [sym_parenthesized_expression] = STATE(3487),
    [sym_char_literal] = STATE(3487),
    [sym_concatenated_string] = STATE(3487),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3487),
    [sym_new_expression] = STATE(3487),
    [sym_delete_expression] = STATE(3487),
    [sym_lambda_expression] = STATE(3487),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7800),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(7800),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7802),
    [sym_false] = ACTIONS(7802),
    [sym_null] = ACTIONS(7802),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(7802),
  },
  [3294] = {
    [sym_compound_statement] = STATE(3488),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [sym_comment] = ACTIONS(91),
  },
  [3295] = {
    [sym_catch_clause] = STATE(3295),
    [aux_sym_try_statement_repeat1] = STATE(3295),
    [sym_raw_string_literal] = ACTIONS(4993),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4995),
    [sym_preproc_directive] = ACTIONS(4995),
    [anon_sym_SEMI] = ACTIONS(4993),
    [anon_sym_typedef] = ACTIONS(4995),
    [anon_sym_extern] = ACTIONS(4995),
    [anon_sym_LBRACE] = ACTIONS(4993),
    [anon_sym_LPAREN2] = ACTIONS(4993),
    [anon_sym_STAR] = ACTIONS(4993),
    [anon_sym_LBRACK] = ACTIONS(4993),
    [anon_sym_static] = ACTIONS(4995),
    [anon_sym_register] = ACTIONS(4995),
    [anon_sym_inline] = ACTIONS(4995),
    [anon_sym_const] = ACTIONS(4995),
    [anon_sym_restrict] = ACTIONS(4995),
    [anon_sym_volatile] = ACTIONS(4995),
    [anon_sym__Atomic] = ACTIONS(4995),
    [anon_sym_mutable] = ACTIONS(4995),
    [anon_sym_explicit] = ACTIONS(4995),
    [anon_sym_constexpr] = ACTIONS(4995),
    [anon_sym_unsigned] = ACTIONS(4995),
    [anon_sym_long] = ACTIONS(4995),
    [anon_sym_short] = ACTIONS(4995),
    [sym_primitive_type] = ACTIONS(4995),
    [anon_sym_enum] = ACTIONS(4995),
    [anon_sym_struct] = ACTIONS(4995),
    [anon_sym_union] = ACTIONS(4995),
    [anon_sym_if] = ACTIONS(4995),
    [anon_sym_switch] = ACTIONS(4995),
    [anon_sym_case] = ACTIONS(4995),
    [anon_sym_default] = ACTIONS(4995),
    [anon_sym_while] = ACTIONS(4995),
    [anon_sym_do] = ACTIONS(4995),
    [anon_sym_for] = ACTIONS(4995),
    [anon_sym_return] = ACTIONS(4995),
    [anon_sym_break] = ACTIONS(4995),
    [anon_sym_continue] = ACTIONS(4995),
    [anon_sym_goto] = ACTIONS(4995),
    [anon_sym_AMP] = ACTIONS(4993),
    [anon_sym_BANG] = ACTIONS(4993),
    [anon_sym_TILDE] = ACTIONS(4993),
    [anon_sym_PLUS] = ACTIONS(4995),
    [anon_sym_DASH] = ACTIONS(4995),
    [anon_sym_DASH_DASH] = ACTIONS(4993),
    [anon_sym_PLUS_PLUS] = ACTIONS(4993),
    [anon_sym_sizeof] = ACTIONS(4995),
    [sym_number_literal] = ACTIONS(4993),
    [anon_sym_SQUOTE] = ACTIONS(4993),
    [anon_sym_DQUOTE] = ACTIONS(4993),
    [sym_true] = ACTIONS(4995),
    [sym_false] = ACTIONS(4995),
    [sym_null] = ACTIONS(4995),
    [sym_identifier] = ACTIONS(4995),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4995),
    [sym_auto] = ACTIONS(4995),
    [anon_sym_typename] = ACTIONS(4995),
    [anon_sym_delete] = ACTIONS(4995),
    [anon_sym_try] = ACTIONS(4995),
    [anon_sym_catch] = ACTIONS(7804),
    [anon_sym_new] = ACTIONS(4995),
    [anon_sym_COLON_COLON] = ACTIONS(4993),
    [sym_nullptr] = ACTIONS(4995),
  },
  [3296] = {
    [sym_raw_string_literal] = ACTIONS(5113),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5115),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5115),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5115),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5115),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5115),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5115),
    [sym_preproc_directive] = ACTIONS(5115),
    [anon_sym_SEMI] = ACTIONS(5113),
    [anon_sym_typedef] = ACTIONS(5115),
    [anon_sym_extern] = ACTIONS(5115),
    [anon_sym_LBRACE] = ACTIONS(5113),
    [anon_sym_LPAREN2] = ACTIONS(5113),
    [anon_sym_STAR] = ACTIONS(5113),
    [anon_sym_LBRACK] = ACTIONS(5113),
    [anon_sym_static] = ACTIONS(5115),
    [anon_sym_register] = ACTIONS(5115),
    [anon_sym_inline] = ACTIONS(5115),
    [anon_sym_const] = ACTIONS(5115),
    [anon_sym_restrict] = ACTIONS(5115),
    [anon_sym_volatile] = ACTIONS(5115),
    [anon_sym__Atomic] = ACTIONS(5115),
    [anon_sym_mutable] = ACTIONS(5115),
    [anon_sym_explicit] = ACTIONS(5115),
    [anon_sym_constexpr] = ACTIONS(5115),
    [anon_sym_unsigned] = ACTIONS(5115),
    [anon_sym_long] = ACTIONS(5115),
    [anon_sym_short] = ACTIONS(5115),
    [sym_primitive_type] = ACTIONS(5115),
    [anon_sym_enum] = ACTIONS(5115),
    [anon_sym_struct] = ACTIONS(5115),
    [anon_sym_union] = ACTIONS(5115),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_else] = ACTIONS(5115),
    [anon_sym_switch] = ACTIONS(5115),
    [anon_sym_case] = ACTIONS(5115),
    [anon_sym_default] = ACTIONS(5115),
    [anon_sym_while] = ACTIONS(5115),
    [anon_sym_do] = ACTIONS(5115),
    [anon_sym_for] = ACTIONS(5115),
    [anon_sym_return] = ACTIONS(5115),
    [anon_sym_break] = ACTIONS(5115),
    [anon_sym_continue] = ACTIONS(5115),
    [anon_sym_goto] = ACTIONS(5115),
    [anon_sym_AMP] = ACTIONS(5113),
    [anon_sym_BANG] = ACTIONS(5113),
    [anon_sym_TILDE] = ACTIONS(5113),
    [anon_sym_PLUS] = ACTIONS(5115),
    [anon_sym_DASH] = ACTIONS(5115),
    [anon_sym_DASH_DASH] = ACTIONS(5113),
    [anon_sym_PLUS_PLUS] = ACTIONS(5113),
    [anon_sym_sizeof] = ACTIONS(5115),
    [sym_number_literal] = ACTIONS(5113),
    [anon_sym_SQUOTE] = ACTIONS(5113),
    [anon_sym_DQUOTE] = ACTIONS(5113),
    [sym_true] = ACTIONS(5115),
    [sym_false] = ACTIONS(5115),
    [sym_null] = ACTIONS(5115),
    [sym_identifier] = ACTIONS(5115),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5115),
    [sym_auto] = ACTIONS(5115),
    [anon_sym_typename] = ACTIONS(5115),
    [anon_sym_delete] = ACTIONS(5115),
    [anon_sym_try] = ACTIONS(5115),
    [anon_sym_new] = ACTIONS(5115),
    [anon_sym_COLON_COLON] = ACTIONS(5113),
    [sym_nullptr] = ACTIONS(5115),
  },
  [3297] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(7807),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3298] = {
    [anon_sym_SEMI] = ACTIONS(7807),
    [sym_comment] = ACTIONS(91),
  },
  [3299] = {
    [sym_raw_string_literal] = ACTIONS(5122),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5124),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5124),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5124),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5124),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5124),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5124),
    [sym_preproc_directive] = ACTIONS(5124),
    [anon_sym_SEMI] = ACTIONS(5122),
    [anon_sym_typedef] = ACTIONS(5124),
    [anon_sym_extern] = ACTIONS(5124),
    [anon_sym_LBRACE] = ACTIONS(5122),
    [anon_sym_LPAREN2] = ACTIONS(5122),
    [anon_sym_STAR] = ACTIONS(5122),
    [anon_sym_LBRACK] = ACTIONS(5122),
    [anon_sym_static] = ACTIONS(5124),
    [anon_sym_register] = ACTIONS(5124),
    [anon_sym_inline] = ACTIONS(5124),
    [anon_sym_const] = ACTIONS(5124),
    [anon_sym_restrict] = ACTIONS(5124),
    [anon_sym_volatile] = ACTIONS(5124),
    [anon_sym__Atomic] = ACTIONS(5124),
    [anon_sym_mutable] = ACTIONS(5124),
    [anon_sym_explicit] = ACTIONS(5124),
    [anon_sym_constexpr] = ACTIONS(5124),
    [anon_sym_unsigned] = ACTIONS(5124),
    [anon_sym_long] = ACTIONS(5124),
    [anon_sym_short] = ACTIONS(5124),
    [sym_primitive_type] = ACTIONS(5124),
    [anon_sym_enum] = ACTIONS(5124),
    [anon_sym_struct] = ACTIONS(5124),
    [anon_sym_union] = ACTIONS(5124),
    [anon_sym_if] = ACTIONS(5124),
    [anon_sym_switch] = ACTIONS(5124),
    [anon_sym_case] = ACTIONS(5124),
    [anon_sym_default] = ACTIONS(5124),
    [anon_sym_while] = ACTIONS(5124),
    [anon_sym_do] = ACTIONS(5124),
    [anon_sym_for] = ACTIONS(5124),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_break] = ACTIONS(5124),
    [anon_sym_continue] = ACTIONS(5124),
    [anon_sym_goto] = ACTIONS(5124),
    [anon_sym_AMP] = ACTIONS(5122),
    [anon_sym_BANG] = ACTIONS(5122),
    [anon_sym_TILDE] = ACTIONS(5122),
    [anon_sym_PLUS] = ACTIONS(5124),
    [anon_sym_DASH] = ACTIONS(5124),
    [anon_sym_DASH_DASH] = ACTIONS(5122),
    [anon_sym_PLUS_PLUS] = ACTIONS(5122),
    [anon_sym_sizeof] = ACTIONS(5124),
    [sym_number_literal] = ACTIONS(5122),
    [anon_sym_SQUOTE] = ACTIONS(5122),
    [anon_sym_DQUOTE] = ACTIONS(5122),
    [sym_true] = ACTIONS(5124),
    [sym_false] = ACTIONS(5124),
    [sym_null] = ACTIONS(5124),
    [sym_identifier] = ACTIONS(5124),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5124),
    [sym_auto] = ACTIONS(5124),
    [anon_sym_typename] = ACTIONS(5124),
    [anon_sym_delete] = ACTIONS(5124),
    [anon_sym_try] = ACTIONS(5124),
    [anon_sym_new] = ACTIONS(5124),
    [anon_sym_COLON_COLON] = ACTIONS(5122),
    [sym_nullptr] = ACTIONS(5124),
  },
  [3300] = {
    [sym_raw_string_literal] = ACTIONS(5621),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5623),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5623),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5623),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5623),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5623),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5623),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(5623),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(5623),
    [sym_preproc_directive] = ACTIONS(5623),
    [anon_sym_SEMI] = ACTIONS(5621),
    [anon_sym_typedef] = ACTIONS(5623),
    [anon_sym_extern] = ACTIONS(5623),
    [anon_sym_LBRACE] = ACTIONS(5621),
    [anon_sym_LPAREN2] = ACTIONS(5621),
    [anon_sym_STAR] = ACTIONS(5621),
    [anon_sym_LBRACK] = ACTIONS(5621),
    [anon_sym_static] = ACTIONS(5623),
    [anon_sym_register] = ACTIONS(5623),
    [anon_sym_inline] = ACTIONS(5623),
    [anon_sym_const] = ACTIONS(5623),
    [anon_sym_restrict] = ACTIONS(5623),
    [anon_sym_volatile] = ACTIONS(5623),
    [anon_sym__Atomic] = ACTIONS(5623),
    [anon_sym_mutable] = ACTIONS(5623),
    [anon_sym_explicit] = ACTIONS(5623),
    [anon_sym_constexpr] = ACTIONS(5623),
    [anon_sym_unsigned] = ACTIONS(5623),
    [anon_sym_long] = ACTIONS(5623),
    [anon_sym_short] = ACTIONS(5623),
    [sym_primitive_type] = ACTIONS(5623),
    [anon_sym_enum] = ACTIONS(5623),
    [anon_sym_struct] = ACTIONS(5623),
    [anon_sym_union] = ACTIONS(5623),
    [anon_sym_if] = ACTIONS(5623),
    [anon_sym_else] = ACTIONS(5623),
    [anon_sym_switch] = ACTIONS(5623),
    [anon_sym_case] = ACTIONS(5623),
    [anon_sym_default] = ACTIONS(5623),
    [anon_sym_while] = ACTIONS(5623),
    [anon_sym_do] = ACTIONS(5623),
    [anon_sym_for] = ACTIONS(5623),
    [anon_sym_return] = ACTIONS(5623),
    [anon_sym_break] = ACTIONS(5623),
    [anon_sym_continue] = ACTIONS(5623),
    [anon_sym_goto] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5621),
    [anon_sym_BANG] = ACTIONS(5621),
    [anon_sym_TILDE] = ACTIONS(5621),
    [anon_sym_PLUS] = ACTIONS(5623),
    [anon_sym_DASH] = ACTIONS(5623),
    [anon_sym_DASH_DASH] = ACTIONS(5621),
    [anon_sym_PLUS_PLUS] = ACTIONS(5621),
    [anon_sym_sizeof] = ACTIONS(5623),
    [sym_number_literal] = ACTIONS(5621),
    [anon_sym_SQUOTE] = ACTIONS(5621),
    [anon_sym_DQUOTE] = ACTIONS(5621),
    [sym_true] = ACTIONS(5623),
    [sym_false] = ACTIONS(5623),
    [sym_null] = ACTIONS(5623),
    [sym_identifier] = ACTIONS(5623),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5623),
    [sym_auto] = ACTIONS(5623),
    [anon_sym_typename] = ACTIONS(5623),
    [anon_sym_delete] = ACTIONS(5623),
    [anon_sym_try] = ACTIONS(5623),
    [anon_sym_new] = ACTIONS(5623),
    [anon_sym_COLON_COLON] = ACTIONS(5621),
    [sym_nullptr] = ACTIONS(5623),
  },
  [3301] = {
    [anon_sym_LPAREN2] = ACTIONS(7809),
    [anon_sym_constexpr] = ACTIONS(7811),
    [sym_comment] = ACTIONS(91),
  },
  [3302] = {
    [sym_parenthesized_expression] = STATE(3492),
    [anon_sym_LPAREN2] = ACTIONS(323),
    [sym_comment] = ACTIONS(91),
  },
  [3303] = {
    [sym__expression] = STATE(3493),
    [sym_conditional_expression] = STATE(3493),
    [sym_assignment_expression] = STATE(3493),
    [sym_pointer_expression] = STATE(3493),
    [sym_logical_expression] = STATE(3493),
    [sym_bitwise_expression] = STATE(3493),
    [sym_equality_expression] = STATE(3493),
    [sym_relational_expression] = STATE(3493),
    [sym_shift_expression] = STATE(3493),
    [sym_math_expression] = STATE(3493),
    [sym_cast_expression] = STATE(3493),
    [sym_sizeof_expression] = STATE(3493),
    [sym_subscript_expression] = STATE(3493),
    [sym_call_expression] = STATE(3493),
    [sym_field_expression] = STATE(3493),
    [sym_compound_literal_expression] = STATE(3493),
    [sym_parenthesized_expression] = STATE(3493),
    [sym_char_literal] = STATE(3493),
    [sym_concatenated_string] = STATE(3493),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3493),
    [sym_new_expression] = STATE(3493),
    [sym_delete_expression] = STATE(3493),
    [sym_lambda_expression] = STATE(3493),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7813),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(7813),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(7815),
    [sym_false] = ACTIONS(7815),
    [sym_null] = ACTIONS(7815),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(7815),
  },
  [3304] = {
    [anon_sym_COLON] = ACTIONS(7817),
    [sym_comment] = ACTIONS(91),
  },
  [3305] = {
    [sym_parenthesized_expression] = STATE(3495),
    [anon_sym_LPAREN2] = ACTIONS(323),
    [sym_comment] = ACTIONS(91),
  },
  [3306] = {
    [anon_sym_LPAREN2] = ACTIONS(7819),
    [sym_comment] = ACTIONS(91),
  },
  [3307] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(548),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_COLON] = ACTIONS(7821),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(935),
  },
  [3308] = {
    [sym_compound_statement] = STATE(3498),
    [anon_sym_LBRACE] = ACTIONS(357),
    [sym_comment] = ACTIONS(91),
  },
  [3309] = {
    [sym_raw_string_literal] = ACTIONS(6091),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6093),
    [sym_preproc_directive] = ACTIONS(6093),
    [anon_sym_SEMI] = ACTIONS(6091),
    [anon_sym_typedef] = ACTIONS(6093),
    [anon_sym_extern] = ACTIONS(6093),
    [anon_sym_LBRACE] = ACTIONS(6091),
    [anon_sym_LPAREN2] = ACTIONS(6091),
    [anon_sym_STAR] = ACTIONS(6091),
    [anon_sym_LBRACK] = ACTIONS(6091),
    [anon_sym_static] = ACTIONS(6093),
    [anon_sym_register] = ACTIONS(6093),
    [anon_sym_inline] = ACTIONS(6093),
    [anon_sym_const] = ACTIONS(6093),
    [anon_sym_restrict] = ACTIONS(6093),
    [anon_sym_volatile] = ACTIONS(6093),
    [anon_sym__Atomic] = ACTIONS(6093),
    [anon_sym_mutable] = ACTIONS(6093),
    [anon_sym_explicit] = ACTIONS(6093),
    [anon_sym_constexpr] = ACTIONS(6093),
    [anon_sym_unsigned] = ACTIONS(6093),
    [anon_sym_long] = ACTIONS(6093),
    [anon_sym_short] = ACTIONS(6093),
    [sym_primitive_type] = ACTIONS(6093),
    [anon_sym_enum] = ACTIONS(6093),
    [anon_sym_struct] = ACTIONS(6093),
    [anon_sym_union] = ACTIONS(6093),
    [anon_sym_if] = ACTIONS(6093),
    [anon_sym_else] = ACTIONS(7823),
    [anon_sym_switch] = ACTIONS(6093),
    [anon_sym_case] = ACTIONS(6093),
    [anon_sym_default] = ACTIONS(6093),
    [anon_sym_while] = ACTIONS(6093),
    [anon_sym_do] = ACTIONS(6093),
    [anon_sym_for] = ACTIONS(6093),
    [anon_sym_return] = ACTIONS(6093),
    [anon_sym_break] = ACTIONS(6093),
    [anon_sym_continue] = ACTIONS(6093),
    [anon_sym_goto] = ACTIONS(6093),
    [anon_sym_AMP] = ACTIONS(6091),
    [anon_sym_BANG] = ACTIONS(6091),
    [anon_sym_TILDE] = ACTIONS(6091),
    [anon_sym_PLUS] = ACTIONS(6093),
    [anon_sym_DASH] = ACTIONS(6093),
    [anon_sym_DASH_DASH] = ACTIONS(6091),
    [anon_sym_PLUS_PLUS] = ACTIONS(6091),
    [anon_sym_sizeof] = ACTIONS(6093),
    [sym_number_literal] = ACTIONS(6091),
    [anon_sym_SQUOTE] = ACTIONS(6091),
    [anon_sym_DQUOTE] = ACTIONS(6091),
    [sym_true] = ACTIONS(6093),
    [sym_false] = ACTIONS(6093),
    [sym_null] = ACTIONS(6093),
    [sym_identifier] = ACTIONS(6093),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6093),
    [sym_auto] = ACTIONS(6093),
    [anon_sym_typename] = ACTIONS(6093),
    [anon_sym_delete] = ACTIONS(6093),
    [anon_sym_try] = ACTIONS(6093),
    [anon_sym_new] = ACTIONS(6093),
    [anon_sym_COLON_COLON] = ACTIONS(6091),
    [sym_nullptr] = ACTIONS(6093),
  },
  [3310] = {
    [sym_compound_statement] = STATE(3500),
    [sym_labeled_statement] = STATE(3500),
    [sym_expression_statement] = STATE(3500),
    [sym_if_statement] = STATE(3500),
    [sym_switch_statement] = STATE(3500),
    [sym_case_statement] = STATE(3500),
    [sym_while_statement] = STATE(3500),
    [sym_do_statement] = STATE(3500),
    [sym_for_statement] = STATE(3500),
    [sym_return_statement] = STATE(3500),
    [sym_break_statement] = STATE(3500),
    [sym_continue_statement] = STATE(3500),
    [sym_goto_statement] = STATE(3500),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(3500),
    [sym_try_statement] = STATE(3500),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7431),
    [anon_sym_switch] = ACTIONS(7433),
    [anon_sym_case] = ACTIONS(7435),
    [anon_sym_default] = ACTIONS(7437),
    [anon_sym_while] = ACTIONS(7439),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(7441),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(7443),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7445),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2242),
  },
  [3311] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(895),
    [anon_sym_RPAREN] = ACTIONS(7825),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3312] = {
    [anon_sym_RPAREN] = ACTIONS(7825),
    [sym_comment] = ACTIONS(91),
  },
  [3313] = {
    [sym_compound_statement] = STATE(3502),
    [sym_labeled_statement] = STATE(3502),
    [sym_expression_statement] = STATE(3502),
    [sym_if_statement] = STATE(3502),
    [sym_switch_statement] = STATE(3502),
    [sym_case_statement] = STATE(3502),
    [sym_while_statement] = STATE(3502),
    [sym_do_statement] = STATE(3502),
    [sym_for_statement] = STATE(3502),
    [sym_return_statement] = STATE(3502),
    [sym_break_statement] = STATE(3502),
    [sym_continue_statement] = STATE(3502),
    [sym_goto_statement] = STATE(3502),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(3502),
    [sym_try_statement] = STATE(3502),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(2220),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(5705),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2242),
  },
  [3314] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3504),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(7827),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3315] = {
    [sym__expression] = STATE(3505),
    [sym_conditional_expression] = STATE(3505),
    [sym_assignment_expression] = STATE(3505),
    [sym_pointer_expression] = STATE(3505),
    [sym_logical_expression] = STATE(3505),
    [sym_bitwise_expression] = STATE(3505),
    [sym_equality_expression] = STATE(3505),
    [sym_relational_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_math_expression] = STATE(3505),
    [sym_cast_expression] = STATE(3505),
    [sym_sizeof_expression] = STATE(3505),
    [sym_subscript_expression] = STATE(3505),
    [sym_call_expression] = STATE(3505),
    [sym_field_expression] = STATE(3505),
    [sym_compound_literal_expression] = STATE(3505),
    [sym_parenthesized_expression] = STATE(3505),
    [sym_char_literal] = STATE(3505),
    [sym_concatenated_string] = STATE(3505),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3505),
    [sym_new_expression] = STATE(3505),
    [sym_delete_expression] = STATE(3505),
    [sym_lambda_expression] = STATE(3505),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7829),
    [anon_sym_RPAREN] = ACTIONS(7827),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(7829),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7831),
    [sym_false] = ACTIONS(7831),
    [sym_null] = ACTIONS(7831),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(7831),
  },
  [3316] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(7833),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3317] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(7835),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3318] = {
    [sym_raw_string_literal] = ACTIONS(6379),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6381),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6381),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6381),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6381),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6381),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6381),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6381),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6381),
    [sym_preproc_directive] = ACTIONS(6381),
    [anon_sym_SEMI] = ACTIONS(6379),
    [anon_sym_typedef] = ACTIONS(6381),
    [anon_sym_extern] = ACTIONS(6381),
    [anon_sym_LBRACE] = ACTIONS(6379),
    [anon_sym_LPAREN2] = ACTIONS(6379),
    [anon_sym_STAR] = ACTIONS(6379),
    [anon_sym_LBRACK] = ACTIONS(6379),
    [anon_sym_static] = ACTIONS(6381),
    [anon_sym_register] = ACTIONS(6381),
    [anon_sym_inline] = ACTIONS(6381),
    [anon_sym_const] = ACTIONS(6381),
    [anon_sym_restrict] = ACTIONS(6381),
    [anon_sym_volatile] = ACTIONS(6381),
    [anon_sym__Atomic] = ACTIONS(6381),
    [anon_sym_mutable] = ACTIONS(6381),
    [anon_sym_explicit] = ACTIONS(6381),
    [anon_sym_constexpr] = ACTIONS(6381),
    [anon_sym_unsigned] = ACTIONS(6381),
    [anon_sym_long] = ACTIONS(6381),
    [anon_sym_short] = ACTIONS(6381),
    [sym_primitive_type] = ACTIONS(6381),
    [anon_sym_enum] = ACTIONS(6381),
    [anon_sym_struct] = ACTIONS(6381),
    [anon_sym_union] = ACTIONS(6381),
    [anon_sym_if] = ACTIONS(6381),
    [anon_sym_else] = ACTIONS(6381),
    [anon_sym_switch] = ACTIONS(6381),
    [anon_sym_case] = ACTIONS(6381),
    [anon_sym_default] = ACTIONS(6381),
    [anon_sym_while] = ACTIONS(6381),
    [anon_sym_do] = ACTIONS(6381),
    [anon_sym_for] = ACTIONS(6381),
    [anon_sym_return] = ACTIONS(6381),
    [anon_sym_break] = ACTIONS(6381),
    [anon_sym_continue] = ACTIONS(6381),
    [anon_sym_goto] = ACTIONS(6381),
    [anon_sym_AMP] = ACTIONS(6379),
    [anon_sym_BANG] = ACTIONS(6379),
    [anon_sym_TILDE] = ACTIONS(6379),
    [anon_sym_PLUS] = ACTIONS(6381),
    [anon_sym_DASH] = ACTIONS(6381),
    [anon_sym_DASH_DASH] = ACTIONS(6379),
    [anon_sym_PLUS_PLUS] = ACTIONS(6379),
    [anon_sym_sizeof] = ACTIONS(6381),
    [sym_number_literal] = ACTIONS(6379),
    [anon_sym_SQUOTE] = ACTIONS(6379),
    [anon_sym_DQUOTE] = ACTIONS(6379),
    [sym_true] = ACTIONS(6381),
    [sym_false] = ACTIONS(6381),
    [sym_null] = ACTIONS(6381),
    [sym_identifier] = ACTIONS(6381),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6381),
    [sym_auto] = ACTIONS(6381),
    [anon_sym_typename] = ACTIONS(6381),
    [anon_sym_delete] = ACTIONS(6381),
    [anon_sym_try] = ACTIONS(6381),
    [anon_sym_catch] = ACTIONS(6381),
    [anon_sym_new] = ACTIONS(6381),
    [anon_sym_COLON_COLON] = ACTIONS(6379),
    [sym_nullptr] = ACTIONS(6381),
  },
  [3319] = {
    [sym_raw_string_literal] = ACTIONS(6503),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6505),
    [sym_preproc_directive] = ACTIONS(6505),
    [anon_sym_SEMI] = ACTIONS(6503),
    [anon_sym_typedef] = ACTIONS(6505),
    [anon_sym_extern] = ACTIONS(6505),
    [anon_sym_LBRACE] = ACTIONS(6503),
    [anon_sym_LPAREN2] = ACTIONS(6503),
    [anon_sym_STAR] = ACTIONS(6503),
    [anon_sym_LBRACK] = ACTIONS(6503),
    [anon_sym_static] = ACTIONS(6505),
    [anon_sym_register] = ACTIONS(6505),
    [anon_sym_inline] = ACTIONS(6505),
    [anon_sym_const] = ACTIONS(6505),
    [anon_sym_restrict] = ACTIONS(6505),
    [anon_sym_volatile] = ACTIONS(6505),
    [anon_sym__Atomic] = ACTIONS(6505),
    [anon_sym_mutable] = ACTIONS(6505),
    [anon_sym_explicit] = ACTIONS(6505),
    [anon_sym_constexpr] = ACTIONS(6505),
    [anon_sym_unsigned] = ACTIONS(6505),
    [anon_sym_long] = ACTIONS(6505),
    [anon_sym_short] = ACTIONS(6505),
    [sym_primitive_type] = ACTIONS(6505),
    [anon_sym_enum] = ACTIONS(6505),
    [anon_sym_struct] = ACTIONS(6505),
    [anon_sym_union] = ACTIONS(6505),
    [anon_sym_if] = ACTIONS(6505),
    [anon_sym_switch] = ACTIONS(6505),
    [anon_sym_case] = ACTIONS(6505),
    [anon_sym_default] = ACTIONS(6505),
    [anon_sym_while] = ACTIONS(6505),
    [anon_sym_do] = ACTIONS(6505),
    [anon_sym_for] = ACTIONS(6505),
    [anon_sym_return] = ACTIONS(6505),
    [anon_sym_break] = ACTIONS(6505),
    [anon_sym_continue] = ACTIONS(6505),
    [anon_sym_goto] = ACTIONS(6505),
    [anon_sym_AMP] = ACTIONS(6503),
    [anon_sym_BANG] = ACTIONS(6503),
    [anon_sym_TILDE] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6505),
    [anon_sym_DASH] = ACTIONS(6505),
    [anon_sym_DASH_DASH] = ACTIONS(6503),
    [anon_sym_PLUS_PLUS] = ACTIONS(6503),
    [anon_sym_sizeof] = ACTIONS(6505),
    [sym_number_literal] = ACTIONS(6503),
    [anon_sym_SQUOTE] = ACTIONS(6503),
    [anon_sym_DQUOTE] = ACTIONS(6503),
    [sym_true] = ACTIONS(6505),
    [sym_false] = ACTIONS(6505),
    [sym_null] = ACTIONS(6505),
    [sym_identifier] = ACTIONS(6505),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6505),
    [sym_auto] = ACTIONS(6505),
    [anon_sym_typename] = ACTIONS(6505),
    [anon_sym_delete] = ACTIONS(6505),
    [anon_sym_try] = ACTIONS(6505),
    [anon_sym_new] = ACTIONS(6505),
    [anon_sym_COLON_COLON] = ACTIONS(6503),
    [sym_nullptr] = ACTIONS(6505),
  },
  [3320] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(7837),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3321] = {
    [sym__expression] = STATE(3509),
    [sym_conditional_expression] = STATE(3509),
    [sym_assignment_expression] = STATE(3509),
    [sym_pointer_expression] = STATE(3509),
    [sym_logical_expression] = STATE(3509),
    [sym_bitwise_expression] = STATE(3509),
    [sym_equality_expression] = STATE(3509),
    [sym_relational_expression] = STATE(3509),
    [sym_shift_expression] = STATE(3509),
    [sym_math_expression] = STATE(3509),
    [sym_cast_expression] = STATE(3509),
    [sym_sizeof_expression] = STATE(3509),
    [sym_subscript_expression] = STATE(3509),
    [sym_call_expression] = STATE(3509),
    [sym_field_expression] = STATE(3509),
    [sym_compound_literal_expression] = STATE(3509),
    [sym_parenthesized_expression] = STATE(3509),
    [sym_char_literal] = STATE(3509),
    [sym_concatenated_string] = STATE(3509),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3509),
    [sym_new_expression] = STATE(3509),
    [sym_delete_expression] = STATE(3509),
    [sym_lambda_expression] = STATE(3509),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7839),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(7839),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7841),
    [sym_false] = ACTIONS(7841),
    [sym_null] = ACTIONS(7841),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(7841),
  },
  [3322] = {
    [sym_declaration] = STATE(1948),
    [sym_type_definition] = STATE(1948),
    [sym__declaration_specifiers] = STATE(1156),
    [sym_compound_statement] = STATE(1948),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_labeled_statement] = STATE(1948),
    [sym_expression_statement] = STATE(1948),
    [sym_if_statement] = STATE(1948),
    [sym_switch_statement] = STATE(1948),
    [sym_case_statement] = STATE(1948),
    [sym_while_statement] = STATE(1948),
    [sym_do_statement] = STATE(1948),
    [sym_for_statement] = STATE(1948),
    [sym_return_statement] = STATE(1948),
    [sym_break_statement] = STATE(1948),
    [sym_continue_statement] = STATE(1948),
    [sym_goto_statement] = STATE(1948),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(1948),
    [sym_try_statement] = STATE(1948),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(157),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_typedef] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(5814),
    [anon_sym_switch] = ACTIONS(5816),
    [anon_sym_case] = ACTIONS(5818),
    [anon_sym_default] = ACTIONS(5820),
    [anon_sym_while] = ACTIONS(5822),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(5824),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(7482),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(5828),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(1202),
    [sym_nullptr] = ACTIONS(207),
  },
  [3323] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(1362),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_extern] = ACTIONS(468),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(465),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_register] = ACTIONS(468),
    [anon_sym_inline] = ACTIONS(468),
    [anon_sym_const] = ACTIONS(468),
    [anon_sym_restrict] = ACTIONS(468),
    [anon_sym_volatile] = ACTIONS(468),
    [anon_sym__Atomic] = ACTIONS(468),
    [anon_sym_mutable] = ACTIONS(468),
    [anon_sym_explicit] = ACTIONS(468),
    [anon_sym_constexpr] = ACTIONS(468),
    [anon_sym_COLON] = ACTIONS(6920),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(474),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_TILDE] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_identifier] = ACTIONS(468),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(2855),
    [sym_operator_name] = ACTIONS(481),
  },
  [3324] = {
    [sym__expression] = STATE(3511),
    [sym_conditional_expression] = STATE(3511),
    [sym_assignment_expression] = STATE(3511),
    [sym_pointer_expression] = STATE(3511),
    [sym_logical_expression] = STATE(3511),
    [sym_bitwise_expression] = STATE(3511),
    [sym_equality_expression] = STATE(3511),
    [sym_relational_expression] = STATE(3511),
    [sym_shift_expression] = STATE(3511),
    [sym_math_expression] = STATE(3511),
    [sym_cast_expression] = STATE(3511),
    [sym_sizeof_expression] = STATE(3511),
    [sym_subscript_expression] = STATE(3511),
    [sym_call_expression] = STATE(3511),
    [sym_field_expression] = STATE(3511),
    [sym_compound_literal_expression] = STATE(3511),
    [sym_parenthesized_expression] = STATE(3511),
    [sym_char_literal] = STATE(3511),
    [sym_concatenated_string] = STATE(3511),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3511),
    [sym_new_expression] = STATE(3511),
    [sym_delete_expression] = STATE(3511),
    [sym_lambda_expression] = STATE(3511),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7843),
    [anon_sym_SEMI] = ACTIONS(7845),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(7843),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7847),
    [sym_false] = ACTIONS(7847),
    [sym_null] = ACTIONS(7847),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(7847),
  },
  [3325] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(7849),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3326] = {
    [anon_sym_COLON] = ACTIONS(7851),
    [sym_comment] = ACTIONS(91),
  },
  [3327] = {
    [sym_catch_clause] = STATE(3514),
    [aux_sym_try_statement_repeat1] = STATE(3514),
    [sym_raw_string_literal] = ACTIONS(3346),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3348),
    [sym_preproc_directive] = ACTIONS(3348),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym_typedef] = ACTIONS(3348),
    [anon_sym_extern] = ACTIONS(3348),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_RBRACE] = ACTIONS(3346),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(3346),
    [anon_sym_static] = ACTIONS(3348),
    [anon_sym_register] = ACTIONS(3348),
    [anon_sym_inline] = ACTIONS(3348),
    [anon_sym_const] = ACTIONS(3348),
    [anon_sym_restrict] = ACTIONS(3348),
    [anon_sym_volatile] = ACTIONS(3348),
    [anon_sym__Atomic] = ACTIONS(3348),
    [anon_sym_mutable] = ACTIONS(3348),
    [anon_sym_explicit] = ACTIONS(3348),
    [anon_sym_constexpr] = ACTIONS(3348),
    [anon_sym_unsigned] = ACTIONS(3348),
    [anon_sym_long] = ACTIONS(3348),
    [anon_sym_short] = ACTIONS(3348),
    [sym_primitive_type] = ACTIONS(3348),
    [anon_sym_enum] = ACTIONS(3348),
    [anon_sym_struct] = ACTIONS(3348),
    [anon_sym_union] = ACTIONS(3348),
    [anon_sym_if] = ACTIONS(3348),
    [anon_sym_else] = ACTIONS(3348),
    [anon_sym_switch] = ACTIONS(3348),
    [anon_sym_case] = ACTIONS(3348),
    [anon_sym_default] = ACTIONS(3348),
    [anon_sym_while] = ACTIONS(3348),
    [anon_sym_do] = ACTIONS(3348),
    [anon_sym_for] = ACTIONS(3348),
    [anon_sym_return] = ACTIONS(3348),
    [anon_sym_break] = ACTIONS(3348),
    [anon_sym_continue] = ACTIONS(3348),
    [anon_sym_goto] = ACTIONS(3348),
    [anon_sym_AMP] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_PLUS] = ACTIONS(3348),
    [anon_sym_DASH] = ACTIONS(3348),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_sizeof] = ACTIONS(3348),
    [sym_number_literal] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [sym_true] = ACTIONS(3348),
    [sym_false] = ACTIONS(3348),
    [sym_null] = ACTIONS(3348),
    [sym_identifier] = ACTIONS(3348),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3348),
    [sym_auto] = ACTIONS(3348),
    [anon_sym_typename] = ACTIONS(3348),
    [anon_sym_delete] = ACTIONS(3348),
    [anon_sym_try] = ACTIONS(3348),
    [anon_sym_catch] = ACTIONS(4116),
    [anon_sym_new] = ACTIONS(3348),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [sym_nullptr] = ACTIONS(3348),
  },
  [3328] = {
    [sym_raw_string_literal] = ACTIONS(7561),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7563),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7563),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7563),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7563),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7563),
    [sym_preproc_directive] = ACTIONS(7563),
    [anon_sym_SEMI] = ACTIONS(7561),
    [anon_sym_typedef] = ACTIONS(7563),
    [anon_sym_extern] = ACTIONS(7563),
    [anon_sym_LBRACE] = ACTIONS(7561),
    [anon_sym_RBRACE] = ACTIONS(7561),
    [anon_sym_LPAREN2] = ACTIONS(7561),
    [anon_sym_STAR] = ACTIONS(7561),
    [anon_sym_LBRACK] = ACTIONS(7561),
    [anon_sym_static] = ACTIONS(7563),
    [anon_sym_register] = ACTIONS(7563),
    [anon_sym_inline] = ACTIONS(7563),
    [anon_sym_const] = ACTIONS(7563),
    [anon_sym_restrict] = ACTIONS(7563),
    [anon_sym_volatile] = ACTIONS(7563),
    [anon_sym__Atomic] = ACTIONS(7563),
    [anon_sym_mutable] = ACTIONS(7563),
    [anon_sym_explicit] = ACTIONS(7563),
    [anon_sym_constexpr] = ACTIONS(7563),
    [anon_sym_unsigned] = ACTIONS(7563),
    [anon_sym_long] = ACTIONS(7563),
    [anon_sym_short] = ACTIONS(7563),
    [sym_primitive_type] = ACTIONS(7563),
    [anon_sym_enum] = ACTIONS(7563),
    [anon_sym_struct] = ACTIONS(7563),
    [anon_sym_union] = ACTIONS(7563),
    [anon_sym_if] = ACTIONS(7563),
    [anon_sym_else] = ACTIONS(7563),
    [anon_sym_switch] = ACTIONS(7563),
    [anon_sym_case] = ACTIONS(7563),
    [anon_sym_default] = ACTIONS(7563),
    [anon_sym_while] = ACTIONS(7563),
    [anon_sym_do] = ACTIONS(7563),
    [anon_sym_for] = ACTIONS(7563),
    [anon_sym_return] = ACTIONS(7563),
    [anon_sym_break] = ACTIONS(7563),
    [anon_sym_continue] = ACTIONS(7563),
    [anon_sym_goto] = ACTIONS(7563),
    [anon_sym_AMP] = ACTIONS(7561),
    [anon_sym_BANG] = ACTIONS(7561),
    [anon_sym_TILDE] = ACTIONS(7561),
    [anon_sym_PLUS] = ACTIONS(7563),
    [anon_sym_DASH] = ACTIONS(7563),
    [anon_sym_DASH_DASH] = ACTIONS(7561),
    [anon_sym_PLUS_PLUS] = ACTIONS(7561),
    [anon_sym_sizeof] = ACTIONS(7563),
    [sym_number_literal] = ACTIONS(7561),
    [anon_sym_SQUOTE] = ACTIONS(7561),
    [anon_sym_DQUOTE] = ACTIONS(7561),
    [sym_true] = ACTIONS(7563),
    [sym_false] = ACTIONS(7563),
    [sym_null] = ACTIONS(7563),
    [sym_identifier] = ACTIONS(7563),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7563),
    [sym_auto] = ACTIONS(7563),
    [anon_sym_typename] = ACTIONS(7563),
    [anon_sym_delete] = ACTIONS(7563),
    [anon_sym_try] = ACTIONS(7563),
    [anon_sym_new] = ACTIONS(7563),
    [anon_sym_COLON_COLON] = ACTIONS(7561),
    [sym_nullptr] = ACTIONS(7563),
  },
  [3329] = {
    [sym_compound_statement] = STATE(3515),
    [sym_labeled_statement] = STATE(3515),
    [sym_expression_statement] = STATE(3515),
    [sym_if_statement] = STATE(3515),
    [sym_switch_statement] = STATE(3515),
    [sym_case_statement] = STATE(3515),
    [sym_while_statement] = STATE(3515),
    [sym_do_statement] = STATE(3515),
    [sym_for_statement] = STATE(3515),
    [sym_return_statement] = STATE(3515),
    [sym_break_statement] = STATE(3515),
    [sym_continue_statement] = STATE(3515),
    [sym_goto_statement] = STATE(3515),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(3515),
    [sym_try_statement] = STATE(3515),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(157),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(185),
    [anon_sym_case] = ACTIONS(187),
    [anon_sym_default] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(2262),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(207),
  },
  [3330] = {
    [sym_raw_string_literal] = ACTIONS(7589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7591),
    [sym_preproc_directive] = ACTIONS(7591),
    [anon_sym_SEMI] = ACTIONS(7589),
    [anon_sym_typedef] = ACTIONS(7591),
    [anon_sym_extern] = ACTIONS(7591),
    [anon_sym_LBRACE] = ACTIONS(7589),
    [anon_sym_RBRACE] = ACTIONS(7589),
    [anon_sym_LPAREN2] = ACTIONS(7589),
    [anon_sym_STAR] = ACTIONS(7589),
    [anon_sym_LBRACK] = ACTIONS(7589),
    [anon_sym_static] = ACTIONS(7591),
    [anon_sym_register] = ACTIONS(7591),
    [anon_sym_inline] = ACTIONS(7591),
    [anon_sym_const] = ACTIONS(7591),
    [anon_sym_restrict] = ACTIONS(7591),
    [anon_sym_volatile] = ACTIONS(7591),
    [anon_sym__Atomic] = ACTIONS(7591),
    [anon_sym_mutable] = ACTIONS(7591),
    [anon_sym_explicit] = ACTIONS(7591),
    [anon_sym_constexpr] = ACTIONS(7591),
    [anon_sym_unsigned] = ACTIONS(7591),
    [anon_sym_long] = ACTIONS(7591),
    [anon_sym_short] = ACTIONS(7591),
    [sym_primitive_type] = ACTIONS(7591),
    [anon_sym_enum] = ACTIONS(7591),
    [anon_sym_struct] = ACTIONS(7591),
    [anon_sym_union] = ACTIONS(7591),
    [anon_sym_if] = ACTIONS(7591),
    [anon_sym_else] = ACTIONS(7591),
    [anon_sym_switch] = ACTIONS(7591),
    [anon_sym_case] = ACTIONS(7591),
    [anon_sym_default] = ACTIONS(7591),
    [anon_sym_while] = ACTIONS(7591),
    [anon_sym_do] = ACTIONS(7591),
    [anon_sym_for] = ACTIONS(7591),
    [anon_sym_return] = ACTIONS(7591),
    [anon_sym_break] = ACTIONS(7591),
    [anon_sym_continue] = ACTIONS(7591),
    [anon_sym_goto] = ACTIONS(7591),
    [anon_sym_AMP] = ACTIONS(7589),
    [anon_sym_BANG] = ACTIONS(7589),
    [anon_sym_TILDE] = ACTIONS(7589),
    [anon_sym_PLUS] = ACTIONS(7591),
    [anon_sym_DASH] = ACTIONS(7591),
    [anon_sym_DASH_DASH] = ACTIONS(7589),
    [anon_sym_PLUS_PLUS] = ACTIONS(7589),
    [anon_sym_sizeof] = ACTIONS(7591),
    [sym_number_literal] = ACTIONS(7589),
    [anon_sym_SQUOTE] = ACTIONS(7589),
    [anon_sym_DQUOTE] = ACTIONS(7589),
    [sym_true] = ACTIONS(7591),
    [sym_false] = ACTIONS(7591),
    [sym_null] = ACTIONS(7591),
    [sym_identifier] = ACTIONS(7591),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7591),
    [sym_auto] = ACTIONS(7591),
    [anon_sym_typename] = ACTIONS(7591),
    [anon_sym_delete] = ACTIONS(7591),
    [anon_sym_try] = ACTIONS(7591),
    [anon_sym_new] = ACTIONS(7591),
    [anon_sym_COLON_COLON] = ACTIONS(7589),
    [sym_nullptr] = ACTIONS(7591),
  },
  [3331] = {
    [sym_compound_statement] = STATE(3516),
    [sym_labeled_statement] = STATE(3516),
    [sym_expression_statement] = STATE(3516),
    [sym_if_statement] = STATE(3516),
    [sym_switch_statement] = STATE(3516),
    [sym_case_statement] = STATE(3516),
    [sym_while_statement] = STATE(3516),
    [sym_do_statement] = STATE(3516),
    [sym_for_statement] = STATE(3516),
    [sym_return_statement] = STATE(3516),
    [sym_break_statement] = STATE(3516),
    [sym_continue_statement] = STATE(3516),
    [sym_goto_statement] = STATE(3516),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(3516),
    [sym_try_statement] = STATE(3516),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(157),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(185),
    [anon_sym_case] = ACTIONS(187),
    [anon_sym_default] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(2262),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(207),
  },
  [3332] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(7853),
    [sym_comment] = ACTIONS(91),
  },
  [3333] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3518),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(7853),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3334] = {
    [sym_raw_string_literal] = ACTIONS(7598),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7600),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7600),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7600),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7600),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7600),
    [sym_preproc_directive] = ACTIONS(7600),
    [anon_sym_SEMI] = ACTIONS(7598),
    [anon_sym_typedef] = ACTIONS(7600),
    [anon_sym_extern] = ACTIONS(7600),
    [anon_sym_LBRACE] = ACTIONS(7598),
    [anon_sym_RBRACE] = ACTIONS(7598),
    [anon_sym_LPAREN2] = ACTIONS(7598),
    [anon_sym_STAR] = ACTIONS(7598),
    [anon_sym_LBRACK] = ACTIONS(7598),
    [anon_sym_static] = ACTIONS(7600),
    [anon_sym_register] = ACTIONS(7600),
    [anon_sym_inline] = ACTIONS(7600),
    [anon_sym_const] = ACTIONS(7600),
    [anon_sym_restrict] = ACTIONS(7600),
    [anon_sym_volatile] = ACTIONS(7600),
    [anon_sym__Atomic] = ACTIONS(7600),
    [anon_sym_mutable] = ACTIONS(7600),
    [anon_sym_explicit] = ACTIONS(7600),
    [anon_sym_constexpr] = ACTIONS(7600),
    [anon_sym_unsigned] = ACTIONS(7600),
    [anon_sym_long] = ACTIONS(7600),
    [anon_sym_short] = ACTIONS(7600),
    [sym_primitive_type] = ACTIONS(7600),
    [anon_sym_enum] = ACTIONS(7600),
    [anon_sym_struct] = ACTIONS(7600),
    [anon_sym_union] = ACTIONS(7600),
    [anon_sym_if] = ACTIONS(7600),
    [anon_sym_else] = ACTIONS(7600),
    [anon_sym_switch] = ACTIONS(7600),
    [anon_sym_case] = ACTIONS(7600),
    [anon_sym_default] = ACTIONS(7600),
    [anon_sym_while] = ACTIONS(7600),
    [anon_sym_do] = ACTIONS(7600),
    [anon_sym_for] = ACTIONS(7600),
    [anon_sym_return] = ACTIONS(7600),
    [anon_sym_break] = ACTIONS(7600),
    [anon_sym_continue] = ACTIONS(7600),
    [anon_sym_goto] = ACTIONS(7600),
    [anon_sym_AMP] = ACTIONS(7598),
    [anon_sym_BANG] = ACTIONS(7598),
    [anon_sym_TILDE] = ACTIONS(7598),
    [anon_sym_PLUS] = ACTIONS(7600),
    [anon_sym_DASH] = ACTIONS(7600),
    [anon_sym_DASH_DASH] = ACTIONS(7598),
    [anon_sym_PLUS_PLUS] = ACTIONS(7598),
    [anon_sym_sizeof] = ACTIONS(7600),
    [sym_number_literal] = ACTIONS(7598),
    [anon_sym_SQUOTE] = ACTIONS(7598),
    [anon_sym_DQUOTE] = ACTIONS(7598),
    [sym_true] = ACTIONS(7600),
    [sym_false] = ACTIONS(7600),
    [sym_null] = ACTIONS(7600),
    [sym_identifier] = ACTIONS(7600),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7600),
    [sym_auto] = ACTIONS(7600),
    [anon_sym_typename] = ACTIONS(7600),
    [anon_sym_delete] = ACTIONS(7600),
    [anon_sym_try] = ACTIONS(7600),
    [anon_sym_new] = ACTIONS(7600),
    [anon_sym_COLON_COLON] = ACTIONS(7598),
    [sym_nullptr] = ACTIONS(7600),
  },
  [3335] = {
    [sym_parameter_list] = STATE(3068),
    [anon_sym_RPAREN] = ACTIONS(5889),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_const] = ACTIONS(7689),
    [anon_sym_restrict] = ACTIONS(5889),
    [anon_sym_volatile] = ACTIONS(5889),
    [anon_sym__Atomic] = ACTIONS(5889),
    [anon_sym_mutable] = ACTIONS(5889),
    [anon_sym_explicit] = ACTIONS(5889),
    [anon_sym_constexpr] = ACTIONS(5889),
    [anon_sym_DASH_GT] = ACTIONS(5889),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5889),
    [anon_sym_override] = ACTIONS(5889),
    [sym_noexcept] = ACTIONS(5889),
  },
  [3336] = {
    [sym_type_qualifier] = STATE(3336),
    [aux_sym_type_definition_repeat1] = STATE(3336),
    [anon_sym_RPAREN] = ACTIONS(2179),
    [anon_sym_LPAREN2] = ACTIONS(2179),
    [anon_sym_STAR] = ACTIONS(2179),
    [anon_sym_LBRACK] = ACTIONS(2179),
    [anon_sym_const] = ACTIONS(2538),
    [anon_sym_restrict] = ACTIONS(5316),
    [anon_sym_volatile] = ACTIONS(5316),
    [anon_sym__Atomic] = ACTIONS(5316),
    [anon_sym_mutable] = ACTIONS(5316),
    [anon_sym_explicit] = ACTIONS(5316),
    [anon_sym_constexpr] = ACTIONS(5316),
    [anon_sym_AMP] = ACTIONS(2177),
    [anon_sym_AMP_AMP] = ACTIONS(2179),
    [anon_sym_DASH_GT] = ACTIONS(2179),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2179),
    [anon_sym_override] = ACTIONS(2179),
    [sym_noexcept] = ACTIONS(2179),
  },
  [3337] = {
    [sym_type_qualifier] = STATE(3338),
    [sym_trailing_return_type] = STATE(2418),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3338),
    [anon_sym_RPAREN] = ACTIONS(5331),
    [anon_sym_LPAREN2] = ACTIONS(5331),
    [anon_sym_LBRACK] = ACTIONS(5331),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(2457),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5331),
    [anon_sym_override] = ACTIONS(5331),
    [sym_noexcept] = ACTIONS(7498),
  },
  [3338] = {
    [sym_type_qualifier] = STATE(3338),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3338),
    [anon_sym_RPAREN] = ACTIONS(5351),
    [anon_sym_LPAREN2] = ACTIONS(5351),
    [anon_sym_LBRACK] = ACTIONS(5351),
    [anon_sym_const] = ACTIONS(5353),
    [anon_sym_restrict] = ACTIONS(5356),
    [anon_sym_volatile] = ACTIONS(5356),
    [anon_sym__Atomic] = ACTIONS(5356),
    [anon_sym_mutable] = ACTIONS(5356),
    [anon_sym_explicit] = ACTIONS(5356),
    [anon_sym_constexpr] = ACTIONS(5356),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5351),
    [anon_sym_override] = ACTIONS(5351),
    [sym_noexcept] = ACTIONS(7855),
  },
  [3339] = {
    [sym_parameter_list] = STATE(3073),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_const] = ACTIONS(7689),
    [anon_sym_restrict] = ACTIONS(5889),
    [anon_sym_volatile] = ACTIONS(5889),
    [anon_sym__Atomic] = ACTIONS(5889),
    [anon_sym_mutable] = ACTIONS(5889),
    [anon_sym_explicit] = ACTIONS(5889),
    [anon_sym_constexpr] = ACTIONS(5889),
    [anon_sym_DASH_GT] = ACTIONS(5889),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5889),
    [anon_sym_override] = ACTIONS(5889),
    [sym_noexcept] = ACTIONS(5889),
  },
  [3340] = {
    [sym_type_qualifier] = STATE(3340),
    [aux_sym_type_definition_repeat1] = STATE(3340),
    [anon_sym_LPAREN2] = ACTIONS(2179),
    [anon_sym_STAR] = ACTIONS(2179),
    [anon_sym_LBRACK] = ACTIONS(2179),
    [anon_sym_const] = ACTIONS(2538),
    [anon_sym_restrict] = ACTIONS(5316),
    [anon_sym_volatile] = ACTIONS(5316),
    [anon_sym__Atomic] = ACTIONS(5316),
    [anon_sym_mutable] = ACTIONS(5316),
    [anon_sym_explicit] = ACTIONS(5316),
    [anon_sym_constexpr] = ACTIONS(5316),
    [anon_sym_AMP] = ACTIONS(2177),
    [anon_sym_AMP_AMP] = ACTIONS(2179),
    [anon_sym_DASH_GT] = ACTIONS(2179),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2179),
    [anon_sym_override] = ACTIONS(2179),
    [sym_noexcept] = ACTIONS(2179),
  },
  [3341] = {
    [sym_type_qualifier] = STATE(3342),
    [sym_trailing_return_type] = STATE(2418),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3342),
    [anon_sym_LPAREN2] = ACTIONS(5331),
    [anon_sym_LBRACK] = ACTIONS(5331),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(2532),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5331),
    [anon_sym_override] = ACTIONS(5331),
    [sym_noexcept] = ACTIONS(7500),
  },
  [3342] = {
    [sym_type_qualifier] = STATE(3342),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3342),
    [anon_sym_LPAREN2] = ACTIONS(5351),
    [anon_sym_LBRACK] = ACTIONS(5351),
    [anon_sym_const] = ACTIONS(5353),
    [anon_sym_restrict] = ACTIONS(5356),
    [anon_sym_volatile] = ACTIONS(5356),
    [anon_sym__Atomic] = ACTIONS(5356),
    [anon_sym_mutable] = ACTIONS(5356),
    [anon_sym_explicit] = ACTIONS(5356),
    [anon_sym_constexpr] = ACTIONS(5356),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5351),
    [anon_sym_override] = ACTIONS(5351),
    [sym_noexcept] = ACTIONS(7858),
  },
  [3343] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7861),
    [sym_comment] = ACTIONS(91),
  },
  [3344] = {
    [sym_parameter_list] = STATE(3089),
    [anon_sym_COMMA] = ACTIONS(6974),
    [anon_sym_SEMI] = ACTIONS(6974),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_COLON] = ACTIONS(6974),
    [sym_comment] = ACTIONS(91),
  },
  [3345] = {
    [sym__type_specifier] = STATE(3523),
    [sym_sized_type_specifier] = STATE(3523),
    [sym_enum_specifier] = STATE(3523),
    [sym_struct_specifier] = STATE(3523),
    [sym_union_specifier] = STATE(3523),
    [sym_macro_type_specifier] = STATE(3523),
    [sym_class_specifier] = STATE(3523),
    [sym_dependent_type] = STATE(3523),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(1691),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3524),
    [anon_sym_unsigned] = ACTIONS(7863),
    [anon_sym_long] = ACTIONS(7863),
    [anon_sym_short] = ACTIONS(7863),
    [sym_primitive_type] = ACTIONS(7865),
    [anon_sym_enum] = ACTIONS(139),
    [anon_sym_struct] = ACTIONS(7867),
    [anon_sym_union] = ACTIONS(7869),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7871),
    [sym_auto] = ACTIONS(7865),
    [anon_sym_typename] = ACTIONS(7873),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [3346] = {
    [sym_type_qualifier] = STATE(3525),
    [sym_virtual_specifier] = STATE(3525),
    [sym_trailing_return_type] = STATE(3525),
    [aux_sym_function_declarator_repeat1] = STATE(3525),
    [anon_sym_COMMA] = ACTIONS(7004),
    [anon_sym_SEMI] = ACTIONS(7004),
    [anon_sym_LPAREN2] = ACTIONS(7004),
    [anon_sym_LBRACK] = ACTIONS(7004),
    [anon_sym_const] = ACTIONS(1667),
    [anon_sym_restrict] = ACTIONS(1669),
    [anon_sym_volatile] = ACTIONS(1669),
    [anon_sym__Atomic] = ACTIONS(1669),
    [anon_sym_mutable] = ACTIONS(1669),
    [anon_sym_explicit] = ACTIONS(1669),
    [anon_sym_constexpr] = ACTIONS(1669),
    [anon_sym_COLON] = ACTIONS(7004),
    [anon_sym_DASH_GT] = ACTIONS(7514),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1673),
    [anon_sym_override] = ACTIONS(1673),
    [sym_noexcept] = ACTIONS(7875),
  },
  [3347] = {
    [anon_sym_COMMA] = ACTIONS(7877),
    [anon_sym_RPAREN] = ACTIONS(7877),
    [anon_sym_SEMI] = ACTIONS(7877),
    [anon_sym_LBRACE] = ACTIONS(7877),
    [anon_sym_LPAREN2] = ACTIONS(7877),
    [anon_sym_LBRACK] = ACTIONS(7877),
    [anon_sym_EQ] = ACTIONS(7877),
    [anon_sym_COLON] = ACTIONS(7877),
    [sym_comment] = ACTIONS(91),
  },
  [3348] = {
    [sym__abstract_declarator] = STATE(3526),
    [sym_abstract_pointer_declarator] = STATE(3526),
    [sym_abstract_function_declarator] = STATE(3526),
    [sym_abstract_array_declarator] = STATE(3526),
    [sym_type_qualifier] = STATE(3527),
    [sym_parameter_list] = STATE(3351),
    [sym_abstract_reference_declarator] = STATE(3526),
    [aux_sym_type_definition_repeat1] = STATE(3527),
    [anon_sym_COMMA] = ACTIONS(2461),
    [anon_sym_SEMI] = ACTIONS(2461),
    [anon_sym_LBRACE] = ACTIONS(2461),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(7526),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_EQ] = ACTIONS(2461),
    [anon_sym_const] = ACTIONS(1667),
    [anon_sym_restrict] = ACTIONS(1669),
    [anon_sym_volatile] = ACTIONS(1669),
    [anon_sym__Atomic] = ACTIONS(1669),
    [anon_sym_mutable] = ACTIONS(1669),
    [anon_sym_explicit] = ACTIONS(1669),
    [anon_sym_constexpr] = ACTIONS(1669),
    [anon_sym_COLON] = ACTIONS(2461),
    [anon_sym_AMP] = ACTIONS(7528),
    [anon_sym_AMP_AMP] = ACTIONS(7530),
    [anon_sym_DASH_GT] = ACTIONS(2461),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2461),
    [anon_sym_override] = ACTIONS(2461),
    [sym_noexcept] = ACTIONS(2461),
  },
  [3349] = {
    [sym__abstract_declarator] = STATE(3528),
    [sym_abstract_pointer_declarator] = STATE(3528),
    [sym_abstract_function_declarator] = STATE(3528),
    [sym_abstract_array_declarator] = STATE(3528),
    [sym_parameter_list] = STATE(3351),
    [sym_abstract_reference_declarator] = STATE(3528),
    [anon_sym_COMMA] = ACTIONS(2463),
    [anon_sym_SEMI] = ACTIONS(2463),
    [anon_sym_LBRACE] = ACTIONS(2463),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(7526),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_EQ] = ACTIONS(2463),
    [anon_sym_const] = ACTIONS(6555),
    [anon_sym_restrict] = ACTIONS(2463),
    [anon_sym_volatile] = ACTIONS(2463),
    [anon_sym__Atomic] = ACTIONS(2463),
    [anon_sym_mutable] = ACTIONS(2463),
    [anon_sym_explicit] = ACTIONS(2463),
    [anon_sym_constexpr] = ACTIONS(2463),
    [anon_sym_COLON] = ACTIONS(2463),
    [anon_sym_AMP] = ACTIONS(7528),
    [anon_sym_AMP_AMP] = ACTIONS(7530),
    [anon_sym_DASH_GT] = ACTIONS(2463),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2463),
    [anon_sym_override] = ACTIONS(2463),
    [sym_noexcept] = ACTIONS(2463),
  },
  [3350] = {
    [sym_parameter_list] = STATE(3529),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(6557),
    [anon_sym_const] = ACTIONS(6559),
    [anon_sym_restrict] = ACTIONS(6557),
    [anon_sym_volatile] = ACTIONS(6557),
    [anon_sym__Atomic] = ACTIONS(6557),
    [anon_sym_mutable] = ACTIONS(6557),
    [anon_sym_explicit] = ACTIONS(6557),
    [anon_sym_constexpr] = ACTIONS(6557),
    [anon_sym_COLON] = ACTIONS(6557),
    [anon_sym_DASH_GT] = ACTIONS(6557),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(6557),
    [anon_sym_override] = ACTIONS(6557),
    [sym_noexcept] = ACTIONS(6557),
  },
  [3351] = {
    [sym_type_qualifier] = STATE(3530),
    [sym_trailing_return_type] = STATE(971),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3530),
    [anon_sym_COMMA] = ACTIONS(1787),
    [anon_sym_SEMI] = ACTIONS(1787),
    [anon_sym_LBRACE] = ACTIONS(1787),
    [anon_sym_LPAREN2] = ACTIONS(1787),
    [anon_sym_LBRACK] = ACTIONS(1787),
    [anon_sym_EQ] = ACTIONS(1787),
    [anon_sym_const] = ACTIONS(6561),
    [anon_sym_restrict] = ACTIONS(1787),
    [anon_sym_volatile] = ACTIONS(1787),
    [anon_sym__Atomic] = ACTIONS(1787),
    [anon_sym_mutable] = ACTIONS(1787),
    [anon_sym_explicit] = ACTIONS(1787),
    [anon_sym_constexpr] = ACTIONS(1787),
    [anon_sym_COLON] = ACTIONS(1787),
    [anon_sym_DASH_GT] = ACTIONS(1787),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1787),
    [anon_sym_override] = ACTIONS(1787),
    [sym_noexcept] = ACTIONS(1787),
  },
  [3352] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3352),
    [anon_sym_COMMA] = ACTIONS(1985),
    [anon_sym_SEMI] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(1985),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1985),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_EQ] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1987),
    [anon_sym_restrict] = ACTIONS(1987),
    [anon_sym_volatile] = ACTIONS(1987),
    [anon_sym__Atomic] = ACTIONS(1987),
    [anon_sym_mutable] = ACTIONS(1987),
    [anon_sym_explicit] = ACTIONS(1987),
    [anon_sym_constexpr] = ACTIONS(1987),
    [anon_sym_unsigned] = ACTIONS(7879),
    [anon_sym_long] = ACTIONS(7879),
    [anon_sym_short] = ACTIONS(7879),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_COLON] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_DASH_GT] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1987),
    [anon_sym_override] = ACTIONS(1987),
    [sym_noexcept] = ACTIONS(1987),
  },
  [3353] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7882),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7884),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7884),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7884),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7884),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7884),
    [anon_sym_typedef] = ACTIONS(7882),
    [anon_sym_extern] = ACTIONS(7882),
    [anon_sym_RBRACE] = ACTIONS(7884),
    [anon_sym_LPAREN2] = ACTIONS(7884),
    [anon_sym_STAR] = ACTIONS(7884),
    [anon_sym_static] = ACTIONS(7882),
    [anon_sym_register] = ACTIONS(7882),
    [anon_sym_inline] = ACTIONS(7882),
    [anon_sym_const] = ACTIONS(7882),
    [anon_sym_restrict] = ACTIONS(7882),
    [anon_sym_volatile] = ACTIONS(7882),
    [anon_sym__Atomic] = ACTIONS(7882),
    [anon_sym_mutable] = ACTIONS(7882),
    [anon_sym_explicit] = ACTIONS(7882),
    [anon_sym_constexpr] = ACTIONS(7882),
    [anon_sym_unsigned] = ACTIONS(7882),
    [anon_sym_long] = ACTIONS(7882),
    [anon_sym_short] = ACTIONS(7882),
    [sym_primitive_type] = ACTIONS(7882),
    [anon_sym_enum] = ACTIONS(7882),
    [anon_sym_struct] = ACTIONS(7882),
    [anon_sym_union] = ACTIONS(7882),
    [anon_sym_AMP] = ACTIONS(7882),
    [anon_sym_AMP_AMP] = ACTIONS(7884),
    [anon_sym_TILDE] = ACTIONS(7884),
    [sym_identifier] = ACTIONS(7882),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7882),
    [anon_sym_public] = ACTIONS(7882),
    [sym_auto] = ACTIONS(7882),
    [anon_sym_typename] = ACTIONS(7882),
    [anon_sym_template] = ACTIONS(7882),
    [anon_sym_friend] = ACTIONS(7882),
    [anon_sym_private] = ACTIONS(7882),
    [anon_sym_protected] = ACTIONS(7882),
    [anon_sym_using] = ACTIONS(7882),
    [anon_sym_COLON_COLON] = ACTIONS(7884),
    [sym_operator_name] = ACTIONS(7884),
  },
  [3354] = {
    [sym_parameter_list] = STATE(3357),
    [anon_sym_SEMI] = ACTIONS(4157),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(4157),
    [anon_sym_const] = ACTIONS(7279),
    [anon_sym_restrict] = ACTIONS(4157),
    [anon_sym_volatile] = ACTIONS(4157),
    [anon_sym__Atomic] = ACTIONS(4157),
    [anon_sym_mutable] = ACTIONS(4157),
    [anon_sym_explicit] = ACTIONS(4157),
    [anon_sym_constexpr] = ACTIONS(4157),
    [anon_sym_COLON] = ACTIONS(4157),
    [anon_sym_DASH_GT] = ACTIONS(4157),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4157),
    [anon_sym_override] = ACTIONS(4157),
    [sym_noexcept] = ACTIONS(4157),
  },
  [3355] = {
    [sym__abstract_declarator] = STATE(3531),
    [sym_abstract_pointer_declarator] = STATE(3531),
    [sym_abstract_function_declarator] = STATE(3531),
    [sym_abstract_array_declarator] = STATE(3531),
    [sym_type_qualifier] = STATE(3532),
    [sym_parameter_list] = STATE(3102),
    [sym_abstract_reference_declarator] = STATE(3531),
    [aux_sym_type_definition_repeat1] = STATE(3532),
    [anon_sym_SEMI] = ACTIONS(4157),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(7015),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_EQ] = ACTIONS(4157),
    [anon_sym_const] = ACTIONS(1667),
    [anon_sym_restrict] = ACTIONS(1669),
    [anon_sym_volatile] = ACTIONS(1669),
    [anon_sym__Atomic] = ACTIONS(1669),
    [anon_sym_mutable] = ACTIONS(1669),
    [anon_sym_explicit] = ACTIONS(1669),
    [anon_sym_constexpr] = ACTIONS(1669),
    [anon_sym_COLON] = ACTIONS(4157),
    [anon_sym_AMP] = ACTIONS(7017),
    [anon_sym_AMP_AMP] = ACTIONS(7019),
    [anon_sym_DASH_GT] = ACTIONS(4157),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4157),
    [anon_sym_override] = ACTIONS(4157),
    [sym_noexcept] = ACTIONS(4157),
  },
  [3356] = {
    [sym_parameter_list] = STATE(3357),
    [anon_sym_SEMI] = ACTIONS(4159),
    [anon_sym_LBRACE] = ACTIONS(4159),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_const] = ACTIONS(7281),
    [anon_sym_restrict] = ACTIONS(4159),
    [anon_sym_volatile] = ACTIONS(4159),
    [anon_sym__Atomic] = ACTIONS(4159),
    [anon_sym_mutable] = ACTIONS(4159),
    [anon_sym_explicit] = ACTIONS(4159),
    [anon_sym_constexpr] = ACTIONS(4159),
    [anon_sym_COLON] = ACTIONS(4159),
    [anon_sym_DASH_GT] = ACTIONS(4159),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4159),
    [anon_sym_override] = ACTIONS(4159),
    [sym_noexcept] = ACTIONS(4159),
  },
  [3357] = {
    [sym_type_qualifier] = STATE(3533),
    [sym_trailing_return_type] = STATE(1720),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3533),
    [anon_sym_SEMI] = ACTIONS(3663),
    [anon_sym_LBRACE] = ACTIONS(3663),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_EQ] = ACTIONS(3663),
    [anon_sym_const] = ACTIONS(3685),
    [anon_sym_restrict] = ACTIONS(3663),
    [anon_sym_volatile] = ACTIONS(3663),
    [anon_sym__Atomic] = ACTIONS(3663),
    [anon_sym_mutable] = ACTIONS(3663),
    [anon_sym_explicit] = ACTIONS(3663),
    [anon_sym_constexpr] = ACTIONS(3663),
    [anon_sym_COLON] = ACTIONS(3663),
    [anon_sym_DASH_GT] = ACTIONS(3663),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3663),
    [anon_sym_override] = ACTIONS(3663),
    [sym_noexcept] = ACTIONS(3663),
  },
  [3358] = {
    [sym_type_qualifier] = STATE(3534),
    [sym_trailing_return_type] = STATE(1720),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3534),
    [anon_sym_SEMI] = ACTIONS(3663),
    [anon_sym_LBRACE] = ACTIONS(3663),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_EQ] = ACTIONS(3663),
    [anon_sym_const] = ACTIONS(1667),
    [anon_sym_restrict] = ACTIONS(1669),
    [anon_sym_volatile] = ACTIONS(1669),
    [anon_sym__Atomic] = ACTIONS(1669),
    [anon_sym_mutable] = ACTIONS(1669),
    [anon_sym_explicit] = ACTIONS(1669),
    [anon_sym_constexpr] = ACTIONS(1669),
    [anon_sym_COLON] = ACTIONS(3663),
    [anon_sym_DASH_GT] = ACTIONS(4291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3663),
    [anon_sym_override] = ACTIONS(3663),
    [sym_noexcept] = ACTIONS(7886),
  },
  [3359] = {
    [sym_compound_statement] = STATE(3535),
    [sym_labeled_statement] = STATE(3535),
    [sym_expression_statement] = STATE(3535),
    [sym_if_statement] = STATE(3535),
    [sym_switch_statement] = STATE(3535),
    [sym_case_statement] = STATE(3535),
    [sym_while_statement] = STATE(3535),
    [sym_do_statement] = STATE(3535),
    [sym_for_statement] = STATE(3535),
    [sym_return_statement] = STATE(3535),
    [sym_break_statement] = STATE(3535),
    [sym_continue_statement] = STATE(3535),
    [sym_goto_statement] = STATE(3535),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(3535),
    [sym_try_statement] = STATE(3535),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(4430),
    [anon_sym_switch] = ACTIONS(4432),
    [anon_sym_case] = ACTIONS(4434),
    [anon_sym_default] = ACTIONS(4436),
    [anon_sym_while] = ACTIONS(4438),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(4440),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(4442),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(4444),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [3360] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(7888),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3361] = {
    [sym__expression] = STATE(3538),
    [sym_conditional_expression] = STATE(3538),
    [sym_assignment_expression] = STATE(3538),
    [sym_pointer_expression] = STATE(3538),
    [sym_logical_expression] = STATE(3538),
    [sym_bitwise_expression] = STATE(3538),
    [sym_equality_expression] = STATE(3538),
    [sym_relational_expression] = STATE(3538),
    [sym_shift_expression] = STATE(3538),
    [sym_math_expression] = STATE(3538),
    [sym_cast_expression] = STATE(3538),
    [sym_sizeof_expression] = STATE(3538),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(3538),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(3538),
    [sym_concatenated_string] = STATE(3538),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3538),
    [sym_new_expression] = STATE(3538),
    [sym_delete_expression] = STATE(3538),
    [sym_lambda_expression] = STATE(3538),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7890),
    [anon_sym_RPAREN] = ACTIONS(7892),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(7890),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7894),
    [sym_false] = ACTIONS(7894),
    [sym_null] = ACTIONS(7894),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(7894),
  },
  [3362] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(7896),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3363] = {
    [sym__expression] = STATE(3540),
    [sym_conditional_expression] = STATE(3540),
    [sym_assignment_expression] = STATE(3540),
    [sym_pointer_expression] = STATE(3540),
    [sym_logical_expression] = STATE(3540),
    [sym_bitwise_expression] = STATE(3540),
    [sym_equality_expression] = STATE(3540),
    [sym_relational_expression] = STATE(3540),
    [sym_shift_expression] = STATE(3540),
    [sym_math_expression] = STATE(3540),
    [sym_cast_expression] = STATE(3540),
    [sym_sizeof_expression] = STATE(3540),
    [sym_subscript_expression] = STATE(3540),
    [sym_call_expression] = STATE(3540),
    [sym_field_expression] = STATE(3540),
    [sym_compound_literal_expression] = STATE(3540),
    [sym_parenthesized_expression] = STATE(3540),
    [sym_char_literal] = STATE(3540),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3540),
    [sym_new_expression] = STATE(3540),
    [sym_delete_expression] = STATE(3540),
    [sym_lambda_expression] = STATE(3540),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7898),
    [anon_sym_SEMI] = ACTIONS(7896),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(7898),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7900),
    [sym_false] = ACTIONS(7900),
    [sym_null] = ACTIONS(7900),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(7900),
  },
  [3364] = {
    [sym__expression] = STATE(3541),
    [sym_conditional_expression] = STATE(3541),
    [sym_assignment_expression] = STATE(3541),
    [sym_pointer_expression] = STATE(3541),
    [sym_logical_expression] = STATE(3541),
    [sym_bitwise_expression] = STATE(3541),
    [sym_equality_expression] = STATE(3541),
    [sym_relational_expression] = STATE(3541),
    [sym_shift_expression] = STATE(3541),
    [sym_math_expression] = STATE(3541),
    [sym_cast_expression] = STATE(3541),
    [sym_sizeof_expression] = STATE(3541),
    [sym_subscript_expression] = STATE(3541),
    [sym_call_expression] = STATE(3541),
    [sym_field_expression] = STATE(3541),
    [sym_compound_literal_expression] = STATE(3541),
    [sym_parenthesized_expression] = STATE(3541),
    [sym_char_literal] = STATE(3541),
    [sym_concatenated_string] = STATE(3541),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3541),
    [sym_new_expression] = STATE(3541),
    [sym_delete_expression] = STATE(3541),
    [sym_lambda_expression] = STATE(3541),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7902),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(7902),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7904),
    [sym_false] = ACTIONS(7904),
    [sym_null] = ACTIONS(7904),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(7904),
  },
  [3365] = {
    [sym_catch_clause] = STATE(3365),
    [aux_sym_try_statement_repeat1] = STATE(3365),
    [sym_raw_string_literal] = ACTIONS(4993),
    [ts_builtin_sym_end] = ACTIONS(4993),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4995),
    [sym_preproc_directive] = ACTIONS(4995),
    [anon_sym_SEMI] = ACTIONS(4993),
    [anon_sym_typedef] = ACTIONS(4995),
    [anon_sym_extern] = ACTIONS(4995),
    [anon_sym_LBRACE] = ACTIONS(4993),
    [anon_sym_LPAREN2] = ACTIONS(4993),
    [anon_sym_STAR] = ACTIONS(4993),
    [anon_sym_LBRACK] = ACTIONS(4993),
    [anon_sym_static] = ACTIONS(4995),
    [anon_sym_register] = ACTIONS(4995),
    [anon_sym_inline] = ACTIONS(4995),
    [anon_sym_const] = ACTIONS(4995),
    [anon_sym_restrict] = ACTIONS(4995),
    [anon_sym_volatile] = ACTIONS(4995),
    [anon_sym__Atomic] = ACTIONS(4995),
    [anon_sym_mutable] = ACTIONS(4995),
    [anon_sym_explicit] = ACTIONS(4995),
    [anon_sym_constexpr] = ACTIONS(4995),
    [anon_sym_unsigned] = ACTIONS(4995),
    [anon_sym_long] = ACTIONS(4995),
    [anon_sym_short] = ACTIONS(4995),
    [sym_primitive_type] = ACTIONS(4995),
    [anon_sym_enum] = ACTIONS(4995),
    [anon_sym_struct] = ACTIONS(4995),
    [anon_sym_union] = ACTIONS(4995),
    [anon_sym_if] = ACTIONS(4995),
    [anon_sym_else] = ACTIONS(4995),
    [anon_sym_switch] = ACTIONS(4995),
    [anon_sym_case] = ACTIONS(4995),
    [anon_sym_default] = ACTIONS(4995),
    [anon_sym_while] = ACTIONS(4995),
    [anon_sym_do] = ACTIONS(4995),
    [anon_sym_for] = ACTIONS(4995),
    [anon_sym_return] = ACTIONS(4995),
    [anon_sym_break] = ACTIONS(4995),
    [anon_sym_continue] = ACTIONS(4995),
    [anon_sym_goto] = ACTIONS(4995),
    [anon_sym_AMP] = ACTIONS(4995),
    [anon_sym_AMP_AMP] = ACTIONS(4993),
    [anon_sym_BANG] = ACTIONS(4993),
    [anon_sym_TILDE] = ACTIONS(4993),
    [anon_sym_PLUS] = ACTIONS(4995),
    [anon_sym_DASH] = ACTIONS(4995),
    [anon_sym_DASH_DASH] = ACTIONS(4993),
    [anon_sym_PLUS_PLUS] = ACTIONS(4993),
    [anon_sym_sizeof] = ACTIONS(4995),
    [sym_number_literal] = ACTIONS(4993),
    [anon_sym_SQUOTE] = ACTIONS(4993),
    [anon_sym_DQUOTE] = ACTIONS(4993),
    [sym_true] = ACTIONS(4995),
    [sym_false] = ACTIONS(4995),
    [sym_null] = ACTIONS(4995),
    [sym_identifier] = ACTIONS(4995),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4995),
    [sym_auto] = ACTIONS(4995),
    [anon_sym_typename] = ACTIONS(4995),
    [anon_sym_template] = ACTIONS(4995),
    [anon_sym_delete] = ACTIONS(4995),
    [anon_sym_namespace] = ACTIONS(4995),
    [anon_sym_using] = ACTIONS(4995),
    [anon_sym_try] = ACTIONS(4995),
    [anon_sym_catch] = ACTIONS(4997),
    [anon_sym_new] = ACTIONS(4995),
    [anon_sym_COLON_COLON] = ACTIONS(4993),
    [sym_operator_name] = ACTIONS(4993),
    [sym_nullptr] = ACTIONS(4995),
  },
  [3366] = {
    [sym_raw_string_literal] = ACTIONS(7906),
    [ts_builtin_sym_end] = ACTIONS(7906),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7908),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7908),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7908),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7908),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7908),
    [sym_preproc_directive] = ACTIONS(7908),
    [anon_sym_SEMI] = ACTIONS(7906),
    [anon_sym_typedef] = ACTIONS(7908),
    [anon_sym_extern] = ACTIONS(7908),
    [anon_sym_LBRACE] = ACTIONS(7906),
    [anon_sym_RBRACE] = ACTIONS(7906),
    [anon_sym_LPAREN2] = ACTIONS(7906),
    [anon_sym_STAR] = ACTIONS(7906),
    [anon_sym_LBRACK] = ACTIONS(7906),
    [anon_sym_static] = ACTIONS(7908),
    [anon_sym_register] = ACTIONS(7908),
    [anon_sym_inline] = ACTIONS(7908),
    [anon_sym_const] = ACTIONS(7908),
    [anon_sym_restrict] = ACTIONS(7908),
    [anon_sym_volatile] = ACTIONS(7908),
    [anon_sym__Atomic] = ACTIONS(7908),
    [anon_sym_mutable] = ACTIONS(7908),
    [anon_sym_explicit] = ACTIONS(7908),
    [anon_sym_constexpr] = ACTIONS(7908),
    [anon_sym_unsigned] = ACTIONS(7908),
    [anon_sym_long] = ACTIONS(7908),
    [anon_sym_short] = ACTIONS(7908),
    [sym_primitive_type] = ACTIONS(7908),
    [anon_sym_enum] = ACTIONS(7908),
    [anon_sym_struct] = ACTIONS(7908),
    [anon_sym_union] = ACTIONS(7908),
    [anon_sym_if] = ACTIONS(7908),
    [anon_sym_else] = ACTIONS(7908),
    [anon_sym_switch] = ACTIONS(7908),
    [anon_sym_case] = ACTIONS(7908),
    [anon_sym_default] = ACTIONS(7908),
    [anon_sym_while] = ACTIONS(7908),
    [anon_sym_do] = ACTIONS(7908),
    [anon_sym_for] = ACTIONS(7908),
    [anon_sym_return] = ACTIONS(7908),
    [anon_sym_break] = ACTIONS(7908),
    [anon_sym_continue] = ACTIONS(7908),
    [anon_sym_goto] = ACTIONS(7908),
    [anon_sym_AMP] = ACTIONS(7908),
    [anon_sym_AMP_AMP] = ACTIONS(7906),
    [anon_sym_BANG] = ACTIONS(7906),
    [anon_sym_TILDE] = ACTIONS(7906),
    [anon_sym_PLUS] = ACTIONS(7908),
    [anon_sym_DASH] = ACTIONS(7908),
    [anon_sym_DASH_DASH] = ACTIONS(7906),
    [anon_sym_PLUS_PLUS] = ACTIONS(7906),
    [anon_sym_sizeof] = ACTIONS(7908),
    [sym_number_literal] = ACTIONS(7906),
    [anon_sym_SQUOTE] = ACTIONS(7906),
    [anon_sym_DQUOTE] = ACTIONS(7906),
    [sym_true] = ACTIONS(7908),
    [sym_false] = ACTIONS(7908),
    [sym_null] = ACTIONS(7908),
    [sym_identifier] = ACTIONS(7908),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7908),
    [sym_auto] = ACTIONS(7908),
    [anon_sym_typename] = ACTIONS(7908),
    [anon_sym_template] = ACTIONS(7908),
    [anon_sym_delete] = ACTIONS(7908),
    [anon_sym_namespace] = ACTIONS(7908),
    [anon_sym_using] = ACTIONS(7908),
    [anon_sym_try] = ACTIONS(7908),
    [anon_sym_new] = ACTIONS(7908),
    [anon_sym_COLON_COLON] = ACTIONS(7906),
    [sym_operator_name] = ACTIONS(7906),
    [sym_nullptr] = ACTIONS(7908),
  },
  [3367] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(7910),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3368] = {
    [sym__expression] = STATE(3543),
    [sym_conditional_expression] = STATE(3543),
    [sym_assignment_expression] = STATE(3543),
    [sym_pointer_expression] = STATE(3543),
    [sym_logical_expression] = STATE(3543),
    [sym_bitwise_expression] = STATE(3543),
    [sym_equality_expression] = STATE(3543),
    [sym_relational_expression] = STATE(3543),
    [sym_shift_expression] = STATE(3543),
    [sym_math_expression] = STATE(3543),
    [sym_cast_expression] = STATE(3543),
    [sym_sizeof_expression] = STATE(3543),
    [sym_subscript_expression] = STATE(3543),
    [sym_call_expression] = STATE(3543),
    [sym_field_expression] = STATE(3543),
    [sym_compound_literal_expression] = STATE(3543),
    [sym_parenthesized_expression] = STATE(3543),
    [sym_char_literal] = STATE(3543),
    [sym_concatenated_string] = STATE(3543),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3543),
    [sym_new_expression] = STATE(3543),
    [sym_delete_expression] = STATE(3543),
    [sym_lambda_expression] = STATE(3543),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7912),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(7912),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7914),
    [sym_false] = ACTIONS(7914),
    [sym_null] = ACTIONS(7914),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(7914),
  },
  [3369] = {
    [sym_declaration] = STATE(2095),
    [sym_type_definition] = STATE(2095),
    [sym__declaration_specifiers] = STATE(1373),
    [sym_compound_statement] = STATE(2095),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_labeled_statement] = STATE(2095),
    [sym_expression_statement] = STATE(2095),
    [sym_if_statement] = STATE(2095),
    [sym_switch_statement] = STATE(2095),
    [sym_case_statement] = STATE(2095),
    [sym_while_statement] = STATE(2095),
    [sym_do_statement] = STATE(2095),
    [sym_for_statement] = STATE(2095),
    [sym_return_statement] = STATE(2095),
    [sym_break_statement] = STATE(2095),
    [sym_continue_statement] = STATE(2095),
    [sym_goto_statement] = STATE(2095),
    [sym__expression] = STATE(222),
    [sym_comma_expression] = STATE(223),
    [sym_conditional_expression] = STATE(222),
    [sym_assignment_expression] = STATE(222),
    [sym_pointer_expression] = STATE(222),
    [sym_logical_expression] = STATE(222),
    [sym_bitwise_expression] = STATE(222),
    [sym_equality_expression] = STATE(222),
    [sym_relational_expression] = STATE(222),
    [sym_shift_expression] = STATE(222),
    [sym_math_expression] = STATE(222),
    [sym_cast_expression] = STATE(222),
    [sym_sizeof_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_call_expression] = STATE(222),
    [sym_field_expression] = STATE(222),
    [sym_compound_literal_expression] = STATE(222),
    [sym_parenthesized_expression] = STATE(222),
    [sym_char_literal] = STATE(222),
    [sym_concatenated_string] = STATE(222),
    [sym_string_literal] = STATE(55),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(222),
    [sym_for_range_loop] = STATE(2095),
    [sym_try_statement] = STATE(2095),
    [sym_new_expression] = STATE(222),
    [sym_delete_expression] = STATE(222),
    [sym_lambda_expression] = STATE(222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_typedef] = ACTIONS(1023),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(6119),
    [anon_sym_switch] = ACTIONS(6121),
    [anon_sym_case] = ACTIONS(6123),
    [anon_sym_default] = ACTIONS(6125),
    [anon_sym_while] = ACTIONS(6127),
    [anon_sym_do] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(6129),
    [anon_sym_return] = ACTIONS(373),
    [anon_sym_break] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_goto] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(353),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_identifier] = ACTIONS(7573),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(6133),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(1202),
    [sym_nullptr] = ACTIONS(381),
  },
  [3370] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(1362),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_extern] = ACTIONS(468),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(465),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_register] = ACTIONS(468),
    [anon_sym_inline] = ACTIONS(468),
    [anon_sym_const] = ACTIONS(468),
    [anon_sym_restrict] = ACTIONS(468),
    [anon_sym_volatile] = ACTIONS(468),
    [anon_sym__Atomic] = ACTIONS(468),
    [anon_sym_mutable] = ACTIONS(468),
    [anon_sym_explicit] = ACTIONS(468),
    [anon_sym_constexpr] = ACTIONS(468),
    [anon_sym_COLON] = ACTIONS(7081),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(474),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_TILDE] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_identifier] = ACTIONS(468),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(2855),
    [sym_operator_name] = ACTIONS(481),
  },
  [3371] = {
    [sym__expression] = STATE(3545),
    [sym_conditional_expression] = STATE(3545),
    [sym_assignment_expression] = STATE(3545),
    [sym_pointer_expression] = STATE(3545),
    [sym_logical_expression] = STATE(3545),
    [sym_bitwise_expression] = STATE(3545),
    [sym_equality_expression] = STATE(3545),
    [sym_relational_expression] = STATE(3545),
    [sym_shift_expression] = STATE(3545),
    [sym_math_expression] = STATE(3545),
    [sym_cast_expression] = STATE(3545),
    [sym_sizeof_expression] = STATE(3545),
    [sym_subscript_expression] = STATE(3545),
    [sym_call_expression] = STATE(3545),
    [sym_field_expression] = STATE(3545),
    [sym_compound_literal_expression] = STATE(3545),
    [sym_parenthesized_expression] = STATE(3545),
    [sym_char_literal] = STATE(3545),
    [sym_concatenated_string] = STATE(3545),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3545),
    [sym_new_expression] = STATE(3545),
    [sym_delete_expression] = STATE(3545),
    [sym_lambda_expression] = STATE(3545),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7916),
    [anon_sym_SEMI] = ACTIONS(7918),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(7916),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7920),
    [sym_false] = ACTIONS(7920),
    [sym_null] = ACTIONS(7920),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(7920),
  },
  [3372] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(7922),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3373] = {
    [anon_sym_COLON] = ACTIONS(7924),
    [sym_comment] = ACTIONS(91),
  },
  [3374] = {
    [sym_catch_clause] = STATE(3548),
    [aux_sym_try_statement_repeat1] = STATE(3548),
    [anon_sym_else] = ACTIONS(3346),
    [anon_sym_while] = ACTIONS(3346),
    [sym_comment] = ACTIONS(91),
    [anon_sym_catch] = ACTIONS(2895),
  },
  [3375] = {
    [anon_sym_else] = ACTIONS(7561),
    [anon_sym_while] = ACTIONS(7561),
    [sym_comment] = ACTIONS(91),
  },
  [3376] = {
    [sym_compound_statement] = STATE(3549),
    [sym_labeled_statement] = STATE(3549),
    [sym_expression_statement] = STATE(3549),
    [sym_if_statement] = STATE(3549),
    [sym_switch_statement] = STATE(3549),
    [sym_case_statement] = STATE(3549),
    [sym_while_statement] = STATE(3549),
    [sym_do_statement] = STATE(3549),
    [sym_for_statement] = STATE(3549),
    [sym_return_statement] = STATE(3549),
    [sym_break_statement] = STATE(3549),
    [sym_continue_statement] = STATE(3549),
    [sym_goto_statement] = STATE(3549),
    [sym__expression] = STATE(222),
    [sym_comma_expression] = STATE(223),
    [sym_conditional_expression] = STATE(222),
    [sym_assignment_expression] = STATE(222),
    [sym_pointer_expression] = STATE(222),
    [sym_logical_expression] = STATE(222),
    [sym_bitwise_expression] = STATE(222),
    [sym_equality_expression] = STATE(222),
    [sym_relational_expression] = STATE(222),
    [sym_shift_expression] = STATE(222),
    [sym_math_expression] = STATE(222),
    [sym_cast_expression] = STATE(222),
    [sym_sizeof_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_call_expression] = STATE(222),
    [sym_field_expression] = STATE(222),
    [sym_compound_literal_expression] = STATE(222),
    [sym_parenthesized_expression] = STATE(222),
    [sym_char_literal] = STATE(222),
    [sym_concatenated_string] = STATE(222),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(222),
    [sym_for_range_loop] = STATE(3549),
    [sym_try_statement] = STATE(3549),
    [sym_new_expression] = STATE(222),
    [sym_delete_expression] = STATE(222),
    [sym_lambda_expression] = STATE(222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(359),
    [anon_sym_switch] = ACTIONS(361),
    [anon_sym_case] = ACTIONS(363),
    [anon_sym_default] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [anon_sym_do] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(373),
    [anon_sym_break] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_goto] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(353),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_identifier] = ACTIONS(383),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(381),
  },
  [3377] = {
    [anon_sym_else] = ACTIONS(7589),
    [anon_sym_while] = ACTIONS(7589),
    [sym_comment] = ACTIONS(91),
  },
  [3378] = {
    [sym_compound_statement] = STATE(3550),
    [sym_labeled_statement] = STATE(3550),
    [sym_expression_statement] = STATE(3550),
    [sym_if_statement] = STATE(3550),
    [sym_switch_statement] = STATE(3550),
    [sym_case_statement] = STATE(3550),
    [sym_while_statement] = STATE(3550),
    [sym_do_statement] = STATE(3550),
    [sym_for_statement] = STATE(3550),
    [sym_return_statement] = STATE(3550),
    [sym_break_statement] = STATE(3550),
    [sym_continue_statement] = STATE(3550),
    [sym_goto_statement] = STATE(3550),
    [sym__expression] = STATE(222),
    [sym_comma_expression] = STATE(223),
    [sym_conditional_expression] = STATE(222),
    [sym_assignment_expression] = STATE(222),
    [sym_pointer_expression] = STATE(222),
    [sym_logical_expression] = STATE(222),
    [sym_bitwise_expression] = STATE(222),
    [sym_equality_expression] = STATE(222),
    [sym_relational_expression] = STATE(222),
    [sym_shift_expression] = STATE(222),
    [sym_math_expression] = STATE(222),
    [sym_cast_expression] = STATE(222),
    [sym_sizeof_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_call_expression] = STATE(222),
    [sym_field_expression] = STATE(222),
    [sym_compound_literal_expression] = STATE(222),
    [sym_parenthesized_expression] = STATE(222),
    [sym_char_literal] = STATE(222),
    [sym_concatenated_string] = STATE(222),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(222),
    [sym_for_range_loop] = STATE(3550),
    [sym_try_statement] = STATE(3550),
    [sym_new_expression] = STATE(222),
    [sym_delete_expression] = STATE(222),
    [sym_lambda_expression] = STATE(222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(359),
    [anon_sym_switch] = ACTIONS(361),
    [anon_sym_case] = ACTIONS(363),
    [anon_sym_default] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [anon_sym_do] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(373),
    [anon_sym_break] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_goto] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(353),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_identifier] = ACTIONS(383),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(381),
  },
  [3379] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(7926),
    [sym_comment] = ACTIONS(91),
  },
  [3380] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3552),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(7926),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3381] = {
    [anon_sym_else] = ACTIONS(7598),
    [anon_sym_while] = ACTIONS(7598),
    [sym_comment] = ACTIONS(91),
  },
  [3382] = {
    [sym_raw_string_literal] = ACTIONS(7928),
    [ts_builtin_sym_end] = ACTIONS(7928),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7930),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7930),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7930),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7930),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7930),
    [sym_preproc_directive] = ACTIONS(7930),
    [anon_sym_SEMI] = ACTIONS(7928),
    [anon_sym_typedef] = ACTIONS(7930),
    [anon_sym_extern] = ACTIONS(7930),
    [anon_sym_LBRACE] = ACTIONS(7928),
    [anon_sym_RBRACE] = ACTIONS(7928),
    [anon_sym_LPAREN2] = ACTIONS(7928),
    [anon_sym_STAR] = ACTIONS(7928),
    [anon_sym_LBRACK] = ACTIONS(7928),
    [anon_sym_static] = ACTIONS(7930),
    [anon_sym_register] = ACTIONS(7930),
    [anon_sym_inline] = ACTIONS(7930),
    [anon_sym_const] = ACTIONS(7930),
    [anon_sym_restrict] = ACTIONS(7930),
    [anon_sym_volatile] = ACTIONS(7930),
    [anon_sym__Atomic] = ACTIONS(7930),
    [anon_sym_mutable] = ACTIONS(7930),
    [anon_sym_explicit] = ACTIONS(7930),
    [anon_sym_constexpr] = ACTIONS(7930),
    [anon_sym_unsigned] = ACTIONS(7930),
    [anon_sym_long] = ACTIONS(7930),
    [anon_sym_short] = ACTIONS(7930),
    [sym_primitive_type] = ACTIONS(7930),
    [anon_sym_enum] = ACTIONS(7930),
    [anon_sym_struct] = ACTIONS(7930),
    [anon_sym_union] = ACTIONS(7930),
    [anon_sym_if] = ACTIONS(7930),
    [anon_sym_else] = ACTIONS(7930),
    [anon_sym_switch] = ACTIONS(7930),
    [anon_sym_case] = ACTIONS(7930),
    [anon_sym_default] = ACTIONS(7930),
    [anon_sym_while] = ACTIONS(7930),
    [anon_sym_do] = ACTIONS(7930),
    [anon_sym_for] = ACTIONS(7930),
    [anon_sym_return] = ACTIONS(7930),
    [anon_sym_break] = ACTIONS(7930),
    [anon_sym_continue] = ACTIONS(7930),
    [anon_sym_goto] = ACTIONS(7930),
    [anon_sym_AMP] = ACTIONS(7930),
    [anon_sym_AMP_AMP] = ACTIONS(7928),
    [anon_sym_BANG] = ACTIONS(7928),
    [anon_sym_TILDE] = ACTIONS(7928),
    [anon_sym_PLUS] = ACTIONS(7930),
    [anon_sym_DASH] = ACTIONS(7930),
    [anon_sym_DASH_DASH] = ACTIONS(7928),
    [anon_sym_PLUS_PLUS] = ACTIONS(7928),
    [anon_sym_sizeof] = ACTIONS(7930),
    [sym_number_literal] = ACTIONS(7928),
    [anon_sym_SQUOTE] = ACTIONS(7928),
    [anon_sym_DQUOTE] = ACTIONS(7928),
    [sym_true] = ACTIONS(7930),
    [sym_false] = ACTIONS(7930),
    [sym_null] = ACTIONS(7930),
    [sym_identifier] = ACTIONS(7930),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7930),
    [sym_auto] = ACTIONS(7930),
    [anon_sym_typename] = ACTIONS(7930),
    [anon_sym_template] = ACTIONS(7930),
    [anon_sym_delete] = ACTIONS(7930),
    [anon_sym_namespace] = ACTIONS(7930),
    [anon_sym_using] = ACTIONS(7930),
    [anon_sym_try] = ACTIONS(7930),
    [anon_sym_new] = ACTIONS(7930),
    [anon_sym_COLON_COLON] = ACTIONS(7928),
    [sym_operator_name] = ACTIONS(7928),
    [sym_nullptr] = ACTIONS(7930),
  },
  [3383] = {
    [sym_compound_statement] = STATE(3553),
    [sym_labeled_statement] = STATE(3553),
    [sym_expression_statement] = STATE(3553),
    [sym_if_statement] = STATE(3553),
    [sym_switch_statement] = STATE(3553),
    [sym_case_statement] = STATE(3553),
    [sym_while_statement] = STATE(3553),
    [sym_do_statement] = STATE(3553),
    [sym_for_statement] = STATE(3553),
    [sym_return_statement] = STATE(3553),
    [sym_break_statement] = STATE(3553),
    [sym_continue_statement] = STATE(3553),
    [sym_goto_statement] = STATE(3553),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(3553),
    [sym_try_statement] = STATE(3553),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_switch] = ACTIONS(49),
    [anon_sym_case] = ACTIONS(51),
    [anon_sym_default] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(1115),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(105),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [3384] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(7932),
    [sym_comment] = ACTIONS(91),
  },
  [3385] = {
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_LPAREN2] = ACTIONS(7123),
    [anon_sym_STAR] = ACTIONS(7125),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [anon_sym_EQ] = ACTIONS(7125),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7125),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7125),
    [anon_sym_CARET] = ACTIONS(7125),
    [anon_sym_EQ_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_LT] = ACTIONS(7125),
    [anon_sym_GT] = ACTIONS(7125),
    [anon_sym_LT_EQ] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7125),
    [anon_sym_GT_GT] = ACTIONS(7125),
    [anon_sym_PLUS] = ACTIONS(7125),
    [anon_sym_DASH] = ACTIONS(7125),
    [anon_sym_SLASH] = ACTIONS(7125),
    [anon_sym_PERCENT] = ACTIONS(7125),
    [anon_sym_DASH_DASH] = ACTIONS(7123),
    [anon_sym_PLUS_PLUS] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7123),
    [anon_sym_DASH_GT] = ACTIONS(7123),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(7123),
  },
  [3386] = {
    [anon_sym_COMMA] = ACTIONS(5928),
    [anon_sym_LBRACE] = ACTIONS(5928),
    [anon_sym_LPAREN2] = ACTIONS(5928),
    [anon_sym_STAR] = ACTIONS(5930),
    [anon_sym_LBRACK] = ACTIONS(5928),
    [anon_sym_EQ] = ACTIONS(5930),
    [anon_sym_QMARK] = ACTIONS(5928),
    [anon_sym_STAR_EQ] = ACTIONS(5928),
    [anon_sym_SLASH_EQ] = ACTIONS(5928),
    [anon_sym_PERCENT_EQ] = ACTIONS(5928),
    [anon_sym_PLUS_EQ] = ACTIONS(5928),
    [anon_sym_DASH_EQ] = ACTIONS(5928),
    [anon_sym_LT_LT_EQ] = ACTIONS(5928),
    [anon_sym_GT_GT_EQ] = ACTIONS(5928),
    [anon_sym_AMP_EQ] = ACTIONS(5928),
    [anon_sym_CARET_EQ] = ACTIONS(5928),
    [anon_sym_PIPE_EQ] = ACTIONS(5928),
    [anon_sym_AMP] = ACTIONS(5930),
    [anon_sym_PIPE_PIPE] = ACTIONS(5928),
    [anon_sym_AMP_AMP] = ACTIONS(5928),
    [anon_sym_PIPE] = ACTIONS(5930),
    [anon_sym_CARET] = ACTIONS(5930),
    [anon_sym_EQ_EQ] = ACTIONS(5928),
    [anon_sym_BANG_EQ] = ACTIONS(5928),
    [anon_sym_LT] = ACTIONS(5930),
    [anon_sym_GT] = ACTIONS(5930),
    [anon_sym_LT_EQ] = ACTIONS(5928),
    [anon_sym_GT_EQ] = ACTIONS(5928),
    [anon_sym_LT_LT] = ACTIONS(5930),
    [anon_sym_GT_GT] = ACTIONS(5930),
    [anon_sym_PLUS] = ACTIONS(5930),
    [anon_sym_DASH] = ACTIONS(5930),
    [anon_sym_SLASH] = ACTIONS(5930),
    [anon_sym_PERCENT] = ACTIONS(5930),
    [anon_sym_DASH_DASH] = ACTIONS(5928),
    [anon_sym_PLUS_PLUS] = ACTIONS(5928),
    [anon_sym_DOT] = ACTIONS(5928),
    [anon_sym_DASH_GT] = ACTIONS(5928),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(5928),
  },
  [3387] = {
    [sym_enumerator] = STATE(1988),
    [anon_sym_RBRACE] = ACTIONS(7934),
    [sym_identifier] = ACTIONS(1009),
    [sym_comment] = ACTIONS(91),
  },
  [3388] = {
    [anon_sym_COMMA] = ACTIONS(6046),
    [anon_sym_LBRACE] = ACTIONS(6046),
    [anon_sym_LPAREN2] = ACTIONS(6046),
    [anon_sym_STAR] = ACTIONS(6048),
    [anon_sym_LBRACK] = ACTIONS(6046),
    [anon_sym_EQ] = ACTIONS(6048),
    [anon_sym_QMARK] = ACTIONS(6046),
    [anon_sym_STAR_EQ] = ACTIONS(6046),
    [anon_sym_SLASH_EQ] = ACTIONS(6046),
    [anon_sym_PERCENT_EQ] = ACTIONS(6046),
    [anon_sym_PLUS_EQ] = ACTIONS(6046),
    [anon_sym_DASH_EQ] = ACTIONS(6046),
    [anon_sym_LT_LT_EQ] = ACTIONS(6046),
    [anon_sym_GT_GT_EQ] = ACTIONS(6046),
    [anon_sym_AMP_EQ] = ACTIONS(6046),
    [anon_sym_CARET_EQ] = ACTIONS(6046),
    [anon_sym_PIPE_EQ] = ACTIONS(6046),
    [anon_sym_AMP] = ACTIONS(6048),
    [anon_sym_PIPE_PIPE] = ACTIONS(6046),
    [anon_sym_AMP_AMP] = ACTIONS(6046),
    [anon_sym_PIPE] = ACTIONS(6048),
    [anon_sym_CARET] = ACTIONS(6048),
    [anon_sym_EQ_EQ] = ACTIONS(6046),
    [anon_sym_BANG_EQ] = ACTIONS(6046),
    [anon_sym_LT] = ACTIONS(6048),
    [anon_sym_GT] = ACTIONS(6048),
    [anon_sym_LT_EQ] = ACTIONS(6046),
    [anon_sym_GT_EQ] = ACTIONS(6046),
    [anon_sym_LT_LT] = ACTIONS(6048),
    [anon_sym_GT_GT] = ACTIONS(6048),
    [anon_sym_PLUS] = ACTIONS(6048),
    [anon_sym_DASH] = ACTIONS(6048),
    [anon_sym_SLASH] = ACTIONS(6048),
    [anon_sym_PERCENT] = ACTIONS(6048),
    [anon_sym_DASH_DASH] = ACTIONS(6046),
    [anon_sym_PLUS_PLUS] = ACTIONS(6046),
    [anon_sym_DOT] = ACTIONS(6046),
    [anon_sym_DASH_GT] = ACTIONS(6046),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(6046),
  },
  [3389] = {
    [anon_sym_COMMA] = ACTIONS(6050),
    [anon_sym_LBRACE] = ACTIONS(6050),
    [anon_sym_LPAREN2] = ACTIONS(6050),
    [anon_sym_STAR] = ACTIONS(6052),
    [anon_sym_LBRACK] = ACTIONS(6050),
    [anon_sym_EQ] = ACTIONS(6052),
    [anon_sym_QMARK] = ACTIONS(6050),
    [anon_sym_STAR_EQ] = ACTIONS(6050),
    [anon_sym_SLASH_EQ] = ACTIONS(6050),
    [anon_sym_PERCENT_EQ] = ACTIONS(6050),
    [anon_sym_PLUS_EQ] = ACTIONS(6050),
    [anon_sym_DASH_EQ] = ACTIONS(6050),
    [anon_sym_LT_LT_EQ] = ACTIONS(6050),
    [anon_sym_GT_GT_EQ] = ACTIONS(6050),
    [anon_sym_AMP_EQ] = ACTIONS(6050),
    [anon_sym_CARET_EQ] = ACTIONS(6050),
    [anon_sym_PIPE_EQ] = ACTIONS(6050),
    [anon_sym_AMP] = ACTIONS(6052),
    [anon_sym_PIPE_PIPE] = ACTIONS(6050),
    [anon_sym_AMP_AMP] = ACTIONS(6050),
    [anon_sym_PIPE] = ACTIONS(6052),
    [anon_sym_CARET] = ACTIONS(6052),
    [anon_sym_EQ_EQ] = ACTIONS(6050),
    [anon_sym_BANG_EQ] = ACTIONS(6050),
    [anon_sym_LT] = ACTIONS(6052),
    [anon_sym_GT] = ACTIONS(6052),
    [anon_sym_LT_EQ] = ACTIONS(6050),
    [anon_sym_GT_EQ] = ACTIONS(6050),
    [anon_sym_LT_LT] = ACTIONS(6052),
    [anon_sym_GT_GT] = ACTIONS(6052),
    [anon_sym_PLUS] = ACTIONS(6052),
    [anon_sym_DASH] = ACTIONS(6052),
    [anon_sym_SLASH] = ACTIONS(6052),
    [anon_sym_PERCENT] = ACTIONS(6052),
    [anon_sym_DASH_DASH] = ACTIONS(6050),
    [anon_sym_PLUS_PLUS] = ACTIONS(6050),
    [anon_sym_DOT] = ACTIONS(6050),
    [anon_sym_DASH_GT] = ACTIONS(6050),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(6050),
  },
  [3390] = {
    [anon_sym_COMMA] = ACTIONS(6054),
    [anon_sym_LBRACE] = ACTIONS(6054),
    [anon_sym_LPAREN2] = ACTIONS(6054),
    [anon_sym_STAR] = ACTIONS(6056),
    [anon_sym_LBRACK] = ACTIONS(6054),
    [anon_sym_EQ] = ACTIONS(6056),
    [anon_sym_QMARK] = ACTIONS(6054),
    [anon_sym_STAR_EQ] = ACTIONS(6054),
    [anon_sym_SLASH_EQ] = ACTIONS(6054),
    [anon_sym_PERCENT_EQ] = ACTIONS(6054),
    [anon_sym_PLUS_EQ] = ACTIONS(6054),
    [anon_sym_DASH_EQ] = ACTIONS(6054),
    [anon_sym_LT_LT_EQ] = ACTIONS(6054),
    [anon_sym_GT_GT_EQ] = ACTIONS(6054),
    [anon_sym_AMP_EQ] = ACTIONS(6054),
    [anon_sym_CARET_EQ] = ACTIONS(6054),
    [anon_sym_PIPE_EQ] = ACTIONS(6054),
    [anon_sym_AMP] = ACTIONS(6056),
    [anon_sym_PIPE_PIPE] = ACTIONS(6054),
    [anon_sym_AMP_AMP] = ACTIONS(6054),
    [anon_sym_PIPE] = ACTIONS(6056),
    [anon_sym_CARET] = ACTIONS(6056),
    [anon_sym_EQ_EQ] = ACTIONS(6054),
    [anon_sym_BANG_EQ] = ACTIONS(6054),
    [anon_sym_LT] = ACTIONS(6056),
    [anon_sym_GT] = ACTIONS(6056),
    [anon_sym_LT_EQ] = ACTIONS(6054),
    [anon_sym_GT_EQ] = ACTIONS(6054),
    [anon_sym_LT_LT] = ACTIONS(6056),
    [anon_sym_GT_GT] = ACTIONS(6056),
    [anon_sym_PLUS] = ACTIONS(6056),
    [anon_sym_DASH] = ACTIONS(6056),
    [anon_sym_SLASH] = ACTIONS(6056),
    [anon_sym_PERCENT] = ACTIONS(6056),
    [anon_sym_DASH_DASH] = ACTIONS(6054),
    [anon_sym_PLUS_PLUS] = ACTIONS(6054),
    [anon_sym_DOT] = ACTIONS(6054),
    [anon_sym_DASH_GT] = ACTIONS(6054),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(6054),
  },
  [3391] = {
    [anon_sym_COMMA] = ACTIONS(6058),
    [anon_sym_LBRACE] = ACTIONS(6058),
    [anon_sym_LPAREN2] = ACTIONS(6058),
    [anon_sym_STAR] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6058),
    [anon_sym_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6058),
    [anon_sym_STAR_EQ] = ACTIONS(6058),
    [anon_sym_SLASH_EQ] = ACTIONS(6058),
    [anon_sym_PERCENT_EQ] = ACTIONS(6058),
    [anon_sym_PLUS_EQ] = ACTIONS(6058),
    [anon_sym_DASH_EQ] = ACTIONS(6058),
    [anon_sym_LT_LT_EQ] = ACTIONS(6058),
    [anon_sym_GT_GT_EQ] = ACTIONS(6058),
    [anon_sym_AMP_EQ] = ACTIONS(6058),
    [anon_sym_CARET_EQ] = ACTIONS(6058),
    [anon_sym_PIPE_EQ] = ACTIONS(6058),
    [anon_sym_AMP] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6058),
    [anon_sym_AMP_AMP] = ACTIONS(6058),
    [anon_sym_PIPE] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6058),
    [anon_sym_BANG_EQ] = ACTIONS(6058),
    [anon_sym_LT] = ACTIONS(6060),
    [anon_sym_GT] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6058),
    [anon_sym_GT_EQ] = ACTIONS(6058),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_DASH] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [anon_sym_DASH_DASH] = ACTIONS(6058),
    [anon_sym_PLUS_PLUS] = ACTIONS(6058),
    [anon_sym_DOT] = ACTIONS(6058),
    [anon_sym_DASH_GT] = ACTIONS(6058),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(6058),
  },
  [3392] = {
    [anon_sym_COMMA] = ACTIONS(6300),
    [anon_sym_LBRACE] = ACTIONS(6300),
    [anon_sym_LPAREN2] = ACTIONS(6300),
    [anon_sym_STAR] = ACTIONS(6302),
    [anon_sym_LBRACK] = ACTIONS(6300),
    [anon_sym_EQ] = ACTIONS(6302),
    [anon_sym_QMARK] = ACTIONS(6300),
    [anon_sym_STAR_EQ] = ACTIONS(6300),
    [anon_sym_SLASH_EQ] = ACTIONS(6300),
    [anon_sym_PERCENT_EQ] = ACTIONS(6300),
    [anon_sym_PLUS_EQ] = ACTIONS(6300),
    [anon_sym_DASH_EQ] = ACTIONS(6300),
    [anon_sym_LT_LT_EQ] = ACTIONS(6300),
    [anon_sym_GT_GT_EQ] = ACTIONS(6300),
    [anon_sym_AMP_EQ] = ACTIONS(6300),
    [anon_sym_CARET_EQ] = ACTIONS(6300),
    [anon_sym_PIPE_EQ] = ACTIONS(6300),
    [anon_sym_AMP] = ACTIONS(6302),
    [anon_sym_PIPE_PIPE] = ACTIONS(6300),
    [anon_sym_AMP_AMP] = ACTIONS(6300),
    [anon_sym_PIPE] = ACTIONS(6302),
    [anon_sym_CARET] = ACTIONS(6302),
    [anon_sym_EQ_EQ] = ACTIONS(6300),
    [anon_sym_BANG_EQ] = ACTIONS(6300),
    [anon_sym_LT] = ACTIONS(6302),
    [anon_sym_GT] = ACTIONS(6302),
    [anon_sym_LT_EQ] = ACTIONS(6300),
    [anon_sym_GT_EQ] = ACTIONS(6300),
    [anon_sym_LT_LT] = ACTIONS(6302),
    [anon_sym_GT_GT] = ACTIONS(6302),
    [anon_sym_PLUS] = ACTIONS(6302),
    [anon_sym_DASH] = ACTIONS(6302),
    [anon_sym_SLASH] = ACTIONS(6302),
    [anon_sym_PERCENT] = ACTIONS(6302),
    [anon_sym_DASH_DASH] = ACTIONS(6300),
    [anon_sym_PLUS_PLUS] = ACTIONS(6300),
    [anon_sym_DOT] = ACTIONS(6300),
    [anon_sym_DASH_GT] = ACTIONS(6300),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(6300),
  },
  [3393] = {
    [anon_sym_COMMA] = ACTIONS(6304),
    [anon_sym_LBRACE] = ACTIONS(6304),
    [anon_sym_LPAREN2] = ACTIONS(6304),
    [anon_sym_STAR] = ACTIONS(6306),
    [anon_sym_LBRACK] = ACTIONS(6304),
    [anon_sym_EQ] = ACTIONS(6306),
    [anon_sym_QMARK] = ACTIONS(6304),
    [anon_sym_STAR_EQ] = ACTIONS(6304),
    [anon_sym_SLASH_EQ] = ACTIONS(6304),
    [anon_sym_PERCENT_EQ] = ACTIONS(6304),
    [anon_sym_PLUS_EQ] = ACTIONS(6304),
    [anon_sym_DASH_EQ] = ACTIONS(6304),
    [anon_sym_LT_LT_EQ] = ACTIONS(6304),
    [anon_sym_GT_GT_EQ] = ACTIONS(6304),
    [anon_sym_AMP_EQ] = ACTIONS(6304),
    [anon_sym_CARET_EQ] = ACTIONS(6304),
    [anon_sym_PIPE_EQ] = ACTIONS(6304),
    [anon_sym_AMP] = ACTIONS(6306),
    [anon_sym_PIPE_PIPE] = ACTIONS(6304),
    [anon_sym_AMP_AMP] = ACTIONS(6304),
    [anon_sym_PIPE] = ACTIONS(6306),
    [anon_sym_CARET] = ACTIONS(6306),
    [anon_sym_EQ_EQ] = ACTIONS(6304),
    [anon_sym_BANG_EQ] = ACTIONS(6304),
    [anon_sym_LT] = ACTIONS(6306),
    [anon_sym_GT] = ACTIONS(6306),
    [anon_sym_LT_EQ] = ACTIONS(6304),
    [anon_sym_GT_EQ] = ACTIONS(6304),
    [anon_sym_LT_LT] = ACTIONS(6306),
    [anon_sym_GT_GT] = ACTIONS(6306),
    [anon_sym_PLUS] = ACTIONS(6306),
    [anon_sym_DASH] = ACTIONS(6306),
    [anon_sym_SLASH] = ACTIONS(6306),
    [anon_sym_PERCENT] = ACTIONS(6306),
    [anon_sym_DASH_DASH] = ACTIONS(6304),
    [anon_sym_PLUS_PLUS] = ACTIONS(6304),
    [anon_sym_DOT] = ACTIONS(6304),
    [anon_sym_DASH_GT] = ACTIONS(6304),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(6304),
  },
  [3394] = {
    [anon_sym_COMMA] = ACTIONS(7219),
    [anon_sym_LBRACE] = ACTIONS(7219),
    [anon_sym_LPAREN2] = ACTIONS(7219),
    [anon_sym_STAR] = ACTIONS(7221),
    [anon_sym_LBRACK] = ACTIONS(7219),
    [anon_sym_EQ] = ACTIONS(7221),
    [anon_sym_QMARK] = ACTIONS(7219),
    [anon_sym_STAR_EQ] = ACTIONS(7219),
    [anon_sym_SLASH_EQ] = ACTIONS(7219),
    [anon_sym_PERCENT_EQ] = ACTIONS(7219),
    [anon_sym_PLUS_EQ] = ACTIONS(7219),
    [anon_sym_DASH_EQ] = ACTIONS(7219),
    [anon_sym_LT_LT_EQ] = ACTIONS(7219),
    [anon_sym_GT_GT_EQ] = ACTIONS(7219),
    [anon_sym_AMP_EQ] = ACTIONS(7219),
    [anon_sym_CARET_EQ] = ACTIONS(7219),
    [anon_sym_PIPE_EQ] = ACTIONS(7219),
    [anon_sym_AMP] = ACTIONS(7221),
    [anon_sym_PIPE_PIPE] = ACTIONS(7219),
    [anon_sym_AMP_AMP] = ACTIONS(7219),
    [anon_sym_PIPE] = ACTIONS(7221),
    [anon_sym_CARET] = ACTIONS(7221),
    [anon_sym_EQ_EQ] = ACTIONS(7219),
    [anon_sym_BANG_EQ] = ACTIONS(7219),
    [anon_sym_LT] = ACTIONS(7221),
    [anon_sym_GT] = ACTIONS(7221),
    [anon_sym_LT_EQ] = ACTIONS(7219),
    [anon_sym_GT_EQ] = ACTIONS(7219),
    [anon_sym_LT_LT] = ACTIONS(7221),
    [anon_sym_GT_GT] = ACTIONS(7221),
    [anon_sym_PLUS] = ACTIONS(7221),
    [anon_sym_DASH] = ACTIONS(7221),
    [anon_sym_SLASH] = ACTIONS(7221),
    [anon_sym_PERCENT] = ACTIONS(7221),
    [anon_sym_DASH_DASH] = ACTIONS(7219),
    [anon_sym_PLUS_PLUS] = ACTIONS(7219),
    [anon_sym_DOT] = ACTIONS(7219),
    [anon_sym_DASH_GT] = ACTIONS(7219),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(7219),
  },
  [3395] = {
    [sym__abstract_declarator] = STATE(3556),
    [sym_abstract_pointer_declarator] = STATE(3556),
    [sym_abstract_function_declarator] = STATE(3556),
    [sym_abstract_array_declarator] = STATE(3556),
    [sym_type_qualifier] = STATE(3557),
    [sym_parameter_list] = STATE(3398),
    [sym_abstract_reference_declarator] = STATE(3556),
    [aux_sym_type_definition_repeat1] = STATE(3557),
    [anon_sym_COMMA] = ACTIONS(2461),
    [anon_sym_LBRACE] = ACTIONS(2461),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(7611),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_EQ] = ACTIONS(2461),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(7613),
    [anon_sym_AMP_AMP] = ACTIONS(7615),
    [anon_sym_DASH_GT] = ACTIONS(2461),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2461),
    [anon_sym_override] = ACTIONS(2461),
    [anon_sym_GT2] = ACTIONS(2461),
    [sym_noexcept] = ACTIONS(2461),
  },
  [3396] = {
    [sym__abstract_declarator] = STATE(3558),
    [sym_abstract_pointer_declarator] = STATE(3558),
    [sym_abstract_function_declarator] = STATE(3558),
    [sym_abstract_array_declarator] = STATE(3558),
    [sym_parameter_list] = STATE(3398),
    [sym_abstract_reference_declarator] = STATE(3558),
    [anon_sym_COMMA] = ACTIONS(2463),
    [anon_sym_LBRACE] = ACTIONS(2463),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(7611),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_EQ] = ACTIONS(2463),
    [anon_sym_const] = ACTIONS(6555),
    [anon_sym_restrict] = ACTIONS(2463),
    [anon_sym_volatile] = ACTIONS(2463),
    [anon_sym__Atomic] = ACTIONS(2463),
    [anon_sym_mutable] = ACTIONS(2463),
    [anon_sym_explicit] = ACTIONS(2463),
    [anon_sym_constexpr] = ACTIONS(2463),
    [anon_sym_AMP] = ACTIONS(7613),
    [anon_sym_AMP_AMP] = ACTIONS(7615),
    [anon_sym_DASH_GT] = ACTIONS(2463),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2463),
    [anon_sym_override] = ACTIONS(2463),
    [anon_sym_GT2] = ACTIONS(2463),
    [sym_noexcept] = ACTIONS(2463),
  },
  [3397] = {
    [sym_parameter_list] = STATE(3559),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(6557),
    [anon_sym_const] = ACTIONS(6559),
    [anon_sym_restrict] = ACTIONS(6557),
    [anon_sym_volatile] = ACTIONS(6557),
    [anon_sym__Atomic] = ACTIONS(6557),
    [anon_sym_mutable] = ACTIONS(6557),
    [anon_sym_explicit] = ACTIONS(6557),
    [anon_sym_constexpr] = ACTIONS(6557),
    [anon_sym_DASH_GT] = ACTIONS(6557),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(6557),
    [anon_sym_override] = ACTIONS(6557),
    [anon_sym_GT2] = ACTIONS(6557),
    [sym_noexcept] = ACTIONS(6557),
  },
  [3398] = {
    [sym_type_qualifier] = STATE(3560),
    [sym_trailing_return_type] = STATE(971),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3560),
    [anon_sym_COMMA] = ACTIONS(1787),
    [anon_sym_LBRACE] = ACTIONS(1787),
    [anon_sym_LPAREN2] = ACTIONS(1787),
    [anon_sym_LBRACK] = ACTIONS(1787),
    [anon_sym_EQ] = ACTIONS(1787),
    [anon_sym_const] = ACTIONS(6561),
    [anon_sym_restrict] = ACTIONS(1787),
    [anon_sym_volatile] = ACTIONS(1787),
    [anon_sym__Atomic] = ACTIONS(1787),
    [anon_sym_mutable] = ACTIONS(1787),
    [anon_sym_explicit] = ACTIONS(1787),
    [anon_sym_constexpr] = ACTIONS(1787),
    [anon_sym_DASH_GT] = ACTIONS(1787),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1787),
    [anon_sym_override] = ACTIONS(1787),
    [anon_sym_GT2] = ACTIONS(1787),
    [sym_noexcept] = ACTIONS(1787),
  },
  [3399] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3399),
    [anon_sym_COMMA] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(1985),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1985),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_EQ] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1987),
    [anon_sym_restrict] = ACTIONS(1987),
    [anon_sym_volatile] = ACTIONS(1987),
    [anon_sym__Atomic] = ACTIONS(1987),
    [anon_sym_mutable] = ACTIONS(1987),
    [anon_sym_explicit] = ACTIONS(1987),
    [anon_sym_constexpr] = ACTIONS(1987),
    [anon_sym_unsigned] = ACTIONS(7936),
    [anon_sym_long] = ACTIONS(7936),
    [anon_sym_short] = ACTIONS(7936),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_DASH_GT] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1987),
    [anon_sym_override] = ACTIONS(1987),
    [anon_sym_GT2] = ACTIONS(1985),
    [sym_noexcept] = ACTIONS(1987),
  },
  [3400] = {
    [sym_parameter_list] = STATE(3180),
    [anon_sym_SEMI] = ACTIONS(5889),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_const] = ACTIONS(7689),
    [anon_sym_restrict] = ACTIONS(5889),
    [anon_sym_volatile] = ACTIONS(5889),
    [anon_sym__Atomic] = ACTIONS(5889),
    [anon_sym_mutable] = ACTIONS(5889),
    [anon_sym_explicit] = ACTIONS(5889),
    [anon_sym_constexpr] = ACTIONS(5889),
    [anon_sym_DASH_GT] = ACTIONS(5889),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5889),
    [anon_sym_override] = ACTIONS(5889),
    [sym_noexcept] = ACTIONS(5889),
  },
  [3401] = {
    [sym_type_qualifier] = STATE(3401),
    [aux_sym_type_definition_repeat1] = STATE(3401),
    [anon_sym_SEMI] = ACTIONS(2179),
    [anon_sym_LPAREN2] = ACTIONS(2179),
    [anon_sym_STAR] = ACTIONS(2179),
    [anon_sym_LBRACK] = ACTIONS(2179),
    [anon_sym_const] = ACTIONS(2538),
    [anon_sym_restrict] = ACTIONS(5316),
    [anon_sym_volatile] = ACTIONS(5316),
    [anon_sym__Atomic] = ACTIONS(5316),
    [anon_sym_mutable] = ACTIONS(5316),
    [anon_sym_explicit] = ACTIONS(5316),
    [anon_sym_constexpr] = ACTIONS(5316),
    [anon_sym_AMP] = ACTIONS(2177),
    [anon_sym_AMP_AMP] = ACTIONS(2179),
    [anon_sym_DASH_GT] = ACTIONS(2179),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2179),
    [anon_sym_override] = ACTIONS(2179),
    [sym_noexcept] = ACTIONS(2179),
  },
  [3402] = {
    [sym_type_qualifier] = STATE(3403),
    [sym_trailing_return_type] = STATE(2418),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3403),
    [anon_sym_SEMI] = ACTIONS(5331),
    [anon_sym_LPAREN2] = ACTIONS(5331),
    [anon_sym_LBRACK] = ACTIONS(5331),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(3285),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5331),
    [anon_sym_override] = ACTIONS(5331),
    [sym_noexcept] = ACTIONS(7625),
  },
  [3403] = {
    [sym_type_qualifier] = STATE(3403),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3403),
    [anon_sym_SEMI] = ACTIONS(5351),
    [anon_sym_LPAREN2] = ACTIONS(5351),
    [anon_sym_LBRACK] = ACTIONS(5351),
    [anon_sym_const] = ACTIONS(5353),
    [anon_sym_restrict] = ACTIONS(5356),
    [anon_sym_volatile] = ACTIONS(5356),
    [anon_sym__Atomic] = ACTIONS(5356),
    [anon_sym_mutable] = ACTIONS(5356),
    [anon_sym_explicit] = ACTIONS(5356),
    [anon_sym_constexpr] = ACTIONS(5356),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5351),
    [anon_sym_override] = ACTIONS(5351),
    [sym_noexcept] = ACTIONS(7939),
  },
  [3404] = {
    [sym__expression] = STATE(3561),
    [sym_conditional_expression] = STATE(3561),
    [sym_assignment_expression] = STATE(3561),
    [sym_pointer_expression] = STATE(3561),
    [sym_logical_expression] = STATE(3561),
    [sym_bitwise_expression] = STATE(3561),
    [sym_equality_expression] = STATE(3561),
    [sym_relational_expression] = STATE(3561),
    [sym_shift_expression] = STATE(3561),
    [sym_math_expression] = STATE(3561),
    [sym_cast_expression] = STATE(3561),
    [sym_sizeof_expression] = STATE(3561),
    [sym_subscript_expression] = STATE(3561),
    [sym_call_expression] = STATE(3561),
    [sym_field_expression] = STATE(3561),
    [sym_compound_literal_expression] = STATE(3561),
    [sym_parenthesized_expression] = STATE(3561),
    [sym_char_literal] = STATE(3561),
    [sym_concatenated_string] = STATE(3561),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3561),
    [sym_new_expression] = STATE(3561),
    [sym_delete_expression] = STATE(3561),
    [sym_lambda_expression] = STATE(3561),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7942),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(7942),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7944),
    [sym_false] = ACTIONS(7944),
    [sym_null] = ACTIONS(7944),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(7944),
  },
  [3405] = {
    [anon_sym_LPAREN2] = ACTIONS(7946),
    [sym_comment] = ACTIONS(91),
  },
  [3406] = {
    [sym_compound_statement] = STATE(642),
    [sym_labeled_statement] = STATE(642),
    [sym_expression_statement] = STATE(642),
    [sym_if_statement] = STATE(642),
    [sym_switch_statement] = STATE(642),
    [sym_case_statement] = STATE(642),
    [sym_while_statement] = STATE(642),
    [sym_do_statement] = STATE(642),
    [sym_for_statement] = STATE(642),
    [sym_return_statement] = STATE(642),
    [sym_break_statement] = STATE(642),
    [sym_continue_statement] = STATE(642),
    [sym_goto_statement] = STATE(642),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(642),
    [sym_try_statement] = STATE(642),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7177),
    [anon_sym_switch] = ACTIONS(7179),
    [anon_sym_case] = ACTIONS(7181),
    [anon_sym_default] = ACTIONS(7183),
    [anon_sym_while] = ACTIONS(7185),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(7187),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(7189),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7191),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [3407] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_COLON] = ACTIONS(7948),
    [anon_sym_QMARK] = ACTIONS(1171),
    [anon_sym_STAR_EQ] = ACTIONS(1173),
    [anon_sym_SLASH_EQ] = ACTIONS(1173),
    [anon_sym_PERCENT_EQ] = ACTIONS(1173),
    [anon_sym_PLUS_EQ] = ACTIONS(1173),
    [anon_sym_DASH_EQ] = ACTIONS(1173),
    [anon_sym_LT_LT_EQ] = ACTIONS(1173),
    [anon_sym_GT_GT_EQ] = ACTIONS(1173),
    [anon_sym_AMP_EQ] = ACTIONS(1173),
    [anon_sym_CARET_EQ] = ACTIONS(1173),
    [anon_sym_PIPE_EQ] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_CARET] = ACTIONS(1183),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [3408] = {
    [sym_declaration] = STATE(681),
    [sym_type_definition] = STATE(681),
    [sym__declaration_specifiers] = STATE(682),
    [sym_compound_statement] = STATE(681),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_labeled_statement] = STATE(681),
    [sym_expression_statement] = STATE(681),
    [sym_if_statement] = STATE(681),
    [sym_switch_statement] = STATE(681),
    [sym_case_statement] = STATE(681),
    [sym_while_statement] = STATE(681),
    [sym_do_statement] = STATE(681),
    [sym_for_statement] = STATE(681),
    [sym_return_statement] = STATE(681),
    [sym_break_statement] = STATE(681),
    [sym_continue_statement] = STATE(681),
    [sym_goto_statement] = STATE(681),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(681),
    [sym_try_statement] = STATE(681),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(7177),
    [anon_sym_switch] = ACTIONS(7179),
    [anon_sym_case] = ACTIONS(7181),
    [anon_sym_default] = ACTIONS(7183),
    [anon_sym_while] = ACTIONS(7185),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(7187),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(7950),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7191),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(1202),
    [sym_nullptr] = ACTIONS(87),
  },
  [3409] = {
    [sym_compound_statement] = STATE(685),
    [sym_labeled_statement] = STATE(685),
    [sym_expression_statement] = STATE(685),
    [sym_if_statement] = STATE(685),
    [sym_switch_statement] = STATE(685),
    [sym_case_statement] = STATE(685),
    [sym_while_statement] = STATE(685),
    [sym_do_statement] = STATE(685),
    [sym_for_statement] = STATE(685),
    [sym_return_statement] = STATE(685),
    [sym_break_statement] = STATE(685),
    [sym_continue_statement] = STATE(685),
    [sym_goto_statement] = STATE(685),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(685),
    [sym_try_statement] = STATE(685),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7177),
    [anon_sym_switch] = ACTIONS(7179),
    [anon_sym_case] = ACTIONS(7181),
    [anon_sym_default] = ACTIONS(7183),
    [anon_sym_while] = ACTIONS(7185),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(7187),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(7189),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7191),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [3410] = {
    [sym_declaration] = STATE(3565),
    [sym__declaration_specifiers] = STATE(709),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym__expression] = STATE(3566),
    [sym_conditional_expression] = STATE(3566),
    [sym_assignment_expression] = STATE(3566),
    [sym_pointer_expression] = STATE(3566),
    [sym_logical_expression] = STATE(3566),
    [sym_bitwise_expression] = STATE(3566),
    [sym_equality_expression] = STATE(3566),
    [sym_relational_expression] = STATE(3566),
    [sym_shift_expression] = STATE(3566),
    [sym_math_expression] = STATE(3566),
    [sym_cast_expression] = STATE(3566),
    [sym_sizeof_expression] = STATE(3566),
    [sym_subscript_expression] = STATE(3566),
    [sym_call_expression] = STATE(3566),
    [sym_field_expression] = STATE(3566),
    [sym_compound_literal_expression] = STATE(3566),
    [sym_parenthesized_expression] = STATE(3566),
    [sym_char_literal] = STATE(3566),
    [sym_concatenated_string] = STATE(3566),
    [sym_string_literal] = STATE(238),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(3566),
    [sym_for_range_declaration] = STATE(3567),
    [sym_new_expression] = STATE(3566),
    [sym_delete_expression] = STATE(3566),
    [sym_lambda_expression] = STATE(3566),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(7952),
    [anon_sym_SEMI] = ACTIONS(7954),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(7952),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7956),
    [sym_false] = ACTIONS(7956),
    [sym_null] = ACTIONS(7956),
    [sym_identifier] = ACTIONS(1242),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(1244),
    [sym_nullptr] = ACTIONS(7956),
  },
  [3411] = {
    [sym_compound_statement] = STATE(762),
    [sym_labeled_statement] = STATE(762),
    [sym_expression_statement] = STATE(762),
    [sym_if_statement] = STATE(762),
    [sym_switch_statement] = STATE(762),
    [sym_case_statement] = STATE(762),
    [sym_while_statement] = STATE(762),
    [sym_do_statement] = STATE(762),
    [sym_for_statement] = STATE(762),
    [sym_return_statement] = STATE(762),
    [sym_break_statement] = STATE(762),
    [sym_continue_statement] = STATE(762),
    [sym_goto_statement] = STATE(762),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(762),
    [sym_try_statement] = STATE(762),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7177),
    [anon_sym_switch] = ACTIONS(7179),
    [anon_sym_case] = ACTIONS(7181),
    [anon_sym_default] = ACTIONS(7183),
    [anon_sym_while] = ACTIONS(7185),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(7187),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(7189),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7191),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [3412] = {
    [sym_catch_clause] = STATE(3568),
    [aux_sym_try_statement_repeat1] = STATE(3568),
    [sym_comment] = ACTIONS(91),
    [anon_sym_catch] = ACTIONS(1527),
  },
  [3413] = {
    [sym_compound_statement] = STATE(3114),
    [sym_labeled_statement] = STATE(3114),
    [sym_expression_statement] = STATE(3114),
    [sym_if_statement] = STATE(3114),
    [sym_switch_statement] = STATE(3114),
    [sym_case_statement] = STATE(3114),
    [sym_while_statement] = STATE(3114),
    [sym_do_statement] = STATE(3114),
    [sym_for_statement] = STATE(3114),
    [sym_return_statement] = STATE(3114),
    [sym_break_statement] = STATE(3114),
    [sym_continue_statement] = STATE(3114),
    [sym_goto_statement] = STATE(3114),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(3114),
    [sym_try_statement] = STATE(3114),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(1495),
    [anon_sym_switch] = ACTIONS(1497),
    [anon_sym_case] = ACTIONS(1499),
    [anon_sym_default] = ACTIONS(1501),
    [anon_sym_while] = ACTIONS(1503),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(1505),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(4937),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(1509),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [3414] = {
    [sym_raw_string_literal] = ACTIONS(7063),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7065),
    [sym_preproc_directive] = ACTIONS(7065),
    [anon_sym_SEMI] = ACTIONS(7063),
    [anon_sym_typedef] = ACTIONS(7065),
    [anon_sym_extern] = ACTIONS(7065),
    [anon_sym_LBRACE] = ACTIONS(7063),
    [anon_sym_RBRACE] = ACTIONS(7063),
    [anon_sym_LPAREN2] = ACTIONS(7063),
    [anon_sym_STAR] = ACTIONS(7063),
    [anon_sym_LBRACK] = ACTIONS(7063),
    [anon_sym_static] = ACTIONS(7065),
    [anon_sym_register] = ACTIONS(7065),
    [anon_sym_inline] = ACTIONS(7065),
    [anon_sym_const] = ACTIONS(7065),
    [anon_sym_restrict] = ACTIONS(7065),
    [anon_sym_volatile] = ACTIONS(7065),
    [anon_sym__Atomic] = ACTIONS(7065),
    [anon_sym_mutable] = ACTIONS(7065),
    [anon_sym_explicit] = ACTIONS(7065),
    [anon_sym_constexpr] = ACTIONS(7065),
    [anon_sym_unsigned] = ACTIONS(7065),
    [anon_sym_long] = ACTIONS(7065),
    [anon_sym_short] = ACTIONS(7065),
    [sym_primitive_type] = ACTIONS(7065),
    [anon_sym_enum] = ACTIONS(7065),
    [anon_sym_struct] = ACTIONS(7065),
    [anon_sym_union] = ACTIONS(7065),
    [anon_sym_if] = ACTIONS(7065),
    [anon_sym_else] = ACTIONS(7958),
    [anon_sym_switch] = ACTIONS(7065),
    [anon_sym_case] = ACTIONS(7065),
    [anon_sym_default] = ACTIONS(7065),
    [anon_sym_while] = ACTIONS(7065),
    [anon_sym_do] = ACTIONS(7065),
    [anon_sym_for] = ACTIONS(7065),
    [anon_sym_return] = ACTIONS(7065),
    [anon_sym_break] = ACTIONS(7065),
    [anon_sym_continue] = ACTIONS(7065),
    [anon_sym_goto] = ACTIONS(7065),
    [anon_sym_AMP] = ACTIONS(7065),
    [anon_sym_AMP_AMP] = ACTIONS(7063),
    [anon_sym_BANG] = ACTIONS(7063),
    [anon_sym_TILDE] = ACTIONS(7063),
    [anon_sym_PLUS] = ACTIONS(7065),
    [anon_sym_DASH] = ACTIONS(7065),
    [anon_sym_DASH_DASH] = ACTIONS(7063),
    [anon_sym_PLUS_PLUS] = ACTIONS(7063),
    [anon_sym_sizeof] = ACTIONS(7065),
    [sym_number_literal] = ACTIONS(7063),
    [anon_sym_SQUOTE] = ACTIONS(7063),
    [anon_sym_DQUOTE] = ACTIONS(7063),
    [sym_true] = ACTIONS(7065),
    [sym_false] = ACTIONS(7065),
    [sym_null] = ACTIONS(7065),
    [sym_identifier] = ACTIONS(7065),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7065),
    [sym_auto] = ACTIONS(7065),
    [anon_sym_typename] = ACTIONS(7065),
    [anon_sym_template] = ACTIONS(7065),
    [anon_sym_delete] = ACTIONS(7065),
    [anon_sym_namespace] = ACTIONS(7065),
    [anon_sym_using] = ACTIONS(7065),
    [anon_sym_try] = ACTIONS(7065),
    [anon_sym_new] = ACTIONS(7065),
    [anon_sym_COLON_COLON] = ACTIONS(7063),
    [sym_operator_name] = ACTIONS(7063),
    [sym_nullptr] = ACTIONS(7065),
  },
  [3415] = {
    [sym_compound_statement] = STATE(3135),
    [sym_labeled_statement] = STATE(3135),
    [sym_expression_statement] = STATE(3135),
    [sym_if_statement] = STATE(3135),
    [sym_switch_statement] = STATE(3135),
    [sym_case_statement] = STATE(3135),
    [sym_while_statement] = STATE(3135),
    [sym_do_statement] = STATE(3135),
    [sym_for_statement] = STATE(3135),
    [sym_return_statement] = STATE(3135),
    [sym_break_statement] = STATE(3135),
    [sym_continue_statement] = STATE(3135),
    [sym_goto_statement] = STATE(3135),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(3135),
    [sym_try_statement] = STATE(3135),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(1495),
    [anon_sym_switch] = ACTIONS(1497),
    [anon_sym_case] = ACTIONS(1499),
    [anon_sym_default] = ACTIONS(1501),
    [anon_sym_while] = ACTIONS(1503),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(1505),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(4937),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(1509),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [3416] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [sym_comment] = ACTIONS(91),
  },
  [3417] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3571),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3418] = {
    [sym__expression] = STATE(3572),
    [sym_conditional_expression] = STATE(3572),
    [sym_assignment_expression] = STATE(3572),
    [sym_pointer_expression] = STATE(3572),
    [sym_logical_expression] = STATE(3572),
    [sym_bitwise_expression] = STATE(3572),
    [sym_equality_expression] = STATE(3572),
    [sym_relational_expression] = STATE(3572),
    [sym_shift_expression] = STATE(3572),
    [sym_math_expression] = STATE(3572),
    [sym_cast_expression] = STATE(3572),
    [sym_sizeof_expression] = STATE(3572),
    [sym_subscript_expression] = STATE(3572),
    [sym_call_expression] = STATE(3572),
    [sym_field_expression] = STATE(3572),
    [sym_compound_literal_expression] = STATE(3572),
    [sym_parenthesized_expression] = STATE(3572),
    [sym_char_literal] = STATE(3572),
    [sym_concatenated_string] = STATE(3572),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3572),
    [sym_new_expression] = STATE(3572),
    [sym_delete_expression] = STATE(3572),
    [sym_lambda_expression] = STATE(3572),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7962),
    [anon_sym_RPAREN] = ACTIONS(7960),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(7962),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7964),
    [sym_false] = ACTIONS(7964),
    [sym_null] = ACTIONS(7964),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(7964),
  },
  [3419] = {
    [sym_compound_statement] = STATE(3140),
    [sym_labeled_statement] = STATE(3140),
    [sym_expression_statement] = STATE(3140),
    [sym_if_statement] = STATE(3140),
    [sym_switch_statement] = STATE(3140),
    [sym_case_statement] = STATE(3140),
    [sym_while_statement] = STATE(3140),
    [sym_do_statement] = STATE(3140),
    [sym_for_statement] = STATE(3140),
    [sym_return_statement] = STATE(3140),
    [sym_break_statement] = STATE(3140),
    [sym_continue_statement] = STATE(3140),
    [sym_goto_statement] = STATE(3140),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(3140),
    [sym_try_statement] = STATE(3140),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(1495),
    [anon_sym_switch] = ACTIONS(1497),
    [anon_sym_case] = ACTIONS(1499),
    [anon_sym_default] = ACTIONS(1501),
    [anon_sym_while] = ACTIONS(1503),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(1505),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(4937),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(1509),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [3420] = {
    [sym_parameter_list] = STATE(2849),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [sym_comment] = ACTIONS(91),
  },
  [3421] = {
    [sym_new_declarator] = STATE(2861),
    [anon_sym_COMMA] = ACTIONS(6396),
    [anon_sym_SEMI] = ACTIONS(6396),
    [anon_sym_LBRACE] = ACTIONS(6396),
    [anon_sym_RBRACE] = ACTIONS(6396),
    [anon_sym_LPAREN2] = ACTIONS(6396),
    [anon_sym_STAR] = ACTIONS(6398),
    [anon_sym_LBRACK] = ACTIONS(6419),
    [anon_sym_EQ] = ACTIONS(6398),
    [anon_sym_QMARK] = ACTIONS(6396),
    [anon_sym_STAR_EQ] = ACTIONS(6396),
    [anon_sym_SLASH_EQ] = ACTIONS(6396),
    [anon_sym_PERCENT_EQ] = ACTIONS(6396),
    [anon_sym_PLUS_EQ] = ACTIONS(6396),
    [anon_sym_DASH_EQ] = ACTIONS(6396),
    [anon_sym_LT_LT_EQ] = ACTIONS(6396),
    [anon_sym_GT_GT_EQ] = ACTIONS(6396),
    [anon_sym_AMP_EQ] = ACTIONS(6396),
    [anon_sym_CARET_EQ] = ACTIONS(6396),
    [anon_sym_PIPE_EQ] = ACTIONS(6396),
    [anon_sym_AMP] = ACTIONS(6398),
    [anon_sym_PIPE_PIPE] = ACTIONS(6396),
    [anon_sym_AMP_AMP] = ACTIONS(6396),
    [anon_sym_PIPE] = ACTIONS(6398),
    [anon_sym_CARET] = ACTIONS(6398),
    [anon_sym_EQ_EQ] = ACTIONS(6396),
    [anon_sym_BANG_EQ] = ACTIONS(6396),
    [anon_sym_LT] = ACTIONS(6398),
    [anon_sym_GT] = ACTIONS(6398),
    [anon_sym_LT_EQ] = ACTIONS(6396),
    [anon_sym_GT_EQ] = ACTIONS(6396),
    [anon_sym_LT_LT] = ACTIONS(6398),
    [anon_sym_GT_GT] = ACTIONS(6398),
    [anon_sym_PLUS] = ACTIONS(6398),
    [anon_sym_DASH] = ACTIONS(6398),
    [anon_sym_SLASH] = ACTIONS(6398),
    [anon_sym_PERCENT] = ACTIONS(6398),
    [anon_sym_DASH_DASH] = ACTIONS(6396),
    [anon_sym_PLUS_PLUS] = ACTIONS(6396),
    [anon_sym_DOT] = ACTIONS(6396),
    [anon_sym_DASH_GT] = ACTIONS(6396),
    [sym_comment] = ACTIONS(91),
  },
  [3422] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(6404),
    [anon_sym_SEMI] = ACTIONS(6404),
    [anon_sym_RBRACE] = ACTIONS(6404),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(5060),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(6406),
    [anon_sym_QMARK] = ACTIONS(6404),
    [anon_sym_STAR_EQ] = ACTIONS(6404),
    [anon_sym_SLASH_EQ] = ACTIONS(6404),
    [anon_sym_PERCENT_EQ] = ACTIONS(6404),
    [anon_sym_PLUS_EQ] = ACTIONS(6404),
    [anon_sym_DASH_EQ] = ACTIONS(6404),
    [anon_sym_LT_LT_EQ] = ACTIONS(6404),
    [anon_sym_GT_GT_EQ] = ACTIONS(6404),
    [anon_sym_AMP_EQ] = ACTIONS(6404),
    [anon_sym_CARET_EQ] = ACTIONS(6404),
    [anon_sym_PIPE_EQ] = ACTIONS(6404),
    [anon_sym_AMP] = ACTIONS(5068),
    [anon_sym_PIPE_PIPE] = ACTIONS(5070),
    [anon_sym_AMP_AMP] = ACTIONS(5072),
    [anon_sym_PIPE] = ACTIONS(5074),
    [anon_sym_CARET] = ACTIONS(5076),
    [anon_sym_EQ_EQ] = ACTIONS(5078),
    [anon_sym_BANG_EQ] = ACTIONS(5078),
    [anon_sym_LT] = ACTIONS(5080),
    [anon_sym_GT] = ACTIONS(5080),
    [anon_sym_LT_EQ] = ACTIONS(5082),
    [anon_sym_GT_EQ] = ACTIONS(5082),
    [anon_sym_LT_LT] = ACTIONS(5084),
    [anon_sym_GT_GT] = ACTIONS(5084),
    [anon_sym_PLUS] = ACTIONS(5086),
    [anon_sym_DASH] = ACTIONS(5086),
    [anon_sym_SLASH] = ACTIONS(5060),
    [anon_sym_PERCENT] = ACTIONS(5060),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3423] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(6579),
    [anon_sym_SEMI] = ACTIONS(6579),
    [anon_sym_RBRACE] = ACTIONS(6579),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(5060),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(5062),
    [anon_sym_QMARK] = ACTIONS(5064),
    [anon_sym_STAR_EQ] = ACTIONS(5066),
    [anon_sym_SLASH_EQ] = ACTIONS(5066),
    [anon_sym_PERCENT_EQ] = ACTIONS(5066),
    [anon_sym_PLUS_EQ] = ACTIONS(5066),
    [anon_sym_DASH_EQ] = ACTIONS(5066),
    [anon_sym_LT_LT_EQ] = ACTIONS(5066),
    [anon_sym_GT_GT_EQ] = ACTIONS(5066),
    [anon_sym_AMP_EQ] = ACTIONS(5066),
    [anon_sym_CARET_EQ] = ACTIONS(5066),
    [anon_sym_PIPE_EQ] = ACTIONS(5066),
    [anon_sym_AMP] = ACTIONS(5068),
    [anon_sym_PIPE_PIPE] = ACTIONS(5070),
    [anon_sym_AMP_AMP] = ACTIONS(5072),
    [anon_sym_PIPE] = ACTIONS(5074),
    [anon_sym_CARET] = ACTIONS(5076),
    [anon_sym_EQ_EQ] = ACTIONS(5078),
    [anon_sym_BANG_EQ] = ACTIONS(5078),
    [anon_sym_LT] = ACTIONS(5080),
    [anon_sym_GT] = ACTIONS(5080),
    [anon_sym_LT_EQ] = ACTIONS(5082),
    [anon_sym_GT_EQ] = ACTIONS(5082),
    [anon_sym_LT_LT] = ACTIONS(5084),
    [anon_sym_GT_GT] = ACTIONS(5084),
    [anon_sym_PLUS] = ACTIONS(5086),
    [anon_sym_DASH] = ACTIONS(5086),
    [anon_sym_SLASH] = ACTIONS(5060),
    [anon_sym_PERCENT] = ACTIONS(5060),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3424] = {
    [sym_parameter_list] = STATE(3211),
    [anon_sym_COMMA] = ACTIONS(5889),
    [anon_sym_SEMI] = ACTIONS(5889),
    [anon_sym_LBRACE] = ACTIONS(5889),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(5889),
    [anon_sym_const] = ACTIONS(7689),
    [anon_sym_restrict] = ACTIONS(5889),
    [anon_sym_volatile] = ACTIONS(5889),
    [anon_sym__Atomic] = ACTIONS(5889),
    [anon_sym_mutable] = ACTIONS(5889),
    [anon_sym_explicit] = ACTIONS(5889),
    [anon_sym_constexpr] = ACTIONS(5889),
    [anon_sym_DASH_GT] = ACTIONS(5889),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5889),
    [anon_sym_override] = ACTIONS(5889),
    [sym_noexcept] = ACTIONS(5889),
  },
  [3425] = {
    [sym_type_qualifier] = STATE(3425),
    [aux_sym_type_definition_repeat1] = STATE(3425),
    [anon_sym_COMMA] = ACTIONS(2179),
    [anon_sym_SEMI] = ACTIONS(2179),
    [anon_sym_LBRACE] = ACTIONS(2179),
    [anon_sym_LPAREN2] = ACTIONS(2179),
    [anon_sym_STAR] = ACTIONS(2179),
    [anon_sym_LBRACK] = ACTIONS(2179),
    [anon_sym_EQ] = ACTIONS(2179),
    [anon_sym_const] = ACTIONS(2538),
    [anon_sym_restrict] = ACTIONS(5316),
    [anon_sym_volatile] = ACTIONS(5316),
    [anon_sym__Atomic] = ACTIONS(5316),
    [anon_sym_mutable] = ACTIONS(5316),
    [anon_sym_explicit] = ACTIONS(5316),
    [anon_sym_constexpr] = ACTIONS(5316),
    [anon_sym_AMP] = ACTIONS(2177),
    [anon_sym_AMP_AMP] = ACTIONS(2179),
    [anon_sym_DASH_GT] = ACTIONS(2179),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2179),
    [anon_sym_override] = ACTIONS(2179),
    [sym_noexcept] = ACTIONS(2179),
  },
  [3426] = {
    [sym_type_qualifier] = STATE(3427),
    [sym_trailing_return_type] = STATE(2418),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3427),
    [anon_sym_COMMA] = ACTIONS(5331),
    [anon_sym_SEMI] = ACTIONS(5331),
    [anon_sym_LBRACE] = ACTIONS(5331),
    [anon_sym_LPAREN2] = ACTIONS(5331),
    [anon_sym_LBRACK] = ACTIONS(5331),
    [anon_sym_EQ] = ACTIONS(5331),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(3443),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5331),
    [anon_sym_override] = ACTIONS(5331),
    [sym_noexcept] = ACTIONS(7670),
  },
  [3427] = {
    [sym_type_qualifier] = STATE(3427),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3427),
    [anon_sym_COMMA] = ACTIONS(5351),
    [anon_sym_SEMI] = ACTIONS(5351),
    [anon_sym_LBRACE] = ACTIONS(5351),
    [anon_sym_LPAREN2] = ACTIONS(5351),
    [anon_sym_LBRACK] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_const] = ACTIONS(5353),
    [anon_sym_restrict] = ACTIONS(5356),
    [anon_sym_volatile] = ACTIONS(5356),
    [anon_sym__Atomic] = ACTIONS(5356),
    [anon_sym_mutable] = ACTIONS(5356),
    [anon_sym_explicit] = ACTIONS(5356),
    [anon_sym_constexpr] = ACTIONS(5356),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5351),
    [anon_sym_override] = ACTIONS(5351),
    [sym_noexcept] = ACTIONS(7966),
  },
  [3428] = {
    [sym__abstract_declarator] = STATE(3573),
    [sym_abstract_pointer_declarator] = STATE(3573),
    [sym_abstract_function_declarator] = STATE(3573),
    [sym_abstract_array_declarator] = STATE(3573),
    [sym_type_qualifier] = STATE(3574),
    [sym_parameter_list] = STATE(3431),
    [sym_abstract_reference_declarator] = STATE(3573),
    [aux_sym_type_definition_repeat1] = STATE(3574),
    [anon_sym_COMMA] = ACTIONS(2461),
    [anon_sym_RPAREN] = ACTIONS(2461),
    [anon_sym_LBRACE] = ACTIONS(2461),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(7672),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_EQ] = ACTIONS(2461),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(7674),
    [anon_sym_AMP_AMP] = ACTIONS(7676),
    [anon_sym_DASH_GT] = ACTIONS(2461),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2461),
    [anon_sym_override] = ACTIONS(2461),
    [sym_noexcept] = ACTIONS(2461),
  },
  [3429] = {
    [sym__abstract_declarator] = STATE(3575),
    [sym_abstract_pointer_declarator] = STATE(3575),
    [sym_abstract_function_declarator] = STATE(3575),
    [sym_abstract_array_declarator] = STATE(3575),
    [sym_parameter_list] = STATE(3431),
    [sym_abstract_reference_declarator] = STATE(3575),
    [anon_sym_COMMA] = ACTIONS(2463),
    [anon_sym_RPAREN] = ACTIONS(2463),
    [anon_sym_LBRACE] = ACTIONS(2463),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(7672),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_EQ] = ACTIONS(2463),
    [anon_sym_const] = ACTIONS(6555),
    [anon_sym_restrict] = ACTIONS(2463),
    [anon_sym_volatile] = ACTIONS(2463),
    [anon_sym__Atomic] = ACTIONS(2463),
    [anon_sym_mutable] = ACTIONS(2463),
    [anon_sym_explicit] = ACTIONS(2463),
    [anon_sym_constexpr] = ACTIONS(2463),
    [anon_sym_AMP] = ACTIONS(7674),
    [anon_sym_AMP_AMP] = ACTIONS(7676),
    [anon_sym_DASH_GT] = ACTIONS(2463),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2463),
    [anon_sym_override] = ACTIONS(2463),
    [sym_noexcept] = ACTIONS(2463),
  },
  [3430] = {
    [sym_parameter_list] = STATE(3576),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_RPAREN] = ACTIONS(6557),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(6557),
    [anon_sym_const] = ACTIONS(6559),
    [anon_sym_restrict] = ACTIONS(6557),
    [anon_sym_volatile] = ACTIONS(6557),
    [anon_sym__Atomic] = ACTIONS(6557),
    [anon_sym_mutable] = ACTIONS(6557),
    [anon_sym_explicit] = ACTIONS(6557),
    [anon_sym_constexpr] = ACTIONS(6557),
    [anon_sym_DASH_GT] = ACTIONS(6557),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(6557),
    [anon_sym_override] = ACTIONS(6557),
    [sym_noexcept] = ACTIONS(6557),
  },
  [3431] = {
    [sym_type_qualifier] = STATE(3577),
    [sym_trailing_return_type] = STATE(971),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3577),
    [anon_sym_COMMA] = ACTIONS(1787),
    [anon_sym_RPAREN] = ACTIONS(1787),
    [anon_sym_LBRACE] = ACTIONS(1787),
    [anon_sym_LPAREN2] = ACTIONS(1787),
    [anon_sym_LBRACK] = ACTIONS(1787),
    [anon_sym_EQ] = ACTIONS(1787),
    [anon_sym_const] = ACTIONS(6561),
    [anon_sym_restrict] = ACTIONS(1787),
    [anon_sym_volatile] = ACTIONS(1787),
    [anon_sym__Atomic] = ACTIONS(1787),
    [anon_sym_mutable] = ACTIONS(1787),
    [anon_sym_explicit] = ACTIONS(1787),
    [anon_sym_constexpr] = ACTIONS(1787),
    [anon_sym_DASH_GT] = ACTIONS(1787),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1787),
    [anon_sym_override] = ACTIONS(1787),
    [sym_noexcept] = ACTIONS(1787),
  },
  [3432] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3432),
    [anon_sym_COMMA] = ACTIONS(1985),
    [anon_sym_RPAREN] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(1985),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1985),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_EQ] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1987),
    [anon_sym_restrict] = ACTIONS(1987),
    [anon_sym_volatile] = ACTIONS(1987),
    [anon_sym__Atomic] = ACTIONS(1987),
    [anon_sym_mutable] = ACTIONS(1987),
    [anon_sym_explicit] = ACTIONS(1987),
    [anon_sym_constexpr] = ACTIONS(1987),
    [anon_sym_unsigned] = ACTIONS(7969),
    [anon_sym_long] = ACTIONS(7969),
    [anon_sym_short] = ACTIONS(7969),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_DASH_GT] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1987),
    [anon_sym_override] = ACTIONS(1987),
    [sym_noexcept] = ACTIONS(1987),
  },
  [3433] = {
    [sym__abstract_declarator] = STATE(2900),
    [sym_abstract_pointer_declarator] = STATE(2900),
    [sym_abstract_function_declarator] = STATE(2900),
    [sym_abstract_array_declarator] = STATE(2900),
    [sym_type_qualifier] = STATE(3578),
    [sym_parameter_list] = STATE(1654),
    [sym_abstract_reference_declarator] = STATE(2900),
    [aux_sym_type_definition_repeat1] = STATE(3578),
    [anon_sym_COMMA] = ACTIONS(4157),
    [anon_sym_RPAREN] = ACTIONS(4157),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(7254),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(7256),
    [anon_sym_AMP_AMP] = ACTIONS(7258),
    [sym_comment] = ACTIONS(91),
  },
  [3434] = {
    [sym__expression] = STATE(3579),
    [sym_conditional_expression] = STATE(3579),
    [sym_assignment_expression] = STATE(3579),
    [sym_pointer_expression] = STATE(3579),
    [sym_logical_expression] = STATE(3579),
    [sym_bitwise_expression] = STATE(3579),
    [sym_equality_expression] = STATE(3579),
    [sym_relational_expression] = STATE(3579),
    [sym_shift_expression] = STATE(3579),
    [sym_math_expression] = STATE(3579),
    [sym_cast_expression] = STATE(3579),
    [sym_sizeof_expression] = STATE(3579),
    [sym_subscript_expression] = STATE(3579),
    [sym_call_expression] = STATE(3579),
    [sym_field_expression] = STATE(3579),
    [sym_compound_literal_expression] = STATE(3579),
    [sym_parenthesized_expression] = STATE(3579),
    [sym_char_literal] = STATE(3579),
    [sym_concatenated_string] = STATE(3579),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3579),
    [sym_new_expression] = STATE(3579),
    [sym_delete_expression] = STATE(3579),
    [sym_lambda_expression] = STATE(3579),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7972),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(7972),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7974),
    [sym_false] = ACTIONS(7974),
    [sym_null] = ACTIONS(7974),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(7974),
  },
  [3435] = {
    [anon_sym_LPAREN2] = ACTIONS(7976),
    [sym_comment] = ACTIONS(91),
  },
  [3436] = {
    [sym_compound_statement] = STATE(2466),
    [sym_labeled_statement] = STATE(2466),
    [sym_expression_statement] = STATE(2466),
    [sym_if_statement] = STATE(2466),
    [sym_switch_statement] = STATE(2466),
    [sym_case_statement] = STATE(2466),
    [sym_while_statement] = STATE(2466),
    [sym_do_statement] = STATE(2466),
    [sym_for_statement] = STATE(2466),
    [sym_return_statement] = STATE(2466),
    [sym_break_statement] = STATE(2466),
    [sym_continue_statement] = STATE(2466),
    [sym_goto_statement] = STATE(2466),
    [sym__expression] = STATE(1020),
    [sym_comma_expression] = STATE(1021),
    [sym_conditional_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1020),
    [sym_pointer_expression] = STATE(1020),
    [sym_logical_expression] = STATE(1020),
    [sym_bitwise_expression] = STATE(1020),
    [sym_equality_expression] = STATE(1020),
    [sym_relational_expression] = STATE(1020),
    [sym_shift_expression] = STATE(1020),
    [sym_math_expression] = STATE(1020),
    [sym_cast_expression] = STATE(1020),
    [sym_sizeof_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_field_expression] = STATE(1020),
    [sym_compound_literal_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_char_literal] = STATE(1020),
    [sym_concatenated_string] = STATE(1020),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1020),
    [sym_for_range_loop] = STATE(2466),
    [sym_try_statement] = STATE(2466),
    [sym_new_expression] = STATE(1020),
    [sym_delete_expression] = STATE(1020),
    [sym_lambda_expression] = STATE(1020),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2022),
    [anon_sym_SEMI] = ACTIONS(2036),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7300),
    [anon_sym_switch] = ACTIONS(7302),
    [anon_sym_case] = ACTIONS(7304),
    [anon_sym_default] = ACTIONS(7306),
    [anon_sym_while] = ACTIONS(7308),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(7310),
    [anon_sym_return] = ACTIONS(2058),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2062),
    [anon_sym_goto] = ACTIONS(2064),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(7312),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7314),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2066),
  },
  [3437] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_COLON] = ACTIONS(7978),
    [anon_sym_QMARK] = ACTIONS(1171),
    [anon_sym_STAR_EQ] = ACTIONS(1173),
    [anon_sym_SLASH_EQ] = ACTIONS(1173),
    [anon_sym_PERCENT_EQ] = ACTIONS(1173),
    [anon_sym_PLUS_EQ] = ACTIONS(1173),
    [anon_sym_DASH_EQ] = ACTIONS(1173),
    [anon_sym_LT_LT_EQ] = ACTIONS(1173),
    [anon_sym_GT_GT_EQ] = ACTIONS(1173),
    [anon_sym_AMP_EQ] = ACTIONS(1173),
    [anon_sym_CARET_EQ] = ACTIONS(1173),
    [anon_sym_PIPE_EQ] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_CARET] = ACTIONS(1183),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [3438] = {
    [sym_declaration] = STATE(2469),
    [sym_type_definition] = STATE(2469),
    [sym__declaration_specifiers] = STATE(2470),
    [sym_compound_statement] = STATE(2469),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_labeled_statement] = STATE(2469),
    [sym_expression_statement] = STATE(2469),
    [sym_if_statement] = STATE(2469),
    [sym_switch_statement] = STATE(2469),
    [sym_case_statement] = STATE(2469),
    [sym_while_statement] = STATE(2469),
    [sym_do_statement] = STATE(2469),
    [sym_for_statement] = STATE(2469),
    [sym_return_statement] = STATE(2469),
    [sym_break_statement] = STATE(2469),
    [sym_continue_statement] = STATE(2469),
    [sym_goto_statement] = STATE(2469),
    [sym__expression] = STATE(1020),
    [sym_comma_expression] = STATE(1021),
    [sym_conditional_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1020),
    [sym_pointer_expression] = STATE(1020),
    [sym_logical_expression] = STATE(1020),
    [sym_bitwise_expression] = STATE(1020),
    [sym_equality_expression] = STATE(1020),
    [sym_relational_expression] = STATE(1020),
    [sym_shift_expression] = STATE(1020),
    [sym_math_expression] = STATE(1020),
    [sym_cast_expression] = STATE(1020),
    [sym_sizeof_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_field_expression] = STATE(1020),
    [sym_compound_literal_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_char_literal] = STATE(1020),
    [sym_concatenated_string] = STATE(1020),
    [sym_string_literal] = STATE(55),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(1020),
    [sym_for_range_loop] = STATE(2469),
    [sym_try_statement] = STATE(2469),
    [sym_new_expression] = STATE(1020),
    [sym_delete_expression] = STATE(1020),
    [sym_lambda_expression] = STATE(1020),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(2022),
    [anon_sym_SEMI] = ACTIONS(2036),
    [anon_sym_typedef] = ACTIONS(2038),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(7300),
    [anon_sym_switch] = ACTIONS(7302),
    [anon_sym_case] = ACTIONS(7304),
    [anon_sym_default] = ACTIONS(7306),
    [anon_sym_while] = ACTIONS(7308),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(7310),
    [anon_sym_return] = ACTIONS(2058),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2062),
    [anon_sym_goto] = ACTIONS(2064),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(7980),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7314),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(1202),
    [sym_nullptr] = ACTIONS(2066),
  },
  [3439] = {
    [sym_compound_statement] = STATE(2471),
    [sym_labeled_statement] = STATE(2471),
    [sym_expression_statement] = STATE(2471),
    [sym_if_statement] = STATE(2471),
    [sym_switch_statement] = STATE(2471),
    [sym_case_statement] = STATE(2471),
    [sym_while_statement] = STATE(2471),
    [sym_do_statement] = STATE(2471),
    [sym_for_statement] = STATE(2471),
    [sym_return_statement] = STATE(2471),
    [sym_break_statement] = STATE(2471),
    [sym_continue_statement] = STATE(2471),
    [sym_goto_statement] = STATE(2471),
    [sym__expression] = STATE(1020),
    [sym_comma_expression] = STATE(1021),
    [sym_conditional_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1020),
    [sym_pointer_expression] = STATE(1020),
    [sym_logical_expression] = STATE(1020),
    [sym_bitwise_expression] = STATE(1020),
    [sym_equality_expression] = STATE(1020),
    [sym_relational_expression] = STATE(1020),
    [sym_shift_expression] = STATE(1020),
    [sym_math_expression] = STATE(1020),
    [sym_cast_expression] = STATE(1020),
    [sym_sizeof_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_field_expression] = STATE(1020),
    [sym_compound_literal_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_char_literal] = STATE(1020),
    [sym_concatenated_string] = STATE(1020),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1020),
    [sym_for_range_loop] = STATE(2471),
    [sym_try_statement] = STATE(2471),
    [sym_new_expression] = STATE(1020),
    [sym_delete_expression] = STATE(1020),
    [sym_lambda_expression] = STATE(1020),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2022),
    [anon_sym_SEMI] = ACTIONS(2036),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7300),
    [anon_sym_switch] = ACTIONS(7302),
    [anon_sym_case] = ACTIONS(7304),
    [anon_sym_default] = ACTIONS(7306),
    [anon_sym_while] = ACTIONS(7308),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(7310),
    [anon_sym_return] = ACTIONS(2058),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2062),
    [anon_sym_goto] = ACTIONS(2064),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(7312),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7314),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2066),
  },
  [3440] = {
    [sym_declaration] = STATE(3583),
    [sym__declaration_specifiers] = STATE(709),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym__expression] = STATE(3584),
    [sym_conditional_expression] = STATE(3584),
    [sym_assignment_expression] = STATE(3584),
    [sym_pointer_expression] = STATE(3584),
    [sym_logical_expression] = STATE(3584),
    [sym_bitwise_expression] = STATE(3584),
    [sym_equality_expression] = STATE(3584),
    [sym_relational_expression] = STATE(3584),
    [sym_shift_expression] = STATE(3584),
    [sym_math_expression] = STATE(3584),
    [sym_cast_expression] = STATE(3584),
    [sym_sizeof_expression] = STATE(3584),
    [sym_subscript_expression] = STATE(3584),
    [sym_call_expression] = STATE(3584),
    [sym_field_expression] = STATE(3584),
    [sym_compound_literal_expression] = STATE(3584),
    [sym_parenthesized_expression] = STATE(3584),
    [sym_char_literal] = STATE(3584),
    [sym_concatenated_string] = STATE(3584),
    [sym_string_literal] = STATE(238),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(3584),
    [sym_for_range_declaration] = STATE(3585),
    [sym_new_expression] = STATE(3584),
    [sym_delete_expression] = STATE(3584),
    [sym_lambda_expression] = STATE(3584),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(7982),
    [anon_sym_SEMI] = ACTIONS(7984),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(7982),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7986),
    [sym_false] = ACTIONS(7986),
    [sym_null] = ACTIONS(7986),
    [sym_identifier] = ACTIONS(1242),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(1244),
    [sym_nullptr] = ACTIONS(7986),
  },
  [3441] = {
    [sym_compound_statement] = STATE(2478),
    [sym_labeled_statement] = STATE(2478),
    [sym_expression_statement] = STATE(2478),
    [sym_if_statement] = STATE(2478),
    [sym_switch_statement] = STATE(2478),
    [sym_case_statement] = STATE(2478),
    [sym_while_statement] = STATE(2478),
    [sym_do_statement] = STATE(2478),
    [sym_for_statement] = STATE(2478),
    [sym_return_statement] = STATE(2478),
    [sym_break_statement] = STATE(2478),
    [sym_continue_statement] = STATE(2478),
    [sym_goto_statement] = STATE(2478),
    [sym__expression] = STATE(1020),
    [sym_comma_expression] = STATE(1021),
    [sym_conditional_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1020),
    [sym_pointer_expression] = STATE(1020),
    [sym_logical_expression] = STATE(1020),
    [sym_bitwise_expression] = STATE(1020),
    [sym_equality_expression] = STATE(1020),
    [sym_relational_expression] = STATE(1020),
    [sym_shift_expression] = STATE(1020),
    [sym_math_expression] = STATE(1020),
    [sym_cast_expression] = STATE(1020),
    [sym_sizeof_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_field_expression] = STATE(1020),
    [sym_compound_literal_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_char_literal] = STATE(1020),
    [sym_concatenated_string] = STATE(1020),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1020),
    [sym_for_range_loop] = STATE(2478),
    [sym_try_statement] = STATE(2478),
    [sym_new_expression] = STATE(1020),
    [sym_delete_expression] = STATE(1020),
    [sym_lambda_expression] = STATE(1020),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2022),
    [anon_sym_SEMI] = ACTIONS(2036),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7300),
    [anon_sym_switch] = ACTIONS(7302),
    [anon_sym_case] = ACTIONS(7304),
    [anon_sym_default] = ACTIONS(7306),
    [anon_sym_while] = ACTIONS(7308),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(7310),
    [anon_sym_return] = ACTIONS(2058),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2062),
    [anon_sym_goto] = ACTIONS(2064),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(7312),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7314),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2066),
  },
  [3442] = {
    [sym_catch_clause] = STATE(3586),
    [aux_sym_try_statement_repeat1] = STATE(3586),
    [sym_comment] = ACTIONS(91),
    [anon_sym_catch] = ACTIONS(5450),
  },
  [3443] = {
    [sym_compound_statement] = STATE(3587),
    [sym_labeled_statement] = STATE(3587),
    [sym_expression_statement] = STATE(3587),
    [sym_if_statement] = STATE(3587),
    [sym_switch_statement] = STATE(3587),
    [sym_case_statement] = STATE(3587),
    [sym_while_statement] = STATE(3587),
    [sym_do_statement] = STATE(3587),
    [sym_for_statement] = STATE(3587),
    [sym_return_statement] = STATE(3587),
    [sym_break_statement] = STATE(3587),
    [sym_continue_statement] = STATE(3587),
    [sym_goto_statement] = STATE(3587),
    [sym__expression] = STATE(1020),
    [sym_comma_expression] = STATE(1021),
    [sym_conditional_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1020),
    [sym_pointer_expression] = STATE(1020),
    [sym_logical_expression] = STATE(1020),
    [sym_bitwise_expression] = STATE(1020),
    [sym_equality_expression] = STATE(1020),
    [sym_relational_expression] = STATE(1020),
    [sym_shift_expression] = STATE(1020),
    [sym_math_expression] = STATE(1020),
    [sym_cast_expression] = STATE(1020),
    [sym_sizeof_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_field_expression] = STATE(1020),
    [sym_compound_literal_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_char_literal] = STATE(1020),
    [sym_concatenated_string] = STATE(1020),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1020),
    [sym_for_range_loop] = STATE(3587),
    [sym_try_statement] = STATE(3587),
    [sym_new_expression] = STATE(1020),
    [sym_delete_expression] = STATE(1020),
    [sym_lambda_expression] = STATE(1020),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2022),
    [anon_sym_SEMI] = ACTIONS(2036),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(2044),
    [anon_sym_switch] = ACTIONS(2046),
    [anon_sym_case] = ACTIONS(2048),
    [anon_sym_default] = ACTIONS(2050),
    [anon_sym_while] = ACTIONS(2052),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(2056),
    [anon_sym_return] = ACTIONS(2058),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2062),
    [anon_sym_goto] = ACTIONS(2064),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(5420),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2076),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2066),
  },
  [3444] = {
    [sym_raw_string_literal] = ACTIONS(7063),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7065),
    [sym_preproc_directive] = ACTIONS(7065),
    [anon_sym_SEMI] = ACTIONS(7063),
    [anon_sym_typedef] = ACTIONS(7065),
    [anon_sym_extern] = ACTIONS(7065),
    [anon_sym_LBRACE] = ACTIONS(7063),
    [anon_sym_LPAREN2] = ACTIONS(7063),
    [anon_sym_STAR] = ACTIONS(7063),
    [anon_sym_LBRACK] = ACTIONS(7063),
    [anon_sym_static] = ACTIONS(7065),
    [anon_sym_register] = ACTIONS(7065),
    [anon_sym_inline] = ACTIONS(7065),
    [anon_sym_const] = ACTIONS(7065),
    [anon_sym_restrict] = ACTIONS(7065),
    [anon_sym_volatile] = ACTIONS(7065),
    [anon_sym__Atomic] = ACTIONS(7065),
    [anon_sym_mutable] = ACTIONS(7065),
    [anon_sym_explicit] = ACTIONS(7065),
    [anon_sym_constexpr] = ACTIONS(7065),
    [anon_sym_unsigned] = ACTIONS(7065),
    [anon_sym_long] = ACTIONS(7065),
    [anon_sym_short] = ACTIONS(7065),
    [sym_primitive_type] = ACTIONS(7065),
    [anon_sym_enum] = ACTIONS(7065),
    [anon_sym_struct] = ACTIONS(7065),
    [anon_sym_union] = ACTIONS(7065),
    [anon_sym_if] = ACTIONS(7065),
    [anon_sym_else] = ACTIONS(7988),
    [anon_sym_switch] = ACTIONS(7065),
    [anon_sym_case] = ACTIONS(7065),
    [anon_sym_default] = ACTIONS(7065),
    [anon_sym_while] = ACTIONS(7065),
    [anon_sym_do] = ACTIONS(7065),
    [anon_sym_for] = ACTIONS(7065),
    [anon_sym_return] = ACTIONS(7065),
    [anon_sym_break] = ACTIONS(7065),
    [anon_sym_continue] = ACTIONS(7065),
    [anon_sym_goto] = ACTIONS(7065),
    [anon_sym_AMP] = ACTIONS(7065),
    [anon_sym_AMP_AMP] = ACTIONS(7063),
    [anon_sym_BANG] = ACTIONS(7063),
    [anon_sym_TILDE] = ACTIONS(7063),
    [anon_sym_PLUS] = ACTIONS(7065),
    [anon_sym_DASH] = ACTIONS(7065),
    [anon_sym_DASH_DASH] = ACTIONS(7063),
    [anon_sym_PLUS_PLUS] = ACTIONS(7063),
    [anon_sym_sizeof] = ACTIONS(7065),
    [sym_number_literal] = ACTIONS(7063),
    [anon_sym_SQUOTE] = ACTIONS(7063),
    [anon_sym_DQUOTE] = ACTIONS(7063),
    [sym_true] = ACTIONS(7065),
    [sym_false] = ACTIONS(7065),
    [sym_null] = ACTIONS(7065),
    [sym_identifier] = ACTIONS(7065),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7065),
    [sym_auto] = ACTIONS(7065),
    [anon_sym_typename] = ACTIONS(7065),
    [anon_sym_template] = ACTIONS(7065),
    [anon_sym_delete] = ACTIONS(7065),
    [anon_sym_namespace] = ACTIONS(7065),
    [anon_sym_using] = ACTIONS(7065),
    [anon_sym_try] = ACTIONS(7065),
    [anon_sym_new] = ACTIONS(7065),
    [anon_sym_COLON_COLON] = ACTIONS(7063),
    [sym_operator_name] = ACTIONS(7063),
    [sym_nullptr] = ACTIONS(7065),
  },
  [3445] = {
    [sym_raw_string_literal] = ACTIONS(2475),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2477),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2477),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2477),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2477),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2477),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2477),
    [sym_preproc_directive] = ACTIONS(2477),
    [anon_sym_SEMI] = ACTIONS(2475),
    [anon_sym_typedef] = ACTIONS(2477),
    [anon_sym_extern] = ACTIONS(2477),
    [anon_sym_LBRACE] = ACTIONS(2475),
    [anon_sym_LPAREN2] = ACTIONS(2475),
    [anon_sym_STAR] = ACTIONS(2475),
    [anon_sym_LBRACK] = ACTIONS(2475),
    [anon_sym_static] = ACTIONS(2477),
    [anon_sym_register] = ACTIONS(2477),
    [anon_sym_inline] = ACTIONS(2477),
    [anon_sym_const] = ACTIONS(2477),
    [anon_sym_restrict] = ACTIONS(2477),
    [anon_sym_volatile] = ACTIONS(2477),
    [anon_sym__Atomic] = ACTIONS(2477),
    [anon_sym_mutable] = ACTIONS(2477),
    [anon_sym_explicit] = ACTIONS(2477),
    [anon_sym_constexpr] = ACTIONS(2477),
    [anon_sym_unsigned] = ACTIONS(2477),
    [anon_sym_long] = ACTIONS(2477),
    [anon_sym_short] = ACTIONS(2477),
    [sym_primitive_type] = ACTIONS(2477),
    [anon_sym_enum] = ACTIONS(2477),
    [anon_sym_struct] = ACTIONS(2477),
    [anon_sym_union] = ACTIONS(2477),
    [anon_sym_if] = ACTIONS(2477),
    [anon_sym_else] = ACTIONS(2477),
    [anon_sym_switch] = ACTIONS(2477),
    [anon_sym_case] = ACTIONS(2477),
    [anon_sym_default] = ACTIONS(2477),
    [anon_sym_while] = ACTIONS(2477),
    [anon_sym_do] = ACTIONS(2477),
    [anon_sym_for] = ACTIONS(2477),
    [anon_sym_return] = ACTIONS(2477),
    [anon_sym_break] = ACTIONS(2477),
    [anon_sym_continue] = ACTIONS(2477),
    [anon_sym_goto] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2477),
    [anon_sym_AMP_AMP] = ACTIONS(2475),
    [anon_sym_BANG] = ACTIONS(2475),
    [anon_sym_TILDE] = ACTIONS(2475),
    [anon_sym_PLUS] = ACTIONS(2477),
    [anon_sym_DASH] = ACTIONS(2477),
    [anon_sym_DASH_DASH] = ACTIONS(2475),
    [anon_sym_PLUS_PLUS] = ACTIONS(2475),
    [anon_sym_sizeof] = ACTIONS(2477),
    [sym_number_literal] = ACTIONS(2475),
    [anon_sym_SQUOTE] = ACTIONS(2475),
    [anon_sym_DQUOTE] = ACTIONS(2475),
    [sym_true] = ACTIONS(2477),
    [sym_false] = ACTIONS(2477),
    [sym_null] = ACTIONS(2477),
    [sym_identifier] = ACTIONS(2477),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2477),
    [sym_auto] = ACTIONS(2477),
    [anon_sym_typename] = ACTIONS(2477),
    [anon_sym_template] = ACTIONS(2477),
    [anon_sym_delete] = ACTIONS(2477),
    [anon_sym_namespace] = ACTIONS(2477),
    [anon_sym_using] = ACTIONS(2477),
    [anon_sym_try] = ACTIONS(2477),
    [anon_sym_new] = ACTIONS(2477),
    [anon_sym_COLON_COLON] = ACTIONS(2475),
    [sym_operator_name] = ACTIONS(2475),
    [sym_nullptr] = ACTIONS(2477),
  },
  [3446] = {
    [sym_raw_string_literal] = ACTIONS(7095),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7097),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7097),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7097),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7097),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7097),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7097),
    [sym_preproc_directive] = ACTIONS(7097),
    [anon_sym_SEMI] = ACTIONS(7095),
    [anon_sym_typedef] = ACTIONS(7097),
    [anon_sym_extern] = ACTIONS(7097),
    [anon_sym_LBRACE] = ACTIONS(7095),
    [anon_sym_LPAREN2] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7095),
    [anon_sym_LBRACK] = ACTIONS(7095),
    [anon_sym_static] = ACTIONS(7097),
    [anon_sym_register] = ACTIONS(7097),
    [anon_sym_inline] = ACTIONS(7097),
    [anon_sym_const] = ACTIONS(7097),
    [anon_sym_restrict] = ACTIONS(7097),
    [anon_sym_volatile] = ACTIONS(7097),
    [anon_sym__Atomic] = ACTIONS(7097),
    [anon_sym_mutable] = ACTIONS(7097),
    [anon_sym_explicit] = ACTIONS(7097),
    [anon_sym_constexpr] = ACTIONS(7097),
    [anon_sym_unsigned] = ACTIONS(7097),
    [anon_sym_long] = ACTIONS(7097),
    [anon_sym_short] = ACTIONS(7097),
    [sym_primitive_type] = ACTIONS(7097),
    [anon_sym_enum] = ACTIONS(7097),
    [anon_sym_struct] = ACTIONS(7097),
    [anon_sym_union] = ACTIONS(7097),
    [anon_sym_if] = ACTIONS(7097),
    [anon_sym_else] = ACTIONS(7097),
    [anon_sym_switch] = ACTIONS(7097),
    [anon_sym_case] = ACTIONS(7097),
    [anon_sym_default] = ACTIONS(7097),
    [anon_sym_while] = ACTIONS(7097),
    [anon_sym_do] = ACTIONS(7097),
    [anon_sym_for] = ACTIONS(7097),
    [anon_sym_return] = ACTIONS(7097),
    [anon_sym_break] = ACTIONS(7097),
    [anon_sym_continue] = ACTIONS(7097),
    [anon_sym_goto] = ACTIONS(7097),
    [anon_sym_AMP] = ACTIONS(7097),
    [anon_sym_AMP_AMP] = ACTIONS(7095),
    [anon_sym_BANG] = ACTIONS(7095),
    [anon_sym_TILDE] = ACTIONS(7095),
    [anon_sym_PLUS] = ACTIONS(7097),
    [anon_sym_DASH] = ACTIONS(7097),
    [anon_sym_DASH_DASH] = ACTIONS(7095),
    [anon_sym_PLUS_PLUS] = ACTIONS(7095),
    [anon_sym_sizeof] = ACTIONS(7097),
    [sym_number_literal] = ACTIONS(7095),
    [anon_sym_SQUOTE] = ACTIONS(7095),
    [anon_sym_DQUOTE] = ACTIONS(7095),
    [sym_true] = ACTIONS(7097),
    [sym_false] = ACTIONS(7097),
    [sym_null] = ACTIONS(7097),
    [sym_identifier] = ACTIONS(7097),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7097),
    [sym_auto] = ACTIONS(7097),
    [anon_sym_typename] = ACTIONS(7097),
    [anon_sym_template] = ACTIONS(7097),
    [anon_sym_delete] = ACTIONS(7097),
    [anon_sym_namespace] = ACTIONS(7097),
    [anon_sym_using] = ACTIONS(7097),
    [anon_sym_try] = ACTIONS(7097),
    [anon_sym_new] = ACTIONS(7097),
    [anon_sym_COLON_COLON] = ACTIONS(7095),
    [sym_operator_name] = ACTIONS(7095),
    [sym_nullptr] = ACTIONS(7097),
  },
  [3447] = {
    [sym_compound_statement] = STATE(3589),
    [sym_labeled_statement] = STATE(3589),
    [sym_expression_statement] = STATE(3589),
    [sym_if_statement] = STATE(3589),
    [sym_switch_statement] = STATE(3589),
    [sym_case_statement] = STATE(3589),
    [sym_while_statement] = STATE(3589),
    [sym_do_statement] = STATE(3589),
    [sym_for_statement] = STATE(3589),
    [sym_return_statement] = STATE(3589),
    [sym_break_statement] = STATE(3589),
    [sym_continue_statement] = STATE(3589),
    [sym_goto_statement] = STATE(3589),
    [sym__expression] = STATE(1020),
    [sym_comma_expression] = STATE(1021),
    [sym_conditional_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1020),
    [sym_pointer_expression] = STATE(1020),
    [sym_logical_expression] = STATE(1020),
    [sym_bitwise_expression] = STATE(1020),
    [sym_equality_expression] = STATE(1020),
    [sym_relational_expression] = STATE(1020),
    [sym_shift_expression] = STATE(1020),
    [sym_math_expression] = STATE(1020),
    [sym_cast_expression] = STATE(1020),
    [sym_sizeof_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_field_expression] = STATE(1020),
    [sym_compound_literal_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_char_literal] = STATE(1020),
    [sym_concatenated_string] = STATE(1020),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1020),
    [sym_for_range_loop] = STATE(3589),
    [sym_try_statement] = STATE(3589),
    [sym_new_expression] = STATE(1020),
    [sym_delete_expression] = STATE(1020),
    [sym_lambda_expression] = STATE(1020),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2022),
    [anon_sym_SEMI] = ACTIONS(2036),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(2044),
    [anon_sym_switch] = ACTIONS(2046),
    [anon_sym_case] = ACTIONS(2048),
    [anon_sym_default] = ACTIONS(2050),
    [anon_sym_while] = ACTIONS(2052),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(2056),
    [anon_sym_return] = ACTIONS(2058),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2062),
    [anon_sym_goto] = ACTIONS(2064),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(5420),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2076),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2066),
  },
  [3448] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(7990),
    [sym_comment] = ACTIONS(91),
  },
  [3449] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3591),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(7990),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3450] = {
    [sym__expression] = STATE(3592),
    [sym_conditional_expression] = STATE(3592),
    [sym_assignment_expression] = STATE(3592),
    [sym_pointer_expression] = STATE(3592),
    [sym_logical_expression] = STATE(3592),
    [sym_bitwise_expression] = STATE(3592),
    [sym_equality_expression] = STATE(3592),
    [sym_relational_expression] = STATE(3592),
    [sym_shift_expression] = STATE(3592),
    [sym_math_expression] = STATE(3592),
    [sym_cast_expression] = STATE(3592),
    [sym_sizeof_expression] = STATE(3592),
    [sym_subscript_expression] = STATE(3592),
    [sym_call_expression] = STATE(3592),
    [sym_field_expression] = STATE(3592),
    [sym_compound_literal_expression] = STATE(3592),
    [sym_parenthesized_expression] = STATE(3592),
    [sym_char_literal] = STATE(3592),
    [sym_concatenated_string] = STATE(3592),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3592),
    [sym_new_expression] = STATE(3592),
    [sym_delete_expression] = STATE(3592),
    [sym_lambda_expression] = STATE(3592),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7992),
    [anon_sym_RPAREN] = ACTIONS(7990),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(7992),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(7994),
    [sym_false] = ACTIONS(7994),
    [sym_null] = ACTIONS(7994),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(7994),
  },
  [3451] = {
    [sym_compound_statement] = STATE(3593),
    [sym_labeled_statement] = STATE(3593),
    [sym_expression_statement] = STATE(3593),
    [sym_if_statement] = STATE(3593),
    [sym_switch_statement] = STATE(3593),
    [sym_case_statement] = STATE(3593),
    [sym_while_statement] = STATE(3593),
    [sym_do_statement] = STATE(3593),
    [sym_for_statement] = STATE(3593),
    [sym_return_statement] = STATE(3593),
    [sym_break_statement] = STATE(3593),
    [sym_continue_statement] = STATE(3593),
    [sym_goto_statement] = STATE(3593),
    [sym__expression] = STATE(1020),
    [sym_comma_expression] = STATE(1021),
    [sym_conditional_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1020),
    [sym_pointer_expression] = STATE(1020),
    [sym_logical_expression] = STATE(1020),
    [sym_bitwise_expression] = STATE(1020),
    [sym_equality_expression] = STATE(1020),
    [sym_relational_expression] = STATE(1020),
    [sym_shift_expression] = STATE(1020),
    [sym_math_expression] = STATE(1020),
    [sym_cast_expression] = STATE(1020),
    [sym_sizeof_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_field_expression] = STATE(1020),
    [sym_compound_literal_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_char_literal] = STATE(1020),
    [sym_concatenated_string] = STATE(1020),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1020),
    [sym_for_range_loop] = STATE(3593),
    [sym_try_statement] = STATE(3593),
    [sym_new_expression] = STATE(1020),
    [sym_delete_expression] = STATE(1020),
    [sym_lambda_expression] = STATE(1020),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2022),
    [anon_sym_SEMI] = ACTIONS(2036),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(2044),
    [anon_sym_switch] = ACTIONS(2046),
    [anon_sym_case] = ACTIONS(2048),
    [anon_sym_default] = ACTIONS(2050),
    [anon_sym_while] = ACTIONS(2052),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(2056),
    [anon_sym_return] = ACTIONS(2058),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2062),
    [anon_sym_goto] = ACTIONS(2064),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(5420),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2076),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2066),
  },
  [3452] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(7996),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3453] = {
    [sym__expression] = STATE(3595),
    [sym_conditional_expression] = STATE(3595),
    [sym_assignment_expression] = STATE(3595),
    [sym_pointer_expression] = STATE(3595),
    [sym_logical_expression] = STATE(3595),
    [sym_bitwise_expression] = STATE(3595),
    [sym_equality_expression] = STATE(3595),
    [sym_relational_expression] = STATE(3595),
    [sym_shift_expression] = STATE(3595),
    [sym_math_expression] = STATE(3595),
    [sym_cast_expression] = STATE(3595),
    [sym_sizeof_expression] = STATE(3595),
    [sym_subscript_expression] = STATE(3595),
    [sym_call_expression] = STATE(3595),
    [sym_field_expression] = STATE(3595),
    [sym_compound_literal_expression] = STATE(3595),
    [sym_parenthesized_expression] = STATE(3595),
    [sym_char_literal] = STATE(3595),
    [sym_concatenated_string] = STATE(3595),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3595),
    [sym_new_expression] = STATE(3595),
    [sym_delete_expression] = STATE(3595),
    [sym_lambda_expression] = STATE(3595),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(7998),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(7998),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8000),
    [sym_false] = ACTIONS(8000),
    [sym_null] = ACTIONS(8000),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(8000),
  },
  [3454] = {
    [sym_declaration] = STATE(2507),
    [sym_type_definition] = STATE(2507),
    [sym__declaration_specifiers] = STATE(1814),
    [sym_compound_statement] = STATE(2507),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_labeled_statement] = STATE(2507),
    [sym_expression_statement] = STATE(2507),
    [sym_if_statement] = STATE(2507),
    [sym_switch_statement] = STATE(2507),
    [sym_case_statement] = STATE(2507),
    [sym_while_statement] = STATE(2507),
    [sym_do_statement] = STATE(2507),
    [sym_for_statement] = STATE(2507),
    [sym_return_statement] = STATE(2507),
    [sym_break_statement] = STATE(2507),
    [sym_continue_statement] = STATE(2507),
    [sym_goto_statement] = STATE(2507),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(411),
    [sym_for_range_loop] = STATE(2507),
    [sym_try_statement] = STATE(2507),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(678),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_typedef] = ACTIONS(698),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(6682),
    [anon_sym_switch] = ACTIONS(6684),
    [anon_sym_case] = ACTIONS(6686),
    [anon_sym_default] = ACTIONS(6688),
    [anon_sym_while] = ACTIONS(6690),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(6692),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(7742),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(6696),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(1202),
    [sym_nullptr] = ACTIONS(726),
  },
  [3455] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(1362),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_extern] = ACTIONS(468),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(465),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_register] = ACTIONS(468),
    [anon_sym_inline] = ACTIONS(468),
    [anon_sym_const] = ACTIONS(468),
    [anon_sym_restrict] = ACTIONS(468),
    [anon_sym_volatile] = ACTIONS(468),
    [anon_sym__Atomic] = ACTIONS(468),
    [anon_sym_mutable] = ACTIONS(468),
    [anon_sym_explicit] = ACTIONS(468),
    [anon_sym_constexpr] = ACTIONS(468),
    [anon_sym_COLON] = ACTIONS(7357),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(474),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_TILDE] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_identifier] = ACTIONS(468),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(2855),
    [sym_operator_name] = ACTIONS(481),
  },
  [3456] = {
    [sym__expression] = STATE(3597),
    [sym_conditional_expression] = STATE(3597),
    [sym_assignment_expression] = STATE(3597),
    [sym_pointer_expression] = STATE(3597),
    [sym_logical_expression] = STATE(3597),
    [sym_bitwise_expression] = STATE(3597),
    [sym_equality_expression] = STATE(3597),
    [sym_relational_expression] = STATE(3597),
    [sym_shift_expression] = STATE(3597),
    [sym_math_expression] = STATE(3597),
    [sym_cast_expression] = STATE(3597),
    [sym_sizeof_expression] = STATE(3597),
    [sym_subscript_expression] = STATE(3597),
    [sym_call_expression] = STATE(3597),
    [sym_field_expression] = STATE(3597),
    [sym_compound_literal_expression] = STATE(3597),
    [sym_parenthesized_expression] = STATE(3597),
    [sym_char_literal] = STATE(3597),
    [sym_concatenated_string] = STATE(3597),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3597),
    [sym_new_expression] = STATE(3597),
    [sym_delete_expression] = STATE(3597),
    [sym_lambda_expression] = STATE(3597),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8002),
    [anon_sym_SEMI] = ACTIONS(8004),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(8002),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8006),
    [sym_false] = ACTIONS(8006),
    [sym_null] = ACTIONS(8006),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(8006),
  },
  [3457] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(8008),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3458] = {
    [anon_sym_COLON] = ACTIONS(8010),
    [sym_comment] = ACTIONS(91),
  },
  [3459] = {
    [sym_catch_clause] = STATE(3600),
    [aux_sym_try_statement_repeat1] = STATE(3600),
    [sym_raw_string_literal] = ACTIONS(3346),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3348),
    [sym_preproc_directive] = ACTIONS(3348),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym_typedef] = ACTIONS(3348),
    [anon_sym_extern] = ACTIONS(3348),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(3346),
    [anon_sym_static] = ACTIONS(3348),
    [anon_sym_register] = ACTIONS(3348),
    [anon_sym_inline] = ACTIONS(3348),
    [anon_sym_const] = ACTIONS(3348),
    [anon_sym_restrict] = ACTIONS(3348),
    [anon_sym_volatile] = ACTIONS(3348),
    [anon_sym__Atomic] = ACTIONS(3348),
    [anon_sym_mutable] = ACTIONS(3348),
    [anon_sym_explicit] = ACTIONS(3348),
    [anon_sym_constexpr] = ACTIONS(3348),
    [anon_sym_unsigned] = ACTIONS(3348),
    [anon_sym_long] = ACTIONS(3348),
    [anon_sym_short] = ACTIONS(3348),
    [sym_primitive_type] = ACTIONS(3348),
    [anon_sym_enum] = ACTIONS(3348),
    [anon_sym_struct] = ACTIONS(3348),
    [anon_sym_union] = ACTIONS(3348),
    [anon_sym_if] = ACTIONS(3348),
    [anon_sym_else] = ACTIONS(3348),
    [anon_sym_switch] = ACTIONS(3348),
    [anon_sym_case] = ACTIONS(3348),
    [anon_sym_default] = ACTIONS(3348),
    [anon_sym_while] = ACTIONS(3348),
    [anon_sym_do] = ACTIONS(3348),
    [anon_sym_for] = ACTIONS(3348),
    [anon_sym_return] = ACTIONS(3348),
    [anon_sym_break] = ACTIONS(3348),
    [anon_sym_continue] = ACTIONS(3348),
    [anon_sym_goto] = ACTIONS(3348),
    [anon_sym_AMP] = ACTIONS(3348),
    [anon_sym_AMP_AMP] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_PLUS] = ACTIONS(3348),
    [anon_sym_DASH] = ACTIONS(3348),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_sizeof] = ACTIONS(3348),
    [sym_number_literal] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [sym_true] = ACTIONS(3348),
    [sym_false] = ACTIONS(3348),
    [sym_null] = ACTIONS(3348),
    [sym_identifier] = ACTIONS(3348),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3348),
    [sym_auto] = ACTIONS(3348),
    [anon_sym_typename] = ACTIONS(3348),
    [anon_sym_template] = ACTIONS(3348),
    [anon_sym_delete] = ACTIONS(3348),
    [anon_sym_namespace] = ACTIONS(3348),
    [anon_sym_using] = ACTIONS(3348),
    [anon_sym_try] = ACTIONS(3348),
    [anon_sym_catch] = ACTIONS(5575),
    [anon_sym_new] = ACTIONS(3348),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [sym_operator_name] = ACTIONS(3346),
    [sym_nullptr] = ACTIONS(3348),
  },
  [3460] = {
    [sym_raw_string_literal] = ACTIONS(7561),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7563),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7563),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7563),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7563),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7563),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7563),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7563),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7563),
    [sym_preproc_directive] = ACTIONS(7563),
    [anon_sym_SEMI] = ACTIONS(7561),
    [anon_sym_typedef] = ACTIONS(7563),
    [anon_sym_extern] = ACTIONS(7563),
    [anon_sym_LBRACE] = ACTIONS(7561),
    [anon_sym_LPAREN2] = ACTIONS(7561),
    [anon_sym_STAR] = ACTIONS(7561),
    [anon_sym_LBRACK] = ACTIONS(7561),
    [anon_sym_static] = ACTIONS(7563),
    [anon_sym_register] = ACTIONS(7563),
    [anon_sym_inline] = ACTIONS(7563),
    [anon_sym_const] = ACTIONS(7563),
    [anon_sym_restrict] = ACTIONS(7563),
    [anon_sym_volatile] = ACTIONS(7563),
    [anon_sym__Atomic] = ACTIONS(7563),
    [anon_sym_mutable] = ACTIONS(7563),
    [anon_sym_explicit] = ACTIONS(7563),
    [anon_sym_constexpr] = ACTIONS(7563),
    [anon_sym_unsigned] = ACTIONS(7563),
    [anon_sym_long] = ACTIONS(7563),
    [anon_sym_short] = ACTIONS(7563),
    [sym_primitive_type] = ACTIONS(7563),
    [anon_sym_enum] = ACTIONS(7563),
    [anon_sym_struct] = ACTIONS(7563),
    [anon_sym_union] = ACTIONS(7563),
    [anon_sym_if] = ACTIONS(7563),
    [anon_sym_else] = ACTIONS(7563),
    [anon_sym_switch] = ACTIONS(7563),
    [anon_sym_case] = ACTIONS(7563),
    [anon_sym_default] = ACTIONS(7563),
    [anon_sym_while] = ACTIONS(7563),
    [anon_sym_do] = ACTIONS(7563),
    [anon_sym_for] = ACTIONS(7563),
    [anon_sym_return] = ACTIONS(7563),
    [anon_sym_break] = ACTIONS(7563),
    [anon_sym_continue] = ACTIONS(7563),
    [anon_sym_goto] = ACTIONS(7563),
    [anon_sym_AMP] = ACTIONS(7563),
    [anon_sym_AMP_AMP] = ACTIONS(7561),
    [anon_sym_BANG] = ACTIONS(7561),
    [anon_sym_TILDE] = ACTIONS(7561),
    [anon_sym_PLUS] = ACTIONS(7563),
    [anon_sym_DASH] = ACTIONS(7563),
    [anon_sym_DASH_DASH] = ACTIONS(7561),
    [anon_sym_PLUS_PLUS] = ACTIONS(7561),
    [anon_sym_sizeof] = ACTIONS(7563),
    [sym_number_literal] = ACTIONS(7561),
    [anon_sym_SQUOTE] = ACTIONS(7561),
    [anon_sym_DQUOTE] = ACTIONS(7561),
    [sym_true] = ACTIONS(7563),
    [sym_false] = ACTIONS(7563),
    [sym_null] = ACTIONS(7563),
    [sym_identifier] = ACTIONS(7563),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7563),
    [sym_auto] = ACTIONS(7563),
    [anon_sym_typename] = ACTIONS(7563),
    [anon_sym_template] = ACTIONS(7563),
    [anon_sym_delete] = ACTIONS(7563),
    [anon_sym_namespace] = ACTIONS(7563),
    [anon_sym_using] = ACTIONS(7563),
    [anon_sym_try] = ACTIONS(7563),
    [anon_sym_new] = ACTIONS(7563),
    [anon_sym_COLON_COLON] = ACTIONS(7561),
    [sym_operator_name] = ACTIONS(7561),
    [sym_nullptr] = ACTIONS(7563),
  },
  [3461] = {
    [sym_compound_statement] = STATE(3601),
    [sym_labeled_statement] = STATE(3601),
    [sym_expression_statement] = STATE(3601),
    [sym_if_statement] = STATE(3601),
    [sym_switch_statement] = STATE(3601),
    [sym_case_statement] = STATE(3601),
    [sym_while_statement] = STATE(3601),
    [sym_do_statement] = STATE(3601),
    [sym_for_statement] = STATE(3601),
    [sym_return_statement] = STATE(3601),
    [sym_break_statement] = STATE(3601),
    [sym_continue_statement] = STATE(3601),
    [sym_goto_statement] = STATE(3601),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(411),
    [sym_for_range_loop] = STATE(3601),
    [sym_try_statement] = STATE(3601),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(678),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(704),
    [anon_sym_switch] = ACTIONS(706),
    [anon_sym_case] = ACTIONS(708),
    [anon_sym_default] = ACTIONS(710),
    [anon_sym_while] = ACTIONS(712),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(3807),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(736),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(726),
  },
  [3462] = {
    [sym_raw_string_literal] = ACTIONS(7589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7591),
    [sym_preproc_directive] = ACTIONS(7591),
    [anon_sym_SEMI] = ACTIONS(7589),
    [anon_sym_typedef] = ACTIONS(7591),
    [anon_sym_extern] = ACTIONS(7591),
    [anon_sym_LBRACE] = ACTIONS(7589),
    [anon_sym_LPAREN2] = ACTIONS(7589),
    [anon_sym_STAR] = ACTIONS(7589),
    [anon_sym_LBRACK] = ACTIONS(7589),
    [anon_sym_static] = ACTIONS(7591),
    [anon_sym_register] = ACTIONS(7591),
    [anon_sym_inline] = ACTIONS(7591),
    [anon_sym_const] = ACTIONS(7591),
    [anon_sym_restrict] = ACTIONS(7591),
    [anon_sym_volatile] = ACTIONS(7591),
    [anon_sym__Atomic] = ACTIONS(7591),
    [anon_sym_mutable] = ACTIONS(7591),
    [anon_sym_explicit] = ACTIONS(7591),
    [anon_sym_constexpr] = ACTIONS(7591),
    [anon_sym_unsigned] = ACTIONS(7591),
    [anon_sym_long] = ACTIONS(7591),
    [anon_sym_short] = ACTIONS(7591),
    [sym_primitive_type] = ACTIONS(7591),
    [anon_sym_enum] = ACTIONS(7591),
    [anon_sym_struct] = ACTIONS(7591),
    [anon_sym_union] = ACTIONS(7591),
    [anon_sym_if] = ACTIONS(7591),
    [anon_sym_else] = ACTIONS(7591),
    [anon_sym_switch] = ACTIONS(7591),
    [anon_sym_case] = ACTIONS(7591),
    [anon_sym_default] = ACTIONS(7591),
    [anon_sym_while] = ACTIONS(7591),
    [anon_sym_do] = ACTIONS(7591),
    [anon_sym_for] = ACTIONS(7591),
    [anon_sym_return] = ACTIONS(7591),
    [anon_sym_break] = ACTIONS(7591),
    [anon_sym_continue] = ACTIONS(7591),
    [anon_sym_goto] = ACTIONS(7591),
    [anon_sym_AMP] = ACTIONS(7591),
    [anon_sym_AMP_AMP] = ACTIONS(7589),
    [anon_sym_BANG] = ACTIONS(7589),
    [anon_sym_TILDE] = ACTIONS(7589),
    [anon_sym_PLUS] = ACTIONS(7591),
    [anon_sym_DASH] = ACTIONS(7591),
    [anon_sym_DASH_DASH] = ACTIONS(7589),
    [anon_sym_PLUS_PLUS] = ACTIONS(7589),
    [anon_sym_sizeof] = ACTIONS(7591),
    [sym_number_literal] = ACTIONS(7589),
    [anon_sym_SQUOTE] = ACTIONS(7589),
    [anon_sym_DQUOTE] = ACTIONS(7589),
    [sym_true] = ACTIONS(7591),
    [sym_false] = ACTIONS(7591),
    [sym_null] = ACTIONS(7591),
    [sym_identifier] = ACTIONS(7591),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7591),
    [sym_auto] = ACTIONS(7591),
    [anon_sym_typename] = ACTIONS(7591),
    [anon_sym_template] = ACTIONS(7591),
    [anon_sym_delete] = ACTIONS(7591),
    [anon_sym_namespace] = ACTIONS(7591),
    [anon_sym_using] = ACTIONS(7591),
    [anon_sym_try] = ACTIONS(7591),
    [anon_sym_new] = ACTIONS(7591),
    [anon_sym_COLON_COLON] = ACTIONS(7589),
    [sym_operator_name] = ACTIONS(7589),
    [sym_nullptr] = ACTIONS(7591),
  },
  [3463] = {
    [sym_compound_statement] = STATE(3602),
    [sym_labeled_statement] = STATE(3602),
    [sym_expression_statement] = STATE(3602),
    [sym_if_statement] = STATE(3602),
    [sym_switch_statement] = STATE(3602),
    [sym_case_statement] = STATE(3602),
    [sym_while_statement] = STATE(3602),
    [sym_do_statement] = STATE(3602),
    [sym_for_statement] = STATE(3602),
    [sym_return_statement] = STATE(3602),
    [sym_break_statement] = STATE(3602),
    [sym_continue_statement] = STATE(3602),
    [sym_goto_statement] = STATE(3602),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(411),
    [sym_for_range_loop] = STATE(3602),
    [sym_try_statement] = STATE(3602),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(678),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(704),
    [anon_sym_switch] = ACTIONS(706),
    [anon_sym_case] = ACTIONS(708),
    [anon_sym_default] = ACTIONS(710),
    [anon_sym_while] = ACTIONS(712),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(3807),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(736),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(726),
  },
  [3464] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8012),
    [sym_comment] = ACTIONS(91),
  },
  [3465] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3604),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8012),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3466] = {
    [sym_raw_string_literal] = ACTIONS(7598),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7600),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7600),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7600),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7600),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7600),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7600),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7600),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7600),
    [sym_preproc_directive] = ACTIONS(7600),
    [anon_sym_SEMI] = ACTIONS(7598),
    [anon_sym_typedef] = ACTIONS(7600),
    [anon_sym_extern] = ACTIONS(7600),
    [anon_sym_LBRACE] = ACTIONS(7598),
    [anon_sym_LPAREN2] = ACTIONS(7598),
    [anon_sym_STAR] = ACTIONS(7598),
    [anon_sym_LBRACK] = ACTIONS(7598),
    [anon_sym_static] = ACTIONS(7600),
    [anon_sym_register] = ACTIONS(7600),
    [anon_sym_inline] = ACTIONS(7600),
    [anon_sym_const] = ACTIONS(7600),
    [anon_sym_restrict] = ACTIONS(7600),
    [anon_sym_volatile] = ACTIONS(7600),
    [anon_sym__Atomic] = ACTIONS(7600),
    [anon_sym_mutable] = ACTIONS(7600),
    [anon_sym_explicit] = ACTIONS(7600),
    [anon_sym_constexpr] = ACTIONS(7600),
    [anon_sym_unsigned] = ACTIONS(7600),
    [anon_sym_long] = ACTIONS(7600),
    [anon_sym_short] = ACTIONS(7600),
    [sym_primitive_type] = ACTIONS(7600),
    [anon_sym_enum] = ACTIONS(7600),
    [anon_sym_struct] = ACTIONS(7600),
    [anon_sym_union] = ACTIONS(7600),
    [anon_sym_if] = ACTIONS(7600),
    [anon_sym_else] = ACTIONS(7600),
    [anon_sym_switch] = ACTIONS(7600),
    [anon_sym_case] = ACTIONS(7600),
    [anon_sym_default] = ACTIONS(7600),
    [anon_sym_while] = ACTIONS(7600),
    [anon_sym_do] = ACTIONS(7600),
    [anon_sym_for] = ACTIONS(7600),
    [anon_sym_return] = ACTIONS(7600),
    [anon_sym_break] = ACTIONS(7600),
    [anon_sym_continue] = ACTIONS(7600),
    [anon_sym_goto] = ACTIONS(7600),
    [anon_sym_AMP] = ACTIONS(7600),
    [anon_sym_AMP_AMP] = ACTIONS(7598),
    [anon_sym_BANG] = ACTIONS(7598),
    [anon_sym_TILDE] = ACTIONS(7598),
    [anon_sym_PLUS] = ACTIONS(7600),
    [anon_sym_DASH] = ACTIONS(7600),
    [anon_sym_DASH_DASH] = ACTIONS(7598),
    [anon_sym_PLUS_PLUS] = ACTIONS(7598),
    [anon_sym_sizeof] = ACTIONS(7600),
    [sym_number_literal] = ACTIONS(7598),
    [anon_sym_SQUOTE] = ACTIONS(7598),
    [anon_sym_DQUOTE] = ACTIONS(7598),
    [sym_true] = ACTIONS(7600),
    [sym_false] = ACTIONS(7600),
    [sym_null] = ACTIONS(7600),
    [sym_identifier] = ACTIONS(7600),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7600),
    [sym_auto] = ACTIONS(7600),
    [anon_sym_typename] = ACTIONS(7600),
    [anon_sym_template] = ACTIONS(7600),
    [anon_sym_delete] = ACTIONS(7600),
    [anon_sym_namespace] = ACTIONS(7600),
    [anon_sym_using] = ACTIONS(7600),
    [anon_sym_try] = ACTIONS(7600),
    [anon_sym_new] = ACTIONS(7600),
    [anon_sym_COLON_COLON] = ACTIONS(7598),
    [sym_operator_name] = ACTIONS(7598),
    [sym_nullptr] = ACTIONS(7600),
  },
  [3467] = {
    [sym_raw_string_literal] = ACTIONS(5376),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5378),
    [sym_preproc_directive] = ACTIONS(5378),
    [anon_sym_SEMI] = ACTIONS(5376),
    [anon_sym_typedef] = ACTIONS(5378),
    [anon_sym_extern] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(5376),
    [anon_sym_LPAREN2] = ACTIONS(5376),
    [anon_sym_STAR] = ACTIONS(5376),
    [anon_sym_LBRACK] = ACTIONS(5376),
    [anon_sym_static] = ACTIONS(5378),
    [anon_sym_register] = ACTIONS(5378),
    [anon_sym_inline] = ACTIONS(5378),
    [anon_sym_const] = ACTIONS(5378),
    [anon_sym_restrict] = ACTIONS(5378),
    [anon_sym_volatile] = ACTIONS(5378),
    [anon_sym__Atomic] = ACTIONS(5378),
    [anon_sym_mutable] = ACTIONS(5378),
    [anon_sym_explicit] = ACTIONS(5378),
    [anon_sym_constexpr] = ACTIONS(5378),
    [anon_sym_unsigned] = ACTIONS(5378),
    [anon_sym_long] = ACTIONS(5378),
    [anon_sym_short] = ACTIONS(5378),
    [sym_primitive_type] = ACTIONS(5378),
    [anon_sym_enum] = ACTIONS(5378),
    [anon_sym_struct] = ACTIONS(5378),
    [anon_sym_union] = ACTIONS(5378),
    [anon_sym_if] = ACTIONS(5378),
    [anon_sym_switch] = ACTIONS(5378),
    [anon_sym_case] = ACTIONS(5378),
    [anon_sym_default] = ACTIONS(5378),
    [anon_sym_while] = ACTIONS(5378),
    [anon_sym_do] = ACTIONS(5378),
    [anon_sym_for] = ACTIONS(5378),
    [anon_sym_return] = ACTIONS(5378),
    [anon_sym_break] = ACTIONS(5378),
    [anon_sym_continue] = ACTIONS(5378),
    [anon_sym_goto] = ACTIONS(5378),
    [anon_sym_AMP] = ACTIONS(5376),
    [anon_sym_BANG] = ACTIONS(5376),
    [anon_sym_TILDE] = ACTIONS(5376),
    [anon_sym_PLUS] = ACTIONS(5378),
    [anon_sym_DASH] = ACTIONS(5378),
    [anon_sym_DASH_DASH] = ACTIONS(5376),
    [anon_sym_PLUS_PLUS] = ACTIONS(5376),
    [anon_sym_sizeof] = ACTIONS(5378),
    [sym_number_literal] = ACTIONS(5376),
    [anon_sym_SQUOTE] = ACTIONS(5376),
    [anon_sym_DQUOTE] = ACTIONS(5376),
    [sym_true] = ACTIONS(5378),
    [sym_false] = ACTIONS(5378),
    [sym_null] = ACTIONS(5378),
    [sym_identifier] = ACTIONS(5378),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5378),
    [sym_auto] = ACTIONS(5378),
    [anon_sym_typename] = ACTIONS(5378),
    [anon_sym_delete] = ACTIONS(5378),
    [anon_sym_try] = ACTIONS(5378),
    [anon_sym_new] = ACTIONS(5378),
    [anon_sym_COLON_COLON] = ACTIONS(5376),
    [sym_nullptr] = ACTIONS(5378),
  },
  [3468] = {
    [sym_raw_string_literal] = ACTIONS(6900),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6902),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6902),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6902),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6902),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6902),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6902),
    [sym_preproc_directive] = ACTIONS(6902),
    [anon_sym_SEMI] = ACTIONS(6900),
    [anon_sym_typedef] = ACTIONS(6902),
    [anon_sym_extern] = ACTIONS(6902),
    [anon_sym_LBRACE] = ACTIONS(6900),
    [anon_sym_LPAREN2] = ACTIONS(6900),
    [anon_sym_STAR] = ACTIONS(6900),
    [anon_sym_LBRACK] = ACTIONS(6900),
    [anon_sym_static] = ACTIONS(6902),
    [anon_sym_register] = ACTIONS(6902),
    [anon_sym_inline] = ACTIONS(6902),
    [anon_sym_const] = ACTIONS(6902),
    [anon_sym_restrict] = ACTIONS(6902),
    [anon_sym_volatile] = ACTIONS(6902),
    [anon_sym__Atomic] = ACTIONS(6902),
    [anon_sym_mutable] = ACTIONS(6902),
    [anon_sym_explicit] = ACTIONS(6902),
    [anon_sym_constexpr] = ACTIONS(6902),
    [anon_sym_unsigned] = ACTIONS(6902),
    [anon_sym_long] = ACTIONS(6902),
    [anon_sym_short] = ACTIONS(6902),
    [sym_primitive_type] = ACTIONS(6902),
    [anon_sym_enum] = ACTIONS(6902),
    [anon_sym_struct] = ACTIONS(6902),
    [anon_sym_union] = ACTIONS(6902),
    [anon_sym_if] = ACTIONS(6902),
    [anon_sym_switch] = ACTIONS(6902),
    [anon_sym_case] = ACTIONS(6902),
    [anon_sym_default] = ACTIONS(6902),
    [anon_sym_while] = ACTIONS(6902),
    [anon_sym_do] = ACTIONS(6902),
    [anon_sym_for] = ACTIONS(6902),
    [anon_sym_return] = ACTIONS(6902),
    [anon_sym_break] = ACTIONS(6902),
    [anon_sym_continue] = ACTIONS(6902),
    [anon_sym_goto] = ACTIONS(6902),
    [anon_sym_AMP] = ACTIONS(6900),
    [anon_sym_BANG] = ACTIONS(6900),
    [anon_sym_TILDE] = ACTIONS(6900),
    [anon_sym_PLUS] = ACTIONS(6902),
    [anon_sym_DASH] = ACTIONS(6902),
    [anon_sym_DASH_DASH] = ACTIONS(6900),
    [anon_sym_PLUS_PLUS] = ACTIONS(6900),
    [anon_sym_sizeof] = ACTIONS(6902),
    [sym_number_literal] = ACTIONS(6900),
    [anon_sym_SQUOTE] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(6900),
    [sym_true] = ACTIONS(6902),
    [sym_false] = ACTIONS(6902),
    [sym_null] = ACTIONS(6902),
    [sym_identifier] = ACTIONS(6902),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6902),
    [sym_auto] = ACTIONS(6902),
    [anon_sym_typename] = ACTIONS(6902),
    [anon_sym_delete] = ACTIONS(6902),
    [anon_sym_try] = ACTIONS(6902),
    [anon_sym_new] = ACTIONS(6902),
    [anon_sym_COLON_COLON] = ACTIONS(6900),
    [sym_nullptr] = ACTIONS(6902),
  },
  [3469] = {
    [sym_raw_string_literal] = ACTIONS(6904),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6906),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6906),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6906),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6906),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6906),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6906),
    [sym_preproc_directive] = ACTIONS(6906),
    [anon_sym_SEMI] = ACTIONS(6904),
    [anon_sym_typedef] = ACTIONS(6906),
    [anon_sym_extern] = ACTIONS(6906),
    [anon_sym_LBRACE] = ACTIONS(6904),
    [anon_sym_LPAREN2] = ACTIONS(6904),
    [anon_sym_STAR] = ACTIONS(6904),
    [anon_sym_LBRACK] = ACTIONS(6904),
    [anon_sym_static] = ACTIONS(6906),
    [anon_sym_register] = ACTIONS(6906),
    [anon_sym_inline] = ACTIONS(6906),
    [anon_sym_const] = ACTIONS(6906),
    [anon_sym_restrict] = ACTIONS(6906),
    [anon_sym_volatile] = ACTIONS(6906),
    [anon_sym__Atomic] = ACTIONS(6906),
    [anon_sym_mutable] = ACTIONS(6906),
    [anon_sym_explicit] = ACTIONS(6906),
    [anon_sym_constexpr] = ACTIONS(6906),
    [anon_sym_unsigned] = ACTIONS(6906),
    [anon_sym_long] = ACTIONS(6906),
    [anon_sym_short] = ACTIONS(6906),
    [sym_primitive_type] = ACTIONS(6906),
    [anon_sym_enum] = ACTIONS(6906),
    [anon_sym_struct] = ACTIONS(6906),
    [anon_sym_union] = ACTIONS(6906),
    [anon_sym_if] = ACTIONS(6906),
    [anon_sym_switch] = ACTIONS(6906),
    [anon_sym_case] = ACTIONS(6906),
    [anon_sym_default] = ACTIONS(6906),
    [anon_sym_while] = ACTIONS(6906),
    [anon_sym_do] = ACTIONS(6906),
    [anon_sym_for] = ACTIONS(6906),
    [anon_sym_return] = ACTIONS(6906),
    [anon_sym_break] = ACTIONS(6906),
    [anon_sym_continue] = ACTIONS(6906),
    [anon_sym_goto] = ACTIONS(6906),
    [anon_sym_AMP] = ACTIONS(6904),
    [anon_sym_BANG] = ACTIONS(6904),
    [anon_sym_TILDE] = ACTIONS(6904),
    [anon_sym_PLUS] = ACTIONS(6906),
    [anon_sym_DASH] = ACTIONS(6906),
    [anon_sym_DASH_DASH] = ACTIONS(6904),
    [anon_sym_PLUS_PLUS] = ACTIONS(6904),
    [anon_sym_sizeof] = ACTIONS(6906),
    [sym_number_literal] = ACTIONS(6904),
    [anon_sym_SQUOTE] = ACTIONS(6904),
    [anon_sym_DQUOTE] = ACTIONS(6904),
    [sym_true] = ACTIONS(6906),
    [sym_false] = ACTIONS(6906),
    [sym_null] = ACTIONS(6906),
    [sym_identifier] = ACTIONS(6906),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6906),
    [sym_auto] = ACTIONS(6906),
    [anon_sym_typename] = ACTIONS(6906),
    [anon_sym_delete] = ACTIONS(6906),
    [anon_sym_try] = ACTIONS(6906),
    [anon_sym_new] = ACTIONS(6906),
    [anon_sym_COLON_COLON] = ACTIONS(6904),
    [sym_nullptr] = ACTIONS(6906),
  },
  [3470] = {
    [sym_raw_string_literal] = ACTIONS(5621),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(5623),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(5623),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(5623),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(5623),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(5623),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(5623),
    [sym_preproc_directive] = ACTIONS(5623),
    [anon_sym_SEMI] = ACTIONS(5621),
    [anon_sym_typedef] = ACTIONS(5623),
    [anon_sym_extern] = ACTIONS(5623),
    [anon_sym_LBRACE] = ACTIONS(5621),
    [anon_sym_LPAREN2] = ACTIONS(5621),
    [anon_sym_STAR] = ACTIONS(5621),
    [anon_sym_LBRACK] = ACTIONS(5621),
    [anon_sym_static] = ACTIONS(5623),
    [anon_sym_register] = ACTIONS(5623),
    [anon_sym_inline] = ACTIONS(5623),
    [anon_sym_const] = ACTIONS(5623),
    [anon_sym_restrict] = ACTIONS(5623),
    [anon_sym_volatile] = ACTIONS(5623),
    [anon_sym__Atomic] = ACTIONS(5623),
    [anon_sym_mutable] = ACTIONS(5623),
    [anon_sym_explicit] = ACTIONS(5623),
    [anon_sym_constexpr] = ACTIONS(5623),
    [anon_sym_unsigned] = ACTIONS(5623),
    [anon_sym_long] = ACTIONS(5623),
    [anon_sym_short] = ACTIONS(5623),
    [sym_primitive_type] = ACTIONS(5623),
    [anon_sym_enum] = ACTIONS(5623),
    [anon_sym_struct] = ACTIONS(5623),
    [anon_sym_union] = ACTIONS(5623),
    [anon_sym_if] = ACTIONS(5623),
    [anon_sym_else] = ACTIONS(5623),
    [anon_sym_switch] = ACTIONS(5623),
    [anon_sym_case] = ACTIONS(5623),
    [anon_sym_default] = ACTIONS(5623),
    [anon_sym_while] = ACTIONS(5623),
    [anon_sym_do] = ACTIONS(5623),
    [anon_sym_for] = ACTIONS(5623),
    [anon_sym_return] = ACTIONS(5623),
    [anon_sym_break] = ACTIONS(5623),
    [anon_sym_continue] = ACTIONS(5623),
    [anon_sym_goto] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5621),
    [anon_sym_BANG] = ACTIONS(5621),
    [anon_sym_TILDE] = ACTIONS(5621),
    [anon_sym_PLUS] = ACTIONS(5623),
    [anon_sym_DASH] = ACTIONS(5623),
    [anon_sym_DASH_DASH] = ACTIONS(5621),
    [anon_sym_PLUS_PLUS] = ACTIONS(5621),
    [anon_sym_sizeof] = ACTIONS(5623),
    [sym_number_literal] = ACTIONS(5621),
    [anon_sym_SQUOTE] = ACTIONS(5621),
    [anon_sym_DQUOTE] = ACTIONS(5621),
    [sym_true] = ACTIONS(5623),
    [sym_false] = ACTIONS(5623),
    [sym_null] = ACTIONS(5623),
    [sym_identifier] = ACTIONS(5623),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(5623),
    [sym_auto] = ACTIONS(5623),
    [anon_sym_typename] = ACTIONS(5623),
    [anon_sym_delete] = ACTIONS(5623),
    [anon_sym_try] = ACTIONS(5623),
    [anon_sym_new] = ACTIONS(5623),
    [anon_sym_COLON_COLON] = ACTIONS(5621),
    [sym_nullptr] = ACTIONS(5623),
  },
  [3471] = {
    [anon_sym_LPAREN2] = ACTIONS(8014),
    [anon_sym_constexpr] = ACTIONS(8016),
    [sym_comment] = ACTIONS(91),
  },
  [3472] = {
    [sym_parenthesized_expression] = STATE(3607),
    [anon_sym_LPAREN2] = ACTIONS(323),
    [sym_comment] = ACTIONS(91),
  },
  [3473] = {
    [sym__expression] = STATE(3608),
    [sym_conditional_expression] = STATE(3608),
    [sym_assignment_expression] = STATE(3608),
    [sym_pointer_expression] = STATE(3608),
    [sym_logical_expression] = STATE(3608),
    [sym_bitwise_expression] = STATE(3608),
    [sym_equality_expression] = STATE(3608),
    [sym_relational_expression] = STATE(3608),
    [sym_shift_expression] = STATE(3608),
    [sym_math_expression] = STATE(3608),
    [sym_cast_expression] = STATE(3608),
    [sym_sizeof_expression] = STATE(3608),
    [sym_subscript_expression] = STATE(3608),
    [sym_call_expression] = STATE(3608),
    [sym_field_expression] = STATE(3608),
    [sym_compound_literal_expression] = STATE(3608),
    [sym_parenthesized_expression] = STATE(3608),
    [sym_char_literal] = STATE(3608),
    [sym_concatenated_string] = STATE(3608),
    [sym_string_literal] = STATE(202),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3608),
    [sym_new_expression] = STATE(3608),
    [sym_delete_expression] = STATE(3608),
    [sym_lambda_expression] = STATE(3608),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(203),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8018),
    [anon_sym_LPAREN2] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(337),
    [anon_sym_PLUS_PLUS] = ACTIONS(337),
    [anon_sym_sizeof] = ACTIONS(339),
    [sym_number_literal] = ACTIONS(8018),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(341),
    [sym_true] = ACTIONS(8020),
    [sym_false] = ACTIONS(8020),
    [sym_null] = ACTIONS(8020),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [sym_nullptr] = ACTIONS(8020),
  },
  [3474] = {
    [anon_sym_COLON] = ACTIONS(8022),
    [sym_comment] = ACTIONS(91),
  },
  [3475] = {
    [sym_parenthesized_expression] = STATE(3610),
    [anon_sym_LPAREN2] = ACTIONS(323),
    [sym_comment] = ACTIONS(91),
  },
  [3476] = {
    [anon_sym_LPAREN2] = ACTIONS(8024),
    [sym_comment] = ACTIONS(91),
  },
  [3477] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(548),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_COLON] = ACTIONS(8026),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(935),
  },
  [3478] = {
    [sym_compound_statement] = STATE(3613),
    [anon_sym_LBRACE] = ACTIONS(357),
    [sym_comment] = ACTIONS(91),
  },
  [3479] = {
    [sym_raw_string_literal] = ACTIONS(6091),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6093),
    [sym_preproc_directive] = ACTIONS(6093),
    [anon_sym_SEMI] = ACTIONS(6091),
    [anon_sym_typedef] = ACTIONS(6093),
    [anon_sym_extern] = ACTIONS(6093),
    [anon_sym_LBRACE] = ACTIONS(6091),
    [anon_sym_LPAREN2] = ACTIONS(6091),
    [anon_sym_STAR] = ACTIONS(6091),
    [anon_sym_LBRACK] = ACTIONS(6091),
    [anon_sym_static] = ACTIONS(6093),
    [anon_sym_register] = ACTIONS(6093),
    [anon_sym_inline] = ACTIONS(6093),
    [anon_sym_const] = ACTIONS(6093),
    [anon_sym_restrict] = ACTIONS(6093),
    [anon_sym_volatile] = ACTIONS(6093),
    [anon_sym__Atomic] = ACTIONS(6093),
    [anon_sym_mutable] = ACTIONS(6093),
    [anon_sym_explicit] = ACTIONS(6093),
    [anon_sym_constexpr] = ACTIONS(6093),
    [anon_sym_unsigned] = ACTIONS(6093),
    [anon_sym_long] = ACTIONS(6093),
    [anon_sym_short] = ACTIONS(6093),
    [sym_primitive_type] = ACTIONS(6093),
    [anon_sym_enum] = ACTIONS(6093),
    [anon_sym_struct] = ACTIONS(6093),
    [anon_sym_union] = ACTIONS(6093),
    [anon_sym_if] = ACTIONS(6093),
    [anon_sym_else] = ACTIONS(8028),
    [anon_sym_switch] = ACTIONS(6093),
    [anon_sym_case] = ACTIONS(6093),
    [anon_sym_default] = ACTIONS(6093),
    [anon_sym_while] = ACTIONS(6093),
    [anon_sym_do] = ACTIONS(6093),
    [anon_sym_for] = ACTIONS(6093),
    [anon_sym_return] = ACTIONS(6093),
    [anon_sym_break] = ACTIONS(6093),
    [anon_sym_continue] = ACTIONS(6093),
    [anon_sym_goto] = ACTIONS(6093),
    [anon_sym_AMP] = ACTIONS(6091),
    [anon_sym_BANG] = ACTIONS(6091),
    [anon_sym_TILDE] = ACTIONS(6091),
    [anon_sym_PLUS] = ACTIONS(6093),
    [anon_sym_DASH] = ACTIONS(6093),
    [anon_sym_DASH_DASH] = ACTIONS(6091),
    [anon_sym_PLUS_PLUS] = ACTIONS(6091),
    [anon_sym_sizeof] = ACTIONS(6093),
    [sym_number_literal] = ACTIONS(6091),
    [anon_sym_SQUOTE] = ACTIONS(6091),
    [anon_sym_DQUOTE] = ACTIONS(6091),
    [sym_true] = ACTIONS(6093),
    [sym_false] = ACTIONS(6093),
    [sym_null] = ACTIONS(6093),
    [sym_identifier] = ACTIONS(6093),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6093),
    [sym_auto] = ACTIONS(6093),
    [anon_sym_typename] = ACTIONS(6093),
    [anon_sym_delete] = ACTIONS(6093),
    [anon_sym_try] = ACTIONS(6093),
    [anon_sym_new] = ACTIONS(6093),
    [anon_sym_COLON_COLON] = ACTIONS(6091),
    [sym_nullptr] = ACTIONS(6093),
  },
  [3480] = {
    [sym_compound_statement] = STATE(3615),
    [sym_labeled_statement] = STATE(3615),
    [sym_expression_statement] = STATE(3615),
    [sym_if_statement] = STATE(3615),
    [sym_switch_statement] = STATE(3615),
    [sym_case_statement] = STATE(3615),
    [sym_while_statement] = STATE(3615),
    [sym_do_statement] = STATE(3615),
    [sym_for_statement] = STATE(3615),
    [sym_return_statement] = STATE(3615),
    [sym_break_statement] = STATE(3615),
    [sym_continue_statement] = STATE(3615),
    [sym_goto_statement] = STATE(3615),
    [sym__expression] = STATE(1908),
    [sym_comma_expression] = STATE(1909),
    [sym_conditional_expression] = STATE(1908),
    [sym_assignment_expression] = STATE(1908),
    [sym_pointer_expression] = STATE(1908),
    [sym_logical_expression] = STATE(1908),
    [sym_bitwise_expression] = STATE(1908),
    [sym_equality_expression] = STATE(1908),
    [sym_relational_expression] = STATE(1908),
    [sym_shift_expression] = STATE(1908),
    [sym_math_expression] = STATE(1908),
    [sym_cast_expression] = STATE(1908),
    [sym_sizeof_expression] = STATE(1908),
    [sym_subscript_expression] = STATE(1908),
    [sym_call_expression] = STATE(1908),
    [sym_field_expression] = STATE(1908),
    [sym_compound_literal_expression] = STATE(1908),
    [sym_parenthesized_expression] = STATE(1908),
    [sym_char_literal] = STATE(1908),
    [sym_concatenated_string] = STATE(1908),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1908),
    [sym_for_range_loop] = STATE(3615),
    [sym_try_statement] = STATE(3615),
    [sym_new_expression] = STATE(1908),
    [sym_delete_expression] = STATE(1908),
    [sym_lambda_expression] = STATE(1908),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3996),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7766),
    [anon_sym_switch] = ACTIONS(7768),
    [anon_sym_case] = ACTIONS(7770),
    [anon_sym_default] = ACTIONS(7772),
    [anon_sym_while] = ACTIONS(7774),
    [anon_sym_do] = ACTIONS(4026),
    [anon_sym_for] = ACTIONS(7776),
    [anon_sym_return] = ACTIONS(4030),
    [anon_sym_break] = ACTIONS(4032),
    [anon_sym_continue] = ACTIONS(4034),
    [anon_sym_goto] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(3996),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4038),
    [sym_false] = ACTIONS(4038),
    [sym_null] = ACTIONS(4038),
    [sym_identifier] = ACTIONS(7778),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7780),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(4038),
  },
  [3481] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_COMMA] = ACTIONS(895),
    [anon_sym_RPAREN] = ACTIONS(8030),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3482] = {
    [anon_sym_RPAREN] = ACTIONS(8030),
    [sym_comment] = ACTIONS(91),
  },
  [3483] = {
    [sym_compound_statement] = STATE(3617),
    [sym_labeled_statement] = STATE(3617),
    [sym_expression_statement] = STATE(3617),
    [sym_if_statement] = STATE(3617),
    [sym_switch_statement] = STATE(3617),
    [sym_case_statement] = STATE(3617),
    [sym_while_statement] = STATE(3617),
    [sym_do_statement] = STATE(3617),
    [sym_for_statement] = STATE(3617),
    [sym_return_statement] = STATE(3617),
    [sym_break_statement] = STATE(3617),
    [sym_continue_statement] = STATE(3617),
    [sym_goto_statement] = STATE(3617),
    [sym__expression] = STATE(1908),
    [sym_comma_expression] = STATE(1909),
    [sym_conditional_expression] = STATE(1908),
    [sym_assignment_expression] = STATE(1908),
    [sym_pointer_expression] = STATE(1908),
    [sym_logical_expression] = STATE(1908),
    [sym_bitwise_expression] = STATE(1908),
    [sym_equality_expression] = STATE(1908),
    [sym_relational_expression] = STATE(1908),
    [sym_shift_expression] = STATE(1908),
    [sym_math_expression] = STATE(1908),
    [sym_cast_expression] = STATE(1908),
    [sym_sizeof_expression] = STATE(1908),
    [sym_subscript_expression] = STATE(1908),
    [sym_call_expression] = STATE(1908),
    [sym_field_expression] = STATE(1908),
    [sym_compound_literal_expression] = STATE(1908),
    [sym_parenthesized_expression] = STATE(1908),
    [sym_char_literal] = STATE(1908),
    [sym_concatenated_string] = STATE(1908),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1908),
    [sym_for_range_loop] = STATE(3617),
    [sym_try_statement] = STATE(3617),
    [sym_new_expression] = STATE(1908),
    [sym_delete_expression] = STATE(1908),
    [sym_lambda_expression] = STATE(1908),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3996),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(4016),
    [anon_sym_switch] = ACTIONS(4018),
    [anon_sym_case] = ACTIONS(4020),
    [anon_sym_default] = ACTIONS(4022),
    [anon_sym_while] = ACTIONS(4024),
    [anon_sym_do] = ACTIONS(4026),
    [anon_sym_for] = ACTIONS(4028),
    [anon_sym_return] = ACTIONS(4030),
    [anon_sym_break] = ACTIONS(4032),
    [anon_sym_continue] = ACTIONS(4034),
    [anon_sym_goto] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(3996),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4038),
    [sym_false] = ACTIONS(4038),
    [sym_null] = ACTIONS(4038),
    [sym_identifier] = ACTIONS(6773),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(4042),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(4038),
  },
  [3484] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3619),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3485] = {
    [sym__expression] = STATE(3620),
    [sym_conditional_expression] = STATE(3620),
    [sym_assignment_expression] = STATE(3620),
    [sym_pointer_expression] = STATE(3620),
    [sym_logical_expression] = STATE(3620),
    [sym_bitwise_expression] = STATE(3620),
    [sym_equality_expression] = STATE(3620),
    [sym_relational_expression] = STATE(3620),
    [sym_shift_expression] = STATE(3620),
    [sym_math_expression] = STATE(3620),
    [sym_cast_expression] = STATE(3620),
    [sym_sizeof_expression] = STATE(3620),
    [sym_subscript_expression] = STATE(3620),
    [sym_call_expression] = STATE(3620),
    [sym_field_expression] = STATE(3620),
    [sym_compound_literal_expression] = STATE(3620),
    [sym_parenthesized_expression] = STATE(3620),
    [sym_char_literal] = STATE(3620),
    [sym_concatenated_string] = STATE(3620),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3620),
    [sym_new_expression] = STATE(3620),
    [sym_delete_expression] = STATE(3620),
    [sym_lambda_expression] = STATE(3620),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8034),
    [anon_sym_RPAREN] = ACTIONS(8032),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(8034),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8036),
    [sym_false] = ACTIONS(8036),
    [sym_null] = ACTIONS(8036),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(8036),
  },
  [3486] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(8038),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3487] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(8040),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3488] = {
    [sym_raw_string_literal] = ACTIONS(6379),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6381),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6381),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6381),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6381),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6381),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6381),
    [sym_preproc_directive] = ACTIONS(6381),
    [anon_sym_SEMI] = ACTIONS(6379),
    [anon_sym_typedef] = ACTIONS(6381),
    [anon_sym_extern] = ACTIONS(6381),
    [anon_sym_LBRACE] = ACTIONS(6379),
    [anon_sym_LPAREN2] = ACTIONS(6379),
    [anon_sym_STAR] = ACTIONS(6379),
    [anon_sym_LBRACK] = ACTIONS(6379),
    [anon_sym_static] = ACTIONS(6381),
    [anon_sym_register] = ACTIONS(6381),
    [anon_sym_inline] = ACTIONS(6381),
    [anon_sym_const] = ACTIONS(6381),
    [anon_sym_restrict] = ACTIONS(6381),
    [anon_sym_volatile] = ACTIONS(6381),
    [anon_sym__Atomic] = ACTIONS(6381),
    [anon_sym_mutable] = ACTIONS(6381),
    [anon_sym_explicit] = ACTIONS(6381),
    [anon_sym_constexpr] = ACTIONS(6381),
    [anon_sym_unsigned] = ACTIONS(6381),
    [anon_sym_long] = ACTIONS(6381),
    [anon_sym_short] = ACTIONS(6381),
    [sym_primitive_type] = ACTIONS(6381),
    [anon_sym_enum] = ACTIONS(6381),
    [anon_sym_struct] = ACTIONS(6381),
    [anon_sym_union] = ACTIONS(6381),
    [anon_sym_if] = ACTIONS(6381),
    [anon_sym_else] = ACTIONS(6381),
    [anon_sym_switch] = ACTIONS(6381),
    [anon_sym_case] = ACTIONS(6381),
    [anon_sym_default] = ACTIONS(6381),
    [anon_sym_while] = ACTIONS(6381),
    [anon_sym_do] = ACTIONS(6381),
    [anon_sym_for] = ACTIONS(6381),
    [anon_sym_return] = ACTIONS(6381),
    [anon_sym_break] = ACTIONS(6381),
    [anon_sym_continue] = ACTIONS(6381),
    [anon_sym_goto] = ACTIONS(6381),
    [anon_sym_AMP] = ACTIONS(6379),
    [anon_sym_BANG] = ACTIONS(6379),
    [anon_sym_TILDE] = ACTIONS(6379),
    [anon_sym_PLUS] = ACTIONS(6381),
    [anon_sym_DASH] = ACTIONS(6381),
    [anon_sym_DASH_DASH] = ACTIONS(6379),
    [anon_sym_PLUS_PLUS] = ACTIONS(6379),
    [anon_sym_sizeof] = ACTIONS(6381),
    [sym_number_literal] = ACTIONS(6379),
    [anon_sym_SQUOTE] = ACTIONS(6379),
    [anon_sym_DQUOTE] = ACTIONS(6379),
    [sym_true] = ACTIONS(6381),
    [sym_false] = ACTIONS(6381),
    [sym_null] = ACTIONS(6381),
    [sym_identifier] = ACTIONS(6381),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6381),
    [sym_auto] = ACTIONS(6381),
    [anon_sym_typename] = ACTIONS(6381),
    [anon_sym_delete] = ACTIONS(6381),
    [anon_sym_try] = ACTIONS(6381),
    [anon_sym_catch] = ACTIONS(6381),
    [anon_sym_new] = ACTIONS(6381),
    [anon_sym_COLON_COLON] = ACTIONS(6379),
    [sym_nullptr] = ACTIONS(6381),
  },
  [3489] = {
    [sym_raw_string_literal] = ACTIONS(6503),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6505),
    [sym_preproc_directive] = ACTIONS(6505),
    [anon_sym_SEMI] = ACTIONS(6503),
    [anon_sym_typedef] = ACTIONS(6505),
    [anon_sym_extern] = ACTIONS(6505),
    [anon_sym_LBRACE] = ACTIONS(6503),
    [anon_sym_LPAREN2] = ACTIONS(6503),
    [anon_sym_STAR] = ACTIONS(6503),
    [anon_sym_LBRACK] = ACTIONS(6503),
    [anon_sym_static] = ACTIONS(6505),
    [anon_sym_register] = ACTIONS(6505),
    [anon_sym_inline] = ACTIONS(6505),
    [anon_sym_const] = ACTIONS(6505),
    [anon_sym_restrict] = ACTIONS(6505),
    [anon_sym_volatile] = ACTIONS(6505),
    [anon_sym__Atomic] = ACTIONS(6505),
    [anon_sym_mutable] = ACTIONS(6505),
    [anon_sym_explicit] = ACTIONS(6505),
    [anon_sym_constexpr] = ACTIONS(6505),
    [anon_sym_unsigned] = ACTIONS(6505),
    [anon_sym_long] = ACTIONS(6505),
    [anon_sym_short] = ACTIONS(6505),
    [sym_primitive_type] = ACTIONS(6505),
    [anon_sym_enum] = ACTIONS(6505),
    [anon_sym_struct] = ACTIONS(6505),
    [anon_sym_union] = ACTIONS(6505),
    [anon_sym_if] = ACTIONS(6505),
    [anon_sym_switch] = ACTIONS(6505),
    [anon_sym_case] = ACTIONS(6505),
    [anon_sym_default] = ACTIONS(6505),
    [anon_sym_while] = ACTIONS(6505),
    [anon_sym_do] = ACTIONS(6505),
    [anon_sym_for] = ACTIONS(6505),
    [anon_sym_return] = ACTIONS(6505),
    [anon_sym_break] = ACTIONS(6505),
    [anon_sym_continue] = ACTIONS(6505),
    [anon_sym_goto] = ACTIONS(6505),
    [anon_sym_AMP] = ACTIONS(6503),
    [anon_sym_BANG] = ACTIONS(6503),
    [anon_sym_TILDE] = ACTIONS(6503),
    [anon_sym_PLUS] = ACTIONS(6505),
    [anon_sym_DASH] = ACTIONS(6505),
    [anon_sym_DASH_DASH] = ACTIONS(6503),
    [anon_sym_PLUS_PLUS] = ACTIONS(6503),
    [anon_sym_sizeof] = ACTIONS(6505),
    [sym_number_literal] = ACTIONS(6503),
    [anon_sym_SQUOTE] = ACTIONS(6503),
    [anon_sym_DQUOTE] = ACTIONS(6503),
    [sym_true] = ACTIONS(6505),
    [sym_false] = ACTIONS(6505),
    [sym_null] = ACTIONS(6505),
    [sym_identifier] = ACTIONS(6505),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6505),
    [sym_auto] = ACTIONS(6505),
    [anon_sym_typename] = ACTIONS(6505),
    [anon_sym_delete] = ACTIONS(6505),
    [anon_sym_try] = ACTIONS(6505),
    [anon_sym_new] = ACTIONS(6505),
    [anon_sym_COLON_COLON] = ACTIONS(6503),
    [sym_nullptr] = ACTIONS(6505),
  },
  [3490] = {
    [sym__expression] = STATE(3623),
    [sym_conditional_expression] = STATE(3623),
    [sym_assignment_expression] = STATE(3623),
    [sym_pointer_expression] = STATE(3623),
    [sym_logical_expression] = STATE(3623),
    [sym_bitwise_expression] = STATE(3623),
    [sym_equality_expression] = STATE(3623),
    [sym_relational_expression] = STATE(3623),
    [sym_shift_expression] = STATE(3623),
    [sym_math_expression] = STATE(3623),
    [sym_cast_expression] = STATE(3623),
    [sym_sizeof_expression] = STATE(3623),
    [sym_subscript_expression] = STATE(3623),
    [sym_call_expression] = STATE(3623),
    [sym_field_expression] = STATE(3623),
    [sym_compound_literal_expression] = STATE(3623),
    [sym_parenthesized_expression] = STATE(3623),
    [sym_char_literal] = STATE(3623),
    [sym_concatenated_string] = STATE(3623),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3623),
    [sym_new_expression] = STATE(3623),
    [sym_delete_expression] = STATE(3623),
    [sym_lambda_expression] = STATE(3623),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8042),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(8042),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8044),
    [sym_false] = ACTIONS(8044),
    [sym_null] = ACTIONS(8044),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(8044),
  },
  [3491] = {
    [anon_sym_LPAREN2] = ACTIONS(8046),
    [sym_comment] = ACTIONS(91),
  },
  [3492] = {
    [sym_compound_statement] = STATE(2596),
    [sym_labeled_statement] = STATE(2596),
    [sym_expression_statement] = STATE(2596),
    [sym_if_statement] = STATE(2596),
    [sym_switch_statement] = STATE(2596),
    [sym_case_statement] = STATE(2596),
    [sym_while_statement] = STATE(2596),
    [sym_do_statement] = STATE(2596),
    [sym_for_statement] = STATE(2596),
    [sym_return_statement] = STATE(2596),
    [sym_break_statement] = STATE(2596),
    [sym_continue_statement] = STATE(2596),
    [sym_goto_statement] = STATE(2596),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(2596),
    [sym_try_statement] = STATE(2596),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7431),
    [anon_sym_switch] = ACTIONS(7433),
    [anon_sym_case] = ACTIONS(7435),
    [anon_sym_default] = ACTIONS(7437),
    [anon_sym_while] = ACTIONS(7439),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(7441),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(7443),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7445),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2242),
  },
  [3493] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_COLON] = ACTIONS(8048),
    [anon_sym_QMARK] = ACTIONS(1171),
    [anon_sym_STAR_EQ] = ACTIONS(1173),
    [anon_sym_SLASH_EQ] = ACTIONS(1173),
    [anon_sym_PERCENT_EQ] = ACTIONS(1173),
    [anon_sym_PLUS_EQ] = ACTIONS(1173),
    [anon_sym_DASH_EQ] = ACTIONS(1173),
    [anon_sym_LT_LT_EQ] = ACTIONS(1173),
    [anon_sym_GT_GT_EQ] = ACTIONS(1173),
    [anon_sym_AMP_EQ] = ACTIONS(1173),
    [anon_sym_CARET_EQ] = ACTIONS(1173),
    [anon_sym_PIPE_EQ] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_CARET] = ACTIONS(1183),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [3494] = {
    [sym_declaration] = STATE(2599),
    [sym_type_definition] = STATE(2599),
    [sym__declaration_specifiers] = STATE(2600),
    [sym_compound_statement] = STATE(2599),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_labeled_statement] = STATE(2599),
    [sym_expression_statement] = STATE(2599),
    [sym_if_statement] = STATE(2599),
    [sym_switch_statement] = STATE(2599),
    [sym_case_statement] = STATE(2599),
    [sym_while_statement] = STATE(2599),
    [sym_do_statement] = STATE(2599),
    [sym_for_statement] = STATE(2599),
    [sym_return_statement] = STATE(2599),
    [sym_break_statement] = STATE(2599),
    [sym_continue_statement] = STATE(2599),
    [sym_goto_statement] = STATE(2599),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(2599),
    [sym_try_statement] = STATE(2599),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_typedef] = ACTIONS(2216),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(7431),
    [anon_sym_switch] = ACTIONS(7433),
    [anon_sym_case] = ACTIONS(7435),
    [anon_sym_default] = ACTIONS(7437),
    [anon_sym_while] = ACTIONS(7439),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(7441),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(8050),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7445),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(1202),
    [sym_nullptr] = ACTIONS(2242),
  },
  [3495] = {
    [sym_compound_statement] = STATE(2601),
    [sym_labeled_statement] = STATE(2601),
    [sym_expression_statement] = STATE(2601),
    [sym_if_statement] = STATE(2601),
    [sym_switch_statement] = STATE(2601),
    [sym_case_statement] = STATE(2601),
    [sym_while_statement] = STATE(2601),
    [sym_do_statement] = STATE(2601),
    [sym_for_statement] = STATE(2601),
    [sym_return_statement] = STATE(2601),
    [sym_break_statement] = STATE(2601),
    [sym_continue_statement] = STATE(2601),
    [sym_goto_statement] = STATE(2601),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(2601),
    [sym_try_statement] = STATE(2601),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7431),
    [anon_sym_switch] = ACTIONS(7433),
    [anon_sym_case] = ACTIONS(7435),
    [anon_sym_default] = ACTIONS(7437),
    [anon_sym_while] = ACTIONS(7439),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(7441),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(7443),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7445),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2242),
  },
  [3496] = {
    [sym_declaration] = STATE(3627),
    [sym__declaration_specifiers] = STATE(709),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym__expression] = STATE(3628),
    [sym_conditional_expression] = STATE(3628),
    [sym_assignment_expression] = STATE(3628),
    [sym_pointer_expression] = STATE(3628),
    [sym_logical_expression] = STATE(3628),
    [sym_bitwise_expression] = STATE(3628),
    [sym_equality_expression] = STATE(3628),
    [sym_relational_expression] = STATE(3628),
    [sym_shift_expression] = STATE(3628),
    [sym_math_expression] = STATE(3628),
    [sym_cast_expression] = STATE(3628),
    [sym_sizeof_expression] = STATE(3628),
    [sym_subscript_expression] = STATE(3628),
    [sym_call_expression] = STATE(3628),
    [sym_field_expression] = STATE(3628),
    [sym_compound_literal_expression] = STATE(3628),
    [sym_parenthesized_expression] = STATE(3628),
    [sym_char_literal] = STATE(3628),
    [sym_concatenated_string] = STATE(3628),
    [sym_string_literal] = STATE(238),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(3628),
    [sym_for_range_declaration] = STATE(3629),
    [sym_new_expression] = STATE(3628),
    [sym_delete_expression] = STATE(3628),
    [sym_lambda_expression] = STATE(3628),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(8052),
    [anon_sym_SEMI] = ACTIONS(8054),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(8052),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8056),
    [sym_false] = ACTIONS(8056),
    [sym_null] = ACTIONS(8056),
    [sym_identifier] = ACTIONS(1242),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(1244),
    [sym_nullptr] = ACTIONS(8056),
  },
  [3497] = {
    [sym_compound_statement] = STATE(2608),
    [sym_labeled_statement] = STATE(2608),
    [sym_expression_statement] = STATE(2608),
    [sym_if_statement] = STATE(2608),
    [sym_switch_statement] = STATE(2608),
    [sym_case_statement] = STATE(2608),
    [sym_while_statement] = STATE(2608),
    [sym_do_statement] = STATE(2608),
    [sym_for_statement] = STATE(2608),
    [sym_return_statement] = STATE(2608),
    [sym_break_statement] = STATE(2608),
    [sym_continue_statement] = STATE(2608),
    [sym_goto_statement] = STATE(2608),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(2608),
    [sym_try_statement] = STATE(2608),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7431),
    [anon_sym_switch] = ACTIONS(7433),
    [anon_sym_case] = ACTIONS(7435),
    [anon_sym_default] = ACTIONS(7437),
    [anon_sym_while] = ACTIONS(7439),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(7441),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(7443),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7445),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2242),
  },
  [3498] = {
    [sym_catch_clause] = STATE(3630),
    [aux_sym_try_statement_repeat1] = STATE(3630),
    [sym_comment] = ACTIONS(91),
    [anon_sym_catch] = ACTIONS(5723),
  },
  [3499] = {
    [sym_compound_statement] = STATE(3631),
    [sym_labeled_statement] = STATE(3631),
    [sym_expression_statement] = STATE(3631),
    [sym_if_statement] = STATE(3631),
    [sym_switch_statement] = STATE(3631),
    [sym_case_statement] = STATE(3631),
    [sym_while_statement] = STATE(3631),
    [sym_do_statement] = STATE(3631),
    [sym_for_statement] = STATE(3631),
    [sym_return_statement] = STATE(3631),
    [sym_break_statement] = STATE(3631),
    [sym_continue_statement] = STATE(3631),
    [sym_goto_statement] = STATE(3631),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(3631),
    [sym_try_statement] = STATE(3631),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(2220),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(5705),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2242),
  },
  [3500] = {
    [sym_raw_string_literal] = ACTIONS(7063),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7065),
    [sym_preproc_directive] = ACTIONS(7065),
    [anon_sym_SEMI] = ACTIONS(7063),
    [anon_sym_typedef] = ACTIONS(7065),
    [anon_sym_extern] = ACTIONS(7065),
    [anon_sym_LBRACE] = ACTIONS(7063),
    [anon_sym_LPAREN2] = ACTIONS(7063),
    [anon_sym_STAR] = ACTIONS(7063),
    [anon_sym_LBRACK] = ACTIONS(7063),
    [anon_sym_static] = ACTIONS(7065),
    [anon_sym_register] = ACTIONS(7065),
    [anon_sym_inline] = ACTIONS(7065),
    [anon_sym_const] = ACTIONS(7065),
    [anon_sym_restrict] = ACTIONS(7065),
    [anon_sym_volatile] = ACTIONS(7065),
    [anon_sym__Atomic] = ACTIONS(7065),
    [anon_sym_mutable] = ACTIONS(7065),
    [anon_sym_explicit] = ACTIONS(7065),
    [anon_sym_constexpr] = ACTIONS(7065),
    [anon_sym_unsigned] = ACTIONS(7065),
    [anon_sym_long] = ACTIONS(7065),
    [anon_sym_short] = ACTIONS(7065),
    [sym_primitive_type] = ACTIONS(7065),
    [anon_sym_enum] = ACTIONS(7065),
    [anon_sym_struct] = ACTIONS(7065),
    [anon_sym_union] = ACTIONS(7065),
    [anon_sym_if] = ACTIONS(7065),
    [anon_sym_else] = ACTIONS(8058),
    [anon_sym_switch] = ACTIONS(7065),
    [anon_sym_case] = ACTIONS(7065),
    [anon_sym_default] = ACTIONS(7065),
    [anon_sym_while] = ACTIONS(7065),
    [anon_sym_do] = ACTIONS(7065),
    [anon_sym_for] = ACTIONS(7065),
    [anon_sym_return] = ACTIONS(7065),
    [anon_sym_break] = ACTIONS(7065),
    [anon_sym_continue] = ACTIONS(7065),
    [anon_sym_goto] = ACTIONS(7065),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_BANG] = ACTIONS(7063),
    [anon_sym_TILDE] = ACTIONS(7063),
    [anon_sym_PLUS] = ACTIONS(7065),
    [anon_sym_DASH] = ACTIONS(7065),
    [anon_sym_DASH_DASH] = ACTIONS(7063),
    [anon_sym_PLUS_PLUS] = ACTIONS(7063),
    [anon_sym_sizeof] = ACTIONS(7065),
    [sym_number_literal] = ACTIONS(7063),
    [anon_sym_SQUOTE] = ACTIONS(7063),
    [anon_sym_DQUOTE] = ACTIONS(7063),
    [sym_true] = ACTIONS(7065),
    [sym_false] = ACTIONS(7065),
    [sym_null] = ACTIONS(7065),
    [sym_identifier] = ACTIONS(7065),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7065),
    [sym_auto] = ACTIONS(7065),
    [anon_sym_typename] = ACTIONS(7065),
    [anon_sym_delete] = ACTIONS(7065),
    [anon_sym_try] = ACTIONS(7065),
    [anon_sym_new] = ACTIONS(7065),
    [anon_sym_COLON_COLON] = ACTIONS(7063),
    [sym_nullptr] = ACTIONS(7065),
  },
  [3501] = {
    [sym_raw_string_literal] = ACTIONS(2475),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2477),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2477),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2477),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2477),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2477),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2477),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2477),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2477),
    [sym_preproc_directive] = ACTIONS(2477),
    [anon_sym_SEMI] = ACTIONS(2475),
    [anon_sym_typedef] = ACTIONS(2477),
    [anon_sym_extern] = ACTIONS(2477),
    [anon_sym_LBRACE] = ACTIONS(2475),
    [anon_sym_LPAREN2] = ACTIONS(2475),
    [anon_sym_STAR] = ACTIONS(2475),
    [anon_sym_LBRACK] = ACTIONS(2475),
    [anon_sym_static] = ACTIONS(2477),
    [anon_sym_register] = ACTIONS(2477),
    [anon_sym_inline] = ACTIONS(2477),
    [anon_sym_const] = ACTIONS(2477),
    [anon_sym_restrict] = ACTIONS(2477),
    [anon_sym_volatile] = ACTIONS(2477),
    [anon_sym__Atomic] = ACTIONS(2477),
    [anon_sym_mutable] = ACTIONS(2477),
    [anon_sym_explicit] = ACTIONS(2477),
    [anon_sym_constexpr] = ACTIONS(2477),
    [anon_sym_unsigned] = ACTIONS(2477),
    [anon_sym_long] = ACTIONS(2477),
    [anon_sym_short] = ACTIONS(2477),
    [sym_primitive_type] = ACTIONS(2477),
    [anon_sym_enum] = ACTIONS(2477),
    [anon_sym_struct] = ACTIONS(2477),
    [anon_sym_union] = ACTIONS(2477),
    [anon_sym_if] = ACTIONS(2477),
    [anon_sym_else] = ACTIONS(2477),
    [anon_sym_switch] = ACTIONS(2477),
    [anon_sym_case] = ACTIONS(2477),
    [anon_sym_default] = ACTIONS(2477),
    [anon_sym_while] = ACTIONS(2477),
    [anon_sym_do] = ACTIONS(2477),
    [anon_sym_for] = ACTIONS(2477),
    [anon_sym_return] = ACTIONS(2477),
    [anon_sym_break] = ACTIONS(2477),
    [anon_sym_continue] = ACTIONS(2477),
    [anon_sym_goto] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2475),
    [anon_sym_BANG] = ACTIONS(2475),
    [anon_sym_TILDE] = ACTIONS(2475),
    [anon_sym_PLUS] = ACTIONS(2477),
    [anon_sym_DASH] = ACTIONS(2477),
    [anon_sym_DASH_DASH] = ACTIONS(2475),
    [anon_sym_PLUS_PLUS] = ACTIONS(2475),
    [anon_sym_sizeof] = ACTIONS(2477),
    [sym_number_literal] = ACTIONS(2475),
    [anon_sym_SQUOTE] = ACTIONS(2475),
    [anon_sym_DQUOTE] = ACTIONS(2475),
    [sym_true] = ACTIONS(2477),
    [sym_false] = ACTIONS(2477),
    [sym_null] = ACTIONS(2477),
    [sym_identifier] = ACTIONS(2477),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2477),
    [sym_auto] = ACTIONS(2477),
    [anon_sym_typename] = ACTIONS(2477),
    [anon_sym_delete] = ACTIONS(2477),
    [anon_sym_try] = ACTIONS(2477),
    [anon_sym_new] = ACTIONS(2477),
    [anon_sym_COLON_COLON] = ACTIONS(2475),
    [sym_nullptr] = ACTIONS(2477),
  },
  [3502] = {
    [sym_raw_string_literal] = ACTIONS(7095),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7097),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7097),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7097),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7097),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7097),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7097),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7097),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7097),
    [sym_preproc_directive] = ACTIONS(7097),
    [anon_sym_SEMI] = ACTIONS(7095),
    [anon_sym_typedef] = ACTIONS(7097),
    [anon_sym_extern] = ACTIONS(7097),
    [anon_sym_LBRACE] = ACTIONS(7095),
    [anon_sym_LPAREN2] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7095),
    [anon_sym_LBRACK] = ACTIONS(7095),
    [anon_sym_static] = ACTIONS(7097),
    [anon_sym_register] = ACTIONS(7097),
    [anon_sym_inline] = ACTIONS(7097),
    [anon_sym_const] = ACTIONS(7097),
    [anon_sym_restrict] = ACTIONS(7097),
    [anon_sym_volatile] = ACTIONS(7097),
    [anon_sym__Atomic] = ACTIONS(7097),
    [anon_sym_mutable] = ACTIONS(7097),
    [anon_sym_explicit] = ACTIONS(7097),
    [anon_sym_constexpr] = ACTIONS(7097),
    [anon_sym_unsigned] = ACTIONS(7097),
    [anon_sym_long] = ACTIONS(7097),
    [anon_sym_short] = ACTIONS(7097),
    [sym_primitive_type] = ACTIONS(7097),
    [anon_sym_enum] = ACTIONS(7097),
    [anon_sym_struct] = ACTIONS(7097),
    [anon_sym_union] = ACTIONS(7097),
    [anon_sym_if] = ACTIONS(7097),
    [anon_sym_else] = ACTIONS(7097),
    [anon_sym_switch] = ACTIONS(7097),
    [anon_sym_case] = ACTIONS(7097),
    [anon_sym_default] = ACTIONS(7097),
    [anon_sym_while] = ACTIONS(7097),
    [anon_sym_do] = ACTIONS(7097),
    [anon_sym_for] = ACTIONS(7097),
    [anon_sym_return] = ACTIONS(7097),
    [anon_sym_break] = ACTIONS(7097),
    [anon_sym_continue] = ACTIONS(7097),
    [anon_sym_goto] = ACTIONS(7097),
    [anon_sym_AMP] = ACTIONS(7095),
    [anon_sym_BANG] = ACTIONS(7095),
    [anon_sym_TILDE] = ACTIONS(7095),
    [anon_sym_PLUS] = ACTIONS(7097),
    [anon_sym_DASH] = ACTIONS(7097),
    [anon_sym_DASH_DASH] = ACTIONS(7095),
    [anon_sym_PLUS_PLUS] = ACTIONS(7095),
    [anon_sym_sizeof] = ACTIONS(7097),
    [sym_number_literal] = ACTIONS(7095),
    [anon_sym_SQUOTE] = ACTIONS(7095),
    [anon_sym_DQUOTE] = ACTIONS(7095),
    [sym_true] = ACTIONS(7097),
    [sym_false] = ACTIONS(7097),
    [sym_null] = ACTIONS(7097),
    [sym_identifier] = ACTIONS(7097),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7097),
    [sym_auto] = ACTIONS(7097),
    [anon_sym_typename] = ACTIONS(7097),
    [anon_sym_delete] = ACTIONS(7097),
    [anon_sym_try] = ACTIONS(7097),
    [anon_sym_new] = ACTIONS(7097),
    [anon_sym_COLON_COLON] = ACTIONS(7095),
    [sym_nullptr] = ACTIONS(7097),
  },
  [3503] = {
    [sym_compound_statement] = STATE(3633),
    [sym_labeled_statement] = STATE(3633),
    [sym_expression_statement] = STATE(3633),
    [sym_if_statement] = STATE(3633),
    [sym_switch_statement] = STATE(3633),
    [sym_case_statement] = STATE(3633),
    [sym_while_statement] = STATE(3633),
    [sym_do_statement] = STATE(3633),
    [sym_for_statement] = STATE(3633),
    [sym_return_statement] = STATE(3633),
    [sym_break_statement] = STATE(3633),
    [sym_continue_statement] = STATE(3633),
    [sym_goto_statement] = STATE(3633),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(3633),
    [sym_try_statement] = STATE(3633),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(2220),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(5705),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2242),
  },
  [3504] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8060),
    [sym_comment] = ACTIONS(91),
  },
  [3505] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3635),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8060),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3506] = {
    [sym__expression] = STATE(3636),
    [sym_conditional_expression] = STATE(3636),
    [sym_assignment_expression] = STATE(3636),
    [sym_pointer_expression] = STATE(3636),
    [sym_logical_expression] = STATE(3636),
    [sym_bitwise_expression] = STATE(3636),
    [sym_equality_expression] = STATE(3636),
    [sym_relational_expression] = STATE(3636),
    [sym_shift_expression] = STATE(3636),
    [sym_math_expression] = STATE(3636),
    [sym_cast_expression] = STATE(3636),
    [sym_sizeof_expression] = STATE(3636),
    [sym_subscript_expression] = STATE(3636),
    [sym_call_expression] = STATE(3636),
    [sym_field_expression] = STATE(3636),
    [sym_compound_literal_expression] = STATE(3636),
    [sym_parenthesized_expression] = STATE(3636),
    [sym_char_literal] = STATE(3636),
    [sym_concatenated_string] = STATE(3636),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3636),
    [sym_new_expression] = STATE(3636),
    [sym_delete_expression] = STATE(3636),
    [sym_lambda_expression] = STATE(3636),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8062),
    [anon_sym_RPAREN] = ACTIONS(8060),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(8062),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8064),
    [sym_false] = ACTIONS(8064),
    [sym_null] = ACTIONS(8064),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(8064),
  },
  [3507] = {
    [sym_compound_statement] = STATE(3637),
    [sym_labeled_statement] = STATE(3637),
    [sym_expression_statement] = STATE(3637),
    [sym_if_statement] = STATE(3637),
    [sym_switch_statement] = STATE(3637),
    [sym_case_statement] = STATE(3637),
    [sym_while_statement] = STATE(3637),
    [sym_do_statement] = STATE(3637),
    [sym_for_statement] = STATE(3637),
    [sym_return_statement] = STATE(3637),
    [sym_break_statement] = STATE(3637),
    [sym_continue_statement] = STATE(3637),
    [sym_goto_statement] = STATE(3637),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(3637),
    [sym_try_statement] = STATE(3637),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(2220),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(5705),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2242),
  },
  [3508] = {
    [sym_compound_statement] = STATE(3638),
    [sym_labeled_statement] = STATE(3638),
    [sym_expression_statement] = STATE(3638),
    [sym_if_statement] = STATE(3638),
    [sym_switch_statement] = STATE(3638),
    [sym_case_statement] = STATE(3638),
    [sym_while_statement] = STATE(3638),
    [sym_do_statement] = STATE(3638),
    [sym_for_statement] = STATE(3638),
    [sym_return_statement] = STATE(3638),
    [sym_break_statement] = STATE(3638),
    [sym_continue_statement] = STATE(3638),
    [sym_goto_statement] = STATE(3638),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(3638),
    [sym_try_statement] = STATE(3638),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(157),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(5814),
    [anon_sym_switch] = ACTIONS(5816),
    [anon_sym_case] = ACTIONS(5818),
    [anon_sym_default] = ACTIONS(5820),
    [anon_sym_while] = ACTIONS(5822),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(5824),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(5826),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(5828),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(207),
  },
  [3509] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(8066),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3510] = {
    [sym__expression] = STATE(3641),
    [sym_conditional_expression] = STATE(3641),
    [sym_assignment_expression] = STATE(3641),
    [sym_pointer_expression] = STATE(3641),
    [sym_logical_expression] = STATE(3641),
    [sym_bitwise_expression] = STATE(3641),
    [sym_equality_expression] = STATE(3641),
    [sym_relational_expression] = STATE(3641),
    [sym_shift_expression] = STATE(3641),
    [sym_math_expression] = STATE(3641),
    [sym_cast_expression] = STATE(3641),
    [sym_sizeof_expression] = STATE(3641),
    [sym_subscript_expression] = STATE(3641),
    [sym_call_expression] = STATE(3641),
    [sym_field_expression] = STATE(3641),
    [sym_compound_literal_expression] = STATE(3641),
    [sym_parenthesized_expression] = STATE(3641),
    [sym_char_literal] = STATE(3641),
    [sym_concatenated_string] = STATE(3641),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3641),
    [sym_new_expression] = STATE(3641),
    [sym_delete_expression] = STATE(3641),
    [sym_lambda_expression] = STATE(3641),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8068),
    [anon_sym_RPAREN] = ACTIONS(8070),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(8068),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8072),
    [sym_false] = ACTIONS(8072),
    [sym_null] = ACTIONS(8072),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(8072),
  },
  [3511] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(8074),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3512] = {
    [sym__expression] = STATE(3643),
    [sym_conditional_expression] = STATE(3643),
    [sym_assignment_expression] = STATE(3643),
    [sym_pointer_expression] = STATE(3643),
    [sym_logical_expression] = STATE(3643),
    [sym_bitwise_expression] = STATE(3643),
    [sym_equality_expression] = STATE(3643),
    [sym_relational_expression] = STATE(3643),
    [sym_shift_expression] = STATE(3643),
    [sym_math_expression] = STATE(3643),
    [sym_cast_expression] = STATE(3643),
    [sym_sizeof_expression] = STATE(3643),
    [sym_subscript_expression] = STATE(3643),
    [sym_call_expression] = STATE(3643),
    [sym_field_expression] = STATE(3643),
    [sym_compound_literal_expression] = STATE(3643),
    [sym_parenthesized_expression] = STATE(3643),
    [sym_char_literal] = STATE(3643),
    [sym_concatenated_string] = STATE(3643),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3643),
    [sym_new_expression] = STATE(3643),
    [sym_delete_expression] = STATE(3643),
    [sym_lambda_expression] = STATE(3643),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8076),
    [anon_sym_SEMI] = ACTIONS(8074),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(8076),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8078),
    [sym_false] = ACTIONS(8078),
    [sym_null] = ACTIONS(8078),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(8078),
  },
  [3513] = {
    [sym__expression] = STATE(3644),
    [sym_conditional_expression] = STATE(3644),
    [sym_assignment_expression] = STATE(3644),
    [sym_pointer_expression] = STATE(3644),
    [sym_logical_expression] = STATE(3644),
    [sym_bitwise_expression] = STATE(3644),
    [sym_equality_expression] = STATE(3644),
    [sym_relational_expression] = STATE(3644),
    [sym_shift_expression] = STATE(3644),
    [sym_math_expression] = STATE(3644),
    [sym_cast_expression] = STATE(3644),
    [sym_sizeof_expression] = STATE(3644),
    [sym_subscript_expression] = STATE(3644),
    [sym_call_expression] = STATE(3644),
    [sym_field_expression] = STATE(3644),
    [sym_compound_literal_expression] = STATE(3644),
    [sym_parenthesized_expression] = STATE(3644),
    [sym_char_literal] = STATE(3644),
    [sym_concatenated_string] = STATE(3644),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3644),
    [sym_new_expression] = STATE(3644),
    [sym_delete_expression] = STATE(3644),
    [sym_lambda_expression] = STATE(3644),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8080),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(8080),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8082),
    [sym_false] = ACTIONS(8082),
    [sym_null] = ACTIONS(8082),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(8082),
  },
  [3514] = {
    [sym_catch_clause] = STATE(3514),
    [aux_sym_try_statement_repeat1] = STATE(3514),
    [sym_raw_string_literal] = ACTIONS(4993),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4995),
    [sym_preproc_directive] = ACTIONS(4995),
    [anon_sym_SEMI] = ACTIONS(4993),
    [anon_sym_typedef] = ACTIONS(4995),
    [anon_sym_extern] = ACTIONS(4995),
    [anon_sym_LBRACE] = ACTIONS(4993),
    [anon_sym_RBRACE] = ACTIONS(4993),
    [anon_sym_LPAREN2] = ACTIONS(4993),
    [anon_sym_STAR] = ACTIONS(4993),
    [anon_sym_LBRACK] = ACTIONS(4993),
    [anon_sym_static] = ACTIONS(4995),
    [anon_sym_register] = ACTIONS(4995),
    [anon_sym_inline] = ACTIONS(4995),
    [anon_sym_const] = ACTIONS(4995),
    [anon_sym_restrict] = ACTIONS(4995),
    [anon_sym_volatile] = ACTIONS(4995),
    [anon_sym__Atomic] = ACTIONS(4995),
    [anon_sym_mutable] = ACTIONS(4995),
    [anon_sym_explicit] = ACTIONS(4995),
    [anon_sym_constexpr] = ACTIONS(4995),
    [anon_sym_unsigned] = ACTIONS(4995),
    [anon_sym_long] = ACTIONS(4995),
    [anon_sym_short] = ACTIONS(4995),
    [sym_primitive_type] = ACTIONS(4995),
    [anon_sym_enum] = ACTIONS(4995),
    [anon_sym_struct] = ACTIONS(4995),
    [anon_sym_union] = ACTIONS(4995),
    [anon_sym_if] = ACTIONS(4995),
    [anon_sym_else] = ACTIONS(4995),
    [anon_sym_switch] = ACTIONS(4995),
    [anon_sym_case] = ACTIONS(4995),
    [anon_sym_default] = ACTIONS(4995),
    [anon_sym_while] = ACTIONS(4995),
    [anon_sym_do] = ACTIONS(4995),
    [anon_sym_for] = ACTIONS(4995),
    [anon_sym_return] = ACTIONS(4995),
    [anon_sym_break] = ACTIONS(4995),
    [anon_sym_continue] = ACTIONS(4995),
    [anon_sym_goto] = ACTIONS(4995),
    [anon_sym_AMP] = ACTIONS(4993),
    [anon_sym_BANG] = ACTIONS(4993),
    [anon_sym_TILDE] = ACTIONS(4993),
    [anon_sym_PLUS] = ACTIONS(4995),
    [anon_sym_DASH] = ACTIONS(4995),
    [anon_sym_DASH_DASH] = ACTIONS(4993),
    [anon_sym_PLUS_PLUS] = ACTIONS(4993),
    [anon_sym_sizeof] = ACTIONS(4995),
    [sym_number_literal] = ACTIONS(4993),
    [anon_sym_SQUOTE] = ACTIONS(4993),
    [anon_sym_DQUOTE] = ACTIONS(4993),
    [sym_true] = ACTIONS(4995),
    [sym_false] = ACTIONS(4995),
    [sym_null] = ACTIONS(4995),
    [sym_identifier] = ACTIONS(4995),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4995),
    [sym_auto] = ACTIONS(4995),
    [anon_sym_typename] = ACTIONS(4995),
    [anon_sym_delete] = ACTIONS(4995),
    [anon_sym_try] = ACTIONS(4995),
    [anon_sym_catch] = ACTIONS(5848),
    [anon_sym_new] = ACTIONS(4995),
    [anon_sym_COLON_COLON] = ACTIONS(4993),
    [sym_nullptr] = ACTIONS(4995),
  },
  [3515] = {
    [sym_raw_string_literal] = ACTIONS(7906),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7908),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7908),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7908),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7908),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7908),
    [sym_preproc_directive] = ACTIONS(7908),
    [anon_sym_SEMI] = ACTIONS(7906),
    [anon_sym_typedef] = ACTIONS(7908),
    [anon_sym_extern] = ACTIONS(7908),
    [anon_sym_LBRACE] = ACTIONS(7906),
    [anon_sym_RBRACE] = ACTIONS(7906),
    [anon_sym_LPAREN2] = ACTIONS(7906),
    [anon_sym_STAR] = ACTIONS(7906),
    [anon_sym_LBRACK] = ACTIONS(7906),
    [anon_sym_static] = ACTIONS(7908),
    [anon_sym_register] = ACTIONS(7908),
    [anon_sym_inline] = ACTIONS(7908),
    [anon_sym_const] = ACTIONS(7908),
    [anon_sym_restrict] = ACTIONS(7908),
    [anon_sym_volatile] = ACTIONS(7908),
    [anon_sym__Atomic] = ACTIONS(7908),
    [anon_sym_mutable] = ACTIONS(7908),
    [anon_sym_explicit] = ACTIONS(7908),
    [anon_sym_constexpr] = ACTIONS(7908),
    [anon_sym_unsigned] = ACTIONS(7908),
    [anon_sym_long] = ACTIONS(7908),
    [anon_sym_short] = ACTIONS(7908),
    [sym_primitive_type] = ACTIONS(7908),
    [anon_sym_enum] = ACTIONS(7908),
    [anon_sym_struct] = ACTIONS(7908),
    [anon_sym_union] = ACTIONS(7908),
    [anon_sym_if] = ACTIONS(7908),
    [anon_sym_else] = ACTIONS(7908),
    [anon_sym_switch] = ACTIONS(7908),
    [anon_sym_case] = ACTIONS(7908),
    [anon_sym_default] = ACTIONS(7908),
    [anon_sym_while] = ACTIONS(7908),
    [anon_sym_do] = ACTIONS(7908),
    [anon_sym_for] = ACTIONS(7908),
    [anon_sym_return] = ACTIONS(7908),
    [anon_sym_break] = ACTIONS(7908),
    [anon_sym_continue] = ACTIONS(7908),
    [anon_sym_goto] = ACTIONS(7908),
    [anon_sym_AMP] = ACTIONS(7906),
    [anon_sym_BANG] = ACTIONS(7906),
    [anon_sym_TILDE] = ACTIONS(7906),
    [anon_sym_PLUS] = ACTIONS(7908),
    [anon_sym_DASH] = ACTIONS(7908),
    [anon_sym_DASH_DASH] = ACTIONS(7906),
    [anon_sym_PLUS_PLUS] = ACTIONS(7906),
    [anon_sym_sizeof] = ACTIONS(7908),
    [sym_number_literal] = ACTIONS(7906),
    [anon_sym_SQUOTE] = ACTIONS(7906),
    [anon_sym_DQUOTE] = ACTIONS(7906),
    [sym_true] = ACTIONS(7908),
    [sym_false] = ACTIONS(7908),
    [sym_null] = ACTIONS(7908),
    [sym_identifier] = ACTIONS(7908),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7908),
    [sym_auto] = ACTIONS(7908),
    [anon_sym_typename] = ACTIONS(7908),
    [anon_sym_delete] = ACTIONS(7908),
    [anon_sym_try] = ACTIONS(7908),
    [anon_sym_new] = ACTIONS(7908),
    [anon_sym_COLON_COLON] = ACTIONS(7906),
    [sym_nullptr] = ACTIONS(7908),
  },
  [3516] = {
    [sym_raw_string_literal] = ACTIONS(7928),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7930),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7930),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7930),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7930),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7930),
    [sym_preproc_directive] = ACTIONS(7930),
    [anon_sym_SEMI] = ACTIONS(7928),
    [anon_sym_typedef] = ACTIONS(7930),
    [anon_sym_extern] = ACTIONS(7930),
    [anon_sym_LBRACE] = ACTIONS(7928),
    [anon_sym_RBRACE] = ACTIONS(7928),
    [anon_sym_LPAREN2] = ACTIONS(7928),
    [anon_sym_STAR] = ACTIONS(7928),
    [anon_sym_LBRACK] = ACTIONS(7928),
    [anon_sym_static] = ACTIONS(7930),
    [anon_sym_register] = ACTIONS(7930),
    [anon_sym_inline] = ACTIONS(7930),
    [anon_sym_const] = ACTIONS(7930),
    [anon_sym_restrict] = ACTIONS(7930),
    [anon_sym_volatile] = ACTIONS(7930),
    [anon_sym__Atomic] = ACTIONS(7930),
    [anon_sym_mutable] = ACTIONS(7930),
    [anon_sym_explicit] = ACTIONS(7930),
    [anon_sym_constexpr] = ACTIONS(7930),
    [anon_sym_unsigned] = ACTIONS(7930),
    [anon_sym_long] = ACTIONS(7930),
    [anon_sym_short] = ACTIONS(7930),
    [sym_primitive_type] = ACTIONS(7930),
    [anon_sym_enum] = ACTIONS(7930),
    [anon_sym_struct] = ACTIONS(7930),
    [anon_sym_union] = ACTIONS(7930),
    [anon_sym_if] = ACTIONS(7930),
    [anon_sym_else] = ACTIONS(7930),
    [anon_sym_switch] = ACTIONS(7930),
    [anon_sym_case] = ACTIONS(7930),
    [anon_sym_default] = ACTIONS(7930),
    [anon_sym_while] = ACTIONS(7930),
    [anon_sym_do] = ACTIONS(7930),
    [anon_sym_for] = ACTIONS(7930),
    [anon_sym_return] = ACTIONS(7930),
    [anon_sym_break] = ACTIONS(7930),
    [anon_sym_continue] = ACTIONS(7930),
    [anon_sym_goto] = ACTIONS(7930),
    [anon_sym_AMP] = ACTIONS(7928),
    [anon_sym_BANG] = ACTIONS(7928),
    [anon_sym_TILDE] = ACTIONS(7928),
    [anon_sym_PLUS] = ACTIONS(7930),
    [anon_sym_DASH] = ACTIONS(7930),
    [anon_sym_DASH_DASH] = ACTIONS(7928),
    [anon_sym_PLUS_PLUS] = ACTIONS(7928),
    [anon_sym_sizeof] = ACTIONS(7930),
    [sym_number_literal] = ACTIONS(7928),
    [anon_sym_SQUOTE] = ACTIONS(7928),
    [anon_sym_DQUOTE] = ACTIONS(7928),
    [sym_true] = ACTIONS(7930),
    [sym_false] = ACTIONS(7930),
    [sym_null] = ACTIONS(7930),
    [sym_identifier] = ACTIONS(7930),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7930),
    [sym_auto] = ACTIONS(7930),
    [anon_sym_typename] = ACTIONS(7930),
    [anon_sym_delete] = ACTIONS(7930),
    [anon_sym_try] = ACTIONS(7930),
    [anon_sym_new] = ACTIONS(7930),
    [anon_sym_COLON_COLON] = ACTIONS(7928),
    [sym_nullptr] = ACTIONS(7930),
  },
  [3517] = {
    [sym_compound_statement] = STATE(3645),
    [sym_labeled_statement] = STATE(3645),
    [sym_expression_statement] = STATE(3645),
    [sym_if_statement] = STATE(3645),
    [sym_switch_statement] = STATE(3645),
    [sym_case_statement] = STATE(3645),
    [sym_while_statement] = STATE(3645),
    [sym_do_statement] = STATE(3645),
    [sym_for_statement] = STATE(3645),
    [sym_return_statement] = STATE(3645),
    [sym_break_statement] = STATE(3645),
    [sym_continue_statement] = STATE(3645),
    [sym_goto_statement] = STATE(3645),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(3645),
    [sym_try_statement] = STATE(3645),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(157),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(185),
    [anon_sym_case] = ACTIONS(187),
    [anon_sym_default] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(2262),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(207),
  },
  [3518] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8084),
    [sym_comment] = ACTIONS(91),
  },
  [3519] = {
    [sym_field_declaration_list] = STATE(424),
    [sym_virtual_specifier] = STATE(425),
    [sym_base_class_clause] = STATE(426),
    [sym_template_type] = STATE(3648),
    [sym_scoped_type_identifier] = STATE(3649),
    [sym_scoped_namespace_identifier] = STATE(83),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(8086),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [3520] = {
    [sym_field_declaration_list] = STATE(430),
    [sym_virtual_specifier] = STATE(431),
    [sym_base_class_clause] = STATE(432),
    [sym_template_type] = STATE(3651),
    [sym_scoped_type_identifier] = STATE(3652),
    [sym_scoped_namespace_identifier] = STATE(83),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(8088),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [3521] = {
    [sym_field_declaration_list] = STATE(439),
    [sym_virtual_specifier] = STATE(440),
    [sym_base_class_clause] = STATE(441),
    [sym_template_type] = STATE(3654),
    [sym_scoped_type_identifier] = STATE(3655),
    [sym_scoped_namespace_identifier] = STATE(83),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_COLON] = ACTIONS(309),
    [sym_identifier] = ACTIONS(8090),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(313),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [3522] = {
    [sym__type_specifier] = STATE(444),
    [sym_sized_type_specifier] = STATE(444),
    [sym_enum_specifier] = STATE(444),
    [sym_struct_specifier] = STATE(444),
    [sym_union_specifier] = STATE(444),
    [sym_macro_type_specifier] = STATE(444),
    [sym_class_specifier] = STATE(444),
    [sym_dependent_type] = STATE(444),
    [sym_template_type] = STATE(81),
    [sym_scoped_type_identifier] = STATE(1691),
    [sym_scoped_namespace_identifier] = STATE(83),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3524),
    [anon_sym_unsigned] = ACTIONS(7863),
    [anon_sym_long] = ACTIONS(7863),
    [anon_sym_short] = ACTIONS(7863),
    [sym_primitive_type] = ACTIONS(762),
    [anon_sym_enum] = ACTIONS(139),
    [anon_sym_struct] = ACTIONS(7867),
    [anon_sym_union] = ACTIONS(7869),
    [sym_identifier] = ACTIONS(869),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7871),
    [sym_auto] = ACTIONS(762),
    [anon_sym_typename] = ACTIONS(7873),
    [anon_sym_COLON_COLON] = ACTIONS(151),
  },
  [3523] = {
    [sym__abstract_declarator] = STATE(3658),
    [sym_abstract_pointer_declarator] = STATE(3658),
    [sym_abstract_function_declarator] = STATE(3658),
    [sym_abstract_array_declarator] = STATE(3658),
    [sym_parameter_list] = STATE(3659),
    [sym_abstract_reference_declarator] = STATE(3658),
    [anon_sym_COMMA] = ACTIONS(5222),
    [anon_sym_SEMI] = ACTIONS(5222),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(8092),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_const] = ACTIONS(5226),
    [anon_sym_restrict] = ACTIONS(5222),
    [anon_sym_volatile] = ACTIONS(5222),
    [anon_sym__Atomic] = ACTIONS(5222),
    [anon_sym_mutable] = ACTIONS(5222),
    [anon_sym_explicit] = ACTIONS(5222),
    [anon_sym_constexpr] = ACTIONS(5222),
    [anon_sym_COLON] = ACTIONS(5222),
    [anon_sym_AMP] = ACTIONS(8094),
    [anon_sym_AMP_AMP] = ACTIONS(8096),
    [anon_sym_DASH_GT] = ACTIONS(5222),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5222),
    [anon_sym_override] = ACTIONS(5222),
    [sym_noexcept] = ACTIONS(5222),
  },
  [3524] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3660),
    [anon_sym_COMMA] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(653),
    [anon_sym_LPAREN2] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(655),
    [anon_sym_restrict] = ACTIONS(655),
    [anon_sym_volatile] = ACTIONS(655),
    [anon_sym__Atomic] = ACTIONS(655),
    [anon_sym_mutable] = ACTIONS(655),
    [anon_sym_explicit] = ACTIONS(655),
    [anon_sym_constexpr] = ACTIONS(655),
    [anon_sym_unsigned] = ACTIONS(8098),
    [anon_sym_long] = ACTIONS(8098),
    [anon_sym_short] = ACTIONS(8098),
    [sym_primitive_type] = ACTIONS(778),
    [anon_sym_COLON] = ACTIONS(653),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [anon_sym_DASH_GT] = ACTIONS(653),
    [sym_identifier] = ACTIONS(5234),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(655),
    [anon_sym_override] = ACTIONS(655),
    [sym_noexcept] = ACTIONS(655),
  },
  [3525] = {
    [sym_type_qualifier] = STATE(3525),
    [sym_virtual_specifier] = STATE(3525),
    [sym_trailing_return_type] = STATE(3525),
    [aux_sym_function_declarator_repeat1] = STATE(3525),
    [anon_sym_COMMA] = ACTIONS(5236),
    [anon_sym_SEMI] = ACTIONS(5236),
    [anon_sym_LPAREN2] = ACTIONS(5236),
    [anon_sym_LBRACK] = ACTIONS(5236),
    [anon_sym_const] = ACTIONS(5238),
    [anon_sym_restrict] = ACTIONS(5241),
    [anon_sym_volatile] = ACTIONS(5241),
    [anon_sym__Atomic] = ACTIONS(5241),
    [anon_sym_mutable] = ACTIONS(5241),
    [anon_sym_explicit] = ACTIONS(5241),
    [anon_sym_constexpr] = ACTIONS(5241),
    [anon_sym_COLON] = ACTIONS(5236),
    [anon_sym_DASH_GT] = ACTIONS(8100),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5247),
    [anon_sym_override] = ACTIONS(5247),
    [sym_noexcept] = ACTIONS(8103),
  },
  [3526] = {
    [sym_parameter_list] = STATE(3529),
    [anon_sym_COMMA] = ACTIONS(4157),
    [anon_sym_SEMI] = ACTIONS(4157),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(4157),
    [anon_sym_const] = ACTIONS(7279),
    [anon_sym_restrict] = ACTIONS(4157),
    [anon_sym_volatile] = ACTIONS(4157),
    [anon_sym__Atomic] = ACTIONS(4157),
    [anon_sym_mutable] = ACTIONS(4157),
    [anon_sym_explicit] = ACTIONS(4157),
    [anon_sym_constexpr] = ACTIONS(4157),
    [anon_sym_COLON] = ACTIONS(4157),
    [anon_sym_DASH_GT] = ACTIONS(4157),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4157),
    [anon_sym_override] = ACTIONS(4157),
    [sym_noexcept] = ACTIONS(4157),
  },
  [3527] = {
    [sym__abstract_declarator] = STATE(3661),
    [sym_abstract_pointer_declarator] = STATE(3661),
    [sym_abstract_function_declarator] = STATE(3661),
    [sym_abstract_array_declarator] = STATE(3661),
    [sym_type_qualifier] = STATE(3662),
    [sym_parameter_list] = STATE(3351),
    [sym_abstract_reference_declarator] = STATE(3661),
    [aux_sym_type_definition_repeat1] = STATE(3662),
    [anon_sym_COMMA] = ACTIONS(4157),
    [anon_sym_SEMI] = ACTIONS(4157),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(7526),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_EQ] = ACTIONS(4157),
    [anon_sym_const] = ACTIONS(1667),
    [anon_sym_restrict] = ACTIONS(1669),
    [anon_sym_volatile] = ACTIONS(1669),
    [anon_sym__Atomic] = ACTIONS(1669),
    [anon_sym_mutable] = ACTIONS(1669),
    [anon_sym_explicit] = ACTIONS(1669),
    [anon_sym_constexpr] = ACTIONS(1669),
    [anon_sym_COLON] = ACTIONS(4157),
    [anon_sym_AMP] = ACTIONS(7528),
    [anon_sym_AMP_AMP] = ACTIONS(7530),
    [anon_sym_DASH_GT] = ACTIONS(4157),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4157),
    [anon_sym_override] = ACTIONS(4157),
    [sym_noexcept] = ACTIONS(4157),
  },
  [3528] = {
    [sym_parameter_list] = STATE(3529),
    [anon_sym_COMMA] = ACTIONS(4159),
    [anon_sym_SEMI] = ACTIONS(4159),
    [anon_sym_LBRACE] = ACTIONS(4159),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_const] = ACTIONS(7281),
    [anon_sym_restrict] = ACTIONS(4159),
    [anon_sym_volatile] = ACTIONS(4159),
    [anon_sym__Atomic] = ACTIONS(4159),
    [anon_sym_mutable] = ACTIONS(4159),
    [anon_sym_explicit] = ACTIONS(4159),
    [anon_sym_constexpr] = ACTIONS(4159),
    [anon_sym_COLON] = ACTIONS(4159),
    [anon_sym_DASH_GT] = ACTIONS(4159),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4159),
    [anon_sym_override] = ACTIONS(4159),
    [sym_noexcept] = ACTIONS(4159),
  },
  [3529] = {
    [sym_type_qualifier] = STATE(3663),
    [sym_trailing_return_type] = STATE(1720),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3663),
    [anon_sym_COMMA] = ACTIONS(3663),
    [anon_sym_SEMI] = ACTIONS(3663),
    [anon_sym_LBRACE] = ACTIONS(3663),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_EQ] = ACTIONS(3663),
    [anon_sym_const] = ACTIONS(3685),
    [anon_sym_restrict] = ACTIONS(3663),
    [anon_sym_volatile] = ACTIONS(3663),
    [anon_sym__Atomic] = ACTIONS(3663),
    [anon_sym_mutable] = ACTIONS(3663),
    [anon_sym_explicit] = ACTIONS(3663),
    [anon_sym_constexpr] = ACTIONS(3663),
    [anon_sym_COLON] = ACTIONS(3663),
    [anon_sym_DASH_GT] = ACTIONS(3663),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3663),
    [anon_sym_override] = ACTIONS(3663),
    [sym_noexcept] = ACTIONS(3663),
  },
  [3530] = {
    [sym_type_qualifier] = STATE(3664),
    [sym_trailing_return_type] = STATE(1720),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3664),
    [anon_sym_COMMA] = ACTIONS(3663),
    [anon_sym_SEMI] = ACTIONS(3663),
    [anon_sym_LBRACE] = ACTIONS(3663),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_EQ] = ACTIONS(3663),
    [anon_sym_const] = ACTIONS(1667),
    [anon_sym_restrict] = ACTIONS(1669),
    [anon_sym_volatile] = ACTIONS(1669),
    [anon_sym__Atomic] = ACTIONS(1669),
    [anon_sym_mutable] = ACTIONS(1669),
    [anon_sym_explicit] = ACTIONS(1669),
    [anon_sym_constexpr] = ACTIONS(1669),
    [anon_sym_COLON] = ACTIONS(3663),
    [anon_sym_DASH_GT] = ACTIONS(6013),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3663),
    [anon_sym_override] = ACTIONS(3663),
    [sym_noexcept] = ACTIONS(8106),
  },
  [3531] = {
    [sym_parameter_list] = STATE(3357),
    [anon_sym_SEMI] = ACTIONS(5889),
    [anon_sym_LBRACE] = ACTIONS(5889),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(5889),
    [anon_sym_const] = ACTIONS(7689),
    [anon_sym_restrict] = ACTIONS(5889),
    [anon_sym_volatile] = ACTIONS(5889),
    [anon_sym__Atomic] = ACTIONS(5889),
    [anon_sym_mutable] = ACTIONS(5889),
    [anon_sym_explicit] = ACTIONS(5889),
    [anon_sym_constexpr] = ACTIONS(5889),
    [anon_sym_COLON] = ACTIONS(5889),
    [anon_sym_DASH_GT] = ACTIONS(5889),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5889),
    [anon_sym_override] = ACTIONS(5889),
    [sym_noexcept] = ACTIONS(5889),
  },
  [3532] = {
    [sym_type_qualifier] = STATE(3532),
    [aux_sym_type_definition_repeat1] = STATE(3532),
    [anon_sym_SEMI] = ACTIONS(2179),
    [anon_sym_LBRACE] = ACTIONS(2179),
    [anon_sym_LPAREN2] = ACTIONS(2179),
    [anon_sym_STAR] = ACTIONS(2179),
    [anon_sym_LBRACK] = ACTIONS(2179),
    [anon_sym_EQ] = ACTIONS(2179),
    [anon_sym_const] = ACTIONS(7691),
    [anon_sym_restrict] = ACTIONS(7694),
    [anon_sym_volatile] = ACTIONS(7694),
    [anon_sym__Atomic] = ACTIONS(7694),
    [anon_sym_mutable] = ACTIONS(7694),
    [anon_sym_explicit] = ACTIONS(7694),
    [anon_sym_constexpr] = ACTIONS(7694),
    [anon_sym_COLON] = ACTIONS(2179),
    [anon_sym_AMP] = ACTIONS(2177),
    [anon_sym_AMP_AMP] = ACTIONS(2179),
    [anon_sym_DASH_GT] = ACTIONS(2179),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2179),
    [anon_sym_override] = ACTIONS(2179),
    [sym_noexcept] = ACTIONS(2179),
  },
  [3533] = {
    [sym_type_qualifier] = STATE(3534),
    [sym_trailing_return_type] = STATE(2418),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3534),
    [anon_sym_SEMI] = ACTIONS(5331),
    [anon_sym_LBRACE] = ACTIONS(5331),
    [anon_sym_LPAREN2] = ACTIONS(5331),
    [anon_sym_LBRACK] = ACTIONS(5331),
    [anon_sym_EQ] = ACTIONS(5331),
    [anon_sym_const] = ACTIONS(1667),
    [anon_sym_restrict] = ACTIONS(1669),
    [anon_sym_volatile] = ACTIONS(1669),
    [anon_sym__Atomic] = ACTIONS(1669),
    [anon_sym_mutable] = ACTIONS(1669),
    [anon_sym_explicit] = ACTIONS(1669),
    [anon_sym_constexpr] = ACTIONS(1669),
    [anon_sym_COLON] = ACTIONS(5331),
    [anon_sym_DASH_GT] = ACTIONS(4291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5331),
    [anon_sym_override] = ACTIONS(5331),
    [sym_noexcept] = ACTIONS(7886),
  },
  [3534] = {
    [sym_type_qualifier] = STATE(3534),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3534),
    [anon_sym_SEMI] = ACTIONS(5351),
    [anon_sym_LBRACE] = ACTIONS(5351),
    [anon_sym_LPAREN2] = ACTIONS(5351),
    [anon_sym_LBRACK] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_const] = ACTIONS(7697),
    [anon_sym_restrict] = ACTIONS(7700),
    [anon_sym_volatile] = ACTIONS(7700),
    [anon_sym__Atomic] = ACTIONS(7700),
    [anon_sym_mutable] = ACTIONS(7700),
    [anon_sym_explicit] = ACTIONS(7700),
    [anon_sym_constexpr] = ACTIONS(7700),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5351),
    [anon_sym_override] = ACTIONS(5351),
    [sym_noexcept] = ACTIONS(8108),
  },
  [3535] = {
    [sym_raw_string_literal] = ACTIONS(6091),
    [ts_builtin_sym_end] = ACTIONS(6091),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6093),
    [sym_preproc_directive] = ACTIONS(6093),
    [anon_sym_SEMI] = ACTIONS(6091),
    [anon_sym_typedef] = ACTIONS(6093),
    [anon_sym_extern] = ACTIONS(6093),
    [anon_sym_LBRACE] = ACTIONS(6091),
    [anon_sym_LPAREN2] = ACTIONS(6091),
    [anon_sym_STAR] = ACTIONS(6091),
    [anon_sym_LBRACK] = ACTIONS(6091),
    [anon_sym_static] = ACTIONS(6093),
    [anon_sym_register] = ACTIONS(6093),
    [anon_sym_inline] = ACTIONS(6093),
    [anon_sym_const] = ACTIONS(6093),
    [anon_sym_restrict] = ACTIONS(6093),
    [anon_sym_volatile] = ACTIONS(6093),
    [anon_sym__Atomic] = ACTIONS(6093),
    [anon_sym_mutable] = ACTIONS(6093),
    [anon_sym_explicit] = ACTIONS(6093),
    [anon_sym_constexpr] = ACTIONS(6093),
    [anon_sym_unsigned] = ACTIONS(6093),
    [anon_sym_long] = ACTIONS(6093),
    [anon_sym_short] = ACTIONS(6093),
    [sym_primitive_type] = ACTIONS(6093),
    [anon_sym_enum] = ACTIONS(6093),
    [anon_sym_struct] = ACTIONS(6093),
    [anon_sym_union] = ACTIONS(6093),
    [anon_sym_if] = ACTIONS(6093),
    [anon_sym_else] = ACTIONS(8111),
    [anon_sym_switch] = ACTIONS(6093),
    [anon_sym_case] = ACTIONS(6093),
    [anon_sym_default] = ACTIONS(6093),
    [anon_sym_while] = ACTIONS(6093),
    [anon_sym_do] = ACTIONS(6093),
    [anon_sym_for] = ACTIONS(6093),
    [anon_sym_return] = ACTIONS(6093),
    [anon_sym_break] = ACTIONS(6093),
    [anon_sym_continue] = ACTIONS(6093),
    [anon_sym_goto] = ACTIONS(6093),
    [anon_sym_AMP] = ACTIONS(6093),
    [anon_sym_AMP_AMP] = ACTIONS(6091),
    [anon_sym_BANG] = ACTIONS(6091),
    [anon_sym_TILDE] = ACTIONS(6091),
    [anon_sym_PLUS] = ACTIONS(6093),
    [anon_sym_DASH] = ACTIONS(6093),
    [anon_sym_DASH_DASH] = ACTIONS(6091),
    [anon_sym_PLUS_PLUS] = ACTIONS(6091),
    [anon_sym_sizeof] = ACTIONS(6093),
    [sym_number_literal] = ACTIONS(6091),
    [anon_sym_SQUOTE] = ACTIONS(6091),
    [anon_sym_DQUOTE] = ACTIONS(6091),
    [sym_true] = ACTIONS(6093),
    [sym_false] = ACTIONS(6093),
    [sym_null] = ACTIONS(6093),
    [sym_identifier] = ACTIONS(6093),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6093),
    [sym_auto] = ACTIONS(6093),
    [anon_sym_typename] = ACTIONS(6093),
    [anon_sym_template] = ACTIONS(6093),
    [anon_sym_delete] = ACTIONS(6093),
    [anon_sym_namespace] = ACTIONS(6093),
    [anon_sym_using] = ACTIONS(6093),
    [anon_sym_try] = ACTIONS(6093),
    [anon_sym_new] = ACTIONS(6093),
    [anon_sym_COLON_COLON] = ACTIONS(6091),
    [sym_operator_name] = ACTIONS(6091),
    [sym_nullptr] = ACTIONS(6093),
  },
  [3536] = {
    [sym_compound_statement] = STATE(3666),
    [sym_labeled_statement] = STATE(3666),
    [sym_expression_statement] = STATE(3666),
    [sym_if_statement] = STATE(3666),
    [sym_switch_statement] = STATE(3666),
    [sym_case_statement] = STATE(3666),
    [sym_while_statement] = STATE(3666),
    [sym_do_statement] = STATE(3666),
    [sym_for_statement] = STATE(3666),
    [sym_return_statement] = STATE(3666),
    [sym_break_statement] = STATE(3666),
    [sym_continue_statement] = STATE(3666),
    [sym_goto_statement] = STATE(3666),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(3666),
    [sym_try_statement] = STATE(3666),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(4430),
    [anon_sym_switch] = ACTIONS(4432),
    [anon_sym_case] = ACTIONS(4434),
    [anon_sym_default] = ACTIONS(4436),
    [anon_sym_while] = ACTIONS(4438),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(4440),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(4442),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(4444),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [3537] = {
    [sym_compound_statement] = STATE(2749),
    [sym_labeled_statement] = STATE(2749),
    [sym_expression_statement] = STATE(2749),
    [sym_if_statement] = STATE(2749),
    [sym_switch_statement] = STATE(2749),
    [sym_case_statement] = STATE(2749),
    [sym_while_statement] = STATE(2749),
    [sym_do_statement] = STATE(2749),
    [sym_for_statement] = STATE(2749),
    [sym_return_statement] = STATE(2749),
    [sym_break_statement] = STATE(2749),
    [sym_continue_statement] = STATE(2749),
    [sym_goto_statement] = STATE(2749),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(2749),
    [sym_try_statement] = STATE(2749),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(4430),
    [anon_sym_switch] = ACTIONS(4432),
    [anon_sym_case] = ACTIONS(4434),
    [anon_sym_default] = ACTIONS(4436),
    [anon_sym_while] = ACTIONS(4438),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(4440),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(4442),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(4444),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [3538] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3668),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8113),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3539] = {
    [sym__expression] = STATE(3669),
    [sym_conditional_expression] = STATE(3669),
    [sym_assignment_expression] = STATE(3669),
    [sym_pointer_expression] = STATE(3669),
    [sym_logical_expression] = STATE(3669),
    [sym_bitwise_expression] = STATE(3669),
    [sym_equality_expression] = STATE(3669),
    [sym_relational_expression] = STATE(3669),
    [sym_shift_expression] = STATE(3669),
    [sym_math_expression] = STATE(3669),
    [sym_cast_expression] = STATE(3669),
    [sym_sizeof_expression] = STATE(3669),
    [sym_subscript_expression] = STATE(3669),
    [sym_call_expression] = STATE(3669),
    [sym_field_expression] = STATE(3669),
    [sym_compound_literal_expression] = STATE(3669),
    [sym_parenthesized_expression] = STATE(3669),
    [sym_char_literal] = STATE(3669),
    [sym_concatenated_string] = STATE(3669),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3669),
    [sym_new_expression] = STATE(3669),
    [sym_delete_expression] = STATE(3669),
    [sym_lambda_expression] = STATE(3669),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8115),
    [anon_sym_RPAREN] = ACTIONS(8113),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(8115),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8117),
    [sym_false] = ACTIONS(8117),
    [sym_null] = ACTIONS(8117),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(8117),
  },
  [3540] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(8119),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3541] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(8121),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3542] = {
    [sym_compound_statement] = STATE(3672),
    [sym_labeled_statement] = STATE(3672),
    [sym_expression_statement] = STATE(3672),
    [sym_if_statement] = STATE(3672),
    [sym_switch_statement] = STATE(3672),
    [sym_case_statement] = STATE(3672),
    [sym_while_statement] = STATE(3672),
    [sym_do_statement] = STATE(3672),
    [sym_for_statement] = STATE(3672),
    [sym_return_statement] = STATE(3672),
    [sym_break_statement] = STATE(3672),
    [sym_continue_statement] = STATE(3672),
    [sym_goto_statement] = STATE(3672),
    [sym__expression] = STATE(222),
    [sym_comma_expression] = STATE(223),
    [sym_conditional_expression] = STATE(222),
    [sym_assignment_expression] = STATE(222),
    [sym_pointer_expression] = STATE(222),
    [sym_logical_expression] = STATE(222),
    [sym_bitwise_expression] = STATE(222),
    [sym_equality_expression] = STATE(222),
    [sym_relational_expression] = STATE(222),
    [sym_shift_expression] = STATE(222),
    [sym_math_expression] = STATE(222),
    [sym_cast_expression] = STATE(222),
    [sym_sizeof_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_call_expression] = STATE(222),
    [sym_field_expression] = STATE(222),
    [sym_compound_literal_expression] = STATE(222),
    [sym_parenthesized_expression] = STATE(222),
    [sym_char_literal] = STATE(222),
    [sym_concatenated_string] = STATE(222),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(222),
    [sym_for_range_loop] = STATE(3672),
    [sym_try_statement] = STATE(3672),
    [sym_new_expression] = STATE(222),
    [sym_delete_expression] = STATE(222),
    [sym_lambda_expression] = STATE(222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(6119),
    [anon_sym_switch] = ACTIONS(6121),
    [anon_sym_case] = ACTIONS(6123),
    [anon_sym_default] = ACTIONS(6125),
    [anon_sym_while] = ACTIONS(6127),
    [anon_sym_do] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(6129),
    [anon_sym_return] = ACTIONS(373),
    [anon_sym_break] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_goto] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(353),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_identifier] = ACTIONS(6131),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(6133),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(381),
  },
  [3543] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(8123),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3544] = {
    [sym__expression] = STATE(3675),
    [sym_conditional_expression] = STATE(3675),
    [sym_assignment_expression] = STATE(3675),
    [sym_pointer_expression] = STATE(3675),
    [sym_logical_expression] = STATE(3675),
    [sym_bitwise_expression] = STATE(3675),
    [sym_equality_expression] = STATE(3675),
    [sym_relational_expression] = STATE(3675),
    [sym_shift_expression] = STATE(3675),
    [sym_math_expression] = STATE(3675),
    [sym_cast_expression] = STATE(3675),
    [sym_sizeof_expression] = STATE(3675),
    [sym_subscript_expression] = STATE(3675),
    [sym_call_expression] = STATE(3675),
    [sym_field_expression] = STATE(3675),
    [sym_compound_literal_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym_char_literal] = STATE(3675),
    [sym_concatenated_string] = STATE(3675),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3675),
    [sym_new_expression] = STATE(3675),
    [sym_delete_expression] = STATE(3675),
    [sym_lambda_expression] = STATE(3675),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8125),
    [anon_sym_RPAREN] = ACTIONS(8127),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(8125),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8129),
    [sym_false] = ACTIONS(8129),
    [sym_null] = ACTIONS(8129),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(8129),
  },
  [3545] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(8131),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3546] = {
    [sym__expression] = STATE(3677),
    [sym_conditional_expression] = STATE(3677),
    [sym_assignment_expression] = STATE(3677),
    [sym_pointer_expression] = STATE(3677),
    [sym_logical_expression] = STATE(3677),
    [sym_bitwise_expression] = STATE(3677),
    [sym_equality_expression] = STATE(3677),
    [sym_relational_expression] = STATE(3677),
    [sym_shift_expression] = STATE(3677),
    [sym_math_expression] = STATE(3677),
    [sym_cast_expression] = STATE(3677),
    [sym_sizeof_expression] = STATE(3677),
    [sym_subscript_expression] = STATE(3677),
    [sym_call_expression] = STATE(3677),
    [sym_field_expression] = STATE(3677),
    [sym_compound_literal_expression] = STATE(3677),
    [sym_parenthesized_expression] = STATE(3677),
    [sym_char_literal] = STATE(3677),
    [sym_concatenated_string] = STATE(3677),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3677),
    [sym_new_expression] = STATE(3677),
    [sym_delete_expression] = STATE(3677),
    [sym_lambda_expression] = STATE(3677),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8133),
    [anon_sym_SEMI] = ACTIONS(8131),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(8133),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8135),
    [sym_false] = ACTIONS(8135),
    [sym_null] = ACTIONS(8135),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(8135),
  },
  [3547] = {
    [sym__expression] = STATE(3678),
    [sym_conditional_expression] = STATE(3678),
    [sym_assignment_expression] = STATE(3678),
    [sym_pointer_expression] = STATE(3678),
    [sym_logical_expression] = STATE(3678),
    [sym_bitwise_expression] = STATE(3678),
    [sym_equality_expression] = STATE(3678),
    [sym_relational_expression] = STATE(3678),
    [sym_shift_expression] = STATE(3678),
    [sym_math_expression] = STATE(3678),
    [sym_cast_expression] = STATE(3678),
    [sym_sizeof_expression] = STATE(3678),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3678),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(3678),
    [sym_concatenated_string] = STATE(3678),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3678),
    [sym_new_expression] = STATE(3678),
    [sym_delete_expression] = STATE(3678),
    [sym_lambda_expression] = STATE(3678),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8137),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(8137),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8139),
    [sym_false] = ACTIONS(8139),
    [sym_null] = ACTIONS(8139),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(8139),
  },
  [3548] = {
    [sym_catch_clause] = STATE(3548),
    [aux_sym_try_statement_repeat1] = STATE(3548),
    [anon_sym_else] = ACTIONS(4993),
    [anon_sym_while] = ACTIONS(4993),
    [sym_comment] = ACTIONS(91),
    [anon_sym_catch] = ACTIONS(6153),
  },
  [3549] = {
    [anon_sym_else] = ACTIONS(7906),
    [anon_sym_while] = ACTIONS(7906),
    [sym_comment] = ACTIONS(91),
  },
  [3550] = {
    [anon_sym_else] = ACTIONS(7928),
    [anon_sym_while] = ACTIONS(7928),
    [sym_comment] = ACTIONS(91),
  },
  [3551] = {
    [sym_compound_statement] = STATE(3679),
    [sym_labeled_statement] = STATE(3679),
    [sym_expression_statement] = STATE(3679),
    [sym_if_statement] = STATE(3679),
    [sym_switch_statement] = STATE(3679),
    [sym_case_statement] = STATE(3679),
    [sym_while_statement] = STATE(3679),
    [sym_do_statement] = STATE(3679),
    [sym_for_statement] = STATE(3679),
    [sym_return_statement] = STATE(3679),
    [sym_break_statement] = STATE(3679),
    [sym_continue_statement] = STATE(3679),
    [sym_goto_statement] = STATE(3679),
    [sym__expression] = STATE(222),
    [sym_comma_expression] = STATE(223),
    [sym_conditional_expression] = STATE(222),
    [sym_assignment_expression] = STATE(222),
    [sym_pointer_expression] = STATE(222),
    [sym_logical_expression] = STATE(222),
    [sym_bitwise_expression] = STATE(222),
    [sym_equality_expression] = STATE(222),
    [sym_relational_expression] = STATE(222),
    [sym_shift_expression] = STATE(222),
    [sym_math_expression] = STATE(222),
    [sym_cast_expression] = STATE(222),
    [sym_sizeof_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_call_expression] = STATE(222),
    [sym_field_expression] = STATE(222),
    [sym_compound_literal_expression] = STATE(222),
    [sym_parenthesized_expression] = STATE(222),
    [sym_char_literal] = STATE(222),
    [sym_concatenated_string] = STATE(222),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(222),
    [sym_for_range_loop] = STATE(3679),
    [sym_try_statement] = STATE(3679),
    [sym_new_expression] = STATE(222),
    [sym_delete_expression] = STATE(222),
    [sym_lambda_expression] = STATE(222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(359),
    [anon_sym_switch] = ACTIONS(361),
    [anon_sym_case] = ACTIONS(363),
    [anon_sym_default] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [anon_sym_do] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(373),
    [anon_sym_break] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_goto] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(353),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_identifier] = ACTIONS(383),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(381),
  },
  [3552] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8141),
    [sym_comment] = ACTIONS(91),
  },
  [3553] = {
    [sym_raw_string_literal] = ACTIONS(8143),
    [ts_builtin_sym_end] = ACTIONS(8143),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(8145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(8145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(8145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(8145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(8145),
    [sym_preproc_directive] = ACTIONS(8145),
    [anon_sym_SEMI] = ACTIONS(8143),
    [anon_sym_typedef] = ACTIONS(8145),
    [anon_sym_extern] = ACTIONS(8145),
    [anon_sym_LBRACE] = ACTIONS(8143),
    [anon_sym_RBRACE] = ACTIONS(8143),
    [anon_sym_LPAREN2] = ACTIONS(8143),
    [anon_sym_STAR] = ACTIONS(8143),
    [anon_sym_LBRACK] = ACTIONS(8143),
    [anon_sym_static] = ACTIONS(8145),
    [anon_sym_register] = ACTIONS(8145),
    [anon_sym_inline] = ACTIONS(8145),
    [anon_sym_const] = ACTIONS(8145),
    [anon_sym_restrict] = ACTIONS(8145),
    [anon_sym_volatile] = ACTIONS(8145),
    [anon_sym__Atomic] = ACTIONS(8145),
    [anon_sym_mutable] = ACTIONS(8145),
    [anon_sym_explicit] = ACTIONS(8145),
    [anon_sym_constexpr] = ACTIONS(8145),
    [anon_sym_unsigned] = ACTIONS(8145),
    [anon_sym_long] = ACTIONS(8145),
    [anon_sym_short] = ACTIONS(8145),
    [sym_primitive_type] = ACTIONS(8145),
    [anon_sym_enum] = ACTIONS(8145),
    [anon_sym_struct] = ACTIONS(8145),
    [anon_sym_union] = ACTIONS(8145),
    [anon_sym_if] = ACTIONS(8145),
    [anon_sym_else] = ACTIONS(8145),
    [anon_sym_switch] = ACTIONS(8145),
    [anon_sym_case] = ACTIONS(8145),
    [anon_sym_default] = ACTIONS(8145),
    [anon_sym_while] = ACTIONS(8145),
    [anon_sym_do] = ACTIONS(8145),
    [anon_sym_for] = ACTIONS(8145),
    [anon_sym_return] = ACTIONS(8145),
    [anon_sym_break] = ACTIONS(8145),
    [anon_sym_continue] = ACTIONS(8145),
    [anon_sym_goto] = ACTIONS(8145),
    [anon_sym_AMP] = ACTIONS(8145),
    [anon_sym_AMP_AMP] = ACTIONS(8143),
    [anon_sym_BANG] = ACTIONS(8143),
    [anon_sym_TILDE] = ACTIONS(8143),
    [anon_sym_PLUS] = ACTIONS(8145),
    [anon_sym_DASH] = ACTIONS(8145),
    [anon_sym_DASH_DASH] = ACTIONS(8143),
    [anon_sym_PLUS_PLUS] = ACTIONS(8143),
    [anon_sym_sizeof] = ACTIONS(8145),
    [sym_number_literal] = ACTIONS(8143),
    [anon_sym_SQUOTE] = ACTIONS(8143),
    [anon_sym_DQUOTE] = ACTIONS(8143),
    [sym_true] = ACTIONS(8145),
    [sym_false] = ACTIONS(8145),
    [sym_null] = ACTIONS(8145),
    [sym_identifier] = ACTIONS(8145),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(8145),
    [sym_auto] = ACTIONS(8145),
    [anon_sym_typename] = ACTIONS(8145),
    [anon_sym_template] = ACTIONS(8145),
    [anon_sym_delete] = ACTIONS(8145),
    [anon_sym_namespace] = ACTIONS(8145),
    [anon_sym_using] = ACTIONS(8145),
    [anon_sym_try] = ACTIONS(8145),
    [anon_sym_new] = ACTIONS(8145),
    [anon_sym_COLON_COLON] = ACTIONS(8143),
    [sym_operator_name] = ACTIONS(8143),
    [sym_nullptr] = ACTIONS(8145),
  },
  [3554] = {
    [sym_compound_statement] = STATE(3681),
    [sym_labeled_statement] = STATE(3681),
    [sym_expression_statement] = STATE(3681),
    [sym_if_statement] = STATE(3681),
    [sym_switch_statement] = STATE(3681),
    [sym_case_statement] = STATE(3681),
    [sym_while_statement] = STATE(3681),
    [sym_do_statement] = STATE(3681),
    [sym_for_statement] = STATE(3681),
    [sym_return_statement] = STATE(3681),
    [sym_break_statement] = STATE(3681),
    [sym_continue_statement] = STATE(3681),
    [sym_goto_statement] = STATE(3681),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(3681),
    [sym_try_statement] = STATE(3681),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_switch] = ACTIONS(49),
    [anon_sym_case] = ACTIONS(51),
    [anon_sym_default] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(1115),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(105),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [3555] = {
    [anon_sym_COMMA] = ACTIONS(6940),
    [anon_sym_LBRACE] = ACTIONS(6940),
    [anon_sym_LPAREN2] = ACTIONS(6940),
    [anon_sym_STAR] = ACTIONS(6942),
    [anon_sym_LBRACK] = ACTIONS(6940),
    [anon_sym_EQ] = ACTIONS(6942),
    [anon_sym_QMARK] = ACTIONS(6940),
    [anon_sym_STAR_EQ] = ACTIONS(6940),
    [anon_sym_SLASH_EQ] = ACTIONS(6940),
    [anon_sym_PERCENT_EQ] = ACTIONS(6940),
    [anon_sym_PLUS_EQ] = ACTIONS(6940),
    [anon_sym_DASH_EQ] = ACTIONS(6940),
    [anon_sym_LT_LT_EQ] = ACTIONS(6940),
    [anon_sym_GT_GT_EQ] = ACTIONS(6940),
    [anon_sym_AMP_EQ] = ACTIONS(6940),
    [anon_sym_CARET_EQ] = ACTIONS(6940),
    [anon_sym_PIPE_EQ] = ACTIONS(6940),
    [anon_sym_AMP] = ACTIONS(6942),
    [anon_sym_PIPE_PIPE] = ACTIONS(6940),
    [anon_sym_AMP_AMP] = ACTIONS(6940),
    [anon_sym_PIPE] = ACTIONS(6942),
    [anon_sym_CARET] = ACTIONS(6942),
    [anon_sym_EQ_EQ] = ACTIONS(6940),
    [anon_sym_BANG_EQ] = ACTIONS(6940),
    [anon_sym_LT] = ACTIONS(6942),
    [anon_sym_GT] = ACTIONS(6942),
    [anon_sym_LT_EQ] = ACTIONS(6940),
    [anon_sym_GT_EQ] = ACTIONS(6940),
    [anon_sym_LT_LT] = ACTIONS(6942),
    [anon_sym_GT_GT] = ACTIONS(6942),
    [anon_sym_PLUS] = ACTIONS(6942),
    [anon_sym_DASH] = ACTIONS(6942),
    [anon_sym_SLASH] = ACTIONS(6942),
    [anon_sym_PERCENT] = ACTIONS(6942),
    [anon_sym_DASH_DASH] = ACTIONS(6940),
    [anon_sym_PLUS_PLUS] = ACTIONS(6940),
    [anon_sym_DOT] = ACTIONS(6940),
    [anon_sym_DASH_GT] = ACTIONS(6940),
    [sym_comment] = ACTIONS(91),
    [anon_sym_GT2] = ACTIONS(6940),
  },
  [3556] = {
    [sym_parameter_list] = STATE(3559),
    [anon_sym_COMMA] = ACTIONS(4157),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(4157),
    [anon_sym_const] = ACTIONS(7279),
    [anon_sym_restrict] = ACTIONS(4157),
    [anon_sym_volatile] = ACTIONS(4157),
    [anon_sym__Atomic] = ACTIONS(4157),
    [anon_sym_mutable] = ACTIONS(4157),
    [anon_sym_explicit] = ACTIONS(4157),
    [anon_sym_constexpr] = ACTIONS(4157),
    [anon_sym_DASH_GT] = ACTIONS(4157),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4157),
    [anon_sym_override] = ACTIONS(4157),
    [anon_sym_GT2] = ACTIONS(4157),
    [sym_noexcept] = ACTIONS(4157),
  },
  [3557] = {
    [sym__abstract_declarator] = STATE(3682),
    [sym_abstract_pointer_declarator] = STATE(3682),
    [sym_abstract_function_declarator] = STATE(3682),
    [sym_abstract_array_declarator] = STATE(3682),
    [sym_type_qualifier] = STATE(3683),
    [sym_parameter_list] = STATE(3398),
    [sym_abstract_reference_declarator] = STATE(3682),
    [aux_sym_type_definition_repeat1] = STATE(3683),
    [anon_sym_COMMA] = ACTIONS(4157),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(7611),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_EQ] = ACTIONS(4157),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(7613),
    [anon_sym_AMP_AMP] = ACTIONS(7615),
    [anon_sym_DASH_GT] = ACTIONS(4157),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4157),
    [anon_sym_override] = ACTIONS(4157),
    [anon_sym_GT2] = ACTIONS(4157),
    [sym_noexcept] = ACTIONS(4157),
  },
  [3558] = {
    [sym_parameter_list] = STATE(3559),
    [anon_sym_COMMA] = ACTIONS(4159),
    [anon_sym_LBRACE] = ACTIONS(4159),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_const] = ACTIONS(7281),
    [anon_sym_restrict] = ACTIONS(4159),
    [anon_sym_volatile] = ACTIONS(4159),
    [anon_sym__Atomic] = ACTIONS(4159),
    [anon_sym_mutable] = ACTIONS(4159),
    [anon_sym_explicit] = ACTIONS(4159),
    [anon_sym_constexpr] = ACTIONS(4159),
    [anon_sym_DASH_GT] = ACTIONS(4159),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4159),
    [anon_sym_override] = ACTIONS(4159),
    [anon_sym_GT2] = ACTIONS(4159),
    [sym_noexcept] = ACTIONS(4159),
  },
  [3559] = {
    [sym_type_qualifier] = STATE(3684),
    [sym_trailing_return_type] = STATE(1720),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3684),
    [anon_sym_COMMA] = ACTIONS(3663),
    [anon_sym_LBRACE] = ACTIONS(3663),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_EQ] = ACTIONS(3663),
    [anon_sym_const] = ACTIONS(3685),
    [anon_sym_restrict] = ACTIONS(3663),
    [anon_sym_volatile] = ACTIONS(3663),
    [anon_sym__Atomic] = ACTIONS(3663),
    [anon_sym_mutable] = ACTIONS(3663),
    [anon_sym_explicit] = ACTIONS(3663),
    [anon_sym_constexpr] = ACTIONS(3663),
    [anon_sym_DASH_GT] = ACTIONS(3663),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3663),
    [anon_sym_override] = ACTIONS(3663),
    [anon_sym_GT2] = ACTIONS(3663),
    [sym_noexcept] = ACTIONS(3663),
  },
  [3560] = {
    [sym_type_qualifier] = STATE(3685),
    [sym_trailing_return_type] = STATE(1720),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3685),
    [anon_sym_COMMA] = ACTIONS(3663),
    [anon_sym_LBRACE] = ACTIONS(3663),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_EQ] = ACTIONS(3663),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(6320),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3663),
    [anon_sym_override] = ACTIONS(3663),
    [anon_sym_GT2] = ACTIONS(3663),
    [sym_noexcept] = ACTIONS(8147),
  },
  [3561] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(8149),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3562] = {
    [sym__expression] = STATE(3687),
    [sym_conditional_expression] = STATE(3687),
    [sym_assignment_expression] = STATE(3687),
    [sym_pointer_expression] = STATE(3687),
    [sym_logical_expression] = STATE(3687),
    [sym_bitwise_expression] = STATE(3687),
    [sym_equality_expression] = STATE(3687),
    [sym_relational_expression] = STATE(3687),
    [sym_shift_expression] = STATE(3687),
    [sym_math_expression] = STATE(3687),
    [sym_cast_expression] = STATE(3687),
    [sym_sizeof_expression] = STATE(3687),
    [sym_subscript_expression] = STATE(3687),
    [sym_call_expression] = STATE(3687),
    [sym_field_expression] = STATE(3687),
    [sym_compound_literal_expression] = STATE(3687),
    [sym_parenthesized_expression] = STATE(3687),
    [sym_char_literal] = STATE(3687),
    [sym_concatenated_string] = STATE(3687),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3687),
    [sym_new_expression] = STATE(3687),
    [sym_delete_expression] = STATE(3687),
    [sym_lambda_expression] = STATE(3687),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8151),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(8151),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8153),
    [sym_false] = ACTIONS(8153),
    [sym_null] = ACTIONS(8153),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(8153),
  },
  [3563] = {
    [sym_declaration] = STATE(1346),
    [sym_type_definition] = STATE(1346),
    [sym__declaration_specifiers] = STATE(682),
    [sym_compound_statement] = STATE(1346),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_labeled_statement] = STATE(1346),
    [sym_expression_statement] = STATE(1346),
    [sym_if_statement] = STATE(1346),
    [sym_switch_statement] = STATE(1346),
    [sym_case_statement] = STATE(1346),
    [sym_while_statement] = STATE(1346),
    [sym_do_statement] = STATE(1346),
    [sym_for_statement] = STATE(1346),
    [sym_return_statement] = STATE(1346),
    [sym_break_statement] = STATE(1346),
    [sym_continue_statement] = STATE(1346),
    [sym_goto_statement] = STATE(1346),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(1346),
    [sym_try_statement] = STATE(1346),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(7177),
    [anon_sym_switch] = ACTIONS(7179),
    [anon_sym_case] = ACTIONS(7181),
    [anon_sym_default] = ACTIONS(7183),
    [anon_sym_while] = ACTIONS(7185),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(7187),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(7950),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7191),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(1202),
    [sym_nullptr] = ACTIONS(87),
  },
  [3564] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(1362),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_extern] = ACTIONS(468),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(465),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_register] = ACTIONS(468),
    [anon_sym_inline] = ACTIONS(468),
    [anon_sym_const] = ACTIONS(468),
    [anon_sym_restrict] = ACTIONS(468),
    [anon_sym_volatile] = ACTIONS(468),
    [anon_sym__Atomic] = ACTIONS(468),
    [anon_sym_mutable] = ACTIONS(468),
    [anon_sym_explicit] = ACTIONS(468),
    [anon_sym_constexpr] = ACTIONS(468),
    [anon_sym_COLON] = ACTIONS(7639),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(474),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_TILDE] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_identifier] = ACTIONS(468),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(2855),
    [sym_operator_name] = ACTIONS(481),
  },
  [3565] = {
    [sym__expression] = STATE(3689),
    [sym_conditional_expression] = STATE(3689),
    [sym_assignment_expression] = STATE(3689),
    [sym_pointer_expression] = STATE(3689),
    [sym_logical_expression] = STATE(3689),
    [sym_bitwise_expression] = STATE(3689),
    [sym_equality_expression] = STATE(3689),
    [sym_relational_expression] = STATE(3689),
    [sym_shift_expression] = STATE(3689),
    [sym_math_expression] = STATE(3689),
    [sym_cast_expression] = STATE(3689),
    [sym_sizeof_expression] = STATE(3689),
    [sym_subscript_expression] = STATE(3689),
    [sym_call_expression] = STATE(3689),
    [sym_field_expression] = STATE(3689),
    [sym_compound_literal_expression] = STATE(3689),
    [sym_parenthesized_expression] = STATE(3689),
    [sym_char_literal] = STATE(3689),
    [sym_concatenated_string] = STATE(3689),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3689),
    [sym_new_expression] = STATE(3689),
    [sym_delete_expression] = STATE(3689),
    [sym_lambda_expression] = STATE(3689),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8155),
    [anon_sym_SEMI] = ACTIONS(8157),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(8155),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8159),
    [sym_false] = ACTIONS(8159),
    [sym_null] = ACTIONS(8159),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(8159),
  },
  [3566] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(8161),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3567] = {
    [anon_sym_COLON] = ACTIONS(8163),
    [sym_comment] = ACTIONS(91),
  },
  [3568] = {
    [sym_catch_clause] = STATE(3692),
    [aux_sym_try_statement_repeat1] = STATE(3692),
    [sym_raw_string_literal] = ACTIONS(3346),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3348),
    [sym_preproc_directive] = ACTIONS(3348),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym_typedef] = ACTIONS(3348),
    [anon_sym_extern] = ACTIONS(3348),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_RBRACE] = ACTIONS(3346),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(3346),
    [anon_sym_static] = ACTIONS(3348),
    [anon_sym_register] = ACTIONS(3348),
    [anon_sym_inline] = ACTIONS(3348),
    [anon_sym_const] = ACTIONS(3348),
    [anon_sym_restrict] = ACTIONS(3348),
    [anon_sym_volatile] = ACTIONS(3348),
    [anon_sym__Atomic] = ACTIONS(3348),
    [anon_sym_mutable] = ACTIONS(3348),
    [anon_sym_explicit] = ACTIONS(3348),
    [anon_sym_constexpr] = ACTIONS(3348),
    [anon_sym_unsigned] = ACTIONS(3348),
    [anon_sym_long] = ACTIONS(3348),
    [anon_sym_short] = ACTIONS(3348),
    [sym_primitive_type] = ACTIONS(3348),
    [anon_sym_enum] = ACTIONS(3348),
    [anon_sym_struct] = ACTIONS(3348),
    [anon_sym_union] = ACTIONS(3348),
    [anon_sym_if] = ACTIONS(3348),
    [anon_sym_else] = ACTIONS(3348),
    [anon_sym_switch] = ACTIONS(3348),
    [anon_sym_case] = ACTIONS(3348),
    [anon_sym_default] = ACTIONS(3348),
    [anon_sym_while] = ACTIONS(3348),
    [anon_sym_do] = ACTIONS(3348),
    [anon_sym_for] = ACTIONS(3348),
    [anon_sym_return] = ACTIONS(3348),
    [anon_sym_break] = ACTIONS(3348),
    [anon_sym_continue] = ACTIONS(3348),
    [anon_sym_goto] = ACTIONS(3348),
    [anon_sym_AMP] = ACTIONS(3348),
    [anon_sym_AMP_AMP] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_PLUS] = ACTIONS(3348),
    [anon_sym_DASH] = ACTIONS(3348),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_sizeof] = ACTIONS(3348),
    [sym_number_literal] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [sym_true] = ACTIONS(3348),
    [sym_false] = ACTIONS(3348),
    [sym_null] = ACTIONS(3348),
    [sym_identifier] = ACTIONS(3348),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3348),
    [sym_auto] = ACTIONS(3348),
    [anon_sym_typename] = ACTIONS(3348),
    [anon_sym_template] = ACTIONS(3348),
    [anon_sym_delete] = ACTIONS(3348),
    [anon_sym_namespace] = ACTIONS(3348),
    [anon_sym_using] = ACTIONS(3348),
    [anon_sym_try] = ACTIONS(3348),
    [anon_sym_catch] = ACTIONS(3350),
    [anon_sym_new] = ACTIONS(3348),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [sym_operator_name] = ACTIONS(3346),
    [sym_nullptr] = ACTIONS(3348),
  },
  [3569] = {
    [sym_compound_statement] = STATE(3366),
    [sym_labeled_statement] = STATE(3366),
    [sym_expression_statement] = STATE(3366),
    [sym_if_statement] = STATE(3366),
    [sym_switch_statement] = STATE(3366),
    [sym_case_statement] = STATE(3366),
    [sym_while_statement] = STATE(3366),
    [sym_do_statement] = STATE(3366),
    [sym_for_statement] = STATE(3366),
    [sym_return_statement] = STATE(3366),
    [sym_break_statement] = STATE(3366),
    [sym_continue_statement] = STATE(3366),
    [sym_goto_statement] = STATE(3366),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(3366),
    [sym_try_statement] = STATE(3366),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(1495),
    [anon_sym_switch] = ACTIONS(1497),
    [anon_sym_case] = ACTIONS(1499),
    [anon_sym_default] = ACTIONS(1501),
    [anon_sym_while] = ACTIONS(1503),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(1505),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(4937),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(1509),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [3570] = {
    [sym_compound_statement] = STATE(3382),
    [sym_labeled_statement] = STATE(3382),
    [sym_expression_statement] = STATE(3382),
    [sym_if_statement] = STATE(3382),
    [sym_switch_statement] = STATE(3382),
    [sym_case_statement] = STATE(3382),
    [sym_while_statement] = STATE(3382),
    [sym_do_statement] = STATE(3382),
    [sym_for_statement] = STATE(3382),
    [sym_return_statement] = STATE(3382),
    [sym_break_statement] = STATE(3382),
    [sym_continue_statement] = STATE(3382),
    [sym_goto_statement] = STATE(3382),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(3382),
    [sym_try_statement] = STATE(3382),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(1495),
    [anon_sym_switch] = ACTIONS(1497),
    [anon_sym_case] = ACTIONS(1499),
    [anon_sym_default] = ACTIONS(1501),
    [anon_sym_while] = ACTIONS(1503),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(1505),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(4937),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(1509),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [3571] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8165),
    [sym_comment] = ACTIONS(91),
  },
  [3572] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3694),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8165),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3573] = {
    [sym_parameter_list] = STATE(3576),
    [anon_sym_COMMA] = ACTIONS(4157),
    [anon_sym_RPAREN] = ACTIONS(4157),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(4157),
    [anon_sym_const] = ACTIONS(7279),
    [anon_sym_restrict] = ACTIONS(4157),
    [anon_sym_volatile] = ACTIONS(4157),
    [anon_sym__Atomic] = ACTIONS(4157),
    [anon_sym_mutable] = ACTIONS(4157),
    [anon_sym_explicit] = ACTIONS(4157),
    [anon_sym_constexpr] = ACTIONS(4157),
    [anon_sym_DASH_GT] = ACTIONS(4157),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4157),
    [anon_sym_override] = ACTIONS(4157),
    [sym_noexcept] = ACTIONS(4157),
  },
  [3574] = {
    [sym__abstract_declarator] = STATE(3695),
    [sym_abstract_pointer_declarator] = STATE(3695),
    [sym_abstract_function_declarator] = STATE(3695),
    [sym_abstract_array_declarator] = STATE(3695),
    [sym_type_qualifier] = STATE(3696),
    [sym_parameter_list] = STATE(3431),
    [sym_abstract_reference_declarator] = STATE(3695),
    [aux_sym_type_definition_repeat1] = STATE(3696),
    [anon_sym_COMMA] = ACTIONS(4157),
    [anon_sym_RPAREN] = ACTIONS(4157),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(7672),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_EQ] = ACTIONS(4157),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(7674),
    [anon_sym_AMP_AMP] = ACTIONS(7676),
    [anon_sym_DASH_GT] = ACTIONS(4157),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4157),
    [anon_sym_override] = ACTIONS(4157),
    [sym_noexcept] = ACTIONS(4157),
  },
  [3575] = {
    [sym_parameter_list] = STATE(3576),
    [anon_sym_COMMA] = ACTIONS(4159),
    [anon_sym_RPAREN] = ACTIONS(4159),
    [anon_sym_LBRACE] = ACTIONS(4159),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_const] = ACTIONS(7281),
    [anon_sym_restrict] = ACTIONS(4159),
    [anon_sym_volatile] = ACTIONS(4159),
    [anon_sym__Atomic] = ACTIONS(4159),
    [anon_sym_mutable] = ACTIONS(4159),
    [anon_sym_explicit] = ACTIONS(4159),
    [anon_sym_constexpr] = ACTIONS(4159),
    [anon_sym_DASH_GT] = ACTIONS(4159),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4159),
    [anon_sym_override] = ACTIONS(4159),
    [sym_noexcept] = ACTIONS(4159),
  },
  [3576] = {
    [sym_type_qualifier] = STATE(3697),
    [sym_trailing_return_type] = STATE(1720),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3697),
    [anon_sym_COMMA] = ACTIONS(3663),
    [anon_sym_RPAREN] = ACTIONS(3663),
    [anon_sym_LBRACE] = ACTIONS(3663),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_EQ] = ACTIONS(3663),
    [anon_sym_const] = ACTIONS(3685),
    [anon_sym_restrict] = ACTIONS(3663),
    [anon_sym_volatile] = ACTIONS(3663),
    [anon_sym__Atomic] = ACTIONS(3663),
    [anon_sym_mutable] = ACTIONS(3663),
    [anon_sym_explicit] = ACTIONS(3663),
    [anon_sym_constexpr] = ACTIONS(3663),
    [anon_sym_DASH_GT] = ACTIONS(3663),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3663),
    [anon_sym_override] = ACTIONS(3663),
    [sym_noexcept] = ACTIONS(3663),
  },
  [3577] = {
    [sym_type_qualifier] = STATE(3698),
    [sym_trailing_return_type] = STATE(1720),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3698),
    [anon_sym_COMMA] = ACTIONS(3663),
    [anon_sym_RPAREN] = ACTIONS(3663),
    [anon_sym_LBRACE] = ACTIONS(3663),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_EQ] = ACTIONS(3663),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(6522),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3663),
    [anon_sym_override] = ACTIONS(3663),
    [sym_noexcept] = ACTIONS(8167),
  },
  [3578] = {
    [sym_type_qualifier] = STATE(3578),
    [aux_sym_type_definition_repeat1] = STATE(3578),
    [anon_sym_COMMA] = ACTIONS(2179),
    [anon_sym_RPAREN] = ACTIONS(2179),
    [anon_sym_LPAREN2] = ACTIONS(2179),
    [anon_sym_STAR] = ACTIONS(2179),
    [anon_sym_LBRACK] = ACTIONS(2179),
    [anon_sym_const] = ACTIONS(2538),
    [anon_sym_restrict] = ACTIONS(5316),
    [anon_sym_volatile] = ACTIONS(5316),
    [anon_sym__Atomic] = ACTIONS(5316),
    [anon_sym_mutable] = ACTIONS(5316),
    [anon_sym_explicit] = ACTIONS(5316),
    [anon_sym_constexpr] = ACTIONS(5316),
    [anon_sym_AMP] = ACTIONS(2177),
    [anon_sym_AMP_AMP] = ACTIONS(2179),
    [sym_comment] = ACTIONS(91),
  },
  [3579] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(8169),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3580] = {
    [sym__expression] = STATE(3700),
    [sym_conditional_expression] = STATE(3700),
    [sym_assignment_expression] = STATE(3700),
    [sym_pointer_expression] = STATE(3700),
    [sym_logical_expression] = STATE(3700),
    [sym_bitwise_expression] = STATE(3700),
    [sym_equality_expression] = STATE(3700),
    [sym_relational_expression] = STATE(3700),
    [sym_shift_expression] = STATE(3700),
    [sym_math_expression] = STATE(3700),
    [sym_cast_expression] = STATE(3700),
    [sym_sizeof_expression] = STATE(3700),
    [sym_subscript_expression] = STATE(3700),
    [sym_call_expression] = STATE(3700),
    [sym_field_expression] = STATE(3700),
    [sym_compound_literal_expression] = STATE(3700),
    [sym_parenthesized_expression] = STATE(3700),
    [sym_char_literal] = STATE(3700),
    [sym_concatenated_string] = STATE(3700),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3700),
    [sym_new_expression] = STATE(3700),
    [sym_delete_expression] = STATE(3700),
    [sym_lambda_expression] = STATE(3700),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8171),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(8171),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8173),
    [sym_false] = ACTIONS(8173),
    [sym_null] = ACTIONS(8173),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(8173),
  },
  [3581] = {
    [sym_declaration] = STATE(2940),
    [sym_type_definition] = STATE(2940),
    [sym__declaration_specifiers] = STATE(2470),
    [sym_compound_statement] = STATE(2940),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_labeled_statement] = STATE(2940),
    [sym_expression_statement] = STATE(2940),
    [sym_if_statement] = STATE(2940),
    [sym_switch_statement] = STATE(2940),
    [sym_case_statement] = STATE(2940),
    [sym_while_statement] = STATE(2940),
    [sym_do_statement] = STATE(2940),
    [sym_for_statement] = STATE(2940),
    [sym_return_statement] = STATE(2940),
    [sym_break_statement] = STATE(2940),
    [sym_continue_statement] = STATE(2940),
    [sym_goto_statement] = STATE(2940),
    [sym__expression] = STATE(1020),
    [sym_comma_expression] = STATE(1021),
    [sym_conditional_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1020),
    [sym_pointer_expression] = STATE(1020),
    [sym_logical_expression] = STATE(1020),
    [sym_bitwise_expression] = STATE(1020),
    [sym_equality_expression] = STATE(1020),
    [sym_relational_expression] = STATE(1020),
    [sym_shift_expression] = STATE(1020),
    [sym_math_expression] = STATE(1020),
    [sym_cast_expression] = STATE(1020),
    [sym_sizeof_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_field_expression] = STATE(1020),
    [sym_compound_literal_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_char_literal] = STATE(1020),
    [sym_concatenated_string] = STATE(1020),
    [sym_string_literal] = STATE(55),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(1020),
    [sym_for_range_loop] = STATE(2940),
    [sym_try_statement] = STATE(2940),
    [sym_new_expression] = STATE(1020),
    [sym_delete_expression] = STATE(1020),
    [sym_lambda_expression] = STATE(1020),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(2022),
    [anon_sym_SEMI] = ACTIONS(2036),
    [anon_sym_typedef] = ACTIONS(2038),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(7300),
    [anon_sym_switch] = ACTIONS(7302),
    [anon_sym_case] = ACTIONS(7304),
    [anon_sym_default] = ACTIONS(7306),
    [anon_sym_while] = ACTIONS(7308),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(7310),
    [anon_sym_return] = ACTIONS(2058),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2062),
    [anon_sym_goto] = ACTIONS(2064),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(7980),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7314),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(1202),
    [sym_nullptr] = ACTIONS(2066),
  },
  [3582] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(1362),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_extern] = ACTIONS(468),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(465),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_register] = ACTIONS(468),
    [anon_sym_inline] = ACTIONS(468),
    [anon_sym_const] = ACTIONS(468),
    [anon_sym_restrict] = ACTIONS(468),
    [anon_sym_volatile] = ACTIONS(468),
    [anon_sym__Atomic] = ACTIONS(468),
    [anon_sym_mutable] = ACTIONS(468),
    [anon_sym_explicit] = ACTIONS(468),
    [anon_sym_constexpr] = ACTIONS(468),
    [anon_sym_COLON] = ACTIONS(7718),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(474),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_TILDE] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_identifier] = ACTIONS(468),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(2855),
    [sym_operator_name] = ACTIONS(481),
  },
  [3583] = {
    [sym__expression] = STATE(3702),
    [sym_conditional_expression] = STATE(3702),
    [sym_assignment_expression] = STATE(3702),
    [sym_pointer_expression] = STATE(3702),
    [sym_logical_expression] = STATE(3702),
    [sym_bitwise_expression] = STATE(3702),
    [sym_equality_expression] = STATE(3702),
    [sym_relational_expression] = STATE(3702),
    [sym_shift_expression] = STATE(3702),
    [sym_math_expression] = STATE(3702),
    [sym_cast_expression] = STATE(3702),
    [sym_sizeof_expression] = STATE(3702),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(3702),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(3702),
    [sym_concatenated_string] = STATE(3702),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3702),
    [sym_new_expression] = STATE(3702),
    [sym_delete_expression] = STATE(3702),
    [sym_lambda_expression] = STATE(3702),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8175),
    [anon_sym_SEMI] = ACTIONS(8177),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(8175),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8179),
    [sym_false] = ACTIONS(8179),
    [sym_null] = ACTIONS(8179),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(8179),
  },
  [3584] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(8181),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3585] = {
    [anon_sym_COLON] = ACTIONS(8183),
    [sym_comment] = ACTIONS(91),
  },
  [3586] = {
    [sym_catch_clause] = STATE(3705),
    [aux_sym_try_statement_repeat1] = STATE(3705),
    [sym_raw_string_literal] = ACTIONS(3346),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3348),
    [sym_preproc_directive] = ACTIONS(3348),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym_typedef] = ACTIONS(3348),
    [anon_sym_extern] = ACTIONS(3348),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(3346),
    [anon_sym_static] = ACTIONS(3348),
    [anon_sym_register] = ACTIONS(3348),
    [anon_sym_inline] = ACTIONS(3348),
    [anon_sym_const] = ACTIONS(3348),
    [anon_sym_restrict] = ACTIONS(3348),
    [anon_sym_volatile] = ACTIONS(3348),
    [anon_sym__Atomic] = ACTIONS(3348),
    [anon_sym_mutable] = ACTIONS(3348),
    [anon_sym_explicit] = ACTIONS(3348),
    [anon_sym_constexpr] = ACTIONS(3348),
    [anon_sym_unsigned] = ACTIONS(3348),
    [anon_sym_long] = ACTIONS(3348),
    [anon_sym_short] = ACTIONS(3348),
    [sym_primitive_type] = ACTIONS(3348),
    [anon_sym_enum] = ACTIONS(3348),
    [anon_sym_struct] = ACTIONS(3348),
    [anon_sym_union] = ACTIONS(3348),
    [anon_sym_if] = ACTIONS(3348),
    [anon_sym_else] = ACTIONS(3348),
    [anon_sym_switch] = ACTIONS(3348),
    [anon_sym_case] = ACTIONS(3348),
    [anon_sym_default] = ACTIONS(3348),
    [anon_sym_while] = ACTIONS(3348),
    [anon_sym_do] = ACTIONS(3348),
    [anon_sym_for] = ACTIONS(3348),
    [anon_sym_return] = ACTIONS(3348),
    [anon_sym_break] = ACTIONS(3348),
    [anon_sym_continue] = ACTIONS(3348),
    [anon_sym_goto] = ACTIONS(3348),
    [anon_sym_AMP] = ACTIONS(3348),
    [anon_sym_AMP_AMP] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_PLUS] = ACTIONS(3348),
    [anon_sym_DASH] = ACTIONS(3348),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_sizeof] = ACTIONS(3348),
    [sym_number_literal] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [sym_true] = ACTIONS(3348),
    [sym_false] = ACTIONS(3348),
    [sym_null] = ACTIONS(3348),
    [sym_identifier] = ACTIONS(3348),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3348),
    [sym_auto] = ACTIONS(3348),
    [anon_sym_typename] = ACTIONS(3348),
    [anon_sym_template] = ACTIONS(3348),
    [anon_sym_delete] = ACTIONS(3348),
    [anon_sym_namespace] = ACTIONS(3348),
    [anon_sym_using] = ACTIONS(3348),
    [anon_sym_try] = ACTIONS(3348),
    [anon_sym_catch] = ACTIONS(6662),
    [anon_sym_new] = ACTIONS(3348),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [sym_operator_name] = ACTIONS(3346),
    [sym_nullptr] = ACTIONS(3348),
  },
  [3587] = {
    [sym_raw_string_literal] = ACTIONS(7561),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7563),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7563),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7563),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7563),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7563),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7563),
    [sym_preproc_directive] = ACTIONS(7563),
    [anon_sym_SEMI] = ACTIONS(7561),
    [anon_sym_typedef] = ACTIONS(7563),
    [anon_sym_extern] = ACTIONS(7563),
    [anon_sym_LBRACE] = ACTIONS(7561),
    [anon_sym_LPAREN2] = ACTIONS(7561),
    [anon_sym_STAR] = ACTIONS(7561),
    [anon_sym_LBRACK] = ACTIONS(7561),
    [anon_sym_static] = ACTIONS(7563),
    [anon_sym_register] = ACTIONS(7563),
    [anon_sym_inline] = ACTIONS(7563),
    [anon_sym_const] = ACTIONS(7563),
    [anon_sym_restrict] = ACTIONS(7563),
    [anon_sym_volatile] = ACTIONS(7563),
    [anon_sym__Atomic] = ACTIONS(7563),
    [anon_sym_mutable] = ACTIONS(7563),
    [anon_sym_explicit] = ACTIONS(7563),
    [anon_sym_constexpr] = ACTIONS(7563),
    [anon_sym_unsigned] = ACTIONS(7563),
    [anon_sym_long] = ACTIONS(7563),
    [anon_sym_short] = ACTIONS(7563),
    [sym_primitive_type] = ACTIONS(7563),
    [anon_sym_enum] = ACTIONS(7563),
    [anon_sym_struct] = ACTIONS(7563),
    [anon_sym_union] = ACTIONS(7563),
    [anon_sym_if] = ACTIONS(7563),
    [anon_sym_else] = ACTIONS(7563),
    [anon_sym_switch] = ACTIONS(7563),
    [anon_sym_case] = ACTIONS(7563),
    [anon_sym_default] = ACTIONS(7563),
    [anon_sym_while] = ACTIONS(7563),
    [anon_sym_do] = ACTIONS(7563),
    [anon_sym_for] = ACTIONS(7563),
    [anon_sym_return] = ACTIONS(7563),
    [anon_sym_break] = ACTIONS(7563),
    [anon_sym_continue] = ACTIONS(7563),
    [anon_sym_goto] = ACTIONS(7563),
    [anon_sym_AMP] = ACTIONS(7563),
    [anon_sym_AMP_AMP] = ACTIONS(7561),
    [anon_sym_BANG] = ACTIONS(7561),
    [anon_sym_TILDE] = ACTIONS(7561),
    [anon_sym_PLUS] = ACTIONS(7563),
    [anon_sym_DASH] = ACTIONS(7563),
    [anon_sym_DASH_DASH] = ACTIONS(7561),
    [anon_sym_PLUS_PLUS] = ACTIONS(7561),
    [anon_sym_sizeof] = ACTIONS(7563),
    [sym_number_literal] = ACTIONS(7561),
    [anon_sym_SQUOTE] = ACTIONS(7561),
    [anon_sym_DQUOTE] = ACTIONS(7561),
    [sym_true] = ACTIONS(7563),
    [sym_false] = ACTIONS(7563),
    [sym_null] = ACTIONS(7563),
    [sym_identifier] = ACTIONS(7563),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7563),
    [sym_auto] = ACTIONS(7563),
    [anon_sym_typename] = ACTIONS(7563),
    [anon_sym_template] = ACTIONS(7563),
    [anon_sym_delete] = ACTIONS(7563),
    [anon_sym_namespace] = ACTIONS(7563),
    [anon_sym_using] = ACTIONS(7563),
    [anon_sym_try] = ACTIONS(7563),
    [anon_sym_new] = ACTIONS(7563),
    [anon_sym_COLON_COLON] = ACTIONS(7561),
    [sym_operator_name] = ACTIONS(7561),
    [sym_nullptr] = ACTIONS(7563),
  },
  [3588] = {
    [sym_compound_statement] = STATE(3706),
    [sym_labeled_statement] = STATE(3706),
    [sym_expression_statement] = STATE(3706),
    [sym_if_statement] = STATE(3706),
    [sym_switch_statement] = STATE(3706),
    [sym_case_statement] = STATE(3706),
    [sym_while_statement] = STATE(3706),
    [sym_do_statement] = STATE(3706),
    [sym_for_statement] = STATE(3706),
    [sym_return_statement] = STATE(3706),
    [sym_break_statement] = STATE(3706),
    [sym_continue_statement] = STATE(3706),
    [sym_goto_statement] = STATE(3706),
    [sym__expression] = STATE(1020),
    [sym_comma_expression] = STATE(1021),
    [sym_conditional_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1020),
    [sym_pointer_expression] = STATE(1020),
    [sym_logical_expression] = STATE(1020),
    [sym_bitwise_expression] = STATE(1020),
    [sym_equality_expression] = STATE(1020),
    [sym_relational_expression] = STATE(1020),
    [sym_shift_expression] = STATE(1020),
    [sym_math_expression] = STATE(1020),
    [sym_cast_expression] = STATE(1020),
    [sym_sizeof_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_field_expression] = STATE(1020),
    [sym_compound_literal_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_char_literal] = STATE(1020),
    [sym_concatenated_string] = STATE(1020),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1020),
    [sym_for_range_loop] = STATE(3706),
    [sym_try_statement] = STATE(3706),
    [sym_new_expression] = STATE(1020),
    [sym_delete_expression] = STATE(1020),
    [sym_lambda_expression] = STATE(1020),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2022),
    [anon_sym_SEMI] = ACTIONS(2036),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(2044),
    [anon_sym_switch] = ACTIONS(2046),
    [anon_sym_case] = ACTIONS(2048),
    [anon_sym_default] = ACTIONS(2050),
    [anon_sym_while] = ACTIONS(2052),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(2056),
    [anon_sym_return] = ACTIONS(2058),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2062),
    [anon_sym_goto] = ACTIONS(2064),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(5420),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2076),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2066),
  },
  [3589] = {
    [sym_raw_string_literal] = ACTIONS(7589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7591),
    [sym_preproc_directive] = ACTIONS(7591),
    [anon_sym_SEMI] = ACTIONS(7589),
    [anon_sym_typedef] = ACTIONS(7591),
    [anon_sym_extern] = ACTIONS(7591),
    [anon_sym_LBRACE] = ACTIONS(7589),
    [anon_sym_LPAREN2] = ACTIONS(7589),
    [anon_sym_STAR] = ACTIONS(7589),
    [anon_sym_LBRACK] = ACTIONS(7589),
    [anon_sym_static] = ACTIONS(7591),
    [anon_sym_register] = ACTIONS(7591),
    [anon_sym_inline] = ACTIONS(7591),
    [anon_sym_const] = ACTIONS(7591),
    [anon_sym_restrict] = ACTIONS(7591),
    [anon_sym_volatile] = ACTIONS(7591),
    [anon_sym__Atomic] = ACTIONS(7591),
    [anon_sym_mutable] = ACTIONS(7591),
    [anon_sym_explicit] = ACTIONS(7591),
    [anon_sym_constexpr] = ACTIONS(7591),
    [anon_sym_unsigned] = ACTIONS(7591),
    [anon_sym_long] = ACTIONS(7591),
    [anon_sym_short] = ACTIONS(7591),
    [sym_primitive_type] = ACTIONS(7591),
    [anon_sym_enum] = ACTIONS(7591),
    [anon_sym_struct] = ACTIONS(7591),
    [anon_sym_union] = ACTIONS(7591),
    [anon_sym_if] = ACTIONS(7591),
    [anon_sym_else] = ACTIONS(7591),
    [anon_sym_switch] = ACTIONS(7591),
    [anon_sym_case] = ACTIONS(7591),
    [anon_sym_default] = ACTIONS(7591),
    [anon_sym_while] = ACTIONS(7591),
    [anon_sym_do] = ACTIONS(7591),
    [anon_sym_for] = ACTIONS(7591),
    [anon_sym_return] = ACTIONS(7591),
    [anon_sym_break] = ACTIONS(7591),
    [anon_sym_continue] = ACTIONS(7591),
    [anon_sym_goto] = ACTIONS(7591),
    [anon_sym_AMP] = ACTIONS(7591),
    [anon_sym_AMP_AMP] = ACTIONS(7589),
    [anon_sym_BANG] = ACTIONS(7589),
    [anon_sym_TILDE] = ACTIONS(7589),
    [anon_sym_PLUS] = ACTIONS(7591),
    [anon_sym_DASH] = ACTIONS(7591),
    [anon_sym_DASH_DASH] = ACTIONS(7589),
    [anon_sym_PLUS_PLUS] = ACTIONS(7589),
    [anon_sym_sizeof] = ACTIONS(7591),
    [sym_number_literal] = ACTIONS(7589),
    [anon_sym_SQUOTE] = ACTIONS(7589),
    [anon_sym_DQUOTE] = ACTIONS(7589),
    [sym_true] = ACTIONS(7591),
    [sym_false] = ACTIONS(7591),
    [sym_null] = ACTIONS(7591),
    [sym_identifier] = ACTIONS(7591),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7591),
    [sym_auto] = ACTIONS(7591),
    [anon_sym_typename] = ACTIONS(7591),
    [anon_sym_template] = ACTIONS(7591),
    [anon_sym_delete] = ACTIONS(7591),
    [anon_sym_namespace] = ACTIONS(7591),
    [anon_sym_using] = ACTIONS(7591),
    [anon_sym_try] = ACTIONS(7591),
    [anon_sym_new] = ACTIONS(7591),
    [anon_sym_COLON_COLON] = ACTIONS(7589),
    [sym_operator_name] = ACTIONS(7589),
    [sym_nullptr] = ACTIONS(7591),
  },
  [3590] = {
    [sym_compound_statement] = STATE(3707),
    [sym_labeled_statement] = STATE(3707),
    [sym_expression_statement] = STATE(3707),
    [sym_if_statement] = STATE(3707),
    [sym_switch_statement] = STATE(3707),
    [sym_case_statement] = STATE(3707),
    [sym_while_statement] = STATE(3707),
    [sym_do_statement] = STATE(3707),
    [sym_for_statement] = STATE(3707),
    [sym_return_statement] = STATE(3707),
    [sym_break_statement] = STATE(3707),
    [sym_continue_statement] = STATE(3707),
    [sym_goto_statement] = STATE(3707),
    [sym__expression] = STATE(1020),
    [sym_comma_expression] = STATE(1021),
    [sym_conditional_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1020),
    [sym_pointer_expression] = STATE(1020),
    [sym_logical_expression] = STATE(1020),
    [sym_bitwise_expression] = STATE(1020),
    [sym_equality_expression] = STATE(1020),
    [sym_relational_expression] = STATE(1020),
    [sym_shift_expression] = STATE(1020),
    [sym_math_expression] = STATE(1020),
    [sym_cast_expression] = STATE(1020),
    [sym_sizeof_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_field_expression] = STATE(1020),
    [sym_compound_literal_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_char_literal] = STATE(1020),
    [sym_concatenated_string] = STATE(1020),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1020),
    [sym_for_range_loop] = STATE(3707),
    [sym_try_statement] = STATE(3707),
    [sym_new_expression] = STATE(1020),
    [sym_delete_expression] = STATE(1020),
    [sym_lambda_expression] = STATE(1020),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2022),
    [anon_sym_SEMI] = ACTIONS(2036),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(2044),
    [anon_sym_switch] = ACTIONS(2046),
    [anon_sym_case] = ACTIONS(2048),
    [anon_sym_default] = ACTIONS(2050),
    [anon_sym_while] = ACTIONS(2052),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(2056),
    [anon_sym_return] = ACTIONS(2058),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2062),
    [anon_sym_goto] = ACTIONS(2064),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(5420),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2076),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2066),
  },
  [3591] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8185),
    [sym_comment] = ACTIONS(91),
  },
  [3592] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3709),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8185),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3593] = {
    [sym_raw_string_literal] = ACTIONS(7598),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7600),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7600),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7600),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7600),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7600),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7600),
    [sym_preproc_directive] = ACTIONS(7600),
    [anon_sym_SEMI] = ACTIONS(7598),
    [anon_sym_typedef] = ACTIONS(7600),
    [anon_sym_extern] = ACTIONS(7600),
    [anon_sym_LBRACE] = ACTIONS(7598),
    [anon_sym_LPAREN2] = ACTIONS(7598),
    [anon_sym_STAR] = ACTIONS(7598),
    [anon_sym_LBRACK] = ACTIONS(7598),
    [anon_sym_static] = ACTIONS(7600),
    [anon_sym_register] = ACTIONS(7600),
    [anon_sym_inline] = ACTIONS(7600),
    [anon_sym_const] = ACTIONS(7600),
    [anon_sym_restrict] = ACTIONS(7600),
    [anon_sym_volatile] = ACTIONS(7600),
    [anon_sym__Atomic] = ACTIONS(7600),
    [anon_sym_mutable] = ACTIONS(7600),
    [anon_sym_explicit] = ACTIONS(7600),
    [anon_sym_constexpr] = ACTIONS(7600),
    [anon_sym_unsigned] = ACTIONS(7600),
    [anon_sym_long] = ACTIONS(7600),
    [anon_sym_short] = ACTIONS(7600),
    [sym_primitive_type] = ACTIONS(7600),
    [anon_sym_enum] = ACTIONS(7600),
    [anon_sym_struct] = ACTIONS(7600),
    [anon_sym_union] = ACTIONS(7600),
    [anon_sym_if] = ACTIONS(7600),
    [anon_sym_else] = ACTIONS(7600),
    [anon_sym_switch] = ACTIONS(7600),
    [anon_sym_case] = ACTIONS(7600),
    [anon_sym_default] = ACTIONS(7600),
    [anon_sym_while] = ACTIONS(7600),
    [anon_sym_do] = ACTIONS(7600),
    [anon_sym_for] = ACTIONS(7600),
    [anon_sym_return] = ACTIONS(7600),
    [anon_sym_break] = ACTIONS(7600),
    [anon_sym_continue] = ACTIONS(7600),
    [anon_sym_goto] = ACTIONS(7600),
    [anon_sym_AMP] = ACTIONS(7600),
    [anon_sym_AMP_AMP] = ACTIONS(7598),
    [anon_sym_BANG] = ACTIONS(7598),
    [anon_sym_TILDE] = ACTIONS(7598),
    [anon_sym_PLUS] = ACTIONS(7600),
    [anon_sym_DASH] = ACTIONS(7600),
    [anon_sym_DASH_DASH] = ACTIONS(7598),
    [anon_sym_PLUS_PLUS] = ACTIONS(7598),
    [anon_sym_sizeof] = ACTIONS(7600),
    [sym_number_literal] = ACTIONS(7598),
    [anon_sym_SQUOTE] = ACTIONS(7598),
    [anon_sym_DQUOTE] = ACTIONS(7598),
    [sym_true] = ACTIONS(7600),
    [sym_false] = ACTIONS(7600),
    [sym_null] = ACTIONS(7600),
    [sym_identifier] = ACTIONS(7600),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7600),
    [sym_auto] = ACTIONS(7600),
    [anon_sym_typename] = ACTIONS(7600),
    [anon_sym_template] = ACTIONS(7600),
    [anon_sym_delete] = ACTIONS(7600),
    [anon_sym_namespace] = ACTIONS(7600),
    [anon_sym_using] = ACTIONS(7600),
    [anon_sym_try] = ACTIONS(7600),
    [anon_sym_new] = ACTIONS(7600),
    [anon_sym_COLON_COLON] = ACTIONS(7598),
    [sym_operator_name] = ACTIONS(7598),
    [sym_nullptr] = ACTIONS(7600),
  },
  [3594] = {
    [sym_compound_statement] = STATE(3710),
    [sym_labeled_statement] = STATE(3710),
    [sym_expression_statement] = STATE(3710),
    [sym_if_statement] = STATE(3710),
    [sym_switch_statement] = STATE(3710),
    [sym_case_statement] = STATE(3710),
    [sym_while_statement] = STATE(3710),
    [sym_do_statement] = STATE(3710),
    [sym_for_statement] = STATE(3710),
    [sym_return_statement] = STATE(3710),
    [sym_break_statement] = STATE(3710),
    [sym_continue_statement] = STATE(3710),
    [sym_goto_statement] = STATE(3710),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(411),
    [sym_for_range_loop] = STATE(3710),
    [sym_try_statement] = STATE(3710),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(678),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(6682),
    [anon_sym_switch] = ACTIONS(6684),
    [anon_sym_case] = ACTIONS(6686),
    [anon_sym_default] = ACTIONS(6688),
    [anon_sym_while] = ACTIONS(6690),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(6692),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(6694),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(6696),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(726),
  },
  [3595] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(8187),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3596] = {
    [sym__expression] = STATE(3713),
    [sym_conditional_expression] = STATE(3713),
    [sym_assignment_expression] = STATE(3713),
    [sym_pointer_expression] = STATE(3713),
    [sym_logical_expression] = STATE(3713),
    [sym_bitwise_expression] = STATE(3713),
    [sym_equality_expression] = STATE(3713),
    [sym_relational_expression] = STATE(3713),
    [sym_shift_expression] = STATE(3713),
    [sym_math_expression] = STATE(3713),
    [sym_cast_expression] = STATE(3713),
    [sym_sizeof_expression] = STATE(3713),
    [sym_subscript_expression] = STATE(3713),
    [sym_call_expression] = STATE(3713),
    [sym_field_expression] = STATE(3713),
    [sym_compound_literal_expression] = STATE(3713),
    [sym_parenthesized_expression] = STATE(3713),
    [sym_char_literal] = STATE(3713),
    [sym_concatenated_string] = STATE(3713),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3713),
    [sym_new_expression] = STATE(3713),
    [sym_delete_expression] = STATE(3713),
    [sym_lambda_expression] = STATE(3713),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8189),
    [anon_sym_RPAREN] = ACTIONS(8191),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(8189),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8193),
    [sym_false] = ACTIONS(8193),
    [sym_null] = ACTIONS(8193),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(8193),
  },
  [3597] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(8195),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3598] = {
    [sym__expression] = STATE(3715),
    [sym_conditional_expression] = STATE(3715),
    [sym_assignment_expression] = STATE(3715),
    [sym_pointer_expression] = STATE(3715),
    [sym_logical_expression] = STATE(3715),
    [sym_bitwise_expression] = STATE(3715),
    [sym_equality_expression] = STATE(3715),
    [sym_relational_expression] = STATE(3715),
    [sym_shift_expression] = STATE(3715),
    [sym_math_expression] = STATE(3715),
    [sym_cast_expression] = STATE(3715),
    [sym_sizeof_expression] = STATE(3715),
    [sym_subscript_expression] = STATE(3715),
    [sym_call_expression] = STATE(3715),
    [sym_field_expression] = STATE(3715),
    [sym_compound_literal_expression] = STATE(3715),
    [sym_parenthesized_expression] = STATE(3715),
    [sym_char_literal] = STATE(3715),
    [sym_concatenated_string] = STATE(3715),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3715),
    [sym_new_expression] = STATE(3715),
    [sym_delete_expression] = STATE(3715),
    [sym_lambda_expression] = STATE(3715),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8197),
    [anon_sym_SEMI] = ACTIONS(8195),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(8197),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8199),
    [sym_false] = ACTIONS(8199),
    [sym_null] = ACTIONS(8199),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(8199),
  },
  [3599] = {
    [sym__expression] = STATE(3716),
    [sym_conditional_expression] = STATE(3716),
    [sym_assignment_expression] = STATE(3716),
    [sym_pointer_expression] = STATE(3716),
    [sym_logical_expression] = STATE(3716),
    [sym_bitwise_expression] = STATE(3716),
    [sym_equality_expression] = STATE(3716),
    [sym_relational_expression] = STATE(3716),
    [sym_shift_expression] = STATE(3716),
    [sym_math_expression] = STATE(3716),
    [sym_cast_expression] = STATE(3716),
    [sym_sizeof_expression] = STATE(3716),
    [sym_subscript_expression] = STATE(3716),
    [sym_call_expression] = STATE(3716),
    [sym_field_expression] = STATE(3716),
    [sym_compound_literal_expression] = STATE(3716),
    [sym_parenthesized_expression] = STATE(3716),
    [sym_char_literal] = STATE(3716),
    [sym_concatenated_string] = STATE(3716),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3716),
    [sym_new_expression] = STATE(3716),
    [sym_delete_expression] = STATE(3716),
    [sym_lambda_expression] = STATE(3716),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8201),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(8201),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8203),
    [sym_false] = ACTIONS(8203),
    [sym_null] = ACTIONS(8203),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(8203),
  },
  [3600] = {
    [sym_catch_clause] = STATE(3600),
    [aux_sym_try_statement_repeat1] = STATE(3600),
    [sym_raw_string_literal] = ACTIONS(4993),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4995),
    [sym_preproc_directive] = ACTIONS(4995),
    [anon_sym_SEMI] = ACTIONS(4993),
    [anon_sym_typedef] = ACTIONS(4995),
    [anon_sym_extern] = ACTIONS(4995),
    [anon_sym_LBRACE] = ACTIONS(4993),
    [anon_sym_LPAREN2] = ACTIONS(4993),
    [anon_sym_STAR] = ACTIONS(4993),
    [anon_sym_LBRACK] = ACTIONS(4993),
    [anon_sym_static] = ACTIONS(4995),
    [anon_sym_register] = ACTIONS(4995),
    [anon_sym_inline] = ACTIONS(4995),
    [anon_sym_const] = ACTIONS(4995),
    [anon_sym_restrict] = ACTIONS(4995),
    [anon_sym_volatile] = ACTIONS(4995),
    [anon_sym__Atomic] = ACTIONS(4995),
    [anon_sym_mutable] = ACTIONS(4995),
    [anon_sym_explicit] = ACTIONS(4995),
    [anon_sym_constexpr] = ACTIONS(4995),
    [anon_sym_unsigned] = ACTIONS(4995),
    [anon_sym_long] = ACTIONS(4995),
    [anon_sym_short] = ACTIONS(4995),
    [sym_primitive_type] = ACTIONS(4995),
    [anon_sym_enum] = ACTIONS(4995),
    [anon_sym_struct] = ACTIONS(4995),
    [anon_sym_union] = ACTIONS(4995),
    [anon_sym_if] = ACTIONS(4995),
    [anon_sym_else] = ACTIONS(4995),
    [anon_sym_switch] = ACTIONS(4995),
    [anon_sym_case] = ACTIONS(4995),
    [anon_sym_default] = ACTIONS(4995),
    [anon_sym_while] = ACTIONS(4995),
    [anon_sym_do] = ACTIONS(4995),
    [anon_sym_for] = ACTIONS(4995),
    [anon_sym_return] = ACTIONS(4995),
    [anon_sym_break] = ACTIONS(4995),
    [anon_sym_continue] = ACTIONS(4995),
    [anon_sym_goto] = ACTIONS(4995),
    [anon_sym_AMP] = ACTIONS(4995),
    [anon_sym_AMP_AMP] = ACTIONS(4993),
    [anon_sym_BANG] = ACTIONS(4993),
    [anon_sym_TILDE] = ACTIONS(4993),
    [anon_sym_PLUS] = ACTIONS(4995),
    [anon_sym_DASH] = ACTIONS(4995),
    [anon_sym_DASH_DASH] = ACTIONS(4993),
    [anon_sym_PLUS_PLUS] = ACTIONS(4993),
    [anon_sym_sizeof] = ACTIONS(4995),
    [sym_number_literal] = ACTIONS(4993),
    [anon_sym_SQUOTE] = ACTIONS(4993),
    [anon_sym_DQUOTE] = ACTIONS(4993),
    [sym_true] = ACTIONS(4995),
    [sym_false] = ACTIONS(4995),
    [sym_null] = ACTIONS(4995),
    [sym_identifier] = ACTIONS(4995),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4995),
    [sym_auto] = ACTIONS(4995),
    [anon_sym_typename] = ACTIONS(4995),
    [anon_sym_template] = ACTIONS(4995),
    [anon_sym_delete] = ACTIONS(4995),
    [anon_sym_namespace] = ACTIONS(4995),
    [anon_sym_using] = ACTIONS(4995),
    [anon_sym_try] = ACTIONS(4995),
    [anon_sym_catch] = ACTIONS(6722),
    [anon_sym_new] = ACTIONS(4995),
    [anon_sym_COLON_COLON] = ACTIONS(4993),
    [sym_operator_name] = ACTIONS(4993),
    [sym_nullptr] = ACTIONS(4995),
  },
  [3601] = {
    [sym_raw_string_literal] = ACTIONS(7906),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7908),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7908),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7908),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7908),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7908),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7908),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7908),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7908),
    [sym_preproc_directive] = ACTIONS(7908),
    [anon_sym_SEMI] = ACTIONS(7906),
    [anon_sym_typedef] = ACTIONS(7908),
    [anon_sym_extern] = ACTIONS(7908),
    [anon_sym_LBRACE] = ACTIONS(7906),
    [anon_sym_LPAREN2] = ACTIONS(7906),
    [anon_sym_STAR] = ACTIONS(7906),
    [anon_sym_LBRACK] = ACTIONS(7906),
    [anon_sym_static] = ACTIONS(7908),
    [anon_sym_register] = ACTIONS(7908),
    [anon_sym_inline] = ACTIONS(7908),
    [anon_sym_const] = ACTIONS(7908),
    [anon_sym_restrict] = ACTIONS(7908),
    [anon_sym_volatile] = ACTIONS(7908),
    [anon_sym__Atomic] = ACTIONS(7908),
    [anon_sym_mutable] = ACTIONS(7908),
    [anon_sym_explicit] = ACTIONS(7908),
    [anon_sym_constexpr] = ACTIONS(7908),
    [anon_sym_unsigned] = ACTIONS(7908),
    [anon_sym_long] = ACTIONS(7908),
    [anon_sym_short] = ACTIONS(7908),
    [sym_primitive_type] = ACTIONS(7908),
    [anon_sym_enum] = ACTIONS(7908),
    [anon_sym_struct] = ACTIONS(7908),
    [anon_sym_union] = ACTIONS(7908),
    [anon_sym_if] = ACTIONS(7908),
    [anon_sym_else] = ACTIONS(7908),
    [anon_sym_switch] = ACTIONS(7908),
    [anon_sym_case] = ACTIONS(7908),
    [anon_sym_default] = ACTIONS(7908),
    [anon_sym_while] = ACTIONS(7908),
    [anon_sym_do] = ACTIONS(7908),
    [anon_sym_for] = ACTIONS(7908),
    [anon_sym_return] = ACTIONS(7908),
    [anon_sym_break] = ACTIONS(7908),
    [anon_sym_continue] = ACTIONS(7908),
    [anon_sym_goto] = ACTIONS(7908),
    [anon_sym_AMP] = ACTIONS(7908),
    [anon_sym_AMP_AMP] = ACTIONS(7906),
    [anon_sym_BANG] = ACTIONS(7906),
    [anon_sym_TILDE] = ACTIONS(7906),
    [anon_sym_PLUS] = ACTIONS(7908),
    [anon_sym_DASH] = ACTIONS(7908),
    [anon_sym_DASH_DASH] = ACTIONS(7906),
    [anon_sym_PLUS_PLUS] = ACTIONS(7906),
    [anon_sym_sizeof] = ACTIONS(7908),
    [sym_number_literal] = ACTIONS(7906),
    [anon_sym_SQUOTE] = ACTIONS(7906),
    [anon_sym_DQUOTE] = ACTIONS(7906),
    [sym_true] = ACTIONS(7908),
    [sym_false] = ACTIONS(7908),
    [sym_null] = ACTIONS(7908),
    [sym_identifier] = ACTIONS(7908),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7908),
    [sym_auto] = ACTIONS(7908),
    [anon_sym_typename] = ACTIONS(7908),
    [anon_sym_template] = ACTIONS(7908),
    [anon_sym_delete] = ACTIONS(7908),
    [anon_sym_namespace] = ACTIONS(7908),
    [anon_sym_using] = ACTIONS(7908),
    [anon_sym_try] = ACTIONS(7908),
    [anon_sym_new] = ACTIONS(7908),
    [anon_sym_COLON_COLON] = ACTIONS(7906),
    [sym_operator_name] = ACTIONS(7906),
    [sym_nullptr] = ACTIONS(7908),
  },
  [3602] = {
    [sym_raw_string_literal] = ACTIONS(7928),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7930),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7930),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7930),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7930),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7930),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7930),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7930),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7930),
    [sym_preproc_directive] = ACTIONS(7930),
    [anon_sym_SEMI] = ACTIONS(7928),
    [anon_sym_typedef] = ACTIONS(7930),
    [anon_sym_extern] = ACTIONS(7930),
    [anon_sym_LBRACE] = ACTIONS(7928),
    [anon_sym_LPAREN2] = ACTIONS(7928),
    [anon_sym_STAR] = ACTIONS(7928),
    [anon_sym_LBRACK] = ACTIONS(7928),
    [anon_sym_static] = ACTIONS(7930),
    [anon_sym_register] = ACTIONS(7930),
    [anon_sym_inline] = ACTIONS(7930),
    [anon_sym_const] = ACTIONS(7930),
    [anon_sym_restrict] = ACTIONS(7930),
    [anon_sym_volatile] = ACTIONS(7930),
    [anon_sym__Atomic] = ACTIONS(7930),
    [anon_sym_mutable] = ACTIONS(7930),
    [anon_sym_explicit] = ACTIONS(7930),
    [anon_sym_constexpr] = ACTIONS(7930),
    [anon_sym_unsigned] = ACTIONS(7930),
    [anon_sym_long] = ACTIONS(7930),
    [anon_sym_short] = ACTIONS(7930),
    [sym_primitive_type] = ACTIONS(7930),
    [anon_sym_enum] = ACTIONS(7930),
    [anon_sym_struct] = ACTIONS(7930),
    [anon_sym_union] = ACTIONS(7930),
    [anon_sym_if] = ACTIONS(7930),
    [anon_sym_else] = ACTIONS(7930),
    [anon_sym_switch] = ACTIONS(7930),
    [anon_sym_case] = ACTIONS(7930),
    [anon_sym_default] = ACTIONS(7930),
    [anon_sym_while] = ACTIONS(7930),
    [anon_sym_do] = ACTIONS(7930),
    [anon_sym_for] = ACTIONS(7930),
    [anon_sym_return] = ACTIONS(7930),
    [anon_sym_break] = ACTIONS(7930),
    [anon_sym_continue] = ACTIONS(7930),
    [anon_sym_goto] = ACTIONS(7930),
    [anon_sym_AMP] = ACTIONS(7930),
    [anon_sym_AMP_AMP] = ACTIONS(7928),
    [anon_sym_BANG] = ACTIONS(7928),
    [anon_sym_TILDE] = ACTIONS(7928),
    [anon_sym_PLUS] = ACTIONS(7930),
    [anon_sym_DASH] = ACTIONS(7930),
    [anon_sym_DASH_DASH] = ACTIONS(7928),
    [anon_sym_PLUS_PLUS] = ACTIONS(7928),
    [anon_sym_sizeof] = ACTIONS(7930),
    [sym_number_literal] = ACTIONS(7928),
    [anon_sym_SQUOTE] = ACTIONS(7928),
    [anon_sym_DQUOTE] = ACTIONS(7928),
    [sym_true] = ACTIONS(7930),
    [sym_false] = ACTIONS(7930),
    [sym_null] = ACTIONS(7930),
    [sym_identifier] = ACTIONS(7930),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7930),
    [sym_auto] = ACTIONS(7930),
    [anon_sym_typename] = ACTIONS(7930),
    [anon_sym_template] = ACTIONS(7930),
    [anon_sym_delete] = ACTIONS(7930),
    [anon_sym_namespace] = ACTIONS(7930),
    [anon_sym_using] = ACTIONS(7930),
    [anon_sym_try] = ACTIONS(7930),
    [anon_sym_new] = ACTIONS(7930),
    [anon_sym_COLON_COLON] = ACTIONS(7928),
    [sym_operator_name] = ACTIONS(7928),
    [sym_nullptr] = ACTIONS(7930),
  },
  [3603] = {
    [sym_compound_statement] = STATE(3717),
    [sym_labeled_statement] = STATE(3717),
    [sym_expression_statement] = STATE(3717),
    [sym_if_statement] = STATE(3717),
    [sym_switch_statement] = STATE(3717),
    [sym_case_statement] = STATE(3717),
    [sym_while_statement] = STATE(3717),
    [sym_do_statement] = STATE(3717),
    [sym_for_statement] = STATE(3717),
    [sym_return_statement] = STATE(3717),
    [sym_break_statement] = STATE(3717),
    [sym_continue_statement] = STATE(3717),
    [sym_goto_statement] = STATE(3717),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(411),
    [sym_for_range_loop] = STATE(3717),
    [sym_try_statement] = STATE(3717),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(678),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(704),
    [anon_sym_switch] = ACTIONS(706),
    [anon_sym_case] = ACTIONS(708),
    [anon_sym_default] = ACTIONS(710),
    [anon_sym_while] = ACTIONS(712),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(3807),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(736),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(726),
  },
  [3604] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8205),
    [sym_comment] = ACTIONS(91),
  },
  [3605] = {
    [sym__expression] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3719),
    [sym_logical_expression] = STATE(3719),
    [sym_bitwise_expression] = STATE(3719),
    [sym_equality_expression] = STATE(3719),
    [sym_relational_expression] = STATE(3719),
    [sym_shift_expression] = STATE(3719),
    [sym_math_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3719),
    [sym_call_expression] = STATE(3719),
    [sym_field_expression] = STATE(3719),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3719),
    [sym_char_literal] = STATE(3719),
    [sym_concatenated_string] = STATE(3719),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8207),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(8207),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8209),
    [sym_false] = ACTIONS(8209),
    [sym_null] = ACTIONS(8209),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(8209),
  },
  [3606] = {
    [anon_sym_LPAREN2] = ACTIONS(8211),
    [sym_comment] = ACTIONS(91),
  },
  [3607] = {
    [sym_compound_statement] = STATE(3011),
    [sym_labeled_statement] = STATE(3011),
    [sym_expression_statement] = STATE(3011),
    [sym_if_statement] = STATE(3011),
    [sym_switch_statement] = STATE(3011),
    [sym_case_statement] = STATE(3011),
    [sym_while_statement] = STATE(3011),
    [sym_do_statement] = STATE(3011),
    [sym_for_statement] = STATE(3011),
    [sym_return_statement] = STATE(3011),
    [sym_break_statement] = STATE(3011),
    [sym_continue_statement] = STATE(3011),
    [sym_goto_statement] = STATE(3011),
    [sym__expression] = STATE(1908),
    [sym_comma_expression] = STATE(1909),
    [sym_conditional_expression] = STATE(1908),
    [sym_assignment_expression] = STATE(1908),
    [sym_pointer_expression] = STATE(1908),
    [sym_logical_expression] = STATE(1908),
    [sym_bitwise_expression] = STATE(1908),
    [sym_equality_expression] = STATE(1908),
    [sym_relational_expression] = STATE(1908),
    [sym_shift_expression] = STATE(1908),
    [sym_math_expression] = STATE(1908),
    [sym_cast_expression] = STATE(1908),
    [sym_sizeof_expression] = STATE(1908),
    [sym_subscript_expression] = STATE(1908),
    [sym_call_expression] = STATE(1908),
    [sym_field_expression] = STATE(1908),
    [sym_compound_literal_expression] = STATE(1908),
    [sym_parenthesized_expression] = STATE(1908),
    [sym_char_literal] = STATE(1908),
    [sym_concatenated_string] = STATE(1908),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1908),
    [sym_for_range_loop] = STATE(3011),
    [sym_try_statement] = STATE(3011),
    [sym_new_expression] = STATE(1908),
    [sym_delete_expression] = STATE(1908),
    [sym_lambda_expression] = STATE(1908),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3996),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7766),
    [anon_sym_switch] = ACTIONS(7768),
    [anon_sym_case] = ACTIONS(7770),
    [anon_sym_default] = ACTIONS(7772),
    [anon_sym_while] = ACTIONS(7774),
    [anon_sym_do] = ACTIONS(4026),
    [anon_sym_for] = ACTIONS(7776),
    [anon_sym_return] = ACTIONS(4030),
    [anon_sym_break] = ACTIONS(4032),
    [anon_sym_continue] = ACTIONS(4034),
    [anon_sym_goto] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(3996),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4038),
    [sym_false] = ACTIONS(4038),
    [sym_null] = ACTIONS(4038),
    [sym_identifier] = ACTIONS(7778),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7780),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(4038),
  },
  [3608] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_COLON] = ACTIONS(8213),
    [anon_sym_QMARK] = ACTIONS(1171),
    [anon_sym_STAR_EQ] = ACTIONS(1173),
    [anon_sym_SLASH_EQ] = ACTIONS(1173),
    [anon_sym_PERCENT_EQ] = ACTIONS(1173),
    [anon_sym_PLUS_EQ] = ACTIONS(1173),
    [anon_sym_DASH_EQ] = ACTIONS(1173),
    [anon_sym_LT_LT_EQ] = ACTIONS(1173),
    [anon_sym_GT_GT_EQ] = ACTIONS(1173),
    [anon_sym_AMP_EQ] = ACTIONS(1173),
    [anon_sym_CARET_EQ] = ACTIONS(1173),
    [anon_sym_PIPE_EQ] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_CARET] = ACTIONS(1183),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(91),
  },
  [3609] = {
    [sym_declaration] = STATE(3014),
    [sym_type_definition] = STATE(3014),
    [sym__declaration_specifiers] = STATE(3015),
    [sym_compound_statement] = STATE(3014),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_labeled_statement] = STATE(3014),
    [sym_expression_statement] = STATE(3014),
    [sym_if_statement] = STATE(3014),
    [sym_switch_statement] = STATE(3014),
    [sym_case_statement] = STATE(3014),
    [sym_while_statement] = STATE(3014),
    [sym_do_statement] = STATE(3014),
    [sym_for_statement] = STATE(3014),
    [sym_return_statement] = STATE(3014),
    [sym_break_statement] = STATE(3014),
    [sym_continue_statement] = STATE(3014),
    [sym_goto_statement] = STATE(3014),
    [sym__expression] = STATE(1908),
    [sym_comma_expression] = STATE(1909),
    [sym_conditional_expression] = STATE(1908),
    [sym_assignment_expression] = STATE(1908),
    [sym_pointer_expression] = STATE(1908),
    [sym_logical_expression] = STATE(1908),
    [sym_bitwise_expression] = STATE(1908),
    [sym_equality_expression] = STATE(1908),
    [sym_relational_expression] = STATE(1908),
    [sym_shift_expression] = STATE(1908),
    [sym_math_expression] = STATE(1908),
    [sym_cast_expression] = STATE(1908),
    [sym_sizeof_expression] = STATE(1908),
    [sym_subscript_expression] = STATE(1908),
    [sym_call_expression] = STATE(1908),
    [sym_field_expression] = STATE(1908),
    [sym_compound_literal_expression] = STATE(1908),
    [sym_parenthesized_expression] = STATE(1908),
    [sym_char_literal] = STATE(1908),
    [sym_concatenated_string] = STATE(1908),
    [sym_string_literal] = STATE(55),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(1908),
    [sym_for_range_loop] = STATE(3014),
    [sym_try_statement] = STATE(3014),
    [sym_new_expression] = STATE(1908),
    [sym_delete_expression] = STATE(1908),
    [sym_lambda_expression] = STATE(1908),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(3996),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_typedef] = ACTIONS(4012),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(7766),
    [anon_sym_switch] = ACTIONS(7768),
    [anon_sym_case] = ACTIONS(7770),
    [anon_sym_default] = ACTIONS(7772),
    [anon_sym_while] = ACTIONS(7774),
    [anon_sym_do] = ACTIONS(4026),
    [anon_sym_for] = ACTIONS(7776),
    [anon_sym_return] = ACTIONS(4030),
    [anon_sym_break] = ACTIONS(4032),
    [anon_sym_continue] = ACTIONS(4034),
    [anon_sym_goto] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(3996),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4038),
    [sym_false] = ACTIONS(4038),
    [sym_null] = ACTIONS(4038),
    [sym_identifier] = ACTIONS(8215),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7780),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(1202),
    [sym_nullptr] = ACTIONS(4038),
  },
  [3610] = {
    [sym_compound_statement] = STATE(3016),
    [sym_labeled_statement] = STATE(3016),
    [sym_expression_statement] = STATE(3016),
    [sym_if_statement] = STATE(3016),
    [sym_switch_statement] = STATE(3016),
    [sym_case_statement] = STATE(3016),
    [sym_while_statement] = STATE(3016),
    [sym_do_statement] = STATE(3016),
    [sym_for_statement] = STATE(3016),
    [sym_return_statement] = STATE(3016),
    [sym_break_statement] = STATE(3016),
    [sym_continue_statement] = STATE(3016),
    [sym_goto_statement] = STATE(3016),
    [sym__expression] = STATE(1908),
    [sym_comma_expression] = STATE(1909),
    [sym_conditional_expression] = STATE(1908),
    [sym_assignment_expression] = STATE(1908),
    [sym_pointer_expression] = STATE(1908),
    [sym_logical_expression] = STATE(1908),
    [sym_bitwise_expression] = STATE(1908),
    [sym_equality_expression] = STATE(1908),
    [sym_relational_expression] = STATE(1908),
    [sym_shift_expression] = STATE(1908),
    [sym_math_expression] = STATE(1908),
    [sym_cast_expression] = STATE(1908),
    [sym_sizeof_expression] = STATE(1908),
    [sym_subscript_expression] = STATE(1908),
    [sym_call_expression] = STATE(1908),
    [sym_field_expression] = STATE(1908),
    [sym_compound_literal_expression] = STATE(1908),
    [sym_parenthesized_expression] = STATE(1908),
    [sym_char_literal] = STATE(1908),
    [sym_concatenated_string] = STATE(1908),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1908),
    [sym_for_range_loop] = STATE(3016),
    [sym_try_statement] = STATE(3016),
    [sym_new_expression] = STATE(1908),
    [sym_delete_expression] = STATE(1908),
    [sym_lambda_expression] = STATE(1908),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3996),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7766),
    [anon_sym_switch] = ACTIONS(7768),
    [anon_sym_case] = ACTIONS(7770),
    [anon_sym_default] = ACTIONS(7772),
    [anon_sym_while] = ACTIONS(7774),
    [anon_sym_do] = ACTIONS(4026),
    [anon_sym_for] = ACTIONS(7776),
    [anon_sym_return] = ACTIONS(4030),
    [anon_sym_break] = ACTIONS(4032),
    [anon_sym_continue] = ACTIONS(4034),
    [anon_sym_goto] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(3996),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4038),
    [sym_false] = ACTIONS(4038),
    [sym_null] = ACTIONS(4038),
    [sym_identifier] = ACTIONS(7778),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7780),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(4038),
  },
  [3611] = {
    [sym_declaration] = STATE(3723),
    [sym__declaration_specifiers] = STATE(709),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym__expression] = STATE(3724),
    [sym_conditional_expression] = STATE(3724),
    [sym_assignment_expression] = STATE(3724),
    [sym_pointer_expression] = STATE(3724),
    [sym_logical_expression] = STATE(3724),
    [sym_bitwise_expression] = STATE(3724),
    [sym_equality_expression] = STATE(3724),
    [sym_relational_expression] = STATE(3724),
    [sym_shift_expression] = STATE(3724),
    [sym_math_expression] = STATE(3724),
    [sym_cast_expression] = STATE(3724),
    [sym_sizeof_expression] = STATE(3724),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(3724),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3724),
    [sym_concatenated_string] = STATE(3724),
    [sym_string_literal] = STATE(238),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(3724),
    [sym_for_range_declaration] = STATE(3725),
    [sym_new_expression] = STATE(3724),
    [sym_delete_expression] = STATE(3724),
    [sym_lambda_expression] = STATE(3724),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(8217),
    [anon_sym_SEMI] = ACTIONS(8219),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(8217),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8221),
    [sym_false] = ACTIONS(8221),
    [sym_null] = ACTIONS(8221),
    [sym_identifier] = ACTIONS(1242),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(1244),
    [sym_nullptr] = ACTIONS(8221),
  },
  [3612] = {
    [sym_compound_statement] = STATE(3023),
    [sym_labeled_statement] = STATE(3023),
    [sym_expression_statement] = STATE(3023),
    [sym_if_statement] = STATE(3023),
    [sym_switch_statement] = STATE(3023),
    [sym_case_statement] = STATE(3023),
    [sym_while_statement] = STATE(3023),
    [sym_do_statement] = STATE(3023),
    [sym_for_statement] = STATE(3023),
    [sym_return_statement] = STATE(3023),
    [sym_break_statement] = STATE(3023),
    [sym_continue_statement] = STATE(3023),
    [sym_goto_statement] = STATE(3023),
    [sym__expression] = STATE(1908),
    [sym_comma_expression] = STATE(1909),
    [sym_conditional_expression] = STATE(1908),
    [sym_assignment_expression] = STATE(1908),
    [sym_pointer_expression] = STATE(1908),
    [sym_logical_expression] = STATE(1908),
    [sym_bitwise_expression] = STATE(1908),
    [sym_equality_expression] = STATE(1908),
    [sym_relational_expression] = STATE(1908),
    [sym_shift_expression] = STATE(1908),
    [sym_math_expression] = STATE(1908),
    [sym_cast_expression] = STATE(1908),
    [sym_sizeof_expression] = STATE(1908),
    [sym_subscript_expression] = STATE(1908),
    [sym_call_expression] = STATE(1908),
    [sym_field_expression] = STATE(1908),
    [sym_compound_literal_expression] = STATE(1908),
    [sym_parenthesized_expression] = STATE(1908),
    [sym_char_literal] = STATE(1908),
    [sym_concatenated_string] = STATE(1908),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1908),
    [sym_for_range_loop] = STATE(3023),
    [sym_try_statement] = STATE(3023),
    [sym_new_expression] = STATE(1908),
    [sym_delete_expression] = STATE(1908),
    [sym_lambda_expression] = STATE(1908),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3996),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7766),
    [anon_sym_switch] = ACTIONS(7768),
    [anon_sym_case] = ACTIONS(7770),
    [anon_sym_default] = ACTIONS(7772),
    [anon_sym_while] = ACTIONS(7774),
    [anon_sym_do] = ACTIONS(4026),
    [anon_sym_for] = ACTIONS(7776),
    [anon_sym_return] = ACTIONS(4030),
    [anon_sym_break] = ACTIONS(4032),
    [anon_sym_continue] = ACTIONS(4034),
    [anon_sym_goto] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(3996),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4038),
    [sym_false] = ACTIONS(4038),
    [sym_null] = ACTIONS(4038),
    [sym_identifier] = ACTIONS(7778),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7780),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(4038),
  },
  [3613] = {
    [sym_catch_clause] = STATE(3726),
    [aux_sym_try_statement_repeat1] = STATE(3726),
    [sym_comment] = ACTIONS(91),
    [anon_sym_catch] = ACTIONS(6791),
  },
  [3614] = {
    [sym_compound_statement] = STATE(3727),
    [sym_labeled_statement] = STATE(3727),
    [sym_expression_statement] = STATE(3727),
    [sym_if_statement] = STATE(3727),
    [sym_switch_statement] = STATE(3727),
    [sym_case_statement] = STATE(3727),
    [sym_while_statement] = STATE(3727),
    [sym_do_statement] = STATE(3727),
    [sym_for_statement] = STATE(3727),
    [sym_return_statement] = STATE(3727),
    [sym_break_statement] = STATE(3727),
    [sym_continue_statement] = STATE(3727),
    [sym_goto_statement] = STATE(3727),
    [sym__expression] = STATE(1908),
    [sym_comma_expression] = STATE(1909),
    [sym_conditional_expression] = STATE(1908),
    [sym_assignment_expression] = STATE(1908),
    [sym_pointer_expression] = STATE(1908),
    [sym_logical_expression] = STATE(1908),
    [sym_bitwise_expression] = STATE(1908),
    [sym_equality_expression] = STATE(1908),
    [sym_relational_expression] = STATE(1908),
    [sym_shift_expression] = STATE(1908),
    [sym_math_expression] = STATE(1908),
    [sym_cast_expression] = STATE(1908),
    [sym_sizeof_expression] = STATE(1908),
    [sym_subscript_expression] = STATE(1908),
    [sym_call_expression] = STATE(1908),
    [sym_field_expression] = STATE(1908),
    [sym_compound_literal_expression] = STATE(1908),
    [sym_parenthesized_expression] = STATE(1908),
    [sym_char_literal] = STATE(1908),
    [sym_concatenated_string] = STATE(1908),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1908),
    [sym_for_range_loop] = STATE(3727),
    [sym_try_statement] = STATE(3727),
    [sym_new_expression] = STATE(1908),
    [sym_delete_expression] = STATE(1908),
    [sym_lambda_expression] = STATE(1908),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3996),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(4016),
    [anon_sym_switch] = ACTIONS(4018),
    [anon_sym_case] = ACTIONS(4020),
    [anon_sym_default] = ACTIONS(4022),
    [anon_sym_while] = ACTIONS(4024),
    [anon_sym_do] = ACTIONS(4026),
    [anon_sym_for] = ACTIONS(4028),
    [anon_sym_return] = ACTIONS(4030),
    [anon_sym_break] = ACTIONS(4032),
    [anon_sym_continue] = ACTIONS(4034),
    [anon_sym_goto] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(3996),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4038),
    [sym_false] = ACTIONS(4038),
    [sym_null] = ACTIONS(4038),
    [sym_identifier] = ACTIONS(6773),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(4042),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(4038),
  },
  [3615] = {
    [sym_raw_string_literal] = ACTIONS(7063),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7065),
    [sym_preproc_directive] = ACTIONS(7065),
    [anon_sym_SEMI] = ACTIONS(7063),
    [anon_sym_typedef] = ACTIONS(7065),
    [anon_sym_extern] = ACTIONS(7065),
    [anon_sym_LBRACE] = ACTIONS(7063),
    [anon_sym_LPAREN2] = ACTIONS(7063),
    [anon_sym_STAR] = ACTIONS(7063),
    [anon_sym_LBRACK] = ACTIONS(7063),
    [anon_sym_static] = ACTIONS(7065),
    [anon_sym_register] = ACTIONS(7065),
    [anon_sym_inline] = ACTIONS(7065),
    [anon_sym_const] = ACTIONS(7065),
    [anon_sym_restrict] = ACTIONS(7065),
    [anon_sym_volatile] = ACTIONS(7065),
    [anon_sym__Atomic] = ACTIONS(7065),
    [anon_sym_mutable] = ACTIONS(7065),
    [anon_sym_explicit] = ACTIONS(7065),
    [anon_sym_constexpr] = ACTIONS(7065),
    [anon_sym_unsigned] = ACTIONS(7065),
    [anon_sym_long] = ACTIONS(7065),
    [anon_sym_short] = ACTIONS(7065),
    [sym_primitive_type] = ACTIONS(7065),
    [anon_sym_enum] = ACTIONS(7065),
    [anon_sym_struct] = ACTIONS(7065),
    [anon_sym_union] = ACTIONS(7065),
    [anon_sym_if] = ACTIONS(7065),
    [anon_sym_else] = ACTIONS(8223),
    [anon_sym_switch] = ACTIONS(7065),
    [anon_sym_case] = ACTIONS(7065),
    [anon_sym_default] = ACTIONS(7065),
    [anon_sym_while] = ACTIONS(7065),
    [anon_sym_do] = ACTIONS(7065),
    [anon_sym_for] = ACTIONS(7065),
    [anon_sym_return] = ACTIONS(7065),
    [anon_sym_break] = ACTIONS(7065),
    [anon_sym_continue] = ACTIONS(7065),
    [anon_sym_goto] = ACTIONS(7065),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_BANG] = ACTIONS(7063),
    [anon_sym_TILDE] = ACTIONS(7063),
    [anon_sym_PLUS] = ACTIONS(7065),
    [anon_sym_DASH] = ACTIONS(7065),
    [anon_sym_DASH_DASH] = ACTIONS(7063),
    [anon_sym_PLUS_PLUS] = ACTIONS(7063),
    [anon_sym_sizeof] = ACTIONS(7065),
    [sym_number_literal] = ACTIONS(7063),
    [anon_sym_SQUOTE] = ACTIONS(7063),
    [anon_sym_DQUOTE] = ACTIONS(7063),
    [sym_true] = ACTIONS(7065),
    [sym_false] = ACTIONS(7065),
    [sym_null] = ACTIONS(7065),
    [sym_identifier] = ACTIONS(7065),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7065),
    [sym_auto] = ACTIONS(7065),
    [anon_sym_typename] = ACTIONS(7065),
    [anon_sym_delete] = ACTIONS(7065),
    [anon_sym_try] = ACTIONS(7065),
    [anon_sym_new] = ACTIONS(7065),
    [anon_sym_COLON_COLON] = ACTIONS(7063),
    [sym_nullptr] = ACTIONS(7065),
  },
  [3616] = {
    [sym_raw_string_literal] = ACTIONS(2475),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2477),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2477),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2477),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2477),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2477),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2477),
    [sym_preproc_directive] = ACTIONS(2477),
    [anon_sym_SEMI] = ACTIONS(2475),
    [anon_sym_typedef] = ACTIONS(2477),
    [anon_sym_extern] = ACTIONS(2477),
    [anon_sym_LBRACE] = ACTIONS(2475),
    [anon_sym_LPAREN2] = ACTIONS(2475),
    [anon_sym_STAR] = ACTIONS(2475),
    [anon_sym_LBRACK] = ACTIONS(2475),
    [anon_sym_static] = ACTIONS(2477),
    [anon_sym_register] = ACTIONS(2477),
    [anon_sym_inline] = ACTIONS(2477),
    [anon_sym_const] = ACTIONS(2477),
    [anon_sym_restrict] = ACTIONS(2477),
    [anon_sym_volatile] = ACTIONS(2477),
    [anon_sym__Atomic] = ACTIONS(2477),
    [anon_sym_mutable] = ACTIONS(2477),
    [anon_sym_explicit] = ACTIONS(2477),
    [anon_sym_constexpr] = ACTIONS(2477),
    [anon_sym_unsigned] = ACTIONS(2477),
    [anon_sym_long] = ACTIONS(2477),
    [anon_sym_short] = ACTIONS(2477),
    [sym_primitive_type] = ACTIONS(2477),
    [anon_sym_enum] = ACTIONS(2477),
    [anon_sym_struct] = ACTIONS(2477),
    [anon_sym_union] = ACTIONS(2477),
    [anon_sym_if] = ACTIONS(2477),
    [anon_sym_else] = ACTIONS(2477),
    [anon_sym_switch] = ACTIONS(2477),
    [anon_sym_case] = ACTIONS(2477),
    [anon_sym_default] = ACTIONS(2477),
    [anon_sym_while] = ACTIONS(2477),
    [anon_sym_do] = ACTIONS(2477),
    [anon_sym_for] = ACTIONS(2477),
    [anon_sym_return] = ACTIONS(2477),
    [anon_sym_break] = ACTIONS(2477),
    [anon_sym_continue] = ACTIONS(2477),
    [anon_sym_goto] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2475),
    [anon_sym_BANG] = ACTIONS(2475),
    [anon_sym_TILDE] = ACTIONS(2475),
    [anon_sym_PLUS] = ACTIONS(2477),
    [anon_sym_DASH] = ACTIONS(2477),
    [anon_sym_DASH_DASH] = ACTIONS(2475),
    [anon_sym_PLUS_PLUS] = ACTIONS(2475),
    [anon_sym_sizeof] = ACTIONS(2477),
    [sym_number_literal] = ACTIONS(2475),
    [anon_sym_SQUOTE] = ACTIONS(2475),
    [anon_sym_DQUOTE] = ACTIONS(2475),
    [sym_true] = ACTIONS(2477),
    [sym_false] = ACTIONS(2477),
    [sym_null] = ACTIONS(2477),
    [sym_identifier] = ACTIONS(2477),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(2477),
    [sym_auto] = ACTIONS(2477),
    [anon_sym_typename] = ACTIONS(2477),
    [anon_sym_delete] = ACTIONS(2477),
    [anon_sym_try] = ACTIONS(2477),
    [anon_sym_new] = ACTIONS(2477),
    [anon_sym_COLON_COLON] = ACTIONS(2475),
    [sym_nullptr] = ACTIONS(2477),
  },
  [3617] = {
    [sym_raw_string_literal] = ACTIONS(7095),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7097),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7097),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7097),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7097),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7097),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7097),
    [sym_preproc_directive] = ACTIONS(7097),
    [anon_sym_SEMI] = ACTIONS(7095),
    [anon_sym_typedef] = ACTIONS(7097),
    [anon_sym_extern] = ACTIONS(7097),
    [anon_sym_LBRACE] = ACTIONS(7095),
    [anon_sym_LPAREN2] = ACTIONS(7095),
    [anon_sym_STAR] = ACTIONS(7095),
    [anon_sym_LBRACK] = ACTIONS(7095),
    [anon_sym_static] = ACTIONS(7097),
    [anon_sym_register] = ACTIONS(7097),
    [anon_sym_inline] = ACTIONS(7097),
    [anon_sym_const] = ACTIONS(7097),
    [anon_sym_restrict] = ACTIONS(7097),
    [anon_sym_volatile] = ACTIONS(7097),
    [anon_sym__Atomic] = ACTIONS(7097),
    [anon_sym_mutable] = ACTIONS(7097),
    [anon_sym_explicit] = ACTIONS(7097),
    [anon_sym_constexpr] = ACTIONS(7097),
    [anon_sym_unsigned] = ACTIONS(7097),
    [anon_sym_long] = ACTIONS(7097),
    [anon_sym_short] = ACTIONS(7097),
    [sym_primitive_type] = ACTIONS(7097),
    [anon_sym_enum] = ACTIONS(7097),
    [anon_sym_struct] = ACTIONS(7097),
    [anon_sym_union] = ACTIONS(7097),
    [anon_sym_if] = ACTIONS(7097),
    [anon_sym_else] = ACTIONS(7097),
    [anon_sym_switch] = ACTIONS(7097),
    [anon_sym_case] = ACTIONS(7097),
    [anon_sym_default] = ACTIONS(7097),
    [anon_sym_while] = ACTIONS(7097),
    [anon_sym_do] = ACTIONS(7097),
    [anon_sym_for] = ACTIONS(7097),
    [anon_sym_return] = ACTIONS(7097),
    [anon_sym_break] = ACTIONS(7097),
    [anon_sym_continue] = ACTIONS(7097),
    [anon_sym_goto] = ACTIONS(7097),
    [anon_sym_AMP] = ACTIONS(7095),
    [anon_sym_BANG] = ACTIONS(7095),
    [anon_sym_TILDE] = ACTIONS(7095),
    [anon_sym_PLUS] = ACTIONS(7097),
    [anon_sym_DASH] = ACTIONS(7097),
    [anon_sym_DASH_DASH] = ACTIONS(7095),
    [anon_sym_PLUS_PLUS] = ACTIONS(7095),
    [anon_sym_sizeof] = ACTIONS(7097),
    [sym_number_literal] = ACTIONS(7095),
    [anon_sym_SQUOTE] = ACTIONS(7095),
    [anon_sym_DQUOTE] = ACTIONS(7095),
    [sym_true] = ACTIONS(7097),
    [sym_false] = ACTIONS(7097),
    [sym_null] = ACTIONS(7097),
    [sym_identifier] = ACTIONS(7097),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7097),
    [sym_auto] = ACTIONS(7097),
    [anon_sym_typename] = ACTIONS(7097),
    [anon_sym_delete] = ACTIONS(7097),
    [anon_sym_try] = ACTIONS(7097),
    [anon_sym_new] = ACTIONS(7097),
    [anon_sym_COLON_COLON] = ACTIONS(7095),
    [sym_nullptr] = ACTIONS(7097),
  },
  [3618] = {
    [sym_compound_statement] = STATE(3729),
    [sym_labeled_statement] = STATE(3729),
    [sym_expression_statement] = STATE(3729),
    [sym_if_statement] = STATE(3729),
    [sym_switch_statement] = STATE(3729),
    [sym_case_statement] = STATE(3729),
    [sym_while_statement] = STATE(3729),
    [sym_do_statement] = STATE(3729),
    [sym_for_statement] = STATE(3729),
    [sym_return_statement] = STATE(3729),
    [sym_break_statement] = STATE(3729),
    [sym_continue_statement] = STATE(3729),
    [sym_goto_statement] = STATE(3729),
    [sym__expression] = STATE(1908),
    [sym_comma_expression] = STATE(1909),
    [sym_conditional_expression] = STATE(1908),
    [sym_assignment_expression] = STATE(1908),
    [sym_pointer_expression] = STATE(1908),
    [sym_logical_expression] = STATE(1908),
    [sym_bitwise_expression] = STATE(1908),
    [sym_equality_expression] = STATE(1908),
    [sym_relational_expression] = STATE(1908),
    [sym_shift_expression] = STATE(1908),
    [sym_math_expression] = STATE(1908),
    [sym_cast_expression] = STATE(1908),
    [sym_sizeof_expression] = STATE(1908),
    [sym_subscript_expression] = STATE(1908),
    [sym_call_expression] = STATE(1908),
    [sym_field_expression] = STATE(1908),
    [sym_compound_literal_expression] = STATE(1908),
    [sym_parenthesized_expression] = STATE(1908),
    [sym_char_literal] = STATE(1908),
    [sym_concatenated_string] = STATE(1908),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1908),
    [sym_for_range_loop] = STATE(3729),
    [sym_try_statement] = STATE(3729),
    [sym_new_expression] = STATE(1908),
    [sym_delete_expression] = STATE(1908),
    [sym_lambda_expression] = STATE(1908),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3996),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(4016),
    [anon_sym_switch] = ACTIONS(4018),
    [anon_sym_case] = ACTIONS(4020),
    [anon_sym_default] = ACTIONS(4022),
    [anon_sym_while] = ACTIONS(4024),
    [anon_sym_do] = ACTIONS(4026),
    [anon_sym_for] = ACTIONS(4028),
    [anon_sym_return] = ACTIONS(4030),
    [anon_sym_break] = ACTIONS(4032),
    [anon_sym_continue] = ACTIONS(4034),
    [anon_sym_goto] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(3996),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4038),
    [sym_false] = ACTIONS(4038),
    [sym_null] = ACTIONS(4038),
    [sym_identifier] = ACTIONS(6773),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(4042),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(4038),
  },
  [3619] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8225),
    [sym_comment] = ACTIONS(91),
  },
  [3620] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3731),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8225),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3621] = {
    [sym__expression] = STATE(3732),
    [sym_conditional_expression] = STATE(3732),
    [sym_assignment_expression] = STATE(3732),
    [sym_pointer_expression] = STATE(3732),
    [sym_logical_expression] = STATE(3732),
    [sym_bitwise_expression] = STATE(3732),
    [sym_equality_expression] = STATE(3732),
    [sym_relational_expression] = STATE(3732),
    [sym_shift_expression] = STATE(3732),
    [sym_math_expression] = STATE(3732),
    [sym_cast_expression] = STATE(3732),
    [sym_sizeof_expression] = STATE(3732),
    [sym_subscript_expression] = STATE(3732),
    [sym_call_expression] = STATE(3732),
    [sym_field_expression] = STATE(3732),
    [sym_compound_literal_expression] = STATE(3732),
    [sym_parenthesized_expression] = STATE(3732),
    [sym_char_literal] = STATE(3732),
    [sym_concatenated_string] = STATE(3732),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3732),
    [sym_new_expression] = STATE(3732),
    [sym_delete_expression] = STATE(3732),
    [sym_lambda_expression] = STATE(3732),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8227),
    [anon_sym_RPAREN] = ACTIONS(8225),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(8227),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8229),
    [sym_false] = ACTIONS(8229),
    [sym_null] = ACTIONS(8229),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(8229),
  },
  [3622] = {
    [sym_compound_statement] = STATE(3733),
    [sym_labeled_statement] = STATE(3733),
    [sym_expression_statement] = STATE(3733),
    [sym_if_statement] = STATE(3733),
    [sym_switch_statement] = STATE(3733),
    [sym_case_statement] = STATE(3733),
    [sym_while_statement] = STATE(3733),
    [sym_do_statement] = STATE(3733),
    [sym_for_statement] = STATE(3733),
    [sym_return_statement] = STATE(3733),
    [sym_break_statement] = STATE(3733),
    [sym_continue_statement] = STATE(3733),
    [sym_goto_statement] = STATE(3733),
    [sym__expression] = STATE(1908),
    [sym_comma_expression] = STATE(1909),
    [sym_conditional_expression] = STATE(1908),
    [sym_assignment_expression] = STATE(1908),
    [sym_pointer_expression] = STATE(1908),
    [sym_logical_expression] = STATE(1908),
    [sym_bitwise_expression] = STATE(1908),
    [sym_equality_expression] = STATE(1908),
    [sym_relational_expression] = STATE(1908),
    [sym_shift_expression] = STATE(1908),
    [sym_math_expression] = STATE(1908),
    [sym_cast_expression] = STATE(1908),
    [sym_sizeof_expression] = STATE(1908),
    [sym_subscript_expression] = STATE(1908),
    [sym_call_expression] = STATE(1908),
    [sym_field_expression] = STATE(1908),
    [sym_compound_literal_expression] = STATE(1908),
    [sym_parenthesized_expression] = STATE(1908),
    [sym_char_literal] = STATE(1908),
    [sym_concatenated_string] = STATE(1908),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1908),
    [sym_for_range_loop] = STATE(3733),
    [sym_try_statement] = STATE(3733),
    [sym_new_expression] = STATE(1908),
    [sym_delete_expression] = STATE(1908),
    [sym_lambda_expression] = STATE(1908),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3996),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(4016),
    [anon_sym_switch] = ACTIONS(4018),
    [anon_sym_case] = ACTIONS(4020),
    [anon_sym_default] = ACTIONS(4022),
    [anon_sym_while] = ACTIONS(4024),
    [anon_sym_do] = ACTIONS(4026),
    [anon_sym_for] = ACTIONS(4028),
    [anon_sym_return] = ACTIONS(4030),
    [anon_sym_break] = ACTIONS(4032),
    [anon_sym_continue] = ACTIONS(4034),
    [anon_sym_goto] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(3996),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4038),
    [sym_false] = ACTIONS(4038),
    [sym_null] = ACTIONS(4038),
    [sym_identifier] = ACTIONS(6773),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(4042),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(4038),
  },
  [3623] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(8231),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3624] = {
    [sym__expression] = STATE(3735),
    [sym_conditional_expression] = STATE(3735),
    [sym_assignment_expression] = STATE(3735),
    [sym_pointer_expression] = STATE(3735),
    [sym_logical_expression] = STATE(3735),
    [sym_bitwise_expression] = STATE(3735),
    [sym_equality_expression] = STATE(3735),
    [sym_relational_expression] = STATE(3735),
    [sym_shift_expression] = STATE(3735),
    [sym_math_expression] = STATE(3735),
    [sym_cast_expression] = STATE(3735),
    [sym_sizeof_expression] = STATE(3735),
    [sym_subscript_expression] = STATE(3735),
    [sym_call_expression] = STATE(3735),
    [sym_field_expression] = STATE(3735),
    [sym_compound_literal_expression] = STATE(3735),
    [sym_parenthesized_expression] = STATE(3735),
    [sym_char_literal] = STATE(3735),
    [sym_concatenated_string] = STATE(3735),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3735),
    [sym_new_expression] = STATE(3735),
    [sym_delete_expression] = STATE(3735),
    [sym_lambda_expression] = STATE(3735),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8233),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(8233),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8235),
    [sym_false] = ACTIONS(8235),
    [sym_null] = ACTIONS(8235),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(8235),
  },
  [3625] = {
    [sym_declaration] = STATE(3035),
    [sym_type_definition] = STATE(3035),
    [sym__declaration_specifiers] = STATE(2600),
    [sym_compound_statement] = STATE(3035),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_labeled_statement] = STATE(3035),
    [sym_expression_statement] = STATE(3035),
    [sym_if_statement] = STATE(3035),
    [sym_switch_statement] = STATE(3035),
    [sym_case_statement] = STATE(3035),
    [sym_while_statement] = STATE(3035),
    [sym_do_statement] = STATE(3035),
    [sym_for_statement] = STATE(3035),
    [sym_return_statement] = STATE(3035),
    [sym_break_statement] = STATE(3035),
    [sym_continue_statement] = STATE(3035),
    [sym_goto_statement] = STATE(3035),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(3035),
    [sym_try_statement] = STATE(3035),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_typedef] = ACTIONS(2216),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(7431),
    [anon_sym_switch] = ACTIONS(7433),
    [anon_sym_case] = ACTIONS(7435),
    [anon_sym_default] = ACTIONS(7437),
    [anon_sym_while] = ACTIONS(7439),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(7441),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(8050),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7445),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(1202),
    [sym_nullptr] = ACTIONS(2242),
  },
  [3626] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(1362),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_extern] = ACTIONS(468),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(465),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_register] = ACTIONS(468),
    [anon_sym_inline] = ACTIONS(468),
    [anon_sym_const] = ACTIONS(468),
    [anon_sym_restrict] = ACTIONS(468),
    [anon_sym_volatile] = ACTIONS(468),
    [anon_sym__Atomic] = ACTIONS(468),
    [anon_sym_mutable] = ACTIONS(468),
    [anon_sym_explicit] = ACTIONS(468),
    [anon_sym_constexpr] = ACTIONS(468),
    [anon_sym_COLON] = ACTIONS(7821),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(474),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_TILDE] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_identifier] = ACTIONS(468),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(2855),
    [sym_operator_name] = ACTIONS(481),
  },
  [3627] = {
    [sym__expression] = STATE(3737),
    [sym_conditional_expression] = STATE(3737),
    [sym_assignment_expression] = STATE(3737),
    [sym_pointer_expression] = STATE(3737),
    [sym_logical_expression] = STATE(3737),
    [sym_bitwise_expression] = STATE(3737),
    [sym_equality_expression] = STATE(3737),
    [sym_relational_expression] = STATE(3737),
    [sym_shift_expression] = STATE(3737),
    [sym_math_expression] = STATE(3737),
    [sym_cast_expression] = STATE(3737),
    [sym_sizeof_expression] = STATE(3737),
    [sym_subscript_expression] = STATE(3737),
    [sym_call_expression] = STATE(3737),
    [sym_field_expression] = STATE(3737),
    [sym_compound_literal_expression] = STATE(3737),
    [sym_parenthesized_expression] = STATE(3737),
    [sym_char_literal] = STATE(3737),
    [sym_concatenated_string] = STATE(3737),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3737),
    [sym_new_expression] = STATE(3737),
    [sym_delete_expression] = STATE(3737),
    [sym_lambda_expression] = STATE(3737),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8237),
    [anon_sym_SEMI] = ACTIONS(8239),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(8237),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8241),
    [sym_false] = ACTIONS(8241),
    [sym_null] = ACTIONS(8241),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(8241),
  },
  [3628] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(8243),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3629] = {
    [anon_sym_COLON] = ACTIONS(8245),
    [sym_comment] = ACTIONS(91),
  },
  [3630] = {
    [sym_catch_clause] = STATE(3740),
    [aux_sym_try_statement_repeat1] = STATE(3740),
    [sym_raw_string_literal] = ACTIONS(3346),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3348),
    [sym_preproc_directive] = ACTIONS(3348),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym_typedef] = ACTIONS(3348),
    [anon_sym_extern] = ACTIONS(3348),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(3346),
    [anon_sym_static] = ACTIONS(3348),
    [anon_sym_register] = ACTIONS(3348),
    [anon_sym_inline] = ACTIONS(3348),
    [anon_sym_const] = ACTIONS(3348),
    [anon_sym_restrict] = ACTIONS(3348),
    [anon_sym_volatile] = ACTIONS(3348),
    [anon_sym__Atomic] = ACTIONS(3348),
    [anon_sym_mutable] = ACTIONS(3348),
    [anon_sym_explicit] = ACTIONS(3348),
    [anon_sym_constexpr] = ACTIONS(3348),
    [anon_sym_unsigned] = ACTIONS(3348),
    [anon_sym_long] = ACTIONS(3348),
    [anon_sym_short] = ACTIONS(3348),
    [sym_primitive_type] = ACTIONS(3348),
    [anon_sym_enum] = ACTIONS(3348),
    [anon_sym_struct] = ACTIONS(3348),
    [anon_sym_union] = ACTIONS(3348),
    [anon_sym_if] = ACTIONS(3348),
    [anon_sym_else] = ACTIONS(3348),
    [anon_sym_switch] = ACTIONS(3348),
    [anon_sym_case] = ACTIONS(3348),
    [anon_sym_default] = ACTIONS(3348),
    [anon_sym_while] = ACTIONS(3348),
    [anon_sym_do] = ACTIONS(3348),
    [anon_sym_for] = ACTIONS(3348),
    [anon_sym_return] = ACTIONS(3348),
    [anon_sym_break] = ACTIONS(3348),
    [anon_sym_continue] = ACTIONS(3348),
    [anon_sym_goto] = ACTIONS(3348),
    [anon_sym_AMP] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_PLUS] = ACTIONS(3348),
    [anon_sym_DASH] = ACTIONS(3348),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_sizeof] = ACTIONS(3348),
    [sym_number_literal] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [sym_true] = ACTIONS(3348),
    [sym_false] = ACTIONS(3348),
    [sym_null] = ACTIONS(3348),
    [sym_identifier] = ACTIONS(3348),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3348),
    [sym_auto] = ACTIONS(3348),
    [anon_sym_typename] = ACTIONS(3348),
    [anon_sym_delete] = ACTIONS(3348),
    [anon_sym_try] = ACTIONS(3348),
    [anon_sym_catch] = ACTIONS(6890),
    [anon_sym_new] = ACTIONS(3348),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [sym_nullptr] = ACTIONS(3348),
  },
  [3631] = {
    [sym_raw_string_literal] = ACTIONS(7561),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7563),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7563),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7563),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7563),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7563),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7563),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7563),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7563),
    [sym_preproc_directive] = ACTIONS(7563),
    [anon_sym_SEMI] = ACTIONS(7561),
    [anon_sym_typedef] = ACTIONS(7563),
    [anon_sym_extern] = ACTIONS(7563),
    [anon_sym_LBRACE] = ACTIONS(7561),
    [anon_sym_LPAREN2] = ACTIONS(7561),
    [anon_sym_STAR] = ACTIONS(7561),
    [anon_sym_LBRACK] = ACTIONS(7561),
    [anon_sym_static] = ACTIONS(7563),
    [anon_sym_register] = ACTIONS(7563),
    [anon_sym_inline] = ACTIONS(7563),
    [anon_sym_const] = ACTIONS(7563),
    [anon_sym_restrict] = ACTIONS(7563),
    [anon_sym_volatile] = ACTIONS(7563),
    [anon_sym__Atomic] = ACTIONS(7563),
    [anon_sym_mutable] = ACTIONS(7563),
    [anon_sym_explicit] = ACTIONS(7563),
    [anon_sym_constexpr] = ACTIONS(7563),
    [anon_sym_unsigned] = ACTIONS(7563),
    [anon_sym_long] = ACTIONS(7563),
    [anon_sym_short] = ACTIONS(7563),
    [sym_primitive_type] = ACTIONS(7563),
    [anon_sym_enum] = ACTIONS(7563),
    [anon_sym_struct] = ACTIONS(7563),
    [anon_sym_union] = ACTIONS(7563),
    [anon_sym_if] = ACTIONS(7563),
    [anon_sym_else] = ACTIONS(7563),
    [anon_sym_switch] = ACTIONS(7563),
    [anon_sym_case] = ACTIONS(7563),
    [anon_sym_default] = ACTIONS(7563),
    [anon_sym_while] = ACTIONS(7563),
    [anon_sym_do] = ACTIONS(7563),
    [anon_sym_for] = ACTIONS(7563),
    [anon_sym_return] = ACTIONS(7563),
    [anon_sym_break] = ACTIONS(7563),
    [anon_sym_continue] = ACTIONS(7563),
    [anon_sym_goto] = ACTIONS(7563),
    [anon_sym_AMP] = ACTIONS(7561),
    [anon_sym_BANG] = ACTIONS(7561),
    [anon_sym_TILDE] = ACTIONS(7561),
    [anon_sym_PLUS] = ACTIONS(7563),
    [anon_sym_DASH] = ACTIONS(7563),
    [anon_sym_DASH_DASH] = ACTIONS(7561),
    [anon_sym_PLUS_PLUS] = ACTIONS(7561),
    [anon_sym_sizeof] = ACTIONS(7563),
    [sym_number_literal] = ACTIONS(7561),
    [anon_sym_SQUOTE] = ACTIONS(7561),
    [anon_sym_DQUOTE] = ACTIONS(7561),
    [sym_true] = ACTIONS(7563),
    [sym_false] = ACTIONS(7563),
    [sym_null] = ACTIONS(7563),
    [sym_identifier] = ACTIONS(7563),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7563),
    [sym_auto] = ACTIONS(7563),
    [anon_sym_typename] = ACTIONS(7563),
    [anon_sym_delete] = ACTIONS(7563),
    [anon_sym_try] = ACTIONS(7563),
    [anon_sym_new] = ACTIONS(7563),
    [anon_sym_COLON_COLON] = ACTIONS(7561),
    [sym_nullptr] = ACTIONS(7563),
  },
  [3632] = {
    [sym_compound_statement] = STATE(3741),
    [sym_labeled_statement] = STATE(3741),
    [sym_expression_statement] = STATE(3741),
    [sym_if_statement] = STATE(3741),
    [sym_switch_statement] = STATE(3741),
    [sym_case_statement] = STATE(3741),
    [sym_while_statement] = STATE(3741),
    [sym_do_statement] = STATE(3741),
    [sym_for_statement] = STATE(3741),
    [sym_return_statement] = STATE(3741),
    [sym_break_statement] = STATE(3741),
    [sym_continue_statement] = STATE(3741),
    [sym_goto_statement] = STATE(3741),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(3741),
    [sym_try_statement] = STATE(3741),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(2220),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(5705),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2242),
  },
  [3633] = {
    [sym_raw_string_literal] = ACTIONS(7589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7591),
    [sym_preproc_directive] = ACTIONS(7591),
    [anon_sym_SEMI] = ACTIONS(7589),
    [anon_sym_typedef] = ACTIONS(7591),
    [anon_sym_extern] = ACTIONS(7591),
    [anon_sym_LBRACE] = ACTIONS(7589),
    [anon_sym_LPAREN2] = ACTIONS(7589),
    [anon_sym_STAR] = ACTIONS(7589),
    [anon_sym_LBRACK] = ACTIONS(7589),
    [anon_sym_static] = ACTIONS(7591),
    [anon_sym_register] = ACTIONS(7591),
    [anon_sym_inline] = ACTIONS(7591),
    [anon_sym_const] = ACTIONS(7591),
    [anon_sym_restrict] = ACTIONS(7591),
    [anon_sym_volatile] = ACTIONS(7591),
    [anon_sym__Atomic] = ACTIONS(7591),
    [anon_sym_mutable] = ACTIONS(7591),
    [anon_sym_explicit] = ACTIONS(7591),
    [anon_sym_constexpr] = ACTIONS(7591),
    [anon_sym_unsigned] = ACTIONS(7591),
    [anon_sym_long] = ACTIONS(7591),
    [anon_sym_short] = ACTIONS(7591),
    [sym_primitive_type] = ACTIONS(7591),
    [anon_sym_enum] = ACTIONS(7591),
    [anon_sym_struct] = ACTIONS(7591),
    [anon_sym_union] = ACTIONS(7591),
    [anon_sym_if] = ACTIONS(7591),
    [anon_sym_else] = ACTIONS(7591),
    [anon_sym_switch] = ACTIONS(7591),
    [anon_sym_case] = ACTIONS(7591),
    [anon_sym_default] = ACTIONS(7591),
    [anon_sym_while] = ACTIONS(7591),
    [anon_sym_do] = ACTIONS(7591),
    [anon_sym_for] = ACTIONS(7591),
    [anon_sym_return] = ACTIONS(7591),
    [anon_sym_break] = ACTIONS(7591),
    [anon_sym_continue] = ACTIONS(7591),
    [anon_sym_goto] = ACTIONS(7591),
    [anon_sym_AMP] = ACTIONS(7589),
    [anon_sym_BANG] = ACTIONS(7589),
    [anon_sym_TILDE] = ACTIONS(7589),
    [anon_sym_PLUS] = ACTIONS(7591),
    [anon_sym_DASH] = ACTIONS(7591),
    [anon_sym_DASH_DASH] = ACTIONS(7589),
    [anon_sym_PLUS_PLUS] = ACTIONS(7589),
    [anon_sym_sizeof] = ACTIONS(7591),
    [sym_number_literal] = ACTIONS(7589),
    [anon_sym_SQUOTE] = ACTIONS(7589),
    [anon_sym_DQUOTE] = ACTIONS(7589),
    [sym_true] = ACTIONS(7591),
    [sym_false] = ACTIONS(7591),
    [sym_null] = ACTIONS(7591),
    [sym_identifier] = ACTIONS(7591),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7591),
    [sym_auto] = ACTIONS(7591),
    [anon_sym_typename] = ACTIONS(7591),
    [anon_sym_delete] = ACTIONS(7591),
    [anon_sym_try] = ACTIONS(7591),
    [anon_sym_new] = ACTIONS(7591),
    [anon_sym_COLON_COLON] = ACTIONS(7589),
    [sym_nullptr] = ACTIONS(7591),
  },
  [3634] = {
    [sym_compound_statement] = STATE(3742),
    [sym_labeled_statement] = STATE(3742),
    [sym_expression_statement] = STATE(3742),
    [sym_if_statement] = STATE(3742),
    [sym_switch_statement] = STATE(3742),
    [sym_case_statement] = STATE(3742),
    [sym_while_statement] = STATE(3742),
    [sym_do_statement] = STATE(3742),
    [sym_for_statement] = STATE(3742),
    [sym_return_statement] = STATE(3742),
    [sym_break_statement] = STATE(3742),
    [sym_continue_statement] = STATE(3742),
    [sym_goto_statement] = STATE(3742),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(3742),
    [sym_try_statement] = STATE(3742),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(2220),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(5705),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2242),
  },
  [3635] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8247),
    [sym_comment] = ACTIONS(91),
  },
  [3636] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3744),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8247),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3637] = {
    [sym_raw_string_literal] = ACTIONS(7598),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7600),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7600),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7600),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7600),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7600),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7600),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7600),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7600),
    [sym_preproc_directive] = ACTIONS(7600),
    [anon_sym_SEMI] = ACTIONS(7598),
    [anon_sym_typedef] = ACTIONS(7600),
    [anon_sym_extern] = ACTIONS(7600),
    [anon_sym_LBRACE] = ACTIONS(7598),
    [anon_sym_LPAREN2] = ACTIONS(7598),
    [anon_sym_STAR] = ACTIONS(7598),
    [anon_sym_LBRACK] = ACTIONS(7598),
    [anon_sym_static] = ACTIONS(7600),
    [anon_sym_register] = ACTIONS(7600),
    [anon_sym_inline] = ACTIONS(7600),
    [anon_sym_const] = ACTIONS(7600),
    [anon_sym_restrict] = ACTIONS(7600),
    [anon_sym_volatile] = ACTIONS(7600),
    [anon_sym__Atomic] = ACTIONS(7600),
    [anon_sym_mutable] = ACTIONS(7600),
    [anon_sym_explicit] = ACTIONS(7600),
    [anon_sym_constexpr] = ACTIONS(7600),
    [anon_sym_unsigned] = ACTIONS(7600),
    [anon_sym_long] = ACTIONS(7600),
    [anon_sym_short] = ACTIONS(7600),
    [sym_primitive_type] = ACTIONS(7600),
    [anon_sym_enum] = ACTIONS(7600),
    [anon_sym_struct] = ACTIONS(7600),
    [anon_sym_union] = ACTIONS(7600),
    [anon_sym_if] = ACTIONS(7600),
    [anon_sym_else] = ACTIONS(7600),
    [anon_sym_switch] = ACTIONS(7600),
    [anon_sym_case] = ACTIONS(7600),
    [anon_sym_default] = ACTIONS(7600),
    [anon_sym_while] = ACTIONS(7600),
    [anon_sym_do] = ACTIONS(7600),
    [anon_sym_for] = ACTIONS(7600),
    [anon_sym_return] = ACTIONS(7600),
    [anon_sym_break] = ACTIONS(7600),
    [anon_sym_continue] = ACTIONS(7600),
    [anon_sym_goto] = ACTIONS(7600),
    [anon_sym_AMP] = ACTIONS(7598),
    [anon_sym_BANG] = ACTIONS(7598),
    [anon_sym_TILDE] = ACTIONS(7598),
    [anon_sym_PLUS] = ACTIONS(7600),
    [anon_sym_DASH] = ACTIONS(7600),
    [anon_sym_DASH_DASH] = ACTIONS(7598),
    [anon_sym_PLUS_PLUS] = ACTIONS(7598),
    [anon_sym_sizeof] = ACTIONS(7600),
    [sym_number_literal] = ACTIONS(7598),
    [anon_sym_SQUOTE] = ACTIONS(7598),
    [anon_sym_DQUOTE] = ACTIONS(7598),
    [sym_true] = ACTIONS(7600),
    [sym_false] = ACTIONS(7600),
    [sym_null] = ACTIONS(7600),
    [sym_identifier] = ACTIONS(7600),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7600),
    [sym_auto] = ACTIONS(7600),
    [anon_sym_typename] = ACTIONS(7600),
    [anon_sym_delete] = ACTIONS(7600),
    [anon_sym_try] = ACTIONS(7600),
    [anon_sym_new] = ACTIONS(7600),
    [anon_sym_COLON_COLON] = ACTIONS(7598),
    [sym_nullptr] = ACTIONS(7600),
  },
  [3638] = {
    [sym_raw_string_literal] = ACTIONS(6091),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6093),
    [sym_preproc_directive] = ACTIONS(6093),
    [anon_sym_SEMI] = ACTIONS(6091),
    [anon_sym_typedef] = ACTIONS(6093),
    [anon_sym_extern] = ACTIONS(6093),
    [anon_sym_LBRACE] = ACTIONS(6091),
    [anon_sym_RBRACE] = ACTIONS(6091),
    [anon_sym_LPAREN2] = ACTIONS(6091),
    [anon_sym_STAR] = ACTIONS(6091),
    [anon_sym_LBRACK] = ACTIONS(6091),
    [anon_sym_static] = ACTIONS(6093),
    [anon_sym_register] = ACTIONS(6093),
    [anon_sym_inline] = ACTIONS(6093),
    [anon_sym_const] = ACTIONS(6093),
    [anon_sym_restrict] = ACTIONS(6093),
    [anon_sym_volatile] = ACTIONS(6093),
    [anon_sym__Atomic] = ACTIONS(6093),
    [anon_sym_mutable] = ACTIONS(6093),
    [anon_sym_explicit] = ACTIONS(6093),
    [anon_sym_constexpr] = ACTIONS(6093),
    [anon_sym_unsigned] = ACTIONS(6093),
    [anon_sym_long] = ACTIONS(6093),
    [anon_sym_short] = ACTIONS(6093),
    [sym_primitive_type] = ACTIONS(6093),
    [anon_sym_enum] = ACTIONS(6093),
    [anon_sym_struct] = ACTIONS(6093),
    [anon_sym_union] = ACTIONS(6093),
    [anon_sym_if] = ACTIONS(6093),
    [anon_sym_else] = ACTIONS(8249),
    [anon_sym_switch] = ACTIONS(6093),
    [anon_sym_case] = ACTIONS(6093),
    [anon_sym_default] = ACTIONS(6093),
    [anon_sym_while] = ACTIONS(6093),
    [anon_sym_do] = ACTIONS(6093),
    [anon_sym_for] = ACTIONS(6093),
    [anon_sym_return] = ACTIONS(6093),
    [anon_sym_break] = ACTIONS(6093),
    [anon_sym_continue] = ACTIONS(6093),
    [anon_sym_goto] = ACTIONS(6093),
    [anon_sym_AMP] = ACTIONS(6091),
    [anon_sym_BANG] = ACTIONS(6091),
    [anon_sym_TILDE] = ACTIONS(6091),
    [anon_sym_PLUS] = ACTIONS(6093),
    [anon_sym_DASH] = ACTIONS(6093),
    [anon_sym_DASH_DASH] = ACTIONS(6091),
    [anon_sym_PLUS_PLUS] = ACTIONS(6091),
    [anon_sym_sizeof] = ACTIONS(6093),
    [sym_number_literal] = ACTIONS(6091),
    [anon_sym_SQUOTE] = ACTIONS(6091),
    [anon_sym_DQUOTE] = ACTIONS(6091),
    [sym_true] = ACTIONS(6093),
    [sym_false] = ACTIONS(6093),
    [sym_null] = ACTIONS(6093),
    [sym_identifier] = ACTIONS(6093),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6093),
    [sym_auto] = ACTIONS(6093),
    [anon_sym_typename] = ACTIONS(6093),
    [anon_sym_delete] = ACTIONS(6093),
    [anon_sym_try] = ACTIONS(6093),
    [anon_sym_new] = ACTIONS(6093),
    [anon_sym_COLON_COLON] = ACTIONS(6091),
    [sym_nullptr] = ACTIONS(6093),
  },
  [3639] = {
    [sym_compound_statement] = STATE(3746),
    [sym_labeled_statement] = STATE(3746),
    [sym_expression_statement] = STATE(3746),
    [sym_if_statement] = STATE(3746),
    [sym_switch_statement] = STATE(3746),
    [sym_case_statement] = STATE(3746),
    [sym_while_statement] = STATE(3746),
    [sym_do_statement] = STATE(3746),
    [sym_for_statement] = STATE(3746),
    [sym_return_statement] = STATE(3746),
    [sym_break_statement] = STATE(3746),
    [sym_continue_statement] = STATE(3746),
    [sym_goto_statement] = STATE(3746),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(3746),
    [sym_try_statement] = STATE(3746),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(157),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(5814),
    [anon_sym_switch] = ACTIONS(5816),
    [anon_sym_case] = ACTIONS(5818),
    [anon_sym_default] = ACTIONS(5820),
    [anon_sym_while] = ACTIONS(5822),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(5824),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(5826),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(5828),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(207),
  },
  [3640] = {
    [sym_compound_statement] = STATE(3059),
    [sym_labeled_statement] = STATE(3059),
    [sym_expression_statement] = STATE(3059),
    [sym_if_statement] = STATE(3059),
    [sym_switch_statement] = STATE(3059),
    [sym_case_statement] = STATE(3059),
    [sym_while_statement] = STATE(3059),
    [sym_do_statement] = STATE(3059),
    [sym_for_statement] = STATE(3059),
    [sym_return_statement] = STATE(3059),
    [sym_break_statement] = STATE(3059),
    [sym_continue_statement] = STATE(3059),
    [sym_goto_statement] = STATE(3059),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(3059),
    [sym_try_statement] = STATE(3059),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(157),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(5814),
    [anon_sym_switch] = ACTIONS(5816),
    [anon_sym_case] = ACTIONS(5818),
    [anon_sym_default] = ACTIONS(5820),
    [anon_sym_while] = ACTIONS(5822),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(5824),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(5826),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(5828),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(207),
  },
  [3641] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3748),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8251),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3642] = {
    [sym__expression] = STATE(3749),
    [sym_conditional_expression] = STATE(3749),
    [sym_assignment_expression] = STATE(3749),
    [sym_pointer_expression] = STATE(3749),
    [sym_logical_expression] = STATE(3749),
    [sym_bitwise_expression] = STATE(3749),
    [sym_equality_expression] = STATE(3749),
    [sym_relational_expression] = STATE(3749),
    [sym_shift_expression] = STATE(3749),
    [sym_math_expression] = STATE(3749),
    [sym_cast_expression] = STATE(3749),
    [sym_sizeof_expression] = STATE(3749),
    [sym_subscript_expression] = STATE(3749),
    [sym_call_expression] = STATE(3749),
    [sym_field_expression] = STATE(3749),
    [sym_compound_literal_expression] = STATE(3749),
    [sym_parenthesized_expression] = STATE(3749),
    [sym_char_literal] = STATE(3749),
    [sym_concatenated_string] = STATE(3749),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3749),
    [sym_new_expression] = STATE(3749),
    [sym_delete_expression] = STATE(3749),
    [sym_lambda_expression] = STATE(3749),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8253),
    [anon_sym_RPAREN] = ACTIONS(8251),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(8253),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8255),
    [sym_false] = ACTIONS(8255),
    [sym_null] = ACTIONS(8255),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(8255),
  },
  [3643] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(8257),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3644] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(8259),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3645] = {
    [sym_raw_string_literal] = ACTIONS(8143),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(8145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(8145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(8145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(8145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(8145),
    [sym_preproc_directive] = ACTIONS(8145),
    [anon_sym_SEMI] = ACTIONS(8143),
    [anon_sym_typedef] = ACTIONS(8145),
    [anon_sym_extern] = ACTIONS(8145),
    [anon_sym_LBRACE] = ACTIONS(8143),
    [anon_sym_RBRACE] = ACTIONS(8143),
    [anon_sym_LPAREN2] = ACTIONS(8143),
    [anon_sym_STAR] = ACTIONS(8143),
    [anon_sym_LBRACK] = ACTIONS(8143),
    [anon_sym_static] = ACTIONS(8145),
    [anon_sym_register] = ACTIONS(8145),
    [anon_sym_inline] = ACTIONS(8145),
    [anon_sym_const] = ACTIONS(8145),
    [anon_sym_restrict] = ACTIONS(8145),
    [anon_sym_volatile] = ACTIONS(8145),
    [anon_sym__Atomic] = ACTIONS(8145),
    [anon_sym_mutable] = ACTIONS(8145),
    [anon_sym_explicit] = ACTIONS(8145),
    [anon_sym_constexpr] = ACTIONS(8145),
    [anon_sym_unsigned] = ACTIONS(8145),
    [anon_sym_long] = ACTIONS(8145),
    [anon_sym_short] = ACTIONS(8145),
    [sym_primitive_type] = ACTIONS(8145),
    [anon_sym_enum] = ACTIONS(8145),
    [anon_sym_struct] = ACTIONS(8145),
    [anon_sym_union] = ACTIONS(8145),
    [anon_sym_if] = ACTIONS(8145),
    [anon_sym_else] = ACTIONS(8145),
    [anon_sym_switch] = ACTIONS(8145),
    [anon_sym_case] = ACTIONS(8145),
    [anon_sym_default] = ACTIONS(8145),
    [anon_sym_while] = ACTIONS(8145),
    [anon_sym_do] = ACTIONS(8145),
    [anon_sym_for] = ACTIONS(8145),
    [anon_sym_return] = ACTIONS(8145),
    [anon_sym_break] = ACTIONS(8145),
    [anon_sym_continue] = ACTIONS(8145),
    [anon_sym_goto] = ACTIONS(8145),
    [anon_sym_AMP] = ACTIONS(8143),
    [anon_sym_BANG] = ACTIONS(8143),
    [anon_sym_TILDE] = ACTIONS(8143),
    [anon_sym_PLUS] = ACTIONS(8145),
    [anon_sym_DASH] = ACTIONS(8145),
    [anon_sym_DASH_DASH] = ACTIONS(8143),
    [anon_sym_PLUS_PLUS] = ACTIONS(8143),
    [anon_sym_sizeof] = ACTIONS(8145),
    [sym_number_literal] = ACTIONS(8143),
    [anon_sym_SQUOTE] = ACTIONS(8143),
    [anon_sym_DQUOTE] = ACTIONS(8143),
    [sym_true] = ACTIONS(8145),
    [sym_false] = ACTIONS(8145),
    [sym_null] = ACTIONS(8145),
    [sym_identifier] = ACTIONS(8145),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(8145),
    [sym_auto] = ACTIONS(8145),
    [anon_sym_typename] = ACTIONS(8145),
    [anon_sym_delete] = ACTIONS(8145),
    [anon_sym_try] = ACTIONS(8145),
    [anon_sym_new] = ACTIONS(8145),
    [anon_sym_COLON_COLON] = ACTIONS(8143),
    [sym_nullptr] = ACTIONS(8145),
  },
  [3646] = {
    [sym_compound_statement] = STATE(3752),
    [sym_labeled_statement] = STATE(3752),
    [sym_expression_statement] = STATE(3752),
    [sym_if_statement] = STATE(3752),
    [sym_switch_statement] = STATE(3752),
    [sym_case_statement] = STATE(3752),
    [sym_while_statement] = STATE(3752),
    [sym_do_statement] = STATE(3752),
    [sym_for_statement] = STATE(3752),
    [sym_return_statement] = STATE(3752),
    [sym_break_statement] = STATE(3752),
    [sym_continue_statement] = STATE(3752),
    [sym_goto_statement] = STATE(3752),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(3752),
    [sym_try_statement] = STATE(3752),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(157),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(185),
    [anon_sym_case] = ACTIONS(187),
    [anon_sym_default] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(2262),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(207),
  },
  [3647] = {
    [sym_field_declaration_list] = STATE(1077),
    [sym_virtual_specifier] = STATE(1078),
    [sym_base_class_clause] = STATE(1079),
    [sym_template_argument_list] = STATE(437),
    [anon_sym_COMMA] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_LPAREN2] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_const] = ACTIONS(1059),
    [anon_sym_restrict] = ACTIONS(1057),
    [anon_sym_volatile] = ACTIONS(1057),
    [anon_sym__Atomic] = ACTIONS(1057),
    [anon_sym_mutable] = ACTIONS(1057),
    [anon_sym_explicit] = ACTIONS(1057),
    [anon_sym_constexpr] = ACTIONS(1057),
    [anon_sym_COLON] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_DASH_GT] = ACTIONS(1057),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1057),
    [anon_sym_override] = ACTIONS(1057),
    [sym_noexcept] = ACTIONS(1057),
    [anon_sym_COLON_COLON] = ACTIONS(758),
  },
  [3648] = {
    [sym_field_declaration_list] = STATE(1080),
    [sym_virtual_specifier] = STATE(1082),
    [sym_base_class_clause] = STATE(1081),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1069),
    [anon_sym_const] = ACTIONS(1071),
    [anon_sym_restrict] = ACTIONS(1069),
    [anon_sym_volatile] = ACTIONS(1069),
    [anon_sym__Atomic] = ACTIONS(1069),
    [anon_sym_mutable] = ACTIONS(1069),
    [anon_sym_explicit] = ACTIONS(1069),
    [anon_sym_constexpr] = ACTIONS(1069),
    [anon_sym_COLON] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1069),
    [anon_sym_DASH_GT] = ACTIONS(1069),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1069),
    [anon_sym_override] = ACTIONS(1069),
    [sym_noexcept] = ACTIONS(1069),
    [anon_sym_COLON_COLON] = ACTIONS(772),
  },
  [3649] = {
    [sym_field_declaration_list] = STATE(1080),
    [sym_virtual_specifier] = STATE(1082),
    [sym_base_class_clause] = STATE(1081),
    [sym_template_argument_list] = STATE(362),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1069),
    [anon_sym_const] = ACTIONS(1071),
    [anon_sym_restrict] = ACTIONS(1069),
    [anon_sym_volatile] = ACTIONS(1069),
    [anon_sym__Atomic] = ACTIONS(1069),
    [anon_sym_mutable] = ACTIONS(1069),
    [anon_sym_explicit] = ACTIONS(1069),
    [anon_sym_constexpr] = ACTIONS(1069),
    [anon_sym_COLON] = ACTIONS(1069),
    [anon_sym_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1069),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_DASH_GT] = ACTIONS(1069),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1069),
    [anon_sym_override] = ACTIONS(1069),
    [sym_noexcept] = ACTIONS(1069),
  },
  [3650] = {
    [sym_field_declaration_list] = STATE(1083),
    [sym_virtual_specifier] = STATE(1084),
    [sym_base_class_clause] = STATE(1085),
    [sym_template_argument_list] = STATE(437),
    [anon_sym_COMMA] = ACTIONS(1077),
    [anon_sym_SEMI] = ACTIONS(1077),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_LPAREN2] = ACTIONS(1077),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_LBRACK] = ACTIONS(1077),
    [anon_sym_const] = ACTIONS(1079),
    [anon_sym_restrict] = ACTIONS(1077),
    [anon_sym_volatile] = ACTIONS(1077),
    [anon_sym__Atomic] = ACTIONS(1077),
    [anon_sym_mutable] = ACTIONS(1077),
    [anon_sym_explicit] = ACTIONS(1077),
    [anon_sym_constexpr] = ACTIONS(1077),
    [anon_sym_COLON] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_DASH_GT] = ACTIONS(1077),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1077),
    [anon_sym_override] = ACTIONS(1077),
    [sym_noexcept] = ACTIONS(1077),
    [anon_sym_COLON_COLON] = ACTIONS(758),
  },
  [3651] = {
    [sym_field_declaration_list] = STATE(1086),
    [sym_virtual_specifier] = STATE(1088),
    [sym_base_class_clause] = STATE(1087),
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_LPAREN2] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1081),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_const] = ACTIONS(1083),
    [anon_sym_restrict] = ACTIONS(1081),
    [anon_sym_volatile] = ACTIONS(1081),
    [anon_sym__Atomic] = ACTIONS(1081),
    [anon_sym_mutable] = ACTIONS(1081),
    [anon_sym_explicit] = ACTIONS(1081),
    [anon_sym_constexpr] = ACTIONS(1081),
    [anon_sym_COLON] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(1081),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1081),
    [anon_sym_override] = ACTIONS(1081),
    [sym_noexcept] = ACTIONS(1081),
    [anon_sym_COLON_COLON] = ACTIONS(772),
  },
  [3652] = {
    [sym_field_declaration_list] = STATE(1086),
    [sym_virtual_specifier] = STATE(1088),
    [sym_base_class_clause] = STATE(1087),
    [sym_template_argument_list] = STATE(362),
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_LPAREN2] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1081),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_const] = ACTIONS(1083),
    [anon_sym_restrict] = ACTIONS(1081),
    [anon_sym_volatile] = ACTIONS(1081),
    [anon_sym__Atomic] = ACTIONS(1081),
    [anon_sym_mutable] = ACTIONS(1081),
    [anon_sym_explicit] = ACTIONS(1081),
    [anon_sym_constexpr] = ACTIONS(1081),
    [anon_sym_COLON] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_DASH_GT] = ACTIONS(1081),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1081),
    [anon_sym_override] = ACTIONS(1081),
    [sym_noexcept] = ACTIONS(1081),
  },
  [3653] = {
    [sym_field_declaration_list] = STATE(1093),
    [sym_virtual_specifier] = STATE(1094),
    [sym_base_class_clause] = STATE(1095),
    [sym_template_argument_list] = STATE(437),
    [anon_sym_COMMA] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1438),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_LPAREN2] = ACTIONS(1438),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_LBRACK] = ACTIONS(1438),
    [anon_sym_const] = ACTIONS(1440),
    [anon_sym_restrict] = ACTIONS(1438),
    [anon_sym_volatile] = ACTIONS(1438),
    [anon_sym__Atomic] = ACTIONS(1438),
    [anon_sym_mutable] = ACTIONS(1438),
    [anon_sym_explicit] = ACTIONS(1438),
    [anon_sym_constexpr] = ACTIONS(1438),
    [anon_sym_COLON] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_AMP_AMP] = ACTIONS(1438),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_DASH_GT] = ACTIONS(1438),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1438),
    [anon_sym_override] = ACTIONS(1438),
    [sym_noexcept] = ACTIONS(1438),
    [anon_sym_COLON_COLON] = ACTIONS(758),
  },
  [3654] = {
    [sym_field_declaration_list] = STATE(1096),
    [sym_virtual_specifier] = STATE(1098),
    [sym_base_class_clause] = STATE(1097),
    [anon_sym_COMMA] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1442),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_LPAREN2] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(1442),
    [anon_sym_const] = ACTIONS(1444),
    [anon_sym_restrict] = ACTIONS(1442),
    [anon_sym_volatile] = ACTIONS(1442),
    [anon_sym__Atomic] = ACTIONS(1442),
    [anon_sym_mutable] = ACTIONS(1442),
    [anon_sym_explicit] = ACTIONS(1442),
    [anon_sym_constexpr] = ACTIONS(1442),
    [anon_sym_COLON] = ACTIONS(1444),
    [anon_sym_AMP] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1442),
    [anon_sym_DASH_GT] = ACTIONS(1442),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1442),
    [anon_sym_override] = ACTIONS(1442),
    [sym_noexcept] = ACTIONS(1442),
    [anon_sym_COLON_COLON] = ACTIONS(772),
  },
  [3655] = {
    [sym_field_declaration_list] = STATE(1096),
    [sym_virtual_specifier] = STATE(1098),
    [sym_base_class_clause] = STATE(1097),
    [sym_template_argument_list] = STATE(362),
    [anon_sym_COMMA] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1442),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_LPAREN2] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(1442),
    [anon_sym_const] = ACTIONS(1444),
    [anon_sym_restrict] = ACTIONS(1442),
    [anon_sym_volatile] = ACTIONS(1442),
    [anon_sym__Atomic] = ACTIONS(1442),
    [anon_sym_mutable] = ACTIONS(1442),
    [anon_sym_explicit] = ACTIONS(1442),
    [anon_sym_constexpr] = ACTIONS(1442),
    [anon_sym_COLON] = ACTIONS(1442),
    [anon_sym_AMP] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1442),
    [anon_sym_LT] = ACTIONS(643),
    [anon_sym_DASH_GT] = ACTIONS(1442),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1442),
    [anon_sym_override] = ACTIONS(1442),
    [sym_noexcept] = ACTIONS(1442),
  },
  [3656] = {
    [sym__abstract_declarator] = STATE(3753),
    [sym_abstract_pointer_declarator] = STATE(3753),
    [sym_abstract_function_declarator] = STATE(3753),
    [sym_abstract_array_declarator] = STATE(3753),
    [sym_type_qualifier] = STATE(3754),
    [sym_parameter_list] = STATE(3659),
    [sym_abstract_reference_declarator] = STATE(3753),
    [aux_sym_type_definition_repeat1] = STATE(3754),
    [anon_sym_COMMA] = ACTIONS(2461),
    [anon_sym_SEMI] = ACTIONS(2461),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(8092),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_const] = ACTIONS(1667),
    [anon_sym_restrict] = ACTIONS(1669),
    [anon_sym_volatile] = ACTIONS(1669),
    [anon_sym__Atomic] = ACTIONS(1669),
    [anon_sym_mutable] = ACTIONS(1669),
    [anon_sym_explicit] = ACTIONS(1669),
    [anon_sym_constexpr] = ACTIONS(1669),
    [anon_sym_COLON] = ACTIONS(2461),
    [anon_sym_AMP] = ACTIONS(8094),
    [anon_sym_AMP_AMP] = ACTIONS(8096),
    [anon_sym_DASH_GT] = ACTIONS(2461),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2461),
    [anon_sym_override] = ACTIONS(2461),
    [sym_noexcept] = ACTIONS(2461),
  },
  [3657] = {
    [sym__abstract_declarator] = STATE(3755),
    [sym_abstract_pointer_declarator] = STATE(3755),
    [sym_abstract_function_declarator] = STATE(3755),
    [sym_abstract_array_declarator] = STATE(3755),
    [sym_parameter_list] = STATE(3659),
    [sym_abstract_reference_declarator] = STATE(3755),
    [anon_sym_COMMA] = ACTIONS(2463),
    [anon_sym_SEMI] = ACTIONS(2463),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(8092),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_const] = ACTIONS(6555),
    [anon_sym_restrict] = ACTIONS(2463),
    [anon_sym_volatile] = ACTIONS(2463),
    [anon_sym__Atomic] = ACTIONS(2463),
    [anon_sym_mutable] = ACTIONS(2463),
    [anon_sym_explicit] = ACTIONS(2463),
    [anon_sym_constexpr] = ACTIONS(2463),
    [anon_sym_COLON] = ACTIONS(2463),
    [anon_sym_AMP] = ACTIONS(8094),
    [anon_sym_AMP_AMP] = ACTIONS(8096),
    [anon_sym_DASH_GT] = ACTIONS(2463),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2463),
    [anon_sym_override] = ACTIONS(2463),
    [sym_noexcept] = ACTIONS(2463),
  },
  [3658] = {
    [sym_parameter_list] = STATE(3756),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_const] = ACTIONS(6559),
    [anon_sym_restrict] = ACTIONS(6557),
    [anon_sym_volatile] = ACTIONS(6557),
    [anon_sym__Atomic] = ACTIONS(6557),
    [anon_sym_mutable] = ACTIONS(6557),
    [anon_sym_explicit] = ACTIONS(6557),
    [anon_sym_constexpr] = ACTIONS(6557),
    [anon_sym_COLON] = ACTIONS(6557),
    [anon_sym_DASH_GT] = ACTIONS(6557),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(6557),
    [anon_sym_override] = ACTIONS(6557),
    [sym_noexcept] = ACTIONS(6557),
  },
  [3659] = {
    [sym_type_qualifier] = STATE(3757),
    [sym_trailing_return_type] = STATE(971),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3757),
    [anon_sym_COMMA] = ACTIONS(1787),
    [anon_sym_SEMI] = ACTIONS(1787),
    [anon_sym_LPAREN2] = ACTIONS(1787),
    [anon_sym_LBRACK] = ACTIONS(1787),
    [anon_sym_const] = ACTIONS(6561),
    [anon_sym_restrict] = ACTIONS(1787),
    [anon_sym_volatile] = ACTIONS(1787),
    [anon_sym__Atomic] = ACTIONS(1787),
    [anon_sym_mutable] = ACTIONS(1787),
    [anon_sym_explicit] = ACTIONS(1787),
    [anon_sym_constexpr] = ACTIONS(1787),
    [anon_sym_COLON] = ACTIONS(1787),
    [anon_sym_DASH_GT] = ACTIONS(1787),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1787),
    [anon_sym_override] = ACTIONS(1787),
    [sym_noexcept] = ACTIONS(1787),
  },
  [3660] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3660),
    [anon_sym_COMMA] = ACTIONS(1985),
    [anon_sym_SEMI] = ACTIONS(1985),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1985),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1987),
    [anon_sym_restrict] = ACTIONS(1987),
    [anon_sym_volatile] = ACTIONS(1987),
    [anon_sym__Atomic] = ACTIONS(1987),
    [anon_sym_mutable] = ACTIONS(1987),
    [anon_sym_explicit] = ACTIONS(1987),
    [anon_sym_constexpr] = ACTIONS(1987),
    [anon_sym_unsigned] = ACTIONS(8261),
    [anon_sym_long] = ACTIONS(8261),
    [anon_sym_short] = ACTIONS(8261),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_COLON] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_DASH_GT] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(1987),
    [anon_sym_override] = ACTIONS(1987),
    [sym_noexcept] = ACTIONS(1987),
  },
  [3661] = {
    [sym_parameter_list] = STATE(3529),
    [anon_sym_COMMA] = ACTIONS(5889),
    [anon_sym_SEMI] = ACTIONS(5889),
    [anon_sym_LBRACE] = ACTIONS(5889),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(5889),
    [anon_sym_const] = ACTIONS(7689),
    [anon_sym_restrict] = ACTIONS(5889),
    [anon_sym_volatile] = ACTIONS(5889),
    [anon_sym__Atomic] = ACTIONS(5889),
    [anon_sym_mutable] = ACTIONS(5889),
    [anon_sym_explicit] = ACTIONS(5889),
    [anon_sym_constexpr] = ACTIONS(5889),
    [anon_sym_COLON] = ACTIONS(5889),
    [anon_sym_DASH_GT] = ACTIONS(5889),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5889),
    [anon_sym_override] = ACTIONS(5889),
    [sym_noexcept] = ACTIONS(5889),
  },
  [3662] = {
    [sym_type_qualifier] = STATE(3662),
    [aux_sym_type_definition_repeat1] = STATE(3662),
    [anon_sym_COMMA] = ACTIONS(2179),
    [anon_sym_SEMI] = ACTIONS(2179),
    [anon_sym_LBRACE] = ACTIONS(2179),
    [anon_sym_LPAREN2] = ACTIONS(2179),
    [anon_sym_STAR] = ACTIONS(2179),
    [anon_sym_LBRACK] = ACTIONS(2179),
    [anon_sym_EQ] = ACTIONS(2179),
    [anon_sym_const] = ACTIONS(7691),
    [anon_sym_restrict] = ACTIONS(7694),
    [anon_sym_volatile] = ACTIONS(7694),
    [anon_sym__Atomic] = ACTIONS(7694),
    [anon_sym_mutable] = ACTIONS(7694),
    [anon_sym_explicit] = ACTIONS(7694),
    [anon_sym_constexpr] = ACTIONS(7694),
    [anon_sym_COLON] = ACTIONS(2179),
    [anon_sym_AMP] = ACTIONS(2177),
    [anon_sym_AMP_AMP] = ACTIONS(2179),
    [anon_sym_DASH_GT] = ACTIONS(2179),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2179),
    [anon_sym_override] = ACTIONS(2179),
    [sym_noexcept] = ACTIONS(2179),
  },
  [3663] = {
    [sym_type_qualifier] = STATE(3664),
    [sym_trailing_return_type] = STATE(2418),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3664),
    [anon_sym_COMMA] = ACTIONS(5331),
    [anon_sym_SEMI] = ACTIONS(5331),
    [anon_sym_LBRACE] = ACTIONS(5331),
    [anon_sym_LPAREN2] = ACTIONS(5331),
    [anon_sym_LBRACK] = ACTIONS(5331),
    [anon_sym_EQ] = ACTIONS(5331),
    [anon_sym_const] = ACTIONS(1667),
    [anon_sym_restrict] = ACTIONS(1669),
    [anon_sym_volatile] = ACTIONS(1669),
    [anon_sym__Atomic] = ACTIONS(1669),
    [anon_sym_mutable] = ACTIONS(1669),
    [anon_sym_explicit] = ACTIONS(1669),
    [anon_sym_constexpr] = ACTIONS(1669),
    [anon_sym_COLON] = ACTIONS(5331),
    [anon_sym_DASH_GT] = ACTIONS(6013),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5331),
    [anon_sym_override] = ACTIONS(5331),
    [sym_noexcept] = ACTIONS(8106),
  },
  [3664] = {
    [sym_type_qualifier] = STATE(3664),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3664),
    [anon_sym_COMMA] = ACTIONS(5351),
    [anon_sym_SEMI] = ACTIONS(5351),
    [anon_sym_LBRACE] = ACTIONS(5351),
    [anon_sym_LPAREN2] = ACTIONS(5351),
    [anon_sym_LBRACK] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_const] = ACTIONS(7697),
    [anon_sym_restrict] = ACTIONS(7700),
    [anon_sym_volatile] = ACTIONS(7700),
    [anon_sym__Atomic] = ACTIONS(7700),
    [anon_sym_mutable] = ACTIONS(7700),
    [anon_sym_explicit] = ACTIONS(7700),
    [anon_sym_constexpr] = ACTIONS(7700),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5351),
    [anon_sym_override] = ACTIONS(5351),
    [sym_noexcept] = ACTIONS(8264),
  },
  [3665] = {
    [sym_compound_statement] = STATE(3114),
    [sym_labeled_statement] = STATE(3114),
    [sym_expression_statement] = STATE(3114),
    [sym_if_statement] = STATE(3114),
    [sym_switch_statement] = STATE(3114),
    [sym_case_statement] = STATE(3114),
    [sym_while_statement] = STATE(3114),
    [sym_do_statement] = STATE(3114),
    [sym_for_statement] = STATE(3114),
    [sym_return_statement] = STATE(3114),
    [sym_break_statement] = STATE(3114),
    [sym_continue_statement] = STATE(3114),
    [sym_goto_statement] = STATE(3114),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(3114),
    [sym_try_statement] = STATE(3114),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(4430),
    [anon_sym_switch] = ACTIONS(4432),
    [anon_sym_case] = ACTIONS(4434),
    [anon_sym_default] = ACTIONS(4436),
    [anon_sym_while] = ACTIONS(4438),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(4440),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(4442),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(4444),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [3666] = {
    [sym_raw_string_literal] = ACTIONS(7063),
    [ts_builtin_sym_end] = ACTIONS(7063),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7065),
    [sym_preproc_directive] = ACTIONS(7065),
    [anon_sym_SEMI] = ACTIONS(7063),
    [anon_sym_typedef] = ACTIONS(7065),
    [anon_sym_extern] = ACTIONS(7065),
    [anon_sym_LBRACE] = ACTIONS(7063),
    [anon_sym_LPAREN2] = ACTIONS(7063),
    [anon_sym_STAR] = ACTIONS(7063),
    [anon_sym_LBRACK] = ACTIONS(7063),
    [anon_sym_static] = ACTIONS(7065),
    [anon_sym_register] = ACTIONS(7065),
    [anon_sym_inline] = ACTIONS(7065),
    [anon_sym_const] = ACTIONS(7065),
    [anon_sym_restrict] = ACTIONS(7065),
    [anon_sym_volatile] = ACTIONS(7065),
    [anon_sym__Atomic] = ACTIONS(7065),
    [anon_sym_mutable] = ACTIONS(7065),
    [anon_sym_explicit] = ACTIONS(7065),
    [anon_sym_constexpr] = ACTIONS(7065),
    [anon_sym_unsigned] = ACTIONS(7065),
    [anon_sym_long] = ACTIONS(7065),
    [anon_sym_short] = ACTIONS(7065),
    [sym_primitive_type] = ACTIONS(7065),
    [anon_sym_enum] = ACTIONS(7065),
    [anon_sym_struct] = ACTIONS(7065),
    [anon_sym_union] = ACTIONS(7065),
    [anon_sym_if] = ACTIONS(7065),
    [anon_sym_else] = ACTIONS(8267),
    [anon_sym_switch] = ACTIONS(7065),
    [anon_sym_case] = ACTIONS(7065),
    [anon_sym_default] = ACTIONS(7065),
    [anon_sym_while] = ACTIONS(7065),
    [anon_sym_do] = ACTIONS(7065),
    [anon_sym_for] = ACTIONS(7065),
    [anon_sym_return] = ACTIONS(7065),
    [anon_sym_break] = ACTIONS(7065),
    [anon_sym_continue] = ACTIONS(7065),
    [anon_sym_goto] = ACTIONS(7065),
    [anon_sym_AMP] = ACTIONS(7065),
    [anon_sym_AMP_AMP] = ACTIONS(7063),
    [anon_sym_BANG] = ACTIONS(7063),
    [anon_sym_TILDE] = ACTIONS(7063),
    [anon_sym_PLUS] = ACTIONS(7065),
    [anon_sym_DASH] = ACTIONS(7065),
    [anon_sym_DASH_DASH] = ACTIONS(7063),
    [anon_sym_PLUS_PLUS] = ACTIONS(7063),
    [anon_sym_sizeof] = ACTIONS(7065),
    [sym_number_literal] = ACTIONS(7063),
    [anon_sym_SQUOTE] = ACTIONS(7063),
    [anon_sym_DQUOTE] = ACTIONS(7063),
    [sym_true] = ACTIONS(7065),
    [sym_false] = ACTIONS(7065),
    [sym_null] = ACTIONS(7065),
    [sym_identifier] = ACTIONS(7065),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7065),
    [sym_auto] = ACTIONS(7065),
    [anon_sym_typename] = ACTIONS(7065),
    [anon_sym_template] = ACTIONS(7065),
    [anon_sym_delete] = ACTIONS(7065),
    [anon_sym_namespace] = ACTIONS(7065),
    [anon_sym_using] = ACTIONS(7065),
    [anon_sym_try] = ACTIONS(7065),
    [anon_sym_new] = ACTIONS(7065),
    [anon_sym_COLON_COLON] = ACTIONS(7063),
    [sym_operator_name] = ACTIONS(7063),
    [sym_nullptr] = ACTIONS(7065),
  },
  [3667] = {
    [sym_compound_statement] = STATE(3135),
    [sym_labeled_statement] = STATE(3135),
    [sym_expression_statement] = STATE(3135),
    [sym_if_statement] = STATE(3135),
    [sym_switch_statement] = STATE(3135),
    [sym_case_statement] = STATE(3135),
    [sym_while_statement] = STATE(3135),
    [sym_do_statement] = STATE(3135),
    [sym_for_statement] = STATE(3135),
    [sym_return_statement] = STATE(3135),
    [sym_break_statement] = STATE(3135),
    [sym_continue_statement] = STATE(3135),
    [sym_goto_statement] = STATE(3135),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(3135),
    [sym_try_statement] = STATE(3135),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(4430),
    [anon_sym_switch] = ACTIONS(4432),
    [anon_sym_case] = ACTIONS(4434),
    [anon_sym_default] = ACTIONS(4436),
    [anon_sym_while] = ACTIONS(4438),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(4440),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(4442),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(4444),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [3668] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8269),
    [sym_comment] = ACTIONS(91),
  },
  [3669] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3760),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8269),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3670] = {
    [sym__expression] = STATE(3761),
    [sym_conditional_expression] = STATE(3761),
    [sym_assignment_expression] = STATE(3761),
    [sym_pointer_expression] = STATE(3761),
    [sym_logical_expression] = STATE(3761),
    [sym_bitwise_expression] = STATE(3761),
    [sym_equality_expression] = STATE(3761),
    [sym_relational_expression] = STATE(3761),
    [sym_shift_expression] = STATE(3761),
    [sym_math_expression] = STATE(3761),
    [sym_cast_expression] = STATE(3761),
    [sym_sizeof_expression] = STATE(3761),
    [sym_subscript_expression] = STATE(3761),
    [sym_call_expression] = STATE(3761),
    [sym_field_expression] = STATE(3761),
    [sym_compound_literal_expression] = STATE(3761),
    [sym_parenthesized_expression] = STATE(3761),
    [sym_char_literal] = STATE(3761),
    [sym_concatenated_string] = STATE(3761),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3761),
    [sym_new_expression] = STATE(3761),
    [sym_delete_expression] = STATE(3761),
    [sym_lambda_expression] = STATE(3761),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8271),
    [anon_sym_RPAREN] = ACTIONS(8269),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(8271),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8273),
    [sym_false] = ACTIONS(8273),
    [sym_null] = ACTIONS(8273),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(8273),
  },
  [3671] = {
    [sym_compound_statement] = STATE(3140),
    [sym_labeled_statement] = STATE(3140),
    [sym_expression_statement] = STATE(3140),
    [sym_if_statement] = STATE(3140),
    [sym_switch_statement] = STATE(3140),
    [sym_case_statement] = STATE(3140),
    [sym_while_statement] = STATE(3140),
    [sym_do_statement] = STATE(3140),
    [sym_for_statement] = STATE(3140),
    [sym_return_statement] = STATE(3140),
    [sym_break_statement] = STATE(3140),
    [sym_continue_statement] = STATE(3140),
    [sym_goto_statement] = STATE(3140),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(3140),
    [sym_try_statement] = STATE(3140),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(4430),
    [anon_sym_switch] = ACTIONS(4432),
    [anon_sym_case] = ACTIONS(4434),
    [anon_sym_default] = ACTIONS(4436),
    [anon_sym_while] = ACTIONS(4438),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(4440),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(4442),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(4444),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [3672] = {
    [anon_sym_else] = ACTIONS(8275),
    [anon_sym_while] = ACTIONS(6091),
    [sym_comment] = ACTIONS(91),
  },
  [3673] = {
    [sym_compound_statement] = STATE(3763),
    [sym_labeled_statement] = STATE(3763),
    [sym_expression_statement] = STATE(3763),
    [sym_if_statement] = STATE(3763),
    [sym_switch_statement] = STATE(3763),
    [sym_case_statement] = STATE(3763),
    [sym_while_statement] = STATE(3763),
    [sym_do_statement] = STATE(3763),
    [sym_for_statement] = STATE(3763),
    [sym_return_statement] = STATE(3763),
    [sym_break_statement] = STATE(3763),
    [sym_continue_statement] = STATE(3763),
    [sym_goto_statement] = STATE(3763),
    [sym__expression] = STATE(222),
    [sym_comma_expression] = STATE(223),
    [sym_conditional_expression] = STATE(222),
    [sym_assignment_expression] = STATE(222),
    [sym_pointer_expression] = STATE(222),
    [sym_logical_expression] = STATE(222),
    [sym_bitwise_expression] = STATE(222),
    [sym_equality_expression] = STATE(222),
    [sym_relational_expression] = STATE(222),
    [sym_shift_expression] = STATE(222),
    [sym_math_expression] = STATE(222),
    [sym_cast_expression] = STATE(222),
    [sym_sizeof_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_call_expression] = STATE(222),
    [sym_field_expression] = STATE(222),
    [sym_compound_literal_expression] = STATE(222),
    [sym_parenthesized_expression] = STATE(222),
    [sym_char_literal] = STATE(222),
    [sym_concatenated_string] = STATE(222),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(222),
    [sym_for_range_loop] = STATE(3763),
    [sym_try_statement] = STATE(3763),
    [sym_new_expression] = STATE(222),
    [sym_delete_expression] = STATE(222),
    [sym_lambda_expression] = STATE(222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(6119),
    [anon_sym_switch] = ACTIONS(6121),
    [anon_sym_case] = ACTIONS(6123),
    [anon_sym_default] = ACTIONS(6125),
    [anon_sym_while] = ACTIONS(6127),
    [anon_sym_do] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(6129),
    [anon_sym_return] = ACTIONS(373),
    [anon_sym_break] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_goto] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(353),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_identifier] = ACTIONS(6131),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(6133),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(381),
  },
  [3674] = {
    [sym_compound_statement] = STATE(3128),
    [sym_labeled_statement] = STATE(3128),
    [sym_expression_statement] = STATE(3128),
    [sym_if_statement] = STATE(3128),
    [sym_switch_statement] = STATE(3128),
    [sym_case_statement] = STATE(3128),
    [sym_while_statement] = STATE(3128),
    [sym_do_statement] = STATE(3128),
    [sym_for_statement] = STATE(3128),
    [sym_return_statement] = STATE(3128),
    [sym_break_statement] = STATE(3128),
    [sym_continue_statement] = STATE(3128),
    [sym_goto_statement] = STATE(3128),
    [sym__expression] = STATE(222),
    [sym_comma_expression] = STATE(223),
    [sym_conditional_expression] = STATE(222),
    [sym_assignment_expression] = STATE(222),
    [sym_pointer_expression] = STATE(222),
    [sym_logical_expression] = STATE(222),
    [sym_bitwise_expression] = STATE(222),
    [sym_equality_expression] = STATE(222),
    [sym_relational_expression] = STATE(222),
    [sym_shift_expression] = STATE(222),
    [sym_math_expression] = STATE(222),
    [sym_cast_expression] = STATE(222),
    [sym_sizeof_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_call_expression] = STATE(222),
    [sym_field_expression] = STATE(222),
    [sym_compound_literal_expression] = STATE(222),
    [sym_parenthesized_expression] = STATE(222),
    [sym_char_literal] = STATE(222),
    [sym_concatenated_string] = STATE(222),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(222),
    [sym_for_range_loop] = STATE(3128),
    [sym_try_statement] = STATE(3128),
    [sym_new_expression] = STATE(222),
    [sym_delete_expression] = STATE(222),
    [sym_lambda_expression] = STATE(222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(6119),
    [anon_sym_switch] = ACTIONS(6121),
    [anon_sym_case] = ACTIONS(6123),
    [anon_sym_default] = ACTIONS(6125),
    [anon_sym_while] = ACTIONS(6127),
    [anon_sym_do] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(6129),
    [anon_sym_return] = ACTIONS(373),
    [anon_sym_break] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_goto] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(353),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_identifier] = ACTIONS(6131),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(6133),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(381),
  },
  [3675] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3765),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8277),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3676] = {
    [sym__expression] = STATE(3766),
    [sym_conditional_expression] = STATE(3766),
    [sym_assignment_expression] = STATE(3766),
    [sym_pointer_expression] = STATE(3766),
    [sym_logical_expression] = STATE(3766),
    [sym_bitwise_expression] = STATE(3766),
    [sym_equality_expression] = STATE(3766),
    [sym_relational_expression] = STATE(3766),
    [sym_shift_expression] = STATE(3766),
    [sym_math_expression] = STATE(3766),
    [sym_cast_expression] = STATE(3766),
    [sym_sizeof_expression] = STATE(3766),
    [sym_subscript_expression] = STATE(3766),
    [sym_call_expression] = STATE(3766),
    [sym_field_expression] = STATE(3766),
    [sym_compound_literal_expression] = STATE(3766),
    [sym_parenthesized_expression] = STATE(3766),
    [sym_char_literal] = STATE(3766),
    [sym_concatenated_string] = STATE(3766),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3766),
    [sym_new_expression] = STATE(3766),
    [sym_delete_expression] = STATE(3766),
    [sym_lambda_expression] = STATE(3766),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8279),
    [anon_sym_RPAREN] = ACTIONS(8277),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(8279),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8281),
    [sym_false] = ACTIONS(8281),
    [sym_null] = ACTIONS(8281),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(8281),
  },
  [3677] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(8283),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3678] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(8285),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3679] = {
    [anon_sym_else] = ACTIONS(8143),
    [anon_sym_while] = ACTIONS(8143),
    [sym_comment] = ACTIONS(91),
  },
  [3680] = {
    [sym_compound_statement] = STATE(3769),
    [sym_labeled_statement] = STATE(3769),
    [sym_expression_statement] = STATE(3769),
    [sym_if_statement] = STATE(3769),
    [sym_switch_statement] = STATE(3769),
    [sym_case_statement] = STATE(3769),
    [sym_while_statement] = STATE(3769),
    [sym_do_statement] = STATE(3769),
    [sym_for_statement] = STATE(3769),
    [sym_return_statement] = STATE(3769),
    [sym_break_statement] = STATE(3769),
    [sym_continue_statement] = STATE(3769),
    [sym_goto_statement] = STATE(3769),
    [sym__expression] = STATE(222),
    [sym_comma_expression] = STATE(223),
    [sym_conditional_expression] = STATE(222),
    [sym_assignment_expression] = STATE(222),
    [sym_pointer_expression] = STATE(222),
    [sym_logical_expression] = STATE(222),
    [sym_bitwise_expression] = STATE(222),
    [sym_equality_expression] = STATE(222),
    [sym_relational_expression] = STATE(222),
    [sym_shift_expression] = STATE(222),
    [sym_math_expression] = STATE(222),
    [sym_cast_expression] = STATE(222),
    [sym_sizeof_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_call_expression] = STATE(222),
    [sym_field_expression] = STATE(222),
    [sym_compound_literal_expression] = STATE(222),
    [sym_parenthesized_expression] = STATE(222),
    [sym_char_literal] = STATE(222),
    [sym_concatenated_string] = STATE(222),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(222),
    [sym_for_range_loop] = STATE(3769),
    [sym_try_statement] = STATE(3769),
    [sym_new_expression] = STATE(222),
    [sym_delete_expression] = STATE(222),
    [sym_lambda_expression] = STATE(222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(359),
    [anon_sym_switch] = ACTIONS(361),
    [anon_sym_case] = ACTIONS(363),
    [anon_sym_default] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [anon_sym_do] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(373),
    [anon_sym_break] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_goto] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(353),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_identifier] = ACTIONS(383),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(381),
  },
  [3681] = {
    [sym_raw_string_literal] = ACTIONS(8287),
    [ts_builtin_sym_end] = ACTIONS(8287),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(8289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(8289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(8289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(8289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(8289),
    [sym_preproc_directive] = ACTIONS(8289),
    [anon_sym_SEMI] = ACTIONS(8287),
    [anon_sym_typedef] = ACTIONS(8289),
    [anon_sym_extern] = ACTIONS(8289),
    [anon_sym_LBRACE] = ACTIONS(8287),
    [anon_sym_RBRACE] = ACTIONS(8287),
    [anon_sym_LPAREN2] = ACTIONS(8287),
    [anon_sym_STAR] = ACTIONS(8287),
    [anon_sym_LBRACK] = ACTIONS(8287),
    [anon_sym_static] = ACTIONS(8289),
    [anon_sym_register] = ACTIONS(8289),
    [anon_sym_inline] = ACTIONS(8289),
    [anon_sym_const] = ACTIONS(8289),
    [anon_sym_restrict] = ACTIONS(8289),
    [anon_sym_volatile] = ACTIONS(8289),
    [anon_sym__Atomic] = ACTIONS(8289),
    [anon_sym_mutable] = ACTIONS(8289),
    [anon_sym_explicit] = ACTIONS(8289),
    [anon_sym_constexpr] = ACTIONS(8289),
    [anon_sym_unsigned] = ACTIONS(8289),
    [anon_sym_long] = ACTIONS(8289),
    [anon_sym_short] = ACTIONS(8289),
    [sym_primitive_type] = ACTIONS(8289),
    [anon_sym_enum] = ACTIONS(8289),
    [anon_sym_struct] = ACTIONS(8289),
    [anon_sym_union] = ACTIONS(8289),
    [anon_sym_if] = ACTIONS(8289),
    [anon_sym_else] = ACTIONS(8289),
    [anon_sym_switch] = ACTIONS(8289),
    [anon_sym_case] = ACTIONS(8289),
    [anon_sym_default] = ACTIONS(8289),
    [anon_sym_while] = ACTIONS(8289),
    [anon_sym_do] = ACTIONS(8289),
    [anon_sym_for] = ACTIONS(8289),
    [anon_sym_return] = ACTIONS(8289),
    [anon_sym_break] = ACTIONS(8289),
    [anon_sym_continue] = ACTIONS(8289),
    [anon_sym_goto] = ACTIONS(8289),
    [anon_sym_AMP] = ACTIONS(8289),
    [anon_sym_AMP_AMP] = ACTIONS(8287),
    [anon_sym_BANG] = ACTIONS(8287),
    [anon_sym_TILDE] = ACTIONS(8287),
    [anon_sym_PLUS] = ACTIONS(8289),
    [anon_sym_DASH] = ACTIONS(8289),
    [anon_sym_DASH_DASH] = ACTIONS(8287),
    [anon_sym_PLUS_PLUS] = ACTIONS(8287),
    [anon_sym_sizeof] = ACTIONS(8289),
    [sym_number_literal] = ACTIONS(8287),
    [anon_sym_SQUOTE] = ACTIONS(8287),
    [anon_sym_DQUOTE] = ACTIONS(8287),
    [sym_true] = ACTIONS(8289),
    [sym_false] = ACTIONS(8289),
    [sym_null] = ACTIONS(8289),
    [sym_identifier] = ACTIONS(8289),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(8289),
    [sym_auto] = ACTIONS(8289),
    [anon_sym_typename] = ACTIONS(8289),
    [anon_sym_template] = ACTIONS(8289),
    [anon_sym_delete] = ACTIONS(8289),
    [anon_sym_namespace] = ACTIONS(8289),
    [anon_sym_using] = ACTIONS(8289),
    [anon_sym_try] = ACTIONS(8289),
    [anon_sym_new] = ACTIONS(8289),
    [anon_sym_COLON_COLON] = ACTIONS(8287),
    [sym_operator_name] = ACTIONS(8287),
    [sym_nullptr] = ACTIONS(8289),
  },
  [3682] = {
    [sym_parameter_list] = STATE(3559),
    [anon_sym_COMMA] = ACTIONS(5889),
    [anon_sym_LBRACE] = ACTIONS(5889),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(5889),
    [anon_sym_const] = ACTIONS(7689),
    [anon_sym_restrict] = ACTIONS(5889),
    [anon_sym_volatile] = ACTIONS(5889),
    [anon_sym__Atomic] = ACTIONS(5889),
    [anon_sym_mutable] = ACTIONS(5889),
    [anon_sym_explicit] = ACTIONS(5889),
    [anon_sym_constexpr] = ACTIONS(5889),
    [anon_sym_DASH_GT] = ACTIONS(5889),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5889),
    [anon_sym_override] = ACTIONS(5889),
    [anon_sym_GT2] = ACTIONS(5889),
    [sym_noexcept] = ACTIONS(5889),
  },
  [3683] = {
    [sym_type_qualifier] = STATE(3683),
    [aux_sym_type_definition_repeat1] = STATE(3683),
    [anon_sym_COMMA] = ACTIONS(2179),
    [anon_sym_LBRACE] = ACTIONS(2179),
    [anon_sym_LPAREN2] = ACTIONS(2179),
    [anon_sym_STAR] = ACTIONS(2179),
    [anon_sym_LBRACK] = ACTIONS(2179),
    [anon_sym_EQ] = ACTIONS(2179),
    [anon_sym_const] = ACTIONS(2538),
    [anon_sym_restrict] = ACTIONS(5316),
    [anon_sym_volatile] = ACTIONS(5316),
    [anon_sym__Atomic] = ACTIONS(5316),
    [anon_sym_mutable] = ACTIONS(5316),
    [anon_sym_explicit] = ACTIONS(5316),
    [anon_sym_constexpr] = ACTIONS(5316),
    [anon_sym_AMP] = ACTIONS(2177),
    [anon_sym_AMP_AMP] = ACTIONS(2179),
    [anon_sym_DASH_GT] = ACTIONS(2179),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2179),
    [anon_sym_override] = ACTIONS(2179),
    [anon_sym_GT2] = ACTIONS(2179),
    [sym_noexcept] = ACTIONS(2179),
  },
  [3684] = {
    [sym_type_qualifier] = STATE(3685),
    [sym_trailing_return_type] = STATE(2418),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3685),
    [anon_sym_COMMA] = ACTIONS(5331),
    [anon_sym_LBRACE] = ACTIONS(5331),
    [anon_sym_LPAREN2] = ACTIONS(5331),
    [anon_sym_LBRACK] = ACTIONS(5331),
    [anon_sym_EQ] = ACTIONS(5331),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(6320),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5331),
    [anon_sym_override] = ACTIONS(5331),
    [anon_sym_GT2] = ACTIONS(5331),
    [sym_noexcept] = ACTIONS(8147),
  },
  [3685] = {
    [sym_type_qualifier] = STATE(3685),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3685),
    [anon_sym_COMMA] = ACTIONS(5351),
    [anon_sym_LBRACE] = ACTIONS(5351),
    [anon_sym_LPAREN2] = ACTIONS(5351),
    [anon_sym_LBRACK] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_const] = ACTIONS(5353),
    [anon_sym_restrict] = ACTIONS(5356),
    [anon_sym_volatile] = ACTIONS(5356),
    [anon_sym__Atomic] = ACTIONS(5356),
    [anon_sym_mutable] = ACTIONS(5356),
    [anon_sym_explicit] = ACTIONS(5356),
    [anon_sym_constexpr] = ACTIONS(5356),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5351),
    [anon_sym_override] = ACTIONS(5351),
    [anon_sym_GT2] = ACTIONS(5351),
    [sym_noexcept] = ACTIONS(8291),
  },
  [3686] = {
    [sym_compound_statement] = STATE(3770),
    [sym_labeled_statement] = STATE(3770),
    [sym_expression_statement] = STATE(3770),
    [sym_if_statement] = STATE(3770),
    [sym_switch_statement] = STATE(3770),
    [sym_case_statement] = STATE(3770),
    [sym_while_statement] = STATE(3770),
    [sym_do_statement] = STATE(3770),
    [sym_for_statement] = STATE(3770),
    [sym_return_statement] = STATE(3770),
    [sym_break_statement] = STATE(3770),
    [sym_continue_statement] = STATE(3770),
    [sym_goto_statement] = STATE(3770),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(3770),
    [sym_try_statement] = STATE(3770),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7177),
    [anon_sym_switch] = ACTIONS(7179),
    [anon_sym_case] = ACTIONS(7181),
    [anon_sym_default] = ACTIONS(7183),
    [anon_sym_while] = ACTIONS(7185),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(7187),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(7189),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7191),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [3687] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(8294),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3688] = {
    [sym__expression] = STATE(3773),
    [sym_conditional_expression] = STATE(3773),
    [sym_assignment_expression] = STATE(3773),
    [sym_pointer_expression] = STATE(3773),
    [sym_logical_expression] = STATE(3773),
    [sym_bitwise_expression] = STATE(3773),
    [sym_equality_expression] = STATE(3773),
    [sym_relational_expression] = STATE(3773),
    [sym_shift_expression] = STATE(3773),
    [sym_math_expression] = STATE(3773),
    [sym_cast_expression] = STATE(3773),
    [sym_sizeof_expression] = STATE(3773),
    [sym_subscript_expression] = STATE(3773),
    [sym_call_expression] = STATE(3773),
    [sym_field_expression] = STATE(3773),
    [sym_compound_literal_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym_char_literal] = STATE(3773),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3773),
    [sym_new_expression] = STATE(3773),
    [sym_delete_expression] = STATE(3773),
    [sym_lambda_expression] = STATE(3773),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8296),
    [anon_sym_RPAREN] = ACTIONS(8298),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(8296),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8300),
    [sym_false] = ACTIONS(8300),
    [sym_null] = ACTIONS(8300),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(8300),
  },
  [3689] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(8302),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3690] = {
    [sym__expression] = STATE(3775),
    [sym_conditional_expression] = STATE(3775),
    [sym_assignment_expression] = STATE(3775),
    [sym_pointer_expression] = STATE(3775),
    [sym_logical_expression] = STATE(3775),
    [sym_bitwise_expression] = STATE(3775),
    [sym_equality_expression] = STATE(3775),
    [sym_relational_expression] = STATE(3775),
    [sym_shift_expression] = STATE(3775),
    [sym_math_expression] = STATE(3775),
    [sym_cast_expression] = STATE(3775),
    [sym_sizeof_expression] = STATE(3775),
    [sym_subscript_expression] = STATE(3775),
    [sym_call_expression] = STATE(3775),
    [sym_field_expression] = STATE(3775),
    [sym_compound_literal_expression] = STATE(3775),
    [sym_parenthesized_expression] = STATE(3775),
    [sym_char_literal] = STATE(3775),
    [sym_concatenated_string] = STATE(3775),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3775),
    [sym_new_expression] = STATE(3775),
    [sym_delete_expression] = STATE(3775),
    [sym_lambda_expression] = STATE(3775),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8304),
    [anon_sym_SEMI] = ACTIONS(8302),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(8304),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8306),
    [sym_false] = ACTIONS(8306),
    [sym_null] = ACTIONS(8306),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(8306),
  },
  [3691] = {
    [sym__expression] = STATE(3776),
    [sym_conditional_expression] = STATE(3776),
    [sym_assignment_expression] = STATE(3776),
    [sym_pointer_expression] = STATE(3776),
    [sym_logical_expression] = STATE(3776),
    [sym_bitwise_expression] = STATE(3776),
    [sym_equality_expression] = STATE(3776),
    [sym_relational_expression] = STATE(3776),
    [sym_shift_expression] = STATE(3776),
    [sym_math_expression] = STATE(3776),
    [sym_cast_expression] = STATE(3776),
    [sym_sizeof_expression] = STATE(3776),
    [sym_subscript_expression] = STATE(3776),
    [sym_call_expression] = STATE(3776),
    [sym_field_expression] = STATE(3776),
    [sym_compound_literal_expression] = STATE(3776),
    [sym_parenthesized_expression] = STATE(3776),
    [sym_char_literal] = STATE(3776),
    [sym_concatenated_string] = STATE(3776),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3776),
    [sym_new_expression] = STATE(3776),
    [sym_delete_expression] = STATE(3776),
    [sym_lambda_expression] = STATE(3776),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8308),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(8308),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8310),
    [sym_false] = ACTIONS(8310),
    [sym_null] = ACTIONS(8310),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(8310),
  },
  [3692] = {
    [sym_catch_clause] = STATE(3692),
    [aux_sym_try_statement_repeat1] = STATE(3692),
    [sym_raw_string_literal] = ACTIONS(4993),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4995),
    [sym_preproc_directive] = ACTIONS(4995),
    [anon_sym_SEMI] = ACTIONS(4993),
    [anon_sym_typedef] = ACTIONS(4995),
    [anon_sym_extern] = ACTIONS(4995),
    [anon_sym_LBRACE] = ACTIONS(4993),
    [anon_sym_RBRACE] = ACTIONS(4993),
    [anon_sym_LPAREN2] = ACTIONS(4993),
    [anon_sym_STAR] = ACTIONS(4993),
    [anon_sym_LBRACK] = ACTIONS(4993),
    [anon_sym_static] = ACTIONS(4995),
    [anon_sym_register] = ACTIONS(4995),
    [anon_sym_inline] = ACTIONS(4995),
    [anon_sym_const] = ACTIONS(4995),
    [anon_sym_restrict] = ACTIONS(4995),
    [anon_sym_volatile] = ACTIONS(4995),
    [anon_sym__Atomic] = ACTIONS(4995),
    [anon_sym_mutable] = ACTIONS(4995),
    [anon_sym_explicit] = ACTIONS(4995),
    [anon_sym_constexpr] = ACTIONS(4995),
    [anon_sym_unsigned] = ACTIONS(4995),
    [anon_sym_long] = ACTIONS(4995),
    [anon_sym_short] = ACTIONS(4995),
    [sym_primitive_type] = ACTIONS(4995),
    [anon_sym_enum] = ACTIONS(4995),
    [anon_sym_struct] = ACTIONS(4995),
    [anon_sym_union] = ACTIONS(4995),
    [anon_sym_if] = ACTIONS(4995),
    [anon_sym_else] = ACTIONS(4995),
    [anon_sym_switch] = ACTIONS(4995),
    [anon_sym_case] = ACTIONS(4995),
    [anon_sym_default] = ACTIONS(4995),
    [anon_sym_while] = ACTIONS(4995),
    [anon_sym_do] = ACTIONS(4995),
    [anon_sym_for] = ACTIONS(4995),
    [anon_sym_return] = ACTIONS(4995),
    [anon_sym_break] = ACTIONS(4995),
    [anon_sym_continue] = ACTIONS(4995),
    [anon_sym_goto] = ACTIONS(4995),
    [anon_sym_AMP] = ACTIONS(4995),
    [anon_sym_AMP_AMP] = ACTIONS(4993),
    [anon_sym_BANG] = ACTIONS(4993),
    [anon_sym_TILDE] = ACTIONS(4993),
    [anon_sym_PLUS] = ACTIONS(4995),
    [anon_sym_DASH] = ACTIONS(4995),
    [anon_sym_DASH_DASH] = ACTIONS(4993),
    [anon_sym_PLUS_PLUS] = ACTIONS(4993),
    [anon_sym_sizeof] = ACTIONS(4995),
    [sym_number_literal] = ACTIONS(4993),
    [anon_sym_SQUOTE] = ACTIONS(4993),
    [anon_sym_DQUOTE] = ACTIONS(4993),
    [sym_true] = ACTIONS(4995),
    [sym_false] = ACTIONS(4995),
    [sym_null] = ACTIONS(4995),
    [sym_identifier] = ACTIONS(4995),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4995),
    [sym_auto] = ACTIONS(4995),
    [anon_sym_typename] = ACTIONS(4995),
    [anon_sym_template] = ACTIONS(4995),
    [anon_sym_delete] = ACTIONS(4995),
    [anon_sym_namespace] = ACTIONS(4995),
    [anon_sym_using] = ACTIONS(4995),
    [anon_sym_try] = ACTIONS(4995),
    [anon_sym_catch] = ACTIONS(4997),
    [anon_sym_new] = ACTIONS(4995),
    [anon_sym_COLON_COLON] = ACTIONS(4993),
    [sym_operator_name] = ACTIONS(4993),
    [sym_nullptr] = ACTIONS(4995),
  },
  [3693] = {
    [sym_compound_statement] = STATE(3553),
    [sym_labeled_statement] = STATE(3553),
    [sym_expression_statement] = STATE(3553),
    [sym_if_statement] = STATE(3553),
    [sym_switch_statement] = STATE(3553),
    [sym_case_statement] = STATE(3553),
    [sym_while_statement] = STATE(3553),
    [sym_do_statement] = STATE(3553),
    [sym_for_statement] = STATE(3553),
    [sym_return_statement] = STATE(3553),
    [sym_break_statement] = STATE(3553),
    [sym_continue_statement] = STATE(3553),
    [sym_goto_statement] = STATE(3553),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(3553),
    [sym_try_statement] = STATE(3553),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(1495),
    [anon_sym_switch] = ACTIONS(1497),
    [anon_sym_case] = ACTIONS(1499),
    [anon_sym_default] = ACTIONS(1501),
    [anon_sym_while] = ACTIONS(1503),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(1505),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(4937),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(1509),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [3694] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8312),
    [sym_comment] = ACTIONS(91),
  },
  [3695] = {
    [sym_parameter_list] = STATE(3576),
    [anon_sym_COMMA] = ACTIONS(5889),
    [anon_sym_RPAREN] = ACTIONS(5889),
    [anon_sym_LBRACE] = ACTIONS(5889),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(5889),
    [anon_sym_const] = ACTIONS(7689),
    [anon_sym_restrict] = ACTIONS(5889),
    [anon_sym_volatile] = ACTIONS(5889),
    [anon_sym__Atomic] = ACTIONS(5889),
    [anon_sym_mutable] = ACTIONS(5889),
    [anon_sym_explicit] = ACTIONS(5889),
    [anon_sym_constexpr] = ACTIONS(5889),
    [anon_sym_DASH_GT] = ACTIONS(5889),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5889),
    [anon_sym_override] = ACTIONS(5889),
    [sym_noexcept] = ACTIONS(5889),
  },
  [3696] = {
    [sym_type_qualifier] = STATE(3696),
    [aux_sym_type_definition_repeat1] = STATE(3696),
    [anon_sym_COMMA] = ACTIONS(2179),
    [anon_sym_RPAREN] = ACTIONS(2179),
    [anon_sym_LBRACE] = ACTIONS(2179),
    [anon_sym_LPAREN2] = ACTIONS(2179),
    [anon_sym_STAR] = ACTIONS(2179),
    [anon_sym_LBRACK] = ACTIONS(2179),
    [anon_sym_EQ] = ACTIONS(2179),
    [anon_sym_const] = ACTIONS(2538),
    [anon_sym_restrict] = ACTIONS(5316),
    [anon_sym_volatile] = ACTIONS(5316),
    [anon_sym__Atomic] = ACTIONS(5316),
    [anon_sym_mutable] = ACTIONS(5316),
    [anon_sym_explicit] = ACTIONS(5316),
    [anon_sym_constexpr] = ACTIONS(5316),
    [anon_sym_AMP] = ACTIONS(2177),
    [anon_sym_AMP_AMP] = ACTIONS(2179),
    [anon_sym_DASH_GT] = ACTIONS(2179),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2179),
    [anon_sym_override] = ACTIONS(2179),
    [sym_noexcept] = ACTIONS(2179),
  },
  [3697] = {
    [sym_type_qualifier] = STATE(3698),
    [sym_trailing_return_type] = STATE(2418),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3698),
    [anon_sym_COMMA] = ACTIONS(5331),
    [anon_sym_RPAREN] = ACTIONS(5331),
    [anon_sym_LBRACE] = ACTIONS(5331),
    [anon_sym_LPAREN2] = ACTIONS(5331),
    [anon_sym_LBRACK] = ACTIONS(5331),
    [anon_sym_EQ] = ACTIONS(5331),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_restrict] = ACTIONS(1773),
    [anon_sym_volatile] = ACTIONS(1773),
    [anon_sym__Atomic] = ACTIONS(1773),
    [anon_sym_mutable] = ACTIONS(1773),
    [anon_sym_explicit] = ACTIONS(1773),
    [anon_sym_constexpr] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(6522),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5331),
    [anon_sym_override] = ACTIONS(5331),
    [sym_noexcept] = ACTIONS(8167),
  },
  [3698] = {
    [sym_type_qualifier] = STATE(3698),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3698),
    [anon_sym_COMMA] = ACTIONS(5351),
    [anon_sym_RPAREN] = ACTIONS(5351),
    [anon_sym_LBRACE] = ACTIONS(5351),
    [anon_sym_LPAREN2] = ACTIONS(5351),
    [anon_sym_LBRACK] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5351),
    [anon_sym_const] = ACTIONS(5353),
    [anon_sym_restrict] = ACTIONS(5356),
    [anon_sym_volatile] = ACTIONS(5356),
    [anon_sym__Atomic] = ACTIONS(5356),
    [anon_sym_mutable] = ACTIONS(5356),
    [anon_sym_explicit] = ACTIONS(5356),
    [anon_sym_constexpr] = ACTIONS(5356),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5351),
    [anon_sym_override] = ACTIONS(5351),
    [sym_noexcept] = ACTIONS(8314),
  },
  [3699] = {
    [sym_compound_statement] = STATE(3778),
    [sym_labeled_statement] = STATE(3778),
    [sym_expression_statement] = STATE(3778),
    [sym_if_statement] = STATE(3778),
    [sym_switch_statement] = STATE(3778),
    [sym_case_statement] = STATE(3778),
    [sym_while_statement] = STATE(3778),
    [sym_do_statement] = STATE(3778),
    [sym_for_statement] = STATE(3778),
    [sym_return_statement] = STATE(3778),
    [sym_break_statement] = STATE(3778),
    [sym_continue_statement] = STATE(3778),
    [sym_goto_statement] = STATE(3778),
    [sym__expression] = STATE(1020),
    [sym_comma_expression] = STATE(1021),
    [sym_conditional_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1020),
    [sym_pointer_expression] = STATE(1020),
    [sym_logical_expression] = STATE(1020),
    [sym_bitwise_expression] = STATE(1020),
    [sym_equality_expression] = STATE(1020),
    [sym_relational_expression] = STATE(1020),
    [sym_shift_expression] = STATE(1020),
    [sym_math_expression] = STATE(1020),
    [sym_cast_expression] = STATE(1020),
    [sym_sizeof_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_field_expression] = STATE(1020),
    [sym_compound_literal_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_char_literal] = STATE(1020),
    [sym_concatenated_string] = STATE(1020),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1020),
    [sym_for_range_loop] = STATE(3778),
    [sym_try_statement] = STATE(3778),
    [sym_new_expression] = STATE(1020),
    [sym_delete_expression] = STATE(1020),
    [sym_lambda_expression] = STATE(1020),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2022),
    [anon_sym_SEMI] = ACTIONS(2036),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7300),
    [anon_sym_switch] = ACTIONS(7302),
    [anon_sym_case] = ACTIONS(7304),
    [anon_sym_default] = ACTIONS(7306),
    [anon_sym_while] = ACTIONS(7308),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(7310),
    [anon_sym_return] = ACTIONS(2058),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2062),
    [anon_sym_goto] = ACTIONS(2064),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(7312),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7314),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2066),
  },
  [3700] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(8317),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3701] = {
    [sym__expression] = STATE(3781),
    [sym_conditional_expression] = STATE(3781),
    [sym_assignment_expression] = STATE(3781),
    [sym_pointer_expression] = STATE(3781),
    [sym_logical_expression] = STATE(3781),
    [sym_bitwise_expression] = STATE(3781),
    [sym_equality_expression] = STATE(3781),
    [sym_relational_expression] = STATE(3781),
    [sym_shift_expression] = STATE(3781),
    [sym_math_expression] = STATE(3781),
    [sym_cast_expression] = STATE(3781),
    [sym_sizeof_expression] = STATE(3781),
    [sym_subscript_expression] = STATE(3781),
    [sym_call_expression] = STATE(3781),
    [sym_field_expression] = STATE(3781),
    [sym_compound_literal_expression] = STATE(3781),
    [sym_parenthesized_expression] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3781),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3781),
    [sym_new_expression] = STATE(3781),
    [sym_delete_expression] = STATE(3781),
    [sym_lambda_expression] = STATE(3781),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8319),
    [anon_sym_RPAREN] = ACTIONS(8321),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(8319),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8323),
    [sym_false] = ACTIONS(8323),
    [sym_null] = ACTIONS(8323),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(8323),
  },
  [3702] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(8325),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3703] = {
    [sym__expression] = STATE(3783),
    [sym_conditional_expression] = STATE(3783),
    [sym_assignment_expression] = STATE(3783),
    [sym_pointer_expression] = STATE(3783),
    [sym_logical_expression] = STATE(3783),
    [sym_bitwise_expression] = STATE(3783),
    [sym_equality_expression] = STATE(3783),
    [sym_relational_expression] = STATE(3783),
    [sym_shift_expression] = STATE(3783),
    [sym_math_expression] = STATE(3783),
    [sym_cast_expression] = STATE(3783),
    [sym_sizeof_expression] = STATE(3783),
    [sym_subscript_expression] = STATE(3783),
    [sym_call_expression] = STATE(3783),
    [sym_field_expression] = STATE(3783),
    [sym_compound_literal_expression] = STATE(3783),
    [sym_parenthesized_expression] = STATE(3783),
    [sym_char_literal] = STATE(3783),
    [sym_concatenated_string] = STATE(3783),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3783),
    [sym_new_expression] = STATE(3783),
    [sym_delete_expression] = STATE(3783),
    [sym_lambda_expression] = STATE(3783),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8327),
    [anon_sym_SEMI] = ACTIONS(8325),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(8327),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8329),
    [sym_false] = ACTIONS(8329),
    [sym_null] = ACTIONS(8329),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(8329),
  },
  [3704] = {
    [sym__expression] = STATE(3784),
    [sym_conditional_expression] = STATE(3784),
    [sym_assignment_expression] = STATE(3784),
    [sym_pointer_expression] = STATE(3784),
    [sym_logical_expression] = STATE(3784),
    [sym_bitwise_expression] = STATE(3784),
    [sym_equality_expression] = STATE(3784),
    [sym_relational_expression] = STATE(3784),
    [sym_shift_expression] = STATE(3784),
    [sym_math_expression] = STATE(3784),
    [sym_cast_expression] = STATE(3784),
    [sym_sizeof_expression] = STATE(3784),
    [sym_subscript_expression] = STATE(3784),
    [sym_call_expression] = STATE(3784),
    [sym_field_expression] = STATE(3784),
    [sym_compound_literal_expression] = STATE(3784),
    [sym_parenthesized_expression] = STATE(3784),
    [sym_char_literal] = STATE(3784),
    [sym_concatenated_string] = STATE(3784),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3784),
    [sym_new_expression] = STATE(3784),
    [sym_delete_expression] = STATE(3784),
    [sym_lambda_expression] = STATE(3784),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8331),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(8331),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8333),
    [sym_false] = ACTIONS(8333),
    [sym_null] = ACTIONS(8333),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(8333),
  },
  [3705] = {
    [sym_catch_clause] = STATE(3705),
    [aux_sym_try_statement_repeat1] = STATE(3705),
    [sym_raw_string_literal] = ACTIONS(4993),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4995),
    [sym_preproc_directive] = ACTIONS(4995),
    [anon_sym_SEMI] = ACTIONS(4993),
    [anon_sym_typedef] = ACTIONS(4995),
    [anon_sym_extern] = ACTIONS(4995),
    [anon_sym_LBRACE] = ACTIONS(4993),
    [anon_sym_LPAREN2] = ACTIONS(4993),
    [anon_sym_STAR] = ACTIONS(4993),
    [anon_sym_LBRACK] = ACTIONS(4993),
    [anon_sym_static] = ACTIONS(4995),
    [anon_sym_register] = ACTIONS(4995),
    [anon_sym_inline] = ACTIONS(4995),
    [anon_sym_const] = ACTIONS(4995),
    [anon_sym_restrict] = ACTIONS(4995),
    [anon_sym_volatile] = ACTIONS(4995),
    [anon_sym__Atomic] = ACTIONS(4995),
    [anon_sym_mutable] = ACTIONS(4995),
    [anon_sym_explicit] = ACTIONS(4995),
    [anon_sym_constexpr] = ACTIONS(4995),
    [anon_sym_unsigned] = ACTIONS(4995),
    [anon_sym_long] = ACTIONS(4995),
    [anon_sym_short] = ACTIONS(4995),
    [sym_primitive_type] = ACTIONS(4995),
    [anon_sym_enum] = ACTIONS(4995),
    [anon_sym_struct] = ACTIONS(4995),
    [anon_sym_union] = ACTIONS(4995),
    [anon_sym_if] = ACTIONS(4995),
    [anon_sym_else] = ACTIONS(4995),
    [anon_sym_switch] = ACTIONS(4995),
    [anon_sym_case] = ACTIONS(4995),
    [anon_sym_default] = ACTIONS(4995),
    [anon_sym_while] = ACTIONS(4995),
    [anon_sym_do] = ACTIONS(4995),
    [anon_sym_for] = ACTIONS(4995),
    [anon_sym_return] = ACTIONS(4995),
    [anon_sym_break] = ACTIONS(4995),
    [anon_sym_continue] = ACTIONS(4995),
    [anon_sym_goto] = ACTIONS(4995),
    [anon_sym_AMP] = ACTIONS(4995),
    [anon_sym_AMP_AMP] = ACTIONS(4993),
    [anon_sym_BANG] = ACTIONS(4993),
    [anon_sym_TILDE] = ACTIONS(4993),
    [anon_sym_PLUS] = ACTIONS(4995),
    [anon_sym_DASH] = ACTIONS(4995),
    [anon_sym_DASH_DASH] = ACTIONS(4993),
    [anon_sym_PLUS_PLUS] = ACTIONS(4993),
    [anon_sym_sizeof] = ACTIONS(4995),
    [sym_number_literal] = ACTIONS(4993),
    [anon_sym_SQUOTE] = ACTIONS(4993),
    [anon_sym_DQUOTE] = ACTIONS(4993),
    [sym_true] = ACTIONS(4995),
    [sym_false] = ACTIONS(4995),
    [sym_null] = ACTIONS(4995),
    [sym_identifier] = ACTIONS(4995),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4995),
    [sym_auto] = ACTIONS(4995),
    [anon_sym_typename] = ACTIONS(4995),
    [anon_sym_template] = ACTIONS(4995),
    [anon_sym_delete] = ACTIONS(4995),
    [anon_sym_namespace] = ACTIONS(4995),
    [anon_sym_using] = ACTIONS(4995),
    [anon_sym_try] = ACTIONS(4995),
    [anon_sym_catch] = ACTIONS(7340),
    [anon_sym_new] = ACTIONS(4995),
    [anon_sym_COLON_COLON] = ACTIONS(4993),
    [sym_operator_name] = ACTIONS(4993),
    [sym_nullptr] = ACTIONS(4995),
  },
  [3706] = {
    [sym_raw_string_literal] = ACTIONS(7906),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7908),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7908),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7908),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7908),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7908),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7908),
    [sym_preproc_directive] = ACTIONS(7908),
    [anon_sym_SEMI] = ACTIONS(7906),
    [anon_sym_typedef] = ACTIONS(7908),
    [anon_sym_extern] = ACTIONS(7908),
    [anon_sym_LBRACE] = ACTIONS(7906),
    [anon_sym_LPAREN2] = ACTIONS(7906),
    [anon_sym_STAR] = ACTIONS(7906),
    [anon_sym_LBRACK] = ACTIONS(7906),
    [anon_sym_static] = ACTIONS(7908),
    [anon_sym_register] = ACTIONS(7908),
    [anon_sym_inline] = ACTIONS(7908),
    [anon_sym_const] = ACTIONS(7908),
    [anon_sym_restrict] = ACTIONS(7908),
    [anon_sym_volatile] = ACTIONS(7908),
    [anon_sym__Atomic] = ACTIONS(7908),
    [anon_sym_mutable] = ACTIONS(7908),
    [anon_sym_explicit] = ACTIONS(7908),
    [anon_sym_constexpr] = ACTIONS(7908),
    [anon_sym_unsigned] = ACTIONS(7908),
    [anon_sym_long] = ACTIONS(7908),
    [anon_sym_short] = ACTIONS(7908),
    [sym_primitive_type] = ACTIONS(7908),
    [anon_sym_enum] = ACTIONS(7908),
    [anon_sym_struct] = ACTIONS(7908),
    [anon_sym_union] = ACTIONS(7908),
    [anon_sym_if] = ACTIONS(7908),
    [anon_sym_else] = ACTIONS(7908),
    [anon_sym_switch] = ACTIONS(7908),
    [anon_sym_case] = ACTIONS(7908),
    [anon_sym_default] = ACTIONS(7908),
    [anon_sym_while] = ACTIONS(7908),
    [anon_sym_do] = ACTIONS(7908),
    [anon_sym_for] = ACTIONS(7908),
    [anon_sym_return] = ACTIONS(7908),
    [anon_sym_break] = ACTIONS(7908),
    [anon_sym_continue] = ACTIONS(7908),
    [anon_sym_goto] = ACTIONS(7908),
    [anon_sym_AMP] = ACTIONS(7908),
    [anon_sym_AMP_AMP] = ACTIONS(7906),
    [anon_sym_BANG] = ACTIONS(7906),
    [anon_sym_TILDE] = ACTIONS(7906),
    [anon_sym_PLUS] = ACTIONS(7908),
    [anon_sym_DASH] = ACTIONS(7908),
    [anon_sym_DASH_DASH] = ACTIONS(7906),
    [anon_sym_PLUS_PLUS] = ACTIONS(7906),
    [anon_sym_sizeof] = ACTIONS(7908),
    [sym_number_literal] = ACTIONS(7906),
    [anon_sym_SQUOTE] = ACTIONS(7906),
    [anon_sym_DQUOTE] = ACTIONS(7906),
    [sym_true] = ACTIONS(7908),
    [sym_false] = ACTIONS(7908),
    [sym_null] = ACTIONS(7908),
    [sym_identifier] = ACTIONS(7908),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7908),
    [sym_auto] = ACTIONS(7908),
    [anon_sym_typename] = ACTIONS(7908),
    [anon_sym_template] = ACTIONS(7908),
    [anon_sym_delete] = ACTIONS(7908),
    [anon_sym_namespace] = ACTIONS(7908),
    [anon_sym_using] = ACTIONS(7908),
    [anon_sym_try] = ACTIONS(7908),
    [anon_sym_new] = ACTIONS(7908),
    [anon_sym_COLON_COLON] = ACTIONS(7906),
    [sym_operator_name] = ACTIONS(7906),
    [sym_nullptr] = ACTIONS(7908),
  },
  [3707] = {
    [sym_raw_string_literal] = ACTIONS(7928),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7930),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7930),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7930),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7930),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7930),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7930),
    [sym_preproc_directive] = ACTIONS(7930),
    [anon_sym_SEMI] = ACTIONS(7928),
    [anon_sym_typedef] = ACTIONS(7930),
    [anon_sym_extern] = ACTIONS(7930),
    [anon_sym_LBRACE] = ACTIONS(7928),
    [anon_sym_LPAREN2] = ACTIONS(7928),
    [anon_sym_STAR] = ACTIONS(7928),
    [anon_sym_LBRACK] = ACTIONS(7928),
    [anon_sym_static] = ACTIONS(7930),
    [anon_sym_register] = ACTIONS(7930),
    [anon_sym_inline] = ACTIONS(7930),
    [anon_sym_const] = ACTIONS(7930),
    [anon_sym_restrict] = ACTIONS(7930),
    [anon_sym_volatile] = ACTIONS(7930),
    [anon_sym__Atomic] = ACTIONS(7930),
    [anon_sym_mutable] = ACTIONS(7930),
    [anon_sym_explicit] = ACTIONS(7930),
    [anon_sym_constexpr] = ACTIONS(7930),
    [anon_sym_unsigned] = ACTIONS(7930),
    [anon_sym_long] = ACTIONS(7930),
    [anon_sym_short] = ACTIONS(7930),
    [sym_primitive_type] = ACTIONS(7930),
    [anon_sym_enum] = ACTIONS(7930),
    [anon_sym_struct] = ACTIONS(7930),
    [anon_sym_union] = ACTIONS(7930),
    [anon_sym_if] = ACTIONS(7930),
    [anon_sym_else] = ACTIONS(7930),
    [anon_sym_switch] = ACTIONS(7930),
    [anon_sym_case] = ACTIONS(7930),
    [anon_sym_default] = ACTIONS(7930),
    [anon_sym_while] = ACTIONS(7930),
    [anon_sym_do] = ACTIONS(7930),
    [anon_sym_for] = ACTIONS(7930),
    [anon_sym_return] = ACTIONS(7930),
    [anon_sym_break] = ACTIONS(7930),
    [anon_sym_continue] = ACTIONS(7930),
    [anon_sym_goto] = ACTIONS(7930),
    [anon_sym_AMP] = ACTIONS(7930),
    [anon_sym_AMP_AMP] = ACTIONS(7928),
    [anon_sym_BANG] = ACTIONS(7928),
    [anon_sym_TILDE] = ACTIONS(7928),
    [anon_sym_PLUS] = ACTIONS(7930),
    [anon_sym_DASH] = ACTIONS(7930),
    [anon_sym_DASH_DASH] = ACTIONS(7928),
    [anon_sym_PLUS_PLUS] = ACTIONS(7928),
    [anon_sym_sizeof] = ACTIONS(7930),
    [sym_number_literal] = ACTIONS(7928),
    [anon_sym_SQUOTE] = ACTIONS(7928),
    [anon_sym_DQUOTE] = ACTIONS(7928),
    [sym_true] = ACTIONS(7930),
    [sym_false] = ACTIONS(7930),
    [sym_null] = ACTIONS(7930),
    [sym_identifier] = ACTIONS(7930),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7930),
    [sym_auto] = ACTIONS(7930),
    [anon_sym_typename] = ACTIONS(7930),
    [anon_sym_template] = ACTIONS(7930),
    [anon_sym_delete] = ACTIONS(7930),
    [anon_sym_namespace] = ACTIONS(7930),
    [anon_sym_using] = ACTIONS(7930),
    [anon_sym_try] = ACTIONS(7930),
    [anon_sym_new] = ACTIONS(7930),
    [anon_sym_COLON_COLON] = ACTIONS(7928),
    [sym_operator_name] = ACTIONS(7928),
    [sym_nullptr] = ACTIONS(7930),
  },
  [3708] = {
    [sym_compound_statement] = STATE(3785),
    [sym_labeled_statement] = STATE(3785),
    [sym_expression_statement] = STATE(3785),
    [sym_if_statement] = STATE(3785),
    [sym_switch_statement] = STATE(3785),
    [sym_case_statement] = STATE(3785),
    [sym_while_statement] = STATE(3785),
    [sym_do_statement] = STATE(3785),
    [sym_for_statement] = STATE(3785),
    [sym_return_statement] = STATE(3785),
    [sym_break_statement] = STATE(3785),
    [sym_continue_statement] = STATE(3785),
    [sym_goto_statement] = STATE(3785),
    [sym__expression] = STATE(1020),
    [sym_comma_expression] = STATE(1021),
    [sym_conditional_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1020),
    [sym_pointer_expression] = STATE(1020),
    [sym_logical_expression] = STATE(1020),
    [sym_bitwise_expression] = STATE(1020),
    [sym_equality_expression] = STATE(1020),
    [sym_relational_expression] = STATE(1020),
    [sym_shift_expression] = STATE(1020),
    [sym_math_expression] = STATE(1020),
    [sym_cast_expression] = STATE(1020),
    [sym_sizeof_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_field_expression] = STATE(1020),
    [sym_compound_literal_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_char_literal] = STATE(1020),
    [sym_concatenated_string] = STATE(1020),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1020),
    [sym_for_range_loop] = STATE(3785),
    [sym_try_statement] = STATE(3785),
    [sym_new_expression] = STATE(1020),
    [sym_delete_expression] = STATE(1020),
    [sym_lambda_expression] = STATE(1020),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2022),
    [anon_sym_SEMI] = ACTIONS(2036),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(2044),
    [anon_sym_switch] = ACTIONS(2046),
    [anon_sym_case] = ACTIONS(2048),
    [anon_sym_default] = ACTIONS(2050),
    [anon_sym_while] = ACTIONS(2052),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(2056),
    [anon_sym_return] = ACTIONS(2058),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2062),
    [anon_sym_goto] = ACTIONS(2064),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(5420),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2076),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2066),
  },
  [3709] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8335),
    [sym_comment] = ACTIONS(91),
  },
  [3710] = {
    [sym_raw_string_literal] = ACTIONS(6091),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6093),
    [sym_preproc_directive] = ACTIONS(6093),
    [anon_sym_SEMI] = ACTIONS(6091),
    [anon_sym_typedef] = ACTIONS(6093),
    [anon_sym_extern] = ACTIONS(6093),
    [anon_sym_LBRACE] = ACTIONS(6091),
    [anon_sym_LPAREN2] = ACTIONS(6091),
    [anon_sym_STAR] = ACTIONS(6091),
    [anon_sym_LBRACK] = ACTIONS(6091),
    [anon_sym_static] = ACTIONS(6093),
    [anon_sym_register] = ACTIONS(6093),
    [anon_sym_inline] = ACTIONS(6093),
    [anon_sym_const] = ACTIONS(6093),
    [anon_sym_restrict] = ACTIONS(6093),
    [anon_sym_volatile] = ACTIONS(6093),
    [anon_sym__Atomic] = ACTIONS(6093),
    [anon_sym_mutable] = ACTIONS(6093),
    [anon_sym_explicit] = ACTIONS(6093),
    [anon_sym_constexpr] = ACTIONS(6093),
    [anon_sym_unsigned] = ACTIONS(6093),
    [anon_sym_long] = ACTIONS(6093),
    [anon_sym_short] = ACTIONS(6093),
    [sym_primitive_type] = ACTIONS(6093),
    [anon_sym_enum] = ACTIONS(6093),
    [anon_sym_struct] = ACTIONS(6093),
    [anon_sym_union] = ACTIONS(6093),
    [anon_sym_if] = ACTIONS(6093),
    [anon_sym_else] = ACTIONS(8337),
    [anon_sym_switch] = ACTIONS(6093),
    [anon_sym_case] = ACTIONS(6093),
    [anon_sym_default] = ACTIONS(6093),
    [anon_sym_while] = ACTIONS(6093),
    [anon_sym_do] = ACTIONS(6093),
    [anon_sym_for] = ACTIONS(6093),
    [anon_sym_return] = ACTIONS(6093),
    [anon_sym_break] = ACTIONS(6093),
    [anon_sym_continue] = ACTIONS(6093),
    [anon_sym_goto] = ACTIONS(6093),
    [anon_sym_AMP] = ACTIONS(6093),
    [anon_sym_AMP_AMP] = ACTIONS(6091),
    [anon_sym_BANG] = ACTIONS(6091),
    [anon_sym_TILDE] = ACTIONS(6091),
    [anon_sym_PLUS] = ACTIONS(6093),
    [anon_sym_DASH] = ACTIONS(6093),
    [anon_sym_DASH_DASH] = ACTIONS(6091),
    [anon_sym_PLUS_PLUS] = ACTIONS(6091),
    [anon_sym_sizeof] = ACTIONS(6093),
    [sym_number_literal] = ACTIONS(6091),
    [anon_sym_SQUOTE] = ACTIONS(6091),
    [anon_sym_DQUOTE] = ACTIONS(6091),
    [sym_true] = ACTIONS(6093),
    [sym_false] = ACTIONS(6093),
    [sym_null] = ACTIONS(6093),
    [sym_identifier] = ACTIONS(6093),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6093),
    [sym_auto] = ACTIONS(6093),
    [anon_sym_typename] = ACTIONS(6093),
    [anon_sym_template] = ACTIONS(6093),
    [anon_sym_delete] = ACTIONS(6093),
    [anon_sym_namespace] = ACTIONS(6093),
    [anon_sym_using] = ACTIONS(6093),
    [anon_sym_try] = ACTIONS(6093),
    [anon_sym_new] = ACTIONS(6093),
    [anon_sym_COLON_COLON] = ACTIONS(6091),
    [sym_operator_name] = ACTIONS(6091),
    [sym_nullptr] = ACTIONS(6093),
  },
  [3711] = {
    [sym_compound_statement] = STATE(3788),
    [sym_labeled_statement] = STATE(3788),
    [sym_expression_statement] = STATE(3788),
    [sym_if_statement] = STATE(3788),
    [sym_switch_statement] = STATE(3788),
    [sym_case_statement] = STATE(3788),
    [sym_while_statement] = STATE(3788),
    [sym_do_statement] = STATE(3788),
    [sym_for_statement] = STATE(3788),
    [sym_return_statement] = STATE(3788),
    [sym_break_statement] = STATE(3788),
    [sym_continue_statement] = STATE(3788),
    [sym_goto_statement] = STATE(3788),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(411),
    [sym_for_range_loop] = STATE(3788),
    [sym_try_statement] = STATE(3788),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(678),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(6682),
    [anon_sym_switch] = ACTIONS(6684),
    [anon_sym_case] = ACTIONS(6686),
    [anon_sym_default] = ACTIONS(6688),
    [anon_sym_while] = ACTIONS(6690),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(6692),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(6694),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(6696),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(726),
  },
  [3712] = {
    [sym_compound_statement] = STATE(3266),
    [sym_labeled_statement] = STATE(3266),
    [sym_expression_statement] = STATE(3266),
    [sym_if_statement] = STATE(3266),
    [sym_switch_statement] = STATE(3266),
    [sym_case_statement] = STATE(3266),
    [sym_while_statement] = STATE(3266),
    [sym_do_statement] = STATE(3266),
    [sym_for_statement] = STATE(3266),
    [sym_return_statement] = STATE(3266),
    [sym_break_statement] = STATE(3266),
    [sym_continue_statement] = STATE(3266),
    [sym_goto_statement] = STATE(3266),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(411),
    [sym_for_range_loop] = STATE(3266),
    [sym_try_statement] = STATE(3266),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(678),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(6682),
    [anon_sym_switch] = ACTIONS(6684),
    [anon_sym_case] = ACTIONS(6686),
    [anon_sym_default] = ACTIONS(6688),
    [anon_sym_while] = ACTIONS(6690),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(6692),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(6694),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(6696),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(726),
  },
  [3713] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3790),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8339),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3714] = {
    [sym__expression] = STATE(3791),
    [sym_conditional_expression] = STATE(3791),
    [sym_assignment_expression] = STATE(3791),
    [sym_pointer_expression] = STATE(3791),
    [sym_logical_expression] = STATE(3791),
    [sym_bitwise_expression] = STATE(3791),
    [sym_equality_expression] = STATE(3791),
    [sym_relational_expression] = STATE(3791),
    [sym_shift_expression] = STATE(3791),
    [sym_math_expression] = STATE(3791),
    [sym_cast_expression] = STATE(3791),
    [sym_sizeof_expression] = STATE(3791),
    [sym_subscript_expression] = STATE(3791),
    [sym_call_expression] = STATE(3791),
    [sym_field_expression] = STATE(3791),
    [sym_compound_literal_expression] = STATE(3791),
    [sym_parenthesized_expression] = STATE(3791),
    [sym_char_literal] = STATE(3791),
    [sym_concatenated_string] = STATE(3791),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3791),
    [sym_new_expression] = STATE(3791),
    [sym_delete_expression] = STATE(3791),
    [sym_lambda_expression] = STATE(3791),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8341),
    [anon_sym_RPAREN] = ACTIONS(8339),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(8341),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8343),
    [sym_false] = ACTIONS(8343),
    [sym_null] = ACTIONS(8343),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(8343),
  },
  [3715] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(8345),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3716] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(8347),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3717] = {
    [sym_raw_string_literal] = ACTIONS(8143),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(8145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(8145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(8145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(8145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(8145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(8145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(8145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(8145),
    [sym_preproc_directive] = ACTIONS(8145),
    [anon_sym_SEMI] = ACTIONS(8143),
    [anon_sym_typedef] = ACTIONS(8145),
    [anon_sym_extern] = ACTIONS(8145),
    [anon_sym_LBRACE] = ACTIONS(8143),
    [anon_sym_LPAREN2] = ACTIONS(8143),
    [anon_sym_STAR] = ACTIONS(8143),
    [anon_sym_LBRACK] = ACTIONS(8143),
    [anon_sym_static] = ACTIONS(8145),
    [anon_sym_register] = ACTIONS(8145),
    [anon_sym_inline] = ACTIONS(8145),
    [anon_sym_const] = ACTIONS(8145),
    [anon_sym_restrict] = ACTIONS(8145),
    [anon_sym_volatile] = ACTIONS(8145),
    [anon_sym__Atomic] = ACTIONS(8145),
    [anon_sym_mutable] = ACTIONS(8145),
    [anon_sym_explicit] = ACTIONS(8145),
    [anon_sym_constexpr] = ACTIONS(8145),
    [anon_sym_unsigned] = ACTIONS(8145),
    [anon_sym_long] = ACTIONS(8145),
    [anon_sym_short] = ACTIONS(8145),
    [sym_primitive_type] = ACTIONS(8145),
    [anon_sym_enum] = ACTIONS(8145),
    [anon_sym_struct] = ACTIONS(8145),
    [anon_sym_union] = ACTIONS(8145),
    [anon_sym_if] = ACTIONS(8145),
    [anon_sym_else] = ACTIONS(8145),
    [anon_sym_switch] = ACTIONS(8145),
    [anon_sym_case] = ACTIONS(8145),
    [anon_sym_default] = ACTIONS(8145),
    [anon_sym_while] = ACTIONS(8145),
    [anon_sym_do] = ACTIONS(8145),
    [anon_sym_for] = ACTIONS(8145),
    [anon_sym_return] = ACTIONS(8145),
    [anon_sym_break] = ACTIONS(8145),
    [anon_sym_continue] = ACTIONS(8145),
    [anon_sym_goto] = ACTIONS(8145),
    [anon_sym_AMP] = ACTIONS(8145),
    [anon_sym_AMP_AMP] = ACTIONS(8143),
    [anon_sym_BANG] = ACTIONS(8143),
    [anon_sym_TILDE] = ACTIONS(8143),
    [anon_sym_PLUS] = ACTIONS(8145),
    [anon_sym_DASH] = ACTIONS(8145),
    [anon_sym_DASH_DASH] = ACTIONS(8143),
    [anon_sym_PLUS_PLUS] = ACTIONS(8143),
    [anon_sym_sizeof] = ACTIONS(8145),
    [sym_number_literal] = ACTIONS(8143),
    [anon_sym_SQUOTE] = ACTIONS(8143),
    [anon_sym_DQUOTE] = ACTIONS(8143),
    [sym_true] = ACTIONS(8145),
    [sym_false] = ACTIONS(8145),
    [sym_null] = ACTIONS(8145),
    [sym_identifier] = ACTIONS(8145),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(8145),
    [sym_auto] = ACTIONS(8145),
    [anon_sym_typename] = ACTIONS(8145),
    [anon_sym_template] = ACTIONS(8145),
    [anon_sym_delete] = ACTIONS(8145),
    [anon_sym_namespace] = ACTIONS(8145),
    [anon_sym_using] = ACTIONS(8145),
    [anon_sym_try] = ACTIONS(8145),
    [anon_sym_new] = ACTIONS(8145),
    [anon_sym_COLON_COLON] = ACTIONS(8143),
    [sym_operator_name] = ACTIONS(8143),
    [sym_nullptr] = ACTIONS(8145),
  },
  [3718] = {
    [sym_compound_statement] = STATE(3794),
    [sym_labeled_statement] = STATE(3794),
    [sym_expression_statement] = STATE(3794),
    [sym_if_statement] = STATE(3794),
    [sym_switch_statement] = STATE(3794),
    [sym_case_statement] = STATE(3794),
    [sym_while_statement] = STATE(3794),
    [sym_do_statement] = STATE(3794),
    [sym_for_statement] = STATE(3794),
    [sym_return_statement] = STATE(3794),
    [sym_break_statement] = STATE(3794),
    [sym_continue_statement] = STATE(3794),
    [sym_goto_statement] = STATE(3794),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(411),
    [sym_for_range_loop] = STATE(3794),
    [sym_try_statement] = STATE(3794),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(678),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(704),
    [anon_sym_switch] = ACTIONS(706),
    [anon_sym_case] = ACTIONS(708),
    [anon_sym_default] = ACTIONS(710),
    [anon_sym_while] = ACTIONS(712),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(3807),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(736),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(726),
  },
  [3719] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(8349),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3720] = {
    [sym__expression] = STATE(3796),
    [sym_conditional_expression] = STATE(3796),
    [sym_assignment_expression] = STATE(3796),
    [sym_pointer_expression] = STATE(3796),
    [sym_logical_expression] = STATE(3796),
    [sym_bitwise_expression] = STATE(3796),
    [sym_equality_expression] = STATE(3796),
    [sym_relational_expression] = STATE(3796),
    [sym_shift_expression] = STATE(3796),
    [sym_math_expression] = STATE(3796),
    [sym_cast_expression] = STATE(3796),
    [sym_sizeof_expression] = STATE(3796),
    [sym_subscript_expression] = STATE(3796),
    [sym_call_expression] = STATE(3796),
    [sym_field_expression] = STATE(3796),
    [sym_compound_literal_expression] = STATE(3796),
    [sym_parenthesized_expression] = STATE(3796),
    [sym_char_literal] = STATE(3796),
    [sym_concatenated_string] = STATE(3796),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3796),
    [sym_new_expression] = STATE(3796),
    [sym_delete_expression] = STATE(3796),
    [sym_lambda_expression] = STATE(3796),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8351),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(8351),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8353),
    [sym_false] = ACTIONS(8353),
    [sym_null] = ACTIONS(8353),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(8353),
  },
  [3721] = {
    [sym_declaration] = STATE(3287),
    [sym_type_definition] = STATE(3287),
    [sym__declaration_specifiers] = STATE(3015),
    [sym_compound_statement] = STATE(3287),
    [sym_storage_class_specifier] = STATE(286),
    [sym_type_qualifier] = STATE(286),
    [sym__type_specifier] = STATE(282),
    [sym_sized_type_specifier] = STATE(282),
    [sym_enum_specifier] = STATE(282),
    [sym_struct_specifier] = STATE(282),
    [sym_union_specifier] = STATE(282),
    [sym_labeled_statement] = STATE(3287),
    [sym_expression_statement] = STATE(3287),
    [sym_if_statement] = STATE(3287),
    [sym_switch_statement] = STATE(3287),
    [sym_case_statement] = STATE(3287),
    [sym_while_statement] = STATE(3287),
    [sym_do_statement] = STATE(3287),
    [sym_for_statement] = STATE(3287),
    [sym_return_statement] = STATE(3287),
    [sym_break_statement] = STATE(3287),
    [sym_continue_statement] = STATE(3287),
    [sym_goto_statement] = STATE(3287),
    [sym__expression] = STATE(1908),
    [sym_comma_expression] = STATE(1909),
    [sym_conditional_expression] = STATE(1908),
    [sym_assignment_expression] = STATE(1908),
    [sym_pointer_expression] = STATE(1908),
    [sym_logical_expression] = STATE(1908),
    [sym_bitwise_expression] = STATE(1908),
    [sym_equality_expression] = STATE(1908),
    [sym_relational_expression] = STATE(1908),
    [sym_shift_expression] = STATE(1908),
    [sym_math_expression] = STATE(1908),
    [sym_cast_expression] = STATE(1908),
    [sym_sizeof_expression] = STATE(1908),
    [sym_subscript_expression] = STATE(1908),
    [sym_call_expression] = STATE(1908),
    [sym_field_expression] = STATE(1908),
    [sym_compound_literal_expression] = STATE(1908),
    [sym_parenthesized_expression] = STATE(1908),
    [sym_char_literal] = STATE(1908),
    [sym_concatenated_string] = STATE(1908),
    [sym_string_literal] = STATE(55),
    [sym_macro_type_specifier] = STATE(282),
    [sym_class_specifier] = STATE(282),
    [sym_dependent_type] = STATE(282),
    [sym_template_type] = STATE(683),
    [sym_template_function] = STATE(1908),
    [sym_for_range_loop] = STATE(3287),
    [sym_try_statement] = STATE(3287),
    [sym_new_expression] = STATE(1908),
    [sym_delete_expression] = STATE(1908),
    [sym_lambda_expression] = STATE(1908),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(60),
    [sym_scoped_namespace_identifier] = STATE(684),
    [aux_sym__declaration_specifiers_repeat1] = STATE(286),
    [aux_sym_sized_type_specifier_repeat1] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(3996),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_typedef] = ACTIONS(4012),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_register] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(133),
    [anon_sym_restrict] = ACTIONS(133),
    [anon_sym_volatile] = ACTIONS(133),
    [anon_sym__Atomic] = ACTIONS(133),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_explicit] = ACTIONS(133),
    [anon_sym_constexpr] = ACTIONS(133),
    [anon_sym_unsigned] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [sym_primitive_type] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
    [anon_sym_union] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(7766),
    [anon_sym_switch] = ACTIONS(7768),
    [anon_sym_case] = ACTIONS(7770),
    [anon_sym_default] = ACTIONS(7772),
    [anon_sym_while] = ACTIONS(7774),
    [anon_sym_do] = ACTIONS(4026),
    [anon_sym_for] = ACTIONS(7776),
    [anon_sym_return] = ACTIONS(4030),
    [anon_sym_break] = ACTIONS(4032),
    [anon_sym_continue] = ACTIONS(4034),
    [anon_sym_goto] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(3996),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4038),
    [sym_false] = ACTIONS(4038),
    [sym_null] = ACTIONS(4038),
    [sym_identifier] = ACTIONS(8215),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(93),
    [sym_auto] = ACTIONS(498),
    [anon_sym_typename] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7780),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(1202),
    [sym_nullptr] = ACTIONS(4038),
  },
  [3722] = {
    [sym_initializer_list] = STATE(262),
    [sym_template_argument_list] = STATE(1362),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_extern] = ACTIONS(468),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LPAREN2] = ACTIONS(465),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_register] = ACTIONS(468),
    [anon_sym_inline] = ACTIONS(468),
    [anon_sym_const] = ACTIONS(468),
    [anon_sym_restrict] = ACTIONS(468),
    [anon_sym_volatile] = ACTIONS(468),
    [anon_sym__Atomic] = ACTIONS(468),
    [anon_sym_mutable] = ACTIONS(468),
    [anon_sym_explicit] = ACTIONS(468),
    [anon_sym_constexpr] = ACTIONS(468),
    [anon_sym_COLON] = ACTIONS(8026),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(474),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_TILDE] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [sym_identifier] = ACTIONS(468),
    [sym_comment] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(2855),
    [sym_operator_name] = ACTIONS(481),
  },
  [3723] = {
    [sym__expression] = STATE(3798),
    [sym_conditional_expression] = STATE(3798),
    [sym_assignment_expression] = STATE(3798),
    [sym_pointer_expression] = STATE(3798),
    [sym_logical_expression] = STATE(3798),
    [sym_bitwise_expression] = STATE(3798),
    [sym_equality_expression] = STATE(3798),
    [sym_relational_expression] = STATE(3798),
    [sym_shift_expression] = STATE(3798),
    [sym_math_expression] = STATE(3798),
    [sym_cast_expression] = STATE(3798),
    [sym_sizeof_expression] = STATE(3798),
    [sym_subscript_expression] = STATE(3798),
    [sym_call_expression] = STATE(3798),
    [sym_field_expression] = STATE(3798),
    [sym_compound_literal_expression] = STATE(3798),
    [sym_parenthesized_expression] = STATE(3798),
    [sym_char_literal] = STATE(3798),
    [sym_concatenated_string] = STATE(3798),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3798),
    [sym_new_expression] = STATE(3798),
    [sym_delete_expression] = STATE(3798),
    [sym_lambda_expression] = STATE(3798),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8355),
    [anon_sym_SEMI] = ACTIONS(8357),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(8355),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8359),
    [sym_false] = ACTIONS(8359),
    [sym_null] = ACTIONS(8359),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(8359),
  },
  [3724] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(8361),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3725] = {
    [anon_sym_COLON] = ACTIONS(8363),
    [sym_comment] = ACTIONS(91),
  },
  [3726] = {
    [sym_catch_clause] = STATE(3801),
    [aux_sym_try_statement_repeat1] = STATE(3801),
    [sym_raw_string_literal] = ACTIONS(3346),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3348),
    [sym_preproc_directive] = ACTIONS(3348),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym_typedef] = ACTIONS(3348),
    [anon_sym_extern] = ACTIONS(3348),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_STAR] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(3346),
    [anon_sym_static] = ACTIONS(3348),
    [anon_sym_register] = ACTIONS(3348),
    [anon_sym_inline] = ACTIONS(3348),
    [anon_sym_const] = ACTIONS(3348),
    [anon_sym_restrict] = ACTIONS(3348),
    [anon_sym_volatile] = ACTIONS(3348),
    [anon_sym__Atomic] = ACTIONS(3348),
    [anon_sym_mutable] = ACTIONS(3348),
    [anon_sym_explicit] = ACTIONS(3348),
    [anon_sym_constexpr] = ACTIONS(3348),
    [anon_sym_unsigned] = ACTIONS(3348),
    [anon_sym_long] = ACTIONS(3348),
    [anon_sym_short] = ACTIONS(3348),
    [sym_primitive_type] = ACTIONS(3348),
    [anon_sym_enum] = ACTIONS(3348),
    [anon_sym_struct] = ACTIONS(3348),
    [anon_sym_union] = ACTIONS(3348),
    [anon_sym_if] = ACTIONS(3348),
    [anon_sym_else] = ACTIONS(3348),
    [anon_sym_switch] = ACTIONS(3348),
    [anon_sym_case] = ACTIONS(3348),
    [anon_sym_default] = ACTIONS(3348),
    [anon_sym_while] = ACTIONS(3348),
    [anon_sym_do] = ACTIONS(3348),
    [anon_sym_for] = ACTIONS(3348),
    [anon_sym_return] = ACTIONS(3348),
    [anon_sym_break] = ACTIONS(3348),
    [anon_sym_continue] = ACTIONS(3348),
    [anon_sym_goto] = ACTIONS(3348),
    [anon_sym_AMP] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_PLUS] = ACTIONS(3348),
    [anon_sym_DASH] = ACTIONS(3348),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_sizeof] = ACTIONS(3348),
    [sym_number_literal] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [sym_true] = ACTIONS(3348),
    [sym_false] = ACTIONS(3348),
    [sym_null] = ACTIONS(3348),
    [sym_identifier] = ACTIONS(3348),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(3348),
    [sym_auto] = ACTIONS(3348),
    [anon_sym_typename] = ACTIONS(3348),
    [anon_sym_delete] = ACTIONS(3348),
    [anon_sym_try] = ACTIONS(3348),
    [anon_sym_catch] = ACTIONS(7417),
    [anon_sym_new] = ACTIONS(3348),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [sym_nullptr] = ACTIONS(3348),
  },
  [3727] = {
    [sym_raw_string_literal] = ACTIONS(7561),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7563),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7563),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7563),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7563),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7563),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7563),
    [sym_preproc_directive] = ACTIONS(7563),
    [anon_sym_SEMI] = ACTIONS(7561),
    [anon_sym_typedef] = ACTIONS(7563),
    [anon_sym_extern] = ACTIONS(7563),
    [anon_sym_LBRACE] = ACTIONS(7561),
    [anon_sym_LPAREN2] = ACTIONS(7561),
    [anon_sym_STAR] = ACTIONS(7561),
    [anon_sym_LBRACK] = ACTIONS(7561),
    [anon_sym_static] = ACTIONS(7563),
    [anon_sym_register] = ACTIONS(7563),
    [anon_sym_inline] = ACTIONS(7563),
    [anon_sym_const] = ACTIONS(7563),
    [anon_sym_restrict] = ACTIONS(7563),
    [anon_sym_volatile] = ACTIONS(7563),
    [anon_sym__Atomic] = ACTIONS(7563),
    [anon_sym_mutable] = ACTIONS(7563),
    [anon_sym_explicit] = ACTIONS(7563),
    [anon_sym_constexpr] = ACTIONS(7563),
    [anon_sym_unsigned] = ACTIONS(7563),
    [anon_sym_long] = ACTIONS(7563),
    [anon_sym_short] = ACTIONS(7563),
    [sym_primitive_type] = ACTIONS(7563),
    [anon_sym_enum] = ACTIONS(7563),
    [anon_sym_struct] = ACTIONS(7563),
    [anon_sym_union] = ACTIONS(7563),
    [anon_sym_if] = ACTIONS(7563),
    [anon_sym_else] = ACTIONS(7563),
    [anon_sym_switch] = ACTIONS(7563),
    [anon_sym_case] = ACTIONS(7563),
    [anon_sym_default] = ACTIONS(7563),
    [anon_sym_while] = ACTIONS(7563),
    [anon_sym_do] = ACTIONS(7563),
    [anon_sym_for] = ACTIONS(7563),
    [anon_sym_return] = ACTIONS(7563),
    [anon_sym_break] = ACTIONS(7563),
    [anon_sym_continue] = ACTIONS(7563),
    [anon_sym_goto] = ACTIONS(7563),
    [anon_sym_AMP] = ACTIONS(7561),
    [anon_sym_BANG] = ACTIONS(7561),
    [anon_sym_TILDE] = ACTIONS(7561),
    [anon_sym_PLUS] = ACTIONS(7563),
    [anon_sym_DASH] = ACTIONS(7563),
    [anon_sym_DASH_DASH] = ACTIONS(7561),
    [anon_sym_PLUS_PLUS] = ACTIONS(7561),
    [anon_sym_sizeof] = ACTIONS(7563),
    [sym_number_literal] = ACTIONS(7561),
    [anon_sym_SQUOTE] = ACTIONS(7561),
    [anon_sym_DQUOTE] = ACTIONS(7561),
    [sym_true] = ACTIONS(7563),
    [sym_false] = ACTIONS(7563),
    [sym_null] = ACTIONS(7563),
    [sym_identifier] = ACTIONS(7563),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7563),
    [sym_auto] = ACTIONS(7563),
    [anon_sym_typename] = ACTIONS(7563),
    [anon_sym_delete] = ACTIONS(7563),
    [anon_sym_try] = ACTIONS(7563),
    [anon_sym_new] = ACTIONS(7563),
    [anon_sym_COLON_COLON] = ACTIONS(7561),
    [sym_nullptr] = ACTIONS(7563),
  },
  [3728] = {
    [sym_compound_statement] = STATE(3802),
    [sym_labeled_statement] = STATE(3802),
    [sym_expression_statement] = STATE(3802),
    [sym_if_statement] = STATE(3802),
    [sym_switch_statement] = STATE(3802),
    [sym_case_statement] = STATE(3802),
    [sym_while_statement] = STATE(3802),
    [sym_do_statement] = STATE(3802),
    [sym_for_statement] = STATE(3802),
    [sym_return_statement] = STATE(3802),
    [sym_break_statement] = STATE(3802),
    [sym_continue_statement] = STATE(3802),
    [sym_goto_statement] = STATE(3802),
    [sym__expression] = STATE(1908),
    [sym_comma_expression] = STATE(1909),
    [sym_conditional_expression] = STATE(1908),
    [sym_assignment_expression] = STATE(1908),
    [sym_pointer_expression] = STATE(1908),
    [sym_logical_expression] = STATE(1908),
    [sym_bitwise_expression] = STATE(1908),
    [sym_equality_expression] = STATE(1908),
    [sym_relational_expression] = STATE(1908),
    [sym_shift_expression] = STATE(1908),
    [sym_math_expression] = STATE(1908),
    [sym_cast_expression] = STATE(1908),
    [sym_sizeof_expression] = STATE(1908),
    [sym_subscript_expression] = STATE(1908),
    [sym_call_expression] = STATE(1908),
    [sym_field_expression] = STATE(1908),
    [sym_compound_literal_expression] = STATE(1908),
    [sym_parenthesized_expression] = STATE(1908),
    [sym_char_literal] = STATE(1908),
    [sym_concatenated_string] = STATE(1908),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1908),
    [sym_for_range_loop] = STATE(3802),
    [sym_try_statement] = STATE(3802),
    [sym_new_expression] = STATE(1908),
    [sym_delete_expression] = STATE(1908),
    [sym_lambda_expression] = STATE(1908),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3996),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(4016),
    [anon_sym_switch] = ACTIONS(4018),
    [anon_sym_case] = ACTIONS(4020),
    [anon_sym_default] = ACTIONS(4022),
    [anon_sym_while] = ACTIONS(4024),
    [anon_sym_do] = ACTIONS(4026),
    [anon_sym_for] = ACTIONS(4028),
    [anon_sym_return] = ACTIONS(4030),
    [anon_sym_break] = ACTIONS(4032),
    [anon_sym_continue] = ACTIONS(4034),
    [anon_sym_goto] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(3996),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4038),
    [sym_false] = ACTIONS(4038),
    [sym_null] = ACTIONS(4038),
    [sym_identifier] = ACTIONS(6773),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(4042),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(4038),
  },
  [3729] = {
    [sym_raw_string_literal] = ACTIONS(7589),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7591),
    [sym_preproc_directive] = ACTIONS(7591),
    [anon_sym_SEMI] = ACTIONS(7589),
    [anon_sym_typedef] = ACTIONS(7591),
    [anon_sym_extern] = ACTIONS(7591),
    [anon_sym_LBRACE] = ACTIONS(7589),
    [anon_sym_LPAREN2] = ACTIONS(7589),
    [anon_sym_STAR] = ACTIONS(7589),
    [anon_sym_LBRACK] = ACTIONS(7589),
    [anon_sym_static] = ACTIONS(7591),
    [anon_sym_register] = ACTIONS(7591),
    [anon_sym_inline] = ACTIONS(7591),
    [anon_sym_const] = ACTIONS(7591),
    [anon_sym_restrict] = ACTIONS(7591),
    [anon_sym_volatile] = ACTIONS(7591),
    [anon_sym__Atomic] = ACTIONS(7591),
    [anon_sym_mutable] = ACTIONS(7591),
    [anon_sym_explicit] = ACTIONS(7591),
    [anon_sym_constexpr] = ACTIONS(7591),
    [anon_sym_unsigned] = ACTIONS(7591),
    [anon_sym_long] = ACTIONS(7591),
    [anon_sym_short] = ACTIONS(7591),
    [sym_primitive_type] = ACTIONS(7591),
    [anon_sym_enum] = ACTIONS(7591),
    [anon_sym_struct] = ACTIONS(7591),
    [anon_sym_union] = ACTIONS(7591),
    [anon_sym_if] = ACTIONS(7591),
    [anon_sym_else] = ACTIONS(7591),
    [anon_sym_switch] = ACTIONS(7591),
    [anon_sym_case] = ACTIONS(7591),
    [anon_sym_default] = ACTIONS(7591),
    [anon_sym_while] = ACTIONS(7591),
    [anon_sym_do] = ACTIONS(7591),
    [anon_sym_for] = ACTIONS(7591),
    [anon_sym_return] = ACTIONS(7591),
    [anon_sym_break] = ACTIONS(7591),
    [anon_sym_continue] = ACTIONS(7591),
    [anon_sym_goto] = ACTIONS(7591),
    [anon_sym_AMP] = ACTIONS(7589),
    [anon_sym_BANG] = ACTIONS(7589),
    [anon_sym_TILDE] = ACTIONS(7589),
    [anon_sym_PLUS] = ACTIONS(7591),
    [anon_sym_DASH] = ACTIONS(7591),
    [anon_sym_DASH_DASH] = ACTIONS(7589),
    [anon_sym_PLUS_PLUS] = ACTIONS(7589),
    [anon_sym_sizeof] = ACTIONS(7591),
    [sym_number_literal] = ACTIONS(7589),
    [anon_sym_SQUOTE] = ACTIONS(7589),
    [anon_sym_DQUOTE] = ACTIONS(7589),
    [sym_true] = ACTIONS(7591),
    [sym_false] = ACTIONS(7591),
    [sym_null] = ACTIONS(7591),
    [sym_identifier] = ACTIONS(7591),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7591),
    [sym_auto] = ACTIONS(7591),
    [anon_sym_typename] = ACTIONS(7591),
    [anon_sym_delete] = ACTIONS(7591),
    [anon_sym_try] = ACTIONS(7591),
    [anon_sym_new] = ACTIONS(7591),
    [anon_sym_COLON_COLON] = ACTIONS(7589),
    [sym_nullptr] = ACTIONS(7591),
  },
  [3730] = {
    [sym_compound_statement] = STATE(3803),
    [sym_labeled_statement] = STATE(3803),
    [sym_expression_statement] = STATE(3803),
    [sym_if_statement] = STATE(3803),
    [sym_switch_statement] = STATE(3803),
    [sym_case_statement] = STATE(3803),
    [sym_while_statement] = STATE(3803),
    [sym_do_statement] = STATE(3803),
    [sym_for_statement] = STATE(3803),
    [sym_return_statement] = STATE(3803),
    [sym_break_statement] = STATE(3803),
    [sym_continue_statement] = STATE(3803),
    [sym_goto_statement] = STATE(3803),
    [sym__expression] = STATE(1908),
    [sym_comma_expression] = STATE(1909),
    [sym_conditional_expression] = STATE(1908),
    [sym_assignment_expression] = STATE(1908),
    [sym_pointer_expression] = STATE(1908),
    [sym_logical_expression] = STATE(1908),
    [sym_bitwise_expression] = STATE(1908),
    [sym_equality_expression] = STATE(1908),
    [sym_relational_expression] = STATE(1908),
    [sym_shift_expression] = STATE(1908),
    [sym_math_expression] = STATE(1908),
    [sym_cast_expression] = STATE(1908),
    [sym_sizeof_expression] = STATE(1908),
    [sym_subscript_expression] = STATE(1908),
    [sym_call_expression] = STATE(1908),
    [sym_field_expression] = STATE(1908),
    [sym_compound_literal_expression] = STATE(1908),
    [sym_parenthesized_expression] = STATE(1908),
    [sym_char_literal] = STATE(1908),
    [sym_concatenated_string] = STATE(1908),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1908),
    [sym_for_range_loop] = STATE(3803),
    [sym_try_statement] = STATE(3803),
    [sym_new_expression] = STATE(1908),
    [sym_delete_expression] = STATE(1908),
    [sym_lambda_expression] = STATE(1908),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3996),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(4016),
    [anon_sym_switch] = ACTIONS(4018),
    [anon_sym_case] = ACTIONS(4020),
    [anon_sym_default] = ACTIONS(4022),
    [anon_sym_while] = ACTIONS(4024),
    [anon_sym_do] = ACTIONS(4026),
    [anon_sym_for] = ACTIONS(4028),
    [anon_sym_return] = ACTIONS(4030),
    [anon_sym_break] = ACTIONS(4032),
    [anon_sym_continue] = ACTIONS(4034),
    [anon_sym_goto] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(3996),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4038),
    [sym_false] = ACTIONS(4038),
    [sym_null] = ACTIONS(4038),
    [sym_identifier] = ACTIONS(6773),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(4042),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(4038),
  },
  [3731] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8365),
    [sym_comment] = ACTIONS(91),
  },
  [3732] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3805),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8365),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3733] = {
    [sym_raw_string_literal] = ACTIONS(7598),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7600),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7600),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7600),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7600),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7600),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7600),
    [sym_preproc_directive] = ACTIONS(7600),
    [anon_sym_SEMI] = ACTIONS(7598),
    [anon_sym_typedef] = ACTIONS(7600),
    [anon_sym_extern] = ACTIONS(7600),
    [anon_sym_LBRACE] = ACTIONS(7598),
    [anon_sym_LPAREN2] = ACTIONS(7598),
    [anon_sym_STAR] = ACTIONS(7598),
    [anon_sym_LBRACK] = ACTIONS(7598),
    [anon_sym_static] = ACTIONS(7600),
    [anon_sym_register] = ACTIONS(7600),
    [anon_sym_inline] = ACTIONS(7600),
    [anon_sym_const] = ACTIONS(7600),
    [anon_sym_restrict] = ACTIONS(7600),
    [anon_sym_volatile] = ACTIONS(7600),
    [anon_sym__Atomic] = ACTIONS(7600),
    [anon_sym_mutable] = ACTIONS(7600),
    [anon_sym_explicit] = ACTIONS(7600),
    [anon_sym_constexpr] = ACTIONS(7600),
    [anon_sym_unsigned] = ACTIONS(7600),
    [anon_sym_long] = ACTIONS(7600),
    [anon_sym_short] = ACTIONS(7600),
    [sym_primitive_type] = ACTIONS(7600),
    [anon_sym_enum] = ACTIONS(7600),
    [anon_sym_struct] = ACTIONS(7600),
    [anon_sym_union] = ACTIONS(7600),
    [anon_sym_if] = ACTIONS(7600),
    [anon_sym_else] = ACTIONS(7600),
    [anon_sym_switch] = ACTIONS(7600),
    [anon_sym_case] = ACTIONS(7600),
    [anon_sym_default] = ACTIONS(7600),
    [anon_sym_while] = ACTIONS(7600),
    [anon_sym_do] = ACTIONS(7600),
    [anon_sym_for] = ACTIONS(7600),
    [anon_sym_return] = ACTIONS(7600),
    [anon_sym_break] = ACTIONS(7600),
    [anon_sym_continue] = ACTIONS(7600),
    [anon_sym_goto] = ACTIONS(7600),
    [anon_sym_AMP] = ACTIONS(7598),
    [anon_sym_BANG] = ACTIONS(7598),
    [anon_sym_TILDE] = ACTIONS(7598),
    [anon_sym_PLUS] = ACTIONS(7600),
    [anon_sym_DASH] = ACTIONS(7600),
    [anon_sym_DASH_DASH] = ACTIONS(7598),
    [anon_sym_PLUS_PLUS] = ACTIONS(7598),
    [anon_sym_sizeof] = ACTIONS(7600),
    [sym_number_literal] = ACTIONS(7598),
    [anon_sym_SQUOTE] = ACTIONS(7598),
    [anon_sym_DQUOTE] = ACTIONS(7598),
    [sym_true] = ACTIONS(7600),
    [sym_false] = ACTIONS(7600),
    [sym_null] = ACTIONS(7600),
    [sym_identifier] = ACTIONS(7600),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7600),
    [sym_auto] = ACTIONS(7600),
    [anon_sym_typename] = ACTIONS(7600),
    [anon_sym_delete] = ACTIONS(7600),
    [anon_sym_try] = ACTIONS(7600),
    [anon_sym_new] = ACTIONS(7600),
    [anon_sym_COLON_COLON] = ACTIONS(7598),
    [sym_nullptr] = ACTIONS(7600),
  },
  [3734] = {
    [sym_compound_statement] = STATE(3806),
    [sym_labeled_statement] = STATE(3806),
    [sym_expression_statement] = STATE(3806),
    [sym_if_statement] = STATE(3806),
    [sym_switch_statement] = STATE(3806),
    [sym_case_statement] = STATE(3806),
    [sym_while_statement] = STATE(3806),
    [sym_do_statement] = STATE(3806),
    [sym_for_statement] = STATE(3806),
    [sym_return_statement] = STATE(3806),
    [sym_break_statement] = STATE(3806),
    [sym_continue_statement] = STATE(3806),
    [sym_goto_statement] = STATE(3806),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(3806),
    [sym_try_statement] = STATE(3806),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7431),
    [anon_sym_switch] = ACTIONS(7433),
    [anon_sym_case] = ACTIONS(7435),
    [anon_sym_default] = ACTIONS(7437),
    [anon_sym_while] = ACTIONS(7439),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(7441),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(7443),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7445),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2242),
  },
  [3735] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(8367),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3736] = {
    [sym__expression] = STATE(3809),
    [sym_conditional_expression] = STATE(3809),
    [sym_assignment_expression] = STATE(3809),
    [sym_pointer_expression] = STATE(3809),
    [sym_logical_expression] = STATE(3809),
    [sym_bitwise_expression] = STATE(3809),
    [sym_equality_expression] = STATE(3809),
    [sym_relational_expression] = STATE(3809),
    [sym_shift_expression] = STATE(3809),
    [sym_math_expression] = STATE(3809),
    [sym_cast_expression] = STATE(3809),
    [sym_sizeof_expression] = STATE(3809),
    [sym_subscript_expression] = STATE(3809),
    [sym_call_expression] = STATE(3809),
    [sym_field_expression] = STATE(3809),
    [sym_compound_literal_expression] = STATE(3809),
    [sym_parenthesized_expression] = STATE(3809),
    [sym_char_literal] = STATE(3809),
    [sym_concatenated_string] = STATE(3809),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3809),
    [sym_new_expression] = STATE(3809),
    [sym_delete_expression] = STATE(3809),
    [sym_lambda_expression] = STATE(3809),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8369),
    [anon_sym_RPAREN] = ACTIONS(8371),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(8369),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8373),
    [sym_false] = ACTIONS(8373),
    [sym_null] = ACTIONS(8373),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(8373),
  },
  [3737] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(8375),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3738] = {
    [sym__expression] = STATE(3811),
    [sym_conditional_expression] = STATE(3811),
    [sym_assignment_expression] = STATE(3811),
    [sym_pointer_expression] = STATE(3811),
    [sym_logical_expression] = STATE(3811),
    [sym_bitwise_expression] = STATE(3811),
    [sym_equality_expression] = STATE(3811),
    [sym_relational_expression] = STATE(3811),
    [sym_shift_expression] = STATE(3811),
    [sym_math_expression] = STATE(3811),
    [sym_cast_expression] = STATE(3811),
    [sym_sizeof_expression] = STATE(3811),
    [sym_subscript_expression] = STATE(3811),
    [sym_call_expression] = STATE(3811),
    [sym_field_expression] = STATE(3811),
    [sym_compound_literal_expression] = STATE(3811),
    [sym_parenthesized_expression] = STATE(3811),
    [sym_char_literal] = STATE(3811),
    [sym_concatenated_string] = STATE(3811),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3811),
    [sym_new_expression] = STATE(3811),
    [sym_delete_expression] = STATE(3811),
    [sym_lambda_expression] = STATE(3811),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8377),
    [anon_sym_SEMI] = ACTIONS(8375),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(8377),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8379),
    [sym_false] = ACTIONS(8379),
    [sym_null] = ACTIONS(8379),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(8379),
  },
  [3739] = {
    [sym__expression] = STATE(3812),
    [sym_conditional_expression] = STATE(3812),
    [sym_assignment_expression] = STATE(3812),
    [sym_pointer_expression] = STATE(3812),
    [sym_logical_expression] = STATE(3812),
    [sym_bitwise_expression] = STATE(3812),
    [sym_equality_expression] = STATE(3812),
    [sym_relational_expression] = STATE(3812),
    [sym_shift_expression] = STATE(3812),
    [sym_math_expression] = STATE(3812),
    [sym_cast_expression] = STATE(3812),
    [sym_sizeof_expression] = STATE(3812),
    [sym_subscript_expression] = STATE(3812),
    [sym_call_expression] = STATE(3812),
    [sym_field_expression] = STATE(3812),
    [sym_compound_literal_expression] = STATE(3812),
    [sym_parenthesized_expression] = STATE(3812),
    [sym_char_literal] = STATE(3812),
    [sym_concatenated_string] = STATE(3812),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3812),
    [sym_new_expression] = STATE(3812),
    [sym_delete_expression] = STATE(3812),
    [sym_lambda_expression] = STATE(3812),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8381),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(8381),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8383),
    [sym_false] = ACTIONS(8383),
    [sym_null] = ACTIONS(8383),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(8383),
  },
  [3740] = {
    [sym_catch_clause] = STATE(3740),
    [aux_sym_try_statement_repeat1] = STATE(3740),
    [sym_raw_string_literal] = ACTIONS(4993),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4995),
    [sym_preproc_directive] = ACTIONS(4995),
    [anon_sym_SEMI] = ACTIONS(4993),
    [anon_sym_typedef] = ACTIONS(4995),
    [anon_sym_extern] = ACTIONS(4995),
    [anon_sym_LBRACE] = ACTIONS(4993),
    [anon_sym_LPAREN2] = ACTIONS(4993),
    [anon_sym_STAR] = ACTIONS(4993),
    [anon_sym_LBRACK] = ACTIONS(4993),
    [anon_sym_static] = ACTIONS(4995),
    [anon_sym_register] = ACTIONS(4995),
    [anon_sym_inline] = ACTIONS(4995),
    [anon_sym_const] = ACTIONS(4995),
    [anon_sym_restrict] = ACTIONS(4995),
    [anon_sym_volatile] = ACTIONS(4995),
    [anon_sym__Atomic] = ACTIONS(4995),
    [anon_sym_mutable] = ACTIONS(4995),
    [anon_sym_explicit] = ACTIONS(4995),
    [anon_sym_constexpr] = ACTIONS(4995),
    [anon_sym_unsigned] = ACTIONS(4995),
    [anon_sym_long] = ACTIONS(4995),
    [anon_sym_short] = ACTIONS(4995),
    [sym_primitive_type] = ACTIONS(4995),
    [anon_sym_enum] = ACTIONS(4995),
    [anon_sym_struct] = ACTIONS(4995),
    [anon_sym_union] = ACTIONS(4995),
    [anon_sym_if] = ACTIONS(4995),
    [anon_sym_else] = ACTIONS(4995),
    [anon_sym_switch] = ACTIONS(4995),
    [anon_sym_case] = ACTIONS(4995),
    [anon_sym_default] = ACTIONS(4995),
    [anon_sym_while] = ACTIONS(4995),
    [anon_sym_do] = ACTIONS(4995),
    [anon_sym_for] = ACTIONS(4995),
    [anon_sym_return] = ACTIONS(4995),
    [anon_sym_break] = ACTIONS(4995),
    [anon_sym_continue] = ACTIONS(4995),
    [anon_sym_goto] = ACTIONS(4995),
    [anon_sym_AMP] = ACTIONS(4993),
    [anon_sym_BANG] = ACTIONS(4993),
    [anon_sym_TILDE] = ACTIONS(4993),
    [anon_sym_PLUS] = ACTIONS(4995),
    [anon_sym_DASH] = ACTIONS(4995),
    [anon_sym_DASH_DASH] = ACTIONS(4993),
    [anon_sym_PLUS_PLUS] = ACTIONS(4993),
    [anon_sym_sizeof] = ACTIONS(4995),
    [sym_number_literal] = ACTIONS(4993),
    [anon_sym_SQUOTE] = ACTIONS(4993),
    [anon_sym_DQUOTE] = ACTIONS(4993),
    [sym_true] = ACTIONS(4995),
    [sym_false] = ACTIONS(4995),
    [sym_null] = ACTIONS(4995),
    [sym_identifier] = ACTIONS(4995),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4995),
    [sym_auto] = ACTIONS(4995),
    [anon_sym_typename] = ACTIONS(4995),
    [anon_sym_delete] = ACTIONS(4995),
    [anon_sym_try] = ACTIONS(4995),
    [anon_sym_catch] = ACTIONS(7469),
    [anon_sym_new] = ACTIONS(4995),
    [anon_sym_COLON_COLON] = ACTIONS(4993),
    [sym_nullptr] = ACTIONS(4995),
  },
  [3741] = {
    [sym_raw_string_literal] = ACTIONS(7906),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7908),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7908),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7908),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7908),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7908),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7908),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7908),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7908),
    [sym_preproc_directive] = ACTIONS(7908),
    [anon_sym_SEMI] = ACTIONS(7906),
    [anon_sym_typedef] = ACTIONS(7908),
    [anon_sym_extern] = ACTIONS(7908),
    [anon_sym_LBRACE] = ACTIONS(7906),
    [anon_sym_LPAREN2] = ACTIONS(7906),
    [anon_sym_STAR] = ACTIONS(7906),
    [anon_sym_LBRACK] = ACTIONS(7906),
    [anon_sym_static] = ACTIONS(7908),
    [anon_sym_register] = ACTIONS(7908),
    [anon_sym_inline] = ACTIONS(7908),
    [anon_sym_const] = ACTIONS(7908),
    [anon_sym_restrict] = ACTIONS(7908),
    [anon_sym_volatile] = ACTIONS(7908),
    [anon_sym__Atomic] = ACTIONS(7908),
    [anon_sym_mutable] = ACTIONS(7908),
    [anon_sym_explicit] = ACTIONS(7908),
    [anon_sym_constexpr] = ACTIONS(7908),
    [anon_sym_unsigned] = ACTIONS(7908),
    [anon_sym_long] = ACTIONS(7908),
    [anon_sym_short] = ACTIONS(7908),
    [sym_primitive_type] = ACTIONS(7908),
    [anon_sym_enum] = ACTIONS(7908),
    [anon_sym_struct] = ACTIONS(7908),
    [anon_sym_union] = ACTIONS(7908),
    [anon_sym_if] = ACTIONS(7908),
    [anon_sym_else] = ACTIONS(7908),
    [anon_sym_switch] = ACTIONS(7908),
    [anon_sym_case] = ACTIONS(7908),
    [anon_sym_default] = ACTIONS(7908),
    [anon_sym_while] = ACTIONS(7908),
    [anon_sym_do] = ACTIONS(7908),
    [anon_sym_for] = ACTIONS(7908),
    [anon_sym_return] = ACTIONS(7908),
    [anon_sym_break] = ACTIONS(7908),
    [anon_sym_continue] = ACTIONS(7908),
    [anon_sym_goto] = ACTIONS(7908),
    [anon_sym_AMP] = ACTIONS(7906),
    [anon_sym_BANG] = ACTIONS(7906),
    [anon_sym_TILDE] = ACTIONS(7906),
    [anon_sym_PLUS] = ACTIONS(7908),
    [anon_sym_DASH] = ACTIONS(7908),
    [anon_sym_DASH_DASH] = ACTIONS(7906),
    [anon_sym_PLUS_PLUS] = ACTIONS(7906),
    [anon_sym_sizeof] = ACTIONS(7908),
    [sym_number_literal] = ACTIONS(7906),
    [anon_sym_SQUOTE] = ACTIONS(7906),
    [anon_sym_DQUOTE] = ACTIONS(7906),
    [sym_true] = ACTIONS(7908),
    [sym_false] = ACTIONS(7908),
    [sym_null] = ACTIONS(7908),
    [sym_identifier] = ACTIONS(7908),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7908),
    [sym_auto] = ACTIONS(7908),
    [anon_sym_typename] = ACTIONS(7908),
    [anon_sym_delete] = ACTIONS(7908),
    [anon_sym_try] = ACTIONS(7908),
    [anon_sym_new] = ACTIONS(7908),
    [anon_sym_COLON_COLON] = ACTIONS(7906),
    [sym_nullptr] = ACTIONS(7908),
  },
  [3742] = {
    [sym_raw_string_literal] = ACTIONS(7928),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7930),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7930),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7930),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7930),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7930),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7930),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7930),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7930),
    [sym_preproc_directive] = ACTIONS(7930),
    [anon_sym_SEMI] = ACTIONS(7928),
    [anon_sym_typedef] = ACTIONS(7930),
    [anon_sym_extern] = ACTIONS(7930),
    [anon_sym_LBRACE] = ACTIONS(7928),
    [anon_sym_LPAREN2] = ACTIONS(7928),
    [anon_sym_STAR] = ACTIONS(7928),
    [anon_sym_LBRACK] = ACTIONS(7928),
    [anon_sym_static] = ACTIONS(7930),
    [anon_sym_register] = ACTIONS(7930),
    [anon_sym_inline] = ACTIONS(7930),
    [anon_sym_const] = ACTIONS(7930),
    [anon_sym_restrict] = ACTIONS(7930),
    [anon_sym_volatile] = ACTIONS(7930),
    [anon_sym__Atomic] = ACTIONS(7930),
    [anon_sym_mutable] = ACTIONS(7930),
    [anon_sym_explicit] = ACTIONS(7930),
    [anon_sym_constexpr] = ACTIONS(7930),
    [anon_sym_unsigned] = ACTIONS(7930),
    [anon_sym_long] = ACTIONS(7930),
    [anon_sym_short] = ACTIONS(7930),
    [sym_primitive_type] = ACTIONS(7930),
    [anon_sym_enum] = ACTIONS(7930),
    [anon_sym_struct] = ACTIONS(7930),
    [anon_sym_union] = ACTIONS(7930),
    [anon_sym_if] = ACTIONS(7930),
    [anon_sym_else] = ACTIONS(7930),
    [anon_sym_switch] = ACTIONS(7930),
    [anon_sym_case] = ACTIONS(7930),
    [anon_sym_default] = ACTIONS(7930),
    [anon_sym_while] = ACTIONS(7930),
    [anon_sym_do] = ACTIONS(7930),
    [anon_sym_for] = ACTIONS(7930),
    [anon_sym_return] = ACTIONS(7930),
    [anon_sym_break] = ACTIONS(7930),
    [anon_sym_continue] = ACTIONS(7930),
    [anon_sym_goto] = ACTIONS(7930),
    [anon_sym_AMP] = ACTIONS(7928),
    [anon_sym_BANG] = ACTIONS(7928),
    [anon_sym_TILDE] = ACTIONS(7928),
    [anon_sym_PLUS] = ACTIONS(7930),
    [anon_sym_DASH] = ACTIONS(7930),
    [anon_sym_DASH_DASH] = ACTIONS(7928),
    [anon_sym_PLUS_PLUS] = ACTIONS(7928),
    [anon_sym_sizeof] = ACTIONS(7930),
    [sym_number_literal] = ACTIONS(7928),
    [anon_sym_SQUOTE] = ACTIONS(7928),
    [anon_sym_DQUOTE] = ACTIONS(7928),
    [sym_true] = ACTIONS(7930),
    [sym_false] = ACTIONS(7930),
    [sym_null] = ACTIONS(7930),
    [sym_identifier] = ACTIONS(7930),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7930),
    [sym_auto] = ACTIONS(7930),
    [anon_sym_typename] = ACTIONS(7930),
    [anon_sym_delete] = ACTIONS(7930),
    [anon_sym_try] = ACTIONS(7930),
    [anon_sym_new] = ACTIONS(7930),
    [anon_sym_COLON_COLON] = ACTIONS(7928),
    [sym_nullptr] = ACTIONS(7930),
  },
  [3743] = {
    [sym_compound_statement] = STATE(3813),
    [sym_labeled_statement] = STATE(3813),
    [sym_expression_statement] = STATE(3813),
    [sym_if_statement] = STATE(3813),
    [sym_switch_statement] = STATE(3813),
    [sym_case_statement] = STATE(3813),
    [sym_while_statement] = STATE(3813),
    [sym_do_statement] = STATE(3813),
    [sym_for_statement] = STATE(3813),
    [sym_return_statement] = STATE(3813),
    [sym_break_statement] = STATE(3813),
    [sym_continue_statement] = STATE(3813),
    [sym_goto_statement] = STATE(3813),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(3813),
    [sym_try_statement] = STATE(3813),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(2220),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(5705),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2242),
  },
  [3744] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8385),
    [sym_comment] = ACTIONS(91),
  },
  [3745] = {
    [sym_compound_statement] = STATE(3328),
    [sym_labeled_statement] = STATE(3328),
    [sym_expression_statement] = STATE(3328),
    [sym_if_statement] = STATE(3328),
    [sym_switch_statement] = STATE(3328),
    [sym_case_statement] = STATE(3328),
    [sym_while_statement] = STATE(3328),
    [sym_do_statement] = STATE(3328),
    [sym_for_statement] = STATE(3328),
    [sym_return_statement] = STATE(3328),
    [sym_break_statement] = STATE(3328),
    [sym_continue_statement] = STATE(3328),
    [sym_goto_statement] = STATE(3328),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(3328),
    [sym_try_statement] = STATE(3328),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(157),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(5814),
    [anon_sym_switch] = ACTIONS(5816),
    [anon_sym_case] = ACTIONS(5818),
    [anon_sym_default] = ACTIONS(5820),
    [anon_sym_while] = ACTIONS(5822),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(5824),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(5826),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(5828),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(207),
  },
  [3746] = {
    [sym_raw_string_literal] = ACTIONS(7063),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7065),
    [sym_preproc_directive] = ACTIONS(7065),
    [anon_sym_SEMI] = ACTIONS(7063),
    [anon_sym_typedef] = ACTIONS(7065),
    [anon_sym_extern] = ACTIONS(7065),
    [anon_sym_LBRACE] = ACTIONS(7063),
    [anon_sym_RBRACE] = ACTIONS(7063),
    [anon_sym_LPAREN2] = ACTIONS(7063),
    [anon_sym_STAR] = ACTIONS(7063),
    [anon_sym_LBRACK] = ACTIONS(7063),
    [anon_sym_static] = ACTIONS(7065),
    [anon_sym_register] = ACTIONS(7065),
    [anon_sym_inline] = ACTIONS(7065),
    [anon_sym_const] = ACTIONS(7065),
    [anon_sym_restrict] = ACTIONS(7065),
    [anon_sym_volatile] = ACTIONS(7065),
    [anon_sym__Atomic] = ACTIONS(7065),
    [anon_sym_mutable] = ACTIONS(7065),
    [anon_sym_explicit] = ACTIONS(7065),
    [anon_sym_constexpr] = ACTIONS(7065),
    [anon_sym_unsigned] = ACTIONS(7065),
    [anon_sym_long] = ACTIONS(7065),
    [anon_sym_short] = ACTIONS(7065),
    [sym_primitive_type] = ACTIONS(7065),
    [anon_sym_enum] = ACTIONS(7065),
    [anon_sym_struct] = ACTIONS(7065),
    [anon_sym_union] = ACTIONS(7065),
    [anon_sym_if] = ACTIONS(7065),
    [anon_sym_else] = ACTIONS(8387),
    [anon_sym_switch] = ACTIONS(7065),
    [anon_sym_case] = ACTIONS(7065),
    [anon_sym_default] = ACTIONS(7065),
    [anon_sym_while] = ACTIONS(7065),
    [anon_sym_do] = ACTIONS(7065),
    [anon_sym_for] = ACTIONS(7065),
    [anon_sym_return] = ACTIONS(7065),
    [anon_sym_break] = ACTIONS(7065),
    [anon_sym_continue] = ACTIONS(7065),
    [anon_sym_goto] = ACTIONS(7065),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_BANG] = ACTIONS(7063),
    [anon_sym_TILDE] = ACTIONS(7063),
    [anon_sym_PLUS] = ACTIONS(7065),
    [anon_sym_DASH] = ACTIONS(7065),
    [anon_sym_DASH_DASH] = ACTIONS(7063),
    [anon_sym_PLUS_PLUS] = ACTIONS(7063),
    [anon_sym_sizeof] = ACTIONS(7065),
    [sym_number_literal] = ACTIONS(7063),
    [anon_sym_SQUOTE] = ACTIONS(7063),
    [anon_sym_DQUOTE] = ACTIONS(7063),
    [sym_true] = ACTIONS(7065),
    [sym_false] = ACTIONS(7065),
    [sym_null] = ACTIONS(7065),
    [sym_identifier] = ACTIONS(7065),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7065),
    [sym_auto] = ACTIONS(7065),
    [anon_sym_typename] = ACTIONS(7065),
    [anon_sym_delete] = ACTIONS(7065),
    [anon_sym_try] = ACTIONS(7065),
    [anon_sym_new] = ACTIONS(7065),
    [anon_sym_COLON_COLON] = ACTIONS(7063),
    [sym_nullptr] = ACTIONS(7065),
  },
  [3747] = {
    [sym_compound_statement] = STATE(3330),
    [sym_labeled_statement] = STATE(3330),
    [sym_expression_statement] = STATE(3330),
    [sym_if_statement] = STATE(3330),
    [sym_switch_statement] = STATE(3330),
    [sym_case_statement] = STATE(3330),
    [sym_while_statement] = STATE(3330),
    [sym_do_statement] = STATE(3330),
    [sym_for_statement] = STATE(3330),
    [sym_return_statement] = STATE(3330),
    [sym_break_statement] = STATE(3330),
    [sym_continue_statement] = STATE(3330),
    [sym_goto_statement] = STATE(3330),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(3330),
    [sym_try_statement] = STATE(3330),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(157),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(5814),
    [anon_sym_switch] = ACTIONS(5816),
    [anon_sym_case] = ACTIONS(5818),
    [anon_sym_default] = ACTIONS(5820),
    [anon_sym_while] = ACTIONS(5822),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(5824),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(5826),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(5828),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(207),
  },
  [3748] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8389),
    [sym_comment] = ACTIONS(91),
  },
  [3749] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3817),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8389),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3750] = {
    [sym__expression] = STATE(3818),
    [sym_conditional_expression] = STATE(3818),
    [sym_assignment_expression] = STATE(3818),
    [sym_pointer_expression] = STATE(3818),
    [sym_logical_expression] = STATE(3818),
    [sym_bitwise_expression] = STATE(3818),
    [sym_equality_expression] = STATE(3818),
    [sym_relational_expression] = STATE(3818),
    [sym_shift_expression] = STATE(3818),
    [sym_math_expression] = STATE(3818),
    [sym_cast_expression] = STATE(3818),
    [sym_sizeof_expression] = STATE(3818),
    [sym_subscript_expression] = STATE(3818),
    [sym_call_expression] = STATE(3818),
    [sym_field_expression] = STATE(3818),
    [sym_compound_literal_expression] = STATE(3818),
    [sym_parenthesized_expression] = STATE(3818),
    [sym_char_literal] = STATE(3818),
    [sym_concatenated_string] = STATE(3818),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3818),
    [sym_new_expression] = STATE(3818),
    [sym_delete_expression] = STATE(3818),
    [sym_lambda_expression] = STATE(3818),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8391),
    [anon_sym_RPAREN] = ACTIONS(8389),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(8391),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8393),
    [sym_false] = ACTIONS(8393),
    [sym_null] = ACTIONS(8393),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(8393),
  },
  [3751] = {
    [sym_compound_statement] = STATE(3334),
    [sym_labeled_statement] = STATE(3334),
    [sym_expression_statement] = STATE(3334),
    [sym_if_statement] = STATE(3334),
    [sym_switch_statement] = STATE(3334),
    [sym_case_statement] = STATE(3334),
    [sym_while_statement] = STATE(3334),
    [sym_do_statement] = STATE(3334),
    [sym_for_statement] = STATE(3334),
    [sym_return_statement] = STATE(3334),
    [sym_break_statement] = STATE(3334),
    [sym_continue_statement] = STATE(3334),
    [sym_goto_statement] = STATE(3334),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(3334),
    [sym_try_statement] = STATE(3334),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(157),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(5814),
    [anon_sym_switch] = ACTIONS(5816),
    [anon_sym_case] = ACTIONS(5818),
    [anon_sym_default] = ACTIONS(5820),
    [anon_sym_while] = ACTIONS(5822),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(5824),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(5826),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(5828),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(207),
  },
  [3752] = {
    [sym_raw_string_literal] = ACTIONS(8287),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(8289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(8289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(8289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(8289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(8289),
    [sym_preproc_directive] = ACTIONS(8289),
    [anon_sym_SEMI] = ACTIONS(8287),
    [anon_sym_typedef] = ACTIONS(8289),
    [anon_sym_extern] = ACTIONS(8289),
    [anon_sym_LBRACE] = ACTIONS(8287),
    [anon_sym_RBRACE] = ACTIONS(8287),
    [anon_sym_LPAREN2] = ACTIONS(8287),
    [anon_sym_STAR] = ACTIONS(8287),
    [anon_sym_LBRACK] = ACTIONS(8287),
    [anon_sym_static] = ACTIONS(8289),
    [anon_sym_register] = ACTIONS(8289),
    [anon_sym_inline] = ACTIONS(8289),
    [anon_sym_const] = ACTIONS(8289),
    [anon_sym_restrict] = ACTIONS(8289),
    [anon_sym_volatile] = ACTIONS(8289),
    [anon_sym__Atomic] = ACTIONS(8289),
    [anon_sym_mutable] = ACTIONS(8289),
    [anon_sym_explicit] = ACTIONS(8289),
    [anon_sym_constexpr] = ACTIONS(8289),
    [anon_sym_unsigned] = ACTIONS(8289),
    [anon_sym_long] = ACTIONS(8289),
    [anon_sym_short] = ACTIONS(8289),
    [sym_primitive_type] = ACTIONS(8289),
    [anon_sym_enum] = ACTIONS(8289),
    [anon_sym_struct] = ACTIONS(8289),
    [anon_sym_union] = ACTIONS(8289),
    [anon_sym_if] = ACTIONS(8289),
    [anon_sym_else] = ACTIONS(8289),
    [anon_sym_switch] = ACTIONS(8289),
    [anon_sym_case] = ACTIONS(8289),
    [anon_sym_default] = ACTIONS(8289),
    [anon_sym_while] = ACTIONS(8289),
    [anon_sym_do] = ACTIONS(8289),
    [anon_sym_for] = ACTIONS(8289),
    [anon_sym_return] = ACTIONS(8289),
    [anon_sym_break] = ACTIONS(8289),
    [anon_sym_continue] = ACTIONS(8289),
    [anon_sym_goto] = ACTIONS(8289),
    [anon_sym_AMP] = ACTIONS(8287),
    [anon_sym_BANG] = ACTIONS(8287),
    [anon_sym_TILDE] = ACTIONS(8287),
    [anon_sym_PLUS] = ACTIONS(8289),
    [anon_sym_DASH] = ACTIONS(8289),
    [anon_sym_DASH_DASH] = ACTIONS(8287),
    [anon_sym_PLUS_PLUS] = ACTIONS(8287),
    [anon_sym_sizeof] = ACTIONS(8289),
    [sym_number_literal] = ACTIONS(8287),
    [anon_sym_SQUOTE] = ACTIONS(8287),
    [anon_sym_DQUOTE] = ACTIONS(8287),
    [sym_true] = ACTIONS(8289),
    [sym_false] = ACTIONS(8289),
    [sym_null] = ACTIONS(8289),
    [sym_identifier] = ACTIONS(8289),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(8289),
    [sym_auto] = ACTIONS(8289),
    [anon_sym_typename] = ACTIONS(8289),
    [anon_sym_delete] = ACTIONS(8289),
    [anon_sym_try] = ACTIONS(8289),
    [anon_sym_new] = ACTIONS(8289),
    [anon_sym_COLON_COLON] = ACTIONS(8287),
    [sym_nullptr] = ACTIONS(8289),
  },
  [3753] = {
    [sym_parameter_list] = STATE(3756),
    [anon_sym_COMMA] = ACTIONS(4157),
    [anon_sym_SEMI] = ACTIONS(4157),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_const] = ACTIONS(7279),
    [anon_sym_restrict] = ACTIONS(4157),
    [anon_sym_volatile] = ACTIONS(4157),
    [anon_sym__Atomic] = ACTIONS(4157),
    [anon_sym_mutable] = ACTIONS(4157),
    [anon_sym_explicit] = ACTIONS(4157),
    [anon_sym_constexpr] = ACTIONS(4157),
    [anon_sym_COLON] = ACTIONS(4157),
    [anon_sym_DASH_GT] = ACTIONS(4157),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4157),
    [anon_sym_override] = ACTIONS(4157),
    [sym_noexcept] = ACTIONS(4157),
  },
  [3754] = {
    [sym__abstract_declarator] = STATE(3819),
    [sym_abstract_pointer_declarator] = STATE(3819),
    [sym_abstract_function_declarator] = STATE(3819),
    [sym_abstract_array_declarator] = STATE(3819),
    [sym_type_qualifier] = STATE(3820),
    [sym_parameter_list] = STATE(3659),
    [sym_abstract_reference_declarator] = STATE(3819),
    [aux_sym_type_definition_repeat1] = STATE(3820),
    [anon_sym_COMMA] = ACTIONS(4157),
    [anon_sym_SEMI] = ACTIONS(4157),
    [anon_sym_LPAREN2] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(8092),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_const] = ACTIONS(1667),
    [anon_sym_restrict] = ACTIONS(1669),
    [anon_sym_volatile] = ACTIONS(1669),
    [anon_sym__Atomic] = ACTIONS(1669),
    [anon_sym_mutable] = ACTIONS(1669),
    [anon_sym_explicit] = ACTIONS(1669),
    [anon_sym_constexpr] = ACTIONS(1669),
    [anon_sym_COLON] = ACTIONS(4157),
    [anon_sym_AMP] = ACTIONS(8094),
    [anon_sym_AMP_AMP] = ACTIONS(8096),
    [anon_sym_DASH_GT] = ACTIONS(4157),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4157),
    [anon_sym_override] = ACTIONS(4157),
    [sym_noexcept] = ACTIONS(4157),
  },
  [3755] = {
    [sym_parameter_list] = STATE(3756),
    [anon_sym_COMMA] = ACTIONS(4159),
    [anon_sym_SEMI] = ACTIONS(4159),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_const] = ACTIONS(7281),
    [anon_sym_restrict] = ACTIONS(4159),
    [anon_sym_volatile] = ACTIONS(4159),
    [anon_sym__Atomic] = ACTIONS(4159),
    [anon_sym_mutable] = ACTIONS(4159),
    [anon_sym_explicit] = ACTIONS(4159),
    [anon_sym_constexpr] = ACTIONS(4159),
    [anon_sym_COLON] = ACTIONS(4159),
    [anon_sym_DASH_GT] = ACTIONS(4159),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(4159),
    [anon_sym_override] = ACTIONS(4159),
    [sym_noexcept] = ACTIONS(4159),
  },
  [3756] = {
    [sym_type_qualifier] = STATE(3821),
    [sym_trailing_return_type] = STATE(1720),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3821),
    [anon_sym_COMMA] = ACTIONS(3663),
    [anon_sym_SEMI] = ACTIONS(3663),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_const] = ACTIONS(3685),
    [anon_sym_restrict] = ACTIONS(3663),
    [anon_sym_volatile] = ACTIONS(3663),
    [anon_sym__Atomic] = ACTIONS(3663),
    [anon_sym_mutable] = ACTIONS(3663),
    [anon_sym_explicit] = ACTIONS(3663),
    [anon_sym_constexpr] = ACTIONS(3663),
    [anon_sym_COLON] = ACTIONS(3663),
    [anon_sym_DASH_GT] = ACTIONS(3663),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3663),
    [anon_sym_override] = ACTIONS(3663),
    [sym_noexcept] = ACTIONS(3663),
  },
  [3757] = {
    [sym_type_qualifier] = STATE(3822),
    [sym_trailing_return_type] = STATE(1720),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3822),
    [anon_sym_COMMA] = ACTIONS(3663),
    [anon_sym_SEMI] = ACTIONS(3663),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_const] = ACTIONS(1667),
    [anon_sym_restrict] = ACTIONS(1669),
    [anon_sym_volatile] = ACTIONS(1669),
    [anon_sym__Atomic] = ACTIONS(1669),
    [anon_sym_mutable] = ACTIONS(1669),
    [anon_sym_explicit] = ACTIONS(1669),
    [anon_sym_constexpr] = ACTIONS(1669),
    [anon_sym_COLON] = ACTIONS(3663),
    [anon_sym_DASH_GT] = ACTIONS(7514),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(3663),
    [anon_sym_override] = ACTIONS(3663),
    [sym_noexcept] = ACTIONS(8395),
  },
  [3758] = {
    [sym_compound_statement] = STATE(3366),
    [sym_labeled_statement] = STATE(3366),
    [sym_expression_statement] = STATE(3366),
    [sym_if_statement] = STATE(3366),
    [sym_switch_statement] = STATE(3366),
    [sym_case_statement] = STATE(3366),
    [sym_while_statement] = STATE(3366),
    [sym_do_statement] = STATE(3366),
    [sym_for_statement] = STATE(3366),
    [sym_return_statement] = STATE(3366),
    [sym_break_statement] = STATE(3366),
    [sym_continue_statement] = STATE(3366),
    [sym_goto_statement] = STATE(3366),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(3366),
    [sym_try_statement] = STATE(3366),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(4430),
    [anon_sym_switch] = ACTIONS(4432),
    [anon_sym_case] = ACTIONS(4434),
    [anon_sym_default] = ACTIONS(4436),
    [anon_sym_while] = ACTIONS(4438),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(4440),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(4442),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(4444),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [3759] = {
    [sym_compound_statement] = STATE(3382),
    [sym_labeled_statement] = STATE(3382),
    [sym_expression_statement] = STATE(3382),
    [sym_if_statement] = STATE(3382),
    [sym_switch_statement] = STATE(3382),
    [sym_case_statement] = STATE(3382),
    [sym_while_statement] = STATE(3382),
    [sym_do_statement] = STATE(3382),
    [sym_for_statement] = STATE(3382),
    [sym_return_statement] = STATE(3382),
    [sym_break_statement] = STATE(3382),
    [sym_continue_statement] = STATE(3382),
    [sym_goto_statement] = STATE(3382),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(3382),
    [sym_try_statement] = STATE(3382),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(4430),
    [anon_sym_switch] = ACTIONS(4432),
    [anon_sym_case] = ACTIONS(4434),
    [anon_sym_default] = ACTIONS(4436),
    [anon_sym_while] = ACTIONS(4438),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(4440),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(4442),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(4444),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [3760] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8397),
    [sym_comment] = ACTIONS(91),
  },
  [3761] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3824),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8397),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3762] = {
    [sym_compound_statement] = STATE(3375),
    [sym_labeled_statement] = STATE(3375),
    [sym_expression_statement] = STATE(3375),
    [sym_if_statement] = STATE(3375),
    [sym_switch_statement] = STATE(3375),
    [sym_case_statement] = STATE(3375),
    [sym_while_statement] = STATE(3375),
    [sym_do_statement] = STATE(3375),
    [sym_for_statement] = STATE(3375),
    [sym_return_statement] = STATE(3375),
    [sym_break_statement] = STATE(3375),
    [sym_continue_statement] = STATE(3375),
    [sym_goto_statement] = STATE(3375),
    [sym__expression] = STATE(222),
    [sym_comma_expression] = STATE(223),
    [sym_conditional_expression] = STATE(222),
    [sym_assignment_expression] = STATE(222),
    [sym_pointer_expression] = STATE(222),
    [sym_logical_expression] = STATE(222),
    [sym_bitwise_expression] = STATE(222),
    [sym_equality_expression] = STATE(222),
    [sym_relational_expression] = STATE(222),
    [sym_shift_expression] = STATE(222),
    [sym_math_expression] = STATE(222),
    [sym_cast_expression] = STATE(222),
    [sym_sizeof_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_call_expression] = STATE(222),
    [sym_field_expression] = STATE(222),
    [sym_compound_literal_expression] = STATE(222),
    [sym_parenthesized_expression] = STATE(222),
    [sym_char_literal] = STATE(222),
    [sym_concatenated_string] = STATE(222),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(222),
    [sym_for_range_loop] = STATE(3375),
    [sym_try_statement] = STATE(3375),
    [sym_new_expression] = STATE(222),
    [sym_delete_expression] = STATE(222),
    [sym_lambda_expression] = STATE(222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(6119),
    [anon_sym_switch] = ACTIONS(6121),
    [anon_sym_case] = ACTIONS(6123),
    [anon_sym_default] = ACTIONS(6125),
    [anon_sym_while] = ACTIONS(6127),
    [anon_sym_do] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(6129),
    [anon_sym_return] = ACTIONS(373),
    [anon_sym_break] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_goto] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(353),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_identifier] = ACTIONS(6131),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(6133),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(381),
  },
  [3763] = {
    [anon_sym_else] = ACTIONS(8399),
    [anon_sym_while] = ACTIONS(7063),
    [sym_comment] = ACTIONS(91),
  },
  [3764] = {
    [sym_compound_statement] = STATE(3377),
    [sym_labeled_statement] = STATE(3377),
    [sym_expression_statement] = STATE(3377),
    [sym_if_statement] = STATE(3377),
    [sym_switch_statement] = STATE(3377),
    [sym_case_statement] = STATE(3377),
    [sym_while_statement] = STATE(3377),
    [sym_do_statement] = STATE(3377),
    [sym_for_statement] = STATE(3377),
    [sym_return_statement] = STATE(3377),
    [sym_break_statement] = STATE(3377),
    [sym_continue_statement] = STATE(3377),
    [sym_goto_statement] = STATE(3377),
    [sym__expression] = STATE(222),
    [sym_comma_expression] = STATE(223),
    [sym_conditional_expression] = STATE(222),
    [sym_assignment_expression] = STATE(222),
    [sym_pointer_expression] = STATE(222),
    [sym_logical_expression] = STATE(222),
    [sym_bitwise_expression] = STATE(222),
    [sym_equality_expression] = STATE(222),
    [sym_relational_expression] = STATE(222),
    [sym_shift_expression] = STATE(222),
    [sym_math_expression] = STATE(222),
    [sym_cast_expression] = STATE(222),
    [sym_sizeof_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_call_expression] = STATE(222),
    [sym_field_expression] = STATE(222),
    [sym_compound_literal_expression] = STATE(222),
    [sym_parenthesized_expression] = STATE(222),
    [sym_char_literal] = STATE(222),
    [sym_concatenated_string] = STATE(222),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(222),
    [sym_for_range_loop] = STATE(3377),
    [sym_try_statement] = STATE(3377),
    [sym_new_expression] = STATE(222),
    [sym_delete_expression] = STATE(222),
    [sym_lambda_expression] = STATE(222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(6119),
    [anon_sym_switch] = ACTIONS(6121),
    [anon_sym_case] = ACTIONS(6123),
    [anon_sym_default] = ACTIONS(6125),
    [anon_sym_while] = ACTIONS(6127),
    [anon_sym_do] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(6129),
    [anon_sym_return] = ACTIONS(373),
    [anon_sym_break] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_goto] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(353),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_identifier] = ACTIONS(6131),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(6133),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(381),
  },
  [3765] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8401),
    [sym_comment] = ACTIONS(91),
  },
  [3766] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3827),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8401),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3767] = {
    [sym__expression] = STATE(3828),
    [sym_conditional_expression] = STATE(3828),
    [sym_assignment_expression] = STATE(3828),
    [sym_pointer_expression] = STATE(3828),
    [sym_logical_expression] = STATE(3828),
    [sym_bitwise_expression] = STATE(3828),
    [sym_equality_expression] = STATE(3828),
    [sym_relational_expression] = STATE(3828),
    [sym_shift_expression] = STATE(3828),
    [sym_math_expression] = STATE(3828),
    [sym_cast_expression] = STATE(3828),
    [sym_sizeof_expression] = STATE(3828),
    [sym_subscript_expression] = STATE(3828),
    [sym_call_expression] = STATE(3828),
    [sym_field_expression] = STATE(3828),
    [sym_compound_literal_expression] = STATE(3828),
    [sym_parenthesized_expression] = STATE(3828),
    [sym_char_literal] = STATE(3828),
    [sym_concatenated_string] = STATE(3828),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3828),
    [sym_new_expression] = STATE(3828),
    [sym_delete_expression] = STATE(3828),
    [sym_lambda_expression] = STATE(3828),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8403),
    [anon_sym_RPAREN] = ACTIONS(8401),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(8403),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8405),
    [sym_false] = ACTIONS(8405),
    [sym_null] = ACTIONS(8405),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(8405),
  },
  [3768] = {
    [sym_compound_statement] = STATE(3381),
    [sym_labeled_statement] = STATE(3381),
    [sym_expression_statement] = STATE(3381),
    [sym_if_statement] = STATE(3381),
    [sym_switch_statement] = STATE(3381),
    [sym_case_statement] = STATE(3381),
    [sym_while_statement] = STATE(3381),
    [sym_do_statement] = STATE(3381),
    [sym_for_statement] = STATE(3381),
    [sym_return_statement] = STATE(3381),
    [sym_break_statement] = STATE(3381),
    [sym_continue_statement] = STATE(3381),
    [sym_goto_statement] = STATE(3381),
    [sym__expression] = STATE(222),
    [sym_comma_expression] = STATE(223),
    [sym_conditional_expression] = STATE(222),
    [sym_assignment_expression] = STATE(222),
    [sym_pointer_expression] = STATE(222),
    [sym_logical_expression] = STATE(222),
    [sym_bitwise_expression] = STATE(222),
    [sym_equality_expression] = STATE(222),
    [sym_relational_expression] = STATE(222),
    [sym_shift_expression] = STATE(222),
    [sym_math_expression] = STATE(222),
    [sym_cast_expression] = STATE(222),
    [sym_sizeof_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_call_expression] = STATE(222),
    [sym_field_expression] = STATE(222),
    [sym_compound_literal_expression] = STATE(222),
    [sym_parenthesized_expression] = STATE(222),
    [sym_char_literal] = STATE(222),
    [sym_concatenated_string] = STATE(222),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(222),
    [sym_for_range_loop] = STATE(3381),
    [sym_try_statement] = STATE(3381),
    [sym_new_expression] = STATE(222),
    [sym_delete_expression] = STATE(222),
    [sym_lambda_expression] = STATE(222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(6119),
    [anon_sym_switch] = ACTIONS(6121),
    [anon_sym_case] = ACTIONS(6123),
    [anon_sym_default] = ACTIONS(6125),
    [anon_sym_while] = ACTIONS(6127),
    [anon_sym_do] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(6129),
    [anon_sym_return] = ACTIONS(373),
    [anon_sym_break] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_goto] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(353),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_identifier] = ACTIONS(6131),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(6133),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(381),
  },
  [3769] = {
    [anon_sym_else] = ACTIONS(8287),
    [anon_sym_while] = ACTIONS(8287),
    [sym_comment] = ACTIONS(91),
  },
  [3770] = {
    [sym_raw_string_literal] = ACTIONS(6091),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6093),
    [sym_preproc_directive] = ACTIONS(6093),
    [anon_sym_SEMI] = ACTIONS(6091),
    [anon_sym_typedef] = ACTIONS(6093),
    [anon_sym_extern] = ACTIONS(6093),
    [anon_sym_LBRACE] = ACTIONS(6091),
    [anon_sym_RBRACE] = ACTIONS(6091),
    [anon_sym_LPAREN2] = ACTIONS(6091),
    [anon_sym_STAR] = ACTIONS(6091),
    [anon_sym_LBRACK] = ACTIONS(6091),
    [anon_sym_static] = ACTIONS(6093),
    [anon_sym_register] = ACTIONS(6093),
    [anon_sym_inline] = ACTIONS(6093),
    [anon_sym_const] = ACTIONS(6093),
    [anon_sym_restrict] = ACTIONS(6093),
    [anon_sym_volatile] = ACTIONS(6093),
    [anon_sym__Atomic] = ACTIONS(6093),
    [anon_sym_mutable] = ACTIONS(6093),
    [anon_sym_explicit] = ACTIONS(6093),
    [anon_sym_constexpr] = ACTIONS(6093),
    [anon_sym_unsigned] = ACTIONS(6093),
    [anon_sym_long] = ACTIONS(6093),
    [anon_sym_short] = ACTIONS(6093),
    [sym_primitive_type] = ACTIONS(6093),
    [anon_sym_enum] = ACTIONS(6093),
    [anon_sym_struct] = ACTIONS(6093),
    [anon_sym_union] = ACTIONS(6093),
    [anon_sym_if] = ACTIONS(6093),
    [anon_sym_else] = ACTIONS(8407),
    [anon_sym_switch] = ACTIONS(6093),
    [anon_sym_case] = ACTIONS(6093),
    [anon_sym_default] = ACTIONS(6093),
    [anon_sym_while] = ACTIONS(6093),
    [anon_sym_do] = ACTIONS(6093),
    [anon_sym_for] = ACTIONS(6093),
    [anon_sym_return] = ACTIONS(6093),
    [anon_sym_break] = ACTIONS(6093),
    [anon_sym_continue] = ACTIONS(6093),
    [anon_sym_goto] = ACTIONS(6093),
    [anon_sym_AMP] = ACTIONS(6093),
    [anon_sym_AMP_AMP] = ACTIONS(6091),
    [anon_sym_BANG] = ACTIONS(6091),
    [anon_sym_TILDE] = ACTIONS(6091),
    [anon_sym_PLUS] = ACTIONS(6093),
    [anon_sym_DASH] = ACTIONS(6093),
    [anon_sym_DASH_DASH] = ACTIONS(6091),
    [anon_sym_PLUS_PLUS] = ACTIONS(6091),
    [anon_sym_sizeof] = ACTIONS(6093),
    [sym_number_literal] = ACTIONS(6091),
    [anon_sym_SQUOTE] = ACTIONS(6091),
    [anon_sym_DQUOTE] = ACTIONS(6091),
    [sym_true] = ACTIONS(6093),
    [sym_false] = ACTIONS(6093),
    [sym_null] = ACTIONS(6093),
    [sym_identifier] = ACTIONS(6093),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6093),
    [sym_auto] = ACTIONS(6093),
    [anon_sym_typename] = ACTIONS(6093),
    [anon_sym_template] = ACTIONS(6093),
    [anon_sym_delete] = ACTIONS(6093),
    [anon_sym_namespace] = ACTIONS(6093),
    [anon_sym_using] = ACTIONS(6093),
    [anon_sym_try] = ACTIONS(6093),
    [anon_sym_new] = ACTIONS(6093),
    [anon_sym_COLON_COLON] = ACTIONS(6091),
    [sym_operator_name] = ACTIONS(6091),
    [sym_nullptr] = ACTIONS(6093),
  },
  [3771] = {
    [sym_compound_statement] = STATE(3830),
    [sym_labeled_statement] = STATE(3830),
    [sym_expression_statement] = STATE(3830),
    [sym_if_statement] = STATE(3830),
    [sym_switch_statement] = STATE(3830),
    [sym_case_statement] = STATE(3830),
    [sym_while_statement] = STATE(3830),
    [sym_do_statement] = STATE(3830),
    [sym_for_statement] = STATE(3830),
    [sym_return_statement] = STATE(3830),
    [sym_break_statement] = STATE(3830),
    [sym_continue_statement] = STATE(3830),
    [sym_goto_statement] = STATE(3830),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(3830),
    [sym_try_statement] = STATE(3830),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7177),
    [anon_sym_switch] = ACTIONS(7179),
    [anon_sym_case] = ACTIONS(7181),
    [anon_sym_default] = ACTIONS(7183),
    [anon_sym_while] = ACTIONS(7185),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(7187),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(7189),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7191),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [3772] = {
    [sym_compound_statement] = STATE(2749),
    [sym_labeled_statement] = STATE(2749),
    [sym_expression_statement] = STATE(2749),
    [sym_if_statement] = STATE(2749),
    [sym_switch_statement] = STATE(2749),
    [sym_case_statement] = STATE(2749),
    [sym_while_statement] = STATE(2749),
    [sym_do_statement] = STATE(2749),
    [sym_for_statement] = STATE(2749),
    [sym_return_statement] = STATE(2749),
    [sym_break_statement] = STATE(2749),
    [sym_continue_statement] = STATE(2749),
    [sym_goto_statement] = STATE(2749),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(2749),
    [sym_try_statement] = STATE(2749),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7177),
    [anon_sym_switch] = ACTIONS(7179),
    [anon_sym_case] = ACTIONS(7181),
    [anon_sym_default] = ACTIONS(7183),
    [anon_sym_while] = ACTIONS(7185),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(7187),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(7189),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7191),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [3773] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3832),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8409),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3774] = {
    [sym__expression] = STATE(3833),
    [sym_conditional_expression] = STATE(3833),
    [sym_assignment_expression] = STATE(3833),
    [sym_pointer_expression] = STATE(3833),
    [sym_logical_expression] = STATE(3833),
    [sym_bitwise_expression] = STATE(3833),
    [sym_equality_expression] = STATE(3833),
    [sym_relational_expression] = STATE(3833),
    [sym_shift_expression] = STATE(3833),
    [sym_math_expression] = STATE(3833),
    [sym_cast_expression] = STATE(3833),
    [sym_sizeof_expression] = STATE(3833),
    [sym_subscript_expression] = STATE(3833),
    [sym_call_expression] = STATE(3833),
    [sym_field_expression] = STATE(3833),
    [sym_compound_literal_expression] = STATE(3833),
    [sym_parenthesized_expression] = STATE(3833),
    [sym_char_literal] = STATE(3833),
    [sym_concatenated_string] = STATE(3833),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3833),
    [sym_new_expression] = STATE(3833),
    [sym_delete_expression] = STATE(3833),
    [sym_lambda_expression] = STATE(3833),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8411),
    [anon_sym_RPAREN] = ACTIONS(8409),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(8411),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8413),
    [sym_false] = ACTIONS(8413),
    [sym_null] = ACTIONS(8413),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(8413),
  },
  [3775] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(8415),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3776] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(8417),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3777] = {
    [sym_compound_statement] = STATE(3681),
    [sym_labeled_statement] = STATE(3681),
    [sym_expression_statement] = STATE(3681),
    [sym_if_statement] = STATE(3681),
    [sym_switch_statement] = STATE(3681),
    [sym_case_statement] = STATE(3681),
    [sym_while_statement] = STATE(3681),
    [sym_do_statement] = STATE(3681),
    [sym_for_statement] = STATE(3681),
    [sym_return_statement] = STATE(3681),
    [sym_break_statement] = STATE(3681),
    [sym_continue_statement] = STATE(3681),
    [sym_goto_statement] = STATE(3681),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(3681),
    [sym_try_statement] = STATE(3681),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(1495),
    [anon_sym_switch] = ACTIONS(1497),
    [anon_sym_case] = ACTIONS(1499),
    [anon_sym_default] = ACTIONS(1501),
    [anon_sym_while] = ACTIONS(1503),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(1505),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(4937),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(1509),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [3778] = {
    [sym_raw_string_literal] = ACTIONS(6091),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6093),
    [sym_preproc_directive] = ACTIONS(6093),
    [anon_sym_SEMI] = ACTIONS(6091),
    [anon_sym_typedef] = ACTIONS(6093),
    [anon_sym_extern] = ACTIONS(6093),
    [anon_sym_LBRACE] = ACTIONS(6091),
    [anon_sym_LPAREN2] = ACTIONS(6091),
    [anon_sym_STAR] = ACTIONS(6091),
    [anon_sym_LBRACK] = ACTIONS(6091),
    [anon_sym_static] = ACTIONS(6093),
    [anon_sym_register] = ACTIONS(6093),
    [anon_sym_inline] = ACTIONS(6093),
    [anon_sym_const] = ACTIONS(6093),
    [anon_sym_restrict] = ACTIONS(6093),
    [anon_sym_volatile] = ACTIONS(6093),
    [anon_sym__Atomic] = ACTIONS(6093),
    [anon_sym_mutable] = ACTIONS(6093),
    [anon_sym_explicit] = ACTIONS(6093),
    [anon_sym_constexpr] = ACTIONS(6093),
    [anon_sym_unsigned] = ACTIONS(6093),
    [anon_sym_long] = ACTIONS(6093),
    [anon_sym_short] = ACTIONS(6093),
    [sym_primitive_type] = ACTIONS(6093),
    [anon_sym_enum] = ACTIONS(6093),
    [anon_sym_struct] = ACTIONS(6093),
    [anon_sym_union] = ACTIONS(6093),
    [anon_sym_if] = ACTIONS(6093),
    [anon_sym_else] = ACTIONS(8419),
    [anon_sym_switch] = ACTIONS(6093),
    [anon_sym_case] = ACTIONS(6093),
    [anon_sym_default] = ACTIONS(6093),
    [anon_sym_while] = ACTIONS(6093),
    [anon_sym_do] = ACTIONS(6093),
    [anon_sym_for] = ACTIONS(6093),
    [anon_sym_return] = ACTIONS(6093),
    [anon_sym_break] = ACTIONS(6093),
    [anon_sym_continue] = ACTIONS(6093),
    [anon_sym_goto] = ACTIONS(6093),
    [anon_sym_AMP] = ACTIONS(6093),
    [anon_sym_AMP_AMP] = ACTIONS(6091),
    [anon_sym_BANG] = ACTIONS(6091),
    [anon_sym_TILDE] = ACTIONS(6091),
    [anon_sym_PLUS] = ACTIONS(6093),
    [anon_sym_DASH] = ACTIONS(6093),
    [anon_sym_DASH_DASH] = ACTIONS(6091),
    [anon_sym_PLUS_PLUS] = ACTIONS(6091),
    [anon_sym_sizeof] = ACTIONS(6093),
    [sym_number_literal] = ACTIONS(6091),
    [anon_sym_SQUOTE] = ACTIONS(6091),
    [anon_sym_DQUOTE] = ACTIONS(6091),
    [sym_true] = ACTIONS(6093),
    [sym_false] = ACTIONS(6093),
    [sym_null] = ACTIONS(6093),
    [sym_identifier] = ACTIONS(6093),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6093),
    [sym_auto] = ACTIONS(6093),
    [anon_sym_typename] = ACTIONS(6093),
    [anon_sym_template] = ACTIONS(6093),
    [anon_sym_delete] = ACTIONS(6093),
    [anon_sym_namespace] = ACTIONS(6093),
    [anon_sym_using] = ACTIONS(6093),
    [anon_sym_try] = ACTIONS(6093),
    [anon_sym_new] = ACTIONS(6093),
    [anon_sym_COLON_COLON] = ACTIONS(6091),
    [sym_operator_name] = ACTIONS(6091),
    [sym_nullptr] = ACTIONS(6093),
  },
  [3779] = {
    [sym_compound_statement] = STATE(3837),
    [sym_labeled_statement] = STATE(3837),
    [sym_expression_statement] = STATE(3837),
    [sym_if_statement] = STATE(3837),
    [sym_switch_statement] = STATE(3837),
    [sym_case_statement] = STATE(3837),
    [sym_while_statement] = STATE(3837),
    [sym_do_statement] = STATE(3837),
    [sym_for_statement] = STATE(3837),
    [sym_return_statement] = STATE(3837),
    [sym_break_statement] = STATE(3837),
    [sym_continue_statement] = STATE(3837),
    [sym_goto_statement] = STATE(3837),
    [sym__expression] = STATE(1020),
    [sym_comma_expression] = STATE(1021),
    [sym_conditional_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1020),
    [sym_pointer_expression] = STATE(1020),
    [sym_logical_expression] = STATE(1020),
    [sym_bitwise_expression] = STATE(1020),
    [sym_equality_expression] = STATE(1020),
    [sym_relational_expression] = STATE(1020),
    [sym_shift_expression] = STATE(1020),
    [sym_math_expression] = STATE(1020),
    [sym_cast_expression] = STATE(1020),
    [sym_sizeof_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_field_expression] = STATE(1020),
    [sym_compound_literal_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_char_literal] = STATE(1020),
    [sym_concatenated_string] = STATE(1020),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1020),
    [sym_for_range_loop] = STATE(3837),
    [sym_try_statement] = STATE(3837),
    [sym_new_expression] = STATE(1020),
    [sym_delete_expression] = STATE(1020),
    [sym_lambda_expression] = STATE(1020),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2022),
    [anon_sym_SEMI] = ACTIONS(2036),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7300),
    [anon_sym_switch] = ACTIONS(7302),
    [anon_sym_case] = ACTIONS(7304),
    [anon_sym_default] = ACTIONS(7306),
    [anon_sym_while] = ACTIONS(7308),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(7310),
    [anon_sym_return] = ACTIONS(2058),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2062),
    [anon_sym_goto] = ACTIONS(2064),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(7312),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7314),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2066),
  },
  [3780] = {
    [sym_compound_statement] = STATE(3446),
    [sym_labeled_statement] = STATE(3446),
    [sym_expression_statement] = STATE(3446),
    [sym_if_statement] = STATE(3446),
    [sym_switch_statement] = STATE(3446),
    [sym_case_statement] = STATE(3446),
    [sym_while_statement] = STATE(3446),
    [sym_do_statement] = STATE(3446),
    [sym_for_statement] = STATE(3446),
    [sym_return_statement] = STATE(3446),
    [sym_break_statement] = STATE(3446),
    [sym_continue_statement] = STATE(3446),
    [sym_goto_statement] = STATE(3446),
    [sym__expression] = STATE(1020),
    [sym_comma_expression] = STATE(1021),
    [sym_conditional_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1020),
    [sym_pointer_expression] = STATE(1020),
    [sym_logical_expression] = STATE(1020),
    [sym_bitwise_expression] = STATE(1020),
    [sym_equality_expression] = STATE(1020),
    [sym_relational_expression] = STATE(1020),
    [sym_shift_expression] = STATE(1020),
    [sym_math_expression] = STATE(1020),
    [sym_cast_expression] = STATE(1020),
    [sym_sizeof_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_field_expression] = STATE(1020),
    [sym_compound_literal_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_char_literal] = STATE(1020),
    [sym_concatenated_string] = STATE(1020),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1020),
    [sym_for_range_loop] = STATE(3446),
    [sym_try_statement] = STATE(3446),
    [sym_new_expression] = STATE(1020),
    [sym_delete_expression] = STATE(1020),
    [sym_lambda_expression] = STATE(1020),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2022),
    [anon_sym_SEMI] = ACTIONS(2036),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7300),
    [anon_sym_switch] = ACTIONS(7302),
    [anon_sym_case] = ACTIONS(7304),
    [anon_sym_default] = ACTIONS(7306),
    [anon_sym_while] = ACTIONS(7308),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(7310),
    [anon_sym_return] = ACTIONS(2058),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2062),
    [anon_sym_goto] = ACTIONS(2064),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(7312),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7314),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2066),
  },
  [3781] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3839),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8421),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3782] = {
    [sym__expression] = STATE(3840),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3840),
    [sym_logical_expression] = STATE(3840),
    [sym_bitwise_expression] = STATE(3840),
    [sym_equality_expression] = STATE(3840),
    [sym_relational_expression] = STATE(3840),
    [sym_shift_expression] = STATE(3840),
    [sym_math_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3840),
    [sym_call_expression] = STATE(3840),
    [sym_field_expression] = STATE(3840),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3840),
    [sym_char_literal] = STATE(3840),
    [sym_concatenated_string] = STATE(3840),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8423),
    [anon_sym_RPAREN] = ACTIONS(8421),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(8423),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8425),
    [sym_false] = ACTIONS(8425),
    [sym_null] = ACTIONS(8425),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(8425),
  },
  [3783] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(8427),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3784] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(8429),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3785] = {
    [sym_raw_string_literal] = ACTIONS(8143),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(8145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(8145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(8145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(8145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(8145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(8145),
    [sym_preproc_directive] = ACTIONS(8145),
    [anon_sym_SEMI] = ACTIONS(8143),
    [anon_sym_typedef] = ACTIONS(8145),
    [anon_sym_extern] = ACTIONS(8145),
    [anon_sym_LBRACE] = ACTIONS(8143),
    [anon_sym_LPAREN2] = ACTIONS(8143),
    [anon_sym_STAR] = ACTIONS(8143),
    [anon_sym_LBRACK] = ACTIONS(8143),
    [anon_sym_static] = ACTIONS(8145),
    [anon_sym_register] = ACTIONS(8145),
    [anon_sym_inline] = ACTIONS(8145),
    [anon_sym_const] = ACTIONS(8145),
    [anon_sym_restrict] = ACTIONS(8145),
    [anon_sym_volatile] = ACTIONS(8145),
    [anon_sym__Atomic] = ACTIONS(8145),
    [anon_sym_mutable] = ACTIONS(8145),
    [anon_sym_explicit] = ACTIONS(8145),
    [anon_sym_constexpr] = ACTIONS(8145),
    [anon_sym_unsigned] = ACTIONS(8145),
    [anon_sym_long] = ACTIONS(8145),
    [anon_sym_short] = ACTIONS(8145),
    [sym_primitive_type] = ACTIONS(8145),
    [anon_sym_enum] = ACTIONS(8145),
    [anon_sym_struct] = ACTIONS(8145),
    [anon_sym_union] = ACTIONS(8145),
    [anon_sym_if] = ACTIONS(8145),
    [anon_sym_else] = ACTIONS(8145),
    [anon_sym_switch] = ACTIONS(8145),
    [anon_sym_case] = ACTIONS(8145),
    [anon_sym_default] = ACTIONS(8145),
    [anon_sym_while] = ACTIONS(8145),
    [anon_sym_do] = ACTIONS(8145),
    [anon_sym_for] = ACTIONS(8145),
    [anon_sym_return] = ACTIONS(8145),
    [anon_sym_break] = ACTIONS(8145),
    [anon_sym_continue] = ACTIONS(8145),
    [anon_sym_goto] = ACTIONS(8145),
    [anon_sym_AMP] = ACTIONS(8145),
    [anon_sym_AMP_AMP] = ACTIONS(8143),
    [anon_sym_BANG] = ACTIONS(8143),
    [anon_sym_TILDE] = ACTIONS(8143),
    [anon_sym_PLUS] = ACTIONS(8145),
    [anon_sym_DASH] = ACTIONS(8145),
    [anon_sym_DASH_DASH] = ACTIONS(8143),
    [anon_sym_PLUS_PLUS] = ACTIONS(8143),
    [anon_sym_sizeof] = ACTIONS(8145),
    [sym_number_literal] = ACTIONS(8143),
    [anon_sym_SQUOTE] = ACTIONS(8143),
    [anon_sym_DQUOTE] = ACTIONS(8143),
    [sym_true] = ACTIONS(8145),
    [sym_false] = ACTIONS(8145),
    [sym_null] = ACTIONS(8145),
    [sym_identifier] = ACTIONS(8145),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(8145),
    [sym_auto] = ACTIONS(8145),
    [anon_sym_typename] = ACTIONS(8145),
    [anon_sym_template] = ACTIONS(8145),
    [anon_sym_delete] = ACTIONS(8145),
    [anon_sym_namespace] = ACTIONS(8145),
    [anon_sym_using] = ACTIONS(8145),
    [anon_sym_try] = ACTIONS(8145),
    [anon_sym_new] = ACTIONS(8145),
    [anon_sym_COLON_COLON] = ACTIONS(8143),
    [sym_operator_name] = ACTIONS(8143),
    [sym_nullptr] = ACTIONS(8145),
  },
  [3786] = {
    [sym_compound_statement] = STATE(3843),
    [sym_labeled_statement] = STATE(3843),
    [sym_expression_statement] = STATE(3843),
    [sym_if_statement] = STATE(3843),
    [sym_switch_statement] = STATE(3843),
    [sym_case_statement] = STATE(3843),
    [sym_while_statement] = STATE(3843),
    [sym_do_statement] = STATE(3843),
    [sym_for_statement] = STATE(3843),
    [sym_return_statement] = STATE(3843),
    [sym_break_statement] = STATE(3843),
    [sym_continue_statement] = STATE(3843),
    [sym_goto_statement] = STATE(3843),
    [sym__expression] = STATE(1020),
    [sym_comma_expression] = STATE(1021),
    [sym_conditional_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1020),
    [sym_pointer_expression] = STATE(1020),
    [sym_logical_expression] = STATE(1020),
    [sym_bitwise_expression] = STATE(1020),
    [sym_equality_expression] = STATE(1020),
    [sym_relational_expression] = STATE(1020),
    [sym_shift_expression] = STATE(1020),
    [sym_math_expression] = STATE(1020),
    [sym_cast_expression] = STATE(1020),
    [sym_sizeof_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_field_expression] = STATE(1020),
    [sym_compound_literal_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_char_literal] = STATE(1020),
    [sym_concatenated_string] = STATE(1020),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1020),
    [sym_for_range_loop] = STATE(3843),
    [sym_try_statement] = STATE(3843),
    [sym_new_expression] = STATE(1020),
    [sym_delete_expression] = STATE(1020),
    [sym_lambda_expression] = STATE(1020),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2022),
    [anon_sym_SEMI] = ACTIONS(2036),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(2044),
    [anon_sym_switch] = ACTIONS(2046),
    [anon_sym_case] = ACTIONS(2048),
    [anon_sym_default] = ACTIONS(2050),
    [anon_sym_while] = ACTIONS(2052),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(2056),
    [anon_sym_return] = ACTIONS(2058),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2062),
    [anon_sym_goto] = ACTIONS(2064),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(5420),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2076),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2066),
  },
  [3787] = {
    [sym_compound_statement] = STATE(3460),
    [sym_labeled_statement] = STATE(3460),
    [sym_expression_statement] = STATE(3460),
    [sym_if_statement] = STATE(3460),
    [sym_switch_statement] = STATE(3460),
    [sym_case_statement] = STATE(3460),
    [sym_while_statement] = STATE(3460),
    [sym_do_statement] = STATE(3460),
    [sym_for_statement] = STATE(3460),
    [sym_return_statement] = STATE(3460),
    [sym_break_statement] = STATE(3460),
    [sym_continue_statement] = STATE(3460),
    [sym_goto_statement] = STATE(3460),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(411),
    [sym_for_range_loop] = STATE(3460),
    [sym_try_statement] = STATE(3460),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(678),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(6682),
    [anon_sym_switch] = ACTIONS(6684),
    [anon_sym_case] = ACTIONS(6686),
    [anon_sym_default] = ACTIONS(6688),
    [anon_sym_while] = ACTIONS(6690),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(6692),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(6694),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(6696),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(726),
  },
  [3788] = {
    [sym_raw_string_literal] = ACTIONS(7063),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7065),
    [sym_preproc_directive] = ACTIONS(7065),
    [anon_sym_SEMI] = ACTIONS(7063),
    [anon_sym_typedef] = ACTIONS(7065),
    [anon_sym_extern] = ACTIONS(7065),
    [anon_sym_LBRACE] = ACTIONS(7063),
    [anon_sym_LPAREN2] = ACTIONS(7063),
    [anon_sym_STAR] = ACTIONS(7063),
    [anon_sym_LBRACK] = ACTIONS(7063),
    [anon_sym_static] = ACTIONS(7065),
    [anon_sym_register] = ACTIONS(7065),
    [anon_sym_inline] = ACTIONS(7065),
    [anon_sym_const] = ACTIONS(7065),
    [anon_sym_restrict] = ACTIONS(7065),
    [anon_sym_volatile] = ACTIONS(7065),
    [anon_sym__Atomic] = ACTIONS(7065),
    [anon_sym_mutable] = ACTIONS(7065),
    [anon_sym_explicit] = ACTIONS(7065),
    [anon_sym_constexpr] = ACTIONS(7065),
    [anon_sym_unsigned] = ACTIONS(7065),
    [anon_sym_long] = ACTIONS(7065),
    [anon_sym_short] = ACTIONS(7065),
    [sym_primitive_type] = ACTIONS(7065),
    [anon_sym_enum] = ACTIONS(7065),
    [anon_sym_struct] = ACTIONS(7065),
    [anon_sym_union] = ACTIONS(7065),
    [anon_sym_if] = ACTIONS(7065),
    [anon_sym_else] = ACTIONS(8431),
    [anon_sym_switch] = ACTIONS(7065),
    [anon_sym_case] = ACTIONS(7065),
    [anon_sym_default] = ACTIONS(7065),
    [anon_sym_while] = ACTIONS(7065),
    [anon_sym_do] = ACTIONS(7065),
    [anon_sym_for] = ACTIONS(7065),
    [anon_sym_return] = ACTIONS(7065),
    [anon_sym_break] = ACTIONS(7065),
    [anon_sym_continue] = ACTIONS(7065),
    [anon_sym_goto] = ACTIONS(7065),
    [anon_sym_AMP] = ACTIONS(7065),
    [anon_sym_AMP_AMP] = ACTIONS(7063),
    [anon_sym_BANG] = ACTIONS(7063),
    [anon_sym_TILDE] = ACTIONS(7063),
    [anon_sym_PLUS] = ACTIONS(7065),
    [anon_sym_DASH] = ACTIONS(7065),
    [anon_sym_DASH_DASH] = ACTIONS(7063),
    [anon_sym_PLUS_PLUS] = ACTIONS(7063),
    [anon_sym_sizeof] = ACTIONS(7065),
    [sym_number_literal] = ACTIONS(7063),
    [anon_sym_SQUOTE] = ACTIONS(7063),
    [anon_sym_DQUOTE] = ACTIONS(7063),
    [sym_true] = ACTIONS(7065),
    [sym_false] = ACTIONS(7065),
    [sym_null] = ACTIONS(7065),
    [sym_identifier] = ACTIONS(7065),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7065),
    [sym_auto] = ACTIONS(7065),
    [anon_sym_typename] = ACTIONS(7065),
    [anon_sym_template] = ACTIONS(7065),
    [anon_sym_delete] = ACTIONS(7065),
    [anon_sym_namespace] = ACTIONS(7065),
    [anon_sym_using] = ACTIONS(7065),
    [anon_sym_try] = ACTIONS(7065),
    [anon_sym_new] = ACTIONS(7065),
    [anon_sym_COLON_COLON] = ACTIONS(7063),
    [sym_operator_name] = ACTIONS(7063),
    [sym_nullptr] = ACTIONS(7065),
  },
  [3789] = {
    [sym_compound_statement] = STATE(3462),
    [sym_labeled_statement] = STATE(3462),
    [sym_expression_statement] = STATE(3462),
    [sym_if_statement] = STATE(3462),
    [sym_switch_statement] = STATE(3462),
    [sym_case_statement] = STATE(3462),
    [sym_while_statement] = STATE(3462),
    [sym_do_statement] = STATE(3462),
    [sym_for_statement] = STATE(3462),
    [sym_return_statement] = STATE(3462),
    [sym_break_statement] = STATE(3462),
    [sym_continue_statement] = STATE(3462),
    [sym_goto_statement] = STATE(3462),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(411),
    [sym_for_range_loop] = STATE(3462),
    [sym_try_statement] = STATE(3462),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(678),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(6682),
    [anon_sym_switch] = ACTIONS(6684),
    [anon_sym_case] = ACTIONS(6686),
    [anon_sym_default] = ACTIONS(6688),
    [anon_sym_while] = ACTIONS(6690),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(6692),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(6694),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(6696),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(726),
  },
  [3790] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8433),
    [sym_comment] = ACTIONS(91),
  },
  [3791] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3846),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8433),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3792] = {
    [sym__expression] = STATE(3847),
    [sym_conditional_expression] = STATE(3847),
    [sym_assignment_expression] = STATE(3847),
    [sym_pointer_expression] = STATE(3847),
    [sym_logical_expression] = STATE(3847),
    [sym_bitwise_expression] = STATE(3847),
    [sym_equality_expression] = STATE(3847),
    [sym_relational_expression] = STATE(3847),
    [sym_shift_expression] = STATE(3847),
    [sym_math_expression] = STATE(3847),
    [sym_cast_expression] = STATE(3847),
    [sym_sizeof_expression] = STATE(3847),
    [sym_subscript_expression] = STATE(3847),
    [sym_call_expression] = STATE(3847),
    [sym_field_expression] = STATE(3847),
    [sym_compound_literal_expression] = STATE(3847),
    [sym_parenthesized_expression] = STATE(3847),
    [sym_char_literal] = STATE(3847),
    [sym_concatenated_string] = STATE(3847),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3847),
    [sym_new_expression] = STATE(3847),
    [sym_delete_expression] = STATE(3847),
    [sym_lambda_expression] = STATE(3847),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8435),
    [anon_sym_RPAREN] = ACTIONS(8433),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(8435),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8437),
    [sym_false] = ACTIONS(8437),
    [sym_null] = ACTIONS(8437),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(8437),
  },
  [3793] = {
    [sym_compound_statement] = STATE(3466),
    [sym_labeled_statement] = STATE(3466),
    [sym_expression_statement] = STATE(3466),
    [sym_if_statement] = STATE(3466),
    [sym_switch_statement] = STATE(3466),
    [sym_case_statement] = STATE(3466),
    [sym_while_statement] = STATE(3466),
    [sym_do_statement] = STATE(3466),
    [sym_for_statement] = STATE(3466),
    [sym_return_statement] = STATE(3466),
    [sym_break_statement] = STATE(3466),
    [sym_continue_statement] = STATE(3466),
    [sym_goto_statement] = STATE(3466),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(411),
    [sym_for_range_loop] = STATE(3466),
    [sym_try_statement] = STATE(3466),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(678),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(6682),
    [anon_sym_switch] = ACTIONS(6684),
    [anon_sym_case] = ACTIONS(6686),
    [anon_sym_default] = ACTIONS(6688),
    [anon_sym_while] = ACTIONS(6690),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(6692),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(6694),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(6696),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(726),
  },
  [3794] = {
    [sym_raw_string_literal] = ACTIONS(8287),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(8289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(8289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(8289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(8289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(8289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(8289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(8289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(8289),
    [sym_preproc_directive] = ACTIONS(8289),
    [anon_sym_SEMI] = ACTIONS(8287),
    [anon_sym_typedef] = ACTIONS(8289),
    [anon_sym_extern] = ACTIONS(8289),
    [anon_sym_LBRACE] = ACTIONS(8287),
    [anon_sym_LPAREN2] = ACTIONS(8287),
    [anon_sym_STAR] = ACTIONS(8287),
    [anon_sym_LBRACK] = ACTIONS(8287),
    [anon_sym_static] = ACTIONS(8289),
    [anon_sym_register] = ACTIONS(8289),
    [anon_sym_inline] = ACTIONS(8289),
    [anon_sym_const] = ACTIONS(8289),
    [anon_sym_restrict] = ACTIONS(8289),
    [anon_sym_volatile] = ACTIONS(8289),
    [anon_sym__Atomic] = ACTIONS(8289),
    [anon_sym_mutable] = ACTIONS(8289),
    [anon_sym_explicit] = ACTIONS(8289),
    [anon_sym_constexpr] = ACTIONS(8289),
    [anon_sym_unsigned] = ACTIONS(8289),
    [anon_sym_long] = ACTIONS(8289),
    [anon_sym_short] = ACTIONS(8289),
    [sym_primitive_type] = ACTIONS(8289),
    [anon_sym_enum] = ACTIONS(8289),
    [anon_sym_struct] = ACTIONS(8289),
    [anon_sym_union] = ACTIONS(8289),
    [anon_sym_if] = ACTIONS(8289),
    [anon_sym_else] = ACTIONS(8289),
    [anon_sym_switch] = ACTIONS(8289),
    [anon_sym_case] = ACTIONS(8289),
    [anon_sym_default] = ACTIONS(8289),
    [anon_sym_while] = ACTIONS(8289),
    [anon_sym_do] = ACTIONS(8289),
    [anon_sym_for] = ACTIONS(8289),
    [anon_sym_return] = ACTIONS(8289),
    [anon_sym_break] = ACTIONS(8289),
    [anon_sym_continue] = ACTIONS(8289),
    [anon_sym_goto] = ACTIONS(8289),
    [anon_sym_AMP] = ACTIONS(8289),
    [anon_sym_AMP_AMP] = ACTIONS(8287),
    [anon_sym_BANG] = ACTIONS(8287),
    [anon_sym_TILDE] = ACTIONS(8287),
    [anon_sym_PLUS] = ACTIONS(8289),
    [anon_sym_DASH] = ACTIONS(8289),
    [anon_sym_DASH_DASH] = ACTIONS(8287),
    [anon_sym_PLUS_PLUS] = ACTIONS(8287),
    [anon_sym_sizeof] = ACTIONS(8289),
    [sym_number_literal] = ACTIONS(8287),
    [anon_sym_SQUOTE] = ACTIONS(8287),
    [anon_sym_DQUOTE] = ACTIONS(8287),
    [sym_true] = ACTIONS(8289),
    [sym_false] = ACTIONS(8289),
    [sym_null] = ACTIONS(8289),
    [sym_identifier] = ACTIONS(8289),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(8289),
    [sym_auto] = ACTIONS(8289),
    [anon_sym_typename] = ACTIONS(8289),
    [anon_sym_template] = ACTIONS(8289),
    [anon_sym_delete] = ACTIONS(8289),
    [anon_sym_namespace] = ACTIONS(8289),
    [anon_sym_using] = ACTIONS(8289),
    [anon_sym_try] = ACTIONS(8289),
    [anon_sym_new] = ACTIONS(8289),
    [anon_sym_COLON_COLON] = ACTIONS(8287),
    [sym_operator_name] = ACTIONS(8287),
    [sym_nullptr] = ACTIONS(8289),
  },
  [3795] = {
    [sym_compound_statement] = STATE(3848),
    [sym_labeled_statement] = STATE(3848),
    [sym_expression_statement] = STATE(3848),
    [sym_if_statement] = STATE(3848),
    [sym_switch_statement] = STATE(3848),
    [sym_case_statement] = STATE(3848),
    [sym_while_statement] = STATE(3848),
    [sym_do_statement] = STATE(3848),
    [sym_for_statement] = STATE(3848),
    [sym_return_statement] = STATE(3848),
    [sym_break_statement] = STATE(3848),
    [sym_continue_statement] = STATE(3848),
    [sym_goto_statement] = STATE(3848),
    [sym__expression] = STATE(1908),
    [sym_comma_expression] = STATE(1909),
    [sym_conditional_expression] = STATE(1908),
    [sym_assignment_expression] = STATE(1908),
    [sym_pointer_expression] = STATE(1908),
    [sym_logical_expression] = STATE(1908),
    [sym_bitwise_expression] = STATE(1908),
    [sym_equality_expression] = STATE(1908),
    [sym_relational_expression] = STATE(1908),
    [sym_shift_expression] = STATE(1908),
    [sym_math_expression] = STATE(1908),
    [sym_cast_expression] = STATE(1908),
    [sym_sizeof_expression] = STATE(1908),
    [sym_subscript_expression] = STATE(1908),
    [sym_call_expression] = STATE(1908),
    [sym_field_expression] = STATE(1908),
    [sym_compound_literal_expression] = STATE(1908),
    [sym_parenthesized_expression] = STATE(1908),
    [sym_char_literal] = STATE(1908),
    [sym_concatenated_string] = STATE(1908),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1908),
    [sym_for_range_loop] = STATE(3848),
    [sym_try_statement] = STATE(3848),
    [sym_new_expression] = STATE(1908),
    [sym_delete_expression] = STATE(1908),
    [sym_lambda_expression] = STATE(1908),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3996),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7766),
    [anon_sym_switch] = ACTIONS(7768),
    [anon_sym_case] = ACTIONS(7770),
    [anon_sym_default] = ACTIONS(7772),
    [anon_sym_while] = ACTIONS(7774),
    [anon_sym_do] = ACTIONS(4026),
    [anon_sym_for] = ACTIONS(7776),
    [anon_sym_return] = ACTIONS(4030),
    [anon_sym_break] = ACTIONS(4032),
    [anon_sym_continue] = ACTIONS(4034),
    [anon_sym_goto] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(3996),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4038),
    [sym_false] = ACTIONS(4038),
    [sym_null] = ACTIONS(4038),
    [sym_identifier] = ACTIONS(7778),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7780),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(4038),
  },
  [3796] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(8439),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3797] = {
    [sym__expression] = STATE(3851),
    [sym_conditional_expression] = STATE(3851),
    [sym_assignment_expression] = STATE(3851),
    [sym_pointer_expression] = STATE(3851),
    [sym_logical_expression] = STATE(3851),
    [sym_bitwise_expression] = STATE(3851),
    [sym_equality_expression] = STATE(3851),
    [sym_relational_expression] = STATE(3851),
    [sym_shift_expression] = STATE(3851),
    [sym_math_expression] = STATE(3851),
    [sym_cast_expression] = STATE(3851),
    [sym_sizeof_expression] = STATE(3851),
    [sym_subscript_expression] = STATE(3851),
    [sym_call_expression] = STATE(3851),
    [sym_field_expression] = STATE(3851),
    [sym_compound_literal_expression] = STATE(3851),
    [sym_parenthesized_expression] = STATE(3851),
    [sym_char_literal] = STATE(3851),
    [sym_concatenated_string] = STATE(3851),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3851),
    [sym_new_expression] = STATE(3851),
    [sym_delete_expression] = STATE(3851),
    [sym_lambda_expression] = STATE(3851),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8441),
    [anon_sym_RPAREN] = ACTIONS(8443),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(8441),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8445),
    [sym_false] = ACTIONS(8445),
    [sym_null] = ACTIONS(8445),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(8445),
  },
  [3798] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(8447),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3799] = {
    [sym__expression] = STATE(3853),
    [sym_conditional_expression] = STATE(3853),
    [sym_assignment_expression] = STATE(3853),
    [sym_pointer_expression] = STATE(3853),
    [sym_logical_expression] = STATE(3853),
    [sym_bitwise_expression] = STATE(3853),
    [sym_equality_expression] = STATE(3853),
    [sym_relational_expression] = STATE(3853),
    [sym_shift_expression] = STATE(3853),
    [sym_math_expression] = STATE(3853),
    [sym_cast_expression] = STATE(3853),
    [sym_sizeof_expression] = STATE(3853),
    [sym_subscript_expression] = STATE(3853),
    [sym_call_expression] = STATE(3853),
    [sym_field_expression] = STATE(3853),
    [sym_compound_literal_expression] = STATE(3853),
    [sym_parenthesized_expression] = STATE(3853),
    [sym_char_literal] = STATE(3853),
    [sym_concatenated_string] = STATE(3853),
    [sym_string_literal] = STATE(238),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3853),
    [sym_new_expression] = STATE(3853),
    [sym_delete_expression] = STATE(3853),
    [sym_lambda_expression] = STATE(3853),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8449),
    [anon_sym_SEMI] = ACTIONS(8447),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_sizeof] = ACTIONS(407),
    [sym_number_literal] = ACTIONS(8449),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8451),
    [sym_false] = ACTIONS(8451),
    [sym_null] = ACTIONS(8451),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(411),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(415),
    [sym_nullptr] = ACTIONS(8451),
  },
  [3800] = {
    [sym__expression] = STATE(3854),
    [sym_conditional_expression] = STATE(3854),
    [sym_assignment_expression] = STATE(3854),
    [sym_pointer_expression] = STATE(3854),
    [sym_logical_expression] = STATE(3854),
    [sym_bitwise_expression] = STATE(3854),
    [sym_equality_expression] = STATE(3854),
    [sym_relational_expression] = STATE(3854),
    [sym_shift_expression] = STATE(3854),
    [sym_math_expression] = STATE(3854),
    [sym_cast_expression] = STATE(3854),
    [sym_sizeof_expression] = STATE(3854),
    [sym_subscript_expression] = STATE(3854),
    [sym_call_expression] = STATE(3854),
    [sym_field_expression] = STATE(3854),
    [sym_compound_literal_expression] = STATE(3854),
    [sym_parenthesized_expression] = STATE(3854),
    [sym_char_literal] = STATE(3854),
    [sym_concatenated_string] = STATE(3854),
    [sym_string_literal] = STATE(637),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3854),
    [sym_new_expression] = STATE(3854),
    [sym_delete_expression] = STATE(3854),
    [sym_lambda_expression] = STATE(3854),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8453),
    [anon_sym_LPAREN2] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_sizeof] = ACTIONS(1099),
    [sym_number_literal] = ACTIONS(8453),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8455),
    [sym_false] = ACTIONS(8455),
    [sym_null] = ACTIONS(8455),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [sym_nullptr] = ACTIONS(8455),
  },
  [3801] = {
    [sym_catch_clause] = STATE(3801),
    [aux_sym_try_statement_repeat1] = STATE(3801),
    [sym_raw_string_literal] = ACTIONS(4993),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4995),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4995),
    [sym_preproc_directive] = ACTIONS(4995),
    [anon_sym_SEMI] = ACTIONS(4993),
    [anon_sym_typedef] = ACTIONS(4995),
    [anon_sym_extern] = ACTIONS(4995),
    [anon_sym_LBRACE] = ACTIONS(4993),
    [anon_sym_LPAREN2] = ACTIONS(4993),
    [anon_sym_STAR] = ACTIONS(4993),
    [anon_sym_LBRACK] = ACTIONS(4993),
    [anon_sym_static] = ACTIONS(4995),
    [anon_sym_register] = ACTIONS(4995),
    [anon_sym_inline] = ACTIONS(4995),
    [anon_sym_const] = ACTIONS(4995),
    [anon_sym_restrict] = ACTIONS(4995),
    [anon_sym_volatile] = ACTIONS(4995),
    [anon_sym__Atomic] = ACTIONS(4995),
    [anon_sym_mutable] = ACTIONS(4995),
    [anon_sym_explicit] = ACTIONS(4995),
    [anon_sym_constexpr] = ACTIONS(4995),
    [anon_sym_unsigned] = ACTIONS(4995),
    [anon_sym_long] = ACTIONS(4995),
    [anon_sym_short] = ACTIONS(4995),
    [sym_primitive_type] = ACTIONS(4995),
    [anon_sym_enum] = ACTIONS(4995),
    [anon_sym_struct] = ACTIONS(4995),
    [anon_sym_union] = ACTIONS(4995),
    [anon_sym_if] = ACTIONS(4995),
    [anon_sym_else] = ACTIONS(4995),
    [anon_sym_switch] = ACTIONS(4995),
    [anon_sym_case] = ACTIONS(4995),
    [anon_sym_default] = ACTIONS(4995),
    [anon_sym_while] = ACTIONS(4995),
    [anon_sym_do] = ACTIONS(4995),
    [anon_sym_for] = ACTIONS(4995),
    [anon_sym_return] = ACTIONS(4995),
    [anon_sym_break] = ACTIONS(4995),
    [anon_sym_continue] = ACTIONS(4995),
    [anon_sym_goto] = ACTIONS(4995),
    [anon_sym_AMP] = ACTIONS(4993),
    [anon_sym_BANG] = ACTIONS(4993),
    [anon_sym_TILDE] = ACTIONS(4993),
    [anon_sym_PLUS] = ACTIONS(4995),
    [anon_sym_DASH] = ACTIONS(4995),
    [anon_sym_DASH_DASH] = ACTIONS(4993),
    [anon_sym_PLUS_PLUS] = ACTIONS(4993),
    [anon_sym_sizeof] = ACTIONS(4995),
    [sym_number_literal] = ACTIONS(4993),
    [anon_sym_SQUOTE] = ACTIONS(4993),
    [anon_sym_DQUOTE] = ACTIONS(4993),
    [sym_true] = ACTIONS(4995),
    [sym_false] = ACTIONS(4995),
    [sym_null] = ACTIONS(4995),
    [sym_identifier] = ACTIONS(4995),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(4995),
    [sym_auto] = ACTIONS(4995),
    [anon_sym_typename] = ACTIONS(4995),
    [anon_sym_delete] = ACTIONS(4995),
    [anon_sym_try] = ACTIONS(4995),
    [anon_sym_catch] = ACTIONS(7804),
    [anon_sym_new] = ACTIONS(4995),
    [anon_sym_COLON_COLON] = ACTIONS(4993),
    [sym_nullptr] = ACTIONS(4995),
  },
  [3802] = {
    [sym_raw_string_literal] = ACTIONS(7906),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7908),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7908),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7908),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7908),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7908),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7908),
    [sym_preproc_directive] = ACTIONS(7908),
    [anon_sym_SEMI] = ACTIONS(7906),
    [anon_sym_typedef] = ACTIONS(7908),
    [anon_sym_extern] = ACTIONS(7908),
    [anon_sym_LBRACE] = ACTIONS(7906),
    [anon_sym_LPAREN2] = ACTIONS(7906),
    [anon_sym_STAR] = ACTIONS(7906),
    [anon_sym_LBRACK] = ACTIONS(7906),
    [anon_sym_static] = ACTIONS(7908),
    [anon_sym_register] = ACTIONS(7908),
    [anon_sym_inline] = ACTIONS(7908),
    [anon_sym_const] = ACTIONS(7908),
    [anon_sym_restrict] = ACTIONS(7908),
    [anon_sym_volatile] = ACTIONS(7908),
    [anon_sym__Atomic] = ACTIONS(7908),
    [anon_sym_mutable] = ACTIONS(7908),
    [anon_sym_explicit] = ACTIONS(7908),
    [anon_sym_constexpr] = ACTIONS(7908),
    [anon_sym_unsigned] = ACTIONS(7908),
    [anon_sym_long] = ACTIONS(7908),
    [anon_sym_short] = ACTIONS(7908),
    [sym_primitive_type] = ACTIONS(7908),
    [anon_sym_enum] = ACTIONS(7908),
    [anon_sym_struct] = ACTIONS(7908),
    [anon_sym_union] = ACTIONS(7908),
    [anon_sym_if] = ACTIONS(7908),
    [anon_sym_else] = ACTIONS(7908),
    [anon_sym_switch] = ACTIONS(7908),
    [anon_sym_case] = ACTIONS(7908),
    [anon_sym_default] = ACTIONS(7908),
    [anon_sym_while] = ACTIONS(7908),
    [anon_sym_do] = ACTIONS(7908),
    [anon_sym_for] = ACTIONS(7908),
    [anon_sym_return] = ACTIONS(7908),
    [anon_sym_break] = ACTIONS(7908),
    [anon_sym_continue] = ACTIONS(7908),
    [anon_sym_goto] = ACTIONS(7908),
    [anon_sym_AMP] = ACTIONS(7906),
    [anon_sym_BANG] = ACTIONS(7906),
    [anon_sym_TILDE] = ACTIONS(7906),
    [anon_sym_PLUS] = ACTIONS(7908),
    [anon_sym_DASH] = ACTIONS(7908),
    [anon_sym_DASH_DASH] = ACTIONS(7906),
    [anon_sym_PLUS_PLUS] = ACTIONS(7906),
    [anon_sym_sizeof] = ACTIONS(7908),
    [sym_number_literal] = ACTIONS(7906),
    [anon_sym_SQUOTE] = ACTIONS(7906),
    [anon_sym_DQUOTE] = ACTIONS(7906),
    [sym_true] = ACTIONS(7908),
    [sym_false] = ACTIONS(7908),
    [sym_null] = ACTIONS(7908),
    [sym_identifier] = ACTIONS(7908),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7908),
    [sym_auto] = ACTIONS(7908),
    [anon_sym_typename] = ACTIONS(7908),
    [anon_sym_delete] = ACTIONS(7908),
    [anon_sym_try] = ACTIONS(7908),
    [anon_sym_new] = ACTIONS(7908),
    [anon_sym_COLON_COLON] = ACTIONS(7906),
    [sym_nullptr] = ACTIONS(7908),
  },
  [3803] = {
    [sym_raw_string_literal] = ACTIONS(7928),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7930),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7930),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7930),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7930),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7930),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7930),
    [sym_preproc_directive] = ACTIONS(7930),
    [anon_sym_SEMI] = ACTIONS(7928),
    [anon_sym_typedef] = ACTIONS(7930),
    [anon_sym_extern] = ACTIONS(7930),
    [anon_sym_LBRACE] = ACTIONS(7928),
    [anon_sym_LPAREN2] = ACTIONS(7928),
    [anon_sym_STAR] = ACTIONS(7928),
    [anon_sym_LBRACK] = ACTIONS(7928),
    [anon_sym_static] = ACTIONS(7930),
    [anon_sym_register] = ACTIONS(7930),
    [anon_sym_inline] = ACTIONS(7930),
    [anon_sym_const] = ACTIONS(7930),
    [anon_sym_restrict] = ACTIONS(7930),
    [anon_sym_volatile] = ACTIONS(7930),
    [anon_sym__Atomic] = ACTIONS(7930),
    [anon_sym_mutable] = ACTIONS(7930),
    [anon_sym_explicit] = ACTIONS(7930),
    [anon_sym_constexpr] = ACTIONS(7930),
    [anon_sym_unsigned] = ACTIONS(7930),
    [anon_sym_long] = ACTIONS(7930),
    [anon_sym_short] = ACTIONS(7930),
    [sym_primitive_type] = ACTIONS(7930),
    [anon_sym_enum] = ACTIONS(7930),
    [anon_sym_struct] = ACTIONS(7930),
    [anon_sym_union] = ACTIONS(7930),
    [anon_sym_if] = ACTIONS(7930),
    [anon_sym_else] = ACTIONS(7930),
    [anon_sym_switch] = ACTIONS(7930),
    [anon_sym_case] = ACTIONS(7930),
    [anon_sym_default] = ACTIONS(7930),
    [anon_sym_while] = ACTIONS(7930),
    [anon_sym_do] = ACTIONS(7930),
    [anon_sym_for] = ACTIONS(7930),
    [anon_sym_return] = ACTIONS(7930),
    [anon_sym_break] = ACTIONS(7930),
    [anon_sym_continue] = ACTIONS(7930),
    [anon_sym_goto] = ACTIONS(7930),
    [anon_sym_AMP] = ACTIONS(7928),
    [anon_sym_BANG] = ACTIONS(7928),
    [anon_sym_TILDE] = ACTIONS(7928),
    [anon_sym_PLUS] = ACTIONS(7930),
    [anon_sym_DASH] = ACTIONS(7930),
    [anon_sym_DASH_DASH] = ACTIONS(7928),
    [anon_sym_PLUS_PLUS] = ACTIONS(7928),
    [anon_sym_sizeof] = ACTIONS(7930),
    [sym_number_literal] = ACTIONS(7928),
    [anon_sym_SQUOTE] = ACTIONS(7928),
    [anon_sym_DQUOTE] = ACTIONS(7928),
    [sym_true] = ACTIONS(7930),
    [sym_false] = ACTIONS(7930),
    [sym_null] = ACTIONS(7930),
    [sym_identifier] = ACTIONS(7930),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7930),
    [sym_auto] = ACTIONS(7930),
    [anon_sym_typename] = ACTIONS(7930),
    [anon_sym_delete] = ACTIONS(7930),
    [anon_sym_try] = ACTIONS(7930),
    [anon_sym_new] = ACTIONS(7930),
    [anon_sym_COLON_COLON] = ACTIONS(7928),
    [sym_nullptr] = ACTIONS(7930),
  },
  [3804] = {
    [sym_compound_statement] = STATE(3855),
    [sym_labeled_statement] = STATE(3855),
    [sym_expression_statement] = STATE(3855),
    [sym_if_statement] = STATE(3855),
    [sym_switch_statement] = STATE(3855),
    [sym_case_statement] = STATE(3855),
    [sym_while_statement] = STATE(3855),
    [sym_do_statement] = STATE(3855),
    [sym_for_statement] = STATE(3855),
    [sym_return_statement] = STATE(3855),
    [sym_break_statement] = STATE(3855),
    [sym_continue_statement] = STATE(3855),
    [sym_goto_statement] = STATE(3855),
    [sym__expression] = STATE(1908),
    [sym_comma_expression] = STATE(1909),
    [sym_conditional_expression] = STATE(1908),
    [sym_assignment_expression] = STATE(1908),
    [sym_pointer_expression] = STATE(1908),
    [sym_logical_expression] = STATE(1908),
    [sym_bitwise_expression] = STATE(1908),
    [sym_equality_expression] = STATE(1908),
    [sym_relational_expression] = STATE(1908),
    [sym_shift_expression] = STATE(1908),
    [sym_math_expression] = STATE(1908),
    [sym_cast_expression] = STATE(1908),
    [sym_sizeof_expression] = STATE(1908),
    [sym_subscript_expression] = STATE(1908),
    [sym_call_expression] = STATE(1908),
    [sym_field_expression] = STATE(1908),
    [sym_compound_literal_expression] = STATE(1908),
    [sym_parenthesized_expression] = STATE(1908),
    [sym_char_literal] = STATE(1908),
    [sym_concatenated_string] = STATE(1908),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1908),
    [sym_for_range_loop] = STATE(3855),
    [sym_try_statement] = STATE(3855),
    [sym_new_expression] = STATE(1908),
    [sym_delete_expression] = STATE(1908),
    [sym_lambda_expression] = STATE(1908),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3996),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(4016),
    [anon_sym_switch] = ACTIONS(4018),
    [anon_sym_case] = ACTIONS(4020),
    [anon_sym_default] = ACTIONS(4022),
    [anon_sym_while] = ACTIONS(4024),
    [anon_sym_do] = ACTIONS(4026),
    [anon_sym_for] = ACTIONS(4028),
    [anon_sym_return] = ACTIONS(4030),
    [anon_sym_break] = ACTIONS(4032),
    [anon_sym_continue] = ACTIONS(4034),
    [anon_sym_goto] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(3996),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4038),
    [sym_false] = ACTIONS(4038),
    [sym_null] = ACTIONS(4038),
    [sym_identifier] = ACTIONS(6773),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(4042),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(4038),
  },
  [3805] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8457),
    [sym_comment] = ACTIONS(91),
  },
  [3806] = {
    [sym_raw_string_literal] = ACTIONS(6091),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(6093),
    [sym_preproc_directive] = ACTIONS(6093),
    [anon_sym_SEMI] = ACTIONS(6091),
    [anon_sym_typedef] = ACTIONS(6093),
    [anon_sym_extern] = ACTIONS(6093),
    [anon_sym_LBRACE] = ACTIONS(6091),
    [anon_sym_LPAREN2] = ACTIONS(6091),
    [anon_sym_STAR] = ACTIONS(6091),
    [anon_sym_LBRACK] = ACTIONS(6091),
    [anon_sym_static] = ACTIONS(6093),
    [anon_sym_register] = ACTIONS(6093),
    [anon_sym_inline] = ACTIONS(6093),
    [anon_sym_const] = ACTIONS(6093),
    [anon_sym_restrict] = ACTIONS(6093),
    [anon_sym_volatile] = ACTIONS(6093),
    [anon_sym__Atomic] = ACTIONS(6093),
    [anon_sym_mutable] = ACTIONS(6093),
    [anon_sym_explicit] = ACTIONS(6093),
    [anon_sym_constexpr] = ACTIONS(6093),
    [anon_sym_unsigned] = ACTIONS(6093),
    [anon_sym_long] = ACTIONS(6093),
    [anon_sym_short] = ACTIONS(6093),
    [sym_primitive_type] = ACTIONS(6093),
    [anon_sym_enum] = ACTIONS(6093),
    [anon_sym_struct] = ACTIONS(6093),
    [anon_sym_union] = ACTIONS(6093),
    [anon_sym_if] = ACTIONS(6093),
    [anon_sym_else] = ACTIONS(8459),
    [anon_sym_switch] = ACTIONS(6093),
    [anon_sym_case] = ACTIONS(6093),
    [anon_sym_default] = ACTIONS(6093),
    [anon_sym_while] = ACTIONS(6093),
    [anon_sym_do] = ACTIONS(6093),
    [anon_sym_for] = ACTIONS(6093),
    [anon_sym_return] = ACTIONS(6093),
    [anon_sym_break] = ACTIONS(6093),
    [anon_sym_continue] = ACTIONS(6093),
    [anon_sym_goto] = ACTIONS(6093),
    [anon_sym_AMP] = ACTIONS(6091),
    [anon_sym_BANG] = ACTIONS(6091),
    [anon_sym_TILDE] = ACTIONS(6091),
    [anon_sym_PLUS] = ACTIONS(6093),
    [anon_sym_DASH] = ACTIONS(6093),
    [anon_sym_DASH_DASH] = ACTIONS(6091),
    [anon_sym_PLUS_PLUS] = ACTIONS(6091),
    [anon_sym_sizeof] = ACTIONS(6093),
    [sym_number_literal] = ACTIONS(6091),
    [anon_sym_SQUOTE] = ACTIONS(6091),
    [anon_sym_DQUOTE] = ACTIONS(6091),
    [sym_true] = ACTIONS(6093),
    [sym_false] = ACTIONS(6093),
    [sym_null] = ACTIONS(6093),
    [sym_identifier] = ACTIONS(6093),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6093),
    [sym_auto] = ACTIONS(6093),
    [anon_sym_typename] = ACTIONS(6093),
    [anon_sym_delete] = ACTIONS(6093),
    [anon_sym_try] = ACTIONS(6093),
    [anon_sym_new] = ACTIONS(6093),
    [anon_sym_COLON_COLON] = ACTIONS(6091),
    [sym_nullptr] = ACTIONS(6093),
  },
  [3807] = {
    [sym_compound_statement] = STATE(3858),
    [sym_labeled_statement] = STATE(3858),
    [sym_expression_statement] = STATE(3858),
    [sym_if_statement] = STATE(3858),
    [sym_switch_statement] = STATE(3858),
    [sym_case_statement] = STATE(3858),
    [sym_while_statement] = STATE(3858),
    [sym_do_statement] = STATE(3858),
    [sym_for_statement] = STATE(3858),
    [sym_return_statement] = STATE(3858),
    [sym_break_statement] = STATE(3858),
    [sym_continue_statement] = STATE(3858),
    [sym_goto_statement] = STATE(3858),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(3858),
    [sym_try_statement] = STATE(3858),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7431),
    [anon_sym_switch] = ACTIONS(7433),
    [anon_sym_case] = ACTIONS(7435),
    [anon_sym_default] = ACTIONS(7437),
    [anon_sym_while] = ACTIONS(7439),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(7441),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(7443),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7445),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2242),
  },
  [3808] = {
    [sym_compound_statement] = STATE(3502),
    [sym_labeled_statement] = STATE(3502),
    [sym_expression_statement] = STATE(3502),
    [sym_if_statement] = STATE(3502),
    [sym_switch_statement] = STATE(3502),
    [sym_case_statement] = STATE(3502),
    [sym_while_statement] = STATE(3502),
    [sym_do_statement] = STATE(3502),
    [sym_for_statement] = STATE(3502),
    [sym_return_statement] = STATE(3502),
    [sym_break_statement] = STATE(3502),
    [sym_continue_statement] = STATE(3502),
    [sym_goto_statement] = STATE(3502),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(3502),
    [sym_try_statement] = STATE(3502),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7431),
    [anon_sym_switch] = ACTIONS(7433),
    [anon_sym_case] = ACTIONS(7435),
    [anon_sym_default] = ACTIONS(7437),
    [anon_sym_while] = ACTIONS(7439),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(7441),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(7443),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7445),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2242),
  },
  [3809] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3860),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8461),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3810] = {
    [sym__expression] = STATE(3861),
    [sym_conditional_expression] = STATE(3861),
    [sym_assignment_expression] = STATE(3861),
    [sym_pointer_expression] = STATE(3861),
    [sym_logical_expression] = STATE(3861),
    [sym_bitwise_expression] = STATE(3861),
    [sym_equality_expression] = STATE(3861),
    [sym_relational_expression] = STATE(3861),
    [sym_shift_expression] = STATE(3861),
    [sym_math_expression] = STATE(3861),
    [sym_cast_expression] = STATE(3861),
    [sym_sizeof_expression] = STATE(3861),
    [sym_subscript_expression] = STATE(3861),
    [sym_call_expression] = STATE(3861),
    [sym_field_expression] = STATE(3861),
    [sym_compound_literal_expression] = STATE(3861),
    [sym_parenthesized_expression] = STATE(3861),
    [sym_char_literal] = STATE(3861),
    [sym_concatenated_string] = STATE(3861),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3861),
    [sym_new_expression] = STATE(3861),
    [sym_delete_expression] = STATE(3861),
    [sym_lambda_expression] = STATE(3861),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8463),
    [anon_sym_RPAREN] = ACTIONS(8461),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(8463),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8465),
    [sym_false] = ACTIONS(8465),
    [sym_null] = ACTIONS(8465),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(8465),
  },
  [3811] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(8467),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3812] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(8469),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3813] = {
    [sym_raw_string_literal] = ACTIONS(8143),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(8145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(8145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(8145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(8145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(8145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(8145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(8145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(8145),
    [sym_preproc_directive] = ACTIONS(8145),
    [anon_sym_SEMI] = ACTIONS(8143),
    [anon_sym_typedef] = ACTIONS(8145),
    [anon_sym_extern] = ACTIONS(8145),
    [anon_sym_LBRACE] = ACTIONS(8143),
    [anon_sym_LPAREN2] = ACTIONS(8143),
    [anon_sym_STAR] = ACTIONS(8143),
    [anon_sym_LBRACK] = ACTIONS(8143),
    [anon_sym_static] = ACTIONS(8145),
    [anon_sym_register] = ACTIONS(8145),
    [anon_sym_inline] = ACTIONS(8145),
    [anon_sym_const] = ACTIONS(8145),
    [anon_sym_restrict] = ACTIONS(8145),
    [anon_sym_volatile] = ACTIONS(8145),
    [anon_sym__Atomic] = ACTIONS(8145),
    [anon_sym_mutable] = ACTIONS(8145),
    [anon_sym_explicit] = ACTIONS(8145),
    [anon_sym_constexpr] = ACTIONS(8145),
    [anon_sym_unsigned] = ACTIONS(8145),
    [anon_sym_long] = ACTIONS(8145),
    [anon_sym_short] = ACTIONS(8145),
    [sym_primitive_type] = ACTIONS(8145),
    [anon_sym_enum] = ACTIONS(8145),
    [anon_sym_struct] = ACTIONS(8145),
    [anon_sym_union] = ACTIONS(8145),
    [anon_sym_if] = ACTIONS(8145),
    [anon_sym_else] = ACTIONS(8145),
    [anon_sym_switch] = ACTIONS(8145),
    [anon_sym_case] = ACTIONS(8145),
    [anon_sym_default] = ACTIONS(8145),
    [anon_sym_while] = ACTIONS(8145),
    [anon_sym_do] = ACTIONS(8145),
    [anon_sym_for] = ACTIONS(8145),
    [anon_sym_return] = ACTIONS(8145),
    [anon_sym_break] = ACTIONS(8145),
    [anon_sym_continue] = ACTIONS(8145),
    [anon_sym_goto] = ACTIONS(8145),
    [anon_sym_AMP] = ACTIONS(8143),
    [anon_sym_BANG] = ACTIONS(8143),
    [anon_sym_TILDE] = ACTIONS(8143),
    [anon_sym_PLUS] = ACTIONS(8145),
    [anon_sym_DASH] = ACTIONS(8145),
    [anon_sym_DASH_DASH] = ACTIONS(8143),
    [anon_sym_PLUS_PLUS] = ACTIONS(8143),
    [anon_sym_sizeof] = ACTIONS(8145),
    [sym_number_literal] = ACTIONS(8143),
    [anon_sym_SQUOTE] = ACTIONS(8143),
    [anon_sym_DQUOTE] = ACTIONS(8143),
    [sym_true] = ACTIONS(8145),
    [sym_false] = ACTIONS(8145),
    [sym_null] = ACTIONS(8145),
    [sym_identifier] = ACTIONS(8145),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(8145),
    [sym_auto] = ACTIONS(8145),
    [anon_sym_typename] = ACTIONS(8145),
    [anon_sym_delete] = ACTIONS(8145),
    [anon_sym_try] = ACTIONS(8145),
    [anon_sym_new] = ACTIONS(8145),
    [anon_sym_COLON_COLON] = ACTIONS(8143),
    [sym_nullptr] = ACTIONS(8145),
  },
  [3814] = {
    [sym_compound_statement] = STATE(3864),
    [sym_labeled_statement] = STATE(3864),
    [sym_expression_statement] = STATE(3864),
    [sym_if_statement] = STATE(3864),
    [sym_switch_statement] = STATE(3864),
    [sym_case_statement] = STATE(3864),
    [sym_while_statement] = STATE(3864),
    [sym_do_statement] = STATE(3864),
    [sym_for_statement] = STATE(3864),
    [sym_return_statement] = STATE(3864),
    [sym_break_statement] = STATE(3864),
    [sym_continue_statement] = STATE(3864),
    [sym_goto_statement] = STATE(3864),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(3864),
    [sym_try_statement] = STATE(3864),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(2220),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(5705),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2242),
  },
  [3815] = {
    [sym_compound_statement] = STATE(3515),
    [sym_labeled_statement] = STATE(3515),
    [sym_expression_statement] = STATE(3515),
    [sym_if_statement] = STATE(3515),
    [sym_switch_statement] = STATE(3515),
    [sym_case_statement] = STATE(3515),
    [sym_while_statement] = STATE(3515),
    [sym_do_statement] = STATE(3515),
    [sym_for_statement] = STATE(3515),
    [sym_return_statement] = STATE(3515),
    [sym_break_statement] = STATE(3515),
    [sym_continue_statement] = STATE(3515),
    [sym_goto_statement] = STATE(3515),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(3515),
    [sym_try_statement] = STATE(3515),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(157),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(5814),
    [anon_sym_switch] = ACTIONS(5816),
    [anon_sym_case] = ACTIONS(5818),
    [anon_sym_default] = ACTIONS(5820),
    [anon_sym_while] = ACTIONS(5822),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(5824),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(5826),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(5828),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(207),
  },
  [3816] = {
    [sym_compound_statement] = STATE(3516),
    [sym_labeled_statement] = STATE(3516),
    [sym_expression_statement] = STATE(3516),
    [sym_if_statement] = STATE(3516),
    [sym_switch_statement] = STATE(3516),
    [sym_case_statement] = STATE(3516),
    [sym_while_statement] = STATE(3516),
    [sym_do_statement] = STATE(3516),
    [sym_for_statement] = STATE(3516),
    [sym_return_statement] = STATE(3516),
    [sym_break_statement] = STATE(3516),
    [sym_continue_statement] = STATE(3516),
    [sym_goto_statement] = STATE(3516),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(3516),
    [sym_try_statement] = STATE(3516),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(157),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(5814),
    [anon_sym_switch] = ACTIONS(5816),
    [anon_sym_case] = ACTIONS(5818),
    [anon_sym_default] = ACTIONS(5820),
    [anon_sym_while] = ACTIONS(5822),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(5824),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(5826),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(5828),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(207),
  },
  [3817] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8471),
    [sym_comment] = ACTIONS(91),
  },
  [3818] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3866),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8471),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3819] = {
    [sym_parameter_list] = STATE(3756),
    [anon_sym_COMMA] = ACTIONS(5889),
    [anon_sym_SEMI] = ACTIONS(5889),
    [anon_sym_LPAREN2] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_const] = ACTIONS(7689),
    [anon_sym_restrict] = ACTIONS(5889),
    [anon_sym_volatile] = ACTIONS(5889),
    [anon_sym__Atomic] = ACTIONS(5889),
    [anon_sym_mutable] = ACTIONS(5889),
    [anon_sym_explicit] = ACTIONS(5889),
    [anon_sym_constexpr] = ACTIONS(5889),
    [anon_sym_COLON] = ACTIONS(5889),
    [anon_sym_DASH_GT] = ACTIONS(5889),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5889),
    [anon_sym_override] = ACTIONS(5889),
    [sym_noexcept] = ACTIONS(5889),
  },
  [3820] = {
    [sym_type_qualifier] = STATE(3820),
    [aux_sym_type_definition_repeat1] = STATE(3820),
    [anon_sym_COMMA] = ACTIONS(2179),
    [anon_sym_SEMI] = ACTIONS(2179),
    [anon_sym_LPAREN2] = ACTIONS(2179),
    [anon_sym_STAR] = ACTIONS(2179),
    [anon_sym_LBRACK] = ACTIONS(2179),
    [anon_sym_const] = ACTIONS(7691),
    [anon_sym_restrict] = ACTIONS(7694),
    [anon_sym_volatile] = ACTIONS(7694),
    [anon_sym__Atomic] = ACTIONS(7694),
    [anon_sym_mutable] = ACTIONS(7694),
    [anon_sym_explicit] = ACTIONS(7694),
    [anon_sym_constexpr] = ACTIONS(7694),
    [anon_sym_COLON] = ACTIONS(2179),
    [anon_sym_AMP] = ACTIONS(2177),
    [anon_sym_AMP_AMP] = ACTIONS(2179),
    [anon_sym_DASH_GT] = ACTIONS(2179),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(2179),
    [anon_sym_override] = ACTIONS(2179),
    [sym_noexcept] = ACTIONS(2179),
  },
  [3821] = {
    [sym_type_qualifier] = STATE(3822),
    [sym_trailing_return_type] = STATE(2418),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3822),
    [anon_sym_COMMA] = ACTIONS(5331),
    [anon_sym_SEMI] = ACTIONS(5331),
    [anon_sym_LPAREN2] = ACTIONS(5331),
    [anon_sym_LBRACK] = ACTIONS(5331),
    [anon_sym_const] = ACTIONS(1667),
    [anon_sym_restrict] = ACTIONS(1669),
    [anon_sym_volatile] = ACTIONS(1669),
    [anon_sym__Atomic] = ACTIONS(1669),
    [anon_sym_mutable] = ACTIONS(1669),
    [anon_sym_explicit] = ACTIONS(1669),
    [anon_sym_constexpr] = ACTIONS(1669),
    [anon_sym_COLON] = ACTIONS(5331),
    [anon_sym_DASH_GT] = ACTIONS(7514),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5331),
    [anon_sym_override] = ACTIONS(5331),
    [sym_noexcept] = ACTIONS(8395),
  },
  [3822] = {
    [sym_type_qualifier] = STATE(3822),
    [aux_sym_abstract_function_declarator_repeat1] = STATE(3822),
    [anon_sym_COMMA] = ACTIONS(5351),
    [anon_sym_SEMI] = ACTIONS(5351),
    [anon_sym_LPAREN2] = ACTIONS(5351),
    [anon_sym_LBRACK] = ACTIONS(5351),
    [anon_sym_const] = ACTIONS(7697),
    [anon_sym_restrict] = ACTIONS(7700),
    [anon_sym_volatile] = ACTIONS(7700),
    [anon_sym__Atomic] = ACTIONS(7700),
    [anon_sym_mutable] = ACTIONS(7700),
    [anon_sym_explicit] = ACTIONS(7700),
    [anon_sym_constexpr] = ACTIONS(7700),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [sym_comment] = ACTIONS(91),
    [anon_sym_final] = ACTIONS(5351),
    [anon_sym_override] = ACTIONS(5351),
    [sym_noexcept] = ACTIONS(8473),
  },
  [3823] = {
    [sym_compound_statement] = STATE(3553),
    [sym_labeled_statement] = STATE(3553),
    [sym_expression_statement] = STATE(3553),
    [sym_if_statement] = STATE(3553),
    [sym_switch_statement] = STATE(3553),
    [sym_case_statement] = STATE(3553),
    [sym_while_statement] = STATE(3553),
    [sym_do_statement] = STATE(3553),
    [sym_for_statement] = STATE(3553),
    [sym_return_statement] = STATE(3553),
    [sym_break_statement] = STATE(3553),
    [sym_continue_statement] = STATE(3553),
    [sym_goto_statement] = STATE(3553),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(3553),
    [sym_try_statement] = STATE(3553),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(4430),
    [anon_sym_switch] = ACTIONS(4432),
    [anon_sym_case] = ACTIONS(4434),
    [anon_sym_default] = ACTIONS(4436),
    [anon_sym_while] = ACTIONS(4438),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(4440),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(4442),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(4444),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [3824] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8476),
    [sym_comment] = ACTIONS(91),
  },
  [3825] = {
    [sym_compound_statement] = STATE(3549),
    [sym_labeled_statement] = STATE(3549),
    [sym_expression_statement] = STATE(3549),
    [sym_if_statement] = STATE(3549),
    [sym_switch_statement] = STATE(3549),
    [sym_case_statement] = STATE(3549),
    [sym_while_statement] = STATE(3549),
    [sym_do_statement] = STATE(3549),
    [sym_for_statement] = STATE(3549),
    [sym_return_statement] = STATE(3549),
    [sym_break_statement] = STATE(3549),
    [sym_continue_statement] = STATE(3549),
    [sym_goto_statement] = STATE(3549),
    [sym__expression] = STATE(222),
    [sym_comma_expression] = STATE(223),
    [sym_conditional_expression] = STATE(222),
    [sym_assignment_expression] = STATE(222),
    [sym_pointer_expression] = STATE(222),
    [sym_logical_expression] = STATE(222),
    [sym_bitwise_expression] = STATE(222),
    [sym_equality_expression] = STATE(222),
    [sym_relational_expression] = STATE(222),
    [sym_shift_expression] = STATE(222),
    [sym_math_expression] = STATE(222),
    [sym_cast_expression] = STATE(222),
    [sym_sizeof_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_call_expression] = STATE(222),
    [sym_field_expression] = STATE(222),
    [sym_compound_literal_expression] = STATE(222),
    [sym_parenthesized_expression] = STATE(222),
    [sym_char_literal] = STATE(222),
    [sym_concatenated_string] = STATE(222),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(222),
    [sym_for_range_loop] = STATE(3549),
    [sym_try_statement] = STATE(3549),
    [sym_new_expression] = STATE(222),
    [sym_delete_expression] = STATE(222),
    [sym_lambda_expression] = STATE(222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(6119),
    [anon_sym_switch] = ACTIONS(6121),
    [anon_sym_case] = ACTIONS(6123),
    [anon_sym_default] = ACTIONS(6125),
    [anon_sym_while] = ACTIONS(6127),
    [anon_sym_do] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(6129),
    [anon_sym_return] = ACTIONS(373),
    [anon_sym_break] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_goto] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(353),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_identifier] = ACTIONS(6131),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(6133),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(381),
  },
  [3826] = {
    [sym_compound_statement] = STATE(3550),
    [sym_labeled_statement] = STATE(3550),
    [sym_expression_statement] = STATE(3550),
    [sym_if_statement] = STATE(3550),
    [sym_switch_statement] = STATE(3550),
    [sym_case_statement] = STATE(3550),
    [sym_while_statement] = STATE(3550),
    [sym_do_statement] = STATE(3550),
    [sym_for_statement] = STATE(3550),
    [sym_return_statement] = STATE(3550),
    [sym_break_statement] = STATE(3550),
    [sym_continue_statement] = STATE(3550),
    [sym_goto_statement] = STATE(3550),
    [sym__expression] = STATE(222),
    [sym_comma_expression] = STATE(223),
    [sym_conditional_expression] = STATE(222),
    [sym_assignment_expression] = STATE(222),
    [sym_pointer_expression] = STATE(222),
    [sym_logical_expression] = STATE(222),
    [sym_bitwise_expression] = STATE(222),
    [sym_equality_expression] = STATE(222),
    [sym_relational_expression] = STATE(222),
    [sym_shift_expression] = STATE(222),
    [sym_math_expression] = STATE(222),
    [sym_cast_expression] = STATE(222),
    [sym_sizeof_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_call_expression] = STATE(222),
    [sym_field_expression] = STATE(222),
    [sym_compound_literal_expression] = STATE(222),
    [sym_parenthesized_expression] = STATE(222),
    [sym_char_literal] = STATE(222),
    [sym_concatenated_string] = STATE(222),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(222),
    [sym_for_range_loop] = STATE(3550),
    [sym_try_statement] = STATE(3550),
    [sym_new_expression] = STATE(222),
    [sym_delete_expression] = STATE(222),
    [sym_lambda_expression] = STATE(222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(6119),
    [anon_sym_switch] = ACTIONS(6121),
    [anon_sym_case] = ACTIONS(6123),
    [anon_sym_default] = ACTIONS(6125),
    [anon_sym_while] = ACTIONS(6127),
    [anon_sym_do] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(6129),
    [anon_sym_return] = ACTIONS(373),
    [anon_sym_break] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_goto] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(353),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_identifier] = ACTIONS(6131),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(6133),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(381),
  },
  [3827] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8478),
    [sym_comment] = ACTIONS(91),
  },
  [3828] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3869),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8478),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3829] = {
    [sym_compound_statement] = STATE(3114),
    [sym_labeled_statement] = STATE(3114),
    [sym_expression_statement] = STATE(3114),
    [sym_if_statement] = STATE(3114),
    [sym_switch_statement] = STATE(3114),
    [sym_case_statement] = STATE(3114),
    [sym_while_statement] = STATE(3114),
    [sym_do_statement] = STATE(3114),
    [sym_for_statement] = STATE(3114),
    [sym_return_statement] = STATE(3114),
    [sym_break_statement] = STATE(3114),
    [sym_continue_statement] = STATE(3114),
    [sym_goto_statement] = STATE(3114),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(3114),
    [sym_try_statement] = STATE(3114),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7177),
    [anon_sym_switch] = ACTIONS(7179),
    [anon_sym_case] = ACTIONS(7181),
    [anon_sym_default] = ACTIONS(7183),
    [anon_sym_while] = ACTIONS(7185),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(7187),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(7189),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7191),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [3830] = {
    [sym_raw_string_literal] = ACTIONS(7063),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7065),
    [sym_preproc_directive] = ACTIONS(7065),
    [anon_sym_SEMI] = ACTIONS(7063),
    [anon_sym_typedef] = ACTIONS(7065),
    [anon_sym_extern] = ACTIONS(7065),
    [anon_sym_LBRACE] = ACTIONS(7063),
    [anon_sym_RBRACE] = ACTIONS(7063),
    [anon_sym_LPAREN2] = ACTIONS(7063),
    [anon_sym_STAR] = ACTIONS(7063),
    [anon_sym_LBRACK] = ACTIONS(7063),
    [anon_sym_static] = ACTIONS(7065),
    [anon_sym_register] = ACTIONS(7065),
    [anon_sym_inline] = ACTIONS(7065),
    [anon_sym_const] = ACTIONS(7065),
    [anon_sym_restrict] = ACTIONS(7065),
    [anon_sym_volatile] = ACTIONS(7065),
    [anon_sym__Atomic] = ACTIONS(7065),
    [anon_sym_mutable] = ACTIONS(7065),
    [anon_sym_explicit] = ACTIONS(7065),
    [anon_sym_constexpr] = ACTIONS(7065),
    [anon_sym_unsigned] = ACTIONS(7065),
    [anon_sym_long] = ACTIONS(7065),
    [anon_sym_short] = ACTIONS(7065),
    [sym_primitive_type] = ACTIONS(7065),
    [anon_sym_enum] = ACTIONS(7065),
    [anon_sym_struct] = ACTIONS(7065),
    [anon_sym_union] = ACTIONS(7065),
    [anon_sym_if] = ACTIONS(7065),
    [anon_sym_else] = ACTIONS(8480),
    [anon_sym_switch] = ACTIONS(7065),
    [anon_sym_case] = ACTIONS(7065),
    [anon_sym_default] = ACTIONS(7065),
    [anon_sym_while] = ACTIONS(7065),
    [anon_sym_do] = ACTIONS(7065),
    [anon_sym_for] = ACTIONS(7065),
    [anon_sym_return] = ACTIONS(7065),
    [anon_sym_break] = ACTIONS(7065),
    [anon_sym_continue] = ACTIONS(7065),
    [anon_sym_goto] = ACTIONS(7065),
    [anon_sym_AMP] = ACTIONS(7065),
    [anon_sym_AMP_AMP] = ACTIONS(7063),
    [anon_sym_BANG] = ACTIONS(7063),
    [anon_sym_TILDE] = ACTIONS(7063),
    [anon_sym_PLUS] = ACTIONS(7065),
    [anon_sym_DASH] = ACTIONS(7065),
    [anon_sym_DASH_DASH] = ACTIONS(7063),
    [anon_sym_PLUS_PLUS] = ACTIONS(7063),
    [anon_sym_sizeof] = ACTIONS(7065),
    [sym_number_literal] = ACTIONS(7063),
    [anon_sym_SQUOTE] = ACTIONS(7063),
    [anon_sym_DQUOTE] = ACTIONS(7063),
    [sym_true] = ACTIONS(7065),
    [sym_false] = ACTIONS(7065),
    [sym_null] = ACTIONS(7065),
    [sym_identifier] = ACTIONS(7065),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7065),
    [sym_auto] = ACTIONS(7065),
    [anon_sym_typename] = ACTIONS(7065),
    [anon_sym_template] = ACTIONS(7065),
    [anon_sym_delete] = ACTIONS(7065),
    [anon_sym_namespace] = ACTIONS(7065),
    [anon_sym_using] = ACTIONS(7065),
    [anon_sym_try] = ACTIONS(7065),
    [anon_sym_new] = ACTIONS(7065),
    [anon_sym_COLON_COLON] = ACTIONS(7063),
    [sym_operator_name] = ACTIONS(7063),
    [sym_nullptr] = ACTIONS(7065),
  },
  [3831] = {
    [sym_compound_statement] = STATE(3135),
    [sym_labeled_statement] = STATE(3135),
    [sym_expression_statement] = STATE(3135),
    [sym_if_statement] = STATE(3135),
    [sym_switch_statement] = STATE(3135),
    [sym_case_statement] = STATE(3135),
    [sym_while_statement] = STATE(3135),
    [sym_do_statement] = STATE(3135),
    [sym_for_statement] = STATE(3135),
    [sym_return_statement] = STATE(3135),
    [sym_break_statement] = STATE(3135),
    [sym_continue_statement] = STATE(3135),
    [sym_goto_statement] = STATE(3135),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(3135),
    [sym_try_statement] = STATE(3135),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7177),
    [anon_sym_switch] = ACTIONS(7179),
    [anon_sym_case] = ACTIONS(7181),
    [anon_sym_default] = ACTIONS(7183),
    [anon_sym_while] = ACTIONS(7185),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(7187),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(7189),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7191),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [3832] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8482),
    [sym_comment] = ACTIONS(91),
  },
  [3833] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3872),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8482),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3834] = {
    [sym__expression] = STATE(3873),
    [sym_conditional_expression] = STATE(3873),
    [sym_assignment_expression] = STATE(3873),
    [sym_pointer_expression] = STATE(3873),
    [sym_logical_expression] = STATE(3873),
    [sym_bitwise_expression] = STATE(3873),
    [sym_equality_expression] = STATE(3873),
    [sym_relational_expression] = STATE(3873),
    [sym_shift_expression] = STATE(3873),
    [sym_math_expression] = STATE(3873),
    [sym_cast_expression] = STATE(3873),
    [sym_sizeof_expression] = STATE(3873),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(3873),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(3873),
    [sym_concatenated_string] = STATE(3873),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3873),
    [sym_new_expression] = STATE(3873),
    [sym_delete_expression] = STATE(3873),
    [sym_lambda_expression] = STATE(3873),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8484),
    [anon_sym_RPAREN] = ACTIONS(8482),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(8484),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8486),
    [sym_false] = ACTIONS(8486),
    [sym_null] = ACTIONS(8486),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(8486),
  },
  [3835] = {
    [sym_compound_statement] = STATE(3140),
    [sym_labeled_statement] = STATE(3140),
    [sym_expression_statement] = STATE(3140),
    [sym_if_statement] = STATE(3140),
    [sym_switch_statement] = STATE(3140),
    [sym_case_statement] = STATE(3140),
    [sym_while_statement] = STATE(3140),
    [sym_do_statement] = STATE(3140),
    [sym_for_statement] = STATE(3140),
    [sym_return_statement] = STATE(3140),
    [sym_break_statement] = STATE(3140),
    [sym_continue_statement] = STATE(3140),
    [sym_goto_statement] = STATE(3140),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(3140),
    [sym_try_statement] = STATE(3140),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7177),
    [anon_sym_switch] = ACTIONS(7179),
    [anon_sym_case] = ACTIONS(7181),
    [anon_sym_default] = ACTIONS(7183),
    [anon_sym_while] = ACTIONS(7185),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(7187),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(7189),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7191),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [3836] = {
    [sym_compound_statement] = STATE(3587),
    [sym_labeled_statement] = STATE(3587),
    [sym_expression_statement] = STATE(3587),
    [sym_if_statement] = STATE(3587),
    [sym_switch_statement] = STATE(3587),
    [sym_case_statement] = STATE(3587),
    [sym_while_statement] = STATE(3587),
    [sym_do_statement] = STATE(3587),
    [sym_for_statement] = STATE(3587),
    [sym_return_statement] = STATE(3587),
    [sym_break_statement] = STATE(3587),
    [sym_continue_statement] = STATE(3587),
    [sym_goto_statement] = STATE(3587),
    [sym__expression] = STATE(1020),
    [sym_comma_expression] = STATE(1021),
    [sym_conditional_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1020),
    [sym_pointer_expression] = STATE(1020),
    [sym_logical_expression] = STATE(1020),
    [sym_bitwise_expression] = STATE(1020),
    [sym_equality_expression] = STATE(1020),
    [sym_relational_expression] = STATE(1020),
    [sym_shift_expression] = STATE(1020),
    [sym_math_expression] = STATE(1020),
    [sym_cast_expression] = STATE(1020),
    [sym_sizeof_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_field_expression] = STATE(1020),
    [sym_compound_literal_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_char_literal] = STATE(1020),
    [sym_concatenated_string] = STATE(1020),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1020),
    [sym_for_range_loop] = STATE(3587),
    [sym_try_statement] = STATE(3587),
    [sym_new_expression] = STATE(1020),
    [sym_delete_expression] = STATE(1020),
    [sym_lambda_expression] = STATE(1020),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2022),
    [anon_sym_SEMI] = ACTIONS(2036),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7300),
    [anon_sym_switch] = ACTIONS(7302),
    [anon_sym_case] = ACTIONS(7304),
    [anon_sym_default] = ACTIONS(7306),
    [anon_sym_while] = ACTIONS(7308),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(7310),
    [anon_sym_return] = ACTIONS(2058),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2062),
    [anon_sym_goto] = ACTIONS(2064),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(7312),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7314),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2066),
  },
  [3837] = {
    [sym_raw_string_literal] = ACTIONS(7063),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7065),
    [sym_preproc_directive] = ACTIONS(7065),
    [anon_sym_SEMI] = ACTIONS(7063),
    [anon_sym_typedef] = ACTIONS(7065),
    [anon_sym_extern] = ACTIONS(7065),
    [anon_sym_LBRACE] = ACTIONS(7063),
    [anon_sym_LPAREN2] = ACTIONS(7063),
    [anon_sym_STAR] = ACTIONS(7063),
    [anon_sym_LBRACK] = ACTIONS(7063),
    [anon_sym_static] = ACTIONS(7065),
    [anon_sym_register] = ACTIONS(7065),
    [anon_sym_inline] = ACTIONS(7065),
    [anon_sym_const] = ACTIONS(7065),
    [anon_sym_restrict] = ACTIONS(7065),
    [anon_sym_volatile] = ACTIONS(7065),
    [anon_sym__Atomic] = ACTIONS(7065),
    [anon_sym_mutable] = ACTIONS(7065),
    [anon_sym_explicit] = ACTIONS(7065),
    [anon_sym_constexpr] = ACTIONS(7065),
    [anon_sym_unsigned] = ACTIONS(7065),
    [anon_sym_long] = ACTIONS(7065),
    [anon_sym_short] = ACTIONS(7065),
    [sym_primitive_type] = ACTIONS(7065),
    [anon_sym_enum] = ACTIONS(7065),
    [anon_sym_struct] = ACTIONS(7065),
    [anon_sym_union] = ACTIONS(7065),
    [anon_sym_if] = ACTIONS(7065),
    [anon_sym_else] = ACTIONS(8488),
    [anon_sym_switch] = ACTIONS(7065),
    [anon_sym_case] = ACTIONS(7065),
    [anon_sym_default] = ACTIONS(7065),
    [anon_sym_while] = ACTIONS(7065),
    [anon_sym_do] = ACTIONS(7065),
    [anon_sym_for] = ACTIONS(7065),
    [anon_sym_return] = ACTIONS(7065),
    [anon_sym_break] = ACTIONS(7065),
    [anon_sym_continue] = ACTIONS(7065),
    [anon_sym_goto] = ACTIONS(7065),
    [anon_sym_AMP] = ACTIONS(7065),
    [anon_sym_AMP_AMP] = ACTIONS(7063),
    [anon_sym_BANG] = ACTIONS(7063),
    [anon_sym_TILDE] = ACTIONS(7063),
    [anon_sym_PLUS] = ACTIONS(7065),
    [anon_sym_DASH] = ACTIONS(7065),
    [anon_sym_DASH_DASH] = ACTIONS(7063),
    [anon_sym_PLUS_PLUS] = ACTIONS(7063),
    [anon_sym_sizeof] = ACTIONS(7065),
    [sym_number_literal] = ACTIONS(7063),
    [anon_sym_SQUOTE] = ACTIONS(7063),
    [anon_sym_DQUOTE] = ACTIONS(7063),
    [sym_true] = ACTIONS(7065),
    [sym_false] = ACTIONS(7065),
    [sym_null] = ACTIONS(7065),
    [sym_identifier] = ACTIONS(7065),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7065),
    [sym_auto] = ACTIONS(7065),
    [anon_sym_typename] = ACTIONS(7065),
    [anon_sym_template] = ACTIONS(7065),
    [anon_sym_delete] = ACTIONS(7065),
    [anon_sym_namespace] = ACTIONS(7065),
    [anon_sym_using] = ACTIONS(7065),
    [anon_sym_try] = ACTIONS(7065),
    [anon_sym_new] = ACTIONS(7065),
    [anon_sym_COLON_COLON] = ACTIONS(7063),
    [sym_operator_name] = ACTIONS(7063),
    [sym_nullptr] = ACTIONS(7065),
  },
  [3838] = {
    [sym_compound_statement] = STATE(3589),
    [sym_labeled_statement] = STATE(3589),
    [sym_expression_statement] = STATE(3589),
    [sym_if_statement] = STATE(3589),
    [sym_switch_statement] = STATE(3589),
    [sym_case_statement] = STATE(3589),
    [sym_while_statement] = STATE(3589),
    [sym_do_statement] = STATE(3589),
    [sym_for_statement] = STATE(3589),
    [sym_return_statement] = STATE(3589),
    [sym_break_statement] = STATE(3589),
    [sym_continue_statement] = STATE(3589),
    [sym_goto_statement] = STATE(3589),
    [sym__expression] = STATE(1020),
    [sym_comma_expression] = STATE(1021),
    [sym_conditional_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1020),
    [sym_pointer_expression] = STATE(1020),
    [sym_logical_expression] = STATE(1020),
    [sym_bitwise_expression] = STATE(1020),
    [sym_equality_expression] = STATE(1020),
    [sym_relational_expression] = STATE(1020),
    [sym_shift_expression] = STATE(1020),
    [sym_math_expression] = STATE(1020),
    [sym_cast_expression] = STATE(1020),
    [sym_sizeof_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_field_expression] = STATE(1020),
    [sym_compound_literal_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_char_literal] = STATE(1020),
    [sym_concatenated_string] = STATE(1020),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1020),
    [sym_for_range_loop] = STATE(3589),
    [sym_try_statement] = STATE(3589),
    [sym_new_expression] = STATE(1020),
    [sym_delete_expression] = STATE(1020),
    [sym_lambda_expression] = STATE(1020),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2022),
    [anon_sym_SEMI] = ACTIONS(2036),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7300),
    [anon_sym_switch] = ACTIONS(7302),
    [anon_sym_case] = ACTIONS(7304),
    [anon_sym_default] = ACTIONS(7306),
    [anon_sym_while] = ACTIONS(7308),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(7310),
    [anon_sym_return] = ACTIONS(2058),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2062),
    [anon_sym_goto] = ACTIONS(2064),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(7312),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7314),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2066),
  },
  [3839] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8490),
    [sym_comment] = ACTIONS(91),
  },
  [3840] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3876),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8490),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3841] = {
    [sym__expression] = STATE(3877),
    [sym_conditional_expression] = STATE(3877),
    [sym_assignment_expression] = STATE(3877),
    [sym_pointer_expression] = STATE(3877),
    [sym_logical_expression] = STATE(3877),
    [sym_bitwise_expression] = STATE(3877),
    [sym_equality_expression] = STATE(3877),
    [sym_relational_expression] = STATE(3877),
    [sym_shift_expression] = STATE(3877),
    [sym_math_expression] = STATE(3877),
    [sym_cast_expression] = STATE(3877),
    [sym_sizeof_expression] = STATE(3877),
    [sym_subscript_expression] = STATE(3877),
    [sym_call_expression] = STATE(3877),
    [sym_field_expression] = STATE(3877),
    [sym_compound_literal_expression] = STATE(3877),
    [sym_parenthesized_expression] = STATE(3877),
    [sym_char_literal] = STATE(3877),
    [sym_concatenated_string] = STATE(3877),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3877),
    [sym_new_expression] = STATE(3877),
    [sym_delete_expression] = STATE(3877),
    [sym_lambda_expression] = STATE(3877),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8492),
    [anon_sym_RPAREN] = ACTIONS(8490),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(8492),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8494),
    [sym_false] = ACTIONS(8494),
    [sym_null] = ACTIONS(8494),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(8494),
  },
  [3842] = {
    [sym_compound_statement] = STATE(3593),
    [sym_labeled_statement] = STATE(3593),
    [sym_expression_statement] = STATE(3593),
    [sym_if_statement] = STATE(3593),
    [sym_switch_statement] = STATE(3593),
    [sym_case_statement] = STATE(3593),
    [sym_while_statement] = STATE(3593),
    [sym_do_statement] = STATE(3593),
    [sym_for_statement] = STATE(3593),
    [sym_return_statement] = STATE(3593),
    [sym_break_statement] = STATE(3593),
    [sym_continue_statement] = STATE(3593),
    [sym_goto_statement] = STATE(3593),
    [sym__expression] = STATE(1020),
    [sym_comma_expression] = STATE(1021),
    [sym_conditional_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1020),
    [sym_pointer_expression] = STATE(1020),
    [sym_logical_expression] = STATE(1020),
    [sym_bitwise_expression] = STATE(1020),
    [sym_equality_expression] = STATE(1020),
    [sym_relational_expression] = STATE(1020),
    [sym_shift_expression] = STATE(1020),
    [sym_math_expression] = STATE(1020),
    [sym_cast_expression] = STATE(1020),
    [sym_sizeof_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_field_expression] = STATE(1020),
    [sym_compound_literal_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_char_literal] = STATE(1020),
    [sym_concatenated_string] = STATE(1020),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1020),
    [sym_for_range_loop] = STATE(3593),
    [sym_try_statement] = STATE(3593),
    [sym_new_expression] = STATE(1020),
    [sym_delete_expression] = STATE(1020),
    [sym_lambda_expression] = STATE(1020),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2022),
    [anon_sym_SEMI] = ACTIONS(2036),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7300),
    [anon_sym_switch] = ACTIONS(7302),
    [anon_sym_case] = ACTIONS(7304),
    [anon_sym_default] = ACTIONS(7306),
    [anon_sym_while] = ACTIONS(7308),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(7310),
    [anon_sym_return] = ACTIONS(2058),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2062),
    [anon_sym_goto] = ACTIONS(2064),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(7312),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7314),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2066),
  },
  [3843] = {
    [sym_raw_string_literal] = ACTIONS(8287),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(8289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(8289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(8289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(8289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(8289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(8289),
    [sym_preproc_directive] = ACTIONS(8289),
    [anon_sym_SEMI] = ACTIONS(8287),
    [anon_sym_typedef] = ACTIONS(8289),
    [anon_sym_extern] = ACTIONS(8289),
    [anon_sym_LBRACE] = ACTIONS(8287),
    [anon_sym_LPAREN2] = ACTIONS(8287),
    [anon_sym_STAR] = ACTIONS(8287),
    [anon_sym_LBRACK] = ACTIONS(8287),
    [anon_sym_static] = ACTIONS(8289),
    [anon_sym_register] = ACTIONS(8289),
    [anon_sym_inline] = ACTIONS(8289),
    [anon_sym_const] = ACTIONS(8289),
    [anon_sym_restrict] = ACTIONS(8289),
    [anon_sym_volatile] = ACTIONS(8289),
    [anon_sym__Atomic] = ACTIONS(8289),
    [anon_sym_mutable] = ACTIONS(8289),
    [anon_sym_explicit] = ACTIONS(8289),
    [anon_sym_constexpr] = ACTIONS(8289),
    [anon_sym_unsigned] = ACTIONS(8289),
    [anon_sym_long] = ACTIONS(8289),
    [anon_sym_short] = ACTIONS(8289),
    [sym_primitive_type] = ACTIONS(8289),
    [anon_sym_enum] = ACTIONS(8289),
    [anon_sym_struct] = ACTIONS(8289),
    [anon_sym_union] = ACTIONS(8289),
    [anon_sym_if] = ACTIONS(8289),
    [anon_sym_else] = ACTIONS(8289),
    [anon_sym_switch] = ACTIONS(8289),
    [anon_sym_case] = ACTIONS(8289),
    [anon_sym_default] = ACTIONS(8289),
    [anon_sym_while] = ACTIONS(8289),
    [anon_sym_do] = ACTIONS(8289),
    [anon_sym_for] = ACTIONS(8289),
    [anon_sym_return] = ACTIONS(8289),
    [anon_sym_break] = ACTIONS(8289),
    [anon_sym_continue] = ACTIONS(8289),
    [anon_sym_goto] = ACTIONS(8289),
    [anon_sym_AMP] = ACTIONS(8289),
    [anon_sym_AMP_AMP] = ACTIONS(8287),
    [anon_sym_BANG] = ACTIONS(8287),
    [anon_sym_TILDE] = ACTIONS(8287),
    [anon_sym_PLUS] = ACTIONS(8289),
    [anon_sym_DASH] = ACTIONS(8289),
    [anon_sym_DASH_DASH] = ACTIONS(8287),
    [anon_sym_PLUS_PLUS] = ACTIONS(8287),
    [anon_sym_sizeof] = ACTIONS(8289),
    [sym_number_literal] = ACTIONS(8287),
    [anon_sym_SQUOTE] = ACTIONS(8287),
    [anon_sym_DQUOTE] = ACTIONS(8287),
    [sym_true] = ACTIONS(8289),
    [sym_false] = ACTIONS(8289),
    [sym_null] = ACTIONS(8289),
    [sym_identifier] = ACTIONS(8289),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(8289),
    [sym_auto] = ACTIONS(8289),
    [anon_sym_typename] = ACTIONS(8289),
    [anon_sym_template] = ACTIONS(8289),
    [anon_sym_delete] = ACTIONS(8289),
    [anon_sym_namespace] = ACTIONS(8289),
    [anon_sym_using] = ACTIONS(8289),
    [anon_sym_try] = ACTIONS(8289),
    [anon_sym_new] = ACTIONS(8289),
    [anon_sym_COLON_COLON] = ACTIONS(8287),
    [sym_operator_name] = ACTIONS(8287),
    [sym_nullptr] = ACTIONS(8289),
  },
  [3844] = {
    [sym_compound_statement] = STATE(3601),
    [sym_labeled_statement] = STATE(3601),
    [sym_expression_statement] = STATE(3601),
    [sym_if_statement] = STATE(3601),
    [sym_switch_statement] = STATE(3601),
    [sym_case_statement] = STATE(3601),
    [sym_while_statement] = STATE(3601),
    [sym_do_statement] = STATE(3601),
    [sym_for_statement] = STATE(3601),
    [sym_return_statement] = STATE(3601),
    [sym_break_statement] = STATE(3601),
    [sym_continue_statement] = STATE(3601),
    [sym_goto_statement] = STATE(3601),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(411),
    [sym_for_range_loop] = STATE(3601),
    [sym_try_statement] = STATE(3601),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(678),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(6682),
    [anon_sym_switch] = ACTIONS(6684),
    [anon_sym_case] = ACTIONS(6686),
    [anon_sym_default] = ACTIONS(6688),
    [anon_sym_while] = ACTIONS(6690),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(6692),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(6694),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(6696),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(726),
  },
  [3845] = {
    [sym_compound_statement] = STATE(3602),
    [sym_labeled_statement] = STATE(3602),
    [sym_expression_statement] = STATE(3602),
    [sym_if_statement] = STATE(3602),
    [sym_switch_statement] = STATE(3602),
    [sym_case_statement] = STATE(3602),
    [sym_while_statement] = STATE(3602),
    [sym_do_statement] = STATE(3602),
    [sym_for_statement] = STATE(3602),
    [sym_return_statement] = STATE(3602),
    [sym_break_statement] = STATE(3602),
    [sym_continue_statement] = STATE(3602),
    [sym_goto_statement] = STATE(3602),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(411),
    [sym_for_range_loop] = STATE(3602),
    [sym_try_statement] = STATE(3602),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(678),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(6682),
    [anon_sym_switch] = ACTIONS(6684),
    [anon_sym_case] = ACTIONS(6686),
    [anon_sym_default] = ACTIONS(6688),
    [anon_sym_while] = ACTIONS(6690),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(6692),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(6694),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(6696),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(726),
  },
  [3846] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8496),
    [sym_comment] = ACTIONS(91),
  },
  [3847] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3879),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8496),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3848] = {
    [sym_raw_string_literal] = ACTIONS(6091),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(6093),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(6093),
    [sym_preproc_directive] = ACTIONS(6093),
    [anon_sym_SEMI] = ACTIONS(6091),
    [anon_sym_typedef] = ACTIONS(6093),
    [anon_sym_extern] = ACTIONS(6093),
    [anon_sym_LBRACE] = ACTIONS(6091),
    [anon_sym_LPAREN2] = ACTIONS(6091),
    [anon_sym_STAR] = ACTIONS(6091),
    [anon_sym_LBRACK] = ACTIONS(6091),
    [anon_sym_static] = ACTIONS(6093),
    [anon_sym_register] = ACTIONS(6093),
    [anon_sym_inline] = ACTIONS(6093),
    [anon_sym_const] = ACTIONS(6093),
    [anon_sym_restrict] = ACTIONS(6093),
    [anon_sym_volatile] = ACTIONS(6093),
    [anon_sym__Atomic] = ACTIONS(6093),
    [anon_sym_mutable] = ACTIONS(6093),
    [anon_sym_explicit] = ACTIONS(6093),
    [anon_sym_constexpr] = ACTIONS(6093),
    [anon_sym_unsigned] = ACTIONS(6093),
    [anon_sym_long] = ACTIONS(6093),
    [anon_sym_short] = ACTIONS(6093),
    [sym_primitive_type] = ACTIONS(6093),
    [anon_sym_enum] = ACTIONS(6093),
    [anon_sym_struct] = ACTIONS(6093),
    [anon_sym_union] = ACTIONS(6093),
    [anon_sym_if] = ACTIONS(6093),
    [anon_sym_else] = ACTIONS(8498),
    [anon_sym_switch] = ACTIONS(6093),
    [anon_sym_case] = ACTIONS(6093),
    [anon_sym_default] = ACTIONS(6093),
    [anon_sym_while] = ACTIONS(6093),
    [anon_sym_do] = ACTIONS(6093),
    [anon_sym_for] = ACTIONS(6093),
    [anon_sym_return] = ACTIONS(6093),
    [anon_sym_break] = ACTIONS(6093),
    [anon_sym_continue] = ACTIONS(6093),
    [anon_sym_goto] = ACTIONS(6093),
    [anon_sym_AMP] = ACTIONS(6091),
    [anon_sym_BANG] = ACTIONS(6091),
    [anon_sym_TILDE] = ACTIONS(6091),
    [anon_sym_PLUS] = ACTIONS(6093),
    [anon_sym_DASH] = ACTIONS(6093),
    [anon_sym_DASH_DASH] = ACTIONS(6091),
    [anon_sym_PLUS_PLUS] = ACTIONS(6091),
    [anon_sym_sizeof] = ACTIONS(6093),
    [sym_number_literal] = ACTIONS(6091),
    [anon_sym_SQUOTE] = ACTIONS(6091),
    [anon_sym_DQUOTE] = ACTIONS(6091),
    [sym_true] = ACTIONS(6093),
    [sym_false] = ACTIONS(6093),
    [sym_null] = ACTIONS(6093),
    [sym_identifier] = ACTIONS(6093),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(6093),
    [sym_auto] = ACTIONS(6093),
    [anon_sym_typename] = ACTIONS(6093),
    [anon_sym_delete] = ACTIONS(6093),
    [anon_sym_try] = ACTIONS(6093),
    [anon_sym_new] = ACTIONS(6093),
    [anon_sym_COLON_COLON] = ACTIONS(6091),
    [sym_nullptr] = ACTIONS(6093),
  },
  [3849] = {
    [sym_compound_statement] = STATE(3881),
    [sym_labeled_statement] = STATE(3881),
    [sym_expression_statement] = STATE(3881),
    [sym_if_statement] = STATE(3881),
    [sym_switch_statement] = STATE(3881),
    [sym_case_statement] = STATE(3881),
    [sym_while_statement] = STATE(3881),
    [sym_do_statement] = STATE(3881),
    [sym_for_statement] = STATE(3881),
    [sym_return_statement] = STATE(3881),
    [sym_break_statement] = STATE(3881),
    [sym_continue_statement] = STATE(3881),
    [sym_goto_statement] = STATE(3881),
    [sym__expression] = STATE(1908),
    [sym_comma_expression] = STATE(1909),
    [sym_conditional_expression] = STATE(1908),
    [sym_assignment_expression] = STATE(1908),
    [sym_pointer_expression] = STATE(1908),
    [sym_logical_expression] = STATE(1908),
    [sym_bitwise_expression] = STATE(1908),
    [sym_equality_expression] = STATE(1908),
    [sym_relational_expression] = STATE(1908),
    [sym_shift_expression] = STATE(1908),
    [sym_math_expression] = STATE(1908),
    [sym_cast_expression] = STATE(1908),
    [sym_sizeof_expression] = STATE(1908),
    [sym_subscript_expression] = STATE(1908),
    [sym_call_expression] = STATE(1908),
    [sym_field_expression] = STATE(1908),
    [sym_compound_literal_expression] = STATE(1908),
    [sym_parenthesized_expression] = STATE(1908),
    [sym_char_literal] = STATE(1908),
    [sym_concatenated_string] = STATE(1908),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1908),
    [sym_for_range_loop] = STATE(3881),
    [sym_try_statement] = STATE(3881),
    [sym_new_expression] = STATE(1908),
    [sym_delete_expression] = STATE(1908),
    [sym_lambda_expression] = STATE(1908),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3996),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7766),
    [anon_sym_switch] = ACTIONS(7768),
    [anon_sym_case] = ACTIONS(7770),
    [anon_sym_default] = ACTIONS(7772),
    [anon_sym_while] = ACTIONS(7774),
    [anon_sym_do] = ACTIONS(4026),
    [anon_sym_for] = ACTIONS(7776),
    [anon_sym_return] = ACTIONS(4030),
    [anon_sym_break] = ACTIONS(4032),
    [anon_sym_continue] = ACTIONS(4034),
    [anon_sym_goto] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(3996),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4038),
    [sym_false] = ACTIONS(4038),
    [sym_null] = ACTIONS(4038),
    [sym_identifier] = ACTIONS(7778),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7780),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(4038),
  },
  [3850] = {
    [sym_compound_statement] = STATE(3617),
    [sym_labeled_statement] = STATE(3617),
    [sym_expression_statement] = STATE(3617),
    [sym_if_statement] = STATE(3617),
    [sym_switch_statement] = STATE(3617),
    [sym_case_statement] = STATE(3617),
    [sym_while_statement] = STATE(3617),
    [sym_do_statement] = STATE(3617),
    [sym_for_statement] = STATE(3617),
    [sym_return_statement] = STATE(3617),
    [sym_break_statement] = STATE(3617),
    [sym_continue_statement] = STATE(3617),
    [sym_goto_statement] = STATE(3617),
    [sym__expression] = STATE(1908),
    [sym_comma_expression] = STATE(1909),
    [sym_conditional_expression] = STATE(1908),
    [sym_assignment_expression] = STATE(1908),
    [sym_pointer_expression] = STATE(1908),
    [sym_logical_expression] = STATE(1908),
    [sym_bitwise_expression] = STATE(1908),
    [sym_equality_expression] = STATE(1908),
    [sym_relational_expression] = STATE(1908),
    [sym_shift_expression] = STATE(1908),
    [sym_math_expression] = STATE(1908),
    [sym_cast_expression] = STATE(1908),
    [sym_sizeof_expression] = STATE(1908),
    [sym_subscript_expression] = STATE(1908),
    [sym_call_expression] = STATE(1908),
    [sym_field_expression] = STATE(1908),
    [sym_compound_literal_expression] = STATE(1908),
    [sym_parenthesized_expression] = STATE(1908),
    [sym_char_literal] = STATE(1908),
    [sym_concatenated_string] = STATE(1908),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1908),
    [sym_for_range_loop] = STATE(3617),
    [sym_try_statement] = STATE(3617),
    [sym_new_expression] = STATE(1908),
    [sym_delete_expression] = STATE(1908),
    [sym_lambda_expression] = STATE(1908),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3996),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7766),
    [anon_sym_switch] = ACTIONS(7768),
    [anon_sym_case] = ACTIONS(7770),
    [anon_sym_default] = ACTIONS(7772),
    [anon_sym_while] = ACTIONS(7774),
    [anon_sym_do] = ACTIONS(4026),
    [anon_sym_for] = ACTIONS(7776),
    [anon_sym_return] = ACTIONS(4030),
    [anon_sym_break] = ACTIONS(4032),
    [anon_sym_continue] = ACTIONS(4034),
    [anon_sym_goto] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(3996),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4038),
    [sym_false] = ACTIONS(4038),
    [sym_null] = ACTIONS(4038),
    [sym_identifier] = ACTIONS(7778),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7780),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(4038),
  },
  [3851] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3883),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8500),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3852] = {
    [sym__expression] = STATE(3884),
    [sym_conditional_expression] = STATE(3884),
    [sym_assignment_expression] = STATE(3884),
    [sym_pointer_expression] = STATE(3884),
    [sym_logical_expression] = STATE(3884),
    [sym_bitwise_expression] = STATE(3884),
    [sym_equality_expression] = STATE(3884),
    [sym_relational_expression] = STATE(3884),
    [sym_shift_expression] = STATE(3884),
    [sym_math_expression] = STATE(3884),
    [sym_cast_expression] = STATE(3884),
    [sym_sizeof_expression] = STATE(3884),
    [sym_subscript_expression] = STATE(3884),
    [sym_call_expression] = STATE(3884),
    [sym_field_expression] = STATE(3884),
    [sym_compound_literal_expression] = STATE(3884),
    [sym_parenthesized_expression] = STATE(3884),
    [sym_char_literal] = STATE(3884),
    [sym_concatenated_string] = STATE(3884),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3884),
    [sym_new_expression] = STATE(3884),
    [sym_delete_expression] = STATE(3884),
    [sym_lambda_expression] = STATE(3884),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8502),
    [anon_sym_RPAREN] = ACTIONS(8500),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(8502),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8504),
    [sym_false] = ACTIONS(8504),
    [sym_null] = ACTIONS(8504),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(8504),
  },
  [3853] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_SEMI] = ACTIONS(8506),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1310),
    [anon_sym_SLASH_EQ] = ACTIONS(1310),
    [anon_sym_PERCENT_EQ] = ACTIONS(1310),
    [anon_sym_PLUS_EQ] = ACTIONS(1310),
    [anon_sym_DASH_EQ] = ACTIONS(1310),
    [anon_sym_LT_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1310),
    [anon_sym_AMP_EQ] = ACTIONS(1310),
    [anon_sym_CARET_EQ] = ACTIONS(1310),
    [anon_sym_PIPE_EQ] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3854] = {
    [sym_argument_list] = STATE(349),
    [anon_sym_RPAREN] = ACTIONS(8508),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2749),
    [anon_sym_EQ_EQ] = ACTIONS(2751),
    [anon_sym_BANG_EQ] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3855] = {
    [sym_raw_string_literal] = ACTIONS(8143),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(8145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(8145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(8145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(8145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(8145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(8145),
    [sym_preproc_directive] = ACTIONS(8145),
    [anon_sym_SEMI] = ACTIONS(8143),
    [anon_sym_typedef] = ACTIONS(8145),
    [anon_sym_extern] = ACTIONS(8145),
    [anon_sym_LBRACE] = ACTIONS(8143),
    [anon_sym_LPAREN2] = ACTIONS(8143),
    [anon_sym_STAR] = ACTIONS(8143),
    [anon_sym_LBRACK] = ACTIONS(8143),
    [anon_sym_static] = ACTIONS(8145),
    [anon_sym_register] = ACTIONS(8145),
    [anon_sym_inline] = ACTIONS(8145),
    [anon_sym_const] = ACTIONS(8145),
    [anon_sym_restrict] = ACTIONS(8145),
    [anon_sym_volatile] = ACTIONS(8145),
    [anon_sym__Atomic] = ACTIONS(8145),
    [anon_sym_mutable] = ACTIONS(8145),
    [anon_sym_explicit] = ACTIONS(8145),
    [anon_sym_constexpr] = ACTIONS(8145),
    [anon_sym_unsigned] = ACTIONS(8145),
    [anon_sym_long] = ACTIONS(8145),
    [anon_sym_short] = ACTIONS(8145),
    [sym_primitive_type] = ACTIONS(8145),
    [anon_sym_enum] = ACTIONS(8145),
    [anon_sym_struct] = ACTIONS(8145),
    [anon_sym_union] = ACTIONS(8145),
    [anon_sym_if] = ACTIONS(8145),
    [anon_sym_else] = ACTIONS(8145),
    [anon_sym_switch] = ACTIONS(8145),
    [anon_sym_case] = ACTIONS(8145),
    [anon_sym_default] = ACTIONS(8145),
    [anon_sym_while] = ACTIONS(8145),
    [anon_sym_do] = ACTIONS(8145),
    [anon_sym_for] = ACTIONS(8145),
    [anon_sym_return] = ACTIONS(8145),
    [anon_sym_break] = ACTIONS(8145),
    [anon_sym_continue] = ACTIONS(8145),
    [anon_sym_goto] = ACTIONS(8145),
    [anon_sym_AMP] = ACTIONS(8143),
    [anon_sym_BANG] = ACTIONS(8143),
    [anon_sym_TILDE] = ACTIONS(8143),
    [anon_sym_PLUS] = ACTIONS(8145),
    [anon_sym_DASH] = ACTIONS(8145),
    [anon_sym_DASH_DASH] = ACTIONS(8143),
    [anon_sym_PLUS_PLUS] = ACTIONS(8143),
    [anon_sym_sizeof] = ACTIONS(8145),
    [sym_number_literal] = ACTIONS(8143),
    [anon_sym_SQUOTE] = ACTIONS(8143),
    [anon_sym_DQUOTE] = ACTIONS(8143),
    [sym_true] = ACTIONS(8145),
    [sym_false] = ACTIONS(8145),
    [sym_null] = ACTIONS(8145),
    [sym_identifier] = ACTIONS(8145),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(8145),
    [sym_auto] = ACTIONS(8145),
    [anon_sym_typename] = ACTIONS(8145),
    [anon_sym_delete] = ACTIONS(8145),
    [anon_sym_try] = ACTIONS(8145),
    [anon_sym_new] = ACTIONS(8145),
    [anon_sym_COLON_COLON] = ACTIONS(8143),
    [sym_nullptr] = ACTIONS(8145),
  },
  [3856] = {
    [sym_compound_statement] = STATE(3887),
    [sym_labeled_statement] = STATE(3887),
    [sym_expression_statement] = STATE(3887),
    [sym_if_statement] = STATE(3887),
    [sym_switch_statement] = STATE(3887),
    [sym_case_statement] = STATE(3887),
    [sym_while_statement] = STATE(3887),
    [sym_do_statement] = STATE(3887),
    [sym_for_statement] = STATE(3887),
    [sym_return_statement] = STATE(3887),
    [sym_break_statement] = STATE(3887),
    [sym_continue_statement] = STATE(3887),
    [sym_goto_statement] = STATE(3887),
    [sym__expression] = STATE(1908),
    [sym_comma_expression] = STATE(1909),
    [sym_conditional_expression] = STATE(1908),
    [sym_assignment_expression] = STATE(1908),
    [sym_pointer_expression] = STATE(1908),
    [sym_logical_expression] = STATE(1908),
    [sym_bitwise_expression] = STATE(1908),
    [sym_equality_expression] = STATE(1908),
    [sym_relational_expression] = STATE(1908),
    [sym_shift_expression] = STATE(1908),
    [sym_math_expression] = STATE(1908),
    [sym_cast_expression] = STATE(1908),
    [sym_sizeof_expression] = STATE(1908),
    [sym_subscript_expression] = STATE(1908),
    [sym_call_expression] = STATE(1908),
    [sym_field_expression] = STATE(1908),
    [sym_compound_literal_expression] = STATE(1908),
    [sym_parenthesized_expression] = STATE(1908),
    [sym_char_literal] = STATE(1908),
    [sym_concatenated_string] = STATE(1908),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1908),
    [sym_for_range_loop] = STATE(3887),
    [sym_try_statement] = STATE(3887),
    [sym_new_expression] = STATE(1908),
    [sym_delete_expression] = STATE(1908),
    [sym_lambda_expression] = STATE(1908),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3996),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(4016),
    [anon_sym_switch] = ACTIONS(4018),
    [anon_sym_case] = ACTIONS(4020),
    [anon_sym_default] = ACTIONS(4022),
    [anon_sym_while] = ACTIONS(4024),
    [anon_sym_do] = ACTIONS(4026),
    [anon_sym_for] = ACTIONS(4028),
    [anon_sym_return] = ACTIONS(4030),
    [anon_sym_break] = ACTIONS(4032),
    [anon_sym_continue] = ACTIONS(4034),
    [anon_sym_goto] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(3996),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4038),
    [sym_false] = ACTIONS(4038),
    [sym_null] = ACTIONS(4038),
    [sym_identifier] = ACTIONS(6773),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(4042),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(4038),
  },
  [3857] = {
    [sym_compound_statement] = STATE(3631),
    [sym_labeled_statement] = STATE(3631),
    [sym_expression_statement] = STATE(3631),
    [sym_if_statement] = STATE(3631),
    [sym_switch_statement] = STATE(3631),
    [sym_case_statement] = STATE(3631),
    [sym_while_statement] = STATE(3631),
    [sym_do_statement] = STATE(3631),
    [sym_for_statement] = STATE(3631),
    [sym_return_statement] = STATE(3631),
    [sym_break_statement] = STATE(3631),
    [sym_continue_statement] = STATE(3631),
    [sym_goto_statement] = STATE(3631),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(3631),
    [sym_try_statement] = STATE(3631),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7431),
    [anon_sym_switch] = ACTIONS(7433),
    [anon_sym_case] = ACTIONS(7435),
    [anon_sym_default] = ACTIONS(7437),
    [anon_sym_while] = ACTIONS(7439),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(7441),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(7443),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7445),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2242),
  },
  [3858] = {
    [sym_raw_string_literal] = ACTIONS(7063),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(7065),
    [sym_preproc_directive] = ACTIONS(7065),
    [anon_sym_SEMI] = ACTIONS(7063),
    [anon_sym_typedef] = ACTIONS(7065),
    [anon_sym_extern] = ACTIONS(7065),
    [anon_sym_LBRACE] = ACTIONS(7063),
    [anon_sym_LPAREN2] = ACTIONS(7063),
    [anon_sym_STAR] = ACTIONS(7063),
    [anon_sym_LBRACK] = ACTIONS(7063),
    [anon_sym_static] = ACTIONS(7065),
    [anon_sym_register] = ACTIONS(7065),
    [anon_sym_inline] = ACTIONS(7065),
    [anon_sym_const] = ACTIONS(7065),
    [anon_sym_restrict] = ACTIONS(7065),
    [anon_sym_volatile] = ACTIONS(7065),
    [anon_sym__Atomic] = ACTIONS(7065),
    [anon_sym_mutable] = ACTIONS(7065),
    [anon_sym_explicit] = ACTIONS(7065),
    [anon_sym_constexpr] = ACTIONS(7065),
    [anon_sym_unsigned] = ACTIONS(7065),
    [anon_sym_long] = ACTIONS(7065),
    [anon_sym_short] = ACTIONS(7065),
    [sym_primitive_type] = ACTIONS(7065),
    [anon_sym_enum] = ACTIONS(7065),
    [anon_sym_struct] = ACTIONS(7065),
    [anon_sym_union] = ACTIONS(7065),
    [anon_sym_if] = ACTIONS(7065),
    [anon_sym_else] = ACTIONS(8510),
    [anon_sym_switch] = ACTIONS(7065),
    [anon_sym_case] = ACTIONS(7065),
    [anon_sym_default] = ACTIONS(7065),
    [anon_sym_while] = ACTIONS(7065),
    [anon_sym_do] = ACTIONS(7065),
    [anon_sym_for] = ACTIONS(7065),
    [anon_sym_return] = ACTIONS(7065),
    [anon_sym_break] = ACTIONS(7065),
    [anon_sym_continue] = ACTIONS(7065),
    [anon_sym_goto] = ACTIONS(7065),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_BANG] = ACTIONS(7063),
    [anon_sym_TILDE] = ACTIONS(7063),
    [anon_sym_PLUS] = ACTIONS(7065),
    [anon_sym_DASH] = ACTIONS(7065),
    [anon_sym_DASH_DASH] = ACTIONS(7063),
    [anon_sym_PLUS_PLUS] = ACTIONS(7063),
    [anon_sym_sizeof] = ACTIONS(7065),
    [sym_number_literal] = ACTIONS(7063),
    [anon_sym_SQUOTE] = ACTIONS(7063),
    [anon_sym_DQUOTE] = ACTIONS(7063),
    [sym_true] = ACTIONS(7065),
    [sym_false] = ACTIONS(7065),
    [sym_null] = ACTIONS(7065),
    [sym_identifier] = ACTIONS(7065),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7065),
    [sym_auto] = ACTIONS(7065),
    [anon_sym_typename] = ACTIONS(7065),
    [anon_sym_delete] = ACTIONS(7065),
    [anon_sym_try] = ACTIONS(7065),
    [anon_sym_new] = ACTIONS(7065),
    [anon_sym_COLON_COLON] = ACTIONS(7063),
    [sym_nullptr] = ACTIONS(7065),
  },
  [3859] = {
    [sym_compound_statement] = STATE(3633),
    [sym_labeled_statement] = STATE(3633),
    [sym_expression_statement] = STATE(3633),
    [sym_if_statement] = STATE(3633),
    [sym_switch_statement] = STATE(3633),
    [sym_case_statement] = STATE(3633),
    [sym_while_statement] = STATE(3633),
    [sym_do_statement] = STATE(3633),
    [sym_for_statement] = STATE(3633),
    [sym_return_statement] = STATE(3633),
    [sym_break_statement] = STATE(3633),
    [sym_continue_statement] = STATE(3633),
    [sym_goto_statement] = STATE(3633),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(3633),
    [sym_try_statement] = STATE(3633),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7431),
    [anon_sym_switch] = ACTIONS(7433),
    [anon_sym_case] = ACTIONS(7435),
    [anon_sym_default] = ACTIONS(7437),
    [anon_sym_while] = ACTIONS(7439),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(7441),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(7443),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7445),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2242),
  },
  [3860] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8512),
    [sym_comment] = ACTIONS(91),
  },
  [3861] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3890),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8512),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3862] = {
    [sym__expression] = STATE(3891),
    [sym_conditional_expression] = STATE(3891),
    [sym_assignment_expression] = STATE(3891),
    [sym_pointer_expression] = STATE(3891),
    [sym_logical_expression] = STATE(3891),
    [sym_bitwise_expression] = STATE(3891),
    [sym_equality_expression] = STATE(3891),
    [sym_relational_expression] = STATE(3891),
    [sym_shift_expression] = STATE(3891),
    [sym_math_expression] = STATE(3891),
    [sym_cast_expression] = STATE(3891),
    [sym_sizeof_expression] = STATE(3891),
    [sym_subscript_expression] = STATE(3891),
    [sym_call_expression] = STATE(3891),
    [sym_field_expression] = STATE(3891),
    [sym_compound_literal_expression] = STATE(3891),
    [sym_parenthesized_expression] = STATE(3891),
    [sym_char_literal] = STATE(3891),
    [sym_concatenated_string] = STATE(3891),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3891),
    [sym_new_expression] = STATE(3891),
    [sym_delete_expression] = STATE(3891),
    [sym_lambda_expression] = STATE(3891),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8514),
    [anon_sym_RPAREN] = ACTIONS(8512),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(8514),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8516),
    [sym_false] = ACTIONS(8516),
    [sym_null] = ACTIONS(8516),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(8516),
  },
  [3863] = {
    [sym_compound_statement] = STATE(3637),
    [sym_labeled_statement] = STATE(3637),
    [sym_expression_statement] = STATE(3637),
    [sym_if_statement] = STATE(3637),
    [sym_switch_statement] = STATE(3637),
    [sym_case_statement] = STATE(3637),
    [sym_while_statement] = STATE(3637),
    [sym_do_statement] = STATE(3637),
    [sym_for_statement] = STATE(3637),
    [sym_return_statement] = STATE(3637),
    [sym_break_statement] = STATE(3637),
    [sym_continue_statement] = STATE(3637),
    [sym_goto_statement] = STATE(3637),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(3637),
    [sym_try_statement] = STATE(3637),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7431),
    [anon_sym_switch] = ACTIONS(7433),
    [anon_sym_case] = ACTIONS(7435),
    [anon_sym_default] = ACTIONS(7437),
    [anon_sym_while] = ACTIONS(7439),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(7441),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(7443),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7445),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2242),
  },
  [3864] = {
    [sym_raw_string_literal] = ACTIONS(8287),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(8289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(8289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(8289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(8289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(8289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(8289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(8289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(8289),
    [sym_preproc_directive] = ACTIONS(8289),
    [anon_sym_SEMI] = ACTIONS(8287),
    [anon_sym_typedef] = ACTIONS(8289),
    [anon_sym_extern] = ACTIONS(8289),
    [anon_sym_LBRACE] = ACTIONS(8287),
    [anon_sym_LPAREN2] = ACTIONS(8287),
    [anon_sym_STAR] = ACTIONS(8287),
    [anon_sym_LBRACK] = ACTIONS(8287),
    [anon_sym_static] = ACTIONS(8289),
    [anon_sym_register] = ACTIONS(8289),
    [anon_sym_inline] = ACTIONS(8289),
    [anon_sym_const] = ACTIONS(8289),
    [anon_sym_restrict] = ACTIONS(8289),
    [anon_sym_volatile] = ACTIONS(8289),
    [anon_sym__Atomic] = ACTIONS(8289),
    [anon_sym_mutable] = ACTIONS(8289),
    [anon_sym_explicit] = ACTIONS(8289),
    [anon_sym_constexpr] = ACTIONS(8289),
    [anon_sym_unsigned] = ACTIONS(8289),
    [anon_sym_long] = ACTIONS(8289),
    [anon_sym_short] = ACTIONS(8289),
    [sym_primitive_type] = ACTIONS(8289),
    [anon_sym_enum] = ACTIONS(8289),
    [anon_sym_struct] = ACTIONS(8289),
    [anon_sym_union] = ACTIONS(8289),
    [anon_sym_if] = ACTIONS(8289),
    [anon_sym_else] = ACTIONS(8289),
    [anon_sym_switch] = ACTIONS(8289),
    [anon_sym_case] = ACTIONS(8289),
    [anon_sym_default] = ACTIONS(8289),
    [anon_sym_while] = ACTIONS(8289),
    [anon_sym_do] = ACTIONS(8289),
    [anon_sym_for] = ACTIONS(8289),
    [anon_sym_return] = ACTIONS(8289),
    [anon_sym_break] = ACTIONS(8289),
    [anon_sym_continue] = ACTIONS(8289),
    [anon_sym_goto] = ACTIONS(8289),
    [anon_sym_AMP] = ACTIONS(8287),
    [anon_sym_BANG] = ACTIONS(8287),
    [anon_sym_TILDE] = ACTIONS(8287),
    [anon_sym_PLUS] = ACTIONS(8289),
    [anon_sym_DASH] = ACTIONS(8289),
    [anon_sym_DASH_DASH] = ACTIONS(8287),
    [anon_sym_PLUS_PLUS] = ACTIONS(8287),
    [anon_sym_sizeof] = ACTIONS(8289),
    [sym_number_literal] = ACTIONS(8287),
    [anon_sym_SQUOTE] = ACTIONS(8287),
    [anon_sym_DQUOTE] = ACTIONS(8287),
    [sym_true] = ACTIONS(8289),
    [sym_false] = ACTIONS(8289),
    [sym_null] = ACTIONS(8289),
    [sym_identifier] = ACTIONS(8289),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(8289),
    [sym_auto] = ACTIONS(8289),
    [anon_sym_typename] = ACTIONS(8289),
    [anon_sym_delete] = ACTIONS(8289),
    [anon_sym_try] = ACTIONS(8289),
    [anon_sym_new] = ACTIONS(8289),
    [anon_sym_COLON_COLON] = ACTIONS(8287),
    [sym_nullptr] = ACTIONS(8289),
  },
  [3865] = {
    [sym_compound_statement] = STATE(3645),
    [sym_labeled_statement] = STATE(3645),
    [sym_expression_statement] = STATE(3645),
    [sym_if_statement] = STATE(3645),
    [sym_switch_statement] = STATE(3645),
    [sym_case_statement] = STATE(3645),
    [sym_while_statement] = STATE(3645),
    [sym_do_statement] = STATE(3645),
    [sym_for_statement] = STATE(3645),
    [sym_return_statement] = STATE(3645),
    [sym_break_statement] = STATE(3645),
    [sym_continue_statement] = STATE(3645),
    [sym_goto_statement] = STATE(3645),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(3645),
    [sym_try_statement] = STATE(3645),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(157),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(5814),
    [anon_sym_switch] = ACTIONS(5816),
    [anon_sym_case] = ACTIONS(5818),
    [anon_sym_default] = ACTIONS(5820),
    [anon_sym_while] = ACTIONS(5822),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(5824),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(5826),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(5828),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(207),
  },
  [3866] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8518),
    [sym_comment] = ACTIONS(91),
  },
  [3867] = {
    [sym_compound_statement] = STATE(3681),
    [sym_labeled_statement] = STATE(3681),
    [sym_expression_statement] = STATE(3681),
    [sym_if_statement] = STATE(3681),
    [sym_switch_statement] = STATE(3681),
    [sym_case_statement] = STATE(3681),
    [sym_while_statement] = STATE(3681),
    [sym_do_statement] = STATE(3681),
    [sym_for_statement] = STATE(3681),
    [sym_return_statement] = STATE(3681),
    [sym_break_statement] = STATE(3681),
    [sym_continue_statement] = STATE(3681),
    [sym_goto_statement] = STATE(3681),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(3681),
    [sym_try_statement] = STATE(3681),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(4430),
    [anon_sym_switch] = ACTIONS(4432),
    [anon_sym_case] = ACTIONS(4434),
    [anon_sym_default] = ACTIONS(4436),
    [anon_sym_while] = ACTIONS(4438),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(4440),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(4442),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(4444),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [3868] = {
    [sym_compound_statement] = STATE(3679),
    [sym_labeled_statement] = STATE(3679),
    [sym_expression_statement] = STATE(3679),
    [sym_if_statement] = STATE(3679),
    [sym_switch_statement] = STATE(3679),
    [sym_case_statement] = STATE(3679),
    [sym_while_statement] = STATE(3679),
    [sym_do_statement] = STATE(3679),
    [sym_for_statement] = STATE(3679),
    [sym_return_statement] = STATE(3679),
    [sym_break_statement] = STATE(3679),
    [sym_continue_statement] = STATE(3679),
    [sym_goto_statement] = STATE(3679),
    [sym__expression] = STATE(222),
    [sym_comma_expression] = STATE(223),
    [sym_conditional_expression] = STATE(222),
    [sym_assignment_expression] = STATE(222),
    [sym_pointer_expression] = STATE(222),
    [sym_logical_expression] = STATE(222),
    [sym_bitwise_expression] = STATE(222),
    [sym_equality_expression] = STATE(222),
    [sym_relational_expression] = STATE(222),
    [sym_shift_expression] = STATE(222),
    [sym_math_expression] = STATE(222),
    [sym_cast_expression] = STATE(222),
    [sym_sizeof_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_call_expression] = STATE(222),
    [sym_field_expression] = STATE(222),
    [sym_compound_literal_expression] = STATE(222),
    [sym_parenthesized_expression] = STATE(222),
    [sym_char_literal] = STATE(222),
    [sym_concatenated_string] = STATE(222),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(222),
    [sym_for_range_loop] = STATE(3679),
    [sym_try_statement] = STATE(3679),
    [sym_new_expression] = STATE(222),
    [sym_delete_expression] = STATE(222),
    [sym_lambda_expression] = STATE(222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(6119),
    [anon_sym_switch] = ACTIONS(6121),
    [anon_sym_case] = ACTIONS(6123),
    [anon_sym_default] = ACTIONS(6125),
    [anon_sym_while] = ACTIONS(6127),
    [anon_sym_do] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(6129),
    [anon_sym_return] = ACTIONS(373),
    [anon_sym_break] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_goto] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(353),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_identifier] = ACTIONS(6131),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(6133),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(381),
  },
  [3869] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8520),
    [sym_comment] = ACTIONS(91),
  },
  [3870] = {
    [sym_compound_statement] = STATE(3366),
    [sym_labeled_statement] = STATE(3366),
    [sym_expression_statement] = STATE(3366),
    [sym_if_statement] = STATE(3366),
    [sym_switch_statement] = STATE(3366),
    [sym_case_statement] = STATE(3366),
    [sym_while_statement] = STATE(3366),
    [sym_do_statement] = STATE(3366),
    [sym_for_statement] = STATE(3366),
    [sym_return_statement] = STATE(3366),
    [sym_break_statement] = STATE(3366),
    [sym_continue_statement] = STATE(3366),
    [sym_goto_statement] = STATE(3366),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(3366),
    [sym_try_statement] = STATE(3366),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7177),
    [anon_sym_switch] = ACTIONS(7179),
    [anon_sym_case] = ACTIONS(7181),
    [anon_sym_default] = ACTIONS(7183),
    [anon_sym_while] = ACTIONS(7185),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(7187),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(7189),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7191),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [3871] = {
    [sym_compound_statement] = STATE(3382),
    [sym_labeled_statement] = STATE(3382),
    [sym_expression_statement] = STATE(3382),
    [sym_if_statement] = STATE(3382),
    [sym_switch_statement] = STATE(3382),
    [sym_case_statement] = STATE(3382),
    [sym_while_statement] = STATE(3382),
    [sym_do_statement] = STATE(3382),
    [sym_for_statement] = STATE(3382),
    [sym_return_statement] = STATE(3382),
    [sym_break_statement] = STATE(3382),
    [sym_continue_statement] = STATE(3382),
    [sym_goto_statement] = STATE(3382),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(3382),
    [sym_try_statement] = STATE(3382),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7177),
    [anon_sym_switch] = ACTIONS(7179),
    [anon_sym_case] = ACTIONS(7181),
    [anon_sym_default] = ACTIONS(7183),
    [anon_sym_while] = ACTIONS(7185),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(7187),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(7189),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7191),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [3872] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8522),
    [sym_comment] = ACTIONS(91),
  },
  [3873] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3895),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8522),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3874] = {
    [sym_compound_statement] = STATE(3706),
    [sym_labeled_statement] = STATE(3706),
    [sym_expression_statement] = STATE(3706),
    [sym_if_statement] = STATE(3706),
    [sym_switch_statement] = STATE(3706),
    [sym_case_statement] = STATE(3706),
    [sym_while_statement] = STATE(3706),
    [sym_do_statement] = STATE(3706),
    [sym_for_statement] = STATE(3706),
    [sym_return_statement] = STATE(3706),
    [sym_break_statement] = STATE(3706),
    [sym_continue_statement] = STATE(3706),
    [sym_goto_statement] = STATE(3706),
    [sym__expression] = STATE(1020),
    [sym_comma_expression] = STATE(1021),
    [sym_conditional_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1020),
    [sym_pointer_expression] = STATE(1020),
    [sym_logical_expression] = STATE(1020),
    [sym_bitwise_expression] = STATE(1020),
    [sym_equality_expression] = STATE(1020),
    [sym_relational_expression] = STATE(1020),
    [sym_shift_expression] = STATE(1020),
    [sym_math_expression] = STATE(1020),
    [sym_cast_expression] = STATE(1020),
    [sym_sizeof_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_field_expression] = STATE(1020),
    [sym_compound_literal_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_char_literal] = STATE(1020),
    [sym_concatenated_string] = STATE(1020),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1020),
    [sym_for_range_loop] = STATE(3706),
    [sym_try_statement] = STATE(3706),
    [sym_new_expression] = STATE(1020),
    [sym_delete_expression] = STATE(1020),
    [sym_lambda_expression] = STATE(1020),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2022),
    [anon_sym_SEMI] = ACTIONS(2036),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7300),
    [anon_sym_switch] = ACTIONS(7302),
    [anon_sym_case] = ACTIONS(7304),
    [anon_sym_default] = ACTIONS(7306),
    [anon_sym_while] = ACTIONS(7308),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(7310),
    [anon_sym_return] = ACTIONS(2058),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2062),
    [anon_sym_goto] = ACTIONS(2064),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(7312),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7314),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2066),
  },
  [3875] = {
    [sym_compound_statement] = STATE(3707),
    [sym_labeled_statement] = STATE(3707),
    [sym_expression_statement] = STATE(3707),
    [sym_if_statement] = STATE(3707),
    [sym_switch_statement] = STATE(3707),
    [sym_case_statement] = STATE(3707),
    [sym_while_statement] = STATE(3707),
    [sym_do_statement] = STATE(3707),
    [sym_for_statement] = STATE(3707),
    [sym_return_statement] = STATE(3707),
    [sym_break_statement] = STATE(3707),
    [sym_continue_statement] = STATE(3707),
    [sym_goto_statement] = STATE(3707),
    [sym__expression] = STATE(1020),
    [sym_comma_expression] = STATE(1021),
    [sym_conditional_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1020),
    [sym_pointer_expression] = STATE(1020),
    [sym_logical_expression] = STATE(1020),
    [sym_bitwise_expression] = STATE(1020),
    [sym_equality_expression] = STATE(1020),
    [sym_relational_expression] = STATE(1020),
    [sym_shift_expression] = STATE(1020),
    [sym_math_expression] = STATE(1020),
    [sym_cast_expression] = STATE(1020),
    [sym_sizeof_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_field_expression] = STATE(1020),
    [sym_compound_literal_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_char_literal] = STATE(1020),
    [sym_concatenated_string] = STATE(1020),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1020),
    [sym_for_range_loop] = STATE(3707),
    [sym_try_statement] = STATE(3707),
    [sym_new_expression] = STATE(1020),
    [sym_delete_expression] = STATE(1020),
    [sym_lambda_expression] = STATE(1020),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2022),
    [anon_sym_SEMI] = ACTIONS(2036),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7300),
    [anon_sym_switch] = ACTIONS(7302),
    [anon_sym_case] = ACTIONS(7304),
    [anon_sym_default] = ACTIONS(7306),
    [anon_sym_while] = ACTIONS(7308),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(7310),
    [anon_sym_return] = ACTIONS(2058),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2062),
    [anon_sym_goto] = ACTIONS(2064),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(7312),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7314),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2066),
  },
  [3876] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8524),
    [sym_comment] = ACTIONS(91),
  },
  [3877] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3897),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8524),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3878] = {
    [sym_compound_statement] = STATE(3717),
    [sym_labeled_statement] = STATE(3717),
    [sym_expression_statement] = STATE(3717),
    [sym_if_statement] = STATE(3717),
    [sym_switch_statement] = STATE(3717),
    [sym_case_statement] = STATE(3717),
    [sym_while_statement] = STATE(3717),
    [sym_do_statement] = STATE(3717),
    [sym_for_statement] = STATE(3717),
    [sym_return_statement] = STATE(3717),
    [sym_break_statement] = STATE(3717),
    [sym_continue_statement] = STATE(3717),
    [sym_goto_statement] = STATE(3717),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(411),
    [sym_for_range_loop] = STATE(3717),
    [sym_try_statement] = STATE(3717),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(678),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(6682),
    [anon_sym_switch] = ACTIONS(6684),
    [anon_sym_case] = ACTIONS(6686),
    [anon_sym_default] = ACTIONS(6688),
    [anon_sym_while] = ACTIONS(6690),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(6692),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(6694),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(6696),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(726),
  },
  [3879] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8526),
    [sym_comment] = ACTIONS(91),
  },
  [3880] = {
    [sym_compound_statement] = STATE(3727),
    [sym_labeled_statement] = STATE(3727),
    [sym_expression_statement] = STATE(3727),
    [sym_if_statement] = STATE(3727),
    [sym_switch_statement] = STATE(3727),
    [sym_case_statement] = STATE(3727),
    [sym_while_statement] = STATE(3727),
    [sym_do_statement] = STATE(3727),
    [sym_for_statement] = STATE(3727),
    [sym_return_statement] = STATE(3727),
    [sym_break_statement] = STATE(3727),
    [sym_continue_statement] = STATE(3727),
    [sym_goto_statement] = STATE(3727),
    [sym__expression] = STATE(1908),
    [sym_comma_expression] = STATE(1909),
    [sym_conditional_expression] = STATE(1908),
    [sym_assignment_expression] = STATE(1908),
    [sym_pointer_expression] = STATE(1908),
    [sym_logical_expression] = STATE(1908),
    [sym_bitwise_expression] = STATE(1908),
    [sym_equality_expression] = STATE(1908),
    [sym_relational_expression] = STATE(1908),
    [sym_shift_expression] = STATE(1908),
    [sym_math_expression] = STATE(1908),
    [sym_cast_expression] = STATE(1908),
    [sym_sizeof_expression] = STATE(1908),
    [sym_subscript_expression] = STATE(1908),
    [sym_call_expression] = STATE(1908),
    [sym_field_expression] = STATE(1908),
    [sym_compound_literal_expression] = STATE(1908),
    [sym_parenthesized_expression] = STATE(1908),
    [sym_char_literal] = STATE(1908),
    [sym_concatenated_string] = STATE(1908),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1908),
    [sym_for_range_loop] = STATE(3727),
    [sym_try_statement] = STATE(3727),
    [sym_new_expression] = STATE(1908),
    [sym_delete_expression] = STATE(1908),
    [sym_lambda_expression] = STATE(1908),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3996),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7766),
    [anon_sym_switch] = ACTIONS(7768),
    [anon_sym_case] = ACTIONS(7770),
    [anon_sym_default] = ACTIONS(7772),
    [anon_sym_while] = ACTIONS(7774),
    [anon_sym_do] = ACTIONS(4026),
    [anon_sym_for] = ACTIONS(7776),
    [anon_sym_return] = ACTIONS(4030),
    [anon_sym_break] = ACTIONS(4032),
    [anon_sym_continue] = ACTIONS(4034),
    [anon_sym_goto] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(3996),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4038),
    [sym_false] = ACTIONS(4038),
    [sym_null] = ACTIONS(4038),
    [sym_identifier] = ACTIONS(7778),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7780),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(4038),
  },
  [3881] = {
    [sym_raw_string_literal] = ACTIONS(7063),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(7065),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(7065),
    [sym_preproc_directive] = ACTIONS(7065),
    [anon_sym_SEMI] = ACTIONS(7063),
    [anon_sym_typedef] = ACTIONS(7065),
    [anon_sym_extern] = ACTIONS(7065),
    [anon_sym_LBRACE] = ACTIONS(7063),
    [anon_sym_LPAREN2] = ACTIONS(7063),
    [anon_sym_STAR] = ACTIONS(7063),
    [anon_sym_LBRACK] = ACTIONS(7063),
    [anon_sym_static] = ACTIONS(7065),
    [anon_sym_register] = ACTIONS(7065),
    [anon_sym_inline] = ACTIONS(7065),
    [anon_sym_const] = ACTIONS(7065),
    [anon_sym_restrict] = ACTIONS(7065),
    [anon_sym_volatile] = ACTIONS(7065),
    [anon_sym__Atomic] = ACTIONS(7065),
    [anon_sym_mutable] = ACTIONS(7065),
    [anon_sym_explicit] = ACTIONS(7065),
    [anon_sym_constexpr] = ACTIONS(7065),
    [anon_sym_unsigned] = ACTIONS(7065),
    [anon_sym_long] = ACTIONS(7065),
    [anon_sym_short] = ACTIONS(7065),
    [sym_primitive_type] = ACTIONS(7065),
    [anon_sym_enum] = ACTIONS(7065),
    [anon_sym_struct] = ACTIONS(7065),
    [anon_sym_union] = ACTIONS(7065),
    [anon_sym_if] = ACTIONS(7065),
    [anon_sym_else] = ACTIONS(8528),
    [anon_sym_switch] = ACTIONS(7065),
    [anon_sym_case] = ACTIONS(7065),
    [anon_sym_default] = ACTIONS(7065),
    [anon_sym_while] = ACTIONS(7065),
    [anon_sym_do] = ACTIONS(7065),
    [anon_sym_for] = ACTIONS(7065),
    [anon_sym_return] = ACTIONS(7065),
    [anon_sym_break] = ACTIONS(7065),
    [anon_sym_continue] = ACTIONS(7065),
    [anon_sym_goto] = ACTIONS(7065),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_BANG] = ACTIONS(7063),
    [anon_sym_TILDE] = ACTIONS(7063),
    [anon_sym_PLUS] = ACTIONS(7065),
    [anon_sym_DASH] = ACTIONS(7065),
    [anon_sym_DASH_DASH] = ACTIONS(7063),
    [anon_sym_PLUS_PLUS] = ACTIONS(7063),
    [anon_sym_sizeof] = ACTIONS(7065),
    [sym_number_literal] = ACTIONS(7063),
    [anon_sym_SQUOTE] = ACTIONS(7063),
    [anon_sym_DQUOTE] = ACTIONS(7063),
    [sym_true] = ACTIONS(7065),
    [sym_false] = ACTIONS(7065),
    [sym_null] = ACTIONS(7065),
    [sym_identifier] = ACTIONS(7065),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(7065),
    [sym_auto] = ACTIONS(7065),
    [anon_sym_typename] = ACTIONS(7065),
    [anon_sym_delete] = ACTIONS(7065),
    [anon_sym_try] = ACTIONS(7065),
    [anon_sym_new] = ACTIONS(7065),
    [anon_sym_COLON_COLON] = ACTIONS(7063),
    [sym_nullptr] = ACTIONS(7065),
  },
  [3882] = {
    [sym_compound_statement] = STATE(3729),
    [sym_labeled_statement] = STATE(3729),
    [sym_expression_statement] = STATE(3729),
    [sym_if_statement] = STATE(3729),
    [sym_switch_statement] = STATE(3729),
    [sym_case_statement] = STATE(3729),
    [sym_while_statement] = STATE(3729),
    [sym_do_statement] = STATE(3729),
    [sym_for_statement] = STATE(3729),
    [sym_return_statement] = STATE(3729),
    [sym_break_statement] = STATE(3729),
    [sym_continue_statement] = STATE(3729),
    [sym_goto_statement] = STATE(3729),
    [sym__expression] = STATE(1908),
    [sym_comma_expression] = STATE(1909),
    [sym_conditional_expression] = STATE(1908),
    [sym_assignment_expression] = STATE(1908),
    [sym_pointer_expression] = STATE(1908),
    [sym_logical_expression] = STATE(1908),
    [sym_bitwise_expression] = STATE(1908),
    [sym_equality_expression] = STATE(1908),
    [sym_relational_expression] = STATE(1908),
    [sym_shift_expression] = STATE(1908),
    [sym_math_expression] = STATE(1908),
    [sym_cast_expression] = STATE(1908),
    [sym_sizeof_expression] = STATE(1908),
    [sym_subscript_expression] = STATE(1908),
    [sym_call_expression] = STATE(1908),
    [sym_field_expression] = STATE(1908),
    [sym_compound_literal_expression] = STATE(1908),
    [sym_parenthesized_expression] = STATE(1908),
    [sym_char_literal] = STATE(1908),
    [sym_concatenated_string] = STATE(1908),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1908),
    [sym_for_range_loop] = STATE(3729),
    [sym_try_statement] = STATE(3729),
    [sym_new_expression] = STATE(1908),
    [sym_delete_expression] = STATE(1908),
    [sym_lambda_expression] = STATE(1908),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3996),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7766),
    [anon_sym_switch] = ACTIONS(7768),
    [anon_sym_case] = ACTIONS(7770),
    [anon_sym_default] = ACTIONS(7772),
    [anon_sym_while] = ACTIONS(7774),
    [anon_sym_do] = ACTIONS(4026),
    [anon_sym_for] = ACTIONS(7776),
    [anon_sym_return] = ACTIONS(4030),
    [anon_sym_break] = ACTIONS(4032),
    [anon_sym_continue] = ACTIONS(4034),
    [anon_sym_goto] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(3996),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4038),
    [sym_false] = ACTIONS(4038),
    [sym_null] = ACTIONS(4038),
    [sym_identifier] = ACTIONS(7778),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7780),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(4038),
  },
  [3883] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8530),
    [sym_comment] = ACTIONS(91),
  },
  [3884] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3901),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8530),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3885] = {
    [sym__expression] = STATE(3902),
    [sym_conditional_expression] = STATE(3902),
    [sym_assignment_expression] = STATE(3902),
    [sym_pointer_expression] = STATE(3902),
    [sym_logical_expression] = STATE(3902),
    [sym_bitwise_expression] = STATE(3902),
    [sym_equality_expression] = STATE(3902),
    [sym_relational_expression] = STATE(3902),
    [sym_shift_expression] = STATE(3902),
    [sym_math_expression] = STATE(3902),
    [sym_cast_expression] = STATE(3902),
    [sym_sizeof_expression] = STATE(3902),
    [sym_subscript_expression] = STATE(3902),
    [sym_call_expression] = STATE(3902),
    [sym_field_expression] = STATE(3902),
    [sym_compound_literal_expression] = STATE(3902),
    [sym_parenthesized_expression] = STATE(3902),
    [sym_char_literal] = STATE(3902),
    [sym_concatenated_string] = STATE(3902),
    [sym_string_literal] = STATE(140),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(3902),
    [sym_new_expression] = STATE(3902),
    [sym_delete_expression] = STATE(3902),
    [sym_lambda_expression] = STATE(3902),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(8532),
    [anon_sym_RPAREN] = ACTIONS(8530),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_sizeof] = ACTIONS(239),
    [sym_number_literal] = ACTIONS(8532),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(8534),
    [sym_false] = ACTIONS(8534),
    [sym_null] = ACTIONS(8534),
    [sym_identifier] = ACTIONS(291),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [sym_nullptr] = ACTIONS(8534),
  },
  [3886] = {
    [sym_compound_statement] = STATE(3733),
    [sym_labeled_statement] = STATE(3733),
    [sym_expression_statement] = STATE(3733),
    [sym_if_statement] = STATE(3733),
    [sym_switch_statement] = STATE(3733),
    [sym_case_statement] = STATE(3733),
    [sym_while_statement] = STATE(3733),
    [sym_do_statement] = STATE(3733),
    [sym_for_statement] = STATE(3733),
    [sym_return_statement] = STATE(3733),
    [sym_break_statement] = STATE(3733),
    [sym_continue_statement] = STATE(3733),
    [sym_goto_statement] = STATE(3733),
    [sym__expression] = STATE(1908),
    [sym_comma_expression] = STATE(1909),
    [sym_conditional_expression] = STATE(1908),
    [sym_assignment_expression] = STATE(1908),
    [sym_pointer_expression] = STATE(1908),
    [sym_logical_expression] = STATE(1908),
    [sym_bitwise_expression] = STATE(1908),
    [sym_equality_expression] = STATE(1908),
    [sym_relational_expression] = STATE(1908),
    [sym_shift_expression] = STATE(1908),
    [sym_math_expression] = STATE(1908),
    [sym_cast_expression] = STATE(1908),
    [sym_sizeof_expression] = STATE(1908),
    [sym_subscript_expression] = STATE(1908),
    [sym_call_expression] = STATE(1908),
    [sym_field_expression] = STATE(1908),
    [sym_compound_literal_expression] = STATE(1908),
    [sym_parenthesized_expression] = STATE(1908),
    [sym_char_literal] = STATE(1908),
    [sym_concatenated_string] = STATE(1908),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1908),
    [sym_for_range_loop] = STATE(3733),
    [sym_try_statement] = STATE(3733),
    [sym_new_expression] = STATE(1908),
    [sym_delete_expression] = STATE(1908),
    [sym_lambda_expression] = STATE(1908),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3996),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7766),
    [anon_sym_switch] = ACTIONS(7768),
    [anon_sym_case] = ACTIONS(7770),
    [anon_sym_default] = ACTIONS(7772),
    [anon_sym_while] = ACTIONS(7774),
    [anon_sym_do] = ACTIONS(4026),
    [anon_sym_for] = ACTIONS(7776),
    [anon_sym_return] = ACTIONS(4030),
    [anon_sym_break] = ACTIONS(4032),
    [anon_sym_continue] = ACTIONS(4034),
    [anon_sym_goto] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(3996),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4038),
    [sym_false] = ACTIONS(4038),
    [sym_null] = ACTIONS(4038),
    [sym_identifier] = ACTIONS(7778),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7780),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(4038),
  },
  [3887] = {
    [sym_raw_string_literal] = ACTIONS(8287),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(8289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(8289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(8289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(8289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(8289),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(8289),
    [sym_preproc_directive] = ACTIONS(8289),
    [anon_sym_SEMI] = ACTIONS(8287),
    [anon_sym_typedef] = ACTIONS(8289),
    [anon_sym_extern] = ACTIONS(8289),
    [anon_sym_LBRACE] = ACTIONS(8287),
    [anon_sym_LPAREN2] = ACTIONS(8287),
    [anon_sym_STAR] = ACTIONS(8287),
    [anon_sym_LBRACK] = ACTIONS(8287),
    [anon_sym_static] = ACTIONS(8289),
    [anon_sym_register] = ACTIONS(8289),
    [anon_sym_inline] = ACTIONS(8289),
    [anon_sym_const] = ACTIONS(8289),
    [anon_sym_restrict] = ACTIONS(8289),
    [anon_sym_volatile] = ACTIONS(8289),
    [anon_sym__Atomic] = ACTIONS(8289),
    [anon_sym_mutable] = ACTIONS(8289),
    [anon_sym_explicit] = ACTIONS(8289),
    [anon_sym_constexpr] = ACTIONS(8289),
    [anon_sym_unsigned] = ACTIONS(8289),
    [anon_sym_long] = ACTIONS(8289),
    [anon_sym_short] = ACTIONS(8289),
    [sym_primitive_type] = ACTIONS(8289),
    [anon_sym_enum] = ACTIONS(8289),
    [anon_sym_struct] = ACTIONS(8289),
    [anon_sym_union] = ACTIONS(8289),
    [anon_sym_if] = ACTIONS(8289),
    [anon_sym_else] = ACTIONS(8289),
    [anon_sym_switch] = ACTIONS(8289),
    [anon_sym_case] = ACTIONS(8289),
    [anon_sym_default] = ACTIONS(8289),
    [anon_sym_while] = ACTIONS(8289),
    [anon_sym_do] = ACTIONS(8289),
    [anon_sym_for] = ACTIONS(8289),
    [anon_sym_return] = ACTIONS(8289),
    [anon_sym_break] = ACTIONS(8289),
    [anon_sym_continue] = ACTIONS(8289),
    [anon_sym_goto] = ACTIONS(8289),
    [anon_sym_AMP] = ACTIONS(8287),
    [anon_sym_BANG] = ACTIONS(8287),
    [anon_sym_TILDE] = ACTIONS(8287),
    [anon_sym_PLUS] = ACTIONS(8289),
    [anon_sym_DASH] = ACTIONS(8289),
    [anon_sym_DASH_DASH] = ACTIONS(8287),
    [anon_sym_PLUS_PLUS] = ACTIONS(8287),
    [anon_sym_sizeof] = ACTIONS(8289),
    [sym_number_literal] = ACTIONS(8287),
    [anon_sym_SQUOTE] = ACTIONS(8287),
    [anon_sym_DQUOTE] = ACTIONS(8287),
    [sym_true] = ACTIONS(8289),
    [sym_false] = ACTIONS(8289),
    [sym_null] = ACTIONS(8289),
    [sym_identifier] = ACTIONS(8289),
    [sym_comment] = ACTIONS(91),
    [anon_sym_class] = ACTIONS(8289),
    [sym_auto] = ACTIONS(8289),
    [anon_sym_typename] = ACTIONS(8289),
    [anon_sym_delete] = ACTIONS(8289),
    [anon_sym_try] = ACTIONS(8289),
    [anon_sym_new] = ACTIONS(8289),
    [anon_sym_COLON_COLON] = ACTIONS(8287),
    [sym_nullptr] = ACTIONS(8289),
  },
  [3888] = {
    [sym_compound_statement] = STATE(3741),
    [sym_labeled_statement] = STATE(3741),
    [sym_expression_statement] = STATE(3741),
    [sym_if_statement] = STATE(3741),
    [sym_switch_statement] = STATE(3741),
    [sym_case_statement] = STATE(3741),
    [sym_while_statement] = STATE(3741),
    [sym_do_statement] = STATE(3741),
    [sym_for_statement] = STATE(3741),
    [sym_return_statement] = STATE(3741),
    [sym_break_statement] = STATE(3741),
    [sym_continue_statement] = STATE(3741),
    [sym_goto_statement] = STATE(3741),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(3741),
    [sym_try_statement] = STATE(3741),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7431),
    [anon_sym_switch] = ACTIONS(7433),
    [anon_sym_case] = ACTIONS(7435),
    [anon_sym_default] = ACTIONS(7437),
    [anon_sym_while] = ACTIONS(7439),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(7441),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(7443),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7445),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2242),
  },
  [3889] = {
    [sym_compound_statement] = STATE(3742),
    [sym_labeled_statement] = STATE(3742),
    [sym_expression_statement] = STATE(3742),
    [sym_if_statement] = STATE(3742),
    [sym_switch_statement] = STATE(3742),
    [sym_case_statement] = STATE(3742),
    [sym_while_statement] = STATE(3742),
    [sym_do_statement] = STATE(3742),
    [sym_for_statement] = STATE(3742),
    [sym_return_statement] = STATE(3742),
    [sym_break_statement] = STATE(3742),
    [sym_continue_statement] = STATE(3742),
    [sym_goto_statement] = STATE(3742),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(3742),
    [sym_try_statement] = STATE(3742),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7431),
    [anon_sym_switch] = ACTIONS(7433),
    [anon_sym_case] = ACTIONS(7435),
    [anon_sym_default] = ACTIONS(7437),
    [anon_sym_while] = ACTIONS(7439),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(7441),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(7443),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7445),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2242),
  },
  [3890] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8536),
    [sym_comment] = ACTIONS(91),
  },
  [3891] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3904),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8536),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3892] = {
    [sym_compound_statement] = STATE(3752),
    [sym_labeled_statement] = STATE(3752),
    [sym_expression_statement] = STATE(3752),
    [sym_if_statement] = STATE(3752),
    [sym_switch_statement] = STATE(3752),
    [sym_case_statement] = STATE(3752),
    [sym_while_statement] = STATE(3752),
    [sym_do_statement] = STATE(3752),
    [sym_for_statement] = STATE(3752),
    [sym_return_statement] = STATE(3752),
    [sym_break_statement] = STATE(3752),
    [sym_continue_statement] = STATE(3752),
    [sym_goto_statement] = STATE(3752),
    [sym__expression] = STATE(114),
    [sym_comma_expression] = STATE(115),
    [sym_conditional_expression] = STATE(114),
    [sym_assignment_expression] = STATE(114),
    [sym_pointer_expression] = STATE(114),
    [sym_logical_expression] = STATE(114),
    [sym_bitwise_expression] = STATE(114),
    [sym_equality_expression] = STATE(114),
    [sym_relational_expression] = STATE(114),
    [sym_shift_expression] = STATE(114),
    [sym_math_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_sizeof_expression] = STATE(114),
    [sym_subscript_expression] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_field_expression] = STATE(114),
    [sym_compound_literal_expression] = STATE(114),
    [sym_parenthesized_expression] = STATE(114),
    [sym_char_literal] = STATE(114),
    [sym_concatenated_string] = STATE(114),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(114),
    [sym_for_range_loop] = STATE(3752),
    [sym_try_statement] = STATE(3752),
    [sym_new_expression] = STATE(114),
    [sym_delete_expression] = STATE(114),
    [sym_lambda_expression] = STATE(114),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(157),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(5814),
    [anon_sym_switch] = ACTIONS(5816),
    [anon_sym_case] = ACTIONS(5818),
    [anon_sym_default] = ACTIONS(5820),
    [anon_sym_while] = ACTIONS(5822),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(5824),
    [anon_sym_return] = ACTIONS(197),
    [anon_sym_break] = ACTIONS(199),
    [anon_sym_continue] = ACTIONS(201),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(207),
    [sym_false] = ACTIONS(207),
    [sym_null] = ACTIONS(207),
    [sym_identifier] = ACTIONS(5826),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(5828),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(207),
  },
  [3893] = {
    [sym_compound_statement] = STATE(3769),
    [sym_labeled_statement] = STATE(3769),
    [sym_expression_statement] = STATE(3769),
    [sym_if_statement] = STATE(3769),
    [sym_switch_statement] = STATE(3769),
    [sym_case_statement] = STATE(3769),
    [sym_while_statement] = STATE(3769),
    [sym_do_statement] = STATE(3769),
    [sym_for_statement] = STATE(3769),
    [sym_return_statement] = STATE(3769),
    [sym_break_statement] = STATE(3769),
    [sym_continue_statement] = STATE(3769),
    [sym_goto_statement] = STATE(3769),
    [sym__expression] = STATE(222),
    [sym_comma_expression] = STATE(223),
    [sym_conditional_expression] = STATE(222),
    [sym_assignment_expression] = STATE(222),
    [sym_pointer_expression] = STATE(222),
    [sym_logical_expression] = STATE(222),
    [sym_bitwise_expression] = STATE(222),
    [sym_equality_expression] = STATE(222),
    [sym_relational_expression] = STATE(222),
    [sym_shift_expression] = STATE(222),
    [sym_math_expression] = STATE(222),
    [sym_cast_expression] = STATE(222),
    [sym_sizeof_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_call_expression] = STATE(222),
    [sym_field_expression] = STATE(222),
    [sym_compound_literal_expression] = STATE(222),
    [sym_parenthesized_expression] = STATE(222),
    [sym_char_literal] = STATE(222),
    [sym_concatenated_string] = STATE(222),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(222),
    [sym_for_range_loop] = STATE(3769),
    [sym_try_statement] = STATE(3769),
    [sym_new_expression] = STATE(222),
    [sym_delete_expression] = STATE(222),
    [sym_lambda_expression] = STATE(222),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(6119),
    [anon_sym_switch] = ACTIONS(6121),
    [anon_sym_case] = ACTIONS(6123),
    [anon_sym_default] = ACTIONS(6125),
    [anon_sym_while] = ACTIONS(6127),
    [anon_sym_do] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(6129),
    [anon_sym_return] = ACTIONS(373),
    [anon_sym_break] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_goto] = ACTIONS(379),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(353),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_identifier] = ACTIONS(6131),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(6133),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(381),
  },
  [3894] = {
    [sym_compound_statement] = STATE(3553),
    [sym_labeled_statement] = STATE(3553),
    [sym_expression_statement] = STATE(3553),
    [sym_if_statement] = STATE(3553),
    [sym_switch_statement] = STATE(3553),
    [sym_case_statement] = STATE(3553),
    [sym_while_statement] = STATE(3553),
    [sym_do_statement] = STATE(3553),
    [sym_for_statement] = STATE(3553),
    [sym_return_statement] = STATE(3553),
    [sym_break_statement] = STATE(3553),
    [sym_continue_statement] = STATE(3553),
    [sym_goto_statement] = STATE(3553),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(3553),
    [sym_try_statement] = STATE(3553),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7177),
    [anon_sym_switch] = ACTIONS(7179),
    [anon_sym_case] = ACTIONS(7181),
    [anon_sym_default] = ACTIONS(7183),
    [anon_sym_while] = ACTIONS(7185),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(7187),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(7189),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7191),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [3895] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8538),
    [sym_comment] = ACTIONS(91),
  },
  [3896] = {
    [sym_compound_statement] = STATE(3785),
    [sym_labeled_statement] = STATE(3785),
    [sym_expression_statement] = STATE(3785),
    [sym_if_statement] = STATE(3785),
    [sym_switch_statement] = STATE(3785),
    [sym_case_statement] = STATE(3785),
    [sym_while_statement] = STATE(3785),
    [sym_do_statement] = STATE(3785),
    [sym_for_statement] = STATE(3785),
    [sym_return_statement] = STATE(3785),
    [sym_break_statement] = STATE(3785),
    [sym_continue_statement] = STATE(3785),
    [sym_goto_statement] = STATE(3785),
    [sym__expression] = STATE(1020),
    [sym_comma_expression] = STATE(1021),
    [sym_conditional_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1020),
    [sym_pointer_expression] = STATE(1020),
    [sym_logical_expression] = STATE(1020),
    [sym_bitwise_expression] = STATE(1020),
    [sym_equality_expression] = STATE(1020),
    [sym_relational_expression] = STATE(1020),
    [sym_shift_expression] = STATE(1020),
    [sym_math_expression] = STATE(1020),
    [sym_cast_expression] = STATE(1020),
    [sym_sizeof_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_field_expression] = STATE(1020),
    [sym_compound_literal_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_char_literal] = STATE(1020),
    [sym_concatenated_string] = STATE(1020),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1020),
    [sym_for_range_loop] = STATE(3785),
    [sym_try_statement] = STATE(3785),
    [sym_new_expression] = STATE(1020),
    [sym_delete_expression] = STATE(1020),
    [sym_lambda_expression] = STATE(1020),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2022),
    [anon_sym_SEMI] = ACTIONS(2036),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7300),
    [anon_sym_switch] = ACTIONS(7302),
    [anon_sym_case] = ACTIONS(7304),
    [anon_sym_default] = ACTIONS(7306),
    [anon_sym_while] = ACTIONS(7308),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(7310),
    [anon_sym_return] = ACTIONS(2058),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2062),
    [anon_sym_goto] = ACTIONS(2064),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(7312),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7314),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2066),
  },
  [3897] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8540),
    [sym_comment] = ACTIONS(91),
  },
  [3898] = {
    [sym_compound_statement] = STATE(3794),
    [sym_labeled_statement] = STATE(3794),
    [sym_expression_statement] = STATE(3794),
    [sym_if_statement] = STATE(3794),
    [sym_switch_statement] = STATE(3794),
    [sym_case_statement] = STATE(3794),
    [sym_while_statement] = STATE(3794),
    [sym_do_statement] = STATE(3794),
    [sym_for_statement] = STATE(3794),
    [sym_return_statement] = STATE(3794),
    [sym_break_statement] = STATE(3794),
    [sym_continue_statement] = STATE(3794),
    [sym_goto_statement] = STATE(3794),
    [sym__expression] = STATE(411),
    [sym_comma_expression] = STATE(412),
    [sym_conditional_expression] = STATE(411),
    [sym_assignment_expression] = STATE(411),
    [sym_pointer_expression] = STATE(411),
    [sym_logical_expression] = STATE(411),
    [sym_bitwise_expression] = STATE(411),
    [sym_equality_expression] = STATE(411),
    [sym_relational_expression] = STATE(411),
    [sym_shift_expression] = STATE(411),
    [sym_math_expression] = STATE(411),
    [sym_cast_expression] = STATE(411),
    [sym_sizeof_expression] = STATE(411),
    [sym_subscript_expression] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_field_expression] = STATE(411),
    [sym_compound_literal_expression] = STATE(411),
    [sym_parenthesized_expression] = STATE(411),
    [sym_char_literal] = STATE(411),
    [sym_concatenated_string] = STATE(411),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(411),
    [sym_for_range_loop] = STATE(3794),
    [sym_try_statement] = STATE(3794),
    [sym_new_expression] = STATE(411),
    [sym_delete_expression] = STATE(411),
    [sym_lambda_expression] = STATE(411),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(678),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(6682),
    [anon_sym_switch] = ACTIONS(6684),
    [anon_sym_case] = ACTIONS(6686),
    [anon_sym_default] = ACTIONS(6688),
    [anon_sym_while] = ACTIONS(6690),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(6692),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_goto] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_identifier] = ACTIONS(6694),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(6696),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(726),
  },
  [3899] = {
    [sym_compound_statement] = STATE(3802),
    [sym_labeled_statement] = STATE(3802),
    [sym_expression_statement] = STATE(3802),
    [sym_if_statement] = STATE(3802),
    [sym_switch_statement] = STATE(3802),
    [sym_case_statement] = STATE(3802),
    [sym_while_statement] = STATE(3802),
    [sym_do_statement] = STATE(3802),
    [sym_for_statement] = STATE(3802),
    [sym_return_statement] = STATE(3802),
    [sym_break_statement] = STATE(3802),
    [sym_continue_statement] = STATE(3802),
    [sym_goto_statement] = STATE(3802),
    [sym__expression] = STATE(1908),
    [sym_comma_expression] = STATE(1909),
    [sym_conditional_expression] = STATE(1908),
    [sym_assignment_expression] = STATE(1908),
    [sym_pointer_expression] = STATE(1908),
    [sym_logical_expression] = STATE(1908),
    [sym_bitwise_expression] = STATE(1908),
    [sym_equality_expression] = STATE(1908),
    [sym_relational_expression] = STATE(1908),
    [sym_shift_expression] = STATE(1908),
    [sym_math_expression] = STATE(1908),
    [sym_cast_expression] = STATE(1908),
    [sym_sizeof_expression] = STATE(1908),
    [sym_subscript_expression] = STATE(1908),
    [sym_call_expression] = STATE(1908),
    [sym_field_expression] = STATE(1908),
    [sym_compound_literal_expression] = STATE(1908),
    [sym_parenthesized_expression] = STATE(1908),
    [sym_char_literal] = STATE(1908),
    [sym_concatenated_string] = STATE(1908),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1908),
    [sym_for_range_loop] = STATE(3802),
    [sym_try_statement] = STATE(3802),
    [sym_new_expression] = STATE(1908),
    [sym_delete_expression] = STATE(1908),
    [sym_lambda_expression] = STATE(1908),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3996),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7766),
    [anon_sym_switch] = ACTIONS(7768),
    [anon_sym_case] = ACTIONS(7770),
    [anon_sym_default] = ACTIONS(7772),
    [anon_sym_while] = ACTIONS(7774),
    [anon_sym_do] = ACTIONS(4026),
    [anon_sym_for] = ACTIONS(7776),
    [anon_sym_return] = ACTIONS(4030),
    [anon_sym_break] = ACTIONS(4032),
    [anon_sym_continue] = ACTIONS(4034),
    [anon_sym_goto] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(3996),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4038),
    [sym_false] = ACTIONS(4038),
    [sym_null] = ACTIONS(4038),
    [sym_identifier] = ACTIONS(7778),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7780),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(4038),
  },
  [3900] = {
    [sym_compound_statement] = STATE(3803),
    [sym_labeled_statement] = STATE(3803),
    [sym_expression_statement] = STATE(3803),
    [sym_if_statement] = STATE(3803),
    [sym_switch_statement] = STATE(3803),
    [sym_case_statement] = STATE(3803),
    [sym_while_statement] = STATE(3803),
    [sym_do_statement] = STATE(3803),
    [sym_for_statement] = STATE(3803),
    [sym_return_statement] = STATE(3803),
    [sym_break_statement] = STATE(3803),
    [sym_continue_statement] = STATE(3803),
    [sym_goto_statement] = STATE(3803),
    [sym__expression] = STATE(1908),
    [sym_comma_expression] = STATE(1909),
    [sym_conditional_expression] = STATE(1908),
    [sym_assignment_expression] = STATE(1908),
    [sym_pointer_expression] = STATE(1908),
    [sym_logical_expression] = STATE(1908),
    [sym_bitwise_expression] = STATE(1908),
    [sym_equality_expression] = STATE(1908),
    [sym_relational_expression] = STATE(1908),
    [sym_shift_expression] = STATE(1908),
    [sym_math_expression] = STATE(1908),
    [sym_cast_expression] = STATE(1908),
    [sym_sizeof_expression] = STATE(1908),
    [sym_subscript_expression] = STATE(1908),
    [sym_call_expression] = STATE(1908),
    [sym_field_expression] = STATE(1908),
    [sym_compound_literal_expression] = STATE(1908),
    [sym_parenthesized_expression] = STATE(1908),
    [sym_char_literal] = STATE(1908),
    [sym_concatenated_string] = STATE(1908),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1908),
    [sym_for_range_loop] = STATE(3803),
    [sym_try_statement] = STATE(3803),
    [sym_new_expression] = STATE(1908),
    [sym_delete_expression] = STATE(1908),
    [sym_lambda_expression] = STATE(1908),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3996),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7766),
    [anon_sym_switch] = ACTIONS(7768),
    [anon_sym_case] = ACTIONS(7770),
    [anon_sym_default] = ACTIONS(7772),
    [anon_sym_while] = ACTIONS(7774),
    [anon_sym_do] = ACTIONS(4026),
    [anon_sym_for] = ACTIONS(7776),
    [anon_sym_return] = ACTIONS(4030),
    [anon_sym_break] = ACTIONS(4032),
    [anon_sym_continue] = ACTIONS(4034),
    [anon_sym_goto] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(3996),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4038),
    [sym_false] = ACTIONS(4038),
    [sym_null] = ACTIONS(4038),
    [sym_identifier] = ACTIONS(7778),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7780),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(4038),
  },
  [3901] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8542),
    [sym_comment] = ACTIONS(91),
  },
  [3902] = {
    [sym_argument_list] = STATE(349),
    [aux_sym_for_statement_repeat1] = STATE(3908),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8542),
    [anon_sym_LPAREN2] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(622),
    [sym_comment] = ACTIONS(91),
  },
  [3903] = {
    [sym_compound_statement] = STATE(3813),
    [sym_labeled_statement] = STATE(3813),
    [sym_expression_statement] = STATE(3813),
    [sym_if_statement] = STATE(3813),
    [sym_switch_statement] = STATE(3813),
    [sym_case_statement] = STATE(3813),
    [sym_while_statement] = STATE(3813),
    [sym_do_statement] = STATE(3813),
    [sym_for_statement] = STATE(3813),
    [sym_return_statement] = STATE(3813),
    [sym_break_statement] = STATE(3813),
    [sym_continue_statement] = STATE(3813),
    [sym_goto_statement] = STATE(3813),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(3813),
    [sym_try_statement] = STATE(3813),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7431),
    [anon_sym_switch] = ACTIONS(7433),
    [anon_sym_case] = ACTIONS(7435),
    [anon_sym_default] = ACTIONS(7437),
    [anon_sym_while] = ACTIONS(7439),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(7441),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(7443),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7445),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2242),
  },
  [3904] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8544),
    [sym_comment] = ACTIONS(91),
  },
  [3905] = {
    [sym_compound_statement] = STATE(3681),
    [sym_labeled_statement] = STATE(3681),
    [sym_expression_statement] = STATE(3681),
    [sym_if_statement] = STATE(3681),
    [sym_switch_statement] = STATE(3681),
    [sym_case_statement] = STATE(3681),
    [sym_while_statement] = STATE(3681),
    [sym_do_statement] = STATE(3681),
    [sym_for_statement] = STATE(3681),
    [sym_return_statement] = STATE(3681),
    [sym_break_statement] = STATE(3681),
    [sym_continue_statement] = STATE(3681),
    [sym_goto_statement] = STATE(3681),
    [sym__expression] = STATE(53),
    [sym_comma_expression] = STATE(54),
    [sym_conditional_expression] = STATE(53),
    [sym_assignment_expression] = STATE(53),
    [sym_pointer_expression] = STATE(53),
    [sym_logical_expression] = STATE(53),
    [sym_bitwise_expression] = STATE(53),
    [sym_equality_expression] = STATE(53),
    [sym_relational_expression] = STATE(53),
    [sym_shift_expression] = STATE(53),
    [sym_math_expression] = STATE(53),
    [sym_cast_expression] = STATE(53),
    [sym_sizeof_expression] = STATE(53),
    [sym_subscript_expression] = STATE(53),
    [sym_call_expression] = STATE(53),
    [sym_field_expression] = STATE(53),
    [sym_compound_literal_expression] = STATE(53),
    [sym_parenthesized_expression] = STATE(53),
    [sym_char_literal] = STATE(53),
    [sym_concatenated_string] = STATE(53),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(53),
    [sym_for_range_loop] = STATE(3681),
    [sym_try_statement] = STATE(3681),
    [sym_new_expression] = STATE(53),
    [sym_delete_expression] = STATE(53),
    [sym_lambda_expression] = STATE(53),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7177),
    [anon_sym_switch] = ACTIONS(7179),
    [anon_sym_case] = ACTIONS(7181),
    [anon_sym_default] = ACTIONS(7183),
    [anon_sym_while] = ACTIONS(7185),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(7187),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(63),
    [anon_sym_continue] = ACTIONS(65),
    [anon_sym_goto] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_identifier] = ACTIONS(7189),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7191),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(87),
  },
  [3906] = {
    [sym_compound_statement] = STATE(3843),
    [sym_labeled_statement] = STATE(3843),
    [sym_expression_statement] = STATE(3843),
    [sym_if_statement] = STATE(3843),
    [sym_switch_statement] = STATE(3843),
    [sym_case_statement] = STATE(3843),
    [sym_while_statement] = STATE(3843),
    [sym_do_statement] = STATE(3843),
    [sym_for_statement] = STATE(3843),
    [sym_return_statement] = STATE(3843),
    [sym_break_statement] = STATE(3843),
    [sym_continue_statement] = STATE(3843),
    [sym_goto_statement] = STATE(3843),
    [sym__expression] = STATE(1020),
    [sym_comma_expression] = STATE(1021),
    [sym_conditional_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1020),
    [sym_pointer_expression] = STATE(1020),
    [sym_logical_expression] = STATE(1020),
    [sym_bitwise_expression] = STATE(1020),
    [sym_equality_expression] = STATE(1020),
    [sym_relational_expression] = STATE(1020),
    [sym_shift_expression] = STATE(1020),
    [sym_math_expression] = STATE(1020),
    [sym_cast_expression] = STATE(1020),
    [sym_sizeof_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_field_expression] = STATE(1020),
    [sym_compound_literal_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_char_literal] = STATE(1020),
    [sym_concatenated_string] = STATE(1020),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1020),
    [sym_for_range_loop] = STATE(3843),
    [sym_try_statement] = STATE(3843),
    [sym_new_expression] = STATE(1020),
    [sym_delete_expression] = STATE(1020),
    [sym_lambda_expression] = STATE(1020),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2022),
    [anon_sym_SEMI] = ACTIONS(2036),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7300),
    [anon_sym_switch] = ACTIONS(7302),
    [anon_sym_case] = ACTIONS(7304),
    [anon_sym_default] = ACTIONS(7306),
    [anon_sym_while] = ACTIONS(7308),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(7310),
    [anon_sym_return] = ACTIONS(2058),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2062),
    [anon_sym_goto] = ACTIONS(2064),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(7312),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7314),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2066),
  },
  [3907] = {
    [sym_compound_statement] = STATE(3855),
    [sym_labeled_statement] = STATE(3855),
    [sym_expression_statement] = STATE(3855),
    [sym_if_statement] = STATE(3855),
    [sym_switch_statement] = STATE(3855),
    [sym_case_statement] = STATE(3855),
    [sym_while_statement] = STATE(3855),
    [sym_do_statement] = STATE(3855),
    [sym_for_statement] = STATE(3855),
    [sym_return_statement] = STATE(3855),
    [sym_break_statement] = STATE(3855),
    [sym_continue_statement] = STATE(3855),
    [sym_goto_statement] = STATE(3855),
    [sym__expression] = STATE(1908),
    [sym_comma_expression] = STATE(1909),
    [sym_conditional_expression] = STATE(1908),
    [sym_assignment_expression] = STATE(1908),
    [sym_pointer_expression] = STATE(1908),
    [sym_logical_expression] = STATE(1908),
    [sym_bitwise_expression] = STATE(1908),
    [sym_equality_expression] = STATE(1908),
    [sym_relational_expression] = STATE(1908),
    [sym_shift_expression] = STATE(1908),
    [sym_math_expression] = STATE(1908),
    [sym_cast_expression] = STATE(1908),
    [sym_sizeof_expression] = STATE(1908),
    [sym_subscript_expression] = STATE(1908),
    [sym_call_expression] = STATE(1908),
    [sym_field_expression] = STATE(1908),
    [sym_compound_literal_expression] = STATE(1908),
    [sym_parenthesized_expression] = STATE(1908),
    [sym_char_literal] = STATE(1908),
    [sym_concatenated_string] = STATE(1908),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1908),
    [sym_for_range_loop] = STATE(3855),
    [sym_try_statement] = STATE(3855),
    [sym_new_expression] = STATE(1908),
    [sym_delete_expression] = STATE(1908),
    [sym_lambda_expression] = STATE(1908),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3996),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7766),
    [anon_sym_switch] = ACTIONS(7768),
    [anon_sym_case] = ACTIONS(7770),
    [anon_sym_default] = ACTIONS(7772),
    [anon_sym_while] = ACTIONS(7774),
    [anon_sym_do] = ACTIONS(4026),
    [anon_sym_for] = ACTIONS(7776),
    [anon_sym_return] = ACTIONS(4030),
    [anon_sym_break] = ACTIONS(4032),
    [anon_sym_continue] = ACTIONS(4034),
    [anon_sym_goto] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(3996),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4038),
    [sym_false] = ACTIONS(4038),
    [sym_null] = ACTIONS(4038),
    [sym_identifier] = ACTIONS(7778),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7780),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(4038),
  },
  [3908] = {
    [aux_sym_for_statement_repeat1] = STATE(3137),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(8546),
    [sym_comment] = ACTIONS(91),
  },
  [3909] = {
    [sym_compound_statement] = STATE(3864),
    [sym_labeled_statement] = STATE(3864),
    [sym_expression_statement] = STATE(3864),
    [sym_if_statement] = STATE(3864),
    [sym_switch_statement] = STATE(3864),
    [sym_case_statement] = STATE(3864),
    [sym_while_statement] = STATE(3864),
    [sym_do_statement] = STATE(3864),
    [sym_for_statement] = STATE(3864),
    [sym_return_statement] = STATE(3864),
    [sym_break_statement] = STATE(3864),
    [sym_continue_statement] = STATE(3864),
    [sym_goto_statement] = STATE(3864),
    [sym__expression] = STATE(1139),
    [sym_comma_expression] = STATE(1140),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1139),
    [sym_for_range_loop] = STATE(3864),
    [sym_try_statement] = STATE(3864),
    [sym_new_expression] = STATE(1139),
    [sym_delete_expression] = STATE(1139),
    [sym_lambda_expression] = STATE(1139),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7431),
    [anon_sym_switch] = ACTIONS(7433),
    [anon_sym_case] = ACTIONS(7435),
    [anon_sym_default] = ACTIONS(7437),
    [anon_sym_while] = ACTIONS(7439),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(7441),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(7443),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7445),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(2242),
  },
  [3910] = {
    [sym_compound_statement] = STATE(3887),
    [sym_labeled_statement] = STATE(3887),
    [sym_expression_statement] = STATE(3887),
    [sym_if_statement] = STATE(3887),
    [sym_switch_statement] = STATE(3887),
    [sym_case_statement] = STATE(3887),
    [sym_while_statement] = STATE(3887),
    [sym_do_statement] = STATE(3887),
    [sym_for_statement] = STATE(3887),
    [sym_return_statement] = STATE(3887),
    [sym_break_statement] = STATE(3887),
    [sym_continue_statement] = STATE(3887),
    [sym_goto_statement] = STATE(3887),
    [sym__expression] = STATE(1908),
    [sym_comma_expression] = STATE(1909),
    [sym_conditional_expression] = STATE(1908),
    [sym_assignment_expression] = STATE(1908),
    [sym_pointer_expression] = STATE(1908),
    [sym_logical_expression] = STATE(1908),
    [sym_bitwise_expression] = STATE(1908),
    [sym_equality_expression] = STATE(1908),
    [sym_relational_expression] = STATE(1908),
    [sym_shift_expression] = STATE(1908),
    [sym_math_expression] = STATE(1908),
    [sym_cast_expression] = STATE(1908),
    [sym_sizeof_expression] = STATE(1908),
    [sym_subscript_expression] = STATE(1908),
    [sym_call_expression] = STATE(1908),
    [sym_field_expression] = STATE(1908),
    [sym_compound_literal_expression] = STATE(1908),
    [sym_parenthesized_expression] = STATE(1908),
    [sym_char_literal] = STATE(1908),
    [sym_concatenated_string] = STATE(1908),
    [sym_string_literal] = STATE(55),
    [sym_template_type] = STATE(147),
    [sym_template_function] = STATE(1908),
    [sym_for_range_loop] = STATE(3887),
    [sym_try_statement] = STATE(3887),
    [sym_new_expression] = STATE(1908),
    [sym_delete_expression] = STATE(1908),
    [sym_lambda_expression] = STATE(1908),
    [sym_lambda_capture_specifier] = STATE(58),
    [sym_scoped_identifier] = STATE(116),
    [sym_scoped_type_identifier] = STATE(148),
    [sym_scoped_namespace_identifier] = STATE(149),
    [sym_raw_string_literal] = ACTIONS(3996),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(7766),
    [anon_sym_switch] = ACTIONS(7768),
    [anon_sym_case] = ACTIONS(7770),
    [anon_sym_default] = ACTIONS(7772),
    [anon_sym_while] = ACTIONS(7774),
    [anon_sym_do] = ACTIONS(4026),
    [anon_sym_for] = ACTIONS(7776),
    [anon_sym_return] = ACTIONS(4030),
    [anon_sym_break] = ACTIONS(4032),
    [anon_sym_continue] = ACTIONS(4034),
    [anon_sym_goto] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [sym_number_literal] = ACTIONS(3996),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [sym_true] = ACTIONS(4038),
    [sym_false] = ACTIONS(4038),
    [sym_null] = ACTIONS(4038),
    [sym_identifier] = ACTIONS(7778),
    [sym_comment] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(7780),
    [anon_sym_new] = ACTIONS(107),
    [anon_sym_COLON_COLON] = ACTIONS(263),
    [sym_nullptr] = ACTIONS(4038),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = true}, RECOVER(),
  [3] = {.count = 1, .reusable = false}, RECOVER(),
  [5] = {.count = 1, .reusable = true}, SHIFT(53),
  [7] = {.count = 1, .reusable = true}, REDUCE(sym_translation_unit, 0),
  [9] = {.count = 1, .reusable = false}, SHIFT(2),
  [11] = {.count = 1, .reusable = false}, SHIFT(3),
  [13] = {.count = 1, .reusable = false}, SHIFT(4),
  [15] = {.count = 1, .reusable = false}, SHIFT(5),
  [17] = {.count = 1, .reusable = false}, SHIFT(6),
  [19] = {.count = 1, .reusable = true}, SHIFT(7),
  [21] = {.count = 1, .reusable = false}, SHIFT(8),
  [23] = {.count = 1, .reusable = false}, SHIFT(9),
  [25] = {.count = 1, .reusable = true}, SHIFT(10),
  [27] = {.count = 1, .reusable = true}, SHIFT(11),
  [29] = {.count = 1, .reusable = true}, SHIFT(12),
  [31] = {.count = 1, .reusable = true}, SHIFT(13),
  [33] = {.count = 1, .reusable = false}, SHIFT(14),
  [35] = {.count = 1, .reusable = false}, SHIFT(15),
  [37] = {.count = 1, .reusable = false}, SHIFT(64),
  [39] = {.count = 1, .reusable = false}, SHIFT(52),
  [41] = {.count = 1, .reusable = false}, SHIFT(16),
  [43] = {.count = 1, .reusable = false}, SHIFT(17),
  [45] = {.count = 1, .reusable = false}, SHIFT(18),
  [47] = {.count = 1, .reusable = false}, SHIFT(19),
  [49] = {.count = 1, .reusable = false}, SHIFT(20),
  [51] = {.count = 1, .reusable = false}, SHIFT(21),
  [53] = {.count = 1, .reusable = false}, SHIFT(22),
  [55] = {.count = 1, .reusable = false}, SHIFT(23),
  [57] = {.count = 1, .reusable = false}, SHIFT(24),
  [59] = {.count = 1, .reusable = false}, SHIFT(25),
  [61] = {.count = 1, .reusable = false}, SHIFT(26),
  [63] = {.count = 1, .reusable = false}, SHIFT(27),
  [65] = {.count = 1, .reusable = false}, SHIFT(28),
  [67] = {.count = 1, .reusable = false}, SHIFT(29),
  [69] = {.count = 1, .reusable = false}, SHIFT(30),
  [71] = {.count = 1, .reusable = true}, SHIFT(31),
  [73] = {.count = 1, .reusable = true}, SHIFT(32),
  [75] = {.count = 1, .reusable = true}, SHIFT(33),
  [77] = {.count = 1, .reusable = false}, SHIFT(34),
  [79] = {.count = 1, .reusable = true}, SHIFT(34),
  [81] = {.count = 1, .reusable = false}, SHIFT(35),
  [83] = {.count = 1, .reusable = true}, SHIFT(36),
  [85] = {.count = 1, .reusable = true}, SHIFT(37),
  [87] = {.count = 1, .reusable = false}, SHIFT(53),
  [89] = {.count = 1, .reusable = false}, SHIFT(38),
  [91] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [93] = {.count = 1, .reusable = false}, SHIFT(39),
  [95] = {.count = 1, .reusable = false}, SHIFT(40),
  [97] = {.count = 1, .reusable = false}, SHIFT(41),
  [99] = {.count = 1, .reusable = false}, SHIFT(42),
  [101] = {.count = 1, .reusable = false}, SHIFT(43),
  [103] = {.count = 1, .reusable = false}, SHIFT(44),
  [105] = {.count = 1, .reusable = false}, SHIFT(45),
  [107] = {.count = 1, .reusable = false}, SHIFT(46),
  [109] = {.count = 1, .reusable = true}, SHIFT(47),
  [111] = {.count = 1, .reusable = true}, SHIFT(50),
  [113] = {.count = 1, .reusable = true}, SHIFT(65),
  [115] = {.count = 1, .reusable = true}, SHIFT(66),
  [117] = {.count = 1, .reusable = true}, SHIFT(67),
  [119] = {.count = 1, .reusable = false}, SHIFT(68),
  [121] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [123] = {.count = 1, .reusable = true}, SHIFT(69),
  [125] = {.count = 1, .reusable = false}, SHIFT(70),
  [127] = {.count = 1, .reusable = false}, SHIFT(71),
  [129] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 1),
  [131] = {.count = 1, .reusable = false}, REDUCE(sym_expression_statement, 1),
  [133] = {.count = 1, .reusable = false}, SHIFT(72),
  [135] = {.count = 1, .reusable = false}, SHIFT(85),
  [137] = {.count = 1, .reusable = false}, SHIFT(80),
  [139] = {.count = 1, .reusable = false}, SHIFT(73),
  [141] = {.count = 1, .reusable = false}, SHIFT(74),
  [143] = {.count = 1, .reusable = false}, SHIFT(75),
  [145] = {.count = 1, .reusable = false}, SHIFT(76),
  [147] = {.count = 1, .reusable = false}, SHIFT(77),
  [149] = {.count = 1, .reusable = false}, SHIFT(78),
  [151] = {.count = 1, .reusable = true}, SHIFT(79),
  [153] = {.count = 1, .reusable = false}, REDUCE(sym_storage_class_specifier, 1),
  [155] = {.count = 1, .reusable = true}, REDUCE(sym_storage_class_specifier, 1),
  [157] = {.count = 1, .reusable = true}, SHIFT(114),
  [159] = {.count = 1, .reusable = false}, SHIFT(87),
  [161] = {.count = 1, .reusable = false}, SHIFT(88),
  [163] = {.count = 1, .reusable = false}, SHIFT(89),
  [165] = {.count = 1, .reusable = false}, SHIFT(90),
  [167] = {.count = 1, .reusable = false}, SHIFT(91),
  [169] = {.count = 1, .reusable = true}, SHIFT(92),
  [171] = {.count = 1, .reusable = false}, SHIFT(93),
  [173] = {.count = 1, .reusable = false}, SHIFT(94),
  [175] = {.count = 1, .reusable = true}, SHIFT(95),
  [177] = {.count = 1, .reusable = true}, SHIFT(96),
  [179] = {.count = 1, .reusable = true}, SHIFT(97),
  [181] = {.count = 1, .reusable = true}, SHIFT(98),
  [183] = {.count = 1, .reusable = false}, SHIFT(99),
  [185] = {.count = 1, .reusable = false}, SHIFT(100),
  [187] = {.count = 1, .reusable = false}, SHIFT(101),
  [189] = {.count = 1, .reusable = false}, SHIFT(102),
  [191] = {.count = 1, .reusable = false}, SHIFT(103),
  [193] = {.count = 1, .reusable = false}, SHIFT(104),
  [195] = {.count = 1, .reusable = false}, SHIFT(105),
  [197] = {.count = 1, .reusable = false}, SHIFT(106),
  [199] = {.count = 1, .reusable = false}, SHIFT(107),
  [201] = {.count = 1, .reusable = false}, SHIFT(108),
  [203] = {.count = 1, .reusable = false}, SHIFT(109),
  [205] = {.count = 1, .reusable = true}, SHIFT(110),
  [207] = {.count = 1, .reusable = false}, SHIFT(114),
  [209] = {.count = 1, .reusable = false}, SHIFT(111),
  [211] = {.count = 1, .reusable = false}, SHIFT(112),
  [213] = {.count = 1, .reusable = true}, SHIFT(137),
  [215] = {.count = 1, .reusable = true}, SHIFT(119),
  [217] = {.count = 1, .reusable = true}, SHIFT(120),
  [219] = {.count = 1, .reusable = false}, SHIFT(142),
  [221] = {.count = 1, .reusable = false}, SHIFT(136),
  [223] = {.count = 1, .reusable = false}, SHIFT(121),
  [225] = {.count = 1, .reusable = false}, SHIFT(122),
  [227] = {.count = 1, .reusable = false}, SHIFT(123),
  [229] = {.count = 1, .reusable = true}, SHIFT(124),
  [231] = {.count = 1, .reusable = true}, SHIFT(125),
  [233] = {.count = 1, .reusable = true}, SHIFT(126),
  [235] = {.count = 1, .reusable = false}, SHIFT(127),
  [237] = {.count = 1, .reusable = true}, SHIFT(127),
  [239] = {.count = 1, .reusable = false}, SHIFT(128),
  [241] = {.count = 1, .reusable = false}, SHIFT(137),
  [243] = {.count = 1, .reusable = false}, SHIFT(129),
  [245] = {.count = 1, .reusable = false}, SHIFT(130),
  [247] = {.count = 1, .reusable = false}, SHIFT(131),
  [249] = {.count = 1, .reusable = false}, SHIFT(132),
  [251] = {.count = 1, .reusable = false}, SHIFT(133),
  [253] = {.count = 1, .reusable = true}, SHIFT(134),
  [255] = {.count = 1, .reusable = true}, SHIFT(135),
  [257] = {.count = 1, .reusable = true}, SHIFT(146),
  [259] = {.count = 1, .reusable = false}, SHIFT(146),
  [261] = {.count = 1, .reusable = false}, SHIFT(143),
  [263] = {.count = 1, .reusable = true}, SHIFT(144),
  [265] = {.count = 1, .reusable = true}, SHIFT(145),
  [267] = {.count = 1, .reusable = true}, SHIFT(164),
  [269] = {.count = 1, .reusable = true}, SHIFT(151),
  [271] = {.count = 1, .reusable = true}, SHIFT(152),
  [273] = {.count = 1, .reusable = true}, SHIFT(153),
  [275] = {.count = 1, .reusable = true}, SHIFT(154),
  [277] = {.count = 1, .reusable = true}, SHIFT(155),
  [279] = {.count = 1, .reusable = true}, SHIFT(156),
  [281] = {.count = 1, .reusable = true}, SHIFT(157),
  [283] = {.count = 1, .reusable = false}, SHIFT(158),
  [285] = {.count = 1, .reusable = true}, SHIFT(158),
  [287] = {.count = 1, .reusable = false}, SHIFT(159),
  [289] = {.count = 1, .reusable = false}, SHIFT(164),
  [291] = {.count = 1, .reusable = false}, SHIFT(160),
  [293] = {.count = 1, .reusable = false}, SHIFT(161),
  [295] = {.count = 1, .reusable = false}, SHIFT(162),
  [297] = {.count = 1, .reusable = true}, SHIFT(163),
  [299] = {.count = 1, .reusable = true}, REDUCE(sym_type_qualifier, 1),
  [301] = {.count = 1, .reusable = false}, REDUCE(sym_type_qualifier, 1),
  [303] = {.count = 1, .reusable = true}, SHIFT(167),
  [305] = {.count = 1, .reusable = true}, SHIFT(168),
  [307] = {.count = 1, .reusable = true}, SHIFT(170),
  [309] = {.count = 1, .reusable = false}, SHIFT(171),
  [311] = {.count = 1, .reusable = false}, SHIFT(172),
  [313] = {.count = 1, .reusable = false}, SHIFT(173),
  [315] = {.count = 1, .reusable = true}, SHIFT(174),
  [317] = {.count = 1, .reusable = false}, SHIFT(181),
  [319] = {.count = 1, .reusable = true}, SHIFT(187),
  [321] = {.count = 1, .reusable = true}, SHIFT(188),
  [323] = {.count = 1, .reusable = true}, SHIFT(189),
  [325] = {.count = 1, .reusable = true}, SHIFT(201),
  [327] = {.count = 1, .reusable = true}, SHIFT(191),
  [329] = {.count = 1, .reusable = true}, SHIFT(192),
  [331] = {.count = 1, .reusable = true}, SHIFT(193),
  [333] = {.count = 1, .reusable = true}, SHIFT(194),
  [335] = {.count = 1, .reusable = false}, SHIFT(195),
  [337] = {.count = 1, .reusable = true}, SHIFT(195),
  [339] = {.count = 1, .reusable = false}, SHIFT(196),
  [341] = {.count = 1, .reusable = true}, SHIFT(197),
  [343] = {.count = 1, .reusable = false}, SHIFT(201),
  [345] = {.count = 1, .reusable = false}, SHIFT(198),
  [347] = {.count = 1, .reusable = false}, SHIFT(199),
  [349] = {.count = 1, .reusable = true}, SHIFT(200),
  [351] = {.count = 1, .reusable = true}, SHIFT(204),
  [353] = {.count = 1, .reusable = true}, SHIFT(222),
  [355] = {.count = 1, .reusable = true}, SHIFT(206),
  [357] = {.count = 1, .reusable = true}, SHIFT(207),
  [359] = {.count = 1, .reusable = false}, SHIFT(208),
  [361] = {.count = 1, .reusable = false}, SHIFT(209),
  [363] = {.count = 1, .reusable = false}, SHIFT(210),
  [365] = {.count = 1, .reusable = false}, SHIFT(211),
  [367] = {.count = 1, .reusable = false}, SHIFT(212),
  [369] = {.count = 1, .reusable = false}, SHIFT(213),
  [371] = {.count = 1, .reusable = false}, SHIFT(214),
  [373] = {.count = 1, .reusable = false}, SHIFT(215),
  [375] = {.count = 1, .reusable = false}, SHIFT(216),
  [377] = {.count = 1, .reusable = false}, SHIFT(217),
  [379] = {.count = 1, .reusable = false}, SHIFT(218),
  [381] = {.count = 1, .reusable = false}, SHIFT(222),
  [383] = {.count = 1, .reusable = false}, SHIFT(219),
  [385] = {.count = 1, .reusable = false}, SHIFT(220),
  [387] = {.count = 1, .reusable = true}, SHIFT(224),
  [389] = {.count = 1, .reusable = true}, SHIFT(236),
  [391] = {.count = 1, .reusable = true}, SHIFT(225),
  [393] = {.count = 1, .reusable = true}, SHIFT(226),
  [395] = {.count = 1, .reusable = true}, SHIFT(227),
  [397] = {.count = 1, .reusable = true}, SHIFT(228),
  [399] = {.count = 1, .reusable = true}, SHIFT(229),
  [401] = {.count = 1, .reusable = true}, SHIFT(230),
  [403] = {.count = 1, .reusable = false}, SHIFT(231),
  [405] = {.count = 1, .reusable = true}, SHIFT(231),
  [407] = {.count = 1, .reusable = false}, SHIFT(232),
  [409] = {.count = 1, .reusable = false}, SHIFT(236),
  [411] = {.count = 1, .reusable = false}, SHIFT(233),
  [413] = {.count = 1, .reusable = false}, SHIFT(234),
  [415] = {.count = 1, .reusable = true}, SHIFT(235),
  [417] = {.count = 1, .reusable = true}, SHIFT(239),
  [419] = {.count = 1, .reusable = true}, SHIFT(240),
  [421] = {.count = 1, .reusable = true}, SHIFT(241),
  [423] = {.count = 1, .reusable = true}, SHIFT(242),
  [425] = {.count = 1, .reusable = true}, SHIFT(243),
  [427] = {.count = 1, .reusable = false}, SHIFT(31),
  [429] = {.count = 1, .reusable = true}, SHIFT(244),
  [431] = {.count = 1, .reusable = false}, SHIFT(245),
  [433] = {.count = 1, .reusable = true}, SHIFT(246),
  [435] = {.count = 1, .reusable = true}, SHIFT(250),
  [437] = {.count = 1, .reusable = false}, SHIFT(250),
  [439] = {.count = 1, .reusable = true}, SHIFT(252),
  [441] = {.count = 1, .reusable = false}, SHIFT(252),
  [443] = {.count = 1, .reusable = false}, SHIFT(251),
  [445] = {.count = 1, .reusable = true}, SHIFT(253),
  [447] = {.count = 1, .reusable = false}, SHIFT(253),
  [449] = {.count = 1, .reusable = true}, SHIFT(255),
  [451] = {.count = 1, .reusable = true}, SHIFT(254),
  [453] = {.count = 1, .reusable = false}, SHIFT(255),
  [455] = {.count = 1, .reusable = false}, SHIFT(256),
  [457] = {.count = 1, .reusable = true}, SHIFT(256),
  [459] = {.count = 1, .reusable = false}, SHIFT(257),
  [461] = {.count = 1, .reusable = true}, SHIFT(258),
  [463] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1),
  [465] = {.count = 2, .reusable = true}, REDUCE(sym__type_specifier, 1, .alias_sequence_id = 1), REDUCE(sym__expression, 1),
  [468] = {.count = 1, .reusable = false}, REDUCE(sym__type_specifier, 1, .alias_sequence_id = 1),
  [470] = {.count = 3, .reusable = true}, REDUCE(sym__declarator, 1), REDUCE(sym__type_specifier, 1, .alias_sequence_id = 1), REDUCE(sym__expression, 1),
  [474] = {.count = 2, .reusable = false}, REDUCE(sym__type_specifier, 1, .alias_sequence_id = 1), REDUCE(sym__expression, 1),
  [477] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1),
  [479] = {.count = 1, .reusable = false}, SHIFT(259),
  [481] = {.count = 1, .reusable = true}, REDUCE(sym__type_specifier, 1, .alias_sequence_id = 1),
  [483] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(260),
  [486] = {.count = 1, .reusable = true}, SHIFT(261),
  [488] = {.count = 1, .reusable = false}, SHIFT(264),
  [490] = {.count = 1, .reusable = false}, SHIFT(271),
  [492] = {.count = 1, .reusable = false}, SHIFT(270),
  [494] = {.count = 1, .reusable = true}, SHIFT(274),
  [496] = {.count = 1, .reusable = false}, SHIFT(287),
  [498] = {.count = 1, .reusable = false}, SHIFT(282),
  [500] = {.count = 1, .reusable = false}, SHIFT(275),
  [502] = {.count = 1, .reusable = true}, SHIFT(275),
  [504] = {.count = 1, .reusable = true}, SHIFT(276),
  [506] = {.count = 1, .reusable = false}, SHIFT(277),
  [508] = {.count = 1, .reusable = false}, SHIFT(278),
  [510] = {.count = 1, .reusable = true}, SHIFT(279),
  [512] = {.count = 1, .reusable = true}, SHIFT(281),
  [514] = {.count = 1, .reusable = true}, SHIFT(289),
  [516] = {.count = 1, .reusable = true}, SHIFT(288),
  [518] = {.count = 1, .reusable = false}, SHIFT(289),
  [520] = {.count = 1, .reusable = true}, SHIFT(290),
  [522] = {.count = 1, .reusable = true}, SHIFT(291),
  [524] = {.count = 1, .reusable = false}, SHIFT(293),
  [526] = {.count = 1, .reusable = false}, SHIFT(294),
  [528] = {.count = 1, .reusable = true}, SHIFT(295),
  [530] = {.count = 1, .reusable = true}, SHIFT(299),
  [532] = {.count = 1, .reusable = false}, SHIFT(312),
  [534] = {.count = 1, .reusable = false}, SHIFT(307),
  [536] = {.count = 1, .reusable = false}, SHIFT(300),
  [538] = {.count = 1, .reusable = false}, SHIFT(301),
  [540] = {.count = 1, .reusable = false}, SHIFT(302),
  [542] = {.count = 1, .reusable = false}, SHIFT(303),
  [544] = {.count = 1, .reusable = false}, SHIFT(304),
  [546] = {.count = 1, .reusable = false}, SHIFT(305),
  [548] = {.count = 1, .reusable = true}, SHIFT(306),
  [550] = {.count = 1, .reusable = false}, SHIFT(313),
  [552] = {.count = 1, .reusable = false}, SHIFT(314),
  [554] = {.count = 1, .reusable = true}, SHIFT(315),
  [556] = {.count = 1, .reusable = true}, ACCEPT_INPUT(),
  [558] = {.count = 1, .reusable = true}, SHIFT(316),
  [560] = {.count = 1, .reusable = true}, SHIFT(317),
  [562] = {.count = 1, .reusable = true}, SHIFT(318),
  [564] = {.count = 1, .reusable = false}, SHIFT(319),
  [566] = {.count = 1, .reusable = true}, SHIFT(319),
  [568] = {.count = 1, .reusable = false}, SHIFT(320),
  [570] = {.count = 1, .reusable = true}, SHIFT(321),
  [572] = {.count = 1, .reusable = true}, SHIFT(324),
  [574] = {.count = 1, .reusable = true}, SHIFT(325),
  [576] = {.count = 1, .reusable = true}, REDUCE(sym__declarator, 1),
  [578] = {.count = 1, .reusable = true}, SHIFT(327),
  [580] = {.count = 1, .reusable = true}, SHIFT(328),
  [582] = {.count = 1, .reusable = true}, REDUCE(sym__declaration_specifiers, 1),
  [584] = {.count = 1, .reusable = false}, REDUCE(sym__declaration_specifiers, 1),
  [586] = {.count = 1, .reusable = true}, SHIFT(332),
  [588] = {.count = 1, .reusable = true}, SHIFT(333),
  [590] = {.count = 1, .reusable = false}, SHIFT(334),
  [592] = {.count = 1, .reusable = true}, SHIFT(335),
  [594] = {.count = 1, .reusable = false}, SHIFT(336),
  [596] = {.count = 1, .reusable = true}, SHIFT(337),
  [598] = {.count = 1, .reusable = true}, SHIFT(336),
  [600] = {.count = 1, .reusable = false}, SHIFT(338),
  [602] = {.count = 1, .reusable = true}, SHIFT(339),
  [604] = {.count = 1, .reusable = true}, SHIFT(340),
  [606] = {.count = 1, .reusable = false}, SHIFT(341),
  [608] = {.count = 1, .reusable = false}, SHIFT(342),
  [610] = {.count = 1, .reusable = true}, SHIFT(343),
  [612] = {.count = 1, .reusable = false}, SHIFT(344),
  [614] = {.count = 1, .reusable = true}, SHIFT(344),
  [616] = {.count = 1, .reusable = false}, SHIFT(345),
  [618] = {.count = 1, .reusable = false}, SHIFT(346),
  [620] = {.count = 1, .reusable = true}, SHIFT(347),
  [622] = {.count = 1, .reusable = true}, SHIFT(348),
  [624] = {.count = 1, .reusable = true}, REDUCE(sym__type_specifier, 1),
  [626] = {.count = 1, .reusable = false}, REDUCE(sym__type_specifier, 1),
  [628] = {.count = 1, .reusable = true}, SHIFT(351),
  [630] = {.count = 2, .reusable = true}, REDUCE(sym__declarator, 1), REDUCE(sym__expression, 1),
  [633] = {.count = 1, .reusable = true}, SHIFT(353),
  [635] = {.count = 1, .reusable = true}, SHIFT(354),
  [637] = {.count = 1, .reusable = true}, SHIFT(355),
  [639] = {.count = 1, .reusable = false}, SHIFT(356),
  [641] = {.count = 1, .reusable = true}, SHIFT(356),
  [643] = {.count = 1, .reusable = true}, SHIFT(361),
  [645] = {.count = 1, .reusable = true}, REDUCE(sym_translation_unit, 1),
  [647] = {.count = 1, .reusable = false}, SHIFT(367),
  [649] = {.count = 1, .reusable = false}, SHIFT(364),
  [651] = {.count = 1, .reusable = true}, SHIFT(365),
  [653] = {.count = 1, .reusable = true}, REDUCE(sym_sized_type_specifier, 1),
  [655] = {.count = 1, .reusable = false}, REDUCE(sym_sized_type_specifier, 1),
  [657] = {.count = 1, .reusable = false}, SHIFT(373),
  [659] = {.count = 1, .reusable = false}, SHIFT(371),
  [661] = {.count = 2, .reusable = false}, REDUCE(sym_sized_type_specifier, 1), SHIFT(372),
  [664] = {.count = 1, .reusable = false}, SHIFT(374),
  [666] = {.count = 1, .reusable = true}, SHIFT(375),
  [668] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_include, 2),
  [670] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_include, 2),
  [672] = {.count = 1, .reusable = false}, SHIFT(376),
  [674] = {.count = 1, .reusable = true}, SHIFT(377),
  [676] = {.count = 1, .reusable = false}, SHIFT(378),
  [678] = {.count = 1, .reusable = true}, SHIFT(411),
  [680] = {.count = 1, .reusable = false}, SHIFT(380),
  [682] = {.count = 1, .reusable = false}, SHIFT(381),
  [684] = {.count = 1, .reusable = false}, SHIFT(382),
  [686] = {.count = 1, .reusable = false}, SHIFT(383),
  [688] = {.count = 1, .reusable = false}, SHIFT(384),
  [690] = {.count = 1, .reusable = false}, SHIFT(385),
  [692] = {.count = 1, .reusable = false}, SHIFT(386),
  [694] = {.count = 1, .reusable = false}, SHIFT(387),
  [696] = {.count = 1, .reusable = true}, SHIFT(388),
  [698] = {.count = 1, .reusable = false}, SHIFT(389),
  [700] = {.count = 1, .reusable = false}, SHIFT(390),
  [702] = {.count = 1, .reusable = true}, SHIFT(391),
  [704] = {.count = 1, .reusable = false}, SHIFT(392),
  [706] = {.count = 1, .reusable = false}, SHIFT(393),
  [708] = {.count = 1, .reusable = false}, SHIFT(394),
  [710] = {.count = 1, .reusable = false}, SHIFT(395),
  [712] = {.count = 1, .reusable = false}, SHIFT(396),
  [714] = {.count = 1, .reusable = false}, SHIFT(397),
  [716] = {.count = 1, .reusable = false}, SHIFT(398),
  [718] = {.count = 1, .reusable = false}, SHIFT(399),
  [720] = {.count = 1, .reusable = false}, SHIFT(400),
  [722] = {.count = 1, .reusable = false}, SHIFT(401),
  [724] = {.count = 1, .reusable = false}, SHIFT(402),
  [726] = {.count = 1, .reusable = false}, SHIFT(411),
  [728] = {.count = 1, .reusable = false}, SHIFT(403),
  [730] = {.count = 1, .reusable = false}, SHIFT(404),
  [732] = {.count = 1, .reusable = false}, SHIFT(405),
  [734] = {.count = 1, .reusable = false}, SHIFT(406),
  [736] = {.count = 1, .reusable = false}, SHIFT(407),
  [738] = {.count = 1, .reusable = false}, SHIFT(415),
  [740] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_call, 2),
  [742] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_call, 2),
  [744] = {.count = 1, .reusable = true}, SHIFT(418),
  [746] = {.count = 1, .reusable = true}, SHIFT(419),
  [748] = {.count = 1, .reusable = true}, SHIFT(420),
  [750] = {.count = 1, .reusable = true}, SHIFT(422),
  [752] = {.count = 1, .reusable = false}, SHIFT(423),
  [754] = {.count = 1, .reusable = false}, SHIFT(429),
  [756] = {.count = 1, .reusable = true}, SHIFT(435),
  [758] = {.count = 1, .reusable = true}, SHIFT(436),
  [760] = {.count = 1, .reusable = false}, SHIFT(438),
  [762] = {.count = 1, .reusable = false}, SHIFT(444),
  [764] = {.count = 1, .reusable = true}, SHIFT(445),
  [766] = {.count = 1, .reusable = true}, SHIFT(446),
  [768] = {.count = 1, .reusable = true}, SHIFT(447),
  [770] = {.count = 1, .reusable = true}, SHIFT(448),
  [772] = {.count = 1, .reusable = true}, SHIFT(450),
  [774] = {.count = 1, .reusable = false}, SHIFT(452),
  [776] = {.count = 1, .reusable = false}, SHIFT(456),
  [778] = {.count = 1, .reusable = false}, SHIFT(454),
  [780] = {.count = 2, .reusable = false}, REDUCE(sym_sized_type_specifier, 1), SHIFT(455),
  [783] = {.count = 1, .reusable = true}, SHIFT(459),
  [785] = {.count = 1, .reusable = true}, SHIFT(460),
  [787] = {.count = 1, .reusable = true}, SHIFT(461),
  [789] = {.count = 1, .reusable = false}, SHIFT(462),
  [791] = {.count = 1, .reusable = true}, SHIFT(463),
  [793] = {.count = 1, .reusable = false}, SHIFT(464),
  [795] = {.count = 1, .reusable = false}, SHIFT(465),
  [797] = {.count = 1, .reusable = false}, SHIFT(466),
  [799] = {.count = 1, .reusable = true}, SHIFT(468),
  [801] = {.count = 1, .reusable = true}, REDUCE(sym_compound_statement, 2),
  [803] = {.count = 1, .reusable = false}, REDUCE(sym_compound_statement, 2),
  [805] = {.count = 1, .reusable = true}, SHIFT(470),
  [807] = {.count = 1, .reusable = true}, SHIFT(471),
  [809] = {.count = 1, .reusable = true}, SHIFT(472),
  [811] = {.count = 1, .reusable = false}, SHIFT(473),
  [813] = {.count = 1, .reusable = true}, SHIFT(474),
  [815] = {.count = 1, .reusable = true}, SHIFT(475),
  [817] = {.count = 1, .reusable = true}, SHIFT(477),
  [819] = {.count = 1, .reusable = false}, SHIFT(477),
  [821] = {.count = 1, .reusable = true}, SHIFT(478),
  [823] = {.count = 1, .reusable = true}, SHIFT(481),
  [825] = {.count = 1, .reusable = true}, SHIFT(483),
  [827] = {.count = 1, .reusable = true}, SHIFT(482),
  [829] = {.count = 1, .reusable = false}, SHIFT(483),
  [831] = {.count = 1, .reusable = true}, SHIFT(485),
  [833] = {.count = 1, .reusable = true}, SHIFT(486),
  [835] = {.count = 1, .reusable = true}, SHIFT(487),
  [837] = {.count = 1, .reusable = false}, SHIFT(488),
  [839] = {.count = 1, .reusable = true}, SHIFT(490),
  [841] = {.count = 1, .reusable = true}, SHIFT(491),
  [843] = {.count = 1, .reusable = true}, SHIFT(494),
  [845] = {.count = 1, .reusable = true}, SHIFT(495),
  [847] = {.count = 1, .reusable = true}, SHIFT(499),
  [849] = {.count = 1, .reusable = true}, SHIFT(500),
  [851] = {.count = 1, .reusable = false}, SHIFT(502),
  [853] = {.count = 1, .reusable = false}, SHIFT(505),
  [855] = {.count = 1, .reusable = true}, SHIFT(508),
  [857] = {.count = 1, .reusable = true}, SHIFT(509),
  [859] = {.count = 1, .reusable = false}, SHIFT(124),
  [861] = {.count = 1, .reusable = true}, SHIFT(511),
  [863] = {.count = 1, .reusable = true}, SHIFT(510),
  [865] = {.count = 1, .reusable = false}, SHIFT(511),
  [867] = {.count = 1, .reusable = false}, SHIFT(512),
  [869] = {.count = 1, .reusable = false}, SHIFT(515),
  [871] = {.count = 1, .reusable = true}, SHIFT(517),
  [873] = {.count = 1, .reusable = true}, SHIFT(516),
  [875] = {.count = 1, .reusable = false}, SHIFT(517),
  [877] = {.count = 1, .reusable = false}, SHIFT(521),
  [879] = {.count = 1, .reusable = false}, SHIFT(519),
  [881] = {.count = 1, .reusable = false}, SHIFT(518),
  [883] = {.count = 1, .reusable = false}, SHIFT(522),
  [885] = {.count = 1, .reusable = true}, SHIFT(523),
  [887] = {.count = 1, .reusable = true}, REDUCE(sym_type_descriptor, 1),
  [889] = {.count = 1, .reusable = true}, SHIFT(525),
  [891] = {.count = 1, .reusable = false}, SHIFT(526),
  [893] = {.count = 1, .reusable = true}, SHIFT(526),
  [895] = {.count = 1, .reusable = true}, SHIFT(529),
  [897] = {.count = 1, .reusable = true}, SHIFT(530),
  [899] = {.count = 1, .reusable = false}, SHIFT(531),
  [901] = {.count = 1, .reusable = false}, SHIFT(532),
  [903] = {.count = 1, .reusable = true}, SHIFT(533),
  [905] = {.count = 1, .reusable = true}, SHIFT(532),
  [907] = {.count = 1, .reusable = false}, SHIFT(534),
  [909] = {.count = 1, .reusable = true}, SHIFT(535),
  [911] = {.count = 1, .reusable = true}, SHIFT(536),
  [913] = {.count = 1, .reusable = false}, SHIFT(537),
  [915] = {.count = 1, .reusable = false}, SHIFT(538),
  [917] = {.count = 1, .reusable = true}, SHIFT(539),
  [919] = {.count = 1, .reusable = false}, SHIFT(540),
  [921] = {.count = 1, .reusable = true}, SHIFT(540),
  [923] = {.count = 1, .reusable = false}, SHIFT(541),
  [925] = {.count = 1, .reusable = false}, SHIFT(542),
  [927] = {.count = 1, .reusable = true}, SHIFT(543),
  [929] = {.count = 1, .reusable = false}, SHIFT(545),
  [931] = {.count = 1, .reusable = false}, SHIFT(546),
  [933] = {.count = 1, .reusable = false}, SHIFT(372),
  [935] = {.count = 1, .reusable = true}, SHIFT(547),
  [937] = {.count = 1, .reusable = false}, SHIFT(549),
  [939] = {.count = 1, .reusable = true}, REDUCE(sym_pointer_expression, 2),
  [941] = {.count = 1, .reusable = false}, REDUCE(sym_pointer_expression, 2),
  [943] = {.count = 1, .reusable = true}, SHIFT(551),
  [945] = {.count = 1, .reusable = true}, SHIFT(260),
  [947] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_capture_specifier, 2),
  [949] = {.count = 1, .reusable = false}, REDUCE(sym_lambda_capture_specifier, 2),
  [951] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_default_capture, 1),
  [953] = {.count = 1, .reusable = true}, SHIFT(555),
  [955] = {.count = 1, .reusable = true}, SHIFT(554),
  [957] = {.count = 1, .reusable = false}, SHIFT(555),
  [959] = {.count = 1, .reusable = true}, SHIFT(557),
  [961] = {.count = 1, .reusable = true}, SHIFT(556),
  [963] = {.count = 1, .reusable = false}, SHIFT(557),
  [965] = {.count = 1, .reusable = false}, SHIFT(561),
  [967] = {.count = 1, .reusable = false}, SHIFT(559),
  [969] = {.count = 1, .reusable = false}, SHIFT(558),
  [971] = {.count = 1, .reusable = false}, SHIFT(562),
  [973] = {.count = 1, .reusable = true}, SHIFT(563),
  [975] = {.count = 1, .reusable = false}, SHIFT(564),
  [977] = {.count = 1, .reusable = true}, SHIFT(565),
  [979] = {.count = 1, .reusable = false}, SHIFT(566),
  [981] = {.count = 1, .reusable = true}, SHIFT(567),
  [983] = {.count = 1, .reusable = true}, SHIFT(566),
  [985] = {.count = 1, .reusable = false}, SHIFT(568),
  [987] = {.count = 1, .reusable = true}, SHIFT(569),
  [989] = {.count = 1, .reusable = true}, SHIFT(570),
  [991] = {.count = 1, .reusable = false}, SHIFT(571),
  [993] = {.count = 1, .reusable = false}, SHIFT(572),
  [995] = {.count = 1, .reusable = true}, SHIFT(573),
  [997] = {.count = 1, .reusable = false}, SHIFT(574),
  [999] = {.count = 1, .reusable = true}, SHIFT(574),
  [1001] = {.count = 1, .reusable = false}, SHIFT(575),
  [1003] = {.count = 1, .reusable = false}, SHIFT(576),
  [1005] = {.count = 1, .reusable = true}, SHIFT(579),
  [1007] = {.count = 1, .reusable = true}, SHIFT(580),
  [1009] = {.count = 1, .reusable = true}, SHIFT(581),
  [1011] = {.count = 1, .reusable = true}, REDUCE(sym_enum_specifier, 2, .alias_sequence_id = 2),
  [1013] = {.count = 1, .reusable = false}, REDUCE(sym_enum_specifier, 2, .alias_sequence_id = 2),
  [1015] = {.count = 1, .reusable = true}, REDUCE(sym_enum_specifier, 2),
  [1017] = {.count = 1, .reusable = false}, REDUCE(sym_enum_specifier, 2),
  [1019] = {.count = 1, .reusable = false}, SHIFT(584),
  [1021] = {.count = 1, .reusable = true}, SHIFT(585),
  [1023] = {.count = 1, .reusable = false}, SHIFT(586),
  [1025] = {.count = 1, .reusable = true}, SHIFT(587),
  [1027] = {.count = 1, .reusable = false}, SHIFT(606),
  [1029] = {.count = 1, .reusable = false}, SHIFT(601),
  [1031] = {.count = 1, .reusable = false}, SHIFT(588),
  [1033] = {.count = 1, .reusable = false}, SHIFT(589),
  [1035] = {.count = 1, .reusable = false}, SHIFT(590),
  [1037] = {.count = 1, .reusable = false}, SHIFT(591),
  [1039] = {.count = 1, .reusable = false}, SHIFT(592),
  [1041] = {.count = 1, .reusable = false}, SHIFT(593),
  [1043] = {.count = 1, .reusable = false}, SHIFT(594),
  [1045] = {.count = 1, .reusable = false}, SHIFT(595),
  [1047] = {.count = 1, .reusable = false}, SHIFT(596),
  [1049] = {.count = 1, .reusable = true}, SHIFT(597),
  [1051] = {.count = 1, .reusable = true}, SHIFT(599),
  [1053] = {.count = 1, .reusable = false}, SHIFT(607),
  [1055] = {.count = 1, .reusable = false}, SHIFT(608),
  [1057] = {.count = 1, .reusable = true}, REDUCE(sym_struct_specifier, 2, .alias_sequence_id = 2),
  [1059] = {.count = 1, .reusable = false}, REDUCE(sym_struct_specifier, 2, .alias_sequence_id = 2),
  [1061] = {.count = 1, .reusable = true}, SHIFT(611),
  [1063] = {.count = 1, .reusable = true}, REDUCE(sym_virtual_specifier, 1),
  [1065] = {.count = 1, .reusable = false}, REDUCE(sym_virtual_specifier, 1),
  [1067] = {.count = 1, .reusable = true}, SHIFT(616),
  [1069] = {.count = 1, .reusable = true}, REDUCE(sym_struct_specifier, 2),
  [1071] = {.count = 1, .reusable = false}, REDUCE(sym_struct_specifier, 2),
  [1073] = {.count = 1, .reusable = true}, SHIFT(171),
  [1075] = {.count = 1, .reusable = true}, SHIFT(619),
  [1077] = {.count = 1, .reusable = true}, REDUCE(sym_union_specifier, 2, .alias_sequence_id = 2),
  [1079] = {.count = 1, .reusable = false}, REDUCE(sym_union_specifier, 2, .alias_sequence_id = 2),
  [1081] = {.count = 1, .reusable = true}, REDUCE(sym_union_specifier, 2),
  [1083] = {.count = 1, .reusable = false}, REDUCE(sym_union_specifier, 2),
  [1085] = {.count = 1, .reusable = true}, SHIFT(636),
  [1087] = {.count = 1, .reusable = true}, SHIFT(627),
  [1089] = {.count = 1, .reusable = true}, SHIFT(628),
  [1091] = {.count = 1, .reusable = true}, SHIFT(629),
  [1093] = {.count = 1, .reusable = true}, SHIFT(630),
  [1095] = {.count = 1, .reusable = false}, SHIFT(631),
  [1097] = {.count = 1, .reusable = true}, SHIFT(631),
  [1099] = {.count = 1, .reusable = false}, SHIFT(632),
  [1101] = {.count = 1, .reusable = false}, SHIFT(636),
  [1103] = {.count = 1, .reusable = false}, SHIFT(633),
  [1105] = {.count = 1, .reusable = false}, SHIFT(634),
  [1107] = {.count = 1, .reusable = true}, SHIFT(635),
  [1109] = {.count = 1, .reusable = true}, SHIFT(638),
  [1111] = {.count = 1, .reusable = true}, SHIFT(639),
  [1113] = {.count = 1, .reusable = false}, SHIFT(639),
  [1115] = {.count = 1, .reusable = false}, SHIFT(641),
  [1117] = {.count = 1, .reusable = true}, SHIFT(644),
  [1119] = {.count = 1, .reusable = false}, SHIFT(644),
  [1121] = {.count = 1, .reusable = true}, SHIFT(645),
  [1123] = {.count = 1, .reusable = false}, SHIFT(645),
  [1125] = {.count = 1, .reusable = true}, SHIFT(646),
  [1127] = {.count = 1, .reusable = false}, SHIFT(646),
  [1129] = {.count = 1, .reusable = true}, SHIFT(647),
  [1131] = {.count = 1, .reusable = false}, SHIFT(647),
  [1133] = {.count = 1, .reusable = true}, SHIFT(649),
  [1135] = {.count = 1, .reusable = true}, SHIFT(648),
  [1137] = {.count = 1, .reusable = false}, SHIFT(649),
  [1139] = {.count = 1, .reusable = false}, SHIFT(650),
  [1141] = {.count = 1, .reusable = true}, SHIFT(651),
  [1143] = {.count = 1, .reusable = true}, SHIFT(653),
  [1145] = {.count = 1, .reusable = true}, SHIFT(652),
  [1147] = {.count = 1, .reusable = false}, SHIFT(653),
  [1149] = {.count = 1, .reusable = false}, SHIFT(660),
  [1151] = {.count = 1, .reusable = false}, SHIFT(658),
  [1153] = {.count = 1, .reusable = false}, SHIFT(654),
  [1155] = {.count = 1, .reusable = false}, SHIFT(655),
  [1157] = {.count = 1, .reusable = false}, SHIFT(656),
  [1159] = {.count = 1, .reusable = false}, SHIFT(657),
  [1161] = {.count = 1, .reusable = false}, SHIFT(661),
  [1163] = {.count = 1, .reusable = true}, SHIFT(662),
  [1165] = {.count = 1, .reusable = false}, SHIFT(663),
  [1167] = {.count = 1, .reusable = false}, SHIFT(664),
  [1169] = {.count = 1, .reusable = true}, SHIFT(665),
  [1171] = {.count = 1, .reusable = true}, SHIFT(666),
  [1173] = {.count = 1, .reusable = true}, SHIFT(664),
  [1175] = {.count = 1, .reusable = false}, SHIFT(667),
  [1177] = {.count = 1, .reusable = true}, SHIFT(668),
  [1179] = {.count = 1, .reusable = true}, SHIFT(669),
  [1181] = {.count = 1, .reusable = false}, SHIFT(670),
  [1183] = {.count = 1, .reusable = false}, SHIFT(671),
  [1185] = {.count = 1, .reusable = true}, SHIFT(672),
  [1187] = {.count = 1, .reusable = false}, SHIFT(673),
  [1189] = {.count = 1, .reusable = true}, SHIFT(673),
  [1191] = {.count = 1, .reusable = false}, SHIFT(674),
  [1193] = {.count = 1, .reusable = false}, SHIFT(675),
  [1195] = {.count = 1, .reusable = true}, SHIFT(676),
  [1197] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(678),
  [1200] = {.count = 1, .reusable = false}, SHIFT(679),
  [1202] = {.count = 1, .reusable = true}, SHIFT(680),
  [1204] = {.count = 1, .reusable = true}, SHIFT(686),
  [1206] = {.count = 1, .reusable = true}, SHIFT(688),
  [1208] = {.count = 1, .reusable = true}, SHIFT(689),
  [1210] = {.count = 1, .reusable = true}, SHIFT(691),
  [1212] = {.count = 1, .reusable = false}, SHIFT(691),
  [1214] = {.count = 1, .reusable = true}, SHIFT(692),
  [1216] = {.count = 1, .reusable = true}, SHIFT(695),
  [1218] = {.count = 1, .reusable = true}, SHIFT(697),
  [1220] = {.count = 1, .reusable = true}, SHIFT(696),
  [1222] = {.count = 1, .reusable = false}, SHIFT(697),
  [1224] = {.count = 1, .reusable = true}, SHIFT(699),
  [1226] = {.count = 1, .reusable = true}, SHIFT(700),
  [1228] = {.count = 1, .reusable = true}, SHIFT(701),
  [1230] = {.count = 1, .reusable = false}, SHIFT(702),
  [1232] = {.count = 1, .reusable = true}, SHIFT(704),
  [1234] = {.count = 1, .reusable = true}, SHIFT(705),
  [1236] = {.count = 1, .reusable = true}, SHIFT(710),
  [1238] = {.count = 1, .reusable = true}, SHIFT(706),
  [1240] = {.count = 1, .reusable = false}, SHIFT(710),
  [1242] = {.count = 1, .reusable = false}, SHIFT(707),
  [1244] = {.count = 1, .reusable = true}, SHIFT(708),
  [1246] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 2),
  [1248] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 2),
  [1250] = {.count = 1, .reusable = true}, SHIFT(725),
  [1252] = {.count = 1, .reusable = true}, SHIFT(712),
  [1254] = {.count = 1, .reusable = true}, SHIFT(713),
  [1256] = {.count = 1, .reusable = true}, SHIFT(714),
  [1258] = {.count = 1, .reusable = true}, SHIFT(715),
  [1260] = {.count = 1, .reusable = true}, SHIFT(716),
  [1262] = {.count = 1, .reusable = true}, SHIFT(717),
  [1264] = {.count = 1, .reusable = true}, SHIFT(718),
  [1266] = {.count = 1, .reusable = false}, SHIFT(719),
  [1268] = {.count = 1, .reusable = true}, SHIFT(719),
  [1270] = {.count = 1, .reusable = false}, SHIFT(720),
  [1272] = {.count = 1, .reusable = true}, SHIFT(721),
  [1274] = {.count = 1, .reusable = false}, SHIFT(725),
  [1276] = {.count = 1, .reusable = false}, SHIFT(722),
  [1278] = {.count = 1, .reusable = false}, SHIFT(723),
  [1280] = {.count = 1, .reusable = true}, SHIFT(724),
  [1282] = {.count = 1, .reusable = true}, SHIFT(731),
  [1284] = {.count = 1, .reusable = true}, SHIFT(730),
  [1286] = {.count = 1, .reusable = false}, SHIFT(731),
  [1288] = {.count = 1, .reusable = true}, SHIFT(733),
  [1290] = {.count = 1, .reusable = true}, SHIFT(732),
  [1292] = {.count = 1, .reusable = false}, SHIFT(733),
  [1294] = {.count = 1, .reusable = false}, SHIFT(737),
  [1296] = {.count = 1, .reusable = false}, SHIFT(735),
  [1298] = {.count = 1, .reusable = false}, SHIFT(734),
  [1300] = {.count = 1, .reusable = false}, SHIFT(738),
  [1302] = {.count = 1, .reusable = true}, SHIFT(739),
  [1304] = {.count = 1, .reusable = false}, SHIFT(740),
  [1306] = {.count = 1, .reusable = false}, SHIFT(741),
  [1308] = {.count = 1, .reusable = true}, SHIFT(742),
  [1310] = {.count = 1, .reusable = true}, SHIFT(741),
  [1312] = {.count = 1, .reusable = false}, SHIFT(743),
  [1314] = {.count = 1, .reusable = true}, SHIFT(744),
  [1316] = {.count = 1, .reusable = true}, SHIFT(745),
  [1318] = {.count = 1, .reusable = false}, SHIFT(746),
  [1320] = {.count = 1, .reusable = false}, SHIFT(747),
  [1322] = {.count = 1, .reusable = true}, SHIFT(748),
  [1324] = {.count = 1, .reusable = false}, SHIFT(749),
  [1326] = {.count = 1, .reusable = true}, SHIFT(749),
  [1328] = {.count = 1, .reusable = false}, SHIFT(750),
  [1330] = {.count = 1, .reusable = false}, SHIFT(751),
  [1332] = {.count = 1, .reusable = true}, REDUCE(sym_break_statement, 2),
  [1334] = {.count = 1, .reusable = false}, REDUCE(sym_break_statement, 2),
  [1336] = {.count = 1, .reusable = true}, REDUCE(sym_continue_statement, 2),
  [1338] = {.count = 1, .reusable = false}, REDUCE(sym_continue_statement, 2),
  [1340] = {.count = 1, .reusable = true}, SHIFT(753),
  [1342] = {.count = 1, .reusable = true}, SHIFT(754),
  [1344] = {.count = 1, .reusable = true}, SHIFT(755),
  [1346] = {.count = 1, .reusable = false}, SHIFT(756),
  [1348] = {.count = 1, .reusable = true}, SHIFT(757),
  [1350] = {.count = 1, .reusable = true}, REDUCE(sym_logical_expression, 2),
  [1352] = {.count = 1, .reusable = false}, REDUCE(sym_logical_expression, 2),
  [1354] = {.count = 1, .reusable = true}, REDUCE(sym_destructor_name, 2),
  [1356] = {.count = 1, .reusable = true}, REDUCE(sym_bitwise_expression, 2),
  [1358] = {.count = 1, .reusable = false}, REDUCE(sym_bitwise_expression, 2),
  [1360] = {.count = 1, .reusable = true}, REDUCE(sym_math_expression, 2),
  [1362] = {.count = 1, .reusable = false}, REDUCE(sym_math_expression, 2),
  [1364] = {.count = 1, .reusable = true}, REDUCE(sym_sizeof_expression, 2),
  [1366] = {.count = 1, .reusable = false}, REDUCE(sym_sizeof_expression, 2),
  [1368] = {.count = 1, .reusable = true}, SHIFT(759),
  [1370] = {.count = 1, .reusable = true}, REDUCE(sym_string_literal, 2),
  [1372] = {.count = 1, .reusable = false}, REDUCE(sym_string_literal, 2),
  [1374] = {.count = 1, .reusable = false}, SHIFT(760),
  [1376] = {.count = 1, .reusable = true}, SHIFT(761),
  [1378] = {.count = 1, .reusable = true}, SHIFT(778),
  [1380] = {.count = 1, .reusable = true}, SHIFT(763),
  [1382] = {.count = 1, .reusable = true}, SHIFT(764),
  [1384] = {.count = 1, .reusable = false}, SHIFT(787),
  [1386] = {.count = 1, .reusable = false}, SHIFT(777),
  [1388] = {.count = 1, .reusable = true}, SHIFT(765),
  [1390] = {.count = 1, .reusable = true}, SHIFT(766),
  [1392] = {.count = 1, .reusable = false}, SHIFT(767),
  [1394] = {.count = 1, .reusable = true}, SHIFT(767),
  [1396] = {.count = 1, .reusable = false}, SHIFT(768),
  [1398] = {.count = 1, .reusable = true}, SHIFT(769),
  [1400] = {.count = 1, .reusable = true}, SHIFT(770),
  [1402] = {.count = 1, .reusable = false}, SHIFT(778),
  [1404] = {.count = 1, .reusable = false}, SHIFT(771),
  [1406] = {.count = 1, .reusable = false}, SHIFT(772),
  [1408] = {.count = 1, .reusable = true}, SHIFT(773),
  [1410] = {.count = 1, .reusable = false}, SHIFT(774),
  [1412] = {.count = 1, .reusable = false}, SHIFT(775),
  [1414] = {.count = 1, .reusable = true}, SHIFT(776),
  [1416] = {.count = 1, .reusable = false}, SHIFT(788),
  [1418] = {.count = 1, .reusable = true}, SHIFT(789),
  [1420] = {.count = 1, .reusable = true}, REDUCE(sym_compound_literal_expression, 2, .alias_sequence_id = 1),
  [1422] = {.count = 1, .reusable = false}, REDUCE(sym_compound_literal_expression, 2, .alias_sequence_id = 1),
  [1424] = {.count = 1, .reusable = true}, REDUCE(sym_template_function, 2),
  [1426] = {.count = 2, .reusable = true}, REDUCE(sym_template_type, 2, .alias_sequence_id = 1), REDUCE(sym_template_function, 2),
  [1429] = {.count = 1, .reusable = false}, REDUCE(sym_template_type, 2, .alias_sequence_id = 1),
  [1431] = {.count = 1, .reusable = true}, REDUCE(sym_template_type, 2, .alias_sequence_id = 1),
  [1433] = {.count = 2, .reusable = false}, REDUCE(sym_template_type, 2, .alias_sequence_id = 1), REDUCE(sym_template_function, 2),
  [1436] = {.count = 1, .reusable = false}, REDUCE(sym_template_function, 2),
  [1438] = {.count = 1, .reusable = true}, REDUCE(sym_class_specifier, 2, .alias_sequence_id = 2),
  [1440] = {.count = 1, .reusable = false}, REDUCE(sym_class_specifier, 2, .alias_sequence_id = 2),
  [1442] = {.count = 1, .reusable = true}, REDUCE(sym_class_specifier, 2),
  [1444] = {.count = 1, .reusable = false}, REDUCE(sym_class_specifier, 2),
  [1446] = {.count = 1, .reusable = true}, REDUCE(sym_dependent_type, 2, .dynamic_precedence = -1),
  [1448] = {.count = 1, .reusable = false}, REDUCE(sym_dependent_type, 2, .dynamic_precedence = -1),
  [1450] = {.count = 1, .reusable = true}, SHIFT(796),
  [1452] = {.count = 1, .reusable = true}, SHIFT(798),
  [1454] = {.count = 1, .reusable = false}, SHIFT(806),
  [1456] = {.count = 1, .reusable = false}, SHIFT(803),
  [1458] = {.count = 1, .reusable = false}, SHIFT(799),
  [1460] = {.count = 1, .reusable = false}, SHIFT(800),
  [1462] = {.count = 1, .reusable = true}, SHIFT(801),
  [1464] = {.count = 2, .reusable = true}, REDUCE(sym__declarator, 1), REDUCE(sym__type_specifier, 1, .alias_sequence_id = 1),
  [1467] = {.count = 1, .reusable = true}, SHIFT(807),
  [1469] = {.count = 1, .reusable = false}, SHIFT(809),
  [1471] = {.count = 1, .reusable = true}, SHIFT(810),
  [1473] = {.count = 1, .reusable = true}, SHIFT(811),
  [1475] = {.count = 1, .reusable = false}, SHIFT(819),
  [1477] = {.count = 1, .reusable = false}, SHIFT(817),
  [1479] = {.count = 1, .reusable = false}, SHIFT(814),
  [1481] = {.count = 1, .reusable = true}, SHIFT(820),
  [1483] = {.count = 1, .reusable = false}, SHIFT(821),
  [1485] = {.count = 1, .reusable = false}, SHIFT(822),
  [1487] = {.count = 1, .reusable = true}, SHIFT(823),
  [1489] = {.count = 1, .reusable = true}, REDUCE(sym_delete_expression, 2),
  [1491] = {.count = 1, .reusable = false}, REDUCE(sym_delete_expression, 2),
  [1493] = {.count = 1, .reusable = true}, SHIFT(824),
  [1495] = {.count = 1, .reusable = false}, SHIFT(825),
  [1497] = {.count = 1, .reusable = false}, SHIFT(826),
  [1499] = {.count = 1, .reusable = false}, SHIFT(827),
  [1501] = {.count = 1, .reusable = false}, SHIFT(828),
  [1503] = {.count = 1, .reusable = false}, SHIFT(829),
  [1505] = {.count = 1, .reusable = false}, SHIFT(830),
  [1507] = {.count = 1, .reusable = false}, SHIFT(831),
  [1509] = {.count = 1, .reusable = false}, SHIFT(832),
  [1511] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_definition, 2),
  [1513] = {.count = 1, .reusable = false}, REDUCE(sym_namespace_definition, 2),
  [1515] = {.count = 1, .reusable = true}, SHIFT(835),
  [1517] = {.count = 1, .reusable = true}, SHIFT(836),
  [1519] = {.count = 1, .reusable = true}, SHIFT(837),
  [1521] = {.count = 1, .reusable = true}, SHIFT(838),
  [1523] = {.count = 1, .reusable = false}, SHIFT(840),
  [1525] = {.count = 1, .reusable = true}, SHIFT(841),
  [1527] = {.count = 1, .reusable = true}, SHIFT(842),
  [1529] = {.count = 1, .reusable = true}, SHIFT(845),
  [1531] = {.count = 1, .reusable = true}, SHIFT(844),
  [1533] = {.count = 1, .reusable = false}, SHIFT(845),
  [1535] = {.count = 1, .reusable = true}, SHIFT(847),
  [1537] = {.count = 1, .reusable = true}, SHIFT(848),
  [1539] = {.count = 1, .reusable = true}, SHIFT(850),
  [1541] = {.count = 1, .reusable = false}, SHIFT(851),
  [1543] = {.count = 1, .reusable = false}, SHIFT(857),
  [1545] = {.count = 2, .reusable = false}, REDUCE(sym__type_specifier, 1, .alias_sequence_id = 1), SHIFT(260),
  [1548] = {.count = 1, .reusable = true}, SHIFT(863),
  [1550] = {.count = 1, .reusable = false}, SHIFT(865),
  [1552] = {.count = 1, .reusable = false}, SHIFT(871),
  [1554] = {.count = 1, .reusable = true}, SHIFT(872),
  [1556] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 2),
  [1558] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 2),
  [1560] = {.count = 1, .reusable = true}, SHIFT(873),
  [1562] = {.count = 1, .reusable = false}, SHIFT(876),
  [1564] = {.count = 1, .reusable = true}, SHIFT(877),
  [1566] = {.count = 2, .reusable = false}, REDUCE(sym__type_specifier, 1), SHIFT(260),
  [1569] = {.count = 1, .reusable = false}, SHIFT(881),
  [1571] = {.count = 1, .reusable = false}, SHIFT(879),
  [1573] = {.count = 1, .reusable = false}, SHIFT(880),
  [1575] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_identifier, 2),
  [1577] = {.count = 2, .reusable = true}, REDUCE(sym_scoped_identifier, 2), REDUCE(sym_scoped_type_identifier, 2, .alias_sequence_id = 2),
  [1580] = {.count = 1, .reusable = false}, REDUCE(sym_scoped_type_identifier, 2, .alias_sequence_id = 2),
  [1582] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_type_identifier, 2, .alias_sequence_id = 2),
  [1584] = {.count = 2, .reusable = false}, REDUCE(sym_scoped_identifier, 2), REDUCE(sym_scoped_type_identifier, 2, .alias_sequence_id = 2),
  [1587] = {.count = 1, .reusable = false}, REDUCE(sym_scoped_identifier, 2),
  [1589] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_namespace_identifier, 2, .alias_sequence_id = 3),
  [1591] = {.count = 1, .reusable = true}, SHIFT(883),
  [1593] = {.count = 1, .reusable = true}, SHIFT(882),
  [1595] = {.count = 1, .reusable = false}, SHIFT(883),
  [1597] = {.count = 1, .reusable = true}, REDUCE(sym__empty_declaration, 2),
  [1599] = {.count = 1, .reusable = false}, REDUCE(sym__empty_declaration, 2),
  [1601] = {.count = 1, .reusable = false}, SHIFT(884),
  [1603] = {.count = 1, .reusable = true}, SHIFT(884),
  [1605] = {.count = 1, .reusable = true}, SHIFT(885),
  [1607] = {.count = 1, .reusable = true}, SHIFT(887),
  [1609] = {.count = 1, .reusable = true}, SHIFT(888),
  [1611] = {.count = 1, .reusable = false}, REDUCE(sym__declarator, 1),
  [1613] = {.count = 1, .reusable = true}, SHIFT(891),
  [1615] = {.count = 1, .reusable = true}, SHIFT(892),
  [1617] = {.count = 1, .reusable = true}, SHIFT(893),
  [1619] = {.count = 1, .reusable = true}, SHIFT(894),
  [1621] = {.count = 1, .reusable = true}, SHIFT(895),
  [1623] = {.count = 1, .reusable = true}, SHIFT(900),
  [1625] = {.count = 1, .reusable = true}, SHIFT(902),
  [1627] = {.count = 1, .reusable = true}, SHIFT(903),
  [1629] = {.count = 1, .reusable = false}, SHIFT(908),
  [1631] = {.count = 1, .reusable = false}, SHIFT(906),
  [1633] = {.count = 1, .reusable = false}, SHIFT(904),
  [1635] = {.count = 1, .reusable = true}, SHIFT(921),
  [1637] = {.count = 1, .reusable = true}, SHIFT(909),
  [1639] = {.count = 1, .reusable = true}, SHIFT(910),
  [1641] = {.count = 1, .reusable = true}, SHIFT(911),
  [1643] = {.count = 1, .reusable = false}, SHIFT(912),
  [1645] = {.count = 1, .reusable = true}, SHIFT(913),
  [1647] = {.count = 1, .reusable = true}, SHIFT(914),
  [1649] = {.count = 1, .reusable = true}, SHIFT(915),
  [1651] = {.count = 1, .reusable = false}, SHIFT(916),
  [1653] = {.count = 1, .reusable = true}, SHIFT(916),
  [1655] = {.count = 1, .reusable = false}, SHIFT(917),
  [1657] = {.count = 1, .reusable = false}, SHIFT(921),
  [1659] = {.count = 1, .reusable = false}, SHIFT(918),
  [1661] = {.count = 1, .reusable = false}, SHIFT(919),
  [1663] = {.count = 1, .reusable = true}, SHIFT(920),
  [1665] = {.count = 1, .reusable = true}, REDUCE(sym_function_declarator, 2),
  [1667] = {.count = 1, .reusable = false}, SHIFT(924),
  [1669] = {.count = 1, .reusable = true}, SHIFT(924),
  [1671] = {.count = 1, .reusable = true}, SHIFT(925),
  [1673] = {.count = 1, .reusable = true}, SHIFT(173),
  [1675] = {.count = 1, .reusable = true}, SHIFT(926),
  [1677] = {.count = 1, .reusable = true}, SHIFT(927),
  [1679] = {.count = 1, .reusable = true}, SHIFT(928),
  [1681] = {.count = 1, .reusable = true}, SHIFT(929),
  [1683] = {.count = 1, .reusable = true}, SHIFT(930),
  [1685] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_or_destructor_definition, 2),
  [1687] = {.count = 1, .reusable = false}, REDUCE(sym_constructor_or_destructor_definition, 2),
  [1689] = {.count = 1, .reusable = true}, REDUCE(sym__declaration_specifiers, 2),
  [1691] = {.count = 1, .reusable = false}, REDUCE(sym__declaration_specifiers, 2),
  [1693] = {.count = 1, .reusable = true}, SHIFT(936),
  [1695] = {.count = 1, .reusable = false}, SHIFT(936),
  [1697] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 2),
  [1699] = {.count = 1, .reusable = false}, REDUCE(sym_expression_statement, 2),
  [1701] = {.count = 1, .reusable = true}, SHIFT(938),
  [1703] = {.count = 1, .reusable = false}, SHIFT(938),
  [1705] = {.count = 1, .reusable = true}, SHIFT(939),
  [1707] = {.count = 1, .reusable = false}, SHIFT(939),
  [1709] = {.count = 1, .reusable = true}, SHIFT(940),
  [1711] = {.count = 1, .reusable = false}, SHIFT(940),
  [1713] = {.count = 1, .reusable = true}, SHIFT(941),
  [1715] = {.count = 1, .reusable = false}, SHIFT(941),
  [1717] = {.count = 1, .reusable = true}, SHIFT(942),
  [1719] = {.count = 1, .reusable = false}, SHIFT(942),
  [1721] = {.count = 1, .reusable = true}, SHIFT(943),
  [1723] = {.count = 1, .reusable = false}, SHIFT(943),
  [1725] = {.count = 1, .reusable = true}, SHIFT(944),
  [1727] = {.count = 1, .reusable = false}, SHIFT(944),
  [1729] = {.count = 1, .reusable = true}, SHIFT(945),
  [1731] = {.count = 1, .reusable = false}, SHIFT(945),
  [1733] = {.count = 1, .reusable = true}, SHIFT(946),
  [1735] = {.count = 1, .reusable = false}, SHIFT(946),
  [1737] = {.count = 1, .reusable = true}, SHIFT(947),
  [1739] = {.count = 1, .reusable = false}, SHIFT(947),
  [1741] = {.count = 1, .reusable = true}, SHIFT(948),
  [1743] = {.count = 1, .reusable = false}, SHIFT(948),
  [1745] = {.count = 1, .reusable = true}, SHIFT(949),
  [1747] = {.count = 1, .reusable = false}, SHIFT(949),
  [1749] = {.count = 1, .reusable = true}, SHIFT(950),
  [1751] = {.count = 1, .reusable = false}, SHIFT(950),
  [1753] = {.count = 1, .reusable = true}, SHIFT(951),
  [1755] = {.count = 1, .reusable = true}, SHIFT(952),
  [1757] = {.count = 1, .reusable = true}, REDUCE(sym_call_expression, 2),
  [1759] = {.count = 1, .reusable = false}, REDUCE(sym_call_expression, 2),
  [1761] = {.count = 1, .reusable = true}, REDUCE(sym_concatenated_string, 2),
  [1763] = {.count = 1, .reusable = false}, REDUCE(sym_concatenated_string, 2),
  [1765] = {.count = 1, .reusable = false}, SHIFT(957),
  [1767] = {.count = 1, .reusable = true}, SHIFT(958),
  [1769] = {.count = 1, .reusable = true}, REDUCE(sym_compound_literal_expression, 2),
  [1771] = {.count = 1, .reusable = false}, REDUCE(sym_compound_literal_expression, 2),
  [1773] = {.count = 1, .reusable = true}, SHIFT(15),
  [1775] = {.count = 1, .reusable = true}, SHIFT(965),
  [1777] = {.count = 1, .reusable = true}, SHIFT(963),
  [1779] = {.count = 1, .reusable = true}, SHIFT(964),
  [1781] = {.count = 1, .reusable = false}, SHIFT(965),
  [1783] = {.count = 1, .reusable = true}, SHIFT(967),
  [1785] = {.count = 1, .reusable = true}, REDUCE(sym__abstract_declarator, 1),
  [1787] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_function_declarator, 1),
  [1789] = {.count = 1, .reusable = true}, SHIFT(970),
  [1791] = {.count = 1, .reusable = true}, SHIFT(972),
  [1793] = {.count = 1, .reusable = true}, SHIFT(974),
  [1795] = {.count = 1, .reusable = false}, SHIFT(974),
  [1797] = {.count = 1, .reusable = true}, SHIFT(973),
  [1799] = {.count = 1, .reusable = true}, REDUCE(sym_template_type, 2),
  [1801] = {.count = 1, .reusable = false}, REDUCE(sym_template_type, 2),
  [1803] = {.count = 2, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(53),
  [1806] = {.count = 1, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 2),
  [1808] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(2),
  [1811] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(3),
  [1814] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(4),
  [1817] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(5),
  [1820] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(6),
  [1823] = {.count = 2, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(7),
  [1826] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(8),
  [1829] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(9),
  [1832] = {.count = 2, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(10),
  [1835] = {.count = 2, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(11),
  [1838] = {.count = 2, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(12),
  [1841] = {.count = 2, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(13),
  [1844] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(14),
  [1847] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(15),
  [1850] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(64),
  [1853] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(52),
  [1856] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(16),
  [1859] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(17),
  [1862] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(18),
  [1865] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(19),
  [1868] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(20),
  [1871] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(21),
  [1874] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(22),
  [1877] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(23),
  [1880] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(24),
  [1883] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(25),
  [1886] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(26),
  [1889] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(27),
  [1892] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(28),
  [1895] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(29),
  [1898] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(30),
  [1901] = {.count = 2, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(31),
  [1904] = {.count = 2, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(32),
  [1907] = {.count = 2, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(33),
  [1910] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(34),
  [1913] = {.count = 2, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(34),
  [1916] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(35),
  [1919] = {.count = 2, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(36),
  [1922] = {.count = 2, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(37),
  [1925] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(53),
  [1928] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(38),
  [1931] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(39),
  [1934] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(40),
  [1937] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(41),
  [1940] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(42),
  [1943] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(43),
  [1946] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(44),
  [1949] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(45),
  [1952] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(46),
  [1955] = {.count = 2, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(47),
  [1958] = {.count = 2, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(50),
  [1961] = {.count = 1, .reusable = true}, SHIFT(976),
  [1963] = {.count = 1, .reusable = false}, SHIFT(978),
  [1965] = {.count = 1, .reusable = true}, SHIFT(981),
  [1967] = {.count = 2, .reusable = false}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(14),
  [1970] = {.count = 1, .reusable = true}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2),
  [1972] = {.count = 2, .reusable = false}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(15),
  [1975] = {.count = 1, .reusable = false}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2),
  [1977] = {.count = 1, .reusable = true}, REDUCE(sym_sized_type_specifier, 2),
  [1979] = {.count = 1, .reusable = false}, REDUCE(sym_sized_type_specifier, 2),
  [1981] = {.count = 1, .reusable = true}, REDUCE(sym_sized_type_specifier, 2, .dynamic_precedence = -1, .alias_sequence_id = 2),
  [1983] = {.count = 1, .reusable = false}, REDUCE(sym_sized_type_specifier, 2, .dynamic_precedence = -1, .alias_sequence_id = 2),
  [1985] = {.count = 1, .reusable = true}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2),
  [1987] = {.count = 1, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2),
  [1989] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(373),
  [1992] = {.count = 1, .reusable = false}, SHIFT(982),
  [1994] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_def, 3),
  [1996] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_def, 3),
  [1998] = {.count = 1, .reusable = true}, SHIFT(983),
  [2000] = {.count = 1, .reusable = true}, SHIFT(984),
  [2002] = {.count = 1, .reusable = true}, SHIFT(985),
  [2004] = {.count = 1, .reusable = false}, SHIFT(986),
  [2006] = {.count = 1, .reusable = false}, SHIFT(987),
  [2008] = {.count = 1, .reusable = true}, SHIFT(988),
  [2010] = {.count = 1, .reusable = true}, SHIFT(989),
  [2012] = {.count = 1, .reusable = true}, SHIFT(990),
  [2014] = {.count = 1, .reusable = false}, SHIFT(991),
  [2016] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if, 3),
  [2018] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if, 3),
  [2020] = {.count = 1, .reusable = true}, SHIFT(992),
  [2022] = {.count = 1, .reusable = true}, SHIFT(1020),
  [2024] = {.count = 1, .reusable = false}, SHIFT(993),
  [2026] = {.count = 1, .reusable = false}, SHIFT(994),
  [2028] = {.count = 1, .reusable = false}, SHIFT(995),
  [2030] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_else, 1),
  [2032] = {.count = 1, .reusable = false}, SHIFT(996),
  [2034] = {.count = 1, .reusable = false}, SHIFT(997),
  [2036] = {.count = 1, .reusable = true}, SHIFT(998),
  [2038] = {.count = 1, .reusable = false}, SHIFT(999),
  [2040] = {.count = 1, .reusable = false}, SHIFT(1000),
  [2042] = {.count = 1, .reusable = true}, SHIFT(1001),
  [2044] = {.count = 1, .reusable = false}, SHIFT(1002),
  [2046] = {.count = 1, .reusable = false}, SHIFT(1003),
  [2048] = {.count = 1, .reusable = false}, SHIFT(1004),
  [2050] = {.count = 1, .reusable = false}, SHIFT(1005),
  [2052] = {.count = 1, .reusable = false}, SHIFT(1006),
  [2054] = {.count = 1, .reusable = false}, SHIFT(1007),
  [2056] = {.count = 1, .reusable = false}, SHIFT(1008),
  [2058] = {.count = 1, .reusable = false}, SHIFT(1009),
  [2060] = {.count = 1, .reusable = false}, SHIFT(1010),
  [2062] = {.count = 1, .reusable = false}, SHIFT(1011),
  [2064] = {.count = 1, .reusable = false}, SHIFT(1012),
  [2066] = {.count = 1, .reusable = false}, SHIFT(1020),
  [2068] = {.count = 1, .reusable = false}, SHIFT(1013),
  [2070] = {.count = 1, .reusable = false}, SHIFT(1014),
  [2072] = {.count = 1, .reusable = false}, SHIFT(1015),
  [2074] = {.count = 1, .reusable = false}, SHIFT(1016),
  [2076] = {.count = 1, .reusable = false}, SHIFT(1017),
  [2078] = {.count = 1, .reusable = false}, SHIFT(1024),
  [2080] = {.count = 1, .reusable = false}, SHIFT(1025),
  [2082] = {.count = 1, .reusable = false}, SHIFT(1026),
  [2084] = {.count = 1, .reusable = false}, SHIFT(1027),
  [2086] = {.count = 1, .reusable = true}, SHIFT(1030),
  [2088] = {.count = 1, .reusable = true}, SHIFT(1032),
  [2090] = {.count = 1, .reusable = true}, SHIFT(1033),
  [2092] = {.count = 1, .reusable = true}, SHIFT(1035),
  [2094] = {.count = 1, .reusable = false}, SHIFT(1035),
  [2096] = {.count = 1, .reusable = true}, SHIFT(1036),
  [2098] = {.count = 1, .reusable = true}, SHIFT(1039),
  [2100] = {.count = 1, .reusable = true}, SHIFT(1041),
  [2102] = {.count = 1, .reusable = true}, SHIFT(1040),
  [2104] = {.count = 1, .reusable = false}, SHIFT(1041),
  [2106] = {.count = 1, .reusable = true}, SHIFT(1043),
  [2108] = {.count = 1, .reusable = true}, SHIFT(1044),
  [2110] = {.count = 1, .reusable = true}, SHIFT(1045),
  [2112] = {.count = 1, .reusable = false}, SHIFT(1046),
  [2114] = {.count = 1, .reusable = true}, SHIFT(1048),
  [2116] = {.count = 1, .reusable = true}, SHIFT(1050),
  [2118] = {.count = 1, .reusable = true}, SHIFT(1051),
  [2120] = {.count = 1, .reusable = false}, SHIFT(1053),
  [2122] = {.count = 1, .reusable = false}, SHIFT(1054),
  [2124] = {.count = 1, .reusable = true}, SHIFT(1057),
  [2126] = {.count = 1, .reusable = true}, SHIFT(1058),
  [2128] = {.count = 1, .reusable = true}, SHIFT(1059),
  [2130] = {.count = 1, .reusable = true}, SHIFT(1062),
  [2132] = {.count = 1, .reusable = true}, SHIFT(1065),
  [2134] = {.count = 1, .reusable = false}, SHIFT(1057),
  [2136] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef, 3),
  [2138] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef, 3),
  [2140] = {.count = 1, .reusable = true}, SHIFT(1069),
  [2142] = {.count = 1, .reusable = false}, SHIFT(1069),
  [2144] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_call, 3),
  [2146] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_call, 3),
  [2148] = {.count = 1, .reusable = true}, SHIFT(1071),
  [2150] = {.count = 1, .reusable = true}, SHIFT(1072),
  [2152] = {.count = 1, .reusable = true}, SHIFT(1075),
  [2154] = {.count = 1, .reusable = true}, SHIFT(1090),
  [2156] = {.count = 1, .reusable = false}, SHIFT(1090),
  [2158] = {.count = 1, .reusable = true}, SHIFT(1089),
  [2160] = {.count = 1, .reusable = true}, SHIFT(1092),
  [2162] = {.count = 1, .reusable = true}, SHIFT(1099),
  [2164] = {.count = 1, .reusable = false}, SHIFT(448),
  [2166] = {.count = 1, .reusable = true}, REDUCE(sym__type_declarator, 1, .alias_sequence_id = 1),
  [2168] = {.count = 1, .reusable = true}, SHIFT(1103),
  [2170] = {.count = 1, .reusable = true}, SHIFT(1104),
  [2172] = {.count = 1, .reusable = true}, SHIFT(1106),
  [2174] = {.count = 2, .reusable = false}, REDUCE(aux_sym_type_definition_repeat1, 2), SHIFT_REPEAT(72),
  [2177] = {.count = 1, .reusable = false}, REDUCE(aux_sym_type_definition_repeat1, 2),
  [2179] = {.count = 1, .reusable = true}, REDUCE(aux_sym_type_definition_repeat1, 2),
  [2181] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(456),
  [2184] = {.count = 1, .reusable = true}, REDUCE(sym_linkage_specification, 3),
  [2186] = {.count = 1, .reusable = false}, REDUCE(sym_linkage_specification, 3),
  [2188] = {.count = 1, .reusable = false}, SHIFT(1108),
  [2190] = {.count = 1, .reusable = true}, SHIFT(1109),
  [2192] = {.count = 1, .reusable = false}, SHIFT(1110),
  [2194] = {.count = 1, .reusable = false}, SHIFT(1111),
  [2196] = {.count = 1, .reusable = true}, SHIFT(1139),
  [2198] = {.count = 1, .reusable = false}, SHIFT(1113),
  [2200] = {.count = 1, .reusable = false}, SHIFT(1114),
  [2202] = {.count = 1, .reusable = false}, SHIFT(1115),
  [2204] = {.count = 1, .reusable = false}, SHIFT(1116),
  [2206] = {.count = 1, .reusable = false}, SHIFT(1117),
  [2208] = {.count = 1, .reusable = false}, SHIFT(1118),
  [2210] = {.count = 1, .reusable = false}, SHIFT(1119),
  [2212] = {.count = 1, .reusable = false}, SHIFT(1120),
  [2214] = {.count = 1, .reusable = true}, SHIFT(1121),
  [2216] = {.count = 1, .reusable = false}, SHIFT(1122),
  [2218] = {.count = 1, .reusable = true}, SHIFT(1123),
  [2220] = {.count = 1, .reusable = false}, SHIFT(1124),
  [2222] = {.count = 1, .reusable = false}, SHIFT(1125),
  [2224] = {.count = 1, .reusable = false}, SHIFT(1126),
  [2226] = {.count = 1, .reusable = false}, SHIFT(1127),
  [2228] = {.count = 1, .reusable = false}, SHIFT(1128),
  [2230] = {.count = 1, .reusable = false}, SHIFT(1129),
  [2232] = {.count = 1, .reusable = false}, SHIFT(1130),
  [2234] = {.count = 1, .reusable = false}, SHIFT(1131),
  [2236] = {.count = 1, .reusable = false}, SHIFT(1132),
  [2238] = {.count = 1, .reusable = false}, SHIFT(1133),
  [2240] = {.count = 1, .reusable = false}, SHIFT(1134),
  [2242] = {.count = 1, .reusable = false}, SHIFT(1139),
  [2244] = {.count = 1, .reusable = false}, SHIFT(1135),
  [2246] = {.count = 1, .reusable = false}, SHIFT(1136),
  [2248] = {.count = 1, .reusable = false}, SHIFT(1142),
  [2250] = {.count = 1, .reusable = true}, SHIFT(1145),
  [2252] = {.count = 1, .reusable = false}, SHIFT(1147),
  [2254] = {.count = 1, .reusable = true}, SHIFT(1148),
  [2256] = {.count = 1, .reusable = true}, SHIFT(1149),
  [2258] = {.count = 1, .reusable = false}, SHIFT(1149),
  [2260] = {.count = 1, .reusable = true}, SHIFT(1150),
  [2262] = {.count = 1, .reusable = false}, SHIFT(1151),
  [2264] = {.count = 1, .reusable = true}, SHIFT(1153),
  [2266] = {.count = 1, .reusable = false}, SHIFT(1154),
  [2268] = {.count = 1, .reusable = true}, SHIFT(1158),
  [2270] = {.count = 1, .reusable = true}, SHIFT(1160),
  [2272] = {.count = 1, .reusable = true}, SHIFT(1159),
  [2274] = {.count = 1, .reusable = false}, SHIFT(1160),
  [2276] = {.count = 1, .reusable = true}, SHIFT(1162),
  [2278] = {.count = 1, .reusable = true}, SHIFT(1163),
  [2280] = {.count = 1, .reusable = true}, SHIFT(1165),
  [2282] = {.count = 1, .reusable = true}, SHIFT(1167),
  [2284] = {.count = 1, .reusable = true}, SHIFT(1169),
  [2286] = {.count = 1, .reusable = true}, REDUCE(sym_compound_statement, 3),
  [2288] = {.count = 1, .reusable = false}, REDUCE(sym_compound_statement, 3),
  [2290] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(114),
  [2293] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(87),
  [2296] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(88),
  [2299] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(89),
  [2302] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(90),
  [2305] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(91),
  [2308] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(92),
  [2311] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(93),
  [2314] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(94),
  [2317] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(95),
  [2320] = {.count = 1, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2),
  [2322] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(97),
  [2325] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(98),
  [2328] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(13),
  [2331] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(72),
  [2334] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(64),
  [2337] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(52),
  [2340] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(16),
  [2343] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(17),
  [2346] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(18),
  [2349] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(99),
  [2352] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(100),
  [2355] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(101),
  [2358] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(102),
  [2361] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(103),
  [2364] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(104),
  [2367] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(105),
  [2370] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(106),
  [2373] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(107),
  [2376] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(108),
  [2379] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(109),
  [2382] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(32),
  [2385] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(110),
  [2388] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(34),
  [2391] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(34),
  [2394] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(35),
  [2397] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(36),
  [2400] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(37),
  [2403] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(114),
  [2406] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(111),
  [2409] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(39),
  [2412] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(40),
  [2415] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(42),
  [2418] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(112),
  [2421] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(46),
  [2424] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(47),
  [2427] = {.count = 2, .reusable = false}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(94),
  [2430] = {.count = 2, .reusable = false}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(72),
  [2433] = {.count = 1, .reusable = true}, SHIFT(1171),
  [2435] = {.count = 1, .reusable = true}, REDUCE(sym_pointer_declarator, 2, .dynamic_precedence = 1),
  [2437] = {.count = 1, .reusable = true}, SHIFT(1172),
  [2439] = {.count = 1, .reusable = true}, REDUCE(sym_reference_declarator, 2, .dynamic_precedence = 1),
  [2441] = {.count = 1, .reusable = true}, SHIFT(1174),
  [2443] = {.count = 1, .reusable = true}, SHIFT(1175),
  [2445] = {.count = 1, .reusable = false}, SHIFT(1176),
  [2447] = {.count = 1, .reusable = false}, SHIFT(1177),
  [2449] = {.count = 1, .reusable = true}, SHIFT(1179),
  [2451] = {.count = 1, .reusable = true}, SHIFT(1178),
  [2453] = {.count = 1, .reusable = false}, SHIFT(1179),
  [2455] = {.count = 1, .reusable = true}, REDUCE(sym__declarator, 3, .dynamic_precedence = -10),
  [2457] = {.count = 1, .reusable = true}, SHIFT(1180),
  [2459] = {.count = 1, .reusable = true}, SHIFT(1181),
  [2461] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_pointer_declarator, 1, .dynamic_precedence = 1),
  [2463] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_reference_declarator, 1),
  [2465] = {.count = 1, .reusable = true}, REDUCE(sym_type_descriptor, 2),
  [2467] = {.count = 1, .reusable = true}, SHIFT(1186),
  [2469] = {.count = 1, .reusable = true}, SHIFT(1187),
  [2471] = {.count = 1, .reusable = true}, SHIFT(1188),
  [2473] = {.count = 1, .reusable = false}, SHIFT(1188),
  [2475] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 3),
  [2477] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 3),
  [2479] = {.count = 1, .reusable = true}, SHIFT(1189),
  [2481] = {.count = 1, .reusable = false}, SHIFT(1189),
  [2483] = {.count = 1, .reusable = true}, SHIFT(1190),
  [2485] = {.count = 1, .reusable = false}, SHIFT(1190),
  [2487] = {.count = 1, .reusable = true}, SHIFT(1191),
  [2489] = {.count = 1, .reusable = false}, SHIFT(1191),
  [2491] = {.count = 1, .reusable = true}, SHIFT(1192),
  [2493] = {.count = 1, .reusable = false}, SHIFT(1192),
  [2495] = {.count = 1, .reusable = true}, SHIFT(1193),
  [2497] = {.count = 1, .reusable = false}, SHIFT(1193),
  [2499] = {.count = 1, .reusable = true}, SHIFT(1194),
  [2501] = {.count = 1, .reusable = false}, SHIFT(1194),
  [2503] = {.count = 1, .reusable = true}, SHIFT(1195),
  [2505] = {.count = 1, .reusable = false}, SHIFT(1195),
  [2507] = {.count = 1, .reusable = true}, SHIFT(1196),
  [2509] = {.count = 1, .reusable = false}, SHIFT(1196),
  [2511] = {.count = 1, .reusable = true}, SHIFT(1197),
  [2513] = {.count = 1, .reusable = false}, SHIFT(1197),
  [2515] = {.count = 1, .reusable = true}, SHIFT(1198),
  [2517] = {.count = 1, .reusable = false}, SHIFT(1198),
  [2519] = {.count = 1, .reusable = true}, SHIFT(1199),
  [2521] = {.count = 1, .reusable = false}, SHIFT(1199),
  [2523] = {.count = 1, .reusable = true}, SHIFT(1200),
  [2525] = {.count = 1, .reusable = false}, SHIFT(1200),
  [2527] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(546),
  [2530] = {.count = 1, .reusable = false}, SHIFT(1204),
  [2532] = {.count = 1, .reusable = true}, SHIFT(1205),
  [2534] = {.count = 1, .reusable = true}, SHIFT(1206),
  [2536] = {.count = 1, .reusable = false}, SHIFT(1207),
  [2538] = {.count = 2, .reusable = false}, REDUCE(aux_sym_type_definition_repeat1, 2), SHIFT_REPEAT(15),
  [2541] = {.count = 1, .reusable = true}, SHIFT(1208),
  [2543] = {.count = 1, .reusable = true}, SHIFT(1210),
  [2545] = {.count = 1, .reusable = true}, SHIFT(1211),
  [2547] = {.count = 1, .reusable = false}, SHIFT(1212),
  [2549] = {.count = 1, .reusable = false}, SHIFT(1213),
  [2551] = {.count = 1, .reusable = true}, SHIFT(1215),
  [2553] = {.count = 1, .reusable = true}, SHIFT(1214),
  [2555] = {.count = 1, .reusable = false}, SHIFT(1215),
  [2557] = {.count = 1, .reusable = true}, SHIFT(1216),
  [2559] = {.count = 1, .reusable = false}, SHIFT(1216),
  [2561] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_capture_specifier, 3),
  [2563] = {.count = 1, .reusable = false}, REDUCE(sym_lambda_capture_specifier, 3),
  [2565] = {.count = 1, .reusable = true}, SHIFT(1217),
  [2567] = {.count = 1, .reusable = false}, SHIFT(1217),
  [2569] = {.count = 1, .reusable = true}, SHIFT(1218),
  [2571] = {.count = 1, .reusable = false}, SHIFT(1218),
  [2573] = {.count = 1, .reusable = true}, SHIFT(1219),
  [2575] = {.count = 1, .reusable = false}, SHIFT(1219),
  [2577] = {.count = 1, .reusable = true}, SHIFT(1220),
  [2579] = {.count = 1, .reusable = false}, SHIFT(1220),
  [2581] = {.count = 1, .reusable = true}, SHIFT(1221),
  [2583] = {.count = 1, .reusable = false}, SHIFT(1221),
  [2585] = {.count = 1, .reusable = true}, SHIFT(1222),
  [2587] = {.count = 1, .reusable = false}, SHIFT(1222),
  [2589] = {.count = 1, .reusable = true}, SHIFT(1223),
  [2591] = {.count = 1, .reusable = false}, SHIFT(1223),
  [2593] = {.count = 1, .reusable = true}, SHIFT(1224),
  [2595] = {.count = 1, .reusable = false}, SHIFT(1224),
  [2597] = {.count = 1, .reusable = true}, SHIFT(1225),
  [2599] = {.count = 1, .reusable = false}, SHIFT(1225),
  [2601] = {.count = 1, .reusable = true}, SHIFT(1226),
  [2603] = {.count = 1, .reusable = false}, SHIFT(1226),
  [2605] = {.count = 1, .reusable = true}, SHIFT(1227),
  [2607] = {.count = 1, .reusable = false}, SHIFT(1227),
  [2609] = {.count = 1, .reusable = true}, SHIFT(1228),
  [2611] = {.count = 1, .reusable = true}, SHIFT(1231),
  [2613] = {.count = 1, .reusable = true}, REDUCE(sym_enumerator_list, 2),
  [2615] = {.count = 1, .reusable = false}, REDUCE(sym_enumerator_list, 2),
  [2617] = {.count = 1, .reusable = true}, REDUCE(sym_enumerator, 1),
  [2619] = {.count = 1, .reusable = true}, SHIFT(1232),
  [2621] = {.count = 1, .reusable = true}, SHIFT(1233),
  [2623] = {.count = 1, .reusable = true}, REDUCE(sym_enum_specifier, 3, .alias_sequence_id = 2),
  [2625] = {.count = 1, .reusable = false}, REDUCE(sym_enum_specifier, 3, .alias_sequence_id = 2),
  [2627] = {.count = 1, .reusable = false}, SHIFT(1235),
  [2629] = {.count = 1, .reusable = true}, SHIFT(1236),
  [2631] = {.count = 1, .reusable = false}, SHIFT(1237),
  [2633] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration_list, 2),
  [2635] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration_list, 2),
  [2637] = {.count = 1, .reusable = false}, SHIFT(1239),
  [2639] = {.count = 1, .reusable = false}, SHIFT(1242),
  [2641] = {.count = 1, .reusable = true}, SHIFT(1245),
  [2643] = {.count = 1, .reusable = false}, SHIFT(1247),
  [2645] = {.count = 1, .reusable = true}, SHIFT(1250),
  [2647] = {.count = 1, .reusable = false}, SHIFT(1255),
  [2649] = {.count = 1, .reusable = false}, SHIFT(1256),
  [2651] = {.count = 1, .reusable = false}, SHIFT(1258),
  [2653] = {.count = 1, .reusable = true}, SHIFT(1259),
  [2655] = {.count = 1, .reusable = true}, SHIFT(1260),
  [2657] = {.count = 1, .reusable = true}, SHIFT(1261),
  [2659] = {.count = 1, .reusable = false}, SHIFT(1262),
  [2661] = {.count = 1, .reusable = false}, SHIFT(1263),
  [2663] = {.count = 1, .reusable = true}, SHIFT(1263),
  [2665] = {.count = 1, .reusable = false}, SHIFT(1264),
  [2667] = {.count = 1, .reusable = true}, SHIFT(1265),
  [2669] = {.count = 1, .reusable = true}, SHIFT(1268),
  [2671] = {.count = 1, .reusable = true}, SHIFT(1269),
  [2673] = {.count = 1, .reusable = true}, SHIFT(1270),
  [2675] = {.count = 1, .reusable = true}, SHIFT(1274),
  [2677] = {.count = 1, .reusable = true}, SHIFT(1275),
  [2679] = {.count = 1, .reusable = false}, SHIFT(1278),
  [2681] = {.count = 1, .reusable = false}, SHIFT(1279),
  [2683] = {.count = 1, .reusable = true}, SHIFT(1280),
  [2685] = {.count = 1, .reusable = true}, REDUCE(sym_base_class_clause, 2, .alias_sequence_id = 2),
  [2687] = {.count = 1, .reusable = true}, SHIFT(1282),
  [2689] = {.count = 1, .reusable = true}, REDUCE(sym_base_class_clause, 2),
  [2691] = {.count = 1, .reusable = true}, SHIFT(1286),
  [2693] = {.count = 1, .reusable = true}, REDUCE(sym_struct_specifier, 3, .alias_sequence_id = 2),
  [2695] = {.count = 1, .reusable = false}, REDUCE(sym_struct_specifier, 3, .alias_sequence_id = 2),
  [2697] = {.count = 1, .reusable = true}, REDUCE(sym_struct_specifier, 3),
  [2699] = {.count = 1, .reusable = false}, REDUCE(sym_struct_specifier, 3),
  [2701] = {.count = 1, .reusable = true}, SHIFT(1290),
  [2703] = {.count = 1, .reusable = true}, REDUCE(sym_union_specifier, 3, .alias_sequence_id = 2),
  [2705] = {.count = 1, .reusable = false}, REDUCE(sym_union_specifier, 3, .alias_sequence_id = 2),
  [2707] = {.count = 1, .reusable = true}, REDUCE(sym_union_specifier, 3),
  [2709] = {.count = 1, .reusable = false}, REDUCE(sym_union_specifier, 3),
  [2711] = {.count = 1, .reusable = true}, SHIFT(1298),
  [2713] = {.count = 1, .reusable = true}, SHIFT(1297),
  [2715] = {.count = 1, .reusable = false}, SHIFT(1298),
  [2717] = {.count = 1, .reusable = true}, SHIFT(1300),
  [2719] = {.count = 1, .reusable = true}, SHIFT(1299),
  [2721] = {.count = 1, .reusable = false}, SHIFT(1300),
  [2723] = {.count = 1, .reusable = false}, SHIFT(1304),
  [2725] = {.count = 1, .reusable = false}, SHIFT(1302),
  [2727] = {.count = 1, .reusable = false}, SHIFT(1301),
  [2729] = {.count = 1, .reusable = false}, SHIFT(1305),
  [2731] = {.count = 1, .reusable = true}, SHIFT(1306),
  [2733] = {.count = 1, .reusable = false}, SHIFT(1307),
  [2735] = {.count = 1, .reusable = false}, SHIFT(1308),
  [2737] = {.count = 1, .reusable = true}, SHIFT(1309),
  [2739] = {.count = 1, .reusable = true}, SHIFT(1308),
  [2741] = {.count = 1, .reusable = false}, SHIFT(1310),
  [2743] = {.count = 1, .reusable = true}, SHIFT(1311),
  [2745] = {.count = 1, .reusable = true}, SHIFT(1312),
  [2747] = {.count = 1, .reusable = false}, SHIFT(1313),
  [2749] = {.count = 1, .reusable = false}, SHIFT(1314),
  [2751] = {.count = 1, .reusable = true}, SHIFT(1315),
  [2753] = {.count = 1, .reusable = false}, SHIFT(1316),
  [2755] = {.count = 1, .reusable = true}, SHIFT(1316),
  [2757] = {.count = 1, .reusable = false}, SHIFT(1317),
  [2759] = {.count = 1, .reusable = false}, SHIFT(1318),
  [2761] = {.count = 1, .reusable = true}, SHIFT(1320),
  [2763] = {.count = 1, .reusable = false}, SHIFT(1320),
  [2765] = {.count = 1, .reusable = true}, SHIFT(1321),
  [2767] = {.count = 1, .reusable = true}, REDUCE(sym_switch_statement, 3),
  [2769] = {.count = 1, .reusable = false}, REDUCE(sym_switch_statement, 3),
  [2771] = {.count = 1, .reusable = true}, SHIFT(1322),
  [2773] = {.count = 1, .reusable = false}, SHIFT(1324),
  [2775] = {.count = 1, .reusable = true}, SHIFT(1325),
  [2777] = {.count = 1, .reusable = false}, SHIFT(1326),
  [2779] = {.count = 1, .reusable = false}, SHIFT(1329),
  [2781] = {.count = 1, .reusable = false}, SHIFT(1332),
  [2783] = {.count = 1, .reusable = true}, SHIFT(1335),
  [2785] = {.count = 1, .reusable = false}, SHIFT(1337),
  [2787] = {.count = 1, .reusable = false}, SHIFT(1338),
  [2789] = {.count = 1, .reusable = true}, SHIFT(1340),
  [2791] = {.count = 1, .reusable = true}, SHIFT(1339),
  [2793] = {.count = 1, .reusable = false}, SHIFT(1340),
  [2795] = {.count = 1, .reusable = true}, SHIFT(1342),
  [2797] = {.count = 1, .reusable = true}, SHIFT(1341),
  [2799] = {.count = 1, .reusable = false}, SHIFT(1342),
  [2801] = {.count = 1, .reusable = true}, SHIFT(1344),
  [2803] = {.count = 1, .reusable = false}, SHIFT(1344),
  [2805] = {.count = 1, .reusable = true}, SHIFT(1345),
  [2807] = {.count = 1, .reusable = false}, SHIFT(1345),
  [2809] = {.count = 1, .reusable = true}, SHIFT(1347),
  [2811] = {.count = 1, .reusable = false}, SHIFT(1347),
  [2813] = {.count = 1, .reusable = true}, SHIFT(1348),
  [2815] = {.count = 1, .reusable = false}, SHIFT(1348),
  [2817] = {.count = 1, .reusable = true}, SHIFT(1349),
  [2819] = {.count = 1, .reusable = false}, SHIFT(1349),
  [2821] = {.count = 1, .reusable = true}, SHIFT(1350),
  [2823] = {.count = 1, .reusable = false}, SHIFT(1350),
  [2825] = {.count = 1, .reusable = true}, SHIFT(1351),
  [2827] = {.count = 1, .reusable = false}, SHIFT(1351),
  [2829] = {.count = 1, .reusable = true}, SHIFT(1352),
  [2831] = {.count = 1, .reusable = false}, SHIFT(1352),
  [2833] = {.count = 1, .reusable = true}, SHIFT(1353),
  [2835] = {.count = 1, .reusable = false}, SHIFT(1353),
  [2837] = {.count = 1, .reusable = true}, SHIFT(1354),
  [2839] = {.count = 1, .reusable = false}, SHIFT(1354),
  [2841] = {.count = 1, .reusable = true}, SHIFT(1355),
  [2843] = {.count = 1, .reusable = false}, SHIFT(1355),
  [2845] = {.count = 1, .reusable = true}, SHIFT(1356),
  [2847] = {.count = 1, .reusable = false}, SHIFT(1356),
  [2849] = {.count = 1, .reusable = true}, SHIFT(1359),
  [2851] = {.count = 1, .reusable = false}, SHIFT(1359),
  [2853] = {.count = 1, .reusable = true}, SHIFT(1358),
  [2855] = {.count = 1, .reusable = true}, SHIFT(1361),
  [2857] = {.count = 1, .reusable = false}, SHIFT(1363),
  [2859] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 3),
  [2861] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 3),
  [2863] = {.count = 1, .reusable = true}, SHIFT(1364),
  [2865] = {.count = 1, .reusable = true}, SHIFT(1365),
  [2867] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 3),
  [2869] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 3),
  [2871] = {.count = 1, .reusable = true}, SHIFT(1366),
  [2873] = {.count = 1, .reusable = true}, SHIFT(1367),
  [2875] = {.count = 1, .reusable = false}, SHIFT(1367),
  [2877] = {.count = 1, .reusable = true}, SHIFT(1368),
  [2879] = {.count = 1, .reusable = true}, SHIFT(1370),
  [2881] = {.count = 1, .reusable = false}, SHIFT(1371),
  [2883] = {.count = 1, .reusable = true}, SHIFT(1375),
  [2885] = {.count = 1, .reusable = true}, SHIFT(1377),
  [2887] = {.count = 1, .reusable = true}, SHIFT(1376),
  [2889] = {.count = 1, .reusable = false}, SHIFT(1377),
  [2891] = {.count = 1, .reusable = true}, SHIFT(1379),
  [2893] = {.count = 1, .reusable = true}, SHIFT(1380),
  [2895] = {.count = 1, .reusable = true}, SHIFT(1382),
  [2897] = {.count = 1, .reusable = true}, SHIFT(1384),
  [2899] = {.count = 1, .reusable = true}, SHIFT(1387),
  [2901] = {.count = 1, .reusable = true}, SHIFT(1386),
  [2903] = {.count = 1, .reusable = false}, SHIFT(1387),
  [2905] = {.count = 1, .reusable = true}, SHIFT(1388),
  [2907] = {.count = 1, .reusable = false}, SHIFT(1389),
  [2909] = {.count = 1, .reusable = true}, SHIFT(1389),
  [2911] = {.count = 1, .reusable = true}, SHIFT(1390),
  [2913] = {.count = 1, .reusable = true}, SHIFT(1392),
  [2915] = {.count = 1, .reusable = true}, SHIFT(1393),
  [2917] = {.count = 1, .reusable = true}, SHIFT(1394),
  [2919] = {.count = 1, .reusable = true}, REDUCE(sym_initializer_list, 2),
  [2921] = {.count = 1, .reusable = false}, REDUCE(sym_initializer_list, 2),
  [2923] = {.count = 1, .reusable = true}, SHIFT(1396),
  [2925] = {.count = 1, .reusable = false}, SHIFT(1396),
  [2927] = {.count = 1, .reusable = true}, SHIFT(1398),
  [2929] = {.count = 1, .reusable = true}, SHIFT(1397),
  [2931] = {.count = 1, .reusable = false}, SHIFT(1398),
  [2933] = {.count = 1, .reusable = true}, SHIFT(1399),
  [2935] = {.count = 1, .reusable = true}, SHIFT(1401),
  [2937] = {.count = 1, .reusable = true}, SHIFT(1400),
  [2939] = {.count = 1, .reusable = false}, SHIFT(1401),
  [2941] = {.count = 1, .reusable = false}, SHIFT(1405),
  [2943] = {.count = 1, .reusable = false}, SHIFT(1403),
  [2945] = {.count = 1, .reusable = false}, SHIFT(1402),
  [2947] = {.count = 1, .reusable = false}, SHIFT(1406),
  [2949] = {.count = 1, .reusable = true}, SHIFT(1407),
  [2951] = {.count = 1, .reusable = false}, SHIFT(1408),
  [2953] = {.count = 1, .reusable = false}, SHIFT(1409),
  [2955] = {.count = 1, .reusable = true}, SHIFT(1410),
  [2957] = {.count = 1, .reusable = true}, SHIFT(1409),
  [2959] = {.count = 1, .reusable = false}, SHIFT(1411),
  [2961] = {.count = 1, .reusable = true}, SHIFT(1412),
  [2963] = {.count = 1, .reusable = true}, SHIFT(1413),
  [2965] = {.count = 1, .reusable = false}, SHIFT(1414),
  [2967] = {.count = 1, .reusable = false}, SHIFT(1415),
  [2969] = {.count = 1, .reusable = true}, SHIFT(1416),
  [2971] = {.count = 1, .reusable = false}, SHIFT(1417),
  [2973] = {.count = 1, .reusable = true}, SHIFT(1417),
  [2975] = {.count = 1, .reusable = false}, SHIFT(1418),
  [2977] = {.count = 1, .reusable = false}, SHIFT(1419),
  [2979] = {.count = 1, .reusable = true}, SHIFT(1422),
  [2981] = {.count = 1, .reusable = true}, SHIFT(1423),
  [2983] = {.count = 1, .reusable = true}, SHIFT(1425),
  [2985] = {.count = 1, .reusable = true}, SHIFT(1427),
  [2987] = {.count = 1, .reusable = true}, SHIFT(1428),
  [2989] = {.count = 1, .reusable = false}, SHIFT(1429),
  [2991] = {.count = 1, .reusable = false}, SHIFT(1430),
  [2993] = {.count = 1, .reusable = true}, SHIFT(1432),
  [2995] = {.count = 1, .reusable = true}, SHIFT(1431),
  [2997] = {.count = 1, .reusable = false}, SHIFT(1432),
  [2999] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 3),
  [3001] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 3),
  [3003] = {.count = 1, .reusable = true}, SHIFT(1433),
  [3005] = {.count = 1, .reusable = false}, SHIFT(1433),
  [3007] = {.count = 1, .reusable = true}, SHIFT(1434),
  [3009] = {.count = 1, .reusable = false}, SHIFT(1434),
  [3011] = {.count = 1, .reusable = true}, SHIFT(1435),
  [3013] = {.count = 1, .reusable = false}, SHIFT(1435),
  [3015] = {.count = 1, .reusable = true}, SHIFT(1436),
  [3017] = {.count = 1, .reusable = false}, SHIFT(1436),
  [3019] = {.count = 1, .reusable = true}, SHIFT(1437),
  [3021] = {.count = 1, .reusable = false}, SHIFT(1437),
  [3023] = {.count = 1, .reusable = true}, SHIFT(1438),
  [3025] = {.count = 1, .reusable = false}, SHIFT(1438),
  [3027] = {.count = 1, .reusable = true}, SHIFT(1439),
  [3029] = {.count = 1, .reusable = false}, SHIFT(1439),
  [3031] = {.count = 1, .reusable = true}, SHIFT(1440),
  [3033] = {.count = 1, .reusable = false}, SHIFT(1440),
  [3035] = {.count = 1, .reusable = true}, SHIFT(1441),
  [3037] = {.count = 1, .reusable = false}, SHIFT(1441),
  [3039] = {.count = 1, .reusable = true}, SHIFT(1442),
  [3041] = {.count = 1, .reusable = false}, SHIFT(1442),
  [3043] = {.count = 1, .reusable = true}, SHIFT(1443),
  [3045] = {.count = 1, .reusable = false}, SHIFT(1443),
  [3047] = {.count = 1, .reusable = true}, REDUCE(sym_goto_statement, 3, .alias_sequence_id = 4),
  [3049] = {.count = 1, .reusable = false}, REDUCE(sym_goto_statement, 3, .alias_sequence_id = 4),
  [3051] = {.count = 1, .reusable = false}, REDUCE(sym_destructor_name, 2),
  [3053] = {.count = 1, .reusable = false}, SHIFT(1445),
  [3055] = {.count = 1, .reusable = false}, SHIFT(1446),
  [3057] = {.count = 1, .reusable = true}, SHIFT(1447),
  [3059] = {.count = 1, .reusable = true}, REDUCE(sym_char_literal, 3),
  [3061] = {.count = 1, .reusable = false}, REDUCE(sym_char_literal, 3),
  [3063] = {.count = 1, .reusable = true}, REDUCE(sym_string_literal, 3),
  [3065] = {.count = 1, .reusable = false}, REDUCE(sym_string_literal, 3),
  [3067] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_literal_repeat1, 2),
  [3069] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(761),
  [3072] = {.count = 1, .reusable = true}, REDUCE(sym_labeled_statement, 3, .alias_sequence_id = 5),
  [3074] = {.count = 1, .reusable = false}, REDUCE(sym_labeled_statement, 3, .alias_sequence_id = 5),
  [3076] = {.count = 1, .reusable = true}, SHIFT(1448),
  [3078] = {.count = 1, .reusable = false}, SHIFT(1448),
  [3080] = {.count = 1, .reusable = true}, SHIFT(1453),
  [3082] = {.count = 1, .reusable = false}, SHIFT(1453),
  [3084] = {.count = 1, .reusable = false}, SHIFT(1451),
  [3086] = {.count = 1, .reusable = true}, SHIFT(1452),
  [3088] = {.count = 1, .reusable = true}, SHIFT(1457),
  [3090] = {.count = 1, .reusable = false}, SHIFT(1457),
  [3092] = {.count = 1, .reusable = true}, SHIFT(1458),
  [3094] = {.count = 1, .reusable = false}, SHIFT(1458),
  [3096] = {.count = 1, .reusable = true}, SHIFT(1459),
  [3098] = {.count = 1, .reusable = false}, SHIFT(1459),
  [3100] = {.count = 1, .reusable = true}, SHIFT(1461),
  [3102] = {.count = 1, .reusable = true}, SHIFT(1460),
  [3104] = {.count = 1, .reusable = false}, SHIFT(1461),
  [3106] = {.count = 1, .reusable = false}, SHIFT(1462),
  [3108] = {.count = 1, .reusable = true}, SHIFT(1462),
  [3110] = {.count = 1, .reusable = false}, SHIFT(1463),
  [3112] = {.count = 1, .reusable = true}, SHIFT(1464),
  [3114] = {.count = 1, .reusable = true}, SHIFT(1465),
  [3116] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(1466),
  [3119] = {.count = 1, .reusable = true}, SHIFT(1467),
  [3121] = {.count = 1, .reusable = true}, REDUCE(sym_template_argument_list, 2),
  [3123] = {.count = 1, .reusable = false}, REDUCE(sym_template_argument_list, 2),
  [3125] = {.count = 1, .reusable = true}, SHIFT(1471),
  [3127] = {.count = 1, .reusable = true}, SHIFT(1470),
  [3129] = {.count = 1, .reusable = false}, SHIFT(1471),
  [3131] = {.count = 1, .reusable = false}, SHIFT(1484),
  [3133] = {.count = 1, .reusable = false}, SHIFT(1479),
  [3135] = {.count = 1, .reusable = false}, SHIFT(1472),
  [3137] = {.count = 1, .reusable = false}, SHIFT(1473),
  [3139] = {.count = 1, .reusable = false}, SHIFT(1474),
  [3141] = {.count = 1, .reusable = false}, SHIFT(1475),
  [3143] = {.count = 1, .reusable = false}, SHIFT(1476),
  [3145] = {.count = 1, .reusable = false}, SHIFT(1477),
  [3147] = {.count = 1, .reusable = true}, SHIFT(1478),
  [3149] = {.count = 1, .reusable = true}, SHIFT(1485),
  [3151] = {.count = 1, .reusable = false}, SHIFT(1486),
  [3153] = {.count = 1, .reusable = false}, SHIFT(1487),
  [3155] = {.count = 1, .reusable = true}, SHIFT(1488),
  [3157] = {.count = 1, .reusable = true}, SHIFT(1489),
  [3159] = {.count = 1, .reusable = false}, SHIFT(1490),
  [3161] = {.count = 1, .reusable = true}, SHIFT(1490),
  [3163] = {.count = 1, .reusable = true}, SHIFT(1493),
  [3165] = {.count = 1, .reusable = true}, SHIFT(1494),
  [3167] = {.count = 1, .reusable = false}, SHIFT(1495),
  [3169] = {.count = 1, .reusable = true}, SHIFT(1496),
  [3171] = {.count = 1, .reusable = false}, SHIFT(1497),
  [3173] = {.count = 1, .reusable = true}, SHIFT(1498),
  [3175] = {.count = 1, .reusable = true}, SHIFT(1497),
  [3177] = {.count = 1, .reusable = false}, SHIFT(1499),
  [3179] = {.count = 1, .reusable = true}, SHIFT(1500),
  [3181] = {.count = 1, .reusable = true}, SHIFT(1501),
  [3183] = {.count = 1, .reusable = false}, SHIFT(1502),
  [3185] = {.count = 1, .reusable = false}, SHIFT(1503),
  [3187] = {.count = 1, .reusable = true}, SHIFT(1504),
  [3189] = {.count = 1, .reusable = false}, SHIFT(1505),
  [3191] = {.count = 1, .reusable = true}, SHIFT(1505),
  [3193] = {.count = 1, .reusable = false}, SHIFT(1506),
  [3195] = {.count = 1, .reusable = false}, SHIFT(1507),
  [3197] = {.count = 1, .reusable = true}, SHIFT(1508),
  [3199] = {.count = 1, .reusable = true}, SHIFT(1509),
  [3201] = {.count = 1, .reusable = true}, SHIFT(1510),
  [3203] = {.count = 1, .reusable = true}, SHIFT(1513),
  [3205] = {.count = 1, .reusable = true}, SHIFT(1516),
  [3207] = {.count = 1, .reusable = false}, SHIFT(1520),
  [3209] = {.count = 1, .reusable = false}, SHIFT(1521),
  [3211] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_identifier, 3, .alias_sequence_id = 6),
  [3213] = {.count = 2, .reusable = true}, REDUCE(sym_scoped_identifier, 3, .alias_sequence_id = 6), REDUCE(sym_scoped_type_identifier, 3, .alias_sequence_id = 7),
  [3216] = {.count = 1, .reusable = false}, REDUCE(sym_scoped_type_identifier, 3, .alias_sequence_id = 7),
  [3218] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_type_identifier, 3, .alias_sequence_id = 7),
  [3220] = {.count = 2, .reusable = false}, REDUCE(sym_scoped_identifier, 3, .alias_sequence_id = 6), REDUCE(sym_scoped_type_identifier, 3, .alias_sequence_id = 7),
  [3223] = {.count = 1, .reusable = false}, REDUCE(sym_scoped_identifier, 3, .alias_sequence_id = 6),
  [3225] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_namespace_identifier, 3, .alias_sequence_id = 8),
  [3227] = {.count = 1, .reusable = true}, REDUCE(sym_class_specifier, 3, .alias_sequence_id = 2),
  [3229] = {.count = 1, .reusable = false}, REDUCE(sym_class_specifier, 3, .alias_sequence_id = 2),
  [3231] = {.count = 1, .reusable = true}, REDUCE(sym_class_specifier, 3),
  [3233] = {.count = 1, .reusable = false}, REDUCE(sym_class_specifier, 3),
  [3235] = {.count = 1, .reusable = true}, SHIFT(1526),
  [3237] = {.count = 1, .reusable = false}, SHIFT(1527),
  [3239] = {.count = 1, .reusable = false}, SHIFT(1528),
  [3241] = {.count = 1, .reusable = false}, SHIFT(1529),
  [3243] = {.count = 1, .reusable = false}, REDUCE(sym_template_parameter_list, 2),
  [3245] = {.count = 1, .reusable = true}, REDUCE(sym_template_parameter_list, 2),
  [3247] = {.count = 1, .reusable = true}, REDUCE(sym_parameter_declaration, 1),
  [3249] = {.count = 1, .reusable = true}, SHIFT(1530),
  [3251] = {.count = 1, .reusable = true}, SHIFT(1531),
  [3253] = {.count = 1, .reusable = false}, SHIFT(1532),
  [3255] = {.count = 1, .reusable = true}, SHIFT(1532),
  [3257] = {.count = 1, .reusable = false}, SHIFT(1533),
  [3259] = {.count = 1, .reusable = true}, SHIFT(1534),
  [3261] = {.count = 1, .reusable = true}, SHIFT(1535),
  [3263] = {.count = 1, .reusable = true}, SHIFT(1540),
  [3265] = {.count = 1, .reusable = true}, SHIFT(1542),
  [3267] = {.count = 1, .reusable = true}, SHIFT(1543),
  [3269] = {.count = 1, .reusable = false}, SHIFT(1547),
  [3271] = {.count = 1, .reusable = false}, SHIFT(1546),
  [3273] = {.count = 1, .reusable = false}, SHIFT(1545),
  [3275] = {.count = 1, .reusable = false}, SHIFT(1548),
  [3277] = {.count = 1, .reusable = false}, SHIFT(1549),
  [3279] = {.count = 1, .reusable = true}, SHIFT(1550),
  [3281] = {.count = 1, .reusable = true}, REDUCE(sym_template_instantiation, 3),
  [3283] = {.count = 1, .reusable = false}, REDUCE(sym_template_instantiation, 3),
  [3285] = {.count = 1, .reusable = true}, SHIFT(1551),
  [3287] = {.count = 1, .reusable = true}, SHIFT(1552),
  [3289] = {.count = 1, .reusable = true}, REDUCE(sym_template_declaration, 3),
  [3291] = {.count = 1, .reusable = false}, REDUCE(sym_template_declaration, 3),
  [3293] = {.count = 1, .reusable = false}, SHIFT(1555),
  [3295] = {.count = 1, .reusable = false}, SHIFT(1556),
  [3297] = {.count = 1, .reusable = false}, SHIFT(1557),
  [3299] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(822),
  [3302] = {.count = 1, .reusable = true}, SHIFT(1559),
  [3304] = {.count = 1, .reusable = false}, SHIFT(1559),
  [3306] = {.count = 1, .reusable = true}, REDUCE(sym_declaration_list, 2),
  [3308] = {.count = 1, .reusable = false}, REDUCE(sym_declaration_list, 2),
  [3310] = {.count = 1, .reusable = true}, SHIFT(1560),
  [3312] = {.count = 1, .reusable = true}, SHIFT(1561),
  [3314] = {.count = 1, .reusable = true}, SHIFT(1563),
  [3316] = {.count = 1, .reusable = false}, SHIFT(1563),
  [3318] = {.count = 1, .reusable = true}, SHIFT(1564),
  [3320] = {.count = 1, .reusable = true}, SHIFT(1566),
  [3322] = {.count = 1, .reusable = false}, SHIFT(1567),
  [3324] = {.count = 1, .reusable = true}, SHIFT(1569),
  [3326] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_definition, 3),
  [3328] = {.count = 1, .reusable = false}, REDUCE(sym_namespace_definition, 3),
  [3330] = {.count = 1, .reusable = true}, REDUCE(sym_using_declaration, 3),
  [3332] = {.count = 1, .reusable = false}, REDUCE(sym_using_declaration, 3),
  [3334] = {.count = 1, .reusable = false}, SHIFT(1575),
  [3336] = {.count = 1, .reusable = false}, SHIFT(1572),
  [3338] = {.count = 1, .reusable = false}, SHIFT(1571),
  [3340] = {.count = 1, .reusable = false}, SHIFT(1576),
  [3342] = {.count = 1, .reusable = true}, SHIFT(1577),
  [3344] = {.count = 1, .reusable = false}, SHIFT(1578),
  [3346] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 3),
  [3348] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 3),
  [3350] = {.count = 1, .reusable = false}, SHIFT(842),
  [3352] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 2),
  [3354] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 2),
  [3356] = {.count = 1, .reusable = true}, SHIFT(1581),
  [3358] = {.count = 1, .reusable = true}, SHIFT(1582),
  [3360] = {.count = 1, .reusable = true}, SHIFT(1584),
  [3362] = {.count = 1, .reusable = true}, SHIFT(1585),
  [3364] = {.count = 1, .reusable = true}, SHIFT(1588),
  [3366] = {.count = 1, .reusable = true}, SHIFT(1602),
  [3368] = {.count = 1, .reusable = true}, SHIFT(1609),
  [3370] = {.count = 1, .reusable = false}, SHIFT(1609),
  [3372] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 3),
  [3374] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 3),
  [3376] = {.count = 1, .reusable = true}, SHIFT(1612),
  [3378] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(881),
  [3381] = {.count = 1, .reusable = true}, SHIFT(1613),
  [3383] = {.count = 1, .reusable = true}, REDUCE(sym_delete_expression, 3),
  [3385] = {.count = 1, .reusable = false}, REDUCE(sym_delete_expression, 3),
  [3387] = {.count = 1, .reusable = true}, SHIFT(1614),
  [3389] = {.count = 1, .reusable = true}, SHIFT(1615),
  [3391] = {.count = 1, .reusable = true}, SHIFT(1616),
  [3393] = {.count = 1, .reusable = true}, REDUCE(sym_structured_binding_reference_declarator, 2),
  [3395] = {.count = 1, .reusable = true}, SHIFT(1618),
  [3397] = {.count = 1, .reusable = true}, REDUCE(sym_declaration, 3),
  [3399] = {.count = 1, .reusable = false}, REDUCE(sym_declaration, 3),
  [3401] = {.count = 1, .reusable = true}, SHIFT(1631),
  [3403] = {.count = 1, .reusable = true}, SHIFT(1620),
  [3405] = {.count = 1, .reusable = true}, SHIFT(1621),
  [3407] = {.count = 1, .reusable = true}, SHIFT(1622),
  [3409] = {.count = 1, .reusable = true}, SHIFT(1623),
  [3411] = {.count = 1, .reusable = true}, SHIFT(1624),
  [3413] = {.count = 1, .reusable = true}, SHIFT(1625),
  [3415] = {.count = 1, .reusable = false}, SHIFT(1626),
  [3417] = {.count = 1, .reusable = true}, SHIFT(1626),
  [3419] = {.count = 1, .reusable = false}, SHIFT(1627),
  [3421] = {.count = 1, .reusable = false}, SHIFT(1631),
  [3423] = {.count = 1, .reusable = false}, SHIFT(1628),
  [3425] = {.count = 1, .reusable = false}, SHIFT(1629),
  [3427] = {.count = 1, .reusable = true}, SHIFT(1630),
  [3429] = {.count = 1, .reusable = true}, SHIFT(1633),
  [3431] = {.count = 1, .reusable = false}, SHIFT(1634),
  [3433] = {.count = 1, .reusable = true}, SHIFT(1635),
  [3435] = {.count = 1, .reusable = true}, SHIFT(1638),
  [3437] = {.count = 1, .reusable = false}, SHIFT(1638),
  [3439] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 3),
  [3441] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 3),
  [3443] = {.count = 1, .reusable = true}, SHIFT(1640),
  [3445] = {.count = 1, .reusable = true}, SHIFT(1641),
  [3447] = {.count = 1, .reusable = true}, REDUCE(sym_init_declarator, 2),
  [3449] = {.count = 1, .reusable = true}, SHIFT(1642),
  [3451] = {.count = 1, .reusable = true}, SHIFT(1644),
  [3453] = {.count = 1, .reusable = false}, SHIFT(1644),
  [3455] = {.count = 1, .reusable = true}, SHIFT(1646),
  [3457] = {.count = 1, .reusable = true}, SHIFT(1647),
  [3459] = {.count = 1, .reusable = true}, SHIFT(1648),
  [3461] = {.count = 1, .reusable = true}, REDUCE(sym_parameter_list, 2),
  [3463] = {.count = 1, .reusable = false}, REDUCE(sym_parameter_list, 2),
  [3465] = {.count = 1, .reusable = true}, SHIFT(1650),
  [3467] = {.count = 1, .reusable = false}, SHIFT(1651),
  [3469] = {.count = 1, .reusable = true}, SHIFT(1651),
  [3471] = {.count = 1, .reusable = true}, SHIFT(1652),
  [3473] = {.count = 1, .reusable = false}, SHIFT(1656),
  [3475] = {.count = 1, .reusable = false}, SHIFT(1657),
  [3477] = {.count = 1, .reusable = true}, SHIFT(1659),
  [3479] = {.count = 1, .reusable = true}, REDUCE(sym_array_declarator, 3),
  [3481] = {.count = 1, .reusable = true}, SHIFT(1661),
  [3483] = {.count = 1, .reusable = true}, SHIFT(1660),
  [3485] = {.count = 1, .reusable = false}, SHIFT(1661),
  [3487] = {.count = 1, .reusable = true}, SHIFT(1663),
  [3489] = {.count = 1, .reusable = true}, SHIFT(1662),
  [3491] = {.count = 1, .reusable = false}, SHIFT(1663),
  [3493] = {.count = 1, .reusable = false}, SHIFT(1667),
  [3495] = {.count = 1, .reusable = false}, SHIFT(1665),
  [3497] = {.count = 1, .reusable = false}, SHIFT(1664),
  [3499] = {.count = 1, .reusable = false}, SHIFT(1668),
  [3501] = {.count = 1, .reusable = false}, SHIFT(1669),
  [3503] = {.count = 1, .reusable = false}, SHIFT(1670),
  [3505] = {.count = 1, .reusable = true}, SHIFT(1671),
  [3507] = {.count = 1, .reusable = true}, SHIFT(1670),
  [3509] = {.count = 1, .reusable = false}, SHIFT(1672),
  [3511] = {.count = 1, .reusable = true}, SHIFT(1673),
  [3513] = {.count = 1, .reusable = true}, SHIFT(1674),
  [3515] = {.count = 1, .reusable = false}, SHIFT(1675),
  [3517] = {.count = 1, .reusable = false}, SHIFT(1676),
  [3519] = {.count = 1, .reusable = true}, SHIFT(1677),
  [3521] = {.count = 1, .reusable = false}, SHIFT(1678),
  [3523] = {.count = 1, .reusable = true}, SHIFT(1678),
  [3525] = {.count = 1, .reusable = false}, SHIFT(1679),
  [3527] = {.count = 1, .reusable = false}, SHIFT(1680),
  [3529] = {.count = 1, .reusable = true}, SHIFT(1683),
  [3531] = {.count = 1, .reusable = true}, SHIFT(1682),
  [3533] = {.count = 1, .reusable = false}, SHIFT(1683),
  [3535] = {.count = 1, .reusable = false}, SHIFT(1692),
  [3537] = {.count = 1, .reusable = false}, SHIFT(1690),
  [3539] = {.count = 1, .reusable = false}, SHIFT(1685),
  [3541] = {.count = 1, .reusable = false}, SHIFT(1686),
  [3543] = {.count = 1, .reusable = false}, SHIFT(1687),
  [3545] = {.count = 1, .reusable = false}, SHIFT(1688),
  [3547] = {.count = 1, .reusable = false}, SHIFT(1689),
  [3549] = {.count = 1, .reusable = true}, REDUCE(sym_function_declarator, 3),
  [3551] = {.count = 1, .reusable = true}, SHIFT(1693),
  [3553] = {.count = 1, .reusable = true}, SHIFT(1694),
  [3555] = {.count = 1, .reusable = true}, SHIFT(1695),
  [3557] = {.count = 1, .reusable = true}, SHIFT(1696),
  [3559] = {.count = 1, .reusable = false}, SHIFT(1698),
  [3561] = {.count = 1, .reusable = true}, SHIFT(1699),
  [3563] = {.count = 1, .reusable = true}, SHIFT(1700),
  [3565] = {.count = 1, .reusable = true}, REDUCE(sym_field_initializer_list, 2),
  [3567] = {.count = 1, .reusable = true}, SHIFT(1702),
  [3569] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_or_destructor_definition, 3),
  [3571] = {.count = 1, .reusable = false}, REDUCE(sym_constructor_or_destructor_definition, 3),
  [3573] = {.count = 1, .reusable = true}, REDUCE(sym_comma_expression, 3),
  [3575] = {.count = 1, .reusable = true}, REDUCE(sym_math_expression, 3),
  [3577] = {.count = 1, .reusable = false}, REDUCE(sym_math_expression, 3),
  [3579] = {.count = 1, .reusable = true}, SHIFT(1704),
  [3581] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3),
  [3583] = {.count = 1, .reusable = true}, SHIFT(1705),
  [3585] = {.count = 1, .reusable = true}, REDUCE(sym_bitwise_expression, 3),
  [3587] = {.count = 1, .reusable = false}, REDUCE(sym_bitwise_expression, 3),
  [3589] = {.count = 1, .reusable = true}, REDUCE(sym_logical_expression, 3),
  [3591] = {.count = 1, .reusable = false}, REDUCE(sym_logical_expression, 3),
  [3593] = {.count = 1, .reusable = true}, REDUCE(sym_equality_expression, 3),
  [3595] = {.count = 1, .reusable = false}, REDUCE(sym_equality_expression, 3),
  [3597] = {.count = 1, .reusable = true}, REDUCE(sym_relational_expression, 3),
  [3599] = {.count = 1, .reusable = false}, REDUCE(sym_relational_expression, 3),
  [3601] = {.count = 1, .reusable = true}, REDUCE(sym_shift_expression, 3),
  [3603] = {.count = 1, .reusable = false}, REDUCE(sym_shift_expression, 3),
  [3605] = {.count = 1, .reusable = true}, REDUCE(sym_field_expression, 3, .alias_sequence_id = 9),
  [3607] = {.count = 1, .reusable = false}, REDUCE(sym_field_expression, 3, .alias_sequence_id = 9),
  [3609] = {.count = 2, .reusable = false}, REDUCE(sym_field_expression, 3, .alias_sequence_id = 9), SHIFT(260),
  [3612] = {.count = 1, .reusable = true}, SHIFT(1706),
  [3614] = {.count = 1, .reusable = false}, SHIFT(1708),
  [3616] = {.count = 1, .reusable = true}, SHIFT(1709),
  [3618] = {.count = 1, .reusable = true}, REDUCE(sym_field_expression, 3),
  [3620] = {.count = 1, .reusable = false}, REDUCE(sym_field_expression, 3),
  [3622] = {.count = 1, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [3624] = {.count = 1, .reusable = false}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [3626] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(37),
  [3629] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_identifier, 3),
  [3631] = {.count = 2, .reusable = true}, REDUCE(sym_scoped_identifier, 3), REDUCE(sym_scoped_type_identifier, 3, .alias_sequence_id = 10),
  [3634] = {.count = 1, .reusable = false}, REDUCE(sym_scoped_type_identifier, 3, .alias_sequence_id = 10),
  [3636] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_type_identifier, 3, .alias_sequence_id = 10),
  [3638] = {.count = 2, .reusable = false}, REDUCE(sym_scoped_identifier, 3), REDUCE(sym_scoped_type_identifier, 3, .alias_sequence_id = 10),
  [3641] = {.count = 1, .reusable = false}, REDUCE(sym_scoped_identifier, 3),
  [3643] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_namespace_identifier, 3, .alias_sequence_id = 11),
  [3645] = {.count = 1, .reusable = true}, SHIFT(1711),
  [3647] = {.count = 1, .reusable = true}, SHIFT(1713),
  [3649] = {.count = 1, .reusable = true}, SHIFT(1714),
  [3651] = {.count = 1, .reusable = true}, SHIFT(1716),
  [3653] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_array_declarator, 2),
  [3655] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_array_declarator, 2),
  [3657] = {.count = 1, .reusable = true}, SHIFT(1718),
  [3659] = {.count = 1, .reusable = true}, SHIFT(1717),
  [3661] = {.count = 1, .reusable = false}, SHIFT(1718),
  [3663] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_function_declarator, 2),
  [3665] = {.count = 1, .reusable = true}, SHIFT(1721),
  [3667] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_expression, 3),
  [3669] = {.count = 1, .reusable = false}, REDUCE(sym_lambda_expression, 3),
  [3671] = {.count = 1, .reusable = false}, SHIFT(1728),
  [3673] = {.count = 1, .reusable = false}, SHIFT(1727),
  [3675] = {.count = 1, .reusable = false}, SHIFT(1722),
  [3677] = {.count = 1, .reusable = false}, SHIFT(1723),
  [3679] = {.count = 1, .reusable = false}, SHIFT(1724),
  [3681] = {.count = 1, .reusable = false}, SHIFT(1725),
  [3683] = {.count = 1, .reusable = false}, SHIFT(1726),
  [3685] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_function_declarator, 2),
  [3687] = {.count = 1, .reusable = true}, SHIFT(1729),
  [3689] = {.count = 1, .reusable = true}, SHIFT(1730),
  [3691] = {.count = 1, .reusable = true}, SHIFT(1732),
  [3693] = {.count = 1, .reusable = false}, SHIFT(1734),
  [3695] = {.count = 1, .reusable = true}, REDUCE(sym__declaration_specifiers, 3),
  [3697] = {.count = 1, .reusable = false}, REDUCE(sym__declaration_specifiers, 3),
  [3699] = {.count = 1, .reusable = false}, SHIFT(1736),
  [3701] = {.count = 1, .reusable = true}, SHIFT(1737),
  [3703] = {.count = 1, .reusable = true}, SHIFT(1738),
  [3705] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_params, 2),
  [3707] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_def, 4),
  [3709] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_def, 4),
  [3711] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_function_def, 4),
  [3713] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_function_def, 4),
  [3715] = {.count = 1, .reusable = true}, SHIFT(1740),
  [3717] = {.count = 1, .reusable = false}, SHIFT(1741),
  [3719] = {.count = 1, .reusable = true}, SHIFT(1742),
  [3721] = {.count = 1, .reusable = false}, SHIFT(1743),
  [3723] = {.count = 1, .reusable = false}, SHIFT(1744),
  [3725] = {.count = 1, .reusable = false}, SHIFT(1746),
  [3727] = {.count = 1, .reusable = false}, SHIFT(1749),
  [3729] = {.count = 1, .reusable = true}, SHIFT(1752),
  [3731] = {.count = 1, .reusable = true}, SHIFT(1753),
  [3733] = {.count = 1, .reusable = true}, SHIFT(1754),
  [3735] = {.count = 1, .reusable = false}, SHIFT(1755),
  [3737] = {.count = 1, .reusable = true}, SHIFT(1756),
  [3739] = {.count = 1, .reusable = false}, SHIFT(1757),
  [3741] = {.count = 1, .reusable = false}, SHIFT(1758),
  [3743] = {.count = 1, .reusable = false}, SHIFT(1759),
  [3745] = {.count = 1, .reusable = true}, SHIFT(1762),
  [3747] = {.count = 1, .reusable = true}, SHIFT(1764),
  [3749] = {.count = 1, .reusable = true}, SHIFT(1765),
  [3751] = {.count = 1, .reusable = true}, SHIFT(1767),
  [3753] = {.count = 1, .reusable = false}, SHIFT(1767),
  [3755] = {.count = 1, .reusable = true}, SHIFT(1768),
  [3757] = {.count = 1, .reusable = true}, SHIFT(1771),
  [3759] = {.count = 1, .reusable = true}, SHIFT(1773),
  [3761] = {.count = 1, .reusable = true}, SHIFT(1772),
  [3763] = {.count = 1, .reusable = false}, SHIFT(1773),
  [3765] = {.count = 1, .reusable = true}, SHIFT(1775),
  [3767] = {.count = 1, .reusable = true}, SHIFT(1776),
  [3769] = {.count = 1, .reusable = true}, SHIFT(1777),
  [3771] = {.count = 1, .reusable = false}, SHIFT(1778),
  [3773] = {.count = 1, .reusable = true}, SHIFT(1780),
  [3775] = {.count = 1, .reusable = true}, SHIFT(1782),
  [3777] = {.count = 1, .reusable = true}, SHIFT(1783),
  [3779] = {.count = 1, .reusable = false}, SHIFT(1785),
  [3781] = {.count = 1, .reusable = false}, SHIFT(1786),
  [3783] = {.count = 1, .reusable = true}, SHIFT(1789),
  [3785] = {.count = 1, .reusable = true}, SHIFT(1790),
  [3787] = {.count = 1, .reusable = true}, SHIFT(1793),
  [3789] = {.count = 1, .reusable = true}, SHIFT(1796),
  [3791] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_else, 2),
  [3793] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_elif, 2),
  [3795] = {.count = 1, .reusable = true}, SHIFT(1801),
  [3797] = {.count = 1, .reusable = false}, SHIFT(1803),
  [3799] = {.count = 1, .reusable = true}, SHIFT(1806),
  [3801] = {.count = 1, .reusable = true}, SHIFT(1807),
  [3803] = {.count = 1, .reusable = false}, SHIFT(1807),
  [3805] = {.count = 1, .reusable = true}, SHIFT(1808),
  [3807] = {.count = 1, .reusable = false}, SHIFT(1809),
  [3809] = {.count = 1, .reusable = true}, SHIFT(1811),
  [3811] = {.count = 1, .reusable = false}, SHIFT(1812),
  [3813] = {.count = 1, .reusable = true}, SHIFT(1816),
  [3815] = {.count = 1, .reusable = true}, SHIFT(1818),
  [3817] = {.count = 1, .reusable = true}, SHIFT(1817),
  [3819] = {.count = 1, .reusable = false}, SHIFT(1818),
  [3821] = {.count = 1, .reusable = true}, SHIFT(1820),
  [3823] = {.count = 1, .reusable = true}, SHIFT(1821),
  [3825] = {.count = 1, .reusable = true}, SHIFT(1823),
  [3827] = {.count = 1, .reusable = true}, SHIFT(1824),
  [3829] = {.count = 1, .reusable = true}, SHIFT(1827),
  [3831] = {.count = 1, .reusable = true}, SHIFT(1830),
  [3833] = {.count = 1, .reusable = true}, SHIFT(1831),
  [3835] = {.count = 1, .reusable = true}, SHIFT(1832),
  [3837] = {.count = 1, .reusable = true}, SHIFT(1834),
  [3839] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if, 4),
  [3841] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if, 4),
  [3843] = {.count = 1, .reusable = true}, SHIFT(1836),
  [3845] = {.count = 1, .reusable = true}, SHIFT(1837),
  [3847] = {.count = 1, .reusable = true}, SHIFT(1840),
  [3849] = {.count = 1, .reusable = true}, SHIFT(1842),
  [3851] = {.count = 1, .reusable = true}, SHIFT(1843),
  [3853] = {.count = 1, .reusable = true}, SHIFT(1845),
  [3855] = {.count = 2, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(411),
  [3858] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(380),
  [3861] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(381),
  [3864] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(382),
  [3867] = {.count = 1, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2),
  [3869] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(384),
  [3872] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(387),
  [3875] = {.count = 2, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(388),
  [3878] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(389),
  [3881] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(390),
  [3884] = {.count = 2, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(391),
  [3887] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(392),
  [3890] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(393),
  [3893] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(394),
  [3896] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(395),
  [3899] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(396),
  [3902] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(397),
  [3905] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(398),
  [3908] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(399),
  [3911] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(400),
  [3914] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(401),
  [3917] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(402),
  [3920] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(411),
  [3923] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(403),
  [3926] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(404),
  [3929] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(405),
  [3932] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(406),
  [3935] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(407),
  [3938] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef, 4),
  [3940] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef, 4),
  [3942] = {.count = 1, .reusable = true}, SHIFT(1847),
  [3944] = {.count = 1, .reusable = true}, SHIFT(1848),
  [3946] = {.count = 1, .reusable = true}, SHIFT(1849),
  [3948] = {.count = 1, .reusable = true}, SHIFT(1851),
  [3950] = {.count = 1, .reusable = true}, SHIFT(1860),
  [3952] = {.count = 1, .reusable = true}, SHIFT(1862),
  [3954] = {.count = 1, .reusable = true}, SHIFT(1869),
  [3956] = {.count = 1, .reusable = true}, REDUCE(sym_pointer_type_declarator, 2, .dynamic_precedence = 1),
  [3958] = {.count = 1, .reusable = true}, REDUCE(sym_type_definition, 4),
  [3960] = {.count = 1, .reusable = false}, REDUCE(sym_type_definition, 4),
  [3962] = {.count = 1, .reusable = true}, SHIFT(1874),
  [3964] = {.count = 1, .reusable = true}, SHIFT(1872),
  [3966] = {.count = 1, .reusable = true}, SHIFT(1873),
  [3968] = {.count = 1, .reusable = false}, SHIFT(1874),
  [3970] = {.count = 1, .reusable = true}, REDUCE(sym_function_type_declarator, 2),
  [3972] = {.count = 1, .reusable = true}, SHIFT(1876),
  [3974] = {.count = 1, .reusable = false}, SHIFT(1877),
  [3976] = {.count = 1, .reusable = true}, SHIFT(1878),
  [3978] = {.count = 1, .reusable = false}, SHIFT(1879),
  [3980] = {.count = 1, .reusable = false}, SHIFT(1880),
  [3982] = {.count = 1, .reusable = true}, SHIFT(1881),
  [3984] = {.count = 1, .reusable = true}, SHIFT(1882),
  [3986] = {.count = 1, .reusable = true}, SHIFT(1883),
  [3988] = {.count = 1, .reusable = false}, SHIFT(1884),
  [3990] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_compound_statement, 3),
  [3992] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_compound_statement, 3),
  [3994] = {.count = 1, .reusable = true}, SHIFT(1885),
  [3996] = {.count = 1, .reusable = true}, SHIFT(1908),
  [3998] = {.count = 1, .reusable = false}, SHIFT(1886),
  [4000] = {.count = 1, .reusable = false}, SHIFT(1887),
  [4002] = {.count = 1, .reusable = false}, SHIFT(1888),
  [4004] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_else_in_compound_statement, 1),
  [4006] = {.count = 1, .reusable = false}, SHIFT(1889),
  [4008] = {.count = 1, .reusable = false}, SHIFT(1890),
  [4010] = {.count = 1, .reusable = true}, SHIFT(1891),
  [4012] = {.count = 1, .reusable = false}, SHIFT(1892),
  [4014] = {.count = 1, .reusable = true}, SHIFT(1893),
  [4016] = {.count = 1, .reusable = false}, SHIFT(1894),
  [4018] = {.count = 1, .reusable = false}, SHIFT(1895),
  [4020] = {.count = 1, .reusable = false}, SHIFT(1896),
  [4022] = {.count = 1, .reusable = false}, SHIFT(1897),
  [4024] = {.count = 1, .reusable = false}, SHIFT(1898),
  [4026] = {.count = 1, .reusable = false}, SHIFT(1899),
  [4028] = {.count = 1, .reusable = false}, SHIFT(1900),
  [4030] = {.count = 1, .reusable = false}, SHIFT(1901),
  [4032] = {.count = 1, .reusable = false}, SHIFT(1902),
  [4034] = {.count = 1, .reusable = false}, SHIFT(1903),
  [4036] = {.count = 1, .reusable = false}, SHIFT(1904),
  [4038] = {.count = 1, .reusable = false}, SHIFT(1908),
  [4040] = {.count = 1, .reusable = false}, SHIFT(1905),
  [4042] = {.count = 1, .reusable = false}, SHIFT(1906),
  [4044] = {.count = 1, .reusable = false}, SHIFT(1911),
  [4046] = {.count = 1, .reusable = false}, SHIFT(1912),
  [4048] = {.count = 1, .reusable = false}, SHIFT(1913),
  [4050] = {.count = 1, .reusable = false}, SHIFT(1914),
  [4052] = {.count = 1, .reusable = true}, SHIFT(1916),
  [4054] = {.count = 1, .reusable = true}, SHIFT(1918),
  [4056] = {.count = 1, .reusable = true}, SHIFT(1919),
  [4058] = {.count = 1, .reusable = true}, SHIFT(1921),
  [4060] = {.count = 1, .reusable = false}, SHIFT(1921),
  [4062] = {.count = 1, .reusable = true}, SHIFT(1922),
  [4064] = {.count = 1, .reusable = true}, SHIFT(1925),
  [4066] = {.count = 1, .reusable = true}, SHIFT(1927),
  [4068] = {.count = 1, .reusable = true}, SHIFT(1926),
  [4070] = {.count = 1, .reusable = false}, SHIFT(1927),
  [4072] = {.count = 1, .reusable = true}, SHIFT(1929),
  [4074] = {.count = 1, .reusable = true}, SHIFT(1930),
  [4076] = {.count = 1, .reusable = true}, SHIFT(1931),
  [4078] = {.count = 1, .reusable = false}, SHIFT(1932),
  [4080] = {.count = 1, .reusable = true}, SHIFT(1934),
  [4082] = {.count = 1, .reusable = true}, SHIFT(1935),
  [4084] = {.count = 1, .reusable = true}, SHIFT(1936),
  [4086] = {.count = 1, .reusable = true}, SHIFT(1939),
  [4088] = {.count = 1, .reusable = false}, SHIFT(1934),
  [4090] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 3),
  [4092] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 3),
  [4094] = {.count = 1, .reusable = true}, SHIFT(1942),
  [4096] = {.count = 1, .reusable = false}, SHIFT(1942),
  [4098] = {.count = 1, .reusable = true}, SHIFT(1944),
  [4100] = {.count = 1, .reusable = true}, SHIFT(1946),
  [4102] = {.count = 1, .reusable = true}, SHIFT(1947),
  [4104] = {.count = 1, .reusable = false}, SHIFT(1947),
  [4106] = {.count = 1, .reusable = true}, SHIFT(1951),
  [4108] = {.count = 1, .reusable = true}, SHIFT(1950),
  [4110] = {.count = 1, .reusable = false}, SHIFT(1951),
  [4112] = {.count = 1, .reusable = true}, SHIFT(1952),
  [4114] = {.count = 1, .reusable = true}, SHIFT(1953),
  [4116] = {.count = 1, .reusable = false}, SHIFT(1165),
  [4118] = {.count = 1, .reusable = true}, SHIFT(1956),
  [4120] = {.count = 1, .reusable = true}, SHIFT(1957),
  [4122] = {.count = 1, .reusable = false}, SHIFT(1957),
  [4124] = {.count = 1, .reusable = true}, SHIFT(1959),
  [4126] = {.count = 1, .reusable = true}, REDUCE(sym_pointer_declarator, 3, .dynamic_precedence = 1),
  [4128] = {.count = 1, .reusable = true}, SHIFT(1960),
  [4130] = {.count = 1, .reusable = true}, SHIFT(1961),
  [4132] = {.count = 1, .reusable = false}, SHIFT(1961),
  [4134] = {.count = 1, .reusable = true}, SHIFT(1962),
  [4136] = {.count = 1, .reusable = false}, SHIFT(1962),
  [4138] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(1177),
  [4141] = {.count = 1, .reusable = true}, SHIFT(1963),
  [4143] = {.count = 1, .reusable = false}, SHIFT(1969),
  [4145] = {.count = 1, .reusable = false}, SHIFT(1968),
  [4147] = {.count = 1, .reusable = false}, SHIFT(1964),
  [4149] = {.count = 1, .reusable = false}, SHIFT(1965),
  [4151] = {.count = 1, .reusable = false}, SHIFT(1966),
  [4153] = {.count = 1, .reusable = false}, SHIFT(1967),
  [4155] = {.count = 1, .reusable = true}, SHIFT(1970),
  [4157] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_pointer_declarator, 2, .dynamic_precedence = 1),
  [4159] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_reference_declarator, 2),
  [4161] = {.count = 1, .reusable = true}, SHIFT(1973),
  [4163] = {.count = 1, .reusable = false}, SHIFT(1974),
  [4165] = {.count = 1, .reusable = true}, SHIFT(1975),
  [4167] = {.count = 1, .reusable = true}, SHIFT(1976),
  [4169] = {.count = 1, .reusable = true}, REDUCE(sym_cast_expression, 4),
  [4171] = {.count = 1, .reusable = false}, REDUCE(sym_cast_expression, 4),
  [4173] = {.count = 1, .reusable = true}, REDUCE(sym_compound_literal_expression, 4),
  [4175] = {.count = 1, .reusable = false}, REDUCE(sym_compound_literal_expression, 4),
  [4177] = {.count = 1, .reusable = true}, REDUCE(sym_type_descriptor, 3),
  [4179] = {.count = 1, .reusable = false}, SHIFT(1979),
  [4181] = {.count = 1, .reusable = false}, SHIFT(1978),
  [4183] = {.count = 1, .reusable = false}, SHIFT(1977),
  [4185] = {.count = 1, .reusable = true}, SHIFT(1980),
  [4187] = {.count = 1, .reusable = true}, SHIFT(1981),
  [4189] = {.count = 1, .reusable = true}, SHIFT(1982),
  [4191] = {.count = 1, .reusable = false}, SHIFT(1982),
  [4193] = {.count = 1, .reusable = true}, SHIFT(1983),
  [4195] = {.count = 1, .reusable = false}, SHIFT(1983),
  [4197] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(1213),
  [4200] = {.count = 1, .reusable = true}, SHIFT(1984),
  [4202] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [4204] = {.count = 1, .reusable = true}, SHIFT(1985),
  [4206] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_capture_specifier, 4),
  [4208] = {.count = 1, .reusable = false}, REDUCE(sym_lambda_capture_specifier, 4),
  [4210] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(563),
  [4213] = {.count = 1, .reusable = true}, REDUCE(sym_enumerator_list, 3),
  [4215] = {.count = 1, .reusable = false}, REDUCE(sym_enumerator_list, 3),
  [4217] = {.count = 1, .reusable = true}, SHIFT(1986),
  [4219] = {.count = 1, .reusable = false}, SHIFT(1986),
  [4221] = {.count = 1, .reusable = true}, SHIFT(1987),
  [4223] = {.count = 1, .reusable = true}, SHIFT(1989),
  [4225] = {.count = 1, .reusable = true}, SHIFT(1991),
  [4227] = {.count = 1, .reusable = true}, SHIFT(1992),
  [4229] = {.count = 1, .reusable = true}, SHIFT(1993),
  [4231] = {.count = 1, .reusable = true}, SHIFT(1996),
  [4233] = {.count = 1, .reusable = false}, SHIFT(2000),
  [4235] = {.count = 1, .reusable = false}, SHIFT(2001),
  [4237] = {.count = 1, .reusable = false}, REDUCE(sym_access_specifier, 2),
  [4239] = {.count = 1, .reusable = true}, REDUCE(sym_access_specifier, 2),
  [4241] = {.count = 1, .reusable = false}, REDUCE(sym_friend_declaration, 2),
  [4243] = {.count = 1, .reusable = true}, REDUCE(sym_friend_declaration, 2),
  [4245] = {.count = 1, .reusable = true}, SHIFT(2004),
  [4247] = {.count = 1, .reusable = true}, SHIFT(2006),
  [4249] = {.count = 1, .reusable = true}, SHIFT(2007),
  [4251] = {.count = 1, .reusable = true}, SHIFT(2008),
  [4253] = {.count = 1, .reusable = true}, SHIFT(2009),
  [4255] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration, 2),
  [4257] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration, 2),
  [4259] = {.count = 1, .reusable = true}, SHIFT(2011),
  [4261] = {.count = 1, .reusable = false}, SHIFT(2012),
  [4263] = {.count = 1, .reusable = true}, SHIFT(2012),
  [4265] = {.count = 1, .reusable = true}, SHIFT(2013),
  [4267] = {.count = 1, .reusable = true}, SHIFT(2014),
  [4269] = {.count = 1, .reusable = true}, SHIFT(2016),
  [4271] = {.count = 1, .reusable = false}, SHIFT(2016),
  [4273] = {.count = 1, .reusable = true}, SHIFT(2017),
  [4275] = {.count = 1, .reusable = true}, REDUCE(sym__field_declarator, 1, .alias_sequence_id = 12),
  [4277] = {.count = 1, .reusable = false}, REDUCE(sym__field_declarator, 1, .alias_sequence_id = 12),
  [4279] = {.count = 1, .reusable = true}, SHIFT(2018),
  [4281] = {.count = 1, .reusable = true}, SHIFT(2019),
  [4283] = {.count = 1, .reusable = true}, SHIFT(2020),
  [4285] = {.count = 1, .reusable = true}, SHIFT(2021),
  [4287] = {.count = 1, .reusable = true}, SHIFT(2022),
  [4289] = {.count = 1, .reusable = true}, SHIFT(678),
  [4291] = {.count = 1, .reusable = true}, SHIFT(2026),
  [4293] = {.count = 1, .reusable = true}, SHIFT(2027),
  [4295] = {.count = 1, .reusable = false}, REDUCE(sym_constructor_or_destructor_declaration, 2),
  [4297] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_or_destructor_declaration, 2),
  [4299] = {.count = 1, .reusable = true}, SHIFT(2028),
  [4301] = {.count = 1, .reusable = true}, SHIFT(2030),
  [4303] = {.count = 1, .reusable = true}, SHIFT(2031),
  [4305] = {.count = 1, .reusable = false}, SHIFT(2034),
  [4307] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration_list, 3),
  [4309] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration_list, 3),
  [4311] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(584),
  [4314] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(585),
  [4317] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(586),
  [4320] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(14),
  [4323] = {.count = 1, .reusable = true}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2),
  [4325] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(242),
  [4328] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(243),
  [4331] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(15),
  [4334] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(606),
  [4337] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(601),
  [4340] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(16),
  [4343] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(588),
  [4346] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(589),
  [4349] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(31),
  [4352] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(31),
  [4355] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(244),
  [4358] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(590),
  [4361] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(591),
  [4364] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(592),
  [4367] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(593),
  [4370] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(594),
  [4373] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(595),
  [4376] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(596),
  [4379] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(597),
  [4382] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(599),
  [4385] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(1279),
  [4388] = {.count = 1, .reusable = false}, SHIFT(2037),
  [4390] = {.count = 1, .reusable = false}, SHIFT(2038),
  [4392] = {.count = 1, .reusable = true}, REDUCE(sym_base_class_clause, 3, .alias_sequence_id = 2),
  [4394] = {.count = 1, .reusable = true}, REDUCE(sym_base_class_clause, 3, .alias_sequence_id = 10),
  [4396] = {.count = 1, .reusable = true}, REDUCE(sym_base_class_clause, 3),
  [4398] = {.count = 1, .reusable = true}, REDUCE(sym_struct_specifier, 4, .alias_sequence_id = 2),
  [4400] = {.count = 1, .reusable = false}, REDUCE(sym_struct_specifier, 4, .alias_sequence_id = 2),
  [4402] = {.count = 1, .reusable = true}, REDUCE(sym_struct_specifier, 4),
  [4404] = {.count = 1, .reusable = false}, REDUCE(sym_struct_specifier, 4),
  [4406] = {.count = 1, .reusable = true}, REDUCE(sym_union_specifier, 4, .alias_sequence_id = 2),
  [4408] = {.count = 1, .reusable = false}, REDUCE(sym_union_specifier, 4, .alias_sequence_id = 2),
  [4410] = {.count = 1, .reusable = true}, REDUCE(sym_union_specifier, 4),
  [4412] = {.count = 1, .reusable = false}, REDUCE(sym_union_specifier, 4),
  [4414] = {.count = 1, .reusable = true}, SHIFT(2048),
  [4416] = {.count = 1, .reusable = true}, SHIFT(2050),
  [4418] = {.count = 1, .reusable = true}, SHIFT(2051),
  [4420] = {.count = 1, .reusable = false}, SHIFT(2052),
  [4422] = {.count = 1, .reusable = false}, SHIFT(2053),
  [4424] = {.count = 1, .reusable = true}, SHIFT(2055),
  [4426] = {.count = 1, .reusable = true}, SHIFT(2054),
  [4428] = {.count = 1, .reusable = false}, SHIFT(2055),
  [4430] = {.count = 1, .reusable = false}, SHIFT(2056),
  [4432] = {.count = 1, .reusable = false}, SHIFT(2057),
  [4434] = {.count = 1, .reusable = false}, SHIFT(2058),
  [4436] = {.count = 1, .reusable = false}, SHIFT(2059),
  [4438] = {.count = 1, .reusable = false}, SHIFT(2060),
  [4440] = {.count = 1, .reusable = false}, SHIFT(2061),
  [4442] = {.count = 1, .reusable = false}, SHIFT(2062),
  [4444] = {.count = 1, .reusable = false}, SHIFT(2063),
  [4446] = {.count = 1, .reusable = true}, SHIFT(2065),
  [4448] = {.count = 1, .reusable = false}, SHIFT(2065),
  [4450] = {.count = 1, .reusable = true}, SHIFT(2066),
  [4452] = {.count = 1, .reusable = false}, SHIFT(2066),
  [4454] = {.count = 1, .reusable = true}, SHIFT(2067),
  [4456] = {.count = 1, .reusable = false}, SHIFT(2067),
  [4458] = {.count = 1, .reusable = true}, SHIFT(2068),
  [4460] = {.count = 1, .reusable = false}, SHIFT(2068),
  [4462] = {.count = 1, .reusable = true}, SHIFT(2069),
  [4464] = {.count = 1, .reusable = false}, SHIFT(2069),
  [4466] = {.count = 1, .reusable = true}, SHIFT(2070),
  [4468] = {.count = 1, .reusable = false}, SHIFT(2070),
  [4470] = {.count = 1, .reusable = true}, SHIFT(2071),
  [4472] = {.count = 1, .reusable = false}, SHIFT(2071),
  [4474] = {.count = 1, .reusable = true}, SHIFT(2072),
  [4476] = {.count = 1, .reusable = false}, SHIFT(2072),
  [4478] = {.count = 1, .reusable = true}, SHIFT(2073),
  [4480] = {.count = 1, .reusable = false}, SHIFT(2073),
  [4482] = {.count = 1, .reusable = true}, SHIFT(2074),
  [4484] = {.count = 1, .reusable = false}, SHIFT(2074),
  [4486] = {.count = 1, .reusable = true}, SHIFT(2075),
  [4488] = {.count = 1, .reusable = false}, SHIFT(2075),
  [4490] = {.count = 1, .reusable = true}, SHIFT(2077),
  [4492] = {.count = 1, .reusable = true}, SHIFT(2078),
  [4494] = {.count = 1, .reusable = false}, SHIFT(2078),
  [4496] = {.count = 1, .reusable = true}, SHIFT(2079),
  [4498] = {.count = 1, .reusable = true}, SHIFT(2080),
  [4500] = {.count = 1, .reusable = false}, SHIFT(2080),
  [4502] = {.count = 1, .reusable = true}, SHIFT(2081),
  [4504] = {.count = 1, .reusable = false}, SHIFT(2081),
  [4506] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(1338),
  [4509] = {.count = 1, .reusable = true}, SHIFT(2083),
  [4511] = {.count = 1, .reusable = true}, SHIFT(2084),
  [4513] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 4),
  [4515] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 4),
  [4517] = {.count = 1, .reusable = true}, SHIFT(2086),
  [4519] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(197),
  [4522] = {.count = 1, .reusable = true}, SHIFT(2087),
  [4524] = {.count = 1, .reusable = true}, SHIFT(2089),
  [4526] = {.count = 1, .reusable = false}, SHIFT(2091),
  [4528] = {.count = 1, .reusable = false}, SHIFT(2092),
  [4530] = {.count = 1, .reusable = true}, SHIFT(2093),
  [4532] = {.count = 1, .reusable = true}, SHIFT(2094),
  [4534] = {.count = 1, .reusable = false}, SHIFT(2094),
  [4536] = {.count = 1, .reusable = true}, SHIFT(2096),
  [4538] = {.count = 1, .reusable = true}, SHIFT(2097),
  [4540] = {.count = 1, .reusable = true}, SHIFT(2100),
  [4542] = {.count = 1, .reusable = true}, SHIFT(2099),
  [4544] = {.count = 1, .reusable = false}, SHIFT(2100),
  [4546] = {.count = 1, .reusable = true}, SHIFT(2101),
  [4548] = {.count = 1, .reusable = true}, SHIFT(2102),
  [4550] = {.count = 1, .reusable = true}, SHIFT(2105),
  [4552] = {.count = 1, .reusable = false}, SHIFT(2105),
  [4554] = {.count = 1, .reusable = true}, REDUCE(sym_do_statement, 4),
  [4556] = {.count = 1, .reusable = false}, REDUCE(sym_do_statement, 4),
  [4558] = {.count = 1, .reusable = true}, SHIFT(2108),
  [4560] = {.count = 1, .reusable = true}, SHIFT(2107),
  [4562] = {.count = 1, .reusable = false}, SHIFT(2108),
  [4564] = {.count = 1, .reusable = true}, SHIFT(2109),
  [4566] = {.count = 1, .reusable = true}, SHIFT(2110),
  [4568] = {.count = 1, .reusable = true}, SHIFT(2112),
  [4570] = {.count = 1, .reusable = true}, REDUCE(sym_for_range_declaration, 2),
  [4572] = {.count = 1, .reusable = true}, SHIFT(2114),
  [4574] = {.count = 1, .reusable = false}, SHIFT(2114),
  [4576] = {.count = 1, .reusable = true}, SHIFT(2115),
  [4578] = {.count = 1, .reusable = false}, SHIFT(2115),
  [4580] = {.count = 1, .reusable = true}, REDUCE(sym_initializer_list, 3),
  [4582] = {.count = 1, .reusable = false}, REDUCE(sym_initializer_list, 3),
  [4584] = {.count = 1, .reusable = true}, SHIFT(2116),
  [4586] = {.count = 1, .reusable = true}, SHIFT(2117),
  [4588] = {.count = 1, .reusable = true}, REDUCE(sym_field_designator, 2, .alias_sequence_id = 13),
  [4590] = {.count = 1, .reusable = true}, SHIFT(2119),
  [4592] = {.count = 1, .reusable = true}, SHIFT(2120),
  [4594] = {.count = 1, .reusable = false}, SHIFT(2121),
  [4596] = {.count = 1, .reusable = false}, SHIFT(2122),
  [4598] = {.count = 1, .reusable = true}, SHIFT(2124),
  [4600] = {.count = 1, .reusable = true}, SHIFT(2123),
  [4602] = {.count = 1, .reusable = false}, SHIFT(2124),
  [4604] = {.count = 1, .reusable = true}, SHIFT(2126),
  [4606] = {.count = 1, .reusable = true}, SHIFT(2125),
  [4608] = {.count = 1, .reusable = false}, SHIFT(2126),
  [4610] = {.count = 1, .reusable = true}, SHIFT(2128),
  [4612] = {.count = 1, .reusable = false}, SHIFT(2128),
  [4614] = {.count = 1, .reusable = true}, SHIFT(2129),
  [4616] = {.count = 1, .reusable = false}, SHIFT(2129),
  [4618] = {.count = 1, .reusable = true}, SHIFT(2130),
  [4620] = {.count = 1, .reusable = false}, SHIFT(2130),
  [4622] = {.count = 1, .reusable = true}, SHIFT(2131),
  [4624] = {.count = 1, .reusable = false}, SHIFT(2131),
  [4626] = {.count = 1, .reusable = true}, SHIFT(2132),
  [4628] = {.count = 1, .reusable = false}, SHIFT(2132),
  [4630] = {.count = 1, .reusable = true}, SHIFT(2133),
  [4632] = {.count = 1, .reusable = false}, SHIFT(2133),
  [4634] = {.count = 1, .reusable = true}, SHIFT(2134),
  [4636] = {.count = 1, .reusable = false}, SHIFT(2134),
  [4638] = {.count = 1, .reusable = true}, SHIFT(2135),
  [4640] = {.count = 1, .reusable = false}, SHIFT(2135),
  [4642] = {.count = 1, .reusable = true}, SHIFT(2136),
  [4644] = {.count = 1, .reusable = false}, SHIFT(2136),
  [4646] = {.count = 1, .reusable = true}, SHIFT(2137),
  [4648] = {.count = 1, .reusable = false}, SHIFT(2137),
  [4650] = {.count = 1, .reusable = true}, SHIFT(2138),
  [4652] = {.count = 1, .reusable = false}, SHIFT(2138),
  [4654] = {.count = 1, .reusable = true}, SHIFT(2139),
  [4656] = {.count = 1, .reusable = true}, SHIFT(2142),
  [4658] = {.count = 1, .reusable = false}, SHIFT(2142),
  [4660] = {.count = 1, .reusable = true}, SHIFT(2143),
  [4662] = {.count = 1, .reusable = false}, SHIFT(2143),
  [4664] = {.count = 2, .reusable = true}, REDUCE(aux_sym_initializer_pair_repeat1, 2), SHIFT_REPEAT(1422),
  [4667] = {.count = 1, .reusable = true}, REDUCE(aux_sym_initializer_pair_repeat1, 2),
  [4669] = {.count = 2, .reusable = true}, REDUCE(aux_sym_initializer_pair_repeat1, 2), SHIFT_REPEAT(721),
  [4672] = {.count = 1, .reusable = true}, SHIFT(2145),
  [4674] = {.count = 1, .reusable = true}, SHIFT(2146),
  [4676] = {.count = 1, .reusable = false}, SHIFT(2146),
  [4678] = {.count = 1, .reusable = true}, SHIFT(2147),
  [4680] = {.count = 1, .reusable = false}, SHIFT(2147),
  [4682] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(1430),
  [4685] = {.count = 1, .reusable = true}, SHIFT(2148),
  [4687] = {.count = 1, .reusable = true}, SHIFT(2149),
  [4689] = {.count = 1, .reusable = true}, REDUCE(sym_sizeof_expression, 4),
  [4691] = {.count = 1, .reusable = false}, SHIFT(98),
  [4693] = {.count = 1, .reusable = false}, REDUCE(sym_sizeof_expression, 4),
  [4695] = {.count = 1, .reusable = false}, SHIFT(32),
  [4697] = {.count = 1, .reusable = true}, SHIFT(2150),
  [4699] = {.count = 1, .reusable = true}, SHIFT(2151),
  [4701] = {.count = 1, .reusable = true}, SHIFT(2152),
  [4703] = {.count = 1, .reusable = false}, SHIFT(2154),
  [4705] = {.count = 1, .reusable = true}, SHIFT(2155),
  [4707] = {.count = 1, .reusable = true}, SHIFT(2157),
  [4709] = {.count = 1, .reusable = false}, SHIFT(2158),
  [4711] = {.count = 1, .reusable = true}, SHIFT(2161),
  [4713] = {.count = 1, .reusable = true}, SHIFT(2159),
  [4715] = {.count = 1, .reusable = true}, SHIFT(2160),
  [4717] = {.count = 1, .reusable = false}, SHIFT(2161),
  [4719] = {.count = 1, .reusable = true}, SHIFT(2164),
  [4721] = {.count = 1, .reusable = false}, SHIFT(2164),
  [4723] = {.count = 1, .reusable = true}, SHIFT(2163),
  [4725] = {.count = 1, .reusable = false}, SHIFT(2166),
  [4727] = {.count = 1, .reusable = true}, SHIFT(2167),
  [4729] = {.count = 1, .reusable = true}, SHIFT(2168),
  [4731] = {.count = 1, .reusable = true}, SHIFT(2169),
  [4733] = {.count = 1, .reusable = true}, SHIFT(2170),
  [4735] = {.count = 1, .reusable = true}, SHIFT(2172),
  [4737] = {.count = 1, .reusable = false}, SHIFT(2173),
  [4739] = {.count = 1, .reusable = false}, SHIFT(2179),
  [4741] = {.count = 2, .reusable = false}, REDUCE(sym__type_specifier, 1, .alias_sequence_id = 1), SHIFT(1466),
  [4744] = {.count = 1, .reusable = true}, SHIFT(2185),
  [4746] = {.count = 1, .reusable = false}, SHIFT(2187),
  [4748] = {.count = 1, .reusable = false}, SHIFT(2193),
  [4750] = {.count = 1, .reusable = true}, SHIFT(2194),
  [4752] = {.count = 1, .reusable = true}, SHIFT(2195),
  [4754] = {.count = 1, .reusable = false}, SHIFT(2198),
  [4756] = {.count = 1, .reusable = true}, SHIFT(2199),
  [4758] = {.count = 2, .reusable = false}, REDUCE(sym__type_specifier, 1), SHIFT(1466),
  [4761] = {.count = 1, .reusable = false}, SHIFT(2203),
  [4763] = {.count = 1, .reusable = false}, SHIFT(2201),
  [4765] = {.count = 1, .reusable = false}, SHIFT(2202),
  [4767] = {.count = 1, .reusable = true}, SHIFT(2204),
  [4769] = {.count = 1, .reusable = true}, SHIFT(2206),
  [4771] = {.count = 1, .reusable = true}, SHIFT(2205),
  [4773] = {.count = 1, .reusable = false}, SHIFT(2206),
  [4775] = {.count = 1, .reusable = true}, SHIFT(2211),
  [4777] = {.count = 1, .reusable = true}, SHIFT(2212),
  [4779] = {.count = 1, .reusable = true}, SHIFT(2213),
  [4781] = {.count = 1, .reusable = false}, SHIFT(2213),
  [4783] = {.count = 1, .reusable = true}, SHIFT(2216),
  [4785] = {.count = 1, .reusable = true}, SHIFT(2215),
  [4787] = {.count = 1, .reusable = false}, SHIFT(2216),
  [4789] = {.count = 1, .reusable = true}, SHIFT(2218),
  [4791] = {.count = 1, .reusable = false}, SHIFT(2218),
  [4793] = {.count = 1, .reusable = true}, SHIFT(2219),
  [4795] = {.count = 1, .reusable = false}, SHIFT(2219),
  [4797] = {.count = 1, .reusable = true}, SHIFT(2220),
  [4799] = {.count = 1, .reusable = false}, SHIFT(2220),
  [4801] = {.count = 1, .reusable = true}, SHIFT(2221),
  [4803] = {.count = 1, .reusable = false}, SHIFT(2221),
  [4805] = {.count = 1, .reusable = true}, SHIFT(2222),
  [4807] = {.count = 1, .reusable = false}, SHIFT(2222),
  [4809] = {.count = 1, .reusable = true}, SHIFT(2223),
  [4811] = {.count = 1, .reusable = false}, SHIFT(2223),
  [4813] = {.count = 1, .reusable = true}, SHIFT(2224),
  [4815] = {.count = 1, .reusable = false}, SHIFT(2224),
  [4817] = {.count = 1, .reusable = true}, SHIFT(2225),
  [4819] = {.count = 1, .reusable = false}, SHIFT(2225),
  [4821] = {.count = 1, .reusable = true}, SHIFT(2226),
  [4823] = {.count = 1, .reusable = false}, SHIFT(2226),
  [4825] = {.count = 1, .reusable = true}, SHIFT(2227),
  [4827] = {.count = 1, .reusable = false}, SHIFT(2227),
  [4829] = {.count = 1, .reusable = true}, SHIFT(2228),
  [4831] = {.count = 1, .reusable = false}, SHIFT(2228),
  [4833] = {.count = 1, .reusable = true}, SHIFT(2229),
  [4835] = {.count = 1, .reusable = false}, SHIFT(2229),
  [4837] = {.count = 1, .reusable = true}, SHIFT(2230),
  [4839] = {.count = 1, .reusable = false}, SHIFT(2230),
  [4841] = {.count = 1, .reusable = true}, SHIFT(2231),
  [4843] = {.count = 1, .reusable = true}, REDUCE(sym_template_argument_list, 3),
  [4845] = {.count = 1, .reusable = false}, REDUCE(sym_template_argument_list, 3),
  [4847] = {.count = 1, .reusable = true}, SHIFT(2234),
  [4849] = {.count = 1, .reusable = true}, REDUCE(sym_template_argument_list, 3, .dynamic_precedence = 1),
  [4851] = {.count = 1, .reusable = false}, REDUCE(sym_template_argument_list, 3, .dynamic_precedence = 1),
  [4853] = {.count = 1, .reusable = true}, SHIFT(2236),
  [4855] = {.count = 1, .reusable = false}, SHIFT(2238),
  [4857] = {.count = 1, .reusable = true}, SHIFT(2239),
  [4859] = {.count = 1, .reusable = true}, SHIFT(2240),
  [4861] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(1521),
  [4864] = {.count = 1, .reusable = true}, REDUCE(sym_class_specifier, 4, .alias_sequence_id = 2),
  [4866] = {.count = 1, .reusable = false}, REDUCE(sym_class_specifier, 4, .alias_sequence_id = 2),
  [4868] = {.count = 1, .reusable = true}, REDUCE(sym_class_specifier, 4),
  [4870] = {.count = 1, .reusable = false}, REDUCE(sym_class_specifier, 4),
  [4872] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter_declaration, 2, .alias_sequence_id = 2),
  [4874] = {.count = 2, .reusable = true}, REDUCE(sym__type_specifier, 1, .alias_sequence_id = 1), SHIFT(2245),
  [4877] = {.count = 1, .reusable = true}, SHIFT(2246),
  [4879] = {.count = 1, .reusable = false}, SHIFT(2247),
  [4881] = {.count = 1, .reusable = true}, SHIFT(2247),
  [4883] = {.count = 1, .reusable = true}, SHIFT(2248),
  [4885] = {.count = 1, .reusable = true}, SHIFT(2250),
  [4887] = {.count = 1, .reusable = true}, SHIFT(2251),
  [4889] = {.count = 1, .reusable = true}, REDUCE(sym_parameter_declaration, 2),
  [4891] = {.count = 1, .reusable = true}, SHIFT(2252),
  [4893] = {.count = 1, .reusable = true}, SHIFT(2253),
  [4895] = {.count = 1, .reusable = true}, SHIFT(2255),
  [4897] = {.count = 1, .reusable = true}, SHIFT(2256),
  [4899] = {.count = 1, .reusable = false}, SHIFT(2256),
  [4901] = {.count = 1, .reusable = false}, REDUCE(sym_template_parameter_list, 3),
  [4903] = {.count = 1, .reusable = true}, REDUCE(sym_template_parameter_list, 3),
  [4905] = {.count = 1, .reusable = true}, SHIFT(2259),
  [4907] = {.count = 1, .reusable = false}, SHIFT(2262),
  [4909] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(1548),
  [4912] = {.count = 1, .reusable = true}, REDUCE(sym_template_instantiation, 4),
  [4914] = {.count = 1, .reusable = false}, REDUCE(sym_template_instantiation, 4),
  [4916] = {.count = 1, .reusable = false}, SHIFT(2265),
  [4918] = {.count = 1, .reusable = false}, SHIFT(2264),
  [4920] = {.count = 1, .reusable = false}, SHIFT(2263),
  [4922] = {.count = 1, .reusable = true}, SHIFT(2266),
  [4924] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(1556),
  [4927] = {.count = 1, .reusable = true}, REDUCE(sym_delete_expression, 4),
  [4929] = {.count = 1, .reusable = false}, REDUCE(sym_delete_expression, 4),
  [4931] = {.count = 1, .reusable = true}, SHIFT(2269),
  [4933] = {.count = 1, .reusable = false}, SHIFT(2269),
  [4935] = {.count = 1, .reusable = true}, SHIFT(2270),
  [4937] = {.count = 1, .reusable = false}, SHIFT(2271),
  [4939] = {.count = 1, .reusable = true}, SHIFT(2272),
  [4941] = {.count = 1, .reusable = false}, SHIFT(2273),
  [4943] = {.count = 1, .reusable = true}, SHIFT(2275),
  [4945] = {.count = 1, .reusable = true}, SHIFT(2274),
  [4947] = {.count = 1, .reusable = false}, SHIFT(2275),
  [4949] = {.count = 1, .reusable = true}, REDUCE(sym_declaration_list, 3),
  [4951] = {.count = 1, .reusable = false}, REDUCE(sym_declaration_list, 3),
  [4953] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(825),
  [4956] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(826),
  [4959] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(827),
  [4962] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(828),
  [4965] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(829),
  [4968] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(830),
  [4971] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(831),
  [4974] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(832),
  [4977] = {.count = 1, .reusable = true}, SHIFT(2278),
  [4979] = {.count = 1, .reusable = false}, SHIFT(2279),
  [4981] = {.count = 1, .reusable = true}, SHIFT(2279),
  [4983] = {.count = 1, .reusable = true}, SHIFT(2282),
  [4985] = {.count = 1, .reusable = false}, SHIFT(2283),
  [4987] = {.count = 1, .reusable = false}, SHIFT(2284),
  [4989] = {.count = 1, .reusable = true}, REDUCE(sym_using_declaration, 4),
  [4991] = {.count = 1, .reusable = false}, REDUCE(sym_using_declaration, 4),
  [4993] = {.count = 1, .reusable = true}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [4995] = {.count = 1, .reusable = false}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [4997] = {.count = 2, .reusable = false}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(842),
  [5000] = {.count = 1, .reusable = true}, SHIFT(2286),
  [5002] = {.count = 1, .reusable = false}, SHIFT(2286),
  [5004] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 3),
  [5006] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 3),
  [5008] = {.count = 1, .reusable = true}, SHIFT(2288),
  [5010] = {.count = 1, .reusable = true}, SHIFT(2290),
  [5012] = {.count = 1, .reusable = true}, SHIFT(2291),
  [5014] = {.count = 1, .reusable = true}, SHIFT(2293),
  [5016] = {.count = 1, .reusable = true}, SHIFT(2306),
  [5018] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 4),
  [5020] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 4),
  [5022] = {.count = 1, .reusable = true}, SHIFT(2308),
  [5024] = {.count = 1, .reusable = false}, SHIFT(2308),
  [5026] = {.count = 1, .reusable = true}, SHIFT(2309),
  [5028] = {.count = 1, .reusable = true}, REDUCE(sym_structured_binding_declarator, 3),
  [5030] = {.count = 1, .reusable = true}, SHIFT(2310),
  [5032] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_repeat1, 2),
  [5034] = {.count = 1, .reusable = true}, SHIFT(2312),
  [5036] = {.count = 1, .reusable = true}, SHIFT(2314),
  [5038] = {.count = 1, .reusable = true}, SHIFT(2316),
  [5040] = {.count = 1, .reusable = true}, SHIFT(2315),
  [5042] = {.count = 1, .reusable = false}, SHIFT(2316),
  [5044] = {.count = 1, .reusable = true}, SHIFT(2318),
  [5046] = {.count = 1, .reusable = true}, SHIFT(2317),
  [5048] = {.count = 1, .reusable = false}, SHIFT(2318),
  [5050] = {.count = 1, .reusable = false}, SHIFT(2322),
  [5052] = {.count = 1, .reusable = false}, SHIFT(2320),
  [5054] = {.count = 1, .reusable = false}, SHIFT(2319),
  [5056] = {.count = 1, .reusable = false}, SHIFT(2323),
  [5058] = {.count = 1, .reusable = true}, SHIFT(2324),
  [5060] = {.count = 1, .reusable = false}, SHIFT(2325),
  [5062] = {.count = 1, .reusable = false}, SHIFT(2326),
  [5064] = {.count = 1, .reusable = true}, SHIFT(2327),
  [5066] = {.count = 1, .reusable = true}, SHIFT(2326),
  [5068] = {.count = 1, .reusable = false}, SHIFT(2328),
  [5070] = {.count = 1, .reusable = true}, SHIFT(2329),
  [5072] = {.count = 1, .reusable = true}, SHIFT(2330),
  [5074] = {.count = 1, .reusable = false}, SHIFT(2331),
  [5076] = {.count = 1, .reusable = false}, SHIFT(2332),
  [5078] = {.count = 1, .reusable = true}, SHIFT(2333),
  [5080] = {.count = 1, .reusable = false}, SHIFT(2334),
  [5082] = {.count = 1, .reusable = true}, SHIFT(2334),
  [5084] = {.count = 1, .reusable = false}, SHIFT(2335),
  [5086] = {.count = 1, .reusable = false}, SHIFT(2336),
  [5088] = {.count = 2, .reusable = true}, REDUCE(sym_parameter_list, 2), REDUCE(sym_argument_list, 2),
  [5091] = {.count = 1, .reusable = true}, SHIFT(2338),
  [5093] = {.count = 1, .reusable = false}, SHIFT(2340),
  [5095] = {.count = 1, .reusable = true}, SHIFT(2341),
  [5097] = {.count = 1, .reusable = true}, REDUCE(sym_init_declarator, 3),
  [5099] = {.count = 1, .reusable = false}, SHIFT(2347),
  [5101] = {.count = 1, .reusable = false}, SHIFT(2346),
  [5103] = {.count = 1, .reusable = false}, SHIFT(2342),
  [5105] = {.count = 1, .reusable = false}, SHIFT(2343),
  [5107] = {.count = 1, .reusable = false}, SHIFT(2344),
  [5109] = {.count = 1, .reusable = false}, SHIFT(2345),
  [5111] = {.count = 1, .reusable = true}, SHIFT(2348),
  [5113] = {.count = 1, .reusable = true}, REDUCE(sym_declaration, 4),
  [5115] = {.count = 1, .reusable = false}, REDUCE(sym_declaration, 4),
  [5117] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_repeat1, 2), SHIFT_REPEAT(891),
  [5120] = {.count = 1, .reusable = true}, SHIFT(2349),
  [5122] = {.count = 1, .reusable = true}, REDUCE(sym_structured_binding_declaration, 4),
  [5124] = {.count = 1, .reusable = false}, REDUCE(sym_structured_binding_declaration, 4),
  [5126] = {.count = 1, .reusable = true}, SHIFT(2350),
  [5128] = {.count = 1, .reusable = true}, REDUCE(sym_parameter_list, 3),
  [5130] = {.count = 1, .reusable = false}, REDUCE(sym_parameter_list, 3),
  [5132] = {.count = 1, .reusable = true}, SHIFT(2351),
  [5134] = {.count = 1, .reusable = true}, SHIFT(2353),
  [5136] = {.count = 1, .reusable = true}, SHIFT(2356),
  [5138] = {.count = 1, .reusable = true}, SHIFT(2358),
  [5140] = {.count = 1, .reusable = true}, SHIFT(2361),
  [5142] = {.count = 1, .reusable = true}, SHIFT(2362),
  [5144] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(1657),
  [5147] = {.count = 1, .reusable = true}, SHIFT(2365),
  [5149] = {.count = 1, .reusable = true}, REDUCE(sym_array_declarator, 4),
  [5151] = {.count = 1, .reusable = true}, SHIFT(2367),
  [5153] = {.count = 1, .reusable = true}, SHIFT(2368),
  [5155] = {.count = 1, .reusable = false}, SHIFT(2369),
  [5157] = {.count = 1, .reusable = false}, SHIFT(2370),
  [5159] = {.count = 1, .reusable = true}, SHIFT(2372),
  [5161] = {.count = 1, .reusable = true}, SHIFT(2371),
  [5163] = {.count = 1, .reusable = false}, SHIFT(2372),
  [5165] = {.count = 1, .reusable = true}, SHIFT(2373),
  [5167] = {.count = 1, .reusable = false}, SHIFT(2373),
  [5169] = {.count = 1, .reusable = true}, SHIFT(2374),
  [5171] = {.count = 1, .reusable = false}, SHIFT(2374),
  [5173] = {.count = 1, .reusable = true}, SHIFT(2375),
  [5175] = {.count = 1, .reusable = false}, SHIFT(2375),
  [5177] = {.count = 1, .reusable = true}, SHIFT(2376),
  [5179] = {.count = 1, .reusable = false}, SHIFT(2376),
  [5181] = {.count = 1, .reusable = true}, SHIFT(2377),
  [5183] = {.count = 1, .reusable = false}, SHIFT(2377),
  [5185] = {.count = 1, .reusable = true}, SHIFT(2378),
  [5187] = {.count = 1, .reusable = false}, SHIFT(2378),
  [5189] = {.count = 1, .reusable = true}, SHIFT(2379),
  [5191] = {.count = 1, .reusable = false}, SHIFT(2379),
  [5193] = {.count = 1, .reusable = true}, SHIFT(2380),
  [5195] = {.count = 1, .reusable = false}, SHIFT(2380),
  [5197] = {.count = 1, .reusable = true}, SHIFT(2381),
  [5199] = {.count = 1, .reusable = false}, SHIFT(2381),
  [5201] = {.count = 1, .reusable = true}, SHIFT(2382),
  [5203] = {.count = 1, .reusable = false}, SHIFT(2382),
  [5205] = {.count = 1, .reusable = true}, SHIFT(2383),
  [5207] = {.count = 1, .reusable = false}, SHIFT(2383),
  [5209] = {.count = 1, .reusable = true}, SHIFT(2385),
  [5211] = {.count = 2, .reusable = false}, REDUCE(aux_sym_type_definition_repeat1, 2), SHIFT_REPEAT(912),
  [5214] = {.count = 1, .reusable = true}, SHIFT(2386),
  [5216] = {.count = 1, .reusable = false}, SHIFT(2387),
  [5218] = {.count = 1, .reusable = false}, SHIFT(2390),
  [5220] = {.count = 1, .reusable = false}, SHIFT(2393),
  [5222] = {.count = 1, .reusable = true}, REDUCE(sym_trailing_return_type, 2),
  [5224] = {.count = 1, .reusable = true}, SHIFT(2396),
  [5226] = {.count = 1, .reusable = false}, REDUCE(sym_trailing_return_type, 2),
  [5228] = {.count = 1, .reusable = false}, SHIFT(2397),
  [5230] = {.count = 1, .reusable = true}, SHIFT(2397),
  [5232] = {.count = 1, .reusable = false}, SHIFT(2400),
  [5234] = {.count = 1, .reusable = false}, SHIFT(455),
  [5236] = {.count = 1, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2),
  [5238] = {.count = 2, .reusable = false}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(924),
  [5241] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(924),
  [5244] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(925),
  [5247] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(173),
  [5250] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(1693),
  [5253] = {.count = 1, .reusable = true}, REDUCE(sym_default_method_clause, 3),
  [5255] = {.count = 1, .reusable = false}, REDUCE(sym_default_method_clause, 3),
  [5257] = {.count = 1, .reusable = true}, REDUCE(sym_delete_method_clause, 3),
  [5259] = {.count = 1, .reusable = false}, REDUCE(sym_delete_method_clause, 3),
  [5261] = {.count = 1, .reusable = false}, SHIFT(2401),
  [5263] = {.count = 1, .reusable = true}, SHIFT(2402),
  [5265] = {.count = 1, .reusable = true}, REDUCE(sym_field_initializer, 2, .alias_sequence_id = 12),
  [5267] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_field_identifier, 2, .alias_sequence_id = 13),
  [5269] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_field_identifier, 2),
  [5271] = {.count = 1, .reusable = true}, REDUCE(sym_field_initializer_list, 3),
  [5273] = {.count = 1, .reusable = false}, SHIFT(2405),
  [5275] = {.count = 1, .reusable = true}, SHIFT(2406),
  [5277] = {.count = 1, .reusable = true}, REDUCE(sym_field_initializer, 2),
  [5279] = {.count = 1, .reusable = true}, REDUCE(sym_subscript_expression, 4),
  [5281] = {.count = 1, .reusable = false}, REDUCE(sym_subscript_expression, 4),
  [5283] = {.count = 1, .reusable = true}, SHIFT(2407),
  [5285] = {.count = 1, .reusable = false}, SHIFT(2407),
  [5287] = {.count = 1, .reusable = false}, SHIFT(2408),
  [5289] = {.count = 1, .reusable = true}, REDUCE(sym_template_method, 2, .alias_sequence_id = 12),
  [5291] = {.count = 1, .reusable = false}, REDUCE(sym_template_method, 2, .alias_sequence_id = 12),
  [5293] = {.count = 2, .reusable = true}, REDUCE(sym_scoped_field_identifier, 2, .alias_sequence_id = 13), REDUCE(sym_scoped_type_identifier, 2, .alias_sequence_id = 2),
  [5296] = {.count = 1, .reusable = false}, SHIFT(2409),
  [5298] = {.count = 1, .reusable = true}, REDUCE(sym_template_method, 2),
  [5300] = {.count = 1, .reusable = false}, REDUCE(sym_template_method, 2),
  [5302] = {.count = 1, .reusable = true}, REDUCE(sym__abstract_declarator, 3),
  [5304] = {.count = 1, .reusable = false}, REDUCE(sym__abstract_declarator, 3),
  [5306] = {.count = 1, .reusable = true}, SHIFT(2410),
  [5308] = {.count = 1, .reusable = false}, SHIFT(2413),
  [5310] = {.count = 1, .reusable = false}, SHIFT(2412),
  [5312] = {.count = 1, .reusable = false}, SHIFT(2411),
  [5314] = {.count = 1, .reusable = true}, SHIFT(2414),
  [5316] = {.count = 2, .reusable = true}, REDUCE(aux_sym_type_definition_repeat1, 2), SHIFT_REPEAT(15),
  [5319] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_array_declarator, 3),
  [5321] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_array_declarator, 3),
  [5323] = {.count = 1, .reusable = true}, SHIFT(2415),
  [5325] = {.count = 1, .reusable = true}, SHIFT(2417),
  [5327] = {.count = 1, .reusable = true}, SHIFT(2416),
  [5329] = {.count = 1, .reusable = false}, SHIFT(2417),
  [5331] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_function_declarator, 3),
  [5333] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_function_declarator, 3),
  [5335] = {.count = 1, .reusable = true}, SHIFT(2419),
  [5337] = {.count = 1, .reusable = false}, SHIFT(2420),
  [5339] = {.count = 1, .reusable = false}, SHIFT(2423),
  [5341] = {.count = 1, .reusable = false}, SHIFT(2426),
  [5343] = {.count = 1, .reusable = true}, SHIFT(2429),
  [5345] = {.count = 1, .reusable = false}, SHIFT(2430),
  [5347] = {.count = 1, .reusable = true}, SHIFT(2430),
  [5349] = {.count = 1, .reusable = false}, SHIFT(2432),
  [5351] = {.count = 1, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2),
  [5353] = {.count = 2, .reusable = false}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(15),
  [5356] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(15),
  [5359] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(1729),
  [5362] = {.count = 1, .reusable = true}, SHIFT(2433),
  [5364] = {.count = 1, .reusable = true}, SHIFT(2434),
  [5366] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_or_destructor_definition, 4),
  [5368] = {.count = 1, .reusable = false}, REDUCE(sym_constructor_or_destructor_definition, 4),
  [5370] = {.count = 1, .reusable = true}, SHIFT(2435),
  [5372] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_params, 3),
  [5374] = {.count = 1, .reusable = true}, SHIFT(2436),
  [5376] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_function_def, 5),
  [5378] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_function_def, 5),
  [5380] = {.count = 1, .reusable = false}, SHIFT(2438),
  [5382] = {.count = 1, .reusable = true}, SHIFT(2439),
  [5384] = {.count = 1, .reusable = false}, SHIFT(2440),
  [5386] = {.count = 1, .reusable = false}, SHIFT(2441),
  [5388] = {.count = 1, .reusable = true}, SHIFT(2442),
  [5390] = {.count = 1, .reusable = false}, SHIFT(2442),
  [5392] = {.count = 1, .reusable = true}, SHIFT(2444),
  [5394] = {.count = 1, .reusable = false}, SHIFT(2444),
  [5396] = {.count = 1, .reusable = false}, SHIFT(2446),
  [5398] = {.count = 1, .reusable = true}, SHIFT(2447),
  [5400] = {.count = 1, .reusable = false}, SHIFT(2448),
  [5402] = {.count = 1, .reusable = false}, SHIFT(2449),
  [5404] = {.count = 1, .reusable = false}, SHIFT(2451),
  [5406] = {.count = 1, .reusable = false}, SHIFT(2454),
  [5408] = {.count = 1, .reusable = true}, SHIFT(2457),
  [5410] = {.count = 1, .reusable = false}, SHIFT(2459),
  [5412] = {.count = 1, .reusable = true}, SHIFT(2462),
  [5414] = {.count = 1, .reusable = true}, SHIFT(2463),
  [5416] = {.count = 1, .reusable = false}, SHIFT(2463),
  [5418] = {.count = 1, .reusable = true}, SHIFT(2464),
  [5420] = {.count = 1, .reusable = false}, SHIFT(2465),
  [5422] = {.count = 1, .reusable = true}, SHIFT(2467),
  [5424] = {.count = 1, .reusable = false}, SHIFT(2468),
  [5426] = {.count = 1, .reusable = true}, SHIFT(2472),
  [5428] = {.count = 1, .reusable = true}, SHIFT(2474),
  [5430] = {.count = 1, .reusable = true}, SHIFT(2473),
  [5432] = {.count = 1, .reusable = false}, SHIFT(2474),
  [5434] = {.count = 1, .reusable = true}, SHIFT(2476),
  [5436] = {.count = 1, .reusable = true}, SHIFT(2477),
  [5438] = {.count = 1, .reusable = true}, SHIFT(2479),
  [5440] = {.count = 1, .reusable = true}, SHIFT(2480),
  [5442] = {.count = 1, .reusable = true}, SHIFT(2483),
  [5444] = {.count = 1, .reusable = true}, SHIFT(2486),
  [5446] = {.count = 1, .reusable = true}, SHIFT(2487),
  [5448] = {.count = 1, .reusable = true}, SHIFT(2488),
  [5450] = {.count = 1, .reusable = true}, SHIFT(2490),
  [5452] = {.count = 1, .reusable = true}, SHIFT(2492),
  [5454] = {.count = 1, .reusable = true}, SHIFT(2493),
  [5456] = {.count = 1, .reusable = true}, SHIFT(2496),
  [5458] = {.count = 1, .reusable = true}, SHIFT(2498),
  [5460] = {.count = 1, .reusable = true}, SHIFT(2499),
  [5462] = {.count = 2, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1020),
  [5465] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(993),
  [5468] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(994),
  [5471] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(995),
  [5474] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(996),
  [5477] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(997),
  [5480] = {.count = 2, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(998),
  [5483] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(999),
  [5486] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1000),
  [5489] = {.count = 2, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1001),
  [5492] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1002),
  [5495] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1003),
  [5498] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1004),
  [5501] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1005),
  [5504] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1006),
  [5507] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1007),
  [5510] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1008),
  [5513] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1009),
  [5516] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1010),
  [5519] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1011),
  [5522] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1012),
  [5525] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1020),
  [5528] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1013),
  [5531] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1014),
  [5534] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1015),
  [5537] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1016),
  [5540] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1017),
  [5543] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif, 3),
  [5545] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_elif, 3),
  [5547] = {.count = 1, .reusable = true}, SHIFT(2503),
  [5549] = {.count = 1, .reusable = true}, SHIFT(2505),
  [5551] = {.count = 1, .reusable = true}, SHIFT(2506),
  [5553] = {.count = 1, .reusable = false}, SHIFT(2506),
  [5555] = {.count = 1, .reusable = true}, SHIFT(2508),
  [5557] = {.count = 1, .reusable = true}, SHIFT(2509),
  [5559] = {.count = 1, .reusable = true}, SHIFT(2512),
  [5561] = {.count = 1, .reusable = true}, SHIFT(2511),
  [5563] = {.count = 1, .reusable = false}, SHIFT(2512),
  [5565] = {.count = 1, .reusable = true}, SHIFT(2513),
  [5567] = {.count = 1, .reusable = true}, SHIFT(2514),
  [5569] = {.count = 1, .reusable = true}, SHIFT(2515),
  [5571] = {.count = 1, .reusable = true}, SHIFT(2516),
  [5573] = {.count = 1, .reusable = true}, SHIFT(2518),
  [5575] = {.count = 1, .reusable = false}, SHIFT(1834),
  [5577] = {.count = 1, .reusable = true}, SHIFT(2521),
  [5579] = {.count = 1, .reusable = true}, SHIFT(2522),
  [5581] = {.count = 1, .reusable = true}, SHIFT(2523),
  [5583] = {.count = 1, .reusable = false}, SHIFT(2523),
  [5585] = {.count = 1, .reusable = true}, SHIFT(2525),
  [5587] = {.count = 1, .reusable = true}, SHIFT(2526),
  [5589] = {.count = 1, .reusable = true}, SHIFT(2527),
  [5591] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if, 5),
  [5593] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if, 5),
  [5595] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef, 5),
  [5597] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef, 5),
  [5599] = {.count = 1, .reusable = true}, SHIFT(2529),
  [5601] = {.count = 1, .reusable = true}, SHIFT(2530),
  [5603] = {.count = 1, .reusable = true}, SHIFT(2535),
  [5605] = {.count = 1, .reusable = true}, SHIFT(2536),
  [5607] = {.count = 1, .reusable = true}, REDUCE(sym__type_declarator, 3, .dynamic_precedence = -10),
  [5609] = {.count = 1, .reusable = true}, REDUCE(sym_pointer_type_declarator, 3, .dynamic_precedence = 1),
  [5611] = {.count = 1, .reusable = true}, SHIFT(2539),
  [5613] = {.count = 1, .reusable = true}, REDUCE(sym_array_type_declarator, 3),
  [5615] = {.count = 1, .reusable = true}, SHIFT(2541),
  [5617] = {.count = 1, .reusable = true}, SHIFT(2540),
  [5619] = {.count = 1, .reusable = false}, SHIFT(2541),
  [5621] = {.count = 1, .reusable = true}, REDUCE(sym_type_definition, 5),
  [5623] = {.count = 1, .reusable = false}, REDUCE(sym_type_definition, 5),
  [5625] = {.count = 1, .reusable = true}, SHIFT(2542),
  [5627] = {.count = 1, .reusable = false}, SHIFT(2543),
  [5629] = {.count = 1, .reusable = true}, SHIFT(2544),
  [5631] = {.count = 1, .reusable = false}, SHIFT(2545),
  [5633] = {.count = 1, .reusable = false}, SHIFT(2546),
  [5635] = {.count = 1, .reusable = false}, SHIFT(2548),
  [5637] = {.count = 1, .reusable = false}, SHIFT(2551),
  [5639] = {.count = 1, .reusable = true}, SHIFT(2554),
  [5641] = {.count = 1, .reusable = true}, SHIFT(2555),
  [5643] = {.count = 1, .reusable = true}, SHIFT(2556),
  [5645] = {.count = 1, .reusable = false}, SHIFT(2557),
  [5647] = {.count = 1, .reusable = true}, SHIFT(2558),
  [5649] = {.count = 1, .reusable = false}, SHIFT(2559),
  [5651] = {.count = 1, .reusable = false}, SHIFT(2560),
  [5653] = {.count = 1, .reusable = false}, SHIFT(2561),
  [5655] = {.count = 1, .reusable = true}, SHIFT(2563),
  [5657] = {.count = 1, .reusable = true}, SHIFT(2565),
  [5659] = {.count = 1, .reusable = true}, SHIFT(2566),
  [5661] = {.count = 1, .reusable = true}, SHIFT(2568),
  [5663] = {.count = 1, .reusable = false}, SHIFT(2568),
  [5665] = {.count = 1, .reusable = true}, SHIFT(2569),
  [5667] = {.count = 1, .reusable = true}, SHIFT(2572),
  [5669] = {.count = 1, .reusable = true}, SHIFT(2574),
  [5671] = {.count = 1, .reusable = true}, SHIFT(2573),
  [5673] = {.count = 1, .reusable = false}, SHIFT(2574),
  [5675] = {.count = 1, .reusable = true}, SHIFT(2576),
  [5677] = {.count = 1, .reusable = true}, SHIFT(2577),
  [5679] = {.count = 1, .reusable = true}, SHIFT(2578),
  [5681] = {.count = 1, .reusable = false}, SHIFT(2579),
  [5683] = {.count = 1, .reusable = true}, SHIFT(2581),
  [5685] = {.count = 1, .reusable = true}, SHIFT(2582),
  [5687] = {.count = 1, .reusable = true}, SHIFT(2585),
  [5689] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_else_in_compound_statement, 2),
  [5691] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_elif_in_compound_statement, 2),
  [5693] = {.count = 1, .reusable = true}, SHIFT(2589),
  [5695] = {.count = 1, .reusable = false}, SHIFT(2591),
  [5697] = {.count = 1, .reusable = true}, SHIFT(2592),
  [5699] = {.count = 1, .reusable = true}, SHIFT(2593),
  [5701] = {.count = 1, .reusable = false}, SHIFT(2593),
  [5703] = {.count = 1, .reusable = true}, SHIFT(2594),
  [5705] = {.count = 1, .reusable = false}, SHIFT(2595),
  [5707] = {.count = 1, .reusable = true}, SHIFT(2597),
  [5709] = {.count = 1, .reusable = false}, SHIFT(2598),
  [5711] = {.count = 1, .reusable = true}, SHIFT(2602),
  [5713] = {.count = 1, .reusable = true}, SHIFT(2604),
  [5715] = {.count = 1, .reusable = true}, SHIFT(2603),
  [5717] = {.count = 1, .reusable = false}, SHIFT(2604),
  [5719] = {.count = 1, .reusable = true}, SHIFT(2606),
  [5721] = {.count = 1, .reusable = true}, SHIFT(2607),
  [5723] = {.count = 1, .reusable = true}, SHIFT(2609),
  [5725] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_compound_statement, 4),
  [5727] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_compound_statement, 4),
  [5729] = {.count = 1, .reusable = true}, SHIFT(2611),
  [5731] = {.count = 1, .reusable = true}, SHIFT(2613),
  [5733] = {.count = 1, .reusable = true}, SHIFT(2615),
  [5735] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1139),
  [5738] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1113),
  [5741] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1114),
  [5744] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1115),
  [5747] = {.count = 1, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2),
  [5749] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1117),
  [5752] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1120),
  [5755] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1121),
  [5758] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1122),
  [5761] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1123),
  [5764] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1124),
  [5767] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1125),
  [5770] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1126),
  [5773] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1127),
  [5776] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1128),
  [5779] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1129),
  [5782] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1130),
  [5785] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1131),
  [5788] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1132),
  [5791] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1133),
  [5794] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1134),
  [5797] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1139),
  [5800] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1135),
  [5803] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1136),
  [5806] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4),
  [5808] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4),
  [5810] = {.count = 1, .reusable = true}, SHIFT(2616),
  [5812] = {.count = 1, .reusable = true}, SHIFT(2617),
  [5814] = {.count = 1, .reusable = false}, SHIFT(2618),
  [5816] = {.count = 1, .reusable = false}, SHIFT(2619),
  [5818] = {.count = 1, .reusable = false}, SHIFT(2620),
  [5820] = {.count = 1, .reusable = false}, SHIFT(2621),
  [5822] = {.count = 1, .reusable = false}, SHIFT(2622),
  [5824] = {.count = 1, .reusable = false}, SHIFT(2623),
  [5826] = {.count = 1, .reusable = false}, SHIFT(2624),
  [5828] = {.count = 1, .reusable = false}, SHIFT(2625),
  [5830] = {.count = 1, .reusable = true}, SHIFT(2627),
  [5832] = {.count = 1, .reusable = true}, SHIFT(2629),
  [5834] = {.count = 1, .reusable = true}, SHIFT(2628),
  [5836] = {.count = 1, .reusable = false}, SHIFT(2629),
  [5838] = {.count = 1, .reusable = true}, SHIFT(2630),
  [5840] = {.count = 1, .reusable = true}, SHIFT(2631),
  [5842] = {.count = 1, .reusable = false}, SHIFT(2631),
  [5844] = {.count = 1, .reusable = true}, SHIFT(2632),
  [5846] = {.count = 1, .reusable = false}, SHIFT(2632),
  [5848] = {.count = 2, .reusable = false}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(1165),
  [5851] = {.count = 1, .reusable = true}, SHIFT(2634),
  [5853] = {.count = 1, .reusable = false}, SHIFT(471),
  [5855] = {.count = 1, .reusable = false}, SHIFT(125),
  [5857] = {.count = 1, .reusable = true}, SHIFT(2635),
  [5859] = {.count = 1, .reusable = true}, SHIFT(2636),
  [5861] = {.count = 1, .reusable = false}, SHIFT(2636),
  [5863] = {.count = 1, .reusable = false}, SHIFT(2637),
  [5865] = {.count = 1, .reusable = false}, SHIFT(2640),
  [5867] = {.count = 1, .reusable = false}, SHIFT(2643),
  [5869] = {.count = 1, .reusable = true}, SHIFT(2646),
  [5871] = {.count = 1, .reusable = false}, SHIFT(2647),
  [5873] = {.count = 1, .reusable = true}, SHIFT(2647),
  [5875] = {.count = 1, .reusable = false}, SHIFT(2650),
  [5877] = {.count = 2, .reusable = false}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(15),
  [5880] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(15),
  [5883] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(1180),
  [5886] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(1970),
  [5889] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_pointer_declarator, 3, .dynamic_precedence = 1),
  [5891] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(1975),
  [5894] = {.count = 1, .reusable = true}, SHIFT(2652),
  [5896] = {.count = 1, .reusable = false}, SHIFT(2652),
  [5898] = {.count = 1, .reusable = true}, SHIFT(2653),
  [5900] = {.count = 1, .reusable = false}, SHIFT(2654),
  [5902] = {.count = 1, .reusable = true}, SHIFT(2654),
  [5904] = {.count = 1, .reusable = false}, SHIFT(2657),
  [5906] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(1205),
  [5909] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(1980),
  [5912] = {.count = 1, .reusable = false}, SHIFT(152),
  [5914] = {.count = 1, .reusable = false}, SHIFT(156),
  [5916] = {.count = 1, .reusable = true}, SHIFT(2658),
  [5918] = {.count = 1, .reusable = true}, SHIFT(2659),
  [5920] = {.count = 1, .reusable = false}, SHIFT(2659),
  [5922] = {.count = 1, .reusable = true}, SHIFT(2660),
  [5924] = {.count = 1, .reusable = false}, SHIFT(2660),
  [5926] = {.count = 1, .reusable = true}, REDUCE(sym_enumerator, 3),
  [5928] = {.count = 1, .reusable = true}, REDUCE(sym_enumerator_list, 4),
  [5930] = {.count = 1, .reusable = false}, REDUCE(sym_enumerator_list, 4),
  [5932] = {.count = 1, .reusable = true}, REDUCE(aux_sym_enumerator_list_repeat1, 2),
  [5934] = {.count = 1, .reusable = true}, SHIFT(2661),
  [5936] = {.count = 2, .reusable = true}, REDUCE(aux_sym_enumerator_list_repeat1, 2), SHIFT_REPEAT(2662),
  [5939] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_field_declaration_list, 3),
  [5941] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_field_declaration_list, 3),
  [5943] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_else_in_field_declaration_list, 1),
  [5945] = {.count = 1, .reusable = false}, SHIFT(2664),
  [5947] = {.count = 1, .reusable = true}, SHIFT(2665),
  [5949] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3),
  [5951] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3),
  [5953] = {.count = 1, .reusable = true}, SHIFT(2668),
  [5955] = {.count = 1, .reusable = true}, SHIFT(2670),
  [5957] = {.count = 1, .reusable = true}, SHIFT(2672),
  [5959] = {.count = 1, .reusable = true}, SHIFT(2673),
  [5961] = {.count = 1, .reusable = true}, SHIFT(2674),
  [5963] = {.count = 1, .reusable = false}, REDUCE(sym_friend_declaration, 3),
  [5965] = {.count = 1, .reusable = true}, REDUCE(sym_friend_declaration, 3),
  [5967] = {.count = 1, .reusable = true}, SHIFT(2678),
  [5969] = {.count = 1, .reusable = true}, SHIFT(2679),
  [5971] = {.count = 1, .reusable = true}, SHIFT(2681),
  [5973] = {.count = 1, .reusable = true}, SHIFT(2682),
  [5975] = {.count = 1, .reusable = true}, REDUCE(sym_pointer_field_declarator, 2, .dynamic_precedence = 1),
  [5977] = {.count = 1, .reusable = true}, SHIFT(2684),
  [5979] = {.count = 1, .reusable = true}, SHIFT(2686),
  [5981] = {.count = 1, .reusable = true}, REDUCE(sym_reference_field_declarator, 2, .dynamic_precedence = 1),
  [5983] = {.count = 1, .reusable = true}, SHIFT(2687),
  [5985] = {.count = 1, .reusable = false}, SHIFT(2688),
  [5987] = {.count = 1, .reusable = true}, SHIFT(2688),
  [5989] = {.count = 1, .reusable = true}, SHIFT(2689),
  [5991] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration, 3),
  [5993] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration, 3),
  [5995] = {.count = 1, .reusable = true}, SHIFT(2692),
  [5997] = {.count = 1, .reusable = true}, SHIFT(2690),
  [5999] = {.count = 1, .reusable = true}, SHIFT(2691),
  [6001] = {.count = 1, .reusable = false}, SHIFT(2692),
  [6003] = {.count = 1, .reusable = true}, SHIFT(2694),
  [6005] = {.count = 1, .reusable = false}, SHIFT(2694),
  [6007] = {.count = 1, .reusable = false}, REDUCE(sym_inline_method_definition, 3),
  [6009] = {.count = 1, .reusable = true}, REDUCE(sym_inline_method_definition, 3),
  [6011] = {.count = 1, .reusable = true}, REDUCE(sym_function_field_declarator, 2),
  [6013] = {.count = 1, .reusable = true}, SHIFT(2695),
  [6015] = {.count = 1, .reusable = true}, SHIFT(2696),
  [6017] = {.count = 1, .reusable = true}, SHIFT(2697),
  [6019] = {.count = 1, .reusable = false}, SHIFT(2701),
  [6021] = {.count = 1, .reusable = false}, SHIFT(2700),
  [6023] = {.count = 1, .reusable = false}, SHIFT(2699),
  [6025] = {.count = 1, .reusable = true}, SHIFT(2702),
  [6027] = {.count = 1, .reusable = true}, SHIFT(2703),
  [6029] = {.count = 1, .reusable = true}, SHIFT(2704),
  [6031] = {.count = 1, .reusable = true}, SHIFT(2705),
  [6033] = {.count = 1, .reusable = true}, REDUCE(aux_sym_base_class_clause_repeat1, 2, .alias_sequence_id = 2),
  [6035] = {.count = 1, .reusable = true}, SHIFT(2707),
  [6037] = {.count = 1, .reusable = true}, REDUCE(aux_sym_base_class_clause_repeat1, 2),
  [6039] = {.count = 2, .reusable = true}, REDUCE(aux_sym_base_class_clause_repeat1, 2), SHIFT_REPEAT(1280),
  [6042] = {.count = 1, .reusable = true}, REDUCE(sym_base_class_clause, 4, .alias_sequence_id = 10),
  [6044] = {.count = 1, .reusable = true}, REDUCE(sym_base_class_clause, 4),
  [6046] = {.count = 1, .reusable = true}, REDUCE(sym_struct_specifier, 5, .alias_sequence_id = 2),
  [6048] = {.count = 1, .reusable = false}, REDUCE(sym_struct_specifier, 5, .alias_sequence_id = 2),
  [6050] = {.count = 1, .reusable = true}, REDUCE(sym_struct_specifier, 5),
  [6052] = {.count = 1, .reusable = false}, REDUCE(sym_struct_specifier, 5),
  [6054] = {.count = 1, .reusable = true}, REDUCE(sym_union_specifier, 5, .alias_sequence_id = 2),
  [6056] = {.count = 1, .reusable = false}, REDUCE(sym_union_specifier, 5, .alias_sequence_id = 2),
  [6058] = {.count = 1, .reusable = true}, REDUCE(sym_union_specifier, 5),
  [6060] = {.count = 1, .reusable = false}, REDUCE(sym_union_specifier, 5),
  [6062] = {.count = 1, .reusable = true}, SHIFT(2710),
  [6064] = {.count = 1, .reusable = true}, SHIFT(2711),
  [6066] = {.count = 1, .reusable = false}, SHIFT(2711),
  [6068] = {.count = 1, .reusable = true}, SHIFT(2712),
  [6070] = {.count = 1, .reusable = false}, SHIFT(2712),
  [6072] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2053),
  [6075] = {.count = 1, .reusable = true}, SHIFT(2713),
  [6077] = {.count = 1, .reusable = true}, SHIFT(2714),
  [6079] = {.count = 1, .reusable = true}, SHIFT(2715),
  [6081] = {.count = 1, .reusable = true}, SHIFT(2717),
  [6083] = {.count = 1, .reusable = false}, SHIFT(2717),
  [6085] = {.count = 1, .reusable = true}, SHIFT(2718),
  [6087] = {.count = 1, .reusable = true}, SHIFT(2720),
  [6089] = {.count = 1, .reusable = false}, SHIFT(2721),
  [6091] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5),
  [6093] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5),
  [6095] = {.count = 1, .reusable = false}, SHIFT(2723),
  [6097] = {.count = 1, .reusable = true}, SHIFT(2724),
  [6099] = {.count = 1, .reusable = false}, SHIFT(192),
  [6101] = {.count = 1, .reusable = false}, SHIFT(193),
  [6103] = {.count = 1, .reusable = true}, SHIFT(2726),
  [6105] = {.count = 1, .reusable = true}, SHIFT(2727),
  [6107] = {.count = 1, .reusable = false}, SHIFT(2727),
  [6109] = {.count = 1, .reusable = true}, SHIFT(2728),
  [6111] = {.count = 1, .reusable = true}, SHIFT(2729),
  [6113] = {.count = 1, .reusable = false}, SHIFT(2729),
  [6115] = {.count = 1, .reusable = true}, SHIFT(2730),
  [6117] = {.count = 1, .reusable = true}, SHIFT(2731),
  [6119] = {.count = 1, .reusable = false}, SHIFT(2732),
  [6121] = {.count = 1, .reusable = false}, SHIFT(2733),
  [6123] = {.count = 1, .reusable = false}, SHIFT(2734),
  [6125] = {.count = 1, .reusable = false}, SHIFT(2735),
  [6127] = {.count = 1, .reusable = false}, SHIFT(2736),
  [6129] = {.count = 1, .reusable = false}, SHIFT(2737),
  [6131] = {.count = 1, .reusable = false}, SHIFT(2738),
  [6133] = {.count = 1, .reusable = false}, SHIFT(2739),
  [6135] = {.count = 1, .reusable = true}, SHIFT(2741),
  [6137] = {.count = 1, .reusable = true}, SHIFT(2743),
  [6139] = {.count = 1, .reusable = true}, SHIFT(2742),
  [6141] = {.count = 1, .reusable = false}, SHIFT(2743),
  [6143] = {.count = 1, .reusable = true}, SHIFT(2744),
  [6145] = {.count = 1, .reusable = true}, SHIFT(2745),
  [6147] = {.count = 1, .reusable = false}, SHIFT(2745),
  [6149] = {.count = 1, .reusable = true}, SHIFT(2746),
  [6151] = {.count = 1, .reusable = false}, SHIFT(2746),
  [6153] = {.count = 2, .reusable = true}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(1382),
  [6156] = {.count = 1, .reusable = true}, SHIFT(2748),
  [6158] = {.count = 1, .reusable = true}, SHIFT(2750),
  [6160] = {.count = 1, .reusable = true}, SHIFT(2751),
  [6162] = {.count = 1, .reusable = true}, SHIFT(2753),
  [6164] = {.count = 1, .reusable = false}, SHIFT(2753),
  [6166] = {.count = 1, .reusable = true}, SHIFT(2754),
  [6168] = {.count = 1, .reusable = true}, SHIFT(2755),
  [6170] = {.count = 1, .reusable = true}, SHIFT(2756),
  [6172] = {.count = 1, .reusable = true}, SHIFT(2757),
  [6174] = {.count = 1, .reusable = true}, REDUCE(sym_subscript_designator, 3),
  [6176] = {.count = 1, .reusable = true}, SHIFT(2758),
  [6178] = {.count = 1, .reusable = true}, SHIFT(2759),
  [6180] = {.count = 1, .reusable = false}, SHIFT(2759),
  [6182] = {.count = 1, .reusable = true}, SHIFT(2760),
  [6184] = {.count = 1, .reusable = false}, SHIFT(2760),
  [6186] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2122),
  [6189] = {.count = 1, .reusable = true}, SHIFT(2761),
  [6191] = {.count = 1, .reusable = true}, REDUCE(sym_initializer_list, 4),
  [6193] = {.count = 1, .reusable = false}, REDUCE(sym_initializer_list, 4),
  [6195] = {.count = 1, .reusable = true}, REDUCE(aux_sym_initializer_list_repeat1, 2),
  [6197] = {.count = 1, .reusable = true}, SHIFT(2762),
  [6199] = {.count = 1, .reusable = true}, SHIFT(2763),
  [6201] = {.count = 2, .reusable = true}, REDUCE(aux_sym_initializer_list_repeat1, 2), SHIFT_REPEAT(2764),
  [6204] = {.count = 1, .reusable = true}, SHIFT(2765),
  [6206] = {.count = 1, .reusable = true}, REDUCE(sym_initializer_pair, 3),
  [6208] = {.count = 1, .reusable = false}, SHIFT(228),
  [6210] = {.count = 1, .reusable = false}, SHIFT(229),
  [6212] = {.count = 1, .reusable = true}, SHIFT(2766),
  [6214] = {.count = 1, .reusable = true}, SHIFT(2767),
  [6216] = {.count = 1, .reusable = false}, SHIFT(2767),
  [6218] = {.count = 1, .reusable = true}, SHIFT(2768),
  [6220] = {.count = 1, .reusable = false}, SHIFT(2768),
  [6222] = {.count = 1, .reusable = true}, SHIFT(2769),
  [6224] = {.count = 1, .reusable = false}, SHIFT(2769),
  [6226] = {.count = 1, .reusable = false}, SHIFT(2771),
  [6228] = {.count = 1, .reusable = false}, SHIFT(2772),
  [6230] = {.count = 1, .reusable = true}, SHIFT(2773),
  [6232] = {.count = 1, .reusable = true}, SHIFT(2774),
  [6234] = {.count = 1, .reusable = true}, SHIFT(2775),
  [6236] = {.count = 1, .reusable = true}, SHIFT(2777),
  [6238] = {.count = 1, .reusable = true}, SHIFT(2779),
  [6240] = {.count = 1, .reusable = true}, SHIFT(2781),
  [6242] = {.count = 1, .reusable = false}, SHIFT(2781),
  [6244] = {.count = 1, .reusable = true}, SHIFT(2782),
  [6246] = {.count = 1, .reusable = true}, SHIFT(2783),
  [6248] = {.count = 1, .reusable = true}, SHIFT(2786),
  [6250] = {.count = 1, .reusable = true}, SHIFT(2800),
  [6252] = {.count = 1, .reusable = true}, SHIFT(2807),
  [6254] = {.count = 1, .reusable = false}, SHIFT(2807),
  [6256] = {.count = 1, .reusable = true}, SHIFT(2810),
  [6258] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2203),
  [6261] = {.count = 1, .reusable = true}, SHIFT(2811),
  [6263] = {.count = 1, .reusable = true}, SHIFT(2814),
  [6265] = {.count = 1, .reusable = false}, SHIFT(2815),
  [6267] = {.count = 1, .reusable = true}, SHIFT(2816),
  [6269] = {.count = 1, .reusable = true}, REDUCE(aux_sym_template_argument_list_repeat1, 2),
  [6271] = {.count = 1, .reusable = true}, REDUCE(aux_sym_template_argument_list_repeat1, 2, .dynamic_precedence = 1),
  [6273] = {.count = 1, .reusable = true}, SHIFT(2817),
  [6275] = {.count = 1, .reusable = true}, SHIFT(2819),
  [6277] = {.count = 1, .reusable = true}, SHIFT(2820),
  [6279] = {.count = 2, .reusable = false}, REDUCE(sym_field_expression, 3, .alias_sequence_id = 9), SHIFT(1466),
  [6282] = {.count = 1, .reusable = true}, SHIFT(1466),
  [6284] = {.count = 1, .reusable = true}, REDUCE(sym_template_argument_list, 4),
  [6286] = {.count = 1, .reusable = false}, REDUCE(sym_template_argument_list, 4),
  [6288] = {.count = 2, .reusable = true}, REDUCE(aux_sym_template_argument_list_repeat1, 2), SHIFT_REPEAT(1493),
  [6291] = {.count = 1, .reusable = true}, REDUCE(sym_template_argument_list, 4, .dynamic_precedence = 1),
  [6293] = {.count = 1, .reusable = false}, REDUCE(sym_template_argument_list, 4, .dynamic_precedence = 1),
  [6295] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(770),
  [6298] = {.count = 1, .reusable = true}, SHIFT(2823),
  [6300] = {.count = 1, .reusable = true}, REDUCE(sym_class_specifier, 5, .alias_sequence_id = 2),
  [6302] = {.count = 1, .reusable = false}, REDUCE(sym_class_specifier, 5, .alias_sequence_id = 2),
  [6304] = {.count = 1, .reusable = true}, REDUCE(sym_class_specifier, 5),
  [6306] = {.count = 1, .reusable = false}, REDUCE(sym_class_specifier, 5),
  [6308] = {.count = 1, .reusable = false}, SHIFT(2827),
  [6310] = {.count = 1, .reusable = false}, SHIFT(2826),
  [6312] = {.count = 1, .reusable = false}, SHIFT(2825),
  [6314] = {.count = 1, .reusable = true}, SHIFT(2829),
  [6316] = {.count = 1, .reusable = true}, SHIFT(2831),
  [6318] = {.count = 1, .reusable = false}, SHIFT(2831),
  [6320] = {.count = 1, .reusable = true}, SHIFT(2832),
  [6322] = {.count = 1, .reusable = true}, SHIFT(2833),
  [6324] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter_declaration, 3),
  [6326] = {.count = 1, .reusable = true}, REDUCE(aux_sym_template_parameter_list_repeat1, 2),
  [6328] = {.count = 1, .reusable = false}, REDUCE(sym_template_parameter_list, 4),
  [6330] = {.count = 1, .reusable = true}, REDUCE(sym_template_parameter_list, 4),
  [6332] = {.count = 2, .reusable = true}, REDUCE(aux_sym_template_parameter_list_repeat1, 2), SHIFT_REPEAT(1542),
  [6335] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2262),
  [6338] = {.count = 1, .reusable = true}, SHIFT(2834),
  [6340] = {.count = 1, .reusable = false}, SHIFT(2835),
  [6342] = {.count = 1, .reusable = true}, SHIFT(2835),
  [6344] = {.count = 1, .reusable = false}, SHIFT(2838),
  [6346] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(1551),
  [6349] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(2266),
  [6352] = {.count = 1, .reusable = true}, SHIFT(2839),
  [6354] = {.count = 1, .reusable = true}, SHIFT(2840),
  [6356] = {.count = 1, .reusable = false}, SHIFT(2840),
  [6358] = {.count = 1, .reusable = true}, SHIFT(2842),
  [6360] = {.count = 1, .reusable = true}, SHIFT(2841),
  [6362] = {.count = 1, .reusable = false}, SHIFT(2842),
  [6364] = {.count = 1, .reusable = true}, SHIFT(2843),
  [6366] = {.count = 1, .reusable = true}, SHIFT(2844),
  [6368] = {.count = 1, .reusable = true}, SHIFT(2850),
  [6370] = {.count = 1, .reusable = true}, SHIFT(2851),
  [6372] = {.count = 1, .reusable = true}, REDUCE(sym_alias_declaration, 5, .alias_sequence_id = 2),
  [6374] = {.count = 1, .reusable = false}, REDUCE(sym_alias_declaration, 5, .alias_sequence_id = 2),
  [6376] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2284),
  [6379] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 3),
  [6381] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 3),
  [6383] = {.count = 1, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2),
  [6385] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 4),
  [6387] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 4),
  [6389] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(1581),
  [6392] = {.count = 1, .reusable = true}, SHIFT(2853),
  [6394] = {.count = 1, .reusable = true}, SHIFT(2854),
  [6396] = {.count = 1, .reusable = true}, REDUCE(sym_new_declarator, 3),
  [6398] = {.count = 1, .reusable = false}, REDUCE(sym_new_declarator, 3),
  [6400] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 5),
  [6402] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 5),
  [6404] = {.count = 1, .reusable = true}, REDUCE(sym_delete_expression, 5),
  [6406] = {.count = 1, .reusable = false}, REDUCE(sym_delete_expression, 5),
  [6408] = {.count = 1, .reusable = true}, REDUCE(aux_sym_structured_binding_declarator_repeat1, 2),
  [6410] = {.count = 1, .reusable = true}, REDUCE(sym_structured_binding_declarator, 4),
  [6412] = {.count = 2, .reusable = true}, REDUCE(aux_sym_structured_binding_declarator_repeat1, 2), SHIFT_REPEAT(1615),
  [6415] = {.count = 1, .reusable = true}, SHIFT(2862),
  [6417] = {.count = 1, .reusable = true}, SHIFT(2864),
  [6419] = {.count = 1, .reusable = true}, SHIFT(2865),
  [6421] = {.count = 1, .reusable = false}, SHIFT(2866),
  [6423] = {.count = 1, .reusable = false}, SHIFT(2867),
  [6425] = {.count = 1, .reusable = true}, SHIFT(2869),
  [6427] = {.count = 1, .reusable = true}, SHIFT(2868),
  [6429] = {.count = 1, .reusable = false}, SHIFT(2869),
  [6431] = {.count = 1, .reusable = true}, SHIFT(2870),
  [6433] = {.count = 1, .reusable = false}, SHIFT(2870),
  [6435] = {.count = 1, .reusable = true}, SHIFT(2871),
  [6437] = {.count = 1, .reusable = false}, SHIFT(2871),
  [6439] = {.count = 1, .reusable = true}, SHIFT(2872),
  [6441] = {.count = 1, .reusable = false}, SHIFT(2872),
  [6443] = {.count = 1, .reusable = true}, SHIFT(2873),
  [6445] = {.count = 1, .reusable = false}, SHIFT(2873),
  [6447] = {.count = 1, .reusable = true}, SHIFT(2874),
  [6449] = {.count = 1, .reusable = false}, SHIFT(2874),
  [6451] = {.count = 1, .reusable = true}, SHIFT(2875),
  [6453] = {.count = 1, .reusable = false}, SHIFT(2875),
  [6455] = {.count = 1, .reusable = true}, SHIFT(2876),
  [6457] = {.count = 1, .reusable = false}, SHIFT(2876),
  [6459] = {.count = 1, .reusable = true}, SHIFT(2877),
  [6461] = {.count = 1, .reusable = false}, SHIFT(2877),
  [6463] = {.count = 1, .reusable = true}, SHIFT(2878),
  [6465] = {.count = 1, .reusable = false}, SHIFT(2878),
  [6467] = {.count = 1, .reusable = true}, SHIFT(2879),
  [6469] = {.count = 1, .reusable = false}, SHIFT(2879),
  [6471] = {.count = 1, .reusable = true}, SHIFT(2880),
  [6473] = {.count = 1, .reusable = false}, SHIFT(2880),
  [6475] = {.count = 1, .reusable = true}, SHIFT(2881),
  [6477] = {.count = 1, .reusable = false}, SHIFT(2881),
  [6479] = {.count = 1, .reusable = false}, SHIFT(2883),
  [6481] = {.count = 1, .reusable = false}, SHIFT(2884),
  [6483] = {.count = 1, .reusable = false}, SHIFT(2885),
  [6485] = {.count = 1, .reusable = false}, SHIFT(2888),
  [6487] = {.count = 1, .reusable = false}, SHIFT(2891),
  [6489] = {.count = 1, .reusable = true}, SHIFT(2894),
  [6491] = {.count = 1, .reusable = false}, SHIFT(2895),
  [6493] = {.count = 1, .reusable = true}, SHIFT(2895),
  [6495] = {.count = 1, .reusable = false}, SHIFT(2898),
  [6497] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(1640),
  [6500] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(2348),
  [6503] = {.count = 1, .reusable = true}, REDUCE(sym_structured_binding_declaration, 5),
  [6505] = {.count = 1, .reusable = false}, REDUCE(sym_structured_binding_declaration, 5),
  [6507] = {.count = 1, .reusable = true}, REDUCE(aux_sym_parameter_list_repeat1, 2),
  [6509] = {.count = 1, .reusable = true}, REDUCE(sym_parameter_list, 4),
  [6511] = {.count = 1, .reusable = false}, REDUCE(sym_parameter_list, 4),
  [6513] = {.count = 2, .reusable = true}, REDUCE(aux_sym_parameter_list_repeat1, 2), SHIFT_REPEAT(1647),
  [6516] = {.count = 1, .reusable = true}, SHIFT(2899),
  [6518] = {.count = 1, .reusable = true}, SHIFT(2902),
  [6520] = {.count = 1, .reusable = false}, SHIFT(2902),
  [6522] = {.count = 1, .reusable = true}, SHIFT(2903),
  [6524] = {.count = 1, .reusable = true}, SHIFT(2904),
  [6526] = {.count = 1, .reusable = true}, SHIFT(2905),
  [6528] = {.count = 1, .reusable = false}, SHIFT(2908),
  [6530] = {.count = 1, .reusable = false}, SHIFT(2907),
  [6532] = {.count = 1, .reusable = false}, SHIFT(2906),
  [6534] = {.count = 1, .reusable = true}, SHIFT(2909),
  [6536] = {.count = 1, .reusable = true}, SHIFT(2910),
  [6538] = {.count = 1, .reusable = true}, SHIFT(2911),
  [6540] = {.count = 1, .reusable = false}, SHIFT(2911),
  [6542] = {.count = 1, .reusable = true}, SHIFT(2912),
  [6544] = {.count = 1, .reusable = false}, SHIFT(2912),
  [6546] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2370),
  [6549] = {.count = 1, .reusable = true}, SHIFT(2913),
  [6551] = {.count = 1, .reusable = true}, SHIFT(2914),
  [6553] = {.count = 1, .reusable = true}, REDUCE(sym_array_declarator, 5),
  [6555] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_reference_declarator, 1),
  [6557] = {.count = 1, .reusable = true}, REDUCE(sym_trailing_return_type, 3),
  [6559] = {.count = 1, .reusable = false}, REDUCE(sym_trailing_return_type, 3),
  [6561] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_function_declarator, 1),
  [6563] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2400),
  [6566] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_field_identifier, 3, .alias_sequence_id = 14),
  [6568] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_field_identifier, 3, .alias_sequence_id = 6),
  [6570] = {.count = 1, .reusable = true}, REDUCE(aux_sym_field_initializer_list_repeat1, 2),
  [6572] = {.count = 2, .reusable = true}, REDUCE(aux_sym_field_initializer_list_repeat1, 2), SHIFT_REPEAT(1700),
  [6575] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_field_identifier, 3, .alias_sequence_id = 9),
  [6577] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_field_identifier, 3),
  [6579] = {.count = 1, .reusable = true}, REDUCE(sym_conditional_expression, 5),
  [6581] = {.count = 2, .reusable = true}, REDUCE(sym_scoped_field_identifier, 3, .alias_sequence_id = 14), REDUCE(sym_scoped_type_identifier, 3, .alias_sequence_id = 7),
  [6584] = {.count = 2, .reusable = true}, REDUCE(sym_scoped_field_identifier, 3, .alias_sequence_id = 9), REDUCE(sym_scoped_type_identifier, 3, .alias_sequence_id = 10),
  [6587] = {.count = 1, .reusable = false}, SHIFT(2920),
  [6589] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(2414),
  [6592] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_array_declarator, 4),
  [6594] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_array_declarator, 4),
  [6596] = {.count = 1, .reusable = true}, SHIFT(2921),
  [6598] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_function_declarator, 4),
  [6600] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_function_declarator, 4),
  [6602] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2432),
  [6605] = {.count = 1, .reusable = true}, REDUCE(aux_sym_preproc_params_repeat1, 2),
  [6607] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_params, 4),
  [6609] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_params_repeat1, 2), SHIFT_REPEAT(1737),
  [6612] = {.count = 1, .reusable = true}, SHIFT(2925),
  [6614] = {.count = 1, .reusable = true}, SHIFT(2926),
  [6616] = {.count = 1, .reusable = true}, SHIFT(2927),
  [6618] = {.count = 1, .reusable = false}, SHIFT(2928),
  [6620] = {.count = 1, .reusable = true}, SHIFT(2929),
  [6622] = {.count = 1, .reusable = false}, SHIFT(2930),
  [6624] = {.count = 1, .reusable = false}, SHIFT(2931),
  [6626] = {.count = 1, .reusable = true}, SHIFT(2932),
  [6628] = {.count = 1, .reusable = false}, SHIFT(2932),
  [6630] = {.count = 1, .reusable = true}, SHIFT(2934),
  [6632] = {.count = 1, .reusable = false}, SHIFT(2934),
  [6634] = {.count = 1, .reusable = true}, SHIFT(2936),
  [6636] = {.count = 1, .reusable = true}, SHIFT(2938),
  [6638] = {.count = 1, .reusable = true}, SHIFT(2939),
  [6640] = {.count = 1, .reusable = false}, SHIFT(2939),
  [6642] = {.count = 1, .reusable = true}, SHIFT(2941),
  [6644] = {.count = 1, .reusable = true}, SHIFT(2942),
  [6646] = {.count = 1, .reusable = true}, SHIFT(2945),
  [6648] = {.count = 1, .reusable = true}, SHIFT(2944),
  [6650] = {.count = 1, .reusable = false}, SHIFT(2945),
  [6652] = {.count = 1, .reusable = true}, SHIFT(2946),
  [6654] = {.count = 1, .reusable = true}, SHIFT(2947),
  [6656] = {.count = 1, .reusable = true}, SHIFT(2948),
  [6658] = {.count = 1, .reusable = true}, SHIFT(2949),
  [6660] = {.count = 1, .reusable = true}, SHIFT(2951),
  [6662] = {.count = 1, .reusable = false}, SHIFT(2490),
  [6664] = {.count = 1, .reusable = true}, SHIFT(2954),
  [6666] = {.count = 1, .reusable = true}, SHIFT(2955),
  [6668] = {.count = 1, .reusable = true}, SHIFT(2956),
  [6670] = {.count = 1, .reusable = false}, SHIFT(2956),
  [6672] = {.count = 1, .reusable = true}, SHIFT(2958),
  [6674] = {.count = 1, .reusable = true}, SHIFT(2959),
  [6676] = {.count = 1, .reusable = true}, SHIFT(2960),
  [6678] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif, 4),
  [6680] = {.count = 1, .reusable = true}, SHIFT(2962),
  [6682] = {.count = 1, .reusable = false}, SHIFT(2963),
  [6684] = {.count = 1, .reusable = false}, SHIFT(2964),
  [6686] = {.count = 1, .reusable = false}, SHIFT(2965),
  [6688] = {.count = 1, .reusable = false}, SHIFT(2966),
  [6690] = {.count = 1, .reusable = false}, SHIFT(2967),
  [6692] = {.count = 1, .reusable = false}, SHIFT(2968),
  [6694] = {.count = 1, .reusable = false}, SHIFT(2969),
  [6696] = {.count = 1, .reusable = false}, SHIFT(2970),
  [6698] = {.count = 1, .reusable = true}, SHIFT(2972),
  [6700] = {.count = 1, .reusable = true}, SHIFT(2973),
  [6702] = {.count = 1, .reusable = false}, SHIFT(2973),
  [6704] = {.count = 1, .reusable = true}, SHIFT(2976),
  [6706] = {.count = 1, .reusable = true}, SHIFT(2975),
  [6708] = {.count = 1, .reusable = false}, SHIFT(2976),
  [6710] = {.count = 1, .reusable = true}, SHIFT(2977),
  [6712] = {.count = 1, .reusable = true}, SHIFT(2978),
  [6714] = {.count = 1, .reusable = false}, SHIFT(2978),
  [6716] = {.count = 1, .reusable = true}, SHIFT(2979),
  [6718] = {.count = 1, .reusable = false}, SHIFT(2979),
  [6720] = {.count = 1, .reusable = true}, SHIFT(2980),
  [6722] = {.count = 2, .reusable = false}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(1834),
  [6725] = {.count = 1, .reusable = true}, SHIFT(2982),
  [6727] = {.count = 1, .reusable = true}, SHIFT(2983),
  [6729] = {.count = 1, .reusable = true}, REDUCE(sym_array_type_declarator, 4),
  [6731] = {.count = 1, .reusable = true}, SHIFT(2984),
  [6733] = {.count = 1, .reusable = false}, SHIFT(2985),
  [6735] = {.count = 1, .reusable = true}, SHIFT(2986),
  [6737] = {.count = 1, .reusable = false}, SHIFT(2987),
  [6739] = {.count = 1, .reusable = false}, SHIFT(2988),
  [6741] = {.count = 1, .reusable = true}, SHIFT(2989),
  [6743] = {.count = 1, .reusable = false}, SHIFT(2989),
  [6745] = {.count = 1, .reusable = true}, SHIFT(2991),
  [6747] = {.count = 1, .reusable = false}, SHIFT(2991),
  [6749] = {.count = 1, .reusable = false}, SHIFT(2993),
  [6751] = {.count = 1, .reusable = true}, SHIFT(2994),
  [6753] = {.count = 1, .reusable = false}, SHIFT(2995),
  [6755] = {.count = 1, .reusable = false}, SHIFT(2996),
  [6757] = {.count = 1, .reusable = false}, SHIFT(2998),
  [6759] = {.count = 1, .reusable = false}, SHIFT(3001),
  [6761] = {.count = 1, .reusable = true}, SHIFT(3004),
  [6763] = {.count = 1, .reusable = false}, SHIFT(3006),
  [6765] = {.count = 1, .reusable = true}, SHIFT(3007),
  [6767] = {.count = 1, .reusable = true}, SHIFT(3008),
  [6769] = {.count = 1, .reusable = false}, SHIFT(3008),
  [6771] = {.count = 1, .reusable = true}, SHIFT(3009),
  [6773] = {.count = 1, .reusable = false}, SHIFT(3010),
  [6775] = {.count = 1, .reusable = true}, SHIFT(3012),
  [6777] = {.count = 1, .reusable = false}, SHIFT(3013),
  [6779] = {.count = 1, .reusable = true}, SHIFT(3017),
  [6781] = {.count = 1, .reusable = true}, SHIFT(3019),
  [6783] = {.count = 1, .reusable = true}, SHIFT(3018),
  [6785] = {.count = 1, .reusable = false}, SHIFT(3019),
  [6787] = {.count = 1, .reusable = true}, SHIFT(3021),
  [6789] = {.count = 1, .reusable = true}, SHIFT(3022),
  [6791] = {.count = 1, .reusable = true}, SHIFT(3024),
  [6793] = {.count = 1, .reusable = true}, SHIFT(3026),
  [6795] = {.count = 1, .reusable = true}, SHIFT(3028),
  [6797] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1908),
  [6800] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1886),
  [6803] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1887),
  [6806] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1888),
  [6809] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1889),
  [6812] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1890),
  [6815] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1891),
  [6818] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1892),
  [6821] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1893),
  [6824] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1894),
  [6827] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1895),
  [6830] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1896),
  [6833] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1897),
  [6836] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1898),
  [6839] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1899),
  [6842] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1900),
  [6845] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1901),
  [6848] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1902),
  [6851] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1903),
  [6854] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1904),
  [6857] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1908),
  [6860] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1905),
  [6863] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(1906),
  [6866] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_compound_statement, 3),
  [6868] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_elif_in_compound_statement, 3),
  [6870] = {.count = 1, .reusable = true}, SHIFT(3031),
  [6872] = {.count = 1, .reusable = true}, SHIFT(3033),
  [6874] = {.count = 1, .reusable = true}, SHIFT(3034),
  [6876] = {.count = 1, .reusable = false}, SHIFT(3034),
  [6878] = {.count = 1, .reusable = true}, SHIFT(3036),
  [6880] = {.count = 1, .reusable = true}, SHIFT(3039),
  [6882] = {.count = 1, .reusable = true}, SHIFT(3038),
  [6884] = {.count = 1, .reusable = false}, SHIFT(3039),
  [6886] = {.count = 1, .reusable = true}, SHIFT(3040),
  [6888] = {.count = 1, .reusable = true}, SHIFT(3041),
  [6890] = {.count = 1, .reusable = false}, SHIFT(2609),
  [6892] = {.count = 1, .reusable = true}, SHIFT(3044),
  [6894] = {.count = 1, .reusable = true}, SHIFT(3045),
  [6896] = {.count = 1, .reusable = false}, SHIFT(3045),
  [6898] = {.count = 1, .reusable = true}, SHIFT(3047),
  [6900] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_compound_statement, 5),
  [6902] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_compound_statement, 5),
  [6904] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 5),
  [6906] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 5),
  [6908] = {.count = 1, .reusable = true}, SHIFT(3048),
  [6910] = {.count = 1, .reusable = true}, SHIFT(3049),
  [6912] = {.count = 1, .reusable = true}, SHIFT(3051),
  [6914] = {.count = 1, .reusable = false}, SHIFT(3051),
  [6916] = {.count = 1, .reusable = true}, SHIFT(3052),
  [6918] = {.count = 1, .reusable = true}, SHIFT(3054),
  [6920] = {.count = 1, .reusable = false}, SHIFT(3055),
  [6922] = {.count = 1, .reusable = false}, SHIFT(3057),
  [6924] = {.count = 1, .reusable = true}, SHIFT(3060),
  [6926] = {.count = 1, .reusable = true}, SHIFT(3062),
  [6928] = {.count = 1, .reusable = false}, SHIFT(3062),
  [6930] = {.count = 1, .reusable = true}, SHIFT(3063),
  [6932] = {.count = 1, .reusable = true}, SHIFT(3064),
  [6934] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2650),
  [6937] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2657),
  [6940] = {.count = 1, .reusable = true}, REDUCE(sym_enumerator_list, 5),
  [6942] = {.count = 1, .reusable = false}, REDUCE(sym_enumerator_list, 5),
  [6944] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_else_in_field_declaration_list, 2),
  [6946] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_field_declaration_list, 2),
  [6948] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_field_declaration_list, 4),
  [6950] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_field_declaration_list, 4),
  [6952] = {.count = 1, .reusable = true}, SHIFT(3078),
  [6954] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4),
  [6956] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4),
  [6958] = {.count = 1, .reusable = true}, SHIFT(3079),
  [6960] = {.count = 1, .reusable = true}, SHIFT(3080),
  [6962] = {.count = 1, .reusable = true}, SHIFT(3081),
  [6964] = {.count = 1, .reusable = true}, SHIFT(3082),
  [6966] = {.count = 1, .reusable = true}, SHIFT(3083),
  [6968] = {.count = 1, .reusable = true}, SHIFT(3084),
  [6970] = {.count = 1, .reusable = true}, REDUCE(sym__field_declarator, 3, .dynamic_precedence = -10),
  [6972] = {.count = 1, .reusable = true}, SHIFT(3085),
  [6974] = {.count = 1, .reusable = true}, REDUCE(sym_pointer_field_declarator, 3, .dynamic_precedence = 1),
  [6976] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration, 4),
  [6978] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration, 4),
  [6980] = {.count = 1, .reusable = true}, SHIFT(3086),
  [6982] = {.count = 1, .reusable = true}, SHIFT(3088),
  [6984] = {.count = 1, .reusable = true}, REDUCE(aux_sym_field_declaration_repeat1, 2),
  [6986] = {.count = 1, .reusable = true}, SHIFT(3090),
  [6988] = {.count = 1, .reusable = true}, REDUCE(sym_array_field_declarator, 3),
  [6990] = {.count = 1, .reusable = true}, SHIFT(3092),
  [6992] = {.count = 1, .reusable = true}, SHIFT(3091),
  [6994] = {.count = 1, .reusable = false}, SHIFT(3092),
  [6996] = {.count = 1, .reusable = true}, SHIFT(3093),
  [6998] = {.count = 1, .reusable = false}, SHIFT(3096),
  [7000] = {.count = 1, .reusable = false}, SHIFT(3095),
  [7002] = {.count = 1, .reusable = false}, SHIFT(3094),
  [7004] = {.count = 1, .reusable = true}, REDUCE(sym_function_field_declarator, 3),
  [7006] = {.count = 1, .reusable = true}, SHIFT(3097),
  [7008] = {.count = 1, .reusable = true}, SHIFT(3098),
  [7010] = {.count = 1, .reusable = false}, SHIFT(3098),
  [7012] = {.count = 2, .reusable = true}, REDUCE(aux_sym_field_declaration_repeat1, 2), SHIFT_REPEAT(2018),
  [7015] = {.count = 1, .reusable = true}, SHIFT(3099),
  [7017] = {.count = 1, .reusable = false}, SHIFT(3100),
  [7019] = {.count = 1, .reusable = true}, SHIFT(3100),
  [7021] = {.count = 1, .reusable = false}, SHIFT(3103),
  [7023] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(2026),
  [7026] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(2702),
  [7029] = {.count = 1, .reusable = true}, REDUCE(aux_sym_base_class_clause_repeat1, 3, .alias_sequence_id = 10),
  [7031] = {.count = 1, .reusable = true}, REDUCE(aux_sym_base_class_clause_repeat1, 3),
  [7033] = {.count = 1, .reusable = false}, SHIFT(628),
  [7035] = {.count = 1, .reusable = false}, SHIFT(629),
  [7037] = {.count = 1, .reusable = true}, SHIFT(3104),
  [7039] = {.count = 1, .reusable = true}, SHIFT(3105),
  [7041] = {.count = 1, .reusable = false}, SHIFT(3105),
  [7043] = {.count = 1, .reusable = true}, SHIFT(3106),
  [7045] = {.count = 1, .reusable = false}, SHIFT(3106),
  [7047] = {.count = 1, .reusable = true}, SHIFT(3107),
  [7049] = {.count = 1, .reusable = true}, SHIFT(3108),
  [7051] = {.count = 1, .reusable = false}, SHIFT(3109),
  [7053] = {.count = 1, .reusable = true}, SHIFT(3111),
  [7055] = {.count = 1, .reusable = true}, SHIFT(3110),
  [7057] = {.count = 1, .reusable = false}, SHIFT(3111),
  [7059] = {.count = 1, .reusable = true}, SHIFT(3115),
  [7061] = {.count = 1, .reusable = false}, SHIFT(3115),
  [7063] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 6),
  [7065] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 6),
  [7067] = {.count = 1, .reusable = false}, SHIFT(3116),
  [7069] = {.count = 1, .reusable = true}, SHIFT(3117),
  [7071] = {.count = 1, .reusable = true}, SHIFT(3118),
  [7073] = {.count = 1, .reusable = true}, SHIFT(3120),
  [7075] = {.count = 1, .reusable = false}, SHIFT(3120),
  [7077] = {.count = 1, .reusable = true}, SHIFT(3121),
  [7079] = {.count = 1, .reusable = true}, SHIFT(3123),
  [7081] = {.count = 1, .reusable = false}, SHIFT(3124),
  [7083] = {.count = 1, .reusable = true}, SHIFT(3126),
  [7085] = {.count = 1, .reusable = true}, SHIFT(3129),
  [7087] = {.count = 1, .reusable = true}, SHIFT(3131),
  [7089] = {.count = 1, .reusable = false}, SHIFT(3131),
  [7091] = {.count = 1, .reusable = true}, SHIFT(3132),
  [7093] = {.count = 1, .reusable = true}, SHIFT(3133),
  [7095] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 6),
  [7097] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 6),
  [7099] = {.count = 1, .reusable = true}, SHIFT(3134),
  [7101] = {.count = 1, .reusable = false}, SHIFT(3134),
  [7103] = {.count = 1, .reusable = true}, SHIFT(3136),
  [7105] = {.count = 1, .reusable = true}, SHIFT(3139),
  [7107] = {.count = 1, .reusable = false}, SHIFT(3139),
  [7109] = {.count = 1, .reusable = false}, SHIFT(715),
  [7111] = {.count = 1, .reusable = false}, SHIFT(717),
  [7113] = {.count = 1, .reusable = true}, SHIFT(3141),
  [7115] = {.count = 1, .reusable = true}, SHIFT(3142),
  [7117] = {.count = 1, .reusable = false}, SHIFT(3142),
  [7119] = {.count = 1, .reusable = true}, SHIFT(3143),
  [7121] = {.count = 1, .reusable = false}, SHIFT(3143),
  [7123] = {.count = 1, .reusable = true}, REDUCE(sym_initializer_list, 5),
  [7125] = {.count = 1, .reusable = false}, REDUCE(sym_initializer_list, 5),
  [7127] = {.count = 1, .reusable = false}, SHIFT(764),
  [7129] = {.count = 1, .reusable = false}, SHIFT(765),
  [7131] = {.count = 1, .reusable = true}, SHIFT(3144),
  [7133] = {.count = 1, .reusable = true}, SHIFT(3145),
  [7135] = {.count = 1, .reusable = true}, SHIFT(3146),
  [7137] = {.count = 1, .reusable = true}, SHIFT(3147),
  [7139] = {.count = 1, .reusable = true}, SHIFT(3148),
  [7141] = {.count = 1, .reusable = true}, SHIFT(3149),
  [7143] = {.count = 1, .reusable = true}, SHIFT(3151),
  [7145] = {.count = 1, .reusable = true}, SHIFT(3164),
  [7147] = {.count = 1, .reusable = true}, SHIFT(3166),
  [7149] = {.count = 1, .reusable = false}, SHIFT(3166),
  [7151] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(2816),
  [7154] = {.count = 1, .reusable = true}, SHIFT(3168),
  [7156] = {.count = 1, .reusable = true}, SHIFT(3169),
  [7158] = {.count = 1, .reusable = false}, SHIFT(3169),
  [7160] = {.count = 1, .reusable = true}, SHIFT(3170),
  [7162] = {.count = 1, .reusable = true}, REDUCE(sym_optional_type_parameter_declaration, 4, .alias_sequence_id = 2),
  [7164] = {.count = 1, .reusable = false}, SHIFT(3171),
  [7166] = {.count = 1, .reusable = false}, SHIFT(3175),
  [7168] = {.count = 1, .reusable = false}, SHIFT(3174),
  [7170] = {.count = 1, .reusable = false}, SHIFT(3173),
  [7172] = {.count = 1, .reusable = true}, SHIFT(3176),
  [7174] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2838),
  [7177] = {.count = 1, .reusable = false}, SHIFT(3182),
  [7179] = {.count = 1, .reusable = false}, SHIFT(3183),
  [7181] = {.count = 1, .reusable = false}, SHIFT(3184),
  [7183] = {.count = 1, .reusable = false}, SHIFT(3185),
  [7185] = {.count = 1, .reusable = false}, SHIFT(3186),
  [7187] = {.count = 1, .reusable = false}, SHIFT(3187),
  [7189] = {.count = 1, .reusable = false}, SHIFT(3188),
  [7191] = {.count = 1, .reusable = false}, SHIFT(3189),
  [7193] = {.count = 1, .reusable = true}, SHIFT(3191),
  [7195] = {.count = 1, .reusable = true}, SHIFT(3193),
  [7197] = {.count = 1, .reusable = true}, SHIFT(3192),
  [7199] = {.count = 1, .reusable = false}, SHIFT(3193),
  [7201] = {.count = 1, .reusable = true}, SHIFT(3194),
  [7203] = {.count = 1, .reusable = true}, SHIFT(3195),
  [7205] = {.count = 1, .reusable = false}, SHIFT(3195),
  [7207] = {.count = 1, .reusable = true}, SHIFT(3196),
  [7209] = {.count = 1, .reusable = false}, SHIFT(3196),
  [7211] = {.count = 1, .reusable = true}, SHIFT(3199),
  [7213] = {.count = 1, .reusable = false}, SHIFT(3200),
  [7215] = {.count = 1, .reusable = true}, SHIFT(3201),
  [7217] = {.count = 1, .reusable = true}, SHIFT(3202),
  [7219] = {.count = 1, .reusable = true}, REDUCE(sym_new_declarator, 4),
  [7221] = {.count = 1, .reusable = false}, REDUCE(sym_new_declarator, 4),
  [7223] = {.count = 1, .reusable = true}, SHIFT(3203),
  [7225] = {.count = 1, .reusable = true}, SHIFT(3204),
  [7227] = {.count = 1, .reusable = false}, SHIFT(3204),
  [7229] = {.count = 1, .reusable = true}, SHIFT(3205),
  [7231] = {.count = 1, .reusable = false}, SHIFT(3205),
  [7233] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2867),
  [7236] = {.count = 1, .reusable = true}, SHIFT(3206),
  [7238] = {.count = 2, .reusable = true}, REDUCE(aux_sym_initializer_list_repeat1, 2), SHIFT(332),
  [7241] = {.count = 1, .reusable = true}, SHIFT(3207),
  [7243] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2898),
  [7246] = {.count = 1, .reusable = false}, SHIFT(3215),
  [7248] = {.count = 1, .reusable = false}, SHIFT(3214),
  [7250] = {.count = 1, .reusable = false}, SHIFT(3213),
  [7252] = {.count = 1, .reusable = true}, SHIFT(3216),
  [7254] = {.count = 1, .reusable = true}, SHIFT(3217),
  [7256] = {.count = 1, .reusable = false}, SHIFT(3218),
  [7258] = {.count = 1, .reusable = true}, SHIFT(3218),
  [7260] = {.count = 1, .reusable = false}, SHIFT(3220),
  [7262] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(2909),
  [7265] = {.count = 1, .reusable = false}, SHIFT(913),
  [7267] = {.count = 1, .reusable = false}, SHIFT(914),
  [7269] = {.count = 1, .reusable = true}, SHIFT(3221),
  [7271] = {.count = 1, .reusable = true}, SHIFT(3222),
  [7273] = {.count = 1, .reusable = false}, SHIFT(3222),
  [7275] = {.count = 1, .reusable = true}, SHIFT(3223),
  [7277] = {.count = 1, .reusable = false}, SHIFT(3223),
  [7279] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_pointer_declarator, 2, .dynamic_precedence = 1),
  [7281] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_reference_declarator, 2),
  [7283] = {.count = 1, .reusable = true}, SHIFT(3227),
  [7285] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(2920),
  [7288] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_array_declarator, 5),
  [7290] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_array_declarator, 5),
  [7292] = {.count = 1, .reusable = true}, SHIFT(3230),
  [7294] = {.count = 1, .reusable = true}, SHIFT(3231),
  [7296] = {.count = 1, .reusable = true}, SHIFT(3232),
  [7298] = {.count = 1, .reusable = true}, SHIFT(3233),
  [7300] = {.count = 1, .reusable = false}, SHIFT(3234),
  [7302] = {.count = 1, .reusable = false}, SHIFT(3235),
  [7304] = {.count = 1, .reusable = false}, SHIFT(3236),
  [7306] = {.count = 1, .reusable = false}, SHIFT(3237),
  [7308] = {.count = 1, .reusable = false}, SHIFT(3238),
  [7310] = {.count = 1, .reusable = false}, SHIFT(3239),
  [7312] = {.count = 1, .reusable = false}, SHIFT(3240),
  [7314] = {.count = 1, .reusable = false}, SHIFT(3241),
  [7316] = {.count = 1, .reusable = true}, SHIFT(3243),
  [7318] = {.count = 1, .reusable = true}, SHIFT(3244),
  [7320] = {.count = 1, .reusable = false}, SHIFT(3244),
  [7322] = {.count = 1, .reusable = true}, SHIFT(3247),
  [7324] = {.count = 1, .reusable = true}, SHIFT(3246),
  [7326] = {.count = 1, .reusable = false}, SHIFT(3247),
  [7328] = {.count = 1, .reusable = true}, SHIFT(3248),
  [7330] = {.count = 1, .reusable = true}, SHIFT(3249),
  [7332] = {.count = 1, .reusable = false}, SHIFT(3249),
  [7334] = {.count = 1, .reusable = true}, SHIFT(3250),
  [7336] = {.count = 1, .reusable = false}, SHIFT(3250),
  [7338] = {.count = 1, .reusable = true}, SHIFT(3251),
  [7340] = {.count = 2, .reusable = false}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(2490),
  [7343] = {.count = 1, .reusable = true}, SHIFT(3253),
  [7345] = {.count = 1, .reusable = true}, SHIFT(3254),
  [7347] = {.count = 1, .reusable = true}, SHIFT(3255),
  [7349] = {.count = 1, .reusable = true}, SHIFT(3257),
  [7351] = {.count = 1, .reusable = false}, SHIFT(3257),
  [7353] = {.count = 1, .reusable = true}, SHIFT(3258),
  [7355] = {.count = 1, .reusable = true}, SHIFT(3260),
  [7357] = {.count = 1, .reusable = false}, SHIFT(3261),
  [7359] = {.count = 1, .reusable = false}, SHIFT(3263),
  [7361] = {.count = 1, .reusable = true}, SHIFT(3265),
  [7363] = {.count = 1, .reusable = true}, SHIFT(3267),
  [7365] = {.count = 1, .reusable = true}, SHIFT(3269),
  [7367] = {.count = 1, .reusable = false}, SHIFT(3269),
  [7369] = {.count = 1, .reusable = true}, SHIFT(3270),
  [7371] = {.count = 1, .reusable = true}, SHIFT(3271),
  [7373] = {.count = 1, .reusable = true}, REDUCE(sym_array_type_declarator, 5),
  [7375] = {.count = 1, .reusable = true}, SHIFT(3272),
  [7377] = {.count = 1, .reusable = true}, SHIFT(3273),
  [7379] = {.count = 1, .reusable = true}, SHIFT(3274),
  [7381] = {.count = 1, .reusable = false}, SHIFT(3275),
  [7383] = {.count = 1, .reusable = true}, SHIFT(3276),
  [7385] = {.count = 1, .reusable = false}, SHIFT(3277),
  [7387] = {.count = 1, .reusable = false}, SHIFT(3278),
  [7389] = {.count = 1, .reusable = true}, SHIFT(3279),
  [7391] = {.count = 1, .reusable = false}, SHIFT(3279),
  [7393] = {.count = 1, .reusable = true}, SHIFT(3281),
  [7395] = {.count = 1, .reusable = false}, SHIFT(3281),
  [7397] = {.count = 1, .reusable = true}, SHIFT(3283),
  [7399] = {.count = 1, .reusable = true}, SHIFT(3285),
  [7401] = {.count = 1, .reusable = true}, SHIFT(3286),
  [7403] = {.count = 1, .reusable = false}, SHIFT(3286),
  [7405] = {.count = 1, .reusable = true}, SHIFT(3288),
  [7407] = {.count = 1, .reusable = true}, SHIFT(3291),
  [7409] = {.count = 1, .reusable = true}, SHIFT(3290),
  [7411] = {.count = 1, .reusable = false}, SHIFT(3291),
  [7413] = {.count = 1, .reusable = true}, SHIFT(3292),
  [7415] = {.count = 1, .reusable = true}, SHIFT(3293),
  [7417] = {.count = 1, .reusable = false}, SHIFT(3024),
  [7419] = {.count = 1, .reusable = true}, SHIFT(3296),
  [7421] = {.count = 1, .reusable = true}, SHIFT(3297),
  [7423] = {.count = 1, .reusable = false}, SHIFT(3297),
  [7425] = {.count = 1, .reusable = true}, SHIFT(3299),
  [7427] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_compound_statement, 4),
  [7429] = {.count = 1, .reusable = true}, SHIFT(3300),
  [7431] = {.count = 1, .reusable = false}, SHIFT(3301),
  [7433] = {.count = 1, .reusable = false}, SHIFT(3302),
  [7435] = {.count = 1, .reusable = false}, SHIFT(3303),
  [7437] = {.count = 1, .reusable = false}, SHIFT(3304),
  [7439] = {.count = 1, .reusable = false}, SHIFT(3305),
  [7441] = {.count = 1, .reusable = false}, SHIFT(3306),
  [7443] = {.count = 1, .reusable = false}, SHIFT(3307),
  [7445] = {.count = 1, .reusable = false}, SHIFT(3308),
  [7447] = {.count = 1, .reusable = true}, SHIFT(3310),
  [7449] = {.count = 1, .reusable = true}, SHIFT(3311),
  [7451] = {.count = 1, .reusable = false}, SHIFT(3311),
  [7453] = {.count = 1, .reusable = true}, SHIFT(3314),
  [7455] = {.count = 1, .reusable = true}, SHIFT(3313),
  [7457] = {.count = 1, .reusable = false}, SHIFT(3314),
  [7459] = {.count = 1, .reusable = true}, SHIFT(3315),
  [7461] = {.count = 1, .reusable = true}, SHIFT(3316),
  [7463] = {.count = 1, .reusable = false}, SHIFT(3316),
  [7465] = {.count = 1, .reusable = true}, SHIFT(3317),
  [7467] = {.count = 1, .reusable = false}, SHIFT(3317),
  [7469] = {.count = 2, .reusable = false}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(2609),
  [7472] = {.count = 1, .reusable = true}, SHIFT(3319),
  [7474] = {.count = 1, .reusable = true}, SHIFT(3320),
  [7476] = {.count = 1, .reusable = false}, SHIFT(3320),
  [7478] = {.count = 1, .reusable = true}, SHIFT(3321),
  [7480] = {.count = 1, .reusable = true}, SHIFT(3322),
  [7482] = {.count = 1, .reusable = false}, SHIFT(3323),
  [7484] = {.count = 1, .reusable = true}, SHIFT(3325),
  [7486] = {.count = 1, .reusable = true}, SHIFT(3324),
  [7488] = {.count = 1, .reusable = false}, SHIFT(3325),
  [7490] = {.count = 1, .reusable = false}, SHIFT(3329),
  [7492] = {.count = 1, .reusable = true}, SHIFT(3331),
  [7494] = {.count = 1, .reusable = true}, SHIFT(3333),
  [7496] = {.count = 1, .reusable = false}, SHIFT(3333),
  [7498] = {.count = 1, .reusable = true}, SHIFT(3338),
  [7500] = {.count = 1, .reusable = true}, SHIFT(3342),
  [7502] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_field_declaration_list, 3),
  [7504] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_field_declaration_list, 5),
  [7506] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_field_declaration_list, 5),
  [7508] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5),
  [7510] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5),
  [7512] = {.count = 1, .reusable = true}, SHIFT(3344),
  [7514] = {.count = 1, .reusable = true}, SHIFT(3345),
  [7516] = {.count = 1, .reusable = true}, SHIFT(3346),
  [7518] = {.count = 1, .reusable = true}, REDUCE(sym_array_field_declarator, 4),
  [7520] = {.count = 1, .reusable = true}, SHIFT(3347),
  [7522] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration, 5),
  [7524] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration, 5),
  [7526] = {.count = 1, .reusable = true}, SHIFT(3348),
  [7528] = {.count = 1, .reusable = false}, SHIFT(3349),
  [7530] = {.count = 1, .reusable = true}, SHIFT(3349),
  [7532] = {.count = 1, .reusable = false}, SHIFT(3352),
  [7534] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(2695),
  [7537] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(3097),
  [7540] = {.count = 1, .reusable = true}, SHIFT(3353),
  [7542] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(3103),
  [7545] = {.count = 1, .reusable = true}, SHIFT(3359),
  [7547] = {.count = 1, .reusable = true}, SHIFT(3360),
  [7549] = {.count = 1, .reusable = false}, SHIFT(3360),
  [7551] = {.count = 1, .reusable = true}, SHIFT(3362),
  [7553] = {.count = 1, .reusable = true}, SHIFT(3361),
  [7555] = {.count = 1, .reusable = false}, SHIFT(3362),
  [7557] = {.count = 1, .reusable = true}, SHIFT(3363),
  [7559] = {.count = 1, .reusable = true}, SHIFT(3364),
  [7561] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 7),
  [7563] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 7),
  [7565] = {.count = 1, .reusable = true}, SHIFT(3367),
  [7567] = {.count = 1, .reusable = false}, SHIFT(3367),
  [7569] = {.count = 1, .reusable = true}, SHIFT(3368),
  [7571] = {.count = 1, .reusable = true}, SHIFT(3369),
  [7573] = {.count = 1, .reusable = false}, SHIFT(3370),
  [7575] = {.count = 1, .reusable = true}, SHIFT(3372),
  [7577] = {.count = 1, .reusable = true}, SHIFT(3371),
  [7579] = {.count = 1, .reusable = false}, SHIFT(3372),
  [7581] = {.count = 1, .reusable = true}, SHIFT(3376),
  [7583] = {.count = 1, .reusable = true}, SHIFT(3378),
  [7585] = {.count = 1, .reusable = true}, SHIFT(3380),
  [7587] = {.count = 1, .reusable = false}, SHIFT(3380),
  [7589] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 7),
  [7591] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 7),
  [7593] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(2750),
  [7596] = {.count = 1, .reusable = true}, SHIFT(3383),
  [7598] = {.count = 1, .reusable = true}, REDUCE(sym_for_range_loop, 7),
  [7600] = {.count = 1, .reusable = false}, REDUCE(sym_for_range_loop, 7),
  [7602] = {.count = 1, .reusable = true}, SHIFT(3385),
  [7604] = {.count = 1, .reusable = true}, SHIFT(3386),
  [7606] = {.count = 1, .reusable = true}, SHIFT(3387),
  [7608] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(3171),
  [7611] = {.count = 1, .reusable = true}, SHIFT(3395),
  [7613] = {.count = 1, .reusable = false}, SHIFT(3396),
  [7615] = {.count = 1, .reusable = true}, SHIFT(3396),
  [7617] = {.count = 1, .reusable = false}, SHIFT(3399),
  [7619] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(2832),
  [7622] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(3176),
  [7625] = {.count = 1, .reusable = true}, SHIFT(3403),
  [7627] = {.count = 1, .reusable = true}, SHIFT(3404),
  [7629] = {.count = 1, .reusable = true}, SHIFT(3405),
  [7631] = {.count = 1, .reusable = true}, SHIFT(3407),
  [7633] = {.count = 1, .reusable = false}, SHIFT(3407),
  [7635] = {.count = 1, .reusable = true}, SHIFT(3408),
  [7637] = {.count = 1, .reusable = true}, SHIFT(3410),
  [7639] = {.count = 1, .reusable = false}, SHIFT(3411),
  [7641] = {.count = 1, .reusable = false}, SHIFT(3413),
  [7643] = {.count = 1, .reusable = true}, SHIFT(3415),
  [7645] = {.count = 1, .reusable = true}, SHIFT(3417),
  [7647] = {.count = 1, .reusable = false}, SHIFT(3417),
  [7649] = {.count = 1, .reusable = true}, SHIFT(3418),
  [7651] = {.count = 1, .reusable = true}, SHIFT(3419),
  [7653] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(3201),
  [7656] = {.count = 1, .reusable = false}, SHIFT(1623),
  [7658] = {.count = 1, .reusable = false}, SHIFT(1624),
  [7660] = {.count = 1, .reusable = true}, SHIFT(3421),
  [7662] = {.count = 1, .reusable = true}, SHIFT(3422),
  [7664] = {.count = 1, .reusable = false}, SHIFT(3422),
  [7666] = {.count = 1, .reusable = true}, SHIFT(3423),
  [7668] = {.count = 1, .reusable = false}, SHIFT(3423),
  [7670] = {.count = 1, .reusable = true}, SHIFT(3427),
  [7672] = {.count = 1, .reusable = true}, SHIFT(3428),
  [7674] = {.count = 1, .reusable = false}, SHIFT(3429),
  [7676] = {.count = 1, .reusable = true}, SHIFT(3429),
  [7678] = {.count = 1, .reusable = false}, SHIFT(3432),
  [7680] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(2903),
  [7683] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(3216),
  [7686] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(3220),
  [7689] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_pointer_declarator, 3, .dynamic_precedence = 1),
  [7691] = {.count = 2, .reusable = false}, REDUCE(aux_sym_type_definition_repeat1, 2), SHIFT_REPEAT(924),
  [7694] = {.count = 2, .reusable = true}, REDUCE(aux_sym_type_definition_repeat1, 2), SHIFT_REPEAT(924),
  [7697] = {.count = 2, .reusable = false}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(924),
  [7700] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(924),
  [7703] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(3227),
  [7706] = {.count = 1, .reusable = true}, SHIFT(3434),
  [7708] = {.count = 1, .reusable = true}, SHIFT(3435),
  [7710] = {.count = 1, .reusable = true}, SHIFT(3437),
  [7712] = {.count = 1, .reusable = false}, SHIFT(3437),
  [7714] = {.count = 1, .reusable = true}, SHIFT(3438),
  [7716] = {.count = 1, .reusable = true}, SHIFT(3440),
  [7718] = {.count = 1, .reusable = false}, SHIFT(3441),
  [7720] = {.count = 1, .reusable = false}, SHIFT(3443),
  [7722] = {.count = 1, .reusable = true}, SHIFT(3445),
  [7724] = {.count = 1, .reusable = true}, SHIFT(3447),
  [7726] = {.count = 1, .reusable = true}, SHIFT(3449),
  [7728] = {.count = 1, .reusable = false}, SHIFT(3449),
  [7730] = {.count = 1, .reusable = true}, SHIFT(3450),
  [7732] = {.count = 1, .reusable = true}, SHIFT(3451),
  [7734] = {.count = 1, .reusable = true}, SHIFT(3452),
  [7736] = {.count = 1, .reusable = false}, SHIFT(3452),
  [7738] = {.count = 1, .reusable = true}, SHIFT(3453),
  [7740] = {.count = 1, .reusable = true}, SHIFT(3454),
  [7742] = {.count = 1, .reusable = false}, SHIFT(3455),
  [7744] = {.count = 1, .reusable = true}, SHIFT(3457),
  [7746] = {.count = 1, .reusable = true}, SHIFT(3456),
  [7748] = {.count = 1, .reusable = false}, SHIFT(3457),
  [7750] = {.count = 1, .reusable = false}, SHIFT(3461),
  [7752] = {.count = 1, .reusable = true}, SHIFT(3463),
  [7754] = {.count = 1, .reusable = true}, SHIFT(3465),
  [7756] = {.count = 1, .reusable = false}, SHIFT(3465),
  [7758] = {.count = 1, .reusable = true}, SHIFT(3467),
  [7760] = {.count = 1, .reusable = true}, SHIFT(3468),
  [7762] = {.count = 1, .reusable = true}, SHIFT(3469),
  [7764] = {.count = 1, .reusable = true}, SHIFT(3470),
  [7766] = {.count = 1, .reusable = false}, SHIFT(3471),
  [7768] = {.count = 1, .reusable = false}, SHIFT(3472),
  [7770] = {.count = 1, .reusable = false}, SHIFT(3473),
  [7772] = {.count = 1, .reusable = false}, SHIFT(3474),
  [7774] = {.count = 1, .reusable = false}, SHIFT(3475),
  [7776] = {.count = 1, .reusable = false}, SHIFT(3476),
  [7778] = {.count = 1, .reusable = false}, SHIFT(3477),
  [7780] = {.count = 1, .reusable = false}, SHIFT(3478),
  [7782] = {.count = 1, .reusable = true}, SHIFT(3480),
  [7784] = {.count = 1, .reusable = true}, SHIFT(3481),
  [7786] = {.count = 1, .reusable = false}, SHIFT(3481),
  [7788] = {.count = 1, .reusable = true}, SHIFT(3484),
  [7790] = {.count = 1, .reusable = true}, SHIFT(3483),
  [7792] = {.count = 1, .reusable = false}, SHIFT(3484),
  [7794] = {.count = 1, .reusable = true}, SHIFT(3485),
  [7796] = {.count = 1, .reusable = true}, SHIFT(3486),
  [7798] = {.count = 1, .reusable = false}, SHIFT(3486),
  [7800] = {.count = 1, .reusable = true}, SHIFT(3487),
  [7802] = {.count = 1, .reusable = false}, SHIFT(3487),
  [7804] = {.count = 2, .reusable = false}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(3024),
  [7807] = {.count = 1, .reusable = true}, SHIFT(3489),
  [7809] = {.count = 1, .reusable = true}, SHIFT(3490),
  [7811] = {.count = 1, .reusable = true}, SHIFT(3491),
  [7813] = {.count = 1, .reusable = true}, SHIFT(3493),
  [7815] = {.count = 1, .reusable = false}, SHIFT(3493),
  [7817] = {.count = 1, .reusable = true}, SHIFT(3494),
  [7819] = {.count = 1, .reusable = true}, SHIFT(3496),
  [7821] = {.count = 1, .reusable = false}, SHIFT(3497),
  [7823] = {.count = 1, .reusable = false}, SHIFT(3499),
  [7825] = {.count = 1, .reusable = true}, SHIFT(3501),
  [7827] = {.count = 1, .reusable = true}, SHIFT(3503),
  [7829] = {.count = 1, .reusable = true}, SHIFT(3505),
  [7831] = {.count = 1, .reusable = false}, SHIFT(3505),
  [7833] = {.count = 1, .reusable = true}, SHIFT(3506),
  [7835] = {.count = 1, .reusable = true}, SHIFT(3507),
  [7837] = {.count = 1, .reusable = true}, SHIFT(3508),
  [7839] = {.count = 1, .reusable = true}, SHIFT(3509),
  [7841] = {.count = 1, .reusable = false}, SHIFT(3509),
  [7843] = {.count = 1, .reusable = true}, SHIFT(3511),
  [7845] = {.count = 1, .reusable = true}, SHIFT(3510),
  [7847] = {.count = 1, .reusable = false}, SHIFT(3511),
  [7849] = {.count = 1, .reusable = true}, SHIFT(3512),
  [7851] = {.count = 1, .reusable = true}, SHIFT(3513),
  [7853] = {.count = 1, .reusable = true}, SHIFT(3517),
  [7855] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(3338),
  [7858] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(3342),
  [7861] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_field_declaration_list, 4),
  [7863] = {.count = 1, .reusable = false}, SHIFT(3524),
  [7865] = {.count = 1, .reusable = false}, SHIFT(3523),
  [7867] = {.count = 1, .reusable = false}, SHIFT(3519),
  [7869] = {.count = 1, .reusable = false}, SHIFT(3520),
  [7871] = {.count = 1, .reusable = false}, SHIFT(3521),
  [7873] = {.count = 1, .reusable = false}, SHIFT(3522),
  [7875] = {.count = 1, .reusable = true}, SHIFT(3525),
  [7877] = {.count = 1, .reusable = true}, REDUCE(sym_array_field_declarator, 5),
  [7879] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(3352),
  [7882] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration, 6),
  [7884] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration, 6),
  [7886] = {.count = 1, .reusable = true}, SHIFT(3534),
  [7888] = {.count = 1, .reusable = true}, SHIFT(3536),
  [7890] = {.count = 1, .reusable = true}, SHIFT(3538),
  [7892] = {.count = 1, .reusable = true}, SHIFT(3537),
  [7894] = {.count = 1, .reusable = false}, SHIFT(3538),
  [7896] = {.count = 1, .reusable = true}, SHIFT(3539),
  [7898] = {.count = 1, .reusable = true}, SHIFT(3540),
  [7900] = {.count = 1, .reusable = false}, SHIFT(3540),
  [7902] = {.count = 1, .reusable = true}, SHIFT(3541),
  [7904] = {.count = 1, .reusable = false}, SHIFT(3541),
  [7906] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 8),
  [7908] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 8),
  [7910] = {.count = 1, .reusable = true}, SHIFT(3542),
  [7912] = {.count = 1, .reusable = true}, SHIFT(3543),
  [7914] = {.count = 1, .reusable = false}, SHIFT(3543),
  [7916] = {.count = 1, .reusable = true}, SHIFT(3545),
  [7918] = {.count = 1, .reusable = true}, SHIFT(3544),
  [7920] = {.count = 1, .reusable = false}, SHIFT(3545),
  [7922] = {.count = 1, .reusable = true}, SHIFT(3546),
  [7924] = {.count = 1, .reusable = true}, SHIFT(3547),
  [7926] = {.count = 1, .reusable = true}, SHIFT(3551),
  [7928] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 8),
  [7930] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 8),
  [7932] = {.count = 1, .reusable = true}, SHIFT(3554),
  [7934] = {.count = 1, .reusable = true}, SHIFT(3555),
  [7936] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(3399),
  [7939] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(3403),
  [7942] = {.count = 1, .reusable = true}, SHIFT(3561),
  [7944] = {.count = 1, .reusable = false}, SHIFT(3561),
  [7946] = {.count = 1, .reusable = true}, SHIFT(3562),
  [7948] = {.count = 1, .reusable = true}, SHIFT(3563),
  [7950] = {.count = 1, .reusable = false}, SHIFT(3564),
  [7952] = {.count = 1, .reusable = true}, SHIFT(3566),
  [7954] = {.count = 1, .reusable = true}, SHIFT(3565),
  [7956] = {.count = 1, .reusable = false}, SHIFT(3566),
  [7958] = {.count = 1, .reusable = false}, SHIFT(3569),
  [7960] = {.count = 1, .reusable = true}, SHIFT(3570),
  [7962] = {.count = 1, .reusable = true}, SHIFT(3572),
  [7964] = {.count = 1, .reusable = false}, SHIFT(3572),
  [7966] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(3427),
  [7969] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(3432),
  [7972] = {.count = 1, .reusable = true}, SHIFT(3579),
  [7974] = {.count = 1, .reusable = false}, SHIFT(3579),
  [7976] = {.count = 1, .reusable = true}, SHIFT(3580),
  [7978] = {.count = 1, .reusable = true}, SHIFT(3581),
  [7980] = {.count = 1, .reusable = false}, SHIFT(3582),
  [7982] = {.count = 1, .reusable = true}, SHIFT(3584),
  [7984] = {.count = 1, .reusable = true}, SHIFT(3583),
  [7986] = {.count = 1, .reusable = false}, SHIFT(3584),
  [7988] = {.count = 1, .reusable = false}, SHIFT(3588),
  [7990] = {.count = 1, .reusable = true}, SHIFT(3590),
  [7992] = {.count = 1, .reusable = true}, SHIFT(3592),
  [7994] = {.count = 1, .reusable = false}, SHIFT(3592),
  [7996] = {.count = 1, .reusable = true}, SHIFT(3594),
  [7998] = {.count = 1, .reusable = true}, SHIFT(3595),
  [8000] = {.count = 1, .reusable = false}, SHIFT(3595),
  [8002] = {.count = 1, .reusable = true}, SHIFT(3597),
  [8004] = {.count = 1, .reusable = true}, SHIFT(3596),
  [8006] = {.count = 1, .reusable = false}, SHIFT(3597),
  [8008] = {.count = 1, .reusable = true}, SHIFT(3598),
  [8010] = {.count = 1, .reusable = true}, SHIFT(3599),
  [8012] = {.count = 1, .reusable = true}, SHIFT(3603),
  [8014] = {.count = 1, .reusable = true}, SHIFT(3605),
  [8016] = {.count = 1, .reusable = true}, SHIFT(3606),
  [8018] = {.count = 1, .reusable = true}, SHIFT(3608),
  [8020] = {.count = 1, .reusable = false}, SHIFT(3608),
  [8022] = {.count = 1, .reusable = true}, SHIFT(3609),
  [8024] = {.count = 1, .reusable = true}, SHIFT(3611),
  [8026] = {.count = 1, .reusable = false}, SHIFT(3612),
  [8028] = {.count = 1, .reusable = false}, SHIFT(3614),
  [8030] = {.count = 1, .reusable = true}, SHIFT(3616),
  [8032] = {.count = 1, .reusable = true}, SHIFT(3618),
  [8034] = {.count = 1, .reusable = true}, SHIFT(3620),
  [8036] = {.count = 1, .reusable = false}, SHIFT(3620),
  [8038] = {.count = 1, .reusable = true}, SHIFT(3621),
  [8040] = {.count = 1, .reusable = true}, SHIFT(3622),
  [8042] = {.count = 1, .reusable = true}, SHIFT(3623),
  [8044] = {.count = 1, .reusable = false}, SHIFT(3623),
  [8046] = {.count = 1, .reusable = true}, SHIFT(3624),
  [8048] = {.count = 1, .reusable = true}, SHIFT(3625),
  [8050] = {.count = 1, .reusable = false}, SHIFT(3626),
  [8052] = {.count = 1, .reusable = true}, SHIFT(3628),
  [8054] = {.count = 1, .reusable = true}, SHIFT(3627),
  [8056] = {.count = 1, .reusable = false}, SHIFT(3628),
  [8058] = {.count = 1, .reusable = false}, SHIFT(3632),
  [8060] = {.count = 1, .reusable = true}, SHIFT(3634),
  [8062] = {.count = 1, .reusable = true}, SHIFT(3636),
  [8064] = {.count = 1, .reusable = false}, SHIFT(3636),
  [8066] = {.count = 1, .reusable = true}, SHIFT(3639),
  [8068] = {.count = 1, .reusable = true}, SHIFT(3641),
  [8070] = {.count = 1, .reusable = true}, SHIFT(3640),
  [8072] = {.count = 1, .reusable = false}, SHIFT(3641),
  [8074] = {.count = 1, .reusable = true}, SHIFT(3642),
  [8076] = {.count = 1, .reusable = true}, SHIFT(3643),
  [8078] = {.count = 1, .reusable = false}, SHIFT(3643),
  [8080] = {.count = 1, .reusable = true}, SHIFT(3644),
  [8082] = {.count = 1, .reusable = false}, SHIFT(3644),
  [8084] = {.count = 1, .reusable = true}, SHIFT(3646),
  [8086] = {.count = 1, .reusable = false}, SHIFT(3647),
  [8088] = {.count = 1, .reusable = false}, SHIFT(3650),
  [8090] = {.count = 1, .reusable = false}, SHIFT(3653),
  [8092] = {.count = 1, .reusable = true}, SHIFT(3656),
  [8094] = {.count = 1, .reusable = false}, SHIFT(3657),
  [8096] = {.count = 1, .reusable = true}, SHIFT(3657),
  [8098] = {.count = 1, .reusable = false}, SHIFT(3660),
  [8100] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(3345),
  [8103] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(3525),
  [8106] = {.count = 1, .reusable = true}, SHIFT(3664),
  [8108] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(3534),
  [8111] = {.count = 1, .reusable = false}, SHIFT(3665),
  [8113] = {.count = 1, .reusable = true}, SHIFT(3667),
  [8115] = {.count = 1, .reusable = true}, SHIFT(3669),
  [8117] = {.count = 1, .reusable = false}, SHIFT(3669),
  [8119] = {.count = 1, .reusable = true}, SHIFT(3670),
  [8121] = {.count = 1, .reusable = true}, SHIFT(3671),
  [8123] = {.count = 1, .reusable = true}, SHIFT(3673),
  [8125] = {.count = 1, .reusable = true}, SHIFT(3675),
  [8127] = {.count = 1, .reusable = true}, SHIFT(3674),
  [8129] = {.count = 1, .reusable = false}, SHIFT(3675),
  [8131] = {.count = 1, .reusable = true}, SHIFT(3676),
  [8133] = {.count = 1, .reusable = true}, SHIFT(3677),
  [8135] = {.count = 1, .reusable = false}, SHIFT(3677),
  [8137] = {.count = 1, .reusable = true}, SHIFT(3678),
  [8139] = {.count = 1, .reusable = false}, SHIFT(3678),
  [8141] = {.count = 1, .reusable = true}, SHIFT(3680),
  [8143] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 9),
  [8145] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 9),
  [8147] = {.count = 1, .reusable = true}, SHIFT(3685),
  [8149] = {.count = 1, .reusable = true}, SHIFT(3686),
  [8151] = {.count = 1, .reusable = true}, SHIFT(3687),
  [8153] = {.count = 1, .reusable = false}, SHIFT(3687),
  [8155] = {.count = 1, .reusable = true}, SHIFT(3689),
  [8157] = {.count = 1, .reusable = true}, SHIFT(3688),
  [8159] = {.count = 1, .reusable = false}, SHIFT(3689),
  [8161] = {.count = 1, .reusable = true}, SHIFT(3690),
  [8163] = {.count = 1, .reusable = true}, SHIFT(3691),
  [8165] = {.count = 1, .reusable = true}, SHIFT(3693),
  [8167] = {.count = 1, .reusable = true}, SHIFT(3698),
  [8169] = {.count = 1, .reusable = true}, SHIFT(3699),
  [8171] = {.count = 1, .reusable = true}, SHIFT(3700),
  [8173] = {.count = 1, .reusable = false}, SHIFT(3700),
  [8175] = {.count = 1, .reusable = true}, SHIFT(3702),
  [8177] = {.count = 1, .reusable = true}, SHIFT(3701),
  [8179] = {.count = 1, .reusable = false}, SHIFT(3702),
  [8181] = {.count = 1, .reusable = true}, SHIFT(3703),
  [8183] = {.count = 1, .reusable = true}, SHIFT(3704),
  [8185] = {.count = 1, .reusable = true}, SHIFT(3708),
  [8187] = {.count = 1, .reusable = true}, SHIFT(3711),
  [8189] = {.count = 1, .reusable = true}, SHIFT(3713),
  [8191] = {.count = 1, .reusable = true}, SHIFT(3712),
  [8193] = {.count = 1, .reusable = false}, SHIFT(3713),
  [8195] = {.count = 1, .reusable = true}, SHIFT(3714),
  [8197] = {.count = 1, .reusable = true}, SHIFT(3715),
  [8199] = {.count = 1, .reusable = false}, SHIFT(3715),
  [8201] = {.count = 1, .reusable = true}, SHIFT(3716),
  [8203] = {.count = 1, .reusable = false}, SHIFT(3716),
  [8205] = {.count = 1, .reusable = true}, SHIFT(3718),
  [8207] = {.count = 1, .reusable = true}, SHIFT(3719),
  [8209] = {.count = 1, .reusable = false}, SHIFT(3719),
  [8211] = {.count = 1, .reusable = true}, SHIFT(3720),
  [8213] = {.count = 1, .reusable = true}, SHIFT(3721),
  [8215] = {.count = 1, .reusable = false}, SHIFT(3722),
  [8217] = {.count = 1, .reusable = true}, SHIFT(3724),
  [8219] = {.count = 1, .reusable = true}, SHIFT(3723),
  [8221] = {.count = 1, .reusable = false}, SHIFT(3724),
  [8223] = {.count = 1, .reusable = false}, SHIFT(3728),
  [8225] = {.count = 1, .reusable = true}, SHIFT(3730),
  [8227] = {.count = 1, .reusable = true}, SHIFT(3732),
  [8229] = {.count = 1, .reusable = false}, SHIFT(3732),
  [8231] = {.count = 1, .reusable = true}, SHIFT(3734),
  [8233] = {.count = 1, .reusable = true}, SHIFT(3735),
  [8235] = {.count = 1, .reusable = false}, SHIFT(3735),
  [8237] = {.count = 1, .reusable = true}, SHIFT(3737),
  [8239] = {.count = 1, .reusable = true}, SHIFT(3736),
  [8241] = {.count = 1, .reusable = false}, SHIFT(3737),
  [8243] = {.count = 1, .reusable = true}, SHIFT(3738),
  [8245] = {.count = 1, .reusable = true}, SHIFT(3739),
  [8247] = {.count = 1, .reusable = true}, SHIFT(3743),
  [8249] = {.count = 1, .reusable = false}, SHIFT(3745),
  [8251] = {.count = 1, .reusable = true}, SHIFT(3747),
  [8253] = {.count = 1, .reusable = true}, SHIFT(3749),
  [8255] = {.count = 1, .reusable = false}, SHIFT(3749),
  [8257] = {.count = 1, .reusable = true}, SHIFT(3750),
  [8259] = {.count = 1, .reusable = true}, SHIFT(3751),
  [8261] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(3660),
  [8264] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(3664),
  [8267] = {.count = 1, .reusable = false}, SHIFT(3758),
  [8269] = {.count = 1, .reusable = true}, SHIFT(3759),
  [8271] = {.count = 1, .reusable = true}, SHIFT(3761),
  [8273] = {.count = 1, .reusable = false}, SHIFT(3761),
  [8275] = {.count = 1, .reusable = true}, SHIFT(3762),
  [8277] = {.count = 1, .reusable = true}, SHIFT(3764),
  [8279] = {.count = 1, .reusable = true}, SHIFT(3766),
  [8281] = {.count = 1, .reusable = false}, SHIFT(3766),
  [8283] = {.count = 1, .reusable = true}, SHIFT(3767),
  [8285] = {.count = 1, .reusable = true}, SHIFT(3768),
  [8287] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 10),
  [8289] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 10),
  [8291] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(3685),
  [8294] = {.count = 1, .reusable = true}, SHIFT(3771),
  [8296] = {.count = 1, .reusable = true}, SHIFT(3773),
  [8298] = {.count = 1, .reusable = true}, SHIFT(3772),
  [8300] = {.count = 1, .reusable = false}, SHIFT(3773),
  [8302] = {.count = 1, .reusable = true}, SHIFT(3774),
  [8304] = {.count = 1, .reusable = true}, SHIFT(3775),
  [8306] = {.count = 1, .reusable = false}, SHIFT(3775),
  [8308] = {.count = 1, .reusable = true}, SHIFT(3776),
  [8310] = {.count = 1, .reusable = false}, SHIFT(3776),
  [8312] = {.count = 1, .reusable = true}, SHIFT(3777),
  [8314] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(3698),
  [8317] = {.count = 1, .reusable = true}, SHIFT(3779),
  [8319] = {.count = 1, .reusable = true}, SHIFT(3781),
  [8321] = {.count = 1, .reusable = true}, SHIFT(3780),
  [8323] = {.count = 1, .reusable = false}, SHIFT(3781),
  [8325] = {.count = 1, .reusable = true}, SHIFT(3782),
  [8327] = {.count = 1, .reusable = true}, SHIFT(3783),
  [8329] = {.count = 1, .reusable = false}, SHIFT(3783),
  [8331] = {.count = 1, .reusable = true}, SHIFT(3784),
  [8333] = {.count = 1, .reusable = false}, SHIFT(3784),
  [8335] = {.count = 1, .reusable = true}, SHIFT(3786),
  [8337] = {.count = 1, .reusable = false}, SHIFT(3787),
  [8339] = {.count = 1, .reusable = true}, SHIFT(3789),
  [8341] = {.count = 1, .reusable = true}, SHIFT(3791),
  [8343] = {.count = 1, .reusable = false}, SHIFT(3791),
  [8345] = {.count = 1, .reusable = true}, SHIFT(3792),
  [8347] = {.count = 1, .reusable = true}, SHIFT(3793),
  [8349] = {.count = 1, .reusable = true}, SHIFT(3795),
  [8351] = {.count = 1, .reusable = true}, SHIFT(3796),
  [8353] = {.count = 1, .reusable = false}, SHIFT(3796),
  [8355] = {.count = 1, .reusable = true}, SHIFT(3798),
  [8357] = {.count = 1, .reusable = true}, SHIFT(3797),
  [8359] = {.count = 1, .reusable = false}, SHIFT(3798),
  [8361] = {.count = 1, .reusable = true}, SHIFT(3799),
  [8363] = {.count = 1, .reusable = true}, SHIFT(3800),
  [8365] = {.count = 1, .reusable = true}, SHIFT(3804),
  [8367] = {.count = 1, .reusable = true}, SHIFT(3807),
  [8369] = {.count = 1, .reusable = true}, SHIFT(3809),
  [8371] = {.count = 1, .reusable = true}, SHIFT(3808),
  [8373] = {.count = 1, .reusable = false}, SHIFT(3809),
  [8375] = {.count = 1, .reusable = true}, SHIFT(3810),
  [8377] = {.count = 1, .reusable = true}, SHIFT(3811),
  [8379] = {.count = 1, .reusable = false}, SHIFT(3811),
  [8381] = {.count = 1, .reusable = true}, SHIFT(3812),
  [8383] = {.count = 1, .reusable = false}, SHIFT(3812),
  [8385] = {.count = 1, .reusable = true}, SHIFT(3814),
  [8387] = {.count = 1, .reusable = false}, SHIFT(3815),
  [8389] = {.count = 1, .reusable = true}, SHIFT(3816),
  [8391] = {.count = 1, .reusable = true}, SHIFT(3818),
  [8393] = {.count = 1, .reusable = false}, SHIFT(3818),
  [8395] = {.count = 1, .reusable = true}, SHIFT(3822),
  [8397] = {.count = 1, .reusable = true}, SHIFT(3823),
  [8399] = {.count = 1, .reusable = true}, SHIFT(3825),
  [8401] = {.count = 1, .reusable = true}, SHIFT(3826),
  [8403] = {.count = 1, .reusable = true}, SHIFT(3828),
  [8405] = {.count = 1, .reusable = false}, SHIFT(3828),
  [8407] = {.count = 1, .reusable = false}, SHIFT(3829),
  [8409] = {.count = 1, .reusable = true}, SHIFT(3831),
  [8411] = {.count = 1, .reusable = true}, SHIFT(3833),
  [8413] = {.count = 1, .reusable = false}, SHIFT(3833),
  [8415] = {.count = 1, .reusable = true}, SHIFT(3834),
  [8417] = {.count = 1, .reusable = true}, SHIFT(3835),
  [8419] = {.count = 1, .reusable = false}, SHIFT(3836),
  [8421] = {.count = 1, .reusable = true}, SHIFT(3838),
  [8423] = {.count = 1, .reusable = true}, SHIFT(3840),
  [8425] = {.count = 1, .reusable = false}, SHIFT(3840),
  [8427] = {.count = 1, .reusable = true}, SHIFT(3841),
  [8429] = {.count = 1, .reusable = true}, SHIFT(3842),
  [8431] = {.count = 1, .reusable = false}, SHIFT(3844),
  [8433] = {.count = 1, .reusable = true}, SHIFT(3845),
  [8435] = {.count = 1, .reusable = true}, SHIFT(3847),
  [8437] = {.count = 1, .reusable = false}, SHIFT(3847),
  [8439] = {.count = 1, .reusable = true}, SHIFT(3849),
  [8441] = {.count = 1, .reusable = true}, SHIFT(3851),
  [8443] = {.count = 1, .reusable = true}, SHIFT(3850),
  [8445] = {.count = 1, .reusable = false}, SHIFT(3851),
  [8447] = {.count = 1, .reusable = true}, SHIFT(3852),
  [8449] = {.count = 1, .reusable = true}, SHIFT(3853),
  [8451] = {.count = 1, .reusable = false}, SHIFT(3853),
  [8453] = {.count = 1, .reusable = true}, SHIFT(3854),
  [8455] = {.count = 1, .reusable = false}, SHIFT(3854),
  [8457] = {.count = 1, .reusable = true}, SHIFT(3856),
  [8459] = {.count = 1, .reusable = false}, SHIFT(3857),
  [8461] = {.count = 1, .reusable = true}, SHIFT(3859),
  [8463] = {.count = 1, .reusable = true}, SHIFT(3861),
  [8465] = {.count = 1, .reusable = false}, SHIFT(3861),
  [8467] = {.count = 1, .reusable = true}, SHIFT(3862),
  [8469] = {.count = 1, .reusable = true}, SHIFT(3863),
  [8471] = {.count = 1, .reusable = true}, SHIFT(3865),
  [8473] = {.count = 2, .reusable = true}, REDUCE(aux_sym_abstract_function_declarator_repeat1, 2), SHIFT_REPEAT(3822),
  [8476] = {.count = 1, .reusable = true}, SHIFT(3867),
  [8478] = {.count = 1, .reusable = true}, SHIFT(3868),
  [8480] = {.count = 1, .reusable = false}, SHIFT(3870),
  [8482] = {.count = 1, .reusable = true}, SHIFT(3871),
  [8484] = {.count = 1, .reusable = true}, SHIFT(3873),
  [8486] = {.count = 1, .reusable = false}, SHIFT(3873),
  [8488] = {.count = 1, .reusable = false}, SHIFT(3874),
  [8490] = {.count = 1, .reusable = true}, SHIFT(3875),
  [8492] = {.count = 1, .reusable = true}, SHIFT(3877),
  [8494] = {.count = 1, .reusable = false}, SHIFT(3877),
  [8496] = {.count = 1, .reusable = true}, SHIFT(3878),
  [8498] = {.count = 1, .reusable = false}, SHIFT(3880),
  [8500] = {.count = 1, .reusable = true}, SHIFT(3882),
  [8502] = {.count = 1, .reusable = true}, SHIFT(3884),
  [8504] = {.count = 1, .reusable = false}, SHIFT(3884),
  [8506] = {.count = 1, .reusable = true}, SHIFT(3885),
  [8508] = {.count = 1, .reusable = true}, SHIFT(3886),
  [8510] = {.count = 1, .reusable = false}, SHIFT(3888),
  [8512] = {.count = 1, .reusable = true}, SHIFT(3889),
  [8514] = {.count = 1, .reusable = true}, SHIFT(3891),
  [8516] = {.count = 1, .reusable = false}, SHIFT(3891),
  [8518] = {.count = 1, .reusable = true}, SHIFT(3892),
  [8520] = {.count = 1, .reusable = true}, SHIFT(3893),
  [8522] = {.count = 1, .reusable = true}, SHIFT(3894),
  [8524] = {.count = 1, .reusable = true}, SHIFT(3896),
  [8526] = {.count = 1, .reusable = true}, SHIFT(3898),
  [8528] = {.count = 1, .reusable = false}, SHIFT(3899),
  [8530] = {.count = 1, .reusable = true}, SHIFT(3900),
  [8532] = {.count = 1, .reusable = true}, SHIFT(3902),
  [8534] = {.count = 1, .reusable = false}, SHIFT(3902),
  [8536] = {.count = 1, .reusable = true}, SHIFT(3903),
  [8538] = {.count = 1, .reusable = true}, SHIFT(3905),
  [8540] = {.count = 1, .reusable = true}, SHIFT(3906),
  [8542] = {.count = 1, .reusable = true}, SHIFT(3907),
  [8544] = {.count = 1, .reusable = true}, SHIFT(3909),
  [8546] = {.count = 1, .reusable = true}, SHIFT(3910),
};

void *tree_sitter_cpp_external_scanner_create();
void tree_sitter_cpp_external_scanner_destroy(void *);
bool tree_sitter_cpp_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_cpp_external_scanner_serialize(void *, char *);
void tree_sitter_cpp_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_cpp() {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_cpp_external_scanner_create,
      tree_sitter_cpp_external_scanner_destroy,
      tree_sitter_cpp_external_scanner_scan,
      tree_sitter_cpp_external_scanner_serialize,
      tree_sitter_cpp_external_scanner_deserialize,
    },
  };
  return &language;
}
